/*
 * Copyright (C) 2014-  Qiming Sun <osirpt.sun@gmail.com>
 * Description: code generated by  gen-code.cl
 */
#include <stdlib.h>
#include "gto/grid_ao_drv.h"
/*  R DOT R |GTO> */
static void shell_eval_GTOval_rr(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+3)*4];
double fy0[SIMDD*(ANG_MAX+3)*4];
double fz0[SIMDD*(ANG_MAX+3)*4];
double *fx1 = fx0 + SIMDD*(ANG_MAX+3);
double *fy1 = fy0 + SIMDD*(ANG_MAX+3);
double *fz1 = fz0 + SIMDD*(ANG_MAX+3);
double *fx2 = fx1 + SIMDD*(ANG_MAX+3);
double *fy2 = fy1 + SIMDD*(ANG_MAX+3);
double *fz2 = fz1 + SIMDD*(ANG_MAX+3);
double *fx3 = fx2 + SIMDD*(ANG_MAX+3);
double *fy3 = fy2 + SIMDD*(ANG_MAX+3);
double *fz3 = fz2 + SIMDD*(ANG_MAX+3);
double buf[SIMDD*nc*1];
double s[SIMDD*9];
double *gto0 = cgto;

for (j = 0; j < 1; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_rr_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_cart_drv(shell_eval_GTOval_rr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_rr_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_sph_drv(shell_eval_GTOval_rr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_rr_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_spinor_drv(shell_eval_GTOval_rr, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  R DOT R R DOT R |GTO> */
static void shell_eval_GTOval_rrrr(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+5)*16];
double fy0[SIMDD*(ANG_MAX+5)*16];
double fz0[SIMDD*(ANG_MAX+5)*16];
double *fx1 = fx0 + SIMDD*(ANG_MAX+5);
double *fy1 = fy0 + SIMDD*(ANG_MAX+5);
double *fz1 = fz0 + SIMDD*(ANG_MAX+5);
double *fx2 = fx1 + SIMDD*(ANG_MAX+5);
double *fy2 = fy1 + SIMDD*(ANG_MAX+5);
double *fz2 = fz1 + SIMDD*(ANG_MAX+5);
double *fx3 = fx2 + SIMDD*(ANG_MAX+5);
double *fy3 = fy2 + SIMDD*(ANG_MAX+5);
double *fz3 = fz2 + SIMDD*(ANG_MAX+5);
double *fx4 = fx3 + SIMDD*(ANG_MAX+5);
double *fy4 = fy3 + SIMDD*(ANG_MAX+5);
double *fz4 = fz3 + SIMDD*(ANG_MAX+5);
double *fx5 = fx4 + SIMDD*(ANG_MAX+5);
double *fy5 = fy4 + SIMDD*(ANG_MAX+5);
double *fz5 = fz4 + SIMDD*(ANG_MAX+5);
double *fx6 = fx5 + SIMDD*(ANG_MAX+5);
double *fy6 = fy5 + SIMDD*(ANG_MAX+5);
double *fz6 = fz5 + SIMDD*(ANG_MAX+5);
double *fx7 = fx6 + SIMDD*(ANG_MAX+5);
double *fy7 = fy6 + SIMDD*(ANG_MAX+5);
double *fz7 = fz6 + SIMDD*(ANG_MAX+5);
double *fx8 = fx7 + SIMDD*(ANG_MAX+5);
double *fy8 = fy7 + SIMDD*(ANG_MAX+5);
double *fz8 = fz7 + SIMDD*(ANG_MAX+5);
double *fx9 = fx8 + SIMDD*(ANG_MAX+5);
double *fy9 = fy8 + SIMDD*(ANG_MAX+5);
double *fz9 = fz8 + SIMDD*(ANG_MAX+5);
double *fx10 = fx9 + SIMDD*(ANG_MAX+5);
double *fy10 = fy9 + SIMDD*(ANG_MAX+5);
double *fz10 = fz9 + SIMDD*(ANG_MAX+5);
double *fx11 = fx10 + SIMDD*(ANG_MAX+5);
double *fy11 = fy10 + SIMDD*(ANG_MAX+5);
double *fz11 = fz10 + SIMDD*(ANG_MAX+5);
double *fx12 = fx11 + SIMDD*(ANG_MAX+5);
double *fy12 = fy11 + SIMDD*(ANG_MAX+5);
double *fz12 = fz11 + SIMDD*(ANG_MAX+5);
double *fx13 = fx12 + SIMDD*(ANG_MAX+5);
double *fy13 = fy12 + SIMDD*(ANG_MAX+5);
double *fz13 = fz12 + SIMDD*(ANG_MAX+5);
double *fx14 = fx13 + SIMDD*(ANG_MAX+5);
double *fy14 = fy13 + SIMDD*(ANG_MAX+5);
double *fz14 = fz13 + SIMDD*(ANG_MAX+5);
double *fx15 = fx14 + SIMDD*(ANG_MAX+5);
double *fy15 = fy14 + SIMDD*(ANG_MAX+5);
double *fz15 = fz14 + SIMDD*(ANG_MAX+5);
double buf[SIMDD*nc*1];
double s[SIMDD*81];
double *gto0 = cgto;

for (j = 0; j < 1; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+4; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_R_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
GTO_R_I(8, 0, l+3);
GTO_R_I(9, 8, l+0);
GTO_R_I(10, 8, l+1);
GTO_R_I(11, 10, l+0);
GTO_R_I(12, 8, l+2);
GTO_R_I(13, 12, l+0);
GTO_R_I(14, 12, l+1);
GTO_R_I(15, 14, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + (2*s[4*SIMDD+n]) + (2*s[8*SIMDD+n]) + s[40*SIMDD+n] + (2*s[44*SIMDD+n]) + s[80*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+4; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_R_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
GTO_R_I(8, 0, l+3);
GTO_R_I(9, 8, l+0);
GTO_R_I(10, 8, l+1);
GTO_R_I(11, 10, l+0);
GTO_R_I(12, 8, l+2);
GTO_R_I(13, 12, l+0);
GTO_R_I(14, 12, l+1);
GTO_R_I(15, 14, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + (2*s[4*SIMDD+n]) + (2*s[8*SIMDD+n]) + s[40*SIMDD+n] + (2*s[44*SIMDD+n]) + s[80*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_rrrr_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_cart_drv(shell_eval_GTOval_rrrr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_rrrr_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_sph_drv(shell_eval_GTOval_rrrr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_rrrr_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_spinor_drv(shell_eval_GTOval_rrrr, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA R DOT R |GTO> */
static void shell_eval_GTOval_iprr(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+4)*8];
double fy0[SIMDD*(ANG_MAX+4)*8];
double fz0[SIMDD*(ANG_MAX+4)*8];
double *fx1 = fx0 + SIMDD*(ANG_MAX+4);
double *fy1 = fy0 + SIMDD*(ANG_MAX+4);
double *fz1 = fz0 + SIMDD*(ANG_MAX+4);
double *fx2 = fx1 + SIMDD*(ANG_MAX+4);
double *fy2 = fy1 + SIMDD*(ANG_MAX+4);
double *fz2 = fz1 + SIMDD*(ANG_MAX+4);
double *fx3 = fx2 + SIMDD*(ANG_MAX+4);
double *fy3 = fy2 + SIMDD*(ANG_MAX+4);
double *fz3 = fz2 + SIMDD*(ANG_MAX+4);
double *fx4 = fx3 + SIMDD*(ANG_MAX+4);
double *fy4 = fy3 + SIMDD*(ANG_MAX+4);
double *fz4 = fz3 + SIMDD*(ANG_MAX+4);
double *fx5 = fx4 + SIMDD*(ANG_MAX+4);
double *fy5 = fy4 + SIMDD*(ANG_MAX+4);
double *fz5 = fz4 + SIMDD*(ANG_MAX+4);
double *fx6 = fx5 + SIMDD*(ANG_MAX+4);
double *fy6 = fy5 + SIMDD*(ANG_MAX+4);
double *fz6 = fz5 + SIMDD*(ANG_MAX+4);
double *fx7 = fx6 + SIMDD*(ANG_MAX+4);
double *fy7 = fy6 + SIMDD*(ANG_MAX+4);
double *fz7 = fz6 + SIMDD*(ANG_MAX+4);
double buf[SIMDD*nc*3];
double s[SIMDD*27];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;

for (j = 0; j < 3; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+3; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
buf[1*SIMDD+n] = + s[9*SIMDD+n] + s[13*SIMDD+n] + s[17*SIMDD+n];
buf[2*SIMDD+n] = + s[18*SIMDD+n] + s[22*SIMDD+n] + s[26*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+3; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
buf[1*SIMDD+n] = + s[9*SIMDD+n] + s[13*SIMDD+n] + s[17*SIMDD+n];
buf[2*SIMDD+n] = + s[18*SIMDD+n] + s[22*SIMDD+n] + s[26*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_iprr_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_cart_drv(shell_eval_GTOval_iprr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_iprr_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_sph_drv(shell_eval_GTOval_iprr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_iprr_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_spinor_drv(shell_eval_GTOval_iprr, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA R DOT R R DOT R |GTO> */
static void shell_eval_GTOval_iprrrr(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+6)*32];
double fy0[SIMDD*(ANG_MAX+6)*32];
double fz0[SIMDD*(ANG_MAX+6)*32];
double *fx1 = fx0 + SIMDD*(ANG_MAX+6);
double *fy1 = fy0 + SIMDD*(ANG_MAX+6);
double *fz1 = fz0 + SIMDD*(ANG_MAX+6);
double *fx2 = fx1 + SIMDD*(ANG_MAX+6);
double *fy2 = fy1 + SIMDD*(ANG_MAX+6);
double *fz2 = fz1 + SIMDD*(ANG_MAX+6);
double *fx3 = fx2 + SIMDD*(ANG_MAX+6);
double *fy3 = fy2 + SIMDD*(ANG_MAX+6);
double *fz3 = fz2 + SIMDD*(ANG_MAX+6);
double *fx4 = fx3 + SIMDD*(ANG_MAX+6);
double *fy4 = fy3 + SIMDD*(ANG_MAX+6);
double *fz4 = fz3 + SIMDD*(ANG_MAX+6);
double *fx5 = fx4 + SIMDD*(ANG_MAX+6);
double *fy5 = fy4 + SIMDD*(ANG_MAX+6);
double *fz5 = fz4 + SIMDD*(ANG_MAX+6);
double *fx6 = fx5 + SIMDD*(ANG_MAX+6);
double *fy6 = fy5 + SIMDD*(ANG_MAX+6);
double *fz6 = fz5 + SIMDD*(ANG_MAX+6);
double *fx7 = fx6 + SIMDD*(ANG_MAX+6);
double *fy7 = fy6 + SIMDD*(ANG_MAX+6);
double *fz7 = fz6 + SIMDD*(ANG_MAX+6);
double *fx8 = fx7 + SIMDD*(ANG_MAX+6);
double *fy8 = fy7 + SIMDD*(ANG_MAX+6);
double *fz8 = fz7 + SIMDD*(ANG_MAX+6);
double *fx9 = fx8 + SIMDD*(ANG_MAX+6);
double *fy9 = fy8 + SIMDD*(ANG_MAX+6);
double *fz9 = fz8 + SIMDD*(ANG_MAX+6);
double *fx10 = fx9 + SIMDD*(ANG_MAX+6);
double *fy10 = fy9 + SIMDD*(ANG_MAX+6);
double *fz10 = fz9 + SIMDD*(ANG_MAX+6);
double *fx11 = fx10 + SIMDD*(ANG_MAX+6);
double *fy11 = fy10 + SIMDD*(ANG_MAX+6);
double *fz11 = fz10 + SIMDD*(ANG_MAX+6);
double *fx12 = fx11 + SIMDD*(ANG_MAX+6);
double *fy12 = fy11 + SIMDD*(ANG_MAX+6);
double *fz12 = fz11 + SIMDD*(ANG_MAX+6);
double *fx13 = fx12 + SIMDD*(ANG_MAX+6);
double *fy13 = fy12 + SIMDD*(ANG_MAX+6);
double *fz13 = fz12 + SIMDD*(ANG_MAX+6);
double *fx14 = fx13 + SIMDD*(ANG_MAX+6);
double *fy14 = fy13 + SIMDD*(ANG_MAX+6);
double *fz14 = fz13 + SIMDD*(ANG_MAX+6);
double *fx15 = fx14 + SIMDD*(ANG_MAX+6);
double *fy15 = fy14 + SIMDD*(ANG_MAX+6);
double *fz15 = fz14 + SIMDD*(ANG_MAX+6);
double *fx16 = fx15 + SIMDD*(ANG_MAX+6);
double *fy16 = fy15 + SIMDD*(ANG_MAX+6);
double *fz16 = fz15 + SIMDD*(ANG_MAX+6);
double *fx17 = fx16 + SIMDD*(ANG_MAX+6);
double *fy17 = fy16 + SIMDD*(ANG_MAX+6);
double *fz17 = fz16 + SIMDD*(ANG_MAX+6);
double *fx18 = fx17 + SIMDD*(ANG_MAX+6);
double *fy18 = fy17 + SIMDD*(ANG_MAX+6);
double *fz18 = fz17 + SIMDD*(ANG_MAX+6);
double *fx19 = fx18 + SIMDD*(ANG_MAX+6);
double *fy19 = fy18 + SIMDD*(ANG_MAX+6);
double *fz19 = fz18 + SIMDD*(ANG_MAX+6);
double *fx20 = fx19 + SIMDD*(ANG_MAX+6);
double *fy20 = fy19 + SIMDD*(ANG_MAX+6);
double *fz20 = fz19 + SIMDD*(ANG_MAX+6);
double *fx21 = fx20 + SIMDD*(ANG_MAX+6);
double *fy21 = fy20 + SIMDD*(ANG_MAX+6);
double *fz21 = fz20 + SIMDD*(ANG_MAX+6);
double *fx22 = fx21 + SIMDD*(ANG_MAX+6);
double *fy22 = fy21 + SIMDD*(ANG_MAX+6);
double *fz22 = fz21 + SIMDD*(ANG_MAX+6);
double *fx23 = fx22 + SIMDD*(ANG_MAX+6);
double *fy23 = fy22 + SIMDD*(ANG_MAX+6);
double *fz23 = fz22 + SIMDD*(ANG_MAX+6);
double *fx24 = fx23 + SIMDD*(ANG_MAX+6);
double *fy24 = fy23 + SIMDD*(ANG_MAX+6);
double *fz24 = fz23 + SIMDD*(ANG_MAX+6);
double *fx25 = fx24 + SIMDD*(ANG_MAX+6);
double *fy25 = fy24 + SIMDD*(ANG_MAX+6);
double *fz25 = fz24 + SIMDD*(ANG_MAX+6);
double *fx26 = fx25 + SIMDD*(ANG_MAX+6);
double *fy26 = fy25 + SIMDD*(ANG_MAX+6);
double *fz26 = fz25 + SIMDD*(ANG_MAX+6);
double *fx27 = fx26 + SIMDD*(ANG_MAX+6);
double *fy27 = fy26 + SIMDD*(ANG_MAX+6);
double *fz27 = fz26 + SIMDD*(ANG_MAX+6);
double *fx28 = fx27 + SIMDD*(ANG_MAX+6);
double *fy28 = fy27 + SIMDD*(ANG_MAX+6);
double *fz28 = fz27 + SIMDD*(ANG_MAX+6);
double *fx29 = fx28 + SIMDD*(ANG_MAX+6);
double *fy29 = fy28 + SIMDD*(ANG_MAX+6);
double *fz29 = fz28 + SIMDD*(ANG_MAX+6);
double *fx30 = fx29 + SIMDD*(ANG_MAX+6);
double *fy30 = fy29 + SIMDD*(ANG_MAX+6);
double *fz30 = fz29 + SIMDD*(ANG_MAX+6);
double *fx31 = fx30 + SIMDD*(ANG_MAX+6);
double *fy31 = fy30 + SIMDD*(ANG_MAX+6);
double *fz31 = fz30 + SIMDD*(ANG_MAX+6);
double buf[SIMDD*nc*3];
double s[SIMDD*243];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;

for (j = 0; j < 3; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+5; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_R_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
GTO_R_I(8, 0, l+3);
GTO_R_I(9, 8, l+0);
GTO_R_I(10, 8, l+1);
GTO_R_I(11, 10, l+0);
GTO_R_I(12, 8, l+2);
GTO_R_I(13, 12, l+0);
GTO_R_I(14, 12, l+1);
GTO_R_I(15, 14, l+0);
GTO_D_I(16, 0, l+4);
GTO_R_I(17, 16, l+0);
GTO_R_I(18, 16, l+1);
GTO_R_I(19, 18, l+0);
GTO_R_I(20, 16, l+2);
GTO_R_I(21, 20, l+0);
GTO_R_I(22, 20, l+1);
GTO_R_I(23, 22, l+0);
GTO_R_I(24, 16, l+3);
GTO_R_I(25, 24, l+0);
GTO_R_I(26, 24, l+1);
GTO_R_I(27, 26, l+0);
GTO_R_I(28, 24, l+2);
GTO_R_I(29, 28, l+0);
GTO_R_I(30, 28, l+1);
GTO_R_I(31, 30, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx31[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[81*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[82*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[83*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[84*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[85*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[86*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[87*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[88*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[89*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[90*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[91*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[92*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[93*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[94*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[95*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[96*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[97*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[98*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[99*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[100*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[101*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[102*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[103*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[104*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[105*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[106*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[107*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[108*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[109*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[110*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[111*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[112*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[113*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[114*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[115*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[116*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[117*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[118*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[119*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[120*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[121*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy31[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[122*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[123*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[124*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[125*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[126*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[127*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[128*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[129*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[130*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[131*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[132*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[133*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[134*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[135*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[136*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[137*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[138*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[139*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[140*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[141*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[142*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[143*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[144*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[145*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[146*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[147*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[148*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[149*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[150*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[151*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[152*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[153*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[154*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[155*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[156*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[157*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[158*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[159*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[160*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[161*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[162*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[163*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[164*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[165*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[166*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[167*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[168*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[169*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[170*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[171*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[172*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[173*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[174*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[175*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[176*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[177*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[178*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[179*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[180*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[181*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[182*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[183*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[184*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[185*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[186*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[187*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[188*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[189*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[190*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[191*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[192*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[193*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[194*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[195*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[196*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[197*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[198*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[199*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[200*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[201*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[202*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[203*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[204*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[205*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[206*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[207*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[208*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[209*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[210*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[211*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[212*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[213*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[214*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[215*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[216*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[217*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[218*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[219*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[220*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[221*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[222*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[223*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[224*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[225*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[226*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[227*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[228*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[229*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[230*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[231*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[232*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[233*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[234*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[235*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[236*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[237*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[238*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[239*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[240*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[241*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[242*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz31[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + (2*s[4*SIMDD+n]) + (2*s[8*SIMDD+n]) + s[40*SIMDD+n] + (2*s[44*SIMDD+n]) + s[80*SIMDD+n];
buf[1*SIMDD+n] = + s[81*SIMDD+n] + (2*s[85*SIMDD+n]) + (2*s[89*SIMDD+n]) + s[121*SIMDD+n] + (2*s[125*SIMDD+n]) + s[161*SIMDD+n];
buf[2*SIMDD+n] = + s[162*SIMDD+n] + (2*s[166*SIMDD+n]) + (2*s[170*SIMDD+n]) + s[202*SIMDD+n] + (2*s[206*SIMDD+n]) + s[242*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+5; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_R_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
GTO_R_I(8, 0, l+3);
GTO_R_I(9, 8, l+0);
GTO_R_I(10, 8, l+1);
GTO_R_I(11, 10, l+0);
GTO_R_I(12, 8, l+2);
GTO_R_I(13, 12, l+0);
GTO_R_I(14, 12, l+1);
GTO_R_I(15, 14, l+0);
GTO_D_I(16, 0, l+4);
GTO_R_I(17, 16, l+0);
GTO_R_I(18, 16, l+1);
GTO_R_I(19, 18, l+0);
GTO_R_I(20, 16, l+2);
GTO_R_I(21, 20, l+0);
GTO_R_I(22, 20, l+1);
GTO_R_I(23, 22, l+0);
GTO_R_I(24, 16, l+3);
GTO_R_I(25, 24, l+0);
GTO_R_I(26, 24, l+1);
GTO_R_I(27, 26, l+0);
GTO_R_I(28, 24, l+2);
GTO_R_I(29, 28, l+0);
GTO_R_I(30, 28, l+1);
GTO_R_I(31, 30, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx31[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[81*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[82*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[83*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[84*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[85*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[86*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[87*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[88*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[89*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[90*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[91*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[92*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[93*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[94*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[95*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[96*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[97*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[98*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[99*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[100*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[101*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[102*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[103*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[104*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[105*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[106*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[107*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[108*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[109*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[110*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[111*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[112*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[113*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[114*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[115*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[116*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[117*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[118*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[119*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[120*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[121*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy31[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[122*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[123*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[124*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[125*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[126*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[127*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[128*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[129*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[130*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[131*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[132*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[133*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[134*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[135*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[136*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[137*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[138*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[139*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[140*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[141*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[142*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[143*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[144*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[145*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[146*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[147*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[148*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[149*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[150*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[151*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[152*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[153*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[154*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[155*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[156*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[157*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[158*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[159*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[160*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[161*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[162*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[163*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[164*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[165*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[166*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[167*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[168*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[169*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[170*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[171*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[172*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[173*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[174*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[175*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[176*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[177*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[178*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[179*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[180*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[181*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[182*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[183*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[184*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[185*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[186*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[187*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[188*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[189*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[190*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[191*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[192*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[193*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[194*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[195*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[196*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[197*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[198*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[199*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[200*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[201*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[202*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[203*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[204*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[205*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[206*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[207*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[208*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[209*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[210*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[211*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[212*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[213*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[214*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[215*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[216*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[217*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[218*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[219*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[220*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[221*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[222*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[223*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[224*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[225*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[226*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[227*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[228*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[229*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[230*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[231*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[232*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[233*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[234*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[235*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[236*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[237*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[238*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[239*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[240*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[241*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[242*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz31[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + (2*s[4*SIMDD+n]) + (2*s[8*SIMDD+n]) + s[40*SIMDD+n] + (2*s[44*SIMDD+n]) + s[80*SIMDD+n];
buf[1*SIMDD+n] = + s[81*SIMDD+n] + (2*s[85*SIMDD+n]) + (2*s[89*SIMDD+n]) + s[121*SIMDD+n] + (2*s[125*SIMDD+n]) + s[161*SIMDD+n];
buf[2*SIMDD+n] = + s[162*SIMDD+n] + (2*s[166*SIMDD+n]) + (2*s[170*SIMDD+n]) + s[202*SIMDD+n] + (2*s[206*SIMDD+n]) + s[242*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_iprrrr_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_cart_drv(shell_eval_GTOval_iprrrr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_iprrrr_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_sph_drv(shell_eval_GTOval_iprrrr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_iprrrr_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_spinor_drv(shell_eval_GTOval_iprrrr, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA NABLA |GTO> */
static void shell_eval_GTOval_ipip(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+3)*4];
double fy0[SIMDD*(ANG_MAX+3)*4];
double fz0[SIMDD*(ANG_MAX+3)*4];
double *fx1 = fx0 + SIMDD*(ANG_MAX+3);
double *fy1 = fy0 + SIMDD*(ANG_MAX+3);
double *fz1 = fz0 + SIMDD*(ANG_MAX+3);
double *fx2 = fx1 + SIMDD*(ANG_MAX+3);
double *fy2 = fy1 + SIMDD*(ANG_MAX+3);
double *fz2 = fz1 + SIMDD*(ANG_MAX+3);
double *fx3 = fx2 + SIMDD*(ANG_MAX+3);
double *fy3 = fy2 + SIMDD*(ANG_MAX+3);
double *fz3 = fz2 + SIMDD*(ANG_MAX+3);
double buf[SIMDD*nc*9];
double s[SIMDD*9];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double *gto3 = cgto + nao*ngrids*3;
double *gto4 = cgto + nao*ngrids*4;
double *gto5 = cgto + nao*ngrids*5;
double *gto6 = cgto + nao*ngrids*6;
double *gto7 = cgto + nao*ngrids*7;
double *gto8 = cgto + nao*ngrids*8;

for (j = 0; j < 9; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n];
buf[1*SIMDD+n] = + s[1*SIMDD+n];
buf[2*SIMDD+n] = + s[2*SIMDD+n];
buf[3*SIMDD+n] = + s[3*SIMDD+n];
buf[4*SIMDD+n] = + s[4*SIMDD+n];
buf[5*SIMDD+n] = + s[5*SIMDD+n];
buf[6*SIMDD+n] = + s[6*SIMDD+n];
buf[7*SIMDD+n] = + s[7*SIMDD+n];
buf[8*SIMDD+n] = + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n];
buf[1*SIMDD+n] = + s[1*SIMDD+n];
buf[2*SIMDD+n] = + s[2*SIMDD+n];
buf[3*SIMDD+n] = + s[3*SIMDD+n];
buf[4*SIMDD+n] = + s[4*SIMDD+n];
buf[5*SIMDD+n] = + s[5*SIMDD+n];
buf[6*SIMDD+n] = + s[6*SIMDD+n];
buf[7*SIMDD+n] = + s[7*SIMDD+n];
buf[8*SIMDD+n] = + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_ipip_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_cart_drv(shell_eval_GTOval_ipip, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipip_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_sph_drv(shell_eval_GTOval_ipip, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipip_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_spinor_drv(shell_eval_GTOval_ipip, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA NABLA NABLA |GTO> */
static void shell_eval_GTOval_ipipip(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+4)*8];
double fy0[SIMDD*(ANG_MAX+4)*8];
double fz0[SIMDD*(ANG_MAX+4)*8];
double *fx1 = fx0 + SIMDD*(ANG_MAX+4);
double *fy1 = fy0 + SIMDD*(ANG_MAX+4);
double *fz1 = fz0 + SIMDD*(ANG_MAX+4);
double *fx2 = fx1 + SIMDD*(ANG_MAX+4);
double *fy2 = fy1 + SIMDD*(ANG_MAX+4);
double *fz2 = fz1 + SIMDD*(ANG_MAX+4);
double *fx3 = fx2 + SIMDD*(ANG_MAX+4);
double *fy3 = fy2 + SIMDD*(ANG_MAX+4);
double *fz3 = fz2 + SIMDD*(ANG_MAX+4);
double *fx4 = fx3 + SIMDD*(ANG_MAX+4);
double *fy4 = fy3 + SIMDD*(ANG_MAX+4);
double *fz4 = fz3 + SIMDD*(ANG_MAX+4);
double *fx5 = fx4 + SIMDD*(ANG_MAX+4);
double *fy5 = fy4 + SIMDD*(ANG_MAX+4);
double *fz5 = fz4 + SIMDD*(ANG_MAX+4);
double *fx6 = fx5 + SIMDD*(ANG_MAX+4);
double *fy6 = fy5 + SIMDD*(ANG_MAX+4);
double *fz6 = fz5 + SIMDD*(ANG_MAX+4);
double *fx7 = fx6 + SIMDD*(ANG_MAX+4);
double *fy7 = fy6 + SIMDD*(ANG_MAX+4);
double *fz7 = fz6 + SIMDD*(ANG_MAX+4);
double buf[SIMDD*nc*27];
double s[SIMDD*27];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double *gto3 = cgto + nao*ngrids*3;
double *gto4 = cgto + nao*ngrids*4;
double *gto5 = cgto + nao*ngrids*5;
double *gto6 = cgto + nao*ngrids*6;
double *gto7 = cgto + nao*ngrids*7;
double *gto8 = cgto + nao*ngrids*8;
double *gto9 = cgto + nao*ngrids*9;
double *gto10 = cgto + nao*ngrids*10;
double *gto11 = cgto + nao*ngrids*11;
double *gto12 = cgto + nao*ngrids*12;
double *gto13 = cgto + nao*ngrids*13;
double *gto14 = cgto + nao*ngrids*14;
double *gto15 = cgto + nao*ngrids*15;
double *gto16 = cgto + nao*ngrids*16;
double *gto17 = cgto + nao*ngrids*17;
double *gto18 = cgto + nao*ngrids*18;
double *gto19 = cgto + nao*ngrids*19;
double *gto20 = cgto + nao*ngrids*20;
double *gto21 = cgto + nao*ngrids*21;
double *gto22 = cgto + nao*ngrids*22;
double *gto23 = cgto + nao*ngrids*23;
double *gto24 = cgto + nao*ngrids*24;
double *gto25 = cgto + nao*ngrids*25;
double *gto26 = cgto + nao*ngrids*26;

for (j = 0; j < 27; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+3; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_D_I(5, 4, l+0);
GTO_D_I(6, 4, l+1);
GTO_D_I(7, 6, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n];
buf[1*SIMDD+n] = + s[1*SIMDD+n];
buf[2*SIMDD+n] = + s[2*SIMDD+n];
buf[3*SIMDD+n] = + s[3*SIMDD+n];
buf[4*SIMDD+n] = + s[4*SIMDD+n];
buf[5*SIMDD+n] = + s[5*SIMDD+n];
buf[6*SIMDD+n] = + s[6*SIMDD+n];
buf[7*SIMDD+n] = + s[7*SIMDD+n];
buf[8*SIMDD+n] = + s[8*SIMDD+n];
buf[9*SIMDD+n] = + s[9*SIMDD+n];
buf[10*SIMDD+n] = + s[10*SIMDD+n];
buf[11*SIMDD+n] = + s[11*SIMDD+n];
buf[12*SIMDD+n] = + s[12*SIMDD+n];
buf[13*SIMDD+n] = + s[13*SIMDD+n];
buf[14*SIMDD+n] = + s[14*SIMDD+n];
buf[15*SIMDD+n] = + s[15*SIMDD+n];
buf[16*SIMDD+n] = + s[16*SIMDD+n];
buf[17*SIMDD+n] = + s[17*SIMDD+n];
buf[18*SIMDD+n] = + s[18*SIMDD+n];
buf[19*SIMDD+n] = + s[19*SIMDD+n];
buf[20*SIMDD+n] = + s[20*SIMDD+n];
buf[21*SIMDD+n] = + s[21*SIMDD+n];
buf[22*SIMDD+n] = + s[22*SIMDD+n];
buf[23*SIMDD+n] = + s[23*SIMDD+n];
buf[24*SIMDD+n] = + s[24*SIMDD+n];
buf[25*SIMDD+n] = + s[25*SIMDD+n];
buf[26*SIMDD+n] = + s[26*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
gto9[j1*ngrids+i+n] += buf[9*SIMDD+n] * coeff[j*np+k];
gto10[j1*ngrids+i+n] += buf[10*SIMDD+n] * coeff[j*np+k];
gto11[j1*ngrids+i+n] += buf[11*SIMDD+n] * coeff[j*np+k];
gto12[j1*ngrids+i+n] += buf[12*SIMDD+n] * coeff[j*np+k];
gto13[j1*ngrids+i+n] += buf[13*SIMDD+n] * coeff[j*np+k];
gto14[j1*ngrids+i+n] += buf[14*SIMDD+n] * coeff[j*np+k];
gto15[j1*ngrids+i+n] += buf[15*SIMDD+n] * coeff[j*np+k];
gto16[j1*ngrids+i+n] += buf[16*SIMDD+n] * coeff[j*np+k];
gto17[j1*ngrids+i+n] += buf[17*SIMDD+n] * coeff[j*np+k];
gto18[j1*ngrids+i+n] += buf[18*SIMDD+n] * coeff[j*np+k];
gto19[j1*ngrids+i+n] += buf[19*SIMDD+n] * coeff[j*np+k];
gto20[j1*ngrids+i+n] += buf[20*SIMDD+n] * coeff[j*np+k];
gto21[j1*ngrids+i+n] += buf[21*SIMDD+n] * coeff[j*np+k];
gto22[j1*ngrids+i+n] += buf[22*SIMDD+n] * coeff[j*np+k];
gto23[j1*ngrids+i+n] += buf[23*SIMDD+n] * coeff[j*np+k];
gto24[j1*ngrids+i+n] += buf[24*SIMDD+n] * coeff[j*np+k];
gto25[j1*ngrids+i+n] += buf[25*SIMDD+n] * coeff[j*np+k];
gto26[j1*ngrids+i+n] += buf[26*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+3; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_D_I(5, 4, l+0);
GTO_D_I(6, 4, l+1);
GTO_D_I(7, 6, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n];
buf[1*SIMDD+n] = + s[1*SIMDD+n];
buf[2*SIMDD+n] = + s[2*SIMDD+n];
buf[3*SIMDD+n] = + s[3*SIMDD+n];
buf[4*SIMDD+n] = + s[4*SIMDD+n];
buf[5*SIMDD+n] = + s[5*SIMDD+n];
buf[6*SIMDD+n] = + s[6*SIMDD+n];
buf[7*SIMDD+n] = + s[7*SIMDD+n];
buf[8*SIMDD+n] = + s[8*SIMDD+n];
buf[9*SIMDD+n] = + s[9*SIMDD+n];
buf[10*SIMDD+n] = + s[10*SIMDD+n];
buf[11*SIMDD+n] = + s[11*SIMDD+n];
buf[12*SIMDD+n] = + s[12*SIMDD+n];
buf[13*SIMDD+n] = + s[13*SIMDD+n];
buf[14*SIMDD+n] = + s[14*SIMDD+n];
buf[15*SIMDD+n] = + s[15*SIMDD+n];
buf[16*SIMDD+n] = + s[16*SIMDD+n];
buf[17*SIMDD+n] = + s[17*SIMDD+n];
buf[18*SIMDD+n] = + s[18*SIMDD+n];
buf[19*SIMDD+n] = + s[19*SIMDD+n];
buf[20*SIMDD+n] = + s[20*SIMDD+n];
buf[21*SIMDD+n] = + s[21*SIMDD+n];
buf[22*SIMDD+n] = + s[22*SIMDD+n];
buf[23*SIMDD+n] = + s[23*SIMDD+n];
buf[24*SIMDD+n] = + s[24*SIMDD+n];
buf[25*SIMDD+n] = + s[25*SIMDD+n];
buf[26*SIMDD+n] = + s[26*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
gto9[j1*ngrids+i+n] += buf[9*SIMDD+n] * coeff[j*np+k];
gto10[j1*ngrids+i+n] += buf[10*SIMDD+n] * coeff[j*np+k];
gto11[j1*ngrids+i+n] += buf[11*SIMDD+n] * coeff[j*np+k];
gto12[j1*ngrids+i+n] += buf[12*SIMDD+n] * coeff[j*np+k];
gto13[j1*ngrids+i+n] += buf[13*SIMDD+n] * coeff[j*np+k];
gto14[j1*ngrids+i+n] += buf[14*SIMDD+n] * coeff[j*np+k];
gto15[j1*ngrids+i+n] += buf[15*SIMDD+n] * coeff[j*np+k];
gto16[j1*ngrids+i+n] += buf[16*SIMDD+n] * coeff[j*np+k];
gto17[j1*ngrids+i+n] += buf[17*SIMDD+n] * coeff[j*np+k];
gto18[j1*ngrids+i+n] += buf[18*SIMDD+n] * coeff[j*np+k];
gto19[j1*ngrids+i+n] += buf[19*SIMDD+n] * coeff[j*np+k];
gto20[j1*ngrids+i+n] += buf[20*SIMDD+n] * coeff[j*np+k];
gto21[j1*ngrids+i+n] += buf[21*SIMDD+n] * coeff[j*np+k];
gto22[j1*ngrids+i+n] += buf[22*SIMDD+n] * coeff[j*np+k];
gto23[j1*ngrids+i+n] += buf[23*SIMDD+n] * coeff[j*np+k];
gto24[j1*ngrids+i+n] += buf[24*SIMDD+n] * coeff[j*np+k];
gto25[j1*ngrids+i+n] += buf[25*SIMDD+n] * coeff[j*np+k];
gto26[j1*ngrids+i+n] += buf[26*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_ipipip_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 27};
GTOeval_cart_drv(shell_eval_GTOval_ipipip, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipipip_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 27};
GTOeval_sph_drv(shell_eval_GTOval_ipipip, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipipip_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 27};
GTOeval_spinor_drv(shell_eval_GTOval_ipipip, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA DOT NABLA R DOT R |GTO> */
static void shell_eval_GTOval_laplrr(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+5)*16];
double fy0[SIMDD*(ANG_MAX+5)*16];
double fz0[SIMDD*(ANG_MAX+5)*16];
double *fx1 = fx0 + SIMDD*(ANG_MAX+5);
double *fy1 = fy0 + SIMDD*(ANG_MAX+5);
double *fz1 = fz0 + SIMDD*(ANG_MAX+5);
double *fx2 = fx1 + SIMDD*(ANG_MAX+5);
double *fy2 = fy1 + SIMDD*(ANG_MAX+5);
double *fz2 = fz1 + SIMDD*(ANG_MAX+5);
double *fx3 = fx2 + SIMDD*(ANG_MAX+5);
double *fy3 = fy2 + SIMDD*(ANG_MAX+5);
double *fz3 = fz2 + SIMDD*(ANG_MAX+5);
double *fx4 = fx3 + SIMDD*(ANG_MAX+5);
double *fy4 = fy3 + SIMDD*(ANG_MAX+5);
double *fz4 = fz3 + SIMDD*(ANG_MAX+5);
double *fx5 = fx4 + SIMDD*(ANG_MAX+5);
double *fy5 = fy4 + SIMDD*(ANG_MAX+5);
double *fz5 = fz4 + SIMDD*(ANG_MAX+5);
double *fx6 = fx5 + SIMDD*(ANG_MAX+5);
double *fy6 = fy5 + SIMDD*(ANG_MAX+5);
double *fz6 = fz5 + SIMDD*(ANG_MAX+5);
double *fx7 = fx6 + SIMDD*(ANG_MAX+5);
double *fy7 = fy6 + SIMDD*(ANG_MAX+5);
double *fz7 = fz6 + SIMDD*(ANG_MAX+5);
double *fx8 = fx7 + SIMDD*(ANG_MAX+5);
double *fy8 = fy7 + SIMDD*(ANG_MAX+5);
double *fz8 = fz7 + SIMDD*(ANG_MAX+5);
double *fx9 = fx8 + SIMDD*(ANG_MAX+5);
double *fy9 = fy8 + SIMDD*(ANG_MAX+5);
double *fz9 = fz8 + SIMDD*(ANG_MAX+5);
double *fx10 = fx9 + SIMDD*(ANG_MAX+5);
double *fy10 = fy9 + SIMDD*(ANG_MAX+5);
double *fz10 = fz9 + SIMDD*(ANG_MAX+5);
double *fx11 = fx10 + SIMDD*(ANG_MAX+5);
double *fy11 = fy10 + SIMDD*(ANG_MAX+5);
double *fz11 = fz10 + SIMDD*(ANG_MAX+5);
double *fx12 = fx11 + SIMDD*(ANG_MAX+5);
double *fy12 = fy11 + SIMDD*(ANG_MAX+5);
double *fz12 = fz11 + SIMDD*(ANG_MAX+5);
double *fx13 = fx12 + SIMDD*(ANG_MAX+5);
double *fy13 = fy12 + SIMDD*(ANG_MAX+5);
double *fz13 = fz12 + SIMDD*(ANG_MAX+5);
double *fx14 = fx13 + SIMDD*(ANG_MAX+5);
double *fy14 = fy13 + SIMDD*(ANG_MAX+5);
double *fz14 = fz13 + SIMDD*(ANG_MAX+5);
double *fx15 = fx14 + SIMDD*(ANG_MAX+5);
double *fy15 = fy14 + SIMDD*(ANG_MAX+5);
double *fz15 = fz14 + SIMDD*(ANG_MAX+5);
double buf[SIMDD*nc*1];
double s[SIMDD*81];
double *gto0 = cgto;

for (j = 0; j < 1; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+4; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
GTO_D_I(8, 0, l+3);
GTO_R_I(9, 8, l+0);
GTO_R_I(10, 8, l+1);
GTO_R_I(11, 10, l+0);
GTO_D_I(12, 8, l+2);
GTO_R_I(13, 12, l+0);
GTO_R_I(14, 12, l+1);
GTO_R_I(15, 14, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[36*SIMDD+n] + s[72*SIMDD+n] + s[4*SIMDD+n] + s[40*SIMDD+n] + s[76*SIMDD+n] + s[8*SIMDD+n] + s[44*SIMDD+n] + s[80*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+4; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
GTO_D_I(8, 0, l+3);
GTO_R_I(9, 8, l+0);
GTO_R_I(10, 8, l+1);
GTO_R_I(11, 10, l+0);
GTO_D_I(12, 8, l+2);
GTO_R_I(13, 12, l+0);
GTO_R_I(14, 12, l+1);
GTO_R_I(15, 14, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[36*SIMDD+n] + s[72*SIMDD+n] + s[4*SIMDD+n] + s[40*SIMDD+n] + s[76*SIMDD+n] + s[8*SIMDD+n] + s[44*SIMDD+n] + s[80*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_laplrr_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_cart_drv(shell_eval_GTOval_laplrr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_laplrr_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_sph_drv(shell_eval_GTOval_laplrr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_laplrr_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_spinor_drv(shell_eval_GTOval_laplrr, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA DOT NABLA R DOT R R DOT R |GTO> */
static void shell_eval_GTOval_laplrrrr(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+7)*64];
double fy0[SIMDD*(ANG_MAX+7)*64];
double fz0[SIMDD*(ANG_MAX+7)*64];
double *fx1 = fx0 + SIMDD*(ANG_MAX+7);
double *fy1 = fy0 + SIMDD*(ANG_MAX+7);
double *fz1 = fz0 + SIMDD*(ANG_MAX+7);
double *fx2 = fx1 + SIMDD*(ANG_MAX+7);
double *fy2 = fy1 + SIMDD*(ANG_MAX+7);
double *fz2 = fz1 + SIMDD*(ANG_MAX+7);
double *fx3 = fx2 + SIMDD*(ANG_MAX+7);
double *fy3 = fy2 + SIMDD*(ANG_MAX+7);
double *fz3 = fz2 + SIMDD*(ANG_MAX+7);
double *fx4 = fx3 + SIMDD*(ANG_MAX+7);
double *fy4 = fy3 + SIMDD*(ANG_MAX+7);
double *fz4 = fz3 + SIMDD*(ANG_MAX+7);
double *fx5 = fx4 + SIMDD*(ANG_MAX+7);
double *fy5 = fy4 + SIMDD*(ANG_MAX+7);
double *fz5 = fz4 + SIMDD*(ANG_MAX+7);
double *fx6 = fx5 + SIMDD*(ANG_MAX+7);
double *fy6 = fy5 + SIMDD*(ANG_MAX+7);
double *fz6 = fz5 + SIMDD*(ANG_MAX+7);
double *fx7 = fx6 + SIMDD*(ANG_MAX+7);
double *fy7 = fy6 + SIMDD*(ANG_MAX+7);
double *fz7 = fz6 + SIMDD*(ANG_MAX+7);
double *fx8 = fx7 + SIMDD*(ANG_MAX+7);
double *fy8 = fy7 + SIMDD*(ANG_MAX+7);
double *fz8 = fz7 + SIMDD*(ANG_MAX+7);
double *fx9 = fx8 + SIMDD*(ANG_MAX+7);
double *fy9 = fy8 + SIMDD*(ANG_MAX+7);
double *fz9 = fz8 + SIMDD*(ANG_MAX+7);
double *fx10 = fx9 + SIMDD*(ANG_MAX+7);
double *fy10 = fy9 + SIMDD*(ANG_MAX+7);
double *fz10 = fz9 + SIMDD*(ANG_MAX+7);
double *fx11 = fx10 + SIMDD*(ANG_MAX+7);
double *fy11 = fy10 + SIMDD*(ANG_MAX+7);
double *fz11 = fz10 + SIMDD*(ANG_MAX+7);
double *fx12 = fx11 + SIMDD*(ANG_MAX+7);
double *fy12 = fy11 + SIMDD*(ANG_MAX+7);
double *fz12 = fz11 + SIMDD*(ANG_MAX+7);
double *fx13 = fx12 + SIMDD*(ANG_MAX+7);
double *fy13 = fy12 + SIMDD*(ANG_MAX+7);
double *fz13 = fz12 + SIMDD*(ANG_MAX+7);
double *fx14 = fx13 + SIMDD*(ANG_MAX+7);
double *fy14 = fy13 + SIMDD*(ANG_MAX+7);
double *fz14 = fz13 + SIMDD*(ANG_MAX+7);
double *fx15 = fx14 + SIMDD*(ANG_MAX+7);
double *fy15 = fy14 + SIMDD*(ANG_MAX+7);
double *fz15 = fz14 + SIMDD*(ANG_MAX+7);
double *fx16 = fx15 + SIMDD*(ANG_MAX+7);
double *fy16 = fy15 + SIMDD*(ANG_MAX+7);
double *fz16 = fz15 + SIMDD*(ANG_MAX+7);
double *fx17 = fx16 + SIMDD*(ANG_MAX+7);
double *fy17 = fy16 + SIMDD*(ANG_MAX+7);
double *fz17 = fz16 + SIMDD*(ANG_MAX+7);
double *fx18 = fx17 + SIMDD*(ANG_MAX+7);
double *fy18 = fy17 + SIMDD*(ANG_MAX+7);
double *fz18 = fz17 + SIMDD*(ANG_MAX+7);
double *fx19 = fx18 + SIMDD*(ANG_MAX+7);
double *fy19 = fy18 + SIMDD*(ANG_MAX+7);
double *fz19 = fz18 + SIMDD*(ANG_MAX+7);
double *fx20 = fx19 + SIMDD*(ANG_MAX+7);
double *fy20 = fy19 + SIMDD*(ANG_MAX+7);
double *fz20 = fz19 + SIMDD*(ANG_MAX+7);
double *fx21 = fx20 + SIMDD*(ANG_MAX+7);
double *fy21 = fy20 + SIMDD*(ANG_MAX+7);
double *fz21 = fz20 + SIMDD*(ANG_MAX+7);
double *fx22 = fx21 + SIMDD*(ANG_MAX+7);
double *fy22 = fy21 + SIMDD*(ANG_MAX+7);
double *fz22 = fz21 + SIMDD*(ANG_MAX+7);
double *fx23 = fx22 + SIMDD*(ANG_MAX+7);
double *fy23 = fy22 + SIMDD*(ANG_MAX+7);
double *fz23 = fz22 + SIMDD*(ANG_MAX+7);
double *fx24 = fx23 + SIMDD*(ANG_MAX+7);
double *fy24 = fy23 + SIMDD*(ANG_MAX+7);
double *fz24 = fz23 + SIMDD*(ANG_MAX+7);
double *fx25 = fx24 + SIMDD*(ANG_MAX+7);
double *fy25 = fy24 + SIMDD*(ANG_MAX+7);
double *fz25 = fz24 + SIMDD*(ANG_MAX+7);
double *fx26 = fx25 + SIMDD*(ANG_MAX+7);
double *fy26 = fy25 + SIMDD*(ANG_MAX+7);
double *fz26 = fz25 + SIMDD*(ANG_MAX+7);
double *fx27 = fx26 + SIMDD*(ANG_MAX+7);
double *fy27 = fy26 + SIMDD*(ANG_MAX+7);
double *fz27 = fz26 + SIMDD*(ANG_MAX+7);
double *fx28 = fx27 + SIMDD*(ANG_MAX+7);
double *fy28 = fy27 + SIMDD*(ANG_MAX+7);
double *fz28 = fz27 + SIMDD*(ANG_MAX+7);
double *fx29 = fx28 + SIMDD*(ANG_MAX+7);
double *fy29 = fy28 + SIMDD*(ANG_MAX+7);
double *fz29 = fz28 + SIMDD*(ANG_MAX+7);
double *fx30 = fx29 + SIMDD*(ANG_MAX+7);
double *fy30 = fy29 + SIMDD*(ANG_MAX+7);
double *fz30 = fz29 + SIMDD*(ANG_MAX+7);
double *fx31 = fx30 + SIMDD*(ANG_MAX+7);
double *fy31 = fy30 + SIMDD*(ANG_MAX+7);
double *fz31 = fz30 + SIMDD*(ANG_MAX+7);
double *fx32 = fx31 + SIMDD*(ANG_MAX+7);
double *fy32 = fy31 + SIMDD*(ANG_MAX+7);
double *fz32 = fz31 + SIMDD*(ANG_MAX+7);
double *fx33 = fx32 + SIMDD*(ANG_MAX+7);
double *fy33 = fy32 + SIMDD*(ANG_MAX+7);
double *fz33 = fz32 + SIMDD*(ANG_MAX+7);
double *fx34 = fx33 + SIMDD*(ANG_MAX+7);
double *fy34 = fy33 + SIMDD*(ANG_MAX+7);
double *fz34 = fz33 + SIMDD*(ANG_MAX+7);
double *fx35 = fx34 + SIMDD*(ANG_MAX+7);
double *fy35 = fy34 + SIMDD*(ANG_MAX+7);
double *fz35 = fz34 + SIMDD*(ANG_MAX+7);
double *fx36 = fx35 + SIMDD*(ANG_MAX+7);
double *fy36 = fy35 + SIMDD*(ANG_MAX+7);
double *fz36 = fz35 + SIMDD*(ANG_MAX+7);
double *fx37 = fx36 + SIMDD*(ANG_MAX+7);
double *fy37 = fy36 + SIMDD*(ANG_MAX+7);
double *fz37 = fz36 + SIMDD*(ANG_MAX+7);
double *fx38 = fx37 + SIMDD*(ANG_MAX+7);
double *fy38 = fy37 + SIMDD*(ANG_MAX+7);
double *fz38 = fz37 + SIMDD*(ANG_MAX+7);
double *fx39 = fx38 + SIMDD*(ANG_MAX+7);
double *fy39 = fy38 + SIMDD*(ANG_MAX+7);
double *fz39 = fz38 + SIMDD*(ANG_MAX+7);
double *fx40 = fx39 + SIMDD*(ANG_MAX+7);
double *fy40 = fy39 + SIMDD*(ANG_MAX+7);
double *fz40 = fz39 + SIMDD*(ANG_MAX+7);
double *fx41 = fx40 + SIMDD*(ANG_MAX+7);
double *fy41 = fy40 + SIMDD*(ANG_MAX+7);
double *fz41 = fz40 + SIMDD*(ANG_MAX+7);
double *fx42 = fx41 + SIMDD*(ANG_MAX+7);
double *fy42 = fy41 + SIMDD*(ANG_MAX+7);
double *fz42 = fz41 + SIMDD*(ANG_MAX+7);
double *fx43 = fx42 + SIMDD*(ANG_MAX+7);
double *fy43 = fy42 + SIMDD*(ANG_MAX+7);
double *fz43 = fz42 + SIMDD*(ANG_MAX+7);
double *fx44 = fx43 + SIMDD*(ANG_MAX+7);
double *fy44 = fy43 + SIMDD*(ANG_MAX+7);
double *fz44 = fz43 + SIMDD*(ANG_MAX+7);
double *fx45 = fx44 + SIMDD*(ANG_MAX+7);
double *fy45 = fy44 + SIMDD*(ANG_MAX+7);
double *fz45 = fz44 + SIMDD*(ANG_MAX+7);
double *fx46 = fx45 + SIMDD*(ANG_MAX+7);
double *fy46 = fy45 + SIMDD*(ANG_MAX+7);
double *fz46 = fz45 + SIMDD*(ANG_MAX+7);
double *fx47 = fx46 + SIMDD*(ANG_MAX+7);
double *fy47 = fy46 + SIMDD*(ANG_MAX+7);
double *fz47 = fz46 + SIMDD*(ANG_MAX+7);
double *fx48 = fx47 + SIMDD*(ANG_MAX+7);
double *fy48 = fy47 + SIMDD*(ANG_MAX+7);
double *fz48 = fz47 + SIMDD*(ANG_MAX+7);
double *fx49 = fx48 + SIMDD*(ANG_MAX+7);
double *fy49 = fy48 + SIMDD*(ANG_MAX+7);
double *fz49 = fz48 + SIMDD*(ANG_MAX+7);
double *fx50 = fx49 + SIMDD*(ANG_MAX+7);
double *fy50 = fy49 + SIMDD*(ANG_MAX+7);
double *fz50 = fz49 + SIMDD*(ANG_MAX+7);
double *fx51 = fx50 + SIMDD*(ANG_MAX+7);
double *fy51 = fy50 + SIMDD*(ANG_MAX+7);
double *fz51 = fz50 + SIMDD*(ANG_MAX+7);
double *fx52 = fx51 + SIMDD*(ANG_MAX+7);
double *fy52 = fy51 + SIMDD*(ANG_MAX+7);
double *fz52 = fz51 + SIMDD*(ANG_MAX+7);
double *fx53 = fx52 + SIMDD*(ANG_MAX+7);
double *fy53 = fy52 + SIMDD*(ANG_MAX+7);
double *fz53 = fz52 + SIMDD*(ANG_MAX+7);
double *fx54 = fx53 + SIMDD*(ANG_MAX+7);
double *fy54 = fy53 + SIMDD*(ANG_MAX+7);
double *fz54 = fz53 + SIMDD*(ANG_MAX+7);
double *fx55 = fx54 + SIMDD*(ANG_MAX+7);
double *fy55 = fy54 + SIMDD*(ANG_MAX+7);
double *fz55 = fz54 + SIMDD*(ANG_MAX+7);
double *fx56 = fx55 + SIMDD*(ANG_MAX+7);
double *fy56 = fy55 + SIMDD*(ANG_MAX+7);
double *fz56 = fz55 + SIMDD*(ANG_MAX+7);
double *fx57 = fx56 + SIMDD*(ANG_MAX+7);
double *fy57 = fy56 + SIMDD*(ANG_MAX+7);
double *fz57 = fz56 + SIMDD*(ANG_MAX+7);
double *fx58 = fx57 + SIMDD*(ANG_MAX+7);
double *fy58 = fy57 + SIMDD*(ANG_MAX+7);
double *fz58 = fz57 + SIMDD*(ANG_MAX+7);
double *fx59 = fx58 + SIMDD*(ANG_MAX+7);
double *fy59 = fy58 + SIMDD*(ANG_MAX+7);
double *fz59 = fz58 + SIMDD*(ANG_MAX+7);
double *fx60 = fx59 + SIMDD*(ANG_MAX+7);
double *fy60 = fy59 + SIMDD*(ANG_MAX+7);
double *fz60 = fz59 + SIMDD*(ANG_MAX+7);
double *fx61 = fx60 + SIMDD*(ANG_MAX+7);
double *fy61 = fy60 + SIMDD*(ANG_MAX+7);
double *fz61 = fz60 + SIMDD*(ANG_MAX+7);
double *fx62 = fx61 + SIMDD*(ANG_MAX+7);
double *fy62 = fy61 + SIMDD*(ANG_MAX+7);
double *fz62 = fz61 + SIMDD*(ANG_MAX+7);
double *fx63 = fx62 + SIMDD*(ANG_MAX+7);
double *fy63 = fy62 + SIMDD*(ANG_MAX+7);
double *fz63 = fz62 + SIMDD*(ANG_MAX+7);
double buf[SIMDD*nc*1];
double s[SIMDD*729];
double *gto0 = cgto;

for (j = 0; j < 1; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+6; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_R_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
GTO_R_I(8, 0, l+3);
GTO_R_I(9, 8, l+0);
GTO_R_I(10, 8, l+1);
GTO_R_I(11, 10, l+0);
GTO_R_I(12, 8, l+2);
GTO_R_I(13, 12, l+0);
GTO_R_I(14, 12, l+1);
GTO_R_I(15, 14, l+0);
GTO_D_I(16, 0, l+4);
GTO_R_I(17, 16, l+0);
GTO_R_I(18, 16, l+1);
GTO_R_I(19, 18, l+0);
GTO_R_I(20, 16, l+2);
GTO_R_I(21, 20, l+0);
GTO_R_I(22, 20, l+1);
GTO_R_I(23, 22, l+0);
GTO_R_I(24, 16, l+3);
GTO_R_I(25, 24, l+0);
GTO_R_I(26, 24, l+1);
GTO_R_I(27, 26, l+0);
GTO_R_I(28, 24, l+2);
GTO_R_I(29, 28, l+0);
GTO_R_I(30, 28, l+1);
GTO_R_I(31, 30, l+0);
GTO_D_I(32, 0, l+5);
GTO_R_I(33, 32, l+0);
GTO_R_I(34, 32, l+1);
GTO_R_I(35, 34, l+0);
GTO_R_I(36, 32, l+2);
GTO_R_I(37, 36, l+0);
GTO_R_I(38, 36, l+1);
GTO_R_I(39, 38, l+0);
GTO_R_I(40, 32, l+3);
GTO_R_I(41, 40, l+0);
GTO_R_I(42, 40, l+1);
GTO_R_I(43, 42, l+0);
GTO_R_I(44, 40, l+2);
GTO_R_I(45, 44, l+0);
GTO_R_I(46, 44, l+1);
GTO_R_I(47, 46, l+0);
GTO_D_I(48, 32, l+4);
GTO_R_I(49, 48, l+0);
GTO_R_I(50, 48, l+1);
GTO_R_I(51, 50, l+0);
GTO_R_I(52, 48, l+2);
GTO_R_I(53, 52, l+0);
GTO_R_I(54, 52, l+1);
GTO_R_I(55, 54, l+0);
GTO_R_I(56, 48, l+3);
GTO_R_I(57, 56, l+0);
GTO_R_I(58, 56, l+1);
GTO_R_I(59, 58, l+0);
GTO_R_I(60, 56, l+2);
GTO_R_I(61, 60, l+0);
GTO_R_I(62, 60, l+1);
GTO_R_I(63, 62, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx63[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx62[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx62[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx61[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx60[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx60[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx61[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx60[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx60[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx59[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx58[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx58[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx57[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx57[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx59[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx58[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx58[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx57[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx57[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx55[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx54[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx54[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx53[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx53[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx51[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx51[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx55[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx54[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx54[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx53[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx53[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx51[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx51[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[81*SIMDD+n] = e * fx47[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[82*SIMDD+n] = e * fx46[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[83*SIMDD+n] = e * fx46[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[84*SIMDD+n] = e * fx45[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[85*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[86*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[87*SIMDD+n] = e * fx45[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[88*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[89*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[90*SIMDD+n] = e * fx43[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[91*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[92*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[93*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[94*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[95*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[96*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[97*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[98*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[99*SIMDD+n] = e * fx43[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[100*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[101*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[102*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[103*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[104*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[105*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[106*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[107*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[108*SIMDD+n] = e * fx39[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[109*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[110*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[111*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[112*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[113*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[114*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[115*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[116*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[117*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[118*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[119*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[120*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[121*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy31[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[122*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[123*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[124*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[125*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[126*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[127*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[128*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[129*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[130*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[131*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[132*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[133*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[134*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[135*SIMDD+n] = e * fx39[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[136*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[137*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[138*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[139*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[140*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[141*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[142*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[143*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[144*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[145*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[146*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[147*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[148*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[149*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[150*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[151*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[152*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[153*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[154*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[155*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[156*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[157*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[158*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[159*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[160*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[161*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[162*SIMDD+n] = e * fx47[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[163*SIMDD+n] = e * fx46[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[164*SIMDD+n] = e * fx46[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[165*SIMDD+n] = e * fx45[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[166*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[167*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[168*SIMDD+n] = e * fx45[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[169*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[170*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[171*SIMDD+n] = e * fx43[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[172*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[173*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[174*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[175*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[176*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[177*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[178*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[179*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[180*SIMDD+n] = e * fx43[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[181*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[182*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[183*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[184*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[185*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[186*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[187*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[188*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[189*SIMDD+n] = e * fx39[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[190*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[191*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[192*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[193*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[194*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[195*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[196*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[197*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[198*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[199*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[200*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[201*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[202*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[203*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[204*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[205*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[206*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[207*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[208*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[209*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[210*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[211*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[212*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[213*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[214*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[215*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[216*SIMDD+n] = e * fx39[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[217*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[218*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[219*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[220*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[221*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[222*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[223*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[224*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[225*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[226*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[227*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[228*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[229*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[230*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[231*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[232*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[233*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[234*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[235*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[236*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[237*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[238*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[239*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[240*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[241*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[242*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz31[lz*SIMDD+n];
s[243*SIMDD+n] = e * fx31[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[244*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[245*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[246*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[247*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[248*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[249*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[250*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[251*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[252*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[253*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[254*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[255*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[256*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy39[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[257*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[258*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[259*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[260*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[261*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[262*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[263*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[264*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[265*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[266*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[267*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[268*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[269*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[270*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[271*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[272*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[273*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[274*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy43[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[275*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[276*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[277*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[278*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[279*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[280*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy45[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[281*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[282*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy46[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[283*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy47[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[284*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy46[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[285*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[286*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy45[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[287*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[288*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[289*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[290*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[291*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[292*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy43[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[293*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[294*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[295*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[296*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[297*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[298*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[299*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[300*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[301*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[302*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[303*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[304*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[305*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[306*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[307*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[308*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[309*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[310*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy39[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[311*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[312*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[313*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[314*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[315*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[316*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[317*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[318*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[319*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[320*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[321*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[322*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[323*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[324*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[325*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[326*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[327*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[328*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy51[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[329*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[330*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[331*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[332*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[333*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[334*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy53[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[335*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[336*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy54[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[337*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy55[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[338*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy54[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[339*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[340*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy53[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[341*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[342*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[343*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[344*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[345*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[346*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy51[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[347*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[348*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[349*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[350*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[351*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[352*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy57[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[353*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[354*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy58[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[355*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy59[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[356*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy58[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[357*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[358*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy57[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[359*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[360*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy60[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[361*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy61[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[362*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy60[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[363*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy62[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[364*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy63[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[365*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy62[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[366*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy60[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[367*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy61[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[368*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy60[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[369*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[370*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy57[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[371*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[372*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy58[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[373*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy59[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[374*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy58[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[375*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[376*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy57[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[377*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[378*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[379*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[380*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[381*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[382*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy51[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[383*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[384*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[385*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[386*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[387*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[388*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy53[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[389*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[390*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy54[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[391*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy55[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[392*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy54[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[393*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[394*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy53[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[395*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[396*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[397*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[398*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[399*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[400*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy51[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[401*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[402*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[403*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[404*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[405*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[406*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[407*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[408*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[409*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[410*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[411*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[412*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[413*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[414*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[415*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[416*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[417*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[418*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy39[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[419*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[420*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[421*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[422*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[423*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[424*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[425*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[426*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[427*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[428*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[429*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[430*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[431*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[432*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[433*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[434*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[435*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[436*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy43[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[437*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[438*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[439*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[440*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[441*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[442*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy45[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[443*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[444*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy46[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[445*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy47[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[446*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy46[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[447*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[448*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy45[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[449*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[450*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[451*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[452*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[453*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[454*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy43[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[455*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[456*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[457*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[458*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[459*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[460*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[461*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[462*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[463*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[464*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[465*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[466*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[467*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[468*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[469*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[470*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[471*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[472*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy39[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[473*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[474*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[475*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[476*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[477*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[478*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[479*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[480*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[481*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[482*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[483*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[484*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[485*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz31[lz*SIMDD+n];
s[486*SIMDD+n] = e * fx31[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[487*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[488*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[489*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[490*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[491*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[492*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[493*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[494*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[495*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[496*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[497*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[498*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[499*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[500*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[501*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[502*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[503*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[504*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[505*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[506*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[507*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[508*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[509*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[510*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[511*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[512*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz39[lz*SIMDD+n];
s[513*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[514*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[515*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[516*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[517*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[518*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[519*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[520*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[521*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[522*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[523*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[524*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[525*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[526*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[527*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[528*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[529*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[530*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[531*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[532*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[533*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[534*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[535*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[536*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[537*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[538*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[539*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz39[lz*SIMDD+n];
s[540*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[541*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[542*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[543*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[544*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[545*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[546*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[547*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[548*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz43[lz*SIMDD+n];
s[549*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[550*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[551*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[552*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[553*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[554*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[555*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[556*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[557*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz43[lz*SIMDD+n];
s[558*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[559*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[560*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz45[lz*SIMDD+n];
s[561*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[562*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[563*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz45[lz*SIMDD+n];
s[564*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz46[lz*SIMDD+n];
s[565*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz46[lz*SIMDD+n];
s[566*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz47[lz*SIMDD+n];
s[567*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[568*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[569*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[570*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[571*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[572*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[573*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[574*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[575*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[576*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[577*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[578*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[579*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[580*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[581*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[582*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[583*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[584*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[585*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[586*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[587*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[588*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[589*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[590*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[591*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[592*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[593*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz39[lz*SIMDD+n];
s[594*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[595*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[596*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[597*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[598*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[599*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[600*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[601*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[602*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[603*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[604*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[605*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[606*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[607*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy31[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[608*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[609*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[610*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[611*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[612*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[613*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[614*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[615*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[616*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[617*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[618*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[619*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[620*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz39[lz*SIMDD+n];
s[621*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[622*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[623*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[624*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[625*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[626*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[627*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[628*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[629*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz43[lz*SIMDD+n];
s[630*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[631*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[632*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[633*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[634*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[635*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[636*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[637*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[638*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz43[lz*SIMDD+n];
s[639*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[640*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[641*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz45[lz*SIMDD+n];
s[642*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[643*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[644*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz45[lz*SIMDD+n];
s[645*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz46[lz*SIMDD+n];
s[646*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz46[lz*SIMDD+n];
s[647*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz47[lz*SIMDD+n];
s[648*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[649*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[650*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[651*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[652*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[653*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[654*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[655*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[656*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz51[lz*SIMDD+n];
s[657*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[658*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[659*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[660*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[661*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[662*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[663*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[664*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[665*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz51[lz*SIMDD+n];
s[666*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[667*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[668*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz53[lz*SIMDD+n];
s[669*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[670*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[671*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz53[lz*SIMDD+n];
s[672*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz54[lz*SIMDD+n];
s[673*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz54[lz*SIMDD+n];
s[674*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz55[lz*SIMDD+n];
s[675*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[676*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[677*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[678*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[679*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[680*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[681*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[682*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[683*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz51[lz*SIMDD+n];
s[684*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[685*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[686*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[687*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[688*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[689*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[690*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[691*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[692*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz51[lz*SIMDD+n];
s[693*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[694*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[695*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz53[lz*SIMDD+n];
s[696*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[697*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[698*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz53[lz*SIMDD+n];
s[699*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz54[lz*SIMDD+n];
s[700*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz54[lz*SIMDD+n];
s[701*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz55[lz*SIMDD+n];
s[702*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[703*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[704*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz57[lz*SIMDD+n];
s[705*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[706*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[707*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz57[lz*SIMDD+n];
s[708*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz58[lz*SIMDD+n];
s[709*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz58[lz*SIMDD+n];
s[710*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz59[lz*SIMDD+n];
s[711*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[712*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[713*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz57[lz*SIMDD+n];
s[714*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[715*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[716*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz57[lz*SIMDD+n];
s[717*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz58[lz*SIMDD+n];
s[718*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz58[lz*SIMDD+n];
s[719*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz59[lz*SIMDD+n];
s[720*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz60[lz*SIMDD+n];
s[721*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz60[lz*SIMDD+n];
s[722*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz61[lz*SIMDD+n];
s[723*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz60[lz*SIMDD+n];
s[724*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz60[lz*SIMDD+n];
s[725*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz61[lz*SIMDD+n];
s[726*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz62[lz*SIMDD+n];
s[727*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz62[lz*SIMDD+n];
s[728*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz63[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[324*SIMDD+n] + s[648*SIMDD+n] + (2*s[4*SIMDD+n]) + (2*s[328*SIMDD+n]) + (2*s[652*SIMDD+n]) + (2*s[8*SIMDD+n]) + (2*s[332*SIMDD+n]) + (2*s[656*SIMDD+n]) + s[40*SIMDD+n] + s[364*SIMDD+n] + s[688*SIMDD+n] + (2*s[44*SIMDD+n]) + (2*s[368*SIMDD+n]) + (2*s[692*SIMDD+n]) + s[80*SIMDD+n] + s[404*SIMDD+n] + s[728*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+6; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_R_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
GTO_R_I(4, 0, l+2);
GTO_R_I(5, 4, l+0);
GTO_R_I(6, 4, l+1);
GTO_R_I(7, 6, l+0);
GTO_R_I(8, 0, l+3);
GTO_R_I(9, 8, l+0);
GTO_R_I(10, 8, l+1);
GTO_R_I(11, 10, l+0);
GTO_R_I(12, 8, l+2);
GTO_R_I(13, 12, l+0);
GTO_R_I(14, 12, l+1);
GTO_R_I(15, 14, l+0);
GTO_D_I(16, 0, l+4);
GTO_R_I(17, 16, l+0);
GTO_R_I(18, 16, l+1);
GTO_R_I(19, 18, l+0);
GTO_R_I(20, 16, l+2);
GTO_R_I(21, 20, l+0);
GTO_R_I(22, 20, l+1);
GTO_R_I(23, 22, l+0);
GTO_R_I(24, 16, l+3);
GTO_R_I(25, 24, l+0);
GTO_R_I(26, 24, l+1);
GTO_R_I(27, 26, l+0);
GTO_R_I(28, 24, l+2);
GTO_R_I(29, 28, l+0);
GTO_R_I(30, 28, l+1);
GTO_R_I(31, 30, l+0);
GTO_D_I(32, 0, l+5);
GTO_R_I(33, 32, l+0);
GTO_R_I(34, 32, l+1);
GTO_R_I(35, 34, l+0);
GTO_R_I(36, 32, l+2);
GTO_R_I(37, 36, l+0);
GTO_R_I(38, 36, l+1);
GTO_R_I(39, 38, l+0);
GTO_R_I(40, 32, l+3);
GTO_R_I(41, 40, l+0);
GTO_R_I(42, 40, l+1);
GTO_R_I(43, 42, l+0);
GTO_R_I(44, 40, l+2);
GTO_R_I(45, 44, l+0);
GTO_R_I(46, 44, l+1);
GTO_R_I(47, 46, l+0);
GTO_D_I(48, 32, l+4);
GTO_R_I(49, 48, l+0);
GTO_R_I(50, 48, l+1);
GTO_R_I(51, 50, l+0);
GTO_R_I(52, 48, l+2);
GTO_R_I(53, 52, l+0);
GTO_R_I(54, 52, l+1);
GTO_R_I(55, 54, l+0);
GTO_R_I(56, 48, l+3);
GTO_R_I(57, 56, l+0);
GTO_R_I(58, 56, l+1);
GTO_R_I(59, 58, l+0);
GTO_R_I(60, 56, l+2);
GTO_R_I(61, 60, l+0);
GTO_R_I(62, 60, l+1);
GTO_R_I(63, 62, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx63[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx62[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx62[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx61[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx60[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx60[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx61[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx60[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx60[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx59[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx58[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx58[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx57[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx57[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx59[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx58[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx58[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx57[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx57[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx56[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx55[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx54[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx54[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx53[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx53[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx51[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx51[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx55[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx54[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx54[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx53[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx53[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx52[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx51[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx51[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx50[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx49[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx48[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[81*SIMDD+n] = e * fx47[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[82*SIMDD+n] = e * fx46[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[83*SIMDD+n] = e * fx46[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[84*SIMDD+n] = e * fx45[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[85*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[86*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[87*SIMDD+n] = e * fx45[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[88*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[89*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[90*SIMDD+n] = e * fx43[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[91*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[92*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[93*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[94*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[95*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[96*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[97*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[98*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[99*SIMDD+n] = e * fx43[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[100*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[101*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[102*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[103*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[104*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[105*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[106*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[107*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[108*SIMDD+n] = e * fx39[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[109*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[110*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[111*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[112*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[113*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[114*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[115*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[116*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[117*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[118*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[119*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[120*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[121*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy31[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[122*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[123*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[124*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[125*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[126*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[127*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[128*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[129*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[130*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[131*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[132*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[133*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[134*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[135*SIMDD+n] = e * fx39[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[136*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[137*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[138*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[139*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[140*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[141*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[142*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[143*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[144*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[145*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[146*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[147*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[148*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[149*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[150*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[151*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[152*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[153*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[154*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[155*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[156*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[157*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[158*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[159*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[160*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[161*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[162*SIMDD+n] = e * fx47[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[163*SIMDD+n] = e * fx46[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[164*SIMDD+n] = e * fx46[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[165*SIMDD+n] = e * fx45[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[166*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[167*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[168*SIMDD+n] = e * fx45[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[169*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[170*SIMDD+n] = e * fx44[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[171*SIMDD+n] = e * fx43[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[172*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[173*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[174*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[175*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[176*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[177*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[178*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[179*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[180*SIMDD+n] = e * fx43[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[181*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[182*SIMDD+n] = e * fx42[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[183*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[184*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[185*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[186*SIMDD+n] = e * fx41[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[187*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[188*SIMDD+n] = e * fx40[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[189*SIMDD+n] = e * fx39[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[190*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[191*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[192*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[193*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[194*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[195*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[196*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[197*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[198*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[199*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[200*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[201*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[202*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[203*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[204*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[205*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[206*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[207*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[208*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[209*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[210*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[211*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[212*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[213*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[214*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[215*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[216*SIMDD+n] = e * fx39[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[217*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[218*SIMDD+n] = e * fx38[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[219*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[220*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[221*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[222*SIMDD+n] = e * fx37[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[223*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[224*SIMDD+n] = e * fx36[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[225*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[226*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[227*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[228*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[229*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[230*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[231*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[232*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[233*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[234*SIMDD+n] = e * fx35[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[235*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[236*SIMDD+n] = e * fx34[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[237*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[238*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[239*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[240*SIMDD+n] = e * fx33[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[241*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[242*SIMDD+n] = e * fx32[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz31[lz*SIMDD+n];
s[243*SIMDD+n] = e * fx31[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[244*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[245*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[246*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[247*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[248*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[249*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[250*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[251*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[252*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[253*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[254*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[255*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[256*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy39[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[257*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[258*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[259*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[260*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[261*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[262*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[263*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[264*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[265*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[266*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[267*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[268*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[269*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[270*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[271*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[272*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[273*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[274*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy43[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[275*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[276*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[277*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[278*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[279*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[280*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy45[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[281*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[282*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy46[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[283*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy47[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[284*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy46[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[285*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[286*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy45[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[287*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[288*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[289*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[290*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[291*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[292*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy43[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[293*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[294*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[295*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[296*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[297*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[298*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[299*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[300*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[301*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[302*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[303*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[304*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[305*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[306*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[307*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[308*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[309*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[310*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy39[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[311*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[312*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[313*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[314*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[315*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[316*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[317*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[318*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[319*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[320*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[321*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[322*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[323*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[324*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[325*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[326*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[327*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[328*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy51[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[329*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[330*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[331*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[332*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[333*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[334*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy53[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[335*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[336*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy54[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[337*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy55[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[338*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy54[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[339*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[340*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy53[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[341*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[342*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[343*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[344*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[345*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[346*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy51[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[347*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[348*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[349*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[350*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[351*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[352*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy57[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[353*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[354*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy58[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[355*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy59[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[356*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy58[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[357*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[358*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy57[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[359*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[360*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy60[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[361*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy61[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[362*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy60[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[363*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy62[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[364*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy63[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[365*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy62[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[366*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy60[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[367*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy61[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[368*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy60[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[369*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[370*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy57[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[371*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[372*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy58[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[373*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy59[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[374*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy58[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[375*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[376*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy57[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[377*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy56[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[378*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[379*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[380*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[381*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[382*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy51[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[383*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[384*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[385*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[386*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[387*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[388*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy53[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[389*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[390*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy54[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[391*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy55[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[392*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy54[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[393*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[394*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy53[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[395*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy52[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[396*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[397*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[398*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[399*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[400*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy51[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[401*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy50[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[402*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[403*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy49[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[404*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy48[ly*SIMDD+n] * fz15[lz*SIMDD+n];
s[405*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[406*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[407*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[408*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[409*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[410*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[411*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[412*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[413*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[414*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[415*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[416*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[417*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[418*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy39[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[419*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[420*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[421*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[422*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[423*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[424*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[425*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[426*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[427*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[428*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[429*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[430*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[431*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[432*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[433*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[434*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[435*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[436*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy43[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[437*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[438*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[439*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[440*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[441*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[442*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy45[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[443*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[444*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy46[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[445*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy47[ly*SIMDD+n] * fz16[lz*SIMDD+n];
s[446*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy46[ly*SIMDD+n] * fz17[lz*SIMDD+n];
s[447*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[448*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy45[ly*SIMDD+n] * fz18[lz*SIMDD+n];
s[449*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy44[ly*SIMDD+n] * fz19[lz*SIMDD+n];
s[450*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[451*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[452*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[453*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[454*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy43[ly*SIMDD+n] * fz20[lz*SIMDD+n];
s[455*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy42[ly*SIMDD+n] * fz21[lz*SIMDD+n];
s[456*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[457*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy41[ly*SIMDD+n] * fz22[lz*SIMDD+n];
s[458*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy40[ly*SIMDD+n] * fz23[lz*SIMDD+n];
s[459*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[460*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[461*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[462*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[463*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[464*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[465*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[466*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[467*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[468*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[469*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[470*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[471*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[472*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy39[ly*SIMDD+n] * fz24[lz*SIMDD+n];
s[473*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy38[ly*SIMDD+n] * fz25[lz*SIMDD+n];
s[474*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[475*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy37[ly*SIMDD+n] * fz26[lz*SIMDD+n];
s[476*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy36[ly*SIMDD+n] * fz27[lz*SIMDD+n];
s[477*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[478*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[479*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[480*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[481*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy35[ly*SIMDD+n] * fz28[lz*SIMDD+n];
s[482*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy34[ly*SIMDD+n] * fz29[lz*SIMDD+n];
s[483*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[484*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy33[ly*SIMDD+n] * fz30[lz*SIMDD+n];
s[485*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy32[ly*SIMDD+n] * fz31[lz*SIMDD+n];
s[486*SIMDD+n] = e * fx31[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[487*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[488*SIMDD+n] = e * fx30[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[489*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[490*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[491*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[492*SIMDD+n] = e * fx29[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[493*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[494*SIMDD+n] = e * fx28[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[495*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[496*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[497*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[498*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[499*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[500*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[501*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[502*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[503*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[504*SIMDD+n] = e * fx27[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[505*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[506*SIMDD+n] = e * fx26[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[507*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[508*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[509*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[510*SIMDD+n] = e * fx25[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[511*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[512*SIMDD+n] = e * fx24[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz39[lz*SIMDD+n];
s[513*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[514*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[515*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[516*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[517*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[518*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[519*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[520*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[521*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[522*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[523*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[524*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[525*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[526*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[527*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[528*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[529*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[530*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[531*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[532*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[533*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[534*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[535*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[536*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[537*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[538*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[539*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz39[lz*SIMDD+n];
s[540*SIMDD+n] = e * fx23[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[541*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[542*SIMDD+n] = e * fx22[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[543*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[544*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[545*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[546*SIMDD+n] = e * fx21[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[547*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[548*SIMDD+n] = e * fx20[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz43[lz*SIMDD+n];
s[549*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[550*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[551*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[552*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[553*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[554*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[555*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[556*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[557*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz43[lz*SIMDD+n];
s[558*SIMDD+n] = e * fx19[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[559*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[560*SIMDD+n] = e * fx18[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz45[lz*SIMDD+n];
s[561*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[562*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[563*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz45[lz*SIMDD+n];
s[564*SIMDD+n] = e * fx17[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz46[lz*SIMDD+n];
s[565*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz46[lz*SIMDD+n];
s[566*SIMDD+n] = e * fx16[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz47[lz*SIMDD+n];
s[567*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[568*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[569*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[570*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[571*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[572*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[573*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[574*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[575*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[576*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[577*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[578*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[579*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[580*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[581*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[582*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[583*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[584*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[585*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[586*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[587*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[588*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[589*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[590*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[591*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[592*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[593*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz39[lz*SIMDD+n];
s[594*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[595*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[596*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[597*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[598*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[599*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[600*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[601*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[602*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[603*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[604*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[605*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[606*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[607*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy31[ly*SIMDD+n] * fz32[lz*SIMDD+n];
s[608*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy30[ly*SIMDD+n] * fz33[lz*SIMDD+n];
s[609*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[610*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy29[ly*SIMDD+n] * fz34[lz*SIMDD+n];
s[611*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy28[ly*SIMDD+n] * fz35[lz*SIMDD+n];
s[612*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[613*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[614*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[615*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[616*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy27[ly*SIMDD+n] * fz36[lz*SIMDD+n];
s[617*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy26[ly*SIMDD+n] * fz37[lz*SIMDD+n];
s[618*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[619*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy25[ly*SIMDD+n] * fz38[lz*SIMDD+n];
s[620*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy24[ly*SIMDD+n] * fz39[lz*SIMDD+n];
s[621*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[622*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[623*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[624*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[625*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[626*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[627*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[628*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[629*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz43[lz*SIMDD+n];
s[630*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[631*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[632*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[633*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[634*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy23[ly*SIMDD+n] * fz40[lz*SIMDD+n];
s[635*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy22[ly*SIMDD+n] * fz41[lz*SIMDD+n];
s[636*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[637*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy21[ly*SIMDD+n] * fz42[lz*SIMDD+n];
s[638*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy20[ly*SIMDD+n] * fz43[lz*SIMDD+n];
s[639*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[640*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[641*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz45[lz*SIMDD+n];
s[642*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[643*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy19[ly*SIMDD+n] * fz44[lz*SIMDD+n];
s[644*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy18[ly*SIMDD+n] * fz45[lz*SIMDD+n];
s[645*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz46[lz*SIMDD+n];
s[646*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy17[ly*SIMDD+n] * fz46[lz*SIMDD+n];
s[647*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy16[ly*SIMDD+n] * fz47[lz*SIMDD+n];
s[648*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[649*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[650*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[651*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[652*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[653*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[654*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[655*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[656*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz51[lz*SIMDD+n];
s[657*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[658*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[659*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[660*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[661*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[662*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[663*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[664*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[665*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz51[lz*SIMDD+n];
s[666*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[667*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[668*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz53[lz*SIMDD+n];
s[669*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[670*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[671*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz53[lz*SIMDD+n];
s[672*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz54[lz*SIMDD+n];
s[673*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz54[lz*SIMDD+n];
s[674*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz55[lz*SIMDD+n];
s[675*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[676*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[677*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[678*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[679*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[680*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[681*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[682*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[683*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz51[lz*SIMDD+n];
s[684*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[685*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[686*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[687*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[688*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz48[lz*SIMDD+n];
s[689*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz49[lz*SIMDD+n];
s[690*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[691*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz50[lz*SIMDD+n];
s[692*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz51[lz*SIMDD+n];
s[693*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[694*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[695*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz53[lz*SIMDD+n];
s[696*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[697*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz52[lz*SIMDD+n];
s[698*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz53[lz*SIMDD+n];
s[699*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz54[lz*SIMDD+n];
s[700*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz54[lz*SIMDD+n];
s[701*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz55[lz*SIMDD+n];
s[702*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[703*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[704*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz57[lz*SIMDD+n];
s[705*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[706*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[707*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz57[lz*SIMDD+n];
s[708*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz58[lz*SIMDD+n];
s[709*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz58[lz*SIMDD+n];
s[710*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz59[lz*SIMDD+n];
s[711*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[712*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[713*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz57[lz*SIMDD+n];
s[714*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[715*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz56[lz*SIMDD+n];
s[716*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz57[lz*SIMDD+n];
s[717*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz58[lz*SIMDD+n];
s[718*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz58[lz*SIMDD+n];
s[719*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz59[lz*SIMDD+n];
s[720*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz60[lz*SIMDD+n];
s[721*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz60[lz*SIMDD+n];
s[722*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz61[lz*SIMDD+n];
s[723*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz60[lz*SIMDD+n];
s[724*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz60[lz*SIMDD+n];
s[725*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz61[lz*SIMDD+n];
s[726*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz62[lz*SIMDD+n];
s[727*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz62[lz*SIMDD+n];
s[728*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz63[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[324*SIMDD+n] + s[648*SIMDD+n] + (2*s[4*SIMDD+n]) + (2*s[328*SIMDD+n]) + (2*s[652*SIMDD+n]) + (2*s[8*SIMDD+n]) + (2*s[332*SIMDD+n]) + (2*s[656*SIMDD+n]) + s[40*SIMDD+n] + s[364*SIMDD+n] + s[688*SIMDD+n] + (2*s[44*SIMDD+n]) + (2*s[368*SIMDD+n]) + (2*s[692*SIMDD+n]) + s[80*SIMDD+n] + s[404*SIMDD+n] + s[728*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_laplrrrr_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_cart_drv(shell_eval_GTOval_laplrrrr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_laplrrrr_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_sph_drv(shell_eval_GTOval_laplrrrr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_laplrrrr_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_spinor_drv(shell_eval_GTOval_laplrrrr, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA DOT NABLA |GTO> */
static void shell_eval_GTOval_lapl(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+3)*4];
double fy0[SIMDD*(ANG_MAX+3)*4];
double fz0[SIMDD*(ANG_MAX+3)*4];
double *fx1 = fx0 + SIMDD*(ANG_MAX+3);
double *fy1 = fy0 + SIMDD*(ANG_MAX+3);
double *fz1 = fz0 + SIMDD*(ANG_MAX+3);
double *fx2 = fx1 + SIMDD*(ANG_MAX+3);
double *fy2 = fy1 + SIMDD*(ANG_MAX+3);
double *fz2 = fz1 + SIMDD*(ANG_MAX+3);
double *fx3 = fx2 + SIMDD*(ANG_MAX+3);
double *fy3 = fy2 + SIMDD*(ANG_MAX+3);
double *fz3 = fz2 + SIMDD*(ANG_MAX+3);
double buf[SIMDD*nc*1];
double s[SIMDD*9];
double *gto0 = cgto;

for (j = 0; j < 1; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_lapl_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_cart_drv(shell_eval_GTOval_lapl, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_lapl_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_sph_drv(shell_eval_GTOval_lapl, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_lapl_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 1};
GTOeval_spinor_drv(shell_eval_GTOval_lapl, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA NABLA DOT NABLA |GTO> */
static void shell_eval_GTOval_iplapl(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+4)*8];
double fy0[SIMDD*(ANG_MAX+4)*8];
double fz0[SIMDD*(ANG_MAX+4)*8];
double *fx1 = fx0 + SIMDD*(ANG_MAX+4);
double *fy1 = fy0 + SIMDD*(ANG_MAX+4);
double *fz1 = fz0 + SIMDD*(ANG_MAX+4);
double *fx2 = fx1 + SIMDD*(ANG_MAX+4);
double *fy2 = fy1 + SIMDD*(ANG_MAX+4);
double *fz2 = fz1 + SIMDD*(ANG_MAX+4);
double *fx3 = fx2 + SIMDD*(ANG_MAX+4);
double *fy3 = fy2 + SIMDD*(ANG_MAX+4);
double *fz3 = fz2 + SIMDD*(ANG_MAX+4);
double *fx4 = fx3 + SIMDD*(ANG_MAX+4);
double *fy4 = fy3 + SIMDD*(ANG_MAX+4);
double *fz4 = fz3 + SIMDD*(ANG_MAX+4);
double *fx5 = fx4 + SIMDD*(ANG_MAX+4);
double *fy5 = fy4 + SIMDD*(ANG_MAX+4);
double *fz5 = fz4 + SIMDD*(ANG_MAX+4);
double *fx6 = fx5 + SIMDD*(ANG_MAX+4);
double *fy6 = fy5 + SIMDD*(ANG_MAX+4);
double *fz6 = fz5 + SIMDD*(ANG_MAX+4);
double *fx7 = fx6 + SIMDD*(ANG_MAX+4);
double *fy7 = fy6 + SIMDD*(ANG_MAX+4);
double *fz7 = fz6 + SIMDD*(ANG_MAX+4);
double buf[SIMDD*nc*3];
double s[SIMDD*27];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;

for (j = 0; j < 3; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+3; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_D_I(5, 4, l+0);
GTO_D_I(6, 4, l+1);
GTO_D_I(7, 6, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
buf[1*SIMDD+n] = + s[9*SIMDD+n] + s[13*SIMDD+n] + s[17*SIMDD+n];
buf[2*SIMDD+n] = + s[18*SIMDD+n] + s[22*SIMDD+n] + s[26*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+3; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_D_I(5, 4, l+0);
GTO_D_I(6, 4, l+1);
GTO_D_I(7, 6, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
buf[1*SIMDD+n] = + s[9*SIMDD+n] + s[13*SIMDD+n] + s[17*SIMDD+n];
buf[2*SIMDD+n] = + s[18*SIMDD+n] + s[22*SIMDD+n] + s[26*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_iplapl_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_cart_drv(shell_eval_GTOval_iplapl, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_iplapl_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_sph_drv(shell_eval_GTOval_iplapl, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_iplapl_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_spinor_drv(shell_eval_GTOval_iplapl, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA NABLA NABLA DOT NABLA |GTO> */
static void shell_eval_GTOval_ipiplapl(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+5)*16];
double fy0[SIMDD*(ANG_MAX+5)*16];
double fz0[SIMDD*(ANG_MAX+5)*16];
double *fx1 = fx0 + SIMDD*(ANG_MAX+5);
double *fy1 = fy0 + SIMDD*(ANG_MAX+5);
double *fz1 = fz0 + SIMDD*(ANG_MAX+5);
double *fx2 = fx1 + SIMDD*(ANG_MAX+5);
double *fy2 = fy1 + SIMDD*(ANG_MAX+5);
double *fz2 = fz1 + SIMDD*(ANG_MAX+5);
double *fx3 = fx2 + SIMDD*(ANG_MAX+5);
double *fy3 = fy2 + SIMDD*(ANG_MAX+5);
double *fz3 = fz2 + SIMDD*(ANG_MAX+5);
double *fx4 = fx3 + SIMDD*(ANG_MAX+5);
double *fy4 = fy3 + SIMDD*(ANG_MAX+5);
double *fz4 = fz3 + SIMDD*(ANG_MAX+5);
double *fx5 = fx4 + SIMDD*(ANG_MAX+5);
double *fy5 = fy4 + SIMDD*(ANG_MAX+5);
double *fz5 = fz4 + SIMDD*(ANG_MAX+5);
double *fx6 = fx5 + SIMDD*(ANG_MAX+5);
double *fy6 = fy5 + SIMDD*(ANG_MAX+5);
double *fz6 = fz5 + SIMDD*(ANG_MAX+5);
double *fx7 = fx6 + SIMDD*(ANG_MAX+5);
double *fy7 = fy6 + SIMDD*(ANG_MAX+5);
double *fz7 = fz6 + SIMDD*(ANG_MAX+5);
double *fx8 = fx7 + SIMDD*(ANG_MAX+5);
double *fy8 = fy7 + SIMDD*(ANG_MAX+5);
double *fz8 = fz7 + SIMDD*(ANG_MAX+5);
double *fx9 = fx8 + SIMDD*(ANG_MAX+5);
double *fy9 = fy8 + SIMDD*(ANG_MAX+5);
double *fz9 = fz8 + SIMDD*(ANG_MAX+5);
double *fx10 = fx9 + SIMDD*(ANG_MAX+5);
double *fy10 = fy9 + SIMDD*(ANG_MAX+5);
double *fz10 = fz9 + SIMDD*(ANG_MAX+5);
double *fx11 = fx10 + SIMDD*(ANG_MAX+5);
double *fy11 = fy10 + SIMDD*(ANG_MAX+5);
double *fz11 = fz10 + SIMDD*(ANG_MAX+5);
double *fx12 = fx11 + SIMDD*(ANG_MAX+5);
double *fy12 = fy11 + SIMDD*(ANG_MAX+5);
double *fz12 = fz11 + SIMDD*(ANG_MAX+5);
double *fx13 = fx12 + SIMDD*(ANG_MAX+5);
double *fy13 = fy12 + SIMDD*(ANG_MAX+5);
double *fz13 = fz12 + SIMDD*(ANG_MAX+5);
double *fx14 = fx13 + SIMDD*(ANG_MAX+5);
double *fy14 = fy13 + SIMDD*(ANG_MAX+5);
double *fz14 = fz13 + SIMDD*(ANG_MAX+5);
double *fx15 = fx14 + SIMDD*(ANG_MAX+5);
double *fy15 = fy14 + SIMDD*(ANG_MAX+5);
double *fz15 = fz14 + SIMDD*(ANG_MAX+5);
double buf[SIMDD*nc*9];
double s[SIMDD*81];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double *gto3 = cgto + nao*ngrids*3;
double *gto4 = cgto + nao*ngrids*4;
double *gto5 = cgto + nao*ngrids*5;
double *gto6 = cgto + nao*ngrids*6;
double *gto7 = cgto + nao*ngrids*7;
double *gto8 = cgto + nao*ngrids*8;

for (j = 0; j < 9; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+4; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_D_I(5, 4, l+0);
GTO_D_I(6, 4, l+1);
GTO_D_I(7, 6, l+0);
GTO_D_I(8, 0, l+3);
GTO_D_I(9, 8, l+0);
GTO_D_I(10, 8, l+1);
GTO_D_I(11, 10, l+0);
GTO_D_I(12, 8, l+2);
GTO_D_I(13, 12, l+0);
GTO_D_I(14, 12, l+1);
GTO_D_I(15, 14, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
buf[1*SIMDD+n] = + s[9*SIMDD+n] + s[13*SIMDD+n] + s[17*SIMDD+n];
buf[2*SIMDD+n] = + s[18*SIMDD+n] + s[22*SIMDD+n] + s[26*SIMDD+n];
buf[3*SIMDD+n] = + s[27*SIMDD+n] + s[31*SIMDD+n] + s[35*SIMDD+n];
buf[4*SIMDD+n] = + s[36*SIMDD+n] + s[40*SIMDD+n] + s[44*SIMDD+n];
buf[5*SIMDD+n] = + s[45*SIMDD+n] + s[49*SIMDD+n] + s[53*SIMDD+n];
buf[6*SIMDD+n] = + s[54*SIMDD+n] + s[58*SIMDD+n] + s[62*SIMDD+n];
buf[7*SIMDD+n] = + s[63*SIMDD+n] + s[67*SIMDD+n] + s[71*SIMDD+n];
buf[8*SIMDD+n] = + s[72*SIMDD+n] + s[76*SIMDD+n] + s[80*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+4; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_D_I(5, 4, l+0);
GTO_D_I(6, 4, l+1);
GTO_D_I(7, 6, l+0);
GTO_D_I(8, 0, l+3);
GTO_D_I(9, 8, l+0);
GTO_D_I(10, 8, l+1);
GTO_D_I(11, 10, l+0);
GTO_D_I(12, 8, l+2);
GTO_D_I(13, 12, l+0);
GTO_D_I(14, 12, l+1);
GTO_D_I(15, 14, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx15[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx14[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx13[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx12[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx11[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx10[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx9[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx8[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[27*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[28*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[29*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[30*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[31*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[32*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[33*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[34*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[35*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[36*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[37*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[38*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[39*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[40*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy15[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[41*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy14[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[42*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[43*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy13[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[44*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy12[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[45*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[46*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[47*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[48*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[49*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy11[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[50*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy10[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[51*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[52*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy9[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[53*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy8[ly*SIMDD+n] * fz7[lz*SIMDD+n];
s[54*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[55*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[56*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[57*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[58*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[59*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[60*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[61*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[62*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[63*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[64*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[65*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[66*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[67*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz8[lz*SIMDD+n];
s[68*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz9[lz*SIMDD+n];
s[69*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[70*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz10[lz*SIMDD+n];
s[71*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz11[lz*SIMDD+n];
s[72*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[73*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[74*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[75*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[76*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz12[lz*SIMDD+n];
s[77*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz13[lz*SIMDD+n];
s[78*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[79*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz14[lz*SIMDD+n];
s[80*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz15[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n] + s[4*SIMDD+n] + s[8*SIMDD+n];
buf[1*SIMDD+n] = + s[9*SIMDD+n] + s[13*SIMDD+n] + s[17*SIMDD+n];
buf[2*SIMDD+n] = + s[18*SIMDD+n] + s[22*SIMDD+n] + s[26*SIMDD+n];
buf[3*SIMDD+n] = + s[27*SIMDD+n] + s[31*SIMDD+n] + s[35*SIMDD+n];
buf[4*SIMDD+n] = + s[36*SIMDD+n] + s[40*SIMDD+n] + s[44*SIMDD+n];
buf[5*SIMDD+n] = + s[45*SIMDD+n] + s[49*SIMDD+n] + s[53*SIMDD+n];
buf[6*SIMDD+n] = + s[54*SIMDD+n] + s[58*SIMDD+n] + s[62*SIMDD+n];
buf[7*SIMDD+n] = + s[63*SIMDD+n] + s[67*SIMDD+n] + s[71*SIMDD+n];
buf[8*SIMDD+n] = + s[72*SIMDD+n] + s[76*SIMDD+n] + s[80*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_ipiplapl_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_cart_drv(shell_eval_GTOval_ipiplapl, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipiplapl_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_sph_drv(shell_eval_GTOval_ipiplapl, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipiplapl_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_spinor_drv(shell_eval_GTOval_ipiplapl, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  #C(0 1) G |GTO> */
static void shell_eval_GTOval_ig(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+2)*2];
double fy0[SIMDD*(ANG_MAX+2)*2];
double fz0[SIMDD*(ANG_MAX+2)*2];
double *fx1 = fx0 + SIMDD*(ANG_MAX+2);
double *fy1 = fy0 + SIMDD*(ANG_MAX+2);
double *fz1 = fz0 + SIMDD*(ANG_MAX+2);
double buf[SIMDD*nc*3];
double s[SIMDD*3];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double c[3];
c[0] = 1 * (-ri[0]);
c[1] = 1 * (-ri[1]);
c[2] = 1 * (-ri[2]);

for (j = 0; j < 3; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+1; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R0I(1, 0, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*c[1]*s[2*SIMDD+n]) + c[2]*s[1*SIMDD+n];
buf[1*SIMDD+n] = + (-1*c[2]*s[0*SIMDD+n]) + c[0]*s[2*SIMDD+n];
buf[2*SIMDD+n] = + (-1*c[0]*s[1*SIMDD+n]) + c[1]*s[0*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+1; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R0I(1, 0, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*c[1]*s[2*SIMDD+n]) + c[2]*s[1*SIMDD+n];
buf[1*SIMDD+n] = + (-1*c[2]*s[0*SIMDD+n]) + c[0]*s[2*SIMDD+n];
buf[2*SIMDD+n] = + (-1*c[0]*s[1*SIMDD+n]) + c[1]*s[0*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_ig_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_cart_drv(shell_eval_GTOval_ig, GTOprim_exp, 0.5,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ig_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_sph_drv(shell_eval_GTOval_ig, GTOprim_exp, 0.5,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ig_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 3};
GTOeval_spinor_drv(shell_eval_GTOval_ig, GTOprim_exp, CINTc2s_iket_spinor_sf1, 0.5,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  #C(0 1) NABLA G |GTO> */
static void shell_eval_GTOval_ipig(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+3)*4];
double fy0[SIMDD*(ANG_MAX+3)*4];
double fz0[SIMDD*(ANG_MAX+3)*4];
double *fx1 = fx0 + SIMDD*(ANG_MAX+3);
double *fy1 = fy0 + SIMDD*(ANG_MAX+3);
double *fz1 = fz0 + SIMDD*(ANG_MAX+3);
double *fx2 = fx1 + SIMDD*(ANG_MAX+3);
double *fy2 = fy1 + SIMDD*(ANG_MAX+3);
double *fz2 = fz1 + SIMDD*(ANG_MAX+3);
double *fx3 = fx2 + SIMDD*(ANG_MAX+3);
double *fy3 = fy2 + SIMDD*(ANG_MAX+3);
double *fz3 = fz2 + SIMDD*(ANG_MAX+3);
double buf[SIMDD*nc*9];
double s[SIMDD*9];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double *gto3 = cgto + nao*ngrids*3;
double *gto4 = cgto + nao*ngrids*4;
double *gto5 = cgto + nao*ngrids*5;
double *gto6 = cgto + nao*ngrids*6;
double *gto7 = cgto + nao*ngrids*7;
double *gto8 = cgto + nao*ngrids*8;
double c[3];
c[0] = 1 * (-ri[0]);
c[1] = 1 * (-ri[1]);
c[2] = 1 * (-ri[2]);

for (j = 0; j < 9; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R0I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_R0I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*c[1]*s[2*SIMDD+n]) + c[2]*s[1*SIMDD+n];
buf[1*SIMDD+n] = + (-1*c[2]*s[0*SIMDD+n]) + c[0]*s[2*SIMDD+n];
buf[2*SIMDD+n] = + (-1*c[0]*s[1*SIMDD+n]) + c[1]*s[0*SIMDD+n];
buf[3*SIMDD+n] = + (-1*c[1]*s[5*SIMDD+n]) + c[2]*s[4*SIMDD+n];
buf[4*SIMDD+n] = + (-1*c[2]*s[3*SIMDD+n]) + c[0]*s[5*SIMDD+n];
buf[5*SIMDD+n] = + (-1*c[0]*s[4*SIMDD+n]) + c[1]*s[3*SIMDD+n];
buf[6*SIMDD+n] = + (-1*c[1]*s[8*SIMDD+n]) + c[2]*s[7*SIMDD+n];
buf[7*SIMDD+n] = + (-1*c[2]*s[6*SIMDD+n]) + c[0]*s[8*SIMDD+n];
buf[8*SIMDD+n] = + (-1*c[0]*s[7*SIMDD+n]) + c[1]*s[6*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R0I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_R0I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*c[1]*s[2*SIMDD+n]) + c[2]*s[1*SIMDD+n];
buf[1*SIMDD+n] = + (-1*c[2]*s[0*SIMDD+n]) + c[0]*s[2*SIMDD+n];
buf[2*SIMDD+n] = + (-1*c[0]*s[1*SIMDD+n]) + c[1]*s[0*SIMDD+n];
buf[3*SIMDD+n] = + (-1*c[1]*s[5*SIMDD+n]) + c[2]*s[4*SIMDD+n];
buf[4*SIMDD+n] = + (-1*c[2]*s[3*SIMDD+n]) + c[0]*s[5*SIMDD+n];
buf[5*SIMDD+n] = + (-1*c[0]*s[4*SIMDD+n]) + c[1]*s[3*SIMDD+n];
buf[6*SIMDD+n] = + (-1*c[1]*s[8*SIMDD+n]) + c[2]*s[7*SIMDD+n];
buf[7*SIMDD+n] = + (-1*c[2]*s[6*SIMDD+n]) + c[0]*s[8*SIMDD+n];
buf[8*SIMDD+n] = + (-1*c[0]*s[7*SIMDD+n]) + c[1]*s[6*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_ipig_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_cart_drv(shell_eval_GTOval_ipig, GTOprim_exp, 0.5,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipig_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_sph_drv(shell_eval_GTOval_ipig, GTOprim_exp, 0.5,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipig_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_spinor_drv(shell_eval_GTOval_ipig, GTOprim_exp, CINTc2s_iket_spinor_sf1, 0.5,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  SIGMA DOT P |GTO> */
static void shell_eval_GTOval_sp(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+2)*2];
double fy0[SIMDD*(ANG_MAX+2)*2];
double fz0[SIMDD*(ANG_MAX+2)*2];
double *fx1 = fx0 + SIMDD*(ANG_MAX+2);
double *fy1 = fy0 + SIMDD*(ANG_MAX+2);
double *fz1 = fz0 + SIMDD*(ANG_MAX+2);
double buf[SIMDD*nc*4];
double s[SIMDD*3];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double *gto3 = cgto + nao*ngrids*3;

for (j = 0; j < 4; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+1; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*s[0*SIMDD+n]);
buf[1*SIMDD+n] = + (-1*s[1*SIMDD+n]);
buf[2*SIMDD+n] = + (-1*s[2*SIMDD+n]);
buf[3*SIMDD+n] = 0;
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+1; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*s[0*SIMDD+n]);
buf[1*SIMDD+n] = + (-1*s[1*SIMDD+n]);
buf[2*SIMDD+n] = + (-1*s[2*SIMDD+n]);
buf[3*SIMDD+n] = 0;
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_sp_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {4, 1};
GTOeval_cart_drv(shell_eval_GTOval_sp, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_sp_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {4, 1};
GTOeval_sph_drv(shell_eval_GTOval_sp, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_sp_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {4, 1};
GTOeval_spinor_drv(shell_eval_GTOval_sp, GTOprim_exp, CINTc2s_ket_spinor_si1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA SIGMA DOT P |GTO> */
static void shell_eval_GTOval_ipsp(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+3)*4];
double fy0[SIMDD*(ANG_MAX+3)*4];
double fz0[SIMDD*(ANG_MAX+3)*4];
double *fx1 = fx0 + SIMDD*(ANG_MAX+3);
double *fy1 = fy0 + SIMDD*(ANG_MAX+3);
double *fz1 = fz0 + SIMDD*(ANG_MAX+3);
double *fx2 = fx1 + SIMDD*(ANG_MAX+3);
double *fy2 = fy1 + SIMDD*(ANG_MAX+3);
double *fz2 = fz1 + SIMDD*(ANG_MAX+3);
double *fx3 = fx2 + SIMDD*(ANG_MAX+3);
double *fy3 = fy2 + SIMDD*(ANG_MAX+3);
double *fz3 = fz2 + SIMDD*(ANG_MAX+3);
double buf[SIMDD*nc*12];
double s[SIMDD*9];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double *gto3 = cgto + nao*ngrids*3;
double *gto4 = cgto + nao*ngrids*4;
double *gto5 = cgto + nao*ngrids*5;
double *gto6 = cgto + nao*ngrids*6;
double *gto7 = cgto + nao*ngrids*7;
double *gto8 = cgto + nao*ngrids*8;
double *gto9 = cgto + nao*ngrids*9;
double *gto10 = cgto + nao*ngrids*10;
double *gto11 = cgto + nao*ngrids*11;

for (j = 0; j < 12; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*s[0*SIMDD+n]);
buf[1*SIMDD+n] = + (-1*s[1*SIMDD+n]);
buf[2*SIMDD+n] = + (-1*s[2*SIMDD+n]);
buf[3*SIMDD+n] = 0;
buf[4*SIMDD+n] = + (-1*s[3*SIMDD+n]);
buf[5*SIMDD+n] = + (-1*s[4*SIMDD+n]);
buf[6*SIMDD+n] = + (-1*s[5*SIMDD+n]);
buf[7*SIMDD+n] = 0;
buf[8*SIMDD+n] = + (-1*s[6*SIMDD+n]);
buf[9*SIMDD+n] = + (-1*s[7*SIMDD+n]);
buf[10*SIMDD+n] = + (-1*s[8*SIMDD+n]);
buf[11*SIMDD+n] = 0;
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
gto9[j1*ngrids+i+n] += buf[9*SIMDD+n] * coeff[j*np+k];
gto10[j1*ngrids+i+n] += buf[10*SIMDD+n] * coeff[j*np+k];
gto11[j1*ngrids+i+n] += buf[11*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*s[0*SIMDD+n]);
buf[1*SIMDD+n] = + (-1*s[1*SIMDD+n]);
buf[2*SIMDD+n] = + (-1*s[2*SIMDD+n]);
buf[3*SIMDD+n] = 0;
buf[4*SIMDD+n] = + (-1*s[3*SIMDD+n]);
buf[5*SIMDD+n] = + (-1*s[4*SIMDD+n]);
buf[6*SIMDD+n] = + (-1*s[5*SIMDD+n]);
buf[7*SIMDD+n] = 0;
buf[8*SIMDD+n] = + (-1*s[6*SIMDD+n]);
buf[9*SIMDD+n] = + (-1*s[7*SIMDD+n]);
buf[10*SIMDD+n] = + (-1*s[8*SIMDD+n]);
buf[11*SIMDD+n] = 0;
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
gto9[j1*ngrids+i+n] += buf[9*SIMDD+n] * coeff[j*np+k];
gto10[j1*ngrids+i+n] += buf[10*SIMDD+n] * coeff[j*np+k];
gto11[j1*ngrids+i+n] += buf[11*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_ipsp_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {4, 3};
GTOeval_cart_drv(shell_eval_GTOval_ipsp, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipsp_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {4, 3};
GTOeval_sph_drv(shell_eval_GTOval_ipsp, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipsp_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {4, 3};
GTOeval_spinor_drv(shell_eval_GTOval_ipsp, GTOprim_exp, CINTc2s_ket_spinor_si1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA NABLA SIGMA DOT P |GTO> */
static void shell_eval_GTOval_ipipsp(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+4)*8];
double fy0[SIMDD*(ANG_MAX+4)*8];
double fz0[SIMDD*(ANG_MAX+4)*8];
double *fx1 = fx0 + SIMDD*(ANG_MAX+4);
double *fy1 = fy0 + SIMDD*(ANG_MAX+4);
double *fz1 = fz0 + SIMDD*(ANG_MAX+4);
double *fx2 = fx1 + SIMDD*(ANG_MAX+4);
double *fy2 = fy1 + SIMDD*(ANG_MAX+4);
double *fz2 = fz1 + SIMDD*(ANG_MAX+4);
double *fx3 = fx2 + SIMDD*(ANG_MAX+4);
double *fy3 = fy2 + SIMDD*(ANG_MAX+4);
double *fz3 = fz2 + SIMDD*(ANG_MAX+4);
double *fx4 = fx3 + SIMDD*(ANG_MAX+4);
double *fy4 = fy3 + SIMDD*(ANG_MAX+4);
double *fz4 = fz3 + SIMDD*(ANG_MAX+4);
double *fx5 = fx4 + SIMDD*(ANG_MAX+4);
double *fy5 = fy4 + SIMDD*(ANG_MAX+4);
double *fz5 = fz4 + SIMDD*(ANG_MAX+4);
double *fx6 = fx5 + SIMDD*(ANG_MAX+4);
double *fy6 = fy5 + SIMDD*(ANG_MAX+4);
double *fz6 = fz5 + SIMDD*(ANG_MAX+4);
double *fx7 = fx6 + SIMDD*(ANG_MAX+4);
double *fy7 = fy6 + SIMDD*(ANG_MAX+4);
double *fz7 = fz6 + SIMDD*(ANG_MAX+4);
double buf[SIMDD*nc*36];
double s[SIMDD*27];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double *gto3 = cgto + nao*ngrids*3;
double *gto4 = cgto + nao*ngrids*4;
double *gto5 = cgto + nao*ngrids*5;
double *gto6 = cgto + nao*ngrids*6;
double *gto7 = cgto + nao*ngrids*7;
double *gto8 = cgto + nao*ngrids*8;
double *gto9 = cgto + nao*ngrids*9;
double *gto10 = cgto + nao*ngrids*10;
double *gto11 = cgto + nao*ngrids*11;
double *gto12 = cgto + nao*ngrids*12;
double *gto13 = cgto + nao*ngrids*13;
double *gto14 = cgto + nao*ngrids*14;
double *gto15 = cgto + nao*ngrids*15;
double *gto16 = cgto + nao*ngrids*16;
double *gto17 = cgto + nao*ngrids*17;
double *gto18 = cgto + nao*ngrids*18;
double *gto19 = cgto + nao*ngrids*19;
double *gto20 = cgto + nao*ngrids*20;
double *gto21 = cgto + nao*ngrids*21;
double *gto22 = cgto + nao*ngrids*22;
double *gto23 = cgto + nao*ngrids*23;
double *gto24 = cgto + nao*ngrids*24;
double *gto25 = cgto + nao*ngrids*25;
double *gto26 = cgto + nao*ngrids*26;
double *gto27 = cgto + nao*ngrids*27;
double *gto28 = cgto + nao*ngrids*28;
double *gto29 = cgto + nao*ngrids*29;
double *gto30 = cgto + nao*ngrids*30;
double *gto31 = cgto + nao*ngrids*31;
double *gto32 = cgto + nao*ngrids*32;
double *gto33 = cgto + nao*ngrids*33;
double *gto34 = cgto + nao*ngrids*34;
double *gto35 = cgto + nao*ngrids*35;

for (j = 0; j < 36; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+3; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_D_I(5, 4, l+0);
GTO_D_I(6, 4, l+1);
GTO_D_I(7, 6, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*s[0*SIMDD+n]);
buf[1*SIMDD+n] = + (-1*s[1*SIMDD+n]);
buf[2*SIMDD+n] = + (-1*s[2*SIMDD+n]);
buf[3*SIMDD+n] = 0;
buf[4*SIMDD+n] = + (-1*s[3*SIMDD+n]);
buf[5*SIMDD+n] = + (-1*s[4*SIMDD+n]);
buf[6*SIMDD+n] = + (-1*s[5*SIMDD+n]);
buf[7*SIMDD+n] = 0;
buf[8*SIMDD+n] = + (-1*s[6*SIMDD+n]);
buf[9*SIMDD+n] = + (-1*s[7*SIMDD+n]);
buf[10*SIMDD+n] = + (-1*s[8*SIMDD+n]);
buf[11*SIMDD+n] = 0;
buf[12*SIMDD+n] = + (-1*s[9*SIMDD+n]);
buf[13*SIMDD+n] = + (-1*s[10*SIMDD+n]);
buf[14*SIMDD+n] = + (-1*s[11*SIMDD+n]);
buf[15*SIMDD+n] = 0;
buf[16*SIMDD+n] = + (-1*s[12*SIMDD+n]);
buf[17*SIMDD+n] = + (-1*s[13*SIMDD+n]);
buf[18*SIMDD+n] = + (-1*s[14*SIMDD+n]);
buf[19*SIMDD+n] = 0;
buf[20*SIMDD+n] = + (-1*s[15*SIMDD+n]);
buf[21*SIMDD+n] = + (-1*s[16*SIMDD+n]);
buf[22*SIMDD+n] = + (-1*s[17*SIMDD+n]);
buf[23*SIMDD+n] = 0;
buf[24*SIMDD+n] = + (-1*s[18*SIMDD+n]);
buf[25*SIMDD+n] = + (-1*s[19*SIMDD+n]);
buf[26*SIMDD+n] = + (-1*s[20*SIMDD+n]);
buf[27*SIMDD+n] = 0;
buf[28*SIMDD+n] = + (-1*s[21*SIMDD+n]);
buf[29*SIMDD+n] = + (-1*s[22*SIMDD+n]);
buf[30*SIMDD+n] = + (-1*s[23*SIMDD+n]);
buf[31*SIMDD+n] = 0;
buf[32*SIMDD+n] = + (-1*s[24*SIMDD+n]);
buf[33*SIMDD+n] = + (-1*s[25*SIMDD+n]);
buf[34*SIMDD+n] = + (-1*s[26*SIMDD+n]);
buf[35*SIMDD+n] = 0;
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
gto9[j1*ngrids+i+n] += buf[9*SIMDD+n] * coeff[j*np+k];
gto10[j1*ngrids+i+n] += buf[10*SIMDD+n] * coeff[j*np+k];
gto11[j1*ngrids+i+n] += buf[11*SIMDD+n] * coeff[j*np+k];
gto12[j1*ngrids+i+n] += buf[12*SIMDD+n] * coeff[j*np+k];
gto13[j1*ngrids+i+n] += buf[13*SIMDD+n] * coeff[j*np+k];
gto14[j1*ngrids+i+n] += buf[14*SIMDD+n] * coeff[j*np+k];
gto15[j1*ngrids+i+n] += buf[15*SIMDD+n] * coeff[j*np+k];
gto16[j1*ngrids+i+n] += buf[16*SIMDD+n] * coeff[j*np+k];
gto17[j1*ngrids+i+n] += buf[17*SIMDD+n] * coeff[j*np+k];
gto18[j1*ngrids+i+n] += buf[18*SIMDD+n] * coeff[j*np+k];
gto19[j1*ngrids+i+n] += buf[19*SIMDD+n] * coeff[j*np+k];
gto20[j1*ngrids+i+n] += buf[20*SIMDD+n] * coeff[j*np+k];
gto21[j1*ngrids+i+n] += buf[21*SIMDD+n] * coeff[j*np+k];
gto22[j1*ngrids+i+n] += buf[22*SIMDD+n] * coeff[j*np+k];
gto23[j1*ngrids+i+n] += buf[23*SIMDD+n] * coeff[j*np+k];
gto24[j1*ngrids+i+n] += buf[24*SIMDD+n] * coeff[j*np+k];
gto25[j1*ngrids+i+n] += buf[25*SIMDD+n] * coeff[j*np+k];
gto26[j1*ngrids+i+n] += buf[26*SIMDD+n] * coeff[j*np+k];
gto27[j1*ngrids+i+n] += buf[27*SIMDD+n] * coeff[j*np+k];
gto28[j1*ngrids+i+n] += buf[28*SIMDD+n] * coeff[j*np+k];
gto29[j1*ngrids+i+n] += buf[29*SIMDD+n] * coeff[j*np+k];
gto30[j1*ngrids+i+n] += buf[30*SIMDD+n] * coeff[j*np+k];
gto31[j1*ngrids+i+n] += buf[31*SIMDD+n] * coeff[j*np+k];
gto32[j1*ngrids+i+n] += buf[32*SIMDD+n] * coeff[j*np+k];
gto33[j1*ngrids+i+n] += buf[33*SIMDD+n] * coeff[j*np+k];
gto34[j1*ngrids+i+n] += buf[34*SIMDD+n] * coeff[j*np+k];
gto35[j1*ngrids+i+n] += buf[35*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+3; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_D_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_D_I(3, 2, l+0);
GTO_D_I(4, 0, l+2);
GTO_D_I(5, 4, l+0);
GTO_D_I(6, 4, l+1);
GTO_D_I(7, 6, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx7[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx6[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx5[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx4[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[9*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[10*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[11*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[12*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[13*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy7[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[14*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy6[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[15*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[16*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy5[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[17*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy4[ly*SIMDD+n] * fz3[lz*SIMDD+n];
s[18*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[19*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[20*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[21*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[22*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz4[lz*SIMDD+n];
s[23*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz5[lz*SIMDD+n];
s[24*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[25*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz6[lz*SIMDD+n];
s[26*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz7[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + (-1*s[0*SIMDD+n]);
buf[1*SIMDD+n] = + (-1*s[1*SIMDD+n]);
buf[2*SIMDD+n] = + (-1*s[2*SIMDD+n]);
buf[3*SIMDD+n] = 0;
buf[4*SIMDD+n] = + (-1*s[3*SIMDD+n]);
buf[5*SIMDD+n] = + (-1*s[4*SIMDD+n]);
buf[6*SIMDD+n] = + (-1*s[5*SIMDD+n]);
buf[7*SIMDD+n] = 0;
buf[8*SIMDD+n] = + (-1*s[6*SIMDD+n]);
buf[9*SIMDD+n] = + (-1*s[7*SIMDD+n]);
buf[10*SIMDD+n] = + (-1*s[8*SIMDD+n]);
buf[11*SIMDD+n] = 0;
buf[12*SIMDD+n] = + (-1*s[9*SIMDD+n]);
buf[13*SIMDD+n] = + (-1*s[10*SIMDD+n]);
buf[14*SIMDD+n] = + (-1*s[11*SIMDD+n]);
buf[15*SIMDD+n] = 0;
buf[16*SIMDD+n] = + (-1*s[12*SIMDD+n]);
buf[17*SIMDD+n] = + (-1*s[13*SIMDD+n]);
buf[18*SIMDD+n] = + (-1*s[14*SIMDD+n]);
buf[19*SIMDD+n] = 0;
buf[20*SIMDD+n] = + (-1*s[15*SIMDD+n]);
buf[21*SIMDD+n] = + (-1*s[16*SIMDD+n]);
buf[22*SIMDD+n] = + (-1*s[17*SIMDD+n]);
buf[23*SIMDD+n] = 0;
buf[24*SIMDD+n] = + (-1*s[18*SIMDD+n]);
buf[25*SIMDD+n] = + (-1*s[19*SIMDD+n]);
buf[26*SIMDD+n] = + (-1*s[20*SIMDD+n]);
buf[27*SIMDD+n] = 0;
buf[28*SIMDD+n] = + (-1*s[21*SIMDD+n]);
buf[29*SIMDD+n] = + (-1*s[22*SIMDD+n]);
buf[30*SIMDD+n] = + (-1*s[23*SIMDD+n]);
buf[31*SIMDD+n] = 0;
buf[32*SIMDD+n] = + (-1*s[24*SIMDD+n]);
buf[33*SIMDD+n] = + (-1*s[25*SIMDD+n]);
buf[34*SIMDD+n] = + (-1*s[26*SIMDD+n]);
buf[35*SIMDD+n] = 0;
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
gto9[j1*ngrids+i+n] += buf[9*SIMDD+n] * coeff[j*np+k];
gto10[j1*ngrids+i+n] += buf[10*SIMDD+n] * coeff[j*np+k];
gto11[j1*ngrids+i+n] += buf[11*SIMDD+n] * coeff[j*np+k];
gto12[j1*ngrids+i+n] += buf[12*SIMDD+n] * coeff[j*np+k];
gto13[j1*ngrids+i+n] += buf[13*SIMDD+n] * coeff[j*np+k];
gto14[j1*ngrids+i+n] += buf[14*SIMDD+n] * coeff[j*np+k];
gto15[j1*ngrids+i+n] += buf[15*SIMDD+n] * coeff[j*np+k];
gto16[j1*ngrids+i+n] += buf[16*SIMDD+n] * coeff[j*np+k];
gto17[j1*ngrids+i+n] += buf[17*SIMDD+n] * coeff[j*np+k];
gto18[j1*ngrids+i+n] += buf[18*SIMDD+n] * coeff[j*np+k];
gto19[j1*ngrids+i+n] += buf[19*SIMDD+n] * coeff[j*np+k];
gto20[j1*ngrids+i+n] += buf[20*SIMDD+n] * coeff[j*np+k];
gto21[j1*ngrids+i+n] += buf[21*SIMDD+n] * coeff[j*np+k];
gto22[j1*ngrids+i+n] += buf[22*SIMDD+n] * coeff[j*np+k];
gto23[j1*ngrids+i+n] += buf[23*SIMDD+n] * coeff[j*np+k];
gto24[j1*ngrids+i+n] += buf[24*SIMDD+n] * coeff[j*np+k];
gto25[j1*ngrids+i+n] += buf[25*SIMDD+n] * coeff[j*np+k];
gto26[j1*ngrids+i+n] += buf[26*SIMDD+n] * coeff[j*np+k];
gto27[j1*ngrids+i+n] += buf[27*SIMDD+n] * coeff[j*np+k];
gto28[j1*ngrids+i+n] += buf[28*SIMDD+n] * coeff[j*np+k];
gto29[j1*ngrids+i+n] += buf[29*SIMDD+n] * coeff[j*np+k];
gto30[j1*ngrids+i+n] += buf[30*SIMDD+n] * coeff[j*np+k];
gto31[j1*ngrids+i+n] += buf[31*SIMDD+n] * coeff[j*np+k];
gto32[j1*ngrids+i+n] += buf[32*SIMDD+n] * coeff[j*np+k];
gto33[j1*ngrids+i+n] += buf[33*SIMDD+n] * coeff[j*np+k];
gto34[j1*ngrids+i+n] += buf[34*SIMDD+n] * coeff[j*np+k];
gto35[j1*ngrids+i+n] += buf[35*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_ipipsp_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {4, 9};
GTOeval_cart_drv(shell_eval_GTOval_ipipsp, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipipsp_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {4, 9};
GTOeval_sph_drv(shell_eval_GTOval_ipipsp, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipipsp_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {4, 9};
GTOeval_spinor_drv(shell_eval_GTOval_ipipsp, GTOprim_exp, CINTc2s_ket_spinor_si1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA RC |GTO> */
static void shell_eval_GTOval_iprc(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+3)*4];
double fy0[SIMDD*(ANG_MAX+3)*4];
double fz0[SIMDD*(ANG_MAX+3)*4];
double *fx1 = fx0 + SIMDD*(ANG_MAX+3);
double *fy1 = fy0 + SIMDD*(ANG_MAX+3);
double *fz1 = fz0 + SIMDD*(ANG_MAX+3);
double *fx2 = fx1 + SIMDD*(ANG_MAX+3);
double *fy2 = fy1 + SIMDD*(ANG_MAX+3);
double *fz2 = fz1 + SIMDD*(ANG_MAX+3);
double *fx3 = fx2 + SIMDD*(ANG_MAX+3);
double *fy3 = fy2 + SIMDD*(ANG_MAX+3);
double *fz3 = fz2 + SIMDD*(ANG_MAX+3);
double buf[SIMDD*nc*9];
double s[SIMDD*9];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double *gto3 = cgto + nao*ngrids*3;
double *gto4 = cgto + nao*ngrids*4;
double *gto5 = cgto + nao*ngrids*5;
double *gto6 = cgto + nao*ngrids*6;
double *gto7 = cgto + nao*ngrids*7;
double *gto8 = cgto + nao*ngrids*8;
double dri[3];
dri[0] = ri[0] - env[PTR_COMMON_ORIG+0];
dri[1] = ri[1] - env[PTR_COMMON_ORIG+1];
dri[2] = ri[2] - env[PTR_COMMON_ORIG+2];

for (j = 0; j < 9; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_RCI(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_RCI(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n];
buf[1*SIMDD+n] = + s[1*SIMDD+n];
buf[2*SIMDD+n] = + s[2*SIMDD+n];
buf[3*SIMDD+n] = + s[3*SIMDD+n];
buf[4*SIMDD+n] = + s[4*SIMDD+n];
buf[5*SIMDD+n] = + s[5*SIMDD+n];
buf[6*SIMDD+n] = + s[6*SIMDD+n];
buf[7*SIMDD+n] = + s[7*SIMDD+n];
buf[8*SIMDD+n] = + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_RCI(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_RCI(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n];
buf[1*SIMDD+n] = + s[1*SIMDD+n];
buf[2*SIMDD+n] = + s[2*SIMDD+n];
buf[3*SIMDD+n] = + s[3*SIMDD+n];
buf[4*SIMDD+n] = + s[4*SIMDD+n];
buf[5*SIMDD+n] = + s[5*SIMDD+n];
buf[6*SIMDD+n] = + s[6*SIMDD+n];
buf[7*SIMDD+n] = + s[7*SIMDD+n];
buf[8*SIMDD+n] = + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_iprc_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_cart_drv(shell_eval_GTOval_iprc, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_iprc_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_sph_drv(shell_eval_GTOval_iprc, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_iprc_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_spinor_drv(shell_eval_GTOval_iprc, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
/*  NABLA R |GTO> */
static void shell_eval_GTOval_ipr(double *cgto, double *ri, double *exps,
double *coord, double *alpha, double *coeff, double *env,
int l, int np, int nc, size_t nao, size_t ngrids, size_t bgrids)
{
const size_t degen = (l+1)*(l+2)/2;
const size_t bgrids0 = (bgrids >= SIMDD) ? (bgrids+1-SIMDD) : 0;
int lx, ly, lz;
size_t i, j, j1, k, l1, n;
double e;
double *pgto;
double *gridx = coord;
double *gridy = coord+BLKSIZE;
double *gridz = coord+BLKSIZE*2;
double fx0[SIMDD*(ANG_MAX+3)*4];
double fy0[SIMDD*(ANG_MAX+3)*4];
double fz0[SIMDD*(ANG_MAX+3)*4];
double *fx1 = fx0 + SIMDD*(ANG_MAX+3);
double *fy1 = fy0 + SIMDD*(ANG_MAX+3);
double *fz1 = fz0 + SIMDD*(ANG_MAX+3);
double *fx2 = fx1 + SIMDD*(ANG_MAX+3);
double *fy2 = fy1 + SIMDD*(ANG_MAX+3);
double *fz2 = fz1 + SIMDD*(ANG_MAX+3);
double *fx3 = fx2 + SIMDD*(ANG_MAX+3);
double *fy3 = fy2 + SIMDD*(ANG_MAX+3);
double *fz3 = fz2 + SIMDD*(ANG_MAX+3);
double buf[SIMDD*nc*9];
double s[SIMDD*9];
double *gto0 = cgto;
double *gto1 = cgto + nao*ngrids*1;
double *gto2 = cgto + nao*ngrids*2;
double *gto3 = cgto + nao*ngrids*3;
double *gto4 = cgto + nao*ngrids*4;
double *gto5 = cgto + nao*ngrids*5;
double *gto6 = cgto + nao*ngrids*6;
double *gto7 = cgto + nao*ngrids*7;
double *gto8 = cgto + nao*ngrids*8;

for (j = 0; j < 9; j++) {
        pgto = cgto + j*nao*ngrids;
        for (n = 0; n < degen*nc; n++) {
        for (i = 0; i < bgrids; i++) {
                pgto[n*ngrids+i] = 0;
        } }
}
for (i = 0; i < bgrids0; i+=SIMDD) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, SIMDD)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n];
buf[1*SIMDD+n] = + s[1*SIMDD+n];
buf[2*SIMDD+n] = + s[2*SIMDD+n];
buf[3*SIMDD+n] = + s[3*SIMDD+n];
buf[4*SIMDD+n] = + s[4*SIMDD+n];
buf[5*SIMDD+n] = + s[5*SIMDD+n];
buf[6*SIMDD+n] = + s[6*SIMDD+n];
buf[7*SIMDD+n] = + s[7*SIMDD+n];
buf[8*SIMDD+n] = + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
#pragma GCC ivdep
                for (n = 0; n < SIMDD; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }

if (i < bgrids) {
        for (k = 0; k < np; k++) {
                if (_nonzero_in(exps+k*BLKSIZE+i, bgrids-i)) {
for (n = 0; n < SIMDD; n++) {
        fx0[n] = 1;
        fy0[n] = 1;
        fz0[n] = 1;
}
for (lx = 1; lx <= l+2; lx++) {
for (n = 0; n < SIMDD; n++) {
        fx0[lx*SIMDD+n] = fx0[(lx-1)*SIMDD+n] * gridx[i+n];
        fy0[lx*SIMDD+n] = fy0[(lx-1)*SIMDD+n] * gridy[i+n];
        fz0[lx*SIMDD+n] = fz0[(lx-1)*SIMDD+n] * gridz[i+n];
} }
GTO_R_I(1, 0, l+0);
GTO_D_I(2, 0, l+1);
GTO_R_I(3, 2, l+0);
for (lx = l, l1 = 0; lx >= 0; lx--) {
        for (ly = l - lx; ly >= 0; ly--, l1++) {
                lz = l - lx - ly;
                for (n = 0; n < SIMDD; n++) {
                       e = exps[k*BLKSIZE+i+n];
s[0*SIMDD+n] = e * fx3[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[1*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[2*SIMDD+n] = e * fx2[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[3*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[4*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy3[ly*SIMDD+n] * fz0[lz*SIMDD+n];
s[5*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy2[ly*SIMDD+n] * fz1[lz*SIMDD+n];
s[6*SIMDD+n] = e * fx1[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[7*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy1[ly*SIMDD+n] * fz2[lz*SIMDD+n];
s[8*SIMDD+n] = e * fx0[lx*SIMDD+n] * fy0[ly*SIMDD+n] * fz3[lz*SIMDD+n];
                }
                for (n = 0; n < SIMDD; n++) {
buf[0*SIMDD+n] = + s[0*SIMDD+n];
buf[1*SIMDD+n] = + s[1*SIMDD+n];
buf[2*SIMDD+n] = + s[2*SIMDD+n];
buf[3*SIMDD+n] = + s[3*SIMDD+n];
buf[4*SIMDD+n] = + s[4*SIMDD+n];
buf[5*SIMDD+n] = + s[5*SIMDD+n];
buf[6*SIMDD+n] = + s[6*SIMDD+n];
buf[7*SIMDD+n] = + s[7*SIMDD+n];
buf[8*SIMDD+n] = + s[8*SIMDD+n];
                }
                for (j = 0, j1 = l1; j < nc; j++, j1+=degen) {
                for (n = 0; n < bgrids-i; n++) {
gto0[j1*ngrids+i+n] += buf[0*SIMDD+n] * coeff[j*np+k];
gto1[j1*ngrids+i+n] += buf[1*SIMDD+n] * coeff[j*np+k];
gto2[j1*ngrids+i+n] += buf[2*SIMDD+n] * coeff[j*np+k];
gto3[j1*ngrids+i+n] += buf[3*SIMDD+n] * coeff[j*np+k];
gto4[j1*ngrids+i+n] += buf[4*SIMDD+n] * coeff[j*np+k];
gto5[j1*ngrids+i+n] += buf[5*SIMDD+n] * coeff[j*np+k];
gto6[j1*ngrids+i+n] += buf[6*SIMDD+n] * coeff[j*np+k];
gto7[j1*ngrids+i+n] += buf[7*SIMDD+n] * coeff[j*np+k];
gto8[j1*ngrids+i+n] += buf[8*SIMDD+n] * coeff[j*np+k];
} } } } } } }
}
void GTOval_ipr_cart(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_cart_drv(shell_eval_GTOval_ipr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipr_sph(int ngrids, int *shls_slice, int *ao_loc,
double *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_sph_drv(shell_eval_GTOval_ipr, GTOprim_exp, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table,
atm, natm, bas, nbas, env);
}
void GTOval_ipr_spinor(int ngrids, int *shls_slice, int *ao_loc,
double complex *ao, double *coord, uint8_t *non0table,
int *atm, int natm, int *bas, int nbas, double *env)
{
int param[] = {1, 9};
GTOeval_spinor_drv(shell_eval_GTOval_ipr, GTOprim_exp, CINTc2s_ket_spinor_sf1, 1,
ngrids, param, shls_slice, ao_loc, ao, coord, non0table, atm, natm, bas, nbas, env);
}
