/*
 * Copyright (C) 2013-  Qiming Sun <osirpt.sun@gmail.com>
 * Description: code generated by  gen-code.cl
 */
#include <stdlib.h>
#include <stdio.h>
#include "cint_bas.h"
#include "cart2sph.h"
#include "g1e.h"
#include "g1e_grids.h"
#include "g2e.h"
#include "optimizer.h"
#include "cint1e.h"
#include "cint2e.h"
#include "misc.h"
#include "c2f.h"
/* <i|OVLP |P DOT P j> */
void CINTgout1e_int1e_kin(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double s[9];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*1+0] = - s[0] - s[4] - s[8];
} else {
gout[n*1+0] += - s[0] - s[4] - s[8];
}}}
void int1e_kin_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_kin_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_kin;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_kin_cart
CACHE_SIZE_T int1e_kin_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_kin;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_kin_sph
CACHE_SIZE_T int1e_kin_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_kin;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_kin_spinor
ALL_CINT1E(int1e_kin)
ALL_CINT1E_FORTRAN_(int1e_kin)
/* <RI DOT RI i|OVLP |j> */
void CINTgout1e_int1e_rrovlp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[9];
G1E_RCI(g1, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + s[4] + s[8];
} else {
gout[n*1+0] += + s[0] + s[4] + s[8];
}}}
void int1e_rrovlp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrovlp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrovlp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrovlp_cart
CACHE_SIZE_T int1e_rrovlp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrovlp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrovlp_sph
CACHE_SIZE_T int1e_rrovlp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrovlp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrovlp_spinor
ALL_CINT1E(int1e_rrovlp)
ALL_CINT1E_FORTRAN_(int1e_rrovlp)
/* <RI DOT RI i|NUC |j> */
void CINTgout1e_int1e_rrnuc(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
G2E_RCI(g1, g0, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*1+0] = + s[0] + s[4] + s[8];
} else {
gout[n*1+0] += + s[0] + s[4] + s[8];
}}}
void int1e_rrnuc_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrnuc_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrnuc;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 2);
} // int1e_rrnuc_cart
CACHE_SIZE_T int1e_rrnuc_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrnuc;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 2);
} // int1e_rrnuc_sph
CACHE_SIZE_T int1e_rrnuc_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrnuc;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 2);
} // int1e_rrnuc_spinor
ALL_CINT1E(int1e_rrnuc)
ALL_CINT1E_FORTRAN_(int1e_rrnuc)
/* <RI DOT RI i|RINV |j> */
void CINTgout1e_int1e_rrrinv(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
G2E_RCI(g1, g0, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*1+0] = + s[0] + s[4] + s[8];
} else {
gout[n*1+0] += + s[0] + s[4] + s[8];
}}}
void int1e_rrrinv_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrinv_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrinv;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_rrrinv_cart
CACHE_SIZE_T int1e_rrrinv_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrinv;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_rrrinv_sph
CACHE_SIZE_T int1e_rrrinv_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 0, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrinv;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_rrrinv_spinor
ALL_CINT1E(int1e_rrrinv)
ALL_CINT1E_FORTRAN_(int1e_rrrinv)
/* <RI DOT RI i|OVLP |P DOT P j> */
void CINTgout1e_int1e_rrkin(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCI(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*1+0] = - s[0] - s[36] - s[72] - s[4] - s[40] - s[76] - s[8] - s[44] - s[80];
} else {
gout[n*1+0] += - s[0] - s[36] - s[72] - s[4] - s[40] - s[76] - s[8] - s[44] - s[80];
}}}
void int1e_rrkin_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrkin_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrkin;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrkin_cart
CACHE_SIZE_T int1e_rrkin_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrkin;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrkin_sph
CACHE_SIZE_T int1e_rrkin_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrkin;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrkin_spinor
ALL_CINT1E(int1e_rrkin)
ALL_CINT1E_FORTRAN_(int1e_rrkin)
/* <RI DOT RI i|R0 |j> */
void CINTgout1e_int1e_rrr0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[27];
G1E_R0J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCI(g2, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g3, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[0] + s[12] + s[24];
gout[n*3+1] = + s[1] + s[13] + s[25];
gout[n*3+2] = + s[2] + s[14] + s[26];
} else {
gout[n*3+0] += + s[0] + s[12] + s[24];
gout[n*3+1] += + s[1] + s[13] + s[25];
gout[n*3+2] += + s[2] + s[14] + s[26];
}}}
void int1e_rrr0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrr0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrr0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrr0_cart
CACHE_SIZE_T int1e_rrr0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrr0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrr0_sph
CACHE_SIZE_T int1e_rrr0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrr0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrr0_spinor
ALL_CINT1E(int1e_rrr0)
ALL_CINT1E_FORTRAN_(int1e_rrr0)
/* <RI DOT RI RI DOT RI i|OVLP |j> */
void CINTgout1e_int1e_rrrrovlp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[81];
G1E_RCI(g1, g0, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g2, g0, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g3, g1, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
}}}
void int1e_rrrrovlp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrrovlp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrovlp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrrrovlp_cart
CACHE_SIZE_T int1e_rrrrovlp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrovlp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrrrovlp_sph
CACHE_SIZE_T int1e_rrrrovlp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrovlp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrrrovlp_spinor
ALL_CINT1E(int1e_rrrrovlp)
ALL_CINT1E_FORTRAN_(int1e_rrrrovlp)
/* <RI DOT RI RI DOT RI i|NUC |j> */
void CINTgout1e_int1e_rrrrnuc(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
G2E_RCI(g1, g0, envs->i_l+3, envs->j_l, 0, 0);
G2E_RCI(g2, g0, envs->i_l+2, envs->j_l, 0, 0);
G2E_RCI(g3, g1, envs->i_l+2, envs->j_l, 0, 0);
G2E_RCI(g4, g0, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g5, g1, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g6, g2, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g7, g3, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g8, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g9, g1, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g10, g2, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g11, g3, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g12, g4, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g13, g5, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g14, g6, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g15, g7, envs->i_l+0, envs->j_l, 0, 0);
double s[81];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 81; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g15[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g14[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g14[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g13[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g12[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g12[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g13[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g12[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g12[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g11[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g10[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g10[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g9[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g8[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g8[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g9[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g8[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g8[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g11[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g10[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g10[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g9[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g8[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g8[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g9[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g8[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g8[ix+i] * g0[iy+i] * g7[iz+i];
s[27] += g7[ix+i] * g8[iy+i] * g0[iz+i];
s[28] += g6[ix+i] * g9[iy+i] * g0[iz+i];
s[29] += g6[ix+i] * g8[iy+i] * g1[iz+i];
s[30] += g5[ix+i] * g10[iy+i] * g0[iz+i];
s[31] += g4[ix+i] * g11[iy+i] * g0[iz+i];
s[32] += g4[ix+i] * g10[iy+i] * g1[iz+i];
s[33] += g5[ix+i] * g8[iy+i] * g2[iz+i];
s[34] += g4[ix+i] * g9[iy+i] * g2[iz+i];
s[35] += g4[ix+i] * g8[iy+i] * g3[iz+i];
s[36] += g3[ix+i] * g12[iy+i] * g0[iz+i];
s[37] += g2[ix+i] * g13[iy+i] * g0[iz+i];
s[38] += g2[ix+i] * g12[iy+i] * g1[iz+i];
s[39] += g1[ix+i] * g14[iy+i] * g0[iz+i];
s[40] += g0[ix+i] * g15[iy+i] * g0[iz+i];
s[41] += g0[ix+i] * g14[iy+i] * g1[iz+i];
s[42] += g1[ix+i] * g12[iy+i] * g2[iz+i];
s[43] += g0[ix+i] * g13[iy+i] * g2[iz+i];
s[44] += g0[ix+i] * g12[iy+i] * g3[iz+i];
s[45] += g3[ix+i] * g8[iy+i] * g4[iz+i];
s[46] += g2[ix+i] * g9[iy+i] * g4[iz+i];
s[47] += g2[ix+i] * g8[iy+i] * g5[iz+i];
s[48] += g1[ix+i] * g10[iy+i] * g4[iz+i];
s[49] += g0[ix+i] * g11[iy+i] * g4[iz+i];
s[50] += g0[ix+i] * g10[iy+i] * g5[iz+i];
s[51] += g1[ix+i] * g8[iy+i] * g6[iz+i];
s[52] += g0[ix+i] * g9[iy+i] * g6[iz+i];
s[53] += g0[ix+i] * g8[iy+i] * g7[iz+i];
s[54] += g7[ix+i] * g0[iy+i] * g8[iz+i];
s[55] += g6[ix+i] * g1[iy+i] * g8[iz+i];
s[56] += g6[ix+i] * g0[iy+i] * g9[iz+i];
s[57] += g5[ix+i] * g2[iy+i] * g8[iz+i];
s[58] += g4[ix+i] * g3[iy+i] * g8[iz+i];
s[59] += g4[ix+i] * g2[iy+i] * g9[iz+i];
s[60] += g5[ix+i] * g0[iy+i] * g10[iz+i];
s[61] += g4[ix+i] * g1[iy+i] * g10[iz+i];
s[62] += g4[ix+i] * g0[iy+i] * g11[iz+i];
s[63] += g3[ix+i] * g4[iy+i] * g8[iz+i];
s[64] += g2[ix+i] * g5[iy+i] * g8[iz+i];
s[65] += g2[ix+i] * g4[iy+i] * g9[iz+i];
s[66] += g1[ix+i] * g6[iy+i] * g8[iz+i];
s[67] += g0[ix+i] * g7[iy+i] * g8[iz+i];
s[68] += g0[ix+i] * g6[iy+i] * g9[iz+i];
s[69] += g1[ix+i] * g4[iy+i] * g10[iz+i];
s[70] += g0[ix+i] * g5[iy+i] * g10[iz+i];
s[71] += g0[ix+i] * g4[iy+i] * g11[iz+i];
s[72] += g3[ix+i] * g0[iy+i] * g12[iz+i];
s[73] += g2[ix+i] * g1[iy+i] * g12[iz+i];
s[74] += g2[ix+i] * g0[iy+i] * g13[iz+i];
s[75] += g1[ix+i] * g2[iy+i] * g12[iz+i];
s[76] += g0[ix+i] * g3[iy+i] * g12[iz+i];
s[77] += g0[ix+i] * g2[iy+i] * g13[iz+i];
s[78] += g1[ix+i] * g0[iy+i] * g14[iz+i];
s[79] += g0[ix+i] * g1[iy+i] * g14[iz+i];
s[80] += g0[ix+i] * g0[iy+i] * g15[iz+i];
}
if (gout_empty) {
gout[n*1+0] = + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
}}}
void int1e_rrrrnuc_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrrnuc_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrnuc;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 2);
} // int1e_rrrrnuc_cart
CACHE_SIZE_T int1e_rrrrnuc_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrnuc;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 2);
} // int1e_rrrrnuc_sph
CACHE_SIZE_T int1e_rrrrnuc_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrnuc;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 2);
} // int1e_rrrrnuc_spinor
ALL_CINT1E(int1e_rrrrnuc)
ALL_CINT1E_FORTRAN_(int1e_rrrrnuc)
/* <RI DOT RI RI DOT RI i|RINV |j> */
void CINTgout1e_int1e_rrrrrinv(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
G2E_RCI(g1, g0, envs->i_l+3, envs->j_l, 0, 0);
G2E_RCI(g2, g0, envs->i_l+2, envs->j_l, 0, 0);
G2E_RCI(g3, g1, envs->i_l+2, envs->j_l, 0, 0);
G2E_RCI(g4, g0, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g5, g1, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g6, g2, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g7, g3, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g8, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g9, g1, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g10, g2, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g11, g3, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g12, g4, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g13, g5, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g14, g6, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g15, g7, envs->i_l+0, envs->j_l, 0, 0);
double s[81];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 81; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g15[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g14[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g14[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g13[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g12[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g12[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g13[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g12[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g12[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g11[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g10[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g10[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g9[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g8[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g8[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g9[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g8[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g8[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g11[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g10[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g10[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g9[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g8[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g8[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g9[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g8[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g8[ix+i] * g0[iy+i] * g7[iz+i];
s[27] += g7[ix+i] * g8[iy+i] * g0[iz+i];
s[28] += g6[ix+i] * g9[iy+i] * g0[iz+i];
s[29] += g6[ix+i] * g8[iy+i] * g1[iz+i];
s[30] += g5[ix+i] * g10[iy+i] * g0[iz+i];
s[31] += g4[ix+i] * g11[iy+i] * g0[iz+i];
s[32] += g4[ix+i] * g10[iy+i] * g1[iz+i];
s[33] += g5[ix+i] * g8[iy+i] * g2[iz+i];
s[34] += g4[ix+i] * g9[iy+i] * g2[iz+i];
s[35] += g4[ix+i] * g8[iy+i] * g3[iz+i];
s[36] += g3[ix+i] * g12[iy+i] * g0[iz+i];
s[37] += g2[ix+i] * g13[iy+i] * g0[iz+i];
s[38] += g2[ix+i] * g12[iy+i] * g1[iz+i];
s[39] += g1[ix+i] * g14[iy+i] * g0[iz+i];
s[40] += g0[ix+i] * g15[iy+i] * g0[iz+i];
s[41] += g0[ix+i] * g14[iy+i] * g1[iz+i];
s[42] += g1[ix+i] * g12[iy+i] * g2[iz+i];
s[43] += g0[ix+i] * g13[iy+i] * g2[iz+i];
s[44] += g0[ix+i] * g12[iy+i] * g3[iz+i];
s[45] += g3[ix+i] * g8[iy+i] * g4[iz+i];
s[46] += g2[ix+i] * g9[iy+i] * g4[iz+i];
s[47] += g2[ix+i] * g8[iy+i] * g5[iz+i];
s[48] += g1[ix+i] * g10[iy+i] * g4[iz+i];
s[49] += g0[ix+i] * g11[iy+i] * g4[iz+i];
s[50] += g0[ix+i] * g10[iy+i] * g5[iz+i];
s[51] += g1[ix+i] * g8[iy+i] * g6[iz+i];
s[52] += g0[ix+i] * g9[iy+i] * g6[iz+i];
s[53] += g0[ix+i] * g8[iy+i] * g7[iz+i];
s[54] += g7[ix+i] * g0[iy+i] * g8[iz+i];
s[55] += g6[ix+i] * g1[iy+i] * g8[iz+i];
s[56] += g6[ix+i] * g0[iy+i] * g9[iz+i];
s[57] += g5[ix+i] * g2[iy+i] * g8[iz+i];
s[58] += g4[ix+i] * g3[iy+i] * g8[iz+i];
s[59] += g4[ix+i] * g2[iy+i] * g9[iz+i];
s[60] += g5[ix+i] * g0[iy+i] * g10[iz+i];
s[61] += g4[ix+i] * g1[iy+i] * g10[iz+i];
s[62] += g4[ix+i] * g0[iy+i] * g11[iz+i];
s[63] += g3[ix+i] * g4[iy+i] * g8[iz+i];
s[64] += g2[ix+i] * g5[iy+i] * g8[iz+i];
s[65] += g2[ix+i] * g4[iy+i] * g9[iz+i];
s[66] += g1[ix+i] * g6[iy+i] * g8[iz+i];
s[67] += g0[ix+i] * g7[iy+i] * g8[iz+i];
s[68] += g0[ix+i] * g6[iy+i] * g9[iz+i];
s[69] += g1[ix+i] * g4[iy+i] * g10[iz+i];
s[70] += g0[ix+i] * g5[iy+i] * g10[iz+i];
s[71] += g0[ix+i] * g4[iy+i] * g11[iz+i];
s[72] += g3[ix+i] * g0[iy+i] * g12[iz+i];
s[73] += g2[ix+i] * g1[iy+i] * g12[iz+i];
s[74] += g2[ix+i] * g0[iy+i] * g13[iz+i];
s[75] += g1[ix+i] * g2[iy+i] * g12[iz+i];
s[76] += g0[ix+i] * g3[iy+i] * g12[iz+i];
s[77] += g0[ix+i] * g2[iy+i] * g13[iz+i];
s[78] += g1[ix+i] * g0[iy+i] * g14[iz+i];
s[79] += g0[ix+i] * g1[iy+i] * g14[iz+i];
s[80] += g0[ix+i] * g0[iy+i] * g15[iz+i];
}
if (gout_empty) {
gout[n*1+0] = + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
}}}
void int1e_rrrrrinv_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrrrinv_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrrinv;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_rrrrrinv_cart
CACHE_SIZE_T int1e_rrrrrinv_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrrinv;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_rrrrrinv_sph
CACHE_SIZE_T int1e_rrrrrinv_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 0, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrrinv;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_rrrrrinv_spinor
ALL_CINT1E(int1e_rrrrrinv)
ALL_CINT1E_FORTRAN_(int1e_rrrrrinv)
/* <RI DOT RI RI DOT RI i|OVLP |P DOT P j> */
void CINTgout1e_int1e_rrrrkin(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+4, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+4, envs->j_l+0, 0);
G1E_RCI(g4, g0, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g5, g1, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g6, g2, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g7, g3, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*1+0] = - s[0] -2*s[36] -2*s[72] - s[360] -2*s[396] - s[720] - s[4] -2*s[40] -2*s[76] - s[364] -2*s[400] - s[724] - s[8] -2*s[44] -2*s[80] - s[368] -2*s[404] - s[728];
} else {
gout[n*1+0] += - s[0] -2*s[36] -2*s[72] - s[360] -2*s[396] - s[720] - s[4] -2*s[40] -2*s[76] - s[364] -2*s[400] - s[724] - s[8] -2*s[44] -2*s[80] - s[368] -2*s[404] - s[728];
}}}
void int1e_rrrrkin_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrrkin_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrkin;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrrrkin_cart
CACHE_SIZE_T int1e_rrrrkin_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrkin;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrrrkin_sph
CACHE_SIZE_T int1e_rrrrkin_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrkin;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrrrkin_spinor
ALL_CINT1E(int1e_rrrrkin)
ALL_CINT1E_FORTRAN_(int1e_rrrrkin)
/* <RI DOT RI RI DOT RI i|R0 |j> */
void CINTgout1e_int1e_rrrrr0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[243];
G1E_R0J(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_RCI(g2, g0, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g3, g1, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g4, g0, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g5, g1, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g6, g2, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g7, g3, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[0] + 2*s[12] + 2*s[24] + s[120] + 2*s[132] + s[240];
gout[n*3+1] = + s[1] + 2*s[13] + 2*s[25] + s[121] + 2*s[133] + s[241];
gout[n*3+2] = + s[2] + 2*s[14] + 2*s[26] + s[122] + 2*s[134] + s[242];
} else {
gout[n*3+0] += + s[0] + 2*s[12] + 2*s[24] + s[120] + 2*s[132] + s[240];
gout[n*3+1] += + s[1] + 2*s[13] + 2*s[25] + s[121] + 2*s[133] + s[241];
gout[n*3+2] += + s[2] + 2*s[14] + 2*s[26] + s[122] + 2*s[134] + s[242];
}}}
void int1e_rrrrr0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrrr0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrr0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrrrr0_cart
CACHE_SIZE_T int1e_rrrrr0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrr0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrrrr0_sph
CACHE_SIZE_T int1e_rrrrr0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrr0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrrrr0_spinor
ALL_CINT1E(int1e_rrrrr0)
ALL_CINT1E_FORTRAN_(int1e_rrrrr0)
/* <RI DOT RI i|OVLP |RJ DOT RJ j> */
void CINTgout1e_int1e_rrovlprr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCI(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + s[36] + s[72] + s[4] + s[40] + s[76] + s[8] + s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + s[36] + s[72] + s[4] + s[40] + s[76] + s[8] + s[44] + s[80];
}}}
void int1e_rrovlprr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrovlprr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrovlprr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrovlprr_cart
CACHE_SIZE_T int1e_rrovlprr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrovlprr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrovlprr_sph
CACHE_SIZE_T int1e_rrovlprr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrovlprr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrovlprr_spinor
ALL_CINT1E(int1e_rrovlprr)
ALL_CINT1E_FORTRAN_(int1e_rrovlprr)
/* <RI DOT RI i|NUC |RJ DOT RJ j> */
void CINTgout1e_int1e_rrnucrr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
G2E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0, 0);
G2E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0, 0);
G2E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0, 0);
G2E_RCI(g4, g0, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g5, g1, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g6, g2, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g7, g3, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g8, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g9, g1, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g10, g2, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g11, g3, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g12, g4, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g13, g5, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g14, g6, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g15, g7, envs->i_l+0, envs->j_l, 0, 0);
double s[81];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 81; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g15[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g14[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g14[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g13[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g12[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g12[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g13[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g12[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g12[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g11[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g10[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g10[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g9[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g8[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g8[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g9[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g8[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g8[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g11[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g10[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g10[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g9[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g8[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g8[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g9[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g8[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g8[ix+i] * g0[iy+i] * g7[iz+i];
s[27] += g7[ix+i] * g8[iy+i] * g0[iz+i];
s[28] += g6[ix+i] * g9[iy+i] * g0[iz+i];
s[29] += g6[ix+i] * g8[iy+i] * g1[iz+i];
s[30] += g5[ix+i] * g10[iy+i] * g0[iz+i];
s[31] += g4[ix+i] * g11[iy+i] * g0[iz+i];
s[32] += g4[ix+i] * g10[iy+i] * g1[iz+i];
s[33] += g5[ix+i] * g8[iy+i] * g2[iz+i];
s[34] += g4[ix+i] * g9[iy+i] * g2[iz+i];
s[35] += g4[ix+i] * g8[iy+i] * g3[iz+i];
s[36] += g3[ix+i] * g12[iy+i] * g0[iz+i];
s[37] += g2[ix+i] * g13[iy+i] * g0[iz+i];
s[38] += g2[ix+i] * g12[iy+i] * g1[iz+i];
s[39] += g1[ix+i] * g14[iy+i] * g0[iz+i];
s[40] += g0[ix+i] * g15[iy+i] * g0[iz+i];
s[41] += g0[ix+i] * g14[iy+i] * g1[iz+i];
s[42] += g1[ix+i] * g12[iy+i] * g2[iz+i];
s[43] += g0[ix+i] * g13[iy+i] * g2[iz+i];
s[44] += g0[ix+i] * g12[iy+i] * g3[iz+i];
s[45] += g3[ix+i] * g8[iy+i] * g4[iz+i];
s[46] += g2[ix+i] * g9[iy+i] * g4[iz+i];
s[47] += g2[ix+i] * g8[iy+i] * g5[iz+i];
s[48] += g1[ix+i] * g10[iy+i] * g4[iz+i];
s[49] += g0[ix+i] * g11[iy+i] * g4[iz+i];
s[50] += g0[ix+i] * g10[iy+i] * g5[iz+i];
s[51] += g1[ix+i] * g8[iy+i] * g6[iz+i];
s[52] += g0[ix+i] * g9[iy+i] * g6[iz+i];
s[53] += g0[ix+i] * g8[iy+i] * g7[iz+i];
s[54] += g7[ix+i] * g0[iy+i] * g8[iz+i];
s[55] += g6[ix+i] * g1[iy+i] * g8[iz+i];
s[56] += g6[ix+i] * g0[iy+i] * g9[iz+i];
s[57] += g5[ix+i] * g2[iy+i] * g8[iz+i];
s[58] += g4[ix+i] * g3[iy+i] * g8[iz+i];
s[59] += g4[ix+i] * g2[iy+i] * g9[iz+i];
s[60] += g5[ix+i] * g0[iy+i] * g10[iz+i];
s[61] += g4[ix+i] * g1[iy+i] * g10[iz+i];
s[62] += g4[ix+i] * g0[iy+i] * g11[iz+i];
s[63] += g3[ix+i] * g4[iy+i] * g8[iz+i];
s[64] += g2[ix+i] * g5[iy+i] * g8[iz+i];
s[65] += g2[ix+i] * g4[iy+i] * g9[iz+i];
s[66] += g1[ix+i] * g6[iy+i] * g8[iz+i];
s[67] += g0[ix+i] * g7[iy+i] * g8[iz+i];
s[68] += g0[ix+i] * g6[iy+i] * g9[iz+i];
s[69] += g1[ix+i] * g4[iy+i] * g10[iz+i];
s[70] += g0[ix+i] * g5[iy+i] * g10[iz+i];
s[71] += g0[ix+i] * g4[iy+i] * g11[iz+i];
s[72] += g3[ix+i] * g0[iy+i] * g12[iz+i];
s[73] += g2[ix+i] * g1[iy+i] * g12[iz+i];
s[74] += g2[ix+i] * g0[iy+i] * g13[iz+i];
s[75] += g1[ix+i] * g2[iy+i] * g12[iz+i];
s[76] += g0[ix+i] * g3[iy+i] * g12[iz+i];
s[77] += g0[ix+i] * g2[iy+i] * g13[iz+i];
s[78] += g1[ix+i] * g0[iy+i] * g14[iz+i];
s[79] += g0[ix+i] * g1[iy+i] * g14[iz+i];
s[80] += g0[ix+i] * g0[iy+i] * g15[iz+i];
}
if (gout_empty) {
gout[n*1+0] = + s[0] + s[36] + s[72] + s[4] + s[40] + s[76] + s[8] + s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + s[36] + s[72] + s[4] + s[40] + s[76] + s[8] + s[44] + s[80];
}}}
void int1e_rrnucrr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrnucrr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrnucrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 2);
} // int1e_rrnucrr_cart
CACHE_SIZE_T int1e_rrnucrr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrnucrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 2);
} // int1e_rrnucrr_sph
CACHE_SIZE_T int1e_rrnucrr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrnucrr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 2);
} // int1e_rrnucrr_spinor
ALL_CINT1E(int1e_rrnucrr)
ALL_CINT1E_FORTRAN_(int1e_rrnucrr)
/* <RI DOT RI i|RINV |RJ DOT RJ j> */
void CINTgout1e_int1e_rrrinvrr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
G2E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0, 0);
G2E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0, 0);
G2E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0, 0);
G2E_RCI(g4, g0, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g5, g1, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g6, g2, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g7, g3, envs->i_l+1, envs->j_l, 0, 0);
G2E_RCI(g8, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g9, g1, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g10, g2, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g11, g3, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g12, g4, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g13, g5, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g14, g6, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g15, g7, envs->i_l+0, envs->j_l, 0, 0);
double s[81];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 81; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g15[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g14[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g14[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g13[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g12[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g12[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g13[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g12[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g12[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g11[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g10[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g10[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g9[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g8[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g8[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g9[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g8[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g8[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g11[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g10[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g10[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g9[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g8[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g8[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g9[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g8[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g8[ix+i] * g0[iy+i] * g7[iz+i];
s[27] += g7[ix+i] * g8[iy+i] * g0[iz+i];
s[28] += g6[ix+i] * g9[iy+i] * g0[iz+i];
s[29] += g6[ix+i] * g8[iy+i] * g1[iz+i];
s[30] += g5[ix+i] * g10[iy+i] * g0[iz+i];
s[31] += g4[ix+i] * g11[iy+i] * g0[iz+i];
s[32] += g4[ix+i] * g10[iy+i] * g1[iz+i];
s[33] += g5[ix+i] * g8[iy+i] * g2[iz+i];
s[34] += g4[ix+i] * g9[iy+i] * g2[iz+i];
s[35] += g4[ix+i] * g8[iy+i] * g3[iz+i];
s[36] += g3[ix+i] * g12[iy+i] * g0[iz+i];
s[37] += g2[ix+i] * g13[iy+i] * g0[iz+i];
s[38] += g2[ix+i] * g12[iy+i] * g1[iz+i];
s[39] += g1[ix+i] * g14[iy+i] * g0[iz+i];
s[40] += g0[ix+i] * g15[iy+i] * g0[iz+i];
s[41] += g0[ix+i] * g14[iy+i] * g1[iz+i];
s[42] += g1[ix+i] * g12[iy+i] * g2[iz+i];
s[43] += g0[ix+i] * g13[iy+i] * g2[iz+i];
s[44] += g0[ix+i] * g12[iy+i] * g3[iz+i];
s[45] += g3[ix+i] * g8[iy+i] * g4[iz+i];
s[46] += g2[ix+i] * g9[iy+i] * g4[iz+i];
s[47] += g2[ix+i] * g8[iy+i] * g5[iz+i];
s[48] += g1[ix+i] * g10[iy+i] * g4[iz+i];
s[49] += g0[ix+i] * g11[iy+i] * g4[iz+i];
s[50] += g0[ix+i] * g10[iy+i] * g5[iz+i];
s[51] += g1[ix+i] * g8[iy+i] * g6[iz+i];
s[52] += g0[ix+i] * g9[iy+i] * g6[iz+i];
s[53] += g0[ix+i] * g8[iy+i] * g7[iz+i];
s[54] += g7[ix+i] * g0[iy+i] * g8[iz+i];
s[55] += g6[ix+i] * g1[iy+i] * g8[iz+i];
s[56] += g6[ix+i] * g0[iy+i] * g9[iz+i];
s[57] += g5[ix+i] * g2[iy+i] * g8[iz+i];
s[58] += g4[ix+i] * g3[iy+i] * g8[iz+i];
s[59] += g4[ix+i] * g2[iy+i] * g9[iz+i];
s[60] += g5[ix+i] * g0[iy+i] * g10[iz+i];
s[61] += g4[ix+i] * g1[iy+i] * g10[iz+i];
s[62] += g4[ix+i] * g0[iy+i] * g11[iz+i];
s[63] += g3[ix+i] * g4[iy+i] * g8[iz+i];
s[64] += g2[ix+i] * g5[iy+i] * g8[iz+i];
s[65] += g2[ix+i] * g4[iy+i] * g9[iz+i];
s[66] += g1[ix+i] * g6[iy+i] * g8[iz+i];
s[67] += g0[ix+i] * g7[iy+i] * g8[iz+i];
s[68] += g0[ix+i] * g6[iy+i] * g9[iz+i];
s[69] += g1[ix+i] * g4[iy+i] * g10[iz+i];
s[70] += g0[ix+i] * g5[iy+i] * g10[iz+i];
s[71] += g0[ix+i] * g4[iy+i] * g11[iz+i];
s[72] += g3[ix+i] * g0[iy+i] * g12[iz+i];
s[73] += g2[ix+i] * g1[iy+i] * g12[iz+i];
s[74] += g2[ix+i] * g0[iy+i] * g13[iz+i];
s[75] += g1[ix+i] * g2[iy+i] * g12[iz+i];
s[76] += g0[ix+i] * g3[iy+i] * g12[iz+i];
s[77] += g0[ix+i] * g2[iy+i] * g13[iz+i];
s[78] += g1[ix+i] * g0[iy+i] * g14[iz+i];
s[79] += g0[ix+i] * g1[iy+i] * g14[iz+i];
s[80] += g0[ix+i] * g0[iy+i] * g15[iz+i];
}
if (gout_empty) {
gout[n*1+0] = + s[0] + s[36] + s[72] + s[4] + s[40] + s[76] + s[8] + s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + s[36] + s[72] + s[4] + s[40] + s[76] + s[8] + s[44] + s[80];
}}}
void int1e_rrrinvrr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrinvrr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrinvrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_rrrinvrr_cart
CACHE_SIZE_T int1e_rrrinvrr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrinvrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_rrrinvrr_sph
CACHE_SIZE_T int1e_rrrinvrr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrinvrr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_rrrinvrr_spinor
ALL_CINT1E(int1e_rrrinvrr)
ALL_CINT1E_FORTRAN_(int1e_rrrinvrr)
/* <RI DOT RI i|OVLP |P DOT P RJ DOT RJ j> */
void CINTgout1e_int1e_rrkinrr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g8, g0, envs->i_l+2, envs->j_l+3, 0);
G1E_RCJ(g9, g8, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g11, g10, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g13, g12, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g15, g14, envs->i_l+2, envs->j_l+0, 0);
G1E_RCI(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*1+0] = - s[0] - s[324] - s[648] - s[36] - s[360] - s[684] - s[72] - s[396] - s[720] - s[4] - s[328] - s[652] - s[40] - s[364] - s[688] - s[76] - s[400] - s[724] - s[8] - s[332] - s[656] - s[44] - s[368] - s[692] - s[80] - s[404] - s[728];
} else {
gout[n*1+0] += - s[0] - s[324] - s[648] - s[36] - s[360] - s[684] - s[72] - s[396] - s[720] - s[4] - s[328] - s[652] - s[40] - s[364] - s[688] - s[76] - s[400] - s[724] - s[8] - s[332] - s[656] - s[44] - s[368] - s[692] - s[80] - s[404] - s[728];
}}}
void int1e_rrkinrr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrkinrr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrkinrr;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrkinrr_cart
CACHE_SIZE_T int1e_rrkinrr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrkinrr;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrkinrr_sph
CACHE_SIZE_T int1e_rrkinrr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrkinrr;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrkinrr_spinor
ALL_CINT1E(int1e_rrkinrr)
ALL_CINT1E_FORTRAN_(int1e_rrkinrr)
/* <RI DOT RI i|R0 |RJ DOT RJ j> */
void CINTgout1e_int1e_rrr0rr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_R0J(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_RCI(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[0] + s[108] + s[216] + s[4] + s[112] + s[220] + s[8] + s[116] + s[224];
gout[n*3+1] = + s[9] + s[117] + s[225] + s[13] + s[121] + s[229] + s[17] + s[125] + s[233];
gout[n*3+2] = + s[18] + s[126] + s[234] + s[22] + s[130] + s[238] + s[26] + s[134] + s[242];
} else {
gout[n*3+0] += + s[0] + s[108] + s[216] + s[4] + s[112] + s[220] + s[8] + s[116] + s[224];
gout[n*3+1] += + s[9] + s[117] + s[225] + s[13] + s[121] + s[229] + s[17] + s[125] + s[233];
gout[n*3+2] += + s[18] + s[126] + s[234] + s[22] + s[130] + s[238] + s[26] + s[134] + s[242];
}}}
void int1e_rrr0rr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrr0rr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrr0rr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrr0rr_cart
CACHE_SIZE_T int1e_rrr0rr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrr0rr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrr0rr_sph
CACHE_SIZE_T int1e_rrr0rr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrr0rr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrr0rr_spinor
ALL_CINT1E(int1e_rrr0rr)
ALL_CINT1E_FORTRAN_(int1e_rrr0rr)
/* <i|NABLA-RINV |CROSS P j> */
void CINTgout1e_int1e_ia01p(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
G2E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0, 0);
G2E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0, 0);
G2E_D_I(g3, g0, envs->i_l+0, envs->j_l+1, 0, 0);
for (ix = 0; ix < envs->g_size * 3; ix++) {g2[ix] += g3[ix];}
G2E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*3+0] = + s[5] - s[7];
gout[n*3+1] = + s[6] - s[2];
gout[n*3+2] = + s[1] - s[3];
} else {
gout[n*3+0] += + s[5] - s[7];
gout[n*3+1] += + s[6] - s[2];
gout[n*3+2] += + s[1] - s[3];
}}}
void int1e_ia01p_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ia01p_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ia01p;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_ia01p_cart
CACHE_SIZE_T int1e_ia01p_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ia01p;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_ia01p_sph
CACHE_SIZE_T int1e_ia01p_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ia01p;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_ia01p_spinor
ALL_CINT1E(int1e_ia01p)
ALL_CINT1E_FORTRAN_(int1e_ia01p)
/* <i|OVLP |R CROSS P j> */
void CINTgout1e_int1e_giao_irjxp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double s[9];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[5] - s[7];
gout[n*3+1] = + s[6] - s[2];
gout[n*3+2] = + s[1] - s[3];
} else {
gout[n*3+0] += + s[5] - s[7];
gout[n*3+1] += + s[6] - s[2];
gout[n*3+2] += + s[1] - s[3];
}}}
void int1e_giao_irjxp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_giao_irjxp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_irjxp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_giao_irjxp_cart
CACHE_SIZE_T int1e_giao_irjxp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_irjxp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_giao_irjxp_sph
CACHE_SIZE_T int1e_giao_irjxp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_irjxp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_giao_irjxp_spinor
ALL_CINT1E(int1e_giao_irjxp)
ALL_CINT1E_FORTRAN_(int1e_giao_irjxp)
/* <i|OVLP |RC CROSS P j> */
void CINTgout1e_int1e_cg_irxp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[9];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[5] - s[7];
gout[n*3+1] = + s[6] - s[2];
gout[n*3+2] = + s[1] - s[3];
} else {
gout[n*3+0] += + s[5] - s[7];
gout[n*3+1] += + s[6] - s[2];
gout[n*3+2] += + s[1] - s[3];
}}}
void int1e_cg_irxp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_cg_irxp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_irxp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_cg_irxp_cart
CACHE_SIZE_T int1e_cg_irxp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_irxp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_cg_irxp_sph
CACHE_SIZE_T int1e_cg_irxp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_irxp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_cg_irxp_spinor
ALL_CINT1E(int1e_cg_irxp)
ALL_CINT1E_FORTRAN_(int1e_cg_irxp)
/* <i|NABLA-RINV |R j> */
void CINTgout1e_int1e_giao_a11part(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
G2E_R_J(g1, g0, envs->i_l+0, envs->j_l+0, 0, 0);
G2E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0, 0);
G2E_D_I(g3, g0, envs->i_l+0, envs->j_l+1, 0, 0);
for (ix = 0; ix < envs->g_size * 3; ix++) {g2[ix] += g3[ix];}
G2E_R_J(g3, g2, envs->i_l+0, envs->j_l+0, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_giao_a11part_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_giao_a11part_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_a11part;
envs.common_factor *= -0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_giao_a11part_cart
CACHE_SIZE_T int1e_giao_a11part_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_a11part;
envs.common_factor *= -0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_giao_a11part_sph
CACHE_SIZE_T int1e_giao_a11part_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_a11part;
envs.common_factor *= -0.5;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_giao_a11part_spinor
ALL_CINT1E(int1e_giao_a11part)
ALL_CINT1E_FORTRAN_(int1e_giao_a11part)
/* <i|NABLA-RINV |RC j> */
void CINTgout1e_int1e_cg_a11part(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
G2E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0, 0);
G2E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0, 0);
G2E_D_I(g3, g0, envs->i_l+0, envs->j_l+1, 0, 0);
for (ix = 0; ix < envs->g_size * 3; ix++) {g2[ix] += g3[ix];}
G2E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_cg_a11part_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_cg_a11part_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_a11part;
envs.common_factor *= -0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_cg_a11part_cart
CACHE_SIZE_T int1e_cg_a11part_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_a11part;
envs.common_factor *= -0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_cg_a11part_sph
CACHE_SIZE_T int1e_cg_a11part_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_a11part;
envs.common_factor *= -0.5;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_cg_a11part_spinor
ALL_CINT1E(int1e_cg_a11part)
ALL_CINT1E_FORTRAN_(int1e_cg_a11part)
/* <G i|NABLA-RINV CROSS P |j> */
void CINTgout1e_int1e_a01gp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
G2E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0, 0);
G2E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0, 0);
G2E_D_I(g3, g0, envs->i_l+1, envs->j_l+1, 0, 0);
for (ix = 0; ix < envs->g_size * 3; ix++) {g2[ix] += g3[ix];}
G2E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0, 0);
G2E_R0I(g4, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_R0I(g5, g1, envs->i_l+0, envs->j_l, 0, 0);
G2E_R0I(g6, g2, envs->i_l+0, envs->j_l, 0, 0);
G2E_R0I(g7, g3, envs->i_l+0, envs->j_l, 0, 0);
double s[27];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g7[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g6[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g6[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g5[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g4[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g4[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g5[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g4[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g4[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g3[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g2[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g2[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g1[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g0[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g0[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g1[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g0[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g0[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g3[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g2[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g2[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g1[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g0[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g0[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g1[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g0[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g0[ix+i] * g0[iy+i] * g7[iz+i];
}
if (gout_empty) {
gout[n*9+0] = + c[1]*s[23] - c[2]*s[14] - c[1]*s[25] + c[2]*s[16];
gout[n*9+1] = + c[1]*s[24] - c[2]*s[15] - c[1]*s[20] + c[2]*s[11];
gout[n*9+2] = + c[1]*s[19] - c[2]*s[10] - c[1]*s[21] + c[2]*s[12];
gout[n*9+3] = + c[2]*s[5] - c[0]*s[23] - c[2]*s[7] + c[0]*s[25];
gout[n*9+4] = + c[2]*s[6] - c[0]*s[24] - c[2]*s[2] + c[0]*s[20];
gout[n*9+5] = + c[2]*s[1] - c[0]*s[19] - c[2]*s[3] + c[0]*s[21];
gout[n*9+6] = + c[0]*s[14] - c[1]*s[5] - c[0]*s[16] + c[1]*s[7];
gout[n*9+7] = + c[0]*s[15] - c[1]*s[6] - c[0]*s[11] + c[1]*s[2];
gout[n*9+8] = + c[0]*s[10] - c[1]*s[1] - c[0]*s[12] + c[1]*s[3];
} else {
gout[n*9+0] += + c[1]*s[23] - c[2]*s[14] - c[1]*s[25] + c[2]*s[16];
gout[n*9+1] += + c[1]*s[24] - c[2]*s[15] - c[1]*s[20] + c[2]*s[11];
gout[n*9+2] += + c[1]*s[19] - c[2]*s[10] - c[1]*s[21] + c[2]*s[12];
gout[n*9+3] += + c[2]*s[5] - c[0]*s[23] - c[2]*s[7] + c[0]*s[25];
gout[n*9+4] += + c[2]*s[6] - c[0]*s[24] - c[2]*s[2] + c[0]*s[20];
gout[n*9+5] += + c[2]*s[1] - c[0]*s[19] - c[2]*s[3] + c[0]*s[21];
gout[n*9+6] += + c[0]*s[14] - c[1]*s[5] - c[0]*s[16] + c[1]*s[7];
gout[n*9+7] += + c[0]*s[15] - c[1]*s[6] - c[0]*s[11] + c[1]*s[2];
gout[n*9+8] += + c[0]*s[10] - c[1]*s[1] - c[0]*s[12] + c[1]*s[3];
}}}
void int1e_a01gp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 3, 1, 0, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_a01gp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 3, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_a01gp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = envs.nfi * envs.x_ctr[0];
counts[1] = envs.nfj * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_a01gp_cart
CACHE_SIZE_T int1e_a01gp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 3, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_a01gp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = (envs.i_l*2+1) * envs.x_ctr[0];
counts[1] = (envs.j_l*2+1) * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_a01gp_sph
CACHE_SIZE_T int1e_a01gp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 3, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_a01gp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = CINTcgto_spinor(envs.shls[0], envs.bas);
counts[1] = CINTcgto_spinor(envs.shls[1], envs.bas);
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_tensor; i++) {
c2s_zset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_a01gp_spinor
ALL_CINT1E(int1e_a01gp)
ALL_CINT1E_FORTRAN_(int1e_a01gp)
/* <G i|OVLP |P DOT P j> */
void CINTgout1e_int1e_igkin(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
double s[27];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_R0I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_R0I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_R0I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_R0I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*3+0] = + c[1]*s[18] - c[2]*s[9] + c[1]*s[22] - c[2]*s[13] + c[1]*s[26] - c[2]*s[17];
gout[n*3+1] = + c[2]*s[0] - c[0]*s[18] + c[2]*s[4] - c[0]*s[22] + c[2]*s[8] - c[0]*s[26];
gout[n*3+2] = + c[0]*s[9] - c[1]*s[0] + c[0]*s[13] - c[1]*s[4] + c[0]*s[17] - c[1]*s[8];
} else {
gout[n*3+0] += + c[1]*s[18] - c[2]*s[9] + c[1]*s[22] - c[2]*s[13] + c[1]*s[26] - c[2]*s[17];
gout[n*3+1] += + c[2]*s[0] - c[0]*s[18] + c[2]*s[4] - c[0]*s[22] + c[2]*s[8] - c[0]*s[26];
gout[n*3+2] += + c[0]*s[9] - c[1]*s[0] + c[0]*s[13] - c[1]*s[4] + c[0]*s[17] - c[1]*s[8];
}}}
void int1e_igkin_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_igkin_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_igkin;
envs.common_factor *= 0.25;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = envs.nfi * envs.x_ctr[0];
counts[1] = envs.nfj * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_igkin_cart
CACHE_SIZE_T int1e_igkin_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_igkin;
envs.common_factor *= 0.25;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = (envs.i_l*2+1) * envs.x_ctr[0];
counts[1] = (envs.j_l*2+1) * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_igkin_sph
CACHE_SIZE_T int1e_igkin_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_igkin;
envs.common_factor *= 0.25;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = CINTcgto_spinor(envs.shls[0], envs.bas);
counts[1] = CINTcgto_spinor(envs.shls[1], envs.bas);
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_tensor; i++) {
c2s_zset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_igkin_spinor
ALL_CINT1E(int1e_igkin)
ALL_CINT1E_FORTRAN_(int1e_igkin)
/* <G i|OVLP |j> */
void CINTgout1e_int1e_igovlp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
double s[3];
G1E_R0I(g1, g0, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
if (gout_empty) {
gout[n*3+0] = - c[1]*s[2] + c[2]*s[1];
gout[n*3+1] = - c[2]*s[0] + c[0]*s[2];
gout[n*3+2] = - c[0]*s[1] + c[1]*s[0];
} else {
gout[n*3+0] += - c[1]*s[2] + c[2]*s[1];
gout[n*3+1] += - c[2]*s[0] + c[0]*s[2];
gout[n*3+2] += - c[0]*s[1] + c[1]*s[0];
}}}
void int1e_igovlp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_igovlp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_igovlp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = envs.nfi * envs.x_ctr[0];
counts[1] = envs.nfj * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_igovlp_cart
CACHE_SIZE_T int1e_igovlp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_igovlp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = (envs.i_l*2+1) * envs.x_ctr[0];
counts[1] = (envs.j_l*2+1) * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_igovlp_sph
CACHE_SIZE_T int1e_igovlp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_igovlp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = CINTcgto_spinor(envs.shls[0], envs.bas);
counts[1] = CINTcgto_spinor(envs.shls[1], envs.bas);
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_tensor; i++) {
c2s_zset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_igovlp_spinor
ALL_CINT1E(int1e_igovlp)
ALL_CINT1E_FORTRAN_(int1e_igovlp)
/* <G i|NUC |j> */
void CINTgout1e_int1e_ignuc(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
G2E_R0I(g1, g0, envs->i_l+0, envs->j_l, 0, 0);
double s[3];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 3; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g1[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g0[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g0[ix+i] * g0[iy+i] * g1[iz+i];
}
if (gout_empty) {
gout[n*3+0] = - c[1]*s[2] + c[2]*s[1];
gout[n*3+1] = - c[2]*s[0] + c[0]*s[2];
gout[n*3+2] = - c[0]*s[1] + c[1]*s[0];
} else {
gout[n*3+0] += - c[1]*s[2] + c[2]*s[1];
gout[n*3+1] += - c[2]*s[0] + c[0]*s[2];
gout[n*3+2] += - c[0]*s[1] + c[1]*s[0];
}}}
void int1e_ignuc_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ignuc_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ignuc;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = envs.nfi * envs.x_ctr[0];
counts[1] = envs.nfj * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 2);
} // int1e_ignuc_cart
CACHE_SIZE_T int1e_ignuc_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ignuc;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = (envs.i_l*2+1) * envs.x_ctr[0];
counts[1] = (envs.j_l*2+1) * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 2);
} // int1e_ignuc_sph
CACHE_SIZE_T int1e_ignuc_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ignuc;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
FINT i, nout;
FINT counts[4];
counts[0] = CINTcgto_spinor(envs.shls[0], envs.bas);
counts[1] = CINTcgto_spinor(envs.shls[1], envs.bas);
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_tensor; i++) {
c2s_zset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 2);
} // int1e_ignuc_spinor
ALL_CINT1E(int1e_ignuc)
ALL_CINT1E_FORTRAN_(int1e_ignuc)
/* <P* i|NUC DOT P |j> */
void CINTgout1e_int1e_pnucp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*1+0] = + s[0] + s[4] + s[8];
} else {
gout[n*1+0] += + s[0] + s[4] + s[8];
}}}
void int1e_pnucp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_pnucp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_pnucp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 2);
} // int1e_pnucp_cart
CACHE_SIZE_T int1e_pnucp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_pnucp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 2);
} // int1e_pnucp_sph
CACHE_SIZE_T int1e_pnucp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_pnucp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 2);
} // int1e_pnucp_spinor
ALL_CINT1E(int1e_pnucp)
ALL_CINT1E_FORTRAN_(int1e_pnucp)
/* <i|ZC |j> */
void CINTgout1e_int1e_z(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[3];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[2];
} else {
gout[n*1+0] += + s[2];
}}}
void int1e_z_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_z_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_z;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_z_cart
CACHE_SIZE_T int1e_z_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_z;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_z_sph
CACHE_SIZE_T int1e_z_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_z;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_z_spinor
ALL_CINT1E(int1e_z)
ALL_CINT1E_FORTRAN_(int1e_z)
/* <i|ZC ZC |j> */
void CINTgout1e_int1e_zz(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[9];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[8];
} else {
gout[n*1+0] += + s[8];
}}}
void int1e_zz_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_zz_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_zz;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_zz_cart
CACHE_SIZE_T int1e_zz_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_zz;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_zz_sph
CACHE_SIZE_T int1e_zz_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_zz;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_zz_spinor
ALL_CINT1E(int1e_zz)
ALL_CINT1E_FORTRAN_(int1e_zz)
/* <i|RC |j> */
void CINTgout1e_int1e_r(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[3];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[0];
gout[n*3+1] = + s[1];
gout[n*3+2] = + s[2];
} else {
gout[n*3+0] += + s[0];
gout[n*3+1] += + s[1];
gout[n*3+2] += + s[2];
}}}
void int1e_r_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_r_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_r_cart
CACHE_SIZE_T int1e_r_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_r_sph
CACHE_SIZE_T int1e_r_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_r_spinor
ALL_CINT1E(int1e_r)
ALL_CINT1E_FORTRAN_(int1e_r)
/* <i|RC DOT RC |j> */
void CINTgout1e_int1e_r2(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[9];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + s[4] + s[8];
} else {
gout[n*1+0] += + s[0] + s[4] + s[8];
}}}
void int1e_r2_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_r2_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r2;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_r2_cart
CACHE_SIZE_T int1e_r2_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r2;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_r2_sph
CACHE_SIZE_T int1e_r2_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r2;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_r2_spinor
ALL_CINT1E(int1e_r2)
ALL_CINT1E_FORTRAN_(int1e_r2)
/* <i|RC DOT RC RC DOT RC |j> */
void CINTgout1e_int1e_r4(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[81];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_RCJ(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_RCJ(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
}}}
void int1e_r4_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_r4_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r4;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_r4_cart
CACHE_SIZE_T int1e_r4_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r4;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_r4_sph
CACHE_SIZE_T int1e_r4_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r4;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_r4_spinor
ALL_CINT1E(int1e_r4)
ALL_CINT1E_FORTRAN_(int1e_r4)
/* <i|RC RC |j> */
void CINTgout1e_int1e_rr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[9];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_rr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rr_cart
CACHE_SIZE_T int1e_rr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rr_sph
CACHE_SIZE_T int1e_rr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rr_spinor
ALL_CINT1E(int1e_rr)
ALL_CINT1E_FORTRAN_(int1e_rr)
/* <i|RC RC RC |j> */
void CINTgout1e_int1e_rrr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[27];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_rrr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrr_cart
CACHE_SIZE_T int1e_rrr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrr_sph
CACHE_SIZE_T int1e_rrr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrr_spinor
ALL_CINT1E(int1e_rrr)
ALL_CINT1E_FORTRAN_(int1e_rrr)
/* <i|RC RC RC RC |j> */
void CINTgout1e_int1e_rrrr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[81];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_RCJ(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_RCJ(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_rrrr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrrr_cart
CACHE_SIZE_T int1e_rrrr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrrr_sph
CACHE_SIZE_T int1e_rrrr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrrr_spinor
ALL_CINT1E(int1e_rrrr)
ALL_CINT1E_FORTRAN_(int1e_rrrr)
/* <i|Z |j> */
void CINTgout1e_int1e_z_origj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double s[3];
G1E_R_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[2];
} else {
gout[n*1+0] += + s[2];
}}}
void int1e_z_origj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_z_origj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_z_origj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_z_origj_cart
CACHE_SIZE_T int1e_z_origj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_z_origj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_z_origj_sph
CACHE_SIZE_T int1e_z_origj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_z_origj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_z_origj_spinor
ALL_CINT1E(int1e_z_origj)
ALL_CINT1E_FORTRAN_(int1e_z_origj)
/* <i|Z Z |j> */
void CINTgout1e_int1e_zz_origj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double s[9];
G1E_R_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[8];
} else {
gout[n*1+0] += + s[8];
}}}
void int1e_zz_origj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_zz_origj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_zz_origj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_zz_origj_cart
CACHE_SIZE_T int1e_zz_origj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_zz_origj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_zz_origj_sph
CACHE_SIZE_T int1e_zz_origj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_zz_origj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_zz_origj_spinor
ALL_CINT1E(int1e_zz_origj)
ALL_CINT1E_FORTRAN_(int1e_zz_origj)
/* <P DOT P i|OVLP |P DOT P j> */
void CINTgout1e_int1e_p4(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double s[81];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
}}}
void int1e_p4_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_p4_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_p4;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_p4_cart
CACHE_SIZE_T int1e_p4_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_p4;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_p4_sph
CACHE_SIZE_T int1e_p4_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_p4;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_p4_spinor
ALL_CINT1E(int1e_p4)
ALL_CINT1E_FORTRAN_(int1e_p4)
/* <P* i|RINV DOT P |j> */
void CINTgout1e_int1e_prinvp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*1+0] = + s[0] + s[4] + s[8];
} else {
gout[n*1+0] += + s[0] + s[4] + s[8];
}}}
void int1e_prinvp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_prinvp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_prinvp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_prinvp_cart
CACHE_SIZE_T int1e_prinvp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_prinvp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_prinvp_sph
CACHE_SIZE_T int1e_prinvp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_prinvp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_prinvp_spinor
ALL_CINT1E(int1e_prinvp)
ALL_CINT1E_FORTRAN_(int1e_prinvp)
/* <P* i|RINV CROSS P |j> */
void CINTgout1e_int1e_prinvxp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*3+0] = + s[5] - s[7];
gout[n*3+1] = + s[6] - s[2];
gout[n*3+2] = + s[1] - s[3];
} else {
gout[n*3+0] += + s[5] - s[7];
gout[n*3+1] += + s[6] - s[2];
gout[n*3+2] += + s[1] - s[3];
}}}
void int1e_prinvxp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_prinvxp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_prinvxp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_prinvxp_cart
CACHE_SIZE_T int1e_prinvxp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_prinvxp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_prinvxp_sph
CACHE_SIZE_T int1e_prinvxp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_prinvxp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_prinvxp_spinor
ALL_CINT1E(int1e_prinvxp)
ALL_CINT1E_FORTRAN_(int1e_prinvxp)
/* <P* i|NUC CROSS P |j> */
void CINTgout1e_int1e_pnucxp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*3+0] = + s[5] - s[7];
gout[n*3+1] = + s[6] - s[2];
gout[n*3+2] = + s[1] - s[3];
} else {
gout[n*3+0] += + s[5] - s[7];
gout[n*3+1] += + s[6] - s[2];
gout[n*3+2] += + s[1] - s[3];
}}}
void int1e_pnucxp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_pnucxp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_pnucxp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 2);
} // int1e_pnucxp_cart
CACHE_SIZE_T int1e_pnucxp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_pnucxp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 2);
} // int1e_pnucxp_sph
CACHE_SIZE_T int1e_pnucxp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_pnucxp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 2);
} // int1e_pnucxp_spinor
ALL_CINT1E(int1e_pnucxp)
ALL_CINT1E_FORTRAN_(int1e_pnucxp)
/* <i|RC NABLA |j> */
void CINTgout1e_int1e_irp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[9];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_irp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_irp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_irp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_irp_cart
CACHE_SIZE_T int1e_irp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_irp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_irp_sph
CACHE_SIZE_T int1e_irp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_irp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_irp_spinor
ALL_CINT1E(int1e_irp)
ALL_CINT1E_FORTRAN_(int1e_irp)
/* <i|RC RC NABLA |j> */
void CINTgout1e_int1e_irrp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[27];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_irrp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_irrp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_irrp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_irrp_cart
CACHE_SIZE_T int1e_irrp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_irrp;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_irrp_sph
CACHE_SIZE_T int1e_irrp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_irrp;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_irrp_spinor
ALL_CINT1E(int1e_irrp)
ALL_CINT1E_FORTRAN_(int1e_irrp)
/* <i|RC NABLA RC |j> */
void CINTgout1e_int1e_irpr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
double s[27];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_irpr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_irpr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_irpr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_irpr_cart
CACHE_SIZE_T int1e_irpr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_irpr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_irpr_sph
CACHE_SIZE_T int1e_irpr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_irpr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_irpr_spinor
ALL_CINT1E(int1e_irpr)
ALL_CINT1E_FORTRAN_(int1e_irpr)
/* <i|G G |j> */
void CINTgout1e_int1e_ggovlp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double rirj[3], c[9];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0] * rirj[0];
c[1] = 1 * rirj[0] * rirj[1];
c[2] = 1 * rirj[0] * rirj[2];
c[3] = 1 * rirj[1] * rirj[0];
c[4] = 1 * rirj[1] * rirj[1];
c[5] = 1 * rirj[1] * rirj[2];
c[6] = 1 * rirj[2] * rirj[0];
c[7] = 1 * rirj[2] * rirj[1];
c[8] = 1 * rirj[2] * rirj[2];
double s[9];
G1E_R0J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_R0J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = - c[4]*s[8] + 2*c[5]*s[7] - c[8]*s[4];
gout[n*9+1] = - c[5]*s[6] + c[8]*s[3] + c[3]*s[8] - c[6]*s[5];
gout[n*9+2] = - c[3]*s[7] + c[6]*s[4] + c[4]*s[6] - c[7]*s[3];
gout[n*9+3] = - c[7]*s[2] + c[1]*s[8] + c[8]*s[1] - c[2]*s[7];
gout[n*9+4] = - c[8]*s[0] + 2*c[6]*s[2] - c[0]*s[8];
gout[n*9+5] = - c[6]*s[1] + c[0]*s[7] + c[7]*s[0] - c[1]*s[6];
gout[n*9+6] = - c[1]*s[5] + c[4]*s[2] + c[2]*s[4] - c[5]*s[1];
gout[n*9+7] = - c[2]*s[3] + c[5]*s[0] + c[0]*s[5] - c[3]*s[2];
gout[n*9+8] = - c[0]*s[4] + 2*c[1]*s[3] - c[4]*s[0];
} else {
gout[n*9+0] += - c[4]*s[8] + 2*c[5]*s[7] - c[8]*s[4];
gout[n*9+1] += - c[5]*s[6] + c[8]*s[3] + c[3]*s[8] - c[6]*s[5];
gout[n*9+2] += - c[3]*s[7] + c[6]*s[4] + c[4]*s[6] - c[7]*s[3];
gout[n*9+3] += - c[7]*s[2] + c[1]*s[8] + c[8]*s[1] - c[2]*s[7];
gout[n*9+4] += - c[8]*s[0] + 2*c[6]*s[2] - c[0]*s[8];
gout[n*9+5] += - c[6]*s[1] + c[0]*s[7] + c[7]*s[0] - c[1]*s[6];
gout[n*9+6] += - c[1]*s[5] + c[4]*s[2] + c[2]*s[4] - c[5]*s[1];
gout[n*9+7] += - c[2]*s[3] + c[5]*s[0] + c[0]*s[5] - c[3]*s[2];
gout[n*9+8] += - c[0]*s[4] + 2*c[1]*s[3] - c[4]*s[0];
}}}
void int1e_ggovlp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ggovlp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ggovlp;
envs.common_factor *= 0.25;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ggovlp_cart
CACHE_SIZE_T int1e_ggovlp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ggovlp;
envs.common_factor *= 0.25;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ggovlp_sph
CACHE_SIZE_T int1e_ggovlp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ggovlp;
envs.common_factor *= 0.25;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ggovlp_spinor
ALL_CINT1E(int1e_ggovlp)
ALL_CINT1E_FORTRAN_(int1e_ggovlp)
/* <i|G G P DOT P |j> */
void CINTgout1e_int1e_ggkin(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double rirj[3], c[9];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0] * rirj[0];
c[1] = 1 * rirj[0] * rirj[1];
c[2] = 1 * rirj[0] * rirj[2];
c[3] = 1 * rirj[1] * rirj[0];
c[4] = 1 * rirj[1] * rirj[1];
c[5] = 1 * rirj[1] * rirj[2];
c[6] = 1 * rirj[2] * rirj[0];
c[7] = 1 * rirj[2] * rirj[1];
c[8] = 1 * rirj[2] * rirj[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_R0J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_R0J(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_R0J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*9+0] = + c[4]*s[72] -2*c[5]*s[63] + c[8]*s[36] + c[4]*s[76] -2*c[5]*s[67] + c[8]*s[40] + c[4]*s[80] -2*c[5]*s[71] + c[8]*s[44];
gout[n*9+1] = + c[5]*s[54] - c[8]*s[27] - c[3]*s[72] + c[6]*s[45] + c[5]*s[58] - c[8]*s[31] - c[3]*s[76] + c[6]*s[49] + c[5]*s[62] - c[8]*s[35] - c[3]*s[80] + c[6]*s[53];
gout[n*9+2] = + c[3]*s[63] - c[6]*s[36] - c[4]*s[54] + c[7]*s[27] + c[3]*s[67] - c[6]*s[40] - c[4]*s[58] + c[7]*s[31] + c[3]*s[71] - c[6]*s[44] - c[4]*s[62] + c[7]*s[35];
gout[n*9+3] = + c[7]*s[18] - c[1]*s[72] - c[8]*s[9] + c[2]*s[63] + c[7]*s[22] - c[1]*s[76] - c[8]*s[13] + c[2]*s[67] + c[7]*s[26] - c[1]*s[80] - c[8]*s[17] + c[2]*s[71];
gout[n*9+4] = + c[8]*s[0] -2*c[6]*s[18] + c[0]*s[72] + c[8]*s[4] -2*c[6]*s[22] + c[0]*s[76] + c[8]*s[8] -2*c[6]*s[26] + c[0]*s[80];
gout[n*9+5] = + c[6]*s[9] - c[0]*s[63] - c[7]*s[0] + c[1]*s[54] + c[6]*s[13] - c[0]*s[67] - c[7]*s[4] + c[1]*s[58] + c[6]*s[17] - c[0]*s[71] - c[7]*s[8] + c[1]*s[62];
gout[n*9+6] = + c[1]*s[45] - c[4]*s[18] - c[2]*s[36] + c[5]*s[9] + c[1]*s[49] - c[4]*s[22] - c[2]*s[40] + c[5]*s[13] + c[1]*s[53] - c[4]*s[26] - c[2]*s[44] + c[5]*s[17];
gout[n*9+7] = + c[2]*s[27] - c[5]*s[0] - c[0]*s[45] + c[3]*s[18] + c[2]*s[31] - c[5]*s[4] - c[0]*s[49] + c[3]*s[22] + c[2]*s[35] - c[5]*s[8] - c[0]*s[53] + c[3]*s[26];
gout[n*9+8] = + c[0]*s[36] -2*c[1]*s[27] + c[4]*s[0] + c[0]*s[40] -2*c[1]*s[31] + c[4]*s[4] + c[0]*s[44] -2*c[1]*s[35] + c[4]*s[8];
} else {
gout[n*9+0] += + c[4]*s[72] -2*c[5]*s[63] + c[8]*s[36] + c[4]*s[76] -2*c[5]*s[67] + c[8]*s[40] + c[4]*s[80] -2*c[5]*s[71] + c[8]*s[44];
gout[n*9+1] += + c[5]*s[54] - c[8]*s[27] - c[3]*s[72] + c[6]*s[45] + c[5]*s[58] - c[8]*s[31] - c[3]*s[76] + c[6]*s[49] + c[5]*s[62] - c[8]*s[35] - c[3]*s[80] + c[6]*s[53];
gout[n*9+2] += + c[3]*s[63] - c[6]*s[36] - c[4]*s[54] + c[7]*s[27] + c[3]*s[67] - c[6]*s[40] - c[4]*s[58] + c[7]*s[31] + c[3]*s[71] - c[6]*s[44] - c[4]*s[62] + c[7]*s[35];
gout[n*9+3] += + c[7]*s[18] - c[1]*s[72] - c[8]*s[9] + c[2]*s[63] + c[7]*s[22] - c[1]*s[76] - c[8]*s[13] + c[2]*s[67] + c[7]*s[26] - c[1]*s[80] - c[8]*s[17] + c[2]*s[71];
gout[n*9+4] += + c[8]*s[0] -2*c[6]*s[18] + c[0]*s[72] + c[8]*s[4] -2*c[6]*s[22] + c[0]*s[76] + c[8]*s[8] -2*c[6]*s[26] + c[0]*s[80];
gout[n*9+5] += + c[6]*s[9] - c[0]*s[63] - c[7]*s[0] + c[1]*s[54] + c[6]*s[13] - c[0]*s[67] - c[7]*s[4] + c[1]*s[58] + c[6]*s[17] - c[0]*s[71] - c[7]*s[8] + c[1]*s[62];
gout[n*9+6] += + c[1]*s[45] - c[4]*s[18] - c[2]*s[36] + c[5]*s[9] + c[1]*s[49] - c[4]*s[22] - c[2]*s[40] + c[5]*s[13] + c[1]*s[53] - c[4]*s[26] - c[2]*s[44] + c[5]*s[17];
gout[n*9+7] += + c[2]*s[27] - c[5]*s[0] - c[0]*s[45] + c[3]*s[18] + c[2]*s[31] - c[5]*s[4] - c[0]*s[49] + c[3]*s[22] + c[2]*s[35] - c[5]*s[8] - c[0]*s[53] + c[3]*s[26];
gout[n*9+8] += + c[0]*s[36] -2*c[1]*s[27] + c[4]*s[0] + c[0]*s[40] -2*c[1]*s[31] + c[4]*s[4] + c[0]*s[44] -2*c[1]*s[35] + c[4]*s[8];
}}}
void int1e_ggkin_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ggkin_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ggkin;
envs.common_factor *= 0.125;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ggkin_cart
CACHE_SIZE_T int1e_ggkin_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ggkin;
envs.common_factor *= 0.125;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ggkin_sph
CACHE_SIZE_T int1e_ggkin_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ggkin;
envs.common_factor *= 0.125;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ggkin_spinor
ALL_CINT1E(int1e_ggkin)
ALL_CINT1E_FORTRAN_(int1e_ggkin)
/* <i|G G NUC |j> */
void CINTgout1e_int1e_ggnuc(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double rirj[3], c[9];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0] * rirj[0];
c[1] = 1 * rirj[0] * rirj[1];
c[2] = 1 * rirj[0] * rirj[2];
c[3] = 1 * rirj[1] * rirj[0];
c[4] = 1 * rirj[1] * rirj[1];
c[5] = 1 * rirj[1] * rirj[2];
c[6] = 1 * rirj[2] * rirj[0];
c[7] = 1 * rirj[2] * rirj[1];
c[8] = 1 * rirj[2] * rirj[2];
G2E_R0J(g1, g0, envs->i_l+0, envs->j_l+0, 0, 0);
G2E_R0J(g2, g0, envs->i_l+0, envs->j_l+1, 0, 0);
G2E_R0J(g3, g2, envs->i_l+0, envs->j_l+0, 0, 0);
double s[9];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g3[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g2[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g2[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g1[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g0[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g0[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g1[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g0[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g0[ix+i] * g0[iy+i] * g3[iz+i];
}
if (gout_empty) {
gout[n*9+0] = - c[4]*s[8] + 2*c[5]*s[7] - c[8]*s[4];
gout[n*9+1] = - c[5]*s[6] + c[8]*s[3] + c[3]*s[8] - c[6]*s[5];
gout[n*9+2] = - c[3]*s[7] + c[6]*s[4] + c[4]*s[6] - c[7]*s[3];
gout[n*9+3] = - c[7]*s[2] + c[1]*s[8] + c[8]*s[1] - c[2]*s[7];
gout[n*9+4] = - c[8]*s[0] + 2*c[6]*s[2] - c[0]*s[8];
gout[n*9+5] = - c[6]*s[1] + c[0]*s[7] + c[7]*s[0] - c[1]*s[6];
gout[n*9+6] = - c[1]*s[5] + c[4]*s[2] + c[2]*s[4] - c[5]*s[1];
gout[n*9+7] = - c[2]*s[3] + c[5]*s[0] + c[0]*s[5] - c[3]*s[2];
gout[n*9+8] = - c[0]*s[4] + 2*c[1]*s[3] - c[4]*s[0];
} else {
gout[n*9+0] += - c[4]*s[8] + 2*c[5]*s[7] - c[8]*s[4];
gout[n*9+1] += - c[5]*s[6] + c[8]*s[3] + c[3]*s[8] - c[6]*s[5];
gout[n*9+2] += - c[3]*s[7] + c[6]*s[4] + c[4]*s[6] - c[7]*s[3];
gout[n*9+3] += - c[7]*s[2] + c[1]*s[8] + c[8]*s[1] - c[2]*s[7];
gout[n*9+4] += - c[8]*s[0] + 2*c[6]*s[2] - c[0]*s[8];
gout[n*9+5] += - c[6]*s[1] + c[0]*s[7] + c[7]*s[0] - c[1]*s[6];
gout[n*9+6] += - c[1]*s[5] + c[4]*s[2] + c[2]*s[4] - c[5]*s[1];
gout[n*9+7] += - c[2]*s[3] + c[5]*s[0] + c[0]*s[5] - c[3]*s[2];
gout[n*9+8] += - c[0]*s[4] + 2*c[1]*s[3] - c[4]*s[0];
}}}
void int1e_ggnuc_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ggnuc_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ggnuc;
envs.common_factor *= 0.25;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 2);
} // int1e_ggnuc_cart
CACHE_SIZE_T int1e_ggnuc_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ggnuc;
envs.common_factor *= 0.25;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 2);
} // int1e_ggnuc_sph
CACHE_SIZE_T int1e_ggnuc_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ggnuc;
envs.common_factor *= 0.25;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 2);
} // int1e_ggnuc_spinor
ALL_CINT1E(int1e_ggnuc)
ALL_CINT1E_FORTRAN_(int1e_ggnuc)
/* <i|G R CROSS P |j> */
void CINTgout1e_int1e_grjxp(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
double s[27];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_R0J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*9+0] = + c[1]*s[23] - c[2]*s[14] - c[1]*s[25] + c[2]*s[16];
gout[n*9+1] = + c[1]*s[24] - c[2]*s[15] - c[1]*s[20] + c[2]*s[11];
gout[n*9+2] = + c[1]*s[19] - c[2]*s[10] - c[1]*s[21] + c[2]*s[12];
gout[n*9+3] = + c[2]*s[5] - c[0]*s[23] - c[2]*s[7] + c[0]*s[25];
gout[n*9+4] = + c[2]*s[6] - c[0]*s[24] - c[2]*s[2] + c[0]*s[20];
gout[n*9+5] = + c[2]*s[1] - c[0]*s[19] - c[2]*s[3] + c[0]*s[21];
gout[n*9+6] = + c[0]*s[14] - c[1]*s[5] - c[0]*s[16] + c[1]*s[7];
gout[n*9+7] = + c[0]*s[15] - c[1]*s[6] - c[0]*s[11] + c[1]*s[2];
gout[n*9+8] = + c[0]*s[10] - c[1]*s[1] - c[0]*s[12] + c[1]*s[3];
} else {
gout[n*9+0] += + c[1]*s[23] - c[2]*s[14] - c[1]*s[25] + c[2]*s[16];
gout[n*9+1] += + c[1]*s[24] - c[2]*s[15] - c[1]*s[20] + c[2]*s[11];
gout[n*9+2] += + c[1]*s[19] - c[2]*s[10] - c[1]*s[21] + c[2]*s[12];
gout[n*9+3] += + c[2]*s[5] - c[0]*s[23] - c[2]*s[7] + c[0]*s[25];
gout[n*9+4] += + c[2]*s[6] - c[0]*s[24] - c[2]*s[2] + c[0]*s[20];
gout[n*9+5] += + c[2]*s[1] - c[0]*s[19] - c[2]*s[3] + c[0]*s[21];
gout[n*9+6] += + c[0]*s[14] - c[1]*s[5] - c[0]*s[16] + c[1]*s[7];
gout[n*9+7] += + c[0]*s[15] - c[1]*s[6] - c[0]*s[11] + c[1]*s[2];
gout[n*9+8] += + c[0]*s[10] - c[1]*s[1] - c[0]*s[12] + c[1]*s[3];
}}}
void int1e_grjxp_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_grjxp_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_grjxp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_grjxp_cart
CACHE_SIZE_T int1e_grjxp_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_grjxp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_grjxp_sph
CACHE_SIZE_T int1e_grjxp_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_grjxp;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_grjxp_spinor
ALL_CINT1E(int1e_grjxp)
ALL_CINT1E_FORTRAN_(int1e_grjxp)
/* <i|RINV |j> */
void CINTgout1e_int1e_rinv(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double s[1];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 1; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g0[ix+i] * g0[iy+i] * g0[iz+i];
}
if (gout_empty) {
gout[n*1+0] = + s[0];
} else {
gout[n*1+0] += + s[0];
}}}
void int1e_rinv_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 0, 0, 0, 0, 1, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rinv_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 0, 0, 0, 0, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rinv;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_rinv_cart
CACHE_SIZE_T int1e_rinv_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 0, 0, 0, 0, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rinv;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_rinv_sph
CACHE_SIZE_T int1e_rinv_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 0, 0, 0, 0, 1, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rinv;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_rinv_spinor
ALL_CINT1E(int1e_rinv)
ALL_CINT1E_FORTRAN_(int1e_rinv)
/* <i|NABLA-RINV |j> */
void CINTgout1e_int1e_drinv(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT nrys_roots = envs->nrys_roots;
FINT ix, iy, iz, n, i;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
G2E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+0, envs->j_l+0, 0, 0);
for (ix = 0; ix < envs->g_size * 3; ix++) {g1[ix] += g2[ix];}
double s[3];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 3; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g1[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g0[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g0[ix+i] * g0[iy+i] * g1[iz+i];
}
if (gout_empty) {
gout[n*3+0] = + s[0];
gout[n*3+1] = + s[1];
gout[n*3+2] = + s[2];
} else {
gout[n*3+0] += + s[0];
gout[n*3+1] += + s[1];
gout[n*3+2] += + s[2];
}}}
void int1e_drinv_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 1, 0, 0, 1, 1, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_drinv_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_drinv;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 1);
} // int1e_drinv_cart
CACHE_SIZE_T int1e_drinv_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_drinv;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 1);
} // int1e_drinv_sph
CACHE_SIZE_T int1e_drinv_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_drinv;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 1);
} // int1e_drinv_spinor
ALL_CINT1E(int1e_drinv)
ALL_CINT1E_FORTRAN_(int1e_drinv)
/* <i|RI |j> */
void CINTgout1e_int1e_m(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[3];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[0];
gout[n*3+1] = + s[1];
gout[n*3+2] = + s[2];
} else {
gout[n*3+0] += + s[0];
gout[n*3+1] += + s[1];
gout[n*3+2] += + s[2];
}}}
void int1e_m_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_m_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_m;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_m_cart
CACHE_SIZE_T int1e_m_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_m;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_m_sph
CACHE_SIZE_T int1e_m_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_m;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_m_spinor
ALL_CINT1E(int1e_m)
ALL_CINT1E_FORTRAN_(int1e_m)
/* <i|RI RI |j> */
void CINTgout1e_int1e_mm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[9];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_mm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mm_cart
CACHE_SIZE_T int1e_mm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mm_sph
CACHE_SIZE_T int1e_mm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mm_spinor
ALL_CINT1E(int1e_mm)
ALL_CINT1E_FORTRAN_(int1e_mm)
/* <i|RI RI RI |j> */
void CINTgout1e_int1e_mmm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[27];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_mmm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mmm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mmm_cart
CACHE_SIZE_T int1e_mmm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mmm_sph
CACHE_SIZE_T int1e_mmm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mmm_spinor
ALL_CINT1E(int1e_mmm)
ALL_CINT1E_FORTRAN_(int1e_mmm)
/* <i|RI DOT RI |j> */
void CINTgout1e_int1e_m2(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[9];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + s[4] + s[8];
} else {
gout[n*1+0] += + s[0] + s[4] + s[8];
}}}
void int1e_m2_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_m2_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_m2;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_m2_cart
CACHE_SIZE_T int1e_m2_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_m2;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_m2_sph
CACHE_SIZE_T int1e_m2_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_m2;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_m2_spinor
ALL_CINT1E(int1e_m2)
ALL_CINT1E_FORTRAN_(int1e_m2)
/* <i|OVLP |RI DOT RI RI DOT R j> */
void CINTgout1e_int1e_m4(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_R_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_R_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_R_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_R_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + s[36] + s[72] + s[4] + s[40] + s[76] + s[8] + s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + s[36] + s[72] + s[4] + s[40] + s[76] + s[8] + s[44] + s[80];
}}}
void int1e_m4_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_m4_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_m4;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_m4_cart
CACHE_SIZE_T int1e_m4_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_m4;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_m4_sph
CACHE_SIZE_T int1e_m4_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_m4;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_m4_spinor
ALL_CINT1E(int1e_m4)
ALL_CINT1E_FORTRAN_(int1e_m4)
/* <NABLA i|RI |j> */
void CINTgout1e_int1e_ipm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[9];
G1E_RCJ(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_ipm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipm_cart
CACHE_SIZE_T int1e_ipm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipm_sph
CACHE_SIZE_T int1e_ipm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipm_spinor
ALL_CINT1E(int1e_ipm)
ALL_CINT1E_FORTRAN_(int1e_ipm)
/* <NABLA NABLA i|RI |j> */
void CINTgout1e_int1e_ipipm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[27];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[9];
gout[n*27+4] = + s[10];
gout[n*27+5] = + s[11];
gout[n*27+6] = + s[18];
gout[n*27+7] = + s[19];
gout[n*27+8] = + s[20];
gout[n*27+9] = + s[3];
gout[n*27+10] = + s[4];
gout[n*27+11] = + s[5];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[21];
gout[n*27+16] = + s[22];
gout[n*27+17] = + s[23];
gout[n*27+18] = + s[6];
gout[n*27+19] = + s[7];
gout[n*27+20] = + s[8];
gout[n*27+21] = + s[15];
gout[n*27+22] = + s[16];
gout[n*27+23] = + s[17];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[9];
gout[n*27+4] += + s[10];
gout[n*27+5] += + s[11];
gout[n*27+6] += + s[18];
gout[n*27+7] += + s[19];
gout[n*27+8] += + s[20];
gout[n*27+9] += + s[3];
gout[n*27+10] += + s[4];
gout[n*27+11] += + s[5];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[21];
gout[n*27+16] += + s[22];
gout[n*27+17] += + s[23];
gout[n*27+18] += + s[6];
gout[n*27+19] += + s[7];
gout[n*27+20] += + s[8];
gout[n*27+21] += + s[15];
gout[n*27+22] += + s[16];
gout[n*27+23] += + s[17];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_ipipm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipm_cart
CACHE_SIZE_T int1e_ipipm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipm_sph
CACHE_SIZE_T int1e_ipipm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipm_spinor
ALL_CINT1E(int1e_ipipm)
ALL_CINT1E_FORTRAN_(int1e_ipipm)
/* <NABLA NABLA NABLA i|RI |j> */
void CINTgout1e_int1e_ipipipm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_RCJ(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[27];
gout[n*81+4] = + s[28];
gout[n*81+5] = + s[29];
gout[n*81+6] = + s[54];
gout[n*81+7] = + s[55];
gout[n*81+8] = + s[56];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[36];
gout[n*81+13] = + s[37];
gout[n*81+14] = + s[38];
gout[n*81+15] = + s[63];
gout[n*81+16] = + s[64];
gout[n*81+17] = + s[65];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[45];
gout[n*81+22] = + s[46];
gout[n*81+23] = + s[47];
gout[n*81+24] = + s[72];
gout[n*81+25] = + s[73];
gout[n*81+26] = + s[74];
gout[n*81+27] = + s[3];
gout[n*81+28] = + s[4];
gout[n*81+29] = + s[5];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[57];
gout[n*81+34] = + s[58];
gout[n*81+35] = + s[59];
gout[n*81+36] = + s[12];
gout[n*81+37] = + s[13];
gout[n*81+38] = + s[14];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[66];
gout[n*81+43] = + s[67];
gout[n*81+44] = + s[68];
gout[n*81+45] = + s[21];
gout[n*81+46] = + s[22];
gout[n*81+47] = + s[23];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[75];
gout[n*81+52] = + s[76];
gout[n*81+53] = + s[77];
gout[n*81+54] = + s[6];
gout[n*81+55] = + s[7];
gout[n*81+56] = + s[8];
gout[n*81+57] = + s[33];
gout[n*81+58] = + s[34];
gout[n*81+59] = + s[35];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[15];
gout[n*81+64] = + s[16];
gout[n*81+65] = + s[17];
gout[n*81+66] = + s[42];
gout[n*81+67] = + s[43];
gout[n*81+68] = + s[44];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[24];
gout[n*81+73] = + s[25];
gout[n*81+74] = + s[26];
gout[n*81+75] = + s[51];
gout[n*81+76] = + s[52];
gout[n*81+77] = + s[53];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[27];
gout[n*81+4] += + s[28];
gout[n*81+5] += + s[29];
gout[n*81+6] += + s[54];
gout[n*81+7] += + s[55];
gout[n*81+8] += + s[56];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[36];
gout[n*81+13] += + s[37];
gout[n*81+14] += + s[38];
gout[n*81+15] += + s[63];
gout[n*81+16] += + s[64];
gout[n*81+17] += + s[65];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[45];
gout[n*81+22] += + s[46];
gout[n*81+23] += + s[47];
gout[n*81+24] += + s[72];
gout[n*81+25] += + s[73];
gout[n*81+26] += + s[74];
gout[n*81+27] += + s[3];
gout[n*81+28] += + s[4];
gout[n*81+29] += + s[5];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[57];
gout[n*81+34] += + s[58];
gout[n*81+35] += + s[59];
gout[n*81+36] += + s[12];
gout[n*81+37] += + s[13];
gout[n*81+38] += + s[14];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[66];
gout[n*81+43] += + s[67];
gout[n*81+44] += + s[68];
gout[n*81+45] += + s[21];
gout[n*81+46] += + s[22];
gout[n*81+47] += + s[23];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[75];
gout[n*81+52] += + s[76];
gout[n*81+53] += + s[77];
gout[n*81+54] += + s[6];
gout[n*81+55] += + s[7];
gout[n*81+56] += + s[8];
gout[n*81+57] += + s[33];
gout[n*81+58] += + s[34];
gout[n*81+59] += + s[35];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[15];
gout[n*81+64] += + s[16];
gout[n*81+65] += + s[17];
gout[n*81+66] += + s[42];
gout[n*81+67] += + s[43];
gout[n*81+68] += + s[44];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[24];
gout[n*81+73] += + s[25];
gout[n*81+74] += + s[26];
gout[n*81+75] += + s[51];
gout[n*81+76] += + s[52];
gout[n*81+77] += + s[53];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipipipm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 1, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 1, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipm_cart
CACHE_SIZE_T int1e_ipipipm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 1, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipm_sph
CACHE_SIZE_T int1e_ipipipm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 1, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipm_spinor
ALL_CINT1E(int1e_ipipipm)
ALL_CINT1E_FORTRAN_(int1e_ipipipm)
/* <NABLA NABLA NABLA NABLA i|RI |j> */
void CINTgout1e_int1e_ipipipipm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_RCJ(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g4, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[81];
gout[n*243+4] = + s[82];
gout[n*243+5] = + s[83];
gout[n*243+6] = + s[162];
gout[n*243+7] = + s[163];
gout[n*243+8] = + s[164];
gout[n*243+9] = + s[27];
gout[n*243+10] = + s[28];
gout[n*243+11] = + s[29];
gout[n*243+12] = + s[108];
gout[n*243+13] = + s[109];
gout[n*243+14] = + s[110];
gout[n*243+15] = + s[189];
gout[n*243+16] = + s[190];
gout[n*243+17] = + s[191];
gout[n*243+18] = + s[54];
gout[n*243+19] = + s[55];
gout[n*243+20] = + s[56];
gout[n*243+21] = + s[135];
gout[n*243+22] = + s[136];
gout[n*243+23] = + s[137];
gout[n*243+24] = + s[216];
gout[n*243+25] = + s[217];
gout[n*243+26] = + s[218];
gout[n*243+27] = + s[9];
gout[n*243+28] = + s[10];
gout[n*243+29] = + s[11];
gout[n*243+30] = + s[90];
gout[n*243+31] = + s[91];
gout[n*243+32] = + s[92];
gout[n*243+33] = + s[171];
gout[n*243+34] = + s[172];
gout[n*243+35] = + s[173];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[117];
gout[n*243+40] = + s[118];
gout[n*243+41] = + s[119];
gout[n*243+42] = + s[198];
gout[n*243+43] = + s[199];
gout[n*243+44] = + s[200];
gout[n*243+45] = + s[63];
gout[n*243+46] = + s[64];
gout[n*243+47] = + s[65];
gout[n*243+48] = + s[144];
gout[n*243+49] = + s[145];
gout[n*243+50] = + s[146];
gout[n*243+51] = + s[225];
gout[n*243+52] = + s[226];
gout[n*243+53] = + s[227];
gout[n*243+54] = + s[18];
gout[n*243+55] = + s[19];
gout[n*243+56] = + s[20];
gout[n*243+57] = + s[99];
gout[n*243+58] = + s[100];
gout[n*243+59] = + s[101];
gout[n*243+60] = + s[180];
gout[n*243+61] = + s[181];
gout[n*243+62] = + s[182];
gout[n*243+63] = + s[45];
gout[n*243+64] = + s[46];
gout[n*243+65] = + s[47];
gout[n*243+66] = + s[126];
gout[n*243+67] = + s[127];
gout[n*243+68] = + s[128];
gout[n*243+69] = + s[207];
gout[n*243+70] = + s[208];
gout[n*243+71] = + s[209];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[153];
gout[n*243+76] = + s[154];
gout[n*243+77] = + s[155];
gout[n*243+78] = + s[234];
gout[n*243+79] = + s[235];
gout[n*243+80] = + s[236];
gout[n*243+81] = + s[3];
gout[n*243+82] = + s[4];
gout[n*243+83] = + s[5];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[165];
gout[n*243+88] = + s[166];
gout[n*243+89] = + s[167];
gout[n*243+90] = + s[30];
gout[n*243+91] = + s[31];
gout[n*243+92] = + s[32];
gout[n*243+93] = + s[111];
gout[n*243+94] = + s[112];
gout[n*243+95] = + s[113];
gout[n*243+96] = + s[192];
gout[n*243+97] = + s[193];
gout[n*243+98] = + s[194];
gout[n*243+99] = + s[57];
gout[n*243+100] = + s[58];
gout[n*243+101] = + s[59];
gout[n*243+102] = + s[138];
gout[n*243+103] = + s[139];
gout[n*243+104] = + s[140];
gout[n*243+105] = + s[219];
gout[n*243+106] = + s[220];
gout[n*243+107] = + s[221];
gout[n*243+108] = + s[12];
gout[n*243+109] = + s[13];
gout[n*243+110] = + s[14];
gout[n*243+111] = + s[93];
gout[n*243+112] = + s[94];
gout[n*243+113] = + s[95];
gout[n*243+114] = + s[174];
gout[n*243+115] = + s[175];
gout[n*243+116] = + s[176];
gout[n*243+117] = + s[39];
gout[n*243+118] = + s[40];
gout[n*243+119] = + s[41];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[201];
gout[n*243+124] = + s[202];
gout[n*243+125] = + s[203];
gout[n*243+126] = + s[66];
gout[n*243+127] = + s[67];
gout[n*243+128] = + s[68];
gout[n*243+129] = + s[147];
gout[n*243+130] = + s[148];
gout[n*243+131] = + s[149];
gout[n*243+132] = + s[228];
gout[n*243+133] = + s[229];
gout[n*243+134] = + s[230];
gout[n*243+135] = + s[21];
gout[n*243+136] = + s[22];
gout[n*243+137] = + s[23];
gout[n*243+138] = + s[102];
gout[n*243+139] = + s[103];
gout[n*243+140] = + s[104];
gout[n*243+141] = + s[183];
gout[n*243+142] = + s[184];
gout[n*243+143] = + s[185];
gout[n*243+144] = + s[48];
gout[n*243+145] = + s[49];
gout[n*243+146] = + s[50];
gout[n*243+147] = + s[129];
gout[n*243+148] = + s[130];
gout[n*243+149] = + s[131];
gout[n*243+150] = + s[210];
gout[n*243+151] = + s[211];
gout[n*243+152] = + s[212];
gout[n*243+153] = + s[75];
gout[n*243+154] = + s[76];
gout[n*243+155] = + s[77];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[237];
gout[n*243+160] = + s[238];
gout[n*243+161] = + s[239];
gout[n*243+162] = + s[6];
gout[n*243+163] = + s[7];
gout[n*243+164] = + s[8];
gout[n*243+165] = + s[87];
gout[n*243+166] = + s[88];
gout[n*243+167] = + s[89];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[33];
gout[n*243+172] = + s[34];
gout[n*243+173] = + s[35];
gout[n*243+174] = + s[114];
gout[n*243+175] = + s[115];
gout[n*243+176] = + s[116];
gout[n*243+177] = + s[195];
gout[n*243+178] = + s[196];
gout[n*243+179] = + s[197];
gout[n*243+180] = + s[60];
gout[n*243+181] = + s[61];
gout[n*243+182] = + s[62];
gout[n*243+183] = + s[141];
gout[n*243+184] = + s[142];
gout[n*243+185] = + s[143];
gout[n*243+186] = + s[222];
gout[n*243+187] = + s[223];
gout[n*243+188] = + s[224];
gout[n*243+189] = + s[15];
gout[n*243+190] = + s[16];
gout[n*243+191] = + s[17];
gout[n*243+192] = + s[96];
gout[n*243+193] = + s[97];
gout[n*243+194] = + s[98];
gout[n*243+195] = + s[177];
gout[n*243+196] = + s[178];
gout[n*243+197] = + s[179];
gout[n*243+198] = + s[42];
gout[n*243+199] = + s[43];
gout[n*243+200] = + s[44];
gout[n*243+201] = + s[123];
gout[n*243+202] = + s[124];
gout[n*243+203] = + s[125];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[69];
gout[n*243+208] = + s[70];
gout[n*243+209] = + s[71];
gout[n*243+210] = + s[150];
gout[n*243+211] = + s[151];
gout[n*243+212] = + s[152];
gout[n*243+213] = + s[231];
gout[n*243+214] = + s[232];
gout[n*243+215] = + s[233];
gout[n*243+216] = + s[24];
gout[n*243+217] = + s[25];
gout[n*243+218] = + s[26];
gout[n*243+219] = + s[105];
gout[n*243+220] = + s[106];
gout[n*243+221] = + s[107];
gout[n*243+222] = + s[186];
gout[n*243+223] = + s[187];
gout[n*243+224] = + s[188];
gout[n*243+225] = + s[51];
gout[n*243+226] = + s[52];
gout[n*243+227] = + s[53];
gout[n*243+228] = + s[132];
gout[n*243+229] = + s[133];
gout[n*243+230] = + s[134];
gout[n*243+231] = + s[213];
gout[n*243+232] = + s[214];
gout[n*243+233] = + s[215];
gout[n*243+234] = + s[78];
gout[n*243+235] = + s[79];
gout[n*243+236] = + s[80];
gout[n*243+237] = + s[159];
gout[n*243+238] = + s[160];
gout[n*243+239] = + s[161];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[81];
gout[n*243+4] += + s[82];
gout[n*243+5] += + s[83];
gout[n*243+6] += + s[162];
gout[n*243+7] += + s[163];
gout[n*243+8] += + s[164];
gout[n*243+9] += + s[27];
gout[n*243+10] += + s[28];
gout[n*243+11] += + s[29];
gout[n*243+12] += + s[108];
gout[n*243+13] += + s[109];
gout[n*243+14] += + s[110];
gout[n*243+15] += + s[189];
gout[n*243+16] += + s[190];
gout[n*243+17] += + s[191];
gout[n*243+18] += + s[54];
gout[n*243+19] += + s[55];
gout[n*243+20] += + s[56];
gout[n*243+21] += + s[135];
gout[n*243+22] += + s[136];
gout[n*243+23] += + s[137];
gout[n*243+24] += + s[216];
gout[n*243+25] += + s[217];
gout[n*243+26] += + s[218];
gout[n*243+27] += + s[9];
gout[n*243+28] += + s[10];
gout[n*243+29] += + s[11];
gout[n*243+30] += + s[90];
gout[n*243+31] += + s[91];
gout[n*243+32] += + s[92];
gout[n*243+33] += + s[171];
gout[n*243+34] += + s[172];
gout[n*243+35] += + s[173];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[117];
gout[n*243+40] += + s[118];
gout[n*243+41] += + s[119];
gout[n*243+42] += + s[198];
gout[n*243+43] += + s[199];
gout[n*243+44] += + s[200];
gout[n*243+45] += + s[63];
gout[n*243+46] += + s[64];
gout[n*243+47] += + s[65];
gout[n*243+48] += + s[144];
gout[n*243+49] += + s[145];
gout[n*243+50] += + s[146];
gout[n*243+51] += + s[225];
gout[n*243+52] += + s[226];
gout[n*243+53] += + s[227];
gout[n*243+54] += + s[18];
gout[n*243+55] += + s[19];
gout[n*243+56] += + s[20];
gout[n*243+57] += + s[99];
gout[n*243+58] += + s[100];
gout[n*243+59] += + s[101];
gout[n*243+60] += + s[180];
gout[n*243+61] += + s[181];
gout[n*243+62] += + s[182];
gout[n*243+63] += + s[45];
gout[n*243+64] += + s[46];
gout[n*243+65] += + s[47];
gout[n*243+66] += + s[126];
gout[n*243+67] += + s[127];
gout[n*243+68] += + s[128];
gout[n*243+69] += + s[207];
gout[n*243+70] += + s[208];
gout[n*243+71] += + s[209];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[153];
gout[n*243+76] += + s[154];
gout[n*243+77] += + s[155];
gout[n*243+78] += + s[234];
gout[n*243+79] += + s[235];
gout[n*243+80] += + s[236];
gout[n*243+81] += + s[3];
gout[n*243+82] += + s[4];
gout[n*243+83] += + s[5];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[165];
gout[n*243+88] += + s[166];
gout[n*243+89] += + s[167];
gout[n*243+90] += + s[30];
gout[n*243+91] += + s[31];
gout[n*243+92] += + s[32];
gout[n*243+93] += + s[111];
gout[n*243+94] += + s[112];
gout[n*243+95] += + s[113];
gout[n*243+96] += + s[192];
gout[n*243+97] += + s[193];
gout[n*243+98] += + s[194];
gout[n*243+99] += + s[57];
gout[n*243+100] += + s[58];
gout[n*243+101] += + s[59];
gout[n*243+102] += + s[138];
gout[n*243+103] += + s[139];
gout[n*243+104] += + s[140];
gout[n*243+105] += + s[219];
gout[n*243+106] += + s[220];
gout[n*243+107] += + s[221];
gout[n*243+108] += + s[12];
gout[n*243+109] += + s[13];
gout[n*243+110] += + s[14];
gout[n*243+111] += + s[93];
gout[n*243+112] += + s[94];
gout[n*243+113] += + s[95];
gout[n*243+114] += + s[174];
gout[n*243+115] += + s[175];
gout[n*243+116] += + s[176];
gout[n*243+117] += + s[39];
gout[n*243+118] += + s[40];
gout[n*243+119] += + s[41];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[201];
gout[n*243+124] += + s[202];
gout[n*243+125] += + s[203];
gout[n*243+126] += + s[66];
gout[n*243+127] += + s[67];
gout[n*243+128] += + s[68];
gout[n*243+129] += + s[147];
gout[n*243+130] += + s[148];
gout[n*243+131] += + s[149];
gout[n*243+132] += + s[228];
gout[n*243+133] += + s[229];
gout[n*243+134] += + s[230];
gout[n*243+135] += + s[21];
gout[n*243+136] += + s[22];
gout[n*243+137] += + s[23];
gout[n*243+138] += + s[102];
gout[n*243+139] += + s[103];
gout[n*243+140] += + s[104];
gout[n*243+141] += + s[183];
gout[n*243+142] += + s[184];
gout[n*243+143] += + s[185];
gout[n*243+144] += + s[48];
gout[n*243+145] += + s[49];
gout[n*243+146] += + s[50];
gout[n*243+147] += + s[129];
gout[n*243+148] += + s[130];
gout[n*243+149] += + s[131];
gout[n*243+150] += + s[210];
gout[n*243+151] += + s[211];
gout[n*243+152] += + s[212];
gout[n*243+153] += + s[75];
gout[n*243+154] += + s[76];
gout[n*243+155] += + s[77];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[237];
gout[n*243+160] += + s[238];
gout[n*243+161] += + s[239];
gout[n*243+162] += + s[6];
gout[n*243+163] += + s[7];
gout[n*243+164] += + s[8];
gout[n*243+165] += + s[87];
gout[n*243+166] += + s[88];
gout[n*243+167] += + s[89];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[33];
gout[n*243+172] += + s[34];
gout[n*243+173] += + s[35];
gout[n*243+174] += + s[114];
gout[n*243+175] += + s[115];
gout[n*243+176] += + s[116];
gout[n*243+177] += + s[195];
gout[n*243+178] += + s[196];
gout[n*243+179] += + s[197];
gout[n*243+180] += + s[60];
gout[n*243+181] += + s[61];
gout[n*243+182] += + s[62];
gout[n*243+183] += + s[141];
gout[n*243+184] += + s[142];
gout[n*243+185] += + s[143];
gout[n*243+186] += + s[222];
gout[n*243+187] += + s[223];
gout[n*243+188] += + s[224];
gout[n*243+189] += + s[15];
gout[n*243+190] += + s[16];
gout[n*243+191] += + s[17];
gout[n*243+192] += + s[96];
gout[n*243+193] += + s[97];
gout[n*243+194] += + s[98];
gout[n*243+195] += + s[177];
gout[n*243+196] += + s[178];
gout[n*243+197] += + s[179];
gout[n*243+198] += + s[42];
gout[n*243+199] += + s[43];
gout[n*243+200] += + s[44];
gout[n*243+201] += + s[123];
gout[n*243+202] += + s[124];
gout[n*243+203] += + s[125];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[69];
gout[n*243+208] += + s[70];
gout[n*243+209] += + s[71];
gout[n*243+210] += + s[150];
gout[n*243+211] += + s[151];
gout[n*243+212] += + s[152];
gout[n*243+213] += + s[231];
gout[n*243+214] += + s[232];
gout[n*243+215] += + s[233];
gout[n*243+216] += + s[24];
gout[n*243+217] += + s[25];
gout[n*243+218] += + s[26];
gout[n*243+219] += + s[105];
gout[n*243+220] += + s[106];
gout[n*243+221] += + s[107];
gout[n*243+222] += + s[186];
gout[n*243+223] += + s[187];
gout[n*243+224] += + s[188];
gout[n*243+225] += + s[51];
gout[n*243+226] += + s[52];
gout[n*243+227] += + s[53];
gout[n*243+228] += + s[132];
gout[n*243+229] += + s[133];
gout[n*243+230] += + s[134];
gout[n*243+231] += + s[213];
gout[n*243+232] += + s[214];
gout[n*243+233] += + s[215];
gout[n*243+234] += + s[78];
gout[n*243+235] += + s[79];
gout[n*243+236] += + s[80];
gout[n*243+237] += + s[159];
gout[n*243+238] += + s[160];
gout[n*243+239] += + s[161];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipipipm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipipm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipipm_cart
CACHE_SIZE_T int1e_ipipipipm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipipm_sph
CACHE_SIZE_T int1e_ipipipipm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipipm_spinor
ALL_CINT1E(int1e_ipipipipm)
ALL_CINT1E_FORTRAN_(int1e_ipipipipm)
/* <i|RI |NABLA j> */
void CINTgout1e_int1e_mip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[9];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_mip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mip_cart
CACHE_SIZE_T int1e_mip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mip_sph
CACHE_SIZE_T int1e_mip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mip_spinor
ALL_CINT1E(int1e_mip)
ALL_CINT1E_FORTRAN_(int1e_mip)
/* <i|RI |NABLA NABLA j> */
void CINTgout1e_int1e_mipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[27];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_mipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mipip_cart
CACHE_SIZE_T int1e_mipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mipip_sph
CACHE_SIZE_T int1e_mipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mipip_spinor
ALL_CINT1E(int1e_mipip)
ALL_CINT1E_FORTRAN_(int1e_mipip)
/* <i|RI |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_mipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_mipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mipipip_cart
CACHE_SIZE_T int1e_mipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mipipip_sph
CACHE_SIZE_T int1e_mipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mipipip_spinor
ALL_CINT1E(int1e_mipipip)
ALL_CINT1E_FORTRAN_(int1e_mipipip)
/* <i|RI |NABLA NABLA NABLA NABLA j> */
void CINTgout1e_int1e_mipipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_mipipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mipipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mipipipip_cart
CACHE_SIZE_T int1e_mipipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mipipipip_sph
CACHE_SIZE_T int1e_mipipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mipipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mipipipip_spinor
ALL_CINT1E(int1e_mipipipip)
ALL_CINT1E_FORTRAN_(int1e_mipipipip)
/* <NABLA i|RI |NABLA j> */
void CINTgout1e_int1e_ipmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[27];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_ipmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmip_cart
CACHE_SIZE_T int1e_ipmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmip_sph
CACHE_SIZE_T int1e_ipmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmip_spinor
ALL_CINT1E(int1e_ipmip)
ALL_CINT1E_FORTRAN_(int1e_ipmip)
/* <NABLA i|RI |NABLA NABLA j> */
void CINTgout1e_int1e_ipmipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipmipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmipip_cart
CACHE_SIZE_T int1e_ipmipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmipip_sph
CACHE_SIZE_T int1e_ipmipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmipip_spinor
ALL_CINT1E(int1e_ipmipip)
ALL_CINT1E_FORTRAN_(int1e_ipmipip)
/* <NABLA i|RI |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_ipmipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipmipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmipipip_cart
CACHE_SIZE_T int1e_ipmipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmipipip_sph
CACHE_SIZE_T int1e_ipmipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmipipip_spinor
ALL_CINT1E(int1e_ipmipipip)
ALL_CINT1E_FORTRAN_(int1e_ipmipipip)
/* <NABLA i|RI |NABLA NABLA NABLA NABLA j> */
void CINTgout1e_int1e_ipmipipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+1, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g24, g16, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipmipipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmipipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmipipipip_cart
CACHE_SIZE_T int1e_ipmipipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmipipipip_sph
CACHE_SIZE_T int1e_ipmipipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmipipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmipipipip_spinor
ALL_CINT1E(int1e_ipmipipipip)
ALL_CINT1E_FORTRAN_(int1e_ipmipipipip)
/* <NABLA NABLA i|RI |NABLA j> */
void CINTgout1e_int1e_ipipmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[27];
gout[n*81+10] = + s[28];
gout[n*81+11] = + s[29];
gout[n*81+12] = + s[30];
gout[n*81+13] = + s[31];
gout[n*81+14] = + s[32];
gout[n*81+15] = + s[33];
gout[n*81+16] = + s[34];
gout[n*81+17] = + s[35];
gout[n*81+18] = + s[54];
gout[n*81+19] = + s[55];
gout[n*81+20] = + s[56];
gout[n*81+21] = + s[57];
gout[n*81+22] = + s[58];
gout[n*81+23] = + s[59];
gout[n*81+24] = + s[60];
gout[n*81+25] = + s[61];
gout[n*81+26] = + s[62];
gout[n*81+27] = + s[9];
gout[n*81+28] = + s[10];
gout[n*81+29] = + s[11];
gout[n*81+30] = + s[12];
gout[n*81+31] = + s[13];
gout[n*81+32] = + s[14];
gout[n*81+33] = + s[15];
gout[n*81+34] = + s[16];
gout[n*81+35] = + s[17];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[63];
gout[n*81+46] = + s[64];
gout[n*81+47] = + s[65];
gout[n*81+48] = + s[66];
gout[n*81+49] = + s[67];
gout[n*81+50] = + s[68];
gout[n*81+51] = + s[69];
gout[n*81+52] = + s[70];
gout[n*81+53] = + s[71];
gout[n*81+54] = + s[18];
gout[n*81+55] = + s[19];
gout[n*81+56] = + s[20];
gout[n*81+57] = + s[21];
gout[n*81+58] = + s[22];
gout[n*81+59] = + s[23];
gout[n*81+60] = + s[24];
gout[n*81+61] = + s[25];
gout[n*81+62] = + s[26];
gout[n*81+63] = + s[45];
gout[n*81+64] = + s[46];
gout[n*81+65] = + s[47];
gout[n*81+66] = + s[48];
gout[n*81+67] = + s[49];
gout[n*81+68] = + s[50];
gout[n*81+69] = + s[51];
gout[n*81+70] = + s[52];
gout[n*81+71] = + s[53];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[27];
gout[n*81+10] += + s[28];
gout[n*81+11] += + s[29];
gout[n*81+12] += + s[30];
gout[n*81+13] += + s[31];
gout[n*81+14] += + s[32];
gout[n*81+15] += + s[33];
gout[n*81+16] += + s[34];
gout[n*81+17] += + s[35];
gout[n*81+18] += + s[54];
gout[n*81+19] += + s[55];
gout[n*81+20] += + s[56];
gout[n*81+21] += + s[57];
gout[n*81+22] += + s[58];
gout[n*81+23] += + s[59];
gout[n*81+24] += + s[60];
gout[n*81+25] += + s[61];
gout[n*81+26] += + s[62];
gout[n*81+27] += + s[9];
gout[n*81+28] += + s[10];
gout[n*81+29] += + s[11];
gout[n*81+30] += + s[12];
gout[n*81+31] += + s[13];
gout[n*81+32] += + s[14];
gout[n*81+33] += + s[15];
gout[n*81+34] += + s[16];
gout[n*81+35] += + s[17];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[63];
gout[n*81+46] += + s[64];
gout[n*81+47] += + s[65];
gout[n*81+48] += + s[66];
gout[n*81+49] += + s[67];
gout[n*81+50] += + s[68];
gout[n*81+51] += + s[69];
gout[n*81+52] += + s[70];
gout[n*81+53] += + s[71];
gout[n*81+54] += + s[18];
gout[n*81+55] += + s[19];
gout[n*81+56] += + s[20];
gout[n*81+57] += + s[21];
gout[n*81+58] += + s[22];
gout[n*81+59] += + s[23];
gout[n*81+60] += + s[24];
gout[n*81+61] += + s[25];
gout[n*81+62] += + s[26];
gout[n*81+63] += + s[45];
gout[n*81+64] += + s[46];
gout[n*81+65] += + s[47];
gout[n*81+66] += + s[48];
gout[n*81+67] += + s[49];
gout[n*81+68] += + s[50];
gout[n*81+69] += + s[51];
gout[n*81+70] += + s[52];
gout[n*81+71] += + s[53];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipipmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipmip_cart
CACHE_SIZE_T int1e_ipipmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipmip_sph
CACHE_SIZE_T int1e_ipipmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipmip_spinor
ALL_CINT1E(int1e_ipipmip)
ALL_CINT1E_FORTRAN_(int1e_ipipmip)
/* <NABLA NABLA NABLA i|RI |NABLA j> */
void CINTgout1e_int1e_ipipipmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[81];
gout[n*243+10] = + s[82];
gout[n*243+11] = + s[83];
gout[n*243+12] = + s[84];
gout[n*243+13] = + s[85];
gout[n*243+14] = + s[86];
gout[n*243+15] = + s[87];
gout[n*243+16] = + s[88];
gout[n*243+17] = + s[89];
gout[n*243+18] = + s[162];
gout[n*243+19] = + s[163];
gout[n*243+20] = + s[164];
gout[n*243+21] = + s[165];
gout[n*243+22] = + s[166];
gout[n*243+23] = + s[167];
gout[n*243+24] = + s[168];
gout[n*243+25] = + s[169];
gout[n*243+26] = + s[170];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[108];
gout[n*243+37] = + s[109];
gout[n*243+38] = + s[110];
gout[n*243+39] = + s[111];
gout[n*243+40] = + s[112];
gout[n*243+41] = + s[113];
gout[n*243+42] = + s[114];
gout[n*243+43] = + s[115];
gout[n*243+44] = + s[116];
gout[n*243+45] = + s[189];
gout[n*243+46] = + s[190];
gout[n*243+47] = + s[191];
gout[n*243+48] = + s[192];
gout[n*243+49] = + s[193];
gout[n*243+50] = + s[194];
gout[n*243+51] = + s[195];
gout[n*243+52] = + s[196];
gout[n*243+53] = + s[197];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[135];
gout[n*243+64] = + s[136];
gout[n*243+65] = + s[137];
gout[n*243+66] = + s[138];
gout[n*243+67] = + s[139];
gout[n*243+68] = + s[140];
gout[n*243+69] = + s[141];
gout[n*243+70] = + s[142];
gout[n*243+71] = + s[143];
gout[n*243+72] = + s[216];
gout[n*243+73] = + s[217];
gout[n*243+74] = + s[218];
gout[n*243+75] = + s[219];
gout[n*243+76] = + s[220];
gout[n*243+77] = + s[221];
gout[n*243+78] = + s[222];
gout[n*243+79] = + s[223];
gout[n*243+80] = + s[224];
gout[n*243+81] = + s[9];
gout[n*243+82] = + s[10];
gout[n*243+83] = + s[11];
gout[n*243+84] = + s[12];
gout[n*243+85] = + s[13];
gout[n*243+86] = + s[14];
gout[n*243+87] = + s[15];
gout[n*243+88] = + s[16];
gout[n*243+89] = + s[17];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[171];
gout[n*243+100] = + s[172];
gout[n*243+101] = + s[173];
gout[n*243+102] = + s[174];
gout[n*243+103] = + s[175];
gout[n*243+104] = + s[176];
gout[n*243+105] = + s[177];
gout[n*243+106] = + s[178];
gout[n*243+107] = + s[179];
gout[n*243+108] = + s[36];
gout[n*243+109] = + s[37];
gout[n*243+110] = + s[38];
gout[n*243+111] = + s[39];
gout[n*243+112] = + s[40];
gout[n*243+113] = + s[41];
gout[n*243+114] = + s[42];
gout[n*243+115] = + s[43];
gout[n*243+116] = + s[44];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[198];
gout[n*243+127] = + s[199];
gout[n*243+128] = + s[200];
gout[n*243+129] = + s[201];
gout[n*243+130] = + s[202];
gout[n*243+131] = + s[203];
gout[n*243+132] = + s[204];
gout[n*243+133] = + s[205];
gout[n*243+134] = + s[206];
gout[n*243+135] = + s[63];
gout[n*243+136] = + s[64];
gout[n*243+137] = + s[65];
gout[n*243+138] = + s[66];
gout[n*243+139] = + s[67];
gout[n*243+140] = + s[68];
gout[n*243+141] = + s[69];
gout[n*243+142] = + s[70];
gout[n*243+143] = + s[71];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[225];
gout[n*243+154] = + s[226];
gout[n*243+155] = + s[227];
gout[n*243+156] = + s[228];
gout[n*243+157] = + s[229];
gout[n*243+158] = + s[230];
gout[n*243+159] = + s[231];
gout[n*243+160] = + s[232];
gout[n*243+161] = + s[233];
gout[n*243+162] = + s[18];
gout[n*243+163] = + s[19];
gout[n*243+164] = + s[20];
gout[n*243+165] = + s[21];
gout[n*243+166] = + s[22];
gout[n*243+167] = + s[23];
gout[n*243+168] = + s[24];
gout[n*243+169] = + s[25];
gout[n*243+170] = + s[26];
gout[n*243+171] = + s[99];
gout[n*243+172] = + s[100];
gout[n*243+173] = + s[101];
gout[n*243+174] = + s[102];
gout[n*243+175] = + s[103];
gout[n*243+176] = + s[104];
gout[n*243+177] = + s[105];
gout[n*243+178] = + s[106];
gout[n*243+179] = + s[107];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[45];
gout[n*243+190] = + s[46];
gout[n*243+191] = + s[47];
gout[n*243+192] = + s[48];
gout[n*243+193] = + s[49];
gout[n*243+194] = + s[50];
gout[n*243+195] = + s[51];
gout[n*243+196] = + s[52];
gout[n*243+197] = + s[53];
gout[n*243+198] = + s[126];
gout[n*243+199] = + s[127];
gout[n*243+200] = + s[128];
gout[n*243+201] = + s[129];
gout[n*243+202] = + s[130];
gout[n*243+203] = + s[131];
gout[n*243+204] = + s[132];
gout[n*243+205] = + s[133];
gout[n*243+206] = + s[134];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[72];
gout[n*243+217] = + s[73];
gout[n*243+218] = + s[74];
gout[n*243+219] = + s[75];
gout[n*243+220] = + s[76];
gout[n*243+221] = + s[77];
gout[n*243+222] = + s[78];
gout[n*243+223] = + s[79];
gout[n*243+224] = + s[80];
gout[n*243+225] = + s[153];
gout[n*243+226] = + s[154];
gout[n*243+227] = + s[155];
gout[n*243+228] = + s[156];
gout[n*243+229] = + s[157];
gout[n*243+230] = + s[158];
gout[n*243+231] = + s[159];
gout[n*243+232] = + s[160];
gout[n*243+233] = + s[161];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[81];
gout[n*243+10] += + s[82];
gout[n*243+11] += + s[83];
gout[n*243+12] += + s[84];
gout[n*243+13] += + s[85];
gout[n*243+14] += + s[86];
gout[n*243+15] += + s[87];
gout[n*243+16] += + s[88];
gout[n*243+17] += + s[89];
gout[n*243+18] += + s[162];
gout[n*243+19] += + s[163];
gout[n*243+20] += + s[164];
gout[n*243+21] += + s[165];
gout[n*243+22] += + s[166];
gout[n*243+23] += + s[167];
gout[n*243+24] += + s[168];
gout[n*243+25] += + s[169];
gout[n*243+26] += + s[170];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[108];
gout[n*243+37] += + s[109];
gout[n*243+38] += + s[110];
gout[n*243+39] += + s[111];
gout[n*243+40] += + s[112];
gout[n*243+41] += + s[113];
gout[n*243+42] += + s[114];
gout[n*243+43] += + s[115];
gout[n*243+44] += + s[116];
gout[n*243+45] += + s[189];
gout[n*243+46] += + s[190];
gout[n*243+47] += + s[191];
gout[n*243+48] += + s[192];
gout[n*243+49] += + s[193];
gout[n*243+50] += + s[194];
gout[n*243+51] += + s[195];
gout[n*243+52] += + s[196];
gout[n*243+53] += + s[197];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[135];
gout[n*243+64] += + s[136];
gout[n*243+65] += + s[137];
gout[n*243+66] += + s[138];
gout[n*243+67] += + s[139];
gout[n*243+68] += + s[140];
gout[n*243+69] += + s[141];
gout[n*243+70] += + s[142];
gout[n*243+71] += + s[143];
gout[n*243+72] += + s[216];
gout[n*243+73] += + s[217];
gout[n*243+74] += + s[218];
gout[n*243+75] += + s[219];
gout[n*243+76] += + s[220];
gout[n*243+77] += + s[221];
gout[n*243+78] += + s[222];
gout[n*243+79] += + s[223];
gout[n*243+80] += + s[224];
gout[n*243+81] += + s[9];
gout[n*243+82] += + s[10];
gout[n*243+83] += + s[11];
gout[n*243+84] += + s[12];
gout[n*243+85] += + s[13];
gout[n*243+86] += + s[14];
gout[n*243+87] += + s[15];
gout[n*243+88] += + s[16];
gout[n*243+89] += + s[17];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[171];
gout[n*243+100] += + s[172];
gout[n*243+101] += + s[173];
gout[n*243+102] += + s[174];
gout[n*243+103] += + s[175];
gout[n*243+104] += + s[176];
gout[n*243+105] += + s[177];
gout[n*243+106] += + s[178];
gout[n*243+107] += + s[179];
gout[n*243+108] += + s[36];
gout[n*243+109] += + s[37];
gout[n*243+110] += + s[38];
gout[n*243+111] += + s[39];
gout[n*243+112] += + s[40];
gout[n*243+113] += + s[41];
gout[n*243+114] += + s[42];
gout[n*243+115] += + s[43];
gout[n*243+116] += + s[44];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[198];
gout[n*243+127] += + s[199];
gout[n*243+128] += + s[200];
gout[n*243+129] += + s[201];
gout[n*243+130] += + s[202];
gout[n*243+131] += + s[203];
gout[n*243+132] += + s[204];
gout[n*243+133] += + s[205];
gout[n*243+134] += + s[206];
gout[n*243+135] += + s[63];
gout[n*243+136] += + s[64];
gout[n*243+137] += + s[65];
gout[n*243+138] += + s[66];
gout[n*243+139] += + s[67];
gout[n*243+140] += + s[68];
gout[n*243+141] += + s[69];
gout[n*243+142] += + s[70];
gout[n*243+143] += + s[71];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[225];
gout[n*243+154] += + s[226];
gout[n*243+155] += + s[227];
gout[n*243+156] += + s[228];
gout[n*243+157] += + s[229];
gout[n*243+158] += + s[230];
gout[n*243+159] += + s[231];
gout[n*243+160] += + s[232];
gout[n*243+161] += + s[233];
gout[n*243+162] += + s[18];
gout[n*243+163] += + s[19];
gout[n*243+164] += + s[20];
gout[n*243+165] += + s[21];
gout[n*243+166] += + s[22];
gout[n*243+167] += + s[23];
gout[n*243+168] += + s[24];
gout[n*243+169] += + s[25];
gout[n*243+170] += + s[26];
gout[n*243+171] += + s[99];
gout[n*243+172] += + s[100];
gout[n*243+173] += + s[101];
gout[n*243+174] += + s[102];
gout[n*243+175] += + s[103];
gout[n*243+176] += + s[104];
gout[n*243+177] += + s[105];
gout[n*243+178] += + s[106];
gout[n*243+179] += + s[107];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[45];
gout[n*243+190] += + s[46];
gout[n*243+191] += + s[47];
gout[n*243+192] += + s[48];
gout[n*243+193] += + s[49];
gout[n*243+194] += + s[50];
gout[n*243+195] += + s[51];
gout[n*243+196] += + s[52];
gout[n*243+197] += + s[53];
gout[n*243+198] += + s[126];
gout[n*243+199] += + s[127];
gout[n*243+200] += + s[128];
gout[n*243+201] += + s[129];
gout[n*243+202] += + s[130];
gout[n*243+203] += + s[131];
gout[n*243+204] += + s[132];
gout[n*243+205] += + s[133];
gout[n*243+206] += + s[134];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[72];
gout[n*243+217] += + s[73];
gout[n*243+218] += + s[74];
gout[n*243+219] += + s[75];
gout[n*243+220] += + s[76];
gout[n*243+221] += + s[77];
gout[n*243+222] += + s[78];
gout[n*243+223] += + s[79];
gout[n*243+224] += + s[80];
gout[n*243+225] += + s[153];
gout[n*243+226] += + s[154];
gout[n*243+227] += + s[155];
gout[n*243+228] += + s[156];
gout[n*243+229] += + s[157];
gout[n*243+230] += + s[158];
gout[n*243+231] += + s[159];
gout[n*243+232] += + s[160];
gout[n*243+233] += + s[161];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipipmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipmip_cart
CACHE_SIZE_T int1e_ipipipmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipmip_sph
CACHE_SIZE_T int1e_ipipipmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipmip_spinor
ALL_CINT1E(int1e_ipipipmip)
ALL_CINT1E_FORTRAN_(int1e_ipipipmip)
/* <NABLA NABLA NABLA NABLA i|RI |NABLA j> */
void CINTgout1e_int1e_ipipipipmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+4, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+4, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[243];
gout[n*729+10] = + s[244];
gout[n*729+11] = + s[245];
gout[n*729+12] = + s[246];
gout[n*729+13] = + s[247];
gout[n*729+14] = + s[248];
gout[n*729+15] = + s[249];
gout[n*729+16] = + s[250];
gout[n*729+17] = + s[251];
gout[n*729+18] = + s[486];
gout[n*729+19] = + s[487];
gout[n*729+20] = + s[488];
gout[n*729+21] = + s[489];
gout[n*729+22] = + s[490];
gout[n*729+23] = + s[491];
gout[n*729+24] = + s[492];
gout[n*729+25] = + s[493];
gout[n*729+26] = + s[494];
gout[n*729+27] = + s[81];
gout[n*729+28] = + s[82];
gout[n*729+29] = + s[83];
gout[n*729+30] = + s[84];
gout[n*729+31] = + s[85];
gout[n*729+32] = + s[86];
gout[n*729+33] = + s[87];
gout[n*729+34] = + s[88];
gout[n*729+35] = + s[89];
gout[n*729+36] = + s[324];
gout[n*729+37] = + s[325];
gout[n*729+38] = + s[326];
gout[n*729+39] = + s[327];
gout[n*729+40] = + s[328];
gout[n*729+41] = + s[329];
gout[n*729+42] = + s[330];
gout[n*729+43] = + s[331];
gout[n*729+44] = + s[332];
gout[n*729+45] = + s[567];
gout[n*729+46] = + s[568];
gout[n*729+47] = + s[569];
gout[n*729+48] = + s[570];
gout[n*729+49] = + s[571];
gout[n*729+50] = + s[572];
gout[n*729+51] = + s[573];
gout[n*729+52] = + s[574];
gout[n*729+53] = + s[575];
gout[n*729+54] = + s[162];
gout[n*729+55] = + s[163];
gout[n*729+56] = + s[164];
gout[n*729+57] = + s[165];
gout[n*729+58] = + s[166];
gout[n*729+59] = + s[167];
gout[n*729+60] = + s[168];
gout[n*729+61] = + s[169];
gout[n*729+62] = + s[170];
gout[n*729+63] = + s[405];
gout[n*729+64] = + s[406];
gout[n*729+65] = + s[407];
gout[n*729+66] = + s[408];
gout[n*729+67] = + s[409];
gout[n*729+68] = + s[410];
gout[n*729+69] = + s[411];
gout[n*729+70] = + s[412];
gout[n*729+71] = + s[413];
gout[n*729+72] = + s[648];
gout[n*729+73] = + s[649];
gout[n*729+74] = + s[650];
gout[n*729+75] = + s[651];
gout[n*729+76] = + s[652];
gout[n*729+77] = + s[653];
gout[n*729+78] = + s[654];
gout[n*729+79] = + s[655];
gout[n*729+80] = + s[656];
gout[n*729+81] = + s[27];
gout[n*729+82] = + s[28];
gout[n*729+83] = + s[29];
gout[n*729+84] = + s[30];
gout[n*729+85] = + s[31];
gout[n*729+86] = + s[32];
gout[n*729+87] = + s[33];
gout[n*729+88] = + s[34];
gout[n*729+89] = + s[35];
gout[n*729+90] = + s[270];
gout[n*729+91] = + s[271];
gout[n*729+92] = + s[272];
gout[n*729+93] = + s[273];
gout[n*729+94] = + s[274];
gout[n*729+95] = + s[275];
gout[n*729+96] = + s[276];
gout[n*729+97] = + s[277];
gout[n*729+98] = + s[278];
gout[n*729+99] = + s[513];
gout[n*729+100] = + s[514];
gout[n*729+101] = + s[515];
gout[n*729+102] = + s[516];
gout[n*729+103] = + s[517];
gout[n*729+104] = + s[518];
gout[n*729+105] = + s[519];
gout[n*729+106] = + s[520];
gout[n*729+107] = + s[521];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[351];
gout[n*729+118] = + s[352];
gout[n*729+119] = + s[353];
gout[n*729+120] = + s[354];
gout[n*729+121] = + s[355];
gout[n*729+122] = + s[356];
gout[n*729+123] = + s[357];
gout[n*729+124] = + s[358];
gout[n*729+125] = + s[359];
gout[n*729+126] = + s[594];
gout[n*729+127] = + s[595];
gout[n*729+128] = + s[596];
gout[n*729+129] = + s[597];
gout[n*729+130] = + s[598];
gout[n*729+131] = + s[599];
gout[n*729+132] = + s[600];
gout[n*729+133] = + s[601];
gout[n*729+134] = + s[602];
gout[n*729+135] = + s[189];
gout[n*729+136] = + s[190];
gout[n*729+137] = + s[191];
gout[n*729+138] = + s[192];
gout[n*729+139] = + s[193];
gout[n*729+140] = + s[194];
gout[n*729+141] = + s[195];
gout[n*729+142] = + s[196];
gout[n*729+143] = + s[197];
gout[n*729+144] = + s[432];
gout[n*729+145] = + s[433];
gout[n*729+146] = + s[434];
gout[n*729+147] = + s[435];
gout[n*729+148] = + s[436];
gout[n*729+149] = + s[437];
gout[n*729+150] = + s[438];
gout[n*729+151] = + s[439];
gout[n*729+152] = + s[440];
gout[n*729+153] = + s[675];
gout[n*729+154] = + s[676];
gout[n*729+155] = + s[677];
gout[n*729+156] = + s[678];
gout[n*729+157] = + s[679];
gout[n*729+158] = + s[680];
gout[n*729+159] = + s[681];
gout[n*729+160] = + s[682];
gout[n*729+161] = + s[683];
gout[n*729+162] = + s[54];
gout[n*729+163] = + s[55];
gout[n*729+164] = + s[56];
gout[n*729+165] = + s[57];
gout[n*729+166] = + s[58];
gout[n*729+167] = + s[59];
gout[n*729+168] = + s[60];
gout[n*729+169] = + s[61];
gout[n*729+170] = + s[62];
gout[n*729+171] = + s[297];
gout[n*729+172] = + s[298];
gout[n*729+173] = + s[299];
gout[n*729+174] = + s[300];
gout[n*729+175] = + s[301];
gout[n*729+176] = + s[302];
gout[n*729+177] = + s[303];
gout[n*729+178] = + s[304];
gout[n*729+179] = + s[305];
gout[n*729+180] = + s[540];
gout[n*729+181] = + s[541];
gout[n*729+182] = + s[542];
gout[n*729+183] = + s[543];
gout[n*729+184] = + s[544];
gout[n*729+185] = + s[545];
gout[n*729+186] = + s[546];
gout[n*729+187] = + s[547];
gout[n*729+188] = + s[548];
gout[n*729+189] = + s[135];
gout[n*729+190] = + s[136];
gout[n*729+191] = + s[137];
gout[n*729+192] = + s[138];
gout[n*729+193] = + s[139];
gout[n*729+194] = + s[140];
gout[n*729+195] = + s[141];
gout[n*729+196] = + s[142];
gout[n*729+197] = + s[143];
gout[n*729+198] = + s[378];
gout[n*729+199] = + s[379];
gout[n*729+200] = + s[380];
gout[n*729+201] = + s[381];
gout[n*729+202] = + s[382];
gout[n*729+203] = + s[383];
gout[n*729+204] = + s[384];
gout[n*729+205] = + s[385];
gout[n*729+206] = + s[386];
gout[n*729+207] = + s[621];
gout[n*729+208] = + s[622];
gout[n*729+209] = + s[623];
gout[n*729+210] = + s[624];
gout[n*729+211] = + s[625];
gout[n*729+212] = + s[626];
gout[n*729+213] = + s[627];
gout[n*729+214] = + s[628];
gout[n*729+215] = + s[629];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[459];
gout[n*729+226] = + s[460];
gout[n*729+227] = + s[461];
gout[n*729+228] = + s[462];
gout[n*729+229] = + s[463];
gout[n*729+230] = + s[464];
gout[n*729+231] = + s[465];
gout[n*729+232] = + s[466];
gout[n*729+233] = + s[467];
gout[n*729+234] = + s[702];
gout[n*729+235] = + s[703];
gout[n*729+236] = + s[704];
gout[n*729+237] = + s[705];
gout[n*729+238] = + s[706];
gout[n*729+239] = + s[707];
gout[n*729+240] = + s[708];
gout[n*729+241] = + s[709];
gout[n*729+242] = + s[710];
gout[n*729+243] = + s[9];
gout[n*729+244] = + s[10];
gout[n*729+245] = + s[11];
gout[n*729+246] = + s[12];
gout[n*729+247] = + s[13];
gout[n*729+248] = + s[14];
gout[n*729+249] = + s[15];
gout[n*729+250] = + s[16];
gout[n*729+251] = + s[17];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[495];
gout[n*729+262] = + s[496];
gout[n*729+263] = + s[497];
gout[n*729+264] = + s[498];
gout[n*729+265] = + s[499];
gout[n*729+266] = + s[500];
gout[n*729+267] = + s[501];
gout[n*729+268] = + s[502];
gout[n*729+269] = + s[503];
gout[n*729+270] = + s[90];
gout[n*729+271] = + s[91];
gout[n*729+272] = + s[92];
gout[n*729+273] = + s[93];
gout[n*729+274] = + s[94];
gout[n*729+275] = + s[95];
gout[n*729+276] = + s[96];
gout[n*729+277] = + s[97];
gout[n*729+278] = + s[98];
gout[n*729+279] = + s[333];
gout[n*729+280] = + s[334];
gout[n*729+281] = + s[335];
gout[n*729+282] = + s[336];
gout[n*729+283] = + s[337];
gout[n*729+284] = + s[338];
gout[n*729+285] = + s[339];
gout[n*729+286] = + s[340];
gout[n*729+287] = + s[341];
gout[n*729+288] = + s[576];
gout[n*729+289] = + s[577];
gout[n*729+290] = + s[578];
gout[n*729+291] = + s[579];
gout[n*729+292] = + s[580];
gout[n*729+293] = + s[581];
gout[n*729+294] = + s[582];
gout[n*729+295] = + s[583];
gout[n*729+296] = + s[584];
gout[n*729+297] = + s[171];
gout[n*729+298] = + s[172];
gout[n*729+299] = + s[173];
gout[n*729+300] = + s[174];
gout[n*729+301] = + s[175];
gout[n*729+302] = + s[176];
gout[n*729+303] = + s[177];
gout[n*729+304] = + s[178];
gout[n*729+305] = + s[179];
gout[n*729+306] = + s[414];
gout[n*729+307] = + s[415];
gout[n*729+308] = + s[416];
gout[n*729+309] = + s[417];
gout[n*729+310] = + s[418];
gout[n*729+311] = + s[419];
gout[n*729+312] = + s[420];
gout[n*729+313] = + s[421];
gout[n*729+314] = + s[422];
gout[n*729+315] = + s[657];
gout[n*729+316] = + s[658];
gout[n*729+317] = + s[659];
gout[n*729+318] = + s[660];
gout[n*729+319] = + s[661];
gout[n*729+320] = + s[662];
gout[n*729+321] = + s[663];
gout[n*729+322] = + s[664];
gout[n*729+323] = + s[665];
gout[n*729+324] = + s[36];
gout[n*729+325] = + s[37];
gout[n*729+326] = + s[38];
gout[n*729+327] = + s[39];
gout[n*729+328] = + s[40];
gout[n*729+329] = + s[41];
gout[n*729+330] = + s[42];
gout[n*729+331] = + s[43];
gout[n*729+332] = + s[44];
gout[n*729+333] = + s[279];
gout[n*729+334] = + s[280];
gout[n*729+335] = + s[281];
gout[n*729+336] = + s[282];
gout[n*729+337] = + s[283];
gout[n*729+338] = + s[284];
gout[n*729+339] = + s[285];
gout[n*729+340] = + s[286];
gout[n*729+341] = + s[287];
gout[n*729+342] = + s[522];
gout[n*729+343] = + s[523];
gout[n*729+344] = + s[524];
gout[n*729+345] = + s[525];
gout[n*729+346] = + s[526];
gout[n*729+347] = + s[527];
gout[n*729+348] = + s[528];
gout[n*729+349] = + s[529];
gout[n*729+350] = + s[530];
gout[n*729+351] = + s[117];
gout[n*729+352] = + s[118];
gout[n*729+353] = + s[119];
gout[n*729+354] = + s[120];
gout[n*729+355] = + s[121];
gout[n*729+356] = + s[122];
gout[n*729+357] = + s[123];
gout[n*729+358] = + s[124];
gout[n*729+359] = + s[125];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[603];
gout[n*729+370] = + s[604];
gout[n*729+371] = + s[605];
gout[n*729+372] = + s[606];
gout[n*729+373] = + s[607];
gout[n*729+374] = + s[608];
gout[n*729+375] = + s[609];
gout[n*729+376] = + s[610];
gout[n*729+377] = + s[611];
gout[n*729+378] = + s[198];
gout[n*729+379] = + s[199];
gout[n*729+380] = + s[200];
gout[n*729+381] = + s[201];
gout[n*729+382] = + s[202];
gout[n*729+383] = + s[203];
gout[n*729+384] = + s[204];
gout[n*729+385] = + s[205];
gout[n*729+386] = + s[206];
gout[n*729+387] = + s[441];
gout[n*729+388] = + s[442];
gout[n*729+389] = + s[443];
gout[n*729+390] = + s[444];
gout[n*729+391] = + s[445];
gout[n*729+392] = + s[446];
gout[n*729+393] = + s[447];
gout[n*729+394] = + s[448];
gout[n*729+395] = + s[449];
gout[n*729+396] = + s[684];
gout[n*729+397] = + s[685];
gout[n*729+398] = + s[686];
gout[n*729+399] = + s[687];
gout[n*729+400] = + s[688];
gout[n*729+401] = + s[689];
gout[n*729+402] = + s[690];
gout[n*729+403] = + s[691];
gout[n*729+404] = + s[692];
gout[n*729+405] = + s[63];
gout[n*729+406] = + s[64];
gout[n*729+407] = + s[65];
gout[n*729+408] = + s[66];
gout[n*729+409] = + s[67];
gout[n*729+410] = + s[68];
gout[n*729+411] = + s[69];
gout[n*729+412] = + s[70];
gout[n*729+413] = + s[71];
gout[n*729+414] = + s[306];
gout[n*729+415] = + s[307];
gout[n*729+416] = + s[308];
gout[n*729+417] = + s[309];
gout[n*729+418] = + s[310];
gout[n*729+419] = + s[311];
gout[n*729+420] = + s[312];
gout[n*729+421] = + s[313];
gout[n*729+422] = + s[314];
gout[n*729+423] = + s[549];
gout[n*729+424] = + s[550];
gout[n*729+425] = + s[551];
gout[n*729+426] = + s[552];
gout[n*729+427] = + s[553];
gout[n*729+428] = + s[554];
gout[n*729+429] = + s[555];
gout[n*729+430] = + s[556];
gout[n*729+431] = + s[557];
gout[n*729+432] = + s[144];
gout[n*729+433] = + s[145];
gout[n*729+434] = + s[146];
gout[n*729+435] = + s[147];
gout[n*729+436] = + s[148];
gout[n*729+437] = + s[149];
gout[n*729+438] = + s[150];
gout[n*729+439] = + s[151];
gout[n*729+440] = + s[152];
gout[n*729+441] = + s[387];
gout[n*729+442] = + s[388];
gout[n*729+443] = + s[389];
gout[n*729+444] = + s[390];
gout[n*729+445] = + s[391];
gout[n*729+446] = + s[392];
gout[n*729+447] = + s[393];
gout[n*729+448] = + s[394];
gout[n*729+449] = + s[395];
gout[n*729+450] = + s[630];
gout[n*729+451] = + s[631];
gout[n*729+452] = + s[632];
gout[n*729+453] = + s[633];
gout[n*729+454] = + s[634];
gout[n*729+455] = + s[635];
gout[n*729+456] = + s[636];
gout[n*729+457] = + s[637];
gout[n*729+458] = + s[638];
gout[n*729+459] = + s[225];
gout[n*729+460] = + s[226];
gout[n*729+461] = + s[227];
gout[n*729+462] = + s[228];
gout[n*729+463] = + s[229];
gout[n*729+464] = + s[230];
gout[n*729+465] = + s[231];
gout[n*729+466] = + s[232];
gout[n*729+467] = + s[233];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[711];
gout[n*729+478] = + s[712];
gout[n*729+479] = + s[713];
gout[n*729+480] = + s[714];
gout[n*729+481] = + s[715];
gout[n*729+482] = + s[716];
gout[n*729+483] = + s[717];
gout[n*729+484] = + s[718];
gout[n*729+485] = + s[719];
gout[n*729+486] = + s[18];
gout[n*729+487] = + s[19];
gout[n*729+488] = + s[20];
gout[n*729+489] = + s[21];
gout[n*729+490] = + s[22];
gout[n*729+491] = + s[23];
gout[n*729+492] = + s[24];
gout[n*729+493] = + s[25];
gout[n*729+494] = + s[26];
gout[n*729+495] = + s[261];
gout[n*729+496] = + s[262];
gout[n*729+497] = + s[263];
gout[n*729+498] = + s[264];
gout[n*729+499] = + s[265];
gout[n*729+500] = + s[266];
gout[n*729+501] = + s[267];
gout[n*729+502] = + s[268];
gout[n*729+503] = + s[269];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[99];
gout[n*729+514] = + s[100];
gout[n*729+515] = + s[101];
gout[n*729+516] = + s[102];
gout[n*729+517] = + s[103];
gout[n*729+518] = + s[104];
gout[n*729+519] = + s[105];
gout[n*729+520] = + s[106];
gout[n*729+521] = + s[107];
gout[n*729+522] = + s[342];
gout[n*729+523] = + s[343];
gout[n*729+524] = + s[344];
gout[n*729+525] = + s[345];
gout[n*729+526] = + s[346];
gout[n*729+527] = + s[347];
gout[n*729+528] = + s[348];
gout[n*729+529] = + s[349];
gout[n*729+530] = + s[350];
gout[n*729+531] = + s[585];
gout[n*729+532] = + s[586];
gout[n*729+533] = + s[587];
gout[n*729+534] = + s[588];
gout[n*729+535] = + s[589];
gout[n*729+536] = + s[590];
gout[n*729+537] = + s[591];
gout[n*729+538] = + s[592];
gout[n*729+539] = + s[593];
gout[n*729+540] = + s[180];
gout[n*729+541] = + s[181];
gout[n*729+542] = + s[182];
gout[n*729+543] = + s[183];
gout[n*729+544] = + s[184];
gout[n*729+545] = + s[185];
gout[n*729+546] = + s[186];
gout[n*729+547] = + s[187];
gout[n*729+548] = + s[188];
gout[n*729+549] = + s[423];
gout[n*729+550] = + s[424];
gout[n*729+551] = + s[425];
gout[n*729+552] = + s[426];
gout[n*729+553] = + s[427];
gout[n*729+554] = + s[428];
gout[n*729+555] = + s[429];
gout[n*729+556] = + s[430];
gout[n*729+557] = + s[431];
gout[n*729+558] = + s[666];
gout[n*729+559] = + s[667];
gout[n*729+560] = + s[668];
gout[n*729+561] = + s[669];
gout[n*729+562] = + s[670];
gout[n*729+563] = + s[671];
gout[n*729+564] = + s[672];
gout[n*729+565] = + s[673];
gout[n*729+566] = + s[674];
gout[n*729+567] = + s[45];
gout[n*729+568] = + s[46];
gout[n*729+569] = + s[47];
gout[n*729+570] = + s[48];
gout[n*729+571] = + s[49];
gout[n*729+572] = + s[50];
gout[n*729+573] = + s[51];
gout[n*729+574] = + s[52];
gout[n*729+575] = + s[53];
gout[n*729+576] = + s[288];
gout[n*729+577] = + s[289];
gout[n*729+578] = + s[290];
gout[n*729+579] = + s[291];
gout[n*729+580] = + s[292];
gout[n*729+581] = + s[293];
gout[n*729+582] = + s[294];
gout[n*729+583] = + s[295];
gout[n*729+584] = + s[296];
gout[n*729+585] = + s[531];
gout[n*729+586] = + s[532];
gout[n*729+587] = + s[533];
gout[n*729+588] = + s[534];
gout[n*729+589] = + s[535];
gout[n*729+590] = + s[536];
gout[n*729+591] = + s[537];
gout[n*729+592] = + s[538];
gout[n*729+593] = + s[539];
gout[n*729+594] = + s[126];
gout[n*729+595] = + s[127];
gout[n*729+596] = + s[128];
gout[n*729+597] = + s[129];
gout[n*729+598] = + s[130];
gout[n*729+599] = + s[131];
gout[n*729+600] = + s[132];
gout[n*729+601] = + s[133];
gout[n*729+602] = + s[134];
gout[n*729+603] = + s[369];
gout[n*729+604] = + s[370];
gout[n*729+605] = + s[371];
gout[n*729+606] = + s[372];
gout[n*729+607] = + s[373];
gout[n*729+608] = + s[374];
gout[n*729+609] = + s[375];
gout[n*729+610] = + s[376];
gout[n*729+611] = + s[377];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[207];
gout[n*729+622] = + s[208];
gout[n*729+623] = + s[209];
gout[n*729+624] = + s[210];
gout[n*729+625] = + s[211];
gout[n*729+626] = + s[212];
gout[n*729+627] = + s[213];
gout[n*729+628] = + s[214];
gout[n*729+629] = + s[215];
gout[n*729+630] = + s[450];
gout[n*729+631] = + s[451];
gout[n*729+632] = + s[452];
gout[n*729+633] = + s[453];
gout[n*729+634] = + s[454];
gout[n*729+635] = + s[455];
gout[n*729+636] = + s[456];
gout[n*729+637] = + s[457];
gout[n*729+638] = + s[458];
gout[n*729+639] = + s[693];
gout[n*729+640] = + s[694];
gout[n*729+641] = + s[695];
gout[n*729+642] = + s[696];
gout[n*729+643] = + s[697];
gout[n*729+644] = + s[698];
gout[n*729+645] = + s[699];
gout[n*729+646] = + s[700];
gout[n*729+647] = + s[701];
gout[n*729+648] = + s[72];
gout[n*729+649] = + s[73];
gout[n*729+650] = + s[74];
gout[n*729+651] = + s[75];
gout[n*729+652] = + s[76];
gout[n*729+653] = + s[77];
gout[n*729+654] = + s[78];
gout[n*729+655] = + s[79];
gout[n*729+656] = + s[80];
gout[n*729+657] = + s[315];
gout[n*729+658] = + s[316];
gout[n*729+659] = + s[317];
gout[n*729+660] = + s[318];
gout[n*729+661] = + s[319];
gout[n*729+662] = + s[320];
gout[n*729+663] = + s[321];
gout[n*729+664] = + s[322];
gout[n*729+665] = + s[323];
gout[n*729+666] = + s[558];
gout[n*729+667] = + s[559];
gout[n*729+668] = + s[560];
gout[n*729+669] = + s[561];
gout[n*729+670] = + s[562];
gout[n*729+671] = + s[563];
gout[n*729+672] = + s[564];
gout[n*729+673] = + s[565];
gout[n*729+674] = + s[566];
gout[n*729+675] = + s[153];
gout[n*729+676] = + s[154];
gout[n*729+677] = + s[155];
gout[n*729+678] = + s[156];
gout[n*729+679] = + s[157];
gout[n*729+680] = + s[158];
gout[n*729+681] = + s[159];
gout[n*729+682] = + s[160];
gout[n*729+683] = + s[161];
gout[n*729+684] = + s[396];
gout[n*729+685] = + s[397];
gout[n*729+686] = + s[398];
gout[n*729+687] = + s[399];
gout[n*729+688] = + s[400];
gout[n*729+689] = + s[401];
gout[n*729+690] = + s[402];
gout[n*729+691] = + s[403];
gout[n*729+692] = + s[404];
gout[n*729+693] = + s[639];
gout[n*729+694] = + s[640];
gout[n*729+695] = + s[641];
gout[n*729+696] = + s[642];
gout[n*729+697] = + s[643];
gout[n*729+698] = + s[644];
gout[n*729+699] = + s[645];
gout[n*729+700] = + s[646];
gout[n*729+701] = + s[647];
gout[n*729+702] = + s[234];
gout[n*729+703] = + s[235];
gout[n*729+704] = + s[236];
gout[n*729+705] = + s[237];
gout[n*729+706] = + s[238];
gout[n*729+707] = + s[239];
gout[n*729+708] = + s[240];
gout[n*729+709] = + s[241];
gout[n*729+710] = + s[242];
gout[n*729+711] = + s[477];
gout[n*729+712] = + s[478];
gout[n*729+713] = + s[479];
gout[n*729+714] = + s[480];
gout[n*729+715] = + s[481];
gout[n*729+716] = + s[482];
gout[n*729+717] = + s[483];
gout[n*729+718] = + s[484];
gout[n*729+719] = + s[485];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[243];
gout[n*729+10] += + s[244];
gout[n*729+11] += + s[245];
gout[n*729+12] += + s[246];
gout[n*729+13] += + s[247];
gout[n*729+14] += + s[248];
gout[n*729+15] += + s[249];
gout[n*729+16] += + s[250];
gout[n*729+17] += + s[251];
gout[n*729+18] += + s[486];
gout[n*729+19] += + s[487];
gout[n*729+20] += + s[488];
gout[n*729+21] += + s[489];
gout[n*729+22] += + s[490];
gout[n*729+23] += + s[491];
gout[n*729+24] += + s[492];
gout[n*729+25] += + s[493];
gout[n*729+26] += + s[494];
gout[n*729+27] += + s[81];
gout[n*729+28] += + s[82];
gout[n*729+29] += + s[83];
gout[n*729+30] += + s[84];
gout[n*729+31] += + s[85];
gout[n*729+32] += + s[86];
gout[n*729+33] += + s[87];
gout[n*729+34] += + s[88];
gout[n*729+35] += + s[89];
gout[n*729+36] += + s[324];
gout[n*729+37] += + s[325];
gout[n*729+38] += + s[326];
gout[n*729+39] += + s[327];
gout[n*729+40] += + s[328];
gout[n*729+41] += + s[329];
gout[n*729+42] += + s[330];
gout[n*729+43] += + s[331];
gout[n*729+44] += + s[332];
gout[n*729+45] += + s[567];
gout[n*729+46] += + s[568];
gout[n*729+47] += + s[569];
gout[n*729+48] += + s[570];
gout[n*729+49] += + s[571];
gout[n*729+50] += + s[572];
gout[n*729+51] += + s[573];
gout[n*729+52] += + s[574];
gout[n*729+53] += + s[575];
gout[n*729+54] += + s[162];
gout[n*729+55] += + s[163];
gout[n*729+56] += + s[164];
gout[n*729+57] += + s[165];
gout[n*729+58] += + s[166];
gout[n*729+59] += + s[167];
gout[n*729+60] += + s[168];
gout[n*729+61] += + s[169];
gout[n*729+62] += + s[170];
gout[n*729+63] += + s[405];
gout[n*729+64] += + s[406];
gout[n*729+65] += + s[407];
gout[n*729+66] += + s[408];
gout[n*729+67] += + s[409];
gout[n*729+68] += + s[410];
gout[n*729+69] += + s[411];
gout[n*729+70] += + s[412];
gout[n*729+71] += + s[413];
gout[n*729+72] += + s[648];
gout[n*729+73] += + s[649];
gout[n*729+74] += + s[650];
gout[n*729+75] += + s[651];
gout[n*729+76] += + s[652];
gout[n*729+77] += + s[653];
gout[n*729+78] += + s[654];
gout[n*729+79] += + s[655];
gout[n*729+80] += + s[656];
gout[n*729+81] += + s[27];
gout[n*729+82] += + s[28];
gout[n*729+83] += + s[29];
gout[n*729+84] += + s[30];
gout[n*729+85] += + s[31];
gout[n*729+86] += + s[32];
gout[n*729+87] += + s[33];
gout[n*729+88] += + s[34];
gout[n*729+89] += + s[35];
gout[n*729+90] += + s[270];
gout[n*729+91] += + s[271];
gout[n*729+92] += + s[272];
gout[n*729+93] += + s[273];
gout[n*729+94] += + s[274];
gout[n*729+95] += + s[275];
gout[n*729+96] += + s[276];
gout[n*729+97] += + s[277];
gout[n*729+98] += + s[278];
gout[n*729+99] += + s[513];
gout[n*729+100] += + s[514];
gout[n*729+101] += + s[515];
gout[n*729+102] += + s[516];
gout[n*729+103] += + s[517];
gout[n*729+104] += + s[518];
gout[n*729+105] += + s[519];
gout[n*729+106] += + s[520];
gout[n*729+107] += + s[521];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[351];
gout[n*729+118] += + s[352];
gout[n*729+119] += + s[353];
gout[n*729+120] += + s[354];
gout[n*729+121] += + s[355];
gout[n*729+122] += + s[356];
gout[n*729+123] += + s[357];
gout[n*729+124] += + s[358];
gout[n*729+125] += + s[359];
gout[n*729+126] += + s[594];
gout[n*729+127] += + s[595];
gout[n*729+128] += + s[596];
gout[n*729+129] += + s[597];
gout[n*729+130] += + s[598];
gout[n*729+131] += + s[599];
gout[n*729+132] += + s[600];
gout[n*729+133] += + s[601];
gout[n*729+134] += + s[602];
gout[n*729+135] += + s[189];
gout[n*729+136] += + s[190];
gout[n*729+137] += + s[191];
gout[n*729+138] += + s[192];
gout[n*729+139] += + s[193];
gout[n*729+140] += + s[194];
gout[n*729+141] += + s[195];
gout[n*729+142] += + s[196];
gout[n*729+143] += + s[197];
gout[n*729+144] += + s[432];
gout[n*729+145] += + s[433];
gout[n*729+146] += + s[434];
gout[n*729+147] += + s[435];
gout[n*729+148] += + s[436];
gout[n*729+149] += + s[437];
gout[n*729+150] += + s[438];
gout[n*729+151] += + s[439];
gout[n*729+152] += + s[440];
gout[n*729+153] += + s[675];
gout[n*729+154] += + s[676];
gout[n*729+155] += + s[677];
gout[n*729+156] += + s[678];
gout[n*729+157] += + s[679];
gout[n*729+158] += + s[680];
gout[n*729+159] += + s[681];
gout[n*729+160] += + s[682];
gout[n*729+161] += + s[683];
gout[n*729+162] += + s[54];
gout[n*729+163] += + s[55];
gout[n*729+164] += + s[56];
gout[n*729+165] += + s[57];
gout[n*729+166] += + s[58];
gout[n*729+167] += + s[59];
gout[n*729+168] += + s[60];
gout[n*729+169] += + s[61];
gout[n*729+170] += + s[62];
gout[n*729+171] += + s[297];
gout[n*729+172] += + s[298];
gout[n*729+173] += + s[299];
gout[n*729+174] += + s[300];
gout[n*729+175] += + s[301];
gout[n*729+176] += + s[302];
gout[n*729+177] += + s[303];
gout[n*729+178] += + s[304];
gout[n*729+179] += + s[305];
gout[n*729+180] += + s[540];
gout[n*729+181] += + s[541];
gout[n*729+182] += + s[542];
gout[n*729+183] += + s[543];
gout[n*729+184] += + s[544];
gout[n*729+185] += + s[545];
gout[n*729+186] += + s[546];
gout[n*729+187] += + s[547];
gout[n*729+188] += + s[548];
gout[n*729+189] += + s[135];
gout[n*729+190] += + s[136];
gout[n*729+191] += + s[137];
gout[n*729+192] += + s[138];
gout[n*729+193] += + s[139];
gout[n*729+194] += + s[140];
gout[n*729+195] += + s[141];
gout[n*729+196] += + s[142];
gout[n*729+197] += + s[143];
gout[n*729+198] += + s[378];
gout[n*729+199] += + s[379];
gout[n*729+200] += + s[380];
gout[n*729+201] += + s[381];
gout[n*729+202] += + s[382];
gout[n*729+203] += + s[383];
gout[n*729+204] += + s[384];
gout[n*729+205] += + s[385];
gout[n*729+206] += + s[386];
gout[n*729+207] += + s[621];
gout[n*729+208] += + s[622];
gout[n*729+209] += + s[623];
gout[n*729+210] += + s[624];
gout[n*729+211] += + s[625];
gout[n*729+212] += + s[626];
gout[n*729+213] += + s[627];
gout[n*729+214] += + s[628];
gout[n*729+215] += + s[629];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[459];
gout[n*729+226] += + s[460];
gout[n*729+227] += + s[461];
gout[n*729+228] += + s[462];
gout[n*729+229] += + s[463];
gout[n*729+230] += + s[464];
gout[n*729+231] += + s[465];
gout[n*729+232] += + s[466];
gout[n*729+233] += + s[467];
gout[n*729+234] += + s[702];
gout[n*729+235] += + s[703];
gout[n*729+236] += + s[704];
gout[n*729+237] += + s[705];
gout[n*729+238] += + s[706];
gout[n*729+239] += + s[707];
gout[n*729+240] += + s[708];
gout[n*729+241] += + s[709];
gout[n*729+242] += + s[710];
gout[n*729+243] += + s[9];
gout[n*729+244] += + s[10];
gout[n*729+245] += + s[11];
gout[n*729+246] += + s[12];
gout[n*729+247] += + s[13];
gout[n*729+248] += + s[14];
gout[n*729+249] += + s[15];
gout[n*729+250] += + s[16];
gout[n*729+251] += + s[17];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[495];
gout[n*729+262] += + s[496];
gout[n*729+263] += + s[497];
gout[n*729+264] += + s[498];
gout[n*729+265] += + s[499];
gout[n*729+266] += + s[500];
gout[n*729+267] += + s[501];
gout[n*729+268] += + s[502];
gout[n*729+269] += + s[503];
gout[n*729+270] += + s[90];
gout[n*729+271] += + s[91];
gout[n*729+272] += + s[92];
gout[n*729+273] += + s[93];
gout[n*729+274] += + s[94];
gout[n*729+275] += + s[95];
gout[n*729+276] += + s[96];
gout[n*729+277] += + s[97];
gout[n*729+278] += + s[98];
gout[n*729+279] += + s[333];
gout[n*729+280] += + s[334];
gout[n*729+281] += + s[335];
gout[n*729+282] += + s[336];
gout[n*729+283] += + s[337];
gout[n*729+284] += + s[338];
gout[n*729+285] += + s[339];
gout[n*729+286] += + s[340];
gout[n*729+287] += + s[341];
gout[n*729+288] += + s[576];
gout[n*729+289] += + s[577];
gout[n*729+290] += + s[578];
gout[n*729+291] += + s[579];
gout[n*729+292] += + s[580];
gout[n*729+293] += + s[581];
gout[n*729+294] += + s[582];
gout[n*729+295] += + s[583];
gout[n*729+296] += + s[584];
gout[n*729+297] += + s[171];
gout[n*729+298] += + s[172];
gout[n*729+299] += + s[173];
gout[n*729+300] += + s[174];
gout[n*729+301] += + s[175];
gout[n*729+302] += + s[176];
gout[n*729+303] += + s[177];
gout[n*729+304] += + s[178];
gout[n*729+305] += + s[179];
gout[n*729+306] += + s[414];
gout[n*729+307] += + s[415];
gout[n*729+308] += + s[416];
gout[n*729+309] += + s[417];
gout[n*729+310] += + s[418];
gout[n*729+311] += + s[419];
gout[n*729+312] += + s[420];
gout[n*729+313] += + s[421];
gout[n*729+314] += + s[422];
gout[n*729+315] += + s[657];
gout[n*729+316] += + s[658];
gout[n*729+317] += + s[659];
gout[n*729+318] += + s[660];
gout[n*729+319] += + s[661];
gout[n*729+320] += + s[662];
gout[n*729+321] += + s[663];
gout[n*729+322] += + s[664];
gout[n*729+323] += + s[665];
gout[n*729+324] += + s[36];
gout[n*729+325] += + s[37];
gout[n*729+326] += + s[38];
gout[n*729+327] += + s[39];
gout[n*729+328] += + s[40];
gout[n*729+329] += + s[41];
gout[n*729+330] += + s[42];
gout[n*729+331] += + s[43];
gout[n*729+332] += + s[44];
gout[n*729+333] += + s[279];
gout[n*729+334] += + s[280];
gout[n*729+335] += + s[281];
gout[n*729+336] += + s[282];
gout[n*729+337] += + s[283];
gout[n*729+338] += + s[284];
gout[n*729+339] += + s[285];
gout[n*729+340] += + s[286];
gout[n*729+341] += + s[287];
gout[n*729+342] += + s[522];
gout[n*729+343] += + s[523];
gout[n*729+344] += + s[524];
gout[n*729+345] += + s[525];
gout[n*729+346] += + s[526];
gout[n*729+347] += + s[527];
gout[n*729+348] += + s[528];
gout[n*729+349] += + s[529];
gout[n*729+350] += + s[530];
gout[n*729+351] += + s[117];
gout[n*729+352] += + s[118];
gout[n*729+353] += + s[119];
gout[n*729+354] += + s[120];
gout[n*729+355] += + s[121];
gout[n*729+356] += + s[122];
gout[n*729+357] += + s[123];
gout[n*729+358] += + s[124];
gout[n*729+359] += + s[125];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[603];
gout[n*729+370] += + s[604];
gout[n*729+371] += + s[605];
gout[n*729+372] += + s[606];
gout[n*729+373] += + s[607];
gout[n*729+374] += + s[608];
gout[n*729+375] += + s[609];
gout[n*729+376] += + s[610];
gout[n*729+377] += + s[611];
gout[n*729+378] += + s[198];
gout[n*729+379] += + s[199];
gout[n*729+380] += + s[200];
gout[n*729+381] += + s[201];
gout[n*729+382] += + s[202];
gout[n*729+383] += + s[203];
gout[n*729+384] += + s[204];
gout[n*729+385] += + s[205];
gout[n*729+386] += + s[206];
gout[n*729+387] += + s[441];
gout[n*729+388] += + s[442];
gout[n*729+389] += + s[443];
gout[n*729+390] += + s[444];
gout[n*729+391] += + s[445];
gout[n*729+392] += + s[446];
gout[n*729+393] += + s[447];
gout[n*729+394] += + s[448];
gout[n*729+395] += + s[449];
gout[n*729+396] += + s[684];
gout[n*729+397] += + s[685];
gout[n*729+398] += + s[686];
gout[n*729+399] += + s[687];
gout[n*729+400] += + s[688];
gout[n*729+401] += + s[689];
gout[n*729+402] += + s[690];
gout[n*729+403] += + s[691];
gout[n*729+404] += + s[692];
gout[n*729+405] += + s[63];
gout[n*729+406] += + s[64];
gout[n*729+407] += + s[65];
gout[n*729+408] += + s[66];
gout[n*729+409] += + s[67];
gout[n*729+410] += + s[68];
gout[n*729+411] += + s[69];
gout[n*729+412] += + s[70];
gout[n*729+413] += + s[71];
gout[n*729+414] += + s[306];
gout[n*729+415] += + s[307];
gout[n*729+416] += + s[308];
gout[n*729+417] += + s[309];
gout[n*729+418] += + s[310];
gout[n*729+419] += + s[311];
gout[n*729+420] += + s[312];
gout[n*729+421] += + s[313];
gout[n*729+422] += + s[314];
gout[n*729+423] += + s[549];
gout[n*729+424] += + s[550];
gout[n*729+425] += + s[551];
gout[n*729+426] += + s[552];
gout[n*729+427] += + s[553];
gout[n*729+428] += + s[554];
gout[n*729+429] += + s[555];
gout[n*729+430] += + s[556];
gout[n*729+431] += + s[557];
gout[n*729+432] += + s[144];
gout[n*729+433] += + s[145];
gout[n*729+434] += + s[146];
gout[n*729+435] += + s[147];
gout[n*729+436] += + s[148];
gout[n*729+437] += + s[149];
gout[n*729+438] += + s[150];
gout[n*729+439] += + s[151];
gout[n*729+440] += + s[152];
gout[n*729+441] += + s[387];
gout[n*729+442] += + s[388];
gout[n*729+443] += + s[389];
gout[n*729+444] += + s[390];
gout[n*729+445] += + s[391];
gout[n*729+446] += + s[392];
gout[n*729+447] += + s[393];
gout[n*729+448] += + s[394];
gout[n*729+449] += + s[395];
gout[n*729+450] += + s[630];
gout[n*729+451] += + s[631];
gout[n*729+452] += + s[632];
gout[n*729+453] += + s[633];
gout[n*729+454] += + s[634];
gout[n*729+455] += + s[635];
gout[n*729+456] += + s[636];
gout[n*729+457] += + s[637];
gout[n*729+458] += + s[638];
gout[n*729+459] += + s[225];
gout[n*729+460] += + s[226];
gout[n*729+461] += + s[227];
gout[n*729+462] += + s[228];
gout[n*729+463] += + s[229];
gout[n*729+464] += + s[230];
gout[n*729+465] += + s[231];
gout[n*729+466] += + s[232];
gout[n*729+467] += + s[233];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[711];
gout[n*729+478] += + s[712];
gout[n*729+479] += + s[713];
gout[n*729+480] += + s[714];
gout[n*729+481] += + s[715];
gout[n*729+482] += + s[716];
gout[n*729+483] += + s[717];
gout[n*729+484] += + s[718];
gout[n*729+485] += + s[719];
gout[n*729+486] += + s[18];
gout[n*729+487] += + s[19];
gout[n*729+488] += + s[20];
gout[n*729+489] += + s[21];
gout[n*729+490] += + s[22];
gout[n*729+491] += + s[23];
gout[n*729+492] += + s[24];
gout[n*729+493] += + s[25];
gout[n*729+494] += + s[26];
gout[n*729+495] += + s[261];
gout[n*729+496] += + s[262];
gout[n*729+497] += + s[263];
gout[n*729+498] += + s[264];
gout[n*729+499] += + s[265];
gout[n*729+500] += + s[266];
gout[n*729+501] += + s[267];
gout[n*729+502] += + s[268];
gout[n*729+503] += + s[269];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[99];
gout[n*729+514] += + s[100];
gout[n*729+515] += + s[101];
gout[n*729+516] += + s[102];
gout[n*729+517] += + s[103];
gout[n*729+518] += + s[104];
gout[n*729+519] += + s[105];
gout[n*729+520] += + s[106];
gout[n*729+521] += + s[107];
gout[n*729+522] += + s[342];
gout[n*729+523] += + s[343];
gout[n*729+524] += + s[344];
gout[n*729+525] += + s[345];
gout[n*729+526] += + s[346];
gout[n*729+527] += + s[347];
gout[n*729+528] += + s[348];
gout[n*729+529] += + s[349];
gout[n*729+530] += + s[350];
gout[n*729+531] += + s[585];
gout[n*729+532] += + s[586];
gout[n*729+533] += + s[587];
gout[n*729+534] += + s[588];
gout[n*729+535] += + s[589];
gout[n*729+536] += + s[590];
gout[n*729+537] += + s[591];
gout[n*729+538] += + s[592];
gout[n*729+539] += + s[593];
gout[n*729+540] += + s[180];
gout[n*729+541] += + s[181];
gout[n*729+542] += + s[182];
gout[n*729+543] += + s[183];
gout[n*729+544] += + s[184];
gout[n*729+545] += + s[185];
gout[n*729+546] += + s[186];
gout[n*729+547] += + s[187];
gout[n*729+548] += + s[188];
gout[n*729+549] += + s[423];
gout[n*729+550] += + s[424];
gout[n*729+551] += + s[425];
gout[n*729+552] += + s[426];
gout[n*729+553] += + s[427];
gout[n*729+554] += + s[428];
gout[n*729+555] += + s[429];
gout[n*729+556] += + s[430];
gout[n*729+557] += + s[431];
gout[n*729+558] += + s[666];
gout[n*729+559] += + s[667];
gout[n*729+560] += + s[668];
gout[n*729+561] += + s[669];
gout[n*729+562] += + s[670];
gout[n*729+563] += + s[671];
gout[n*729+564] += + s[672];
gout[n*729+565] += + s[673];
gout[n*729+566] += + s[674];
gout[n*729+567] += + s[45];
gout[n*729+568] += + s[46];
gout[n*729+569] += + s[47];
gout[n*729+570] += + s[48];
gout[n*729+571] += + s[49];
gout[n*729+572] += + s[50];
gout[n*729+573] += + s[51];
gout[n*729+574] += + s[52];
gout[n*729+575] += + s[53];
gout[n*729+576] += + s[288];
gout[n*729+577] += + s[289];
gout[n*729+578] += + s[290];
gout[n*729+579] += + s[291];
gout[n*729+580] += + s[292];
gout[n*729+581] += + s[293];
gout[n*729+582] += + s[294];
gout[n*729+583] += + s[295];
gout[n*729+584] += + s[296];
gout[n*729+585] += + s[531];
gout[n*729+586] += + s[532];
gout[n*729+587] += + s[533];
gout[n*729+588] += + s[534];
gout[n*729+589] += + s[535];
gout[n*729+590] += + s[536];
gout[n*729+591] += + s[537];
gout[n*729+592] += + s[538];
gout[n*729+593] += + s[539];
gout[n*729+594] += + s[126];
gout[n*729+595] += + s[127];
gout[n*729+596] += + s[128];
gout[n*729+597] += + s[129];
gout[n*729+598] += + s[130];
gout[n*729+599] += + s[131];
gout[n*729+600] += + s[132];
gout[n*729+601] += + s[133];
gout[n*729+602] += + s[134];
gout[n*729+603] += + s[369];
gout[n*729+604] += + s[370];
gout[n*729+605] += + s[371];
gout[n*729+606] += + s[372];
gout[n*729+607] += + s[373];
gout[n*729+608] += + s[374];
gout[n*729+609] += + s[375];
gout[n*729+610] += + s[376];
gout[n*729+611] += + s[377];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[207];
gout[n*729+622] += + s[208];
gout[n*729+623] += + s[209];
gout[n*729+624] += + s[210];
gout[n*729+625] += + s[211];
gout[n*729+626] += + s[212];
gout[n*729+627] += + s[213];
gout[n*729+628] += + s[214];
gout[n*729+629] += + s[215];
gout[n*729+630] += + s[450];
gout[n*729+631] += + s[451];
gout[n*729+632] += + s[452];
gout[n*729+633] += + s[453];
gout[n*729+634] += + s[454];
gout[n*729+635] += + s[455];
gout[n*729+636] += + s[456];
gout[n*729+637] += + s[457];
gout[n*729+638] += + s[458];
gout[n*729+639] += + s[693];
gout[n*729+640] += + s[694];
gout[n*729+641] += + s[695];
gout[n*729+642] += + s[696];
gout[n*729+643] += + s[697];
gout[n*729+644] += + s[698];
gout[n*729+645] += + s[699];
gout[n*729+646] += + s[700];
gout[n*729+647] += + s[701];
gout[n*729+648] += + s[72];
gout[n*729+649] += + s[73];
gout[n*729+650] += + s[74];
gout[n*729+651] += + s[75];
gout[n*729+652] += + s[76];
gout[n*729+653] += + s[77];
gout[n*729+654] += + s[78];
gout[n*729+655] += + s[79];
gout[n*729+656] += + s[80];
gout[n*729+657] += + s[315];
gout[n*729+658] += + s[316];
gout[n*729+659] += + s[317];
gout[n*729+660] += + s[318];
gout[n*729+661] += + s[319];
gout[n*729+662] += + s[320];
gout[n*729+663] += + s[321];
gout[n*729+664] += + s[322];
gout[n*729+665] += + s[323];
gout[n*729+666] += + s[558];
gout[n*729+667] += + s[559];
gout[n*729+668] += + s[560];
gout[n*729+669] += + s[561];
gout[n*729+670] += + s[562];
gout[n*729+671] += + s[563];
gout[n*729+672] += + s[564];
gout[n*729+673] += + s[565];
gout[n*729+674] += + s[566];
gout[n*729+675] += + s[153];
gout[n*729+676] += + s[154];
gout[n*729+677] += + s[155];
gout[n*729+678] += + s[156];
gout[n*729+679] += + s[157];
gout[n*729+680] += + s[158];
gout[n*729+681] += + s[159];
gout[n*729+682] += + s[160];
gout[n*729+683] += + s[161];
gout[n*729+684] += + s[396];
gout[n*729+685] += + s[397];
gout[n*729+686] += + s[398];
gout[n*729+687] += + s[399];
gout[n*729+688] += + s[400];
gout[n*729+689] += + s[401];
gout[n*729+690] += + s[402];
gout[n*729+691] += + s[403];
gout[n*729+692] += + s[404];
gout[n*729+693] += + s[639];
gout[n*729+694] += + s[640];
gout[n*729+695] += + s[641];
gout[n*729+696] += + s[642];
gout[n*729+697] += + s[643];
gout[n*729+698] += + s[644];
gout[n*729+699] += + s[645];
gout[n*729+700] += + s[646];
gout[n*729+701] += + s[647];
gout[n*729+702] += + s[234];
gout[n*729+703] += + s[235];
gout[n*729+704] += + s[236];
gout[n*729+705] += + s[237];
gout[n*729+706] += + s[238];
gout[n*729+707] += + s[239];
gout[n*729+708] += + s[240];
gout[n*729+709] += + s[241];
gout[n*729+710] += + s[242];
gout[n*729+711] += + s[477];
gout[n*729+712] += + s[478];
gout[n*729+713] += + s[479];
gout[n*729+714] += + s[480];
gout[n*729+715] += + s[481];
gout[n*729+716] += + s[482];
gout[n*729+717] += + s[483];
gout[n*729+718] += + s[484];
gout[n*729+719] += + s[485];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipipipmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipipmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipipmip_cart
CACHE_SIZE_T int1e_ipipipipmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipipmip_sph
CACHE_SIZE_T int1e_ipipipipmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipipmip_spinor
ALL_CINT1E(int1e_ipipipipmip)
ALL_CINT1E_FORTRAN_(int1e_ipipipipmip)
/* <NABLA NABLA i|RI |NABLA NABLA j> */
void CINTgout1e_int1e_ipipmipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipmipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipmipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipmipip_cart
CACHE_SIZE_T int1e_ipipmipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipmipip_sph
CACHE_SIZE_T int1e_ipipmipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipmipip_spinor
ALL_CINT1E(int1e_ipipmipip)
ALL_CINT1E_FORTRAN_(int1e_ipipmipip)
/* <i|RI RI |NABLA j> */
void CINTgout1e_int1e_mmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[27];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_mmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mmip_cart
CACHE_SIZE_T int1e_mmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mmip_sph
CACHE_SIZE_T int1e_mmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mmip_spinor
ALL_CINT1E(int1e_mmip)
ALL_CINT1E_FORTRAN_(int1e_mmip)
/* <i|RI RI |NABLA NABLA j> */
void CINTgout1e_int1e_mmipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_mmipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mmipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mmipip_cart
CACHE_SIZE_T int1e_mmipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mmipip_sph
CACHE_SIZE_T int1e_mmipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mmipip_spinor
ALL_CINT1E(int1e_mmipip)
ALL_CINT1E_FORTRAN_(int1e_mmipip)
/* <i|RI RI |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_mmipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_mmipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mmipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mmipipip_cart
CACHE_SIZE_T int1e_mmipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mmipipip_sph
CACHE_SIZE_T int1e_mmipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mmipipip_spinor
ALL_CINT1E(int1e_mmipipip)
ALL_CINT1E_FORTRAN_(int1e_mmipipip)
/* <i|RI RI |NABLA NABLA NABLA NABLA j> */
void CINTgout1e_int1e_mmipipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g32, g0, envs->i_l+0, envs->j_l+5, 0);
G1E_D_J(g33, g32, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g34, g32, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g35, g34, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g36, g32, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g37, g36, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g38, g36, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g39, g38, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g40, g32, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g41, g40, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g42, g40, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g43, g42, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g44, g40, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g45, g44, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g46, g44, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g47, g46, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g48, g32, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g49, g48, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g50, g48, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g51, g50, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g52, g48, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g53, g52, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g54, g52, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g55, g54, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g56, g48, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g57, g56, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g58, g56, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g59, g58, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g60, g56, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g61, g60, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g62, g60, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g63, g62, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_mmipipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mmipipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mmipipipip_cart
CACHE_SIZE_T int1e_mmipipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mmipipipip_sph
CACHE_SIZE_T int1e_mmipipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmipipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mmipipipip_spinor
ALL_CINT1E(int1e_mmipipipip)
ALL_CINT1E_FORTRAN_(int1e_mmipipipip)
/* <NABLA i|RI RI |j> */
void CINTgout1e_int1e_ipmm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[27];
G1E_RCJ(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_ipmm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmm_cart
CACHE_SIZE_T int1e_ipmm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmm_sph
CACHE_SIZE_T int1e_ipmm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmm_spinor
ALL_CINT1E(int1e_ipmm)
ALL_CINT1E_FORTRAN_(int1e_ipmm)
/* <NABLA NABLA i|RI RI |j> */
void CINTgout1e_int1e_ipipmm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[27];
gout[n*81+10] = + s[28];
gout[n*81+11] = + s[29];
gout[n*81+12] = + s[30];
gout[n*81+13] = + s[31];
gout[n*81+14] = + s[32];
gout[n*81+15] = + s[33];
gout[n*81+16] = + s[34];
gout[n*81+17] = + s[35];
gout[n*81+18] = + s[54];
gout[n*81+19] = + s[55];
gout[n*81+20] = + s[56];
gout[n*81+21] = + s[57];
gout[n*81+22] = + s[58];
gout[n*81+23] = + s[59];
gout[n*81+24] = + s[60];
gout[n*81+25] = + s[61];
gout[n*81+26] = + s[62];
gout[n*81+27] = + s[9];
gout[n*81+28] = + s[10];
gout[n*81+29] = + s[11];
gout[n*81+30] = + s[12];
gout[n*81+31] = + s[13];
gout[n*81+32] = + s[14];
gout[n*81+33] = + s[15];
gout[n*81+34] = + s[16];
gout[n*81+35] = + s[17];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[63];
gout[n*81+46] = + s[64];
gout[n*81+47] = + s[65];
gout[n*81+48] = + s[66];
gout[n*81+49] = + s[67];
gout[n*81+50] = + s[68];
gout[n*81+51] = + s[69];
gout[n*81+52] = + s[70];
gout[n*81+53] = + s[71];
gout[n*81+54] = + s[18];
gout[n*81+55] = + s[19];
gout[n*81+56] = + s[20];
gout[n*81+57] = + s[21];
gout[n*81+58] = + s[22];
gout[n*81+59] = + s[23];
gout[n*81+60] = + s[24];
gout[n*81+61] = + s[25];
gout[n*81+62] = + s[26];
gout[n*81+63] = + s[45];
gout[n*81+64] = + s[46];
gout[n*81+65] = + s[47];
gout[n*81+66] = + s[48];
gout[n*81+67] = + s[49];
gout[n*81+68] = + s[50];
gout[n*81+69] = + s[51];
gout[n*81+70] = + s[52];
gout[n*81+71] = + s[53];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[27];
gout[n*81+10] += + s[28];
gout[n*81+11] += + s[29];
gout[n*81+12] += + s[30];
gout[n*81+13] += + s[31];
gout[n*81+14] += + s[32];
gout[n*81+15] += + s[33];
gout[n*81+16] += + s[34];
gout[n*81+17] += + s[35];
gout[n*81+18] += + s[54];
gout[n*81+19] += + s[55];
gout[n*81+20] += + s[56];
gout[n*81+21] += + s[57];
gout[n*81+22] += + s[58];
gout[n*81+23] += + s[59];
gout[n*81+24] += + s[60];
gout[n*81+25] += + s[61];
gout[n*81+26] += + s[62];
gout[n*81+27] += + s[9];
gout[n*81+28] += + s[10];
gout[n*81+29] += + s[11];
gout[n*81+30] += + s[12];
gout[n*81+31] += + s[13];
gout[n*81+32] += + s[14];
gout[n*81+33] += + s[15];
gout[n*81+34] += + s[16];
gout[n*81+35] += + s[17];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[63];
gout[n*81+46] += + s[64];
gout[n*81+47] += + s[65];
gout[n*81+48] += + s[66];
gout[n*81+49] += + s[67];
gout[n*81+50] += + s[68];
gout[n*81+51] += + s[69];
gout[n*81+52] += + s[70];
gout[n*81+53] += + s[71];
gout[n*81+54] += + s[18];
gout[n*81+55] += + s[19];
gout[n*81+56] += + s[20];
gout[n*81+57] += + s[21];
gout[n*81+58] += + s[22];
gout[n*81+59] += + s[23];
gout[n*81+60] += + s[24];
gout[n*81+61] += + s[25];
gout[n*81+62] += + s[26];
gout[n*81+63] += + s[45];
gout[n*81+64] += + s[46];
gout[n*81+65] += + s[47];
gout[n*81+66] += + s[48];
gout[n*81+67] += + s[49];
gout[n*81+68] += + s[50];
gout[n*81+69] += + s[51];
gout[n*81+70] += + s[52];
gout[n*81+71] += + s[53];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipipmm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipmm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipmm_cart
CACHE_SIZE_T int1e_ipipmm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipmm_sph
CACHE_SIZE_T int1e_ipipmm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipmm_spinor
ALL_CINT1E(int1e_ipipmm)
ALL_CINT1E_FORTRAN_(int1e_ipipmm)
/* <NABLA NABLA NABLA i|RI RI |j> */
void CINTgout1e_int1e_ipipipmm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_RCJ(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[81];
gout[n*243+10] = + s[82];
gout[n*243+11] = + s[83];
gout[n*243+12] = + s[84];
gout[n*243+13] = + s[85];
gout[n*243+14] = + s[86];
gout[n*243+15] = + s[87];
gout[n*243+16] = + s[88];
gout[n*243+17] = + s[89];
gout[n*243+18] = + s[162];
gout[n*243+19] = + s[163];
gout[n*243+20] = + s[164];
gout[n*243+21] = + s[165];
gout[n*243+22] = + s[166];
gout[n*243+23] = + s[167];
gout[n*243+24] = + s[168];
gout[n*243+25] = + s[169];
gout[n*243+26] = + s[170];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[108];
gout[n*243+37] = + s[109];
gout[n*243+38] = + s[110];
gout[n*243+39] = + s[111];
gout[n*243+40] = + s[112];
gout[n*243+41] = + s[113];
gout[n*243+42] = + s[114];
gout[n*243+43] = + s[115];
gout[n*243+44] = + s[116];
gout[n*243+45] = + s[189];
gout[n*243+46] = + s[190];
gout[n*243+47] = + s[191];
gout[n*243+48] = + s[192];
gout[n*243+49] = + s[193];
gout[n*243+50] = + s[194];
gout[n*243+51] = + s[195];
gout[n*243+52] = + s[196];
gout[n*243+53] = + s[197];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[135];
gout[n*243+64] = + s[136];
gout[n*243+65] = + s[137];
gout[n*243+66] = + s[138];
gout[n*243+67] = + s[139];
gout[n*243+68] = + s[140];
gout[n*243+69] = + s[141];
gout[n*243+70] = + s[142];
gout[n*243+71] = + s[143];
gout[n*243+72] = + s[216];
gout[n*243+73] = + s[217];
gout[n*243+74] = + s[218];
gout[n*243+75] = + s[219];
gout[n*243+76] = + s[220];
gout[n*243+77] = + s[221];
gout[n*243+78] = + s[222];
gout[n*243+79] = + s[223];
gout[n*243+80] = + s[224];
gout[n*243+81] = + s[9];
gout[n*243+82] = + s[10];
gout[n*243+83] = + s[11];
gout[n*243+84] = + s[12];
gout[n*243+85] = + s[13];
gout[n*243+86] = + s[14];
gout[n*243+87] = + s[15];
gout[n*243+88] = + s[16];
gout[n*243+89] = + s[17];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[171];
gout[n*243+100] = + s[172];
gout[n*243+101] = + s[173];
gout[n*243+102] = + s[174];
gout[n*243+103] = + s[175];
gout[n*243+104] = + s[176];
gout[n*243+105] = + s[177];
gout[n*243+106] = + s[178];
gout[n*243+107] = + s[179];
gout[n*243+108] = + s[36];
gout[n*243+109] = + s[37];
gout[n*243+110] = + s[38];
gout[n*243+111] = + s[39];
gout[n*243+112] = + s[40];
gout[n*243+113] = + s[41];
gout[n*243+114] = + s[42];
gout[n*243+115] = + s[43];
gout[n*243+116] = + s[44];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[198];
gout[n*243+127] = + s[199];
gout[n*243+128] = + s[200];
gout[n*243+129] = + s[201];
gout[n*243+130] = + s[202];
gout[n*243+131] = + s[203];
gout[n*243+132] = + s[204];
gout[n*243+133] = + s[205];
gout[n*243+134] = + s[206];
gout[n*243+135] = + s[63];
gout[n*243+136] = + s[64];
gout[n*243+137] = + s[65];
gout[n*243+138] = + s[66];
gout[n*243+139] = + s[67];
gout[n*243+140] = + s[68];
gout[n*243+141] = + s[69];
gout[n*243+142] = + s[70];
gout[n*243+143] = + s[71];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[225];
gout[n*243+154] = + s[226];
gout[n*243+155] = + s[227];
gout[n*243+156] = + s[228];
gout[n*243+157] = + s[229];
gout[n*243+158] = + s[230];
gout[n*243+159] = + s[231];
gout[n*243+160] = + s[232];
gout[n*243+161] = + s[233];
gout[n*243+162] = + s[18];
gout[n*243+163] = + s[19];
gout[n*243+164] = + s[20];
gout[n*243+165] = + s[21];
gout[n*243+166] = + s[22];
gout[n*243+167] = + s[23];
gout[n*243+168] = + s[24];
gout[n*243+169] = + s[25];
gout[n*243+170] = + s[26];
gout[n*243+171] = + s[99];
gout[n*243+172] = + s[100];
gout[n*243+173] = + s[101];
gout[n*243+174] = + s[102];
gout[n*243+175] = + s[103];
gout[n*243+176] = + s[104];
gout[n*243+177] = + s[105];
gout[n*243+178] = + s[106];
gout[n*243+179] = + s[107];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[45];
gout[n*243+190] = + s[46];
gout[n*243+191] = + s[47];
gout[n*243+192] = + s[48];
gout[n*243+193] = + s[49];
gout[n*243+194] = + s[50];
gout[n*243+195] = + s[51];
gout[n*243+196] = + s[52];
gout[n*243+197] = + s[53];
gout[n*243+198] = + s[126];
gout[n*243+199] = + s[127];
gout[n*243+200] = + s[128];
gout[n*243+201] = + s[129];
gout[n*243+202] = + s[130];
gout[n*243+203] = + s[131];
gout[n*243+204] = + s[132];
gout[n*243+205] = + s[133];
gout[n*243+206] = + s[134];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[72];
gout[n*243+217] = + s[73];
gout[n*243+218] = + s[74];
gout[n*243+219] = + s[75];
gout[n*243+220] = + s[76];
gout[n*243+221] = + s[77];
gout[n*243+222] = + s[78];
gout[n*243+223] = + s[79];
gout[n*243+224] = + s[80];
gout[n*243+225] = + s[153];
gout[n*243+226] = + s[154];
gout[n*243+227] = + s[155];
gout[n*243+228] = + s[156];
gout[n*243+229] = + s[157];
gout[n*243+230] = + s[158];
gout[n*243+231] = + s[159];
gout[n*243+232] = + s[160];
gout[n*243+233] = + s[161];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[81];
gout[n*243+10] += + s[82];
gout[n*243+11] += + s[83];
gout[n*243+12] += + s[84];
gout[n*243+13] += + s[85];
gout[n*243+14] += + s[86];
gout[n*243+15] += + s[87];
gout[n*243+16] += + s[88];
gout[n*243+17] += + s[89];
gout[n*243+18] += + s[162];
gout[n*243+19] += + s[163];
gout[n*243+20] += + s[164];
gout[n*243+21] += + s[165];
gout[n*243+22] += + s[166];
gout[n*243+23] += + s[167];
gout[n*243+24] += + s[168];
gout[n*243+25] += + s[169];
gout[n*243+26] += + s[170];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[108];
gout[n*243+37] += + s[109];
gout[n*243+38] += + s[110];
gout[n*243+39] += + s[111];
gout[n*243+40] += + s[112];
gout[n*243+41] += + s[113];
gout[n*243+42] += + s[114];
gout[n*243+43] += + s[115];
gout[n*243+44] += + s[116];
gout[n*243+45] += + s[189];
gout[n*243+46] += + s[190];
gout[n*243+47] += + s[191];
gout[n*243+48] += + s[192];
gout[n*243+49] += + s[193];
gout[n*243+50] += + s[194];
gout[n*243+51] += + s[195];
gout[n*243+52] += + s[196];
gout[n*243+53] += + s[197];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[135];
gout[n*243+64] += + s[136];
gout[n*243+65] += + s[137];
gout[n*243+66] += + s[138];
gout[n*243+67] += + s[139];
gout[n*243+68] += + s[140];
gout[n*243+69] += + s[141];
gout[n*243+70] += + s[142];
gout[n*243+71] += + s[143];
gout[n*243+72] += + s[216];
gout[n*243+73] += + s[217];
gout[n*243+74] += + s[218];
gout[n*243+75] += + s[219];
gout[n*243+76] += + s[220];
gout[n*243+77] += + s[221];
gout[n*243+78] += + s[222];
gout[n*243+79] += + s[223];
gout[n*243+80] += + s[224];
gout[n*243+81] += + s[9];
gout[n*243+82] += + s[10];
gout[n*243+83] += + s[11];
gout[n*243+84] += + s[12];
gout[n*243+85] += + s[13];
gout[n*243+86] += + s[14];
gout[n*243+87] += + s[15];
gout[n*243+88] += + s[16];
gout[n*243+89] += + s[17];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[171];
gout[n*243+100] += + s[172];
gout[n*243+101] += + s[173];
gout[n*243+102] += + s[174];
gout[n*243+103] += + s[175];
gout[n*243+104] += + s[176];
gout[n*243+105] += + s[177];
gout[n*243+106] += + s[178];
gout[n*243+107] += + s[179];
gout[n*243+108] += + s[36];
gout[n*243+109] += + s[37];
gout[n*243+110] += + s[38];
gout[n*243+111] += + s[39];
gout[n*243+112] += + s[40];
gout[n*243+113] += + s[41];
gout[n*243+114] += + s[42];
gout[n*243+115] += + s[43];
gout[n*243+116] += + s[44];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[198];
gout[n*243+127] += + s[199];
gout[n*243+128] += + s[200];
gout[n*243+129] += + s[201];
gout[n*243+130] += + s[202];
gout[n*243+131] += + s[203];
gout[n*243+132] += + s[204];
gout[n*243+133] += + s[205];
gout[n*243+134] += + s[206];
gout[n*243+135] += + s[63];
gout[n*243+136] += + s[64];
gout[n*243+137] += + s[65];
gout[n*243+138] += + s[66];
gout[n*243+139] += + s[67];
gout[n*243+140] += + s[68];
gout[n*243+141] += + s[69];
gout[n*243+142] += + s[70];
gout[n*243+143] += + s[71];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[225];
gout[n*243+154] += + s[226];
gout[n*243+155] += + s[227];
gout[n*243+156] += + s[228];
gout[n*243+157] += + s[229];
gout[n*243+158] += + s[230];
gout[n*243+159] += + s[231];
gout[n*243+160] += + s[232];
gout[n*243+161] += + s[233];
gout[n*243+162] += + s[18];
gout[n*243+163] += + s[19];
gout[n*243+164] += + s[20];
gout[n*243+165] += + s[21];
gout[n*243+166] += + s[22];
gout[n*243+167] += + s[23];
gout[n*243+168] += + s[24];
gout[n*243+169] += + s[25];
gout[n*243+170] += + s[26];
gout[n*243+171] += + s[99];
gout[n*243+172] += + s[100];
gout[n*243+173] += + s[101];
gout[n*243+174] += + s[102];
gout[n*243+175] += + s[103];
gout[n*243+176] += + s[104];
gout[n*243+177] += + s[105];
gout[n*243+178] += + s[106];
gout[n*243+179] += + s[107];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[45];
gout[n*243+190] += + s[46];
gout[n*243+191] += + s[47];
gout[n*243+192] += + s[48];
gout[n*243+193] += + s[49];
gout[n*243+194] += + s[50];
gout[n*243+195] += + s[51];
gout[n*243+196] += + s[52];
gout[n*243+197] += + s[53];
gout[n*243+198] += + s[126];
gout[n*243+199] += + s[127];
gout[n*243+200] += + s[128];
gout[n*243+201] += + s[129];
gout[n*243+202] += + s[130];
gout[n*243+203] += + s[131];
gout[n*243+204] += + s[132];
gout[n*243+205] += + s[133];
gout[n*243+206] += + s[134];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[72];
gout[n*243+217] += + s[73];
gout[n*243+218] += + s[74];
gout[n*243+219] += + s[75];
gout[n*243+220] += + s[76];
gout[n*243+221] += + s[77];
gout[n*243+222] += + s[78];
gout[n*243+223] += + s[79];
gout[n*243+224] += + s[80];
gout[n*243+225] += + s[153];
gout[n*243+226] += + s[154];
gout[n*243+227] += + s[155];
gout[n*243+228] += + s[156];
gout[n*243+229] += + s[157];
gout[n*243+230] += + s[158];
gout[n*243+231] += + s[159];
gout[n*243+232] += + s[160];
gout[n*243+233] += + s[161];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipipmm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipmm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipmm_cart
CACHE_SIZE_T int1e_ipipipmm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipmm_sph
CACHE_SIZE_T int1e_ipipipmm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipmm_spinor
ALL_CINT1E(int1e_ipipipmm)
ALL_CINT1E_FORTRAN_(int1e_ipipipmm)
/* <NABLA NABLA NABLA NABLA i|RI RI |j> */
void CINTgout1e_int1e_ipipipipmm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_RCJ(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+4, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+4, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[243];
gout[n*729+10] = + s[244];
gout[n*729+11] = + s[245];
gout[n*729+12] = + s[246];
gout[n*729+13] = + s[247];
gout[n*729+14] = + s[248];
gout[n*729+15] = + s[249];
gout[n*729+16] = + s[250];
gout[n*729+17] = + s[251];
gout[n*729+18] = + s[486];
gout[n*729+19] = + s[487];
gout[n*729+20] = + s[488];
gout[n*729+21] = + s[489];
gout[n*729+22] = + s[490];
gout[n*729+23] = + s[491];
gout[n*729+24] = + s[492];
gout[n*729+25] = + s[493];
gout[n*729+26] = + s[494];
gout[n*729+27] = + s[81];
gout[n*729+28] = + s[82];
gout[n*729+29] = + s[83];
gout[n*729+30] = + s[84];
gout[n*729+31] = + s[85];
gout[n*729+32] = + s[86];
gout[n*729+33] = + s[87];
gout[n*729+34] = + s[88];
gout[n*729+35] = + s[89];
gout[n*729+36] = + s[324];
gout[n*729+37] = + s[325];
gout[n*729+38] = + s[326];
gout[n*729+39] = + s[327];
gout[n*729+40] = + s[328];
gout[n*729+41] = + s[329];
gout[n*729+42] = + s[330];
gout[n*729+43] = + s[331];
gout[n*729+44] = + s[332];
gout[n*729+45] = + s[567];
gout[n*729+46] = + s[568];
gout[n*729+47] = + s[569];
gout[n*729+48] = + s[570];
gout[n*729+49] = + s[571];
gout[n*729+50] = + s[572];
gout[n*729+51] = + s[573];
gout[n*729+52] = + s[574];
gout[n*729+53] = + s[575];
gout[n*729+54] = + s[162];
gout[n*729+55] = + s[163];
gout[n*729+56] = + s[164];
gout[n*729+57] = + s[165];
gout[n*729+58] = + s[166];
gout[n*729+59] = + s[167];
gout[n*729+60] = + s[168];
gout[n*729+61] = + s[169];
gout[n*729+62] = + s[170];
gout[n*729+63] = + s[405];
gout[n*729+64] = + s[406];
gout[n*729+65] = + s[407];
gout[n*729+66] = + s[408];
gout[n*729+67] = + s[409];
gout[n*729+68] = + s[410];
gout[n*729+69] = + s[411];
gout[n*729+70] = + s[412];
gout[n*729+71] = + s[413];
gout[n*729+72] = + s[648];
gout[n*729+73] = + s[649];
gout[n*729+74] = + s[650];
gout[n*729+75] = + s[651];
gout[n*729+76] = + s[652];
gout[n*729+77] = + s[653];
gout[n*729+78] = + s[654];
gout[n*729+79] = + s[655];
gout[n*729+80] = + s[656];
gout[n*729+81] = + s[27];
gout[n*729+82] = + s[28];
gout[n*729+83] = + s[29];
gout[n*729+84] = + s[30];
gout[n*729+85] = + s[31];
gout[n*729+86] = + s[32];
gout[n*729+87] = + s[33];
gout[n*729+88] = + s[34];
gout[n*729+89] = + s[35];
gout[n*729+90] = + s[270];
gout[n*729+91] = + s[271];
gout[n*729+92] = + s[272];
gout[n*729+93] = + s[273];
gout[n*729+94] = + s[274];
gout[n*729+95] = + s[275];
gout[n*729+96] = + s[276];
gout[n*729+97] = + s[277];
gout[n*729+98] = + s[278];
gout[n*729+99] = + s[513];
gout[n*729+100] = + s[514];
gout[n*729+101] = + s[515];
gout[n*729+102] = + s[516];
gout[n*729+103] = + s[517];
gout[n*729+104] = + s[518];
gout[n*729+105] = + s[519];
gout[n*729+106] = + s[520];
gout[n*729+107] = + s[521];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[351];
gout[n*729+118] = + s[352];
gout[n*729+119] = + s[353];
gout[n*729+120] = + s[354];
gout[n*729+121] = + s[355];
gout[n*729+122] = + s[356];
gout[n*729+123] = + s[357];
gout[n*729+124] = + s[358];
gout[n*729+125] = + s[359];
gout[n*729+126] = + s[594];
gout[n*729+127] = + s[595];
gout[n*729+128] = + s[596];
gout[n*729+129] = + s[597];
gout[n*729+130] = + s[598];
gout[n*729+131] = + s[599];
gout[n*729+132] = + s[600];
gout[n*729+133] = + s[601];
gout[n*729+134] = + s[602];
gout[n*729+135] = + s[189];
gout[n*729+136] = + s[190];
gout[n*729+137] = + s[191];
gout[n*729+138] = + s[192];
gout[n*729+139] = + s[193];
gout[n*729+140] = + s[194];
gout[n*729+141] = + s[195];
gout[n*729+142] = + s[196];
gout[n*729+143] = + s[197];
gout[n*729+144] = + s[432];
gout[n*729+145] = + s[433];
gout[n*729+146] = + s[434];
gout[n*729+147] = + s[435];
gout[n*729+148] = + s[436];
gout[n*729+149] = + s[437];
gout[n*729+150] = + s[438];
gout[n*729+151] = + s[439];
gout[n*729+152] = + s[440];
gout[n*729+153] = + s[675];
gout[n*729+154] = + s[676];
gout[n*729+155] = + s[677];
gout[n*729+156] = + s[678];
gout[n*729+157] = + s[679];
gout[n*729+158] = + s[680];
gout[n*729+159] = + s[681];
gout[n*729+160] = + s[682];
gout[n*729+161] = + s[683];
gout[n*729+162] = + s[54];
gout[n*729+163] = + s[55];
gout[n*729+164] = + s[56];
gout[n*729+165] = + s[57];
gout[n*729+166] = + s[58];
gout[n*729+167] = + s[59];
gout[n*729+168] = + s[60];
gout[n*729+169] = + s[61];
gout[n*729+170] = + s[62];
gout[n*729+171] = + s[297];
gout[n*729+172] = + s[298];
gout[n*729+173] = + s[299];
gout[n*729+174] = + s[300];
gout[n*729+175] = + s[301];
gout[n*729+176] = + s[302];
gout[n*729+177] = + s[303];
gout[n*729+178] = + s[304];
gout[n*729+179] = + s[305];
gout[n*729+180] = + s[540];
gout[n*729+181] = + s[541];
gout[n*729+182] = + s[542];
gout[n*729+183] = + s[543];
gout[n*729+184] = + s[544];
gout[n*729+185] = + s[545];
gout[n*729+186] = + s[546];
gout[n*729+187] = + s[547];
gout[n*729+188] = + s[548];
gout[n*729+189] = + s[135];
gout[n*729+190] = + s[136];
gout[n*729+191] = + s[137];
gout[n*729+192] = + s[138];
gout[n*729+193] = + s[139];
gout[n*729+194] = + s[140];
gout[n*729+195] = + s[141];
gout[n*729+196] = + s[142];
gout[n*729+197] = + s[143];
gout[n*729+198] = + s[378];
gout[n*729+199] = + s[379];
gout[n*729+200] = + s[380];
gout[n*729+201] = + s[381];
gout[n*729+202] = + s[382];
gout[n*729+203] = + s[383];
gout[n*729+204] = + s[384];
gout[n*729+205] = + s[385];
gout[n*729+206] = + s[386];
gout[n*729+207] = + s[621];
gout[n*729+208] = + s[622];
gout[n*729+209] = + s[623];
gout[n*729+210] = + s[624];
gout[n*729+211] = + s[625];
gout[n*729+212] = + s[626];
gout[n*729+213] = + s[627];
gout[n*729+214] = + s[628];
gout[n*729+215] = + s[629];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[459];
gout[n*729+226] = + s[460];
gout[n*729+227] = + s[461];
gout[n*729+228] = + s[462];
gout[n*729+229] = + s[463];
gout[n*729+230] = + s[464];
gout[n*729+231] = + s[465];
gout[n*729+232] = + s[466];
gout[n*729+233] = + s[467];
gout[n*729+234] = + s[702];
gout[n*729+235] = + s[703];
gout[n*729+236] = + s[704];
gout[n*729+237] = + s[705];
gout[n*729+238] = + s[706];
gout[n*729+239] = + s[707];
gout[n*729+240] = + s[708];
gout[n*729+241] = + s[709];
gout[n*729+242] = + s[710];
gout[n*729+243] = + s[9];
gout[n*729+244] = + s[10];
gout[n*729+245] = + s[11];
gout[n*729+246] = + s[12];
gout[n*729+247] = + s[13];
gout[n*729+248] = + s[14];
gout[n*729+249] = + s[15];
gout[n*729+250] = + s[16];
gout[n*729+251] = + s[17];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[495];
gout[n*729+262] = + s[496];
gout[n*729+263] = + s[497];
gout[n*729+264] = + s[498];
gout[n*729+265] = + s[499];
gout[n*729+266] = + s[500];
gout[n*729+267] = + s[501];
gout[n*729+268] = + s[502];
gout[n*729+269] = + s[503];
gout[n*729+270] = + s[90];
gout[n*729+271] = + s[91];
gout[n*729+272] = + s[92];
gout[n*729+273] = + s[93];
gout[n*729+274] = + s[94];
gout[n*729+275] = + s[95];
gout[n*729+276] = + s[96];
gout[n*729+277] = + s[97];
gout[n*729+278] = + s[98];
gout[n*729+279] = + s[333];
gout[n*729+280] = + s[334];
gout[n*729+281] = + s[335];
gout[n*729+282] = + s[336];
gout[n*729+283] = + s[337];
gout[n*729+284] = + s[338];
gout[n*729+285] = + s[339];
gout[n*729+286] = + s[340];
gout[n*729+287] = + s[341];
gout[n*729+288] = + s[576];
gout[n*729+289] = + s[577];
gout[n*729+290] = + s[578];
gout[n*729+291] = + s[579];
gout[n*729+292] = + s[580];
gout[n*729+293] = + s[581];
gout[n*729+294] = + s[582];
gout[n*729+295] = + s[583];
gout[n*729+296] = + s[584];
gout[n*729+297] = + s[171];
gout[n*729+298] = + s[172];
gout[n*729+299] = + s[173];
gout[n*729+300] = + s[174];
gout[n*729+301] = + s[175];
gout[n*729+302] = + s[176];
gout[n*729+303] = + s[177];
gout[n*729+304] = + s[178];
gout[n*729+305] = + s[179];
gout[n*729+306] = + s[414];
gout[n*729+307] = + s[415];
gout[n*729+308] = + s[416];
gout[n*729+309] = + s[417];
gout[n*729+310] = + s[418];
gout[n*729+311] = + s[419];
gout[n*729+312] = + s[420];
gout[n*729+313] = + s[421];
gout[n*729+314] = + s[422];
gout[n*729+315] = + s[657];
gout[n*729+316] = + s[658];
gout[n*729+317] = + s[659];
gout[n*729+318] = + s[660];
gout[n*729+319] = + s[661];
gout[n*729+320] = + s[662];
gout[n*729+321] = + s[663];
gout[n*729+322] = + s[664];
gout[n*729+323] = + s[665];
gout[n*729+324] = + s[36];
gout[n*729+325] = + s[37];
gout[n*729+326] = + s[38];
gout[n*729+327] = + s[39];
gout[n*729+328] = + s[40];
gout[n*729+329] = + s[41];
gout[n*729+330] = + s[42];
gout[n*729+331] = + s[43];
gout[n*729+332] = + s[44];
gout[n*729+333] = + s[279];
gout[n*729+334] = + s[280];
gout[n*729+335] = + s[281];
gout[n*729+336] = + s[282];
gout[n*729+337] = + s[283];
gout[n*729+338] = + s[284];
gout[n*729+339] = + s[285];
gout[n*729+340] = + s[286];
gout[n*729+341] = + s[287];
gout[n*729+342] = + s[522];
gout[n*729+343] = + s[523];
gout[n*729+344] = + s[524];
gout[n*729+345] = + s[525];
gout[n*729+346] = + s[526];
gout[n*729+347] = + s[527];
gout[n*729+348] = + s[528];
gout[n*729+349] = + s[529];
gout[n*729+350] = + s[530];
gout[n*729+351] = + s[117];
gout[n*729+352] = + s[118];
gout[n*729+353] = + s[119];
gout[n*729+354] = + s[120];
gout[n*729+355] = + s[121];
gout[n*729+356] = + s[122];
gout[n*729+357] = + s[123];
gout[n*729+358] = + s[124];
gout[n*729+359] = + s[125];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[603];
gout[n*729+370] = + s[604];
gout[n*729+371] = + s[605];
gout[n*729+372] = + s[606];
gout[n*729+373] = + s[607];
gout[n*729+374] = + s[608];
gout[n*729+375] = + s[609];
gout[n*729+376] = + s[610];
gout[n*729+377] = + s[611];
gout[n*729+378] = + s[198];
gout[n*729+379] = + s[199];
gout[n*729+380] = + s[200];
gout[n*729+381] = + s[201];
gout[n*729+382] = + s[202];
gout[n*729+383] = + s[203];
gout[n*729+384] = + s[204];
gout[n*729+385] = + s[205];
gout[n*729+386] = + s[206];
gout[n*729+387] = + s[441];
gout[n*729+388] = + s[442];
gout[n*729+389] = + s[443];
gout[n*729+390] = + s[444];
gout[n*729+391] = + s[445];
gout[n*729+392] = + s[446];
gout[n*729+393] = + s[447];
gout[n*729+394] = + s[448];
gout[n*729+395] = + s[449];
gout[n*729+396] = + s[684];
gout[n*729+397] = + s[685];
gout[n*729+398] = + s[686];
gout[n*729+399] = + s[687];
gout[n*729+400] = + s[688];
gout[n*729+401] = + s[689];
gout[n*729+402] = + s[690];
gout[n*729+403] = + s[691];
gout[n*729+404] = + s[692];
gout[n*729+405] = + s[63];
gout[n*729+406] = + s[64];
gout[n*729+407] = + s[65];
gout[n*729+408] = + s[66];
gout[n*729+409] = + s[67];
gout[n*729+410] = + s[68];
gout[n*729+411] = + s[69];
gout[n*729+412] = + s[70];
gout[n*729+413] = + s[71];
gout[n*729+414] = + s[306];
gout[n*729+415] = + s[307];
gout[n*729+416] = + s[308];
gout[n*729+417] = + s[309];
gout[n*729+418] = + s[310];
gout[n*729+419] = + s[311];
gout[n*729+420] = + s[312];
gout[n*729+421] = + s[313];
gout[n*729+422] = + s[314];
gout[n*729+423] = + s[549];
gout[n*729+424] = + s[550];
gout[n*729+425] = + s[551];
gout[n*729+426] = + s[552];
gout[n*729+427] = + s[553];
gout[n*729+428] = + s[554];
gout[n*729+429] = + s[555];
gout[n*729+430] = + s[556];
gout[n*729+431] = + s[557];
gout[n*729+432] = + s[144];
gout[n*729+433] = + s[145];
gout[n*729+434] = + s[146];
gout[n*729+435] = + s[147];
gout[n*729+436] = + s[148];
gout[n*729+437] = + s[149];
gout[n*729+438] = + s[150];
gout[n*729+439] = + s[151];
gout[n*729+440] = + s[152];
gout[n*729+441] = + s[387];
gout[n*729+442] = + s[388];
gout[n*729+443] = + s[389];
gout[n*729+444] = + s[390];
gout[n*729+445] = + s[391];
gout[n*729+446] = + s[392];
gout[n*729+447] = + s[393];
gout[n*729+448] = + s[394];
gout[n*729+449] = + s[395];
gout[n*729+450] = + s[630];
gout[n*729+451] = + s[631];
gout[n*729+452] = + s[632];
gout[n*729+453] = + s[633];
gout[n*729+454] = + s[634];
gout[n*729+455] = + s[635];
gout[n*729+456] = + s[636];
gout[n*729+457] = + s[637];
gout[n*729+458] = + s[638];
gout[n*729+459] = + s[225];
gout[n*729+460] = + s[226];
gout[n*729+461] = + s[227];
gout[n*729+462] = + s[228];
gout[n*729+463] = + s[229];
gout[n*729+464] = + s[230];
gout[n*729+465] = + s[231];
gout[n*729+466] = + s[232];
gout[n*729+467] = + s[233];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[711];
gout[n*729+478] = + s[712];
gout[n*729+479] = + s[713];
gout[n*729+480] = + s[714];
gout[n*729+481] = + s[715];
gout[n*729+482] = + s[716];
gout[n*729+483] = + s[717];
gout[n*729+484] = + s[718];
gout[n*729+485] = + s[719];
gout[n*729+486] = + s[18];
gout[n*729+487] = + s[19];
gout[n*729+488] = + s[20];
gout[n*729+489] = + s[21];
gout[n*729+490] = + s[22];
gout[n*729+491] = + s[23];
gout[n*729+492] = + s[24];
gout[n*729+493] = + s[25];
gout[n*729+494] = + s[26];
gout[n*729+495] = + s[261];
gout[n*729+496] = + s[262];
gout[n*729+497] = + s[263];
gout[n*729+498] = + s[264];
gout[n*729+499] = + s[265];
gout[n*729+500] = + s[266];
gout[n*729+501] = + s[267];
gout[n*729+502] = + s[268];
gout[n*729+503] = + s[269];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[99];
gout[n*729+514] = + s[100];
gout[n*729+515] = + s[101];
gout[n*729+516] = + s[102];
gout[n*729+517] = + s[103];
gout[n*729+518] = + s[104];
gout[n*729+519] = + s[105];
gout[n*729+520] = + s[106];
gout[n*729+521] = + s[107];
gout[n*729+522] = + s[342];
gout[n*729+523] = + s[343];
gout[n*729+524] = + s[344];
gout[n*729+525] = + s[345];
gout[n*729+526] = + s[346];
gout[n*729+527] = + s[347];
gout[n*729+528] = + s[348];
gout[n*729+529] = + s[349];
gout[n*729+530] = + s[350];
gout[n*729+531] = + s[585];
gout[n*729+532] = + s[586];
gout[n*729+533] = + s[587];
gout[n*729+534] = + s[588];
gout[n*729+535] = + s[589];
gout[n*729+536] = + s[590];
gout[n*729+537] = + s[591];
gout[n*729+538] = + s[592];
gout[n*729+539] = + s[593];
gout[n*729+540] = + s[180];
gout[n*729+541] = + s[181];
gout[n*729+542] = + s[182];
gout[n*729+543] = + s[183];
gout[n*729+544] = + s[184];
gout[n*729+545] = + s[185];
gout[n*729+546] = + s[186];
gout[n*729+547] = + s[187];
gout[n*729+548] = + s[188];
gout[n*729+549] = + s[423];
gout[n*729+550] = + s[424];
gout[n*729+551] = + s[425];
gout[n*729+552] = + s[426];
gout[n*729+553] = + s[427];
gout[n*729+554] = + s[428];
gout[n*729+555] = + s[429];
gout[n*729+556] = + s[430];
gout[n*729+557] = + s[431];
gout[n*729+558] = + s[666];
gout[n*729+559] = + s[667];
gout[n*729+560] = + s[668];
gout[n*729+561] = + s[669];
gout[n*729+562] = + s[670];
gout[n*729+563] = + s[671];
gout[n*729+564] = + s[672];
gout[n*729+565] = + s[673];
gout[n*729+566] = + s[674];
gout[n*729+567] = + s[45];
gout[n*729+568] = + s[46];
gout[n*729+569] = + s[47];
gout[n*729+570] = + s[48];
gout[n*729+571] = + s[49];
gout[n*729+572] = + s[50];
gout[n*729+573] = + s[51];
gout[n*729+574] = + s[52];
gout[n*729+575] = + s[53];
gout[n*729+576] = + s[288];
gout[n*729+577] = + s[289];
gout[n*729+578] = + s[290];
gout[n*729+579] = + s[291];
gout[n*729+580] = + s[292];
gout[n*729+581] = + s[293];
gout[n*729+582] = + s[294];
gout[n*729+583] = + s[295];
gout[n*729+584] = + s[296];
gout[n*729+585] = + s[531];
gout[n*729+586] = + s[532];
gout[n*729+587] = + s[533];
gout[n*729+588] = + s[534];
gout[n*729+589] = + s[535];
gout[n*729+590] = + s[536];
gout[n*729+591] = + s[537];
gout[n*729+592] = + s[538];
gout[n*729+593] = + s[539];
gout[n*729+594] = + s[126];
gout[n*729+595] = + s[127];
gout[n*729+596] = + s[128];
gout[n*729+597] = + s[129];
gout[n*729+598] = + s[130];
gout[n*729+599] = + s[131];
gout[n*729+600] = + s[132];
gout[n*729+601] = + s[133];
gout[n*729+602] = + s[134];
gout[n*729+603] = + s[369];
gout[n*729+604] = + s[370];
gout[n*729+605] = + s[371];
gout[n*729+606] = + s[372];
gout[n*729+607] = + s[373];
gout[n*729+608] = + s[374];
gout[n*729+609] = + s[375];
gout[n*729+610] = + s[376];
gout[n*729+611] = + s[377];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[207];
gout[n*729+622] = + s[208];
gout[n*729+623] = + s[209];
gout[n*729+624] = + s[210];
gout[n*729+625] = + s[211];
gout[n*729+626] = + s[212];
gout[n*729+627] = + s[213];
gout[n*729+628] = + s[214];
gout[n*729+629] = + s[215];
gout[n*729+630] = + s[450];
gout[n*729+631] = + s[451];
gout[n*729+632] = + s[452];
gout[n*729+633] = + s[453];
gout[n*729+634] = + s[454];
gout[n*729+635] = + s[455];
gout[n*729+636] = + s[456];
gout[n*729+637] = + s[457];
gout[n*729+638] = + s[458];
gout[n*729+639] = + s[693];
gout[n*729+640] = + s[694];
gout[n*729+641] = + s[695];
gout[n*729+642] = + s[696];
gout[n*729+643] = + s[697];
gout[n*729+644] = + s[698];
gout[n*729+645] = + s[699];
gout[n*729+646] = + s[700];
gout[n*729+647] = + s[701];
gout[n*729+648] = + s[72];
gout[n*729+649] = + s[73];
gout[n*729+650] = + s[74];
gout[n*729+651] = + s[75];
gout[n*729+652] = + s[76];
gout[n*729+653] = + s[77];
gout[n*729+654] = + s[78];
gout[n*729+655] = + s[79];
gout[n*729+656] = + s[80];
gout[n*729+657] = + s[315];
gout[n*729+658] = + s[316];
gout[n*729+659] = + s[317];
gout[n*729+660] = + s[318];
gout[n*729+661] = + s[319];
gout[n*729+662] = + s[320];
gout[n*729+663] = + s[321];
gout[n*729+664] = + s[322];
gout[n*729+665] = + s[323];
gout[n*729+666] = + s[558];
gout[n*729+667] = + s[559];
gout[n*729+668] = + s[560];
gout[n*729+669] = + s[561];
gout[n*729+670] = + s[562];
gout[n*729+671] = + s[563];
gout[n*729+672] = + s[564];
gout[n*729+673] = + s[565];
gout[n*729+674] = + s[566];
gout[n*729+675] = + s[153];
gout[n*729+676] = + s[154];
gout[n*729+677] = + s[155];
gout[n*729+678] = + s[156];
gout[n*729+679] = + s[157];
gout[n*729+680] = + s[158];
gout[n*729+681] = + s[159];
gout[n*729+682] = + s[160];
gout[n*729+683] = + s[161];
gout[n*729+684] = + s[396];
gout[n*729+685] = + s[397];
gout[n*729+686] = + s[398];
gout[n*729+687] = + s[399];
gout[n*729+688] = + s[400];
gout[n*729+689] = + s[401];
gout[n*729+690] = + s[402];
gout[n*729+691] = + s[403];
gout[n*729+692] = + s[404];
gout[n*729+693] = + s[639];
gout[n*729+694] = + s[640];
gout[n*729+695] = + s[641];
gout[n*729+696] = + s[642];
gout[n*729+697] = + s[643];
gout[n*729+698] = + s[644];
gout[n*729+699] = + s[645];
gout[n*729+700] = + s[646];
gout[n*729+701] = + s[647];
gout[n*729+702] = + s[234];
gout[n*729+703] = + s[235];
gout[n*729+704] = + s[236];
gout[n*729+705] = + s[237];
gout[n*729+706] = + s[238];
gout[n*729+707] = + s[239];
gout[n*729+708] = + s[240];
gout[n*729+709] = + s[241];
gout[n*729+710] = + s[242];
gout[n*729+711] = + s[477];
gout[n*729+712] = + s[478];
gout[n*729+713] = + s[479];
gout[n*729+714] = + s[480];
gout[n*729+715] = + s[481];
gout[n*729+716] = + s[482];
gout[n*729+717] = + s[483];
gout[n*729+718] = + s[484];
gout[n*729+719] = + s[485];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[243];
gout[n*729+10] += + s[244];
gout[n*729+11] += + s[245];
gout[n*729+12] += + s[246];
gout[n*729+13] += + s[247];
gout[n*729+14] += + s[248];
gout[n*729+15] += + s[249];
gout[n*729+16] += + s[250];
gout[n*729+17] += + s[251];
gout[n*729+18] += + s[486];
gout[n*729+19] += + s[487];
gout[n*729+20] += + s[488];
gout[n*729+21] += + s[489];
gout[n*729+22] += + s[490];
gout[n*729+23] += + s[491];
gout[n*729+24] += + s[492];
gout[n*729+25] += + s[493];
gout[n*729+26] += + s[494];
gout[n*729+27] += + s[81];
gout[n*729+28] += + s[82];
gout[n*729+29] += + s[83];
gout[n*729+30] += + s[84];
gout[n*729+31] += + s[85];
gout[n*729+32] += + s[86];
gout[n*729+33] += + s[87];
gout[n*729+34] += + s[88];
gout[n*729+35] += + s[89];
gout[n*729+36] += + s[324];
gout[n*729+37] += + s[325];
gout[n*729+38] += + s[326];
gout[n*729+39] += + s[327];
gout[n*729+40] += + s[328];
gout[n*729+41] += + s[329];
gout[n*729+42] += + s[330];
gout[n*729+43] += + s[331];
gout[n*729+44] += + s[332];
gout[n*729+45] += + s[567];
gout[n*729+46] += + s[568];
gout[n*729+47] += + s[569];
gout[n*729+48] += + s[570];
gout[n*729+49] += + s[571];
gout[n*729+50] += + s[572];
gout[n*729+51] += + s[573];
gout[n*729+52] += + s[574];
gout[n*729+53] += + s[575];
gout[n*729+54] += + s[162];
gout[n*729+55] += + s[163];
gout[n*729+56] += + s[164];
gout[n*729+57] += + s[165];
gout[n*729+58] += + s[166];
gout[n*729+59] += + s[167];
gout[n*729+60] += + s[168];
gout[n*729+61] += + s[169];
gout[n*729+62] += + s[170];
gout[n*729+63] += + s[405];
gout[n*729+64] += + s[406];
gout[n*729+65] += + s[407];
gout[n*729+66] += + s[408];
gout[n*729+67] += + s[409];
gout[n*729+68] += + s[410];
gout[n*729+69] += + s[411];
gout[n*729+70] += + s[412];
gout[n*729+71] += + s[413];
gout[n*729+72] += + s[648];
gout[n*729+73] += + s[649];
gout[n*729+74] += + s[650];
gout[n*729+75] += + s[651];
gout[n*729+76] += + s[652];
gout[n*729+77] += + s[653];
gout[n*729+78] += + s[654];
gout[n*729+79] += + s[655];
gout[n*729+80] += + s[656];
gout[n*729+81] += + s[27];
gout[n*729+82] += + s[28];
gout[n*729+83] += + s[29];
gout[n*729+84] += + s[30];
gout[n*729+85] += + s[31];
gout[n*729+86] += + s[32];
gout[n*729+87] += + s[33];
gout[n*729+88] += + s[34];
gout[n*729+89] += + s[35];
gout[n*729+90] += + s[270];
gout[n*729+91] += + s[271];
gout[n*729+92] += + s[272];
gout[n*729+93] += + s[273];
gout[n*729+94] += + s[274];
gout[n*729+95] += + s[275];
gout[n*729+96] += + s[276];
gout[n*729+97] += + s[277];
gout[n*729+98] += + s[278];
gout[n*729+99] += + s[513];
gout[n*729+100] += + s[514];
gout[n*729+101] += + s[515];
gout[n*729+102] += + s[516];
gout[n*729+103] += + s[517];
gout[n*729+104] += + s[518];
gout[n*729+105] += + s[519];
gout[n*729+106] += + s[520];
gout[n*729+107] += + s[521];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[351];
gout[n*729+118] += + s[352];
gout[n*729+119] += + s[353];
gout[n*729+120] += + s[354];
gout[n*729+121] += + s[355];
gout[n*729+122] += + s[356];
gout[n*729+123] += + s[357];
gout[n*729+124] += + s[358];
gout[n*729+125] += + s[359];
gout[n*729+126] += + s[594];
gout[n*729+127] += + s[595];
gout[n*729+128] += + s[596];
gout[n*729+129] += + s[597];
gout[n*729+130] += + s[598];
gout[n*729+131] += + s[599];
gout[n*729+132] += + s[600];
gout[n*729+133] += + s[601];
gout[n*729+134] += + s[602];
gout[n*729+135] += + s[189];
gout[n*729+136] += + s[190];
gout[n*729+137] += + s[191];
gout[n*729+138] += + s[192];
gout[n*729+139] += + s[193];
gout[n*729+140] += + s[194];
gout[n*729+141] += + s[195];
gout[n*729+142] += + s[196];
gout[n*729+143] += + s[197];
gout[n*729+144] += + s[432];
gout[n*729+145] += + s[433];
gout[n*729+146] += + s[434];
gout[n*729+147] += + s[435];
gout[n*729+148] += + s[436];
gout[n*729+149] += + s[437];
gout[n*729+150] += + s[438];
gout[n*729+151] += + s[439];
gout[n*729+152] += + s[440];
gout[n*729+153] += + s[675];
gout[n*729+154] += + s[676];
gout[n*729+155] += + s[677];
gout[n*729+156] += + s[678];
gout[n*729+157] += + s[679];
gout[n*729+158] += + s[680];
gout[n*729+159] += + s[681];
gout[n*729+160] += + s[682];
gout[n*729+161] += + s[683];
gout[n*729+162] += + s[54];
gout[n*729+163] += + s[55];
gout[n*729+164] += + s[56];
gout[n*729+165] += + s[57];
gout[n*729+166] += + s[58];
gout[n*729+167] += + s[59];
gout[n*729+168] += + s[60];
gout[n*729+169] += + s[61];
gout[n*729+170] += + s[62];
gout[n*729+171] += + s[297];
gout[n*729+172] += + s[298];
gout[n*729+173] += + s[299];
gout[n*729+174] += + s[300];
gout[n*729+175] += + s[301];
gout[n*729+176] += + s[302];
gout[n*729+177] += + s[303];
gout[n*729+178] += + s[304];
gout[n*729+179] += + s[305];
gout[n*729+180] += + s[540];
gout[n*729+181] += + s[541];
gout[n*729+182] += + s[542];
gout[n*729+183] += + s[543];
gout[n*729+184] += + s[544];
gout[n*729+185] += + s[545];
gout[n*729+186] += + s[546];
gout[n*729+187] += + s[547];
gout[n*729+188] += + s[548];
gout[n*729+189] += + s[135];
gout[n*729+190] += + s[136];
gout[n*729+191] += + s[137];
gout[n*729+192] += + s[138];
gout[n*729+193] += + s[139];
gout[n*729+194] += + s[140];
gout[n*729+195] += + s[141];
gout[n*729+196] += + s[142];
gout[n*729+197] += + s[143];
gout[n*729+198] += + s[378];
gout[n*729+199] += + s[379];
gout[n*729+200] += + s[380];
gout[n*729+201] += + s[381];
gout[n*729+202] += + s[382];
gout[n*729+203] += + s[383];
gout[n*729+204] += + s[384];
gout[n*729+205] += + s[385];
gout[n*729+206] += + s[386];
gout[n*729+207] += + s[621];
gout[n*729+208] += + s[622];
gout[n*729+209] += + s[623];
gout[n*729+210] += + s[624];
gout[n*729+211] += + s[625];
gout[n*729+212] += + s[626];
gout[n*729+213] += + s[627];
gout[n*729+214] += + s[628];
gout[n*729+215] += + s[629];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[459];
gout[n*729+226] += + s[460];
gout[n*729+227] += + s[461];
gout[n*729+228] += + s[462];
gout[n*729+229] += + s[463];
gout[n*729+230] += + s[464];
gout[n*729+231] += + s[465];
gout[n*729+232] += + s[466];
gout[n*729+233] += + s[467];
gout[n*729+234] += + s[702];
gout[n*729+235] += + s[703];
gout[n*729+236] += + s[704];
gout[n*729+237] += + s[705];
gout[n*729+238] += + s[706];
gout[n*729+239] += + s[707];
gout[n*729+240] += + s[708];
gout[n*729+241] += + s[709];
gout[n*729+242] += + s[710];
gout[n*729+243] += + s[9];
gout[n*729+244] += + s[10];
gout[n*729+245] += + s[11];
gout[n*729+246] += + s[12];
gout[n*729+247] += + s[13];
gout[n*729+248] += + s[14];
gout[n*729+249] += + s[15];
gout[n*729+250] += + s[16];
gout[n*729+251] += + s[17];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[495];
gout[n*729+262] += + s[496];
gout[n*729+263] += + s[497];
gout[n*729+264] += + s[498];
gout[n*729+265] += + s[499];
gout[n*729+266] += + s[500];
gout[n*729+267] += + s[501];
gout[n*729+268] += + s[502];
gout[n*729+269] += + s[503];
gout[n*729+270] += + s[90];
gout[n*729+271] += + s[91];
gout[n*729+272] += + s[92];
gout[n*729+273] += + s[93];
gout[n*729+274] += + s[94];
gout[n*729+275] += + s[95];
gout[n*729+276] += + s[96];
gout[n*729+277] += + s[97];
gout[n*729+278] += + s[98];
gout[n*729+279] += + s[333];
gout[n*729+280] += + s[334];
gout[n*729+281] += + s[335];
gout[n*729+282] += + s[336];
gout[n*729+283] += + s[337];
gout[n*729+284] += + s[338];
gout[n*729+285] += + s[339];
gout[n*729+286] += + s[340];
gout[n*729+287] += + s[341];
gout[n*729+288] += + s[576];
gout[n*729+289] += + s[577];
gout[n*729+290] += + s[578];
gout[n*729+291] += + s[579];
gout[n*729+292] += + s[580];
gout[n*729+293] += + s[581];
gout[n*729+294] += + s[582];
gout[n*729+295] += + s[583];
gout[n*729+296] += + s[584];
gout[n*729+297] += + s[171];
gout[n*729+298] += + s[172];
gout[n*729+299] += + s[173];
gout[n*729+300] += + s[174];
gout[n*729+301] += + s[175];
gout[n*729+302] += + s[176];
gout[n*729+303] += + s[177];
gout[n*729+304] += + s[178];
gout[n*729+305] += + s[179];
gout[n*729+306] += + s[414];
gout[n*729+307] += + s[415];
gout[n*729+308] += + s[416];
gout[n*729+309] += + s[417];
gout[n*729+310] += + s[418];
gout[n*729+311] += + s[419];
gout[n*729+312] += + s[420];
gout[n*729+313] += + s[421];
gout[n*729+314] += + s[422];
gout[n*729+315] += + s[657];
gout[n*729+316] += + s[658];
gout[n*729+317] += + s[659];
gout[n*729+318] += + s[660];
gout[n*729+319] += + s[661];
gout[n*729+320] += + s[662];
gout[n*729+321] += + s[663];
gout[n*729+322] += + s[664];
gout[n*729+323] += + s[665];
gout[n*729+324] += + s[36];
gout[n*729+325] += + s[37];
gout[n*729+326] += + s[38];
gout[n*729+327] += + s[39];
gout[n*729+328] += + s[40];
gout[n*729+329] += + s[41];
gout[n*729+330] += + s[42];
gout[n*729+331] += + s[43];
gout[n*729+332] += + s[44];
gout[n*729+333] += + s[279];
gout[n*729+334] += + s[280];
gout[n*729+335] += + s[281];
gout[n*729+336] += + s[282];
gout[n*729+337] += + s[283];
gout[n*729+338] += + s[284];
gout[n*729+339] += + s[285];
gout[n*729+340] += + s[286];
gout[n*729+341] += + s[287];
gout[n*729+342] += + s[522];
gout[n*729+343] += + s[523];
gout[n*729+344] += + s[524];
gout[n*729+345] += + s[525];
gout[n*729+346] += + s[526];
gout[n*729+347] += + s[527];
gout[n*729+348] += + s[528];
gout[n*729+349] += + s[529];
gout[n*729+350] += + s[530];
gout[n*729+351] += + s[117];
gout[n*729+352] += + s[118];
gout[n*729+353] += + s[119];
gout[n*729+354] += + s[120];
gout[n*729+355] += + s[121];
gout[n*729+356] += + s[122];
gout[n*729+357] += + s[123];
gout[n*729+358] += + s[124];
gout[n*729+359] += + s[125];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[603];
gout[n*729+370] += + s[604];
gout[n*729+371] += + s[605];
gout[n*729+372] += + s[606];
gout[n*729+373] += + s[607];
gout[n*729+374] += + s[608];
gout[n*729+375] += + s[609];
gout[n*729+376] += + s[610];
gout[n*729+377] += + s[611];
gout[n*729+378] += + s[198];
gout[n*729+379] += + s[199];
gout[n*729+380] += + s[200];
gout[n*729+381] += + s[201];
gout[n*729+382] += + s[202];
gout[n*729+383] += + s[203];
gout[n*729+384] += + s[204];
gout[n*729+385] += + s[205];
gout[n*729+386] += + s[206];
gout[n*729+387] += + s[441];
gout[n*729+388] += + s[442];
gout[n*729+389] += + s[443];
gout[n*729+390] += + s[444];
gout[n*729+391] += + s[445];
gout[n*729+392] += + s[446];
gout[n*729+393] += + s[447];
gout[n*729+394] += + s[448];
gout[n*729+395] += + s[449];
gout[n*729+396] += + s[684];
gout[n*729+397] += + s[685];
gout[n*729+398] += + s[686];
gout[n*729+399] += + s[687];
gout[n*729+400] += + s[688];
gout[n*729+401] += + s[689];
gout[n*729+402] += + s[690];
gout[n*729+403] += + s[691];
gout[n*729+404] += + s[692];
gout[n*729+405] += + s[63];
gout[n*729+406] += + s[64];
gout[n*729+407] += + s[65];
gout[n*729+408] += + s[66];
gout[n*729+409] += + s[67];
gout[n*729+410] += + s[68];
gout[n*729+411] += + s[69];
gout[n*729+412] += + s[70];
gout[n*729+413] += + s[71];
gout[n*729+414] += + s[306];
gout[n*729+415] += + s[307];
gout[n*729+416] += + s[308];
gout[n*729+417] += + s[309];
gout[n*729+418] += + s[310];
gout[n*729+419] += + s[311];
gout[n*729+420] += + s[312];
gout[n*729+421] += + s[313];
gout[n*729+422] += + s[314];
gout[n*729+423] += + s[549];
gout[n*729+424] += + s[550];
gout[n*729+425] += + s[551];
gout[n*729+426] += + s[552];
gout[n*729+427] += + s[553];
gout[n*729+428] += + s[554];
gout[n*729+429] += + s[555];
gout[n*729+430] += + s[556];
gout[n*729+431] += + s[557];
gout[n*729+432] += + s[144];
gout[n*729+433] += + s[145];
gout[n*729+434] += + s[146];
gout[n*729+435] += + s[147];
gout[n*729+436] += + s[148];
gout[n*729+437] += + s[149];
gout[n*729+438] += + s[150];
gout[n*729+439] += + s[151];
gout[n*729+440] += + s[152];
gout[n*729+441] += + s[387];
gout[n*729+442] += + s[388];
gout[n*729+443] += + s[389];
gout[n*729+444] += + s[390];
gout[n*729+445] += + s[391];
gout[n*729+446] += + s[392];
gout[n*729+447] += + s[393];
gout[n*729+448] += + s[394];
gout[n*729+449] += + s[395];
gout[n*729+450] += + s[630];
gout[n*729+451] += + s[631];
gout[n*729+452] += + s[632];
gout[n*729+453] += + s[633];
gout[n*729+454] += + s[634];
gout[n*729+455] += + s[635];
gout[n*729+456] += + s[636];
gout[n*729+457] += + s[637];
gout[n*729+458] += + s[638];
gout[n*729+459] += + s[225];
gout[n*729+460] += + s[226];
gout[n*729+461] += + s[227];
gout[n*729+462] += + s[228];
gout[n*729+463] += + s[229];
gout[n*729+464] += + s[230];
gout[n*729+465] += + s[231];
gout[n*729+466] += + s[232];
gout[n*729+467] += + s[233];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[711];
gout[n*729+478] += + s[712];
gout[n*729+479] += + s[713];
gout[n*729+480] += + s[714];
gout[n*729+481] += + s[715];
gout[n*729+482] += + s[716];
gout[n*729+483] += + s[717];
gout[n*729+484] += + s[718];
gout[n*729+485] += + s[719];
gout[n*729+486] += + s[18];
gout[n*729+487] += + s[19];
gout[n*729+488] += + s[20];
gout[n*729+489] += + s[21];
gout[n*729+490] += + s[22];
gout[n*729+491] += + s[23];
gout[n*729+492] += + s[24];
gout[n*729+493] += + s[25];
gout[n*729+494] += + s[26];
gout[n*729+495] += + s[261];
gout[n*729+496] += + s[262];
gout[n*729+497] += + s[263];
gout[n*729+498] += + s[264];
gout[n*729+499] += + s[265];
gout[n*729+500] += + s[266];
gout[n*729+501] += + s[267];
gout[n*729+502] += + s[268];
gout[n*729+503] += + s[269];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[99];
gout[n*729+514] += + s[100];
gout[n*729+515] += + s[101];
gout[n*729+516] += + s[102];
gout[n*729+517] += + s[103];
gout[n*729+518] += + s[104];
gout[n*729+519] += + s[105];
gout[n*729+520] += + s[106];
gout[n*729+521] += + s[107];
gout[n*729+522] += + s[342];
gout[n*729+523] += + s[343];
gout[n*729+524] += + s[344];
gout[n*729+525] += + s[345];
gout[n*729+526] += + s[346];
gout[n*729+527] += + s[347];
gout[n*729+528] += + s[348];
gout[n*729+529] += + s[349];
gout[n*729+530] += + s[350];
gout[n*729+531] += + s[585];
gout[n*729+532] += + s[586];
gout[n*729+533] += + s[587];
gout[n*729+534] += + s[588];
gout[n*729+535] += + s[589];
gout[n*729+536] += + s[590];
gout[n*729+537] += + s[591];
gout[n*729+538] += + s[592];
gout[n*729+539] += + s[593];
gout[n*729+540] += + s[180];
gout[n*729+541] += + s[181];
gout[n*729+542] += + s[182];
gout[n*729+543] += + s[183];
gout[n*729+544] += + s[184];
gout[n*729+545] += + s[185];
gout[n*729+546] += + s[186];
gout[n*729+547] += + s[187];
gout[n*729+548] += + s[188];
gout[n*729+549] += + s[423];
gout[n*729+550] += + s[424];
gout[n*729+551] += + s[425];
gout[n*729+552] += + s[426];
gout[n*729+553] += + s[427];
gout[n*729+554] += + s[428];
gout[n*729+555] += + s[429];
gout[n*729+556] += + s[430];
gout[n*729+557] += + s[431];
gout[n*729+558] += + s[666];
gout[n*729+559] += + s[667];
gout[n*729+560] += + s[668];
gout[n*729+561] += + s[669];
gout[n*729+562] += + s[670];
gout[n*729+563] += + s[671];
gout[n*729+564] += + s[672];
gout[n*729+565] += + s[673];
gout[n*729+566] += + s[674];
gout[n*729+567] += + s[45];
gout[n*729+568] += + s[46];
gout[n*729+569] += + s[47];
gout[n*729+570] += + s[48];
gout[n*729+571] += + s[49];
gout[n*729+572] += + s[50];
gout[n*729+573] += + s[51];
gout[n*729+574] += + s[52];
gout[n*729+575] += + s[53];
gout[n*729+576] += + s[288];
gout[n*729+577] += + s[289];
gout[n*729+578] += + s[290];
gout[n*729+579] += + s[291];
gout[n*729+580] += + s[292];
gout[n*729+581] += + s[293];
gout[n*729+582] += + s[294];
gout[n*729+583] += + s[295];
gout[n*729+584] += + s[296];
gout[n*729+585] += + s[531];
gout[n*729+586] += + s[532];
gout[n*729+587] += + s[533];
gout[n*729+588] += + s[534];
gout[n*729+589] += + s[535];
gout[n*729+590] += + s[536];
gout[n*729+591] += + s[537];
gout[n*729+592] += + s[538];
gout[n*729+593] += + s[539];
gout[n*729+594] += + s[126];
gout[n*729+595] += + s[127];
gout[n*729+596] += + s[128];
gout[n*729+597] += + s[129];
gout[n*729+598] += + s[130];
gout[n*729+599] += + s[131];
gout[n*729+600] += + s[132];
gout[n*729+601] += + s[133];
gout[n*729+602] += + s[134];
gout[n*729+603] += + s[369];
gout[n*729+604] += + s[370];
gout[n*729+605] += + s[371];
gout[n*729+606] += + s[372];
gout[n*729+607] += + s[373];
gout[n*729+608] += + s[374];
gout[n*729+609] += + s[375];
gout[n*729+610] += + s[376];
gout[n*729+611] += + s[377];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[207];
gout[n*729+622] += + s[208];
gout[n*729+623] += + s[209];
gout[n*729+624] += + s[210];
gout[n*729+625] += + s[211];
gout[n*729+626] += + s[212];
gout[n*729+627] += + s[213];
gout[n*729+628] += + s[214];
gout[n*729+629] += + s[215];
gout[n*729+630] += + s[450];
gout[n*729+631] += + s[451];
gout[n*729+632] += + s[452];
gout[n*729+633] += + s[453];
gout[n*729+634] += + s[454];
gout[n*729+635] += + s[455];
gout[n*729+636] += + s[456];
gout[n*729+637] += + s[457];
gout[n*729+638] += + s[458];
gout[n*729+639] += + s[693];
gout[n*729+640] += + s[694];
gout[n*729+641] += + s[695];
gout[n*729+642] += + s[696];
gout[n*729+643] += + s[697];
gout[n*729+644] += + s[698];
gout[n*729+645] += + s[699];
gout[n*729+646] += + s[700];
gout[n*729+647] += + s[701];
gout[n*729+648] += + s[72];
gout[n*729+649] += + s[73];
gout[n*729+650] += + s[74];
gout[n*729+651] += + s[75];
gout[n*729+652] += + s[76];
gout[n*729+653] += + s[77];
gout[n*729+654] += + s[78];
gout[n*729+655] += + s[79];
gout[n*729+656] += + s[80];
gout[n*729+657] += + s[315];
gout[n*729+658] += + s[316];
gout[n*729+659] += + s[317];
gout[n*729+660] += + s[318];
gout[n*729+661] += + s[319];
gout[n*729+662] += + s[320];
gout[n*729+663] += + s[321];
gout[n*729+664] += + s[322];
gout[n*729+665] += + s[323];
gout[n*729+666] += + s[558];
gout[n*729+667] += + s[559];
gout[n*729+668] += + s[560];
gout[n*729+669] += + s[561];
gout[n*729+670] += + s[562];
gout[n*729+671] += + s[563];
gout[n*729+672] += + s[564];
gout[n*729+673] += + s[565];
gout[n*729+674] += + s[566];
gout[n*729+675] += + s[153];
gout[n*729+676] += + s[154];
gout[n*729+677] += + s[155];
gout[n*729+678] += + s[156];
gout[n*729+679] += + s[157];
gout[n*729+680] += + s[158];
gout[n*729+681] += + s[159];
gout[n*729+682] += + s[160];
gout[n*729+683] += + s[161];
gout[n*729+684] += + s[396];
gout[n*729+685] += + s[397];
gout[n*729+686] += + s[398];
gout[n*729+687] += + s[399];
gout[n*729+688] += + s[400];
gout[n*729+689] += + s[401];
gout[n*729+690] += + s[402];
gout[n*729+691] += + s[403];
gout[n*729+692] += + s[404];
gout[n*729+693] += + s[639];
gout[n*729+694] += + s[640];
gout[n*729+695] += + s[641];
gout[n*729+696] += + s[642];
gout[n*729+697] += + s[643];
gout[n*729+698] += + s[644];
gout[n*729+699] += + s[645];
gout[n*729+700] += + s[646];
gout[n*729+701] += + s[647];
gout[n*729+702] += + s[234];
gout[n*729+703] += + s[235];
gout[n*729+704] += + s[236];
gout[n*729+705] += + s[237];
gout[n*729+706] += + s[238];
gout[n*729+707] += + s[239];
gout[n*729+708] += + s[240];
gout[n*729+709] += + s[241];
gout[n*729+710] += + s[242];
gout[n*729+711] += + s[477];
gout[n*729+712] += + s[478];
gout[n*729+713] += + s[479];
gout[n*729+714] += + s[480];
gout[n*729+715] += + s[481];
gout[n*729+716] += + s[482];
gout[n*729+717] += + s[483];
gout[n*729+718] += + s[484];
gout[n*729+719] += + s[485];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipipipmm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipipmm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipipmm_cart
CACHE_SIZE_T int1e_ipipipipmm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipipmm_sph
CACHE_SIZE_T int1e_ipipipipmm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipmm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipipmm_spinor
ALL_CINT1E(int1e_ipipipipmm)
ALL_CINT1E_FORTRAN_(int1e_ipipipipmm)
/* <NABLA i|RI RI |NABLA j> */
void CINTgout1e_int1e_ipmmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipmmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmmip_cart
CACHE_SIZE_T int1e_ipmmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmmip_sph
CACHE_SIZE_T int1e_ipmmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmmip_spinor
ALL_CINT1E(int1e_ipmmip)
ALL_CINT1E_FORTRAN_(int1e_ipmmip)
/* <NABLA i|RI RI |NABLA NABLA j> */
void CINTgout1e_int1e_ipmmipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipmmipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmmipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmmipip_cart
CACHE_SIZE_T int1e_ipmmipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmmipip_sph
CACHE_SIZE_T int1e_ipmmipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmmipip_spinor
ALL_CINT1E(int1e_ipmmipip)
ALL_CINT1E_FORTRAN_(int1e_ipmmipip)
/* <NABLA NABLA i|RI RI |NABLA j> */
void CINTgout1e_int1e_ipipmmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipmmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipmmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipmmip_cart
CACHE_SIZE_T int1e_ipipmmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipmmip_sph
CACHE_SIZE_T int1e_ipipmmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipmmip_spinor
ALL_CINT1E(int1e_ipipmmip)
ALL_CINT1E_FORTRAN_(int1e_ipipmmip)
/* <NABLA i|RI RI |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_ipmmipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+1, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipmmipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmmipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmmipipip_cart
CACHE_SIZE_T int1e_ipmmipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmmipipip_sph
CACHE_SIZE_T int1e_ipmmipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmmipipip_spinor
ALL_CINT1E(int1e_ipmmipipip)
ALL_CINT1E_FORTRAN_(int1e_ipmmipipip)
/* <NABLA NABLA NABLA i|RI RI |NABLA j> */
void CINTgout1e_int1e_ipipipmmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+3, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+3, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[243];
gout[n*729+28] = + s[244];
gout[n*729+29] = + s[245];
gout[n*729+30] = + s[246];
gout[n*729+31] = + s[247];
gout[n*729+32] = + s[248];
gout[n*729+33] = + s[249];
gout[n*729+34] = + s[250];
gout[n*729+35] = + s[251];
gout[n*729+36] = + s[252];
gout[n*729+37] = + s[253];
gout[n*729+38] = + s[254];
gout[n*729+39] = + s[255];
gout[n*729+40] = + s[256];
gout[n*729+41] = + s[257];
gout[n*729+42] = + s[258];
gout[n*729+43] = + s[259];
gout[n*729+44] = + s[260];
gout[n*729+45] = + s[261];
gout[n*729+46] = + s[262];
gout[n*729+47] = + s[263];
gout[n*729+48] = + s[264];
gout[n*729+49] = + s[265];
gout[n*729+50] = + s[266];
gout[n*729+51] = + s[267];
gout[n*729+52] = + s[268];
gout[n*729+53] = + s[269];
gout[n*729+54] = + s[486];
gout[n*729+55] = + s[487];
gout[n*729+56] = + s[488];
gout[n*729+57] = + s[489];
gout[n*729+58] = + s[490];
gout[n*729+59] = + s[491];
gout[n*729+60] = + s[492];
gout[n*729+61] = + s[493];
gout[n*729+62] = + s[494];
gout[n*729+63] = + s[495];
gout[n*729+64] = + s[496];
gout[n*729+65] = + s[497];
gout[n*729+66] = + s[498];
gout[n*729+67] = + s[499];
gout[n*729+68] = + s[500];
gout[n*729+69] = + s[501];
gout[n*729+70] = + s[502];
gout[n*729+71] = + s[503];
gout[n*729+72] = + s[504];
gout[n*729+73] = + s[505];
gout[n*729+74] = + s[506];
gout[n*729+75] = + s[507];
gout[n*729+76] = + s[508];
gout[n*729+77] = + s[509];
gout[n*729+78] = + s[510];
gout[n*729+79] = + s[511];
gout[n*729+80] = + s[512];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[324];
gout[n*729+109] = + s[325];
gout[n*729+110] = + s[326];
gout[n*729+111] = + s[327];
gout[n*729+112] = + s[328];
gout[n*729+113] = + s[329];
gout[n*729+114] = + s[330];
gout[n*729+115] = + s[331];
gout[n*729+116] = + s[332];
gout[n*729+117] = + s[333];
gout[n*729+118] = + s[334];
gout[n*729+119] = + s[335];
gout[n*729+120] = + s[336];
gout[n*729+121] = + s[337];
gout[n*729+122] = + s[338];
gout[n*729+123] = + s[339];
gout[n*729+124] = + s[340];
gout[n*729+125] = + s[341];
gout[n*729+126] = + s[342];
gout[n*729+127] = + s[343];
gout[n*729+128] = + s[344];
gout[n*729+129] = + s[345];
gout[n*729+130] = + s[346];
gout[n*729+131] = + s[347];
gout[n*729+132] = + s[348];
gout[n*729+133] = + s[349];
gout[n*729+134] = + s[350];
gout[n*729+135] = + s[567];
gout[n*729+136] = + s[568];
gout[n*729+137] = + s[569];
gout[n*729+138] = + s[570];
gout[n*729+139] = + s[571];
gout[n*729+140] = + s[572];
gout[n*729+141] = + s[573];
gout[n*729+142] = + s[574];
gout[n*729+143] = + s[575];
gout[n*729+144] = + s[576];
gout[n*729+145] = + s[577];
gout[n*729+146] = + s[578];
gout[n*729+147] = + s[579];
gout[n*729+148] = + s[580];
gout[n*729+149] = + s[581];
gout[n*729+150] = + s[582];
gout[n*729+151] = + s[583];
gout[n*729+152] = + s[584];
gout[n*729+153] = + s[585];
gout[n*729+154] = + s[586];
gout[n*729+155] = + s[587];
gout[n*729+156] = + s[588];
gout[n*729+157] = + s[589];
gout[n*729+158] = + s[590];
gout[n*729+159] = + s[591];
gout[n*729+160] = + s[592];
gout[n*729+161] = + s[593];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[405];
gout[n*729+190] = + s[406];
gout[n*729+191] = + s[407];
gout[n*729+192] = + s[408];
gout[n*729+193] = + s[409];
gout[n*729+194] = + s[410];
gout[n*729+195] = + s[411];
gout[n*729+196] = + s[412];
gout[n*729+197] = + s[413];
gout[n*729+198] = + s[414];
gout[n*729+199] = + s[415];
gout[n*729+200] = + s[416];
gout[n*729+201] = + s[417];
gout[n*729+202] = + s[418];
gout[n*729+203] = + s[419];
gout[n*729+204] = + s[420];
gout[n*729+205] = + s[421];
gout[n*729+206] = + s[422];
gout[n*729+207] = + s[423];
gout[n*729+208] = + s[424];
gout[n*729+209] = + s[425];
gout[n*729+210] = + s[426];
gout[n*729+211] = + s[427];
gout[n*729+212] = + s[428];
gout[n*729+213] = + s[429];
gout[n*729+214] = + s[430];
gout[n*729+215] = + s[431];
gout[n*729+216] = + s[648];
gout[n*729+217] = + s[649];
gout[n*729+218] = + s[650];
gout[n*729+219] = + s[651];
gout[n*729+220] = + s[652];
gout[n*729+221] = + s[653];
gout[n*729+222] = + s[654];
gout[n*729+223] = + s[655];
gout[n*729+224] = + s[656];
gout[n*729+225] = + s[657];
gout[n*729+226] = + s[658];
gout[n*729+227] = + s[659];
gout[n*729+228] = + s[660];
gout[n*729+229] = + s[661];
gout[n*729+230] = + s[662];
gout[n*729+231] = + s[663];
gout[n*729+232] = + s[664];
gout[n*729+233] = + s[665];
gout[n*729+234] = + s[666];
gout[n*729+235] = + s[667];
gout[n*729+236] = + s[668];
gout[n*729+237] = + s[669];
gout[n*729+238] = + s[670];
gout[n*729+239] = + s[671];
gout[n*729+240] = + s[672];
gout[n*729+241] = + s[673];
gout[n*729+242] = + s[674];
gout[n*729+243] = + s[27];
gout[n*729+244] = + s[28];
gout[n*729+245] = + s[29];
gout[n*729+246] = + s[30];
gout[n*729+247] = + s[31];
gout[n*729+248] = + s[32];
gout[n*729+249] = + s[33];
gout[n*729+250] = + s[34];
gout[n*729+251] = + s[35];
gout[n*729+252] = + s[36];
gout[n*729+253] = + s[37];
gout[n*729+254] = + s[38];
gout[n*729+255] = + s[39];
gout[n*729+256] = + s[40];
gout[n*729+257] = + s[41];
gout[n*729+258] = + s[42];
gout[n*729+259] = + s[43];
gout[n*729+260] = + s[44];
gout[n*729+261] = + s[45];
gout[n*729+262] = + s[46];
gout[n*729+263] = + s[47];
gout[n*729+264] = + s[48];
gout[n*729+265] = + s[49];
gout[n*729+266] = + s[50];
gout[n*729+267] = + s[51];
gout[n*729+268] = + s[52];
gout[n*729+269] = + s[53];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[513];
gout[n*729+298] = + s[514];
gout[n*729+299] = + s[515];
gout[n*729+300] = + s[516];
gout[n*729+301] = + s[517];
gout[n*729+302] = + s[518];
gout[n*729+303] = + s[519];
gout[n*729+304] = + s[520];
gout[n*729+305] = + s[521];
gout[n*729+306] = + s[522];
gout[n*729+307] = + s[523];
gout[n*729+308] = + s[524];
gout[n*729+309] = + s[525];
gout[n*729+310] = + s[526];
gout[n*729+311] = + s[527];
gout[n*729+312] = + s[528];
gout[n*729+313] = + s[529];
gout[n*729+314] = + s[530];
gout[n*729+315] = + s[531];
gout[n*729+316] = + s[532];
gout[n*729+317] = + s[533];
gout[n*729+318] = + s[534];
gout[n*729+319] = + s[535];
gout[n*729+320] = + s[536];
gout[n*729+321] = + s[537];
gout[n*729+322] = + s[538];
gout[n*729+323] = + s[539];
gout[n*729+324] = + s[108];
gout[n*729+325] = + s[109];
gout[n*729+326] = + s[110];
gout[n*729+327] = + s[111];
gout[n*729+328] = + s[112];
gout[n*729+329] = + s[113];
gout[n*729+330] = + s[114];
gout[n*729+331] = + s[115];
gout[n*729+332] = + s[116];
gout[n*729+333] = + s[117];
gout[n*729+334] = + s[118];
gout[n*729+335] = + s[119];
gout[n*729+336] = + s[120];
gout[n*729+337] = + s[121];
gout[n*729+338] = + s[122];
gout[n*729+339] = + s[123];
gout[n*729+340] = + s[124];
gout[n*729+341] = + s[125];
gout[n*729+342] = + s[126];
gout[n*729+343] = + s[127];
gout[n*729+344] = + s[128];
gout[n*729+345] = + s[129];
gout[n*729+346] = + s[130];
gout[n*729+347] = + s[131];
gout[n*729+348] = + s[132];
gout[n*729+349] = + s[133];
gout[n*729+350] = + s[134];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[594];
gout[n*729+379] = + s[595];
gout[n*729+380] = + s[596];
gout[n*729+381] = + s[597];
gout[n*729+382] = + s[598];
gout[n*729+383] = + s[599];
gout[n*729+384] = + s[600];
gout[n*729+385] = + s[601];
gout[n*729+386] = + s[602];
gout[n*729+387] = + s[603];
gout[n*729+388] = + s[604];
gout[n*729+389] = + s[605];
gout[n*729+390] = + s[606];
gout[n*729+391] = + s[607];
gout[n*729+392] = + s[608];
gout[n*729+393] = + s[609];
gout[n*729+394] = + s[610];
gout[n*729+395] = + s[611];
gout[n*729+396] = + s[612];
gout[n*729+397] = + s[613];
gout[n*729+398] = + s[614];
gout[n*729+399] = + s[615];
gout[n*729+400] = + s[616];
gout[n*729+401] = + s[617];
gout[n*729+402] = + s[618];
gout[n*729+403] = + s[619];
gout[n*729+404] = + s[620];
gout[n*729+405] = + s[189];
gout[n*729+406] = + s[190];
gout[n*729+407] = + s[191];
gout[n*729+408] = + s[192];
gout[n*729+409] = + s[193];
gout[n*729+410] = + s[194];
gout[n*729+411] = + s[195];
gout[n*729+412] = + s[196];
gout[n*729+413] = + s[197];
gout[n*729+414] = + s[198];
gout[n*729+415] = + s[199];
gout[n*729+416] = + s[200];
gout[n*729+417] = + s[201];
gout[n*729+418] = + s[202];
gout[n*729+419] = + s[203];
gout[n*729+420] = + s[204];
gout[n*729+421] = + s[205];
gout[n*729+422] = + s[206];
gout[n*729+423] = + s[207];
gout[n*729+424] = + s[208];
gout[n*729+425] = + s[209];
gout[n*729+426] = + s[210];
gout[n*729+427] = + s[211];
gout[n*729+428] = + s[212];
gout[n*729+429] = + s[213];
gout[n*729+430] = + s[214];
gout[n*729+431] = + s[215];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[675];
gout[n*729+460] = + s[676];
gout[n*729+461] = + s[677];
gout[n*729+462] = + s[678];
gout[n*729+463] = + s[679];
gout[n*729+464] = + s[680];
gout[n*729+465] = + s[681];
gout[n*729+466] = + s[682];
gout[n*729+467] = + s[683];
gout[n*729+468] = + s[684];
gout[n*729+469] = + s[685];
gout[n*729+470] = + s[686];
gout[n*729+471] = + s[687];
gout[n*729+472] = + s[688];
gout[n*729+473] = + s[689];
gout[n*729+474] = + s[690];
gout[n*729+475] = + s[691];
gout[n*729+476] = + s[692];
gout[n*729+477] = + s[693];
gout[n*729+478] = + s[694];
gout[n*729+479] = + s[695];
gout[n*729+480] = + s[696];
gout[n*729+481] = + s[697];
gout[n*729+482] = + s[698];
gout[n*729+483] = + s[699];
gout[n*729+484] = + s[700];
gout[n*729+485] = + s[701];
gout[n*729+486] = + s[54];
gout[n*729+487] = + s[55];
gout[n*729+488] = + s[56];
gout[n*729+489] = + s[57];
gout[n*729+490] = + s[58];
gout[n*729+491] = + s[59];
gout[n*729+492] = + s[60];
gout[n*729+493] = + s[61];
gout[n*729+494] = + s[62];
gout[n*729+495] = + s[63];
gout[n*729+496] = + s[64];
gout[n*729+497] = + s[65];
gout[n*729+498] = + s[66];
gout[n*729+499] = + s[67];
gout[n*729+500] = + s[68];
gout[n*729+501] = + s[69];
gout[n*729+502] = + s[70];
gout[n*729+503] = + s[71];
gout[n*729+504] = + s[72];
gout[n*729+505] = + s[73];
gout[n*729+506] = + s[74];
gout[n*729+507] = + s[75];
gout[n*729+508] = + s[76];
gout[n*729+509] = + s[77];
gout[n*729+510] = + s[78];
gout[n*729+511] = + s[79];
gout[n*729+512] = + s[80];
gout[n*729+513] = + s[297];
gout[n*729+514] = + s[298];
gout[n*729+515] = + s[299];
gout[n*729+516] = + s[300];
gout[n*729+517] = + s[301];
gout[n*729+518] = + s[302];
gout[n*729+519] = + s[303];
gout[n*729+520] = + s[304];
gout[n*729+521] = + s[305];
gout[n*729+522] = + s[306];
gout[n*729+523] = + s[307];
gout[n*729+524] = + s[308];
gout[n*729+525] = + s[309];
gout[n*729+526] = + s[310];
gout[n*729+527] = + s[311];
gout[n*729+528] = + s[312];
gout[n*729+529] = + s[313];
gout[n*729+530] = + s[314];
gout[n*729+531] = + s[315];
gout[n*729+532] = + s[316];
gout[n*729+533] = + s[317];
gout[n*729+534] = + s[318];
gout[n*729+535] = + s[319];
gout[n*729+536] = + s[320];
gout[n*729+537] = + s[321];
gout[n*729+538] = + s[322];
gout[n*729+539] = + s[323];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[135];
gout[n*729+568] = + s[136];
gout[n*729+569] = + s[137];
gout[n*729+570] = + s[138];
gout[n*729+571] = + s[139];
gout[n*729+572] = + s[140];
gout[n*729+573] = + s[141];
gout[n*729+574] = + s[142];
gout[n*729+575] = + s[143];
gout[n*729+576] = + s[144];
gout[n*729+577] = + s[145];
gout[n*729+578] = + s[146];
gout[n*729+579] = + s[147];
gout[n*729+580] = + s[148];
gout[n*729+581] = + s[149];
gout[n*729+582] = + s[150];
gout[n*729+583] = + s[151];
gout[n*729+584] = + s[152];
gout[n*729+585] = + s[153];
gout[n*729+586] = + s[154];
gout[n*729+587] = + s[155];
gout[n*729+588] = + s[156];
gout[n*729+589] = + s[157];
gout[n*729+590] = + s[158];
gout[n*729+591] = + s[159];
gout[n*729+592] = + s[160];
gout[n*729+593] = + s[161];
gout[n*729+594] = + s[378];
gout[n*729+595] = + s[379];
gout[n*729+596] = + s[380];
gout[n*729+597] = + s[381];
gout[n*729+598] = + s[382];
gout[n*729+599] = + s[383];
gout[n*729+600] = + s[384];
gout[n*729+601] = + s[385];
gout[n*729+602] = + s[386];
gout[n*729+603] = + s[387];
gout[n*729+604] = + s[388];
gout[n*729+605] = + s[389];
gout[n*729+606] = + s[390];
gout[n*729+607] = + s[391];
gout[n*729+608] = + s[392];
gout[n*729+609] = + s[393];
gout[n*729+610] = + s[394];
gout[n*729+611] = + s[395];
gout[n*729+612] = + s[396];
gout[n*729+613] = + s[397];
gout[n*729+614] = + s[398];
gout[n*729+615] = + s[399];
gout[n*729+616] = + s[400];
gout[n*729+617] = + s[401];
gout[n*729+618] = + s[402];
gout[n*729+619] = + s[403];
gout[n*729+620] = + s[404];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[216];
gout[n*729+649] = + s[217];
gout[n*729+650] = + s[218];
gout[n*729+651] = + s[219];
gout[n*729+652] = + s[220];
gout[n*729+653] = + s[221];
gout[n*729+654] = + s[222];
gout[n*729+655] = + s[223];
gout[n*729+656] = + s[224];
gout[n*729+657] = + s[225];
gout[n*729+658] = + s[226];
gout[n*729+659] = + s[227];
gout[n*729+660] = + s[228];
gout[n*729+661] = + s[229];
gout[n*729+662] = + s[230];
gout[n*729+663] = + s[231];
gout[n*729+664] = + s[232];
gout[n*729+665] = + s[233];
gout[n*729+666] = + s[234];
gout[n*729+667] = + s[235];
gout[n*729+668] = + s[236];
gout[n*729+669] = + s[237];
gout[n*729+670] = + s[238];
gout[n*729+671] = + s[239];
gout[n*729+672] = + s[240];
gout[n*729+673] = + s[241];
gout[n*729+674] = + s[242];
gout[n*729+675] = + s[459];
gout[n*729+676] = + s[460];
gout[n*729+677] = + s[461];
gout[n*729+678] = + s[462];
gout[n*729+679] = + s[463];
gout[n*729+680] = + s[464];
gout[n*729+681] = + s[465];
gout[n*729+682] = + s[466];
gout[n*729+683] = + s[467];
gout[n*729+684] = + s[468];
gout[n*729+685] = + s[469];
gout[n*729+686] = + s[470];
gout[n*729+687] = + s[471];
gout[n*729+688] = + s[472];
gout[n*729+689] = + s[473];
gout[n*729+690] = + s[474];
gout[n*729+691] = + s[475];
gout[n*729+692] = + s[476];
gout[n*729+693] = + s[477];
gout[n*729+694] = + s[478];
gout[n*729+695] = + s[479];
gout[n*729+696] = + s[480];
gout[n*729+697] = + s[481];
gout[n*729+698] = + s[482];
gout[n*729+699] = + s[483];
gout[n*729+700] = + s[484];
gout[n*729+701] = + s[485];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[243];
gout[n*729+28] += + s[244];
gout[n*729+29] += + s[245];
gout[n*729+30] += + s[246];
gout[n*729+31] += + s[247];
gout[n*729+32] += + s[248];
gout[n*729+33] += + s[249];
gout[n*729+34] += + s[250];
gout[n*729+35] += + s[251];
gout[n*729+36] += + s[252];
gout[n*729+37] += + s[253];
gout[n*729+38] += + s[254];
gout[n*729+39] += + s[255];
gout[n*729+40] += + s[256];
gout[n*729+41] += + s[257];
gout[n*729+42] += + s[258];
gout[n*729+43] += + s[259];
gout[n*729+44] += + s[260];
gout[n*729+45] += + s[261];
gout[n*729+46] += + s[262];
gout[n*729+47] += + s[263];
gout[n*729+48] += + s[264];
gout[n*729+49] += + s[265];
gout[n*729+50] += + s[266];
gout[n*729+51] += + s[267];
gout[n*729+52] += + s[268];
gout[n*729+53] += + s[269];
gout[n*729+54] += + s[486];
gout[n*729+55] += + s[487];
gout[n*729+56] += + s[488];
gout[n*729+57] += + s[489];
gout[n*729+58] += + s[490];
gout[n*729+59] += + s[491];
gout[n*729+60] += + s[492];
gout[n*729+61] += + s[493];
gout[n*729+62] += + s[494];
gout[n*729+63] += + s[495];
gout[n*729+64] += + s[496];
gout[n*729+65] += + s[497];
gout[n*729+66] += + s[498];
gout[n*729+67] += + s[499];
gout[n*729+68] += + s[500];
gout[n*729+69] += + s[501];
gout[n*729+70] += + s[502];
gout[n*729+71] += + s[503];
gout[n*729+72] += + s[504];
gout[n*729+73] += + s[505];
gout[n*729+74] += + s[506];
gout[n*729+75] += + s[507];
gout[n*729+76] += + s[508];
gout[n*729+77] += + s[509];
gout[n*729+78] += + s[510];
gout[n*729+79] += + s[511];
gout[n*729+80] += + s[512];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[324];
gout[n*729+109] += + s[325];
gout[n*729+110] += + s[326];
gout[n*729+111] += + s[327];
gout[n*729+112] += + s[328];
gout[n*729+113] += + s[329];
gout[n*729+114] += + s[330];
gout[n*729+115] += + s[331];
gout[n*729+116] += + s[332];
gout[n*729+117] += + s[333];
gout[n*729+118] += + s[334];
gout[n*729+119] += + s[335];
gout[n*729+120] += + s[336];
gout[n*729+121] += + s[337];
gout[n*729+122] += + s[338];
gout[n*729+123] += + s[339];
gout[n*729+124] += + s[340];
gout[n*729+125] += + s[341];
gout[n*729+126] += + s[342];
gout[n*729+127] += + s[343];
gout[n*729+128] += + s[344];
gout[n*729+129] += + s[345];
gout[n*729+130] += + s[346];
gout[n*729+131] += + s[347];
gout[n*729+132] += + s[348];
gout[n*729+133] += + s[349];
gout[n*729+134] += + s[350];
gout[n*729+135] += + s[567];
gout[n*729+136] += + s[568];
gout[n*729+137] += + s[569];
gout[n*729+138] += + s[570];
gout[n*729+139] += + s[571];
gout[n*729+140] += + s[572];
gout[n*729+141] += + s[573];
gout[n*729+142] += + s[574];
gout[n*729+143] += + s[575];
gout[n*729+144] += + s[576];
gout[n*729+145] += + s[577];
gout[n*729+146] += + s[578];
gout[n*729+147] += + s[579];
gout[n*729+148] += + s[580];
gout[n*729+149] += + s[581];
gout[n*729+150] += + s[582];
gout[n*729+151] += + s[583];
gout[n*729+152] += + s[584];
gout[n*729+153] += + s[585];
gout[n*729+154] += + s[586];
gout[n*729+155] += + s[587];
gout[n*729+156] += + s[588];
gout[n*729+157] += + s[589];
gout[n*729+158] += + s[590];
gout[n*729+159] += + s[591];
gout[n*729+160] += + s[592];
gout[n*729+161] += + s[593];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[405];
gout[n*729+190] += + s[406];
gout[n*729+191] += + s[407];
gout[n*729+192] += + s[408];
gout[n*729+193] += + s[409];
gout[n*729+194] += + s[410];
gout[n*729+195] += + s[411];
gout[n*729+196] += + s[412];
gout[n*729+197] += + s[413];
gout[n*729+198] += + s[414];
gout[n*729+199] += + s[415];
gout[n*729+200] += + s[416];
gout[n*729+201] += + s[417];
gout[n*729+202] += + s[418];
gout[n*729+203] += + s[419];
gout[n*729+204] += + s[420];
gout[n*729+205] += + s[421];
gout[n*729+206] += + s[422];
gout[n*729+207] += + s[423];
gout[n*729+208] += + s[424];
gout[n*729+209] += + s[425];
gout[n*729+210] += + s[426];
gout[n*729+211] += + s[427];
gout[n*729+212] += + s[428];
gout[n*729+213] += + s[429];
gout[n*729+214] += + s[430];
gout[n*729+215] += + s[431];
gout[n*729+216] += + s[648];
gout[n*729+217] += + s[649];
gout[n*729+218] += + s[650];
gout[n*729+219] += + s[651];
gout[n*729+220] += + s[652];
gout[n*729+221] += + s[653];
gout[n*729+222] += + s[654];
gout[n*729+223] += + s[655];
gout[n*729+224] += + s[656];
gout[n*729+225] += + s[657];
gout[n*729+226] += + s[658];
gout[n*729+227] += + s[659];
gout[n*729+228] += + s[660];
gout[n*729+229] += + s[661];
gout[n*729+230] += + s[662];
gout[n*729+231] += + s[663];
gout[n*729+232] += + s[664];
gout[n*729+233] += + s[665];
gout[n*729+234] += + s[666];
gout[n*729+235] += + s[667];
gout[n*729+236] += + s[668];
gout[n*729+237] += + s[669];
gout[n*729+238] += + s[670];
gout[n*729+239] += + s[671];
gout[n*729+240] += + s[672];
gout[n*729+241] += + s[673];
gout[n*729+242] += + s[674];
gout[n*729+243] += + s[27];
gout[n*729+244] += + s[28];
gout[n*729+245] += + s[29];
gout[n*729+246] += + s[30];
gout[n*729+247] += + s[31];
gout[n*729+248] += + s[32];
gout[n*729+249] += + s[33];
gout[n*729+250] += + s[34];
gout[n*729+251] += + s[35];
gout[n*729+252] += + s[36];
gout[n*729+253] += + s[37];
gout[n*729+254] += + s[38];
gout[n*729+255] += + s[39];
gout[n*729+256] += + s[40];
gout[n*729+257] += + s[41];
gout[n*729+258] += + s[42];
gout[n*729+259] += + s[43];
gout[n*729+260] += + s[44];
gout[n*729+261] += + s[45];
gout[n*729+262] += + s[46];
gout[n*729+263] += + s[47];
gout[n*729+264] += + s[48];
gout[n*729+265] += + s[49];
gout[n*729+266] += + s[50];
gout[n*729+267] += + s[51];
gout[n*729+268] += + s[52];
gout[n*729+269] += + s[53];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[513];
gout[n*729+298] += + s[514];
gout[n*729+299] += + s[515];
gout[n*729+300] += + s[516];
gout[n*729+301] += + s[517];
gout[n*729+302] += + s[518];
gout[n*729+303] += + s[519];
gout[n*729+304] += + s[520];
gout[n*729+305] += + s[521];
gout[n*729+306] += + s[522];
gout[n*729+307] += + s[523];
gout[n*729+308] += + s[524];
gout[n*729+309] += + s[525];
gout[n*729+310] += + s[526];
gout[n*729+311] += + s[527];
gout[n*729+312] += + s[528];
gout[n*729+313] += + s[529];
gout[n*729+314] += + s[530];
gout[n*729+315] += + s[531];
gout[n*729+316] += + s[532];
gout[n*729+317] += + s[533];
gout[n*729+318] += + s[534];
gout[n*729+319] += + s[535];
gout[n*729+320] += + s[536];
gout[n*729+321] += + s[537];
gout[n*729+322] += + s[538];
gout[n*729+323] += + s[539];
gout[n*729+324] += + s[108];
gout[n*729+325] += + s[109];
gout[n*729+326] += + s[110];
gout[n*729+327] += + s[111];
gout[n*729+328] += + s[112];
gout[n*729+329] += + s[113];
gout[n*729+330] += + s[114];
gout[n*729+331] += + s[115];
gout[n*729+332] += + s[116];
gout[n*729+333] += + s[117];
gout[n*729+334] += + s[118];
gout[n*729+335] += + s[119];
gout[n*729+336] += + s[120];
gout[n*729+337] += + s[121];
gout[n*729+338] += + s[122];
gout[n*729+339] += + s[123];
gout[n*729+340] += + s[124];
gout[n*729+341] += + s[125];
gout[n*729+342] += + s[126];
gout[n*729+343] += + s[127];
gout[n*729+344] += + s[128];
gout[n*729+345] += + s[129];
gout[n*729+346] += + s[130];
gout[n*729+347] += + s[131];
gout[n*729+348] += + s[132];
gout[n*729+349] += + s[133];
gout[n*729+350] += + s[134];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[594];
gout[n*729+379] += + s[595];
gout[n*729+380] += + s[596];
gout[n*729+381] += + s[597];
gout[n*729+382] += + s[598];
gout[n*729+383] += + s[599];
gout[n*729+384] += + s[600];
gout[n*729+385] += + s[601];
gout[n*729+386] += + s[602];
gout[n*729+387] += + s[603];
gout[n*729+388] += + s[604];
gout[n*729+389] += + s[605];
gout[n*729+390] += + s[606];
gout[n*729+391] += + s[607];
gout[n*729+392] += + s[608];
gout[n*729+393] += + s[609];
gout[n*729+394] += + s[610];
gout[n*729+395] += + s[611];
gout[n*729+396] += + s[612];
gout[n*729+397] += + s[613];
gout[n*729+398] += + s[614];
gout[n*729+399] += + s[615];
gout[n*729+400] += + s[616];
gout[n*729+401] += + s[617];
gout[n*729+402] += + s[618];
gout[n*729+403] += + s[619];
gout[n*729+404] += + s[620];
gout[n*729+405] += + s[189];
gout[n*729+406] += + s[190];
gout[n*729+407] += + s[191];
gout[n*729+408] += + s[192];
gout[n*729+409] += + s[193];
gout[n*729+410] += + s[194];
gout[n*729+411] += + s[195];
gout[n*729+412] += + s[196];
gout[n*729+413] += + s[197];
gout[n*729+414] += + s[198];
gout[n*729+415] += + s[199];
gout[n*729+416] += + s[200];
gout[n*729+417] += + s[201];
gout[n*729+418] += + s[202];
gout[n*729+419] += + s[203];
gout[n*729+420] += + s[204];
gout[n*729+421] += + s[205];
gout[n*729+422] += + s[206];
gout[n*729+423] += + s[207];
gout[n*729+424] += + s[208];
gout[n*729+425] += + s[209];
gout[n*729+426] += + s[210];
gout[n*729+427] += + s[211];
gout[n*729+428] += + s[212];
gout[n*729+429] += + s[213];
gout[n*729+430] += + s[214];
gout[n*729+431] += + s[215];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[675];
gout[n*729+460] += + s[676];
gout[n*729+461] += + s[677];
gout[n*729+462] += + s[678];
gout[n*729+463] += + s[679];
gout[n*729+464] += + s[680];
gout[n*729+465] += + s[681];
gout[n*729+466] += + s[682];
gout[n*729+467] += + s[683];
gout[n*729+468] += + s[684];
gout[n*729+469] += + s[685];
gout[n*729+470] += + s[686];
gout[n*729+471] += + s[687];
gout[n*729+472] += + s[688];
gout[n*729+473] += + s[689];
gout[n*729+474] += + s[690];
gout[n*729+475] += + s[691];
gout[n*729+476] += + s[692];
gout[n*729+477] += + s[693];
gout[n*729+478] += + s[694];
gout[n*729+479] += + s[695];
gout[n*729+480] += + s[696];
gout[n*729+481] += + s[697];
gout[n*729+482] += + s[698];
gout[n*729+483] += + s[699];
gout[n*729+484] += + s[700];
gout[n*729+485] += + s[701];
gout[n*729+486] += + s[54];
gout[n*729+487] += + s[55];
gout[n*729+488] += + s[56];
gout[n*729+489] += + s[57];
gout[n*729+490] += + s[58];
gout[n*729+491] += + s[59];
gout[n*729+492] += + s[60];
gout[n*729+493] += + s[61];
gout[n*729+494] += + s[62];
gout[n*729+495] += + s[63];
gout[n*729+496] += + s[64];
gout[n*729+497] += + s[65];
gout[n*729+498] += + s[66];
gout[n*729+499] += + s[67];
gout[n*729+500] += + s[68];
gout[n*729+501] += + s[69];
gout[n*729+502] += + s[70];
gout[n*729+503] += + s[71];
gout[n*729+504] += + s[72];
gout[n*729+505] += + s[73];
gout[n*729+506] += + s[74];
gout[n*729+507] += + s[75];
gout[n*729+508] += + s[76];
gout[n*729+509] += + s[77];
gout[n*729+510] += + s[78];
gout[n*729+511] += + s[79];
gout[n*729+512] += + s[80];
gout[n*729+513] += + s[297];
gout[n*729+514] += + s[298];
gout[n*729+515] += + s[299];
gout[n*729+516] += + s[300];
gout[n*729+517] += + s[301];
gout[n*729+518] += + s[302];
gout[n*729+519] += + s[303];
gout[n*729+520] += + s[304];
gout[n*729+521] += + s[305];
gout[n*729+522] += + s[306];
gout[n*729+523] += + s[307];
gout[n*729+524] += + s[308];
gout[n*729+525] += + s[309];
gout[n*729+526] += + s[310];
gout[n*729+527] += + s[311];
gout[n*729+528] += + s[312];
gout[n*729+529] += + s[313];
gout[n*729+530] += + s[314];
gout[n*729+531] += + s[315];
gout[n*729+532] += + s[316];
gout[n*729+533] += + s[317];
gout[n*729+534] += + s[318];
gout[n*729+535] += + s[319];
gout[n*729+536] += + s[320];
gout[n*729+537] += + s[321];
gout[n*729+538] += + s[322];
gout[n*729+539] += + s[323];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[135];
gout[n*729+568] += + s[136];
gout[n*729+569] += + s[137];
gout[n*729+570] += + s[138];
gout[n*729+571] += + s[139];
gout[n*729+572] += + s[140];
gout[n*729+573] += + s[141];
gout[n*729+574] += + s[142];
gout[n*729+575] += + s[143];
gout[n*729+576] += + s[144];
gout[n*729+577] += + s[145];
gout[n*729+578] += + s[146];
gout[n*729+579] += + s[147];
gout[n*729+580] += + s[148];
gout[n*729+581] += + s[149];
gout[n*729+582] += + s[150];
gout[n*729+583] += + s[151];
gout[n*729+584] += + s[152];
gout[n*729+585] += + s[153];
gout[n*729+586] += + s[154];
gout[n*729+587] += + s[155];
gout[n*729+588] += + s[156];
gout[n*729+589] += + s[157];
gout[n*729+590] += + s[158];
gout[n*729+591] += + s[159];
gout[n*729+592] += + s[160];
gout[n*729+593] += + s[161];
gout[n*729+594] += + s[378];
gout[n*729+595] += + s[379];
gout[n*729+596] += + s[380];
gout[n*729+597] += + s[381];
gout[n*729+598] += + s[382];
gout[n*729+599] += + s[383];
gout[n*729+600] += + s[384];
gout[n*729+601] += + s[385];
gout[n*729+602] += + s[386];
gout[n*729+603] += + s[387];
gout[n*729+604] += + s[388];
gout[n*729+605] += + s[389];
gout[n*729+606] += + s[390];
gout[n*729+607] += + s[391];
gout[n*729+608] += + s[392];
gout[n*729+609] += + s[393];
gout[n*729+610] += + s[394];
gout[n*729+611] += + s[395];
gout[n*729+612] += + s[396];
gout[n*729+613] += + s[397];
gout[n*729+614] += + s[398];
gout[n*729+615] += + s[399];
gout[n*729+616] += + s[400];
gout[n*729+617] += + s[401];
gout[n*729+618] += + s[402];
gout[n*729+619] += + s[403];
gout[n*729+620] += + s[404];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[216];
gout[n*729+649] += + s[217];
gout[n*729+650] += + s[218];
gout[n*729+651] += + s[219];
gout[n*729+652] += + s[220];
gout[n*729+653] += + s[221];
gout[n*729+654] += + s[222];
gout[n*729+655] += + s[223];
gout[n*729+656] += + s[224];
gout[n*729+657] += + s[225];
gout[n*729+658] += + s[226];
gout[n*729+659] += + s[227];
gout[n*729+660] += + s[228];
gout[n*729+661] += + s[229];
gout[n*729+662] += + s[230];
gout[n*729+663] += + s[231];
gout[n*729+664] += + s[232];
gout[n*729+665] += + s[233];
gout[n*729+666] += + s[234];
gout[n*729+667] += + s[235];
gout[n*729+668] += + s[236];
gout[n*729+669] += + s[237];
gout[n*729+670] += + s[238];
gout[n*729+671] += + s[239];
gout[n*729+672] += + s[240];
gout[n*729+673] += + s[241];
gout[n*729+674] += + s[242];
gout[n*729+675] += + s[459];
gout[n*729+676] += + s[460];
gout[n*729+677] += + s[461];
gout[n*729+678] += + s[462];
gout[n*729+679] += + s[463];
gout[n*729+680] += + s[464];
gout[n*729+681] += + s[465];
gout[n*729+682] += + s[466];
gout[n*729+683] += + s[467];
gout[n*729+684] += + s[468];
gout[n*729+685] += + s[469];
gout[n*729+686] += + s[470];
gout[n*729+687] += + s[471];
gout[n*729+688] += + s[472];
gout[n*729+689] += + s[473];
gout[n*729+690] += + s[474];
gout[n*729+691] += + s[475];
gout[n*729+692] += + s[476];
gout[n*729+693] += + s[477];
gout[n*729+694] += + s[478];
gout[n*729+695] += + s[479];
gout[n*729+696] += + s[480];
gout[n*729+697] += + s[481];
gout[n*729+698] += + s[482];
gout[n*729+699] += + s[483];
gout[n*729+700] += + s[484];
gout[n*729+701] += + s[485];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipipmmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipmmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipmmip_cart
CACHE_SIZE_T int1e_ipipipmmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipmmip_sph
CACHE_SIZE_T int1e_ipipipmmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipmmip_spinor
ALL_CINT1E(int1e_ipipipmmip)
ALL_CINT1E_FORTRAN_(int1e_ipipipmmip)
/* <NABLA NABLA i|RI RI |NABLA NABLA j> */
void CINTgout1e_int1e_ipipmmipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+2, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[243];
gout[n*729+82] = + s[244];
gout[n*729+83] = + s[245];
gout[n*729+84] = + s[246];
gout[n*729+85] = + s[247];
gout[n*729+86] = + s[248];
gout[n*729+87] = + s[249];
gout[n*729+88] = + s[250];
gout[n*729+89] = + s[251];
gout[n*729+90] = + s[252];
gout[n*729+91] = + s[253];
gout[n*729+92] = + s[254];
gout[n*729+93] = + s[255];
gout[n*729+94] = + s[256];
gout[n*729+95] = + s[257];
gout[n*729+96] = + s[258];
gout[n*729+97] = + s[259];
gout[n*729+98] = + s[260];
gout[n*729+99] = + s[261];
gout[n*729+100] = + s[262];
gout[n*729+101] = + s[263];
gout[n*729+102] = + s[264];
gout[n*729+103] = + s[265];
gout[n*729+104] = + s[266];
gout[n*729+105] = + s[267];
gout[n*729+106] = + s[268];
gout[n*729+107] = + s[269];
gout[n*729+108] = + s[270];
gout[n*729+109] = + s[271];
gout[n*729+110] = + s[272];
gout[n*729+111] = + s[273];
gout[n*729+112] = + s[274];
gout[n*729+113] = + s[275];
gout[n*729+114] = + s[276];
gout[n*729+115] = + s[277];
gout[n*729+116] = + s[278];
gout[n*729+117] = + s[279];
gout[n*729+118] = + s[280];
gout[n*729+119] = + s[281];
gout[n*729+120] = + s[282];
gout[n*729+121] = + s[283];
gout[n*729+122] = + s[284];
gout[n*729+123] = + s[285];
gout[n*729+124] = + s[286];
gout[n*729+125] = + s[287];
gout[n*729+126] = + s[288];
gout[n*729+127] = + s[289];
gout[n*729+128] = + s[290];
gout[n*729+129] = + s[291];
gout[n*729+130] = + s[292];
gout[n*729+131] = + s[293];
gout[n*729+132] = + s[294];
gout[n*729+133] = + s[295];
gout[n*729+134] = + s[296];
gout[n*729+135] = + s[297];
gout[n*729+136] = + s[298];
gout[n*729+137] = + s[299];
gout[n*729+138] = + s[300];
gout[n*729+139] = + s[301];
gout[n*729+140] = + s[302];
gout[n*729+141] = + s[303];
gout[n*729+142] = + s[304];
gout[n*729+143] = + s[305];
gout[n*729+144] = + s[306];
gout[n*729+145] = + s[307];
gout[n*729+146] = + s[308];
gout[n*729+147] = + s[309];
gout[n*729+148] = + s[310];
gout[n*729+149] = + s[311];
gout[n*729+150] = + s[312];
gout[n*729+151] = + s[313];
gout[n*729+152] = + s[314];
gout[n*729+153] = + s[315];
gout[n*729+154] = + s[316];
gout[n*729+155] = + s[317];
gout[n*729+156] = + s[318];
gout[n*729+157] = + s[319];
gout[n*729+158] = + s[320];
gout[n*729+159] = + s[321];
gout[n*729+160] = + s[322];
gout[n*729+161] = + s[323];
gout[n*729+162] = + s[486];
gout[n*729+163] = + s[487];
gout[n*729+164] = + s[488];
gout[n*729+165] = + s[489];
gout[n*729+166] = + s[490];
gout[n*729+167] = + s[491];
gout[n*729+168] = + s[492];
gout[n*729+169] = + s[493];
gout[n*729+170] = + s[494];
gout[n*729+171] = + s[495];
gout[n*729+172] = + s[496];
gout[n*729+173] = + s[497];
gout[n*729+174] = + s[498];
gout[n*729+175] = + s[499];
gout[n*729+176] = + s[500];
gout[n*729+177] = + s[501];
gout[n*729+178] = + s[502];
gout[n*729+179] = + s[503];
gout[n*729+180] = + s[504];
gout[n*729+181] = + s[505];
gout[n*729+182] = + s[506];
gout[n*729+183] = + s[507];
gout[n*729+184] = + s[508];
gout[n*729+185] = + s[509];
gout[n*729+186] = + s[510];
gout[n*729+187] = + s[511];
gout[n*729+188] = + s[512];
gout[n*729+189] = + s[513];
gout[n*729+190] = + s[514];
gout[n*729+191] = + s[515];
gout[n*729+192] = + s[516];
gout[n*729+193] = + s[517];
gout[n*729+194] = + s[518];
gout[n*729+195] = + s[519];
gout[n*729+196] = + s[520];
gout[n*729+197] = + s[521];
gout[n*729+198] = + s[522];
gout[n*729+199] = + s[523];
gout[n*729+200] = + s[524];
gout[n*729+201] = + s[525];
gout[n*729+202] = + s[526];
gout[n*729+203] = + s[527];
gout[n*729+204] = + s[528];
gout[n*729+205] = + s[529];
gout[n*729+206] = + s[530];
gout[n*729+207] = + s[531];
gout[n*729+208] = + s[532];
gout[n*729+209] = + s[533];
gout[n*729+210] = + s[534];
gout[n*729+211] = + s[535];
gout[n*729+212] = + s[536];
gout[n*729+213] = + s[537];
gout[n*729+214] = + s[538];
gout[n*729+215] = + s[539];
gout[n*729+216] = + s[540];
gout[n*729+217] = + s[541];
gout[n*729+218] = + s[542];
gout[n*729+219] = + s[543];
gout[n*729+220] = + s[544];
gout[n*729+221] = + s[545];
gout[n*729+222] = + s[546];
gout[n*729+223] = + s[547];
gout[n*729+224] = + s[548];
gout[n*729+225] = + s[549];
gout[n*729+226] = + s[550];
gout[n*729+227] = + s[551];
gout[n*729+228] = + s[552];
gout[n*729+229] = + s[553];
gout[n*729+230] = + s[554];
gout[n*729+231] = + s[555];
gout[n*729+232] = + s[556];
gout[n*729+233] = + s[557];
gout[n*729+234] = + s[558];
gout[n*729+235] = + s[559];
gout[n*729+236] = + s[560];
gout[n*729+237] = + s[561];
gout[n*729+238] = + s[562];
gout[n*729+239] = + s[563];
gout[n*729+240] = + s[564];
gout[n*729+241] = + s[565];
gout[n*729+242] = + s[566];
gout[n*729+243] = + s[81];
gout[n*729+244] = + s[82];
gout[n*729+245] = + s[83];
gout[n*729+246] = + s[84];
gout[n*729+247] = + s[85];
gout[n*729+248] = + s[86];
gout[n*729+249] = + s[87];
gout[n*729+250] = + s[88];
gout[n*729+251] = + s[89];
gout[n*729+252] = + s[90];
gout[n*729+253] = + s[91];
gout[n*729+254] = + s[92];
gout[n*729+255] = + s[93];
gout[n*729+256] = + s[94];
gout[n*729+257] = + s[95];
gout[n*729+258] = + s[96];
gout[n*729+259] = + s[97];
gout[n*729+260] = + s[98];
gout[n*729+261] = + s[99];
gout[n*729+262] = + s[100];
gout[n*729+263] = + s[101];
gout[n*729+264] = + s[102];
gout[n*729+265] = + s[103];
gout[n*729+266] = + s[104];
gout[n*729+267] = + s[105];
gout[n*729+268] = + s[106];
gout[n*729+269] = + s[107];
gout[n*729+270] = + s[108];
gout[n*729+271] = + s[109];
gout[n*729+272] = + s[110];
gout[n*729+273] = + s[111];
gout[n*729+274] = + s[112];
gout[n*729+275] = + s[113];
gout[n*729+276] = + s[114];
gout[n*729+277] = + s[115];
gout[n*729+278] = + s[116];
gout[n*729+279] = + s[117];
gout[n*729+280] = + s[118];
gout[n*729+281] = + s[119];
gout[n*729+282] = + s[120];
gout[n*729+283] = + s[121];
gout[n*729+284] = + s[122];
gout[n*729+285] = + s[123];
gout[n*729+286] = + s[124];
gout[n*729+287] = + s[125];
gout[n*729+288] = + s[126];
gout[n*729+289] = + s[127];
gout[n*729+290] = + s[128];
gout[n*729+291] = + s[129];
gout[n*729+292] = + s[130];
gout[n*729+293] = + s[131];
gout[n*729+294] = + s[132];
gout[n*729+295] = + s[133];
gout[n*729+296] = + s[134];
gout[n*729+297] = + s[135];
gout[n*729+298] = + s[136];
gout[n*729+299] = + s[137];
gout[n*729+300] = + s[138];
gout[n*729+301] = + s[139];
gout[n*729+302] = + s[140];
gout[n*729+303] = + s[141];
gout[n*729+304] = + s[142];
gout[n*729+305] = + s[143];
gout[n*729+306] = + s[144];
gout[n*729+307] = + s[145];
gout[n*729+308] = + s[146];
gout[n*729+309] = + s[147];
gout[n*729+310] = + s[148];
gout[n*729+311] = + s[149];
gout[n*729+312] = + s[150];
gout[n*729+313] = + s[151];
gout[n*729+314] = + s[152];
gout[n*729+315] = + s[153];
gout[n*729+316] = + s[154];
gout[n*729+317] = + s[155];
gout[n*729+318] = + s[156];
gout[n*729+319] = + s[157];
gout[n*729+320] = + s[158];
gout[n*729+321] = + s[159];
gout[n*729+322] = + s[160];
gout[n*729+323] = + s[161];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[567];
gout[n*729+406] = + s[568];
gout[n*729+407] = + s[569];
gout[n*729+408] = + s[570];
gout[n*729+409] = + s[571];
gout[n*729+410] = + s[572];
gout[n*729+411] = + s[573];
gout[n*729+412] = + s[574];
gout[n*729+413] = + s[575];
gout[n*729+414] = + s[576];
gout[n*729+415] = + s[577];
gout[n*729+416] = + s[578];
gout[n*729+417] = + s[579];
gout[n*729+418] = + s[580];
gout[n*729+419] = + s[581];
gout[n*729+420] = + s[582];
gout[n*729+421] = + s[583];
gout[n*729+422] = + s[584];
gout[n*729+423] = + s[585];
gout[n*729+424] = + s[586];
gout[n*729+425] = + s[587];
gout[n*729+426] = + s[588];
gout[n*729+427] = + s[589];
gout[n*729+428] = + s[590];
gout[n*729+429] = + s[591];
gout[n*729+430] = + s[592];
gout[n*729+431] = + s[593];
gout[n*729+432] = + s[594];
gout[n*729+433] = + s[595];
gout[n*729+434] = + s[596];
gout[n*729+435] = + s[597];
gout[n*729+436] = + s[598];
gout[n*729+437] = + s[599];
gout[n*729+438] = + s[600];
gout[n*729+439] = + s[601];
gout[n*729+440] = + s[602];
gout[n*729+441] = + s[603];
gout[n*729+442] = + s[604];
gout[n*729+443] = + s[605];
gout[n*729+444] = + s[606];
gout[n*729+445] = + s[607];
gout[n*729+446] = + s[608];
gout[n*729+447] = + s[609];
gout[n*729+448] = + s[610];
gout[n*729+449] = + s[611];
gout[n*729+450] = + s[612];
gout[n*729+451] = + s[613];
gout[n*729+452] = + s[614];
gout[n*729+453] = + s[615];
gout[n*729+454] = + s[616];
gout[n*729+455] = + s[617];
gout[n*729+456] = + s[618];
gout[n*729+457] = + s[619];
gout[n*729+458] = + s[620];
gout[n*729+459] = + s[621];
gout[n*729+460] = + s[622];
gout[n*729+461] = + s[623];
gout[n*729+462] = + s[624];
gout[n*729+463] = + s[625];
gout[n*729+464] = + s[626];
gout[n*729+465] = + s[627];
gout[n*729+466] = + s[628];
gout[n*729+467] = + s[629];
gout[n*729+468] = + s[630];
gout[n*729+469] = + s[631];
gout[n*729+470] = + s[632];
gout[n*729+471] = + s[633];
gout[n*729+472] = + s[634];
gout[n*729+473] = + s[635];
gout[n*729+474] = + s[636];
gout[n*729+475] = + s[637];
gout[n*729+476] = + s[638];
gout[n*729+477] = + s[639];
gout[n*729+478] = + s[640];
gout[n*729+479] = + s[641];
gout[n*729+480] = + s[642];
gout[n*729+481] = + s[643];
gout[n*729+482] = + s[644];
gout[n*729+483] = + s[645];
gout[n*729+484] = + s[646];
gout[n*729+485] = + s[647];
gout[n*729+486] = + s[162];
gout[n*729+487] = + s[163];
gout[n*729+488] = + s[164];
gout[n*729+489] = + s[165];
gout[n*729+490] = + s[166];
gout[n*729+491] = + s[167];
gout[n*729+492] = + s[168];
gout[n*729+493] = + s[169];
gout[n*729+494] = + s[170];
gout[n*729+495] = + s[171];
gout[n*729+496] = + s[172];
gout[n*729+497] = + s[173];
gout[n*729+498] = + s[174];
gout[n*729+499] = + s[175];
gout[n*729+500] = + s[176];
gout[n*729+501] = + s[177];
gout[n*729+502] = + s[178];
gout[n*729+503] = + s[179];
gout[n*729+504] = + s[180];
gout[n*729+505] = + s[181];
gout[n*729+506] = + s[182];
gout[n*729+507] = + s[183];
gout[n*729+508] = + s[184];
gout[n*729+509] = + s[185];
gout[n*729+510] = + s[186];
gout[n*729+511] = + s[187];
gout[n*729+512] = + s[188];
gout[n*729+513] = + s[189];
gout[n*729+514] = + s[190];
gout[n*729+515] = + s[191];
gout[n*729+516] = + s[192];
gout[n*729+517] = + s[193];
gout[n*729+518] = + s[194];
gout[n*729+519] = + s[195];
gout[n*729+520] = + s[196];
gout[n*729+521] = + s[197];
gout[n*729+522] = + s[198];
gout[n*729+523] = + s[199];
gout[n*729+524] = + s[200];
gout[n*729+525] = + s[201];
gout[n*729+526] = + s[202];
gout[n*729+527] = + s[203];
gout[n*729+528] = + s[204];
gout[n*729+529] = + s[205];
gout[n*729+530] = + s[206];
gout[n*729+531] = + s[207];
gout[n*729+532] = + s[208];
gout[n*729+533] = + s[209];
gout[n*729+534] = + s[210];
gout[n*729+535] = + s[211];
gout[n*729+536] = + s[212];
gout[n*729+537] = + s[213];
gout[n*729+538] = + s[214];
gout[n*729+539] = + s[215];
gout[n*729+540] = + s[216];
gout[n*729+541] = + s[217];
gout[n*729+542] = + s[218];
gout[n*729+543] = + s[219];
gout[n*729+544] = + s[220];
gout[n*729+545] = + s[221];
gout[n*729+546] = + s[222];
gout[n*729+547] = + s[223];
gout[n*729+548] = + s[224];
gout[n*729+549] = + s[225];
gout[n*729+550] = + s[226];
gout[n*729+551] = + s[227];
gout[n*729+552] = + s[228];
gout[n*729+553] = + s[229];
gout[n*729+554] = + s[230];
gout[n*729+555] = + s[231];
gout[n*729+556] = + s[232];
gout[n*729+557] = + s[233];
gout[n*729+558] = + s[234];
gout[n*729+559] = + s[235];
gout[n*729+560] = + s[236];
gout[n*729+561] = + s[237];
gout[n*729+562] = + s[238];
gout[n*729+563] = + s[239];
gout[n*729+564] = + s[240];
gout[n*729+565] = + s[241];
gout[n*729+566] = + s[242];
gout[n*729+567] = + s[405];
gout[n*729+568] = + s[406];
gout[n*729+569] = + s[407];
gout[n*729+570] = + s[408];
gout[n*729+571] = + s[409];
gout[n*729+572] = + s[410];
gout[n*729+573] = + s[411];
gout[n*729+574] = + s[412];
gout[n*729+575] = + s[413];
gout[n*729+576] = + s[414];
gout[n*729+577] = + s[415];
gout[n*729+578] = + s[416];
gout[n*729+579] = + s[417];
gout[n*729+580] = + s[418];
gout[n*729+581] = + s[419];
gout[n*729+582] = + s[420];
gout[n*729+583] = + s[421];
gout[n*729+584] = + s[422];
gout[n*729+585] = + s[423];
gout[n*729+586] = + s[424];
gout[n*729+587] = + s[425];
gout[n*729+588] = + s[426];
gout[n*729+589] = + s[427];
gout[n*729+590] = + s[428];
gout[n*729+591] = + s[429];
gout[n*729+592] = + s[430];
gout[n*729+593] = + s[431];
gout[n*729+594] = + s[432];
gout[n*729+595] = + s[433];
gout[n*729+596] = + s[434];
gout[n*729+597] = + s[435];
gout[n*729+598] = + s[436];
gout[n*729+599] = + s[437];
gout[n*729+600] = + s[438];
gout[n*729+601] = + s[439];
gout[n*729+602] = + s[440];
gout[n*729+603] = + s[441];
gout[n*729+604] = + s[442];
gout[n*729+605] = + s[443];
gout[n*729+606] = + s[444];
gout[n*729+607] = + s[445];
gout[n*729+608] = + s[446];
gout[n*729+609] = + s[447];
gout[n*729+610] = + s[448];
gout[n*729+611] = + s[449];
gout[n*729+612] = + s[450];
gout[n*729+613] = + s[451];
gout[n*729+614] = + s[452];
gout[n*729+615] = + s[453];
gout[n*729+616] = + s[454];
gout[n*729+617] = + s[455];
gout[n*729+618] = + s[456];
gout[n*729+619] = + s[457];
gout[n*729+620] = + s[458];
gout[n*729+621] = + s[459];
gout[n*729+622] = + s[460];
gout[n*729+623] = + s[461];
gout[n*729+624] = + s[462];
gout[n*729+625] = + s[463];
gout[n*729+626] = + s[464];
gout[n*729+627] = + s[465];
gout[n*729+628] = + s[466];
gout[n*729+629] = + s[467];
gout[n*729+630] = + s[468];
gout[n*729+631] = + s[469];
gout[n*729+632] = + s[470];
gout[n*729+633] = + s[471];
gout[n*729+634] = + s[472];
gout[n*729+635] = + s[473];
gout[n*729+636] = + s[474];
gout[n*729+637] = + s[475];
gout[n*729+638] = + s[476];
gout[n*729+639] = + s[477];
gout[n*729+640] = + s[478];
gout[n*729+641] = + s[479];
gout[n*729+642] = + s[480];
gout[n*729+643] = + s[481];
gout[n*729+644] = + s[482];
gout[n*729+645] = + s[483];
gout[n*729+646] = + s[484];
gout[n*729+647] = + s[485];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[243];
gout[n*729+82] += + s[244];
gout[n*729+83] += + s[245];
gout[n*729+84] += + s[246];
gout[n*729+85] += + s[247];
gout[n*729+86] += + s[248];
gout[n*729+87] += + s[249];
gout[n*729+88] += + s[250];
gout[n*729+89] += + s[251];
gout[n*729+90] += + s[252];
gout[n*729+91] += + s[253];
gout[n*729+92] += + s[254];
gout[n*729+93] += + s[255];
gout[n*729+94] += + s[256];
gout[n*729+95] += + s[257];
gout[n*729+96] += + s[258];
gout[n*729+97] += + s[259];
gout[n*729+98] += + s[260];
gout[n*729+99] += + s[261];
gout[n*729+100] += + s[262];
gout[n*729+101] += + s[263];
gout[n*729+102] += + s[264];
gout[n*729+103] += + s[265];
gout[n*729+104] += + s[266];
gout[n*729+105] += + s[267];
gout[n*729+106] += + s[268];
gout[n*729+107] += + s[269];
gout[n*729+108] += + s[270];
gout[n*729+109] += + s[271];
gout[n*729+110] += + s[272];
gout[n*729+111] += + s[273];
gout[n*729+112] += + s[274];
gout[n*729+113] += + s[275];
gout[n*729+114] += + s[276];
gout[n*729+115] += + s[277];
gout[n*729+116] += + s[278];
gout[n*729+117] += + s[279];
gout[n*729+118] += + s[280];
gout[n*729+119] += + s[281];
gout[n*729+120] += + s[282];
gout[n*729+121] += + s[283];
gout[n*729+122] += + s[284];
gout[n*729+123] += + s[285];
gout[n*729+124] += + s[286];
gout[n*729+125] += + s[287];
gout[n*729+126] += + s[288];
gout[n*729+127] += + s[289];
gout[n*729+128] += + s[290];
gout[n*729+129] += + s[291];
gout[n*729+130] += + s[292];
gout[n*729+131] += + s[293];
gout[n*729+132] += + s[294];
gout[n*729+133] += + s[295];
gout[n*729+134] += + s[296];
gout[n*729+135] += + s[297];
gout[n*729+136] += + s[298];
gout[n*729+137] += + s[299];
gout[n*729+138] += + s[300];
gout[n*729+139] += + s[301];
gout[n*729+140] += + s[302];
gout[n*729+141] += + s[303];
gout[n*729+142] += + s[304];
gout[n*729+143] += + s[305];
gout[n*729+144] += + s[306];
gout[n*729+145] += + s[307];
gout[n*729+146] += + s[308];
gout[n*729+147] += + s[309];
gout[n*729+148] += + s[310];
gout[n*729+149] += + s[311];
gout[n*729+150] += + s[312];
gout[n*729+151] += + s[313];
gout[n*729+152] += + s[314];
gout[n*729+153] += + s[315];
gout[n*729+154] += + s[316];
gout[n*729+155] += + s[317];
gout[n*729+156] += + s[318];
gout[n*729+157] += + s[319];
gout[n*729+158] += + s[320];
gout[n*729+159] += + s[321];
gout[n*729+160] += + s[322];
gout[n*729+161] += + s[323];
gout[n*729+162] += + s[486];
gout[n*729+163] += + s[487];
gout[n*729+164] += + s[488];
gout[n*729+165] += + s[489];
gout[n*729+166] += + s[490];
gout[n*729+167] += + s[491];
gout[n*729+168] += + s[492];
gout[n*729+169] += + s[493];
gout[n*729+170] += + s[494];
gout[n*729+171] += + s[495];
gout[n*729+172] += + s[496];
gout[n*729+173] += + s[497];
gout[n*729+174] += + s[498];
gout[n*729+175] += + s[499];
gout[n*729+176] += + s[500];
gout[n*729+177] += + s[501];
gout[n*729+178] += + s[502];
gout[n*729+179] += + s[503];
gout[n*729+180] += + s[504];
gout[n*729+181] += + s[505];
gout[n*729+182] += + s[506];
gout[n*729+183] += + s[507];
gout[n*729+184] += + s[508];
gout[n*729+185] += + s[509];
gout[n*729+186] += + s[510];
gout[n*729+187] += + s[511];
gout[n*729+188] += + s[512];
gout[n*729+189] += + s[513];
gout[n*729+190] += + s[514];
gout[n*729+191] += + s[515];
gout[n*729+192] += + s[516];
gout[n*729+193] += + s[517];
gout[n*729+194] += + s[518];
gout[n*729+195] += + s[519];
gout[n*729+196] += + s[520];
gout[n*729+197] += + s[521];
gout[n*729+198] += + s[522];
gout[n*729+199] += + s[523];
gout[n*729+200] += + s[524];
gout[n*729+201] += + s[525];
gout[n*729+202] += + s[526];
gout[n*729+203] += + s[527];
gout[n*729+204] += + s[528];
gout[n*729+205] += + s[529];
gout[n*729+206] += + s[530];
gout[n*729+207] += + s[531];
gout[n*729+208] += + s[532];
gout[n*729+209] += + s[533];
gout[n*729+210] += + s[534];
gout[n*729+211] += + s[535];
gout[n*729+212] += + s[536];
gout[n*729+213] += + s[537];
gout[n*729+214] += + s[538];
gout[n*729+215] += + s[539];
gout[n*729+216] += + s[540];
gout[n*729+217] += + s[541];
gout[n*729+218] += + s[542];
gout[n*729+219] += + s[543];
gout[n*729+220] += + s[544];
gout[n*729+221] += + s[545];
gout[n*729+222] += + s[546];
gout[n*729+223] += + s[547];
gout[n*729+224] += + s[548];
gout[n*729+225] += + s[549];
gout[n*729+226] += + s[550];
gout[n*729+227] += + s[551];
gout[n*729+228] += + s[552];
gout[n*729+229] += + s[553];
gout[n*729+230] += + s[554];
gout[n*729+231] += + s[555];
gout[n*729+232] += + s[556];
gout[n*729+233] += + s[557];
gout[n*729+234] += + s[558];
gout[n*729+235] += + s[559];
gout[n*729+236] += + s[560];
gout[n*729+237] += + s[561];
gout[n*729+238] += + s[562];
gout[n*729+239] += + s[563];
gout[n*729+240] += + s[564];
gout[n*729+241] += + s[565];
gout[n*729+242] += + s[566];
gout[n*729+243] += + s[81];
gout[n*729+244] += + s[82];
gout[n*729+245] += + s[83];
gout[n*729+246] += + s[84];
gout[n*729+247] += + s[85];
gout[n*729+248] += + s[86];
gout[n*729+249] += + s[87];
gout[n*729+250] += + s[88];
gout[n*729+251] += + s[89];
gout[n*729+252] += + s[90];
gout[n*729+253] += + s[91];
gout[n*729+254] += + s[92];
gout[n*729+255] += + s[93];
gout[n*729+256] += + s[94];
gout[n*729+257] += + s[95];
gout[n*729+258] += + s[96];
gout[n*729+259] += + s[97];
gout[n*729+260] += + s[98];
gout[n*729+261] += + s[99];
gout[n*729+262] += + s[100];
gout[n*729+263] += + s[101];
gout[n*729+264] += + s[102];
gout[n*729+265] += + s[103];
gout[n*729+266] += + s[104];
gout[n*729+267] += + s[105];
gout[n*729+268] += + s[106];
gout[n*729+269] += + s[107];
gout[n*729+270] += + s[108];
gout[n*729+271] += + s[109];
gout[n*729+272] += + s[110];
gout[n*729+273] += + s[111];
gout[n*729+274] += + s[112];
gout[n*729+275] += + s[113];
gout[n*729+276] += + s[114];
gout[n*729+277] += + s[115];
gout[n*729+278] += + s[116];
gout[n*729+279] += + s[117];
gout[n*729+280] += + s[118];
gout[n*729+281] += + s[119];
gout[n*729+282] += + s[120];
gout[n*729+283] += + s[121];
gout[n*729+284] += + s[122];
gout[n*729+285] += + s[123];
gout[n*729+286] += + s[124];
gout[n*729+287] += + s[125];
gout[n*729+288] += + s[126];
gout[n*729+289] += + s[127];
gout[n*729+290] += + s[128];
gout[n*729+291] += + s[129];
gout[n*729+292] += + s[130];
gout[n*729+293] += + s[131];
gout[n*729+294] += + s[132];
gout[n*729+295] += + s[133];
gout[n*729+296] += + s[134];
gout[n*729+297] += + s[135];
gout[n*729+298] += + s[136];
gout[n*729+299] += + s[137];
gout[n*729+300] += + s[138];
gout[n*729+301] += + s[139];
gout[n*729+302] += + s[140];
gout[n*729+303] += + s[141];
gout[n*729+304] += + s[142];
gout[n*729+305] += + s[143];
gout[n*729+306] += + s[144];
gout[n*729+307] += + s[145];
gout[n*729+308] += + s[146];
gout[n*729+309] += + s[147];
gout[n*729+310] += + s[148];
gout[n*729+311] += + s[149];
gout[n*729+312] += + s[150];
gout[n*729+313] += + s[151];
gout[n*729+314] += + s[152];
gout[n*729+315] += + s[153];
gout[n*729+316] += + s[154];
gout[n*729+317] += + s[155];
gout[n*729+318] += + s[156];
gout[n*729+319] += + s[157];
gout[n*729+320] += + s[158];
gout[n*729+321] += + s[159];
gout[n*729+322] += + s[160];
gout[n*729+323] += + s[161];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[567];
gout[n*729+406] += + s[568];
gout[n*729+407] += + s[569];
gout[n*729+408] += + s[570];
gout[n*729+409] += + s[571];
gout[n*729+410] += + s[572];
gout[n*729+411] += + s[573];
gout[n*729+412] += + s[574];
gout[n*729+413] += + s[575];
gout[n*729+414] += + s[576];
gout[n*729+415] += + s[577];
gout[n*729+416] += + s[578];
gout[n*729+417] += + s[579];
gout[n*729+418] += + s[580];
gout[n*729+419] += + s[581];
gout[n*729+420] += + s[582];
gout[n*729+421] += + s[583];
gout[n*729+422] += + s[584];
gout[n*729+423] += + s[585];
gout[n*729+424] += + s[586];
gout[n*729+425] += + s[587];
gout[n*729+426] += + s[588];
gout[n*729+427] += + s[589];
gout[n*729+428] += + s[590];
gout[n*729+429] += + s[591];
gout[n*729+430] += + s[592];
gout[n*729+431] += + s[593];
gout[n*729+432] += + s[594];
gout[n*729+433] += + s[595];
gout[n*729+434] += + s[596];
gout[n*729+435] += + s[597];
gout[n*729+436] += + s[598];
gout[n*729+437] += + s[599];
gout[n*729+438] += + s[600];
gout[n*729+439] += + s[601];
gout[n*729+440] += + s[602];
gout[n*729+441] += + s[603];
gout[n*729+442] += + s[604];
gout[n*729+443] += + s[605];
gout[n*729+444] += + s[606];
gout[n*729+445] += + s[607];
gout[n*729+446] += + s[608];
gout[n*729+447] += + s[609];
gout[n*729+448] += + s[610];
gout[n*729+449] += + s[611];
gout[n*729+450] += + s[612];
gout[n*729+451] += + s[613];
gout[n*729+452] += + s[614];
gout[n*729+453] += + s[615];
gout[n*729+454] += + s[616];
gout[n*729+455] += + s[617];
gout[n*729+456] += + s[618];
gout[n*729+457] += + s[619];
gout[n*729+458] += + s[620];
gout[n*729+459] += + s[621];
gout[n*729+460] += + s[622];
gout[n*729+461] += + s[623];
gout[n*729+462] += + s[624];
gout[n*729+463] += + s[625];
gout[n*729+464] += + s[626];
gout[n*729+465] += + s[627];
gout[n*729+466] += + s[628];
gout[n*729+467] += + s[629];
gout[n*729+468] += + s[630];
gout[n*729+469] += + s[631];
gout[n*729+470] += + s[632];
gout[n*729+471] += + s[633];
gout[n*729+472] += + s[634];
gout[n*729+473] += + s[635];
gout[n*729+474] += + s[636];
gout[n*729+475] += + s[637];
gout[n*729+476] += + s[638];
gout[n*729+477] += + s[639];
gout[n*729+478] += + s[640];
gout[n*729+479] += + s[641];
gout[n*729+480] += + s[642];
gout[n*729+481] += + s[643];
gout[n*729+482] += + s[644];
gout[n*729+483] += + s[645];
gout[n*729+484] += + s[646];
gout[n*729+485] += + s[647];
gout[n*729+486] += + s[162];
gout[n*729+487] += + s[163];
gout[n*729+488] += + s[164];
gout[n*729+489] += + s[165];
gout[n*729+490] += + s[166];
gout[n*729+491] += + s[167];
gout[n*729+492] += + s[168];
gout[n*729+493] += + s[169];
gout[n*729+494] += + s[170];
gout[n*729+495] += + s[171];
gout[n*729+496] += + s[172];
gout[n*729+497] += + s[173];
gout[n*729+498] += + s[174];
gout[n*729+499] += + s[175];
gout[n*729+500] += + s[176];
gout[n*729+501] += + s[177];
gout[n*729+502] += + s[178];
gout[n*729+503] += + s[179];
gout[n*729+504] += + s[180];
gout[n*729+505] += + s[181];
gout[n*729+506] += + s[182];
gout[n*729+507] += + s[183];
gout[n*729+508] += + s[184];
gout[n*729+509] += + s[185];
gout[n*729+510] += + s[186];
gout[n*729+511] += + s[187];
gout[n*729+512] += + s[188];
gout[n*729+513] += + s[189];
gout[n*729+514] += + s[190];
gout[n*729+515] += + s[191];
gout[n*729+516] += + s[192];
gout[n*729+517] += + s[193];
gout[n*729+518] += + s[194];
gout[n*729+519] += + s[195];
gout[n*729+520] += + s[196];
gout[n*729+521] += + s[197];
gout[n*729+522] += + s[198];
gout[n*729+523] += + s[199];
gout[n*729+524] += + s[200];
gout[n*729+525] += + s[201];
gout[n*729+526] += + s[202];
gout[n*729+527] += + s[203];
gout[n*729+528] += + s[204];
gout[n*729+529] += + s[205];
gout[n*729+530] += + s[206];
gout[n*729+531] += + s[207];
gout[n*729+532] += + s[208];
gout[n*729+533] += + s[209];
gout[n*729+534] += + s[210];
gout[n*729+535] += + s[211];
gout[n*729+536] += + s[212];
gout[n*729+537] += + s[213];
gout[n*729+538] += + s[214];
gout[n*729+539] += + s[215];
gout[n*729+540] += + s[216];
gout[n*729+541] += + s[217];
gout[n*729+542] += + s[218];
gout[n*729+543] += + s[219];
gout[n*729+544] += + s[220];
gout[n*729+545] += + s[221];
gout[n*729+546] += + s[222];
gout[n*729+547] += + s[223];
gout[n*729+548] += + s[224];
gout[n*729+549] += + s[225];
gout[n*729+550] += + s[226];
gout[n*729+551] += + s[227];
gout[n*729+552] += + s[228];
gout[n*729+553] += + s[229];
gout[n*729+554] += + s[230];
gout[n*729+555] += + s[231];
gout[n*729+556] += + s[232];
gout[n*729+557] += + s[233];
gout[n*729+558] += + s[234];
gout[n*729+559] += + s[235];
gout[n*729+560] += + s[236];
gout[n*729+561] += + s[237];
gout[n*729+562] += + s[238];
gout[n*729+563] += + s[239];
gout[n*729+564] += + s[240];
gout[n*729+565] += + s[241];
gout[n*729+566] += + s[242];
gout[n*729+567] += + s[405];
gout[n*729+568] += + s[406];
gout[n*729+569] += + s[407];
gout[n*729+570] += + s[408];
gout[n*729+571] += + s[409];
gout[n*729+572] += + s[410];
gout[n*729+573] += + s[411];
gout[n*729+574] += + s[412];
gout[n*729+575] += + s[413];
gout[n*729+576] += + s[414];
gout[n*729+577] += + s[415];
gout[n*729+578] += + s[416];
gout[n*729+579] += + s[417];
gout[n*729+580] += + s[418];
gout[n*729+581] += + s[419];
gout[n*729+582] += + s[420];
gout[n*729+583] += + s[421];
gout[n*729+584] += + s[422];
gout[n*729+585] += + s[423];
gout[n*729+586] += + s[424];
gout[n*729+587] += + s[425];
gout[n*729+588] += + s[426];
gout[n*729+589] += + s[427];
gout[n*729+590] += + s[428];
gout[n*729+591] += + s[429];
gout[n*729+592] += + s[430];
gout[n*729+593] += + s[431];
gout[n*729+594] += + s[432];
gout[n*729+595] += + s[433];
gout[n*729+596] += + s[434];
gout[n*729+597] += + s[435];
gout[n*729+598] += + s[436];
gout[n*729+599] += + s[437];
gout[n*729+600] += + s[438];
gout[n*729+601] += + s[439];
gout[n*729+602] += + s[440];
gout[n*729+603] += + s[441];
gout[n*729+604] += + s[442];
gout[n*729+605] += + s[443];
gout[n*729+606] += + s[444];
gout[n*729+607] += + s[445];
gout[n*729+608] += + s[446];
gout[n*729+609] += + s[447];
gout[n*729+610] += + s[448];
gout[n*729+611] += + s[449];
gout[n*729+612] += + s[450];
gout[n*729+613] += + s[451];
gout[n*729+614] += + s[452];
gout[n*729+615] += + s[453];
gout[n*729+616] += + s[454];
gout[n*729+617] += + s[455];
gout[n*729+618] += + s[456];
gout[n*729+619] += + s[457];
gout[n*729+620] += + s[458];
gout[n*729+621] += + s[459];
gout[n*729+622] += + s[460];
gout[n*729+623] += + s[461];
gout[n*729+624] += + s[462];
gout[n*729+625] += + s[463];
gout[n*729+626] += + s[464];
gout[n*729+627] += + s[465];
gout[n*729+628] += + s[466];
gout[n*729+629] += + s[467];
gout[n*729+630] += + s[468];
gout[n*729+631] += + s[469];
gout[n*729+632] += + s[470];
gout[n*729+633] += + s[471];
gout[n*729+634] += + s[472];
gout[n*729+635] += + s[473];
gout[n*729+636] += + s[474];
gout[n*729+637] += + s[475];
gout[n*729+638] += + s[476];
gout[n*729+639] += + s[477];
gout[n*729+640] += + s[478];
gout[n*729+641] += + s[479];
gout[n*729+642] += + s[480];
gout[n*729+643] += + s[481];
gout[n*729+644] += + s[482];
gout[n*729+645] += + s[483];
gout[n*729+646] += + s[484];
gout[n*729+647] += + s[485];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipmmipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipmmipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipmmipip_cart
CACHE_SIZE_T int1e_ipipmmipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipmmipip_sph
CACHE_SIZE_T int1e_ipipmmipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipmmipip_spinor
ALL_CINT1E(int1e_ipipmmipip)
ALL_CINT1E_FORTRAN_(int1e_ipipmmipip)
/* <i|RI RI RI |NABLA j> */
void CINTgout1e_int1e_mmmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_mmmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mmmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mmmip_cart
CACHE_SIZE_T int1e_mmmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mmmip_sph
CACHE_SIZE_T int1e_mmmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mmmip_spinor
ALL_CINT1E(int1e_mmmip)
ALL_CINT1E_FORTRAN_(int1e_mmmip)
/* <i|RI RI RI |NABLA NABLA j> */
void CINTgout1e_int1e_mmmipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_mmmipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mmmipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mmmipip_cart
CACHE_SIZE_T int1e_mmmipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mmmipip_sph
CACHE_SIZE_T int1e_mmmipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mmmipip_spinor
ALL_CINT1E(int1e_mmmipip)
ALL_CINT1E_FORTRAN_(int1e_mmmipip)
/* <i|RI RI RI |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_mmmipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g32, g0, envs->i_l+0, envs->j_l+5, 0);
G1E_D_J(g33, g32, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g34, g32, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g35, g34, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g36, g32, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g37, g36, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g38, g36, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g39, g38, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g40, g32, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g41, g40, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g42, g40, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g43, g42, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g44, g40, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g45, g44, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g46, g44, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g47, g46, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g48, g32, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g49, g48, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g50, g48, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g51, g50, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g52, g48, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g53, g52, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g54, g52, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g55, g54, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g56, g48, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g57, g56, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g58, g56, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g59, g58, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g60, g56, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g61, g60, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g62, g60, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g63, g62, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_mmmipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mmmipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mmmipipip_cart
CACHE_SIZE_T int1e_mmmipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mmmipipip_sph
CACHE_SIZE_T int1e_mmmipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mmmipipip_spinor
ALL_CINT1E(int1e_mmmipipip)
ALL_CINT1E_FORTRAN_(int1e_mmmipipip)
/* <i|RI RI RI |NABLA NABLA NABLA NABLA j> */
void CINTgout1e_int1e_mmmipipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double *g64 = g63 + envs->g_size * 3;
double *g65 = g64 + envs->g_size * 3;
double *g66 = g65 + envs->g_size * 3;
double *g67 = g66 + envs->g_size * 3;
double *g68 = g67 + envs->g_size * 3;
double *g69 = g68 + envs->g_size * 3;
double *g70 = g69 + envs->g_size * 3;
double *g71 = g70 + envs->g_size * 3;
double *g72 = g71 + envs->g_size * 3;
double *g73 = g72 + envs->g_size * 3;
double *g74 = g73 + envs->g_size * 3;
double *g75 = g74 + envs->g_size * 3;
double *g76 = g75 + envs->g_size * 3;
double *g77 = g76 + envs->g_size * 3;
double *g78 = g77 + envs->g_size * 3;
double *g79 = g78 + envs->g_size * 3;
double *g80 = g79 + envs->g_size * 3;
double *g81 = g80 + envs->g_size * 3;
double *g82 = g81 + envs->g_size * 3;
double *g83 = g82 + envs->g_size * 3;
double *g84 = g83 + envs->g_size * 3;
double *g85 = g84 + envs->g_size * 3;
double *g86 = g85 + envs->g_size * 3;
double *g87 = g86 + envs->g_size * 3;
double *g88 = g87 + envs->g_size * 3;
double *g89 = g88 + envs->g_size * 3;
double *g90 = g89 + envs->g_size * 3;
double *g91 = g90 + envs->g_size * 3;
double *g92 = g91 + envs->g_size * 3;
double *g93 = g92 + envs->g_size * 3;
double *g94 = g93 + envs->g_size * 3;
double *g95 = g94 + envs->g_size * 3;
double *g96 = g95 + envs->g_size * 3;
double *g97 = g96 + envs->g_size * 3;
double *g98 = g97 + envs->g_size * 3;
double *g99 = g98 + envs->g_size * 3;
double *g100 = g99 + envs->g_size * 3;
double *g101 = g100 + envs->g_size * 3;
double *g102 = g101 + envs->g_size * 3;
double *g103 = g102 + envs->g_size * 3;
double *g104 = g103 + envs->g_size * 3;
double *g105 = g104 + envs->g_size * 3;
double *g106 = g105 + envs->g_size * 3;
double *g107 = g106 + envs->g_size * 3;
double *g108 = g107 + envs->g_size * 3;
double *g109 = g108 + envs->g_size * 3;
double *g110 = g109 + envs->g_size * 3;
double *g111 = g110 + envs->g_size * 3;
double *g112 = g111 + envs->g_size * 3;
double *g113 = g112 + envs->g_size * 3;
double *g114 = g113 + envs->g_size * 3;
double *g115 = g114 + envs->g_size * 3;
double *g116 = g115 + envs->g_size * 3;
double *g117 = g116 + envs->g_size * 3;
double *g118 = g117 + envs->g_size * 3;
double *g119 = g118 + envs->g_size * 3;
double *g120 = g119 + envs->g_size * 3;
double *g121 = g120 + envs->g_size * 3;
double *g122 = g121 + envs->g_size * 3;
double *g123 = g122 + envs->g_size * 3;
double *g124 = g123 + envs->g_size * 3;
double *g125 = g124 + envs->g_size * 3;
double *g126 = g125 + envs->g_size * 3;
double *g127 = g126 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[2187];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g32, g0, envs->i_l+0, envs->j_l+5, 0);
G1E_D_J(g33, g32, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g34, g32, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g35, g34, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g36, g32, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g37, g36, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g38, g36, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g39, g38, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g40, g32, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g41, g40, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g42, g40, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g43, g42, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g44, g40, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g45, g44, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g46, g44, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g47, g46, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g48, g32, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g49, g48, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g50, g48, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g51, g50, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g52, g48, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g53, g52, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g54, g52, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g55, g54, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g56, g48, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g57, g56, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g58, g56, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g59, g58, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g60, g56, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g61, g60, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g62, g60, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g63, g62, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g64, g0, envs->i_l+0, envs->j_l+6, 0);
G1E_D_J(g65, g64, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g66, g64, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g67, g66, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g68, g64, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g69, g68, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g70, g68, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g71, g70, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g72, g64, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g73, g72, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g74, g72, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g75, g74, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g76, g72, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g77, g76, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g78, g76, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g79, g78, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g80, g64, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g81, g80, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g82, g80, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g83, g82, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g84, g80, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g85, g84, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g86, g84, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g87, g86, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g88, g80, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g89, g88, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g90, g88, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g91, g90, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g92, g88, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g93, g92, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g94, g92, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g95, g94, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g96, g64, envs->i_l+0, envs->j_l+5, 0);
G1E_D_J(g97, g96, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g98, g96, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g99, g98, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g100, g96, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g101, g100, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g102, g100, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g103, g102, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g104, g96, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g105, g104, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g106, g104, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g107, g106, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g108, g104, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g109, g108, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g110, g108, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g111, g110, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g112, g96, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g113, g112, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g114, g112, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g115, g114, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g116, g112, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g117, g116, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g118, g116, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g119, g118, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g120, g112, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g121, g120, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g122, g120, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g123, g122, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g124, g120, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g125, g124, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g126, g124, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g127, g126, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g127[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g126[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g126[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g125[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g124[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g124[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g125[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g124[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g124[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g123[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g122[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g122[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g121[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g120[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g120[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g121[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g120[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g120[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g123[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g122[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g122[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g121[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g120[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g120[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g121[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g120[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g120[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g119[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g118[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g118[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g117[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g116[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g116[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g117[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g116[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g116[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g115[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g114[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g114[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g113[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g112[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g112[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g113[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g112[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g112[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g115[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g114[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g114[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g113[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g112[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g112[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g113[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g112[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g112[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g119[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g118[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g118[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g117[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g116[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g116[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g117[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g116[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g116[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g115[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g114[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g114[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g113[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g112[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g112[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g113[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g112[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g112[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g115[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g114[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g114[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g113[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g112[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g112[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g113[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g112[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g112[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g111[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g110[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g110[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g109[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g108[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g108[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g109[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g108[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g108[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g107[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g106[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g106[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g105[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g104[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g104[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g105[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g104[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g104[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g107[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g106[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g106[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g105[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g104[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g104[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g105[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g104[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g104[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g103[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g102[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g102[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g101[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g100[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g100[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g101[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g100[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g100[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g99[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g98[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g98[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g97[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g96[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g96[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g97[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g96[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g96[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g99[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g98[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g98[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g97[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g96[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g96[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g97[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g96[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g96[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g103[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g102[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g102[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g101[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g100[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g100[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g101[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g100[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g100[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g99[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g98[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g98[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g97[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g96[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g96[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g97[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g96[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g96[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g99[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g98[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g98[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g97[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g96[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g96[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g97[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g96[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g96[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g111[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g110[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g110[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g109[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g108[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g108[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g109[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g108[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g108[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g107[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g106[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g106[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g105[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g104[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g104[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g105[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g104[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g104[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g107[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g106[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g106[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g105[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g104[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g104[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g105[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g104[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g104[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g103[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g102[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g102[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g101[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g100[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g100[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g101[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g100[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g100[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g99[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g98[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g98[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g97[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g96[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g96[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g97[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g96[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g96[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g99[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g98[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g98[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g97[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g96[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g96[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g97[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g96[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g96[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g103[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g102[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g102[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g101[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g100[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g100[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g101[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g100[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g100[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g99[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g98[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g98[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g97[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g96[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g96[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g97[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g96[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g96[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g99[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g98[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g98[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g97[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g96[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g96[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g97[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g96[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g96[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g95[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g94[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g94[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g93[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g92[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g92[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g93[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g92[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g92[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g91[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g90[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g90[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g89[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g88[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g88[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g89[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g88[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g88[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g91[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g90[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g90[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g89[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g88[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g88[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g89[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g88[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g88[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g87[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g86[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g86[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g85[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g84[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g84[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g85[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g84[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g84[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g83[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g82[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g82[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g81[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g80[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g80[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g81[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g80[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g80[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g83[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g82[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g82[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g81[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g80[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g80[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g81[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g80[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g80[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g87[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g86[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g86[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g85[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g84[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g84[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g85[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g84[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g84[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g83[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g82[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g82[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g81[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g80[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g80[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g81[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g80[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g80[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g83[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g82[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g82[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g81[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g80[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g80[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g81[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g80[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g80[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g79[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g78[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g78[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g77[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g76[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g76[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g77[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g76[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g76[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g75[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g74[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g74[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g73[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g72[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g72[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g73[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g72[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g72[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g75[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g74[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g74[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g73[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g72[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g72[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g73[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g72[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g72[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g71[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g70[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g70[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g69[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g68[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g68[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g69[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g68[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g68[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g67[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g66[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g66[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g65[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g64[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g64[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g65[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g64[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g64[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g67[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g66[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g66[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g65[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g64[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g64[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g65[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g64[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g64[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g71[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g70[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g70[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g69[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g68[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g68[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g69[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g68[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g68[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g67[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g66[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g66[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g65[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g64[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g64[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g65[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g64[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g64[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g67[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g66[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g66[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g65[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g64[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g64[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g65[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g64[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g64[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g79[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g78[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g78[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g77[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g76[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g76[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g77[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g76[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g76[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g75[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g74[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g74[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g73[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g72[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g72[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g73[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g72[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g72[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g75[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g74[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g74[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g73[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g72[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g72[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g73[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g72[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g72[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g71[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g70[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g70[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g69[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g68[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g68[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g69[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g68[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g68[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g67[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g66[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g66[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g65[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g64[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g64[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g65[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g64[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g64[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g67[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g66[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g66[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g65[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g64[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g64[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g65[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g64[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g64[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g71[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g70[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g70[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g69[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g68[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g68[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g69[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g68[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g68[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g67[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g66[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g66[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g65[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g64[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g64[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g65[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g64[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g64[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g67[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g66[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g66[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g65[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g64[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g64[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g65[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g64[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g64[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g95[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g94[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g94[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g93[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g92[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g92[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g93[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g92[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g92[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g91[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g90[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g90[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g89[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g88[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g88[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g89[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g88[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g88[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g91[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g90[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g90[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g89[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g88[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g88[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g89[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g88[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g88[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g87[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g86[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g86[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g85[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g84[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g84[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g85[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g84[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g84[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g83[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g82[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g82[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g81[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g80[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g80[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g81[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g80[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g80[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g83[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g82[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g82[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g81[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g80[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g80[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g81[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g80[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g80[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g87[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g86[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g86[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g85[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g84[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g84[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g85[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g84[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g84[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g83[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g82[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g82[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g81[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g80[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g80[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g81[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g80[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g80[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g83[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g82[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g82[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g81[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g80[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g80[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g81[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g80[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g80[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g79[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g78[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g78[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g77[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g76[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g76[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g77[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g76[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g76[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g75[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g74[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g74[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g73[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g72[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g72[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g73[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g72[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g72[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g75[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g74[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g74[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g73[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g72[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g72[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g73[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g72[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g72[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g71[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g70[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g70[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g69[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g68[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g68[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g69[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g68[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g68[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g67[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g66[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g66[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g65[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g64[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g64[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g65[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g64[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g64[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g67[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g66[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g66[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g65[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g64[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g64[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g65[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g64[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g64[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g71[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g70[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g70[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g69[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g68[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g68[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g69[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g68[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g68[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g67[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g66[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g66[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g65[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g64[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g64[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g65[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g64[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g64[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g67[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g66[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g66[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g65[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g64[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g64[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g65[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g64[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g64[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g79[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g78[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g78[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g77[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g76[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g76[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g77[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g76[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g76[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g75[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g74[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g74[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g73[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g72[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g72[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g73[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g72[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g72[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g75[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g74[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g74[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g73[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g72[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g72[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g73[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g72[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g72[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g71[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g70[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g70[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g69[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g68[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g68[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g69[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g68[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g68[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g67[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g66[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g66[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g65[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g64[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g64[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g65[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g64[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g64[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g67[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g66[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g66[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g65[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g64[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g64[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g65[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g64[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g64[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g71[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g70[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g70[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g69[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g68[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g68[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g69[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g68[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g68[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g67[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g66[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g66[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g65[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g64[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g64[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g65[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g64[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g64[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g67[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g66[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g66[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g65[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g64[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g64[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g65[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g64[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g64[ix+0]*g0[iy+0]*g63[iz+0];
s[729] = + g63[ix+0]*g64[iy+0]*g0[iz+0];
s[730] = + g62[ix+0]*g65[iy+0]*g0[iz+0];
s[731] = + g62[ix+0]*g64[iy+0]*g1[iz+0];
s[732] = + g61[ix+0]*g66[iy+0]*g0[iz+0];
s[733] = + g60[ix+0]*g67[iy+0]*g0[iz+0];
s[734] = + g60[ix+0]*g66[iy+0]*g1[iz+0];
s[735] = + g61[ix+0]*g64[iy+0]*g2[iz+0];
s[736] = + g60[ix+0]*g65[iy+0]*g2[iz+0];
s[737] = + g60[ix+0]*g64[iy+0]*g3[iz+0];
s[738] = + g59[ix+0]*g68[iy+0]*g0[iz+0];
s[739] = + g58[ix+0]*g69[iy+0]*g0[iz+0];
s[740] = + g58[ix+0]*g68[iy+0]*g1[iz+0];
s[741] = + g57[ix+0]*g70[iy+0]*g0[iz+0];
s[742] = + g56[ix+0]*g71[iy+0]*g0[iz+0];
s[743] = + g56[ix+0]*g70[iy+0]*g1[iz+0];
s[744] = + g57[ix+0]*g68[iy+0]*g2[iz+0];
s[745] = + g56[ix+0]*g69[iy+0]*g2[iz+0];
s[746] = + g56[ix+0]*g68[iy+0]*g3[iz+0];
s[747] = + g59[ix+0]*g64[iy+0]*g4[iz+0];
s[748] = + g58[ix+0]*g65[iy+0]*g4[iz+0];
s[749] = + g58[ix+0]*g64[iy+0]*g5[iz+0];
s[750] = + g57[ix+0]*g66[iy+0]*g4[iz+0];
s[751] = + g56[ix+0]*g67[iy+0]*g4[iz+0];
s[752] = + g56[ix+0]*g66[iy+0]*g5[iz+0];
s[753] = + g57[ix+0]*g64[iy+0]*g6[iz+0];
s[754] = + g56[ix+0]*g65[iy+0]*g6[iz+0];
s[755] = + g56[ix+0]*g64[iy+0]*g7[iz+0];
s[756] = + g55[ix+0]*g72[iy+0]*g0[iz+0];
s[757] = + g54[ix+0]*g73[iy+0]*g0[iz+0];
s[758] = + g54[ix+0]*g72[iy+0]*g1[iz+0];
s[759] = + g53[ix+0]*g74[iy+0]*g0[iz+0];
s[760] = + g52[ix+0]*g75[iy+0]*g0[iz+0];
s[761] = + g52[ix+0]*g74[iy+0]*g1[iz+0];
s[762] = + g53[ix+0]*g72[iy+0]*g2[iz+0];
s[763] = + g52[ix+0]*g73[iy+0]*g2[iz+0];
s[764] = + g52[ix+0]*g72[iy+0]*g3[iz+0];
s[765] = + g51[ix+0]*g76[iy+0]*g0[iz+0];
s[766] = + g50[ix+0]*g77[iy+0]*g0[iz+0];
s[767] = + g50[ix+0]*g76[iy+0]*g1[iz+0];
s[768] = + g49[ix+0]*g78[iy+0]*g0[iz+0];
s[769] = + g48[ix+0]*g79[iy+0]*g0[iz+0];
s[770] = + g48[ix+0]*g78[iy+0]*g1[iz+0];
s[771] = + g49[ix+0]*g76[iy+0]*g2[iz+0];
s[772] = + g48[ix+0]*g77[iy+0]*g2[iz+0];
s[773] = + g48[ix+0]*g76[iy+0]*g3[iz+0];
s[774] = + g51[ix+0]*g72[iy+0]*g4[iz+0];
s[775] = + g50[ix+0]*g73[iy+0]*g4[iz+0];
s[776] = + g50[ix+0]*g72[iy+0]*g5[iz+0];
s[777] = + g49[ix+0]*g74[iy+0]*g4[iz+0];
s[778] = + g48[ix+0]*g75[iy+0]*g4[iz+0];
s[779] = + g48[ix+0]*g74[iy+0]*g5[iz+0];
s[780] = + g49[ix+0]*g72[iy+0]*g6[iz+0];
s[781] = + g48[ix+0]*g73[iy+0]*g6[iz+0];
s[782] = + g48[ix+0]*g72[iy+0]*g7[iz+0];
s[783] = + g55[ix+0]*g64[iy+0]*g8[iz+0];
s[784] = + g54[ix+0]*g65[iy+0]*g8[iz+0];
s[785] = + g54[ix+0]*g64[iy+0]*g9[iz+0];
s[786] = + g53[ix+0]*g66[iy+0]*g8[iz+0];
s[787] = + g52[ix+0]*g67[iy+0]*g8[iz+0];
s[788] = + g52[ix+0]*g66[iy+0]*g9[iz+0];
s[789] = + g53[ix+0]*g64[iy+0]*g10[iz+0];
s[790] = + g52[ix+0]*g65[iy+0]*g10[iz+0];
s[791] = + g52[ix+0]*g64[iy+0]*g11[iz+0];
s[792] = + g51[ix+0]*g68[iy+0]*g8[iz+0];
s[793] = + g50[ix+0]*g69[iy+0]*g8[iz+0];
s[794] = + g50[ix+0]*g68[iy+0]*g9[iz+0];
s[795] = + g49[ix+0]*g70[iy+0]*g8[iz+0];
s[796] = + g48[ix+0]*g71[iy+0]*g8[iz+0];
s[797] = + g48[ix+0]*g70[iy+0]*g9[iz+0];
s[798] = + g49[ix+0]*g68[iy+0]*g10[iz+0];
s[799] = + g48[ix+0]*g69[iy+0]*g10[iz+0];
s[800] = + g48[ix+0]*g68[iy+0]*g11[iz+0];
s[801] = + g51[ix+0]*g64[iy+0]*g12[iz+0];
s[802] = + g50[ix+0]*g65[iy+0]*g12[iz+0];
s[803] = + g50[ix+0]*g64[iy+0]*g13[iz+0];
s[804] = + g49[ix+0]*g66[iy+0]*g12[iz+0];
s[805] = + g48[ix+0]*g67[iy+0]*g12[iz+0];
s[806] = + g48[ix+0]*g66[iy+0]*g13[iz+0];
s[807] = + g49[ix+0]*g64[iy+0]*g14[iz+0];
s[808] = + g48[ix+0]*g65[iy+0]*g14[iz+0];
s[809] = + g48[ix+0]*g64[iy+0]*g15[iz+0];
s[810] = + g47[ix+0]*g80[iy+0]*g0[iz+0];
s[811] = + g46[ix+0]*g81[iy+0]*g0[iz+0];
s[812] = + g46[ix+0]*g80[iy+0]*g1[iz+0];
s[813] = + g45[ix+0]*g82[iy+0]*g0[iz+0];
s[814] = + g44[ix+0]*g83[iy+0]*g0[iz+0];
s[815] = + g44[ix+0]*g82[iy+0]*g1[iz+0];
s[816] = + g45[ix+0]*g80[iy+0]*g2[iz+0];
s[817] = + g44[ix+0]*g81[iy+0]*g2[iz+0];
s[818] = + g44[ix+0]*g80[iy+0]*g3[iz+0];
s[819] = + g43[ix+0]*g84[iy+0]*g0[iz+0];
s[820] = + g42[ix+0]*g85[iy+0]*g0[iz+0];
s[821] = + g42[ix+0]*g84[iy+0]*g1[iz+0];
s[822] = + g41[ix+0]*g86[iy+0]*g0[iz+0];
s[823] = + g40[ix+0]*g87[iy+0]*g0[iz+0];
s[824] = + g40[ix+0]*g86[iy+0]*g1[iz+0];
s[825] = + g41[ix+0]*g84[iy+0]*g2[iz+0];
s[826] = + g40[ix+0]*g85[iy+0]*g2[iz+0];
s[827] = + g40[ix+0]*g84[iy+0]*g3[iz+0];
s[828] = + g43[ix+0]*g80[iy+0]*g4[iz+0];
s[829] = + g42[ix+0]*g81[iy+0]*g4[iz+0];
s[830] = + g42[ix+0]*g80[iy+0]*g5[iz+0];
s[831] = + g41[ix+0]*g82[iy+0]*g4[iz+0];
s[832] = + g40[ix+0]*g83[iy+0]*g4[iz+0];
s[833] = + g40[ix+0]*g82[iy+0]*g5[iz+0];
s[834] = + g41[ix+0]*g80[iy+0]*g6[iz+0];
s[835] = + g40[ix+0]*g81[iy+0]*g6[iz+0];
s[836] = + g40[ix+0]*g80[iy+0]*g7[iz+0];
s[837] = + g39[ix+0]*g88[iy+0]*g0[iz+0];
s[838] = + g38[ix+0]*g89[iy+0]*g0[iz+0];
s[839] = + g38[ix+0]*g88[iy+0]*g1[iz+0];
s[840] = + g37[ix+0]*g90[iy+0]*g0[iz+0];
s[841] = + g36[ix+0]*g91[iy+0]*g0[iz+0];
s[842] = + g36[ix+0]*g90[iy+0]*g1[iz+0];
s[843] = + g37[ix+0]*g88[iy+0]*g2[iz+0];
s[844] = + g36[ix+0]*g89[iy+0]*g2[iz+0];
s[845] = + g36[ix+0]*g88[iy+0]*g3[iz+0];
s[846] = + g35[ix+0]*g92[iy+0]*g0[iz+0];
s[847] = + g34[ix+0]*g93[iy+0]*g0[iz+0];
s[848] = + g34[ix+0]*g92[iy+0]*g1[iz+0];
s[849] = + g33[ix+0]*g94[iy+0]*g0[iz+0];
s[850] = + g32[ix+0]*g95[iy+0]*g0[iz+0];
s[851] = + g32[ix+0]*g94[iy+0]*g1[iz+0];
s[852] = + g33[ix+0]*g92[iy+0]*g2[iz+0];
s[853] = + g32[ix+0]*g93[iy+0]*g2[iz+0];
s[854] = + g32[ix+0]*g92[iy+0]*g3[iz+0];
s[855] = + g35[ix+0]*g88[iy+0]*g4[iz+0];
s[856] = + g34[ix+0]*g89[iy+0]*g4[iz+0];
s[857] = + g34[ix+0]*g88[iy+0]*g5[iz+0];
s[858] = + g33[ix+0]*g90[iy+0]*g4[iz+0];
s[859] = + g32[ix+0]*g91[iy+0]*g4[iz+0];
s[860] = + g32[ix+0]*g90[iy+0]*g5[iz+0];
s[861] = + g33[ix+0]*g88[iy+0]*g6[iz+0];
s[862] = + g32[ix+0]*g89[iy+0]*g6[iz+0];
s[863] = + g32[ix+0]*g88[iy+0]*g7[iz+0];
s[864] = + g39[ix+0]*g80[iy+0]*g8[iz+0];
s[865] = + g38[ix+0]*g81[iy+0]*g8[iz+0];
s[866] = + g38[ix+0]*g80[iy+0]*g9[iz+0];
s[867] = + g37[ix+0]*g82[iy+0]*g8[iz+0];
s[868] = + g36[ix+0]*g83[iy+0]*g8[iz+0];
s[869] = + g36[ix+0]*g82[iy+0]*g9[iz+0];
s[870] = + g37[ix+0]*g80[iy+0]*g10[iz+0];
s[871] = + g36[ix+0]*g81[iy+0]*g10[iz+0];
s[872] = + g36[ix+0]*g80[iy+0]*g11[iz+0];
s[873] = + g35[ix+0]*g84[iy+0]*g8[iz+0];
s[874] = + g34[ix+0]*g85[iy+0]*g8[iz+0];
s[875] = + g34[ix+0]*g84[iy+0]*g9[iz+0];
s[876] = + g33[ix+0]*g86[iy+0]*g8[iz+0];
s[877] = + g32[ix+0]*g87[iy+0]*g8[iz+0];
s[878] = + g32[ix+0]*g86[iy+0]*g9[iz+0];
s[879] = + g33[ix+0]*g84[iy+0]*g10[iz+0];
s[880] = + g32[ix+0]*g85[iy+0]*g10[iz+0];
s[881] = + g32[ix+0]*g84[iy+0]*g11[iz+0];
s[882] = + g35[ix+0]*g80[iy+0]*g12[iz+0];
s[883] = + g34[ix+0]*g81[iy+0]*g12[iz+0];
s[884] = + g34[ix+0]*g80[iy+0]*g13[iz+0];
s[885] = + g33[ix+0]*g82[iy+0]*g12[iz+0];
s[886] = + g32[ix+0]*g83[iy+0]*g12[iz+0];
s[887] = + g32[ix+0]*g82[iy+0]*g13[iz+0];
s[888] = + g33[ix+0]*g80[iy+0]*g14[iz+0];
s[889] = + g32[ix+0]*g81[iy+0]*g14[iz+0];
s[890] = + g32[ix+0]*g80[iy+0]*g15[iz+0];
s[891] = + g47[ix+0]*g64[iy+0]*g16[iz+0];
s[892] = + g46[ix+0]*g65[iy+0]*g16[iz+0];
s[893] = + g46[ix+0]*g64[iy+0]*g17[iz+0];
s[894] = + g45[ix+0]*g66[iy+0]*g16[iz+0];
s[895] = + g44[ix+0]*g67[iy+0]*g16[iz+0];
s[896] = + g44[ix+0]*g66[iy+0]*g17[iz+0];
s[897] = + g45[ix+0]*g64[iy+0]*g18[iz+0];
s[898] = + g44[ix+0]*g65[iy+0]*g18[iz+0];
s[899] = + g44[ix+0]*g64[iy+0]*g19[iz+0];
s[900] = + g43[ix+0]*g68[iy+0]*g16[iz+0];
s[901] = + g42[ix+0]*g69[iy+0]*g16[iz+0];
s[902] = + g42[ix+0]*g68[iy+0]*g17[iz+0];
s[903] = + g41[ix+0]*g70[iy+0]*g16[iz+0];
s[904] = + g40[ix+0]*g71[iy+0]*g16[iz+0];
s[905] = + g40[ix+0]*g70[iy+0]*g17[iz+0];
s[906] = + g41[ix+0]*g68[iy+0]*g18[iz+0];
s[907] = + g40[ix+0]*g69[iy+0]*g18[iz+0];
s[908] = + g40[ix+0]*g68[iy+0]*g19[iz+0];
s[909] = + g43[ix+0]*g64[iy+0]*g20[iz+0];
s[910] = + g42[ix+0]*g65[iy+0]*g20[iz+0];
s[911] = + g42[ix+0]*g64[iy+0]*g21[iz+0];
s[912] = + g41[ix+0]*g66[iy+0]*g20[iz+0];
s[913] = + g40[ix+0]*g67[iy+0]*g20[iz+0];
s[914] = + g40[ix+0]*g66[iy+0]*g21[iz+0];
s[915] = + g41[ix+0]*g64[iy+0]*g22[iz+0];
s[916] = + g40[ix+0]*g65[iy+0]*g22[iz+0];
s[917] = + g40[ix+0]*g64[iy+0]*g23[iz+0];
s[918] = + g39[ix+0]*g72[iy+0]*g16[iz+0];
s[919] = + g38[ix+0]*g73[iy+0]*g16[iz+0];
s[920] = + g38[ix+0]*g72[iy+0]*g17[iz+0];
s[921] = + g37[ix+0]*g74[iy+0]*g16[iz+0];
s[922] = + g36[ix+0]*g75[iy+0]*g16[iz+0];
s[923] = + g36[ix+0]*g74[iy+0]*g17[iz+0];
s[924] = + g37[ix+0]*g72[iy+0]*g18[iz+0];
s[925] = + g36[ix+0]*g73[iy+0]*g18[iz+0];
s[926] = + g36[ix+0]*g72[iy+0]*g19[iz+0];
s[927] = + g35[ix+0]*g76[iy+0]*g16[iz+0];
s[928] = + g34[ix+0]*g77[iy+0]*g16[iz+0];
s[929] = + g34[ix+0]*g76[iy+0]*g17[iz+0];
s[930] = + g33[ix+0]*g78[iy+0]*g16[iz+0];
s[931] = + g32[ix+0]*g79[iy+0]*g16[iz+0];
s[932] = + g32[ix+0]*g78[iy+0]*g17[iz+0];
s[933] = + g33[ix+0]*g76[iy+0]*g18[iz+0];
s[934] = + g32[ix+0]*g77[iy+0]*g18[iz+0];
s[935] = + g32[ix+0]*g76[iy+0]*g19[iz+0];
s[936] = + g35[ix+0]*g72[iy+0]*g20[iz+0];
s[937] = + g34[ix+0]*g73[iy+0]*g20[iz+0];
s[938] = + g34[ix+0]*g72[iy+0]*g21[iz+0];
s[939] = + g33[ix+0]*g74[iy+0]*g20[iz+0];
s[940] = + g32[ix+0]*g75[iy+0]*g20[iz+0];
s[941] = + g32[ix+0]*g74[iy+0]*g21[iz+0];
s[942] = + g33[ix+0]*g72[iy+0]*g22[iz+0];
s[943] = + g32[ix+0]*g73[iy+0]*g22[iz+0];
s[944] = + g32[ix+0]*g72[iy+0]*g23[iz+0];
s[945] = + g39[ix+0]*g64[iy+0]*g24[iz+0];
s[946] = + g38[ix+0]*g65[iy+0]*g24[iz+0];
s[947] = + g38[ix+0]*g64[iy+0]*g25[iz+0];
s[948] = + g37[ix+0]*g66[iy+0]*g24[iz+0];
s[949] = + g36[ix+0]*g67[iy+0]*g24[iz+0];
s[950] = + g36[ix+0]*g66[iy+0]*g25[iz+0];
s[951] = + g37[ix+0]*g64[iy+0]*g26[iz+0];
s[952] = + g36[ix+0]*g65[iy+0]*g26[iz+0];
s[953] = + g36[ix+0]*g64[iy+0]*g27[iz+0];
s[954] = + g35[ix+0]*g68[iy+0]*g24[iz+0];
s[955] = + g34[ix+0]*g69[iy+0]*g24[iz+0];
s[956] = + g34[ix+0]*g68[iy+0]*g25[iz+0];
s[957] = + g33[ix+0]*g70[iy+0]*g24[iz+0];
s[958] = + g32[ix+0]*g71[iy+0]*g24[iz+0];
s[959] = + g32[ix+0]*g70[iy+0]*g25[iz+0];
s[960] = + g33[ix+0]*g68[iy+0]*g26[iz+0];
s[961] = + g32[ix+0]*g69[iy+0]*g26[iz+0];
s[962] = + g32[ix+0]*g68[iy+0]*g27[iz+0];
s[963] = + g35[ix+0]*g64[iy+0]*g28[iz+0];
s[964] = + g34[ix+0]*g65[iy+0]*g28[iz+0];
s[965] = + g34[ix+0]*g64[iy+0]*g29[iz+0];
s[966] = + g33[ix+0]*g66[iy+0]*g28[iz+0];
s[967] = + g32[ix+0]*g67[iy+0]*g28[iz+0];
s[968] = + g32[ix+0]*g66[iy+0]*g29[iz+0];
s[969] = + g33[ix+0]*g64[iy+0]*g30[iz+0];
s[970] = + g32[ix+0]*g65[iy+0]*g30[iz+0];
s[971] = + g32[ix+0]*g64[iy+0]*g31[iz+0];
s[972] = + g31[ix+0]*g96[iy+0]*g0[iz+0];
s[973] = + g30[ix+0]*g97[iy+0]*g0[iz+0];
s[974] = + g30[ix+0]*g96[iy+0]*g1[iz+0];
s[975] = + g29[ix+0]*g98[iy+0]*g0[iz+0];
s[976] = + g28[ix+0]*g99[iy+0]*g0[iz+0];
s[977] = + g28[ix+0]*g98[iy+0]*g1[iz+0];
s[978] = + g29[ix+0]*g96[iy+0]*g2[iz+0];
s[979] = + g28[ix+0]*g97[iy+0]*g2[iz+0];
s[980] = + g28[ix+0]*g96[iy+0]*g3[iz+0];
s[981] = + g27[ix+0]*g100[iy+0]*g0[iz+0];
s[982] = + g26[ix+0]*g101[iy+0]*g0[iz+0];
s[983] = + g26[ix+0]*g100[iy+0]*g1[iz+0];
s[984] = + g25[ix+0]*g102[iy+0]*g0[iz+0];
s[985] = + g24[ix+0]*g103[iy+0]*g0[iz+0];
s[986] = + g24[ix+0]*g102[iy+0]*g1[iz+0];
s[987] = + g25[ix+0]*g100[iy+0]*g2[iz+0];
s[988] = + g24[ix+0]*g101[iy+0]*g2[iz+0];
s[989] = + g24[ix+0]*g100[iy+0]*g3[iz+0];
s[990] = + g27[ix+0]*g96[iy+0]*g4[iz+0];
s[991] = + g26[ix+0]*g97[iy+0]*g4[iz+0];
s[992] = + g26[ix+0]*g96[iy+0]*g5[iz+0];
s[993] = + g25[ix+0]*g98[iy+0]*g4[iz+0];
s[994] = + g24[ix+0]*g99[iy+0]*g4[iz+0];
s[995] = + g24[ix+0]*g98[iy+0]*g5[iz+0];
s[996] = + g25[ix+0]*g96[iy+0]*g6[iz+0];
s[997] = + g24[ix+0]*g97[iy+0]*g6[iz+0];
s[998] = + g24[ix+0]*g96[iy+0]*g7[iz+0];
s[999] = + g23[ix+0]*g104[iy+0]*g0[iz+0];
s[1000] = + g22[ix+0]*g105[iy+0]*g0[iz+0];
s[1001] = + g22[ix+0]*g104[iy+0]*g1[iz+0];
s[1002] = + g21[ix+0]*g106[iy+0]*g0[iz+0];
s[1003] = + g20[ix+0]*g107[iy+0]*g0[iz+0];
s[1004] = + g20[ix+0]*g106[iy+0]*g1[iz+0];
s[1005] = + g21[ix+0]*g104[iy+0]*g2[iz+0];
s[1006] = + g20[ix+0]*g105[iy+0]*g2[iz+0];
s[1007] = + g20[ix+0]*g104[iy+0]*g3[iz+0];
s[1008] = + g19[ix+0]*g108[iy+0]*g0[iz+0];
s[1009] = + g18[ix+0]*g109[iy+0]*g0[iz+0];
s[1010] = + g18[ix+0]*g108[iy+0]*g1[iz+0];
s[1011] = + g17[ix+0]*g110[iy+0]*g0[iz+0];
s[1012] = + g16[ix+0]*g111[iy+0]*g0[iz+0];
s[1013] = + g16[ix+0]*g110[iy+0]*g1[iz+0];
s[1014] = + g17[ix+0]*g108[iy+0]*g2[iz+0];
s[1015] = + g16[ix+0]*g109[iy+0]*g2[iz+0];
s[1016] = + g16[ix+0]*g108[iy+0]*g3[iz+0];
s[1017] = + g19[ix+0]*g104[iy+0]*g4[iz+0];
s[1018] = + g18[ix+0]*g105[iy+0]*g4[iz+0];
s[1019] = + g18[ix+0]*g104[iy+0]*g5[iz+0];
s[1020] = + g17[ix+0]*g106[iy+0]*g4[iz+0];
s[1021] = + g16[ix+0]*g107[iy+0]*g4[iz+0];
s[1022] = + g16[ix+0]*g106[iy+0]*g5[iz+0];
s[1023] = + g17[ix+0]*g104[iy+0]*g6[iz+0];
s[1024] = + g16[ix+0]*g105[iy+0]*g6[iz+0];
s[1025] = + g16[ix+0]*g104[iy+0]*g7[iz+0];
s[1026] = + g23[ix+0]*g96[iy+0]*g8[iz+0];
s[1027] = + g22[ix+0]*g97[iy+0]*g8[iz+0];
s[1028] = + g22[ix+0]*g96[iy+0]*g9[iz+0];
s[1029] = + g21[ix+0]*g98[iy+0]*g8[iz+0];
s[1030] = + g20[ix+0]*g99[iy+0]*g8[iz+0];
s[1031] = + g20[ix+0]*g98[iy+0]*g9[iz+0];
s[1032] = + g21[ix+0]*g96[iy+0]*g10[iz+0];
s[1033] = + g20[ix+0]*g97[iy+0]*g10[iz+0];
s[1034] = + g20[ix+0]*g96[iy+0]*g11[iz+0];
s[1035] = + g19[ix+0]*g100[iy+0]*g8[iz+0];
s[1036] = + g18[ix+0]*g101[iy+0]*g8[iz+0];
s[1037] = + g18[ix+0]*g100[iy+0]*g9[iz+0];
s[1038] = + g17[ix+0]*g102[iy+0]*g8[iz+0];
s[1039] = + g16[ix+0]*g103[iy+0]*g8[iz+0];
s[1040] = + g16[ix+0]*g102[iy+0]*g9[iz+0];
s[1041] = + g17[ix+0]*g100[iy+0]*g10[iz+0];
s[1042] = + g16[ix+0]*g101[iy+0]*g10[iz+0];
s[1043] = + g16[ix+0]*g100[iy+0]*g11[iz+0];
s[1044] = + g19[ix+0]*g96[iy+0]*g12[iz+0];
s[1045] = + g18[ix+0]*g97[iy+0]*g12[iz+0];
s[1046] = + g18[ix+0]*g96[iy+0]*g13[iz+0];
s[1047] = + g17[ix+0]*g98[iy+0]*g12[iz+0];
s[1048] = + g16[ix+0]*g99[iy+0]*g12[iz+0];
s[1049] = + g16[ix+0]*g98[iy+0]*g13[iz+0];
s[1050] = + g17[ix+0]*g96[iy+0]*g14[iz+0];
s[1051] = + g16[ix+0]*g97[iy+0]*g14[iz+0];
s[1052] = + g16[ix+0]*g96[iy+0]*g15[iz+0];
s[1053] = + g15[ix+0]*g112[iy+0]*g0[iz+0];
s[1054] = + g14[ix+0]*g113[iy+0]*g0[iz+0];
s[1055] = + g14[ix+0]*g112[iy+0]*g1[iz+0];
s[1056] = + g13[ix+0]*g114[iy+0]*g0[iz+0];
s[1057] = + g12[ix+0]*g115[iy+0]*g0[iz+0];
s[1058] = + g12[ix+0]*g114[iy+0]*g1[iz+0];
s[1059] = + g13[ix+0]*g112[iy+0]*g2[iz+0];
s[1060] = + g12[ix+0]*g113[iy+0]*g2[iz+0];
s[1061] = + g12[ix+0]*g112[iy+0]*g3[iz+0];
s[1062] = + g11[ix+0]*g116[iy+0]*g0[iz+0];
s[1063] = + g10[ix+0]*g117[iy+0]*g0[iz+0];
s[1064] = + g10[ix+0]*g116[iy+0]*g1[iz+0];
s[1065] = + g9[ix+0]*g118[iy+0]*g0[iz+0];
s[1066] = + g8[ix+0]*g119[iy+0]*g0[iz+0];
s[1067] = + g8[ix+0]*g118[iy+0]*g1[iz+0];
s[1068] = + g9[ix+0]*g116[iy+0]*g2[iz+0];
s[1069] = + g8[ix+0]*g117[iy+0]*g2[iz+0];
s[1070] = + g8[ix+0]*g116[iy+0]*g3[iz+0];
s[1071] = + g11[ix+0]*g112[iy+0]*g4[iz+0];
s[1072] = + g10[ix+0]*g113[iy+0]*g4[iz+0];
s[1073] = + g10[ix+0]*g112[iy+0]*g5[iz+0];
s[1074] = + g9[ix+0]*g114[iy+0]*g4[iz+0];
s[1075] = + g8[ix+0]*g115[iy+0]*g4[iz+0];
s[1076] = + g8[ix+0]*g114[iy+0]*g5[iz+0];
s[1077] = + g9[ix+0]*g112[iy+0]*g6[iz+0];
s[1078] = + g8[ix+0]*g113[iy+0]*g6[iz+0];
s[1079] = + g8[ix+0]*g112[iy+0]*g7[iz+0];
s[1080] = + g7[ix+0]*g120[iy+0]*g0[iz+0];
s[1081] = + g6[ix+0]*g121[iy+0]*g0[iz+0];
s[1082] = + g6[ix+0]*g120[iy+0]*g1[iz+0];
s[1083] = + g5[ix+0]*g122[iy+0]*g0[iz+0];
s[1084] = + g4[ix+0]*g123[iy+0]*g0[iz+0];
s[1085] = + g4[ix+0]*g122[iy+0]*g1[iz+0];
s[1086] = + g5[ix+0]*g120[iy+0]*g2[iz+0];
s[1087] = + g4[ix+0]*g121[iy+0]*g2[iz+0];
s[1088] = + g4[ix+0]*g120[iy+0]*g3[iz+0];
s[1089] = + g3[ix+0]*g124[iy+0]*g0[iz+0];
s[1090] = + g2[ix+0]*g125[iy+0]*g0[iz+0];
s[1091] = + g2[ix+0]*g124[iy+0]*g1[iz+0];
s[1092] = + g1[ix+0]*g126[iy+0]*g0[iz+0];
s[1093] = + g0[ix+0]*g127[iy+0]*g0[iz+0];
s[1094] = + g0[ix+0]*g126[iy+0]*g1[iz+0];
s[1095] = + g1[ix+0]*g124[iy+0]*g2[iz+0];
s[1096] = + g0[ix+0]*g125[iy+0]*g2[iz+0];
s[1097] = + g0[ix+0]*g124[iy+0]*g3[iz+0];
s[1098] = + g3[ix+0]*g120[iy+0]*g4[iz+0];
s[1099] = + g2[ix+0]*g121[iy+0]*g4[iz+0];
s[1100] = + g2[ix+0]*g120[iy+0]*g5[iz+0];
s[1101] = + g1[ix+0]*g122[iy+0]*g4[iz+0];
s[1102] = + g0[ix+0]*g123[iy+0]*g4[iz+0];
s[1103] = + g0[ix+0]*g122[iy+0]*g5[iz+0];
s[1104] = + g1[ix+0]*g120[iy+0]*g6[iz+0];
s[1105] = + g0[ix+0]*g121[iy+0]*g6[iz+0];
s[1106] = + g0[ix+0]*g120[iy+0]*g7[iz+0];
s[1107] = + g7[ix+0]*g112[iy+0]*g8[iz+0];
s[1108] = + g6[ix+0]*g113[iy+0]*g8[iz+0];
s[1109] = + g6[ix+0]*g112[iy+0]*g9[iz+0];
s[1110] = + g5[ix+0]*g114[iy+0]*g8[iz+0];
s[1111] = + g4[ix+0]*g115[iy+0]*g8[iz+0];
s[1112] = + g4[ix+0]*g114[iy+0]*g9[iz+0];
s[1113] = + g5[ix+0]*g112[iy+0]*g10[iz+0];
s[1114] = + g4[ix+0]*g113[iy+0]*g10[iz+0];
s[1115] = + g4[ix+0]*g112[iy+0]*g11[iz+0];
s[1116] = + g3[ix+0]*g116[iy+0]*g8[iz+0];
s[1117] = + g2[ix+0]*g117[iy+0]*g8[iz+0];
s[1118] = + g2[ix+0]*g116[iy+0]*g9[iz+0];
s[1119] = + g1[ix+0]*g118[iy+0]*g8[iz+0];
s[1120] = + g0[ix+0]*g119[iy+0]*g8[iz+0];
s[1121] = + g0[ix+0]*g118[iy+0]*g9[iz+0];
s[1122] = + g1[ix+0]*g116[iy+0]*g10[iz+0];
s[1123] = + g0[ix+0]*g117[iy+0]*g10[iz+0];
s[1124] = + g0[ix+0]*g116[iy+0]*g11[iz+0];
s[1125] = + g3[ix+0]*g112[iy+0]*g12[iz+0];
s[1126] = + g2[ix+0]*g113[iy+0]*g12[iz+0];
s[1127] = + g2[ix+0]*g112[iy+0]*g13[iz+0];
s[1128] = + g1[ix+0]*g114[iy+0]*g12[iz+0];
s[1129] = + g0[ix+0]*g115[iy+0]*g12[iz+0];
s[1130] = + g0[ix+0]*g114[iy+0]*g13[iz+0];
s[1131] = + g1[ix+0]*g112[iy+0]*g14[iz+0];
s[1132] = + g0[ix+0]*g113[iy+0]*g14[iz+0];
s[1133] = + g0[ix+0]*g112[iy+0]*g15[iz+0];
s[1134] = + g15[ix+0]*g96[iy+0]*g16[iz+0];
s[1135] = + g14[ix+0]*g97[iy+0]*g16[iz+0];
s[1136] = + g14[ix+0]*g96[iy+0]*g17[iz+0];
s[1137] = + g13[ix+0]*g98[iy+0]*g16[iz+0];
s[1138] = + g12[ix+0]*g99[iy+0]*g16[iz+0];
s[1139] = + g12[ix+0]*g98[iy+0]*g17[iz+0];
s[1140] = + g13[ix+0]*g96[iy+0]*g18[iz+0];
s[1141] = + g12[ix+0]*g97[iy+0]*g18[iz+0];
s[1142] = + g12[ix+0]*g96[iy+0]*g19[iz+0];
s[1143] = + g11[ix+0]*g100[iy+0]*g16[iz+0];
s[1144] = + g10[ix+0]*g101[iy+0]*g16[iz+0];
s[1145] = + g10[ix+0]*g100[iy+0]*g17[iz+0];
s[1146] = + g9[ix+0]*g102[iy+0]*g16[iz+0];
s[1147] = + g8[ix+0]*g103[iy+0]*g16[iz+0];
s[1148] = + g8[ix+0]*g102[iy+0]*g17[iz+0];
s[1149] = + g9[ix+0]*g100[iy+0]*g18[iz+0];
s[1150] = + g8[ix+0]*g101[iy+0]*g18[iz+0];
s[1151] = + g8[ix+0]*g100[iy+0]*g19[iz+0];
s[1152] = + g11[ix+0]*g96[iy+0]*g20[iz+0];
s[1153] = + g10[ix+0]*g97[iy+0]*g20[iz+0];
s[1154] = + g10[ix+0]*g96[iy+0]*g21[iz+0];
s[1155] = + g9[ix+0]*g98[iy+0]*g20[iz+0];
s[1156] = + g8[ix+0]*g99[iy+0]*g20[iz+0];
s[1157] = + g8[ix+0]*g98[iy+0]*g21[iz+0];
s[1158] = + g9[ix+0]*g96[iy+0]*g22[iz+0];
s[1159] = + g8[ix+0]*g97[iy+0]*g22[iz+0];
s[1160] = + g8[ix+0]*g96[iy+0]*g23[iz+0];
s[1161] = + g7[ix+0]*g104[iy+0]*g16[iz+0];
s[1162] = + g6[ix+0]*g105[iy+0]*g16[iz+0];
s[1163] = + g6[ix+0]*g104[iy+0]*g17[iz+0];
s[1164] = + g5[ix+0]*g106[iy+0]*g16[iz+0];
s[1165] = + g4[ix+0]*g107[iy+0]*g16[iz+0];
s[1166] = + g4[ix+0]*g106[iy+0]*g17[iz+0];
s[1167] = + g5[ix+0]*g104[iy+0]*g18[iz+0];
s[1168] = + g4[ix+0]*g105[iy+0]*g18[iz+0];
s[1169] = + g4[ix+0]*g104[iy+0]*g19[iz+0];
s[1170] = + g3[ix+0]*g108[iy+0]*g16[iz+0];
s[1171] = + g2[ix+0]*g109[iy+0]*g16[iz+0];
s[1172] = + g2[ix+0]*g108[iy+0]*g17[iz+0];
s[1173] = + g1[ix+0]*g110[iy+0]*g16[iz+0];
s[1174] = + g0[ix+0]*g111[iy+0]*g16[iz+0];
s[1175] = + g0[ix+0]*g110[iy+0]*g17[iz+0];
s[1176] = + g1[ix+0]*g108[iy+0]*g18[iz+0];
s[1177] = + g0[ix+0]*g109[iy+0]*g18[iz+0];
s[1178] = + g0[ix+0]*g108[iy+0]*g19[iz+0];
s[1179] = + g3[ix+0]*g104[iy+0]*g20[iz+0];
s[1180] = + g2[ix+0]*g105[iy+0]*g20[iz+0];
s[1181] = + g2[ix+0]*g104[iy+0]*g21[iz+0];
s[1182] = + g1[ix+0]*g106[iy+0]*g20[iz+0];
s[1183] = + g0[ix+0]*g107[iy+0]*g20[iz+0];
s[1184] = + g0[ix+0]*g106[iy+0]*g21[iz+0];
s[1185] = + g1[ix+0]*g104[iy+0]*g22[iz+0];
s[1186] = + g0[ix+0]*g105[iy+0]*g22[iz+0];
s[1187] = + g0[ix+0]*g104[iy+0]*g23[iz+0];
s[1188] = + g7[ix+0]*g96[iy+0]*g24[iz+0];
s[1189] = + g6[ix+0]*g97[iy+0]*g24[iz+0];
s[1190] = + g6[ix+0]*g96[iy+0]*g25[iz+0];
s[1191] = + g5[ix+0]*g98[iy+0]*g24[iz+0];
s[1192] = + g4[ix+0]*g99[iy+0]*g24[iz+0];
s[1193] = + g4[ix+0]*g98[iy+0]*g25[iz+0];
s[1194] = + g5[ix+0]*g96[iy+0]*g26[iz+0];
s[1195] = + g4[ix+0]*g97[iy+0]*g26[iz+0];
s[1196] = + g4[ix+0]*g96[iy+0]*g27[iz+0];
s[1197] = + g3[ix+0]*g100[iy+0]*g24[iz+0];
s[1198] = + g2[ix+0]*g101[iy+0]*g24[iz+0];
s[1199] = + g2[ix+0]*g100[iy+0]*g25[iz+0];
s[1200] = + g1[ix+0]*g102[iy+0]*g24[iz+0];
s[1201] = + g0[ix+0]*g103[iy+0]*g24[iz+0];
s[1202] = + g0[ix+0]*g102[iy+0]*g25[iz+0];
s[1203] = + g1[ix+0]*g100[iy+0]*g26[iz+0];
s[1204] = + g0[ix+0]*g101[iy+0]*g26[iz+0];
s[1205] = + g0[ix+0]*g100[iy+0]*g27[iz+0];
s[1206] = + g3[ix+0]*g96[iy+0]*g28[iz+0];
s[1207] = + g2[ix+0]*g97[iy+0]*g28[iz+0];
s[1208] = + g2[ix+0]*g96[iy+0]*g29[iz+0];
s[1209] = + g1[ix+0]*g98[iy+0]*g28[iz+0];
s[1210] = + g0[ix+0]*g99[iy+0]*g28[iz+0];
s[1211] = + g0[ix+0]*g98[iy+0]*g29[iz+0];
s[1212] = + g1[ix+0]*g96[iy+0]*g30[iz+0];
s[1213] = + g0[ix+0]*g97[iy+0]*g30[iz+0];
s[1214] = + g0[ix+0]*g96[iy+0]*g31[iz+0];
s[1215] = + g31[ix+0]*g64[iy+0]*g32[iz+0];
s[1216] = + g30[ix+0]*g65[iy+0]*g32[iz+0];
s[1217] = + g30[ix+0]*g64[iy+0]*g33[iz+0];
s[1218] = + g29[ix+0]*g66[iy+0]*g32[iz+0];
s[1219] = + g28[ix+0]*g67[iy+0]*g32[iz+0];
s[1220] = + g28[ix+0]*g66[iy+0]*g33[iz+0];
s[1221] = + g29[ix+0]*g64[iy+0]*g34[iz+0];
s[1222] = + g28[ix+0]*g65[iy+0]*g34[iz+0];
s[1223] = + g28[ix+0]*g64[iy+0]*g35[iz+0];
s[1224] = + g27[ix+0]*g68[iy+0]*g32[iz+0];
s[1225] = + g26[ix+0]*g69[iy+0]*g32[iz+0];
s[1226] = + g26[ix+0]*g68[iy+0]*g33[iz+0];
s[1227] = + g25[ix+0]*g70[iy+0]*g32[iz+0];
s[1228] = + g24[ix+0]*g71[iy+0]*g32[iz+0];
s[1229] = + g24[ix+0]*g70[iy+0]*g33[iz+0];
s[1230] = + g25[ix+0]*g68[iy+0]*g34[iz+0];
s[1231] = + g24[ix+0]*g69[iy+0]*g34[iz+0];
s[1232] = + g24[ix+0]*g68[iy+0]*g35[iz+0];
s[1233] = + g27[ix+0]*g64[iy+0]*g36[iz+0];
s[1234] = + g26[ix+0]*g65[iy+0]*g36[iz+0];
s[1235] = + g26[ix+0]*g64[iy+0]*g37[iz+0];
s[1236] = + g25[ix+0]*g66[iy+0]*g36[iz+0];
s[1237] = + g24[ix+0]*g67[iy+0]*g36[iz+0];
s[1238] = + g24[ix+0]*g66[iy+0]*g37[iz+0];
s[1239] = + g25[ix+0]*g64[iy+0]*g38[iz+0];
s[1240] = + g24[ix+0]*g65[iy+0]*g38[iz+0];
s[1241] = + g24[ix+0]*g64[iy+0]*g39[iz+0];
s[1242] = + g23[ix+0]*g72[iy+0]*g32[iz+0];
s[1243] = + g22[ix+0]*g73[iy+0]*g32[iz+0];
s[1244] = + g22[ix+0]*g72[iy+0]*g33[iz+0];
s[1245] = + g21[ix+0]*g74[iy+0]*g32[iz+0];
s[1246] = + g20[ix+0]*g75[iy+0]*g32[iz+0];
s[1247] = + g20[ix+0]*g74[iy+0]*g33[iz+0];
s[1248] = + g21[ix+0]*g72[iy+0]*g34[iz+0];
s[1249] = + g20[ix+0]*g73[iy+0]*g34[iz+0];
s[1250] = + g20[ix+0]*g72[iy+0]*g35[iz+0];
s[1251] = + g19[ix+0]*g76[iy+0]*g32[iz+0];
s[1252] = + g18[ix+0]*g77[iy+0]*g32[iz+0];
s[1253] = + g18[ix+0]*g76[iy+0]*g33[iz+0];
s[1254] = + g17[ix+0]*g78[iy+0]*g32[iz+0];
s[1255] = + g16[ix+0]*g79[iy+0]*g32[iz+0];
s[1256] = + g16[ix+0]*g78[iy+0]*g33[iz+0];
s[1257] = + g17[ix+0]*g76[iy+0]*g34[iz+0];
s[1258] = + g16[ix+0]*g77[iy+0]*g34[iz+0];
s[1259] = + g16[ix+0]*g76[iy+0]*g35[iz+0];
s[1260] = + g19[ix+0]*g72[iy+0]*g36[iz+0];
s[1261] = + g18[ix+0]*g73[iy+0]*g36[iz+0];
s[1262] = + g18[ix+0]*g72[iy+0]*g37[iz+0];
s[1263] = + g17[ix+0]*g74[iy+0]*g36[iz+0];
s[1264] = + g16[ix+0]*g75[iy+0]*g36[iz+0];
s[1265] = + g16[ix+0]*g74[iy+0]*g37[iz+0];
s[1266] = + g17[ix+0]*g72[iy+0]*g38[iz+0];
s[1267] = + g16[ix+0]*g73[iy+0]*g38[iz+0];
s[1268] = + g16[ix+0]*g72[iy+0]*g39[iz+0];
s[1269] = + g23[ix+0]*g64[iy+0]*g40[iz+0];
s[1270] = + g22[ix+0]*g65[iy+0]*g40[iz+0];
s[1271] = + g22[ix+0]*g64[iy+0]*g41[iz+0];
s[1272] = + g21[ix+0]*g66[iy+0]*g40[iz+0];
s[1273] = + g20[ix+0]*g67[iy+0]*g40[iz+0];
s[1274] = + g20[ix+0]*g66[iy+0]*g41[iz+0];
s[1275] = + g21[ix+0]*g64[iy+0]*g42[iz+0];
s[1276] = + g20[ix+0]*g65[iy+0]*g42[iz+0];
s[1277] = + g20[ix+0]*g64[iy+0]*g43[iz+0];
s[1278] = + g19[ix+0]*g68[iy+0]*g40[iz+0];
s[1279] = + g18[ix+0]*g69[iy+0]*g40[iz+0];
s[1280] = + g18[ix+0]*g68[iy+0]*g41[iz+0];
s[1281] = + g17[ix+0]*g70[iy+0]*g40[iz+0];
s[1282] = + g16[ix+0]*g71[iy+0]*g40[iz+0];
s[1283] = + g16[ix+0]*g70[iy+0]*g41[iz+0];
s[1284] = + g17[ix+0]*g68[iy+0]*g42[iz+0];
s[1285] = + g16[ix+0]*g69[iy+0]*g42[iz+0];
s[1286] = + g16[ix+0]*g68[iy+0]*g43[iz+0];
s[1287] = + g19[ix+0]*g64[iy+0]*g44[iz+0];
s[1288] = + g18[ix+0]*g65[iy+0]*g44[iz+0];
s[1289] = + g18[ix+0]*g64[iy+0]*g45[iz+0];
s[1290] = + g17[ix+0]*g66[iy+0]*g44[iz+0];
s[1291] = + g16[ix+0]*g67[iy+0]*g44[iz+0];
s[1292] = + g16[ix+0]*g66[iy+0]*g45[iz+0];
s[1293] = + g17[ix+0]*g64[iy+0]*g46[iz+0];
s[1294] = + g16[ix+0]*g65[iy+0]*g46[iz+0];
s[1295] = + g16[ix+0]*g64[iy+0]*g47[iz+0];
s[1296] = + g15[ix+0]*g80[iy+0]*g32[iz+0];
s[1297] = + g14[ix+0]*g81[iy+0]*g32[iz+0];
s[1298] = + g14[ix+0]*g80[iy+0]*g33[iz+0];
s[1299] = + g13[ix+0]*g82[iy+0]*g32[iz+0];
s[1300] = + g12[ix+0]*g83[iy+0]*g32[iz+0];
s[1301] = + g12[ix+0]*g82[iy+0]*g33[iz+0];
s[1302] = + g13[ix+0]*g80[iy+0]*g34[iz+0];
s[1303] = + g12[ix+0]*g81[iy+0]*g34[iz+0];
s[1304] = + g12[ix+0]*g80[iy+0]*g35[iz+0];
s[1305] = + g11[ix+0]*g84[iy+0]*g32[iz+0];
s[1306] = + g10[ix+0]*g85[iy+0]*g32[iz+0];
s[1307] = + g10[ix+0]*g84[iy+0]*g33[iz+0];
s[1308] = + g9[ix+0]*g86[iy+0]*g32[iz+0];
s[1309] = + g8[ix+0]*g87[iy+0]*g32[iz+0];
s[1310] = + g8[ix+0]*g86[iy+0]*g33[iz+0];
s[1311] = + g9[ix+0]*g84[iy+0]*g34[iz+0];
s[1312] = + g8[ix+0]*g85[iy+0]*g34[iz+0];
s[1313] = + g8[ix+0]*g84[iy+0]*g35[iz+0];
s[1314] = + g11[ix+0]*g80[iy+0]*g36[iz+0];
s[1315] = + g10[ix+0]*g81[iy+0]*g36[iz+0];
s[1316] = + g10[ix+0]*g80[iy+0]*g37[iz+0];
s[1317] = + g9[ix+0]*g82[iy+0]*g36[iz+0];
s[1318] = + g8[ix+0]*g83[iy+0]*g36[iz+0];
s[1319] = + g8[ix+0]*g82[iy+0]*g37[iz+0];
s[1320] = + g9[ix+0]*g80[iy+0]*g38[iz+0];
s[1321] = + g8[ix+0]*g81[iy+0]*g38[iz+0];
s[1322] = + g8[ix+0]*g80[iy+0]*g39[iz+0];
s[1323] = + g7[ix+0]*g88[iy+0]*g32[iz+0];
s[1324] = + g6[ix+0]*g89[iy+0]*g32[iz+0];
s[1325] = + g6[ix+0]*g88[iy+0]*g33[iz+0];
s[1326] = + g5[ix+0]*g90[iy+0]*g32[iz+0];
s[1327] = + g4[ix+0]*g91[iy+0]*g32[iz+0];
s[1328] = + g4[ix+0]*g90[iy+0]*g33[iz+0];
s[1329] = + g5[ix+0]*g88[iy+0]*g34[iz+0];
s[1330] = + g4[ix+0]*g89[iy+0]*g34[iz+0];
s[1331] = + g4[ix+0]*g88[iy+0]*g35[iz+0];
s[1332] = + g3[ix+0]*g92[iy+0]*g32[iz+0];
s[1333] = + g2[ix+0]*g93[iy+0]*g32[iz+0];
s[1334] = + g2[ix+0]*g92[iy+0]*g33[iz+0];
s[1335] = + g1[ix+0]*g94[iy+0]*g32[iz+0];
s[1336] = + g0[ix+0]*g95[iy+0]*g32[iz+0];
s[1337] = + g0[ix+0]*g94[iy+0]*g33[iz+0];
s[1338] = + g1[ix+0]*g92[iy+0]*g34[iz+0];
s[1339] = + g0[ix+0]*g93[iy+0]*g34[iz+0];
s[1340] = + g0[ix+0]*g92[iy+0]*g35[iz+0];
s[1341] = + g3[ix+0]*g88[iy+0]*g36[iz+0];
s[1342] = + g2[ix+0]*g89[iy+0]*g36[iz+0];
s[1343] = + g2[ix+0]*g88[iy+0]*g37[iz+0];
s[1344] = + g1[ix+0]*g90[iy+0]*g36[iz+0];
s[1345] = + g0[ix+0]*g91[iy+0]*g36[iz+0];
s[1346] = + g0[ix+0]*g90[iy+0]*g37[iz+0];
s[1347] = + g1[ix+0]*g88[iy+0]*g38[iz+0];
s[1348] = + g0[ix+0]*g89[iy+0]*g38[iz+0];
s[1349] = + g0[ix+0]*g88[iy+0]*g39[iz+0];
s[1350] = + g7[ix+0]*g80[iy+0]*g40[iz+0];
s[1351] = + g6[ix+0]*g81[iy+0]*g40[iz+0];
s[1352] = + g6[ix+0]*g80[iy+0]*g41[iz+0];
s[1353] = + g5[ix+0]*g82[iy+0]*g40[iz+0];
s[1354] = + g4[ix+0]*g83[iy+0]*g40[iz+0];
s[1355] = + g4[ix+0]*g82[iy+0]*g41[iz+0];
s[1356] = + g5[ix+0]*g80[iy+0]*g42[iz+0];
s[1357] = + g4[ix+0]*g81[iy+0]*g42[iz+0];
s[1358] = + g4[ix+0]*g80[iy+0]*g43[iz+0];
s[1359] = + g3[ix+0]*g84[iy+0]*g40[iz+0];
s[1360] = + g2[ix+0]*g85[iy+0]*g40[iz+0];
s[1361] = + g2[ix+0]*g84[iy+0]*g41[iz+0];
s[1362] = + g1[ix+0]*g86[iy+0]*g40[iz+0];
s[1363] = + g0[ix+0]*g87[iy+0]*g40[iz+0];
s[1364] = + g0[ix+0]*g86[iy+0]*g41[iz+0];
s[1365] = + g1[ix+0]*g84[iy+0]*g42[iz+0];
s[1366] = + g0[ix+0]*g85[iy+0]*g42[iz+0];
s[1367] = + g0[ix+0]*g84[iy+0]*g43[iz+0];
s[1368] = + g3[ix+0]*g80[iy+0]*g44[iz+0];
s[1369] = + g2[ix+0]*g81[iy+0]*g44[iz+0];
s[1370] = + g2[ix+0]*g80[iy+0]*g45[iz+0];
s[1371] = + g1[ix+0]*g82[iy+0]*g44[iz+0];
s[1372] = + g0[ix+0]*g83[iy+0]*g44[iz+0];
s[1373] = + g0[ix+0]*g82[iy+0]*g45[iz+0];
s[1374] = + g1[ix+0]*g80[iy+0]*g46[iz+0];
s[1375] = + g0[ix+0]*g81[iy+0]*g46[iz+0];
s[1376] = + g0[ix+0]*g80[iy+0]*g47[iz+0];
s[1377] = + g15[ix+0]*g64[iy+0]*g48[iz+0];
s[1378] = + g14[ix+0]*g65[iy+0]*g48[iz+0];
s[1379] = + g14[ix+0]*g64[iy+0]*g49[iz+0];
s[1380] = + g13[ix+0]*g66[iy+0]*g48[iz+0];
s[1381] = + g12[ix+0]*g67[iy+0]*g48[iz+0];
s[1382] = + g12[ix+0]*g66[iy+0]*g49[iz+0];
s[1383] = + g13[ix+0]*g64[iy+0]*g50[iz+0];
s[1384] = + g12[ix+0]*g65[iy+0]*g50[iz+0];
s[1385] = + g12[ix+0]*g64[iy+0]*g51[iz+0];
s[1386] = + g11[ix+0]*g68[iy+0]*g48[iz+0];
s[1387] = + g10[ix+0]*g69[iy+0]*g48[iz+0];
s[1388] = + g10[ix+0]*g68[iy+0]*g49[iz+0];
s[1389] = + g9[ix+0]*g70[iy+0]*g48[iz+0];
s[1390] = + g8[ix+0]*g71[iy+0]*g48[iz+0];
s[1391] = + g8[ix+0]*g70[iy+0]*g49[iz+0];
s[1392] = + g9[ix+0]*g68[iy+0]*g50[iz+0];
s[1393] = + g8[ix+0]*g69[iy+0]*g50[iz+0];
s[1394] = + g8[ix+0]*g68[iy+0]*g51[iz+0];
s[1395] = + g11[ix+0]*g64[iy+0]*g52[iz+0];
s[1396] = + g10[ix+0]*g65[iy+0]*g52[iz+0];
s[1397] = + g10[ix+0]*g64[iy+0]*g53[iz+0];
s[1398] = + g9[ix+0]*g66[iy+0]*g52[iz+0];
s[1399] = + g8[ix+0]*g67[iy+0]*g52[iz+0];
s[1400] = + g8[ix+0]*g66[iy+0]*g53[iz+0];
s[1401] = + g9[ix+0]*g64[iy+0]*g54[iz+0];
s[1402] = + g8[ix+0]*g65[iy+0]*g54[iz+0];
s[1403] = + g8[ix+0]*g64[iy+0]*g55[iz+0];
s[1404] = + g7[ix+0]*g72[iy+0]*g48[iz+0];
s[1405] = + g6[ix+0]*g73[iy+0]*g48[iz+0];
s[1406] = + g6[ix+0]*g72[iy+0]*g49[iz+0];
s[1407] = + g5[ix+0]*g74[iy+0]*g48[iz+0];
s[1408] = + g4[ix+0]*g75[iy+0]*g48[iz+0];
s[1409] = + g4[ix+0]*g74[iy+0]*g49[iz+0];
s[1410] = + g5[ix+0]*g72[iy+0]*g50[iz+0];
s[1411] = + g4[ix+0]*g73[iy+0]*g50[iz+0];
s[1412] = + g4[ix+0]*g72[iy+0]*g51[iz+0];
s[1413] = + g3[ix+0]*g76[iy+0]*g48[iz+0];
s[1414] = + g2[ix+0]*g77[iy+0]*g48[iz+0];
s[1415] = + g2[ix+0]*g76[iy+0]*g49[iz+0];
s[1416] = + g1[ix+0]*g78[iy+0]*g48[iz+0];
s[1417] = + g0[ix+0]*g79[iy+0]*g48[iz+0];
s[1418] = + g0[ix+0]*g78[iy+0]*g49[iz+0];
s[1419] = + g1[ix+0]*g76[iy+0]*g50[iz+0];
s[1420] = + g0[ix+0]*g77[iy+0]*g50[iz+0];
s[1421] = + g0[ix+0]*g76[iy+0]*g51[iz+0];
s[1422] = + g3[ix+0]*g72[iy+0]*g52[iz+0];
s[1423] = + g2[ix+0]*g73[iy+0]*g52[iz+0];
s[1424] = + g2[ix+0]*g72[iy+0]*g53[iz+0];
s[1425] = + g1[ix+0]*g74[iy+0]*g52[iz+0];
s[1426] = + g0[ix+0]*g75[iy+0]*g52[iz+0];
s[1427] = + g0[ix+0]*g74[iy+0]*g53[iz+0];
s[1428] = + g1[ix+0]*g72[iy+0]*g54[iz+0];
s[1429] = + g0[ix+0]*g73[iy+0]*g54[iz+0];
s[1430] = + g0[ix+0]*g72[iy+0]*g55[iz+0];
s[1431] = + g7[ix+0]*g64[iy+0]*g56[iz+0];
s[1432] = + g6[ix+0]*g65[iy+0]*g56[iz+0];
s[1433] = + g6[ix+0]*g64[iy+0]*g57[iz+0];
s[1434] = + g5[ix+0]*g66[iy+0]*g56[iz+0];
s[1435] = + g4[ix+0]*g67[iy+0]*g56[iz+0];
s[1436] = + g4[ix+0]*g66[iy+0]*g57[iz+0];
s[1437] = + g5[ix+0]*g64[iy+0]*g58[iz+0];
s[1438] = + g4[ix+0]*g65[iy+0]*g58[iz+0];
s[1439] = + g4[ix+0]*g64[iy+0]*g59[iz+0];
s[1440] = + g3[ix+0]*g68[iy+0]*g56[iz+0];
s[1441] = + g2[ix+0]*g69[iy+0]*g56[iz+0];
s[1442] = + g2[ix+0]*g68[iy+0]*g57[iz+0];
s[1443] = + g1[ix+0]*g70[iy+0]*g56[iz+0];
s[1444] = + g0[ix+0]*g71[iy+0]*g56[iz+0];
s[1445] = + g0[ix+0]*g70[iy+0]*g57[iz+0];
s[1446] = + g1[ix+0]*g68[iy+0]*g58[iz+0];
s[1447] = + g0[ix+0]*g69[iy+0]*g58[iz+0];
s[1448] = + g0[ix+0]*g68[iy+0]*g59[iz+0];
s[1449] = + g3[ix+0]*g64[iy+0]*g60[iz+0];
s[1450] = + g2[ix+0]*g65[iy+0]*g60[iz+0];
s[1451] = + g2[ix+0]*g64[iy+0]*g61[iz+0];
s[1452] = + g1[ix+0]*g66[iy+0]*g60[iz+0];
s[1453] = + g0[ix+0]*g67[iy+0]*g60[iz+0];
s[1454] = + g0[ix+0]*g66[iy+0]*g61[iz+0];
s[1455] = + g1[ix+0]*g64[iy+0]*g62[iz+0];
s[1456] = + g0[ix+0]*g65[iy+0]*g62[iz+0];
s[1457] = + g0[ix+0]*g64[iy+0]*g63[iz+0];
s[1458] = + g63[ix+0]*g0[iy+0]*g64[iz+0];
s[1459] = + g62[ix+0]*g1[iy+0]*g64[iz+0];
s[1460] = + g62[ix+0]*g0[iy+0]*g65[iz+0];
s[1461] = + g61[ix+0]*g2[iy+0]*g64[iz+0];
s[1462] = + g60[ix+0]*g3[iy+0]*g64[iz+0];
s[1463] = + g60[ix+0]*g2[iy+0]*g65[iz+0];
s[1464] = + g61[ix+0]*g0[iy+0]*g66[iz+0];
s[1465] = + g60[ix+0]*g1[iy+0]*g66[iz+0];
s[1466] = + g60[ix+0]*g0[iy+0]*g67[iz+0];
s[1467] = + g59[ix+0]*g4[iy+0]*g64[iz+0];
s[1468] = + g58[ix+0]*g5[iy+0]*g64[iz+0];
s[1469] = + g58[ix+0]*g4[iy+0]*g65[iz+0];
s[1470] = + g57[ix+0]*g6[iy+0]*g64[iz+0];
s[1471] = + g56[ix+0]*g7[iy+0]*g64[iz+0];
s[1472] = + g56[ix+0]*g6[iy+0]*g65[iz+0];
s[1473] = + g57[ix+0]*g4[iy+0]*g66[iz+0];
s[1474] = + g56[ix+0]*g5[iy+0]*g66[iz+0];
s[1475] = + g56[ix+0]*g4[iy+0]*g67[iz+0];
s[1476] = + g59[ix+0]*g0[iy+0]*g68[iz+0];
s[1477] = + g58[ix+0]*g1[iy+0]*g68[iz+0];
s[1478] = + g58[ix+0]*g0[iy+0]*g69[iz+0];
s[1479] = + g57[ix+0]*g2[iy+0]*g68[iz+0];
s[1480] = + g56[ix+0]*g3[iy+0]*g68[iz+0];
s[1481] = + g56[ix+0]*g2[iy+0]*g69[iz+0];
s[1482] = + g57[ix+0]*g0[iy+0]*g70[iz+0];
s[1483] = + g56[ix+0]*g1[iy+0]*g70[iz+0];
s[1484] = + g56[ix+0]*g0[iy+0]*g71[iz+0];
s[1485] = + g55[ix+0]*g8[iy+0]*g64[iz+0];
s[1486] = + g54[ix+0]*g9[iy+0]*g64[iz+0];
s[1487] = + g54[ix+0]*g8[iy+0]*g65[iz+0];
s[1488] = + g53[ix+0]*g10[iy+0]*g64[iz+0];
s[1489] = + g52[ix+0]*g11[iy+0]*g64[iz+0];
s[1490] = + g52[ix+0]*g10[iy+0]*g65[iz+0];
s[1491] = + g53[ix+0]*g8[iy+0]*g66[iz+0];
s[1492] = + g52[ix+0]*g9[iy+0]*g66[iz+0];
s[1493] = + g52[ix+0]*g8[iy+0]*g67[iz+0];
s[1494] = + g51[ix+0]*g12[iy+0]*g64[iz+0];
s[1495] = + g50[ix+0]*g13[iy+0]*g64[iz+0];
s[1496] = + g50[ix+0]*g12[iy+0]*g65[iz+0];
s[1497] = + g49[ix+0]*g14[iy+0]*g64[iz+0];
s[1498] = + g48[ix+0]*g15[iy+0]*g64[iz+0];
s[1499] = + g48[ix+0]*g14[iy+0]*g65[iz+0];
s[1500] = + g49[ix+0]*g12[iy+0]*g66[iz+0];
s[1501] = + g48[ix+0]*g13[iy+0]*g66[iz+0];
s[1502] = + g48[ix+0]*g12[iy+0]*g67[iz+0];
s[1503] = + g51[ix+0]*g8[iy+0]*g68[iz+0];
s[1504] = + g50[ix+0]*g9[iy+0]*g68[iz+0];
s[1505] = + g50[ix+0]*g8[iy+0]*g69[iz+0];
s[1506] = + g49[ix+0]*g10[iy+0]*g68[iz+0];
s[1507] = + g48[ix+0]*g11[iy+0]*g68[iz+0];
s[1508] = + g48[ix+0]*g10[iy+0]*g69[iz+0];
s[1509] = + g49[ix+0]*g8[iy+0]*g70[iz+0];
s[1510] = + g48[ix+0]*g9[iy+0]*g70[iz+0];
s[1511] = + g48[ix+0]*g8[iy+0]*g71[iz+0];
s[1512] = + g55[ix+0]*g0[iy+0]*g72[iz+0];
s[1513] = + g54[ix+0]*g1[iy+0]*g72[iz+0];
s[1514] = + g54[ix+0]*g0[iy+0]*g73[iz+0];
s[1515] = + g53[ix+0]*g2[iy+0]*g72[iz+0];
s[1516] = + g52[ix+0]*g3[iy+0]*g72[iz+0];
s[1517] = + g52[ix+0]*g2[iy+0]*g73[iz+0];
s[1518] = + g53[ix+0]*g0[iy+0]*g74[iz+0];
s[1519] = + g52[ix+0]*g1[iy+0]*g74[iz+0];
s[1520] = + g52[ix+0]*g0[iy+0]*g75[iz+0];
s[1521] = + g51[ix+0]*g4[iy+0]*g72[iz+0];
s[1522] = + g50[ix+0]*g5[iy+0]*g72[iz+0];
s[1523] = + g50[ix+0]*g4[iy+0]*g73[iz+0];
s[1524] = + g49[ix+0]*g6[iy+0]*g72[iz+0];
s[1525] = + g48[ix+0]*g7[iy+0]*g72[iz+0];
s[1526] = + g48[ix+0]*g6[iy+0]*g73[iz+0];
s[1527] = + g49[ix+0]*g4[iy+0]*g74[iz+0];
s[1528] = + g48[ix+0]*g5[iy+0]*g74[iz+0];
s[1529] = + g48[ix+0]*g4[iy+0]*g75[iz+0];
s[1530] = + g51[ix+0]*g0[iy+0]*g76[iz+0];
s[1531] = + g50[ix+0]*g1[iy+0]*g76[iz+0];
s[1532] = + g50[ix+0]*g0[iy+0]*g77[iz+0];
s[1533] = + g49[ix+0]*g2[iy+0]*g76[iz+0];
s[1534] = + g48[ix+0]*g3[iy+0]*g76[iz+0];
s[1535] = + g48[ix+0]*g2[iy+0]*g77[iz+0];
s[1536] = + g49[ix+0]*g0[iy+0]*g78[iz+0];
s[1537] = + g48[ix+0]*g1[iy+0]*g78[iz+0];
s[1538] = + g48[ix+0]*g0[iy+0]*g79[iz+0];
s[1539] = + g47[ix+0]*g16[iy+0]*g64[iz+0];
s[1540] = + g46[ix+0]*g17[iy+0]*g64[iz+0];
s[1541] = + g46[ix+0]*g16[iy+0]*g65[iz+0];
s[1542] = + g45[ix+0]*g18[iy+0]*g64[iz+0];
s[1543] = + g44[ix+0]*g19[iy+0]*g64[iz+0];
s[1544] = + g44[ix+0]*g18[iy+0]*g65[iz+0];
s[1545] = + g45[ix+0]*g16[iy+0]*g66[iz+0];
s[1546] = + g44[ix+0]*g17[iy+0]*g66[iz+0];
s[1547] = + g44[ix+0]*g16[iy+0]*g67[iz+0];
s[1548] = + g43[ix+0]*g20[iy+0]*g64[iz+0];
s[1549] = + g42[ix+0]*g21[iy+0]*g64[iz+0];
s[1550] = + g42[ix+0]*g20[iy+0]*g65[iz+0];
s[1551] = + g41[ix+0]*g22[iy+0]*g64[iz+0];
s[1552] = + g40[ix+0]*g23[iy+0]*g64[iz+0];
s[1553] = + g40[ix+0]*g22[iy+0]*g65[iz+0];
s[1554] = + g41[ix+0]*g20[iy+0]*g66[iz+0];
s[1555] = + g40[ix+0]*g21[iy+0]*g66[iz+0];
s[1556] = + g40[ix+0]*g20[iy+0]*g67[iz+0];
s[1557] = + g43[ix+0]*g16[iy+0]*g68[iz+0];
s[1558] = + g42[ix+0]*g17[iy+0]*g68[iz+0];
s[1559] = + g42[ix+0]*g16[iy+0]*g69[iz+0];
s[1560] = + g41[ix+0]*g18[iy+0]*g68[iz+0];
s[1561] = + g40[ix+0]*g19[iy+0]*g68[iz+0];
s[1562] = + g40[ix+0]*g18[iy+0]*g69[iz+0];
s[1563] = + g41[ix+0]*g16[iy+0]*g70[iz+0];
s[1564] = + g40[ix+0]*g17[iy+0]*g70[iz+0];
s[1565] = + g40[ix+0]*g16[iy+0]*g71[iz+0];
s[1566] = + g39[ix+0]*g24[iy+0]*g64[iz+0];
s[1567] = + g38[ix+0]*g25[iy+0]*g64[iz+0];
s[1568] = + g38[ix+0]*g24[iy+0]*g65[iz+0];
s[1569] = + g37[ix+0]*g26[iy+0]*g64[iz+0];
s[1570] = + g36[ix+0]*g27[iy+0]*g64[iz+0];
s[1571] = + g36[ix+0]*g26[iy+0]*g65[iz+0];
s[1572] = + g37[ix+0]*g24[iy+0]*g66[iz+0];
s[1573] = + g36[ix+0]*g25[iy+0]*g66[iz+0];
s[1574] = + g36[ix+0]*g24[iy+0]*g67[iz+0];
s[1575] = + g35[ix+0]*g28[iy+0]*g64[iz+0];
s[1576] = + g34[ix+0]*g29[iy+0]*g64[iz+0];
s[1577] = + g34[ix+0]*g28[iy+0]*g65[iz+0];
s[1578] = + g33[ix+0]*g30[iy+0]*g64[iz+0];
s[1579] = + g32[ix+0]*g31[iy+0]*g64[iz+0];
s[1580] = + g32[ix+0]*g30[iy+0]*g65[iz+0];
s[1581] = + g33[ix+0]*g28[iy+0]*g66[iz+0];
s[1582] = + g32[ix+0]*g29[iy+0]*g66[iz+0];
s[1583] = + g32[ix+0]*g28[iy+0]*g67[iz+0];
s[1584] = + g35[ix+0]*g24[iy+0]*g68[iz+0];
s[1585] = + g34[ix+0]*g25[iy+0]*g68[iz+0];
s[1586] = + g34[ix+0]*g24[iy+0]*g69[iz+0];
s[1587] = + g33[ix+0]*g26[iy+0]*g68[iz+0];
s[1588] = + g32[ix+0]*g27[iy+0]*g68[iz+0];
s[1589] = + g32[ix+0]*g26[iy+0]*g69[iz+0];
s[1590] = + g33[ix+0]*g24[iy+0]*g70[iz+0];
s[1591] = + g32[ix+0]*g25[iy+0]*g70[iz+0];
s[1592] = + g32[ix+0]*g24[iy+0]*g71[iz+0];
s[1593] = + g39[ix+0]*g16[iy+0]*g72[iz+0];
s[1594] = + g38[ix+0]*g17[iy+0]*g72[iz+0];
s[1595] = + g38[ix+0]*g16[iy+0]*g73[iz+0];
s[1596] = + g37[ix+0]*g18[iy+0]*g72[iz+0];
s[1597] = + g36[ix+0]*g19[iy+0]*g72[iz+0];
s[1598] = + g36[ix+0]*g18[iy+0]*g73[iz+0];
s[1599] = + g37[ix+0]*g16[iy+0]*g74[iz+0];
s[1600] = + g36[ix+0]*g17[iy+0]*g74[iz+0];
s[1601] = + g36[ix+0]*g16[iy+0]*g75[iz+0];
s[1602] = + g35[ix+0]*g20[iy+0]*g72[iz+0];
s[1603] = + g34[ix+0]*g21[iy+0]*g72[iz+0];
s[1604] = + g34[ix+0]*g20[iy+0]*g73[iz+0];
s[1605] = + g33[ix+0]*g22[iy+0]*g72[iz+0];
s[1606] = + g32[ix+0]*g23[iy+0]*g72[iz+0];
s[1607] = + g32[ix+0]*g22[iy+0]*g73[iz+0];
s[1608] = + g33[ix+0]*g20[iy+0]*g74[iz+0];
s[1609] = + g32[ix+0]*g21[iy+0]*g74[iz+0];
s[1610] = + g32[ix+0]*g20[iy+0]*g75[iz+0];
s[1611] = + g35[ix+0]*g16[iy+0]*g76[iz+0];
s[1612] = + g34[ix+0]*g17[iy+0]*g76[iz+0];
s[1613] = + g34[ix+0]*g16[iy+0]*g77[iz+0];
s[1614] = + g33[ix+0]*g18[iy+0]*g76[iz+0];
s[1615] = + g32[ix+0]*g19[iy+0]*g76[iz+0];
s[1616] = + g32[ix+0]*g18[iy+0]*g77[iz+0];
s[1617] = + g33[ix+0]*g16[iy+0]*g78[iz+0];
s[1618] = + g32[ix+0]*g17[iy+0]*g78[iz+0];
s[1619] = + g32[ix+0]*g16[iy+0]*g79[iz+0];
s[1620] = + g47[ix+0]*g0[iy+0]*g80[iz+0];
s[1621] = + g46[ix+0]*g1[iy+0]*g80[iz+0];
s[1622] = + g46[ix+0]*g0[iy+0]*g81[iz+0];
s[1623] = + g45[ix+0]*g2[iy+0]*g80[iz+0];
s[1624] = + g44[ix+0]*g3[iy+0]*g80[iz+0];
s[1625] = + g44[ix+0]*g2[iy+0]*g81[iz+0];
s[1626] = + g45[ix+0]*g0[iy+0]*g82[iz+0];
s[1627] = + g44[ix+0]*g1[iy+0]*g82[iz+0];
s[1628] = + g44[ix+0]*g0[iy+0]*g83[iz+0];
s[1629] = + g43[ix+0]*g4[iy+0]*g80[iz+0];
s[1630] = + g42[ix+0]*g5[iy+0]*g80[iz+0];
s[1631] = + g42[ix+0]*g4[iy+0]*g81[iz+0];
s[1632] = + g41[ix+0]*g6[iy+0]*g80[iz+0];
s[1633] = + g40[ix+0]*g7[iy+0]*g80[iz+0];
s[1634] = + g40[ix+0]*g6[iy+0]*g81[iz+0];
s[1635] = + g41[ix+0]*g4[iy+0]*g82[iz+0];
s[1636] = + g40[ix+0]*g5[iy+0]*g82[iz+0];
s[1637] = + g40[ix+0]*g4[iy+0]*g83[iz+0];
s[1638] = + g43[ix+0]*g0[iy+0]*g84[iz+0];
s[1639] = + g42[ix+0]*g1[iy+0]*g84[iz+0];
s[1640] = + g42[ix+0]*g0[iy+0]*g85[iz+0];
s[1641] = + g41[ix+0]*g2[iy+0]*g84[iz+0];
s[1642] = + g40[ix+0]*g3[iy+0]*g84[iz+0];
s[1643] = + g40[ix+0]*g2[iy+0]*g85[iz+0];
s[1644] = + g41[ix+0]*g0[iy+0]*g86[iz+0];
s[1645] = + g40[ix+0]*g1[iy+0]*g86[iz+0];
s[1646] = + g40[ix+0]*g0[iy+0]*g87[iz+0];
s[1647] = + g39[ix+0]*g8[iy+0]*g80[iz+0];
s[1648] = + g38[ix+0]*g9[iy+0]*g80[iz+0];
s[1649] = + g38[ix+0]*g8[iy+0]*g81[iz+0];
s[1650] = + g37[ix+0]*g10[iy+0]*g80[iz+0];
s[1651] = + g36[ix+0]*g11[iy+0]*g80[iz+0];
s[1652] = + g36[ix+0]*g10[iy+0]*g81[iz+0];
s[1653] = + g37[ix+0]*g8[iy+0]*g82[iz+0];
s[1654] = + g36[ix+0]*g9[iy+0]*g82[iz+0];
s[1655] = + g36[ix+0]*g8[iy+0]*g83[iz+0];
s[1656] = + g35[ix+0]*g12[iy+0]*g80[iz+0];
s[1657] = + g34[ix+0]*g13[iy+0]*g80[iz+0];
s[1658] = + g34[ix+0]*g12[iy+0]*g81[iz+0];
s[1659] = + g33[ix+0]*g14[iy+0]*g80[iz+0];
s[1660] = + g32[ix+0]*g15[iy+0]*g80[iz+0];
s[1661] = + g32[ix+0]*g14[iy+0]*g81[iz+0];
s[1662] = + g33[ix+0]*g12[iy+0]*g82[iz+0];
s[1663] = + g32[ix+0]*g13[iy+0]*g82[iz+0];
s[1664] = + g32[ix+0]*g12[iy+0]*g83[iz+0];
s[1665] = + g35[ix+0]*g8[iy+0]*g84[iz+0];
s[1666] = + g34[ix+0]*g9[iy+0]*g84[iz+0];
s[1667] = + g34[ix+0]*g8[iy+0]*g85[iz+0];
s[1668] = + g33[ix+0]*g10[iy+0]*g84[iz+0];
s[1669] = + g32[ix+0]*g11[iy+0]*g84[iz+0];
s[1670] = + g32[ix+0]*g10[iy+0]*g85[iz+0];
s[1671] = + g33[ix+0]*g8[iy+0]*g86[iz+0];
s[1672] = + g32[ix+0]*g9[iy+0]*g86[iz+0];
s[1673] = + g32[ix+0]*g8[iy+0]*g87[iz+0];
s[1674] = + g39[ix+0]*g0[iy+0]*g88[iz+0];
s[1675] = + g38[ix+0]*g1[iy+0]*g88[iz+0];
s[1676] = + g38[ix+0]*g0[iy+0]*g89[iz+0];
s[1677] = + g37[ix+0]*g2[iy+0]*g88[iz+0];
s[1678] = + g36[ix+0]*g3[iy+0]*g88[iz+0];
s[1679] = + g36[ix+0]*g2[iy+0]*g89[iz+0];
s[1680] = + g37[ix+0]*g0[iy+0]*g90[iz+0];
s[1681] = + g36[ix+0]*g1[iy+0]*g90[iz+0];
s[1682] = + g36[ix+0]*g0[iy+0]*g91[iz+0];
s[1683] = + g35[ix+0]*g4[iy+0]*g88[iz+0];
s[1684] = + g34[ix+0]*g5[iy+0]*g88[iz+0];
s[1685] = + g34[ix+0]*g4[iy+0]*g89[iz+0];
s[1686] = + g33[ix+0]*g6[iy+0]*g88[iz+0];
s[1687] = + g32[ix+0]*g7[iy+0]*g88[iz+0];
s[1688] = + g32[ix+0]*g6[iy+0]*g89[iz+0];
s[1689] = + g33[ix+0]*g4[iy+0]*g90[iz+0];
s[1690] = + g32[ix+0]*g5[iy+0]*g90[iz+0];
s[1691] = + g32[ix+0]*g4[iy+0]*g91[iz+0];
s[1692] = + g35[ix+0]*g0[iy+0]*g92[iz+0];
s[1693] = + g34[ix+0]*g1[iy+0]*g92[iz+0];
s[1694] = + g34[ix+0]*g0[iy+0]*g93[iz+0];
s[1695] = + g33[ix+0]*g2[iy+0]*g92[iz+0];
s[1696] = + g32[ix+0]*g3[iy+0]*g92[iz+0];
s[1697] = + g32[ix+0]*g2[iy+0]*g93[iz+0];
s[1698] = + g33[ix+0]*g0[iy+0]*g94[iz+0];
s[1699] = + g32[ix+0]*g1[iy+0]*g94[iz+0];
s[1700] = + g32[ix+0]*g0[iy+0]*g95[iz+0];
s[1701] = + g31[ix+0]*g32[iy+0]*g64[iz+0];
s[1702] = + g30[ix+0]*g33[iy+0]*g64[iz+0];
s[1703] = + g30[ix+0]*g32[iy+0]*g65[iz+0];
s[1704] = + g29[ix+0]*g34[iy+0]*g64[iz+0];
s[1705] = + g28[ix+0]*g35[iy+0]*g64[iz+0];
s[1706] = + g28[ix+0]*g34[iy+0]*g65[iz+0];
s[1707] = + g29[ix+0]*g32[iy+0]*g66[iz+0];
s[1708] = + g28[ix+0]*g33[iy+0]*g66[iz+0];
s[1709] = + g28[ix+0]*g32[iy+0]*g67[iz+0];
s[1710] = + g27[ix+0]*g36[iy+0]*g64[iz+0];
s[1711] = + g26[ix+0]*g37[iy+0]*g64[iz+0];
s[1712] = + g26[ix+0]*g36[iy+0]*g65[iz+0];
s[1713] = + g25[ix+0]*g38[iy+0]*g64[iz+0];
s[1714] = + g24[ix+0]*g39[iy+0]*g64[iz+0];
s[1715] = + g24[ix+0]*g38[iy+0]*g65[iz+0];
s[1716] = + g25[ix+0]*g36[iy+0]*g66[iz+0];
s[1717] = + g24[ix+0]*g37[iy+0]*g66[iz+0];
s[1718] = + g24[ix+0]*g36[iy+0]*g67[iz+0];
s[1719] = + g27[ix+0]*g32[iy+0]*g68[iz+0];
s[1720] = + g26[ix+0]*g33[iy+0]*g68[iz+0];
s[1721] = + g26[ix+0]*g32[iy+0]*g69[iz+0];
s[1722] = + g25[ix+0]*g34[iy+0]*g68[iz+0];
s[1723] = + g24[ix+0]*g35[iy+0]*g68[iz+0];
s[1724] = + g24[ix+0]*g34[iy+0]*g69[iz+0];
s[1725] = + g25[ix+0]*g32[iy+0]*g70[iz+0];
s[1726] = + g24[ix+0]*g33[iy+0]*g70[iz+0];
s[1727] = + g24[ix+0]*g32[iy+0]*g71[iz+0];
s[1728] = + g23[ix+0]*g40[iy+0]*g64[iz+0];
s[1729] = + g22[ix+0]*g41[iy+0]*g64[iz+0];
s[1730] = + g22[ix+0]*g40[iy+0]*g65[iz+0];
s[1731] = + g21[ix+0]*g42[iy+0]*g64[iz+0];
s[1732] = + g20[ix+0]*g43[iy+0]*g64[iz+0];
s[1733] = + g20[ix+0]*g42[iy+0]*g65[iz+0];
s[1734] = + g21[ix+0]*g40[iy+0]*g66[iz+0];
s[1735] = + g20[ix+0]*g41[iy+0]*g66[iz+0];
s[1736] = + g20[ix+0]*g40[iy+0]*g67[iz+0];
s[1737] = + g19[ix+0]*g44[iy+0]*g64[iz+0];
s[1738] = + g18[ix+0]*g45[iy+0]*g64[iz+0];
s[1739] = + g18[ix+0]*g44[iy+0]*g65[iz+0];
s[1740] = + g17[ix+0]*g46[iy+0]*g64[iz+0];
s[1741] = + g16[ix+0]*g47[iy+0]*g64[iz+0];
s[1742] = + g16[ix+0]*g46[iy+0]*g65[iz+0];
s[1743] = + g17[ix+0]*g44[iy+0]*g66[iz+0];
s[1744] = + g16[ix+0]*g45[iy+0]*g66[iz+0];
s[1745] = + g16[ix+0]*g44[iy+0]*g67[iz+0];
s[1746] = + g19[ix+0]*g40[iy+0]*g68[iz+0];
s[1747] = + g18[ix+0]*g41[iy+0]*g68[iz+0];
s[1748] = + g18[ix+0]*g40[iy+0]*g69[iz+0];
s[1749] = + g17[ix+0]*g42[iy+0]*g68[iz+0];
s[1750] = + g16[ix+0]*g43[iy+0]*g68[iz+0];
s[1751] = + g16[ix+0]*g42[iy+0]*g69[iz+0];
s[1752] = + g17[ix+0]*g40[iy+0]*g70[iz+0];
s[1753] = + g16[ix+0]*g41[iy+0]*g70[iz+0];
s[1754] = + g16[ix+0]*g40[iy+0]*g71[iz+0];
s[1755] = + g23[ix+0]*g32[iy+0]*g72[iz+0];
s[1756] = + g22[ix+0]*g33[iy+0]*g72[iz+0];
s[1757] = + g22[ix+0]*g32[iy+0]*g73[iz+0];
s[1758] = + g21[ix+0]*g34[iy+0]*g72[iz+0];
s[1759] = + g20[ix+0]*g35[iy+0]*g72[iz+0];
s[1760] = + g20[ix+0]*g34[iy+0]*g73[iz+0];
s[1761] = + g21[ix+0]*g32[iy+0]*g74[iz+0];
s[1762] = + g20[ix+0]*g33[iy+0]*g74[iz+0];
s[1763] = + g20[ix+0]*g32[iy+0]*g75[iz+0];
s[1764] = + g19[ix+0]*g36[iy+0]*g72[iz+0];
s[1765] = + g18[ix+0]*g37[iy+0]*g72[iz+0];
s[1766] = + g18[ix+0]*g36[iy+0]*g73[iz+0];
s[1767] = + g17[ix+0]*g38[iy+0]*g72[iz+0];
s[1768] = + g16[ix+0]*g39[iy+0]*g72[iz+0];
s[1769] = + g16[ix+0]*g38[iy+0]*g73[iz+0];
s[1770] = + g17[ix+0]*g36[iy+0]*g74[iz+0];
s[1771] = + g16[ix+0]*g37[iy+0]*g74[iz+0];
s[1772] = + g16[ix+0]*g36[iy+0]*g75[iz+0];
s[1773] = + g19[ix+0]*g32[iy+0]*g76[iz+0];
s[1774] = + g18[ix+0]*g33[iy+0]*g76[iz+0];
s[1775] = + g18[ix+0]*g32[iy+0]*g77[iz+0];
s[1776] = + g17[ix+0]*g34[iy+0]*g76[iz+0];
s[1777] = + g16[ix+0]*g35[iy+0]*g76[iz+0];
s[1778] = + g16[ix+0]*g34[iy+0]*g77[iz+0];
s[1779] = + g17[ix+0]*g32[iy+0]*g78[iz+0];
s[1780] = + g16[ix+0]*g33[iy+0]*g78[iz+0];
s[1781] = + g16[ix+0]*g32[iy+0]*g79[iz+0];
s[1782] = + g15[ix+0]*g48[iy+0]*g64[iz+0];
s[1783] = + g14[ix+0]*g49[iy+0]*g64[iz+0];
s[1784] = + g14[ix+0]*g48[iy+0]*g65[iz+0];
s[1785] = + g13[ix+0]*g50[iy+0]*g64[iz+0];
s[1786] = + g12[ix+0]*g51[iy+0]*g64[iz+0];
s[1787] = + g12[ix+0]*g50[iy+0]*g65[iz+0];
s[1788] = + g13[ix+0]*g48[iy+0]*g66[iz+0];
s[1789] = + g12[ix+0]*g49[iy+0]*g66[iz+0];
s[1790] = + g12[ix+0]*g48[iy+0]*g67[iz+0];
s[1791] = + g11[ix+0]*g52[iy+0]*g64[iz+0];
s[1792] = + g10[ix+0]*g53[iy+0]*g64[iz+0];
s[1793] = + g10[ix+0]*g52[iy+0]*g65[iz+0];
s[1794] = + g9[ix+0]*g54[iy+0]*g64[iz+0];
s[1795] = + g8[ix+0]*g55[iy+0]*g64[iz+0];
s[1796] = + g8[ix+0]*g54[iy+0]*g65[iz+0];
s[1797] = + g9[ix+0]*g52[iy+0]*g66[iz+0];
s[1798] = + g8[ix+0]*g53[iy+0]*g66[iz+0];
s[1799] = + g8[ix+0]*g52[iy+0]*g67[iz+0];
s[1800] = + g11[ix+0]*g48[iy+0]*g68[iz+0];
s[1801] = + g10[ix+0]*g49[iy+0]*g68[iz+0];
s[1802] = + g10[ix+0]*g48[iy+0]*g69[iz+0];
s[1803] = + g9[ix+0]*g50[iy+0]*g68[iz+0];
s[1804] = + g8[ix+0]*g51[iy+0]*g68[iz+0];
s[1805] = + g8[ix+0]*g50[iy+0]*g69[iz+0];
s[1806] = + g9[ix+0]*g48[iy+0]*g70[iz+0];
s[1807] = + g8[ix+0]*g49[iy+0]*g70[iz+0];
s[1808] = + g8[ix+0]*g48[iy+0]*g71[iz+0];
s[1809] = + g7[ix+0]*g56[iy+0]*g64[iz+0];
s[1810] = + g6[ix+0]*g57[iy+0]*g64[iz+0];
s[1811] = + g6[ix+0]*g56[iy+0]*g65[iz+0];
s[1812] = + g5[ix+0]*g58[iy+0]*g64[iz+0];
s[1813] = + g4[ix+0]*g59[iy+0]*g64[iz+0];
s[1814] = + g4[ix+0]*g58[iy+0]*g65[iz+0];
s[1815] = + g5[ix+0]*g56[iy+0]*g66[iz+0];
s[1816] = + g4[ix+0]*g57[iy+0]*g66[iz+0];
s[1817] = + g4[ix+0]*g56[iy+0]*g67[iz+0];
s[1818] = + g3[ix+0]*g60[iy+0]*g64[iz+0];
s[1819] = + g2[ix+0]*g61[iy+0]*g64[iz+0];
s[1820] = + g2[ix+0]*g60[iy+0]*g65[iz+0];
s[1821] = + g1[ix+0]*g62[iy+0]*g64[iz+0];
s[1822] = + g0[ix+0]*g63[iy+0]*g64[iz+0];
s[1823] = + g0[ix+0]*g62[iy+0]*g65[iz+0];
s[1824] = + g1[ix+0]*g60[iy+0]*g66[iz+0];
s[1825] = + g0[ix+0]*g61[iy+0]*g66[iz+0];
s[1826] = + g0[ix+0]*g60[iy+0]*g67[iz+0];
s[1827] = + g3[ix+0]*g56[iy+0]*g68[iz+0];
s[1828] = + g2[ix+0]*g57[iy+0]*g68[iz+0];
s[1829] = + g2[ix+0]*g56[iy+0]*g69[iz+0];
s[1830] = + g1[ix+0]*g58[iy+0]*g68[iz+0];
s[1831] = + g0[ix+0]*g59[iy+0]*g68[iz+0];
s[1832] = + g0[ix+0]*g58[iy+0]*g69[iz+0];
s[1833] = + g1[ix+0]*g56[iy+0]*g70[iz+0];
s[1834] = + g0[ix+0]*g57[iy+0]*g70[iz+0];
s[1835] = + g0[ix+0]*g56[iy+0]*g71[iz+0];
s[1836] = + g7[ix+0]*g48[iy+0]*g72[iz+0];
s[1837] = + g6[ix+0]*g49[iy+0]*g72[iz+0];
s[1838] = + g6[ix+0]*g48[iy+0]*g73[iz+0];
s[1839] = + g5[ix+0]*g50[iy+0]*g72[iz+0];
s[1840] = + g4[ix+0]*g51[iy+0]*g72[iz+0];
s[1841] = + g4[ix+0]*g50[iy+0]*g73[iz+0];
s[1842] = + g5[ix+0]*g48[iy+0]*g74[iz+0];
s[1843] = + g4[ix+0]*g49[iy+0]*g74[iz+0];
s[1844] = + g4[ix+0]*g48[iy+0]*g75[iz+0];
s[1845] = + g3[ix+0]*g52[iy+0]*g72[iz+0];
s[1846] = + g2[ix+0]*g53[iy+0]*g72[iz+0];
s[1847] = + g2[ix+0]*g52[iy+0]*g73[iz+0];
s[1848] = + g1[ix+0]*g54[iy+0]*g72[iz+0];
s[1849] = + g0[ix+0]*g55[iy+0]*g72[iz+0];
s[1850] = + g0[ix+0]*g54[iy+0]*g73[iz+0];
s[1851] = + g1[ix+0]*g52[iy+0]*g74[iz+0];
s[1852] = + g0[ix+0]*g53[iy+0]*g74[iz+0];
s[1853] = + g0[ix+0]*g52[iy+0]*g75[iz+0];
s[1854] = + g3[ix+0]*g48[iy+0]*g76[iz+0];
s[1855] = + g2[ix+0]*g49[iy+0]*g76[iz+0];
s[1856] = + g2[ix+0]*g48[iy+0]*g77[iz+0];
s[1857] = + g1[ix+0]*g50[iy+0]*g76[iz+0];
s[1858] = + g0[ix+0]*g51[iy+0]*g76[iz+0];
s[1859] = + g0[ix+0]*g50[iy+0]*g77[iz+0];
s[1860] = + g1[ix+0]*g48[iy+0]*g78[iz+0];
s[1861] = + g0[ix+0]*g49[iy+0]*g78[iz+0];
s[1862] = + g0[ix+0]*g48[iy+0]*g79[iz+0];
s[1863] = + g15[ix+0]*g32[iy+0]*g80[iz+0];
s[1864] = + g14[ix+0]*g33[iy+0]*g80[iz+0];
s[1865] = + g14[ix+0]*g32[iy+0]*g81[iz+0];
s[1866] = + g13[ix+0]*g34[iy+0]*g80[iz+0];
s[1867] = + g12[ix+0]*g35[iy+0]*g80[iz+0];
s[1868] = + g12[ix+0]*g34[iy+0]*g81[iz+0];
s[1869] = + g13[ix+0]*g32[iy+0]*g82[iz+0];
s[1870] = + g12[ix+0]*g33[iy+0]*g82[iz+0];
s[1871] = + g12[ix+0]*g32[iy+0]*g83[iz+0];
s[1872] = + g11[ix+0]*g36[iy+0]*g80[iz+0];
s[1873] = + g10[ix+0]*g37[iy+0]*g80[iz+0];
s[1874] = + g10[ix+0]*g36[iy+0]*g81[iz+0];
s[1875] = + g9[ix+0]*g38[iy+0]*g80[iz+0];
s[1876] = + g8[ix+0]*g39[iy+0]*g80[iz+0];
s[1877] = + g8[ix+0]*g38[iy+0]*g81[iz+0];
s[1878] = + g9[ix+0]*g36[iy+0]*g82[iz+0];
s[1879] = + g8[ix+0]*g37[iy+0]*g82[iz+0];
s[1880] = + g8[ix+0]*g36[iy+0]*g83[iz+0];
s[1881] = + g11[ix+0]*g32[iy+0]*g84[iz+0];
s[1882] = + g10[ix+0]*g33[iy+0]*g84[iz+0];
s[1883] = + g10[ix+0]*g32[iy+0]*g85[iz+0];
s[1884] = + g9[ix+0]*g34[iy+0]*g84[iz+0];
s[1885] = + g8[ix+0]*g35[iy+0]*g84[iz+0];
s[1886] = + g8[ix+0]*g34[iy+0]*g85[iz+0];
s[1887] = + g9[ix+0]*g32[iy+0]*g86[iz+0];
s[1888] = + g8[ix+0]*g33[iy+0]*g86[iz+0];
s[1889] = + g8[ix+0]*g32[iy+0]*g87[iz+0];
s[1890] = + g7[ix+0]*g40[iy+0]*g80[iz+0];
s[1891] = + g6[ix+0]*g41[iy+0]*g80[iz+0];
s[1892] = + g6[ix+0]*g40[iy+0]*g81[iz+0];
s[1893] = + g5[ix+0]*g42[iy+0]*g80[iz+0];
s[1894] = + g4[ix+0]*g43[iy+0]*g80[iz+0];
s[1895] = + g4[ix+0]*g42[iy+0]*g81[iz+0];
s[1896] = + g5[ix+0]*g40[iy+0]*g82[iz+0];
s[1897] = + g4[ix+0]*g41[iy+0]*g82[iz+0];
s[1898] = + g4[ix+0]*g40[iy+0]*g83[iz+0];
s[1899] = + g3[ix+0]*g44[iy+0]*g80[iz+0];
s[1900] = + g2[ix+0]*g45[iy+0]*g80[iz+0];
s[1901] = + g2[ix+0]*g44[iy+0]*g81[iz+0];
s[1902] = + g1[ix+0]*g46[iy+0]*g80[iz+0];
s[1903] = + g0[ix+0]*g47[iy+0]*g80[iz+0];
s[1904] = + g0[ix+0]*g46[iy+0]*g81[iz+0];
s[1905] = + g1[ix+0]*g44[iy+0]*g82[iz+0];
s[1906] = + g0[ix+0]*g45[iy+0]*g82[iz+0];
s[1907] = + g0[ix+0]*g44[iy+0]*g83[iz+0];
s[1908] = + g3[ix+0]*g40[iy+0]*g84[iz+0];
s[1909] = + g2[ix+0]*g41[iy+0]*g84[iz+0];
s[1910] = + g2[ix+0]*g40[iy+0]*g85[iz+0];
s[1911] = + g1[ix+0]*g42[iy+0]*g84[iz+0];
s[1912] = + g0[ix+0]*g43[iy+0]*g84[iz+0];
s[1913] = + g0[ix+0]*g42[iy+0]*g85[iz+0];
s[1914] = + g1[ix+0]*g40[iy+0]*g86[iz+0];
s[1915] = + g0[ix+0]*g41[iy+0]*g86[iz+0];
s[1916] = + g0[ix+0]*g40[iy+0]*g87[iz+0];
s[1917] = + g7[ix+0]*g32[iy+0]*g88[iz+0];
s[1918] = + g6[ix+0]*g33[iy+0]*g88[iz+0];
s[1919] = + g6[ix+0]*g32[iy+0]*g89[iz+0];
s[1920] = + g5[ix+0]*g34[iy+0]*g88[iz+0];
s[1921] = + g4[ix+0]*g35[iy+0]*g88[iz+0];
s[1922] = + g4[ix+0]*g34[iy+0]*g89[iz+0];
s[1923] = + g5[ix+0]*g32[iy+0]*g90[iz+0];
s[1924] = + g4[ix+0]*g33[iy+0]*g90[iz+0];
s[1925] = + g4[ix+0]*g32[iy+0]*g91[iz+0];
s[1926] = + g3[ix+0]*g36[iy+0]*g88[iz+0];
s[1927] = + g2[ix+0]*g37[iy+0]*g88[iz+0];
s[1928] = + g2[ix+0]*g36[iy+0]*g89[iz+0];
s[1929] = + g1[ix+0]*g38[iy+0]*g88[iz+0];
s[1930] = + g0[ix+0]*g39[iy+0]*g88[iz+0];
s[1931] = + g0[ix+0]*g38[iy+0]*g89[iz+0];
s[1932] = + g1[ix+0]*g36[iy+0]*g90[iz+0];
s[1933] = + g0[ix+0]*g37[iy+0]*g90[iz+0];
s[1934] = + g0[ix+0]*g36[iy+0]*g91[iz+0];
s[1935] = + g3[ix+0]*g32[iy+0]*g92[iz+0];
s[1936] = + g2[ix+0]*g33[iy+0]*g92[iz+0];
s[1937] = + g2[ix+0]*g32[iy+0]*g93[iz+0];
s[1938] = + g1[ix+0]*g34[iy+0]*g92[iz+0];
s[1939] = + g0[ix+0]*g35[iy+0]*g92[iz+0];
s[1940] = + g0[ix+0]*g34[iy+0]*g93[iz+0];
s[1941] = + g1[ix+0]*g32[iy+0]*g94[iz+0];
s[1942] = + g0[ix+0]*g33[iy+0]*g94[iz+0];
s[1943] = + g0[ix+0]*g32[iy+0]*g95[iz+0];
s[1944] = + g31[ix+0]*g0[iy+0]*g96[iz+0];
s[1945] = + g30[ix+0]*g1[iy+0]*g96[iz+0];
s[1946] = + g30[ix+0]*g0[iy+0]*g97[iz+0];
s[1947] = + g29[ix+0]*g2[iy+0]*g96[iz+0];
s[1948] = + g28[ix+0]*g3[iy+0]*g96[iz+0];
s[1949] = + g28[ix+0]*g2[iy+0]*g97[iz+0];
s[1950] = + g29[ix+0]*g0[iy+0]*g98[iz+0];
s[1951] = + g28[ix+0]*g1[iy+0]*g98[iz+0];
s[1952] = + g28[ix+0]*g0[iy+0]*g99[iz+0];
s[1953] = + g27[ix+0]*g4[iy+0]*g96[iz+0];
s[1954] = + g26[ix+0]*g5[iy+0]*g96[iz+0];
s[1955] = + g26[ix+0]*g4[iy+0]*g97[iz+0];
s[1956] = + g25[ix+0]*g6[iy+0]*g96[iz+0];
s[1957] = + g24[ix+0]*g7[iy+0]*g96[iz+0];
s[1958] = + g24[ix+0]*g6[iy+0]*g97[iz+0];
s[1959] = + g25[ix+0]*g4[iy+0]*g98[iz+0];
s[1960] = + g24[ix+0]*g5[iy+0]*g98[iz+0];
s[1961] = + g24[ix+0]*g4[iy+0]*g99[iz+0];
s[1962] = + g27[ix+0]*g0[iy+0]*g100[iz+0];
s[1963] = + g26[ix+0]*g1[iy+0]*g100[iz+0];
s[1964] = + g26[ix+0]*g0[iy+0]*g101[iz+0];
s[1965] = + g25[ix+0]*g2[iy+0]*g100[iz+0];
s[1966] = + g24[ix+0]*g3[iy+0]*g100[iz+0];
s[1967] = + g24[ix+0]*g2[iy+0]*g101[iz+0];
s[1968] = + g25[ix+0]*g0[iy+0]*g102[iz+0];
s[1969] = + g24[ix+0]*g1[iy+0]*g102[iz+0];
s[1970] = + g24[ix+0]*g0[iy+0]*g103[iz+0];
s[1971] = + g23[ix+0]*g8[iy+0]*g96[iz+0];
s[1972] = + g22[ix+0]*g9[iy+0]*g96[iz+0];
s[1973] = + g22[ix+0]*g8[iy+0]*g97[iz+0];
s[1974] = + g21[ix+0]*g10[iy+0]*g96[iz+0];
s[1975] = + g20[ix+0]*g11[iy+0]*g96[iz+0];
s[1976] = + g20[ix+0]*g10[iy+0]*g97[iz+0];
s[1977] = + g21[ix+0]*g8[iy+0]*g98[iz+0];
s[1978] = + g20[ix+0]*g9[iy+0]*g98[iz+0];
s[1979] = + g20[ix+0]*g8[iy+0]*g99[iz+0];
s[1980] = + g19[ix+0]*g12[iy+0]*g96[iz+0];
s[1981] = + g18[ix+0]*g13[iy+0]*g96[iz+0];
s[1982] = + g18[ix+0]*g12[iy+0]*g97[iz+0];
s[1983] = + g17[ix+0]*g14[iy+0]*g96[iz+0];
s[1984] = + g16[ix+0]*g15[iy+0]*g96[iz+0];
s[1985] = + g16[ix+0]*g14[iy+0]*g97[iz+0];
s[1986] = + g17[ix+0]*g12[iy+0]*g98[iz+0];
s[1987] = + g16[ix+0]*g13[iy+0]*g98[iz+0];
s[1988] = + g16[ix+0]*g12[iy+0]*g99[iz+0];
s[1989] = + g19[ix+0]*g8[iy+0]*g100[iz+0];
s[1990] = + g18[ix+0]*g9[iy+0]*g100[iz+0];
s[1991] = + g18[ix+0]*g8[iy+0]*g101[iz+0];
s[1992] = + g17[ix+0]*g10[iy+0]*g100[iz+0];
s[1993] = + g16[ix+0]*g11[iy+0]*g100[iz+0];
s[1994] = + g16[ix+0]*g10[iy+0]*g101[iz+0];
s[1995] = + g17[ix+0]*g8[iy+0]*g102[iz+0];
s[1996] = + g16[ix+0]*g9[iy+0]*g102[iz+0];
s[1997] = + g16[ix+0]*g8[iy+0]*g103[iz+0];
s[1998] = + g23[ix+0]*g0[iy+0]*g104[iz+0];
s[1999] = + g22[ix+0]*g1[iy+0]*g104[iz+0];
s[2000] = + g22[ix+0]*g0[iy+0]*g105[iz+0];
s[2001] = + g21[ix+0]*g2[iy+0]*g104[iz+0];
s[2002] = + g20[ix+0]*g3[iy+0]*g104[iz+0];
s[2003] = + g20[ix+0]*g2[iy+0]*g105[iz+0];
s[2004] = + g21[ix+0]*g0[iy+0]*g106[iz+0];
s[2005] = + g20[ix+0]*g1[iy+0]*g106[iz+0];
s[2006] = + g20[ix+0]*g0[iy+0]*g107[iz+0];
s[2007] = + g19[ix+0]*g4[iy+0]*g104[iz+0];
s[2008] = + g18[ix+0]*g5[iy+0]*g104[iz+0];
s[2009] = + g18[ix+0]*g4[iy+0]*g105[iz+0];
s[2010] = + g17[ix+0]*g6[iy+0]*g104[iz+0];
s[2011] = + g16[ix+0]*g7[iy+0]*g104[iz+0];
s[2012] = + g16[ix+0]*g6[iy+0]*g105[iz+0];
s[2013] = + g17[ix+0]*g4[iy+0]*g106[iz+0];
s[2014] = + g16[ix+0]*g5[iy+0]*g106[iz+0];
s[2015] = + g16[ix+0]*g4[iy+0]*g107[iz+0];
s[2016] = + g19[ix+0]*g0[iy+0]*g108[iz+0];
s[2017] = + g18[ix+0]*g1[iy+0]*g108[iz+0];
s[2018] = + g18[ix+0]*g0[iy+0]*g109[iz+0];
s[2019] = + g17[ix+0]*g2[iy+0]*g108[iz+0];
s[2020] = + g16[ix+0]*g3[iy+0]*g108[iz+0];
s[2021] = + g16[ix+0]*g2[iy+0]*g109[iz+0];
s[2022] = + g17[ix+0]*g0[iy+0]*g110[iz+0];
s[2023] = + g16[ix+0]*g1[iy+0]*g110[iz+0];
s[2024] = + g16[ix+0]*g0[iy+0]*g111[iz+0];
s[2025] = + g15[ix+0]*g16[iy+0]*g96[iz+0];
s[2026] = + g14[ix+0]*g17[iy+0]*g96[iz+0];
s[2027] = + g14[ix+0]*g16[iy+0]*g97[iz+0];
s[2028] = + g13[ix+0]*g18[iy+0]*g96[iz+0];
s[2029] = + g12[ix+0]*g19[iy+0]*g96[iz+0];
s[2030] = + g12[ix+0]*g18[iy+0]*g97[iz+0];
s[2031] = + g13[ix+0]*g16[iy+0]*g98[iz+0];
s[2032] = + g12[ix+0]*g17[iy+0]*g98[iz+0];
s[2033] = + g12[ix+0]*g16[iy+0]*g99[iz+0];
s[2034] = + g11[ix+0]*g20[iy+0]*g96[iz+0];
s[2035] = + g10[ix+0]*g21[iy+0]*g96[iz+0];
s[2036] = + g10[ix+0]*g20[iy+0]*g97[iz+0];
s[2037] = + g9[ix+0]*g22[iy+0]*g96[iz+0];
s[2038] = + g8[ix+0]*g23[iy+0]*g96[iz+0];
s[2039] = + g8[ix+0]*g22[iy+0]*g97[iz+0];
s[2040] = + g9[ix+0]*g20[iy+0]*g98[iz+0];
s[2041] = + g8[ix+0]*g21[iy+0]*g98[iz+0];
s[2042] = + g8[ix+0]*g20[iy+0]*g99[iz+0];
s[2043] = + g11[ix+0]*g16[iy+0]*g100[iz+0];
s[2044] = + g10[ix+0]*g17[iy+0]*g100[iz+0];
s[2045] = + g10[ix+0]*g16[iy+0]*g101[iz+0];
s[2046] = + g9[ix+0]*g18[iy+0]*g100[iz+0];
s[2047] = + g8[ix+0]*g19[iy+0]*g100[iz+0];
s[2048] = + g8[ix+0]*g18[iy+0]*g101[iz+0];
s[2049] = + g9[ix+0]*g16[iy+0]*g102[iz+0];
s[2050] = + g8[ix+0]*g17[iy+0]*g102[iz+0];
s[2051] = + g8[ix+0]*g16[iy+0]*g103[iz+0];
s[2052] = + g7[ix+0]*g24[iy+0]*g96[iz+0];
s[2053] = + g6[ix+0]*g25[iy+0]*g96[iz+0];
s[2054] = + g6[ix+0]*g24[iy+0]*g97[iz+0];
s[2055] = + g5[ix+0]*g26[iy+0]*g96[iz+0];
s[2056] = + g4[ix+0]*g27[iy+0]*g96[iz+0];
s[2057] = + g4[ix+0]*g26[iy+0]*g97[iz+0];
s[2058] = + g5[ix+0]*g24[iy+0]*g98[iz+0];
s[2059] = + g4[ix+0]*g25[iy+0]*g98[iz+0];
s[2060] = + g4[ix+0]*g24[iy+0]*g99[iz+0];
s[2061] = + g3[ix+0]*g28[iy+0]*g96[iz+0];
s[2062] = + g2[ix+0]*g29[iy+0]*g96[iz+0];
s[2063] = + g2[ix+0]*g28[iy+0]*g97[iz+0];
s[2064] = + g1[ix+0]*g30[iy+0]*g96[iz+0];
s[2065] = + g0[ix+0]*g31[iy+0]*g96[iz+0];
s[2066] = + g0[ix+0]*g30[iy+0]*g97[iz+0];
s[2067] = + g1[ix+0]*g28[iy+0]*g98[iz+0];
s[2068] = + g0[ix+0]*g29[iy+0]*g98[iz+0];
s[2069] = + g0[ix+0]*g28[iy+0]*g99[iz+0];
s[2070] = + g3[ix+0]*g24[iy+0]*g100[iz+0];
s[2071] = + g2[ix+0]*g25[iy+0]*g100[iz+0];
s[2072] = + g2[ix+0]*g24[iy+0]*g101[iz+0];
s[2073] = + g1[ix+0]*g26[iy+0]*g100[iz+0];
s[2074] = + g0[ix+0]*g27[iy+0]*g100[iz+0];
s[2075] = + g0[ix+0]*g26[iy+0]*g101[iz+0];
s[2076] = + g1[ix+0]*g24[iy+0]*g102[iz+0];
s[2077] = + g0[ix+0]*g25[iy+0]*g102[iz+0];
s[2078] = + g0[ix+0]*g24[iy+0]*g103[iz+0];
s[2079] = + g7[ix+0]*g16[iy+0]*g104[iz+0];
s[2080] = + g6[ix+0]*g17[iy+0]*g104[iz+0];
s[2081] = + g6[ix+0]*g16[iy+0]*g105[iz+0];
s[2082] = + g5[ix+0]*g18[iy+0]*g104[iz+0];
s[2083] = + g4[ix+0]*g19[iy+0]*g104[iz+0];
s[2084] = + g4[ix+0]*g18[iy+0]*g105[iz+0];
s[2085] = + g5[ix+0]*g16[iy+0]*g106[iz+0];
s[2086] = + g4[ix+0]*g17[iy+0]*g106[iz+0];
s[2087] = + g4[ix+0]*g16[iy+0]*g107[iz+0];
s[2088] = + g3[ix+0]*g20[iy+0]*g104[iz+0];
s[2089] = + g2[ix+0]*g21[iy+0]*g104[iz+0];
s[2090] = + g2[ix+0]*g20[iy+0]*g105[iz+0];
s[2091] = + g1[ix+0]*g22[iy+0]*g104[iz+0];
s[2092] = + g0[ix+0]*g23[iy+0]*g104[iz+0];
s[2093] = + g0[ix+0]*g22[iy+0]*g105[iz+0];
s[2094] = + g1[ix+0]*g20[iy+0]*g106[iz+0];
s[2095] = + g0[ix+0]*g21[iy+0]*g106[iz+0];
s[2096] = + g0[ix+0]*g20[iy+0]*g107[iz+0];
s[2097] = + g3[ix+0]*g16[iy+0]*g108[iz+0];
s[2098] = + g2[ix+0]*g17[iy+0]*g108[iz+0];
s[2099] = + g2[ix+0]*g16[iy+0]*g109[iz+0];
s[2100] = + g1[ix+0]*g18[iy+0]*g108[iz+0];
s[2101] = + g0[ix+0]*g19[iy+0]*g108[iz+0];
s[2102] = + g0[ix+0]*g18[iy+0]*g109[iz+0];
s[2103] = + g1[ix+0]*g16[iy+0]*g110[iz+0];
s[2104] = + g0[ix+0]*g17[iy+0]*g110[iz+0];
s[2105] = + g0[ix+0]*g16[iy+0]*g111[iz+0];
s[2106] = + g15[ix+0]*g0[iy+0]*g112[iz+0];
s[2107] = + g14[ix+0]*g1[iy+0]*g112[iz+0];
s[2108] = + g14[ix+0]*g0[iy+0]*g113[iz+0];
s[2109] = + g13[ix+0]*g2[iy+0]*g112[iz+0];
s[2110] = + g12[ix+0]*g3[iy+0]*g112[iz+0];
s[2111] = + g12[ix+0]*g2[iy+0]*g113[iz+0];
s[2112] = + g13[ix+0]*g0[iy+0]*g114[iz+0];
s[2113] = + g12[ix+0]*g1[iy+0]*g114[iz+0];
s[2114] = + g12[ix+0]*g0[iy+0]*g115[iz+0];
s[2115] = + g11[ix+0]*g4[iy+0]*g112[iz+0];
s[2116] = + g10[ix+0]*g5[iy+0]*g112[iz+0];
s[2117] = + g10[ix+0]*g4[iy+0]*g113[iz+0];
s[2118] = + g9[ix+0]*g6[iy+0]*g112[iz+0];
s[2119] = + g8[ix+0]*g7[iy+0]*g112[iz+0];
s[2120] = + g8[ix+0]*g6[iy+0]*g113[iz+0];
s[2121] = + g9[ix+0]*g4[iy+0]*g114[iz+0];
s[2122] = + g8[ix+0]*g5[iy+0]*g114[iz+0];
s[2123] = + g8[ix+0]*g4[iy+0]*g115[iz+0];
s[2124] = + g11[ix+0]*g0[iy+0]*g116[iz+0];
s[2125] = + g10[ix+0]*g1[iy+0]*g116[iz+0];
s[2126] = + g10[ix+0]*g0[iy+0]*g117[iz+0];
s[2127] = + g9[ix+0]*g2[iy+0]*g116[iz+0];
s[2128] = + g8[ix+0]*g3[iy+0]*g116[iz+0];
s[2129] = + g8[ix+0]*g2[iy+0]*g117[iz+0];
s[2130] = + g9[ix+0]*g0[iy+0]*g118[iz+0];
s[2131] = + g8[ix+0]*g1[iy+0]*g118[iz+0];
s[2132] = + g8[ix+0]*g0[iy+0]*g119[iz+0];
s[2133] = + g7[ix+0]*g8[iy+0]*g112[iz+0];
s[2134] = + g6[ix+0]*g9[iy+0]*g112[iz+0];
s[2135] = + g6[ix+0]*g8[iy+0]*g113[iz+0];
s[2136] = + g5[ix+0]*g10[iy+0]*g112[iz+0];
s[2137] = + g4[ix+0]*g11[iy+0]*g112[iz+0];
s[2138] = + g4[ix+0]*g10[iy+0]*g113[iz+0];
s[2139] = + g5[ix+0]*g8[iy+0]*g114[iz+0];
s[2140] = + g4[ix+0]*g9[iy+0]*g114[iz+0];
s[2141] = + g4[ix+0]*g8[iy+0]*g115[iz+0];
s[2142] = + g3[ix+0]*g12[iy+0]*g112[iz+0];
s[2143] = + g2[ix+0]*g13[iy+0]*g112[iz+0];
s[2144] = + g2[ix+0]*g12[iy+0]*g113[iz+0];
s[2145] = + g1[ix+0]*g14[iy+0]*g112[iz+0];
s[2146] = + g0[ix+0]*g15[iy+0]*g112[iz+0];
s[2147] = + g0[ix+0]*g14[iy+0]*g113[iz+0];
s[2148] = + g1[ix+0]*g12[iy+0]*g114[iz+0];
s[2149] = + g0[ix+0]*g13[iy+0]*g114[iz+0];
s[2150] = + g0[ix+0]*g12[iy+0]*g115[iz+0];
s[2151] = + g3[ix+0]*g8[iy+0]*g116[iz+0];
s[2152] = + g2[ix+0]*g9[iy+0]*g116[iz+0];
s[2153] = + g2[ix+0]*g8[iy+0]*g117[iz+0];
s[2154] = + g1[ix+0]*g10[iy+0]*g116[iz+0];
s[2155] = + g0[ix+0]*g11[iy+0]*g116[iz+0];
s[2156] = + g0[ix+0]*g10[iy+0]*g117[iz+0];
s[2157] = + g1[ix+0]*g8[iy+0]*g118[iz+0];
s[2158] = + g0[ix+0]*g9[iy+0]*g118[iz+0];
s[2159] = + g0[ix+0]*g8[iy+0]*g119[iz+0];
s[2160] = + g7[ix+0]*g0[iy+0]*g120[iz+0];
s[2161] = + g6[ix+0]*g1[iy+0]*g120[iz+0];
s[2162] = + g6[ix+0]*g0[iy+0]*g121[iz+0];
s[2163] = + g5[ix+0]*g2[iy+0]*g120[iz+0];
s[2164] = + g4[ix+0]*g3[iy+0]*g120[iz+0];
s[2165] = + g4[ix+0]*g2[iy+0]*g121[iz+0];
s[2166] = + g5[ix+0]*g0[iy+0]*g122[iz+0];
s[2167] = + g4[ix+0]*g1[iy+0]*g122[iz+0];
s[2168] = + g4[ix+0]*g0[iy+0]*g123[iz+0];
s[2169] = + g3[ix+0]*g4[iy+0]*g120[iz+0];
s[2170] = + g2[ix+0]*g5[iy+0]*g120[iz+0];
s[2171] = + g2[ix+0]*g4[iy+0]*g121[iz+0];
s[2172] = + g1[ix+0]*g6[iy+0]*g120[iz+0];
s[2173] = + g0[ix+0]*g7[iy+0]*g120[iz+0];
s[2174] = + g0[ix+0]*g6[iy+0]*g121[iz+0];
s[2175] = + g1[ix+0]*g4[iy+0]*g122[iz+0];
s[2176] = + g0[ix+0]*g5[iy+0]*g122[iz+0];
s[2177] = + g0[ix+0]*g4[iy+0]*g123[iz+0];
s[2178] = + g3[ix+0]*g0[iy+0]*g124[iz+0];
s[2179] = + g2[ix+0]*g1[iy+0]*g124[iz+0];
s[2180] = + g2[ix+0]*g0[iy+0]*g125[iz+0];
s[2181] = + g1[ix+0]*g2[iy+0]*g124[iz+0];
s[2182] = + g0[ix+0]*g3[iy+0]*g124[iz+0];
s[2183] = + g0[ix+0]*g2[iy+0]*g125[iz+0];
s[2184] = + g1[ix+0]*g0[iy+0]*g126[iz+0];
s[2185] = + g0[ix+0]*g1[iy+0]*g126[iz+0];
s[2186] = + g0[ix+0]*g0[iy+0]*g127[iz+0];
if (gout_empty) {
gout[n*2187+0] = + s[0];
gout[n*2187+1] = + s[1];
gout[n*2187+2] = + s[2];
gout[n*2187+3] = + s[3];
gout[n*2187+4] = + s[4];
gout[n*2187+5] = + s[5];
gout[n*2187+6] = + s[6];
gout[n*2187+7] = + s[7];
gout[n*2187+8] = + s[8];
gout[n*2187+9] = + s[9];
gout[n*2187+10] = + s[10];
gout[n*2187+11] = + s[11];
gout[n*2187+12] = + s[12];
gout[n*2187+13] = + s[13];
gout[n*2187+14] = + s[14];
gout[n*2187+15] = + s[15];
gout[n*2187+16] = + s[16];
gout[n*2187+17] = + s[17];
gout[n*2187+18] = + s[18];
gout[n*2187+19] = + s[19];
gout[n*2187+20] = + s[20];
gout[n*2187+21] = + s[21];
gout[n*2187+22] = + s[22];
gout[n*2187+23] = + s[23];
gout[n*2187+24] = + s[24];
gout[n*2187+25] = + s[25];
gout[n*2187+26] = + s[26];
gout[n*2187+27] = + s[27];
gout[n*2187+28] = + s[28];
gout[n*2187+29] = + s[29];
gout[n*2187+30] = + s[30];
gout[n*2187+31] = + s[31];
gout[n*2187+32] = + s[32];
gout[n*2187+33] = + s[33];
gout[n*2187+34] = + s[34];
gout[n*2187+35] = + s[35];
gout[n*2187+36] = + s[36];
gout[n*2187+37] = + s[37];
gout[n*2187+38] = + s[38];
gout[n*2187+39] = + s[39];
gout[n*2187+40] = + s[40];
gout[n*2187+41] = + s[41];
gout[n*2187+42] = + s[42];
gout[n*2187+43] = + s[43];
gout[n*2187+44] = + s[44];
gout[n*2187+45] = + s[45];
gout[n*2187+46] = + s[46];
gout[n*2187+47] = + s[47];
gout[n*2187+48] = + s[48];
gout[n*2187+49] = + s[49];
gout[n*2187+50] = + s[50];
gout[n*2187+51] = + s[51];
gout[n*2187+52] = + s[52];
gout[n*2187+53] = + s[53];
gout[n*2187+54] = + s[54];
gout[n*2187+55] = + s[55];
gout[n*2187+56] = + s[56];
gout[n*2187+57] = + s[57];
gout[n*2187+58] = + s[58];
gout[n*2187+59] = + s[59];
gout[n*2187+60] = + s[60];
gout[n*2187+61] = + s[61];
gout[n*2187+62] = + s[62];
gout[n*2187+63] = + s[63];
gout[n*2187+64] = + s[64];
gout[n*2187+65] = + s[65];
gout[n*2187+66] = + s[66];
gout[n*2187+67] = + s[67];
gout[n*2187+68] = + s[68];
gout[n*2187+69] = + s[69];
gout[n*2187+70] = + s[70];
gout[n*2187+71] = + s[71];
gout[n*2187+72] = + s[72];
gout[n*2187+73] = + s[73];
gout[n*2187+74] = + s[74];
gout[n*2187+75] = + s[75];
gout[n*2187+76] = + s[76];
gout[n*2187+77] = + s[77];
gout[n*2187+78] = + s[78];
gout[n*2187+79] = + s[79];
gout[n*2187+80] = + s[80];
gout[n*2187+81] = + s[81];
gout[n*2187+82] = + s[82];
gout[n*2187+83] = + s[83];
gout[n*2187+84] = + s[84];
gout[n*2187+85] = + s[85];
gout[n*2187+86] = + s[86];
gout[n*2187+87] = + s[87];
gout[n*2187+88] = + s[88];
gout[n*2187+89] = + s[89];
gout[n*2187+90] = + s[90];
gout[n*2187+91] = + s[91];
gout[n*2187+92] = + s[92];
gout[n*2187+93] = + s[93];
gout[n*2187+94] = + s[94];
gout[n*2187+95] = + s[95];
gout[n*2187+96] = + s[96];
gout[n*2187+97] = + s[97];
gout[n*2187+98] = + s[98];
gout[n*2187+99] = + s[99];
gout[n*2187+100] = + s[100];
gout[n*2187+101] = + s[101];
gout[n*2187+102] = + s[102];
gout[n*2187+103] = + s[103];
gout[n*2187+104] = + s[104];
gout[n*2187+105] = + s[105];
gout[n*2187+106] = + s[106];
gout[n*2187+107] = + s[107];
gout[n*2187+108] = + s[108];
gout[n*2187+109] = + s[109];
gout[n*2187+110] = + s[110];
gout[n*2187+111] = + s[111];
gout[n*2187+112] = + s[112];
gout[n*2187+113] = + s[113];
gout[n*2187+114] = + s[114];
gout[n*2187+115] = + s[115];
gout[n*2187+116] = + s[116];
gout[n*2187+117] = + s[117];
gout[n*2187+118] = + s[118];
gout[n*2187+119] = + s[119];
gout[n*2187+120] = + s[120];
gout[n*2187+121] = + s[121];
gout[n*2187+122] = + s[122];
gout[n*2187+123] = + s[123];
gout[n*2187+124] = + s[124];
gout[n*2187+125] = + s[125];
gout[n*2187+126] = + s[126];
gout[n*2187+127] = + s[127];
gout[n*2187+128] = + s[128];
gout[n*2187+129] = + s[129];
gout[n*2187+130] = + s[130];
gout[n*2187+131] = + s[131];
gout[n*2187+132] = + s[132];
gout[n*2187+133] = + s[133];
gout[n*2187+134] = + s[134];
gout[n*2187+135] = + s[135];
gout[n*2187+136] = + s[136];
gout[n*2187+137] = + s[137];
gout[n*2187+138] = + s[138];
gout[n*2187+139] = + s[139];
gout[n*2187+140] = + s[140];
gout[n*2187+141] = + s[141];
gout[n*2187+142] = + s[142];
gout[n*2187+143] = + s[143];
gout[n*2187+144] = + s[144];
gout[n*2187+145] = + s[145];
gout[n*2187+146] = + s[146];
gout[n*2187+147] = + s[147];
gout[n*2187+148] = + s[148];
gout[n*2187+149] = + s[149];
gout[n*2187+150] = + s[150];
gout[n*2187+151] = + s[151];
gout[n*2187+152] = + s[152];
gout[n*2187+153] = + s[153];
gout[n*2187+154] = + s[154];
gout[n*2187+155] = + s[155];
gout[n*2187+156] = + s[156];
gout[n*2187+157] = + s[157];
gout[n*2187+158] = + s[158];
gout[n*2187+159] = + s[159];
gout[n*2187+160] = + s[160];
gout[n*2187+161] = + s[161];
gout[n*2187+162] = + s[162];
gout[n*2187+163] = + s[163];
gout[n*2187+164] = + s[164];
gout[n*2187+165] = + s[165];
gout[n*2187+166] = + s[166];
gout[n*2187+167] = + s[167];
gout[n*2187+168] = + s[168];
gout[n*2187+169] = + s[169];
gout[n*2187+170] = + s[170];
gout[n*2187+171] = + s[171];
gout[n*2187+172] = + s[172];
gout[n*2187+173] = + s[173];
gout[n*2187+174] = + s[174];
gout[n*2187+175] = + s[175];
gout[n*2187+176] = + s[176];
gout[n*2187+177] = + s[177];
gout[n*2187+178] = + s[178];
gout[n*2187+179] = + s[179];
gout[n*2187+180] = + s[180];
gout[n*2187+181] = + s[181];
gout[n*2187+182] = + s[182];
gout[n*2187+183] = + s[183];
gout[n*2187+184] = + s[184];
gout[n*2187+185] = + s[185];
gout[n*2187+186] = + s[186];
gout[n*2187+187] = + s[187];
gout[n*2187+188] = + s[188];
gout[n*2187+189] = + s[189];
gout[n*2187+190] = + s[190];
gout[n*2187+191] = + s[191];
gout[n*2187+192] = + s[192];
gout[n*2187+193] = + s[193];
gout[n*2187+194] = + s[194];
gout[n*2187+195] = + s[195];
gout[n*2187+196] = + s[196];
gout[n*2187+197] = + s[197];
gout[n*2187+198] = + s[198];
gout[n*2187+199] = + s[199];
gout[n*2187+200] = + s[200];
gout[n*2187+201] = + s[201];
gout[n*2187+202] = + s[202];
gout[n*2187+203] = + s[203];
gout[n*2187+204] = + s[204];
gout[n*2187+205] = + s[205];
gout[n*2187+206] = + s[206];
gout[n*2187+207] = + s[207];
gout[n*2187+208] = + s[208];
gout[n*2187+209] = + s[209];
gout[n*2187+210] = + s[210];
gout[n*2187+211] = + s[211];
gout[n*2187+212] = + s[212];
gout[n*2187+213] = + s[213];
gout[n*2187+214] = + s[214];
gout[n*2187+215] = + s[215];
gout[n*2187+216] = + s[216];
gout[n*2187+217] = + s[217];
gout[n*2187+218] = + s[218];
gout[n*2187+219] = + s[219];
gout[n*2187+220] = + s[220];
gout[n*2187+221] = + s[221];
gout[n*2187+222] = + s[222];
gout[n*2187+223] = + s[223];
gout[n*2187+224] = + s[224];
gout[n*2187+225] = + s[225];
gout[n*2187+226] = + s[226];
gout[n*2187+227] = + s[227];
gout[n*2187+228] = + s[228];
gout[n*2187+229] = + s[229];
gout[n*2187+230] = + s[230];
gout[n*2187+231] = + s[231];
gout[n*2187+232] = + s[232];
gout[n*2187+233] = + s[233];
gout[n*2187+234] = + s[234];
gout[n*2187+235] = + s[235];
gout[n*2187+236] = + s[236];
gout[n*2187+237] = + s[237];
gout[n*2187+238] = + s[238];
gout[n*2187+239] = + s[239];
gout[n*2187+240] = + s[240];
gout[n*2187+241] = + s[241];
gout[n*2187+242] = + s[242];
gout[n*2187+243] = + s[243];
gout[n*2187+244] = + s[244];
gout[n*2187+245] = + s[245];
gout[n*2187+246] = + s[246];
gout[n*2187+247] = + s[247];
gout[n*2187+248] = + s[248];
gout[n*2187+249] = + s[249];
gout[n*2187+250] = + s[250];
gout[n*2187+251] = + s[251];
gout[n*2187+252] = + s[252];
gout[n*2187+253] = + s[253];
gout[n*2187+254] = + s[254];
gout[n*2187+255] = + s[255];
gout[n*2187+256] = + s[256];
gout[n*2187+257] = + s[257];
gout[n*2187+258] = + s[258];
gout[n*2187+259] = + s[259];
gout[n*2187+260] = + s[260];
gout[n*2187+261] = + s[261];
gout[n*2187+262] = + s[262];
gout[n*2187+263] = + s[263];
gout[n*2187+264] = + s[264];
gout[n*2187+265] = + s[265];
gout[n*2187+266] = + s[266];
gout[n*2187+267] = + s[267];
gout[n*2187+268] = + s[268];
gout[n*2187+269] = + s[269];
gout[n*2187+270] = + s[270];
gout[n*2187+271] = + s[271];
gout[n*2187+272] = + s[272];
gout[n*2187+273] = + s[273];
gout[n*2187+274] = + s[274];
gout[n*2187+275] = + s[275];
gout[n*2187+276] = + s[276];
gout[n*2187+277] = + s[277];
gout[n*2187+278] = + s[278];
gout[n*2187+279] = + s[279];
gout[n*2187+280] = + s[280];
gout[n*2187+281] = + s[281];
gout[n*2187+282] = + s[282];
gout[n*2187+283] = + s[283];
gout[n*2187+284] = + s[284];
gout[n*2187+285] = + s[285];
gout[n*2187+286] = + s[286];
gout[n*2187+287] = + s[287];
gout[n*2187+288] = + s[288];
gout[n*2187+289] = + s[289];
gout[n*2187+290] = + s[290];
gout[n*2187+291] = + s[291];
gout[n*2187+292] = + s[292];
gout[n*2187+293] = + s[293];
gout[n*2187+294] = + s[294];
gout[n*2187+295] = + s[295];
gout[n*2187+296] = + s[296];
gout[n*2187+297] = + s[297];
gout[n*2187+298] = + s[298];
gout[n*2187+299] = + s[299];
gout[n*2187+300] = + s[300];
gout[n*2187+301] = + s[301];
gout[n*2187+302] = + s[302];
gout[n*2187+303] = + s[303];
gout[n*2187+304] = + s[304];
gout[n*2187+305] = + s[305];
gout[n*2187+306] = + s[306];
gout[n*2187+307] = + s[307];
gout[n*2187+308] = + s[308];
gout[n*2187+309] = + s[309];
gout[n*2187+310] = + s[310];
gout[n*2187+311] = + s[311];
gout[n*2187+312] = + s[312];
gout[n*2187+313] = + s[313];
gout[n*2187+314] = + s[314];
gout[n*2187+315] = + s[315];
gout[n*2187+316] = + s[316];
gout[n*2187+317] = + s[317];
gout[n*2187+318] = + s[318];
gout[n*2187+319] = + s[319];
gout[n*2187+320] = + s[320];
gout[n*2187+321] = + s[321];
gout[n*2187+322] = + s[322];
gout[n*2187+323] = + s[323];
gout[n*2187+324] = + s[324];
gout[n*2187+325] = + s[325];
gout[n*2187+326] = + s[326];
gout[n*2187+327] = + s[327];
gout[n*2187+328] = + s[328];
gout[n*2187+329] = + s[329];
gout[n*2187+330] = + s[330];
gout[n*2187+331] = + s[331];
gout[n*2187+332] = + s[332];
gout[n*2187+333] = + s[333];
gout[n*2187+334] = + s[334];
gout[n*2187+335] = + s[335];
gout[n*2187+336] = + s[336];
gout[n*2187+337] = + s[337];
gout[n*2187+338] = + s[338];
gout[n*2187+339] = + s[339];
gout[n*2187+340] = + s[340];
gout[n*2187+341] = + s[341];
gout[n*2187+342] = + s[342];
gout[n*2187+343] = + s[343];
gout[n*2187+344] = + s[344];
gout[n*2187+345] = + s[345];
gout[n*2187+346] = + s[346];
gout[n*2187+347] = + s[347];
gout[n*2187+348] = + s[348];
gout[n*2187+349] = + s[349];
gout[n*2187+350] = + s[350];
gout[n*2187+351] = + s[351];
gout[n*2187+352] = + s[352];
gout[n*2187+353] = + s[353];
gout[n*2187+354] = + s[354];
gout[n*2187+355] = + s[355];
gout[n*2187+356] = + s[356];
gout[n*2187+357] = + s[357];
gout[n*2187+358] = + s[358];
gout[n*2187+359] = + s[359];
gout[n*2187+360] = + s[360];
gout[n*2187+361] = + s[361];
gout[n*2187+362] = + s[362];
gout[n*2187+363] = + s[363];
gout[n*2187+364] = + s[364];
gout[n*2187+365] = + s[365];
gout[n*2187+366] = + s[366];
gout[n*2187+367] = + s[367];
gout[n*2187+368] = + s[368];
gout[n*2187+369] = + s[369];
gout[n*2187+370] = + s[370];
gout[n*2187+371] = + s[371];
gout[n*2187+372] = + s[372];
gout[n*2187+373] = + s[373];
gout[n*2187+374] = + s[374];
gout[n*2187+375] = + s[375];
gout[n*2187+376] = + s[376];
gout[n*2187+377] = + s[377];
gout[n*2187+378] = + s[378];
gout[n*2187+379] = + s[379];
gout[n*2187+380] = + s[380];
gout[n*2187+381] = + s[381];
gout[n*2187+382] = + s[382];
gout[n*2187+383] = + s[383];
gout[n*2187+384] = + s[384];
gout[n*2187+385] = + s[385];
gout[n*2187+386] = + s[386];
gout[n*2187+387] = + s[387];
gout[n*2187+388] = + s[388];
gout[n*2187+389] = + s[389];
gout[n*2187+390] = + s[390];
gout[n*2187+391] = + s[391];
gout[n*2187+392] = + s[392];
gout[n*2187+393] = + s[393];
gout[n*2187+394] = + s[394];
gout[n*2187+395] = + s[395];
gout[n*2187+396] = + s[396];
gout[n*2187+397] = + s[397];
gout[n*2187+398] = + s[398];
gout[n*2187+399] = + s[399];
gout[n*2187+400] = + s[400];
gout[n*2187+401] = + s[401];
gout[n*2187+402] = + s[402];
gout[n*2187+403] = + s[403];
gout[n*2187+404] = + s[404];
gout[n*2187+405] = + s[405];
gout[n*2187+406] = + s[406];
gout[n*2187+407] = + s[407];
gout[n*2187+408] = + s[408];
gout[n*2187+409] = + s[409];
gout[n*2187+410] = + s[410];
gout[n*2187+411] = + s[411];
gout[n*2187+412] = + s[412];
gout[n*2187+413] = + s[413];
gout[n*2187+414] = + s[414];
gout[n*2187+415] = + s[415];
gout[n*2187+416] = + s[416];
gout[n*2187+417] = + s[417];
gout[n*2187+418] = + s[418];
gout[n*2187+419] = + s[419];
gout[n*2187+420] = + s[420];
gout[n*2187+421] = + s[421];
gout[n*2187+422] = + s[422];
gout[n*2187+423] = + s[423];
gout[n*2187+424] = + s[424];
gout[n*2187+425] = + s[425];
gout[n*2187+426] = + s[426];
gout[n*2187+427] = + s[427];
gout[n*2187+428] = + s[428];
gout[n*2187+429] = + s[429];
gout[n*2187+430] = + s[430];
gout[n*2187+431] = + s[431];
gout[n*2187+432] = + s[432];
gout[n*2187+433] = + s[433];
gout[n*2187+434] = + s[434];
gout[n*2187+435] = + s[435];
gout[n*2187+436] = + s[436];
gout[n*2187+437] = + s[437];
gout[n*2187+438] = + s[438];
gout[n*2187+439] = + s[439];
gout[n*2187+440] = + s[440];
gout[n*2187+441] = + s[441];
gout[n*2187+442] = + s[442];
gout[n*2187+443] = + s[443];
gout[n*2187+444] = + s[444];
gout[n*2187+445] = + s[445];
gout[n*2187+446] = + s[446];
gout[n*2187+447] = + s[447];
gout[n*2187+448] = + s[448];
gout[n*2187+449] = + s[449];
gout[n*2187+450] = + s[450];
gout[n*2187+451] = + s[451];
gout[n*2187+452] = + s[452];
gout[n*2187+453] = + s[453];
gout[n*2187+454] = + s[454];
gout[n*2187+455] = + s[455];
gout[n*2187+456] = + s[456];
gout[n*2187+457] = + s[457];
gout[n*2187+458] = + s[458];
gout[n*2187+459] = + s[459];
gout[n*2187+460] = + s[460];
gout[n*2187+461] = + s[461];
gout[n*2187+462] = + s[462];
gout[n*2187+463] = + s[463];
gout[n*2187+464] = + s[464];
gout[n*2187+465] = + s[465];
gout[n*2187+466] = + s[466];
gout[n*2187+467] = + s[467];
gout[n*2187+468] = + s[468];
gout[n*2187+469] = + s[469];
gout[n*2187+470] = + s[470];
gout[n*2187+471] = + s[471];
gout[n*2187+472] = + s[472];
gout[n*2187+473] = + s[473];
gout[n*2187+474] = + s[474];
gout[n*2187+475] = + s[475];
gout[n*2187+476] = + s[476];
gout[n*2187+477] = + s[477];
gout[n*2187+478] = + s[478];
gout[n*2187+479] = + s[479];
gout[n*2187+480] = + s[480];
gout[n*2187+481] = + s[481];
gout[n*2187+482] = + s[482];
gout[n*2187+483] = + s[483];
gout[n*2187+484] = + s[484];
gout[n*2187+485] = + s[485];
gout[n*2187+486] = + s[486];
gout[n*2187+487] = + s[487];
gout[n*2187+488] = + s[488];
gout[n*2187+489] = + s[489];
gout[n*2187+490] = + s[490];
gout[n*2187+491] = + s[491];
gout[n*2187+492] = + s[492];
gout[n*2187+493] = + s[493];
gout[n*2187+494] = + s[494];
gout[n*2187+495] = + s[495];
gout[n*2187+496] = + s[496];
gout[n*2187+497] = + s[497];
gout[n*2187+498] = + s[498];
gout[n*2187+499] = + s[499];
gout[n*2187+500] = + s[500];
gout[n*2187+501] = + s[501];
gout[n*2187+502] = + s[502];
gout[n*2187+503] = + s[503];
gout[n*2187+504] = + s[504];
gout[n*2187+505] = + s[505];
gout[n*2187+506] = + s[506];
gout[n*2187+507] = + s[507];
gout[n*2187+508] = + s[508];
gout[n*2187+509] = + s[509];
gout[n*2187+510] = + s[510];
gout[n*2187+511] = + s[511];
gout[n*2187+512] = + s[512];
gout[n*2187+513] = + s[513];
gout[n*2187+514] = + s[514];
gout[n*2187+515] = + s[515];
gout[n*2187+516] = + s[516];
gout[n*2187+517] = + s[517];
gout[n*2187+518] = + s[518];
gout[n*2187+519] = + s[519];
gout[n*2187+520] = + s[520];
gout[n*2187+521] = + s[521];
gout[n*2187+522] = + s[522];
gout[n*2187+523] = + s[523];
gout[n*2187+524] = + s[524];
gout[n*2187+525] = + s[525];
gout[n*2187+526] = + s[526];
gout[n*2187+527] = + s[527];
gout[n*2187+528] = + s[528];
gout[n*2187+529] = + s[529];
gout[n*2187+530] = + s[530];
gout[n*2187+531] = + s[531];
gout[n*2187+532] = + s[532];
gout[n*2187+533] = + s[533];
gout[n*2187+534] = + s[534];
gout[n*2187+535] = + s[535];
gout[n*2187+536] = + s[536];
gout[n*2187+537] = + s[537];
gout[n*2187+538] = + s[538];
gout[n*2187+539] = + s[539];
gout[n*2187+540] = + s[540];
gout[n*2187+541] = + s[541];
gout[n*2187+542] = + s[542];
gout[n*2187+543] = + s[543];
gout[n*2187+544] = + s[544];
gout[n*2187+545] = + s[545];
gout[n*2187+546] = + s[546];
gout[n*2187+547] = + s[547];
gout[n*2187+548] = + s[548];
gout[n*2187+549] = + s[549];
gout[n*2187+550] = + s[550];
gout[n*2187+551] = + s[551];
gout[n*2187+552] = + s[552];
gout[n*2187+553] = + s[553];
gout[n*2187+554] = + s[554];
gout[n*2187+555] = + s[555];
gout[n*2187+556] = + s[556];
gout[n*2187+557] = + s[557];
gout[n*2187+558] = + s[558];
gout[n*2187+559] = + s[559];
gout[n*2187+560] = + s[560];
gout[n*2187+561] = + s[561];
gout[n*2187+562] = + s[562];
gout[n*2187+563] = + s[563];
gout[n*2187+564] = + s[564];
gout[n*2187+565] = + s[565];
gout[n*2187+566] = + s[566];
gout[n*2187+567] = + s[567];
gout[n*2187+568] = + s[568];
gout[n*2187+569] = + s[569];
gout[n*2187+570] = + s[570];
gout[n*2187+571] = + s[571];
gout[n*2187+572] = + s[572];
gout[n*2187+573] = + s[573];
gout[n*2187+574] = + s[574];
gout[n*2187+575] = + s[575];
gout[n*2187+576] = + s[576];
gout[n*2187+577] = + s[577];
gout[n*2187+578] = + s[578];
gout[n*2187+579] = + s[579];
gout[n*2187+580] = + s[580];
gout[n*2187+581] = + s[581];
gout[n*2187+582] = + s[582];
gout[n*2187+583] = + s[583];
gout[n*2187+584] = + s[584];
gout[n*2187+585] = + s[585];
gout[n*2187+586] = + s[586];
gout[n*2187+587] = + s[587];
gout[n*2187+588] = + s[588];
gout[n*2187+589] = + s[589];
gout[n*2187+590] = + s[590];
gout[n*2187+591] = + s[591];
gout[n*2187+592] = + s[592];
gout[n*2187+593] = + s[593];
gout[n*2187+594] = + s[594];
gout[n*2187+595] = + s[595];
gout[n*2187+596] = + s[596];
gout[n*2187+597] = + s[597];
gout[n*2187+598] = + s[598];
gout[n*2187+599] = + s[599];
gout[n*2187+600] = + s[600];
gout[n*2187+601] = + s[601];
gout[n*2187+602] = + s[602];
gout[n*2187+603] = + s[603];
gout[n*2187+604] = + s[604];
gout[n*2187+605] = + s[605];
gout[n*2187+606] = + s[606];
gout[n*2187+607] = + s[607];
gout[n*2187+608] = + s[608];
gout[n*2187+609] = + s[609];
gout[n*2187+610] = + s[610];
gout[n*2187+611] = + s[611];
gout[n*2187+612] = + s[612];
gout[n*2187+613] = + s[613];
gout[n*2187+614] = + s[614];
gout[n*2187+615] = + s[615];
gout[n*2187+616] = + s[616];
gout[n*2187+617] = + s[617];
gout[n*2187+618] = + s[618];
gout[n*2187+619] = + s[619];
gout[n*2187+620] = + s[620];
gout[n*2187+621] = + s[621];
gout[n*2187+622] = + s[622];
gout[n*2187+623] = + s[623];
gout[n*2187+624] = + s[624];
gout[n*2187+625] = + s[625];
gout[n*2187+626] = + s[626];
gout[n*2187+627] = + s[627];
gout[n*2187+628] = + s[628];
gout[n*2187+629] = + s[629];
gout[n*2187+630] = + s[630];
gout[n*2187+631] = + s[631];
gout[n*2187+632] = + s[632];
gout[n*2187+633] = + s[633];
gout[n*2187+634] = + s[634];
gout[n*2187+635] = + s[635];
gout[n*2187+636] = + s[636];
gout[n*2187+637] = + s[637];
gout[n*2187+638] = + s[638];
gout[n*2187+639] = + s[639];
gout[n*2187+640] = + s[640];
gout[n*2187+641] = + s[641];
gout[n*2187+642] = + s[642];
gout[n*2187+643] = + s[643];
gout[n*2187+644] = + s[644];
gout[n*2187+645] = + s[645];
gout[n*2187+646] = + s[646];
gout[n*2187+647] = + s[647];
gout[n*2187+648] = + s[648];
gout[n*2187+649] = + s[649];
gout[n*2187+650] = + s[650];
gout[n*2187+651] = + s[651];
gout[n*2187+652] = + s[652];
gout[n*2187+653] = + s[653];
gout[n*2187+654] = + s[654];
gout[n*2187+655] = + s[655];
gout[n*2187+656] = + s[656];
gout[n*2187+657] = + s[657];
gout[n*2187+658] = + s[658];
gout[n*2187+659] = + s[659];
gout[n*2187+660] = + s[660];
gout[n*2187+661] = + s[661];
gout[n*2187+662] = + s[662];
gout[n*2187+663] = + s[663];
gout[n*2187+664] = + s[664];
gout[n*2187+665] = + s[665];
gout[n*2187+666] = + s[666];
gout[n*2187+667] = + s[667];
gout[n*2187+668] = + s[668];
gout[n*2187+669] = + s[669];
gout[n*2187+670] = + s[670];
gout[n*2187+671] = + s[671];
gout[n*2187+672] = + s[672];
gout[n*2187+673] = + s[673];
gout[n*2187+674] = + s[674];
gout[n*2187+675] = + s[675];
gout[n*2187+676] = + s[676];
gout[n*2187+677] = + s[677];
gout[n*2187+678] = + s[678];
gout[n*2187+679] = + s[679];
gout[n*2187+680] = + s[680];
gout[n*2187+681] = + s[681];
gout[n*2187+682] = + s[682];
gout[n*2187+683] = + s[683];
gout[n*2187+684] = + s[684];
gout[n*2187+685] = + s[685];
gout[n*2187+686] = + s[686];
gout[n*2187+687] = + s[687];
gout[n*2187+688] = + s[688];
gout[n*2187+689] = + s[689];
gout[n*2187+690] = + s[690];
gout[n*2187+691] = + s[691];
gout[n*2187+692] = + s[692];
gout[n*2187+693] = + s[693];
gout[n*2187+694] = + s[694];
gout[n*2187+695] = + s[695];
gout[n*2187+696] = + s[696];
gout[n*2187+697] = + s[697];
gout[n*2187+698] = + s[698];
gout[n*2187+699] = + s[699];
gout[n*2187+700] = + s[700];
gout[n*2187+701] = + s[701];
gout[n*2187+702] = + s[702];
gout[n*2187+703] = + s[703];
gout[n*2187+704] = + s[704];
gout[n*2187+705] = + s[705];
gout[n*2187+706] = + s[706];
gout[n*2187+707] = + s[707];
gout[n*2187+708] = + s[708];
gout[n*2187+709] = + s[709];
gout[n*2187+710] = + s[710];
gout[n*2187+711] = + s[711];
gout[n*2187+712] = + s[712];
gout[n*2187+713] = + s[713];
gout[n*2187+714] = + s[714];
gout[n*2187+715] = + s[715];
gout[n*2187+716] = + s[716];
gout[n*2187+717] = + s[717];
gout[n*2187+718] = + s[718];
gout[n*2187+719] = + s[719];
gout[n*2187+720] = + s[720];
gout[n*2187+721] = + s[721];
gout[n*2187+722] = + s[722];
gout[n*2187+723] = + s[723];
gout[n*2187+724] = + s[724];
gout[n*2187+725] = + s[725];
gout[n*2187+726] = + s[726];
gout[n*2187+727] = + s[727];
gout[n*2187+728] = + s[728];
gout[n*2187+729] = + s[729];
gout[n*2187+730] = + s[730];
gout[n*2187+731] = + s[731];
gout[n*2187+732] = + s[732];
gout[n*2187+733] = + s[733];
gout[n*2187+734] = + s[734];
gout[n*2187+735] = + s[735];
gout[n*2187+736] = + s[736];
gout[n*2187+737] = + s[737];
gout[n*2187+738] = + s[738];
gout[n*2187+739] = + s[739];
gout[n*2187+740] = + s[740];
gout[n*2187+741] = + s[741];
gout[n*2187+742] = + s[742];
gout[n*2187+743] = + s[743];
gout[n*2187+744] = + s[744];
gout[n*2187+745] = + s[745];
gout[n*2187+746] = + s[746];
gout[n*2187+747] = + s[747];
gout[n*2187+748] = + s[748];
gout[n*2187+749] = + s[749];
gout[n*2187+750] = + s[750];
gout[n*2187+751] = + s[751];
gout[n*2187+752] = + s[752];
gout[n*2187+753] = + s[753];
gout[n*2187+754] = + s[754];
gout[n*2187+755] = + s[755];
gout[n*2187+756] = + s[756];
gout[n*2187+757] = + s[757];
gout[n*2187+758] = + s[758];
gout[n*2187+759] = + s[759];
gout[n*2187+760] = + s[760];
gout[n*2187+761] = + s[761];
gout[n*2187+762] = + s[762];
gout[n*2187+763] = + s[763];
gout[n*2187+764] = + s[764];
gout[n*2187+765] = + s[765];
gout[n*2187+766] = + s[766];
gout[n*2187+767] = + s[767];
gout[n*2187+768] = + s[768];
gout[n*2187+769] = + s[769];
gout[n*2187+770] = + s[770];
gout[n*2187+771] = + s[771];
gout[n*2187+772] = + s[772];
gout[n*2187+773] = + s[773];
gout[n*2187+774] = + s[774];
gout[n*2187+775] = + s[775];
gout[n*2187+776] = + s[776];
gout[n*2187+777] = + s[777];
gout[n*2187+778] = + s[778];
gout[n*2187+779] = + s[779];
gout[n*2187+780] = + s[780];
gout[n*2187+781] = + s[781];
gout[n*2187+782] = + s[782];
gout[n*2187+783] = + s[783];
gout[n*2187+784] = + s[784];
gout[n*2187+785] = + s[785];
gout[n*2187+786] = + s[786];
gout[n*2187+787] = + s[787];
gout[n*2187+788] = + s[788];
gout[n*2187+789] = + s[789];
gout[n*2187+790] = + s[790];
gout[n*2187+791] = + s[791];
gout[n*2187+792] = + s[792];
gout[n*2187+793] = + s[793];
gout[n*2187+794] = + s[794];
gout[n*2187+795] = + s[795];
gout[n*2187+796] = + s[796];
gout[n*2187+797] = + s[797];
gout[n*2187+798] = + s[798];
gout[n*2187+799] = + s[799];
gout[n*2187+800] = + s[800];
gout[n*2187+801] = + s[801];
gout[n*2187+802] = + s[802];
gout[n*2187+803] = + s[803];
gout[n*2187+804] = + s[804];
gout[n*2187+805] = + s[805];
gout[n*2187+806] = + s[806];
gout[n*2187+807] = + s[807];
gout[n*2187+808] = + s[808];
gout[n*2187+809] = + s[809];
gout[n*2187+810] = + s[810];
gout[n*2187+811] = + s[811];
gout[n*2187+812] = + s[812];
gout[n*2187+813] = + s[813];
gout[n*2187+814] = + s[814];
gout[n*2187+815] = + s[815];
gout[n*2187+816] = + s[816];
gout[n*2187+817] = + s[817];
gout[n*2187+818] = + s[818];
gout[n*2187+819] = + s[819];
gout[n*2187+820] = + s[820];
gout[n*2187+821] = + s[821];
gout[n*2187+822] = + s[822];
gout[n*2187+823] = + s[823];
gout[n*2187+824] = + s[824];
gout[n*2187+825] = + s[825];
gout[n*2187+826] = + s[826];
gout[n*2187+827] = + s[827];
gout[n*2187+828] = + s[828];
gout[n*2187+829] = + s[829];
gout[n*2187+830] = + s[830];
gout[n*2187+831] = + s[831];
gout[n*2187+832] = + s[832];
gout[n*2187+833] = + s[833];
gout[n*2187+834] = + s[834];
gout[n*2187+835] = + s[835];
gout[n*2187+836] = + s[836];
gout[n*2187+837] = + s[837];
gout[n*2187+838] = + s[838];
gout[n*2187+839] = + s[839];
gout[n*2187+840] = + s[840];
gout[n*2187+841] = + s[841];
gout[n*2187+842] = + s[842];
gout[n*2187+843] = + s[843];
gout[n*2187+844] = + s[844];
gout[n*2187+845] = + s[845];
gout[n*2187+846] = + s[846];
gout[n*2187+847] = + s[847];
gout[n*2187+848] = + s[848];
gout[n*2187+849] = + s[849];
gout[n*2187+850] = + s[850];
gout[n*2187+851] = + s[851];
gout[n*2187+852] = + s[852];
gout[n*2187+853] = + s[853];
gout[n*2187+854] = + s[854];
gout[n*2187+855] = + s[855];
gout[n*2187+856] = + s[856];
gout[n*2187+857] = + s[857];
gout[n*2187+858] = + s[858];
gout[n*2187+859] = + s[859];
gout[n*2187+860] = + s[860];
gout[n*2187+861] = + s[861];
gout[n*2187+862] = + s[862];
gout[n*2187+863] = + s[863];
gout[n*2187+864] = + s[864];
gout[n*2187+865] = + s[865];
gout[n*2187+866] = + s[866];
gout[n*2187+867] = + s[867];
gout[n*2187+868] = + s[868];
gout[n*2187+869] = + s[869];
gout[n*2187+870] = + s[870];
gout[n*2187+871] = + s[871];
gout[n*2187+872] = + s[872];
gout[n*2187+873] = + s[873];
gout[n*2187+874] = + s[874];
gout[n*2187+875] = + s[875];
gout[n*2187+876] = + s[876];
gout[n*2187+877] = + s[877];
gout[n*2187+878] = + s[878];
gout[n*2187+879] = + s[879];
gout[n*2187+880] = + s[880];
gout[n*2187+881] = + s[881];
gout[n*2187+882] = + s[882];
gout[n*2187+883] = + s[883];
gout[n*2187+884] = + s[884];
gout[n*2187+885] = + s[885];
gout[n*2187+886] = + s[886];
gout[n*2187+887] = + s[887];
gout[n*2187+888] = + s[888];
gout[n*2187+889] = + s[889];
gout[n*2187+890] = + s[890];
gout[n*2187+891] = + s[891];
gout[n*2187+892] = + s[892];
gout[n*2187+893] = + s[893];
gout[n*2187+894] = + s[894];
gout[n*2187+895] = + s[895];
gout[n*2187+896] = + s[896];
gout[n*2187+897] = + s[897];
gout[n*2187+898] = + s[898];
gout[n*2187+899] = + s[899];
gout[n*2187+900] = + s[900];
gout[n*2187+901] = + s[901];
gout[n*2187+902] = + s[902];
gout[n*2187+903] = + s[903];
gout[n*2187+904] = + s[904];
gout[n*2187+905] = + s[905];
gout[n*2187+906] = + s[906];
gout[n*2187+907] = + s[907];
gout[n*2187+908] = + s[908];
gout[n*2187+909] = + s[909];
gout[n*2187+910] = + s[910];
gout[n*2187+911] = + s[911];
gout[n*2187+912] = + s[912];
gout[n*2187+913] = + s[913];
gout[n*2187+914] = + s[914];
gout[n*2187+915] = + s[915];
gout[n*2187+916] = + s[916];
gout[n*2187+917] = + s[917];
gout[n*2187+918] = + s[918];
gout[n*2187+919] = + s[919];
gout[n*2187+920] = + s[920];
gout[n*2187+921] = + s[921];
gout[n*2187+922] = + s[922];
gout[n*2187+923] = + s[923];
gout[n*2187+924] = + s[924];
gout[n*2187+925] = + s[925];
gout[n*2187+926] = + s[926];
gout[n*2187+927] = + s[927];
gout[n*2187+928] = + s[928];
gout[n*2187+929] = + s[929];
gout[n*2187+930] = + s[930];
gout[n*2187+931] = + s[931];
gout[n*2187+932] = + s[932];
gout[n*2187+933] = + s[933];
gout[n*2187+934] = + s[934];
gout[n*2187+935] = + s[935];
gout[n*2187+936] = + s[936];
gout[n*2187+937] = + s[937];
gout[n*2187+938] = + s[938];
gout[n*2187+939] = + s[939];
gout[n*2187+940] = + s[940];
gout[n*2187+941] = + s[941];
gout[n*2187+942] = + s[942];
gout[n*2187+943] = + s[943];
gout[n*2187+944] = + s[944];
gout[n*2187+945] = + s[945];
gout[n*2187+946] = + s[946];
gout[n*2187+947] = + s[947];
gout[n*2187+948] = + s[948];
gout[n*2187+949] = + s[949];
gout[n*2187+950] = + s[950];
gout[n*2187+951] = + s[951];
gout[n*2187+952] = + s[952];
gout[n*2187+953] = + s[953];
gout[n*2187+954] = + s[954];
gout[n*2187+955] = + s[955];
gout[n*2187+956] = + s[956];
gout[n*2187+957] = + s[957];
gout[n*2187+958] = + s[958];
gout[n*2187+959] = + s[959];
gout[n*2187+960] = + s[960];
gout[n*2187+961] = + s[961];
gout[n*2187+962] = + s[962];
gout[n*2187+963] = + s[963];
gout[n*2187+964] = + s[964];
gout[n*2187+965] = + s[965];
gout[n*2187+966] = + s[966];
gout[n*2187+967] = + s[967];
gout[n*2187+968] = + s[968];
gout[n*2187+969] = + s[969];
gout[n*2187+970] = + s[970];
gout[n*2187+971] = + s[971];
gout[n*2187+972] = + s[972];
gout[n*2187+973] = + s[973];
gout[n*2187+974] = + s[974];
gout[n*2187+975] = + s[975];
gout[n*2187+976] = + s[976];
gout[n*2187+977] = + s[977];
gout[n*2187+978] = + s[978];
gout[n*2187+979] = + s[979];
gout[n*2187+980] = + s[980];
gout[n*2187+981] = + s[981];
gout[n*2187+982] = + s[982];
gout[n*2187+983] = + s[983];
gout[n*2187+984] = + s[984];
gout[n*2187+985] = + s[985];
gout[n*2187+986] = + s[986];
gout[n*2187+987] = + s[987];
gout[n*2187+988] = + s[988];
gout[n*2187+989] = + s[989];
gout[n*2187+990] = + s[990];
gout[n*2187+991] = + s[991];
gout[n*2187+992] = + s[992];
gout[n*2187+993] = + s[993];
gout[n*2187+994] = + s[994];
gout[n*2187+995] = + s[995];
gout[n*2187+996] = + s[996];
gout[n*2187+997] = + s[997];
gout[n*2187+998] = + s[998];
gout[n*2187+999] = + s[999];
gout[n*2187+1000] = + s[1000];
gout[n*2187+1001] = + s[1001];
gout[n*2187+1002] = + s[1002];
gout[n*2187+1003] = + s[1003];
gout[n*2187+1004] = + s[1004];
gout[n*2187+1005] = + s[1005];
gout[n*2187+1006] = + s[1006];
gout[n*2187+1007] = + s[1007];
gout[n*2187+1008] = + s[1008];
gout[n*2187+1009] = + s[1009];
gout[n*2187+1010] = + s[1010];
gout[n*2187+1011] = + s[1011];
gout[n*2187+1012] = + s[1012];
gout[n*2187+1013] = + s[1013];
gout[n*2187+1014] = + s[1014];
gout[n*2187+1015] = + s[1015];
gout[n*2187+1016] = + s[1016];
gout[n*2187+1017] = + s[1017];
gout[n*2187+1018] = + s[1018];
gout[n*2187+1019] = + s[1019];
gout[n*2187+1020] = + s[1020];
gout[n*2187+1021] = + s[1021];
gout[n*2187+1022] = + s[1022];
gout[n*2187+1023] = + s[1023];
gout[n*2187+1024] = + s[1024];
gout[n*2187+1025] = + s[1025];
gout[n*2187+1026] = + s[1026];
gout[n*2187+1027] = + s[1027];
gout[n*2187+1028] = + s[1028];
gout[n*2187+1029] = + s[1029];
gout[n*2187+1030] = + s[1030];
gout[n*2187+1031] = + s[1031];
gout[n*2187+1032] = + s[1032];
gout[n*2187+1033] = + s[1033];
gout[n*2187+1034] = + s[1034];
gout[n*2187+1035] = + s[1035];
gout[n*2187+1036] = + s[1036];
gout[n*2187+1037] = + s[1037];
gout[n*2187+1038] = + s[1038];
gout[n*2187+1039] = + s[1039];
gout[n*2187+1040] = + s[1040];
gout[n*2187+1041] = + s[1041];
gout[n*2187+1042] = + s[1042];
gout[n*2187+1043] = + s[1043];
gout[n*2187+1044] = + s[1044];
gout[n*2187+1045] = + s[1045];
gout[n*2187+1046] = + s[1046];
gout[n*2187+1047] = + s[1047];
gout[n*2187+1048] = + s[1048];
gout[n*2187+1049] = + s[1049];
gout[n*2187+1050] = + s[1050];
gout[n*2187+1051] = + s[1051];
gout[n*2187+1052] = + s[1052];
gout[n*2187+1053] = + s[1053];
gout[n*2187+1054] = + s[1054];
gout[n*2187+1055] = + s[1055];
gout[n*2187+1056] = + s[1056];
gout[n*2187+1057] = + s[1057];
gout[n*2187+1058] = + s[1058];
gout[n*2187+1059] = + s[1059];
gout[n*2187+1060] = + s[1060];
gout[n*2187+1061] = + s[1061];
gout[n*2187+1062] = + s[1062];
gout[n*2187+1063] = + s[1063];
gout[n*2187+1064] = + s[1064];
gout[n*2187+1065] = + s[1065];
gout[n*2187+1066] = + s[1066];
gout[n*2187+1067] = + s[1067];
gout[n*2187+1068] = + s[1068];
gout[n*2187+1069] = + s[1069];
gout[n*2187+1070] = + s[1070];
gout[n*2187+1071] = + s[1071];
gout[n*2187+1072] = + s[1072];
gout[n*2187+1073] = + s[1073];
gout[n*2187+1074] = + s[1074];
gout[n*2187+1075] = + s[1075];
gout[n*2187+1076] = + s[1076];
gout[n*2187+1077] = + s[1077];
gout[n*2187+1078] = + s[1078];
gout[n*2187+1079] = + s[1079];
gout[n*2187+1080] = + s[1080];
gout[n*2187+1081] = + s[1081];
gout[n*2187+1082] = + s[1082];
gout[n*2187+1083] = + s[1083];
gout[n*2187+1084] = + s[1084];
gout[n*2187+1085] = + s[1085];
gout[n*2187+1086] = + s[1086];
gout[n*2187+1087] = + s[1087];
gout[n*2187+1088] = + s[1088];
gout[n*2187+1089] = + s[1089];
gout[n*2187+1090] = + s[1090];
gout[n*2187+1091] = + s[1091];
gout[n*2187+1092] = + s[1092];
gout[n*2187+1093] = + s[1093];
gout[n*2187+1094] = + s[1094];
gout[n*2187+1095] = + s[1095];
gout[n*2187+1096] = + s[1096];
gout[n*2187+1097] = + s[1097];
gout[n*2187+1098] = + s[1098];
gout[n*2187+1099] = + s[1099];
gout[n*2187+1100] = + s[1100];
gout[n*2187+1101] = + s[1101];
gout[n*2187+1102] = + s[1102];
gout[n*2187+1103] = + s[1103];
gout[n*2187+1104] = + s[1104];
gout[n*2187+1105] = + s[1105];
gout[n*2187+1106] = + s[1106];
gout[n*2187+1107] = + s[1107];
gout[n*2187+1108] = + s[1108];
gout[n*2187+1109] = + s[1109];
gout[n*2187+1110] = + s[1110];
gout[n*2187+1111] = + s[1111];
gout[n*2187+1112] = + s[1112];
gout[n*2187+1113] = + s[1113];
gout[n*2187+1114] = + s[1114];
gout[n*2187+1115] = + s[1115];
gout[n*2187+1116] = + s[1116];
gout[n*2187+1117] = + s[1117];
gout[n*2187+1118] = + s[1118];
gout[n*2187+1119] = + s[1119];
gout[n*2187+1120] = + s[1120];
gout[n*2187+1121] = + s[1121];
gout[n*2187+1122] = + s[1122];
gout[n*2187+1123] = + s[1123];
gout[n*2187+1124] = + s[1124];
gout[n*2187+1125] = + s[1125];
gout[n*2187+1126] = + s[1126];
gout[n*2187+1127] = + s[1127];
gout[n*2187+1128] = + s[1128];
gout[n*2187+1129] = + s[1129];
gout[n*2187+1130] = + s[1130];
gout[n*2187+1131] = + s[1131];
gout[n*2187+1132] = + s[1132];
gout[n*2187+1133] = + s[1133];
gout[n*2187+1134] = + s[1134];
gout[n*2187+1135] = + s[1135];
gout[n*2187+1136] = + s[1136];
gout[n*2187+1137] = + s[1137];
gout[n*2187+1138] = + s[1138];
gout[n*2187+1139] = + s[1139];
gout[n*2187+1140] = + s[1140];
gout[n*2187+1141] = + s[1141];
gout[n*2187+1142] = + s[1142];
gout[n*2187+1143] = + s[1143];
gout[n*2187+1144] = + s[1144];
gout[n*2187+1145] = + s[1145];
gout[n*2187+1146] = + s[1146];
gout[n*2187+1147] = + s[1147];
gout[n*2187+1148] = + s[1148];
gout[n*2187+1149] = + s[1149];
gout[n*2187+1150] = + s[1150];
gout[n*2187+1151] = + s[1151];
gout[n*2187+1152] = + s[1152];
gout[n*2187+1153] = + s[1153];
gout[n*2187+1154] = + s[1154];
gout[n*2187+1155] = + s[1155];
gout[n*2187+1156] = + s[1156];
gout[n*2187+1157] = + s[1157];
gout[n*2187+1158] = + s[1158];
gout[n*2187+1159] = + s[1159];
gout[n*2187+1160] = + s[1160];
gout[n*2187+1161] = + s[1161];
gout[n*2187+1162] = + s[1162];
gout[n*2187+1163] = + s[1163];
gout[n*2187+1164] = + s[1164];
gout[n*2187+1165] = + s[1165];
gout[n*2187+1166] = + s[1166];
gout[n*2187+1167] = + s[1167];
gout[n*2187+1168] = + s[1168];
gout[n*2187+1169] = + s[1169];
gout[n*2187+1170] = + s[1170];
gout[n*2187+1171] = + s[1171];
gout[n*2187+1172] = + s[1172];
gout[n*2187+1173] = + s[1173];
gout[n*2187+1174] = + s[1174];
gout[n*2187+1175] = + s[1175];
gout[n*2187+1176] = + s[1176];
gout[n*2187+1177] = + s[1177];
gout[n*2187+1178] = + s[1178];
gout[n*2187+1179] = + s[1179];
gout[n*2187+1180] = + s[1180];
gout[n*2187+1181] = + s[1181];
gout[n*2187+1182] = + s[1182];
gout[n*2187+1183] = + s[1183];
gout[n*2187+1184] = + s[1184];
gout[n*2187+1185] = + s[1185];
gout[n*2187+1186] = + s[1186];
gout[n*2187+1187] = + s[1187];
gout[n*2187+1188] = + s[1188];
gout[n*2187+1189] = + s[1189];
gout[n*2187+1190] = + s[1190];
gout[n*2187+1191] = + s[1191];
gout[n*2187+1192] = + s[1192];
gout[n*2187+1193] = + s[1193];
gout[n*2187+1194] = + s[1194];
gout[n*2187+1195] = + s[1195];
gout[n*2187+1196] = + s[1196];
gout[n*2187+1197] = + s[1197];
gout[n*2187+1198] = + s[1198];
gout[n*2187+1199] = + s[1199];
gout[n*2187+1200] = + s[1200];
gout[n*2187+1201] = + s[1201];
gout[n*2187+1202] = + s[1202];
gout[n*2187+1203] = + s[1203];
gout[n*2187+1204] = + s[1204];
gout[n*2187+1205] = + s[1205];
gout[n*2187+1206] = + s[1206];
gout[n*2187+1207] = + s[1207];
gout[n*2187+1208] = + s[1208];
gout[n*2187+1209] = + s[1209];
gout[n*2187+1210] = + s[1210];
gout[n*2187+1211] = + s[1211];
gout[n*2187+1212] = + s[1212];
gout[n*2187+1213] = + s[1213];
gout[n*2187+1214] = + s[1214];
gout[n*2187+1215] = + s[1215];
gout[n*2187+1216] = + s[1216];
gout[n*2187+1217] = + s[1217];
gout[n*2187+1218] = + s[1218];
gout[n*2187+1219] = + s[1219];
gout[n*2187+1220] = + s[1220];
gout[n*2187+1221] = + s[1221];
gout[n*2187+1222] = + s[1222];
gout[n*2187+1223] = + s[1223];
gout[n*2187+1224] = + s[1224];
gout[n*2187+1225] = + s[1225];
gout[n*2187+1226] = + s[1226];
gout[n*2187+1227] = + s[1227];
gout[n*2187+1228] = + s[1228];
gout[n*2187+1229] = + s[1229];
gout[n*2187+1230] = + s[1230];
gout[n*2187+1231] = + s[1231];
gout[n*2187+1232] = + s[1232];
gout[n*2187+1233] = + s[1233];
gout[n*2187+1234] = + s[1234];
gout[n*2187+1235] = + s[1235];
gout[n*2187+1236] = + s[1236];
gout[n*2187+1237] = + s[1237];
gout[n*2187+1238] = + s[1238];
gout[n*2187+1239] = + s[1239];
gout[n*2187+1240] = + s[1240];
gout[n*2187+1241] = + s[1241];
gout[n*2187+1242] = + s[1242];
gout[n*2187+1243] = + s[1243];
gout[n*2187+1244] = + s[1244];
gout[n*2187+1245] = + s[1245];
gout[n*2187+1246] = + s[1246];
gout[n*2187+1247] = + s[1247];
gout[n*2187+1248] = + s[1248];
gout[n*2187+1249] = + s[1249];
gout[n*2187+1250] = + s[1250];
gout[n*2187+1251] = + s[1251];
gout[n*2187+1252] = + s[1252];
gout[n*2187+1253] = + s[1253];
gout[n*2187+1254] = + s[1254];
gout[n*2187+1255] = + s[1255];
gout[n*2187+1256] = + s[1256];
gout[n*2187+1257] = + s[1257];
gout[n*2187+1258] = + s[1258];
gout[n*2187+1259] = + s[1259];
gout[n*2187+1260] = + s[1260];
gout[n*2187+1261] = + s[1261];
gout[n*2187+1262] = + s[1262];
gout[n*2187+1263] = + s[1263];
gout[n*2187+1264] = + s[1264];
gout[n*2187+1265] = + s[1265];
gout[n*2187+1266] = + s[1266];
gout[n*2187+1267] = + s[1267];
gout[n*2187+1268] = + s[1268];
gout[n*2187+1269] = + s[1269];
gout[n*2187+1270] = + s[1270];
gout[n*2187+1271] = + s[1271];
gout[n*2187+1272] = + s[1272];
gout[n*2187+1273] = + s[1273];
gout[n*2187+1274] = + s[1274];
gout[n*2187+1275] = + s[1275];
gout[n*2187+1276] = + s[1276];
gout[n*2187+1277] = + s[1277];
gout[n*2187+1278] = + s[1278];
gout[n*2187+1279] = + s[1279];
gout[n*2187+1280] = + s[1280];
gout[n*2187+1281] = + s[1281];
gout[n*2187+1282] = + s[1282];
gout[n*2187+1283] = + s[1283];
gout[n*2187+1284] = + s[1284];
gout[n*2187+1285] = + s[1285];
gout[n*2187+1286] = + s[1286];
gout[n*2187+1287] = + s[1287];
gout[n*2187+1288] = + s[1288];
gout[n*2187+1289] = + s[1289];
gout[n*2187+1290] = + s[1290];
gout[n*2187+1291] = + s[1291];
gout[n*2187+1292] = + s[1292];
gout[n*2187+1293] = + s[1293];
gout[n*2187+1294] = + s[1294];
gout[n*2187+1295] = + s[1295];
gout[n*2187+1296] = + s[1296];
gout[n*2187+1297] = + s[1297];
gout[n*2187+1298] = + s[1298];
gout[n*2187+1299] = + s[1299];
gout[n*2187+1300] = + s[1300];
gout[n*2187+1301] = + s[1301];
gout[n*2187+1302] = + s[1302];
gout[n*2187+1303] = + s[1303];
gout[n*2187+1304] = + s[1304];
gout[n*2187+1305] = + s[1305];
gout[n*2187+1306] = + s[1306];
gout[n*2187+1307] = + s[1307];
gout[n*2187+1308] = + s[1308];
gout[n*2187+1309] = + s[1309];
gout[n*2187+1310] = + s[1310];
gout[n*2187+1311] = + s[1311];
gout[n*2187+1312] = + s[1312];
gout[n*2187+1313] = + s[1313];
gout[n*2187+1314] = + s[1314];
gout[n*2187+1315] = + s[1315];
gout[n*2187+1316] = + s[1316];
gout[n*2187+1317] = + s[1317];
gout[n*2187+1318] = + s[1318];
gout[n*2187+1319] = + s[1319];
gout[n*2187+1320] = + s[1320];
gout[n*2187+1321] = + s[1321];
gout[n*2187+1322] = + s[1322];
gout[n*2187+1323] = + s[1323];
gout[n*2187+1324] = + s[1324];
gout[n*2187+1325] = + s[1325];
gout[n*2187+1326] = + s[1326];
gout[n*2187+1327] = + s[1327];
gout[n*2187+1328] = + s[1328];
gout[n*2187+1329] = + s[1329];
gout[n*2187+1330] = + s[1330];
gout[n*2187+1331] = + s[1331];
gout[n*2187+1332] = + s[1332];
gout[n*2187+1333] = + s[1333];
gout[n*2187+1334] = + s[1334];
gout[n*2187+1335] = + s[1335];
gout[n*2187+1336] = + s[1336];
gout[n*2187+1337] = + s[1337];
gout[n*2187+1338] = + s[1338];
gout[n*2187+1339] = + s[1339];
gout[n*2187+1340] = + s[1340];
gout[n*2187+1341] = + s[1341];
gout[n*2187+1342] = + s[1342];
gout[n*2187+1343] = + s[1343];
gout[n*2187+1344] = + s[1344];
gout[n*2187+1345] = + s[1345];
gout[n*2187+1346] = + s[1346];
gout[n*2187+1347] = + s[1347];
gout[n*2187+1348] = + s[1348];
gout[n*2187+1349] = + s[1349];
gout[n*2187+1350] = + s[1350];
gout[n*2187+1351] = + s[1351];
gout[n*2187+1352] = + s[1352];
gout[n*2187+1353] = + s[1353];
gout[n*2187+1354] = + s[1354];
gout[n*2187+1355] = + s[1355];
gout[n*2187+1356] = + s[1356];
gout[n*2187+1357] = + s[1357];
gout[n*2187+1358] = + s[1358];
gout[n*2187+1359] = + s[1359];
gout[n*2187+1360] = + s[1360];
gout[n*2187+1361] = + s[1361];
gout[n*2187+1362] = + s[1362];
gout[n*2187+1363] = + s[1363];
gout[n*2187+1364] = + s[1364];
gout[n*2187+1365] = + s[1365];
gout[n*2187+1366] = + s[1366];
gout[n*2187+1367] = + s[1367];
gout[n*2187+1368] = + s[1368];
gout[n*2187+1369] = + s[1369];
gout[n*2187+1370] = + s[1370];
gout[n*2187+1371] = + s[1371];
gout[n*2187+1372] = + s[1372];
gout[n*2187+1373] = + s[1373];
gout[n*2187+1374] = + s[1374];
gout[n*2187+1375] = + s[1375];
gout[n*2187+1376] = + s[1376];
gout[n*2187+1377] = + s[1377];
gout[n*2187+1378] = + s[1378];
gout[n*2187+1379] = + s[1379];
gout[n*2187+1380] = + s[1380];
gout[n*2187+1381] = + s[1381];
gout[n*2187+1382] = + s[1382];
gout[n*2187+1383] = + s[1383];
gout[n*2187+1384] = + s[1384];
gout[n*2187+1385] = + s[1385];
gout[n*2187+1386] = + s[1386];
gout[n*2187+1387] = + s[1387];
gout[n*2187+1388] = + s[1388];
gout[n*2187+1389] = + s[1389];
gout[n*2187+1390] = + s[1390];
gout[n*2187+1391] = + s[1391];
gout[n*2187+1392] = + s[1392];
gout[n*2187+1393] = + s[1393];
gout[n*2187+1394] = + s[1394];
gout[n*2187+1395] = + s[1395];
gout[n*2187+1396] = + s[1396];
gout[n*2187+1397] = + s[1397];
gout[n*2187+1398] = + s[1398];
gout[n*2187+1399] = + s[1399];
gout[n*2187+1400] = + s[1400];
gout[n*2187+1401] = + s[1401];
gout[n*2187+1402] = + s[1402];
gout[n*2187+1403] = + s[1403];
gout[n*2187+1404] = + s[1404];
gout[n*2187+1405] = + s[1405];
gout[n*2187+1406] = + s[1406];
gout[n*2187+1407] = + s[1407];
gout[n*2187+1408] = + s[1408];
gout[n*2187+1409] = + s[1409];
gout[n*2187+1410] = + s[1410];
gout[n*2187+1411] = + s[1411];
gout[n*2187+1412] = + s[1412];
gout[n*2187+1413] = + s[1413];
gout[n*2187+1414] = + s[1414];
gout[n*2187+1415] = + s[1415];
gout[n*2187+1416] = + s[1416];
gout[n*2187+1417] = + s[1417];
gout[n*2187+1418] = + s[1418];
gout[n*2187+1419] = + s[1419];
gout[n*2187+1420] = + s[1420];
gout[n*2187+1421] = + s[1421];
gout[n*2187+1422] = + s[1422];
gout[n*2187+1423] = + s[1423];
gout[n*2187+1424] = + s[1424];
gout[n*2187+1425] = + s[1425];
gout[n*2187+1426] = + s[1426];
gout[n*2187+1427] = + s[1427];
gout[n*2187+1428] = + s[1428];
gout[n*2187+1429] = + s[1429];
gout[n*2187+1430] = + s[1430];
gout[n*2187+1431] = + s[1431];
gout[n*2187+1432] = + s[1432];
gout[n*2187+1433] = + s[1433];
gout[n*2187+1434] = + s[1434];
gout[n*2187+1435] = + s[1435];
gout[n*2187+1436] = + s[1436];
gout[n*2187+1437] = + s[1437];
gout[n*2187+1438] = + s[1438];
gout[n*2187+1439] = + s[1439];
gout[n*2187+1440] = + s[1440];
gout[n*2187+1441] = + s[1441];
gout[n*2187+1442] = + s[1442];
gout[n*2187+1443] = + s[1443];
gout[n*2187+1444] = + s[1444];
gout[n*2187+1445] = + s[1445];
gout[n*2187+1446] = + s[1446];
gout[n*2187+1447] = + s[1447];
gout[n*2187+1448] = + s[1448];
gout[n*2187+1449] = + s[1449];
gout[n*2187+1450] = + s[1450];
gout[n*2187+1451] = + s[1451];
gout[n*2187+1452] = + s[1452];
gout[n*2187+1453] = + s[1453];
gout[n*2187+1454] = + s[1454];
gout[n*2187+1455] = + s[1455];
gout[n*2187+1456] = + s[1456];
gout[n*2187+1457] = + s[1457];
gout[n*2187+1458] = + s[1458];
gout[n*2187+1459] = + s[1459];
gout[n*2187+1460] = + s[1460];
gout[n*2187+1461] = + s[1461];
gout[n*2187+1462] = + s[1462];
gout[n*2187+1463] = + s[1463];
gout[n*2187+1464] = + s[1464];
gout[n*2187+1465] = + s[1465];
gout[n*2187+1466] = + s[1466];
gout[n*2187+1467] = + s[1467];
gout[n*2187+1468] = + s[1468];
gout[n*2187+1469] = + s[1469];
gout[n*2187+1470] = + s[1470];
gout[n*2187+1471] = + s[1471];
gout[n*2187+1472] = + s[1472];
gout[n*2187+1473] = + s[1473];
gout[n*2187+1474] = + s[1474];
gout[n*2187+1475] = + s[1475];
gout[n*2187+1476] = + s[1476];
gout[n*2187+1477] = + s[1477];
gout[n*2187+1478] = + s[1478];
gout[n*2187+1479] = + s[1479];
gout[n*2187+1480] = + s[1480];
gout[n*2187+1481] = + s[1481];
gout[n*2187+1482] = + s[1482];
gout[n*2187+1483] = + s[1483];
gout[n*2187+1484] = + s[1484];
gout[n*2187+1485] = + s[1485];
gout[n*2187+1486] = + s[1486];
gout[n*2187+1487] = + s[1487];
gout[n*2187+1488] = + s[1488];
gout[n*2187+1489] = + s[1489];
gout[n*2187+1490] = + s[1490];
gout[n*2187+1491] = + s[1491];
gout[n*2187+1492] = + s[1492];
gout[n*2187+1493] = + s[1493];
gout[n*2187+1494] = + s[1494];
gout[n*2187+1495] = + s[1495];
gout[n*2187+1496] = + s[1496];
gout[n*2187+1497] = + s[1497];
gout[n*2187+1498] = + s[1498];
gout[n*2187+1499] = + s[1499];
gout[n*2187+1500] = + s[1500];
gout[n*2187+1501] = + s[1501];
gout[n*2187+1502] = + s[1502];
gout[n*2187+1503] = + s[1503];
gout[n*2187+1504] = + s[1504];
gout[n*2187+1505] = + s[1505];
gout[n*2187+1506] = + s[1506];
gout[n*2187+1507] = + s[1507];
gout[n*2187+1508] = + s[1508];
gout[n*2187+1509] = + s[1509];
gout[n*2187+1510] = + s[1510];
gout[n*2187+1511] = + s[1511];
gout[n*2187+1512] = + s[1512];
gout[n*2187+1513] = + s[1513];
gout[n*2187+1514] = + s[1514];
gout[n*2187+1515] = + s[1515];
gout[n*2187+1516] = + s[1516];
gout[n*2187+1517] = + s[1517];
gout[n*2187+1518] = + s[1518];
gout[n*2187+1519] = + s[1519];
gout[n*2187+1520] = + s[1520];
gout[n*2187+1521] = + s[1521];
gout[n*2187+1522] = + s[1522];
gout[n*2187+1523] = + s[1523];
gout[n*2187+1524] = + s[1524];
gout[n*2187+1525] = + s[1525];
gout[n*2187+1526] = + s[1526];
gout[n*2187+1527] = + s[1527];
gout[n*2187+1528] = + s[1528];
gout[n*2187+1529] = + s[1529];
gout[n*2187+1530] = + s[1530];
gout[n*2187+1531] = + s[1531];
gout[n*2187+1532] = + s[1532];
gout[n*2187+1533] = + s[1533];
gout[n*2187+1534] = + s[1534];
gout[n*2187+1535] = + s[1535];
gout[n*2187+1536] = + s[1536];
gout[n*2187+1537] = + s[1537];
gout[n*2187+1538] = + s[1538];
gout[n*2187+1539] = + s[1539];
gout[n*2187+1540] = + s[1540];
gout[n*2187+1541] = + s[1541];
gout[n*2187+1542] = + s[1542];
gout[n*2187+1543] = + s[1543];
gout[n*2187+1544] = + s[1544];
gout[n*2187+1545] = + s[1545];
gout[n*2187+1546] = + s[1546];
gout[n*2187+1547] = + s[1547];
gout[n*2187+1548] = + s[1548];
gout[n*2187+1549] = + s[1549];
gout[n*2187+1550] = + s[1550];
gout[n*2187+1551] = + s[1551];
gout[n*2187+1552] = + s[1552];
gout[n*2187+1553] = + s[1553];
gout[n*2187+1554] = + s[1554];
gout[n*2187+1555] = + s[1555];
gout[n*2187+1556] = + s[1556];
gout[n*2187+1557] = + s[1557];
gout[n*2187+1558] = + s[1558];
gout[n*2187+1559] = + s[1559];
gout[n*2187+1560] = + s[1560];
gout[n*2187+1561] = + s[1561];
gout[n*2187+1562] = + s[1562];
gout[n*2187+1563] = + s[1563];
gout[n*2187+1564] = + s[1564];
gout[n*2187+1565] = + s[1565];
gout[n*2187+1566] = + s[1566];
gout[n*2187+1567] = + s[1567];
gout[n*2187+1568] = + s[1568];
gout[n*2187+1569] = + s[1569];
gout[n*2187+1570] = + s[1570];
gout[n*2187+1571] = + s[1571];
gout[n*2187+1572] = + s[1572];
gout[n*2187+1573] = + s[1573];
gout[n*2187+1574] = + s[1574];
gout[n*2187+1575] = + s[1575];
gout[n*2187+1576] = + s[1576];
gout[n*2187+1577] = + s[1577];
gout[n*2187+1578] = + s[1578];
gout[n*2187+1579] = + s[1579];
gout[n*2187+1580] = + s[1580];
gout[n*2187+1581] = + s[1581];
gout[n*2187+1582] = + s[1582];
gout[n*2187+1583] = + s[1583];
gout[n*2187+1584] = + s[1584];
gout[n*2187+1585] = + s[1585];
gout[n*2187+1586] = + s[1586];
gout[n*2187+1587] = + s[1587];
gout[n*2187+1588] = + s[1588];
gout[n*2187+1589] = + s[1589];
gout[n*2187+1590] = + s[1590];
gout[n*2187+1591] = + s[1591];
gout[n*2187+1592] = + s[1592];
gout[n*2187+1593] = + s[1593];
gout[n*2187+1594] = + s[1594];
gout[n*2187+1595] = + s[1595];
gout[n*2187+1596] = + s[1596];
gout[n*2187+1597] = + s[1597];
gout[n*2187+1598] = + s[1598];
gout[n*2187+1599] = + s[1599];
gout[n*2187+1600] = + s[1600];
gout[n*2187+1601] = + s[1601];
gout[n*2187+1602] = + s[1602];
gout[n*2187+1603] = + s[1603];
gout[n*2187+1604] = + s[1604];
gout[n*2187+1605] = + s[1605];
gout[n*2187+1606] = + s[1606];
gout[n*2187+1607] = + s[1607];
gout[n*2187+1608] = + s[1608];
gout[n*2187+1609] = + s[1609];
gout[n*2187+1610] = + s[1610];
gout[n*2187+1611] = + s[1611];
gout[n*2187+1612] = + s[1612];
gout[n*2187+1613] = + s[1613];
gout[n*2187+1614] = + s[1614];
gout[n*2187+1615] = + s[1615];
gout[n*2187+1616] = + s[1616];
gout[n*2187+1617] = + s[1617];
gout[n*2187+1618] = + s[1618];
gout[n*2187+1619] = + s[1619];
gout[n*2187+1620] = + s[1620];
gout[n*2187+1621] = + s[1621];
gout[n*2187+1622] = + s[1622];
gout[n*2187+1623] = + s[1623];
gout[n*2187+1624] = + s[1624];
gout[n*2187+1625] = + s[1625];
gout[n*2187+1626] = + s[1626];
gout[n*2187+1627] = + s[1627];
gout[n*2187+1628] = + s[1628];
gout[n*2187+1629] = + s[1629];
gout[n*2187+1630] = + s[1630];
gout[n*2187+1631] = + s[1631];
gout[n*2187+1632] = + s[1632];
gout[n*2187+1633] = + s[1633];
gout[n*2187+1634] = + s[1634];
gout[n*2187+1635] = + s[1635];
gout[n*2187+1636] = + s[1636];
gout[n*2187+1637] = + s[1637];
gout[n*2187+1638] = + s[1638];
gout[n*2187+1639] = + s[1639];
gout[n*2187+1640] = + s[1640];
gout[n*2187+1641] = + s[1641];
gout[n*2187+1642] = + s[1642];
gout[n*2187+1643] = + s[1643];
gout[n*2187+1644] = + s[1644];
gout[n*2187+1645] = + s[1645];
gout[n*2187+1646] = + s[1646];
gout[n*2187+1647] = + s[1647];
gout[n*2187+1648] = + s[1648];
gout[n*2187+1649] = + s[1649];
gout[n*2187+1650] = + s[1650];
gout[n*2187+1651] = + s[1651];
gout[n*2187+1652] = + s[1652];
gout[n*2187+1653] = + s[1653];
gout[n*2187+1654] = + s[1654];
gout[n*2187+1655] = + s[1655];
gout[n*2187+1656] = + s[1656];
gout[n*2187+1657] = + s[1657];
gout[n*2187+1658] = + s[1658];
gout[n*2187+1659] = + s[1659];
gout[n*2187+1660] = + s[1660];
gout[n*2187+1661] = + s[1661];
gout[n*2187+1662] = + s[1662];
gout[n*2187+1663] = + s[1663];
gout[n*2187+1664] = + s[1664];
gout[n*2187+1665] = + s[1665];
gout[n*2187+1666] = + s[1666];
gout[n*2187+1667] = + s[1667];
gout[n*2187+1668] = + s[1668];
gout[n*2187+1669] = + s[1669];
gout[n*2187+1670] = + s[1670];
gout[n*2187+1671] = + s[1671];
gout[n*2187+1672] = + s[1672];
gout[n*2187+1673] = + s[1673];
gout[n*2187+1674] = + s[1674];
gout[n*2187+1675] = + s[1675];
gout[n*2187+1676] = + s[1676];
gout[n*2187+1677] = + s[1677];
gout[n*2187+1678] = + s[1678];
gout[n*2187+1679] = + s[1679];
gout[n*2187+1680] = + s[1680];
gout[n*2187+1681] = + s[1681];
gout[n*2187+1682] = + s[1682];
gout[n*2187+1683] = + s[1683];
gout[n*2187+1684] = + s[1684];
gout[n*2187+1685] = + s[1685];
gout[n*2187+1686] = + s[1686];
gout[n*2187+1687] = + s[1687];
gout[n*2187+1688] = + s[1688];
gout[n*2187+1689] = + s[1689];
gout[n*2187+1690] = + s[1690];
gout[n*2187+1691] = + s[1691];
gout[n*2187+1692] = + s[1692];
gout[n*2187+1693] = + s[1693];
gout[n*2187+1694] = + s[1694];
gout[n*2187+1695] = + s[1695];
gout[n*2187+1696] = + s[1696];
gout[n*2187+1697] = + s[1697];
gout[n*2187+1698] = + s[1698];
gout[n*2187+1699] = + s[1699];
gout[n*2187+1700] = + s[1700];
gout[n*2187+1701] = + s[1701];
gout[n*2187+1702] = + s[1702];
gout[n*2187+1703] = + s[1703];
gout[n*2187+1704] = + s[1704];
gout[n*2187+1705] = + s[1705];
gout[n*2187+1706] = + s[1706];
gout[n*2187+1707] = + s[1707];
gout[n*2187+1708] = + s[1708];
gout[n*2187+1709] = + s[1709];
gout[n*2187+1710] = + s[1710];
gout[n*2187+1711] = + s[1711];
gout[n*2187+1712] = + s[1712];
gout[n*2187+1713] = + s[1713];
gout[n*2187+1714] = + s[1714];
gout[n*2187+1715] = + s[1715];
gout[n*2187+1716] = + s[1716];
gout[n*2187+1717] = + s[1717];
gout[n*2187+1718] = + s[1718];
gout[n*2187+1719] = + s[1719];
gout[n*2187+1720] = + s[1720];
gout[n*2187+1721] = + s[1721];
gout[n*2187+1722] = + s[1722];
gout[n*2187+1723] = + s[1723];
gout[n*2187+1724] = + s[1724];
gout[n*2187+1725] = + s[1725];
gout[n*2187+1726] = + s[1726];
gout[n*2187+1727] = + s[1727];
gout[n*2187+1728] = + s[1728];
gout[n*2187+1729] = + s[1729];
gout[n*2187+1730] = + s[1730];
gout[n*2187+1731] = + s[1731];
gout[n*2187+1732] = + s[1732];
gout[n*2187+1733] = + s[1733];
gout[n*2187+1734] = + s[1734];
gout[n*2187+1735] = + s[1735];
gout[n*2187+1736] = + s[1736];
gout[n*2187+1737] = + s[1737];
gout[n*2187+1738] = + s[1738];
gout[n*2187+1739] = + s[1739];
gout[n*2187+1740] = + s[1740];
gout[n*2187+1741] = + s[1741];
gout[n*2187+1742] = + s[1742];
gout[n*2187+1743] = + s[1743];
gout[n*2187+1744] = + s[1744];
gout[n*2187+1745] = + s[1745];
gout[n*2187+1746] = + s[1746];
gout[n*2187+1747] = + s[1747];
gout[n*2187+1748] = + s[1748];
gout[n*2187+1749] = + s[1749];
gout[n*2187+1750] = + s[1750];
gout[n*2187+1751] = + s[1751];
gout[n*2187+1752] = + s[1752];
gout[n*2187+1753] = + s[1753];
gout[n*2187+1754] = + s[1754];
gout[n*2187+1755] = + s[1755];
gout[n*2187+1756] = + s[1756];
gout[n*2187+1757] = + s[1757];
gout[n*2187+1758] = + s[1758];
gout[n*2187+1759] = + s[1759];
gout[n*2187+1760] = + s[1760];
gout[n*2187+1761] = + s[1761];
gout[n*2187+1762] = + s[1762];
gout[n*2187+1763] = + s[1763];
gout[n*2187+1764] = + s[1764];
gout[n*2187+1765] = + s[1765];
gout[n*2187+1766] = + s[1766];
gout[n*2187+1767] = + s[1767];
gout[n*2187+1768] = + s[1768];
gout[n*2187+1769] = + s[1769];
gout[n*2187+1770] = + s[1770];
gout[n*2187+1771] = + s[1771];
gout[n*2187+1772] = + s[1772];
gout[n*2187+1773] = + s[1773];
gout[n*2187+1774] = + s[1774];
gout[n*2187+1775] = + s[1775];
gout[n*2187+1776] = + s[1776];
gout[n*2187+1777] = + s[1777];
gout[n*2187+1778] = + s[1778];
gout[n*2187+1779] = + s[1779];
gout[n*2187+1780] = + s[1780];
gout[n*2187+1781] = + s[1781];
gout[n*2187+1782] = + s[1782];
gout[n*2187+1783] = + s[1783];
gout[n*2187+1784] = + s[1784];
gout[n*2187+1785] = + s[1785];
gout[n*2187+1786] = + s[1786];
gout[n*2187+1787] = + s[1787];
gout[n*2187+1788] = + s[1788];
gout[n*2187+1789] = + s[1789];
gout[n*2187+1790] = + s[1790];
gout[n*2187+1791] = + s[1791];
gout[n*2187+1792] = + s[1792];
gout[n*2187+1793] = + s[1793];
gout[n*2187+1794] = + s[1794];
gout[n*2187+1795] = + s[1795];
gout[n*2187+1796] = + s[1796];
gout[n*2187+1797] = + s[1797];
gout[n*2187+1798] = + s[1798];
gout[n*2187+1799] = + s[1799];
gout[n*2187+1800] = + s[1800];
gout[n*2187+1801] = + s[1801];
gout[n*2187+1802] = + s[1802];
gout[n*2187+1803] = + s[1803];
gout[n*2187+1804] = + s[1804];
gout[n*2187+1805] = + s[1805];
gout[n*2187+1806] = + s[1806];
gout[n*2187+1807] = + s[1807];
gout[n*2187+1808] = + s[1808];
gout[n*2187+1809] = + s[1809];
gout[n*2187+1810] = + s[1810];
gout[n*2187+1811] = + s[1811];
gout[n*2187+1812] = + s[1812];
gout[n*2187+1813] = + s[1813];
gout[n*2187+1814] = + s[1814];
gout[n*2187+1815] = + s[1815];
gout[n*2187+1816] = + s[1816];
gout[n*2187+1817] = + s[1817];
gout[n*2187+1818] = + s[1818];
gout[n*2187+1819] = + s[1819];
gout[n*2187+1820] = + s[1820];
gout[n*2187+1821] = + s[1821];
gout[n*2187+1822] = + s[1822];
gout[n*2187+1823] = + s[1823];
gout[n*2187+1824] = + s[1824];
gout[n*2187+1825] = + s[1825];
gout[n*2187+1826] = + s[1826];
gout[n*2187+1827] = + s[1827];
gout[n*2187+1828] = + s[1828];
gout[n*2187+1829] = + s[1829];
gout[n*2187+1830] = + s[1830];
gout[n*2187+1831] = + s[1831];
gout[n*2187+1832] = + s[1832];
gout[n*2187+1833] = + s[1833];
gout[n*2187+1834] = + s[1834];
gout[n*2187+1835] = + s[1835];
gout[n*2187+1836] = + s[1836];
gout[n*2187+1837] = + s[1837];
gout[n*2187+1838] = + s[1838];
gout[n*2187+1839] = + s[1839];
gout[n*2187+1840] = + s[1840];
gout[n*2187+1841] = + s[1841];
gout[n*2187+1842] = + s[1842];
gout[n*2187+1843] = + s[1843];
gout[n*2187+1844] = + s[1844];
gout[n*2187+1845] = + s[1845];
gout[n*2187+1846] = + s[1846];
gout[n*2187+1847] = + s[1847];
gout[n*2187+1848] = + s[1848];
gout[n*2187+1849] = + s[1849];
gout[n*2187+1850] = + s[1850];
gout[n*2187+1851] = + s[1851];
gout[n*2187+1852] = + s[1852];
gout[n*2187+1853] = + s[1853];
gout[n*2187+1854] = + s[1854];
gout[n*2187+1855] = + s[1855];
gout[n*2187+1856] = + s[1856];
gout[n*2187+1857] = + s[1857];
gout[n*2187+1858] = + s[1858];
gout[n*2187+1859] = + s[1859];
gout[n*2187+1860] = + s[1860];
gout[n*2187+1861] = + s[1861];
gout[n*2187+1862] = + s[1862];
gout[n*2187+1863] = + s[1863];
gout[n*2187+1864] = + s[1864];
gout[n*2187+1865] = + s[1865];
gout[n*2187+1866] = + s[1866];
gout[n*2187+1867] = + s[1867];
gout[n*2187+1868] = + s[1868];
gout[n*2187+1869] = + s[1869];
gout[n*2187+1870] = + s[1870];
gout[n*2187+1871] = + s[1871];
gout[n*2187+1872] = + s[1872];
gout[n*2187+1873] = + s[1873];
gout[n*2187+1874] = + s[1874];
gout[n*2187+1875] = + s[1875];
gout[n*2187+1876] = + s[1876];
gout[n*2187+1877] = + s[1877];
gout[n*2187+1878] = + s[1878];
gout[n*2187+1879] = + s[1879];
gout[n*2187+1880] = + s[1880];
gout[n*2187+1881] = + s[1881];
gout[n*2187+1882] = + s[1882];
gout[n*2187+1883] = + s[1883];
gout[n*2187+1884] = + s[1884];
gout[n*2187+1885] = + s[1885];
gout[n*2187+1886] = + s[1886];
gout[n*2187+1887] = + s[1887];
gout[n*2187+1888] = + s[1888];
gout[n*2187+1889] = + s[1889];
gout[n*2187+1890] = + s[1890];
gout[n*2187+1891] = + s[1891];
gout[n*2187+1892] = + s[1892];
gout[n*2187+1893] = + s[1893];
gout[n*2187+1894] = + s[1894];
gout[n*2187+1895] = + s[1895];
gout[n*2187+1896] = + s[1896];
gout[n*2187+1897] = + s[1897];
gout[n*2187+1898] = + s[1898];
gout[n*2187+1899] = + s[1899];
gout[n*2187+1900] = + s[1900];
gout[n*2187+1901] = + s[1901];
gout[n*2187+1902] = + s[1902];
gout[n*2187+1903] = + s[1903];
gout[n*2187+1904] = + s[1904];
gout[n*2187+1905] = + s[1905];
gout[n*2187+1906] = + s[1906];
gout[n*2187+1907] = + s[1907];
gout[n*2187+1908] = + s[1908];
gout[n*2187+1909] = + s[1909];
gout[n*2187+1910] = + s[1910];
gout[n*2187+1911] = + s[1911];
gout[n*2187+1912] = + s[1912];
gout[n*2187+1913] = + s[1913];
gout[n*2187+1914] = + s[1914];
gout[n*2187+1915] = + s[1915];
gout[n*2187+1916] = + s[1916];
gout[n*2187+1917] = + s[1917];
gout[n*2187+1918] = + s[1918];
gout[n*2187+1919] = + s[1919];
gout[n*2187+1920] = + s[1920];
gout[n*2187+1921] = + s[1921];
gout[n*2187+1922] = + s[1922];
gout[n*2187+1923] = + s[1923];
gout[n*2187+1924] = + s[1924];
gout[n*2187+1925] = + s[1925];
gout[n*2187+1926] = + s[1926];
gout[n*2187+1927] = + s[1927];
gout[n*2187+1928] = + s[1928];
gout[n*2187+1929] = + s[1929];
gout[n*2187+1930] = + s[1930];
gout[n*2187+1931] = + s[1931];
gout[n*2187+1932] = + s[1932];
gout[n*2187+1933] = + s[1933];
gout[n*2187+1934] = + s[1934];
gout[n*2187+1935] = + s[1935];
gout[n*2187+1936] = + s[1936];
gout[n*2187+1937] = + s[1937];
gout[n*2187+1938] = + s[1938];
gout[n*2187+1939] = + s[1939];
gout[n*2187+1940] = + s[1940];
gout[n*2187+1941] = + s[1941];
gout[n*2187+1942] = + s[1942];
gout[n*2187+1943] = + s[1943];
gout[n*2187+1944] = + s[1944];
gout[n*2187+1945] = + s[1945];
gout[n*2187+1946] = + s[1946];
gout[n*2187+1947] = + s[1947];
gout[n*2187+1948] = + s[1948];
gout[n*2187+1949] = + s[1949];
gout[n*2187+1950] = + s[1950];
gout[n*2187+1951] = + s[1951];
gout[n*2187+1952] = + s[1952];
gout[n*2187+1953] = + s[1953];
gout[n*2187+1954] = + s[1954];
gout[n*2187+1955] = + s[1955];
gout[n*2187+1956] = + s[1956];
gout[n*2187+1957] = + s[1957];
gout[n*2187+1958] = + s[1958];
gout[n*2187+1959] = + s[1959];
gout[n*2187+1960] = + s[1960];
gout[n*2187+1961] = + s[1961];
gout[n*2187+1962] = + s[1962];
gout[n*2187+1963] = + s[1963];
gout[n*2187+1964] = + s[1964];
gout[n*2187+1965] = + s[1965];
gout[n*2187+1966] = + s[1966];
gout[n*2187+1967] = + s[1967];
gout[n*2187+1968] = + s[1968];
gout[n*2187+1969] = + s[1969];
gout[n*2187+1970] = + s[1970];
gout[n*2187+1971] = + s[1971];
gout[n*2187+1972] = + s[1972];
gout[n*2187+1973] = + s[1973];
gout[n*2187+1974] = + s[1974];
gout[n*2187+1975] = + s[1975];
gout[n*2187+1976] = + s[1976];
gout[n*2187+1977] = + s[1977];
gout[n*2187+1978] = + s[1978];
gout[n*2187+1979] = + s[1979];
gout[n*2187+1980] = + s[1980];
gout[n*2187+1981] = + s[1981];
gout[n*2187+1982] = + s[1982];
gout[n*2187+1983] = + s[1983];
gout[n*2187+1984] = + s[1984];
gout[n*2187+1985] = + s[1985];
gout[n*2187+1986] = + s[1986];
gout[n*2187+1987] = + s[1987];
gout[n*2187+1988] = + s[1988];
gout[n*2187+1989] = + s[1989];
gout[n*2187+1990] = + s[1990];
gout[n*2187+1991] = + s[1991];
gout[n*2187+1992] = + s[1992];
gout[n*2187+1993] = + s[1993];
gout[n*2187+1994] = + s[1994];
gout[n*2187+1995] = + s[1995];
gout[n*2187+1996] = + s[1996];
gout[n*2187+1997] = + s[1997];
gout[n*2187+1998] = + s[1998];
gout[n*2187+1999] = + s[1999];
gout[n*2187+2000] = + s[2000];
gout[n*2187+2001] = + s[2001];
gout[n*2187+2002] = + s[2002];
gout[n*2187+2003] = + s[2003];
gout[n*2187+2004] = + s[2004];
gout[n*2187+2005] = + s[2005];
gout[n*2187+2006] = + s[2006];
gout[n*2187+2007] = + s[2007];
gout[n*2187+2008] = + s[2008];
gout[n*2187+2009] = + s[2009];
gout[n*2187+2010] = + s[2010];
gout[n*2187+2011] = + s[2011];
gout[n*2187+2012] = + s[2012];
gout[n*2187+2013] = + s[2013];
gout[n*2187+2014] = + s[2014];
gout[n*2187+2015] = + s[2015];
gout[n*2187+2016] = + s[2016];
gout[n*2187+2017] = + s[2017];
gout[n*2187+2018] = + s[2018];
gout[n*2187+2019] = + s[2019];
gout[n*2187+2020] = + s[2020];
gout[n*2187+2021] = + s[2021];
gout[n*2187+2022] = + s[2022];
gout[n*2187+2023] = + s[2023];
gout[n*2187+2024] = + s[2024];
gout[n*2187+2025] = + s[2025];
gout[n*2187+2026] = + s[2026];
gout[n*2187+2027] = + s[2027];
gout[n*2187+2028] = + s[2028];
gout[n*2187+2029] = + s[2029];
gout[n*2187+2030] = + s[2030];
gout[n*2187+2031] = + s[2031];
gout[n*2187+2032] = + s[2032];
gout[n*2187+2033] = + s[2033];
gout[n*2187+2034] = + s[2034];
gout[n*2187+2035] = + s[2035];
gout[n*2187+2036] = + s[2036];
gout[n*2187+2037] = + s[2037];
gout[n*2187+2038] = + s[2038];
gout[n*2187+2039] = + s[2039];
gout[n*2187+2040] = + s[2040];
gout[n*2187+2041] = + s[2041];
gout[n*2187+2042] = + s[2042];
gout[n*2187+2043] = + s[2043];
gout[n*2187+2044] = + s[2044];
gout[n*2187+2045] = + s[2045];
gout[n*2187+2046] = + s[2046];
gout[n*2187+2047] = + s[2047];
gout[n*2187+2048] = + s[2048];
gout[n*2187+2049] = + s[2049];
gout[n*2187+2050] = + s[2050];
gout[n*2187+2051] = + s[2051];
gout[n*2187+2052] = + s[2052];
gout[n*2187+2053] = + s[2053];
gout[n*2187+2054] = + s[2054];
gout[n*2187+2055] = + s[2055];
gout[n*2187+2056] = + s[2056];
gout[n*2187+2057] = + s[2057];
gout[n*2187+2058] = + s[2058];
gout[n*2187+2059] = + s[2059];
gout[n*2187+2060] = + s[2060];
gout[n*2187+2061] = + s[2061];
gout[n*2187+2062] = + s[2062];
gout[n*2187+2063] = + s[2063];
gout[n*2187+2064] = + s[2064];
gout[n*2187+2065] = + s[2065];
gout[n*2187+2066] = + s[2066];
gout[n*2187+2067] = + s[2067];
gout[n*2187+2068] = + s[2068];
gout[n*2187+2069] = + s[2069];
gout[n*2187+2070] = + s[2070];
gout[n*2187+2071] = + s[2071];
gout[n*2187+2072] = + s[2072];
gout[n*2187+2073] = + s[2073];
gout[n*2187+2074] = + s[2074];
gout[n*2187+2075] = + s[2075];
gout[n*2187+2076] = + s[2076];
gout[n*2187+2077] = + s[2077];
gout[n*2187+2078] = + s[2078];
gout[n*2187+2079] = + s[2079];
gout[n*2187+2080] = + s[2080];
gout[n*2187+2081] = + s[2081];
gout[n*2187+2082] = + s[2082];
gout[n*2187+2083] = + s[2083];
gout[n*2187+2084] = + s[2084];
gout[n*2187+2085] = + s[2085];
gout[n*2187+2086] = + s[2086];
gout[n*2187+2087] = + s[2087];
gout[n*2187+2088] = + s[2088];
gout[n*2187+2089] = + s[2089];
gout[n*2187+2090] = + s[2090];
gout[n*2187+2091] = + s[2091];
gout[n*2187+2092] = + s[2092];
gout[n*2187+2093] = + s[2093];
gout[n*2187+2094] = + s[2094];
gout[n*2187+2095] = + s[2095];
gout[n*2187+2096] = + s[2096];
gout[n*2187+2097] = + s[2097];
gout[n*2187+2098] = + s[2098];
gout[n*2187+2099] = + s[2099];
gout[n*2187+2100] = + s[2100];
gout[n*2187+2101] = + s[2101];
gout[n*2187+2102] = + s[2102];
gout[n*2187+2103] = + s[2103];
gout[n*2187+2104] = + s[2104];
gout[n*2187+2105] = + s[2105];
gout[n*2187+2106] = + s[2106];
gout[n*2187+2107] = + s[2107];
gout[n*2187+2108] = + s[2108];
gout[n*2187+2109] = + s[2109];
gout[n*2187+2110] = + s[2110];
gout[n*2187+2111] = + s[2111];
gout[n*2187+2112] = + s[2112];
gout[n*2187+2113] = + s[2113];
gout[n*2187+2114] = + s[2114];
gout[n*2187+2115] = + s[2115];
gout[n*2187+2116] = + s[2116];
gout[n*2187+2117] = + s[2117];
gout[n*2187+2118] = + s[2118];
gout[n*2187+2119] = + s[2119];
gout[n*2187+2120] = + s[2120];
gout[n*2187+2121] = + s[2121];
gout[n*2187+2122] = + s[2122];
gout[n*2187+2123] = + s[2123];
gout[n*2187+2124] = + s[2124];
gout[n*2187+2125] = + s[2125];
gout[n*2187+2126] = + s[2126];
gout[n*2187+2127] = + s[2127];
gout[n*2187+2128] = + s[2128];
gout[n*2187+2129] = + s[2129];
gout[n*2187+2130] = + s[2130];
gout[n*2187+2131] = + s[2131];
gout[n*2187+2132] = + s[2132];
gout[n*2187+2133] = + s[2133];
gout[n*2187+2134] = + s[2134];
gout[n*2187+2135] = + s[2135];
gout[n*2187+2136] = + s[2136];
gout[n*2187+2137] = + s[2137];
gout[n*2187+2138] = + s[2138];
gout[n*2187+2139] = + s[2139];
gout[n*2187+2140] = + s[2140];
gout[n*2187+2141] = + s[2141];
gout[n*2187+2142] = + s[2142];
gout[n*2187+2143] = + s[2143];
gout[n*2187+2144] = + s[2144];
gout[n*2187+2145] = + s[2145];
gout[n*2187+2146] = + s[2146];
gout[n*2187+2147] = + s[2147];
gout[n*2187+2148] = + s[2148];
gout[n*2187+2149] = + s[2149];
gout[n*2187+2150] = + s[2150];
gout[n*2187+2151] = + s[2151];
gout[n*2187+2152] = + s[2152];
gout[n*2187+2153] = + s[2153];
gout[n*2187+2154] = + s[2154];
gout[n*2187+2155] = + s[2155];
gout[n*2187+2156] = + s[2156];
gout[n*2187+2157] = + s[2157];
gout[n*2187+2158] = + s[2158];
gout[n*2187+2159] = + s[2159];
gout[n*2187+2160] = + s[2160];
gout[n*2187+2161] = + s[2161];
gout[n*2187+2162] = + s[2162];
gout[n*2187+2163] = + s[2163];
gout[n*2187+2164] = + s[2164];
gout[n*2187+2165] = + s[2165];
gout[n*2187+2166] = + s[2166];
gout[n*2187+2167] = + s[2167];
gout[n*2187+2168] = + s[2168];
gout[n*2187+2169] = + s[2169];
gout[n*2187+2170] = + s[2170];
gout[n*2187+2171] = + s[2171];
gout[n*2187+2172] = + s[2172];
gout[n*2187+2173] = + s[2173];
gout[n*2187+2174] = + s[2174];
gout[n*2187+2175] = + s[2175];
gout[n*2187+2176] = + s[2176];
gout[n*2187+2177] = + s[2177];
gout[n*2187+2178] = + s[2178];
gout[n*2187+2179] = + s[2179];
gout[n*2187+2180] = + s[2180];
gout[n*2187+2181] = + s[2181];
gout[n*2187+2182] = + s[2182];
gout[n*2187+2183] = + s[2183];
gout[n*2187+2184] = + s[2184];
gout[n*2187+2185] = + s[2185];
gout[n*2187+2186] = + s[2186];
} else {
gout[n*2187+0] += + s[0];
gout[n*2187+1] += + s[1];
gout[n*2187+2] += + s[2];
gout[n*2187+3] += + s[3];
gout[n*2187+4] += + s[4];
gout[n*2187+5] += + s[5];
gout[n*2187+6] += + s[6];
gout[n*2187+7] += + s[7];
gout[n*2187+8] += + s[8];
gout[n*2187+9] += + s[9];
gout[n*2187+10] += + s[10];
gout[n*2187+11] += + s[11];
gout[n*2187+12] += + s[12];
gout[n*2187+13] += + s[13];
gout[n*2187+14] += + s[14];
gout[n*2187+15] += + s[15];
gout[n*2187+16] += + s[16];
gout[n*2187+17] += + s[17];
gout[n*2187+18] += + s[18];
gout[n*2187+19] += + s[19];
gout[n*2187+20] += + s[20];
gout[n*2187+21] += + s[21];
gout[n*2187+22] += + s[22];
gout[n*2187+23] += + s[23];
gout[n*2187+24] += + s[24];
gout[n*2187+25] += + s[25];
gout[n*2187+26] += + s[26];
gout[n*2187+27] += + s[27];
gout[n*2187+28] += + s[28];
gout[n*2187+29] += + s[29];
gout[n*2187+30] += + s[30];
gout[n*2187+31] += + s[31];
gout[n*2187+32] += + s[32];
gout[n*2187+33] += + s[33];
gout[n*2187+34] += + s[34];
gout[n*2187+35] += + s[35];
gout[n*2187+36] += + s[36];
gout[n*2187+37] += + s[37];
gout[n*2187+38] += + s[38];
gout[n*2187+39] += + s[39];
gout[n*2187+40] += + s[40];
gout[n*2187+41] += + s[41];
gout[n*2187+42] += + s[42];
gout[n*2187+43] += + s[43];
gout[n*2187+44] += + s[44];
gout[n*2187+45] += + s[45];
gout[n*2187+46] += + s[46];
gout[n*2187+47] += + s[47];
gout[n*2187+48] += + s[48];
gout[n*2187+49] += + s[49];
gout[n*2187+50] += + s[50];
gout[n*2187+51] += + s[51];
gout[n*2187+52] += + s[52];
gout[n*2187+53] += + s[53];
gout[n*2187+54] += + s[54];
gout[n*2187+55] += + s[55];
gout[n*2187+56] += + s[56];
gout[n*2187+57] += + s[57];
gout[n*2187+58] += + s[58];
gout[n*2187+59] += + s[59];
gout[n*2187+60] += + s[60];
gout[n*2187+61] += + s[61];
gout[n*2187+62] += + s[62];
gout[n*2187+63] += + s[63];
gout[n*2187+64] += + s[64];
gout[n*2187+65] += + s[65];
gout[n*2187+66] += + s[66];
gout[n*2187+67] += + s[67];
gout[n*2187+68] += + s[68];
gout[n*2187+69] += + s[69];
gout[n*2187+70] += + s[70];
gout[n*2187+71] += + s[71];
gout[n*2187+72] += + s[72];
gout[n*2187+73] += + s[73];
gout[n*2187+74] += + s[74];
gout[n*2187+75] += + s[75];
gout[n*2187+76] += + s[76];
gout[n*2187+77] += + s[77];
gout[n*2187+78] += + s[78];
gout[n*2187+79] += + s[79];
gout[n*2187+80] += + s[80];
gout[n*2187+81] += + s[81];
gout[n*2187+82] += + s[82];
gout[n*2187+83] += + s[83];
gout[n*2187+84] += + s[84];
gout[n*2187+85] += + s[85];
gout[n*2187+86] += + s[86];
gout[n*2187+87] += + s[87];
gout[n*2187+88] += + s[88];
gout[n*2187+89] += + s[89];
gout[n*2187+90] += + s[90];
gout[n*2187+91] += + s[91];
gout[n*2187+92] += + s[92];
gout[n*2187+93] += + s[93];
gout[n*2187+94] += + s[94];
gout[n*2187+95] += + s[95];
gout[n*2187+96] += + s[96];
gout[n*2187+97] += + s[97];
gout[n*2187+98] += + s[98];
gout[n*2187+99] += + s[99];
gout[n*2187+100] += + s[100];
gout[n*2187+101] += + s[101];
gout[n*2187+102] += + s[102];
gout[n*2187+103] += + s[103];
gout[n*2187+104] += + s[104];
gout[n*2187+105] += + s[105];
gout[n*2187+106] += + s[106];
gout[n*2187+107] += + s[107];
gout[n*2187+108] += + s[108];
gout[n*2187+109] += + s[109];
gout[n*2187+110] += + s[110];
gout[n*2187+111] += + s[111];
gout[n*2187+112] += + s[112];
gout[n*2187+113] += + s[113];
gout[n*2187+114] += + s[114];
gout[n*2187+115] += + s[115];
gout[n*2187+116] += + s[116];
gout[n*2187+117] += + s[117];
gout[n*2187+118] += + s[118];
gout[n*2187+119] += + s[119];
gout[n*2187+120] += + s[120];
gout[n*2187+121] += + s[121];
gout[n*2187+122] += + s[122];
gout[n*2187+123] += + s[123];
gout[n*2187+124] += + s[124];
gout[n*2187+125] += + s[125];
gout[n*2187+126] += + s[126];
gout[n*2187+127] += + s[127];
gout[n*2187+128] += + s[128];
gout[n*2187+129] += + s[129];
gout[n*2187+130] += + s[130];
gout[n*2187+131] += + s[131];
gout[n*2187+132] += + s[132];
gout[n*2187+133] += + s[133];
gout[n*2187+134] += + s[134];
gout[n*2187+135] += + s[135];
gout[n*2187+136] += + s[136];
gout[n*2187+137] += + s[137];
gout[n*2187+138] += + s[138];
gout[n*2187+139] += + s[139];
gout[n*2187+140] += + s[140];
gout[n*2187+141] += + s[141];
gout[n*2187+142] += + s[142];
gout[n*2187+143] += + s[143];
gout[n*2187+144] += + s[144];
gout[n*2187+145] += + s[145];
gout[n*2187+146] += + s[146];
gout[n*2187+147] += + s[147];
gout[n*2187+148] += + s[148];
gout[n*2187+149] += + s[149];
gout[n*2187+150] += + s[150];
gout[n*2187+151] += + s[151];
gout[n*2187+152] += + s[152];
gout[n*2187+153] += + s[153];
gout[n*2187+154] += + s[154];
gout[n*2187+155] += + s[155];
gout[n*2187+156] += + s[156];
gout[n*2187+157] += + s[157];
gout[n*2187+158] += + s[158];
gout[n*2187+159] += + s[159];
gout[n*2187+160] += + s[160];
gout[n*2187+161] += + s[161];
gout[n*2187+162] += + s[162];
gout[n*2187+163] += + s[163];
gout[n*2187+164] += + s[164];
gout[n*2187+165] += + s[165];
gout[n*2187+166] += + s[166];
gout[n*2187+167] += + s[167];
gout[n*2187+168] += + s[168];
gout[n*2187+169] += + s[169];
gout[n*2187+170] += + s[170];
gout[n*2187+171] += + s[171];
gout[n*2187+172] += + s[172];
gout[n*2187+173] += + s[173];
gout[n*2187+174] += + s[174];
gout[n*2187+175] += + s[175];
gout[n*2187+176] += + s[176];
gout[n*2187+177] += + s[177];
gout[n*2187+178] += + s[178];
gout[n*2187+179] += + s[179];
gout[n*2187+180] += + s[180];
gout[n*2187+181] += + s[181];
gout[n*2187+182] += + s[182];
gout[n*2187+183] += + s[183];
gout[n*2187+184] += + s[184];
gout[n*2187+185] += + s[185];
gout[n*2187+186] += + s[186];
gout[n*2187+187] += + s[187];
gout[n*2187+188] += + s[188];
gout[n*2187+189] += + s[189];
gout[n*2187+190] += + s[190];
gout[n*2187+191] += + s[191];
gout[n*2187+192] += + s[192];
gout[n*2187+193] += + s[193];
gout[n*2187+194] += + s[194];
gout[n*2187+195] += + s[195];
gout[n*2187+196] += + s[196];
gout[n*2187+197] += + s[197];
gout[n*2187+198] += + s[198];
gout[n*2187+199] += + s[199];
gout[n*2187+200] += + s[200];
gout[n*2187+201] += + s[201];
gout[n*2187+202] += + s[202];
gout[n*2187+203] += + s[203];
gout[n*2187+204] += + s[204];
gout[n*2187+205] += + s[205];
gout[n*2187+206] += + s[206];
gout[n*2187+207] += + s[207];
gout[n*2187+208] += + s[208];
gout[n*2187+209] += + s[209];
gout[n*2187+210] += + s[210];
gout[n*2187+211] += + s[211];
gout[n*2187+212] += + s[212];
gout[n*2187+213] += + s[213];
gout[n*2187+214] += + s[214];
gout[n*2187+215] += + s[215];
gout[n*2187+216] += + s[216];
gout[n*2187+217] += + s[217];
gout[n*2187+218] += + s[218];
gout[n*2187+219] += + s[219];
gout[n*2187+220] += + s[220];
gout[n*2187+221] += + s[221];
gout[n*2187+222] += + s[222];
gout[n*2187+223] += + s[223];
gout[n*2187+224] += + s[224];
gout[n*2187+225] += + s[225];
gout[n*2187+226] += + s[226];
gout[n*2187+227] += + s[227];
gout[n*2187+228] += + s[228];
gout[n*2187+229] += + s[229];
gout[n*2187+230] += + s[230];
gout[n*2187+231] += + s[231];
gout[n*2187+232] += + s[232];
gout[n*2187+233] += + s[233];
gout[n*2187+234] += + s[234];
gout[n*2187+235] += + s[235];
gout[n*2187+236] += + s[236];
gout[n*2187+237] += + s[237];
gout[n*2187+238] += + s[238];
gout[n*2187+239] += + s[239];
gout[n*2187+240] += + s[240];
gout[n*2187+241] += + s[241];
gout[n*2187+242] += + s[242];
gout[n*2187+243] += + s[243];
gout[n*2187+244] += + s[244];
gout[n*2187+245] += + s[245];
gout[n*2187+246] += + s[246];
gout[n*2187+247] += + s[247];
gout[n*2187+248] += + s[248];
gout[n*2187+249] += + s[249];
gout[n*2187+250] += + s[250];
gout[n*2187+251] += + s[251];
gout[n*2187+252] += + s[252];
gout[n*2187+253] += + s[253];
gout[n*2187+254] += + s[254];
gout[n*2187+255] += + s[255];
gout[n*2187+256] += + s[256];
gout[n*2187+257] += + s[257];
gout[n*2187+258] += + s[258];
gout[n*2187+259] += + s[259];
gout[n*2187+260] += + s[260];
gout[n*2187+261] += + s[261];
gout[n*2187+262] += + s[262];
gout[n*2187+263] += + s[263];
gout[n*2187+264] += + s[264];
gout[n*2187+265] += + s[265];
gout[n*2187+266] += + s[266];
gout[n*2187+267] += + s[267];
gout[n*2187+268] += + s[268];
gout[n*2187+269] += + s[269];
gout[n*2187+270] += + s[270];
gout[n*2187+271] += + s[271];
gout[n*2187+272] += + s[272];
gout[n*2187+273] += + s[273];
gout[n*2187+274] += + s[274];
gout[n*2187+275] += + s[275];
gout[n*2187+276] += + s[276];
gout[n*2187+277] += + s[277];
gout[n*2187+278] += + s[278];
gout[n*2187+279] += + s[279];
gout[n*2187+280] += + s[280];
gout[n*2187+281] += + s[281];
gout[n*2187+282] += + s[282];
gout[n*2187+283] += + s[283];
gout[n*2187+284] += + s[284];
gout[n*2187+285] += + s[285];
gout[n*2187+286] += + s[286];
gout[n*2187+287] += + s[287];
gout[n*2187+288] += + s[288];
gout[n*2187+289] += + s[289];
gout[n*2187+290] += + s[290];
gout[n*2187+291] += + s[291];
gout[n*2187+292] += + s[292];
gout[n*2187+293] += + s[293];
gout[n*2187+294] += + s[294];
gout[n*2187+295] += + s[295];
gout[n*2187+296] += + s[296];
gout[n*2187+297] += + s[297];
gout[n*2187+298] += + s[298];
gout[n*2187+299] += + s[299];
gout[n*2187+300] += + s[300];
gout[n*2187+301] += + s[301];
gout[n*2187+302] += + s[302];
gout[n*2187+303] += + s[303];
gout[n*2187+304] += + s[304];
gout[n*2187+305] += + s[305];
gout[n*2187+306] += + s[306];
gout[n*2187+307] += + s[307];
gout[n*2187+308] += + s[308];
gout[n*2187+309] += + s[309];
gout[n*2187+310] += + s[310];
gout[n*2187+311] += + s[311];
gout[n*2187+312] += + s[312];
gout[n*2187+313] += + s[313];
gout[n*2187+314] += + s[314];
gout[n*2187+315] += + s[315];
gout[n*2187+316] += + s[316];
gout[n*2187+317] += + s[317];
gout[n*2187+318] += + s[318];
gout[n*2187+319] += + s[319];
gout[n*2187+320] += + s[320];
gout[n*2187+321] += + s[321];
gout[n*2187+322] += + s[322];
gout[n*2187+323] += + s[323];
gout[n*2187+324] += + s[324];
gout[n*2187+325] += + s[325];
gout[n*2187+326] += + s[326];
gout[n*2187+327] += + s[327];
gout[n*2187+328] += + s[328];
gout[n*2187+329] += + s[329];
gout[n*2187+330] += + s[330];
gout[n*2187+331] += + s[331];
gout[n*2187+332] += + s[332];
gout[n*2187+333] += + s[333];
gout[n*2187+334] += + s[334];
gout[n*2187+335] += + s[335];
gout[n*2187+336] += + s[336];
gout[n*2187+337] += + s[337];
gout[n*2187+338] += + s[338];
gout[n*2187+339] += + s[339];
gout[n*2187+340] += + s[340];
gout[n*2187+341] += + s[341];
gout[n*2187+342] += + s[342];
gout[n*2187+343] += + s[343];
gout[n*2187+344] += + s[344];
gout[n*2187+345] += + s[345];
gout[n*2187+346] += + s[346];
gout[n*2187+347] += + s[347];
gout[n*2187+348] += + s[348];
gout[n*2187+349] += + s[349];
gout[n*2187+350] += + s[350];
gout[n*2187+351] += + s[351];
gout[n*2187+352] += + s[352];
gout[n*2187+353] += + s[353];
gout[n*2187+354] += + s[354];
gout[n*2187+355] += + s[355];
gout[n*2187+356] += + s[356];
gout[n*2187+357] += + s[357];
gout[n*2187+358] += + s[358];
gout[n*2187+359] += + s[359];
gout[n*2187+360] += + s[360];
gout[n*2187+361] += + s[361];
gout[n*2187+362] += + s[362];
gout[n*2187+363] += + s[363];
gout[n*2187+364] += + s[364];
gout[n*2187+365] += + s[365];
gout[n*2187+366] += + s[366];
gout[n*2187+367] += + s[367];
gout[n*2187+368] += + s[368];
gout[n*2187+369] += + s[369];
gout[n*2187+370] += + s[370];
gout[n*2187+371] += + s[371];
gout[n*2187+372] += + s[372];
gout[n*2187+373] += + s[373];
gout[n*2187+374] += + s[374];
gout[n*2187+375] += + s[375];
gout[n*2187+376] += + s[376];
gout[n*2187+377] += + s[377];
gout[n*2187+378] += + s[378];
gout[n*2187+379] += + s[379];
gout[n*2187+380] += + s[380];
gout[n*2187+381] += + s[381];
gout[n*2187+382] += + s[382];
gout[n*2187+383] += + s[383];
gout[n*2187+384] += + s[384];
gout[n*2187+385] += + s[385];
gout[n*2187+386] += + s[386];
gout[n*2187+387] += + s[387];
gout[n*2187+388] += + s[388];
gout[n*2187+389] += + s[389];
gout[n*2187+390] += + s[390];
gout[n*2187+391] += + s[391];
gout[n*2187+392] += + s[392];
gout[n*2187+393] += + s[393];
gout[n*2187+394] += + s[394];
gout[n*2187+395] += + s[395];
gout[n*2187+396] += + s[396];
gout[n*2187+397] += + s[397];
gout[n*2187+398] += + s[398];
gout[n*2187+399] += + s[399];
gout[n*2187+400] += + s[400];
gout[n*2187+401] += + s[401];
gout[n*2187+402] += + s[402];
gout[n*2187+403] += + s[403];
gout[n*2187+404] += + s[404];
gout[n*2187+405] += + s[405];
gout[n*2187+406] += + s[406];
gout[n*2187+407] += + s[407];
gout[n*2187+408] += + s[408];
gout[n*2187+409] += + s[409];
gout[n*2187+410] += + s[410];
gout[n*2187+411] += + s[411];
gout[n*2187+412] += + s[412];
gout[n*2187+413] += + s[413];
gout[n*2187+414] += + s[414];
gout[n*2187+415] += + s[415];
gout[n*2187+416] += + s[416];
gout[n*2187+417] += + s[417];
gout[n*2187+418] += + s[418];
gout[n*2187+419] += + s[419];
gout[n*2187+420] += + s[420];
gout[n*2187+421] += + s[421];
gout[n*2187+422] += + s[422];
gout[n*2187+423] += + s[423];
gout[n*2187+424] += + s[424];
gout[n*2187+425] += + s[425];
gout[n*2187+426] += + s[426];
gout[n*2187+427] += + s[427];
gout[n*2187+428] += + s[428];
gout[n*2187+429] += + s[429];
gout[n*2187+430] += + s[430];
gout[n*2187+431] += + s[431];
gout[n*2187+432] += + s[432];
gout[n*2187+433] += + s[433];
gout[n*2187+434] += + s[434];
gout[n*2187+435] += + s[435];
gout[n*2187+436] += + s[436];
gout[n*2187+437] += + s[437];
gout[n*2187+438] += + s[438];
gout[n*2187+439] += + s[439];
gout[n*2187+440] += + s[440];
gout[n*2187+441] += + s[441];
gout[n*2187+442] += + s[442];
gout[n*2187+443] += + s[443];
gout[n*2187+444] += + s[444];
gout[n*2187+445] += + s[445];
gout[n*2187+446] += + s[446];
gout[n*2187+447] += + s[447];
gout[n*2187+448] += + s[448];
gout[n*2187+449] += + s[449];
gout[n*2187+450] += + s[450];
gout[n*2187+451] += + s[451];
gout[n*2187+452] += + s[452];
gout[n*2187+453] += + s[453];
gout[n*2187+454] += + s[454];
gout[n*2187+455] += + s[455];
gout[n*2187+456] += + s[456];
gout[n*2187+457] += + s[457];
gout[n*2187+458] += + s[458];
gout[n*2187+459] += + s[459];
gout[n*2187+460] += + s[460];
gout[n*2187+461] += + s[461];
gout[n*2187+462] += + s[462];
gout[n*2187+463] += + s[463];
gout[n*2187+464] += + s[464];
gout[n*2187+465] += + s[465];
gout[n*2187+466] += + s[466];
gout[n*2187+467] += + s[467];
gout[n*2187+468] += + s[468];
gout[n*2187+469] += + s[469];
gout[n*2187+470] += + s[470];
gout[n*2187+471] += + s[471];
gout[n*2187+472] += + s[472];
gout[n*2187+473] += + s[473];
gout[n*2187+474] += + s[474];
gout[n*2187+475] += + s[475];
gout[n*2187+476] += + s[476];
gout[n*2187+477] += + s[477];
gout[n*2187+478] += + s[478];
gout[n*2187+479] += + s[479];
gout[n*2187+480] += + s[480];
gout[n*2187+481] += + s[481];
gout[n*2187+482] += + s[482];
gout[n*2187+483] += + s[483];
gout[n*2187+484] += + s[484];
gout[n*2187+485] += + s[485];
gout[n*2187+486] += + s[486];
gout[n*2187+487] += + s[487];
gout[n*2187+488] += + s[488];
gout[n*2187+489] += + s[489];
gout[n*2187+490] += + s[490];
gout[n*2187+491] += + s[491];
gout[n*2187+492] += + s[492];
gout[n*2187+493] += + s[493];
gout[n*2187+494] += + s[494];
gout[n*2187+495] += + s[495];
gout[n*2187+496] += + s[496];
gout[n*2187+497] += + s[497];
gout[n*2187+498] += + s[498];
gout[n*2187+499] += + s[499];
gout[n*2187+500] += + s[500];
gout[n*2187+501] += + s[501];
gout[n*2187+502] += + s[502];
gout[n*2187+503] += + s[503];
gout[n*2187+504] += + s[504];
gout[n*2187+505] += + s[505];
gout[n*2187+506] += + s[506];
gout[n*2187+507] += + s[507];
gout[n*2187+508] += + s[508];
gout[n*2187+509] += + s[509];
gout[n*2187+510] += + s[510];
gout[n*2187+511] += + s[511];
gout[n*2187+512] += + s[512];
gout[n*2187+513] += + s[513];
gout[n*2187+514] += + s[514];
gout[n*2187+515] += + s[515];
gout[n*2187+516] += + s[516];
gout[n*2187+517] += + s[517];
gout[n*2187+518] += + s[518];
gout[n*2187+519] += + s[519];
gout[n*2187+520] += + s[520];
gout[n*2187+521] += + s[521];
gout[n*2187+522] += + s[522];
gout[n*2187+523] += + s[523];
gout[n*2187+524] += + s[524];
gout[n*2187+525] += + s[525];
gout[n*2187+526] += + s[526];
gout[n*2187+527] += + s[527];
gout[n*2187+528] += + s[528];
gout[n*2187+529] += + s[529];
gout[n*2187+530] += + s[530];
gout[n*2187+531] += + s[531];
gout[n*2187+532] += + s[532];
gout[n*2187+533] += + s[533];
gout[n*2187+534] += + s[534];
gout[n*2187+535] += + s[535];
gout[n*2187+536] += + s[536];
gout[n*2187+537] += + s[537];
gout[n*2187+538] += + s[538];
gout[n*2187+539] += + s[539];
gout[n*2187+540] += + s[540];
gout[n*2187+541] += + s[541];
gout[n*2187+542] += + s[542];
gout[n*2187+543] += + s[543];
gout[n*2187+544] += + s[544];
gout[n*2187+545] += + s[545];
gout[n*2187+546] += + s[546];
gout[n*2187+547] += + s[547];
gout[n*2187+548] += + s[548];
gout[n*2187+549] += + s[549];
gout[n*2187+550] += + s[550];
gout[n*2187+551] += + s[551];
gout[n*2187+552] += + s[552];
gout[n*2187+553] += + s[553];
gout[n*2187+554] += + s[554];
gout[n*2187+555] += + s[555];
gout[n*2187+556] += + s[556];
gout[n*2187+557] += + s[557];
gout[n*2187+558] += + s[558];
gout[n*2187+559] += + s[559];
gout[n*2187+560] += + s[560];
gout[n*2187+561] += + s[561];
gout[n*2187+562] += + s[562];
gout[n*2187+563] += + s[563];
gout[n*2187+564] += + s[564];
gout[n*2187+565] += + s[565];
gout[n*2187+566] += + s[566];
gout[n*2187+567] += + s[567];
gout[n*2187+568] += + s[568];
gout[n*2187+569] += + s[569];
gout[n*2187+570] += + s[570];
gout[n*2187+571] += + s[571];
gout[n*2187+572] += + s[572];
gout[n*2187+573] += + s[573];
gout[n*2187+574] += + s[574];
gout[n*2187+575] += + s[575];
gout[n*2187+576] += + s[576];
gout[n*2187+577] += + s[577];
gout[n*2187+578] += + s[578];
gout[n*2187+579] += + s[579];
gout[n*2187+580] += + s[580];
gout[n*2187+581] += + s[581];
gout[n*2187+582] += + s[582];
gout[n*2187+583] += + s[583];
gout[n*2187+584] += + s[584];
gout[n*2187+585] += + s[585];
gout[n*2187+586] += + s[586];
gout[n*2187+587] += + s[587];
gout[n*2187+588] += + s[588];
gout[n*2187+589] += + s[589];
gout[n*2187+590] += + s[590];
gout[n*2187+591] += + s[591];
gout[n*2187+592] += + s[592];
gout[n*2187+593] += + s[593];
gout[n*2187+594] += + s[594];
gout[n*2187+595] += + s[595];
gout[n*2187+596] += + s[596];
gout[n*2187+597] += + s[597];
gout[n*2187+598] += + s[598];
gout[n*2187+599] += + s[599];
gout[n*2187+600] += + s[600];
gout[n*2187+601] += + s[601];
gout[n*2187+602] += + s[602];
gout[n*2187+603] += + s[603];
gout[n*2187+604] += + s[604];
gout[n*2187+605] += + s[605];
gout[n*2187+606] += + s[606];
gout[n*2187+607] += + s[607];
gout[n*2187+608] += + s[608];
gout[n*2187+609] += + s[609];
gout[n*2187+610] += + s[610];
gout[n*2187+611] += + s[611];
gout[n*2187+612] += + s[612];
gout[n*2187+613] += + s[613];
gout[n*2187+614] += + s[614];
gout[n*2187+615] += + s[615];
gout[n*2187+616] += + s[616];
gout[n*2187+617] += + s[617];
gout[n*2187+618] += + s[618];
gout[n*2187+619] += + s[619];
gout[n*2187+620] += + s[620];
gout[n*2187+621] += + s[621];
gout[n*2187+622] += + s[622];
gout[n*2187+623] += + s[623];
gout[n*2187+624] += + s[624];
gout[n*2187+625] += + s[625];
gout[n*2187+626] += + s[626];
gout[n*2187+627] += + s[627];
gout[n*2187+628] += + s[628];
gout[n*2187+629] += + s[629];
gout[n*2187+630] += + s[630];
gout[n*2187+631] += + s[631];
gout[n*2187+632] += + s[632];
gout[n*2187+633] += + s[633];
gout[n*2187+634] += + s[634];
gout[n*2187+635] += + s[635];
gout[n*2187+636] += + s[636];
gout[n*2187+637] += + s[637];
gout[n*2187+638] += + s[638];
gout[n*2187+639] += + s[639];
gout[n*2187+640] += + s[640];
gout[n*2187+641] += + s[641];
gout[n*2187+642] += + s[642];
gout[n*2187+643] += + s[643];
gout[n*2187+644] += + s[644];
gout[n*2187+645] += + s[645];
gout[n*2187+646] += + s[646];
gout[n*2187+647] += + s[647];
gout[n*2187+648] += + s[648];
gout[n*2187+649] += + s[649];
gout[n*2187+650] += + s[650];
gout[n*2187+651] += + s[651];
gout[n*2187+652] += + s[652];
gout[n*2187+653] += + s[653];
gout[n*2187+654] += + s[654];
gout[n*2187+655] += + s[655];
gout[n*2187+656] += + s[656];
gout[n*2187+657] += + s[657];
gout[n*2187+658] += + s[658];
gout[n*2187+659] += + s[659];
gout[n*2187+660] += + s[660];
gout[n*2187+661] += + s[661];
gout[n*2187+662] += + s[662];
gout[n*2187+663] += + s[663];
gout[n*2187+664] += + s[664];
gout[n*2187+665] += + s[665];
gout[n*2187+666] += + s[666];
gout[n*2187+667] += + s[667];
gout[n*2187+668] += + s[668];
gout[n*2187+669] += + s[669];
gout[n*2187+670] += + s[670];
gout[n*2187+671] += + s[671];
gout[n*2187+672] += + s[672];
gout[n*2187+673] += + s[673];
gout[n*2187+674] += + s[674];
gout[n*2187+675] += + s[675];
gout[n*2187+676] += + s[676];
gout[n*2187+677] += + s[677];
gout[n*2187+678] += + s[678];
gout[n*2187+679] += + s[679];
gout[n*2187+680] += + s[680];
gout[n*2187+681] += + s[681];
gout[n*2187+682] += + s[682];
gout[n*2187+683] += + s[683];
gout[n*2187+684] += + s[684];
gout[n*2187+685] += + s[685];
gout[n*2187+686] += + s[686];
gout[n*2187+687] += + s[687];
gout[n*2187+688] += + s[688];
gout[n*2187+689] += + s[689];
gout[n*2187+690] += + s[690];
gout[n*2187+691] += + s[691];
gout[n*2187+692] += + s[692];
gout[n*2187+693] += + s[693];
gout[n*2187+694] += + s[694];
gout[n*2187+695] += + s[695];
gout[n*2187+696] += + s[696];
gout[n*2187+697] += + s[697];
gout[n*2187+698] += + s[698];
gout[n*2187+699] += + s[699];
gout[n*2187+700] += + s[700];
gout[n*2187+701] += + s[701];
gout[n*2187+702] += + s[702];
gout[n*2187+703] += + s[703];
gout[n*2187+704] += + s[704];
gout[n*2187+705] += + s[705];
gout[n*2187+706] += + s[706];
gout[n*2187+707] += + s[707];
gout[n*2187+708] += + s[708];
gout[n*2187+709] += + s[709];
gout[n*2187+710] += + s[710];
gout[n*2187+711] += + s[711];
gout[n*2187+712] += + s[712];
gout[n*2187+713] += + s[713];
gout[n*2187+714] += + s[714];
gout[n*2187+715] += + s[715];
gout[n*2187+716] += + s[716];
gout[n*2187+717] += + s[717];
gout[n*2187+718] += + s[718];
gout[n*2187+719] += + s[719];
gout[n*2187+720] += + s[720];
gout[n*2187+721] += + s[721];
gout[n*2187+722] += + s[722];
gout[n*2187+723] += + s[723];
gout[n*2187+724] += + s[724];
gout[n*2187+725] += + s[725];
gout[n*2187+726] += + s[726];
gout[n*2187+727] += + s[727];
gout[n*2187+728] += + s[728];
gout[n*2187+729] += + s[729];
gout[n*2187+730] += + s[730];
gout[n*2187+731] += + s[731];
gout[n*2187+732] += + s[732];
gout[n*2187+733] += + s[733];
gout[n*2187+734] += + s[734];
gout[n*2187+735] += + s[735];
gout[n*2187+736] += + s[736];
gout[n*2187+737] += + s[737];
gout[n*2187+738] += + s[738];
gout[n*2187+739] += + s[739];
gout[n*2187+740] += + s[740];
gout[n*2187+741] += + s[741];
gout[n*2187+742] += + s[742];
gout[n*2187+743] += + s[743];
gout[n*2187+744] += + s[744];
gout[n*2187+745] += + s[745];
gout[n*2187+746] += + s[746];
gout[n*2187+747] += + s[747];
gout[n*2187+748] += + s[748];
gout[n*2187+749] += + s[749];
gout[n*2187+750] += + s[750];
gout[n*2187+751] += + s[751];
gout[n*2187+752] += + s[752];
gout[n*2187+753] += + s[753];
gout[n*2187+754] += + s[754];
gout[n*2187+755] += + s[755];
gout[n*2187+756] += + s[756];
gout[n*2187+757] += + s[757];
gout[n*2187+758] += + s[758];
gout[n*2187+759] += + s[759];
gout[n*2187+760] += + s[760];
gout[n*2187+761] += + s[761];
gout[n*2187+762] += + s[762];
gout[n*2187+763] += + s[763];
gout[n*2187+764] += + s[764];
gout[n*2187+765] += + s[765];
gout[n*2187+766] += + s[766];
gout[n*2187+767] += + s[767];
gout[n*2187+768] += + s[768];
gout[n*2187+769] += + s[769];
gout[n*2187+770] += + s[770];
gout[n*2187+771] += + s[771];
gout[n*2187+772] += + s[772];
gout[n*2187+773] += + s[773];
gout[n*2187+774] += + s[774];
gout[n*2187+775] += + s[775];
gout[n*2187+776] += + s[776];
gout[n*2187+777] += + s[777];
gout[n*2187+778] += + s[778];
gout[n*2187+779] += + s[779];
gout[n*2187+780] += + s[780];
gout[n*2187+781] += + s[781];
gout[n*2187+782] += + s[782];
gout[n*2187+783] += + s[783];
gout[n*2187+784] += + s[784];
gout[n*2187+785] += + s[785];
gout[n*2187+786] += + s[786];
gout[n*2187+787] += + s[787];
gout[n*2187+788] += + s[788];
gout[n*2187+789] += + s[789];
gout[n*2187+790] += + s[790];
gout[n*2187+791] += + s[791];
gout[n*2187+792] += + s[792];
gout[n*2187+793] += + s[793];
gout[n*2187+794] += + s[794];
gout[n*2187+795] += + s[795];
gout[n*2187+796] += + s[796];
gout[n*2187+797] += + s[797];
gout[n*2187+798] += + s[798];
gout[n*2187+799] += + s[799];
gout[n*2187+800] += + s[800];
gout[n*2187+801] += + s[801];
gout[n*2187+802] += + s[802];
gout[n*2187+803] += + s[803];
gout[n*2187+804] += + s[804];
gout[n*2187+805] += + s[805];
gout[n*2187+806] += + s[806];
gout[n*2187+807] += + s[807];
gout[n*2187+808] += + s[808];
gout[n*2187+809] += + s[809];
gout[n*2187+810] += + s[810];
gout[n*2187+811] += + s[811];
gout[n*2187+812] += + s[812];
gout[n*2187+813] += + s[813];
gout[n*2187+814] += + s[814];
gout[n*2187+815] += + s[815];
gout[n*2187+816] += + s[816];
gout[n*2187+817] += + s[817];
gout[n*2187+818] += + s[818];
gout[n*2187+819] += + s[819];
gout[n*2187+820] += + s[820];
gout[n*2187+821] += + s[821];
gout[n*2187+822] += + s[822];
gout[n*2187+823] += + s[823];
gout[n*2187+824] += + s[824];
gout[n*2187+825] += + s[825];
gout[n*2187+826] += + s[826];
gout[n*2187+827] += + s[827];
gout[n*2187+828] += + s[828];
gout[n*2187+829] += + s[829];
gout[n*2187+830] += + s[830];
gout[n*2187+831] += + s[831];
gout[n*2187+832] += + s[832];
gout[n*2187+833] += + s[833];
gout[n*2187+834] += + s[834];
gout[n*2187+835] += + s[835];
gout[n*2187+836] += + s[836];
gout[n*2187+837] += + s[837];
gout[n*2187+838] += + s[838];
gout[n*2187+839] += + s[839];
gout[n*2187+840] += + s[840];
gout[n*2187+841] += + s[841];
gout[n*2187+842] += + s[842];
gout[n*2187+843] += + s[843];
gout[n*2187+844] += + s[844];
gout[n*2187+845] += + s[845];
gout[n*2187+846] += + s[846];
gout[n*2187+847] += + s[847];
gout[n*2187+848] += + s[848];
gout[n*2187+849] += + s[849];
gout[n*2187+850] += + s[850];
gout[n*2187+851] += + s[851];
gout[n*2187+852] += + s[852];
gout[n*2187+853] += + s[853];
gout[n*2187+854] += + s[854];
gout[n*2187+855] += + s[855];
gout[n*2187+856] += + s[856];
gout[n*2187+857] += + s[857];
gout[n*2187+858] += + s[858];
gout[n*2187+859] += + s[859];
gout[n*2187+860] += + s[860];
gout[n*2187+861] += + s[861];
gout[n*2187+862] += + s[862];
gout[n*2187+863] += + s[863];
gout[n*2187+864] += + s[864];
gout[n*2187+865] += + s[865];
gout[n*2187+866] += + s[866];
gout[n*2187+867] += + s[867];
gout[n*2187+868] += + s[868];
gout[n*2187+869] += + s[869];
gout[n*2187+870] += + s[870];
gout[n*2187+871] += + s[871];
gout[n*2187+872] += + s[872];
gout[n*2187+873] += + s[873];
gout[n*2187+874] += + s[874];
gout[n*2187+875] += + s[875];
gout[n*2187+876] += + s[876];
gout[n*2187+877] += + s[877];
gout[n*2187+878] += + s[878];
gout[n*2187+879] += + s[879];
gout[n*2187+880] += + s[880];
gout[n*2187+881] += + s[881];
gout[n*2187+882] += + s[882];
gout[n*2187+883] += + s[883];
gout[n*2187+884] += + s[884];
gout[n*2187+885] += + s[885];
gout[n*2187+886] += + s[886];
gout[n*2187+887] += + s[887];
gout[n*2187+888] += + s[888];
gout[n*2187+889] += + s[889];
gout[n*2187+890] += + s[890];
gout[n*2187+891] += + s[891];
gout[n*2187+892] += + s[892];
gout[n*2187+893] += + s[893];
gout[n*2187+894] += + s[894];
gout[n*2187+895] += + s[895];
gout[n*2187+896] += + s[896];
gout[n*2187+897] += + s[897];
gout[n*2187+898] += + s[898];
gout[n*2187+899] += + s[899];
gout[n*2187+900] += + s[900];
gout[n*2187+901] += + s[901];
gout[n*2187+902] += + s[902];
gout[n*2187+903] += + s[903];
gout[n*2187+904] += + s[904];
gout[n*2187+905] += + s[905];
gout[n*2187+906] += + s[906];
gout[n*2187+907] += + s[907];
gout[n*2187+908] += + s[908];
gout[n*2187+909] += + s[909];
gout[n*2187+910] += + s[910];
gout[n*2187+911] += + s[911];
gout[n*2187+912] += + s[912];
gout[n*2187+913] += + s[913];
gout[n*2187+914] += + s[914];
gout[n*2187+915] += + s[915];
gout[n*2187+916] += + s[916];
gout[n*2187+917] += + s[917];
gout[n*2187+918] += + s[918];
gout[n*2187+919] += + s[919];
gout[n*2187+920] += + s[920];
gout[n*2187+921] += + s[921];
gout[n*2187+922] += + s[922];
gout[n*2187+923] += + s[923];
gout[n*2187+924] += + s[924];
gout[n*2187+925] += + s[925];
gout[n*2187+926] += + s[926];
gout[n*2187+927] += + s[927];
gout[n*2187+928] += + s[928];
gout[n*2187+929] += + s[929];
gout[n*2187+930] += + s[930];
gout[n*2187+931] += + s[931];
gout[n*2187+932] += + s[932];
gout[n*2187+933] += + s[933];
gout[n*2187+934] += + s[934];
gout[n*2187+935] += + s[935];
gout[n*2187+936] += + s[936];
gout[n*2187+937] += + s[937];
gout[n*2187+938] += + s[938];
gout[n*2187+939] += + s[939];
gout[n*2187+940] += + s[940];
gout[n*2187+941] += + s[941];
gout[n*2187+942] += + s[942];
gout[n*2187+943] += + s[943];
gout[n*2187+944] += + s[944];
gout[n*2187+945] += + s[945];
gout[n*2187+946] += + s[946];
gout[n*2187+947] += + s[947];
gout[n*2187+948] += + s[948];
gout[n*2187+949] += + s[949];
gout[n*2187+950] += + s[950];
gout[n*2187+951] += + s[951];
gout[n*2187+952] += + s[952];
gout[n*2187+953] += + s[953];
gout[n*2187+954] += + s[954];
gout[n*2187+955] += + s[955];
gout[n*2187+956] += + s[956];
gout[n*2187+957] += + s[957];
gout[n*2187+958] += + s[958];
gout[n*2187+959] += + s[959];
gout[n*2187+960] += + s[960];
gout[n*2187+961] += + s[961];
gout[n*2187+962] += + s[962];
gout[n*2187+963] += + s[963];
gout[n*2187+964] += + s[964];
gout[n*2187+965] += + s[965];
gout[n*2187+966] += + s[966];
gout[n*2187+967] += + s[967];
gout[n*2187+968] += + s[968];
gout[n*2187+969] += + s[969];
gout[n*2187+970] += + s[970];
gout[n*2187+971] += + s[971];
gout[n*2187+972] += + s[972];
gout[n*2187+973] += + s[973];
gout[n*2187+974] += + s[974];
gout[n*2187+975] += + s[975];
gout[n*2187+976] += + s[976];
gout[n*2187+977] += + s[977];
gout[n*2187+978] += + s[978];
gout[n*2187+979] += + s[979];
gout[n*2187+980] += + s[980];
gout[n*2187+981] += + s[981];
gout[n*2187+982] += + s[982];
gout[n*2187+983] += + s[983];
gout[n*2187+984] += + s[984];
gout[n*2187+985] += + s[985];
gout[n*2187+986] += + s[986];
gout[n*2187+987] += + s[987];
gout[n*2187+988] += + s[988];
gout[n*2187+989] += + s[989];
gout[n*2187+990] += + s[990];
gout[n*2187+991] += + s[991];
gout[n*2187+992] += + s[992];
gout[n*2187+993] += + s[993];
gout[n*2187+994] += + s[994];
gout[n*2187+995] += + s[995];
gout[n*2187+996] += + s[996];
gout[n*2187+997] += + s[997];
gout[n*2187+998] += + s[998];
gout[n*2187+999] += + s[999];
gout[n*2187+1000] += + s[1000];
gout[n*2187+1001] += + s[1001];
gout[n*2187+1002] += + s[1002];
gout[n*2187+1003] += + s[1003];
gout[n*2187+1004] += + s[1004];
gout[n*2187+1005] += + s[1005];
gout[n*2187+1006] += + s[1006];
gout[n*2187+1007] += + s[1007];
gout[n*2187+1008] += + s[1008];
gout[n*2187+1009] += + s[1009];
gout[n*2187+1010] += + s[1010];
gout[n*2187+1011] += + s[1011];
gout[n*2187+1012] += + s[1012];
gout[n*2187+1013] += + s[1013];
gout[n*2187+1014] += + s[1014];
gout[n*2187+1015] += + s[1015];
gout[n*2187+1016] += + s[1016];
gout[n*2187+1017] += + s[1017];
gout[n*2187+1018] += + s[1018];
gout[n*2187+1019] += + s[1019];
gout[n*2187+1020] += + s[1020];
gout[n*2187+1021] += + s[1021];
gout[n*2187+1022] += + s[1022];
gout[n*2187+1023] += + s[1023];
gout[n*2187+1024] += + s[1024];
gout[n*2187+1025] += + s[1025];
gout[n*2187+1026] += + s[1026];
gout[n*2187+1027] += + s[1027];
gout[n*2187+1028] += + s[1028];
gout[n*2187+1029] += + s[1029];
gout[n*2187+1030] += + s[1030];
gout[n*2187+1031] += + s[1031];
gout[n*2187+1032] += + s[1032];
gout[n*2187+1033] += + s[1033];
gout[n*2187+1034] += + s[1034];
gout[n*2187+1035] += + s[1035];
gout[n*2187+1036] += + s[1036];
gout[n*2187+1037] += + s[1037];
gout[n*2187+1038] += + s[1038];
gout[n*2187+1039] += + s[1039];
gout[n*2187+1040] += + s[1040];
gout[n*2187+1041] += + s[1041];
gout[n*2187+1042] += + s[1042];
gout[n*2187+1043] += + s[1043];
gout[n*2187+1044] += + s[1044];
gout[n*2187+1045] += + s[1045];
gout[n*2187+1046] += + s[1046];
gout[n*2187+1047] += + s[1047];
gout[n*2187+1048] += + s[1048];
gout[n*2187+1049] += + s[1049];
gout[n*2187+1050] += + s[1050];
gout[n*2187+1051] += + s[1051];
gout[n*2187+1052] += + s[1052];
gout[n*2187+1053] += + s[1053];
gout[n*2187+1054] += + s[1054];
gout[n*2187+1055] += + s[1055];
gout[n*2187+1056] += + s[1056];
gout[n*2187+1057] += + s[1057];
gout[n*2187+1058] += + s[1058];
gout[n*2187+1059] += + s[1059];
gout[n*2187+1060] += + s[1060];
gout[n*2187+1061] += + s[1061];
gout[n*2187+1062] += + s[1062];
gout[n*2187+1063] += + s[1063];
gout[n*2187+1064] += + s[1064];
gout[n*2187+1065] += + s[1065];
gout[n*2187+1066] += + s[1066];
gout[n*2187+1067] += + s[1067];
gout[n*2187+1068] += + s[1068];
gout[n*2187+1069] += + s[1069];
gout[n*2187+1070] += + s[1070];
gout[n*2187+1071] += + s[1071];
gout[n*2187+1072] += + s[1072];
gout[n*2187+1073] += + s[1073];
gout[n*2187+1074] += + s[1074];
gout[n*2187+1075] += + s[1075];
gout[n*2187+1076] += + s[1076];
gout[n*2187+1077] += + s[1077];
gout[n*2187+1078] += + s[1078];
gout[n*2187+1079] += + s[1079];
gout[n*2187+1080] += + s[1080];
gout[n*2187+1081] += + s[1081];
gout[n*2187+1082] += + s[1082];
gout[n*2187+1083] += + s[1083];
gout[n*2187+1084] += + s[1084];
gout[n*2187+1085] += + s[1085];
gout[n*2187+1086] += + s[1086];
gout[n*2187+1087] += + s[1087];
gout[n*2187+1088] += + s[1088];
gout[n*2187+1089] += + s[1089];
gout[n*2187+1090] += + s[1090];
gout[n*2187+1091] += + s[1091];
gout[n*2187+1092] += + s[1092];
gout[n*2187+1093] += + s[1093];
gout[n*2187+1094] += + s[1094];
gout[n*2187+1095] += + s[1095];
gout[n*2187+1096] += + s[1096];
gout[n*2187+1097] += + s[1097];
gout[n*2187+1098] += + s[1098];
gout[n*2187+1099] += + s[1099];
gout[n*2187+1100] += + s[1100];
gout[n*2187+1101] += + s[1101];
gout[n*2187+1102] += + s[1102];
gout[n*2187+1103] += + s[1103];
gout[n*2187+1104] += + s[1104];
gout[n*2187+1105] += + s[1105];
gout[n*2187+1106] += + s[1106];
gout[n*2187+1107] += + s[1107];
gout[n*2187+1108] += + s[1108];
gout[n*2187+1109] += + s[1109];
gout[n*2187+1110] += + s[1110];
gout[n*2187+1111] += + s[1111];
gout[n*2187+1112] += + s[1112];
gout[n*2187+1113] += + s[1113];
gout[n*2187+1114] += + s[1114];
gout[n*2187+1115] += + s[1115];
gout[n*2187+1116] += + s[1116];
gout[n*2187+1117] += + s[1117];
gout[n*2187+1118] += + s[1118];
gout[n*2187+1119] += + s[1119];
gout[n*2187+1120] += + s[1120];
gout[n*2187+1121] += + s[1121];
gout[n*2187+1122] += + s[1122];
gout[n*2187+1123] += + s[1123];
gout[n*2187+1124] += + s[1124];
gout[n*2187+1125] += + s[1125];
gout[n*2187+1126] += + s[1126];
gout[n*2187+1127] += + s[1127];
gout[n*2187+1128] += + s[1128];
gout[n*2187+1129] += + s[1129];
gout[n*2187+1130] += + s[1130];
gout[n*2187+1131] += + s[1131];
gout[n*2187+1132] += + s[1132];
gout[n*2187+1133] += + s[1133];
gout[n*2187+1134] += + s[1134];
gout[n*2187+1135] += + s[1135];
gout[n*2187+1136] += + s[1136];
gout[n*2187+1137] += + s[1137];
gout[n*2187+1138] += + s[1138];
gout[n*2187+1139] += + s[1139];
gout[n*2187+1140] += + s[1140];
gout[n*2187+1141] += + s[1141];
gout[n*2187+1142] += + s[1142];
gout[n*2187+1143] += + s[1143];
gout[n*2187+1144] += + s[1144];
gout[n*2187+1145] += + s[1145];
gout[n*2187+1146] += + s[1146];
gout[n*2187+1147] += + s[1147];
gout[n*2187+1148] += + s[1148];
gout[n*2187+1149] += + s[1149];
gout[n*2187+1150] += + s[1150];
gout[n*2187+1151] += + s[1151];
gout[n*2187+1152] += + s[1152];
gout[n*2187+1153] += + s[1153];
gout[n*2187+1154] += + s[1154];
gout[n*2187+1155] += + s[1155];
gout[n*2187+1156] += + s[1156];
gout[n*2187+1157] += + s[1157];
gout[n*2187+1158] += + s[1158];
gout[n*2187+1159] += + s[1159];
gout[n*2187+1160] += + s[1160];
gout[n*2187+1161] += + s[1161];
gout[n*2187+1162] += + s[1162];
gout[n*2187+1163] += + s[1163];
gout[n*2187+1164] += + s[1164];
gout[n*2187+1165] += + s[1165];
gout[n*2187+1166] += + s[1166];
gout[n*2187+1167] += + s[1167];
gout[n*2187+1168] += + s[1168];
gout[n*2187+1169] += + s[1169];
gout[n*2187+1170] += + s[1170];
gout[n*2187+1171] += + s[1171];
gout[n*2187+1172] += + s[1172];
gout[n*2187+1173] += + s[1173];
gout[n*2187+1174] += + s[1174];
gout[n*2187+1175] += + s[1175];
gout[n*2187+1176] += + s[1176];
gout[n*2187+1177] += + s[1177];
gout[n*2187+1178] += + s[1178];
gout[n*2187+1179] += + s[1179];
gout[n*2187+1180] += + s[1180];
gout[n*2187+1181] += + s[1181];
gout[n*2187+1182] += + s[1182];
gout[n*2187+1183] += + s[1183];
gout[n*2187+1184] += + s[1184];
gout[n*2187+1185] += + s[1185];
gout[n*2187+1186] += + s[1186];
gout[n*2187+1187] += + s[1187];
gout[n*2187+1188] += + s[1188];
gout[n*2187+1189] += + s[1189];
gout[n*2187+1190] += + s[1190];
gout[n*2187+1191] += + s[1191];
gout[n*2187+1192] += + s[1192];
gout[n*2187+1193] += + s[1193];
gout[n*2187+1194] += + s[1194];
gout[n*2187+1195] += + s[1195];
gout[n*2187+1196] += + s[1196];
gout[n*2187+1197] += + s[1197];
gout[n*2187+1198] += + s[1198];
gout[n*2187+1199] += + s[1199];
gout[n*2187+1200] += + s[1200];
gout[n*2187+1201] += + s[1201];
gout[n*2187+1202] += + s[1202];
gout[n*2187+1203] += + s[1203];
gout[n*2187+1204] += + s[1204];
gout[n*2187+1205] += + s[1205];
gout[n*2187+1206] += + s[1206];
gout[n*2187+1207] += + s[1207];
gout[n*2187+1208] += + s[1208];
gout[n*2187+1209] += + s[1209];
gout[n*2187+1210] += + s[1210];
gout[n*2187+1211] += + s[1211];
gout[n*2187+1212] += + s[1212];
gout[n*2187+1213] += + s[1213];
gout[n*2187+1214] += + s[1214];
gout[n*2187+1215] += + s[1215];
gout[n*2187+1216] += + s[1216];
gout[n*2187+1217] += + s[1217];
gout[n*2187+1218] += + s[1218];
gout[n*2187+1219] += + s[1219];
gout[n*2187+1220] += + s[1220];
gout[n*2187+1221] += + s[1221];
gout[n*2187+1222] += + s[1222];
gout[n*2187+1223] += + s[1223];
gout[n*2187+1224] += + s[1224];
gout[n*2187+1225] += + s[1225];
gout[n*2187+1226] += + s[1226];
gout[n*2187+1227] += + s[1227];
gout[n*2187+1228] += + s[1228];
gout[n*2187+1229] += + s[1229];
gout[n*2187+1230] += + s[1230];
gout[n*2187+1231] += + s[1231];
gout[n*2187+1232] += + s[1232];
gout[n*2187+1233] += + s[1233];
gout[n*2187+1234] += + s[1234];
gout[n*2187+1235] += + s[1235];
gout[n*2187+1236] += + s[1236];
gout[n*2187+1237] += + s[1237];
gout[n*2187+1238] += + s[1238];
gout[n*2187+1239] += + s[1239];
gout[n*2187+1240] += + s[1240];
gout[n*2187+1241] += + s[1241];
gout[n*2187+1242] += + s[1242];
gout[n*2187+1243] += + s[1243];
gout[n*2187+1244] += + s[1244];
gout[n*2187+1245] += + s[1245];
gout[n*2187+1246] += + s[1246];
gout[n*2187+1247] += + s[1247];
gout[n*2187+1248] += + s[1248];
gout[n*2187+1249] += + s[1249];
gout[n*2187+1250] += + s[1250];
gout[n*2187+1251] += + s[1251];
gout[n*2187+1252] += + s[1252];
gout[n*2187+1253] += + s[1253];
gout[n*2187+1254] += + s[1254];
gout[n*2187+1255] += + s[1255];
gout[n*2187+1256] += + s[1256];
gout[n*2187+1257] += + s[1257];
gout[n*2187+1258] += + s[1258];
gout[n*2187+1259] += + s[1259];
gout[n*2187+1260] += + s[1260];
gout[n*2187+1261] += + s[1261];
gout[n*2187+1262] += + s[1262];
gout[n*2187+1263] += + s[1263];
gout[n*2187+1264] += + s[1264];
gout[n*2187+1265] += + s[1265];
gout[n*2187+1266] += + s[1266];
gout[n*2187+1267] += + s[1267];
gout[n*2187+1268] += + s[1268];
gout[n*2187+1269] += + s[1269];
gout[n*2187+1270] += + s[1270];
gout[n*2187+1271] += + s[1271];
gout[n*2187+1272] += + s[1272];
gout[n*2187+1273] += + s[1273];
gout[n*2187+1274] += + s[1274];
gout[n*2187+1275] += + s[1275];
gout[n*2187+1276] += + s[1276];
gout[n*2187+1277] += + s[1277];
gout[n*2187+1278] += + s[1278];
gout[n*2187+1279] += + s[1279];
gout[n*2187+1280] += + s[1280];
gout[n*2187+1281] += + s[1281];
gout[n*2187+1282] += + s[1282];
gout[n*2187+1283] += + s[1283];
gout[n*2187+1284] += + s[1284];
gout[n*2187+1285] += + s[1285];
gout[n*2187+1286] += + s[1286];
gout[n*2187+1287] += + s[1287];
gout[n*2187+1288] += + s[1288];
gout[n*2187+1289] += + s[1289];
gout[n*2187+1290] += + s[1290];
gout[n*2187+1291] += + s[1291];
gout[n*2187+1292] += + s[1292];
gout[n*2187+1293] += + s[1293];
gout[n*2187+1294] += + s[1294];
gout[n*2187+1295] += + s[1295];
gout[n*2187+1296] += + s[1296];
gout[n*2187+1297] += + s[1297];
gout[n*2187+1298] += + s[1298];
gout[n*2187+1299] += + s[1299];
gout[n*2187+1300] += + s[1300];
gout[n*2187+1301] += + s[1301];
gout[n*2187+1302] += + s[1302];
gout[n*2187+1303] += + s[1303];
gout[n*2187+1304] += + s[1304];
gout[n*2187+1305] += + s[1305];
gout[n*2187+1306] += + s[1306];
gout[n*2187+1307] += + s[1307];
gout[n*2187+1308] += + s[1308];
gout[n*2187+1309] += + s[1309];
gout[n*2187+1310] += + s[1310];
gout[n*2187+1311] += + s[1311];
gout[n*2187+1312] += + s[1312];
gout[n*2187+1313] += + s[1313];
gout[n*2187+1314] += + s[1314];
gout[n*2187+1315] += + s[1315];
gout[n*2187+1316] += + s[1316];
gout[n*2187+1317] += + s[1317];
gout[n*2187+1318] += + s[1318];
gout[n*2187+1319] += + s[1319];
gout[n*2187+1320] += + s[1320];
gout[n*2187+1321] += + s[1321];
gout[n*2187+1322] += + s[1322];
gout[n*2187+1323] += + s[1323];
gout[n*2187+1324] += + s[1324];
gout[n*2187+1325] += + s[1325];
gout[n*2187+1326] += + s[1326];
gout[n*2187+1327] += + s[1327];
gout[n*2187+1328] += + s[1328];
gout[n*2187+1329] += + s[1329];
gout[n*2187+1330] += + s[1330];
gout[n*2187+1331] += + s[1331];
gout[n*2187+1332] += + s[1332];
gout[n*2187+1333] += + s[1333];
gout[n*2187+1334] += + s[1334];
gout[n*2187+1335] += + s[1335];
gout[n*2187+1336] += + s[1336];
gout[n*2187+1337] += + s[1337];
gout[n*2187+1338] += + s[1338];
gout[n*2187+1339] += + s[1339];
gout[n*2187+1340] += + s[1340];
gout[n*2187+1341] += + s[1341];
gout[n*2187+1342] += + s[1342];
gout[n*2187+1343] += + s[1343];
gout[n*2187+1344] += + s[1344];
gout[n*2187+1345] += + s[1345];
gout[n*2187+1346] += + s[1346];
gout[n*2187+1347] += + s[1347];
gout[n*2187+1348] += + s[1348];
gout[n*2187+1349] += + s[1349];
gout[n*2187+1350] += + s[1350];
gout[n*2187+1351] += + s[1351];
gout[n*2187+1352] += + s[1352];
gout[n*2187+1353] += + s[1353];
gout[n*2187+1354] += + s[1354];
gout[n*2187+1355] += + s[1355];
gout[n*2187+1356] += + s[1356];
gout[n*2187+1357] += + s[1357];
gout[n*2187+1358] += + s[1358];
gout[n*2187+1359] += + s[1359];
gout[n*2187+1360] += + s[1360];
gout[n*2187+1361] += + s[1361];
gout[n*2187+1362] += + s[1362];
gout[n*2187+1363] += + s[1363];
gout[n*2187+1364] += + s[1364];
gout[n*2187+1365] += + s[1365];
gout[n*2187+1366] += + s[1366];
gout[n*2187+1367] += + s[1367];
gout[n*2187+1368] += + s[1368];
gout[n*2187+1369] += + s[1369];
gout[n*2187+1370] += + s[1370];
gout[n*2187+1371] += + s[1371];
gout[n*2187+1372] += + s[1372];
gout[n*2187+1373] += + s[1373];
gout[n*2187+1374] += + s[1374];
gout[n*2187+1375] += + s[1375];
gout[n*2187+1376] += + s[1376];
gout[n*2187+1377] += + s[1377];
gout[n*2187+1378] += + s[1378];
gout[n*2187+1379] += + s[1379];
gout[n*2187+1380] += + s[1380];
gout[n*2187+1381] += + s[1381];
gout[n*2187+1382] += + s[1382];
gout[n*2187+1383] += + s[1383];
gout[n*2187+1384] += + s[1384];
gout[n*2187+1385] += + s[1385];
gout[n*2187+1386] += + s[1386];
gout[n*2187+1387] += + s[1387];
gout[n*2187+1388] += + s[1388];
gout[n*2187+1389] += + s[1389];
gout[n*2187+1390] += + s[1390];
gout[n*2187+1391] += + s[1391];
gout[n*2187+1392] += + s[1392];
gout[n*2187+1393] += + s[1393];
gout[n*2187+1394] += + s[1394];
gout[n*2187+1395] += + s[1395];
gout[n*2187+1396] += + s[1396];
gout[n*2187+1397] += + s[1397];
gout[n*2187+1398] += + s[1398];
gout[n*2187+1399] += + s[1399];
gout[n*2187+1400] += + s[1400];
gout[n*2187+1401] += + s[1401];
gout[n*2187+1402] += + s[1402];
gout[n*2187+1403] += + s[1403];
gout[n*2187+1404] += + s[1404];
gout[n*2187+1405] += + s[1405];
gout[n*2187+1406] += + s[1406];
gout[n*2187+1407] += + s[1407];
gout[n*2187+1408] += + s[1408];
gout[n*2187+1409] += + s[1409];
gout[n*2187+1410] += + s[1410];
gout[n*2187+1411] += + s[1411];
gout[n*2187+1412] += + s[1412];
gout[n*2187+1413] += + s[1413];
gout[n*2187+1414] += + s[1414];
gout[n*2187+1415] += + s[1415];
gout[n*2187+1416] += + s[1416];
gout[n*2187+1417] += + s[1417];
gout[n*2187+1418] += + s[1418];
gout[n*2187+1419] += + s[1419];
gout[n*2187+1420] += + s[1420];
gout[n*2187+1421] += + s[1421];
gout[n*2187+1422] += + s[1422];
gout[n*2187+1423] += + s[1423];
gout[n*2187+1424] += + s[1424];
gout[n*2187+1425] += + s[1425];
gout[n*2187+1426] += + s[1426];
gout[n*2187+1427] += + s[1427];
gout[n*2187+1428] += + s[1428];
gout[n*2187+1429] += + s[1429];
gout[n*2187+1430] += + s[1430];
gout[n*2187+1431] += + s[1431];
gout[n*2187+1432] += + s[1432];
gout[n*2187+1433] += + s[1433];
gout[n*2187+1434] += + s[1434];
gout[n*2187+1435] += + s[1435];
gout[n*2187+1436] += + s[1436];
gout[n*2187+1437] += + s[1437];
gout[n*2187+1438] += + s[1438];
gout[n*2187+1439] += + s[1439];
gout[n*2187+1440] += + s[1440];
gout[n*2187+1441] += + s[1441];
gout[n*2187+1442] += + s[1442];
gout[n*2187+1443] += + s[1443];
gout[n*2187+1444] += + s[1444];
gout[n*2187+1445] += + s[1445];
gout[n*2187+1446] += + s[1446];
gout[n*2187+1447] += + s[1447];
gout[n*2187+1448] += + s[1448];
gout[n*2187+1449] += + s[1449];
gout[n*2187+1450] += + s[1450];
gout[n*2187+1451] += + s[1451];
gout[n*2187+1452] += + s[1452];
gout[n*2187+1453] += + s[1453];
gout[n*2187+1454] += + s[1454];
gout[n*2187+1455] += + s[1455];
gout[n*2187+1456] += + s[1456];
gout[n*2187+1457] += + s[1457];
gout[n*2187+1458] += + s[1458];
gout[n*2187+1459] += + s[1459];
gout[n*2187+1460] += + s[1460];
gout[n*2187+1461] += + s[1461];
gout[n*2187+1462] += + s[1462];
gout[n*2187+1463] += + s[1463];
gout[n*2187+1464] += + s[1464];
gout[n*2187+1465] += + s[1465];
gout[n*2187+1466] += + s[1466];
gout[n*2187+1467] += + s[1467];
gout[n*2187+1468] += + s[1468];
gout[n*2187+1469] += + s[1469];
gout[n*2187+1470] += + s[1470];
gout[n*2187+1471] += + s[1471];
gout[n*2187+1472] += + s[1472];
gout[n*2187+1473] += + s[1473];
gout[n*2187+1474] += + s[1474];
gout[n*2187+1475] += + s[1475];
gout[n*2187+1476] += + s[1476];
gout[n*2187+1477] += + s[1477];
gout[n*2187+1478] += + s[1478];
gout[n*2187+1479] += + s[1479];
gout[n*2187+1480] += + s[1480];
gout[n*2187+1481] += + s[1481];
gout[n*2187+1482] += + s[1482];
gout[n*2187+1483] += + s[1483];
gout[n*2187+1484] += + s[1484];
gout[n*2187+1485] += + s[1485];
gout[n*2187+1486] += + s[1486];
gout[n*2187+1487] += + s[1487];
gout[n*2187+1488] += + s[1488];
gout[n*2187+1489] += + s[1489];
gout[n*2187+1490] += + s[1490];
gout[n*2187+1491] += + s[1491];
gout[n*2187+1492] += + s[1492];
gout[n*2187+1493] += + s[1493];
gout[n*2187+1494] += + s[1494];
gout[n*2187+1495] += + s[1495];
gout[n*2187+1496] += + s[1496];
gout[n*2187+1497] += + s[1497];
gout[n*2187+1498] += + s[1498];
gout[n*2187+1499] += + s[1499];
gout[n*2187+1500] += + s[1500];
gout[n*2187+1501] += + s[1501];
gout[n*2187+1502] += + s[1502];
gout[n*2187+1503] += + s[1503];
gout[n*2187+1504] += + s[1504];
gout[n*2187+1505] += + s[1505];
gout[n*2187+1506] += + s[1506];
gout[n*2187+1507] += + s[1507];
gout[n*2187+1508] += + s[1508];
gout[n*2187+1509] += + s[1509];
gout[n*2187+1510] += + s[1510];
gout[n*2187+1511] += + s[1511];
gout[n*2187+1512] += + s[1512];
gout[n*2187+1513] += + s[1513];
gout[n*2187+1514] += + s[1514];
gout[n*2187+1515] += + s[1515];
gout[n*2187+1516] += + s[1516];
gout[n*2187+1517] += + s[1517];
gout[n*2187+1518] += + s[1518];
gout[n*2187+1519] += + s[1519];
gout[n*2187+1520] += + s[1520];
gout[n*2187+1521] += + s[1521];
gout[n*2187+1522] += + s[1522];
gout[n*2187+1523] += + s[1523];
gout[n*2187+1524] += + s[1524];
gout[n*2187+1525] += + s[1525];
gout[n*2187+1526] += + s[1526];
gout[n*2187+1527] += + s[1527];
gout[n*2187+1528] += + s[1528];
gout[n*2187+1529] += + s[1529];
gout[n*2187+1530] += + s[1530];
gout[n*2187+1531] += + s[1531];
gout[n*2187+1532] += + s[1532];
gout[n*2187+1533] += + s[1533];
gout[n*2187+1534] += + s[1534];
gout[n*2187+1535] += + s[1535];
gout[n*2187+1536] += + s[1536];
gout[n*2187+1537] += + s[1537];
gout[n*2187+1538] += + s[1538];
gout[n*2187+1539] += + s[1539];
gout[n*2187+1540] += + s[1540];
gout[n*2187+1541] += + s[1541];
gout[n*2187+1542] += + s[1542];
gout[n*2187+1543] += + s[1543];
gout[n*2187+1544] += + s[1544];
gout[n*2187+1545] += + s[1545];
gout[n*2187+1546] += + s[1546];
gout[n*2187+1547] += + s[1547];
gout[n*2187+1548] += + s[1548];
gout[n*2187+1549] += + s[1549];
gout[n*2187+1550] += + s[1550];
gout[n*2187+1551] += + s[1551];
gout[n*2187+1552] += + s[1552];
gout[n*2187+1553] += + s[1553];
gout[n*2187+1554] += + s[1554];
gout[n*2187+1555] += + s[1555];
gout[n*2187+1556] += + s[1556];
gout[n*2187+1557] += + s[1557];
gout[n*2187+1558] += + s[1558];
gout[n*2187+1559] += + s[1559];
gout[n*2187+1560] += + s[1560];
gout[n*2187+1561] += + s[1561];
gout[n*2187+1562] += + s[1562];
gout[n*2187+1563] += + s[1563];
gout[n*2187+1564] += + s[1564];
gout[n*2187+1565] += + s[1565];
gout[n*2187+1566] += + s[1566];
gout[n*2187+1567] += + s[1567];
gout[n*2187+1568] += + s[1568];
gout[n*2187+1569] += + s[1569];
gout[n*2187+1570] += + s[1570];
gout[n*2187+1571] += + s[1571];
gout[n*2187+1572] += + s[1572];
gout[n*2187+1573] += + s[1573];
gout[n*2187+1574] += + s[1574];
gout[n*2187+1575] += + s[1575];
gout[n*2187+1576] += + s[1576];
gout[n*2187+1577] += + s[1577];
gout[n*2187+1578] += + s[1578];
gout[n*2187+1579] += + s[1579];
gout[n*2187+1580] += + s[1580];
gout[n*2187+1581] += + s[1581];
gout[n*2187+1582] += + s[1582];
gout[n*2187+1583] += + s[1583];
gout[n*2187+1584] += + s[1584];
gout[n*2187+1585] += + s[1585];
gout[n*2187+1586] += + s[1586];
gout[n*2187+1587] += + s[1587];
gout[n*2187+1588] += + s[1588];
gout[n*2187+1589] += + s[1589];
gout[n*2187+1590] += + s[1590];
gout[n*2187+1591] += + s[1591];
gout[n*2187+1592] += + s[1592];
gout[n*2187+1593] += + s[1593];
gout[n*2187+1594] += + s[1594];
gout[n*2187+1595] += + s[1595];
gout[n*2187+1596] += + s[1596];
gout[n*2187+1597] += + s[1597];
gout[n*2187+1598] += + s[1598];
gout[n*2187+1599] += + s[1599];
gout[n*2187+1600] += + s[1600];
gout[n*2187+1601] += + s[1601];
gout[n*2187+1602] += + s[1602];
gout[n*2187+1603] += + s[1603];
gout[n*2187+1604] += + s[1604];
gout[n*2187+1605] += + s[1605];
gout[n*2187+1606] += + s[1606];
gout[n*2187+1607] += + s[1607];
gout[n*2187+1608] += + s[1608];
gout[n*2187+1609] += + s[1609];
gout[n*2187+1610] += + s[1610];
gout[n*2187+1611] += + s[1611];
gout[n*2187+1612] += + s[1612];
gout[n*2187+1613] += + s[1613];
gout[n*2187+1614] += + s[1614];
gout[n*2187+1615] += + s[1615];
gout[n*2187+1616] += + s[1616];
gout[n*2187+1617] += + s[1617];
gout[n*2187+1618] += + s[1618];
gout[n*2187+1619] += + s[1619];
gout[n*2187+1620] += + s[1620];
gout[n*2187+1621] += + s[1621];
gout[n*2187+1622] += + s[1622];
gout[n*2187+1623] += + s[1623];
gout[n*2187+1624] += + s[1624];
gout[n*2187+1625] += + s[1625];
gout[n*2187+1626] += + s[1626];
gout[n*2187+1627] += + s[1627];
gout[n*2187+1628] += + s[1628];
gout[n*2187+1629] += + s[1629];
gout[n*2187+1630] += + s[1630];
gout[n*2187+1631] += + s[1631];
gout[n*2187+1632] += + s[1632];
gout[n*2187+1633] += + s[1633];
gout[n*2187+1634] += + s[1634];
gout[n*2187+1635] += + s[1635];
gout[n*2187+1636] += + s[1636];
gout[n*2187+1637] += + s[1637];
gout[n*2187+1638] += + s[1638];
gout[n*2187+1639] += + s[1639];
gout[n*2187+1640] += + s[1640];
gout[n*2187+1641] += + s[1641];
gout[n*2187+1642] += + s[1642];
gout[n*2187+1643] += + s[1643];
gout[n*2187+1644] += + s[1644];
gout[n*2187+1645] += + s[1645];
gout[n*2187+1646] += + s[1646];
gout[n*2187+1647] += + s[1647];
gout[n*2187+1648] += + s[1648];
gout[n*2187+1649] += + s[1649];
gout[n*2187+1650] += + s[1650];
gout[n*2187+1651] += + s[1651];
gout[n*2187+1652] += + s[1652];
gout[n*2187+1653] += + s[1653];
gout[n*2187+1654] += + s[1654];
gout[n*2187+1655] += + s[1655];
gout[n*2187+1656] += + s[1656];
gout[n*2187+1657] += + s[1657];
gout[n*2187+1658] += + s[1658];
gout[n*2187+1659] += + s[1659];
gout[n*2187+1660] += + s[1660];
gout[n*2187+1661] += + s[1661];
gout[n*2187+1662] += + s[1662];
gout[n*2187+1663] += + s[1663];
gout[n*2187+1664] += + s[1664];
gout[n*2187+1665] += + s[1665];
gout[n*2187+1666] += + s[1666];
gout[n*2187+1667] += + s[1667];
gout[n*2187+1668] += + s[1668];
gout[n*2187+1669] += + s[1669];
gout[n*2187+1670] += + s[1670];
gout[n*2187+1671] += + s[1671];
gout[n*2187+1672] += + s[1672];
gout[n*2187+1673] += + s[1673];
gout[n*2187+1674] += + s[1674];
gout[n*2187+1675] += + s[1675];
gout[n*2187+1676] += + s[1676];
gout[n*2187+1677] += + s[1677];
gout[n*2187+1678] += + s[1678];
gout[n*2187+1679] += + s[1679];
gout[n*2187+1680] += + s[1680];
gout[n*2187+1681] += + s[1681];
gout[n*2187+1682] += + s[1682];
gout[n*2187+1683] += + s[1683];
gout[n*2187+1684] += + s[1684];
gout[n*2187+1685] += + s[1685];
gout[n*2187+1686] += + s[1686];
gout[n*2187+1687] += + s[1687];
gout[n*2187+1688] += + s[1688];
gout[n*2187+1689] += + s[1689];
gout[n*2187+1690] += + s[1690];
gout[n*2187+1691] += + s[1691];
gout[n*2187+1692] += + s[1692];
gout[n*2187+1693] += + s[1693];
gout[n*2187+1694] += + s[1694];
gout[n*2187+1695] += + s[1695];
gout[n*2187+1696] += + s[1696];
gout[n*2187+1697] += + s[1697];
gout[n*2187+1698] += + s[1698];
gout[n*2187+1699] += + s[1699];
gout[n*2187+1700] += + s[1700];
gout[n*2187+1701] += + s[1701];
gout[n*2187+1702] += + s[1702];
gout[n*2187+1703] += + s[1703];
gout[n*2187+1704] += + s[1704];
gout[n*2187+1705] += + s[1705];
gout[n*2187+1706] += + s[1706];
gout[n*2187+1707] += + s[1707];
gout[n*2187+1708] += + s[1708];
gout[n*2187+1709] += + s[1709];
gout[n*2187+1710] += + s[1710];
gout[n*2187+1711] += + s[1711];
gout[n*2187+1712] += + s[1712];
gout[n*2187+1713] += + s[1713];
gout[n*2187+1714] += + s[1714];
gout[n*2187+1715] += + s[1715];
gout[n*2187+1716] += + s[1716];
gout[n*2187+1717] += + s[1717];
gout[n*2187+1718] += + s[1718];
gout[n*2187+1719] += + s[1719];
gout[n*2187+1720] += + s[1720];
gout[n*2187+1721] += + s[1721];
gout[n*2187+1722] += + s[1722];
gout[n*2187+1723] += + s[1723];
gout[n*2187+1724] += + s[1724];
gout[n*2187+1725] += + s[1725];
gout[n*2187+1726] += + s[1726];
gout[n*2187+1727] += + s[1727];
gout[n*2187+1728] += + s[1728];
gout[n*2187+1729] += + s[1729];
gout[n*2187+1730] += + s[1730];
gout[n*2187+1731] += + s[1731];
gout[n*2187+1732] += + s[1732];
gout[n*2187+1733] += + s[1733];
gout[n*2187+1734] += + s[1734];
gout[n*2187+1735] += + s[1735];
gout[n*2187+1736] += + s[1736];
gout[n*2187+1737] += + s[1737];
gout[n*2187+1738] += + s[1738];
gout[n*2187+1739] += + s[1739];
gout[n*2187+1740] += + s[1740];
gout[n*2187+1741] += + s[1741];
gout[n*2187+1742] += + s[1742];
gout[n*2187+1743] += + s[1743];
gout[n*2187+1744] += + s[1744];
gout[n*2187+1745] += + s[1745];
gout[n*2187+1746] += + s[1746];
gout[n*2187+1747] += + s[1747];
gout[n*2187+1748] += + s[1748];
gout[n*2187+1749] += + s[1749];
gout[n*2187+1750] += + s[1750];
gout[n*2187+1751] += + s[1751];
gout[n*2187+1752] += + s[1752];
gout[n*2187+1753] += + s[1753];
gout[n*2187+1754] += + s[1754];
gout[n*2187+1755] += + s[1755];
gout[n*2187+1756] += + s[1756];
gout[n*2187+1757] += + s[1757];
gout[n*2187+1758] += + s[1758];
gout[n*2187+1759] += + s[1759];
gout[n*2187+1760] += + s[1760];
gout[n*2187+1761] += + s[1761];
gout[n*2187+1762] += + s[1762];
gout[n*2187+1763] += + s[1763];
gout[n*2187+1764] += + s[1764];
gout[n*2187+1765] += + s[1765];
gout[n*2187+1766] += + s[1766];
gout[n*2187+1767] += + s[1767];
gout[n*2187+1768] += + s[1768];
gout[n*2187+1769] += + s[1769];
gout[n*2187+1770] += + s[1770];
gout[n*2187+1771] += + s[1771];
gout[n*2187+1772] += + s[1772];
gout[n*2187+1773] += + s[1773];
gout[n*2187+1774] += + s[1774];
gout[n*2187+1775] += + s[1775];
gout[n*2187+1776] += + s[1776];
gout[n*2187+1777] += + s[1777];
gout[n*2187+1778] += + s[1778];
gout[n*2187+1779] += + s[1779];
gout[n*2187+1780] += + s[1780];
gout[n*2187+1781] += + s[1781];
gout[n*2187+1782] += + s[1782];
gout[n*2187+1783] += + s[1783];
gout[n*2187+1784] += + s[1784];
gout[n*2187+1785] += + s[1785];
gout[n*2187+1786] += + s[1786];
gout[n*2187+1787] += + s[1787];
gout[n*2187+1788] += + s[1788];
gout[n*2187+1789] += + s[1789];
gout[n*2187+1790] += + s[1790];
gout[n*2187+1791] += + s[1791];
gout[n*2187+1792] += + s[1792];
gout[n*2187+1793] += + s[1793];
gout[n*2187+1794] += + s[1794];
gout[n*2187+1795] += + s[1795];
gout[n*2187+1796] += + s[1796];
gout[n*2187+1797] += + s[1797];
gout[n*2187+1798] += + s[1798];
gout[n*2187+1799] += + s[1799];
gout[n*2187+1800] += + s[1800];
gout[n*2187+1801] += + s[1801];
gout[n*2187+1802] += + s[1802];
gout[n*2187+1803] += + s[1803];
gout[n*2187+1804] += + s[1804];
gout[n*2187+1805] += + s[1805];
gout[n*2187+1806] += + s[1806];
gout[n*2187+1807] += + s[1807];
gout[n*2187+1808] += + s[1808];
gout[n*2187+1809] += + s[1809];
gout[n*2187+1810] += + s[1810];
gout[n*2187+1811] += + s[1811];
gout[n*2187+1812] += + s[1812];
gout[n*2187+1813] += + s[1813];
gout[n*2187+1814] += + s[1814];
gout[n*2187+1815] += + s[1815];
gout[n*2187+1816] += + s[1816];
gout[n*2187+1817] += + s[1817];
gout[n*2187+1818] += + s[1818];
gout[n*2187+1819] += + s[1819];
gout[n*2187+1820] += + s[1820];
gout[n*2187+1821] += + s[1821];
gout[n*2187+1822] += + s[1822];
gout[n*2187+1823] += + s[1823];
gout[n*2187+1824] += + s[1824];
gout[n*2187+1825] += + s[1825];
gout[n*2187+1826] += + s[1826];
gout[n*2187+1827] += + s[1827];
gout[n*2187+1828] += + s[1828];
gout[n*2187+1829] += + s[1829];
gout[n*2187+1830] += + s[1830];
gout[n*2187+1831] += + s[1831];
gout[n*2187+1832] += + s[1832];
gout[n*2187+1833] += + s[1833];
gout[n*2187+1834] += + s[1834];
gout[n*2187+1835] += + s[1835];
gout[n*2187+1836] += + s[1836];
gout[n*2187+1837] += + s[1837];
gout[n*2187+1838] += + s[1838];
gout[n*2187+1839] += + s[1839];
gout[n*2187+1840] += + s[1840];
gout[n*2187+1841] += + s[1841];
gout[n*2187+1842] += + s[1842];
gout[n*2187+1843] += + s[1843];
gout[n*2187+1844] += + s[1844];
gout[n*2187+1845] += + s[1845];
gout[n*2187+1846] += + s[1846];
gout[n*2187+1847] += + s[1847];
gout[n*2187+1848] += + s[1848];
gout[n*2187+1849] += + s[1849];
gout[n*2187+1850] += + s[1850];
gout[n*2187+1851] += + s[1851];
gout[n*2187+1852] += + s[1852];
gout[n*2187+1853] += + s[1853];
gout[n*2187+1854] += + s[1854];
gout[n*2187+1855] += + s[1855];
gout[n*2187+1856] += + s[1856];
gout[n*2187+1857] += + s[1857];
gout[n*2187+1858] += + s[1858];
gout[n*2187+1859] += + s[1859];
gout[n*2187+1860] += + s[1860];
gout[n*2187+1861] += + s[1861];
gout[n*2187+1862] += + s[1862];
gout[n*2187+1863] += + s[1863];
gout[n*2187+1864] += + s[1864];
gout[n*2187+1865] += + s[1865];
gout[n*2187+1866] += + s[1866];
gout[n*2187+1867] += + s[1867];
gout[n*2187+1868] += + s[1868];
gout[n*2187+1869] += + s[1869];
gout[n*2187+1870] += + s[1870];
gout[n*2187+1871] += + s[1871];
gout[n*2187+1872] += + s[1872];
gout[n*2187+1873] += + s[1873];
gout[n*2187+1874] += + s[1874];
gout[n*2187+1875] += + s[1875];
gout[n*2187+1876] += + s[1876];
gout[n*2187+1877] += + s[1877];
gout[n*2187+1878] += + s[1878];
gout[n*2187+1879] += + s[1879];
gout[n*2187+1880] += + s[1880];
gout[n*2187+1881] += + s[1881];
gout[n*2187+1882] += + s[1882];
gout[n*2187+1883] += + s[1883];
gout[n*2187+1884] += + s[1884];
gout[n*2187+1885] += + s[1885];
gout[n*2187+1886] += + s[1886];
gout[n*2187+1887] += + s[1887];
gout[n*2187+1888] += + s[1888];
gout[n*2187+1889] += + s[1889];
gout[n*2187+1890] += + s[1890];
gout[n*2187+1891] += + s[1891];
gout[n*2187+1892] += + s[1892];
gout[n*2187+1893] += + s[1893];
gout[n*2187+1894] += + s[1894];
gout[n*2187+1895] += + s[1895];
gout[n*2187+1896] += + s[1896];
gout[n*2187+1897] += + s[1897];
gout[n*2187+1898] += + s[1898];
gout[n*2187+1899] += + s[1899];
gout[n*2187+1900] += + s[1900];
gout[n*2187+1901] += + s[1901];
gout[n*2187+1902] += + s[1902];
gout[n*2187+1903] += + s[1903];
gout[n*2187+1904] += + s[1904];
gout[n*2187+1905] += + s[1905];
gout[n*2187+1906] += + s[1906];
gout[n*2187+1907] += + s[1907];
gout[n*2187+1908] += + s[1908];
gout[n*2187+1909] += + s[1909];
gout[n*2187+1910] += + s[1910];
gout[n*2187+1911] += + s[1911];
gout[n*2187+1912] += + s[1912];
gout[n*2187+1913] += + s[1913];
gout[n*2187+1914] += + s[1914];
gout[n*2187+1915] += + s[1915];
gout[n*2187+1916] += + s[1916];
gout[n*2187+1917] += + s[1917];
gout[n*2187+1918] += + s[1918];
gout[n*2187+1919] += + s[1919];
gout[n*2187+1920] += + s[1920];
gout[n*2187+1921] += + s[1921];
gout[n*2187+1922] += + s[1922];
gout[n*2187+1923] += + s[1923];
gout[n*2187+1924] += + s[1924];
gout[n*2187+1925] += + s[1925];
gout[n*2187+1926] += + s[1926];
gout[n*2187+1927] += + s[1927];
gout[n*2187+1928] += + s[1928];
gout[n*2187+1929] += + s[1929];
gout[n*2187+1930] += + s[1930];
gout[n*2187+1931] += + s[1931];
gout[n*2187+1932] += + s[1932];
gout[n*2187+1933] += + s[1933];
gout[n*2187+1934] += + s[1934];
gout[n*2187+1935] += + s[1935];
gout[n*2187+1936] += + s[1936];
gout[n*2187+1937] += + s[1937];
gout[n*2187+1938] += + s[1938];
gout[n*2187+1939] += + s[1939];
gout[n*2187+1940] += + s[1940];
gout[n*2187+1941] += + s[1941];
gout[n*2187+1942] += + s[1942];
gout[n*2187+1943] += + s[1943];
gout[n*2187+1944] += + s[1944];
gout[n*2187+1945] += + s[1945];
gout[n*2187+1946] += + s[1946];
gout[n*2187+1947] += + s[1947];
gout[n*2187+1948] += + s[1948];
gout[n*2187+1949] += + s[1949];
gout[n*2187+1950] += + s[1950];
gout[n*2187+1951] += + s[1951];
gout[n*2187+1952] += + s[1952];
gout[n*2187+1953] += + s[1953];
gout[n*2187+1954] += + s[1954];
gout[n*2187+1955] += + s[1955];
gout[n*2187+1956] += + s[1956];
gout[n*2187+1957] += + s[1957];
gout[n*2187+1958] += + s[1958];
gout[n*2187+1959] += + s[1959];
gout[n*2187+1960] += + s[1960];
gout[n*2187+1961] += + s[1961];
gout[n*2187+1962] += + s[1962];
gout[n*2187+1963] += + s[1963];
gout[n*2187+1964] += + s[1964];
gout[n*2187+1965] += + s[1965];
gout[n*2187+1966] += + s[1966];
gout[n*2187+1967] += + s[1967];
gout[n*2187+1968] += + s[1968];
gout[n*2187+1969] += + s[1969];
gout[n*2187+1970] += + s[1970];
gout[n*2187+1971] += + s[1971];
gout[n*2187+1972] += + s[1972];
gout[n*2187+1973] += + s[1973];
gout[n*2187+1974] += + s[1974];
gout[n*2187+1975] += + s[1975];
gout[n*2187+1976] += + s[1976];
gout[n*2187+1977] += + s[1977];
gout[n*2187+1978] += + s[1978];
gout[n*2187+1979] += + s[1979];
gout[n*2187+1980] += + s[1980];
gout[n*2187+1981] += + s[1981];
gout[n*2187+1982] += + s[1982];
gout[n*2187+1983] += + s[1983];
gout[n*2187+1984] += + s[1984];
gout[n*2187+1985] += + s[1985];
gout[n*2187+1986] += + s[1986];
gout[n*2187+1987] += + s[1987];
gout[n*2187+1988] += + s[1988];
gout[n*2187+1989] += + s[1989];
gout[n*2187+1990] += + s[1990];
gout[n*2187+1991] += + s[1991];
gout[n*2187+1992] += + s[1992];
gout[n*2187+1993] += + s[1993];
gout[n*2187+1994] += + s[1994];
gout[n*2187+1995] += + s[1995];
gout[n*2187+1996] += + s[1996];
gout[n*2187+1997] += + s[1997];
gout[n*2187+1998] += + s[1998];
gout[n*2187+1999] += + s[1999];
gout[n*2187+2000] += + s[2000];
gout[n*2187+2001] += + s[2001];
gout[n*2187+2002] += + s[2002];
gout[n*2187+2003] += + s[2003];
gout[n*2187+2004] += + s[2004];
gout[n*2187+2005] += + s[2005];
gout[n*2187+2006] += + s[2006];
gout[n*2187+2007] += + s[2007];
gout[n*2187+2008] += + s[2008];
gout[n*2187+2009] += + s[2009];
gout[n*2187+2010] += + s[2010];
gout[n*2187+2011] += + s[2011];
gout[n*2187+2012] += + s[2012];
gout[n*2187+2013] += + s[2013];
gout[n*2187+2014] += + s[2014];
gout[n*2187+2015] += + s[2015];
gout[n*2187+2016] += + s[2016];
gout[n*2187+2017] += + s[2017];
gout[n*2187+2018] += + s[2018];
gout[n*2187+2019] += + s[2019];
gout[n*2187+2020] += + s[2020];
gout[n*2187+2021] += + s[2021];
gout[n*2187+2022] += + s[2022];
gout[n*2187+2023] += + s[2023];
gout[n*2187+2024] += + s[2024];
gout[n*2187+2025] += + s[2025];
gout[n*2187+2026] += + s[2026];
gout[n*2187+2027] += + s[2027];
gout[n*2187+2028] += + s[2028];
gout[n*2187+2029] += + s[2029];
gout[n*2187+2030] += + s[2030];
gout[n*2187+2031] += + s[2031];
gout[n*2187+2032] += + s[2032];
gout[n*2187+2033] += + s[2033];
gout[n*2187+2034] += + s[2034];
gout[n*2187+2035] += + s[2035];
gout[n*2187+2036] += + s[2036];
gout[n*2187+2037] += + s[2037];
gout[n*2187+2038] += + s[2038];
gout[n*2187+2039] += + s[2039];
gout[n*2187+2040] += + s[2040];
gout[n*2187+2041] += + s[2041];
gout[n*2187+2042] += + s[2042];
gout[n*2187+2043] += + s[2043];
gout[n*2187+2044] += + s[2044];
gout[n*2187+2045] += + s[2045];
gout[n*2187+2046] += + s[2046];
gout[n*2187+2047] += + s[2047];
gout[n*2187+2048] += + s[2048];
gout[n*2187+2049] += + s[2049];
gout[n*2187+2050] += + s[2050];
gout[n*2187+2051] += + s[2051];
gout[n*2187+2052] += + s[2052];
gout[n*2187+2053] += + s[2053];
gout[n*2187+2054] += + s[2054];
gout[n*2187+2055] += + s[2055];
gout[n*2187+2056] += + s[2056];
gout[n*2187+2057] += + s[2057];
gout[n*2187+2058] += + s[2058];
gout[n*2187+2059] += + s[2059];
gout[n*2187+2060] += + s[2060];
gout[n*2187+2061] += + s[2061];
gout[n*2187+2062] += + s[2062];
gout[n*2187+2063] += + s[2063];
gout[n*2187+2064] += + s[2064];
gout[n*2187+2065] += + s[2065];
gout[n*2187+2066] += + s[2066];
gout[n*2187+2067] += + s[2067];
gout[n*2187+2068] += + s[2068];
gout[n*2187+2069] += + s[2069];
gout[n*2187+2070] += + s[2070];
gout[n*2187+2071] += + s[2071];
gout[n*2187+2072] += + s[2072];
gout[n*2187+2073] += + s[2073];
gout[n*2187+2074] += + s[2074];
gout[n*2187+2075] += + s[2075];
gout[n*2187+2076] += + s[2076];
gout[n*2187+2077] += + s[2077];
gout[n*2187+2078] += + s[2078];
gout[n*2187+2079] += + s[2079];
gout[n*2187+2080] += + s[2080];
gout[n*2187+2081] += + s[2081];
gout[n*2187+2082] += + s[2082];
gout[n*2187+2083] += + s[2083];
gout[n*2187+2084] += + s[2084];
gout[n*2187+2085] += + s[2085];
gout[n*2187+2086] += + s[2086];
gout[n*2187+2087] += + s[2087];
gout[n*2187+2088] += + s[2088];
gout[n*2187+2089] += + s[2089];
gout[n*2187+2090] += + s[2090];
gout[n*2187+2091] += + s[2091];
gout[n*2187+2092] += + s[2092];
gout[n*2187+2093] += + s[2093];
gout[n*2187+2094] += + s[2094];
gout[n*2187+2095] += + s[2095];
gout[n*2187+2096] += + s[2096];
gout[n*2187+2097] += + s[2097];
gout[n*2187+2098] += + s[2098];
gout[n*2187+2099] += + s[2099];
gout[n*2187+2100] += + s[2100];
gout[n*2187+2101] += + s[2101];
gout[n*2187+2102] += + s[2102];
gout[n*2187+2103] += + s[2103];
gout[n*2187+2104] += + s[2104];
gout[n*2187+2105] += + s[2105];
gout[n*2187+2106] += + s[2106];
gout[n*2187+2107] += + s[2107];
gout[n*2187+2108] += + s[2108];
gout[n*2187+2109] += + s[2109];
gout[n*2187+2110] += + s[2110];
gout[n*2187+2111] += + s[2111];
gout[n*2187+2112] += + s[2112];
gout[n*2187+2113] += + s[2113];
gout[n*2187+2114] += + s[2114];
gout[n*2187+2115] += + s[2115];
gout[n*2187+2116] += + s[2116];
gout[n*2187+2117] += + s[2117];
gout[n*2187+2118] += + s[2118];
gout[n*2187+2119] += + s[2119];
gout[n*2187+2120] += + s[2120];
gout[n*2187+2121] += + s[2121];
gout[n*2187+2122] += + s[2122];
gout[n*2187+2123] += + s[2123];
gout[n*2187+2124] += + s[2124];
gout[n*2187+2125] += + s[2125];
gout[n*2187+2126] += + s[2126];
gout[n*2187+2127] += + s[2127];
gout[n*2187+2128] += + s[2128];
gout[n*2187+2129] += + s[2129];
gout[n*2187+2130] += + s[2130];
gout[n*2187+2131] += + s[2131];
gout[n*2187+2132] += + s[2132];
gout[n*2187+2133] += + s[2133];
gout[n*2187+2134] += + s[2134];
gout[n*2187+2135] += + s[2135];
gout[n*2187+2136] += + s[2136];
gout[n*2187+2137] += + s[2137];
gout[n*2187+2138] += + s[2138];
gout[n*2187+2139] += + s[2139];
gout[n*2187+2140] += + s[2140];
gout[n*2187+2141] += + s[2141];
gout[n*2187+2142] += + s[2142];
gout[n*2187+2143] += + s[2143];
gout[n*2187+2144] += + s[2144];
gout[n*2187+2145] += + s[2145];
gout[n*2187+2146] += + s[2146];
gout[n*2187+2147] += + s[2147];
gout[n*2187+2148] += + s[2148];
gout[n*2187+2149] += + s[2149];
gout[n*2187+2150] += + s[2150];
gout[n*2187+2151] += + s[2151];
gout[n*2187+2152] += + s[2152];
gout[n*2187+2153] += + s[2153];
gout[n*2187+2154] += + s[2154];
gout[n*2187+2155] += + s[2155];
gout[n*2187+2156] += + s[2156];
gout[n*2187+2157] += + s[2157];
gout[n*2187+2158] += + s[2158];
gout[n*2187+2159] += + s[2159];
gout[n*2187+2160] += + s[2160];
gout[n*2187+2161] += + s[2161];
gout[n*2187+2162] += + s[2162];
gout[n*2187+2163] += + s[2163];
gout[n*2187+2164] += + s[2164];
gout[n*2187+2165] += + s[2165];
gout[n*2187+2166] += + s[2166];
gout[n*2187+2167] += + s[2167];
gout[n*2187+2168] += + s[2168];
gout[n*2187+2169] += + s[2169];
gout[n*2187+2170] += + s[2170];
gout[n*2187+2171] += + s[2171];
gout[n*2187+2172] += + s[2172];
gout[n*2187+2173] += + s[2173];
gout[n*2187+2174] += + s[2174];
gout[n*2187+2175] += + s[2175];
gout[n*2187+2176] += + s[2176];
gout[n*2187+2177] += + s[2177];
gout[n*2187+2178] += + s[2178];
gout[n*2187+2179] += + s[2179];
gout[n*2187+2180] += + s[2180];
gout[n*2187+2181] += + s[2181];
gout[n*2187+2182] += + s[2182];
gout[n*2187+2183] += + s[2183];
gout[n*2187+2184] += + s[2184];
gout[n*2187+2185] += + s[2185];
gout[n*2187+2186] += + s[2186];
}}}
void int1e_mmmipipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 7, 0, 0, 7, 1, 1, 2187};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_mmmipipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 7, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_mmmipipipip_cart
CACHE_SIZE_T int1e_mmmipipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 7, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_mmmipipipip_sph
CACHE_SIZE_T int1e_mmmipipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 7, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_mmmipipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_mmmipipipip_spinor
ALL_CINT1E(int1e_mmmipipipip)
ALL_CINT1E_FORTRAN_(int1e_mmmipipipip)
/* <NABLA i|RI RI RI |j> */
void CINTgout1e_int1e_ipmmm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[81];
G1E_RCJ(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipmmm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmmm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmmm_cart
CACHE_SIZE_T int1e_ipmmm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmmm_sph
CACHE_SIZE_T int1e_ipmmm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmmm_spinor
ALL_CINT1E(int1e_ipmmm)
ALL_CINT1E_FORTRAN_(int1e_ipmmm)
/* <NABLA NABLA i|RI RI RI |j> */
void CINTgout1e_int1e_ipipmmm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipmmm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipmmm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipmmm_cart
CACHE_SIZE_T int1e_ipipmmm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipmmm_sph
CACHE_SIZE_T int1e_ipipmmm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipmmm_spinor
ALL_CINT1E(int1e_ipipmmm)
ALL_CINT1E_FORTRAN_(int1e_ipipmmm)
/* <NABLA NABLA NABLA i|RI RI RI |j> */
void CINTgout1e_int1e_ipipipmmm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_RCJ(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+3, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+3, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[243];
gout[n*729+28] = + s[244];
gout[n*729+29] = + s[245];
gout[n*729+30] = + s[246];
gout[n*729+31] = + s[247];
gout[n*729+32] = + s[248];
gout[n*729+33] = + s[249];
gout[n*729+34] = + s[250];
gout[n*729+35] = + s[251];
gout[n*729+36] = + s[252];
gout[n*729+37] = + s[253];
gout[n*729+38] = + s[254];
gout[n*729+39] = + s[255];
gout[n*729+40] = + s[256];
gout[n*729+41] = + s[257];
gout[n*729+42] = + s[258];
gout[n*729+43] = + s[259];
gout[n*729+44] = + s[260];
gout[n*729+45] = + s[261];
gout[n*729+46] = + s[262];
gout[n*729+47] = + s[263];
gout[n*729+48] = + s[264];
gout[n*729+49] = + s[265];
gout[n*729+50] = + s[266];
gout[n*729+51] = + s[267];
gout[n*729+52] = + s[268];
gout[n*729+53] = + s[269];
gout[n*729+54] = + s[486];
gout[n*729+55] = + s[487];
gout[n*729+56] = + s[488];
gout[n*729+57] = + s[489];
gout[n*729+58] = + s[490];
gout[n*729+59] = + s[491];
gout[n*729+60] = + s[492];
gout[n*729+61] = + s[493];
gout[n*729+62] = + s[494];
gout[n*729+63] = + s[495];
gout[n*729+64] = + s[496];
gout[n*729+65] = + s[497];
gout[n*729+66] = + s[498];
gout[n*729+67] = + s[499];
gout[n*729+68] = + s[500];
gout[n*729+69] = + s[501];
gout[n*729+70] = + s[502];
gout[n*729+71] = + s[503];
gout[n*729+72] = + s[504];
gout[n*729+73] = + s[505];
gout[n*729+74] = + s[506];
gout[n*729+75] = + s[507];
gout[n*729+76] = + s[508];
gout[n*729+77] = + s[509];
gout[n*729+78] = + s[510];
gout[n*729+79] = + s[511];
gout[n*729+80] = + s[512];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[324];
gout[n*729+109] = + s[325];
gout[n*729+110] = + s[326];
gout[n*729+111] = + s[327];
gout[n*729+112] = + s[328];
gout[n*729+113] = + s[329];
gout[n*729+114] = + s[330];
gout[n*729+115] = + s[331];
gout[n*729+116] = + s[332];
gout[n*729+117] = + s[333];
gout[n*729+118] = + s[334];
gout[n*729+119] = + s[335];
gout[n*729+120] = + s[336];
gout[n*729+121] = + s[337];
gout[n*729+122] = + s[338];
gout[n*729+123] = + s[339];
gout[n*729+124] = + s[340];
gout[n*729+125] = + s[341];
gout[n*729+126] = + s[342];
gout[n*729+127] = + s[343];
gout[n*729+128] = + s[344];
gout[n*729+129] = + s[345];
gout[n*729+130] = + s[346];
gout[n*729+131] = + s[347];
gout[n*729+132] = + s[348];
gout[n*729+133] = + s[349];
gout[n*729+134] = + s[350];
gout[n*729+135] = + s[567];
gout[n*729+136] = + s[568];
gout[n*729+137] = + s[569];
gout[n*729+138] = + s[570];
gout[n*729+139] = + s[571];
gout[n*729+140] = + s[572];
gout[n*729+141] = + s[573];
gout[n*729+142] = + s[574];
gout[n*729+143] = + s[575];
gout[n*729+144] = + s[576];
gout[n*729+145] = + s[577];
gout[n*729+146] = + s[578];
gout[n*729+147] = + s[579];
gout[n*729+148] = + s[580];
gout[n*729+149] = + s[581];
gout[n*729+150] = + s[582];
gout[n*729+151] = + s[583];
gout[n*729+152] = + s[584];
gout[n*729+153] = + s[585];
gout[n*729+154] = + s[586];
gout[n*729+155] = + s[587];
gout[n*729+156] = + s[588];
gout[n*729+157] = + s[589];
gout[n*729+158] = + s[590];
gout[n*729+159] = + s[591];
gout[n*729+160] = + s[592];
gout[n*729+161] = + s[593];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[405];
gout[n*729+190] = + s[406];
gout[n*729+191] = + s[407];
gout[n*729+192] = + s[408];
gout[n*729+193] = + s[409];
gout[n*729+194] = + s[410];
gout[n*729+195] = + s[411];
gout[n*729+196] = + s[412];
gout[n*729+197] = + s[413];
gout[n*729+198] = + s[414];
gout[n*729+199] = + s[415];
gout[n*729+200] = + s[416];
gout[n*729+201] = + s[417];
gout[n*729+202] = + s[418];
gout[n*729+203] = + s[419];
gout[n*729+204] = + s[420];
gout[n*729+205] = + s[421];
gout[n*729+206] = + s[422];
gout[n*729+207] = + s[423];
gout[n*729+208] = + s[424];
gout[n*729+209] = + s[425];
gout[n*729+210] = + s[426];
gout[n*729+211] = + s[427];
gout[n*729+212] = + s[428];
gout[n*729+213] = + s[429];
gout[n*729+214] = + s[430];
gout[n*729+215] = + s[431];
gout[n*729+216] = + s[648];
gout[n*729+217] = + s[649];
gout[n*729+218] = + s[650];
gout[n*729+219] = + s[651];
gout[n*729+220] = + s[652];
gout[n*729+221] = + s[653];
gout[n*729+222] = + s[654];
gout[n*729+223] = + s[655];
gout[n*729+224] = + s[656];
gout[n*729+225] = + s[657];
gout[n*729+226] = + s[658];
gout[n*729+227] = + s[659];
gout[n*729+228] = + s[660];
gout[n*729+229] = + s[661];
gout[n*729+230] = + s[662];
gout[n*729+231] = + s[663];
gout[n*729+232] = + s[664];
gout[n*729+233] = + s[665];
gout[n*729+234] = + s[666];
gout[n*729+235] = + s[667];
gout[n*729+236] = + s[668];
gout[n*729+237] = + s[669];
gout[n*729+238] = + s[670];
gout[n*729+239] = + s[671];
gout[n*729+240] = + s[672];
gout[n*729+241] = + s[673];
gout[n*729+242] = + s[674];
gout[n*729+243] = + s[27];
gout[n*729+244] = + s[28];
gout[n*729+245] = + s[29];
gout[n*729+246] = + s[30];
gout[n*729+247] = + s[31];
gout[n*729+248] = + s[32];
gout[n*729+249] = + s[33];
gout[n*729+250] = + s[34];
gout[n*729+251] = + s[35];
gout[n*729+252] = + s[36];
gout[n*729+253] = + s[37];
gout[n*729+254] = + s[38];
gout[n*729+255] = + s[39];
gout[n*729+256] = + s[40];
gout[n*729+257] = + s[41];
gout[n*729+258] = + s[42];
gout[n*729+259] = + s[43];
gout[n*729+260] = + s[44];
gout[n*729+261] = + s[45];
gout[n*729+262] = + s[46];
gout[n*729+263] = + s[47];
gout[n*729+264] = + s[48];
gout[n*729+265] = + s[49];
gout[n*729+266] = + s[50];
gout[n*729+267] = + s[51];
gout[n*729+268] = + s[52];
gout[n*729+269] = + s[53];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[513];
gout[n*729+298] = + s[514];
gout[n*729+299] = + s[515];
gout[n*729+300] = + s[516];
gout[n*729+301] = + s[517];
gout[n*729+302] = + s[518];
gout[n*729+303] = + s[519];
gout[n*729+304] = + s[520];
gout[n*729+305] = + s[521];
gout[n*729+306] = + s[522];
gout[n*729+307] = + s[523];
gout[n*729+308] = + s[524];
gout[n*729+309] = + s[525];
gout[n*729+310] = + s[526];
gout[n*729+311] = + s[527];
gout[n*729+312] = + s[528];
gout[n*729+313] = + s[529];
gout[n*729+314] = + s[530];
gout[n*729+315] = + s[531];
gout[n*729+316] = + s[532];
gout[n*729+317] = + s[533];
gout[n*729+318] = + s[534];
gout[n*729+319] = + s[535];
gout[n*729+320] = + s[536];
gout[n*729+321] = + s[537];
gout[n*729+322] = + s[538];
gout[n*729+323] = + s[539];
gout[n*729+324] = + s[108];
gout[n*729+325] = + s[109];
gout[n*729+326] = + s[110];
gout[n*729+327] = + s[111];
gout[n*729+328] = + s[112];
gout[n*729+329] = + s[113];
gout[n*729+330] = + s[114];
gout[n*729+331] = + s[115];
gout[n*729+332] = + s[116];
gout[n*729+333] = + s[117];
gout[n*729+334] = + s[118];
gout[n*729+335] = + s[119];
gout[n*729+336] = + s[120];
gout[n*729+337] = + s[121];
gout[n*729+338] = + s[122];
gout[n*729+339] = + s[123];
gout[n*729+340] = + s[124];
gout[n*729+341] = + s[125];
gout[n*729+342] = + s[126];
gout[n*729+343] = + s[127];
gout[n*729+344] = + s[128];
gout[n*729+345] = + s[129];
gout[n*729+346] = + s[130];
gout[n*729+347] = + s[131];
gout[n*729+348] = + s[132];
gout[n*729+349] = + s[133];
gout[n*729+350] = + s[134];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[594];
gout[n*729+379] = + s[595];
gout[n*729+380] = + s[596];
gout[n*729+381] = + s[597];
gout[n*729+382] = + s[598];
gout[n*729+383] = + s[599];
gout[n*729+384] = + s[600];
gout[n*729+385] = + s[601];
gout[n*729+386] = + s[602];
gout[n*729+387] = + s[603];
gout[n*729+388] = + s[604];
gout[n*729+389] = + s[605];
gout[n*729+390] = + s[606];
gout[n*729+391] = + s[607];
gout[n*729+392] = + s[608];
gout[n*729+393] = + s[609];
gout[n*729+394] = + s[610];
gout[n*729+395] = + s[611];
gout[n*729+396] = + s[612];
gout[n*729+397] = + s[613];
gout[n*729+398] = + s[614];
gout[n*729+399] = + s[615];
gout[n*729+400] = + s[616];
gout[n*729+401] = + s[617];
gout[n*729+402] = + s[618];
gout[n*729+403] = + s[619];
gout[n*729+404] = + s[620];
gout[n*729+405] = + s[189];
gout[n*729+406] = + s[190];
gout[n*729+407] = + s[191];
gout[n*729+408] = + s[192];
gout[n*729+409] = + s[193];
gout[n*729+410] = + s[194];
gout[n*729+411] = + s[195];
gout[n*729+412] = + s[196];
gout[n*729+413] = + s[197];
gout[n*729+414] = + s[198];
gout[n*729+415] = + s[199];
gout[n*729+416] = + s[200];
gout[n*729+417] = + s[201];
gout[n*729+418] = + s[202];
gout[n*729+419] = + s[203];
gout[n*729+420] = + s[204];
gout[n*729+421] = + s[205];
gout[n*729+422] = + s[206];
gout[n*729+423] = + s[207];
gout[n*729+424] = + s[208];
gout[n*729+425] = + s[209];
gout[n*729+426] = + s[210];
gout[n*729+427] = + s[211];
gout[n*729+428] = + s[212];
gout[n*729+429] = + s[213];
gout[n*729+430] = + s[214];
gout[n*729+431] = + s[215];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[675];
gout[n*729+460] = + s[676];
gout[n*729+461] = + s[677];
gout[n*729+462] = + s[678];
gout[n*729+463] = + s[679];
gout[n*729+464] = + s[680];
gout[n*729+465] = + s[681];
gout[n*729+466] = + s[682];
gout[n*729+467] = + s[683];
gout[n*729+468] = + s[684];
gout[n*729+469] = + s[685];
gout[n*729+470] = + s[686];
gout[n*729+471] = + s[687];
gout[n*729+472] = + s[688];
gout[n*729+473] = + s[689];
gout[n*729+474] = + s[690];
gout[n*729+475] = + s[691];
gout[n*729+476] = + s[692];
gout[n*729+477] = + s[693];
gout[n*729+478] = + s[694];
gout[n*729+479] = + s[695];
gout[n*729+480] = + s[696];
gout[n*729+481] = + s[697];
gout[n*729+482] = + s[698];
gout[n*729+483] = + s[699];
gout[n*729+484] = + s[700];
gout[n*729+485] = + s[701];
gout[n*729+486] = + s[54];
gout[n*729+487] = + s[55];
gout[n*729+488] = + s[56];
gout[n*729+489] = + s[57];
gout[n*729+490] = + s[58];
gout[n*729+491] = + s[59];
gout[n*729+492] = + s[60];
gout[n*729+493] = + s[61];
gout[n*729+494] = + s[62];
gout[n*729+495] = + s[63];
gout[n*729+496] = + s[64];
gout[n*729+497] = + s[65];
gout[n*729+498] = + s[66];
gout[n*729+499] = + s[67];
gout[n*729+500] = + s[68];
gout[n*729+501] = + s[69];
gout[n*729+502] = + s[70];
gout[n*729+503] = + s[71];
gout[n*729+504] = + s[72];
gout[n*729+505] = + s[73];
gout[n*729+506] = + s[74];
gout[n*729+507] = + s[75];
gout[n*729+508] = + s[76];
gout[n*729+509] = + s[77];
gout[n*729+510] = + s[78];
gout[n*729+511] = + s[79];
gout[n*729+512] = + s[80];
gout[n*729+513] = + s[297];
gout[n*729+514] = + s[298];
gout[n*729+515] = + s[299];
gout[n*729+516] = + s[300];
gout[n*729+517] = + s[301];
gout[n*729+518] = + s[302];
gout[n*729+519] = + s[303];
gout[n*729+520] = + s[304];
gout[n*729+521] = + s[305];
gout[n*729+522] = + s[306];
gout[n*729+523] = + s[307];
gout[n*729+524] = + s[308];
gout[n*729+525] = + s[309];
gout[n*729+526] = + s[310];
gout[n*729+527] = + s[311];
gout[n*729+528] = + s[312];
gout[n*729+529] = + s[313];
gout[n*729+530] = + s[314];
gout[n*729+531] = + s[315];
gout[n*729+532] = + s[316];
gout[n*729+533] = + s[317];
gout[n*729+534] = + s[318];
gout[n*729+535] = + s[319];
gout[n*729+536] = + s[320];
gout[n*729+537] = + s[321];
gout[n*729+538] = + s[322];
gout[n*729+539] = + s[323];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[135];
gout[n*729+568] = + s[136];
gout[n*729+569] = + s[137];
gout[n*729+570] = + s[138];
gout[n*729+571] = + s[139];
gout[n*729+572] = + s[140];
gout[n*729+573] = + s[141];
gout[n*729+574] = + s[142];
gout[n*729+575] = + s[143];
gout[n*729+576] = + s[144];
gout[n*729+577] = + s[145];
gout[n*729+578] = + s[146];
gout[n*729+579] = + s[147];
gout[n*729+580] = + s[148];
gout[n*729+581] = + s[149];
gout[n*729+582] = + s[150];
gout[n*729+583] = + s[151];
gout[n*729+584] = + s[152];
gout[n*729+585] = + s[153];
gout[n*729+586] = + s[154];
gout[n*729+587] = + s[155];
gout[n*729+588] = + s[156];
gout[n*729+589] = + s[157];
gout[n*729+590] = + s[158];
gout[n*729+591] = + s[159];
gout[n*729+592] = + s[160];
gout[n*729+593] = + s[161];
gout[n*729+594] = + s[378];
gout[n*729+595] = + s[379];
gout[n*729+596] = + s[380];
gout[n*729+597] = + s[381];
gout[n*729+598] = + s[382];
gout[n*729+599] = + s[383];
gout[n*729+600] = + s[384];
gout[n*729+601] = + s[385];
gout[n*729+602] = + s[386];
gout[n*729+603] = + s[387];
gout[n*729+604] = + s[388];
gout[n*729+605] = + s[389];
gout[n*729+606] = + s[390];
gout[n*729+607] = + s[391];
gout[n*729+608] = + s[392];
gout[n*729+609] = + s[393];
gout[n*729+610] = + s[394];
gout[n*729+611] = + s[395];
gout[n*729+612] = + s[396];
gout[n*729+613] = + s[397];
gout[n*729+614] = + s[398];
gout[n*729+615] = + s[399];
gout[n*729+616] = + s[400];
gout[n*729+617] = + s[401];
gout[n*729+618] = + s[402];
gout[n*729+619] = + s[403];
gout[n*729+620] = + s[404];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[216];
gout[n*729+649] = + s[217];
gout[n*729+650] = + s[218];
gout[n*729+651] = + s[219];
gout[n*729+652] = + s[220];
gout[n*729+653] = + s[221];
gout[n*729+654] = + s[222];
gout[n*729+655] = + s[223];
gout[n*729+656] = + s[224];
gout[n*729+657] = + s[225];
gout[n*729+658] = + s[226];
gout[n*729+659] = + s[227];
gout[n*729+660] = + s[228];
gout[n*729+661] = + s[229];
gout[n*729+662] = + s[230];
gout[n*729+663] = + s[231];
gout[n*729+664] = + s[232];
gout[n*729+665] = + s[233];
gout[n*729+666] = + s[234];
gout[n*729+667] = + s[235];
gout[n*729+668] = + s[236];
gout[n*729+669] = + s[237];
gout[n*729+670] = + s[238];
gout[n*729+671] = + s[239];
gout[n*729+672] = + s[240];
gout[n*729+673] = + s[241];
gout[n*729+674] = + s[242];
gout[n*729+675] = + s[459];
gout[n*729+676] = + s[460];
gout[n*729+677] = + s[461];
gout[n*729+678] = + s[462];
gout[n*729+679] = + s[463];
gout[n*729+680] = + s[464];
gout[n*729+681] = + s[465];
gout[n*729+682] = + s[466];
gout[n*729+683] = + s[467];
gout[n*729+684] = + s[468];
gout[n*729+685] = + s[469];
gout[n*729+686] = + s[470];
gout[n*729+687] = + s[471];
gout[n*729+688] = + s[472];
gout[n*729+689] = + s[473];
gout[n*729+690] = + s[474];
gout[n*729+691] = + s[475];
gout[n*729+692] = + s[476];
gout[n*729+693] = + s[477];
gout[n*729+694] = + s[478];
gout[n*729+695] = + s[479];
gout[n*729+696] = + s[480];
gout[n*729+697] = + s[481];
gout[n*729+698] = + s[482];
gout[n*729+699] = + s[483];
gout[n*729+700] = + s[484];
gout[n*729+701] = + s[485];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[243];
gout[n*729+28] += + s[244];
gout[n*729+29] += + s[245];
gout[n*729+30] += + s[246];
gout[n*729+31] += + s[247];
gout[n*729+32] += + s[248];
gout[n*729+33] += + s[249];
gout[n*729+34] += + s[250];
gout[n*729+35] += + s[251];
gout[n*729+36] += + s[252];
gout[n*729+37] += + s[253];
gout[n*729+38] += + s[254];
gout[n*729+39] += + s[255];
gout[n*729+40] += + s[256];
gout[n*729+41] += + s[257];
gout[n*729+42] += + s[258];
gout[n*729+43] += + s[259];
gout[n*729+44] += + s[260];
gout[n*729+45] += + s[261];
gout[n*729+46] += + s[262];
gout[n*729+47] += + s[263];
gout[n*729+48] += + s[264];
gout[n*729+49] += + s[265];
gout[n*729+50] += + s[266];
gout[n*729+51] += + s[267];
gout[n*729+52] += + s[268];
gout[n*729+53] += + s[269];
gout[n*729+54] += + s[486];
gout[n*729+55] += + s[487];
gout[n*729+56] += + s[488];
gout[n*729+57] += + s[489];
gout[n*729+58] += + s[490];
gout[n*729+59] += + s[491];
gout[n*729+60] += + s[492];
gout[n*729+61] += + s[493];
gout[n*729+62] += + s[494];
gout[n*729+63] += + s[495];
gout[n*729+64] += + s[496];
gout[n*729+65] += + s[497];
gout[n*729+66] += + s[498];
gout[n*729+67] += + s[499];
gout[n*729+68] += + s[500];
gout[n*729+69] += + s[501];
gout[n*729+70] += + s[502];
gout[n*729+71] += + s[503];
gout[n*729+72] += + s[504];
gout[n*729+73] += + s[505];
gout[n*729+74] += + s[506];
gout[n*729+75] += + s[507];
gout[n*729+76] += + s[508];
gout[n*729+77] += + s[509];
gout[n*729+78] += + s[510];
gout[n*729+79] += + s[511];
gout[n*729+80] += + s[512];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[324];
gout[n*729+109] += + s[325];
gout[n*729+110] += + s[326];
gout[n*729+111] += + s[327];
gout[n*729+112] += + s[328];
gout[n*729+113] += + s[329];
gout[n*729+114] += + s[330];
gout[n*729+115] += + s[331];
gout[n*729+116] += + s[332];
gout[n*729+117] += + s[333];
gout[n*729+118] += + s[334];
gout[n*729+119] += + s[335];
gout[n*729+120] += + s[336];
gout[n*729+121] += + s[337];
gout[n*729+122] += + s[338];
gout[n*729+123] += + s[339];
gout[n*729+124] += + s[340];
gout[n*729+125] += + s[341];
gout[n*729+126] += + s[342];
gout[n*729+127] += + s[343];
gout[n*729+128] += + s[344];
gout[n*729+129] += + s[345];
gout[n*729+130] += + s[346];
gout[n*729+131] += + s[347];
gout[n*729+132] += + s[348];
gout[n*729+133] += + s[349];
gout[n*729+134] += + s[350];
gout[n*729+135] += + s[567];
gout[n*729+136] += + s[568];
gout[n*729+137] += + s[569];
gout[n*729+138] += + s[570];
gout[n*729+139] += + s[571];
gout[n*729+140] += + s[572];
gout[n*729+141] += + s[573];
gout[n*729+142] += + s[574];
gout[n*729+143] += + s[575];
gout[n*729+144] += + s[576];
gout[n*729+145] += + s[577];
gout[n*729+146] += + s[578];
gout[n*729+147] += + s[579];
gout[n*729+148] += + s[580];
gout[n*729+149] += + s[581];
gout[n*729+150] += + s[582];
gout[n*729+151] += + s[583];
gout[n*729+152] += + s[584];
gout[n*729+153] += + s[585];
gout[n*729+154] += + s[586];
gout[n*729+155] += + s[587];
gout[n*729+156] += + s[588];
gout[n*729+157] += + s[589];
gout[n*729+158] += + s[590];
gout[n*729+159] += + s[591];
gout[n*729+160] += + s[592];
gout[n*729+161] += + s[593];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[405];
gout[n*729+190] += + s[406];
gout[n*729+191] += + s[407];
gout[n*729+192] += + s[408];
gout[n*729+193] += + s[409];
gout[n*729+194] += + s[410];
gout[n*729+195] += + s[411];
gout[n*729+196] += + s[412];
gout[n*729+197] += + s[413];
gout[n*729+198] += + s[414];
gout[n*729+199] += + s[415];
gout[n*729+200] += + s[416];
gout[n*729+201] += + s[417];
gout[n*729+202] += + s[418];
gout[n*729+203] += + s[419];
gout[n*729+204] += + s[420];
gout[n*729+205] += + s[421];
gout[n*729+206] += + s[422];
gout[n*729+207] += + s[423];
gout[n*729+208] += + s[424];
gout[n*729+209] += + s[425];
gout[n*729+210] += + s[426];
gout[n*729+211] += + s[427];
gout[n*729+212] += + s[428];
gout[n*729+213] += + s[429];
gout[n*729+214] += + s[430];
gout[n*729+215] += + s[431];
gout[n*729+216] += + s[648];
gout[n*729+217] += + s[649];
gout[n*729+218] += + s[650];
gout[n*729+219] += + s[651];
gout[n*729+220] += + s[652];
gout[n*729+221] += + s[653];
gout[n*729+222] += + s[654];
gout[n*729+223] += + s[655];
gout[n*729+224] += + s[656];
gout[n*729+225] += + s[657];
gout[n*729+226] += + s[658];
gout[n*729+227] += + s[659];
gout[n*729+228] += + s[660];
gout[n*729+229] += + s[661];
gout[n*729+230] += + s[662];
gout[n*729+231] += + s[663];
gout[n*729+232] += + s[664];
gout[n*729+233] += + s[665];
gout[n*729+234] += + s[666];
gout[n*729+235] += + s[667];
gout[n*729+236] += + s[668];
gout[n*729+237] += + s[669];
gout[n*729+238] += + s[670];
gout[n*729+239] += + s[671];
gout[n*729+240] += + s[672];
gout[n*729+241] += + s[673];
gout[n*729+242] += + s[674];
gout[n*729+243] += + s[27];
gout[n*729+244] += + s[28];
gout[n*729+245] += + s[29];
gout[n*729+246] += + s[30];
gout[n*729+247] += + s[31];
gout[n*729+248] += + s[32];
gout[n*729+249] += + s[33];
gout[n*729+250] += + s[34];
gout[n*729+251] += + s[35];
gout[n*729+252] += + s[36];
gout[n*729+253] += + s[37];
gout[n*729+254] += + s[38];
gout[n*729+255] += + s[39];
gout[n*729+256] += + s[40];
gout[n*729+257] += + s[41];
gout[n*729+258] += + s[42];
gout[n*729+259] += + s[43];
gout[n*729+260] += + s[44];
gout[n*729+261] += + s[45];
gout[n*729+262] += + s[46];
gout[n*729+263] += + s[47];
gout[n*729+264] += + s[48];
gout[n*729+265] += + s[49];
gout[n*729+266] += + s[50];
gout[n*729+267] += + s[51];
gout[n*729+268] += + s[52];
gout[n*729+269] += + s[53];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[513];
gout[n*729+298] += + s[514];
gout[n*729+299] += + s[515];
gout[n*729+300] += + s[516];
gout[n*729+301] += + s[517];
gout[n*729+302] += + s[518];
gout[n*729+303] += + s[519];
gout[n*729+304] += + s[520];
gout[n*729+305] += + s[521];
gout[n*729+306] += + s[522];
gout[n*729+307] += + s[523];
gout[n*729+308] += + s[524];
gout[n*729+309] += + s[525];
gout[n*729+310] += + s[526];
gout[n*729+311] += + s[527];
gout[n*729+312] += + s[528];
gout[n*729+313] += + s[529];
gout[n*729+314] += + s[530];
gout[n*729+315] += + s[531];
gout[n*729+316] += + s[532];
gout[n*729+317] += + s[533];
gout[n*729+318] += + s[534];
gout[n*729+319] += + s[535];
gout[n*729+320] += + s[536];
gout[n*729+321] += + s[537];
gout[n*729+322] += + s[538];
gout[n*729+323] += + s[539];
gout[n*729+324] += + s[108];
gout[n*729+325] += + s[109];
gout[n*729+326] += + s[110];
gout[n*729+327] += + s[111];
gout[n*729+328] += + s[112];
gout[n*729+329] += + s[113];
gout[n*729+330] += + s[114];
gout[n*729+331] += + s[115];
gout[n*729+332] += + s[116];
gout[n*729+333] += + s[117];
gout[n*729+334] += + s[118];
gout[n*729+335] += + s[119];
gout[n*729+336] += + s[120];
gout[n*729+337] += + s[121];
gout[n*729+338] += + s[122];
gout[n*729+339] += + s[123];
gout[n*729+340] += + s[124];
gout[n*729+341] += + s[125];
gout[n*729+342] += + s[126];
gout[n*729+343] += + s[127];
gout[n*729+344] += + s[128];
gout[n*729+345] += + s[129];
gout[n*729+346] += + s[130];
gout[n*729+347] += + s[131];
gout[n*729+348] += + s[132];
gout[n*729+349] += + s[133];
gout[n*729+350] += + s[134];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[594];
gout[n*729+379] += + s[595];
gout[n*729+380] += + s[596];
gout[n*729+381] += + s[597];
gout[n*729+382] += + s[598];
gout[n*729+383] += + s[599];
gout[n*729+384] += + s[600];
gout[n*729+385] += + s[601];
gout[n*729+386] += + s[602];
gout[n*729+387] += + s[603];
gout[n*729+388] += + s[604];
gout[n*729+389] += + s[605];
gout[n*729+390] += + s[606];
gout[n*729+391] += + s[607];
gout[n*729+392] += + s[608];
gout[n*729+393] += + s[609];
gout[n*729+394] += + s[610];
gout[n*729+395] += + s[611];
gout[n*729+396] += + s[612];
gout[n*729+397] += + s[613];
gout[n*729+398] += + s[614];
gout[n*729+399] += + s[615];
gout[n*729+400] += + s[616];
gout[n*729+401] += + s[617];
gout[n*729+402] += + s[618];
gout[n*729+403] += + s[619];
gout[n*729+404] += + s[620];
gout[n*729+405] += + s[189];
gout[n*729+406] += + s[190];
gout[n*729+407] += + s[191];
gout[n*729+408] += + s[192];
gout[n*729+409] += + s[193];
gout[n*729+410] += + s[194];
gout[n*729+411] += + s[195];
gout[n*729+412] += + s[196];
gout[n*729+413] += + s[197];
gout[n*729+414] += + s[198];
gout[n*729+415] += + s[199];
gout[n*729+416] += + s[200];
gout[n*729+417] += + s[201];
gout[n*729+418] += + s[202];
gout[n*729+419] += + s[203];
gout[n*729+420] += + s[204];
gout[n*729+421] += + s[205];
gout[n*729+422] += + s[206];
gout[n*729+423] += + s[207];
gout[n*729+424] += + s[208];
gout[n*729+425] += + s[209];
gout[n*729+426] += + s[210];
gout[n*729+427] += + s[211];
gout[n*729+428] += + s[212];
gout[n*729+429] += + s[213];
gout[n*729+430] += + s[214];
gout[n*729+431] += + s[215];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[675];
gout[n*729+460] += + s[676];
gout[n*729+461] += + s[677];
gout[n*729+462] += + s[678];
gout[n*729+463] += + s[679];
gout[n*729+464] += + s[680];
gout[n*729+465] += + s[681];
gout[n*729+466] += + s[682];
gout[n*729+467] += + s[683];
gout[n*729+468] += + s[684];
gout[n*729+469] += + s[685];
gout[n*729+470] += + s[686];
gout[n*729+471] += + s[687];
gout[n*729+472] += + s[688];
gout[n*729+473] += + s[689];
gout[n*729+474] += + s[690];
gout[n*729+475] += + s[691];
gout[n*729+476] += + s[692];
gout[n*729+477] += + s[693];
gout[n*729+478] += + s[694];
gout[n*729+479] += + s[695];
gout[n*729+480] += + s[696];
gout[n*729+481] += + s[697];
gout[n*729+482] += + s[698];
gout[n*729+483] += + s[699];
gout[n*729+484] += + s[700];
gout[n*729+485] += + s[701];
gout[n*729+486] += + s[54];
gout[n*729+487] += + s[55];
gout[n*729+488] += + s[56];
gout[n*729+489] += + s[57];
gout[n*729+490] += + s[58];
gout[n*729+491] += + s[59];
gout[n*729+492] += + s[60];
gout[n*729+493] += + s[61];
gout[n*729+494] += + s[62];
gout[n*729+495] += + s[63];
gout[n*729+496] += + s[64];
gout[n*729+497] += + s[65];
gout[n*729+498] += + s[66];
gout[n*729+499] += + s[67];
gout[n*729+500] += + s[68];
gout[n*729+501] += + s[69];
gout[n*729+502] += + s[70];
gout[n*729+503] += + s[71];
gout[n*729+504] += + s[72];
gout[n*729+505] += + s[73];
gout[n*729+506] += + s[74];
gout[n*729+507] += + s[75];
gout[n*729+508] += + s[76];
gout[n*729+509] += + s[77];
gout[n*729+510] += + s[78];
gout[n*729+511] += + s[79];
gout[n*729+512] += + s[80];
gout[n*729+513] += + s[297];
gout[n*729+514] += + s[298];
gout[n*729+515] += + s[299];
gout[n*729+516] += + s[300];
gout[n*729+517] += + s[301];
gout[n*729+518] += + s[302];
gout[n*729+519] += + s[303];
gout[n*729+520] += + s[304];
gout[n*729+521] += + s[305];
gout[n*729+522] += + s[306];
gout[n*729+523] += + s[307];
gout[n*729+524] += + s[308];
gout[n*729+525] += + s[309];
gout[n*729+526] += + s[310];
gout[n*729+527] += + s[311];
gout[n*729+528] += + s[312];
gout[n*729+529] += + s[313];
gout[n*729+530] += + s[314];
gout[n*729+531] += + s[315];
gout[n*729+532] += + s[316];
gout[n*729+533] += + s[317];
gout[n*729+534] += + s[318];
gout[n*729+535] += + s[319];
gout[n*729+536] += + s[320];
gout[n*729+537] += + s[321];
gout[n*729+538] += + s[322];
gout[n*729+539] += + s[323];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[135];
gout[n*729+568] += + s[136];
gout[n*729+569] += + s[137];
gout[n*729+570] += + s[138];
gout[n*729+571] += + s[139];
gout[n*729+572] += + s[140];
gout[n*729+573] += + s[141];
gout[n*729+574] += + s[142];
gout[n*729+575] += + s[143];
gout[n*729+576] += + s[144];
gout[n*729+577] += + s[145];
gout[n*729+578] += + s[146];
gout[n*729+579] += + s[147];
gout[n*729+580] += + s[148];
gout[n*729+581] += + s[149];
gout[n*729+582] += + s[150];
gout[n*729+583] += + s[151];
gout[n*729+584] += + s[152];
gout[n*729+585] += + s[153];
gout[n*729+586] += + s[154];
gout[n*729+587] += + s[155];
gout[n*729+588] += + s[156];
gout[n*729+589] += + s[157];
gout[n*729+590] += + s[158];
gout[n*729+591] += + s[159];
gout[n*729+592] += + s[160];
gout[n*729+593] += + s[161];
gout[n*729+594] += + s[378];
gout[n*729+595] += + s[379];
gout[n*729+596] += + s[380];
gout[n*729+597] += + s[381];
gout[n*729+598] += + s[382];
gout[n*729+599] += + s[383];
gout[n*729+600] += + s[384];
gout[n*729+601] += + s[385];
gout[n*729+602] += + s[386];
gout[n*729+603] += + s[387];
gout[n*729+604] += + s[388];
gout[n*729+605] += + s[389];
gout[n*729+606] += + s[390];
gout[n*729+607] += + s[391];
gout[n*729+608] += + s[392];
gout[n*729+609] += + s[393];
gout[n*729+610] += + s[394];
gout[n*729+611] += + s[395];
gout[n*729+612] += + s[396];
gout[n*729+613] += + s[397];
gout[n*729+614] += + s[398];
gout[n*729+615] += + s[399];
gout[n*729+616] += + s[400];
gout[n*729+617] += + s[401];
gout[n*729+618] += + s[402];
gout[n*729+619] += + s[403];
gout[n*729+620] += + s[404];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[216];
gout[n*729+649] += + s[217];
gout[n*729+650] += + s[218];
gout[n*729+651] += + s[219];
gout[n*729+652] += + s[220];
gout[n*729+653] += + s[221];
gout[n*729+654] += + s[222];
gout[n*729+655] += + s[223];
gout[n*729+656] += + s[224];
gout[n*729+657] += + s[225];
gout[n*729+658] += + s[226];
gout[n*729+659] += + s[227];
gout[n*729+660] += + s[228];
gout[n*729+661] += + s[229];
gout[n*729+662] += + s[230];
gout[n*729+663] += + s[231];
gout[n*729+664] += + s[232];
gout[n*729+665] += + s[233];
gout[n*729+666] += + s[234];
gout[n*729+667] += + s[235];
gout[n*729+668] += + s[236];
gout[n*729+669] += + s[237];
gout[n*729+670] += + s[238];
gout[n*729+671] += + s[239];
gout[n*729+672] += + s[240];
gout[n*729+673] += + s[241];
gout[n*729+674] += + s[242];
gout[n*729+675] += + s[459];
gout[n*729+676] += + s[460];
gout[n*729+677] += + s[461];
gout[n*729+678] += + s[462];
gout[n*729+679] += + s[463];
gout[n*729+680] += + s[464];
gout[n*729+681] += + s[465];
gout[n*729+682] += + s[466];
gout[n*729+683] += + s[467];
gout[n*729+684] += + s[468];
gout[n*729+685] += + s[469];
gout[n*729+686] += + s[470];
gout[n*729+687] += + s[471];
gout[n*729+688] += + s[472];
gout[n*729+689] += + s[473];
gout[n*729+690] += + s[474];
gout[n*729+691] += + s[475];
gout[n*729+692] += + s[476];
gout[n*729+693] += + s[477];
gout[n*729+694] += + s[478];
gout[n*729+695] += + s[479];
gout[n*729+696] += + s[480];
gout[n*729+697] += + s[481];
gout[n*729+698] += + s[482];
gout[n*729+699] += + s[483];
gout[n*729+700] += + s[484];
gout[n*729+701] += + s[485];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipipmmm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipmmm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipmmm_cart
CACHE_SIZE_T int1e_ipipipmmm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipmmm_sph
CACHE_SIZE_T int1e_ipipipmmm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipmmm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipmmm_spinor
ALL_CINT1E(int1e_ipipipmmm)
ALL_CINT1E_FORTRAN_(int1e_ipipipmmm)
/* <NABLA NABLA NABLA NABLA i|RI RI RI |j> */
void CINTgout1e_int1e_ipipipipmmm(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double *g64 = g63 + envs->g_size * 3;
double *g65 = g64 + envs->g_size * 3;
double *g66 = g65 + envs->g_size * 3;
double *g67 = g66 + envs->g_size * 3;
double *g68 = g67 + envs->g_size * 3;
double *g69 = g68 + envs->g_size * 3;
double *g70 = g69 + envs->g_size * 3;
double *g71 = g70 + envs->g_size * 3;
double *g72 = g71 + envs->g_size * 3;
double *g73 = g72 + envs->g_size * 3;
double *g74 = g73 + envs->g_size * 3;
double *g75 = g74 + envs->g_size * 3;
double *g76 = g75 + envs->g_size * 3;
double *g77 = g76 + envs->g_size * 3;
double *g78 = g77 + envs->g_size * 3;
double *g79 = g78 + envs->g_size * 3;
double *g80 = g79 + envs->g_size * 3;
double *g81 = g80 + envs->g_size * 3;
double *g82 = g81 + envs->g_size * 3;
double *g83 = g82 + envs->g_size * 3;
double *g84 = g83 + envs->g_size * 3;
double *g85 = g84 + envs->g_size * 3;
double *g86 = g85 + envs->g_size * 3;
double *g87 = g86 + envs->g_size * 3;
double *g88 = g87 + envs->g_size * 3;
double *g89 = g88 + envs->g_size * 3;
double *g90 = g89 + envs->g_size * 3;
double *g91 = g90 + envs->g_size * 3;
double *g92 = g91 + envs->g_size * 3;
double *g93 = g92 + envs->g_size * 3;
double *g94 = g93 + envs->g_size * 3;
double *g95 = g94 + envs->g_size * 3;
double *g96 = g95 + envs->g_size * 3;
double *g97 = g96 + envs->g_size * 3;
double *g98 = g97 + envs->g_size * 3;
double *g99 = g98 + envs->g_size * 3;
double *g100 = g99 + envs->g_size * 3;
double *g101 = g100 + envs->g_size * 3;
double *g102 = g101 + envs->g_size * 3;
double *g103 = g102 + envs->g_size * 3;
double *g104 = g103 + envs->g_size * 3;
double *g105 = g104 + envs->g_size * 3;
double *g106 = g105 + envs->g_size * 3;
double *g107 = g106 + envs->g_size * 3;
double *g108 = g107 + envs->g_size * 3;
double *g109 = g108 + envs->g_size * 3;
double *g110 = g109 + envs->g_size * 3;
double *g111 = g110 + envs->g_size * 3;
double *g112 = g111 + envs->g_size * 3;
double *g113 = g112 + envs->g_size * 3;
double *g114 = g113 + envs->g_size * 3;
double *g115 = g114 + envs->g_size * 3;
double *g116 = g115 + envs->g_size * 3;
double *g117 = g116 + envs->g_size * 3;
double *g118 = g117 + envs->g_size * 3;
double *g119 = g118 + envs->g_size * 3;
double *g120 = g119 + envs->g_size * 3;
double *g121 = g120 + envs->g_size * 3;
double *g122 = g121 + envs->g_size * 3;
double *g123 = g122 + envs->g_size * 3;
double *g124 = g123 + envs->g_size * 3;
double *g125 = g124 + envs->g_size * 3;
double *g126 = g125 + envs->g_size * 3;
double *g127 = g126 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[2187];
G1E_RCJ(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+4, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+4, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+4, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+4, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g64, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g65, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g66, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g67, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g68, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g69, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g70, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g71, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g72, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g73, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g74, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g75, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g76, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g77, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g78, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g79, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g80, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g81, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g82, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g83, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g84, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g85, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g86, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g87, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g88, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g89, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g90, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g91, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g92, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g93, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g94, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g95, g31, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g96, g32, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g97, g33, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g98, g34, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g99, g35, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g100, g36, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g101, g37, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g102, g38, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g103, g39, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g104, g40, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g105, g41, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g106, g42, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g107, g43, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g108, g44, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g109, g45, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g110, g46, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g111, g47, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g112, g48, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g113, g49, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g114, g50, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g115, g51, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g116, g52, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g117, g53, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g118, g54, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g119, g55, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g120, g56, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g121, g57, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g122, g58, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g123, g59, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g124, g60, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g125, g61, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g126, g62, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g127, g63, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g127[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g126[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g126[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g125[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g124[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g124[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g125[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g124[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g124[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g123[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g122[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g122[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g121[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g120[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g120[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g121[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g120[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g120[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g123[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g122[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g122[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g121[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g120[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g120[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g121[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g120[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g120[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g119[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g118[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g118[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g117[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g116[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g116[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g117[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g116[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g116[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g115[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g114[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g114[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g113[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g112[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g112[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g113[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g112[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g112[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g115[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g114[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g114[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g113[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g112[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g112[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g113[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g112[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g112[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g119[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g118[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g118[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g117[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g116[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g116[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g117[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g116[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g116[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g115[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g114[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g114[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g113[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g112[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g112[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g113[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g112[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g112[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g115[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g114[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g114[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g113[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g112[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g112[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g113[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g112[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g112[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g111[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g110[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g110[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g109[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g108[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g108[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g109[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g108[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g108[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g107[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g106[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g106[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g105[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g104[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g104[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g105[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g104[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g104[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g107[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g106[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g106[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g105[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g104[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g104[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g105[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g104[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g104[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g103[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g102[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g102[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g101[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g100[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g100[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g101[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g100[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g100[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g99[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g98[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g98[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g97[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g96[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g96[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g97[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g96[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g96[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g99[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g98[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g98[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g97[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g96[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g96[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g97[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g96[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g96[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g103[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g102[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g102[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g101[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g100[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g100[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g101[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g100[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g100[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g99[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g98[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g98[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g97[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g96[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g96[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g97[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g96[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g96[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g99[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g98[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g98[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g97[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g96[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g96[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g97[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g96[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g96[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g111[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g110[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g110[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g109[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g108[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g108[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g109[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g108[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g108[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g107[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g106[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g106[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g105[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g104[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g104[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g105[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g104[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g104[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g107[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g106[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g106[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g105[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g104[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g104[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g105[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g104[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g104[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g103[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g102[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g102[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g101[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g100[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g100[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g101[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g100[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g100[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g99[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g98[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g98[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g97[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g96[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g96[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g97[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g96[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g96[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g99[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g98[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g98[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g97[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g96[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g96[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g97[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g96[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g96[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g103[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g102[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g102[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g101[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g100[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g100[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g101[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g100[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g100[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g99[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g98[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g98[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g97[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g96[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g96[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g97[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g96[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g96[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g99[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g98[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g98[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g97[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g96[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g96[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g97[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g96[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g96[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g95[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g94[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g94[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g93[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g92[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g92[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g93[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g92[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g92[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g91[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g90[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g90[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g89[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g88[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g88[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g89[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g88[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g88[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g91[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g90[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g90[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g89[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g88[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g88[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g89[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g88[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g88[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g87[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g86[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g86[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g85[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g84[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g84[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g85[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g84[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g84[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g83[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g82[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g82[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g81[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g80[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g80[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g81[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g80[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g80[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g83[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g82[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g82[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g81[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g80[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g80[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g81[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g80[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g80[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g87[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g86[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g86[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g85[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g84[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g84[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g85[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g84[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g84[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g83[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g82[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g82[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g81[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g80[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g80[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g81[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g80[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g80[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g83[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g82[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g82[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g81[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g80[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g80[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g81[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g80[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g80[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g79[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g78[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g78[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g77[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g76[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g76[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g77[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g76[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g76[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g75[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g74[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g74[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g73[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g72[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g72[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g73[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g72[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g72[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g75[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g74[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g74[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g73[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g72[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g72[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g73[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g72[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g72[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g71[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g70[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g70[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g69[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g68[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g68[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g69[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g68[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g68[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g67[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g66[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g66[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g65[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g64[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g64[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g65[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g64[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g64[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g67[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g66[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g66[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g65[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g64[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g64[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g65[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g64[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g64[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g71[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g70[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g70[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g69[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g68[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g68[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g69[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g68[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g68[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g67[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g66[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g66[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g65[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g64[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g64[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g65[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g64[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g64[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g67[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g66[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g66[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g65[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g64[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g64[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g65[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g64[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g64[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g79[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g78[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g78[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g77[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g76[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g76[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g77[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g76[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g76[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g75[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g74[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g74[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g73[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g72[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g72[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g73[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g72[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g72[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g75[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g74[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g74[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g73[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g72[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g72[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g73[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g72[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g72[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g71[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g70[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g70[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g69[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g68[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g68[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g69[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g68[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g68[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g67[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g66[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g66[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g65[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g64[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g64[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g65[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g64[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g64[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g67[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g66[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g66[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g65[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g64[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g64[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g65[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g64[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g64[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g71[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g70[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g70[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g69[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g68[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g68[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g69[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g68[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g68[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g67[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g66[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g66[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g65[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g64[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g64[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g65[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g64[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g64[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g67[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g66[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g66[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g65[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g64[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g64[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g65[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g64[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g64[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g95[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g94[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g94[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g93[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g92[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g92[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g93[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g92[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g92[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g91[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g90[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g90[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g89[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g88[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g88[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g89[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g88[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g88[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g91[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g90[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g90[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g89[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g88[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g88[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g89[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g88[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g88[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g87[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g86[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g86[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g85[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g84[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g84[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g85[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g84[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g84[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g83[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g82[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g82[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g81[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g80[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g80[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g81[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g80[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g80[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g83[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g82[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g82[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g81[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g80[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g80[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g81[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g80[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g80[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g87[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g86[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g86[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g85[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g84[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g84[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g85[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g84[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g84[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g83[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g82[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g82[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g81[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g80[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g80[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g81[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g80[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g80[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g83[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g82[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g82[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g81[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g80[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g80[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g81[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g80[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g80[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g79[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g78[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g78[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g77[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g76[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g76[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g77[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g76[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g76[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g75[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g74[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g74[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g73[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g72[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g72[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g73[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g72[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g72[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g75[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g74[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g74[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g73[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g72[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g72[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g73[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g72[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g72[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g71[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g70[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g70[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g69[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g68[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g68[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g69[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g68[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g68[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g67[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g66[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g66[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g65[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g64[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g64[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g65[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g64[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g64[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g67[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g66[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g66[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g65[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g64[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g64[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g65[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g64[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g64[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g71[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g70[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g70[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g69[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g68[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g68[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g69[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g68[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g68[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g67[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g66[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g66[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g65[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g64[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g64[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g65[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g64[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g64[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g67[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g66[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g66[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g65[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g64[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g64[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g65[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g64[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g64[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g79[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g78[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g78[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g77[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g76[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g76[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g77[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g76[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g76[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g75[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g74[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g74[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g73[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g72[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g72[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g73[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g72[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g72[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g75[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g74[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g74[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g73[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g72[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g72[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g73[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g72[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g72[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g71[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g70[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g70[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g69[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g68[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g68[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g69[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g68[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g68[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g67[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g66[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g66[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g65[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g64[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g64[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g65[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g64[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g64[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g67[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g66[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g66[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g65[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g64[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g64[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g65[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g64[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g64[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g71[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g70[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g70[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g69[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g68[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g68[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g69[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g68[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g68[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g67[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g66[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g66[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g65[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g64[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g64[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g65[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g64[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g64[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g67[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g66[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g66[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g65[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g64[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g64[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g65[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g64[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g64[ix+0]*g0[iy+0]*g63[iz+0];
s[729] = + g63[ix+0]*g64[iy+0]*g0[iz+0];
s[730] = + g62[ix+0]*g65[iy+0]*g0[iz+0];
s[731] = + g62[ix+0]*g64[iy+0]*g1[iz+0];
s[732] = + g61[ix+0]*g66[iy+0]*g0[iz+0];
s[733] = + g60[ix+0]*g67[iy+0]*g0[iz+0];
s[734] = + g60[ix+0]*g66[iy+0]*g1[iz+0];
s[735] = + g61[ix+0]*g64[iy+0]*g2[iz+0];
s[736] = + g60[ix+0]*g65[iy+0]*g2[iz+0];
s[737] = + g60[ix+0]*g64[iy+0]*g3[iz+0];
s[738] = + g59[ix+0]*g68[iy+0]*g0[iz+0];
s[739] = + g58[ix+0]*g69[iy+0]*g0[iz+0];
s[740] = + g58[ix+0]*g68[iy+0]*g1[iz+0];
s[741] = + g57[ix+0]*g70[iy+0]*g0[iz+0];
s[742] = + g56[ix+0]*g71[iy+0]*g0[iz+0];
s[743] = + g56[ix+0]*g70[iy+0]*g1[iz+0];
s[744] = + g57[ix+0]*g68[iy+0]*g2[iz+0];
s[745] = + g56[ix+0]*g69[iy+0]*g2[iz+0];
s[746] = + g56[ix+0]*g68[iy+0]*g3[iz+0];
s[747] = + g59[ix+0]*g64[iy+0]*g4[iz+0];
s[748] = + g58[ix+0]*g65[iy+0]*g4[iz+0];
s[749] = + g58[ix+0]*g64[iy+0]*g5[iz+0];
s[750] = + g57[ix+0]*g66[iy+0]*g4[iz+0];
s[751] = + g56[ix+0]*g67[iy+0]*g4[iz+0];
s[752] = + g56[ix+0]*g66[iy+0]*g5[iz+0];
s[753] = + g57[ix+0]*g64[iy+0]*g6[iz+0];
s[754] = + g56[ix+0]*g65[iy+0]*g6[iz+0];
s[755] = + g56[ix+0]*g64[iy+0]*g7[iz+0];
s[756] = + g55[ix+0]*g72[iy+0]*g0[iz+0];
s[757] = + g54[ix+0]*g73[iy+0]*g0[iz+0];
s[758] = + g54[ix+0]*g72[iy+0]*g1[iz+0];
s[759] = + g53[ix+0]*g74[iy+0]*g0[iz+0];
s[760] = + g52[ix+0]*g75[iy+0]*g0[iz+0];
s[761] = + g52[ix+0]*g74[iy+0]*g1[iz+0];
s[762] = + g53[ix+0]*g72[iy+0]*g2[iz+0];
s[763] = + g52[ix+0]*g73[iy+0]*g2[iz+0];
s[764] = + g52[ix+0]*g72[iy+0]*g3[iz+0];
s[765] = + g51[ix+0]*g76[iy+0]*g0[iz+0];
s[766] = + g50[ix+0]*g77[iy+0]*g0[iz+0];
s[767] = + g50[ix+0]*g76[iy+0]*g1[iz+0];
s[768] = + g49[ix+0]*g78[iy+0]*g0[iz+0];
s[769] = + g48[ix+0]*g79[iy+0]*g0[iz+0];
s[770] = + g48[ix+0]*g78[iy+0]*g1[iz+0];
s[771] = + g49[ix+0]*g76[iy+0]*g2[iz+0];
s[772] = + g48[ix+0]*g77[iy+0]*g2[iz+0];
s[773] = + g48[ix+0]*g76[iy+0]*g3[iz+0];
s[774] = + g51[ix+0]*g72[iy+0]*g4[iz+0];
s[775] = + g50[ix+0]*g73[iy+0]*g4[iz+0];
s[776] = + g50[ix+0]*g72[iy+0]*g5[iz+0];
s[777] = + g49[ix+0]*g74[iy+0]*g4[iz+0];
s[778] = + g48[ix+0]*g75[iy+0]*g4[iz+0];
s[779] = + g48[ix+0]*g74[iy+0]*g5[iz+0];
s[780] = + g49[ix+0]*g72[iy+0]*g6[iz+0];
s[781] = + g48[ix+0]*g73[iy+0]*g6[iz+0];
s[782] = + g48[ix+0]*g72[iy+0]*g7[iz+0];
s[783] = + g55[ix+0]*g64[iy+0]*g8[iz+0];
s[784] = + g54[ix+0]*g65[iy+0]*g8[iz+0];
s[785] = + g54[ix+0]*g64[iy+0]*g9[iz+0];
s[786] = + g53[ix+0]*g66[iy+0]*g8[iz+0];
s[787] = + g52[ix+0]*g67[iy+0]*g8[iz+0];
s[788] = + g52[ix+0]*g66[iy+0]*g9[iz+0];
s[789] = + g53[ix+0]*g64[iy+0]*g10[iz+0];
s[790] = + g52[ix+0]*g65[iy+0]*g10[iz+0];
s[791] = + g52[ix+0]*g64[iy+0]*g11[iz+0];
s[792] = + g51[ix+0]*g68[iy+0]*g8[iz+0];
s[793] = + g50[ix+0]*g69[iy+0]*g8[iz+0];
s[794] = + g50[ix+0]*g68[iy+0]*g9[iz+0];
s[795] = + g49[ix+0]*g70[iy+0]*g8[iz+0];
s[796] = + g48[ix+0]*g71[iy+0]*g8[iz+0];
s[797] = + g48[ix+0]*g70[iy+0]*g9[iz+0];
s[798] = + g49[ix+0]*g68[iy+0]*g10[iz+0];
s[799] = + g48[ix+0]*g69[iy+0]*g10[iz+0];
s[800] = + g48[ix+0]*g68[iy+0]*g11[iz+0];
s[801] = + g51[ix+0]*g64[iy+0]*g12[iz+0];
s[802] = + g50[ix+0]*g65[iy+0]*g12[iz+0];
s[803] = + g50[ix+0]*g64[iy+0]*g13[iz+0];
s[804] = + g49[ix+0]*g66[iy+0]*g12[iz+0];
s[805] = + g48[ix+0]*g67[iy+0]*g12[iz+0];
s[806] = + g48[ix+0]*g66[iy+0]*g13[iz+0];
s[807] = + g49[ix+0]*g64[iy+0]*g14[iz+0];
s[808] = + g48[ix+0]*g65[iy+0]*g14[iz+0];
s[809] = + g48[ix+0]*g64[iy+0]*g15[iz+0];
s[810] = + g47[ix+0]*g80[iy+0]*g0[iz+0];
s[811] = + g46[ix+0]*g81[iy+0]*g0[iz+0];
s[812] = + g46[ix+0]*g80[iy+0]*g1[iz+0];
s[813] = + g45[ix+0]*g82[iy+0]*g0[iz+0];
s[814] = + g44[ix+0]*g83[iy+0]*g0[iz+0];
s[815] = + g44[ix+0]*g82[iy+0]*g1[iz+0];
s[816] = + g45[ix+0]*g80[iy+0]*g2[iz+0];
s[817] = + g44[ix+0]*g81[iy+0]*g2[iz+0];
s[818] = + g44[ix+0]*g80[iy+0]*g3[iz+0];
s[819] = + g43[ix+0]*g84[iy+0]*g0[iz+0];
s[820] = + g42[ix+0]*g85[iy+0]*g0[iz+0];
s[821] = + g42[ix+0]*g84[iy+0]*g1[iz+0];
s[822] = + g41[ix+0]*g86[iy+0]*g0[iz+0];
s[823] = + g40[ix+0]*g87[iy+0]*g0[iz+0];
s[824] = + g40[ix+0]*g86[iy+0]*g1[iz+0];
s[825] = + g41[ix+0]*g84[iy+0]*g2[iz+0];
s[826] = + g40[ix+0]*g85[iy+0]*g2[iz+0];
s[827] = + g40[ix+0]*g84[iy+0]*g3[iz+0];
s[828] = + g43[ix+0]*g80[iy+0]*g4[iz+0];
s[829] = + g42[ix+0]*g81[iy+0]*g4[iz+0];
s[830] = + g42[ix+0]*g80[iy+0]*g5[iz+0];
s[831] = + g41[ix+0]*g82[iy+0]*g4[iz+0];
s[832] = + g40[ix+0]*g83[iy+0]*g4[iz+0];
s[833] = + g40[ix+0]*g82[iy+0]*g5[iz+0];
s[834] = + g41[ix+0]*g80[iy+0]*g6[iz+0];
s[835] = + g40[ix+0]*g81[iy+0]*g6[iz+0];
s[836] = + g40[ix+0]*g80[iy+0]*g7[iz+0];
s[837] = + g39[ix+0]*g88[iy+0]*g0[iz+0];
s[838] = + g38[ix+0]*g89[iy+0]*g0[iz+0];
s[839] = + g38[ix+0]*g88[iy+0]*g1[iz+0];
s[840] = + g37[ix+0]*g90[iy+0]*g0[iz+0];
s[841] = + g36[ix+0]*g91[iy+0]*g0[iz+0];
s[842] = + g36[ix+0]*g90[iy+0]*g1[iz+0];
s[843] = + g37[ix+0]*g88[iy+0]*g2[iz+0];
s[844] = + g36[ix+0]*g89[iy+0]*g2[iz+0];
s[845] = + g36[ix+0]*g88[iy+0]*g3[iz+0];
s[846] = + g35[ix+0]*g92[iy+0]*g0[iz+0];
s[847] = + g34[ix+0]*g93[iy+0]*g0[iz+0];
s[848] = + g34[ix+0]*g92[iy+0]*g1[iz+0];
s[849] = + g33[ix+0]*g94[iy+0]*g0[iz+0];
s[850] = + g32[ix+0]*g95[iy+0]*g0[iz+0];
s[851] = + g32[ix+0]*g94[iy+0]*g1[iz+0];
s[852] = + g33[ix+0]*g92[iy+0]*g2[iz+0];
s[853] = + g32[ix+0]*g93[iy+0]*g2[iz+0];
s[854] = + g32[ix+0]*g92[iy+0]*g3[iz+0];
s[855] = + g35[ix+0]*g88[iy+0]*g4[iz+0];
s[856] = + g34[ix+0]*g89[iy+0]*g4[iz+0];
s[857] = + g34[ix+0]*g88[iy+0]*g5[iz+0];
s[858] = + g33[ix+0]*g90[iy+0]*g4[iz+0];
s[859] = + g32[ix+0]*g91[iy+0]*g4[iz+0];
s[860] = + g32[ix+0]*g90[iy+0]*g5[iz+0];
s[861] = + g33[ix+0]*g88[iy+0]*g6[iz+0];
s[862] = + g32[ix+0]*g89[iy+0]*g6[iz+0];
s[863] = + g32[ix+0]*g88[iy+0]*g7[iz+0];
s[864] = + g39[ix+0]*g80[iy+0]*g8[iz+0];
s[865] = + g38[ix+0]*g81[iy+0]*g8[iz+0];
s[866] = + g38[ix+0]*g80[iy+0]*g9[iz+0];
s[867] = + g37[ix+0]*g82[iy+0]*g8[iz+0];
s[868] = + g36[ix+0]*g83[iy+0]*g8[iz+0];
s[869] = + g36[ix+0]*g82[iy+0]*g9[iz+0];
s[870] = + g37[ix+0]*g80[iy+0]*g10[iz+0];
s[871] = + g36[ix+0]*g81[iy+0]*g10[iz+0];
s[872] = + g36[ix+0]*g80[iy+0]*g11[iz+0];
s[873] = + g35[ix+0]*g84[iy+0]*g8[iz+0];
s[874] = + g34[ix+0]*g85[iy+0]*g8[iz+0];
s[875] = + g34[ix+0]*g84[iy+0]*g9[iz+0];
s[876] = + g33[ix+0]*g86[iy+0]*g8[iz+0];
s[877] = + g32[ix+0]*g87[iy+0]*g8[iz+0];
s[878] = + g32[ix+0]*g86[iy+0]*g9[iz+0];
s[879] = + g33[ix+0]*g84[iy+0]*g10[iz+0];
s[880] = + g32[ix+0]*g85[iy+0]*g10[iz+0];
s[881] = + g32[ix+0]*g84[iy+0]*g11[iz+0];
s[882] = + g35[ix+0]*g80[iy+0]*g12[iz+0];
s[883] = + g34[ix+0]*g81[iy+0]*g12[iz+0];
s[884] = + g34[ix+0]*g80[iy+0]*g13[iz+0];
s[885] = + g33[ix+0]*g82[iy+0]*g12[iz+0];
s[886] = + g32[ix+0]*g83[iy+0]*g12[iz+0];
s[887] = + g32[ix+0]*g82[iy+0]*g13[iz+0];
s[888] = + g33[ix+0]*g80[iy+0]*g14[iz+0];
s[889] = + g32[ix+0]*g81[iy+0]*g14[iz+0];
s[890] = + g32[ix+0]*g80[iy+0]*g15[iz+0];
s[891] = + g47[ix+0]*g64[iy+0]*g16[iz+0];
s[892] = + g46[ix+0]*g65[iy+0]*g16[iz+0];
s[893] = + g46[ix+0]*g64[iy+0]*g17[iz+0];
s[894] = + g45[ix+0]*g66[iy+0]*g16[iz+0];
s[895] = + g44[ix+0]*g67[iy+0]*g16[iz+0];
s[896] = + g44[ix+0]*g66[iy+0]*g17[iz+0];
s[897] = + g45[ix+0]*g64[iy+0]*g18[iz+0];
s[898] = + g44[ix+0]*g65[iy+0]*g18[iz+0];
s[899] = + g44[ix+0]*g64[iy+0]*g19[iz+0];
s[900] = + g43[ix+0]*g68[iy+0]*g16[iz+0];
s[901] = + g42[ix+0]*g69[iy+0]*g16[iz+0];
s[902] = + g42[ix+0]*g68[iy+0]*g17[iz+0];
s[903] = + g41[ix+0]*g70[iy+0]*g16[iz+0];
s[904] = + g40[ix+0]*g71[iy+0]*g16[iz+0];
s[905] = + g40[ix+0]*g70[iy+0]*g17[iz+0];
s[906] = + g41[ix+0]*g68[iy+0]*g18[iz+0];
s[907] = + g40[ix+0]*g69[iy+0]*g18[iz+0];
s[908] = + g40[ix+0]*g68[iy+0]*g19[iz+0];
s[909] = + g43[ix+0]*g64[iy+0]*g20[iz+0];
s[910] = + g42[ix+0]*g65[iy+0]*g20[iz+0];
s[911] = + g42[ix+0]*g64[iy+0]*g21[iz+0];
s[912] = + g41[ix+0]*g66[iy+0]*g20[iz+0];
s[913] = + g40[ix+0]*g67[iy+0]*g20[iz+0];
s[914] = + g40[ix+0]*g66[iy+0]*g21[iz+0];
s[915] = + g41[ix+0]*g64[iy+0]*g22[iz+0];
s[916] = + g40[ix+0]*g65[iy+0]*g22[iz+0];
s[917] = + g40[ix+0]*g64[iy+0]*g23[iz+0];
s[918] = + g39[ix+0]*g72[iy+0]*g16[iz+0];
s[919] = + g38[ix+0]*g73[iy+0]*g16[iz+0];
s[920] = + g38[ix+0]*g72[iy+0]*g17[iz+0];
s[921] = + g37[ix+0]*g74[iy+0]*g16[iz+0];
s[922] = + g36[ix+0]*g75[iy+0]*g16[iz+0];
s[923] = + g36[ix+0]*g74[iy+0]*g17[iz+0];
s[924] = + g37[ix+0]*g72[iy+0]*g18[iz+0];
s[925] = + g36[ix+0]*g73[iy+0]*g18[iz+0];
s[926] = + g36[ix+0]*g72[iy+0]*g19[iz+0];
s[927] = + g35[ix+0]*g76[iy+0]*g16[iz+0];
s[928] = + g34[ix+0]*g77[iy+0]*g16[iz+0];
s[929] = + g34[ix+0]*g76[iy+0]*g17[iz+0];
s[930] = + g33[ix+0]*g78[iy+0]*g16[iz+0];
s[931] = + g32[ix+0]*g79[iy+0]*g16[iz+0];
s[932] = + g32[ix+0]*g78[iy+0]*g17[iz+0];
s[933] = + g33[ix+0]*g76[iy+0]*g18[iz+0];
s[934] = + g32[ix+0]*g77[iy+0]*g18[iz+0];
s[935] = + g32[ix+0]*g76[iy+0]*g19[iz+0];
s[936] = + g35[ix+0]*g72[iy+0]*g20[iz+0];
s[937] = + g34[ix+0]*g73[iy+0]*g20[iz+0];
s[938] = + g34[ix+0]*g72[iy+0]*g21[iz+0];
s[939] = + g33[ix+0]*g74[iy+0]*g20[iz+0];
s[940] = + g32[ix+0]*g75[iy+0]*g20[iz+0];
s[941] = + g32[ix+0]*g74[iy+0]*g21[iz+0];
s[942] = + g33[ix+0]*g72[iy+0]*g22[iz+0];
s[943] = + g32[ix+0]*g73[iy+0]*g22[iz+0];
s[944] = + g32[ix+0]*g72[iy+0]*g23[iz+0];
s[945] = + g39[ix+0]*g64[iy+0]*g24[iz+0];
s[946] = + g38[ix+0]*g65[iy+0]*g24[iz+0];
s[947] = + g38[ix+0]*g64[iy+0]*g25[iz+0];
s[948] = + g37[ix+0]*g66[iy+0]*g24[iz+0];
s[949] = + g36[ix+0]*g67[iy+0]*g24[iz+0];
s[950] = + g36[ix+0]*g66[iy+0]*g25[iz+0];
s[951] = + g37[ix+0]*g64[iy+0]*g26[iz+0];
s[952] = + g36[ix+0]*g65[iy+0]*g26[iz+0];
s[953] = + g36[ix+0]*g64[iy+0]*g27[iz+0];
s[954] = + g35[ix+0]*g68[iy+0]*g24[iz+0];
s[955] = + g34[ix+0]*g69[iy+0]*g24[iz+0];
s[956] = + g34[ix+0]*g68[iy+0]*g25[iz+0];
s[957] = + g33[ix+0]*g70[iy+0]*g24[iz+0];
s[958] = + g32[ix+0]*g71[iy+0]*g24[iz+0];
s[959] = + g32[ix+0]*g70[iy+0]*g25[iz+0];
s[960] = + g33[ix+0]*g68[iy+0]*g26[iz+0];
s[961] = + g32[ix+0]*g69[iy+0]*g26[iz+0];
s[962] = + g32[ix+0]*g68[iy+0]*g27[iz+0];
s[963] = + g35[ix+0]*g64[iy+0]*g28[iz+0];
s[964] = + g34[ix+0]*g65[iy+0]*g28[iz+0];
s[965] = + g34[ix+0]*g64[iy+0]*g29[iz+0];
s[966] = + g33[ix+0]*g66[iy+0]*g28[iz+0];
s[967] = + g32[ix+0]*g67[iy+0]*g28[iz+0];
s[968] = + g32[ix+0]*g66[iy+0]*g29[iz+0];
s[969] = + g33[ix+0]*g64[iy+0]*g30[iz+0];
s[970] = + g32[ix+0]*g65[iy+0]*g30[iz+0];
s[971] = + g32[ix+0]*g64[iy+0]*g31[iz+0];
s[972] = + g31[ix+0]*g96[iy+0]*g0[iz+0];
s[973] = + g30[ix+0]*g97[iy+0]*g0[iz+0];
s[974] = + g30[ix+0]*g96[iy+0]*g1[iz+0];
s[975] = + g29[ix+0]*g98[iy+0]*g0[iz+0];
s[976] = + g28[ix+0]*g99[iy+0]*g0[iz+0];
s[977] = + g28[ix+0]*g98[iy+0]*g1[iz+0];
s[978] = + g29[ix+0]*g96[iy+0]*g2[iz+0];
s[979] = + g28[ix+0]*g97[iy+0]*g2[iz+0];
s[980] = + g28[ix+0]*g96[iy+0]*g3[iz+0];
s[981] = + g27[ix+0]*g100[iy+0]*g0[iz+0];
s[982] = + g26[ix+0]*g101[iy+0]*g0[iz+0];
s[983] = + g26[ix+0]*g100[iy+0]*g1[iz+0];
s[984] = + g25[ix+0]*g102[iy+0]*g0[iz+0];
s[985] = + g24[ix+0]*g103[iy+0]*g0[iz+0];
s[986] = + g24[ix+0]*g102[iy+0]*g1[iz+0];
s[987] = + g25[ix+0]*g100[iy+0]*g2[iz+0];
s[988] = + g24[ix+0]*g101[iy+0]*g2[iz+0];
s[989] = + g24[ix+0]*g100[iy+0]*g3[iz+0];
s[990] = + g27[ix+0]*g96[iy+0]*g4[iz+0];
s[991] = + g26[ix+0]*g97[iy+0]*g4[iz+0];
s[992] = + g26[ix+0]*g96[iy+0]*g5[iz+0];
s[993] = + g25[ix+0]*g98[iy+0]*g4[iz+0];
s[994] = + g24[ix+0]*g99[iy+0]*g4[iz+0];
s[995] = + g24[ix+0]*g98[iy+0]*g5[iz+0];
s[996] = + g25[ix+0]*g96[iy+0]*g6[iz+0];
s[997] = + g24[ix+0]*g97[iy+0]*g6[iz+0];
s[998] = + g24[ix+0]*g96[iy+0]*g7[iz+0];
s[999] = + g23[ix+0]*g104[iy+0]*g0[iz+0];
s[1000] = + g22[ix+0]*g105[iy+0]*g0[iz+0];
s[1001] = + g22[ix+0]*g104[iy+0]*g1[iz+0];
s[1002] = + g21[ix+0]*g106[iy+0]*g0[iz+0];
s[1003] = + g20[ix+0]*g107[iy+0]*g0[iz+0];
s[1004] = + g20[ix+0]*g106[iy+0]*g1[iz+0];
s[1005] = + g21[ix+0]*g104[iy+0]*g2[iz+0];
s[1006] = + g20[ix+0]*g105[iy+0]*g2[iz+0];
s[1007] = + g20[ix+0]*g104[iy+0]*g3[iz+0];
s[1008] = + g19[ix+0]*g108[iy+0]*g0[iz+0];
s[1009] = + g18[ix+0]*g109[iy+0]*g0[iz+0];
s[1010] = + g18[ix+0]*g108[iy+0]*g1[iz+0];
s[1011] = + g17[ix+0]*g110[iy+0]*g0[iz+0];
s[1012] = + g16[ix+0]*g111[iy+0]*g0[iz+0];
s[1013] = + g16[ix+0]*g110[iy+0]*g1[iz+0];
s[1014] = + g17[ix+0]*g108[iy+0]*g2[iz+0];
s[1015] = + g16[ix+0]*g109[iy+0]*g2[iz+0];
s[1016] = + g16[ix+0]*g108[iy+0]*g3[iz+0];
s[1017] = + g19[ix+0]*g104[iy+0]*g4[iz+0];
s[1018] = + g18[ix+0]*g105[iy+0]*g4[iz+0];
s[1019] = + g18[ix+0]*g104[iy+0]*g5[iz+0];
s[1020] = + g17[ix+0]*g106[iy+0]*g4[iz+0];
s[1021] = + g16[ix+0]*g107[iy+0]*g4[iz+0];
s[1022] = + g16[ix+0]*g106[iy+0]*g5[iz+0];
s[1023] = + g17[ix+0]*g104[iy+0]*g6[iz+0];
s[1024] = + g16[ix+0]*g105[iy+0]*g6[iz+0];
s[1025] = + g16[ix+0]*g104[iy+0]*g7[iz+0];
s[1026] = + g23[ix+0]*g96[iy+0]*g8[iz+0];
s[1027] = + g22[ix+0]*g97[iy+0]*g8[iz+0];
s[1028] = + g22[ix+0]*g96[iy+0]*g9[iz+0];
s[1029] = + g21[ix+0]*g98[iy+0]*g8[iz+0];
s[1030] = + g20[ix+0]*g99[iy+0]*g8[iz+0];
s[1031] = + g20[ix+0]*g98[iy+0]*g9[iz+0];
s[1032] = + g21[ix+0]*g96[iy+0]*g10[iz+0];
s[1033] = + g20[ix+0]*g97[iy+0]*g10[iz+0];
s[1034] = + g20[ix+0]*g96[iy+0]*g11[iz+0];
s[1035] = + g19[ix+0]*g100[iy+0]*g8[iz+0];
s[1036] = + g18[ix+0]*g101[iy+0]*g8[iz+0];
s[1037] = + g18[ix+0]*g100[iy+0]*g9[iz+0];
s[1038] = + g17[ix+0]*g102[iy+0]*g8[iz+0];
s[1039] = + g16[ix+0]*g103[iy+0]*g8[iz+0];
s[1040] = + g16[ix+0]*g102[iy+0]*g9[iz+0];
s[1041] = + g17[ix+0]*g100[iy+0]*g10[iz+0];
s[1042] = + g16[ix+0]*g101[iy+0]*g10[iz+0];
s[1043] = + g16[ix+0]*g100[iy+0]*g11[iz+0];
s[1044] = + g19[ix+0]*g96[iy+0]*g12[iz+0];
s[1045] = + g18[ix+0]*g97[iy+0]*g12[iz+0];
s[1046] = + g18[ix+0]*g96[iy+0]*g13[iz+0];
s[1047] = + g17[ix+0]*g98[iy+0]*g12[iz+0];
s[1048] = + g16[ix+0]*g99[iy+0]*g12[iz+0];
s[1049] = + g16[ix+0]*g98[iy+0]*g13[iz+0];
s[1050] = + g17[ix+0]*g96[iy+0]*g14[iz+0];
s[1051] = + g16[ix+0]*g97[iy+0]*g14[iz+0];
s[1052] = + g16[ix+0]*g96[iy+0]*g15[iz+0];
s[1053] = + g15[ix+0]*g112[iy+0]*g0[iz+0];
s[1054] = + g14[ix+0]*g113[iy+0]*g0[iz+0];
s[1055] = + g14[ix+0]*g112[iy+0]*g1[iz+0];
s[1056] = + g13[ix+0]*g114[iy+0]*g0[iz+0];
s[1057] = + g12[ix+0]*g115[iy+0]*g0[iz+0];
s[1058] = + g12[ix+0]*g114[iy+0]*g1[iz+0];
s[1059] = + g13[ix+0]*g112[iy+0]*g2[iz+0];
s[1060] = + g12[ix+0]*g113[iy+0]*g2[iz+0];
s[1061] = + g12[ix+0]*g112[iy+0]*g3[iz+0];
s[1062] = + g11[ix+0]*g116[iy+0]*g0[iz+0];
s[1063] = + g10[ix+0]*g117[iy+0]*g0[iz+0];
s[1064] = + g10[ix+0]*g116[iy+0]*g1[iz+0];
s[1065] = + g9[ix+0]*g118[iy+0]*g0[iz+0];
s[1066] = + g8[ix+0]*g119[iy+0]*g0[iz+0];
s[1067] = + g8[ix+0]*g118[iy+0]*g1[iz+0];
s[1068] = + g9[ix+0]*g116[iy+0]*g2[iz+0];
s[1069] = + g8[ix+0]*g117[iy+0]*g2[iz+0];
s[1070] = + g8[ix+0]*g116[iy+0]*g3[iz+0];
s[1071] = + g11[ix+0]*g112[iy+0]*g4[iz+0];
s[1072] = + g10[ix+0]*g113[iy+0]*g4[iz+0];
s[1073] = + g10[ix+0]*g112[iy+0]*g5[iz+0];
s[1074] = + g9[ix+0]*g114[iy+0]*g4[iz+0];
s[1075] = + g8[ix+0]*g115[iy+0]*g4[iz+0];
s[1076] = + g8[ix+0]*g114[iy+0]*g5[iz+0];
s[1077] = + g9[ix+0]*g112[iy+0]*g6[iz+0];
s[1078] = + g8[ix+0]*g113[iy+0]*g6[iz+0];
s[1079] = + g8[ix+0]*g112[iy+0]*g7[iz+0];
s[1080] = + g7[ix+0]*g120[iy+0]*g0[iz+0];
s[1081] = + g6[ix+0]*g121[iy+0]*g0[iz+0];
s[1082] = + g6[ix+0]*g120[iy+0]*g1[iz+0];
s[1083] = + g5[ix+0]*g122[iy+0]*g0[iz+0];
s[1084] = + g4[ix+0]*g123[iy+0]*g0[iz+0];
s[1085] = + g4[ix+0]*g122[iy+0]*g1[iz+0];
s[1086] = + g5[ix+0]*g120[iy+0]*g2[iz+0];
s[1087] = + g4[ix+0]*g121[iy+0]*g2[iz+0];
s[1088] = + g4[ix+0]*g120[iy+0]*g3[iz+0];
s[1089] = + g3[ix+0]*g124[iy+0]*g0[iz+0];
s[1090] = + g2[ix+0]*g125[iy+0]*g0[iz+0];
s[1091] = + g2[ix+0]*g124[iy+0]*g1[iz+0];
s[1092] = + g1[ix+0]*g126[iy+0]*g0[iz+0];
s[1093] = + g0[ix+0]*g127[iy+0]*g0[iz+0];
s[1094] = + g0[ix+0]*g126[iy+0]*g1[iz+0];
s[1095] = + g1[ix+0]*g124[iy+0]*g2[iz+0];
s[1096] = + g0[ix+0]*g125[iy+0]*g2[iz+0];
s[1097] = + g0[ix+0]*g124[iy+0]*g3[iz+0];
s[1098] = + g3[ix+0]*g120[iy+0]*g4[iz+0];
s[1099] = + g2[ix+0]*g121[iy+0]*g4[iz+0];
s[1100] = + g2[ix+0]*g120[iy+0]*g5[iz+0];
s[1101] = + g1[ix+0]*g122[iy+0]*g4[iz+0];
s[1102] = + g0[ix+0]*g123[iy+0]*g4[iz+0];
s[1103] = + g0[ix+0]*g122[iy+0]*g5[iz+0];
s[1104] = + g1[ix+0]*g120[iy+0]*g6[iz+0];
s[1105] = + g0[ix+0]*g121[iy+0]*g6[iz+0];
s[1106] = + g0[ix+0]*g120[iy+0]*g7[iz+0];
s[1107] = + g7[ix+0]*g112[iy+0]*g8[iz+0];
s[1108] = + g6[ix+0]*g113[iy+0]*g8[iz+0];
s[1109] = + g6[ix+0]*g112[iy+0]*g9[iz+0];
s[1110] = + g5[ix+0]*g114[iy+0]*g8[iz+0];
s[1111] = + g4[ix+0]*g115[iy+0]*g8[iz+0];
s[1112] = + g4[ix+0]*g114[iy+0]*g9[iz+0];
s[1113] = + g5[ix+0]*g112[iy+0]*g10[iz+0];
s[1114] = + g4[ix+0]*g113[iy+0]*g10[iz+0];
s[1115] = + g4[ix+0]*g112[iy+0]*g11[iz+0];
s[1116] = + g3[ix+0]*g116[iy+0]*g8[iz+0];
s[1117] = + g2[ix+0]*g117[iy+0]*g8[iz+0];
s[1118] = + g2[ix+0]*g116[iy+0]*g9[iz+0];
s[1119] = + g1[ix+0]*g118[iy+0]*g8[iz+0];
s[1120] = + g0[ix+0]*g119[iy+0]*g8[iz+0];
s[1121] = + g0[ix+0]*g118[iy+0]*g9[iz+0];
s[1122] = + g1[ix+0]*g116[iy+0]*g10[iz+0];
s[1123] = + g0[ix+0]*g117[iy+0]*g10[iz+0];
s[1124] = + g0[ix+0]*g116[iy+0]*g11[iz+0];
s[1125] = + g3[ix+0]*g112[iy+0]*g12[iz+0];
s[1126] = + g2[ix+0]*g113[iy+0]*g12[iz+0];
s[1127] = + g2[ix+0]*g112[iy+0]*g13[iz+0];
s[1128] = + g1[ix+0]*g114[iy+0]*g12[iz+0];
s[1129] = + g0[ix+0]*g115[iy+0]*g12[iz+0];
s[1130] = + g0[ix+0]*g114[iy+0]*g13[iz+0];
s[1131] = + g1[ix+0]*g112[iy+0]*g14[iz+0];
s[1132] = + g0[ix+0]*g113[iy+0]*g14[iz+0];
s[1133] = + g0[ix+0]*g112[iy+0]*g15[iz+0];
s[1134] = + g15[ix+0]*g96[iy+0]*g16[iz+0];
s[1135] = + g14[ix+0]*g97[iy+0]*g16[iz+0];
s[1136] = + g14[ix+0]*g96[iy+0]*g17[iz+0];
s[1137] = + g13[ix+0]*g98[iy+0]*g16[iz+0];
s[1138] = + g12[ix+0]*g99[iy+0]*g16[iz+0];
s[1139] = + g12[ix+0]*g98[iy+0]*g17[iz+0];
s[1140] = + g13[ix+0]*g96[iy+0]*g18[iz+0];
s[1141] = + g12[ix+0]*g97[iy+0]*g18[iz+0];
s[1142] = + g12[ix+0]*g96[iy+0]*g19[iz+0];
s[1143] = + g11[ix+0]*g100[iy+0]*g16[iz+0];
s[1144] = + g10[ix+0]*g101[iy+0]*g16[iz+0];
s[1145] = + g10[ix+0]*g100[iy+0]*g17[iz+0];
s[1146] = + g9[ix+0]*g102[iy+0]*g16[iz+0];
s[1147] = + g8[ix+0]*g103[iy+0]*g16[iz+0];
s[1148] = + g8[ix+0]*g102[iy+0]*g17[iz+0];
s[1149] = + g9[ix+0]*g100[iy+0]*g18[iz+0];
s[1150] = + g8[ix+0]*g101[iy+0]*g18[iz+0];
s[1151] = + g8[ix+0]*g100[iy+0]*g19[iz+0];
s[1152] = + g11[ix+0]*g96[iy+0]*g20[iz+0];
s[1153] = + g10[ix+0]*g97[iy+0]*g20[iz+0];
s[1154] = + g10[ix+0]*g96[iy+0]*g21[iz+0];
s[1155] = + g9[ix+0]*g98[iy+0]*g20[iz+0];
s[1156] = + g8[ix+0]*g99[iy+0]*g20[iz+0];
s[1157] = + g8[ix+0]*g98[iy+0]*g21[iz+0];
s[1158] = + g9[ix+0]*g96[iy+0]*g22[iz+0];
s[1159] = + g8[ix+0]*g97[iy+0]*g22[iz+0];
s[1160] = + g8[ix+0]*g96[iy+0]*g23[iz+0];
s[1161] = + g7[ix+0]*g104[iy+0]*g16[iz+0];
s[1162] = + g6[ix+0]*g105[iy+0]*g16[iz+0];
s[1163] = + g6[ix+0]*g104[iy+0]*g17[iz+0];
s[1164] = + g5[ix+0]*g106[iy+0]*g16[iz+0];
s[1165] = + g4[ix+0]*g107[iy+0]*g16[iz+0];
s[1166] = + g4[ix+0]*g106[iy+0]*g17[iz+0];
s[1167] = + g5[ix+0]*g104[iy+0]*g18[iz+0];
s[1168] = + g4[ix+0]*g105[iy+0]*g18[iz+0];
s[1169] = + g4[ix+0]*g104[iy+0]*g19[iz+0];
s[1170] = + g3[ix+0]*g108[iy+0]*g16[iz+0];
s[1171] = + g2[ix+0]*g109[iy+0]*g16[iz+0];
s[1172] = + g2[ix+0]*g108[iy+0]*g17[iz+0];
s[1173] = + g1[ix+0]*g110[iy+0]*g16[iz+0];
s[1174] = + g0[ix+0]*g111[iy+0]*g16[iz+0];
s[1175] = + g0[ix+0]*g110[iy+0]*g17[iz+0];
s[1176] = + g1[ix+0]*g108[iy+0]*g18[iz+0];
s[1177] = + g0[ix+0]*g109[iy+0]*g18[iz+0];
s[1178] = + g0[ix+0]*g108[iy+0]*g19[iz+0];
s[1179] = + g3[ix+0]*g104[iy+0]*g20[iz+0];
s[1180] = + g2[ix+0]*g105[iy+0]*g20[iz+0];
s[1181] = + g2[ix+0]*g104[iy+0]*g21[iz+0];
s[1182] = + g1[ix+0]*g106[iy+0]*g20[iz+0];
s[1183] = + g0[ix+0]*g107[iy+0]*g20[iz+0];
s[1184] = + g0[ix+0]*g106[iy+0]*g21[iz+0];
s[1185] = + g1[ix+0]*g104[iy+0]*g22[iz+0];
s[1186] = + g0[ix+0]*g105[iy+0]*g22[iz+0];
s[1187] = + g0[ix+0]*g104[iy+0]*g23[iz+0];
s[1188] = + g7[ix+0]*g96[iy+0]*g24[iz+0];
s[1189] = + g6[ix+0]*g97[iy+0]*g24[iz+0];
s[1190] = + g6[ix+0]*g96[iy+0]*g25[iz+0];
s[1191] = + g5[ix+0]*g98[iy+0]*g24[iz+0];
s[1192] = + g4[ix+0]*g99[iy+0]*g24[iz+0];
s[1193] = + g4[ix+0]*g98[iy+0]*g25[iz+0];
s[1194] = + g5[ix+0]*g96[iy+0]*g26[iz+0];
s[1195] = + g4[ix+0]*g97[iy+0]*g26[iz+0];
s[1196] = + g4[ix+0]*g96[iy+0]*g27[iz+0];
s[1197] = + g3[ix+0]*g100[iy+0]*g24[iz+0];
s[1198] = + g2[ix+0]*g101[iy+0]*g24[iz+0];
s[1199] = + g2[ix+0]*g100[iy+0]*g25[iz+0];
s[1200] = + g1[ix+0]*g102[iy+0]*g24[iz+0];
s[1201] = + g0[ix+0]*g103[iy+0]*g24[iz+0];
s[1202] = + g0[ix+0]*g102[iy+0]*g25[iz+0];
s[1203] = + g1[ix+0]*g100[iy+0]*g26[iz+0];
s[1204] = + g0[ix+0]*g101[iy+0]*g26[iz+0];
s[1205] = + g0[ix+0]*g100[iy+0]*g27[iz+0];
s[1206] = + g3[ix+0]*g96[iy+0]*g28[iz+0];
s[1207] = + g2[ix+0]*g97[iy+0]*g28[iz+0];
s[1208] = + g2[ix+0]*g96[iy+0]*g29[iz+0];
s[1209] = + g1[ix+0]*g98[iy+0]*g28[iz+0];
s[1210] = + g0[ix+0]*g99[iy+0]*g28[iz+0];
s[1211] = + g0[ix+0]*g98[iy+0]*g29[iz+0];
s[1212] = + g1[ix+0]*g96[iy+0]*g30[iz+0];
s[1213] = + g0[ix+0]*g97[iy+0]*g30[iz+0];
s[1214] = + g0[ix+0]*g96[iy+0]*g31[iz+0];
s[1215] = + g31[ix+0]*g64[iy+0]*g32[iz+0];
s[1216] = + g30[ix+0]*g65[iy+0]*g32[iz+0];
s[1217] = + g30[ix+0]*g64[iy+0]*g33[iz+0];
s[1218] = + g29[ix+0]*g66[iy+0]*g32[iz+0];
s[1219] = + g28[ix+0]*g67[iy+0]*g32[iz+0];
s[1220] = + g28[ix+0]*g66[iy+0]*g33[iz+0];
s[1221] = + g29[ix+0]*g64[iy+0]*g34[iz+0];
s[1222] = + g28[ix+0]*g65[iy+0]*g34[iz+0];
s[1223] = + g28[ix+0]*g64[iy+0]*g35[iz+0];
s[1224] = + g27[ix+0]*g68[iy+0]*g32[iz+0];
s[1225] = + g26[ix+0]*g69[iy+0]*g32[iz+0];
s[1226] = + g26[ix+0]*g68[iy+0]*g33[iz+0];
s[1227] = + g25[ix+0]*g70[iy+0]*g32[iz+0];
s[1228] = + g24[ix+0]*g71[iy+0]*g32[iz+0];
s[1229] = + g24[ix+0]*g70[iy+0]*g33[iz+0];
s[1230] = + g25[ix+0]*g68[iy+0]*g34[iz+0];
s[1231] = + g24[ix+0]*g69[iy+0]*g34[iz+0];
s[1232] = + g24[ix+0]*g68[iy+0]*g35[iz+0];
s[1233] = + g27[ix+0]*g64[iy+0]*g36[iz+0];
s[1234] = + g26[ix+0]*g65[iy+0]*g36[iz+0];
s[1235] = + g26[ix+0]*g64[iy+0]*g37[iz+0];
s[1236] = + g25[ix+0]*g66[iy+0]*g36[iz+0];
s[1237] = + g24[ix+0]*g67[iy+0]*g36[iz+0];
s[1238] = + g24[ix+0]*g66[iy+0]*g37[iz+0];
s[1239] = + g25[ix+0]*g64[iy+0]*g38[iz+0];
s[1240] = + g24[ix+0]*g65[iy+0]*g38[iz+0];
s[1241] = + g24[ix+0]*g64[iy+0]*g39[iz+0];
s[1242] = + g23[ix+0]*g72[iy+0]*g32[iz+0];
s[1243] = + g22[ix+0]*g73[iy+0]*g32[iz+0];
s[1244] = + g22[ix+0]*g72[iy+0]*g33[iz+0];
s[1245] = + g21[ix+0]*g74[iy+0]*g32[iz+0];
s[1246] = + g20[ix+0]*g75[iy+0]*g32[iz+0];
s[1247] = + g20[ix+0]*g74[iy+0]*g33[iz+0];
s[1248] = + g21[ix+0]*g72[iy+0]*g34[iz+0];
s[1249] = + g20[ix+0]*g73[iy+0]*g34[iz+0];
s[1250] = + g20[ix+0]*g72[iy+0]*g35[iz+0];
s[1251] = + g19[ix+0]*g76[iy+0]*g32[iz+0];
s[1252] = + g18[ix+0]*g77[iy+0]*g32[iz+0];
s[1253] = + g18[ix+0]*g76[iy+0]*g33[iz+0];
s[1254] = + g17[ix+0]*g78[iy+0]*g32[iz+0];
s[1255] = + g16[ix+0]*g79[iy+0]*g32[iz+0];
s[1256] = + g16[ix+0]*g78[iy+0]*g33[iz+0];
s[1257] = + g17[ix+0]*g76[iy+0]*g34[iz+0];
s[1258] = + g16[ix+0]*g77[iy+0]*g34[iz+0];
s[1259] = + g16[ix+0]*g76[iy+0]*g35[iz+0];
s[1260] = + g19[ix+0]*g72[iy+0]*g36[iz+0];
s[1261] = + g18[ix+0]*g73[iy+0]*g36[iz+0];
s[1262] = + g18[ix+0]*g72[iy+0]*g37[iz+0];
s[1263] = + g17[ix+0]*g74[iy+0]*g36[iz+0];
s[1264] = + g16[ix+0]*g75[iy+0]*g36[iz+0];
s[1265] = + g16[ix+0]*g74[iy+0]*g37[iz+0];
s[1266] = + g17[ix+0]*g72[iy+0]*g38[iz+0];
s[1267] = + g16[ix+0]*g73[iy+0]*g38[iz+0];
s[1268] = + g16[ix+0]*g72[iy+0]*g39[iz+0];
s[1269] = + g23[ix+0]*g64[iy+0]*g40[iz+0];
s[1270] = + g22[ix+0]*g65[iy+0]*g40[iz+0];
s[1271] = + g22[ix+0]*g64[iy+0]*g41[iz+0];
s[1272] = + g21[ix+0]*g66[iy+0]*g40[iz+0];
s[1273] = + g20[ix+0]*g67[iy+0]*g40[iz+0];
s[1274] = + g20[ix+0]*g66[iy+0]*g41[iz+0];
s[1275] = + g21[ix+0]*g64[iy+0]*g42[iz+0];
s[1276] = + g20[ix+0]*g65[iy+0]*g42[iz+0];
s[1277] = + g20[ix+0]*g64[iy+0]*g43[iz+0];
s[1278] = + g19[ix+0]*g68[iy+0]*g40[iz+0];
s[1279] = + g18[ix+0]*g69[iy+0]*g40[iz+0];
s[1280] = + g18[ix+0]*g68[iy+0]*g41[iz+0];
s[1281] = + g17[ix+0]*g70[iy+0]*g40[iz+0];
s[1282] = + g16[ix+0]*g71[iy+0]*g40[iz+0];
s[1283] = + g16[ix+0]*g70[iy+0]*g41[iz+0];
s[1284] = + g17[ix+0]*g68[iy+0]*g42[iz+0];
s[1285] = + g16[ix+0]*g69[iy+0]*g42[iz+0];
s[1286] = + g16[ix+0]*g68[iy+0]*g43[iz+0];
s[1287] = + g19[ix+0]*g64[iy+0]*g44[iz+0];
s[1288] = + g18[ix+0]*g65[iy+0]*g44[iz+0];
s[1289] = + g18[ix+0]*g64[iy+0]*g45[iz+0];
s[1290] = + g17[ix+0]*g66[iy+0]*g44[iz+0];
s[1291] = + g16[ix+0]*g67[iy+0]*g44[iz+0];
s[1292] = + g16[ix+0]*g66[iy+0]*g45[iz+0];
s[1293] = + g17[ix+0]*g64[iy+0]*g46[iz+0];
s[1294] = + g16[ix+0]*g65[iy+0]*g46[iz+0];
s[1295] = + g16[ix+0]*g64[iy+0]*g47[iz+0];
s[1296] = + g15[ix+0]*g80[iy+0]*g32[iz+0];
s[1297] = + g14[ix+0]*g81[iy+0]*g32[iz+0];
s[1298] = + g14[ix+0]*g80[iy+0]*g33[iz+0];
s[1299] = + g13[ix+0]*g82[iy+0]*g32[iz+0];
s[1300] = + g12[ix+0]*g83[iy+0]*g32[iz+0];
s[1301] = + g12[ix+0]*g82[iy+0]*g33[iz+0];
s[1302] = + g13[ix+0]*g80[iy+0]*g34[iz+0];
s[1303] = + g12[ix+0]*g81[iy+0]*g34[iz+0];
s[1304] = + g12[ix+0]*g80[iy+0]*g35[iz+0];
s[1305] = + g11[ix+0]*g84[iy+0]*g32[iz+0];
s[1306] = + g10[ix+0]*g85[iy+0]*g32[iz+0];
s[1307] = + g10[ix+0]*g84[iy+0]*g33[iz+0];
s[1308] = + g9[ix+0]*g86[iy+0]*g32[iz+0];
s[1309] = + g8[ix+0]*g87[iy+0]*g32[iz+0];
s[1310] = + g8[ix+0]*g86[iy+0]*g33[iz+0];
s[1311] = + g9[ix+0]*g84[iy+0]*g34[iz+0];
s[1312] = + g8[ix+0]*g85[iy+0]*g34[iz+0];
s[1313] = + g8[ix+0]*g84[iy+0]*g35[iz+0];
s[1314] = + g11[ix+0]*g80[iy+0]*g36[iz+0];
s[1315] = + g10[ix+0]*g81[iy+0]*g36[iz+0];
s[1316] = + g10[ix+0]*g80[iy+0]*g37[iz+0];
s[1317] = + g9[ix+0]*g82[iy+0]*g36[iz+0];
s[1318] = + g8[ix+0]*g83[iy+0]*g36[iz+0];
s[1319] = + g8[ix+0]*g82[iy+0]*g37[iz+0];
s[1320] = + g9[ix+0]*g80[iy+0]*g38[iz+0];
s[1321] = + g8[ix+0]*g81[iy+0]*g38[iz+0];
s[1322] = + g8[ix+0]*g80[iy+0]*g39[iz+0];
s[1323] = + g7[ix+0]*g88[iy+0]*g32[iz+0];
s[1324] = + g6[ix+0]*g89[iy+0]*g32[iz+0];
s[1325] = + g6[ix+0]*g88[iy+0]*g33[iz+0];
s[1326] = + g5[ix+0]*g90[iy+0]*g32[iz+0];
s[1327] = + g4[ix+0]*g91[iy+0]*g32[iz+0];
s[1328] = + g4[ix+0]*g90[iy+0]*g33[iz+0];
s[1329] = + g5[ix+0]*g88[iy+0]*g34[iz+0];
s[1330] = + g4[ix+0]*g89[iy+0]*g34[iz+0];
s[1331] = + g4[ix+0]*g88[iy+0]*g35[iz+0];
s[1332] = + g3[ix+0]*g92[iy+0]*g32[iz+0];
s[1333] = + g2[ix+0]*g93[iy+0]*g32[iz+0];
s[1334] = + g2[ix+0]*g92[iy+0]*g33[iz+0];
s[1335] = + g1[ix+0]*g94[iy+0]*g32[iz+0];
s[1336] = + g0[ix+0]*g95[iy+0]*g32[iz+0];
s[1337] = + g0[ix+0]*g94[iy+0]*g33[iz+0];
s[1338] = + g1[ix+0]*g92[iy+0]*g34[iz+0];
s[1339] = + g0[ix+0]*g93[iy+0]*g34[iz+0];
s[1340] = + g0[ix+0]*g92[iy+0]*g35[iz+0];
s[1341] = + g3[ix+0]*g88[iy+0]*g36[iz+0];
s[1342] = + g2[ix+0]*g89[iy+0]*g36[iz+0];
s[1343] = + g2[ix+0]*g88[iy+0]*g37[iz+0];
s[1344] = + g1[ix+0]*g90[iy+0]*g36[iz+0];
s[1345] = + g0[ix+0]*g91[iy+0]*g36[iz+0];
s[1346] = + g0[ix+0]*g90[iy+0]*g37[iz+0];
s[1347] = + g1[ix+0]*g88[iy+0]*g38[iz+0];
s[1348] = + g0[ix+0]*g89[iy+0]*g38[iz+0];
s[1349] = + g0[ix+0]*g88[iy+0]*g39[iz+0];
s[1350] = + g7[ix+0]*g80[iy+0]*g40[iz+0];
s[1351] = + g6[ix+0]*g81[iy+0]*g40[iz+0];
s[1352] = + g6[ix+0]*g80[iy+0]*g41[iz+0];
s[1353] = + g5[ix+0]*g82[iy+0]*g40[iz+0];
s[1354] = + g4[ix+0]*g83[iy+0]*g40[iz+0];
s[1355] = + g4[ix+0]*g82[iy+0]*g41[iz+0];
s[1356] = + g5[ix+0]*g80[iy+0]*g42[iz+0];
s[1357] = + g4[ix+0]*g81[iy+0]*g42[iz+0];
s[1358] = + g4[ix+0]*g80[iy+0]*g43[iz+0];
s[1359] = + g3[ix+0]*g84[iy+0]*g40[iz+0];
s[1360] = + g2[ix+0]*g85[iy+0]*g40[iz+0];
s[1361] = + g2[ix+0]*g84[iy+0]*g41[iz+0];
s[1362] = + g1[ix+0]*g86[iy+0]*g40[iz+0];
s[1363] = + g0[ix+0]*g87[iy+0]*g40[iz+0];
s[1364] = + g0[ix+0]*g86[iy+0]*g41[iz+0];
s[1365] = + g1[ix+0]*g84[iy+0]*g42[iz+0];
s[1366] = + g0[ix+0]*g85[iy+0]*g42[iz+0];
s[1367] = + g0[ix+0]*g84[iy+0]*g43[iz+0];
s[1368] = + g3[ix+0]*g80[iy+0]*g44[iz+0];
s[1369] = + g2[ix+0]*g81[iy+0]*g44[iz+0];
s[1370] = + g2[ix+0]*g80[iy+0]*g45[iz+0];
s[1371] = + g1[ix+0]*g82[iy+0]*g44[iz+0];
s[1372] = + g0[ix+0]*g83[iy+0]*g44[iz+0];
s[1373] = + g0[ix+0]*g82[iy+0]*g45[iz+0];
s[1374] = + g1[ix+0]*g80[iy+0]*g46[iz+0];
s[1375] = + g0[ix+0]*g81[iy+0]*g46[iz+0];
s[1376] = + g0[ix+0]*g80[iy+0]*g47[iz+0];
s[1377] = + g15[ix+0]*g64[iy+0]*g48[iz+0];
s[1378] = + g14[ix+0]*g65[iy+0]*g48[iz+0];
s[1379] = + g14[ix+0]*g64[iy+0]*g49[iz+0];
s[1380] = + g13[ix+0]*g66[iy+0]*g48[iz+0];
s[1381] = + g12[ix+0]*g67[iy+0]*g48[iz+0];
s[1382] = + g12[ix+0]*g66[iy+0]*g49[iz+0];
s[1383] = + g13[ix+0]*g64[iy+0]*g50[iz+0];
s[1384] = + g12[ix+0]*g65[iy+0]*g50[iz+0];
s[1385] = + g12[ix+0]*g64[iy+0]*g51[iz+0];
s[1386] = + g11[ix+0]*g68[iy+0]*g48[iz+0];
s[1387] = + g10[ix+0]*g69[iy+0]*g48[iz+0];
s[1388] = + g10[ix+0]*g68[iy+0]*g49[iz+0];
s[1389] = + g9[ix+0]*g70[iy+0]*g48[iz+0];
s[1390] = + g8[ix+0]*g71[iy+0]*g48[iz+0];
s[1391] = + g8[ix+0]*g70[iy+0]*g49[iz+0];
s[1392] = + g9[ix+0]*g68[iy+0]*g50[iz+0];
s[1393] = + g8[ix+0]*g69[iy+0]*g50[iz+0];
s[1394] = + g8[ix+0]*g68[iy+0]*g51[iz+0];
s[1395] = + g11[ix+0]*g64[iy+0]*g52[iz+0];
s[1396] = + g10[ix+0]*g65[iy+0]*g52[iz+0];
s[1397] = + g10[ix+0]*g64[iy+0]*g53[iz+0];
s[1398] = + g9[ix+0]*g66[iy+0]*g52[iz+0];
s[1399] = + g8[ix+0]*g67[iy+0]*g52[iz+0];
s[1400] = + g8[ix+0]*g66[iy+0]*g53[iz+0];
s[1401] = + g9[ix+0]*g64[iy+0]*g54[iz+0];
s[1402] = + g8[ix+0]*g65[iy+0]*g54[iz+0];
s[1403] = + g8[ix+0]*g64[iy+0]*g55[iz+0];
s[1404] = + g7[ix+0]*g72[iy+0]*g48[iz+0];
s[1405] = + g6[ix+0]*g73[iy+0]*g48[iz+0];
s[1406] = + g6[ix+0]*g72[iy+0]*g49[iz+0];
s[1407] = + g5[ix+0]*g74[iy+0]*g48[iz+0];
s[1408] = + g4[ix+0]*g75[iy+0]*g48[iz+0];
s[1409] = + g4[ix+0]*g74[iy+0]*g49[iz+0];
s[1410] = + g5[ix+0]*g72[iy+0]*g50[iz+0];
s[1411] = + g4[ix+0]*g73[iy+0]*g50[iz+0];
s[1412] = + g4[ix+0]*g72[iy+0]*g51[iz+0];
s[1413] = + g3[ix+0]*g76[iy+0]*g48[iz+0];
s[1414] = + g2[ix+0]*g77[iy+0]*g48[iz+0];
s[1415] = + g2[ix+0]*g76[iy+0]*g49[iz+0];
s[1416] = + g1[ix+0]*g78[iy+0]*g48[iz+0];
s[1417] = + g0[ix+0]*g79[iy+0]*g48[iz+0];
s[1418] = + g0[ix+0]*g78[iy+0]*g49[iz+0];
s[1419] = + g1[ix+0]*g76[iy+0]*g50[iz+0];
s[1420] = + g0[ix+0]*g77[iy+0]*g50[iz+0];
s[1421] = + g0[ix+0]*g76[iy+0]*g51[iz+0];
s[1422] = + g3[ix+0]*g72[iy+0]*g52[iz+0];
s[1423] = + g2[ix+0]*g73[iy+0]*g52[iz+0];
s[1424] = + g2[ix+0]*g72[iy+0]*g53[iz+0];
s[1425] = + g1[ix+0]*g74[iy+0]*g52[iz+0];
s[1426] = + g0[ix+0]*g75[iy+0]*g52[iz+0];
s[1427] = + g0[ix+0]*g74[iy+0]*g53[iz+0];
s[1428] = + g1[ix+0]*g72[iy+0]*g54[iz+0];
s[1429] = + g0[ix+0]*g73[iy+0]*g54[iz+0];
s[1430] = + g0[ix+0]*g72[iy+0]*g55[iz+0];
s[1431] = + g7[ix+0]*g64[iy+0]*g56[iz+0];
s[1432] = + g6[ix+0]*g65[iy+0]*g56[iz+0];
s[1433] = + g6[ix+0]*g64[iy+0]*g57[iz+0];
s[1434] = + g5[ix+0]*g66[iy+0]*g56[iz+0];
s[1435] = + g4[ix+0]*g67[iy+0]*g56[iz+0];
s[1436] = + g4[ix+0]*g66[iy+0]*g57[iz+0];
s[1437] = + g5[ix+0]*g64[iy+0]*g58[iz+0];
s[1438] = + g4[ix+0]*g65[iy+0]*g58[iz+0];
s[1439] = + g4[ix+0]*g64[iy+0]*g59[iz+0];
s[1440] = + g3[ix+0]*g68[iy+0]*g56[iz+0];
s[1441] = + g2[ix+0]*g69[iy+0]*g56[iz+0];
s[1442] = + g2[ix+0]*g68[iy+0]*g57[iz+0];
s[1443] = + g1[ix+0]*g70[iy+0]*g56[iz+0];
s[1444] = + g0[ix+0]*g71[iy+0]*g56[iz+0];
s[1445] = + g0[ix+0]*g70[iy+0]*g57[iz+0];
s[1446] = + g1[ix+0]*g68[iy+0]*g58[iz+0];
s[1447] = + g0[ix+0]*g69[iy+0]*g58[iz+0];
s[1448] = + g0[ix+0]*g68[iy+0]*g59[iz+0];
s[1449] = + g3[ix+0]*g64[iy+0]*g60[iz+0];
s[1450] = + g2[ix+0]*g65[iy+0]*g60[iz+0];
s[1451] = + g2[ix+0]*g64[iy+0]*g61[iz+0];
s[1452] = + g1[ix+0]*g66[iy+0]*g60[iz+0];
s[1453] = + g0[ix+0]*g67[iy+0]*g60[iz+0];
s[1454] = + g0[ix+0]*g66[iy+0]*g61[iz+0];
s[1455] = + g1[ix+0]*g64[iy+0]*g62[iz+0];
s[1456] = + g0[ix+0]*g65[iy+0]*g62[iz+0];
s[1457] = + g0[ix+0]*g64[iy+0]*g63[iz+0];
s[1458] = + g63[ix+0]*g0[iy+0]*g64[iz+0];
s[1459] = + g62[ix+0]*g1[iy+0]*g64[iz+0];
s[1460] = + g62[ix+0]*g0[iy+0]*g65[iz+0];
s[1461] = + g61[ix+0]*g2[iy+0]*g64[iz+0];
s[1462] = + g60[ix+0]*g3[iy+0]*g64[iz+0];
s[1463] = + g60[ix+0]*g2[iy+0]*g65[iz+0];
s[1464] = + g61[ix+0]*g0[iy+0]*g66[iz+0];
s[1465] = + g60[ix+0]*g1[iy+0]*g66[iz+0];
s[1466] = + g60[ix+0]*g0[iy+0]*g67[iz+0];
s[1467] = + g59[ix+0]*g4[iy+0]*g64[iz+0];
s[1468] = + g58[ix+0]*g5[iy+0]*g64[iz+0];
s[1469] = + g58[ix+0]*g4[iy+0]*g65[iz+0];
s[1470] = + g57[ix+0]*g6[iy+0]*g64[iz+0];
s[1471] = + g56[ix+0]*g7[iy+0]*g64[iz+0];
s[1472] = + g56[ix+0]*g6[iy+0]*g65[iz+0];
s[1473] = + g57[ix+0]*g4[iy+0]*g66[iz+0];
s[1474] = + g56[ix+0]*g5[iy+0]*g66[iz+0];
s[1475] = + g56[ix+0]*g4[iy+0]*g67[iz+0];
s[1476] = + g59[ix+0]*g0[iy+0]*g68[iz+0];
s[1477] = + g58[ix+0]*g1[iy+0]*g68[iz+0];
s[1478] = + g58[ix+0]*g0[iy+0]*g69[iz+0];
s[1479] = + g57[ix+0]*g2[iy+0]*g68[iz+0];
s[1480] = + g56[ix+0]*g3[iy+0]*g68[iz+0];
s[1481] = + g56[ix+0]*g2[iy+0]*g69[iz+0];
s[1482] = + g57[ix+0]*g0[iy+0]*g70[iz+0];
s[1483] = + g56[ix+0]*g1[iy+0]*g70[iz+0];
s[1484] = + g56[ix+0]*g0[iy+0]*g71[iz+0];
s[1485] = + g55[ix+0]*g8[iy+0]*g64[iz+0];
s[1486] = + g54[ix+0]*g9[iy+0]*g64[iz+0];
s[1487] = + g54[ix+0]*g8[iy+0]*g65[iz+0];
s[1488] = + g53[ix+0]*g10[iy+0]*g64[iz+0];
s[1489] = + g52[ix+0]*g11[iy+0]*g64[iz+0];
s[1490] = + g52[ix+0]*g10[iy+0]*g65[iz+0];
s[1491] = + g53[ix+0]*g8[iy+0]*g66[iz+0];
s[1492] = + g52[ix+0]*g9[iy+0]*g66[iz+0];
s[1493] = + g52[ix+0]*g8[iy+0]*g67[iz+0];
s[1494] = + g51[ix+0]*g12[iy+0]*g64[iz+0];
s[1495] = + g50[ix+0]*g13[iy+0]*g64[iz+0];
s[1496] = + g50[ix+0]*g12[iy+0]*g65[iz+0];
s[1497] = + g49[ix+0]*g14[iy+0]*g64[iz+0];
s[1498] = + g48[ix+0]*g15[iy+0]*g64[iz+0];
s[1499] = + g48[ix+0]*g14[iy+0]*g65[iz+0];
s[1500] = + g49[ix+0]*g12[iy+0]*g66[iz+0];
s[1501] = + g48[ix+0]*g13[iy+0]*g66[iz+0];
s[1502] = + g48[ix+0]*g12[iy+0]*g67[iz+0];
s[1503] = + g51[ix+0]*g8[iy+0]*g68[iz+0];
s[1504] = + g50[ix+0]*g9[iy+0]*g68[iz+0];
s[1505] = + g50[ix+0]*g8[iy+0]*g69[iz+0];
s[1506] = + g49[ix+0]*g10[iy+0]*g68[iz+0];
s[1507] = + g48[ix+0]*g11[iy+0]*g68[iz+0];
s[1508] = + g48[ix+0]*g10[iy+0]*g69[iz+0];
s[1509] = + g49[ix+0]*g8[iy+0]*g70[iz+0];
s[1510] = + g48[ix+0]*g9[iy+0]*g70[iz+0];
s[1511] = + g48[ix+0]*g8[iy+0]*g71[iz+0];
s[1512] = + g55[ix+0]*g0[iy+0]*g72[iz+0];
s[1513] = + g54[ix+0]*g1[iy+0]*g72[iz+0];
s[1514] = + g54[ix+0]*g0[iy+0]*g73[iz+0];
s[1515] = + g53[ix+0]*g2[iy+0]*g72[iz+0];
s[1516] = + g52[ix+0]*g3[iy+0]*g72[iz+0];
s[1517] = + g52[ix+0]*g2[iy+0]*g73[iz+0];
s[1518] = + g53[ix+0]*g0[iy+0]*g74[iz+0];
s[1519] = + g52[ix+0]*g1[iy+0]*g74[iz+0];
s[1520] = + g52[ix+0]*g0[iy+0]*g75[iz+0];
s[1521] = + g51[ix+0]*g4[iy+0]*g72[iz+0];
s[1522] = + g50[ix+0]*g5[iy+0]*g72[iz+0];
s[1523] = + g50[ix+0]*g4[iy+0]*g73[iz+0];
s[1524] = + g49[ix+0]*g6[iy+0]*g72[iz+0];
s[1525] = + g48[ix+0]*g7[iy+0]*g72[iz+0];
s[1526] = + g48[ix+0]*g6[iy+0]*g73[iz+0];
s[1527] = + g49[ix+0]*g4[iy+0]*g74[iz+0];
s[1528] = + g48[ix+0]*g5[iy+0]*g74[iz+0];
s[1529] = + g48[ix+0]*g4[iy+0]*g75[iz+0];
s[1530] = + g51[ix+0]*g0[iy+0]*g76[iz+0];
s[1531] = + g50[ix+0]*g1[iy+0]*g76[iz+0];
s[1532] = + g50[ix+0]*g0[iy+0]*g77[iz+0];
s[1533] = + g49[ix+0]*g2[iy+0]*g76[iz+0];
s[1534] = + g48[ix+0]*g3[iy+0]*g76[iz+0];
s[1535] = + g48[ix+0]*g2[iy+0]*g77[iz+0];
s[1536] = + g49[ix+0]*g0[iy+0]*g78[iz+0];
s[1537] = + g48[ix+0]*g1[iy+0]*g78[iz+0];
s[1538] = + g48[ix+0]*g0[iy+0]*g79[iz+0];
s[1539] = + g47[ix+0]*g16[iy+0]*g64[iz+0];
s[1540] = + g46[ix+0]*g17[iy+0]*g64[iz+0];
s[1541] = + g46[ix+0]*g16[iy+0]*g65[iz+0];
s[1542] = + g45[ix+0]*g18[iy+0]*g64[iz+0];
s[1543] = + g44[ix+0]*g19[iy+0]*g64[iz+0];
s[1544] = + g44[ix+0]*g18[iy+0]*g65[iz+0];
s[1545] = + g45[ix+0]*g16[iy+0]*g66[iz+0];
s[1546] = + g44[ix+0]*g17[iy+0]*g66[iz+0];
s[1547] = + g44[ix+0]*g16[iy+0]*g67[iz+0];
s[1548] = + g43[ix+0]*g20[iy+0]*g64[iz+0];
s[1549] = + g42[ix+0]*g21[iy+0]*g64[iz+0];
s[1550] = + g42[ix+0]*g20[iy+0]*g65[iz+0];
s[1551] = + g41[ix+0]*g22[iy+0]*g64[iz+0];
s[1552] = + g40[ix+0]*g23[iy+0]*g64[iz+0];
s[1553] = + g40[ix+0]*g22[iy+0]*g65[iz+0];
s[1554] = + g41[ix+0]*g20[iy+0]*g66[iz+0];
s[1555] = + g40[ix+0]*g21[iy+0]*g66[iz+0];
s[1556] = + g40[ix+0]*g20[iy+0]*g67[iz+0];
s[1557] = + g43[ix+0]*g16[iy+0]*g68[iz+0];
s[1558] = + g42[ix+0]*g17[iy+0]*g68[iz+0];
s[1559] = + g42[ix+0]*g16[iy+0]*g69[iz+0];
s[1560] = + g41[ix+0]*g18[iy+0]*g68[iz+0];
s[1561] = + g40[ix+0]*g19[iy+0]*g68[iz+0];
s[1562] = + g40[ix+0]*g18[iy+0]*g69[iz+0];
s[1563] = + g41[ix+0]*g16[iy+0]*g70[iz+0];
s[1564] = + g40[ix+0]*g17[iy+0]*g70[iz+0];
s[1565] = + g40[ix+0]*g16[iy+0]*g71[iz+0];
s[1566] = + g39[ix+0]*g24[iy+0]*g64[iz+0];
s[1567] = + g38[ix+0]*g25[iy+0]*g64[iz+0];
s[1568] = + g38[ix+0]*g24[iy+0]*g65[iz+0];
s[1569] = + g37[ix+0]*g26[iy+0]*g64[iz+0];
s[1570] = + g36[ix+0]*g27[iy+0]*g64[iz+0];
s[1571] = + g36[ix+0]*g26[iy+0]*g65[iz+0];
s[1572] = + g37[ix+0]*g24[iy+0]*g66[iz+0];
s[1573] = + g36[ix+0]*g25[iy+0]*g66[iz+0];
s[1574] = + g36[ix+0]*g24[iy+0]*g67[iz+0];
s[1575] = + g35[ix+0]*g28[iy+0]*g64[iz+0];
s[1576] = + g34[ix+0]*g29[iy+0]*g64[iz+0];
s[1577] = + g34[ix+0]*g28[iy+0]*g65[iz+0];
s[1578] = + g33[ix+0]*g30[iy+0]*g64[iz+0];
s[1579] = + g32[ix+0]*g31[iy+0]*g64[iz+0];
s[1580] = + g32[ix+0]*g30[iy+0]*g65[iz+0];
s[1581] = + g33[ix+0]*g28[iy+0]*g66[iz+0];
s[1582] = + g32[ix+0]*g29[iy+0]*g66[iz+0];
s[1583] = + g32[ix+0]*g28[iy+0]*g67[iz+0];
s[1584] = + g35[ix+0]*g24[iy+0]*g68[iz+0];
s[1585] = + g34[ix+0]*g25[iy+0]*g68[iz+0];
s[1586] = + g34[ix+0]*g24[iy+0]*g69[iz+0];
s[1587] = + g33[ix+0]*g26[iy+0]*g68[iz+0];
s[1588] = + g32[ix+0]*g27[iy+0]*g68[iz+0];
s[1589] = + g32[ix+0]*g26[iy+0]*g69[iz+0];
s[1590] = + g33[ix+0]*g24[iy+0]*g70[iz+0];
s[1591] = + g32[ix+0]*g25[iy+0]*g70[iz+0];
s[1592] = + g32[ix+0]*g24[iy+0]*g71[iz+0];
s[1593] = + g39[ix+0]*g16[iy+0]*g72[iz+0];
s[1594] = + g38[ix+0]*g17[iy+0]*g72[iz+0];
s[1595] = + g38[ix+0]*g16[iy+0]*g73[iz+0];
s[1596] = + g37[ix+0]*g18[iy+0]*g72[iz+0];
s[1597] = + g36[ix+0]*g19[iy+0]*g72[iz+0];
s[1598] = + g36[ix+0]*g18[iy+0]*g73[iz+0];
s[1599] = + g37[ix+0]*g16[iy+0]*g74[iz+0];
s[1600] = + g36[ix+0]*g17[iy+0]*g74[iz+0];
s[1601] = + g36[ix+0]*g16[iy+0]*g75[iz+0];
s[1602] = + g35[ix+0]*g20[iy+0]*g72[iz+0];
s[1603] = + g34[ix+0]*g21[iy+0]*g72[iz+0];
s[1604] = + g34[ix+0]*g20[iy+0]*g73[iz+0];
s[1605] = + g33[ix+0]*g22[iy+0]*g72[iz+0];
s[1606] = + g32[ix+0]*g23[iy+0]*g72[iz+0];
s[1607] = + g32[ix+0]*g22[iy+0]*g73[iz+0];
s[1608] = + g33[ix+0]*g20[iy+0]*g74[iz+0];
s[1609] = + g32[ix+0]*g21[iy+0]*g74[iz+0];
s[1610] = + g32[ix+0]*g20[iy+0]*g75[iz+0];
s[1611] = + g35[ix+0]*g16[iy+0]*g76[iz+0];
s[1612] = + g34[ix+0]*g17[iy+0]*g76[iz+0];
s[1613] = + g34[ix+0]*g16[iy+0]*g77[iz+0];
s[1614] = + g33[ix+0]*g18[iy+0]*g76[iz+0];
s[1615] = + g32[ix+0]*g19[iy+0]*g76[iz+0];
s[1616] = + g32[ix+0]*g18[iy+0]*g77[iz+0];
s[1617] = + g33[ix+0]*g16[iy+0]*g78[iz+0];
s[1618] = + g32[ix+0]*g17[iy+0]*g78[iz+0];
s[1619] = + g32[ix+0]*g16[iy+0]*g79[iz+0];
s[1620] = + g47[ix+0]*g0[iy+0]*g80[iz+0];
s[1621] = + g46[ix+0]*g1[iy+0]*g80[iz+0];
s[1622] = + g46[ix+0]*g0[iy+0]*g81[iz+0];
s[1623] = + g45[ix+0]*g2[iy+0]*g80[iz+0];
s[1624] = + g44[ix+0]*g3[iy+0]*g80[iz+0];
s[1625] = + g44[ix+0]*g2[iy+0]*g81[iz+0];
s[1626] = + g45[ix+0]*g0[iy+0]*g82[iz+0];
s[1627] = + g44[ix+0]*g1[iy+0]*g82[iz+0];
s[1628] = + g44[ix+0]*g0[iy+0]*g83[iz+0];
s[1629] = + g43[ix+0]*g4[iy+0]*g80[iz+0];
s[1630] = + g42[ix+0]*g5[iy+0]*g80[iz+0];
s[1631] = + g42[ix+0]*g4[iy+0]*g81[iz+0];
s[1632] = + g41[ix+0]*g6[iy+0]*g80[iz+0];
s[1633] = + g40[ix+0]*g7[iy+0]*g80[iz+0];
s[1634] = + g40[ix+0]*g6[iy+0]*g81[iz+0];
s[1635] = + g41[ix+0]*g4[iy+0]*g82[iz+0];
s[1636] = + g40[ix+0]*g5[iy+0]*g82[iz+0];
s[1637] = + g40[ix+0]*g4[iy+0]*g83[iz+0];
s[1638] = + g43[ix+0]*g0[iy+0]*g84[iz+0];
s[1639] = + g42[ix+0]*g1[iy+0]*g84[iz+0];
s[1640] = + g42[ix+0]*g0[iy+0]*g85[iz+0];
s[1641] = + g41[ix+0]*g2[iy+0]*g84[iz+0];
s[1642] = + g40[ix+0]*g3[iy+0]*g84[iz+0];
s[1643] = + g40[ix+0]*g2[iy+0]*g85[iz+0];
s[1644] = + g41[ix+0]*g0[iy+0]*g86[iz+0];
s[1645] = + g40[ix+0]*g1[iy+0]*g86[iz+0];
s[1646] = + g40[ix+0]*g0[iy+0]*g87[iz+0];
s[1647] = + g39[ix+0]*g8[iy+0]*g80[iz+0];
s[1648] = + g38[ix+0]*g9[iy+0]*g80[iz+0];
s[1649] = + g38[ix+0]*g8[iy+0]*g81[iz+0];
s[1650] = + g37[ix+0]*g10[iy+0]*g80[iz+0];
s[1651] = + g36[ix+0]*g11[iy+0]*g80[iz+0];
s[1652] = + g36[ix+0]*g10[iy+0]*g81[iz+0];
s[1653] = + g37[ix+0]*g8[iy+0]*g82[iz+0];
s[1654] = + g36[ix+0]*g9[iy+0]*g82[iz+0];
s[1655] = + g36[ix+0]*g8[iy+0]*g83[iz+0];
s[1656] = + g35[ix+0]*g12[iy+0]*g80[iz+0];
s[1657] = + g34[ix+0]*g13[iy+0]*g80[iz+0];
s[1658] = + g34[ix+0]*g12[iy+0]*g81[iz+0];
s[1659] = + g33[ix+0]*g14[iy+0]*g80[iz+0];
s[1660] = + g32[ix+0]*g15[iy+0]*g80[iz+0];
s[1661] = + g32[ix+0]*g14[iy+0]*g81[iz+0];
s[1662] = + g33[ix+0]*g12[iy+0]*g82[iz+0];
s[1663] = + g32[ix+0]*g13[iy+0]*g82[iz+0];
s[1664] = + g32[ix+0]*g12[iy+0]*g83[iz+0];
s[1665] = + g35[ix+0]*g8[iy+0]*g84[iz+0];
s[1666] = + g34[ix+0]*g9[iy+0]*g84[iz+0];
s[1667] = + g34[ix+0]*g8[iy+0]*g85[iz+0];
s[1668] = + g33[ix+0]*g10[iy+0]*g84[iz+0];
s[1669] = + g32[ix+0]*g11[iy+0]*g84[iz+0];
s[1670] = + g32[ix+0]*g10[iy+0]*g85[iz+0];
s[1671] = + g33[ix+0]*g8[iy+0]*g86[iz+0];
s[1672] = + g32[ix+0]*g9[iy+0]*g86[iz+0];
s[1673] = + g32[ix+0]*g8[iy+0]*g87[iz+0];
s[1674] = + g39[ix+0]*g0[iy+0]*g88[iz+0];
s[1675] = + g38[ix+0]*g1[iy+0]*g88[iz+0];
s[1676] = + g38[ix+0]*g0[iy+0]*g89[iz+0];
s[1677] = + g37[ix+0]*g2[iy+0]*g88[iz+0];
s[1678] = + g36[ix+0]*g3[iy+0]*g88[iz+0];
s[1679] = + g36[ix+0]*g2[iy+0]*g89[iz+0];
s[1680] = + g37[ix+0]*g0[iy+0]*g90[iz+0];
s[1681] = + g36[ix+0]*g1[iy+0]*g90[iz+0];
s[1682] = + g36[ix+0]*g0[iy+0]*g91[iz+0];
s[1683] = + g35[ix+0]*g4[iy+0]*g88[iz+0];
s[1684] = + g34[ix+0]*g5[iy+0]*g88[iz+0];
s[1685] = + g34[ix+0]*g4[iy+0]*g89[iz+0];
s[1686] = + g33[ix+0]*g6[iy+0]*g88[iz+0];
s[1687] = + g32[ix+0]*g7[iy+0]*g88[iz+0];
s[1688] = + g32[ix+0]*g6[iy+0]*g89[iz+0];
s[1689] = + g33[ix+0]*g4[iy+0]*g90[iz+0];
s[1690] = + g32[ix+0]*g5[iy+0]*g90[iz+0];
s[1691] = + g32[ix+0]*g4[iy+0]*g91[iz+0];
s[1692] = + g35[ix+0]*g0[iy+0]*g92[iz+0];
s[1693] = + g34[ix+0]*g1[iy+0]*g92[iz+0];
s[1694] = + g34[ix+0]*g0[iy+0]*g93[iz+0];
s[1695] = + g33[ix+0]*g2[iy+0]*g92[iz+0];
s[1696] = + g32[ix+0]*g3[iy+0]*g92[iz+0];
s[1697] = + g32[ix+0]*g2[iy+0]*g93[iz+0];
s[1698] = + g33[ix+0]*g0[iy+0]*g94[iz+0];
s[1699] = + g32[ix+0]*g1[iy+0]*g94[iz+0];
s[1700] = + g32[ix+0]*g0[iy+0]*g95[iz+0];
s[1701] = + g31[ix+0]*g32[iy+0]*g64[iz+0];
s[1702] = + g30[ix+0]*g33[iy+0]*g64[iz+0];
s[1703] = + g30[ix+0]*g32[iy+0]*g65[iz+0];
s[1704] = + g29[ix+0]*g34[iy+0]*g64[iz+0];
s[1705] = + g28[ix+0]*g35[iy+0]*g64[iz+0];
s[1706] = + g28[ix+0]*g34[iy+0]*g65[iz+0];
s[1707] = + g29[ix+0]*g32[iy+0]*g66[iz+0];
s[1708] = + g28[ix+0]*g33[iy+0]*g66[iz+0];
s[1709] = + g28[ix+0]*g32[iy+0]*g67[iz+0];
s[1710] = + g27[ix+0]*g36[iy+0]*g64[iz+0];
s[1711] = + g26[ix+0]*g37[iy+0]*g64[iz+0];
s[1712] = + g26[ix+0]*g36[iy+0]*g65[iz+0];
s[1713] = + g25[ix+0]*g38[iy+0]*g64[iz+0];
s[1714] = + g24[ix+0]*g39[iy+0]*g64[iz+0];
s[1715] = + g24[ix+0]*g38[iy+0]*g65[iz+0];
s[1716] = + g25[ix+0]*g36[iy+0]*g66[iz+0];
s[1717] = + g24[ix+0]*g37[iy+0]*g66[iz+0];
s[1718] = + g24[ix+0]*g36[iy+0]*g67[iz+0];
s[1719] = + g27[ix+0]*g32[iy+0]*g68[iz+0];
s[1720] = + g26[ix+0]*g33[iy+0]*g68[iz+0];
s[1721] = + g26[ix+0]*g32[iy+0]*g69[iz+0];
s[1722] = + g25[ix+0]*g34[iy+0]*g68[iz+0];
s[1723] = + g24[ix+0]*g35[iy+0]*g68[iz+0];
s[1724] = + g24[ix+0]*g34[iy+0]*g69[iz+0];
s[1725] = + g25[ix+0]*g32[iy+0]*g70[iz+0];
s[1726] = + g24[ix+0]*g33[iy+0]*g70[iz+0];
s[1727] = + g24[ix+0]*g32[iy+0]*g71[iz+0];
s[1728] = + g23[ix+0]*g40[iy+0]*g64[iz+0];
s[1729] = + g22[ix+0]*g41[iy+0]*g64[iz+0];
s[1730] = + g22[ix+0]*g40[iy+0]*g65[iz+0];
s[1731] = + g21[ix+0]*g42[iy+0]*g64[iz+0];
s[1732] = + g20[ix+0]*g43[iy+0]*g64[iz+0];
s[1733] = + g20[ix+0]*g42[iy+0]*g65[iz+0];
s[1734] = + g21[ix+0]*g40[iy+0]*g66[iz+0];
s[1735] = + g20[ix+0]*g41[iy+0]*g66[iz+0];
s[1736] = + g20[ix+0]*g40[iy+0]*g67[iz+0];
s[1737] = + g19[ix+0]*g44[iy+0]*g64[iz+0];
s[1738] = + g18[ix+0]*g45[iy+0]*g64[iz+0];
s[1739] = + g18[ix+0]*g44[iy+0]*g65[iz+0];
s[1740] = + g17[ix+0]*g46[iy+0]*g64[iz+0];
s[1741] = + g16[ix+0]*g47[iy+0]*g64[iz+0];
s[1742] = + g16[ix+0]*g46[iy+0]*g65[iz+0];
s[1743] = + g17[ix+0]*g44[iy+0]*g66[iz+0];
s[1744] = + g16[ix+0]*g45[iy+0]*g66[iz+0];
s[1745] = + g16[ix+0]*g44[iy+0]*g67[iz+0];
s[1746] = + g19[ix+0]*g40[iy+0]*g68[iz+0];
s[1747] = + g18[ix+0]*g41[iy+0]*g68[iz+0];
s[1748] = + g18[ix+0]*g40[iy+0]*g69[iz+0];
s[1749] = + g17[ix+0]*g42[iy+0]*g68[iz+0];
s[1750] = + g16[ix+0]*g43[iy+0]*g68[iz+0];
s[1751] = + g16[ix+0]*g42[iy+0]*g69[iz+0];
s[1752] = + g17[ix+0]*g40[iy+0]*g70[iz+0];
s[1753] = + g16[ix+0]*g41[iy+0]*g70[iz+0];
s[1754] = + g16[ix+0]*g40[iy+0]*g71[iz+0];
s[1755] = + g23[ix+0]*g32[iy+0]*g72[iz+0];
s[1756] = + g22[ix+0]*g33[iy+0]*g72[iz+0];
s[1757] = + g22[ix+0]*g32[iy+0]*g73[iz+0];
s[1758] = + g21[ix+0]*g34[iy+0]*g72[iz+0];
s[1759] = + g20[ix+0]*g35[iy+0]*g72[iz+0];
s[1760] = + g20[ix+0]*g34[iy+0]*g73[iz+0];
s[1761] = + g21[ix+0]*g32[iy+0]*g74[iz+0];
s[1762] = + g20[ix+0]*g33[iy+0]*g74[iz+0];
s[1763] = + g20[ix+0]*g32[iy+0]*g75[iz+0];
s[1764] = + g19[ix+0]*g36[iy+0]*g72[iz+0];
s[1765] = + g18[ix+0]*g37[iy+0]*g72[iz+0];
s[1766] = + g18[ix+0]*g36[iy+0]*g73[iz+0];
s[1767] = + g17[ix+0]*g38[iy+0]*g72[iz+0];
s[1768] = + g16[ix+0]*g39[iy+0]*g72[iz+0];
s[1769] = + g16[ix+0]*g38[iy+0]*g73[iz+0];
s[1770] = + g17[ix+0]*g36[iy+0]*g74[iz+0];
s[1771] = + g16[ix+0]*g37[iy+0]*g74[iz+0];
s[1772] = + g16[ix+0]*g36[iy+0]*g75[iz+0];
s[1773] = + g19[ix+0]*g32[iy+0]*g76[iz+0];
s[1774] = + g18[ix+0]*g33[iy+0]*g76[iz+0];
s[1775] = + g18[ix+0]*g32[iy+0]*g77[iz+0];
s[1776] = + g17[ix+0]*g34[iy+0]*g76[iz+0];
s[1777] = + g16[ix+0]*g35[iy+0]*g76[iz+0];
s[1778] = + g16[ix+0]*g34[iy+0]*g77[iz+0];
s[1779] = + g17[ix+0]*g32[iy+0]*g78[iz+0];
s[1780] = + g16[ix+0]*g33[iy+0]*g78[iz+0];
s[1781] = + g16[ix+0]*g32[iy+0]*g79[iz+0];
s[1782] = + g15[ix+0]*g48[iy+0]*g64[iz+0];
s[1783] = + g14[ix+0]*g49[iy+0]*g64[iz+0];
s[1784] = + g14[ix+0]*g48[iy+0]*g65[iz+0];
s[1785] = + g13[ix+0]*g50[iy+0]*g64[iz+0];
s[1786] = + g12[ix+0]*g51[iy+0]*g64[iz+0];
s[1787] = + g12[ix+0]*g50[iy+0]*g65[iz+0];
s[1788] = + g13[ix+0]*g48[iy+0]*g66[iz+0];
s[1789] = + g12[ix+0]*g49[iy+0]*g66[iz+0];
s[1790] = + g12[ix+0]*g48[iy+0]*g67[iz+0];
s[1791] = + g11[ix+0]*g52[iy+0]*g64[iz+0];
s[1792] = + g10[ix+0]*g53[iy+0]*g64[iz+0];
s[1793] = + g10[ix+0]*g52[iy+0]*g65[iz+0];
s[1794] = + g9[ix+0]*g54[iy+0]*g64[iz+0];
s[1795] = + g8[ix+0]*g55[iy+0]*g64[iz+0];
s[1796] = + g8[ix+0]*g54[iy+0]*g65[iz+0];
s[1797] = + g9[ix+0]*g52[iy+0]*g66[iz+0];
s[1798] = + g8[ix+0]*g53[iy+0]*g66[iz+0];
s[1799] = + g8[ix+0]*g52[iy+0]*g67[iz+0];
s[1800] = + g11[ix+0]*g48[iy+0]*g68[iz+0];
s[1801] = + g10[ix+0]*g49[iy+0]*g68[iz+0];
s[1802] = + g10[ix+0]*g48[iy+0]*g69[iz+0];
s[1803] = + g9[ix+0]*g50[iy+0]*g68[iz+0];
s[1804] = + g8[ix+0]*g51[iy+0]*g68[iz+0];
s[1805] = + g8[ix+0]*g50[iy+0]*g69[iz+0];
s[1806] = + g9[ix+0]*g48[iy+0]*g70[iz+0];
s[1807] = + g8[ix+0]*g49[iy+0]*g70[iz+0];
s[1808] = + g8[ix+0]*g48[iy+0]*g71[iz+0];
s[1809] = + g7[ix+0]*g56[iy+0]*g64[iz+0];
s[1810] = + g6[ix+0]*g57[iy+0]*g64[iz+0];
s[1811] = + g6[ix+0]*g56[iy+0]*g65[iz+0];
s[1812] = + g5[ix+0]*g58[iy+0]*g64[iz+0];
s[1813] = + g4[ix+0]*g59[iy+0]*g64[iz+0];
s[1814] = + g4[ix+0]*g58[iy+0]*g65[iz+0];
s[1815] = + g5[ix+0]*g56[iy+0]*g66[iz+0];
s[1816] = + g4[ix+0]*g57[iy+0]*g66[iz+0];
s[1817] = + g4[ix+0]*g56[iy+0]*g67[iz+0];
s[1818] = + g3[ix+0]*g60[iy+0]*g64[iz+0];
s[1819] = + g2[ix+0]*g61[iy+0]*g64[iz+0];
s[1820] = + g2[ix+0]*g60[iy+0]*g65[iz+0];
s[1821] = + g1[ix+0]*g62[iy+0]*g64[iz+0];
s[1822] = + g0[ix+0]*g63[iy+0]*g64[iz+0];
s[1823] = + g0[ix+0]*g62[iy+0]*g65[iz+0];
s[1824] = + g1[ix+0]*g60[iy+0]*g66[iz+0];
s[1825] = + g0[ix+0]*g61[iy+0]*g66[iz+0];
s[1826] = + g0[ix+0]*g60[iy+0]*g67[iz+0];
s[1827] = + g3[ix+0]*g56[iy+0]*g68[iz+0];
s[1828] = + g2[ix+0]*g57[iy+0]*g68[iz+0];
s[1829] = + g2[ix+0]*g56[iy+0]*g69[iz+0];
s[1830] = + g1[ix+0]*g58[iy+0]*g68[iz+0];
s[1831] = + g0[ix+0]*g59[iy+0]*g68[iz+0];
s[1832] = + g0[ix+0]*g58[iy+0]*g69[iz+0];
s[1833] = + g1[ix+0]*g56[iy+0]*g70[iz+0];
s[1834] = + g0[ix+0]*g57[iy+0]*g70[iz+0];
s[1835] = + g0[ix+0]*g56[iy+0]*g71[iz+0];
s[1836] = + g7[ix+0]*g48[iy+0]*g72[iz+0];
s[1837] = + g6[ix+0]*g49[iy+0]*g72[iz+0];
s[1838] = + g6[ix+0]*g48[iy+0]*g73[iz+0];
s[1839] = + g5[ix+0]*g50[iy+0]*g72[iz+0];
s[1840] = + g4[ix+0]*g51[iy+0]*g72[iz+0];
s[1841] = + g4[ix+0]*g50[iy+0]*g73[iz+0];
s[1842] = + g5[ix+0]*g48[iy+0]*g74[iz+0];
s[1843] = + g4[ix+0]*g49[iy+0]*g74[iz+0];
s[1844] = + g4[ix+0]*g48[iy+0]*g75[iz+0];
s[1845] = + g3[ix+0]*g52[iy+0]*g72[iz+0];
s[1846] = + g2[ix+0]*g53[iy+0]*g72[iz+0];
s[1847] = + g2[ix+0]*g52[iy+0]*g73[iz+0];
s[1848] = + g1[ix+0]*g54[iy+0]*g72[iz+0];
s[1849] = + g0[ix+0]*g55[iy+0]*g72[iz+0];
s[1850] = + g0[ix+0]*g54[iy+0]*g73[iz+0];
s[1851] = + g1[ix+0]*g52[iy+0]*g74[iz+0];
s[1852] = + g0[ix+0]*g53[iy+0]*g74[iz+0];
s[1853] = + g0[ix+0]*g52[iy+0]*g75[iz+0];
s[1854] = + g3[ix+0]*g48[iy+0]*g76[iz+0];
s[1855] = + g2[ix+0]*g49[iy+0]*g76[iz+0];
s[1856] = + g2[ix+0]*g48[iy+0]*g77[iz+0];
s[1857] = + g1[ix+0]*g50[iy+0]*g76[iz+0];
s[1858] = + g0[ix+0]*g51[iy+0]*g76[iz+0];
s[1859] = + g0[ix+0]*g50[iy+0]*g77[iz+0];
s[1860] = + g1[ix+0]*g48[iy+0]*g78[iz+0];
s[1861] = + g0[ix+0]*g49[iy+0]*g78[iz+0];
s[1862] = + g0[ix+0]*g48[iy+0]*g79[iz+0];
s[1863] = + g15[ix+0]*g32[iy+0]*g80[iz+0];
s[1864] = + g14[ix+0]*g33[iy+0]*g80[iz+0];
s[1865] = + g14[ix+0]*g32[iy+0]*g81[iz+0];
s[1866] = + g13[ix+0]*g34[iy+0]*g80[iz+0];
s[1867] = + g12[ix+0]*g35[iy+0]*g80[iz+0];
s[1868] = + g12[ix+0]*g34[iy+0]*g81[iz+0];
s[1869] = + g13[ix+0]*g32[iy+0]*g82[iz+0];
s[1870] = + g12[ix+0]*g33[iy+0]*g82[iz+0];
s[1871] = + g12[ix+0]*g32[iy+0]*g83[iz+0];
s[1872] = + g11[ix+0]*g36[iy+0]*g80[iz+0];
s[1873] = + g10[ix+0]*g37[iy+0]*g80[iz+0];
s[1874] = + g10[ix+0]*g36[iy+0]*g81[iz+0];
s[1875] = + g9[ix+0]*g38[iy+0]*g80[iz+0];
s[1876] = + g8[ix+0]*g39[iy+0]*g80[iz+0];
s[1877] = + g8[ix+0]*g38[iy+0]*g81[iz+0];
s[1878] = + g9[ix+0]*g36[iy+0]*g82[iz+0];
s[1879] = + g8[ix+0]*g37[iy+0]*g82[iz+0];
s[1880] = + g8[ix+0]*g36[iy+0]*g83[iz+0];
s[1881] = + g11[ix+0]*g32[iy+0]*g84[iz+0];
s[1882] = + g10[ix+0]*g33[iy+0]*g84[iz+0];
s[1883] = + g10[ix+0]*g32[iy+0]*g85[iz+0];
s[1884] = + g9[ix+0]*g34[iy+0]*g84[iz+0];
s[1885] = + g8[ix+0]*g35[iy+0]*g84[iz+0];
s[1886] = + g8[ix+0]*g34[iy+0]*g85[iz+0];
s[1887] = + g9[ix+0]*g32[iy+0]*g86[iz+0];
s[1888] = + g8[ix+0]*g33[iy+0]*g86[iz+0];
s[1889] = + g8[ix+0]*g32[iy+0]*g87[iz+0];
s[1890] = + g7[ix+0]*g40[iy+0]*g80[iz+0];
s[1891] = + g6[ix+0]*g41[iy+0]*g80[iz+0];
s[1892] = + g6[ix+0]*g40[iy+0]*g81[iz+0];
s[1893] = + g5[ix+0]*g42[iy+0]*g80[iz+0];
s[1894] = + g4[ix+0]*g43[iy+0]*g80[iz+0];
s[1895] = + g4[ix+0]*g42[iy+0]*g81[iz+0];
s[1896] = + g5[ix+0]*g40[iy+0]*g82[iz+0];
s[1897] = + g4[ix+0]*g41[iy+0]*g82[iz+0];
s[1898] = + g4[ix+0]*g40[iy+0]*g83[iz+0];
s[1899] = + g3[ix+0]*g44[iy+0]*g80[iz+0];
s[1900] = + g2[ix+0]*g45[iy+0]*g80[iz+0];
s[1901] = + g2[ix+0]*g44[iy+0]*g81[iz+0];
s[1902] = + g1[ix+0]*g46[iy+0]*g80[iz+0];
s[1903] = + g0[ix+0]*g47[iy+0]*g80[iz+0];
s[1904] = + g0[ix+0]*g46[iy+0]*g81[iz+0];
s[1905] = + g1[ix+0]*g44[iy+0]*g82[iz+0];
s[1906] = + g0[ix+0]*g45[iy+0]*g82[iz+0];
s[1907] = + g0[ix+0]*g44[iy+0]*g83[iz+0];
s[1908] = + g3[ix+0]*g40[iy+0]*g84[iz+0];
s[1909] = + g2[ix+0]*g41[iy+0]*g84[iz+0];
s[1910] = + g2[ix+0]*g40[iy+0]*g85[iz+0];
s[1911] = + g1[ix+0]*g42[iy+0]*g84[iz+0];
s[1912] = + g0[ix+0]*g43[iy+0]*g84[iz+0];
s[1913] = + g0[ix+0]*g42[iy+0]*g85[iz+0];
s[1914] = + g1[ix+0]*g40[iy+0]*g86[iz+0];
s[1915] = + g0[ix+0]*g41[iy+0]*g86[iz+0];
s[1916] = + g0[ix+0]*g40[iy+0]*g87[iz+0];
s[1917] = + g7[ix+0]*g32[iy+0]*g88[iz+0];
s[1918] = + g6[ix+0]*g33[iy+0]*g88[iz+0];
s[1919] = + g6[ix+0]*g32[iy+0]*g89[iz+0];
s[1920] = + g5[ix+0]*g34[iy+0]*g88[iz+0];
s[1921] = + g4[ix+0]*g35[iy+0]*g88[iz+0];
s[1922] = + g4[ix+0]*g34[iy+0]*g89[iz+0];
s[1923] = + g5[ix+0]*g32[iy+0]*g90[iz+0];
s[1924] = + g4[ix+0]*g33[iy+0]*g90[iz+0];
s[1925] = + g4[ix+0]*g32[iy+0]*g91[iz+0];
s[1926] = + g3[ix+0]*g36[iy+0]*g88[iz+0];
s[1927] = + g2[ix+0]*g37[iy+0]*g88[iz+0];
s[1928] = + g2[ix+0]*g36[iy+0]*g89[iz+0];
s[1929] = + g1[ix+0]*g38[iy+0]*g88[iz+0];
s[1930] = + g0[ix+0]*g39[iy+0]*g88[iz+0];
s[1931] = + g0[ix+0]*g38[iy+0]*g89[iz+0];
s[1932] = + g1[ix+0]*g36[iy+0]*g90[iz+0];
s[1933] = + g0[ix+0]*g37[iy+0]*g90[iz+0];
s[1934] = + g0[ix+0]*g36[iy+0]*g91[iz+0];
s[1935] = + g3[ix+0]*g32[iy+0]*g92[iz+0];
s[1936] = + g2[ix+0]*g33[iy+0]*g92[iz+0];
s[1937] = + g2[ix+0]*g32[iy+0]*g93[iz+0];
s[1938] = + g1[ix+0]*g34[iy+0]*g92[iz+0];
s[1939] = + g0[ix+0]*g35[iy+0]*g92[iz+0];
s[1940] = + g0[ix+0]*g34[iy+0]*g93[iz+0];
s[1941] = + g1[ix+0]*g32[iy+0]*g94[iz+0];
s[1942] = + g0[ix+0]*g33[iy+0]*g94[iz+0];
s[1943] = + g0[ix+0]*g32[iy+0]*g95[iz+0];
s[1944] = + g31[ix+0]*g0[iy+0]*g96[iz+0];
s[1945] = + g30[ix+0]*g1[iy+0]*g96[iz+0];
s[1946] = + g30[ix+0]*g0[iy+0]*g97[iz+0];
s[1947] = + g29[ix+0]*g2[iy+0]*g96[iz+0];
s[1948] = + g28[ix+0]*g3[iy+0]*g96[iz+0];
s[1949] = + g28[ix+0]*g2[iy+0]*g97[iz+0];
s[1950] = + g29[ix+0]*g0[iy+0]*g98[iz+0];
s[1951] = + g28[ix+0]*g1[iy+0]*g98[iz+0];
s[1952] = + g28[ix+0]*g0[iy+0]*g99[iz+0];
s[1953] = + g27[ix+0]*g4[iy+0]*g96[iz+0];
s[1954] = + g26[ix+0]*g5[iy+0]*g96[iz+0];
s[1955] = + g26[ix+0]*g4[iy+0]*g97[iz+0];
s[1956] = + g25[ix+0]*g6[iy+0]*g96[iz+0];
s[1957] = + g24[ix+0]*g7[iy+0]*g96[iz+0];
s[1958] = + g24[ix+0]*g6[iy+0]*g97[iz+0];
s[1959] = + g25[ix+0]*g4[iy+0]*g98[iz+0];
s[1960] = + g24[ix+0]*g5[iy+0]*g98[iz+0];
s[1961] = + g24[ix+0]*g4[iy+0]*g99[iz+0];
s[1962] = + g27[ix+0]*g0[iy+0]*g100[iz+0];
s[1963] = + g26[ix+0]*g1[iy+0]*g100[iz+0];
s[1964] = + g26[ix+0]*g0[iy+0]*g101[iz+0];
s[1965] = + g25[ix+0]*g2[iy+0]*g100[iz+0];
s[1966] = + g24[ix+0]*g3[iy+0]*g100[iz+0];
s[1967] = + g24[ix+0]*g2[iy+0]*g101[iz+0];
s[1968] = + g25[ix+0]*g0[iy+0]*g102[iz+0];
s[1969] = + g24[ix+0]*g1[iy+0]*g102[iz+0];
s[1970] = + g24[ix+0]*g0[iy+0]*g103[iz+0];
s[1971] = + g23[ix+0]*g8[iy+0]*g96[iz+0];
s[1972] = + g22[ix+0]*g9[iy+0]*g96[iz+0];
s[1973] = + g22[ix+0]*g8[iy+0]*g97[iz+0];
s[1974] = + g21[ix+0]*g10[iy+0]*g96[iz+0];
s[1975] = + g20[ix+0]*g11[iy+0]*g96[iz+0];
s[1976] = + g20[ix+0]*g10[iy+0]*g97[iz+0];
s[1977] = + g21[ix+0]*g8[iy+0]*g98[iz+0];
s[1978] = + g20[ix+0]*g9[iy+0]*g98[iz+0];
s[1979] = + g20[ix+0]*g8[iy+0]*g99[iz+0];
s[1980] = + g19[ix+0]*g12[iy+0]*g96[iz+0];
s[1981] = + g18[ix+0]*g13[iy+0]*g96[iz+0];
s[1982] = + g18[ix+0]*g12[iy+0]*g97[iz+0];
s[1983] = + g17[ix+0]*g14[iy+0]*g96[iz+0];
s[1984] = + g16[ix+0]*g15[iy+0]*g96[iz+0];
s[1985] = + g16[ix+0]*g14[iy+0]*g97[iz+0];
s[1986] = + g17[ix+0]*g12[iy+0]*g98[iz+0];
s[1987] = + g16[ix+0]*g13[iy+0]*g98[iz+0];
s[1988] = + g16[ix+0]*g12[iy+0]*g99[iz+0];
s[1989] = + g19[ix+0]*g8[iy+0]*g100[iz+0];
s[1990] = + g18[ix+0]*g9[iy+0]*g100[iz+0];
s[1991] = + g18[ix+0]*g8[iy+0]*g101[iz+0];
s[1992] = + g17[ix+0]*g10[iy+0]*g100[iz+0];
s[1993] = + g16[ix+0]*g11[iy+0]*g100[iz+0];
s[1994] = + g16[ix+0]*g10[iy+0]*g101[iz+0];
s[1995] = + g17[ix+0]*g8[iy+0]*g102[iz+0];
s[1996] = + g16[ix+0]*g9[iy+0]*g102[iz+0];
s[1997] = + g16[ix+0]*g8[iy+0]*g103[iz+0];
s[1998] = + g23[ix+0]*g0[iy+0]*g104[iz+0];
s[1999] = + g22[ix+0]*g1[iy+0]*g104[iz+0];
s[2000] = + g22[ix+0]*g0[iy+0]*g105[iz+0];
s[2001] = + g21[ix+0]*g2[iy+0]*g104[iz+0];
s[2002] = + g20[ix+0]*g3[iy+0]*g104[iz+0];
s[2003] = + g20[ix+0]*g2[iy+0]*g105[iz+0];
s[2004] = + g21[ix+0]*g0[iy+0]*g106[iz+0];
s[2005] = + g20[ix+0]*g1[iy+0]*g106[iz+0];
s[2006] = + g20[ix+0]*g0[iy+0]*g107[iz+0];
s[2007] = + g19[ix+0]*g4[iy+0]*g104[iz+0];
s[2008] = + g18[ix+0]*g5[iy+0]*g104[iz+0];
s[2009] = + g18[ix+0]*g4[iy+0]*g105[iz+0];
s[2010] = + g17[ix+0]*g6[iy+0]*g104[iz+0];
s[2011] = + g16[ix+0]*g7[iy+0]*g104[iz+0];
s[2012] = + g16[ix+0]*g6[iy+0]*g105[iz+0];
s[2013] = + g17[ix+0]*g4[iy+0]*g106[iz+0];
s[2014] = + g16[ix+0]*g5[iy+0]*g106[iz+0];
s[2015] = + g16[ix+0]*g4[iy+0]*g107[iz+0];
s[2016] = + g19[ix+0]*g0[iy+0]*g108[iz+0];
s[2017] = + g18[ix+0]*g1[iy+0]*g108[iz+0];
s[2018] = + g18[ix+0]*g0[iy+0]*g109[iz+0];
s[2019] = + g17[ix+0]*g2[iy+0]*g108[iz+0];
s[2020] = + g16[ix+0]*g3[iy+0]*g108[iz+0];
s[2021] = + g16[ix+0]*g2[iy+0]*g109[iz+0];
s[2022] = + g17[ix+0]*g0[iy+0]*g110[iz+0];
s[2023] = + g16[ix+0]*g1[iy+0]*g110[iz+0];
s[2024] = + g16[ix+0]*g0[iy+0]*g111[iz+0];
s[2025] = + g15[ix+0]*g16[iy+0]*g96[iz+0];
s[2026] = + g14[ix+0]*g17[iy+0]*g96[iz+0];
s[2027] = + g14[ix+0]*g16[iy+0]*g97[iz+0];
s[2028] = + g13[ix+0]*g18[iy+0]*g96[iz+0];
s[2029] = + g12[ix+0]*g19[iy+0]*g96[iz+0];
s[2030] = + g12[ix+0]*g18[iy+0]*g97[iz+0];
s[2031] = + g13[ix+0]*g16[iy+0]*g98[iz+0];
s[2032] = + g12[ix+0]*g17[iy+0]*g98[iz+0];
s[2033] = + g12[ix+0]*g16[iy+0]*g99[iz+0];
s[2034] = + g11[ix+0]*g20[iy+0]*g96[iz+0];
s[2035] = + g10[ix+0]*g21[iy+0]*g96[iz+0];
s[2036] = + g10[ix+0]*g20[iy+0]*g97[iz+0];
s[2037] = + g9[ix+0]*g22[iy+0]*g96[iz+0];
s[2038] = + g8[ix+0]*g23[iy+0]*g96[iz+0];
s[2039] = + g8[ix+0]*g22[iy+0]*g97[iz+0];
s[2040] = + g9[ix+0]*g20[iy+0]*g98[iz+0];
s[2041] = + g8[ix+0]*g21[iy+0]*g98[iz+0];
s[2042] = + g8[ix+0]*g20[iy+0]*g99[iz+0];
s[2043] = + g11[ix+0]*g16[iy+0]*g100[iz+0];
s[2044] = + g10[ix+0]*g17[iy+0]*g100[iz+0];
s[2045] = + g10[ix+0]*g16[iy+0]*g101[iz+0];
s[2046] = + g9[ix+0]*g18[iy+0]*g100[iz+0];
s[2047] = + g8[ix+0]*g19[iy+0]*g100[iz+0];
s[2048] = + g8[ix+0]*g18[iy+0]*g101[iz+0];
s[2049] = + g9[ix+0]*g16[iy+0]*g102[iz+0];
s[2050] = + g8[ix+0]*g17[iy+0]*g102[iz+0];
s[2051] = + g8[ix+0]*g16[iy+0]*g103[iz+0];
s[2052] = + g7[ix+0]*g24[iy+0]*g96[iz+0];
s[2053] = + g6[ix+0]*g25[iy+0]*g96[iz+0];
s[2054] = + g6[ix+0]*g24[iy+0]*g97[iz+0];
s[2055] = + g5[ix+0]*g26[iy+0]*g96[iz+0];
s[2056] = + g4[ix+0]*g27[iy+0]*g96[iz+0];
s[2057] = + g4[ix+0]*g26[iy+0]*g97[iz+0];
s[2058] = + g5[ix+0]*g24[iy+0]*g98[iz+0];
s[2059] = + g4[ix+0]*g25[iy+0]*g98[iz+0];
s[2060] = + g4[ix+0]*g24[iy+0]*g99[iz+0];
s[2061] = + g3[ix+0]*g28[iy+0]*g96[iz+0];
s[2062] = + g2[ix+0]*g29[iy+0]*g96[iz+0];
s[2063] = + g2[ix+0]*g28[iy+0]*g97[iz+0];
s[2064] = + g1[ix+0]*g30[iy+0]*g96[iz+0];
s[2065] = + g0[ix+0]*g31[iy+0]*g96[iz+0];
s[2066] = + g0[ix+0]*g30[iy+0]*g97[iz+0];
s[2067] = + g1[ix+0]*g28[iy+0]*g98[iz+0];
s[2068] = + g0[ix+0]*g29[iy+0]*g98[iz+0];
s[2069] = + g0[ix+0]*g28[iy+0]*g99[iz+0];
s[2070] = + g3[ix+0]*g24[iy+0]*g100[iz+0];
s[2071] = + g2[ix+0]*g25[iy+0]*g100[iz+0];
s[2072] = + g2[ix+0]*g24[iy+0]*g101[iz+0];
s[2073] = + g1[ix+0]*g26[iy+0]*g100[iz+0];
s[2074] = + g0[ix+0]*g27[iy+0]*g100[iz+0];
s[2075] = + g0[ix+0]*g26[iy+0]*g101[iz+0];
s[2076] = + g1[ix+0]*g24[iy+0]*g102[iz+0];
s[2077] = + g0[ix+0]*g25[iy+0]*g102[iz+0];
s[2078] = + g0[ix+0]*g24[iy+0]*g103[iz+0];
s[2079] = + g7[ix+0]*g16[iy+0]*g104[iz+0];
s[2080] = + g6[ix+0]*g17[iy+0]*g104[iz+0];
s[2081] = + g6[ix+0]*g16[iy+0]*g105[iz+0];
s[2082] = + g5[ix+0]*g18[iy+0]*g104[iz+0];
s[2083] = + g4[ix+0]*g19[iy+0]*g104[iz+0];
s[2084] = + g4[ix+0]*g18[iy+0]*g105[iz+0];
s[2085] = + g5[ix+0]*g16[iy+0]*g106[iz+0];
s[2086] = + g4[ix+0]*g17[iy+0]*g106[iz+0];
s[2087] = + g4[ix+0]*g16[iy+0]*g107[iz+0];
s[2088] = + g3[ix+0]*g20[iy+0]*g104[iz+0];
s[2089] = + g2[ix+0]*g21[iy+0]*g104[iz+0];
s[2090] = + g2[ix+0]*g20[iy+0]*g105[iz+0];
s[2091] = + g1[ix+0]*g22[iy+0]*g104[iz+0];
s[2092] = + g0[ix+0]*g23[iy+0]*g104[iz+0];
s[2093] = + g0[ix+0]*g22[iy+0]*g105[iz+0];
s[2094] = + g1[ix+0]*g20[iy+0]*g106[iz+0];
s[2095] = + g0[ix+0]*g21[iy+0]*g106[iz+0];
s[2096] = + g0[ix+0]*g20[iy+0]*g107[iz+0];
s[2097] = + g3[ix+0]*g16[iy+0]*g108[iz+0];
s[2098] = + g2[ix+0]*g17[iy+0]*g108[iz+0];
s[2099] = + g2[ix+0]*g16[iy+0]*g109[iz+0];
s[2100] = + g1[ix+0]*g18[iy+0]*g108[iz+0];
s[2101] = + g0[ix+0]*g19[iy+0]*g108[iz+0];
s[2102] = + g0[ix+0]*g18[iy+0]*g109[iz+0];
s[2103] = + g1[ix+0]*g16[iy+0]*g110[iz+0];
s[2104] = + g0[ix+0]*g17[iy+0]*g110[iz+0];
s[2105] = + g0[ix+0]*g16[iy+0]*g111[iz+0];
s[2106] = + g15[ix+0]*g0[iy+0]*g112[iz+0];
s[2107] = + g14[ix+0]*g1[iy+0]*g112[iz+0];
s[2108] = + g14[ix+0]*g0[iy+0]*g113[iz+0];
s[2109] = + g13[ix+0]*g2[iy+0]*g112[iz+0];
s[2110] = + g12[ix+0]*g3[iy+0]*g112[iz+0];
s[2111] = + g12[ix+0]*g2[iy+0]*g113[iz+0];
s[2112] = + g13[ix+0]*g0[iy+0]*g114[iz+0];
s[2113] = + g12[ix+0]*g1[iy+0]*g114[iz+0];
s[2114] = + g12[ix+0]*g0[iy+0]*g115[iz+0];
s[2115] = + g11[ix+0]*g4[iy+0]*g112[iz+0];
s[2116] = + g10[ix+0]*g5[iy+0]*g112[iz+0];
s[2117] = + g10[ix+0]*g4[iy+0]*g113[iz+0];
s[2118] = + g9[ix+0]*g6[iy+0]*g112[iz+0];
s[2119] = + g8[ix+0]*g7[iy+0]*g112[iz+0];
s[2120] = + g8[ix+0]*g6[iy+0]*g113[iz+0];
s[2121] = + g9[ix+0]*g4[iy+0]*g114[iz+0];
s[2122] = + g8[ix+0]*g5[iy+0]*g114[iz+0];
s[2123] = + g8[ix+0]*g4[iy+0]*g115[iz+0];
s[2124] = + g11[ix+0]*g0[iy+0]*g116[iz+0];
s[2125] = + g10[ix+0]*g1[iy+0]*g116[iz+0];
s[2126] = + g10[ix+0]*g0[iy+0]*g117[iz+0];
s[2127] = + g9[ix+0]*g2[iy+0]*g116[iz+0];
s[2128] = + g8[ix+0]*g3[iy+0]*g116[iz+0];
s[2129] = + g8[ix+0]*g2[iy+0]*g117[iz+0];
s[2130] = + g9[ix+0]*g0[iy+0]*g118[iz+0];
s[2131] = + g8[ix+0]*g1[iy+0]*g118[iz+0];
s[2132] = + g8[ix+0]*g0[iy+0]*g119[iz+0];
s[2133] = + g7[ix+0]*g8[iy+0]*g112[iz+0];
s[2134] = + g6[ix+0]*g9[iy+0]*g112[iz+0];
s[2135] = + g6[ix+0]*g8[iy+0]*g113[iz+0];
s[2136] = + g5[ix+0]*g10[iy+0]*g112[iz+0];
s[2137] = + g4[ix+0]*g11[iy+0]*g112[iz+0];
s[2138] = + g4[ix+0]*g10[iy+0]*g113[iz+0];
s[2139] = + g5[ix+0]*g8[iy+0]*g114[iz+0];
s[2140] = + g4[ix+0]*g9[iy+0]*g114[iz+0];
s[2141] = + g4[ix+0]*g8[iy+0]*g115[iz+0];
s[2142] = + g3[ix+0]*g12[iy+0]*g112[iz+0];
s[2143] = + g2[ix+0]*g13[iy+0]*g112[iz+0];
s[2144] = + g2[ix+0]*g12[iy+0]*g113[iz+0];
s[2145] = + g1[ix+0]*g14[iy+0]*g112[iz+0];
s[2146] = + g0[ix+0]*g15[iy+0]*g112[iz+0];
s[2147] = + g0[ix+0]*g14[iy+0]*g113[iz+0];
s[2148] = + g1[ix+0]*g12[iy+0]*g114[iz+0];
s[2149] = + g0[ix+0]*g13[iy+0]*g114[iz+0];
s[2150] = + g0[ix+0]*g12[iy+0]*g115[iz+0];
s[2151] = + g3[ix+0]*g8[iy+0]*g116[iz+0];
s[2152] = + g2[ix+0]*g9[iy+0]*g116[iz+0];
s[2153] = + g2[ix+0]*g8[iy+0]*g117[iz+0];
s[2154] = + g1[ix+0]*g10[iy+0]*g116[iz+0];
s[2155] = + g0[ix+0]*g11[iy+0]*g116[iz+0];
s[2156] = + g0[ix+0]*g10[iy+0]*g117[iz+0];
s[2157] = + g1[ix+0]*g8[iy+0]*g118[iz+0];
s[2158] = + g0[ix+0]*g9[iy+0]*g118[iz+0];
s[2159] = + g0[ix+0]*g8[iy+0]*g119[iz+0];
s[2160] = + g7[ix+0]*g0[iy+0]*g120[iz+0];
s[2161] = + g6[ix+0]*g1[iy+0]*g120[iz+0];
s[2162] = + g6[ix+0]*g0[iy+0]*g121[iz+0];
s[2163] = + g5[ix+0]*g2[iy+0]*g120[iz+0];
s[2164] = + g4[ix+0]*g3[iy+0]*g120[iz+0];
s[2165] = + g4[ix+0]*g2[iy+0]*g121[iz+0];
s[2166] = + g5[ix+0]*g0[iy+0]*g122[iz+0];
s[2167] = + g4[ix+0]*g1[iy+0]*g122[iz+0];
s[2168] = + g4[ix+0]*g0[iy+0]*g123[iz+0];
s[2169] = + g3[ix+0]*g4[iy+0]*g120[iz+0];
s[2170] = + g2[ix+0]*g5[iy+0]*g120[iz+0];
s[2171] = + g2[ix+0]*g4[iy+0]*g121[iz+0];
s[2172] = + g1[ix+0]*g6[iy+0]*g120[iz+0];
s[2173] = + g0[ix+0]*g7[iy+0]*g120[iz+0];
s[2174] = + g0[ix+0]*g6[iy+0]*g121[iz+0];
s[2175] = + g1[ix+0]*g4[iy+0]*g122[iz+0];
s[2176] = + g0[ix+0]*g5[iy+0]*g122[iz+0];
s[2177] = + g0[ix+0]*g4[iy+0]*g123[iz+0];
s[2178] = + g3[ix+0]*g0[iy+0]*g124[iz+0];
s[2179] = + g2[ix+0]*g1[iy+0]*g124[iz+0];
s[2180] = + g2[ix+0]*g0[iy+0]*g125[iz+0];
s[2181] = + g1[ix+0]*g2[iy+0]*g124[iz+0];
s[2182] = + g0[ix+0]*g3[iy+0]*g124[iz+0];
s[2183] = + g0[ix+0]*g2[iy+0]*g125[iz+0];
s[2184] = + g1[ix+0]*g0[iy+0]*g126[iz+0];
s[2185] = + g0[ix+0]*g1[iy+0]*g126[iz+0];
s[2186] = + g0[ix+0]*g0[iy+0]*g127[iz+0];
if (gout_empty) {
gout[n*2187+0] = + s[0];
gout[n*2187+1] = + s[1];
gout[n*2187+2] = + s[2];
gout[n*2187+3] = + s[3];
gout[n*2187+4] = + s[4];
gout[n*2187+5] = + s[5];
gout[n*2187+6] = + s[6];
gout[n*2187+7] = + s[7];
gout[n*2187+8] = + s[8];
gout[n*2187+9] = + s[9];
gout[n*2187+10] = + s[10];
gout[n*2187+11] = + s[11];
gout[n*2187+12] = + s[12];
gout[n*2187+13] = + s[13];
gout[n*2187+14] = + s[14];
gout[n*2187+15] = + s[15];
gout[n*2187+16] = + s[16];
gout[n*2187+17] = + s[17];
gout[n*2187+18] = + s[18];
gout[n*2187+19] = + s[19];
gout[n*2187+20] = + s[20];
gout[n*2187+21] = + s[21];
gout[n*2187+22] = + s[22];
gout[n*2187+23] = + s[23];
gout[n*2187+24] = + s[24];
gout[n*2187+25] = + s[25];
gout[n*2187+26] = + s[26];
gout[n*2187+27] = + s[729];
gout[n*2187+28] = + s[730];
gout[n*2187+29] = + s[731];
gout[n*2187+30] = + s[732];
gout[n*2187+31] = + s[733];
gout[n*2187+32] = + s[734];
gout[n*2187+33] = + s[735];
gout[n*2187+34] = + s[736];
gout[n*2187+35] = + s[737];
gout[n*2187+36] = + s[738];
gout[n*2187+37] = + s[739];
gout[n*2187+38] = + s[740];
gout[n*2187+39] = + s[741];
gout[n*2187+40] = + s[742];
gout[n*2187+41] = + s[743];
gout[n*2187+42] = + s[744];
gout[n*2187+43] = + s[745];
gout[n*2187+44] = + s[746];
gout[n*2187+45] = + s[747];
gout[n*2187+46] = + s[748];
gout[n*2187+47] = + s[749];
gout[n*2187+48] = + s[750];
gout[n*2187+49] = + s[751];
gout[n*2187+50] = + s[752];
gout[n*2187+51] = + s[753];
gout[n*2187+52] = + s[754];
gout[n*2187+53] = + s[755];
gout[n*2187+54] = + s[1458];
gout[n*2187+55] = + s[1459];
gout[n*2187+56] = + s[1460];
gout[n*2187+57] = + s[1461];
gout[n*2187+58] = + s[1462];
gout[n*2187+59] = + s[1463];
gout[n*2187+60] = + s[1464];
gout[n*2187+61] = + s[1465];
gout[n*2187+62] = + s[1466];
gout[n*2187+63] = + s[1467];
gout[n*2187+64] = + s[1468];
gout[n*2187+65] = + s[1469];
gout[n*2187+66] = + s[1470];
gout[n*2187+67] = + s[1471];
gout[n*2187+68] = + s[1472];
gout[n*2187+69] = + s[1473];
gout[n*2187+70] = + s[1474];
gout[n*2187+71] = + s[1475];
gout[n*2187+72] = + s[1476];
gout[n*2187+73] = + s[1477];
gout[n*2187+74] = + s[1478];
gout[n*2187+75] = + s[1479];
gout[n*2187+76] = + s[1480];
gout[n*2187+77] = + s[1481];
gout[n*2187+78] = + s[1482];
gout[n*2187+79] = + s[1483];
gout[n*2187+80] = + s[1484];
gout[n*2187+81] = + s[243];
gout[n*2187+82] = + s[244];
gout[n*2187+83] = + s[245];
gout[n*2187+84] = + s[246];
gout[n*2187+85] = + s[247];
gout[n*2187+86] = + s[248];
gout[n*2187+87] = + s[249];
gout[n*2187+88] = + s[250];
gout[n*2187+89] = + s[251];
gout[n*2187+90] = + s[252];
gout[n*2187+91] = + s[253];
gout[n*2187+92] = + s[254];
gout[n*2187+93] = + s[255];
gout[n*2187+94] = + s[256];
gout[n*2187+95] = + s[257];
gout[n*2187+96] = + s[258];
gout[n*2187+97] = + s[259];
gout[n*2187+98] = + s[260];
gout[n*2187+99] = + s[261];
gout[n*2187+100] = + s[262];
gout[n*2187+101] = + s[263];
gout[n*2187+102] = + s[264];
gout[n*2187+103] = + s[265];
gout[n*2187+104] = + s[266];
gout[n*2187+105] = + s[267];
gout[n*2187+106] = + s[268];
gout[n*2187+107] = + s[269];
gout[n*2187+108] = + s[972];
gout[n*2187+109] = + s[973];
gout[n*2187+110] = + s[974];
gout[n*2187+111] = + s[975];
gout[n*2187+112] = + s[976];
gout[n*2187+113] = + s[977];
gout[n*2187+114] = + s[978];
gout[n*2187+115] = + s[979];
gout[n*2187+116] = + s[980];
gout[n*2187+117] = + s[981];
gout[n*2187+118] = + s[982];
gout[n*2187+119] = + s[983];
gout[n*2187+120] = + s[984];
gout[n*2187+121] = + s[985];
gout[n*2187+122] = + s[986];
gout[n*2187+123] = + s[987];
gout[n*2187+124] = + s[988];
gout[n*2187+125] = + s[989];
gout[n*2187+126] = + s[990];
gout[n*2187+127] = + s[991];
gout[n*2187+128] = + s[992];
gout[n*2187+129] = + s[993];
gout[n*2187+130] = + s[994];
gout[n*2187+131] = + s[995];
gout[n*2187+132] = + s[996];
gout[n*2187+133] = + s[997];
gout[n*2187+134] = + s[998];
gout[n*2187+135] = + s[1701];
gout[n*2187+136] = + s[1702];
gout[n*2187+137] = + s[1703];
gout[n*2187+138] = + s[1704];
gout[n*2187+139] = + s[1705];
gout[n*2187+140] = + s[1706];
gout[n*2187+141] = + s[1707];
gout[n*2187+142] = + s[1708];
gout[n*2187+143] = + s[1709];
gout[n*2187+144] = + s[1710];
gout[n*2187+145] = + s[1711];
gout[n*2187+146] = + s[1712];
gout[n*2187+147] = + s[1713];
gout[n*2187+148] = + s[1714];
gout[n*2187+149] = + s[1715];
gout[n*2187+150] = + s[1716];
gout[n*2187+151] = + s[1717];
gout[n*2187+152] = + s[1718];
gout[n*2187+153] = + s[1719];
gout[n*2187+154] = + s[1720];
gout[n*2187+155] = + s[1721];
gout[n*2187+156] = + s[1722];
gout[n*2187+157] = + s[1723];
gout[n*2187+158] = + s[1724];
gout[n*2187+159] = + s[1725];
gout[n*2187+160] = + s[1726];
gout[n*2187+161] = + s[1727];
gout[n*2187+162] = + s[486];
gout[n*2187+163] = + s[487];
gout[n*2187+164] = + s[488];
gout[n*2187+165] = + s[489];
gout[n*2187+166] = + s[490];
gout[n*2187+167] = + s[491];
gout[n*2187+168] = + s[492];
gout[n*2187+169] = + s[493];
gout[n*2187+170] = + s[494];
gout[n*2187+171] = + s[495];
gout[n*2187+172] = + s[496];
gout[n*2187+173] = + s[497];
gout[n*2187+174] = + s[498];
gout[n*2187+175] = + s[499];
gout[n*2187+176] = + s[500];
gout[n*2187+177] = + s[501];
gout[n*2187+178] = + s[502];
gout[n*2187+179] = + s[503];
gout[n*2187+180] = + s[504];
gout[n*2187+181] = + s[505];
gout[n*2187+182] = + s[506];
gout[n*2187+183] = + s[507];
gout[n*2187+184] = + s[508];
gout[n*2187+185] = + s[509];
gout[n*2187+186] = + s[510];
gout[n*2187+187] = + s[511];
gout[n*2187+188] = + s[512];
gout[n*2187+189] = + s[1215];
gout[n*2187+190] = + s[1216];
gout[n*2187+191] = + s[1217];
gout[n*2187+192] = + s[1218];
gout[n*2187+193] = + s[1219];
gout[n*2187+194] = + s[1220];
gout[n*2187+195] = + s[1221];
gout[n*2187+196] = + s[1222];
gout[n*2187+197] = + s[1223];
gout[n*2187+198] = + s[1224];
gout[n*2187+199] = + s[1225];
gout[n*2187+200] = + s[1226];
gout[n*2187+201] = + s[1227];
gout[n*2187+202] = + s[1228];
gout[n*2187+203] = + s[1229];
gout[n*2187+204] = + s[1230];
gout[n*2187+205] = + s[1231];
gout[n*2187+206] = + s[1232];
gout[n*2187+207] = + s[1233];
gout[n*2187+208] = + s[1234];
gout[n*2187+209] = + s[1235];
gout[n*2187+210] = + s[1236];
gout[n*2187+211] = + s[1237];
gout[n*2187+212] = + s[1238];
gout[n*2187+213] = + s[1239];
gout[n*2187+214] = + s[1240];
gout[n*2187+215] = + s[1241];
gout[n*2187+216] = + s[1944];
gout[n*2187+217] = + s[1945];
gout[n*2187+218] = + s[1946];
gout[n*2187+219] = + s[1947];
gout[n*2187+220] = + s[1948];
gout[n*2187+221] = + s[1949];
gout[n*2187+222] = + s[1950];
gout[n*2187+223] = + s[1951];
gout[n*2187+224] = + s[1952];
gout[n*2187+225] = + s[1953];
gout[n*2187+226] = + s[1954];
gout[n*2187+227] = + s[1955];
gout[n*2187+228] = + s[1956];
gout[n*2187+229] = + s[1957];
gout[n*2187+230] = + s[1958];
gout[n*2187+231] = + s[1959];
gout[n*2187+232] = + s[1960];
gout[n*2187+233] = + s[1961];
gout[n*2187+234] = + s[1962];
gout[n*2187+235] = + s[1963];
gout[n*2187+236] = + s[1964];
gout[n*2187+237] = + s[1965];
gout[n*2187+238] = + s[1966];
gout[n*2187+239] = + s[1967];
gout[n*2187+240] = + s[1968];
gout[n*2187+241] = + s[1969];
gout[n*2187+242] = + s[1970];
gout[n*2187+243] = + s[81];
gout[n*2187+244] = + s[82];
gout[n*2187+245] = + s[83];
gout[n*2187+246] = + s[84];
gout[n*2187+247] = + s[85];
gout[n*2187+248] = + s[86];
gout[n*2187+249] = + s[87];
gout[n*2187+250] = + s[88];
gout[n*2187+251] = + s[89];
gout[n*2187+252] = + s[90];
gout[n*2187+253] = + s[91];
gout[n*2187+254] = + s[92];
gout[n*2187+255] = + s[93];
gout[n*2187+256] = + s[94];
gout[n*2187+257] = + s[95];
gout[n*2187+258] = + s[96];
gout[n*2187+259] = + s[97];
gout[n*2187+260] = + s[98];
gout[n*2187+261] = + s[99];
gout[n*2187+262] = + s[100];
gout[n*2187+263] = + s[101];
gout[n*2187+264] = + s[102];
gout[n*2187+265] = + s[103];
gout[n*2187+266] = + s[104];
gout[n*2187+267] = + s[105];
gout[n*2187+268] = + s[106];
gout[n*2187+269] = + s[107];
gout[n*2187+270] = + s[810];
gout[n*2187+271] = + s[811];
gout[n*2187+272] = + s[812];
gout[n*2187+273] = + s[813];
gout[n*2187+274] = + s[814];
gout[n*2187+275] = + s[815];
gout[n*2187+276] = + s[816];
gout[n*2187+277] = + s[817];
gout[n*2187+278] = + s[818];
gout[n*2187+279] = + s[819];
gout[n*2187+280] = + s[820];
gout[n*2187+281] = + s[821];
gout[n*2187+282] = + s[822];
gout[n*2187+283] = + s[823];
gout[n*2187+284] = + s[824];
gout[n*2187+285] = + s[825];
gout[n*2187+286] = + s[826];
gout[n*2187+287] = + s[827];
gout[n*2187+288] = + s[828];
gout[n*2187+289] = + s[829];
gout[n*2187+290] = + s[830];
gout[n*2187+291] = + s[831];
gout[n*2187+292] = + s[832];
gout[n*2187+293] = + s[833];
gout[n*2187+294] = + s[834];
gout[n*2187+295] = + s[835];
gout[n*2187+296] = + s[836];
gout[n*2187+297] = + s[1539];
gout[n*2187+298] = + s[1540];
gout[n*2187+299] = + s[1541];
gout[n*2187+300] = + s[1542];
gout[n*2187+301] = + s[1543];
gout[n*2187+302] = + s[1544];
gout[n*2187+303] = + s[1545];
gout[n*2187+304] = + s[1546];
gout[n*2187+305] = + s[1547];
gout[n*2187+306] = + s[1548];
gout[n*2187+307] = + s[1549];
gout[n*2187+308] = + s[1550];
gout[n*2187+309] = + s[1551];
gout[n*2187+310] = + s[1552];
gout[n*2187+311] = + s[1553];
gout[n*2187+312] = + s[1554];
gout[n*2187+313] = + s[1555];
gout[n*2187+314] = + s[1556];
gout[n*2187+315] = + s[1557];
gout[n*2187+316] = + s[1558];
gout[n*2187+317] = + s[1559];
gout[n*2187+318] = + s[1560];
gout[n*2187+319] = + s[1561];
gout[n*2187+320] = + s[1562];
gout[n*2187+321] = + s[1563];
gout[n*2187+322] = + s[1564];
gout[n*2187+323] = + s[1565];
gout[n*2187+324] = + s[324];
gout[n*2187+325] = + s[325];
gout[n*2187+326] = + s[326];
gout[n*2187+327] = + s[327];
gout[n*2187+328] = + s[328];
gout[n*2187+329] = + s[329];
gout[n*2187+330] = + s[330];
gout[n*2187+331] = + s[331];
gout[n*2187+332] = + s[332];
gout[n*2187+333] = + s[333];
gout[n*2187+334] = + s[334];
gout[n*2187+335] = + s[335];
gout[n*2187+336] = + s[336];
gout[n*2187+337] = + s[337];
gout[n*2187+338] = + s[338];
gout[n*2187+339] = + s[339];
gout[n*2187+340] = + s[340];
gout[n*2187+341] = + s[341];
gout[n*2187+342] = + s[342];
gout[n*2187+343] = + s[343];
gout[n*2187+344] = + s[344];
gout[n*2187+345] = + s[345];
gout[n*2187+346] = + s[346];
gout[n*2187+347] = + s[347];
gout[n*2187+348] = + s[348];
gout[n*2187+349] = + s[349];
gout[n*2187+350] = + s[350];
gout[n*2187+351] = + s[1053];
gout[n*2187+352] = + s[1054];
gout[n*2187+353] = + s[1055];
gout[n*2187+354] = + s[1056];
gout[n*2187+355] = + s[1057];
gout[n*2187+356] = + s[1058];
gout[n*2187+357] = + s[1059];
gout[n*2187+358] = + s[1060];
gout[n*2187+359] = + s[1061];
gout[n*2187+360] = + s[1062];
gout[n*2187+361] = + s[1063];
gout[n*2187+362] = + s[1064];
gout[n*2187+363] = + s[1065];
gout[n*2187+364] = + s[1066];
gout[n*2187+365] = + s[1067];
gout[n*2187+366] = + s[1068];
gout[n*2187+367] = + s[1069];
gout[n*2187+368] = + s[1070];
gout[n*2187+369] = + s[1071];
gout[n*2187+370] = + s[1072];
gout[n*2187+371] = + s[1073];
gout[n*2187+372] = + s[1074];
gout[n*2187+373] = + s[1075];
gout[n*2187+374] = + s[1076];
gout[n*2187+375] = + s[1077];
gout[n*2187+376] = + s[1078];
gout[n*2187+377] = + s[1079];
gout[n*2187+378] = + s[1782];
gout[n*2187+379] = + s[1783];
gout[n*2187+380] = + s[1784];
gout[n*2187+381] = + s[1785];
gout[n*2187+382] = + s[1786];
gout[n*2187+383] = + s[1787];
gout[n*2187+384] = + s[1788];
gout[n*2187+385] = + s[1789];
gout[n*2187+386] = + s[1790];
gout[n*2187+387] = + s[1791];
gout[n*2187+388] = + s[1792];
gout[n*2187+389] = + s[1793];
gout[n*2187+390] = + s[1794];
gout[n*2187+391] = + s[1795];
gout[n*2187+392] = + s[1796];
gout[n*2187+393] = + s[1797];
gout[n*2187+394] = + s[1798];
gout[n*2187+395] = + s[1799];
gout[n*2187+396] = + s[1800];
gout[n*2187+397] = + s[1801];
gout[n*2187+398] = + s[1802];
gout[n*2187+399] = + s[1803];
gout[n*2187+400] = + s[1804];
gout[n*2187+401] = + s[1805];
gout[n*2187+402] = + s[1806];
gout[n*2187+403] = + s[1807];
gout[n*2187+404] = + s[1808];
gout[n*2187+405] = + s[567];
gout[n*2187+406] = + s[568];
gout[n*2187+407] = + s[569];
gout[n*2187+408] = + s[570];
gout[n*2187+409] = + s[571];
gout[n*2187+410] = + s[572];
gout[n*2187+411] = + s[573];
gout[n*2187+412] = + s[574];
gout[n*2187+413] = + s[575];
gout[n*2187+414] = + s[576];
gout[n*2187+415] = + s[577];
gout[n*2187+416] = + s[578];
gout[n*2187+417] = + s[579];
gout[n*2187+418] = + s[580];
gout[n*2187+419] = + s[581];
gout[n*2187+420] = + s[582];
gout[n*2187+421] = + s[583];
gout[n*2187+422] = + s[584];
gout[n*2187+423] = + s[585];
gout[n*2187+424] = + s[586];
gout[n*2187+425] = + s[587];
gout[n*2187+426] = + s[588];
gout[n*2187+427] = + s[589];
gout[n*2187+428] = + s[590];
gout[n*2187+429] = + s[591];
gout[n*2187+430] = + s[592];
gout[n*2187+431] = + s[593];
gout[n*2187+432] = + s[1296];
gout[n*2187+433] = + s[1297];
gout[n*2187+434] = + s[1298];
gout[n*2187+435] = + s[1299];
gout[n*2187+436] = + s[1300];
gout[n*2187+437] = + s[1301];
gout[n*2187+438] = + s[1302];
gout[n*2187+439] = + s[1303];
gout[n*2187+440] = + s[1304];
gout[n*2187+441] = + s[1305];
gout[n*2187+442] = + s[1306];
gout[n*2187+443] = + s[1307];
gout[n*2187+444] = + s[1308];
gout[n*2187+445] = + s[1309];
gout[n*2187+446] = + s[1310];
gout[n*2187+447] = + s[1311];
gout[n*2187+448] = + s[1312];
gout[n*2187+449] = + s[1313];
gout[n*2187+450] = + s[1314];
gout[n*2187+451] = + s[1315];
gout[n*2187+452] = + s[1316];
gout[n*2187+453] = + s[1317];
gout[n*2187+454] = + s[1318];
gout[n*2187+455] = + s[1319];
gout[n*2187+456] = + s[1320];
gout[n*2187+457] = + s[1321];
gout[n*2187+458] = + s[1322];
gout[n*2187+459] = + s[2025];
gout[n*2187+460] = + s[2026];
gout[n*2187+461] = + s[2027];
gout[n*2187+462] = + s[2028];
gout[n*2187+463] = + s[2029];
gout[n*2187+464] = + s[2030];
gout[n*2187+465] = + s[2031];
gout[n*2187+466] = + s[2032];
gout[n*2187+467] = + s[2033];
gout[n*2187+468] = + s[2034];
gout[n*2187+469] = + s[2035];
gout[n*2187+470] = + s[2036];
gout[n*2187+471] = + s[2037];
gout[n*2187+472] = + s[2038];
gout[n*2187+473] = + s[2039];
gout[n*2187+474] = + s[2040];
gout[n*2187+475] = + s[2041];
gout[n*2187+476] = + s[2042];
gout[n*2187+477] = + s[2043];
gout[n*2187+478] = + s[2044];
gout[n*2187+479] = + s[2045];
gout[n*2187+480] = + s[2046];
gout[n*2187+481] = + s[2047];
gout[n*2187+482] = + s[2048];
gout[n*2187+483] = + s[2049];
gout[n*2187+484] = + s[2050];
gout[n*2187+485] = + s[2051];
gout[n*2187+486] = + s[162];
gout[n*2187+487] = + s[163];
gout[n*2187+488] = + s[164];
gout[n*2187+489] = + s[165];
gout[n*2187+490] = + s[166];
gout[n*2187+491] = + s[167];
gout[n*2187+492] = + s[168];
gout[n*2187+493] = + s[169];
gout[n*2187+494] = + s[170];
gout[n*2187+495] = + s[171];
gout[n*2187+496] = + s[172];
gout[n*2187+497] = + s[173];
gout[n*2187+498] = + s[174];
gout[n*2187+499] = + s[175];
gout[n*2187+500] = + s[176];
gout[n*2187+501] = + s[177];
gout[n*2187+502] = + s[178];
gout[n*2187+503] = + s[179];
gout[n*2187+504] = + s[180];
gout[n*2187+505] = + s[181];
gout[n*2187+506] = + s[182];
gout[n*2187+507] = + s[183];
gout[n*2187+508] = + s[184];
gout[n*2187+509] = + s[185];
gout[n*2187+510] = + s[186];
gout[n*2187+511] = + s[187];
gout[n*2187+512] = + s[188];
gout[n*2187+513] = + s[891];
gout[n*2187+514] = + s[892];
gout[n*2187+515] = + s[893];
gout[n*2187+516] = + s[894];
gout[n*2187+517] = + s[895];
gout[n*2187+518] = + s[896];
gout[n*2187+519] = + s[897];
gout[n*2187+520] = + s[898];
gout[n*2187+521] = + s[899];
gout[n*2187+522] = + s[900];
gout[n*2187+523] = + s[901];
gout[n*2187+524] = + s[902];
gout[n*2187+525] = + s[903];
gout[n*2187+526] = + s[904];
gout[n*2187+527] = + s[905];
gout[n*2187+528] = + s[906];
gout[n*2187+529] = + s[907];
gout[n*2187+530] = + s[908];
gout[n*2187+531] = + s[909];
gout[n*2187+532] = + s[910];
gout[n*2187+533] = + s[911];
gout[n*2187+534] = + s[912];
gout[n*2187+535] = + s[913];
gout[n*2187+536] = + s[914];
gout[n*2187+537] = + s[915];
gout[n*2187+538] = + s[916];
gout[n*2187+539] = + s[917];
gout[n*2187+540] = + s[1620];
gout[n*2187+541] = + s[1621];
gout[n*2187+542] = + s[1622];
gout[n*2187+543] = + s[1623];
gout[n*2187+544] = + s[1624];
gout[n*2187+545] = + s[1625];
gout[n*2187+546] = + s[1626];
gout[n*2187+547] = + s[1627];
gout[n*2187+548] = + s[1628];
gout[n*2187+549] = + s[1629];
gout[n*2187+550] = + s[1630];
gout[n*2187+551] = + s[1631];
gout[n*2187+552] = + s[1632];
gout[n*2187+553] = + s[1633];
gout[n*2187+554] = + s[1634];
gout[n*2187+555] = + s[1635];
gout[n*2187+556] = + s[1636];
gout[n*2187+557] = + s[1637];
gout[n*2187+558] = + s[1638];
gout[n*2187+559] = + s[1639];
gout[n*2187+560] = + s[1640];
gout[n*2187+561] = + s[1641];
gout[n*2187+562] = + s[1642];
gout[n*2187+563] = + s[1643];
gout[n*2187+564] = + s[1644];
gout[n*2187+565] = + s[1645];
gout[n*2187+566] = + s[1646];
gout[n*2187+567] = + s[405];
gout[n*2187+568] = + s[406];
gout[n*2187+569] = + s[407];
gout[n*2187+570] = + s[408];
gout[n*2187+571] = + s[409];
gout[n*2187+572] = + s[410];
gout[n*2187+573] = + s[411];
gout[n*2187+574] = + s[412];
gout[n*2187+575] = + s[413];
gout[n*2187+576] = + s[414];
gout[n*2187+577] = + s[415];
gout[n*2187+578] = + s[416];
gout[n*2187+579] = + s[417];
gout[n*2187+580] = + s[418];
gout[n*2187+581] = + s[419];
gout[n*2187+582] = + s[420];
gout[n*2187+583] = + s[421];
gout[n*2187+584] = + s[422];
gout[n*2187+585] = + s[423];
gout[n*2187+586] = + s[424];
gout[n*2187+587] = + s[425];
gout[n*2187+588] = + s[426];
gout[n*2187+589] = + s[427];
gout[n*2187+590] = + s[428];
gout[n*2187+591] = + s[429];
gout[n*2187+592] = + s[430];
gout[n*2187+593] = + s[431];
gout[n*2187+594] = + s[1134];
gout[n*2187+595] = + s[1135];
gout[n*2187+596] = + s[1136];
gout[n*2187+597] = + s[1137];
gout[n*2187+598] = + s[1138];
gout[n*2187+599] = + s[1139];
gout[n*2187+600] = + s[1140];
gout[n*2187+601] = + s[1141];
gout[n*2187+602] = + s[1142];
gout[n*2187+603] = + s[1143];
gout[n*2187+604] = + s[1144];
gout[n*2187+605] = + s[1145];
gout[n*2187+606] = + s[1146];
gout[n*2187+607] = + s[1147];
gout[n*2187+608] = + s[1148];
gout[n*2187+609] = + s[1149];
gout[n*2187+610] = + s[1150];
gout[n*2187+611] = + s[1151];
gout[n*2187+612] = + s[1152];
gout[n*2187+613] = + s[1153];
gout[n*2187+614] = + s[1154];
gout[n*2187+615] = + s[1155];
gout[n*2187+616] = + s[1156];
gout[n*2187+617] = + s[1157];
gout[n*2187+618] = + s[1158];
gout[n*2187+619] = + s[1159];
gout[n*2187+620] = + s[1160];
gout[n*2187+621] = + s[1863];
gout[n*2187+622] = + s[1864];
gout[n*2187+623] = + s[1865];
gout[n*2187+624] = + s[1866];
gout[n*2187+625] = + s[1867];
gout[n*2187+626] = + s[1868];
gout[n*2187+627] = + s[1869];
gout[n*2187+628] = + s[1870];
gout[n*2187+629] = + s[1871];
gout[n*2187+630] = + s[1872];
gout[n*2187+631] = + s[1873];
gout[n*2187+632] = + s[1874];
gout[n*2187+633] = + s[1875];
gout[n*2187+634] = + s[1876];
gout[n*2187+635] = + s[1877];
gout[n*2187+636] = + s[1878];
gout[n*2187+637] = + s[1879];
gout[n*2187+638] = + s[1880];
gout[n*2187+639] = + s[1881];
gout[n*2187+640] = + s[1882];
gout[n*2187+641] = + s[1883];
gout[n*2187+642] = + s[1884];
gout[n*2187+643] = + s[1885];
gout[n*2187+644] = + s[1886];
gout[n*2187+645] = + s[1887];
gout[n*2187+646] = + s[1888];
gout[n*2187+647] = + s[1889];
gout[n*2187+648] = + s[648];
gout[n*2187+649] = + s[649];
gout[n*2187+650] = + s[650];
gout[n*2187+651] = + s[651];
gout[n*2187+652] = + s[652];
gout[n*2187+653] = + s[653];
gout[n*2187+654] = + s[654];
gout[n*2187+655] = + s[655];
gout[n*2187+656] = + s[656];
gout[n*2187+657] = + s[657];
gout[n*2187+658] = + s[658];
gout[n*2187+659] = + s[659];
gout[n*2187+660] = + s[660];
gout[n*2187+661] = + s[661];
gout[n*2187+662] = + s[662];
gout[n*2187+663] = + s[663];
gout[n*2187+664] = + s[664];
gout[n*2187+665] = + s[665];
gout[n*2187+666] = + s[666];
gout[n*2187+667] = + s[667];
gout[n*2187+668] = + s[668];
gout[n*2187+669] = + s[669];
gout[n*2187+670] = + s[670];
gout[n*2187+671] = + s[671];
gout[n*2187+672] = + s[672];
gout[n*2187+673] = + s[673];
gout[n*2187+674] = + s[674];
gout[n*2187+675] = + s[1377];
gout[n*2187+676] = + s[1378];
gout[n*2187+677] = + s[1379];
gout[n*2187+678] = + s[1380];
gout[n*2187+679] = + s[1381];
gout[n*2187+680] = + s[1382];
gout[n*2187+681] = + s[1383];
gout[n*2187+682] = + s[1384];
gout[n*2187+683] = + s[1385];
gout[n*2187+684] = + s[1386];
gout[n*2187+685] = + s[1387];
gout[n*2187+686] = + s[1388];
gout[n*2187+687] = + s[1389];
gout[n*2187+688] = + s[1390];
gout[n*2187+689] = + s[1391];
gout[n*2187+690] = + s[1392];
gout[n*2187+691] = + s[1393];
gout[n*2187+692] = + s[1394];
gout[n*2187+693] = + s[1395];
gout[n*2187+694] = + s[1396];
gout[n*2187+695] = + s[1397];
gout[n*2187+696] = + s[1398];
gout[n*2187+697] = + s[1399];
gout[n*2187+698] = + s[1400];
gout[n*2187+699] = + s[1401];
gout[n*2187+700] = + s[1402];
gout[n*2187+701] = + s[1403];
gout[n*2187+702] = + s[2106];
gout[n*2187+703] = + s[2107];
gout[n*2187+704] = + s[2108];
gout[n*2187+705] = + s[2109];
gout[n*2187+706] = + s[2110];
gout[n*2187+707] = + s[2111];
gout[n*2187+708] = + s[2112];
gout[n*2187+709] = + s[2113];
gout[n*2187+710] = + s[2114];
gout[n*2187+711] = + s[2115];
gout[n*2187+712] = + s[2116];
gout[n*2187+713] = + s[2117];
gout[n*2187+714] = + s[2118];
gout[n*2187+715] = + s[2119];
gout[n*2187+716] = + s[2120];
gout[n*2187+717] = + s[2121];
gout[n*2187+718] = + s[2122];
gout[n*2187+719] = + s[2123];
gout[n*2187+720] = + s[2124];
gout[n*2187+721] = + s[2125];
gout[n*2187+722] = + s[2126];
gout[n*2187+723] = + s[2127];
gout[n*2187+724] = + s[2128];
gout[n*2187+725] = + s[2129];
gout[n*2187+726] = + s[2130];
gout[n*2187+727] = + s[2131];
gout[n*2187+728] = + s[2132];
gout[n*2187+729] = + s[27];
gout[n*2187+730] = + s[28];
gout[n*2187+731] = + s[29];
gout[n*2187+732] = + s[30];
gout[n*2187+733] = + s[31];
gout[n*2187+734] = + s[32];
gout[n*2187+735] = + s[33];
gout[n*2187+736] = + s[34];
gout[n*2187+737] = + s[35];
gout[n*2187+738] = + s[36];
gout[n*2187+739] = + s[37];
gout[n*2187+740] = + s[38];
gout[n*2187+741] = + s[39];
gout[n*2187+742] = + s[40];
gout[n*2187+743] = + s[41];
gout[n*2187+744] = + s[42];
gout[n*2187+745] = + s[43];
gout[n*2187+746] = + s[44];
gout[n*2187+747] = + s[45];
gout[n*2187+748] = + s[46];
gout[n*2187+749] = + s[47];
gout[n*2187+750] = + s[48];
gout[n*2187+751] = + s[49];
gout[n*2187+752] = + s[50];
gout[n*2187+753] = + s[51];
gout[n*2187+754] = + s[52];
gout[n*2187+755] = + s[53];
gout[n*2187+756] = + s[756];
gout[n*2187+757] = + s[757];
gout[n*2187+758] = + s[758];
gout[n*2187+759] = + s[759];
gout[n*2187+760] = + s[760];
gout[n*2187+761] = + s[761];
gout[n*2187+762] = + s[762];
gout[n*2187+763] = + s[763];
gout[n*2187+764] = + s[764];
gout[n*2187+765] = + s[765];
gout[n*2187+766] = + s[766];
gout[n*2187+767] = + s[767];
gout[n*2187+768] = + s[768];
gout[n*2187+769] = + s[769];
gout[n*2187+770] = + s[770];
gout[n*2187+771] = + s[771];
gout[n*2187+772] = + s[772];
gout[n*2187+773] = + s[773];
gout[n*2187+774] = + s[774];
gout[n*2187+775] = + s[775];
gout[n*2187+776] = + s[776];
gout[n*2187+777] = + s[777];
gout[n*2187+778] = + s[778];
gout[n*2187+779] = + s[779];
gout[n*2187+780] = + s[780];
gout[n*2187+781] = + s[781];
gout[n*2187+782] = + s[782];
gout[n*2187+783] = + s[1485];
gout[n*2187+784] = + s[1486];
gout[n*2187+785] = + s[1487];
gout[n*2187+786] = + s[1488];
gout[n*2187+787] = + s[1489];
gout[n*2187+788] = + s[1490];
gout[n*2187+789] = + s[1491];
gout[n*2187+790] = + s[1492];
gout[n*2187+791] = + s[1493];
gout[n*2187+792] = + s[1494];
gout[n*2187+793] = + s[1495];
gout[n*2187+794] = + s[1496];
gout[n*2187+795] = + s[1497];
gout[n*2187+796] = + s[1498];
gout[n*2187+797] = + s[1499];
gout[n*2187+798] = + s[1500];
gout[n*2187+799] = + s[1501];
gout[n*2187+800] = + s[1502];
gout[n*2187+801] = + s[1503];
gout[n*2187+802] = + s[1504];
gout[n*2187+803] = + s[1505];
gout[n*2187+804] = + s[1506];
gout[n*2187+805] = + s[1507];
gout[n*2187+806] = + s[1508];
gout[n*2187+807] = + s[1509];
gout[n*2187+808] = + s[1510];
gout[n*2187+809] = + s[1511];
gout[n*2187+810] = + s[270];
gout[n*2187+811] = + s[271];
gout[n*2187+812] = + s[272];
gout[n*2187+813] = + s[273];
gout[n*2187+814] = + s[274];
gout[n*2187+815] = + s[275];
gout[n*2187+816] = + s[276];
gout[n*2187+817] = + s[277];
gout[n*2187+818] = + s[278];
gout[n*2187+819] = + s[279];
gout[n*2187+820] = + s[280];
gout[n*2187+821] = + s[281];
gout[n*2187+822] = + s[282];
gout[n*2187+823] = + s[283];
gout[n*2187+824] = + s[284];
gout[n*2187+825] = + s[285];
gout[n*2187+826] = + s[286];
gout[n*2187+827] = + s[287];
gout[n*2187+828] = + s[288];
gout[n*2187+829] = + s[289];
gout[n*2187+830] = + s[290];
gout[n*2187+831] = + s[291];
gout[n*2187+832] = + s[292];
gout[n*2187+833] = + s[293];
gout[n*2187+834] = + s[294];
gout[n*2187+835] = + s[295];
gout[n*2187+836] = + s[296];
gout[n*2187+837] = + s[999];
gout[n*2187+838] = + s[1000];
gout[n*2187+839] = + s[1001];
gout[n*2187+840] = + s[1002];
gout[n*2187+841] = + s[1003];
gout[n*2187+842] = + s[1004];
gout[n*2187+843] = + s[1005];
gout[n*2187+844] = + s[1006];
gout[n*2187+845] = + s[1007];
gout[n*2187+846] = + s[1008];
gout[n*2187+847] = + s[1009];
gout[n*2187+848] = + s[1010];
gout[n*2187+849] = + s[1011];
gout[n*2187+850] = + s[1012];
gout[n*2187+851] = + s[1013];
gout[n*2187+852] = + s[1014];
gout[n*2187+853] = + s[1015];
gout[n*2187+854] = + s[1016];
gout[n*2187+855] = + s[1017];
gout[n*2187+856] = + s[1018];
gout[n*2187+857] = + s[1019];
gout[n*2187+858] = + s[1020];
gout[n*2187+859] = + s[1021];
gout[n*2187+860] = + s[1022];
gout[n*2187+861] = + s[1023];
gout[n*2187+862] = + s[1024];
gout[n*2187+863] = + s[1025];
gout[n*2187+864] = + s[1728];
gout[n*2187+865] = + s[1729];
gout[n*2187+866] = + s[1730];
gout[n*2187+867] = + s[1731];
gout[n*2187+868] = + s[1732];
gout[n*2187+869] = + s[1733];
gout[n*2187+870] = + s[1734];
gout[n*2187+871] = + s[1735];
gout[n*2187+872] = + s[1736];
gout[n*2187+873] = + s[1737];
gout[n*2187+874] = + s[1738];
gout[n*2187+875] = + s[1739];
gout[n*2187+876] = + s[1740];
gout[n*2187+877] = + s[1741];
gout[n*2187+878] = + s[1742];
gout[n*2187+879] = + s[1743];
gout[n*2187+880] = + s[1744];
gout[n*2187+881] = + s[1745];
gout[n*2187+882] = + s[1746];
gout[n*2187+883] = + s[1747];
gout[n*2187+884] = + s[1748];
gout[n*2187+885] = + s[1749];
gout[n*2187+886] = + s[1750];
gout[n*2187+887] = + s[1751];
gout[n*2187+888] = + s[1752];
gout[n*2187+889] = + s[1753];
gout[n*2187+890] = + s[1754];
gout[n*2187+891] = + s[513];
gout[n*2187+892] = + s[514];
gout[n*2187+893] = + s[515];
gout[n*2187+894] = + s[516];
gout[n*2187+895] = + s[517];
gout[n*2187+896] = + s[518];
gout[n*2187+897] = + s[519];
gout[n*2187+898] = + s[520];
gout[n*2187+899] = + s[521];
gout[n*2187+900] = + s[522];
gout[n*2187+901] = + s[523];
gout[n*2187+902] = + s[524];
gout[n*2187+903] = + s[525];
gout[n*2187+904] = + s[526];
gout[n*2187+905] = + s[527];
gout[n*2187+906] = + s[528];
gout[n*2187+907] = + s[529];
gout[n*2187+908] = + s[530];
gout[n*2187+909] = + s[531];
gout[n*2187+910] = + s[532];
gout[n*2187+911] = + s[533];
gout[n*2187+912] = + s[534];
gout[n*2187+913] = + s[535];
gout[n*2187+914] = + s[536];
gout[n*2187+915] = + s[537];
gout[n*2187+916] = + s[538];
gout[n*2187+917] = + s[539];
gout[n*2187+918] = + s[1242];
gout[n*2187+919] = + s[1243];
gout[n*2187+920] = + s[1244];
gout[n*2187+921] = + s[1245];
gout[n*2187+922] = + s[1246];
gout[n*2187+923] = + s[1247];
gout[n*2187+924] = + s[1248];
gout[n*2187+925] = + s[1249];
gout[n*2187+926] = + s[1250];
gout[n*2187+927] = + s[1251];
gout[n*2187+928] = + s[1252];
gout[n*2187+929] = + s[1253];
gout[n*2187+930] = + s[1254];
gout[n*2187+931] = + s[1255];
gout[n*2187+932] = + s[1256];
gout[n*2187+933] = + s[1257];
gout[n*2187+934] = + s[1258];
gout[n*2187+935] = + s[1259];
gout[n*2187+936] = + s[1260];
gout[n*2187+937] = + s[1261];
gout[n*2187+938] = + s[1262];
gout[n*2187+939] = + s[1263];
gout[n*2187+940] = + s[1264];
gout[n*2187+941] = + s[1265];
gout[n*2187+942] = + s[1266];
gout[n*2187+943] = + s[1267];
gout[n*2187+944] = + s[1268];
gout[n*2187+945] = + s[1971];
gout[n*2187+946] = + s[1972];
gout[n*2187+947] = + s[1973];
gout[n*2187+948] = + s[1974];
gout[n*2187+949] = + s[1975];
gout[n*2187+950] = + s[1976];
gout[n*2187+951] = + s[1977];
gout[n*2187+952] = + s[1978];
gout[n*2187+953] = + s[1979];
gout[n*2187+954] = + s[1980];
gout[n*2187+955] = + s[1981];
gout[n*2187+956] = + s[1982];
gout[n*2187+957] = + s[1983];
gout[n*2187+958] = + s[1984];
gout[n*2187+959] = + s[1985];
gout[n*2187+960] = + s[1986];
gout[n*2187+961] = + s[1987];
gout[n*2187+962] = + s[1988];
gout[n*2187+963] = + s[1989];
gout[n*2187+964] = + s[1990];
gout[n*2187+965] = + s[1991];
gout[n*2187+966] = + s[1992];
gout[n*2187+967] = + s[1993];
gout[n*2187+968] = + s[1994];
gout[n*2187+969] = + s[1995];
gout[n*2187+970] = + s[1996];
gout[n*2187+971] = + s[1997];
gout[n*2187+972] = + s[108];
gout[n*2187+973] = + s[109];
gout[n*2187+974] = + s[110];
gout[n*2187+975] = + s[111];
gout[n*2187+976] = + s[112];
gout[n*2187+977] = + s[113];
gout[n*2187+978] = + s[114];
gout[n*2187+979] = + s[115];
gout[n*2187+980] = + s[116];
gout[n*2187+981] = + s[117];
gout[n*2187+982] = + s[118];
gout[n*2187+983] = + s[119];
gout[n*2187+984] = + s[120];
gout[n*2187+985] = + s[121];
gout[n*2187+986] = + s[122];
gout[n*2187+987] = + s[123];
gout[n*2187+988] = + s[124];
gout[n*2187+989] = + s[125];
gout[n*2187+990] = + s[126];
gout[n*2187+991] = + s[127];
gout[n*2187+992] = + s[128];
gout[n*2187+993] = + s[129];
gout[n*2187+994] = + s[130];
gout[n*2187+995] = + s[131];
gout[n*2187+996] = + s[132];
gout[n*2187+997] = + s[133];
gout[n*2187+998] = + s[134];
gout[n*2187+999] = + s[837];
gout[n*2187+1000] = + s[838];
gout[n*2187+1001] = + s[839];
gout[n*2187+1002] = + s[840];
gout[n*2187+1003] = + s[841];
gout[n*2187+1004] = + s[842];
gout[n*2187+1005] = + s[843];
gout[n*2187+1006] = + s[844];
gout[n*2187+1007] = + s[845];
gout[n*2187+1008] = + s[846];
gout[n*2187+1009] = + s[847];
gout[n*2187+1010] = + s[848];
gout[n*2187+1011] = + s[849];
gout[n*2187+1012] = + s[850];
gout[n*2187+1013] = + s[851];
gout[n*2187+1014] = + s[852];
gout[n*2187+1015] = + s[853];
gout[n*2187+1016] = + s[854];
gout[n*2187+1017] = + s[855];
gout[n*2187+1018] = + s[856];
gout[n*2187+1019] = + s[857];
gout[n*2187+1020] = + s[858];
gout[n*2187+1021] = + s[859];
gout[n*2187+1022] = + s[860];
gout[n*2187+1023] = + s[861];
gout[n*2187+1024] = + s[862];
gout[n*2187+1025] = + s[863];
gout[n*2187+1026] = + s[1566];
gout[n*2187+1027] = + s[1567];
gout[n*2187+1028] = + s[1568];
gout[n*2187+1029] = + s[1569];
gout[n*2187+1030] = + s[1570];
gout[n*2187+1031] = + s[1571];
gout[n*2187+1032] = + s[1572];
gout[n*2187+1033] = + s[1573];
gout[n*2187+1034] = + s[1574];
gout[n*2187+1035] = + s[1575];
gout[n*2187+1036] = + s[1576];
gout[n*2187+1037] = + s[1577];
gout[n*2187+1038] = + s[1578];
gout[n*2187+1039] = + s[1579];
gout[n*2187+1040] = + s[1580];
gout[n*2187+1041] = + s[1581];
gout[n*2187+1042] = + s[1582];
gout[n*2187+1043] = + s[1583];
gout[n*2187+1044] = + s[1584];
gout[n*2187+1045] = + s[1585];
gout[n*2187+1046] = + s[1586];
gout[n*2187+1047] = + s[1587];
gout[n*2187+1048] = + s[1588];
gout[n*2187+1049] = + s[1589];
gout[n*2187+1050] = + s[1590];
gout[n*2187+1051] = + s[1591];
gout[n*2187+1052] = + s[1592];
gout[n*2187+1053] = + s[351];
gout[n*2187+1054] = + s[352];
gout[n*2187+1055] = + s[353];
gout[n*2187+1056] = + s[354];
gout[n*2187+1057] = + s[355];
gout[n*2187+1058] = + s[356];
gout[n*2187+1059] = + s[357];
gout[n*2187+1060] = + s[358];
gout[n*2187+1061] = + s[359];
gout[n*2187+1062] = + s[360];
gout[n*2187+1063] = + s[361];
gout[n*2187+1064] = + s[362];
gout[n*2187+1065] = + s[363];
gout[n*2187+1066] = + s[364];
gout[n*2187+1067] = + s[365];
gout[n*2187+1068] = + s[366];
gout[n*2187+1069] = + s[367];
gout[n*2187+1070] = + s[368];
gout[n*2187+1071] = + s[369];
gout[n*2187+1072] = + s[370];
gout[n*2187+1073] = + s[371];
gout[n*2187+1074] = + s[372];
gout[n*2187+1075] = + s[373];
gout[n*2187+1076] = + s[374];
gout[n*2187+1077] = + s[375];
gout[n*2187+1078] = + s[376];
gout[n*2187+1079] = + s[377];
gout[n*2187+1080] = + s[1080];
gout[n*2187+1081] = + s[1081];
gout[n*2187+1082] = + s[1082];
gout[n*2187+1083] = + s[1083];
gout[n*2187+1084] = + s[1084];
gout[n*2187+1085] = + s[1085];
gout[n*2187+1086] = + s[1086];
gout[n*2187+1087] = + s[1087];
gout[n*2187+1088] = + s[1088];
gout[n*2187+1089] = + s[1089];
gout[n*2187+1090] = + s[1090];
gout[n*2187+1091] = + s[1091];
gout[n*2187+1092] = + s[1092];
gout[n*2187+1093] = + s[1093];
gout[n*2187+1094] = + s[1094];
gout[n*2187+1095] = + s[1095];
gout[n*2187+1096] = + s[1096];
gout[n*2187+1097] = + s[1097];
gout[n*2187+1098] = + s[1098];
gout[n*2187+1099] = + s[1099];
gout[n*2187+1100] = + s[1100];
gout[n*2187+1101] = + s[1101];
gout[n*2187+1102] = + s[1102];
gout[n*2187+1103] = + s[1103];
gout[n*2187+1104] = + s[1104];
gout[n*2187+1105] = + s[1105];
gout[n*2187+1106] = + s[1106];
gout[n*2187+1107] = + s[1809];
gout[n*2187+1108] = + s[1810];
gout[n*2187+1109] = + s[1811];
gout[n*2187+1110] = + s[1812];
gout[n*2187+1111] = + s[1813];
gout[n*2187+1112] = + s[1814];
gout[n*2187+1113] = + s[1815];
gout[n*2187+1114] = + s[1816];
gout[n*2187+1115] = + s[1817];
gout[n*2187+1116] = + s[1818];
gout[n*2187+1117] = + s[1819];
gout[n*2187+1118] = + s[1820];
gout[n*2187+1119] = + s[1821];
gout[n*2187+1120] = + s[1822];
gout[n*2187+1121] = + s[1823];
gout[n*2187+1122] = + s[1824];
gout[n*2187+1123] = + s[1825];
gout[n*2187+1124] = + s[1826];
gout[n*2187+1125] = + s[1827];
gout[n*2187+1126] = + s[1828];
gout[n*2187+1127] = + s[1829];
gout[n*2187+1128] = + s[1830];
gout[n*2187+1129] = + s[1831];
gout[n*2187+1130] = + s[1832];
gout[n*2187+1131] = + s[1833];
gout[n*2187+1132] = + s[1834];
gout[n*2187+1133] = + s[1835];
gout[n*2187+1134] = + s[594];
gout[n*2187+1135] = + s[595];
gout[n*2187+1136] = + s[596];
gout[n*2187+1137] = + s[597];
gout[n*2187+1138] = + s[598];
gout[n*2187+1139] = + s[599];
gout[n*2187+1140] = + s[600];
gout[n*2187+1141] = + s[601];
gout[n*2187+1142] = + s[602];
gout[n*2187+1143] = + s[603];
gout[n*2187+1144] = + s[604];
gout[n*2187+1145] = + s[605];
gout[n*2187+1146] = + s[606];
gout[n*2187+1147] = + s[607];
gout[n*2187+1148] = + s[608];
gout[n*2187+1149] = + s[609];
gout[n*2187+1150] = + s[610];
gout[n*2187+1151] = + s[611];
gout[n*2187+1152] = + s[612];
gout[n*2187+1153] = + s[613];
gout[n*2187+1154] = + s[614];
gout[n*2187+1155] = + s[615];
gout[n*2187+1156] = + s[616];
gout[n*2187+1157] = + s[617];
gout[n*2187+1158] = + s[618];
gout[n*2187+1159] = + s[619];
gout[n*2187+1160] = + s[620];
gout[n*2187+1161] = + s[1323];
gout[n*2187+1162] = + s[1324];
gout[n*2187+1163] = + s[1325];
gout[n*2187+1164] = + s[1326];
gout[n*2187+1165] = + s[1327];
gout[n*2187+1166] = + s[1328];
gout[n*2187+1167] = + s[1329];
gout[n*2187+1168] = + s[1330];
gout[n*2187+1169] = + s[1331];
gout[n*2187+1170] = + s[1332];
gout[n*2187+1171] = + s[1333];
gout[n*2187+1172] = + s[1334];
gout[n*2187+1173] = + s[1335];
gout[n*2187+1174] = + s[1336];
gout[n*2187+1175] = + s[1337];
gout[n*2187+1176] = + s[1338];
gout[n*2187+1177] = + s[1339];
gout[n*2187+1178] = + s[1340];
gout[n*2187+1179] = + s[1341];
gout[n*2187+1180] = + s[1342];
gout[n*2187+1181] = + s[1343];
gout[n*2187+1182] = + s[1344];
gout[n*2187+1183] = + s[1345];
gout[n*2187+1184] = + s[1346];
gout[n*2187+1185] = + s[1347];
gout[n*2187+1186] = + s[1348];
gout[n*2187+1187] = + s[1349];
gout[n*2187+1188] = + s[2052];
gout[n*2187+1189] = + s[2053];
gout[n*2187+1190] = + s[2054];
gout[n*2187+1191] = + s[2055];
gout[n*2187+1192] = + s[2056];
gout[n*2187+1193] = + s[2057];
gout[n*2187+1194] = + s[2058];
gout[n*2187+1195] = + s[2059];
gout[n*2187+1196] = + s[2060];
gout[n*2187+1197] = + s[2061];
gout[n*2187+1198] = + s[2062];
gout[n*2187+1199] = + s[2063];
gout[n*2187+1200] = + s[2064];
gout[n*2187+1201] = + s[2065];
gout[n*2187+1202] = + s[2066];
gout[n*2187+1203] = + s[2067];
gout[n*2187+1204] = + s[2068];
gout[n*2187+1205] = + s[2069];
gout[n*2187+1206] = + s[2070];
gout[n*2187+1207] = + s[2071];
gout[n*2187+1208] = + s[2072];
gout[n*2187+1209] = + s[2073];
gout[n*2187+1210] = + s[2074];
gout[n*2187+1211] = + s[2075];
gout[n*2187+1212] = + s[2076];
gout[n*2187+1213] = + s[2077];
gout[n*2187+1214] = + s[2078];
gout[n*2187+1215] = + s[189];
gout[n*2187+1216] = + s[190];
gout[n*2187+1217] = + s[191];
gout[n*2187+1218] = + s[192];
gout[n*2187+1219] = + s[193];
gout[n*2187+1220] = + s[194];
gout[n*2187+1221] = + s[195];
gout[n*2187+1222] = + s[196];
gout[n*2187+1223] = + s[197];
gout[n*2187+1224] = + s[198];
gout[n*2187+1225] = + s[199];
gout[n*2187+1226] = + s[200];
gout[n*2187+1227] = + s[201];
gout[n*2187+1228] = + s[202];
gout[n*2187+1229] = + s[203];
gout[n*2187+1230] = + s[204];
gout[n*2187+1231] = + s[205];
gout[n*2187+1232] = + s[206];
gout[n*2187+1233] = + s[207];
gout[n*2187+1234] = + s[208];
gout[n*2187+1235] = + s[209];
gout[n*2187+1236] = + s[210];
gout[n*2187+1237] = + s[211];
gout[n*2187+1238] = + s[212];
gout[n*2187+1239] = + s[213];
gout[n*2187+1240] = + s[214];
gout[n*2187+1241] = + s[215];
gout[n*2187+1242] = + s[918];
gout[n*2187+1243] = + s[919];
gout[n*2187+1244] = + s[920];
gout[n*2187+1245] = + s[921];
gout[n*2187+1246] = + s[922];
gout[n*2187+1247] = + s[923];
gout[n*2187+1248] = + s[924];
gout[n*2187+1249] = + s[925];
gout[n*2187+1250] = + s[926];
gout[n*2187+1251] = + s[927];
gout[n*2187+1252] = + s[928];
gout[n*2187+1253] = + s[929];
gout[n*2187+1254] = + s[930];
gout[n*2187+1255] = + s[931];
gout[n*2187+1256] = + s[932];
gout[n*2187+1257] = + s[933];
gout[n*2187+1258] = + s[934];
gout[n*2187+1259] = + s[935];
gout[n*2187+1260] = + s[936];
gout[n*2187+1261] = + s[937];
gout[n*2187+1262] = + s[938];
gout[n*2187+1263] = + s[939];
gout[n*2187+1264] = + s[940];
gout[n*2187+1265] = + s[941];
gout[n*2187+1266] = + s[942];
gout[n*2187+1267] = + s[943];
gout[n*2187+1268] = + s[944];
gout[n*2187+1269] = + s[1647];
gout[n*2187+1270] = + s[1648];
gout[n*2187+1271] = + s[1649];
gout[n*2187+1272] = + s[1650];
gout[n*2187+1273] = + s[1651];
gout[n*2187+1274] = + s[1652];
gout[n*2187+1275] = + s[1653];
gout[n*2187+1276] = + s[1654];
gout[n*2187+1277] = + s[1655];
gout[n*2187+1278] = + s[1656];
gout[n*2187+1279] = + s[1657];
gout[n*2187+1280] = + s[1658];
gout[n*2187+1281] = + s[1659];
gout[n*2187+1282] = + s[1660];
gout[n*2187+1283] = + s[1661];
gout[n*2187+1284] = + s[1662];
gout[n*2187+1285] = + s[1663];
gout[n*2187+1286] = + s[1664];
gout[n*2187+1287] = + s[1665];
gout[n*2187+1288] = + s[1666];
gout[n*2187+1289] = + s[1667];
gout[n*2187+1290] = + s[1668];
gout[n*2187+1291] = + s[1669];
gout[n*2187+1292] = + s[1670];
gout[n*2187+1293] = + s[1671];
gout[n*2187+1294] = + s[1672];
gout[n*2187+1295] = + s[1673];
gout[n*2187+1296] = + s[432];
gout[n*2187+1297] = + s[433];
gout[n*2187+1298] = + s[434];
gout[n*2187+1299] = + s[435];
gout[n*2187+1300] = + s[436];
gout[n*2187+1301] = + s[437];
gout[n*2187+1302] = + s[438];
gout[n*2187+1303] = + s[439];
gout[n*2187+1304] = + s[440];
gout[n*2187+1305] = + s[441];
gout[n*2187+1306] = + s[442];
gout[n*2187+1307] = + s[443];
gout[n*2187+1308] = + s[444];
gout[n*2187+1309] = + s[445];
gout[n*2187+1310] = + s[446];
gout[n*2187+1311] = + s[447];
gout[n*2187+1312] = + s[448];
gout[n*2187+1313] = + s[449];
gout[n*2187+1314] = + s[450];
gout[n*2187+1315] = + s[451];
gout[n*2187+1316] = + s[452];
gout[n*2187+1317] = + s[453];
gout[n*2187+1318] = + s[454];
gout[n*2187+1319] = + s[455];
gout[n*2187+1320] = + s[456];
gout[n*2187+1321] = + s[457];
gout[n*2187+1322] = + s[458];
gout[n*2187+1323] = + s[1161];
gout[n*2187+1324] = + s[1162];
gout[n*2187+1325] = + s[1163];
gout[n*2187+1326] = + s[1164];
gout[n*2187+1327] = + s[1165];
gout[n*2187+1328] = + s[1166];
gout[n*2187+1329] = + s[1167];
gout[n*2187+1330] = + s[1168];
gout[n*2187+1331] = + s[1169];
gout[n*2187+1332] = + s[1170];
gout[n*2187+1333] = + s[1171];
gout[n*2187+1334] = + s[1172];
gout[n*2187+1335] = + s[1173];
gout[n*2187+1336] = + s[1174];
gout[n*2187+1337] = + s[1175];
gout[n*2187+1338] = + s[1176];
gout[n*2187+1339] = + s[1177];
gout[n*2187+1340] = + s[1178];
gout[n*2187+1341] = + s[1179];
gout[n*2187+1342] = + s[1180];
gout[n*2187+1343] = + s[1181];
gout[n*2187+1344] = + s[1182];
gout[n*2187+1345] = + s[1183];
gout[n*2187+1346] = + s[1184];
gout[n*2187+1347] = + s[1185];
gout[n*2187+1348] = + s[1186];
gout[n*2187+1349] = + s[1187];
gout[n*2187+1350] = + s[1890];
gout[n*2187+1351] = + s[1891];
gout[n*2187+1352] = + s[1892];
gout[n*2187+1353] = + s[1893];
gout[n*2187+1354] = + s[1894];
gout[n*2187+1355] = + s[1895];
gout[n*2187+1356] = + s[1896];
gout[n*2187+1357] = + s[1897];
gout[n*2187+1358] = + s[1898];
gout[n*2187+1359] = + s[1899];
gout[n*2187+1360] = + s[1900];
gout[n*2187+1361] = + s[1901];
gout[n*2187+1362] = + s[1902];
gout[n*2187+1363] = + s[1903];
gout[n*2187+1364] = + s[1904];
gout[n*2187+1365] = + s[1905];
gout[n*2187+1366] = + s[1906];
gout[n*2187+1367] = + s[1907];
gout[n*2187+1368] = + s[1908];
gout[n*2187+1369] = + s[1909];
gout[n*2187+1370] = + s[1910];
gout[n*2187+1371] = + s[1911];
gout[n*2187+1372] = + s[1912];
gout[n*2187+1373] = + s[1913];
gout[n*2187+1374] = + s[1914];
gout[n*2187+1375] = + s[1915];
gout[n*2187+1376] = + s[1916];
gout[n*2187+1377] = + s[675];
gout[n*2187+1378] = + s[676];
gout[n*2187+1379] = + s[677];
gout[n*2187+1380] = + s[678];
gout[n*2187+1381] = + s[679];
gout[n*2187+1382] = + s[680];
gout[n*2187+1383] = + s[681];
gout[n*2187+1384] = + s[682];
gout[n*2187+1385] = + s[683];
gout[n*2187+1386] = + s[684];
gout[n*2187+1387] = + s[685];
gout[n*2187+1388] = + s[686];
gout[n*2187+1389] = + s[687];
gout[n*2187+1390] = + s[688];
gout[n*2187+1391] = + s[689];
gout[n*2187+1392] = + s[690];
gout[n*2187+1393] = + s[691];
gout[n*2187+1394] = + s[692];
gout[n*2187+1395] = + s[693];
gout[n*2187+1396] = + s[694];
gout[n*2187+1397] = + s[695];
gout[n*2187+1398] = + s[696];
gout[n*2187+1399] = + s[697];
gout[n*2187+1400] = + s[698];
gout[n*2187+1401] = + s[699];
gout[n*2187+1402] = + s[700];
gout[n*2187+1403] = + s[701];
gout[n*2187+1404] = + s[1404];
gout[n*2187+1405] = + s[1405];
gout[n*2187+1406] = + s[1406];
gout[n*2187+1407] = + s[1407];
gout[n*2187+1408] = + s[1408];
gout[n*2187+1409] = + s[1409];
gout[n*2187+1410] = + s[1410];
gout[n*2187+1411] = + s[1411];
gout[n*2187+1412] = + s[1412];
gout[n*2187+1413] = + s[1413];
gout[n*2187+1414] = + s[1414];
gout[n*2187+1415] = + s[1415];
gout[n*2187+1416] = + s[1416];
gout[n*2187+1417] = + s[1417];
gout[n*2187+1418] = + s[1418];
gout[n*2187+1419] = + s[1419];
gout[n*2187+1420] = + s[1420];
gout[n*2187+1421] = + s[1421];
gout[n*2187+1422] = + s[1422];
gout[n*2187+1423] = + s[1423];
gout[n*2187+1424] = + s[1424];
gout[n*2187+1425] = + s[1425];
gout[n*2187+1426] = + s[1426];
gout[n*2187+1427] = + s[1427];
gout[n*2187+1428] = + s[1428];
gout[n*2187+1429] = + s[1429];
gout[n*2187+1430] = + s[1430];
gout[n*2187+1431] = + s[2133];
gout[n*2187+1432] = + s[2134];
gout[n*2187+1433] = + s[2135];
gout[n*2187+1434] = + s[2136];
gout[n*2187+1435] = + s[2137];
gout[n*2187+1436] = + s[2138];
gout[n*2187+1437] = + s[2139];
gout[n*2187+1438] = + s[2140];
gout[n*2187+1439] = + s[2141];
gout[n*2187+1440] = + s[2142];
gout[n*2187+1441] = + s[2143];
gout[n*2187+1442] = + s[2144];
gout[n*2187+1443] = + s[2145];
gout[n*2187+1444] = + s[2146];
gout[n*2187+1445] = + s[2147];
gout[n*2187+1446] = + s[2148];
gout[n*2187+1447] = + s[2149];
gout[n*2187+1448] = + s[2150];
gout[n*2187+1449] = + s[2151];
gout[n*2187+1450] = + s[2152];
gout[n*2187+1451] = + s[2153];
gout[n*2187+1452] = + s[2154];
gout[n*2187+1453] = + s[2155];
gout[n*2187+1454] = + s[2156];
gout[n*2187+1455] = + s[2157];
gout[n*2187+1456] = + s[2158];
gout[n*2187+1457] = + s[2159];
gout[n*2187+1458] = + s[54];
gout[n*2187+1459] = + s[55];
gout[n*2187+1460] = + s[56];
gout[n*2187+1461] = + s[57];
gout[n*2187+1462] = + s[58];
gout[n*2187+1463] = + s[59];
gout[n*2187+1464] = + s[60];
gout[n*2187+1465] = + s[61];
gout[n*2187+1466] = + s[62];
gout[n*2187+1467] = + s[63];
gout[n*2187+1468] = + s[64];
gout[n*2187+1469] = + s[65];
gout[n*2187+1470] = + s[66];
gout[n*2187+1471] = + s[67];
gout[n*2187+1472] = + s[68];
gout[n*2187+1473] = + s[69];
gout[n*2187+1474] = + s[70];
gout[n*2187+1475] = + s[71];
gout[n*2187+1476] = + s[72];
gout[n*2187+1477] = + s[73];
gout[n*2187+1478] = + s[74];
gout[n*2187+1479] = + s[75];
gout[n*2187+1480] = + s[76];
gout[n*2187+1481] = + s[77];
gout[n*2187+1482] = + s[78];
gout[n*2187+1483] = + s[79];
gout[n*2187+1484] = + s[80];
gout[n*2187+1485] = + s[783];
gout[n*2187+1486] = + s[784];
gout[n*2187+1487] = + s[785];
gout[n*2187+1488] = + s[786];
gout[n*2187+1489] = + s[787];
gout[n*2187+1490] = + s[788];
gout[n*2187+1491] = + s[789];
gout[n*2187+1492] = + s[790];
gout[n*2187+1493] = + s[791];
gout[n*2187+1494] = + s[792];
gout[n*2187+1495] = + s[793];
gout[n*2187+1496] = + s[794];
gout[n*2187+1497] = + s[795];
gout[n*2187+1498] = + s[796];
gout[n*2187+1499] = + s[797];
gout[n*2187+1500] = + s[798];
gout[n*2187+1501] = + s[799];
gout[n*2187+1502] = + s[800];
gout[n*2187+1503] = + s[801];
gout[n*2187+1504] = + s[802];
gout[n*2187+1505] = + s[803];
gout[n*2187+1506] = + s[804];
gout[n*2187+1507] = + s[805];
gout[n*2187+1508] = + s[806];
gout[n*2187+1509] = + s[807];
gout[n*2187+1510] = + s[808];
gout[n*2187+1511] = + s[809];
gout[n*2187+1512] = + s[1512];
gout[n*2187+1513] = + s[1513];
gout[n*2187+1514] = + s[1514];
gout[n*2187+1515] = + s[1515];
gout[n*2187+1516] = + s[1516];
gout[n*2187+1517] = + s[1517];
gout[n*2187+1518] = + s[1518];
gout[n*2187+1519] = + s[1519];
gout[n*2187+1520] = + s[1520];
gout[n*2187+1521] = + s[1521];
gout[n*2187+1522] = + s[1522];
gout[n*2187+1523] = + s[1523];
gout[n*2187+1524] = + s[1524];
gout[n*2187+1525] = + s[1525];
gout[n*2187+1526] = + s[1526];
gout[n*2187+1527] = + s[1527];
gout[n*2187+1528] = + s[1528];
gout[n*2187+1529] = + s[1529];
gout[n*2187+1530] = + s[1530];
gout[n*2187+1531] = + s[1531];
gout[n*2187+1532] = + s[1532];
gout[n*2187+1533] = + s[1533];
gout[n*2187+1534] = + s[1534];
gout[n*2187+1535] = + s[1535];
gout[n*2187+1536] = + s[1536];
gout[n*2187+1537] = + s[1537];
gout[n*2187+1538] = + s[1538];
gout[n*2187+1539] = + s[297];
gout[n*2187+1540] = + s[298];
gout[n*2187+1541] = + s[299];
gout[n*2187+1542] = + s[300];
gout[n*2187+1543] = + s[301];
gout[n*2187+1544] = + s[302];
gout[n*2187+1545] = + s[303];
gout[n*2187+1546] = + s[304];
gout[n*2187+1547] = + s[305];
gout[n*2187+1548] = + s[306];
gout[n*2187+1549] = + s[307];
gout[n*2187+1550] = + s[308];
gout[n*2187+1551] = + s[309];
gout[n*2187+1552] = + s[310];
gout[n*2187+1553] = + s[311];
gout[n*2187+1554] = + s[312];
gout[n*2187+1555] = + s[313];
gout[n*2187+1556] = + s[314];
gout[n*2187+1557] = + s[315];
gout[n*2187+1558] = + s[316];
gout[n*2187+1559] = + s[317];
gout[n*2187+1560] = + s[318];
gout[n*2187+1561] = + s[319];
gout[n*2187+1562] = + s[320];
gout[n*2187+1563] = + s[321];
gout[n*2187+1564] = + s[322];
gout[n*2187+1565] = + s[323];
gout[n*2187+1566] = + s[1026];
gout[n*2187+1567] = + s[1027];
gout[n*2187+1568] = + s[1028];
gout[n*2187+1569] = + s[1029];
gout[n*2187+1570] = + s[1030];
gout[n*2187+1571] = + s[1031];
gout[n*2187+1572] = + s[1032];
gout[n*2187+1573] = + s[1033];
gout[n*2187+1574] = + s[1034];
gout[n*2187+1575] = + s[1035];
gout[n*2187+1576] = + s[1036];
gout[n*2187+1577] = + s[1037];
gout[n*2187+1578] = + s[1038];
gout[n*2187+1579] = + s[1039];
gout[n*2187+1580] = + s[1040];
gout[n*2187+1581] = + s[1041];
gout[n*2187+1582] = + s[1042];
gout[n*2187+1583] = + s[1043];
gout[n*2187+1584] = + s[1044];
gout[n*2187+1585] = + s[1045];
gout[n*2187+1586] = + s[1046];
gout[n*2187+1587] = + s[1047];
gout[n*2187+1588] = + s[1048];
gout[n*2187+1589] = + s[1049];
gout[n*2187+1590] = + s[1050];
gout[n*2187+1591] = + s[1051];
gout[n*2187+1592] = + s[1052];
gout[n*2187+1593] = + s[1755];
gout[n*2187+1594] = + s[1756];
gout[n*2187+1595] = + s[1757];
gout[n*2187+1596] = + s[1758];
gout[n*2187+1597] = + s[1759];
gout[n*2187+1598] = + s[1760];
gout[n*2187+1599] = + s[1761];
gout[n*2187+1600] = + s[1762];
gout[n*2187+1601] = + s[1763];
gout[n*2187+1602] = + s[1764];
gout[n*2187+1603] = + s[1765];
gout[n*2187+1604] = + s[1766];
gout[n*2187+1605] = + s[1767];
gout[n*2187+1606] = + s[1768];
gout[n*2187+1607] = + s[1769];
gout[n*2187+1608] = + s[1770];
gout[n*2187+1609] = + s[1771];
gout[n*2187+1610] = + s[1772];
gout[n*2187+1611] = + s[1773];
gout[n*2187+1612] = + s[1774];
gout[n*2187+1613] = + s[1775];
gout[n*2187+1614] = + s[1776];
gout[n*2187+1615] = + s[1777];
gout[n*2187+1616] = + s[1778];
gout[n*2187+1617] = + s[1779];
gout[n*2187+1618] = + s[1780];
gout[n*2187+1619] = + s[1781];
gout[n*2187+1620] = + s[540];
gout[n*2187+1621] = + s[541];
gout[n*2187+1622] = + s[542];
gout[n*2187+1623] = + s[543];
gout[n*2187+1624] = + s[544];
gout[n*2187+1625] = + s[545];
gout[n*2187+1626] = + s[546];
gout[n*2187+1627] = + s[547];
gout[n*2187+1628] = + s[548];
gout[n*2187+1629] = + s[549];
gout[n*2187+1630] = + s[550];
gout[n*2187+1631] = + s[551];
gout[n*2187+1632] = + s[552];
gout[n*2187+1633] = + s[553];
gout[n*2187+1634] = + s[554];
gout[n*2187+1635] = + s[555];
gout[n*2187+1636] = + s[556];
gout[n*2187+1637] = + s[557];
gout[n*2187+1638] = + s[558];
gout[n*2187+1639] = + s[559];
gout[n*2187+1640] = + s[560];
gout[n*2187+1641] = + s[561];
gout[n*2187+1642] = + s[562];
gout[n*2187+1643] = + s[563];
gout[n*2187+1644] = + s[564];
gout[n*2187+1645] = + s[565];
gout[n*2187+1646] = + s[566];
gout[n*2187+1647] = + s[1269];
gout[n*2187+1648] = + s[1270];
gout[n*2187+1649] = + s[1271];
gout[n*2187+1650] = + s[1272];
gout[n*2187+1651] = + s[1273];
gout[n*2187+1652] = + s[1274];
gout[n*2187+1653] = + s[1275];
gout[n*2187+1654] = + s[1276];
gout[n*2187+1655] = + s[1277];
gout[n*2187+1656] = + s[1278];
gout[n*2187+1657] = + s[1279];
gout[n*2187+1658] = + s[1280];
gout[n*2187+1659] = + s[1281];
gout[n*2187+1660] = + s[1282];
gout[n*2187+1661] = + s[1283];
gout[n*2187+1662] = + s[1284];
gout[n*2187+1663] = + s[1285];
gout[n*2187+1664] = + s[1286];
gout[n*2187+1665] = + s[1287];
gout[n*2187+1666] = + s[1288];
gout[n*2187+1667] = + s[1289];
gout[n*2187+1668] = + s[1290];
gout[n*2187+1669] = + s[1291];
gout[n*2187+1670] = + s[1292];
gout[n*2187+1671] = + s[1293];
gout[n*2187+1672] = + s[1294];
gout[n*2187+1673] = + s[1295];
gout[n*2187+1674] = + s[1998];
gout[n*2187+1675] = + s[1999];
gout[n*2187+1676] = + s[2000];
gout[n*2187+1677] = + s[2001];
gout[n*2187+1678] = + s[2002];
gout[n*2187+1679] = + s[2003];
gout[n*2187+1680] = + s[2004];
gout[n*2187+1681] = + s[2005];
gout[n*2187+1682] = + s[2006];
gout[n*2187+1683] = + s[2007];
gout[n*2187+1684] = + s[2008];
gout[n*2187+1685] = + s[2009];
gout[n*2187+1686] = + s[2010];
gout[n*2187+1687] = + s[2011];
gout[n*2187+1688] = + s[2012];
gout[n*2187+1689] = + s[2013];
gout[n*2187+1690] = + s[2014];
gout[n*2187+1691] = + s[2015];
gout[n*2187+1692] = + s[2016];
gout[n*2187+1693] = + s[2017];
gout[n*2187+1694] = + s[2018];
gout[n*2187+1695] = + s[2019];
gout[n*2187+1696] = + s[2020];
gout[n*2187+1697] = + s[2021];
gout[n*2187+1698] = + s[2022];
gout[n*2187+1699] = + s[2023];
gout[n*2187+1700] = + s[2024];
gout[n*2187+1701] = + s[135];
gout[n*2187+1702] = + s[136];
gout[n*2187+1703] = + s[137];
gout[n*2187+1704] = + s[138];
gout[n*2187+1705] = + s[139];
gout[n*2187+1706] = + s[140];
gout[n*2187+1707] = + s[141];
gout[n*2187+1708] = + s[142];
gout[n*2187+1709] = + s[143];
gout[n*2187+1710] = + s[144];
gout[n*2187+1711] = + s[145];
gout[n*2187+1712] = + s[146];
gout[n*2187+1713] = + s[147];
gout[n*2187+1714] = + s[148];
gout[n*2187+1715] = + s[149];
gout[n*2187+1716] = + s[150];
gout[n*2187+1717] = + s[151];
gout[n*2187+1718] = + s[152];
gout[n*2187+1719] = + s[153];
gout[n*2187+1720] = + s[154];
gout[n*2187+1721] = + s[155];
gout[n*2187+1722] = + s[156];
gout[n*2187+1723] = + s[157];
gout[n*2187+1724] = + s[158];
gout[n*2187+1725] = + s[159];
gout[n*2187+1726] = + s[160];
gout[n*2187+1727] = + s[161];
gout[n*2187+1728] = + s[864];
gout[n*2187+1729] = + s[865];
gout[n*2187+1730] = + s[866];
gout[n*2187+1731] = + s[867];
gout[n*2187+1732] = + s[868];
gout[n*2187+1733] = + s[869];
gout[n*2187+1734] = + s[870];
gout[n*2187+1735] = + s[871];
gout[n*2187+1736] = + s[872];
gout[n*2187+1737] = + s[873];
gout[n*2187+1738] = + s[874];
gout[n*2187+1739] = + s[875];
gout[n*2187+1740] = + s[876];
gout[n*2187+1741] = + s[877];
gout[n*2187+1742] = + s[878];
gout[n*2187+1743] = + s[879];
gout[n*2187+1744] = + s[880];
gout[n*2187+1745] = + s[881];
gout[n*2187+1746] = + s[882];
gout[n*2187+1747] = + s[883];
gout[n*2187+1748] = + s[884];
gout[n*2187+1749] = + s[885];
gout[n*2187+1750] = + s[886];
gout[n*2187+1751] = + s[887];
gout[n*2187+1752] = + s[888];
gout[n*2187+1753] = + s[889];
gout[n*2187+1754] = + s[890];
gout[n*2187+1755] = + s[1593];
gout[n*2187+1756] = + s[1594];
gout[n*2187+1757] = + s[1595];
gout[n*2187+1758] = + s[1596];
gout[n*2187+1759] = + s[1597];
gout[n*2187+1760] = + s[1598];
gout[n*2187+1761] = + s[1599];
gout[n*2187+1762] = + s[1600];
gout[n*2187+1763] = + s[1601];
gout[n*2187+1764] = + s[1602];
gout[n*2187+1765] = + s[1603];
gout[n*2187+1766] = + s[1604];
gout[n*2187+1767] = + s[1605];
gout[n*2187+1768] = + s[1606];
gout[n*2187+1769] = + s[1607];
gout[n*2187+1770] = + s[1608];
gout[n*2187+1771] = + s[1609];
gout[n*2187+1772] = + s[1610];
gout[n*2187+1773] = + s[1611];
gout[n*2187+1774] = + s[1612];
gout[n*2187+1775] = + s[1613];
gout[n*2187+1776] = + s[1614];
gout[n*2187+1777] = + s[1615];
gout[n*2187+1778] = + s[1616];
gout[n*2187+1779] = + s[1617];
gout[n*2187+1780] = + s[1618];
gout[n*2187+1781] = + s[1619];
gout[n*2187+1782] = + s[378];
gout[n*2187+1783] = + s[379];
gout[n*2187+1784] = + s[380];
gout[n*2187+1785] = + s[381];
gout[n*2187+1786] = + s[382];
gout[n*2187+1787] = + s[383];
gout[n*2187+1788] = + s[384];
gout[n*2187+1789] = + s[385];
gout[n*2187+1790] = + s[386];
gout[n*2187+1791] = + s[387];
gout[n*2187+1792] = + s[388];
gout[n*2187+1793] = + s[389];
gout[n*2187+1794] = + s[390];
gout[n*2187+1795] = + s[391];
gout[n*2187+1796] = + s[392];
gout[n*2187+1797] = + s[393];
gout[n*2187+1798] = + s[394];
gout[n*2187+1799] = + s[395];
gout[n*2187+1800] = + s[396];
gout[n*2187+1801] = + s[397];
gout[n*2187+1802] = + s[398];
gout[n*2187+1803] = + s[399];
gout[n*2187+1804] = + s[400];
gout[n*2187+1805] = + s[401];
gout[n*2187+1806] = + s[402];
gout[n*2187+1807] = + s[403];
gout[n*2187+1808] = + s[404];
gout[n*2187+1809] = + s[1107];
gout[n*2187+1810] = + s[1108];
gout[n*2187+1811] = + s[1109];
gout[n*2187+1812] = + s[1110];
gout[n*2187+1813] = + s[1111];
gout[n*2187+1814] = + s[1112];
gout[n*2187+1815] = + s[1113];
gout[n*2187+1816] = + s[1114];
gout[n*2187+1817] = + s[1115];
gout[n*2187+1818] = + s[1116];
gout[n*2187+1819] = + s[1117];
gout[n*2187+1820] = + s[1118];
gout[n*2187+1821] = + s[1119];
gout[n*2187+1822] = + s[1120];
gout[n*2187+1823] = + s[1121];
gout[n*2187+1824] = + s[1122];
gout[n*2187+1825] = + s[1123];
gout[n*2187+1826] = + s[1124];
gout[n*2187+1827] = + s[1125];
gout[n*2187+1828] = + s[1126];
gout[n*2187+1829] = + s[1127];
gout[n*2187+1830] = + s[1128];
gout[n*2187+1831] = + s[1129];
gout[n*2187+1832] = + s[1130];
gout[n*2187+1833] = + s[1131];
gout[n*2187+1834] = + s[1132];
gout[n*2187+1835] = + s[1133];
gout[n*2187+1836] = + s[1836];
gout[n*2187+1837] = + s[1837];
gout[n*2187+1838] = + s[1838];
gout[n*2187+1839] = + s[1839];
gout[n*2187+1840] = + s[1840];
gout[n*2187+1841] = + s[1841];
gout[n*2187+1842] = + s[1842];
gout[n*2187+1843] = + s[1843];
gout[n*2187+1844] = + s[1844];
gout[n*2187+1845] = + s[1845];
gout[n*2187+1846] = + s[1846];
gout[n*2187+1847] = + s[1847];
gout[n*2187+1848] = + s[1848];
gout[n*2187+1849] = + s[1849];
gout[n*2187+1850] = + s[1850];
gout[n*2187+1851] = + s[1851];
gout[n*2187+1852] = + s[1852];
gout[n*2187+1853] = + s[1853];
gout[n*2187+1854] = + s[1854];
gout[n*2187+1855] = + s[1855];
gout[n*2187+1856] = + s[1856];
gout[n*2187+1857] = + s[1857];
gout[n*2187+1858] = + s[1858];
gout[n*2187+1859] = + s[1859];
gout[n*2187+1860] = + s[1860];
gout[n*2187+1861] = + s[1861];
gout[n*2187+1862] = + s[1862];
gout[n*2187+1863] = + s[621];
gout[n*2187+1864] = + s[622];
gout[n*2187+1865] = + s[623];
gout[n*2187+1866] = + s[624];
gout[n*2187+1867] = + s[625];
gout[n*2187+1868] = + s[626];
gout[n*2187+1869] = + s[627];
gout[n*2187+1870] = + s[628];
gout[n*2187+1871] = + s[629];
gout[n*2187+1872] = + s[630];
gout[n*2187+1873] = + s[631];
gout[n*2187+1874] = + s[632];
gout[n*2187+1875] = + s[633];
gout[n*2187+1876] = + s[634];
gout[n*2187+1877] = + s[635];
gout[n*2187+1878] = + s[636];
gout[n*2187+1879] = + s[637];
gout[n*2187+1880] = + s[638];
gout[n*2187+1881] = + s[639];
gout[n*2187+1882] = + s[640];
gout[n*2187+1883] = + s[641];
gout[n*2187+1884] = + s[642];
gout[n*2187+1885] = + s[643];
gout[n*2187+1886] = + s[644];
gout[n*2187+1887] = + s[645];
gout[n*2187+1888] = + s[646];
gout[n*2187+1889] = + s[647];
gout[n*2187+1890] = + s[1350];
gout[n*2187+1891] = + s[1351];
gout[n*2187+1892] = + s[1352];
gout[n*2187+1893] = + s[1353];
gout[n*2187+1894] = + s[1354];
gout[n*2187+1895] = + s[1355];
gout[n*2187+1896] = + s[1356];
gout[n*2187+1897] = + s[1357];
gout[n*2187+1898] = + s[1358];
gout[n*2187+1899] = + s[1359];
gout[n*2187+1900] = + s[1360];
gout[n*2187+1901] = + s[1361];
gout[n*2187+1902] = + s[1362];
gout[n*2187+1903] = + s[1363];
gout[n*2187+1904] = + s[1364];
gout[n*2187+1905] = + s[1365];
gout[n*2187+1906] = + s[1366];
gout[n*2187+1907] = + s[1367];
gout[n*2187+1908] = + s[1368];
gout[n*2187+1909] = + s[1369];
gout[n*2187+1910] = + s[1370];
gout[n*2187+1911] = + s[1371];
gout[n*2187+1912] = + s[1372];
gout[n*2187+1913] = + s[1373];
gout[n*2187+1914] = + s[1374];
gout[n*2187+1915] = + s[1375];
gout[n*2187+1916] = + s[1376];
gout[n*2187+1917] = + s[2079];
gout[n*2187+1918] = + s[2080];
gout[n*2187+1919] = + s[2081];
gout[n*2187+1920] = + s[2082];
gout[n*2187+1921] = + s[2083];
gout[n*2187+1922] = + s[2084];
gout[n*2187+1923] = + s[2085];
gout[n*2187+1924] = + s[2086];
gout[n*2187+1925] = + s[2087];
gout[n*2187+1926] = + s[2088];
gout[n*2187+1927] = + s[2089];
gout[n*2187+1928] = + s[2090];
gout[n*2187+1929] = + s[2091];
gout[n*2187+1930] = + s[2092];
gout[n*2187+1931] = + s[2093];
gout[n*2187+1932] = + s[2094];
gout[n*2187+1933] = + s[2095];
gout[n*2187+1934] = + s[2096];
gout[n*2187+1935] = + s[2097];
gout[n*2187+1936] = + s[2098];
gout[n*2187+1937] = + s[2099];
gout[n*2187+1938] = + s[2100];
gout[n*2187+1939] = + s[2101];
gout[n*2187+1940] = + s[2102];
gout[n*2187+1941] = + s[2103];
gout[n*2187+1942] = + s[2104];
gout[n*2187+1943] = + s[2105];
gout[n*2187+1944] = + s[216];
gout[n*2187+1945] = + s[217];
gout[n*2187+1946] = + s[218];
gout[n*2187+1947] = + s[219];
gout[n*2187+1948] = + s[220];
gout[n*2187+1949] = + s[221];
gout[n*2187+1950] = + s[222];
gout[n*2187+1951] = + s[223];
gout[n*2187+1952] = + s[224];
gout[n*2187+1953] = + s[225];
gout[n*2187+1954] = + s[226];
gout[n*2187+1955] = + s[227];
gout[n*2187+1956] = + s[228];
gout[n*2187+1957] = + s[229];
gout[n*2187+1958] = + s[230];
gout[n*2187+1959] = + s[231];
gout[n*2187+1960] = + s[232];
gout[n*2187+1961] = + s[233];
gout[n*2187+1962] = + s[234];
gout[n*2187+1963] = + s[235];
gout[n*2187+1964] = + s[236];
gout[n*2187+1965] = + s[237];
gout[n*2187+1966] = + s[238];
gout[n*2187+1967] = + s[239];
gout[n*2187+1968] = + s[240];
gout[n*2187+1969] = + s[241];
gout[n*2187+1970] = + s[242];
gout[n*2187+1971] = + s[945];
gout[n*2187+1972] = + s[946];
gout[n*2187+1973] = + s[947];
gout[n*2187+1974] = + s[948];
gout[n*2187+1975] = + s[949];
gout[n*2187+1976] = + s[950];
gout[n*2187+1977] = + s[951];
gout[n*2187+1978] = + s[952];
gout[n*2187+1979] = + s[953];
gout[n*2187+1980] = + s[954];
gout[n*2187+1981] = + s[955];
gout[n*2187+1982] = + s[956];
gout[n*2187+1983] = + s[957];
gout[n*2187+1984] = + s[958];
gout[n*2187+1985] = + s[959];
gout[n*2187+1986] = + s[960];
gout[n*2187+1987] = + s[961];
gout[n*2187+1988] = + s[962];
gout[n*2187+1989] = + s[963];
gout[n*2187+1990] = + s[964];
gout[n*2187+1991] = + s[965];
gout[n*2187+1992] = + s[966];
gout[n*2187+1993] = + s[967];
gout[n*2187+1994] = + s[968];
gout[n*2187+1995] = + s[969];
gout[n*2187+1996] = + s[970];
gout[n*2187+1997] = + s[971];
gout[n*2187+1998] = + s[1674];
gout[n*2187+1999] = + s[1675];
gout[n*2187+2000] = + s[1676];
gout[n*2187+2001] = + s[1677];
gout[n*2187+2002] = + s[1678];
gout[n*2187+2003] = + s[1679];
gout[n*2187+2004] = + s[1680];
gout[n*2187+2005] = + s[1681];
gout[n*2187+2006] = + s[1682];
gout[n*2187+2007] = + s[1683];
gout[n*2187+2008] = + s[1684];
gout[n*2187+2009] = + s[1685];
gout[n*2187+2010] = + s[1686];
gout[n*2187+2011] = + s[1687];
gout[n*2187+2012] = + s[1688];
gout[n*2187+2013] = + s[1689];
gout[n*2187+2014] = + s[1690];
gout[n*2187+2015] = + s[1691];
gout[n*2187+2016] = + s[1692];
gout[n*2187+2017] = + s[1693];
gout[n*2187+2018] = + s[1694];
gout[n*2187+2019] = + s[1695];
gout[n*2187+2020] = + s[1696];
gout[n*2187+2021] = + s[1697];
gout[n*2187+2022] = + s[1698];
gout[n*2187+2023] = + s[1699];
gout[n*2187+2024] = + s[1700];
gout[n*2187+2025] = + s[459];
gout[n*2187+2026] = + s[460];
gout[n*2187+2027] = + s[461];
gout[n*2187+2028] = + s[462];
gout[n*2187+2029] = + s[463];
gout[n*2187+2030] = + s[464];
gout[n*2187+2031] = + s[465];
gout[n*2187+2032] = + s[466];
gout[n*2187+2033] = + s[467];
gout[n*2187+2034] = + s[468];
gout[n*2187+2035] = + s[469];
gout[n*2187+2036] = + s[470];
gout[n*2187+2037] = + s[471];
gout[n*2187+2038] = + s[472];
gout[n*2187+2039] = + s[473];
gout[n*2187+2040] = + s[474];
gout[n*2187+2041] = + s[475];
gout[n*2187+2042] = + s[476];
gout[n*2187+2043] = + s[477];
gout[n*2187+2044] = + s[478];
gout[n*2187+2045] = + s[479];
gout[n*2187+2046] = + s[480];
gout[n*2187+2047] = + s[481];
gout[n*2187+2048] = + s[482];
gout[n*2187+2049] = + s[483];
gout[n*2187+2050] = + s[484];
gout[n*2187+2051] = + s[485];
gout[n*2187+2052] = + s[1188];
gout[n*2187+2053] = + s[1189];
gout[n*2187+2054] = + s[1190];
gout[n*2187+2055] = + s[1191];
gout[n*2187+2056] = + s[1192];
gout[n*2187+2057] = + s[1193];
gout[n*2187+2058] = + s[1194];
gout[n*2187+2059] = + s[1195];
gout[n*2187+2060] = + s[1196];
gout[n*2187+2061] = + s[1197];
gout[n*2187+2062] = + s[1198];
gout[n*2187+2063] = + s[1199];
gout[n*2187+2064] = + s[1200];
gout[n*2187+2065] = + s[1201];
gout[n*2187+2066] = + s[1202];
gout[n*2187+2067] = + s[1203];
gout[n*2187+2068] = + s[1204];
gout[n*2187+2069] = + s[1205];
gout[n*2187+2070] = + s[1206];
gout[n*2187+2071] = + s[1207];
gout[n*2187+2072] = + s[1208];
gout[n*2187+2073] = + s[1209];
gout[n*2187+2074] = + s[1210];
gout[n*2187+2075] = + s[1211];
gout[n*2187+2076] = + s[1212];
gout[n*2187+2077] = + s[1213];
gout[n*2187+2078] = + s[1214];
gout[n*2187+2079] = + s[1917];
gout[n*2187+2080] = + s[1918];
gout[n*2187+2081] = + s[1919];
gout[n*2187+2082] = + s[1920];
gout[n*2187+2083] = + s[1921];
gout[n*2187+2084] = + s[1922];
gout[n*2187+2085] = + s[1923];
gout[n*2187+2086] = + s[1924];
gout[n*2187+2087] = + s[1925];
gout[n*2187+2088] = + s[1926];
gout[n*2187+2089] = + s[1927];
gout[n*2187+2090] = + s[1928];
gout[n*2187+2091] = + s[1929];
gout[n*2187+2092] = + s[1930];
gout[n*2187+2093] = + s[1931];
gout[n*2187+2094] = + s[1932];
gout[n*2187+2095] = + s[1933];
gout[n*2187+2096] = + s[1934];
gout[n*2187+2097] = + s[1935];
gout[n*2187+2098] = + s[1936];
gout[n*2187+2099] = + s[1937];
gout[n*2187+2100] = + s[1938];
gout[n*2187+2101] = + s[1939];
gout[n*2187+2102] = + s[1940];
gout[n*2187+2103] = + s[1941];
gout[n*2187+2104] = + s[1942];
gout[n*2187+2105] = + s[1943];
gout[n*2187+2106] = + s[702];
gout[n*2187+2107] = + s[703];
gout[n*2187+2108] = + s[704];
gout[n*2187+2109] = + s[705];
gout[n*2187+2110] = + s[706];
gout[n*2187+2111] = + s[707];
gout[n*2187+2112] = + s[708];
gout[n*2187+2113] = + s[709];
gout[n*2187+2114] = + s[710];
gout[n*2187+2115] = + s[711];
gout[n*2187+2116] = + s[712];
gout[n*2187+2117] = + s[713];
gout[n*2187+2118] = + s[714];
gout[n*2187+2119] = + s[715];
gout[n*2187+2120] = + s[716];
gout[n*2187+2121] = + s[717];
gout[n*2187+2122] = + s[718];
gout[n*2187+2123] = + s[719];
gout[n*2187+2124] = + s[720];
gout[n*2187+2125] = + s[721];
gout[n*2187+2126] = + s[722];
gout[n*2187+2127] = + s[723];
gout[n*2187+2128] = + s[724];
gout[n*2187+2129] = + s[725];
gout[n*2187+2130] = + s[726];
gout[n*2187+2131] = + s[727];
gout[n*2187+2132] = + s[728];
gout[n*2187+2133] = + s[1431];
gout[n*2187+2134] = + s[1432];
gout[n*2187+2135] = + s[1433];
gout[n*2187+2136] = + s[1434];
gout[n*2187+2137] = + s[1435];
gout[n*2187+2138] = + s[1436];
gout[n*2187+2139] = + s[1437];
gout[n*2187+2140] = + s[1438];
gout[n*2187+2141] = + s[1439];
gout[n*2187+2142] = + s[1440];
gout[n*2187+2143] = + s[1441];
gout[n*2187+2144] = + s[1442];
gout[n*2187+2145] = + s[1443];
gout[n*2187+2146] = + s[1444];
gout[n*2187+2147] = + s[1445];
gout[n*2187+2148] = + s[1446];
gout[n*2187+2149] = + s[1447];
gout[n*2187+2150] = + s[1448];
gout[n*2187+2151] = + s[1449];
gout[n*2187+2152] = + s[1450];
gout[n*2187+2153] = + s[1451];
gout[n*2187+2154] = + s[1452];
gout[n*2187+2155] = + s[1453];
gout[n*2187+2156] = + s[1454];
gout[n*2187+2157] = + s[1455];
gout[n*2187+2158] = + s[1456];
gout[n*2187+2159] = + s[1457];
gout[n*2187+2160] = + s[2160];
gout[n*2187+2161] = + s[2161];
gout[n*2187+2162] = + s[2162];
gout[n*2187+2163] = + s[2163];
gout[n*2187+2164] = + s[2164];
gout[n*2187+2165] = + s[2165];
gout[n*2187+2166] = + s[2166];
gout[n*2187+2167] = + s[2167];
gout[n*2187+2168] = + s[2168];
gout[n*2187+2169] = + s[2169];
gout[n*2187+2170] = + s[2170];
gout[n*2187+2171] = + s[2171];
gout[n*2187+2172] = + s[2172];
gout[n*2187+2173] = + s[2173];
gout[n*2187+2174] = + s[2174];
gout[n*2187+2175] = + s[2175];
gout[n*2187+2176] = + s[2176];
gout[n*2187+2177] = + s[2177];
gout[n*2187+2178] = + s[2178];
gout[n*2187+2179] = + s[2179];
gout[n*2187+2180] = + s[2180];
gout[n*2187+2181] = + s[2181];
gout[n*2187+2182] = + s[2182];
gout[n*2187+2183] = + s[2183];
gout[n*2187+2184] = + s[2184];
gout[n*2187+2185] = + s[2185];
gout[n*2187+2186] = + s[2186];
} else {
gout[n*2187+0] += + s[0];
gout[n*2187+1] += + s[1];
gout[n*2187+2] += + s[2];
gout[n*2187+3] += + s[3];
gout[n*2187+4] += + s[4];
gout[n*2187+5] += + s[5];
gout[n*2187+6] += + s[6];
gout[n*2187+7] += + s[7];
gout[n*2187+8] += + s[8];
gout[n*2187+9] += + s[9];
gout[n*2187+10] += + s[10];
gout[n*2187+11] += + s[11];
gout[n*2187+12] += + s[12];
gout[n*2187+13] += + s[13];
gout[n*2187+14] += + s[14];
gout[n*2187+15] += + s[15];
gout[n*2187+16] += + s[16];
gout[n*2187+17] += + s[17];
gout[n*2187+18] += + s[18];
gout[n*2187+19] += + s[19];
gout[n*2187+20] += + s[20];
gout[n*2187+21] += + s[21];
gout[n*2187+22] += + s[22];
gout[n*2187+23] += + s[23];
gout[n*2187+24] += + s[24];
gout[n*2187+25] += + s[25];
gout[n*2187+26] += + s[26];
gout[n*2187+27] += + s[729];
gout[n*2187+28] += + s[730];
gout[n*2187+29] += + s[731];
gout[n*2187+30] += + s[732];
gout[n*2187+31] += + s[733];
gout[n*2187+32] += + s[734];
gout[n*2187+33] += + s[735];
gout[n*2187+34] += + s[736];
gout[n*2187+35] += + s[737];
gout[n*2187+36] += + s[738];
gout[n*2187+37] += + s[739];
gout[n*2187+38] += + s[740];
gout[n*2187+39] += + s[741];
gout[n*2187+40] += + s[742];
gout[n*2187+41] += + s[743];
gout[n*2187+42] += + s[744];
gout[n*2187+43] += + s[745];
gout[n*2187+44] += + s[746];
gout[n*2187+45] += + s[747];
gout[n*2187+46] += + s[748];
gout[n*2187+47] += + s[749];
gout[n*2187+48] += + s[750];
gout[n*2187+49] += + s[751];
gout[n*2187+50] += + s[752];
gout[n*2187+51] += + s[753];
gout[n*2187+52] += + s[754];
gout[n*2187+53] += + s[755];
gout[n*2187+54] += + s[1458];
gout[n*2187+55] += + s[1459];
gout[n*2187+56] += + s[1460];
gout[n*2187+57] += + s[1461];
gout[n*2187+58] += + s[1462];
gout[n*2187+59] += + s[1463];
gout[n*2187+60] += + s[1464];
gout[n*2187+61] += + s[1465];
gout[n*2187+62] += + s[1466];
gout[n*2187+63] += + s[1467];
gout[n*2187+64] += + s[1468];
gout[n*2187+65] += + s[1469];
gout[n*2187+66] += + s[1470];
gout[n*2187+67] += + s[1471];
gout[n*2187+68] += + s[1472];
gout[n*2187+69] += + s[1473];
gout[n*2187+70] += + s[1474];
gout[n*2187+71] += + s[1475];
gout[n*2187+72] += + s[1476];
gout[n*2187+73] += + s[1477];
gout[n*2187+74] += + s[1478];
gout[n*2187+75] += + s[1479];
gout[n*2187+76] += + s[1480];
gout[n*2187+77] += + s[1481];
gout[n*2187+78] += + s[1482];
gout[n*2187+79] += + s[1483];
gout[n*2187+80] += + s[1484];
gout[n*2187+81] += + s[243];
gout[n*2187+82] += + s[244];
gout[n*2187+83] += + s[245];
gout[n*2187+84] += + s[246];
gout[n*2187+85] += + s[247];
gout[n*2187+86] += + s[248];
gout[n*2187+87] += + s[249];
gout[n*2187+88] += + s[250];
gout[n*2187+89] += + s[251];
gout[n*2187+90] += + s[252];
gout[n*2187+91] += + s[253];
gout[n*2187+92] += + s[254];
gout[n*2187+93] += + s[255];
gout[n*2187+94] += + s[256];
gout[n*2187+95] += + s[257];
gout[n*2187+96] += + s[258];
gout[n*2187+97] += + s[259];
gout[n*2187+98] += + s[260];
gout[n*2187+99] += + s[261];
gout[n*2187+100] += + s[262];
gout[n*2187+101] += + s[263];
gout[n*2187+102] += + s[264];
gout[n*2187+103] += + s[265];
gout[n*2187+104] += + s[266];
gout[n*2187+105] += + s[267];
gout[n*2187+106] += + s[268];
gout[n*2187+107] += + s[269];
gout[n*2187+108] += + s[972];
gout[n*2187+109] += + s[973];
gout[n*2187+110] += + s[974];
gout[n*2187+111] += + s[975];
gout[n*2187+112] += + s[976];
gout[n*2187+113] += + s[977];
gout[n*2187+114] += + s[978];
gout[n*2187+115] += + s[979];
gout[n*2187+116] += + s[980];
gout[n*2187+117] += + s[981];
gout[n*2187+118] += + s[982];
gout[n*2187+119] += + s[983];
gout[n*2187+120] += + s[984];
gout[n*2187+121] += + s[985];
gout[n*2187+122] += + s[986];
gout[n*2187+123] += + s[987];
gout[n*2187+124] += + s[988];
gout[n*2187+125] += + s[989];
gout[n*2187+126] += + s[990];
gout[n*2187+127] += + s[991];
gout[n*2187+128] += + s[992];
gout[n*2187+129] += + s[993];
gout[n*2187+130] += + s[994];
gout[n*2187+131] += + s[995];
gout[n*2187+132] += + s[996];
gout[n*2187+133] += + s[997];
gout[n*2187+134] += + s[998];
gout[n*2187+135] += + s[1701];
gout[n*2187+136] += + s[1702];
gout[n*2187+137] += + s[1703];
gout[n*2187+138] += + s[1704];
gout[n*2187+139] += + s[1705];
gout[n*2187+140] += + s[1706];
gout[n*2187+141] += + s[1707];
gout[n*2187+142] += + s[1708];
gout[n*2187+143] += + s[1709];
gout[n*2187+144] += + s[1710];
gout[n*2187+145] += + s[1711];
gout[n*2187+146] += + s[1712];
gout[n*2187+147] += + s[1713];
gout[n*2187+148] += + s[1714];
gout[n*2187+149] += + s[1715];
gout[n*2187+150] += + s[1716];
gout[n*2187+151] += + s[1717];
gout[n*2187+152] += + s[1718];
gout[n*2187+153] += + s[1719];
gout[n*2187+154] += + s[1720];
gout[n*2187+155] += + s[1721];
gout[n*2187+156] += + s[1722];
gout[n*2187+157] += + s[1723];
gout[n*2187+158] += + s[1724];
gout[n*2187+159] += + s[1725];
gout[n*2187+160] += + s[1726];
gout[n*2187+161] += + s[1727];
gout[n*2187+162] += + s[486];
gout[n*2187+163] += + s[487];
gout[n*2187+164] += + s[488];
gout[n*2187+165] += + s[489];
gout[n*2187+166] += + s[490];
gout[n*2187+167] += + s[491];
gout[n*2187+168] += + s[492];
gout[n*2187+169] += + s[493];
gout[n*2187+170] += + s[494];
gout[n*2187+171] += + s[495];
gout[n*2187+172] += + s[496];
gout[n*2187+173] += + s[497];
gout[n*2187+174] += + s[498];
gout[n*2187+175] += + s[499];
gout[n*2187+176] += + s[500];
gout[n*2187+177] += + s[501];
gout[n*2187+178] += + s[502];
gout[n*2187+179] += + s[503];
gout[n*2187+180] += + s[504];
gout[n*2187+181] += + s[505];
gout[n*2187+182] += + s[506];
gout[n*2187+183] += + s[507];
gout[n*2187+184] += + s[508];
gout[n*2187+185] += + s[509];
gout[n*2187+186] += + s[510];
gout[n*2187+187] += + s[511];
gout[n*2187+188] += + s[512];
gout[n*2187+189] += + s[1215];
gout[n*2187+190] += + s[1216];
gout[n*2187+191] += + s[1217];
gout[n*2187+192] += + s[1218];
gout[n*2187+193] += + s[1219];
gout[n*2187+194] += + s[1220];
gout[n*2187+195] += + s[1221];
gout[n*2187+196] += + s[1222];
gout[n*2187+197] += + s[1223];
gout[n*2187+198] += + s[1224];
gout[n*2187+199] += + s[1225];
gout[n*2187+200] += + s[1226];
gout[n*2187+201] += + s[1227];
gout[n*2187+202] += + s[1228];
gout[n*2187+203] += + s[1229];
gout[n*2187+204] += + s[1230];
gout[n*2187+205] += + s[1231];
gout[n*2187+206] += + s[1232];
gout[n*2187+207] += + s[1233];
gout[n*2187+208] += + s[1234];
gout[n*2187+209] += + s[1235];
gout[n*2187+210] += + s[1236];
gout[n*2187+211] += + s[1237];
gout[n*2187+212] += + s[1238];
gout[n*2187+213] += + s[1239];
gout[n*2187+214] += + s[1240];
gout[n*2187+215] += + s[1241];
gout[n*2187+216] += + s[1944];
gout[n*2187+217] += + s[1945];
gout[n*2187+218] += + s[1946];
gout[n*2187+219] += + s[1947];
gout[n*2187+220] += + s[1948];
gout[n*2187+221] += + s[1949];
gout[n*2187+222] += + s[1950];
gout[n*2187+223] += + s[1951];
gout[n*2187+224] += + s[1952];
gout[n*2187+225] += + s[1953];
gout[n*2187+226] += + s[1954];
gout[n*2187+227] += + s[1955];
gout[n*2187+228] += + s[1956];
gout[n*2187+229] += + s[1957];
gout[n*2187+230] += + s[1958];
gout[n*2187+231] += + s[1959];
gout[n*2187+232] += + s[1960];
gout[n*2187+233] += + s[1961];
gout[n*2187+234] += + s[1962];
gout[n*2187+235] += + s[1963];
gout[n*2187+236] += + s[1964];
gout[n*2187+237] += + s[1965];
gout[n*2187+238] += + s[1966];
gout[n*2187+239] += + s[1967];
gout[n*2187+240] += + s[1968];
gout[n*2187+241] += + s[1969];
gout[n*2187+242] += + s[1970];
gout[n*2187+243] += + s[81];
gout[n*2187+244] += + s[82];
gout[n*2187+245] += + s[83];
gout[n*2187+246] += + s[84];
gout[n*2187+247] += + s[85];
gout[n*2187+248] += + s[86];
gout[n*2187+249] += + s[87];
gout[n*2187+250] += + s[88];
gout[n*2187+251] += + s[89];
gout[n*2187+252] += + s[90];
gout[n*2187+253] += + s[91];
gout[n*2187+254] += + s[92];
gout[n*2187+255] += + s[93];
gout[n*2187+256] += + s[94];
gout[n*2187+257] += + s[95];
gout[n*2187+258] += + s[96];
gout[n*2187+259] += + s[97];
gout[n*2187+260] += + s[98];
gout[n*2187+261] += + s[99];
gout[n*2187+262] += + s[100];
gout[n*2187+263] += + s[101];
gout[n*2187+264] += + s[102];
gout[n*2187+265] += + s[103];
gout[n*2187+266] += + s[104];
gout[n*2187+267] += + s[105];
gout[n*2187+268] += + s[106];
gout[n*2187+269] += + s[107];
gout[n*2187+270] += + s[810];
gout[n*2187+271] += + s[811];
gout[n*2187+272] += + s[812];
gout[n*2187+273] += + s[813];
gout[n*2187+274] += + s[814];
gout[n*2187+275] += + s[815];
gout[n*2187+276] += + s[816];
gout[n*2187+277] += + s[817];
gout[n*2187+278] += + s[818];
gout[n*2187+279] += + s[819];
gout[n*2187+280] += + s[820];
gout[n*2187+281] += + s[821];
gout[n*2187+282] += + s[822];
gout[n*2187+283] += + s[823];
gout[n*2187+284] += + s[824];
gout[n*2187+285] += + s[825];
gout[n*2187+286] += + s[826];
gout[n*2187+287] += + s[827];
gout[n*2187+288] += + s[828];
gout[n*2187+289] += + s[829];
gout[n*2187+290] += + s[830];
gout[n*2187+291] += + s[831];
gout[n*2187+292] += + s[832];
gout[n*2187+293] += + s[833];
gout[n*2187+294] += + s[834];
gout[n*2187+295] += + s[835];
gout[n*2187+296] += + s[836];
gout[n*2187+297] += + s[1539];
gout[n*2187+298] += + s[1540];
gout[n*2187+299] += + s[1541];
gout[n*2187+300] += + s[1542];
gout[n*2187+301] += + s[1543];
gout[n*2187+302] += + s[1544];
gout[n*2187+303] += + s[1545];
gout[n*2187+304] += + s[1546];
gout[n*2187+305] += + s[1547];
gout[n*2187+306] += + s[1548];
gout[n*2187+307] += + s[1549];
gout[n*2187+308] += + s[1550];
gout[n*2187+309] += + s[1551];
gout[n*2187+310] += + s[1552];
gout[n*2187+311] += + s[1553];
gout[n*2187+312] += + s[1554];
gout[n*2187+313] += + s[1555];
gout[n*2187+314] += + s[1556];
gout[n*2187+315] += + s[1557];
gout[n*2187+316] += + s[1558];
gout[n*2187+317] += + s[1559];
gout[n*2187+318] += + s[1560];
gout[n*2187+319] += + s[1561];
gout[n*2187+320] += + s[1562];
gout[n*2187+321] += + s[1563];
gout[n*2187+322] += + s[1564];
gout[n*2187+323] += + s[1565];
gout[n*2187+324] += + s[324];
gout[n*2187+325] += + s[325];
gout[n*2187+326] += + s[326];
gout[n*2187+327] += + s[327];
gout[n*2187+328] += + s[328];
gout[n*2187+329] += + s[329];
gout[n*2187+330] += + s[330];
gout[n*2187+331] += + s[331];
gout[n*2187+332] += + s[332];
gout[n*2187+333] += + s[333];
gout[n*2187+334] += + s[334];
gout[n*2187+335] += + s[335];
gout[n*2187+336] += + s[336];
gout[n*2187+337] += + s[337];
gout[n*2187+338] += + s[338];
gout[n*2187+339] += + s[339];
gout[n*2187+340] += + s[340];
gout[n*2187+341] += + s[341];
gout[n*2187+342] += + s[342];
gout[n*2187+343] += + s[343];
gout[n*2187+344] += + s[344];
gout[n*2187+345] += + s[345];
gout[n*2187+346] += + s[346];
gout[n*2187+347] += + s[347];
gout[n*2187+348] += + s[348];
gout[n*2187+349] += + s[349];
gout[n*2187+350] += + s[350];
gout[n*2187+351] += + s[1053];
gout[n*2187+352] += + s[1054];
gout[n*2187+353] += + s[1055];
gout[n*2187+354] += + s[1056];
gout[n*2187+355] += + s[1057];
gout[n*2187+356] += + s[1058];
gout[n*2187+357] += + s[1059];
gout[n*2187+358] += + s[1060];
gout[n*2187+359] += + s[1061];
gout[n*2187+360] += + s[1062];
gout[n*2187+361] += + s[1063];
gout[n*2187+362] += + s[1064];
gout[n*2187+363] += + s[1065];
gout[n*2187+364] += + s[1066];
gout[n*2187+365] += + s[1067];
gout[n*2187+366] += + s[1068];
gout[n*2187+367] += + s[1069];
gout[n*2187+368] += + s[1070];
gout[n*2187+369] += + s[1071];
gout[n*2187+370] += + s[1072];
gout[n*2187+371] += + s[1073];
gout[n*2187+372] += + s[1074];
gout[n*2187+373] += + s[1075];
gout[n*2187+374] += + s[1076];
gout[n*2187+375] += + s[1077];
gout[n*2187+376] += + s[1078];
gout[n*2187+377] += + s[1079];
gout[n*2187+378] += + s[1782];
gout[n*2187+379] += + s[1783];
gout[n*2187+380] += + s[1784];
gout[n*2187+381] += + s[1785];
gout[n*2187+382] += + s[1786];
gout[n*2187+383] += + s[1787];
gout[n*2187+384] += + s[1788];
gout[n*2187+385] += + s[1789];
gout[n*2187+386] += + s[1790];
gout[n*2187+387] += + s[1791];
gout[n*2187+388] += + s[1792];
gout[n*2187+389] += + s[1793];
gout[n*2187+390] += + s[1794];
gout[n*2187+391] += + s[1795];
gout[n*2187+392] += + s[1796];
gout[n*2187+393] += + s[1797];
gout[n*2187+394] += + s[1798];
gout[n*2187+395] += + s[1799];
gout[n*2187+396] += + s[1800];
gout[n*2187+397] += + s[1801];
gout[n*2187+398] += + s[1802];
gout[n*2187+399] += + s[1803];
gout[n*2187+400] += + s[1804];
gout[n*2187+401] += + s[1805];
gout[n*2187+402] += + s[1806];
gout[n*2187+403] += + s[1807];
gout[n*2187+404] += + s[1808];
gout[n*2187+405] += + s[567];
gout[n*2187+406] += + s[568];
gout[n*2187+407] += + s[569];
gout[n*2187+408] += + s[570];
gout[n*2187+409] += + s[571];
gout[n*2187+410] += + s[572];
gout[n*2187+411] += + s[573];
gout[n*2187+412] += + s[574];
gout[n*2187+413] += + s[575];
gout[n*2187+414] += + s[576];
gout[n*2187+415] += + s[577];
gout[n*2187+416] += + s[578];
gout[n*2187+417] += + s[579];
gout[n*2187+418] += + s[580];
gout[n*2187+419] += + s[581];
gout[n*2187+420] += + s[582];
gout[n*2187+421] += + s[583];
gout[n*2187+422] += + s[584];
gout[n*2187+423] += + s[585];
gout[n*2187+424] += + s[586];
gout[n*2187+425] += + s[587];
gout[n*2187+426] += + s[588];
gout[n*2187+427] += + s[589];
gout[n*2187+428] += + s[590];
gout[n*2187+429] += + s[591];
gout[n*2187+430] += + s[592];
gout[n*2187+431] += + s[593];
gout[n*2187+432] += + s[1296];
gout[n*2187+433] += + s[1297];
gout[n*2187+434] += + s[1298];
gout[n*2187+435] += + s[1299];
gout[n*2187+436] += + s[1300];
gout[n*2187+437] += + s[1301];
gout[n*2187+438] += + s[1302];
gout[n*2187+439] += + s[1303];
gout[n*2187+440] += + s[1304];
gout[n*2187+441] += + s[1305];
gout[n*2187+442] += + s[1306];
gout[n*2187+443] += + s[1307];
gout[n*2187+444] += + s[1308];
gout[n*2187+445] += + s[1309];
gout[n*2187+446] += + s[1310];
gout[n*2187+447] += + s[1311];
gout[n*2187+448] += + s[1312];
gout[n*2187+449] += + s[1313];
gout[n*2187+450] += + s[1314];
gout[n*2187+451] += + s[1315];
gout[n*2187+452] += + s[1316];
gout[n*2187+453] += + s[1317];
gout[n*2187+454] += + s[1318];
gout[n*2187+455] += + s[1319];
gout[n*2187+456] += + s[1320];
gout[n*2187+457] += + s[1321];
gout[n*2187+458] += + s[1322];
gout[n*2187+459] += + s[2025];
gout[n*2187+460] += + s[2026];
gout[n*2187+461] += + s[2027];
gout[n*2187+462] += + s[2028];
gout[n*2187+463] += + s[2029];
gout[n*2187+464] += + s[2030];
gout[n*2187+465] += + s[2031];
gout[n*2187+466] += + s[2032];
gout[n*2187+467] += + s[2033];
gout[n*2187+468] += + s[2034];
gout[n*2187+469] += + s[2035];
gout[n*2187+470] += + s[2036];
gout[n*2187+471] += + s[2037];
gout[n*2187+472] += + s[2038];
gout[n*2187+473] += + s[2039];
gout[n*2187+474] += + s[2040];
gout[n*2187+475] += + s[2041];
gout[n*2187+476] += + s[2042];
gout[n*2187+477] += + s[2043];
gout[n*2187+478] += + s[2044];
gout[n*2187+479] += + s[2045];
gout[n*2187+480] += + s[2046];
gout[n*2187+481] += + s[2047];
gout[n*2187+482] += + s[2048];
gout[n*2187+483] += + s[2049];
gout[n*2187+484] += + s[2050];
gout[n*2187+485] += + s[2051];
gout[n*2187+486] += + s[162];
gout[n*2187+487] += + s[163];
gout[n*2187+488] += + s[164];
gout[n*2187+489] += + s[165];
gout[n*2187+490] += + s[166];
gout[n*2187+491] += + s[167];
gout[n*2187+492] += + s[168];
gout[n*2187+493] += + s[169];
gout[n*2187+494] += + s[170];
gout[n*2187+495] += + s[171];
gout[n*2187+496] += + s[172];
gout[n*2187+497] += + s[173];
gout[n*2187+498] += + s[174];
gout[n*2187+499] += + s[175];
gout[n*2187+500] += + s[176];
gout[n*2187+501] += + s[177];
gout[n*2187+502] += + s[178];
gout[n*2187+503] += + s[179];
gout[n*2187+504] += + s[180];
gout[n*2187+505] += + s[181];
gout[n*2187+506] += + s[182];
gout[n*2187+507] += + s[183];
gout[n*2187+508] += + s[184];
gout[n*2187+509] += + s[185];
gout[n*2187+510] += + s[186];
gout[n*2187+511] += + s[187];
gout[n*2187+512] += + s[188];
gout[n*2187+513] += + s[891];
gout[n*2187+514] += + s[892];
gout[n*2187+515] += + s[893];
gout[n*2187+516] += + s[894];
gout[n*2187+517] += + s[895];
gout[n*2187+518] += + s[896];
gout[n*2187+519] += + s[897];
gout[n*2187+520] += + s[898];
gout[n*2187+521] += + s[899];
gout[n*2187+522] += + s[900];
gout[n*2187+523] += + s[901];
gout[n*2187+524] += + s[902];
gout[n*2187+525] += + s[903];
gout[n*2187+526] += + s[904];
gout[n*2187+527] += + s[905];
gout[n*2187+528] += + s[906];
gout[n*2187+529] += + s[907];
gout[n*2187+530] += + s[908];
gout[n*2187+531] += + s[909];
gout[n*2187+532] += + s[910];
gout[n*2187+533] += + s[911];
gout[n*2187+534] += + s[912];
gout[n*2187+535] += + s[913];
gout[n*2187+536] += + s[914];
gout[n*2187+537] += + s[915];
gout[n*2187+538] += + s[916];
gout[n*2187+539] += + s[917];
gout[n*2187+540] += + s[1620];
gout[n*2187+541] += + s[1621];
gout[n*2187+542] += + s[1622];
gout[n*2187+543] += + s[1623];
gout[n*2187+544] += + s[1624];
gout[n*2187+545] += + s[1625];
gout[n*2187+546] += + s[1626];
gout[n*2187+547] += + s[1627];
gout[n*2187+548] += + s[1628];
gout[n*2187+549] += + s[1629];
gout[n*2187+550] += + s[1630];
gout[n*2187+551] += + s[1631];
gout[n*2187+552] += + s[1632];
gout[n*2187+553] += + s[1633];
gout[n*2187+554] += + s[1634];
gout[n*2187+555] += + s[1635];
gout[n*2187+556] += + s[1636];
gout[n*2187+557] += + s[1637];
gout[n*2187+558] += + s[1638];
gout[n*2187+559] += + s[1639];
gout[n*2187+560] += + s[1640];
gout[n*2187+561] += + s[1641];
gout[n*2187+562] += + s[1642];
gout[n*2187+563] += + s[1643];
gout[n*2187+564] += + s[1644];
gout[n*2187+565] += + s[1645];
gout[n*2187+566] += + s[1646];
gout[n*2187+567] += + s[405];
gout[n*2187+568] += + s[406];
gout[n*2187+569] += + s[407];
gout[n*2187+570] += + s[408];
gout[n*2187+571] += + s[409];
gout[n*2187+572] += + s[410];
gout[n*2187+573] += + s[411];
gout[n*2187+574] += + s[412];
gout[n*2187+575] += + s[413];
gout[n*2187+576] += + s[414];
gout[n*2187+577] += + s[415];
gout[n*2187+578] += + s[416];
gout[n*2187+579] += + s[417];
gout[n*2187+580] += + s[418];
gout[n*2187+581] += + s[419];
gout[n*2187+582] += + s[420];
gout[n*2187+583] += + s[421];
gout[n*2187+584] += + s[422];
gout[n*2187+585] += + s[423];
gout[n*2187+586] += + s[424];
gout[n*2187+587] += + s[425];
gout[n*2187+588] += + s[426];
gout[n*2187+589] += + s[427];
gout[n*2187+590] += + s[428];
gout[n*2187+591] += + s[429];
gout[n*2187+592] += + s[430];
gout[n*2187+593] += + s[431];
gout[n*2187+594] += + s[1134];
gout[n*2187+595] += + s[1135];
gout[n*2187+596] += + s[1136];
gout[n*2187+597] += + s[1137];
gout[n*2187+598] += + s[1138];
gout[n*2187+599] += + s[1139];
gout[n*2187+600] += + s[1140];
gout[n*2187+601] += + s[1141];
gout[n*2187+602] += + s[1142];
gout[n*2187+603] += + s[1143];
gout[n*2187+604] += + s[1144];
gout[n*2187+605] += + s[1145];
gout[n*2187+606] += + s[1146];
gout[n*2187+607] += + s[1147];
gout[n*2187+608] += + s[1148];
gout[n*2187+609] += + s[1149];
gout[n*2187+610] += + s[1150];
gout[n*2187+611] += + s[1151];
gout[n*2187+612] += + s[1152];
gout[n*2187+613] += + s[1153];
gout[n*2187+614] += + s[1154];
gout[n*2187+615] += + s[1155];
gout[n*2187+616] += + s[1156];
gout[n*2187+617] += + s[1157];
gout[n*2187+618] += + s[1158];
gout[n*2187+619] += + s[1159];
gout[n*2187+620] += + s[1160];
gout[n*2187+621] += + s[1863];
gout[n*2187+622] += + s[1864];
gout[n*2187+623] += + s[1865];
gout[n*2187+624] += + s[1866];
gout[n*2187+625] += + s[1867];
gout[n*2187+626] += + s[1868];
gout[n*2187+627] += + s[1869];
gout[n*2187+628] += + s[1870];
gout[n*2187+629] += + s[1871];
gout[n*2187+630] += + s[1872];
gout[n*2187+631] += + s[1873];
gout[n*2187+632] += + s[1874];
gout[n*2187+633] += + s[1875];
gout[n*2187+634] += + s[1876];
gout[n*2187+635] += + s[1877];
gout[n*2187+636] += + s[1878];
gout[n*2187+637] += + s[1879];
gout[n*2187+638] += + s[1880];
gout[n*2187+639] += + s[1881];
gout[n*2187+640] += + s[1882];
gout[n*2187+641] += + s[1883];
gout[n*2187+642] += + s[1884];
gout[n*2187+643] += + s[1885];
gout[n*2187+644] += + s[1886];
gout[n*2187+645] += + s[1887];
gout[n*2187+646] += + s[1888];
gout[n*2187+647] += + s[1889];
gout[n*2187+648] += + s[648];
gout[n*2187+649] += + s[649];
gout[n*2187+650] += + s[650];
gout[n*2187+651] += + s[651];
gout[n*2187+652] += + s[652];
gout[n*2187+653] += + s[653];
gout[n*2187+654] += + s[654];
gout[n*2187+655] += + s[655];
gout[n*2187+656] += + s[656];
gout[n*2187+657] += + s[657];
gout[n*2187+658] += + s[658];
gout[n*2187+659] += + s[659];
gout[n*2187+660] += + s[660];
gout[n*2187+661] += + s[661];
gout[n*2187+662] += + s[662];
gout[n*2187+663] += + s[663];
gout[n*2187+664] += + s[664];
gout[n*2187+665] += + s[665];
gout[n*2187+666] += + s[666];
gout[n*2187+667] += + s[667];
gout[n*2187+668] += + s[668];
gout[n*2187+669] += + s[669];
gout[n*2187+670] += + s[670];
gout[n*2187+671] += + s[671];
gout[n*2187+672] += + s[672];
gout[n*2187+673] += + s[673];
gout[n*2187+674] += + s[674];
gout[n*2187+675] += + s[1377];
gout[n*2187+676] += + s[1378];
gout[n*2187+677] += + s[1379];
gout[n*2187+678] += + s[1380];
gout[n*2187+679] += + s[1381];
gout[n*2187+680] += + s[1382];
gout[n*2187+681] += + s[1383];
gout[n*2187+682] += + s[1384];
gout[n*2187+683] += + s[1385];
gout[n*2187+684] += + s[1386];
gout[n*2187+685] += + s[1387];
gout[n*2187+686] += + s[1388];
gout[n*2187+687] += + s[1389];
gout[n*2187+688] += + s[1390];
gout[n*2187+689] += + s[1391];
gout[n*2187+690] += + s[1392];
gout[n*2187+691] += + s[1393];
gout[n*2187+692] += + s[1394];
gout[n*2187+693] += + s[1395];
gout[n*2187+694] += + s[1396];
gout[n*2187+695] += + s[1397];
gout[n*2187+696] += + s[1398];
gout[n*2187+697] += + s[1399];
gout[n*2187+698] += + s[1400];
gout[n*2187+699] += + s[1401];
gout[n*2187+700] += + s[1402];
gout[n*2187+701] += + s[1403];
gout[n*2187+702] += + s[2106];
gout[n*2187+703] += + s[2107];
gout[n*2187+704] += + s[2108];
gout[n*2187+705] += + s[2109];
gout[n*2187+706] += + s[2110];
gout[n*2187+707] += + s[2111];
gout[n*2187+708] += + s[2112];
gout[n*2187+709] += + s[2113];
gout[n*2187+710] += + s[2114];
gout[n*2187+711] += + s[2115];
gout[n*2187+712] += + s[2116];
gout[n*2187+713] += + s[2117];
gout[n*2187+714] += + s[2118];
gout[n*2187+715] += + s[2119];
gout[n*2187+716] += + s[2120];
gout[n*2187+717] += + s[2121];
gout[n*2187+718] += + s[2122];
gout[n*2187+719] += + s[2123];
gout[n*2187+720] += + s[2124];
gout[n*2187+721] += + s[2125];
gout[n*2187+722] += + s[2126];
gout[n*2187+723] += + s[2127];
gout[n*2187+724] += + s[2128];
gout[n*2187+725] += + s[2129];
gout[n*2187+726] += + s[2130];
gout[n*2187+727] += + s[2131];
gout[n*2187+728] += + s[2132];
gout[n*2187+729] += + s[27];
gout[n*2187+730] += + s[28];
gout[n*2187+731] += + s[29];
gout[n*2187+732] += + s[30];
gout[n*2187+733] += + s[31];
gout[n*2187+734] += + s[32];
gout[n*2187+735] += + s[33];
gout[n*2187+736] += + s[34];
gout[n*2187+737] += + s[35];
gout[n*2187+738] += + s[36];
gout[n*2187+739] += + s[37];
gout[n*2187+740] += + s[38];
gout[n*2187+741] += + s[39];
gout[n*2187+742] += + s[40];
gout[n*2187+743] += + s[41];
gout[n*2187+744] += + s[42];
gout[n*2187+745] += + s[43];
gout[n*2187+746] += + s[44];
gout[n*2187+747] += + s[45];
gout[n*2187+748] += + s[46];
gout[n*2187+749] += + s[47];
gout[n*2187+750] += + s[48];
gout[n*2187+751] += + s[49];
gout[n*2187+752] += + s[50];
gout[n*2187+753] += + s[51];
gout[n*2187+754] += + s[52];
gout[n*2187+755] += + s[53];
gout[n*2187+756] += + s[756];
gout[n*2187+757] += + s[757];
gout[n*2187+758] += + s[758];
gout[n*2187+759] += + s[759];
gout[n*2187+760] += + s[760];
gout[n*2187+761] += + s[761];
gout[n*2187+762] += + s[762];
gout[n*2187+763] += + s[763];
gout[n*2187+764] += + s[764];
gout[n*2187+765] += + s[765];
gout[n*2187+766] += + s[766];
gout[n*2187+767] += + s[767];
gout[n*2187+768] += + s[768];
gout[n*2187+769] += + s[769];
gout[n*2187+770] += + s[770];
gout[n*2187+771] += + s[771];
gout[n*2187+772] += + s[772];
gout[n*2187+773] += + s[773];
gout[n*2187+774] += + s[774];
gout[n*2187+775] += + s[775];
gout[n*2187+776] += + s[776];
gout[n*2187+777] += + s[777];
gout[n*2187+778] += + s[778];
gout[n*2187+779] += + s[779];
gout[n*2187+780] += + s[780];
gout[n*2187+781] += + s[781];
gout[n*2187+782] += + s[782];
gout[n*2187+783] += + s[1485];
gout[n*2187+784] += + s[1486];
gout[n*2187+785] += + s[1487];
gout[n*2187+786] += + s[1488];
gout[n*2187+787] += + s[1489];
gout[n*2187+788] += + s[1490];
gout[n*2187+789] += + s[1491];
gout[n*2187+790] += + s[1492];
gout[n*2187+791] += + s[1493];
gout[n*2187+792] += + s[1494];
gout[n*2187+793] += + s[1495];
gout[n*2187+794] += + s[1496];
gout[n*2187+795] += + s[1497];
gout[n*2187+796] += + s[1498];
gout[n*2187+797] += + s[1499];
gout[n*2187+798] += + s[1500];
gout[n*2187+799] += + s[1501];
gout[n*2187+800] += + s[1502];
gout[n*2187+801] += + s[1503];
gout[n*2187+802] += + s[1504];
gout[n*2187+803] += + s[1505];
gout[n*2187+804] += + s[1506];
gout[n*2187+805] += + s[1507];
gout[n*2187+806] += + s[1508];
gout[n*2187+807] += + s[1509];
gout[n*2187+808] += + s[1510];
gout[n*2187+809] += + s[1511];
gout[n*2187+810] += + s[270];
gout[n*2187+811] += + s[271];
gout[n*2187+812] += + s[272];
gout[n*2187+813] += + s[273];
gout[n*2187+814] += + s[274];
gout[n*2187+815] += + s[275];
gout[n*2187+816] += + s[276];
gout[n*2187+817] += + s[277];
gout[n*2187+818] += + s[278];
gout[n*2187+819] += + s[279];
gout[n*2187+820] += + s[280];
gout[n*2187+821] += + s[281];
gout[n*2187+822] += + s[282];
gout[n*2187+823] += + s[283];
gout[n*2187+824] += + s[284];
gout[n*2187+825] += + s[285];
gout[n*2187+826] += + s[286];
gout[n*2187+827] += + s[287];
gout[n*2187+828] += + s[288];
gout[n*2187+829] += + s[289];
gout[n*2187+830] += + s[290];
gout[n*2187+831] += + s[291];
gout[n*2187+832] += + s[292];
gout[n*2187+833] += + s[293];
gout[n*2187+834] += + s[294];
gout[n*2187+835] += + s[295];
gout[n*2187+836] += + s[296];
gout[n*2187+837] += + s[999];
gout[n*2187+838] += + s[1000];
gout[n*2187+839] += + s[1001];
gout[n*2187+840] += + s[1002];
gout[n*2187+841] += + s[1003];
gout[n*2187+842] += + s[1004];
gout[n*2187+843] += + s[1005];
gout[n*2187+844] += + s[1006];
gout[n*2187+845] += + s[1007];
gout[n*2187+846] += + s[1008];
gout[n*2187+847] += + s[1009];
gout[n*2187+848] += + s[1010];
gout[n*2187+849] += + s[1011];
gout[n*2187+850] += + s[1012];
gout[n*2187+851] += + s[1013];
gout[n*2187+852] += + s[1014];
gout[n*2187+853] += + s[1015];
gout[n*2187+854] += + s[1016];
gout[n*2187+855] += + s[1017];
gout[n*2187+856] += + s[1018];
gout[n*2187+857] += + s[1019];
gout[n*2187+858] += + s[1020];
gout[n*2187+859] += + s[1021];
gout[n*2187+860] += + s[1022];
gout[n*2187+861] += + s[1023];
gout[n*2187+862] += + s[1024];
gout[n*2187+863] += + s[1025];
gout[n*2187+864] += + s[1728];
gout[n*2187+865] += + s[1729];
gout[n*2187+866] += + s[1730];
gout[n*2187+867] += + s[1731];
gout[n*2187+868] += + s[1732];
gout[n*2187+869] += + s[1733];
gout[n*2187+870] += + s[1734];
gout[n*2187+871] += + s[1735];
gout[n*2187+872] += + s[1736];
gout[n*2187+873] += + s[1737];
gout[n*2187+874] += + s[1738];
gout[n*2187+875] += + s[1739];
gout[n*2187+876] += + s[1740];
gout[n*2187+877] += + s[1741];
gout[n*2187+878] += + s[1742];
gout[n*2187+879] += + s[1743];
gout[n*2187+880] += + s[1744];
gout[n*2187+881] += + s[1745];
gout[n*2187+882] += + s[1746];
gout[n*2187+883] += + s[1747];
gout[n*2187+884] += + s[1748];
gout[n*2187+885] += + s[1749];
gout[n*2187+886] += + s[1750];
gout[n*2187+887] += + s[1751];
gout[n*2187+888] += + s[1752];
gout[n*2187+889] += + s[1753];
gout[n*2187+890] += + s[1754];
gout[n*2187+891] += + s[513];
gout[n*2187+892] += + s[514];
gout[n*2187+893] += + s[515];
gout[n*2187+894] += + s[516];
gout[n*2187+895] += + s[517];
gout[n*2187+896] += + s[518];
gout[n*2187+897] += + s[519];
gout[n*2187+898] += + s[520];
gout[n*2187+899] += + s[521];
gout[n*2187+900] += + s[522];
gout[n*2187+901] += + s[523];
gout[n*2187+902] += + s[524];
gout[n*2187+903] += + s[525];
gout[n*2187+904] += + s[526];
gout[n*2187+905] += + s[527];
gout[n*2187+906] += + s[528];
gout[n*2187+907] += + s[529];
gout[n*2187+908] += + s[530];
gout[n*2187+909] += + s[531];
gout[n*2187+910] += + s[532];
gout[n*2187+911] += + s[533];
gout[n*2187+912] += + s[534];
gout[n*2187+913] += + s[535];
gout[n*2187+914] += + s[536];
gout[n*2187+915] += + s[537];
gout[n*2187+916] += + s[538];
gout[n*2187+917] += + s[539];
gout[n*2187+918] += + s[1242];
gout[n*2187+919] += + s[1243];
gout[n*2187+920] += + s[1244];
gout[n*2187+921] += + s[1245];
gout[n*2187+922] += + s[1246];
gout[n*2187+923] += + s[1247];
gout[n*2187+924] += + s[1248];
gout[n*2187+925] += + s[1249];
gout[n*2187+926] += + s[1250];
gout[n*2187+927] += + s[1251];
gout[n*2187+928] += + s[1252];
gout[n*2187+929] += + s[1253];
gout[n*2187+930] += + s[1254];
gout[n*2187+931] += + s[1255];
gout[n*2187+932] += + s[1256];
gout[n*2187+933] += + s[1257];
gout[n*2187+934] += + s[1258];
gout[n*2187+935] += + s[1259];
gout[n*2187+936] += + s[1260];
gout[n*2187+937] += + s[1261];
gout[n*2187+938] += + s[1262];
gout[n*2187+939] += + s[1263];
gout[n*2187+940] += + s[1264];
gout[n*2187+941] += + s[1265];
gout[n*2187+942] += + s[1266];
gout[n*2187+943] += + s[1267];
gout[n*2187+944] += + s[1268];
gout[n*2187+945] += + s[1971];
gout[n*2187+946] += + s[1972];
gout[n*2187+947] += + s[1973];
gout[n*2187+948] += + s[1974];
gout[n*2187+949] += + s[1975];
gout[n*2187+950] += + s[1976];
gout[n*2187+951] += + s[1977];
gout[n*2187+952] += + s[1978];
gout[n*2187+953] += + s[1979];
gout[n*2187+954] += + s[1980];
gout[n*2187+955] += + s[1981];
gout[n*2187+956] += + s[1982];
gout[n*2187+957] += + s[1983];
gout[n*2187+958] += + s[1984];
gout[n*2187+959] += + s[1985];
gout[n*2187+960] += + s[1986];
gout[n*2187+961] += + s[1987];
gout[n*2187+962] += + s[1988];
gout[n*2187+963] += + s[1989];
gout[n*2187+964] += + s[1990];
gout[n*2187+965] += + s[1991];
gout[n*2187+966] += + s[1992];
gout[n*2187+967] += + s[1993];
gout[n*2187+968] += + s[1994];
gout[n*2187+969] += + s[1995];
gout[n*2187+970] += + s[1996];
gout[n*2187+971] += + s[1997];
gout[n*2187+972] += + s[108];
gout[n*2187+973] += + s[109];
gout[n*2187+974] += + s[110];
gout[n*2187+975] += + s[111];
gout[n*2187+976] += + s[112];
gout[n*2187+977] += + s[113];
gout[n*2187+978] += + s[114];
gout[n*2187+979] += + s[115];
gout[n*2187+980] += + s[116];
gout[n*2187+981] += + s[117];
gout[n*2187+982] += + s[118];
gout[n*2187+983] += + s[119];
gout[n*2187+984] += + s[120];
gout[n*2187+985] += + s[121];
gout[n*2187+986] += + s[122];
gout[n*2187+987] += + s[123];
gout[n*2187+988] += + s[124];
gout[n*2187+989] += + s[125];
gout[n*2187+990] += + s[126];
gout[n*2187+991] += + s[127];
gout[n*2187+992] += + s[128];
gout[n*2187+993] += + s[129];
gout[n*2187+994] += + s[130];
gout[n*2187+995] += + s[131];
gout[n*2187+996] += + s[132];
gout[n*2187+997] += + s[133];
gout[n*2187+998] += + s[134];
gout[n*2187+999] += + s[837];
gout[n*2187+1000] += + s[838];
gout[n*2187+1001] += + s[839];
gout[n*2187+1002] += + s[840];
gout[n*2187+1003] += + s[841];
gout[n*2187+1004] += + s[842];
gout[n*2187+1005] += + s[843];
gout[n*2187+1006] += + s[844];
gout[n*2187+1007] += + s[845];
gout[n*2187+1008] += + s[846];
gout[n*2187+1009] += + s[847];
gout[n*2187+1010] += + s[848];
gout[n*2187+1011] += + s[849];
gout[n*2187+1012] += + s[850];
gout[n*2187+1013] += + s[851];
gout[n*2187+1014] += + s[852];
gout[n*2187+1015] += + s[853];
gout[n*2187+1016] += + s[854];
gout[n*2187+1017] += + s[855];
gout[n*2187+1018] += + s[856];
gout[n*2187+1019] += + s[857];
gout[n*2187+1020] += + s[858];
gout[n*2187+1021] += + s[859];
gout[n*2187+1022] += + s[860];
gout[n*2187+1023] += + s[861];
gout[n*2187+1024] += + s[862];
gout[n*2187+1025] += + s[863];
gout[n*2187+1026] += + s[1566];
gout[n*2187+1027] += + s[1567];
gout[n*2187+1028] += + s[1568];
gout[n*2187+1029] += + s[1569];
gout[n*2187+1030] += + s[1570];
gout[n*2187+1031] += + s[1571];
gout[n*2187+1032] += + s[1572];
gout[n*2187+1033] += + s[1573];
gout[n*2187+1034] += + s[1574];
gout[n*2187+1035] += + s[1575];
gout[n*2187+1036] += + s[1576];
gout[n*2187+1037] += + s[1577];
gout[n*2187+1038] += + s[1578];
gout[n*2187+1039] += + s[1579];
gout[n*2187+1040] += + s[1580];
gout[n*2187+1041] += + s[1581];
gout[n*2187+1042] += + s[1582];
gout[n*2187+1043] += + s[1583];
gout[n*2187+1044] += + s[1584];
gout[n*2187+1045] += + s[1585];
gout[n*2187+1046] += + s[1586];
gout[n*2187+1047] += + s[1587];
gout[n*2187+1048] += + s[1588];
gout[n*2187+1049] += + s[1589];
gout[n*2187+1050] += + s[1590];
gout[n*2187+1051] += + s[1591];
gout[n*2187+1052] += + s[1592];
gout[n*2187+1053] += + s[351];
gout[n*2187+1054] += + s[352];
gout[n*2187+1055] += + s[353];
gout[n*2187+1056] += + s[354];
gout[n*2187+1057] += + s[355];
gout[n*2187+1058] += + s[356];
gout[n*2187+1059] += + s[357];
gout[n*2187+1060] += + s[358];
gout[n*2187+1061] += + s[359];
gout[n*2187+1062] += + s[360];
gout[n*2187+1063] += + s[361];
gout[n*2187+1064] += + s[362];
gout[n*2187+1065] += + s[363];
gout[n*2187+1066] += + s[364];
gout[n*2187+1067] += + s[365];
gout[n*2187+1068] += + s[366];
gout[n*2187+1069] += + s[367];
gout[n*2187+1070] += + s[368];
gout[n*2187+1071] += + s[369];
gout[n*2187+1072] += + s[370];
gout[n*2187+1073] += + s[371];
gout[n*2187+1074] += + s[372];
gout[n*2187+1075] += + s[373];
gout[n*2187+1076] += + s[374];
gout[n*2187+1077] += + s[375];
gout[n*2187+1078] += + s[376];
gout[n*2187+1079] += + s[377];
gout[n*2187+1080] += + s[1080];
gout[n*2187+1081] += + s[1081];
gout[n*2187+1082] += + s[1082];
gout[n*2187+1083] += + s[1083];
gout[n*2187+1084] += + s[1084];
gout[n*2187+1085] += + s[1085];
gout[n*2187+1086] += + s[1086];
gout[n*2187+1087] += + s[1087];
gout[n*2187+1088] += + s[1088];
gout[n*2187+1089] += + s[1089];
gout[n*2187+1090] += + s[1090];
gout[n*2187+1091] += + s[1091];
gout[n*2187+1092] += + s[1092];
gout[n*2187+1093] += + s[1093];
gout[n*2187+1094] += + s[1094];
gout[n*2187+1095] += + s[1095];
gout[n*2187+1096] += + s[1096];
gout[n*2187+1097] += + s[1097];
gout[n*2187+1098] += + s[1098];
gout[n*2187+1099] += + s[1099];
gout[n*2187+1100] += + s[1100];
gout[n*2187+1101] += + s[1101];
gout[n*2187+1102] += + s[1102];
gout[n*2187+1103] += + s[1103];
gout[n*2187+1104] += + s[1104];
gout[n*2187+1105] += + s[1105];
gout[n*2187+1106] += + s[1106];
gout[n*2187+1107] += + s[1809];
gout[n*2187+1108] += + s[1810];
gout[n*2187+1109] += + s[1811];
gout[n*2187+1110] += + s[1812];
gout[n*2187+1111] += + s[1813];
gout[n*2187+1112] += + s[1814];
gout[n*2187+1113] += + s[1815];
gout[n*2187+1114] += + s[1816];
gout[n*2187+1115] += + s[1817];
gout[n*2187+1116] += + s[1818];
gout[n*2187+1117] += + s[1819];
gout[n*2187+1118] += + s[1820];
gout[n*2187+1119] += + s[1821];
gout[n*2187+1120] += + s[1822];
gout[n*2187+1121] += + s[1823];
gout[n*2187+1122] += + s[1824];
gout[n*2187+1123] += + s[1825];
gout[n*2187+1124] += + s[1826];
gout[n*2187+1125] += + s[1827];
gout[n*2187+1126] += + s[1828];
gout[n*2187+1127] += + s[1829];
gout[n*2187+1128] += + s[1830];
gout[n*2187+1129] += + s[1831];
gout[n*2187+1130] += + s[1832];
gout[n*2187+1131] += + s[1833];
gout[n*2187+1132] += + s[1834];
gout[n*2187+1133] += + s[1835];
gout[n*2187+1134] += + s[594];
gout[n*2187+1135] += + s[595];
gout[n*2187+1136] += + s[596];
gout[n*2187+1137] += + s[597];
gout[n*2187+1138] += + s[598];
gout[n*2187+1139] += + s[599];
gout[n*2187+1140] += + s[600];
gout[n*2187+1141] += + s[601];
gout[n*2187+1142] += + s[602];
gout[n*2187+1143] += + s[603];
gout[n*2187+1144] += + s[604];
gout[n*2187+1145] += + s[605];
gout[n*2187+1146] += + s[606];
gout[n*2187+1147] += + s[607];
gout[n*2187+1148] += + s[608];
gout[n*2187+1149] += + s[609];
gout[n*2187+1150] += + s[610];
gout[n*2187+1151] += + s[611];
gout[n*2187+1152] += + s[612];
gout[n*2187+1153] += + s[613];
gout[n*2187+1154] += + s[614];
gout[n*2187+1155] += + s[615];
gout[n*2187+1156] += + s[616];
gout[n*2187+1157] += + s[617];
gout[n*2187+1158] += + s[618];
gout[n*2187+1159] += + s[619];
gout[n*2187+1160] += + s[620];
gout[n*2187+1161] += + s[1323];
gout[n*2187+1162] += + s[1324];
gout[n*2187+1163] += + s[1325];
gout[n*2187+1164] += + s[1326];
gout[n*2187+1165] += + s[1327];
gout[n*2187+1166] += + s[1328];
gout[n*2187+1167] += + s[1329];
gout[n*2187+1168] += + s[1330];
gout[n*2187+1169] += + s[1331];
gout[n*2187+1170] += + s[1332];
gout[n*2187+1171] += + s[1333];
gout[n*2187+1172] += + s[1334];
gout[n*2187+1173] += + s[1335];
gout[n*2187+1174] += + s[1336];
gout[n*2187+1175] += + s[1337];
gout[n*2187+1176] += + s[1338];
gout[n*2187+1177] += + s[1339];
gout[n*2187+1178] += + s[1340];
gout[n*2187+1179] += + s[1341];
gout[n*2187+1180] += + s[1342];
gout[n*2187+1181] += + s[1343];
gout[n*2187+1182] += + s[1344];
gout[n*2187+1183] += + s[1345];
gout[n*2187+1184] += + s[1346];
gout[n*2187+1185] += + s[1347];
gout[n*2187+1186] += + s[1348];
gout[n*2187+1187] += + s[1349];
gout[n*2187+1188] += + s[2052];
gout[n*2187+1189] += + s[2053];
gout[n*2187+1190] += + s[2054];
gout[n*2187+1191] += + s[2055];
gout[n*2187+1192] += + s[2056];
gout[n*2187+1193] += + s[2057];
gout[n*2187+1194] += + s[2058];
gout[n*2187+1195] += + s[2059];
gout[n*2187+1196] += + s[2060];
gout[n*2187+1197] += + s[2061];
gout[n*2187+1198] += + s[2062];
gout[n*2187+1199] += + s[2063];
gout[n*2187+1200] += + s[2064];
gout[n*2187+1201] += + s[2065];
gout[n*2187+1202] += + s[2066];
gout[n*2187+1203] += + s[2067];
gout[n*2187+1204] += + s[2068];
gout[n*2187+1205] += + s[2069];
gout[n*2187+1206] += + s[2070];
gout[n*2187+1207] += + s[2071];
gout[n*2187+1208] += + s[2072];
gout[n*2187+1209] += + s[2073];
gout[n*2187+1210] += + s[2074];
gout[n*2187+1211] += + s[2075];
gout[n*2187+1212] += + s[2076];
gout[n*2187+1213] += + s[2077];
gout[n*2187+1214] += + s[2078];
gout[n*2187+1215] += + s[189];
gout[n*2187+1216] += + s[190];
gout[n*2187+1217] += + s[191];
gout[n*2187+1218] += + s[192];
gout[n*2187+1219] += + s[193];
gout[n*2187+1220] += + s[194];
gout[n*2187+1221] += + s[195];
gout[n*2187+1222] += + s[196];
gout[n*2187+1223] += + s[197];
gout[n*2187+1224] += + s[198];
gout[n*2187+1225] += + s[199];
gout[n*2187+1226] += + s[200];
gout[n*2187+1227] += + s[201];
gout[n*2187+1228] += + s[202];
gout[n*2187+1229] += + s[203];
gout[n*2187+1230] += + s[204];
gout[n*2187+1231] += + s[205];
gout[n*2187+1232] += + s[206];
gout[n*2187+1233] += + s[207];
gout[n*2187+1234] += + s[208];
gout[n*2187+1235] += + s[209];
gout[n*2187+1236] += + s[210];
gout[n*2187+1237] += + s[211];
gout[n*2187+1238] += + s[212];
gout[n*2187+1239] += + s[213];
gout[n*2187+1240] += + s[214];
gout[n*2187+1241] += + s[215];
gout[n*2187+1242] += + s[918];
gout[n*2187+1243] += + s[919];
gout[n*2187+1244] += + s[920];
gout[n*2187+1245] += + s[921];
gout[n*2187+1246] += + s[922];
gout[n*2187+1247] += + s[923];
gout[n*2187+1248] += + s[924];
gout[n*2187+1249] += + s[925];
gout[n*2187+1250] += + s[926];
gout[n*2187+1251] += + s[927];
gout[n*2187+1252] += + s[928];
gout[n*2187+1253] += + s[929];
gout[n*2187+1254] += + s[930];
gout[n*2187+1255] += + s[931];
gout[n*2187+1256] += + s[932];
gout[n*2187+1257] += + s[933];
gout[n*2187+1258] += + s[934];
gout[n*2187+1259] += + s[935];
gout[n*2187+1260] += + s[936];
gout[n*2187+1261] += + s[937];
gout[n*2187+1262] += + s[938];
gout[n*2187+1263] += + s[939];
gout[n*2187+1264] += + s[940];
gout[n*2187+1265] += + s[941];
gout[n*2187+1266] += + s[942];
gout[n*2187+1267] += + s[943];
gout[n*2187+1268] += + s[944];
gout[n*2187+1269] += + s[1647];
gout[n*2187+1270] += + s[1648];
gout[n*2187+1271] += + s[1649];
gout[n*2187+1272] += + s[1650];
gout[n*2187+1273] += + s[1651];
gout[n*2187+1274] += + s[1652];
gout[n*2187+1275] += + s[1653];
gout[n*2187+1276] += + s[1654];
gout[n*2187+1277] += + s[1655];
gout[n*2187+1278] += + s[1656];
gout[n*2187+1279] += + s[1657];
gout[n*2187+1280] += + s[1658];
gout[n*2187+1281] += + s[1659];
gout[n*2187+1282] += + s[1660];
gout[n*2187+1283] += + s[1661];
gout[n*2187+1284] += + s[1662];
gout[n*2187+1285] += + s[1663];
gout[n*2187+1286] += + s[1664];
gout[n*2187+1287] += + s[1665];
gout[n*2187+1288] += + s[1666];
gout[n*2187+1289] += + s[1667];
gout[n*2187+1290] += + s[1668];
gout[n*2187+1291] += + s[1669];
gout[n*2187+1292] += + s[1670];
gout[n*2187+1293] += + s[1671];
gout[n*2187+1294] += + s[1672];
gout[n*2187+1295] += + s[1673];
gout[n*2187+1296] += + s[432];
gout[n*2187+1297] += + s[433];
gout[n*2187+1298] += + s[434];
gout[n*2187+1299] += + s[435];
gout[n*2187+1300] += + s[436];
gout[n*2187+1301] += + s[437];
gout[n*2187+1302] += + s[438];
gout[n*2187+1303] += + s[439];
gout[n*2187+1304] += + s[440];
gout[n*2187+1305] += + s[441];
gout[n*2187+1306] += + s[442];
gout[n*2187+1307] += + s[443];
gout[n*2187+1308] += + s[444];
gout[n*2187+1309] += + s[445];
gout[n*2187+1310] += + s[446];
gout[n*2187+1311] += + s[447];
gout[n*2187+1312] += + s[448];
gout[n*2187+1313] += + s[449];
gout[n*2187+1314] += + s[450];
gout[n*2187+1315] += + s[451];
gout[n*2187+1316] += + s[452];
gout[n*2187+1317] += + s[453];
gout[n*2187+1318] += + s[454];
gout[n*2187+1319] += + s[455];
gout[n*2187+1320] += + s[456];
gout[n*2187+1321] += + s[457];
gout[n*2187+1322] += + s[458];
gout[n*2187+1323] += + s[1161];
gout[n*2187+1324] += + s[1162];
gout[n*2187+1325] += + s[1163];
gout[n*2187+1326] += + s[1164];
gout[n*2187+1327] += + s[1165];
gout[n*2187+1328] += + s[1166];
gout[n*2187+1329] += + s[1167];
gout[n*2187+1330] += + s[1168];
gout[n*2187+1331] += + s[1169];
gout[n*2187+1332] += + s[1170];
gout[n*2187+1333] += + s[1171];
gout[n*2187+1334] += + s[1172];
gout[n*2187+1335] += + s[1173];
gout[n*2187+1336] += + s[1174];
gout[n*2187+1337] += + s[1175];
gout[n*2187+1338] += + s[1176];
gout[n*2187+1339] += + s[1177];
gout[n*2187+1340] += + s[1178];
gout[n*2187+1341] += + s[1179];
gout[n*2187+1342] += + s[1180];
gout[n*2187+1343] += + s[1181];
gout[n*2187+1344] += + s[1182];
gout[n*2187+1345] += + s[1183];
gout[n*2187+1346] += + s[1184];
gout[n*2187+1347] += + s[1185];
gout[n*2187+1348] += + s[1186];
gout[n*2187+1349] += + s[1187];
gout[n*2187+1350] += + s[1890];
gout[n*2187+1351] += + s[1891];
gout[n*2187+1352] += + s[1892];
gout[n*2187+1353] += + s[1893];
gout[n*2187+1354] += + s[1894];
gout[n*2187+1355] += + s[1895];
gout[n*2187+1356] += + s[1896];
gout[n*2187+1357] += + s[1897];
gout[n*2187+1358] += + s[1898];
gout[n*2187+1359] += + s[1899];
gout[n*2187+1360] += + s[1900];
gout[n*2187+1361] += + s[1901];
gout[n*2187+1362] += + s[1902];
gout[n*2187+1363] += + s[1903];
gout[n*2187+1364] += + s[1904];
gout[n*2187+1365] += + s[1905];
gout[n*2187+1366] += + s[1906];
gout[n*2187+1367] += + s[1907];
gout[n*2187+1368] += + s[1908];
gout[n*2187+1369] += + s[1909];
gout[n*2187+1370] += + s[1910];
gout[n*2187+1371] += + s[1911];
gout[n*2187+1372] += + s[1912];
gout[n*2187+1373] += + s[1913];
gout[n*2187+1374] += + s[1914];
gout[n*2187+1375] += + s[1915];
gout[n*2187+1376] += + s[1916];
gout[n*2187+1377] += + s[675];
gout[n*2187+1378] += + s[676];
gout[n*2187+1379] += + s[677];
gout[n*2187+1380] += + s[678];
gout[n*2187+1381] += + s[679];
gout[n*2187+1382] += + s[680];
gout[n*2187+1383] += + s[681];
gout[n*2187+1384] += + s[682];
gout[n*2187+1385] += + s[683];
gout[n*2187+1386] += + s[684];
gout[n*2187+1387] += + s[685];
gout[n*2187+1388] += + s[686];
gout[n*2187+1389] += + s[687];
gout[n*2187+1390] += + s[688];
gout[n*2187+1391] += + s[689];
gout[n*2187+1392] += + s[690];
gout[n*2187+1393] += + s[691];
gout[n*2187+1394] += + s[692];
gout[n*2187+1395] += + s[693];
gout[n*2187+1396] += + s[694];
gout[n*2187+1397] += + s[695];
gout[n*2187+1398] += + s[696];
gout[n*2187+1399] += + s[697];
gout[n*2187+1400] += + s[698];
gout[n*2187+1401] += + s[699];
gout[n*2187+1402] += + s[700];
gout[n*2187+1403] += + s[701];
gout[n*2187+1404] += + s[1404];
gout[n*2187+1405] += + s[1405];
gout[n*2187+1406] += + s[1406];
gout[n*2187+1407] += + s[1407];
gout[n*2187+1408] += + s[1408];
gout[n*2187+1409] += + s[1409];
gout[n*2187+1410] += + s[1410];
gout[n*2187+1411] += + s[1411];
gout[n*2187+1412] += + s[1412];
gout[n*2187+1413] += + s[1413];
gout[n*2187+1414] += + s[1414];
gout[n*2187+1415] += + s[1415];
gout[n*2187+1416] += + s[1416];
gout[n*2187+1417] += + s[1417];
gout[n*2187+1418] += + s[1418];
gout[n*2187+1419] += + s[1419];
gout[n*2187+1420] += + s[1420];
gout[n*2187+1421] += + s[1421];
gout[n*2187+1422] += + s[1422];
gout[n*2187+1423] += + s[1423];
gout[n*2187+1424] += + s[1424];
gout[n*2187+1425] += + s[1425];
gout[n*2187+1426] += + s[1426];
gout[n*2187+1427] += + s[1427];
gout[n*2187+1428] += + s[1428];
gout[n*2187+1429] += + s[1429];
gout[n*2187+1430] += + s[1430];
gout[n*2187+1431] += + s[2133];
gout[n*2187+1432] += + s[2134];
gout[n*2187+1433] += + s[2135];
gout[n*2187+1434] += + s[2136];
gout[n*2187+1435] += + s[2137];
gout[n*2187+1436] += + s[2138];
gout[n*2187+1437] += + s[2139];
gout[n*2187+1438] += + s[2140];
gout[n*2187+1439] += + s[2141];
gout[n*2187+1440] += + s[2142];
gout[n*2187+1441] += + s[2143];
gout[n*2187+1442] += + s[2144];
gout[n*2187+1443] += + s[2145];
gout[n*2187+1444] += + s[2146];
gout[n*2187+1445] += + s[2147];
gout[n*2187+1446] += + s[2148];
gout[n*2187+1447] += + s[2149];
gout[n*2187+1448] += + s[2150];
gout[n*2187+1449] += + s[2151];
gout[n*2187+1450] += + s[2152];
gout[n*2187+1451] += + s[2153];
gout[n*2187+1452] += + s[2154];
gout[n*2187+1453] += + s[2155];
gout[n*2187+1454] += + s[2156];
gout[n*2187+1455] += + s[2157];
gout[n*2187+1456] += + s[2158];
gout[n*2187+1457] += + s[2159];
gout[n*2187+1458] += + s[54];
gout[n*2187+1459] += + s[55];
gout[n*2187+1460] += + s[56];
gout[n*2187+1461] += + s[57];
gout[n*2187+1462] += + s[58];
gout[n*2187+1463] += + s[59];
gout[n*2187+1464] += + s[60];
gout[n*2187+1465] += + s[61];
gout[n*2187+1466] += + s[62];
gout[n*2187+1467] += + s[63];
gout[n*2187+1468] += + s[64];
gout[n*2187+1469] += + s[65];
gout[n*2187+1470] += + s[66];
gout[n*2187+1471] += + s[67];
gout[n*2187+1472] += + s[68];
gout[n*2187+1473] += + s[69];
gout[n*2187+1474] += + s[70];
gout[n*2187+1475] += + s[71];
gout[n*2187+1476] += + s[72];
gout[n*2187+1477] += + s[73];
gout[n*2187+1478] += + s[74];
gout[n*2187+1479] += + s[75];
gout[n*2187+1480] += + s[76];
gout[n*2187+1481] += + s[77];
gout[n*2187+1482] += + s[78];
gout[n*2187+1483] += + s[79];
gout[n*2187+1484] += + s[80];
gout[n*2187+1485] += + s[783];
gout[n*2187+1486] += + s[784];
gout[n*2187+1487] += + s[785];
gout[n*2187+1488] += + s[786];
gout[n*2187+1489] += + s[787];
gout[n*2187+1490] += + s[788];
gout[n*2187+1491] += + s[789];
gout[n*2187+1492] += + s[790];
gout[n*2187+1493] += + s[791];
gout[n*2187+1494] += + s[792];
gout[n*2187+1495] += + s[793];
gout[n*2187+1496] += + s[794];
gout[n*2187+1497] += + s[795];
gout[n*2187+1498] += + s[796];
gout[n*2187+1499] += + s[797];
gout[n*2187+1500] += + s[798];
gout[n*2187+1501] += + s[799];
gout[n*2187+1502] += + s[800];
gout[n*2187+1503] += + s[801];
gout[n*2187+1504] += + s[802];
gout[n*2187+1505] += + s[803];
gout[n*2187+1506] += + s[804];
gout[n*2187+1507] += + s[805];
gout[n*2187+1508] += + s[806];
gout[n*2187+1509] += + s[807];
gout[n*2187+1510] += + s[808];
gout[n*2187+1511] += + s[809];
gout[n*2187+1512] += + s[1512];
gout[n*2187+1513] += + s[1513];
gout[n*2187+1514] += + s[1514];
gout[n*2187+1515] += + s[1515];
gout[n*2187+1516] += + s[1516];
gout[n*2187+1517] += + s[1517];
gout[n*2187+1518] += + s[1518];
gout[n*2187+1519] += + s[1519];
gout[n*2187+1520] += + s[1520];
gout[n*2187+1521] += + s[1521];
gout[n*2187+1522] += + s[1522];
gout[n*2187+1523] += + s[1523];
gout[n*2187+1524] += + s[1524];
gout[n*2187+1525] += + s[1525];
gout[n*2187+1526] += + s[1526];
gout[n*2187+1527] += + s[1527];
gout[n*2187+1528] += + s[1528];
gout[n*2187+1529] += + s[1529];
gout[n*2187+1530] += + s[1530];
gout[n*2187+1531] += + s[1531];
gout[n*2187+1532] += + s[1532];
gout[n*2187+1533] += + s[1533];
gout[n*2187+1534] += + s[1534];
gout[n*2187+1535] += + s[1535];
gout[n*2187+1536] += + s[1536];
gout[n*2187+1537] += + s[1537];
gout[n*2187+1538] += + s[1538];
gout[n*2187+1539] += + s[297];
gout[n*2187+1540] += + s[298];
gout[n*2187+1541] += + s[299];
gout[n*2187+1542] += + s[300];
gout[n*2187+1543] += + s[301];
gout[n*2187+1544] += + s[302];
gout[n*2187+1545] += + s[303];
gout[n*2187+1546] += + s[304];
gout[n*2187+1547] += + s[305];
gout[n*2187+1548] += + s[306];
gout[n*2187+1549] += + s[307];
gout[n*2187+1550] += + s[308];
gout[n*2187+1551] += + s[309];
gout[n*2187+1552] += + s[310];
gout[n*2187+1553] += + s[311];
gout[n*2187+1554] += + s[312];
gout[n*2187+1555] += + s[313];
gout[n*2187+1556] += + s[314];
gout[n*2187+1557] += + s[315];
gout[n*2187+1558] += + s[316];
gout[n*2187+1559] += + s[317];
gout[n*2187+1560] += + s[318];
gout[n*2187+1561] += + s[319];
gout[n*2187+1562] += + s[320];
gout[n*2187+1563] += + s[321];
gout[n*2187+1564] += + s[322];
gout[n*2187+1565] += + s[323];
gout[n*2187+1566] += + s[1026];
gout[n*2187+1567] += + s[1027];
gout[n*2187+1568] += + s[1028];
gout[n*2187+1569] += + s[1029];
gout[n*2187+1570] += + s[1030];
gout[n*2187+1571] += + s[1031];
gout[n*2187+1572] += + s[1032];
gout[n*2187+1573] += + s[1033];
gout[n*2187+1574] += + s[1034];
gout[n*2187+1575] += + s[1035];
gout[n*2187+1576] += + s[1036];
gout[n*2187+1577] += + s[1037];
gout[n*2187+1578] += + s[1038];
gout[n*2187+1579] += + s[1039];
gout[n*2187+1580] += + s[1040];
gout[n*2187+1581] += + s[1041];
gout[n*2187+1582] += + s[1042];
gout[n*2187+1583] += + s[1043];
gout[n*2187+1584] += + s[1044];
gout[n*2187+1585] += + s[1045];
gout[n*2187+1586] += + s[1046];
gout[n*2187+1587] += + s[1047];
gout[n*2187+1588] += + s[1048];
gout[n*2187+1589] += + s[1049];
gout[n*2187+1590] += + s[1050];
gout[n*2187+1591] += + s[1051];
gout[n*2187+1592] += + s[1052];
gout[n*2187+1593] += + s[1755];
gout[n*2187+1594] += + s[1756];
gout[n*2187+1595] += + s[1757];
gout[n*2187+1596] += + s[1758];
gout[n*2187+1597] += + s[1759];
gout[n*2187+1598] += + s[1760];
gout[n*2187+1599] += + s[1761];
gout[n*2187+1600] += + s[1762];
gout[n*2187+1601] += + s[1763];
gout[n*2187+1602] += + s[1764];
gout[n*2187+1603] += + s[1765];
gout[n*2187+1604] += + s[1766];
gout[n*2187+1605] += + s[1767];
gout[n*2187+1606] += + s[1768];
gout[n*2187+1607] += + s[1769];
gout[n*2187+1608] += + s[1770];
gout[n*2187+1609] += + s[1771];
gout[n*2187+1610] += + s[1772];
gout[n*2187+1611] += + s[1773];
gout[n*2187+1612] += + s[1774];
gout[n*2187+1613] += + s[1775];
gout[n*2187+1614] += + s[1776];
gout[n*2187+1615] += + s[1777];
gout[n*2187+1616] += + s[1778];
gout[n*2187+1617] += + s[1779];
gout[n*2187+1618] += + s[1780];
gout[n*2187+1619] += + s[1781];
gout[n*2187+1620] += + s[540];
gout[n*2187+1621] += + s[541];
gout[n*2187+1622] += + s[542];
gout[n*2187+1623] += + s[543];
gout[n*2187+1624] += + s[544];
gout[n*2187+1625] += + s[545];
gout[n*2187+1626] += + s[546];
gout[n*2187+1627] += + s[547];
gout[n*2187+1628] += + s[548];
gout[n*2187+1629] += + s[549];
gout[n*2187+1630] += + s[550];
gout[n*2187+1631] += + s[551];
gout[n*2187+1632] += + s[552];
gout[n*2187+1633] += + s[553];
gout[n*2187+1634] += + s[554];
gout[n*2187+1635] += + s[555];
gout[n*2187+1636] += + s[556];
gout[n*2187+1637] += + s[557];
gout[n*2187+1638] += + s[558];
gout[n*2187+1639] += + s[559];
gout[n*2187+1640] += + s[560];
gout[n*2187+1641] += + s[561];
gout[n*2187+1642] += + s[562];
gout[n*2187+1643] += + s[563];
gout[n*2187+1644] += + s[564];
gout[n*2187+1645] += + s[565];
gout[n*2187+1646] += + s[566];
gout[n*2187+1647] += + s[1269];
gout[n*2187+1648] += + s[1270];
gout[n*2187+1649] += + s[1271];
gout[n*2187+1650] += + s[1272];
gout[n*2187+1651] += + s[1273];
gout[n*2187+1652] += + s[1274];
gout[n*2187+1653] += + s[1275];
gout[n*2187+1654] += + s[1276];
gout[n*2187+1655] += + s[1277];
gout[n*2187+1656] += + s[1278];
gout[n*2187+1657] += + s[1279];
gout[n*2187+1658] += + s[1280];
gout[n*2187+1659] += + s[1281];
gout[n*2187+1660] += + s[1282];
gout[n*2187+1661] += + s[1283];
gout[n*2187+1662] += + s[1284];
gout[n*2187+1663] += + s[1285];
gout[n*2187+1664] += + s[1286];
gout[n*2187+1665] += + s[1287];
gout[n*2187+1666] += + s[1288];
gout[n*2187+1667] += + s[1289];
gout[n*2187+1668] += + s[1290];
gout[n*2187+1669] += + s[1291];
gout[n*2187+1670] += + s[1292];
gout[n*2187+1671] += + s[1293];
gout[n*2187+1672] += + s[1294];
gout[n*2187+1673] += + s[1295];
gout[n*2187+1674] += + s[1998];
gout[n*2187+1675] += + s[1999];
gout[n*2187+1676] += + s[2000];
gout[n*2187+1677] += + s[2001];
gout[n*2187+1678] += + s[2002];
gout[n*2187+1679] += + s[2003];
gout[n*2187+1680] += + s[2004];
gout[n*2187+1681] += + s[2005];
gout[n*2187+1682] += + s[2006];
gout[n*2187+1683] += + s[2007];
gout[n*2187+1684] += + s[2008];
gout[n*2187+1685] += + s[2009];
gout[n*2187+1686] += + s[2010];
gout[n*2187+1687] += + s[2011];
gout[n*2187+1688] += + s[2012];
gout[n*2187+1689] += + s[2013];
gout[n*2187+1690] += + s[2014];
gout[n*2187+1691] += + s[2015];
gout[n*2187+1692] += + s[2016];
gout[n*2187+1693] += + s[2017];
gout[n*2187+1694] += + s[2018];
gout[n*2187+1695] += + s[2019];
gout[n*2187+1696] += + s[2020];
gout[n*2187+1697] += + s[2021];
gout[n*2187+1698] += + s[2022];
gout[n*2187+1699] += + s[2023];
gout[n*2187+1700] += + s[2024];
gout[n*2187+1701] += + s[135];
gout[n*2187+1702] += + s[136];
gout[n*2187+1703] += + s[137];
gout[n*2187+1704] += + s[138];
gout[n*2187+1705] += + s[139];
gout[n*2187+1706] += + s[140];
gout[n*2187+1707] += + s[141];
gout[n*2187+1708] += + s[142];
gout[n*2187+1709] += + s[143];
gout[n*2187+1710] += + s[144];
gout[n*2187+1711] += + s[145];
gout[n*2187+1712] += + s[146];
gout[n*2187+1713] += + s[147];
gout[n*2187+1714] += + s[148];
gout[n*2187+1715] += + s[149];
gout[n*2187+1716] += + s[150];
gout[n*2187+1717] += + s[151];
gout[n*2187+1718] += + s[152];
gout[n*2187+1719] += + s[153];
gout[n*2187+1720] += + s[154];
gout[n*2187+1721] += + s[155];
gout[n*2187+1722] += + s[156];
gout[n*2187+1723] += + s[157];
gout[n*2187+1724] += + s[158];
gout[n*2187+1725] += + s[159];
gout[n*2187+1726] += + s[160];
gout[n*2187+1727] += + s[161];
gout[n*2187+1728] += + s[864];
gout[n*2187+1729] += + s[865];
gout[n*2187+1730] += + s[866];
gout[n*2187+1731] += + s[867];
gout[n*2187+1732] += + s[868];
gout[n*2187+1733] += + s[869];
gout[n*2187+1734] += + s[870];
gout[n*2187+1735] += + s[871];
gout[n*2187+1736] += + s[872];
gout[n*2187+1737] += + s[873];
gout[n*2187+1738] += + s[874];
gout[n*2187+1739] += + s[875];
gout[n*2187+1740] += + s[876];
gout[n*2187+1741] += + s[877];
gout[n*2187+1742] += + s[878];
gout[n*2187+1743] += + s[879];
gout[n*2187+1744] += + s[880];
gout[n*2187+1745] += + s[881];
gout[n*2187+1746] += + s[882];
gout[n*2187+1747] += + s[883];
gout[n*2187+1748] += + s[884];
gout[n*2187+1749] += + s[885];
gout[n*2187+1750] += + s[886];
gout[n*2187+1751] += + s[887];
gout[n*2187+1752] += + s[888];
gout[n*2187+1753] += + s[889];
gout[n*2187+1754] += + s[890];
gout[n*2187+1755] += + s[1593];
gout[n*2187+1756] += + s[1594];
gout[n*2187+1757] += + s[1595];
gout[n*2187+1758] += + s[1596];
gout[n*2187+1759] += + s[1597];
gout[n*2187+1760] += + s[1598];
gout[n*2187+1761] += + s[1599];
gout[n*2187+1762] += + s[1600];
gout[n*2187+1763] += + s[1601];
gout[n*2187+1764] += + s[1602];
gout[n*2187+1765] += + s[1603];
gout[n*2187+1766] += + s[1604];
gout[n*2187+1767] += + s[1605];
gout[n*2187+1768] += + s[1606];
gout[n*2187+1769] += + s[1607];
gout[n*2187+1770] += + s[1608];
gout[n*2187+1771] += + s[1609];
gout[n*2187+1772] += + s[1610];
gout[n*2187+1773] += + s[1611];
gout[n*2187+1774] += + s[1612];
gout[n*2187+1775] += + s[1613];
gout[n*2187+1776] += + s[1614];
gout[n*2187+1777] += + s[1615];
gout[n*2187+1778] += + s[1616];
gout[n*2187+1779] += + s[1617];
gout[n*2187+1780] += + s[1618];
gout[n*2187+1781] += + s[1619];
gout[n*2187+1782] += + s[378];
gout[n*2187+1783] += + s[379];
gout[n*2187+1784] += + s[380];
gout[n*2187+1785] += + s[381];
gout[n*2187+1786] += + s[382];
gout[n*2187+1787] += + s[383];
gout[n*2187+1788] += + s[384];
gout[n*2187+1789] += + s[385];
gout[n*2187+1790] += + s[386];
gout[n*2187+1791] += + s[387];
gout[n*2187+1792] += + s[388];
gout[n*2187+1793] += + s[389];
gout[n*2187+1794] += + s[390];
gout[n*2187+1795] += + s[391];
gout[n*2187+1796] += + s[392];
gout[n*2187+1797] += + s[393];
gout[n*2187+1798] += + s[394];
gout[n*2187+1799] += + s[395];
gout[n*2187+1800] += + s[396];
gout[n*2187+1801] += + s[397];
gout[n*2187+1802] += + s[398];
gout[n*2187+1803] += + s[399];
gout[n*2187+1804] += + s[400];
gout[n*2187+1805] += + s[401];
gout[n*2187+1806] += + s[402];
gout[n*2187+1807] += + s[403];
gout[n*2187+1808] += + s[404];
gout[n*2187+1809] += + s[1107];
gout[n*2187+1810] += + s[1108];
gout[n*2187+1811] += + s[1109];
gout[n*2187+1812] += + s[1110];
gout[n*2187+1813] += + s[1111];
gout[n*2187+1814] += + s[1112];
gout[n*2187+1815] += + s[1113];
gout[n*2187+1816] += + s[1114];
gout[n*2187+1817] += + s[1115];
gout[n*2187+1818] += + s[1116];
gout[n*2187+1819] += + s[1117];
gout[n*2187+1820] += + s[1118];
gout[n*2187+1821] += + s[1119];
gout[n*2187+1822] += + s[1120];
gout[n*2187+1823] += + s[1121];
gout[n*2187+1824] += + s[1122];
gout[n*2187+1825] += + s[1123];
gout[n*2187+1826] += + s[1124];
gout[n*2187+1827] += + s[1125];
gout[n*2187+1828] += + s[1126];
gout[n*2187+1829] += + s[1127];
gout[n*2187+1830] += + s[1128];
gout[n*2187+1831] += + s[1129];
gout[n*2187+1832] += + s[1130];
gout[n*2187+1833] += + s[1131];
gout[n*2187+1834] += + s[1132];
gout[n*2187+1835] += + s[1133];
gout[n*2187+1836] += + s[1836];
gout[n*2187+1837] += + s[1837];
gout[n*2187+1838] += + s[1838];
gout[n*2187+1839] += + s[1839];
gout[n*2187+1840] += + s[1840];
gout[n*2187+1841] += + s[1841];
gout[n*2187+1842] += + s[1842];
gout[n*2187+1843] += + s[1843];
gout[n*2187+1844] += + s[1844];
gout[n*2187+1845] += + s[1845];
gout[n*2187+1846] += + s[1846];
gout[n*2187+1847] += + s[1847];
gout[n*2187+1848] += + s[1848];
gout[n*2187+1849] += + s[1849];
gout[n*2187+1850] += + s[1850];
gout[n*2187+1851] += + s[1851];
gout[n*2187+1852] += + s[1852];
gout[n*2187+1853] += + s[1853];
gout[n*2187+1854] += + s[1854];
gout[n*2187+1855] += + s[1855];
gout[n*2187+1856] += + s[1856];
gout[n*2187+1857] += + s[1857];
gout[n*2187+1858] += + s[1858];
gout[n*2187+1859] += + s[1859];
gout[n*2187+1860] += + s[1860];
gout[n*2187+1861] += + s[1861];
gout[n*2187+1862] += + s[1862];
gout[n*2187+1863] += + s[621];
gout[n*2187+1864] += + s[622];
gout[n*2187+1865] += + s[623];
gout[n*2187+1866] += + s[624];
gout[n*2187+1867] += + s[625];
gout[n*2187+1868] += + s[626];
gout[n*2187+1869] += + s[627];
gout[n*2187+1870] += + s[628];
gout[n*2187+1871] += + s[629];
gout[n*2187+1872] += + s[630];
gout[n*2187+1873] += + s[631];
gout[n*2187+1874] += + s[632];
gout[n*2187+1875] += + s[633];
gout[n*2187+1876] += + s[634];
gout[n*2187+1877] += + s[635];
gout[n*2187+1878] += + s[636];
gout[n*2187+1879] += + s[637];
gout[n*2187+1880] += + s[638];
gout[n*2187+1881] += + s[639];
gout[n*2187+1882] += + s[640];
gout[n*2187+1883] += + s[641];
gout[n*2187+1884] += + s[642];
gout[n*2187+1885] += + s[643];
gout[n*2187+1886] += + s[644];
gout[n*2187+1887] += + s[645];
gout[n*2187+1888] += + s[646];
gout[n*2187+1889] += + s[647];
gout[n*2187+1890] += + s[1350];
gout[n*2187+1891] += + s[1351];
gout[n*2187+1892] += + s[1352];
gout[n*2187+1893] += + s[1353];
gout[n*2187+1894] += + s[1354];
gout[n*2187+1895] += + s[1355];
gout[n*2187+1896] += + s[1356];
gout[n*2187+1897] += + s[1357];
gout[n*2187+1898] += + s[1358];
gout[n*2187+1899] += + s[1359];
gout[n*2187+1900] += + s[1360];
gout[n*2187+1901] += + s[1361];
gout[n*2187+1902] += + s[1362];
gout[n*2187+1903] += + s[1363];
gout[n*2187+1904] += + s[1364];
gout[n*2187+1905] += + s[1365];
gout[n*2187+1906] += + s[1366];
gout[n*2187+1907] += + s[1367];
gout[n*2187+1908] += + s[1368];
gout[n*2187+1909] += + s[1369];
gout[n*2187+1910] += + s[1370];
gout[n*2187+1911] += + s[1371];
gout[n*2187+1912] += + s[1372];
gout[n*2187+1913] += + s[1373];
gout[n*2187+1914] += + s[1374];
gout[n*2187+1915] += + s[1375];
gout[n*2187+1916] += + s[1376];
gout[n*2187+1917] += + s[2079];
gout[n*2187+1918] += + s[2080];
gout[n*2187+1919] += + s[2081];
gout[n*2187+1920] += + s[2082];
gout[n*2187+1921] += + s[2083];
gout[n*2187+1922] += + s[2084];
gout[n*2187+1923] += + s[2085];
gout[n*2187+1924] += + s[2086];
gout[n*2187+1925] += + s[2087];
gout[n*2187+1926] += + s[2088];
gout[n*2187+1927] += + s[2089];
gout[n*2187+1928] += + s[2090];
gout[n*2187+1929] += + s[2091];
gout[n*2187+1930] += + s[2092];
gout[n*2187+1931] += + s[2093];
gout[n*2187+1932] += + s[2094];
gout[n*2187+1933] += + s[2095];
gout[n*2187+1934] += + s[2096];
gout[n*2187+1935] += + s[2097];
gout[n*2187+1936] += + s[2098];
gout[n*2187+1937] += + s[2099];
gout[n*2187+1938] += + s[2100];
gout[n*2187+1939] += + s[2101];
gout[n*2187+1940] += + s[2102];
gout[n*2187+1941] += + s[2103];
gout[n*2187+1942] += + s[2104];
gout[n*2187+1943] += + s[2105];
gout[n*2187+1944] += + s[216];
gout[n*2187+1945] += + s[217];
gout[n*2187+1946] += + s[218];
gout[n*2187+1947] += + s[219];
gout[n*2187+1948] += + s[220];
gout[n*2187+1949] += + s[221];
gout[n*2187+1950] += + s[222];
gout[n*2187+1951] += + s[223];
gout[n*2187+1952] += + s[224];
gout[n*2187+1953] += + s[225];
gout[n*2187+1954] += + s[226];
gout[n*2187+1955] += + s[227];
gout[n*2187+1956] += + s[228];
gout[n*2187+1957] += + s[229];
gout[n*2187+1958] += + s[230];
gout[n*2187+1959] += + s[231];
gout[n*2187+1960] += + s[232];
gout[n*2187+1961] += + s[233];
gout[n*2187+1962] += + s[234];
gout[n*2187+1963] += + s[235];
gout[n*2187+1964] += + s[236];
gout[n*2187+1965] += + s[237];
gout[n*2187+1966] += + s[238];
gout[n*2187+1967] += + s[239];
gout[n*2187+1968] += + s[240];
gout[n*2187+1969] += + s[241];
gout[n*2187+1970] += + s[242];
gout[n*2187+1971] += + s[945];
gout[n*2187+1972] += + s[946];
gout[n*2187+1973] += + s[947];
gout[n*2187+1974] += + s[948];
gout[n*2187+1975] += + s[949];
gout[n*2187+1976] += + s[950];
gout[n*2187+1977] += + s[951];
gout[n*2187+1978] += + s[952];
gout[n*2187+1979] += + s[953];
gout[n*2187+1980] += + s[954];
gout[n*2187+1981] += + s[955];
gout[n*2187+1982] += + s[956];
gout[n*2187+1983] += + s[957];
gout[n*2187+1984] += + s[958];
gout[n*2187+1985] += + s[959];
gout[n*2187+1986] += + s[960];
gout[n*2187+1987] += + s[961];
gout[n*2187+1988] += + s[962];
gout[n*2187+1989] += + s[963];
gout[n*2187+1990] += + s[964];
gout[n*2187+1991] += + s[965];
gout[n*2187+1992] += + s[966];
gout[n*2187+1993] += + s[967];
gout[n*2187+1994] += + s[968];
gout[n*2187+1995] += + s[969];
gout[n*2187+1996] += + s[970];
gout[n*2187+1997] += + s[971];
gout[n*2187+1998] += + s[1674];
gout[n*2187+1999] += + s[1675];
gout[n*2187+2000] += + s[1676];
gout[n*2187+2001] += + s[1677];
gout[n*2187+2002] += + s[1678];
gout[n*2187+2003] += + s[1679];
gout[n*2187+2004] += + s[1680];
gout[n*2187+2005] += + s[1681];
gout[n*2187+2006] += + s[1682];
gout[n*2187+2007] += + s[1683];
gout[n*2187+2008] += + s[1684];
gout[n*2187+2009] += + s[1685];
gout[n*2187+2010] += + s[1686];
gout[n*2187+2011] += + s[1687];
gout[n*2187+2012] += + s[1688];
gout[n*2187+2013] += + s[1689];
gout[n*2187+2014] += + s[1690];
gout[n*2187+2015] += + s[1691];
gout[n*2187+2016] += + s[1692];
gout[n*2187+2017] += + s[1693];
gout[n*2187+2018] += + s[1694];
gout[n*2187+2019] += + s[1695];
gout[n*2187+2020] += + s[1696];
gout[n*2187+2021] += + s[1697];
gout[n*2187+2022] += + s[1698];
gout[n*2187+2023] += + s[1699];
gout[n*2187+2024] += + s[1700];
gout[n*2187+2025] += + s[459];
gout[n*2187+2026] += + s[460];
gout[n*2187+2027] += + s[461];
gout[n*2187+2028] += + s[462];
gout[n*2187+2029] += + s[463];
gout[n*2187+2030] += + s[464];
gout[n*2187+2031] += + s[465];
gout[n*2187+2032] += + s[466];
gout[n*2187+2033] += + s[467];
gout[n*2187+2034] += + s[468];
gout[n*2187+2035] += + s[469];
gout[n*2187+2036] += + s[470];
gout[n*2187+2037] += + s[471];
gout[n*2187+2038] += + s[472];
gout[n*2187+2039] += + s[473];
gout[n*2187+2040] += + s[474];
gout[n*2187+2041] += + s[475];
gout[n*2187+2042] += + s[476];
gout[n*2187+2043] += + s[477];
gout[n*2187+2044] += + s[478];
gout[n*2187+2045] += + s[479];
gout[n*2187+2046] += + s[480];
gout[n*2187+2047] += + s[481];
gout[n*2187+2048] += + s[482];
gout[n*2187+2049] += + s[483];
gout[n*2187+2050] += + s[484];
gout[n*2187+2051] += + s[485];
gout[n*2187+2052] += + s[1188];
gout[n*2187+2053] += + s[1189];
gout[n*2187+2054] += + s[1190];
gout[n*2187+2055] += + s[1191];
gout[n*2187+2056] += + s[1192];
gout[n*2187+2057] += + s[1193];
gout[n*2187+2058] += + s[1194];
gout[n*2187+2059] += + s[1195];
gout[n*2187+2060] += + s[1196];
gout[n*2187+2061] += + s[1197];
gout[n*2187+2062] += + s[1198];
gout[n*2187+2063] += + s[1199];
gout[n*2187+2064] += + s[1200];
gout[n*2187+2065] += + s[1201];
gout[n*2187+2066] += + s[1202];
gout[n*2187+2067] += + s[1203];
gout[n*2187+2068] += + s[1204];
gout[n*2187+2069] += + s[1205];
gout[n*2187+2070] += + s[1206];
gout[n*2187+2071] += + s[1207];
gout[n*2187+2072] += + s[1208];
gout[n*2187+2073] += + s[1209];
gout[n*2187+2074] += + s[1210];
gout[n*2187+2075] += + s[1211];
gout[n*2187+2076] += + s[1212];
gout[n*2187+2077] += + s[1213];
gout[n*2187+2078] += + s[1214];
gout[n*2187+2079] += + s[1917];
gout[n*2187+2080] += + s[1918];
gout[n*2187+2081] += + s[1919];
gout[n*2187+2082] += + s[1920];
gout[n*2187+2083] += + s[1921];
gout[n*2187+2084] += + s[1922];
gout[n*2187+2085] += + s[1923];
gout[n*2187+2086] += + s[1924];
gout[n*2187+2087] += + s[1925];
gout[n*2187+2088] += + s[1926];
gout[n*2187+2089] += + s[1927];
gout[n*2187+2090] += + s[1928];
gout[n*2187+2091] += + s[1929];
gout[n*2187+2092] += + s[1930];
gout[n*2187+2093] += + s[1931];
gout[n*2187+2094] += + s[1932];
gout[n*2187+2095] += + s[1933];
gout[n*2187+2096] += + s[1934];
gout[n*2187+2097] += + s[1935];
gout[n*2187+2098] += + s[1936];
gout[n*2187+2099] += + s[1937];
gout[n*2187+2100] += + s[1938];
gout[n*2187+2101] += + s[1939];
gout[n*2187+2102] += + s[1940];
gout[n*2187+2103] += + s[1941];
gout[n*2187+2104] += + s[1942];
gout[n*2187+2105] += + s[1943];
gout[n*2187+2106] += + s[702];
gout[n*2187+2107] += + s[703];
gout[n*2187+2108] += + s[704];
gout[n*2187+2109] += + s[705];
gout[n*2187+2110] += + s[706];
gout[n*2187+2111] += + s[707];
gout[n*2187+2112] += + s[708];
gout[n*2187+2113] += + s[709];
gout[n*2187+2114] += + s[710];
gout[n*2187+2115] += + s[711];
gout[n*2187+2116] += + s[712];
gout[n*2187+2117] += + s[713];
gout[n*2187+2118] += + s[714];
gout[n*2187+2119] += + s[715];
gout[n*2187+2120] += + s[716];
gout[n*2187+2121] += + s[717];
gout[n*2187+2122] += + s[718];
gout[n*2187+2123] += + s[719];
gout[n*2187+2124] += + s[720];
gout[n*2187+2125] += + s[721];
gout[n*2187+2126] += + s[722];
gout[n*2187+2127] += + s[723];
gout[n*2187+2128] += + s[724];
gout[n*2187+2129] += + s[725];
gout[n*2187+2130] += + s[726];
gout[n*2187+2131] += + s[727];
gout[n*2187+2132] += + s[728];
gout[n*2187+2133] += + s[1431];
gout[n*2187+2134] += + s[1432];
gout[n*2187+2135] += + s[1433];
gout[n*2187+2136] += + s[1434];
gout[n*2187+2137] += + s[1435];
gout[n*2187+2138] += + s[1436];
gout[n*2187+2139] += + s[1437];
gout[n*2187+2140] += + s[1438];
gout[n*2187+2141] += + s[1439];
gout[n*2187+2142] += + s[1440];
gout[n*2187+2143] += + s[1441];
gout[n*2187+2144] += + s[1442];
gout[n*2187+2145] += + s[1443];
gout[n*2187+2146] += + s[1444];
gout[n*2187+2147] += + s[1445];
gout[n*2187+2148] += + s[1446];
gout[n*2187+2149] += + s[1447];
gout[n*2187+2150] += + s[1448];
gout[n*2187+2151] += + s[1449];
gout[n*2187+2152] += + s[1450];
gout[n*2187+2153] += + s[1451];
gout[n*2187+2154] += + s[1452];
gout[n*2187+2155] += + s[1453];
gout[n*2187+2156] += + s[1454];
gout[n*2187+2157] += + s[1455];
gout[n*2187+2158] += + s[1456];
gout[n*2187+2159] += + s[1457];
gout[n*2187+2160] += + s[2160];
gout[n*2187+2161] += + s[2161];
gout[n*2187+2162] += + s[2162];
gout[n*2187+2163] += + s[2163];
gout[n*2187+2164] += + s[2164];
gout[n*2187+2165] += + s[2165];
gout[n*2187+2166] += + s[2166];
gout[n*2187+2167] += + s[2167];
gout[n*2187+2168] += + s[2168];
gout[n*2187+2169] += + s[2169];
gout[n*2187+2170] += + s[2170];
gout[n*2187+2171] += + s[2171];
gout[n*2187+2172] += + s[2172];
gout[n*2187+2173] += + s[2173];
gout[n*2187+2174] += + s[2174];
gout[n*2187+2175] += + s[2175];
gout[n*2187+2176] += + s[2176];
gout[n*2187+2177] += + s[2177];
gout[n*2187+2178] += + s[2178];
gout[n*2187+2179] += + s[2179];
gout[n*2187+2180] += + s[2180];
gout[n*2187+2181] += + s[2181];
gout[n*2187+2182] += + s[2182];
gout[n*2187+2183] += + s[2183];
gout[n*2187+2184] += + s[2184];
gout[n*2187+2185] += + s[2185];
gout[n*2187+2186] += + s[2186];
}}}
void int1e_ipipipipmmm_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 2187};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipipmmm_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipmmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipipmmm_cart
CACHE_SIZE_T int1e_ipipipipmmm_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipmmm;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipipmmm_sph
CACHE_SIZE_T int1e_ipipipipmmm_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipmmm;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipipmmm_spinor
ALL_CINT1E(int1e_ipipipipmmm)
ALL_CINT1E_FORTRAN_(int1e_ipipipipmmm)
/* <NABLA i|RI RI RI |NABLA j> */
void CINTgout1e_int1e_ipmmmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipmmmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmmmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmmmip_cart
CACHE_SIZE_T int1e_ipmmmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmmmip_sph
CACHE_SIZE_T int1e_ipmmmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmmmip_spinor
ALL_CINT1E(int1e_ipmmmip)
ALL_CINT1E_FORTRAN_(int1e_ipmmmip)
/* <NABLA i|RI RI RI |NABLA NABLA j> */
void CINTgout1e_int1e_ipmmmipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+1, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g20, g16, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g28, g24, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipmmmipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipmmmipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipmmmipip_cart
CACHE_SIZE_T int1e_ipmmmipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipmmmipip_sph
CACHE_SIZE_T int1e_ipmmmipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipmmmipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipmmmipip_spinor
ALL_CINT1E(int1e_ipmmmipip)
ALL_CINT1E_FORTRAN_(int1e_ipmmmipip)
/* <NABLA NABLA i|RI RI RI |NABLA j> */
void CINTgout1e_int1e_ipipmmmip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+2, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[243];
gout[n*729+82] = + s[244];
gout[n*729+83] = + s[245];
gout[n*729+84] = + s[246];
gout[n*729+85] = + s[247];
gout[n*729+86] = + s[248];
gout[n*729+87] = + s[249];
gout[n*729+88] = + s[250];
gout[n*729+89] = + s[251];
gout[n*729+90] = + s[252];
gout[n*729+91] = + s[253];
gout[n*729+92] = + s[254];
gout[n*729+93] = + s[255];
gout[n*729+94] = + s[256];
gout[n*729+95] = + s[257];
gout[n*729+96] = + s[258];
gout[n*729+97] = + s[259];
gout[n*729+98] = + s[260];
gout[n*729+99] = + s[261];
gout[n*729+100] = + s[262];
gout[n*729+101] = + s[263];
gout[n*729+102] = + s[264];
gout[n*729+103] = + s[265];
gout[n*729+104] = + s[266];
gout[n*729+105] = + s[267];
gout[n*729+106] = + s[268];
gout[n*729+107] = + s[269];
gout[n*729+108] = + s[270];
gout[n*729+109] = + s[271];
gout[n*729+110] = + s[272];
gout[n*729+111] = + s[273];
gout[n*729+112] = + s[274];
gout[n*729+113] = + s[275];
gout[n*729+114] = + s[276];
gout[n*729+115] = + s[277];
gout[n*729+116] = + s[278];
gout[n*729+117] = + s[279];
gout[n*729+118] = + s[280];
gout[n*729+119] = + s[281];
gout[n*729+120] = + s[282];
gout[n*729+121] = + s[283];
gout[n*729+122] = + s[284];
gout[n*729+123] = + s[285];
gout[n*729+124] = + s[286];
gout[n*729+125] = + s[287];
gout[n*729+126] = + s[288];
gout[n*729+127] = + s[289];
gout[n*729+128] = + s[290];
gout[n*729+129] = + s[291];
gout[n*729+130] = + s[292];
gout[n*729+131] = + s[293];
gout[n*729+132] = + s[294];
gout[n*729+133] = + s[295];
gout[n*729+134] = + s[296];
gout[n*729+135] = + s[297];
gout[n*729+136] = + s[298];
gout[n*729+137] = + s[299];
gout[n*729+138] = + s[300];
gout[n*729+139] = + s[301];
gout[n*729+140] = + s[302];
gout[n*729+141] = + s[303];
gout[n*729+142] = + s[304];
gout[n*729+143] = + s[305];
gout[n*729+144] = + s[306];
gout[n*729+145] = + s[307];
gout[n*729+146] = + s[308];
gout[n*729+147] = + s[309];
gout[n*729+148] = + s[310];
gout[n*729+149] = + s[311];
gout[n*729+150] = + s[312];
gout[n*729+151] = + s[313];
gout[n*729+152] = + s[314];
gout[n*729+153] = + s[315];
gout[n*729+154] = + s[316];
gout[n*729+155] = + s[317];
gout[n*729+156] = + s[318];
gout[n*729+157] = + s[319];
gout[n*729+158] = + s[320];
gout[n*729+159] = + s[321];
gout[n*729+160] = + s[322];
gout[n*729+161] = + s[323];
gout[n*729+162] = + s[486];
gout[n*729+163] = + s[487];
gout[n*729+164] = + s[488];
gout[n*729+165] = + s[489];
gout[n*729+166] = + s[490];
gout[n*729+167] = + s[491];
gout[n*729+168] = + s[492];
gout[n*729+169] = + s[493];
gout[n*729+170] = + s[494];
gout[n*729+171] = + s[495];
gout[n*729+172] = + s[496];
gout[n*729+173] = + s[497];
gout[n*729+174] = + s[498];
gout[n*729+175] = + s[499];
gout[n*729+176] = + s[500];
gout[n*729+177] = + s[501];
gout[n*729+178] = + s[502];
gout[n*729+179] = + s[503];
gout[n*729+180] = + s[504];
gout[n*729+181] = + s[505];
gout[n*729+182] = + s[506];
gout[n*729+183] = + s[507];
gout[n*729+184] = + s[508];
gout[n*729+185] = + s[509];
gout[n*729+186] = + s[510];
gout[n*729+187] = + s[511];
gout[n*729+188] = + s[512];
gout[n*729+189] = + s[513];
gout[n*729+190] = + s[514];
gout[n*729+191] = + s[515];
gout[n*729+192] = + s[516];
gout[n*729+193] = + s[517];
gout[n*729+194] = + s[518];
gout[n*729+195] = + s[519];
gout[n*729+196] = + s[520];
gout[n*729+197] = + s[521];
gout[n*729+198] = + s[522];
gout[n*729+199] = + s[523];
gout[n*729+200] = + s[524];
gout[n*729+201] = + s[525];
gout[n*729+202] = + s[526];
gout[n*729+203] = + s[527];
gout[n*729+204] = + s[528];
gout[n*729+205] = + s[529];
gout[n*729+206] = + s[530];
gout[n*729+207] = + s[531];
gout[n*729+208] = + s[532];
gout[n*729+209] = + s[533];
gout[n*729+210] = + s[534];
gout[n*729+211] = + s[535];
gout[n*729+212] = + s[536];
gout[n*729+213] = + s[537];
gout[n*729+214] = + s[538];
gout[n*729+215] = + s[539];
gout[n*729+216] = + s[540];
gout[n*729+217] = + s[541];
gout[n*729+218] = + s[542];
gout[n*729+219] = + s[543];
gout[n*729+220] = + s[544];
gout[n*729+221] = + s[545];
gout[n*729+222] = + s[546];
gout[n*729+223] = + s[547];
gout[n*729+224] = + s[548];
gout[n*729+225] = + s[549];
gout[n*729+226] = + s[550];
gout[n*729+227] = + s[551];
gout[n*729+228] = + s[552];
gout[n*729+229] = + s[553];
gout[n*729+230] = + s[554];
gout[n*729+231] = + s[555];
gout[n*729+232] = + s[556];
gout[n*729+233] = + s[557];
gout[n*729+234] = + s[558];
gout[n*729+235] = + s[559];
gout[n*729+236] = + s[560];
gout[n*729+237] = + s[561];
gout[n*729+238] = + s[562];
gout[n*729+239] = + s[563];
gout[n*729+240] = + s[564];
gout[n*729+241] = + s[565];
gout[n*729+242] = + s[566];
gout[n*729+243] = + s[81];
gout[n*729+244] = + s[82];
gout[n*729+245] = + s[83];
gout[n*729+246] = + s[84];
gout[n*729+247] = + s[85];
gout[n*729+248] = + s[86];
gout[n*729+249] = + s[87];
gout[n*729+250] = + s[88];
gout[n*729+251] = + s[89];
gout[n*729+252] = + s[90];
gout[n*729+253] = + s[91];
gout[n*729+254] = + s[92];
gout[n*729+255] = + s[93];
gout[n*729+256] = + s[94];
gout[n*729+257] = + s[95];
gout[n*729+258] = + s[96];
gout[n*729+259] = + s[97];
gout[n*729+260] = + s[98];
gout[n*729+261] = + s[99];
gout[n*729+262] = + s[100];
gout[n*729+263] = + s[101];
gout[n*729+264] = + s[102];
gout[n*729+265] = + s[103];
gout[n*729+266] = + s[104];
gout[n*729+267] = + s[105];
gout[n*729+268] = + s[106];
gout[n*729+269] = + s[107];
gout[n*729+270] = + s[108];
gout[n*729+271] = + s[109];
gout[n*729+272] = + s[110];
gout[n*729+273] = + s[111];
gout[n*729+274] = + s[112];
gout[n*729+275] = + s[113];
gout[n*729+276] = + s[114];
gout[n*729+277] = + s[115];
gout[n*729+278] = + s[116];
gout[n*729+279] = + s[117];
gout[n*729+280] = + s[118];
gout[n*729+281] = + s[119];
gout[n*729+282] = + s[120];
gout[n*729+283] = + s[121];
gout[n*729+284] = + s[122];
gout[n*729+285] = + s[123];
gout[n*729+286] = + s[124];
gout[n*729+287] = + s[125];
gout[n*729+288] = + s[126];
gout[n*729+289] = + s[127];
gout[n*729+290] = + s[128];
gout[n*729+291] = + s[129];
gout[n*729+292] = + s[130];
gout[n*729+293] = + s[131];
gout[n*729+294] = + s[132];
gout[n*729+295] = + s[133];
gout[n*729+296] = + s[134];
gout[n*729+297] = + s[135];
gout[n*729+298] = + s[136];
gout[n*729+299] = + s[137];
gout[n*729+300] = + s[138];
gout[n*729+301] = + s[139];
gout[n*729+302] = + s[140];
gout[n*729+303] = + s[141];
gout[n*729+304] = + s[142];
gout[n*729+305] = + s[143];
gout[n*729+306] = + s[144];
gout[n*729+307] = + s[145];
gout[n*729+308] = + s[146];
gout[n*729+309] = + s[147];
gout[n*729+310] = + s[148];
gout[n*729+311] = + s[149];
gout[n*729+312] = + s[150];
gout[n*729+313] = + s[151];
gout[n*729+314] = + s[152];
gout[n*729+315] = + s[153];
gout[n*729+316] = + s[154];
gout[n*729+317] = + s[155];
gout[n*729+318] = + s[156];
gout[n*729+319] = + s[157];
gout[n*729+320] = + s[158];
gout[n*729+321] = + s[159];
gout[n*729+322] = + s[160];
gout[n*729+323] = + s[161];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[567];
gout[n*729+406] = + s[568];
gout[n*729+407] = + s[569];
gout[n*729+408] = + s[570];
gout[n*729+409] = + s[571];
gout[n*729+410] = + s[572];
gout[n*729+411] = + s[573];
gout[n*729+412] = + s[574];
gout[n*729+413] = + s[575];
gout[n*729+414] = + s[576];
gout[n*729+415] = + s[577];
gout[n*729+416] = + s[578];
gout[n*729+417] = + s[579];
gout[n*729+418] = + s[580];
gout[n*729+419] = + s[581];
gout[n*729+420] = + s[582];
gout[n*729+421] = + s[583];
gout[n*729+422] = + s[584];
gout[n*729+423] = + s[585];
gout[n*729+424] = + s[586];
gout[n*729+425] = + s[587];
gout[n*729+426] = + s[588];
gout[n*729+427] = + s[589];
gout[n*729+428] = + s[590];
gout[n*729+429] = + s[591];
gout[n*729+430] = + s[592];
gout[n*729+431] = + s[593];
gout[n*729+432] = + s[594];
gout[n*729+433] = + s[595];
gout[n*729+434] = + s[596];
gout[n*729+435] = + s[597];
gout[n*729+436] = + s[598];
gout[n*729+437] = + s[599];
gout[n*729+438] = + s[600];
gout[n*729+439] = + s[601];
gout[n*729+440] = + s[602];
gout[n*729+441] = + s[603];
gout[n*729+442] = + s[604];
gout[n*729+443] = + s[605];
gout[n*729+444] = + s[606];
gout[n*729+445] = + s[607];
gout[n*729+446] = + s[608];
gout[n*729+447] = + s[609];
gout[n*729+448] = + s[610];
gout[n*729+449] = + s[611];
gout[n*729+450] = + s[612];
gout[n*729+451] = + s[613];
gout[n*729+452] = + s[614];
gout[n*729+453] = + s[615];
gout[n*729+454] = + s[616];
gout[n*729+455] = + s[617];
gout[n*729+456] = + s[618];
gout[n*729+457] = + s[619];
gout[n*729+458] = + s[620];
gout[n*729+459] = + s[621];
gout[n*729+460] = + s[622];
gout[n*729+461] = + s[623];
gout[n*729+462] = + s[624];
gout[n*729+463] = + s[625];
gout[n*729+464] = + s[626];
gout[n*729+465] = + s[627];
gout[n*729+466] = + s[628];
gout[n*729+467] = + s[629];
gout[n*729+468] = + s[630];
gout[n*729+469] = + s[631];
gout[n*729+470] = + s[632];
gout[n*729+471] = + s[633];
gout[n*729+472] = + s[634];
gout[n*729+473] = + s[635];
gout[n*729+474] = + s[636];
gout[n*729+475] = + s[637];
gout[n*729+476] = + s[638];
gout[n*729+477] = + s[639];
gout[n*729+478] = + s[640];
gout[n*729+479] = + s[641];
gout[n*729+480] = + s[642];
gout[n*729+481] = + s[643];
gout[n*729+482] = + s[644];
gout[n*729+483] = + s[645];
gout[n*729+484] = + s[646];
gout[n*729+485] = + s[647];
gout[n*729+486] = + s[162];
gout[n*729+487] = + s[163];
gout[n*729+488] = + s[164];
gout[n*729+489] = + s[165];
gout[n*729+490] = + s[166];
gout[n*729+491] = + s[167];
gout[n*729+492] = + s[168];
gout[n*729+493] = + s[169];
gout[n*729+494] = + s[170];
gout[n*729+495] = + s[171];
gout[n*729+496] = + s[172];
gout[n*729+497] = + s[173];
gout[n*729+498] = + s[174];
gout[n*729+499] = + s[175];
gout[n*729+500] = + s[176];
gout[n*729+501] = + s[177];
gout[n*729+502] = + s[178];
gout[n*729+503] = + s[179];
gout[n*729+504] = + s[180];
gout[n*729+505] = + s[181];
gout[n*729+506] = + s[182];
gout[n*729+507] = + s[183];
gout[n*729+508] = + s[184];
gout[n*729+509] = + s[185];
gout[n*729+510] = + s[186];
gout[n*729+511] = + s[187];
gout[n*729+512] = + s[188];
gout[n*729+513] = + s[189];
gout[n*729+514] = + s[190];
gout[n*729+515] = + s[191];
gout[n*729+516] = + s[192];
gout[n*729+517] = + s[193];
gout[n*729+518] = + s[194];
gout[n*729+519] = + s[195];
gout[n*729+520] = + s[196];
gout[n*729+521] = + s[197];
gout[n*729+522] = + s[198];
gout[n*729+523] = + s[199];
gout[n*729+524] = + s[200];
gout[n*729+525] = + s[201];
gout[n*729+526] = + s[202];
gout[n*729+527] = + s[203];
gout[n*729+528] = + s[204];
gout[n*729+529] = + s[205];
gout[n*729+530] = + s[206];
gout[n*729+531] = + s[207];
gout[n*729+532] = + s[208];
gout[n*729+533] = + s[209];
gout[n*729+534] = + s[210];
gout[n*729+535] = + s[211];
gout[n*729+536] = + s[212];
gout[n*729+537] = + s[213];
gout[n*729+538] = + s[214];
gout[n*729+539] = + s[215];
gout[n*729+540] = + s[216];
gout[n*729+541] = + s[217];
gout[n*729+542] = + s[218];
gout[n*729+543] = + s[219];
gout[n*729+544] = + s[220];
gout[n*729+545] = + s[221];
gout[n*729+546] = + s[222];
gout[n*729+547] = + s[223];
gout[n*729+548] = + s[224];
gout[n*729+549] = + s[225];
gout[n*729+550] = + s[226];
gout[n*729+551] = + s[227];
gout[n*729+552] = + s[228];
gout[n*729+553] = + s[229];
gout[n*729+554] = + s[230];
gout[n*729+555] = + s[231];
gout[n*729+556] = + s[232];
gout[n*729+557] = + s[233];
gout[n*729+558] = + s[234];
gout[n*729+559] = + s[235];
gout[n*729+560] = + s[236];
gout[n*729+561] = + s[237];
gout[n*729+562] = + s[238];
gout[n*729+563] = + s[239];
gout[n*729+564] = + s[240];
gout[n*729+565] = + s[241];
gout[n*729+566] = + s[242];
gout[n*729+567] = + s[405];
gout[n*729+568] = + s[406];
gout[n*729+569] = + s[407];
gout[n*729+570] = + s[408];
gout[n*729+571] = + s[409];
gout[n*729+572] = + s[410];
gout[n*729+573] = + s[411];
gout[n*729+574] = + s[412];
gout[n*729+575] = + s[413];
gout[n*729+576] = + s[414];
gout[n*729+577] = + s[415];
gout[n*729+578] = + s[416];
gout[n*729+579] = + s[417];
gout[n*729+580] = + s[418];
gout[n*729+581] = + s[419];
gout[n*729+582] = + s[420];
gout[n*729+583] = + s[421];
gout[n*729+584] = + s[422];
gout[n*729+585] = + s[423];
gout[n*729+586] = + s[424];
gout[n*729+587] = + s[425];
gout[n*729+588] = + s[426];
gout[n*729+589] = + s[427];
gout[n*729+590] = + s[428];
gout[n*729+591] = + s[429];
gout[n*729+592] = + s[430];
gout[n*729+593] = + s[431];
gout[n*729+594] = + s[432];
gout[n*729+595] = + s[433];
gout[n*729+596] = + s[434];
gout[n*729+597] = + s[435];
gout[n*729+598] = + s[436];
gout[n*729+599] = + s[437];
gout[n*729+600] = + s[438];
gout[n*729+601] = + s[439];
gout[n*729+602] = + s[440];
gout[n*729+603] = + s[441];
gout[n*729+604] = + s[442];
gout[n*729+605] = + s[443];
gout[n*729+606] = + s[444];
gout[n*729+607] = + s[445];
gout[n*729+608] = + s[446];
gout[n*729+609] = + s[447];
gout[n*729+610] = + s[448];
gout[n*729+611] = + s[449];
gout[n*729+612] = + s[450];
gout[n*729+613] = + s[451];
gout[n*729+614] = + s[452];
gout[n*729+615] = + s[453];
gout[n*729+616] = + s[454];
gout[n*729+617] = + s[455];
gout[n*729+618] = + s[456];
gout[n*729+619] = + s[457];
gout[n*729+620] = + s[458];
gout[n*729+621] = + s[459];
gout[n*729+622] = + s[460];
gout[n*729+623] = + s[461];
gout[n*729+624] = + s[462];
gout[n*729+625] = + s[463];
gout[n*729+626] = + s[464];
gout[n*729+627] = + s[465];
gout[n*729+628] = + s[466];
gout[n*729+629] = + s[467];
gout[n*729+630] = + s[468];
gout[n*729+631] = + s[469];
gout[n*729+632] = + s[470];
gout[n*729+633] = + s[471];
gout[n*729+634] = + s[472];
gout[n*729+635] = + s[473];
gout[n*729+636] = + s[474];
gout[n*729+637] = + s[475];
gout[n*729+638] = + s[476];
gout[n*729+639] = + s[477];
gout[n*729+640] = + s[478];
gout[n*729+641] = + s[479];
gout[n*729+642] = + s[480];
gout[n*729+643] = + s[481];
gout[n*729+644] = + s[482];
gout[n*729+645] = + s[483];
gout[n*729+646] = + s[484];
gout[n*729+647] = + s[485];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[243];
gout[n*729+82] += + s[244];
gout[n*729+83] += + s[245];
gout[n*729+84] += + s[246];
gout[n*729+85] += + s[247];
gout[n*729+86] += + s[248];
gout[n*729+87] += + s[249];
gout[n*729+88] += + s[250];
gout[n*729+89] += + s[251];
gout[n*729+90] += + s[252];
gout[n*729+91] += + s[253];
gout[n*729+92] += + s[254];
gout[n*729+93] += + s[255];
gout[n*729+94] += + s[256];
gout[n*729+95] += + s[257];
gout[n*729+96] += + s[258];
gout[n*729+97] += + s[259];
gout[n*729+98] += + s[260];
gout[n*729+99] += + s[261];
gout[n*729+100] += + s[262];
gout[n*729+101] += + s[263];
gout[n*729+102] += + s[264];
gout[n*729+103] += + s[265];
gout[n*729+104] += + s[266];
gout[n*729+105] += + s[267];
gout[n*729+106] += + s[268];
gout[n*729+107] += + s[269];
gout[n*729+108] += + s[270];
gout[n*729+109] += + s[271];
gout[n*729+110] += + s[272];
gout[n*729+111] += + s[273];
gout[n*729+112] += + s[274];
gout[n*729+113] += + s[275];
gout[n*729+114] += + s[276];
gout[n*729+115] += + s[277];
gout[n*729+116] += + s[278];
gout[n*729+117] += + s[279];
gout[n*729+118] += + s[280];
gout[n*729+119] += + s[281];
gout[n*729+120] += + s[282];
gout[n*729+121] += + s[283];
gout[n*729+122] += + s[284];
gout[n*729+123] += + s[285];
gout[n*729+124] += + s[286];
gout[n*729+125] += + s[287];
gout[n*729+126] += + s[288];
gout[n*729+127] += + s[289];
gout[n*729+128] += + s[290];
gout[n*729+129] += + s[291];
gout[n*729+130] += + s[292];
gout[n*729+131] += + s[293];
gout[n*729+132] += + s[294];
gout[n*729+133] += + s[295];
gout[n*729+134] += + s[296];
gout[n*729+135] += + s[297];
gout[n*729+136] += + s[298];
gout[n*729+137] += + s[299];
gout[n*729+138] += + s[300];
gout[n*729+139] += + s[301];
gout[n*729+140] += + s[302];
gout[n*729+141] += + s[303];
gout[n*729+142] += + s[304];
gout[n*729+143] += + s[305];
gout[n*729+144] += + s[306];
gout[n*729+145] += + s[307];
gout[n*729+146] += + s[308];
gout[n*729+147] += + s[309];
gout[n*729+148] += + s[310];
gout[n*729+149] += + s[311];
gout[n*729+150] += + s[312];
gout[n*729+151] += + s[313];
gout[n*729+152] += + s[314];
gout[n*729+153] += + s[315];
gout[n*729+154] += + s[316];
gout[n*729+155] += + s[317];
gout[n*729+156] += + s[318];
gout[n*729+157] += + s[319];
gout[n*729+158] += + s[320];
gout[n*729+159] += + s[321];
gout[n*729+160] += + s[322];
gout[n*729+161] += + s[323];
gout[n*729+162] += + s[486];
gout[n*729+163] += + s[487];
gout[n*729+164] += + s[488];
gout[n*729+165] += + s[489];
gout[n*729+166] += + s[490];
gout[n*729+167] += + s[491];
gout[n*729+168] += + s[492];
gout[n*729+169] += + s[493];
gout[n*729+170] += + s[494];
gout[n*729+171] += + s[495];
gout[n*729+172] += + s[496];
gout[n*729+173] += + s[497];
gout[n*729+174] += + s[498];
gout[n*729+175] += + s[499];
gout[n*729+176] += + s[500];
gout[n*729+177] += + s[501];
gout[n*729+178] += + s[502];
gout[n*729+179] += + s[503];
gout[n*729+180] += + s[504];
gout[n*729+181] += + s[505];
gout[n*729+182] += + s[506];
gout[n*729+183] += + s[507];
gout[n*729+184] += + s[508];
gout[n*729+185] += + s[509];
gout[n*729+186] += + s[510];
gout[n*729+187] += + s[511];
gout[n*729+188] += + s[512];
gout[n*729+189] += + s[513];
gout[n*729+190] += + s[514];
gout[n*729+191] += + s[515];
gout[n*729+192] += + s[516];
gout[n*729+193] += + s[517];
gout[n*729+194] += + s[518];
gout[n*729+195] += + s[519];
gout[n*729+196] += + s[520];
gout[n*729+197] += + s[521];
gout[n*729+198] += + s[522];
gout[n*729+199] += + s[523];
gout[n*729+200] += + s[524];
gout[n*729+201] += + s[525];
gout[n*729+202] += + s[526];
gout[n*729+203] += + s[527];
gout[n*729+204] += + s[528];
gout[n*729+205] += + s[529];
gout[n*729+206] += + s[530];
gout[n*729+207] += + s[531];
gout[n*729+208] += + s[532];
gout[n*729+209] += + s[533];
gout[n*729+210] += + s[534];
gout[n*729+211] += + s[535];
gout[n*729+212] += + s[536];
gout[n*729+213] += + s[537];
gout[n*729+214] += + s[538];
gout[n*729+215] += + s[539];
gout[n*729+216] += + s[540];
gout[n*729+217] += + s[541];
gout[n*729+218] += + s[542];
gout[n*729+219] += + s[543];
gout[n*729+220] += + s[544];
gout[n*729+221] += + s[545];
gout[n*729+222] += + s[546];
gout[n*729+223] += + s[547];
gout[n*729+224] += + s[548];
gout[n*729+225] += + s[549];
gout[n*729+226] += + s[550];
gout[n*729+227] += + s[551];
gout[n*729+228] += + s[552];
gout[n*729+229] += + s[553];
gout[n*729+230] += + s[554];
gout[n*729+231] += + s[555];
gout[n*729+232] += + s[556];
gout[n*729+233] += + s[557];
gout[n*729+234] += + s[558];
gout[n*729+235] += + s[559];
gout[n*729+236] += + s[560];
gout[n*729+237] += + s[561];
gout[n*729+238] += + s[562];
gout[n*729+239] += + s[563];
gout[n*729+240] += + s[564];
gout[n*729+241] += + s[565];
gout[n*729+242] += + s[566];
gout[n*729+243] += + s[81];
gout[n*729+244] += + s[82];
gout[n*729+245] += + s[83];
gout[n*729+246] += + s[84];
gout[n*729+247] += + s[85];
gout[n*729+248] += + s[86];
gout[n*729+249] += + s[87];
gout[n*729+250] += + s[88];
gout[n*729+251] += + s[89];
gout[n*729+252] += + s[90];
gout[n*729+253] += + s[91];
gout[n*729+254] += + s[92];
gout[n*729+255] += + s[93];
gout[n*729+256] += + s[94];
gout[n*729+257] += + s[95];
gout[n*729+258] += + s[96];
gout[n*729+259] += + s[97];
gout[n*729+260] += + s[98];
gout[n*729+261] += + s[99];
gout[n*729+262] += + s[100];
gout[n*729+263] += + s[101];
gout[n*729+264] += + s[102];
gout[n*729+265] += + s[103];
gout[n*729+266] += + s[104];
gout[n*729+267] += + s[105];
gout[n*729+268] += + s[106];
gout[n*729+269] += + s[107];
gout[n*729+270] += + s[108];
gout[n*729+271] += + s[109];
gout[n*729+272] += + s[110];
gout[n*729+273] += + s[111];
gout[n*729+274] += + s[112];
gout[n*729+275] += + s[113];
gout[n*729+276] += + s[114];
gout[n*729+277] += + s[115];
gout[n*729+278] += + s[116];
gout[n*729+279] += + s[117];
gout[n*729+280] += + s[118];
gout[n*729+281] += + s[119];
gout[n*729+282] += + s[120];
gout[n*729+283] += + s[121];
gout[n*729+284] += + s[122];
gout[n*729+285] += + s[123];
gout[n*729+286] += + s[124];
gout[n*729+287] += + s[125];
gout[n*729+288] += + s[126];
gout[n*729+289] += + s[127];
gout[n*729+290] += + s[128];
gout[n*729+291] += + s[129];
gout[n*729+292] += + s[130];
gout[n*729+293] += + s[131];
gout[n*729+294] += + s[132];
gout[n*729+295] += + s[133];
gout[n*729+296] += + s[134];
gout[n*729+297] += + s[135];
gout[n*729+298] += + s[136];
gout[n*729+299] += + s[137];
gout[n*729+300] += + s[138];
gout[n*729+301] += + s[139];
gout[n*729+302] += + s[140];
gout[n*729+303] += + s[141];
gout[n*729+304] += + s[142];
gout[n*729+305] += + s[143];
gout[n*729+306] += + s[144];
gout[n*729+307] += + s[145];
gout[n*729+308] += + s[146];
gout[n*729+309] += + s[147];
gout[n*729+310] += + s[148];
gout[n*729+311] += + s[149];
gout[n*729+312] += + s[150];
gout[n*729+313] += + s[151];
gout[n*729+314] += + s[152];
gout[n*729+315] += + s[153];
gout[n*729+316] += + s[154];
gout[n*729+317] += + s[155];
gout[n*729+318] += + s[156];
gout[n*729+319] += + s[157];
gout[n*729+320] += + s[158];
gout[n*729+321] += + s[159];
gout[n*729+322] += + s[160];
gout[n*729+323] += + s[161];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[567];
gout[n*729+406] += + s[568];
gout[n*729+407] += + s[569];
gout[n*729+408] += + s[570];
gout[n*729+409] += + s[571];
gout[n*729+410] += + s[572];
gout[n*729+411] += + s[573];
gout[n*729+412] += + s[574];
gout[n*729+413] += + s[575];
gout[n*729+414] += + s[576];
gout[n*729+415] += + s[577];
gout[n*729+416] += + s[578];
gout[n*729+417] += + s[579];
gout[n*729+418] += + s[580];
gout[n*729+419] += + s[581];
gout[n*729+420] += + s[582];
gout[n*729+421] += + s[583];
gout[n*729+422] += + s[584];
gout[n*729+423] += + s[585];
gout[n*729+424] += + s[586];
gout[n*729+425] += + s[587];
gout[n*729+426] += + s[588];
gout[n*729+427] += + s[589];
gout[n*729+428] += + s[590];
gout[n*729+429] += + s[591];
gout[n*729+430] += + s[592];
gout[n*729+431] += + s[593];
gout[n*729+432] += + s[594];
gout[n*729+433] += + s[595];
gout[n*729+434] += + s[596];
gout[n*729+435] += + s[597];
gout[n*729+436] += + s[598];
gout[n*729+437] += + s[599];
gout[n*729+438] += + s[600];
gout[n*729+439] += + s[601];
gout[n*729+440] += + s[602];
gout[n*729+441] += + s[603];
gout[n*729+442] += + s[604];
gout[n*729+443] += + s[605];
gout[n*729+444] += + s[606];
gout[n*729+445] += + s[607];
gout[n*729+446] += + s[608];
gout[n*729+447] += + s[609];
gout[n*729+448] += + s[610];
gout[n*729+449] += + s[611];
gout[n*729+450] += + s[612];
gout[n*729+451] += + s[613];
gout[n*729+452] += + s[614];
gout[n*729+453] += + s[615];
gout[n*729+454] += + s[616];
gout[n*729+455] += + s[617];
gout[n*729+456] += + s[618];
gout[n*729+457] += + s[619];
gout[n*729+458] += + s[620];
gout[n*729+459] += + s[621];
gout[n*729+460] += + s[622];
gout[n*729+461] += + s[623];
gout[n*729+462] += + s[624];
gout[n*729+463] += + s[625];
gout[n*729+464] += + s[626];
gout[n*729+465] += + s[627];
gout[n*729+466] += + s[628];
gout[n*729+467] += + s[629];
gout[n*729+468] += + s[630];
gout[n*729+469] += + s[631];
gout[n*729+470] += + s[632];
gout[n*729+471] += + s[633];
gout[n*729+472] += + s[634];
gout[n*729+473] += + s[635];
gout[n*729+474] += + s[636];
gout[n*729+475] += + s[637];
gout[n*729+476] += + s[638];
gout[n*729+477] += + s[639];
gout[n*729+478] += + s[640];
gout[n*729+479] += + s[641];
gout[n*729+480] += + s[642];
gout[n*729+481] += + s[643];
gout[n*729+482] += + s[644];
gout[n*729+483] += + s[645];
gout[n*729+484] += + s[646];
gout[n*729+485] += + s[647];
gout[n*729+486] += + s[162];
gout[n*729+487] += + s[163];
gout[n*729+488] += + s[164];
gout[n*729+489] += + s[165];
gout[n*729+490] += + s[166];
gout[n*729+491] += + s[167];
gout[n*729+492] += + s[168];
gout[n*729+493] += + s[169];
gout[n*729+494] += + s[170];
gout[n*729+495] += + s[171];
gout[n*729+496] += + s[172];
gout[n*729+497] += + s[173];
gout[n*729+498] += + s[174];
gout[n*729+499] += + s[175];
gout[n*729+500] += + s[176];
gout[n*729+501] += + s[177];
gout[n*729+502] += + s[178];
gout[n*729+503] += + s[179];
gout[n*729+504] += + s[180];
gout[n*729+505] += + s[181];
gout[n*729+506] += + s[182];
gout[n*729+507] += + s[183];
gout[n*729+508] += + s[184];
gout[n*729+509] += + s[185];
gout[n*729+510] += + s[186];
gout[n*729+511] += + s[187];
gout[n*729+512] += + s[188];
gout[n*729+513] += + s[189];
gout[n*729+514] += + s[190];
gout[n*729+515] += + s[191];
gout[n*729+516] += + s[192];
gout[n*729+517] += + s[193];
gout[n*729+518] += + s[194];
gout[n*729+519] += + s[195];
gout[n*729+520] += + s[196];
gout[n*729+521] += + s[197];
gout[n*729+522] += + s[198];
gout[n*729+523] += + s[199];
gout[n*729+524] += + s[200];
gout[n*729+525] += + s[201];
gout[n*729+526] += + s[202];
gout[n*729+527] += + s[203];
gout[n*729+528] += + s[204];
gout[n*729+529] += + s[205];
gout[n*729+530] += + s[206];
gout[n*729+531] += + s[207];
gout[n*729+532] += + s[208];
gout[n*729+533] += + s[209];
gout[n*729+534] += + s[210];
gout[n*729+535] += + s[211];
gout[n*729+536] += + s[212];
gout[n*729+537] += + s[213];
gout[n*729+538] += + s[214];
gout[n*729+539] += + s[215];
gout[n*729+540] += + s[216];
gout[n*729+541] += + s[217];
gout[n*729+542] += + s[218];
gout[n*729+543] += + s[219];
gout[n*729+544] += + s[220];
gout[n*729+545] += + s[221];
gout[n*729+546] += + s[222];
gout[n*729+547] += + s[223];
gout[n*729+548] += + s[224];
gout[n*729+549] += + s[225];
gout[n*729+550] += + s[226];
gout[n*729+551] += + s[227];
gout[n*729+552] += + s[228];
gout[n*729+553] += + s[229];
gout[n*729+554] += + s[230];
gout[n*729+555] += + s[231];
gout[n*729+556] += + s[232];
gout[n*729+557] += + s[233];
gout[n*729+558] += + s[234];
gout[n*729+559] += + s[235];
gout[n*729+560] += + s[236];
gout[n*729+561] += + s[237];
gout[n*729+562] += + s[238];
gout[n*729+563] += + s[239];
gout[n*729+564] += + s[240];
gout[n*729+565] += + s[241];
gout[n*729+566] += + s[242];
gout[n*729+567] += + s[405];
gout[n*729+568] += + s[406];
gout[n*729+569] += + s[407];
gout[n*729+570] += + s[408];
gout[n*729+571] += + s[409];
gout[n*729+572] += + s[410];
gout[n*729+573] += + s[411];
gout[n*729+574] += + s[412];
gout[n*729+575] += + s[413];
gout[n*729+576] += + s[414];
gout[n*729+577] += + s[415];
gout[n*729+578] += + s[416];
gout[n*729+579] += + s[417];
gout[n*729+580] += + s[418];
gout[n*729+581] += + s[419];
gout[n*729+582] += + s[420];
gout[n*729+583] += + s[421];
gout[n*729+584] += + s[422];
gout[n*729+585] += + s[423];
gout[n*729+586] += + s[424];
gout[n*729+587] += + s[425];
gout[n*729+588] += + s[426];
gout[n*729+589] += + s[427];
gout[n*729+590] += + s[428];
gout[n*729+591] += + s[429];
gout[n*729+592] += + s[430];
gout[n*729+593] += + s[431];
gout[n*729+594] += + s[432];
gout[n*729+595] += + s[433];
gout[n*729+596] += + s[434];
gout[n*729+597] += + s[435];
gout[n*729+598] += + s[436];
gout[n*729+599] += + s[437];
gout[n*729+600] += + s[438];
gout[n*729+601] += + s[439];
gout[n*729+602] += + s[440];
gout[n*729+603] += + s[441];
gout[n*729+604] += + s[442];
gout[n*729+605] += + s[443];
gout[n*729+606] += + s[444];
gout[n*729+607] += + s[445];
gout[n*729+608] += + s[446];
gout[n*729+609] += + s[447];
gout[n*729+610] += + s[448];
gout[n*729+611] += + s[449];
gout[n*729+612] += + s[450];
gout[n*729+613] += + s[451];
gout[n*729+614] += + s[452];
gout[n*729+615] += + s[453];
gout[n*729+616] += + s[454];
gout[n*729+617] += + s[455];
gout[n*729+618] += + s[456];
gout[n*729+619] += + s[457];
gout[n*729+620] += + s[458];
gout[n*729+621] += + s[459];
gout[n*729+622] += + s[460];
gout[n*729+623] += + s[461];
gout[n*729+624] += + s[462];
gout[n*729+625] += + s[463];
gout[n*729+626] += + s[464];
gout[n*729+627] += + s[465];
gout[n*729+628] += + s[466];
gout[n*729+629] += + s[467];
gout[n*729+630] += + s[468];
gout[n*729+631] += + s[469];
gout[n*729+632] += + s[470];
gout[n*729+633] += + s[471];
gout[n*729+634] += + s[472];
gout[n*729+635] += + s[473];
gout[n*729+636] += + s[474];
gout[n*729+637] += + s[475];
gout[n*729+638] += + s[476];
gout[n*729+639] += + s[477];
gout[n*729+640] += + s[478];
gout[n*729+641] += + s[479];
gout[n*729+642] += + s[480];
gout[n*729+643] += + s[481];
gout[n*729+644] += + s[482];
gout[n*729+645] += + s[483];
gout[n*729+646] += + s[484];
gout[n*729+647] += + s[485];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipmmmip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipmmmip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipmmmip_cart
CACHE_SIZE_T int1e_ipipmmmip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmmip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipmmmip_sph
CACHE_SIZE_T int1e_ipipmmmip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmmip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipmmmip_spinor
ALL_CINT1E(int1e_ipipmmmip)
ALL_CINT1E_FORTRAN_(int1e_ipipmmmip)
/* <NABLA NABLA i|RI RI RI |NABLA NABLA j> */
void CINTgout1e_int1e_ipipmmmipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double *g64 = g63 + envs->g_size * 3;
double *g65 = g64 + envs->g_size * 3;
double *g66 = g65 + envs->g_size * 3;
double *g67 = g66 + envs->g_size * 3;
double *g68 = g67 + envs->g_size * 3;
double *g69 = g68 + envs->g_size * 3;
double *g70 = g69 + envs->g_size * 3;
double *g71 = g70 + envs->g_size * 3;
double *g72 = g71 + envs->g_size * 3;
double *g73 = g72 + envs->g_size * 3;
double *g74 = g73 + envs->g_size * 3;
double *g75 = g74 + envs->g_size * 3;
double *g76 = g75 + envs->g_size * 3;
double *g77 = g76 + envs->g_size * 3;
double *g78 = g77 + envs->g_size * 3;
double *g79 = g78 + envs->g_size * 3;
double *g80 = g79 + envs->g_size * 3;
double *g81 = g80 + envs->g_size * 3;
double *g82 = g81 + envs->g_size * 3;
double *g83 = g82 + envs->g_size * 3;
double *g84 = g83 + envs->g_size * 3;
double *g85 = g84 + envs->g_size * 3;
double *g86 = g85 + envs->g_size * 3;
double *g87 = g86 + envs->g_size * 3;
double *g88 = g87 + envs->g_size * 3;
double *g89 = g88 + envs->g_size * 3;
double *g90 = g89 + envs->g_size * 3;
double *g91 = g90 + envs->g_size * 3;
double *g92 = g91 + envs->g_size * 3;
double *g93 = g92 + envs->g_size * 3;
double *g94 = g93 + envs->g_size * 3;
double *g95 = g94 + envs->g_size * 3;
double *g96 = g95 + envs->g_size * 3;
double *g97 = g96 + envs->g_size * 3;
double *g98 = g97 + envs->g_size * 3;
double *g99 = g98 + envs->g_size * 3;
double *g100 = g99 + envs->g_size * 3;
double *g101 = g100 + envs->g_size * 3;
double *g102 = g101 + envs->g_size * 3;
double *g103 = g102 + envs->g_size * 3;
double *g104 = g103 + envs->g_size * 3;
double *g105 = g104 + envs->g_size * 3;
double *g106 = g105 + envs->g_size * 3;
double *g107 = g106 + envs->g_size * 3;
double *g108 = g107 + envs->g_size * 3;
double *g109 = g108 + envs->g_size * 3;
double *g110 = g109 + envs->g_size * 3;
double *g111 = g110 + envs->g_size * 3;
double *g112 = g111 + envs->g_size * 3;
double *g113 = g112 + envs->g_size * 3;
double *g114 = g113 + envs->g_size * 3;
double *g115 = g114 + envs->g_size * 3;
double *g116 = g115 + envs->g_size * 3;
double *g117 = g116 + envs->g_size * 3;
double *g118 = g117 + envs->g_size * 3;
double *g119 = g118 + envs->g_size * 3;
double *g120 = g119 + envs->g_size * 3;
double *g121 = g120 + envs->g_size * 3;
double *g122 = g121 + envs->g_size * 3;
double *g123 = g122 + envs->g_size * 3;
double *g124 = g123 + envs->g_size * 3;
double *g125 = g124 + envs->g_size * 3;
double *g126 = g125 + envs->g_size * 3;
double *g127 = g126 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->ri[0];
drj[1] = envs->rj[1] - envs->ri[1];
drj[2] = envs->rj[2] - envs->ri[2];
double s[2187];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+2, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+2, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g20, g16, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+2, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g28, g24, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g32, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g64, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g65, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g66, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g67, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g68, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g69, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g70, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g71, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g72, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g73, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g74, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g75, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g76, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g77, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g78, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g79, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g80, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g81, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g82, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g83, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g84, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g85, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g86, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g87, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g88, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g89, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g90, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g91, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g92, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g93, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g94, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g95, g31, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g96, g32, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g97, g33, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g98, g34, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g99, g35, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g100, g36, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g101, g37, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g102, g38, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g103, g39, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g104, g40, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g105, g41, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g106, g42, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g107, g43, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g108, g44, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g109, g45, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g110, g46, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g111, g47, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g112, g48, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g113, g49, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g114, g50, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g115, g51, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g116, g52, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g117, g53, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g118, g54, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g119, g55, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g120, g56, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g121, g57, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g122, g58, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g123, g59, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g124, g60, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g125, g61, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g126, g62, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g127, g63, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g127[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g126[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g126[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g125[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g124[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g124[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g125[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g124[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g124[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g123[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g122[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g122[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g121[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g120[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g120[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g121[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g120[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g120[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g123[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g122[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g122[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g121[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g120[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g120[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g121[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g120[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g120[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g119[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g118[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g118[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g117[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g116[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g116[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g117[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g116[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g116[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g115[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g114[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g114[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g113[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g112[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g112[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g113[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g112[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g112[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g115[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g114[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g114[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g113[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g112[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g112[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g113[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g112[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g112[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g119[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g118[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g118[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g117[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g116[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g116[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g117[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g116[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g116[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g115[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g114[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g114[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g113[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g112[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g112[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g113[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g112[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g112[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g115[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g114[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g114[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g113[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g112[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g112[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g113[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g112[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g112[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g111[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g110[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g110[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g109[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g108[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g108[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g109[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g108[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g108[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g107[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g106[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g106[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g105[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g104[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g104[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g105[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g104[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g104[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g107[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g106[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g106[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g105[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g104[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g104[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g105[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g104[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g104[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g103[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g102[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g102[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g101[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g100[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g100[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g101[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g100[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g100[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g99[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g98[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g98[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g97[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g96[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g96[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g97[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g96[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g96[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g99[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g98[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g98[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g97[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g96[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g96[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g97[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g96[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g96[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g103[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g102[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g102[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g101[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g100[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g100[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g101[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g100[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g100[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g99[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g98[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g98[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g97[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g96[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g96[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g97[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g96[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g96[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g99[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g98[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g98[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g97[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g96[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g96[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g97[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g96[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g96[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g111[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g110[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g110[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g109[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g108[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g108[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g109[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g108[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g108[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g107[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g106[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g106[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g105[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g104[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g104[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g105[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g104[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g104[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g107[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g106[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g106[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g105[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g104[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g104[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g105[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g104[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g104[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g103[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g102[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g102[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g101[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g100[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g100[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g101[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g100[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g100[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g99[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g98[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g98[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g97[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g96[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g96[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g97[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g96[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g96[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g99[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g98[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g98[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g97[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g96[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g96[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g97[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g96[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g96[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g103[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g102[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g102[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g101[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g100[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g100[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g101[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g100[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g100[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g99[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g98[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g98[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g97[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g96[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g96[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g97[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g96[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g96[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g99[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g98[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g98[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g97[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g96[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g96[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g97[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g96[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g96[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g95[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g94[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g94[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g93[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g92[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g92[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g93[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g92[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g92[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g91[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g90[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g90[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g89[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g88[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g88[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g89[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g88[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g88[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g91[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g90[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g90[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g89[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g88[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g88[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g89[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g88[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g88[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g87[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g86[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g86[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g85[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g84[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g84[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g85[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g84[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g84[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g83[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g82[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g82[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g81[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g80[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g80[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g81[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g80[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g80[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g83[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g82[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g82[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g81[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g80[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g80[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g81[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g80[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g80[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g87[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g86[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g86[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g85[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g84[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g84[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g85[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g84[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g84[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g83[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g82[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g82[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g81[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g80[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g80[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g81[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g80[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g80[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g83[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g82[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g82[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g81[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g80[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g80[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g81[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g80[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g80[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g79[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g78[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g78[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g77[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g76[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g76[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g77[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g76[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g76[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g75[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g74[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g74[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g73[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g72[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g72[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g73[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g72[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g72[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g75[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g74[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g74[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g73[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g72[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g72[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g73[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g72[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g72[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g71[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g70[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g70[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g69[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g68[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g68[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g69[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g68[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g68[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g67[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g66[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g66[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g65[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g64[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g64[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g65[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g64[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g64[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g67[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g66[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g66[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g65[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g64[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g64[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g65[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g64[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g64[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g71[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g70[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g70[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g69[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g68[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g68[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g69[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g68[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g68[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g67[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g66[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g66[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g65[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g64[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g64[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g65[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g64[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g64[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g67[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g66[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g66[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g65[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g64[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g64[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g65[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g64[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g64[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g79[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g78[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g78[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g77[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g76[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g76[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g77[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g76[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g76[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g75[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g74[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g74[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g73[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g72[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g72[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g73[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g72[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g72[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g75[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g74[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g74[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g73[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g72[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g72[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g73[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g72[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g72[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g71[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g70[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g70[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g69[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g68[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g68[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g69[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g68[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g68[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g67[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g66[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g66[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g65[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g64[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g64[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g65[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g64[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g64[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g67[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g66[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g66[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g65[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g64[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g64[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g65[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g64[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g64[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g71[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g70[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g70[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g69[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g68[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g68[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g69[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g68[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g68[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g67[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g66[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g66[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g65[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g64[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g64[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g65[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g64[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g64[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g67[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g66[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g66[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g65[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g64[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g64[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g65[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g64[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g64[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g95[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g94[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g94[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g93[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g92[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g92[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g93[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g92[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g92[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g91[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g90[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g90[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g89[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g88[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g88[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g89[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g88[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g88[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g91[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g90[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g90[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g89[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g88[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g88[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g89[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g88[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g88[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g87[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g86[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g86[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g85[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g84[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g84[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g85[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g84[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g84[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g83[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g82[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g82[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g81[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g80[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g80[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g81[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g80[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g80[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g83[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g82[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g82[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g81[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g80[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g80[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g81[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g80[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g80[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g87[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g86[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g86[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g85[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g84[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g84[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g85[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g84[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g84[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g83[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g82[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g82[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g81[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g80[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g80[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g81[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g80[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g80[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g83[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g82[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g82[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g81[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g80[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g80[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g81[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g80[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g80[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g79[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g78[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g78[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g77[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g76[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g76[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g77[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g76[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g76[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g75[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g74[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g74[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g73[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g72[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g72[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g73[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g72[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g72[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g75[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g74[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g74[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g73[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g72[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g72[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g73[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g72[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g72[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g71[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g70[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g70[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g69[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g68[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g68[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g69[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g68[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g68[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g67[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g66[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g66[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g65[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g64[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g64[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g65[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g64[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g64[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g67[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g66[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g66[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g65[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g64[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g64[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g65[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g64[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g64[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g71[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g70[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g70[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g69[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g68[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g68[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g69[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g68[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g68[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g67[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g66[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g66[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g65[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g64[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g64[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g65[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g64[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g64[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g67[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g66[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g66[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g65[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g64[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g64[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g65[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g64[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g64[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g79[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g78[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g78[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g77[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g76[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g76[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g77[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g76[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g76[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g75[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g74[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g74[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g73[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g72[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g72[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g73[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g72[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g72[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g75[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g74[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g74[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g73[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g72[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g72[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g73[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g72[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g72[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g71[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g70[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g70[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g69[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g68[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g68[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g69[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g68[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g68[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g67[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g66[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g66[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g65[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g64[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g64[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g65[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g64[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g64[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g67[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g66[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g66[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g65[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g64[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g64[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g65[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g64[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g64[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g71[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g70[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g70[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g69[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g68[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g68[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g69[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g68[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g68[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g67[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g66[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g66[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g65[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g64[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g64[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g65[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g64[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g64[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g67[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g66[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g66[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g65[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g64[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g64[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g65[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g64[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g64[ix+0]*g0[iy+0]*g63[iz+0];
s[729] = + g63[ix+0]*g64[iy+0]*g0[iz+0];
s[730] = + g62[ix+0]*g65[iy+0]*g0[iz+0];
s[731] = + g62[ix+0]*g64[iy+0]*g1[iz+0];
s[732] = + g61[ix+0]*g66[iy+0]*g0[iz+0];
s[733] = + g60[ix+0]*g67[iy+0]*g0[iz+0];
s[734] = + g60[ix+0]*g66[iy+0]*g1[iz+0];
s[735] = + g61[ix+0]*g64[iy+0]*g2[iz+0];
s[736] = + g60[ix+0]*g65[iy+0]*g2[iz+0];
s[737] = + g60[ix+0]*g64[iy+0]*g3[iz+0];
s[738] = + g59[ix+0]*g68[iy+0]*g0[iz+0];
s[739] = + g58[ix+0]*g69[iy+0]*g0[iz+0];
s[740] = + g58[ix+0]*g68[iy+0]*g1[iz+0];
s[741] = + g57[ix+0]*g70[iy+0]*g0[iz+0];
s[742] = + g56[ix+0]*g71[iy+0]*g0[iz+0];
s[743] = + g56[ix+0]*g70[iy+0]*g1[iz+0];
s[744] = + g57[ix+0]*g68[iy+0]*g2[iz+0];
s[745] = + g56[ix+0]*g69[iy+0]*g2[iz+0];
s[746] = + g56[ix+0]*g68[iy+0]*g3[iz+0];
s[747] = + g59[ix+0]*g64[iy+0]*g4[iz+0];
s[748] = + g58[ix+0]*g65[iy+0]*g4[iz+0];
s[749] = + g58[ix+0]*g64[iy+0]*g5[iz+0];
s[750] = + g57[ix+0]*g66[iy+0]*g4[iz+0];
s[751] = + g56[ix+0]*g67[iy+0]*g4[iz+0];
s[752] = + g56[ix+0]*g66[iy+0]*g5[iz+0];
s[753] = + g57[ix+0]*g64[iy+0]*g6[iz+0];
s[754] = + g56[ix+0]*g65[iy+0]*g6[iz+0];
s[755] = + g56[ix+0]*g64[iy+0]*g7[iz+0];
s[756] = + g55[ix+0]*g72[iy+0]*g0[iz+0];
s[757] = + g54[ix+0]*g73[iy+0]*g0[iz+0];
s[758] = + g54[ix+0]*g72[iy+0]*g1[iz+0];
s[759] = + g53[ix+0]*g74[iy+0]*g0[iz+0];
s[760] = + g52[ix+0]*g75[iy+0]*g0[iz+0];
s[761] = + g52[ix+0]*g74[iy+0]*g1[iz+0];
s[762] = + g53[ix+0]*g72[iy+0]*g2[iz+0];
s[763] = + g52[ix+0]*g73[iy+0]*g2[iz+0];
s[764] = + g52[ix+0]*g72[iy+0]*g3[iz+0];
s[765] = + g51[ix+0]*g76[iy+0]*g0[iz+0];
s[766] = + g50[ix+0]*g77[iy+0]*g0[iz+0];
s[767] = + g50[ix+0]*g76[iy+0]*g1[iz+0];
s[768] = + g49[ix+0]*g78[iy+0]*g0[iz+0];
s[769] = + g48[ix+0]*g79[iy+0]*g0[iz+0];
s[770] = + g48[ix+0]*g78[iy+0]*g1[iz+0];
s[771] = + g49[ix+0]*g76[iy+0]*g2[iz+0];
s[772] = + g48[ix+0]*g77[iy+0]*g2[iz+0];
s[773] = + g48[ix+0]*g76[iy+0]*g3[iz+0];
s[774] = + g51[ix+0]*g72[iy+0]*g4[iz+0];
s[775] = + g50[ix+0]*g73[iy+0]*g4[iz+0];
s[776] = + g50[ix+0]*g72[iy+0]*g5[iz+0];
s[777] = + g49[ix+0]*g74[iy+0]*g4[iz+0];
s[778] = + g48[ix+0]*g75[iy+0]*g4[iz+0];
s[779] = + g48[ix+0]*g74[iy+0]*g5[iz+0];
s[780] = + g49[ix+0]*g72[iy+0]*g6[iz+0];
s[781] = + g48[ix+0]*g73[iy+0]*g6[iz+0];
s[782] = + g48[ix+0]*g72[iy+0]*g7[iz+0];
s[783] = + g55[ix+0]*g64[iy+0]*g8[iz+0];
s[784] = + g54[ix+0]*g65[iy+0]*g8[iz+0];
s[785] = + g54[ix+0]*g64[iy+0]*g9[iz+0];
s[786] = + g53[ix+0]*g66[iy+0]*g8[iz+0];
s[787] = + g52[ix+0]*g67[iy+0]*g8[iz+0];
s[788] = + g52[ix+0]*g66[iy+0]*g9[iz+0];
s[789] = + g53[ix+0]*g64[iy+0]*g10[iz+0];
s[790] = + g52[ix+0]*g65[iy+0]*g10[iz+0];
s[791] = + g52[ix+0]*g64[iy+0]*g11[iz+0];
s[792] = + g51[ix+0]*g68[iy+0]*g8[iz+0];
s[793] = + g50[ix+0]*g69[iy+0]*g8[iz+0];
s[794] = + g50[ix+0]*g68[iy+0]*g9[iz+0];
s[795] = + g49[ix+0]*g70[iy+0]*g8[iz+0];
s[796] = + g48[ix+0]*g71[iy+0]*g8[iz+0];
s[797] = + g48[ix+0]*g70[iy+0]*g9[iz+0];
s[798] = + g49[ix+0]*g68[iy+0]*g10[iz+0];
s[799] = + g48[ix+0]*g69[iy+0]*g10[iz+0];
s[800] = + g48[ix+0]*g68[iy+0]*g11[iz+0];
s[801] = + g51[ix+0]*g64[iy+0]*g12[iz+0];
s[802] = + g50[ix+0]*g65[iy+0]*g12[iz+0];
s[803] = + g50[ix+0]*g64[iy+0]*g13[iz+0];
s[804] = + g49[ix+0]*g66[iy+0]*g12[iz+0];
s[805] = + g48[ix+0]*g67[iy+0]*g12[iz+0];
s[806] = + g48[ix+0]*g66[iy+0]*g13[iz+0];
s[807] = + g49[ix+0]*g64[iy+0]*g14[iz+0];
s[808] = + g48[ix+0]*g65[iy+0]*g14[iz+0];
s[809] = + g48[ix+0]*g64[iy+0]*g15[iz+0];
s[810] = + g47[ix+0]*g80[iy+0]*g0[iz+0];
s[811] = + g46[ix+0]*g81[iy+0]*g0[iz+0];
s[812] = + g46[ix+0]*g80[iy+0]*g1[iz+0];
s[813] = + g45[ix+0]*g82[iy+0]*g0[iz+0];
s[814] = + g44[ix+0]*g83[iy+0]*g0[iz+0];
s[815] = + g44[ix+0]*g82[iy+0]*g1[iz+0];
s[816] = + g45[ix+0]*g80[iy+0]*g2[iz+0];
s[817] = + g44[ix+0]*g81[iy+0]*g2[iz+0];
s[818] = + g44[ix+0]*g80[iy+0]*g3[iz+0];
s[819] = + g43[ix+0]*g84[iy+0]*g0[iz+0];
s[820] = + g42[ix+0]*g85[iy+0]*g0[iz+0];
s[821] = + g42[ix+0]*g84[iy+0]*g1[iz+0];
s[822] = + g41[ix+0]*g86[iy+0]*g0[iz+0];
s[823] = + g40[ix+0]*g87[iy+0]*g0[iz+0];
s[824] = + g40[ix+0]*g86[iy+0]*g1[iz+0];
s[825] = + g41[ix+0]*g84[iy+0]*g2[iz+0];
s[826] = + g40[ix+0]*g85[iy+0]*g2[iz+0];
s[827] = + g40[ix+0]*g84[iy+0]*g3[iz+0];
s[828] = + g43[ix+0]*g80[iy+0]*g4[iz+0];
s[829] = + g42[ix+0]*g81[iy+0]*g4[iz+0];
s[830] = + g42[ix+0]*g80[iy+0]*g5[iz+0];
s[831] = + g41[ix+0]*g82[iy+0]*g4[iz+0];
s[832] = + g40[ix+0]*g83[iy+0]*g4[iz+0];
s[833] = + g40[ix+0]*g82[iy+0]*g5[iz+0];
s[834] = + g41[ix+0]*g80[iy+0]*g6[iz+0];
s[835] = + g40[ix+0]*g81[iy+0]*g6[iz+0];
s[836] = + g40[ix+0]*g80[iy+0]*g7[iz+0];
s[837] = + g39[ix+0]*g88[iy+0]*g0[iz+0];
s[838] = + g38[ix+0]*g89[iy+0]*g0[iz+0];
s[839] = + g38[ix+0]*g88[iy+0]*g1[iz+0];
s[840] = + g37[ix+0]*g90[iy+0]*g0[iz+0];
s[841] = + g36[ix+0]*g91[iy+0]*g0[iz+0];
s[842] = + g36[ix+0]*g90[iy+0]*g1[iz+0];
s[843] = + g37[ix+0]*g88[iy+0]*g2[iz+0];
s[844] = + g36[ix+0]*g89[iy+0]*g2[iz+0];
s[845] = + g36[ix+0]*g88[iy+0]*g3[iz+0];
s[846] = + g35[ix+0]*g92[iy+0]*g0[iz+0];
s[847] = + g34[ix+0]*g93[iy+0]*g0[iz+0];
s[848] = + g34[ix+0]*g92[iy+0]*g1[iz+0];
s[849] = + g33[ix+0]*g94[iy+0]*g0[iz+0];
s[850] = + g32[ix+0]*g95[iy+0]*g0[iz+0];
s[851] = + g32[ix+0]*g94[iy+0]*g1[iz+0];
s[852] = + g33[ix+0]*g92[iy+0]*g2[iz+0];
s[853] = + g32[ix+0]*g93[iy+0]*g2[iz+0];
s[854] = + g32[ix+0]*g92[iy+0]*g3[iz+0];
s[855] = + g35[ix+0]*g88[iy+0]*g4[iz+0];
s[856] = + g34[ix+0]*g89[iy+0]*g4[iz+0];
s[857] = + g34[ix+0]*g88[iy+0]*g5[iz+0];
s[858] = + g33[ix+0]*g90[iy+0]*g4[iz+0];
s[859] = + g32[ix+0]*g91[iy+0]*g4[iz+0];
s[860] = + g32[ix+0]*g90[iy+0]*g5[iz+0];
s[861] = + g33[ix+0]*g88[iy+0]*g6[iz+0];
s[862] = + g32[ix+0]*g89[iy+0]*g6[iz+0];
s[863] = + g32[ix+0]*g88[iy+0]*g7[iz+0];
s[864] = + g39[ix+0]*g80[iy+0]*g8[iz+0];
s[865] = + g38[ix+0]*g81[iy+0]*g8[iz+0];
s[866] = + g38[ix+0]*g80[iy+0]*g9[iz+0];
s[867] = + g37[ix+0]*g82[iy+0]*g8[iz+0];
s[868] = + g36[ix+0]*g83[iy+0]*g8[iz+0];
s[869] = + g36[ix+0]*g82[iy+0]*g9[iz+0];
s[870] = + g37[ix+0]*g80[iy+0]*g10[iz+0];
s[871] = + g36[ix+0]*g81[iy+0]*g10[iz+0];
s[872] = + g36[ix+0]*g80[iy+0]*g11[iz+0];
s[873] = + g35[ix+0]*g84[iy+0]*g8[iz+0];
s[874] = + g34[ix+0]*g85[iy+0]*g8[iz+0];
s[875] = + g34[ix+0]*g84[iy+0]*g9[iz+0];
s[876] = + g33[ix+0]*g86[iy+0]*g8[iz+0];
s[877] = + g32[ix+0]*g87[iy+0]*g8[iz+0];
s[878] = + g32[ix+0]*g86[iy+0]*g9[iz+0];
s[879] = + g33[ix+0]*g84[iy+0]*g10[iz+0];
s[880] = + g32[ix+0]*g85[iy+0]*g10[iz+0];
s[881] = + g32[ix+0]*g84[iy+0]*g11[iz+0];
s[882] = + g35[ix+0]*g80[iy+0]*g12[iz+0];
s[883] = + g34[ix+0]*g81[iy+0]*g12[iz+0];
s[884] = + g34[ix+0]*g80[iy+0]*g13[iz+0];
s[885] = + g33[ix+0]*g82[iy+0]*g12[iz+0];
s[886] = + g32[ix+0]*g83[iy+0]*g12[iz+0];
s[887] = + g32[ix+0]*g82[iy+0]*g13[iz+0];
s[888] = + g33[ix+0]*g80[iy+0]*g14[iz+0];
s[889] = + g32[ix+0]*g81[iy+0]*g14[iz+0];
s[890] = + g32[ix+0]*g80[iy+0]*g15[iz+0];
s[891] = + g47[ix+0]*g64[iy+0]*g16[iz+0];
s[892] = + g46[ix+0]*g65[iy+0]*g16[iz+0];
s[893] = + g46[ix+0]*g64[iy+0]*g17[iz+0];
s[894] = + g45[ix+0]*g66[iy+0]*g16[iz+0];
s[895] = + g44[ix+0]*g67[iy+0]*g16[iz+0];
s[896] = + g44[ix+0]*g66[iy+0]*g17[iz+0];
s[897] = + g45[ix+0]*g64[iy+0]*g18[iz+0];
s[898] = + g44[ix+0]*g65[iy+0]*g18[iz+0];
s[899] = + g44[ix+0]*g64[iy+0]*g19[iz+0];
s[900] = + g43[ix+0]*g68[iy+0]*g16[iz+0];
s[901] = + g42[ix+0]*g69[iy+0]*g16[iz+0];
s[902] = + g42[ix+0]*g68[iy+0]*g17[iz+0];
s[903] = + g41[ix+0]*g70[iy+0]*g16[iz+0];
s[904] = + g40[ix+0]*g71[iy+0]*g16[iz+0];
s[905] = + g40[ix+0]*g70[iy+0]*g17[iz+0];
s[906] = + g41[ix+0]*g68[iy+0]*g18[iz+0];
s[907] = + g40[ix+0]*g69[iy+0]*g18[iz+0];
s[908] = + g40[ix+0]*g68[iy+0]*g19[iz+0];
s[909] = + g43[ix+0]*g64[iy+0]*g20[iz+0];
s[910] = + g42[ix+0]*g65[iy+0]*g20[iz+0];
s[911] = + g42[ix+0]*g64[iy+0]*g21[iz+0];
s[912] = + g41[ix+0]*g66[iy+0]*g20[iz+0];
s[913] = + g40[ix+0]*g67[iy+0]*g20[iz+0];
s[914] = + g40[ix+0]*g66[iy+0]*g21[iz+0];
s[915] = + g41[ix+0]*g64[iy+0]*g22[iz+0];
s[916] = + g40[ix+0]*g65[iy+0]*g22[iz+0];
s[917] = + g40[ix+0]*g64[iy+0]*g23[iz+0];
s[918] = + g39[ix+0]*g72[iy+0]*g16[iz+0];
s[919] = + g38[ix+0]*g73[iy+0]*g16[iz+0];
s[920] = + g38[ix+0]*g72[iy+0]*g17[iz+0];
s[921] = + g37[ix+0]*g74[iy+0]*g16[iz+0];
s[922] = + g36[ix+0]*g75[iy+0]*g16[iz+0];
s[923] = + g36[ix+0]*g74[iy+0]*g17[iz+0];
s[924] = + g37[ix+0]*g72[iy+0]*g18[iz+0];
s[925] = + g36[ix+0]*g73[iy+0]*g18[iz+0];
s[926] = + g36[ix+0]*g72[iy+0]*g19[iz+0];
s[927] = + g35[ix+0]*g76[iy+0]*g16[iz+0];
s[928] = + g34[ix+0]*g77[iy+0]*g16[iz+0];
s[929] = + g34[ix+0]*g76[iy+0]*g17[iz+0];
s[930] = + g33[ix+0]*g78[iy+0]*g16[iz+0];
s[931] = + g32[ix+0]*g79[iy+0]*g16[iz+0];
s[932] = + g32[ix+0]*g78[iy+0]*g17[iz+0];
s[933] = + g33[ix+0]*g76[iy+0]*g18[iz+0];
s[934] = + g32[ix+0]*g77[iy+0]*g18[iz+0];
s[935] = + g32[ix+0]*g76[iy+0]*g19[iz+0];
s[936] = + g35[ix+0]*g72[iy+0]*g20[iz+0];
s[937] = + g34[ix+0]*g73[iy+0]*g20[iz+0];
s[938] = + g34[ix+0]*g72[iy+0]*g21[iz+0];
s[939] = + g33[ix+0]*g74[iy+0]*g20[iz+0];
s[940] = + g32[ix+0]*g75[iy+0]*g20[iz+0];
s[941] = + g32[ix+0]*g74[iy+0]*g21[iz+0];
s[942] = + g33[ix+0]*g72[iy+0]*g22[iz+0];
s[943] = + g32[ix+0]*g73[iy+0]*g22[iz+0];
s[944] = + g32[ix+0]*g72[iy+0]*g23[iz+0];
s[945] = + g39[ix+0]*g64[iy+0]*g24[iz+0];
s[946] = + g38[ix+0]*g65[iy+0]*g24[iz+0];
s[947] = + g38[ix+0]*g64[iy+0]*g25[iz+0];
s[948] = + g37[ix+0]*g66[iy+0]*g24[iz+0];
s[949] = + g36[ix+0]*g67[iy+0]*g24[iz+0];
s[950] = + g36[ix+0]*g66[iy+0]*g25[iz+0];
s[951] = + g37[ix+0]*g64[iy+0]*g26[iz+0];
s[952] = + g36[ix+0]*g65[iy+0]*g26[iz+0];
s[953] = + g36[ix+0]*g64[iy+0]*g27[iz+0];
s[954] = + g35[ix+0]*g68[iy+0]*g24[iz+0];
s[955] = + g34[ix+0]*g69[iy+0]*g24[iz+0];
s[956] = + g34[ix+0]*g68[iy+0]*g25[iz+0];
s[957] = + g33[ix+0]*g70[iy+0]*g24[iz+0];
s[958] = + g32[ix+0]*g71[iy+0]*g24[iz+0];
s[959] = + g32[ix+0]*g70[iy+0]*g25[iz+0];
s[960] = + g33[ix+0]*g68[iy+0]*g26[iz+0];
s[961] = + g32[ix+0]*g69[iy+0]*g26[iz+0];
s[962] = + g32[ix+0]*g68[iy+0]*g27[iz+0];
s[963] = + g35[ix+0]*g64[iy+0]*g28[iz+0];
s[964] = + g34[ix+0]*g65[iy+0]*g28[iz+0];
s[965] = + g34[ix+0]*g64[iy+0]*g29[iz+0];
s[966] = + g33[ix+0]*g66[iy+0]*g28[iz+0];
s[967] = + g32[ix+0]*g67[iy+0]*g28[iz+0];
s[968] = + g32[ix+0]*g66[iy+0]*g29[iz+0];
s[969] = + g33[ix+0]*g64[iy+0]*g30[iz+0];
s[970] = + g32[ix+0]*g65[iy+0]*g30[iz+0];
s[971] = + g32[ix+0]*g64[iy+0]*g31[iz+0];
s[972] = + g31[ix+0]*g96[iy+0]*g0[iz+0];
s[973] = + g30[ix+0]*g97[iy+0]*g0[iz+0];
s[974] = + g30[ix+0]*g96[iy+0]*g1[iz+0];
s[975] = + g29[ix+0]*g98[iy+0]*g0[iz+0];
s[976] = + g28[ix+0]*g99[iy+0]*g0[iz+0];
s[977] = + g28[ix+0]*g98[iy+0]*g1[iz+0];
s[978] = + g29[ix+0]*g96[iy+0]*g2[iz+0];
s[979] = + g28[ix+0]*g97[iy+0]*g2[iz+0];
s[980] = + g28[ix+0]*g96[iy+0]*g3[iz+0];
s[981] = + g27[ix+0]*g100[iy+0]*g0[iz+0];
s[982] = + g26[ix+0]*g101[iy+0]*g0[iz+0];
s[983] = + g26[ix+0]*g100[iy+0]*g1[iz+0];
s[984] = + g25[ix+0]*g102[iy+0]*g0[iz+0];
s[985] = + g24[ix+0]*g103[iy+0]*g0[iz+0];
s[986] = + g24[ix+0]*g102[iy+0]*g1[iz+0];
s[987] = + g25[ix+0]*g100[iy+0]*g2[iz+0];
s[988] = + g24[ix+0]*g101[iy+0]*g2[iz+0];
s[989] = + g24[ix+0]*g100[iy+0]*g3[iz+0];
s[990] = + g27[ix+0]*g96[iy+0]*g4[iz+0];
s[991] = + g26[ix+0]*g97[iy+0]*g4[iz+0];
s[992] = + g26[ix+0]*g96[iy+0]*g5[iz+0];
s[993] = + g25[ix+0]*g98[iy+0]*g4[iz+0];
s[994] = + g24[ix+0]*g99[iy+0]*g4[iz+0];
s[995] = + g24[ix+0]*g98[iy+0]*g5[iz+0];
s[996] = + g25[ix+0]*g96[iy+0]*g6[iz+0];
s[997] = + g24[ix+0]*g97[iy+0]*g6[iz+0];
s[998] = + g24[ix+0]*g96[iy+0]*g7[iz+0];
s[999] = + g23[ix+0]*g104[iy+0]*g0[iz+0];
s[1000] = + g22[ix+0]*g105[iy+0]*g0[iz+0];
s[1001] = + g22[ix+0]*g104[iy+0]*g1[iz+0];
s[1002] = + g21[ix+0]*g106[iy+0]*g0[iz+0];
s[1003] = + g20[ix+0]*g107[iy+0]*g0[iz+0];
s[1004] = + g20[ix+0]*g106[iy+0]*g1[iz+0];
s[1005] = + g21[ix+0]*g104[iy+0]*g2[iz+0];
s[1006] = + g20[ix+0]*g105[iy+0]*g2[iz+0];
s[1007] = + g20[ix+0]*g104[iy+0]*g3[iz+0];
s[1008] = + g19[ix+0]*g108[iy+0]*g0[iz+0];
s[1009] = + g18[ix+0]*g109[iy+0]*g0[iz+0];
s[1010] = + g18[ix+0]*g108[iy+0]*g1[iz+0];
s[1011] = + g17[ix+0]*g110[iy+0]*g0[iz+0];
s[1012] = + g16[ix+0]*g111[iy+0]*g0[iz+0];
s[1013] = + g16[ix+0]*g110[iy+0]*g1[iz+0];
s[1014] = + g17[ix+0]*g108[iy+0]*g2[iz+0];
s[1015] = + g16[ix+0]*g109[iy+0]*g2[iz+0];
s[1016] = + g16[ix+0]*g108[iy+0]*g3[iz+0];
s[1017] = + g19[ix+0]*g104[iy+0]*g4[iz+0];
s[1018] = + g18[ix+0]*g105[iy+0]*g4[iz+0];
s[1019] = + g18[ix+0]*g104[iy+0]*g5[iz+0];
s[1020] = + g17[ix+0]*g106[iy+0]*g4[iz+0];
s[1021] = + g16[ix+0]*g107[iy+0]*g4[iz+0];
s[1022] = + g16[ix+0]*g106[iy+0]*g5[iz+0];
s[1023] = + g17[ix+0]*g104[iy+0]*g6[iz+0];
s[1024] = + g16[ix+0]*g105[iy+0]*g6[iz+0];
s[1025] = + g16[ix+0]*g104[iy+0]*g7[iz+0];
s[1026] = + g23[ix+0]*g96[iy+0]*g8[iz+0];
s[1027] = + g22[ix+0]*g97[iy+0]*g8[iz+0];
s[1028] = + g22[ix+0]*g96[iy+0]*g9[iz+0];
s[1029] = + g21[ix+0]*g98[iy+0]*g8[iz+0];
s[1030] = + g20[ix+0]*g99[iy+0]*g8[iz+0];
s[1031] = + g20[ix+0]*g98[iy+0]*g9[iz+0];
s[1032] = + g21[ix+0]*g96[iy+0]*g10[iz+0];
s[1033] = + g20[ix+0]*g97[iy+0]*g10[iz+0];
s[1034] = + g20[ix+0]*g96[iy+0]*g11[iz+0];
s[1035] = + g19[ix+0]*g100[iy+0]*g8[iz+0];
s[1036] = + g18[ix+0]*g101[iy+0]*g8[iz+0];
s[1037] = + g18[ix+0]*g100[iy+0]*g9[iz+0];
s[1038] = + g17[ix+0]*g102[iy+0]*g8[iz+0];
s[1039] = + g16[ix+0]*g103[iy+0]*g8[iz+0];
s[1040] = + g16[ix+0]*g102[iy+0]*g9[iz+0];
s[1041] = + g17[ix+0]*g100[iy+0]*g10[iz+0];
s[1042] = + g16[ix+0]*g101[iy+0]*g10[iz+0];
s[1043] = + g16[ix+0]*g100[iy+0]*g11[iz+0];
s[1044] = + g19[ix+0]*g96[iy+0]*g12[iz+0];
s[1045] = + g18[ix+0]*g97[iy+0]*g12[iz+0];
s[1046] = + g18[ix+0]*g96[iy+0]*g13[iz+0];
s[1047] = + g17[ix+0]*g98[iy+0]*g12[iz+0];
s[1048] = + g16[ix+0]*g99[iy+0]*g12[iz+0];
s[1049] = + g16[ix+0]*g98[iy+0]*g13[iz+0];
s[1050] = + g17[ix+0]*g96[iy+0]*g14[iz+0];
s[1051] = + g16[ix+0]*g97[iy+0]*g14[iz+0];
s[1052] = + g16[ix+0]*g96[iy+0]*g15[iz+0];
s[1053] = + g15[ix+0]*g112[iy+0]*g0[iz+0];
s[1054] = + g14[ix+0]*g113[iy+0]*g0[iz+0];
s[1055] = + g14[ix+0]*g112[iy+0]*g1[iz+0];
s[1056] = + g13[ix+0]*g114[iy+0]*g0[iz+0];
s[1057] = + g12[ix+0]*g115[iy+0]*g0[iz+0];
s[1058] = + g12[ix+0]*g114[iy+0]*g1[iz+0];
s[1059] = + g13[ix+0]*g112[iy+0]*g2[iz+0];
s[1060] = + g12[ix+0]*g113[iy+0]*g2[iz+0];
s[1061] = + g12[ix+0]*g112[iy+0]*g3[iz+0];
s[1062] = + g11[ix+0]*g116[iy+0]*g0[iz+0];
s[1063] = + g10[ix+0]*g117[iy+0]*g0[iz+0];
s[1064] = + g10[ix+0]*g116[iy+0]*g1[iz+0];
s[1065] = + g9[ix+0]*g118[iy+0]*g0[iz+0];
s[1066] = + g8[ix+0]*g119[iy+0]*g0[iz+0];
s[1067] = + g8[ix+0]*g118[iy+0]*g1[iz+0];
s[1068] = + g9[ix+0]*g116[iy+0]*g2[iz+0];
s[1069] = + g8[ix+0]*g117[iy+0]*g2[iz+0];
s[1070] = + g8[ix+0]*g116[iy+0]*g3[iz+0];
s[1071] = + g11[ix+0]*g112[iy+0]*g4[iz+0];
s[1072] = + g10[ix+0]*g113[iy+0]*g4[iz+0];
s[1073] = + g10[ix+0]*g112[iy+0]*g5[iz+0];
s[1074] = + g9[ix+0]*g114[iy+0]*g4[iz+0];
s[1075] = + g8[ix+0]*g115[iy+0]*g4[iz+0];
s[1076] = + g8[ix+0]*g114[iy+0]*g5[iz+0];
s[1077] = + g9[ix+0]*g112[iy+0]*g6[iz+0];
s[1078] = + g8[ix+0]*g113[iy+0]*g6[iz+0];
s[1079] = + g8[ix+0]*g112[iy+0]*g7[iz+0];
s[1080] = + g7[ix+0]*g120[iy+0]*g0[iz+0];
s[1081] = + g6[ix+0]*g121[iy+0]*g0[iz+0];
s[1082] = + g6[ix+0]*g120[iy+0]*g1[iz+0];
s[1083] = + g5[ix+0]*g122[iy+0]*g0[iz+0];
s[1084] = + g4[ix+0]*g123[iy+0]*g0[iz+0];
s[1085] = + g4[ix+0]*g122[iy+0]*g1[iz+0];
s[1086] = + g5[ix+0]*g120[iy+0]*g2[iz+0];
s[1087] = + g4[ix+0]*g121[iy+0]*g2[iz+0];
s[1088] = + g4[ix+0]*g120[iy+0]*g3[iz+0];
s[1089] = + g3[ix+0]*g124[iy+0]*g0[iz+0];
s[1090] = + g2[ix+0]*g125[iy+0]*g0[iz+0];
s[1091] = + g2[ix+0]*g124[iy+0]*g1[iz+0];
s[1092] = + g1[ix+0]*g126[iy+0]*g0[iz+0];
s[1093] = + g0[ix+0]*g127[iy+0]*g0[iz+0];
s[1094] = + g0[ix+0]*g126[iy+0]*g1[iz+0];
s[1095] = + g1[ix+0]*g124[iy+0]*g2[iz+0];
s[1096] = + g0[ix+0]*g125[iy+0]*g2[iz+0];
s[1097] = + g0[ix+0]*g124[iy+0]*g3[iz+0];
s[1098] = + g3[ix+0]*g120[iy+0]*g4[iz+0];
s[1099] = + g2[ix+0]*g121[iy+0]*g4[iz+0];
s[1100] = + g2[ix+0]*g120[iy+0]*g5[iz+0];
s[1101] = + g1[ix+0]*g122[iy+0]*g4[iz+0];
s[1102] = + g0[ix+0]*g123[iy+0]*g4[iz+0];
s[1103] = + g0[ix+0]*g122[iy+0]*g5[iz+0];
s[1104] = + g1[ix+0]*g120[iy+0]*g6[iz+0];
s[1105] = + g0[ix+0]*g121[iy+0]*g6[iz+0];
s[1106] = + g0[ix+0]*g120[iy+0]*g7[iz+0];
s[1107] = + g7[ix+0]*g112[iy+0]*g8[iz+0];
s[1108] = + g6[ix+0]*g113[iy+0]*g8[iz+0];
s[1109] = + g6[ix+0]*g112[iy+0]*g9[iz+0];
s[1110] = + g5[ix+0]*g114[iy+0]*g8[iz+0];
s[1111] = + g4[ix+0]*g115[iy+0]*g8[iz+0];
s[1112] = + g4[ix+0]*g114[iy+0]*g9[iz+0];
s[1113] = + g5[ix+0]*g112[iy+0]*g10[iz+0];
s[1114] = + g4[ix+0]*g113[iy+0]*g10[iz+0];
s[1115] = + g4[ix+0]*g112[iy+0]*g11[iz+0];
s[1116] = + g3[ix+0]*g116[iy+0]*g8[iz+0];
s[1117] = + g2[ix+0]*g117[iy+0]*g8[iz+0];
s[1118] = + g2[ix+0]*g116[iy+0]*g9[iz+0];
s[1119] = + g1[ix+0]*g118[iy+0]*g8[iz+0];
s[1120] = + g0[ix+0]*g119[iy+0]*g8[iz+0];
s[1121] = + g0[ix+0]*g118[iy+0]*g9[iz+0];
s[1122] = + g1[ix+0]*g116[iy+0]*g10[iz+0];
s[1123] = + g0[ix+0]*g117[iy+0]*g10[iz+0];
s[1124] = + g0[ix+0]*g116[iy+0]*g11[iz+0];
s[1125] = + g3[ix+0]*g112[iy+0]*g12[iz+0];
s[1126] = + g2[ix+0]*g113[iy+0]*g12[iz+0];
s[1127] = + g2[ix+0]*g112[iy+0]*g13[iz+0];
s[1128] = + g1[ix+0]*g114[iy+0]*g12[iz+0];
s[1129] = + g0[ix+0]*g115[iy+0]*g12[iz+0];
s[1130] = + g0[ix+0]*g114[iy+0]*g13[iz+0];
s[1131] = + g1[ix+0]*g112[iy+0]*g14[iz+0];
s[1132] = + g0[ix+0]*g113[iy+0]*g14[iz+0];
s[1133] = + g0[ix+0]*g112[iy+0]*g15[iz+0];
s[1134] = + g15[ix+0]*g96[iy+0]*g16[iz+0];
s[1135] = + g14[ix+0]*g97[iy+0]*g16[iz+0];
s[1136] = + g14[ix+0]*g96[iy+0]*g17[iz+0];
s[1137] = + g13[ix+0]*g98[iy+0]*g16[iz+0];
s[1138] = + g12[ix+0]*g99[iy+0]*g16[iz+0];
s[1139] = + g12[ix+0]*g98[iy+0]*g17[iz+0];
s[1140] = + g13[ix+0]*g96[iy+0]*g18[iz+0];
s[1141] = + g12[ix+0]*g97[iy+0]*g18[iz+0];
s[1142] = + g12[ix+0]*g96[iy+0]*g19[iz+0];
s[1143] = + g11[ix+0]*g100[iy+0]*g16[iz+0];
s[1144] = + g10[ix+0]*g101[iy+0]*g16[iz+0];
s[1145] = + g10[ix+0]*g100[iy+0]*g17[iz+0];
s[1146] = + g9[ix+0]*g102[iy+0]*g16[iz+0];
s[1147] = + g8[ix+0]*g103[iy+0]*g16[iz+0];
s[1148] = + g8[ix+0]*g102[iy+0]*g17[iz+0];
s[1149] = + g9[ix+0]*g100[iy+0]*g18[iz+0];
s[1150] = + g8[ix+0]*g101[iy+0]*g18[iz+0];
s[1151] = + g8[ix+0]*g100[iy+0]*g19[iz+0];
s[1152] = + g11[ix+0]*g96[iy+0]*g20[iz+0];
s[1153] = + g10[ix+0]*g97[iy+0]*g20[iz+0];
s[1154] = + g10[ix+0]*g96[iy+0]*g21[iz+0];
s[1155] = + g9[ix+0]*g98[iy+0]*g20[iz+0];
s[1156] = + g8[ix+0]*g99[iy+0]*g20[iz+0];
s[1157] = + g8[ix+0]*g98[iy+0]*g21[iz+0];
s[1158] = + g9[ix+0]*g96[iy+0]*g22[iz+0];
s[1159] = + g8[ix+0]*g97[iy+0]*g22[iz+0];
s[1160] = + g8[ix+0]*g96[iy+0]*g23[iz+0];
s[1161] = + g7[ix+0]*g104[iy+0]*g16[iz+0];
s[1162] = + g6[ix+0]*g105[iy+0]*g16[iz+0];
s[1163] = + g6[ix+0]*g104[iy+0]*g17[iz+0];
s[1164] = + g5[ix+0]*g106[iy+0]*g16[iz+0];
s[1165] = + g4[ix+0]*g107[iy+0]*g16[iz+0];
s[1166] = + g4[ix+0]*g106[iy+0]*g17[iz+0];
s[1167] = + g5[ix+0]*g104[iy+0]*g18[iz+0];
s[1168] = + g4[ix+0]*g105[iy+0]*g18[iz+0];
s[1169] = + g4[ix+0]*g104[iy+0]*g19[iz+0];
s[1170] = + g3[ix+0]*g108[iy+0]*g16[iz+0];
s[1171] = + g2[ix+0]*g109[iy+0]*g16[iz+0];
s[1172] = + g2[ix+0]*g108[iy+0]*g17[iz+0];
s[1173] = + g1[ix+0]*g110[iy+0]*g16[iz+0];
s[1174] = + g0[ix+0]*g111[iy+0]*g16[iz+0];
s[1175] = + g0[ix+0]*g110[iy+0]*g17[iz+0];
s[1176] = + g1[ix+0]*g108[iy+0]*g18[iz+0];
s[1177] = + g0[ix+0]*g109[iy+0]*g18[iz+0];
s[1178] = + g0[ix+0]*g108[iy+0]*g19[iz+0];
s[1179] = + g3[ix+0]*g104[iy+0]*g20[iz+0];
s[1180] = + g2[ix+0]*g105[iy+0]*g20[iz+0];
s[1181] = + g2[ix+0]*g104[iy+0]*g21[iz+0];
s[1182] = + g1[ix+0]*g106[iy+0]*g20[iz+0];
s[1183] = + g0[ix+0]*g107[iy+0]*g20[iz+0];
s[1184] = + g0[ix+0]*g106[iy+0]*g21[iz+0];
s[1185] = + g1[ix+0]*g104[iy+0]*g22[iz+0];
s[1186] = + g0[ix+0]*g105[iy+0]*g22[iz+0];
s[1187] = + g0[ix+0]*g104[iy+0]*g23[iz+0];
s[1188] = + g7[ix+0]*g96[iy+0]*g24[iz+0];
s[1189] = + g6[ix+0]*g97[iy+0]*g24[iz+0];
s[1190] = + g6[ix+0]*g96[iy+0]*g25[iz+0];
s[1191] = + g5[ix+0]*g98[iy+0]*g24[iz+0];
s[1192] = + g4[ix+0]*g99[iy+0]*g24[iz+0];
s[1193] = + g4[ix+0]*g98[iy+0]*g25[iz+0];
s[1194] = + g5[ix+0]*g96[iy+0]*g26[iz+0];
s[1195] = + g4[ix+0]*g97[iy+0]*g26[iz+0];
s[1196] = + g4[ix+0]*g96[iy+0]*g27[iz+0];
s[1197] = + g3[ix+0]*g100[iy+0]*g24[iz+0];
s[1198] = + g2[ix+0]*g101[iy+0]*g24[iz+0];
s[1199] = + g2[ix+0]*g100[iy+0]*g25[iz+0];
s[1200] = + g1[ix+0]*g102[iy+0]*g24[iz+0];
s[1201] = + g0[ix+0]*g103[iy+0]*g24[iz+0];
s[1202] = + g0[ix+0]*g102[iy+0]*g25[iz+0];
s[1203] = + g1[ix+0]*g100[iy+0]*g26[iz+0];
s[1204] = + g0[ix+0]*g101[iy+0]*g26[iz+0];
s[1205] = + g0[ix+0]*g100[iy+0]*g27[iz+0];
s[1206] = + g3[ix+0]*g96[iy+0]*g28[iz+0];
s[1207] = + g2[ix+0]*g97[iy+0]*g28[iz+0];
s[1208] = + g2[ix+0]*g96[iy+0]*g29[iz+0];
s[1209] = + g1[ix+0]*g98[iy+0]*g28[iz+0];
s[1210] = + g0[ix+0]*g99[iy+0]*g28[iz+0];
s[1211] = + g0[ix+0]*g98[iy+0]*g29[iz+0];
s[1212] = + g1[ix+0]*g96[iy+0]*g30[iz+0];
s[1213] = + g0[ix+0]*g97[iy+0]*g30[iz+0];
s[1214] = + g0[ix+0]*g96[iy+0]*g31[iz+0];
s[1215] = + g31[ix+0]*g64[iy+0]*g32[iz+0];
s[1216] = + g30[ix+0]*g65[iy+0]*g32[iz+0];
s[1217] = + g30[ix+0]*g64[iy+0]*g33[iz+0];
s[1218] = + g29[ix+0]*g66[iy+0]*g32[iz+0];
s[1219] = + g28[ix+0]*g67[iy+0]*g32[iz+0];
s[1220] = + g28[ix+0]*g66[iy+0]*g33[iz+0];
s[1221] = + g29[ix+0]*g64[iy+0]*g34[iz+0];
s[1222] = + g28[ix+0]*g65[iy+0]*g34[iz+0];
s[1223] = + g28[ix+0]*g64[iy+0]*g35[iz+0];
s[1224] = + g27[ix+0]*g68[iy+0]*g32[iz+0];
s[1225] = + g26[ix+0]*g69[iy+0]*g32[iz+0];
s[1226] = + g26[ix+0]*g68[iy+0]*g33[iz+0];
s[1227] = + g25[ix+0]*g70[iy+0]*g32[iz+0];
s[1228] = + g24[ix+0]*g71[iy+0]*g32[iz+0];
s[1229] = + g24[ix+0]*g70[iy+0]*g33[iz+0];
s[1230] = + g25[ix+0]*g68[iy+0]*g34[iz+0];
s[1231] = + g24[ix+0]*g69[iy+0]*g34[iz+0];
s[1232] = + g24[ix+0]*g68[iy+0]*g35[iz+0];
s[1233] = + g27[ix+0]*g64[iy+0]*g36[iz+0];
s[1234] = + g26[ix+0]*g65[iy+0]*g36[iz+0];
s[1235] = + g26[ix+0]*g64[iy+0]*g37[iz+0];
s[1236] = + g25[ix+0]*g66[iy+0]*g36[iz+0];
s[1237] = + g24[ix+0]*g67[iy+0]*g36[iz+0];
s[1238] = + g24[ix+0]*g66[iy+0]*g37[iz+0];
s[1239] = + g25[ix+0]*g64[iy+0]*g38[iz+0];
s[1240] = + g24[ix+0]*g65[iy+0]*g38[iz+0];
s[1241] = + g24[ix+0]*g64[iy+0]*g39[iz+0];
s[1242] = + g23[ix+0]*g72[iy+0]*g32[iz+0];
s[1243] = + g22[ix+0]*g73[iy+0]*g32[iz+0];
s[1244] = + g22[ix+0]*g72[iy+0]*g33[iz+0];
s[1245] = + g21[ix+0]*g74[iy+0]*g32[iz+0];
s[1246] = + g20[ix+0]*g75[iy+0]*g32[iz+0];
s[1247] = + g20[ix+0]*g74[iy+0]*g33[iz+0];
s[1248] = + g21[ix+0]*g72[iy+0]*g34[iz+0];
s[1249] = + g20[ix+0]*g73[iy+0]*g34[iz+0];
s[1250] = + g20[ix+0]*g72[iy+0]*g35[iz+0];
s[1251] = + g19[ix+0]*g76[iy+0]*g32[iz+0];
s[1252] = + g18[ix+0]*g77[iy+0]*g32[iz+0];
s[1253] = + g18[ix+0]*g76[iy+0]*g33[iz+0];
s[1254] = + g17[ix+0]*g78[iy+0]*g32[iz+0];
s[1255] = + g16[ix+0]*g79[iy+0]*g32[iz+0];
s[1256] = + g16[ix+0]*g78[iy+0]*g33[iz+0];
s[1257] = + g17[ix+0]*g76[iy+0]*g34[iz+0];
s[1258] = + g16[ix+0]*g77[iy+0]*g34[iz+0];
s[1259] = + g16[ix+0]*g76[iy+0]*g35[iz+0];
s[1260] = + g19[ix+0]*g72[iy+0]*g36[iz+0];
s[1261] = + g18[ix+0]*g73[iy+0]*g36[iz+0];
s[1262] = + g18[ix+0]*g72[iy+0]*g37[iz+0];
s[1263] = + g17[ix+0]*g74[iy+0]*g36[iz+0];
s[1264] = + g16[ix+0]*g75[iy+0]*g36[iz+0];
s[1265] = + g16[ix+0]*g74[iy+0]*g37[iz+0];
s[1266] = + g17[ix+0]*g72[iy+0]*g38[iz+0];
s[1267] = + g16[ix+0]*g73[iy+0]*g38[iz+0];
s[1268] = + g16[ix+0]*g72[iy+0]*g39[iz+0];
s[1269] = + g23[ix+0]*g64[iy+0]*g40[iz+0];
s[1270] = + g22[ix+0]*g65[iy+0]*g40[iz+0];
s[1271] = + g22[ix+0]*g64[iy+0]*g41[iz+0];
s[1272] = + g21[ix+0]*g66[iy+0]*g40[iz+0];
s[1273] = + g20[ix+0]*g67[iy+0]*g40[iz+0];
s[1274] = + g20[ix+0]*g66[iy+0]*g41[iz+0];
s[1275] = + g21[ix+0]*g64[iy+0]*g42[iz+0];
s[1276] = + g20[ix+0]*g65[iy+0]*g42[iz+0];
s[1277] = + g20[ix+0]*g64[iy+0]*g43[iz+0];
s[1278] = + g19[ix+0]*g68[iy+0]*g40[iz+0];
s[1279] = + g18[ix+0]*g69[iy+0]*g40[iz+0];
s[1280] = + g18[ix+0]*g68[iy+0]*g41[iz+0];
s[1281] = + g17[ix+0]*g70[iy+0]*g40[iz+0];
s[1282] = + g16[ix+0]*g71[iy+0]*g40[iz+0];
s[1283] = + g16[ix+0]*g70[iy+0]*g41[iz+0];
s[1284] = + g17[ix+0]*g68[iy+0]*g42[iz+0];
s[1285] = + g16[ix+0]*g69[iy+0]*g42[iz+0];
s[1286] = + g16[ix+0]*g68[iy+0]*g43[iz+0];
s[1287] = + g19[ix+0]*g64[iy+0]*g44[iz+0];
s[1288] = + g18[ix+0]*g65[iy+0]*g44[iz+0];
s[1289] = + g18[ix+0]*g64[iy+0]*g45[iz+0];
s[1290] = + g17[ix+0]*g66[iy+0]*g44[iz+0];
s[1291] = + g16[ix+0]*g67[iy+0]*g44[iz+0];
s[1292] = + g16[ix+0]*g66[iy+0]*g45[iz+0];
s[1293] = + g17[ix+0]*g64[iy+0]*g46[iz+0];
s[1294] = + g16[ix+0]*g65[iy+0]*g46[iz+0];
s[1295] = + g16[ix+0]*g64[iy+0]*g47[iz+0];
s[1296] = + g15[ix+0]*g80[iy+0]*g32[iz+0];
s[1297] = + g14[ix+0]*g81[iy+0]*g32[iz+0];
s[1298] = + g14[ix+0]*g80[iy+0]*g33[iz+0];
s[1299] = + g13[ix+0]*g82[iy+0]*g32[iz+0];
s[1300] = + g12[ix+0]*g83[iy+0]*g32[iz+0];
s[1301] = + g12[ix+0]*g82[iy+0]*g33[iz+0];
s[1302] = + g13[ix+0]*g80[iy+0]*g34[iz+0];
s[1303] = + g12[ix+0]*g81[iy+0]*g34[iz+0];
s[1304] = + g12[ix+0]*g80[iy+0]*g35[iz+0];
s[1305] = + g11[ix+0]*g84[iy+0]*g32[iz+0];
s[1306] = + g10[ix+0]*g85[iy+0]*g32[iz+0];
s[1307] = + g10[ix+0]*g84[iy+0]*g33[iz+0];
s[1308] = + g9[ix+0]*g86[iy+0]*g32[iz+0];
s[1309] = + g8[ix+0]*g87[iy+0]*g32[iz+0];
s[1310] = + g8[ix+0]*g86[iy+0]*g33[iz+0];
s[1311] = + g9[ix+0]*g84[iy+0]*g34[iz+0];
s[1312] = + g8[ix+0]*g85[iy+0]*g34[iz+0];
s[1313] = + g8[ix+0]*g84[iy+0]*g35[iz+0];
s[1314] = + g11[ix+0]*g80[iy+0]*g36[iz+0];
s[1315] = + g10[ix+0]*g81[iy+0]*g36[iz+0];
s[1316] = + g10[ix+0]*g80[iy+0]*g37[iz+0];
s[1317] = + g9[ix+0]*g82[iy+0]*g36[iz+0];
s[1318] = + g8[ix+0]*g83[iy+0]*g36[iz+0];
s[1319] = + g8[ix+0]*g82[iy+0]*g37[iz+0];
s[1320] = + g9[ix+0]*g80[iy+0]*g38[iz+0];
s[1321] = + g8[ix+0]*g81[iy+0]*g38[iz+0];
s[1322] = + g8[ix+0]*g80[iy+0]*g39[iz+0];
s[1323] = + g7[ix+0]*g88[iy+0]*g32[iz+0];
s[1324] = + g6[ix+0]*g89[iy+0]*g32[iz+0];
s[1325] = + g6[ix+0]*g88[iy+0]*g33[iz+0];
s[1326] = + g5[ix+0]*g90[iy+0]*g32[iz+0];
s[1327] = + g4[ix+0]*g91[iy+0]*g32[iz+0];
s[1328] = + g4[ix+0]*g90[iy+0]*g33[iz+0];
s[1329] = + g5[ix+0]*g88[iy+0]*g34[iz+0];
s[1330] = + g4[ix+0]*g89[iy+0]*g34[iz+0];
s[1331] = + g4[ix+0]*g88[iy+0]*g35[iz+0];
s[1332] = + g3[ix+0]*g92[iy+0]*g32[iz+0];
s[1333] = + g2[ix+0]*g93[iy+0]*g32[iz+0];
s[1334] = + g2[ix+0]*g92[iy+0]*g33[iz+0];
s[1335] = + g1[ix+0]*g94[iy+0]*g32[iz+0];
s[1336] = + g0[ix+0]*g95[iy+0]*g32[iz+0];
s[1337] = + g0[ix+0]*g94[iy+0]*g33[iz+0];
s[1338] = + g1[ix+0]*g92[iy+0]*g34[iz+0];
s[1339] = + g0[ix+0]*g93[iy+0]*g34[iz+0];
s[1340] = + g0[ix+0]*g92[iy+0]*g35[iz+0];
s[1341] = + g3[ix+0]*g88[iy+0]*g36[iz+0];
s[1342] = + g2[ix+0]*g89[iy+0]*g36[iz+0];
s[1343] = + g2[ix+0]*g88[iy+0]*g37[iz+0];
s[1344] = + g1[ix+0]*g90[iy+0]*g36[iz+0];
s[1345] = + g0[ix+0]*g91[iy+0]*g36[iz+0];
s[1346] = + g0[ix+0]*g90[iy+0]*g37[iz+0];
s[1347] = + g1[ix+0]*g88[iy+0]*g38[iz+0];
s[1348] = + g0[ix+0]*g89[iy+0]*g38[iz+0];
s[1349] = + g0[ix+0]*g88[iy+0]*g39[iz+0];
s[1350] = + g7[ix+0]*g80[iy+0]*g40[iz+0];
s[1351] = + g6[ix+0]*g81[iy+0]*g40[iz+0];
s[1352] = + g6[ix+0]*g80[iy+0]*g41[iz+0];
s[1353] = + g5[ix+0]*g82[iy+0]*g40[iz+0];
s[1354] = + g4[ix+0]*g83[iy+0]*g40[iz+0];
s[1355] = + g4[ix+0]*g82[iy+0]*g41[iz+0];
s[1356] = + g5[ix+0]*g80[iy+0]*g42[iz+0];
s[1357] = + g4[ix+0]*g81[iy+0]*g42[iz+0];
s[1358] = + g4[ix+0]*g80[iy+0]*g43[iz+0];
s[1359] = + g3[ix+0]*g84[iy+0]*g40[iz+0];
s[1360] = + g2[ix+0]*g85[iy+0]*g40[iz+0];
s[1361] = + g2[ix+0]*g84[iy+0]*g41[iz+0];
s[1362] = + g1[ix+0]*g86[iy+0]*g40[iz+0];
s[1363] = + g0[ix+0]*g87[iy+0]*g40[iz+0];
s[1364] = + g0[ix+0]*g86[iy+0]*g41[iz+0];
s[1365] = + g1[ix+0]*g84[iy+0]*g42[iz+0];
s[1366] = + g0[ix+0]*g85[iy+0]*g42[iz+0];
s[1367] = + g0[ix+0]*g84[iy+0]*g43[iz+0];
s[1368] = + g3[ix+0]*g80[iy+0]*g44[iz+0];
s[1369] = + g2[ix+0]*g81[iy+0]*g44[iz+0];
s[1370] = + g2[ix+0]*g80[iy+0]*g45[iz+0];
s[1371] = + g1[ix+0]*g82[iy+0]*g44[iz+0];
s[1372] = + g0[ix+0]*g83[iy+0]*g44[iz+0];
s[1373] = + g0[ix+0]*g82[iy+0]*g45[iz+0];
s[1374] = + g1[ix+0]*g80[iy+0]*g46[iz+0];
s[1375] = + g0[ix+0]*g81[iy+0]*g46[iz+0];
s[1376] = + g0[ix+0]*g80[iy+0]*g47[iz+0];
s[1377] = + g15[ix+0]*g64[iy+0]*g48[iz+0];
s[1378] = + g14[ix+0]*g65[iy+0]*g48[iz+0];
s[1379] = + g14[ix+0]*g64[iy+0]*g49[iz+0];
s[1380] = + g13[ix+0]*g66[iy+0]*g48[iz+0];
s[1381] = + g12[ix+0]*g67[iy+0]*g48[iz+0];
s[1382] = + g12[ix+0]*g66[iy+0]*g49[iz+0];
s[1383] = + g13[ix+0]*g64[iy+0]*g50[iz+0];
s[1384] = + g12[ix+0]*g65[iy+0]*g50[iz+0];
s[1385] = + g12[ix+0]*g64[iy+0]*g51[iz+0];
s[1386] = + g11[ix+0]*g68[iy+0]*g48[iz+0];
s[1387] = + g10[ix+0]*g69[iy+0]*g48[iz+0];
s[1388] = + g10[ix+0]*g68[iy+0]*g49[iz+0];
s[1389] = + g9[ix+0]*g70[iy+0]*g48[iz+0];
s[1390] = + g8[ix+0]*g71[iy+0]*g48[iz+0];
s[1391] = + g8[ix+0]*g70[iy+0]*g49[iz+0];
s[1392] = + g9[ix+0]*g68[iy+0]*g50[iz+0];
s[1393] = + g8[ix+0]*g69[iy+0]*g50[iz+0];
s[1394] = + g8[ix+0]*g68[iy+0]*g51[iz+0];
s[1395] = + g11[ix+0]*g64[iy+0]*g52[iz+0];
s[1396] = + g10[ix+0]*g65[iy+0]*g52[iz+0];
s[1397] = + g10[ix+0]*g64[iy+0]*g53[iz+0];
s[1398] = + g9[ix+0]*g66[iy+0]*g52[iz+0];
s[1399] = + g8[ix+0]*g67[iy+0]*g52[iz+0];
s[1400] = + g8[ix+0]*g66[iy+0]*g53[iz+0];
s[1401] = + g9[ix+0]*g64[iy+0]*g54[iz+0];
s[1402] = + g8[ix+0]*g65[iy+0]*g54[iz+0];
s[1403] = + g8[ix+0]*g64[iy+0]*g55[iz+0];
s[1404] = + g7[ix+0]*g72[iy+0]*g48[iz+0];
s[1405] = + g6[ix+0]*g73[iy+0]*g48[iz+0];
s[1406] = + g6[ix+0]*g72[iy+0]*g49[iz+0];
s[1407] = + g5[ix+0]*g74[iy+0]*g48[iz+0];
s[1408] = + g4[ix+0]*g75[iy+0]*g48[iz+0];
s[1409] = + g4[ix+0]*g74[iy+0]*g49[iz+0];
s[1410] = + g5[ix+0]*g72[iy+0]*g50[iz+0];
s[1411] = + g4[ix+0]*g73[iy+0]*g50[iz+0];
s[1412] = + g4[ix+0]*g72[iy+0]*g51[iz+0];
s[1413] = + g3[ix+0]*g76[iy+0]*g48[iz+0];
s[1414] = + g2[ix+0]*g77[iy+0]*g48[iz+0];
s[1415] = + g2[ix+0]*g76[iy+0]*g49[iz+0];
s[1416] = + g1[ix+0]*g78[iy+0]*g48[iz+0];
s[1417] = + g0[ix+0]*g79[iy+0]*g48[iz+0];
s[1418] = + g0[ix+0]*g78[iy+0]*g49[iz+0];
s[1419] = + g1[ix+0]*g76[iy+0]*g50[iz+0];
s[1420] = + g0[ix+0]*g77[iy+0]*g50[iz+0];
s[1421] = + g0[ix+0]*g76[iy+0]*g51[iz+0];
s[1422] = + g3[ix+0]*g72[iy+0]*g52[iz+0];
s[1423] = + g2[ix+0]*g73[iy+0]*g52[iz+0];
s[1424] = + g2[ix+0]*g72[iy+0]*g53[iz+0];
s[1425] = + g1[ix+0]*g74[iy+0]*g52[iz+0];
s[1426] = + g0[ix+0]*g75[iy+0]*g52[iz+0];
s[1427] = + g0[ix+0]*g74[iy+0]*g53[iz+0];
s[1428] = + g1[ix+0]*g72[iy+0]*g54[iz+0];
s[1429] = + g0[ix+0]*g73[iy+0]*g54[iz+0];
s[1430] = + g0[ix+0]*g72[iy+0]*g55[iz+0];
s[1431] = + g7[ix+0]*g64[iy+0]*g56[iz+0];
s[1432] = + g6[ix+0]*g65[iy+0]*g56[iz+0];
s[1433] = + g6[ix+0]*g64[iy+0]*g57[iz+0];
s[1434] = + g5[ix+0]*g66[iy+0]*g56[iz+0];
s[1435] = + g4[ix+0]*g67[iy+0]*g56[iz+0];
s[1436] = + g4[ix+0]*g66[iy+0]*g57[iz+0];
s[1437] = + g5[ix+0]*g64[iy+0]*g58[iz+0];
s[1438] = + g4[ix+0]*g65[iy+0]*g58[iz+0];
s[1439] = + g4[ix+0]*g64[iy+0]*g59[iz+0];
s[1440] = + g3[ix+0]*g68[iy+0]*g56[iz+0];
s[1441] = + g2[ix+0]*g69[iy+0]*g56[iz+0];
s[1442] = + g2[ix+0]*g68[iy+0]*g57[iz+0];
s[1443] = + g1[ix+0]*g70[iy+0]*g56[iz+0];
s[1444] = + g0[ix+0]*g71[iy+0]*g56[iz+0];
s[1445] = + g0[ix+0]*g70[iy+0]*g57[iz+0];
s[1446] = + g1[ix+0]*g68[iy+0]*g58[iz+0];
s[1447] = + g0[ix+0]*g69[iy+0]*g58[iz+0];
s[1448] = + g0[ix+0]*g68[iy+0]*g59[iz+0];
s[1449] = + g3[ix+0]*g64[iy+0]*g60[iz+0];
s[1450] = + g2[ix+0]*g65[iy+0]*g60[iz+0];
s[1451] = + g2[ix+0]*g64[iy+0]*g61[iz+0];
s[1452] = + g1[ix+0]*g66[iy+0]*g60[iz+0];
s[1453] = + g0[ix+0]*g67[iy+0]*g60[iz+0];
s[1454] = + g0[ix+0]*g66[iy+0]*g61[iz+0];
s[1455] = + g1[ix+0]*g64[iy+0]*g62[iz+0];
s[1456] = + g0[ix+0]*g65[iy+0]*g62[iz+0];
s[1457] = + g0[ix+0]*g64[iy+0]*g63[iz+0];
s[1458] = + g63[ix+0]*g0[iy+0]*g64[iz+0];
s[1459] = + g62[ix+0]*g1[iy+0]*g64[iz+0];
s[1460] = + g62[ix+0]*g0[iy+0]*g65[iz+0];
s[1461] = + g61[ix+0]*g2[iy+0]*g64[iz+0];
s[1462] = + g60[ix+0]*g3[iy+0]*g64[iz+0];
s[1463] = + g60[ix+0]*g2[iy+0]*g65[iz+0];
s[1464] = + g61[ix+0]*g0[iy+0]*g66[iz+0];
s[1465] = + g60[ix+0]*g1[iy+0]*g66[iz+0];
s[1466] = + g60[ix+0]*g0[iy+0]*g67[iz+0];
s[1467] = + g59[ix+0]*g4[iy+0]*g64[iz+0];
s[1468] = + g58[ix+0]*g5[iy+0]*g64[iz+0];
s[1469] = + g58[ix+0]*g4[iy+0]*g65[iz+0];
s[1470] = + g57[ix+0]*g6[iy+0]*g64[iz+0];
s[1471] = + g56[ix+0]*g7[iy+0]*g64[iz+0];
s[1472] = + g56[ix+0]*g6[iy+0]*g65[iz+0];
s[1473] = + g57[ix+0]*g4[iy+0]*g66[iz+0];
s[1474] = + g56[ix+0]*g5[iy+0]*g66[iz+0];
s[1475] = + g56[ix+0]*g4[iy+0]*g67[iz+0];
s[1476] = + g59[ix+0]*g0[iy+0]*g68[iz+0];
s[1477] = + g58[ix+0]*g1[iy+0]*g68[iz+0];
s[1478] = + g58[ix+0]*g0[iy+0]*g69[iz+0];
s[1479] = + g57[ix+0]*g2[iy+0]*g68[iz+0];
s[1480] = + g56[ix+0]*g3[iy+0]*g68[iz+0];
s[1481] = + g56[ix+0]*g2[iy+0]*g69[iz+0];
s[1482] = + g57[ix+0]*g0[iy+0]*g70[iz+0];
s[1483] = + g56[ix+0]*g1[iy+0]*g70[iz+0];
s[1484] = + g56[ix+0]*g0[iy+0]*g71[iz+0];
s[1485] = + g55[ix+0]*g8[iy+0]*g64[iz+0];
s[1486] = + g54[ix+0]*g9[iy+0]*g64[iz+0];
s[1487] = + g54[ix+0]*g8[iy+0]*g65[iz+0];
s[1488] = + g53[ix+0]*g10[iy+0]*g64[iz+0];
s[1489] = + g52[ix+0]*g11[iy+0]*g64[iz+0];
s[1490] = + g52[ix+0]*g10[iy+0]*g65[iz+0];
s[1491] = + g53[ix+0]*g8[iy+0]*g66[iz+0];
s[1492] = + g52[ix+0]*g9[iy+0]*g66[iz+0];
s[1493] = + g52[ix+0]*g8[iy+0]*g67[iz+0];
s[1494] = + g51[ix+0]*g12[iy+0]*g64[iz+0];
s[1495] = + g50[ix+0]*g13[iy+0]*g64[iz+0];
s[1496] = + g50[ix+0]*g12[iy+0]*g65[iz+0];
s[1497] = + g49[ix+0]*g14[iy+0]*g64[iz+0];
s[1498] = + g48[ix+0]*g15[iy+0]*g64[iz+0];
s[1499] = + g48[ix+0]*g14[iy+0]*g65[iz+0];
s[1500] = + g49[ix+0]*g12[iy+0]*g66[iz+0];
s[1501] = + g48[ix+0]*g13[iy+0]*g66[iz+0];
s[1502] = + g48[ix+0]*g12[iy+0]*g67[iz+0];
s[1503] = + g51[ix+0]*g8[iy+0]*g68[iz+0];
s[1504] = + g50[ix+0]*g9[iy+0]*g68[iz+0];
s[1505] = + g50[ix+0]*g8[iy+0]*g69[iz+0];
s[1506] = + g49[ix+0]*g10[iy+0]*g68[iz+0];
s[1507] = + g48[ix+0]*g11[iy+0]*g68[iz+0];
s[1508] = + g48[ix+0]*g10[iy+0]*g69[iz+0];
s[1509] = + g49[ix+0]*g8[iy+0]*g70[iz+0];
s[1510] = + g48[ix+0]*g9[iy+0]*g70[iz+0];
s[1511] = + g48[ix+0]*g8[iy+0]*g71[iz+0];
s[1512] = + g55[ix+0]*g0[iy+0]*g72[iz+0];
s[1513] = + g54[ix+0]*g1[iy+0]*g72[iz+0];
s[1514] = + g54[ix+0]*g0[iy+0]*g73[iz+0];
s[1515] = + g53[ix+0]*g2[iy+0]*g72[iz+0];
s[1516] = + g52[ix+0]*g3[iy+0]*g72[iz+0];
s[1517] = + g52[ix+0]*g2[iy+0]*g73[iz+0];
s[1518] = + g53[ix+0]*g0[iy+0]*g74[iz+0];
s[1519] = + g52[ix+0]*g1[iy+0]*g74[iz+0];
s[1520] = + g52[ix+0]*g0[iy+0]*g75[iz+0];
s[1521] = + g51[ix+0]*g4[iy+0]*g72[iz+0];
s[1522] = + g50[ix+0]*g5[iy+0]*g72[iz+0];
s[1523] = + g50[ix+0]*g4[iy+0]*g73[iz+0];
s[1524] = + g49[ix+0]*g6[iy+0]*g72[iz+0];
s[1525] = + g48[ix+0]*g7[iy+0]*g72[iz+0];
s[1526] = + g48[ix+0]*g6[iy+0]*g73[iz+0];
s[1527] = + g49[ix+0]*g4[iy+0]*g74[iz+0];
s[1528] = + g48[ix+0]*g5[iy+0]*g74[iz+0];
s[1529] = + g48[ix+0]*g4[iy+0]*g75[iz+0];
s[1530] = + g51[ix+0]*g0[iy+0]*g76[iz+0];
s[1531] = + g50[ix+0]*g1[iy+0]*g76[iz+0];
s[1532] = + g50[ix+0]*g0[iy+0]*g77[iz+0];
s[1533] = + g49[ix+0]*g2[iy+0]*g76[iz+0];
s[1534] = + g48[ix+0]*g3[iy+0]*g76[iz+0];
s[1535] = + g48[ix+0]*g2[iy+0]*g77[iz+0];
s[1536] = + g49[ix+0]*g0[iy+0]*g78[iz+0];
s[1537] = + g48[ix+0]*g1[iy+0]*g78[iz+0];
s[1538] = + g48[ix+0]*g0[iy+0]*g79[iz+0];
s[1539] = + g47[ix+0]*g16[iy+0]*g64[iz+0];
s[1540] = + g46[ix+0]*g17[iy+0]*g64[iz+0];
s[1541] = + g46[ix+0]*g16[iy+0]*g65[iz+0];
s[1542] = + g45[ix+0]*g18[iy+0]*g64[iz+0];
s[1543] = + g44[ix+0]*g19[iy+0]*g64[iz+0];
s[1544] = + g44[ix+0]*g18[iy+0]*g65[iz+0];
s[1545] = + g45[ix+0]*g16[iy+0]*g66[iz+0];
s[1546] = + g44[ix+0]*g17[iy+0]*g66[iz+0];
s[1547] = + g44[ix+0]*g16[iy+0]*g67[iz+0];
s[1548] = + g43[ix+0]*g20[iy+0]*g64[iz+0];
s[1549] = + g42[ix+0]*g21[iy+0]*g64[iz+0];
s[1550] = + g42[ix+0]*g20[iy+0]*g65[iz+0];
s[1551] = + g41[ix+0]*g22[iy+0]*g64[iz+0];
s[1552] = + g40[ix+0]*g23[iy+0]*g64[iz+0];
s[1553] = + g40[ix+0]*g22[iy+0]*g65[iz+0];
s[1554] = + g41[ix+0]*g20[iy+0]*g66[iz+0];
s[1555] = + g40[ix+0]*g21[iy+0]*g66[iz+0];
s[1556] = + g40[ix+0]*g20[iy+0]*g67[iz+0];
s[1557] = + g43[ix+0]*g16[iy+0]*g68[iz+0];
s[1558] = + g42[ix+0]*g17[iy+0]*g68[iz+0];
s[1559] = + g42[ix+0]*g16[iy+0]*g69[iz+0];
s[1560] = + g41[ix+0]*g18[iy+0]*g68[iz+0];
s[1561] = + g40[ix+0]*g19[iy+0]*g68[iz+0];
s[1562] = + g40[ix+0]*g18[iy+0]*g69[iz+0];
s[1563] = + g41[ix+0]*g16[iy+0]*g70[iz+0];
s[1564] = + g40[ix+0]*g17[iy+0]*g70[iz+0];
s[1565] = + g40[ix+0]*g16[iy+0]*g71[iz+0];
s[1566] = + g39[ix+0]*g24[iy+0]*g64[iz+0];
s[1567] = + g38[ix+0]*g25[iy+0]*g64[iz+0];
s[1568] = + g38[ix+0]*g24[iy+0]*g65[iz+0];
s[1569] = + g37[ix+0]*g26[iy+0]*g64[iz+0];
s[1570] = + g36[ix+0]*g27[iy+0]*g64[iz+0];
s[1571] = + g36[ix+0]*g26[iy+0]*g65[iz+0];
s[1572] = + g37[ix+0]*g24[iy+0]*g66[iz+0];
s[1573] = + g36[ix+0]*g25[iy+0]*g66[iz+0];
s[1574] = + g36[ix+0]*g24[iy+0]*g67[iz+0];
s[1575] = + g35[ix+0]*g28[iy+0]*g64[iz+0];
s[1576] = + g34[ix+0]*g29[iy+0]*g64[iz+0];
s[1577] = + g34[ix+0]*g28[iy+0]*g65[iz+0];
s[1578] = + g33[ix+0]*g30[iy+0]*g64[iz+0];
s[1579] = + g32[ix+0]*g31[iy+0]*g64[iz+0];
s[1580] = + g32[ix+0]*g30[iy+0]*g65[iz+0];
s[1581] = + g33[ix+0]*g28[iy+0]*g66[iz+0];
s[1582] = + g32[ix+0]*g29[iy+0]*g66[iz+0];
s[1583] = + g32[ix+0]*g28[iy+0]*g67[iz+0];
s[1584] = + g35[ix+0]*g24[iy+0]*g68[iz+0];
s[1585] = + g34[ix+0]*g25[iy+0]*g68[iz+0];
s[1586] = + g34[ix+0]*g24[iy+0]*g69[iz+0];
s[1587] = + g33[ix+0]*g26[iy+0]*g68[iz+0];
s[1588] = + g32[ix+0]*g27[iy+0]*g68[iz+0];
s[1589] = + g32[ix+0]*g26[iy+0]*g69[iz+0];
s[1590] = + g33[ix+0]*g24[iy+0]*g70[iz+0];
s[1591] = + g32[ix+0]*g25[iy+0]*g70[iz+0];
s[1592] = + g32[ix+0]*g24[iy+0]*g71[iz+0];
s[1593] = + g39[ix+0]*g16[iy+0]*g72[iz+0];
s[1594] = + g38[ix+0]*g17[iy+0]*g72[iz+0];
s[1595] = + g38[ix+0]*g16[iy+0]*g73[iz+0];
s[1596] = + g37[ix+0]*g18[iy+0]*g72[iz+0];
s[1597] = + g36[ix+0]*g19[iy+0]*g72[iz+0];
s[1598] = + g36[ix+0]*g18[iy+0]*g73[iz+0];
s[1599] = + g37[ix+0]*g16[iy+0]*g74[iz+0];
s[1600] = + g36[ix+0]*g17[iy+0]*g74[iz+0];
s[1601] = + g36[ix+0]*g16[iy+0]*g75[iz+0];
s[1602] = + g35[ix+0]*g20[iy+0]*g72[iz+0];
s[1603] = + g34[ix+0]*g21[iy+0]*g72[iz+0];
s[1604] = + g34[ix+0]*g20[iy+0]*g73[iz+0];
s[1605] = + g33[ix+0]*g22[iy+0]*g72[iz+0];
s[1606] = + g32[ix+0]*g23[iy+0]*g72[iz+0];
s[1607] = + g32[ix+0]*g22[iy+0]*g73[iz+0];
s[1608] = + g33[ix+0]*g20[iy+0]*g74[iz+0];
s[1609] = + g32[ix+0]*g21[iy+0]*g74[iz+0];
s[1610] = + g32[ix+0]*g20[iy+0]*g75[iz+0];
s[1611] = + g35[ix+0]*g16[iy+0]*g76[iz+0];
s[1612] = + g34[ix+0]*g17[iy+0]*g76[iz+0];
s[1613] = + g34[ix+0]*g16[iy+0]*g77[iz+0];
s[1614] = + g33[ix+0]*g18[iy+0]*g76[iz+0];
s[1615] = + g32[ix+0]*g19[iy+0]*g76[iz+0];
s[1616] = + g32[ix+0]*g18[iy+0]*g77[iz+0];
s[1617] = + g33[ix+0]*g16[iy+0]*g78[iz+0];
s[1618] = + g32[ix+0]*g17[iy+0]*g78[iz+0];
s[1619] = + g32[ix+0]*g16[iy+0]*g79[iz+0];
s[1620] = + g47[ix+0]*g0[iy+0]*g80[iz+0];
s[1621] = + g46[ix+0]*g1[iy+0]*g80[iz+0];
s[1622] = + g46[ix+0]*g0[iy+0]*g81[iz+0];
s[1623] = + g45[ix+0]*g2[iy+0]*g80[iz+0];
s[1624] = + g44[ix+0]*g3[iy+0]*g80[iz+0];
s[1625] = + g44[ix+0]*g2[iy+0]*g81[iz+0];
s[1626] = + g45[ix+0]*g0[iy+0]*g82[iz+0];
s[1627] = + g44[ix+0]*g1[iy+0]*g82[iz+0];
s[1628] = + g44[ix+0]*g0[iy+0]*g83[iz+0];
s[1629] = + g43[ix+0]*g4[iy+0]*g80[iz+0];
s[1630] = + g42[ix+0]*g5[iy+0]*g80[iz+0];
s[1631] = + g42[ix+0]*g4[iy+0]*g81[iz+0];
s[1632] = + g41[ix+0]*g6[iy+0]*g80[iz+0];
s[1633] = + g40[ix+0]*g7[iy+0]*g80[iz+0];
s[1634] = + g40[ix+0]*g6[iy+0]*g81[iz+0];
s[1635] = + g41[ix+0]*g4[iy+0]*g82[iz+0];
s[1636] = + g40[ix+0]*g5[iy+0]*g82[iz+0];
s[1637] = + g40[ix+0]*g4[iy+0]*g83[iz+0];
s[1638] = + g43[ix+0]*g0[iy+0]*g84[iz+0];
s[1639] = + g42[ix+0]*g1[iy+0]*g84[iz+0];
s[1640] = + g42[ix+0]*g0[iy+0]*g85[iz+0];
s[1641] = + g41[ix+0]*g2[iy+0]*g84[iz+0];
s[1642] = + g40[ix+0]*g3[iy+0]*g84[iz+0];
s[1643] = + g40[ix+0]*g2[iy+0]*g85[iz+0];
s[1644] = + g41[ix+0]*g0[iy+0]*g86[iz+0];
s[1645] = + g40[ix+0]*g1[iy+0]*g86[iz+0];
s[1646] = + g40[ix+0]*g0[iy+0]*g87[iz+0];
s[1647] = + g39[ix+0]*g8[iy+0]*g80[iz+0];
s[1648] = + g38[ix+0]*g9[iy+0]*g80[iz+0];
s[1649] = + g38[ix+0]*g8[iy+0]*g81[iz+0];
s[1650] = + g37[ix+0]*g10[iy+0]*g80[iz+0];
s[1651] = + g36[ix+0]*g11[iy+0]*g80[iz+0];
s[1652] = + g36[ix+0]*g10[iy+0]*g81[iz+0];
s[1653] = + g37[ix+0]*g8[iy+0]*g82[iz+0];
s[1654] = + g36[ix+0]*g9[iy+0]*g82[iz+0];
s[1655] = + g36[ix+0]*g8[iy+0]*g83[iz+0];
s[1656] = + g35[ix+0]*g12[iy+0]*g80[iz+0];
s[1657] = + g34[ix+0]*g13[iy+0]*g80[iz+0];
s[1658] = + g34[ix+0]*g12[iy+0]*g81[iz+0];
s[1659] = + g33[ix+0]*g14[iy+0]*g80[iz+0];
s[1660] = + g32[ix+0]*g15[iy+0]*g80[iz+0];
s[1661] = + g32[ix+0]*g14[iy+0]*g81[iz+0];
s[1662] = + g33[ix+0]*g12[iy+0]*g82[iz+0];
s[1663] = + g32[ix+0]*g13[iy+0]*g82[iz+0];
s[1664] = + g32[ix+0]*g12[iy+0]*g83[iz+0];
s[1665] = + g35[ix+0]*g8[iy+0]*g84[iz+0];
s[1666] = + g34[ix+0]*g9[iy+0]*g84[iz+0];
s[1667] = + g34[ix+0]*g8[iy+0]*g85[iz+0];
s[1668] = + g33[ix+0]*g10[iy+0]*g84[iz+0];
s[1669] = + g32[ix+0]*g11[iy+0]*g84[iz+0];
s[1670] = + g32[ix+0]*g10[iy+0]*g85[iz+0];
s[1671] = + g33[ix+0]*g8[iy+0]*g86[iz+0];
s[1672] = + g32[ix+0]*g9[iy+0]*g86[iz+0];
s[1673] = + g32[ix+0]*g8[iy+0]*g87[iz+0];
s[1674] = + g39[ix+0]*g0[iy+0]*g88[iz+0];
s[1675] = + g38[ix+0]*g1[iy+0]*g88[iz+0];
s[1676] = + g38[ix+0]*g0[iy+0]*g89[iz+0];
s[1677] = + g37[ix+0]*g2[iy+0]*g88[iz+0];
s[1678] = + g36[ix+0]*g3[iy+0]*g88[iz+0];
s[1679] = + g36[ix+0]*g2[iy+0]*g89[iz+0];
s[1680] = + g37[ix+0]*g0[iy+0]*g90[iz+0];
s[1681] = + g36[ix+0]*g1[iy+0]*g90[iz+0];
s[1682] = + g36[ix+0]*g0[iy+0]*g91[iz+0];
s[1683] = + g35[ix+0]*g4[iy+0]*g88[iz+0];
s[1684] = + g34[ix+0]*g5[iy+0]*g88[iz+0];
s[1685] = + g34[ix+0]*g4[iy+0]*g89[iz+0];
s[1686] = + g33[ix+0]*g6[iy+0]*g88[iz+0];
s[1687] = + g32[ix+0]*g7[iy+0]*g88[iz+0];
s[1688] = + g32[ix+0]*g6[iy+0]*g89[iz+0];
s[1689] = + g33[ix+0]*g4[iy+0]*g90[iz+0];
s[1690] = + g32[ix+0]*g5[iy+0]*g90[iz+0];
s[1691] = + g32[ix+0]*g4[iy+0]*g91[iz+0];
s[1692] = + g35[ix+0]*g0[iy+0]*g92[iz+0];
s[1693] = + g34[ix+0]*g1[iy+0]*g92[iz+0];
s[1694] = + g34[ix+0]*g0[iy+0]*g93[iz+0];
s[1695] = + g33[ix+0]*g2[iy+0]*g92[iz+0];
s[1696] = + g32[ix+0]*g3[iy+0]*g92[iz+0];
s[1697] = + g32[ix+0]*g2[iy+0]*g93[iz+0];
s[1698] = + g33[ix+0]*g0[iy+0]*g94[iz+0];
s[1699] = + g32[ix+0]*g1[iy+0]*g94[iz+0];
s[1700] = + g32[ix+0]*g0[iy+0]*g95[iz+0];
s[1701] = + g31[ix+0]*g32[iy+0]*g64[iz+0];
s[1702] = + g30[ix+0]*g33[iy+0]*g64[iz+0];
s[1703] = + g30[ix+0]*g32[iy+0]*g65[iz+0];
s[1704] = + g29[ix+0]*g34[iy+0]*g64[iz+0];
s[1705] = + g28[ix+0]*g35[iy+0]*g64[iz+0];
s[1706] = + g28[ix+0]*g34[iy+0]*g65[iz+0];
s[1707] = + g29[ix+0]*g32[iy+0]*g66[iz+0];
s[1708] = + g28[ix+0]*g33[iy+0]*g66[iz+0];
s[1709] = + g28[ix+0]*g32[iy+0]*g67[iz+0];
s[1710] = + g27[ix+0]*g36[iy+0]*g64[iz+0];
s[1711] = + g26[ix+0]*g37[iy+0]*g64[iz+0];
s[1712] = + g26[ix+0]*g36[iy+0]*g65[iz+0];
s[1713] = + g25[ix+0]*g38[iy+0]*g64[iz+0];
s[1714] = + g24[ix+0]*g39[iy+0]*g64[iz+0];
s[1715] = + g24[ix+0]*g38[iy+0]*g65[iz+0];
s[1716] = + g25[ix+0]*g36[iy+0]*g66[iz+0];
s[1717] = + g24[ix+0]*g37[iy+0]*g66[iz+0];
s[1718] = + g24[ix+0]*g36[iy+0]*g67[iz+0];
s[1719] = + g27[ix+0]*g32[iy+0]*g68[iz+0];
s[1720] = + g26[ix+0]*g33[iy+0]*g68[iz+0];
s[1721] = + g26[ix+0]*g32[iy+0]*g69[iz+0];
s[1722] = + g25[ix+0]*g34[iy+0]*g68[iz+0];
s[1723] = + g24[ix+0]*g35[iy+0]*g68[iz+0];
s[1724] = + g24[ix+0]*g34[iy+0]*g69[iz+0];
s[1725] = + g25[ix+0]*g32[iy+0]*g70[iz+0];
s[1726] = + g24[ix+0]*g33[iy+0]*g70[iz+0];
s[1727] = + g24[ix+0]*g32[iy+0]*g71[iz+0];
s[1728] = + g23[ix+0]*g40[iy+0]*g64[iz+0];
s[1729] = + g22[ix+0]*g41[iy+0]*g64[iz+0];
s[1730] = + g22[ix+0]*g40[iy+0]*g65[iz+0];
s[1731] = + g21[ix+0]*g42[iy+0]*g64[iz+0];
s[1732] = + g20[ix+0]*g43[iy+0]*g64[iz+0];
s[1733] = + g20[ix+0]*g42[iy+0]*g65[iz+0];
s[1734] = + g21[ix+0]*g40[iy+0]*g66[iz+0];
s[1735] = + g20[ix+0]*g41[iy+0]*g66[iz+0];
s[1736] = + g20[ix+0]*g40[iy+0]*g67[iz+0];
s[1737] = + g19[ix+0]*g44[iy+0]*g64[iz+0];
s[1738] = + g18[ix+0]*g45[iy+0]*g64[iz+0];
s[1739] = + g18[ix+0]*g44[iy+0]*g65[iz+0];
s[1740] = + g17[ix+0]*g46[iy+0]*g64[iz+0];
s[1741] = + g16[ix+0]*g47[iy+0]*g64[iz+0];
s[1742] = + g16[ix+0]*g46[iy+0]*g65[iz+0];
s[1743] = + g17[ix+0]*g44[iy+0]*g66[iz+0];
s[1744] = + g16[ix+0]*g45[iy+0]*g66[iz+0];
s[1745] = + g16[ix+0]*g44[iy+0]*g67[iz+0];
s[1746] = + g19[ix+0]*g40[iy+0]*g68[iz+0];
s[1747] = + g18[ix+0]*g41[iy+0]*g68[iz+0];
s[1748] = + g18[ix+0]*g40[iy+0]*g69[iz+0];
s[1749] = + g17[ix+0]*g42[iy+0]*g68[iz+0];
s[1750] = + g16[ix+0]*g43[iy+0]*g68[iz+0];
s[1751] = + g16[ix+0]*g42[iy+0]*g69[iz+0];
s[1752] = + g17[ix+0]*g40[iy+0]*g70[iz+0];
s[1753] = + g16[ix+0]*g41[iy+0]*g70[iz+0];
s[1754] = + g16[ix+0]*g40[iy+0]*g71[iz+0];
s[1755] = + g23[ix+0]*g32[iy+0]*g72[iz+0];
s[1756] = + g22[ix+0]*g33[iy+0]*g72[iz+0];
s[1757] = + g22[ix+0]*g32[iy+0]*g73[iz+0];
s[1758] = + g21[ix+0]*g34[iy+0]*g72[iz+0];
s[1759] = + g20[ix+0]*g35[iy+0]*g72[iz+0];
s[1760] = + g20[ix+0]*g34[iy+0]*g73[iz+0];
s[1761] = + g21[ix+0]*g32[iy+0]*g74[iz+0];
s[1762] = + g20[ix+0]*g33[iy+0]*g74[iz+0];
s[1763] = + g20[ix+0]*g32[iy+0]*g75[iz+0];
s[1764] = + g19[ix+0]*g36[iy+0]*g72[iz+0];
s[1765] = + g18[ix+0]*g37[iy+0]*g72[iz+0];
s[1766] = + g18[ix+0]*g36[iy+0]*g73[iz+0];
s[1767] = + g17[ix+0]*g38[iy+0]*g72[iz+0];
s[1768] = + g16[ix+0]*g39[iy+0]*g72[iz+0];
s[1769] = + g16[ix+0]*g38[iy+0]*g73[iz+0];
s[1770] = + g17[ix+0]*g36[iy+0]*g74[iz+0];
s[1771] = + g16[ix+0]*g37[iy+0]*g74[iz+0];
s[1772] = + g16[ix+0]*g36[iy+0]*g75[iz+0];
s[1773] = + g19[ix+0]*g32[iy+0]*g76[iz+0];
s[1774] = + g18[ix+0]*g33[iy+0]*g76[iz+0];
s[1775] = + g18[ix+0]*g32[iy+0]*g77[iz+0];
s[1776] = + g17[ix+0]*g34[iy+0]*g76[iz+0];
s[1777] = + g16[ix+0]*g35[iy+0]*g76[iz+0];
s[1778] = + g16[ix+0]*g34[iy+0]*g77[iz+0];
s[1779] = + g17[ix+0]*g32[iy+0]*g78[iz+0];
s[1780] = + g16[ix+0]*g33[iy+0]*g78[iz+0];
s[1781] = + g16[ix+0]*g32[iy+0]*g79[iz+0];
s[1782] = + g15[ix+0]*g48[iy+0]*g64[iz+0];
s[1783] = + g14[ix+0]*g49[iy+0]*g64[iz+0];
s[1784] = + g14[ix+0]*g48[iy+0]*g65[iz+0];
s[1785] = + g13[ix+0]*g50[iy+0]*g64[iz+0];
s[1786] = + g12[ix+0]*g51[iy+0]*g64[iz+0];
s[1787] = + g12[ix+0]*g50[iy+0]*g65[iz+0];
s[1788] = + g13[ix+0]*g48[iy+0]*g66[iz+0];
s[1789] = + g12[ix+0]*g49[iy+0]*g66[iz+0];
s[1790] = + g12[ix+0]*g48[iy+0]*g67[iz+0];
s[1791] = + g11[ix+0]*g52[iy+0]*g64[iz+0];
s[1792] = + g10[ix+0]*g53[iy+0]*g64[iz+0];
s[1793] = + g10[ix+0]*g52[iy+0]*g65[iz+0];
s[1794] = + g9[ix+0]*g54[iy+0]*g64[iz+0];
s[1795] = + g8[ix+0]*g55[iy+0]*g64[iz+0];
s[1796] = + g8[ix+0]*g54[iy+0]*g65[iz+0];
s[1797] = + g9[ix+0]*g52[iy+0]*g66[iz+0];
s[1798] = + g8[ix+0]*g53[iy+0]*g66[iz+0];
s[1799] = + g8[ix+0]*g52[iy+0]*g67[iz+0];
s[1800] = + g11[ix+0]*g48[iy+0]*g68[iz+0];
s[1801] = + g10[ix+0]*g49[iy+0]*g68[iz+0];
s[1802] = + g10[ix+0]*g48[iy+0]*g69[iz+0];
s[1803] = + g9[ix+0]*g50[iy+0]*g68[iz+0];
s[1804] = + g8[ix+0]*g51[iy+0]*g68[iz+0];
s[1805] = + g8[ix+0]*g50[iy+0]*g69[iz+0];
s[1806] = + g9[ix+0]*g48[iy+0]*g70[iz+0];
s[1807] = + g8[ix+0]*g49[iy+0]*g70[iz+0];
s[1808] = + g8[ix+0]*g48[iy+0]*g71[iz+0];
s[1809] = + g7[ix+0]*g56[iy+0]*g64[iz+0];
s[1810] = + g6[ix+0]*g57[iy+0]*g64[iz+0];
s[1811] = + g6[ix+0]*g56[iy+0]*g65[iz+0];
s[1812] = + g5[ix+0]*g58[iy+0]*g64[iz+0];
s[1813] = + g4[ix+0]*g59[iy+0]*g64[iz+0];
s[1814] = + g4[ix+0]*g58[iy+0]*g65[iz+0];
s[1815] = + g5[ix+0]*g56[iy+0]*g66[iz+0];
s[1816] = + g4[ix+0]*g57[iy+0]*g66[iz+0];
s[1817] = + g4[ix+0]*g56[iy+0]*g67[iz+0];
s[1818] = + g3[ix+0]*g60[iy+0]*g64[iz+0];
s[1819] = + g2[ix+0]*g61[iy+0]*g64[iz+0];
s[1820] = + g2[ix+0]*g60[iy+0]*g65[iz+0];
s[1821] = + g1[ix+0]*g62[iy+0]*g64[iz+0];
s[1822] = + g0[ix+0]*g63[iy+0]*g64[iz+0];
s[1823] = + g0[ix+0]*g62[iy+0]*g65[iz+0];
s[1824] = + g1[ix+0]*g60[iy+0]*g66[iz+0];
s[1825] = + g0[ix+0]*g61[iy+0]*g66[iz+0];
s[1826] = + g0[ix+0]*g60[iy+0]*g67[iz+0];
s[1827] = + g3[ix+0]*g56[iy+0]*g68[iz+0];
s[1828] = + g2[ix+0]*g57[iy+0]*g68[iz+0];
s[1829] = + g2[ix+0]*g56[iy+0]*g69[iz+0];
s[1830] = + g1[ix+0]*g58[iy+0]*g68[iz+0];
s[1831] = + g0[ix+0]*g59[iy+0]*g68[iz+0];
s[1832] = + g0[ix+0]*g58[iy+0]*g69[iz+0];
s[1833] = + g1[ix+0]*g56[iy+0]*g70[iz+0];
s[1834] = + g0[ix+0]*g57[iy+0]*g70[iz+0];
s[1835] = + g0[ix+0]*g56[iy+0]*g71[iz+0];
s[1836] = + g7[ix+0]*g48[iy+0]*g72[iz+0];
s[1837] = + g6[ix+0]*g49[iy+0]*g72[iz+0];
s[1838] = + g6[ix+0]*g48[iy+0]*g73[iz+0];
s[1839] = + g5[ix+0]*g50[iy+0]*g72[iz+0];
s[1840] = + g4[ix+0]*g51[iy+0]*g72[iz+0];
s[1841] = + g4[ix+0]*g50[iy+0]*g73[iz+0];
s[1842] = + g5[ix+0]*g48[iy+0]*g74[iz+0];
s[1843] = + g4[ix+0]*g49[iy+0]*g74[iz+0];
s[1844] = + g4[ix+0]*g48[iy+0]*g75[iz+0];
s[1845] = + g3[ix+0]*g52[iy+0]*g72[iz+0];
s[1846] = + g2[ix+0]*g53[iy+0]*g72[iz+0];
s[1847] = + g2[ix+0]*g52[iy+0]*g73[iz+0];
s[1848] = + g1[ix+0]*g54[iy+0]*g72[iz+0];
s[1849] = + g0[ix+0]*g55[iy+0]*g72[iz+0];
s[1850] = + g0[ix+0]*g54[iy+0]*g73[iz+0];
s[1851] = + g1[ix+0]*g52[iy+0]*g74[iz+0];
s[1852] = + g0[ix+0]*g53[iy+0]*g74[iz+0];
s[1853] = + g0[ix+0]*g52[iy+0]*g75[iz+0];
s[1854] = + g3[ix+0]*g48[iy+0]*g76[iz+0];
s[1855] = + g2[ix+0]*g49[iy+0]*g76[iz+0];
s[1856] = + g2[ix+0]*g48[iy+0]*g77[iz+0];
s[1857] = + g1[ix+0]*g50[iy+0]*g76[iz+0];
s[1858] = + g0[ix+0]*g51[iy+0]*g76[iz+0];
s[1859] = + g0[ix+0]*g50[iy+0]*g77[iz+0];
s[1860] = + g1[ix+0]*g48[iy+0]*g78[iz+0];
s[1861] = + g0[ix+0]*g49[iy+0]*g78[iz+0];
s[1862] = + g0[ix+0]*g48[iy+0]*g79[iz+0];
s[1863] = + g15[ix+0]*g32[iy+0]*g80[iz+0];
s[1864] = + g14[ix+0]*g33[iy+0]*g80[iz+0];
s[1865] = + g14[ix+0]*g32[iy+0]*g81[iz+0];
s[1866] = + g13[ix+0]*g34[iy+0]*g80[iz+0];
s[1867] = + g12[ix+0]*g35[iy+0]*g80[iz+0];
s[1868] = + g12[ix+0]*g34[iy+0]*g81[iz+0];
s[1869] = + g13[ix+0]*g32[iy+0]*g82[iz+0];
s[1870] = + g12[ix+0]*g33[iy+0]*g82[iz+0];
s[1871] = + g12[ix+0]*g32[iy+0]*g83[iz+0];
s[1872] = + g11[ix+0]*g36[iy+0]*g80[iz+0];
s[1873] = + g10[ix+0]*g37[iy+0]*g80[iz+0];
s[1874] = + g10[ix+0]*g36[iy+0]*g81[iz+0];
s[1875] = + g9[ix+0]*g38[iy+0]*g80[iz+0];
s[1876] = + g8[ix+0]*g39[iy+0]*g80[iz+0];
s[1877] = + g8[ix+0]*g38[iy+0]*g81[iz+0];
s[1878] = + g9[ix+0]*g36[iy+0]*g82[iz+0];
s[1879] = + g8[ix+0]*g37[iy+0]*g82[iz+0];
s[1880] = + g8[ix+0]*g36[iy+0]*g83[iz+0];
s[1881] = + g11[ix+0]*g32[iy+0]*g84[iz+0];
s[1882] = + g10[ix+0]*g33[iy+0]*g84[iz+0];
s[1883] = + g10[ix+0]*g32[iy+0]*g85[iz+0];
s[1884] = + g9[ix+0]*g34[iy+0]*g84[iz+0];
s[1885] = + g8[ix+0]*g35[iy+0]*g84[iz+0];
s[1886] = + g8[ix+0]*g34[iy+0]*g85[iz+0];
s[1887] = + g9[ix+0]*g32[iy+0]*g86[iz+0];
s[1888] = + g8[ix+0]*g33[iy+0]*g86[iz+0];
s[1889] = + g8[ix+0]*g32[iy+0]*g87[iz+0];
s[1890] = + g7[ix+0]*g40[iy+0]*g80[iz+0];
s[1891] = + g6[ix+0]*g41[iy+0]*g80[iz+0];
s[1892] = + g6[ix+0]*g40[iy+0]*g81[iz+0];
s[1893] = + g5[ix+0]*g42[iy+0]*g80[iz+0];
s[1894] = + g4[ix+0]*g43[iy+0]*g80[iz+0];
s[1895] = + g4[ix+0]*g42[iy+0]*g81[iz+0];
s[1896] = + g5[ix+0]*g40[iy+0]*g82[iz+0];
s[1897] = + g4[ix+0]*g41[iy+0]*g82[iz+0];
s[1898] = + g4[ix+0]*g40[iy+0]*g83[iz+0];
s[1899] = + g3[ix+0]*g44[iy+0]*g80[iz+0];
s[1900] = + g2[ix+0]*g45[iy+0]*g80[iz+0];
s[1901] = + g2[ix+0]*g44[iy+0]*g81[iz+0];
s[1902] = + g1[ix+0]*g46[iy+0]*g80[iz+0];
s[1903] = + g0[ix+0]*g47[iy+0]*g80[iz+0];
s[1904] = + g0[ix+0]*g46[iy+0]*g81[iz+0];
s[1905] = + g1[ix+0]*g44[iy+0]*g82[iz+0];
s[1906] = + g0[ix+0]*g45[iy+0]*g82[iz+0];
s[1907] = + g0[ix+0]*g44[iy+0]*g83[iz+0];
s[1908] = + g3[ix+0]*g40[iy+0]*g84[iz+0];
s[1909] = + g2[ix+0]*g41[iy+0]*g84[iz+0];
s[1910] = + g2[ix+0]*g40[iy+0]*g85[iz+0];
s[1911] = + g1[ix+0]*g42[iy+0]*g84[iz+0];
s[1912] = + g0[ix+0]*g43[iy+0]*g84[iz+0];
s[1913] = + g0[ix+0]*g42[iy+0]*g85[iz+0];
s[1914] = + g1[ix+0]*g40[iy+0]*g86[iz+0];
s[1915] = + g0[ix+0]*g41[iy+0]*g86[iz+0];
s[1916] = + g0[ix+0]*g40[iy+0]*g87[iz+0];
s[1917] = + g7[ix+0]*g32[iy+0]*g88[iz+0];
s[1918] = + g6[ix+0]*g33[iy+0]*g88[iz+0];
s[1919] = + g6[ix+0]*g32[iy+0]*g89[iz+0];
s[1920] = + g5[ix+0]*g34[iy+0]*g88[iz+0];
s[1921] = + g4[ix+0]*g35[iy+0]*g88[iz+0];
s[1922] = + g4[ix+0]*g34[iy+0]*g89[iz+0];
s[1923] = + g5[ix+0]*g32[iy+0]*g90[iz+0];
s[1924] = + g4[ix+0]*g33[iy+0]*g90[iz+0];
s[1925] = + g4[ix+0]*g32[iy+0]*g91[iz+0];
s[1926] = + g3[ix+0]*g36[iy+0]*g88[iz+0];
s[1927] = + g2[ix+0]*g37[iy+0]*g88[iz+0];
s[1928] = + g2[ix+0]*g36[iy+0]*g89[iz+0];
s[1929] = + g1[ix+0]*g38[iy+0]*g88[iz+0];
s[1930] = + g0[ix+0]*g39[iy+0]*g88[iz+0];
s[1931] = + g0[ix+0]*g38[iy+0]*g89[iz+0];
s[1932] = + g1[ix+0]*g36[iy+0]*g90[iz+0];
s[1933] = + g0[ix+0]*g37[iy+0]*g90[iz+0];
s[1934] = + g0[ix+0]*g36[iy+0]*g91[iz+0];
s[1935] = + g3[ix+0]*g32[iy+0]*g92[iz+0];
s[1936] = + g2[ix+0]*g33[iy+0]*g92[iz+0];
s[1937] = + g2[ix+0]*g32[iy+0]*g93[iz+0];
s[1938] = + g1[ix+0]*g34[iy+0]*g92[iz+0];
s[1939] = + g0[ix+0]*g35[iy+0]*g92[iz+0];
s[1940] = + g0[ix+0]*g34[iy+0]*g93[iz+0];
s[1941] = + g1[ix+0]*g32[iy+0]*g94[iz+0];
s[1942] = + g0[ix+0]*g33[iy+0]*g94[iz+0];
s[1943] = + g0[ix+0]*g32[iy+0]*g95[iz+0];
s[1944] = + g31[ix+0]*g0[iy+0]*g96[iz+0];
s[1945] = + g30[ix+0]*g1[iy+0]*g96[iz+0];
s[1946] = + g30[ix+0]*g0[iy+0]*g97[iz+0];
s[1947] = + g29[ix+0]*g2[iy+0]*g96[iz+0];
s[1948] = + g28[ix+0]*g3[iy+0]*g96[iz+0];
s[1949] = + g28[ix+0]*g2[iy+0]*g97[iz+0];
s[1950] = + g29[ix+0]*g0[iy+0]*g98[iz+0];
s[1951] = + g28[ix+0]*g1[iy+0]*g98[iz+0];
s[1952] = + g28[ix+0]*g0[iy+0]*g99[iz+0];
s[1953] = + g27[ix+0]*g4[iy+0]*g96[iz+0];
s[1954] = + g26[ix+0]*g5[iy+0]*g96[iz+0];
s[1955] = + g26[ix+0]*g4[iy+0]*g97[iz+0];
s[1956] = + g25[ix+0]*g6[iy+0]*g96[iz+0];
s[1957] = + g24[ix+0]*g7[iy+0]*g96[iz+0];
s[1958] = + g24[ix+0]*g6[iy+0]*g97[iz+0];
s[1959] = + g25[ix+0]*g4[iy+0]*g98[iz+0];
s[1960] = + g24[ix+0]*g5[iy+0]*g98[iz+0];
s[1961] = + g24[ix+0]*g4[iy+0]*g99[iz+0];
s[1962] = + g27[ix+0]*g0[iy+0]*g100[iz+0];
s[1963] = + g26[ix+0]*g1[iy+0]*g100[iz+0];
s[1964] = + g26[ix+0]*g0[iy+0]*g101[iz+0];
s[1965] = + g25[ix+0]*g2[iy+0]*g100[iz+0];
s[1966] = + g24[ix+0]*g3[iy+0]*g100[iz+0];
s[1967] = + g24[ix+0]*g2[iy+0]*g101[iz+0];
s[1968] = + g25[ix+0]*g0[iy+0]*g102[iz+0];
s[1969] = + g24[ix+0]*g1[iy+0]*g102[iz+0];
s[1970] = + g24[ix+0]*g0[iy+0]*g103[iz+0];
s[1971] = + g23[ix+0]*g8[iy+0]*g96[iz+0];
s[1972] = + g22[ix+0]*g9[iy+0]*g96[iz+0];
s[1973] = + g22[ix+0]*g8[iy+0]*g97[iz+0];
s[1974] = + g21[ix+0]*g10[iy+0]*g96[iz+0];
s[1975] = + g20[ix+0]*g11[iy+0]*g96[iz+0];
s[1976] = + g20[ix+0]*g10[iy+0]*g97[iz+0];
s[1977] = + g21[ix+0]*g8[iy+0]*g98[iz+0];
s[1978] = + g20[ix+0]*g9[iy+0]*g98[iz+0];
s[1979] = + g20[ix+0]*g8[iy+0]*g99[iz+0];
s[1980] = + g19[ix+0]*g12[iy+0]*g96[iz+0];
s[1981] = + g18[ix+0]*g13[iy+0]*g96[iz+0];
s[1982] = + g18[ix+0]*g12[iy+0]*g97[iz+0];
s[1983] = + g17[ix+0]*g14[iy+0]*g96[iz+0];
s[1984] = + g16[ix+0]*g15[iy+0]*g96[iz+0];
s[1985] = + g16[ix+0]*g14[iy+0]*g97[iz+0];
s[1986] = + g17[ix+0]*g12[iy+0]*g98[iz+0];
s[1987] = + g16[ix+0]*g13[iy+0]*g98[iz+0];
s[1988] = + g16[ix+0]*g12[iy+0]*g99[iz+0];
s[1989] = + g19[ix+0]*g8[iy+0]*g100[iz+0];
s[1990] = + g18[ix+0]*g9[iy+0]*g100[iz+0];
s[1991] = + g18[ix+0]*g8[iy+0]*g101[iz+0];
s[1992] = + g17[ix+0]*g10[iy+0]*g100[iz+0];
s[1993] = + g16[ix+0]*g11[iy+0]*g100[iz+0];
s[1994] = + g16[ix+0]*g10[iy+0]*g101[iz+0];
s[1995] = + g17[ix+0]*g8[iy+0]*g102[iz+0];
s[1996] = + g16[ix+0]*g9[iy+0]*g102[iz+0];
s[1997] = + g16[ix+0]*g8[iy+0]*g103[iz+0];
s[1998] = + g23[ix+0]*g0[iy+0]*g104[iz+0];
s[1999] = + g22[ix+0]*g1[iy+0]*g104[iz+0];
s[2000] = + g22[ix+0]*g0[iy+0]*g105[iz+0];
s[2001] = + g21[ix+0]*g2[iy+0]*g104[iz+0];
s[2002] = + g20[ix+0]*g3[iy+0]*g104[iz+0];
s[2003] = + g20[ix+0]*g2[iy+0]*g105[iz+0];
s[2004] = + g21[ix+0]*g0[iy+0]*g106[iz+0];
s[2005] = + g20[ix+0]*g1[iy+0]*g106[iz+0];
s[2006] = + g20[ix+0]*g0[iy+0]*g107[iz+0];
s[2007] = + g19[ix+0]*g4[iy+0]*g104[iz+0];
s[2008] = + g18[ix+0]*g5[iy+0]*g104[iz+0];
s[2009] = + g18[ix+0]*g4[iy+0]*g105[iz+0];
s[2010] = + g17[ix+0]*g6[iy+0]*g104[iz+0];
s[2011] = + g16[ix+0]*g7[iy+0]*g104[iz+0];
s[2012] = + g16[ix+0]*g6[iy+0]*g105[iz+0];
s[2013] = + g17[ix+0]*g4[iy+0]*g106[iz+0];
s[2014] = + g16[ix+0]*g5[iy+0]*g106[iz+0];
s[2015] = + g16[ix+0]*g4[iy+0]*g107[iz+0];
s[2016] = + g19[ix+0]*g0[iy+0]*g108[iz+0];
s[2017] = + g18[ix+0]*g1[iy+0]*g108[iz+0];
s[2018] = + g18[ix+0]*g0[iy+0]*g109[iz+0];
s[2019] = + g17[ix+0]*g2[iy+0]*g108[iz+0];
s[2020] = + g16[ix+0]*g3[iy+0]*g108[iz+0];
s[2021] = + g16[ix+0]*g2[iy+0]*g109[iz+0];
s[2022] = + g17[ix+0]*g0[iy+0]*g110[iz+0];
s[2023] = + g16[ix+0]*g1[iy+0]*g110[iz+0];
s[2024] = + g16[ix+0]*g0[iy+0]*g111[iz+0];
s[2025] = + g15[ix+0]*g16[iy+0]*g96[iz+0];
s[2026] = + g14[ix+0]*g17[iy+0]*g96[iz+0];
s[2027] = + g14[ix+0]*g16[iy+0]*g97[iz+0];
s[2028] = + g13[ix+0]*g18[iy+0]*g96[iz+0];
s[2029] = + g12[ix+0]*g19[iy+0]*g96[iz+0];
s[2030] = + g12[ix+0]*g18[iy+0]*g97[iz+0];
s[2031] = + g13[ix+0]*g16[iy+0]*g98[iz+0];
s[2032] = + g12[ix+0]*g17[iy+0]*g98[iz+0];
s[2033] = + g12[ix+0]*g16[iy+0]*g99[iz+0];
s[2034] = + g11[ix+0]*g20[iy+0]*g96[iz+0];
s[2035] = + g10[ix+0]*g21[iy+0]*g96[iz+0];
s[2036] = + g10[ix+0]*g20[iy+0]*g97[iz+0];
s[2037] = + g9[ix+0]*g22[iy+0]*g96[iz+0];
s[2038] = + g8[ix+0]*g23[iy+0]*g96[iz+0];
s[2039] = + g8[ix+0]*g22[iy+0]*g97[iz+0];
s[2040] = + g9[ix+0]*g20[iy+0]*g98[iz+0];
s[2041] = + g8[ix+0]*g21[iy+0]*g98[iz+0];
s[2042] = + g8[ix+0]*g20[iy+0]*g99[iz+0];
s[2043] = + g11[ix+0]*g16[iy+0]*g100[iz+0];
s[2044] = + g10[ix+0]*g17[iy+0]*g100[iz+0];
s[2045] = + g10[ix+0]*g16[iy+0]*g101[iz+0];
s[2046] = + g9[ix+0]*g18[iy+0]*g100[iz+0];
s[2047] = + g8[ix+0]*g19[iy+0]*g100[iz+0];
s[2048] = + g8[ix+0]*g18[iy+0]*g101[iz+0];
s[2049] = + g9[ix+0]*g16[iy+0]*g102[iz+0];
s[2050] = + g8[ix+0]*g17[iy+0]*g102[iz+0];
s[2051] = + g8[ix+0]*g16[iy+0]*g103[iz+0];
s[2052] = + g7[ix+0]*g24[iy+0]*g96[iz+0];
s[2053] = + g6[ix+0]*g25[iy+0]*g96[iz+0];
s[2054] = + g6[ix+0]*g24[iy+0]*g97[iz+0];
s[2055] = + g5[ix+0]*g26[iy+0]*g96[iz+0];
s[2056] = + g4[ix+0]*g27[iy+0]*g96[iz+0];
s[2057] = + g4[ix+0]*g26[iy+0]*g97[iz+0];
s[2058] = + g5[ix+0]*g24[iy+0]*g98[iz+0];
s[2059] = + g4[ix+0]*g25[iy+0]*g98[iz+0];
s[2060] = + g4[ix+0]*g24[iy+0]*g99[iz+0];
s[2061] = + g3[ix+0]*g28[iy+0]*g96[iz+0];
s[2062] = + g2[ix+0]*g29[iy+0]*g96[iz+0];
s[2063] = + g2[ix+0]*g28[iy+0]*g97[iz+0];
s[2064] = + g1[ix+0]*g30[iy+0]*g96[iz+0];
s[2065] = + g0[ix+0]*g31[iy+0]*g96[iz+0];
s[2066] = + g0[ix+0]*g30[iy+0]*g97[iz+0];
s[2067] = + g1[ix+0]*g28[iy+0]*g98[iz+0];
s[2068] = + g0[ix+0]*g29[iy+0]*g98[iz+0];
s[2069] = + g0[ix+0]*g28[iy+0]*g99[iz+0];
s[2070] = + g3[ix+0]*g24[iy+0]*g100[iz+0];
s[2071] = + g2[ix+0]*g25[iy+0]*g100[iz+0];
s[2072] = + g2[ix+0]*g24[iy+0]*g101[iz+0];
s[2073] = + g1[ix+0]*g26[iy+0]*g100[iz+0];
s[2074] = + g0[ix+0]*g27[iy+0]*g100[iz+0];
s[2075] = + g0[ix+0]*g26[iy+0]*g101[iz+0];
s[2076] = + g1[ix+0]*g24[iy+0]*g102[iz+0];
s[2077] = + g0[ix+0]*g25[iy+0]*g102[iz+0];
s[2078] = + g0[ix+0]*g24[iy+0]*g103[iz+0];
s[2079] = + g7[ix+0]*g16[iy+0]*g104[iz+0];
s[2080] = + g6[ix+0]*g17[iy+0]*g104[iz+0];
s[2081] = + g6[ix+0]*g16[iy+0]*g105[iz+0];
s[2082] = + g5[ix+0]*g18[iy+0]*g104[iz+0];
s[2083] = + g4[ix+0]*g19[iy+0]*g104[iz+0];
s[2084] = + g4[ix+0]*g18[iy+0]*g105[iz+0];
s[2085] = + g5[ix+0]*g16[iy+0]*g106[iz+0];
s[2086] = + g4[ix+0]*g17[iy+0]*g106[iz+0];
s[2087] = + g4[ix+0]*g16[iy+0]*g107[iz+0];
s[2088] = + g3[ix+0]*g20[iy+0]*g104[iz+0];
s[2089] = + g2[ix+0]*g21[iy+0]*g104[iz+0];
s[2090] = + g2[ix+0]*g20[iy+0]*g105[iz+0];
s[2091] = + g1[ix+0]*g22[iy+0]*g104[iz+0];
s[2092] = + g0[ix+0]*g23[iy+0]*g104[iz+0];
s[2093] = + g0[ix+0]*g22[iy+0]*g105[iz+0];
s[2094] = + g1[ix+0]*g20[iy+0]*g106[iz+0];
s[2095] = + g0[ix+0]*g21[iy+0]*g106[iz+0];
s[2096] = + g0[ix+0]*g20[iy+0]*g107[iz+0];
s[2097] = + g3[ix+0]*g16[iy+0]*g108[iz+0];
s[2098] = + g2[ix+0]*g17[iy+0]*g108[iz+0];
s[2099] = + g2[ix+0]*g16[iy+0]*g109[iz+0];
s[2100] = + g1[ix+0]*g18[iy+0]*g108[iz+0];
s[2101] = + g0[ix+0]*g19[iy+0]*g108[iz+0];
s[2102] = + g0[ix+0]*g18[iy+0]*g109[iz+0];
s[2103] = + g1[ix+0]*g16[iy+0]*g110[iz+0];
s[2104] = + g0[ix+0]*g17[iy+0]*g110[iz+0];
s[2105] = + g0[ix+0]*g16[iy+0]*g111[iz+0];
s[2106] = + g15[ix+0]*g0[iy+0]*g112[iz+0];
s[2107] = + g14[ix+0]*g1[iy+0]*g112[iz+0];
s[2108] = + g14[ix+0]*g0[iy+0]*g113[iz+0];
s[2109] = + g13[ix+0]*g2[iy+0]*g112[iz+0];
s[2110] = + g12[ix+0]*g3[iy+0]*g112[iz+0];
s[2111] = + g12[ix+0]*g2[iy+0]*g113[iz+0];
s[2112] = + g13[ix+0]*g0[iy+0]*g114[iz+0];
s[2113] = + g12[ix+0]*g1[iy+0]*g114[iz+0];
s[2114] = + g12[ix+0]*g0[iy+0]*g115[iz+0];
s[2115] = + g11[ix+0]*g4[iy+0]*g112[iz+0];
s[2116] = + g10[ix+0]*g5[iy+0]*g112[iz+0];
s[2117] = + g10[ix+0]*g4[iy+0]*g113[iz+0];
s[2118] = + g9[ix+0]*g6[iy+0]*g112[iz+0];
s[2119] = + g8[ix+0]*g7[iy+0]*g112[iz+0];
s[2120] = + g8[ix+0]*g6[iy+0]*g113[iz+0];
s[2121] = + g9[ix+0]*g4[iy+0]*g114[iz+0];
s[2122] = + g8[ix+0]*g5[iy+0]*g114[iz+0];
s[2123] = + g8[ix+0]*g4[iy+0]*g115[iz+0];
s[2124] = + g11[ix+0]*g0[iy+0]*g116[iz+0];
s[2125] = + g10[ix+0]*g1[iy+0]*g116[iz+0];
s[2126] = + g10[ix+0]*g0[iy+0]*g117[iz+0];
s[2127] = + g9[ix+0]*g2[iy+0]*g116[iz+0];
s[2128] = + g8[ix+0]*g3[iy+0]*g116[iz+0];
s[2129] = + g8[ix+0]*g2[iy+0]*g117[iz+0];
s[2130] = + g9[ix+0]*g0[iy+0]*g118[iz+0];
s[2131] = + g8[ix+0]*g1[iy+0]*g118[iz+0];
s[2132] = + g8[ix+0]*g0[iy+0]*g119[iz+0];
s[2133] = + g7[ix+0]*g8[iy+0]*g112[iz+0];
s[2134] = + g6[ix+0]*g9[iy+0]*g112[iz+0];
s[2135] = + g6[ix+0]*g8[iy+0]*g113[iz+0];
s[2136] = + g5[ix+0]*g10[iy+0]*g112[iz+0];
s[2137] = + g4[ix+0]*g11[iy+0]*g112[iz+0];
s[2138] = + g4[ix+0]*g10[iy+0]*g113[iz+0];
s[2139] = + g5[ix+0]*g8[iy+0]*g114[iz+0];
s[2140] = + g4[ix+0]*g9[iy+0]*g114[iz+0];
s[2141] = + g4[ix+0]*g8[iy+0]*g115[iz+0];
s[2142] = + g3[ix+0]*g12[iy+0]*g112[iz+0];
s[2143] = + g2[ix+0]*g13[iy+0]*g112[iz+0];
s[2144] = + g2[ix+0]*g12[iy+0]*g113[iz+0];
s[2145] = + g1[ix+0]*g14[iy+0]*g112[iz+0];
s[2146] = + g0[ix+0]*g15[iy+0]*g112[iz+0];
s[2147] = + g0[ix+0]*g14[iy+0]*g113[iz+0];
s[2148] = + g1[ix+0]*g12[iy+0]*g114[iz+0];
s[2149] = + g0[ix+0]*g13[iy+0]*g114[iz+0];
s[2150] = + g0[ix+0]*g12[iy+0]*g115[iz+0];
s[2151] = + g3[ix+0]*g8[iy+0]*g116[iz+0];
s[2152] = + g2[ix+0]*g9[iy+0]*g116[iz+0];
s[2153] = + g2[ix+0]*g8[iy+0]*g117[iz+0];
s[2154] = + g1[ix+0]*g10[iy+0]*g116[iz+0];
s[2155] = + g0[ix+0]*g11[iy+0]*g116[iz+0];
s[2156] = + g0[ix+0]*g10[iy+0]*g117[iz+0];
s[2157] = + g1[ix+0]*g8[iy+0]*g118[iz+0];
s[2158] = + g0[ix+0]*g9[iy+0]*g118[iz+0];
s[2159] = + g0[ix+0]*g8[iy+0]*g119[iz+0];
s[2160] = + g7[ix+0]*g0[iy+0]*g120[iz+0];
s[2161] = + g6[ix+0]*g1[iy+0]*g120[iz+0];
s[2162] = + g6[ix+0]*g0[iy+0]*g121[iz+0];
s[2163] = + g5[ix+0]*g2[iy+0]*g120[iz+0];
s[2164] = + g4[ix+0]*g3[iy+0]*g120[iz+0];
s[2165] = + g4[ix+0]*g2[iy+0]*g121[iz+0];
s[2166] = + g5[ix+0]*g0[iy+0]*g122[iz+0];
s[2167] = + g4[ix+0]*g1[iy+0]*g122[iz+0];
s[2168] = + g4[ix+0]*g0[iy+0]*g123[iz+0];
s[2169] = + g3[ix+0]*g4[iy+0]*g120[iz+0];
s[2170] = + g2[ix+0]*g5[iy+0]*g120[iz+0];
s[2171] = + g2[ix+0]*g4[iy+0]*g121[iz+0];
s[2172] = + g1[ix+0]*g6[iy+0]*g120[iz+0];
s[2173] = + g0[ix+0]*g7[iy+0]*g120[iz+0];
s[2174] = + g0[ix+0]*g6[iy+0]*g121[iz+0];
s[2175] = + g1[ix+0]*g4[iy+0]*g122[iz+0];
s[2176] = + g0[ix+0]*g5[iy+0]*g122[iz+0];
s[2177] = + g0[ix+0]*g4[iy+0]*g123[iz+0];
s[2178] = + g3[ix+0]*g0[iy+0]*g124[iz+0];
s[2179] = + g2[ix+0]*g1[iy+0]*g124[iz+0];
s[2180] = + g2[ix+0]*g0[iy+0]*g125[iz+0];
s[2181] = + g1[ix+0]*g2[iy+0]*g124[iz+0];
s[2182] = + g0[ix+0]*g3[iy+0]*g124[iz+0];
s[2183] = + g0[ix+0]*g2[iy+0]*g125[iz+0];
s[2184] = + g1[ix+0]*g0[iy+0]*g126[iz+0];
s[2185] = + g0[ix+0]*g1[iy+0]*g126[iz+0];
s[2186] = + g0[ix+0]*g0[iy+0]*g127[iz+0];
if (gout_empty) {
gout[n*2187+0] = + s[0];
gout[n*2187+1] = + s[1];
gout[n*2187+2] = + s[2];
gout[n*2187+3] = + s[3];
gout[n*2187+4] = + s[4];
gout[n*2187+5] = + s[5];
gout[n*2187+6] = + s[6];
gout[n*2187+7] = + s[7];
gout[n*2187+8] = + s[8];
gout[n*2187+9] = + s[9];
gout[n*2187+10] = + s[10];
gout[n*2187+11] = + s[11];
gout[n*2187+12] = + s[12];
gout[n*2187+13] = + s[13];
gout[n*2187+14] = + s[14];
gout[n*2187+15] = + s[15];
gout[n*2187+16] = + s[16];
gout[n*2187+17] = + s[17];
gout[n*2187+18] = + s[18];
gout[n*2187+19] = + s[19];
gout[n*2187+20] = + s[20];
gout[n*2187+21] = + s[21];
gout[n*2187+22] = + s[22];
gout[n*2187+23] = + s[23];
gout[n*2187+24] = + s[24];
gout[n*2187+25] = + s[25];
gout[n*2187+26] = + s[26];
gout[n*2187+27] = + s[27];
gout[n*2187+28] = + s[28];
gout[n*2187+29] = + s[29];
gout[n*2187+30] = + s[30];
gout[n*2187+31] = + s[31];
gout[n*2187+32] = + s[32];
gout[n*2187+33] = + s[33];
gout[n*2187+34] = + s[34];
gout[n*2187+35] = + s[35];
gout[n*2187+36] = + s[36];
gout[n*2187+37] = + s[37];
gout[n*2187+38] = + s[38];
gout[n*2187+39] = + s[39];
gout[n*2187+40] = + s[40];
gout[n*2187+41] = + s[41];
gout[n*2187+42] = + s[42];
gout[n*2187+43] = + s[43];
gout[n*2187+44] = + s[44];
gout[n*2187+45] = + s[45];
gout[n*2187+46] = + s[46];
gout[n*2187+47] = + s[47];
gout[n*2187+48] = + s[48];
gout[n*2187+49] = + s[49];
gout[n*2187+50] = + s[50];
gout[n*2187+51] = + s[51];
gout[n*2187+52] = + s[52];
gout[n*2187+53] = + s[53];
gout[n*2187+54] = + s[54];
gout[n*2187+55] = + s[55];
gout[n*2187+56] = + s[56];
gout[n*2187+57] = + s[57];
gout[n*2187+58] = + s[58];
gout[n*2187+59] = + s[59];
gout[n*2187+60] = + s[60];
gout[n*2187+61] = + s[61];
gout[n*2187+62] = + s[62];
gout[n*2187+63] = + s[63];
gout[n*2187+64] = + s[64];
gout[n*2187+65] = + s[65];
gout[n*2187+66] = + s[66];
gout[n*2187+67] = + s[67];
gout[n*2187+68] = + s[68];
gout[n*2187+69] = + s[69];
gout[n*2187+70] = + s[70];
gout[n*2187+71] = + s[71];
gout[n*2187+72] = + s[72];
gout[n*2187+73] = + s[73];
gout[n*2187+74] = + s[74];
gout[n*2187+75] = + s[75];
gout[n*2187+76] = + s[76];
gout[n*2187+77] = + s[77];
gout[n*2187+78] = + s[78];
gout[n*2187+79] = + s[79];
gout[n*2187+80] = + s[80];
gout[n*2187+81] = + s[81];
gout[n*2187+82] = + s[82];
gout[n*2187+83] = + s[83];
gout[n*2187+84] = + s[84];
gout[n*2187+85] = + s[85];
gout[n*2187+86] = + s[86];
gout[n*2187+87] = + s[87];
gout[n*2187+88] = + s[88];
gout[n*2187+89] = + s[89];
gout[n*2187+90] = + s[90];
gout[n*2187+91] = + s[91];
gout[n*2187+92] = + s[92];
gout[n*2187+93] = + s[93];
gout[n*2187+94] = + s[94];
gout[n*2187+95] = + s[95];
gout[n*2187+96] = + s[96];
gout[n*2187+97] = + s[97];
gout[n*2187+98] = + s[98];
gout[n*2187+99] = + s[99];
gout[n*2187+100] = + s[100];
gout[n*2187+101] = + s[101];
gout[n*2187+102] = + s[102];
gout[n*2187+103] = + s[103];
gout[n*2187+104] = + s[104];
gout[n*2187+105] = + s[105];
gout[n*2187+106] = + s[106];
gout[n*2187+107] = + s[107];
gout[n*2187+108] = + s[108];
gout[n*2187+109] = + s[109];
gout[n*2187+110] = + s[110];
gout[n*2187+111] = + s[111];
gout[n*2187+112] = + s[112];
gout[n*2187+113] = + s[113];
gout[n*2187+114] = + s[114];
gout[n*2187+115] = + s[115];
gout[n*2187+116] = + s[116];
gout[n*2187+117] = + s[117];
gout[n*2187+118] = + s[118];
gout[n*2187+119] = + s[119];
gout[n*2187+120] = + s[120];
gout[n*2187+121] = + s[121];
gout[n*2187+122] = + s[122];
gout[n*2187+123] = + s[123];
gout[n*2187+124] = + s[124];
gout[n*2187+125] = + s[125];
gout[n*2187+126] = + s[126];
gout[n*2187+127] = + s[127];
gout[n*2187+128] = + s[128];
gout[n*2187+129] = + s[129];
gout[n*2187+130] = + s[130];
gout[n*2187+131] = + s[131];
gout[n*2187+132] = + s[132];
gout[n*2187+133] = + s[133];
gout[n*2187+134] = + s[134];
gout[n*2187+135] = + s[135];
gout[n*2187+136] = + s[136];
gout[n*2187+137] = + s[137];
gout[n*2187+138] = + s[138];
gout[n*2187+139] = + s[139];
gout[n*2187+140] = + s[140];
gout[n*2187+141] = + s[141];
gout[n*2187+142] = + s[142];
gout[n*2187+143] = + s[143];
gout[n*2187+144] = + s[144];
gout[n*2187+145] = + s[145];
gout[n*2187+146] = + s[146];
gout[n*2187+147] = + s[147];
gout[n*2187+148] = + s[148];
gout[n*2187+149] = + s[149];
gout[n*2187+150] = + s[150];
gout[n*2187+151] = + s[151];
gout[n*2187+152] = + s[152];
gout[n*2187+153] = + s[153];
gout[n*2187+154] = + s[154];
gout[n*2187+155] = + s[155];
gout[n*2187+156] = + s[156];
gout[n*2187+157] = + s[157];
gout[n*2187+158] = + s[158];
gout[n*2187+159] = + s[159];
gout[n*2187+160] = + s[160];
gout[n*2187+161] = + s[161];
gout[n*2187+162] = + s[162];
gout[n*2187+163] = + s[163];
gout[n*2187+164] = + s[164];
gout[n*2187+165] = + s[165];
gout[n*2187+166] = + s[166];
gout[n*2187+167] = + s[167];
gout[n*2187+168] = + s[168];
gout[n*2187+169] = + s[169];
gout[n*2187+170] = + s[170];
gout[n*2187+171] = + s[171];
gout[n*2187+172] = + s[172];
gout[n*2187+173] = + s[173];
gout[n*2187+174] = + s[174];
gout[n*2187+175] = + s[175];
gout[n*2187+176] = + s[176];
gout[n*2187+177] = + s[177];
gout[n*2187+178] = + s[178];
gout[n*2187+179] = + s[179];
gout[n*2187+180] = + s[180];
gout[n*2187+181] = + s[181];
gout[n*2187+182] = + s[182];
gout[n*2187+183] = + s[183];
gout[n*2187+184] = + s[184];
gout[n*2187+185] = + s[185];
gout[n*2187+186] = + s[186];
gout[n*2187+187] = + s[187];
gout[n*2187+188] = + s[188];
gout[n*2187+189] = + s[189];
gout[n*2187+190] = + s[190];
gout[n*2187+191] = + s[191];
gout[n*2187+192] = + s[192];
gout[n*2187+193] = + s[193];
gout[n*2187+194] = + s[194];
gout[n*2187+195] = + s[195];
gout[n*2187+196] = + s[196];
gout[n*2187+197] = + s[197];
gout[n*2187+198] = + s[198];
gout[n*2187+199] = + s[199];
gout[n*2187+200] = + s[200];
gout[n*2187+201] = + s[201];
gout[n*2187+202] = + s[202];
gout[n*2187+203] = + s[203];
gout[n*2187+204] = + s[204];
gout[n*2187+205] = + s[205];
gout[n*2187+206] = + s[206];
gout[n*2187+207] = + s[207];
gout[n*2187+208] = + s[208];
gout[n*2187+209] = + s[209];
gout[n*2187+210] = + s[210];
gout[n*2187+211] = + s[211];
gout[n*2187+212] = + s[212];
gout[n*2187+213] = + s[213];
gout[n*2187+214] = + s[214];
gout[n*2187+215] = + s[215];
gout[n*2187+216] = + s[216];
gout[n*2187+217] = + s[217];
gout[n*2187+218] = + s[218];
gout[n*2187+219] = + s[219];
gout[n*2187+220] = + s[220];
gout[n*2187+221] = + s[221];
gout[n*2187+222] = + s[222];
gout[n*2187+223] = + s[223];
gout[n*2187+224] = + s[224];
gout[n*2187+225] = + s[225];
gout[n*2187+226] = + s[226];
gout[n*2187+227] = + s[227];
gout[n*2187+228] = + s[228];
gout[n*2187+229] = + s[229];
gout[n*2187+230] = + s[230];
gout[n*2187+231] = + s[231];
gout[n*2187+232] = + s[232];
gout[n*2187+233] = + s[233];
gout[n*2187+234] = + s[234];
gout[n*2187+235] = + s[235];
gout[n*2187+236] = + s[236];
gout[n*2187+237] = + s[237];
gout[n*2187+238] = + s[238];
gout[n*2187+239] = + s[239];
gout[n*2187+240] = + s[240];
gout[n*2187+241] = + s[241];
gout[n*2187+242] = + s[242];
gout[n*2187+243] = + s[729];
gout[n*2187+244] = + s[730];
gout[n*2187+245] = + s[731];
gout[n*2187+246] = + s[732];
gout[n*2187+247] = + s[733];
gout[n*2187+248] = + s[734];
gout[n*2187+249] = + s[735];
gout[n*2187+250] = + s[736];
gout[n*2187+251] = + s[737];
gout[n*2187+252] = + s[738];
gout[n*2187+253] = + s[739];
gout[n*2187+254] = + s[740];
gout[n*2187+255] = + s[741];
gout[n*2187+256] = + s[742];
gout[n*2187+257] = + s[743];
gout[n*2187+258] = + s[744];
gout[n*2187+259] = + s[745];
gout[n*2187+260] = + s[746];
gout[n*2187+261] = + s[747];
gout[n*2187+262] = + s[748];
gout[n*2187+263] = + s[749];
gout[n*2187+264] = + s[750];
gout[n*2187+265] = + s[751];
gout[n*2187+266] = + s[752];
gout[n*2187+267] = + s[753];
gout[n*2187+268] = + s[754];
gout[n*2187+269] = + s[755];
gout[n*2187+270] = + s[756];
gout[n*2187+271] = + s[757];
gout[n*2187+272] = + s[758];
gout[n*2187+273] = + s[759];
gout[n*2187+274] = + s[760];
gout[n*2187+275] = + s[761];
gout[n*2187+276] = + s[762];
gout[n*2187+277] = + s[763];
gout[n*2187+278] = + s[764];
gout[n*2187+279] = + s[765];
gout[n*2187+280] = + s[766];
gout[n*2187+281] = + s[767];
gout[n*2187+282] = + s[768];
gout[n*2187+283] = + s[769];
gout[n*2187+284] = + s[770];
gout[n*2187+285] = + s[771];
gout[n*2187+286] = + s[772];
gout[n*2187+287] = + s[773];
gout[n*2187+288] = + s[774];
gout[n*2187+289] = + s[775];
gout[n*2187+290] = + s[776];
gout[n*2187+291] = + s[777];
gout[n*2187+292] = + s[778];
gout[n*2187+293] = + s[779];
gout[n*2187+294] = + s[780];
gout[n*2187+295] = + s[781];
gout[n*2187+296] = + s[782];
gout[n*2187+297] = + s[783];
gout[n*2187+298] = + s[784];
gout[n*2187+299] = + s[785];
gout[n*2187+300] = + s[786];
gout[n*2187+301] = + s[787];
gout[n*2187+302] = + s[788];
gout[n*2187+303] = + s[789];
gout[n*2187+304] = + s[790];
gout[n*2187+305] = + s[791];
gout[n*2187+306] = + s[792];
gout[n*2187+307] = + s[793];
gout[n*2187+308] = + s[794];
gout[n*2187+309] = + s[795];
gout[n*2187+310] = + s[796];
gout[n*2187+311] = + s[797];
gout[n*2187+312] = + s[798];
gout[n*2187+313] = + s[799];
gout[n*2187+314] = + s[800];
gout[n*2187+315] = + s[801];
gout[n*2187+316] = + s[802];
gout[n*2187+317] = + s[803];
gout[n*2187+318] = + s[804];
gout[n*2187+319] = + s[805];
gout[n*2187+320] = + s[806];
gout[n*2187+321] = + s[807];
gout[n*2187+322] = + s[808];
gout[n*2187+323] = + s[809];
gout[n*2187+324] = + s[810];
gout[n*2187+325] = + s[811];
gout[n*2187+326] = + s[812];
gout[n*2187+327] = + s[813];
gout[n*2187+328] = + s[814];
gout[n*2187+329] = + s[815];
gout[n*2187+330] = + s[816];
gout[n*2187+331] = + s[817];
gout[n*2187+332] = + s[818];
gout[n*2187+333] = + s[819];
gout[n*2187+334] = + s[820];
gout[n*2187+335] = + s[821];
gout[n*2187+336] = + s[822];
gout[n*2187+337] = + s[823];
gout[n*2187+338] = + s[824];
gout[n*2187+339] = + s[825];
gout[n*2187+340] = + s[826];
gout[n*2187+341] = + s[827];
gout[n*2187+342] = + s[828];
gout[n*2187+343] = + s[829];
gout[n*2187+344] = + s[830];
gout[n*2187+345] = + s[831];
gout[n*2187+346] = + s[832];
gout[n*2187+347] = + s[833];
gout[n*2187+348] = + s[834];
gout[n*2187+349] = + s[835];
gout[n*2187+350] = + s[836];
gout[n*2187+351] = + s[837];
gout[n*2187+352] = + s[838];
gout[n*2187+353] = + s[839];
gout[n*2187+354] = + s[840];
gout[n*2187+355] = + s[841];
gout[n*2187+356] = + s[842];
gout[n*2187+357] = + s[843];
gout[n*2187+358] = + s[844];
gout[n*2187+359] = + s[845];
gout[n*2187+360] = + s[846];
gout[n*2187+361] = + s[847];
gout[n*2187+362] = + s[848];
gout[n*2187+363] = + s[849];
gout[n*2187+364] = + s[850];
gout[n*2187+365] = + s[851];
gout[n*2187+366] = + s[852];
gout[n*2187+367] = + s[853];
gout[n*2187+368] = + s[854];
gout[n*2187+369] = + s[855];
gout[n*2187+370] = + s[856];
gout[n*2187+371] = + s[857];
gout[n*2187+372] = + s[858];
gout[n*2187+373] = + s[859];
gout[n*2187+374] = + s[860];
gout[n*2187+375] = + s[861];
gout[n*2187+376] = + s[862];
gout[n*2187+377] = + s[863];
gout[n*2187+378] = + s[864];
gout[n*2187+379] = + s[865];
gout[n*2187+380] = + s[866];
gout[n*2187+381] = + s[867];
gout[n*2187+382] = + s[868];
gout[n*2187+383] = + s[869];
gout[n*2187+384] = + s[870];
gout[n*2187+385] = + s[871];
gout[n*2187+386] = + s[872];
gout[n*2187+387] = + s[873];
gout[n*2187+388] = + s[874];
gout[n*2187+389] = + s[875];
gout[n*2187+390] = + s[876];
gout[n*2187+391] = + s[877];
gout[n*2187+392] = + s[878];
gout[n*2187+393] = + s[879];
gout[n*2187+394] = + s[880];
gout[n*2187+395] = + s[881];
gout[n*2187+396] = + s[882];
gout[n*2187+397] = + s[883];
gout[n*2187+398] = + s[884];
gout[n*2187+399] = + s[885];
gout[n*2187+400] = + s[886];
gout[n*2187+401] = + s[887];
gout[n*2187+402] = + s[888];
gout[n*2187+403] = + s[889];
gout[n*2187+404] = + s[890];
gout[n*2187+405] = + s[891];
gout[n*2187+406] = + s[892];
gout[n*2187+407] = + s[893];
gout[n*2187+408] = + s[894];
gout[n*2187+409] = + s[895];
gout[n*2187+410] = + s[896];
gout[n*2187+411] = + s[897];
gout[n*2187+412] = + s[898];
gout[n*2187+413] = + s[899];
gout[n*2187+414] = + s[900];
gout[n*2187+415] = + s[901];
gout[n*2187+416] = + s[902];
gout[n*2187+417] = + s[903];
gout[n*2187+418] = + s[904];
gout[n*2187+419] = + s[905];
gout[n*2187+420] = + s[906];
gout[n*2187+421] = + s[907];
gout[n*2187+422] = + s[908];
gout[n*2187+423] = + s[909];
gout[n*2187+424] = + s[910];
gout[n*2187+425] = + s[911];
gout[n*2187+426] = + s[912];
gout[n*2187+427] = + s[913];
gout[n*2187+428] = + s[914];
gout[n*2187+429] = + s[915];
gout[n*2187+430] = + s[916];
gout[n*2187+431] = + s[917];
gout[n*2187+432] = + s[918];
gout[n*2187+433] = + s[919];
gout[n*2187+434] = + s[920];
gout[n*2187+435] = + s[921];
gout[n*2187+436] = + s[922];
gout[n*2187+437] = + s[923];
gout[n*2187+438] = + s[924];
gout[n*2187+439] = + s[925];
gout[n*2187+440] = + s[926];
gout[n*2187+441] = + s[927];
gout[n*2187+442] = + s[928];
gout[n*2187+443] = + s[929];
gout[n*2187+444] = + s[930];
gout[n*2187+445] = + s[931];
gout[n*2187+446] = + s[932];
gout[n*2187+447] = + s[933];
gout[n*2187+448] = + s[934];
gout[n*2187+449] = + s[935];
gout[n*2187+450] = + s[936];
gout[n*2187+451] = + s[937];
gout[n*2187+452] = + s[938];
gout[n*2187+453] = + s[939];
gout[n*2187+454] = + s[940];
gout[n*2187+455] = + s[941];
gout[n*2187+456] = + s[942];
gout[n*2187+457] = + s[943];
gout[n*2187+458] = + s[944];
gout[n*2187+459] = + s[945];
gout[n*2187+460] = + s[946];
gout[n*2187+461] = + s[947];
gout[n*2187+462] = + s[948];
gout[n*2187+463] = + s[949];
gout[n*2187+464] = + s[950];
gout[n*2187+465] = + s[951];
gout[n*2187+466] = + s[952];
gout[n*2187+467] = + s[953];
gout[n*2187+468] = + s[954];
gout[n*2187+469] = + s[955];
gout[n*2187+470] = + s[956];
gout[n*2187+471] = + s[957];
gout[n*2187+472] = + s[958];
gout[n*2187+473] = + s[959];
gout[n*2187+474] = + s[960];
gout[n*2187+475] = + s[961];
gout[n*2187+476] = + s[962];
gout[n*2187+477] = + s[963];
gout[n*2187+478] = + s[964];
gout[n*2187+479] = + s[965];
gout[n*2187+480] = + s[966];
gout[n*2187+481] = + s[967];
gout[n*2187+482] = + s[968];
gout[n*2187+483] = + s[969];
gout[n*2187+484] = + s[970];
gout[n*2187+485] = + s[971];
gout[n*2187+486] = + s[1458];
gout[n*2187+487] = + s[1459];
gout[n*2187+488] = + s[1460];
gout[n*2187+489] = + s[1461];
gout[n*2187+490] = + s[1462];
gout[n*2187+491] = + s[1463];
gout[n*2187+492] = + s[1464];
gout[n*2187+493] = + s[1465];
gout[n*2187+494] = + s[1466];
gout[n*2187+495] = + s[1467];
gout[n*2187+496] = + s[1468];
gout[n*2187+497] = + s[1469];
gout[n*2187+498] = + s[1470];
gout[n*2187+499] = + s[1471];
gout[n*2187+500] = + s[1472];
gout[n*2187+501] = + s[1473];
gout[n*2187+502] = + s[1474];
gout[n*2187+503] = + s[1475];
gout[n*2187+504] = + s[1476];
gout[n*2187+505] = + s[1477];
gout[n*2187+506] = + s[1478];
gout[n*2187+507] = + s[1479];
gout[n*2187+508] = + s[1480];
gout[n*2187+509] = + s[1481];
gout[n*2187+510] = + s[1482];
gout[n*2187+511] = + s[1483];
gout[n*2187+512] = + s[1484];
gout[n*2187+513] = + s[1485];
gout[n*2187+514] = + s[1486];
gout[n*2187+515] = + s[1487];
gout[n*2187+516] = + s[1488];
gout[n*2187+517] = + s[1489];
gout[n*2187+518] = + s[1490];
gout[n*2187+519] = + s[1491];
gout[n*2187+520] = + s[1492];
gout[n*2187+521] = + s[1493];
gout[n*2187+522] = + s[1494];
gout[n*2187+523] = + s[1495];
gout[n*2187+524] = + s[1496];
gout[n*2187+525] = + s[1497];
gout[n*2187+526] = + s[1498];
gout[n*2187+527] = + s[1499];
gout[n*2187+528] = + s[1500];
gout[n*2187+529] = + s[1501];
gout[n*2187+530] = + s[1502];
gout[n*2187+531] = + s[1503];
gout[n*2187+532] = + s[1504];
gout[n*2187+533] = + s[1505];
gout[n*2187+534] = + s[1506];
gout[n*2187+535] = + s[1507];
gout[n*2187+536] = + s[1508];
gout[n*2187+537] = + s[1509];
gout[n*2187+538] = + s[1510];
gout[n*2187+539] = + s[1511];
gout[n*2187+540] = + s[1512];
gout[n*2187+541] = + s[1513];
gout[n*2187+542] = + s[1514];
gout[n*2187+543] = + s[1515];
gout[n*2187+544] = + s[1516];
gout[n*2187+545] = + s[1517];
gout[n*2187+546] = + s[1518];
gout[n*2187+547] = + s[1519];
gout[n*2187+548] = + s[1520];
gout[n*2187+549] = + s[1521];
gout[n*2187+550] = + s[1522];
gout[n*2187+551] = + s[1523];
gout[n*2187+552] = + s[1524];
gout[n*2187+553] = + s[1525];
gout[n*2187+554] = + s[1526];
gout[n*2187+555] = + s[1527];
gout[n*2187+556] = + s[1528];
gout[n*2187+557] = + s[1529];
gout[n*2187+558] = + s[1530];
gout[n*2187+559] = + s[1531];
gout[n*2187+560] = + s[1532];
gout[n*2187+561] = + s[1533];
gout[n*2187+562] = + s[1534];
gout[n*2187+563] = + s[1535];
gout[n*2187+564] = + s[1536];
gout[n*2187+565] = + s[1537];
gout[n*2187+566] = + s[1538];
gout[n*2187+567] = + s[1539];
gout[n*2187+568] = + s[1540];
gout[n*2187+569] = + s[1541];
gout[n*2187+570] = + s[1542];
gout[n*2187+571] = + s[1543];
gout[n*2187+572] = + s[1544];
gout[n*2187+573] = + s[1545];
gout[n*2187+574] = + s[1546];
gout[n*2187+575] = + s[1547];
gout[n*2187+576] = + s[1548];
gout[n*2187+577] = + s[1549];
gout[n*2187+578] = + s[1550];
gout[n*2187+579] = + s[1551];
gout[n*2187+580] = + s[1552];
gout[n*2187+581] = + s[1553];
gout[n*2187+582] = + s[1554];
gout[n*2187+583] = + s[1555];
gout[n*2187+584] = + s[1556];
gout[n*2187+585] = + s[1557];
gout[n*2187+586] = + s[1558];
gout[n*2187+587] = + s[1559];
gout[n*2187+588] = + s[1560];
gout[n*2187+589] = + s[1561];
gout[n*2187+590] = + s[1562];
gout[n*2187+591] = + s[1563];
gout[n*2187+592] = + s[1564];
gout[n*2187+593] = + s[1565];
gout[n*2187+594] = + s[1566];
gout[n*2187+595] = + s[1567];
gout[n*2187+596] = + s[1568];
gout[n*2187+597] = + s[1569];
gout[n*2187+598] = + s[1570];
gout[n*2187+599] = + s[1571];
gout[n*2187+600] = + s[1572];
gout[n*2187+601] = + s[1573];
gout[n*2187+602] = + s[1574];
gout[n*2187+603] = + s[1575];
gout[n*2187+604] = + s[1576];
gout[n*2187+605] = + s[1577];
gout[n*2187+606] = + s[1578];
gout[n*2187+607] = + s[1579];
gout[n*2187+608] = + s[1580];
gout[n*2187+609] = + s[1581];
gout[n*2187+610] = + s[1582];
gout[n*2187+611] = + s[1583];
gout[n*2187+612] = + s[1584];
gout[n*2187+613] = + s[1585];
gout[n*2187+614] = + s[1586];
gout[n*2187+615] = + s[1587];
gout[n*2187+616] = + s[1588];
gout[n*2187+617] = + s[1589];
gout[n*2187+618] = + s[1590];
gout[n*2187+619] = + s[1591];
gout[n*2187+620] = + s[1592];
gout[n*2187+621] = + s[1593];
gout[n*2187+622] = + s[1594];
gout[n*2187+623] = + s[1595];
gout[n*2187+624] = + s[1596];
gout[n*2187+625] = + s[1597];
gout[n*2187+626] = + s[1598];
gout[n*2187+627] = + s[1599];
gout[n*2187+628] = + s[1600];
gout[n*2187+629] = + s[1601];
gout[n*2187+630] = + s[1602];
gout[n*2187+631] = + s[1603];
gout[n*2187+632] = + s[1604];
gout[n*2187+633] = + s[1605];
gout[n*2187+634] = + s[1606];
gout[n*2187+635] = + s[1607];
gout[n*2187+636] = + s[1608];
gout[n*2187+637] = + s[1609];
gout[n*2187+638] = + s[1610];
gout[n*2187+639] = + s[1611];
gout[n*2187+640] = + s[1612];
gout[n*2187+641] = + s[1613];
gout[n*2187+642] = + s[1614];
gout[n*2187+643] = + s[1615];
gout[n*2187+644] = + s[1616];
gout[n*2187+645] = + s[1617];
gout[n*2187+646] = + s[1618];
gout[n*2187+647] = + s[1619];
gout[n*2187+648] = + s[1620];
gout[n*2187+649] = + s[1621];
gout[n*2187+650] = + s[1622];
gout[n*2187+651] = + s[1623];
gout[n*2187+652] = + s[1624];
gout[n*2187+653] = + s[1625];
gout[n*2187+654] = + s[1626];
gout[n*2187+655] = + s[1627];
gout[n*2187+656] = + s[1628];
gout[n*2187+657] = + s[1629];
gout[n*2187+658] = + s[1630];
gout[n*2187+659] = + s[1631];
gout[n*2187+660] = + s[1632];
gout[n*2187+661] = + s[1633];
gout[n*2187+662] = + s[1634];
gout[n*2187+663] = + s[1635];
gout[n*2187+664] = + s[1636];
gout[n*2187+665] = + s[1637];
gout[n*2187+666] = + s[1638];
gout[n*2187+667] = + s[1639];
gout[n*2187+668] = + s[1640];
gout[n*2187+669] = + s[1641];
gout[n*2187+670] = + s[1642];
gout[n*2187+671] = + s[1643];
gout[n*2187+672] = + s[1644];
gout[n*2187+673] = + s[1645];
gout[n*2187+674] = + s[1646];
gout[n*2187+675] = + s[1647];
gout[n*2187+676] = + s[1648];
gout[n*2187+677] = + s[1649];
gout[n*2187+678] = + s[1650];
gout[n*2187+679] = + s[1651];
gout[n*2187+680] = + s[1652];
gout[n*2187+681] = + s[1653];
gout[n*2187+682] = + s[1654];
gout[n*2187+683] = + s[1655];
gout[n*2187+684] = + s[1656];
gout[n*2187+685] = + s[1657];
gout[n*2187+686] = + s[1658];
gout[n*2187+687] = + s[1659];
gout[n*2187+688] = + s[1660];
gout[n*2187+689] = + s[1661];
gout[n*2187+690] = + s[1662];
gout[n*2187+691] = + s[1663];
gout[n*2187+692] = + s[1664];
gout[n*2187+693] = + s[1665];
gout[n*2187+694] = + s[1666];
gout[n*2187+695] = + s[1667];
gout[n*2187+696] = + s[1668];
gout[n*2187+697] = + s[1669];
gout[n*2187+698] = + s[1670];
gout[n*2187+699] = + s[1671];
gout[n*2187+700] = + s[1672];
gout[n*2187+701] = + s[1673];
gout[n*2187+702] = + s[1674];
gout[n*2187+703] = + s[1675];
gout[n*2187+704] = + s[1676];
gout[n*2187+705] = + s[1677];
gout[n*2187+706] = + s[1678];
gout[n*2187+707] = + s[1679];
gout[n*2187+708] = + s[1680];
gout[n*2187+709] = + s[1681];
gout[n*2187+710] = + s[1682];
gout[n*2187+711] = + s[1683];
gout[n*2187+712] = + s[1684];
gout[n*2187+713] = + s[1685];
gout[n*2187+714] = + s[1686];
gout[n*2187+715] = + s[1687];
gout[n*2187+716] = + s[1688];
gout[n*2187+717] = + s[1689];
gout[n*2187+718] = + s[1690];
gout[n*2187+719] = + s[1691];
gout[n*2187+720] = + s[1692];
gout[n*2187+721] = + s[1693];
gout[n*2187+722] = + s[1694];
gout[n*2187+723] = + s[1695];
gout[n*2187+724] = + s[1696];
gout[n*2187+725] = + s[1697];
gout[n*2187+726] = + s[1698];
gout[n*2187+727] = + s[1699];
gout[n*2187+728] = + s[1700];
gout[n*2187+729] = + s[243];
gout[n*2187+730] = + s[244];
gout[n*2187+731] = + s[245];
gout[n*2187+732] = + s[246];
gout[n*2187+733] = + s[247];
gout[n*2187+734] = + s[248];
gout[n*2187+735] = + s[249];
gout[n*2187+736] = + s[250];
gout[n*2187+737] = + s[251];
gout[n*2187+738] = + s[252];
gout[n*2187+739] = + s[253];
gout[n*2187+740] = + s[254];
gout[n*2187+741] = + s[255];
gout[n*2187+742] = + s[256];
gout[n*2187+743] = + s[257];
gout[n*2187+744] = + s[258];
gout[n*2187+745] = + s[259];
gout[n*2187+746] = + s[260];
gout[n*2187+747] = + s[261];
gout[n*2187+748] = + s[262];
gout[n*2187+749] = + s[263];
gout[n*2187+750] = + s[264];
gout[n*2187+751] = + s[265];
gout[n*2187+752] = + s[266];
gout[n*2187+753] = + s[267];
gout[n*2187+754] = + s[268];
gout[n*2187+755] = + s[269];
gout[n*2187+756] = + s[270];
gout[n*2187+757] = + s[271];
gout[n*2187+758] = + s[272];
gout[n*2187+759] = + s[273];
gout[n*2187+760] = + s[274];
gout[n*2187+761] = + s[275];
gout[n*2187+762] = + s[276];
gout[n*2187+763] = + s[277];
gout[n*2187+764] = + s[278];
gout[n*2187+765] = + s[279];
gout[n*2187+766] = + s[280];
gout[n*2187+767] = + s[281];
gout[n*2187+768] = + s[282];
gout[n*2187+769] = + s[283];
gout[n*2187+770] = + s[284];
gout[n*2187+771] = + s[285];
gout[n*2187+772] = + s[286];
gout[n*2187+773] = + s[287];
gout[n*2187+774] = + s[288];
gout[n*2187+775] = + s[289];
gout[n*2187+776] = + s[290];
gout[n*2187+777] = + s[291];
gout[n*2187+778] = + s[292];
gout[n*2187+779] = + s[293];
gout[n*2187+780] = + s[294];
gout[n*2187+781] = + s[295];
gout[n*2187+782] = + s[296];
gout[n*2187+783] = + s[297];
gout[n*2187+784] = + s[298];
gout[n*2187+785] = + s[299];
gout[n*2187+786] = + s[300];
gout[n*2187+787] = + s[301];
gout[n*2187+788] = + s[302];
gout[n*2187+789] = + s[303];
gout[n*2187+790] = + s[304];
gout[n*2187+791] = + s[305];
gout[n*2187+792] = + s[306];
gout[n*2187+793] = + s[307];
gout[n*2187+794] = + s[308];
gout[n*2187+795] = + s[309];
gout[n*2187+796] = + s[310];
gout[n*2187+797] = + s[311];
gout[n*2187+798] = + s[312];
gout[n*2187+799] = + s[313];
gout[n*2187+800] = + s[314];
gout[n*2187+801] = + s[315];
gout[n*2187+802] = + s[316];
gout[n*2187+803] = + s[317];
gout[n*2187+804] = + s[318];
gout[n*2187+805] = + s[319];
gout[n*2187+806] = + s[320];
gout[n*2187+807] = + s[321];
gout[n*2187+808] = + s[322];
gout[n*2187+809] = + s[323];
gout[n*2187+810] = + s[324];
gout[n*2187+811] = + s[325];
gout[n*2187+812] = + s[326];
gout[n*2187+813] = + s[327];
gout[n*2187+814] = + s[328];
gout[n*2187+815] = + s[329];
gout[n*2187+816] = + s[330];
gout[n*2187+817] = + s[331];
gout[n*2187+818] = + s[332];
gout[n*2187+819] = + s[333];
gout[n*2187+820] = + s[334];
gout[n*2187+821] = + s[335];
gout[n*2187+822] = + s[336];
gout[n*2187+823] = + s[337];
gout[n*2187+824] = + s[338];
gout[n*2187+825] = + s[339];
gout[n*2187+826] = + s[340];
gout[n*2187+827] = + s[341];
gout[n*2187+828] = + s[342];
gout[n*2187+829] = + s[343];
gout[n*2187+830] = + s[344];
gout[n*2187+831] = + s[345];
gout[n*2187+832] = + s[346];
gout[n*2187+833] = + s[347];
gout[n*2187+834] = + s[348];
gout[n*2187+835] = + s[349];
gout[n*2187+836] = + s[350];
gout[n*2187+837] = + s[351];
gout[n*2187+838] = + s[352];
gout[n*2187+839] = + s[353];
gout[n*2187+840] = + s[354];
gout[n*2187+841] = + s[355];
gout[n*2187+842] = + s[356];
gout[n*2187+843] = + s[357];
gout[n*2187+844] = + s[358];
gout[n*2187+845] = + s[359];
gout[n*2187+846] = + s[360];
gout[n*2187+847] = + s[361];
gout[n*2187+848] = + s[362];
gout[n*2187+849] = + s[363];
gout[n*2187+850] = + s[364];
gout[n*2187+851] = + s[365];
gout[n*2187+852] = + s[366];
gout[n*2187+853] = + s[367];
gout[n*2187+854] = + s[368];
gout[n*2187+855] = + s[369];
gout[n*2187+856] = + s[370];
gout[n*2187+857] = + s[371];
gout[n*2187+858] = + s[372];
gout[n*2187+859] = + s[373];
gout[n*2187+860] = + s[374];
gout[n*2187+861] = + s[375];
gout[n*2187+862] = + s[376];
gout[n*2187+863] = + s[377];
gout[n*2187+864] = + s[378];
gout[n*2187+865] = + s[379];
gout[n*2187+866] = + s[380];
gout[n*2187+867] = + s[381];
gout[n*2187+868] = + s[382];
gout[n*2187+869] = + s[383];
gout[n*2187+870] = + s[384];
gout[n*2187+871] = + s[385];
gout[n*2187+872] = + s[386];
gout[n*2187+873] = + s[387];
gout[n*2187+874] = + s[388];
gout[n*2187+875] = + s[389];
gout[n*2187+876] = + s[390];
gout[n*2187+877] = + s[391];
gout[n*2187+878] = + s[392];
gout[n*2187+879] = + s[393];
gout[n*2187+880] = + s[394];
gout[n*2187+881] = + s[395];
gout[n*2187+882] = + s[396];
gout[n*2187+883] = + s[397];
gout[n*2187+884] = + s[398];
gout[n*2187+885] = + s[399];
gout[n*2187+886] = + s[400];
gout[n*2187+887] = + s[401];
gout[n*2187+888] = + s[402];
gout[n*2187+889] = + s[403];
gout[n*2187+890] = + s[404];
gout[n*2187+891] = + s[405];
gout[n*2187+892] = + s[406];
gout[n*2187+893] = + s[407];
gout[n*2187+894] = + s[408];
gout[n*2187+895] = + s[409];
gout[n*2187+896] = + s[410];
gout[n*2187+897] = + s[411];
gout[n*2187+898] = + s[412];
gout[n*2187+899] = + s[413];
gout[n*2187+900] = + s[414];
gout[n*2187+901] = + s[415];
gout[n*2187+902] = + s[416];
gout[n*2187+903] = + s[417];
gout[n*2187+904] = + s[418];
gout[n*2187+905] = + s[419];
gout[n*2187+906] = + s[420];
gout[n*2187+907] = + s[421];
gout[n*2187+908] = + s[422];
gout[n*2187+909] = + s[423];
gout[n*2187+910] = + s[424];
gout[n*2187+911] = + s[425];
gout[n*2187+912] = + s[426];
gout[n*2187+913] = + s[427];
gout[n*2187+914] = + s[428];
gout[n*2187+915] = + s[429];
gout[n*2187+916] = + s[430];
gout[n*2187+917] = + s[431];
gout[n*2187+918] = + s[432];
gout[n*2187+919] = + s[433];
gout[n*2187+920] = + s[434];
gout[n*2187+921] = + s[435];
gout[n*2187+922] = + s[436];
gout[n*2187+923] = + s[437];
gout[n*2187+924] = + s[438];
gout[n*2187+925] = + s[439];
gout[n*2187+926] = + s[440];
gout[n*2187+927] = + s[441];
gout[n*2187+928] = + s[442];
gout[n*2187+929] = + s[443];
gout[n*2187+930] = + s[444];
gout[n*2187+931] = + s[445];
gout[n*2187+932] = + s[446];
gout[n*2187+933] = + s[447];
gout[n*2187+934] = + s[448];
gout[n*2187+935] = + s[449];
gout[n*2187+936] = + s[450];
gout[n*2187+937] = + s[451];
gout[n*2187+938] = + s[452];
gout[n*2187+939] = + s[453];
gout[n*2187+940] = + s[454];
gout[n*2187+941] = + s[455];
gout[n*2187+942] = + s[456];
gout[n*2187+943] = + s[457];
gout[n*2187+944] = + s[458];
gout[n*2187+945] = + s[459];
gout[n*2187+946] = + s[460];
gout[n*2187+947] = + s[461];
gout[n*2187+948] = + s[462];
gout[n*2187+949] = + s[463];
gout[n*2187+950] = + s[464];
gout[n*2187+951] = + s[465];
gout[n*2187+952] = + s[466];
gout[n*2187+953] = + s[467];
gout[n*2187+954] = + s[468];
gout[n*2187+955] = + s[469];
gout[n*2187+956] = + s[470];
gout[n*2187+957] = + s[471];
gout[n*2187+958] = + s[472];
gout[n*2187+959] = + s[473];
gout[n*2187+960] = + s[474];
gout[n*2187+961] = + s[475];
gout[n*2187+962] = + s[476];
gout[n*2187+963] = + s[477];
gout[n*2187+964] = + s[478];
gout[n*2187+965] = + s[479];
gout[n*2187+966] = + s[480];
gout[n*2187+967] = + s[481];
gout[n*2187+968] = + s[482];
gout[n*2187+969] = + s[483];
gout[n*2187+970] = + s[484];
gout[n*2187+971] = + s[485];
gout[n*2187+972] = + s[972];
gout[n*2187+973] = + s[973];
gout[n*2187+974] = + s[974];
gout[n*2187+975] = + s[975];
gout[n*2187+976] = + s[976];
gout[n*2187+977] = + s[977];
gout[n*2187+978] = + s[978];
gout[n*2187+979] = + s[979];
gout[n*2187+980] = + s[980];
gout[n*2187+981] = + s[981];
gout[n*2187+982] = + s[982];
gout[n*2187+983] = + s[983];
gout[n*2187+984] = + s[984];
gout[n*2187+985] = + s[985];
gout[n*2187+986] = + s[986];
gout[n*2187+987] = + s[987];
gout[n*2187+988] = + s[988];
gout[n*2187+989] = + s[989];
gout[n*2187+990] = + s[990];
gout[n*2187+991] = + s[991];
gout[n*2187+992] = + s[992];
gout[n*2187+993] = + s[993];
gout[n*2187+994] = + s[994];
gout[n*2187+995] = + s[995];
gout[n*2187+996] = + s[996];
gout[n*2187+997] = + s[997];
gout[n*2187+998] = + s[998];
gout[n*2187+999] = + s[999];
gout[n*2187+1000] = + s[1000];
gout[n*2187+1001] = + s[1001];
gout[n*2187+1002] = + s[1002];
gout[n*2187+1003] = + s[1003];
gout[n*2187+1004] = + s[1004];
gout[n*2187+1005] = + s[1005];
gout[n*2187+1006] = + s[1006];
gout[n*2187+1007] = + s[1007];
gout[n*2187+1008] = + s[1008];
gout[n*2187+1009] = + s[1009];
gout[n*2187+1010] = + s[1010];
gout[n*2187+1011] = + s[1011];
gout[n*2187+1012] = + s[1012];
gout[n*2187+1013] = + s[1013];
gout[n*2187+1014] = + s[1014];
gout[n*2187+1015] = + s[1015];
gout[n*2187+1016] = + s[1016];
gout[n*2187+1017] = + s[1017];
gout[n*2187+1018] = + s[1018];
gout[n*2187+1019] = + s[1019];
gout[n*2187+1020] = + s[1020];
gout[n*2187+1021] = + s[1021];
gout[n*2187+1022] = + s[1022];
gout[n*2187+1023] = + s[1023];
gout[n*2187+1024] = + s[1024];
gout[n*2187+1025] = + s[1025];
gout[n*2187+1026] = + s[1026];
gout[n*2187+1027] = + s[1027];
gout[n*2187+1028] = + s[1028];
gout[n*2187+1029] = + s[1029];
gout[n*2187+1030] = + s[1030];
gout[n*2187+1031] = + s[1031];
gout[n*2187+1032] = + s[1032];
gout[n*2187+1033] = + s[1033];
gout[n*2187+1034] = + s[1034];
gout[n*2187+1035] = + s[1035];
gout[n*2187+1036] = + s[1036];
gout[n*2187+1037] = + s[1037];
gout[n*2187+1038] = + s[1038];
gout[n*2187+1039] = + s[1039];
gout[n*2187+1040] = + s[1040];
gout[n*2187+1041] = + s[1041];
gout[n*2187+1042] = + s[1042];
gout[n*2187+1043] = + s[1043];
gout[n*2187+1044] = + s[1044];
gout[n*2187+1045] = + s[1045];
gout[n*2187+1046] = + s[1046];
gout[n*2187+1047] = + s[1047];
gout[n*2187+1048] = + s[1048];
gout[n*2187+1049] = + s[1049];
gout[n*2187+1050] = + s[1050];
gout[n*2187+1051] = + s[1051];
gout[n*2187+1052] = + s[1052];
gout[n*2187+1053] = + s[1053];
gout[n*2187+1054] = + s[1054];
gout[n*2187+1055] = + s[1055];
gout[n*2187+1056] = + s[1056];
gout[n*2187+1057] = + s[1057];
gout[n*2187+1058] = + s[1058];
gout[n*2187+1059] = + s[1059];
gout[n*2187+1060] = + s[1060];
gout[n*2187+1061] = + s[1061];
gout[n*2187+1062] = + s[1062];
gout[n*2187+1063] = + s[1063];
gout[n*2187+1064] = + s[1064];
gout[n*2187+1065] = + s[1065];
gout[n*2187+1066] = + s[1066];
gout[n*2187+1067] = + s[1067];
gout[n*2187+1068] = + s[1068];
gout[n*2187+1069] = + s[1069];
gout[n*2187+1070] = + s[1070];
gout[n*2187+1071] = + s[1071];
gout[n*2187+1072] = + s[1072];
gout[n*2187+1073] = + s[1073];
gout[n*2187+1074] = + s[1074];
gout[n*2187+1075] = + s[1075];
gout[n*2187+1076] = + s[1076];
gout[n*2187+1077] = + s[1077];
gout[n*2187+1078] = + s[1078];
gout[n*2187+1079] = + s[1079];
gout[n*2187+1080] = + s[1080];
gout[n*2187+1081] = + s[1081];
gout[n*2187+1082] = + s[1082];
gout[n*2187+1083] = + s[1083];
gout[n*2187+1084] = + s[1084];
gout[n*2187+1085] = + s[1085];
gout[n*2187+1086] = + s[1086];
gout[n*2187+1087] = + s[1087];
gout[n*2187+1088] = + s[1088];
gout[n*2187+1089] = + s[1089];
gout[n*2187+1090] = + s[1090];
gout[n*2187+1091] = + s[1091];
gout[n*2187+1092] = + s[1092];
gout[n*2187+1093] = + s[1093];
gout[n*2187+1094] = + s[1094];
gout[n*2187+1095] = + s[1095];
gout[n*2187+1096] = + s[1096];
gout[n*2187+1097] = + s[1097];
gout[n*2187+1098] = + s[1098];
gout[n*2187+1099] = + s[1099];
gout[n*2187+1100] = + s[1100];
gout[n*2187+1101] = + s[1101];
gout[n*2187+1102] = + s[1102];
gout[n*2187+1103] = + s[1103];
gout[n*2187+1104] = + s[1104];
gout[n*2187+1105] = + s[1105];
gout[n*2187+1106] = + s[1106];
gout[n*2187+1107] = + s[1107];
gout[n*2187+1108] = + s[1108];
gout[n*2187+1109] = + s[1109];
gout[n*2187+1110] = + s[1110];
gout[n*2187+1111] = + s[1111];
gout[n*2187+1112] = + s[1112];
gout[n*2187+1113] = + s[1113];
gout[n*2187+1114] = + s[1114];
gout[n*2187+1115] = + s[1115];
gout[n*2187+1116] = + s[1116];
gout[n*2187+1117] = + s[1117];
gout[n*2187+1118] = + s[1118];
gout[n*2187+1119] = + s[1119];
gout[n*2187+1120] = + s[1120];
gout[n*2187+1121] = + s[1121];
gout[n*2187+1122] = + s[1122];
gout[n*2187+1123] = + s[1123];
gout[n*2187+1124] = + s[1124];
gout[n*2187+1125] = + s[1125];
gout[n*2187+1126] = + s[1126];
gout[n*2187+1127] = + s[1127];
gout[n*2187+1128] = + s[1128];
gout[n*2187+1129] = + s[1129];
gout[n*2187+1130] = + s[1130];
gout[n*2187+1131] = + s[1131];
gout[n*2187+1132] = + s[1132];
gout[n*2187+1133] = + s[1133];
gout[n*2187+1134] = + s[1134];
gout[n*2187+1135] = + s[1135];
gout[n*2187+1136] = + s[1136];
gout[n*2187+1137] = + s[1137];
gout[n*2187+1138] = + s[1138];
gout[n*2187+1139] = + s[1139];
gout[n*2187+1140] = + s[1140];
gout[n*2187+1141] = + s[1141];
gout[n*2187+1142] = + s[1142];
gout[n*2187+1143] = + s[1143];
gout[n*2187+1144] = + s[1144];
gout[n*2187+1145] = + s[1145];
gout[n*2187+1146] = + s[1146];
gout[n*2187+1147] = + s[1147];
gout[n*2187+1148] = + s[1148];
gout[n*2187+1149] = + s[1149];
gout[n*2187+1150] = + s[1150];
gout[n*2187+1151] = + s[1151];
gout[n*2187+1152] = + s[1152];
gout[n*2187+1153] = + s[1153];
gout[n*2187+1154] = + s[1154];
gout[n*2187+1155] = + s[1155];
gout[n*2187+1156] = + s[1156];
gout[n*2187+1157] = + s[1157];
gout[n*2187+1158] = + s[1158];
gout[n*2187+1159] = + s[1159];
gout[n*2187+1160] = + s[1160];
gout[n*2187+1161] = + s[1161];
gout[n*2187+1162] = + s[1162];
gout[n*2187+1163] = + s[1163];
gout[n*2187+1164] = + s[1164];
gout[n*2187+1165] = + s[1165];
gout[n*2187+1166] = + s[1166];
gout[n*2187+1167] = + s[1167];
gout[n*2187+1168] = + s[1168];
gout[n*2187+1169] = + s[1169];
gout[n*2187+1170] = + s[1170];
gout[n*2187+1171] = + s[1171];
gout[n*2187+1172] = + s[1172];
gout[n*2187+1173] = + s[1173];
gout[n*2187+1174] = + s[1174];
gout[n*2187+1175] = + s[1175];
gout[n*2187+1176] = + s[1176];
gout[n*2187+1177] = + s[1177];
gout[n*2187+1178] = + s[1178];
gout[n*2187+1179] = + s[1179];
gout[n*2187+1180] = + s[1180];
gout[n*2187+1181] = + s[1181];
gout[n*2187+1182] = + s[1182];
gout[n*2187+1183] = + s[1183];
gout[n*2187+1184] = + s[1184];
gout[n*2187+1185] = + s[1185];
gout[n*2187+1186] = + s[1186];
gout[n*2187+1187] = + s[1187];
gout[n*2187+1188] = + s[1188];
gout[n*2187+1189] = + s[1189];
gout[n*2187+1190] = + s[1190];
gout[n*2187+1191] = + s[1191];
gout[n*2187+1192] = + s[1192];
gout[n*2187+1193] = + s[1193];
gout[n*2187+1194] = + s[1194];
gout[n*2187+1195] = + s[1195];
gout[n*2187+1196] = + s[1196];
gout[n*2187+1197] = + s[1197];
gout[n*2187+1198] = + s[1198];
gout[n*2187+1199] = + s[1199];
gout[n*2187+1200] = + s[1200];
gout[n*2187+1201] = + s[1201];
gout[n*2187+1202] = + s[1202];
gout[n*2187+1203] = + s[1203];
gout[n*2187+1204] = + s[1204];
gout[n*2187+1205] = + s[1205];
gout[n*2187+1206] = + s[1206];
gout[n*2187+1207] = + s[1207];
gout[n*2187+1208] = + s[1208];
gout[n*2187+1209] = + s[1209];
gout[n*2187+1210] = + s[1210];
gout[n*2187+1211] = + s[1211];
gout[n*2187+1212] = + s[1212];
gout[n*2187+1213] = + s[1213];
gout[n*2187+1214] = + s[1214];
gout[n*2187+1215] = + s[1701];
gout[n*2187+1216] = + s[1702];
gout[n*2187+1217] = + s[1703];
gout[n*2187+1218] = + s[1704];
gout[n*2187+1219] = + s[1705];
gout[n*2187+1220] = + s[1706];
gout[n*2187+1221] = + s[1707];
gout[n*2187+1222] = + s[1708];
gout[n*2187+1223] = + s[1709];
gout[n*2187+1224] = + s[1710];
gout[n*2187+1225] = + s[1711];
gout[n*2187+1226] = + s[1712];
gout[n*2187+1227] = + s[1713];
gout[n*2187+1228] = + s[1714];
gout[n*2187+1229] = + s[1715];
gout[n*2187+1230] = + s[1716];
gout[n*2187+1231] = + s[1717];
gout[n*2187+1232] = + s[1718];
gout[n*2187+1233] = + s[1719];
gout[n*2187+1234] = + s[1720];
gout[n*2187+1235] = + s[1721];
gout[n*2187+1236] = + s[1722];
gout[n*2187+1237] = + s[1723];
gout[n*2187+1238] = + s[1724];
gout[n*2187+1239] = + s[1725];
gout[n*2187+1240] = + s[1726];
gout[n*2187+1241] = + s[1727];
gout[n*2187+1242] = + s[1728];
gout[n*2187+1243] = + s[1729];
gout[n*2187+1244] = + s[1730];
gout[n*2187+1245] = + s[1731];
gout[n*2187+1246] = + s[1732];
gout[n*2187+1247] = + s[1733];
gout[n*2187+1248] = + s[1734];
gout[n*2187+1249] = + s[1735];
gout[n*2187+1250] = + s[1736];
gout[n*2187+1251] = + s[1737];
gout[n*2187+1252] = + s[1738];
gout[n*2187+1253] = + s[1739];
gout[n*2187+1254] = + s[1740];
gout[n*2187+1255] = + s[1741];
gout[n*2187+1256] = + s[1742];
gout[n*2187+1257] = + s[1743];
gout[n*2187+1258] = + s[1744];
gout[n*2187+1259] = + s[1745];
gout[n*2187+1260] = + s[1746];
gout[n*2187+1261] = + s[1747];
gout[n*2187+1262] = + s[1748];
gout[n*2187+1263] = + s[1749];
gout[n*2187+1264] = + s[1750];
gout[n*2187+1265] = + s[1751];
gout[n*2187+1266] = + s[1752];
gout[n*2187+1267] = + s[1753];
gout[n*2187+1268] = + s[1754];
gout[n*2187+1269] = + s[1755];
gout[n*2187+1270] = + s[1756];
gout[n*2187+1271] = + s[1757];
gout[n*2187+1272] = + s[1758];
gout[n*2187+1273] = + s[1759];
gout[n*2187+1274] = + s[1760];
gout[n*2187+1275] = + s[1761];
gout[n*2187+1276] = + s[1762];
gout[n*2187+1277] = + s[1763];
gout[n*2187+1278] = + s[1764];
gout[n*2187+1279] = + s[1765];
gout[n*2187+1280] = + s[1766];
gout[n*2187+1281] = + s[1767];
gout[n*2187+1282] = + s[1768];
gout[n*2187+1283] = + s[1769];
gout[n*2187+1284] = + s[1770];
gout[n*2187+1285] = + s[1771];
gout[n*2187+1286] = + s[1772];
gout[n*2187+1287] = + s[1773];
gout[n*2187+1288] = + s[1774];
gout[n*2187+1289] = + s[1775];
gout[n*2187+1290] = + s[1776];
gout[n*2187+1291] = + s[1777];
gout[n*2187+1292] = + s[1778];
gout[n*2187+1293] = + s[1779];
gout[n*2187+1294] = + s[1780];
gout[n*2187+1295] = + s[1781];
gout[n*2187+1296] = + s[1782];
gout[n*2187+1297] = + s[1783];
gout[n*2187+1298] = + s[1784];
gout[n*2187+1299] = + s[1785];
gout[n*2187+1300] = + s[1786];
gout[n*2187+1301] = + s[1787];
gout[n*2187+1302] = + s[1788];
gout[n*2187+1303] = + s[1789];
gout[n*2187+1304] = + s[1790];
gout[n*2187+1305] = + s[1791];
gout[n*2187+1306] = + s[1792];
gout[n*2187+1307] = + s[1793];
gout[n*2187+1308] = + s[1794];
gout[n*2187+1309] = + s[1795];
gout[n*2187+1310] = + s[1796];
gout[n*2187+1311] = + s[1797];
gout[n*2187+1312] = + s[1798];
gout[n*2187+1313] = + s[1799];
gout[n*2187+1314] = + s[1800];
gout[n*2187+1315] = + s[1801];
gout[n*2187+1316] = + s[1802];
gout[n*2187+1317] = + s[1803];
gout[n*2187+1318] = + s[1804];
gout[n*2187+1319] = + s[1805];
gout[n*2187+1320] = + s[1806];
gout[n*2187+1321] = + s[1807];
gout[n*2187+1322] = + s[1808];
gout[n*2187+1323] = + s[1809];
gout[n*2187+1324] = + s[1810];
gout[n*2187+1325] = + s[1811];
gout[n*2187+1326] = + s[1812];
gout[n*2187+1327] = + s[1813];
gout[n*2187+1328] = + s[1814];
gout[n*2187+1329] = + s[1815];
gout[n*2187+1330] = + s[1816];
gout[n*2187+1331] = + s[1817];
gout[n*2187+1332] = + s[1818];
gout[n*2187+1333] = + s[1819];
gout[n*2187+1334] = + s[1820];
gout[n*2187+1335] = + s[1821];
gout[n*2187+1336] = + s[1822];
gout[n*2187+1337] = + s[1823];
gout[n*2187+1338] = + s[1824];
gout[n*2187+1339] = + s[1825];
gout[n*2187+1340] = + s[1826];
gout[n*2187+1341] = + s[1827];
gout[n*2187+1342] = + s[1828];
gout[n*2187+1343] = + s[1829];
gout[n*2187+1344] = + s[1830];
gout[n*2187+1345] = + s[1831];
gout[n*2187+1346] = + s[1832];
gout[n*2187+1347] = + s[1833];
gout[n*2187+1348] = + s[1834];
gout[n*2187+1349] = + s[1835];
gout[n*2187+1350] = + s[1836];
gout[n*2187+1351] = + s[1837];
gout[n*2187+1352] = + s[1838];
gout[n*2187+1353] = + s[1839];
gout[n*2187+1354] = + s[1840];
gout[n*2187+1355] = + s[1841];
gout[n*2187+1356] = + s[1842];
gout[n*2187+1357] = + s[1843];
gout[n*2187+1358] = + s[1844];
gout[n*2187+1359] = + s[1845];
gout[n*2187+1360] = + s[1846];
gout[n*2187+1361] = + s[1847];
gout[n*2187+1362] = + s[1848];
gout[n*2187+1363] = + s[1849];
gout[n*2187+1364] = + s[1850];
gout[n*2187+1365] = + s[1851];
gout[n*2187+1366] = + s[1852];
gout[n*2187+1367] = + s[1853];
gout[n*2187+1368] = + s[1854];
gout[n*2187+1369] = + s[1855];
gout[n*2187+1370] = + s[1856];
gout[n*2187+1371] = + s[1857];
gout[n*2187+1372] = + s[1858];
gout[n*2187+1373] = + s[1859];
gout[n*2187+1374] = + s[1860];
gout[n*2187+1375] = + s[1861];
gout[n*2187+1376] = + s[1862];
gout[n*2187+1377] = + s[1863];
gout[n*2187+1378] = + s[1864];
gout[n*2187+1379] = + s[1865];
gout[n*2187+1380] = + s[1866];
gout[n*2187+1381] = + s[1867];
gout[n*2187+1382] = + s[1868];
gout[n*2187+1383] = + s[1869];
gout[n*2187+1384] = + s[1870];
gout[n*2187+1385] = + s[1871];
gout[n*2187+1386] = + s[1872];
gout[n*2187+1387] = + s[1873];
gout[n*2187+1388] = + s[1874];
gout[n*2187+1389] = + s[1875];
gout[n*2187+1390] = + s[1876];
gout[n*2187+1391] = + s[1877];
gout[n*2187+1392] = + s[1878];
gout[n*2187+1393] = + s[1879];
gout[n*2187+1394] = + s[1880];
gout[n*2187+1395] = + s[1881];
gout[n*2187+1396] = + s[1882];
gout[n*2187+1397] = + s[1883];
gout[n*2187+1398] = + s[1884];
gout[n*2187+1399] = + s[1885];
gout[n*2187+1400] = + s[1886];
gout[n*2187+1401] = + s[1887];
gout[n*2187+1402] = + s[1888];
gout[n*2187+1403] = + s[1889];
gout[n*2187+1404] = + s[1890];
gout[n*2187+1405] = + s[1891];
gout[n*2187+1406] = + s[1892];
gout[n*2187+1407] = + s[1893];
gout[n*2187+1408] = + s[1894];
gout[n*2187+1409] = + s[1895];
gout[n*2187+1410] = + s[1896];
gout[n*2187+1411] = + s[1897];
gout[n*2187+1412] = + s[1898];
gout[n*2187+1413] = + s[1899];
gout[n*2187+1414] = + s[1900];
gout[n*2187+1415] = + s[1901];
gout[n*2187+1416] = + s[1902];
gout[n*2187+1417] = + s[1903];
gout[n*2187+1418] = + s[1904];
gout[n*2187+1419] = + s[1905];
gout[n*2187+1420] = + s[1906];
gout[n*2187+1421] = + s[1907];
gout[n*2187+1422] = + s[1908];
gout[n*2187+1423] = + s[1909];
gout[n*2187+1424] = + s[1910];
gout[n*2187+1425] = + s[1911];
gout[n*2187+1426] = + s[1912];
gout[n*2187+1427] = + s[1913];
gout[n*2187+1428] = + s[1914];
gout[n*2187+1429] = + s[1915];
gout[n*2187+1430] = + s[1916];
gout[n*2187+1431] = + s[1917];
gout[n*2187+1432] = + s[1918];
gout[n*2187+1433] = + s[1919];
gout[n*2187+1434] = + s[1920];
gout[n*2187+1435] = + s[1921];
gout[n*2187+1436] = + s[1922];
gout[n*2187+1437] = + s[1923];
gout[n*2187+1438] = + s[1924];
gout[n*2187+1439] = + s[1925];
gout[n*2187+1440] = + s[1926];
gout[n*2187+1441] = + s[1927];
gout[n*2187+1442] = + s[1928];
gout[n*2187+1443] = + s[1929];
gout[n*2187+1444] = + s[1930];
gout[n*2187+1445] = + s[1931];
gout[n*2187+1446] = + s[1932];
gout[n*2187+1447] = + s[1933];
gout[n*2187+1448] = + s[1934];
gout[n*2187+1449] = + s[1935];
gout[n*2187+1450] = + s[1936];
gout[n*2187+1451] = + s[1937];
gout[n*2187+1452] = + s[1938];
gout[n*2187+1453] = + s[1939];
gout[n*2187+1454] = + s[1940];
gout[n*2187+1455] = + s[1941];
gout[n*2187+1456] = + s[1942];
gout[n*2187+1457] = + s[1943];
gout[n*2187+1458] = + s[486];
gout[n*2187+1459] = + s[487];
gout[n*2187+1460] = + s[488];
gout[n*2187+1461] = + s[489];
gout[n*2187+1462] = + s[490];
gout[n*2187+1463] = + s[491];
gout[n*2187+1464] = + s[492];
gout[n*2187+1465] = + s[493];
gout[n*2187+1466] = + s[494];
gout[n*2187+1467] = + s[495];
gout[n*2187+1468] = + s[496];
gout[n*2187+1469] = + s[497];
gout[n*2187+1470] = + s[498];
gout[n*2187+1471] = + s[499];
gout[n*2187+1472] = + s[500];
gout[n*2187+1473] = + s[501];
gout[n*2187+1474] = + s[502];
gout[n*2187+1475] = + s[503];
gout[n*2187+1476] = + s[504];
gout[n*2187+1477] = + s[505];
gout[n*2187+1478] = + s[506];
gout[n*2187+1479] = + s[507];
gout[n*2187+1480] = + s[508];
gout[n*2187+1481] = + s[509];
gout[n*2187+1482] = + s[510];
gout[n*2187+1483] = + s[511];
gout[n*2187+1484] = + s[512];
gout[n*2187+1485] = + s[513];
gout[n*2187+1486] = + s[514];
gout[n*2187+1487] = + s[515];
gout[n*2187+1488] = + s[516];
gout[n*2187+1489] = + s[517];
gout[n*2187+1490] = + s[518];
gout[n*2187+1491] = + s[519];
gout[n*2187+1492] = + s[520];
gout[n*2187+1493] = + s[521];
gout[n*2187+1494] = + s[522];
gout[n*2187+1495] = + s[523];
gout[n*2187+1496] = + s[524];
gout[n*2187+1497] = + s[525];
gout[n*2187+1498] = + s[526];
gout[n*2187+1499] = + s[527];
gout[n*2187+1500] = + s[528];
gout[n*2187+1501] = + s[529];
gout[n*2187+1502] = + s[530];
gout[n*2187+1503] = + s[531];
gout[n*2187+1504] = + s[532];
gout[n*2187+1505] = + s[533];
gout[n*2187+1506] = + s[534];
gout[n*2187+1507] = + s[535];
gout[n*2187+1508] = + s[536];
gout[n*2187+1509] = + s[537];
gout[n*2187+1510] = + s[538];
gout[n*2187+1511] = + s[539];
gout[n*2187+1512] = + s[540];
gout[n*2187+1513] = + s[541];
gout[n*2187+1514] = + s[542];
gout[n*2187+1515] = + s[543];
gout[n*2187+1516] = + s[544];
gout[n*2187+1517] = + s[545];
gout[n*2187+1518] = + s[546];
gout[n*2187+1519] = + s[547];
gout[n*2187+1520] = + s[548];
gout[n*2187+1521] = + s[549];
gout[n*2187+1522] = + s[550];
gout[n*2187+1523] = + s[551];
gout[n*2187+1524] = + s[552];
gout[n*2187+1525] = + s[553];
gout[n*2187+1526] = + s[554];
gout[n*2187+1527] = + s[555];
gout[n*2187+1528] = + s[556];
gout[n*2187+1529] = + s[557];
gout[n*2187+1530] = + s[558];
gout[n*2187+1531] = + s[559];
gout[n*2187+1532] = + s[560];
gout[n*2187+1533] = + s[561];
gout[n*2187+1534] = + s[562];
gout[n*2187+1535] = + s[563];
gout[n*2187+1536] = + s[564];
gout[n*2187+1537] = + s[565];
gout[n*2187+1538] = + s[566];
gout[n*2187+1539] = + s[567];
gout[n*2187+1540] = + s[568];
gout[n*2187+1541] = + s[569];
gout[n*2187+1542] = + s[570];
gout[n*2187+1543] = + s[571];
gout[n*2187+1544] = + s[572];
gout[n*2187+1545] = + s[573];
gout[n*2187+1546] = + s[574];
gout[n*2187+1547] = + s[575];
gout[n*2187+1548] = + s[576];
gout[n*2187+1549] = + s[577];
gout[n*2187+1550] = + s[578];
gout[n*2187+1551] = + s[579];
gout[n*2187+1552] = + s[580];
gout[n*2187+1553] = + s[581];
gout[n*2187+1554] = + s[582];
gout[n*2187+1555] = + s[583];
gout[n*2187+1556] = + s[584];
gout[n*2187+1557] = + s[585];
gout[n*2187+1558] = + s[586];
gout[n*2187+1559] = + s[587];
gout[n*2187+1560] = + s[588];
gout[n*2187+1561] = + s[589];
gout[n*2187+1562] = + s[590];
gout[n*2187+1563] = + s[591];
gout[n*2187+1564] = + s[592];
gout[n*2187+1565] = + s[593];
gout[n*2187+1566] = + s[594];
gout[n*2187+1567] = + s[595];
gout[n*2187+1568] = + s[596];
gout[n*2187+1569] = + s[597];
gout[n*2187+1570] = + s[598];
gout[n*2187+1571] = + s[599];
gout[n*2187+1572] = + s[600];
gout[n*2187+1573] = + s[601];
gout[n*2187+1574] = + s[602];
gout[n*2187+1575] = + s[603];
gout[n*2187+1576] = + s[604];
gout[n*2187+1577] = + s[605];
gout[n*2187+1578] = + s[606];
gout[n*2187+1579] = + s[607];
gout[n*2187+1580] = + s[608];
gout[n*2187+1581] = + s[609];
gout[n*2187+1582] = + s[610];
gout[n*2187+1583] = + s[611];
gout[n*2187+1584] = + s[612];
gout[n*2187+1585] = + s[613];
gout[n*2187+1586] = + s[614];
gout[n*2187+1587] = + s[615];
gout[n*2187+1588] = + s[616];
gout[n*2187+1589] = + s[617];
gout[n*2187+1590] = + s[618];
gout[n*2187+1591] = + s[619];
gout[n*2187+1592] = + s[620];
gout[n*2187+1593] = + s[621];
gout[n*2187+1594] = + s[622];
gout[n*2187+1595] = + s[623];
gout[n*2187+1596] = + s[624];
gout[n*2187+1597] = + s[625];
gout[n*2187+1598] = + s[626];
gout[n*2187+1599] = + s[627];
gout[n*2187+1600] = + s[628];
gout[n*2187+1601] = + s[629];
gout[n*2187+1602] = + s[630];
gout[n*2187+1603] = + s[631];
gout[n*2187+1604] = + s[632];
gout[n*2187+1605] = + s[633];
gout[n*2187+1606] = + s[634];
gout[n*2187+1607] = + s[635];
gout[n*2187+1608] = + s[636];
gout[n*2187+1609] = + s[637];
gout[n*2187+1610] = + s[638];
gout[n*2187+1611] = + s[639];
gout[n*2187+1612] = + s[640];
gout[n*2187+1613] = + s[641];
gout[n*2187+1614] = + s[642];
gout[n*2187+1615] = + s[643];
gout[n*2187+1616] = + s[644];
gout[n*2187+1617] = + s[645];
gout[n*2187+1618] = + s[646];
gout[n*2187+1619] = + s[647];
gout[n*2187+1620] = + s[648];
gout[n*2187+1621] = + s[649];
gout[n*2187+1622] = + s[650];
gout[n*2187+1623] = + s[651];
gout[n*2187+1624] = + s[652];
gout[n*2187+1625] = + s[653];
gout[n*2187+1626] = + s[654];
gout[n*2187+1627] = + s[655];
gout[n*2187+1628] = + s[656];
gout[n*2187+1629] = + s[657];
gout[n*2187+1630] = + s[658];
gout[n*2187+1631] = + s[659];
gout[n*2187+1632] = + s[660];
gout[n*2187+1633] = + s[661];
gout[n*2187+1634] = + s[662];
gout[n*2187+1635] = + s[663];
gout[n*2187+1636] = + s[664];
gout[n*2187+1637] = + s[665];
gout[n*2187+1638] = + s[666];
gout[n*2187+1639] = + s[667];
gout[n*2187+1640] = + s[668];
gout[n*2187+1641] = + s[669];
gout[n*2187+1642] = + s[670];
gout[n*2187+1643] = + s[671];
gout[n*2187+1644] = + s[672];
gout[n*2187+1645] = + s[673];
gout[n*2187+1646] = + s[674];
gout[n*2187+1647] = + s[675];
gout[n*2187+1648] = + s[676];
gout[n*2187+1649] = + s[677];
gout[n*2187+1650] = + s[678];
gout[n*2187+1651] = + s[679];
gout[n*2187+1652] = + s[680];
gout[n*2187+1653] = + s[681];
gout[n*2187+1654] = + s[682];
gout[n*2187+1655] = + s[683];
gout[n*2187+1656] = + s[684];
gout[n*2187+1657] = + s[685];
gout[n*2187+1658] = + s[686];
gout[n*2187+1659] = + s[687];
gout[n*2187+1660] = + s[688];
gout[n*2187+1661] = + s[689];
gout[n*2187+1662] = + s[690];
gout[n*2187+1663] = + s[691];
gout[n*2187+1664] = + s[692];
gout[n*2187+1665] = + s[693];
gout[n*2187+1666] = + s[694];
gout[n*2187+1667] = + s[695];
gout[n*2187+1668] = + s[696];
gout[n*2187+1669] = + s[697];
gout[n*2187+1670] = + s[698];
gout[n*2187+1671] = + s[699];
gout[n*2187+1672] = + s[700];
gout[n*2187+1673] = + s[701];
gout[n*2187+1674] = + s[702];
gout[n*2187+1675] = + s[703];
gout[n*2187+1676] = + s[704];
gout[n*2187+1677] = + s[705];
gout[n*2187+1678] = + s[706];
gout[n*2187+1679] = + s[707];
gout[n*2187+1680] = + s[708];
gout[n*2187+1681] = + s[709];
gout[n*2187+1682] = + s[710];
gout[n*2187+1683] = + s[711];
gout[n*2187+1684] = + s[712];
gout[n*2187+1685] = + s[713];
gout[n*2187+1686] = + s[714];
gout[n*2187+1687] = + s[715];
gout[n*2187+1688] = + s[716];
gout[n*2187+1689] = + s[717];
gout[n*2187+1690] = + s[718];
gout[n*2187+1691] = + s[719];
gout[n*2187+1692] = + s[720];
gout[n*2187+1693] = + s[721];
gout[n*2187+1694] = + s[722];
gout[n*2187+1695] = + s[723];
gout[n*2187+1696] = + s[724];
gout[n*2187+1697] = + s[725];
gout[n*2187+1698] = + s[726];
gout[n*2187+1699] = + s[727];
gout[n*2187+1700] = + s[728];
gout[n*2187+1701] = + s[1215];
gout[n*2187+1702] = + s[1216];
gout[n*2187+1703] = + s[1217];
gout[n*2187+1704] = + s[1218];
gout[n*2187+1705] = + s[1219];
gout[n*2187+1706] = + s[1220];
gout[n*2187+1707] = + s[1221];
gout[n*2187+1708] = + s[1222];
gout[n*2187+1709] = + s[1223];
gout[n*2187+1710] = + s[1224];
gout[n*2187+1711] = + s[1225];
gout[n*2187+1712] = + s[1226];
gout[n*2187+1713] = + s[1227];
gout[n*2187+1714] = + s[1228];
gout[n*2187+1715] = + s[1229];
gout[n*2187+1716] = + s[1230];
gout[n*2187+1717] = + s[1231];
gout[n*2187+1718] = + s[1232];
gout[n*2187+1719] = + s[1233];
gout[n*2187+1720] = + s[1234];
gout[n*2187+1721] = + s[1235];
gout[n*2187+1722] = + s[1236];
gout[n*2187+1723] = + s[1237];
gout[n*2187+1724] = + s[1238];
gout[n*2187+1725] = + s[1239];
gout[n*2187+1726] = + s[1240];
gout[n*2187+1727] = + s[1241];
gout[n*2187+1728] = + s[1242];
gout[n*2187+1729] = + s[1243];
gout[n*2187+1730] = + s[1244];
gout[n*2187+1731] = + s[1245];
gout[n*2187+1732] = + s[1246];
gout[n*2187+1733] = + s[1247];
gout[n*2187+1734] = + s[1248];
gout[n*2187+1735] = + s[1249];
gout[n*2187+1736] = + s[1250];
gout[n*2187+1737] = + s[1251];
gout[n*2187+1738] = + s[1252];
gout[n*2187+1739] = + s[1253];
gout[n*2187+1740] = + s[1254];
gout[n*2187+1741] = + s[1255];
gout[n*2187+1742] = + s[1256];
gout[n*2187+1743] = + s[1257];
gout[n*2187+1744] = + s[1258];
gout[n*2187+1745] = + s[1259];
gout[n*2187+1746] = + s[1260];
gout[n*2187+1747] = + s[1261];
gout[n*2187+1748] = + s[1262];
gout[n*2187+1749] = + s[1263];
gout[n*2187+1750] = + s[1264];
gout[n*2187+1751] = + s[1265];
gout[n*2187+1752] = + s[1266];
gout[n*2187+1753] = + s[1267];
gout[n*2187+1754] = + s[1268];
gout[n*2187+1755] = + s[1269];
gout[n*2187+1756] = + s[1270];
gout[n*2187+1757] = + s[1271];
gout[n*2187+1758] = + s[1272];
gout[n*2187+1759] = + s[1273];
gout[n*2187+1760] = + s[1274];
gout[n*2187+1761] = + s[1275];
gout[n*2187+1762] = + s[1276];
gout[n*2187+1763] = + s[1277];
gout[n*2187+1764] = + s[1278];
gout[n*2187+1765] = + s[1279];
gout[n*2187+1766] = + s[1280];
gout[n*2187+1767] = + s[1281];
gout[n*2187+1768] = + s[1282];
gout[n*2187+1769] = + s[1283];
gout[n*2187+1770] = + s[1284];
gout[n*2187+1771] = + s[1285];
gout[n*2187+1772] = + s[1286];
gout[n*2187+1773] = + s[1287];
gout[n*2187+1774] = + s[1288];
gout[n*2187+1775] = + s[1289];
gout[n*2187+1776] = + s[1290];
gout[n*2187+1777] = + s[1291];
gout[n*2187+1778] = + s[1292];
gout[n*2187+1779] = + s[1293];
gout[n*2187+1780] = + s[1294];
gout[n*2187+1781] = + s[1295];
gout[n*2187+1782] = + s[1296];
gout[n*2187+1783] = + s[1297];
gout[n*2187+1784] = + s[1298];
gout[n*2187+1785] = + s[1299];
gout[n*2187+1786] = + s[1300];
gout[n*2187+1787] = + s[1301];
gout[n*2187+1788] = + s[1302];
gout[n*2187+1789] = + s[1303];
gout[n*2187+1790] = + s[1304];
gout[n*2187+1791] = + s[1305];
gout[n*2187+1792] = + s[1306];
gout[n*2187+1793] = + s[1307];
gout[n*2187+1794] = + s[1308];
gout[n*2187+1795] = + s[1309];
gout[n*2187+1796] = + s[1310];
gout[n*2187+1797] = + s[1311];
gout[n*2187+1798] = + s[1312];
gout[n*2187+1799] = + s[1313];
gout[n*2187+1800] = + s[1314];
gout[n*2187+1801] = + s[1315];
gout[n*2187+1802] = + s[1316];
gout[n*2187+1803] = + s[1317];
gout[n*2187+1804] = + s[1318];
gout[n*2187+1805] = + s[1319];
gout[n*2187+1806] = + s[1320];
gout[n*2187+1807] = + s[1321];
gout[n*2187+1808] = + s[1322];
gout[n*2187+1809] = + s[1323];
gout[n*2187+1810] = + s[1324];
gout[n*2187+1811] = + s[1325];
gout[n*2187+1812] = + s[1326];
gout[n*2187+1813] = + s[1327];
gout[n*2187+1814] = + s[1328];
gout[n*2187+1815] = + s[1329];
gout[n*2187+1816] = + s[1330];
gout[n*2187+1817] = + s[1331];
gout[n*2187+1818] = + s[1332];
gout[n*2187+1819] = + s[1333];
gout[n*2187+1820] = + s[1334];
gout[n*2187+1821] = + s[1335];
gout[n*2187+1822] = + s[1336];
gout[n*2187+1823] = + s[1337];
gout[n*2187+1824] = + s[1338];
gout[n*2187+1825] = + s[1339];
gout[n*2187+1826] = + s[1340];
gout[n*2187+1827] = + s[1341];
gout[n*2187+1828] = + s[1342];
gout[n*2187+1829] = + s[1343];
gout[n*2187+1830] = + s[1344];
gout[n*2187+1831] = + s[1345];
gout[n*2187+1832] = + s[1346];
gout[n*2187+1833] = + s[1347];
gout[n*2187+1834] = + s[1348];
gout[n*2187+1835] = + s[1349];
gout[n*2187+1836] = + s[1350];
gout[n*2187+1837] = + s[1351];
gout[n*2187+1838] = + s[1352];
gout[n*2187+1839] = + s[1353];
gout[n*2187+1840] = + s[1354];
gout[n*2187+1841] = + s[1355];
gout[n*2187+1842] = + s[1356];
gout[n*2187+1843] = + s[1357];
gout[n*2187+1844] = + s[1358];
gout[n*2187+1845] = + s[1359];
gout[n*2187+1846] = + s[1360];
gout[n*2187+1847] = + s[1361];
gout[n*2187+1848] = + s[1362];
gout[n*2187+1849] = + s[1363];
gout[n*2187+1850] = + s[1364];
gout[n*2187+1851] = + s[1365];
gout[n*2187+1852] = + s[1366];
gout[n*2187+1853] = + s[1367];
gout[n*2187+1854] = + s[1368];
gout[n*2187+1855] = + s[1369];
gout[n*2187+1856] = + s[1370];
gout[n*2187+1857] = + s[1371];
gout[n*2187+1858] = + s[1372];
gout[n*2187+1859] = + s[1373];
gout[n*2187+1860] = + s[1374];
gout[n*2187+1861] = + s[1375];
gout[n*2187+1862] = + s[1376];
gout[n*2187+1863] = + s[1377];
gout[n*2187+1864] = + s[1378];
gout[n*2187+1865] = + s[1379];
gout[n*2187+1866] = + s[1380];
gout[n*2187+1867] = + s[1381];
gout[n*2187+1868] = + s[1382];
gout[n*2187+1869] = + s[1383];
gout[n*2187+1870] = + s[1384];
gout[n*2187+1871] = + s[1385];
gout[n*2187+1872] = + s[1386];
gout[n*2187+1873] = + s[1387];
gout[n*2187+1874] = + s[1388];
gout[n*2187+1875] = + s[1389];
gout[n*2187+1876] = + s[1390];
gout[n*2187+1877] = + s[1391];
gout[n*2187+1878] = + s[1392];
gout[n*2187+1879] = + s[1393];
gout[n*2187+1880] = + s[1394];
gout[n*2187+1881] = + s[1395];
gout[n*2187+1882] = + s[1396];
gout[n*2187+1883] = + s[1397];
gout[n*2187+1884] = + s[1398];
gout[n*2187+1885] = + s[1399];
gout[n*2187+1886] = + s[1400];
gout[n*2187+1887] = + s[1401];
gout[n*2187+1888] = + s[1402];
gout[n*2187+1889] = + s[1403];
gout[n*2187+1890] = + s[1404];
gout[n*2187+1891] = + s[1405];
gout[n*2187+1892] = + s[1406];
gout[n*2187+1893] = + s[1407];
gout[n*2187+1894] = + s[1408];
gout[n*2187+1895] = + s[1409];
gout[n*2187+1896] = + s[1410];
gout[n*2187+1897] = + s[1411];
gout[n*2187+1898] = + s[1412];
gout[n*2187+1899] = + s[1413];
gout[n*2187+1900] = + s[1414];
gout[n*2187+1901] = + s[1415];
gout[n*2187+1902] = + s[1416];
gout[n*2187+1903] = + s[1417];
gout[n*2187+1904] = + s[1418];
gout[n*2187+1905] = + s[1419];
gout[n*2187+1906] = + s[1420];
gout[n*2187+1907] = + s[1421];
gout[n*2187+1908] = + s[1422];
gout[n*2187+1909] = + s[1423];
gout[n*2187+1910] = + s[1424];
gout[n*2187+1911] = + s[1425];
gout[n*2187+1912] = + s[1426];
gout[n*2187+1913] = + s[1427];
gout[n*2187+1914] = + s[1428];
gout[n*2187+1915] = + s[1429];
gout[n*2187+1916] = + s[1430];
gout[n*2187+1917] = + s[1431];
gout[n*2187+1918] = + s[1432];
gout[n*2187+1919] = + s[1433];
gout[n*2187+1920] = + s[1434];
gout[n*2187+1921] = + s[1435];
gout[n*2187+1922] = + s[1436];
gout[n*2187+1923] = + s[1437];
gout[n*2187+1924] = + s[1438];
gout[n*2187+1925] = + s[1439];
gout[n*2187+1926] = + s[1440];
gout[n*2187+1927] = + s[1441];
gout[n*2187+1928] = + s[1442];
gout[n*2187+1929] = + s[1443];
gout[n*2187+1930] = + s[1444];
gout[n*2187+1931] = + s[1445];
gout[n*2187+1932] = + s[1446];
gout[n*2187+1933] = + s[1447];
gout[n*2187+1934] = + s[1448];
gout[n*2187+1935] = + s[1449];
gout[n*2187+1936] = + s[1450];
gout[n*2187+1937] = + s[1451];
gout[n*2187+1938] = + s[1452];
gout[n*2187+1939] = + s[1453];
gout[n*2187+1940] = + s[1454];
gout[n*2187+1941] = + s[1455];
gout[n*2187+1942] = + s[1456];
gout[n*2187+1943] = + s[1457];
gout[n*2187+1944] = + s[1944];
gout[n*2187+1945] = + s[1945];
gout[n*2187+1946] = + s[1946];
gout[n*2187+1947] = + s[1947];
gout[n*2187+1948] = + s[1948];
gout[n*2187+1949] = + s[1949];
gout[n*2187+1950] = + s[1950];
gout[n*2187+1951] = + s[1951];
gout[n*2187+1952] = + s[1952];
gout[n*2187+1953] = + s[1953];
gout[n*2187+1954] = + s[1954];
gout[n*2187+1955] = + s[1955];
gout[n*2187+1956] = + s[1956];
gout[n*2187+1957] = + s[1957];
gout[n*2187+1958] = + s[1958];
gout[n*2187+1959] = + s[1959];
gout[n*2187+1960] = + s[1960];
gout[n*2187+1961] = + s[1961];
gout[n*2187+1962] = + s[1962];
gout[n*2187+1963] = + s[1963];
gout[n*2187+1964] = + s[1964];
gout[n*2187+1965] = + s[1965];
gout[n*2187+1966] = + s[1966];
gout[n*2187+1967] = + s[1967];
gout[n*2187+1968] = + s[1968];
gout[n*2187+1969] = + s[1969];
gout[n*2187+1970] = + s[1970];
gout[n*2187+1971] = + s[1971];
gout[n*2187+1972] = + s[1972];
gout[n*2187+1973] = + s[1973];
gout[n*2187+1974] = + s[1974];
gout[n*2187+1975] = + s[1975];
gout[n*2187+1976] = + s[1976];
gout[n*2187+1977] = + s[1977];
gout[n*2187+1978] = + s[1978];
gout[n*2187+1979] = + s[1979];
gout[n*2187+1980] = + s[1980];
gout[n*2187+1981] = + s[1981];
gout[n*2187+1982] = + s[1982];
gout[n*2187+1983] = + s[1983];
gout[n*2187+1984] = + s[1984];
gout[n*2187+1985] = + s[1985];
gout[n*2187+1986] = + s[1986];
gout[n*2187+1987] = + s[1987];
gout[n*2187+1988] = + s[1988];
gout[n*2187+1989] = + s[1989];
gout[n*2187+1990] = + s[1990];
gout[n*2187+1991] = + s[1991];
gout[n*2187+1992] = + s[1992];
gout[n*2187+1993] = + s[1993];
gout[n*2187+1994] = + s[1994];
gout[n*2187+1995] = + s[1995];
gout[n*2187+1996] = + s[1996];
gout[n*2187+1997] = + s[1997];
gout[n*2187+1998] = + s[1998];
gout[n*2187+1999] = + s[1999];
gout[n*2187+2000] = + s[2000];
gout[n*2187+2001] = + s[2001];
gout[n*2187+2002] = + s[2002];
gout[n*2187+2003] = + s[2003];
gout[n*2187+2004] = + s[2004];
gout[n*2187+2005] = + s[2005];
gout[n*2187+2006] = + s[2006];
gout[n*2187+2007] = + s[2007];
gout[n*2187+2008] = + s[2008];
gout[n*2187+2009] = + s[2009];
gout[n*2187+2010] = + s[2010];
gout[n*2187+2011] = + s[2011];
gout[n*2187+2012] = + s[2012];
gout[n*2187+2013] = + s[2013];
gout[n*2187+2014] = + s[2014];
gout[n*2187+2015] = + s[2015];
gout[n*2187+2016] = + s[2016];
gout[n*2187+2017] = + s[2017];
gout[n*2187+2018] = + s[2018];
gout[n*2187+2019] = + s[2019];
gout[n*2187+2020] = + s[2020];
gout[n*2187+2021] = + s[2021];
gout[n*2187+2022] = + s[2022];
gout[n*2187+2023] = + s[2023];
gout[n*2187+2024] = + s[2024];
gout[n*2187+2025] = + s[2025];
gout[n*2187+2026] = + s[2026];
gout[n*2187+2027] = + s[2027];
gout[n*2187+2028] = + s[2028];
gout[n*2187+2029] = + s[2029];
gout[n*2187+2030] = + s[2030];
gout[n*2187+2031] = + s[2031];
gout[n*2187+2032] = + s[2032];
gout[n*2187+2033] = + s[2033];
gout[n*2187+2034] = + s[2034];
gout[n*2187+2035] = + s[2035];
gout[n*2187+2036] = + s[2036];
gout[n*2187+2037] = + s[2037];
gout[n*2187+2038] = + s[2038];
gout[n*2187+2039] = + s[2039];
gout[n*2187+2040] = + s[2040];
gout[n*2187+2041] = + s[2041];
gout[n*2187+2042] = + s[2042];
gout[n*2187+2043] = + s[2043];
gout[n*2187+2044] = + s[2044];
gout[n*2187+2045] = + s[2045];
gout[n*2187+2046] = + s[2046];
gout[n*2187+2047] = + s[2047];
gout[n*2187+2048] = + s[2048];
gout[n*2187+2049] = + s[2049];
gout[n*2187+2050] = + s[2050];
gout[n*2187+2051] = + s[2051];
gout[n*2187+2052] = + s[2052];
gout[n*2187+2053] = + s[2053];
gout[n*2187+2054] = + s[2054];
gout[n*2187+2055] = + s[2055];
gout[n*2187+2056] = + s[2056];
gout[n*2187+2057] = + s[2057];
gout[n*2187+2058] = + s[2058];
gout[n*2187+2059] = + s[2059];
gout[n*2187+2060] = + s[2060];
gout[n*2187+2061] = + s[2061];
gout[n*2187+2062] = + s[2062];
gout[n*2187+2063] = + s[2063];
gout[n*2187+2064] = + s[2064];
gout[n*2187+2065] = + s[2065];
gout[n*2187+2066] = + s[2066];
gout[n*2187+2067] = + s[2067];
gout[n*2187+2068] = + s[2068];
gout[n*2187+2069] = + s[2069];
gout[n*2187+2070] = + s[2070];
gout[n*2187+2071] = + s[2071];
gout[n*2187+2072] = + s[2072];
gout[n*2187+2073] = + s[2073];
gout[n*2187+2074] = + s[2074];
gout[n*2187+2075] = + s[2075];
gout[n*2187+2076] = + s[2076];
gout[n*2187+2077] = + s[2077];
gout[n*2187+2078] = + s[2078];
gout[n*2187+2079] = + s[2079];
gout[n*2187+2080] = + s[2080];
gout[n*2187+2081] = + s[2081];
gout[n*2187+2082] = + s[2082];
gout[n*2187+2083] = + s[2083];
gout[n*2187+2084] = + s[2084];
gout[n*2187+2085] = + s[2085];
gout[n*2187+2086] = + s[2086];
gout[n*2187+2087] = + s[2087];
gout[n*2187+2088] = + s[2088];
gout[n*2187+2089] = + s[2089];
gout[n*2187+2090] = + s[2090];
gout[n*2187+2091] = + s[2091];
gout[n*2187+2092] = + s[2092];
gout[n*2187+2093] = + s[2093];
gout[n*2187+2094] = + s[2094];
gout[n*2187+2095] = + s[2095];
gout[n*2187+2096] = + s[2096];
gout[n*2187+2097] = + s[2097];
gout[n*2187+2098] = + s[2098];
gout[n*2187+2099] = + s[2099];
gout[n*2187+2100] = + s[2100];
gout[n*2187+2101] = + s[2101];
gout[n*2187+2102] = + s[2102];
gout[n*2187+2103] = + s[2103];
gout[n*2187+2104] = + s[2104];
gout[n*2187+2105] = + s[2105];
gout[n*2187+2106] = + s[2106];
gout[n*2187+2107] = + s[2107];
gout[n*2187+2108] = + s[2108];
gout[n*2187+2109] = + s[2109];
gout[n*2187+2110] = + s[2110];
gout[n*2187+2111] = + s[2111];
gout[n*2187+2112] = + s[2112];
gout[n*2187+2113] = + s[2113];
gout[n*2187+2114] = + s[2114];
gout[n*2187+2115] = + s[2115];
gout[n*2187+2116] = + s[2116];
gout[n*2187+2117] = + s[2117];
gout[n*2187+2118] = + s[2118];
gout[n*2187+2119] = + s[2119];
gout[n*2187+2120] = + s[2120];
gout[n*2187+2121] = + s[2121];
gout[n*2187+2122] = + s[2122];
gout[n*2187+2123] = + s[2123];
gout[n*2187+2124] = + s[2124];
gout[n*2187+2125] = + s[2125];
gout[n*2187+2126] = + s[2126];
gout[n*2187+2127] = + s[2127];
gout[n*2187+2128] = + s[2128];
gout[n*2187+2129] = + s[2129];
gout[n*2187+2130] = + s[2130];
gout[n*2187+2131] = + s[2131];
gout[n*2187+2132] = + s[2132];
gout[n*2187+2133] = + s[2133];
gout[n*2187+2134] = + s[2134];
gout[n*2187+2135] = + s[2135];
gout[n*2187+2136] = + s[2136];
gout[n*2187+2137] = + s[2137];
gout[n*2187+2138] = + s[2138];
gout[n*2187+2139] = + s[2139];
gout[n*2187+2140] = + s[2140];
gout[n*2187+2141] = + s[2141];
gout[n*2187+2142] = + s[2142];
gout[n*2187+2143] = + s[2143];
gout[n*2187+2144] = + s[2144];
gout[n*2187+2145] = + s[2145];
gout[n*2187+2146] = + s[2146];
gout[n*2187+2147] = + s[2147];
gout[n*2187+2148] = + s[2148];
gout[n*2187+2149] = + s[2149];
gout[n*2187+2150] = + s[2150];
gout[n*2187+2151] = + s[2151];
gout[n*2187+2152] = + s[2152];
gout[n*2187+2153] = + s[2153];
gout[n*2187+2154] = + s[2154];
gout[n*2187+2155] = + s[2155];
gout[n*2187+2156] = + s[2156];
gout[n*2187+2157] = + s[2157];
gout[n*2187+2158] = + s[2158];
gout[n*2187+2159] = + s[2159];
gout[n*2187+2160] = + s[2160];
gout[n*2187+2161] = + s[2161];
gout[n*2187+2162] = + s[2162];
gout[n*2187+2163] = + s[2163];
gout[n*2187+2164] = + s[2164];
gout[n*2187+2165] = + s[2165];
gout[n*2187+2166] = + s[2166];
gout[n*2187+2167] = + s[2167];
gout[n*2187+2168] = + s[2168];
gout[n*2187+2169] = + s[2169];
gout[n*2187+2170] = + s[2170];
gout[n*2187+2171] = + s[2171];
gout[n*2187+2172] = + s[2172];
gout[n*2187+2173] = + s[2173];
gout[n*2187+2174] = + s[2174];
gout[n*2187+2175] = + s[2175];
gout[n*2187+2176] = + s[2176];
gout[n*2187+2177] = + s[2177];
gout[n*2187+2178] = + s[2178];
gout[n*2187+2179] = + s[2179];
gout[n*2187+2180] = + s[2180];
gout[n*2187+2181] = + s[2181];
gout[n*2187+2182] = + s[2182];
gout[n*2187+2183] = + s[2183];
gout[n*2187+2184] = + s[2184];
gout[n*2187+2185] = + s[2185];
gout[n*2187+2186] = + s[2186];
} else {
gout[n*2187+0] += + s[0];
gout[n*2187+1] += + s[1];
gout[n*2187+2] += + s[2];
gout[n*2187+3] += + s[3];
gout[n*2187+4] += + s[4];
gout[n*2187+5] += + s[5];
gout[n*2187+6] += + s[6];
gout[n*2187+7] += + s[7];
gout[n*2187+8] += + s[8];
gout[n*2187+9] += + s[9];
gout[n*2187+10] += + s[10];
gout[n*2187+11] += + s[11];
gout[n*2187+12] += + s[12];
gout[n*2187+13] += + s[13];
gout[n*2187+14] += + s[14];
gout[n*2187+15] += + s[15];
gout[n*2187+16] += + s[16];
gout[n*2187+17] += + s[17];
gout[n*2187+18] += + s[18];
gout[n*2187+19] += + s[19];
gout[n*2187+20] += + s[20];
gout[n*2187+21] += + s[21];
gout[n*2187+22] += + s[22];
gout[n*2187+23] += + s[23];
gout[n*2187+24] += + s[24];
gout[n*2187+25] += + s[25];
gout[n*2187+26] += + s[26];
gout[n*2187+27] += + s[27];
gout[n*2187+28] += + s[28];
gout[n*2187+29] += + s[29];
gout[n*2187+30] += + s[30];
gout[n*2187+31] += + s[31];
gout[n*2187+32] += + s[32];
gout[n*2187+33] += + s[33];
gout[n*2187+34] += + s[34];
gout[n*2187+35] += + s[35];
gout[n*2187+36] += + s[36];
gout[n*2187+37] += + s[37];
gout[n*2187+38] += + s[38];
gout[n*2187+39] += + s[39];
gout[n*2187+40] += + s[40];
gout[n*2187+41] += + s[41];
gout[n*2187+42] += + s[42];
gout[n*2187+43] += + s[43];
gout[n*2187+44] += + s[44];
gout[n*2187+45] += + s[45];
gout[n*2187+46] += + s[46];
gout[n*2187+47] += + s[47];
gout[n*2187+48] += + s[48];
gout[n*2187+49] += + s[49];
gout[n*2187+50] += + s[50];
gout[n*2187+51] += + s[51];
gout[n*2187+52] += + s[52];
gout[n*2187+53] += + s[53];
gout[n*2187+54] += + s[54];
gout[n*2187+55] += + s[55];
gout[n*2187+56] += + s[56];
gout[n*2187+57] += + s[57];
gout[n*2187+58] += + s[58];
gout[n*2187+59] += + s[59];
gout[n*2187+60] += + s[60];
gout[n*2187+61] += + s[61];
gout[n*2187+62] += + s[62];
gout[n*2187+63] += + s[63];
gout[n*2187+64] += + s[64];
gout[n*2187+65] += + s[65];
gout[n*2187+66] += + s[66];
gout[n*2187+67] += + s[67];
gout[n*2187+68] += + s[68];
gout[n*2187+69] += + s[69];
gout[n*2187+70] += + s[70];
gout[n*2187+71] += + s[71];
gout[n*2187+72] += + s[72];
gout[n*2187+73] += + s[73];
gout[n*2187+74] += + s[74];
gout[n*2187+75] += + s[75];
gout[n*2187+76] += + s[76];
gout[n*2187+77] += + s[77];
gout[n*2187+78] += + s[78];
gout[n*2187+79] += + s[79];
gout[n*2187+80] += + s[80];
gout[n*2187+81] += + s[81];
gout[n*2187+82] += + s[82];
gout[n*2187+83] += + s[83];
gout[n*2187+84] += + s[84];
gout[n*2187+85] += + s[85];
gout[n*2187+86] += + s[86];
gout[n*2187+87] += + s[87];
gout[n*2187+88] += + s[88];
gout[n*2187+89] += + s[89];
gout[n*2187+90] += + s[90];
gout[n*2187+91] += + s[91];
gout[n*2187+92] += + s[92];
gout[n*2187+93] += + s[93];
gout[n*2187+94] += + s[94];
gout[n*2187+95] += + s[95];
gout[n*2187+96] += + s[96];
gout[n*2187+97] += + s[97];
gout[n*2187+98] += + s[98];
gout[n*2187+99] += + s[99];
gout[n*2187+100] += + s[100];
gout[n*2187+101] += + s[101];
gout[n*2187+102] += + s[102];
gout[n*2187+103] += + s[103];
gout[n*2187+104] += + s[104];
gout[n*2187+105] += + s[105];
gout[n*2187+106] += + s[106];
gout[n*2187+107] += + s[107];
gout[n*2187+108] += + s[108];
gout[n*2187+109] += + s[109];
gout[n*2187+110] += + s[110];
gout[n*2187+111] += + s[111];
gout[n*2187+112] += + s[112];
gout[n*2187+113] += + s[113];
gout[n*2187+114] += + s[114];
gout[n*2187+115] += + s[115];
gout[n*2187+116] += + s[116];
gout[n*2187+117] += + s[117];
gout[n*2187+118] += + s[118];
gout[n*2187+119] += + s[119];
gout[n*2187+120] += + s[120];
gout[n*2187+121] += + s[121];
gout[n*2187+122] += + s[122];
gout[n*2187+123] += + s[123];
gout[n*2187+124] += + s[124];
gout[n*2187+125] += + s[125];
gout[n*2187+126] += + s[126];
gout[n*2187+127] += + s[127];
gout[n*2187+128] += + s[128];
gout[n*2187+129] += + s[129];
gout[n*2187+130] += + s[130];
gout[n*2187+131] += + s[131];
gout[n*2187+132] += + s[132];
gout[n*2187+133] += + s[133];
gout[n*2187+134] += + s[134];
gout[n*2187+135] += + s[135];
gout[n*2187+136] += + s[136];
gout[n*2187+137] += + s[137];
gout[n*2187+138] += + s[138];
gout[n*2187+139] += + s[139];
gout[n*2187+140] += + s[140];
gout[n*2187+141] += + s[141];
gout[n*2187+142] += + s[142];
gout[n*2187+143] += + s[143];
gout[n*2187+144] += + s[144];
gout[n*2187+145] += + s[145];
gout[n*2187+146] += + s[146];
gout[n*2187+147] += + s[147];
gout[n*2187+148] += + s[148];
gout[n*2187+149] += + s[149];
gout[n*2187+150] += + s[150];
gout[n*2187+151] += + s[151];
gout[n*2187+152] += + s[152];
gout[n*2187+153] += + s[153];
gout[n*2187+154] += + s[154];
gout[n*2187+155] += + s[155];
gout[n*2187+156] += + s[156];
gout[n*2187+157] += + s[157];
gout[n*2187+158] += + s[158];
gout[n*2187+159] += + s[159];
gout[n*2187+160] += + s[160];
gout[n*2187+161] += + s[161];
gout[n*2187+162] += + s[162];
gout[n*2187+163] += + s[163];
gout[n*2187+164] += + s[164];
gout[n*2187+165] += + s[165];
gout[n*2187+166] += + s[166];
gout[n*2187+167] += + s[167];
gout[n*2187+168] += + s[168];
gout[n*2187+169] += + s[169];
gout[n*2187+170] += + s[170];
gout[n*2187+171] += + s[171];
gout[n*2187+172] += + s[172];
gout[n*2187+173] += + s[173];
gout[n*2187+174] += + s[174];
gout[n*2187+175] += + s[175];
gout[n*2187+176] += + s[176];
gout[n*2187+177] += + s[177];
gout[n*2187+178] += + s[178];
gout[n*2187+179] += + s[179];
gout[n*2187+180] += + s[180];
gout[n*2187+181] += + s[181];
gout[n*2187+182] += + s[182];
gout[n*2187+183] += + s[183];
gout[n*2187+184] += + s[184];
gout[n*2187+185] += + s[185];
gout[n*2187+186] += + s[186];
gout[n*2187+187] += + s[187];
gout[n*2187+188] += + s[188];
gout[n*2187+189] += + s[189];
gout[n*2187+190] += + s[190];
gout[n*2187+191] += + s[191];
gout[n*2187+192] += + s[192];
gout[n*2187+193] += + s[193];
gout[n*2187+194] += + s[194];
gout[n*2187+195] += + s[195];
gout[n*2187+196] += + s[196];
gout[n*2187+197] += + s[197];
gout[n*2187+198] += + s[198];
gout[n*2187+199] += + s[199];
gout[n*2187+200] += + s[200];
gout[n*2187+201] += + s[201];
gout[n*2187+202] += + s[202];
gout[n*2187+203] += + s[203];
gout[n*2187+204] += + s[204];
gout[n*2187+205] += + s[205];
gout[n*2187+206] += + s[206];
gout[n*2187+207] += + s[207];
gout[n*2187+208] += + s[208];
gout[n*2187+209] += + s[209];
gout[n*2187+210] += + s[210];
gout[n*2187+211] += + s[211];
gout[n*2187+212] += + s[212];
gout[n*2187+213] += + s[213];
gout[n*2187+214] += + s[214];
gout[n*2187+215] += + s[215];
gout[n*2187+216] += + s[216];
gout[n*2187+217] += + s[217];
gout[n*2187+218] += + s[218];
gout[n*2187+219] += + s[219];
gout[n*2187+220] += + s[220];
gout[n*2187+221] += + s[221];
gout[n*2187+222] += + s[222];
gout[n*2187+223] += + s[223];
gout[n*2187+224] += + s[224];
gout[n*2187+225] += + s[225];
gout[n*2187+226] += + s[226];
gout[n*2187+227] += + s[227];
gout[n*2187+228] += + s[228];
gout[n*2187+229] += + s[229];
gout[n*2187+230] += + s[230];
gout[n*2187+231] += + s[231];
gout[n*2187+232] += + s[232];
gout[n*2187+233] += + s[233];
gout[n*2187+234] += + s[234];
gout[n*2187+235] += + s[235];
gout[n*2187+236] += + s[236];
gout[n*2187+237] += + s[237];
gout[n*2187+238] += + s[238];
gout[n*2187+239] += + s[239];
gout[n*2187+240] += + s[240];
gout[n*2187+241] += + s[241];
gout[n*2187+242] += + s[242];
gout[n*2187+243] += + s[729];
gout[n*2187+244] += + s[730];
gout[n*2187+245] += + s[731];
gout[n*2187+246] += + s[732];
gout[n*2187+247] += + s[733];
gout[n*2187+248] += + s[734];
gout[n*2187+249] += + s[735];
gout[n*2187+250] += + s[736];
gout[n*2187+251] += + s[737];
gout[n*2187+252] += + s[738];
gout[n*2187+253] += + s[739];
gout[n*2187+254] += + s[740];
gout[n*2187+255] += + s[741];
gout[n*2187+256] += + s[742];
gout[n*2187+257] += + s[743];
gout[n*2187+258] += + s[744];
gout[n*2187+259] += + s[745];
gout[n*2187+260] += + s[746];
gout[n*2187+261] += + s[747];
gout[n*2187+262] += + s[748];
gout[n*2187+263] += + s[749];
gout[n*2187+264] += + s[750];
gout[n*2187+265] += + s[751];
gout[n*2187+266] += + s[752];
gout[n*2187+267] += + s[753];
gout[n*2187+268] += + s[754];
gout[n*2187+269] += + s[755];
gout[n*2187+270] += + s[756];
gout[n*2187+271] += + s[757];
gout[n*2187+272] += + s[758];
gout[n*2187+273] += + s[759];
gout[n*2187+274] += + s[760];
gout[n*2187+275] += + s[761];
gout[n*2187+276] += + s[762];
gout[n*2187+277] += + s[763];
gout[n*2187+278] += + s[764];
gout[n*2187+279] += + s[765];
gout[n*2187+280] += + s[766];
gout[n*2187+281] += + s[767];
gout[n*2187+282] += + s[768];
gout[n*2187+283] += + s[769];
gout[n*2187+284] += + s[770];
gout[n*2187+285] += + s[771];
gout[n*2187+286] += + s[772];
gout[n*2187+287] += + s[773];
gout[n*2187+288] += + s[774];
gout[n*2187+289] += + s[775];
gout[n*2187+290] += + s[776];
gout[n*2187+291] += + s[777];
gout[n*2187+292] += + s[778];
gout[n*2187+293] += + s[779];
gout[n*2187+294] += + s[780];
gout[n*2187+295] += + s[781];
gout[n*2187+296] += + s[782];
gout[n*2187+297] += + s[783];
gout[n*2187+298] += + s[784];
gout[n*2187+299] += + s[785];
gout[n*2187+300] += + s[786];
gout[n*2187+301] += + s[787];
gout[n*2187+302] += + s[788];
gout[n*2187+303] += + s[789];
gout[n*2187+304] += + s[790];
gout[n*2187+305] += + s[791];
gout[n*2187+306] += + s[792];
gout[n*2187+307] += + s[793];
gout[n*2187+308] += + s[794];
gout[n*2187+309] += + s[795];
gout[n*2187+310] += + s[796];
gout[n*2187+311] += + s[797];
gout[n*2187+312] += + s[798];
gout[n*2187+313] += + s[799];
gout[n*2187+314] += + s[800];
gout[n*2187+315] += + s[801];
gout[n*2187+316] += + s[802];
gout[n*2187+317] += + s[803];
gout[n*2187+318] += + s[804];
gout[n*2187+319] += + s[805];
gout[n*2187+320] += + s[806];
gout[n*2187+321] += + s[807];
gout[n*2187+322] += + s[808];
gout[n*2187+323] += + s[809];
gout[n*2187+324] += + s[810];
gout[n*2187+325] += + s[811];
gout[n*2187+326] += + s[812];
gout[n*2187+327] += + s[813];
gout[n*2187+328] += + s[814];
gout[n*2187+329] += + s[815];
gout[n*2187+330] += + s[816];
gout[n*2187+331] += + s[817];
gout[n*2187+332] += + s[818];
gout[n*2187+333] += + s[819];
gout[n*2187+334] += + s[820];
gout[n*2187+335] += + s[821];
gout[n*2187+336] += + s[822];
gout[n*2187+337] += + s[823];
gout[n*2187+338] += + s[824];
gout[n*2187+339] += + s[825];
gout[n*2187+340] += + s[826];
gout[n*2187+341] += + s[827];
gout[n*2187+342] += + s[828];
gout[n*2187+343] += + s[829];
gout[n*2187+344] += + s[830];
gout[n*2187+345] += + s[831];
gout[n*2187+346] += + s[832];
gout[n*2187+347] += + s[833];
gout[n*2187+348] += + s[834];
gout[n*2187+349] += + s[835];
gout[n*2187+350] += + s[836];
gout[n*2187+351] += + s[837];
gout[n*2187+352] += + s[838];
gout[n*2187+353] += + s[839];
gout[n*2187+354] += + s[840];
gout[n*2187+355] += + s[841];
gout[n*2187+356] += + s[842];
gout[n*2187+357] += + s[843];
gout[n*2187+358] += + s[844];
gout[n*2187+359] += + s[845];
gout[n*2187+360] += + s[846];
gout[n*2187+361] += + s[847];
gout[n*2187+362] += + s[848];
gout[n*2187+363] += + s[849];
gout[n*2187+364] += + s[850];
gout[n*2187+365] += + s[851];
gout[n*2187+366] += + s[852];
gout[n*2187+367] += + s[853];
gout[n*2187+368] += + s[854];
gout[n*2187+369] += + s[855];
gout[n*2187+370] += + s[856];
gout[n*2187+371] += + s[857];
gout[n*2187+372] += + s[858];
gout[n*2187+373] += + s[859];
gout[n*2187+374] += + s[860];
gout[n*2187+375] += + s[861];
gout[n*2187+376] += + s[862];
gout[n*2187+377] += + s[863];
gout[n*2187+378] += + s[864];
gout[n*2187+379] += + s[865];
gout[n*2187+380] += + s[866];
gout[n*2187+381] += + s[867];
gout[n*2187+382] += + s[868];
gout[n*2187+383] += + s[869];
gout[n*2187+384] += + s[870];
gout[n*2187+385] += + s[871];
gout[n*2187+386] += + s[872];
gout[n*2187+387] += + s[873];
gout[n*2187+388] += + s[874];
gout[n*2187+389] += + s[875];
gout[n*2187+390] += + s[876];
gout[n*2187+391] += + s[877];
gout[n*2187+392] += + s[878];
gout[n*2187+393] += + s[879];
gout[n*2187+394] += + s[880];
gout[n*2187+395] += + s[881];
gout[n*2187+396] += + s[882];
gout[n*2187+397] += + s[883];
gout[n*2187+398] += + s[884];
gout[n*2187+399] += + s[885];
gout[n*2187+400] += + s[886];
gout[n*2187+401] += + s[887];
gout[n*2187+402] += + s[888];
gout[n*2187+403] += + s[889];
gout[n*2187+404] += + s[890];
gout[n*2187+405] += + s[891];
gout[n*2187+406] += + s[892];
gout[n*2187+407] += + s[893];
gout[n*2187+408] += + s[894];
gout[n*2187+409] += + s[895];
gout[n*2187+410] += + s[896];
gout[n*2187+411] += + s[897];
gout[n*2187+412] += + s[898];
gout[n*2187+413] += + s[899];
gout[n*2187+414] += + s[900];
gout[n*2187+415] += + s[901];
gout[n*2187+416] += + s[902];
gout[n*2187+417] += + s[903];
gout[n*2187+418] += + s[904];
gout[n*2187+419] += + s[905];
gout[n*2187+420] += + s[906];
gout[n*2187+421] += + s[907];
gout[n*2187+422] += + s[908];
gout[n*2187+423] += + s[909];
gout[n*2187+424] += + s[910];
gout[n*2187+425] += + s[911];
gout[n*2187+426] += + s[912];
gout[n*2187+427] += + s[913];
gout[n*2187+428] += + s[914];
gout[n*2187+429] += + s[915];
gout[n*2187+430] += + s[916];
gout[n*2187+431] += + s[917];
gout[n*2187+432] += + s[918];
gout[n*2187+433] += + s[919];
gout[n*2187+434] += + s[920];
gout[n*2187+435] += + s[921];
gout[n*2187+436] += + s[922];
gout[n*2187+437] += + s[923];
gout[n*2187+438] += + s[924];
gout[n*2187+439] += + s[925];
gout[n*2187+440] += + s[926];
gout[n*2187+441] += + s[927];
gout[n*2187+442] += + s[928];
gout[n*2187+443] += + s[929];
gout[n*2187+444] += + s[930];
gout[n*2187+445] += + s[931];
gout[n*2187+446] += + s[932];
gout[n*2187+447] += + s[933];
gout[n*2187+448] += + s[934];
gout[n*2187+449] += + s[935];
gout[n*2187+450] += + s[936];
gout[n*2187+451] += + s[937];
gout[n*2187+452] += + s[938];
gout[n*2187+453] += + s[939];
gout[n*2187+454] += + s[940];
gout[n*2187+455] += + s[941];
gout[n*2187+456] += + s[942];
gout[n*2187+457] += + s[943];
gout[n*2187+458] += + s[944];
gout[n*2187+459] += + s[945];
gout[n*2187+460] += + s[946];
gout[n*2187+461] += + s[947];
gout[n*2187+462] += + s[948];
gout[n*2187+463] += + s[949];
gout[n*2187+464] += + s[950];
gout[n*2187+465] += + s[951];
gout[n*2187+466] += + s[952];
gout[n*2187+467] += + s[953];
gout[n*2187+468] += + s[954];
gout[n*2187+469] += + s[955];
gout[n*2187+470] += + s[956];
gout[n*2187+471] += + s[957];
gout[n*2187+472] += + s[958];
gout[n*2187+473] += + s[959];
gout[n*2187+474] += + s[960];
gout[n*2187+475] += + s[961];
gout[n*2187+476] += + s[962];
gout[n*2187+477] += + s[963];
gout[n*2187+478] += + s[964];
gout[n*2187+479] += + s[965];
gout[n*2187+480] += + s[966];
gout[n*2187+481] += + s[967];
gout[n*2187+482] += + s[968];
gout[n*2187+483] += + s[969];
gout[n*2187+484] += + s[970];
gout[n*2187+485] += + s[971];
gout[n*2187+486] += + s[1458];
gout[n*2187+487] += + s[1459];
gout[n*2187+488] += + s[1460];
gout[n*2187+489] += + s[1461];
gout[n*2187+490] += + s[1462];
gout[n*2187+491] += + s[1463];
gout[n*2187+492] += + s[1464];
gout[n*2187+493] += + s[1465];
gout[n*2187+494] += + s[1466];
gout[n*2187+495] += + s[1467];
gout[n*2187+496] += + s[1468];
gout[n*2187+497] += + s[1469];
gout[n*2187+498] += + s[1470];
gout[n*2187+499] += + s[1471];
gout[n*2187+500] += + s[1472];
gout[n*2187+501] += + s[1473];
gout[n*2187+502] += + s[1474];
gout[n*2187+503] += + s[1475];
gout[n*2187+504] += + s[1476];
gout[n*2187+505] += + s[1477];
gout[n*2187+506] += + s[1478];
gout[n*2187+507] += + s[1479];
gout[n*2187+508] += + s[1480];
gout[n*2187+509] += + s[1481];
gout[n*2187+510] += + s[1482];
gout[n*2187+511] += + s[1483];
gout[n*2187+512] += + s[1484];
gout[n*2187+513] += + s[1485];
gout[n*2187+514] += + s[1486];
gout[n*2187+515] += + s[1487];
gout[n*2187+516] += + s[1488];
gout[n*2187+517] += + s[1489];
gout[n*2187+518] += + s[1490];
gout[n*2187+519] += + s[1491];
gout[n*2187+520] += + s[1492];
gout[n*2187+521] += + s[1493];
gout[n*2187+522] += + s[1494];
gout[n*2187+523] += + s[1495];
gout[n*2187+524] += + s[1496];
gout[n*2187+525] += + s[1497];
gout[n*2187+526] += + s[1498];
gout[n*2187+527] += + s[1499];
gout[n*2187+528] += + s[1500];
gout[n*2187+529] += + s[1501];
gout[n*2187+530] += + s[1502];
gout[n*2187+531] += + s[1503];
gout[n*2187+532] += + s[1504];
gout[n*2187+533] += + s[1505];
gout[n*2187+534] += + s[1506];
gout[n*2187+535] += + s[1507];
gout[n*2187+536] += + s[1508];
gout[n*2187+537] += + s[1509];
gout[n*2187+538] += + s[1510];
gout[n*2187+539] += + s[1511];
gout[n*2187+540] += + s[1512];
gout[n*2187+541] += + s[1513];
gout[n*2187+542] += + s[1514];
gout[n*2187+543] += + s[1515];
gout[n*2187+544] += + s[1516];
gout[n*2187+545] += + s[1517];
gout[n*2187+546] += + s[1518];
gout[n*2187+547] += + s[1519];
gout[n*2187+548] += + s[1520];
gout[n*2187+549] += + s[1521];
gout[n*2187+550] += + s[1522];
gout[n*2187+551] += + s[1523];
gout[n*2187+552] += + s[1524];
gout[n*2187+553] += + s[1525];
gout[n*2187+554] += + s[1526];
gout[n*2187+555] += + s[1527];
gout[n*2187+556] += + s[1528];
gout[n*2187+557] += + s[1529];
gout[n*2187+558] += + s[1530];
gout[n*2187+559] += + s[1531];
gout[n*2187+560] += + s[1532];
gout[n*2187+561] += + s[1533];
gout[n*2187+562] += + s[1534];
gout[n*2187+563] += + s[1535];
gout[n*2187+564] += + s[1536];
gout[n*2187+565] += + s[1537];
gout[n*2187+566] += + s[1538];
gout[n*2187+567] += + s[1539];
gout[n*2187+568] += + s[1540];
gout[n*2187+569] += + s[1541];
gout[n*2187+570] += + s[1542];
gout[n*2187+571] += + s[1543];
gout[n*2187+572] += + s[1544];
gout[n*2187+573] += + s[1545];
gout[n*2187+574] += + s[1546];
gout[n*2187+575] += + s[1547];
gout[n*2187+576] += + s[1548];
gout[n*2187+577] += + s[1549];
gout[n*2187+578] += + s[1550];
gout[n*2187+579] += + s[1551];
gout[n*2187+580] += + s[1552];
gout[n*2187+581] += + s[1553];
gout[n*2187+582] += + s[1554];
gout[n*2187+583] += + s[1555];
gout[n*2187+584] += + s[1556];
gout[n*2187+585] += + s[1557];
gout[n*2187+586] += + s[1558];
gout[n*2187+587] += + s[1559];
gout[n*2187+588] += + s[1560];
gout[n*2187+589] += + s[1561];
gout[n*2187+590] += + s[1562];
gout[n*2187+591] += + s[1563];
gout[n*2187+592] += + s[1564];
gout[n*2187+593] += + s[1565];
gout[n*2187+594] += + s[1566];
gout[n*2187+595] += + s[1567];
gout[n*2187+596] += + s[1568];
gout[n*2187+597] += + s[1569];
gout[n*2187+598] += + s[1570];
gout[n*2187+599] += + s[1571];
gout[n*2187+600] += + s[1572];
gout[n*2187+601] += + s[1573];
gout[n*2187+602] += + s[1574];
gout[n*2187+603] += + s[1575];
gout[n*2187+604] += + s[1576];
gout[n*2187+605] += + s[1577];
gout[n*2187+606] += + s[1578];
gout[n*2187+607] += + s[1579];
gout[n*2187+608] += + s[1580];
gout[n*2187+609] += + s[1581];
gout[n*2187+610] += + s[1582];
gout[n*2187+611] += + s[1583];
gout[n*2187+612] += + s[1584];
gout[n*2187+613] += + s[1585];
gout[n*2187+614] += + s[1586];
gout[n*2187+615] += + s[1587];
gout[n*2187+616] += + s[1588];
gout[n*2187+617] += + s[1589];
gout[n*2187+618] += + s[1590];
gout[n*2187+619] += + s[1591];
gout[n*2187+620] += + s[1592];
gout[n*2187+621] += + s[1593];
gout[n*2187+622] += + s[1594];
gout[n*2187+623] += + s[1595];
gout[n*2187+624] += + s[1596];
gout[n*2187+625] += + s[1597];
gout[n*2187+626] += + s[1598];
gout[n*2187+627] += + s[1599];
gout[n*2187+628] += + s[1600];
gout[n*2187+629] += + s[1601];
gout[n*2187+630] += + s[1602];
gout[n*2187+631] += + s[1603];
gout[n*2187+632] += + s[1604];
gout[n*2187+633] += + s[1605];
gout[n*2187+634] += + s[1606];
gout[n*2187+635] += + s[1607];
gout[n*2187+636] += + s[1608];
gout[n*2187+637] += + s[1609];
gout[n*2187+638] += + s[1610];
gout[n*2187+639] += + s[1611];
gout[n*2187+640] += + s[1612];
gout[n*2187+641] += + s[1613];
gout[n*2187+642] += + s[1614];
gout[n*2187+643] += + s[1615];
gout[n*2187+644] += + s[1616];
gout[n*2187+645] += + s[1617];
gout[n*2187+646] += + s[1618];
gout[n*2187+647] += + s[1619];
gout[n*2187+648] += + s[1620];
gout[n*2187+649] += + s[1621];
gout[n*2187+650] += + s[1622];
gout[n*2187+651] += + s[1623];
gout[n*2187+652] += + s[1624];
gout[n*2187+653] += + s[1625];
gout[n*2187+654] += + s[1626];
gout[n*2187+655] += + s[1627];
gout[n*2187+656] += + s[1628];
gout[n*2187+657] += + s[1629];
gout[n*2187+658] += + s[1630];
gout[n*2187+659] += + s[1631];
gout[n*2187+660] += + s[1632];
gout[n*2187+661] += + s[1633];
gout[n*2187+662] += + s[1634];
gout[n*2187+663] += + s[1635];
gout[n*2187+664] += + s[1636];
gout[n*2187+665] += + s[1637];
gout[n*2187+666] += + s[1638];
gout[n*2187+667] += + s[1639];
gout[n*2187+668] += + s[1640];
gout[n*2187+669] += + s[1641];
gout[n*2187+670] += + s[1642];
gout[n*2187+671] += + s[1643];
gout[n*2187+672] += + s[1644];
gout[n*2187+673] += + s[1645];
gout[n*2187+674] += + s[1646];
gout[n*2187+675] += + s[1647];
gout[n*2187+676] += + s[1648];
gout[n*2187+677] += + s[1649];
gout[n*2187+678] += + s[1650];
gout[n*2187+679] += + s[1651];
gout[n*2187+680] += + s[1652];
gout[n*2187+681] += + s[1653];
gout[n*2187+682] += + s[1654];
gout[n*2187+683] += + s[1655];
gout[n*2187+684] += + s[1656];
gout[n*2187+685] += + s[1657];
gout[n*2187+686] += + s[1658];
gout[n*2187+687] += + s[1659];
gout[n*2187+688] += + s[1660];
gout[n*2187+689] += + s[1661];
gout[n*2187+690] += + s[1662];
gout[n*2187+691] += + s[1663];
gout[n*2187+692] += + s[1664];
gout[n*2187+693] += + s[1665];
gout[n*2187+694] += + s[1666];
gout[n*2187+695] += + s[1667];
gout[n*2187+696] += + s[1668];
gout[n*2187+697] += + s[1669];
gout[n*2187+698] += + s[1670];
gout[n*2187+699] += + s[1671];
gout[n*2187+700] += + s[1672];
gout[n*2187+701] += + s[1673];
gout[n*2187+702] += + s[1674];
gout[n*2187+703] += + s[1675];
gout[n*2187+704] += + s[1676];
gout[n*2187+705] += + s[1677];
gout[n*2187+706] += + s[1678];
gout[n*2187+707] += + s[1679];
gout[n*2187+708] += + s[1680];
gout[n*2187+709] += + s[1681];
gout[n*2187+710] += + s[1682];
gout[n*2187+711] += + s[1683];
gout[n*2187+712] += + s[1684];
gout[n*2187+713] += + s[1685];
gout[n*2187+714] += + s[1686];
gout[n*2187+715] += + s[1687];
gout[n*2187+716] += + s[1688];
gout[n*2187+717] += + s[1689];
gout[n*2187+718] += + s[1690];
gout[n*2187+719] += + s[1691];
gout[n*2187+720] += + s[1692];
gout[n*2187+721] += + s[1693];
gout[n*2187+722] += + s[1694];
gout[n*2187+723] += + s[1695];
gout[n*2187+724] += + s[1696];
gout[n*2187+725] += + s[1697];
gout[n*2187+726] += + s[1698];
gout[n*2187+727] += + s[1699];
gout[n*2187+728] += + s[1700];
gout[n*2187+729] += + s[243];
gout[n*2187+730] += + s[244];
gout[n*2187+731] += + s[245];
gout[n*2187+732] += + s[246];
gout[n*2187+733] += + s[247];
gout[n*2187+734] += + s[248];
gout[n*2187+735] += + s[249];
gout[n*2187+736] += + s[250];
gout[n*2187+737] += + s[251];
gout[n*2187+738] += + s[252];
gout[n*2187+739] += + s[253];
gout[n*2187+740] += + s[254];
gout[n*2187+741] += + s[255];
gout[n*2187+742] += + s[256];
gout[n*2187+743] += + s[257];
gout[n*2187+744] += + s[258];
gout[n*2187+745] += + s[259];
gout[n*2187+746] += + s[260];
gout[n*2187+747] += + s[261];
gout[n*2187+748] += + s[262];
gout[n*2187+749] += + s[263];
gout[n*2187+750] += + s[264];
gout[n*2187+751] += + s[265];
gout[n*2187+752] += + s[266];
gout[n*2187+753] += + s[267];
gout[n*2187+754] += + s[268];
gout[n*2187+755] += + s[269];
gout[n*2187+756] += + s[270];
gout[n*2187+757] += + s[271];
gout[n*2187+758] += + s[272];
gout[n*2187+759] += + s[273];
gout[n*2187+760] += + s[274];
gout[n*2187+761] += + s[275];
gout[n*2187+762] += + s[276];
gout[n*2187+763] += + s[277];
gout[n*2187+764] += + s[278];
gout[n*2187+765] += + s[279];
gout[n*2187+766] += + s[280];
gout[n*2187+767] += + s[281];
gout[n*2187+768] += + s[282];
gout[n*2187+769] += + s[283];
gout[n*2187+770] += + s[284];
gout[n*2187+771] += + s[285];
gout[n*2187+772] += + s[286];
gout[n*2187+773] += + s[287];
gout[n*2187+774] += + s[288];
gout[n*2187+775] += + s[289];
gout[n*2187+776] += + s[290];
gout[n*2187+777] += + s[291];
gout[n*2187+778] += + s[292];
gout[n*2187+779] += + s[293];
gout[n*2187+780] += + s[294];
gout[n*2187+781] += + s[295];
gout[n*2187+782] += + s[296];
gout[n*2187+783] += + s[297];
gout[n*2187+784] += + s[298];
gout[n*2187+785] += + s[299];
gout[n*2187+786] += + s[300];
gout[n*2187+787] += + s[301];
gout[n*2187+788] += + s[302];
gout[n*2187+789] += + s[303];
gout[n*2187+790] += + s[304];
gout[n*2187+791] += + s[305];
gout[n*2187+792] += + s[306];
gout[n*2187+793] += + s[307];
gout[n*2187+794] += + s[308];
gout[n*2187+795] += + s[309];
gout[n*2187+796] += + s[310];
gout[n*2187+797] += + s[311];
gout[n*2187+798] += + s[312];
gout[n*2187+799] += + s[313];
gout[n*2187+800] += + s[314];
gout[n*2187+801] += + s[315];
gout[n*2187+802] += + s[316];
gout[n*2187+803] += + s[317];
gout[n*2187+804] += + s[318];
gout[n*2187+805] += + s[319];
gout[n*2187+806] += + s[320];
gout[n*2187+807] += + s[321];
gout[n*2187+808] += + s[322];
gout[n*2187+809] += + s[323];
gout[n*2187+810] += + s[324];
gout[n*2187+811] += + s[325];
gout[n*2187+812] += + s[326];
gout[n*2187+813] += + s[327];
gout[n*2187+814] += + s[328];
gout[n*2187+815] += + s[329];
gout[n*2187+816] += + s[330];
gout[n*2187+817] += + s[331];
gout[n*2187+818] += + s[332];
gout[n*2187+819] += + s[333];
gout[n*2187+820] += + s[334];
gout[n*2187+821] += + s[335];
gout[n*2187+822] += + s[336];
gout[n*2187+823] += + s[337];
gout[n*2187+824] += + s[338];
gout[n*2187+825] += + s[339];
gout[n*2187+826] += + s[340];
gout[n*2187+827] += + s[341];
gout[n*2187+828] += + s[342];
gout[n*2187+829] += + s[343];
gout[n*2187+830] += + s[344];
gout[n*2187+831] += + s[345];
gout[n*2187+832] += + s[346];
gout[n*2187+833] += + s[347];
gout[n*2187+834] += + s[348];
gout[n*2187+835] += + s[349];
gout[n*2187+836] += + s[350];
gout[n*2187+837] += + s[351];
gout[n*2187+838] += + s[352];
gout[n*2187+839] += + s[353];
gout[n*2187+840] += + s[354];
gout[n*2187+841] += + s[355];
gout[n*2187+842] += + s[356];
gout[n*2187+843] += + s[357];
gout[n*2187+844] += + s[358];
gout[n*2187+845] += + s[359];
gout[n*2187+846] += + s[360];
gout[n*2187+847] += + s[361];
gout[n*2187+848] += + s[362];
gout[n*2187+849] += + s[363];
gout[n*2187+850] += + s[364];
gout[n*2187+851] += + s[365];
gout[n*2187+852] += + s[366];
gout[n*2187+853] += + s[367];
gout[n*2187+854] += + s[368];
gout[n*2187+855] += + s[369];
gout[n*2187+856] += + s[370];
gout[n*2187+857] += + s[371];
gout[n*2187+858] += + s[372];
gout[n*2187+859] += + s[373];
gout[n*2187+860] += + s[374];
gout[n*2187+861] += + s[375];
gout[n*2187+862] += + s[376];
gout[n*2187+863] += + s[377];
gout[n*2187+864] += + s[378];
gout[n*2187+865] += + s[379];
gout[n*2187+866] += + s[380];
gout[n*2187+867] += + s[381];
gout[n*2187+868] += + s[382];
gout[n*2187+869] += + s[383];
gout[n*2187+870] += + s[384];
gout[n*2187+871] += + s[385];
gout[n*2187+872] += + s[386];
gout[n*2187+873] += + s[387];
gout[n*2187+874] += + s[388];
gout[n*2187+875] += + s[389];
gout[n*2187+876] += + s[390];
gout[n*2187+877] += + s[391];
gout[n*2187+878] += + s[392];
gout[n*2187+879] += + s[393];
gout[n*2187+880] += + s[394];
gout[n*2187+881] += + s[395];
gout[n*2187+882] += + s[396];
gout[n*2187+883] += + s[397];
gout[n*2187+884] += + s[398];
gout[n*2187+885] += + s[399];
gout[n*2187+886] += + s[400];
gout[n*2187+887] += + s[401];
gout[n*2187+888] += + s[402];
gout[n*2187+889] += + s[403];
gout[n*2187+890] += + s[404];
gout[n*2187+891] += + s[405];
gout[n*2187+892] += + s[406];
gout[n*2187+893] += + s[407];
gout[n*2187+894] += + s[408];
gout[n*2187+895] += + s[409];
gout[n*2187+896] += + s[410];
gout[n*2187+897] += + s[411];
gout[n*2187+898] += + s[412];
gout[n*2187+899] += + s[413];
gout[n*2187+900] += + s[414];
gout[n*2187+901] += + s[415];
gout[n*2187+902] += + s[416];
gout[n*2187+903] += + s[417];
gout[n*2187+904] += + s[418];
gout[n*2187+905] += + s[419];
gout[n*2187+906] += + s[420];
gout[n*2187+907] += + s[421];
gout[n*2187+908] += + s[422];
gout[n*2187+909] += + s[423];
gout[n*2187+910] += + s[424];
gout[n*2187+911] += + s[425];
gout[n*2187+912] += + s[426];
gout[n*2187+913] += + s[427];
gout[n*2187+914] += + s[428];
gout[n*2187+915] += + s[429];
gout[n*2187+916] += + s[430];
gout[n*2187+917] += + s[431];
gout[n*2187+918] += + s[432];
gout[n*2187+919] += + s[433];
gout[n*2187+920] += + s[434];
gout[n*2187+921] += + s[435];
gout[n*2187+922] += + s[436];
gout[n*2187+923] += + s[437];
gout[n*2187+924] += + s[438];
gout[n*2187+925] += + s[439];
gout[n*2187+926] += + s[440];
gout[n*2187+927] += + s[441];
gout[n*2187+928] += + s[442];
gout[n*2187+929] += + s[443];
gout[n*2187+930] += + s[444];
gout[n*2187+931] += + s[445];
gout[n*2187+932] += + s[446];
gout[n*2187+933] += + s[447];
gout[n*2187+934] += + s[448];
gout[n*2187+935] += + s[449];
gout[n*2187+936] += + s[450];
gout[n*2187+937] += + s[451];
gout[n*2187+938] += + s[452];
gout[n*2187+939] += + s[453];
gout[n*2187+940] += + s[454];
gout[n*2187+941] += + s[455];
gout[n*2187+942] += + s[456];
gout[n*2187+943] += + s[457];
gout[n*2187+944] += + s[458];
gout[n*2187+945] += + s[459];
gout[n*2187+946] += + s[460];
gout[n*2187+947] += + s[461];
gout[n*2187+948] += + s[462];
gout[n*2187+949] += + s[463];
gout[n*2187+950] += + s[464];
gout[n*2187+951] += + s[465];
gout[n*2187+952] += + s[466];
gout[n*2187+953] += + s[467];
gout[n*2187+954] += + s[468];
gout[n*2187+955] += + s[469];
gout[n*2187+956] += + s[470];
gout[n*2187+957] += + s[471];
gout[n*2187+958] += + s[472];
gout[n*2187+959] += + s[473];
gout[n*2187+960] += + s[474];
gout[n*2187+961] += + s[475];
gout[n*2187+962] += + s[476];
gout[n*2187+963] += + s[477];
gout[n*2187+964] += + s[478];
gout[n*2187+965] += + s[479];
gout[n*2187+966] += + s[480];
gout[n*2187+967] += + s[481];
gout[n*2187+968] += + s[482];
gout[n*2187+969] += + s[483];
gout[n*2187+970] += + s[484];
gout[n*2187+971] += + s[485];
gout[n*2187+972] += + s[972];
gout[n*2187+973] += + s[973];
gout[n*2187+974] += + s[974];
gout[n*2187+975] += + s[975];
gout[n*2187+976] += + s[976];
gout[n*2187+977] += + s[977];
gout[n*2187+978] += + s[978];
gout[n*2187+979] += + s[979];
gout[n*2187+980] += + s[980];
gout[n*2187+981] += + s[981];
gout[n*2187+982] += + s[982];
gout[n*2187+983] += + s[983];
gout[n*2187+984] += + s[984];
gout[n*2187+985] += + s[985];
gout[n*2187+986] += + s[986];
gout[n*2187+987] += + s[987];
gout[n*2187+988] += + s[988];
gout[n*2187+989] += + s[989];
gout[n*2187+990] += + s[990];
gout[n*2187+991] += + s[991];
gout[n*2187+992] += + s[992];
gout[n*2187+993] += + s[993];
gout[n*2187+994] += + s[994];
gout[n*2187+995] += + s[995];
gout[n*2187+996] += + s[996];
gout[n*2187+997] += + s[997];
gout[n*2187+998] += + s[998];
gout[n*2187+999] += + s[999];
gout[n*2187+1000] += + s[1000];
gout[n*2187+1001] += + s[1001];
gout[n*2187+1002] += + s[1002];
gout[n*2187+1003] += + s[1003];
gout[n*2187+1004] += + s[1004];
gout[n*2187+1005] += + s[1005];
gout[n*2187+1006] += + s[1006];
gout[n*2187+1007] += + s[1007];
gout[n*2187+1008] += + s[1008];
gout[n*2187+1009] += + s[1009];
gout[n*2187+1010] += + s[1010];
gout[n*2187+1011] += + s[1011];
gout[n*2187+1012] += + s[1012];
gout[n*2187+1013] += + s[1013];
gout[n*2187+1014] += + s[1014];
gout[n*2187+1015] += + s[1015];
gout[n*2187+1016] += + s[1016];
gout[n*2187+1017] += + s[1017];
gout[n*2187+1018] += + s[1018];
gout[n*2187+1019] += + s[1019];
gout[n*2187+1020] += + s[1020];
gout[n*2187+1021] += + s[1021];
gout[n*2187+1022] += + s[1022];
gout[n*2187+1023] += + s[1023];
gout[n*2187+1024] += + s[1024];
gout[n*2187+1025] += + s[1025];
gout[n*2187+1026] += + s[1026];
gout[n*2187+1027] += + s[1027];
gout[n*2187+1028] += + s[1028];
gout[n*2187+1029] += + s[1029];
gout[n*2187+1030] += + s[1030];
gout[n*2187+1031] += + s[1031];
gout[n*2187+1032] += + s[1032];
gout[n*2187+1033] += + s[1033];
gout[n*2187+1034] += + s[1034];
gout[n*2187+1035] += + s[1035];
gout[n*2187+1036] += + s[1036];
gout[n*2187+1037] += + s[1037];
gout[n*2187+1038] += + s[1038];
gout[n*2187+1039] += + s[1039];
gout[n*2187+1040] += + s[1040];
gout[n*2187+1041] += + s[1041];
gout[n*2187+1042] += + s[1042];
gout[n*2187+1043] += + s[1043];
gout[n*2187+1044] += + s[1044];
gout[n*2187+1045] += + s[1045];
gout[n*2187+1046] += + s[1046];
gout[n*2187+1047] += + s[1047];
gout[n*2187+1048] += + s[1048];
gout[n*2187+1049] += + s[1049];
gout[n*2187+1050] += + s[1050];
gout[n*2187+1051] += + s[1051];
gout[n*2187+1052] += + s[1052];
gout[n*2187+1053] += + s[1053];
gout[n*2187+1054] += + s[1054];
gout[n*2187+1055] += + s[1055];
gout[n*2187+1056] += + s[1056];
gout[n*2187+1057] += + s[1057];
gout[n*2187+1058] += + s[1058];
gout[n*2187+1059] += + s[1059];
gout[n*2187+1060] += + s[1060];
gout[n*2187+1061] += + s[1061];
gout[n*2187+1062] += + s[1062];
gout[n*2187+1063] += + s[1063];
gout[n*2187+1064] += + s[1064];
gout[n*2187+1065] += + s[1065];
gout[n*2187+1066] += + s[1066];
gout[n*2187+1067] += + s[1067];
gout[n*2187+1068] += + s[1068];
gout[n*2187+1069] += + s[1069];
gout[n*2187+1070] += + s[1070];
gout[n*2187+1071] += + s[1071];
gout[n*2187+1072] += + s[1072];
gout[n*2187+1073] += + s[1073];
gout[n*2187+1074] += + s[1074];
gout[n*2187+1075] += + s[1075];
gout[n*2187+1076] += + s[1076];
gout[n*2187+1077] += + s[1077];
gout[n*2187+1078] += + s[1078];
gout[n*2187+1079] += + s[1079];
gout[n*2187+1080] += + s[1080];
gout[n*2187+1081] += + s[1081];
gout[n*2187+1082] += + s[1082];
gout[n*2187+1083] += + s[1083];
gout[n*2187+1084] += + s[1084];
gout[n*2187+1085] += + s[1085];
gout[n*2187+1086] += + s[1086];
gout[n*2187+1087] += + s[1087];
gout[n*2187+1088] += + s[1088];
gout[n*2187+1089] += + s[1089];
gout[n*2187+1090] += + s[1090];
gout[n*2187+1091] += + s[1091];
gout[n*2187+1092] += + s[1092];
gout[n*2187+1093] += + s[1093];
gout[n*2187+1094] += + s[1094];
gout[n*2187+1095] += + s[1095];
gout[n*2187+1096] += + s[1096];
gout[n*2187+1097] += + s[1097];
gout[n*2187+1098] += + s[1098];
gout[n*2187+1099] += + s[1099];
gout[n*2187+1100] += + s[1100];
gout[n*2187+1101] += + s[1101];
gout[n*2187+1102] += + s[1102];
gout[n*2187+1103] += + s[1103];
gout[n*2187+1104] += + s[1104];
gout[n*2187+1105] += + s[1105];
gout[n*2187+1106] += + s[1106];
gout[n*2187+1107] += + s[1107];
gout[n*2187+1108] += + s[1108];
gout[n*2187+1109] += + s[1109];
gout[n*2187+1110] += + s[1110];
gout[n*2187+1111] += + s[1111];
gout[n*2187+1112] += + s[1112];
gout[n*2187+1113] += + s[1113];
gout[n*2187+1114] += + s[1114];
gout[n*2187+1115] += + s[1115];
gout[n*2187+1116] += + s[1116];
gout[n*2187+1117] += + s[1117];
gout[n*2187+1118] += + s[1118];
gout[n*2187+1119] += + s[1119];
gout[n*2187+1120] += + s[1120];
gout[n*2187+1121] += + s[1121];
gout[n*2187+1122] += + s[1122];
gout[n*2187+1123] += + s[1123];
gout[n*2187+1124] += + s[1124];
gout[n*2187+1125] += + s[1125];
gout[n*2187+1126] += + s[1126];
gout[n*2187+1127] += + s[1127];
gout[n*2187+1128] += + s[1128];
gout[n*2187+1129] += + s[1129];
gout[n*2187+1130] += + s[1130];
gout[n*2187+1131] += + s[1131];
gout[n*2187+1132] += + s[1132];
gout[n*2187+1133] += + s[1133];
gout[n*2187+1134] += + s[1134];
gout[n*2187+1135] += + s[1135];
gout[n*2187+1136] += + s[1136];
gout[n*2187+1137] += + s[1137];
gout[n*2187+1138] += + s[1138];
gout[n*2187+1139] += + s[1139];
gout[n*2187+1140] += + s[1140];
gout[n*2187+1141] += + s[1141];
gout[n*2187+1142] += + s[1142];
gout[n*2187+1143] += + s[1143];
gout[n*2187+1144] += + s[1144];
gout[n*2187+1145] += + s[1145];
gout[n*2187+1146] += + s[1146];
gout[n*2187+1147] += + s[1147];
gout[n*2187+1148] += + s[1148];
gout[n*2187+1149] += + s[1149];
gout[n*2187+1150] += + s[1150];
gout[n*2187+1151] += + s[1151];
gout[n*2187+1152] += + s[1152];
gout[n*2187+1153] += + s[1153];
gout[n*2187+1154] += + s[1154];
gout[n*2187+1155] += + s[1155];
gout[n*2187+1156] += + s[1156];
gout[n*2187+1157] += + s[1157];
gout[n*2187+1158] += + s[1158];
gout[n*2187+1159] += + s[1159];
gout[n*2187+1160] += + s[1160];
gout[n*2187+1161] += + s[1161];
gout[n*2187+1162] += + s[1162];
gout[n*2187+1163] += + s[1163];
gout[n*2187+1164] += + s[1164];
gout[n*2187+1165] += + s[1165];
gout[n*2187+1166] += + s[1166];
gout[n*2187+1167] += + s[1167];
gout[n*2187+1168] += + s[1168];
gout[n*2187+1169] += + s[1169];
gout[n*2187+1170] += + s[1170];
gout[n*2187+1171] += + s[1171];
gout[n*2187+1172] += + s[1172];
gout[n*2187+1173] += + s[1173];
gout[n*2187+1174] += + s[1174];
gout[n*2187+1175] += + s[1175];
gout[n*2187+1176] += + s[1176];
gout[n*2187+1177] += + s[1177];
gout[n*2187+1178] += + s[1178];
gout[n*2187+1179] += + s[1179];
gout[n*2187+1180] += + s[1180];
gout[n*2187+1181] += + s[1181];
gout[n*2187+1182] += + s[1182];
gout[n*2187+1183] += + s[1183];
gout[n*2187+1184] += + s[1184];
gout[n*2187+1185] += + s[1185];
gout[n*2187+1186] += + s[1186];
gout[n*2187+1187] += + s[1187];
gout[n*2187+1188] += + s[1188];
gout[n*2187+1189] += + s[1189];
gout[n*2187+1190] += + s[1190];
gout[n*2187+1191] += + s[1191];
gout[n*2187+1192] += + s[1192];
gout[n*2187+1193] += + s[1193];
gout[n*2187+1194] += + s[1194];
gout[n*2187+1195] += + s[1195];
gout[n*2187+1196] += + s[1196];
gout[n*2187+1197] += + s[1197];
gout[n*2187+1198] += + s[1198];
gout[n*2187+1199] += + s[1199];
gout[n*2187+1200] += + s[1200];
gout[n*2187+1201] += + s[1201];
gout[n*2187+1202] += + s[1202];
gout[n*2187+1203] += + s[1203];
gout[n*2187+1204] += + s[1204];
gout[n*2187+1205] += + s[1205];
gout[n*2187+1206] += + s[1206];
gout[n*2187+1207] += + s[1207];
gout[n*2187+1208] += + s[1208];
gout[n*2187+1209] += + s[1209];
gout[n*2187+1210] += + s[1210];
gout[n*2187+1211] += + s[1211];
gout[n*2187+1212] += + s[1212];
gout[n*2187+1213] += + s[1213];
gout[n*2187+1214] += + s[1214];
gout[n*2187+1215] += + s[1701];
gout[n*2187+1216] += + s[1702];
gout[n*2187+1217] += + s[1703];
gout[n*2187+1218] += + s[1704];
gout[n*2187+1219] += + s[1705];
gout[n*2187+1220] += + s[1706];
gout[n*2187+1221] += + s[1707];
gout[n*2187+1222] += + s[1708];
gout[n*2187+1223] += + s[1709];
gout[n*2187+1224] += + s[1710];
gout[n*2187+1225] += + s[1711];
gout[n*2187+1226] += + s[1712];
gout[n*2187+1227] += + s[1713];
gout[n*2187+1228] += + s[1714];
gout[n*2187+1229] += + s[1715];
gout[n*2187+1230] += + s[1716];
gout[n*2187+1231] += + s[1717];
gout[n*2187+1232] += + s[1718];
gout[n*2187+1233] += + s[1719];
gout[n*2187+1234] += + s[1720];
gout[n*2187+1235] += + s[1721];
gout[n*2187+1236] += + s[1722];
gout[n*2187+1237] += + s[1723];
gout[n*2187+1238] += + s[1724];
gout[n*2187+1239] += + s[1725];
gout[n*2187+1240] += + s[1726];
gout[n*2187+1241] += + s[1727];
gout[n*2187+1242] += + s[1728];
gout[n*2187+1243] += + s[1729];
gout[n*2187+1244] += + s[1730];
gout[n*2187+1245] += + s[1731];
gout[n*2187+1246] += + s[1732];
gout[n*2187+1247] += + s[1733];
gout[n*2187+1248] += + s[1734];
gout[n*2187+1249] += + s[1735];
gout[n*2187+1250] += + s[1736];
gout[n*2187+1251] += + s[1737];
gout[n*2187+1252] += + s[1738];
gout[n*2187+1253] += + s[1739];
gout[n*2187+1254] += + s[1740];
gout[n*2187+1255] += + s[1741];
gout[n*2187+1256] += + s[1742];
gout[n*2187+1257] += + s[1743];
gout[n*2187+1258] += + s[1744];
gout[n*2187+1259] += + s[1745];
gout[n*2187+1260] += + s[1746];
gout[n*2187+1261] += + s[1747];
gout[n*2187+1262] += + s[1748];
gout[n*2187+1263] += + s[1749];
gout[n*2187+1264] += + s[1750];
gout[n*2187+1265] += + s[1751];
gout[n*2187+1266] += + s[1752];
gout[n*2187+1267] += + s[1753];
gout[n*2187+1268] += + s[1754];
gout[n*2187+1269] += + s[1755];
gout[n*2187+1270] += + s[1756];
gout[n*2187+1271] += + s[1757];
gout[n*2187+1272] += + s[1758];
gout[n*2187+1273] += + s[1759];
gout[n*2187+1274] += + s[1760];
gout[n*2187+1275] += + s[1761];
gout[n*2187+1276] += + s[1762];
gout[n*2187+1277] += + s[1763];
gout[n*2187+1278] += + s[1764];
gout[n*2187+1279] += + s[1765];
gout[n*2187+1280] += + s[1766];
gout[n*2187+1281] += + s[1767];
gout[n*2187+1282] += + s[1768];
gout[n*2187+1283] += + s[1769];
gout[n*2187+1284] += + s[1770];
gout[n*2187+1285] += + s[1771];
gout[n*2187+1286] += + s[1772];
gout[n*2187+1287] += + s[1773];
gout[n*2187+1288] += + s[1774];
gout[n*2187+1289] += + s[1775];
gout[n*2187+1290] += + s[1776];
gout[n*2187+1291] += + s[1777];
gout[n*2187+1292] += + s[1778];
gout[n*2187+1293] += + s[1779];
gout[n*2187+1294] += + s[1780];
gout[n*2187+1295] += + s[1781];
gout[n*2187+1296] += + s[1782];
gout[n*2187+1297] += + s[1783];
gout[n*2187+1298] += + s[1784];
gout[n*2187+1299] += + s[1785];
gout[n*2187+1300] += + s[1786];
gout[n*2187+1301] += + s[1787];
gout[n*2187+1302] += + s[1788];
gout[n*2187+1303] += + s[1789];
gout[n*2187+1304] += + s[1790];
gout[n*2187+1305] += + s[1791];
gout[n*2187+1306] += + s[1792];
gout[n*2187+1307] += + s[1793];
gout[n*2187+1308] += + s[1794];
gout[n*2187+1309] += + s[1795];
gout[n*2187+1310] += + s[1796];
gout[n*2187+1311] += + s[1797];
gout[n*2187+1312] += + s[1798];
gout[n*2187+1313] += + s[1799];
gout[n*2187+1314] += + s[1800];
gout[n*2187+1315] += + s[1801];
gout[n*2187+1316] += + s[1802];
gout[n*2187+1317] += + s[1803];
gout[n*2187+1318] += + s[1804];
gout[n*2187+1319] += + s[1805];
gout[n*2187+1320] += + s[1806];
gout[n*2187+1321] += + s[1807];
gout[n*2187+1322] += + s[1808];
gout[n*2187+1323] += + s[1809];
gout[n*2187+1324] += + s[1810];
gout[n*2187+1325] += + s[1811];
gout[n*2187+1326] += + s[1812];
gout[n*2187+1327] += + s[1813];
gout[n*2187+1328] += + s[1814];
gout[n*2187+1329] += + s[1815];
gout[n*2187+1330] += + s[1816];
gout[n*2187+1331] += + s[1817];
gout[n*2187+1332] += + s[1818];
gout[n*2187+1333] += + s[1819];
gout[n*2187+1334] += + s[1820];
gout[n*2187+1335] += + s[1821];
gout[n*2187+1336] += + s[1822];
gout[n*2187+1337] += + s[1823];
gout[n*2187+1338] += + s[1824];
gout[n*2187+1339] += + s[1825];
gout[n*2187+1340] += + s[1826];
gout[n*2187+1341] += + s[1827];
gout[n*2187+1342] += + s[1828];
gout[n*2187+1343] += + s[1829];
gout[n*2187+1344] += + s[1830];
gout[n*2187+1345] += + s[1831];
gout[n*2187+1346] += + s[1832];
gout[n*2187+1347] += + s[1833];
gout[n*2187+1348] += + s[1834];
gout[n*2187+1349] += + s[1835];
gout[n*2187+1350] += + s[1836];
gout[n*2187+1351] += + s[1837];
gout[n*2187+1352] += + s[1838];
gout[n*2187+1353] += + s[1839];
gout[n*2187+1354] += + s[1840];
gout[n*2187+1355] += + s[1841];
gout[n*2187+1356] += + s[1842];
gout[n*2187+1357] += + s[1843];
gout[n*2187+1358] += + s[1844];
gout[n*2187+1359] += + s[1845];
gout[n*2187+1360] += + s[1846];
gout[n*2187+1361] += + s[1847];
gout[n*2187+1362] += + s[1848];
gout[n*2187+1363] += + s[1849];
gout[n*2187+1364] += + s[1850];
gout[n*2187+1365] += + s[1851];
gout[n*2187+1366] += + s[1852];
gout[n*2187+1367] += + s[1853];
gout[n*2187+1368] += + s[1854];
gout[n*2187+1369] += + s[1855];
gout[n*2187+1370] += + s[1856];
gout[n*2187+1371] += + s[1857];
gout[n*2187+1372] += + s[1858];
gout[n*2187+1373] += + s[1859];
gout[n*2187+1374] += + s[1860];
gout[n*2187+1375] += + s[1861];
gout[n*2187+1376] += + s[1862];
gout[n*2187+1377] += + s[1863];
gout[n*2187+1378] += + s[1864];
gout[n*2187+1379] += + s[1865];
gout[n*2187+1380] += + s[1866];
gout[n*2187+1381] += + s[1867];
gout[n*2187+1382] += + s[1868];
gout[n*2187+1383] += + s[1869];
gout[n*2187+1384] += + s[1870];
gout[n*2187+1385] += + s[1871];
gout[n*2187+1386] += + s[1872];
gout[n*2187+1387] += + s[1873];
gout[n*2187+1388] += + s[1874];
gout[n*2187+1389] += + s[1875];
gout[n*2187+1390] += + s[1876];
gout[n*2187+1391] += + s[1877];
gout[n*2187+1392] += + s[1878];
gout[n*2187+1393] += + s[1879];
gout[n*2187+1394] += + s[1880];
gout[n*2187+1395] += + s[1881];
gout[n*2187+1396] += + s[1882];
gout[n*2187+1397] += + s[1883];
gout[n*2187+1398] += + s[1884];
gout[n*2187+1399] += + s[1885];
gout[n*2187+1400] += + s[1886];
gout[n*2187+1401] += + s[1887];
gout[n*2187+1402] += + s[1888];
gout[n*2187+1403] += + s[1889];
gout[n*2187+1404] += + s[1890];
gout[n*2187+1405] += + s[1891];
gout[n*2187+1406] += + s[1892];
gout[n*2187+1407] += + s[1893];
gout[n*2187+1408] += + s[1894];
gout[n*2187+1409] += + s[1895];
gout[n*2187+1410] += + s[1896];
gout[n*2187+1411] += + s[1897];
gout[n*2187+1412] += + s[1898];
gout[n*2187+1413] += + s[1899];
gout[n*2187+1414] += + s[1900];
gout[n*2187+1415] += + s[1901];
gout[n*2187+1416] += + s[1902];
gout[n*2187+1417] += + s[1903];
gout[n*2187+1418] += + s[1904];
gout[n*2187+1419] += + s[1905];
gout[n*2187+1420] += + s[1906];
gout[n*2187+1421] += + s[1907];
gout[n*2187+1422] += + s[1908];
gout[n*2187+1423] += + s[1909];
gout[n*2187+1424] += + s[1910];
gout[n*2187+1425] += + s[1911];
gout[n*2187+1426] += + s[1912];
gout[n*2187+1427] += + s[1913];
gout[n*2187+1428] += + s[1914];
gout[n*2187+1429] += + s[1915];
gout[n*2187+1430] += + s[1916];
gout[n*2187+1431] += + s[1917];
gout[n*2187+1432] += + s[1918];
gout[n*2187+1433] += + s[1919];
gout[n*2187+1434] += + s[1920];
gout[n*2187+1435] += + s[1921];
gout[n*2187+1436] += + s[1922];
gout[n*2187+1437] += + s[1923];
gout[n*2187+1438] += + s[1924];
gout[n*2187+1439] += + s[1925];
gout[n*2187+1440] += + s[1926];
gout[n*2187+1441] += + s[1927];
gout[n*2187+1442] += + s[1928];
gout[n*2187+1443] += + s[1929];
gout[n*2187+1444] += + s[1930];
gout[n*2187+1445] += + s[1931];
gout[n*2187+1446] += + s[1932];
gout[n*2187+1447] += + s[1933];
gout[n*2187+1448] += + s[1934];
gout[n*2187+1449] += + s[1935];
gout[n*2187+1450] += + s[1936];
gout[n*2187+1451] += + s[1937];
gout[n*2187+1452] += + s[1938];
gout[n*2187+1453] += + s[1939];
gout[n*2187+1454] += + s[1940];
gout[n*2187+1455] += + s[1941];
gout[n*2187+1456] += + s[1942];
gout[n*2187+1457] += + s[1943];
gout[n*2187+1458] += + s[486];
gout[n*2187+1459] += + s[487];
gout[n*2187+1460] += + s[488];
gout[n*2187+1461] += + s[489];
gout[n*2187+1462] += + s[490];
gout[n*2187+1463] += + s[491];
gout[n*2187+1464] += + s[492];
gout[n*2187+1465] += + s[493];
gout[n*2187+1466] += + s[494];
gout[n*2187+1467] += + s[495];
gout[n*2187+1468] += + s[496];
gout[n*2187+1469] += + s[497];
gout[n*2187+1470] += + s[498];
gout[n*2187+1471] += + s[499];
gout[n*2187+1472] += + s[500];
gout[n*2187+1473] += + s[501];
gout[n*2187+1474] += + s[502];
gout[n*2187+1475] += + s[503];
gout[n*2187+1476] += + s[504];
gout[n*2187+1477] += + s[505];
gout[n*2187+1478] += + s[506];
gout[n*2187+1479] += + s[507];
gout[n*2187+1480] += + s[508];
gout[n*2187+1481] += + s[509];
gout[n*2187+1482] += + s[510];
gout[n*2187+1483] += + s[511];
gout[n*2187+1484] += + s[512];
gout[n*2187+1485] += + s[513];
gout[n*2187+1486] += + s[514];
gout[n*2187+1487] += + s[515];
gout[n*2187+1488] += + s[516];
gout[n*2187+1489] += + s[517];
gout[n*2187+1490] += + s[518];
gout[n*2187+1491] += + s[519];
gout[n*2187+1492] += + s[520];
gout[n*2187+1493] += + s[521];
gout[n*2187+1494] += + s[522];
gout[n*2187+1495] += + s[523];
gout[n*2187+1496] += + s[524];
gout[n*2187+1497] += + s[525];
gout[n*2187+1498] += + s[526];
gout[n*2187+1499] += + s[527];
gout[n*2187+1500] += + s[528];
gout[n*2187+1501] += + s[529];
gout[n*2187+1502] += + s[530];
gout[n*2187+1503] += + s[531];
gout[n*2187+1504] += + s[532];
gout[n*2187+1505] += + s[533];
gout[n*2187+1506] += + s[534];
gout[n*2187+1507] += + s[535];
gout[n*2187+1508] += + s[536];
gout[n*2187+1509] += + s[537];
gout[n*2187+1510] += + s[538];
gout[n*2187+1511] += + s[539];
gout[n*2187+1512] += + s[540];
gout[n*2187+1513] += + s[541];
gout[n*2187+1514] += + s[542];
gout[n*2187+1515] += + s[543];
gout[n*2187+1516] += + s[544];
gout[n*2187+1517] += + s[545];
gout[n*2187+1518] += + s[546];
gout[n*2187+1519] += + s[547];
gout[n*2187+1520] += + s[548];
gout[n*2187+1521] += + s[549];
gout[n*2187+1522] += + s[550];
gout[n*2187+1523] += + s[551];
gout[n*2187+1524] += + s[552];
gout[n*2187+1525] += + s[553];
gout[n*2187+1526] += + s[554];
gout[n*2187+1527] += + s[555];
gout[n*2187+1528] += + s[556];
gout[n*2187+1529] += + s[557];
gout[n*2187+1530] += + s[558];
gout[n*2187+1531] += + s[559];
gout[n*2187+1532] += + s[560];
gout[n*2187+1533] += + s[561];
gout[n*2187+1534] += + s[562];
gout[n*2187+1535] += + s[563];
gout[n*2187+1536] += + s[564];
gout[n*2187+1537] += + s[565];
gout[n*2187+1538] += + s[566];
gout[n*2187+1539] += + s[567];
gout[n*2187+1540] += + s[568];
gout[n*2187+1541] += + s[569];
gout[n*2187+1542] += + s[570];
gout[n*2187+1543] += + s[571];
gout[n*2187+1544] += + s[572];
gout[n*2187+1545] += + s[573];
gout[n*2187+1546] += + s[574];
gout[n*2187+1547] += + s[575];
gout[n*2187+1548] += + s[576];
gout[n*2187+1549] += + s[577];
gout[n*2187+1550] += + s[578];
gout[n*2187+1551] += + s[579];
gout[n*2187+1552] += + s[580];
gout[n*2187+1553] += + s[581];
gout[n*2187+1554] += + s[582];
gout[n*2187+1555] += + s[583];
gout[n*2187+1556] += + s[584];
gout[n*2187+1557] += + s[585];
gout[n*2187+1558] += + s[586];
gout[n*2187+1559] += + s[587];
gout[n*2187+1560] += + s[588];
gout[n*2187+1561] += + s[589];
gout[n*2187+1562] += + s[590];
gout[n*2187+1563] += + s[591];
gout[n*2187+1564] += + s[592];
gout[n*2187+1565] += + s[593];
gout[n*2187+1566] += + s[594];
gout[n*2187+1567] += + s[595];
gout[n*2187+1568] += + s[596];
gout[n*2187+1569] += + s[597];
gout[n*2187+1570] += + s[598];
gout[n*2187+1571] += + s[599];
gout[n*2187+1572] += + s[600];
gout[n*2187+1573] += + s[601];
gout[n*2187+1574] += + s[602];
gout[n*2187+1575] += + s[603];
gout[n*2187+1576] += + s[604];
gout[n*2187+1577] += + s[605];
gout[n*2187+1578] += + s[606];
gout[n*2187+1579] += + s[607];
gout[n*2187+1580] += + s[608];
gout[n*2187+1581] += + s[609];
gout[n*2187+1582] += + s[610];
gout[n*2187+1583] += + s[611];
gout[n*2187+1584] += + s[612];
gout[n*2187+1585] += + s[613];
gout[n*2187+1586] += + s[614];
gout[n*2187+1587] += + s[615];
gout[n*2187+1588] += + s[616];
gout[n*2187+1589] += + s[617];
gout[n*2187+1590] += + s[618];
gout[n*2187+1591] += + s[619];
gout[n*2187+1592] += + s[620];
gout[n*2187+1593] += + s[621];
gout[n*2187+1594] += + s[622];
gout[n*2187+1595] += + s[623];
gout[n*2187+1596] += + s[624];
gout[n*2187+1597] += + s[625];
gout[n*2187+1598] += + s[626];
gout[n*2187+1599] += + s[627];
gout[n*2187+1600] += + s[628];
gout[n*2187+1601] += + s[629];
gout[n*2187+1602] += + s[630];
gout[n*2187+1603] += + s[631];
gout[n*2187+1604] += + s[632];
gout[n*2187+1605] += + s[633];
gout[n*2187+1606] += + s[634];
gout[n*2187+1607] += + s[635];
gout[n*2187+1608] += + s[636];
gout[n*2187+1609] += + s[637];
gout[n*2187+1610] += + s[638];
gout[n*2187+1611] += + s[639];
gout[n*2187+1612] += + s[640];
gout[n*2187+1613] += + s[641];
gout[n*2187+1614] += + s[642];
gout[n*2187+1615] += + s[643];
gout[n*2187+1616] += + s[644];
gout[n*2187+1617] += + s[645];
gout[n*2187+1618] += + s[646];
gout[n*2187+1619] += + s[647];
gout[n*2187+1620] += + s[648];
gout[n*2187+1621] += + s[649];
gout[n*2187+1622] += + s[650];
gout[n*2187+1623] += + s[651];
gout[n*2187+1624] += + s[652];
gout[n*2187+1625] += + s[653];
gout[n*2187+1626] += + s[654];
gout[n*2187+1627] += + s[655];
gout[n*2187+1628] += + s[656];
gout[n*2187+1629] += + s[657];
gout[n*2187+1630] += + s[658];
gout[n*2187+1631] += + s[659];
gout[n*2187+1632] += + s[660];
gout[n*2187+1633] += + s[661];
gout[n*2187+1634] += + s[662];
gout[n*2187+1635] += + s[663];
gout[n*2187+1636] += + s[664];
gout[n*2187+1637] += + s[665];
gout[n*2187+1638] += + s[666];
gout[n*2187+1639] += + s[667];
gout[n*2187+1640] += + s[668];
gout[n*2187+1641] += + s[669];
gout[n*2187+1642] += + s[670];
gout[n*2187+1643] += + s[671];
gout[n*2187+1644] += + s[672];
gout[n*2187+1645] += + s[673];
gout[n*2187+1646] += + s[674];
gout[n*2187+1647] += + s[675];
gout[n*2187+1648] += + s[676];
gout[n*2187+1649] += + s[677];
gout[n*2187+1650] += + s[678];
gout[n*2187+1651] += + s[679];
gout[n*2187+1652] += + s[680];
gout[n*2187+1653] += + s[681];
gout[n*2187+1654] += + s[682];
gout[n*2187+1655] += + s[683];
gout[n*2187+1656] += + s[684];
gout[n*2187+1657] += + s[685];
gout[n*2187+1658] += + s[686];
gout[n*2187+1659] += + s[687];
gout[n*2187+1660] += + s[688];
gout[n*2187+1661] += + s[689];
gout[n*2187+1662] += + s[690];
gout[n*2187+1663] += + s[691];
gout[n*2187+1664] += + s[692];
gout[n*2187+1665] += + s[693];
gout[n*2187+1666] += + s[694];
gout[n*2187+1667] += + s[695];
gout[n*2187+1668] += + s[696];
gout[n*2187+1669] += + s[697];
gout[n*2187+1670] += + s[698];
gout[n*2187+1671] += + s[699];
gout[n*2187+1672] += + s[700];
gout[n*2187+1673] += + s[701];
gout[n*2187+1674] += + s[702];
gout[n*2187+1675] += + s[703];
gout[n*2187+1676] += + s[704];
gout[n*2187+1677] += + s[705];
gout[n*2187+1678] += + s[706];
gout[n*2187+1679] += + s[707];
gout[n*2187+1680] += + s[708];
gout[n*2187+1681] += + s[709];
gout[n*2187+1682] += + s[710];
gout[n*2187+1683] += + s[711];
gout[n*2187+1684] += + s[712];
gout[n*2187+1685] += + s[713];
gout[n*2187+1686] += + s[714];
gout[n*2187+1687] += + s[715];
gout[n*2187+1688] += + s[716];
gout[n*2187+1689] += + s[717];
gout[n*2187+1690] += + s[718];
gout[n*2187+1691] += + s[719];
gout[n*2187+1692] += + s[720];
gout[n*2187+1693] += + s[721];
gout[n*2187+1694] += + s[722];
gout[n*2187+1695] += + s[723];
gout[n*2187+1696] += + s[724];
gout[n*2187+1697] += + s[725];
gout[n*2187+1698] += + s[726];
gout[n*2187+1699] += + s[727];
gout[n*2187+1700] += + s[728];
gout[n*2187+1701] += + s[1215];
gout[n*2187+1702] += + s[1216];
gout[n*2187+1703] += + s[1217];
gout[n*2187+1704] += + s[1218];
gout[n*2187+1705] += + s[1219];
gout[n*2187+1706] += + s[1220];
gout[n*2187+1707] += + s[1221];
gout[n*2187+1708] += + s[1222];
gout[n*2187+1709] += + s[1223];
gout[n*2187+1710] += + s[1224];
gout[n*2187+1711] += + s[1225];
gout[n*2187+1712] += + s[1226];
gout[n*2187+1713] += + s[1227];
gout[n*2187+1714] += + s[1228];
gout[n*2187+1715] += + s[1229];
gout[n*2187+1716] += + s[1230];
gout[n*2187+1717] += + s[1231];
gout[n*2187+1718] += + s[1232];
gout[n*2187+1719] += + s[1233];
gout[n*2187+1720] += + s[1234];
gout[n*2187+1721] += + s[1235];
gout[n*2187+1722] += + s[1236];
gout[n*2187+1723] += + s[1237];
gout[n*2187+1724] += + s[1238];
gout[n*2187+1725] += + s[1239];
gout[n*2187+1726] += + s[1240];
gout[n*2187+1727] += + s[1241];
gout[n*2187+1728] += + s[1242];
gout[n*2187+1729] += + s[1243];
gout[n*2187+1730] += + s[1244];
gout[n*2187+1731] += + s[1245];
gout[n*2187+1732] += + s[1246];
gout[n*2187+1733] += + s[1247];
gout[n*2187+1734] += + s[1248];
gout[n*2187+1735] += + s[1249];
gout[n*2187+1736] += + s[1250];
gout[n*2187+1737] += + s[1251];
gout[n*2187+1738] += + s[1252];
gout[n*2187+1739] += + s[1253];
gout[n*2187+1740] += + s[1254];
gout[n*2187+1741] += + s[1255];
gout[n*2187+1742] += + s[1256];
gout[n*2187+1743] += + s[1257];
gout[n*2187+1744] += + s[1258];
gout[n*2187+1745] += + s[1259];
gout[n*2187+1746] += + s[1260];
gout[n*2187+1747] += + s[1261];
gout[n*2187+1748] += + s[1262];
gout[n*2187+1749] += + s[1263];
gout[n*2187+1750] += + s[1264];
gout[n*2187+1751] += + s[1265];
gout[n*2187+1752] += + s[1266];
gout[n*2187+1753] += + s[1267];
gout[n*2187+1754] += + s[1268];
gout[n*2187+1755] += + s[1269];
gout[n*2187+1756] += + s[1270];
gout[n*2187+1757] += + s[1271];
gout[n*2187+1758] += + s[1272];
gout[n*2187+1759] += + s[1273];
gout[n*2187+1760] += + s[1274];
gout[n*2187+1761] += + s[1275];
gout[n*2187+1762] += + s[1276];
gout[n*2187+1763] += + s[1277];
gout[n*2187+1764] += + s[1278];
gout[n*2187+1765] += + s[1279];
gout[n*2187+1766] += + s[1280];
gout[n*2187+1767] += + s[1281];
gout[n*2187+1768] += + s[1282];
gout[n*2187+1769] += + s[1283];
gout[n*2187+1770] += + s[1284];
gout[n*2187+1771] += + s[1285];
gout[n*2187+1772] += + s[1286];
gout[n*2187+1773] += + s[1287];
gout[n*2187+1774] += + s[1288];
gout[n*2187+1775] += + s[1289];
gout[n*2187+1776] += + s[1290];
gout[n*2187+1777] += + s[1291];
gout[n*2187+1778] += + s[1292];
gout[n*2187+1779] += + s[1293];
gout[n*2187+1780] += + s[1294];
gout[n*2187+1781] += + s[1295];
gout[n*2187+1782] += + s[1296];
gout[n*2187+1783] += + s[1297];
gout[n*2187+1784] += + s[1298];
gout[n*2187+1785] += + s[1299];
gout[n*2187+1786] += + s[1300];
gout[n*2187+1787] += + s[1301];
gout[n*2187+1788] += + s[1302];
gout[n*2187+1789] += + s[1303];
gout[n*2187+1790] += + s[1304];
gout[n*2187+1791] += + s[1305];
gout[n*2187+1792] += + s[1306];
gout[n*2187+1793] += + s[1307];
gout[n*2187+1794] += + s[1308];
gout[n*2187+1795] += + s[1309];
gout[n*2187+1796] += + s[1310];
gout[n*2187+1797] += + s[1311];
gout[n*2187+1798] += + s[1312];
gout[n*2187+1799] += + s[1313];
gout[n*2187+1800] += + s[1314];
gout[n*2187+1801] += + s[1315];
gout[n*2187+1802] += + s[1316];
gout[n*2187+1803] += + s[1317];
gout[n*2187+1804] += + s[1318];
gout[n*2187+1805] += + s[1319];
gout[n*2187+1806] += + s[1320];
gout[n*2187+1807] += + s[1321];
gout[n*2187+1808] += + s[1322];
gout[n*2187+1809] += + s[1323];
gout[n*2187+1810] += + s[1324];
gout[n*2187+1811] += + s[1325];
gout[n*2187+1812] += + s[1326];
gout[n*2187+1813] += + s[1327];
gout[n*2187+1814] += + s[1328];
gout[n*2187+1815] += + s[1329];
gout[n*2187+1816] += + s[1330];
gout[n*2187+1817] += + s[1331];
gout[n*2187+1818] += + s[1332];
gout[n*2187+1819] += + s[1333];
gout[n*2187+1820] += + s[1334];
gout[n*2187+1821] += + s[1335];
gout[n*2187+1822] += + s[1336];
gout[n*2187+1823] += + s[1337];
gout[n*2187+1824] += + s[1338];
gout[n*2187+1825] += + s[1339];
gout[n*2187+1826] += + s[1340];
gout[n*2187+1827] += + s[1341];
gout[n*2187+1828] += + s[1342];
gout[n*2187+1829] += + s[1343];
gout[n*2187+1830] += + s[1344];
gout[n*2187+1831] += + s[1345];
gout[n*2187+1832] += + s[1346];
gout[n*2187+1833] += + s[1347];
gout[n*2187+1834] += + s[1348];
gout[n*2187+1835] += + s[1349];
gout[n*2187+1836] += + s[1350];
gout[n*2187+1837] += + s[1351];
gout[n*2187+1838] += + s[1352];
gout[n*2187+1839] += + s[1353];
gout[n*2187+1840] += + s[1354];
gout[n*2187+1841] += + s[1355];
gout[n*2187+1842] += + s[1356];
gout[n*2187+1843] += + s[1357];
gout[n*2187+1844] += + s[1358];
gout[n*2187+1845] += + s[1359];
gout[n*2187+1846] += + s[1360];
gout[n*2187+1847] += + s[1361];
gout[n*2187+1848] += + s[1362];
gout[n*2187+1849] += + s[1363];
gout[n*2187+1850] += + s[1364];
gout[n*2187+1851] += + s[1365];
gout[n*2187+1852] += + s[1366];
gout[n*2187+1853] += + s[1367];
gout[n*2187+1854] += + s[1368];
gout[n*2187+1855] += + s[1369];
gout[n*2187+1856] += + s[1370];
gout[n*2187+1857] += + s[1371];
gout[n*2187+1858] += + s[1372];
gout[n*2187+1859] += + s[1373];
gout[n*2187+1860] += + s[1374];
gout[n*2187+1861] += + s[1375];
gout[n*2187+1862] += + s[1376];
gout[n*2187+1863] += + s[1377];
gout[n*2187+1864] += + s[1378];
gout[n*2187+1865] += + s[1379];
gout[n*2187+1866] += + s[1380];
gout[n*2187+1867] += + s[1381];
gout[n*2187+1868] += + s[1382];
gout[n*2187+1869] += + s[1383];
gout[n*2187+1870] += + s[1384];
gout[n*2187+1871] += + s[1385];
gout[n*2187+1872] += + s[1386];
gout[n*2187+1873] += + s[1387];
gout[n*2187+1874] += + s[1388];
gout[n*2187+1875] += + s[1389];
gout[n*2187+1876] += + s[1390];
gout[n*2187+1877] += + s[1391];
gout[n*2187+1878] += + s[1392];
gout[n*2187+1879] += + s[1393];
gout[n*2187+1880] += + s[1394];
gout[n*2187+1881] += + s[1395];
gout[n*2187+1882] += + s[1396];
gout[n*2187+1883] += + s[1397];
gout[n*2187+1884] += + s[1398];
gout[n*2187+1885] += + s[1399];
gout[n*2187+1886] += + s[1400];
gout[n*2187+1887] += + s[1401];
gout[n*2187+1888] += + s[1402];
gout[n*2187+1889] += + s[1403];
gout[n*2187+1890] += + s[1404];
gout[n*2187+1891] += + s[1405];
gout[n*2187+1892] += + s[1406];
gout[n*2187+1893] += + s[1407];
gout[n*2187+1894] += + s[1408];
gout[n*2187+1895] += + s[1409];
gout[n*2187+1896] += + s[1410];
gout[n*2187+1897] += + s[1411];
gout[n*2187+1898] += + s[1412];
gout[n*2187+1899] += + s[1413];
gout[n*2187+1900] += + s[1414];
gout[n*2187+1901] += + s[1415];
gout[n*2187+1902] += + s[1416];
gout[n*2187+1903] += + s[1417];
gout[n*2187+1904] += + s[1418];
gout[n*2187+1905] += + s[1419];
gout[n*2187+1906] += + s[1420];
gout[n*2187+1907] += + s[1421];
gout[n*2187+1908] += + s[1422];
gout[n*2187+1909] += + s[1423];
gout[n*2187+1910] += + s[1424];
gout[n*2187+1911] += + s[1425];
gout[n*2187+1912] += + s[1426];
gout[n*2187+1913] += + s[1427];
gout[n*2187+1914] += + s[1428];
gout[n*2187+1915] += + s[1429];
gout[n*2187+1916] += + s[1430];
gout[n*2187+1917] += + s[1431];
gout[n*2187+1918] += + s[1432];
gout[n*2187+1919] += + s[1433];
gout[n*2187+1920] += + s[1434];
gout[n*2187+1921] += + s[1435];
gout[n*2187+1922] += + s[1436];
gout[n*2187+1923] += + s[1437];
gout[n*2187+1924] += + s[1438];
gout[n*2187+1925] += + s[1439];
gout[n*2187+1926] += + s[1440];
gout[n*2187+1927] += + s[1441];
gout[n*2187+1928] += + s[1442];
gout[n*2187+1929] += + s[1443];
gout[n*2187+1930] += + s[1444];
gout[n*2187+1931] += + s[1445];
gout[n*2187+1932] += + s[1446];
gout[n*2187+1933] += + s[1447];
gout[n*2187+1934] += + s[1448];
gout[n*2187+1935] += + s[1449];
gout[n*2187+1936] += + s[1450];
gout[n*2187+1937] += + s[1451];
gout[n*2187+1938] += + s[1452];
gout[n*2187+1939] += + s[1453];
gout[n*2187+1940] += + s[1454];
gout[n*2187+1941] += + s[1455];
gout[n*2187+1942] += + s[1456];
gout[n*2187+1943] += + s[1457];
gout[n*2187+1944] += + s[1944];
gout[n*2187+1945] += + s[1945];
gout[n*2187+1946] += + s[1946];
gout[n*2187+1947] += + s[1947];
gout[n*2187+1948] += + s[1948];
gout[n*2187+1949] += + s[1949];
gout[n*2187+1950] += + s[1950];
gout[n*2187+1951] += + s[1951];
gout[n*2187+1952] += + s[1952];
gout[n*2187+1953] += + s[1953];
gout[n*2187+1954] += + s[1954];
gout[n*2187+1955] += + s[1955];
gout[n*2187+1956] += + s[1956];
gout[n*2187+1957] += + s[1957];
gout[n*2187+1958] += + s[1958];
gout[n*2187+1959] += + s[1959];
gout[n*2187+1960] += + s[1960];
gout[n*2187+1961] += + s[1961];
gout[n*2187+1962] += + s[1962];
gout[n*2187+1963] += + s[1963];
gout[n*2187+1964] += + s[1964];
gout[n*2187+1965] += + s[1965];
gout[n*2187+1966] += + s[1966];
gout[n*2187+1967] += + s[1967];
gout[n*2187+1968] += + s[1968];
gout[n*2187+1969] += + s[1969];
gout[n*2187+1970] += + s[1970];
gout[n*2187+1971] += + s[1971];
gout[n*2187+1972] += + s[1972];
gout[n*2187+1973] += + s[1973];
gout[n*2187+1974] += + s[1974];
gout[n*2187+1975] += + s[1975];
gout[n*2187+1976] += + s[1976];
gout[n*2187+1977] += + s[1977];
gout[n*2187+1978] += + s[1978];
gout[n*2187+1979] += + s[1979];
gout[n*2187+1980] += + s[1980];
gout[n*2187+1981] += + s[1981];
gout[n*2187+1982] += + s[1982];
gout[n*2187+1983] += + s[1983];
gout[n*2187+1984] += + s[1984];
gout[n*2187+1985] += + s[1985];
gout[n*2187+1986] += + s[1986];
gout[n*2187+1987] += + s[1987];
gout[n*2187+1988] += + s[1988];
gout[n*2187+1989] += + s[1989];
gout[n*2187+1990] += + s[1990];
gout[n*2187+1991] += + s[1991];
gout[n*2187+1992] += + s[1992];
gout[n*2187+1993] += + s[1993];
gout[n*2187+1994] += + s[1994];
gout[n*2187+1995] += + s[1995];
gout[n*2187+1996] += + s[1996];
gout[n*2187+1997] += + s[1997];
gout[n*2187+1998] += + s[1998];
gout[n*2187+1999] += + s[1999];
gout[n*2187+2000] += + s[2000];
gout[n*2187+2001] += + s[2001];
gout[n*2187+2002] += + s[2002];
gout[n*2187+2003] += + s[2003];
gout[n*2187+2004] += + s[2004];
gout[n*2187+2005] += + s[2005];
gout[n*2187+2006] += + s[2006];
gout[n*2187+2007] += + s[2007];
gout[n*2187+2008] += + s[2008];
gout[n*2187+2009] += + s[2009];
gout[n*2187+2010] += + s[2010];
gout[n*2187+2011] += + s[2011];
gout[n*2187+2012] += + s[2012];
gout[n*2187+2013] += + s[2013];
gout[n*2187+2014] += + s[2014];
gout[n*2187+2015] += + s[2015];
gout[n*2187+2016] += + s[2016];
gout[n*2187+2017] += + s[2017];
gout[n*2187+2018] += + s[2018];
gout[n*2187+2019] += + s[2019];
gout[n*2187+2020] += + s[2020];
gout[n*2187+2021] += + s[2021];
gout[n*2187+2022] += + s[2022];
gout[n*2187+2023] += + s[2023];
gout[n*2187+2024] += + s[2024];
gout[n*2187+2025] += + s[2025];
gout[n*2187+2026] += + s[2026];
gout[n*2187+2027] += + s[2027];
gout[n*2187+2028] += + s[2028];
gout[n*2187+2029] += + s[2029];
gout[n*2187+2030] += + s[2030];
gout[n*2187+2031] += + s[2031];
gout[n*2187+2032] += + s[2032];
gout[n*2187+2033] += + s[2033];
gout[n*2187+2034] += + s[2034];
gout[n*2187+2035] += + s[2035];
gout[n*2187+2036] += + s[2036];
gout[n*2187+2037] += + s[2037];
gout[n*2187+2038] += + s[2038];
gout[n*2187+2039] += + s[2039];
gout[n*2187+2040] += + s[2040];
gout[n*2187+2041] += + s[2041];
gout[n*2187+2042] += + s[2042];
gout[n*2187+2043] += + s[2043];
gout[n*2187+2044] += + s[2044];
gout[n*2187+2045] += + s[2045];
gout[n*2187+2046] += + s[2046];
gout[n*2187+2047] += + s[2047];
gout[n*2187+2048] += + s[2048];
gout[n*2187+2049] += + s[2049];
gout[n*2187+2050] += + s[2050];
gout[n*2187+2051] += + s[2051];
gout[n*2187+2052] += + s[2052];
gout[n*2187+2053] += + s[2053];
gout[n*2187+2054] += + s[2054];
gout[n*2187+2055] += + s[2055];
gout[n*2187+2056] += + s[2056];
gout[n*2187+2057] += + s[2057];
gout[n*2187+2058] += + s[2058];
gout[n*2187+2059] += + s[2059];
gout[n*2187+2060] += + s[2060];
gout[n*2187+2061] += + s[2061];
gout[n*2187+2062] += + s[2062];
gout[n*2187+2063] += + s[2063];
gout[n*2187+2064] += + s[2064];
gout[n*2187+2065] += + s[2065];
gout[n*2187+2066] += + s[2066];
gout[n*2187+2067] += + s[2067];
gout[n*2187+2068] += + s[2068];
gout[n*2187+2069] += + s[2069];
gout[n*2187+2070] += + s[2070];
gout[n*2187+2071] += + s[2071];
gout[n*2187+2072] += + s[2072];
gout[n*2187+2073] += + s[2073];
gout[n*2187+2074] += + s[2074];
gout[n*2187+2075] += + s[2075];
gout[n*2187+2076] += + s[2076];
gout[n*2187+2077] += + s[2077];
gout[n*2187+2078] += + s[2078];
gout[n*2187+2079] += + s[2079];
gout[n*2187+2080] += + s[2080];
gout[n*2187+2081] += + s[2081];
gout[n*2187+2082] += + s[2082];
gout[n*2187+2083] += + s[2083];
gout[n*2187+2084] += + s[2084];
gout[n*2187+2085] += + s[2085];
gout[n*2187+2086] += + s[2086];
gout[n*2187+2087] += + s[2087];
gout[n*2187+2088] += + s[2088];
gout[n*2187+2089] += + s[2089];
gout[n*2187+2090] += + s[2090];
gout[n*2187+2091] += + s[2091];
gout[n*2187+2092] += + s[2092];
gout[n*2187+2093] += + s[2093];
gout[n*2187+2094] += + s[2094];
gout[n*2187+2095] += + s[2095];
gout[n*2187+2096] += + s[2096];
gout[n*2187+2097] += + s[2097];
gout[n*2187+2098] += + s[2098];
gout[n*2187+2099] += + s[2099];
gout[n*2187+2100] += + s[2100];
gout[n*2187+2101] += + s[2101];
gout[n*2187+2102] += + s[2102];
gout[n*2187+2103] += + s[2103];
gout[n*2187+2104] += + s[2104];
gout[n*2187+2105] += + s[2105];
gout[n*2187+2106] += + s[2106];
gout[n*2187+2107] += + s[2107];
gout[n*2187+2108] += + s[2108];
gout[n*2187+2109] += + s[2109];
gout[n*2187+2110] += + s[2110];
gout[n*2187+2111] += + s[2111];
gout[n*2187+2112] += + s[2112];
gout[n*2187+2113] += + s[2113];
gout[n*2187+2114] += + s[2114];
gout[n*2187+2115] += + s[2115];
gout[n*2187+2116] += + s[2116];
gout[n*2187+2117] += + s[2117];
gout[n*2187+2118] += + s[2118];
gout[n*2187+2119] += + s[2119];
gout[n*2187+2120] += + s[2120];
gout[n*2187+2121] += + s[2121];
gout[n*2187+2122] += + s[2122];
gout[n*2187+2123] += + s[2123];
gout[n*2187+2124] += + s[2124];
gout[n*2187+2125] += + s[2125];
gout[n*2187+2126] += + s[2126];
gout[n*2187+2127] += + s[2127];
gout[n*2187+2128] += + s[2128];
gout[n*2187+2129] += + s[2129];
gout[n*2187+2130] += + s[2130];
gout[n*2187+2131] += + s[2131];
gout[n*2187+2132] += + s[2132];
gout[n*2187+2133] += + s[2133];
gout[n*2187+2134] += + s[2134];
gout[n*2187+2135] += + s[2135];
gout[n*2187+2136] += + s[2136];
gout[n*2187+2137] += + s[2137];
gout[n*2187+2138] += + s[2138];
gout[n*2187+2139] += + s[2139];
gout[n*2187+2140] += + s[2140];
gout[n*2187+2141] += + s[2141];
gout[n*2187+2142] += + s[2142];
gout[n*2187+2143] += + s[2143];
gout[n*2187+2144] += + s[2144];
gout[n*2187+2145] += + s[2145];
gout[n*2187+2146] += + s[2146];
gout[n*2187+2147] += + s[2147];
gout[n*2187+2148] += + s[2148];
gout[n*2187+2149] += + s[2149];
gout[n*2187+2150] += + s[2150];
gout[n*2187+2151] += + s[2151];
gout[n*2187+2152] += + s[2152];
gout[n*2187+2153] += + s[2153];
gout[n*2187+2154] += + s[2154];
gout[n*2187+2155] += + s[2155];
gout[n*2187+2156] += + s[2156];
gout[n*2187+2157] += + s[2157];
gout[n*2187+2158] += + s[2158];
gout[n*2187+2159] += + s[2159];
gout[n*2187+2160] += + s[2160];
gout[n*2187+2161] += + s[2161];
gout[n*2187+2162] += + s[2162];
gout[n*2187+2163] += + s[2163];
gout[n*2187+2164] += + s[2164];
gout[n*2187+2165] += + s[2165];
gout[n*2187+2166] += + s[2166];
gout[n*2187+2167] += + s[2167];
gout[n*2187+2168] += + s[2168];
gout[n*2187+2169] += + s[2169];
gout[n*2187+2170] += + s[2170];
gout[n*2187+2171] += + s[2171];
gout[n*2187+2172] += + s[2172];
gout[n*2187+2173] += + s[2173];
gout[n*2187+2174] += + s[2174];
gout[n*2187+2175] += + s[2175];
gout[n*2187+2176] += + s[2176];
gout[n*2187+2177] += + s[2177];
gout[n*2187+2178] += + s[2178];
gout[n*2187+2179] += + s[2179];
gout[n*2187+2180] += + s[2180];
gout[n*2187+2181] += + s[2181];
gout[n*2187+2182] += + s[2182];
gout[n*2187+2183] += + s[2183];
gout[n*2187+2184] += + s[2184];
gout[n*2187+2185] += + s[2185];
gout[n*2187+2186] += + s[2186];
}}}
void int1e_ipipmmmipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 2187};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipmmmipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipmmmipip_cart
CACHE_SIZE_T int1e_ipipmmmipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmmipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipmmmipip_sph
CACHE_SIZE_T int1e_ipipmmmipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipmmmipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipmmmipip_spinor
ALL_CINT1E(int1e_ipipmmmipip)
ALL_CINT1E_FORTRAN_(int1e_ipipmmmipip)
/* <i|RJ |j> */
void CINTgout1e_int1e_n(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[3];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[0];
gout[n*3+1] = + s[1];
gout[n*3+2] = + s[2];
} else {
gout[n*3+0] += + s[0];
gout[n*3+1] += + s[1];
gout[n*3+2] += + s[2];
}}}
void int1e_n_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_n_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_n;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_n_cart
CACHE_SIZE_T int1e_n_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_n;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_n_sph
CACHE_SIZE_T int1e_n_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_n;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_n_spinor
ALL_CINT1E(int1e_n)
ALL_CINT1E_FORTRAN_(int1e_n)
/* <i|RJ RJ |j> */
void CINTgout1e_int1e_nn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[9];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_nn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nn_cart
CACHE_SIZE_T int1e_nn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nn_sph
CACHE_SIZE_T int1e_nn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nn_spinor
ALL_CINT1E(int1e_nn)
ALL_CINT1E_FORTRAN_(int1e_nn)
/* <i|RJ RJ RJ |j> */
void CINTgout1e_int1e_nnn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[27];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_nnn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nnn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nnn_cart
CACHE_SIZE_T int1e_nnn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nnn_sph
CACHE_SIZE_T int1e_nnn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nnn_spinor
ALL_CINT1E(int1e_nnn)
ALL_CINT1E_FORTRAN_(int1e_nnn)
/* <i|RJ DOT RJ |j> */
void CINTgout1e_int1e_n2(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[9];
G1E_RCJ(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + s[4] + s[8];
} else {
gout[n*1+0] += + s[0] + s[4] + s[8];
}}}
void int1e_n2_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_n2_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_n2;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_n2_cart
CACHE_SIZE_T int1e_n2_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_n2;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_n2_sph
CACHE_SIZE_T int1e_n2_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_n2;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_n2_spinor
ALL_CINT1E(int1e_n2)
ALL_CINT1E_FORTRAN_(int1e_n2)
/* <i|OVLP |RJ DOT RJ RJ DOT R j> */
void CINTgout1e_int1e_n4(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_R_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_R_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_R_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_R_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*1+0] = + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
} else {
gout[n*1+0] += + s[0] + 2*s[4] + 2*s[8] + s[40] + 2*s[44] + s[80];
}}}
void int1e_n4_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_n4_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_n4;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_n4_cart
CACHE_SIZE_T int1e_n4_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_n4;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_n4_sph
CACHE_SIZE_T int1e_n4_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_n4;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_n4_spinor
ALL_CINT1E(int1e_n4)
ALL_CINT1E_FORTRAN_(int1e_n4)
/* <NABLA i|RJ |j> */
void CINTgout1e_int1e_ipn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[9];
G1E_RCJ(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_ipn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipn_cart
CACHE_SIZE_T int1e_ipn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipn_sph
CACHE_SIZE_T int1e_ipn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipn_spinor
ALL_CINT1E(int1e_ipn)
ALL_CINT1E_FORTRAN_(int1e_ipn)
/* <NABLA NABLA i|RJ |j> */
void CINTgout1e_int1e_ipipn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[27];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[9];
gout[n*27+4] = + s[10];
gout[n*27+5] = + s[11];
gout[n*27+6] = + s[18];
gout[n*27+7] = + s[19];
gout[n*27+8] = + s[20];
gout[n*27+9] = + s[3];
gout[n*27+10] = + s[4];
gout[n*27+11] = + s[5];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[21];
gout[n*27+16] = + s[22];
gout[n*27+17] = + s[23];
gout[n*27+18] = + s[6];
gout[n*27+19] = + s[7];
gout[n*27+20] = + s[8];
gout[n*27+21] = + s[15];
gout[n*27+22] = + s[16];
gout[n*27+23] = + s[17];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[9];
gout[n*27+4] += + s[10];
gout[n*27+5] += + s[11];
gout[n*27+6] += + s[18];
gout[n*27+7] += + s[19];
gout[n*27+8] += + s[20];
gout[n*27+9] += + s[3];
gout[n*27+10] += + s[4];
gout[n*27+11] += + s[5];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[21];
gout[n*27+16] += + s[22];
gout[n*27+17] += + s[23];
gout[n*27+18] += + s[6];
gout[n*27+19] += + s[7];
gout[n*27+20] += + s[8];
gout[n*27+21] += + s[15];
gout[n*27+22] += + s[16];
gout[n*27+23] += + s[17];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_ipipn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipn_cart
CACHE_SIZE_T int1e_ipipn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipn_sph
CACHE_SIZE_T int1e_ipipn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 1, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipn_spinor
ALL_CINT1E(int1e_ipipn)
ALL_CINT1E_FORTRAN_(int1e_ipipn)
/* <NABLA NABLA NABLA i|RJ |j> */
void CINTgout1e_int1e_ipipipn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_RCJ(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[27];
gout[n*81+4] = + s[28];
gout[n*81+5] = + s[29];
gout[n*81+6] = + s[54];
gout[n*81+7] = + s[55];
gout[n*81+8] = + s[56];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[36];
gout[n*81+13] = + s[37];
gout[n*81+14] = + s[38];
gout[n*81+15] = + s[63];
gout[n*81+16] = + s[64];
gout[n*81+17] = + s[65];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[45];
gout[n*81+22] = + s[46];
gout[n*81+23] = + s[47];
gout[n*81+24] = + s[72];
gout[n*81+25] = + s[73];
gout[n*81+26] = + s[74];
gout[n*81+27] = + s[3];
gout[n*81+28] = + s[4];
gout[n*81+29] = + s[5];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[57];
gout[n*81+34] = + s[58];
gout[n*81+35] = + s[59];
gout[n*81+36] = + s[12];
gout[n*81+37] = + s[13];
gout[n*81+38] = + s[14];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[66];
gout[n*81+43] = + s[67];
gout[n*81+44] = + s[68];
gout[n*81+45] = + s[21];
gout[n*81+46] = + s[22];
gout[n*81+47] = + s[23];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[75];
gout[n*81+52] = + s[76];
gout[n*81+53] = + s[77];
gout[n*81+54] = + s[6];
gout[n*81+55] = + s[7];
gout[n*81+56] = + s[8];
gout[n*81+57] = + s[33];
gout[n*81+58] = + s[34];
gout[n*81+59] = + s[35];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[15];
gout[n*81+64] = + s[16];
gout[n*81+65] = + s[17];
gout[n*81+66] = + s[42];
gout[n*81+67] = + s[43];
gout[n*81+68] = + s[44];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[24];
gout[n*81+73] = + s[25];
gout[n*81+74] = + s[26];
gout[n*81+75] = + s[51];
gout[n*81+76] = + s[52];
gout[n*81+77] = + s[53];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[27];
gout[n*81+4] += + s[28];
gout[n*81+5] += + s[29];
gout[n*81+6] += + s[54];
gout[n*81+7] += + s[55];
gout[n*81+8] += + s[56];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[36];
gout[n*81+13] += + s[37];
gout[n*81+14] += + s[38];
gout[n*81+15] += + s[63];
gout[n*81+16] += + s[64];
gout[n*81+17] += + s[65];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[45];
gout[n*81+22] += + s[46];
gout[n*81+23] += + s[47];
gout[n*81+24] += + s[72];
gout[n*81+25] += + s[73];
gout[n*81+26] += + s[74];
gout[n*81+27] += + s[3];
gout[n*81+28] += + s[4];
gout[n*81+29] += + s[5];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[57];
gout[n*81+34] += + s[58];
gout[n*81+35] += + s[59];
gout[n*81+36] += + s[12];
gout[n*81+37] += + s[13];
gout[n*81+38] += + s[14];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[66];
gout[n*81+43] += + s[67];
gout[n*81+44] += + s[68];
gout[n*81+45] += + s[21];
gout[n*81+46] += + s[22];
gout[n*81+47] += + s[23];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[75];
gout[n*81+52] += + s[76];
gout[n*81+53] += + s[77];
gout[n*81+54] += + s[6];
gout[n*81+55] += + s[7];
gout[n*81+56] += + s[8];
gout[n*81+57] += + s[33];
gout[n*81+58] += + s[34];
gout[n*81+59] += + s[35];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[15];
gout[n*81+64] += + s[16];
gout[n*81+65] += + s[17];
gout[n*81+66] += + s[42];
gout[n*81+67] += + s[43];
gout[n*81+68] += + s[44];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[24];
gout[n*81+73] += + s[25];
gout[n*81+74] += + s[26];
gout[n*81+75] += + s[51];
gout[n*81+76] += + s[52];
gout[n*81+77] += + s[53];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipipipn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 1, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 1, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipn_cart
CACHE_SIZE_T int1e_ipipipn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 1, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipn_sph
CACHE_SIZE_T int1e_ipipipn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 1, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipn_spinor
ALL_CINT1E(int1e_ipipipn)
ALL_CINT1E_FORTRAN_(int1e_ipipipn)
/* <NABLA NABLA NABLA NABLA i|RJ |j> */
void CINTgout1e_int1e_ipipipipn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_RCJ(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g4, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[81];
gout[n*243+4] = + s[82];
gout[n*243+5] = + s[83];
gout[n*243+6] = + s[162];
gout[n*243+7] = + s[163];
gout[n*243+8] = + s[164];
gout[n*243+9] = + s[27];
gout[n*243+10] = + s[28];
gout[n*243+11] = + s[29];
gout[n*243+12] = + s[108];
gout[n*243+13] = + s[109];
gout[n*243+14] = + s[110];
gout[n*243+15] = + s[189];
gout[n*243+16] = + s[190];
gout[n*243+17] = + s[191];
gout[n*243+18] = + s[54];
gout[n*243+19] = + s[55];
gout[n*243+20] = + s[56];
gout[n*243+21] = + s[135];
gout[n*243+22] = + s[136];
gout[n*243+23] = + s[137];
gout[n*243+24] = + s[216];
gout[n*243+25] = + s[217];
gout[n*243+26] = + s[218];
gout[n*243+27] = + s[9];
gout[n*243+28] = + s[10];
gout[n*243+29] = + s[11];
gout[n*243+30] = + s[90];
gout[n*243+31] = + s[91];
gout[n*243+32] = + s[92];
gout[n*243+33] = + s[171];
gout[n*243+34] = + s[172];
gout[n*243+35] = + s[173];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[117];
gout[n*243+40] = + s[118];
gout[n*243+41] = + s[119];
gout[n*243+42] = + s[198];
gout[n*243+43] = + s[199];
gout[n*243+44] = + s[200];
gout[n*243+45] = + s[63];
gout[n*243+46] = + s[64];
gout[n*243+47] = + s[65];
gout[n*243+48] = + s[144];
gout[n*243+49] = + s[145];
gout[n*243+50] = + s[146];
gout[n*243+51] = + s[225];
gout[n*243+52] = + s[226];
gout[n*243+53] = + s[227];
gout[n*243+54] = + s[18];
gout[n*243+55] = + s[19];
gout[n*243+56] = + s[20];
gout[n*243+57] = + s[99];
gout[n*243+58] = + s[100];
gout[n*243+59] = + s[101];
gout[n*243+60] = + s[180];
gout[n*243+61] = + s[181];
gout[n*243+62] = + s[182];
gout[n*243+63] = + s[45];
gout[n*243+64] = + s[46];
gout[n*243+65] = + s[47];
gout[n*243+66] = + s[126];
gout[n*243+67] = + s[127];
gout[n*243+68] = + s[128];
gout[n*243+69] = + s[207];
gout[n*243+70] = + s[208];
gout[n*243+71] = + s[209];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[153];
gout[n*243+76] = + s[154];
gout[n*243+77] = + s[155];
gout[n*243+78] = + s[234];
gout[n*243+79] = + s[235];
gout[n*243+80] = + s[236];
gout[n*243+81] = + s[3];
gout[n*243+82] = + s[4];
gout[n*243+83] = + s[5];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[165];
gout[n*243+88] = + s[166];
gout[n*243+89] = + s[167];
gout[n*243+90] = + s[30];
gout[n*243+91] = + s[31];
gout[n*243+92] = + s[32];
gout[n*243+93] = + s[111];
gout[n*243+94] = + s[112];
gout[n*243+95] = + s[113];
gout[n*243+96] = + s[192];
gout[n*243+97] = + s[193];
gout[n*243+98] = + s[194];
gout[n*243+99] = + s[57];
gout[n*243+100] = + s[58];
gout[n*243+101] = + s[59];
gout[n*243+102] = + s[138];
gout[n*243+103] = + s[139];
gout[n*243+104] = + s[140];
gout[n*243+105] = + s[219];
gout[n*243+106] = + s[220];
gout[n*243+107] = + s[221];
gout[n*243+108] = + s[12];
gout[n*243+109] = + s[13];
gout[n*243+110] = + s[14];
gout[n*243+111] = + s[93];
gout[n*243+112] = + s[94];
gout[n*243+113] = + s[95];
gout[n*243+114] = + s[174];
gout[n*243+115] = + s[175];
gout[n*243+116] = + s[176];
gout[n*243+117] = + s[39];
gout[n*243+118] = + s[40];
gout[n*243+119] = + s[41];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[201];
gout[n*243+124] = + s[202];
gout[n*243+125] = + s[203];
gout[n*243+126] = + s[66];
gout[n*243+127] = + s[67];
gout[n*243+128] = + s[68];
gout[n*243+129] = + s[147];
gout[n*243+130] = + s[148];
gout[n*243+131] = + s[149];
gout[n*243+132] = + s[228];
gout[n*243+133] = + s[229];
gout[n*243+134] = + s[230];
gout[n*243+135] = + s[21];
gout[n*243+136] = + s[22];
gout[n*243+137] = + s[23];
gout[n*243+138] = + s[102];
gout[n*243+139] = + s[103];
gout[n*243+140] = + s[104];
gout[n*243+141] = + s[183];
gout[n*243+142] = + s[184];
gout[n*243+143] = + s[185];
gout[n*243+144] = + s[48];
gout[n*243+145] = + s[49];
gout[n*243+146] = + s[50];
gout[n*243+147] = + s[129];
gout[n*243+148] = + s[130];
gout[n*243+149] = + s[131];
gout[n*243+150] = + s[210];
gout[n*243+151] = + s[211];
gout[n*243+152] = + s[212];
gout[n*243+153] = + s[75];
gout[n*243+154] = + s[76];
gout[n*243+155] = + s[77];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[237];
gout[n*243+160] = + s[238];
gout[n*243+161] = + s[239];
gout[n*243+162] = + s[6];
gout[n*243+163] = + s[7];
gout[n*243+164] = + s[8];
gout[n*243+165] = + s[87];
gout[n*243+166] = + s[88];
gout[n*243+167] = + s[89];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[33];
gout[n*243+172] = + s[34];
gout[n*243+173] = + s[35];
gout[n*243+174] = + s[114];
gout[n*243+175] = + s[115];
gout[n*243+176] = + s[116];
gout[n*243+177] = + s[195];
gout[n*243+178] = + s[196];
gout[n*243+179] = + s[197];
gout[n*243+180] = + s[60];
gout[n*243+181] = + s[61];
gout[n*243+182] = + s[62];
gout[n*243+183] = + s[141];
gout[n*243+184] = + s[142];
gout[n*243+185] = + s[143];
gout[n*243+186] = + s[222];
gout[n*243+187] = + s[223];
gout[n*243+188] = + s[224];
gout[n*243+189] = + s[15];
gout[n*243+190] = + s[16];
gout[n*243+191] = + s[17];
gout[n*243+192] = + s[96];
gout[n*243+193] = + s[97];
gout[n*243+194] = + s[98];
gout[n*243+195] = + s[177];
gout[n*243+196] = + s[178];
gout[n*243+197] = + s[179];
gout[n*243+198] = + s[42];
gout[n*243+199] = + s[43];
gout[n*243+200] = + s[44];
gout[n*243+201] = + s[123];
gout[n*243+202] = + s[124];
gout[n*243+203] = + s[125];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[69];
gout[n*243+208] = + s[70];
gout[n*243+209] = + s[71];
gout[n*243+210] = + s[150];
gout[n*243+211] = + s[151];
gout[n*243+212] = + s[152];
gout[n*243+213] = + s[231];
gout[n*243+214] = + s[232];
gout[n*243+215] = + s[233];
gout[n*243+216] = + s[24];
gout[n*243+217] = + s[25];
gout[n*243+218] = + s[26];
gout[n*243+219] = + s[105];
gout[n*243+220] = + s[106];
gout[n*243+221] = + s[107];
gout[n*243+222] = + s[186];
gout[n*243+223] = + s[187];
gout[n*243+224] = + s[188];
gout[n*243+225] = + s[51];
gout[n*243+226] = + s[52];
gout[n*243+227] = + s[53];
gout[n*243+228] = + s[132];
gout[n*243+229] = + s[133];
gout[n*243+230] = + s[134];
gout[n*243+231] = + s[213];
gout[n*243+232] = + s[214];
gout[n*243+233] = + s[215];
gout[n*243+234] = + s[78];
gout[n*243+235] = + s[79];
gout[n*243+236] = + s[80];
gout[n*243+237] = + s[159];
gout[n*243+238] = + s[160];
gout[n*243+239] = + s[161];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[81];
gout[n*243+4] += + s[82];
gout[n*243+5] += + s[83];
gout[n*243+6] += + s[162];
gout[n*243+7] += + s[163];
gout[n*243+8] += + s[164];
gout[n*243+9] += + s[27];
gout[n*243+10] += + s[28];
gout[n*243+11] += + s[29];
gout[n*243+12] += + s[108];
gout[n*243+13] += + s[109];
gout[n*243+14] += + s[110];
gout[n*243+15] += + s[189];
gout[n*243+16] += + s[190];
gout[n*243+17] += + s[191];
gout[n*243+18] += + s[54];
gout[n*243+19] += + s[55];
gout[n*243+20] += + s[56];
gout[n*243+21] += + s[135];
gout[n*243+22] += + s[136];
gout[n*243+23] += + s[137];
gout[n*243+24] += + s[216];
gout[n*243+25] += + s[217];
gout[n*243+26] += + s[218];
gout[n*243+27] += + s[9];
gout[n*243+28] += + s[10];
gout[n*243+29] += + s[11];
gout[n*243+30] += + s[90];
gout[n*243+31] += + s[91];
gout[n*243+32] += + s[92];
gout[n*243+33] += + s[171];
gout[n*243+34] += + s[172];
gout[n*243+35] += + s[173];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[117];
gout[n*243+40] += + s[118];
gout[n*243+41] += + s[119];
gout[n*243+42] += + s[198];
gout[n*243+43] += + s[199];
gout[n*243+44] += + s[200];
gout[n*243+45] += + s[63];
gout[n*243+46] += + s[64];
gout[n*243+47] += + s[65];
gout[n*243+48] += + s[144];
gout[n*243+49] += + s[145];
gout[n*243+50] += + s[146];
gout[n*243+51] += + s[225];
gout[n*243+52] += + s[226];
gout[n*243+53] += + s[227];
gout[n*243+54] += + s[18];
gout[n*243+55] += + s[19];
gout[n*243+56] += + s[20];
gout[n*243+57] += + s[99];
gout[n*243+58] += + s[100];
gout[n*243+59] += + s[101];
gout[n*243+60] += + s[180];
gout[n*243+61] += + s[181];
gout[n*243+62] += + s[182];
gout[n*243+63] += + s[45];
gout[n*243+64] += + s[46];
gout[n*243+65] += + s[47];
gout[n*243+66] += + s[126];
gout[n*243+67] += + s[127];
gout[n*243+68] += + s[128];
gout[n*243+69] += + s[207];
gout[n*243+70] += + s[208];
gout[n*243+71] += + s[209];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[153];
gout[n*243+76] += + s[154];
gout[n*243+77] += + s[155];
gout[n*243+78] += + s[234];
gout[n*243+79] += + s[235];
gout[n*243+80] += + s[236];
gout[n*243+81] += + s[3];
gout[n*243+82] += + s[4];
gout[n*243+83] += + s[5];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[165];
gout[n*243+88] += + s[166];
gout[n*243+89] += + s[167];
gout[n*243+90] += + s[30];
gout[n*243+91] += + s[31];
gout[n*243+92] += + s[32];
gout[n*243+93] += + s[111];
gout[n*243+94] += + s[112];
gout[n*243+95] += + s[113];
gout[n*243+96] += + s[192];
gout[n*243+97] += + s[193];
gout[n*243+98] += + s[194];
gout[n*243+99] += + s[57];
gout[n*243+100] += + s[58];
gout[n*243+101] += + s[59];
gout[n*243+102] += + s[138];
gout[n*243+103] += + s[139];
gout[n*243+104] += + s[140];
gout[n*243+105] += + s[219];
gout[n*243+106] += + s[220];
gout[n*243+107] += + s[221];
gout[n*243+108] += + s[12];
gout[n*243+109] += + s[13];
gout[n*243+110] += + s[14];
gout[n*243+111] += + s[93];
gout[n*243+112] += + s[94];
gout[n*243+113] += + s[95];
gout[n*243+114] += + s[174];
gout[n*243+115] += + s[175];
gout[n*243+116] += + s[176];
gout[n*243+117] += + s[39];
gout[n*243+118] += + s[40];
gout[n*243+119] += + s[41];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[201];
gout[n*243+124] += + s[202];
gout[n*243+125] += + s[203];
gout[n*243+126] += + s[66];
gout[n*243+127] += + s[67];
gout[n*243+128] += + s[68];
gout[n*243+129] += + s[147];
gout[n*243+130] += + s[148];
gout[n*243+131] += + s[149];
gout[n*243+132] += + s[228];
gout[n*243+133] += + s[229];
gout[n*243+134] += + s[230];
gout[n*243+135] += + s[21];
gout[n*243+136] += + s[22];
gout[n*243+137] += + s[23];
gout[n*243+138] += + s[102];
gout[n*243+139] += + s[103];
gout[n*243+140] += + s[104];
gout[n*243+141] += + s[183];
gout[n*243+142] += + s[184];
gout[n*243+143] += + s[185];
gout[n*243+144] += + s[48];
gout[n*243+145] += + s[49];
gout[n*243+146] += + s[50];
gout[n*243+147] += + s[129];
gout[n*243+148] += + s[130];
gout[n*243+149] += + s[131];
gout[n*243+150] += + s[210];
gout[n*243+151] += + s[211];
gout[n*243+152] += + s[212];
gout[n*243+153] += + s[75];
gout[n*243+154] += + s[76];
gout[n*243+155] += + s[77];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[237];
gout[n*243+160] += + s[238];
gout[n*243+161] += + s[239];
gout[n*243+162] += + s[6];
gout[n*243+163] += + s[7];
gout[n*243+164] += + s[8];
gout[n*243+165] += + s[87];
gout[n*243+166] += + s[88];
gout[n*243+167] += + s[89];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[33];
gout[n*243+172] += + s[34];
gout[n*243+173] += + s[35];
gout[n*243+174] += + s[114];
gout[n*243+175] += + s[115];
gout[n*243+176] += + s[116];
gout[n*243+177] += + s[195];
gout[n*243+178] += + s[196];
gout[n*243+179] += + s[197];
gout[n*243+180] += + s[60];
gout[n*243+181] += + s[61];
gout[n*243+182] += + s[62];
gout[n*243+183] += + s[141];
gout[n*243+184] += + s[142];
gout[n*243+185] += + s[143];
gout[n*243+186] += + s[222];
gout[n*243+187] += + s[223];
gout[n*243+188] += + s[224];
gout[n*243+189] += + s[15];
gout[n*243+190] += + s[16];
gout[n*243+191] += + s[17];
gout[n*243+192] += + s[96];
gout[n*243+193] += + s[97];
gout[n*243+194] += + s[98];
gout[n*243+195] += + s[177];
gout[n*243+196] += + s[178];
gout[n*243+197] += + s[179];
gout[n*243+198] += + s[42];
gout[n*243+199] += + s[43];
gout[n*243+200] += + s[44];
gout[n*243+201] += + s[123];
gout[n*243+202] += + s[124];
gout[n*243+203] += + s[125];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[69];
gout[n*243+208] += + s[70];
gout[n*243+209] += + s[71];
gout[n*243+210] += + s[150];
gout[n*243+211] += + s[151];
gout[n*243+212] += + s[152];
gout[n*243+213] += + s[231];
gout[n*243+214] += + s[232];
gout[n*243+215] += + s[233];
gout[n*243+216] += + s[24];
gout[n*243+217] += + s[25];
gout[n*243+218] += + s[26];
gout[n*243+219] += + s[105];
gout[n*243+220] += + s[106];
gout[n*243+221] += + s[107];
gout[n*243+222] += + s[186];
gout[n*243+223] += + s[187];
gout[n*243+224] += + s[188];
gout[n*243+225] += + s[51];
gout[n*243+226] += + s[52];
gout[n*243+227] += + s[53];
gout[n*243+228] += + s[132];
gout[n*243+229] += + s[133];
gout[n*243+230] += + s[134];
gout[n*243+231] += + s[213];
gout[n*243+232] += + s[214];
gout[n*243+233] += + s[215];
gout[n*243+234] += + s[78];
gout[n*243+235] += + s[79];
gout[n*243+236] += + s[80];
gout[n*243+237] += + s[159];
gout[n*243+238] += + s[160];
gout[n*243+239] += + s[161];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipipipn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipipn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipipn_cart
CACHE_SIZE_T int1e_ipipipipn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipipn_sph
CACHE_SIZE_T int1e_ipipipipn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 1, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipipn_spinor
ALL_CINT1E(int1e_ipipipipn)
ALL_CINT1E_FORTRAN_(int1e_ipipipipn)
/* <i|RJ |NABLA j> */
void CINTgout1e_int1e_nip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[9];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_nip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nip_cart
CACHE_SIZE_T int1e_nip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nip_sph
CACHE_SIZE_T int1e_nip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nip_spinor
ALL_CINT1E(int1e_nip)
ALL_CINT1E_FORTRAN_(int1e_nip)
/* <i|RJ |NABLA NABLA j> */
void CINTgout1e_int1e_nipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[27];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_nipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nipip_cart
CACHE_SIZE_T int1e_nipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nipip_sph
CACHE_SIZE_T int1e_nipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nipip_spinor
ALL_CINT1E(int1e_nipip)
ALL_CINT1E_FORTRAN_(int1e_nipip)
/* <i|RJ |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_nipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_nipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nipipip_cart
CACHE_SIZE_T int1e_nipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nipipip_sph
CACHE_SIZE_T int1e_nipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nipipip_spinor
ALL_CINT1E(int1e_nipipip)
ALL_CINT1E_FORTRAN_(int1e_nipipip)
/* <i|RJ |NABLA NABLA NABLA NABLA j> */
void CINTgout1e_int1e_nipipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_nipipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nipipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nipipipip_cart
CACHE_SIZE_T int1e_nipipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nipipipip_sph
CACHE_SIZE_T int1e_nipipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nipipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nipipipip_spinor
ALL_CINT1E(int1e_nipipipip)
ALL_CINT1E_FORTRAN_(int1e_nipipipip)
/* <NABLA i|RJ |NABLA j> */
void CINTgout1e_int1e_ipnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[27];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_ipnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnip_cart
CACHE_SIZE_T int1e_ipnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnip_sph
CACHE_SIZE_T int1e_ipnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnip_spinor
ALL_CINT1E(int1e_ipnip)
ALL_CINT1E_FORTRAN_(int1e_ipnip)
/* <NABLA i|RJ |NABLA NABLA j> */
void CINTgout1e_int1e_ipnipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipnipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnipip_cart
CACHE_SIZE_T int1e_ipnipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnipip_sph
CACHE_SIZE_T int1e_ipnipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnipip_spinor
ALL_CINT1E(int1e_ipnipip)
ALL_CINT1E_FORTRAN_(int1e_ipnipip)
/* <NABLA i|RJ |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_ipnipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipnipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnipipip_cart
CACHE_SIZE_T int1e_ipnipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnipipip_sph
CACHE_SIZE_T int1e_ipnipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnipipip_spinor
ALL_CINT1E(int1e_ipnipipip)
ALL_CINT1E_FORTRAN_(int1e_ipnipipip)
/* <NABLA i|RJ |NABLA NABLA NABLA NABLA j> */
void CINTgout1e_int1e_ipnipipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+1, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g24, g16, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipnipipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnipipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnipipipip_cart
CACHE_SIZE_T int1e_ipnipipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnipipipip_sph
CACHE_SIZE_T int1e_ipnipipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnipipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnipipipip_spinor
ALL_CINT1E(int1e_ipnipipipip)
ALL_CINT1E_FORTRAN_(int1e_ipnipipipip)
/* <NABLA NABLA i|RJ |NABLA j> */
void CINTgout1e_int1e_ipipnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[27];
gout[n*81+10] = + s[28];
gout[n*81+11] = + s[29];
gout[n*81+12] = + s[30];
gout[n*81+13] = + s[31];
gout[n*81+14] = + s[32];
gout[n*81+15] = + s[33];
gout[n*81+16] = + s[34];
gout[n*81+17] = + s[35];
gout[n*81+18] = + s[54];
gout[n*81+19] = + s[55];
gout[n*81+20] = + s[56];
gout[n*81+21] = + s[57];
gout[n*81+22] = + s[58];
gout[n*81+23] = + s[59];
gout[n*81+24] = + s[60];
gout[n*81+25] = + s[61];
gout[n*81+26] = + s[62];
gout[n*81+27] = + s[9];
gout[n*81+28] = + s[10];
gout[n*81+29] = + s[11];
gout[n*81+30] = + s[12];
gout[n*81+31] = + s[13];
gout[n*81+32] = + s[14];
gout[n*81+33] = + s[15];
gout[n*81+34] = + s[16];
gout[n*81+35] = + s[17];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[63];
gout[n*81+46] = + s[64];
gout[n*81+47] = + s[65];
gout[n*81+48] = + s[66];
gout[n*81+49] = + s[67];
gout[n*81+50] = + s[68];
gout[n*81+51] = + s[69];
gout[n*81+52] = + s[70];
gout[n*81+53] = + s[71];
gout[n*81+54] = + s[18];
gout[n*81+55] = + s[19];
gout[n*81+56] = + s[20];
gout[n*81+57] = + s[21];
gout[n*81+58] = + s[22];
gout[n*81+59] = + s[23];
gout[n*81+60] = + s[24];
gout[n*81+61] = + s[25];
gout[n*81+62] = + s[26];
gout[n*81+63] = + s[45];
gout[n*81+64] = + s[46];
gout[n*81+65] = + s[47];
gout[n*81+66] = + s[48];
gout[n*81+67] = + s[49];
gout[n*81+68] = + s[50];
gout[n*81+69] = + s[51];
gout[n*81+70] = + s[52];
gout[n*81+71] = + s[53];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[27];
gout[n*81+10] += + s[28];
gout[n*81+11] += + s[29];
gout[n*81+12] += + s[30];
gout[n*81+13] += + s[31];
gout[n*81+14] += + s[32];
gout[n*81+15] += + s[33];
gout[n*81+16] += + s[34];
gout[n*81+17] += + s[35];
gout[n*81+18] += + s[54];
gout[n*81+19] += + s[55];
gout[n*81+20] += + s[56];
gout[n*81+21] += + s[57];
gout[n*81+22] += + s[58];
gout[n*81+23] += + s[59];
gout[n*81+24] += + s[60];
gout[n*81+25] += + s[61];
gout[n*81+26] += + s[62];
gout[n*81+27] += + s[9];
gout[n*81+28] += + s[10];
gout[n*81+29] += + s[11];
gout[n*81+30] += + s[12];
gout[n*81+31] += + s[13];
gout[n*81+32] += + s[14];
gout[n*81+33] += + s[15];
gout[n*81+34] += + s[16];
gout[n*81+35] += + s[17];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[63];
gout[n*81+46] += + s[64];
gout[n*81+47] += + s[65];
gout[n*81+48] += + s[66];
gout[n*81+49] += + s[67];
gout[n*81+50] += + s[68];
gout[n*81+51] += + s[69];
gout[n*81+52] += + s[70];
gout[n*81+53] += + s[71];
gout[n*81+54] += + s[18];
gout[n*81+55] += + s[19];
gout[n*81+56] += + s[20];
gout[n*81+57] += + s[21];
gout[n*81+58] += + s[22];
gout[n*81+59] += + s[23];
gout[n*81+60] += + s[24];
gout[n*81+61] += + s[25];
gout[n*81+62] += + s[26];
gout[n*81+63] += + s[45];
gout[n*81+64] += + s[46];
gout[n*81+65] += + s[47];
gout[n*81+66] += + s[48];
gout[n*81+67] += + s[49];
gout[n*81+68] += + s[50];
gout[n*81+69] += + s[51];
gout[n*81+70] += + s[52];
gout[n*81+71] += + s[53];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipipnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipnip_cart
CACHE_SIZE_T int1e_ipipnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipnip_sph
CACHE_SIZE_T int1e_ipipnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipnip_spinor
ALL_CINT1E(int1e_ipipnip)
ALL_CINT1E_FORTRAN_(int1e_ipipnip)
/* <NABLA NABLA NABLA i|RJ |NABLA j> */
void CINTgout1e_int1e_ipipipnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[81];
gout[n*243+10] = + s[82];
gout[n*243+11] = + s[83];
gout[n*243+12] = + s[84];
gout[n*243+13] = + s[85];
gout[n*243+14] = + s[86];
gout[n*243+15] = + s[87];
gout[n*243+16] = + s[88];
gout[n*243+17] = + s[89];
gout[n*243+18] = + s[162];
gout[n*243+19] = + s[163];
gout[n*243+20] = + s[164];
gout[n*243+21] = + s[165];
gout[n*243+22] = + s[166];
gout[n*243+23] = + s[167];
gout[n*243+24] = + s[168];
gout[n*243+25] = + s[169];
gout[n*243+26] = + s[170];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[108];
gout[n*243+37] = + s[109];
gout[n*243+38] = + s[110];
gout[n*243+39] = + s[111];
gout[n*243+40] = + s[112];
gout[n*243+41] = + s[113];
gout[n*243+42] = + s[114];
gout[n*243+43] = + s[115];
gout[n*243+44] = + s[116];
gout[n*243+45] = + s[189];
gout[n*243+46] = + s[190];
gout[n*243+47] = + s[191];
gout[n*243+48] = + s[192];
gout[n*243+49] = + s[193];
gout[n*243+50] = + s[194];
gout[n*243+51] = + s[195];
gout[n*243+52] = + s[196];
gout[n*243+53] = + s[197];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[135];
gout[n*243+64] = + s[136];
gout[n*243+65] = + s[137];
gout[n*243+66] = + s[138];
gout[n*243+67] = + s[139];
gout[n*243+68] = + s[140];
gout[n*243+69] = + s[141];
gout[n*243+70] = + s[142];
gout[n*243+71] = + s[143];
gout[n*243+72] = + s[216];
gout[n*243+73] = + s[217];
gout[n*243+74] = + s[218];
gout[n*243+75] = + s[219];
gout[n*243+76] = + s[220];
gout[n*243+77] = + s[221];
gout[n*243+78] = + s[222];
gout[n*243+79] = + s[223];
gout[n*243+80] = + s[224];
gout[n*243+81] = + s[9];
gout[n*243+82] = + s[10];
gout[n*243+83] = + s[11];
gout[n*243+84] = + s[12];
gout[n*243+85] = + s[13];
gout[n*243+86] = + s[14];
gout[n*243+87] = + s[15];
gout[n*243+88] = + s[16];
gout[n*243+89] = + s[17];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[171];
gout[n*243+100] = + s[172];
gout[n*243+101] = + s[173];
gout[n*243+102] = + s[174];
gout[n*243+103] = + s[175];
gout[n*243+104] = + s[176];
gout[n*243+105] = + s[177];
gout[n*243+106] = + s[178];
gout[n*243+107] = + s[179];
gout[n*243+108] = + s[36];
gout[n*243+109] = + s[37];
gout[n*243+110] = + s[38];
gout[n*243+111] = + s[39];
gout[n*243+112] = + s[40];
gout[n*243+113] = + s[41];
gout[n*243+114] = + s[42];
gout[n*243+115] = + s[43];
gout[n*243+116] = + s[44];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[198];
gout[n*243+127] = + s[199];
gout[n*243+128] = + s[200];
gout[n*243+129] = + s[201];
gout[n*243+130] = + s[202];
gout[n*243+131] = + s[203];
gout[n*243+132] = + s[204];
gout[n*243+133] = + s[205];
gout[n*243+134] = + s[206];
gout[n*243+135] = + s[63];
gout[n*243+136] = + s[64];
gout[n*243+137] = + s[65];
gout[n*243+138] = + s[66];
gout[n*243+139] = + s[67];
gout[n*243+140] = + s[68];
gout[n*243+141] = + s[69];
gout[n*243+142] = + s[70];
gout[n*243+143] = + s[71];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[225];
gout[n*243+154] = + s[226];
gout[n*243+155] = + s[227];
gout[n*243+156] = + s[228];
gout[n*243+157] = + s[229];
gout[n*243+158] = + s[230];
gout[n*243+159] = + s[231];
gout[n*243+160] = + s[232];
gout[n*243+161] = + s[233];
gout[n*243+162] = + s[18];
gout[n*243+163] = + s[19];
gout[n*243+164] = + s[20];
gout[n*243+165] = + s[21];
gout[n*243+166] = + s[22];
gout[n*243+167] = + s[23];
gout[n*243+168] = + s[24];
gout[n*243+169] = + s[25];
gout[n*243+170] = + s[26];
gout[n*243+171] = + s[99];
gout[n*243+172] = + s[100];
gout[n*243+173] = + s[101];
gout[n*243+174] = + s[102];
gout[n*243+175] = + s[103];
gout[n*243+176] = + s[104];
gout[n*243+177] = + s[105];
gout[n*243+178] = + s[106];
gout[n*243+179] = + s[107];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[45];
gout[n*243+190] = + s[46];
gout[n*243+191] = + s[47];
gout[n*243+192] = + s[48];
gout[n*243+193] = + s[49];
gout[n*243+194] = + s[50];
gout[n*243+195] = + s[51];
gout[n*243+196] = + s[52];
gout[n*243+197] = + s[53];
gout[n*243+198] = + s[126];
gout[n*243+199] = + s[127];
gout[n*243+200] = + s[128];
gout[n*243+201] = + s[129];
gout[n*243+202] = + s[130];
gout[n*243+203] = + s[131];
gout[n*243+204] = + s[132];
gout[n*243+205] = + s[133];
gout[n*243+206] = + s[134];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[72];
gout[n*243+217] = + s[73];
gout[n*243+218] = + s[74];
gout[n*243+219] = + s[75];
gout[n*243+220] = + s[76];
gout[n*243+221] = + s[77];
gout[n*243+222] = + s[78];
gout[n*243+223] = + s[79];
gout[n*243+224] = + s[80];
gout[n*243+225] = + s[153];
gout[n*243+226] = + s[154];
gout[n*243+227] = + s[155];
gout[n*243+228] = + s[156];
gout[n*243+229] = + s[157];
gout[n*243+230] = + s[158];
gout[n*243+231] = + s[159];
gout[n*243+232] = + s[160];
gout[n*243+233] = + s[161];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[81];
gout[n*243+10] += + s[82];
gout[n*243+11] += + s[83];
gout[n*243+12] += + s[84];
gout[n*243+13] += + s[85];
gout[n*243+14] += + s[86];
gout[n*243+15] += + s[87];
gout[n*243+16] += + s[88];
gout[n*243+17] += + s[89];
gout[n*243+18] += + s[162];
gout[n*243+19] += + s[163];
gout[n*243+20] += + s[164];
gout[n*243+21] += + s[165];
gout[n*243+22] += + s[166];
gout[n*243+23] += + s[167];
gout[n*243+24] += + s[168];
gout[n*243+25] += + s[169];
gout[n*243+26] += + s[170];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[108];
gout[n*243+37] += + s[109];
gout[n*243+38] += + s[110];
gout[n*243+39] += + s[111];
gout[n*243+40] += + s[112];
gout[n*243+41] += + s[113];
gout[n*243+42] += + s[114];
gout[n*243+43] += + s[115];
gout[n*243+44] += + s[116];
gout[n*243+45] += + s[189];
gout[n*243+46] += + s[190];
gout[n*243+47] += + s[191];
gout[n*243+48] += + s[192];
gout[n*243+49] += + s[193];
gout[n*243+50] += + s[194];
gout[n*243+51] += + s[195];
gout[n*243+52] += + s[196];
gout[n*243+53] += + s[197];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[135];
gout[n*243+64] += + s[136];
gout[n*243+65] += + s[137];
gout[n*243+66] += + s[138];
gout[n*243+67] += + s[139];
gout[n*243+68] += + s[140];
gout[n*243+69] += + s[141];
gout[n*243+70] += + s[142];
gout[n*243+71] += + s[143];
gout[n*243+72] += + s[216];
gout[n*243+73] += + s[217];
gout[n*243+74] += + s[218];
gout[n*243+75] += + s[219];
gout[n*243+76] += + s[220];
gout[n*243+77] += + s[221];
gout[n*243+78] += + s[222];
gout[n*243+79] += + s[223];
gout[n*243+80] += + s[224];
gout[n*243+81] += + s[9];
gout[n*243+82] += + s[10];
gout[n*243+83] += + s[11];
gout[n*243+84] += + s[12];
gout[n*243+85] += + s[13];
gout[n*243+86] += + s[14];
gout[n*243+87] += + s[15];
gout[n*243+88] += + s[16];
gout[n*243+89] += + s[17];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[171];
gout[n*243+100] += + s[172];
gout[n*243+101] += + s[173];
gout[n*243+102] += + s[174];
gout[n*243+103] += + s[175];
gout[n*243+104] += + s[176];
gout[n*243+105] += + s[177];
gout[n*243+106] += + s[178];
gout[n*243+107] += + s[179];
gout[n*243+108] += + s[36];
gout[n*243+109] += + s[37];
gout[n*243+110] += + s[38];
gout[n*243+111] += + s[39];
gout[n*243+112] += + s[40];
gout[n*243+113] += + s[41];
gout[n*243+114] += + s[42];
gout[n*243+115] += + s[43];
gout[n*243+116] += + s[44];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[198];
gout[n*243+127] += + s[199];
gout[n*243+128] += + s[200];
gout[n*243+129] += + s[201];
gout[n*243+130] += + s[202];
gout[n*243+131] += + s[203];
gout[n*243+132] += + s[204];
gout[n*243+133] += + s[205];
gout[n*243+134] += + s[206];
gout[n*243+135] += + s[63];
gout[n*243+136] += + s[64];
gout[n*243+137] += + s[65];
gout[n*243+138] += + s[66];
gout[n*243+139] += + s[67];
gout[n*243+140] += + s[68];
gout[n*243+141] += + s[69];
gout[n*243+142] += + s[70];
gout[n*243+143] += + s[71];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[225];
gout[n*243+154] += + s[226];
gout[n*243+155] += + s[227];
gout[n*243+156] += + s[228];
gout[n*243+157] += + s[229];
gout[n*243+158] += + s[230];
gout[n*243+159] += + s[231];
gout[n*243+160] += + s[232];
gout[n*243+161] += + s[233];
gout[n*243+162] += + s[18];
gout[n*243+163] += + s[19];
gout[n*243+164] += + s[20];
gout[n*243+165] += + s[21];
gout[n*243+166] += + s[22];
gout[n*243+167] += + s[23];
gout[n*243+168] += + s[24];
gout[n*243+169] += + s[25];
gout[n*243+170] += + s[26];
gout[n*243+171] += + s[99];
gout[n*243+172] += + s[100];
gout[n*243+173] += + s[101];
gout[n*243+174] += + s[102];
gout[n*243+175] += + s[103];
gout[n*243+176] += + s[104];
gout[n*243+177] += + s[105];
gout[n*243+178] += + s[106];
gout[n*243+179] += + s[107];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[45];
gout[n*243+190] += + s[46];
gout[n*243+191] += + s[47];
gout[n*243+192] += + s[48];
gout[n*243+193] += + s[49];
gout[n*243+194] += + s[50];
gout[n*243+195] += + s[51];
gout[n*243+196] += + s[52];
gout[n*243+197] += + s[53];
gout[n*243+198] += + s[126];
gout[n*243+199] += + s[127];
gout[n*243+200] += + s[128];
gout[n*243+201] += + s[129];
gout[n*243+202] += + s[130];
gout[n*243+203] += + s[131];
gout[n*243+204] += + s[132];
gout[n*243+205] += + s[133];
gout[n*243+206] += + s[134];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[72];
gout[n*243+217] += + s[73];
gout[n*243+218] += + s[74];
gout[n*243+219] += + s[75];
gout[n*243+220] += + s[76];
gout[n*243+221] += + s[77];
gout[n*243+222] += + s[78];
gout[n*243+223] += + s[79];
gout[n*243+224] += + s[80];
gout[n*243+225] += + s[153];
gout[n*243+226] += + s[154];
gout[n*243+227] += + s[155];
gout[n*243+228] += + s[156];
gout[n*243+229] += + s[157];
gout[n*243+230] += + s[158];
gout[n*243+231] += + s[159];
gout[n*243+232] += + s[160];
gout[n*243+233] += + s[161];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipipnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipnip_cart
CACHE_SIZE_T int1e_ipipipnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipnip_sph
CACHE_SIZE_T int1e_ipipipnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipnip_spinor
ALL_CINT1E(int1e_ipipipnip)
ALL_CINT1E_FORTRAN_(int1e_ipipipnip)
/* <NABLA NABLA NABLA NABLA i|RJ |NABLA j> */
void CINTgout1e_int1e_ipipipipnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+4, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+4, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[243];
gout[n*729+10] = + s[244];
gout[n*729+11] = + s[245];
gout[n*729+12] = + s[246];
gout[n*729+13] = + s[247];
gout[n*729+14] = + s[248];
gout[n*729+15] = + s[249];
gout[n*729+16] = + s[250];
gout[n*729+17] = + s[251];
gout[n*729+18] = + s[486];
gout[n*729+19] = + s[487];
gout[n*729+20] = + s[488];
gout[n*729+21] = + s[489];
gout[n*729+22] = + s[490];
gout[n*729+23] = + s[491];
gout[n*729+24] = + s[492];
gout[n*729+25] = + s[493];
gout[n*729+26] = + s[494];
gout[n*729+27] = + s[81];
gout[n*729+28] = + s[82];
gout[n*729+29] = + s[83];
gout[n*729+30] = + s[84];
gout[n*729+31] = + s[85];
gout[n*729+32] = + s[86];
gout[n*729+33] = + s[87];
gout[n*729+34] = + s[88];
gout[n*729+35] = + s[89];
gout[n*729+36] = + s[324];
gout[n*729+37] = + s[325];
gout[n*729+38] = + s[326];
gout[n*729+39] = + s[327];
gout[n*729+40] = + s[328];
gout[n*729+41] = + s[329];
gout[n*729+42] = + s[330];
gout[n*729+43] = + s[331];
gout[n*729+44] = + s[332];
gout[n*729+45] = + s[567];
gout[n*729+46] = + s[568];
gout[n*729+47] = + s[569];
gout[n*729+48] = + s[570];
gout[n*729+49] = + s[571];
gout[n*729+50] = + s[572];
gout[n*729+51] = + s[573];
gout[n*729+52] = + s[574];
gout[n*729+53] = + s[575];
gout[n*729+54] = + s[162];
gout[n*729+55] = + s[163];
gout[n*729+56] = + s[164];
gout[n*729+57] = + s[165];
gout[n*729+58] = + s[166];
gout[n*729+59] = + s[167];
gout[n*729+60] = + s[168];
gout[n*729+61] = + s[169];
gout[n*729+62] = + s[170];
gout[n*729+63] = + s[405];
gout[n*729+64] = + s[406];
gout[n*729+65] = + s[407];
gout[n*729+66] = + s[408];
gout[n*729+67] = + s[409];
gout[n*729+68] = + s[410];
gout[n*729+69] = + s[411];
gout[n*729+70] = + s[412];
gout[n*729+71] = + s[413];
gout[n*729+72] = + s[648];
gout[n*729+73] = + s[649];
gout[n*729+74] = + s[650];
gout[n*729+75] = + s[651];
gout[n*729+76] = + s[652];
gout[n*729+77] = + s[653];
gout[n*729+78] = + s[654];
gout[n*729+79] = + s[655];
gout[n*729+80] = + s[656];
gout[n*729+81] = + s[27];
gout[n*729+82] = + s[28];
gout[n*729+83] = + s[29];
gout[n*729+84] = + s[30];
gout[n*729+85] = + s[31];
gout[n*729+86] = + s[32];
gout[n*729+87] = + s[33];
gout[n*729+88] = + s[34];
gout[n*729+89] = + s[35];
gout[n*729+90] = + s[270];
gout[n*729+91] = + s[271];
gout[n*729+92] = + s[272];
gout[n*729+93] = + s[273];
gout[n*729+94] = + s[274];
gout[n*729+95] = + s[275];
gout[n*729+96] = + s[276];
gout[n*729+97] = + s[277];
gout[n*729+98] = + s[278];
gout[n*729+99] = + s[513];
gout[n*729+100] = + s[514];
gout[n*729+101] = + s[515];
gout[n*729+102] = + s[516];
gout[n*729+103] = + s[517];
gout[n*729+104] = + s[518];
gout[n*729+105] = + s[519];
gout[n*729+106] = + s[520];
gout[n*729+107] = + s[521];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[351];
gout[n*729+118] = + s[352];
gout[n*729+119] = + s[353];
gout[n*729+120] = + s[354];
gout[n*729+121] = + s[355];
gout[n*729+122] = + s[356];
gout[n*729+123] = + s[357];
gout[n*729+124] = + s[358];
gout[n*729+125] = + s[359];
gout[n*729+126] = + s[594];
gout[n*729+127] = + s[595];
gout[n*729+128] = + s[596];
gout[n*729+129] = + s[597];
gout[n*729+130] = + s[598];
gout[n*729+131] = + s[599];
gout[n*729+132] = + s[600];
gout[n*729+133] = + s[601];
gout[n*729+134] = + s[602];
gout[n*729+135] = + s[189];
gout[n*729+136] = + s[190];
gout[n*729+137] = + s[191];
gout[n*729+138] = + s[192];
gout[n*729+139] = + s[193];
gout[n*729+140] = + s[194];
gout[n*729+141] = + s[195];
gout[n*729+142] = + s[196];
gout[n*729+143] = + s[197];
gout[n*729+144] = + s[432];
gout[n*729+145] = + s[433];
gout[n*729+146] = + s[434];
gout[n*729+147] = + s[435];
gout[n*729+148] = + s[436];
gout[n*729+149] = + s[437];
gout[n*729+150] = + s[438];
gout[n*729+151] = + s[439];
gout[n*729+152] = + s[440];
gout[n*729+153] = + s[675];
gout[n*729+154] = + s[676];
gout[n*729+155] = + s[677];
gout[n*729+156] = + s[678];
gout[n*729+157] = + s[679];
gout[n*729+158] = + s[680];
gout[n*729+159] = + s[681];
gout[n*729+160] = + s[682];
gout[n*729+161] = + s[683];
gout[n*729+162] = + s[54];
gout[n*729+163] = + s[55];
gout[n*729+164] = + s[56];
gout[n*729+165] = + s[57];
gout[n*729+166] = + s[58];
gout[n*729+167] = + s[59];
gout[n*729+168] = + s[60];
gout[n*729+169] = + s[61];
gout[n*729+170] = + s[62];
gout[n*729+171] = + s[297];
gout[n*729+172] = + s[298];
gout[n*729+173] = + s[299];
gout[n*729+174] = + s[300];
gout[n*729+175] = + s[301];
gout[n*729+176] = + s[302];
gout[n*729+177] = + s[303];
gout[n*729+178] = + s[304];
gout[n*729+179] = + s[305];
gout[n*729+180] = + s[540];
gout[n*729+181] = + s[541];
gout[n*729+182] = + s[542];
gout[n*729+183] = + s[543];
gout[n*729+184] = + s[544];
gout[n*729+185] = + s[545];
gout[n*729+186] = + s[546];
gout[n*729+187] = + s[547];
gout[n*729+188] = + s[548];
gout[n*729+189] = + s[135];
gout[n*729+190] = + s[136];
gout[n*729+191] = + s[137];
gout[n*729+192] = + s[138];
gout[n*729+193] = + s[139];
gout[n*729+194] = + s[140];
gout[n*729+195] = + s[141];
gout[n*729+196] = + s[142];
gout[n*729+197] = + s[143];
gout[n*729+198] = + s[378];
gout[n*729+199] = + s[379];
gout[n*729+200] = + s[380];
gout[n*729+201] = + s[381];
gout[n*729+202] = + s[382];
gout[n*729+203] = + s[383];
gout[n*729+204] = + s[384];
gout[n*729+205] = + s[385];
gout[n*729+206] = + s[386];
gout[n*729+207] = + s[621];
gout[n*729+208] = + s[622];
gout[n*729+209] = + s[623];
gout[n*729+210] = + s[624];
gout[n*729+211] = + s[625];
gout[n*729+212] = + s[626];
gout[n*729+213] = + s[627];
gout[n*729+214] = + s[628];
gout[n*729+215] = + s[629];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[459];
gout[n*729+226] = + s[460];
gout[n*729+227] = + s[461];
gout[n*729+228] = + s[462];
gout[n*729+229] = + s[463];
gout[n*729+230] = + s[464];
gout[n*729+231] = + s[465];
gout[n*729+232] = + s[466];
gout[n*729+233] = + s[467];
gout[n*729+234] = + s[702];
gout[n*729+235] = + s[703];
gout[n*729+236] = + s[704];
gout[n*729+237] = + s[705];
gout[n*729+238] = + s[706];
gout[n*729+239] = + s[707];
gout[n*729+240] = + s[708];
gout[n*729+241] = + s[709];
gout[n*729+242] = + s[710];
gout[n*729+243] = + s[9];
gout[n*729+244] = + s[10];
gout[n*729+245] = + s[11];
gout[n*729+246] = + s[12];
gout[n*729+247] = + s[13];
gout[n*729+248] = + s[14];
gout[n*729+249] = + s[15];
gout[n*729+250] = + s[16];
gout[n*729+251] = + s[17];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[495];
gout[n*729+262] = + s[496];
gout[n*729+263] = + s[497];
gout[n*729+264] = + s[498];
gout[n*729+265] = + s[499];
gout[n*729+266] = + s[500];
gout[n*729+267] = + s[501];
gout[n*729+268] = + s[502];
gout[n*729+269] = + s[503];
gout[n*729+270] = + s[90];
gout[n*729+271] = + s[91];
gout[n*729+272] = + s[92];
gout[n*729+273] = + s[93];
gout[n*729+274] = + s[94];
gout[n*729+275] = + s[95];
gout[n*729+276] = + s[96];
gout[n*729+277] = + s[97];
gout[n*729+278] = + s[98];
gout[n*729+279] = + s[333];
gout[n*729+280] = + s[334];
gout[n*729+281] = + s[335];
gout[n*729+282] = + s[336];
gout[n*729+283] = + s[337];
gout[n*729+284] = + s[338];
gout[n*729+285] = + s[339];
gout[n*729+286] = + s[340];
gout[n*729+287] = + s[341];
gout[n*729+288] = + s[576];
gout[n*729+289] = + s[577];
gout[n*729+290] = + s[578];
gout[n*729+291] = + s[579];
gout[n*729+292] = + s[580];
gout[n*729+293] = + s[581];
gout[n*729+294] = + s[582];
gout[n*729+295] = + s[583];
gout[n*729+296] = + s[584];
gout[n*729+297] = + s[171];
gout[n*729+298] = + s[172];
gout[n*729+299] = + s[173];
gout[n*729+300] = + s[174];
gout[n*729+301] = + s[175];
gout[n*729+302] = + s[176];
gout[n*729+303] = + s[177];
gout[n*729+304] = + s[178];
gout[n*729+305] = + s[179];
gout[n*729+306] = + s[414];
gout[n*729+307] = + s[415];
gout[n*729+308] = + s[416];
gout[n*729+309] = + s[417];
gout[n*729+310] = + s[418];
gout[n*729+311] = + s[419];
gout[n*729+312] = + s[420];
gout[n*729+313] = + s[421];
gout[n*729+314] = + s[422];
gout[n*729+315] = + s[657];
gout[n*729+316] = + s[658];
gout[n*729+317] = + s[659];
gout[n*729+318] = + s[660];
gout[n*729+319] = + s[661];
gout[n*729+320] = + s[662];
gout[n*729+321] = + s[663];
gout[n*729+322] = + s[664];
gout[n*729+323] = + s[665];
gout[n*729+324] = + s[36];
gout[n*729+325] = + s[37];
gout[n*729+326] = + s[38];
gout[n*729+327] = + s[39];
gout[n*729+328] = + s[40];
gout[n*729+329] = + s[41];
gout[n*729+330] = + s[42];
gout[n*729+331] = + s[43];
gout[n*729+332] = + s[44];
gout[n*729+333] = + s[279];
gout[n*729+334] = + s[280];
gout[n*729+335] = + s[281];
gout[n*729+336] = + s[282];
gout[n*729+337] = + s[283];
gout[n*729+338] = + s[284];
gout[n*729+339] = + s[285];
gout[n*729+340] = + s[286];
gout[n*729+341] = + s[287];
gout[n*729+342] = + s[522];
gout[n*729+343] = + s[523];
gout[n*729+344] = + s[524];
gout[n*729+345] = + s[525];
gout[n*729+346] = + s[526];
gout[n*729+347] = + s[527];
gout[n*729+348] = + s[528];
gout[n*729+349] = + s[529];
gout[n*729+350] = + s[530];
gout[n*729+351] = + s[117];
gout[n*729+352] = + s[118];
gout[n*729+353] = + s[119];
gout[n*729+354] = + s[120];
gout[n*729+355] = + s[121];
gout[n*729+356] = + s[122];
gout[n*729+357] = + s[123];
gout[n*729+358] = + s[124];
gout[n*729+359] = + s[125];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[603];
gout[n*729+370] = + s[604];
gout[n*729+371] = + s[605];
gout[n*729+372] = + s[606];
gout[n*729+373] = + s[607];
gout[n*729+374] = + s[608];
gout[n*729+375] = + s[609];
gout[n*729+376] = + s[610];
gout[n*729+377] = + s[611];
gout[n*729+378] = + s[198];
gout[n*729+379] = + s[199];
gout[n*729+380] = + s[200];
gout[n*729+381] = + s[201];
gout[n*729+382] = + s[202];
gout[n*729+383] = + s[203];
gout[n*729+384] = + s[204];
gout[n*729+385] = + s[205];
gout[n*729+386] = + s[206];
gout[n*729+387] = + s[441];
gout[n*729+388] = + s[442];
gout[n*729+389] = + s[443];
gout[n*729+390] = + s[444];
gout[n*729+391] = + s[445];
gout[n*729+392] = + s[446];
gout[n*729+393] = + s[447];
gout[n*729+394] = + s[448];
gout[n*729+395] = + s[449];
gout[n*729+396] = + s[684];
gout[n*729+397] = + s[685];
gout[n*729+398] = + s[686];
gout[n*729+399] = + s[687];
gout[n*729+400] = + s[688];
gout[n*729+401] = + s[689];
gout[n*729+402] = + s[690];
gout[n*729+403] = + s[691];
gout[n*729+404] = + s[692];
gout[n*729+405] = + s[63];
gout[n*729+406] = + s[64];
gout[n*729+407] = + s[65];
gout[n*729+408] = + s[66];
gout[n*729+409] = + s[67];
gout[n*729+410] = + s[68];
gout[n*729+411] = + s[69];
gout[n*729+412] = + s[70];
gout[n*729+413] = + s[71];
gout[n*729+414] = + s[306];
gout[n*729+415] = + s[307];
gout[n*729+416] = + s[308];
gout[n*729+417] = + s[309];
gout[n*729+418] = + s[310];
gout[n*729+419] = + s[311];
gout[n*729+420] = + s[312];
gout[n*729+421] = + s[313];
gout[n*729+422] = + s[314];
gout[n*729+423] = + s[549];
gout[n*729+424] = + s[550];
gout[n*729+425] = + s[551];
gout[n*729+426] = + s[552];
gout[n*729+427] = + s[553];
gout[n*729+428] = + s[554];
gout[n*729+429] = + s[555];
gout[n*729+430] = + s[556];
gout[n*729+431] = + s[557];
gout[n*729+432] = + s[144];
gout[n*729+433] = + s[145];
gout[n*729+434] = + s[146];
gout[n*729+435] = + s[147];
gout[n*729+436] = + s[148];
gout[n*729+437] = + s[149];
gout[n*729+438] = + s[150];
gout[n*729+439] = + s[151];
gout[n*729+440] = + s[152];
gout[n*729+441] = + s[387];
gout[n*729+442] = + s[388];
gout[n*729+443] = + s[389];
gout[n*729+444] = + s[390];
gout[n*729+445] = + s[391];
gout[n*729+446] = + s[392];
gout[n*729+447] = + s[393];
gout[n*729+448] = + s[394];
gout[n*729+449] = + s[395];
gout[n*729+450] = + s[630];
gout[n*729+451] = + s[631];
gout[n*729+452] = + s[632];
gout[n*729+453] = + s[633];
gout[n*729+454] = + s[634];
gout[n*729+455] = + s[635];
gout[n*729+456] = + s[636];
gout[n*729+457] = + s[637];
gout[n*729+458] = + s[638];
gout[n*729+459] = + s[225];
gout[n*729+460] = + s[226];
gout[n*729+461] = + s[227];
gout[n*729+462] = + s[228];
gout[n*729+463] = + s[229];
gout[n*729+464] = + s[230];
gout[n*729+465] = + s[231];
gout[n*729+466] = + s[232];
gout[n*729+467] = + s[233];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[711];
gout[n*729+478] = + s[712];
gout[n*729+479] = + s[713];
gout[n*729+480] = + s[714];
gout[n*729+481] = + s[715];
gout[n*729+482] = + s[716];
gout[n*729+483] = + s[717];
gout[n*729+484] = + s[718];
gout[n*729+485] = + s[719];
gout[n*729+486] = + s[18];
gout[n*729+487] = + s[19];
gout[n*729+488] = + s[20];
gout[n*729+489] = + s[21];
gout[n*729+490] = + s[22];
gout[n*729+491] = + s[23];
gout[n*729+492] = + s[24];
gout[n*729+493] = + s[25];
gout[n*729+494] = + s[26];
gout[n*729+495] = + s[261];
gout[n*729+496] = + s[262];
gout[n*729+497] = + s[263];
gout[n*729+498] = + s[264];
gout[n*729+499] = + s[265];
gout[n*729+500] = + s[266];
gout[n*729+501] = + s[267];
gout[n*729+502] = + s[268];
gout[n*729+503] = + s[269];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[99];
gout[n*729+514] = + s[100];
gout[n*729+515] = + s[101];
gout[n*729+516] = + s[102];
gout[n*729+517] = + s[103];
gout[n*729+518] = + s[104];
gout[n*729+519] = + s[105];
gout[n*729+520] = + s[106];
gout[n*729+521] = + s[107];
gout[n*729+522] = + s[342];
gout[n*729+523] = + s[343];
gout[n*729+524] = + s[344];
gout[n*729+525] = + s[345];
gout[n*729+526] = + s[346];
gout[n*729+527] = + s[347];
gout[n*729+528] = + s[348];
gout[n*729+529] = + s[349];
gout[n*729+530] = + s[350];
gout[n*729+531] = + s[585];
gout[n*729+532] = + s[586];
gout[n*729+533] = + s[587];
gout[n*729+534] = + s[588];
gout[n*729+535] = + s[589];
gout[n*729+536] = + s[590];
gout[n*729+537] = + s[591];
gout[n*729+538] = + s[592];
gout[n*729+539] = + s[593];
gout[n*729+540] = + s[180];
gout[n*729+541] = + s[181];
gout[n*729+542] = + s[182];
gout[n*729+543] = + s[183];
gout[n*729+544] = + s[184];
gout[n*729+545] = + s[185];
gout[n*729+546] = + s[186];
gout[n*729+547] = + s[187];
gout[n*729+548] = + s[188];
gout[n*729+549] = + s[423];
gout[n*729+550] = + s[424];
gout[n*729+551] = + s[425];
gout[n*729+552] = + s[426];
gout[n*729+553] = + s[427];
gout[n*729+554] = + s[428];
gout[n*729+555] = + s[429];
gout[n*729+556] = + s[430];
gout[n*729+557] = + s[431];
gout[n*729+558] = + s[666];
gout[n*729+559] = + s[667];
gout[n*729+560] = + s[668];
gout[n*729+561] = + s[669];
gout[n*729+562] = + s[670];
gout[n*729+563] = + s[671];
gout[n*729+564] = + s[672];
gout[n*729+565] = + s[673];
gout[n*729+566] = + s[674];
gout[n*729+567] = + s[45];
gout[n*729+568] = + s[46];
gout[n*729+569] = + s[47];
gout[n*729+570] = + s[48];
gout[n*729+571] = + s[49];
gout[n*729+572] = + s[50];
gout[n*729+573] = + s[51];
gout[n*729+574] = + s[52];
gout[n*729+575] = + s[53];
gout[n*729+576] = + s[288];
gout[n*729+577] = + s[289];
gout[n*729+578] = + s[290];
gout[n*729+579] = + s[291];
gout[n*729+580] = + s[292];
gout[n*729+581] = + s[293];
gout[n*729+582] = + s[294];
gout[n*729+583] = + s[295];
gout[n*729+584] = + s[296];
gout[n*729+585] = + s[531];
gout[n*729+586] = + s[532];
gout[n*729+587] = + s[533];
gout[n*729+588] = + s[534];
gout[n*729+589] = + s[535];
gout[n*729+590] = + s[536];
gout[n*729+591] = + s[537];
gout[n*729+592] = + s[538];
gout[n*729+593] = + s[539];
gout[n*729+594] = + s[126];
gout[n*729+595] = + s[127];
gout[n*729+596] = + s[128];
gout[n*729+597] = + s[129];
gout[n*729+598] = + s[130];
gout[n*729+599] = + s[131];
gout[n*729+600] = + s[132];
gout[n*729+601] = + s[133];
gout[n*729+602] = + s[134];
gout[n*729+603] = + s[369];
gout[n*729+604] = + s[370];
gout[n*729+605] = + s[371];
gout[n*729+606] = + s[372];
gout[n*729+607] = + s[373];
gout[n*729+608] = + s[374];
gout[n*729+609] = + s[375];
gout[n*729+610] = + s[376];
gout[n*729+611] = + s[377];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[207];
gout[n*729+622] = + s[208];
gout[n*729+623] = + s[209];
gout[n*729+624] = + s[210];
gout[n*729+625] = + s[211];
gout[n*729+626] = + s[212];
gout[n*729+627] = + s[213];
gout[n*729+628] = + s[214];
gout[n*729+629] = + s[215];
gout[n*729+630] = + s[450];
gout[n*729+631] = + s[451];
gout[n*729+632] = + s[452];
gout[n*729+633] = + s[453];
gout[n*729+634] = + s[454];
gout[n*729+635] = + s[455];
gout[n*729+636] = + s[456];
gout[n*729+637] = + s[457];
gout[n*729+638] = + s[458];
gout[n*729+639] = + s[693];
gout[n*729+640] = + s[694];
gout[n*729+641] = + s[695];
gout[n*729+642] = + s[696];
gout[n*729+643] = + s[697];
gout[n*729+644] = + s[698];
gout[n*729+645] = + s[699];
gout[n*729+646] = + s[700];
gout[n*729+647] = + s[701];
gout[n*729+648] = + s[72];
gout[n*729+649] = + s[73];
gout[n*729+650] = + s[74];
gout[n*729+651] = + s[75];
gout[n*729+652] = + s[76];
gout[n*729+653] = + s[77];
gout[n*729+654] = + s[78];
gout[n*729+655] = + s[79];
gout[n*729+656] = + s[80];
gout[n*729+657] = + s[315];
gout[n*729+658] = + s[316];
gout[n*729+659] = + s[317];
gout[n*729+660] = + s[318];
gout[n*729+661] = + s[319];
gout[n*729+662] = + s[320];
gout[n*729+663] = + s[321];
gout[n*729+664] = + s[322];
gout[n*729+665] = + s[323];
gout[n*729+666] = + s[558];
gout[n*729+667] = + s[559];
gout[n*729+668] = + s[560];
gout[n*729+669] = + s[561];
gout[n*729+670] = + s[562];
gout[n*729+671] = + s[563];
gout[n*729+672] = + s[564];
gout[n*729+673] = + s[565];
gout[n*729+674] = + s[566];
gout[n*729+675] = + s[153];
gout[n*729+676] = + s[154];
gout[n*729+677] = + s[155];
gout[n*729+678] = + s[156];
gout[n*729+679] = + s[157];
gout[n*729+680] = + s[158];
gout[n*729+681] = + s[159];
gout[n*729+682] = + s[160];
gout[n*729+683] = + s[161];
gout[n*729+684] = + s[396];
gout[n*729+685] = + s[397];
gout[n*729+686] = + s[398];
gout[n*729+687] = + s[399];
gout[n*729+688] = + s[400];
gout[n*729+689] = + s[401];
gout[n*729+690] = + s[402];
gout[n*729+691] = + s[403];
gout[n*729+692] = + s[404];
gout[n*729+693] = + s[639];
gout[n*729+694] = + s[640];
gout[n*729+695] = + s[641];
gout[n*729+696] = + s[642];
gout[n*729+697] = + s[643];
gout[n*729+698] = + s[644];
gout[n*729+699] = + s[645];
gout[n*729+700] = + s[646];
gout[n*729+701] = + s[647];
gout[n*729+702] = + s[234];
gout[n*729+703] = + s[235];
gout[n*729+704] = + s[236];
gout[n*729+705] = + s[237];
gout[n*729+706] = + s[238];
gout[n*729+707] = + s[239];
gout[n*729+708] = + s[240];
gout[n*729+709] = + s[241];
gout[n*729+710] = + s[242];
gout[n*729+711] = + s[477];
gout[n*729+712] = + s[478];
gout[n*729+713] = + s[479];
gout[n*729+714] = + s[480];
gout[n*729+715] = + s[481];
gout[n*729+716] = + s[482];
gout[n*729+717] = + s[483];
gout[n*729+718] = + s[484];
gout[n*729+719] = + s[485];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[243];
gout[n*729+10] += + s[244];
gout[n*729+11] += + s[245];
gout[n*729+12] += + s[246];
gout[n*729+13] += + s[247];
gout[n*729+14] += + s[248];
gout[n*729+15] += + s[249];
gout[n*729+16] += + s[250];
gout[n*729+17] += + s[251];
gout[n*729+18] += + s[486];
gout[n*729+19] += + s[487];
gout[n*729+20] += + s[488];
gout[n*729+21] += + s[489];
gout[n*729+22] += + s[490];
gout[n*729+23] += + s[491];
gout[n*729+24] += + s[492];
gout[n*729+25] += + s[493];
gout[n*729+26] += + s[494];
gout[n*729+27] += + s[81];
gout[n*729+28] += + s[82];
gout[n*729+29] += + s[83];
gout[n*729+30] += + s[84];
gout[n*729+31] += + s[85];
gout[n*729+32] += + s[86];
gout[n*729+33] += + s[87];
gout[n*729+34] += + s[88];
gout[n*729+35] += + s[89];
gout[n*729+36] += + s[324];
gout[n*729+37] += + s[325];
gout[n*729+38] += + s[326];
gout[n*729+39] += + s[327];
gout[n*729+40] += + s[328];
gout[n*729+41] += + s[329];
gout[n*729+42] += + s[330];
gout[n*729+43] += + s[331];
gout[n*729+44] += + s[332];
gout[n*729+45] += + s[567];
gout[n*729+46] += + s[568];
gout[n*729+47] += + s[569];
gout[n*729+48] += + s[570];
gout[n*729+49] += + s[571];
gout[n*729+50] += + s[572];
gout[n*729+51] += + s[573];
gout[n*729+52] += + s[574];
gout[n*729+53] += + s[575];
gout[n*729+54] += + s[162];
gout[n*729+55] += + s[163];
gout[n*729+56] += + s[164];
gout[n*729+57] += + s[165];
gout[n*729+58] += + s[166];
gout[n*729+59] += + s[167];
gout[n*729+60] += + s[168];
gout[n*729+61] += + s[169];
gout[n*729+62] += + s[170];
gout[n*729+63] += + s[405];
gout[n*729+64] += + s[406];
gout[n*729+65] += + s[407];
gout[n*729+66] += + s[408];
gout[n*729+67] += + s[409];
gout[n*729+68] += + s[410];
gout[n*729+69] += + s[411];
gout[n*729+70] += + s[412];
gout[n*729+71] += + s[413];
gout[n*729+72] += + s[648];
gout[n*729+73] += + s[649];
gout[n*729+74] += + s[650];
gout[n*729+75] += + s[651];
gout[n*729+76] += + s[652];
gout[n*729+77] += + s[653];
gout[n*729+78] += + s[654];
gout[n*729+79] += + s[655];
gout[n*729+80] += + s[656];
gout[n*729+81] += + s[27];
gout[n*729+82] += + s[28];
gout[n*729+83] += + s[29];
gout[n*729+84] += + s[30];
gout[n*729+85] += + s[31];
gout[n*729+86] += + s[32];
gout[n*729+87] += + s[33];
gout[n*729+88] += + s[34];
gout[n*729+89] += + s[35];
gout[n*729+90] += + s[270];
gout[n*729+91] += + s[271];
gout[n*729+92] += + s[272];
gout[n*729+93] += + s[273];
gout[n*729+94] += + s[274];
gout[n*729+95] += + s[275];
gout[n*729+96] += + s[276];
gout[n*729+97] += + s[277];
gout[n*729+98] += + s[278];
gout[n*729+99] += + s[513];
gout[n*729+100] += + s[514];
gout[n*729+101] += + s[515];
gout[n*729+102] += + s[516];
gout[n*729+103] += + s[517];
gout[n*729+104] += + s[518];
gout[n*729+105] += + s[519];
gout[n*729+106] += + s[520];
gout[n*729+107] += + s[521];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[351];
gout[n*729+118] += + s[352];
gout[n*729+119] += + s[353];
gout[n*729+120] += + s[354];
gout[n*729+121] += + s[355];
gout[n*729+122] += + s[356];
gout[n*729+123] += + s[357];
gout[n*729+124] += + s[358];
gout[n*729+125] += + s[359];
gout[n*729+126] += + s[594];
gout[n*729+127] += + s[595];
gout[n*729+128] += + s[596];
gout[n*729+129] += + s[597];
gout[n*729+130] += + s[598];
gout[n*729+131] += + s[599];
gout[n*729+132] += + s[600];
gout[n*729+133] += + s[601];
gout[n*729+134] += + s[602];
gout[n*729+135] += + s[189];
gout[n*729+136] += + s[190];
gout[n*729+137] += + s[191];
gout[n*729+138] += + s[192];
gout[n*729+139] += + s[193];
gout[n*729+140] += + s[194];
gout[n*729+141] += + s[195];
gout[n*729+142] += + s[196];
gout[n*729+143] += + s[197];
gout[n*729+144] += + s[432];
gout[n*729+145] += + s[433];
gout[n*729+146] += + s[434];
gout[n*729+147] += + s[435];
gout[n*729+148] += + s[436];
gout[n*729+149] += + s[437];
gout[n*729+150] += + s[438];
gout[n*729+151] += + s[439];
gout[n*729+152] += + s[440];
gout[n*729+153] += + s[675];
gout[n*729+154] += + s[676];
gout[n*729+155] += + s[677];
gout[n*729+156] += + s[678];
gout[n*729+157] += + s[679];
gout[n*729+158] += + s[680];
gout[n*729+159] += + s[681];
gout[n*729+160] += + s[682];
gout[n*729+161] += + s[683];
gout[n*729+162] += + s[54];
gout[n*729+163] += + s[55];
gout[n*729+164] += + s[56];
gout[n*729+165] += + s[57];
gout[n*729+166] += + s[58];
gout[n*729+167] += + s[59];
gout[n*729+168] += + s[60];
gout[n*729+169] += + s[61];
gout[n*729+170] += + s[62];
gout[n*729+171] += + s[297];
gout[n*729+172] += + s[298];
gout[n*729+173] += + s[299];
gout[n*729+174] += + s[300];
gout[n*729+175] += + s[301];
gout[n*729+176] += + s[302];
gout[n*729+177] += + s[303];
gout[n*729+178] += + s[304];
gout[n*729+179] += + s[305];
gout[n*729+180] += + s[540];
gout[n*729+181] += + s[541];
gout[n*729+182] += + s[542];
gout[n*729+183] += + s[543];
gout[n*729+184] += + s[544];
gout[n*729+185] += + s[545];
gout[n*729+186] += + s[546];
gout[n*729+187] += + s[547];
gout[n*729+188] += + s[548];
gout[n*729+189] += + s[135];
gout[n*729+190] += + s[136];
gout[n*729+191] += + s[137];
gout[n*729+192] += + s[138];
gout[n*729+193] += + s[139];
gout[n*729+194] += + s[140];
gout[n*729+195] += + s[141];
gout[n*729+196] += + s[142];
gout[n*729+197] += + s[143];
gout[n*729+198] += + s[378];
gout[n*729+199] += + s[379];
gout[n*729+200] += + s[380];
gout[n*729+201] += + s[381];
gout[n*729+202] += + s[382];
gout[n*729+203] += + s[383];
gout[n*729+204] += + s[384];
gout[n*729+205] += + s[385];
gout[n*729+206] += + s[386];
gout[n*729+207] += + s[621];
gout[n*729+208] += + s[622];
gout[n*729+209] += + s[623];
gout[n*729+210] += + s[624];
gout[n*729+211] += + s[625];
gout[n*729+212] += + s[626];
gout[n*729+213] += + s[627];
gout[n*729+214] += + s[628];
gout[n*729+215] += + s[629];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[459];
gout[n*729+226] += + s[460];
gout[n*729+227] += + s[461];
gout[n*729+228] += + s[462];
gout[n*729+229] += + s[463];
gout[n*729+230] += + s[464];
gout[n*729+231] += + s[465];
gout[n*729+232] += + s[466];
gout[n*729+233] += + s[467];
gout[n*729+234] += + s[702];
gout[n*729+235] += + s[703];
gout[n*729+236] += + s[704];
gout[n*729+237] += + s[705];
gout[n*729+238] += + s[706];
gout[n*729+239] += + s[707];
gout[n*729+240] += + s[708];
gout[n*729+241] += + s[709];
gout[n*729+242] += + s[710];
gout[n*729+243] += + s[9];
gout[n*729+244] += + s[10];
gout[n*729+245] += + s[11];
gout[n*729+246] += + s[12];
gout[n*729+247] += + s[13];
gout[n*729+248] += + s[14];
gout[n*729+249] += + s[15];
gout[n*729+250] += + s[16];
gout[n*729+251] += + s[17];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[495];
gout[n*729+262] += + s[496];
gout[n*729+263] += + s[497];
gout[n*729+264] += + s[498];
gout[n*729+265] += + s[499];
gout[n*729+266] += + s[500];
gout[n*729+267] += + s[501];
gout[n*729+268] += + s[502];
gout[n*729+269] += + s[503];
gout[n*729+270] += + s[90];
gout[n*729+271] += + s[91];
gout[n*729+272] += + s[92];
gout[n*729+273] += + s[93];
gout[n*729+274] += + s[94];
gout[n*729+275] += + s[95];
gout[n*729+276] += + s[96];
gout[n*729+277] += + s[97];
gout[n*729+278] += + s[98];
gout[n*729+279] += + s[333];
gout[n*729+280] += + s[334];
gout[n*729+281] += + s[335];
gout[n*729+282] += + s[336];
gout[n*729+283] += + s[337];
gout[n*729+284] += + s[338];
gout[n*729+285] += + s[339];
gout[n*729+286] += + s[340];
gout[n*729+287] += + s[341];
gout[n*729+288] += + s[576];
gout[n*729+289] += + s[577];
gout[n*729+290] += + s[578];
gout[n*729+291] += + s[579];
gout[n*729+292] += + s[580];
gout[n*729+293] += + s[581];
gout[n*729+294] += + s[582];
gout[n*729+295] += + s[583];
gout[n*729+296] += + s[584];
gout[n*729+297] += + s[171];
gout[n*729+298] += + s[172];
gout[n*729+299] += + s[173];
gout[n*729+300] += + s[174];
gout[n*729+301] += + s[175];
gout[n*729+302] += + s[176];
gout[n*729+303] += + s[177];
gout[n*729+304] += + s[178];
gout[n*729+305] += + s[179];
gout[n*729+306] += + s[414];
gout[n*729+307] += + s[415];
gout[n*729+308] += + s[416];
gout[n*729+309] += + s[417];
gout[n*729+310] += + s[418];
gout[n*729+311] += + s[419];
gout[n*729+312] += + s[420];
gout[n*729+313] += + s[421];
gout[n*729+314] += + s[422];
gout[n*729+315] += + s[657];
gout[n*729+316] += + s[658];
gout[n*729+317] += + s[659];
gout[n*729+318] += + s[660];
gout[n*729+319] += + s[661];
gout[n*729+320] += + s[662];
gout[n*729+321] += + s[663];
gout[n*729+322] += + s[664];
gout[n*729+323] += + s[665];
gout[n*729+324] += + s[36];
gout[n*729+325] += + s[37];
gout[n*729+326] += + s[38];
gout[n*729+327] += + s[39];
gout[n*729+328] += + s[40];
gout[n*729+329] += + s[41];
gout[n*729+330] += + s[42];
gout[n*729+331] += + s[43];
gout[n*729+332] += + s[44];
gout[n*729+333] += + s[279];
gout[n*729+334] += + s[280];
gout[n*729+335] += + s[281];
gout[n*729+336] += + s[282];
gout[n*729+337] += + s[283];
gout[n*729+338] += + s[284];
gout[n*729+339] += + s[285];
gout[n*729+340] += + s[286];
gout[n*729+341] += + s[287];
gout[n*729+342] += + s[522];
gout[n*729+343] += + s[523];
gout[n*729+344] += + s[524];
gout[n*729+345] += + s[525];
gout[n*729+346] += + s[526];
gout[n*729+347] += + s[527];
gout[n*729+348] += + s[528];
gout[n*729+349] += + s[529];
gout[n*729+350] += + s[530];
gout[n*729+351] += + s[117];
gout[n*729+352] += + s[118];
gout[n*729+353] += + s[119];
gout[n*729+354] += + s[120];
gout[n*729+355] += + s[121];
gout[n*729+356] += + s[122];
gout[n*729+357] += + s[123];
gout[n*729+358] += + s[124];
gout[n*729+359] += + s[125];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[603];
gout[n*729+370] += + s[604];
gout[n*729+371] += + s[605];
gout[n*729+372] += + s[606];
gout[n*729+373] += + s[607];
gout[n*729+374] += + s[608];
gout[n*729+375] += + s[609];
gout[n*729+376] += + s[610];
gout[n*729+377] += + s[611];
gout[n*729+378] += + s[198];
gout[n*729+379] += + s[199];
gout[n*729+380] += + s[200];
gout[n*729+381] += + s[201];
gout[n*729+382] += + s[202];
gout[n*729+383] += + s[203];
gout[n*729+384] += + s[204];
gout[n*729+385] += + s[205];
gout[n*729+386] += + s[206];
gout[n*729+387] += + s[441];
gout[n*729+388] += + s[442];
gout[n*729+389] += + s[443];
gout[n*729+390] += + s[444];
gout[n*729+391] += + s[445];
gout[n*729+392] += + s[446];
gout[n*729+393] += + s[447];
gout[n*729+394] += + s[448];
gout[n*729+395] += + s[449];
gout[n*729+396] += + s[684];
gout[n*729+397] += + s[685];
gout[n*729+398] += + s[686];
gout[n*729+399] += + s[687];
gout[n*729+400] += + s[688];
gout[n*729+401] += + s[689];
gout[n*729+402] += + s[690];
gout[n*729+403] += + s[691];
gout[n*729+404] += + s[692];
gout[n*729+405] += + s[63];
gout[n*729+406] += + s[64];
gout[n*729+407] += + s[65];
gout[n*729+408] += + s[66];
gout[n*729+409] += + s[67];
gout[n*729+410] += + s[68];
gout[n*729+411] += + s[69];
gout[n*729+412] += + s[70];
gout[n*729+413] += + s[71];
gout[n*729+414] += + s[306];
gout[n*729+415] += + s[307];
gout[n*729+416] += + s[308];
gout[n*729+417] += + s[309];
gout[n*729+418] += + s[310];
gout[n*729+419] += + s[311];
gout[n*729+420] += + s[312];
gout[n*729+421] += + s[313];
gout[n*729+422] += + s[314];
gout[n*729+423] += + s[549];
gout[n*729+424] += + s[550];
gout[n*729+425] += + s[551];
gout[n*729+426] += + s[552];
gout[n*729+427] += + s[553];
gout[n*729+428] += + s[554];
gout[n*729+429] += + s[555];
gout[n*729+430] += + s[556];
gout[n*729+431] += + s[557];
gout[n*729+432] += + s[144];
gout[n*729+433] += + s[145];
gout[n*729+434] += + s[146];
gout[n*729+435] += + s[147];
gout[n*729+436] += + s[148];
gout[n*729+437] += + s[149];
gout[n*729+438] += + s[150];
gout[n*729+439] += + s[151];
gout[n*729+440] += + s[152];
gout[n*729+441] += + s[387];
gout[n*729+442] += + s[388];
gout[n*729+443] += + s[389];
gout[n*729+444] += + s[390];
gout[n*729+445] += + s[391];
gout[n*729+446] += + s[392];
gout[n*729+447] += + s[393];
gout[n*729+448] += + s[394];
gout[n*729+449] += + s[395];
gout[n*729+450] += + s[630];
gout[n*729+451] += + s[631];
gout[n*729+452] += + s[632];
gout[n*729+453] += + s[633];
gout[n*729+454] += + s[634];
gout[n*729+455] += + s[635];
gout[n*729+456] += + s[636];
gout[n*729+457] += + s[637];
gout[n*729+458] += + s[638];
gout[n*729+459] += + s[225];
gout[n*729+460] += + s[226];
gout[n*729+461] += + s[227];
gout[n*729+462] += + s[228];
gout[n*729+463] += + s[229];
gout[n*729+464] += + s[230];
gout[n*729+465] += + s[231];
gout[n*729+466] += + s[232];
gout[n*729+467] += + s[233];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[711];
gout[n*729+478] += + s[712];
gout[n*729+479] += + s[713];
gout[n*729+480] += + s[714];
gout[n*729+481] += + s[715];
gout[n*729+482] += + s[716];
gout[n*729+483] += + s[717];
gout[n*729+484] += + s[718];
gout[n*729+485] += + s[719];
gout[n*729+486] += + s[18];
gout[n*729+487] += + s[19];
gout[n*729+488] += + s[20];
gout[n*729+489] += + s[21];
gout[n*729+490] += + s[22];
gout[n*729+491] += + s[23];
gout[n*729+492] += + s[24];
gout[n*729+493] += + s[25];
gout[n*729+494] += + s[26];
gout[n*729+495] += + s[261];
gout[n*729+496] += + s[262];
gout[n*729+497] += + s[263];
gout[n*729+498] += + s[264];
gout[n*729+499] += + s[265];
gout[n*729+500] += + s[266];
gout[n*729+501] += + s[267];
gout[n*729+502] += + s[268];
gout[n*729+503] += + s[269];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[99];
gout[n*729+514] += + s[100];
gout[n*729+515] += + s[101];
gout[n*729+516] += + s[102];
gout[n*729+517] += + s[103];
gout[n*729+518] += + s[104];
gout[n*729+519] += + s[105];
gout[n*729+520] += + s[106];
gout[n*729+521] += + s[107];
gout[n*729+522] += + s[342];
gout[n*729+523] += + s[343];
gout[n*729+524] += + s[344];
gout[n*729+525] += + s[345];
gout[n*729+526] += + s[346];
gout[n*729+527] += + s[347];
gout[n*729+528] += + s[348];
gout[n*729+529] += + s[349];
gout[n*729+530] += + s[350];
gout[n*729+531] += + s[585];
gout[n*729+532] += + s[586];
gout[n*729+533] += + s[587];
gout[n*729+534] += + s[588];
gout[n*729+535] += + s[589];
gout[n*729+536] += + s[590];
gout[n*729+537] += + s[591];
gout[n*729+538] += + s[592];
gout[n*729+539] += + s[593];
gout[n*729+540] += + s[180];
gout[n*729+541] += + s[181];
gout[n*729+542] += + s[182];
gout[n*729+543] += + s[183];
gout[n*729+544] += + s[184];
gout[n*729+545] += + s[185];
gout[n*729+546] += + s[186];
gout[n*729+547] += + s[187];
gout[n*729+548] += + s[188];
gout[n*729+549] += + s[423];
gout[n*729+550] += + s[424];
gout[n*729+551] += + s[425];
gout[n*729+552] += + s[426];
gout[n*729+553] += + s[427];
gout[n*729+554] += + s[428];
gout[n*729+555] += + s[429];
gout[n*729+556] += + s[430];
gout[n*729+557] += + s[431];
gout[n*729+558] += + s[666];
gout[n*729+559] += + s[667];
gout[n*729+560] += + s[668];
gout[n*729+561] += + s[669];
gout[n*729+562] += + s[670];
gout[n*729+563] += + s[671];
gout[n*729+564] += + s[672];
gout[n*729+565] += + s[673];
gout[n*729+566] += + s[674];
gout[n*729+567] += + s[45];
gout[n*729+568] += + s[46];
gout[n*729+569] += + s[47];
gout[n*729+570] += + s[48];
gout[n*729+571] += + s[49];
gout[n*729+572] += + s[50];
gout[n*729+573] += + s[51];
gout[n*729+574] += + s[52];
gout[n*729+575] += + s[53];
gout[n*729+576] += + s[288];
gout[n*729+577] += + s[289];
gout[n*729+578] += + s[290];
gout[n*729+579] += + s[291];
gout[n*729+580] += + s[292];
gout[n*729+581] += + s[293];
gout[n*729+582] += + s[294];
gout[n*729+583] += + s[295];
gout[n*729+584] += + s[296];
gout[n*729+585] += + s[531];
gout[n*729+586] += + s[532];
gout[n*729+587] += + s[533];
gout[n*729+588] += + s[534];
gout[n*729+589] += + s[535];
gout[n*729+590] += + s[536];
gout[n*729+591] += + s[537];
gout[n*729+592] += + s[538];
gout[n*729+593] += + s[539];
gout[n*729+594] += + s[126];
gout[n*729+595] += + s[127];
gout[n*729+596] += + s[128];
gout[n*729+597] += + s[129];
gout[n*729+598] += + s[130];
gout[n*729+599] += + s[131];
gout[n*729+600] += + s[132];
gout[n*729+601] += + s[133];
gout[n*729+602] += + s[134];
gout[n*729+603] += + s[369];
gout[n*729+604] += + s[370];
gout[n*729+605] += + s[371];
gout[n*729+606] += + s[372];
gout[n*729+607] += + s[373];
gout[n*729+608] += + s[374];
gout[n*729+609] += + s[375];
gout[n*729+610] += + s[376];
gout[n*729+611] += + s[377];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[207];
gout[n*729+622] += + s[208];
gout[n*729+623] += + s[209];
gout[n*729+624] += + s[210];
gout[n*729+625] += + s[211];
gout[n*729+626] += + s[212];
gout[n*729+627] += + s[213];
gout[n*729+628] += + s[214];
gout[n*729+629] += + s[215];
gout[n*729+630] += + s[450];
gout[n*729+631] += + s[451];
gout[n*729+632] += + s[452];
gout[n*729+633] += + s[453];
gout[n*729+634] += + s[454];
gout[n*729+635] += + s[455];
gout[n*729+636] += + s[456];
gout[n*729+637] += + s[457];
gout[n*729+638] += + s[458];
gout[n*729+639] += + s[693];
gout[n*729+640] += + s[694];
gout[n*729+641] += + s[695];
gout[n*729+642] += + s[696];
gout[n*729+643] += + s[697];
gout[n*729+644] += + s[698];
gout[n*729+645] += + s[699];
gout[n*729+646] += + s[700];
gout[n*729+647] += + s[701];
gout[n*729+648] += + s[72];
gout[n*729+649] += + s[73];
gout[n*729+650] += + s[74];
gout[n*729+651] += + s[75];
gout[n*729+652] += + s[76];
gout[n*729+653] += + s[77];
gout[n*729+654] += + s[78];
gout[n*729+655] += + s[79];
gout[n*729+656] += + s[80];
gout[n*729+657] += + s[315];
gout[n*729+658] += + s[316];
gout[n*729+659] += + s[317];
gout[n*729+660] += + s[318];
gout[n*729+661] += + s[319];
gout[n*729+662] += + s[320];
gout[n*729+663] += + s[321];
gout[n*729+664] += + s[322];
gout[n*729+665] += + s[323];
gout[n*729+666] += + s[558];
gout[n*729+667] += + s[559];
gout[n*729+668] += + s[560];
gout[n*729+669] += + s[561];
gout[n*729+670] += + s[562];
gout[n*729+671] += + s[563];
gout[n*729+672] += + s[564];
gout[n*729+673] += + s[565];
gout[n*729+674] += + s[566];
gout[n*729+675] += + s[153];
gout[n*729+676] += + s[154];
gout[n*729+677] += + s[155];
gout[n*729+678] += + s[156];
gout[n*729+679] += + s[157];
gout[n*729+680] += + s[158];
gout[n*729+681] += + s[159];
gout[n*729+682] += + s[160];
gout[n*729+683] += + s[161];
gout[n*729+684] += + s[396];
gout[n*729+685] += + s[397];
gout[n*729+686] += + s[398];
gout[n*729+687] += + s[399];
gout[n*729+688] += + s[400];
gout[n*729+689] += + s[401];
gout[n*729+690] += + s[402];
gout[n*729+691] += + s[403];
gout[n*729+692] += + s[404];
gout[n*729+693] += + s[639];
gout[n*729+694] += + s[640];
gout[n*729+695] += + s[641];
gout[n*729+696] += + s[642];
gout[n*729+697] += + s[643];
gout[n*729+698] += + s[644];
gout[n*729+699] += + s[645];
gout[n*729+700] += + s[646];
gout[n*729+701] += + s[647];
gout[n*729+702] += + s[234];
gout[n*729+703] += + s[235];
gout[n*729+704] += + s[236];
gout[n*729+705] += + s[237];
gout[n*729+706] += + s[238];
gout[n*729+707] += + s[239];
gout[n*729+708] += + s[240];
gout[n*729+709] += + s[241];
gout[n*729+710] += + s[242];
gout[n*729+711] += + s[477];
gout[n*729+712] += + s[478];
gout[n*729+713] += + s[479];
gout[n*729+714] += + s[480];
gout[n*729+715] += + s[481];
gout[n*729+716] += + s[482];
gout[n*729+717] += + s[483];
gout[n*729+718] += + s[484];
gout[n*729+719] += + s[485];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipipipnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipipnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipipnip_cart
CACHE_SIZE_T int1e_ipipipipnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipipnip_sph
CACHE_SIZE_T int1e_ipipipipnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipipnip_spinor
ALL_CINT1E(int1e_ipipipipnip)
ALL_CINT1E_FORTRAN_(int1e_ipipipipnip)
/* <NABLA NABLA i|RJ |NABLA NABLA j> */
void CINTgout1e_int1e_ipipnipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipnipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipnipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipnipip_cart
CACHE_SIZE_T int1e_ipipnipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipnipip_sph
CACHE_SIZE_T int1e_ipipnipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipnipip_spinor
ALL_CINT1E(int1e_ipipnipip)
ALL_CINT1E_FORTRAN_(int1e_ipipnipip)
/* <i|RJ RJ |NABLA j> */
void CINTgout1e_int1e_nnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[27];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_nnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nnip_cart
CACHE_SIZE_T int1e_nnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nnip_sph
CACHE_SIZE_T int1e_nnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nnip_spinor
ALL_CINT1E(int1e_nnip)
ALL_CINT1E_FORTRAN_(int1e_nnip)
/* <i|RJ RJ |NABLA NABLA j> */
void CINTgout1e_int1e_nnipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_nnipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nnipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nnipip_cart
CACHE_SIZE_T int1e_nnipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nnipip_sph
CACHE_SIZE_T int1e_nnipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nnipip_spinor
ALL_CINT1E(int1e_nnipip)
ALL_CINT1E_FORTRAN_(int1e_nnipip)
/* <i|RJ RJ |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_nnipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_nnipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nnipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nnipipip_cart
CACHE_SIZE_T int1e_nnipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nnipipip_sph
CACHE_SIZE_T int1e_nnipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nnipipip_spinor
ALL_CINT1E(int1e_nnipipip)
ALL_CINT1E_FORTRAN_(int1e_nnipipip)
/* <i|RJ RJ |NABLA NABLA NABLA NABLA j> */
void CINTgout1e_int1e_nnipipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g32, g0, envs->i_l+0, envs->j_l+5, 0);
G1E_D_J(g33, g32, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g34, g32, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g35, g34, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g36, g32, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g37, g36, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g38, g36, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g39, g38, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g40, g32, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g41, g40, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g42, g40, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g43, g42, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g44, g40, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g45, g44, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g46, g44, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g47, g46, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g48, g32, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g49, g48, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g50, g48, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g51, g50, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g52, g48, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g53, g52, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g54, g52, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g55, g54, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g56, g48, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g57, g56, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g58, g56, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g59, g58, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g60, g56, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g61, g60, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g62, g60, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g63, g62, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_nnipipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nnipipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nnipipipip_cart
CACHE_SIZE_T int1e_nnipipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nnipipipip_sph
CACHE_SIZE_T int1e_nnipipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnipipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nnipipipip_spinor
ALL_CINT1E(int1e_nnipipipip)
ALL_CINT1E_FORTRAN_(int1e_nnipipipip)
/* <NABLA i|RJ RJ |j> */
void CINTgout1e_int1e_ipnn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[27];
G1E_RCJ(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_ipnn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnn_cart
CACHE_SIZE_T int1e_ipnn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnn_sph
CACHE_SIZE_T int1e_ipnn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnn_spinor
ALL_CINT1E(int1e_ipnn)
ALL_CINT1E_FORTRAN_(int1e_ipnn)
/* <NABLA NABLA i|RJ RJ |j> */
void CINTgout1e_int1e_ipipnn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[27];
gout[n*81+10] = + s[28];
gout[n*81+11] = + s[29];
gout[n*81+12] = + s[30];
gout[n*81+13] = + s[31];
gout[n*81+14] = + s[32];
gout[n*81+15] = + s[33];
gout[n*81+16] = + s[34];
gout[n*81+17] = + s[35];
gout[n*81+18] = + s[54];
gout[n*81+19] = + s[55];
gout[n*81+20] = + s[56];
gout[n*81+21] = + s[57];
gout[n*81+22] = + s[58];
gout[n*81+23] = + s[59];
gout[n*81+24] = + s[60];
gout[n*81+25] = + s[61];
gout[n*81+26] = + s[62];
gout[n*81+27] = + s[9];
gout[n*81+28] = + s[10];
gout[n*81+29] = + s[11];
gout[n*81+30] = + s[12];
gout[n*81+31] = + s[13];
gout[n*81+32] = + s[14];
gout[n*81+33] = + s[15];
gout[n*81+34] = + s[16];
gout[n*81+35] = + s[17];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[63];
gout[n*81+46] = + s[64];
gout[n*81+47] = + s[65];
gout[n*81+48] = + s[66];
gout[n*81+49] = + s[67];
gout[n*81+50] = + s[68];
gout[n*81+51] = + s[69];
gout[n*81+52] = + s[70];
gout[n*81+53] = + s[71];
gout[n*81+54] = + s[18];
gout[n*81+55] = + s[19];
gout[n*81+56] = + s[20];
gout[n*81+57] = + s[21];
gout[n*81+58] = + s[22];
gout[n*81+59] = + s[23];
gout[n*81+60] = + s[24];
gout[n*81+61] = + s[25];
gout[n*81+62] = + s[26];
gout[n*81+63] = + s[45];
gout[n*81+64] = + s[46];
gout[n*81+65] = + s[47];
gout[n*81+66] = + s[48];
gout[n*81+67] = + s[49];
gout[n*81+68] = + s[50];
gout[n*81+69] = + s[51];
gout[n*81+70] = + s[52];
gout[n*81+71] = + s[53];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[27];
gout[n*81+10] += + s[28];
gout[n*81+11] += + s[29];
gout[n*81+12] += + s[30];
gout[n*81+13] += + s[31];
gout[n*81+14] += + s[32];
gout[n*81+15] += + s[33];
gout[n*81+16] += + s[34];
gout[n*81+17] += + s[35];
gout[n*81+18] += + s[54];
gout[n*81+19] += + s[55];
gout[n*81+20] += + s[56];
gout[n*81+21] += + s[57];
gout[n*81+22] += + s[58];
gout[n*81+23] += + s[59];
gout[n*81+24] += + s[60];
gout[n*81+25] += + s[61];
gout[n*81+26] += + s[62];
gout[n*81+27] += + s[9];
gout[n*81+28] += + s[10];
gout[n*81+29] += + s[11];
gout[n*81+30] += + s[12];
gout[n*81+31] += + s[13];
gout[n*81+32] += + s[14];
gout[n*81+33] += + s[15];
gout[n*81+34] += + s[16];
gout[n*81+35] += + s[17];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[63];
gout[n*81+46] += + s[64];
gout[n*81+47] += + s[65];
gout[n*81+48] += + s[66];
gout[n*81+49] += + s[67];
gout[n*81+50] += + s[68];
gout[n*81+51] += + s[69];
gout[n*81+52] += + s[70];
gout[n*81+53] += + s[71];
gout[n*81+54] += + s[18];
gout[n*81+55] += + s[19];
gout[n*81+56] += + s[20];
gout[n*81+57] += + s[21];
gout[n*81+58] += + s[22];
gout[n*81+59] += + s[23];
gout[n*81+60] += + s[24];
gout[n*81+61] += + s[25];
gout[n*81+62] += + s[26];
gout[n*81+63] += + s[45];
gout[n*81+64] += + s[46];
gout[n*81+65] += + s[47];
gout[n*81+66] += + s[48];
gout[n*81+67] += + s[49];
gout[n*81+68] += + s[50];
gout[n*81+69] += + s[51];
gout[n*81+70] += + s[52];
gout[n*81+71] += + s[53];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipipnn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipnn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipnn_cart
CACHE_SIZE_T int1e_ipipnn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipnn_sph
CACHE_SIZE_T int1e_ipipnn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipnn_spinor
ALL_CINT1E(int1e_ipipnn)
ALL_CINT1E_FORTRAN_(int1e_ipipnn)
/* <NABLA NABLA NABLA i|RJ RJ |j> */
void CINTgout1e_int1e_ipipipnn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_RCJ(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[81];
gout[n*243+10] = + s[82];
gout[n*243+11] = + s[83];
gout[n*243+12] = + s[84];
gout[n*243+13] = + s[85];
gout[n*243+14] = + s[86];
gout[n*243+15] = + s[87];
gout[n*243+16] = + s[88];
gout[n*243+17] = + s[89];
gout[n*243+18] = + s[162];
gout[n*243+19] = + s[163];
gout[n*243+20] = + s[164];
gout[n*243+21] = + s[165];
gout[n*243+22] = + s[166];
gout[n*243+23] = + s[167];
gout[n*243+24] = + s[168];
gout[n*243+25] = + s[169];
gout[n*243+26] = + s[170];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[108];
gout[n*243+37] = + s[109];
gout[n*243+38] = + s[110];
gout[n*243+39] = + s[111];
gout[n*243+40] = + s[112];
gout[n*243+41] = + s[113];
gout[n*243+42] = + s[114];
gout[n*243+43] = + s[115];
gout[n*243+44] = + s[116];
gout[n*243+45] = + s[189];
gout[n*243+46] = + s[190];
gout[n*243+47] = + s[191];
gout[n*243+48] = + s[192];
gout[n*243+49] = + s[193];
gout[n*243+50] = + s[194];
gout[n*243+51] = + s[195];
gout[n*243+52] = + s[196];
gout[n*243+53] = + s[197];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[135];
gout[n*243+64] = + s[136];
gout[n*243+65] = + s[137];
gout[n*243+66] = + s[138];
gout[n*243+67] = + s[139];
gout[n*243+68] = + s[140];
gout[n*243+69] = + s[141];
gout[n*243+70] = + s[142];
gout[n*243+71] = + s[143];
gout[n*243+72] = + s[216];
gout[n*243+73] = + s[217];
gout[n*243+74] = + s[218];
gout[n*243+75] = + s[219];
gout[n*243+76] = + s[220];
gout[n*243+77] = + s[221];
gout[n*243+78] = + s[222];
gout[n*243+79] = + s[223];
gout[n*243+80] = + s[224];
gout[n*243+81] = + s[9];
gout[n*243+82] = + s[10];
gout[n*243+83] = + s[11];
gout[n*243+84] = + s[12];
gout[n*243+85] = + s[13];
gout[n*243+86] = + s[14];
gout[n*243+87] = + s[15];
gout[n*243+88] = + s[16];
gout[n*243+89] = + s[17];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[171];
gout[n*243+100] = + s[172];
gout[n*243+101] = + s[173];
gout[n*243+102] = + s[174];
gout[n*243+103] = + s[175];
gout[n*243+104] = + s[176];
gout[n*243+105] = + s[177];
gout[n*243+106] = + s[178];
gout[n*243+107] = + s[179];
gout[n*243+108] = + s[36];
gout[n*243+109] = + s[37];
gout[n*243+110] = + s[38];
gout[n*243+111] = + s[39];
gout[n*243+112] = + s[40];
gout[n*243+113] = + s[41];
gout[n*243+114] = + s[42];
gout[n*243+115] = + s[43];
gout[n*243+116] = + s[44];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[198];
gout[n*243+127] = + s[199];
gout[n*243+128] = + s[200];
gout[n*243+129] = + s[201];
gout[n*243+130] = + s[202];
gout[n*243+131] = + s[203];
gout[n*243+132] = + s[204];
gout[n*243+133] = + s[205];
gout[n*243+134] = + s[206];
gout[n*243+135] = + s[63];
gout[n*243+136] = + s[64];
gout[n*243+137] = + s[65];
gout[n*243+138] = + s[66];
gout[n*243+139] = + s[67];
gout[n*243+140] = + s[68];
gout[n*243+141] = + s[69];
gout[n*243+142] = + s[70];
gout[n*243+143] = + s[71];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[225];
gout[n*243+154] = + s[226];
gout[n*243+155] = + s[227];
gout[n*243+156] = + s[228];
gout[n*243+157] = + s[229];
gout[n*243+158] = + s[230];
gout[n*243+159] = + s[231];
gout[n*243+160] = + s[232];
gout[n*243+161] = + s[233];
gout[n*243+162] = + s[18];
gout[n*243+163] = + s[19];
gout[n*243+164] = + s[20];
gout[n*243+165] = + s[21];
gout[n*243+166] = + s[22];
gout[n*243+167] = + s[23];
gout[n*243+168] = + s[24];
gout[n*243+169] = + s[25];
gout[n*243+170] = + s[26];
gout[n*243+171] = + s[99];
gout[n*243+172] = + s[100];
gout[n*243+173] = + s[101];
gout[n*243+174] = + s[102];
gout[n*243+175] = + s[103];
gout[n*243+176] = + s[104];
gout[n*243+177] = + s[105];
gout[n*243+178] = + s[106];
gout[n*243+179] = + s[107];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[45];
gout[n*243+190] = + s[46];
gout[n*243+191] = + s[47];
gout[n*243+192] = + s[48];
gout[n*243+193] = + s[49];
gout[n*243+194] = + s[50];
gout[n*243+195] = + s[51];
gout[n*243+196] = + s[52];
gout[n*243+197] = + s[53];
gout[n*243+198] = + s[126];
gout[n*243+199] = + s[127];
gout[n*243+200] = + s[128];
gout[n*243+201] = + s[129];
gout[n*243+202] = + s[130];
gout[n*243+203] = + s[131];
gout[n*243+204] = + s[132];
gout[n*243+205] = + s[133];
gout[n*243+206] = + s[134];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[72];
gout[n*243+217] = + s[73];
gout[n*243+218] = + s[74];
gout[n*243+219] = + s[75];
gout[n*243+220] = + s[76];
gout[n*243+221] = + s[77];
gout[n*243+222] = + s[78];
gout[n*243+223] = + s[79];
gout[n*243+224] = + s[80];
gout[n*243+225] = + s[153];
gout[n*243+226] = + s[154];
gout[n*243+227] = + s[155];
gout[n*243+228] = + s[156];
gout[n*243+229] = + s[157];
gout[n*243+230] = + s[158];
gout[n*243+231] = + s[159];
gout[n*243+232] = + s[160];
gout[n*243+233] = + s[161];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[81];
gout[n*243+10] += + s[82];
gout[n*243+11] += + s[83];
gout[n*243+12] += + s[84];
gout[n*243+13] += + s[85];
gout[n*243+14] += + s[86];
gout[n*243+15] += + s[87];
gout[n*243+16] += + s[88];
gout[n*243+17] += + s[89];
gout[n*243+18] += + s[162];
gout[n*243+19] += + s[163];
gout[n*243+20] += + s[164];
gout[n*243+21] += + s[165];
gout[n*243+22] += + s[166];
gout[n*243+23] += + s[167];
gout[n*243+24] += + s[168];
gout[n*243+25] += + s[169];
gout[n*243+26] += + s[170];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[108];
gout[n*243+37] += + s[109];
gout[n*243+38] += + s[110];
gout[n*243+39] += + s[111];
gout[n*243+40] += + s[112];
gout[n*243+41] += + s[113];
gout[n*243+42] += + s[114];
gout[n*243+43] += + s[115];
gout[n*243+44] += + s[116];
gout[n*243+45] += + s[189];
gout[n*243+46] += + s[190];
gout[n*243+47] += + s[191];
gout[n*243+48] += + s[192];
gout[n*243+49] += + s[193];
gout[n*243+50] += + s[194];
gout[n*243+51] += + s[195];
gout[n*243+52] += + s[196];
gout[n*243+53] += + s[197];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[135];
gout[n*243+64] += + s[136];
gout[n*243+65] += + s[137];
gout[n*243+66] += + s[138];
gout[n*243+67] += + s[139];
gout[n*243+68] += + s[140];
gout[n*243+69] += + s[141];
gout[n*243+70] += + s[142];
gout[n*243+71] += + s[143];
gout[n*243+72] += + s[216];
gout[n*243+73] += + s[217];
gout[n*243+74] += + s[218];
gout[n*243+75] += + s[219];
gout[n*243+76] += + s[220];
gout[n*243+77] += + s[221];
gout[n*243+78] += + s[222];
gout[n*243+79] += + s[223];
gout[n*243+80] += + s[224];
gout[n*243+81] += + s[9];
gout[n*243+82] += + s[10];
gout[n*243+83] += + s[11];
gout[n*243+84] += + s[12];
gout[n*243+85] += + s[13];
gout[n*243+86] += + s[14];
gout[n*243+87] += + s[15];
gout[n*243+88] += + s[16];
gout[n*243+89] += + s[17];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[171];
gout[n*243+100] += + s[172];
gout[n*243+101] += + s[173];
gout[n*243+102] += + s[174];
gout[n*243+103] += + s[175];
gout[n*243+104] += + s[176];
gout[n*243+105] += + s[177];
gout[n*243+106] += + s[178];
gout[n*243+107] += + s[179];
gout[n*243+108] += + s[36];
gout[n*243+109] += + s[37];
gout[n*243+110] += + s[38];
gout[n*243+111] += + s[39];
gout[n*243+112] += + s[40];
gout[n*243+113] += + s[41];
gout[n*243+114] += + s[42];
gout[n*243+115] += + s[43];
gout[n*243+116] += + s[44];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[198];
gout[n*243+127] += + s[199];
gout[n*243+128] += + s[200];
gout[n*243+129] += + s[201];
gout[n*243+130] += + s[202];
gout[n*243+131] += + s[203];
gout[n*243+132] += + s[204];
gout[n*243+133] += + s[205];
gout[n*243+134] += + s[206];
gout[n*243+135] += + s[63];
gout[n*243+136] += + s[64];
gout[n*243+137] += + s[65];
gout[n*243+138] += + s[66];
gout[n*243+139] += + s[67];
gout[n*243+140] += + s[68];
gout[n*243+141] += + s[69];
gout[n*243+142] += + s[70];
gout[n*243+143] += + s[71];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[225];
gout[n*243+154] += + s[226];
gout[n*243+155] += + s[227];
gout[n*243+156] += + s[228];
gout[n*243+157] += + s[229];
gout[n*243+158] += + s[230];
gout[n*243+159] += + s[231];
gout[n*243+160] += + s[232];
gout[n*243+161] += + s[233];
gout[n*243+162] += + s[18];
gout[n*243+163] += + s[19];
gout[n*243+164] += + s[20];
gout[n*243+165] += + s[21];
gout[n*243+166] += + s[22];
gout[n*243+167] += + s[23];
gout[n*243+168] += + s[24];
gout[n*243+169] += + s[25];
gout[n*243+170] += + s[26];
gout[n*243+171] += + s[99];
gout[n*243+172] += + s[100];
gout[n*243+173] += + s[101];
gout[n*243+174] += + s[102];
gout[n*243+175] += + s[103];
gout[n*243+176] += + s[104];
gout[n*243+177] += + s[105];
gout[n*243+178] += + s[106];
gout[n*243+179] += + s[107];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[45];
gout[n*243+190] += + s[46];
gout[n*243+191] += + s[47];
gout[n*243+192] += + s[48];
gout[n*243+193] += + s[49];
gout[n*243+194] += + s[50];
gout[n*243+195] += + s[51];
gout[n*243+196] += + s[52];
gout[n*243+197] += + s[53];
gout[n*243+198] += + s[126];
gout[n*243+199] += + s[127];
gout[n*243+200] += + s[128];
gout[n*243+201] += + s[129];
gout[n*243+202] += + s[130];
gout[n*243+203] += + s[131];
gout[n*243+204] += + s[132];
gout[n*243+205] += + s[133];
gout[n*243+206] += + s[134];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[72];
gout[n*243+217] += + s[73];
gout[n*243+218] += + s[74];
gout[n*243+219] += + s[75];
gout[n*243+220] += + s[76];
gout[n*243+221] += + s[77];
gout[n*243+222] += + s[78];
gout[n*243+223] += + s[79];
gout[n*243+224] += + s[80];
gout[n*243+225] += + s[153];
gout[n*243+226] += + s[154];
gout[n*243+227] += + s[155];
gout[n*243+228] += + s[156];
gout[n*243+229] += + s[157];
gout[n*243+230] += + s[158];
gout[n*243+231] += + s[159];
gout[n*243+232] += + s[160];
gout[n*243+233] += + s[161];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipipnn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipnn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipnn_cart
CACHE_SIZE_T int1e_ipipipnn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipnn_sph
CACHE_SIZE_T int1e_ipipipnn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipnn_spinor
ALL_CINT1E(int1e_ipipipnn)
ALL_CINT1E_FORTRAN_(int1e_ipipipnn)
/* <NABLA NABLA NABLA NABLA i|RJ RJ |j> */
void CINTgout1e_int1e_ipipipipnn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_RCJ(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+4, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+4, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[243];
gout[n*729+10] = + s[244];
gout[n*729+11] = + s[245];
gout[n*729+12] = + s[246];
gout[n*729+13] = + s[247];
gout[n*729+14] = + s[248];
gout[n*729+15] = + s[249];
gout[n*729+16] = + s[250];
gout[n*729+17] = + s[251];
gout[n*729+18] = + s[486];
gout[n*729+19] = + s[487];
gout[n*729+20] = + s[488];
gout[n*729+21] = + s[489];
gout[n*729+22] = + s[490];
gout[n*729+23] = + s[491];
gout[n*729+24] = + s[492];
gout[n*729+25] = + s[493];
gout[n*729+26] = + s[494];
gout[n*729+27] = + s[81];
gout[n*729+28] = + s[82];
gout[n*729+29] = + s[83];
gout[n*729+30] = + s[84];
gout[n*729+31] = + s[85];
gout[n*729+32] = + s[86];
gout[n*729+33] = + s[87];
gout[n*729+34] = + s[88];
gout[n*729+35] = + s[89];
gout[n*729+36] = + s[324];
gout[n*729+37] = + s[325];
gout[n*729+38] = + s[326];
gout[n*729+39] = + s[327];
gout[n*729+40] = + s[328];
gout[n*729+41] = + s[329];
gout[n*729+42] = + s[330];
gout[n*729+43] = + s[331];
gout[n*729+44] = + s[332];
gout[n*729+45] = + s[567];
gout[n*729+46] = + s[568];
gout[n*729+47] = + s[569];
gout[n*729+48] = + s[570];
gout[n*729+49] = + s[571];
gout[n*729+50] = + s[572];
gout[n*729+51] = + s[573];
gout[n*729+52] = + s[574];
gout[n*729+53] = + s[575];
gout[n*729+54] = + s[162];
gout[n*729+55] = + s[163];
gout[n*729+56] = + s[164];
gout[n*729+57] = + s[165];
gout[n*729+58] = + s[166];
gout[n*729+59] = + s[167];
gout[n*729+60] = + s[168];
gout[n*729+61] = + s[169];
gout[n*729+62] = + s[170];
gout[n*729+63] = + s[405];
gout[n*729+64] = + s[406];
gout[n*729+65] = + s[407];
gout[n*729+66] = + s[408];
gout[n*729+67] = + s[409];
gout[n*729+68] = + s[410];
gout[n*729+69] = + s[411];
gout[n*729+70] = + s[412];
gout[n*729+71] = + s[413];
gout[n*729+72] = + s[648];
gout[n*729+73] = + s[649];
gout[n*729+74] = + s[650];
gout[n*729+75] = + s[651];
gout[n*729+76] = + s[652];
gout[n*729+77] = + s[653];
gout[n*729+78] = + s[654];
gout[n*729+79] = + s[655];
gout[n*729+80] = + s[656];
gout[n*729+81] = + s[27];
gout[n*729+82] = + s[28];
gout[n*729+83] = + s[29];
gout[n*729+84] = + s[30];
gout[n*729+85] = + s[31];
gout[n*729+86] = + s[32];
gout[n*729+87] = + s[33];
gout[n*729+88] = + s[34];
gout[n*729+89] = + s[35];
gout[n*729+90] = + s[270];
gout[n*729+91] = + s[271];
gout[n*729+92] = + s[272];
gout[n*729+93] = + s[273];
gout[n*729+94] = + s[274];
gout[n*729+95] = + s[275];
gout[n*729+96] = + s[276];
gout[n*729+97] = + s[277];
gout[n*729+98] = + s[278];
gout[n*729+99] = + s[513];
gout[n*729+100] = + s[514];
gout[n*729+101] = + s[515];
gout[n*729+102] = + s[516];
gout[n*729+103] = + s[517];
gout[n*729+104] = + s[518];
gout[n*729+105] = + s[519];
gout[n*729+106] = + s[520];
gout[n*729+107] = + s[521];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[351];
gout[n*729+118] = + s[352];
gout[n*729+119] = + s[353];
gout[n*729+120] = + s[354];
gout[n*729+121] = + s[355];
gout[n*729+122] = + s[356];
gout[n*729+123] = + s[357];
gout[n*729+124] = + s[358];
gout[n*729+125] = + s[359];
gout[n*729+126] = + s[594];
gout[n*729+127] = + s[595];
gout[n*729+128] = + s[596];
gout[n*729+129] = + s[597];
gout[n*729+130] = + s[598];
gout[n*729+131] = + s[599];
gout[n*729+132] = + s[600];
gout[n*729+133] = + s[601];
gout[n*729+134] = + s[602];
gout[n*729+135] = + s[189];
gout[n*729+136] = + s[190];
gout[n*729+137] = + s[191];
gout[n*729+138] = + s[192];
gout[n*729+139] = + s[193];
gout[n*729+140] = + s[194];
gout[n*729+141] = + s[195];
gout[n*729+142] = + s[196];
gout[n*729+143] = + s[197];
gout[n*729+144] = + s[432];
gout[n*729+145] = + s[433];
gout[n*729+146] = + s[434];
gout[n*729+147] = + s[435];
gout[n*729+148] = + s[436];
gout[n*729+149] = + s[437];
gout[n*729+150] = + s[438];
gout[n*729+151] = + s[439];
gout[n*729+152] = + s[440];
gout[n*729+153] = + s[675];
gout[n*729+154] = + s[676];
gout[n*729+155] = + s[677];
gout[n*729+156] = + s[678];
gout[n*729+157] = + s[679];
gout[n*729+158] = + s[680];
gout[n*729+159] = + s[681];
gout[n*729+160] = + s[682];
gout[n*729+161] = + s[683];
gout[n*729+162] = + s[54];
gout[n*729+163] = + s[55];
gout[n*729+164] = + s[56];
gout[n*729+165] = + s[57];
gout[n*729+166] = + s[58];
gout[n*729+167] = + s[59];
gout[n*729+168] = + s[60];
gout[n*729+169] = + s[61];
gout[n*729+170] = + s[62];
gout[n*729+171] = + s[297];
gout[n*729+172] = + s[298];
gout[n*729+173] = + s[299];
gout[n*729+174] = + s[300];
gout[n*729+175] = + s[301];
gout[n*729+176] = + s[302];
gout[n*729+177] = + s[303];
gout[n*729+178] = + s[304];
gout[n*729+179] = + s[305];
gout[n*729+180] = + s[540];
gout[n*729+181] = + s[541];
gout[n*729+182] = + s[542];
gout[n*729+183] = + s[543];
gout[n*729+184] = + s[544];
gout[n*729+185] = + s[545];
gout[n*729+186] = + s[546];
gout[n*729+187] = + s[547];
gout[n*729+188] = + s[548];
gout[n*729+189] = + s[135];
gout[n*729+190] = + s[136];
gout[n*729+191] = + s[137];
gout[n*729+192] = + s[138];
gout[n*729+193] = + s[139];
gout[n*729+194] = + s[140];
gout[n*729+195] = + s[141];
gout[n*729+196] = + s[142];
gout[n*729+197] = + s[143];
gout[n*729+198] = + s[378];
gout[n*729+199] = + s[379];
gout[n*729+200] = + s[380];
gout[n*729+201] = + s[381];
gout[n*729+202] = + s[382];
gout[n*729+203] = + s[383];
gout[n*729+204] = + s[384];
gout[n*729+205] = + s[385];
gout[n*729+206] = + s[386];
gout[n*729+207] = + s[621];
gout[n*729+208] = + s[622];
gout[n*729+209] = + s[623];
gout[n*729+210] = + s[624];
gout[n*729+211] = + s[625];
gout[n*729+212] = + s[626];
gout[n*729+213] = + s[627];
gout[n*729+214] = + s[628];
gout[n*729+215] = + s[629];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[459];
gout[n*729+226] = + s[460];
gout[n*729+227] = + s[461];
gout[n*729+228] = + s[462];
gout[n*729+229] = + s[463];
gout[n*729+230] = + s[464];
gout[n*729+231] = + s[465];
gout[n*729+232] = + s[466];
gout[n*729+233] = + s[467];
gout[n*729+234] = + s[702];
gout[n*729+235] = + s[703];
gout[n*729+236] = + s[704];
gout[n*729+237] = + s[705];
gout[n*729+238] = + s[706];
gout[n*729+239] = + s[707];
gout[n*729+240] = + s[708];
gout[n*729+241] = + s[709];
gout[n*729+242] = + s[710];
gout[n*729+243] = + s[9];
gout[n*729+244] = + s[10];
gout[n*729+245] = + s[11];
gout[n*729+246] = + s[12];
gout[n*729+247] = + s[13];
gout[n*729+248] = + s[14];
gout[n*729+249] = + s[15];
gout[n*729+250] = + s[16];
gout[n*729+251] = + s[17];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[495];
gout[n*729+262] = + s[496];
gout[n*729+263] = + s[497];
gout[n*729+264] = + s[498];
gout[n*729+265] = + s[499];
gout[n*729+266] = + s[500];
gout[n*729+267] = + s[501];
gout[n*729+268] = + s[502];
gout[n*729+269] = + s[503];
gout[n*729+270] = + s[90];
gout[n*729+271] = + s[91];
gout[n*729+272] = + s[92];
gout[n*729+273] = + s[93];
gout[n*729+274] = + s[94];
gout[n*729+275] = + s[95];
gout[n*729+276] = + s[96];
gout[n*729+277] = + s[97];
gout[n*729+278] = + s[98];
gout[n*729+279] = + s[333];
gout[n*729+280] = + s[334];
gout[n*729+281] = + s[335];
gout[n*729+282] = + s[336];
gout[n*729+283] = + s[337];
gout[n*729+284] = + s[338];
gout[n*729+285] = + s[339];
gout[n*729+286] = + s[340];
gout[n*729+287] = + s[341];
gout[n*729+288] = + s[576];
gout[n*729+289] = + s[577];
gout[n*729+290] = + s[578];
gout[n*729+291] = + s[579];
gout[n*729+292] = + s[580];
gout[n*729+293] = + s[581];
gout[n*729+294] = + s[582];
gout[n*729+295] = + s[583];
gout[n*729+296] = + s[584];
gout[n*729+297] = + s[171];
gout[n*729+298] = + s[172];
gout[n*729+299] = + s[173];
gout[n*729+300] = + s[174];
gout[n*729+301] = + s[175];
gout[n*729+302] = + s[176];
gout[n*729+303] = + s[177];
gout[n*729+304] = + s[178];
gout[n*729+305] = + s[179];
gout[n*729+306] = + s[414];
gout[n*729+307] = + s[415];
gout[n*729+308] = + s[416];
gout[n*729+309] = + s[417];
gout[n*729+310] = + s[418];
gout[n*729+311] = + s[419];
gout[n*729+312] = + s[420];
gout[n*729+313] = + s[421];
gout[n*729+314] = + s[422];
gout[n*729+315] = + s[657];
gout[n*729+316] = + s[658];
gout[n*729+317] = + s[659];
gout[n*729+318] = + s[660];
gout[n*729+319] = + s[661];
gout[n*729+320] = + s[662];
gout[n*729+321] = + s[663];
gout[n*729+322] = + s[664];
gout[n*729+323] = + s[665];
gout[n*729+324] = + s[36];
gout[n*729+325] = + s[37];
gout[n*729+326] = + s[38];
gout[n*729+327] = + s[39];
gout[n*729+328] = + s[40];
gout[n*729+329] = + s[41];
gout[n*729+330] = + s[42];
gout[n*729+331] = + s[43];
gout[n*729+332] = + s[44];
gout[n*729+333] = + s[279];
gout[n*729+334] = + s[280];
gout[n*729+335] = + s[281];
gout[n*729+336] = + s[282];
gout[n*729+337] = + s[283];
gout[n*729+338] = + s[284];
gout[n*729+339] = + s[285];
gout[n*729+340] = + s[286];
gout[n*729+341] = + s[287];
gout[n*729+342] = + s[522];
gout[n*729+343] = + s[523];
gout[n*729+344] = + s[524];
gout[n*729+345] = + s[525];
gout[n*729+346] = + s[526];
gout[n*729+347] = + s[527];
gout[n*729+348] = + s[528];
gout[n*729+349] = + s[529];
gout[n*729+350] = + s[530];
gout[n*729+351] = + s[117];
gout[n*729+352] = + s[118];
gout[n*729+353] = + s[119];
gout[n*729+354] = + s[120];
gout[n*729+355] = + s[121];
gout[n*729+356] = + s[122];
gout[n*729+357] = + s[123];
gout[n*729+358] = + s[124];
gout[n*729+359] = + s[125];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[603];
gout[n*729+370] = + s[604];
gout[n*729+371] = + s[605];
gout[n*729+372] = + s[606];
gout[n*729+373] = + s[607];
gout[n*729+374] = + s[608];
gout[n*729+375] = + s[609];
gout[n*729+376] = + s[610];
gout[n*729+377] = + s[611];
gout[n*729+378] = + s[198];
gout[n*729+379] = + s[199];
gout[n*729+380] = + s[200];
gout[n*729+381] = + s[201];
gout[n*729+382] = + s[202];
gout[n*729+383] = + s[203];
gout[n*729+384] = + s[204];
gout[n*729+385] = + s[205];
gout[n*729+386] = + s[206];
gout[n*729+387] = + s[441];
gout[n*729+388] = + s[442];
gout[n*729+389] = + s[443];
gout[n*729+390] = + s[444];
gout[n*729+391] = + s[445];
gout[n*729+392] = + s[446];
gout[n*729+393] = + s[447];
gout[n*729+394] = + s[448];
gout[n*729+395] = + s[449];
gout[n*729+396] = + s[684];
gout[n*729+397] = + s[685];
gout[n*729+398] = + s[686];
gout[n*729+399] = + s[687];
gout[n*729+400] = + s[688];
gout[n*729+401] = + s[689];
gout[n*729+402] = + s[690];
gout[n*729+403] = + s[691];
gout[n*729+404] = + s[692];
gout[n*729+405] = + s[63];
gout[n*729+406] = + s[64];
gout[n*729+407] = + s[65];
gout[n*729+408] = + s[66];
gout[n*729+409] = + s[67];
gout[n*729+410] = + s[68];
gout[n*729+411] = + s[69];
gout[n*729+412] = + s[70];
gout[n*729+413] = + s[71];
gout[n*729+414] = + s[306];
gout[n*729+415] = + s[307];
gout[n*729+416] = + s[308];
gout[n*729+417] = + s[309];
gout[n*729+418] = + s[310];
gout[n*729+419] = + s[311];
gout[n*729+420] = + s[312];
gout[n*729+421] = + s[313];
gout[n*729+422] = + s[314];
gout[n*729+423] = + s[549];
gout[n*729+424] = + s[550];
gout[n*729+425] = + s[551];
gout[n*729+426] = + s[552];
gout[n*729+427] = + s[553];
gout[n*729+428] = + s[554];
gout[n*729+429] = + s[555];
gout[n*729+430] = + s[556];
gout[n*729+431] = + s[557];
gout[n*729+432] = + s[144];
gout[n*729+433] = + s[145];
gout[n*729+434] = + s[146];
gout[n*729+435] = + s[147];
gout[n*729+436] = + s[148];
gout[n*729+437] = + s[149];
gout[n*729+438] = + s[150];
gout[n*729+439] = + s[151];
gout[n*729+440] = + s[152];
gout[n*729+441] = + s[387];
gout[n*729+442] = + s[388];
gout[n*729+443] = + s[389];
gout[n*729+444] = + s[390];
gout[n*729+445] = + s[391];
gout[n*729+446] = + s[392];
gout[n*729+447] = + s[393];
gout[n*729+448] = + s[394];
gout[n*729+449] = + s[395];
gout[n*729+450] = + s[630];
gout[n*729+451] = + s[631];
gout[n*729+452] = + s[632];
gout[n*729+453] = + s[633];
gout[n*729+454] = + s[634];
gout[n*729+455] = + s[635];
gout[n*729+456] = + s[636];
gout[n*729+457] = + s[637];
gout[n*729+458] = + s[638];
gout[n*729+459] = + s[225];
gout[n*729+460] = + s[226];
gout[n*729+461] = + s[227];
gout[n*729+462] = + s[228];
gout[n*729+463] = + s[229];
gout[n*729+464] = + s[230];
gout[n*729+465] = + s[231];
gout[n*729+466] = + s[232];
gout[n*729+467] = + s[233];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[711];
gout[n*729+478] = + s[712];
gout[n*729+479] = + s[713];
gout[n*729+480] = + s[714];
gout[n*729+481] = + s[715];
gout[n*729+482] = + s[716];
gout[n*729+483] = + s[717];
gout[n*729+484] = + s[718];
gout[n*729+485] = + s[719];
gout[n*729+486] = + s[18];
gout[n*729+487] = + s[19];
gout[n*729+488] = + s[20];
gout[n*729+489] = + s[21];
gout[n*729+490] = + s[22];
gout[n*729+491] = + s[23];
gout[n*729+492] = + s[24];
gout[n*729+493] = + s[25];
gout[n*729+494] = + s[26];
gout[n*729+495] = + s[261];
gout[n*729+496] = + s[262];
gout[n*729+497] = + s[263];
gout[n*729+498] = + s[264];
gout[n*729+499] = + s[265];
gout[n*729+500] = + s[266];
gout[n*729+501] = + s[267];
gout[n*729+502] = + s[268];
gout[n*729+503] = + s[269];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[99];
gout[n*729+514] = + s[100];
gout[n*729+515] = + s[101];
gout[n*729+516] = + s[102];
gout[n*729+517] = + s[103];
gout[n*729+518] = + s[104];
gout[n*729+519] = + s[105];
gout[n*729+520] = + s[106];
gout[n*729+521] = + s[107];
gout[n*729+522] = + s[342];
gout[n*729+523] = + s[343];
gout[n*729+524] = + s[344];
gout[n*729+525] = + s[345];
gout[n*729+526] = + s[346];
gout[n*729+527] = + s[347];
gout[n*729+528] = + s[348];
gout[n*729+529] = + s[349];
gout[n*729+530] = + s[350];
gout[n*729+531] = + s[585];
gout[n*729+532] = + s[586];
gout[n*729+533] = + s[587];
gout[n*729+534] = + s[588];
gout[n*729+535] = + s[589];
gout[n*729+536] = + s[590];
gout[n*729+537] = + s[591];
gout[n*729+538] = + s[592];
gout[n*729+539] = + s[593];
gout[n*729+540] = + s[180];
gout[n*729+541] = + s[181];
gout[n*729+542] = + s[182];
gout[n*729+543] = + s[183];
gout[n*729+544] = + s[184];
gout[n*729+545] = + s[185];
gout[n*729+546] = + s[186];
gout[n*729+547] = + s[187];
gout[n*729+548] = + s[188];
gout[n*729+549] = + s[423];
gout[n*729+550] = + s[424];
gout[n*729+551] = + s[425];
gout[n*729+552] = + s[426];
gout[n*729+553] = + s[427];
gout[n*729+554] = + s[428];
gout[n*729+555] = + s[429];
gout[n*729+556] = + s[430];
gout[n*729+557] = + s[431];
gout[n*729+558] = + s[666];
gout[n*729+559] = + s[667];
gout[n*729+560] = + s[668];
gout[n*729+561] = + s[669];
gout[n*729+562] = + s[670];
gout[n*729+563] = + s[671];
gout[n*729+564] = + s[672];
gout[n*729+565] = + s[673];
gout[n*729+566] = + s[674];
gout[n*729+567] = + s[45];
gout[n*729+568] = + s[46];
gout[n*729+569] = + s[47];
gout[n*729+570] = + s[48];
gout[n*729+571] = + s[49];
gout[n*729+572] = + s[50];
gout[n*729+573] = + s[51];
gout[n*729+574] = + s[52];
gout[n*729+575] = + s[53];
gout[n*729+576] = + s[288];
gout[n*729+577] = + s[289];
gout[n*729+578] = + s[290];
gout[n*729+579] = + s[291];
gout[n*729+580] = + s[292];
gout[n*729+581] = + s[293];
gout[n*729+582] = + s[294];
gout[n*729+583] = + s[295];
gout[n*729+584] = + s[296];
gout[n*729+585] = + s[531];
gout[n*729+586] = + s[532];
gout[n*729+587] = + s[533];
gout[n*729+588] = + s[534];
gout[n*729+589] = + s[535];
gout[n*729+590] = + s[536];
gout[n*729+591] = + s[537];
gout[n*729+592] = + s[538];
gout[n*729+593] = + s[539];
gout[n*729+594] = + s[126];
gout[n*729+595] = + s[127];
gout[n*729+596] = + s[128];
gout[n*729+597] = + s[129];
gout[n*729+598] = + s[130];
gout[n*729+599] = + s[131];
gout[n*729+600] = + s[132];
gout[n*729+601] = + s[133];
gout[n*729+602] = + s[134];
gout[n*729+603] = + s[369];
gout[n*729+604] = + s[370];
gout[n*729+605] = + s[371];
gout[n*729+606] = + s[372];
gout[n*729+607] = + s[373];
gout[n*729+608] = + s[374];
gout[n*729+609] = + s[375];
gout[n*729+610] = + s[376];
gout[n*729+611] = + s[377];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[207];
gout[n*729+622] = + s[208];
gout[n*729+623] = + s[209];
gout[n*729+624] = + s[210];
gout[n*729+625] = + s[211];
gout[n*729+626] = + s[212];
gout[n*729+627] = + s[213];
gout[n*729+628] = + s[214];
gout[n*729+629] = + s[215];
gout[n*729+630] = + s[450];
gout[n*729+631] = + s[451];
gout[n*729+632] = + s[452];
gout[n*729+633] = + s[453];
gout[n*729+634] = + s[454];
gout[n*729+635] = + s[455];
gout[n*729+636] = + s[456];
gout[n*729+637] = + s[457];
gout[n*729+638] = + s[458];
gout[n*729+639] = + s[693];
gout[n*729+640] = + s[694];
gout[n*729+641] = + s[695];
gout[n*729+642] = + s[696];
gout[n*729+643] = + s[697];
gout[n*729+644] = + s[698];
gout[n*729+645] = + s[699];
gout[n*729+646] = + s[700];
gout[n*729+647] = + s[701];
gout[n*729+648] = + s[72];
gout[n*729+649] = + s[73];
gout[n*729+650] = + s[74];
gout[n*729+651] = + s[75];
gout[n*729+652] = + s[76];
gout[n*729+653] = + s[77];
gout[n*729+654] = + s[78];
gout[n*729+655] = + s[79];
gout[n*729+656] = + s[80];
gout[n*729+657] = + s[315];
gout[n*729+658] = + s[316];
gout[n*729+659] = + s[317];
gout[n*729+660] = + s[318];
gout[n*729+661] = + s[319];
gout[n*729+662] = + s[320];
gout[n*729+663] = + s[321];
gout[n*729+664] = + s[322];
gout[n*729+665] = + s[323];
gout[n*729+666] = + s[558];
gout[n*729+667] = + s[559];
gout[n*729+668] = + s[560];
gout[n*729+669] = + s[561];
gout[n*729+670] = + s[562];
gout[n*729+671] = + s[563];
gout[n*729+672] = + s[564];
gout[n*729+673] = + s[565];
gout[n*729+674] = + s[566];
gout[n*729+675] = + s[153];
gout[n*729+676] = + s[154];
gout[n*729+677] = + s[155];
gout[n*729+678] = + s[156];
gout[n*729+679] = + s[157];
gout[n*729+680] = + s[158];
gout[n*729+681] = + s[159];
gout[n*729+682] = + s[160];
gout[n*729+683] = + s[161];
gout[n*729+684] = + s[396];
gout[n*729+685] = + s[397];
gout[n*729+686] = + s[398];
gout[n*729+687] = + s[399];
gout[n*729+688] = + s[400];
gout[n*729+689] = + s[401];
gout[n*729+690] = + s[402];
gout[n*729+691] = + s[403];
gout[n*729+692] = + s[404];
gout[n*729+693] = + s[639];
gout[n*729+694] = + s[640];
gout[n*729+695] = + s[641];
gout[n*729+696] = + s[642];
gout[n*729+697] = + s[643];
gout[n*729+698] = + s[644];
gout[n*729+699] = + s[645];
gout[n*729+700] = + s[646];
gout[n*729+701] = + s[647];
gout[n*729+702] = + s[234];
gout[n*729+703] = + s[235];
gout[n*729+704] = + s[236];
gout[n*729+705] = + s[237];
gout[n*729+706] = + s[238];
gout[n*729+707] = + s[239];
gout[n*729+708] = + s[240];
gout[n*729+709] = + s[241];
gout[n*729+710] = + s[242];
gout[n*729+711] = + s[477];
gout[n*729+712] = + s[478];
gout[n*729+713] = + s[479];
gout[n*729+714] = + s[480];
gout[n*729+715] = + s[481];
gout[n*729+716] = + s[482];
gout[n*729+717] = + s[483];
gout[n*729+718] = + s[484];
gout[n*729+719] = + s[485];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[243];
gout[n*729+10] += + s[244];
gout[n*729+11] += + s[245];
gout[n*729+12] += + s[246];
gout[n*729+13] += + s[247];
gout[n*729+14] += + s[248];
gout[n*729+15] += + s[249];
gout[n*729+16] += + s[250];
gout[n*729+17] += + s[251];
gout[n*729+18] += + s[486];
gout[n*729+19] += + s[487];
gout[n*729+20] += + s[488];
gout[n*729+21] += + s[489];
gout[n*729+22] += + s[490];
gout[n*729+23] += + s[491];
gout[n*729+24] += + s[492];
gout[n*729+25] += + s[493];
gout[n*729+26] += + s[494];
gout[n*729+27] += + s[81];
gout[n*729+28] += + s[82];
gout[n*729+29] += + s[83];
gout[n*729+30] += + s[84];
gout[n*729+31] += + s[85];
gout[n*729+32] += + s[86];
gout[n*729+33] += + s[87];
gout[n*729+34] += + s[88];
gout[n*729+35] += + s[89];
gout[n*729+36] += + s[324];
gout[n*729+37] += + s[325];
gout[n*729+38] += + s[326];
gout[n*729+39] += + s[327];
gout[n*729+40] += + s[328];
gout[n*729+41] += + s[329];
gout[n*729+42] += + s[330];
gout[n*729+43] += + s[331];
gout[n*729+44] += + s[332];
gout[n*729+45] += + s[567];
gout[n*729+46] += + s[568];
gout[n*729+47] += + s[569];
gout[n*729+48] += + s[570];
gout[n*729+49] += + s[571];
gout[n*729+50] += + s[572];
gout[n*729+51] += + s[573];
gout[n*729+52] += + s[574];
gout[n*729+53] += + s[575];
gout[n*729+54] += + s[162];
gout[n*729+55] += + s[163];
gout[n*729+56] += + s[164];
gout[n*729+57] += + s[165];
gout[n*729+58] += + s[166];
gout[n*729+59] += + s[167];
gout[n*729+60] += + s[168];
gout[n*729+61] += + s[169];
gout[n*729+62] += + s[170];
gout[n*729+63] += + s[405];
gout[n*729+64] += + s[406];
gout[n*729+65] += + s[407];
gout[n*729+66] += + s[408];
gout[n*729+67] += + s[409];
gout[n*729+68] += + s[410];
gout[n*729+69] += + s[411];
gout[n*729+70] += + s[412];
gout[n*729+71] += + s[413];
gout[n*729+72] += + s[648];
gout[n*729+73] += + s[649];
gout[n*729+74] += + s[650];
gout[n*729+75] += + s[651];
gout[n*729+76] += + s[652];
gout[n*729+77] += + s[653];
gout[n*729+78] += + s[654];
gout[n*729+79] += + s[655];
gout[n*729+80] += + s[656];
gout[n*729+81] += + s[27];
gout[n*729+82] += + s[28];
gout[n*729+83] += + s[29];
gout[n*729+84] += + s[30];
gout[n*729+85] += + s[31];
gout[n*729+86] += + s[32];
gout[n*729+87] += + s[33];
gout[n*729+88] += + s[34];
gout[n*729+89] += + s[35];
gout[n*729+90] += + s[270];
gout[n*729+91] += + s[271];
gout[n*729+92] += + s[272];
gout[n*729+93] += + s[273];
gout[n*729+94] += + s[274];
gout[n*729+95] += + s[275];
gout[n*729+96] += + s[276];
gout[n*729+97] += + s[277];
gout[n*729+98] += + s[278];
gout[n*729+99] += + s[513];
gout[n*729+100] += + s[514];
gout[n*729+101] += + s[515];
gout[n*729+102] += + s[516];
gout[n*729+103] += + s[517];
gout[n*729+104] += + s[518];
gout[n*729+105] += + s[519];
gout[n*729+106] += + s[520];
gout[n*729+107] += + s[521];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[351];
gout[n*729+118] += + s[352];
gout[n*729+119] += + s[353];
gout[n*729+120] += + s[354];
gout[n*729+121] += + s[355];
gout[n*729+122] += + s[356];
gout[n*729+123] += + s[357];
gout[n*729+124] += + s[358];
gout[n*729+125] += + s[359];
gout[n*729+126] += + s[594];
gout[n*729+127] += + s[595];
gout[n*729+128] += + s[596];
gout[n*729+129] += + s[597];
gout[n*729+130] += + s[598];
gout[n*729+131] += + s[599];
gout[n*729+132] += + s[600];
gout[n*729+133] += + s[601];
gout[n*729+134] += + s[602];
gout[n*729+135] += + s[189];
gout[n*729+136] += + s[190];
gout[n*729+137] += + s[191];
gout[n*729+138] += + s[192];
gout[n*729+139] += + s[193];
gout[n*729+140] += + s[194];
gout[n*729+141] += + s[195];
gout[n*729+142] += + s[196];
gout[n*729+143] += + s[197];
gout[n*729+144] += + s[432];
gout[n*729+145] += + s[433];
gout[n*729+146] += + s[434];
gout[n*729+147] += + s[435];
gout[n*729+148] += + s[436];
gout[n*729+149] += + s[437];
gout[n*729+150] += + s[438];
gout[n*729+151] += + s[439];
gout[n*729+152] += + s[440];
gout[n*729+153] += + s[675];
gout[n*729+154] += + s[676];
gout[n*729+155] += + s[677];
gout[n*729+156] += + s[678];
gout[n*729+157] += + s[679];
gout[n*729+158] += + s[680];
gout[n*729+159] += + s[681];
gout[n*729+160] += + s[682];
gout[n*729+161] += + s[683];
gout[n*729+162] += + s[54];
gout[n*729+163] += + s[55];
gout[n*729+164] += + s[56];
gout[n*729+165] += + s[57];
gout[n*729+166] += + s[58];
gout[n*729+167] += + s[59];
gout[n*729+168] += + s[60];
gout[n*729+169] += + s[61];
gout[n*729+170] += + s[62];
gout[n*729+171] += + s[297];
gout[n*729+172] += + s[298];
gout[n*729+173] += + s[299];
gout[n*729+174] += + s[300];
gout[n*729+175] += + s[301];
gout[n*729+176] += + s[302];
gout[n*729+177] += + s[303];
gout[n*729+178] += + s[304];
gout[n*729+179] += + s[305];
gout[n*729+180] += + s[540];
gout[n*729+181] += + s[541];
gout[n*729+182] += + s[542];
gout[n*729+183] += + s[543];
gout[n*729+184] += + s[544];
gout[n*729+185] += + s[545];
gout[n*729+186] += + s[546];
gout[n*729+187] += + s[547];
gout[n*729+188] += + s[548];
gout[n*729+189] += + s[135];
gout[n*729+190] += + s[136];
gout[n*729+191] += + s[137];
gout[n*729+192] += + s[138];
gout[n*729+193] += + s[139];
gout[n*729+194] += + s[140];
gout[n*729+195] += + s[141];
gout[n*729+196] += + s[142];
gout[n*729+197] += + s[143];
gout[n*729+198] += + s[378];
gout[n*729+199] += + s[379];
gout[n*729+200] += + s[380];
gout[n*729+201] += + s[381];
gout[n*729+202] += + s[382];
gout[n*729+203] += + s[383];
gout[n*729+204] += + s[384];
gout[n*729+205] += + s[385];
gout[n*729+206] += + s[386];
gout[n*729+207] += + s[621];
gout[n*729+208] += + s[622];
gout[n*729+209] += + s[623];
gout[n*729+210] += + s[624];
gout[n*729+211] += + s[625];
gout[n*729+212] += + s[626];
gout[n*729+213] += + s[627];
gout[n*729+214] += + s[628];
gout[n*729+215] += + s[629];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[459];
gout[n*729+226] += + s[460];
gout[n*729+227] += + s[461];
gout[n*729+228] += + s[462];
gout[n*729+229] += + s[463];
gout[n*729+230] += + s[464];
gout[n*729+231] += + s[465];
gout[n*729+232] += + s[466];
gout[n*729+233] += + s[467];
gout[n*729+234] += + s[702];
gout[n*729+235] += + s[703];
gout[n*729+236] += + s[704];
gout[n*729+237] += + s[705];
gout[n*729+238] += + s[706];
gout[n*729+239] += + s[707];
gout[n*729+240] += + s[708];
gout[n*729+241] += + s[709];
gout[n*729+242] += + s[710];
gout[n*729+243] += + s[9];
gout[n*729+244] += + s[10];
gout[n*729+245] += + s[11];
gout[n*729+246] += + s[12];
gout[n*729+247] += + s[13];
gout[n*729+248] += + s[14];
gout[n*729+249] += + s[15];
gout[n*729+250] += + s[16];
gout[n*729+251] += + s[17];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[495];
gout[n*729+262] += + s[496];
gout[n*729+263] += + s[497];
gout[n*729+264] += + s[498];
gout[n*729+265] += + s[499];
gout[n*729+266] += + s[500];
gout[n*729+267] += + s[501];
gout[n*729+268] += + s[502];
gout[n*729+269] += + s[503];
gout[n*729+270] += + s[90];
gout[n*729+271] += + s[91];
gout[n*729+272] += + s[92];
gout[n*729+273] += + s[93];
gout[n*729+274] += + s[94];
gout[n*729+275] += + s[95];
gout[n*729+276] += + s[96];
gout[n*729+277] += + s[97];
gout[n*729+278] += + s[98];
gout[n*729+279] += + s[333];
gout[n*729+280] += + s[334];
gout[n*729+281] += + s[335];
gout[n*729+282] += + s[336];
gout[n*729+283] += + s[337];
gout[n*729+284] += + s[338];
gout[n*729+285] += + s[339];
gout[n*729+286] += + s[340];
gout[n*729+287] += + s[341];
gout[n*729+288] += + s[576];
gout[n*729+289] += + s[577];
gout[n*729+290] += + s[578];
gout[n*729+291] += + s[579];
gout[n*729+292] += + s[580];
gout[n*729+293] += + s[581];
gout[n*729+294] += + s[582];
gout[n*729+295] += + s[583];
gout[n*729+296] += + s[584];
gout[n*729+297] += + s[171];
gout[n*729+298] += + s[172];
gout[n*729+299] += + s[173];
gout[n*729+300] += + s[174];
gout[n*729+301] += + s[175];
gout[n*729+302] += + s[176];
gout[n*729+303] += + s[177];
gout[n*729+304] += + s[178];
gout[n*729+305] += + s[179];
gout[n*729+306] += + s[414];
gout[n*729+307] += + s[415];
gout[n*729+308] += + s[416];
gout[n*729+309] += + s[417];
gout[n*729+310] += + s[418];
gout[n*729+311] += + s[419];
gout[n*729+312] += + s[420];
gout[n*729+313] += + s[421];
gout[n*729+314] += + s[422];
gout[n*729+315] += + s[657];
gout[n*729+316] += + s[658];
gout[n*729+317] += + s[659];
gout[n*729+318] += + s[660];
gout[n*729+319] += + s[661];
gout[n*729+320] += + s[662];
gout[n*729+321] += + s[663];
gout[n*729+322] += + s[664];
gout[n*729+323] += + s[665];
gout[n*729+324] += + s[36];
gout[n*729+325] += + s[37];
gout[n*729+326] += + s[38];
gout[n*729+327] += + s[39];
gout[n*729+328] += + s[40];
gout[n*729+329] += + s[41];
gout[n*729+330] += + s[42];
gout[n*729+331] += + s[43];
gout[n*729+332] += + s[44];
gout[n*729+333] += + s[279];
gout[n*729+334] += + s[280];
gout[n*729+335] += + s[281];
gout[n*729+336] += + s[282];
gout[n*729+337] += + s[283];
gout[n*729+338] += + s[284];
gout[n*729+339] += + s[285];
gout[n*729+340] += + s[286];
gout[n*729+341] += + s[287];
gout[n*729+342] += + s[522];
gout[n*729+343] += + s[523];
gout[n*729+344] += + s[524];
gout[n*729+345] += + s[525];
gout[n*729+346] += + s[526];
gout[n*729+347] += + s[527];
gout[n*729+348] += + s[528];
gout[n*729+349] += + s[529];
gout[n*729+350] += + s[530];
gout[n*729+351] += + s[117];
gout[n*729+352] += + s[118];
gout[n*729+353] += + s[119];
gout[n*729+354] += + s[120];
gout[n*729+355] += + s[121];
gout[n*729+356] += + s[122];
gout[n*729+357] += + s[123];
gout[n*729+358] += + s[124];
gout[n*729+359] += + s[125];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[603];
gout[n*729+370] += + s[604];
gout[n*729+371] += + s[605];
gout[n*729+372] += + s[606];
gout[n*729+373] += + s[607];
gout[n*729+374] += + s[608];
gout[n*729+375] += + s[609];
gout[n*729+376] += + s[610];
gout[n*729+377] += + s[611];
gout[n*729+378] += + s[198];
gout[n*729+379] += + s[199];
gout[n*729+380] += + s[200];
gout[n*729+381] += + s[201];
gout[n*729+382] += + s[202];
gout[n*729+383] += + s[203];
gout[n*729+384] += + s[204];
gout[n*729+385] += + s[205];
gout[n*729+386] += + s[206];
gout[n*729+387] += + s[441];
gout[n*729+388] += + s[442];
gout[n*729+389] += + s[443];
gout[n*729+390] += + s[444];
gout[n*729+391] += + s[445];
gout[n*729+392] += + s[446];
gout[n*729+393] += + s[447];
gout[n*729+394] += + s[448];
gout[n*729+395] += + s[449];
gout[n*729+396] += + s[684];
gout[n*729+397] += + s[685];
gout[n*729+398] += + s[686];
gout[n*729+399] += + s[687];
gout[n*729+400] += + s[688];
gout[n*729+401] += + s[689];
gout[n*729+402] += + s[690];
gout[n*729+403] += + s[691];
gout[n*729+404] += + s[692];
gout[n*729+405] += + s[63];
gout[n*729+406] += + s[64];
gout[n*729+407] += + s[65];
gout[n*729+408] += + s[66];
gout[n*729+409] += + s[67];
gout[n*729+410] += + s[68];
gout[n*729+411] += + s[69];
gout[n*729+412] += + s[70];
gout[n*729+413] += + s[71];
gout[n*729+414] += + s[306];
gout[n*729+415] += + s[307];
gout[n*729+416] += + s[308];
gout[n*729+417] += + s[309];
gout[n*729+418] += + s[310];
gout[n*729+419] += + s[311];
gout[n*729+420] += + s[312];
gout[n*729+421] += + s[313];
gout[n*729+422] += + s[314];
gout[n*729+423] += + s[549];
gout[n*729+424] += + s[550];
gout[n*729+425] += + s[551];
gout[n*729+426] += + s[552];
gout[n*729+427] += + s[553];
gout[n*729+428] += + s[554];
gout[n*729+429] += + s[555];
gout[n*729+430] += + s[556];
gout[n*729+431] += + s[557];
gout[n*729+432] += + s[144];
gout[n*729+433] += + s[145];
gout[n*729+434] += + s[146];
gout[n*729+435] += + s[147];
gout[n*729+436] += + s[148];
gout[n*729+437] += + s[149];
gout[n*729+438] += + s[150];
gout[n*729+439] += + s[151];
gout[n*729+440] += + s[152];
gout[n*729+441] += + s[387];
gout[n*729+442] += + s[388];
gout[n*729+443] += + s[389];
gout[n*729+444] += + s[390];
gout[n*729+445] += + s[391];
gout[n*729+446] += + s[392];
gout[n*729+447] += + s[393];
gout[n*729+448] += + s[394];
gout[n*729+449] += + s[395];
gout[n*729+450] += + s[630];
gout[n*729+451] += + s[631];
gout[n*729+452] += + s[632];
gout[n*729+453] += + s[633];
gout[n*729+454] += + s[634];
gout[n*729+455] += + s[635];
gout[n*729+456] += + s[636];
gout[n*729+457] += + s[637];
gout[n*729+458] += + s[638];
gout[n*729+459] += + s[225];
gout[n*729+460] += + s[226];
gout[n*729+461] += + s[227];
gout[n*729+462] += + s[228];
gout[n*729+463] += + s[229];
gout[n*729+464] += + s[230];
gout[n*729+465] += + s[231];
gout[n*729+466] += + s[232];
gout[n*729+467] += + s[233];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[711];
gout[n*729+478] += + s[712];
gout[n*729+479] += + s[713];
gout[n*729+480] += + s[714];
gout[n*729+481] += + s[715];
gout[n*729+482] += + s[716];
gout[n*729+483] += + s[717];
gout[n*729+484] += + s[718];
gout[n*729+485] += + s[719];
gout[n*729+486] += + s[18];
gout[n*729+487] += + s[19];
gout[n*729+488] += + s[20];
gout[n*729+489] += + s[21];
gout[n*729+490] += + s[22];
gout[n*729+491] += + s[23];
gout[n*729+492] += + s[24];
gout[n*729+493] += + s[25];
gout[n*729+494] += + s[26];
gout[n*729+495] += + s[261];
gout[n*729+496] += + s[262];
gout[n*729+497] += + s[263];
gout[n*729+498] += + s[264];
gout[n*729+499] += + s[265];
gout[n*729+500] += + s[266];
gout[n*729+501] += + s[267];
gout[n*729+502] += + s[268];
gout[n*729+503] += + s[269];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[99];
gout[n*729+514] += + s[100];
gout[n*729+515] += + s[101];
gout[n*729+516] += + s[102];
gout[n*729+517] += + s[103];
gout[n*729+518] += + s[104];
gout[n*729+519] += + s[105];
gout[n*729+520] += + s[106];
gout[n*729+521] += + s[107];
gout[n*729+522] += + s[342];
gout[n*729+523] += + s[343];
gout[n*729+524] += + s[344];
gout[n*729+525] += + s[345];
gout[n*729+526] += + s[346];
gout[n*729+527] += + s[347];
gout[n*729+528] += + s[348];
gout[n*729+529] += + s[349];
gout[n*729+530] += + s[350];
gout[n*729+531] += + s[585];
gout[n*729+532] += + s[586];
gout[n*729+533] += + s[587];
gout[n*729+534] += + s[588];
gout[n*729+535] += + s[589];
gout[n*729+536] += + s[590];
gout[n*729+537] += + s[591];
gout[n*729+538] += + s[592];
gout[n*729+539] += + s[593];
gout[n*729+540] += + s[180];
gout[n*729+541] += + s[181];
gout[n*729+542] += + s[182];
gout[n*729+543] += + s[183];
gout[n*729+544] += + s[184];
gout[n*729+545] += + s[185];
gout[n*729+546] += + s[186];
gout[n*729+547] += + s[187];
gout[n*729+548] += + s[188];
gout[n*729+549] += + s[423];
gout[n*729+550] += + s[424];
gout[n*729+551] += + s[425];
gout[n*729+552] += + s[426];
gout[n*729+553] += + s[427];
gout[n*729+554] += + s[428];
gout[n*729+555] += + s[429];
gout[n*729+556] += + s[430];
gout[n*729+557] += + s[431];
gout[n*729+558] += + s[666];
gout[n*729+559] += + s[667];
gout[n*729+560] += + s[668];
gout[n*729+561] += + s[669];
gout[n*729+562] += + s[670];
gout[n*729+563] += + s[671];
gout[n*729+564] += + s[672];
gout[n*729+565] += + s[673];
gout[n*729+566] += + s[674];
gout[n*729+567] += + s[45];
gout[n*729+568] += + s[46];
gout[n*729+569] += + s[47];
gout[n*729+570] += + s[48];
gout[n*729+571] += + s[49];
gout[n*729+572] += + s[50];
gout[n*729+573] += + s[51];
gout[n*729+574] += + s[52];
gout[n*729+575] += + s[53];
gout[n*729+576] += + s[288];
gout[n*729+577] += + s[289];
gout[n*729+578] += + s[290];
gout[n*729+579] += + s[291];
gout[n*729+580] += + s[292];
gout[n*729+581] += + s[293];
gout[n*729+582] += + s[294];
gout[n*729+583] += + s[295];
gout[n*729+584] += + s[296];
gout[n*729+585] += + s[531];
gout[n*729+586] += + s[532];
gout[n*729+587] += + s[533];
gout[n*729+588] += + s[534];
gout[n*729+589] += + s[535];
gout[n*729+590] += + s[536];
gout[n*729+591] += + s[537];
gout[n*729+592] += + s[538];
gout[n*729+593] += + s[539];
gout[n*729+594] += + s[126];
gout[n*729+595] += + s[127];
gout[n*729+596] += + s[128];
gout[n*729+597] += + s[129];
gout[n*729+598] += + s[130];
gout[n*729+599] += + s[131];
gout[n*729+600] += + s[132];
gout[n*729+601] += + s[133];
gout[n*729+602] += + s[134];
gout[n*729+603] += + s[369];
gout[n*729+604] += + s[370];
gout[n*729+605] += + s[371];
gout[n*729+606] += + s[372];
gout[n*729+607] += + s[373];
gout[n*729+608] += + s[374];
gout[n*729+609] += + s[375];
gout[n*729+610] += + s[376];
gout[n*729+611] += + s[377];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[207];
gout[n*729+622] += + s[208];
gout[n*729+623] += + s[209];
gout[n*729+624] += + s[210];
gout[n*729+625] += + s[211];
gout[n*729+626] += + s[212];
gout[n*729+627] += + s[213];
gout[n*729+628] += + s[214];
gout[n*729+629] += + s[215];
gout[n*729+630] += + s[450];
gout[n*729+631] += + s[451];
gout[n*729+632] += + s[452];
gout[n*729+633] += + s[453];
gout[n*729+634] += + s[454];
gout[n*729+635] += + s[455];
gout[n*729+636] += + s[456];
gout[n*729+637] += + s[457];
gout[n*729+638] += + s[458];
gout[n*729+639] += + s[693];
gout[n*729+640] += + s[694];
gout[n*729+641] += + s[695];
gout[n*729+642] += + s[696];
gout[n*729+643] += + s[697];
gout[n*729+644] += + s[698];
gout[n*729+645] += + s[699];
gout[n*729+646] += + s[700];
gout[n*729+647] += + s[701];
gout[n*729+648] += + s[72];
gout[n*729+649] += + s[73];
gout[n*729+650] += + s[74];
gout[n*729+651] += + s[75];
gout[n*729+652] += + s[76];
gout[n*729+653] += + s[77];
gout[n*729+654] += + s[78];
gout[n*729+655] += + s[79];
gout[n*729+656] += + s[80];
gout[n*729+657] += + s[315];
gout[n*729+658] += + s[316];
gout[n*729+659] += + s[317];
gout[n*729+660] += + s[318];
gout[n*729+661] += + s[319];
gout[n*729+662] += + s[320];
gout[n*729+663] += + s[321];
gout[n*729+664] += + s[322];
gout[n*729+665] += + s[323];
gout[n*729+666] += + s[558];
gout[n*729+667] += + s[559];
gout[n*729+668] += + s[560];
gout[n*729+669] += + s[561];
gout[n*729+670] += + s[562];
gout[n*729+671] += + s[563];
gout[n*729+672] += + s[564];
gout[n*729+673] += + s[565];
gout[n*729+674] += + s[566];
gout[n*729+675] += + s[153];
gout[n*729+676] += + s[154];
gout[n*729+677] += + s[155];
gout[n*729+678] += + s[156];
gout[n*729+679] += + s[157];
gout[n*729+680] += + s[158];
gout[n*729+681] += + s[159];
gout[n*729+682] += + s[160];
gout[n*729+683] += + s[161];
gout[n*729+684] += + s[396];
gout[n*729+685] += + s[397];
gout[n*729+686] += + s[398];
gout[n*729+687] += + s[399];
gout[n*729+688] += + s[400];
gout[n*729+689] += + s[401];
gout[n*729+690] += + s[402];
gout[n*729+691] += + s[403];
gout[n*729+692] += + s[404];
gout[n*729+693] += + s[639];
gout[n*729+694] += + s[640];
gout[n*729+695] += + s[641];
gout[n*729+696] += + s[642];
gout[n*729+697] += + s[643];
gout[n*729+698] += + s[644];
gout[n*729+699] += + s[645];
gout[n*729+700] += + s[646];
gout[n*729+701] += + s[647];
gout[n*729+702] += + s[234];
gout[n*729+703] += + s[235];
gout[n*729+704] += + s[236];
gout[n*729+705] += + s[237];
gout[n*729+706] += + s[238];
gout[n*729+707] += + s[239];
gout[n*729+708] += + s[240];
gout[n*729+709] += + s[241];
gout[n*729+710] += + s[242];
gout[n*729+711] += + s[477];
gout[n*729+712] += + s[478];
gout[n*729+713] += + s[479];
gout[n*729+714] += + s[480];
gout[n*729+715] += + s[481];
gout[n*729+716] += + s[482];
gout[n*729+717] += + s[483];
gout[n*729+718] += + s[484];
gout[n*729+719] += + s[485];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipipipnn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipipnn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipipnn_cart
CACHE_SIZE_T int1e_ipipipipnn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipipnn_sph
CACHE_SIZE_T int1e_ipipipipnn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipnn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipipnn_spinor
ALL_CINT1E(int1e_ipipipipnn)
ALL_CINT1E_FORTRAN_(int1e_ipipipipnn)
/* <NABLA i|RJ RJ |NABLA j> */
void CINTgout1e_int1e_ipnnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipnnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnnip_cart
CACHE_SIZE_T int1e_ipnnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnnip_sph
CACHE_SIZE_T int1e_ipnnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnnip_spinor
ALL_CINT1E(int1e_ipnnip)
ALL_CINT1E_FORTRAN_(int1e_ipnnip)
/* <NABLA i|RJ RJ |NABLA NABLA j> */
void CINTgout1e_int1e_ipnnipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipnnipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnnipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnnipip_cart
CACHE_SIZE_T int1e_ipnnipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnnipip_sph
CACHE_SIZE_T int1e_ipnnipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnnipip_spinor
ALL_CINT1E(int1e_ipnnipip)
ALL_CINT1E_FORTRAN_(int1e_ipnnipip)
/* <NABLA NABLA i|RJ RJ |NABLA j> */
void CINTgout1e_int1e_ipipnnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipnnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipnnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipnnip_cart
CACHE_SIZE_T int1e_ipipnnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipnnip_sph
CACHE_SIZE_T int1e_ipipnnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipnnip_spinor
ALL_CINT1E(int1e_ipipnnip)
ALL_CINT1E_FORTRAN_(int1e_ipipnnip)
/* <NABLA i|RJ RJ |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_ipnnipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+1, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipnnipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnnipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnnipipip_cart
CACHE_SIZE_T int1e_ipnnipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnnipipip_sph
CACHE_SIZE_T int1e_ipnnipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnnipipip_spinor
ALL_CINT1E(int1e_ipnnipipip)
ALL_CINT1E_FORTRAN_(int1e_ipnnipipip)
/* <NABLA NABLA NABLA i|RJ RJ |NABLA j> */
void CINTgout1e_int1e_ipipipnnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+3, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+3, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[243];
gout[n*729+28] = + s[244];
gout[n*729+29] = + s[245];
gout[n*729+30] = + s[246];
gout[n*729+31] = + s[247];
gout[n*729+32] = + s[248];
gout[n*729+33] = + s[249];
gout[n*729+34] = + s[250];
gout[n*729+35] = + s[251];
gout[n*729+36] = + s[252];
gout[n*729+37] = + s[253];
gout[n*729+38] = + s[254];
gout[n*729+39] = + s[255];
gout[n*729+40] = + s[256];
gout[n*729+41] = + s[257];
gout[n*729+42] = + s[258];
gout[n*729+43] = + s[259];
gout[n*729+44] = + s[260];
gout[n*729+45] = + s[261];
gout[n*729+46] = + s[262];
gout[n*729+47] = + s[263];
gout[n*729+48] = + s[264];
gout[n*729+49] = + s[265];
gout[n*729+50] = + s[266];
gout[n*729+51] = + s[267];
gout[n*729+52] = + s[268];
gout[n*729+53] = + s[269];
gout[n*729+54] = + s[486];
gout[n*729+55] = + s[487];
gout[n*729+56] = + s[488];
gout[n*729+57] = + s[489];
gout[n*729+58] = + s[490];
gout[n*729+59] = + s[491];
gout[n*729+60] = + s[492];
gout[n*729+61] = + s[493];
gout[n*729+62] = + s[494];
gout[n*729+63] = + s[495];
gout[n*729+64] = + s[496];
gout[n*729+65] = + s[497];
gout[n*729+66] = + s[498];
gout[n*729+67] = + s[499];
gout[n*729+68] = + s[500];
gout[n*729+69] = + s[501];
gout[n*729+70] = + s[502];
gout[n*729+71] = + s[503];
gout[n*729+72] = + s[504];
gout[n*729+73] = + s[505];
gout[n*729+74] = + s[506];
gout[n*729+75] = + s[507];
gout[n*729+76] = + s[508];
gout[n*729+77] = + s[509];
gout[n*729+78] = + s[510];
gout[n*729+79] = + s[511];
gout[n*729+80] = + s[512];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[324];
gout[n*729+109] = + s[325];
gout[n*729+110] = + s[326];
gout[n*729+111] = + s[327];
gout[n*729+112] = + s[328];
gout[n*729+113] = + s[329];
gout[n*729+114] = + s[330];
gout[n*729+115] = + s[331];
gout[n*729+116] = + s[332];
gout[n*729+117] = + s[333];
gout[n*729+118] = + s[334];
gout[n*729+119] = + s[335];
gout[n*729+120] = + s[336];
gout[n*729+121] = + s[337];
gout[n*729+122] = + s[338];
gout[n*729+123] = + s[339];
gout[n*729+124] = + s[340];
gout[n*729+125] = + s[341];
gout[n*729+126] = + s[342];
gout[n*729+127] = + s[343];
gout[n*729+128] = + s[344];
gout[n*729+129] = + s[345];
gout[n*729+130] = + s[346];
gout[n*729+131] = + s[347];
gout[n*729+132] = + s[348];
gout[n*729+133] = + s[349];
gout[n*729+134] = + s[350];
gout[n*729+135] = + s[567];
gout[n*729+136] = + s[568];
gout[n*729+137] = + s[569];
gout[n*729+138] = + s[570];
gout[n*729+139] = + s[571];
gout[n*729+140] = + s[572];
gout[n*729+141] = + s[573];
gout[n*729+142] = + s[574];
gout[n*729+143] = + s[575];
gout[n*729+144] = + s[576];
gout[n*729+145] = + s[577];
gout[n*729+146] = + s[578];
gout[n*729+147] = + s[579];
gout[n*729+148] = + s[580];
gout[n*729+149] = + s[581];
gout[n*729+150] = + s[582];
gout[n*729+151] = + s[583];
gout[n*729+152] = + s[584];
gout[n*729+153] = + s[585];
gout[n*729+154] = + s[586];
gout[n*729+155] = + s[587];
gout[n*729+156] = + s[588];
gout[n*729+157] = + s[589];
gout[n*729+158] = + s[590];
gout[n*729+159] = + s[591];
gout[n*729+160] = + s[592];
gout[n*729+161] = + s[593];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[405];
gout[n*729+190] = + s[406];
gout[n*729+191] = + s[407];
gout[n*729+192] = + s[408];
gout[n*729+193] = + s[409];
gout[n*729+194] = + s[410];
gout[n*729+195] = + s[411];
gout[n*729+196] = + s[412];
gout[n*729+197] = + s[413];
gout[n*729+198] = + s[414];
gout[n*729+199] = + s[415];
gout[n*729+200] = + s[416];
gout[n*729+201] = + s[417];
gout[n*729+202] = + s[418];
gout[n*729+203] = + s[419];
gout[n*729+204] = + s[420];
gout[n*729+205] = + s[421];
gout[n*729+206] = + s[422];
gout[n*729+207] = + s[423];
gout[n*729+208] = + s[424];
gout[n*729+209] = + s[425];
gout[n*729+210] = + s[426];
gout[n*729+211] = + s[427];
gout[n*729+212] = + s[428];
gout[n*729+213] = + s[429];
gout[n*729+214] = + s[430];
gout[n*729+215] = + s[431];
gout[n*729+216] = + s[648];
gout[n*729+217] = + s[649];
gout[n*729+218] = + s[650];
gout[n*729+219] = + s[651];
gout[n*729+220] = + s[652];
gout[n*729+221] = + s[653];
gout[n*729+222] = + s[654];
gout[n*729+223] = + s[655];
gout[n*729+224] = + s[656];
gout[n*729+225] = + s[657];
gout[n*729+226] = + s[658];
gout[n*729+227] = + s[659];
gout[n*729+228] = + s[660];
gout[n*729+229] = + s[661];
gout[n*729+230] = + s[662];
gout[n*729+231] = + s[663];
gout[n*729+232] = + s[664];
gout[n*729+233] = + s[665];
gout[n*729+234] = + s[666];
gout[n*729+235] = + s[667];
gout[n*729+236] = + s[668];
gout[n*729+237] = + s[669];
gout[n*729+238] = + s[670];
gout[n*729+239] = + s[671];
gout[n*729+240] = + s[672];
gout[n*729+241] = + s[673];
gout[n*729+242] = + s[674];
gout[n*729+243] = + s[27];
gout[n*729+244] = + s[28];
gout[n*729+245] = + s[29];
gout[n*729+246] = + s[30];
gout[n*729+247] = + s[31];
gout[n*729+248] = + s[32];
gout[n*729+249] = + s[33];
gout[n*729+250] = + s[34];
gout[n*729+251] = + s[35];
gout[n*729+252] = + s[36];
gout[n*729+253] = + s[37];
gout[n*729+254] = + s[38];
gout[n*729+255] = + s[39];
gout[n*729+256] = + s[40];
gout[n*729+257] = + s[41];
gout[n*729+258] = + s[42];
gout[n*729+259] = + s[43];
gout[n*729+260] = + s[44];
gout[n*729+261] = + s[45];
gout[n*729+262] = + s[46];
gout[n*729+263] = + s[47];
gout[n*729+264] = + s[48];
gout[n*729+265] = + s[49];
gout[n*729+266] = + s[50];
gout[n*729+267] = + s[51];
gout[n*729+268] = + s[52];
gout[n*729+269] = + s[53];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[513];
gout[n*729+298] = + s[514];
gout[n*729+299] = + s[515];
gout[n*729+300] = + s[516];
gout[n*729+301] = + s[517];
gout[n*729+302] = + s[518];
gout[n*729+303] = + s[519];
gout[n*729+304] = + s[520];
gout[n*729+305] = + s[521];
gout[n*729+306] = + s[522];
gout[n*729+307] = + s[523];
gout[n*729+308] = + s[524];
gout[n*729+309] = + s[525];
gout[n*729+310] = + s[526];
gout[n*729+311] = + s[527];
gout[n*729+312] = + s[528];
gout[n*729+313] = + s[529];
gout[n*729+314] = + s[530];
gout[n*729+315] = + s[531];
gout[n*729+316] = + s[532];
gout[n*729+317] = + s[533];
gout[n*729+318] = + s[534];
gout[n*729+319] = + s[535];
gout[n*729+320] = + s[536];
gout[n*729+321] = + s[537];
gout[n*729+322] = + s[538];
gout[n*729+323] = + s[539];
gout[n*729+324] = + s[108];
gout[n*729+325] = + s[109];
gout[n*729+326] = + s[110];
gout[n*729+327] = + s[111];
gout[n*729+328] = + s[112];
gout[n*729+329] = + s[113];
gout[n*729+330] = + s[114];
gout[n*729+331] = + s[115];
gout[n*729+332] = + s[116];
gout[n*729+333] = + s[117];
gout[n*729+334] = + s[118];
gout[n*729+335] = + s[119];
gout[n*729+336] = + s[120];
gout[n*729+337] = + s[121];
gout[n*729+338] = + s[122];
gout[n*729+339] = + s[123];
gout[n*729+340] = + s[124];
gout[n*729+341] = + s[125];
gout[n*729+342] = + s[126];
gout[n*729+343] = + s[127];
gout[n*729+344] = + s[128];
gout[n*729+345] = + s[129];
gout[n*729+346] = + s[130];
gout[n*729+347] = + s[131];
gout[n*729+348] = + s[132];
gout[n*729+349] = + s[133];
gout[n*729+350] = + s[134];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[594];
gout[n*729+379] = + s[595];
gout[n*729+380] = + s[596];
gout[n*729+381] = + s[597];
gout[n*729+382] = + s[598];
gout[n*729+383] = + s[599];
gout[n*729+384] = + s[600];
gout[n*729+385] = + s[601];
gout[n*729+386] = + s[602];
gout[n*729+387] = + s[603];
gout[n*729+388] = + s[604];
gout[n*729+389] = + s[605];
gout[n*729+390] = + s[606];
gout[n*729+391] = + s[607];
gout[n*729+392] = + s[608];
gout[n*729+393] = + s[609];
gout[n*729+394] = + s[610];
gout[n*729+395] = + s[611];
gout[n*729+396] = + s[612];
gout[n*729+397] = + s[613];
gout[n*729+398] = + s[614];
gout[n*729+399] = + s[615];
gout[n*729+400] = + s[616];
gout[n*729+401] = + s[617];
gout[n*729+402] = + s[618];
gout[n*729+403] = + s[619];
gout[n*729+404] = + s[620];
gout[n*729+405] = + s[189];
gout[n*729+406] = + s[190];
gout[n*729+407] = + s[191];
gout[n*729+408] = + s[192];
gout[n*729+409] = + s[193];
gout[n*729+410] = + s[194];
gout[n*729+411] = + s[195];
gout[n*729+412] = + s[196];
gout[n*729+413] = + s[197];
gout[n*729+414] = + s[198];
gout[n*729+415] = + s[199];
gout[n*729+416] = + s[200];
gout[n*729+417] = + s[201];
gout[n*729+418] = + s[202];
gout[n*729+419] = + s[203];
gout[n*729+420] = + s[204];
gout[n*729+421] = + s[205];
gout[n*729+422] = + s[206];
gout[n*729+423] = + s[207];
gout[n*729+424] = + s[208];
gout[n*729+425] = + s[209];
gout[n*729+426] = + s[210];
gout[n*729+427] = + s[211];
gout[n*729+428] = + s[212];
gout[n*729+429] = + s[213];
gout[n*729+430] = + s[214];
gout[n*729+431] = + s[215];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[675];
gout[n*729+460] = + s[676];
gout[n*729+461] = + s[677];
gout[n*729+462] = + s[678];
gout[n*729+463] = + s[679];
gout[n*729+464] = + s[680];
gout[n*729+465] = + s[681];
gout[n*729+466] = + s[682];
gout[n*729+467] = + s[683];
gout[n*729+468] = + s[684];
gout[n*729+469] = + s[685];
gout[n*729+470] = + s[686];
gout[n*729+471] = + s[687];
gout[n*729+472] = + s[688];
gout[n*729+473] = + s[689];
gout[n*729+474] = + s[690];
gout[n*729+475] = + s[691];
gout[n*729+476] = + s[692];
gout[n*729+477] = + s[693];
gout[n*729+478] = + s[694];
gout[n*729+479] = + s[695];
gout[n*729+480] = + s[696];
gout[n*729+481] = + s[697];
gout[n*729+482] = + s[698];
gout[n*729+483] = + s[699];
gout[n*729+484] = + s[700];
gout[n*729+485] = + s[701];
gout[n*729+486] = + s[54];
gout[n*729+487] = + s[55];
gout[n*729+488] = + s[56];
gout[n*729+489] = + s[57];
gout[n*729+490] = + s[58];
gout[n*729+491] = + s[59];
gout[n*729+492] = + s[60];
gout[n*729+493] = + s[61];
gout[n*729+494] = + s[62];
gout[n*729+495] = + s[63];
gout[n*729+496] = + s[64];
gout[n*729+497] = + s[65];
gout[n*729+498] = + s[66];
gout[n*729+499] = + s[67];
gout[n*729+500] = + s[68];
gout[n*729+501] = + s[69];
gout[n*729+502] = + s[70];
gout[n*729+503] = + s[71];
gout[n*729+504] = + s[72];
gout[n*729+505] = + s[73];
gout[n*729+506] = + s[74];
gout[n*729+507] = + s[75];
gout[n*729+508] = + s[76];
gout[n*729+509] = + s[77];
gout[n*729+510] = + s[78];
gout[n*729+511] = + s[79];
gout[n*729+512] = + s[80];
gout[n*729+513] = + s[297];
gout[n*729+514] = + s[298];
gout[n*729+515] = + s[299];
gout[n*729+516] = + s[300];
gout[n*729+517] = + s[301];
gout[n*729+518] = + s[302];
gout[n*729+519] = + s[303];
gout[n*729+520] = + s[304];
gout[n*729+521] = + s[305];
gout[n*729+522] = + s[306];
gout[n*729+523] = + s[307];
gout[n*729+524] = + s[308];
gout[n*729+525] = + s[309];
gout[n*729+526] = + s[310];
gout[n*729+527] = + s[311];
gout[n*729+528] = + s[312];
gout[n*729+529] = + s[313];
gout[n*729+530] = + s[314];
gout[n*729+531] = + s[315];
gout[n*729+532] = + s[316];
gout[n*729+533] = + s[317];
gout[n*729+534] = + s[318];
gout[n*729+535] = + s[319];
gout[n*729+536] = + s[320];
gout[n*729+537] = + s[321];
gout[n*729+538] = + s[322];
gout[n*729+539] = + s[323];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[135];
gout[n*729+568] = + s[136];
gout[n*729+569] = + s[137];
gout[n*729+570] = + s[138];
gout[n*729+571] = + s[139];
gout[n*729+572] = + s[140];
gout[n*729+573] = + s[141];
gout[n*729+574] = + s[142];
gout[n*729+575] = + s[143];
gout[n*729+576] = + s[144];
gout[n*729+577] = + s[145];
gout[n*729+578] = + s[146];
gout[n*729+579] = + s[147];
gout[n*729+580] = + s[148];
gout[n*729+581] = + s[149];
gout[n*729+582] = + s[150];
gout[n*729+583] = + s[151];
gout[n*729+584] = + s[152];
gout[n*729+585] = + s[153];
gout[n*729+586] = + s[154];
gout[n*729+587] = + s[155];
gout[n*729+588] = + s[156];
gout[n*729+589] = + s[157];
gout[n*729+590] = + s[158];
gout[n*729+591] = + s[159];
gout[n*729+592] = + s[160];
gout[n*729+593] = + s[161];
gout[n*729+594] = + s[378];
gout[n*729+595] = + s[379];
gout[n*729+596] = + s[380];
gout[n*729+597] = + s[381];
gout[n*729+598] = + s[382];
gout[n*729+599] = + s[383];
gout[n*729+600] = + s[384];
gout[n*729+601] = + s[385];
gout[n*729+602] = + s[386];
gout[n*729+603] = + s[387];
gout[n*729+604] = + s[388];
gout[n*729+605] = + s[389];
gout[n*729+606] = + s[390];
gout[n*729+607] = + s[391];
gout[n*729+608] = + s[392];
gout[n*729+609] = + s[393];
gout[n*729+610] = + s[394];
gout[n*729+611] = + s[395];
gout[n*729+612] = + s[396];
gout[n*729+613] = + s[397];
gout[n*729+614] = + s[398];
gout[n*729+615] = + s[399];
gout[n*729+616] = + s[400];
gout[n*729+617] = + s[401];
gout[n*729+618] = + s[402];
gout[n*729+619] = + s[403];
gout[n*729+620] = + s[404];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[216];
gout[n*729+649] = + s[217];
gout[n*729+650] = + s[218];
gout[n*729+651] = + s[219];
gout[n*729+652] = + s[220];
gout[n*729+653] = + s[221];
gout[n*729+654] = + s[222];
gout[n*729+655] = + s[223];
gout[n*729+656] = + s[224];
gout[n*729+657] = + s[225];
gout[n*729+658] = + s[226];
gout[n*729+659] = + s[227];
gout[n*729+660] = + s[228];
gout[n*729+661] = + s[229];
gout[n*729+662] = + s[230];
gout[n*729+663] = + s[231];
gout[n*729+664] = + s[232];
gout[n*729+665] = + s[233];
gout[n*729+666] = + s[234];
gout[n*729+667] = + s[235];
gout[n*729+668] = + s[236];
gout[n*729+669] = + s[237];
gout[n*729+670] = + s[238];
gout[n*729+671] = + s[239];
gout[n*729+672] = + s[240];
gout[n*729+673] = + s[241];
gout[n*729+674] = + s[242];
gout[n*729+675] = + s[459];
gout[n*729+676] = + s[460];
gout[n*729+677] = + s[461];
gout[n*729+678] = + s[462];
gout[n*729+679] = + s[463];
gout[n*729+680] = + s[464];
gout[n*729+681] = + s[465];
gout[n*729+682] = + s[466];
gout[n*729+683] = + s[467];
gout[n*729+684] = + s[468];
gout[n*729+685] = + s[469];
gout[n*729+686] = + s[470];
gout[n*729+687] = + s[471];
gout[n*729+688] = + s[472];
gout[n*729+689] = + s[473];
gout[n*729+690] = + s[474];
gout[n*729+691] = + s[475];
gout[n*729+692] = + s[476];
gout[n*729+693] = + s[477];
gout[n*729+694] = + s[478];
gout[n*729+695] = + s[479];
gout[n*729+696] = + s[480];
gout[n*729+697] = + s[481];
gout[n*729+698] = + s[482];
gout[n*729+699] = + s[483];
gout[n*729+700] = + s[484];
gout[n*729+701] = + s[485];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[243];
gout[n*729+28] += + s[244];
gout[n*729+29] += + s[245];
gout[n*729+30] += + s[246];
gout[n*729+31] += + s[247];
gout[n*729+32] += + s[248];
gout[n*729+33] += + s[249];
gout[n*729+34] += + s[250];
gout[n*729+35] += + s[251];
gout[n*729+36] += + s[252];
gout[n*729+37] += + s[253];
gout[n*729+38] += + s[254];
gout[n*729+39] += + s[255];
gout[n*729+40] += + s[256];
gout[n*729+41] += + s[257];
gout[n*729+42] += + s[258];
gout[n*729+43] += + s[259];
gout[n*729+44] += + s[260];
gout[n*729+45] += + s[261];
gout[n*729+46] += + s[262];
gout[n*729+47] += + s[263];
gout[n*729+48] += + s[264];
gout[n*729+49] += + s[265];
gout[n*729+50] += + s[266];
gout[n*729+51] += + s[267];
gout[n*729+52] += + s[268];
gout[n*729+53] += + s[269];
gout[n*729+54] += + s[486];
gout[n*729+55] += + s[487];
gout[n*729+56] += + s[488];
gout[n*729+57] += + s[489];
gout[n*729+58] += + s[490];
gout[n*729+59] += + s[491];
gout[n*729+60] += + s[492];
gout[n*729+61] += + s[493];
gout[n*729+62] += + s[494];
gout[n*729+63] += + s[495];
gout[n*729+64] += + s[496];
gout[n*729+65] += + s[497];
gout[n*729+66] += + s[498];
gout[n*729+67] += + s[499];
gout[n*729+68] += + s[500];
gout[n*729+69] += + s[501];
gout[n*729+70] += + s[502];
gout[n*729+71] += + s[503];
gout[n*729+72] += + s[504];
gout[n*729+73] += + s[505];
gout[n*729+74] += + s[506];
gout[n*729+75] += + s[507];
gout[n*729+76] += + s[508];
gout[n*729+77] += + s[509];
gout[n*729+78] += + s[510];
gout[n*729+79] += + s[511];
gout[n*729+80] += + s[512];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[324];
gout[n*729+109] += + s[325];
gout[n*729+110] += + s[326];
gout[n*729+111] += + s[327];
gout[n*729+112] += + s[328];
gout[n*729+113] += + s[329];
gout[n*729+114] += + s[330];
gout[n*729+115] += + s[331];
gout[n*729+116] += + s[332];
gout[n*729+117] += + s[333];
gout[n*729+118] += + s[334];
gout[n*729+119] += + s[335];
gout[n*729+120] += + s[336];
gout[n*729+121] += + s[337];
gout[n*729+122] += + s[338];
gout[n*729+123] += + s[339];
gout[n*729+124] += + s[340];
gout[n*729+125] += + s[341];
gout[n*729+126] += + s[342];
gout[n*729+127] += + s[343];
gout[n*729+128] += + s[344];
gout[n*729+129] += + s[345];
gout[n*729+130] += + s[346];
gout[n*729+131] += + s[347];
gout[n*729+132] += + s[348];
gout[n*729+133] += + s[349];
gout[n*729+134] += + s[350];
gout[n*729+135] += + s[567];
gout[n*729+136] += + s[568];
gout[n*729+137] += + s[569];
gout[n*729+138] += + s[570];
gout[n*729+139] += + s[571];
gout[n*729+140] += + s[572];
gout[n*729+141] += + s[573];
gout[n*729+142] += + s[574];
gout[n*729+143] += + s[575];
gout[n*729+144] += + s[576];
gout[n*729+145] += + s[577];
gout[n*729+146] += + s[578];
gout[n*729+147] += + s[579];
gout[n*729+148] += + s[580];
gout[n*729+149] += + s[581];
gout[n*729+150] += + s[582];
gout[n*729+151] += + s[583];
gout[n*729+152] += + s[584];
gout[n*729+153] += + s[585];
gout[n*729+154] += + s[586];
gout[n*729+155] += + s[587];
gout[n*729+156] += + s[588];
gout[n*729+157] += + s[589];
gout[n*729+158] += + s[590];
gout[n*729+159] += + s[591];
gout[n*729+160] += + s[592];
gout[n*729+161] += + s[593];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[405];
gout[n*729+190] += + s[406];
gout[n*729+191] += + s[407];
gout[n*729+192] += + s[408];
gout[n*729+193] += + s[409];
gout[n*729+194] += + s[410];
gout[n*729+195] += + s[411];
gout[n*729+196] += + s[412];
gout[n*729+197] += + s[413];
gout[n*729+198] += + s[414];
gout[n*729+199] += + s[415];
gout[n*729+200] += + s[416];
gout[n*729+201] += + s[417];
gout[n*729+202] += + s[418];
gout[n*729+203] += + s[419];
gout[n*729+204] += + s[420];
gout[n*729+205] += + s[421];
gout[n*729+206] += + s[422];
gout[n*729+207] += + s[423];
gout[n*729+208] += + s[424];
gout[n*729+209] += + s[425];
gout[n*729+210] += + s[426];
gout[n*729+211] += + s[427];
gout[n*729+212] += + s[428];
gout[n*729+213] += + s[429];
gout[n*729+214] += + s[430];
gout[n*729+215] += + s[431];
gout[n*729+216] += + s[648];
gout[n*729+217] += + s[649];
gout[n*729+218] += + s[650];
gout[n*729+219] += + s[651];
gout[n*729+220] += + s[652];
gout[n*729+221] += + s[653];
gout[n*729+222] += + s[654];
gout[n*729+223] += + s[655];
gout[n*729+224] += + s[656];
gout[n*729+225] += + s[657];
gout[n*729+226] += + s[658];
gout[n*729+227] += + s[659];
gout[n*729+228] += + s[660];
gout[n*729+229] += + s[661];
gout[n*729+230] += + s[662];
gout[n*729+231] += + s[663];
gout[n*729+232] += + s[664];
gout[n*729+233] += + s[665];
gout[n*729+234] += + s[666];
gout[n*729+235] += + s[667];
gout[n*729+236] += + s[668];
gout[n*729+237] += + s[669];
gout[n*729+238] += + s[670];
gout[n*729+239] += + s[671];
gout[n*729+240] += + s[672];
gout[n*729+241] += + s[673];
gout[n*729+242] += + s[674];
gout[n*729+243] += + s[27];
gout[n*729+244] += + s[28];
gout[n*729+245] += + s[29];
gout[n*729+246] += + s[30];
gout[n*729+247] += + s[31];
gout[n*729+248] += + s[32];
gout[n*729+249] += + s[33];
gout[n*729+250] += + s[34];
gout[n*729+251] += + s[35];
gout[n*729+252] += + s[36];
gout[n*729+253] += + s[37];
gout[n*729+254] += + s[38];
gout[n*729+255] += + s[39];
gout[n*729+256] += + s[40];
gout[n*729+257] += + s[41];
gout[n*729+258] += + s[42];
gout[n*729+259] += + s[43];
gout[n*729+260] += + s[44];
gout[n*729+261] += + s[45];
gout[n*729+262] += + s[46];
gout[n*729+263] += + s[47];
gout[n*729+264] += + s[48];
gout[n*729+265] += + s[49];
gout[n*729+266] += + s[50];
gout[n*729+267] += + s[51];
gout[n*729+268] += + s[52];
gout[n*729+269] += + s[53];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[513];
gout[n*729+298] += + s[514];
gout[n*729+299] += + s[515];
gout[n*729+300] += + s[516];
gout[n*729+301] += + s[517];
gout[n*729+302] += + s[518];
gout[n*729+303] += + s[519];
gout[n*729+304] += + s[520];
gout[n*729+305] += + s[521];
gout[n*729+306] += + s[522];
gout[n*729+307] += + s[523];
gout[n*729+308] += + s[524];
gout[n*729+309] += + s[525];
gout[n*729+310] += + s[526];
gout[n*729+311] += + s[527];
gout[n*729+312] += + s[528];
gout[n*729+313] += + s[529];
gout[n*729+314] += + s[530];
gout[n*729+315] += + s[531];
gout[n*729+316] += + s[532];
gout[n*729+317] += + s[533];
gout[n*729+318] += + s[534];
gout[n*729+319] += + s[535];
gout[n*729+320] += + s[536];
gout[n*729+321] += + s[537];
gout[n*729+322] += + s[538];
gout[n*729+323] += + s[539];
gout[n*729+324] += + s[108];
gout[n*729+325] += + s[109];
gout[n*729+326] += + s[110];
gout[n*729+327] += + s[111];
gout[n*729+328] += + s[112];
gout[n*729+329] += + s[113];
gout[n*729+330] += + s[114];
gout[n*729+331] += + s[115];
gout[n*729+332] += + s[116];
gout[n*729+333] += + s[117];
gout[n*729+334] += + s[118];
gout[n*729+335] += + s[119];
gout[n*729+336] += + s[120];
gout[n*729+337] += + s[121];
gout[n*729+338] += + s[122];
gout[n*729+339] += + s[123];
gout[n*729+340] += + s[124];
gout[n*729+341] += + s[125];
gout[n*729+342] += + s[126];
gout[n*729+343] += + s[127];
gout[n*729+344] += + s[128];
gout[n*729+345] += + s[129];
gout[n*729+346] += + s[130];
gout[n*729+347] += + s[131];
gout[n*729+348] += + s[132];
gout[n*729+349] += + s[133];
gout[n*729+350] += + s[134];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[594];
gout[n*729+379] += + s[595];
gout[n*729+380] += + s[596];
gout[n*729+381] += + s[597];
gout[n*729+382] += + s[598];
gout[n*729+383] += + s[599];
gout[n*729+384] += + s[600];
gout[n*729+385] += + s[601];
gout[n*729+386] += + s[602];
gout[n*729+387] += + s[603];
gout[n*729+388] += + s[604];
gout[n*729+389] += + s[605];
gout[n*729+390] += + s[606];
gout[n*729+391] += + s[607];
gout[n*729+392] += + s[608];
gout[n*729+393] += + s[609];
gout[n*729+394] += + s[610];
gout[n*729+395] += + s[611];
gout[n*729+396] += + s[612];
gout[n*729+397] += + s[613];
gout[n*729+398] += + s[614];
gout[n*729+399] += + s[615];
gout[n*729+400] += + s[616];
gout[n*729+401] += + s[617];
gout[n*729+402] += + s[618];
gout[n*729+403] += + s[619];
gout[n*729+404] += + s[620];
gout[n*729+405] += + s[189];
gout[n*729+406] += + s[190];
gout[n*729+407] += + s[191];
gout[n*729+408] += + s[192];
gout[n*729+409] += + s[193];
gout[n*729+410] += + s[194];
gout[n*729+411] += + s[195];
gout[n*729+412] += + s[196];
gout[n*729+413] += + s[197];
gout[n*729+414] += + s[198];
gout[n*729+415] += + s[199];
gout[n*729+416] += + s[200];
gout[n*729+417] += + s[201];
gout[n*729+418] += + s[202];
gout[n*729+419] += + s[203];
gout[n*729+420] += + s[204];
gout[n*729+421] += + s[205];
gout[n*729+422] += + s[206];
gout[n*729+423] += + s[207];
gout[n*729+424] += + s[208];
gout[n*729+425] += + s[209];
gout[n*729+426] += + s[210];
gout[n*729+427] += + s[211];
gout[n*729+428] += + s[212];
gout[n*729+429] += + s[213];
gout[n*729+430] += + s[214];
gout[n*729+431] += + s[215];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[675];
gout[n*729+460] += + s[676];
gout[n*729+461] += + s[677];
gout[n*729+462] += + s[678];
gout[n*729+463] += + s[679];
gout[n*729+464] += + s[680];
gout[n*729+465] += + s[681];
gout[n*729+466] += + s[682];
gout[n*729+467] += + s[683];
gout[n*729+468] += + s[684];
gout[n*729+469] += + s[685];
gout[n*729+470] += + s[686];
gout[n*729+471] += + s[687];
gout[n*729+472] += + s[688];
gout[n*729+473] += + s[689];
gout[n*729+474] += + s[690];
gout[n*729+475] += + s[691];
gout[n*729+476] += + s[692];
gout[n*729+477] += + s[693];
gout[n*729+478] += + s[694];
gout[n*729+479] += + s[695];
gout[n*729+480] += + s[696];
gout[n*729+481] += + s[697];
gout[n*729+482] += + s[698];
gout[n*729+483] += + s[699];
gout[n*729+484] += + s[700];
gout[n*729+485] += + s[701];
gout[n*729+486] += + s[54];
gout[n*729+487] += + s[55];
gout[n*729+488] += + s[56];
gout[n*729+489] += + s[57];
gout[n*729+490] += + s[58];
gout[n*729+491] += + s[59];
gout[n*729+492] += + s[60];
gout[n*729+493] += + s[61];
gout[n*729+494] += + s[62];
gout[n*729+495] += + s[63];
gout[n*729+496] += + s[64];
gout[n*729+497] += + s[65];
gout[n*729+498] += + s[66];
gout[n*729+499] += + s[67];
gout[n*729+500] += + s[68];
gout[n*729+501] += + s[69];
gout[n*729+502] += + s[70];
gout[n*729+503] += + s[71];
gout[n*729+504] += + s[72];
gout[n*729+505] += + s[73];
gout[n*729+506] += + s[74];
gout[n*729+507] += + s[75];
gout[n*729+508] += + s[76];
gout[n*729+509] += + s[77];
gout[n*729+510] += + s[78];
gout[n*729+511] += + s[79];
gout[n*729+512] += + s[80];
gout[n*729+513] += + s[297];
gout[n*729+514] += + s[298];
gout[n*729+515] += + s[299];
gout[n*729+516] += + s[300];
gout[n*729+517] += + s[301];
gout[n*729+518] += + s[302];
gout[n*729+519] += + s[303];
gout[n*729+520] += + s[304];
gout[n*729+521] += + s[305];
gout[n*729+522] += + s[306];
gout[n*729+523] += + s[307];
gout[n*729+524] += + s[308];
gout[n*729+525] += + s[309];
gout[n*729+526] += + s[310];
gout[n*729+527] += + s[311];
gout[n*729+528] += + s[312];
gout[n*729+529] += + s[313];
gout[n*729+530] += + s[314];
gout[n*729+531] += + s[315];
gout[n*729+532] += + s[316];
gout[n*729+533] += + s[317];
gout[n*729+534] += + s[318];
gout[n*729+535] += + s[319];
gout[n*729+536] += + s[320];
gout[n*729+537] += + s[321];
gout[n*729+538] += + s[322];
gout[n*729+539] += + s[323];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[135];
gout[n*729+568] += + s[136];
gout[n*729+569] += + s[137];
gout[n*729+570] += + s[138];
gout[n*729+571] += + s[139];
gout[n*729+572] += + s[140];
gout[n*729+573] += + s[141];
gout[n*729+574] += + s[142];
gout[n*729+575] += + s[143];
gout[n*729+576] += + s[144];
gout[n*729+577] += + s[145];
gout[n*729+578] += + s[146];
gout[n*729+579] += + s[147];
gout[n*729+580] += + s[148];
gout[n*729+581] += + s[149];
gout[n*729+582] += + s[150];
gout[n*729+583] += + s[151];
gout[n*729+584] += + s[152];
gout[n*729+585] += + s[153];
gout[n*729+586] += + s[154];
gout[n*729+587] += + s[155];
gout[n*729+588] += + s[156];
gout[n*729+589] += + s[157];
gout[n*729+590] += + s[158];
gout[n*729+591] += + s[159];
gout[n*729+592] += + s[160];
gout[n*729+593] += + s[161];
gout[n*729+594] += + s[378];
gout[n*729+595] += + s[379];
gout[n*729+596] += + s[380];
gout[n*729+597] += + s[381];
gout[n*729+598] += + s[382];
gout[n*729+599] += + s[383];
gout[n*729+600] += + s[384];
gout[n*729+601] += + s[385];
gout[n*729+602] += + s[386];
gout[n*729+603] += + s[387];
gout[n*729+604] += + s[388];
gout[n*729+605] += + s[389];
gout[n*729+606] += + s[390];
gout[n*729+607] += + s[391];
gout[n*729+608] += + s[392];
gout[n*729+609] += + s[393];
gout[n*729+610] += + s[394];
gout[n*729+611] += + s[395];
gout[n*729+612] += + s[396];
gout[n*729+613] += + s[397];
gout[n*729+614] += + s[398];
gout[n*729+615] += + s[399];
gout[n*729+616] += + s[400];
gout[n*729+617] += + s[401];
gout[n*729+618] += + s[402];
gout[n*729+619] += + s[403];
gout[n*729+620] += + s[404];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[216];
gout[n*729+649] += + s[217];
gout[n*729+650] += + s[218];
gout[n*729+651] += + s[219];
gout[n*729+652] += + s[220];
gout[n*729+653] += + s[221];
gout[n*729+654] += + s[222];
gout[n*729+655] += + s[223];
gout[n*729+656] += + s[224];
gout[n*729+657] += + s[225];
gout[n*729+658] += + s[226];
gout[n*729+659] += + s[227];
gout[n*729+660] += + s[228];
gout[n*729+661] += + s[229];
gout[n*729+662] += + s[230];
gout[n*729+663] += + s[231];
gout[n*729+664] += + s[232];
gout[n*729+665] += + s[233];
gout[n*729+666] += + s[234];
gout[n*729+667] += + s[235];
gout[n*729+668] += + s[236];
gout[n*729+669] += + s[237];
gout[n*729+670] += + s[238];
gout[n*729+671] += + s[239];
gout[n*729+672] += + s[240];
gout[n*729+673] += + s[241];
gout[n*729+674] += + s[242];
gout[n*729+675] += + s[459];
gout[n*729+676] += + s[460];
gout[n*729+677] += + s[461];
gout[n*729+678] += + s[462];
gout[n*729+679] += + s[463];
gout[n*729+680] += + s[464];
gout[n*729+681] += + s[465];
gout[n*729+682] += + s[466];
gout[n*729+683] += + s[467];
gout[n*729+684] += + s[468];
gout[n*729+685] += + s[469];
gout[n*729+686] += + s[470];
gout[n*729+687] += + s[471];
gout[n*729+688] += + s[472];
gout[n*729+689] += + s[473];
gout[n*729+690] += + s[474];
gout[n*729+691] += + s[475];
gout[n*729+692] += + s[476];
gout[n*729+693] += + s[477];
gout[n*729+694] += + s[478];
gout[n*729+695] += + s[479];
gout[n*729+696] += + s[480];
gout[n*729+697] += + s[481];
gout[n*729+698] += + s[482];
gout[n*729+699] += + s[483];
gout[n*729+700] += + s[484];
gout[n*729+701] += + s[485];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipipnnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipnnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipnnip_cart
CACHE_SIZE_T int1e_ipipipnnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipnnip_sph
CACHE_SIZE_T int1e_ipipipnnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipnnip_spinor
ALL_CINT1E(int1e_ipipipnnip)
ALL_CINT1E_FORTRAN_(int1e_ipipipnnip)
/* <NABLA NABLA i|RJ RJ |NABLA NABLA j> */
void CINTgout1e_int1e_ipipnnipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+2, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[243];
gout[n*729+82] = + s[244];
gout[n*729+83] = + s[245];
gout[n*729+84] = + s[246];
gout[n*729+85] = + s[247];
gout[n*729+86] = + s[248];
gout[n*729+87] = + s[249];
gout[n*729+88] = + s[250];
gout[n*729+89] = + s[251];
gout[n*729+90] = + s[252];
gout[n*729+91] = + s[253];
gout[n*729+92] = + s[254];
gout[n*729+93] = + s[255];
gout[n*729+94] = + s[256];
gout[n*729+95] = + s[257];
gout[n*729+96] = + s[258];
gout[n*729+97] = + s[259];
gout[n*729+98] = + s[260];
gout[n*729+99] = + s[261];
gout[n*729+100] = + s[262];
gout[n*729+101] = + s[263];
gout[n*729+102] = + s[264];
gout[n*729+103] = + s[265];
gout[n*729+104] = + s[266];
gout[n*729+105] = + s[267];
gout[n*729+106] = + s[268];
gout[n*729+107] = + s[269];
gout[n*729+108] = + s[270];
gout[n*729+109] = + s[271];
gout[n*729+110] = + s[272];
gout[n*729+111] = + s[273];
gout[n*729+112] = + s[274];
gout[n*729+113] = + s[275];
gout[n*729+114] = + s[276];
gout[n*729+115] = + s[277];
gout[n*729+116] = + s[278];
gout[n*729+117] = + s[279];
gout[n*729+118] = + s[280];
gout[n*729+119] = + s[281];
gout[n*729+120] = + s[282];
gout[n*729+121] = + s[283];
gout[n*729+122] = + s[284];
gout[n*729+123] = + s[285];
gout[n*729+124] = + s[286];
gout[n*729+125] = + s[287];
gout[n*729+126] = + s[288];
gout[n*729+127] = + s[289];
gout[n*729+128] = + s[290];
gout[n*729+129] = + s[291];
gout[n*729+130] = + s[292];
gout[n*729+131] = + s[293];
gout[n*729+132] = + s[294];
gout[n*729+133] = + s[295];
gout[n*729+134] = + s[296];
gout[n*729+135] = + s[297];
gout[n*729+136] = + s[298];
gout[n*729+137] = + s[299];
gout[n*729+138] = + s[300];
gout[n*729+139] = + s[301];
gout[n*729+140] = + s[302];
gout[n*729+141] = + s[303];
gout[n*729+142] = + s[304];
gout[n*729+143] = + s[305];
gout[n*729+144] = + s[306];
gout[n*729+145] = + s[307];
gout[n*729+146] = + s[308];
gout[n*729+147] = + s[309];
gout[n*729+148] = + s[310];
gout[n*729+149] = + s[311];
gout[n*729+150] = + s[312];
gout[n*729+151] = + s[313];
gout[n*729+152] = + s[314];
gout[n*729+153] = + s[315];
gout[n*729+154] = + s[316];
gout[n*729+155] = + s[317];
gout[n*729+156] = + s[318];
gout[n*729+157] = + s[319];
gout[n*729+158] = + s[320];
gout[n*729+159] = + s[321];
gout[n*729+160] = + s[322];
gout[n*729+161] = + s[323];
gout[n*729+162] = + s[486];
gout[n*729+163] = + s[487];
gout[n*729+164] = + s[488];
gout[n*729+165] = + s[489];
gout[n*729+166] = + s[490];
gout[n*729+167] = + s[491];
gout[n*729+168] = + s[492];
gout[n*729+169] = + s[493];
gout[n*729+170] = + s[494];
gout[n*729+171] = + s[495];
gout[n*729+172] = + s[496];
gout[n*729+173] = + s[497];
gout[n*729+174] = + s[498];
gout[n*729+175] = + s[499];
gout[n*729+176] = + s[500];
gout[n*729+177] = + s[501];
gout[n*729+178] = + s[502];
gout[n*729+179] = + s[503];
gout[n*729+180] = + s[504];
gout[n*729+181] = + s[505];
gout[n*729+182] = + s[506];
gout[n*729+183] = + s[507];
gout[n*729+184] = + s[508];
gout[n*729+185] = + s[509];
gout[n*729+186] = + s[510];
gout[n*729+187] = + s[511];
gout[n*729+188] = + s[512];
gout[n*729+189] = + s[513];
gout[n*729+190] = + s[514];
gout[n*729+191] = + s[515];
gout[n*729+192] = + s[516];
gout[n*729+193] = + s[517];
gout[n*729+194] = + s[518];
gout[n*729+195] = + s[519];
gout[n*729+196] = + s[520];
gout[n*729+197] = + s[521];
gout[n*729+198] = + s[522];
gout[n*729+199] = + s[523];
gout[n*729+200] = + s[524];
gout[n*729+201] = + s[525];
gout[n*729+202] = + s[526];
gout[n*729+203] = + s[527];
gout[n*729+204] = + s[528];
gout[n*729+205] = + s[529];
gout[n*729+206] = + s[530];
gout[n*729+207] = + s[531];
gout[n*729+208] = + s[532];
gout[n*729+209] = + s[533];
gout[n*729+210] = + s[534];
gout[n*729+211] = + s[535];
gout[n*729+212] = + s[536];
gout[n*729+213] = + s[537];
gout[n*729+214] = + s[538];
gout[n*729+215] = + s[539];
gout[n*729+216] = + s[540];
gout[n*729+217] = + s[541];
gout[n*729+218] = + s[542];
gout[n*729+219] = + s[543];
gout[n*729+220] = + s[544];
gout[n*729+221] = + s[545];
gout[n*729+222] = + s[546];
gout[n*729+223] = + s[547];
gout[n*729+224] = + s[548];
gout[n*729+225] = + s[549];
gout[n*729+226] = + s[550];
gout[n*729+227] = + s[551];
gout[n*729+228] = + s[552];
gout[n*729+229] = + s[553];
gout[n*729+230] = + s[554];
gout[n*729+231] = + s[555];
gout[n*729+232] = + s[556];
gout[n*729+233] = + s[557];
gout[n*729+234] = + s[558];
gout[n*729+235] = + s[559];
gout[n*729+236] = + s[560];
gout[n*729+237] = + s[561];
gout[n*729+238] = + s[562];
gout[n*729+239] = + s[563];
gout[n*729+240] = + s[564];
gout[n*729+241] = + s[565];
gout[n*729+242] = + s[566];
gout[n*729+243] = + s[81];
gout[n*729+244] = + s[82];
gout[n*729+245] = + s[83];
gout[n*729+246] = + s[84];
gout[n*729+247] = + s[85];
gout[n*729+248] = + s[86];
gout[n*729+249] = + s[87];
gout[n*729+250] = + s[88];
gout[n*729+251] = + s[89];
gout[n*729+252] = + s[90];
gout[n*729+253] = + s[91];
gout[n*729+254] = + s[92];
gout[n*729+255] = + s[93];
gout[n*729+256] = + s[94];
gout[n*729+257] = + s[95];
gout[n*729+258] = + s[96];
gout[n*729+259] = + s[97];
gout[n*729+260] = + s[98];
gout[n*729+261] = + s[99];
gout[n*729+262] = + s[100];
gout[n*729+263] = + s[101];
gout[n*729+264] = + s[102];
gout[n*729+265] = + s[103];
gout[n*729+266] = + s[104];
gout[n*729+267] = + s[105];
gout[n*729+268] = + s[106];
gout[n*729+269] = + s[107];
gout[n*729+270] = + s[108];
gout[n*729+271] = + s[109];
gout[n*729+272] = + s[110];
gout[n*729+273] = + s[111];
gout[n*729+274] = + s[112];
gout[n*729+275] = + s[113];
gout[n*729+276] = + s[114];
gout[n*729+277] = + s[115];
gout[n*729+278] = + s[116];
gout[n*729+279] = + s[117];
gout[n*729+280] = + s[118];
gout[n*729+281] = + s[119];
gout[n*729+282] = + s[120];
gout[n*729+283] = + s[121];
gout[n*729+284] = + s[122];
gout[n*729+285] = + s[123];
gout[n*729+286] = + s[124];
gout[n*729+287] = + s[125];
gout[n*729+288] = + s[126];
gout[n*729+289] = + s[127];
gout[n*729+290] = + s[128];
gout[n*729+291] = + s[129];
gout[n*729+292] = + s[130];
gout[n*729+293] = + s[131];
gout[n*729+294] = + s[132];
gout[n*729+295] = + s[133];
gout[n*729+296] = + s[134];
gout[n*729+297] = + s[135];
gout[n*729+298] = + s[136];
gout[n*729+299] = + s[137];
gout[n*729+300] = + s[138];
gout[n*729+301] = + s[139];
gout[n*729+302] = + s[140];
gout[n*729+303] = + s[141];
gout[n*729+304] = + s[142];
gout[n*729+305] = + s[143];
gout[n*729+306] = + s[144];
gout[n*729+307] = + s[145];
gout[n*729+308] = + s[146];
gout[n*729+309] = + s[147];
gout[n*729+310] = + s[148];
gout[n*729+311] = + s[149];
gout[n*729+312] = + s[150];
gout[n*729+313] = + s[151];
gout[n*729+314] = + s[152];
gout[n*729+315] = + s[153];
gout[n*729+316] = + s[154];
gout[n*729+317] = + s[155];
gout[n*729+318] = + s[156];
gout[n*729+319] = + s[157];
gout[n*729+320] = + s[158];
gout[n*729+321] = + s[159];
gout[n*729+322] = + s[160];
gout[n*729+323] = + s[161];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[567];
gout[n*729+406] = + s[568];
gout[n*729+407] = + s[569];
gout[n*729+408] = + s[570];
gout[n*729+409] = + s[571];
gout[n*729+410] = + s[572];
gout[n*729+411] = + s[573];
gout[n*729+412] = + s[574];
gout[n*729+413] = + s[575];
gout[n*729+414] = + s[576];
gout[n*729+415] = + s[577];
gout[n*729+416] = + s[578];
gout[n*729+417] = + s[579];
gout[n*729+418] = + s[580];
gout[n*729+419] = + s[581];
gout[n*729+420] = + s[582];
gout[n*729+421] = + s[583];
gout[n*729+422] = + s[584];
gout[n*729+423] = + s[585];
gout[n*729+424] = + s[586];
gout[n*729+425] = + s[587];
gout[n*729+426] = + s[588];
gout[n*729+427] = + s[589];
gout[n*729+428] = + s[590];
gout[n*729+429] = + s[591];
gout[n*729+430] = + s[592];
gout[n*729+431] = + s[593];
gout[n*729+432] = + s[594];
gout[n*729+433] = + s[595];
gout[n*729+434] = + s[596];
gout[n*729+435] = + s[597];
gout[n*729+436] = + s[598];
gout[n*729+437] = + s[599];
gout[n*729+438] = + s[600];
gout[n*729+439] = + s[601];
gout[n*729+440] = + s[602];
gout[n*729+441] = + s[603];
gout[n*729+442] = + s[604];
gout[n*729+443] = + s[605];
gout[n*729+444] = + s[606];
gout[n*729+445] = + s[607];
gout[n*729+446] = + s[608];
gout[n*729+447] = + s[609];
gout[n*729+448] = + s[610];
gout[n*729+449] = + s[611];
gout[n*729+450] = + s[612];
gout[n*729+451] = + s[613];
gout[n*729+452] = + s[614];
gout[n*729+453] = + s[615];
gout[n*729+454] = + s[616];
gout[n*729+455] = + s[617];
gout[n*729+456] = + s[618];
gout[n*729+457] = + s[619];
gout[n*729+458] = + s[620];
gout[n*729+459] = + s[621];
gout[n*729+460] = + s[622];
gout[n*729+461] = + s[623];
gout[n*729+462] = + s[624];
gout[n*729+463] = + s[625];
gout[n*729+464] = + s[626];
gout[n*729+465] = + s[627];
gout[n*729+466] = + s[628];
gout[n*729+467] = + s[629];
gout[n*729+468] = + s[630];
gout[n*729+469] = + s[631];
gout[n*729+470] = + s[632];
gout[n*729+471] = + s[633];
gout[n*729+472] = + s[634];
gout[n*729+473] = + s[635];
gout[n*729+474] = + s[636];
gout[n*729+475] = + s[637];
gout[n*729+476] = + s[638];
gout[n*729+477] = + s[639];
gout[n*729+478] = + s[640];
gout[n*729+479] = + s[641];
gout[n*729+480] = + s[642];
gout[n*729+481] = + s[643];
gout[n*729+482] = + s[644];
gout[n*729+483] = + s[645];
gout[n*729+484] = + s[646];
gout[n*729+485] = + s[647];
gout[n*729+486] = + s[162];
gout[n*729+487] = + s[163];
gout[n*729+488] = + s[164];
gout[n*729+489] = + s[165];
gout[n*729+490] = + s[166];
gout[n*729+491] = + s[167];
gout[n*729+492] = + s[168];
gout[n*729+493] = + s[169];
gout[n*729+494] = + s[170];
gout[n*729+495] = + s[171];
gout[n*729+496] = + s[172];
gout[n*729+497] = + s[173];
gout[n*729+498] = + s[174];
gout[n*729+499] = + s[175];
gout[n*729+500] = + s[176];
gout[n*729+501] = + s[177];
gout[n*729+502] = + s[178];
gout[n*729+503] = + s[179];
gout[n*729+504] = + s[180];
gout[n*729+505] = + s[181];
gout[n*729+506] = + s[182];
gout[n*729+507] = + s[183];
gout[n*729+508] = + s[184];
gout[n*729+509] = + s[185];
gout[n*729+510] = + s[186];
gout[n*729+511] = + s[187];
gout[n*729+512] = + s[188];
gout[n*729+513] = + s[189];
gout[n*729+514] = + s[190];
gout[n*729+515] = + s[191];
gout[n*729+516] = + s[192];
gout[n*729+517] = + s[193];
gout[n*729+518] = + s[194];
gout[n*729+519] = + s[195];
gout[n*729+520] = + s[196];
gout[n*729+521] = + s[197];
gout[n*729+522] = + s[198];
gout[n*729+523] = + s[199];
gout[n*729+524] = + s[200];
gout[n*729+525] = + s[201];
gout[n*729+526] = + s[202];
gout[n*729+527] = + s[203];
gout[n*729+528] = + s[204];
gout[n*729+529] = + s[205];
gout[n*729+530] = + s[206];
gout[n*729+531] = + s[207];
gout[n*729+532] = + s[208];
gout[n*729+533] = + s[209];
gout[n*729+534] = + s[210];
gout[n*729+535] = + s[211];
gout[n*729+536] = + s[212];
gout[n*729+537] = + s[213];
gout[n*729+538] = + s[214];
gout[n*729+539] = + s[215];
gout[n*729+540] = + s[216];
gout[n*729+541] = + s[217];
gout[n*729+542] = + s[218];
gout[n*729+543] = + s[219];
gout[n*729+544] = + s[220];
gout[n*729+545] = + s[221];
gout[n*729+546] = + s[222];
gout[n*729+547] = + s[223];
gout[n*729+548] = + s[224];
gout[n*729+549] = + s[225];
gout[n*729+550] = + s[226];
gout[n*729+551] = + s[227];
gout[n*729+552] = + s[228];
gout[n*729+553] = + s[229];
gout[n*729+554] = + s[230];
gout[n*729+555] = + s[231];
gout[n*729+556] = + s[232];
gout[n*729+557] = + s[233];
gout[n*729+558] = + s[234];
gout[n*729+559] = + s[235];
gout[n*729+560] = + s[236];
gout[n*729+561] = + s[237];
gout[n*729+562] = + s[238];
gout[n*729+563] = + s[239];
gout[n*729+564] = + s[240];
gout[n*729+565] = + s[241];
gout[n*729+566] = + s[242];
gout[n*729+567] = + s[405];
gout[n*729+568] = + s[406];
gout[n*729+569] = + s[407];
gout[n*729+570] = + s[408];
gout[n*729+571] = + s[409];
gout[n*729+572] = + s[410];
gout[n*729+573] = + s[411];
gout[n*729+574] = + s[412];
gout[n*729+575] = + s[413];
gout[n*729+576] = + s[414];
gout[n*729+577] = + s[415];
gout[n*729+578] = + s[416];
gout[n*729+579] = + s[417];
gout[n*729+580] = + s[418];
gout[n*729+581] = + s[419];
gout[n*729+582] = + s[420];
gout[n*729+583] = + s[421];
gout[n*729+584] = + s[422];
gout[n*729+585] = + s[423];
gout[n*729+586] = + s[424];
gout[n*729+587] = + s[425];
gout[n*729+588] = + s[426];
gout[n*729+589] = + s[427];
gout[n*729+590] = + s[428];
gout[n*729+591] = + s[429];
gout[n*729+592] = + s[430];
gout[n*729+593] = + s[431];
gout[n*729+594] = + s[432];
gout[n*729+595] = + s[433];
gout[n*729+596] = + s[434];
gout[n*729+597] = + s[435];
gout[n*729+598] = + s[436];
gout[n*729+599] = + s[437];
gout[n*729+600] = + s[438];
gout[n*729+601] = + s[439];
gout[n*729+602] = + s[440];
gout[n*729+603] = + s[441];
gout[n*729+604] = + s[442];
gout[n*729+605] = + s[443];
gout[n*729+606] = + s[444];
gout[n*729+607] = + s[445];
gout[n*729+608] = + s[446];
gout[n*729+609] = + s[447];
gout[n*729+610] = + s[448];
gout[n*729+611] = + s[449];
gout[n*729+612] = + s[450];
gout[n*729+613] = + s[451];
gout[n*729+614] = + s[452];
gout[n*729+615] = + s[453];
gout[n*729+616] = + s[454];
gout[n*729+617] = + s[455];
gout[n*729+618] = + s[456];
gout[n*729+619] = + s[457];
gout[n*729+620] = + s[458];
gout[n*729+621] = + s[459];
gout[n*729+622] = + s[460];
gout[n*729+623] = + s[461];
gout[n*729+624] = + s[462];
gout[n*729+625] = + s[463];
gout[n*729+626] = + s[464];
gout[n*729+627] = + s[465];
gout[n*729+628] = + s[466];
gout[n*729+629] = + s[467];
gout[n*729+630] = + s[468];
gout[n*729+631] = + s[469];
gout[n*729+632] = + s[470];
gout[n*729+633] = + s[471];
gout[n*729+634] = + s[472];
gout[n*729+635] = + s[473];
gout[n*729+636] = + s[474];
gout[n*729+637] = + s[475];
gout[n*729+638] = + s[476];
gout[n*729+639] = + s[477];
gout[n*729+640] = + s[478];
gout[n*729+641] = + s[479];
gout[n*729+642] = + s[480];
gout[n*729+643] = + s[481];
gout[n*729+644] = + s[482];
gout[n*729+645] = + s[483];
gout[n*729+646] = + s[484];
gout[n*729+647] = + s[485];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[243];
gout[n*729+82] += + s[244];
gout[n*729+83] += + s[245];
gout[n*729+84] += + s[246];
gout[n*729+85] += + s[247];
gout[n*729+86] += + s[248];
gout[n*729+87] += + s[249];
gout[n*729+88] += + s[250];
gout[n*729+89] += + s[251];
gout[n*729+90] += + s[252];
gout[n*729+91] += + s[253];
gout[n*729+92] += + s[254];
gout[n*729+93] += + s[255];
gout[n*729+94] += + s[256];
gout[n*729+95] += + s[257];
gout[n*729+96] += + s[258];
gout[n*729+97] += + s[259];
gout[n*729+98] += + s[260];
gout[n*729+99] += + s[261];
gout[n*729+100] += + s[262];
gout[n*729+101] += + s[263];
gout[n*729+102] += + s[264];
gout[n*729+103] += + s[265];
gout[n*729+104] += + s[266];
gout[n*729+105] += + s[267];
gout[n*729+106] += + s[268];
gout[n*729+107] += + s[269];
gout[n*729+108] += + s[270];
gout[n*729+109] += + s[271];
gout[n*729+110] += + s[272];
gout[n*729+111] += + s[273];
gout[n*729+112] += + s[274];
gout[n*729+113] += + s[275];
gout[n*729+114] += + s[276];
gout[n*729+115] += + s[277];
gout[n*729+116] += + s[278];
gout[n*729+117] += + s[279];
gout[n*729+118] += + s[280];
gout[n*729+119] += + s[281];
gout[n*729+120] += + s[282];
gout[n*729+121] += + s[283];
gout[n*729+122] += + s[284];
gout[n*729+123] += + s[285];
gout[n*729+124] += + s[286];
gout[n*729+125] += + s[287];
gout[n*729+126] += + s[288];
gout[n*729+127] += + s[289];
gout[n*729+128] += + s[290];
gout[n*729+129] += + s[291];
gout[n*729+130] += + s[292];
gout[n*729+131] += + s[293];
gout[n*729+132] += + s[294];
gout[n*729+133] += + s[295];
gout[n*729+134] += + s[296];
gout[n*729+135] += + s[297];
gout[n*729+136] += + s[298];
gout[n*729+137] += + s[299];
gout[n*729+138] += + s[300];
gout[n*729+139] += + s[301];
gout[n*729+140] += + s[302];
gout[n*729+141] += + s[303];
gout[n*729+142] += + s[304];
gout[n*729+143] += + s[305];
gout[n*729+144] += + s[306];
gout[n*729+145] += + s[307];
gout[n*729+146] += + s[308];
gout[n*729+147] += + s[309];
gout[n*729+148] += + s[310];
gout[n*729+149] += + s[311];
gout[n*729+150] += + s[312];
gout[n*729+151] += + s[313];
gout[n*729+152] += + s[314];
gout[n*729+153] += + s[315];
gout[n*729+154] += + s[316];
gout[n*729+155] += + s[317];
gout[n*729+156] += + s[318];
gout[n*729+157] += + s[319];
gout[n*729+158] += + s[320];
gout[n*729+159] += + s[321];
gout[n*729+160] += + s[322];
gout[n*729+161] += + s[323];
gout[n*729+162] += + s[486];
gout[n*729+163] += + s[487];
gout[n*729+164] += + s[488];
gout[n*729+165] += + s[489];
gout[n*729+166] += + s[490];
gout[n*729+167] += + s[491];
gout[n*729+168] += + s[492];
gout[n*729+169] += + s[493];
gout[n*729+170] += + s[494];
gout[n*729+171] += + s[495];
gout[n*729+172] += + s[496];
gout[n*729+173] += + s[497];
gout[n*729+174] += + s[498];
gout[n*729+175] += + s[499];
gout[n*729+176] += + s[500];
gout[n*729+177] += + s[501];
gout[n*729+178] += + s[502];
gout[n*729+179] += + s[503];
gout[n*729+180] += + s[504];
gout[n*729+181] += + s[505];
gout[n*729+182] += + s[506];
gout[n*729+183] += + s[507];
gout[n*729+184] += + s[508];
gout[n*729+185] += + s[509];
gout[n*729+186] += + s[510];
gout[n*729+187] += + s[511];
gout[n*729+188] += + s[512];
gout[n*729+189] += + s[513];
gout[n*729+190] += + s[514];
gout[n*729+191] += + s[515];
gout[n*729+192] += + s[516];
gout[n*729+193] += + s[517];
gout[n*729+194] += + s[518];
gout[n*729+195] += + s[519];
gout[n*729+196] += + s[520];
gout[n*729+197] += + s[521];
gout[n*729+198] += + s[522];
gout[n*729+199] += + s[523];
gout[n*729+200] += + s[524];
gout[n*729+201] += + s[525];
gout[n*729+202] += + s[526];
gout[n*729+203] += + s[527];
gout[n*729+204] += + s[528];
gout[n*729+205] += + s[529];
gout[n*729+206] += + s[530];
gout[n*729+207] += + s[531];
gout[n*729+208] += + s[532];
gout[n*729+209] += + s[533];
gout[n*729+210] += + s[534];
gout[n*729+211] += + s[535];
gout[n*729+212] += + s[536];
gout[n*729+213] += + s[537];
gout[n*729+214] += + s[538];
gout[n*729+215] += + s[539];
gout[n*729+216] += + s[540];
gout[n*729+217] += + s[541];
gout[n*729+218] += + s[542];
gout[n*729+219] += + s[543];
gout[n*729+220] += + s[544];
gout[n*729+221] += + s[545];
gout[n*729+222] += + s[546];
gout[n*729+223] += + s[547];
gout[n*729+224] += + s[548];
gout[n*729+225] += + s[549];
gout[n*729+226] += + s[550];
gout[n*729+227] += + s[551];
gout[n*729+228] += + s[552];
gout[n*729+229] += + s[553];
gout[n*729+230] += + s[554];
gout[n*729+231] += + s[555];
gout[n*729+232] += + s[556];
gout[n*729+233] += + s[557];
gout[n*729+234] += + s[558];
gout[n*729+235] += + s[559];
gout[n*729+236] += + s[560];
gout[n*729+237] += + s[561];
gout[n*729+238] += + s[562];
gout[n*729+239] += + s[563];
gout[n*729+240] += + s[564];
gout[n*729+241] += + s[565];
gout[n*729+242] += + s[566];
gout[n*729+243] += + s[81];
gout[n*729+244] += + s[82];
gout[n*729+245] += + s[83];
gout[n*729+246] += + s[84];
gout[n*729+247] += + s[85];
gout[n*729+248] += + s[86];
gout[n*729+249] += + s[87];
gout[n*729+250] += + s[88];
gout[n*729+251] += + s[89];
gout[n*729+252] += + s[90];
gout[n*729+253] += + s[91];
gout[n*729+254] += + s[92];
gout[n*729+255] += + s[93];
gout[n*729+256] += + s[94];
gout[n*729+257] += + s[95];
gout[n*729+258] += + s[96];
gout[n*729+259] += + s[97];
gout[n*729+260] += + s[98];
gout[n*729+261] += + s[99];
gout[n*729+262] += + s[100];
gout[n*729+263] += + s[101];
gout[n*729+264] += + s[102];
gout[n*729+265] += + s[103];
gout[n*729+266] += + s[104];
gout[n*729+267] += + s[105];
gout[n*729+268] += + s[106];
gout[n*729+269] += + s[107];
gout[n*729+270] += + s[108];
gout[n*729+271] += + s[109];
gout[n*729+272] += + s[110];
gout[n*729+273] += + s[111];
gout[n*729+274] += + s[112];
gout[n*729+275] += + s[113];
gout[n*729+276] += + s[114];
gout[n*729+277] += + s[115];
gout[n*729+278] += + s[116];
gout[n*729+279] += + s[117];
gout[n*729+280] += + s[118];
gout[n*729+281] += + s[119];
gout[n*729+282] += + s[120];
gout[n*729+283] += + s[121];
gout[n*729+284] += + s[122];
gout[n*729+285] += + s[123];
gout[n*729+286] += + s[124];
gout[n*729+287] += + s[125];
gout[n*729+288] += + s[126];
gout[n*729+289] += + s[127];
gout[n*729+290] += + s[128];
gout[n*729+291] += + s[129];
gout[n*729+292] += + s[130];
gout[n*729+293] += + s[131];
gout[n*729+294] += + s[132];
gout[n*729+295] += + s[133];
gout[n*729+296] += + s[134];
gout[n*729+297] += + s[135];
gout[n*729+298] += + s[136];
gout[n*729+299] += + s[137];
gout[n*729+300] += + s[138];
gout[n*729+301] += + s[139];
gout[n*729+302] += + s[140];
gout[n*729+303] += + s[141];
gout[n*729+304] += + s[142];
gout[n*729+305] += + s[143];
gout[n*729+306] += + s[144];
gout[n*729+307] += + s[145];
gout[n*729+308] += + s[146];
gout[n*729+309] += + s[147];
gout[n*729+310] += + s[148];
gout[n*729+311] += + s[149];
gout[n*729+312] += + s[150];
gout[n*729+313] += + s[151];
gout[n*729+314] += + s[152];
gout[n*729+315] += + s[153];
gout[n*729+316] += + s[154];
gout[n*729+317] += + s[155];
gout[n*729+318] += + s[156];
gout[n*729+319] += + s[157];
gout[n*729+320] += + s[158];
gout[n*729+321] += + s[159];
gout[n*729+322] += + s[160];
gout[n*729+323] += + s[161];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[567];
gout[n*729+406] += + s[568];
gout[n*729+407] += + s[569];
gout[n*729+408] += + s[570];
gout[n*729+409] += + s[571];
gout[n*729+410] += + s[572];
gout[n*729+411] += + s[573];
gout[n*729+412] += + s[574];
gout[n*729+413] += + s[575];
gout[n*729+414] += + s[576];
gout[n*729+415] += + s[577];
gout[n*729+416] += + s[578];
gout[n*729+417] += + s[579];
gout[n*729+418] += + s[580];
gout[n*729+419] += + s[581];
gout[n*729+420] += + s[582];
gout[n*729+421] += + s[583];
gout[n*729+422] += + s[584];
gout[n*729+423] += + s[585];
gout[n*729+424] += + s[586];
gout[n*729+425] += + s[587];
gout[n*729+426] += + s[588];
gout[n*729+427] += + s[589];
gout[n*729+428] += + s[590];
gout[n*729+429] += + s[591];
gout[n*729+430] += + s[592];
gout[n*729+431] += + s[593];
gout[n*729+432] += + s[594];
gout[n*729+433] += + s[595];
gout[n*729+434] += + s[596];
gout[n*729+435] += + s[597];
gout[n*729+436] += + s[598];
gout[n*729+437] += + s[599];
gout[n*729+438] += + s[600];
gout[n*729+439] += + s[601];
gout[n*729+440] += + s[602];
gout[n*729+441] += + s[603];
gout[n*729+442] += + s[604];
gout[n*729+443] += + s[605];
gout[n*729+444] += + s[606];
gout[n*729+445] += + s[607];
gout[n*729+446] += + s[608];
gout[n*729+447] += + s[609];
gout[n*729+448] += + s[610];
gout[n*729+449] += + s[611];
gout[n*729+450] += + s[612];
gout[n*729+451] += + s[613];
gout[n*729+452] += + s[614];
gout[n*729+453] += + s[615];
gout[n*729+454] += + s[616];
gout[n*729+455] += + s[617];
gout[n*729+456] += + s[618];
gout[n*729+457] += + s[619];
gout[n*729+458] += + s[620];
gout[n*729+459] += + s[621];
gout[n*729+460] += + s[622];
gout[n*729+461] += + s[623];
gout[n*729+462] += + s[624];
gout[n*729+463] += + s[625];
gout[n*729+464] += + s[626];
gout[n*729+465] += + s[627];
gout[n*729+466] += + s[628];
gout[n*729+467] += + s[629];
gout[n*729+468] += + s[630];
gout[n*729+469] += + s[631];
gout[n*729+470] += + s[632];
gout[n*729+471] += + s[633];
gout[n*729+472] += + s[634];
gout[n*729+473] += + s[635];
gout[n*729+474] += + s[636];
gout[n*729+475] += + s[637];
gout[n*729+476] += + s[638];
gout[n*729+477] += + s[639];
gout[n*729+478] += + s[640];
gout[n*729+479] += + s[641];
gout[n*729+480] += + s[642];
gout[n*729+481] += + s[643];
gout[n*729+482] += + s[644];
gout[n*729+483] += + s[645];
gout[n*729+484] += + s[646];
gout[n*729+485] += + s[647];
gout[n*729+486] += + s[162];
gout[n*729+487] += + s[163];
gout[n*729+488] += + s[164];
gout[n*729+489] += + s[165];
gout[n*729+490] += + s[166];
gout[n*729+491] += + s[167];
gout[n*729+492] += + s[168];
gout[n*729+493] += + s[169];
gout[n*729+494] += + s[170];
gout[n*729+495] += + s[171];
gout[n*729+496] += + s[172];
gout[n*729+497] += + s[173];
gout[n*729+498] += + s[174];
gout[n*729+499] += + s[175];
gout[n*729+500] += + s[176];
gout[n*729+501] += + s[177];
gout[n*729+502] += + s[178];
gout[n*729+503] += + s[179];
gout[n*729+504] += + s[180];
gout[n*729+505] += + s[181];
gout[n*729+506] += + s[182];
gout[n*729+507] += + s[183];
gout[n*729+508] += + s[184];
gout[n*729+509] += + s[185];
gout[n*729+510] += + s[186];
gout[n*729+511] += + s[187];
gout[n*729+512] += + s[188];
gout[n*729+513] += + s[189];
gout[n*729+514] += + s[190];
gout[n*729+515] += + s[191];
gout[n*729+516] += + s[192];
gout[n*729+517] += + s[193];
gout[n*729+518] += + s[194];
gout[n*729+519] += + s[195];
gout[n*729+520] += + s[196];
gout[n*729+521] += + s[197];
gout[n*729+522] += + s[198];
gout[n*729+523] += + s[199];
gout[n*729+524] += + s[200];
gout[n*729+525] += + s[201];
gout[n*729+526] += + s[202];
gout[n*729+527] += + s[203];
gout[n*729+528] += + s[204];
gout[n*729+529] += + s[205];
gout[n*729+530] += + s[206];
gout[n*729+531] += + s[207];
gout[n*729+532] += + s[208];
gout[n*729+533] += + s[209];
gout[n*729+534] += + s[210];
gout[n*729+535] += + s[211];
gout[n*729+536] += + s[212];
gout[n*729+537] += + s[213];
gout[n*729+538] += + s[214];
gout[n*729+539] += + s[215];
gout[n*729+540] += + s[216];
gout[n*729+541] += + s[217];
gout[n*729+542] += + s[218];
gout[n*729+543] += + s[219];
gout[n*729+544] += + s[220];
gout[n*729+545] += + s[221];
gout[n*729+546] += + s[222];
gout[n*729+547] += + s[223];
gout[n*729+548] += + s[224];
gout[n*729+549] += + s[225];
gout[n*729+550] += + s[226];
gout[n*729+551] += + s[227];
gout[n*729+552] += + s[228];
gout[n*729+553] += + s[229];
gout[n*729+554] += + s[230];
gout[n*729+555] += + s[231];
gout[n*729+556] += + s[232];
gout[n*729+557] += + s[233];
gout[n*729+558] += + s[234];
gout[n*729+559] += + s[235];
gout[n*729+560] += + s[236];
gout[n*729+561] += + s[237];
gout[n*729+562] += + s[238];
gout[n*729+563] += + s[239];
gout[n*729+564] += + s[240];
gout[n*729+565] += + s[241];
gout[n*729+566] += + s[242];
gout[n*729+567] += + s[405];
gout[n*729+568] += + s[406];
gout[n*729+569] += + s[407];
gout[n*729+570] += + s[408];
gout[n*729+571] += + s[409];
gout[n*729+572] += + s[410];
gout[n*729+573] += + s[411];
gout[n*729+574] += + s[412];
gout[n*729+575] += + s[413];
gout[n*729+576] += + s[414];
gout[n*729+577] += + s[415];
gout[n*729+578] += + s[416];
gout[n*729+579] += + s[417];
gout[n*729+580] += + s[418];
gout[n*729+581] += + s[419];
gout[n*729+582] += + s[420];
gout[n*729+583] += + s[421];
gout[n*729+584] += + s[422];
gout[n*729+585] += + s[423];
gout[n*729+586] += + s[424];
gout[n*729+587] += + s[425];
gout[n*729+588] += + s[426];
gout[n*729+589] += + s[427];
gout[n*729+590] += + s[428];
gout[n*729+591] += + s[429];
gout[n*729+592] += + s[430];
gout[n*729+593] += + s[431];
gout[n*729+594] += + s[432];
gout[n*729+595] += + s[433];
gout[n*729+596] += + s[434];
gout[n*729+597] += + s[435];
gout[n*729+598] += + s[436];
gout[n*729+599] += + s[437];
gout[n*729+600] += + s[438];
gout[n*729+601] += + s[439];
gout[n*729+602] += + s[440];
gout[n*729+603] += + s[441];
gout[n*729+604] += + s[442];
gout[n*729+605] += + s[443];
gout[n*729+606] += + s[444];
gout[n*729+607] += + s[445];
gout[n*729+608] += + s[446];
gout[n*729+609] += + s[447];
gout[n*729+610] += + s[448];
gout[n*729+611] += + s[449];
gout[n*729+612] += + s[450];
gout[n*729+613] += + s[451];
gout[n*729+614] += + s[452];
gout[n*729+615] += + s[453];
gout[n*729+616] += + s[454];
gout[n*729+617] += + s[455];
gout[n*729+618] += + s[456];
gout[n*729+619] += + s[457];
gout[n*729+620] += + s[458];
gout[n*729+621] += + s[459];
gout[n*729+622] += + s[460];
gout[n*729+623] += + s[461];
gout[n*729+624] += + s[462];
gout[n*729+625] += + s[463];
gout[n*729+626] += + s[464];
gout[n*729+627] += + s[465];
gout[n*729+628] += + s[466];
gout[n*729+629] += + s[467];
gout[n*729+630] += + s[468];
gout[n*729+631] += + s[469];
gout[n*729+632] += + s[470];
gout[n*729+633] += + s[471];
gout[n*729+634] += + s[472];
gout[n*729+635] += + s[473];
gout[n*729+636] += + s[474];
gout[n*729+637] += + s[475];
gout[n*729+638] += + s[476];
gout[n*729+639] += + s[477];
gout[n*729+640] += + s[478];
gout[n*729+641] += + s[479];
gout[n*729+642] += + s[480];
gout[n*729+643] += + s[481];
gout[n*729+644] += + s[482];
gout[n*729+645] += + s[483];
gout[n*729+646] += + s[484];
gout[n*729+647] += + s[485];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipnnipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipnnipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipnnipip_cart
CACHE_SIZE_T int1e_ipipnnipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipnnipip_sph
CACHE_SIZE_T int1e_ipipnnipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipnnipip_spinor
ALL_CINT1E(int1e_ipipnnipip)
ALL_CINT1E_FORTRAN_(int1e_ipipnnipip)
/* <i|RJ RJ RJ |NABLA j> */
void CINTgout1e_int1e_nnnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_nnnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nnnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nnnip_cart
CACHE_SIZE_T int1e_nnnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nnnip_sph
CACHE_SIZE_T int1e_nnnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 4, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nnnip_spinor
ALL_CINT1E(int1e_nnnip)
ALL_CINT1E_FORTRAN_(int1e_nnnip)
/* <i|RJ RJ RJ |NABLA NABLA j> */
void CINTgout1e_int1e_nnnipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_nnnipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nnnipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nnnipip_cart
CACHE_SIZE_T int1e_nnnipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nnnipip_sph
CACHE_SIZE_T int1e_nnnipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 5, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nnnipip_spinor
ALL_CINT1E(int1e_nnnipip)
ALL_CINT1E_FORTRAN_(int1e_nnnipip)
/* <i|RJ RJ RJ |NABLA NABLA NABLA j> */
void CINTgout1e_int1e_nnnipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g32, g0, envs->i_l+0, envs->j_l+5, 0);
G1E_D_J(g33, g32, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g34, g32, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g35, g34, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g36, g32, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g37, g36, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g38, g36, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g39, g38, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g40, g32, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g41, g40, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g42, g40, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g43, g42, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g44, g40, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g45, g44, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g46, g44, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g47, g46, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g48, g32, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g49, g48, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g50, g48, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g51, g50, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g52, g48, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g53, g52, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g54, g52, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g55, g54, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g56, g48, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g57, g56, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g58, g56, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g59, g58, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g60, g56, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g61, g60, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g62, g60, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g63, g62, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_nnnipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nnnipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nnnipipip_cart
CACHE_SIZE_T int1e_nnnipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nnnipipip_sph
CACHE_SIZE_T int1e_nnnipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 6, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nnnipipip_spinor
ALL_CINT1E(int1e_nnnipipip)
ALL_CINT1E_FORTRAN_(int1e_nnnipipip)
/* <i|RJ RJ RJ |NABLA NABLA NABLA NABLA j> */
void CINTgout1e_int1e_nnnipipipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double *g64 = g63 + envs->g_size * 3;
double *g65 = g64 + envs->g_size * 3;
double *g66 = g65 + envs->g_size * 3;
double *g67 = g66 + envs->g_size * 3;
double *g68 = g67 + envs->g_size * 3;
double *g69 = g68 + envs->g_size * 3;
double *g70 = g69 + envs->g_size * 3;
double *g71 = g70 + envs->g_size * 3;
double *g72 = g71 + envs->g_size * 3;
double *g73 = g72 + envs->g_size * 3;
double *g74 = g73 + envs->g_size * 3;
double *g75 = g74 + envs->g_size * 3;
double *g76 = g75 + envs->g_size * 3;
double *g77 = g76 + envs->g_size * 3;
double *g78 = g77 + envs->g_size * 3;
double *g79 = g78 + envs->g_size * 3;
double *g80 = g79 + envs->g_size * 3;
double *g81 = g80 + envs->g_size * 3;
double *g82 = g81 + envs->g_size * 3;
double *g83 = g82 + envs->g_size * 3;
double *g84 = g83 + envs->g_size * 3;
double *g85 = g84 + envs->g_size * 3;
double *g86 = g85 + envs->g_size * 3;
double *g87 = g86 + envs->g_size * 3;
double *g88 = g87 + envs->g_size * 3;
double *g89 = g88 + envs->g_size * 3;
double *g90 = g89 + envs->g_size * 3;
double *g91 = g90 + envs->g_size * 3;
double *g92 = g91 + envs->g_size * 3;
double *g93 = g92 + envs->g_size * 3;
double *g94 = g93 + envs->g_size * 3;
double *g95 = g94 + envs->g_size * 3;
double *g96 = g95 + envs->g_size * 3;
double *g97 = g96 + envs->g_size * 3;
double *g98 = g97 + envs->g_size * 3;
double *g99 = g98 + envs->g_size * 3;
double *g100 = g99 + envs->g_size * 3;
double *g101 = g100 + envs->g_size * 3;
double *g102 = g101 + envs->g_size * 3;
double *g103 = g102 + envs->g_size * 3;
double *g104 = g103 + envs->g_size * 3;
double *g105 = g104 + envs->g_size * 3;
double *g106 = g105 + envs->g_size * 3;
double *g107 = g106 + envs->g_size * 3;
double *g108 = g107 + envs->g_size * 3;
double *g109 = g108 + envs->g_size * 3;
double *g110 = g109 + envs->g_size * 3;
double *g111 = g110 + envs->g_size * 3;
double *g112 = g111 + envs->g_size * 3;
double *g113 = g112 + envs->g_size * 3;
double *g114 = g113 + envs->g_size * 3;
double *g115 = g114 + envs->g_size * 3;
double *g116 = g115 + envs->g_size * 3;
double *g117 = g116 + envs->g_size * 3;
double *g118 = g117 + envs->g_size * 3;
double *g119 = g118 + envs->g_size * 3;
double *g120 = g119 + envs->g_size * 3;
double *g121 = g120 + envs->g_size * 3;
double *g122 = g121 + envs->g_size * 3;
double *g123 = g122 + envs->g_size * 3;
double *g124 = g123 + envs->g_size * 3;
double *g125 = g124 + envs->g_size * 3;
double *g126 = g125 + envs->g_size * 3;
double *g127 = g126 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[2187];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g8, g0, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g12, g8, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g20, g16, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g24, g16, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g28, g24, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g32, g0, envs->i_l+0, envs->j_l+5, 0);
G1E_D_J(g33, g32, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g34, g32, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g35, g34, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g36, g32, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g37, g36, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g38, g36, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g39, g38, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g40, g32, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g41, g40, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g42, g40, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g43, g42, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g44, g40, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g45, g44, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g46, g44, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g47, g46, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g48, g32, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g49, g48, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g50, g48, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g51, g50, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g52, g48, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g53, g52, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g54, g52, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g55, g54, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g56, g48, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g57, g56, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g58, g56, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g59, g58, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g60, g56, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g61, g60, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g62, g60, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g63, g62, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g64, g0, envs->i_l+0, envs->j_l+6, 0);
G1E_D_J(g65, g64, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g66, g64, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g67, g66, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g68, g64, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g69, g68, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g70, g68, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g71, g70, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g72, g64, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g73, g72, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g74, g72, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g75, g74, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g76, g72, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g77, g76, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g78, g76, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g79, g78, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g80, g64, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g81, g80, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g82, g80, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g83, g82, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g84, g80, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g85, g84, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g86, g84, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g87, g86, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g88, g80, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g89, g88, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g90, g88, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g91, g90, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g92, g88, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g93, g92, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g94, g92, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g95, g94, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g96, g64, envs->i_l+0, envs->j_l+5, 0);
G1E_D_J(g97, g96, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g98, g96, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g99, g98, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g100, g96, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g101, g100, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g102, g100, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g103, g102, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g104, g96, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g105, g104, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g106, g104, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g107, g106, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g108, g104, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g109, g108, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g110, g108, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g111, g110, envs->i_l+0, envs->j_l+0, 0);
G1E_RCJ(g112, g96, envs->i_l+0, envs->j_l+4, 0);
G1E_D_J(g113, g112, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g114, g112, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g115, g114, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g116, g112, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g117, g116, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g118, g116, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g119, g118, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g120, g112, envs->i_l+0, envs->j_l+3, 0);
G1E_D_J(g121, g120, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g122, g120, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g123, g122, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g124, g120, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g125, g124, envs->i_l+0, envs->j_l+0, 0);
G1E_D_J(g126, g124, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g127, g126, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g127[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g126[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g126[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g125[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g124[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g124[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g125[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g124[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g124[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g123[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g122[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g122[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g121[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g120[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g120[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g121[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g120[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g120[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g123[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g122[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g122[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g121[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g120[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g120[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g121[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g120[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g120[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g119[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g118[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g118[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g117[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g116[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g116[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g117[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g116[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g116[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g115[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g114[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g114[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g113[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g112[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g112[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g113[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g112[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g112[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g115[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g114[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g114[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g113[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g112[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g112[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g113[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g112[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g112[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g119[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g118[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g118[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g117[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g116[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g116[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g117[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g116[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g116[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g115[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g114[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g114[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g113[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g112[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g112[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g113[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g112[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g112[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g115[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g114[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g114[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g113[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g112[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g112[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g113[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g112[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g112[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g111[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g110[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g110[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g109[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g108[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g108[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g109[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g108[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g108[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g107[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g106[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g106[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g105[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g104[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g104[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g105[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g104[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g104[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g107[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g106[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g106[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g105[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g104[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g104[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g105[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g104[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g104[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g103[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g102[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g102[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g101[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g100[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g100[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g101[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g100[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g100[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g99[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g98[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g98[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g97[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g96[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g96[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g97[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g96[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g96[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g99[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g98[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g98[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g97[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g96[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g96[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g97[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g96[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g96[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g103[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g102[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g102[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g101[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g100[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g100[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g101[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g100[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g100[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g99[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g98[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g98[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g97[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g96[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g96[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g97[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g96[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g96[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g99[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g98[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g98[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g97[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g96[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g96[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g97[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g96[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g96[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g111[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g110[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g110[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g109[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g108[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g108[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g109[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g108[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g108[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g107[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g106[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g106[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g105[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g104[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g104[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g105[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g104[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g104[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g107[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g106[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g106[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g105[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g104[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g104[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g105[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g104[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g104[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g103[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g102[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g102[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g101[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g100[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g100[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g101[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g100[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g100[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g99[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g98[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g98[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g97[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g96[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g96[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g97[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g96[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g96[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g99[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g98[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g98[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g97[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g96[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g96[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g97[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g96[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g96[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g103[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g102[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g102[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g101[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g100[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g100[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g101[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g100[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g100[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g99[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g98[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g98[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g97[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g96[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g96[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g97[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g96[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g96[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g99[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g98[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g98[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g97[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g96[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g96[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g97[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g96[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g96[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g95[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g94[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g94[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g93[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g92[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g92[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g93[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g92[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g92[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g91[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g90[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g90[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g89[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g88[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g88[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g89[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g88[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g88[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g91[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g90[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g90[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g89[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g88[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g88[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g89[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g88[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g88[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g87[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g86[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g86[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g85[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g84[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g84[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g85[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g84[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g84[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g83[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g82[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g82[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g81[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g80[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g80[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g81[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g80[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g80[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g83[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g82[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g82[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g81[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g80[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g80[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g81[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g80[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g80[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g87[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g86[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g86[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g85[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g84[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g84[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g85[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g84[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g84[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g83[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g82[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g82[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g81[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g80[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g80[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g81[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g80[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g80[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g83[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g82[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g82[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g81[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g80[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g80[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g81[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g80[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g80[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g79[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g78[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g78[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g77[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g76[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g76[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g77[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g76[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g76[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g75[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g74[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g74[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g73[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g72[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g72[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g73[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g72[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g72[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g75[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g74[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g74[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g73[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g72[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g72[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g73[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g72[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g72[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g71[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g70[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g70[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g69[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g68[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g68[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g69[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g68[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g68[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g67[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g66[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g66[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g65[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g64[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g64[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g65[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g64[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g64[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g67[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g66[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g66[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g65[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g64[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g64[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g65[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g64[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g64[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g71[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g70[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g70[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g69[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g68[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g68[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g69[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g68[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g68[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g67[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g66[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g66[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g65[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g64[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g64[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g65[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g64[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g64[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g67[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g66[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g66[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g65[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g64[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g64[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g65[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g64[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g64[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g79[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g78[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g78[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g77[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g76[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g76[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g77[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g76[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g76[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g75[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g74[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g74[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g73[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g72[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g72[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g73[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g72[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g72[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g75[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g74[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g74[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g73[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g72[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g72[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g73[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g72[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g72[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g71[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g70[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g70[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g69[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g68[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g68[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g69[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g68[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g68[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g67[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g66[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g66[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g65[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g64[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g64[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g65[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g64[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g64[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g67[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g66[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g66[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g65[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g64[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g64[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g65[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g64[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g64[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g71[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g70[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g70[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g69[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g68[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g68[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g69[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g68[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g68[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g67[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g66[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g66[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g65[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g64[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g64[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g65[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g64[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g64[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g67[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g66[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g66[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g65[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g64[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g64[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g65[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g64[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g64[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g95[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g94[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g94[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g93[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g92[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g92[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g93[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g92[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g92[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g91[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g90[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g90[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g89[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g88[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g88[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g89[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g88[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g88[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g91[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g90[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g90[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g89[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g88[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g88[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g89[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g88[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g88[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g87[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g86[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g86[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g85[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g84[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g84[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g85[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g84[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g84[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g83[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g82[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g82[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g81[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g80[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g80[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g81[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g80[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g80[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g83[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g82[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g82[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g81[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g80[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g80[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g81[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g80[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g80[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g87[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g86[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g86[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g85[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g84[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g84[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g85[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g84[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g84[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g83[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g82[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g82[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g81[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g80[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g80[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g81[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g80[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g80[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g83[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g82[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g82[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g81[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g80[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g80[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g81[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g80[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g80[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g79[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g78[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g78[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g77[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g76[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g76[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g77[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g76[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g76[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g75[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g74[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g74[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g73[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g72[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g72[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g73[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g72[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g72[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g75[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g74[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g74[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g73[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g72[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g72[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g73[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g72[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g72[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g71[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g70[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g70[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g69[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g68[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g68[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g69[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g68[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g68[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g67[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g66[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g66[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g65[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g64[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g64[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g65[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g64[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g64[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g67[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g66[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g66[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g65[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g64[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g64[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g65[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g64[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g64[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g71[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g70[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g70[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g69[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g68[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g68[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g69[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g68[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g68[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g67[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g66[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g66[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g65[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g64[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g64[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g65[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g64[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g64[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g67[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g66[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g66[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g65[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g64[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g64[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g65[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g64[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g64[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g79[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g78[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g78[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g77[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g76[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g76[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g77[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g76[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g76[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g75[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g74[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g74[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g73[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g72[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g72[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g73[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g72[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g72[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g75[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g74[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g74[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g73[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g72[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g72[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g73[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g72[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g72[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g71[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g70[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g70[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g69[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g68[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g68[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g69[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g68[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g68[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g67[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g66[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g66[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g65[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g64[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g64[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g65[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g64[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g64[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g67[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g66[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g66[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g65[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g64[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g64[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g65[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g64[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g64[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g71[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g70[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g70[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g69[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g68[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g68[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g69[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g68[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g68[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g67[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g66[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g66[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g65[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g64[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g64[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g65[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g64[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g64[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g67[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g66[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g66[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g65[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g64[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g64[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g65[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g64[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g64[ix+0]*g0[iy+0]*g63[iz+0];
s[729] = + g63[ix+0]*g64[iy+0]*g0[iz+0];
s[730] = + g62[ix+0]*g65[iy+0]*g0[iz+0];
s[731] = + g62[ix+0]*g64[iy+0]*g1[iz+0];
s[732] = + g61[ix+0]*g66[iy+0]*g0[iz+0];
s[733] = + g60[ix+0]*g67[iy+0]*g0[iz+0];
s[734] = + g60[ix+0]*g66[iy+0]*g1[iz+0];
s[735] = + g61[ix+0]*g64[iy+0]*g2[iz+0];
s[736] = + g60[ix+0]*g65[iy+0]*g2[iz+0];
s[737] = + g60[ix+0]*g64[iy+0]*g3[iz+0];
s[738] = + g59[ix+0]*g68[iy+0]*g0[iz+0];
s[739] = + g58[ix+0]*g69[iy+0]*g0[iz+0];
s[740] = + g58[ix+0]*g68[iy+0]*g1[iz+0];
s[741] = + g57[ix+0]*g70[iy+0]*g0[iz+0];
s[742] = + g56[ix+0]*g71[iy+0]*g0[iz+0];
s[743] = + g56[ix+0]*g70[iy+0]*g1[iz+0];
s[744] = + g57[ix+0]*g68[iy+0]*g2[iz+0];
s[745] = + g56[ix+0]*g69[iy+0]*g2[iz+0];
s[746] = + g56[ix+0]*g68[iy+0]*g3[iz+0];
s[747] = + g59[ix+0]*g64[iy+0]*g4[iz+0];
s[748] = + g58[ix+0]*g65[iy+0]*g4[iz+0];
s[749] = + g58[ix+0]*g64[iy+0]*g5[iz+0];
s[750] = + g57[ix+0]*g66[iy+0]*g4[iz+0];
s[751] = + g56[ix+0]*g67[iy+0]*g4[iz+0];
s[752] = + g56[ix+0]*g66[iy+0]*g5[iz+0];
s[753] = + g57[ix+0]*g64[iy+0]*g6[iz+0];
s[754] = + g56[ix+0]*g65[iy+0]*g6[iz+0];
s[755] = + g56[ix+0]*g64[iy+0]*g7[iz+0];
s[756] = + g55[ix+0]*g72[iy+0]*g0[iz+0];
s[757] = + g54[ix+0]*g73[iy+0]*g0[iz+0];
s[758] = + g54[ix+0]*g72[iy+0]*g1[iz+0];
s[759] = + g53[ix+0]*g74[iy+0]*g0[iz+0];
s[760] = + g52[ix+0]*g75[iy+0]*g0[iz+0];
s[761] = + g52[ix+0]*g74[iy+0]*g1[iz+0];
s[762] = + g53[ix+0]*g72[iy+0]*g2[iz+0];
s[763] = + g52[ix+0]*g73[iy+0]*g2[iz+0];
s[764] = + g52[ix+0]*g72[iy+0]*g3[iz+0];
s[765] = + g51[ix+0]*g76[iy+0]*g0[iz+0];
s[766] = + g50[ix+0]*g77[iy+0]*g0[iz+0];
s[767] = + g50[ix+0]*g76[iy+0]*g1[iz+0];
s[768] = + g49[ix+0]*g78[iy+0]*g0[iz+0];
s[769] = + g48[ix+0]*g79[iy+0]*g0[iz+0];
s[770] = + g48[ix+0]*g78[iy+0]*g1[iz+0];
s[771] = + g49[ix+0]*g76[iy+0]*g2[iz+0];
s[772] = + g48[ix+0]*g77[iy+0]*g2[iz+0];
s[773] = + g48[ix+0]*g76[iy+0]*g3[iz+0];
s[774] = + g51[ix+0]*g72[iy+0]*g4[iz+0];
s[775] = + g50[ix+0]*g73[iy+0]*g4[iz+0];
s[776] = + g50[ix+0]*g72[iy+0]*g5[iz+0];
s[777] = + g49[ix+0]*g74[iy+0]*g4[iz+0];
s[778] = + g48[ix+0]*g75[iy+0]*g4[iz+0];
s[779] = + g48[ix+0]*g74[iy+0]*g5[iz+0];
s[780] = + g49[ix+0]*g72[iy+0]*g6[iz+0];
s[781] = + g48[ix+0]*g73[iy+0]*g6[iz+0];
s[782] = + g48[ix+0]*g72[iy+0]*g7[iz+0];
s[783] = + g55[ix+0]*g64[iy+0]*g8[iz+0];
s[784] = + g54[ix+0]*g65[iy+0]*g8[iz+0];
s[785] = + g54[ix+0]*g64[iy+0]*g9[iz+0];
s[786] = + g53[ix+0]*g66[iy+0]*g8[iz+0];
s[787] = + g52[ix+0]*g67[iy+0]*g8[iz+0];
s[788] = + g52[ix+0]*g66[iy+0]*g9[iz+0];
s[789] = + g53[ix+0]*g64[iy+0]*g10[iz+0];
s[790] = + g52[ix+0]*g65[iy+0]*g10[iz+0];
s[791] = + g52[ix+0]*g64[iy+0]*g11[iz+0];
s[792] = + g51[ix+0]*g68[iy+0]*g8[iz+0];
s[793] = + g50[ix+0]*g69[iy+0]*g8[iz+0];
s[794] = + g50[ix+0]*g68[iy+0]*g9[iz+0];
s[795] = + g49[ix+0]*g70[iy+0]*g8[iz+0];
s[796] = + g48[ix+0]*g71[iy+0]*g8[iz+0];
s[797] = + g48[ix+0]*g70[iy+0]*g9[iz+0];
s[798] = + g49[ix+0]*g68[iy+0]*g10[iz+0];
s[799] = + g48[ix+0]*g69[iy+0]*g10[iz+0];
s[800] = + g48[ix+0]*g68[iy+0]*g11[iz+0];
s[801] = + g51[ix+0]*g64[iy+0]*g12[iz+0];
s[802] = + g50[ix+0]*g65[iy+0]*g12[iz+0];
s[803] = + g50[ix+0]*g64[iy+0]*g13[iz+0];
s[804] = + g49[ix+0]*g66[iy+0]*g12[iz+0];
s[805] = + g48[ix+0]*g67[iy+0]*g12[iz+0];
s[806] = + g48[ix+0]*g66[iy+0]*g13[iz+0];
s[807] = + g49[ix+0]*g64[iy+0]*g14[iz+0];
s[808] = + g48[ix+0]*g65[iy+0]*g14[iz+0];
s[809] = + g48[ix+0]*g64[iy+0]*g15[iz+0];
s[810] = + g47[ix+0]*g80[iy+0]*g0[iz+0];
s[811] = + g46[ix+0]*g81[iy+0]*g0[iz+0];
s[812] = + g46[ix+0]*g80[iy+0]*g1[iz+0];
s[813] = + g45[ix+0]*g82[iy+0]*g0[iz+0];
s[814] = + g44[ix+0]*g83[iy+0]*g0[iz+0];
s[815] = + g44[ix+0]*g82[iy+0]*g1[iz+0];
s[816] = + g45[ix+0]*g80[iy+0]*g2[iz+0];
s[817] = + g44[ix+0]*g81[iy+0]*g2[iz+0];
s[818] = + g44[ix+0]*g80[iy+0]*g3[iz+0];
s[819] = + g43[ix+0]*g84[iy+0]*g0[iz+0];
s[820] = + g42[ix+0]*g85[iy+0]*g0[iz+0];
s[821] = + g42[ix+0]*g84[iy+0]*g1[iz+0];
s[822] = + g41[ix+0]*g86[iy+0]*g0[iz+0];
s[823] = + g40[ix+0]*g87[iy+0]*g0[iz+0];
s[824] = + g40[ix+0]*g86[iy+0]*g1[iz+0];
s[825] = + g41[ix+0]*g84[iy+0]*g2[iz+0];
s[826] = + g40[ix+0]*g85[iy+0]*g2[iz+0];
s[827] = + g40[ix+0]*g84[iy+0]*g3[iz+0];
s[828] = + g43[ix+0]*g80[iy+0]*g4[iz+0];
s[829] = + g42[ix+0]*g81[iy+0]*g4[iz+0];
s[830] = + g42[ix+0]*g80[iy+0]*g5[iz+0];
s[831] = + g41[ix+0]*g82[iy+0]*g4[iz+0];
s[832] = + g40[ix+0]*g83[iy+0]*g4[iz+0];
s[833] = + g40[ix+0]*g82[iy+0]*g5[iz+0];
s[834] = + g41[ix+0]*g80[iy+0]*g6[iz+0];
s[835] = + g40[ix+0]*g81[iy+0]*g6[iz+0];
s[836] = + g40[ix+0]*g80[iy+0]*g7[iz+0];
s[837] = + g39[ix+0]*g88[iy+0]*g0[iz+0];
s[838] = + g38[ix+0]*g89[iy+0]*g0[iz+0];
s[839] = + g38[ix+0]*g88[iy+0]*g1[iz+0];
s[840] = + g37[ix+0]*g90[iy+0]*g0[iz+0];
s[841] = + g36[ix+0]*g91[iy+0]*g0[iz+0];
s[842] = + g36[ix+0]*g90[iy+0]*g1[iz+0];
s[843] = + g37[ix+0]*g88[iy+0]*g2[iz+0];
s[844] = + g36[ix+0]*g89[iy+0]*g2[iz+0];
s[845] = + g36[ix+0]*g88[iy+0]*g3[iz+0];
s[846] = + g35[ix+0]*g92[iy+0]*g0[iz+0];
s[847] = + g34[ix+0]*g93[iy+0]*g0[iz+0];
s[848] = + g34[ix+0]*g92[iy+0]*g1[iz+0];
s[849] = + g33[ix+0]*g94[iy+0]*g0[iz+0];
s[850] = + g32[ix+0]*g95[iy+0]*g0[iz+0];
s[851] = + g32[ix+0]*g94[iy+0]*g1[iz+0];
s[852] = + g33[ix+0]*g92[iy+0]*g2[iz+0];
s[853] = + g32[ix+0]*g93[iy+0]*g2[iz+0];
s[854] = + g32[ix+0]*g92[iy+0]*g3[iz+0];
s[855] = + g35[ix+0]*g88[iy+0]*g4[iz+0];
s[856] = + g34[ix+0]*g89[iy+0]*g4[iz+0];
s[857] = + g34[ix+0]*g88[iy+0]*g5[iz+0];
s[858] = + g33[ix+0]*g90[iy+0]*g4[iz+0];
s[859] = + g32[ix+0]*g91[iy+0]*g4[iz+0];
s[860] = + g32[ix+0]*g90[iy+0]*g5[iz+0];
s[861] = + g33[ix+0]*g88[iy+0]*g6[iz+0];
s[862] = + g32[ix+0]*g89[iy+0]*g6[iz+0];
s[863] = + g32[ix+0]*g88[iy+0]*g7[iz+0];
s[864] = + g39[ix+0]*g80[iy+0]*g8[iz+0];
s[865] = + g38[ix+0]*g81[iy+0]*g8[iz+0];
s[866] = + g38[ix+0]*g80[iy+0]*g9[iz+0];
s[867] = + g37[ix+0]*g82[iy+0]*g8[iz+0];
s[868] = + g36[ix+0]*g83[iy+0]*g8[iz+0];
s[869] = + g36[ix+0]*g82[iy+0]*g9[iz+0];
s[870] = + g37[ix+0]*g80[iy+0]*g10[iz+0];
s[871] = + g36[ix+0]*g81[iy+0]*g10[iz+0];
s[872] = + g36[ix+0]*g80[iy+0]*g11[iz+0];
s[873] = + g35[ix+0]*g84[iy+0]*g8[iz+0];
s[874] = + g34[ix+0]*g85[iy+0]*g8[iz+0];
s[875] = + g34[ix+0]*g84[iy+0]*g9[iz+0];
s[876] = + g33[ix+0]*g86[iy+0]*g8[iz+0];
s[877] = + g32[ix+0]*g87[iy+0]*g8[iz+0];
s[878] = + g32[ix+0]*g86[iy+0]*g9[iz+0];
s[879] = + g33[ix+0]*g84[iy+0]*g10[iz+0];
s[880] = + g32[ix+0]*g85[iy+0]*g10[iz+0];
s[881] = + g32[ix+0]*g84[iy+0]*g11[iz+0];
s[882] = + g35[ix+0]*g80[iy+0]*g12[iz+0];
s[883] = + g34[ix+0]*g81[iy+0]*g12[iz+0];
s[884] = + g34[ix+0]*g80[iy+0]*g13[iz+0];
s[885] = + g33[ix+0]*g82[iy+0]*g12[iz+0];
s[886] = + g32[ix+0]*g83[iy+0]*g12[iz+0];
s[887] = + g32[ix+0]*g82[iy+0]*g13[iz+0];
s[888] = + g33[ix+0]*g80[iy+0]*g14[iz+0];
s[889] = + g32[ix+0]*g81[iy+0]*g14[iz+0];
s[890] = + g32[ix+0]*g80[iy+0]*g15[iz+0];
s[891] = + g47[ix+0]*g64[iy+0]*g16[iz+0];
s[892] = + g46[ix+0]*g65[iy+0]*g16[iz+0];
s[893] = + g46[ix+0]*g64[iy+0]*g17[iz+0];
s[894] = + g45[ix+0]*g66[iy+0]*g16[iz+0];
s[895] = + g44[ix+0]*g67[iy+0]*g16[iz+0];
s[896] = + g44[ix+0]*g66[iy+0]*g17[iz+0];
s[897] = + g45[ix+0]*g64[iy+0]*g18[iz+0];
s[898] = + g44[ix+0]*g65[iy+0]*g18[iz+0];
s[899] = + g44[ix+0]*g64[iy+0]*g19[iz+0];
s[900] = + g43[ix+0]*g68[iy+0]*g16[iz+0];
s[901] = + g42[ix+0]*g69[iy+0]*g16[iz+0];
s[902] = + g42[ix+0]*g68[iy+0]*g17[iz+0];
s[903] = + g41[ix+0]*g70[iy+0]*g16[iz+0];
s[904] = + g40[ix+0]*g71[iy+0]*g16[iz+0];
s[905] = + g40[ix+0]*g70[iy+0]*g17[iz+0];
s[906] = + g41[ix+0]*g68[iy+0]*g18[iz+0];
s[907] = + g40[ix+0]*g69[iy+0]*g18[iz+0];
s[908] = + g40[ix+0]*g68[iy+0]*g19[iz+0];
s[909] = + g43[ix+0]*g64[iy+0]*g20[iz+0];
s[910] = + g42[ix+0]*g65[iy+0]*g20[iz+0];
s[911] = + g42[ix+0]*g64[iy+0]*g21[iz+0];
s[912] = + g41[ix+0]*g66[iy+0]*g20[iz+0];
s[913] = + g40[ix+0]*g67[iy+0]*g20[iz+0];
s[914] = + g40[ix+0]*g66[iy+0]*g21[iz+0];
s[915] = + g41[ix+0]*g64[iy+0]*g22[iz+0];
s[916] = + g40[ix+0]*g65[iy+0]*g22[iz+0];
s[917] = + g40[ix+0]*g64[iy+0]*g23[iz+0];
s[918] = + g39[ix+0]*g72[iy+0]*g16[iz+0];
s[919] = + g38[ix+0]*g73[iy+0]*g16[iz+0];
s[920] = + g38[ix+0]*g72[iy+0]*g17[iz+0];
s[921] = + g37[ix+0]*g74[iy+0]*g16[iz+0];
s[922] = + g36[ix+0]*g75[iy+0]*g16[iz+0];
s[923] = + g36[ix+0]*g74[iy+0]*g17[iz+0];
s[924] = + g37[ix+0]*g72[iy+0]*g18[iz+0];
s[925] = + g36[ix+0]*g73[iy+0]*g18[iz+0];
s[926] = + g36[ix+0]*g72[iy+0]*g19[iz+0];
s[927] = + g35[ix+0]*g76[iy+0]*g16[iz+0];
s[928] = + g34[ix+0]*g77[iy+0]*g16[iz+0];
s[929] = + g34[ix+0]*g76[iy+0]*g17[iz+0];
s[930] = + g33[ix+0]*g78[iy+0]*g16[iz+0];
s[931] = + g32[ix+0]*g79[iy+0]*g16[iz+0];
s[932] = + g32[ix+0]*g78[iy+0]*g17[iz+0];
s[933] = + g33[ix+0]*g76[iy+0]*g18[iz+0];
s[934] = + g32[ix+0]*g77[iy+0]*g18[iz+0];
s[935] = + g32[ix+0]*g76[iy+0]*g19[iz+0];
s[936] = + g35[ix+0]*g72[iy+0]*g20[iz+0];
s[937] = + g34[ix+0]*g73[iy+0]*g20[iz+0];
s[938] = + g34[ix+0]*g72[iy+0]*g21[iz+0];
s[939] = + g33[ix+0]*g74[iy+0]*g20[iz+0];
s[940] = + g32[ix+0]*g75[iy+0]*g20[iz+0];
s[941] = + g32[ix+0]*g74[iy+0]*g21[iz+0];
s[942] = + g33[ix+0]*g72[iy+0]*g22[iz+0];
s[943] = + g32[ix+0]*g73[iy+0]*g22[iz+0];
s[944] = + g32[ix+0]*g72[iy+0]*g23[iz+0];
s[945] = + g39[ix+0]*g64[iy+0]*g24[iz+0];
s[946] = + g38[ix+0]*g65[iy+0]*g24[iz+0];
s[947] = + g38[ix+0]*g64[iy+0]*g25[iz+0];
s[948] = + g37[ix+0]*g66[iy+0]*g24[iz+0];
s[949] = + g36[ix+0]*g67[iy+0]*g24[iz+0];
s[950] = + g36[ix+0]*g66[iy+0]*g25[iz+0];
s[951] = + g37[ix+0]*g64[iy+0]*g26[iz+0];
s[952] = + g36[ix+0]*g65[iy+0]*g26[iz+0];
s[953] = + g36[ix+0]*g64[iy+0]*g27[iz+0];
s[954] = + g35[ix+0]*g68[iy+0]*g24[iz+0];
s[955] = + g34[ix+0]*g69[iy+0]*g24[iz+0];
s[956] = + g34[ix+0]*g68[iy+0]*g25[iz+0];
s[957] = + g33[ix+0]*g70[iy+0]*g24[iz+0];
s[958] = + g32[ix+0]*g71[iy+0]*g24[iz+0];
s[959] = + g32[ix+0]*g70[iy+0]*g25[iz+0];
s[960] = + g33[ix+0]*g68[iy+0]*g26[iz+0];
s[961] = + g32[ix+0]*g69[iy+0]*g26[iz+0];
s[962] = + g32[ix+0]*g68[iy+0]*g27[iz+0];
s[963] = + g35[ix+0]*g64[iy+0]*g28[iz+0];
s[964] = + g34[ix+0]*g65[iy+0]*g28[iz+0];
s[965] = + g34[ix+0]*g64[iy+0]*g29[iz+0];
s[966] = + g33[ix+0]*g66[iy+0]*g28[iz+0];
s[967] = + g32[ix+0]*g67[iy+0]*g28[iz+0];
s[968] = + g32[ix+0]*g66[iy+0]*g29[iz+0];
s[969] = + g33[ix+0]*g64[iy+0]*g30[iz+0];
s[970] = + g32[ix+0]*g65[iy+0]*g30[iz+0];
s[971] = + g32[ix+0]*g64[iy+0]*g31[iz+0];
s[972] = + g31[ix+0]*g96[iy+0]*g0[iz+0];
s[973] = + g30[ix+0]*g97[iy+0]*g0[iz+0];
s[974] = + g30[ix+0]*g96[iy+0]*g1[iz+0];
s[975] = + g29[ix+0]*g98[iy+0]*g0[iz+0];
s[976] = + g28[ix+0]*g99[iy+0]*g0[iz+0];
s[977] = + g28[ix+0]*g98[iy+0]*g1[iz+0];
s[978] = + g29[ix+0]*g96[iy+0]*g2[iz+0];
s[979] = + g28[ix+0]*g97[iy+0]*g2[iz+0];
s[980] = + g28[ix+0]*g96[iy+0]*g3[iz+0];
s[981] = + g27[ix+0]*g100[iy+0]*g0[iz+0];
s[982] = + g26[ix+0]*g101[iy+0]*g0[iz+0];
s[983] = + g26[ix+0]*g100[iy+0]*g1[iz+0];
s[984] = + g25[ix+0]*g102[iy+0]*g0[iz+0];
s[985] = + g24[ix+0]*g103[iy+0]*g0[iz+0];
s[986] = + g24[ix+0]*g102[iy+0]*g1[iz+0];
s[987] = + g25[ix+0]*g100[iy+0]*g2[iz+0];
s[988] = + g24[ix+0]*g101[iy+0]*g2[iz+0];
s[989] = + g24[ix+0]*g100[iy+0]*g3[iz+0];
s[990] = + g27[ix+0]*g96[iy+0]*g4[iz+0];
s[991] = + g26[ix+0]*g97[iy+0]*g4[iz+0];
s[992] = + g26[ix+0]*g96[iy+0]*g5[iz+0];
s[993] = + g25[ix+0]*g98[iy+0]*g4[iz+0];
s[994] = + g24[ix+0]*g99[iy+0]*g4[iz+0];
s[995] = + g24[ix+0]*g98[iy+0]*g5[iz+0];
s[996] = + g25[ix+0]*g96[iy+0]*g6[iz+0];
s[997] = + g24[ix+0]*g97[iy+0]*g6[iz+0];
s[998] = + g24[ix+0]*g96[iy+0]*g7[iz+0];
s[999] = + g23[ix+0]*g104[iy+0]*g0[iz+0];
s[1000] = + g22[ix+0]*g105[iy+0]*g0[iz+0];
s[1001] = + g22[ix+0]*g104[iy+0]*g1[iz+0];
s[1002] = + g21[ix+0]*g106[iy+0]*g0[iz+0];
s[1003] = + g20[ix+0]*g107[iy+0]*g0[iz+0];
s[1004] = + g20[ix+0]*g106[iy+0]*g1[iz+0];
s[1005] = + g21[ix+0]*g104[iy+0]*g2[iz+0];
s[1006] = + g20[ix+0]*g105[iy+0]*g2[iz+0];
s[1007] = + g20[ix+0]*g104[iy+0]*g3[iz+0];
s[1008] = + g19[ix+0]*g108[iy+0]*g0[iz+0];
s[1009] = + g18[ix+0]*g109[iy+0]*g0[iz+0];
s[1010] = + g18[ix+0]*g108[iy+0]*g1[iz+0];
s[1011] = + g17[ix+0]*g110[iy+0]*g0[iz+0];
s[1012] = + g16[ix+0]*g111[iy+0]*g0[iz+0];
s[1013] = + g16[ix+0]*g110[iy+0]*g1[iz+0];
s[1014] = + g17[ix+0]*g108[iy+0]*g2[iz+0];
s[1015] = + g16[ix+0]*g109[iy+0]*g2[iz+0];
s[1016] = + g16[ix+0]*g108[iy+0]*g3[iz+0];
s[1017] = + g19[ix+0]*g104[iy+0]*g4[iz+0];
s[1018] = + g18[ix+0]*g105[iy+0]*g4[iz+0];
s[1019] = + g18[ix+0]*g104[iy+0]*g5[iz+0];
s[1020] = + g17[ix+0]*g106[iy+0]*g4[iz+0];
s[1021] = + g16[ix+0]*g107[iy+0]*g4[iz+0];
s[1022] = + g16[ix+0]*g106[iy+0]*g5[iz+0];
s[1023] = + g17[ix+0]*g104[iy+0]*g6[iz+0];
s[1024] = + g16[ix+0]*g105[iy+0]*g6[iz+0];
s[1025] = + g16[ix+0]*g104[iy+0]*g7[iz+0];
s[1026] = + g23[ix+0]*g96[iy+0]*g8[iz+0];
s[1027] = + g22[ix+0]*g97[iy+0]*g8[iz+0];
s[1028] = + g22[ix+0]*g96[iy+0]*g9[iz+0];
s[1029] = + g21[ix+0]*g98[iy+0]*g8[iz+0];
s[1030] = + g20[ix+0]*g99[iy+0]*g8[iz+0];
s[1031] = + g20[ix+0]*g98[iy+0]*g9[iz+0];
s[1032] = + g21[ix+0]*g96[iy+0]*g10[iz+0];
s[1033] = + g20[ix+0]*g97[iy+0]*g10[iz+0];
s[1034] = + g20[ix+0]*g96[iy+0]*g11[iz+0];
s[1035] = + g19[ix+0]*g100[iy+0]*g8[iz+0];
s[1036] = + g18[ix+0]*g101[iy+0]*g8[iz+0];
s[1037] = + g18[ix+0]*g100[iy+0]*g9[iz+0];
s[1038] = + g17[ix+0]*g102[iy+0]*g8[iz+0];
s[1039] = + g16[ix+0]*g103[iy+0]*g8[iz+0];
s[1040] = + g16[ix+0]*g102[iy+0]*g9[iz+0];
s[1041] = + g17[ix+0]*g100[iy+0]*g10[iz+0];
s[1042] = + g16[ix+0]*g101[iy+0]*g10[iz+0];
s[1043] = + g16[ix+0]*g100[iy+0]*g11[iz+0];
s[1044] = + g19[ix+0]*g96[iy+0]*g12[iz+0];
s[1045] = + g18[ix+0]*g97[iy+0]*g12[iz+0];
s[1046] = + g18[ix+0]*g96[iy+0]*g13[iz+0];
s[1047] = + g17[ix+0]*g98[iy+0]*g12[iz+0];
s[1048] = + g16[ix+0]*g99[iy+0]*g12[iz+0];
s[1049] = + g16[ix+0]*g98[iy+0]*g13[iz+0];
s[1050] = + g17[ix+0]*g96[iy+0]*g14[iz+0];
s[1051] = + g16[ix+0]*g97[iy+0]*g14[iz+0];
s[1052] = + g16[ix+0]*g96[iy+0]*g15[iz+0];
s[1053] = + g15[ix+0]*g112[iy+0]*g0[iz+0];
s[1054] = + g14[ix+0]*g113[iy+0]*g0[iz+0];
s[1055] = + g14[ix+0]*g112[iy+0]*g1[iz+0];
s[1056] = + g13[ix+0]*g114[iy+0]*g0[iz+0];
s[1057] = + g12[ix+0]*g115[iy+0]*g0[iz+0];
s[1058] = + g12[ix+0]*g114[iy+0]*g1[iz+0];
s[1059] = + g13[ix+0]*g112[iy+0]*g2[iz+0];
s[1060] = + g12[ix+0]*g113[iy+0]*g2[iz+0];
s[1061] = + g12[ix+0]*g112[iy+0]*g3[iz+0];
s[1062] = + g11[ix+0]*g116[iy+0]*g0[iz+0];
s[1063] = + g10[ix+0]*g117[iy+0]*g0[iz+0];
s[1064] = + g10[ix+0]*g116[iy+0]*g1[iz+0];
s[1065] = + g9[ix+0]*g118[iy+0]*g0[iz+0];
s[1066] = + g8[ix+0]*g119[iy+0]*g0[iz+0];
s[1067] = + g8[ix+0]*g118[iy+0]*g1[iz+0];
s[1068] = + g9[ix+0]*g116[iy+0]*g2[iz+0];
s[1069] = + g8[ix+0]*g117[iy+0]*g2[iz+0];
s[1070] = + g8[ix+0]*g116[iy+0]*g3[iz+0];
s[1071] = + g11[ix+0]*g112[iy+0]*g4[iz+0];
s[1072] = + g10[ix+0]*g113[iy+0]*g4[iz+0];
s[1073] = + g10[ix+0]*g112[iy+0]*g5[iz+0];
s[1074] = + g9[ix+0]*g114[iy+0]*g4[iz+0];
s[1075] = + g8[ix+0]*g115[iy+0]*g4[iz+0];
s[1076] = + g8[ix+0]*g114[iy+0]*g5[iz+0];
s[1077] = + g9[ix+0]*g112[iy+0]*g6[iz+0];
s[1078] = + g8[ix+0]*g113[iy+0]*g6[iz+0];
s[1079] = + g8[ix+0]*g112[iy+0]*g7[iz+0];
s[1080] = + g7[ix+0]*g120[iy+0]*g0[iz+0];
s[1081] = + g6[ix+0]*g121[iy+0]*g0[iz+0];
s[1082] = + g6[ix+0]*g120[iy+0]*g1[iz+0];
s[1083] = + g5[ix+0]*g122[iy+0]*g0[iz+0];
s[1084] = + g4[ix+0]*g123[iy+0]*g0[iz+0];
s[1085] = + g4[ix+0]*g122[iy+0]*g1[iz+0];
s[1086] = + g5[ix+0]*g120[iy+0]*g2[iz+0];
s[1087] = + g4[ix+0]*g121[iy+0]*g2[iz+0];
s[1088] = + g4[ix+0]*g120[iy+0]*g3[iz+0];
s[1089] = + g3[ix+0]*g124[iy+0]*g0[iz+0];
s[1090] = + g2[ix+0]*g125[iy+0]*g0[iz+0];
s[1091] = + g2[ix+0]*g124[iy+0]*g1[iz+0];
s[1092] = + g1[ix+0]*g126[iy+0]*g0[iz+0];
s[1093] = + g0[ix+0]*g127[iy+0]*g0[iz+0];
s[1094] = + g0[ix+0]*g126[iy+0]*g1[iz+0];
s[1095] = + g1[ix+0]*g124[iy+0]*g2[iz+0];
s[1096] = + g0[ix+0]*g125[iy+0]*g2[iz+0];
s[1097] = + g0[ix+0]*g124[iy+0]*g3[iz+0];
s[1098] = + g3[ix+0]*g120[iy+0]*g4[iz+0];
s[1099] = + g2[ix+0]*g121[iy+0]*g4[iz+0];
s[1100] = + g2[ix+0]*g120[iy+0]*g5[iz+0];
s[1101] = + g1[ix+0]*g122[iy+0]*g4[iz+0];
s[1102] = + g0[ix+0]*g123[iy+0]*g4[iz+0];
s[1103] = + g0[ix+0]*g122[iy+0]*g5[iz+0];
s[1104] = + g1[ix+0]*g120[iy+0]*g6[iz+0];
s[1105] = + g0[ix+0]*g121[iy+0]*g6[iz+0];
s[1106] = + g0[ix+0]*g120[iy+0]*g7[iz+0];
s[1107] = + g7[ix+0]*g112[iy+0]*g8[iz+0];
s[1108] = + g6[ix+0]*g113[iy+0]*g8[iz+0];
s[1109] = + g6[ix+0]*g112[iy+0]*g9[iz+0];
s[1110] = + g5[ix+0]*g114[iy+0]*g8[iz+0];
s[1111] = + g4[ix+0]*g115[iy+0]*g8[iz+0];
s[1112] = + g4[ix+0]*g114[iy+0]*g9[iz+0];
s[1113] = + g5[ix+0]*g112[iy+0]*g10[iz+0];
s[1114] = + g4[ix+0]*g113[iy+0]*g10[iz+0];
s[1115] = + g4[ix+0]*g112[iy+0]*g11[iz+0];
s[1116] = + g3[ix+0]*g116[iy+0]*g8[iz+0];
s[1117] = + g2[ix+0]*g117[iy+0]*g8[iz+0];
s[1118] = + g2[ix+0]*g116[iy+0]*g9[iz+0];
s[1119] = + g1[ix+0]*g118[iy+0]*g8[iz+0];
s[1120] = + g0[ix+0]*g119[iy+0]*g8[iz+0];
s[1121] = + g0[ix+0]*g118[iy+0]*g9[iz+0];
s[1122] = + g1[ix+0]*g116[iy+0]*g10[iz+0];
s[1123] = + g0[ix+0]*g117[iy+0]*g10[iz+0];
s[1124] = + g0[ix+0]*g116[iy+0]*g11[iz+0];
s[1125] = + g3[ix+0]*g112[iy+0]*g12[iz+0];
s[1126] = + g2[ix+0]*g113[iy+0]*g12[iz+0];
s[1127] = + g2[ix+0]*g112[iy+0]*g13[iz+0];
s[1128] = + g1[ix+0]*g114[iy+0]*g12[iz+0];
s[1129] = + g0[ix+0]*g115[iy+0]*g12[iz+0];
s[1130] = + g0[ix+0]*g114[iy+0]*g13[iz+0];
s[1131] = + g1[ix+0]*g112[iy+0]*g14[iz+0];
s[1132] = + g0[ix+0]*g113[iy+0]*g14[iz+0];
s[1133] = + g0[ix+0]*g112[iy+0]*g15[iz+0];
s[1134] = + g15[ix+0]*g96[iy+0]*g16[iz+0];
s[1135] = + g14[ix+0]*g97[iy+0]*g16[iz+0];
s[1136] = + g14[ix+0]*g96[iy+0]*g17[iz+0];
s[1137] = + g13[ix+0]*g98[iy+0]*g16[iz+0];
s[1138] = + g12[ix+0]*g99[iy+0]*g16[iz+0];
s[1139] = + g12[ix+0]*g98[iy+0]*g17[iz+0];
s[1140] = + g13[ix+0]*g96[iy+0]*g18[iz+0];
s[1141] = + g12[ix+0]*g97[iy+0]*g18[iz+0];
s[1142] = + g12[ix+0]*g96[iy+0]*g19[iz+0];
s[1143] = + g11[ix+0]*g100[iy+0]*g16[iz+0];
s[1144] = + g10[ix+0]*g101[iy+0]*g16[iz+0];
s[1145] = + g10[ix+0]*g100[iy+0]*g17[iz+0];
s[1146] = + g9[ix+0]*g102[iy+0]*g16[iz+0];
s[1147] = + g8[ix+0]*g103[iy+0]*g16[iz+0];
s[1148] = + g8[ix+0]*g102[iy+0]*g17[iz+0];
s[1149] = + g9[ix+0]*g100[iy+0]*g18[iz+0];
s[1150] = + g8[ix+0]*g101[iy+0]*g18[iz+0];
s[1151] = + g8[ix+0]*g100[iy+0]*g19[iz+0];
s[1152] = + g11[ix+0]*g96[iy+0]*g20[iz+0];
s[1153] = + g10[ix+0]*g97[iy+0]*g20[iz+0];
s[1154] = + g10[ix+0]*g96[iy+0]*g21[iz+0];
s[1155] = + g9[ix+0]*g98[iy+0]*g20[iz+0];
s[1156] = + g8[ix+0]*g99[iy+0]*g20[iz+0];
s[1157] = + g8[ix+0]*g98[iy+0]*g21[iz+0];
s[1158] = + g9[ix+0]*g96[iy+0]*g22[iz+0];
s[1159] = + g8[ix+0]*g97[iy+0]*g22[iz+0];
s[1160] = + g8[ix+0]*g96[iy+0]*g23[iz+0];
s[1161] = + g7[ix+0]*g104[iy+0]*g16[iz+0];
s[1162] = + g6[ix+0]*g105[iy+0]*g16[iz+0];
s[1163] = + g6[ix+0]*g104[iy+0]*g17[iz+0];
s[1164] = + g5[ix+0]*g106[iy+0]*g16[iz+0];
s[1165] = + g4[ix+0]*g107[iy+0]*g16[iz+0];
s[1166] = + g4[ix+0]*g106[iy+0]*g17[iz+0];
s[1167] = + g5[ix+0]*g104[iy+0]*g18[iz+0];
s[1168] = + g4[ix+0]*g105[iy+0]*g18[iz+0];
s[1169] = + g4[ix+0]*g104[iy+0]*g19[iz+0];
s[1170] = + g3[ix+0]*g108[iy+0]*g16[iz+0];
s[1171] = + g2[ix+0]*g109[iy+0]*g16[iz+0];
s[1172] = + g2[ix+0]*g108[iy+0]*g17[iz+0];
s[1173] = + g1[ix+0]*g110[iy+0]*g16[iz+0];
s[1174] = + g0[ix+0]*g111[iy+0]*g16[iz+0];
s[1175] = + g0[ix+0]*g110[iy+0]*g17[iz+0];
s[1176] = + g1[ix+0]*g108[iy+0]*g18[iz+0];
s[1177] = + g0[ix+0]*g109[iy+0]*g18[iz+0];
s[1178] = + g0[ix+0]*g108[iy+0]*g19[iz+0];
s[1179] = + g3[ix+0]*g104[iy+0]*g20[iz+0];
s[1180] = + g2[ix+0]*g105[iy+0]*g20[iz+0];
s[1181] = + g2[ix+0]*g104[iy+0]*g21[iz+0];
s[1182] = + g1[ix+0]*g106[iy+0]*g20[iz+0];
s[1183] = + g0[ix+0]*g107[iy+0]*g20[iz+0];
s[1184] = + g0[ix+0]*g106[iy+0]*g21[iz+0];
s[1185] = + g1[ix+0]*g104[iy+0]*g22[iz+0];
s[1186] = + g0[ix+0]*g105[iy+0]*g22[iz+0];
s[1187] = + g0[ix+0]*g104[iy+0]*g23[iz+0];
s[1188] = + g7[ix+0]*g96[iy+0]*g24[iz+0];
s[1189] = + g6[ix+0]*g97[iy+0]*g24[iz+0];
s[1190] = + g6[ix+0]*g96[iy+0]*g25[iz+0];
s[1191] = + g5[ix+0]*g98[iy+0]*g24[iz+0];
s[1192] = + g4[ix+0]*g99[iy+0]*g24[iz+0];
s[1193] = + g4[ix+0]*g98[iy+0]*g25[iz+0];
s[1194] = + g5[ix+0]*g96[iy+0]*g26[iz+0];
s[1195] = + g4[ix+0]*g97[iy+0]*g26[iz+0];
s[1196] = + g4[ix+0]*g96[iy+0]*g27[iz+0];
s[1197] = + g3[ix+0]*g100[iy+0]*g24[iz+0];
s[1198] = + g2[ix+0]*g101[iy+0]*g24[iz+0];
s[1199] = + g2[ix+0]*g100[iy+0]*g25[iz+0];
s[1200] = + g1[ix+0]*g102[iy+0]*g24[iz+0];
s[1201] = + g0[ix+0]*g103[iy+0]*g24[iz+0];
s[1202] = + g0[ix+0]*g102[iy+0]*g25[iz+0];
s[1203] = + g1[ix+0]*g100[iy+0]*g26[iz+0];
s[1204] = + g0[ix+0]*g101[iy+0]*g26[iz+0];
s[1205] = + g0[ix+0]*g100[iy+0]*g27[iz+0];
s[1206] = + g3[ix+0]*g96[iy+0]*g28[iz+0];
s[1207] = + g2[ix+0]*g97[iy+0]*g28[iz+0];
s[1208] = + g2[ix+0]*g96[iy+0]*g29[iz+0];
s[1209] = + g1[ix+0]*g98[iy+0]*g28[iz+0];
s[1210] = + g0[ix+0]*g99[iy+0]*g28[iz+0];
s[1211] = + g0[ix+0]*g98[iy+0]*g29[iz+0];
s[1212] = + g1[ix+0]*g96[iy+0]*g30[iz+0];
s[1213] = + g0[ix+0]*g97[iy+0]*g30[iz+0];
s[1214] = + g0[ix+0]*g96[iy+0]*g31[iz+0];
s[1215] = + g31[ix+0]*g64[iy+0]*g32[iz+0];
s[1216] = + g30[ix+0]*g65[iy+0]*g32[iz+0];
s[1217] = + g30[ix+0]*g64[iy+0]*g33[iz+0];
s[1218] = + g29[ix+0]*g66[iy+0]*g32[iz+0];
s[1219] = + g28[ix+0]*g67[iy+0]*g32[iz+0];
s[1220] = + g28[ix+0]*g66[iy+0]*g33[iz+0];
s[1221] = + g29[ix+0]*g64[iy+0]*g34[iz+0];
s[1222] = + g28[ix+0]*g65[iy+0]*g34[iz+0];
s[1223] = + g28[ix+0]*g64[iy+0]*g35[iz+0];
s[1224] = + g27[ix+0]*g68[iy+0]*g32[iz+0];
s[1225] = + g26[ix+0]*g69[iy+0]*g32[iz+0];
s[1226] = + g26[ix+0]*g68[iy+0]*g33[iz+0];
s[1227] = + g25[ix+0]*g70[iy+0]*g32[iz+0];
s[1228] = + g24[ix+0]*g71[iy+0]*g32[iz+0];
s[1229] = + g24[ix+0]*g70[iy+0]*g33[iz+0];
s[1230] = + g25[ix+0]*g68[iy+0]*g34[iz+0];
s[1231] = + g24[ix+0]*g69[iy+0]*g34[iz+0];
s[1232] = + g24[ix+0]*g68[iy+0]*g35[iz+0];
s[1233] = + g27[ix+0]*g64[iy+0]*g36[iz+0];
s[1234] = + g26[ix+0]*g65[iy+0]*g36[iz+0];
s[1235] = + g26[ix+0]*g64[iy+0]*g37[iz+0];
s[1236] = + g25[ix+0]*g66[iy+0]*g36[iz+0];
s[1237] = + g24[ix+0]*g67[iy+0]*g36[iz+0];
s[1238] = + g24[ix+0]*g66[iy+0]*g37[iz+0];
s[1239] = + g25[ix+0]*g64[iy+0]*g38[iz+0];
s[1240] = + g24[ix+0]*g65[iy+0]*g38[iz+0];
s[1241] = + g24[ix+0]*g64[iy+0]*g39[iz+0];
s[1242] = + g23[ix+0]*g72[iy+0]*g32[iz+0];
s[1243] = + g22[ix+0]*g73[iy+0]*g32[iz+0];
s[1244] = + g22[ix+0]*g72[iy+0]*g33[iz+0];
s[1245] = + g21[ix+0]*g74[iy+0]*g32[iz+0];
s[1246] = + g20[ix+0]*g75[iy+0]*g32[iz+0];
s[1247] = + g20[ix+0]*g74[iy+0]*g33[iz+0];
s[1248] = + g21[ix+0]*g72[iy+0]*g34[iz+0];
s[1249] = + g20[ix+0]*g73[iy+0]*g34[iz+0];
s[1250] = + g20[ix+0]*g72[iy+0]*g35[iz+0];
s[1251] = + g19[ix+0]*g76[iy+0]*g32[iz+0];
s[1252] = + g18[ix+0]*g77[iy+0]*g32[iz+0];
s[1253] = + g18[ix+0]*g76[iy+0]*g33[iz+0];
s[1254] = + g17[ix+0]*g78[iy+0]*g32[iz+0];
s[1255] = + g16[ix+0]*g79[iy+0]*g32[iz+0];
s[1256] = + g16[ix+0]*g78[iy+0]*g33[iz+0];
s[1257] = + g17[ix+0]*g76[iy+0]*g34[iz+0];
s[1258] = + g16[ix+0]*g77[iy+0]*g34[iz+0];
s[1259] = + g16[ix+0]*g76[iy+0]*g35[iz+0];
s[1260] = + g19[ix+0]*g72[iy+0]*g36[iz+0];
s[1261] = + g18[ix+0]*g73[iy+0]*g36[iz+0];
s[1262] = + g18[ix+0]*g72[iy+0]*g37[iz+0];
s[1263] = + g17[ix+0]*g74[iy+0]*g36[iz+0];
s[1264] = + g16[ix+0]*g75[iy+0]*g36[iz+0];
s[1265] = + g16[ix+0]*g74[iy+0]*g37[iz+0];
s[1266] = + g17[ix+0]*g72[iy+0]*g38[iz+0];
s[1267] = + g16[ix+0]*g73[iy+0]*g38[iz+0];
s[1268] = + g16[ix+0]*g72[iy+0]*g39[iz+0];
s[1269] = + g23[ix+0]*g64[iy+0]*g40[iz+0];
s[1270] = + g22[ix+0]*g65[iy+0]*g40[iz+0];
s[1271] = + g22[ix+0]*g64[iy+0]*g41[iz+0];
s[1272] = + g21[ix+0]*g66[iy+0]*g40[iz+0];
s[1273] = + g20[ix+0]*g67[iy+0]*g40[iz+0];
s[1274] = + g20[ix+0]*g66[iy+0]*g41[iz+0];
s[1275] = + g21[ix+0]*g64[iy+0]*g42[iz+0];
s[1276] = + g20[ix+0]*g65[iy+0]*g42[iz+0];
s[1277] = + g20[ix+0]*g64[iy+0]*g43[iz+0];
s[1278] = + g19[ix+0]*g68[iy+0]*g40[iz+0];
s[1279] = + g18[ix+0]*g69[iy+0]*g40[iz+0];
s[1280] = + g18[ix+0]*g68[iy+0]*g41[iz+0];
s[1281] = + g17[ix+0]*g70[iy+0]*g40[iz+0];
s[1282] = + g16[ix+0]*g71[iy+0]*g40[iz+0];
s[1283] = + g16[ix+0]*g70[iy+0]*g41[iz+0];
s[1284] = + g17[ix+0]*g68[iy+0]*g42[iz+0];
s[1285] = + g16[ix+0]*g69[iy+0]*g42[iz+0];
s[1286] = + g16[ix+0]*g68[iy+0]*g43[iz+0];
s[1287] = + g19[ix+0]*g64[iy+0]*g44[iz+0];
s[1288] = + g18[ix+0]*g65[iy+0]*g44[iz+0];
s[1289] = + g18[ix+0]*g64[iy+0]*g45[iz+0];
s[1290] = + g17[ix+0]*g66[iy+0]*g44[iz+0];
s[1291] = + g16[ix+0]*g67[iy+0]*g44[iz+0];
s[1292] = + g16[ix+0]*g66[iy+0]*g45[iz+0];
s[1293] = + g17[ix+0]*g64[iy+0]*g46[iz+0];
s[1294] = + g16[ix+0]*g65[iy+0]*g46[iz+0];
s[1295] = + g16[ix+0]*g64[iy+0]*g47[iz+0];
s[1296] = + g15[ix+0]*g80[iy+0]*g32[iz+0];
s[1297] = + g14[ix+0]*g81[iy+0]*g32[iz+0];
s[1298] = + g14[ix+0]*g80[iy+0]*g33[iz+0];
s[1299] = + g13[ix+0]*g82[iy+0]*g32[iz+0];
s[1300] = + g12[ix+0]*g83[iy+0]*g32[iz+0];
s[1301] = + g12[ix+0]*g82[iy+0]*g33[iz+0];
s[1302] = + g13[ix+0]*g80[iy+0]*g34[iz+0];
s[1303] = + g12[ix+0]*g81[iy+0]*g34[iz+0];
s[1304] = + g12[ix+0]*g80[iy+0]*g35[iz+0];
s[1305] = + g11[ix+0]*g84[iy+0]*g32[iz+0];
s[1306] = + g10[ix+0]*g85[iy+0]*g32[iz+0];
s[1307] = + g10[ix+0]*g84[iy+0]*g33[iz+0];
s[1308] = + g9[ix+0]*g86[iy+0]*g32[iz+0];
s[1309] = + g8[ix+0]*g87[iy+0]*g32[iz+0];
s[1310] = + g8[ix+0]*g86[iy+0]*g33[iz+0];
s[1311] = + g9[ix+0]*g84[iy+0]*g34[iz+0];
s[1312] = + g8[ix+0]*g85[iy+0]*g34[iz+0];
s[1313] = + g8[ix+0]*g84[iy+0]*g35[iz+0];
s[1314] = + g11[ix+0]*g80[iy+0]*g36[iz+0];
s[1315] = + g10[ix+0]*g81[iy+0]*g36[iz+0];
s[1316] = + g10[ix+0]*g80[iy+0]*g37[iz+0];
s[1317] = + g9[ix+0]*g82[iy+0]*g36[iz+0];
s[1318] = + g8[ix+0]*g83[iy+0]*g36[iz+0];
s[1319] = + g8[ix+0]*g82[iy+0]*g37[iz+0];
s[1320] = + g9[ix+0]*g80[iy+0]*g38[iz+0];
s[1321] = + g8[ix+0]*g81[iy+0]*g38[iz+0];
s[1322] = + g8[ix+0]*g80[iy+0]*g39[iz+0];
s[1323] = + g7[ix+0]*g88[iy+0]*g32[iz+0];
s[1324] = + g6[ix+0]*g89[iy+0]*g32[iz+0];
s[1325] = + g6[ix+0]*g88[iy+0]*g33[iz+0];
s[1326] = + g5[ix+0]*g90[iy+0]*g32[iz+0];
s[1327] = + g4[ix+0]*g91[iy+0]*g32[iz+0];
s[1328] = + g4[ix+0]*g90[iy+0]*g33[iz+0];
s[1329] = + g5[ix+0]*g88[iy+0]*g34[iz+0];
s[1330] = + g4[ix+0]*g89[iy+0]*g34[iz+0];
s[1331] = + g4[ix+0]*g88[iy+0]*g35[iz+0];
s[1332] = + g3[ix+0]*g92[iy+0]*g32[iz+0];
s[1333] = + g2[ix+0]*g93[iy+0]*g32[iz+0];
s[1334] = + g2[ix+0]*g92[iy+0]*g33[iz+0];
s[1335] = + g1[ix+0]*g94[iy+0]*g32[iz+0];
s[1336] = + g0[ix+0]*g95[iy+0]*g32[iz+0];
s[1337] = + g0[ix+0]*g94[iy+0]*g33[iz+0];
s[1338] = + g1[ix+0]*g92[iy+0]*g34[iz+0];
s[1339] = + g0[ix+0]*g93[iy+0]*g34[iz+0];
s[1340] = + g0[ix+0]*g92[iy+0]*g35[iz+0];
s[1341] = + g3[ix+0]*g88[iy+0]*g36[iz+0];
s[1342] = + g2[ix+0]*g89[iy+0]*g36[iz+0];
s[1343] = + g2[ix+0]*g88[iy+0]*g37[iz+0];
s[1344] = + g1[ix+0]*g90[iy+0]*g36[iz+0];
s[1345] = + g0[ix+0]*g91[iy+0]*g36[iz+0];
s[1346] = + g0[ix+0]*g90[iy+0]*g37[iz+0];
s[1347] = + g1[ix+0]*g88[iy+0]*g38[iz+0];
s[1348] = + g0[ix+0]*g89[iy+0]*g38[iz+0];
s[1349] = + g0[ix+0]*g88[iy+0]*g39[iz+0];
s[1350] = + g7[ix+0]*g80[iy+0]*g40[iz+0];
s[1351] = + g6[ix+0]*g81[iy+0]*g40[iz+0];
s[1352] = + g6[ix+0]*g80[iy+0]*g41[iz+0];
s[1353] = + g5[ix+0]*g82[iy+0]*g40[iz+0];
s[1354] = + g4[ix+0]*g83[iy+0]*g40[iz+0];
s[1355] = + g4[ix+0]*g82[iy+0]*g41[iz+0];
s[1356] = + g5[ix+0]*g80[iy+0]*g42[iz+0];
s[1357] = + g4[ix+0]*g81[iy+0]*g42[iz+0];
s[1358] = + g4[ix+0]*g80[iy+0]*g43[iz+0];
s[1359] = + g3[ix+0]*g84[iy+0]*g40[iz+0];
s[1360] = + g2[ix+0]*g85[iy+0]*g40[iz+0];
s[1361] = + g2[ix+0]*g84[iy+0]*g41[iz+0];
s[1362] = + g1[ix+0]*g86[iy+0]*g40[iz+0];
s[1363] = + g0[ix+0]*g87[iy+0]*g40[iz+0];
s[1364] = + g0[ix+0]*g86[iy+0]*g41[iz+0];
s[1365] = + g1[ix+0]*g84[iy+0]*g42[iz+0];
s[1366] = + g0[ix+0]*g85[iy+0]*g42[iz+0];
s[1367] = + g0[ix+0]*g84[iy+0]*g43[iz+0];
s[1368] = + g3[ix+0]*g80[iy+0]*g44[iz+0];
s[1369] = + g2[ix+0]*g81[iy+0]*g44[iz+0];
s[1370] = + g2[ix+0]*g80[iy+0]*g45[iz+0];
s[1371] = + g1[ix+0]*g82[iy+0]*g44[iz+0];
s[1372] = + g0[ix+0]*g83[iy+0]*g44[iz+0];
s[1373] = + g0[ix+0]*g82[iy+0]*g45[iz+0];
s[1374] = + g1[ix+0]*g80[iy+0]*g46[iz+0];
s[1375] = + g0[ix+0]*g81[iy+0]*g46[iz+0];
s[1376] = + g0[ix+0]*g80[iy+0]*g47[iz+0];
s[1377] = + g15[ix+0]*g64[iy+0]*g48[iz+0];
s[1378] = + g14[ix+0]*g65[iy+0]*g48[iz+0];
s[1379] = + g14[ix+0]*g64[iy+0]*g49[iz+0];
s[1380] = + g13[ix+0]*g66[iy+0]*g48[iz+0];
s[1381] = + g12[ix+0]*g67[iy+0]*g48[iz+0];
s[1382] = + g12[ix+0]*g66[iy+0]*g49[iz+0];
s[1383] = + g13[ix+0]*g64[iy+0]*g50[iz+0];
s[1384] = + g12[ix+0]*g65[iy+0]*g50[iz+0];
s[1385] = + g12[ix+0]*g64[iy+0]*g51[iz+0];
s[1386] = + g11[ix+0]*g68[iy+0]*g48[iz+0];
s[1387] = + g10[ix+0]*g69[iy+0]*g48[iz+0];
s[1388] = + g10[ix+0]*g68[iy+0]*g49[iz+0];
s[1389] = + g9[ix+0]*g70[iy+0]*g48[iz+0];
s[1390] = + g8[ix+0]*g71[iy+0]*g48[iz+0];
s[1391] = + g8[ix+0]*g70[iy+0]*g49[iz+0];
s[1392] = + g9[ix+0]*g68[iy+0]*g50[iz+0];
s[1393] = + g8[ix+0]*g69[iy+0]*g50[iz+0];
s[1394] = + g8[ix+0]*g68[iy+0]*g51[iz+0];
s[1395] = + g11[ix+0]*g64[iy+0]*g52[iz+0];
s[1396] = + g10[ix+0]*g65[iy+0]*g52[iz+0];
s[1397] = + g10[ix+0]*g64[iy+0]*g53[iz+0];
s[1398] = + g9[ix+0]*g66[iy+0]*g52[iz+0];
s[1399] = + g8[ix+0]*g67[iy+0]*g52[iz+0];
s[1400] = + g8[ix+0]*g66[iy+0]*g53[iz+0];
s[1401] = + g9[ix+0]*g64[iy+0]*g54[iz+0];
s[1402] = + g8[ix+0]*g65[iy+0]*g54[iz+0];
s[1403] = + g8[ix+0]*g64[iy+0]*g55[iz+0];
s[1404] = + g7[ix+0]*g72[iy+0]*g48[iz+0];
s[1405] = + g6[ix+0]*g73[iy+0]*g48[iz+0];
s[1406] = + g6[ix+0]*g72[iy+0]*g49[iz+0];
s[1407] = + g5[ix+0]*g74[iy+0]*g48[iz+0];
s[1408] = + g4[ix+0]*g75[iy+0]*g48[iz+0];
s[1409] = + g4[ix+0]*g74[iy+0]*g49[iz+0];
s[1410] = + g5[ix+0]*g72[iy+0]*g50[iz+0];
s[1411] = + g4[ix+0]*g73[iy+0]*g50[iz+0];
s[1412] = + g4[ix+0]*g72[iy+0]*g51[iz+0];
s[1413] = + g3[ix+0]*g76[iy+0]*g48[iz+0];
s[1414] = + g2[ix+0]*g77[iy+0]*g48[iz+0];
s[1415] = + g2[ix+0]*g76[iy+0]*g49[iz+0];
s[1416] = + g1[ix+0]*g78[iy+0]*g48[iz+0];
s[1417] = + g0[ix+0]*g79[iy+0]*g48[iz+0];
s[1418] = + g0[ix+0]*g78[iy+0]*g49[iz+0];
s[1419] = + g1[ix+0]*g76[iy+0]*g50[iz+0];
s[1420] = + g0[ix+0]*g77[iy+0]*g50[iz+0];
s[1421] = + g0[ix+0]*g76[iy+0]*g51[iz+0];
s[1422] = + g3[ix+0]*g72[iy+0]*g52[iz+0];
s[1423] = + g2[ix+0]*g73[iy+0]*g52[iz+0];
s[1424] = + g2[ix+0]*g72[iy+0]*g53[iz+0];
s[1425] = + g1[ix+0]*g74[iy+0]*g52[iz+0];
s[1426] = + g0[ix+0]*g75[iy+0]*g52[iz+0];
s[1427] = + g0[ix+0]*g74[iy+0]*g53[iz+0];
s[1428] = + g1[ix+0]*g72[iy+0]*g54[iz+0];
s[1429] = + g0[ix+0]*g73[iy+0]*g54[iz+0];
s[1430] = + g0[ix+0]*g72[iy+0]*g55[iz+0];
s[1431] = + g7[ix+0]*g64[iy+0]*g56[iz+0];
s[1432] = + g6[ix+0]*g65[iy+0]*g56[iz+0];
s[1433] = + g6[ix+0]*g64[iy+0]*g57[iz+0];
s[1434] = + g5[ix+0]*g66[iy+0]*g56[iz+0];
s[1435] = + g4[ix+0]*g67[iy+0]*g56[iz+0];
s[1436] = + g4[ix+0]*g66[iy+0]*g57[iz+0];
s[1437] = + g5[ix+0]*g64[iy+0]*g58[iz+0];
s[1438] = + g4[ix+0]*g65[iy+0]*g58[iz+0];
s[1439] = + g4[ix+0]*g64[iy+0]*g59[iz+0];
s[1440] = + g3[ix+0]*g68[iy+0]*g56[iz+0];
s[1441] = + g2[ix+0]*g69[iy+0]*g56[iz+0];
s[1442] = + g2[ix+0]*g68[iy+0]*g57[iz+0];
s[1443] = + g1[ix+0]*g70[iy+0]*g56[iz+0];
s[1444] = + g0[ix+0]*g71[iy+0]*g56[iz+0];
s[1445] = + g0[ix+0]*g70[iy+0]*g57[iz+0];
s[1446] = + g1[ix+0]*g68[iy+0]*g58[iz+0];
s[1447] = + g0[ix+0]*g69[iy+0]*g58[iz+0];
s[1448] = + g0[ix+0]*g68[iy+0]*g59[iz+0];
s[1449] = + g3[ix+0]*g64[iy+0]*g60[iz+0];
s[1450] = + g2[ix+0]*g65[iy+0]*g60[iz+0];
s[1451] = + g2[ix+0]*g64[iy+0]*g61[iz+0];
s[1452] = + g1[ix+0]*g66[iy+0]*g60[iz+0];
s[1453] = + g0[ix+0]*g67[iy+0]*g60[iz+0];
s[1454] = + g0[ix+0]*g66[iy+0]*g61[iz+0];
s[1455] = + g1[ix+0]*g64[iy+0]*g62[iz+0];
s[1456] = + g0[ix+0]*g65[iy+0]*g62[iz+0];
s[1457] = + g0[ix+0]*g64[iy+0]*g63[iz+0];
s[1458] = + g63[ix+0]*g0[iy+0]*g64[iz+0];
s[1459] = + g62[ix+0]*g1[iy+0]*g64[iz+0];
s[1460] = + g62[ix+0]*g0[iy+0]*g65[iz+0];
s[1461] = + g61[ix+0]*g2[iy+0]*g64[iz+0];
s[1462] = + g60[ix+0]*g3[iy+0]*g64[iz+0];
s[1463] = + g60[ix+0]*g2[iy+0]*g65[iz+0];
s[1464] = + g61[ix+0]*g0[iy+0]*g66[iz+0];
s[1465] = + g60[ix+0]*g1[iy+0]*g66[iz+0];
s[1466] = + g60[ix+0]*g0[iy+0]*g67[iz+0];
s[1467] = + g59[ix+0]*g4[iy+0]*g64[iz+0];
s[1468] = + g58[ix+0]*g5[iy+0]*g64[iz+0];
s[1469] = + g58[ix+0]*g4[iy+0]*g65[iz+0];
s[1470] = + g57[ix+0]*g6[iy+0]*g64[iz+0];
s[1471] = + g56[ix+0]*g7[iy+0]*g64[iz+0];
s[1472] = + g56[ix+0]*g6[iy+0]*g65[iz+0];
s[1473] = + g57[ix+0]*g4[iy+0]*g66[iz+0];
s[1474] = + g56[ix+0]*g5[iy+0]*g66[iz+0];
s[1475] = + g56[ix+0]*g4[iy+0]*g67[iz+0];
s[1476] = + g59[ix+0]*g0[iy+0]*g68[iz+0];
s[1477] = + g58[ix+0]*g1[iy+0]*g68[iz+0];
s[1478] = + g58[ix+0]*g0[iy+0]*g69[iz+0];
s[1479] = + g57[ix+0]*g2[iy+0]*g68[iz+0];
s[1480] = + g56[ix+0]*g3[iy+0]*g68[iz+0];
s[1481] = + g56[ix+0]*g2[iy+0]*g69[iz+0];
s[1482] = + g57[ix+0]*g0[iy+0]*g70[iz+0];
s[1483] = + g56[ix+0]*g1[iy+0]*g70[iz+0];
s[1484] = + g56[ix+0]*g0[iy+0]*g71[iz+0];
s[1485] = + g55[ix+0]*g8[iy+0]*g64[iz+0];
s[1486] = + g54[ix+0]*g9[iy+0]*g64[iz+0];
s[1487] = + g54[ix+0]*g8[iy+0]*g65[iz+0];
s[1488] = + g53[ix+0]*g10[iy+0]*g64[iz+0];
s[1489] = + g52[ix+0]*g11[iy+0]*g64[iz+0];
s[1490] = + g52[ix+0]*g10[iy+0]*g65[iz+0];
s[1491] = + g53[ix+0]*g8[iy+0]*g66[iz+0];
s[1492] = + g52[ix+0]*g9[iy+0]*g66[iz+0];
s[1493] = + g52[ix+0]*g8[iy+0]*g67[iz+0];
s[1494] = + g51[ix+0]*g12[iy+0]*g64[iz+0];
s[1495] = + g50[ix+0]*g13[iy+0]*g64[iz+0];
s[1496] = + g50[ix+0]*g12[iy+0]*g65[iz+0];
s[1497] = + g49[ix+0]*g14[iy+0]*g64[iz+0];
s[1498] = + g48[ix+0]*g15[iy+0]*g64[iz+0];
s[1499] = + g48[ix+0]*g14[iy+0]*g65[iz+0];
s[1500] = + g49[ix+0]*g12[iy+0]*g66[iz+0];
s[1501] = + g48[ix+0]*g13[iy+0]*g66[iz+0];
s[1502] = + g48[ix+0]*g12[iy+0]*g67[iz+0];
s[1503] = + g51[ix+0]*g8[iy+0]*g68[iz+0];
s[1504] = + g50[ix+0]*g9[iy+0]*g68[iz+0];
s[1505] = + g50[ix+0]*g8[iy+0]*g69[iz+0];
s[1506] = + g49[ix+0]*g10[iy+0]*g68[iz+0];
s[1507] = + g48[ix+0]*g11[iy+0]*g68[iz+0];
s[1508] = + g48[ix+0]*g10[iy+0]*g69[iz+0];
s[1509] = + g49[ix+0]*g8[iy+0]*g70[iz+0];
s[1510] = + g48[ix+0]*g9[iy+0]*g70[iz+0];
s[1511] = + g48[ix+0]*g8[iy+0]*g71[iz+0];
s[1512] = + g55[ix+0]*g0[iy+0]*g72[iz+0];
s[1513] = + g54[ix+0]*g1[iy+0]*g72[iz+0];
s[1514] = + g54[ix+0]*g0[iy+0]*g73[iz+0];
s[1515] = + g53[ix+0]*g2[iy+0]*g72[iz+0];
s[1516] = + g52[ix+0]*g3[iy+0]*g72[iz+0];
s[1517] = + g52[ix+0]*g2[iy+0]*g73[iz+0];
s[1518] = + g53[ix+0]*g0[iy+0]*g74[iz+0];
s[1519] = + g52[ix+0]*g1[iy+0]*g74[iz+0];
s[1520] = + g52[ix+0]*g0[iy+0]*g75[iz+0];
s[1521] = + g51[ix+0]*g4[iy+0]*g72[iz+0];
s[1522] = + g50[ix+0]*g5[iy+0]*g72[iz+0];
s[1523] = + g50[ix+0]*g4[iy+0]*g73[iz+0];
s[1524] = + g49[ix+0]*g6[iy+0]*g72[iz+0];
s[1525] = + g48[ix+0]*g7[iy+0]*g72[iz+0];
s[1526] = + g48[ix+0]*g6[iy+0]*g73[iz+0];
s[1527] = + g49[ix+0]*g4[iy+0]*g74[iz+0];
s[1528] = + g48[ix+0]*g5[iy+0]*g74[iz+0];
s[1529] = + g48[ix+0]*g4[iy+0]*g75[iz+0];
s[1530] = + g51[ix+0]*g0[iy+0]*g76[iz+0];
s[1531] = + g50[ix+0]*g1[iy+0]*g76[iz+0];
s[1532] = + g50[ix+0]*g0[iy+0]*g77[iz+0];
s[1533] = + g49[ix+0]*g2[iy+0]*g76[iz+0];
s[1534] = + g48[ix+0]*g3[iy+0]*g76[iz+0];
s[1535] = + g48[ix+0]*g2[iy+0]*g77[iz+0];
s[1536] = + g49[ix+0]*g0[iy+0]*g78[iz+0];
s[1537] = + g48[ix+0]*g1[iy+0]*g78[iz+0];
s[1538] = + g48[ix+0]*g0[iy+0]*g79[iz+0];
s[1539] = + g47[ix+0]*g16[iy+0]*g64[iz+0];
s[1540] = + g46[ix+0]*g17[iy+0]*g64[iz+0];
s[1541] = + g46[ix+0]*g16[iy+0]*g65[iz+0];
s[1542] = + g45[ix+0]*g18[iy+0]*g64[iz+0];
s[1543] = + g44[ix+0]*g19[iy+0]*g64[iz+0];
s[1544] = + g44[ix+0]*g18[iy+0]*g65[iz+0];
s[1545] = + g45[ix+0]*g16[iy+0]*g66[iz+0];
s[1546] = + g44[ix+0]*g17[iy+0]*g66[iz+0];
s[1547] = + g44[ix+0]*g16[iy+0]*g67[iz+0];
s[1548] = + g43[ix+0]*g20[iy+0]*g64[iz+0];
s[1549] = + g42[ix+0]*g21[iy+0]*g64[iz+0];
s[1550] = + g42[ix+0]*g20[iy+0]*g65[iz+0];
s[1551] = + g41[ix+0]*g22[iy+0]*g64[iz+0];
s[1552] = + g40[ix+0]*g23[iy+0]*g64[iz+0];
s[1553] = + g40[ix+0]*g22[iy+0]*g65[iz+0];
s[1554] = + g41[ix+0]*g20[iy+0]*g66[iz+0];
s[1555] = + g40[ix+0]*g21[iy+0]*g66[iz+0];
s[1556] = + g40[ix+0]*g20[iy+0]*g67[iz+0];
s[1557] = + g43[ix+0]*g16[iy+0]*g68[iz+0];
s[1558] = + g42[ix+0]*g17[iy+0]*g68[iz+0];
s[1559] = + g42[ix+0]*g16[iy+0]*g69[iz+0];
s[1560] = + g41[ix+0]*g18[iy+0]*g68[iz+0];
s[1561] = + g40[ix+0]*g19[iy+0]*g68[iz+0];
s[1562] = + g40[ix+0]*g18[iy+0]*g69[iz+0];
s[1563] = + g41[ix+0]*g16[iy+0]*g70[iz+0];
s[1564] = + g40[ix+0]*g17[iy+0]*g70[iz+0];
s[1565] = + g40[ix+0]*g16[iy+0]*g71[iz+0];
s[1566] = + g39[ix+0]*g24[iy+0]*g64[iz+0];
s[1567] = + g38[ix+0]*g25[iy+0]*g64[iz+0];
s[1568] = + g38[ix+0]*g24[iy+0]*g65[iz+0];
s[1569] = + g37[ix+0]*g26[iy+0]*g64[iz+0];
s[1570] = + g36[ix+0]*g27[iy+0]*g64[iz+0];
s[1571] = + g36[ix+0]*g26[iy+0]*g65[iz+0];
s[1572] = + g37[ix+0]*g24[iy+0]*g66[iz+0];
s[1573] = + g36[ix+0]*g25[iy+0]*g66[iz+0];
s[1574] = + g36[ix+0]*g24[iy+0]*g67[iz+0];
s[1575] = + g35[ix+0]*g28[iy+0]*g64[iz+0];
s[1576] = + g34[ix+0]*g29[iy+0]*g64[iz+0];
s[1577] = + g34[ix+0]*g28[iy+0]*g65[iz+0];
s[1578] = + g33[ix+0]*g30[iy+0]*g64[iz+0];
s[1579] = + g32[ix+0]*g31[iy+0]*g64[iz+0];
s[1580] = + g32[ix+0]*g30[iy+0]*g65[iz+0];
s[1581] = + g33[ix+0]*g28[iy+0]*g66[iz+0];
s[1582] = + g32[ix+0]*g29[iy+0]*g66[iz+0];
s[1583] = + g32[ix+0]*g28[iy+0]*g67[iz+0];
s[1584] = + g35[ix+0]*g24[iy+0]*g68[iz+0];
s[1585] = + g34[ix+0]*g25[iy+0]*g68[iz+0];
s[1586] = + g34[ix+0]*g24[iy+0]*g69[iz+0];
s[1587] = + g33[ix+0]*g26[iy+0]*g68[iz+0];
s[1588] = + g32[ix+0]*g27[iy+0]*g68[iz+0];
s[1589] = + g32[ix+0]*g26[iy+0]*g69[iz+0];
s[1590] = + g33[ix+0]*g24[iy+0]*g70[iz+0];
s[1591] = + g32[ix+0]*g25[iy+0]*g70[iz+0];
s[1592] = + g32[ix+0]*g24[iy+0]*g71[iz+0];
s[1593] = + g39[ix+0]*g16[iy+0]*g72[iz+0];
s[1594] = + g38[ix+0]*g17[iy+0]*g72[iz+0];
s[1595] = + g38[ix+0]*g16[iy+0]*g73[iz+0];
s[1596] = + g37[ix+0]*g18[iy+0]*g72[iz+0];
s[1597] = + g36[ix+0]*g19[iy+0]*g72[iz+0];
s[1598] = + g36[ix+0]*g18[iy+0]*g73[iz+0];
s[1599] = + g37[ix+0]*g16[iy+0]*g74[iz+0];
s[1600] = + g36[ix+0]*g17[iy+0]*g74[iz+0];
s[1601] = + g36[ix+0]*g16[iy+0]*g75[iz+0];
s[1602] = + g35[ix+0]*g20[iy+0]*g72[iz+0];
s[1603] = + g34[ix+0]*g21[iy+0]*g72[iz+0];
s[1604] = + g34[ix+0]*g20[iy+0]*g73[iz+0];
s[1605] = + g33[ix+0]*g22[iy+0]*g72[iz+0];
s[1606] = + g32[ix+0]*g23[iy+0]*g72[iz+0];
s[1607] = + g32[ix+0]*g22[iy+0]*g73[iz+0];
s[1608] = + g33[ix+0]*g20[iy+0]*g74[iz+0];
s[1609] = + g32[ix+0]*g21[iy+0]*g74[iz+0];
s[1610] = + g32[ix+0]*g20[iy+0]*g75[iz+0];
s[1611] = + g35[ix+0]*g16[iy+0]*g76[iz+0];
s[1612] = + g34[ix+0]*g17[iy+0]*g76[iz+0];
s[1613] = + g34[ix+0]*g16[iy+0]*g77[iz+0];
s[1614] = + g33[ix+0]*g18[iy+0]*g76[iz+0];
s[1615] = + g32[ix+0]*g19[iy+0]*g76[iz+0];
s[1616] = + g32[ix+0]*g18[iy+0]*g77[iz+0];
s[1617] = + g33[ix+0]*g16[iy+0]*g78[iz+0];
s[1618] = + g32[ix+0]*g17[iy+0]*g78[iz+0];
s[1619] = + g32[ix+0]*g16[iy+0]*g79[iz+0];
s[1620] = + g47[ix+0]*g0[iy+0]*g80[iz+0];
s[1621] = + g46[ix+0]*g1[iy+0]*g80[iz+0];
s[1622] = + g46[ix+0]*g0[iy+0]*g81[iz+0];
s[1623] = + g45[ix+0]*g2[iy+0]*g80[iz+0];
s[1624] = + g44[ix+0]*g3[iy+0]*g80[iz+0];
s[1625] = + g44[ix+0]*g2[iy+0]*g81[iz+0];
s[1626] = + g45[ix+0]*g0[iy+0]*g82[iz+0];
s[1627] = + g44[ix+0]*g1[iy+0]*g82[iz+0];
s[1628] = + g44[ix+0]*g0[iy+0]*g83[iz+0];
s[1629] = + g43[ix+0]*g4[iy+0]*g80[iz+0];
s[1630] = + g42[ix+0]*g5[iy+0]*g80[iz+0];
s[1631] = + g42[ix+0]*g4[iy+0]*g81[iz+0];
s[1632] = + g41[ix+0]*g6[iy+0]*g80[iz+0];
s[1633] = + g40[ix+0]*g7[iy+0]*g80[iz+0];
s[1634] = + g40[ix+0]*g6[iy+0]*g81[iz+0];
s[1635] = + g41[ix+0]*g4[iy+0]*g82[iz+0];
s[1636] = + g40[ix+0]*g5[iy+0]*g82[iz+0];
s[1637] = + g40[ix+0]*g4[iy+0]*g83[iz+0];
s[1638] = + g43[ix+0]*g0[iy+0]*g84[iz+0];
s[1639] = + g42[ix+0]*g1[iy+0]*g84[iz+0];
s[1640] = + g42[ix+0]*g0[iy+0]*g85[iz+0];
s[1641] = + g41[ix+0]*g2[iy+0]*g84[iz+0];
s[1642] = + g40[ix+0]*g3[iy+0]*g84[iz+0];
s[1643] = + g40[ix+0]*g2[iy+0]*g85[iz+0];
s[1644] = + g41[ix+0]*g0[iy+0]*g86[iz+0];
s[1645] = + g40[ix+0]*g1[iy+0]*g86[iz+0];
s[1646] = + g40[ix+0]*g0[iy+0]*g87[iz+0];
s[1647] = + g39[ix+0]*g8[iy+0]*g80[iz+0];
s[1648] = + g38[ix+0]*g9[iy+0]*g80[iz+0];
s[1649] = + g38[ix+0]*g8[iy+0]*g81[iz+0];
s[1650] = + g37[ix+0]*g10[iy+0]*g80[iz+0];
s[1651] = + g36[ix+0]*g11[iy+0]*g80[iz+0];
s[1652] = + g36[ix+0]*g10[iy+0]*g81[iz+0];
s[1653] = + g37[ix+0]*g8[iy+0]*g82[iz+0];
s[1654] = + g36[ix+0]*g9[iy+0]*g82[iz+0];
s[1655] = + g36[ix+0]*g8[iy+0]*g83[iz+0];
s[1656] = + g35[ix+0]*g12[iy+0]*g80[iz+0];
s[1657] = + g34[ix+0]*g13[iy+0]*g80[iz+0];
s[1658] = + g34[ix+0]*g12[iy+0]*g81[iz+0];
s[1659] = + g33[ix+0]*g14[iy+0]*g80[iz+0];
s[1660] = + g32[ix+0]*g15[iy+0]*g80[iz+0];
s[1661] = + g32[ix+0]*g14[iy+0]*g81[iz+0];
s[1662] = + g33[ix+0]*g12[iy+0]*g82[iz+0];
s[1663] = + g32[ix+0]*g13[iy+0]*g82[iz+0];
s[1664] = + g32[ix+0]*g12[iy+0]*g83[iz+0];
s[1665] = + g35[ix+0]*g8[iy+0]*g84[iz+0];
s[1666] = + g34[ix+0]*g9[iy+0]*g84[iz+0];
s[1667] = + g34[ix+0]*g8[iy+0]*g85[iz+0];
s[1668] = + g33[ix+0]*g10[iy+0]*g84[iz+0];
s[1669] = + g32[ix+0]*g11[iy+0]*g84[iz+0];
s[1670] = + g32[ix+0]*g10[iy+0]*g85[iz+0];
s[1671] = + g33[ix+0]*g8[iy+0]*g86[iz+0];
s[1672] = + g32[ix+0]*g9[iy+0]*g86[iz+0];
s[1673] = + g32[ix+0]*g8[iy+0]*g87[iz+0];
s[1674] = + g39[ix+0]*g0[iy+0]*g88[iz+0];
s[1675] = + g38[ix+0]*g1[iy+0]*g88[iz+0];
s[1676] = + g38[ix+0]*g0[iy+0]*g89[iz+0];
s[1677] = + g37[ix+0]*g2[iy+0]*g88[iz+0];
s[1678] = + g36[ix+0]*g3[iy+0]*g88[iz+0];
s[1679] = + g36[ix+0]*g2[iy+0]*g89[iz+0];
s[1680] = + g37[ix+0]*g0[iy+0]*g90[iz+0];
s[1681] = + g36[ix+0]*g1[iy+0]*g90[iz+0];
s[1682] = + g36[ix+0]*g0[iy+0]*g91[iz+0];
s[1683] = + g35[ix+0]*g4[iy+0]*g88[iz+0];
s[1684] = + g34[ix+0]*g5[iy+0]*g88[iz+0];
s[1685] = + g34[ix+0]*g4[iy+0]*g89[iz+0];
s[1686] = + g33[ix+0]*g6[iy+0]*g88[iz+0];
s[1687] = + g32[ix+0]*g7[iy+0]*g88[iz+0];
s[1688] = + g32[ix+0]*g6[iy+0]*g89[iz+0];
s[1689] = + g33[ix+0]*g4[iy+0]*g90[iz+0];
s[1690] = + g32[ix+0]*g5[iy+0]*g90[iz+0];
s[1691] = + g32[ix+0]*g4[iy+0]*g91[iz+0];
s[1692] = + g35[ix+0]*g0[iy+0]*g92[iz+0];
s[1693] = + g34[ix+0]*g1[iy+0]*g92[iz+0];
s[1694] = + g34[ix+0]*g0[iy+0]*g93[iz+0];
s[1695] = + g33[ix+0]*g2[iy+0]*g92[iz+0];
s[1696] = + g32[ix+0]*g3[iy+0]*g92[iz+0];
s[1697] = + g32[ix+0]*g2[iy+0]*g93[iz+0];
s[1698] = + g33[ix+0]*g0[iy+0]*g94[iz+0];
s[1699] = + g32[ix+0]*g1[iy+0]*g94[iz+0];
s[1700] = + g32[ix+0]*g0[iy+0]*g95[iz+0];
s[1701] = + g31[ix+0]*g32[iy+0]*g64[iz+0];
s[1702] = + g30[ix+0]*g33[iy+0]*g64[iz+0];
s[1703] = + g30[ix+0]*g32[iy+0]*g65[iz+0];
s[1704] = + g29[ix+0]*g34[iy+0]*g64[iz+0];
s[1705] = + g28[ix+0]*g35[iy+0]*g64[iz+0];
s[1706] = + g28[ix+0]*g34[iy+0]*g65[iz+0];
s[1707] = + g29[ix+0]*g32[iy+0]*g66[iz+0];
s[1708] = + g28[ix+0]*g33[iy+0]*g66[iz+0];
s[1709] = + g28[ix+0]*g32[iy+0]*g67[iz+0];
s[1710] = + g27[ix+0]*g36[iy+0]*g64[iz+0];
s[1711] = + g26[ix+0]*g37[iy+0]*g64[iz+0];
s[1712] = + g26[ix+0]*g36[iy+0]*g65[iz+0];
s[1713] = + g25[ix+0]*g38[iy+0]*g64[iz+0];
s[1714] = + g24[ix+0]*g39[iy+0]*g64[iz+0];
s[1715] = + g24[ix+0]*g38[iy+0]*g65[iz+0];
s[1716] = + g25[ix+0]*g36[iy+0]*g66[iz+0];
s[1717] = + g24[ix+0]*g37[iy+0]*g66[iz+0];
s[1718] = + g24[ix+0]*g36[iy+0]*g67[iz+0];
s[1719] = + g27[ix+0]*g32[iy+0]*g68[iz+0];
s[1720] = + g26[ix+0]*g33[iy+0]*g68[iz+0];
s[1721] = + g26[ix+0]*g32[iy+0]*g69[iz+0];
s[1722] = + g25[ix+0]*g34[iy+0]*g68[iz+0];
s[1723] = + g24[ix+0]*g35[iy+0]*g68[iz+0];
s[1724] = + g24[ix+0]*g34[iy+0]*g69[iz+0];
s[1725] = + g25[ix+0]*g32[iy+0]*g70[iz+0];
s[1726] = + g24[ix+0]*g33[iy+0]*g70[iz+0];
s[1727] = + g24[ix+0]*g32[iy+0]*g71[iz+0];
s[1728] = + g23[ix+0]*g40[iy+0]*g64[iz+0];
s[1729] = + g22[ix+0]*g41[iy+0]*g64[iz+0];
s[1730] = + g22[ix+0]*g40[iy+0]*g65[iz+0];
s[1731] = + g21[ix+0]*g42[iy+0]*g64[iz+0];
s[1732] = + g20[ix+0]*g43[iy+0]*g64[iz+0];
s[1733] = + g20[ix+0]*g42[iy+0]*g65[iz+0];
s[1734] = + g21[ix+0]*g40[iy+0]*g66[iz+0];
s[1735] = + g20[ix+0]*g41[iy+0]*g66[iz+0];
s[1736] = + g20[ix+0]*g40[iy+0]*g67[iz+0];
s[1737] = + g19[ix+0]*g44[iy+0]*g64[iz+0];
s[1738] = + g18[ix+0]*g45[iy+0]*g64[iz+0];
s[1739] = + g18[ix+0]*g44[iy+0]*g65[iz+0];
s[1740] = + g17[ix+0]*g46[iy+0]*g64[iz+0];
s[1741] = + g16[ix+0]*g47[iy+0]*g64[iz+0];
s[1742] = + g16[ix+0]*g46[iy+0]*g65[iz+0];
s[1743] = + g17[ix+0]*g44[iy+0]*g66[iz+0];
s[1744] = + g16[ix+0]*g45[iy+0]*g66[iz+0];
s[1745] = + g16[ix+0]*g44[iy+0]*g67[iz+0];
s[1746] = + g19[ix+0]*g40[iy+0]*g68[iz+0];
s[1747] = + g18[ix+0]*g41[iy+0]*g68[iz+0];
s[1748] = + g18[ix+0]*g40[iy+0]*g69[iz+0];
s[1749] = + g17[ix+0]*g42[iy+0]*g68[iz+0];
s[1750] = + g16[ix+0]*g43[iy+0]*g68[iz+0];
s[1751] = + g16[ix+0]*g42[iy+0]*g69[iz+0];
s[1752] = + g17[ix+0]*g40[iy+0]*g70[iz+0];
s[1753] = + g16[ix+0]*g41[iy+0]*g70[iz+0];
s[1754] = + g16[ix+0]*g40[iy+0]*g71[iz+0];
s[1755] = + g23[ix+0]*g32[iy+0]*g72[iz+0];
s[1756] = + g22[ix+0]*g33[iy+0]*g72[iz+0];
s[1757] = + g22[ix+0]*g32[iy+0]*g73[iz+0];
s[1758] = + g21[ix+0]*g34[iy+0]*g72[iz+0];
s[1759] = + g20[ix+0]*g35[iy+0]*g72[iz+0];
s[1760] = + g20[ix+0]*g34[iy+0]*g73[iz+0];
s[1761] = + g21[ix+0]*g32[iy+0]*g74[iz+0];
s[1762] = + g20[ix+0]*g33[iy+0]*g74[iz+0];
s[1763] = + g20[ix+0]*g32[iy+0]*g75[iz+0];
s[1764] = + g19[ix+0]*g36[iy+0]*g72[iz+0];
s[1765] = + g18[ix+0]*g37[iy+0]*g72[iz+0];
s[1766] = + g18[ix+0]*g36[iy+0]*g73[iz+0];
s[1767] = + g17[ix+0]*g38[iy+0]*g72[iz+0];
s[1768] = + g16[ix+0]*g39[iy+0]*g72[iz+0];
s[1769] = + g16[ix+0]*g38[iy+0]*g73[iz+0];
s[1770] = + g17[ix+0]*g36[iy+0]*g74[iz+0];
s[1771] = + g16[ix+0]*g37[iy+0]*g74[iz+0];
s[1772] = + g16[ix+0]*g36[iy+0]*g75[iz+0];
s[1773] = + g19[ix+0]*g32[iy+0]*g76[iz+0];
s[1774] = + g18[ix+0]*g33[iy+0]*g76[iz+0];
s[1775] = + g18[ix+0]*g32[iy+0]*g77[iz+0];
s[1776] = + g17[ix+0]*g34[iy+0]*g76[iz+0];
s[1777] = + g16[ix+0]*g35[iy+0]*g76[iz+0];
s[1778] = + g16[ix+0]*g34[iy+0]*g77[iz+0];
s[1779] = + g17[ix+0]*g32[iy+0]*g78[iz+0];
s[1780] = + g16[ix+0]*g33[iy+0]*g78[iz+0];
s[1781] = + g16[ix+0]*g32[iy+0]*g79[iz+0];
s[1782] = + g15[ix+0]*g48[iy+0]*g64[iz+0];
s[1783] = + g14[ix+0]*g49[iy+0]*g64[iz+0];
s[1784] = + g14[ix+0]*g48[iy+0]*g65[iz+0];
s[1785] = + g13[ix+0]*g50[iy+0]*g64[iz+0];
s[1786] = + g12[ix+0]*g51[iy+0]*g64[iz+0];
s[1787] = + g12[ix+0]*g50[iy+0]*g65[iz+0];
s[1788] = + g13[ix+0]*g48[iy+0]*g66[iz+0];
s[1789] = + g12[ix+0]*g49[iy+0]*g66[iz+0];
s[1790] = + g12[ix+0]*g48[iy+0]*g67[iz+0];
s[1791] = + g11[ix+0]*g52[iy+0]*g64[iz+0];
s[1792] = + g10[ix+0]*g53[iy+0]*g64[iz+0];
s[1793] = + g10[ix+0]*g52[iy+0]*g65[iz+0];
s[1794] = + g9[ix+0]*g54[iy+0]*g64[iz+0];
s[1795] = + g8[ix+0]*g55[iy+0]*g64[iz+0];
s[1796] = + g8[ix+0]*g54[iy+0]*g65[iz+0];
s[1797] = + g9[ix+0]*g52[iy+0]*g66[iz+0];
s[1798] = + g8[ix+0]*g53[iy+0]*g66[iz+0];
s[1799] = + g8[ix+0]*g52[iy+0]*g67[iz+0];
s[1800] = + g11[ix+0]*g48[iy+0]*g68[iz+0];
s[1801] = + g10[ix+0]*g49[iy+0]*g68[iz+0];
s[1802] = + g10[ix+0]*g48[iy+0]*g69[iz+0];
s[1803] = + g9[ix+0]*g50[iy+0]*g68[iz+0];
s[1804] = + g8[ix+0]*g51[iy+0]*g68[iz+0];
s[1805] = + g8[ix+0]*g50[iy+0]*g69[iz+0];
s[1806] = + g9[ix+0]*g48[iy+0]*g70[iz+0];
s[1807] = + g8[ix+0]*g49[iy+0]*g70[iz+0];
s[1808] = + g8[ix+0]*g48[iy+0]*g71[iz+0];
s[1809] = + g7[ix+0]*g56[iy+0]*g64[iz+0];
s[1810] = + g6[ix+0]*g57[iy+0]*g64[iz+0];
s[1811] = + g6[ix+0]*g56[iy+0]*g65[iz+0];
s[1812] = + g5[ix+0]*g58[iy+0]*g64[iz+0];
s[1813] = + g4[ix+0]*g59[iy+0]*g64[iz+0];
s[1814] = + g4[ix+0]*g58[iy+0]*g65[iz+0];
s[1815] = + g5[ix+0]*g56[iy+0]*g66[iz+0];
s[1816] = + g4[ix+0]*g57[iy+0]*g66[iz+0];
s[1817] = + g4[ix+0]*g56[iy+0]*g67[iz+0];
s[1818] = + g3[ix+0]*g60[iy+0]*g64[iz+0];
s[1819] = + g2[ix+0]*g61[iy+0]*g64[iz+0];
s[1820] = + g2[ix+0]*g60[iy+0]*g65[iz+0];
s[1821] = + g1[ix+0]*g62[iy+0]*g64[iz+0];
s[1822] = + g0[ix+0]*g63[iy+0]*g64[iz+0];
s[1823] = + g0[ix+0]*g62[iy+0]*g65[iz+0];
s[1824] = + g1[ix+0]*g60[iy+0]*g66[iz+0];
s[1825] = + g0[ix+0]*g61[iy+0]*g66[iz+0];
s[1826] = + g0[ix+0]*g60[iy+0]*g67[iz+0];
s[1827] = + g3[ix+0]*g56[iy+0]*g68[iz+0];
s[1828] = + g2[ix+0]*g57[iy+0]*g68[iz+0];
s[1829] = + g2[ix+0]*g56[iy+0]*g69[iz+0];
s[1830] = + g1[ix+0]*g58[iy+0]*g68[iz+0];
s[1831] = + g0[ix+0]*g59[iy+0]*g68[iz+0];
s[1832] = + g0[ix+0]*g58[iy+0]*g69[iz+0];
s[1833] = + g1[ix+0]*g56[iy+0]*g70[iz+0];
s[1834] = + g0[ix+0]*g57[iy+0]*g70[iz+0];
s[1835] = + g0[ix+0]*g56[iy+0]*g71[iz+0];
s[1836] = + g7[ix+0]*g48[iy+0]*g72[iz+0];
s[1837] = + g6[ix+0]*g49[iy+0]*g72[iz+0];
s[1838] = + g6[ix+0]*g48[iy+0]*g73[iz+0];
s[1839] = + g5[ix+0]*g50[iy+0]*g72[iz+0];
s[1840] = + g4[ix+0]*g51[iy+0]*g72[iz+0];
s[1841] = + g4[ix+0]*g50[iy+0]*g73[iz+0];
s[1842] = + g5[ix+0]*g48[iy+0]*g74[iz+0];
s[1843] = + g4[ix+0]*g49[iy+0]*g74[iz+0];
s[1844] = + g4[ix+0]*g48[iy+0]*g75[iz+0];
s[1845] = + g3[ix+0]*g52[iy+0]*g72[iz+0];
s[1846] = + g2[ix+0]*g53[iy+0]*g72[iz+0];
s[1847] = + g2[ix+0]*g52[iy+0]*g73[iz+0];
s[1848] = + g1[ix+0]*g54[iy+0]*g72[iz+0];
s[1849] = + g0[ix+0]*g55[iy+0]*g72[iz+0];
s[1850] = + g0[ix+0]*g54[iy+0]*g73[iz+0];
s[1851] = + g1[ix+0]*g52[iy+0]*g74[iz+0];
s[1852] = + g0[ix+0]*g53[iy+0]*g74[iz+0];
s[1853] = + g0[ix+0]*g52[iy+0]*g75[iz+0];
s[1854] = + g3[ix+0]*g48[iy+0]*g76[iz+0];
s[1855] = + g2[ix+0]*g49[iy+0]*g76[iz+0];
s[1856] = + g2[ix+0]*g48[iy+0]*g77[iz+0];
s[1857] = + g1[ix+0]*g50[iy+0]*g76[iz+0];
s[1858] = + g0[ix+0]*g51[iy+0]*g76[iz+0];
s[1859] = + g0[ix+0]*g50[iy+0]*g77[iz+0];
s[1860] = + g1[ix+0]*g48[iy+0]*g78[iz+0];
s[1861] = + g0[ix+0]*g49[iy+0]*g78[iz+0];
s[1862] = + g0[ix+0]*g48[iy+0]*g79[iz+0];
s[1863] = + g15[ix+0]*g32[iy+0]*g80[iz+0];
s[1864] = + g14[ix+0]*g33[iy+0]*g80[iz+0];
s[1865] = + g14[ix+0]*g32[iy+0]*g81[iz+0];
s[1866] = + g13[ix+0]*g34[iy+0]*g80[iz+0];
s[1867] = + g12[ix+0]*g35[iy+0]*g80[iz+0];
s[1868] = + g12[ix+0]*g34[iy+0]*g81[iz+0];
s[1869] = + g13[ix+0]*g32[iy+0]*g82[iz+0];
s[1870] = + g12[ix+0]*g33[iy+0]*g82[iz+0];
s[1871] = + g12[ix+0]*g32[iy+0]*g83[iz+0];
s[1872] = + g11[ix+0]*g36[iy+0]*g80[iz+0];
s[1873] = + g10[ix+0]*g37[iy+0]*g80[iz+0];
s[1874] = + g10[ix+0]*g36[iy+0]*g81[iz+0];
s[1875] = + g9[ix+0]*g38[iy+0]*g80[iz+0];
s[1876] = + g8[ix+0]*g39[iy+0]*g80[iz+0];
s[1877] = + g8[ix+0]*g38[iy+0]*g81[iz+0];
s[1878] = + g9[ix+0]*g36[iy+0]*g82[iz+0];
s[1879] = + g8[ix+0]*g37[iy+0]*g82[iz+0];
s[1880] = + g8[ix+0]*g36[iy+0]*g83[iz+0];
s[1881] = + g11[ix+0]*g32[iy+0]*g84[iz+0];
s[1882] = + g10[ix+0]*g33[iy+0]*g84[iz+0];
s[1883] = + g10[ix+0]*g32[iy+0]*g85[iz+0];
s[1884] = + g9[ix+0]*g34[iy+0]*g84[iz+0];
s[1885] = + g8[ix+0]*g35[iy+0]*g84[iz+0];
s[1886] = + g8[ix+0]*g34[iy+0]*g85[iz+0];
s[1887] = + g9[ix+0]*g32[iy+0]*g86[iz+0];
s[1888] = + g8[ix+0]*g33[iy+0]*g86[iz+0];
s[1889] = + g8[ix+0]*g32[iy+0]*g87[iz+0];
s[1890] = + g7[ix+0]*g40[iy+0]*g80[iz+0];
s[1891] = + g6[ix+0]*g41[iy+0]*g80[iz+0];
s[1892] = + g6[ix+0]*g40[iy+0]*g81[iz+0];
s[1893] = + g5[ix+0]*g42[iy+0]*g80[iz+0];
s[1894] = + g4[ix+0]*g43[iy+0]*g80[iz+0];
s[1895] = + g4[ix+0]*g42[iy+0]*g81[iz+0];
s[1896] = + g5[ix+0]*g40[iy+0]*g82[iz+0];
s[1897] = + g4[ix+0]*g41[iy+0]*g82[iz+0];
s[1898] = + g4[ix+0]*g40[iy+0]*g83[iz+0];
s[1899] = + g3[ix+0]*g44[iy+0]*g80[iz+0];
s[1900] = + g2[ix+0]*g45[iy+0]*g80[iz+0];
s[1901] = + g2[ix+0]*g44[iy+0]*g81[iz+0];
s[1902] = + g1[ix+0]*g46[iy+0]*g80[iz+0];
s[1903] = + g0[ix+0]*g47[iy+0]*g80[iz+0];
s[1904] = + g0[ix+0]*g46[iy+0]*g81[iz+0];
s[1905] = + g1[ix+0]*g44[iy+0]*g82[iz+0];
s[1906] = + g0[ix+0]*g45[iy+0]*g82[iz+0];
s[1907] = + g0[ix+0]*g44[iy+0]*g83[iz+0];
s[1908] = + g3[ix+0]*g40[iy+0]*g84[iz+0];
s[1909] = + g2[ix+0]*g41[iy+0]*g84[iz+0];
s[1910] = + g2[ix+0]*g40[iy+0]*g85[iz+0];
s[1911] = + g1[ix+0]*g42[iy+0]*g84[iz+0];
s[1912] = + g0[ix+0]*g43[iy+0]*g84[iz+0];
s[1913] = + g0[ix+0]*g42[iy+0]*g85[iz+0];
s[1914] = + g1[ix+0]*g40[iy+0]*g86[iz+0];
s[1915] = + g0[ix+0]*g41[iy+0]*g86[iz+0];
s[1916] = + g0[ix+0]*g40[iy+0]*g87[iz+0];
s[1917] = + g7[ix+0]*g32[iy+0]*g88[iz+0];
s[1918] = + g6[ix+0]*g33[iy+0]*g88[iz+0];
s[1919] = + g6[ix+0]*g32[iy+0]*g89[iz+0];
s[1920] = + g5[ix+0]*g34[iy+0]*g88[iz+0];
s[1921] = + g4[ix+0]*g35[iy+0]*g88[iz+0];
s[1922] = + g4[ix+0]*g34[iy+0]*g89[iz+0];
s[1923] = + g5[ix+0]*g32[iy+0]*g90[iz+0];
s[1924] = + g4[ix+0]*g33[iy+0]*g90[iz+0];
s[1925] = + g4[ix+0]*g32[iy+0]*g91[iz+0];
s[1926] = + g3[ix+0]*g36[iy+0]*g88[iz+0];
s[1927] = + g2[ix+0]*g37[iy+0]*g88[iz+0];
s[1928] = + g2[ix+0]*g36[iy+0]*g89[iz+0];
s[1929] = + g1[ix+0]*g38[iy+0]*g88[iz+0];
s[1930] = + g0[ix+0]*g39[iy+0]*g88[iz+0];
s[1931] = + g0[ix+0]*g38[iy+0]*g89[iz+0];
s[1932] = + g1[ix+0]*g36[iy+0]*g90[iz+0];
s[1933] = + g0[ix+0]*g37[iy+0]*g90[iz+0];
s[1934] = + g0[ix+0]*g36[iy+0]*g91[iz+0];
s[1935] = + g3[ix+0]*g32[iy+0]*g92[iz+0];
s[1936] = + g2[ix+0]*g33[iy+0]*g92[iz+0];
s[1937] = + g2[ix+0]*g32[iy+0]*g93[iz+0];
s[1938] = + g1[ix+0]*g34[iy+0]*g92[iz+0];
s[1939] = + g0[ix+0]*g35[iy+0]*g92[iz+0];
s[1940] = + g0[ix+0]*g34[iy+0]*g93[iz+0];
s[1941] = + g1[ix+0]*g32[iy+0]*g94[iz+0];
s[1942] = + g0[ix+0]*g33[iy+0]*g94[iz+0];
s[1943] = + g0[ix+0]*g32[iy+0]*g95[iz+0];
s[1944] = + g31[ix+0]*g0[iy+0]*g96[iz+0];
s[1945] = + g30[ix+0]*g1[iy+0]*g96[iz+0];
s[1946] = + g30[ix+0]*g0[iy+0]*g97[iz+0];
s[1947] = + g29[ix+0]*g2[iy+0]*g96[iz+0];
s[1948] = + g28[ix+0]*g3[iy+0]*g96[iz+0];
s[1949] = + g28[ix+0]*g2[iy+0]*g97[iz+0];
s[1950] = + g29[ix+0]*g0[iy+0]*g98[iz+0];
s[1951] = + g28[ix+0]*g1[iy+0]*g98[iz+0];
s[1952] = + g28[ix+0]*g0[iy+0]*g99[iz+0];
s[1953] = + g27[ix+0]*g4[iy+0]*g96[iz+0];
s[1954] = + g26[ix+0]*g5[iy+0]*g96[iz+0];
s[1955] = + g26[ix+0]*g4[iy+0]*g97[iz+0];
s[1956] = + g25[ix+0]*g6[iy+0]*g96[iz+0];
s[1957] = + g24[ix+0]*g7[iy+0]*g96[iz+0];
s[1958] = + g24[ix+0]*g6[iy+0]*g97[iz+0];
s[1959] = + g25[ix+0]*g4[iy+0]*g98[iz+0];
s[1960] = + g24[ix+0]*g5[iy+0]*g98[iz+0];
s[1961] = + g24[ix+0]*g4[iy+0]*g99[iz+0];
s[1962] = + g27[ix+0]*g0[iy+0]*g100[iz+0];
s[1963] = + g26[ix+0]*g1[iy+0]*g100[iz+0];
s[1964] = + g26[ix+0]*g0[iy+0]*g101[iz+0];
s[1965] = + g25[ix+0]*g2[iy+0]*g100[iz+0];
s[1966] = + g24[ix+0]*g3[iy+0]*g100[iz+0];
s[1967] = + g24[ix+0]*g2[iy+0]*g101[iz+0];
s[1968] = + g25[ix+0]*g0[iy+0]*g102[iz+0];
s[1969] = + g24[ix+0]*g1[iy+0]*g102[iz+0];
s[1970] = + g24[ix+0]*g0[iy+0]*g103[iz+0];
s[1971] = + g23[ix+0]*g8[iy+0]*g96[iz+0];
s[1972] = + g22[ix+0]*g9[iy+0]*g96[iz+0];
s[1973] = + g22[ix+0]*g8[iy+0]*g97[iz+0];
s[1974] = + g21[ix+0]*g10[iy+0]*g96[iz+0];
s[1975] = + g20[ix+0]*g11[iy+0]*g96[iz+0];
s[1976] = + g20[ix+0]*g10[iy+0]*g97[iz+0];
s[1977] = + g21[ix+0]*g8[iy+0]*g98[iz+0];
s[1978] = + g20[ix+0]*g9[iy+0]*g98[iz+0];
s[1979] = + g20[ix+0]*g8[iy+0]*g99[iz+0];
s[1980] = + g19[ix+0]*g12[iy+0]*g96[iz+0];
s[1981] = + g18[ix+0]*g13[iy+0]*g96[iz+0];
s[1982] = + g18[ix+0]*g12[iy+0]*g97[iz+0];
s[1983] = + g17[ix+0]*g14[iy+0]*g96[iz+0];
s[1984] = + g16[ix+0]*g15[iy+0]*g96[iz+0];
s[1985] = + g16[ix+0]*g14[iy+0]*g97[iz+0];
s[1986] = + g17[ix+0]*g12[iy+0]*g98[iz+0];
s[1987] = + g16[ix+0]*g13[iy+0]*g98[iz+0];
s[1988] = + g16[ix+0]*g12[iy+0]*g99[iz+0];
s[1989] = + g19[ix+0]*g8[iy+0]*g100[iz+0];
s[1990] = + g18[ix+0]*g9[iy+0]*g100[iz+0];
s[1991] = + g18[ix+0]*g8[iy+0]*g101[iz+0];
s[1992] = + g17[ix+0]*g10[iy+0]*g100[iz+0];
s[1993] = + g16[ix+0]*g11[iy+0]*g100[iz+0];
s[1994] = + g16[ix+0]*g10[iy+0]*g101[iz+0];
s[1995] = + g17[ix+0]*g8[iy+0]*g102[iz+0];
s[1996] = + g16[ix+0]*g9[iy+0]*g102[iz+0];
s[1997] = + g16[ix+0]*g8[iy+0]*g103[iz+0];
s[1998] = + g23[ix+0]*g0[iy+0]*g104[iz+0];
s[1999] = + g22[ix+0]*g1[iy+0]*g104[iz+0];
s[2000] = + g22[ix+0]*g0[iy+0]*g105[iz+0];
s[2001] = + g21[ix+0]*g2[iy+0]*g104[iz+0];
s[2002] = + g20[ix+0]*g3[iy+0]*g104[iz+0];
s[2003] = + g20[ix+0]*g2[iy+0]*g105[iz+0];
s[2004] = + g21[ix+0]*g0[iy+0]*g106[iz+0];
s[2005] = + g20[ix+0]*g1[iy+0]*g106[iz+0];
s[2006] = + g20[ix+0]*g0[iy+0]*g107[iz+0];
s[2007] = + g19[ix+0]*g4[iy+0]*g104[iz+0];
s[2008] = + g18[ix+0]*g5[iy+0]*g104[iz+0];
s[2009] = + g18[ix+0]*g4[iy+0]*g105[iz+0];
s[2010] = + g17[ix+0]*g6[iy+0]*g104[iz+0];
s[2011] = + g16[ix+0]*g7[iy+0]*g104[iz+0];
s[2012] = + g16[ix+0]*g6[iy+0]*g105[iz+0];
s[2013] = + g17[ix+0]*g4[iy+0]*g106[iz+0];
s[2014] = + g16[ix+0]*g5[iy+0]*g106[iz+0];
s[2015] = + g16[ix+0]*g4[iy+0]*g107[iz+0];
s[2016] = + g19[ix+0]*g0[iy+0]*g108[iz+0];
s[2017] = + g18[ix+0]*g1[iy+0]*g108[iz+0];
s[2018] = + g18[ix+0]*g0[iy+0]*g109[iz+0];
s[2019] = + g17[ix+0]*g2[iy+0]*g108[iz+0];
s[2020] = + g16[ix+0]*g3[iy+0]*g108[iz+0];
s[2021] = + g16[ix+0]*g2[iy+0]*g109[iz+0];
s[2022] = + g17[ix+0]*g0[iy+0]*g110[iz+0];
s[2023] = + g16[ix+0]*g1[iy+0]*g110[iz+0];
s[2024] = + g16[ix+0]*g0[iy+0]*g111[iz+0];
s[2025] = + g15[ix+0]*g16[iy+0]*g96[iz+0];
s[2026] = + g14[ix+0]*g17[iy+0]*g96[iz+0];
s[2027] = + g14[ix+0]*g16[iy+0]*g97[iz+0];
s[2028] = + g13[ix+0]*g18[iy+0]*g96[iz+0];
s[2029] = + g12[ix+0]*g19[iy+0]*g96[iz+0];
s[2030] = + g12[ix+0]*g18[iy+0]*g97[iz+0];
s[2031] = + g13[ix+0]*g16[iy+0]*g98[iz+0];
s[2032] = + g12[ix+0]*g17[iy+0]*g98[iz+0];
s[2033] = + g12[ix+0]*g16[iy+0]*g99[iz+0];
s[2034] = + g11[ix+0]*g20[iy+0]*g96[iz+0];
s[2035] = + g10[ix+0]*g21[iy+0]*g96[iz+0];
s[2036] = + g10[ix+0]*g20[iy+0]*g97[iz+0];
s[2037] = + g9[ix+0]*g22[iy+0]*g96[iz+0];
s[2038] = + g8[ix+0]*g23[iy+0]*g96[iz+0];
s[2039] = + g8[ix+0]*g22[iy+0]*g97[iz+0];
s[2040] = + g9[ix+0]*g20[iy+0]*g98[iz+0];
s[2041] = + g8[ix+0]*g21[iy+0]*g98[iz+0];
s[2042] = + g8[ix+0]*g20[iy+0]*g99[iz+0];
s[2043] = + g11[ix+0]*g16[iy+0]*g100[iz+0];
s[2044] = + g10[ix+0]*g17[iy+0]*g100[iz+0];
s[2045] = + g10[ix+0]*g16[iy+0]*g101[iz+0];
s[2046] = + g9[ix+0]*g18[iy+0]*g100[iz+0];
s[2047] = + g8[ix+0]*g19[iy+0]*g100[iz+0];
s[2048] = + g8[ix+0]*g18[iy+0]*g101[iz+0];
s[2049] = + g9[ix+0]*g16[iy+0]*g102[iz+0];
s[2050] = + g8[ix+0]*g17[iy+0]*g102[iz+0];
s[2051] = + g8[ix+0]*g16[iy+0]*g103[iz+0];
s[2052] = + g7[ix+0]*g24[iy+0]*g96[iz+0];
s[2053] = + g6[ix+0]*g25[iy+0]*g96[iz+0];
s[2054] = + g6[ix+0]*g24[iy+0]*g97[iz+0];
s[2055] = + g5[ix+0]*g26[iy+0]*g96[iz+0];
s[2056] = + g4[ix+0]*g27[iy+0]*g96[iz+0];
s[2057] = + g4[ix+0]*g26[iy+0]*g97[iz+0];
s[2058] = + g5[ix+0]*g24[iy+0]*g98[iz+0];
s[2059] = + g4[ix+0]*g25[iy+0]*g98[iz+0];
s[2060] = + g4[ix+0]*g24[iy+0]*g99[iz+0];
s[2061] = + g3[ix+0]*g28[iy+0]*g96[iz+0];
s[2062] = + g2[ix+0]*g29[iy+0]*g96[iz+0];
s[2063] = + g2[ix+0]*g28[iy+0]*g97[iz+0];
s[2064] = + g1[ix+0]*g30[iy+0]*g96[iz+0];
s[2065] = + g0[ix+0]*g31[iy+0]*g96[iz+0];
s[2066] = + g0[ix+0]*g30[iy+0]*g97[iz+0];
s[2067] = + g1[ix+0]*g28[iy+0]*g98[iz+0];
s[2068] = + g0[ix+0]*g29[iy+0]*g98[iz+0];
s[2069] = + g0[ix+0]*g28[iy+0]*g99[iz+0];
s[2070] = + g3[ix+0]*g24[iy+0]*g100[iz+0];
s[2071] = + g2[ix+0]*g25[iy+0]*g100[iz+0];
s[2072] = + g2[ix+0]*g24[iy+0]*g101[iz+0];
s[2073] = + g1[ix+0]*g26[iy+0]*g100[iz+0];
s[2074] = + g0[ix+0]*g27[iy+0]*g100[iz+0];
s[2075] = + g0[ix+0]*g26[iy+0]*g101[iz+0];
s[2076] = + g1[ix+0]*g24[iy+0]*g102[iz+0];
s[2077] = + g0[ix+0]*g25[iy+0]*g102[iz+0];
s[2078] = + g0[ix+0]*g24[iy+0]*g103[iz+0];
s[2079] = + g7[ix+0]*g16[iy+0]*g104[iz+0];
s[2080] = + g6[ix+0]*g17[iy+0]*g104[iz+0];
s[2081] = + g6[ix+0]*g16[iy+0]*g105[iz+0];
s[2082] = + g5[ix+0]*g18[iy+0]*g104[iz+0];
s[2083] = + g4[ix+0]*g19[iy+0]*g104[iz+0];
s[2084] = + g4[ix+0]*g18[iy+0]*g105[iz+0];
s[2085] = + g5[ix+0]*g16[iy+0]*g106[iz+0];
s[2086] = + g4[ix+0]*g17[iy+0]*g106[iz+0];
s[2087] = + g4[ix+0]*g16[iy+0]*g107[iz+0];
s[2088] = + g3[ix+0]*g20[iy+0]*g104[iz+0];
s[2089] = + g2[ix+0]*g21[iy+0]*g104[iz+0];
s[2090] = + g2[ix+0]*g20[iy+0]*g105[iz+0];
s[2091] = + g1[ix+0]*g22[iy+0]*g104[iz+0];
s[2092] = + g0[ix+0]*g23[iy+0]*g104[iz+0];
s[2093] = + g0[ix+0]*g22[iy+0]*g105[iz+0];
s[2094] = + g1[ix+0]*g20[iy+0]*g106[iz+0];
s[2095] = + g0[ix+0]*g21[iy+0]*g106[iz+0];
s[2096] = + g0[ix+0]*g20[iy+0]*g107[iz+0];
s[2097] = + g3[ix+0]*g16[iy+0]*g108[iz+0];
s[2098] = + g2[ix+0]*g17[iy+0]*g108[iz+0];
s[2099] = + g2[ix+0]*g16[iy+0]*g109[iz+0];
s[2100] = + g1[ix+0]*g18[iy+0]*g108[iz+0];
s[2101] = + g0[ix+0]*g19[iy+0]*g108[iz+0];
s[2102] = + g0[ix+0]*g18[iy+0]*g109[iz+0];
s[2103] = + g1[ix+0]*g16[iy+0]*g110[iz+0];
s[2104] = + g0[ix+0]*g17[iy+0]*g110[iz+0];
s[2105] = + g0[ix+0]*g16[iy+0]*g111[iz+0];
s[2106] = + g15[ix+0]*g0[iy+0]*g112[iz+0];
s[2107] = + g14[ix+0]*g1[iy+0]*g112[iz+0];
s[2108] = + g14[ix+0]*g0[iy+0]*g113[iz+0];
s[2109] = + g13[ix+0]*g2[iy+0]*g112[iz+0];
s[2110] = + g12[ix+0]*g3[iy+0]*g112[iz+0];
s[2111] = + g12[ix+0]*g2[iy+0]*g113[iz+0];
s[2112] = + g13[ix+0]*g0[iy+0]*g114[iz+0];
s[2113] = + g12[ix+0]*g1[iy+0]*g114[iz+0];
s[2114] = + g12[ix+0]*g0[iy+0]*g115[iz+0];
s[2115] = + g11[ix+0]*g4[iy+0]*g112[iz+0];
s[2116] = + g10[ix+0]*g5[iy+0]*g112[iz+0];
s[2117] = + g10[ix+0]*g4[iy+0]*g113[iz+0];
s[2118] = + g9[ix+0]*g6[iy+0]*g112[iz+0];
s[2119] = + g8[ix+0]*g7[iy+0]*g112[iz+0];
s[2120] = + g8[ix+0]*g6[iy+0]*g113[iz+0];
s[2121] = + g9[ix+0]*g4[iy+0]*g114[iz+0];
s[2122] = + g8[ix+0]*g5[iy+0]*g114[iz+0];
s[2123] = + g8[ix+0]*g4[iy+0]*g115[iz+0];
s[2124] = + g11[ix+0]*g0[iy+0]*g116[iz+0];
s[2125] = + g10[ix+0]*g1[iy+0]*g116[iz+0];
s[2126] = + g10[ix+0]*g0[iy+0]*g117[iz+0];
s[2127] = + g9[ix+0]*g2[iy+0]*g116[iz+0];
s[2128] = + g8[ix+0]*g3[iy+0]*g116[iz+0];
s[2129] = + g8[ix+0]*g2[iy+0]*g117[iz+0];
s[2130] = + g9[ix+0]*g0[iy+0]*g118[iz+0];
s[2131] = + g8[ix+0]*g1[iy+0]*g118[iz+0];
s[2132] = + g8[ix+0]*g0[iy+0]*g119[iz+0];
s[2133] = + g7[ix+0]*g8[iy+0]*g112[iz+0];
s[2134] = + g6[ix+0]*g9[iy+0]*g112[iz+0];
s[2135] = + g6[ix+0]*g8[iy+0]*g113[iz+0];
s[2136] = + g5[ix+0]*g10[iy+0]*g112[iz+0];
s[2137] = + g4[ix+0]*g11[iy+0]*g112[iz+0];
s[2138] = + g4[ix+0]*g10[iy+0]*g113[iz+0];
s[2139] = + g5[ix+0]*g8[iy+0]*g114[iz+0];
s[2140] = + g4[ix+0]*g9[iy+0]*g114[iz+0];
s[2141] = + g4[ix+0]*g8[iy+0]*g115[iz+0];
s[2142] = + g3[ix+0]*g12[iy+0]*g112[iz+0];
s[2143] = + g2[ix+0]*g13[iy+0]*g112[iz+0];
s[2144] = + g2[ix+0]*g12[iy+0]*g113[iz+0];
s[2145] = + g1[ix+0]*g14[iy+0]*g112[iz+0];
s[2146] = + g0[ix+0]*g15[iy+0]*g112[iz+0];
s[2147] = + g0[ix+0]*g14[iy+0]*g113[iz+0];
s[2148] = + g1[ix+0]*g12[iy+0]*g114[iz+0];
s[2149] = + g0[ix+0]*g13[iy+0]*g114[iz+0];
s[2150] = + g0[ix+0]*g12[iy+0]*g115[iz+0];
s[2151] = + g3[ix+0]*g8[iy+0]*g116[iz+0];
s[2152] = + g2[ix+0]*g9[iy+0]*g116[iz+0];
s[2153] = + g2[ix+0]*g8[iy+0]*g117[iz+0];
s[2154] = + g1[ix+0]*g10[iy+0]*g116[iz+0];
s[2155] = + g0[ix+0]*g11[iy+0]*g116[iz+0];
s[2156] = + g0[ix+0]*g10[iy+0]*g117[iz+0];
s[2157] = + g1[ix+0]*g8[iy+0]*g118[iz+0];
s[2158] = + g0[ix+0]*g9[iy+0]*g118[iz+0];
s[2159] = + g0[ix+0]*g8[iy+0]*g119[iz+0];
s[2160] = + g7[ix+0]*g0[iy+0]*g120[iz+0];
s[2161] = + g6[ix+0]*g1[iy+0]*g120[iz+0];
s[2162] = + g6[ix+0]*g0[iy+0]*g121[iz+0];
s[2163] = + g5[ix+0]*g2[iy+0]*g120[iz+0];
s[2164] = + g4[ix+0]*g3[iy+0]*g120[iz+0];
s[2165] = + g4[ix+0]*g2[iy+0]*g121[iz+0];
s[2166] = + g5[ix+0]*g0[iy+0]*g122[iz+0];
s[2167] = + g4[ix+0]*g1[iy+0]*g122[iz+0];
s[2168] = + g4[ix+0]*g0[iy+0]*g123[iz+0];
s[2169] = + g3[ix+0]*g4[iy+0]*g120[iz+0];
s[2170] = + g2[ix+0]*g5[iy+0]*g120[iz+0];
s[2171] = + g2[ix+0]*g4[iy+0]*g121[iz+0];
s[2172] = + g1[ix+0]*g6[iy+0]*g120[iz+0];
s[2173] = + g0[ix+0]*g7[iy+0]*g120[iz+0];
s[2174] = + g0[ix+0]*g6[iy+0]*g121[iz+0];
s[2175] = + g1[ix+0]*g4[iy+0]*g122[iz+0];
s[2176] = + g0[ix+0]*g5[iy+0]*g122[iz+0];
s[2177] = + g0[ix+0]*g4[iy+0]*g123[iz+0];
s[2178] = + g3[ix+0]*g0[iy+0]*g124[iz+0];
s[2179] = + g2[ix+0]*g1[iy+0]*g124[iz+0];
s[2180] = + g2[ix+0]*g0[iy+0]*g125[iz+0];
s[2181] = + g1[ix+0]*g2[iy+0]*g124[iz+0];
s[2182] = + g0[ix+0]*g3[iy+0]*g124[iz+0];
s[2183] = + g0[ix+0]*g2[iy+0]*g125[iz+0];
s[2184] = + g1[ix+0]*g0[iy+0]*g126[iz+0];
s[2185] = + g0[ix+0]*g1[iy+0]*g126[iz+0];
s[2186] = + g0[ix+0]*g0[iy+0]*g127[iz+0];
if (gout_empty) {
gout[n*2187+0] = + s[0];
gout[n*2187+1] = + s[1];
gout[n*2187+2] = + s[2];
gout[n*2187+3] = + s[3];
gout[n*2187+4] = + s[4];
gout[n*2187+5] = + s[5];
gout[n*2187+6] = + s[6];
gout[n*2187+7] = + s[7];
gout[n*2187+8] = + s[8];
gout[n*2187+9] = + s[9];
gout[n*2187+10] = + s[10];
gout[n*2187+11] = + s[11];
gout[n*2187+12] = + s[12];
gout[n*2187+13] = + s[13];
gout[n*2187+14] = + s[14];
gout[n*2187+15] = + s[15];
gout[n*2187+16] = + s[16];
gout[n*2187+17] = + s[17];
gout[n*2187+18] = + s[18];
gout[n*2187+19] = + s[19];
gout[n*2187+20] = + s[20];
gout[n*2187+21] = + s[21];
gout[n*2187+22] = + s[22];
gout[n*2187+23] = + s[23];
gout[n*2187+24] = + s[24];
gout[n*2187+25] = + s[25];
gout[n*2187+26] = + s[26];
gout[n*2187+27] = + s[27];
gout[n*2187+28] = + s[28];
gout[n*2187+29] = + s[29];
gout[n*2187+30] = + s[30];
gout[n*2187+31] = + s[31];
gout[n*2187+32] = + s[32];
gout[n*2187+33] = + s[33];
gout[n*2187+34] = + s[34];
gout[n*2187+35] = + s[35];
gout[n*2187+36] = + s[36];
gout[n*2187+37] = + s[37];
gout[n*2187+38] = + s[38];
gout[n*2187+39] = + s[39];
gout[n*2187+40] = + s[40];
gout[n*2187+41] = + s[41];
gout[n*2187+42] = + s[42];
gout[n*2187+43] = + s[43];
gout[n*2187+44] = + s[44];
gout[n*2187+45] = + s[45];
gout[n*2187+46] = + s[46];
gout[n*2187+47] = + s[47];
gout[n*2187+48] = + s[48];
gout[n*2187+49] = + s[49];
gout[n*2187+50] = + s[50];
gout[n*2187+51] = + s[51];
gout[n*2187+52] = + s[52];
gout[n*2187+53] = + s[53];
gout[n*2187+54] = + s[54];
gout[n*2187+55] = + s[55];
gout[n*2187+56] = + s[56];
gout[n*2187+57] = + s[57];
gout[n*2187+58] = + s[58];
gout[n*2187+59] = + s[59];
gout[n*2187+60] = + s[60];
gout[n*2187+61] = + s[61];
gout[n*2187+62] = + s[62];
gout[n*2187+63] = + s[63];
gout[n*2187+64] = + s[64];
gout[n*2187+65] = + s[65];
gout[n*2187+66] = + s[66];
gout[n*2187+67] = + s[67];
gout[n*2187+68] = + s[68];
gout[n*2187+69] = + s[69];
gout[n*2187+70] = + s[70];
gout[n*2187+71] = + s[71];
gout[n*2187+72] = + s[72];
gout[n*2187+73] = + s[73];
gout[n*2187+74] = + s[74];
gout[n*2187+75] = + s[75];
gout[n*2187+76] = + s[76];
gout[n*2187+77] = + s[77];
gout[n*2187+78] = + s[78];
gout[n*2187+79] = + s[79];
gout[n*2187+80] = + s[80];
gout[n*2187+81] = + s[81];
gout[n*2187+82] = + s[82];
gout[n*2187+83] = + s[83];
gout[n*2187+84] = + s[84];
gout[n*2187+85] = + s[85];
gout[n*2187+86] = + s[86];
gout[n*2187+87] = + s[87];
gout[n*2187+88] = + s[88];
gout[n*2187+89] = + s[89];
gout[n*2187+90] = + s[90];
gout[n*2187+91] = + s[91];
gout[n*2187+92] = + s[92];
gout[n*2187+93] = + s[93];
gout[n*2187+94] = + s[94];
gout[n*2187+95] = + s[95];
gout[n*2187+96] = + s[96];
gout[n*2187+97] = + s[97];
gout[n*2187+98] = + s[98];
gout[n*2187+99] = + s[99];
gout[n*2187+100] = + s[100];
gout[n*2187+101] = + s[101];
gout[n*2187+102] = + s[102];
gout[n*2187+103] = + s[103];
gout[n*2187+104] = + s[104];
gout[n*2187+105] = + s[105];
gout[n*2187+106] = + s[106];
gout[n*2187+107] = + s[107];
gout[n*2187+108] = + s[108];
gout[n*2187+109] = + s[109];
gout[n*2187+110] = + s[110];
gout[n*2187+111] = + s[111];
gout[n*2187+112] = + s[112];
gout[n*2187+113] = + s[113];
gout[n*2187+114] = + s[114];
gout[n*2187+115] = + s[115];
gout[n*2187+116] = + s[116];
gout[n*2187+117] = + s[117];
gout[n*2187+118] = + s[118];
gout[n*2187+119] = + s[119];
gout[n*2187+120] = + s[120];
gout[n*2187+121] = + s[121];
gout[n*2187+122] = + s[122];
gout[n*2187+123] = + s[123];
gout[n*2187+124] = + s[124];
gout[n*2187+125] = + s[125];
gout[n*2187+126] = + s[126];
gout[n*2187+127] = + s[127];
gout[n*2187+128] = + s[128];
gout[n*2187+129] = + s[129];
gout[n*2187+130] = + s[130];
gout[n*2187+131] = + s[131];
gout[n*2187+132] = + s[132];
gout[n*2187+133] = + s[133];
gout[n*2187+134] = + s[134];
gout[n*2187+135] = + s[135];
gout[n*2187+136] = + s[136];
gout[n*2187+137] = + s[137];
gout[n*2187+138] = + s[138];
gout[n*2187+139] = + s[139];
gout[n*2187+140] = + s[140];
gout[n*2187+141] = + s[141];
gout[n*2187+142] = + s[142];
gout[n*2187+143] = + s[143];
gout[n*2187+144] = + s[144];
gout[n*2187+145] = + s[145];
gout[n*2187+146] = + s[146];
gout[n*2187+147] = + s[147];
gout[n*2187+148] = + s[148];
gout[n*2187+149] = + s[149];
gout[n*2187+150] = + s[150];
gout[n*2187+151] = + s[151];
gout[n*2187+152] = + s[152];
gout[n*2187+153] = + s[153];
gout[n*2187+154] = + s[154];
gout[n*2187+155] = + s[155];
gout[n*2187+156] = + s[156];
gout[n*2187+157] = + s[157];
gout[n*2187+158] = + s[158];
gout[n*2187+159] = + s[159];
gout[n*2187+160] = + s[160];
gout[n*2187+161] = + s[161];
gout[n*2187+162] = + s[162];
gout[n*2187+163] = + s[163];
gout[n*2187+164] = + s[164];
gout[n*2187+165] = + s[165];
gout[n*2187+166] = + s[166];
gout[n*2187+167] = + s[167];
gout[n*2187+168] = + s[168];
gout[n*2187+169] = + s[169];
gout[n*2187+170] = + s[170];
gout[n*2187+171] = + s[171];
gout[n*2187+172] = + s[172];
gout[n*2187+173] = + s[173];
gout[n*2187+174] = + s[174];
gout[n*2187+175] = + s[175];
gout[n*2187+176] = + s[176];
gout[n*2187+177] = + s[177];
gout[n*2187+178] = + s[178];
gout[n*2187+179] = + s[179];
gout[n*2187+180] = + s[180];
gout[n*2187+181] = + s[181];
gout[n*2187+182] = + s[182];
gout[n*2187+183] = + s[183];
gout[n*2187+184] = + s[184];
gout[n*2187+185] = + s[185];
gout[n*2187+186] = + s[186];
gout[n*2187+187] = + s[187];
gout[n*2187+188] = + s[188];
gout[n*2187+189] = + s[189];
gout[n*2187+190] = + s[190];
gout[n*2187+191] = + s[191];
gout[n*2187+192] = + s[192];
gout[n*2187+193] = + s[193];
gout[n*2187+194] = + s[194];
gout[n*2187+195] = + s[195];
gout[n*2187+196] = + s[196];
gout[n*2187+197] = + s[197];
gout[n*2187+198] = + s[198];
gout[n*2187+199] = + s[199];
gout[n*2187+200] = + s[200];
gout[n*2187+201] = + s[201];
gout[n*2187+202] = + s[202];
gout[n*2187+203] = + s[203];
gout[n*2187+204] = + s[204];
gout[n*2187+205] = + s[205];
gout[n*2187+206] = + s[206];
gout[n*2187+207] = + s[207];
gout[n*2187+208] = + s[208];
gout[n*2187+209] = + s[209];
gout[n*2187+210] = + s[210];
gout[n*2187+211] = + s[211];
gout[n*2187+212] = + s[212];
gout[n*2187+213] = + s[213];
gout[n*2187+214] = + s[214];
gout[n*2187+215] = + s[215];
gout[n*2187+216] = + s[216];
gout[n*2187+217] = + s[217];
gout[n*2187+218] = + s[218];
gout[n*2187+219] = + s[219];
gout[n*2187+220] = + s[220];
gout[n*2187+221] = + s[221];
gout[n*2187+222] = + s[222];
gout[n*2187+223] = + s[223];
gout[n*2187+224] = + s[224];
gout[n*2187+225] = + s[225];
gout[n*2187+226] = + s[226];
gout[n*2187+227] = + s[227];
gout[n*2187+228] = + s[228];
gout[n*2187+229] = + s[229];
gout[n*2187+230] = + s[230];
gout[n*2187+231] = + s[231];
gout[n*2187+232] = + s[232];
gout[n*2187+233] = + s[233];
gout[n*2187+234] = + s[234];
gout[n*2187+235] = + s[235];
gout[n*2187+236] = + s[236];
gout[n*2187+237] = + s[237];
gout[n*2187+238] = + s[238];
gout[n*2187+239] = + s[239];
gout[n*2187+240] = + s[240];
gout[n*2187+241] = + s[241];
gout[n*2187+242] = + s[242];
gout[n*2187+243] = + s[243];
gout[n*2187+244] = + s[244];
gout[n*2187+245] = + s[245];
gout[n*2187+246] = + s[246];
gout[n*2187+247] = + s[247];
gout[n*2187+248] = + s[248];
gout[n*2187+249] = + s[249];
gout[n*2187+250] = + s[250];
gout[n*2187+251] = + s[251];
gout[n*2187+252] = + s[252];
gout[n*2187+253] = + s[253];
gout[n*2187+254] = + s[254];
gout[n*2187+255] = + s[255];
gout[n*2187+256] = + s[256];
gout[n*2187+257] = + s[257];
gout[n*2187+258] = + s[258];
gout[n*2187+259] = + s[259];
gout[n*2187+260] = + s[260];
gout[n*2187+261] = + s[261];
gout[n*2187+262] = + s[262];
gout[n*2187+263] = + s[263];
gout[n*2187+264] = + s[264];
gout[n*2187+265] = + s[265];
gout[n*2187+266] = + s[266];
gout[n*2187+267] = + s[267];
gout[n*2187+268] = + s[268];
gout[n*2187+269] = + s[269];
gout[n*2187+270] = + s[270];
gout[n*2187+271] = + s[271];
gout[n*2187+272] = + s[272];
gout[n*2187+273] = + s[273];
gout[n*2187+274] = + s[274];
gout[n*2187+275] = + s[275];
gout[n*2187+276] = + s[276];
gout[n*2187+277] = + s[277];
gout[n*2187+278] = + s[278];
gout[n*2187+279] = + s[279];
gout[n*2187+280] = + s[280];
gout[n*2187+281] = + s[281];
gout[n*2187+282] = + s[282];
gout[n*2187+283] = + s[283];
gout[n*2187+284] = + s[284];
gout[n*2187+285] = + s[285];
gout[n*2187+286] = + s[286];
gout[n*2187+287] = + s[287];
gout[n*2187+288] = + s[288];
gout[n*2187+289] = + s[289];
gout[n*2187+290] = + s[290];
gout[n*2187+291] = + s[291];
gout[n*2187+292] = + s[292];
gout[n*2187+293] = + s[293];
gout[n*2187+294] = + s[294];
gout[n*2187+295] = + s[295];
gout[n*2187+296] = + s[296];
gout[n*2187+297] = + s[297];
gout[n*2187+298] = + s[298];
gout[n*2187+299] = + s[299];
gout[n*2187+300] = + s[300];
gout[n*2187+301] = + s[301];
gout[n*2187+302] = + s[302];
gout[n*2187+303] = + s[303];
gout[n*2187+304] = + s[304];
gout[n*2187+305] = + s[305];
gout[n*2187+306] = + s[306];
gout[n*2187+307] = + s[307];
gout[n*2187+308] = + s[308];
gout[n*2187+309] = + s[309];
gout[n*2187+310] = + s[310];
gout[n*2187+311] = + s[311];
gout[n*2187+312] = + s[312];
gout[n*2187+313] = + s[313];
gout[n*2187+314] = + s[314];
gout[n*2187+315] = + s[315];
gout[n*2187+316] = + s[316];
gout[n*2187+317] = + s[317];
gout[n*2187+318] = + s[318];
gout[n*2187+319] = + s[319];
gout[n*2187+320] = + s[320];
gout[n*2187+321] = + s[321];
gout[n*2187+322] = + s[322];
gout[n*2187+323] = + s[323];
gout[n*2187+324] = + s[324];
gout[n*2187+325] = + s[325];
gout[n*2187+326] = + s[326];
gout[n*2187+327] = + s[327];
gout[n*2187+328] = + s[328];
gout[n*2187+329] = + s[329];
gout[n*2187+330] = + s[330];
gout[n*2187+331] = + s[331];
gout[n*2187+332] = + s[332];
gout[n*2187+333] = + s[333];
gout[n*2187+334] = + s[334];
gout[n*2187+335] = + s[335];
gout[n*2187+336] = + s[336];
gout[n*2187+337] = + s[337];
gout[n*2187+338] = + s[338];
gout[n*2187+339] = + s[339];
gout[n*2187+340] = + s[340];
gout[n*2187+341] = + s[341];
gout[n*2187+342] = + s[342];
gout[n*2187+343] = + s[343];
gout[n*2187+344] = + s[344];
gout[n*2187+345] = + s[345];
gout[n*2187+346] = + s[346];
gout[n*2187+347] = + s[347];
gout[n*2187+348] = + s[348];
gout[n*2187+349] = + s[349];
gout[n*2187+350] = + s[350];
gout[n*2187+351] = + s[351];
gout[n*2187+352] = + s[352];
gout[n*2187+353] = + s[353];
gout[n*2187+354] = + s[354];
gout[n*2187+355] = + s[355];
gout[n*2187+356] = + s[356];
gout[n*2187+357] = + s[357];
gout[n*2187+358] = + s[358];
gout[n*2187+359] = + s[359];
gout[n*2187+360] = + s[360];
gout[n*2187+361] = + s[361];
gout[n*2187+362] = + s[362];
gout[n*2187+363] = + s[363];
gout[n*2187+364] = + s[364];
gout[n*2187+365] = + s[365];
gout[n*2187+366] = + s[366];
gout[n*2187+367] = + s[367];
gout[n*2187+368] = + s[368];
gout[n*2187+369] = + s[369];
gout[n*2187+370] = + s[370];
gout[n*2187+371] = + s[371];
gout[n*2187+372] = + s[372];
gout[n*2187+373] = + s[373];
gout[n*2187+374] = + s[374];
gout[n*2187+375] = + s[375];
gout[n*2187+376] = + s[376];
gout[n*2187+377] = + s[377];
gout[n*2187+378] = + s[378];
gout[n*2187+379] = + s[379];
gout[n*2187+380] = + s[380];
gout[n*2187+381] = + s[381];
gout[n*2187+382] = + s[382];
gout[n*2187+383] = + s[383];
gout[n*2187+384] = + s[384];
gout[n*2187+385] = + s[385];
gout[n*2187+386] = + s[386];
gout[n*2187+387] = + s[387];
gout[n*2187+388] = + s[388];
gout[n*2187+389] = + s[389];
gout[n*2187+390] = + s[390];
gout[n*2187+391] = + s[391];
gout[n*2187+392] = + s[392];
gout[n*2187+393] = + s[393];
gout[n*2187+394] = + s[394];
gout[n*2187+395] = + s[395];
gout[n*2187+396] = + s[396];
gout[n*2187+397] = + s[397];
gout[n*2187+398] = + s[398];
gout[n*2187+399] = + s[399];
gout[n*2187+400] = + s[400];
gout[n*2187+401] = + s[401];
gout[n*2187+402] = + s[402];
gout[n*2187+403] = + s[403];
gout[n*2187+404] = + s[404];
gout[n*2187+405] = + s[405];
gout[n*2187+406] = + s[406];
gout[n*2187+407] = + s[407];
gout[n*2187+408] = + s[408];
gout[n*2187+409] = + s[409];
gout[n*2187+410] = + s[410];
gout[n*2187+411] = + s[411];
gout[n*2187+412] = + s[412];
gout[n*2187+413] = + s[413];
gout[n*2187+414] = + s[414];
gout[n*2187+415] = + s[415];
gout[n*2187+416] = + s[416];
gout[n*2187+417] = + s[417];
gout[n*2187+418] = + s[418];
gout[n*2187+419] = + s[419];
gout[n*2187+420] = + s[420];
gout[n*2187+421] = + s[421];
gout[n*2187+422] = + s[422];
gout[n*2187+423] = + s[423];
gout[n*2187+424] = + s[424];
gout[n*2187+425] = + s[425];
gout[n*2187+426] = + s[426];
gout[n*2187+427] = + s[427];
gout[n*2187+428] = + s[428];
gout[n*2187+429] = + s[429];
gout[n*2187+430] = + s[430];
gout[n*2187+431] = + s[431];
gout[n*2187+432] = + s[432];
gout[n*2187+433] = + s[433];
gout[n*2187+434] = + s[434];
gout[n*2187+435] = + s[435];
gout[n*2187+436] = + s[436];
gout[n*2187+437] = + s[437];
gout[n*2187+438] = + s[438];
gout[n*2187+439] = + s[439];
gout[n*2187+440] = + s[440];
gout[n*2187+441] = + s[441];
gout[n*2187+442] = + s[442];
gout[n*2187+443] = + s[443];
gout[n*2187+444] = + s[444];
gout[n*2187+445] = + s[445];
gout[n*2187+446] = + s[446];
gout[n*2187+447] = + s[447];
gout[n*2187+448] = + s[448];
gout[n*2187+449] = + s[449];
gout[n*2187+450] = + s[450];
gout[n*2187+451] = + s[451];
gout[n*2187+452] = + s[452];
gout[n*2187+453] = + s[453];
gout[n*2187+454] = + s[454];
gout[n*2187+455] = + s[455];
gout[n*2187+456] = + s[456];
gout[n*2187+457] = + s[457];
gout[n*2187+458] = + s[458];
gout[n*2187+459] = + s[459];
gout[n*2187+460] = + s[460];
gout[n*2187+461] = + s[461];
gout[n*2187+462] = + s[462];
gout[n*2187+463] = + s[463];
gout[n*2187+464] = + s[464];
gout[n*2187+465] = + s[465];
gout[n*2187+466] = + s[466];
gout[n*2187+467] = + s[467];
gout[n*2187+468] = + s[468];
gout[n*2187+469] = + s[469];
gout[n*2187+470] = + s[470];
gout[n*2187+471] = + s[471];
gout[n*2187+472] = + s[472];
gout[n*2187+473] = + s[473];
gout[n*2187+474] = + s[474];
gout[n*2187+475] = + s[475];
gout[n*2187+476] = + s[476];
gout[n*2187+477] = + s[477];
gout[n*2187+478] = + s[478];
gout[n*2187+479] = + s[479];
gout[n*2187+480] = + s[480];
gout[n*2187+481] = + s[481];
gout[n*2187+482] = + s[482];
gout[n*2187+483] = + s[483];
gout[n*2187+484] = + s[484];
gout[n*2187+485] = + s[485];
gout[n*2187+486] = + s[486];
gout[n*2187+487] = + s[487];
gout[n*2187+488] = + s[488];
gout[n*2187+489] = + s[489];
gout[n*2187+490] = + s[490];
gout[n*2187+491] = + s[491];
gout[n*2187+492] = + s[492];
gout[n*2187+493] = + s[493];
gout[n*2187+494] = + s[494];
gout[n*2187+495] = + s[495];
gout[n*2187+496] = + s[496];
gout[n*2187+497] = + s[497];
gout[n*2187+498] = + s[498];
gout[n*2187+499] = + s[499];
gout[n*2187+500] = + s[500];
gout[n*2187+501] = + s[501];
gout[n*2187+502] = + s[502];
gout[n*2187+503] = + s[503];
gout[n*2187+504] = + s[504];
gout[n*2187+505] = + s[505];
gout[n*2187+506] = + s[506];
gout[n*2187+507] = + s[507];
gout[n*2187+508] = + s[508];
gout[n*2187+509] = + s[509];
gout[n*2187+510] = + s[510];
gout[n*2187+511] = + s[511];
gout[n*2187+512] = + s[512];
gout[n*2187+513] = + s[513];
gout[n*2187+514] = + s[514];
gout[n*2187+515] = + s[515];
gout[n*2187+516] = + s[516];
gout[n*2187+517] = + s[517];
gout[n*2187+518] = + s[518];
gout[n*2187+519] = + s[519];
gout[n*2187+520] = + s[520];
gout[n*2187+521] = + s[521];
gout[n*2187+522] = + s[522];
gout[n*2187+523] = + s[523];
gout[n*2187+524] = + s[524];
gout[n*2187+525] = + s[525];
gout[n*2187+526] = + s[526];
gout[n*2187+527] = + s[527];
gout[n*2187+528] = + s[528];
gout[n*2187+529] = + s[529];
gout[n*2187+530] = + s[530];
gout[n*2187+531] = + s[531];
gout[n*2187+532] = + s[532];
gout[n*2187+533] = + s[533];
gout[n*2187+534] = + s[534];
gout[n*2187+535] = + s[535];
gout[n*2187+536] = + s[536];
gout[n*2187+537] = + s[537];
gout[n*2187+538] = + s[538];
gout[n*2187+539] = + s[539];
gout[n*2187+540] = + s[540];
gout[n*2187+541] = + s[541];
gout[n*2187+542] = + s[542];
gout[n*2187+543] = + s[543];
gout[n*2187+544] = + s[544];
gout[n*2187+545] = + s[545];
gout[n*2187+546] = + s[546];
gout[n*2187+547] = + s[547];
gout[n*2187+548] = + s[548];
gout[n*2187+549] = + s[549];
gout[n*2187+550] = + s[550];
gout[n*2187+551] = + s[551];
gout[n*2187+552] = + s[552];
gout[n*2187+553] = + s[553];
gout[n*2187+554] = + s[554];
gout[n*2187+555] = + s[555];
gout[n*2187+556] = + s[556];
gout[n*2187+557] = + s[557];
gout[n*2187+558] = + s[558];
gout[n*2187+559] = + s[559];
gout[n*2187+560] = + s[560];
gout[n*2187+561] = + s[561];
gout[n*2187+562] = + s[562];
gout[n*2187+563] = + s[563];
gout[n*2187+564] = + s[564];
gout[n*2187+565] = + s[565];
gout[n*2187+566] = + s[566];
gout[n*2187+567] = + s[567];
gout[n*2187+568] = + s[568];
gout[n*2187+569] = + s[569];
gout[n*2187+570] = + s[570];
gout[n*2187+571] = + s[571];
gout[n*2187+572] = + s[572];
gout[n*2187+573] = + s[573];
gout[n*2187+574] = + s[574];
gout[n*2187+575] = + s[575];
gout[n*2187+576] = + s[576];
gout[n*2187+577] = + s[577];
gout[n*2187+578] = + s[578];
gout[n*2187+579] = + s[579];
gout[n*2187+580] = + s[580];
gout[n*2187+581] = + s[581];
gout[n*2187+582] = + s[582];
gout[n*2187+583] = + s[583];
gout[n*2187+584] = + s[584];
gout[n*2187+585] = + s[585];
gout[n*2187+586] = + s[586];
gout[n*2187+587] = + s[587];
gout[n*2187+588] = + s[588];
gout[n*2187+589] = + s[589];
gout[n*2187+590] = + s[590];
gout[n*2187+591] = + s[591];
gout[n*2187+592] = + s[592];
gout[n*2187+593] = + s[593];
gout[n*2187+594] = + s[594];
gout[n*2187+595] = + s[595];
gout[n*2187+596] = + s[596];
gout[n*2187+597] = + s[597];
gout[n*2187+598] = + s[598];
gout[n*2187+599] = + s[599];
gout[n*2187+600] = + s[600];
gout[n*2187+601] = + s[601];
gout[n*2187+602] = + s[602];
gout[n*2187+603] = + s[603];
gout[n*2187+604] = + s[604];
gout[n*2187+605] = + s[605];
gout[n*2187+606] = + s[606];
gout[n*2187+607] = + s[607];
gout[n*2187+608] = + s[608];
gout[n*2187+609] = + s[609];
gout[n*2187+610] = + s[610];
gout[n*2187+611] = + s[611];
gout[n*2187+612] = + s[612];
gout[n*2187+613] = + s[613];
gout[n*2187+614] = + s[614];
gout[n*2187+615] = + s[615];
gout[n*2187+616] = + s[616];
gout[n*2187+617] = + s[617];
gout[n*2187+618] = + s[618];
gout[n*2187+619] = + s[619];
gout[n*2187+620] = + s[620];
gout[n*2187+621] = + s[621];
gout[n*2187+622] = + s[622];
gout[n*2187+623] = + s[623];
gout[n*2187+624] = + s[624];
gout[n*2187+625] = + s[625];
gout[n*2187+626] = + s[626];
gout[n*2187+627] = + s[627];
gout[n*2187+628] = + s[628];
gout[n*2187+629] = + s[629];
gout[n*2187+630] = + s[630];
gout[n*2187+631] = + s[631];
gout[n*2187+632] = + s[632];
gout[n*2187+633] = + s[633];
gout[n*2187+634] = + s[634];
gout[n*2187+635] = + s[635];
gout[n*2187+636] = + s[636];
gout[n*2187+637] = + s[637];
gout[n*2187+638] = + s[638];
gout[n*2187+639] = + s[639];
gout[n*2187+640] = + s[640];
gout[n*2187+641] = + s[641];
gout[n*2187+642] = + s[642];
gout[n*2187+643] = + s[643];
gout[n*2187+644] = + s[644];
gout[n*2187+645] = + s[645];
gout[n*2187+646] = + s[646];
gout[n*2187+647] = + s[647];
gout[n*2187+648] = + s[648];
gout[n*2187+649] = + s[649];
gout[n*2187+650] = + s[650];
gout[n*2187+651] = + s[651];
gout[n*2187+652] = + s[652];
gout[n*2187+653] = + s[653];
gout[n*2187+654] = + s[654];
gout[n*2187+655] = + s[655];
gout[n*2187+656] = + s[656];
gout[n*2187+657] = + s[657];
gout[n*2187+658] = + s[658];
gout[n*2187+659] = + s[659];
gout[n*2187+660] = + s[660];
gout[n*2187+661] = + s[661];
gout[n*2187+662] = + s[662];
gout[n*2187+663] = + s[663];
gout[n*2187+664] = + s[664];
gout[n*2187+665] = + s[665];
gout[n*2187+666] = + s[666];
gout[n*2187+667] = + s[667];
gout[n*2187+668] = + s[668];
gout[n*2187+669] = + s[669];
gout[n*2187+670] = + s[670];
gout[n*2187+671] = + s[671];
gout[n*2187+672] = + s[672];
gout[n*2187+673] = + s[673];
gout[n*2187+674] = + s[674];
gout[n*2187+675] = + s[675];
gout[n*2187+676] = + s[676];
gout[n*2187+677] = + s[677];
gout[n*2187+678] = + s[678];
gout[n*2187+679] = + s[679];
gout[n*2187+680] = + s[680];
gout[n*2187+681] = + s[681];
gout[n*2187+682] = + s[682];
gout[n*2187+683] = + s[683];
gout[n*2187+684] = + s[684];
gout[n*2187+685] = + s[685];
gout[n*2187+686] = + s[686];
gout[n*2187+687] = + s[687];
gout[n*2187+688] = + s[688];
gout[n*2187+689] = + s[689];
gout[n*2187+690] = + s[690];
gout[n*2187+691] = + s[691];
gout[n*2187+692] = + s[692];
gout[n*2187+693] = + s[693];
gout[n*2187+694] = + s[694];
gout[n*2187+695] = + s[695];
gout[n*2187+696] = + s[696];
gout[n*2187+697] = + s[697];
gout[n*2187+698] = + s[698];
gout[n*2187+699] = + s[699];
gout[n*2187+700] = + s[700];
gout[n*2187+701] = + s[701];
gout[n*2187+702] = + s[702];
gout[n*2187+703] = + s[703];
gout[n*2187+704] = + s[704];
gout[n*2187+705] = + s[705];
gout[n*2187+706] = + s[706];
gout[n*2187+707] = + s[707];
gout[n*2187+708] = + s[708];
gout[n*2187+709] = + s[709];
gout[n*2187+710] = + s[710];
gout[n*2187+711] = + s[711];
gout[n*2187+712] = + s[712];
gout[n*2187+713] = + s[713];
gout[n*2187+714] = + s[714];
gout[n*2187+715] = + s[715];
gout[n*2187+716] = + s[716];
gout[n*2187+717] = + s[717];
gout[n*2187+718] = + s[718];
gout[n*2187+719] = + s[719];
gout[n*2187+720] = + s[720];
gout[n*2187+721] = + s[721];
gout[n*2187+722] = + s[722];
gout[n*2187+723] = + s[723];
gout[n*2187+724] = + s[724];
gout[n*2187+725] = + s[725];
gout[n*2187+726] = + s[726];
gout[n*2187+727] = + s[727];
gout[n*2187+728] = + s[728];
gout[n*2187+729] = + s[729];
gout[n*2187+730] = + s[730];
gout[n*2187+731] = + s[731];
gout[n*2187+732] = + s[732];
gout[n*2187+733] = + s[733];
gout[n*2187+734] = + s[734];
gout[n*2187+735] = + s[735];
gout[n*2187+736] = + s[736];
gout[n*2187+737] = + s[737];
gout[n*2187+738] = + s[738];
gout[n*2187+739] = + s[739];
gout[n*2187+740] = + s[740];
gout[n*2187+741] = + s[741];
gout[n*2187+742] = + s[742];
gout[n*2187+743] = + s[743];
gout[n*2187+744] = + s[744];
gout[n*2187+745] = + s[745];
gout[n*2187+746] = + s[746];
gout[n*2187+747] = + s[747];
gout[n*2187+748] = + s[748];
gout[n*2187+749] = + s[749];
gout[n*2187+750] = + s[750];
gout[n*2187+751] = + s[751];
gout[n*2187+752] = + s[752];
gout[n*2187+753] = + s[753];
gout[n*2187+754] = + s[754];
gout[n*2187+755] = + s[755];
gout[n*2187+756] = + s[756];
gout[n*2187+757] = + s[757];
gout[n*2187+758] = + s[758];
gout[n*2187+759] = + s[759];
gout[n*2187+760] = + s[760];
gout[n*2187+761] = + s[761];
gout[n*2187+762] = + s[762];
gout[n*2187+763] = + s[763];
gout[n*2187+764] = + s[764];
gout[n*2187+765] = + s[765];
gout[n*2187+766] = + s[766];
gout[n*2187+767] = + s[767];
gout[n*2187+768] = + s[768];
gout[n*2187+769] = + s[769];
gout[n*2187+770] = + s[770];
gout[n*2187+771] = + s[771];
gout[n*2187+772] = + s[772];
gout[n*2187+773] = + s[773];
gout[n*2187+774] = + s[774];
gout[n*2187+775] = + s[775];
gout[n*2187+776] = + s[776];
gout[n*2187+777] = + s[777];
gout[n*2187+778] = + s[778];
gout[n*2187+779] = + s[779];
gout[n*2187+780] = + s[780];
gout[n*2187+781] = + s[781];
gout[n*2187+782] = + s[782];
gout[n*2187+783] = + s[783];
gout[n*2187+784] = + s[784];
gout[n*2187+785] = + s[785];
gout[n*2187+786] = + s[786];
gout[n*2187+787] = + s[787];
gout[n*2187+788] = + s[788];
gout[n*2187+789] = + s[789];
gout[n*2187+790] = + s[790];
gout[n*2187+791] = + s[791];
gout[n*2187+792] = + s[792];
gout[n*2187+793] = + s[793];
gout[n*2187+794] = + s[794];
gout[n*2187+795] = + s[795];
gout[n*2187+796] = + s[796];
gout[n*2187+797] = + s[797];
gout[n*2187+798] = + s[798];
gout[n*2187+799] = + s[799];
gout[n*2187+800] = + s[800];
gout[n*2187+801] = + s[801];
gout[n*2187+802] = + s[802];
gout[n*2187+803] = + s[803];
gout[n*2187+804] = + s[804];
gout[n*2187+805] = + s[805];
gout[n*2187+806] = + s[806];
gout[n*2187+807] = + s[807];
gout[n*2187+808] = + s[808];
gout[n*2187+809] = + s[809];
gout[n*2187+810] = + s[810];
gout[n*2187+811] = + s[811];
gout[n*2187+812] = + s[812];
gout[n*2187+813] = + s[813];
gout[n*2187+814] = + s[814];
gout[n*2187+815] = + s[815];
gout[n*2187+816] = + s[816];
gout[n*2187+817] = + s[817];
gout[n*2187+818] = + s[818];
gout[n*2187+819] = + s[819];
gout[n*2187+820] = + s[820];
gout[n*2187+821] = + s[821];
gout[n*2187+822] = + s[822];
gout[n*2187+823] = + s[823];
gout[n*2187+824] = + s[824];
gout[n*2187+825] = + s[825];
gout[n*2187+826] = + s[826];
gout[n*2187+827] = + s[827];
gout[n*2187+828] = + s[828];
gout[n*2187+829] = + s[829];
gout[n*2187+830] = + s[830];
gout[n*2187+831] = + s[831];
gout[n*2187+832] = + s[832];
gout[n*2187+833] = + s[833];
gout[n*2187+834] = + s[834];
gout[n*2187+835] = + s[835];
gout[n*2187+836] = + s[836];
gout[n*2187+837] = + s[837];
gout[n*2187+838] = + s[838];
gout[n*2187+839] = + s[839];
gout[n*2187+840] = + s[840];
gout[n*2187+841] = + s[841];
gout[n*2187+842] = + s[842];
gout[n*2187+843] = + s[843];
gout[n*2187+844] = + s[844];
gout[n*2187+845] = + s[845];
gout[n*2187+846] = + s[846];
gout[n*2187+847] = + s[847];
gout[n*2187+848] = + s[848];
gout[n*2187+849] = + s[849];
gout[n*2187+850] = + s[850];
gout[n*2187+851] = + s[851];
gout[n*2187+852] = + s[852];
gout[n*2187+853] = + s[853];
gout[n*2187+854] = + s[854];
gout[n*2187+855] = + s[855];
gout[n*2187+856] = + s[856];
gout[n*2187+857] = + s[857];
gout[n*2187+858] = + s[858];
gout[n*2187+859] = + s[859];
gout[n*2187+860] = + s[860];
gout[n*2187+861] = + s[861];
gout[n*2187+862] = + s[862];
gout[n*2187+863] = + s[863];
gout[n*2187+864] = + s[864];
gout[n*2187+865] = + s[865];
gout[n*2187+866] = + s[866];
gout[n*2187+867] = + s[867];
gout[n*2187+868] = + s[868];
gout[n*2187+869] = + s[869];
gout[n*2187+870] = + s[870];
gout[n*2187+871] = + s[871];
gout[n*2187+872] = + s[872];
gout[n*2187+873] = + s[873];
gout[n*2187+874] = + s[874];
gout[n*2187+875] = + s[875];
gout[n*2187+876] = + s[876];
gout[n*2187+877] = + s[877];
gout[n*2187+878] = + s[878];
gout[n*2187+879] = + s[879];
gout[n*2187+880] = + s[880];
gout[n*2187+881] = + s[881];
gout[n*2187+882] = + s[882];
gout[n*2187+883] = + s[883];
gout[n*2187+884] = + s[884];
gout[n*2187+885] = + s[885];
gout[n*2187+886] = + s[886];
gout[n*2187+887] = + s[887];
gout[n*2187+888] = + s[888];
gout[n*2187+889] = + s[889];
gout[n*2187+890] = + s[890];
gout[n*2187+891] = + s[891];
gout[n*2187+892] = + s[892];
gout[n*2187+893] = + s[893];
gout[n*2187+894] = + s[894];
gout[n*2187+895] = + s[895];
gout[n*2187+896] = + s[896];
gout[n*2187+897] = + s[897];
gout[n*2187+898] = + s[898];
gout[n*2187+899] = + s[899];
gout[n*2187+900] = + s[900];
gout[n*2187+901] = + s[901];
gout[n*2187+902] = + s[902];
gout[n*2187+903] = + s[903];
gout[n*2187+904] = + s[904];
gout[n*2187+905] = + s[905];
gout[n*2187+906] = + s[906];
gout[n*2187+907] = + s[907];
gout[n*2187+908] = + s[908];
gout[n*2187+909] = + s[909];
gout[n*2187+910] = + s[910];
gout[n*2187+911] = + s[911];
gout[n*2187+912] = + s[912];
gout[n*2187+913] = + s[913];
gout[n*2187+914] = + s[914];
gout[n*2187+915] = + s[915];
gout[n*2187+916] = + s[916];
gout[n*2187+917] = + s[917];
gout[n*2187+918] = + s[918];
gout[n*2187+919] = + s[919];
gout[n*2187+920] = + s[920];
gout[n*2187+921] = + s[921];
gout[n*2187+922] = + s[922];
gout[n*2187+923] = + s[923];
gout[n*2187+924] = + s[924];
gout[n*2187+925] = + s[925];
gout[n*2187+926] = + s[926];
gout[n*2187+927] = + s[927];
gout[n*2187+928] = + s[928];
gout[n*2187+929] = + s[929];
gout[n*2187+930] = + s[930];
gout[n*2187+931] = + s[931];
gout[n*2187+932] = + s[932];
gout[n*2187+933] = + s[933];
gout[n*2187+934] = + s[934];
gout[n*2187+935] = + s[935];
gout[n*2187+936] = + s[936];
gout[n*2187+937] = + s[937];
gout[n*2187+938] = + s[938];
gout[n*2187+939] = + s[939];
gout[n*2187+940] = + s[940];
gout[n*2187+941] = + s[941];
gout[n*2187+942] = + s[942];
gout[n*2187+943] = + s[943];
gout[n*2187+944] = + s[944];
gout[n*2187+945] = + s[945];
gout[n*2187+946] = + s[946];
gout[n*2187+947] = + s[947];
gout[n*2187+948] = + s[948];
gout[n*2187+949] = + s[949];
gout[n*2187+950] = + s[950];
gout[n*2187+951] = + s[951];
gout[n*2187+952] = + s[952];
gout[n*2187+953] = + s[953];
gout[n*2187+954] = + s[954];
gout[n*2187+955] = + s[955];
gout[n*2187+956] = + s[956];
gout[n*2187+957] = + s[957];
gout[n*2187+958] = + s[958];
gout[n*2187+959] = + s[959];
gout[n*2187+960] = + s[960];
gout[n*2187+961] = + s[961];
gout[n*2187+962] = + s[962];
gout[n*2187+963] = + s[963];
gout[n*2187+964] = + s[964];
gout[n*2187+965] = + s[965];
gout[n*2187+966] = + s[966];
gout[n*2187+967] = + s[967];
gout[n*2187+968] = + s[968];
gout[n*2187+969] = + s[969];
gout[n*2187+970] = + s[970];
gout[n*2187+971] = + s[971];
gout[n*2187+972] = + s[972];
gout[n*2187+973] = + s[973];
gout[n*2187+974] = + s[974];
gout[n*2187+975] = + s[975];
gout[n*2187+976] = + s[976];
gout[n*2187+977] = + s[977];
gout[n*2187+978] = + s[978];
gout[n*2187+979] = + s[979];
gout[n*2187+980] = + s[980];
gout[n*2187+981] = + s[981];
gout[n*2187+982] = + s[982];
gout[n*2187+983] = + s[983];
gout[n*2187+984] = + s[984];
gout[n*2187+985] = + s[985];
gout[n*2187+986] = + s[986];
gout[n*2187+987] = + s[987];
gout[n*2187+988] = + s[988];
gout[n*2187+989] = + s[989];
gout[n*2187+990] = + s[990];
gout[n*2187+991] = + s[991];
gout[n*2187+992] = + s[992];
gout[n*2187+993] = + s[993];
gout[n*2187+994] = + s[994];
gout[n*2187+995] = + s[995];
gout[n*2187+996] = + s[996];
gout[n*2187+997] = + s[997];
gout[n*2187+998] = + s[998];
gout[n*2187+999] = + s[999];
gout[n*2187+1000] = + s[1000];
gout[n*2187+1001] = + s[1001];
gout[n*2187+1002] = + s[1002];
gout[n*2187+1003] = + s[1003];
gout[n*2187+1004] = + s[1004];
gout[n*2187+1005] = + s[1005];
gout[n*2187+1006] = + s[1006];
gout[n*2187+1007] = + s[1007];
gout[n*2187+1008] = + s[1008];
gout[n*2187+1009] = + s[1009];
gout[n*2187+1010] = + s[1010];
gout[n*2187+1011] = + s[1011];
gout[n*2187+1012] = + s[1012];
gout[n*2187+1013] = + s[1013];
gout[n*2187+1014] = + s[1014];
gout[n*2187+1015] = + s[1015];
gout[n*2187+1016] = + s[1016];
gout[n*2187+1017] = + s[1017];
gout[n*2187+1018] = + s[1018];
gout[n*2187+1019] = + s[1019];
gout[n*2187+1020] = + s[1020];
gout[n*2187+1021] = + s[1021];
gout[n*2187+1022] = + s[1022];
gout[n*2187+1023] = + s[1023];
gout[n*2187+1024] = + s[1024];
gout[n*2187+1025] = + s[1025];
gout[n*2187+1026] = + s[1026];
gout[n*2187+1027] = + s[1027];
gout[n*2187+1028] = + s[1028];
gout[n*2187+1029] = + s[1029];
gout[n*2187+1030] = + s[1030];
gout[n*2187+1031] = + s[1031];
gout[n*2187+1032] = + s[1032];
gout[n*2187+1033] = + s[1033];
gout[n*2187+1034] = + s[1034];
gout[n*2187+1035] = + s[1035];
gout[n*2187+1036] = + s[1036];
gout[n*2187+1037] = + s[1037];
gout[n*2187+1038] = + s[1038];
gout[n*2187+1039] = + s[1039];
gout[n*2187+1040] = + s[1040];
gout[n*2187+1041] = + s[1041];
gout[n*2187+1042] = + s[1042];
gout[n*2187+1043] = + s[1043];
gout[n*2187+1044] = + s[1044];
gout[n*2187+1045] = + s[1045];
gout[n*2187+1046] = + s[1046];
gout[n*2187+1047] = + s[1047];
gout[n*2187+1048] = + s[1048];
gout[n*2187+1049] = + s[1049];
gout[n*2187+1050] = + s[1050];
gout[n*2187+1051] = + s[1051];
gout[n*2187+1052] = + s[1052];
gout[n*2187+1053] = + s[1053];
gout[n*2187+1054] = + s[1054];
gout[n*2187+1055] = + s[1055];
gout[n*2187+1056] = + s[1056];
gout[n*2187+1057] = + s[1057];
gout[n*2187+1058] = + s[1058];
gout[n*2187+1059] = + s[1059];
gout[n*2187+1060] = + s[1060];
gout[n*2187+1061] = + s[1061];
gout[n*2187+1062] = + s[1062];
gout[n*2187+1063] = + s[1063];
gout[n*2187+1064] = + s[1064];
gout[n*2187+1065] = + s[1065];
gout[n*2187+1066] = + s[1066];
gout[n*2187+1067] = + s[1067];
gout[n*2187+1068] = + s[1068];
gout[n*2187+1069] = + s[1069];
gout[n*2187+1070] = + s[1070];
gout[n*2187+1071] = + s[1071];
gout[n*2187+1072] = + s[1072];
gout[n*2187+1073] = + s[1073];
gout[n*2187+1074] = + s[1074];
gout[n*2187+1075] = + s[1075];
gout[n*2187+1076] = + s[1076];
gout[n*2187+1077] = + s[1077];
gout[n*2187+1078] = + s[1078];
gout[n*2187+1079] = + s[1079];
gout[n*2187+1080] = + s[1080];
gout[n*2187+1081] = + s[1081];
gout[n*2187+1082] = + s[1082];
gout[n*2187+1083] = + s[1083];
gout[n*2187+1084] = + s[1084];
gout[n*2187+1085] = + s[1085];
gout[n*2187+1086] = + s[1086];
gout[n*2187+1087] = + s[1087];
gout[n*2187+1088] = + s[1088];
gout[n*2187+1089] = + s[1089];
gout[n*2187+1090] = + s[1090];
gout[n*2187+1091] = + s[1091];
gout[n*2187+1092] = + s[1092];
gout[n*2187+1093] = + s[1093];
gout[n*2187+1094] = + s[1094];
gout[n*2187+1095] = + s[1095];
gout[n*2187+1096] = + s[1096];
gout[n*2187+1097] = + s[1097];
gout[n*2187+1098] = + s[1098];
gout[n*2187+1099] = + s[1099];
gout[n*2187+1100] = + s[1100];
gout[n*2187+1101] = + s[1101];
gout[n*2187+1102] = + s[1102];
gout[n*2187+1103] = + s[1103];
gout[n*2187+1104] = + s[1104];
gout[n*2187+1105] = + s[1105];
gout[n*2187+1106] = + s[1106];
gout[n*2187+1107] = + s[1107];
gout[n*2187+1108] = + s[1108];
gout[n*2187+1109] = + s[1109];
gout[n*2187+1110] = + s[1110];
gout[n*2187+1111] = + s[1111];
gout[n*2187+1112] = + s[1112];
gout[n*2187+1113] = + s[1113];
gout[n*2187+1114] = + s[1114];
gout[n*2187+1115] = + s[1115];
gout[n*2187+1116] = + s[1116];
gout[n*2187+1117] = + s[1117];
gout[n*2187+1118] = + s[1118];
gout[n*2187+1119] = + s[1119];
gout[n*2187+1120] = + s[1120];
gout[n*2187+1121] = + s[1121];
gout[n*2187+1122] = + s[1122];
gout[n*2187+1123] = + s[1123];
gout[n*2187+1124] = + s[1124];
gout[n*2187+1125] = + s[1125];
gout[n*2187+1126] = + s[1126];
gout[n*2187+1127] = + s[1127];
gout[n*2187+1128] = + s[1128];
gout[n*2187+1129] = + s[1129];
gout[n*2187+1130] = + s[1130];
gout[n*2187+1131] = + s[1131];
gout[n*2187+1132] = + s[1132];
gout[n*2187+1133] = + s[1133];
gout[n*2187+1134] = + s[1134];
gout[n*2187+1135] = + s[1135];
gout[n*2187+1136] = + s[1136];
gout[n*2187+1137] = + s[1137];
gout[n*2187+1138] = + s[1138];
gout[n*2187+1139] = + s[1139];
gout[n*2187+1140] = + s[1140];
gout[n*2187+1141] = + s[1141];
gout[n*2187+1142] = + s[1142];
gout[n*2187+1143] = + s[1143];
gout[n*2187+1144] = + s[1144];
gout[n*2187+1145] = + s[1145];
gout[n*2187+1146] = + s[1146];
gout[n*2187+1147] = + s[1147];
gout[n*2187+1148] = + s[1148];
gout[n*2187+1149] = + s[1149];
gout[n*2187+1150] = + s[1150];
gout[n*2187+1151] = + s[1151];
gout[n*2187+1152] = + s[1152];
gout[n*2187+1153] = + s[1153];
gout[n*2187+1154] = + s[1154];
gout[n*2187+1155] = + s[1155];
gout[n*2187+1156] = + s[1156];
gout[n*2187+1157] = + s[1157];
gout[n*2187+1158] = + s[1158];
gout[n*2187+1159] = + s[1159];
gout[n*2187+1160] = + s[1160];
gout[n*2187+1161] = + s[1161];
gout[n*2187+1162] = + s[1162];
gout[n*2187+1163] = + s[1163];
gout[n*2187+1164] = + s[1164];
gout[n*2187+1165] = + s[1165];
gout[n*2187+1166] = + s[1166];
gout[n*2187+1167] = + s[1167];
gout[n*2187+1168] = + s[1168];
gout[n*2187+1169] = + s[1169];
gout[n*2187+1170] = + s[1170];
gout[n*2187+1171] = + s[1171];
gout[n*2187+1172] = + s[1172];
gout[n*2187+1173] = + s[1173];
gout[n*2187+1174] = + s[1174];
gout[n*2187+1175] = + s[1175];
gout[n*2187+1176] = + s[1176];
gout[n*2187+1177] = + s[1177];
gout[n*2187+1178] = + s[1178];
gout[n*2187+1179] = + s[1179];
gout[n*2187+1180] = + s[1180];
gout[n*2187+1181] = + s[1181];
gout[n*2187+1182] = + s[1182];
gout[n*2187+1183] = + s[1183];
gout[n*2187+1184] = + s[1184];
gout[n*2187+1185] = + s[1185];
gout[n*2187+1186] = + s[1186];
gout[n*2187+1187] = + s[1187];
gout[n*2187+1188] = + s[1188];
gout[n*2187+1189] = + s[1189];
gout[n*2187+1190] = + s[1190];
gout[n*2187+1191] = + s[1191];
gout[n*2187+1192] = + s[1192];
gout[n*2187+1193] = + s[1193];
gout[n*2187+1194] = + s[1194];
gout[n*2187+1195] = + s[1195];
gout[n*2187+1196] = + s[1196];
gout[n*2187+1197] = + s[1197];
gout[n*2187+1198] = + s[1198];
gout[n*2187+1199] = + s[1199];
gout[n*2187+1200] = + s[1200];
gout[n*2187+1201] = + s[1201];
gout[n*2187+1202] = + s[1202];
gout[n*2187+1203] = + s[1203];
gout[n*2187+1204] = + s[1204];
gout[n*2187+1205] = + s[1205];
gout[n*2187+1206] = + s[1206];
gout[n*2187+1207] = + s[1207];
gout[n*2187+1208] = + s[1208];
gout[n*2187+1209] = + s[1209];
gout[n*2187+1210] = + s[1210];
gout[n*2187+1211] = + s[1211];
gout[n*2187+1212] = + s[1212];
gout[n*2187+1213] = + s[1213];
gout[n*2187+1214] = + s[1214];
gout[n*2187+1215] = + s[1215];
gout[n*2187+1216] = + s[1216];
gout[n*2187+1217] = + s[1217];
gout[n*2187+1218] = + s[1218];
gout[n*2187+1219] = + s[1219];
gout[n*2187+1220] = + s[1220];
gout[n*2187+1221] = + s[1221];
gout[n*2187+1222] = + s[1222];
gout[n*2187+1223] = + s[1223];
gout[n*2187+1224] = + s[1224];
gout[n*2187+1225] = + s[1225];
gout[n*2187+1226] = + s[1226];
gout[n*2187+1227] = + s[1227];
gout[n*2187+1228] = + s[1228];
gout[n*2187+1229] = + s[1229];
gout[n*2187+1230] = + s[1230];
gout[n*2187+1231] = + s[1231];
gout[n*2187+1232] = + s[1232];
gout[n*2187+1233] = + s[1233];
gout[n*2187+1234] = + s[1234];
gout[n*2187+1235] = + s[1235];
gout[n*2187+1236] = + s[1236];
gout[n*2187+1237] = + s[1237];
gout[n*2187+1238] = + s[1238];
gout[n*2187+1239] = + s[1239];
gout[n*2187+1240] = + s[1240];
gout[n*2187+1241] = + s[1241];
gout[n*2187+1242] = + s[1242];
gout[n*2187+1243] = + s[1243];
gout[n*2187+1244] = + s[1244];
gout[n*2187+1245] = + s[1245];
gout[n*2187+1246] = + s[1246];
gout[n*2187+1247] = + s[1247];
gout[n*2187+1248] = + s[1248];
gout[n*2187+1249] = + s[1249];
gout[n*2187+1250] = + s[1250];
gout[n*2187+1251] = + s[1251];
gout[n*2187+1252] = + s[1252];
gout[n*2187+1253] = + s[1253];
gout[n*2187+1254] = + s[1254];
gout[n*2187+1255] = + s[1255];
gout[n*2187+1256] = + s[1256];
gout[n*2187+1257] = + s[1257];
gout[n*2187+1258] = + s[1258];
gout[n*2187+1259] = + s[1259];
gout[n*2187+1260] = + s[1260];
gout[n*2187+1261] = + s[1261];
gout[n*2187+1262] = + s[1262];
gout[n*2187+1263] = + s[1263];
gout[n*2187+1264] = + s[1264];
gout[n*2187+1265] = + s[1265];
gout[n*2187+1266] = + s[1266];
gout[n*2187+1267] = + s[1267];
gout[n*2187+1268] = + s[1268];
gout[n*2187+1269] = + s[1269];
gout[n*2187+1270] = + s[1270];
gout[n*2187+1271] = + s[1271];
gout[n*2187+1272] = + s[1272];
gout[n*2187+1273] = + s[1273];
gout[n*2187+1274] = + s[1274];
gout[n*2187+1275] = + s[1275];
gout[n*2187+1276] = + s[1276];
gout[n*2187+1277] = + s[1277];
gout[n*2187+1278] = + s[1278];
gout[n*2187+1279] = + s[1279];
gout[n*2187+1280] = + s[1280];
gout[n*2187+1281] = + s[1281];
gout[n*2187+1282] = + s[1282];
gout[n*2187+1283] = + s[1283];
gout[n*2187+1284] = + s[1284];
gout[n*2187+1285] = + s[1285];
gout[n*2187+1286] = + s[1286];
gout[n*2187+1287] = + s[1287];
gout[n*2187+1288] = + s[1288];
gout[n*2187+1289] = + s[1289];
gout[n*2187+1290] = + s[1290];
gout[n*2187+1291] = + s[1291];
gout[n*2187+1292] = + s[1292];
gout[n*2187+1293] = + s[1293];
gout[n*2187+1294] = + s[1294];
gout[n*2187+1295] = + s[1295];
gout[n*2187+1296] = + s[1296];
gout[n*2187+1297] = + s[1297];
gout[n*2187+1298] = + s[1298];
gout[n*2187+1299] = + s[1299];
gout[n*2187+1300] = + s[1300];
gout[n*2187+1301] = + s[1301];
gout[n*2187+1302] = + s[1302];
gout[n*2187+1303] = + s[1303];
gout[n*2187+1304] = + s[1304];
gout[n*2187+1305] = + s[1305];
gout[n*2187+1306] = + s[1306];
gout[n*2187+1307] = + s[1307];
gout[n*2187+1308] = + s[1308];
gout[n*2187+1309] = + s[1309];
gout[n*2187+1310] = + s[1310];
gout[n*2187+1311] = + s[1311];
gout[n*2187+1312] = + s[1312];
gout[n*2187+1313] = + s[1313];
gout[n*2187+1314] = + s[1314];
gout[n*2187+1315] = + s[1315];
gout[n*2187+1316] = + s[1316];
gout[n*2187+1317] = + s[1317];
gout[n*2187+1318] = + s[1318];
gout[n*2187+1319] = + s[1319];
gout[n*2187+1320] = + s[1320];
gout[n*2187+1321] = + s[1321];
gout[n*2187+1322] = + s[1322];
gout[n*2187+1323] = + s[1323];
gout[n*2187+1324] = + s[1324];
gout[n*2187+1325] = + s[1325];
gout[n*2187+1326] = + s[1326];
gout[n*2187+1327] = + s[1327];
gout[n*2187+1328] = + s[1328];
gout[n*2187+1329] = + s[1329];
gout[n*2187+1330] = + s[1330];
gout[n*2187+1331] = + s[1331];
gout[n*2187+1332] = + s[1332];
gout[n*2187+1333] = + s[1333];
gout[n*2187+1334] = + s[1334];
gout[n*2187+1335] = + s[1335];
gout[n*2187+1336] = + s[1336];
gout[n*2187+1337] = + s[1337];
gout[n*2187+1338] = + s[1338];
gout[n*2187+1339] = + s[1339];
gout[n*2187+1340] = + s[1340];
gout[n*2187+1341] = + s[1341];
gout[n*2187+1342] = + s[1342];
gout[n*2187+1343] = + s[1343];
gout[n*2187+1344] = + s[1344];
gout[n*2187+1345] = + s[1345];
gout[n*2187+1346] = + s[1346];
gout[n*2187+1347] = + s[1347];
gout[n*2187+1348] = + s[1348];
gout[n*2187+1349] = + s[1349];
gout[n*2187+1350] = + s[1350];
gout[n*2187+1351] = + s[1351];
gout[n*2187+1352] = + s[1352];
gout[n*2187+1353] = + s[1353];
gout[n*2187+1354] = + s[1354];
gout[n*2187+1355] = + s[1355];
gout[n*2187+1356] = + s[1356];
gout[n*2187+1357] = + s[1357];
gout[n*2187+1358] = + s[1358];
gout[n*2187+1359] = + s[1359];
gout[n*2187+1360] = + s[1360];
gout[n*2187+1361] = + s[1361];
gout[n*2187+1362] = + s[1362];
gout[n*2187+1363] = + s[1363];
gout[n*2187+1364] = + s[1364];
gout[n*2187+1365] = + s[1365];
gout[n*2187+1366] = + s[1366];
gout[n*2187+1367] = + s[1367];
gout[n*2187+1368] = + s[1368];
gout[n*2187+1369] = + s[1369];
gout[n*2187+1370] = + s[1370];
gout[n*2187+1371] = + s[1371];
gout[n*2187+1372] = + s[1372];
gout[n*2187+1373] = + s[1373];
gout[n*2187+1374] = + s[1374];
gout[n*2187+1375] = + s[1375];
gout[n*2187+1376] = + s[1376];
gout[n*2187+1377] = + s[1377];
gout[n*2187+1378] = + s[1378];
gout[n*2187+1379] = + s[1379];
gout[n*2187+1380] = + s[1380];
gout[n*2187+1381] = + s[1381];
gout[n*2187+1382] = + s[1382];
gout[n*2187+1383] = + s[1383];
gout[n*2187+1384] = + s[1384];
gout[n*2187+1385] = + s[1385];
gout[n*2187+1386] = + s[1386];
gout[n*2187+1387] = + s[1387];
gout[n*2187+1388] = + s[1388];
gout[n*2187+1389] = + s[1389];
gout[n*2187+1390] = + s[1390];
gout[n*2187+1391] = + s[1391];
gout[n*2187+1392] = + s[1392];
gout[n*2187+1393] = + s[1393];
gout[n*2187+1394] = + s[1394];
gout[n*2187+1395] = + s[1395];
gout[n*2187+1396] = + s[1396];
gout[n*2187+1397] = + s[1397];
gout[n*2187+1398] = + s[1398];
gout[n*2187+1399] = + s[1399];
gout[n*2187+1400] = + s[1400];
gout[n*2187+1401] = + s[1401];
gout[n*2187+1402] = + s[1402];
gout[n*2187+1403] = + s[1403];
gout[n*2187+1404] = + s[1404];
gout[n*2187+1405] = + s[1405];
gout[n*2187+1406] = + s[1406];
gout[n*2187+1407] = + s[1407];
gout[n*2187+1408] = + s[1408];
gout[n*2187+1409] = + s[1409];
gout[n*2187+1410] = + s[1410];
gout[n*2187+1411] = + s[1411];
gout[n*2187+1412] = + s[1412];
gout[n*2187+1413] = + s[1413];
gout[n*2187+1414] = + s[1414];
gout[n*2187+1415] = + s[1415];
gout[n*2187+1416] = + s[1416];
gout[n*2187+1417] = + s[1417];
gout[n*2187+1418] = + s[1418];
gout[n*2187+1419] = + s[1419];
gout[n*2187+1420] = + s[1420];
gout[n*2187+1421] = + s[1421];
gout[n*2187+1422] = + s[1422];
gout[n*2187+1423] = + s[1423];
gout[n*2187+1424] = + s[1424];
gout[n*2187+1425] = + s[1425];
gout[n*2187+1426] = + s[1426];
gout[n*2187+1427] = + s[1427];
gout[n*2187+1428] = + s[1428];
gout[n*2187+1429] = + s[1429];
gout[n*2187+1430] = + s[1430];
gout[n*2187+1431] = + s[1431];
gout[n*2187+1432] = + s[1432];
gout[n*2187+1433] = + s[1433];
gout[n*2187+1434] = + s[1434];
gout[n*2187+1435] = + s[1435];
gout[n*2187+1436] = + s[1436];
gout[n*2187+1437] = + s[1437];
gout[n*2187+1438] = + s[1438];
gout[n*2187+1439] = + s[1439];
gout[n*2187+1440] = + s[1440];
gout[n*2187+1441] = + s[1441];
gout[n*2187+1442] = + s[1442];
gout[n*2187+1443] = + s[1443];
gout[n*2187+1444] = + s[1444];
gout[n*2187+1445] = + s[1445];
gout[n*2187+1446] = + s[1446];
gout[n*2187+1447] = + s[1447];
gout[n*2187+1448] = + s[1448];
gout[n*2187+1449] = + s[1449];
gout[n*2187+1450] = + s[1450];
gout[n*2187+1451] = + s[1451];
gout[n*2187+1452] = + s[1452];
gout[n*2187+1453] = + s[1453];
gout[n*2187+1454] = + s[1454];
gout[n*2187+1455] = + s[1455];
gout[n*2187+1456] = + s[1456];
gout[n*2187+1457] = + s[1457];
gout[n*2187+1458] = + s[1458];
gout[n*2187+1459] = + s[1459];
gout[n*2187+1460] = + s[1460];
gout[n*2187+1461] = + s[1461];
gout[n*2187+1462] = + s[1462];
gout[n*2187+1463] = + s[1463];
gout[n*2187+1464] = + s[1464];
gout[n*2187+1465] = + s[1465];
gout[n*2187+1466] = + s[1466];
gout[n*2187+1467] = + s[1467];
gout[n*2187+1468] = + s[1468];
gout[n*2187+1469] = + s[1469];
gout[n*2187+1470] = + s[1470];
gout[n*2187+1471] = + s[1471];
gout[n*2187+1472] = + s[1472];
gout[n*2187+1473] = + s[1473];
gout[n*2187+1474] = + s[1474];
gout[n*2187+1475] = + s[1475];
gout[n*2187+1476] = + s[1476];
gout[n*2187+1477] = + s[1477];
gout[n*2187+1478] = + s[1478];
gout[n*2187+1479] = + s[1479];
gout[n*2187+1480] = + s[1480];
gout[n*2187+1481] = + s[1481];
gout[n*2187+1482] = + s[1482];
gout[n*2187+1483] = + s[1483];
gout[n*2187+1484] = + s[1484];
gout[n*2187+1485] = + s[1485];
gout[n*2187+1486] = + s[1486];
gout[n*2187+1487] = + s[1487];
gout[n*2187+1488] = + s[1488];
gout[n*2187+1489] = + s[1489];
gout[n*2187+1490] = + s[1490];
gout[n*2187+1491] = + s[1491];
gout[n*2187+1492] = + s[1492];
gout[n*2187+1493] = + s[1493];
gout[n*2187+1494] = + s[1494];
gout[n*2187+1495] = + s[1495];
gout[n*2187+1496] = + s[1496];
gout[n*2187+1497] = + s[1497];
gout[n*2187+1498] = + s[1498];
gout[n*2187+1499] = + s[1499];
gout[n*2187+1500] = + s[1500];
gout[n*2187+1501] = + s[1501];
gout[n*2187+1502] = + s[1502];
gout[n*2187+1503] = + s[1503];
gout[n*2187+1504] = + s[1504];
gout[n*2187+1505] = + s[1505];
gout[n*2187+1506] = + s[1506];
gout[n*2187+1507] = + s[1507];
gout[n*2187+1508] = + s[1508];
gout[n*2187+1509] = + s[1509];
gout[n*2187+1510] = + s[1510];
gout[n*2187+1511] = + s[1511];
gout[n*2187+1512] = + s[1512];
gout[n*2187+1513] = + s[1513];
gout[n*2187+1514] = + s[1514];
gout[n*2187+1515] = + s[1515];
gout[n*2187+1516] = + s[1516];
gout[n*2187+1517] = + s[1517];
gout[n*2187+1518] = + s[1518];
gout[n*2187+1519] = + s[1519];
gout[n*2187+1520] = + s[1520];
gout[n*2187+1521] = + s[1521];
gout[n*2187+1522] = + s[1522];
gout[n*2187+1523] = + s[1523];
gout[n*2187+1524] = + s[1524];
gout[n*2187+1525] = + s[1525];
gout[n*2187+1526] = + s[1526];
gout[n*2187+1527] = + s[1527];
gout[n*2187+1528] = + s[1528];
gout[n*2187+1529] = + s[1529];
gout[n*2187+1530] = + s[1530];
gout[n*2187+1531] = + s[1531];
gout[n*2187+1532] = + s[1532];
gout[n*2187+1533] = + s[1533];
gout[n*2187+1534] = + s[1534];
gout[n*2187+1535] = + s[1535];
gout[n*2187+1536] = + s[1536];
gout[n*2187+1537] = + s[1537];
gout[n*2187+1538] = + s[1538];
gout[n*2187+1539] = + s[1539];
gout[n*2187+1540] = + s[1540];
gout[n*2187+1541] = + s[1541];
gout[n*2187+1542] = + s[1542];
gout[n*2187+1543] = + s[1543];
gout[n*2187+1544] = + s[1544];
gout[n*2187+1545] = + s[1545];
gout[n*2187+1546] = + s[1546];
gout[n*2187+1547] = + s[1547];
gout[n*2187+1548] = + s[1548];
gout[n*2187+1549] = + s[1549];
gout[n*2187+1550] = + s[1550];
gout[n*2187+1551] = + s[1551];
gout[n*2187+1552] = + s[1552];
gout[n*2187+1553] = + s[1553];
gout[n*2187+1554] = + s[1554];
gout[n*2187+1555] = + s[1555];
gout[n*2187+1556] = + s[1556];
gout[n*2187+1557] = + s[1557];
gout[n*2187+1558] = + s[1558];
gout[n*2187+1559] = + s[1559];
gout[n*2187+1560] = + s[1560];
gout[n*2187+1561] = + s[1561];
gout[n*2187+1562] = + s[1562];
gout[n*2187+1563] = + s[1563];
gout[n*2187+1564] = + s[1564];
gout[n*2187+1565] = + s[1565];
gout[n*2187+1566] = + s[1566];
gout[n*2187+1567] = + s[1567];
gout[n*2187+1568] = + s[1568];
gout[n*2187+1569] = + s[1569];
gout[n*2187+1570] = + s[1570];
gout[n*2187+1571] = + s[1571];
gout[n*2187+1572] = + s[1572];
gout[n*2187+1573] = + s[1573];
gout[n*2187+1574] = + s[1574];
gout[n*2187+1575] = + s[1575];
gout[n*2187+1576] = + s[1576];
gout[n*2187+1577] = + s[1577];
gout[n*2187+1578] = + s[1578];
gout[n*2187+1579] = + s[1579];
gout[n*2187+1580] = + s[1580];
gout[n*2187+1581] = + s[1581];
gout[n*2187+1582] = + s[1582];
gout[n*2187+1583] = + s[1583];
gout[n*2187+1584] = + s[1584];
gout[n*2187+1585] = + s[1585];
gout[n*2187+1586] = + s[1586];
gout[n*2187+1587] = + s[1587];
gout[n*2187+1588] = + s[1588];
gout[n*2187+1589] = + s[1589];
gout[n*2187+1590] = + s[1590];
gout[n*2187+1591] = + s[1591];
gout[n*2187+1592] = + s[1592];
gout[n*2187+1593] = + s[1593];
gout[n*2187+1594] = + s[1594];
gout[n*2187+1595] = + s[1595];
gout[n*2187+1596] = + s[1596];
gout[n*2187+1597] = + s[1597];
gout[n*2187+1598] = + s[1598];
gout[n*2187+1599] = + s[1599];
gout[n*2187+1600] = + s[1600];
gout[n*2187+1601] = + s[1601];
gout[n*2187+1602] = + s[1602];
gout[n*2187+1603] = + s[1603];
gout[n*2187+1604] = + s[1604];
gout[n*2187+1605] = + s[1605];
gout[n*2187+1606] = + s[1606];
gout[n*2187+1607] = + s[1607];
gout[n*2187+1608] = + s[1608];
gout[n*2187+1609] = + s[1609];
gout[n*2187+1610] = + s[1610];
gout[n*2187+1611] = + s[1611];
gout[n*2187+1612] = + s[1612];
gout[n*2187+1613] = + s[1613];
gout[n*2187+1614] = + s[1614];
gout[n*2187+1615] = + s[1615];
gout[n*2187+1616] = + s[1616];
gout[n*2187+1617] = + s[1617];
gout[n*2187+1618] = + s[1618];
gout[n*2187+1619] = + s[1619];
gout[n*2187+1620] = + s[1620];
gout[n*2187+1621] = + s[1621];
gout[n*2187+1622] = + s[1622];
gout[n*2187+1623] = + s[1623];
gout[n*2187+1624] = + s[1624];
gout[n*2187+1625] = + s[1625];
gout[n*2187+1626] = + s[1626];
gout[n*2187+1627] = + s[1627];
gout[n*2187+1628] = + s[1628];
gout[n*2187+1629] = + s[1629];
gout[n*2187+1630] = + s[1630];
gout[n*2187+1631] = + s[1631];
gout[n*2187+1632] = + s[1632];
gout[n*2187+1633] = + s[1633];
gout[n*2187+1634] = + s[1634];
gout[n*2187+1635] = + s[1635];
gout[n*2187+1636] = + s[1636];
gout[n*2187+1637] = + s[1637];
gout[n*2187+1638] = + s[1638];
gout[n*2187+1639] = + s[1639];
gout[n*2187+1640] = + s[1640];
gout[n*2187+1641] = + s[1641];
gout[n*2187+1642] = + s[1642];
gout[n*2187+1643] = + s[1643];
gout[n*2187+1644] = + s[1644];
gout[n*2187+1645] = + s[1645];
gout[n*2187+1646] = + s[1646];
gout[n*2187+1647] = + s[1647];
gout[n*2187+1648] = + s[1648];
gout[n*2187+1649] = + s[1649];
gout[n*2187+1650] = + s[1650];
gout[n*2187+1651] = + s[1651];
gout[n*2187+1652] = + s[1652];
gout[n*2187+1653] = + s[1653];
gout[n*2187+1654] = + s[1654];
gout[n*2187+1655] = + s[1655];
gout[n*2187+1656] = + s[1656];
gout[n*2187+1657] = + s[1657];
gout[n*2187+1658] = + s[1658];
gout[n*2187+1659] = + s[1659];
gout[n*2187+1660] = + s[1660];
gout[n*2187+1661] = + s[1661];
gout[n*2187+1662] = + s[1662];
gout[n*2187+1663] = + s[1663];
gout[n*2187+1664] = + s[1664];
gout[n*2187+1665] = + s[1665];
gout[n*2187+1666] = + s[1666];
gout[n*2187+1667] = + s[1667];
gout[n*2187+1668] = + s[1668];
gout[n*2187+1669] = + s[1669];
gout[n*2187+1670] = + s[1670];
gout[n*2187+1671] = + s[1671];
gout[n*2187+1672] = + s[1672];
gout[n*2187+1673] = + s[1673];
gout[n*2187+1674] = + s[1674];
gout[n*2187+1675] = + s[1675];
gout[n*2187+1676] = + s[1676];
gout[n*2187+1677] = + s[1677];
gout[n*2187+1678] = + s[1678];
gout[n*2187+1679] = + s[1679];
gout[n*2187+1680] = + s[1680];
gout[n*2187+1681] = + s[1681];
gout[n*2187+1682] = + s[1682];
gout[n*2187+1683] = + s[1683];
gout[n*2187+1684] = + s[1684];
gout[n*2187+1685] = + s[1685];
gout[n*2187+1686] = + s[1686];
gout[n*2187+1687] = + s[1687];
gout[n*2187+1688] = + s[1688];
gout[n*2187+1689] = + s[1689];
gout[n*2187+1690] = + s[1690];
gout[n*2187+1691] = + s[1691];
gout[n*2187+1692] = + s[1692];
gout[n*2187+1693] = + s[1693];
gout[n*2187+1694] = + s[1694];
gout[n*2187+1695] = + s[1695];
gout[n*2187+1696] = + s[1696];
gout[n*2187+1697] = + s[1697];
gout[n*2187+1698] = + s[1698];
gout[n*2187+1699] = + s[1699];
gout[n*2187+1700] = + s[1700];
gout[n*2187+1701] = + s[1701];
gout[n*2187+1702] = + s[1702];
gout[n*2187+1703] = + s[1703];
gout[n*2187+1704] = + s[1704];
gout[n*2187+1705] = + s[1705];
gout[n*2187+1706] = + s[1706];
gout[n*2187+1707] = + s[1707];
gout[n*2187+1708] = + s[1708];
gout[n*2187+1709] = + s[1709];
gout[n*2187+1710] = + s[1710];
gout[n*2187+1711] = + s[1711];
gout[n*2187+1712] = + s[1712];
gout[n*2187+1713] = + s[1713];
gout[n*2187+1714] = + s[1714];
gout[n*2187+1715] = + s[1715];
gout[n*2187+1716] = + s[1716];
gout[n*2187+1717] = + s[1717];
gout[n*2187+1718] = + s[1718];
gout[n*2187+1719] = + s[1719];
gout[n*2187+1720] = + s[1720];
gout[n*2187+1721] = + s[1721];
gout[n*2187+1722] = + s[1722];
gout[n*2187+1723] = + s[1723];
gout[n*2187+1724] = + s[1724];
gout[n*2187+1725] = + s[1725];
gout[n*2187+1726] = + s[1726];
gout[n*2187+1727] = + s[1727];
gout[n*2187+1728] = + s[1728];
gout[n*2187+1729] = + s[1729];
gout[n*2187+1730] = + s[1730];
gout[n*2187+1731] = + s[1731];
gout[n*2187+1732] = + s[1732];
gout[n*2187+1733] = + s[1733];
gout[n*2187+1734] = + s[1734];
gout[n*2187+1735] = + s[1735];
gout[n*2187+1736] = + s[1736];
gout[n*2187+1737] = + s[1737];
gout[n*2187+1738] = + s[1738];
gout[n*2187+1739] = + s[1739];
gout[n*2187+1740] = + s[1740];
gout[n*2187+1741] = + s[1741];
gout[n*2187+1742] = + s[1742];
gout[n*2187+1743] = + s[1743];
gout[n*2187+1744] = + s[1744];
gout[n*2187+1745] = + s[1745];
gout[n*2187+1746] = + s[1746];
gout[n*2187+1747] = + s[1747];
gout[n*2187+1748] = + s[1748];
gout[n*2187+1749] = + s[1749];
gout[n*2187+1750] = + s[1750];
gout[n*2187+1751] = + s[1751];
gout[n*2187+1752] = + s[1752];
gout[n*2187+1753] = + s[1753];
gout[n*2187+1754] = + s[1754];
gout[n*2187+1755] = + s[1755];
gout[n*2187+1756] = + s[1756];
gout[n*2187+1757] = + s[1757];
gout[n*2187+1758] = + s[1758];
gout[n*2187+1759] = + s[1759];
gout[n*2187+1760] = + s[1760];
gout[n*2187+1761] = + s[1761];
gout[n*2187+1762] = + s[1762];
gout[n*2187+1763] = + s[1763];
gout[n*2187+1764] = + s[1764];
gout[n*2187+1765] = + s[1765];
gout[n*2187+1766] = + s[1766];
gout[n*2187+1767] = + s[1767];
gout[n*2187+1768] = + s[1768];
gout[n*2187+1769] = + s[1769];
gout[n*2187+1770] = + s[1770];
gout[n*2187+1771] = + s[1771];
gout[n*2187+1772] = + s[1772];
gout[n*2187+1773] = + s[1773];
gout[n*2187+1774] = + s[1774];
gout[n*2187+1775] = + s[1775];
gout[n*2187+1776] = + s[1776];
gout[n*2187+1777] = + s[1777];
gout[n*2187+1778] = + s[1778];
gout[n*2187+1779] = + s[1779];
gout[n*2187+1780] = + s[1780];
gout[n*2187+1781] = + s[1781];
gout[n*2187+1782] = + s[1782];
gout[n*2187+1783] = + s[1783];
gout[n*2187+1784] = + s[1784];
gout[n*2187+1785] = + s[1785];
gout[n*2187+1786] = + s[1786];
gout[n*2187+1787] = + s[1787];
gout[n*2187+1788] = + s[1788];
gout[n*2187+1789] = + s[1789];
gout[n*2187+1790] = + s[1790];
gout[n*2187+1791] = + s[1791];
gout[n*2187+1792] = + s[1792];
gout[n*2187+1793] = + s[1793];
gout[n*2187+1794] = + s[1794];
gout[n*2187+1795] = + s[1795];
gout[n*2187+1796] = + s[1796];
gout[n*2187+1797] = + s[1797];
gout[n*2187+1798] = + s[1798];
gout[n*2187+1799] = + s[1799];
gout[n*2187+1800] = + s[1800];
gout[n*2187+1801] = + s[1801];
gout[n*2187+1802] = + s[1802];
gout[n*2187+1803] = + s[1803];
gout[n*2187+1804] = + s[1804];
gout[n*2187+1805] = + s[1805];
gout[n*2187+1806] = + s[1806];
gout[n*2187+1807] = + s[1807];
gout[n*2187+1808] = + s[1808];
gout[n*2187+1809] = + s[1809];
gout[n*2187+1810] = + s[1810];
gout[n*2187+1811] = + s[1811];
gout[n*2187+1812] = + s[1812];
gout[n*2187+1813] = + s[1813];
gout[n*2187+1814] = + s[1814];
gout[n*2187+1815] = + s[1815];
gout[n*2187+1816] = + s[1816];
gout[n*2187+1817] = + s[1817];
gout[n*2187+1818] = + s[1818];
gout[n*2187+1819] = + s[1819];
gout[n*2187+1820] = + s[1820];
gout[n*2187+1821] = + s[1821];
gout[n*2187+1822] = + s[1822];
gout[n*2187+1823] = + s[1823];
gout[n*2187+1824] = + s[1824];
gout[n*2187+1825] = + s[1825];
gout[n*2187+1826] = + s[1826];
gout[n*2187+1827] = + s[1827];
gout[n*2187+1828] = + s[1828];
gout[n*2187+1829] = + s[1829];
gout[n*2187+1830] = + s[1830];
gout[n*2187+1831] = + s[1831];
gout[n*2187+1832] = + s[1832];
gout[n*2187+1833] = + s[1833];
gout[n*2187+1834] = + s[1834];
gout[n*2187+1835] = + s[1835];
gout[n*2187+1836] = + s[1836];
gout[n*2187+1837] = + s[1837];
gout[n*2187+1838] = + s[1838];
gout[n*2187+1839] = + s[1839];
gout[n*2187+1840] = + s[1840];
gout[n*2187+1841] = + s[1841];
gout[n*2187+1842] = + s[1842];
gout[n*2187+1843] = + s[1843];
gout[n*2187+1844] = + s[1844];
gout[n*2187+1845] = + s[1845];
gout[n*2187+1846] = + s[1846];
gout[n*2187+1847] = + s[1847];
gout[n*2187+1848] = + s[1848];
gout[n*2187+1849] = + s[1849];
gout[n*2187+1850] = + s[1850];
gout[n*2187+1851] = + s[1851];
gout[n*2187+1852] = + s[1852];
gout[n*2187+1853] = + s[1853];
gout[n*2187+1854] = + s[1854];
gout[n*2187+1855] = + s[1855];
gout[n*2187+1856] = + s[1856];
gout[n*2187+1857] = + s[1857];
gout[n*2187+1858] = + s[1858];
gout[n*2187+1859] = + s[1859];
gout[n*2187+1860] = + s[1860];
gout[n*2187+1861] = + s[1861];
gout[n*2187+1862] = + s[1862];
gout[n*2187+1863] = + s[1863];
gout[n*2187+1864] = + s[1864];
gout[n*2187+1865] = + s[1865];
gout[n*2187+1866] = + s[1866];
gout[n*2187+1867] = + s[1867];
gout[n*2187+1868] = + s[1868];
gout[n*2187+1869] = + s[1869];
gout[n*2187+1870] = + s[1870];
gout[n*2187+1871] = + s[1871];
gout[n*2187+1872] = + s[1872];
gout[n*2187+1873] = + s[1873];
gout[n*2187+1874] = + s[1874];
gout[n*2187+1875] = + s[1875];
gout[n*2187+1876] = + s[1876];
gout[n*2187+1877] = + s[1877];
gout[n*2187+1878] = + s[1878];
gout[n*2187+1879] = + s[1879];
gout[n*2187+1880] = + s[1880];
gout[n*2187+1881] = + s[1881];
gout[n*2187+1882] = + s[1882];
gout[n*2187+1883] = + s[1883];
gout[n*2187+1884] = + s[1884];
gout[n*2187+1885] = + s[1885];
gout[n*2187+1886] = + s[1886];
gout[n*2187+1887] = + s[1887];
gout[n*2187+1888] = + s[1888];
gout[n*2187+1889] = + s[1889];
gout[n*2187+1890] = + s[1890];
gout[n*2187+1891] = + s[1891];
gout[n*2187+1892] = + s[1892];
gout[n*2187+1893] = + s[1893];
gout[n*2187+1894] = + s[1894];
gout[n*2187+1895] = + s[1895];
gout[n*2187+1896] = + s[1896];
gout[n*2187+1897] = + s[1897];
gout[n*2187+1898] = + s[1898];
gout[n*2187+1899] = + s[1899];
gout[n*2187+1900] = + s[1900];
gout[n*2187+1901] = + s[1901];
gout[n*2187+1902] = + s[1902];
gout[n*2187+1903] = + s[1903];
gout[n*2187+1904] = + s[1904];
gout[n*2187+1905] = + s[1905];
gout[n*2187+1906] = + s[1906];
gout[n*2187+1907] = + s[1907];
gout[n*2187+1908] = + s[1908];
gout[n*2187+1909] = + s[1909];
gout[n*2187+1910] = + s[1910];
gout[n*2187+1911] = + s[1911];
gout[n*2187+1912] = + s[1912];
gout[n*2187+1913] = + s[1913];
gout[n*2187+1914] = + s[1914];
gout[n*2187+1915] = + s[1915];
gout[n*2187+1916] = + s[1916];
gout[n*2187+1917] = + s[1917];
gout[n*2187+1918] = + s[1918];
gout[n*2187+1919] = + s[1919];
gout[n*2187+1920] = + s[1920];
gout[n*2187+1921] = + s[1921];
gout[n*2187+1922] = + s[1922];
gout[n*2187+1923] = + s[1923];
gout[n*2187+1924] = + s[1924];
gout[n*2187+1925] = + s[1925];
gout[n*2187+1926] = + s[1926];
gout[n*2187+1927] = + s[1927];
gout[n*2187+1928] = + s[1928];
gout[n*2187+1929] = + s[1929];
gout[n*2187+1930] = + s[1930];
gout[n*2187+1931] = + s[1931];
gout[n*2187+1932] = + s[1932];
gout[n*2187+1933] = + s[1933];
gout[n*2187+1934] = + s[1934];
gout[n*2187+1935] = + s[1935];
gout[n*2187+1936] = + s[1936];
gout[n*2187+1937] = + s[1937];
gout[n*2187+1938] = + s[1938];
gout[n*2187+1939] = + s[1939];
gout[n*2187+1940] = + s[1940];
gout[n*2187+1941] = + s[1941];
gout[n*2187+1942] = + s[1942];
gout[n*2187+1943] = + s[1943];
gout[n*2187+1944] = + s[1944];
gout[n*2187+1945] = + s[1945];
gout[n*2187+1946] = + s[1946];
gout[n*2187+1947] = + s[1947];
gout[n*2187+1948] = + s[1948];
gout[n*2187+1949] = + s[1949];
gout[n*2187+1950] = + s[1950];
gout[n*2187+1951] = + s[1951];
gout[n*2187+1952] = + s[1952];
gout[n*2187+1953] = + s[1953];
gout[n*2187+1954] = + s[1954];
gout[n*2187+1955] = + s[1955];
gout[n*2187+1956] = + s[1956];
gout[n*2187+1957] = + s[1957];
gout[n*2187+1958] = + s[1958];
gout[n*2187+1959] = + s[1959];
gout[n*2187+1960] = + s[1960];
gout[n*2187+1961] = + s[1961];
gout[n*2187+1962] = + s[1962];
gout[n*2187+1963] = + s[1963];
gout[n*2187+1964] = + s[1964];
gout[n*2187+1965] = + s[1965];
gout[n*2187+1966] = + s[1966];
gout[n*2187+1967] = + s[1967];
gout[n*2187+1968] = + s[1968];
gout[n*2187+1969] = + s[1969];
gout[n*2187+1970] = + s[1970];
gout[n*2187+1971] = + s[1971];
gout[n*2187+1972] = + s[1972];
gout[n*2187+1973] = + s[1973];
gout[n*2187+1974] = + s[1974];
gout[n*2187+1975] = + s[1975];
gout[n*2187+1976] = + s[1976];
gout[n*2187+1977] = + s[1977];
gout[n*2187+1978] = + s[1978];
gout[n*2187+1979] = + s[1979];
gout[n*2187+1980] = + s[1980];
gout[n*2187+1981] = + s[1981];
gout[n*2187+1982] = + s[1982];
gout[n*2187+1983] = + s[1983];
gout[n*2187+1984] = + s[1984];
gout[n*2187+1985] = + s[1985];
gout[n*2187+1986] = + s[1986];
gout[n*2187+1987] = + s[1987];
gout[n*2187+1988] = + s[1988];
gout[n*2187+1989] = + s[1989];
gout[n*2187+1990] = + s[1990];
gout[n*2187+1991] = + s[1991];
gout[n*2187+1992] = + s[1992];
gout[n*2187+1993] = + s[1993];
gout[n*2187+1994] = + s[1994];
gout[n*2187+1995] = + s[1995];
gout[n*2187+1996] = + s[1996];
gout[n*2187+1997] = + s[1997];
gout[n*2187+1998] = + s[1998];
gout[n*2187+1999] = + s[1999];
gout[n*2187+2000] = + s[2000];
gout[n*2187+2001] = + s[2001];
gout[n*2187+2002] = + s[2002];
gout[n*2187+2003] = + s[2003];
gout[n*2187+2004] = + s[2004];
gout[n*2187+2005] = + s[2005];
gout[n*2187+2006] = + s[2006];
gout[n*2187+2007] = + s[2007];
gout[n*2187+2008] = + s[2008];
gout[n*2187+2009] = + s[2009];
gout[n*2187+2010] = + s[2010];
gout[n*2187+2011] = + s[2011];
gout[n*2187+2012] = + s[2012];
gout[n*2187+2013] = + s[2013];
gout[n*2187+2014] = + s[2014];
gout[n*2187+2015] = + s[2015];
gout[n*2187+2016] = + s[2016];
gout[n*2187+2017] = + s[2017];
gout[n*2187+2018] = + s[2018];
gout[n*2187+2019] = + s[2019];
gout[n*2187+2020] = + s[2020];
gout[n*2187+2021] = + s[2021];
gout[n*2187+2022] = + s[2022];
gout[n*2187+2023] = + s[2023];
gout[n*2187+2024] = + s[2024];
gout[n*2187+2025] = + s[2025];
gout[n*2187+2026] = + s[2026];
gout[n*2187+2027] = + s[2027];
gout[n*2187+2028] = + s[2028];
gout[n*2187+2029] = + s[2029];
gout[n*2187+2030] = + s[2030];
gout[n*2187+2031] = + s[2031];
gout[n*2187+2032] = + s[2032];
gout[n*2187+2033] = + s[2033];
gout[n*2187+2034] = + s[2034];
gout[n*2187+2035] = + s[2035];
gout[n*2187+2036] = + s[2036];
gout[n*2187+2037] = + s[2037];
gout[n*2187+2038] = + s[2038];
gout[n*2187+2039] = + s[2039];
gout[n*2187+2040] = + s[2040];
gout[n*2187+2041] = + s[2041];
gout[n*2187+2042] = + s[2042];
gout[n*2187+2043] = + s[2043];
gout[n*2187+2044] = + s[2044];
gout[n*2187+2045] = + s[2045];
gout[n*2187+2046] = + s[2046];
gout[n*2187+2047] = + s[2047];
gout[n*2187+2048] = + s[2048];
gout[n*2187+2049] = + s[2049];
gout[n*2187+2050] = + s[2050];
gout[n*2187+2051] = + s[2051];
gout[n*2187+2052] = + s[2052];
gout[n*2187+2053] = + s[2053];
gout[n*2187+2054] = + s[2054];
gout[n*2187+2055] = + s[2055];
gout[n*2187+2056] = + s[2056];
gout[n*2187+2057] = + s[2057];
gout[n*2187+2058] = + s[2058];
gout[n*2187+2059] = + s[2059];
gout[n*2187+2060] = + s[2060];
gout[n*2187+2061] = + s[2061];
gout[n*2187+2062] = + s[2062];
gout[n*2187+2063] = + s[2063];
gout[n*2187+2064] = + s[2064];
gout[n*2187+2065] = + s[2065];
gout[n*2187+2066] = + s[2066];
gout[n*2187+2067] = + s[2067];
gout[n*2187+2068] = + s[2068];
gout[n*2187+2069] = + s[2069];
gout[n*2187+2070] = + s[2070];
gout[n*2187+2071] = + s[2071];
gout[n*2187+2072] = + s[2072];
gout[n*2187+2073] = + s[2073];
gout[n*2187+2074] = + s[2074];
gout[n*2187+2075] = + s[2075];
gout[n*2187+2076] = + s[2076];
gout[n*2187+2077] = + s[2077];
gout[n*2187+2078] = + s[2078];
gout[n*2187+2079] = + s[2079];
gout[n*2187+2080] = + s[2080];
gout[n*2187+2081] = + s[2081];
gout[n*2187+2082] = + s[2082];
gout[n*2187+2083] = + s[2083];
gout[n*2187+2084] = + s[2084];
gout[n*2187+2085] = + s[2085];
gout[n*2187+2086] = + s[2086];
gout[n*2187+2087] = + s[2087];
gout[n*2187+2088] = + s[2088];
gout[n*2187+2089] = + s[2089];
gout[n*2187+2090] = + s[2090];
gout[n*2187+2091] = + s[2091];
gout[n*2187+2092] = + s[2092];
gout[n*2187+2093] = + s[2093];
gout[n*2187+2094] = + s[2094];
gout[n*2187+2095] = + s[2095];
gout[n*2187+2096] = + s[2096];
gout[n*2187+2097] = + s[2097];
gout[n*2187+2098] = + s[2098];
gout[n*2187+2099] = + s[2099];
gout[n*2187+2100] = + s[2100];
gout[n*2187+2101] = + s[2101];
gout[n*2187+2102] = + s[2102];
gout[n*2187+2103] = + s[2103];
gout[n*2187+2104] = + s[2104];
gout[n*2187+2105] = + s[2105];
gout[n*2187+2106] = + s[2106];
gout[n*2187+2107] = + s[2107];
gout[n*2187+2108] = + s[2108];
gout[n*2187+2109] = + s[2109];
gout[n*2187+2110] = + s[2110];
gout[n*2187+2111] = + s[2111];
gout[n*2187+2112] = + s[2112];
gout[n*2187+2113] = + s[2113];
gout[n*2187+2114] = + s[2114];
gout[n*2187+2115] = + s[2115];
gout[n*2187+2116] = + s[2116];
gout[n*2187+2117] = + s[2117];
gout[n*2187+2118] = + s[2118];
gout[n*2187+2119] = + s[2119];
gout[n*2187+2120] = + s[2120];
gout[n*2187+2121] = + s[2121];
gout[n*2187+2122] = + s[2122];
gout[n*2187+2123] = + s[2123];
gout[n*2187+2124] = + s[2124];
gout[n*2187+2125] = + s[2125];
gout[n*2187+2126] = + s[2126];
gout[n*2187+2127] = + s[2127];
gout[n*2187+2128] = + s[2128];
gout[n*2187+2129] = + s[2129];
gout[n*2187+2130] = + s[2130];
gout[n*2187+2131] = + s[2131];
gout[n*2187+2132] = + s[2132];
gout[n*2187+2133] = + s[2133];
gout[n*2187+2134] = + s[2134];
gout[n*2187+2135] = + s[2135];
gout[n*2187+2136] = + s[2136];
gout[n*2187+2137] = + s[2137];
gout[n*2187+2138] = + s[2138];
gout[n*2187+2139] = + s[2139];
gout[n*2187+2140] = + s[2140];
gout[n*2187+2141] = + s[2141];
gout[n*2187+2142] = + s[2142];
gout[n*2187+2143] = + s[2143];
gout[n*2187+2144] = + s[2144];
gout[n*2187+2145] = + s[2145];
gout[n*2187+2146] = + s[2146];
gout[n*2187+2147] = + s[2147];
gout[n*2187+2148] = + s[2148];
gout[n*2187+2149] = + s[2149];
gout[n*2187+2150] = + s[2150];
gout[n*2187+2151] = + s[2151];
gout[n*2187+2152] = + s[2152];
gout[n*2187+2153] = + s[2153];
gout[n*2187+2154] = + s[2154];
gout[n*2187+2155] = + s[2155];
gout[n*2187+2156] = + s[2156];
gout[n*2187+2157] = + s[2157];
gout[n*2187+2158] = + s[2158];
gout[n*2187+2159] = + s[2159];
gout[n*2187+2160] = + s[2160];
gout[n*2187+2161] = + s[2161];
gout[n*2187+2162] = + s[2162];
gout[n*2187+2163] = + s[2163];
gout[n*2187+2164] = + s[2164];
gout[n*2187+2165] = + s[2165];
gout[n*2187+2166] = + s[2166];
gout[n*2187+2167] = + s[2167];
gout[n*2187+2168] = + s[2168];
gout[n*2187+2169] = + s[2169];
gout[n*2187+2170] = + s[2170];
gout[n*2187+2171] = + s[2171];
gout[n*2187+2172] = + s[2172];
gout[n*2187+2173] = + s[2173];
gout[n*2187+2174] = + s[2174];
gout[n*2187+2175] = + s[2175];
gout[n*2187+2176] = + s[2176];
gout[n*2187+2177] = + s[2177];
gout[n*2187+2178] = + s[2178];
gout[n*2187+2179] = + s[2179];
gout[n*2187+2180] = + s[2180];
gout[n*2187+2181] = + s[2181];
gout[n*2187+2182] = + s[2182];
gout[n*2187+2183] = + s[2183];
gout[n*2187+2184] = + s[2184];
gout[n*2187+2185] = + s[2185];
gout[n*2187+2186] = + s[2186];
} else {
gout[n*2187+0] += + s[0];
gout[n*2187+1] += + s[1];
gout[n*2187+2] += + s[2];
gout[n*2187+3] += + s[3];
gout[n*2187+4] += + s[4];
gout[n*2187+5] += + s[5];
gout[n*2187+6] += + s[6];
gout[n*2187+7] += + s[7];
gout[n*2187+8] += + s[8];
gout[n*2187+9] += + s[9];
gout[n*2187+10] += + s[10];
gout[n*2187+11] += + s[11];
gout[n*2187+12] += + s[12];
gout[n*2187+13] += + s[13];
gout[n*2187+14] += + s[14];
gout[n*2187+15] += + s[15];
gout[n*2187+16] += + s[16];
gout[n*2187+17] += + s[17];
gout[n*2187+18] += + s[18];
gout[n*2187+19] += + s[19];
gout[n*2187+20] += + s[20];
gout[n*2187+21] += + s[21];
gout[n*2187+22] += + s[22];
gout[n*2187+23] += + s[23];
gout[n*2187+24] += + s[24];
gout[n*2187+25] += + s[25];
gout[n*2187+26] += + s[26];
gout[n*2187+27] += + s[27];
gout[n*2187+28] += + s[28];
gout[n*2187+29] += + s[29];
gout[n*2187+30] += + s[30];
gout[n*2187+31] += + s[31];
gout[n*2187+32] += + s[32];
gout[n*2187+33] += + s[33];
gout[n*2187+34] += + s[34];
gout[n*2187+35] += + s[35];
gout[n*2187+36] += + s[36];
gout[n*2187+37] += + s[37];
gout[n*2187+38] += + s[38];
gout[n*2187+39] += + s[39];
gout[n*2187+40] += + s[40];
gout[n*2187+41] += + s[41];
gout[n*2187+42] += + s[42];
gout[n*2187+43] += + s[43];
gout[n*2187+44] += + s[44];
gout[n*2187+45] += + s[45];
gout[n*2187+46] += + s[46];
gout[n*2187+47] += + s[47];
gout[n*2187+48] += + s[48];
gout[n*2187+49] += + s[49];
gout[n*2187+50] += + s[50];
gout[n*2187+51] += + s[51];
gout[n*2187+52] += + s[52];
gout[n*2187+53] += + s[53];
gout[n*2187+54] += + s[54];
gout[n*2187+55] += + s[55];
gout[n*2187+56] += + s[56];
gout[n*2187+57] += + s[57];
gout[n*2187+58] += + s[58];
gout[n*2187+59] += + s[59];
gout[n*2187+60] += + s[60];
gout[n*2187+61] += + s[61];
gout[n*2187+62] += + s[62];
gout[n*2187+63] += + s[63];
gout[n*2187+64] += + s[64];
gout[n*2187+65] += + s[65];
gout[n*2187+66] += + s[66];
gout[n*2187+67] += + s[67];
gout[n*2187+68] += + s[68];
gout[n*2187+69] += + s[69];
gout[n*2187+70] += + s[70];
gout[n*2187+71] += + s[71];
gout[n*2187+72] += + s[72];
gout[n*2187+73] += + s[73];
gout[n*2187+74] += + s[74];
gout[n*2187+75] += + s[75];
gout[n*2187+76] += + s[76];
gout[n*2187+77] += + s[77];
gout[n*2187+78] += + s[78];
gout[n*2187+79] += + s[79];
gout[n*2187+80] += + s[80];
gout[n*2187+81] += + s[81];
gout[n*2187+82] += + s[82];
gout[n*2187+83] += + s[83];
gout[n*2187+84] += + s[84];
gout[n*2187+85] += + s[85];
gout[n*2187+86] += + s[86];
gout[n*2187+87] += + s[87];
gout[n*2187+88] += + s[88];
gout[n*2187+89] += + s[89];
gout[n*2187+90] += + s[90];
gout[n*2187+91] += + s[91];
gout[n*2187+92] += + s[92];
gout[n*2187+93] += + s[93];
gout[n*2187+94] += + s[94];
gout[n*2187+95] += + s[95];
gout[n*2187+96] += + s[96];
gout[n*2187+97] += + s[97];
gout[n*2187+98] += + s[98];
gout[n*2187+99] += + s[99];
gout[n*2187+100] += + s[100];
gout[n*2187+101] += + s[101];
gout[n*2187+102] += + s[102];
gout[n*2187+103] += + s[103];
gout[n*2187+104] += + s[104];
gout[n*2187+105] += + s[105];
gout[n*2187+106] += + s[106];
gout[n*2187+107] += + s[107];
gout[n*2187+108] += + s[108];
gout[n*2187+109] += + s[109];
gout[n*2187+110] += + s[110];
gout[n*2187+111] += + s[111];
gout[n*2187+112] += + s[112];
gout[n*2187+113] += + s[113];
gout[n*2187+114] += + s[114];
gout[n*2187+115] += + s[115];
gout[n*2187+116] += + s[116];
gout[n*2187+117] += + s[117];
gout[n*2187+118] += + s[118];
gout[n*2187+119] += + s[119];
gout[n*2187+120] += + s[120];
gout[n*2187+121] += + s[121];
gout[n*2187+122] += + s[122];
gout[n*2187+123] += + s[123];
gout[n*2187+124] += + s[124];
gout[n*2187+125] += + s[125];
gout[n*2187+126] += + s[126];
gout[n*2187+127] += + s[127];
gout[n*2187+128] += + s[128];
gout[n*2187+129] += + s[129];
gout[n*2187+130] += + s[130];
gout[n*2187+131] += + s[131];
gout[n*2187+132] += + s[132];
gout[n*2187+133] += + s[133];
gout[n*2187+134] += + s[134];
gout[n*2187+135] += + s[135];
gout[n*2187+136] += + s[136];
gout[n*2187+137] += + s[137];
gout[n*2187+138] += + s[138];
gout[n*2187+139] += + s[139];
gout[n*2187+140] += + s[140];
gout[n*2187+141] += + s[141];
gout[n*2187+142] += + s[142];
gout[n*2187+143] += + s[143];
gout[n*2187+144] += + s[144];
gout[n*2187+145] += + s[145];
gout[n*2187+146] += + s[146];
gout[n*2187+147] += + s[147];
gout[n*2187+148] += + s[148];
gout[n*2187+149] += + s[149];
gout[n*2187+150] += + s[150];
gout[n*2187+151] += + s[151];
gout[n*2187+152] += + s[152];
gout[n*2187+153] += + s[153];
gout[n*2187+154] += + s[154];
gout[n*2187+155] += + s[155];
gout[n*2187+156] += + s[156];
gout[n*2187+157] += + s[157];
gout[n*2187+158] += + s[158];
gout[n*2187+159] += + s[159];
gout[n*2187+160] += + s[160];
gout[n*2187+161] += + s[161];
gout[n*2187+162] += + s[162];
gout[n*2187+163] += + s[163];
gout[n*2187+164] += + s[164];
gout[n*2187+165] += + s[165];
gout[n*2187+166] += + s[166];
gout[n*2187+167] += + s[167];
gout[n*2187+168] += + s[168];
gout[n*2187+169] += + s[169];
gout[n*2187+170] += + s[170];
gout[n*2187+171] += + s[171];
gout[n*2187+172] += + s[172];
gout[n*2187+173] += + s[173];
gout[n*2187+174] += + s[174];
gout[n*2187+175] += + s[175];
gout[n*2187+176] += + s[176];
gout[n*2187+177] += + s[177];
gout[n*2187+178] += + s[178];
gout[n*2187+179] += + s[179];
gout[n*2187+180] += + s[180];
gout[n*2187+181] += + s[181];
gout[n*2187+182] += + s[182];
gout[n*2187+183] += + s[183];
gout[n*2187+184] += + s[184];
gout[n*2187+185] += + s[185];
gout[n*2187+186] += + s[186];
gout[n*2187+187] += + s[187];
gout[n*2187+188] += + s[188];
gout[n*2187+189] += + s[189];
gout[n*2187+190] += + s[190];
gout[n*2187+191] += + s[191];
gout[n*2187+192] += + s[192];
gout[n*2187+193] += + s[193];
gout[n*2187+194] += + s[194];
gout[n*2187+195] += + s[195];
gout[n*2187+196] += + s[196];
gout[n*2187+197] += + s[197];
gout[n*2187+198] += + s[198];
gout[n*2187+199] += + s[199];
gout[n*2187+200] += + s[200];
gout[n*2187+201] += + s[201];
gout[n*2187+202] += + s[202];
gout[n*2187+203] += + s[203];
gout[n*2187+204] += + s[204];
gout[n*2187+205] += + s[205];
gout[n*2187+206] += + s[206];
gout[n*2187+207] += + s[207];
gout[n*2187+208] += + s[208];
gout[n*2187+209] += + s[209];
gout[n*2187+210] += + s[210];
gout[n*2187+211] += + s[211];
gout[n*2187+212] += + s[212];
gout[n*2187+213] += + s[213];
gout[n*2187+214] += + s[214];
gout[n*2187+215] += + s[215];
gout[n*2187+216] += + s[216];
gout[n*2187+217] += + s[217];
gout[n*2187+218] += + s[218];
gout[n*2187+219] += + s[219];
gout[n*2187+220] += + s[220];
gout[n*2187+221] += + s[221];
gout[n*2187+222] += + s[222];
gout[n*2187+223] += + s[223];
gout[n*2187+224] += + s[224];
gout[n*2187+225] += + s[225];
gout[n*2187+226] += + s[226];
gout[n*2187+227] += + s[227];
gout[n*2187+228] += + s[228];
gout[n*2187+229] += + s[229];
gout[n*2187+230] += + s[230];
gout[n*2187+231] += + s[231];
gout[n*2187+232] += + s[232];
gout[n*2187+233] += + s[233];
gout[n*2187+234] += + s[234];
gout[n*2187+235] += + s[235];
gout[n*2187+236] += + s[236];
gout[n*2187+237] += + s[237];
gout[n*2187+238] += + s[238];
gout[n*2187+239] += + s[239];
gout[n*2187+240] += + s[240];
gout[n*2187+241] += + s[241];
gout[n*2187+242] += + s[242];
gout[n*2187+243] += + s[243];
gout[n*2187+244] += + s[244];
gout[n*2187+245] += + s[245];
gout[n*2187+246] += + s[246];
gout[n*2187+247] += + s[247];
gout[n*2187+248] += + s[248];
gout[n*2187+249] += + s[249];
gout[n*2187+250] += + s[250];
gout[n*2187+251] += + s[251];
gout[n*2187+252] += + s[252];
gout[n*2187+253] += + s[253];
gout[n*2187+254] += + s[254];
gout[n*2187+255] += + s[255];
gout[n*2187+256] += + s[256];
gout[n*2187+257] += + s[257];
gout[n*2187+258] += + s[258];
gout[n*2187+259] += + s[259];
gout[n*2187+260] += + s[260];
gout[n*2187+261] += + s[261];
gout[n*2187+262] += + s[262];
gout[n*2187+263] += + s[263];
gout[n*2187+264] += + s[264];
gout[n*2187+265] += + s[265];
gout[n*2187+266] += + s[266];
gout[n*2187+267] += + s[267];
gout[n*2187+268] += + s[268];
gout[n*2187+269] += + s[269];
gout[n*2187+270] += + s[270];
gout[n*2187+271] += + s[271];
gout[n*2187+272] += + s[272];
gout[n*2187+273] += + s[273];
gout[n*2187+274] += + s[274];
gout[n*2187+275] += + s[275];
gout[n*2187+276] += + s[276];
gout[n*2187+277] += + s[277];
gout[n*2187+278] += + s[278];
gout[n*2187+279] += + s[279];
gout[n*2187+280] += + s[280];
gout[n*2187+281] += + s[281];
gout[n*2187+282] += + s[282];
gout[n*2187+283] += + s[283];
gout[n*2187+284] += + s[284];
gout[n*2187+285] += + s[285];
gout[n*2187+286] += + s[286];
gout[n*2187+287] += + s[287];
gout[n*2187+288] += + s[288];
gout[n*2187+289] += + s[289];
gout[n*2187+290] += + s[290];
gout[n*2187+291] += + s[291];
gout[n*2187+292] += + s[292];
gout[n*2187+293] += + s[293];
gout[n*2187+294] += + s[294];
gout[n*2187+295] += + s[295];
gout[n*2187+296] += + s[296];
gout[n*2187+297] += + s[297];
gout[n*2187+298] += + s[298];
gout[n*2187+299] += + s[299];
gout[n*2187+300] += + s[300];
gout[n*2187+301] += + s[301];
gout[n*2187+302] += + s[302];
gout[n*2187+303] += + s[303];
gout[n*2187+304] += + s[304];
gout[n*2187+305] += + s[305];
gout[n*2187+306] += + s[306];
gout[n*2187+307] += + s[307];
gout[n*2187+308] += + s[308];
gout[n*2187+309] += + s[309];
gout[n*2187+310] += + s[310];
gout[n*2187+311] += + s[311];
gout[n*2187+312] += + s[312];
gout[n*2187+313] += + s[313];
gout[n*2187+314] += + s[314];
gout[n*2187+315] += + s[315];
gout[n*2187+316] += + s[316];
gout[n*2187+317] += + s[317];
gout[n*2187+318] += + s[318];
gout[n*2187+319] += + s[319];
gout[n*2187+320] += + s[320];
gout[n*2187+321] += + s[321];
gout[n*2187+322] += + s[322];
gout[n*2187+323] += + s[323];
gout[n*2187+324] += + s[324];
gout[n*2187+325] += + s[325];
gout[n*2187+326] += + s[326];
gout[n*2187+327] += + s[327];
gout[n*2187+328] += + s[328];
gout[n*2187+329] += + s[329];
gout[n*2187+330] += + s[330];
gout[n*2187+331] += + s[331];
gout[n*2187+332] += + s[332];
gout[n*2187+333] += + s[333];
gout[n*2187+334] += + s[334];
gout[n*2187+335] += + s[335];
gout[n*2187+336] += + s[336];
gout[n*2187+337] += + s[337];
gout[n*2187+338] += + s[338];
gout[n*2187+339] += + s[339];
gout[n*2187+340] += + s[340];
gout[n*2187+341] += + s[341];
gout[n*2187+342] += + s[342];
gout[n*2187+343] += + s[343];
gout[n*2187+344] += + s[344];
gout[n*2187+345] += + s[345];
gout[n*2187+346] += + s[346];
gout[n*2187+347] += + s[347];
gout[n*2187+348] += + s[348];
gout[n*2187+349] += + s[349];
gout[n*2187+350] += + s[350];
gout[n*2187+351] += + s[351];
gout[n*2187+352] += + s[352];
gout[n*2187+353] += + s[353];
gout[n*2187+354] += + s[354];
gout[n*2187+355] += + s[355];
gout[n*2187+356] += + s[356];
gout[n*2187+357] += + s[357];
gout[n*2187+358] += + s[358];
gout[n*2187+359] += + s[359];
gout[n*2187+360] += + s[360];
gout[n*2187+361] += + s[361];
gout[n*2187+362] += + s[362];
gout[n*2187+363] += + s[363];
gout[n*2187+364] += + s[364];
gout[n*2187+365] += + s[365];
gout[n*2187+366] += + s[366];
gout[n*2187+367] += + s[367];
gout[n*2187+368] += + s[368];
gout[n*2187+369] += + s[369];
gout[n*2187+370] += + s[370];
gout[n*2187+371] += + s[371];
gout[n*2187+372] += + s[372];
gout[n*2187+373] += + s[373];
gout[n*2187+374] += + s[374];
gout[n*2187+375] += + s[375];
gout[n*2187+376] += + s[376];
gout[n*2187+377] += + s[377];
gout[n*2187+378] += + s[378];
gout[n*2187+379] += + s[379];
gout[n*2187+380] += + s[380];
gout[n*2187+381] += + s[381];
gout[n*2187+382] += + s[382];
gout[n*2187+383] += + s[383];
gout[n*2187+384] += + s[384];
gout[n*2187+385] += + s[385];
gout[n*2187+386] += + s[386];
gout[n*2187+387] += + s[387];
gout[n*2187+388] += + s[388];
gout[n*2187+389] += + s[389];
gout[n*2187+390] += + s[390];
gout[n*2187+391] += + s[391];
gout[n*2187+392] += + s[392];
gout[n*2187+393] += + s[393];
gout[n*2187+394] += + s[394];
gout[n*2187+395] += + s[395];
gout[n*2187+396] += + s[396];
gout[n*2187+397] += + s[397];
gout[n*2187+398] += + s[398];
gout[n*2187+399] += + s[399];
gout[n*2187+400] += + s[400];
gout[n*2187+401] += + s[401];
gout[n*2187+402] += + s[402];
gout[n*2187+403] += + s[403];
gout[n*2187+404] += + s[404];
gout[n*2187+405] += + s[405];
gout[n*2187+406] += + s[406];
gout[n*2187+407] += + s[407];
gout[n*2187+408] += + s[408];
gout[n*2187+409] += + s[409];
gout[n*2187+410] += + s[410];
gout[n*2187+411] += + s[411];
gout[n*2187+412] += + s[412];
gout[n*2187+413] += + s[413];
gout[n*2187+414] += + s[414];
gout[n*2187+415] += + s[415];
gout[n*2187+416] += + s[416];
gout[n*2187+417] += + s[417];
gout[n*2187+418] += + s[418];
gout[n*2187+419] += + s[419];
gout[n*2187+420] += + s[420];
gout[n*2187+421] += + s[421];
gout[n*2187+422] += + s[422];
gout[n*2187+423] += + s[423];
gout[n*2187+424] += + s[424];
gout[n*2187+425] += + s[425];
gout[n*2187+426] += + s[426];
gout[n*2187+427] += + s[427];
gout[n*2187+428] += + s[428];
gout[n*2187+429] += + s[429];
gout[n*2187+430] += + s[430];
gout[n*2187+431] += + s[431];
gout[n*2187+432] += + s[432];
gout[n*2187+433] += + s[433];
gout[n*2187+434] += + s[434];
gout[n*2187+435] += + s[435];
gout[n*2187+436] += + s[436];
gout[n*2187+437] += + s[437];
gout[n*2187+438] += + s[438];
gout[n*2187+439] += + s[439];
gout[n*2187+440] += + s[440];
gout[n*2187+441] += + s[441];
gout[n*2187+442] += + s[442];
gout[n*2187+443] += + s[443];
gout[n*2187+444] += + s[444];
gout[n*2187+445] += + s[445];
gout[n*2187+446] += + s[446];
gout[n*2187+447] += + s[447];
gout[n*2187+448] += + s[448];
gout[n*2187+449] += + s[449];
gout[n*2187+450] += + s[450];
gout[n*2187+451] += + s[451];
gout[n*2187+452] += + s[452];
gout[n*2187+453] += + s[453];
gout[n*2187+454] += + s[454];
gout[n*2187+455] += + s[455];
gout[n*2187+456] += + s[456];
gout[n*2187+457] += + s[457];
gout[n*2187+458] += + s[458];
gout[n*2187+459] += + s[459];
gout[n*2187+460] += + s[460];
gout[n*2187+461] += + s[461];
gout[n*2187+462] += + s[462];
gout[n*2187+463] += + s[463];
gout[n*2187+464] += + s[464];
gout[n*2187+465] += + s[465];
gout[n*2187+466] += + s[466];
gout[n*2187+467] += + s[467];
gout[n*2187+468] += + s[468];
gout[n*2187+469] += + s[469];
gout[n*2187+470] += + s[470];
gout[n*2187+471] += + s[471];
gout[n*2187+472] += + s[472];
gout[n*2187+473] += + s[473];
gout[n*2187+474] += + s[474];
gout[n*2187+475] += + s[475];
gout[n*2187+476] += + s[476];
gout[n*2187+477] += + s[477];
gout[n*2187+478] += + s[478];
gout[n*2187+479] += + s[479];
gout[n*2187+480] += + s[480];
gout[n*2187+481] += + s[481];
gout[n*2187+482] += + s[482];
gout[n*2187+483] += + s[483];
gout[n*2187+484] += + s[484];
gout[n*2187+485] += + s[485];
gout[n*2187+486] += + s[486];
gout[n*2187+487] += + s[487];
gout[n*2187+488] += + s[488];
gout[n*2187+489] += + s[489];
gout[n*2187+490] += + s[490];
gout[n*2187+491] += + s[491];
gout[n*2187+492] += + s[492];
gout[n*2187+493] += + s[493];
gout[n*2187+494] += + s[494];
gout[n*2187+495] += + s[495];
gout[n*2187+496] += + s[496];
gout[n*2187+497] += + s[497];
gout[n*2187+498] += + s[498];
gout[n*2187+499] += + s[499];
gout[n*2187+500] += + s[500];
gout[n*2187+501] += + s[501];
gout[n*2187+502] += + s[502];
gout[n*2187+503] += + s[503];
gout[n*2187+504] += + s[504];
gout[n*2187+505] += + s[505];
gout[n*2187+506] += + s[506];
gout[n*2187+507] += + s[507];
gout[n*2187+508] += + s[508];
gout[n*2187+509] += + s[509];
gout[n*2187+510] += + s[510];
gout[n*2187+511] += + s[511];
gout[n*2187+512] += + s[512];
gout[n*2187+513] += + s[513];
gout[n*2187+514] += + s[514];
gout[n*2187+515] += + s[515];
gout[n*2187+516] += + s[516];
gout[n*2187+517] += + s[517];
gout[n*2187+518] += + s[518];
gout[n*2187+519] += + s[519];
gout[n*2187+520] += + s[520];
gout[n*2187+521] += + s[521];
gout[n*2187+522] += + s[522];
gout[n*2187+523] += + s[523];
gout[n*2187+524] += + s[524];
gout[n*2187+525] += + s[525];
gout[n*2187+526] += + s[526];
gout[n*2187+527] += + s[527];
gout[n*2187+528] += + s[528];
gout[n*2187+529] += + s[529];
gout[n*2187+530] += + s[530];
gout[n*2187+531] += + s[531];
gout[n*2187+532] += + s[532];
gout[n*2187+533] += + s[533];
gout[n*2187+534] += + s[534];
gout[n*2187+535] += + s[535];
gout[n*2187+536] += + s[536];
gout[n*2187+537] += + s[537];
gout[n*2187+538] += + s[538];
gout[n*2187+539] += + s[539];
gout[n*2187+540] += + s[540];
gout[n*2187+541] += + s[541];
gout[n*2187+542] += + s[542];
gout[n*2187+543] += + s[543];
gout[n*2187+544] += + s[544];
gout[n*2187+545] += + s[545];
gout[n*2187+546] += + s[546];
gout[n*2187+547] += + s[547];
gout[n*2187+548] += + s[548];
gout[n*2187+549] += + s[549];
gout[n*2187+550] += + s[550];
gout[n*2187+551] += + s[551];
gout[n*2187+552] += + s[552];
gout[n*2187+553] += + s[553];
gout[n*2187+554] += + s[554];
gout[n*2187+555] += + s[555];
gout[n*2187+556] += + s[556];
gout[n*2187+557] += + s[557];
gout[n*2187+558] += + s[558];
gout[n*2187+559] += + s[559];
gout[n*2187+560] += + s[560];
gout[n*2187+561] += + s[561];
gout[n*2187+562] += + s[562];
gout[n*2187+563] += + s[563];
gout[n*2187+564] += + s[564];
gout[n*2187+565] += + s[565];
gout[n*2187+566] += + s[566];
gout[n*2187+567] += + s[567];
gout[n*2187+568] += + s[568];
gout[n*2187+569] += + s[569];
gout[n*2187+570] += + s[570];
gout[n*2187+571] += + s[571];
gout[n*2187+572] += + s[572];
gout[n*2187+573] += + s[573];
gout[n*2187+574] += + s[574];
gout[n*2187+575] += + s[575];
gout[n*2187+576] += + s[576];
gout[n*2187+577] += + s[577];
gout[n*2187+578] += + s[578];
gout[n*2187+579] += + s[579];
gout[n*2187+580] += + s[580];
gout[n*2187+581] += + s[581];
gout[n*2187+582] += + s[582];
gout[n*2187+583] += + s[583];
gout[n*2187+584] += + s[584];
gout[n*2187+585] += + s[585];
gout[n*2187+586] += + s[586];
gout[n*2187+587] += + s[587];
gout[n*2187+588] += + s[588];
gout[n*2187+589] += + s[589];
gout[n*2187+590] += + s[590];
gout[n*2187+591] += + s[591];
gout[n*2187+592] += + s[592];
gout[n*2187+593] += + s[593];
gout[n*2187+594] += + s[594];
gout[n*2187+595] += + s[595];
gout[n*2187+596] += + s[596];
gout[n*2187+597] += + s[597];
gout[n*2187+598] += + s[598];
gout[n*2187+599] += + s[599];
gout[n*2187+600] += + s[600];
gout[n*2187+601] += + s[601];
gout[n*2187+602] += + s[602];
gout[n*2187+603] += + s[603];
gout[n*2187+604] += + s[604];
gout[n*2187+605] += + s[605];
gout[n*2187+606] += + s[606];
gout[n*2187+607] += + s[607];
gout[n*2187+608] += + s[608];
gout[n*2187+609] += + s[609];
gout[n*2187+610] += + s[610];
gout[n*2187+611] += + s[611];
gout[n*2187+612] += + s[612];
gout[n*2187+613] += + s[613];
gout[n*2187+614] += + s[614];
gout[n*2187+615] += + s[615];
gout[n*2187+616] += + s[616];
gout[n*2187+617] += + s[617];
gout[n*2187+618] += + s[618];
gout[n*2187+619] += + s[619];
gout[n*2187+620] += + s[620];
gout[n*2187+621] += + s[621];
gout[n*2187+622] += + s[622];
gout[n*2187+623] += + s[623];
gout[n*2187+624] += + s[624];
gout[n*2187+625] += + s[625];
gout[n*2187+626] += + s[626];
gout[n*2187+627] += + s[627];
gout[n*2187+628] += + s[628];
gout[n*2187+629] += + s[629];
gout[n*2187+630] += + s[630];
gout[n*2187+631] += + s[631];
gout[n*2187+632] += + s[632];
gout[n*2187+633] += + s[633];
gout[n*2187+634] += + s[634];
gout[n*2187+635] += + s[635];
gout[n*2187+636] += + s[636];
gout[n*2187+637] += + s[637];
gout[n*2187+638] += + s[638];
gout[n*2187+639] += + s[639];
gout[n*2187+640] += + s[640];
gout[n*2187+641] += + s[641];
gout[n*2187+642] += + s[642];
gout[n*2187+643] += + s[643];
gout[n*2187+644] += + s[644];
gout[n*2187+645] += + s[645];
gout[n*2187+646] += + s[646];
gout[n*2187+647] += + s[647];
gout[n*2187+648] += + s[648];
gout[n*2187+649] += + s[649];
gout[n*2187+650] += + s[650];
gout[n*2187+651] += + s[651];
gout[n*2187+652] += + s[652];
gout[n*2187+653] += + s[653];
gout[n*2187+654] += + s[654];
gout[n*2187+655] += + s[655];
gout[n*2187+656] += + s[656];
gout[n*2187+657] += + s[657];
gout[n*2187+658] += + s[658];
gout[n*2187+659] += + s[659];
gout[n*2187+660] += + s[660];
gout[n*2187+661] += + s[661];
gout[n*2187+662] += + s[662];
gout[n*2187+663] += + s[663];
gout[n*2187+664] += + s[664];
gout[n*2187+665] += + s[665];
gout[n*2187+666] += + s[666];
gout[n*2187+667] += + s[667];
gout[n*2187+668] += + s[668];
gout[n*2187+669] += + s[669];
gout[n*2187+670] += + s[670];
gout[n*2187+671] += + s[671];
gout[n*2187+672] += + s[672];
gout[n*2187+673] += + s[673];
gout[n*2187+674] += + s[674];
gout[n*2187+675] += + s[675];
gout[n*2187+676] += + s[676];
gout[n*2187+677] += + s[677];
gout[n*2187+678] += + s[678];
gout[n*2187+679] += + s[679];
gout[n*2187+680] += + s[680];
gout[n*2187+681] += + s[681];
gout[n*2187+682] += + s[682];
gout[n*2187+683] += + s[683];
gout[n*2187+684] += + s[684];
gout[n*2187+685] += + s[685];
gout[n*2187+686] += + s[686];
gout[n*2187+687] += + s[687];
gout[n*2187+688] += + s[688];
gout[n*2187+689] += + s[689];
gout[n*2187+690] += + s[690];
gout[n*2187+691] += + s[691];
gout[n*2187+692] += + s[692];
gout[n*2187+693] += + s[693];
gout[n*2187+694] += + s[694];
gout[n*2187+695] += + s[695];
gout[n*2187+696] += + s[696];
gout[n*2187+697] += + s[697];
gout[n*2187+698] += + s[698];
gout[n*2187+699] += + s[699];
gout[n*2187+700] += + s[700];
gout[n*2187+701] += + s[701];
gout[n*2187+702] += + s[702];
gout[n*2187+703] += + s[703];
gout[n*2187+704] += + s[704];
gout[n*2187+705] += + s[705];
gout[n*2187+706] += + s[706];
gout[n*2187+707] += + s[707];
gout[n*2187+708] += + s[708];
gout[n*2187+709] += + s[709];
gout[n*2187+710] += + s[710];
gout[n*2187+711] += + s[711];
gout[n*2187+712] += + s[712];
gout[n*2187+713] += + s[713];
gout[n*2187+714] += + s[714];
gout[n*2187+715] += + s[715];
gout[n*2187+716] += + s[716];
gout[n*2187+717] += + s[717];
gout[n*2187+718] += + s[718];
gout[n*2187+719] += + s[719];
gout[n*2187+720] += + s[720];
gout[n*2187+721] += + s[721];
gout[n*2187+722] += + s[722];
gout[n*2187+723] += + s[723];
gout[n*2187+724] += + s[724];
gout[n*2187+725] += + s[725];
gout[n*2187+726] += + s[726];
gout[n*2187+727] += + s[727];
gout[n*2187+728] += + s[728];
gout[n*2187+729] += + s[729];
gout[n*2187+730] += + s[730];
gout[n*2187+731] += + s[731];
gout[n*2187+732] += + s[732];
gout[n*2187+733] += + s[733];
gout[n*2187+734] += + s[734];
gout[n*2187+735] += + s[735];
gout[n*2187+736] += + s[736];
gout[n*2187+737] += + s[737];
gout[n*2187+738] += + s[738];
gout[n*2187+739] += + s[739];
gout[n*2187+740] += + s[740];
gout[n*2187+741] += + s[741];
gout[n*2187+742] += + s[742];
gout[n*2187+743] += + s[743];
gout[n*2187+744] += + s[744];
gout[n*2187+745] += + s[745];
gout[n*2187+746] += + s[746];
gout[n*2187+747] += + s[747];
gout[n*2187+748] += + s[748];
gout[n*2187+749] += + s[749];
gout[n*2187+750] += + s[750];
gout[n*2187+751] += + s[751];
gout[n*2187+752] += + s[752];
gout[n*2187+753] += + s[753];
gout[n*2187+754] += + s[754];
gout[n*2187+755] += + s[755];
gout[n*2187+756] += + s[756];
gout[n*2187+757] += + s[757];
gout[n*2187+758] += + s[758];
gout[n*2187+759] += + s[759];
gout[n*2187+760] += + s[760];
gout[n*2187+761] += + s[761];
gout[n*2187+762] += + s[762];
gout[n*2187+763] += + s[763];
gout[n*2187+764] += + s[764];
gout[n*2187+765] += + s[765];
gout[n*2187+766] += + s[766];
gout[n*2187+767] += + s[767];
gout[n*2187+768] += + s[768];
gout[n*2187+769] += + s[769];
gout[n*2187+770] += + s[770];
gout[n*2187+771] += + s[771];
gout[n*2187+772] += + s[772];
gout[n*2187+773] += + s[773];
gout[n*2187+774] += + s[774];
gout[n*2187+775] += + s[775];
gout[n*2187+776] += + s[776];
gout[n*2187+777] += + s[777];
gout[n*2187+778] += + s[778];
gout[n*2187+779] += + s[779];
gout[n*2187+780] += + s[780];
gout[n*2187+781] += + s[781];
gout[n*2187+782] += + s[782];
gout[n*2187+783] += + s[783];
gout[n*2187+784] += + s[784];
gout[n*2187+785] += + s[785];
gout[n*2187+786] += + s[786];
gout[n*2187+787] += + s[787];
gout[n*2187+788] += + s[788];
gout[n*2187+789] += + s[789];
gout[n*2187+790] += + s[790];
gout[n*2187+791] += + s[791];
gout[n*2187+792] += + s[792];
gout[n*2187+793] += + s[793];
gout[n*2187+794] += + s[794];
gout[n*2187+795] += + s[795];
gout[n*2187+796] += + s[796];
gout[n*2187+797] += + s[797];
gout[n*2187+798] += + s[798];
gout[n*2187+799] += + s[799];
gout[n*2187+800] += + s[800];
gout[n*2187+801] += + s[801];
gout[n*2187+802] += + s[802];
gout[n*2187+803] += + s[803];
gout[n*2187+804] += + s[804];
gout[n*2187+805] += + s[805];
gout[n*2187+806] += + s[806];
gout[n*2187+807] += + s[807];
gout[n*2187+808] += + s[808];
gout[n*2187+809] += + s[809];
gout[n*2187+810] += + s[810];
gout[n*2187+811] += + s[811];
gout[n*2187+812] += + s[812];
gout[n*2187+813] += + s[813];
gout[n*2187+814] += + s[814];
gout[n*2187+815] += + s[815];
gout[n*2187+816] += + s[816];
gout[n*2187+817] += + s[817];
gout[n*2187+818] += + s[818];
gout[n*2187+819] += + s[819];
gout[n*2187+820] += + s[820];
gout[n*2187+821] += + s[821];
gout[n*2187+822] += + s[822];
gout[n*2187+823] += + s[823];
gout[n*2187+824] += + s[824];
gout[n*2187+825] += + s[825];
gout[n*2187+826] += + s[826];
gout[n*2187+827] += + s[827];
gout[n*2187+828] += + s[828];
gout[n*2187+829] += + s[829];
gout[n*2187+830] += + s[830];
gout[n*2187+831] += + s[831];
gout[n*2187+832] += + s[832];
gout[n*2187+833] += + s[833];
gout[n*2187+834] += + s[834];
gout[n*2187+835] += + s[835];
gout[n*2187+836] += + s[836];
gout[n*2187+837] += + s[837];
gout[n*2187+838] += + s[838];
gout[n*2187+839] += + s[839];
gout[n*2187+840] += + s[840];
gout[n*2187+841] += + s[841];
gout[n*2187+842] += + s[842];
gout[n*2187+843] += + s[843];
gout[n*2187+844] += + s[844];
gout[n*2187+845] += + s[845];
gout[n*2187+846] += + s[846];
gout[n*2187+847] += + s[847];
gout[n*2187+848] += + s[848];
gout[n*2187+849] += + s[849];
gout[n*2187+850] += + s[850];
gout[n*2187+851] += + s[851];
gout[n*2187+852] += + s[852];
gout[n*2187+853] += + s[853];
gout[n*2187+854] += + s[854];
gout[n*2187+855] += + s[855];
gout[n*2187+856] += + s[856];
gout[n*2187+857] += + s[857];
gout[n*2187+858] += + s[858];
gout[n*2187+859] += + s[859];
gout[n*2187+860] += + s[860];
gout[n*2187+861] += + s[861];
gout[n*2187+862] += + s[862];
gout[n*2187+863] += + s[863];
gout[n*2187+864] += + s[864];
gout[n*2187+865] += + s[865];
gout[n*2187+866] += + s[866];
gout[n*2187+867] += + s[867];
gout[n*2187+868] += + s[868];
gout[n*2187+869] += + s[869];
gout[n*2187+870] += + s[870];
gout[n*2187+871] += + s[871];
gout[n*2187+872] += + s[872];
gout[n*2187+873] += + s[873];
gout[n*2187+874] += + s[874];
gout[n*2187+875] += + s[875];
gout[n*2187+876] += + s[876];
gout[n*2187+877] += + s[877];
gout[n*2187+878] += + s[878];
gout[n*2187+879] += + s[879];
gout[n*2187+880] += + s[880];
gout[n*2187+881] += + s[881];
gout[n*2187+882] += + s[882];
gout[n*2187+883] += + s[883];
gout[n*2187+884] += + s[884];
gout[n*2187+885] += + s[885];
gout[n*2187+886] += + s[886];
gout[n*2187+887] += + s[887];
gout[n*2187+888] += + s[888];
gout[n*2187+889] += + s[889];
gout[n*2187+890] += + s[890];
gout[n*2187+891] += + s[891];
gout[n*2187+892] += + s[892];
gout[n*2187+893] += + s[893];
gout[n*2187+894] += + s[894];
gout[n*2187+895] += + s[895];
gout[n*2187+896] += + s[896];
gout[n*2187+897] += + s[897];
gout[n*2187+898] += + s[898];
gout[n*2187+899] += + s[899];
gout[n*2187+900] += + s[900];
gout[n*2187+901] += + s[901];
gout[n*2187+902] += + s[902];
gout[n*2187+903] += + s[903];
gout[n*2187+904] += + s[904];
gout[n*2187+905] += + s[905];
gout[n*2187+906] += + s[906];
gout[n*2187+907] += + s[907];
gout[n*2187+908] += + s[908];
gout[n*2187+909] += + s[909];
gout[n*2187+910] += + s[910];
gout[n*2187+911] += + s[911];
gout[n*2187+912] += + s[912];
gout[n*2187+913] += + s[913];
gout[n*2187+914] += + s[914];
gout[n*2187+915] += + s[915];
gout[n*2187+916] += + s[916];
gout[n*2187+917] += + s[917];
gout[n*2187+918] += + s[918];
gout[n*2187+919] += + s[919];
gout[n*2187+920] += + s[920];
gout[n*2187+921] += + s[921];
gout[n*2187+922] += + s[922];
gout[n*2187+923] += + s[923];
gout[n*2187+924] += + s[924];
gout[n*2187+925] += + s[925];
gout[n*2187+926] += + s[926];
gout[n*2187+927] += + s[927];
gout[n*2187+928] += + s[928];
gout[n*2187+929] += + s[929];
gout[n*2187+930] += + s[930];
gout[n*2187+931] += + s[931];
gout[n*2187+932] += + s[932];
gout[n*2187+933] += + s[933];
gout[n*2187+934] += + s[934];
gout[n*2187+935] += + s[935];
gout[n*2187+936] += + s[936];
gout[n*2187+937] += + s[937];
gout[n*2187+938] += + s[938];
gout[n*2187+939] += + s[939];
gout[n*2187+940] += + s[940];
gout[n*2187+941] += + s[941];
gout[n*2187+942] += + s[942];
gout[n*2187+943] += + s[943];
gout[n*2187+944] += + s[944];
gout[n*2187+945] += + s[945];
gout[n*2187+946] += + s[946];
gout[n*2187+947] += + s[947];
gout[n*2187+948] += + s[948];
gout[n*2187+949] += + s[949];
gout[n*2187+950] += + s[950];
gout[n*2187+951] += + s[951];
gout[n*2187+952] += + s[952];
gout[n*2187+953] += + s[953];
gout[n*2187+954] += + s[954];
gout[n*2187+955] += + s[955];
gout[n*2187+956] += + s[956];
gout[n*2187+957] += + s[957];
gout[n*2187+958] += + s[958];
gout[n*2187+959] += + s[959];
gout[n*2187+960] += + s[960];
gout[n*2187+961] += + s[961];
gout[n*2187+962] += + s[962];
gout[n*2187+963] += + s[963];
gout[n*2187+964] += + s[964];
gout[n*2187+965] += + s[965];
gout[n*2187+966] += + s[966];
gout[n*2187+967] += + s[967];
gout[n*2187+968] += + s[968];
gout[n*2187+969] += + s[969];
gout[n*2187+970] += + s[970];
gout[n*2187+971] += + s[971];
gout[n*2187+972] += + s[972];
gout[n*2187+973] += + s[973];
gout[n*2187+974] += + s[974];
gout[n*2187+975] += + s[975];
gout[n*2187+976] += + s[976];
gout[n*2187+977] += + s[977];
gout[n*2187+978] += + s[978];
gout[n*2187+979] += + s[979];
gout[n*2187+980] += + s[980];
gout[n*2187+981] += + s[981];
gout[n*2187+982] += + s[982];
gout[n*2187+983] += + s[983];
gout[n*2187+984] += + s[984];
gout[n*2187+985] += + s[985];
gout[n*2187+986] += + s[986];
gout[n*2187+987] += + s[987];
gout[n*2187+988] += + s[988];
gout[n*2187+989] += + s[989];
gout[n*2187+990] += + s[990];
gout[n*2187+991] += + s[991];
gout[n*2187+992] += + s[992];
gout[n*2187+993] += + s[993];
gout[n*2187+994] += + s[994];
gout[n*2187+995] += + s[995];
gout[n*2187+996] += + s[996];
gout[n*2187+997] += + s[997];
gout[n*2187+998] += + s[998];
gout[n*2187+999] += + s[999];
gout[n*2187+1000] += + s[1000];
gout[n*2187+1001] += + s[1001];
gout[n*2187+1002] += + s[1002];
gout[n*2187+1003] += + s[1003];
gout[n*2187+1004] += + s[1004];
gout[n*2187+1005] += + s[1005];
gout[n*2187+1006] += + s[1006];
gout[n*2187+1007] += + s[1007];
gout[n*2187+1008] += + s[1008];
gout[n*2187+1009] += + s[1009];
gout[n*2187+1010] += + s[1010];
gout[n*2187+1011] += + s[1011];
gout[n*2187+1012] += + s[1012];
gout[n*2187+1013] += + s[1013];
gout[n*2187+1014] += + s[1014];
gout[n*2187+1015] += + s[1015];
gout[n*2187+1016] += + s[1016];
gout[n*2187+1017] += + s[1017];
gout[n*2187+1018] += + s[1018];
gout[n*2187+1019] += + s[1019];
gout[n*2187+1020] += + s[1020];
gout[n*2187+1021] += + s[1021];
gout[n*2187+1022] += + s[1022];
gout[n*2187+1023] += + s[1023];
gout[n*2187+1024] += + s[1024];
gout[n*2187+1025] += + s[1025];
gout[n*2187+1026] += + s[1026];
gout[n*2187+1027] += + s[1027];
gout[n*2187+1028] += + s[1028];
gout[n*2187+1029] += + s[1029];
gout[n*2187+1030] += + s[1030];
gout[n*2187+1031] += + s[1031];
gout[n*2187+1032] += + s[1032];
gout[n*2187+1033] += + s[1033];
gout[n*2187+1034] += + s[1034];
gout[n*2187+1035] += + s[1035];
gout[n*2187+1036] += + s[1036];
gout[n*2187+1037] += + s[1037];
gout[n*2187+1038] += + s[1038];
gout[n*2187+1039] += + s[1039];
gout[n*2187+1040] += + s[1040];
gout[n*2187+1041] += + s[1041];
gout[n*2187+1042] += + s[1042];
gout[n*2187+1043] += + s[1043];
gout[n*2187+1044] += + s[1044];
gout[n*2187+1045] += + s[1045];
gout[n*2187+1046] += + s[1046];
gout[n*2187+1047] += + s[1047];
gout[n*2187+1048] += + s[1048];
gout[n*2187+1049] += + s[1049];
gout[n*2187+1050] += + s[1050];
gout[n*2187+1051] += + s[1051];
gout[n*2187+1052] += + s[1052];
gout[n*2187+1053] += + s[1053];
gout[n*2187+1054] += + s[1054];
gout[n*2187+1055] += + s[1055];
gout[n*2187+1056] += + s[1056];
gout[n*2187+1057] += + s[1057];
gout[n*2187+1058] += + s[1058];
gout[n*2187+1059] += + s[1059];
gout[n*2187+1060] += + s[1060];
gout[n*2187+1061] += + s[1061];
gout[n*2187+1062] += + s[1062];
gout[n*2187+1063] += + s[1063];
gout[n*2187+1064] += + s[1064];
gout[n*2187+1065] += + s[1065];
gout[n*2187+1066] += + s[1066];
gout[n*2187+1067] += + s[1067];
gout[n*2187+1068] += + s[1068];
gout[n*2187+1069] += + s[1069];
gout[n*2187+1070] += + s[1070];
gout[n*2187+1071] += + s[1071];
gout[n*2187+1072] += + s[1072];
gout[n*2187+1073] += + s[1073];
gout[n*2187+1074] += + s[1074];
gout[n*2187+1075] += + s[1075];
gout[n*2187+1076] += + s[1076];
gout[n*2187+1077] += + s[1077];
gout[n*2187+1078] += + s[1078];
gout[n*2187+1079] += + s[1079];
gout[n*2187+1080] += + s[1080];
gout[n*2187+1081] += + s[1081];
gout[n*2187+1082] += + s[1082];
gout[n*2187+1083] += + s[1083];
gout[n*2187+1084] += + s[1084];
gout[n*2187+1085] += + s[1085];
gout[n*2187+1086] += + s[1086];
gout[n*2187+1087] += + s[1087];
gout[n*2187+1088] += + s[1088];
gout[n*2187+1089] += + s[1089];
gout[n*2187+1090] += + s[1090];
gout[n*2187+1091] += + s[1091];
gout[n*2187+1092] += + s[1092];
gout[n*2187+1093] += + s[1093];
gout[n*2187+1094] += + s[1094];
gout[n*2187+1095] += + s[1095];
gout[n*2187+1096] += + s[1096];
gout[n*2187+1097] += + s[1097];
gout[n*2187+1098] += + s[1098];
gout[n*2187+1099] += + s[1099];
gout[n*2187+1100] += + s[1100];
gout[n*2187+1101] += + s[1101];
gout[n*2187+1102] += + s[1102];
gout[n*2187+1103] += + s[1103];
gout[n*2187+1104] += + s[1104];
gout[n*2187+1105] += + s[1105];
gout[n*2187+1106] += + s[1106];
gout[n*2187+1107] += + s[1107];
gout[n*2187+1108] += + s[1108];
gout[n*2187+1109] += + s[1109];
gout[n*2187+1110] += + s[1110];
gout[n*2187+1111] += + s[1111];
gout[n*2187+1112] += + s[1112];
gout[n*2187+1113] += + s[1113];
gout[n*2187+1114] += + s[1114];
gout[n*2187+1115] += + s[1115];
gout[n*2187+1116] += + s[1116];
gout[n*2187+1117] += + s[1117];
gout[n*2187+1118] += + s[1118];
gout[n*2187+1119] += + s[1119];
gout[n*2187+1120] += + s[1120];
gout[n*2187+1121] += + s[1121];
gout[n*2187+1122] += + s[1122];
gout[n*2187+1123] += + s[1123];
gout[n*2187+1124] += + s[1124];
gout[n*2187+1125] += + s[1125];
gout[n*2187+1126] += + s[1126];
gout[n*2187+1127] += + s[1127];
gout[n*2187+1128] += + s[1128];
gout[n*2187+1129] += + s[1129];
gout[n*2187+1130] += + s[1130];
gout[n*2187+1131] += + s[1131];
gout[n*2187+1132] += + s[1132];
gout[n*2187+1133] += + s[1133];
gout[n*2187+1134] += + s[1134];
gout[n*2187+1135] += + s[1135];
gout[n*2187+1136] += + s[1136];
gout[n*2187+1137] += + s[1137];
gout[n*2187+1138] += + s[1138];
gout[n*2187+1139] += + s[1139];
gout[n*2187+1140] += + s[1140];
gout[n*2187+1141] += + s[1141];
gout[n*2187+1142] += + s[1142];
gout[n*2187+1143] += + s[1143];
gout[n*2187+1144] += + s[1144];
gout[n*2187+1145] += + s[1145];
gout[n*2187+1146] += + s[1146];
gout[n*2187+1147] += + s[1147];
gout[n*2187+1148] += + s[1148];
gout[n*2187+1149] += + s[1149];
gout[n*2187+1150] += + s[1150];
gout[n*2187+1151] += + s[1151];
gout[n*2187+1152] += + s[1152];
gout[n*2187+1153] += + s[1153];
gout[n*2187+1154] += + s[1154];
gout[n*2187+1155] += + s[1155];
gout[n*2187+1156] += + s[1156];
gout[n*2187+1157] += + s[1157];
gout[n*2187+1158] += + s[1158];
gout[n*2187+1159] += + s[1159];
gout[n*2187+1160] += + s[1160];
gout[n*2187+1161] += + s[1161];
gout[n*2187+1162] += + s[1162];
gout[n*2187+1163] += + s[1163];
gout[n*2187+1164] += + s[1164];
gout[n*2187+1165] += + s[1165];
gout[n*2187+1166] += + s[1166];
gout[n*2187+1167] += + s[1167];
gout[n*2187+1168] += + s[1168];
gout[n*2187+1169] += + s[1169];
gout[n*2187+1170] += + s[1170];
gout[n*2187+1171] += + s[1171];
gout[n*2187+1172] += + s[1172];
gout[n*2187+1173] += + s[1173];
gout[n*2187+1174] += + s[1174];
gout[n*2187+1175] += + s[1175];
gout[n*2187+1176] += + s[1176];
gout[n*2187+1177] += + s[1177];
gout[n*2187+1178] += + s[1178];
gout[n*2187+1179] += + s[1179];
gout[n*2187+1180] += + s[1180];
gout[n*2187+1181] += + s[1181];
gout[n*2187+1182] += + s[1182];
gout[n*2187+1183] += + s[1183];
gout[n*2187+1184] += + s[1184];
gout[n*2187+1185] += + s[1185];
gout[n*2187+1186] += + s[1186];
gout[n*2187+1187] += + s[1187];
gout[n*2187+1188] += + s[1188];
gout[n*2187+1189] += + s[1189];
gout[n*2187+1190] += + s[1190];
gout[n*2187+1191] += + s[1191];
gout[n*2187+1192] += + s[1192];
gout[n*2187+1193] += + s[1193];
gout[n*2187+1194] += + s[1194];
gout[n*2187+1195] += + s[1195];
gout[n*2187+1196] += + s[1196];
gout[n*2187+1197] += + s[1197];
gout[n*2187+1198] += + s[1198];
gout[n*2187+1199] += + s[1199];
gout[n*2187+1200] += + s[1200];
gout[n*2187+1201] += + s[1201];
gout[n*2187+1202] += + s[1202];
gout[n*2187+1203] += + s[1203];
gout[n*2187+1204] += + s[1204];
gout[n*2187+1205] += + s[1205];
gout[n*2187+1206] += + s[1206];
gout[n*2187+1207] += + s[1207];
gout[n*2187+1208] += + s[1208];
gout[n*2187+1209] += + s[1209];
gout[n*2187+1210] += + s[1210];
gout[n*2187+1211] += + s[1211];
gout[n*2187+1212] += + s[1212];
gout[n*2187+1213] += + s[1213];
gout[n*2187+1214] += + s[1214];
gout[n*2187+1215] += + s[1215];
gout[n*2187+1216] += + s[1216];
gout[n*2187+1217] += + s[1217];
gout[n*2187+1218] += + s[1218];
gout[n*2187+1219] += + s[1219];
gout[n*2187+1220] += + s[1220];
gout[n*2187+1221] += + s[1221];
gout[n*2187+1222] += + s[1222];
gout[n*2187+1223] += + s[1223];
gout[n*2187+1224] += + s[1224];
gout[n*2187+1225] += + s[1225];
gout[n*2187+1226] += + s[1226];
gout[n*2187+1227] += + s[1227];
gout[n*2187+1228] += + s[1228];
gout[n*2187+1229] += + s[1229];
gout[n*2187+1230] += + s[1230];
gout[n*2187+1231] += + s[1231];
gout[n*2187+1232] += + s[1232];
gout[n*2187+1233] += + s[1233];
gout[n*2187+1234] += + s[1234];
gout[n*2187+1235] += + s[1235];
gout[n*2187+1236] += + s[1236];
gout[n*2187+1237] += + s[1237];
gout[n*2187+1238] += + s[1238];
gout[n*2187+1239] += + s[1239];
gout[n*2187+1240] += + s[1240];
gout[n*2187+1241] += + s[1241];
gout[n*2187+1242] += + s[1242];
gout[n*2187+1243] += + s[1243];
gout[n*2187+1244] += + s[1244];
gout[n*2187+1245] += + s[1245];
gout[n*2187+1246] += + s[1246];
gout[n*2187+1247] += + s[1247];
gout[n*2187+1248] += + s[1248];
gout[n*2187+1249] += + s[1249];
gout[n*2187+1250] += + s[1250];
gout[n*2187+1251] += + s[1251];
gout[n*2187+1252] += + s[1252];
gout[n*2187+1253] += + s[1253];
gout[n*2187+1254] += + s[1254];
gout[n*2187+1255] += + s[1255];
gout[n*2187+1256] += + s[1256];
gout[n*2187+1257] += + s[1257];
gout[n*2187+1258] += + s[1258];
gout[n*2187+1259] += + s[1259];
gout[n*2187+1260] += + s[1260];
gout[n*2187+1261] += + s[1261];
gout[n*2187+1262] += + s[1262];
gout[n*2187+1263] += + s[1263];
gout[n*2187+1264] += + s[1264];
gout[n*2187+1265] += + s[1265];
gout[n*2187+1266] += + s[1266];
gout[n*2187+1267] += + s[1267];
gout[n*2187+1268] += + s[1268];
gout[n*2187+1269] += + s[1269];
gout[n*2187+1270] += + s[1270];
gout[n*2187+1271] += + s[1271];
gout[n*2187+1272] += + s[1272];
gout[n*2187+1273] += + s[1273];
gout[n*2187+1274] += + s[1274];
gout[n*2187+1275] += + s[1275];
gout[n*2187+1276] += + s[1276];
gout[n*2187+1277] += + s[1277];
gout[n*2187+1278] += + s[1278];
gout[n*2187+1279] += + s[1279];
gout[n*2187+1280] += + s[1280];
gout[n*2187+1281] += + s[1281];
gout[n*2187+1282] += + s[1282];
gout[n*2187+1283] += + s[1283];
gout[n*2187+1284] += + s[1284];
gout[n*2187+1285] += + s[1285];
gout[n*2187+1286] += + s[1286];
gout[n*2187+1287] += + s[1287];
gout[n*2187+1288] += + s[1288];
gout[n*2187+1289] += + s[1289];
gout[n*2187+1290] += + s[1290];
gout[n*2187+1291] += + s[1291];
gout[n*2187+1292] += + s[1292];
gout[n*2187+1293] += + s[1293];
gout[n*2187+1294] += + s[1294];
gout[n*2187+1295] += + s[1295];
gout[n*2187+1296] += + s[1296];
gout[n*2187+1297] += + s[1297];
gout[n*2187+1298] += + s[1298];
gout[n*2187+1299] += + s[1299];
gout[n*2187+1300] += + s[1300];
gout[n*2187+1301] += + s[1301];
gout[n*2187+1302] += + s[1302];
gout[n*2187+1303] += + s[1303];
gout[n*2187+1304] += + s[1304];
gout[n*2187+1305] += + s[1305];
gout[n*2187+1306] += + s[1306];
gout[n*2187+1307] += + s[1307];
gout[n*2187+1308] += + s[1308];
gout[n*2187+1309] += + s[1309];
gout[n*2187+1310] += + s[1310];
gout[n*2187+1311] += + s[1311];
gout[n*2187+1312] += + s[1312];
gout[n*2187+1313] += + s[1313];
gout[n*2187+1314] += + s[1314];
gout[n*2187+1315] += + s[1315];
gout[n*2187+1316] += + s[1316];
gout[n*2187+1317] += + s[1317];
gout[n*2187+1318] += + s[1318];
gout[n*2187+1319] += + s[1319];
gout[n*2187+1320] += + s[1320];
gout[n*2187+1321] += + s[1321];
gout[n*2187+1322] += + s[1322];
gout[n*2187+1323] += + s[1323];
gout[n*2187+1324] += + s[1324];
gout[n*2187+1325] += + s[1325];
gout[n*2187+1326] += + s[1326];
gout[n*2187+1327] += + s[1327];
gout[n*2187+1328] += + s[1328];
gout[n*2187+1329] += + s[1329];
gout[n*2187+1330] += + s[1330];
gout[n*2187+1331] += + s[1331];
gout[n*2187+1332] += + s[1332];
gout[n*2187+1333] += + s[1333];
gout[n*2187+1334] += + s[1334];
gout[n*2187+1335] += + s[1335];
gout[n*2187+1336] += + s[1336];
gout[n*2187+1337] += + s[1337];
gout[n*2187+1338] += + s[1338];
gout[n*2187+1339] += + s[1339];
gout[n*2187+1340] += + s[1340];
gout[n*2187+1341] += + s[1341];
gout[n*2187+1342] += + s[1342];
gout[n*2187+1343] += + s[1343];
gout[n*2187+1344] += + s[1344];
gout[n*2187+1345] += + s[1345];
gout[n*2187+1346] += + s[1346];
gout[n*2187+1347] += + s[1347];
gout[n*2187+1348] += + s[1348];
gout[n*2187+1349] += + s[1349];
gout[n*2187+1350] += + s[1350];
gout[n*2187+1351] += + s[1351];
gout[n*2187+1352] += + s[1352];
gout[n*2187+1353] += + s[1353];
gout[n*2187+1354] += + s[1354];
gout[n*2187+1355] += + s[1355];
gout[n*2187+1356] += + s[1356];
gout[n*2187+1357] += + s[1357];
gout[n*2187+1358] += + s[1358];
gout[n*2187+1359] += + s[1359];
gout[n*2187+1360] += + s[1360];
gout[n*2187+1361] += + s[1361];
gout[n*2187+1362] += + s[1362];
gout[n*2187+1363] += + s[1363];
gout[n*2187+1364] += + s[1364];
gout[n*2187+1365] += + s[1365];
gout[n*2187+1366] += + s[1366];
gout[n*2187+1367] += + s[1367];
gout[n*2187+1368] += + s[1368];
gout[n*2187+1369] += + s[1369];
gout[n*2187+1370] += + s[1370];
gout[n*2187+1371] += + s[1371];
gout[n*2187+1372] += + s[1372];
gout[n*2187+1373] += + s[1373];
gout[n*2187+1374] += + s[1374];
gout[n*2187+1375] += + s[1375];
gout[n*2187+1376] += + s[1376];
gout[n*2187+1377] += + s[1377];
gout[n*2187+1378] += + s[1378];
gout[n*2187+1379] += + s[1379];
gout[n*2187+1380] += + s[1380];
gout[n*2187+1381] += + s[1381];
gout[n*2187+1382] += + s[1382];
gout[n*2187+1383] += + s[1383];
gout[n*2187+1384] += + s[1384];
gout[n*2187+1385] += + s[1385];
gout[n*2187+1386] += + s[1386];
gout[n*2187+1387] += + s[1387];
gout[n*2187+1388] += + s[1388];
gout[n*2187+1389] += + s[1389];
gout[n*2187+1390] += + s[1390];
gout[n*2187+1391] += + s[1391];
gout[n*2187+1392] += + s[1392];
gout[n*2187+1393] += + s[1393];
gout[n*2187+1394] += + s[1394];
gout[n*2187+1395] += + s[1395];
gout[n*2187+1396] += + s[1396];
gout[n*2187+1397] += + s[1397];
gout[n*2187+1398] += + s[1398];
gout[n*2187+1399] += + s[1399];
gout[n*2187+1400] += + s[1400];
gout[n*2187+1401] += + s[1401];
gout[n*2187+1402] += + s[1402];
gout[n*2187+1403] += + s[1403];
gout[n*2187+1404] += + s[1404];
gout[n*2187+1405] += + s[1405];
gout[n*2187+1406] += + s[1406];
gout[n*2187+1407] += + s[1407];
gout[n*2187+1408] += + s[1408];
gout[n*2187+1409] += + s[1409];
gout[n*2187+1410] += + s[1410];
gout[n*2187+1411] += + s[1411];
gout[n*2187+1412] += + s[1412];
gout[n*2187+1413] += + s[1413];
gout[n*2187+1414] += + s[1414];
gout[n*2187+1415] += + s[1415];
gout[n*2187+1416] += + s[1416];
gout[n*2187+1417] += + s[1417];
gout[n*2187+1418] += + s[1418];
gout[n*2187+1419] += + s[1419];
gout[n*2187+1420] += + s[1420];
gout[n*2187+1421] += + s[1421];
gout[n*2187+1422] += + s[1422];
gout[n*2187+1423] += + s[1423];
gout[n*2187+1424] += + s[1424];
gout[n*2187+1425] += + s[1425];
gout[n*2187+1426] += + s[1426];
gout[n*2187+1427] += + s[1427];
gout[n*2187+1428] += + s[1428];
gout[n*2187+1429] += + s[1429];
gout[n*2187+1430] += + s[1430];
gout[n*2187+1431] += + s[1431];
gout[n*2187+1432] += + s[1432];
gout[n*2187+1433] += + s[1433];
gout[n*2187+1434] += + s[1434];
gout[n*2187+1435] += + s[1435];
gout[n*2187+1436] += + s[1436];
gout[n*2187+1437] += + s[1437];
gout[n*2187+1438] += + s[1438];
gout[n*2187+1439] += + s[1439];
gout[n*2187+1440] += + s[1440];
gout[n*2187+1441] += + s[1441];
gout[n*2187+1442] += + s[1442];
gout[n*2187+1443] += + s[1443];
gout[n*2187+1444] += + s[1444];
gout[n*2187+1445] += + s[1445];
gout[n*2187+1446] += + s[1446];
gout[n*2187+1447] += + s[1447];
gout[n*2187+1448] += + s[1448];
gout[n*2187+1449] += + s[1449];
gout[n*2187+1450] += + s[1450];
gout[n*2187+1451] += + s[1451];
gout[n*2187+1452] += + s[1452];
gout[n*2187+1453] += + s[1453];
gout[n*2187+1454] += + s[1454];
gout[n*2187+1455] += + s[1455];
gout[n*2187+1456] += + s[1456];
gout[n*2187+1457] += + s[1457];
gout[n*2187+1458] += + s[1458];
gout[n*2187+1459] += + s[1459];
gout[n*2187+1460] += + s[1460];
gout[n*2187+1461] += + s[1461];
gout[n*2187+1462] += + s[1462];
gout[n*2187+1463] += + s[1463];
gout[n*2187+1464] += + s[1464];
gout[n*2187+1465] += + s[1465];
gout[n*2187+1466] += + s[1466];
gout[n*2187+1467] += + s[1467];
gout[n*2187+1468] += + s[1468];
gout[n*2187+1469] += + s[1469];
gout[n*2187+1470] += + s[1470];
gout[n*2187+1471] += + s[1471];
gout[n*2187+1472] += + s[1472];
gout[n*2187+1473] += + s[1473];
gout[n*2187+1474] += + s[1474];
gout[n*2187+1475] += + s[1475];
gout[n*2187+1476] += + s[1476];
gout[n*2187+1477] += + s[1477];
gout[n*2187+1478] += + s[1478];
gout[n*2187+1479] += + s[1479];
gout[n*2187+1480] += + s[1480];
gout[n*2187+1481] += + s[1481];
gout[n*2187+1482] += + s[1482];
gout[n*2187+1483] += + s[1483];
gout[n*2187+1484] += + s[1484];
gout[n*2187+1485] += + s[1485];
gout[n*2187+1486] += + s[1486];
gout[n*2187+1487] += + s[1487];
gout[n*2187+1488] += + s[1488];
gout[n*2187+1489] += + s[1489];
gout[n*2187+1490] += + s[1490];
gout[n*2187+1491] += + s[1491];
gout[n*2187+1492] += + s[1492];
gout[n*2187+1493] += + s[1493];
gout[n*2187+1494] += + s[1494];
gout[n*2187+1495] += + s[1495];
gout[n*2187+1496] += + s[1496];
gout[n*2187+1497] += + s[1497];
gout[n*2187+1498] += + s[1498];
gout[n*2187+1499] += + s[1499];
gout[n*2187+1500] += + s[1500];
gout[n*2187+1501] += + s[1501];
gout[n*2187+1502] += + s[1502];
gout[n*2187+1503] += + s[1503];
gout[n*2187+1504] += + s[1504];
gout[n*2187+1505] += + s[1505];
gout[n*2187+1506] += + s[1506];
gout[n*2187+1507] += + s[1507];
gout[n*2187+1508] += + s[1508];
gout[n*2187+1509] += + s[1509];
gout[n*2187+1510] += + s[1510];
gout[n*2187+1511] += + s[1511];
gout[n*2187+1512] += + s[1512];
gout[n*2187+1513] += + s[1513];
gout[n*2187+1514] += + s[1514];
gout[n*2187+1515] += + s[1515];
gout[n*2187+1516] += + s[1516];
gout[n*2187+1517] += + s[1517];
gout[n*2187+1518] += + s[1518];
gout[n*2187+1519] += + s[1519];
gout[n*2187+1520] += + s[1520];
gout[n*2187+1521] += + s[1521];
gout[n*2187+1522] += + s[1522];
gout[n*2187+1523] += + s[1523];
gout[n*2187+1524] += + s[1524];
gout[n*2187+1525] += + s[1525];
gout[n*2187+1526] += + s[1526];
gout[n*2187+1527] += + s[1527];
gout[n*2187+1528] += + s[1528];
gout[n*2187+1529] += + s[1529];
gout[n*2187+1530] += + s[1530];
gout[n*2187+1531] += + s[1531];
gout[n*2187+1532] += + s[1532];
gout[n*2187+1533] += + s[1533];
gout[n*2187+1534] += + s[1534];
gout[n*2187+1535] += + s[1535];
gout[n*2187+1536] += + s[1536];
gout[n*2187+1537] += + s[1537];
gout[n*2187+1538] += + s[1538];
gout[n*2187+1539] += + s[1539];
gout[n*2187+1540] += + s[1540];
gout[n*2187+1541] += + s[1541];
gout[n*2187+1542] += + s[1542];
gout[n*2187+1543] += + s[1543];
gout[n*2187+1544] += + s[1544];
gout[n*2187+1545] += + s[1545];
gout[n*2187+1546] += + s[1546];
gout[n*2187+1547] += + s[1547];
gout[n*2187+1548] += + s[1548];
gout[n*2187+1549] += + s[1549];
gout[n*2187+1550] += + s[1550];
gout[n*2187+1551] += + s[1551];
gout[n*2187+1552] += + s[1552];
gout[n*2187+1553] += + s[1553];
gout[n*2187+1554] += + s[1554];
gout[n*2187+1555] += + s[1555];
gout[n*2187+1556] += + s[1556];
gout[n*2187+1557] += + s[1557];
gout[n*2187+1558] += + s[1558];
gout[n*2187+1559] += + s[1559];
gout[n*2187+1560] += + s[1560];
gout[n*2187+1561] += + s[1561];
gout[n*2187+1562] += + s[1562];
gout[n*2187+1563] += + s[1563];
gout[n*2187+1564] += + s[1564];
gout[n*2187+1565] += + s[1565];
gout[n*2187+1566] += + s[1566];
gout[n*2187+1567] += + s[1567];
gout[n*2187+1568] += + s[1568];
gout[n*2187+1569] += + s[1569];
gout[n*2187+1570] += + s[1570];
gout[n*2187+1571] += + s[1571];
gout[n*2187+1572] += + s[1572];
gout[n*2187+1573] += + s[1573];
gout[n*2187+1574] += + s[1574];
gout[n*2187+1575] += + s[1575];
gout[n*2187+1576] += + s[1576];
gout[n*2187+1577] += + s[1577];
gout[n*2187+1578] += + s[1578];
gout[n*2187+1579] += + s[1579];
gout[n*2187+1580] += + s[1580];
gout[n*2187+1581] += + s[1581];
gout[n*2187+1582] += + s[1582];
gout[n*2187+1583] += + s[1583];
gout[n*2187+1584] += + s[1584];
gout[n*2187+1585] += + s[1585];
gout[n*2187+1586] += + s[1586];
gout[n*2187+1587] += + s[1587];
gout[n*2187+1588] += + s[1588];
gout[n*2187+1589] += + s[1589];
gout[n*2187+1590] += + s[1590];
gout[n*2187+1591] += + s[1591];
gout[n*2187+1592] += + s[1592];
gout[n*2187+1593] += + s[1593];
gout[n*2187+1594] += + s[1594];
gout[n*2187+1595] += + s[1595];
gout[n*2187+1596] += + s[1596];
gout[n*2187+1597] += + s[1597];
gout[n*2187+1598] += + s[1598];
gout[n*2187+1599] += + s[1599];
gout[n*2187+1600] += + s[1600];
gout[n*2187+1601] += + s[1601];
gout[n*2187+1602] += + s[1602];
gout[n*2187+1603] += + s[1603];
gout[n*2187+1604] += + s[1604];
gout[n*2187+1605] += + s[1605];
gout[n*2187+1606] += + s[1606];
gout[n*2187+1607] += + s[1607];
gout[n*2187+1608] += + s[1608];
gout[n*2187+1609] += + s[1609];
gout[n*2187+1610] += + s[1610];
gout[n*2187+1611] += + s[1611];
gout[n*2187+1612] += + s[1612];
gout[n*2187+1613] += + s[1613];
gout[n*2187+1614] += + s[1614];
gout[n*2187+1615] += + s[1615];
gout[n*2187+1616] += + s[1616];
gout[n*2187+1617] += + s[1617];
gout[n*2187+1618] += + s[1618];
gout[n*2187+1619] += + s[1619];
gout[n*2187+1620] += + s[1620];
gout[n*2187+1621] += + s[1621];
gout[n*2187+1622] += + s[1622];
gout[n*2187+1623] += + s[1623];
gout[n*2187+1624] += + s[1624];
gout[n*2187+1625] += + s[1625];
gout[n*2187+1626] += + s[1626];
gout[n*2187+1627] += + s[1627];
gout[n*2187+1628] += + s[1628];
gout[n*2187+1629] += + s[1629];
gout[n*2187+1630] += + s[1630];
gout[n*2187+1631] += + s[1631];
gout[n*2187+1632] += + s[1632];
gout[n*2187+1633] += + s[1633];
gout[n*2187+1634] += + s[1634];
gout[n*2187+1635] += + s[1635];
gout[n*2187+1636] += + s[1636];
gout[n*2187+1637] += + s[1637];
gout[n*2187+1638] += + s[1638];
gout[n*2187+1639] += + s[1639];
gout[n*2187+1640] += + s[1640];
gout[n*2187+1641] += + s[1641];
gout[n*2187+1642] += + s[1642];
gout[n*2187+1643] += + s[1643];
gout[n*2187+1644] += + s[1644];
gout[n*2187+1645] += + s[1645];
gout[n*2187+1646] += + s[1646];
gout[n*2187+1647] += + s[1647];
gout[n*2187+1648] += + s[1648];
gout[n*2187+1649] += + s[1649];
gout[n*2187+1650] += + s[1650];
gout[n*2187+1651] += + s[1651];
gout[n*2187+1652] += + s[1652];
gout[n*2187+1653] += + s[1653];
gout[n*2187+1654] += + s[1654];
gout[n*2187+1655] += + s[1655];
gout[n*2187+1656] += + s[1656];
gout[n*2187+1657] += + s[1657];
gout[n*2187+1658] += + s[1658];
gout[n*2187+1659] += + s[1659];
gout[n*2187+1660] += + s[1660];
gout[n*2187+1661] += + s[1661];
gout[n*2187+1662] += + s[1662];
gout[n*2187+1663] += + s[1663];
gout[n*2187+1664] += + s[1664];
gout[n*2187+1665] += + s[1665];
gout[n*2187+1666] += + s[1666];
gout[n*2187+1667] += + s[1667];
gout[n*2187+1668] += + s[1668];
gout[n*2187+1669] += + s[1669];
gout[n*2187+1670] += + s[1670];
gout[n*2187+1671] += + s[1671];
gout[n*2187+1672] += + s[1672];
gout[n*2187+1673] += + s[1673];
gout[n*2187+1674] += + s[1674];
gout[n*2187+1675] += + s[1675];
gout[n*2187+1676] += + s[1676];
gout[n*2187+1677] += + s[1677];
gout[n*2187+1678] += + s[1678];
gout[n*2187+1679] += + s[1679];
gout[n*2187+1680] += + s[1680];
gout[n*2187+1681] += + s[1681];
gout[n*2187+1682] += + s[1682];
gout[n*2187+1683] += + s[1683];
gout[n*2187+1684] += + s[1684];
gout[n*2187+1685] += + s[1685];
gout[n*2187+1686] += + s[1686];
gout[n*2187+1687] += + s[1687];
gout[n*2187+1688] += + s[1688];
gout[n*2187+1689] += + s[1689];
gout[n*2187+1690] += + s[1690];
gout[n*2187+1691] += + s[1691];
gout[n*2187+1692] += + s[1692];
gout[n*2187+1693] += + s[1693];
gout[n*2187+1694] += + s[1694];
gout[n*2187+1695] += + s[1695];
gout[n*2187+1696] += + s[1696];
gout[n*2187+1697] += + s[1697];
gout[n*2187+1698] += + s[1698];
gout[n*2187+1699] += + s[1699];
gout[n*2187+1700] += + s[1700];
gout[n*2187+1701] += + s[1701];
gout[n*2187+1702] += + s[1702];
gout[n*2187+1703] += + s[1703];
gout[n*2187+1704] += + s[1704];
gout[n*2187+1705] += + s[1705];
gout[n*2187+1706] += + s[1706];
gout[n*2187+1707] += + s[1707];
gout[n*2187+1708] += + s[1708];
gout[n*2187+1709] += + s[1709];
gout[n*2187+1710] += + s[1710];
gout[n*2187+1711] += + s[1711];
gout[n*2187+1712] += + s[1712];
gout[n*2187+1713] += + s[1713];
gout[n*2187+1714] += + s[1714];
gout[n*2187+1715] += + s[1715];
gout[n*2187+1716] += + s[1716];
gout[n*2187+1717] += + s[1717];
gout[n*2187+1718] += + s[1718];
gout[n*2187+1719] += + s[1719];
gout[n*2187+1720] += + s[1720];
gout[n*2187+1721] += + s[1721];
gout[n*2187+1722] += + s[1722];
gout[n*2187+1723] += + s[1723];
gout[n*2187+1724] += + s[1724];
gout[n*2187+1725] += + s[1725];
gout[n*2187+1726] += + s[1726];
gout[n*2187+1727] += + s[1727];
gout[n*2187+1728] += + s[1728];
gout[n*2187+1729] += + s[1729];
gout[n*2187+1730] += + s[1730];
gout[n*2187+1731] += + s[1731];
gout[n*2187+1732] += + s[1732];
gout[n*2187+1733] += + s[1733];
gout[n*2187+1734] += + s[1734];
gout[n*2187+1735] += + s[1735];
gout[n*2187+1736] += + s[1736];
gout[n*2187+1737] += + s[1737];
gout[n*2187+1738] += + s[1738];
gout[n*2187+1739] += + s[1739];
gout[n*2187+1740] += + s[1740];
gout[n*2187+1741] += + s[1741];
gout[n*2187+1742] += + s[1742];
gout[n*2187+1743] += + s[1743];
gout[n*2187+1744] += + s[1744];
gout[n*2187+1745] += + s[1745];
gout[n*2187+1746] += + s[1746];
gout[n*2187+1747] += + s[1747];
gout[n*2187+1748] += + s[1748];
gout[n*2187+1749] += + s[1749];
gout[n*2187+1750] += + s[1750];
gout[n*2187+1751] += + s[1751];
gout[n*2187+1752] += + s[1752];
gout[n*2187+1753] += + s[1753];
gout[n*2187+1754] += + s[1754];
gout[n*2187+1755] += + s[1755];
gout[n*2187+1756] += + s[1756];
gout[n*2187+1757] += + s[1757];
gout[n*2187+1758] += + s[1758];
gout[n*2187+1759] += + s[1759];
gout[n*2187+1760] += + s[1760];
gout[n*2187+1761] += + s[1761];
gout[n*2187+1762] += + s[1762];
gout[n*2187+1763] += + s[1763];
gout[n*2187+1764] += + s[1764];
gout[n*2187+1765] += + s[1765];
gout[n*2187+1766] += + s[1766];
gout[n*2187+1767] += + s[1767];
gout[n*2187+1768] += + s[1768];
gout[n*2187+1769] += + s[1769];
gout[n*2187+1770] += + s[1770];
gout[n*2187+1771] += + s[1771];
gout[n*2187+1772] += + s[1772];
gout[n*2187+1773] += + s[1773];
gout[n*2187+1774] += + s[1774];
gout[n*2187+1775] += + s[1775];
gout[n*2187+1776] += + s[1776];
gout[n*2187+1777] += + s[1777];
gout[n*2187+1778] += + s[1778];
gout[n*2187+1779] += + s[1779];
gout[n*2187+1780] += + s[1780];
gout[n*2187+1781] += + s[1781];
gout[n*2187+1782] += + s[1782];
gout[n*2187+1783] += + s[1783];
gout[n*2187+1784] += + s[1784];
gout[n*2187+1785] += + s[1785];
gout[n*2187+1786] += + s[1786];
gout[n*2187+1787] += + s[1787];
gout[n*2187+1788] += + s[1788];
gout[n*2187+1789] += + s[1789];
gout[n*2187+1790] += + s[1790];
gout[n*2187+1791] += + s[1791];
gout[n*2187+1792] += + s[1792];
gout[n*2187+1793] += + s[1793];
gout[n*2187+1794] += + s[1794];
gout[n*2187+1795] += + s[1795];
gout[n*2187+1796] += + s[1796];
gout[n*2187+1797] += + s[1797];
gout[n*2187+1798] += + s[1798];
gout[n*2187+1799] += + s[1799];
gout[n*2187+1800] += + s[1800];
gout[n*2187+1801] += + s[1801];
gout[n*2187+1802] += + s[1802];
gout[n*2187+1803] += + s[1803];
gout[n*2187+1804] += + s[1804];
gout[n*2187+1805] += + s[1805];
gout[n*2187+1806] += + s[1806];
gout[n*2187+1807] += + s[1807];
gout[n*2187+1808] += + s[1808];
gout[n*2187+1809] += + s[1809];
gout[n*2187+1810] += + s[1810];
gout[n*2187+1811] += + s[1811];
gout[n*2187+1812] += + s[1812];
gout[n*2187+1813] += + s[1813];
gout[n*2187+1814] += + s[1814];
gout[n*2187+1815] += + s[1815];
gout[n*2187+1816] += + s[1816];
gout[n*2187+1817] += + s[1817];
gout[n*2187+1818] += + s[1818];
gout[n*2187+1819] += + s[1819];
gout[n*2187+1820] += + s[1820];
gout[n*2187+1821] += + s[1821];
gout[n*2187+1822] += + s[1822];
gout[n*2187+1823] += + s[1823];
gout[n*2187+1824] += + s[1824];
gout[n*2187+1825] += + s[1825];
gout[n*2187+1826] += + s[1826];
gout[n*2187+1827] += + s[1827];
gout[n*2187+1828] += + s[1828];
gout[n*2187+1829] += + s[1829];
gout[n*2187+1830] += + s[1830];
gout[n*2187+1831] += + s[1831];
gout[n*2187+1832] += + s[1832];
gout[n*2187+1833] += + s[1833];
gout[n*2187+1834] += + s[1834];
gout[n*2187+1835] += + s[1835];
gout[n*2187+1836] += + s[1836];
gout[n*2187+1837] += + s[1837];
gout[n*2187+1838] += + s[1838];
gout[n*2187+1839] += + s[1839];
gout[n*2187+1840] += + s[1840];
gout[n*2187+1841] += + s[1841];
gout[n*2187+1842] += + s[1842];
gout[n*2187+1843] += + s[1843];
gout[n*2187+1844] += + s[1844];
gout[n*2187+1845] += + s[1845];
gout[n*2187+1846] += + s[1846];
gout[n*2187+1847] += + s[1847];
gout[n*2187+1848] += + s[1848];
gout[n*2187+1849] += + s[1849];
gout[n*2187+1850] += + s[1850];
gout[n*2187+1851] += + s[1851];
gout[n*2187+1852] += + s[1852];
gout[n*2187+1853] += + s[1853];
gout[n*2187+1854] += + s[1854];
gout[n*2187+1855] += + s[1855];
gout[n*2187+1856] += + s[1856];
gout[n*2187+1857] += + s[1857];
gout[n*2187+1858] += + s[1858];
gout[n*2187+1859] += + s[1859];
gout[n*2187+1860] += + s[1860];
gout[n*2187+1861] += + s[1861];
gout[n*2187+1862] += + s[1862];
gout[n*2187+1863] += + s[1863];
gout[n*2187+1864] += + s[1864];
gout[n*2187+1865] += + s[1865];
gout[n*2187+1866] += + s[1866];
gout[n*2187+1867] += + s[1867];
gout[n*2187+1868] += + s[1868];
gout[n*2187+1869] += + s[1869];
gout[n*2187+1870] += + s[1870];
gout[n*2187+1871] += + s[1871];
gout[n*2187+1872] += + s[1872];
gout[n*2187+1873] += + s[1873];
gout[n*2187+1874] += + s[1874];
gout[n*2187+1875] += + s[1875];
gout[n*2187+1876] += + s[1876];
gout[n*2187+1877] += + s[1877];
gout[n*2187+1878] += + s[1878];
gout[n*2187+1879] += + s[1879];
gout[n*2187+1880] += + s[1880];
gout[n*2187+1881] += + s[1881];
gout[n*2187+1882] += + s[1882];
gout[n*2187+1883] += + s[1883];
gout[n*2187+1884] += + s[1884];
gout[n*2187+1885] += + s[1885];
gout[n*2187+1886] += + s[1886];
gout[n*2187+1887] += + s[1887];
gout[n*2187+1888] += + s[1888];
gout[n*2187+1889] += + s[1889];
gout[n*2187+1890] += + s[1890];
gout[n*2187+1891] += + s[1891];
gout[n*2187+1892] += + s[1892];
gout[n*2187+1893] += + s[1893];
gout[n*2187+1894] += + s[1894];
gout[n*2187+1895] += + s[1895];
gout[n*2187+1896] += + s[1896];
gout[n*2187+1897] += + s[1897];
gout[n*2187+1898] += + s[1898];
gout[n*2187+1899] += + s[1899];
gout[n*2187+1900] += + s[1900];
gout[n*2187+1901] += + s[1901];
gout[n*2187+1902] += + s[1902];
gout[n*2187+1903] += + s[1903];
gout[n*2187+1904] += + s[1904];
gout[n*2187+1905] += + s[1905];
gout[n*2187+1906] += + s[1906];
gout[n*2187+1907] += + s[1907];
gout[n*2187+1908] += + s[1908];
gout[n*2187+1909] += + s[1909];
gout[n*2187+1910] += + s[1910];
gout[n*2187+1911] += + s[1911];
gout[n*2187+1912] += + s[1912];
gout[n*2187+1913] += + s[1913];
gout[n*2187+1914] += + s[1914];
gout[n*2187+1915] += + s[1915];
gout[n*2187+1916] += + s[1916];
gout[n*2187+1917] += + s[1917];
gout[n*2187+1918] += + s[1918];
gout[n*2187+1919] += + s[1919];
gout[n*2187+1920] += + s[1920];
gout[n*2187+1921] += + s[1921];
gout[n*2187+1922] += + s[1922];
gout[n*2187+1923] += + s[1923];
gout[n*2187+1924] += + s[1924];
gout[n*2187+1925] += + s[1925];
gout[n*2187+1926] += + s[1926];
gout[n*2187+1927] += + s[1927];
gout[n*2187+1928] += + s[1928];
gout[n*2187+1929] += + s[1929];
gout[n*2187+1930] += + s[1930];
gout[n*2187+1931] += + s[1931];
gout[n*2187+1932] += + s[1932];
gout[n*2187+1933] += + s[1933];
gout[n*2187+1934] += + s[1934];
gout[n*2187+1935] += + s[1935];
gout[n*2187+1936] += + s[1936];
gout[n*2187+1937] += + s[1937];
gout[n*2187+1938] += + s[1938];
gout[n*2187+1939] += + s[1939];
gout[n*2187+1940] += + s[1940];
gout[n*2187+1941] += + s[1941];
gout[n*2187+1942] += + s[1942];
gout[n*2187+1943] += + s[1943];
gout[n*2187+1944] += + s[1944];
gout[n*2187+1945] += + s[1945];
gout[n*2187+1946] += + s[1946];
gout[n*2187+1947] += + s[1947];
gout[n*2187+1948] += + s[1948];
gout[n*2187+1949] += + s[1949];
gout[n*2187+1950] += + s[1950];
gout[n*2187+1951] += + s[1951];
gout[n*2187+1952] += + s[1952];
gout[n*2187+1953] += + s[1953];
gout[n*2187+1954] += + s[1954];
gout[n*2187+1955] += + s[1955];
gout[n*2187+1956] += + s[1956];
gout[n*2187+1957] += + s[1957];
gout[n*2187+1958] += + s[1958];
gout[n*2187+1959] += + s[1959];
gout[n*2187+1960] += + s[1960];
gout[n*2187+1961] += + s[1961];
gout[n*2187+1962] += + s[1962];
gout[n*2187+1963] += + s[1963];
gout[n*2187+1964] += + s[1964];
gout[n*2187+1965] += + s[1965];
gout[n*2187+1966] += + s[1966];
gout[n*2187+1967] += + s[1967];
gout[n*2187+1968] += + s[1968];
gout[n*2187+1969] += + s[1969];
gout[n*2187+1970] += + s[1970];
gout[n*2187+1971] += + s[1971];
gout[n*2187+1972] += + s[1972];
gout[n*2187+1973] += + s[1973];
gout[n*2187+1974] += + s[1974];
gout[n*2187+1975] += + s[1975];
gout[n*2187+1976] += + s[1976];
gout[n*2187+1977] += + s[1977];
gout[n*2187+1978] += + s[1978];
gout[n*2187+1979] += + s[1979];
gout[n*2187+1980] += + s[1980];
gout[n*2187+1981] += + s[1981];
gout[n*2187+1982] += + s[1982];
gout[n*2187+1983] += + s[1983];
gout[n*2187+1984] += + s[1984];
gout[n*2187+1985] += + s[1985];
gout[n*2187+1986] += + s[1986];
gout[n*2187+1987] += + s[1987];
gout[n*2187+1988] += + s[1988];
gout[n*2187+1989] += + s[1989];
gout[n*2187+1990] += + s[1990];
gout[n*2187+1991] += + s[1991];
gout[n*2187+1992] += + s[1992];
gout[n*2187+1993] += + s[1993];
gout[n*2187+1994] += + s[1994];
gout[n*2187+1995] += + s[1995];
gout[n*2187+1996] += + s[1996];
gout[n*2187+1997] += + s[1997];
gout[n*2187+1998] += + s[1998];
gout[n*2187+1999] += + s[1999];
gout[n*2187+2000] += + s[2000];
gout[n*2187+2001] += + s[2001];
gout[n*2187+2002] += + s[2002];
gout[n*2187+2003] += + s[2003];
gout[n*2187+2004] += + s[2004];
gout[n*2187+2005] += + s[2005];
gout[n*2187+2006] += + s[2006];
gout[n*2187+2007] += + s[2007];
gout[n*2187+2008] += + s[2008];
gout[n*2187+2009] += + s[2009];
gout[n*2187+2010] += + s[2010];
gout[n*2187+2011] += + s[2011];
gout[n*2187+2012] += + s[2012];
gout[n*2187+2013] += + s[2013];
gout[n*2187+2014] += + s[2014];
gout[n*2187+2015] += + s[2015];
gout[n*2187+2016] += + s[2016];
gout[n*2187+2017] += + s[2017];
gout[n*2187+2018] += + s[2018];
gout[n*2187+2019] += + s[2019];
gout[n*2187+2020] += + s[2020];
gout[n*2187+2021] += + s[2021];
gout[n*2187+2022] += + s[2022];
gout[n*2187+2023] += + s[2023];
gout[n*2187+2024] += + s[2024];
gout[n*2187+2025] += + s[2025];
gout[n*2187+2026] += + s[2026];
gout[n*2187+2027] += + s[2027];
gout[n*2187+2028] += + s[2028];
gout[n*2187+2029] += + s[2029];
gout[n*2187+2030] += + s[2030];
gout[n*2187+2031] += + s[2031];
gout[n*2187+2032] += + s[2032];
gout[n*2187+2033] += + s[2033];
gout[n*2187+2034] += + s[2034];
gout[n*2187+2035] += + s[2035];
gout[n*2187+2036] += + s[2036];
gout[n*2187+2037] += + s[2037];
gout[n*2187+2038] += + s[2038];
gout[n*2187+2039] += + s[2039];
gout[n*2187+2040] += + s[2040];
gout[n*2187+2041] += + s[2041];
gout[n*2187+2042] += + s[2042];
gout[n*2187+2043] += + s[2043];
gout[n*2187+2044] += + s[2044];
gout[n*2187+2045] += + s[2045];
gout[n*2187+2046] += + s[2046];
gout[n*2187+2047] += + s[2047];
gout[n*2187+2048] += + s[2048];
gout[n*2187+2049] += + s[2049];
gout[n*2187+2050] += + s[2050];
gout[n*2187+2051] += + s[2051];
gout[n*2187+2052] += + s[2052];
gout[n*2187+2053] += + s[2053];
gout[n*2187+2054] += + s[2054];
gout[n*2187+2055] += + s[2055];
gout[n*2187+2056] += + s[2056];
gout[n*2187+2057] += + s[2057];
gout[n*2187+2058] += + s[2058];
gout[n*2187+2059] += + s[2059];
gout[n*2187+2060] += + s[2060];
gout[n*2187+2061] += + s[2061];
gout[n*2187+2062] += + s[2062];
gout[n*2187+2063] += + s[2063];
gout[n*2187+2064] += + s[2064];
gout[n*2187+2065] += + s[2065];
gout[n*2187+2066] += + s[2066];
gout[n*2187+2067] += + s[2067];
gout[n*2187+2068] += + s[2068];
gout[n*2187+2069] += + s[2069];
gout[n*2187+2070] += + s[2070];
gout[n*2187+2071] += + s[2071];
gout[n*2187+2072] += + s[2072];
gout[n*2187+2073] += + s[2073];
gout[n*2187+2074] += + s[2074];
gout[n*2187+2075] += + s[2075];
gout[n*2187+2076] += + s[2076];
gout[n*2187+2077] += + s[2077];
gout[n*2187+2078] += + s[2078];
gout[n*2187+2079] += + s[2079];
gout[n*2187+2080] += + s[2080];
gout[n*2187+2081] += + s[2081];
gout[n*2187+2082] += + s[2082];
gout[n*2187+2083] += + s[2083];
gout[n*2187+2084] += + s[2084];
gout[n*2187+2085] += + s[2085];
gout[n*2187+2086] += + s[2086];
gout[n*2187+2087] += + s[2087];
gout[n*2187+2088] += + s[2088];
gout[n*2187+2089] += + s[2089];
gout[n*2187+2090] += + s[2090];
gout[n*2187+2091] += + s[2091];
gout[n*2187+2092] += + s[2092];
gout[n*2187+2093] += + s[2093];
gout[n*2187+2094] += + s[2094];
gout[n*2187+2095] += + s[2095];
gout[n*2187+2096] += + s[2096];
gout[n*2187+2097] += + s[2097];
gout[n*2187+2098] += + s[2098];
gout[n*2187+2099] += + s[2099];
gout[n*2187+2100] += + s[2100];
gout[n*2187+2101] += + s[2101];
gout[n*2187+2102] += + s[2102];
gout[n*2187+2103] += + s[2103];
gout[n*2187+2104] += + s[2104];
gout[n*2187+2105] += + s[2105];
gout[n*2187+2106] += + s[2106];
gout[n*2187+2107] += + s[2107];
gout[n*2187+2108] += + s[2108];
gout[n*2187+2109] += + s[2109];
gout[n*2187+2110] += + s[2110];
gout[n*2187+2111] += + s[2111];
gout[n*2187+2112] += + s[2112];
gout[n*2187+2113] += + s[2113];
gout[n*2187+2114] += + s[2114];
gout[n*2187+2115] += + s[2115];
gout[n*2187+2116] += + s[2116];
gout[n*2187+2117] += + s[2117];
gout[n*2187+2118] += + s[2118];
gout[n*2187+2119] += + s[2119];
gout[n*2187+2120] += + s[2120];
gout[n*2187+2121] += + s[2121];
gout[n*2187+2122] += + s[2122];
gout[n*2187+2123] += + s[2123];
gout[n*2187+2124] += + s[2124];
gout[n*2187+2125] += + s[2125];
gout[n*2187+2126] += + s[2126];
gout[n*2187+2127] += + s[2127];
gout[n*2187+2128] += + s[2128];
gout[n*2187+2129] += + s[2129];
gout[n*2187+2130] += + s[2130];
gout[n*2187+2131] += + s[2131];
gout[n*2187+2132] += + s[2132];
gout[n*2187+2133] += + s[2133];
gout[n*2187+2134] += + s[2134];
gout[n*2187+2135] += + s[2135];
gout[n*2187+2136] += + s[2136];
gout[n*2187+2137] += + s[2137];
gout[n*2187+2138] += + s[2138];
gout[n*2187+2139] += + s[2139];
gout[n*2187+2140] += + s[2140];
gout[n*2187+2141] += + s[2141];
gout[n*2187+2142] += + s[2142];
gout[n*2187+2143] += + s[2143];
gout[n*2187+2144] += + s[2144];
gout[n*2187+2145] += + s[2145];
gout[n*2187+2146] += + s[2146];
gout[n*2187+2147] += + s[2147];
gout[n*2187+2148] += + s[2148];
gout[n*2187+2149] += + s[2149];
gout[n*2187+2150] += + s[2150];
gout[n*2187+2151] += + s[2151];
gout[n*2187+2152] += + s[2152];
gout[n*2187+2153] += + s[2153];
gout[n*2187+2154] += + s[2154];
gout[n*2187+2155] += + s[2155];
gout[n*2187+2156] += + s[2156];
gout[n*2187+2157] += + s[2157];
gout[n*2187+2158] += + s[2158];
gout[n*2187+2159] += + s[2159];
gout[n*2187+2160] += + s[2160];
gout[n*2187+2161] += + s[2161];
gout[n*2187+2162] += + s[2162];
gout[n*2187+2163] += + s[2163];
gout[n*2187+2164] += + s[2164];
gout[n*2187+2165] += + s[2165];
gout[n*2187+2166] += + s[2166];
gout[n*2187+2167] += + s[2167];
gout[n*2187+2168] += + s[2168];
gout[n*2187+2169] += + s[2169];
gout[n*2187+2170] += + s[2170];
gout[n*2187+2171] += + s[2171];
gout[n*2187+2172] += + s[2172];
gout[n*2187+2173] += + s[2173];
gout[n*2187+2174] += + s[2174];
gout[n*2187+2175] += + s[2175];
gout[n*2187+2176] += + s[2176];
gout[n*2187+2177] += + s[2177];
gout[n*2187+2178] += + s[2178];
gout[n*2187+2179] += + s[2179];
gout[n*2187+2180] += + s[2180];
gout[n*2187+2181] += + s[2181];
gout[n*2187+2182] += + s[2182];
gout[n*2187+2183] += + s[2183];
gout[n*2187+2184] += + s[2184];
gout[n*2187+2185] += + s[2185];
gout[n*2187+2186] += + s[2186];
}}}
void int1e_nnnipipipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 7, 0, 0, 7, 1, 1, 2187};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_nnnipipipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 7, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_nnnipipipip_cart
CACHE_SIZE_T int1e_nnnipipipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 7, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnipipipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_nnnipipipip_sph
CACHE_SIZE_T int1e_nnnipipipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 7, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_nnnipipipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_nnnipipipip_spinor
ALL_CINT1E(int1e_nnnipipipip)
ALL_CINT1E_FORTRAN_(int1e_nnnipipipip)
/* <NABLA i|RJ RJ RJ |j> */
void CINTgout1e_int1e_ipnnn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[81];
G1E_RCJ(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipnnn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnnn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnnn_cart
CACHE_SIZE_T int1e_ipnnn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnnn_sph
CACHE_SIZE_T int1e_ipnnn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnnn_spinor
ALL_CINT1E(int1e_ipnnn)
ALL_CINT1E_FORTRAN_(int1e_ipnnn)
/* <NABLA NABLA i|RJ RJ RJ |j> */
void CINTgout1e_int1e_ipipnnn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipnnn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipnnn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipnnn_cart
CACHE_SIZE_T int1e_ipipnnn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipnnn_sph
CACHE_SIZE_T int1e_ipipnnn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipnnn_spinor
ALL_CINT1E(int1e_ipipnnn)
ALL_CINT1E_FORTRAN_(int1e_ipipnnn)
/* <NABLA NABLA NABLA i|RJ RJ RJ |j> */
void CINTgout1e_int1e_ipipipnnn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_RCJ(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+3, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+3, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+3, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[243];
gout[n*729+28] = + s[244];
gout[n*729+29] = + s[245];
gout[n*729+30] = + s[246];
gout[n*729+31] = + s[247];
gout[n*729+32] = + s[248];
gout[n*729+33] = + s[249];
gout[n*729+34] = + s[250];
gout[n*729+35] = + s[251];
gout[n*729+36] = + s[252];
gout[n*729+37] = + s[253];
gout[n*729+38] = + s[254];
gout[n*729+39] = + s[255];
gout[n*729+40] = + s[256];
gout[n*729+41] = + s[257];
gout[n*729+42] = + s[258];
gout[n*729+43] = + s[259];
gout[n*729+44] = + s[260];
gout[n*729+45] = + s[261];
gout[n*729+46] = + s[262];
gout[n*729+47] = + s[263];
gout[n*729+48] = + s[264];
gout[n*729+49] = + s[265];
gout[n*729+50] = + s[266];
gout[n*729+51] = + s[267];
gout[n*729+52] = + s[268];
gout[n*729+53] = + s[269];
gout[n*729+54] = + s[486];
gout[n*729+55] = + s[487];
gout[n*729+56] = + s[488];
gout[n*729+57] = + s[489];
gout[n*729+58] = + s[490];
gout[n*729+59] = + s[491];
gout[n*729+60] = + s[492];
gout[n*729+61] = + s[493];
gout[n*729+62] = + s[494];
gout[n*729+63] = + s[495];
gout[n*729+64] = + s[496];
gout[n*729+65] = + s[497];
gout[n*729+66] = + s[498];
gout[n*729+67] = + s[499];
gout[n*729+68] = + s[500];
gout[n*729+69] = + s[501];
gout[n*729+70] = + s[502];
gout[n*729+71] = + s[503];
gout[n*729+72] = + s[504];
gout[n*729+73] = + s[505];
gout[n*729+74] = + s[506];
gout[n*729+75] = + s[507];
gout[n*729+76] = + s[508];
gout[n*729+77] = + s[509];
gout[n*729+78] = + s[510];
gout[n*729+79] = + s[511];
gout[n*729+80] = + s[512];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[324];
gout[n*729+109] = + s[325];
gout[n*729+110] = + s[326];
gout[n*729+111] = + s[327];
gout[n*729+112] = + s[328];
gout[n*729+113] = + s[329];
gout[n*729+114] = + s[330];
gout[n*729+115] = + s[331];
gout[n*729+116] = + s[332];
gout[n*729+117] = + s[333];
gout[n*729+118] = + s[334];
gout[n*729+119] = + s[335];
gout[n*729+120] = + s[336];
gout[n*729+121] = + s[337];
gout[n*729+122] = + s[338];
gout[n*729+123] = + s[339];
gout[n*729+124] = + s[340];
gout[n*729+125] = + s[341];
gout[n*729+126] = + s[342];
gout[n*729+127] = + s[343];
gout[n*729+128] = + s[344];
gout[n*729+129] = + s[345];
gout[n*729+130] = + s[346];
gout[n*729+131] = + s[347];
gout[n*729+132] = + s[348];
gout[n*729+133] = + s[349];
gout[n*729+134] = + s[350];
gout[n*729+135] = + s[567];
gout[n*729+136] = + s[568];
gout[n*729+137] = + s[569];
gout[n*729+138] = + s[570];
gout[n*729+139] = + s[571];
gout[n*729+140] = + s[572];
gout[n*729+141] = + s[573];
gout[n*729+142] = + s[574];
gout[n*729+143] = + s[575];
gout[n*729+144] = + s[576];
gout[n*729+145] = + s[577];
gout[n*729+146] = + s[578];
gout[n*729+147] = + s[579];
gout[n*729+148] = + s[580];
gout[n*729+149] = + s[581];
gout[n*729+150] = + s[582];
gout[n*729+151] = + s[583];
gout[n*729+152] = + s[584];
gout[n*729+153] = + s[585];
gout[n*729+154] = + s[586];
gout[n*729+155] = + s[587];
gout[n*729+156] = + s[588];
gout[n*729+157] = + s[589];
gout[n*729+158] = + s[590];
gout[n*729+159] = + s[591];
gout[n*729+160] = + s[592];
gout[n*729+161] = + s[593];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[405];
gout[n*729+190] = + s[406];
gout[n*729+191] = + s[407];
gout[n*729+192] = + s[408];
gout[n*729+193] = + s[409];
gout[n*729+194] = + s[410];
gout[n*729+195] = + s[411];
gout[n*729+196] = + s[412];
gout[n*729+197] = + s[413];
gout[n*729+198] = + s[414];
gout[n*729+199] = + s[415];
gout[n*729+200] = + s[416];
gout[n*729+201] = + s[417];
gout[n*729+202] = + s[418];
gout[n*729+203] = + s[419];
gout[n*729+204] = + s[420];
gout[n*729+205] = + s[421];
gout[n*729+206] = + s[422];
gout[n*729+207] = + s[423];
gout[n*729+208] = + s[424];
gout[n*729+209] = + s[425];
gout[n*729+210] = + s[426];
gout[n*729+211] = + s[427];
gout[n*729+212] = + s[428];
gout[n*729+213] = + s[429];
gout[n*729+214] = + s[430];
gout[n*729+215] = + s[431];
gout[n*729+216] = + s[648];
gout[n*729+217] = + s[649];
gout[n*729+218] = + s[650];
gout[n*729+219] = + s[651];
gout[n*729+220] = + s[652];
gout[n*729+221] = + s[653];
gout[n*729+222] = + s[654];
gout[n*729+223] = + s[655];
gout[n*729+224] = + s[656];
gout[n*729+225] = + s[657];
gout[n*729+226] = + s[658];
gout[n*729+227] = + s[659];
gout[n*729+228] = + s[660];
gout[n*729+229] = + s[661];
gout[n*729+230] = + s[662];
gout[n*729+231] = + s[663];
gout[n*729+232] = + s[664];
gout[n*729+233] = + s[665];
gout[n*729+234] = + s[666];
gout[n*729+235] = + s[667];
gout[n*729+236] = + s[668];
gout[n*729+237] = + s[669];
gout[n*729+238] = + s[670];
gout[n*729+239] = + s[671];
gout[n*729+240] = + s[672];
gout[n*729+241] = + s[673];
gout[n*729+242] = + s[674];
gout[n*729+243] = + s[27];
gout[n*729+244] = + s[28];
gout[n*729+245] = + s[29];
gout[n*729+246] = + s[30];
gout[n*729+247] = + s[31];
gout[n*729+248] = + s[32];
gout[n*729+249] = + s[33];
gout[n*729+250] = + s[34];
gout[n*729+251] = + s[35];
gout[n*729+252] = + s[36];
gout[n*729+253] = + s[37];
gout[n*729+254] = + s[38];
gout[n*729+255] = + s[39];
gout[n*729+256] = + s[40];
gout[n*729+257] = + s[41];
gout[n*729+258] = + s[42];
gout[n*729+259] = + s[43];
gout[n*729+260] = + s[44];
gout[n*729+261] = + s[45];
gout[n*729+262] = + s[46];
gout[n*729+263] = + s[47];
gout[n*729+264] = + s[48];
gout[n*729+265] = + s[49];
gout[n*729+266] = + s[50];
gout[n*729+267] = + s[51];
gout[n*729+268] = + s[52];
gout[n*729+269] = + s[53];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[513];
gout[n*729+298] = + s[514];
gout[n*729+299] = + s[515];
gout[n*729+300] = + s[516];
gout[n*729+301] = + s[517];
gout[n*729+302] = + s[518];
gout[n*729+303] = + s[519];
gout[n*729+304] = + s[520];
gout[n*729+305] = + s[521];
gout[n*729+306] = + s[522];
gout[n*729+307] = + s[523];
gout[n*729+308] = + s[524];
gout[n*729+309] = + s[525];
gout[n*729+310] = + s[526];
gout[n*729+311] = + s[527];
gout[n*729+312] = + s[528];
gout[n*729+313] = + s[529];
gout[n*729+314] = + s[530];
gout[n*729+315] = + s[531];
gout[n*729+316] = + s[532];
gout[n*729+317] = + s[533];
gout[n*729+318] = + s[534];
gout[n*729+319] = + s[535];
gout[n*729+320] = + s[536];
gout[n*729+321] = + s[537];
gout[n*729+322] = + s[538];
gout[n*729+323] = + s[539];
gout[n*729+324] = + s[108];
gout[n*729+325] = + s[109];
gout[n*729+326] = + s[110];
gout[n*729+327] = + s[111];
gout[n*729+328] = + s[112];
gout[n*729+329] = + s[113];
gout[n*729+330] = + s[114];
gout[n*729+331] = + s[115];
gout[n*729+332] = + s[116];
gout[n*729+333] = + s[117];
gout[n*729+334] = + s[118];
gout[n*729+335] = + s[119];
gout[n*729+336] = + s[120];
gout[n*729+337] = + s[121];
gout[n*729+338] = + s[122];
gout[n*729+339] = + s[123];
gout[n*729+340] = + s[124];
gout[n*729+341] = + s[125];
gout[n*729+342] = + s[126];
gout[n*729+343] = + s[127];
gout[n*729+344] = + s[128];
gout[n*729+345] = + s[129];
gout[n*729+346] = + s[130];
gout[n*729+347] = + s[131];
gout[n*729+348] = + s[132];
gout[n*729+349] = + s[133];
gout[n*729+350] = + s[134];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[594];
gout[n*729+379] = + s[595];
gout[n*729+380] = + s[596];
gout[n*729+381] = + s[597];
gout[n*729+382] = + s[598];
gout[n*729+383] = + s[599];
gout[n*729+384] = + s[600];
gout[n*729+385] = + s[601];
gout[n*729+386] = + s[602];
gout[n*729+387] = + s[603];
gout[n*729+388] = + s[604];
gout[n*729+389] = + s[605];
gout[n*729+390] = + s[606];
gout[n*729+391] = + s[607];
gout[n*729+392] = + s[608];
gout[n*729+393] = + s[609];
gout[n*729+394] = + s[610];
gout[n*729+395] = + s[611];
gout[n*729+396] = + s[612];
gout[n*729+397] = + s[613];
gout[n*729+398] = + s[614];
gout[n*729+399] = + s[615];
gout[n*729+400] = + s[616];
gout[n*729+401] = + s[617];
gout[n*729+402] = + s[618];
gout[n*729+403] = + s[619];
gout[n*729+404] = + s[620];
gout[n*729+405] = + s[189];
gout[n*729+406] = + s[190];
gout[n*729+407] = + s[191];
gout[n*729+408] = + s[192];
gout[n*729+409] = + s[193];
gout[n*729+410] = + s[194];
gout[n*729+411] = + s[195];
gout[n*729+412] = + s[196];
gout[n*729+413] = + s[197];
gout[n*729+414] = + s[198];
gout[n*729+415] = + s[199];
gout[n*729+416] = + s[200];
gout[n*729+417] = + s[201];
gout[n*729+418] = + s[202];
gout[n*729+419] = + s[203];
gout[n*729+420] = + s[204];
gout[n*729+421] = + s[205];
gout[n*729+422] = + s[206];
gout[n*729+423] = + s[207];
gout[n*729+424] = + s[208];
gout[n*729+425] = + s[209];
gout[n*729+426] = + s[210];
gout[n*729+427] = + s[211];
gout[n*729+428] = + s[212];
gout[n*729+429] = + s[213];
gout[n*729+430] = + s[214];
gout[n*729+431] = + s[215];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[675];
gout[n*729+460] = + s[676];
gout[n*729+461] = + s[677];
gout[n*729+462] = + s[678];
gout[n*729+463] = + s[679];
gout[n*729+464] = + s[680];
gout[n*729+465] = + s[681];
gout[n*729+466] = + s[682];
gout[n*729+467] = + s[683];
gout[n*729+468] = + s[684];
gout[n*729+469] = + s[685];
gout[n*729+470] = + s[686];
gout[n*729+471] = + s[687];
gout[n*729+472] = + s[688];
gout[n*729+473] = + s[689];
gout[n*729+474] = + s[690];
gout[n*729+475] = + s[691];
gout[n*729+476] = + s[692];
gout[n*729+477] = + s[693];
gout[n*729+478] = + s[694];
gout[n*729+479] = + s[695];
gout[n*729+480] = + s[696];
gout[n*729+481] = + s[697];
gout[n*729+482] = + s[698];
gout[n*729+483] = + s[699];
gout[n*729+484] = + s[700];
gout[n*729+485] = + s[701];
gout[n*729+486] = + s[54];
gout[n*729+487] = + s[55];
gout[n*729+488] = + s[56];
gout[n*729+489] = + s[57];
gout[n*729+490] = + s[58];
gout[n*729+491] = + s[59];
gout[n*729+492] = + s[60];
gout[n*729+493] = + s[61];
gout[n*729+494] = + s[62];
gout[n*729+495] = + s[63];
gout[n*729+496] = + s[64];
gout[n*729+497] = + s[65];
gout[n*729+498] = + s[66];
gout[n*729+499] = + s[67];
gout[n*729+500] = + s[68];
gout[n*729+501] = + s[69];
gout[n*729+502] = + s[70];
gout[n*729+503] = + s[71];
gout[n*729+504] = + s[72];
gout[n*729+505] = + s[73];
gout[n*729+506] = + s[74];
gout[n*729+507] = + s[75];
gout[n*729+508] = + s[76];
gout[n*729+509] = + s[77];
gout[n*729+510] = + s[78];
gout[n*729+511] = + s[79];
gout[n*729+512] = + s[80];
gout[n*729+513] = + s[297];
gout[n*729+514] = + s[298];
gout[n*729+515] = + s[299];
gout[n*729+516] = + s[300];
gout[n*729+517] = + s[301];
gout[n*729+518] = + s[302];
gout[n*729+519] = + s[303];
gout[n*729+520] = + s[304];
gout[n*729+521] = + s[305];
gout[n*729+522] = + s[306];
gout[n*729+523] = + s[307];
gout[n*729+524] = + s[308];
gout[n*729+525] = + s[309];
gout[n*729+526] = + s[310];
gout[n*729+527] = + s[311];
gout[n*729+528] = + s[312];
gout[n*729+529] = + s[313];
gout[n*729+530] = + s[314];
gout[n*729+531] = + s[315];
gout[n*729+532] = + s[316];
gout[n*729+533] = + s[317];
gout[n*729+534] = + s[318];
gout[n*729+535] = + s[319];
gout[n*729+536] = + s[320];
gout[n*729+537] = + s[321];
gout[n*729+538] = + s[322];
gout[n*729+539] = + s[323];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[135];
gout[n*729+568] = + s[136];
gout[n*729+569] = + s[137];
gout[n*729+570] = + s[138];
gout[n*729+571] = + s[139];
gout[n*729+572] = + s[140];
gout[n*729+573] = + s[141];
gout[n*729+574] = + s[142];
gout[n*729+575] = + s[143];
gout[n*729+576] = + s[144];
gout[n*729+577] = + s[145];
gout[n*729+578] = + s[146];
gout[n*729+579] = + s[147];
gout[n*729+580] = + s[148];
gout[n*729+581] = + s[149];
gout[n*729+582] = + s[150];
gout[n*729+583] = + s[151];
gout[n*729+584] = + s[152];
gout[n*729+585] = + s[153];
gout[n*729+586] = + s[154];
gout[n*729+587] = + s[155];
gout[n*729+588] = + s[156];
gout[n*729+589] = + s[157];
gout[n*729+590] = + s[158];
gout[n*729+591] = + s[159];
gout[n*729+592] = + s[160];
gout[n*729+593] = + s[161];
gout[n*729+594] = + s[378];
gout[n*729+595] = + s[379];
gout[n*729+596] = + s[380];
gout[n*729+597] = + s[381];
gout[n*729+598] = + s[382];
gout[n*729+599] = + s[383];
gout[n*729+600] = + s[384];
gout[n*729+601] = + s[385];
gout[n*729+602] = + s[386];
gout[n*729+603] = + s[387];
gout[n*729+604] = + s[388];
gout[n*729+605] = + s[389];
gout[n*729+606] = + s[390];
gout[n*729+607] = + s[391];
gout[n*729+608] = + s[392];
gout[n*729+609] = + s[393];
gout[n*729+610] = + s[394];
gout[n*729+611] = + s[395];
gout[n*729+612] = + s[396];
gout[n*729+613] = + s[397];
gout[n*729+614] = + s[398];
gout[n*729+615] = + s[399];
gout[n*729+616] = + s[400];
gout[n*729+617] = + s[401];
gout[n*729+618] = + s[402];
gout[n*729+619] = + s[403];
gout[n*729+620] = + s[404];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[216];
gout[n*729+649] = + s[217];
gout[n*729+650] = + s[218];
gout[n*729+651] = + s[219];
gout[n*729+652] = + s[220];
gout[n*729+653] = + s[221];
gout[n*729+654] = + s[222];
gout[n*729+655] = + s[223];
gout[n*729+656] = + s[224];
gout[n*729+657] = + s[225];
gout[n*729+658] = + s[226];
gout[n*729+659] = + s[227];
gout[n*729+660] = + s[228];
gout[n*729+661] = + s[229];
gout[n*729+662] = + s[230];
gout[n*729+663] = + s[231];
gout[n*729+664] = + s[232];
gout[n*729+665] = + s[233];
gout[n*729+666] = + s[234];
gout[n*729+667] = + s[235];
gout[n*729+668] = + s[236];
gout[n*729+669] = + s[237];
gout[n*729+670] = + s[238];
gout[n*729+671] = + s[239];
gout[n*729+672] = + s[240];
gout[n*729+673] = + s[241];
gout[n*729+674] = + s[242];
gout[n*729+675] = + s[459];
gout[n*729+676] = + s[460];
gout[n*729+677] = + s[461];
gout[n*729+678] = + s[462];
gout[n*729+679] = + s[463];
gout[n*729+680] = + s[464];
gout[n*729+681] = + s[465];
gout[n*729+682] = + s[466];
gout[n*729+683] = + s[467];
gout[n*729+684] = + s[468];
gout[n*729+685] = + s[469];
gout[n*729+686] = + s[470];
gout[n*729+687] = + s[471];
gout[n*729+688] = + s[472];
gout[n*729+689] = + s[473];
gout[n*729+690] = + s[474];
gout[n*729+691] = + s[475];
gout[n*729+692] = + s[476];
gout[n*729+693] = + s[477];
gout[n*729+694] = + s[478];
gout[n*729+695] = + s[479];
gout[n*729+696] = + s[480];
gout[n*729+697] = + s[481];
gout[n*729+698] = + s[482];
gout[n*729+699] = + s[483];
gout[n*729+700] = + s[484];
gout[n*729+701] = + s[485];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[243];
gout[n*729+28] += + s[244];
gout[n*729+29] += + s[245];
gout[n*729+30] += + s[246];
gout[n*729+31] += + s[247];
gout[n*729+32] += + s[248];
gout[n*729+33] += + s[249];
gout[n*729+34] += + s[250];
gout[n*729+35] += + s[251];
gout[n*729+36] += + s[252];
gout[n*729+37] += + s[253];
gout[n*729+38] += + s[254];
gout[n*729+39] += + s[255];
gout[n*729+40] += + s[256];
gout[n*729+41] += + s[257];
gout[n*729+42] += + s[258];
gout[n*729+43] += + s[259];
gout[n*729+44] += + s[260];
gout[n*729+45] += + s[261];
gout[n*729+46] += + s[262];
gout[n*729+47] += + s[263];
gout[n*729+48] += + s[264];
gout[n*729+49] += + s[265];
gout[n*729+50] += + s[266];
gout[n*729+51] += + s[267];
gout[n*729+52] += + s[268];
gout[n*729+53] += + s[269];
gout[n*729+54] += + s[486];
gout[n*729+55] += + s[487];
gout[n*729+56] += + s[488];
gout[n*729+57] += + s[489];
gout[n*729+58] += + s[490];
gout[n*729+59] += + s[491];
gout[n*729+60] += + s[492];
gout[n*729+61] += + s[493];
gout[n*729+62] += + s[494];
gout[n*729+63] += + s[495];
gout[n*729+64] += + s[496];
gout[n*729+65] += + s[497];
gout[n*729+66] += + s[498];
gout[n*729+67] += + s[499];
gout[n*729+68] += + s[500];
gout[n*729+69] += + s[501];
gout[n*729+70] += + s[502];
gout[n*729+71] += + s[503];
gout[n*729+72] += + s[504];
gout[n*729+73] += + s[505];
gout[n*729+74] += + s[506];
gout[n*729+75] += + s[507];
gout[n*729+76] += + s[508];
gout[n*729+77] += + s[509];
gout[n*729+78] += + s[510];
gout[n*729+79] += + s[511];
gout[n*729+80] += + s[512];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[324];
gout[n*729+109] += + s[325];
gout[n*729+110] += + s[326];
gout[n*729+111] += + s[327];
gout[n*729+112] += + s[328];
gout[n*729+113] += + s[329];
gout[n*729+114] += + s[330];
gout[n*729+115] += + s[331];
gout[n*729+116] += + s[332];
gout[n*729+117] += + s[333];
gout[n*729+118] += + s[334];
gout[n*729+119] += + s[335];
gout[n*729+120] += + s[336];
gout[n*729+121] += + s[337];
gout[n*729+122] += + s[338];
gout[n*729+123] += + s[339];
gout[n*729+124] += + s[340];
gout[n*729+125] += + s[341];
gout[n*729+126] += + s[342];
gout[n*729+127] += + s[343];
gout[n*729+128] += + s[344];
gout[n*729+129] += + s[345];
gout[n*729+130] += + s[346];
gout[n*729+131] += + s[347];
gout[n*729+132] += + s[348];
gout[n*729+133] += + s[349];
gout[n*729+134] += + s[350];
gout[n*729+135] += + s[567];
gout[n*729+136] += + s[568];
gout[n*729+137] += + s[569];
gout[n*729+138] += + s[570];
gout[n*729+139] += + s[571];
gout[n*729+140] += + s[572];
gout[n*729+141] += + s[573];
gout[n*729+142] += + s[574];
gout[n*729+143] += + s[575];
gout[n*729+144] += + s[576];
gout[n*729+145] += + s[577];
gout[n*729+146] += + s[578];
gout[n*729+147] += + s[579];
gout[n*729+148] += + s[580];
gout[n*729+149] += + s[581];
gout[n*729+150] += + s[582];
gout[n*729+151] += + s[583];
gout[n*729+152] += + s[584];
gout[n*729+153] += + s[585];
gout[n*729+154] += + s[586];
gout[n*729+155] += + s[587];
gout[n*729+156] += + s[588];
gout[n*729+157] += + s[589];
gout[n*729+158] += + s[590];
gout[n*729+159] += + s[591];
gout[n*729+160] += + s[592];
gout[n*729+161] += + s[593];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[405];
gout[n*729+190] += + s[406];
gout[n*729+191] += + s[407];
gout[n*729+192] += + s[408];
gout[n*729+193] += + s[409];
gout[n*729+194] += + s[410];
gout[n*729+195] += + s[411];
gout[n*729+196] += + s[412];
gout[n*729+197] += + s[413];
gout[n*729+198] += + s[414];
gout[n*729+199] += + s[415];
gout[n*729+200] += + s[416];
gout[n*729+201] += + s[417];
gout[n*729+202] += + s[418];
gout[n*729+203] += + s[419];
gout[n*729+204] += + s[420];
gout[n*729+205] += + s[421];
gout[n*729+206] += + s[422];
gout[n*729+207] += + s[423];
gout[n*729+208] += + s[424];
gout[n*729+209] += + s[425];
gout[n*729+210] += + s[426];
gout[n*729+211] += + s[427];
gout[n*729+212] += + s[428];
gout[n*729+213] += + s[429];
gout[n*729+214] += + s[430];
gout[n*729+215] += + s[431];
gout[n*729+216] += + s[648];
gout[n*729+217] += + s[649];
gout[n*729+218] += + s[650];
gout[n*729+219] += + s[651];
gout[n*729+220] += + s[652];
gout[n*729+221] += + s[653];
gout[n*729+222] += + s[654];
gout[n*729+223] += + s[655];
gout[n*729+224] += + s[656];
gout[n*729+225] += + s[657];
gout[n*729+226] += + s[658];
gout[n*729+227] += + s[659];
gout[n*729+228] += + s[660];
gout[n*729+229] += + s[661];
gout[n*729+230] += + s[662];
gout[n*729+231] += + s[663];
gout[n*729+232] += + s[664];
gout[n*729+233] += + s[665];
gout[n*729+234] += + s[666];
gout[n*729+235] += + s[667];
gout[n*729+236] += + s[668];
gout[n*729+237] += + s[669];
gout[n*729+238] += + s[670];
gout[n*729+239] += + s[671];
gout[n*729+240] += + s[672];
gout[n*729+241] += + s[673];
gout[n*729+242] += + s[674];
gout[n*729+243] += + s[27];
gout[n*729+244] += + s[28];
gout[n*729+245] += + s[29];
gout[n*729+246] += + s[30];
gout[n*729+247] += + s[31];
gout[n*729+248] += + s[32];
gout[n*729+249] += + s[33];
gout[n*729+250] += + s[34];
gout[n*729+251] += + s[35];
gout[n*729+252] += + s[36];
gout[n*729+253] += + s[37];
gout[n*729+254] += + s[38];
gout[n*729+255] += + s[39];
gout[n*729+256] += + s[40];
gout[n*729+257] += + s[41];
gout[n*729+258] += + s[42];
gout[n*729+259] += + s[43];
gout[n*729+260] += + s[44];
gout[n*729+261] += + s[45];
gout[n*729+262] += + s[46];
gout[n*729+263] += + s[47];
gout[n*729+264] += + s[48];
gout[n*729+265] += + s[49];
gout[n*729+266] += + s[50];
gout[n*729+267] += + s[51];
gout[n*729+268] += + s[52];
gout[n*729+269] += + s[53];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[513];
gout[n*729+298] += + s[514];
gout[n*729+299] += + s[515];
gout[n*729+300] += + s[516];
gout[n*729+301] += + s[517];
gout[n*729+302] += + s[518];
gout[n*729+303] += + s[519];
gout[n*729+304] += + s[520];
gout[n*729+305] += + s[521];
gout[n*729+306] += + s[522];
gout[n*729+307] += + s[523];
gout[n*729+308] += + s[524];
gout[n*729+309] += + s[525];
gout[n*729+310] += + s[526];
gout[n*729+311] += + s[527];
gout[n*729+312] += + s[528];
gout[n*729+313] += + s[529];
gout[n*729+314] += + s[530];
gout[n*729+315] += + s[531];
gout[n*729+316] += + s[532];
gout[n*729+317] += + s[533];
gout[n*729+318] += + s[534];
gout[n*729+319] += + s[535];
gout[n*729+320] += + s[536];
gout[n*729+321] += + s[537];
gout[n*729+322] += + s[538];
gout[n*729+323] += + s[539];
gout[n*729+324] += + s[108];
gout[n*729+325] += + s[109];
gout[n*729+326] += + s[110];
gout[n*729+327] += + s[111];
gout[n*729+328] += + s[112];
gout[n*729+329] += + s[113];
gout[n*729+330] += + s[114];
gout[n*729+331] += + s[115];
gout[n*729+332] += + s[116];
gout[n*729+333] += + s[117];
gout[n*729+334] += + s[118];
gout[n*729+335] += + s[119];
gout[n*729+336] += + s[120];
gout[n*729+337] += + s[121];
gout[n*729+338] += + s[122];
gout[n*729+339] += + s[123];
gout[n*729+340] += + s[124];
gout[n*729+341] += + s[125];
gout[n*729+342] += + s[126];
gout[n*729+343] += + s[127];
gout[n*729+344] += + s[128];
gout[n*729+345] += + s[129];
gout[n*729+346] += + s[130];
gout[n*729+347] += + s[131];
gout[n*729+348] += + s[132];
gout[n*729+349] += + s[133];
gout[n*729+350] += + s[134];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[594];
gout[n*729+379] += + s[595];
gout[n*729+380] += + s[596];
gout[n*729+381] += + s[597];
gout[n*729+382] += + s[598];
gout[n*729+383] += + s[599];
gout[n*729+384] += + s[600];
gout[n*729+385] += + s[601];
gout[n*729+386] += + s[602];
gout[n*729+387] += + s[603];
gout[n*729+388] += + s[604];
gout[n*729+389] += + s[605];
gout[n*729+390] += + s[606];
gout[n*729+391] += + s[607];
gout[n*729+392] += + s[608];
gout[n*729+393] += + s[609];
gout[n*729+394] += + s[610];
gout[n*729+395] += + s[611];
gout[n*729+396] += + s[612];
gout[n*729+397] += + s[613];
gout[n*729+398] += + s[614];
gout[n*729+399] += + s[615];
gout[n*729+400] += + s[616];
gout[n*729+401] += + s[617];
gout[n*729+402] += + s[618];
gout[n*729+403] += + s[619];
gout[n*729+404] += + s[620];
gout[n*729+405] += + s[189];
gout[n*729+406] += + s[190];
gout[n*729+407] += + s[191];
gout[n*729+408] += + s[192];
gout[n*729+409] += + s[193];
gout[n*729+410] += + s[194];
gout[n*729+411] += + s[195];
gout[n*729+412] += + s[196];
gout[n*729+413] += + s[197];
gout[n*729+414] += + s[198];
gout[n*729+415] += + s[199];
gout[n*729+416] += + s[200];
gout[n*729+417] += + s[201];
gout[n*729+418] += + s[202];
gout[n*729+419] += + s[203];
gout[n*729+420] += + s[204];
gout[n*729+421] += + s[205];
gout[n*729+422] += + s[206];
gout[n*729+423] += + s[207];
gout[n*729+424] += + s[208];
gout[n*729+425] += + s[209];
gout[n*729+426] += + s[210];
gout[n*729+427] += + s[211];
gout[n*729+428] += + s[212];
gout[n*729+429] += + s[213];
gout[n*729+430] += + s[214];
gout[n*729+431] += + s[215];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[675];
gout[n*729+460] += + s[676];
gout[n*729+461] += + s[677];
gout[n*729+462] += + s[678];
gout[n*729+463] += + s[679];
gout[n*729+464] += + s[680];
gout[n*729+465] += + s[681];
gout[n*729+466] += + s[682];
gout[n*729+467] += + s[683];
gout[n*729+468] += + s[684];
gout[n*729+469] += + s[685];
gout[n*729+470] += + s[686];
gout[n*729+471] += + s[687];
gout[n*729+472] += + s[688];
gout[n*729+473] += + s[689];
gout[n*729+474] += + s[690];
gout[n*729+475] += + s[691];
gout[n*729+476] += + s[692];
gout[n*729+477] += + s[693];
gout[n*729+478] += + s[694];
gout[n*729+479] += + s[695];
gout[n*729+480] += + s[696];
gout[n*729+481] += + s[697];
gout[n*729+482] += + s[698];
gout[n*729+483] += + s[699];
gout[n*729+484] += + s[700];
gout[n*729+485] += + s[701];
gout[n*729+486] += + s[54];
gout[n*729+487] += + s[55];
gout[n*729+488] += + s[56];
gout[n*729+489] += + s[57];
gout[n*729+490] += + s[58];
gout[n*729+491] += + s[59];
gout[n*729+492] += + s[60];
gout[n*729+493] += + s[61];
gout[n*729+494] += + s[62];
gout[n*729+495] += + s[63];
gout[n*729+496] += + s[64];
gout[n*729+497] += + s[65];
gout[n*729+498] += + s[66];
gout[n*729+499] += + s[67];
gout[n*729+500] += + s[68];
gout[n*729+501] += + s[69];
gout[n*729+502] += + s[70];
gout[n*729+503] += + s[71];
gout[n*729+504] += + s[72];
gout[n*729+505] += + s[73];
gout[n*729+506] += + s[74];
gout[n*729+507] += + s[75];
gout[n*729+508] += + s[76];
gout[n*729+509] += + s[77];
gout[n*729+510] += + s[78];
gout[n*729+511] += + s[79];
gout[n*729+512] += + s[80];
gout[n*729+513] += + s[297];
gout[n*729+514] += + s[298];
gout[n*729+515] += + s[299];
gout[n*729+516] += + s[300];
gout[n*729+517] += + s[301];
gout[n*729+518] += + s[302];
gout[n*729+519] += + s[303];
gout[n*729+520] += + s[304];
gout[n*729+521] += + s[305];
gout[n*729+522] += + s[306];
gout[n*729+523] += + s[307];
gout[n*729+524] += + s[308];
gout[n*729+525] += + s[309];
gout[n*729+526] += + s[310];
gout[n*729+527] += + s[311];
gout[n*729+528] += + s[312];
gout[n*729+529] += + s[313];
gout[n*729+530] += + s[314];
gout[n*729+531] += + s[315];
gout[n*729+532] += + s[316];
gout[n*729+533] += + s[317];
gout[n*729+534] += + s[318];
gout[n*729+535] += + s[319];
gout[n*729+536] += + s[320];
gout[n*729+537] += + s[321];
gout[n*729+538] += + s[322];
gout[n*729+539] += + s[323];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[135];
gout[n*729+568] += + s[136];
gout[n*729+569] += + s[137];
gout[n*729+570] += + s[138];
gout[n*729+571] += + s[139];
gout[n*729+572] += + s[140];
gout[n*729+573] += + s[141];
gout[n*729+574] += + s[142];
gout[n*729+575] += + s[143];
gout[n*729+576] += + s[144];
gout[n*729+577] += + s[145];
gout[n*729+578] += + s[146];
gout[n*729+579] += + s[147];
gout[n*729+580] += + s[148];
gout[n*729+581] += + s[149];
gout[n*729+582] += + s[150];
gout[n*729+583] += + s[151];
gout[n*729+584] += + s[152];
gout[n*729+585] += + s[153];
gout[n*729+586] += + s[154];
gout[n*729+587] += + s[155];
gout[n*729+588] += + s[156];
gout[n*729+589] += + s[157];
gout[n*729+590] += + s[158];
gout[n*729+591] += + s[159];
gout[n*729+592] += + s[160];
gout[n*729+593] += + s[161];
gout[n*729+594] += + s[378];
gout[n*729+595] += + s[379];
gout[n*729+596] += + s[380];
gout[n*729+597] += + s[381];
gout[n*729+598] += + s[382];
gout[n*729+599] += + s[383];
gout[n*729+600] += + s[384];
gout[n*729+601] += + s[385];
gout[n*729+602] += + s[386];
gout[n*729+603] += + s[387];
gout[n*729+604] += + s[388];
gout[n*729+605] += + s[389];
gout[n*729+606] += + s[390];
gout[n*729+607] += + s[391];
gout[n*729+608] += + s[392];
gout[n*729+609] += + s[393];
gout[n*729+610] += + s[394];
gout[n*729+611] += + s[395];
gout[n*729+612] += + s[396];
gout[n*729+613] += + s[397];
gout[n*729+614] += + s[398];
gout[n*729+615] += + s[399];
gout[n*729+616] += + s[400];
gout[n*729+617] += + s[401];
gout[n*729+618] += + s[402];
gout[n*729+619] += + s[403];
gout[n*729+620] += + s[404];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[216];
gout[n*729+649] += + s[217];
gout[n*729+650] += + s[218];
gout[n*729+651] += + s[219];
gout[n*729+652] += + s[220];
gout[n*729+653] += + s[221];
gout[n*729+654] += + s[222];
gout[n*729+655] += + s[223];
gout[n*729+656] += + s[224];
gout[n*729+657] += + s[225];
gout[n*729+658] += + s[226];
gout[n*729+659] += + s[227];
gout[n*729+660] += + s[228];
gout[n*729+661] += + s[229];
gout[n*729+662] += + s[230];
gout[n*729+663] += + s[231];
gout[n*729+664] += + s[232];
gout[n*729+665] += + s[233];
gout[n*729+666] += + s[234];
gout[n*729+667] += + s[235];
gout[n*729+668] += + s[236];
gout[n*729+669] += + s[237];
gout[n*729+670] += + s[238];
gout[n*729+671] += + s[239];
gout[n*729+672] += + s[240];
gout[n*729+673] += + s[241];
gout[n*729+674] += + s[242];
gout[n*729+675] += + s[459];
gout[n*729+676] += + s[460];
gout[n*729+677] += + s[461];
gout[n*729+678] += + s[462];
gout[n*729+679] += + s[463];
gout[n*729+680] += + s[464];
gout[n*729+681] += + s[465];
gout[n*729+682] += + s[466];
gout[n*729+683] += + s[467];
gout[n*729+684] += + s[468];
gout[n*729+685] += + s[469];
gout[n*729+686] += + s[470];
gout[n*729+687] += + s[471];
gout[n*729+688] += + s[472];
gout[n*729+689] += + s[473];
gout[n*729+690] += + s[474];
gout[n*729+691] += + s[475];
gout[n*729+692] += + s[476];
gout[n*729+693] += + s[477];
gout[n*729+694] += + s[478];
gout[n*729+695] += + s[479];
gout[n*729+696] += + s[480];
gout[n*729+697] += + s[481];
gout[n*729+698] += + s[482];
gout[n*729+699] += + s[483];
gout[n*729+700] += + s[484];
gout[n*729+701] += + s[485];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipipnnn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipnnn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipnnn_cart
CACHE_SIZE_T int1e_ipipipnnn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipnnn_sph
CACHE_SIZE_T int1e_ipipipnnn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 3, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipnnn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipnnn_spinor
ALL_CINT1E(int1e_ipipipnnn)
ALL_CINT1E_FORTRAN_(int1e_ipipipnnn)
/* <NABLA NABLA NABLA NABLA i|RJ RJ RJ |j> */
void CINTgout1e_int1e_ipipipipnnn(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double *g64 = g63 + envs->g_size * 3;
double *g65 = g64 + envs->g_size * 3;
double *g66 = g65 + envs->g_size * 3;
double *g67 = g66 + envs->g_size * 3;
double *g68 = g67 + envs->g_size * 3;
double *g69 = g68 + envs->g_size * 3;
double *g70 = g69 + envs->g_size * 3;
double *g71 = g70 + envs->g_size * 3;
double *g72 = g71 + envs->g_size * 3;
double *g73 = g72 + envs->g_size * 3;
double *g74 = g73 + envs->g_size * 3;
double *g75 = g74 + envs->g_size * 3;
double *g76 = g75 + envs->g_size * 3;
double *g77 = g76 + envs->g_size * 3;
double *g78 = g77 + envs->g_size * 3;
double *g79 = g78 + envs->g_size * 3;
double *g80 = g79 + envs->g_size * 3;
double *g81 = g80 + envs->g_size * 3;
double *g82 = g81 + envs->g_size * 3;
double *g83 = g82 + envs->g_size * 3;
double *g84 = g83 + envs->g_size * 3;
double *g85 = g84 + envs->g_size * 3;
double *g86 = g85 + envs->g_size * 3;
double *g87 = g86 + envs->g_size * 3;
double *g88 = g87 + envs->g_size * 3;
double *g89 = g88 + envs->g_size * 3;
double *g90 = g89 + envs->g_size * 3;
double *g91 = g90 + envs->g_size * 3;
double *g92 = g91 + envs->g_size * 3;
double *g93 = g92 + envs->g_size * 3;
double *g94 = g93 + envs->g_size * 3;
double *g95 = g94 + envs->g_size * 3;
double *g96 = g95 + envs->g_size * 3;
double *g97 = g96 + envs->g_size * 3;
double *g98 = g97 + envs->g_size * 3;
double *g99 = g98 + envs->g_size * 3;
double *g100 = g99 + envs->g_size * 3;
double *g101 = g100 + envs->g_size * 3;
double *g102 = g101 + envs->g_size * 3;
double *g103 = g102 + envs->g_size * 3;
double *g104 = g103 + envs->g_size * 3;
double *g105 = g104 + envs->g_size * 3;
double *g106 = g105 + envs->g_size * 3;
double *g107 = g106 + envs->g_size * 3;
double *g108 = g107 + envs->g_size * 3;
double *g109 = g108 + envs->g_size * 3;
double *g110 = g109 + envs->g_size * 3;
double *g111 = g110 + envs->g_size * 3;
double *g112 = g111 + envs->g_size * 3;
double *g113 = g112 + envs->g_size * 3;
double *g114 = g113 + envs->g_size * 3;
double *g115 = g114 + envs->g_size * 3;
double *g116 = g115 + envs->g_size * 3;
double *g117 = g116 + envs->g_size * 3;
double *g118 = g117 + envs->g_size * 3;
double *g119 = g118 + envs->g_size * 3;
double *g120 = g119 + envs->g_size * 3;
double *g121 = g120 + envs->g_size * 3;
double *g122 = g121 + envs->g_size * 3;
double *g123 = g122 + envs->g_size * 3;
double *g124 = g123 + envs->g_size * 3;
double *g125 = g124 + envs->g_size * 3;
double *g126 = g125 + envs->g_size * 3;
double *g127 = g126 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[2187];
G1E_RCJ(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+4, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+4, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+4, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+4, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+4, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+3, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g64, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g65, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g66, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g67, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g68, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g69, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g70, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g71, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g72, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g73, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g74, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g75, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g76, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g77, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g78, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g79, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g80, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g81, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g82, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g83, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g84, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g85, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g86, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g87, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g88, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g89, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g90, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g91, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g92, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g93, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g94, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g95, g31, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g96, g32, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g97, g33, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g98, g34, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g99, g35, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g100, g36, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g101, g37, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g102, g38, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g103, g39, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g104, g40, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g105, g41, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g106, g42, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g107, g43, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g108, g44, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g109, g45, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g110, g46, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g111, g47, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g112, g48, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g113, g49, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g114, g50, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g115, g51, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g116, g52, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g117, g53, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g118, g54, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g119, g55, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g120, g56, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g121, g57, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g122, g58, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g123, g59, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g124, g60, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g125, g61, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g126, g62, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g127, g63, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g127[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g126[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g126[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g125[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g124[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g124[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g125[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g124[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g124[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g123[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g122[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g122[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g121[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g120[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g120[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g121[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g120[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g120[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g123[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g122[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g122[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g121[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g120[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g120[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g121[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g120[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g120[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g119[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g118[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g118[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g117[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g116[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g116[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g117[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g116[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g116[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g115[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g114[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g114[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g113[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g112[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g112[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g113[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g112[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g112[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g115[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g114[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g114[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g113[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g112[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g112[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g113[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g112[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g112[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g119[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g118[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g118[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g117[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g116[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g116[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g117[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g116[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g116[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g115[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g114[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g114[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g113[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g112[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g112[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g113[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g112[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g112[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g115[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g114[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g114[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g113[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g112[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g112[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g113[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g112[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g112[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g111[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g110[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g110[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g109[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g108[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g108[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g109[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g108[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g108[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g107[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g106[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g106[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g105[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g104[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g104[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g105[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g104[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g104[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g107[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g106[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g106[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g105[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g104[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g104[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g105[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g104[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g104[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g103[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g102[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g102[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g101[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g100[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g100[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g101[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g100[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g100[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g99[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g98[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g98[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g97[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g96[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g96[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g97[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g96[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g96[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g99[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g98[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g98[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g97[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g96[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g96[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g97[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g96[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g96[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g103[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g102[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g102[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g101[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g100[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g100[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g101[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g100[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g100[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g99[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g98[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g98[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g97[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g96[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g96[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g97[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g96[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g96[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g99[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g98[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g98[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g97[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g96[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g96[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g97[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g96[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g96[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g111[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g110[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g110[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g109[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g108[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g108[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g109[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g108[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g108[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g107[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g106[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g106[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g105[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g104[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g104[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g105[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g104[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g104[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g107[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g106[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g106[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g105[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g104[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g104[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g105[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g104[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g104[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g103[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g102[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g102[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g101[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g100[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g100[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g101[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g100[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g100[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g99[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g98[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g98[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g97[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g96[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g96[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g97[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g96[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g96[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g99[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g98[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g98[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g97[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g96[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g96[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g97[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g96[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g96[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g103[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g102[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g102[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g101[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g100[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g100[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g101[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g100[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g100[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g99[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g98[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g98[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g97[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g96[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g96[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g97[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g96[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g96[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g99[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g98[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g98[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g97[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g96[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g96[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g97[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g96[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g96[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g95[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g94[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g94[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g93[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g92[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g92[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g93[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g92[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g92[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g91[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g90[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g90[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g89[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g88[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g88[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g89[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g88[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g88[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g91[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g90[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g90[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g89[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g88[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g88[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g89[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g88[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g88[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g87[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g86[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g86[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g85[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g84[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g84[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g85[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g84[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g84[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g83[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g82[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g82[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g81[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g80[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g80[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g81[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g80[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g80[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g83[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g82[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g82[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g81[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g80[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g80[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g81[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g80[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g80[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g87[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g86[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g86[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g85[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g84[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g84[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g85[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g84[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g84[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g83[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g82[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g82[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g81[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g80[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g80[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g81[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g80[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g80[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g83[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g82[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g82[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g81[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g80[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g80[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g81[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g80[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g80[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g79[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g78[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g78[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g77[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g76[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g76[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g77[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g76[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g76[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g75[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g74[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g74[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g73[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g72[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g72[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g73[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g72[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g72[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g75[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g74[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g74[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g73[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g72[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g72[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g73[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g72[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g72[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g71[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g70[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g70[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g69[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g68[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g68[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g69[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g68[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g68[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g67[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g66[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g66[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g65[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g64[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g64[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g65[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g64[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g64[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g67[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g66[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g66[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g65[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g64[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g64[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g65[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g64[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g64[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g71[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g70[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g70[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g69[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g68[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g68[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g69[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g68[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g68[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g67[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g66[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g66[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g65[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g64[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g64[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g65[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g64[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g64[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g67[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g66[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g66[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g65[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g64[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g64[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g65[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g64[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g64[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g79[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g78[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g78[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g77[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g76[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g76[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g77[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g76[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g76[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g75[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g74[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g74[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g73[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g72[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g72[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g73[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g72[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g72[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g75[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g74[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g74[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g73[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g72[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g72[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g73[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g72[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g72[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g71[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g70[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g70[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g69[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g68[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g68[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g69[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g68[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g68[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g67[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g66[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g66[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g65[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g64[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g64[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g65[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g64[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g64[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g67[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g66[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g66[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g65[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g64[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g64[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g65[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g64[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g64[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g71[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g70[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g70[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g69[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g68[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g68[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g69[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g68[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g68[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g67[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g66[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g66[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g65[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g64[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g64[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g65[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g64[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g64[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g67[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g66[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g66[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g65[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g64[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g64[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g65[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g64[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g64[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g95[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g94[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g94[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g93[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g92[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g92[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g93[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g92[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g92[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g91[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g90[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g90[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g89[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g88[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g88[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g89[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g88[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g88[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g91[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g90[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g90[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g89[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g88[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g88[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g89[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g88[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g88[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g87[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g86[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g86[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g85[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g84[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g84[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g85[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g84[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g84[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g83[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g82[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g82[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g81[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g80[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g80[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g81[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g80[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g80[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g83[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g82[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g82[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g81[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g80[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g80[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g81[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g80[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g80[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g87[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g86[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g86[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g85[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g84[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g84[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g85[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g84[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g84[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g83[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g82[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g82[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g81[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g80[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g80[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g81[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g80[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g80[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g83[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g82[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g82[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g81[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g80[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g80[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g81[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g80[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g80[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g79[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g78[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g78[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g77[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g76[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g76[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g77[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g76[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g76[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g75[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g74[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g74[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g73[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g72[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g72[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g73[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g72[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g72[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g75[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g74[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g74[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g73[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g72[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g72[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g73[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g72[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g72[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g71[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g70[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g70[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g69[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g68[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g68[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g69[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g68[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g68[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g67[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g66[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g66[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g65[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g64[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g64[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g65[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g64[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g64[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g67[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g66[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g66[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g65[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g64[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g64[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g65[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g64[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g64[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g71[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g70[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g70[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g69[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g68[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g68[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g69[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g68[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g68[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g67[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g66[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g66[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g65[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g64[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g64[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g65[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g64[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g64[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g67[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g66[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g66[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g65[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g64[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g64[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g65[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g64[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g64[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g79[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g78[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g78[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g77[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g76[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g76[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g77[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g76[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g76[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g75[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g74[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g74[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g73[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g72[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g72[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g73[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g72[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g72[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g75[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g74[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g74[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g73[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g72[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g72[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g73[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g72[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g72[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g71[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g70[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g70[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g69[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g68[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g68[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g69[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g68[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g68[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g67[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g66[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g66[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g65[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g64[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g64[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g65[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g64[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g64[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g67[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g66[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g66[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g65[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g64[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g64[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g65[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g64[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g64[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g71[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g70[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g70[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g69[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g68[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g68[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g69[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g68[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g68[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g67[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g66[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g66[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g65[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g64[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g64[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g65[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g64[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g64[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g67[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g66[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g66[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g65[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g64[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g64[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g65[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g64[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g64[ix+0]*g0[iy+0]*g63[iz+0];
s[729] = + g63[ix+0]*g64[iy+0]*g0[iz+0];
s[730] = + g62[ix+0]*g65[iy+0]*g0[iz+0];
s[731] = + g62[ix+0]*g64[iy+0]*g1[iz+0];
s[732] = + g61[ix+0]*g66[iy+0]*g0[iz+0];
s[733] = + g60[ix+0]*g67[iy+0]*g0[iz+0];
s[734] = + g60[ix+0]*g66[iy+0]*g1[iz+0];
s[735] = + g61[ix+0]*g64[iy+0]*g2[iz+0];
s[736] = + g60[ix+0]*g65[iy+0]*g2[iz+0];
s[737] = + g60[ix+0]*g64[iy+0]*g3[iz+0];
s[738] = + g59[ix+0]*g68[iy+0]*g0[iz+0];
s[739] = + g58[ix+0]*g69[iy+0]*g0[iz+0];
s[740] = + g58[ix+0]*g68[iy+0]*g1[iz+0];
s[741] = + g57[ix+0]*g70[iy+0]*g0[iz+0];
s[742] = + g56[ix+0]*g71[iy+0]*g0[iz+0];
s[743] = + g56[ix+0]*g70[iy+0]*g1[iz+0];
s[744] = + g57[ix+0]*g68[iy+0]*g2[iz+0];
s[745] = + g56[ix+0]*g69[iy+0]*g2[iz+0];
s[746] = + g56[ix+0]*g68[iy+0]*g3[iz+0];
s[747] = + g59[ix+0]*g64[iy+0]*g4[iz+0];
s[748] = + g58[ix+0]*g65[iy+0]*g4[iz+0];
s[749] = + g58[ix+0]*g64[iy+0]*g5[iz+0];
s[750] = + g57[ix+0]*g66[iy+0]*g4[iz+0];
s[751] = + g56[ix+0]*g67[iy+0]*g4[iz+0];
s[752] = + g56[ix+0]*g66[iy+0]*g5[iz+0];
s[753] = + g57[ix+0]*g64[iy+0]*g6[iz+0];
s[754] = + g56[ix+0]*g65[iy+0]*g6[iz+0];
s[755] = + g56[ix+0]*g64[iy+0]*g7[iz+0];
s[756] = + g55[ix+0]*g72[iy+0]*g0[iz+0];
s[757] = + g54[ix+0]*g73[iy+0]*g0[iz+0];
s[758] = + g54[ix+0]*g72[iy+0]*g1[iz+0];
s[759] = + g53[ix+0]*g74[iy+0]*g0[iz+0];
s[760] = + g52[ix+0]*g75[iy+0]*g0[iz+0];
s[761] = + g52[ix+0]*g74[iy+0]*g1[iz+0];
s[762] = + g53[ix+0]*g72[iy+0]*g2[iz+0];
s[763] = + g52[ix+0]*g73[iy+0]*g2[iz+0];
s[764] = + g52[ix+0]*g72[iy+0]*g3[iz+0];
s[765] = + g51[ix+0]*g76[iy+0]*g0[iz+0];
s[766] = + g50[ix+0]*g77[iy+0]*g0[iz+0];
s[767] = + g50[ix+0]*g76[iy+0]*g1[iz+0];
s[768] = + g49[ix+0]*g78[iy+0]*g0[iz+0];
s[769] = + g48[ix+0]*g79[iy+0]*g0[iz+0];
s[770] = + g48[ix+0]*g78[iy+0]*g1[iz+0];
s[771] = + g49[ix+0]*g76[iy+0]*g2[iz+0];
s[772] = + g48[ix+0]*g77[iy+0]*g2[iz+0];
s[773] = + g48[ix+0]*g76[iy+0]*g3[iz+0];
s[774] = + g51[ix+0]*g72[iy+0]*g4[iz+0];
s[775] = + g50[ix+0]*g73[iy+0]*g4[iz+0];
s[776] = + g50[ix+0]*g72[iy+0]*g5[iz+0];
s[777] = + g49[ix+0]*g74[iy+0]*g4[iz+0];
s[778] = + g48[ix+0]*g75[iy+0]*g4[iz+0];
s[779] = + g48[ix+0]*g74[iy+0]*g5[iz+0];
s[780] = + g49[ix+0]*g72[iy+0]*g6[iz+0];
s[781] = + g48[ix+0]*g73[iy+0]*g6[iz+0];
s[782] = + g48[ix+0]*g72[iy+0]*g7[iz+0];
s[783] = + g55[ix+0]*g64[iy+0]*g8[iz+0];
s[784] = + g54[ix+0]*g65[iy+0]*g8[iz+0];
s[785] = + g54[ix+0]*g64[iy+0]*g9[iz+0];
s[786] = + g53[ix+0]*g66[iy+0]*g8[iz+0];
s[787] = + g52[ix+0]*g67[iy+0]*g8[iz+0];
s[788] = + g52[ix+0]*g66[iy+0]*g9[iz+0];
s[789] = + g53[ix+0]*g64[iy+0]*g10[iz+0];
s[790] = + g52[ix+0]*g65[iy+0]*g10[iz+0];
s[791] = + g52[ix+0]*g64[iy+0]*g11[iz+0];
s[792] = + g51[ix+0]*g68[iy+0]*g8[iz+0];
s[793] = + g50[ix+0]*g69[iy+0]*g8[iz+0];
s[794] = + g50[ix+0]*g68[iy+0]*g9[iz+0];
s[795] = + g49[ix+0]*g70[iy+0]*g8[iz+0];
s[796] = + g48[ix+0]*g71[iy+0]*g8[iz+0];
s[797] = + g48[ix+0]*g70[iy+0]*g9[iz+0];
s[798] = + g49[ix+0]*g68[iy+0]*g10[iz+0];
s[799] = + g48[ix+0]*g69[iy+0]*g10[iz+0];
s[800] = + g48[ix+0]*g68[iy+0]*g11[iz+0];
s[801] = + g51[ix+0]*g64[iy+0]*g12[iz+0];
s[802] = + g50[ix+0]*g65[iy+0]*g12[iz+0];
s[803] = + g50[ix+0]*g64[iy+0]*g13[iz+0];
s[804] = + g49[ix+0]*g66[iy+0]*g12[iz+0];
s[805] = + g48[ix+0]*g67[iy+0]*g12[iz+0];
s[806] = + g48[ix+0]*g66[iy+0]*g13[iz+0];
s[807] = + g49[ix+0]*g64[iy+0]*g14[iz+0];
s[808] = + g48[ix+0]*g65[iy+0]*g14[iz+0];
s[809] = + g48[ix+0]*g64[iy+0]*g15[iz+0];
s[810] = + g47[ix+0]*g80[iy+0]*g0[iz+0];
s[811] = + g46[ix+0]*g81[iy+0]*g0[iz+0];
s[812] = + g46[ix+0]*g80[iy+0]*g1[iz+0];
s[813] = + g45[ix+0]*g82[iy+0]*g0[iz+0];
s[814] = + g44[ix+0]*g83[iy+0]*g0[iz+0];
s[815] = + g44[ix+0]*g82[iy+0]*g1[iz+0];
s[816] = + g45[ix+0]*g80[iy+0]*g2[iz+0];
s[817] = + g44[ix+0]*g81[iy+0]*g2[iz+0];
s[818] = + g44[ix+0]*g80[iy+0]*g3[iz+0];
s[819] = + g43[ix+0]*g84[iy+0]*g0[iz+0];
s[820] = + g42[ix+0]*g85[iy+0]*g0[iz+0];
s[821] = + g42[ix+0]*g84[iy+0]*g1[iz+0];
s[822] = + g41[ix+0]*g86[iy+0]*g0[iz+0];
s[823] = + g40[ix+0]*g87[iy+0]*g0[iz+0];
s[824] = + g40[ix+0]*g86[iy+0]*g1[iz+0];
s[825] = + g41[ix+0]*g84[iy+0]*g2[iz+0];
s[826] = + g40[ix+0]*g85[iy+0]*g2[iz+0];
s[827] = + g40[ix+0]*g84[iy+0]*g3[iz+0];
s[828] = + g43[ix+0]*g80[iy+0]*g4[iz+0];
s[829] = + g42[ix+0]*g81[iy+0]*g4[iz+0];
s[830] = + g42[ix+0]*g80[iy+0]*g5[iz+0];
s[831] = + g41[ix+0]*g82[iy+0]*g4[iz+0];
s[832] = + g40[ix+0]*g83[iy+0]*g4[iz+0];
s[833] = + g40[ix+0]*g82[iy+0]*g5[iz+0];
s[834] = + g41[ix+0]*g80[iy+0]*g6[iz+0];
s[835] = + g40[ix+0]*g81[iy+0]*g6[iz+0];
s[836] = + g40[ix+0]*g80[iy+0]*g7[iz+0];
s[837] = + g39[ix+0]*g88[iy+0]*g0[iz+0];
s[838] = + g38[ix+0]*g89[iy+0]*g0[iz+0];
s[839] = + g38[ix+0]*g88[iy+0]*g1[iz+0];
s[840] = + g37[ix+0]*g90[iy+0]*g0[iz+0];
s[841] = + g36[ix+0]*g91[iy+0]*g0[iz+0];
s[842] = + g36[ix+0]*g90[iy+0]*g1[iz+0];
s[843] = + g37[ix+0]*g88[iy+0]*g2[iz+0];
s[844] = + g36[ix+0]*g89[iy+0]*g2[iz+0];
s[845] = + g36[ix+0]*g88[iy+0]*g3[iz+0];
s[846] = + g35[ix+0]*g92[iy+0]*g0[iz+0];
s[847] = + g34[ix+0]*g93[iy+0]*g0[iz+0];
s[848] = + g34[ix+0]*g92[iy+0]*g1[iz+0];
s[849] = + g33[ix+0]*g94[iy+0]*g0[iz+0];
s[850] = + g32[ix+0]*g95[iy+0]*g0[iz+0];
s[851] = + g32[ix+0]*g94[iy+0]*g1[iz+0];
s[852] = + g33[ix+0]*g92[iy+0]*g2[iz+0];
s[853] = + g32[ix+0]*g93[iy+0]*g2[iz+0];
s[854] = + g32[ix+0]*g92[iy+0]*g3[iz+0];
s[855] = + g35[ix+0]*g88[iy+0]*g4[iz+0];
s[856] = + g34[ix+0]*g89[iy+0]*g4[iz+0];
s[857] = + g34[ix+0]*g88[iy+0]*g5[iz+0];
s[858] = + g33[ix+0]*g90[iy+0]*g4[iz+0];
s[859] = + g32[ix+0]*g91[iy+0]*g4[iz+0];
s[860] = + g32[ix+0]*g90[iy+0]*g5[iz+0];
s[861] = + g33[ix+0]*g88[iy+0]*g6[iz+0];
s[862] = + g32[ix+0]*g89[iy+0]*g6[iz+0];
s[863] = + g32[ix+0]*g88[iy+0]*g7[iz+0];
s[864] = + g39[ix+0]*g80[iy+0]*g8[iz+0];
s[865] = + g38[ix+0]*g81[iy+0]*g8[iz+0];
s[866] = + g38[ix+0]*g80[iy+0]*g9[iz+0];
s[867] = + g37[ix+0]*g82[iy+0]*g8[iz+0];
s[868] = + g36[ix+0]*g83[iy+0]*g8[iz+0];
s[869] = + g36[ix+0]*g82[iy+0]*g9[iz+0];
s[870] = + g37[ix+0]*g80[iy+0]*g10[iz+0];
s[871] = + g36[ix+0]*g81[iy+0]*g10[iz+0];
s[872] = + g36[ix+0]*g80[iy+0]*g11[iz+0];
s[873] = + g35[ix+0]*g84[iy+0]*g8[iz+0];
s[874] = + g34[ix+0]*g85[iy+0]*g8[iz+0];
s[875] = + g34[ix+0]*g84[iy+0]*g9[iz+0];
s[876] = + g33[ix+0]*g86[iy+0]*g8[iz+0];
s[877] = + g32[ix+0]*g87[iy+0]*g8[iz+0];
s[878] = + g32[ix+0]*g86[iy+0]*g9[iz+0];
s[879] = + g33[ix+0]*g84[iy+0]*g10[iz+0];
s[880] = + g32[ix+0]*g85[iy+0]*g10[iz+0];
s[881] = + g32[ix+0]*g84[iy+0]*g11[iz+0];
s[882] = + g35[ix+0]*g80[iy+0]*g12[iz+0];
s[883] = + g34[ix+0]*g81[iy+0]*g12[iz+0];
s[884] = + g34[ix+0]*g80[iy+0]*g13[iz+0];
s[885] = + g33[ix+0]*g82[iy+0]*g12[iz+0];
s[886] = + g32[ix+0]*g83[iy+0]*g12[iz+0];
s[887] = + g32[ix+0]*g82[iy+0]*g13[iz+0];
s[888] = + g33[ix+0]*g80[iy+0]*g14[iz+0];
s[889] = + g32[ix+0]*g81[iy+0]*g14[iz+0];
s[890] = + g32[ix+0]*g80[iy+0]*g15[iz+0];
s[891] = + g47[ix+0]*g64[iy+0]*g16[iz+0];
s[892] = + g46[ix+0]*g65[iy+0]*g16[iz+0];
s[893] = + g46[ix+0]*g64[iy+0]*g17[iz+0];
s[894] = + g45[ix+0]*g66[iy+0]*g16[iz+0];
s[895] = + g44[ix+0]*g67[iy+0]*g16[iz+0];
s[896] = + g44[ix+0]*g66[iy+0]*g17[iz+0];
s[897] = + g45[ix+0]*g64[iy+0]*g18[iz+0];
s[898] = + g44[ix+0]*g65[iy+0]*g18[iz+0];
s[899] = + g44[ix+0]*g64[iy+0]*g19[iz+0];
s[900] = + g43[ix+0]*g68[iy+0]*g16[iz+0];
s[901] = + g42[ix+0]*g69[iy+0]*g16[iz+0];
s[902] = + g42[ix+0]*g68[iy+0]*g17[iz+0];
s[903] = + g41[ix+0]*g70[iy+0]*g16[iz+0];
s[904] = + g40[ix+0]*g71[iy+0]*g16[iz+0];
s[905] = + g40[ix+0]*g70[iy+0]*g17[iz+0];
s[906] = + g41[ix+0]*g68[iy+0]*g18[iz+0];
s[907] = + g40[ix+0]*g69[iy+0]*g18[iz+0];
s[908] = + g40[ix+0]*g68[iy+0]*g19[iz+0];
s[909] = + g43[ix+0]*g64[iy+0]*g20[iz+0];
s[910] = + g42[ix+0]*g65[iy+0]*g20[iz+0];
s[911] = + g42[ix+0]*g64[iy+0]*g21[iz+0];
s[912] = + g41[ix+0]*g66[iy+0]*g20[iz+0];
s[913] = + g40[ix+0]*g67[iy+0]*g20[iz+0];
s[914] = + g40[ix+0]*g66[iy+0]*g21[iz+0];
s[915] = + g41[ix+0]*g64[iy+0]*g22[iz+0];
s[916] = + g40[ix+0]*g65[iy+0]*g22[iz+0];
s[917] = + g40[ix+0]*g64[iy+0]*g23[iz+0];
s[918] = + g39[ix+0]*g72[iy+0]*g16[iz+0];
s[919] = + g38[ix+0]*g73[iy+0]*g16[iz+0];
s[920] = + g38[ix+0]*g72[iy+0]*g17[iz+0];
s[921] = + g37[ix+0]*g74[iy+0]*g16[iz+0];
s[922] = + g36[ix+0]*g75[iy+0]*g16[iz+0];
s[923] = + g36[ix+0]*g74[iy+0]*g17[iz+0];
s[924] = + g37[ix+0]*g72[iy+0]*g18[iz+0];
s[925] = + g36[ix+0]*g73[iy+0]*g18[iz+0];
s[926] = + g36[ix+0]*g72[iy+0]*g19[iz+0];
s[927] = + g35[ix+0]*g76[iy+0]*g16[iz+0];
s[928] = + g34[ix+0]*g77[iy+0]*g16[iz+0];
s[929] = + g34[ix+0]*g76[iy+0]*g17[iz+0];
s[930] = + g33[ix+0]*g78[iy+0]*g16[iz+0];
s[931] = + g32[ix+0]*g79[iy+0]*g16[iz+0];
s[932] = + g32[ix+0]*g78[iy+0]*g17[iz+0];
s[933] = + g33[ix+0]*g76[iy+0]*g18[iz+0];
s[934] = + g32[ix+0]*g77[iy+0]*g18[iz+0];
s[935] = + g32[ix+0]*g76[iy+0]*g19[iz+0];
s[936] = + g35[ix+0]*g72[iy+0]*g20[iz+0];
s[937] = + g34[ix+0]*g73[iy+0]*g20[iz+0];
s[938] = + g34[ix+0]*g72[iy+0]*g21[iz+0];
s[939] = + g33[ix+0]*g74[iy+0]*g20[iz+0];
s[940] = + g32[ix+0]*g75[iy+0]*g20[iz+0];
s[941] = + g32[ix+0]*g74[iy+0]*g21[iz+0];
s[942] = + g33[ix+0]*g72[iy+0]*g22[iz+0];
s[943] = + g32[ix+0]*g73[iy+0]*g22[iz+0];
s[944] = + g32[ix+0]*g72[iy+0]*g23[iz+0];
s[945] = + g39[ix+0]*g64[iy+0]*g24[iz+0];
s[946] = + g38[ix+0]*g65[iy+0]*g24[iz+0];
s[947] = + g38[ix+0]*g64[iy+0]*g25[iz+0];
s[948] = + g37[ix+0]*g66[iy+0]*g24[iz+0];
s[949] = + g36[ix+0]*g67[iy+0]*g24[iz+0];
s[950] = + g36[ix+0]*g66[iy+0]*g25[iz+0];
s[951] = + g37[ix+0]*g64[iy+0]*g26[iz+0];
s[952] = + g36[ix+0]*g65[iy+0]*g26[iz+0];
s[953] = + g36[ix+0]*g64[iy+0]*g27[iz+0];
s[954] = + g35[ix+0]*g68[iy+0]*g24[iz+0];
s[955] = + g34[ix+0]*g69[iy+0]*g24[iz+0];
s[956] = + g34[ix+0]*g68[iy+0]*g25[iz+0];
s[957] = + g33[ix+0]*g70[iy+0]*g24[iz+0];
s[958] = + g32[ix+0]*g71[iy+0]*g24[iz+0];
s[959] = + g32[ix+0]*g70[iy+0]*g25[iz+0];
s[960] = + g33[ix+0]*g68[iy+0]*g26[iz+0];
s[961] = + g32[ix+0]*g69[iy+0]*g26[iz+0];
s[962] = + g32[ix+0]*g68[iy+0]*g27[iz+0];
s[963] = + g35[ix+0]*g64[iy+0]*g28[iz+0];
s[964] = + g34[ix+0]*g65[iy+0]*g28[iz+0];
s[965] = + g34[ix+0]*g64[iy+0]*g29[iz+0];
s[966] = + g33[ix+0]*g66[iy+0]*g28[iz+0];
s[967] = + g32[ix+0]*g67[iy+0]*g28[iz+0];
s[968] = + g32[ix+0]*g66[iy+0]*g29[iz+0];
s[969] = + g33[ix+0]*g64[iy+0]*g30[iz+0];
s[970] = + g32[ix+0]*g65[iy+0]*g30[iz+0];
s[971] = + g32[ix+0]*g64[iy+0]*g31[iz+0];
s[972] = + g31[ix+0]*g96[iy+0]*g0[iz+0];
s[973] = + g30[ix+0]*g97[iy+0]*g0[iz+0];
s[974] = + g30[ix+0]*g96[iy+0]*g1[iz+0];
s[975] = + g29[ix+0]*g98[iy+0]*g0[iz+0];
s[976] = + g28[ix+0]*g99[iy+0]*g0[iz+0];
s[977] = + g28[ix+0]*g98[iy+0]*g1[iz+0];
s[978] = + g29[ix+0]*g96[iy+0]*g2[iz+0];
s[979] = + g28[ix+0]*g97[iy+0]*g2[iz+0];
s[980] = + g28[ix+0]*g96[iy+0]*g3[iz+0];
s[981] = + g27[ix+0]*g100[iy+0]*g0[iz+0];
s[982] = + g26[ix+0]*g101[iy+0]*g0[iz+0];
s[983] = + g26[ix+0]*g100[iy+0]*g1[iz+0];
s[984] = + g25[ix+0]*g102[iy+0]*g0[iz+0];
s[985] = + g24[ix+0]*g103[iy+0]*g0[iz+0];
s[986] = + g24[ix+0]*g102[iy+0]*g1[iz+0];
s[987] = + g25[ix+0]*g100[iy+0]*g2[iz+0];
s[988] = + g24[ix+0]*g101[iy+0]*g2[iz+0];
s[989] = + g24[ix+0]*g100[iy+0]*g3[iz+0];
s[990] = + g27[ix+0]*g96[iy+0]*g4[iz+0];
s[991] = + g26[ix+0]*g97[iy+0]*g4[iz+0];
s[992] = + g26[ix+0]*g96[iy+0]*g5[iz+0];
s[993] = + g25[ix+0]*g98[iy+0]*g4[iz+0];
s[994] = + g24[ix+0]*g99[iy+0]*g4[iz+0];
s[995] = + g24[ix+0]*g98[iy+0]*g5[iz+0];
s[996] = + g25[ix+0]*g96[iy+0]*g6[iz+0];
s[997] = + g24[ix+0]*g97[iy+0]*g6[iz+0];
s[998] = + g24[ix+0]*g96[iy+0]*g7[iz+0];
s[999] = + g23[ix+0]*g104[iy+0]*g0[iz+0];
s[1000] = + g22[ix+0]*g105[iy+0]*g0[iz+0];
s[1001] = + g22[ix+0]*g104[iy+0]*g1[iz+0];
s[1002] = + g21[ix+0]*g106[iy+0]*g0[iz+0];
s[1003] = + g20[ix+0]*g107[iy+0]*g0[iz+0];
s[1004] = + g20[ix+0]*g106[iy+0]*g1[iz+0];
s[1005] = + g21[ix+0]*g104[iy+0]*g2[iz+0];
s[1006] = + g20[ix+0]*g105[iy+0]*g2[iz+0];
s[1007] = + g20[ix+0]*g104[iy+0]*g3[iz+0];
s[1008] = + g19[ix+0]*g108[iy+0]*g0[iz+0];
s[1009] = + g18[ix+0]*g109[iy+0]*g0[iz+0];
s[1010] = + g18[ix+0]*g108[iy+0]*g1[iz+0];
s[1011] = + g17[ix+0]*g110[iy+0]*g0[iz+0];
s[1012] = + g16[ix+0]*g111[iy+0]*g0[iz+0];
s[1013] = + g16[ix+0]*g110[iy+0]*g1[iz+0];
s[1014] = + g17[ix+0]*g108[iy+0]*g2[iz+0];
s[1015] = + g16[ix+0]*g109[iy+0]*g2[iz+0];
s[1016] = + g16[ix+0]*g108[iy+0]*g3[iz+0];
s[1017] = + g19[ix+0]*g104[iy+0]*g4[iz+0];
s[1018] = + g18[ix+0]*g105[iy+0]*g4[iz+0];
s[1019] = + g18[ix+0]*g104[iy+0]*g5[iz+0];
s[1020] = + g17[ix+0]*g106[iy+0]*g4[iz+0];
s[1021] = + g16[ix+0]*g107[iy+0]*g4[iz+0];
s[1022] = + g16[ix+0]*g106[iy+0]*g5[iz+0];
s[1023] = + g17[ix+0]*g104[iy+0]*g6[iz+0];
s[1024] = + g16[ix+0]*g105[iy+0]*g6[iz+0];
s[1025] = + g16[ix+0]*g104[iy+0]*g7[iz+0];
s[1026] = + g23[ix+0]*g96[iy+0]*g8[iz+0];
s[1027] = + g22[ix+0]*g97[iy+0]*g8[iz+0];
s[1028] = + g22[ix+0]*g96[iy+0]*g9[iz+0];
s[1029] = + g21[ix+0]*g98[iy+0]*g8[iz+0];
s[1030] = + g20[ix+0]*g99[iy+0]*g8[iz+0];
s[1031] = + g20[ix+0]*g98[iy+0]*g9[iz+0];
s[1032] = + g21[ix+0]*g96[iy+0]*g10[iz+0];
s[1033] = + g20[ix+0]*g97[iy+0]*g10[iz+0];
s[1034] = + g20[ix+0]*g96[iy+0]*g11[iz+0];
s[1035] = + g19[ix+0]*g100[iy+0]*g8[iz+0];
s[1036] = + g18[ix+0]*g101[iy+0]*g8[iz+0];
s[1037] = + g18[ix+0]*g100[iy+0]*g9[iz+0];
s[1038] = + g17[ix+0]*g102[iy+0]*g8[iz+0];
s[1039] = + g16[ix+0]*g103[iy+0]*g8[iz+0];
s[1040] = + g16[ix+0]*g102[iy+0]*g9[iz+0];
s[1041] = + g17[ix+0]*g100[iy+0]*g10[iz+0];
s[1042] = + g16[ix+0]*g101[iy+0]*g10[iz+0];
s[1043] = + g16[ix+0]*g100[iy+0]*g11[iz+0];
s[1044] = + g19[ix+0]*g96[iy+0]*g12[iz+0];
s[1045] = + g18[ix+0]*g97[iy+0]*g12[iz+0];
s[1046] = + g18[ix+0]*g96[iy+0]*g13[iz+0];
s[1047] = + g17[ix+0]*g98[iy+0]*g12[iz+0];
s[1048] = + g16[ix+0]*g99[iy+0]*g12[iz+0];
s[1049] = + g16[ix+0]*g98[iy+0]*g13[iz+0];
s[1050] = + g17[ix+0]*g96[iy+0]*g14[iz+0];
s[1051] = + g16[ix+0]*g97[iy+0]*g14[iz+0];
s[1052] = + g16[ix+0]*g96[iy+0]*g15[iz+0];
s[1053] = + g15[ix+0]*g112[iy+0]*g0[iz+0];
s[1054] = + g14[ix+0]*g113[iy+0]*g0[iz+0];
s[1055] = + g14[ix+0]*g112[iy+0]*g1[iz+0];
s[1056] = + g13[ix+0]*g114[iy+0]*g0[iz+0];
s[1057] = + g12[ix+0]*g115[iy+0]*g0[iz+0];
s[1058] = + g12[ix+0]*g114[iy+0]*g1[iz+0];
s[1059] = + g13[ix+0]*g112[iy+0]*g2[iz+0];
s[1060] = + g12[ix+0]*g113[iy+0]*g2[iz+0];
s[1061] = + g12[ix+0]*g112[iy+0]*g3[iz+0];
s[1062] = + g11[ix+0]*g116[iy+0]*g0[iz+0];
s[1063] = + g10[ix+0]*g117[iy+0]*g0[iz+0];
s[1064] = + g10[ix+0]*g116[iy+0]*g1[iz+0];
s[1065] = + g9[ix+0]*g118[iy+0]*g0[iz+0];
s[1066] = + g8[ix+0]*g119[iy+0]*g0[iz+0];
s[1067] = + g8[ix+0]*g118[iy+0]*g1[iz+0];
s[1068] = + g9[ix+0]*g116[iy+0]*g2[iz+0];
s[1069] = + g8[ix+0]*g117[iy+0]*g2[iz+0];
s[1070] = + g8[ix+0]*g116[iy+0]*g3[iz+0];
s[1071] = + g11[ix+0]*g112[iy+0]*g4[iz+0];
s[1072] = + g10[ix+0]*g113[iy+0]*g4[iz+0];
s[1073] = + g10[ix+0]*g112[iy+0]*g5[iz+0];
s[1074] = + g9[ix+0]*g114[iy+0]*g4[iz+0];
s[1075] = + g8[ix+0]*g115[iy+0]*g4[iz+0];
s[1076] = + g8[ix+0]*g114[iy+0]*g5[iz+0];
s[1077] = + g9[ix+0]*g112[iy+0]*g6[iz+0];
s[1078] = + g8[ix+0]*g113[iy+0]*g6[iz+0];
s[1079] = + g8[ix+0]*g112[iy+0]*g7[iz+0];
s[1080] = + g7[ix+0]*g120[iy+0]*g0[iz+0];
s[1081] = + g6[ix+0]*g121[iy+0]*g0[iz+0];
s[1082] = + g6[ix+0]*g120[iy+0]*g1[iz+0];
s[1083] = + g5[ix+0]*g122[iy+0]*g0[iz+0];
s[1084] = + g4[ix+0]*g123[iy+0]*g0[iz+0];
s[1085] = + g4[ix+0]*g122[iy+0]*g1[iz+0];
s[1086] = + g5[ix+0]*g120[iy+0]*g2[iz+0];
s[1087] = + g4[ix+0]*g121[iy+0]*g2[iz+0];
s[1088] = + g4[ix+0]*g120[iy+0]*g3[iz+0];
s[1089] = + g3[ix+0]*g124[iy+0]*g0[iz+0];
s[1090] = + g2[ix+0]*g125[iy+0]*g0[iz+0];
s[1091] = + g2[ix+0]*g124[iy+0]*g1[iz+0];
s[1092] = + g1[ix+0]*g126[iy+0]*g0[iz+0];
s[1093] = + g0[ix+0]*g127[iy+0]*g0[iz+0];
s[1094] = + g0[ix+0]*g126[iy+0]*g1[iz+0];
s[1095] = + g1[ix+0]*g124[iy+0]*g2[iz+0];
s[1096] = + g0[ix+0]*g125[iy+0]*g2[iz+0];
s[1097] = + g0[ix+0]*g124[iy+0]*g3[iz+0];
s[1098] = + g3[ix+0]*g120[iy+0]*g4[iz+0];
s[1099] = + g2[ix+0]*g121[iy+0]*g4[iz+0];
s[1100] = + g2[ix+0]*g120[iy+0]*g5[iz+0];
s[1101] = + g1[ix+0]*g122[iy+0]*g4[iz+0];
s[1102] = + g0[ix+0]*g123[iy+0]*g4[iz+0];
s[1103] = + g0[ix+0]*g122[iy+0]*g5[iz+0];
s[1104] = + g1[ix+0]*g120[iy+0]*g6[iz+0];
s[1105] = + g0[ix+0]*g121[iy+0]*g6[iz+0];
s[1106] = + g0[ix+0]*g120[iy+0]*g7[iz+0];
s[1107] = + g7[ix+0]*g112[iy+0]*g8[iz+0];
s[1108] = + g6[ix+0]*g113[iy+0]*g8[iz+0];
s[1109] = + g6[ix+0]*g112[iy+0]*g9[iz+0];
s[1110] = + g5[ix+0]*g114[iy+0]*g8[iz+0];
s[1111] = + g4[ix+0]*g115[iy+0]*g8[iz+0];
s[1112] = + g4[ix+0]*g114[iy+0]*g9[iz+0];
s[1113] = + g5[ix+0]*g112[iy+0]*g10[iz+0];
s[1114] = + g4[ix+0]*g113[iy+0]*g10[iz+0];
s[1115] = + g4[ix+0]*g112[iy+0]*g11[iz+0];
s[1116] = + g3[ix+0]*g116[iy+0]*g8[iz+0];
s[1117] = + g2[ix+0]*g117[iy+0]*g8[iz+0];
s[1118] = + g2[ix+0]*g116[iy+0]*g9[iz+0];
s[1119] = + g1[ix+0]*g118[iy+0]*g8[iz+0];
s[1120] = + g0[ix+0]*g119[iy+0]*g8[iz+0];
s[1121] = + g0[ix+0]*g118[iy+0]*g9[iz+0];
s[1122] = + g1[ix+0]*g116[iy+0]*g10[iz+0];
s[1123] = + g0[ix+0]*g117[iy+0]*g10[iz+0];
s[1124] = + g0[ix+0]*g116[iy+0]*g11[iz+0];
s[1125] = + g3[ix+0]*g112[iy+0]*g12[iz+0];
s[1126] = + g2[ix+0]*g113[iy+0]*g12[iz+0];
s[1127] = + g2[ix+0]*g112[iy+0]*g13[iz+0];
s[1128] = + g1[ix+0]*g114[iy+0]*g12[iz+0];
s[1129] = + g0[ix+0]*g115[iy+0]*g12[iz+0];
s[1130] = + g0[ix+0]*g114[iy+0]*g13[iz+0];
s[1131] = + g1[ix+0]*g112[iy+0]*g14[iz+0];
s[1132] = + g0[ix+0]*g113[iy+0]*g14[iz+0];
s[1133] = + g0[ix+0]*g112[iy+0]*g15[iz+0];
s[1134] = + g15[ix+0]*g96[iy+0]*g16[iz+0];
s[1135] = + g14[ix+0]*g97[iy+0]*g16[iz+0];
s[1136] = + g14[ix+0]*g96[iy+0]*g17[iz+0];
s[1137] = + g13[ix+0]*g98[iy+0]*g16[iz+0];
s[1138] = + g12[ix+0]*g99[iy+0]*g16[iz+0];
s[1139] = + g12[ix+0]*g98[iy+0]*g17[iz+0];
s[1140] = + g13[ix+0]*g96[iy+0]*g18[iz+0];
s[1141] = + g12[ix+0]*g97[iy+0]*g18[iz+0];
s[1142] = + g12[ix+0]*g96[iy+0]*g19[iz+0];
s[1143] = + g11[ix+0]*g100[iy+0]*g16[iz+0];
s[1144] = + g10[ix+0]*g101[iy+0]*g16[iz+0];
s[1145] = + g10[ix+0]*g100[iy+0]*g17[iz+0];
s[1146] = + g9[ix+0]*g102[iy+0]*g16[iz+0];
s[1147] = + g8[ix+0]*g103[iy+0]*g16[iz+0];
s[1148] = + g8[ix+0]*g102[iy+0]*g17[iz+0];
s[1149] = + g9[ix+0]*g100[iy+0]*g18[iz+0];
s[1150] = + g8[ix+0]*g101[iy+0]*g18[iz+0];
s[1151] = + g8[ix+0]*g100[iy+0]*g19[iz+0];
s[1152] = + g11[ix+0]*g96[iy+0]*g20[iz+0];
s[1153] = + g10[ix+0]*g97[iy+0]*g20[iz+0];
s[1154] = + g10[ix+0]*g96[iy+0]*g21[iz+0];
s[1155] = + g9[ix+0]*g98[iy+0]*g20[iz+0];
s[1156] = + g8[ix+0]*g99[iy+0]*g20[iz+0];
s[1157] = + g8[ix+0]*g98[iy+0]*g21[iz+0];
s[1158] = + g9[ix+0]*g96[iy+0]*g22[iz+0];
s[1159] = + g8[ix+0]*g97[iy+0]*g22[iz+0];
s[1160] = + g8[ix+0]*g96[iy+0]*g23[iz+0];
s[1161] = + g7[ix+0]*g104[iy+0]*g16[iz+0];
s[1162] = + g6[ix+0]*g105[iy+0]*g16[iz+0];
s[1163] = + g6[ix+0]*g104[iy+0]*g17[iz+0];
s[1164] = + g5[ix+0]*g106[iy+0]*g16[iz+0];
s[1165] = + g4[ix+0]*g107[iy+0]*g16[iz+0];
s[1166] = + g4[ix+0]*g106[iy+0]*g17[iz+0];
s[1167] = + g5[ix+0]*g104[iy+0]*g18[iz+0];
s[1168] = + g4[ix+0]*g105[iy+0]*g18[iz+0];
s[1169] = + g4[ix+0]*g104[iy+0]*g19[iz+0];
s[1170] = + g3[ix+0]*g108[iy+0]*g16[iz+0];
s[1171] = + g2[ix+0]*g109[iy+0]*g16[iz+0];
s[1172] = + g2[ix+0]*g108[iy+0]*g17[iz+0];
s[1173] = + g1[ix+0]*g110[iy+0]*g16[iz+0];
s[1174] = + g0[ix+0]*g111[iy+0]*g16[iz+0];
s[1175] = + g0[ix+0]*g110[iy+0]*g17[iz+0];
s[1176] = + g1[ix+0]*g108[iy+0]*g18[iz+0];
s[1177] = + g0[ix+0]*g109[iy+0]*g18[iz+0];
s[1178] = + g0[ix+0]*g108[iy+0]*g19[iz+0];
s[1179] = + g3[ix+0]*g104[iy+0]*g20[iz+0];
s[1180] = + g2[ix+0]*g105[iy+0]*g20[iz+0];
s[1181] = + g2[ix+0]*g104[iy+0]*g21[iz+0];
s[1182] = + g1[ix+0]*g106[iy+0]*g20[iz+0];
s[1183] = + g0[ix+0]*g107[iy+0]*g20[iz+0];
s[1184] = + g0[ix+0]*g106[iy+0]*g21[iz+0];
s[1185] = + g1[ix+0]*g104[iy+0]*g22[iz+0];
s[1186] = + g0[ix+0]*g105[iy+0]*g22[iz+0];
s[1187] = + g0[ix+0]*g104[iy+0]*g23[iz+0];
s[1188] = + g7[ix+0]*g96[iy+0]*g24[iz+0];
s[1189] = + g6[ix+0]*g97[iy+0]*g24[iz+0];
s[1190] = + g6[ix+0]*g96[iy+0]*g25[iz+0];
s[1191] = + g5[ix+0]*g98[iy+0]*g24[iz+0];
s[1192] = + g4[ix+0]*g99[iy+0]*g24[iz+0];
s[1193] = + g4[ix+0]*g98[iy+0]*g25[iz+0];
s[1194] = + g5[ix+0]*g96[iy+0]*g26[iz+0];
s[1195] = + g4[ix+0]*g97[iy+0]*g26[iz+0];
s[1196] = + g4[ix+0]*g96[iy+0]*g27[iz+0];
s[1197] = + g3[ix+0]*g100[iy+0]*g24[iz+0];
s[1198] = + g2[ix+0]*g101[iy+0]*g24[iz+0];
s[1199] = + g2[ix+0]*g100[iy+0]*g25[iz+0];
s[1200] = + g1[ix+0]*g102[iy+0]*g24[iz+0];
s[1201] = + g0[ix+0]*g103[iy+0]*g24[iz+0];
s[1202] = + g0[ix+0]*g102[iy+0]*g25[iz+0];
s[1203] = + g1[ix+0]*g100[iy+0]*g26[iz+0];
s[1204] = + g0[ix+0]*g101[iy+0]*g26[iz+0];
s[1205] = + g0[ix+0]*g100[iy+0]*g27[iz+0];
s[1206] = + g3[ix+0]*g96[iy+0]*g28[iz+0];
s[1207] = + g2[ix+0]*g97[iy+0]*g28[iz+0];
s[1208] = + g2[ix+0]*g96[iy+0]*g29[iz+0];
s[1209] = + g1[ix+0]*g98[iy+0]*g28[iz+0];
s[1210] = + g0[ix+0]*g99[iy+0]*g28[iz+0];
s[1211] = + g0[ix+0]*g98[iy+0]*g29[iz+0];
s[1212] = + g1[ix+0]*g96[iy+0]*g30[iz+0];
s[1213] = + g0[ix+0]*g97[iy+0]*g30[iz+0];
s[1214] = + g0[ix+0]*g96[iy+0]*g31[iz+0];
s[1215] = + g31[ix+0]*g64[iy+0]*g32[iz+0];
s[1216] = + g30[ix+0]*g65[iy+0]*g32[iz+0];
s[1217] = + g30[ix+0]*g64[iy+0]*g33[iz+0];
s[1218] = + g29[ix+0]*g66[iy+0]*g32[iz+0];
s[1219] = + g28[ix+0]*g67[iy+0]*g32[iz+0];
s[1220] = + g28[ix+0]*g66[iy+0]*g33[iz+0];
s[1221] = + g29[ix+0]*g64[iy+0]*g34[iz+0];
s[1222] = + g28[ix+0]*g65[iy+0]*g34[iz+0];
s[1223] = + g28[ix+0]*g64[iy+0]*g35[iz+0];
s[1224] = + g27[ix+0]*g68[iy+0]*g32[iz+0];
s[1225] = + g26[ix+0]*g69[iy+0]*g32[iz+0];
s[1226] = + g26[ix+0]*g68[iy+0]*g33[iz+0];
s[1227] = + g25[ix+0]*g70[iy+0]*g32[iz+0];
s[1228] = + g24[ix+0]*g71[iy+0]*g32[iz+0];
s[1229] = + g24[ix+0]*g70[iy+0]*g33[iz+0];
s[1230] = + g25[ix+0]*g68[iy+0]*g34[iz+0];
s[1231] = + g24[ix+0]*g69[iy+0]*g34[iz+0];
s[1232] = + g24[ix+0]*g68[iy+0]*g35[iz+0];
s[1233] = + g27[ix+0]*g64[iy+0]*g36[iz+0];
s[1234] = + g26[ix+0]*g65[iy+0]*g36[iz+0];
s[1235] = + g26[ix+0]*g64[iy+0]*g37[iz+0];
s[1236] = + g25[ix+0]*g66[iy+0]*g36[iz+0];
s[1237] = + g24[ix+0]*g67[iy+0]*g36[iz+0];
s[1238] = + g24[ix+0]*g66[iy+0]*g37[iz+0];
s[1239] = + g25[ix+0]*g64[iy+0]*g38[iz+0];
s[1240] = + g24[ix+0]*g65[iy+0]*g38[iz+0];
s[1241] = + g24[ix+0]*g64[iy+0]*g39[iz+0];
s[1242] = + g23[ix+0]*g72[iy+0]*g32[iz+0];
s[1243] = + g22[ix+0]*g73[iy+0]*g32[iz+0];
s[1244] = + g22[ix+0]*g72[iy+0]*g33[iz+0];
s[1245] = + g21[ix+0]*g74[iy+0]*g32[iz+0];
s[1246] = + g20[ix+0]*g75[iy+0]*g32[iz+0];
s[1247] = + g20[ix+0]*g74[iy+0]*g33[iz+0];
s[1248] = + g21[ix+0]*g72[iy+0]*g34[iz+0];
s[1249] = + g20[ix+0]*g73[iy+0]*g34[iz+0];
s[1250] = + g20[ix+0]*g72[iy+0]*g35[iz+0];
s[1251] = + g19[ix+0]*g76[iy+0]*g32[iz+0];
s[1252] = + g18[ix+0]*g77[iy+0]*g32[iz+0];
s[1253] = + g18[ix+0]*g76[iy+0]*g33[iz+0];
s[1254] = + g17[ix+0]*g78[iy+0]*g32[iz+0];
s[1255] = + g16[ix+0]*g79[iy+0]*g32[iz+0];
s[1256] = + g16[ix+0]*g78[iy+0]*g33[iz+0];
s[1257] = + g17[ix+0]*g76[iy+0]*g34[iz+0];
s[1258] = + g16[ix+0]*g77[iy+0]*g34[iz+0];
s[1259] = + g16[ix+0]*g76[iy+0]*g35[iz+0];
s[1260] = + g19[ix+0]*g72[iy+0]*g36[iz+0];
s[1261] = + g18[ix+0]*g73[iy+0]*g36[iz+0];
s[1262] = + g18[ix+0]*g72[iy+0]*g37[iz+0];
s[1263] = + g17[ix+0]*g74[iy+0]*g36[iz+0];
s[1264] = + g16[ix+0]*g75[iy+0]*g36[iz+0];
s[1265] = + g16[ix+0]*g74[iy+0]*g37[iz+0];
s[1266] = + g17[ix+0]*g72[iy+0]*g38[iz+0];
s[1267] = + g16[ix+0]*g73[iy+0]*g38[iz+0];
s[1268] = + g16[ix+0]*g72[iy+0]*g39[iz+0];
s[1269] = + g23[ix+0]*g64[iy+0]*g40[iz+0];
s[1270] = + g22[ix+0]*g65[iy+0]*g40[iz+0];
s[1271] = + g22[ix+0]*g64[iy+0]*g41[iz+0];
s[1272] = + g21[ix+0]*g66[iy+0]*g40[iz+0];
s[1273] = + g20[ix+0]*g67[iy+0]*g40[iz+0];
s[1274] = + g20[ix+0]*g66[iy+0]*g41[iz+0];
s[1275] = + g21[ix+0]*g64[iy+0]*g42[iz+0];
s[1276] = + g20[ix+0]*g65[iy+0]*g42[iz+0];
s[1277] = + g20[ix+0]*g64[iy+0]*g43[iz+0];
s[1278] = + g19[ix+0]*g68[iy+0]*g40[iz+0];
s[1279] = + g18[ix+0]*g69[iy+0]*g40[iz+0];
s[1280] = + g18[ix+0]*g68[iy+0]*g41[iz+0];
s[1281] = + g17[ix+0]*g70[iy+0]*g40[iz+0];
s[1282] = + g16[ix+0]*g71[iy+0]*g40[iz+0];
s[1283] = + g16[ix+0]*g70[iy+0]*g41[iz+0];
s[1284] = + g17[ix+0]*g68[iy+0]*g42[iz+0];
s[1285] = + g16[ix+0]*g69[iy+0]*g42[iz+0];
s[1286] = + g16[ix+0]*g68[iy+0]*g43[iz+0];
s[1287] = + g19[ix+0]*g64[iy+0]*g44[iz+0];
s[1288] = + g18[ix+0]*g65[iy+0]*g44[iz+0];
s[1289] = + g18[ix+0]*g64[iy+0]*g45[iz+0];
s[1290] = + g17[ix+0]*g66[iy+0]*g44[iz+0];
s[1291] = + g16[ix+0]*g67[iy+0]*g44[iz+0];
s[1292] = + g16[ix+0]*g66[iy+0]*g45[iz+0];
s[1293] = + g17[ix+0]*g64[iy+0]*g46[iz+0];
s[1294] = + g16[ix+0]*g65[iy+0]*g46[iz+0];
s[1295] = + g16[ix+0]*g64[iy+0]*g47[iz+0];
s[1296] = + g15[ix+0]*g80[iy+0]*g32[iz+0];
s[1297] = + g14[ix+0]*g81[iy+0]*g32[iz+0];
s[1298] = + g14[ix+0]*g80[iy+0]*g33[iz+0];
s[1299] = + g13[ix+0]*g82[iy+0]*g32[iz+0];
s[1300] = + g12[ix+0]*g83[iy+0]*g32[iz+0];
s[1301] = + g12[ix+0]*g82[iy+0]*g33[iz+0];
s[1302] = + g13[ix+0]*g80[iy+0]*g34[iz+0];
s[1303] = + g12[ix+0]*g81[iy+0]*g34[iz+0];
s[1304] = + g12[ix+0]*g80[iy+0]*g35[iz+0];
s[1305] = + g11[ix+0]*g84[iy+0]*g32[iz+0];
s[1306] = + g10[ix+0]*g85[iy+0]*g32[iz+0];
s[1307] = + g10[ix+0]*g84[iy+0]*g33[iz+0];
s[1308] = + g9[ix+0]*g86[iy+0]*g32[iz+0];
s[1309] = + g8[ix+0]*g87[iy+0]*g32[iz+0];
s[1310] = + g8[ix+0]*g86[iy+0]*g33[iz+0];
s[1311] = + g9[ix+0]*g84[iy+0]*g34[iz+0];
s[1312] = + g8[ix+0]*g85[iy+0]*g34[iz+0];
s[1313] = + g8[ix+0]*g84[iy+0]*g35[iz+0];
s[1314] = + g11[ix+0]*g80[iy+0]*g36[iz+0];
s[1315] = + g10[ix+0]*g81[iy+0]*g36[iz+0];
s[1316] = + g10[ix+0]*g80[iy+0]*g37[iz+0];
s[1317] = + g9[ix+0]*g82[iy+0]*g36[iz+0];
s[1318] = + g8[ix+0]*g83[iy+0]*g36[iz+0];
s[1319] = + g8[ix+0]*g82[iy+0]*g37[iz+0];
s[1320] = + g9[ix+0]*g80[iy+0]*g38[iz+0];
s[1321] = + g8[ix+0]*g81[iy+0]*g38[iz+0];
s[1322] = + g8[ix+0]*g80[iy+0]*g39[iz+0];
s[1323] = + g7[ix+0]*g88[iy+0]*g32[iz+0];
s[1324] = + g6[ix+0]*g89[iy+0]*g32[iz+0];
s[1325] = + g6[ix+0]*g88[iy+0]*g33[iz+0];
s[1326] = + g5[ix+0]*g90[iy+0]*g32[iz+0];
s[1327] = + g4[ix+0]*g91[iy+0]*g32[iz+0];
s[1328] = + g4[ix+0]*g90[iy+0]*g33[iz+0];
s[1329] = + g5[ix+0]*g88[iy+0]*g34[iz+0];
s[1330] = + g4[ix+0]*g89[iy+0]*g34[iz+0];
s[1331] = + g4[ix+0]*g88[iy+0]*g35[iz+0];
s[1332] = + g3[ix+0]*g92[iy+0]*g32[iz+0];
s[1333] = + g2[ix+0]*g93[iy+0]*g32[iz+0];
s[1334] = + g2[ix+0]*g92[iy+0]*g33[iz+0];
s[1335] = + g1[ix+0]*g94[iy+0]*g32[iz+0];
s[1336] = + g0[ix+0]*g95[iy+0]*g32[iz+0];
s[1337] = + g0[ix+0]*g94[iy+0]*g33[iz+0];
s[1338] = + g1[ix+0]*g92[iy+0]*g34[iz+0];
s[1339] = + g0[ix+0]*g93[iy+0]*g34[iz+0];
s[1340] = + g0[ix+0]*g92[iy+0]*g35[iz+0];
s[1341] = + g3[ix+0]*g88[iy+0]*g36[iz+0];
s[1342] = + g2[ix+0]*g89[iy+0]*g36[iz+0];
s[1343] = + g2[ix+0]*g88[iy+0]*g37[iz+0];
s[1344] = + g1[ix+0]*g90[iy+0]*g36[iz+0];
s[1345] = + g0[ix+0]*g91[iy+0]*g36[iz+0];
s[1346] = + g0[ix+0]*g90[iy+0]*g37[iz+0];
s[1347] = + g1[ix+0]*g88[iy+0]*g38[iz+0];
s[1348] = + g0[ix+0]*g89[iy+0]*g38[iz+0];
s[1349] = + g0[ix+0]*g88[iy+0]*g39[iz+0];
s[1350] = + g7[ix+0]*g80[iy+0]*g40[iz+0];
s[1351] = + g6[ix+0]*g81[iy+0]*g40[iz+0];
s[1352] = + g6[ix+0]*g80[iy+0]*g41[iz+0];
s[1353] = + g5[ix+0]*g82[iy+0]*g40[iz+0];
s[1354] = + g4[ix+0]*g83[iy+0]*g40[iz+0];
s[1355] = + g4[ix+0]*g82[iy+0]*g41[iz+0];
s[1356] = + g5[ix+0]*g80[iy+0]*g42[iz+0];
s[1357] = + g4[ix+0]*g81[iy+0]*g42[iz+0];
s[1358] = + g4[ix+0]*g80[iy+0]*g43[iz+0];
s[1359] = + g3[ix+0]*g84[iy+0]*g40[iz+0];
s[1360] = + g2[ix+0]*g85[iy+0]*g40[iz+0];
s[1361] = + g2[ix+0]*g84[iy+0]*g41[iz+0];
s[1362] = + g1[ix+0]*g86[iy+0]*g40[iz+0];
s[1363] = + g0[ix+0]*g87[iy+0]*g40[iz+0];
s[1364] = + g0[ix+0]*g86[iy+0]*g41[iz+0];
s[1365] = + g1[ix+0]*g84[iy+0]*g42[iz+0];
s[1366] = + g0[ix+0]*g85[iy+0]*g42[iz+0];
s[1367] = + g0[ix+0]*g84[iy+0]*g43[iz+0];
s[1368] = + g3[ix+0]*g80[iy+0]*g44[iz+0];
s[1369] = + g2[ix+0]*g81[iy+0]*g44[iz+0];
s[1370] = + g2[ix+0]*g80[iy+0]*g45[iz+0];
s[1371] = + g1[ix+0]*g82[iy+0]*g44[iz+0];
s[1372] = + g0[ix+0]*g83[iy+0]*g44[iz+0];
s[1373] = + g0[ix+0]*g82[iy+0]*g45[iz+0];
s[1374] = + g1[ix+0]*g80[iy+0]*g46[iz+0];
s[1375] = + g0[ix+0]*g81[iy+0]*g46[iz+0];
s[1376] = + g0[ix+0]*g80[iy+0]*g47[iz+0];
s[1377] = + g15[ix+0]*g64[iy+0]*g48[iz+0];
s[1378] = + g14[ix+0]*g65[iy+0]*g48[iz+0];
s[1379] = + g14[ix+0]*g64[iy+0]*g49[iz+0];
s[1380] = + g13[ix+0]*g66[iy+0]*g48[iz+0];
s[1381] = + g12[ix+0]*g67[iy+0]*g48[iz+0];
s[1382] = + g12[ix+0]*g66[iy+0]*g49[iz+0];
s[1383] = + g13[ix+0]*g64[iy+0]*g50[iz+0];
s[1384] = + g12[ix+0]*g65[iy+0]*g50[iz+0];
s[1385] = + g12[ix+0]*g64[iy+0]*g51[iz+0];
s[1386] = + g11[ix+0]*g68[iy+0]*g48[iz+0];
s[1387] = + g10[ix+0]*g69[iy+0]*g48[iz+0];
s[1388] = + g10[ix+0]*g68[iy+0]*g49[iz+0];
s[1389] = + g9[ix+0]*g70[iy+0]*g48[iz+0];
s[1390] = + g8[ix+0]*g71[iy+0]*g48[iz+0];
s[1391] = + g8[ix+0]*g70[iy+0]*g49[iz+0];
s[1392] = + g9[ix+0]*g68[iy+0]*g50[iz+0];
s[1393] = + g8[ix+0]*g69[iy+0]*g50[iz+0];
s[1394] = + g8[ix+0]*g68[iy+0]*g51[iz+0];
s[1395] = + g11[ix+0]*g64[iy+0]*g52[iz+0];
s[1396] = + g10[ix+0]*g65[iy+0]*g52[iz+0];
s[1397] = + g10[ix+0]*g64[iy+0]*g53[iz+0];
s[1398] = + g9[ix+0]*g66[iy+0]*g52[iz+0];
s[1399] = + g8[ix+0]*g67[iy+0]*g52[iz+0];
s[1400] = + g8[ix+0]*g66[iy+0]*g53[iz+0];
s[1401] = + g9[ix+0]*g64[iy+0]*g54[iz+0];
s[1402] = + g8[ix+0]*g65[iy+0]*g54[iz+0];
s[1403] = + g8[ix+0]*g64[iy+0]*g55[iz+0];
s[1404] = + g7[ix+0]*g72[iy+0]*g48[iz+0];
s[1405] = + g6[ix+0]*g73[iy+0]*g48[iz+0];
s[1406] = + g6[ix+0]*g72[iy+0]*g49[iz+0];
s[1407] = + g5[ix+0]*g74[iy+0]*g48[iz+0];
s[1408] = + g4[ix+0]*g75[iy+0]*g48[iz+0];
s[1409] = + g4[ix+0]*g74[iy+0]*g49[iz+0];
s[1410] = + g5[ix+0]*g72[iy+0]*g50[iz+0];
s[1411] = + g4[ix+0]*g73[iy+0]*g50[iz+0];
s[1412] = + g4[ix+0]*g72[iy+0]*g51[iz+0];
s[1413] = + g3[ix+0]*g76[iy+0]*g48[iz+0];
s[1414] = + g2[ix+0]*g77[iy+0]*g48[iz+0];
s[1415] = + g2[ix+0]*g76[iy+0]*g49[iz+0];
s[1416] = + g1[ix+0]*g78[iy+0]*g48[iz+0];
s[1417] = + g0[ix+0]*g79[iy+0]*g48[iz+0];
s[1418] = + g0[ix+0]*g78[iy+0]*g49[iz+0];
s[1419] = + g1[ix+0]*g76[iy+0]*g50[iz+0];
s[1420] = + g0[ix+0]*g77[iy+0]*g50[iz+0];
s[1421] = + g0[ix+0]*g76[iy+0]*g51[iz+0];
s[1422] = + g3[ix+0]*g72[iy+0]*g52[iz+0];
s[1423] = + g2[ix+0]*g73[iy+0]*g52[iz+0];
s[1424] = + g2[ix+0]*g72[iy+0]*g53[iz+0];
s[1425] = + g1[ix+0]*g74[iy+0]*g52[iz+0];
s[1426] = + g0[ix+0]*g75[iy+0]*g52[iz+0];
s[1427] = + g0[ix+0]*g74[iy+0]*g53[iz+0];
s[1428] = + g1[ix+0]*g72[iy+0]*g54[iz+0];
s[1429] = + g0[ix+0]*g73[iy+0]*g54[iz+0];
s[1430] = + g0[ix+0]*g72[iy+0]*g55[iz+0];
s[1431] = + g7[ix+0]*g64[iy+0]*g56[iz+0];
s[1432] = + g6[ix+0]*g65[iy+0]*g56[iz+0];
s[1433] = + g6[ix+0]*g64[iy+0]*g57[iz+0];
s[1434] = + g5[ix+0]*g66[iy+0]*g56[iz+0];
s[1435] = + g4[ix+0]*g67[iy+0]*g56[iz+0];
s[1436] = + g4[ix+0]*g66[iy+0]*g57[iz+0];
s[1437] = + g5[ix+0]*g64[iy+0]*g58[iz+0];
s[1438] = + g4[ix+0]*g65[iy+0]*g58[iz+0];
s[1439] = + g4[ix+0]*g64[iy+0]*g59[iz+0];
s[1440] = + g3[ix+0]*g68[iy+0]*g56[iz+0];
s[1441] = + g2[ix+0]*g69[iy+0]*g56[iz+0];
s[1442] = + g2[ix+0]*g68[iy+0]*g57[iz+0];
s[1443] = + g1[ix+0]*g70[iy+0]*g56[iz+0];
s[1444] = + g0[ix+0]*g71[iy+0]*g56[iz+0];
s[1445] = + g0[ix+0]*g70[iy+0]*g57[iz+0];
s[1446] = + g1[ix+0]*g68[iy+0]*g58[iz+0];
s[1447] = + g0[ix+0]*g69[iy+0]*g58[iz+0];
s[1448] = + g0[ix+0]*g68[iy+0]*g59[iz+0];
s[1449] = + g3[ix+0]*g64[iy+0]*g60[iz+0];
s[1450] = + g2[ix+0]*g65[iy+0]*g60[iz+0];
s[1451] = + g2[ix+0]*g64[iy+0]*g61[iz+0];
s[1452] = + g1[ix+0]*g66[iy+0]*g60[iz+0];
s[1453] = + g0[ix+0]*g67[iy+0]*g60[iz+0];
s[1454] = + g0[ix+0]*g66[iy+0]*g61[iz+0];
s[1455] = + g1[ix+0]*g64[iy+0]*g62[iz+0];
s[1456] = + g0[ix+0]*g65[iy+0]*g62[iz+0];
s[1457] = + g0[ix+0]*g64[iy+0]*g63[iz+0];
s[1458] = + g63[ix+0]*g0[iy+0]*g64[iz+0];
s[1459] = + g62[ix+0]*g1[iy+0]*g64[iz+0];
s[1460] = + g62[ix+0]*g0[iy+0]*g65[iz+0];
s[1461] = + g61[ix+0]*g2[iy+0]*g64[iz+0];
s[1462] = + g60[ix+0]*g3[iy+0]*g64[iz+0];
s[1463] = + g60[ix+0]*g2[iy+0]*g65[iz+0];
s[1464] = + g61[ix+0]*g0[iy+0]*g66[iz+0];
s[1465] = + g60[ix+0]*g1[iy+0]*g66[iz+0];
s[1466] = + g60[ix+0]*g0[iy+0]*g67[iz+0];
s[1467] = + g59[ix+0]*g4[iy+0]*g64[iz+0];
s[1468] = + g58[ix+0]*g5[iy+0]*g64[iz+0];
s[1469] = + g58[ix+0]*g4[iy+0]*g65[iz+0];
s[1470] = + g57[ix+0]*g6[iy+0]*g64[iz+0];
s[1471] = + g56[ix+0]*g7[iy+0]*g64[iz+0];
s[1472] = + g56[ix+0]*g6[iy+0]*g65[iz+0];
s[1473] = + g57[ix+0]*g4[iy+0]*g66[iz+0];
s[1474] = + g56[ix+0]*g5[iy+0]*g66[iz+0];
s[1475] = + g56[ix+0]*g4[iy+0]*g67[iz+0];
s[1476] = + g59[ix+0]*g0[iy+0]*g68[iz+0];
s[1477] = + g58[ix+0]*g1[iy+0]*g68[iz+0];
s[1478] = + g58[ix+0]*g0[iy+0]*g69[iz+0];
s[1479] = + g57[ix+0]*g2[iy+0]*g68[iz+0];
s[1480] = + g56[ix+0]*g3[iy+0]*g68[iz+0];
s[1481] = + g56[ix+0]*g2[iy+0]*g69[iz+0];
s[1482] = + g57[ix+0]*g0[iy+0]*g70[iz+0];
s[1483] = + g56[ix+0]*g1[iy+0]*g70[iz+0];
s[1484] = + g56[ix+0]*g0[iy+0]*g71[iz+0];
s[1485] = + g55[ix+0]*g8[iy+0]*g64[iz+0];
s[1486] = + g54[ix+0]*g9[iy+0]*g64[iz+0];
s[1487] = + g54[ix+0]*g8[iy+0]*g65[iz+0];
s[1488] = + g53[ix+0]*g10[iy+0]*g64[iz+0];
s[1489] = + g52[ix+0]*g11[iy+0]*g64[iz+0];
s[1490] = + g52[ix+0]*g10[iy+0]*g65[iz+0];
s[1491] = + g53[ix+0]*g8[iy+0]*g66[iz+0];
s[1492] = + g52[ix+0]*g9[iy+0]*g66[iz+0];
s[1493] = + g52[ix+0]*g8[iy+0]*g67[iz+0];
s[1494] = + g51[ix+0]*g12[iy+0]*g64[iz+0];
s[1495] = + g50[ix+0]*g13[iy+0]*g64[iz+0];
s[1496] = + g50[ix+0]*g12[iy+0]*g65[iz+0];
s[1497] = + g49[ix+0]*g14[iy+0]*g64[iz+0];
s[1498] = + g48[ix+0]*g15[iy+0]*g64[iz+0];
s[1499] = + g48[ix+0]*g14[iy+0]*g65[iz+0];
s[1500] = + g49[ix+0]*g12[iy+0]*g66[iz+0];
s[1501] = + g48[ix+0]*g13[iy+0]*g66[iz+0];
s[1502] = + g48[ix+0]*g12[iy+0]*g67[iz+0];
s[1503] = + g51[ix+0]*g8[iy+0]*g68[iz+0];
s[1504] = + g50[ix+0]*g9[iy+0]*g68[iz+0];
s[1505] = + g50[ix+0]*g8[iy+0]*g69[iz+0];
s[1506] = + g49[ix+0]*g10[iy+0]*g68[iz+0];
s[1507] = + g48[ix+0]*g11[iy+0]*g68[iz+0];
s[1508] = + g48[ix+0]*g10[iy+0]*g69[iz+0];
s[1509] = + g49[ix+0]*g8[iy+0]*g70[iz+0];
s[1510] = + g48[ix+0]*g9[iy+0]*g70[iz+0];
s[1511] = + g48[ix+0]*g8[iy+0]*g71[iz+0];
s[1512] = + g55[ix+0]*g0[iy+0]*g72[iz+0];
s[1513] = + g54[ix+0]*g1[iy+0]*g72[iz+0];
s[1514] = + g54[ix+0]*g0[iy+0]*g73[iz+0];
s[1515] = + g53[ix+0]*g2[iy+0]*g72[iz+0];
s[1516] = + g52[ix+0]*g3[iy+0]*g72[iz+0];
s[1517] = + g52[ix+0]*g2[iy+0]*g73[iz+0];
s[1518] = + g53[ix+0]*g0[iy+0]*g74[iz+0];
s[1519] = + g52[ix+0]*g1[iy+0]*g74[iz+0];
s[1520] = + g52[ix+0]*g0[iy+0]*g75[iz+0];
s[1521] = + g51[ix+0]*g4[iy+0]*g72[iz+0];
s[1522] = + g50[ix+0]*g5[iy+0]*g72[iz+0];
s[1523] = + g50[ix+0]*g4[iy+0]*g73[iz+0];
s[1524] = + g49[ix+0]*g6[iy+0]*g72[iz+0];
s[1525] = + g48[ix+0]*g7[iy+0]*g72[iz+0];
s[1526] = + g48[ix+0]*g6[iy+0]*g73[iz+0];
s[1527] = + g49[ix+0]*g4[iy+0]*g74[iz+0];
s[1528] = + g48[ix+0]*g5[iy+0]*g74[iz+0];
s[1529] = + g48[ix+0]*g4[iy+0]*g75[iz+0];
s[1530] = + g51[ix+0]*g0[iy+0]*g76[iz+0];
s[1531] = + g50[ix+0]*g1[iy+0]*g76[iz+0];
s[1532] = + g50[ix+0]*g0[iy+0]*g77[iz+0];
s[1533] = + g49[ix+0]*g2[iy+0]*g76[iz+0];
s[1534] = + g48[ix+0]*g3[iy+0]*g76[iz+0];
s[1535] = + g48[ix+0]*g2[iy+0]*g77[iz+0];
s[1536] = + g49[ix+0]*g0[iy+0]*g78[iz+0];
s[1537] = + g48[ix+0]*g1[iy+0]*g78[iz+0];
s[1538] = + g48[ix+0]*g0[iy+0]*g79[iz+0];
s[1539] = + g47[ix+0]*g16[iy+0]*g64[iz+0];
s[1540] = + g46[ix+0]*g17[iy+0]*g64[iz+0];
s[1541] = + g46[ix+0]*g16[iy+0]*g65[iz+0];
s[1542] = + g45[ix+0]*g18[iy+0]*g64[iz+0];
s[1543] = + g44[ix+0]*g19[iy+0]*g64[iz+0];
s[1544] = + g44[ix+0]*g18[iy+0]*g65[iz+0];
s[1545] = + g45[ix+0]*g16[iy+0]*g66[iz+0];
s[1546] = + g44[ix+0]*g17[iy+0]*g66[iz+0];
s[1547] = + g44[ix+0]*g16[iy+0]*g67[iz+0];
s[1548] = + g43[ix+0]*g20[iy+0]*g64[iz+0];
s[1549] = + g42[ix+0]*g21[iy+0]*g64[iz+0];
s[1550] = + g42[ix+0]*g20[iy+0]*g65[iz+0];
s[1551] = + g41[ix+0]*g22[iy+0]*g64[iz+0];
s[1552] = + g40[ix+0]*g23[iy+0]*g64[iz+0];
s[1553] = + g40[ix+0]*g22[iy+0]*g65[iz+0];
s[1554] = + g41[ix+0]*g20[iy+0]*g66[iz+0];
s[1555] = + g40[ix+0]*g21[iy+0]*g66[iz+0];
s[1556] = + g40[ix+0]*g20[iy+0]*g67[iz+0];
s[1557] = + g43[ix+0]*g16[iy+0]*g68[iz+0];
s[1558] = + g42[ix+0]*g17[iy+0]*g68[iz+0];
s[1559] = + g42[ix+0]*g16[iy+0]*g69[iz+0];
s[1560] = + g41[ix+0]*g18[iy+0]*g68[iz+0];
s[1561] = + g40[ix+0]*g19[iy+0]*g68[iz+0];
s[1562] = + g40[ix+0]*g18[iy+0]*g69[iz+0];
s[1563] = + g41[ix+0]*g16[iy+0]*g70[iz+0];
s[1564] = + g40[ix+0]*g17[iy+0]*g70[iz+0];
s[1565] = + g40[ix+0]*g16[iy+0]*g71[iz+0];
s[1566] = + g39[ix+0]*g24[iy+0]*g64[iz+0];
s[1567] = + g38[ix+0]*g25[iy+0]*g64[iz+0];
s[1568] = + g38[ix+0]*g24[iy+0]*g65[iz+0];
s[1569] = + g37[ix+0]*g26[iy+0]*g64[iz+0];
s[1570] = + g36[ix+0]*g27[iy+0]*g64[iz+0];
s[1571] = + g36[ix+0]*g26[iy+0]*g65[iz+0];
s[1572] = + g37[ix+0]*g24[iy+0]*g66[iz+0];
s[1573] = + g36[ix+0]*g25[iy+0]*g66[iz+0];
s[1574] = + g36[ix+0]*g24[iy+0]*g67[iz+0];
s[1575] = + g35[ix+0]*g28[iy+0]*g64[iz+0];
s[1576] = + g34[ix+0]*g29[iy+0]*g64[iz+0];
s[1577] = + g34[ix+0]*g28[iy+0]*g65[iz+0];
s[1578] = + g33[ix+0]*g30[iy+0]*g64[iz+0];
s[1579] = + g32[ix+0]*g31[iy+0]*g64[iz+0];
s[1580] = + g32[ix+0]*g30[iy+0]*g65[iz+0];
s[1581] = + g33[ix+0]*g28[iy+0]*g66[iz+0];
s[1582] = + g32[ix+0]*g29[iy+0]*g66[iz+0];
s[1583] = + g32[ix+0]*g28[iy+0]*g67[iz+0];
s[1584] = + g35[ix+0]*g24[iy+0]*g68[iz+0];
s[1585] = + g34[ix+0]*g25[iy+0]*g68[iz+0];
s[1586] = + g34[ix+0]*g24[iy+0]*g69[iz+0];
s[1587] = + g33[ix+0]*g26[iy+0]*g68[iz+0];
s[1588] = + g32[ix+0]*g27[iy+0]*g68[iz+0];
s[1589] = + g32[ix+0]*g26[iy+0]*g69[iz+0];
s[1590] = + g33[ix+0]*g24[iy+0]*g70[iz+0];
s[1591] = + g32[ix+0]*g25[iy+0]*g70[iz+0];
s[1592] = + g32[ix+0]*g24[iy+0]*g71[iz+0];
s[1593] = + g39[ix+0]*g16[iy+0]*g72[iz+0];
s[1594] = + g38[ix+0]*g17[iy+0]*g72[iz+0];
s[1595] = + g38[ix+0]*g16[iy+0]*g73[iz+0];
s[1596] = + g37[ix+0]*g18[iy+0]*g72[iz+0];
s[1597] = + g36[ix+0]*g19[iy+0]*g72[iz+0];
s[1598] = + g36[ix+0]*g18[iy+0]*g73[iz+0];
s[1599] = + g37[ix+0]*g16[iy+0]*g74[iz+0];
s[1600] = + g36[ix+0]*g17[iy+0]*g74[iz+0];
s[1601] = + g36[ix+0]*g16[iy+0]*g75[iz+0];
s[1602] = + g35[ix+0]*g20[iy+0]*g72[iz+0];
s[1603] = + g34[ix+0]*g21[iy+0]*g72[iz+0];
s[1604] = + g34[ix+0]*g20[iy+0]*g73[iz+0];
s[1605] = + g33[ix+0]*g22[iy+0]*g72[iz+0];
s[1606] = + g32[ix+0]*g23[iy+0]*g72[iz+0];
s[1607] = + g32[ix+0]*g22[iy+0]*g73[iz+0];
s[1608] = + g33[ix+0]*g20[iy+0]*g74[iz+0];
s[1609] = + g32[ix+0]*g21[iy+0]*g74[iz+0];
s[1610] = + g32[ix+0]*g20[iy+0]*g75[iz+0];
s[1611] = + g35[ix+0]*g16[iy+0]*g76[iz+0];
s[1612] = + g34[ix+0]*g17[iy+0]*g76[iz+0];
s[1613] = + g34[ix+0]*g16[iy+0]*g77[iz+0];
s[1614] = + g33[ix+0]*g18[iy+0]*g76[iz+0];
s[1615] = + g32[ix+0]*g19[iy+0]*g76[iz+0];
s[1616] = + g32[ix+0]*g18[iy+0]*g77[iz+0];
s[1617] = + g33[ix+0]*g16[iy+0]*g78[iz+0];
s[1618] = + g32[ix+0]*g17[iy+0]*g78[iz+0];
s[1619] = + g32[ix+0]*g16[iy+0]*g79[iz+0];
s[1620] = + g47[ix+0]*g0[iy+0]*g80[iz+0];
s[1621] = + g46[ix+0]*g1[iy+0]*g80[iz+0];
s[1622] = + g46[ix+0]*g0[iy+0]*g81[iz+0];
s[1623] = + g45[ix+0]*g2[iy+0]*g80[iz+0];
s[1624] = + g44[ix+0]*g3[iy+0]*g80[iz+0];
s[1625] = + g44[ix+0]*g2[iy+0]*g81[iz+0];
s[1626] = + g45[ix+0]*g0[iy+0]*g82[iz+0];
s[1627] = + g44[ix+0]*g1[iy+0]*g82[iz+0];
s[1628] = + g44[ix+0]*g0[iy+0]*g83[iz+0];
s[1629] = + g43[ix+0]*g4[iy+0]*g80[iz+0];
s[1630] = + g42[ix+0]*g5[iy+0]*g80[iz+0];
s[1631] = + g42[ix+0]*g4[iy+0]*g81[iz+0];
s[1632] = + g41[ix+0]*g6[iy+0]*g80[iz+0];
s[1633] = + g40[ix+0]*g7[iy+0]*g80[iz+0];
s[1634] = + g40[ix+0]*g6[iy+0]*g81[iz+0];
s[1635] = + g41[ix+0]*g4[iy+0]*g82[iz+0];
s[1636] = + g40[ix+0]*g5[iy+0]*g82[iz+0];
s[1637] = + g40[ix+0]*g4[iy+0]*g83[iz+0];
s[1638] = + g43[ix+0]*g0[iy+0]*g84[iz+0];
s[1639] = + g42[ix+0]*g1[iy+0]*g84[iz+0];
s[1640] = + g42[ix+0]*g0[iy+0]*g85[iz+0];
s[1641] = + g41[ix+0]*g2[iy+0]*g84[iz+0];
s[1642] = + g40[ix+0]*g3[iy+0]*g84[iz+0];
s[1643] = + g40[ix+0]*g2[iy+0]*g85[iz+0];
s[1644] = + g41[ix+0]*g0[iy+0]*g86[iz+0];
s[1645] = + g40[ix+0]*g1[iy+0]*g86[iz+0];
s[1646] = + g40[ix+0]*g0[iy+0]*g87[iz+0];
s[1647] = + g39[ix+0]*g8[iy+0]*g80[iz+0];
s[1648] = + g38[ix+0]*g9[iy+0]*g80[iz+0];
s[1649] = + g38[ix+0]*g8[iy+0]*g81[iz+0];
s[1650] = + g37[ix+0]*g10[iy+0]*g80[iz+0];
s[1651] = + g36[ix+0]*g11[iy+0]*g80[iz+0];
s[1652] = + g36[ix+0]*g10[iy+0]*g81[iz+0];
s[1653] = + g37[ix+0]*g8[iy+0]*g82[iz+0];
s[1654] = + g36[ix+0]*g9[iy+0]*g82[iz+0];
s[1655] = + g36[ix+0]*g8[iy+0]*g83[iz+0];
s[1656] = + g35[ix+0]*g12[iy+0]*g80[iz+0];
s[1657] = + g34[ix+0]*g13[iy+0]*g80[iz+0];
s[1658] = + g34[ix+0]*g12[iy+0]*g81[iz+0];
s[1659] = + g33[ix+0]*g14[iy+0]*g80[iz+0];
s[1660] = + g32[ix+0]*g15[iy+0]*g80[iz+0];
s[1661] = + g32[ix+0]*g14[iy+0]*g81[iz+0];
s[1662] = + g33[ix+0]*g12[iy+0]*g82[iz+0];
s[1663] = + g32[ix+0]*g13[iy+0]*g82[iz+0];
s[1664] = + g32[ix+0]*g12[iy+0]*g83[iz+0];
s[1665] = + g35[ix+0]*g8[iy+0]*g84[iz+0];
s[1666] = + g34[ix+0]*g9[iy+0]*g84[iz+0];
s[1667] = + g34[ix+0]*g8[iy+0]*g85[iz+0];
s[1668] = + g33[ix+0]*g10[iy+0]*g84[iz+0];
s[1669] = + g32[ix+0]*g11[iy+0]*g84[iz+0];
s[1670] = + g32[ix+0]*g10[iy+0]*g85[iz+0];
s[1671] = + g33[ix+0]*g8[iy+0]*g86[iz+0];
s[1672] = + g32[ix+0]*g9[iy+0]*g86[iz+0];
s[1673] = + g32[ix+0]*g8[iy+0]*g87[iz+0];
s[1674] = + g39[ix+0]*g0[iy+0]*g88[iz+0];
s[1675] = + g38[ix+0]*g1[iy+0]*g88[iz+0];
s[1676] = + g38[ix+0]*g0[iy+0]*g89[iz+0];
s[1677] = + g37[ix+0]*g2[iy+0]*g88[iz+0];
s[1678] = + g36[ix+0]*g3[iy+0]*g88[iz+0];
s[1679] = + g36[ix+0]*g2[iy+0]*g89[iz+0];
s[1680] = + g37[ix+0]*g0[iy+0]*g90[iz+0];
s[1681] = + g36[ix+0]*g1[iy+0]*g90[iz+0];
s[1682] = + g36[ix+0]*g0[iy+0]*g91[iz+0];
s[1683] = + g35[ix+0]*g4[iy+0]*g88[iz+0];
s[1684] = + g34[ix+0]*g5[iy+0]*g88[iz+0];
s[1685] = + g34[ix+0]*g4[iy+0]*g89[iz+0];
s[1686] = + g33[ix+0]*g6[iy+0]*g88[iz+0];
s[1687] = + g32[ix+0]*g7[iy+0]*g88[iz+0];
s[1688] = + g32[ix+0]*g6[iy+0]*g89[iz+0];
s[1689] = + g33[ix+0]*g4[iy+0]*g90[iz+0];
s[1690] = + g32[ix+0]*g5[iy+0]*g90[iz+0];
s[1691] = + g32[ix+0]*g4[iy+0]*g91[iz+0];
s[1692] = + g35[ix+0]*g0[iy+0]*g92[iz+0];
s[1693] = + g34[ix+0]*g1[iy+0]*g92[iz+0];
s[1694] = + g34[ix+0]*g0[iy+0]*g93[iz+0];
s[1695] = + g33[ix+0]*g2[iy+0]*g92[iz+0];
s[1696] = + g32[ix+0]*g3[iy+0]*g92[iz+0];
s[1697] = + g32[ix+0]*g2[iy+0]*g93[iz+0];
s[1698] = + g33[ix+0]*g0[iy+0]*g94[iz+0];
s[1699] = + g32[ix+0]*g1[iy+0]*g94[iz+0];
s[1700] = + g32[ix+0]*g0[iy+0]*g95[iz+0];
s[1701] = + g31[ix+0]*g32[iy+0]*g64[iz+0];
s[1702] = + g30[ix+0]*g33[iy+0]*g64[iz+0];
s[1703] = + g30[ix+0]*g32[iy+0]*g65[iz+0];
s[1704] = + g29[ix+0]*g34[iy+0]*g64[iz+0];
s[1705] = + g28[ix+0]*g35[iy+0]*g64[iz+0];
s[1706] = + g28[ix+0]*g34[iy+0]*g65[iz+0];
s[1707] = + g29[ix+0]*g32[iy+0]*g66[iz+0];
s[1708] = + g28[ix+0]*g33[iy+0]*g66[iz+0];
s[1709] = + g28[ix+0]*g32[iy+0]*g67[iz+0];
s[1710] = + g27[ix+0]*g36[iy+0]*g64[iz+0];
s[1711] = + g26[ix+0]*g37[iy+0]*g64[iz+0];
s[1712] = + g26[ix+0]*g36[iy+0]*g65[iz+0];
s[1713] = + g25[ix+0]*g38[iy+0]*g64[iz+0];
s[1714] = + g24[ix+0]*g39[iy+0]*g64[iz+0];
s[1715] = + g24[ix+0]*g38[iy+0]*g65[iz+0];
s[1716] = + g25[ix+0]*g36[iy+0]*g66[iz+0];
s[1717] = + g24[ix+0]*g37[iy+0]*g66[iz+0];
s[1718] = + g24[ix+0]*g36[iy+0]*g67[iz+0];
s[1719] = + g27[ix+0]*g32[iy+0]*g68[iz+0];
s[1720] = + g26[ix+0]*g33[iy+0]*g68[iz+0];
s[1721] = + g26[ix+0]*g32[iy+0]*g69[iz+0];
s[1722] = + g25[ix+0]*g34[iy+0]*g68[iz+0];
s[1723] = + g24[ix+0]*g35[iy+0]*g68[iz+0];
s[1724] = + g24[ix+0]*g34[iy+0]*g69[iz+0];
s[1725] = + g25[ix+0]*g32[iy+0]*g70[iz+0];
s[1726] = + g24[ix+0]*g33[iy+0]*g70[iz+0];
s[1727] = + g24[ix+0]*g32[iy+0]*g71[iz+0];
s[1728] = + g23[ix+0]*g40[iy+0]*g64[iz+0];
s[1729] = + g22[ix+0]*g41[iy+0]*g64[iz+0];
s[1730] = + g22[ix+0]*g40[iy+0]*g65[iz+0];
s[1731] = + g21[ix+0]*g42[iy+0]*g64[iz+0];
s[1732] = + g20[ix+0]*g43[iy+0]*g64[iz+0];
s[1733] = + g20[ix+0]*g42[iy+0]*g65[iz+0];
s[1734] = + g21[ix+0]*g40[iy+0]*g66[iz+0];
s[1735] = + g20[ix+0]*g41[iy+0]*g66[iz+0];
s[1736] = + g20[ix+0]*g40[iy+0]*g67[iz+0];
s[1737] = + g19[ix+0]*g44[iy+0]*g64[iz+0];
s[1738] = + g18[ix+0]*g45[iy+0]*g64[iz+0];
s[1739] = + g18[ix+0]*g44[iy+0]*g65[iz+0];
s[1740] = + g17[ix+0]*g46[iy+0]*g64[iz+0];
s[1741] = + g16[ix+0]*g47[iy+0]*g64[iz+0];
s[1742] = + g16[ix+0]*g46[iy+0]*g65[iz+0];
s[1743] = + g17[ix+0]*g44[iy+0]*g66[iz+0];
s[1744] = + g16[ix+0]*g45[iy+0]*g66[iz+0];
s[1745] = + g16[ix+0]*g44[iy+0]*g67[iz+0];
s[1746] = + g19[ix+0]*g40[iy+0]*g68[iz+0];
s[1747] = + g18[ix+0]*g41[iy+0]*g68[iz+0];
s[1748] = + g18[ix+0]*g40[iy+0]*g69[iz+0];
s[1749] = + g17[ix+0]*g42[iy+0]*g68[iz+0];
s[1750] = + g16[ix+0]*g43[iy+0]*g68[iz+0];
s[1751] = + g16[ix+0]*g42[iy+0]*g69[iz+0];
s[1752] = + g17[ix+0]*g40[iy+0]*g70[iz+0];
s[1753] = + g16[ix+0]*g41[iy+0]*g70[iz+0];
s[1754] = + g16[ix+0]*g40[iy+0]*g71[iz+0];
s[1755] = + g23[ix+0]*g32[iy+0]*g72[iz+0];
s[1756] = + g22[ix+0]*g33[iy+0]*g72[iz+0];
s[1757] = + g22[ix+0]*g32[iy+0]*g73[iz+0];
s[1758] = + g21[ix+0]*g34[iy+0]*g72[iz+0];
s[1759] = + g20[ix+0]*g35[iy+0]*g72[iz+0];
s[1760] = + g20[ix+0]*g34[iy+0]*g73[iz+0];
s[1761] = + g21[ix+0]*g32[iy+0]*g74[iz+0];
s[1762] = + g20[ix+0]*g33[iy+0]*g74[iz+0];
s[1763] = + g20[ix+0]*g32[iy+0]*g75[iz+0];
s[1764] = + g19[ix+0]*g36[iy+0]*g72[iz+0];
s[1765] = + g18[ix+0]*g37[iy+0]*g72[iz+0];
s[1766] = + g18[ix+0]*g36[iy+0]*g73[iz+0];
s[1767] = + g17[ix+0]*g38[iy+0]*g72[iz+0];
s[1768] = + g16[ix+0]*g39[iy+0]*g72[iz+0];
s[1769] = + g16[ix+0]*g38[iy+0]*g73[iz+0];
s[1770] = + g17[ix+0]*g36[iy+0]*g74[iz+0];
s[1771] = + g16[ix+0]*g37[iy+0]*g74[iz+0];
s[1772] = + g16[ix+0]*g36[iy+0]*g75[iz+0];
s[1773] = + g19[ix+0]*g32[iy+0]*g76[iz+0];
s[1774] = + g18[ix+0]*g33[iy+0]*g76[iz+0];
s[1775] = + g18[ix+0]*g32[iy+0]*g77[iz+0];
s[1776] = + g17[ix+0]*g34[iy+0]*g76[iz+0];
s[1777] = + g16[ix+0]*g35[iy+0]*g76[iz+0];
s[1778] = + g16[ix+0]*g34[iy+0]*g77[iz+0];
s[1779] = + g17[ix+0]*g32[iy+0]*g78[iz+0];
s[1780] = + g16[ix+0]*g33[iy+0]*g78[iz+0];
s[1781] = + g16[ix+0]*g32[iy+0]*g79[iz+0];
s[1782] = + g15[ix+0]*g48[iy+0]*g64[iz+0];
s[1783] = + g14[ix+0]*g49[iy+0]*g64[iz+0];
s[1784] = + g14[ix+0]*g48[iy+0]*g65[iz+0];
s[1785] = + g13[ix+0]*g50[iy+0]*g64[iz+0];
s[1786] = + g12[ix+0]*g51[iy+0]*g64[iz+0];
s[1787] = + g12[ix+0]*g50[iy+0]*g65[iz+0];
s[1788] = + g13[ix+0]*g48[iy+0]*g66[iz+0];
s[1789] = + g12[ix+0]*g49[iy+0]*g66[iz+0];
s[1790] = + g12[ix+0]*g48[iy+0]*g67[iz+0];
s[1791] = + g11[ix+0]*g52[iy+0]*g64[iz+0];
s[1792] = + g10[ix+0]*g53[iy+0]*g64[iz+0];
s[1793] = + g10[ix+0]*g52[iy+0]*g65[iz+0];
s[1794] = + g9[ix+0]*g54[iy+0]*g64[iz+0];
s[1795] = + g8[ix+0]*g55[iy+0]*g64[iz+0];
s[1796] = + g8[ix+0]*g54[iy+0]*g65[iz+0];
s[1797] = + g9[ix+0]*g52[iy+0]*g66[iz+0];
s[1798] = + g8[ix+0]*g53[iy+0]*g66[iz+0];
s[1799] = + g8[ix+0]*g52[iy+0]*g67[iz+0];
s[1800] = + g11[ix+0]*g48[iy+0]*g68[iz+0];
s[1801] = + g10[ix+0]*g49[iy+0]*g68[iz+0];
s[1802] = + g10[ix+0]*g48[iy+0]*g69[iz+0];
s[1803] = + g9[ix+0]*g50[iy+0]*g68[iz+0];
s[1804] = + g8[ix+0]*g51[iy+0]*g68[iz+0];
s[1805] = + g8[ix+0]*g50[iy+0]*g69[iz+0];
s[1806] = + g9[ix+0]*g48[iy+0]*g70[iz+0];
s[1807] = + g8[ix+0]*g49[iy+0]*g70[iz+0];
s[1808] = + g8[ix+0]*g48[iy+0]*g71[iz+0];
s[1809] = + g7[ix+0]*g56[iy+0]*g64[iz+0];
s[1810] = + g6[ix+0]*g57[iy+0]*g64[iz+0];
s[1811] = + g6[ix+0]*g56[iy+0]*g65[iz+0];
s[1812] = + g5[ix+0]*g58[iy+0]*g64[iz+0];
s[1813] = + g4[ix+0]*g59[iy+0]*g64[iz+0];
s[1814] = + g4[ix+0]*g58[iy+0]*g65[iz+0];
s[1815] = + g5[ix+0]*g56[iy+0]*g66[iz+0];
s[1816] = + g4[ix+0]*g57[iy+0]*g66[iz+0];
s[1817] = + g4[ix+0]*g56[iy+0]*g67[iz+0];
s[1818] = + g3[ix+0]*g60[iy+0]*g64[iz+0];
s[1819] = + g2[ix+0]*g61[iy+0]*g64[iz+0];
s[1820] = + g2[ix+0]*g60[iy+0]*g65[iz+0];
s[1821] = + g1[ix+0]*g62[iy+0]*g64[iz+0];
s[1822] = + g0[ix+0]*g63[iy+0]*g64[iz+0];
s[1823] = + g0[ix+0]*g62[iy+0]*g65[iz+0];
s[1824] = + g1[ix+0]*g60[iy+0]*g66[iz+0];
s[1825] = + g0[ix+0]*g61[iy+0]*g66[iz+0];
s[1826] = + g0[ix+0]*g60[iy+0]*g67[iz+0];
s[1827] = + g3[ix+0]*g56[iy+0]*g68[iz+0];
s[1828] = + g2[ix+0]*g57[iy+0]*g68[iz+0];
s[1829] = + g2[ix+0]*g56[iy+0]*g69[iz+0];
s[1830] = + g1[ix+0]*g58[iy+0]*g68[iz+0];
s[1831] = + g0[ix+0]*g59[iy+0]*g68[iz+0];
s[1832] = + g0[ix+0]*g58[iy+0]*g69[iz+0];
s[1833] = + g1[ix+0]*g56[iy+0]*g70[iz+0];
s[1834] = + g0[ix+0]*g57[iy+0]*g70[iz+0];
s[1835] = + g0[ix+0]*g56[iy+0]*g71[iz+0];
s[1836] = + g7[ix+0]*g48[iy+0]*g72[iz+0];
s[1837] = + g6[ix+0]*g49[iy+0]*g72[iz+0];
s[1838] = + g6[ix+0]*g48[iy+0]*g73[iz+0];
s[1839] = + g5[ix+0]*g50[iy+0]*g72[iz+0];
s[1840] = + g4[ix+0]*g51[iy+0]*g72[iz+0];
s[1841] = + g4[ix+0]*g50[iy+0]*g73[iz+0];
s[1842] = + g5[ix+0]*g48[iy+0]*g74[iz+0];
s[1843] = + g4[ix+0]*g49[iy+0]*g74[iz+0];
s[1844] = + g4[ix+0]*g48[iy+0]*g75[iz+0];
s[1845] = + g3[ix+0]*g52[iy+0]*g72[iz+0];
s[1846] = + g2[ix+0]*g53[iy+0]*g72[iz+0];
s[1847] = + g2[ix+0]*g52[iy+0]*g73[iz+0];
s[1848] = + g1[ix+0]*g54[iy+0]*g72[iz+0];
s[1849] = + g0[ix+0]*g55[iy+0]*g72[iz+0];
s[1850] = + g0[ix+0]*g54[iy+0]*g73[iz+0];
s[1851] = + g1[ix+0]*g52[iy+0]*g74[iz+0];
s[1852] = + g0[ix+0]*g53[iy+0]*g74[iz+0];
s[1853] = + g0[ix+0]*g52[iy+0]*g75[iz+0];
s[1854] = + g3[ix+0]*g48[iy+0]*g76[iz+0];
s[1855] = + g2[ix+0]*g49[iy+0]*g76[iz+0];
s[1856] = + g2[ix+0]*g48[iy+0]*g77[iz+0];
s[1857] = + g1[ix+0]*g50[iy+0]*g76[iz+0];
s[1858] = + g0[ix+0]*g51[iy+0]*g76[iz+0];
s[1859] = + g0[ix+0]*g50[iy+0]*g77[iz+0];
s[1860] = + g1[ix+0]*g48[iy+0]*g78[iz+0];
s[1861] = + g0[ix+0]*g49[iy+0]*g78[iz+0];
s[1862] = + g0[ix+0]*g48[iy+0]*g79[iz+0];
s[1863] = + g15[ix+0]*g32[iy+0]*g80[iz+0];
s[1864] = + g14[ix+0]*g33[iy+0]*g80[iz+0];
s[1865] = + g14[ix+0]*g32[iy+0]*g81[iz+0];
s[1866] = + g13[ix+0]*g34[iy+0]*g80[iz+0];
s[1867] = + g12[ix+0]*g35[iy+0]*g80[iz+0];
s[1868] = + g12[ix+0]*g34[iy+0]*g81[iz+0];
s[1869] = + g13[ix+0]*g32[iy+0]*g82[iz+0];
s[1870] = + g12[ix+0]*g33[iy+0]*g82[iz+0];
s[1871] = + g12[ix+0]*g32[iy+0]*g83[iz+0];
s[1872] = + g11[ix+0]*g36[iy+0]*g80[iz+0];
s[1873] = + g10[ix+0]*g37[iy+0]*g80[iz+0];
s[1874] = + g10[ix+0]*g36[iy+0]*g81[iz+0];
s[1875] = + g9[ix+0]*g38[iy+0]*g80[iz+0];
s[1876] = + g8[ix+0]*g39[iy+0]*g80[iz+0];
s[1877] = + g8[ix+0]*g38[iy+0]*g81[iz+0];
s[1878] = + g9[ix+0]*g36[iy+0]*g82[iz+0];
s[1879] = + g8[ix+0]*g37[iy+0]*g82[iz+0];
s[1880] = + g8[ix+0]*g36[iy+0]*g83[iz+0];
s[1881] = + g11[ix+0]*g32[iy+0]*g84[iz+0];
s[1882] = + g10[ix+0]*g33[iy+0]*g84[iz+0];
s[1883] = + g10[ix+0]*g32[iy+0]*g85[iz+0];
s[1884] = + g9[ix+0]*g34[iy+0]*g84[iz+0];
s[1885] = + g8[ix+0]*g35[iy+0]*g84[iz+0];
s[1886] = + g8[ix+0]*g34[iy+0]*g85[iz+0];
s[1887] = + g9[ix+0]*g32[iy+0]*g86[iz+0];
s[1888] = + g8[ix+0]*g33[iy+0]*g86[iz+0];
s[1889] = + g8[ix+0]*g32[iy+0]*g87[iz+0];
s[1890] = + g7[ix+0]*g40[iy+0]*g80[iz+0];
s[1891] = + g6[ix+0]*g41[iy+0]*g80[iz+0];
s[1892] = + g6[ix+0]*g40[iy+0]*g81[iz+0];
s[1893] = + g5[ix+0]*g42[iy+0]*g80[iz+0];
s[1894] = + g4[ix+0]*g43[iy+0]*g80[iz+0];
s[1895] = + g4[ix+0]*g42[iy+0]*g81[iz+0];
s[1896] = + g5[ix+0]*g40[iy+0]*g82[iz+0];
s[1897] = + g4[ix+0]*g41[iy+0]*g82[iz+0];
s[1898] = + g4[ix+0]*g40[iy+0]*g83[iz+0];
s[1899] = + g3[ix+0]*g44[iy+0]*g80[iz+0];
s[1900] = + g2[ix+0]*g45[iy+0]*g80[iz+0];
s[1901] = + g2[ix+0]*g44[iy+0]*g81[iz+0];
s[1902] = + g1[ix+0]*g46[iy+0]*g80[iz+0];
s[1903] = + g0[ix+0]*g47[iy+0]*g80[iz+0];
s[1904] = + g0[ix+0]*g46[iy+0]*g81[iz+0];
s[1905] = + g1[ix+0]*g44[iy+0]*g82[iz+0];
s[1906] = + g0[ix+0]*g45[iy+0]*g82[iz+0];
s[1907] = + g0[ix+0]*g44[iy+0]*g83[iz+0];
s[1908] = + g3[ix+0]*g40[iy+0]*g84[iz+0];
s[1909] = + g2[ix+0]*g41[iy+0]*g84[iz+0];
s[1910] = + g2[ix+0]*g40[iy+0]*g85[iz+0];
s[1911] = + g1[ix+0]*g42[iy+0]*g84[iz+0];
s[1912] = + g0[ix+0]*g43[iy+0]*g84[iz+0];
s[1913] = + g0[ix+0]*g42[iy+0]*g85[iz+0];
s[1914] = + g1[ix+0]*g40[iy+0]*g86[iz+0];
s[1915] = + g0[ix+0]*g41[iy+0]*g86[iz+0];
s[1916] = + g0[ix+0]*g40[iy+0]*g87[iz+0];
s[1917] = + g7[ix+0]*g32[iy+0]*g88[iz+0];
s[1918] = + g6[ix+0]*g33[iy+0]*g88[iz+0];
s[1919] = + g6[ix+0]*g32[iy+0]*g89[iz+0];
s[1920] = + g5[ix+0]*g34[iy+0]*g88[iz+0];
s[1921] = + g4[ix+0]*g35[iy+0]*g88[iz+0];
s[1922] = + g4[ix+0]*g34[iy+0]*g89[iz+0];
s[1923] = + g5[ix+0]*g32[iy+0]*g90[iz+0];
s[1924] = + g4[ix+0]*g33[iy+0]*g90[iz+0];
s[1925] = + g4[ix+0]*g32[iy+0]*g91[iz+0];
s[1926] = + g3[ix+0]*g36[iy+0]*g88[iz+0];
s[1927] = + g2[ix+0]*g37[iy+0]*g88[iz+0];
s[1928] = + g2[ix+0]*g36[iy+0]*g89[iz+0];
s[1929] = + g1[ix+0]*g38[iy+0]*g88[iz+0];
s[1930] = + g0[ix+0]*g39[iy+0]*g88[iz+0];
s[1931] = + g0[ix+0]*g38[iy+0]*g89[iz+0];
s[1932] = + g1[ix+0]*g36[iy+0]*g90[iz+0];
s[1933] = + g0[ix+0]*g37[iy+0]*g90[iz+0];
s[1934] = + g0[ix+0]*g36[iy+0]*g91[iz+0];
s[1935] = + g3[ix+0]*g32[iy+0]*g92[iz+0];
s[1936] = + g2[ix+0]*g33[iy+0]*g92[iz+0];
s[1937] = + g2[ix+0]*g32[iy+0]*g93[iz+0];
s[1938] = + g1[ix+0]*g34[iy+0]*g92[iz+0];
s[1939] = + g0[ix+0]*g35[iy+0]*g92[iz+0];
s[1940] = + g0[ix+0]*g34[iy+0]*g93[iz+0];
s[1941] = + g1[ix+0]*g32[iy+0]*g94[iz+0];
s[1942] = + g0[ix+0]*g33[iy+0]*g94[iz+0];
s[1943] = + g0[ix+0]*g32[iy+0]*g95[iz+0];
s[1944] = + g31[ix+0]*g0[iy+0]*g96[iz+0];
s[1945] = + g30[ix+0]*g1[iy+0]*g96[iz+0];
s[1946] = + g30[ix+0]*g0[iy+0]*g97[iz+0];
s[1947] = + g29[ix+0]*g2[iy+0]*g96[iz+0];
s[1948] = + g28[ix+0]*g3[iy+0]*g96[iz+0];
s[1949] = + g28[ix+0]*g2[iy+0]*g97[iz+0];
s[1950] = + g29[ix+0]*g0[iy+0]*g98[iz+0];
s[1951] = + g28[ix+0]*g1[iy+0]*g98[iz+0];
s[1952] = + g28[ix+0]*g0[iy+0]*g99[iz+0];
s[1953] = + g27[ix+0]*g4[iy+0]*g96[iz+0];
s[1954] = + g26[ix+0]*g5[iy+0]*g96[iz+0];
s[1955] = + g26[ix+0]*g4[iy+0]*g97[iz+0];
s[1956] = + g25[ix+0]*g6[iy+0]*g96[iz+0];
s[1957] = + g24[ix+0]*g7[iy+0]*g96[iz+0];
s[1958] = + g24[ix+0]*g6[iy+0]*g97[iz+0];
s[1959] = + g25[ix+0]*g4[iy+0]*g98[iz+0];
s[1960] = + g24[ix+0]*g5[iy+0]*g98[iz+0];
s[1961] = + g24[ix+0]*g4[iy+0]*g99[iz+0];
s[1962] = + g27[ix+0]*g0[iy+0]*g100[iz+0];
s[1963] = + g26[ix+0]*g1[iy+0]*g100[iz+0];
s[1964] = + g26[ix+0]*g0[iy+0]*g101[iz+0];
s[1965] = + g25[ix+0]*g2[iy+0]*g100[iz+0];
s[1966] = + g24[ix+0]*g3[iy+0]*g100[iz+0];
s[1967] = + g24[ix+0]*g2[iy+0]*g101[iz+0];
s[1968] = + g25[ix+0]*g0[iy+0]*g102[iz+0];
s[1969] = + g24[ix+0]*g1[iy+0]*g102[iz+0];
s[1970] = + g24[ix+0]*g0[iy+0]*g103[iz+0];
s[1971] = + g23[ix+0]*g8[iy+0]*g96[iz+0];
s[1972] = + g22[ix+0]*g9[iy+0]*g96[iz+0];
s[1973] = + g22[ix+0]*g8[iy+0]*g97[iz+0];
s[1974] = + g21[ix+0]*g10[iy+0]*g96[iz+0];
s[1975] = + g20[ix+0]*g11[iy+0]*g96[iz+0];
s[1976] = + g20[ix+0]*g10[iy+0]*g97[iz+0];
s[1977] = + g21[ix+0]*g8[iy+0]*g98[iz+0];
s[1978] = + g20[ix+0]*g9[iy+0]*g98[iz+0];
s[1979] = + g20[ix+0]*g8[iy+0]*g99[iz+0];
s[1980] = + g19[ix+0]*g12[iy+0]*g96[iz+0];
s[1981] = + g18[ix+0]*g13[iy+0]*g96[iz+0];
s[1982] = + g18[ix+0]*g12[iy+0]*g97[iz+0];
s[1983] = + g17[ix+0]*g14[iy+0]*g96[iz+0];
s[1984] = + g16[ix+0]*g15[iy+0]*g96[iz+0];
s[1985] = + g16[ix+0]*g14[iy+0]*g97[iz+0];
s[1986] = + g17[ix+0]*g12[iy+0]*g98[iz+0];
s[1987] = + g16[ix+0]*g13[iy+0]*g98[iz+0];
s[1988] = + g16[ix+0]*g12[iy+0]*g99[iz+0];
s[1989] = + g19[ix+0]*g8[iy+0]*g100[iz+0];
s[1990] = + g18[ix+0]*g9[iy+0]*g100[iz+0];
s[1991] = + g18[ix+0]*g8[iy+0]*g101[iz+0];
s[1992] = + g17[ix+0]*g10[iy+0]*g100[iz+0];
s[1993] = + g16[ix+0]*g11[iy+0]*g100[iz+0];
s[1994] = + g16[ix+0]*g10[iy+0]*g101[iz+0];
s[1995] = + g17[ix+0]*g8[iy+0]*g102[iz+0];
s[1996] = + g16[ix+0]*g9[iy+0]*g102[iz+0];
s[1997] = + g16[ix+0]*g8[iy+0]*g103[iz+0];
s[1998] = + g23[ix+0]*g0[iy+0]*g104[iz+0];
s[1999] = + g22[ix+0]*g1[iy+0]*g104[iz+0];
s[2000] = + g22[ix+0]*g0[iy+0]*g105[iz+0];
s[2001] = + g21[ix+0]*g2[iy+0]*g104[iz+0];
s[2002] = + g20[ix+0]*g3[iy+0]*g104[iz+0];
s[2003] = + g20[ix+0]*g2[iy+0]*g105[iz+0];
s[2004] = + g21[ix+0]*g0[iy+0]*g106[iz+0];
s[2005] = + g20[ix+0]*g1[iy+0]*g106[iz+0];
s[2006] = + g20[ix+0]*g0[iy+0]*g107[iz+0];
s[2007] = + g19[ix+0]*g4[iy+0]*g104[iz+0];
s[2008] = + g18[ix+0]*g5[iy+0]*g104[iz+0];
s[2009] = + g18[ix+0]*g4[iy+0]*g105[iz+0];
s[2010] = + g17[ix+0]*g6[iy+0]*g104[iz+0];
s[2011] = + g16[ix+0]*g7[iy+0]*g104[iz+0];
s[2012] = + g16[ix+0]*g6[iy+0]*g105[iz+0];
s[2013] = + g17[ix+0]*g4[iy+0]*g106[iz+0];
s[2014] = + g16[ix+0]*g5[iy+0]*g106[iz+0];
s[2015] = + g16[ix+0]*g4[iy+0]*g107[iz+0];
s[2016] = + g19[ix+0]*g0[iy+0]*g108[iz+0];
s[2017] = + g18[ix+0]*g1[iy+0]*g108[iz+0];
s[2018] = + g18[ix+0]*g0[iy+0]*g109[iz+0];
s[2019] = + g17[ix+0]*g2[iy+0]*g108[iz+0];
s[2020] = + g16[ix+0]*g3[iy+0]*g108[iz+0];
s[2021] = + g16[ix+0]*g2[iy+0]*g109[iz+0];
s[2022] = + g17[ix+0]*g0[iy+0]*g110[iz+0];
s[2023] = + g16[ix+0]*g1[iy+0]*g110[iz+0];
s[2024] = + g16[ix+0]*g0[iy+0]*g111[iz+0];
s[2025] = + g15[ix+0]*g16[iy+0]*g96[iz+0];
s[2026] = + g14[ix+0]*g17[iy+0]*g96[iz+0];
s[2027] = + g14[ix+0]*g16[iy+0]*g97[iz+0];
s[2028] = + g13[ix+0]*g18[iy+0]*g96[iz+0];
s[2029] = + g12[ix+0]*g19[iy+0]*g96[iz+0];
s[2030] = + g12[ix+0]*g18[iy+0]*g97[iz+0];
s[2031] = + g13[ix+0]*g16[iy+0]*g98[iz+0];
s[2032] = + g12[ix+0]*g17[iy+0]*g98[iz+0];
s[2033] = + g12[ix+0]*g16[iy+0]*g99[iz+0];
s[2034] = + g11[ix+0]*g20[iy+0]*g96[iz+0];
s[2035] = + g10[ix+0]*g21[iy+0]*g96[iz+0];
s[2036] = + g10[ix+0]*g20[iy+0]*g97[iz+0];
s[2037] = + g9[ix+0]*g22[iy+0]*g96[iz+0];
s[2038] = + g8[ix+0]*g23[iy+0]*g96[iz+0];
s[2039] = + g8[ix+0]*g22[iy+0]*g97[iz+0];
s[2040] = + g9[ix+0]*g20[iy+0]*g98[iz+0];
s[2041] = + g8[ix+0]*g21[iy+0]*g98[iz+0];
s[2042] = + g8[ix+0]*g20[iy+0]*g99[iz+0];
s[2043] = + g11[ix+0]*g16[iy+0]*g100[iz+0];
s[2044] = + g10[ix+0]*g17[iy+0]*g100[iz+0];
s[2045] = + g10[ix+0]*g16[iy+0]*g101[iz+0];
s[2046] = + g9[ix+0]*g18[iy+0]*g100[iz+0];
s[2047] = + g8[ix+0]*g19[iy+0]*g100[iz+0];
s[2048] = + g8[ix+0]*g18[iy+0]*g101[iz+0];
s[2049] = + g9[ix+0]*g16[iy+0]*g102[iz+0];
s[2050] = + g8[ix+0]*g17[iy+0]*g102[iz+0];
s[2051] = + g8[ix+0]*g16[iy+0]*g103[iz+0];
s[2052] = + g7[ix+0]*g24[iy+0]*g96[iz+0];
s[2053] = + g6[ix+0]*g25[iy+0]*g96[iz+0];
s[2054] = + g6[ix+0]*g24[iy+0]*g97[iz+0];
s[2055] = + g5[ix+0]*g26[iy+0]*g96[iz+0];
s[2056] = + g4[ix+0]*g27[iy+0]*g96[iz+0];
s[2057] = + g4[ix+0]*g26[iy+0]*g97[iz+0];
s[2058] = + g5[ix+0]*g24[iy+0]*g98[iz+0];
s[2059] = + g4[ix+0]*g25[iy+0]*g98[iz+0];
s[2060] = + g4[ix+0]*g24[iy+0]*g99[iz+0];
s[2061] = + g3[ix+0]*g28[iy+0]*g96[iz+0];
s[2062] = + g2[ix+0]*g29[iy+0]*g96[iz+0];
s[2063] = + g2[ix+0]*g28[iy+0]*g97[iz+0];
s[2064] = + g1[ix+0]*g30[iy+0]*g96[iz+0];
s[2065] = + g0[ix+0]*g31[iy+0]*g96[iz+0];
s[2066] = + g0[ix+0]*g30[iy+0]*g97[iz+0];
s[2067] = + g1[ix+0]*g28[iy+0]*g98[iz+0];
s[2068] = + g0[ix+0]*g29[iy+0]*g98[iz+0];
s[2069] = + g0[ix+0]*g28[iy+0]*g99[iz+0];
s[2070] = + g3[ix+0]*g24[iy+0]*g100[iz+0];
s[2071] = + g2[ix+0]*g25[iy+0]*g100[iz+0];
s[2072] = + g2[ix+0]*g24[iy+0]*g101[iz+0];
s[2073] = + g1[ix+0]*g26[iy+0]*g100[iz+0];
s[2074] = + g0[ix+0]*g27[iy+0]*g100[iz+0];
s[2075] = + g0[ix+0]*g26[iy+0]*g101[iz+0];
s[2076] = + g1[ix+0]*g24[iy+0]*g102[iz+0];
s[2077] = + g0[ix+0]*g25[iy+0]*g102[iz+0];
s[2078] = + g0[ix+0]*g24[iy+0]*g103[iz+0];
s[2079] = + g7[ix+0]*g16[iy+0]*g104[iz+0];
s[2080] = + g6[ix+0]*g17[iy+0]*g104[iz+0];
s[2081] = + g6[ix+0]*g16[iy+0]*g105[iz+0];
s[2082] = + g5[ix+0]*g18[iy+0]*g104[iz+0];
s[2083] = + g4[ix+0]*g19[iy+0]*g104[iz+0];
s[2084] = + g4[ix+0]*g18[iy+0]*g105[iz+0];
s[2085] = + g5[ix+0]*g16[iy+0]*g106[iz+0];
s[2086] = + g4[ix+0]*g17[iy+0]*g106[iz+0];
s[2087] = + g4[ix+0]*g16[iy+0]*g107[iz+0];
s[2088] = + g3[ix+0]*g20[iy+0]*g104[iz+0];
s[2089] = + g2[ix+0]*g21[iy+0]*g104[iz+0];
s[2090] = + g2[ix+0]*g20[iy+0]*g105[iz+0];
s[2091] = + g1[ix+0]*g22[iy+0]*g104[iz+0];
s[2092] = + g0[ix+0]*g23[iy+0]*g104[iz+0];
s[2093] = + g0[ix+0]*g22[iy+0]*g105[iz+0];
s[2094] = + g1[ix+0]*g20[iy+0]*g106[iz+0];
s[2095] = + g0[ix+0]*g21[iy+0]*g106[iz+0];
s[2096] = + g0[ix+0]*g20[iy+0]*g107[iz+0];
s[2097] = + g3[ix+0]*g16[iy+0]*g108[iz+0];
s[2098] = + g2[ix+0]*g17[iy+0]*g108[iz+0];
s[2099] = + g2[ix+0]*g16[iy+0]*g109[iz+0];
s[2100] = + g1[ix+0]*g18[iy+0]*g108[iz+0];
s[2101] = + g0[ix+0]*g19[iy+0]*g108[iz+0];
s[2102] = + g0[ix+0]*g18[iy+0]*g109[iz+0];
s[2103] = + g1[ix+0]*g16[iy+0]*g110[iz+0];
s[2104] = + g0[ix+0]*g17[iy+0]*g110[iz+0];
s[2105] = + g0[ix+0]*g16[iy+0]*g111[iz+0];
s[2106] = + g15[ix+0]*g0[iy+0]*g112[iz+0];
s[2107] = + g14[ix+0]*g1[iy+0]*g112[iz+0];
s[2108] = + g14[ix+0]*g0[iy+0]*g113[iz+0];
s[2109] = + g13[ix+0]*g2[iy+0]*g112[iz+0];
s[2110] = + g12[ix+0]*g3[iy+0]*g112[iz+0];
s[2111] = + g12[ix+0]*g2[iy+0]*g113[iz+0];
s[2112] = + g13[ix+0]*g0[iy+0]*g114[iz+0];
s[2113] = + g12[ix+0]*g1[iy+0]*g114[iz+0];
s[2114] = + g12[ix+0]*g0[iy+0]*g115[iz+0];
s[2115] = + g11[ix+0]*g4[iy+0]*g112[iz+0];
s[2116] = + g10[ix+0]*g5[iy+0]*g112[iz+0];
s[2117] = + g10[ix+0]*g4[iy+0]*g113[iz+0];
s[2118] = + g9[ix+0]*g6[iy+0]*g112[iz+0];
s[2119] = + g8[ix+0]*g7[iy+0]*g112[iz+0];
s[2120] = + g8[ix+0]*g6[iy+0]*g113[iz+0];
s[2121] = + g9[ix+0]*g4[iy+0]*g114[iz+0];
s[2122] = + g8[ix+0]*g5[iy+0]*g114[iz+0];
s[2123] = + g8[ix+0]*g4[iy+0]*g115[iz+0];
s[2124] = + g11[ix+0]*g0[iy+0]*g116[iz+0];
s[2125] = + g10[ix+0]*g1[iy+0]*g116[iz+0];
s[2126] = + g10[ix+0]*g0[iy+0]*g117[iz+0];
s[2127] = + g9[ix+0]*g2[iy+0]*g116[iz+0];
s[2128] = + g8[ix+0]*g3[iy+0]*g116[iz+0];
s[2129] = + g8[ix+0]*g2[iy+0]*g117[iz+0];
s[2130] = + g9[ix+0]*g0[iy+0]*g118[iz+0];
s[2131] = + g8[ix+0]*g1[iy+0]*g118[iz+0];
s[2132] = + g8[ix+0]*g0[iy+0]*g119[iz+0];
s[2133] = + g7[ix+0]*g8[iy+0]*g112[iz+0];
s[2134] = + g6[ix+0]*g9[iy+0]*g112[iz+0];
s[2135] = + g6[ix+0]*g8[iy+0]*g113[iz+0];
s[2136] = + g5[ix+0]*g10[iy+0]*g112[iz+0];
s[2137] = + g4[ix+0]*g11[iy+0]*g112[iz+0];
s[2138] = + g4[ix+0]*g10[iy+0]*g113[iz+0];
s[2139] = + g5[ix+0]*g8[iy+0]*g114[iz+0];
s[2140] = + g4[ix+0]*g9[iy+0]*g114[iz+0];
s[2141] = + g4[ix+0]*g8[iy+0]*g115[iz+0];
s[2142] = + g3[ix+0]*g12[iy+0]*g112[iz+0];
s[2143] = + g2[ix+0]*g13[iy+0]*g112[iz+0];
s[2144] = + g2[ix+0]*g12[iy+0]*g113[iz+0];
s[2145] = + g1[ix+0]*g14[iy+0]*g112[iz+0];
s[2146] = + g0[ix+0]*g15[iy+0]*g112[iz+0];
s[2147] = + g0[ix+0]*g14[iy+0]*g113[iz+0];
s[2148] = + g1[ix+0]*g12[iy+0]*g114[iz+0];
s[2149] = + g0[ix+0]*g13[iy+0]*g114[iz+0];
s[2150] = + g0[ix+0]*g12[iy+0]*g115[iz+0];
s[2151] = + g3[ix+0]*g8[iy+0]*g116[iz+0];
s[2152] = + g2[ix+0]*g9[iy+0]*g116[iz+0];
s[2153] = + g2[ix+0]*g8[iy+0]*g117[iz+0];
s[2154] = + g1[ix+0]*g10[iy+0]*g116[iz+0];
s[2155] = + g0[ix+0]*g11[iy+0]*g116[iz+0];
s[2156] = + g0[ix+0]*g10[iy+0]*g117[iz+0];
s[2157] = + g1[ix+0]*g8[iy+0]*g118[iz+0];
s[2158] = + g0[ix+0]*g9[iy+0]*g118[iz+0];
s[2159] = + g0[ix+0]*g8[iy+0]*g119[iz+0];
s[2160] = + g7[ix+0]*g0[iy+0]*g120[iz+0];
s[2161] = + g6[ix+0]*g1[iy+0]*g120[iz+0];
s[2162] = + g6[ix+0]*g0[iy+0]*g121[iz+0];
s[2163] = + g5[ix+0]*g2[iy+0]*g120[iz+0];
s[2164] = + g4[ix+0]*g3[iy+0]*g120[iz+0];
s[2165] = + g4[ix+0]*g2[iy+0]*g121[iz+0];
s[2166] = + g5[ix+0]*g0[iy+0]*g122[iz+0];
s[2167] = + g4[ix+0]*g1[iy+0]*g122[iz+0];
s[2168] = + g4[ix+0]*g0[iy+0]*g123[iz+0];
s[2169] = + g3[ix+0]*g4[iy+0]*g120[iz+0];
s[2170] = + g2[ix+0]*g5[iy+0]*g120[iz+0];
s[2171] = + g2[ix+0]*g4[iy+0]*g121[iz+0];
s[2172] = + g1[ix+0]*g6[iy+0]*g120[iz+0];
s[2173] = + g0[ix+0]*g7[iy+0]*g120[iz+0];
s[2174] = + g0[ix+0]*g6[iy+0]*g121[iz+0];
s[2175] = + g1[ix+0]*g4[iy+0]*g122[iz+0];
s[2176] = + g0[ix+0]*g5[iy+0]*g122[iz+0];
s[2177] = + g0[ix+0]*g4[iy+0]*g123[iz+0];
s[2178] = + g3[ix+0]*g0[iy+0]*g124[iz+0];
s[2179] = + g2[ix+0]*g1[iy+0]*g124[iz+0];
s[2180] = + g2[ix+0]*g0[iy+0]*g125[iz+0];
s[2181] = + g1[ix+0]*g2[iy+0]*g124[iz+0];
s[2182] = + g0[ix+0]*g3[iy+0]*g124[iz+0];
s[2183] = + g0[ix+0]*g2[iy+0]*g125[iz+0];
s[2184] = + g1[ix+0]*g0[iy+0]*g126[iz+0];
s[2185] = + g0[ix+0]*g1[iy+0]*g126[iz+0];
s[2186] = + g0[ix+0]*g0[iy+0]*g127[iz+0];
if (gout_empty) {
gout[n*2187+0] = + s[0];
gout[n*2187+1] = + s[1];
gout[n*2187+2] = + s[2];
gout[n*2187+3] = + s[3];
gout[n*2187+4] = + s[4];
gout[n*2187+5] = + s[5];
gout[n*2187+6] = + s[6];
gout[n*2187+7] = + s[7];
gout[n*2187+8] = + s[8];
gout[n*2187+9] = + s[9];
gout[n*2187+10] = + s[10];
gout[n*2187+11] = + s[11];
gout[n*2187+12] = + s[12];
gout[n*2187+13] = + s[13];
gout[n*2187+14] = + s[14];
gout[n*2187+15] = + s[15];
gout[n*2187+16] = + s[16];
gout[n*2187+17] = + s[17];
gout[n*2187+18] = + s[18];
gout[n*2187+19] = + s[19];
gout[n*2187+20] = + s[20];
gout[n*2187+21] = + s[21];
gout[n*2187+22] = + s[22];
gout[n*2187+23] = + s[23];
gout[n*2187+24] = + s[24];
gout[n*2187+25] = + s[25];
gout[n*2187+26] = + s[26];
gout[n*2187+27] = + s[729];
gout[n*2187+28] = + s[730];
gout[n*2187+29] = + s[731];
gout[n*2187+30] = + s[732];
gout[n*2187+31] = + s[733];
gout[n*2187+32] = + s[734];
gout[n*2187+33] = + s[735];
gout[n*2187+34] = + s[736];
gout[n*2187+35] = + s[737];
gout[n*2187+36] = + s[738];
gout[n*2187+37] = + s[739];
gout[n*2187+38] = + s[740];
gout[n*2187+39] = + s[741];
gout[n*2187+40] = + s[742];
gout[n*2187+41] = + s[743];
gout[n*2187+42] = + s[744];
gout[n*2187+43] = + s[745];
gout[n*2187+44] = + s[746];
gout[n*2187+45] = + s[747];
gout[n*2187+46] = + s[748];
gout[n*2187+47] = + s[749];
gout[n*2187+48] = + s[750];
gout[n*2187+49] = + s[751];
gout[n*2187+50] = + s[752];
gout[n*2187+51] = + s[753];
gout[n*2187+52] = + s[754];
gout[n*2187+53] = + s[755];
gout[n*2187+54] = + s[1458];
gout[n*2187+55] = + s[1459];
gout[n*2187+56] = + s[1460];
gout[n*2187+57] = + s[1461];
gout[n*2187+58] = + s[1462];
gout[n*2187+59] = + s[1463];
gout[n*2187+60] = + s[1464];
gout[n*2187+61] = + s[1465];
gout[n*2187+62] = + s[1466];
gout[n*2187+63] = + s[1467];
gout[n*2187+64] = + s[1468];
gout[n*2187+65] = + s[1469];
gout[n*2187+66] = + s[1470];
gout[n*2187+67] = + s[1471];
gout[n*2187+68] = + s[1472];
gout[n*2187+69] = + s[1473];
gout[n*2187+70] = + s[1474];
gout[n*2187+71] = + s[1475];
gout[n*2187+72] = + s[1476];
gout[n*2187+73] = + s[1477];
gout[n*2187+74] = + s[1478];
gout[n*2187+75] = + s[1479];
gout[n*2187+76] = + s[1480];
gout[n*2187+77] = + s[1481];
gout[n*2187+78] = + s[1482];
gout[n*2187+79] = + s[1483];
gout[n*2187+80] = + s[1484];
gout[n*2187+81] = + s[243];
gout[n*2187+82] = + s[244];
gout[n*2187+83] = + s[245];
gout[n*2187+84] = + s[246];
gout[n*2187+85] = + s[247];
gout[n*2187+86] = + s[248];
gout[n*2187+87] = + s[249];
gout[n*2187+88] = + s[250];
gout[n*2187+89] = + s[251];
gout[n*2187+90] = + s[252];
gout[n*2187+91] = + s[253];
gout[n*2187+92] = + s[254];
gout[n*2187+93] = + s[255];
gout[n*2187+94] = + s[256];
gout[n*2187+95] = + s[257];
gout[n*2187+96] = + s[258];
gout[n*2187+97] = + s[259];
gout[n*2187+98] = + s[260];
gout[n*2187+99] = + s[261];
gout[n*2187+100] = + s[262];
gout[n*2187+101] = + s[263];
gout[n*2187+102] = + s[264];
gout[n*2187+103] = + s[265];
gout[n*2187+104] = + s[266];
gout[n*2187+105] = + s[267];
gout[n*2187+106] = + s[268];
gout[n*2187+107] = + s[269];
gout[n*2187+108] = + s[972];
gout[n*2187+109] = + s[973];
gout[n*2187+110] = + s[974];
gout[n*2187+111] = + s[975];
gout[n*2187+112] = + s[976];
gout[n*2187+113] = + s[977];
gout[n*2187+114] = + s[978];
gout[n*2187+115] = + s[979];
gout[n*2187+116] = + s[980];
gout[n*2187+117] = + s[981];
gout[n*2187+118] = + s[982];
gout[n*2187+119] = + s[983];
gout[n*2187+120] = + s[984];
gout[n*2187+121] = + s[985];
gout[n*2187+122] = + s[986];
gout[n*2187+123] = + s[987];
gout[n*2187+124] = + s[988];
gout[n*2187+125] = + s[989];
gout[n*2187+126] = + s[990];
gout[n*2187+127] = + s[991];
gout[n*2187+128] = + s[992];
gout[n*2187+129] = + s[993];
gout[n*2187+130] = + s[994];
gout[n*2187+131] = + s[995];
gout[n*2187+132] = + s[996];
gout[n*2187+133] = + s[997];
gout[n*2187+134] = + s[998];
gout[n*2187+135] = + s[1701];
gout[n*2187+136] = + s[1702];
gout[n*2187+137] = + s[1703];
gout[n*2187+138] = + s[1704];
gout[n*2187+139] = + s[1705];
gout[n*2187+140] = + s[1706];
gout[n*2187+141] = + s[1707];
gout[n*2187+142] = + s[1708];
gout[n*2187+143] = + s[1709];
gout[n*2187+144] = + s[1710];
gout[n*2187+145] = + s[1711];
gout[n*2187+146] = + s[1712];
gout[n*2187+147] = + s[1713];
gout[n*2187+148] = + s[1714];
gout[n*2187+149] = + s[1715];
gout[n*2187+150] = + s[1716];
gout[n*2187+151] = + s[1717];
gout[n*2187+152] = + s[1718];
gout[n*2187+153] = + s[1719];
gout[n*2187+154] = + s[1720];
gout[n*2187+155] = + s[1721];
gout[n*2187+156] = + s[1722];
gout[n*2187+157] = + s[1723];
gout[n*2187+158] = + s[1724];
gout[n*2187+159] = + s[1725];
gout[n*2187+160] = + s[1726];
gout[n*2187+161] = + s[1727];
gout[n*2187+162] = + s[486];
gout[n*2187+163] = + s[487];
gout[n*2187+164] = + s[488];
gout[n*2187+165] = + s[489];
gout[n*2187+166] = + s[490];
gout[n*2187+167] = + s[491];
gout[n*2187+168] = + s[492];
gout[n*2187+169] = + s[493];
gout[n*2187+170] = + s[494];
gout[n*2187+171] = + s[495];
gout[n*2187+172] = + s[496];
gout[n*2187+173] = + s[497];
gout[n*2187+174] = + s[498];
gout[n*2187+175] = + s[499];
gout[n*2187+176] = + s[500];
gout[n*2187+177] = + s[501];
gout[n*2187+178] = + s[502];
gout[n*2187+179] = + s[503];
gout[n*2187+180] = + s[504];
gout[n*2187+181] = + s[505];
gout[n*2187+182] = + s[506];
gout[n*2187+183] = + s[507];
gout[n*2187+184] = + s[508];
gout[n*2187+185] = + s[509];
gout[n*2187+186] = + s[510];
gout[n*2187+187] = + s[511];
gout[n*2187+188] = + s[512];
gout[n*2187+189] = + s[1215];
gout[n*2187+190] = + s[1216];
gout[n*2187+191] = + s[1217];
gout[n*2187+192] = + s[1218];
gout[n*2187+193] = + s[1219];
gout[n*2187+194] = + s[1220];
gout[n*2187+195] = + s[1221];
gout[n*2187+196] = + s[1222];
gout[n*2187+197] = + s[1223];
gout[n*2187+198] = + s[1224];
gout[n*2187+199] = + s[1225];
gout[n*2187+200] = + s[1226];
gout[n*2187+201] = + s[1227];
gout[n*2187+202] = + s[1228];
gout[n*2187+203] = + s[1229];
gout[n*2187+204] = + s[1230];
gout[n*2187+205] = + s[1231];
gout[n*2187+206] = + s[1232];
gout[n*2187+207] = + s[1233];
gout[n*2187+208] = + s[1234];
gout[n*2187+209] = + s[1235];
gout[n*2187+210] = + s[1236];
gout[n*2187+211] = + s[1237];
gout[n*2187+212] = + s[1238];
gout[n*2187+213] = + s[1239];
gout[n*2187+214] = + s[1240];
gout[n*2187+215] = + s[1241];
gout[n*2187+216] = + s[1944];
gout[n*2187+217] = + s[1945];
gout[n*2187+218] = + s[1946];
gout[n*2187+219] = + s[1947];
gout[n*2187+220] = + s[1948];
gout[n*2187+221] = + s[1949];
gout[n*2187+222] = + s[1950];
gout[n*2187+223] = + s[1951];
gout[n*2187+224] = + s[1952];
gout[n*2187+225] = + s[1953];
gout[n*2187+226] = + s[1954];
gout[n*2187+227] = + s[1955];
gout[n*2187+228] = + s[1956];
gout[n*2187+229] = + s[1957];
gout[n*2187+230] = + s[1958];
gout[n*2187+231] = + s[1959];
gout[n*2187+232] = + s[1960];
gout[n*2187+233] = + s[1961];
gout[n*2187+234] = + s[1962];
gout[n*2187+235] = + s[1963];
gout[n*2187+236] = + s[1964];
gout[n*2187+237] = + s[1965];
gout[n*2187+238] = + s[1966];
gout[n*2187+239] = + s[1967];
gout[n*2187+240] = + s[1968];
gout[n*2187+241] = + s[1969];
gout[n*2187+242] = + s[1970];
gout[n*2187+243] = + s[81];
gout[n*2187+244] = + s[82];
gout[n*2187+245] = + s[83];
gout[n*2187+246] = + s[84];
gout[n*2187+247] = + s[85];
gout[n*2187+248] = + s[86];
gout[n*2187+249] = + s[87];
gout[n*2187+250] = + s[88];
gout[n*2187+251] = + s[89];
gout[n*2187+252] = + s[90];
gout[n*2187+253] = + s[91];
gout[n*2187+254] = + s[92];
gout[n*2187+255] = + s[93];
gout[n*2187+256] = + s[94];
gout[n*2187+257] = + s[95];
gout[n*2187+258] = + s[96];
gout[n*2187+259] = + s[97];
gout[n*2187+260] = + s[98];
gout[n*2187+261] = + s[99];
gout[n*2187+262] = + s[100];
gout[n*2187+263] = + s[101];
gout[n*2187+264] = + s[102];
gout[n*2187+265] = + s[103];
gout[n*2187+266] = + s[104];
gout[n*2187+267] = + s[105];
gout[n*2187+268] = + s[106];
gout[n*2187+269] = + s[107];
gout[n*2187+270] = + s[810];
gout[n*2187+271] = + s[811];
gout[n*2187+272] = + s[812];
gout[n*2187+273] = + s[813];
gout[n*2187+274] = + s[814];
gout[n*2187+275] = + s[815];
gout[n*2187+276] = + s[816];
gout[n*2187+277] = + s[817];
gout[n*2187+278] = + s[818];
gout[n*2187+279] = + s[819];
gout[n*2187+280] = + s[820];
gout[n*2187+281] = + s[821];
gout[n*2187+282] = + s[822];
gout[n*2187+283] = + s[823];
gout[n*2187+284] = + s[824];
gout[n*2187+285] = + s[825];
gout[n*2187+286] = + s[826];
gout[n*2187+287] = + s[827];
gout[n*2187+288] = + s[828];
gout[n*2187+289] = + s[829];
gout[n*2187+290] = + s[830];
gout[n*2187+291] = + s[831];
gout[n*2187+292] = + s[832];
gout[n*2187+293] = + s[833];
gout[n*2187+294] = + s[834];
gout[n*2187+295] = + s[835];
gout[n*2187+296] = + s[836];
gout[n*2187+297] = + s[1539];
gout[n*2187+298] = + s[1540];
gout[n*2187+299] = + s[1541];
gout[n*2187+300] = + s[1542];
gout[n*2187+301] = + s[1543];
gout[n*2187+302] = + s[1544];
gout[n*2187+303] = + s[1545];
gout[n*2187+304] = + s[1546];
gout[n*2187+305] = + s[1547];
gout[n*2187+306] = + s[1548];
gout[n*2187+307] = + s[1549];
gout[n*2187+308] = + s[1550];
gout[n*2187+309] = + s[1551];
gout[n*2187+310] = + s[1552];
gout[n*2187+311] = + s[1553];
gout[n*2187+312] = + s[1554];
gout[n*2187+313] = + s[1555];
gout[n*2187+314] = + s[1556];
gout[n*2187+315] = + s[1557];
gout[n*2187+316] = + s[1558];
gout[n*2187+317] = + s[1559];
gout[n*2187+318] = + s[1560];
gout[n*2187+319] = + s[1561];
gout[n*2187+320] = + s[1562];
gout[n*2187+321] = + s[1563];
gout[n*2187+322] = + s[1564];
gout[n*2187+323] = + s[1565];
gout[n*2187+324] = + s[324];
gout[n*2187+325] = + s[325];
gout[n*2187+326] = + s[326];
gout[n*2187+327] = + s[327];
gout[n*2187+328] = + s[328];
gout[n*2187+329] = + s[329];
gout[n*2187+330] = + s[330];
gout[n*2187+331] = + s[331];
gout[n*2187+332] = + s[332];
gout[n*2187+333] = + s[333];
gout[n*2187+334] = + s[334];
gout[n*2187+335] = + s[335];
gout[n*2187+336] = + s[336];
gout[n*2187+337] = + s[337];
gout[n*2187+338] = + s[338];
gout[n*2187+339] = + s[339];
gout[n*2187+340] = + s[340];
gout[n*2187+341] = + s[341];
gout[n*2187+342] = + s[342];
gout[n*2187+343] = + s[343];
gout[n*2187+344] = + s[344];
gout[n*2187+345] = + s[345];
gout[n*2187+346] = + s[346];
gout[n*2187+347] = + s[347];
gout[n*2187+348] = + s[348];
gout[n*2187+349] = + s[349];
gout[n*2187+350] = + s[350];
gout[n*2187+351] = + s[1053];
gout[n*2187+352] = + s[1054];
gout[n*2187+353] = + s[1055];
gout[n*2187+354] = + s[1056];
gout[n*2187+355] = + s[1057];
gout[n*2187+356] = + s[1058];
gout[n*2187+357] = + s[1059];
gout[n*2187+358] = + s[1060];
gout[n*2187+359] = + s[1061];
gout[n*2187+360] = + s[1062];
gout[n*2187+361] = + s[1063];
gout[n*2187+362] = + s[1064];
gout[n*2187+363] = + s[1065];
gout[n*2187+364] = + s[1066];
gout[n*2187+365] = + s[1067];
gout[n*2187+366] = + s[1068];
gout[n*2187+367] = + s[1069];
gout[n*2187+368] = + s[1070];
gout[n*2187+369] = + s[1071];
gout[n*2187+370] = + s[1072];
gout[n*2187+371] = + s[1073];
gout[n*2187+372] = + s[1074];
gout[n*2187+373] = + s[1075];
gout[n*2187+374] = + s[1076];
gout[n*2187+375] = + s[1077];
gout[n*2187+376] = + s[1078];
gout[n*2187+377] = + s[1079];
gout[n*2187+378] = + s[1782];
gout[n*2187+379] = + s[1783];
gout[n*2187+380] = + s[1784];
gout[n*2187+381] = + s[1785];
gout[n*2187+382] = + s[1786];
gout[n*2187+383] = + s[1787];
gout[n*2187+384] = + s[1788];
gout[n*2187+385] = + s[1789];
gout[n*2187+386] = + s[1790];
gout[n*2187+387] = + s[1791];
gout[n*2187+388] = + s[1792];
gout[n*2187+389] = + s[1793];
gout[n*2187+390] = + s[1794];
gout[n*2187+391] = + s[1795];
gout[n*2187+392] = + s[1796];
gout[n*2187+393] = + s[1797];
gout[n*2187+394] = + s[1798];
gout[n*2187+395] = + s[1799];
gout[n*2187+396] = + s[1800];
gout[n*2187+397] = + s[1801];
gout[n*2187+398] = + s[1802];
gout[n*2187+399] = + s[1803];
gout[n*2187+400] = + s[1804];
gout[n*2187+401] = + s[1805];
gout[n*2187+402] = + s[1806];
gout[n*2187+403] = + s[1807];
gout[n*2187+404] = + s[1808];
gout[n*2187+405] = + s[567];
gout[n*2187+406] = + s[568];
gout[n*2187+407] = + s[569];
gout[n*2187+408] = + s[570];
gout[n*2187+409] = + s[571];
gout[n*2187+410] = + s[572];
gout[n*2187+411] = + s[573];
gout[n*2187+412] = + s[574];
gout[n*2187+413] = + s[575];
gout[n*2187+414] = + s[576];
gout[n*2187+415] = + s[577];
gout[n*2187+416] = + s[578];
gout[n*2187+417] = + s[579];
gout[n*2187+418] = + s[580];
gout[n*2187+419] = + s[581];
gout[n*2187+420] = + s[582];
gout[n*2187+421] = + s[583];
gout[n*2187+422] = + s[584];
gout[n*2187+423] = + s[585];
gout[n*2187+424] = + s[586];
gout[n*2187+425] = + s[587];
gout[n*2187+426] = + s[588];
gout[n*2187+427] = + s[589];
gout[n*2187+428] = + s[590];
gout[n*2187+429] = + s[591];
gout[n*2187+430] = + s[592];
gout[n*2187+431] = + s[593];
gout[n*2187+432] = + s[1296];
gout[n*2187+433] = + s[1297];
gout[n*2187+434] = + s[1298];
gout[n*2187+435] = + s[1299];
gout[n*2187+436] = + s[1300];
gout[n*2187+437] = + s[1301];
gout[n*2187+438] = + s[1302];
gout[n*2187+439] = + s[1303];
gout[n*2187+440] = + s[1304];
gout[n*2187+441] = + s[1305];
gout[n*2187+442] = + s[1306];
gout[n*2187+443] = + s[1307];
gout[n*2187+444] = + s[1308];
gout[n*2187+445] = + s[1309];
gout[n*2187+446] = + s[1310];
gout[n*2187+447] = + s[1311];
gout[n*2187+448] = + s[1312];
gout[n*2187+449] = + s[1313];
gout[n*2187+450] = + s[1314];
gout[n*2187+451] = + s[1315];
gout[n*2187+452] = + s[1316];
gout[n*2187+453] = + s[1317];
gout[n*2187+454] = + s[1318];
gout[n*2187+455] = + s[1319];
gout[n*2187+456] = + s[1320];
gout[n*2187+457] = + s[1321];
gout[n*2187+458] = + s[1322];
gout[n*2187+459] = + s[2025];
gout[n*2187+460] = + s[2026];
gout[n*2187+461] = + s[2027];
gout[n*2187+462] = + s[2028];
gout[n*2187+463] = + s[2029];
gout[n*2187+464] = + s[2030];
gout[n*2187+465] = + s[2031];
gout[n*2187+466] = + s[2032];
gout[n*2187+467] = + s[2033];
gout[n*2187+468] = + s[2034];
gout[n*2187+469] = + s[2035];
gout[n*2187+470] = + s[2036];
gout[n*2187+471] = + s[2037];
gout[n*2187+472] = + s[2038];
gout[n*2187+473] = + s[2039];
gout[n*2187+474] = + s[2040];
gout[n*2187+475] = + s[2041];
gout[n*2187+476] = + s[2042];
gout[n*2187+477] = + s[2043];
gout[n*2187+478] = + s[2044];
gout[n*2187+479] = + s[2045];
gout[n*2187+480] = + s[2046];
gout[n*2187+481] = + s[2047];
gout[n*2187+482] = + s[2048];
gout[n*2187+483] = + s[2049];
gout[n*2187+484] = + s[2050];
gout[n*2187+485] = + s[2051];
gout[n*2187+486] = + s[162];
gout[n*2187+487] = + s[163];
gout[n*2187+488] = + s[164];
gout[n*2187+489] = + s[165];
gout[n*2187+490] = + s[166];
gout[n*2187+491] = + s[167];
gout[n*2187+492] = + s[168];
gout[n*2187+493] = + s[169];
gout[n*2187+494] = + s[170];
gout[n*2187+495] = + s[171];
gout[n*2187+496] = + s[172];
gout[n*2187+497] = + s[173];
gout[n*2187+498] = + s[174];
gout[n*2187+499] = + s[175];
gout[n*2187+500] = + s[176];
gout[n*2187+501] = + s[177];
gout[n*2187+502] = + s[178];
gout[n*2187+503] = + s[179];
gout[n*2187+504] = + s[180];
gout[n*2187+505] = + s[181];
gout[n*2187+506] = + s[182];
gout[n*2187+507] = + s[183];
gout[n*2187+508] = + s[184];
gout[n*2187+509] = + s[185];
gout[n*2187+510] = + s[186];
gout[n*2187+511] = + s[187];
gout[n*2187+512] = + s[188];
gout[n*2187+513] = + s[891];
gout[n*2187+514] = + s[892];
gout[n*2187+515] = + s[893];
gout[n*2187+516] = + s[894];
gout[n*2187+517] = + s[895];
gout[n*2187+518] = + s[896];
gout[n*2187+519] = + s[897];
gout[n*2187+520] = + s[898];
gout[n*2187+521] = + s[899];
gout[n*2187+522] = + s[900];
gout[n*2187+523] = + s[901];
gout[n*2187+524] = + s[902];
gout[n*2187+525] = + s[903];
gout[n*2187+526] = + s[904];
gout[n*2187+527] = + s[905];
gout[n*2187+528] = + s[906];
gout[n*2187+529] = + s[907];
gout[n*2187+530] = + s[908];
gout[n*2187+531] = + s[909];
gout[n*2187+532] = + s[910];
gout[n*2187+533] = + s[911];
gout[n*2187+534] = + s[912];
gout[n*2187+535] = + s[913];
gout[n*2187+536] = + s[914];
gout[n*2187+537] = + s[915];
gout[n*2187+538] = + s[916];
gout[n*2187+539] = + s[917];
gout[n*2187+540] = + s[1620];
gout[n*2187+541] = + s[1621];
gout[n*2187+542] = + s[1622];
gout[n*2187+543] = + s[1623];
gout[n*2187+544] = + s[1624];
gout[n*2187+545] = + s[1625];
gout[n*2187+546] = + s[1626];
gout[n*2187+547] = + s[1627];
gout[n*2187+548] = + s[1628];
gout[n*2187+549] = + s[1629];
gout[n*2187+550] = + s[1630];
gout[n*2187+551] = + s[1631];
gout[n*2187+552] = + s[1632];
gout[n*2187+553] = + s[1633];
gout[n*2187+554] = + s[1634];
gout[n*2187+555] = + s[1635];
gout[n*2187+556] = + s[1636];
gout[n*2187+557] = + s[1637];
gout[n*2187+558] = + s[1638];
gout[n*2187+559] = + s[1639];
gout[n*2187+560] = + s[1640];
gout[n*2187+561] = + s[1641];
gout[n*2187+562] = + s[1642];
gout[n*2187+563] = + s[1643];
gout[n*2187+564] = + s[1644];
gout[n*2187+565] = + s[1645];
gout[n*2187+566] = + s[1646];
gout[n*2187+567] = + s[405];
gout[n*2187+568] = + s[406];
gout[n*2187+569] = + s[407];
gout[n*2187+570] = + s[408];
gout[n*2187+571] = + s[409];
gout[n*2187+572] = + s[410];
gout[n*2187+573] = + s[411];
gout[n*2187+574] = + s[412];
gout[n*2187+575] = + s[413];
gout[n*2187+576] = + s[414];
gout[n*2187+577] = + s[415];
gout[n*2187+578] = + s[416];
gout[n*2187+579] = + s[417];
gout[n*2187+580] = + s[418];
gout[n*2187+581] = + s[419];
gout[n*2187+582] = + s[420];
gout[n*2187+583] = + s[421];
gout[n*2187+584] = + s[422];
gout[n*2187+585] = + s[423];
gout[n*2187+586] = + s[424];
gout[n*2187+587] = + s[425];
gout[n*2187+588] = + s[426];
gout[n*2187+589] = + s[427];
gout[n*2187+590] = + s[428];
gout[n*2187+591] = + s[429];
gout[n*2187+592] = + s[430];
gout[n*2187+593] = + s[431];
gout[n*2187+594] = + s[1134];
gout[n*2187+595] = + s[1135];
gout[n*2187+596] = + s[1136];
gout[n*2187+597] = + s[1137];
gout[n*2187+598] = + s[1138];
gout[n*2187+599] = + s[1139];
gout[n*2187+600] = + s[1140];
gout[n*2187+601] = + s[1141];
gout[n*2187+602] = + s[1142];
gout[n*2187+603] = + s[1143];
gout[n*2187+604] = + s[1144];
gout[n*2187+605] = + s[1145];
gout[n*2187+606] = + s[1146];
gout[n*2187+607] = + s[1147];
gout[n*2187+608] = + s[1148];
gout[n*2187+609] = + s[1149];
gout[n*2187+610] = + s[1150];
gout[n*2187+611] = + s[1151];
gout[n*2187+612] = + s[1152];
gout[n*2187+613] = + s[1153];
gout[n*2187+614] = + s[1154];
gout[n*2187+615] = + s[1155];
gout[n*2187+616] = + s[1156];
gout[n*2187+617] = + s[1157];
gout[n*2187+618] = + s[1158];
gout[n*2187+619] = + s[1159];
gout[n*2187+620] = + s[1160];
gout[n*2187+621] = + s[1863];
gout[n*2187+622] = + s[1864];
gout[n*2187+623] = + s[1865];
gout[n*2187+624] = + s[1866];
gout[n*2187+625] = + s[1867];
gout[n*2187+626] = + s[1868];
gout[n*2187+627] = + s[1869];
gout[n*2187+628] = + s[1870];
gout[n*2187+629] = + s[1871];
gout[n*2187+630] = + s[1872];
gout[n*2187+631] = + s[1873];
gout[n*2187+632] = + s[1874];
gout[n*2187+633] = + s[1875];
gout[n*2187+634] = + s[1876];
gout[n*2187+635] = + s[1877];
gout[n*2187+636] = + s[1878];
gout[n*2187+637] = + s[1879];
gout[n*2187+638] = + s[1880];
gout[n*2187+639] = + s[1881];
gout[n*2187+640] = + s[1882];
gout[n*2187+641] = + s[1883];
gout[n*2187+642] = + s[1884];
gout[n*2187+643] = + s[1885];
gout[n*2187+644] = + s[1886];
gout[n*2187+645] = + s[1887];
gout[n*2187+646] = + s[1888];
gout[n*2187+647] = + s[1889];
gout[n*2187+648] = + s[648];
gout[n*2187+649] = + s[649];
gout[n*2187+650] = + s[650];
gout[n*2187+651] = + s[651];
gout[n*2187+652] = + s[652];
gout[n*2187+653] = + s[653];
gout[n*2187+654] = + s[654];
gout[n*2187+655] = + s[655];
gout[n*2187+656] = + s[656];
gout[n*2187+657] = + s[657];
gout[n*2187+658] = + s[658];
gout[n*2187+659] = + s[659];
gout[n*2187+660] = + s[660];
gout[n*2187+661] = + s[661];
gout[n*2187+662] = + s[662];
gout[n*2187+663] = + s[663];
gout[n*2187+664] = + s[664];
gout[n*2187+665] = + s[665];
gout[n*2187+666] = + s[666];
gout[n*2187+667] = + s[667];
gout[n*2187+668] = + s[668];
gout[n*2187+669] = + s[669];
gout[n*2187+670] = + s[670];
gout[n*2187+671] = + s[671];
gout[n*2187+672] = + s[672];
gout[n*2187+673] = + s[673];
gout[n*2187+674] = + s[674];
gout[n*2187+675] = + s[1377];
gout[n*2187+676] = + s[1378];
gout[n*2187+677] = + s[1379];
gout[n*2187+678] = + s[1380];
gout[n*2187+679] = + s[1381];
gout[n*2187+680] = + s[1382];
gout[n*2187+681] = + s[1383];
gout[n*2187+682] = + s[1384];
gout[n*2187+683] = + s[1385];
gout[n*2187+684] = + s[1386];
gout[n*2187+685] = + s[1387];
gout[n*2187+686] = + s[1388];
gout[n*2187+687] = + s[1389];
gout[n*2187+688] = + s[1390];
gout[n*2187+689] = + s[1391];
gout[n*2187+690] = + s[1392];
gout[n*2187+691] = + s[1393];
gout[n*2187+692] = + s[1394];
gout[n*2187+693] = + s[1395];
gout[n*2187+694] = + s[1396];
gout[n*2187+695] = + s[1397];
gout[n*2187+696] = + s[1398];
gout[n*2187+697] = + s[1399];
gout[n*2187+698] = + s[1400];
gout[n*2187+699] = + s[1401];
gout[n*2187+700] = + s[1402];
gout[n*2187+701] = + s[1403];
gout[n*2187+702] = + s[2106];
gout[n*2187+703] = + s[2107];
gout[n*2187+704] = + s[2108];
gout[n*2187+705] = + s[2109];
gout[n*2187+706] = + s[2110];
gout[n*2187+707] = + s[2111];
gout[n*2187+708] = + s[2112];
gout[n*2187+709] = + s[2113];
gout[n*2187+710] = + s[2114];
gout[n*2187+711] = + s[2115];
gout[n*2187+712] = + s[2116];
gout[n*2187+713] = + s[2117];
gout[n*2187+714] = + s[2118];
gout[n*2187+715] = + s[2119];
gout[n*2187+716] = + s[2120];
gout[n*2187+717] = + s[2121];
gout[n*2187+718] = + s[2122];
gout[n*2187+719] = + s[2123];
gout[n*2187+720] = + s[2124];
gout[n*2187+721] = + s[2125];
gout[n*2187+722] = + s[2126];
gout[n*2187+723] = + s[2127];
gout[n*2187+724] = + s[2128];
gout[n*2187+725] = + s[2129];
gout[n*2187+726] = + s[2130];
gout[n*2187+727] = + s[2131];
gout[n*2187+728] = + s[2132];
gout[n*2187+729] = + s[27];
gout[n*2187+730] = + s[28];
gout[n*2187+731] = + s[29];
gout[n*2187+732] = + s[30];
gout[n*2187+733] = + s[31];
gout[n*2187+734] = + s[32];
gout[n*2187+735] = + s[33];
gout[n*2187+736] = + s[34];
gout[n*2187+737] = + s[35];
gout[n*2187+738] = + s[36];
gout[n*2187+739] = + s[37];
gout[n*2187+740] = + s[38];
gout[n*2187+741] = + s[39];
gout[n*2187+742] = + s[40];
gout[n*2187+743] = + s[41];
gout[n*2187+744] = + s[42];
gout[n*2187+745] = + s[43];
gout[n*2187+746] = + s[44];
gout[n*2187+747] = + s[45];
gout[n*2187+748] = + s[46];
gout[n*2187+749] = + s[47];
gout[n*2187+750] = + s[48];
gout[n*2187+751] = + s[49];
gout[n*2187+752] = + s[50];
gout[n*2187+753] = + s[51];
gout[n*2187+754] = + s[52];
gout[n*2187+755] = + s[53];
gout[n*2187+756] = + s[756];
gout[n*2187+757] = + s[757];
gout[n*2187+758] = + s[758];
gout[n*2187+759] = + s[759];
gout[n*2187+760] = + s[760];
gout[n*2187+761] = + s[761];
gout[n*2187+762] = + s[762];
gout[n*2187+763] = + s[763];
gout[n*2187+764] = + s[764];
gout[n*2187+765] = + s[765];
gout[n*2187+766] = + s[766];
gout[n*2187+767] = + s[767];
gout[n*2187+768] = + s[768];
gout[n*2187+769] = + s[769];
gout[n*2187+770] = + s[770];
gout[n*2187+771] = + s[771];
gout[n*2187+772] = + s[772];
gout[n*2187+773] = + s[773];
gout[n*2187+774] = + s[774];
gout[n*2187+775] = + s[775];
gout[n*2187+776] = + s[776];
gout[n*2187+777] = + s[777];
gout[n*2187+778] = + s[778];
gout[n*2187+779] = + s[779];
gout[n*2187+780] = + s[780];
gout[n*2187+781] = + s[781];
gout[n*2187+782] = + s[782];
gout[n*2187+783] = + s[1485];
gout[n*2187+784] = + s[1486];
gout[n*2187+785] = + s[1487];
gout[n*2187+786] = + s[1488];
gout[n*2187+787] = + s[1489];
gout[n*2187+788] = + s[1490];
gout[n*2187+789] = + s[1491];
gout[n*2187+790] = + s[1492];
gout[n*2187+791] = + s[1493];
gout[n*2187+792] = + s[1494];
gout[n*2187+793] = + s[1495];
gout[n*2187+794] = + s[1496];
gout[n*2187+795] = + s[1497];
gout[n*2187+796] = + s[1498];
gout[n*2187+797] = + s[1499];
gout[n*2187+798] = + s[1500];
gout[n*2187+799] = + s[1501];
gout[n*2187+800] = + s[1502];
gout[n*2187+801] = + s[1503];
gout[n*2187+802] = + s[1504];
gout[n*2187+803] = + s[1505];
gout[n*2187+804] = + s[1506];
gout[n*2187+805] = + s[1507];
gout[n*2187+806] = + s[1508];
gout[n*2187+807] = + s[1509];
gout[n*2187+808] = + s[1510];
gout[n*2187+809] = + s[1511];
gout[n*2187+810] = + s[270];
gout[n*2187+811] = + s[271];
gout[n*2187+812] = + s[272];
gout[n*2187+813] = + s[273];
gout[n*2187+814] = + s[274];
gout[n*2187+815] = + s[275];
gout[n*2187+816] = + s[276];
gout[n*2187+817] = + s[277];
gout[n*2187+818] = + s[278];
gout[n*2187+819] = + s[279];
gout[n*2187+820] = + s[280];
gout[n*2187+821] = + s[281];
gout[n*2187+822] = + s[282];
gout[n*2187+823] = + s[283];
gout[n*2187+824] = + s[284];
gout[n*2187+825] = + s[285];
gout[n*2187+826] = + s[286];
gout[n*2187+827] = + s[287];
gout[n*2187+828] = + s[288];
gout[n*2187+829] = + s[289];
gout[n*2187+830] = + s[290];
gout[n*2187+831] = + s[291];
gout[n*2187+832] = + s[292];
gout[n*2187+833] = + s[293];
gout[n*2187+834] = + s[294];
gout[n*2187+835] = + s[295];
gout[n*2187+836] = + s[296];
gout[n*2187+837] = + s[999];
gout[n*2187+838] = + s[1000];
gout[n*2187+839] = + s[1001];
gout[n*2187+840] = + s[1002];
gout[n*2187+841] = + s[1003];
gout[n*2187+842] = + s[1004];
gout[n*2187+843] = + s[1005];
gout[n*2187+844] = + s[1006];
gout[n*2187+845] = + s[1007];
gout[n*2187+846] = + s[1008];
gout[n*2187+847] = + s[1009];
gout[n*2187+848] = + s[1010];
gout[n*2187+849] = + s[1011];
gout[n*2187+850] = + s[1012];
gout[n*2187+851] = + s[1013];
gout[n*2187+852] = + s[1014];
gout[n*2187+853] = + s[1015];
gout[n*2187+854] = + s[1016];
gout[n*2187+855] = + s[1017];
gout[n*2187+856] = + s[1018];
gout[n*2187+857] = + s[1019];
gout[n*2187+858] = + s[1020];
gout[n*2187+859] = + s[1021];
gout[n*2187+860] = + s[1022];
gout[n*2187+861] = + s[1023];
gout[n*2187+862] = + s[1024];
gout[n*2187+863] = + s[1025];
gout[n*2187+864] = + s[1728];
gout[n*2187+865] = + s[1729];
gout[n*2187+866] = + s[1730];
gout[n*2187+867] = + s[1731];
gout[n*2187+868] = + s[1732];
gout[n*2187+869] = + s[1733];
gout[n*2187+870] = + s[1734];
gout[n*2187+871] = + s[1735];
gout[n*2187+872] = + s[1736];
gout[n*2187+873] = + s[1737];
gout[n*2187+874] = + s[1738];
gout[n*2187+875] = + s[1739];
gout[n*2187+876] = + s[1740];
gout[n*2187+877] = + s[1741];
gout[n*2187+878] = + s[1742];
gout[n*2187+879] = + s[1743];
gout[n*2187+880] = + s[1744];
gout[n*2187+881] = + s[1745];
gout[n*2187+882] = + s[1746];
gout[n*2187+883] = + s[1747];
gout[n*2187+884] = + s[1748];
gout[n*2187+885] = + s[1749];
gout[n*2187+886] = + s[1750];
gout[n*2187+887] = + s[1751];
gout[n*2187+888] = + s[1752];
gout[n*2187+889] = + s[1753];
gout[n*2187+890] = + s[1754];
gout[n*2187+891] = + s[513];
gout[n*2187+892] = + s[514];
gout[n*2187+893] = + s[515];
gout[n*2187+894] = + s[516];
gout[n*2187+895] = + s[517];
gout[n*2187+896] = + s[518];
gout[n*2187+897] = + s[519];
gout[n*2187+898] = + s[520];
gout[n*2187+899] = + s[521];
gout[n*2187+900] = + s[522];
gout[n*2187+901] = + s[523];
gout[n*2187+902] = + s[524];
gout[n*2187+903] = + s[525];
gout[n*2187+904] = + s[526];
gout[n*2187+905] = + s[527];
gout[n*2187+906] = + s[528];
gout[n*2187+907] = + s[529];
gout[n*2187+908] = + s[530];
gout[n*2187+909] = + s[531];
gout[n*2187+910] = + s[532];
gout[n*2187+911] = + s[533];
gout[n*2187+912] = + s[534];
gout[n*2187+913] = + s[535];
gout[n*2187+914] = + s[536];
gout[n*2187+915] = + s[537];
gout[n*2187+916] = + s[538];
gout[n*2187+917] = + s[539];
gout[n*2187+918] = + s[1242];
gout[n*2187+919] = + s[1243];
gout[n*2187+920] = + s[1244];
gout[n*2187+921] = + s[1245];
gout[n*2187+922] = + s[1246];
gout[n*2187+923] = + s[1247];
gout[n*2187+924] = + s[1248];
gout[n*2187+925] = + s[1249];
gout[n*2187+926] = + s[1250];
gout[n*2187+927] = + s[1251];
gout[n*2187+928] = + s[1252];
gout[n*2187+929] = + s[1253];
gout[n*2187+930] = + s[1254];
gout[n*2187+931] = + s[1255];
gout[n*2187+932] = + s[1256];
gout[n*2187+933] = + s[1257];
gout[n*2187+934] = + s[1258];
gout[n*2187+935] = + s[1259];
gout[n*2187+936] = + s[1260];
gout[n*2187+937] = + s[1261];
gout[n*2187+938] = + s[1262];
gout[n*2187+939] = + s[1263];
gout[n*2187+940] = + s[1264];
gout[n*2187+941] = + s[1265];
gout[n*2187+942] = + s[1266];
gout[n*2187+943] = + s[1267];
gout[n*2187+944] = + s[1268];
gout[n*2187+945] = + s[1971];
gout[n*2187+946] = + s[1972];
gout[n*2187+947] = + s[1973];
gout[n*2187+948] = + s[1974];
gout[n*2187+949] = + s[1975];
gout[n*2187+950] = + s[1976];
gout[n*2187+951] = + s[1977];
gout[n*2187+952] = + s[1978];
gout[n*2187+953] = + s[1979];
gout[n*2187+954] = + s[1980];
gout[n*2187+955] = + s[1981];
gout[n*2187+956] = + s[1982];
gout[n*2187+957] = + s[1983];
gout[n*2187+958] = + s[1984];
gout[n*2187+959] = + s[1985];
gout[n*2187+960] = + s[1986];
gout[n*2187+961] = + s[1987];
gout[n*2187+962] = + s[1988];
gout[n*2187+963] = + s[1989];
gout[n*2187+964] = + s[1990];
gout[n*2187+965] = + s[1991];
gout[n*2187+966] = + s[1992];
gout[n*2187+967] = + s[1993];
gout[n*2187+968] = + s[1994];
gout[n*2187+969] = + s[1995];
gout[n*2187+970] = + s[1996];
gout[n*2187+971] = + s[1997];
gout[n*2187+972] = + s[108];
gout[n*2187+973] = + s[109];
gout[n*2187+974] = + s[110];
gout[n*2187+975] = + s[111];
gout[n*2187+976] = + s[112];
gout[n*2187+977] = + s[113];
gout[n*2187+978] = + s[114];
gout[n*2187+979] = + s[115];
gout[n*2187+980] = + s[116];
gout[n*2187+981] = + s[117];
gout[n*2187+982] = + s[118];
gout[n*2187+983] = + s[119];
gout[n*2187+984] = + s[120];
gout[n*2187+985] = + s[121];
gout[n*2187+986] = + s[122];
gout[n*2187+987] = + s[123];
gout[n*2187+988] = + s[124];
gout[n*2187+989] = + s[125];
gout[n*2187+990] = + s[126];
gout[n*2187+991] = + s[127];
gout[n*2187+992] = + s[128];
gout[n*2187+993] = + s[129];
gout[n*2187+994] = + s[130];
gout[n*2187+995] = + s[131];
gout[n*2187+996] = + s[132];
gout[n*2187+997] = + s[133];
gout[n*2187+998] = + s[134];
gout[n*2187+999] = + s[837];
gout[n*2187+1000] = + s[838];
gout[n*2187+1001] = + s[839];
gout[n*2187+1002] = + s[840];
gout[n*2187+1003] = + s[841];
gout[n*2187+1004] = + s[842];
gout[n*2187+1005] = + s[843];
gout[n*2187+1006] = + s[844];
gout[n*2187+1007] = + s[845];
gout[n*2187+1008] = + s[846];
gout[n*2187+1009] = + s[847];
gout[n*2187+1010] = + s[848];
gout[n*2187+1011] = + s[849];
gout[n*2187+1012] = + s[850];
gout[n*2187+1013] = + s[851];
gout[n*2187+1014] = + s[852];
gout[n*2187+1015] = + s[853];
gout[n*2187+1016] = + s[854];
gout[n*2187+1017] = + s[855];
gout[n*2187+1018] = + s[856];
gout[n*2187+1019] = + s[857];
gout[n*2187+1020] = + s[858];
gout[n*2187+1021] = + s[859];
gout[n*2187+1022] = + s[860];
gout[n*2187+1023] = + s[861];
gout[n*2187+1024] = + s[862];
gout[n*2187+1025] = + s[863];
gout[n*2187+1026] = + s[1566];
gout[n*2187+1027] = + s[1567];
gout[n*2187+1028] = + s[1568];
gout[n*2187+1029] = + s[1569];
gout[n*2187+1030] = + s[1570];
gout[n*2187+1031] = + s[1571];
gout[n*2187+1032] = + s[1572];
gout[n*2187+1033] = + s[1573];
gout[n*2187+1034] = + s[1574];
gout[n*2187+1035] = + s[1575];
gout[n*2187+1036] = + s[1576];
gout[n*2187+1037] = + s[1577];
gout[n*2187+1038] = + s[1578];
gout[n*2187+1039] = + s[1579];
gout[n*2187+1040] = + s[1580];
gout[n*2187+1041] = + s[1581];
gout[n*2187+1042] = + s[1582];
gout[n*2187+1043] = + s[1583];
gout[n*2187+1044] = + s[1584];
gout[n*2187+1045] = + s[1585];
gout[n*2187+1046] = + s[1586];
gout[n*2187+1047] = + s[1587];
gout[n*2187+1048] = + s[1588];
gout[n*2187+1049] = + s[1589];
gout[n*2187+1050] = + s[1590];
gout[n*2187+1051] = + s[1591];
gout[n*2187+1052] = + s[1592];
gout[n*2187+1053] = + s[351];
gout[n*2187+1054] = + s[352];
gout[n*2187+1055] = + s[353];
gout[n*2187+1056] = + s[354];
gout[n*2187+1057] = + s[355];
gout[n*2187+1058] = + s[356];
gout[n*2187+1059] = + s[357];
gout[n*2187+1060] = + s[358];
gout[n*2187+1061] = + s[359];
gout[n*2187+1062] = + s[360];
gout[n*2187+1063] = + s[361];
gout[n*2187+1064] = + s[362];
gout[n*2187+1065] = + s[363];
gout[n*2187+1066] = + s[364];
gout[n*2187+1067] = + s[365];
gout[n*2187+1068] = + s[366];
gout[n*2187+1069] = + s[367];
gout[n*2187+1070] = + s[368];
gout[n*2187+1071] = + s[369];
gout[n*2187+1072] = + s[370];
gout[n*2187+1073] = + s[371];
gout[n*2187+1074] = + s[372];
gout[n*2187+1075] = + s[373];
gout[n*2187+1076] = + s[374];
gout[n*2187+1077] = + s[375];
gout[n*2187+1078] = + s[376];
gout[n*2187+1079] = + s[377];
gout[n*2187+1080] = + s[1080];
gout[n*2187+1081] = + s[1081];
gout[n*2187+1082] = + s[1082];
gout[n*2187+1083] = + s[1083];
gout[n*2187+1084] = + s[1084];
gout[n*2187+1085] = + s[1085];
gout[n*2187+1086] = + s[1086];
gout[n*2187+1087] = + s[1087];
gout[n*2187+1088] = + s[1088];
gout[n*2187+1089] = + s[1089];
gout[n*2187+1090] = + s[1090];
gout[n*2187+1091] = + s[1091];
gout[n*2187+1092] = + s[1092];
gout[n*2187+1093] = + s[1093];
gout[n*2187+1094] = + s[1094];
gout[n*2187+1095] = + s[1095];
gout[n*2187+1096] = + s[1096];
gout[n*2187+1097] = + s[1097];
gout[n*2187+1098] = + s[1098];
gout[n*2187+1099] = + s[1099];
gout[n*2187+1100] = + s[1100];
gout[n*2187+1101] = + s[1101];
gout[n*2187+1102] = + s[1102];
gout[n*2187+1103] = + s[1103];
gout[n*2187+1104] = + s[1104];
gout[n*2187+1105] = + s[1105];
gout[n*2187+1106] = + s[1106];
gout[n*2187+1107] = + s[1809];
gout[n*2187+1108] = + s[1810];
gout[n*2187+1109] = + s[1811];
gout[n*2187+1110] = + s[1812];
gout[n*2187+1111] = + s[1813];
gout[n*2187+1112] = + s[1814];
gout[n*2187+1113] = + s[1815];
gout[n*2187+1114] = + s[1816];
gout[n*2187+1115] = + s[1817];
gout[n*2187+1116] = + s[1818];
gout[n*2187+1117] = + s[1819];
gout[n*2187+1118] = + s[1820];
gout[n*2187+1119] = + s[1821];
gout[n*2187+1120] = + s[1822];
gout[n*2187+1121] = + s[1823];
gout[n*2187+1122] = + s[1824];
gout[n*2187+1123] = + s[1825];
gout[n*2187+1124] = + s[1826];
gout[n*2187+1125] = + s[1827];
gout[n*2187+1126] = + s[1828];
gout[n*2187+1127] = + s[1829];
gout[n*2187+1128] = + s[1830];
gout[n*2187+1129] = + s[1831];
gout[n*2187+1130] = + s[1832];
gout[n*2187+1131] = + s[1833];
gout[n*2187+1132] = + s[1834];
gout[n*2187+1133] = + s[1835];
gout[n*2187+1134] = + s[594];
gout[n*2187+1135] = + s[595];
gout[n*2187+1136] = + s[596];
gout[n*2187+1137] = + s[597];
gout[n*2187+1138] = + s[598];
gout[n*2187+1139] = + s[599];
gout[n*2187+1140] = + s[600];
gout[n*2187+1141] = + s[601];
gout[n*2187+1142] = + s[602];
gout[n*2187+1143] = + s[603];
gout[n*2187+1144] = + s[604];
gout[n*2187+1145] = + s[605];
gout[n*2187+1146] = + s[606];
gout[n*2187+1147] = + s[607];
gout[n*2187+1148] = + s[608];
gout[n*2187+1149] = + s[609];
gout[n*2187+1150] = + s[610];
gout[n*2187+1151] = + s[611];
gout[n*2187+1152] = + s[612];
gout[n*2187+1153] = + s[613];
gout[n*2187+1154] = + s[614];
gout[n*2187+1155] = + s[615];
gout[n*2187+1156] = + s[616];
gout[n*2187+1157] = + s[617];
gout[n*2187+1158] = + s[618];
gout[n*2187+1159] = + s[619];
gout[n*2187+1160] = + s[620];
gout[n*2187+1161] = + s[1323];
gout[n*2187+1162] = + s[1324];
gout[n*2187+1163] = + s[1325];
gout[n*2187+1164] = + s[1326];
gout[n*2187+1165] = + s[1327];
gout[n*2187+1166] = + s[1328];
gout[n*2187+1167] = + s[1329];
gout[n*2187+1168] = + s[1330];
gout[n*2187+1169] = + s[1331];
gout[n*2187+1170] = + s[1332];
gout[n*2187+1171] = + s[1333];
gout[n*2187+1172] = + s[1334];
gout[n*2187+1173] = + s[1335];
gout[n*2187+1174] = + s[1336];
gout[n*2187+1175] = + s[1337];
gout[n*2187+1176] = + s[1338];
gout[n*2187+1177] = + s[1339];
gout[n*2187+1178] = + s[1340];
gout[n*2187+1179] = + s[1341];
gout[n*2187+1180] = + s[1342];
gout[n*2187+1181] = + s[1343];
gout[n*2187+1182] = + s[1344];
gout[n*2187+1183] = + s[1345];
gout[n*2187+1184] = + s[1346];
gout[n*2187+1185] = + s[1347];
gout[n*2187+1186] = + s[1348];
gout[n*2187+1187] = + s[1349];
gout[n*2187+1188] = + s[2052];
gout[n*2187+1189] = + s[2053];
gout[n*2187+1190] = + s[2054];
gout[n*2187+1191] = + s[2055];
gout[n*2187+1192] = + s[2056];
gout[n*2187+1193] = + s[2057];
gout[n*2187+1194] = + s[2058];
gout[n*2187+1195] = + s[2059];
gout[n*2187+1196] = + s[2060];
gout[n*2187+1197] = + s[2061];
gout[n*2187+1198] = + s[2062];
gout[n*2187+1199] = + s[2063];
gout[n*2187+1200] = + s[2064];
gout[n*2187+1201] = + s[2065];
gout[n*2187+1202] = + s[2066];
gout[n*2187+1203] = + s[2067];
gout[n*2187+1204] = + s[2068];
gout[n*2187+1205] = + s[2069];
gout[n*2187+1206] = + s[2070];
gout[n*2187+1207] = + s[2071];
gout[n*2187+1208] = + s[2072];
gout[n*2187+1209] = + s[2073];
gout[n*2187+1210] = + s[2074];
gout[n*2187+1211] = + s[2075];
gout[n*2187+1212] = + s[2076];
gout[n*2187+1213] = + s[2077];
gout[n*2187+1214] = + s[2078];
gout[n*2187+1215] = + s[189];
gout[n*2187+1216] = + s[190];
gout[n*2187+1217] = + s[191];
gout[n*2187+1218] = + s[192];
gout[n*2187+1219] = + s[193];
gout[n*2187+1220] = + s[194];
gout[n*2187+1221] = + s[195];
gout[n*2187+1222] = + s[196];
gout[n*2187+1223] = + s[197];
gout[n*2187+1224] = + s[198];
gout[n*2187+1225] = + s[199];
gout[n*2187+1226] = + s[200];
gout[n*2187+1227] = + s[201];
gout[n*2187+1228] = + s[202];
gout[n*2187+1229] = + s[203];
gout[n*2187+1230] = + s[204];
gout[n*2187+1231] = + s[205];
gout[n*2187+1232] = + s[206];
gout[n*2187+1233] = + s[207];
gout[n*2187+1234] = + s[208];
gout[n*2187+1235] = + s[209];
gout[n*2187+1236] = + s[210];
gout[n*2187+1237] = + s[211];
gout[n*2187+1238] = + s[212];
gout[n*2187+1239] = + s[213];
gout[n*2187+1240] = + s[214];
gout[n*2187+1241] = + s[215];
gout[n*2187+1242] = + s[918];
gout[n*2187+1243] = + s[919];
gout[n*2187+1244] = + s[920];
gout[n*2187+1245] = + s[921];
gout[n*2187+1246] = + s[922];
gout[n*2187+1247] = + s[923];
gout[n*2187+1248] = + s[924];
gout[n*2187+1249] = + s[925];
gout[n*2187+1250] = + s[926];
gout[n*2187+1251] = + s[927];
gout[n*2187+1252] = + s[928];
gout[n*2187+1253] = + s[929];
gout[n*2187+1254] = + s[930];
gout[n*2187+1255] = + s[931];
gout[n*2187+1256] = + s[932];
gout[n*2187+1257] = + s[933];
gout[n*2187+1258] = + s[934];
gout[n*2187+1259] = + s[935];
gout[n*2187+1260] = + s[936];
gout[n*2187+1261] = + s[937];
gout[n*2187+1262] = + s[938];
gout[n*2187+1263] = + s[939];
gout[n*2187+1264] = + s[940];
gout[n*2187+1265] = + s[941];
gout[n*2187+1266] = + s[942];
gout[n*2187+1267] = + s[943];
gout[n*2187+1268] = + s[944];
gout[n*2187+1269] = + s[1647];
gout[n*2187+1270] = + s[1648];
gout[n*2187+1271] = + s[1649];
gout[n*2187+1272] = + s[1650];
gout[n*2187+1273] = + s[1651];
gout[n*2187+1274] = + s[1652];
gout[n*2187+1275] = + s[1653];
gout[n*2187+1276] = + s[1654];
gout[n*2187+1277] = + s[1655];
gout[n*2187+1278] = + s[1656];
gout[n*2187+1279] = + s[1657];
gout[n*2187+1280] = + s[1658];
gout[n*2187+1281] = + s[1659];
gout[n*2187+1282] = + s[1660];
gout[n*2187+1283] = + s[1661];
gout[n*2187+1284] = + s[1662];
gout[n*2187+1285] = + s[1663];
gout[n*2187+1286] = + s[1664];
gout[n*2187+1287] = + s[1665];
gout[n*2187+1288] = + s[1666];
gout[n*2187+1289] = + s[1667];
gout[n*2187+1290] = + s[1668];
gout[n*2187+1291] = + s[1669];
gout[n*2187+1292] = + s[1670];
gout[n*2187+1293] = + s[1671];
gout[n*2187+1294] = + s[1672];
gout[n*2187+1295] = + s[1673];
gout[n*2187+1296] = + s[432];
gout[n*2187+1297] = + s[433];
gout[n*2187+1298] = + s[434];
gout[n*2187+1299] = + s[435];
gout[n*2187+1300] = + s[436];
gout[n*2187+1301] = + s[437];
gout[n*2187+1302] = + s[438];
gout[n*2187+1303] = + s[439];
gout[n*2187+1304] = + s[440];
gout[n*2187+1305] = + s[441];
gout[n*2187+1306] = + s[442];
gout[n*2187+1307] = + s[443];
gout[n*2187+1308] = + s[444];
gout[n*2187+1309] = + s[445];
gout[n*2187+1310] = + s[446];
gout[n*2187+1311] = + s[447];
gout[n*2187+1312] = + s[448];
gout[n*2187+1313] = + s[449];
gout[n*2187+1314] = + s[450];
gout[n*2187+1315] = + s[451];
gout[n*2187+1316] = + s[452];
gout[n*2187+1317] = + s[453];
gout[n*2187+1318] = + s[454];
gout[n*2187+1319] = + s[455];
gout[n*2187+1320] = + s[456];
gout[n*2187+1321] = + s[457];
gout[n*2187+1322] = + s[458];
gout[n*2187+1323] = + s[1161];
gout[n*2187+1324] = + s[1162];
gout[n*2187+1325] = + s[1163];
gout[n*2187+1326] = + s[1164];
gout[n*2187+1327] = + s[1165];
gout[n*2187+1328] = + s[1166];
gout[n*2187+1329] = + s[1167];
gout[n*2187+1330] = + s[1168];
gout[n*2187+1331] = + s[1169];
gout[n*2187+1332] = + s[1170];
gout[n*2187+1333] = + s[1171];
gout[n*2187+1334] = + s[1172];
gout[n*2187+1335] = + s[1173];
gout[n*2187+1336] = + s[1174];
gout[n*2187+1337] = + s[1175];
gout[n*2187+1338] = + s[1176];
gout[n*2187+1339] = + s[1177];
gout[n*2187+1340] = + s[1178];
gout[n*2187+1341] = + s[1179];
gout[n*2187+1342] = + s[1180];
gout[n*2187+1343] = + s[1181];
gout[n*2187+1344] = + s[1182];
gout[n*2187+1345] = + s[1183];
gout[n*2187+1346] = + s[1184];
gout[n*2187+1347] = + s[1185];
gout[n*2187+1348] = + s[1186];
gout[n*2187+1349] = + s[1187];
gout[n*2187+1350] = + s[1890];
gout[n*2187+1351] = + s[1891];
gout[n*2187+1352] = + s[1892];
gout[n*2187+1353] = + s[1893];
gout[n*2187+1354] = + s[1894];
gout[n*2187+1355] = + s[1895];
gout[n*2187+1356] = + s[1896];
gout[n*2187+1357] = + s[1897];
gout[n*2187+1358] = + s[1898];
gout[n*2187+1359] = + s[1899];
gout[n*2187+1360] = + s[1900];
gout[n*2187+1361] = + s[1901];
gout[n*2187+1362] = + s[1902];
gout[n*2187+1363] = + s[1903];
gout[n*2187+1364] = + s[1904];
gout[n*2187+1365] = + s[1905];
gout[n*2187+1366] = + s[1906];
gout[n*2187+1367] = + s[1907];
gout[n*2187+1368] = + s[1908];
gout[n*2187+1369] = + s[1909];
gout[n*2187+1370] = + s[1910];
gout[n*2187+1371] = + s[1911];
gout[n*2187+1372] = + s[1912];
gout[n*2187+1373] = + s[1913];
gout[n*2187+1374] = + s[1914];
gout[n*2187+1375] = + s[1915];
gout[n*2187+1376] = + s[1916];
gout[n*2187+1377] = + s[675];
gout[n*2187+1378] = + s[676];
gout[n*2187+1379] = + s[677];
gout[n*2187+1380] = + s[678];
gout[n*2187+1381] = + s[679];
gout[n*2187+1382] = + s[680];
gout[n*2187+1383] = + s[681];
gout[n*2187+1384] = + s[682];
gout[n*2187+1385] = + s[683];
gout[n*2187+1386] = + s[684];
gout[n*2187+1387] = + s[685];
gout[n*2187+1388] = + s[686];
gout[n*2187+1389] = + s[687];
gout[n*2187+1390] = + s[688];
gout[n*2187+1391] = + s[689];
gout[n*2187+1392] = + s[690];
gout[n*2187+1393] = + s[691];
gout[n*2187+1394] = + s[692];
gout[n*2187+1395] = + s[693];
gout[n*2187+1396] = + s[694];
gout[n*2187+1397] = + s[695];
gout[n*2187+1398] = + s[696];
gout[n*2187+1399] = + s[697];
gout[n*2187+1400] = + s[698];
gout[n*2187+1401] = + s[699];
gout[n*2187+1402] = + s[700];
gout[n*2187+1403] = + s[701];
gout[n*2187+1404] = + s[1404];
gout[n*2187+1405] = + s[1405];
gout[n*2187+1406] = + s[1406];
gout[n*2187+1407] = + s[1407];
gout[n*2187+1408] = + s[1408];
gout[n*2187+1409] = + s[1409];
gout[n*2187+1410] = + s[1410];
gout[n*2187+1411] = + s[1411];
gout[n*2187+1412] = + s[1412];
gout[n*2187+1413] = + s[1413];
gout[n*2187+1414] = + s[1414];
gout[n*2187+1415] = + s[1415];
gout[n*2187+1416] = + s[1416];
gout[n*2187+1417] = + s[1417];
gout[n*2187+1418] = + s[1418];
gout[n*2187+1419] = + s[1419];
gout[n*2187+1420] = + s[1420];
gout[n*2187+1421] = + s[1421];
gout[n*2187+1422] = + s[1422];
gout[n*2187+1423] = + s[1423];
gout[n*2187+1424] = + s[1424];
gout[n*2187+1425] = + s[1425];
gout[n*2187+1426] = + s[1426];
gout[n*2187+1427] = + s[1427];
gout[n*2187+1428] = + s[1428];
gout[n*2187+1429] = + s[1429];
gout[n*2187+1430] = + s[1430];
gout[n*2187+1431] = + s[2133];
gout[n*2187+1432] = + s[2134];
gout[n*2187+1433] = + s[2135];
gout[n*2187+1434] = + s[2136];
gout[n*2187+1435] = + s[2137];
gout[n*2187+1436] = + s[2138];
gout[n*2187+1437] = + s[2139];
gout[n*2187+1438] = + s[2140];
gout[n*2187+1439] = + s[2141];
gout[n*2187+1440] = + s[2142];
gout[n*2187+1441] = + s[2143];
gout[n*2187+1442] = + s[2144];
gout[n*2187+1443] = + s[2145];
gout[n*2187+1444] = + s[2146];
gout[n*2187+1445] = + s[2147];
gout[n*2187+1446] = + s[2148];
gout[n*2187+1447] = + s[2149];
gout[n*2187+1448] = + s[2150];
gout[n*2187+1449] = + s[2151];
gout[n*2187+1450] = + s[2152];
gout[n*2187+1451] = + s[2153];
gout[n*2187+1452] = + s[2154];
gout[n*2187+1453] = + s[2155];
gout[n*2187+1454] = + s[2156];
gout[n*2187+1455] = + s[2157];
gout[n*2187+1456] = + s[2158];
gout[n*2187+1457] = + s[2159];
gout[n*2187+1458] = + s[54];
gout[n*2187+1459] = + s[55];
gout[n*2187+1460] = + s[56];
gout[n*2187+1461] = + s[57];
gout[n*2187+1462] = + s[58];
gout[n*2187+1463] = + s[59];
gout[n*2187+1464] = + s[60];
gout[n*2187+1465] = + s[61];
gout[n*2187+1466] = + s[62];
gout[n*2187+1467] = + s[63];
gout[n*2187+1468] = + s[64];
gout[n*2187+1469] = + s[65];
gout[n*2187+1470] = + s[66];
gout[n*2187+1471] = + s[67];
gout[n*2187+1472] = + s[68];
gout[n*2187+1473] = + s[69];
gout[n*2187+1474] = + s[70];
gout[n*2187+1475] = + s[71];
gout[n*2187+1476] = + s[72];
gout[n*2187+1477] = + s[73];
gout[n*2187+1478] = + s[74];
gout[n*2187+1479] = + s[75];
gout[n*2187+1480] = + s[76];
gout[n*2187+1481] = + s[77];
gout[n*2187+1482] = + s[78];
gout[n*2187+1483] = + s[79];
gout[n*2187+1484] = + s[80];
gout[n*2187+1485] = + s[783];
gout[n*2187+1486] = + s[784];
gout[n*2187+1487] = + s[785];
gout[n*2187+1488] = + s[786];
gout[n*2187+1489] = + s[787];
gout[n*2187+1490] = + s[788];
gout[n*2187+1491] = + s[789];
gout[n*2187+1492] = + s[790];
gout[n*2187+1493] = + s[791];
gout[n*2187+1494] = + s[792];
gout[n*2187+1495] = + s[793];
gout[n*2187+1496] = + s[794];
gout[n*2187+1497] = + s[795];
gout[n*2187+1498] = + s[796];
gout[n*2187+1499] = + s[797];
gout[n*2187+1500] = + s[798];
gout[n*2187+1501] = + s[799];
gout[n*2187+1502] = + s[800];
gout[n*2187+1503] = + s[801];
gout[n*2187+1504] = + s[802];
gout[n*2187+1505] = + s[803];
gout[n*2187+1506] = + s[804];
gout[n*2187+1507] = + s[805];
gout[n*2187+1508] = + s[806];
gout[n*2187+1509] = + s[807];
gout[n*2187+1510] = + s[808];
gout[n*2187+1511] = + s[809];
gout[n*2187+1512] = + s[1512];
gout[n*2187+1513] = + s[1513];
gout[n*2187+1514] = + s[1514];
gout[n*2187+1515] = + s[1515];
gout[n*2187+1516] = + s[1516];
gout[n*2187+1517] = + s[1517];
gout[n*2187+1518] = + s[1518];
gout[n*2187+1519] = + s[1519];
gout[n*2187+1520] = + s[1520];
gout[n*2187+1521] = + s[1521];
gout[n*2187+1522] = + s[1522];
gout[n*2187+1523] = + s[1523];
gout[n*2187+1524] = + s[1524];
gout[n*2187+1525] = + s[1525];
gout[n*2187+1526] = + s[1526];
gout[n*2187+1527] = + s[1527];
gout[n*2187+1528] = + s[1528];
gout[n*2187+1529] = + s[1529];
gout[n*2187+1530] = + s[1530];
gout[n*2187+1531] = + s[1531];
gout[n*2187+1532] = + s[1532];
gout[n*2187+1533] = + s[1533];
gout[n*2187+1534] = + s[1534];
gout[n*2187+1535] = + s[1535];
gout[n*2187+1536] = + s[1536];
gout[n*2187+1537] = + s[1537];
gout[n*2187+1538] = + s[1538];
gout[n*2187+1539] = + s[297];
gout[n*2187+1540] = + s[298];
gout[n*2187+1541] = + s[299];
gout[n*2187+1542] = + s[300];
gout[n*2187+1543] = + s[301];
gout[n*2187+1544] = + s[302];
gout[n*2187+1545] = + s[303];
gout[n*2187+1546] = + s[304];
gout[n*2187+1547] = + s[305];
gout[n*2187+1548] = + s[306];
gout[n*2187+1549] = + s[307];
gout[n*2187+1550] = + s[308];
gout[n*2187+1551] = + s[309];
gout[n*2187+1552] = + s[310];
gout[n*2187+1553] = + s[311];
gout[n*2187+1554] = + s[312];
gout[n*2187+1555] = + s[313];
gout[n*2187+1556] = + s[314];
gout[n*2187+1557] = + s[315];
gout[n*2187+1558] = + s[316];
gout[n*2187+1559] = + s[317];
gout[n*2187+1560] = + s[318];
gout[n*2187+1561] = + s[319];
gout[n*2187+1562] = + s[320];
gout[n*2187+1563] = + s[321];
gout[n*2187+1564] = + s[322];
gout[n*2187+1565] = + s[323];
gout[n*2187+1566] = + s[1026];
gout[n*2187+1567] = + s[1027];
gout[n*2187+1568] = + s[1028];
gout[n*2187+1569] = + s[1029];
gout[n*2187+1570] = + s[1030];
gout[n*2187+1571] = + s[1031];
gout[n*2187+1572] = + s[1032];
gout[n*2187+1573] = + s[1033];
gout[n*2187+1574] = + s[1034];
gout[n*2187+1575] = + s[1035];
gout[n*2187+1576] = + s[1036];
gout[n*2187+1577] = + s[1037];
gout[n*2187+1578] = + s[1038];
gout[n*2187+1579] = + s[1039];
gout[n*2187+1580] = + s[1040];
gout[n*2187+1581] = + s[1041];
gout[n*2187+1582] = + s[1042];
gout[n*2187+1583] = + s[1043];
gout[n*2187+1584] = + s[1044];
gout[n*2187+1585] = + s[1045];
gout[n*2187+1586] = + s[1046];
gout[n*2187+1587] = + s[1047];
gout[n*2187+1588] = + s[1048];
gout[n*2187+1589] = + s[1049];
gout[n*2187+1590] = + s[1050];
gout[n*2187+1591] = + s[1051];
gout[n*2187+1592] = + s[1052];
gout[n*2187+1593] = + s[1755];
gout[n*2187+1594] = + s[1756];
gout[n*2187+1595] = + s[1757];
gout[n*2187+1596] = + s[1758];
gout[n*2187+1597] = + s[1759];
gout[n*2187+1598] = + s[1760];
gout[n*2187+1599] = + s[1761];
gout[n*2187+1600] = + s[1762];
gout[n*2187+1601] = + s[1763];
gout[n*2187+1602] = + s[1764];
gout[n*2187+1603] = + s[1765];
gout[n*2187+1604] = + s[1766];
gout[n*2187+1605] = + s[1767];
gout[n*2187+1606] = + s[1768];
gout[n*2187+1607] = + s[1769];
gout[n*2187+1608] = + s[1770];
gout[n*2187+1609] = + s[1771];
gout[n*2187+1610] = + s[1772];
gout[n*2187+1611] = + s[1773];
gout[n*2187+1612] = + s[1774];
gout[n*2187+1613] = + s[1775];
gout[n*2187+1614] = + s[1776];
gout[n*2187+1615] = + s[1777];
gout[n*2187+1616] = + s[1778];
gout[n*2187+1617] = + s[1779];
gout[n*2187+1618] = + s[1780];
gout[n*2187+1619] = + s[1781];
gout[n*2187+1620] = + s[540];
gout[n*2187+1621] = + s[541];
gout[n*2187+1622] = + s[542];
gout[n*2187+1623] = + s[543];
gout[n*2187+1624] = + s[544];
gout[n*2187+1625] = + s[545];
gout[n*2187+1626] = + s[546];
gout[n*2187+1627] = + s[547];
gout[n*2187+1628] = + s[548];
gout[n*2187+1629] = + s[549];
gout[n*2187+1630] = + s[550];
gout[n*2187+1631] = + s[551];
gout[n*2187+1632] = + s[552];
gout[n*2187+1633] = + s[553];
gout[n*2187+1634] = + s[554];
gout[n*2187+1635] = + s[555];
gout[n*2187+1636] = + s[556];
gout[n*2187+1637] = + s[557];
gout[n*2187+1638] = + s[558];
gout[n*2187+1639] = + s[559];
gout[n*2187+1640] = + s[560];
gout[n*2187+1641] = + s[561];
gout[n*2187+1642] = + s[562];
gout[n*2187+1643] = + s[563];
gout[n*2187+1644] = + s[564];
gout[n*2187+1645] = + s[565];
gout[n*2187+1646] = + s[566];
gout[n*2187+1647] = + s[1269];
gout[n*2187+1648] = + s[1270];
gout[n*2187+1649] = + s[1271];
gout[n*2187+1650] = + s[1272];
gout[n*2187+1651] = + s[1273];
gout[n*2187+1652] = + s[1274];
gout[n*2187+1653] = + s[1275];
gout[n*2187+1654] = + s[1276];
gout[n*2187+1655] = + s[1277];
gout[n*2187+1656] = + s[1278];
gout[n*2187+1657] = + s[1279];
gout[n*2187+1658] = + s[1280];
gout[n*2187+1659] = + s[1281];
gout[n*2187+1660] = + s[1282];
gout[n*2187+1661] = + s[1283];
gout[n*2187+1662] = + s[1284];
gout[n*2187+1663] = + s[1285];
gout[n*2187+1664] = + s[1286];
gout[n*2187+1665] = + s[1287];
gout[n*2187+1666] = + s[1288];
gout[n*2187+1667] = + s[1289];
gout[n*2187+1668] = + s[1290];
gout[n*2187+1669] = + s[1291];
gout[n*2187+1670] = + s[1292];
gout[n*2187+1671] = + s[1293];
gout[n*2187+1672] = + s[1294];
gout[n*2187+1673] = + s[1295];
gout[n*2187+1674] = + s[1998];
gout[n*2187+1675] = + s[1999];
gout[n*2187+1676] = + s[2000];
gout[n*2187+1677] = + s[2001];
gout[n*2187+1678] = + s[2002];
gout[n*2187+1679] = + s[2003];
gout[n*2187+1680] = + s[2004];
gout[n*2187+1681] = + s[2005];
gout[n*2187+1682] = + s[2006];
gout[n*2187+1683] = + s[2007];
gout[n*2187+1684] = + s[2008];
gout[n*2187+1685] = + s[2009];
gout[n*2187+1686] = + s[2010];
gout[n*2187+1687] = + s[2011];
gout[n*2187+1688] = + s[2012];
gout[n*2187+1689] = + s[2013];
gout[n*2187+1690] = + s[2014];
gout[n*2187+1691] = + s[2015];
gout[n*2187+1692] = + s[2016];
gout[n*2187+1693] = + s[2017];
gout[n*2187+1694] = + s[2018];
gout[n*2187+1695] = + s[2019];
gout[n*2187+1696] = + s[2020];
gout[n*2187+1697] = + s[2021];
gout[n*2187+1698] = + s[2022];
gout[n*2187+1699] = + s[2023];
gout[n*2187+1700] = + s[2024];
gout[n*2187+1701] = + s[135];
gout[n*2187+1702] = + s[136];
gout[n*2187+1703] = + s[137];
gout[n*2187+1704] = + s[138];
gout[n*2187+1705] = + s[139];
gout[n*2187+1706] = + s[140];
gout[n*2187+1707] = + s[141];
gout[n*2187+1708] = + s[142];
gout[n*2187+1709] = + s[143];
gout[n*2187+1710] = + s[144];
gout[n*2187+1711] = + s[145];
gout[n*2187+1712] = + s[146];
gout[n*2187+1713] = + s[147];
gout[n*2187+1714] = + s[148];
gout[n*2187+1715] = + s[149];
gout[n*2187+1716] = + s[150];
gout[n*2187+1717] = + s[151];
gout[n*2187+1718] = + s[152];
gout[n*2187+1719] = + s[153];
gout[n*2187+1720] = + s[154];
gout[n*2187+1721] = + s[155];
gout[n*2187+1722] = + s[156];
gout[n*2187+1723] = + s[157];
gout[n*2187+1724] = + s[158];
gout[n*2187+1725] = + s[159];
gout[n*2187+1726] = + s[160];
gout[n*2187+1727] = + s[161];
gout[n*2187+1728] = + s[864];
gout[n*2187+1729] = + s[865];
gout[n*2187+1730] = + s[866];
gout[n*2187+1731] = + s[867];
gout[n*2187+1732] = + s[868];
gout[n*2187+1733] = + s[869];
gout[n*2187+1734] = + s[870];
gout[n*2187+1735] = + s[871];
gout[n*2187+1736] = + s[872];
gout[n*2187+1737] = + s[873];
gout[n*2187+1738] = + s[874];
gout[n*2187+1739] = + s[875];
gout[n*2187+1740] = + s[876];
gout[n*2187+1741] = + s[877];
gout[n*2187+1742] = + s[878];
gout[n*2187+1743] = + s[879];
gout[n*2187+1744] = + s[880];
gout[n*2187+1745] = + s[881];
gout[n*2187+1746] = + s[882];
gout[n*2187+1747] = + s[883];
gout[n*2187+1748] = + s[884];
gout[n*2187+1749] = + s[885];
gout[n*2187+1750] = + s[886];
gout[n*2187+1751] = + s[887];
gout[n*2187+1752] = + s[888];
gout[n*2187+1753] = + s[889];
gout[n*2187+1754] = + s[890];
gout[n*2187+1755] = + s[1593];
gout[n*2187+1756] = + s[1594];
gout[n*2187+1757] = + s[1595];
gout[n*2187+1758] = + s[1596];
gout[n*2187+1759] = + s[1597];
gout[n*2187+1760] = + s[1598];
gout[n*2187+1761] = + s[1599];
gout[n*2187+1762] = + s[1600];
gout[n*2187+1763] = + s[1601];
gout[n*2187+1764] = + s[1602];
gout[n*2187+1765] = + s[1603];
gout[n*2187+1766] = + s[1604];
gout[n*2187+1767] = + s[1605];
gout[n*2187+1768] = + s[1606];
gout[n*2187+1769] = + s[1607];
gout[n*2187+1770] = + s[1608];
gout[n*2187+1771] = + s[1609];
gout[n*2187+1772] = + s[1610];
gout[n*2187+1773] = + s[1611];
gout[n*2187+1774] = + s[1612];
gout[n*2187+1775] = + s[1613];
gout[n*2187+1776] = + s[1614];
gout[n*2187+1777] = + s[1615];
gout[n*2187+1778] = + s[1616];
gout[n*2187+1779] = + s[1617];
gout[n*2187+1780] = + s[1618];
gout[n*2187+1781] = + s[1619];
gout[n*2187+1782] = + s[378];
gout[n*2187+1783] = + s[379];
gout[n*2187+1784] = + s[380];
gout[n*2187+1785] = + s[381];
gout[n*2187+1786] = + s[382];
gout[n*2187+1787] = + s[383];
gout[n*2187+1788] = + s[384];
gout[n*2187+1789] = + s[385];
gout[n*2187+1790] = + s[386];
gout[n*2187+1791] = + s[387];
gout[n*2187+1792] = + s[388];
gout[n*2187+1793] = + s[389];
gout[n*2187+1794] = + s[390];
gout[n*2187+1795] = + s[391];
gout[n*2187+1796] = + s[392];
gout[n*2187+1797] = + s[393];
gout[n*2187+1798] = + s[394];
gout[n*2187+1799] = + s[395];
gout[n*2187+1800] = + s[396];
gout[n*2187+1801] = + s[397];
gout[n*2187+1802] = + s[398];
gout[n*2187+1803] = + s[399];
gout[n*2187+1804] = + s[400];
gout[n*2187+1805] = + s[401];
gout[n*2187+1806] = + s[402];
gout[n*2187+1807] = + s[403];
gout[n*2187+1808] = + s[404];
gout[n*2187+1809] = + s[1107];
gout[n*2187+1810] = + s[1108];
gout[n*2187+1811] = + s[1109];
gout[n*2187+1812] = + s[1110];
gout[n*2187+1813] = + s[1111];
gout[n*2187+1814] = + s[1112];
gout[n*2187+1815] = + s[1113];
gout[n*2187+1816] = + s[1114];
gout[n*2187+1817] = + s[1115];
gout[n*2187+1818] = + s[1116];
gout[n*2187+1819] = + s[1117];
gout[n*2187+1820] = + s[1118];
gout[n*2187+1821] = + s[1119];
gout[n*2187+1822] = + s[1120];
gout[n*2187+1823] = + s[1121];
gout[n*2187+1824] = + s[1122];
gout[n*2187+1825] = + s[1123];
gout[n*2187+1826] = + s[1124];
gout[n*2187+1827] = + s[1125];
gout[n*2187+1828] = + s[1126];
gout[n*2187+1829] = + s[1127];
gout[n*2187+1830] = + s[1128];
gout[n*2187+1831] = + s[1129];
gout[n*2187+1832] = + s[1130];
gout[n*2187+1833] = + s[1131];
gout[n*2187+1834] = + s[1132];
gout[n*2187+1835] = + s[1133];
gout[n*2187+1836] = + s[1836];
gout[n*2187+1837] = + s[1837];
gout[n*2187+1838] = + s[1838];
gout[n*2187+1839] = + s[1839];
gout[n*2187+1840] = + s[1840];
gout[n*2187+1841] = + s[1841];
gout[n*2187+1842] = + s[1842];
gout[n*2187+1843] = + s[1843];
gout[n*2187+1844] = + s[1844];
gout[n*2187+1845] = + s[1845];
gout[n*2187+1846] = + s[1846];
gout[n*2187+1847] = + s[1847];
gout[n*2187+1848] = + s[1848];
gout[n*2187+1849] = + s[1849];
gout[n*2187+1850] = + s[1850];
gout[n*2187+1851] = + s[1851];
gout[n*2187+1852] = + s[1852];
gout[n*2187+1853] = + s[1853];
gout[n*2187+1854] = + s[1854];
gout[n*2187+1855] = + s[1855];
gout[n*2187+1856] = + s[1856];
gout[n*2187+1857] = + s[1857];
gout[n*2187+1858] = + s[1858];
gout[n*2187+1859] = + s[1859];
gout[n*2187+1860] = + s[1860];
gout[n*2187+1861] = + s[1861];
gout[n*2187+1862] = + s[1862];
gout[n*2187+1863] = + s[621];
gout[n*2187+1864] = + s[622];
gout[n*2187+1865] = + s[623];
gout[n*2187+1866] = + s[624];
gout[n*2187+1867] = + s[625];
gout[n*2187+1868] = + s[626];
gout[n*2187+1869] = + s[627];
gout[n*2187+1870] = + s[628];
gout[n*2187+1871] = + s[629];
gout[n*2187+1872] = + s[630];
gout[n*2187+1873] = + s[631];
gout[n*2187+1874] = + s[632];
gout[n*2187+1875] = + s[633];
gout[n*2187+1876] = + s[634];
gout[n*2187+1877] = + s[635];
gout[n*2187+1878] = + s[636];
gout[n*2187+1879] = + s[637];
gout[n*2187+1880] = + s[638];
gout[n*2187+1881] = + s[639];
gout[n*2187+1882] = + s[640];
gout[n*2187+1883] = + s[641];
gout[n*2187+1884] = + s[642];
gout[n*2187+1885] = + s[643];
gout[n*2187+1886] = + s[644];
gout[n*2187+1887] = + s[645];
gout[n*2187+1888] = + s[646];
gout[n*2187+1889] = + s[647];
gout[n*2187+1890] = + s[1350];
gout[n*2187+1891] = + s[1351];
gout[n*2187+1892] = + s[1352];
gout[n*2187+1893] = + s[1353];
gout[n*2187+1894] = + s[1354];
gout[n*2187+1895] = + s[1355];
gout[n*2187+1896] = + s[1356];
gout[n*2187+1897] = + s[1357];
gout[n*2187+1898] = + s[1358];
gout[n*2187+1899] = + s[1359];
gout[n*2187+1900] = + s[1360];
gout[n*2187+1901] = + s[1361];
gout[n*2187+1902] = + s[1362];
gout[n*2187+1903] = + s[1363];
gout[n*2187+1904] = + s[1364];
gout[n*2187+1905] = + s[1365];
gout[n*2187+1906] = + s[1366];
gout[n*2187+1907] = + s[1367];
gout[n*2187+1908] = + s[1368];
gout[n*2187+1909] = + s[1369];
gout[n*2187+1910] = + s[1370];
gout[n*2187+1911] = + s[1371];
gout[n*2187+1912] = + s[1372];
gout[n*2187+1913] = + s[1373];
gout[n*2187+1914] = + s[1374];
gout[n*2187+1915] = + s[1375];
gout[n*2187+1916] = + s[1376];
gout[n*2187+1917] = + s[2079];
gout[n*2187+1918] = + s[2080];
gout[n*2187+1919] = + s[2081];
gout[n*2187+1920] = + s[2082];
gout[n*2187+1921] = + s[2083];
gout[n*2187+1922] = + s[2084];
gout[n*2187+1923] = + s[2085];
gout[n*2187+1924] = + s[2086];
gout[n*2187+1925] = + s[2087];
gout[n*2187+1926] = + s[2088];
gout[n*2187+1927] = + s[2089];
gout[n*2187+1928] = + s[2090];
gout[n*2187+1929] = + s[2091];
gout[n*2187+1930] = + s[2092];
gout[n*2187+1931] = + s[2093];
gout[n*2187+1932] = + s[2094];
gout[n*2187+1933] = + s[2095];
gout[n*2187+1934] = + s[2096];
gout[n*2187+1935] = + s[2097];
gout[n*2187+1936] = + s[2098];
gout[n*2187+1937] = + s[2099];
gout[n*2187+1938] = + s[2100];
gout[n*2187+1939] = + s[2101];
gout[n*2187+1940] = + s[2102];
gout[n*2187+1941] = + s[2103];
gout[n*2187+1942] = + s[2104];
gout[n*2187+1943] = + s[2105];
gout[n*2187+1944] = + s[216];
gout[n*2187+1945] = + s[217];
gout[n*2187+1946] = + s[218];
gout[n*2187+1947] = + s[219];
gout[n*2187+1948] = + s[220];
gout[n*2187+1949] = + s[221];
gout[n*2187+1950] = + s[222];
gout[n*2187+1951] = + s[223];
gout[n*2187+1952] = + s[224];
gout[n*2187+1953] = + s[225];
gout[n*2187+1954] = + s[226];
gout[n*2187+1955] = + s[227];
gout[n*2187+1956] = + s[228];
gout[n*2187+1957] = + s[229];
gout[n*2187+1958] = + s[230];
gout[n*2187+1959] = + s[231];
gout[n*2187+1960] = + s[232];
gout[n*2187+1961] = + s[233];
gout[n*2187+1962] = + s[234];
gout[n*2187+1963] = + s[235];
gout[n*2187+1964] = + s[236];
gout[n*2187+1965] = + s[237];
gout[n*2187+1966] = + s[238];
gout[n*2187+1967] = + s[239];
gout[n*2187+1968] = + s[240];
gout[n*2187+1969] = + s[241];
gout[n*2187+1970] = + s[242];
gout[n*2187+1971] = + s[945];
gout[n*2187+1972] = + s[946];
gout[n*2187+1973] = + s[947];
gout[n*2187+1974] = + s[948];
gout[n*2187+1975] = + s[949];
gout[n*2187+1976] = + s[950];
gout[n*2187+1977] = + s[951];
gout[n*2187+1978] = + s[952];
gout[n*2187+1979] = + s[953];
gout[n*2187+1980] = + s[954];
gout[n*2187+1981] = + s[955];
gout[n*2187+1982] = + s[956];
gout[n*2187+1983] = + s[957];
gout[n*2187+1984] = + s[958];
gout[n*2187+1985] = + s[959];
gout[n*2187+1986] = + s[960];
gout[n*2187+1987] = + s[961];
gout[n*2187+1988] = + s[962];
gout[n*2187+1989] = + s[963];
gout[n*2187+1990] = + s[964];
gout[n*2187+1991] = + s[965];
gout[n*2187+1992] = + s[966];
gout[n*2187+1993] = + s[967];
gout[n*2187+1994] = + s[968];
gout[n*2187+1995] = + s[969];
gout[n*2187+1996] = + s[970];
gout[n*2187+1997] = + s[971];
gout[n*2187+1998] = + s[1674];
gout[n*2187+1999] = + s[1675];
gout[n*2187+2000] = + s[1676];
gout[n*2187+2001] = + s[1677];
gout[n*2187+2002] = + s[1678];
gout[n*2187+2003] = + s[1679];
gout[n*2187+2004] = + s[1680];
gout[n*2187+2005] = + s[1681];
gout[n*2187+2006] = + s[1682];
gout[n*2187+2007] = + s[1683];
gout[n*2187+2008] = + s[1684];
gout[n*2187+2009] = + s[1685];
gout[n*2187+2010] = + s[1686];
gout[n*2187+2011] = + s[1687];
gout[n*2187+2012] = + s[1688];
gout[n*2187+2013] = + s[1689];
gout[n*2187+2014] = + s[1690];
gout[n*2187+2015] = + s[1691];
gout[n*2187+2016] = + s[1692];
gout[n*2187+2017] = + s[1693];
gout[n*2187+2018] = + s[1694];
gout[n*2187+2019] = + s[1695];
gout[n*2187+2020] = + s[1696];
gout[n*2187+2021] = + s[1697];
gout[n*2187+2022] = + s[1698];
gout[n*2187+2023] = + s[1699];
gout[n*2187+2024] = + s[1700];
gout[n*2187+2025] = + s[459];
gout[n*2187+2026] = + s[460];
gout[n*2187+2027] = + s[461];
gout[n*2187+2028] = + s[462];
gout[n*2187+2029] = + s[463];
gout[n*2187+2030] = + s[464];
gout[n*2187+2031] = + s[465];
gout[n*2187+2032] = + s[466];
gout[n*2187+2033] = + s[467];
gout[n*2187+2034] = + s[468];
gout[n*2187+2035] = + s[469];
gout[n*2187+2036] = + s[470];
gout[n*2187+2037] = + s[471];
gout[n*2187+2038] = + s[472];
gout[n*2187+2039] = + s[473];
gout[n*2187+2040] = + s[474];
gout[n*2187+2041] = + s[475];
gout[n*2187+2042] = + s[476];
gout[n*2187+2043] = + s[477];
gout[n*2187+2044] = + s[478];
gout[n*2187+2045] = + s[479];
gout[n*2187+2046] = + s[480];
gout[n*2187+2047] = + s[481];
gout[n*2187+2048] = + s[482];
gout[n*2187+2049] = + s[483];
gout[n*2187+2050] = + s[484];
gout[n*2187+2051] = + s[485];
gout[n*2187+2052] = + s[1188];
gout[n*2187+2053] = + s[1189];
gout[n*2187+2054] = + s[1190];
gout[n*2187+2055] = + s[1191];
gout[n*2187+2056] = + s[1192];
gout[n*2187+2057] = + s[1193];
gout[n*2187+2058] = + s[1194];
gout[n*2187+2059] = + s[1195];
gout[n*2187+2060] = + s[1196];
gout[n*2187+2061] = + s[1197];
gout[n*2187+2062] = + s[1198];
gout[n*2187+2063] = + s[1199];
gout[n*2187+2064] = + s[1200];
gout[n*2187+2065] = + s[1201];
gout[n*2187+2066] = + s[1202];
gout[n*2187+2067] = + s[1203];
gout[n*2187+2068] = + s[1204];
gout[n*2187+2069] = + s[1205];
gout[n*2187+2070] = + s[1206];
gout[n*2187+2071] = + s[1207];
gout[n*2187+2072] = + s[1208];
gout[n*2187+2073] = + s[1209];
gout[n*2187+2074] = + s[1210];
gout[n*2187+2075] = + s[1211];
gout[n*2187+2076] = + s[1212];
gout[n*2187+2077] = + s[1213];
gout[n*2187+2078] = + s[1214];
gout[n*2187+2079] = + s[1917];
gout[n*2187+2080] = + s[1918];
gout[n*2187+2081] = + s[1919];
gout[n*2187+2082] = + s[1920];
gout[n*2187+2083] = + s[1921];
gout[n*2187+2084] = + s[1922];
gout[n*2187+2085] = + s[1923];
gout[n*2187+2086] = + s[1924];
gout[n*2187+2087] = + s[1925];
gout[n*2187+2088] = + s[1926];
gout[n*2187+2089] = + s[1927];
gout[n*2187+2090] = + s[1928];
gout[n*2187+2091] = + s[1929];
gout[n*2187+2092] = + s[1930];
gout[n*2187+2093] = + s[1931];
gout[n*2187+2094] = + s[1932];
gout[n*2187+2095] = + s[1933];
gout[n*2187+2096] = + s[1934];
gout[n*2187+2097] = + s[1935];
gout[n*2187+2098] = + s[1936];
gout[n*2187+2099] = + s[1937];
gout[n*2187+2100] = + s[1938];
gout[n*2187+2101] = + s[1939];
gout[n*2187+2102] = + s[1940];
gout[n*2187+2103] = + s[1941];
gout[n*2187+2104] = + s[1942];
gout[n*2187+2105] = + s[1943];
gout[n*2187+2106] = + s[702];
gout[n*2187+2107] = + s[703];
gout[n*2187+2108] = + s[704];
gout[n*2187+2109] = + s[705];
gout[n*2187+2110] = + s[706];
gout[n*2187+2111] = + s[707];
gout[n*2187+2112] = + s[708];
gout[n*2187+2113] = + s[709];
gout[n*2187+2114] = + s[710];
gout[n*2187+2115] = + s[711];
gout[n*2187+2116] = + s[712];
gout[n*2187+2117] = + s[713];
gout[n*2187+2118] = + s[714];
gout[n*2187+2119] = + s[715];
gout[n*2187+2120] = + s[716];
gout[n*2187+2121] = + s[717];
gout[n*2187+2122] = + s[718];
gout[n*2187+2123] = + s[719];
gout[n*2187+2124] = + s[720];
gout[n*2187+2125] = + s[721];
gout[n*2187+2126] = + s[722];
gout[n*2187+2127] = + s[723];
gout[n*2187+2128] = + s[724];
gout[n*2187+2129] = + s[725];
gout[n*2187+2130] = + s[726];
gout[n*2187+2131] = + s[727];
gout[n*2187+2132] = + s[728];
gout[n*2187+2133] = + s[1431];
gout[n*2187+2134] = + s[1432];
gout[n*2187+2135] = + s[1433];
gout[n*2187+2136] = + s[1434];
gout[n*2187+2137] = + s[1435];
gout[n*2187+2138] = + s[1436];
gout[n*2187+2139] = + s[1437];
gout[n*2187+2140] = + s[1438];
gout[n*2187+2141] = + s[1439];
gout[n*2187+2142] = + s[1440];
gout[n*2187+2143] = + s[1441];
gout[n*2187+2144] = + s[1442];
gout[n*2187+2145] = + s[1443];
gout[n*2187+2146] = + s[1444];
gout[n*2187+2147] = + s[1445];
gout[n*2187+2148] = + s[1446];
gout[n*2187+2149] = + s[1447];
gout[n*2187+2150] = + s[1448];
gout[n*2187+2151] = + s[1449];
gout[n*2187+2152] = + s[1450];
gout[n*2187+2153] = + s[1451];
gout[n*2187+2154] = + s[1452];
gout[n*2187+2155] = + s[1453];
gout[n*2187+2156] = + s[1454];
gout[n*2187+2157] = + s[1455];
gout[n*2187+2158] = + s[1456];
gout[n*2187+2159] = + s[1457];
gout[n*2187+2160] = + s[2160];
gout[n*2187+2161] = + s[2161];
gout[n*2187+2162] = + s[2162];
gout[n*2187+2163] = + s[2163];
gout[n*2187+2164] = + s[2164];
gout[n*2187+2165] = + s[2165];
gout[n*2187+2166] = + s[2166];
gout[n*2187+2167] = + s[2167];
gout[n*2187+2168] = + s[2168];
gout[n*2187+2169] = + s[2169];
gout[n*2187+2170] = + s[2170];
gout[n*2187+2171] = + s[2171];
gout[n*2187+2172] = + s[2172];
gout[n*2187+2173] = + s[2173];
gout[n*2187+2174] = + s[2174];
gout[n*2187+2175] = + s[2175];
gout[n*2187+2176] = + s[2176];
gout[n*2187+2177] = + s[2177];
gout[n*2187+2178] = + s[2178];
gout[n*2187+2179] = + s[2179];
gout[n*2187+2180] = + s[2180];
gout[n*2187+2181] = + s[2181];
gout[n*2187+2182] = + s[2182];
gout[n*2187+2183] = + s[2183];
gout[n*2187+2184] = + s[2184];
gout[n*2187+2185] = + s[2185];
gout[n*2187+2186] = + s[2186];
} else {
gout[n*2187+0] += + s[0];
gout[n*2187+1] += + s[1];
gout[n*2187+2] += + s[2];
gout[n*2187+3] += + s[3];
gout[n*2187+4] += + s[4];
gout[n*2187+5] += + s[5];
gout[n*2187+6] += + s[6];
gout[n*2187+7] += + s[7];
gout[n*2187+8] += + s[8];
gout[n*2187+9] += + s[9];
gout[n*2187+10] += + s[10];
gout[n*2187+11] += + s[11];
gout[n*2187+12] += + s[12];
gout[n*2187+13] += + s[13];
gout[n*2187+14] += + s[14];
gout[n*2187+15] += + s[15];
gout[n*2187+16] += + s[16];
gout[n*2187+17] += + s[17];
gout[n*2187+18] += + s[18];
gout[n*2187+19] += + s[19];
gout[n*2187+20] += + s[20];
gout[n*2187+21] += + s[21];
gout[n*2187+22] += + s[22];
gout[n*2187+23] += + s[23];
gout[n*2187+24] += + s[24];
gout[n*2187+25] += + s[25];
gout[n*2187+26] += + s[26];
gout[n*2187+27] += + s[729];
gout[n*2187+28] += + s[730];
gout[n*2187+29] += + s[731];
gout[n*2187+30] += + s[732];
gout[n*2187+31] += + s[733];
gout[n*2187+32] += + s[734];
gout[n*2187+33] += + s[735];
gout[n*2187+34] += + s[736];
gout[n*2187+35] += + s[737];
gout[n*2187+36] += + s[738];
gout[n*2187+37] += + s[739];
gout[n*2187+38] += + s[740];
gout[n*2187+39] += + s[741];
gout[n*2187+40] += + s[742];
gout[n*2187+41] += + s[743];
gout[n*2187+42] += + s[744];
gout[n*2187+43] += + s[745];
gout[n*2187+44] += + s[746];
gout[n*2187+45] += + s[747];
gout[n*2187+46] += + s[748];
gout[n*2187+47] += + s[749];
gout[n*2187+48] += + s[750];
gout[n*2187+49] += + s[751];
gout[n*2187+50] += + s[752];
gout[n*2187+51] += + s[753];
gout[n*2187+52] += + s[754];
gout[n*2187+53] += + s[755];
gout[n*2187+54] += + s[1458];
gout[n*2187+55] += + s[1459];
gout[n*2187+56] += + s[1460];
gout[n*2187+57] += + s[1461];
gout[n*2187+58] += + s[1462];
gout[n*2187+59] += + s[1463];
gout[n*2187+60] += + s[1464];
gout[n*2187+61] += + s[1465];
gout[n*2187+62] += + s[1466];
gout[n*2187+63] += + s[1467];
gout[n*2187+64] += + s[1468];
gout[n*2187+65] += + s[1469];
gout[n*2187+66] += + s[1470];
gout[n*2187+67] += + s[1471];
gout[n*2187+68] += + s[1472];
gout[n*2187+69] += + s[1473];
gout[n*2187+70] += + s[1474];
gout[n*2187+71] += + s[1475];
gout[n*2187+72] += + s[1476];
gout[n*2187+73] += + s[1477];
gout[n*2187+74] += + s[1478];
gout[n*2187+75] += + s[1479];
gout[n*2187+76] += + s[1480];
gout[n*2187+77] += + s[1481];
gout[n*2187+78] += + s[1482];
gout[n*2187+79] += + s[1483];
gout[n*2187+80] += + s[1484];
gout[n*2187+81] += + s[243];
gout[n*2187+82] += + s[244];
gout[n*2187+83] += + s[245];
gout[n*2187+84] += + s[246];
gout[n*2187+85] += + s[247];
gout[n*2187+86] += + s[248];
gout[n*2187+87] += + s[249];
gout[n*2187+88] += + s[250];
gout[n*2187+89] += + s[251];
gout[n*2187+90] += + s[252];
gout[n*2187+91] += + s[253];
gout[n*2187+92] += + s[254];
gout[n*2187+93] += + s[255];
gout[n*2187+94] += + s[256];
gout[n*2187+95] += + s[257];
gout[n*2187+96] += + s[258];
gout[n*2187+97] += + s[259];
gout[n*2187+98] += + s[260];
gout[n*2187+99] += + s[261];
gout[n*2187+100] += + s[262];
gout[n*2187+101] += + s[263];
gout[n*2187+102] += + s[264];
gout[n*2187+103] += + s[265];
gout[n*2187+104] += + s[266];
gout[n*2187+105] += + s[267];
gout[n*2187+106] += + s[268];
gout[n*2187+107] += + s[269];
gout[n*2187+108] += + s[972];
gout[n*2187+109] += + s[973];
gout[n*2187+110] += + s[974];
gout[n*2187+111] += + s[975];
gout[n*2187+112] += + s[976];
gout[n*2187+113] += + s[977];
gout[n*2187+114] += + s[978];
gout[n*2187+115] += + s[979];
gout[n*2187+116] += + s[980];
gout[n*2187+117] += + s[981];
gout[n*2187+118] += + s[982];
gout[n*2187+119] += + s[983];
gout[n*2187+120] += + s[984];
gout[n*2187+121] += + s[985];
gout[n*2187+122] += + s[986];
gout[n*2187+123] += + s[987];
gout[n*2187+124] += + s[988];
gout[n*2187+125] += + s[989];
gout[n*2187+126] += + s[990];
gout[n*2187+127] += + s[991];
gout[n*2187+128] += + s[992];
gout[n*2187+129] += + s[993];
gout[n*2187+130] += + s[994];
gout[n*2187+131] += + s[995];
gout[n*2187+132] += + s[996];
gout[n*2187+133] += + s[997];
gout[n*2187+134] += + s[998];
gout[n*2187+135] += + s[1701];
gout[n*2187+136] += + s[1702];
gout[n*2187+137] += + s[1703];
gout[n*2187+138] += + s[1704];
gout[n*2187+139] += + s[1705];
gout[n*2187+140] += + s[1706];
gout[n*2187+141] += + s[1707];
gout[n*2187+142] += + s[1708];
gout[n*2187+143] += + s[1709];
gout[n*2187+144] += + s[1710];
gout[n*2187+145] += + s[1711];
gout[n*2187+146] += + s[1712];
gout[n*2187+147] += + s[1713];
gout[n*2187+148] += + s[1714];
gout[n*2187+149] += + s[1715];
gout[n*2187+150] += + s[1716];
gout[n*2187+151] += + s[1717];
gout[n*2187+152] += + s[1718];
gout[n*2187+153] += + s[1719];
gout[n*2187+154] += + s[1720];
gout[n*2187+155] += + s[1721];
gout[n*2187+156] += + s[1722];
gout[n*2187+157] += + s[1723];
gout[n*2187+158] += + s[1724];
gout[n*2187+159] += + s[1725];
gout[n*2187+160] += + s[1726];
gout[n*2187+161] += + s[1727];
gout[n*2187+162] += + s[486];
gout[n*2187+163] += + s[487];
gout[n*2187+164] += + s[488];
gout[n*2187+165] += + s[489];
gout[n*2187+166] += + s[490];
gout[n*2187+167] += + s[491];
gout[n*2187+168] += + s[492];
gout[n*2187+169] += + s[493];
gout[n*2187+170] += + s[494];
gout[n*2187+171] += + s[495];
gout[n*2187+172] += + s[496];
gout[n*2187+173] += + s[497];
gout[n*2187+174] += + s[498];
gout[n*2187+175] += + s[499];
gout[n*2187+176] += + s[500];
gout[n*2187+177] += + s[501];
gout[n*2187+178] += + s[502];
gout[n*2187+179] += + s[503];
gout[n*2187+180] += + s[504];
gout[n*2187+181] += + s[505];
gout[n*2187+182] += + s[506];
gout[n*2187+183] += + s[507];
gout[n*2187+184] += + s[508];
gout[n*2187+185] += + s[509];
gout[n*2187+186] += + s[510];
gout[n*2187+187] += + s[511];
gout[n*2187+188] += + s[512];
gout[n*2187+189] += + s[1215];
gout[n*2187+190] += + s[1216];
gout[n*2187+191] += + s[1217];
gout[n*2187+192] += + s[1218];
gout[n*2187+193] += + s[1219];
gout[n*2187+194] += + s[1220];
gout[n*2187+195] += + s[1221];
gout[n*2187+196] += + s[1222];
gout[n*2187+197] += + s[1223];
gout[n*2187+198] += + s[1224];
gout[n*2187+199] += + s[1225];
gout[n*2187+200] += + s[1226];
gout[n*2187+201] += + s[1227];
gout[n*2187+202] += + s[1228];
gout[n*2187+203] += + s[1229];
gout[n*2187+204] += + s[1230];
gout[n*2187+205] += + s[1231];
gout[n*2187+206] += + s[1232];
gout[n*2187+207] += + s[1233];
gout[n*2187+208] += + s[1234];
gout[n*2187+209] += + s[1235];
gout[n*2187+210] += + s[1236];
gout[n*2187+211] += + s[1237];
gout[n*2187+212] += + s[1238];
gout[n*2187+213] += + s[1239];
gout[n*2187+214] += + s[1240];
gout[n*2187+215] += + s[1241];
gout[n*2187+216] += + s[1944];
gout[n*2187+217] += + s[1945];
gout[n*2187+218] += + s[1946];
gout[n*2187+219] += + s[1947];
gout[n*2187+220] += + s[1948];
gout[n*2187+221] += + s[1949];
gout[n*2187+222] += + s[1950];
gout[n*2187+223] += + s[1951];
gout[n*2187+224] += + s[1952];
gout[n*2187+225] += + s[1953];
gout[n*2187+226] += + s[1954];
gout[n*2187+227] += + s[1955];
gout[n*2187+228] += + s[1956];
gout[n*2187+229] += + s[1957];
gout[n*2187+230] += + s[1958];
gout[n*2187+231] += + s[1959];
gout[n*2187+232] += + s[1960];
gout[n*2187+233] += + s[1961];
gout[n*2187+234] += + s[1962];
gout[n*2187+235] += + s[1963];
gout[n*2187+236] += + s[1964];
gout[n*2187+237] += + s[1965];
gout[n*2187+238] += + s[1966];
gout[n*2187+239] += + s[1967];
gout[n*2187+240] += + s[1968];
gout[n*2187+241] += + s[1969];
gout[n*2187+242] += + s[1970];
gout[n*2187+243] += + s[81];
gout[n*2187+244] += + s[82];
gout[n*2187+245] += + s[83];
gout[n*2187+246] += + s[84];
gout[n*2187+247] += + s[85];
gout[n*2187+248] += + s[86];
gout[n*2187+249] += + s[87];
gout[n*2187+250] += + s[88];
gout[n*2187+251] += + s[89];
gout[n*2187+252] += + s[90];
gout[n*2187+253] += + s[91];
gout[n*2187+254] += + s[92];
gout[n*2187+255] += + s[93];
gout[n*2187+256] += + s[94];
gout[n*2187+257] += + s[95];
gout[n*2187+258] += + s[96];
gout[n*2187+259] += + s[97];
gout[n*2187+260] += + s[98];
gout[n*2187+261] += + s[99];
gout[n*2187+262] += + s[100];
gout[n*2187+263] += + s[101];
gout[n*2187+264] += + s[102];
gout[n*2187+265] += + s[103];
gout[n*2187+266] += + s[104];
gout[n*2187+267] += + s[105];
gout[n*2187+268] += + s[106];
gout[n*2187+269] += + s[107];
gout[n*2187+270] += + s[810];
gout[n*2187+271] += + s[811];
gout[n*2187+272] += + s[812];
gout[n*2187+273] += + s[813];
gout[n*2187+274] += + s[814];
gout[n*2187+275] += + s[815];
gout[n*2187+276] += + s[816];
gout[n*2187+277] += + s[817];
gout[n*2187+278] += + s[818];
gout[n*2187+279] += + s[819];
gout[n*2187+280] += + s[820];
gout[n*2187+281] += + s[821];
gout[n*2187+282] += + s[822];
gout[n*2187+283] += + s[823];
gout[n*2187+284] += + s[824];
gout[n*2187+285] += + s[825];
gout[n*2187+286] += + s[826];
gout[n*2187+287] += + s[827];
gout[n*2187+288] += + s[828];
gout[n*2187+289] += + s[829];
gout[n*2187+290] += + s[830];
gout[n*2187+291] += + s[831];
gout[n*2187+292] += + s[832];
gout[n*2187+293] += + s[833];
gout[n*2187+294] += + s[834];
gout[n*2187+295] += + s[835];
gout[n*2187+296] += + s[836];
gout[n*2187+297] += + s[1539];
gout[n*2187+298] += + s[1540];
gout[n*2187+299] += + s[1541];
gout[n*2187+300] += + s[1542];
gout[n*2187+301] += + s[1543];
gout[n*2187+302] += + s[1544];
gout[n*2187+303] += + s[1545];
gout[n*2187+304] += + s[1546];
gout[n*2187+305] += + s[1547];
gout[n*2187+306] += + s[1548];
gout[n*2187+307] += + s[1549];
gout[n*2187+308] += + s[1550];
gout[n*2187+309] += + s[1551];
gout[n*2187+310] += + s[1552];
gout[n*2187+311] += + s[1553];
gout[n*2187+312] += + s[1554];
gout[n*2187+313] += + s[1555];
gout[n*2187+314] += + s[1556];
gout[n*2187+315] += + s[1557];
gout[n*2187+316] += + s[1558];
gout[n*2187+317] += + s[1559];
gout[n*2187+318] += + s[1560];
gout[n*2187+319] += + s[1561];
gout[n*2187+320] += + s[1562];
gout[n*2187+321] += + s[1563];
gout[n*2187+322] += + s[1564];
gout[n*2187+323] += + s[1565];
gout[n*2187+324] += + s[324];
gout[n*2187+325] += + s[325];
gout[n*2187+326] += + s[326];
gout[n*2187+327] += + s[327];
gout[n*2187+328] += + s[328];
gout[n*2187+329] += + s[329];
gout[n*2187+330] += + s[330];
gout[n*2187+331] += + s[331];
gout[n*2187+332] += + s[332];
gout[n*2187+333] += + s[333];
gout[n*2187+334] += + s[334];
gout[n*2187+335] += + s[335];
gout[n*2187+336] += + s[336];
gout[n*2187+337] += + s[337];
gout[n*2187+338] += + s[338];
gout[n*2187+339] += + s[339];
gout[n*2187+340] += + s[340];
gout[n*2187+341] += + s[341];
gout[n*2187+342] += + s[342];
gout[n*2187+343] += + s[343];
gout[n*2187+344] += + s[344];
gout[n*2187+345] += + s[345];
gout[n*2187+346] += + s[346];
gout[n*2187+347] += + s[347];
gout[n*2187+348] += + s[348];
gout[n*2187+349] += + s[349];
gout[n*2187+350] += + s[350];
gout[n*2187+351] += + s[1053];
gout[n*2187+352] += + s[1054];
gout[n*2187+353] += + s[1055];
gout[n*2187+354] += + s[1056];
gout[n*2187+355] += + s[1057];
gout[n*2187+356] += + s[1058];
gout[n*2187+357] += + s[1059];
gout[n*2187+358] += + s[1060];
gout[n*2187+359] += + s[1061];
gout[n*2187+360] += + s[1062];
gout[n*2187+361] += + s[1063];
gout[n*2187+362] += + s[1064];
gout[n*2187+363] += + s[1065];
gout[n*2187+364] += + s[1066];
gout[n*2187+365] += + s[1067];
gout[n*2187+366] += + s[1068];
gout[n*2187+367] += + s[1069];
gout[n*2187+368] += + s[1070];
gout[n*2187+369] += + s[1071];
gout[n*2187+370] += + s[1072];
gout[n*2187+371] += + s[1073];
gout[n*2187+372] += + s[1074];
gout[n*2187+373] += + s[1075];
gout[n*2187+374] += + s[1076];
gout[n*2187+375] += + s[1077];
gout[n*2187+376] += + s[1078];
gout[n*2187+377] += + s[1079];
gout[n*2187+378] += + s[1782];
gout[n*2187+379] += + s[1783];
gout[n*2187+380] += + s[1784];
gout[n*2187+381] += + s[1785];
gout[n*2187+382] += + s[1786];
gout[n*2187+383] += + s[1787];
gout[n*2187+384] += + s[1788];
gout[n*2187+385] += + s[1789];
gout[n*2187+386] += + s[1790];
gout[n*2187+387] += + s[1791];
gout[n*2187+388] += + s[1792];
gout[n*2187+389] += + s[1793];
gout[n*2187+390] += + s[1794];
gout[n*2187+391] += + s[1795];
gout[n*2187+392] += + s[1796];
gout[n*2187+393] += + s[1797];
gout[n*2187+394] += + s[1798];
gout[n*2187+395] += + s[1799];
gout[n*2187+396] += + s[1800];
gout[n*2187+397] += + s[1801];
gout[n*2187+398] += + s[1802];
gout[n*2187+399] += + s[1803];
gout[n*2187+400] += + s[1804];
gout[n*2187+401] += + s[1805];
gout[n*2187+402] += + s[1806];
gout[n*2187+403] += + s[1807];
gout[n*2187+404] += + s[1808];
gout[n*2187+405] += + s[567];
gout[n*2187+406] += + s[568];
gout[n*2187+407] += + s[569];
gout[n*2187+408] += + s[570];
gout[n*2187+409] += + s[571];
gout[n*2187+410] += + s[572];
gout[n*2187+411] += + s[573];
gout[n*2187+412] += + s[574];
gout[n*2187+413] += + s[575];
gout[n*2187+414] += + s[576];
gout[n*2187+415] += + s[577];
gout[n*2187+416] += + s[578];
gout[n*2187+417] += + s[579];
gout[n*2187+418] += + s[580];
gout[n*2187+419] += + s[581];
gout[n*2187+420] += + s[582];
gout[n*2187+421] += + s[583];
gout[n*2187+422] += + s[584];
gout[n*2187+423] += + s[585];
gout[n*2187+424] += + s[586];
gout[n*2187+425] += + s[587];
gout[n*2187+426] += + s[588];
gout[n*2187+427] += + s[589];
gout[n*2187+428] += + s[590];
gout[n*2187+429] += + s[591];
gout[n*2187+430] += + s[592];
gout[n*2187+431] += + s[593];
gout[n*2187+432] += + s[1296];
gout[n*2187+433] += + s[1297];
gout[n*2187+434] += + s[1298];
gout[n*2187+435] += + s[1299];
gout[n*2187+436] += + s[1300];
gout[n*2187+437] += + s[1301];
gout[n*2187+438] += + s[1302];
gout[n*2187+439] += + s[1303];
gout[n*2187+440] += + s[1304];
gout[n*2187+441] += + s[1305];
gout[n*2187+442] += + s[1306];
gout[n*2187+443] += + s[1307];
gout[n*2187+444] += + s[1308];
gout[n*2187+445] += + s[1309];
gout[n*2187+446] += + s[1310];
gout[n*2187+447] += + s[1311];
gout[n*2187+448] += + s[1312];
gout[n*2187+449] += + s[1313];
gout[n*2187+450] += + s[1314];
gout[n*2187+451] += + s[1315];
gout[n*2187+452] += + s[1316];
gout[n*2187+453] += + s[1317];
gout[n*2187+454] += + s[1318];
gout[n*2187+455] += + s[1319];
gout[n*2187+456] += + s[1320];
gout[n*2187+457] += + s[1321];
gout[n*2187+458] += + s[1322];
gout[n*2187+459] += + s[2025];
gout[n*2187+460] += + s[2026];
gout[n*2187+461] += + s[2027];
gout[n*2187+462] += + s[2028];
gout[n*2187+463] += + s[2029];
gout[n*2187+464] += + s[2030];
gout[n*2187+465] += + s[2031];
gout[n*2187+466] += + s[2032];
gout[n*2187+467] += + s[2033];
gout[n*2187+468] += + s[2034];
gout[n*2187+469] += + s[2035];
gout[n*2187+470] += + s[2036];
gout[n*2187+471] += + s[2037];
gout[n*2187+472] += + s[2038];
gout[n*2187+473] += + s[2039];
gout[n*2187+474] += + s[2040];
gout[n*2187+475] += + s[2041];
gout[n*2187+476] += + s[2042];
gout[n*2187+477] += + s[2043];
gout[n*2187+478] += + s[2044];
gout[n*2187+479] += + s[2045];
gout[n*2187+480] += + s[2046];
gout[n*2187+481] += + s[2047];
gout[n*2187+482] += + s[2048];
gout[n*2187+483] += + s[2049];
gout[n*2187+484] += + s[2050];
gout[n*2187+485] += + s[2051];
gout[n*2187+486] += + s[162];
gout[n*2187+487] += + s[163];
gout[n*2187+488] += + s[164];
gout[n*2187+489] += + s[165];
gout[n*2187+490] += + s[166];
gout[n*2187+491] += + s[167];
gout[n*2187+492] += + s[168];
gout[n*2187+493] += + s[169];
gout[n*2187+494] += + s[170];
gout[n*2187+495] += + s[171];
gout[n*2187+496] += + s[172];
gout[n*2187+497] += + s[173];
gout[n*2187+498] += + s[174];
gout[n*2187+499] += + s[175];
gout[n*2187+500] += + s[176];
gout[n*2187+501] += + s[177];
gout[n*2187+502] += + s[178];
gout[n*2187+503] += + s[179];
gout[n*2187+504] += + s[180];
gout[n*2187+505] += + s[181];
gout[n*2187+506] += + s[182];
gout[n*2187+507] += + s[183];
gout[n*2187+508] += + s[184];
gout[n*2187+509] += + s[185];
gout[n*2187+510] += + s[186];
gout[n*2187+511] += + s[187];
gout[n*2187+512] += + s[188];
gout[n*2187+513] += + s[891];
gout[n*2187+514] += + s[892];
gout[n*2187+515] += + s[893];
gout[n*2187+516] += + s[894];
gout[n*2187+517] += + s[895];
gout[n*2187+518] += + s[896];
gout[n*2187+519] += + s[897];
gout[n*2187+520] += + s[898];
gout[n*2187+521] += + s[899];
gout[n*2187+522] += + s[900];
gout[n*2187+523] += + s[901];
gout[n*2187+524] += + s[902];
gout[n*2187+525] += + s[903];
gout[n*2187+526] += + s[904];
gout[n*2187+527] += + s[905];
gout[n*2187+528] += + s[906];
gout[n*2187+529] += + s[907];
gout[n*2187+530] += + s[908];
gout[n*2187+531] += + s[909];
gout[n*2187+532] += + s[910];
gout[n*2187+533] += + s[911];
gout[n*2187+534] += + s[912];
gout[n*2187+535] += + s[913];
gout[n*2187+536] += + s[914];
gout[n*2187+537] += + s[915];
gout[n*2187+538] += + s[916];
gout[n*2187+539] += + s[917];
gout[n*2187+540] += + s[1620];
gout[n*2187+541] += + s[1621];
gout[n*2187+542] += + s[1622];
gout[n*2187+543] += + s[1623];
gout[n*2187+544] += + s[1624];
gout[n*2187+545] += + s[1625];
gout[n*2187+546] += + s[1626];
gout[n*2187+547] += + s[1627];
gout[n*2187+548] += + s[1628];
gout[n*2187+549] += + s[1629];
gout[n*2187+550] += + s[1630];
gout[n*2187+551] += + s[1631];
gout[n*2187+552] += + s[1632];
gout[n*2187+553] += + s[1633];
gout[n*2187+554] += + s[1634];
gout[n*2187+555] += + s[1635];
gout[n*2187+556] += + s[1636];
gout[n*2187+557] += + s[1637];
gout[n*2187+558] += + s[1638];
gout[n*2187+559] += + s[1639];
gout[n*2187+560] += + s[1640];
gout[n*2187+561] += + s[1641];
gout[n*2187+562] += + s[1642];
gout[n*2187+563] += + s[1643];
gout[n*2187+564] += + s[1644];
gout[n*2187+565] += + s[1645];
gout[n*2187+566] += + s[1646];
gout[n*2187+567] += + s[405];
gout[n*2187+568] += + s[406];
gout[n*2187+569] += + s[407];
gout[n*2187+570] += + s[408];
gout[n*2187+571] += + s[409];
gout[n*2187+572] += + s[410];
gout[n*2187+573] += + s[411];
gout[n*2187+574] += + s[412];
gout[n*2187+575] += + s[413];
gout[n*2187+576] += + s[414];
gout[n*2187+577] += + s[415];
gout[n*2187+578] += + s[416];
gout[n*2187+579] += + s[417];
gout[n*2187+580] += + s[418];
gout[n*2187+581] += + s[419];
gout[n*2187+582] += + s[420];
gout[n*2187+583] += + s[421];
gout[n*2187+584] += + s[422];
gout[n*2187+585] += + s[423];
gout[n*2187+586] += + s[424];
gout[n*2187+587] += + s[425];
gout[n*2187+588] += + s[426];
gout[n*2187+589] += + s[427];
gout[n*2187+590] += + s[428];
gout[n*2187+591] += + s[429];
gout[n*2187+592] += + s[430];
gout[n*2187+593] += + s[431];
gout[n*2187+594] += + s[1134];
gout[n*2187+595] += + s[1135];
gout[n*2187+596] += + s[1136];
gout[n*2187+597] += + s[1137];
gout[n*2187+598] += + s[1138];
gout[n*2187+599] += + s[1139];
gout[n*2187+600] += + s[1140];
gout[n*2187+601] += + s[1141];
gout[n*2187+602] += + s[1142];
gout[n*2187+603] += + s[1143];
gout[n*2187+604] += + s[1144];
gout[n*2187+605] += + s[1145];
gout[n*2187+606] += + s[1146];
gout[n*2187+607] += + s[1147];
gout[n*2187+608] += + s[1148];
gout[n*2187+609] += + s[1149];
gout[n*2187+610] += + s[1150];
gout[n*2187+611] += + s[1151];
gout[n*2187+612] += + s[1152];
gout[n*2187+613] += + s[1153];
gout[n*2187+614] += + s[1154];
gout[n*2187+615] += + s[1155];
gout[n*2187+616] += + s[1156];
gout[n*2187+617] += + s[1157];
gout[n*2187+618] += + s[1158];
gout[n*2187+619] += + s[1159];
gout[n*2187+620] += + s[1160];
gout[n*2187+621] += + s[1863];
gout[n*2187+622] += + s[1864];
gout[n*2187+623] += + s[1865];
gout[n*2187+624] += + s[1866];
gout[n*2187+625] += + s[1867];
gout[n*2187+626] += + s[1868];
gout[n*2187+627] += + s[1869];
gout[n*2187+628] += + s[1870];
gout[n*2187+629] += + s[1871];
gout[n*2187+630] += + s[1872];
gout[n*2187+631] += + s[1873];
gout[n*2187+632] += + s[1874];
gout[n*2187+633] += + s[1875];
gout[n*2187+634] += + s[1876];
gout[n*2187+635] += + s[1877];
gout[n*2187+636] += + s[1878];
gout[n*2187+637] += + s[1879];
gout[n*2187+638] += + s[1880];
gout[n*2187+639] += + s[1881];
gout[n*2187+640] += + s[1882];
gout[n*2187+641] += + s[1883];
gout[n*2187+642] += + s[1884];
gout[n*2187+643] += + s[1885];
gout[n*2187+644] += + s[1886];
gout[n*2187+645] += + s[1887];
gout[n*2187+646] += + s[1888];
gout[n*2187+647] += + s[1889];
gout[n*2187+648] += + s[648];
gout[n*2187+649] += + s[649];
gout[n*2187+650] += + s[650];
gout[n*2187+651] += + s[651];
gout[n*2187+652] += + s[652];
gout[n*2187+653] += + s[653];
gout[n*2187+654] += + s[654];
gout[n*2187+655] += + s[655];
gout[n*2187+656] += + s[656];
gout[n*2187+657] += + s[657];
gout[n*2187+658] += + s[658];
gout[n*2187+659] += + s[659];
gout[n*2187+660] += + s[660];
gout[n*2187+661] += + s[661];
gout[n*2187+662] += + s[662];
gout[n*2187+663] += + s[663];
gout[n*2187+664] += + s[664];
gout[n*2187+665] += + s[665];
gout[n*2187+666] += + s[666];
gout[n*2187+667] += + s[667];
gout[n*2187+668] += + s[668];
gout[n*2187+669] += + s[669];
gout[n*2187+670] += + s[670];
gout[n*2187+671] += + s[671];
gout[n*2187+672] += + s[672];
gout[n*2187+673] += + s[673];
gout[n*2187+674] += + s[674];
gout[n*2187+675] += + s[1377];
gout[n*2187+676] += + s[1378];
gout[n*2187+677] += + s[1379];
gout[n*2187+678] += + s[1380];
gout[n*2187+679] += + s[1381];
gout[n*2187+680] += + s[1382];
gout[n*2187+681] += + s[1383];
gout[n*2187+682] += + s[1384];
gout[n*2187+683] += + s[1385];
gout[n*2187+684] += + s[1386];
gout[n*2187+685] += + s[1387];
gout[n*2187+686] += + s[1388];
gout[n*2187+687] += + s[1389];
gout[n*2187+688] += + s[1390];
gout[n*2187+689] += + s[1391];
gout[n*2187+690] += + s[1392];
gout[n*2187+691] += + s[1393];
gout[n*2187+692] += + s[1394];
gout[n*2187+693] += + s[1395];
gout[n*2187+694] += + s[1396];
gout[n*2187+695] += + s[1397];
gout[n*2187+696] += + s[1398];
gout[n*2187+697] += + s[1399];
gout[n*2187+698] += + s[1400];
gout[n*2187+699] += + s[1401];
gout[n*2187+700] += + s[1402];
gout[n*2187+701] += + s[1403];
gout[n*2187+702] += + s[2106];
gout[n*2187+703] += + s[2107];
gout[n*2187+704] += + s[2108];
gout[n*2187+705] += + s[2109];
gout[n*2187+706] += + s[2110];
gout[n*2187+707] += + s[2111];
gout[n*2187+708] += + s[2112];
gout[n*2187+709] += + s[2113];
gout[n*2187+710] += + s[2114];
gout[n*2187+711] += + s[2115];
gout[n*2187+712] += + s[2116];
gout[n*2187+713] += + s[2117];
gout[n*2187+714] += + s[2118];
gout[n*2187+715] += + s[2119];
gout[n*2187+716] += + s[2120];
gout[n*2187+717] += + s[2121];
gout[n*2187+718] += + s[2122];
gout[n*2187+719] += + s[2123];
gout[n*2187+720] += + s[2124];
gout[n*2187+721] += + s[2125];
gout[n*2187+722] += + s[2126];
gout[n*2187+723] += + s[2127];
gout[n*2187+724] += + s[2128];
gout[n*2187+725] += + s[2129];
gout[n*2187+726] += + s[2130];
gout[n*2187+727] += + s[2131];
gout[n*2187+728] += + s[2132];
gout[n*2187+729] += + s[27];
gout[n*2187+730] += + s[28];
gout[n*2187+731] += + s[29];
gout[n*2187+732] += + s[30];
gout[n*2187+733] += + s[31];
gout[n*2187+734] += + s[32];
gout[n*2187+735] += + s[33];
gout[n*2187+736] += + s[34];
gout[n*2187+737] += + s[35];
gout[n*2187+738] += + s[36];
gout[n*2187+739] += + s[37];
gout[n*2187+740] += + s[38];
gout[n*2187+741] += + s[39];
gout[n*2187+742] += + s[40];
gout[n*2187+743] += + s[41];
gout[n*2187+744] += + s[42];
gout[n*2187+745] += + s[43];
gout[n*2187+746] += + s[44];
gout[n*2187+747] += + s[45];
gout[n*2187+748] += + s[46];
gout[n*2187+749] += + s[47];
gout[n*2187+750] += + s[48];
gout[n*2187+751] += + s[49];
gout[n*2187+752] += + s[50];
gout[n*2187+753] += + s[51];
gout[n*2187+754] += + s[52];
gout[n*2187+755] += + s[53];
gout[n*2187+756] += + s[756];
gout[n*2187+757] += + s[757];
gout[n*2187+758] += + s[758];
gout[n*2187+759] += + s[759];
gout[n*2187+760] += + s[760];
gout[n*2187+761] += + s[761];
gout[n*2187+762] += + s[762];
gout[n*2187+763] += + s[763];
gout[n*2187+764] += + s[764];
gout[n*2187+765] += + s[765];
gout[n*2187+766] += + s[766];
gout[n*2187+767] += + s[767];
gout[n*2187+768] += + s[768];
gout[n*2187+769] += + s[769];
gout[n*2187+770] += + s[770];
gout[n*2187+771] += + s[771];
gout[n*2187+772] += + s[772];
gout[n*2187+773] += + s[773];
gout[n*2187+774] += + s[774];
gout[n*2187+775] += + s[775];
gout[n*2187+776] += + s[776];
gout[n*2187+777] += + s[777];
gout[n*2187+778] += + s[778];
gout[n*2187+779] += + s[779];
gout[n*2187+780] += + s[780];
gout[n*2187+781] += + s[781];
gout[n*2187+782] += + s[782];
gout[n*2187+783] += + s[1485];
gout[n*2187+784] += + s[1486];
gout[n*2187+785] += + s[1487];
gout[n*2187+786] += + s[1488];
gout[n*2187+787] += + s[1489];
gout[n*2187+788] += + s[1490];
gout[n*2187+789] += + s[1491];
gout[n*2187+790] += + s[1492];
gout[n*2187+791] += + s[1493];
gout[n*2187+792] += + s[1494];
gout[n*2187+793] += + s[1495];
gout[n*2187+794] += + s[1496];
gout[n*2187+795] += + s[1497];
gout[n*2187+796] += + s[1498];
gout[n*2187+797] += + s[1499];
gout[n*2187+798] += + s[1500];
gout[n*2187+799] += + s[1501];
gout[n*2187+800] += + s[1502];
gout[n*2187+801] += + s[1503];
gout[n*2187+802] += + s[1504];
gout[n*2187+803] += + s[1505];
gout[n*2187+804] += + s[1506];
gout[n*2187+805] += + s[1507];
gout[n*2187+806] += + s[1508];
gout[n*2187+807] += + s[1509];
gout[n*2187+808] += + s[1510];
gout[n*2187+809] += + s[1511];
gout[n*2187+810] += + s[270];
gout[n*2187+811] += + s[271];
gout[n*2187+812] += + s[272];
gout[n*2187+813] += + s[273];
gout[n*2187+814] += + s[274];
gout[n*2187+815] += + s[275];
gout[n*2187+816] += + s[276];
gout[n*2187+817] += + s[277];
gout[n*2187+818] += + s[278];
gout[n*2187+819] += + s[279];
gout[n*2187+820] += + s[280];
gout[n*2187+821] += + s[281];
gout[n*2187+822] += + s[282];
gout[n*2187+823] += + s[283];
gout[n*2187+824] += + s[284];
gout[n*2187+825] += + s[285];
gout[n*2187+826] += + s[286];
gout[n*2187+827] += + s[287];
gout[n*2187+828] += + s[288];
gout[n*2187+829] += + s[289];
gout[n*2187+830] += + s[290];
gout[n*2187+831] += + s[291];
gout[n*2187+832] += + s[292];
gout[n*2187+833] += + s[293];
gout[n*2187+834] += + s[294];
gout[n*2187+835] += + s[295];
gout[n*2187+836] += + s[296];
gout[n*2187+837] += + s[999];
gout[n*2187+838] += + s[1000];
gout[n*2187+839] += + s[1001];
gout[n*2187+840] += + s[1002];
gout[n*2187+841] += + s[1003];
gout[n*2187+842] += + s[1004];
gout[n*2187+843] += + s[1005];
gout[n*2187+844] += + s[1006];
gout[n*2187+845] += + s[1007];
gout[n*2187+846] += + s[1008];
gout[n*2187+847] += + s[1009];
gout[n*2187+848] += + s[1010];
gout[n*2187+849] += + s[1011];
gout[n*2187+850] += + s[1012];
gout[n*2187+851] += + s[1013];
gout[n*2187+852] += + s[1014];
gout[n*2187+853] += + s[1015];
gout[n*2187+854] += + s[1016];
gout[n*2187+855] += + s[1017];
gout[n*2187+856] += + s[1018];
gout[n*2187+857] += + s[1019];
gout[n*2187+858] += + s[1020];
gout[n*2187+859] += + s[1021];
gout[n*2187+860] += + s[1022];
gout[n*2187+861] += + s[1023];
gout[n*2187+862] += + s[1024];
gout[n*2187+863] += + s[1025];
gout[n*2187+864] += + s[1728];
gout[n*2187+865] += + s[1729];
gout[n*2187+866] += + s[1730];
gout[n*2187+867] += + s[1731];
gout[n*2187+868] += + s[1732];
gout[n*2187+869] += + s[1733];
gout[n*2187+870] += + s[1734];
gout[n*2187+871] += + s[1735];
gout[n*2187+872] += + s[1736];
gout[n*2187+873] += + s[1737];
gout[n*2187+874] += + s[1738];
gout[n*2187+875] += + s[1739];
gout[n*2187+876] += + s[1740];
gout[n*2187+877] += + s[1741];
gout[n*2187+878] += + s[1742];
gout[n*2187+879] += + s[1743];
gout[n*2187+880] += + s[1744];
gout[n*2187+881] += + s[1745];
gout[n*2187+882] += + s[1746];
gout[n*2187+883] += + s[1747];
gout[n*2187+884] += + s[1748];
gout[n*2187+885] += + s[1749];
gout[n*2187+886] += + s[1750];
gout[n*2187+887] += + s[1751];
gout[n*2187+888] += + s[1752];
gout[n*2187+889] += + s[1753];
gout[n*2187+890] += + s[1754];
gout[n*2187+891] += + s[513];
gout[n*2187+892] += + s[514];
gout[n*2187+893] += + s[515];
gout[n*2187+894] += + s[516];
gout[n*2187+895] += + s[517];
gout[n*2187+896] += + s[518];
gout[n*2187+897] += + s[519];
gout[n*2187+898] += + s[520];
gout[n*2187+899] += + s[521];
gout[n*2187+900] += + s[522];
gout[n*2187+901] += + s[523];
gout[n*2187+902] += + s[524];
gout[n*2187+903] += + s[525];
gout[n*2187+904] += + s[526];
gout[n*2187+905] += + s[527];
gout[n*2187+906] += + s[528];
gout[n*2187+907] += + s[529];
gout[n*2187+908] += + s[530];
gout[n*2187+909] += + s[531];
gout[n*2187+910] += + s[532];
gout[n*2187+911] += + s[533];
gout[n*2187+912] += + s[534];
gout[n*2187+913] += + s[535];
gout[n*2187+914] += + s[536];
gout[n*2187+915] += + s[537];
gout[n*2187+916] += + s[538];
gout[n*2187+917] += + s[539];
gout[n*2187+918] += + s[1242];
gout[n*2187+919] += + s[1243];
gout[n*2187+920] += + s[1244];
gout[n*2187+921] += + s[1245];
gout[n*2187+922] += + s[1246];
gout[n*2187+923] += + s[1247];
gout[n*2187+924] += + s[1248];
gout[n*2187+925] += + s[1249];
gout[n*2187+926] += + s[1250];
gout[n*2187+927] += + s[1251];
gout[n*2187+928] += + s[1252];
gout[n*2187+929] += + s[1253];
gout[n*2187+930] += + s[1254];
gout[n*2187+931] += + s[1255];
gout[n*2187+932] += + s[1256];
gout[n*2187+933] += + s[1257];
gout[n*2187+934] += + s[1258];
gout[n*2187+935] += + s[1259];
gout[n*2187+936] += + s[1260];
gout[n*2187+937] += + s[1261];
gout[n*2187+938] += + s[1262];
gout[n*2187+939] += + s[1263];
gout[n*2187+940] += + s[1264];
gout[n*2187+941] += + s[1265];
gout[n*2187+942] += + s[1266];
gout[n*2187+943] += + s[1267];
gout[n*2187+944] += + s[1268];
gout[n*2187+945] += + s[1971];
gout[n*2187+946] += + s[1972];
gout[n*2187+947] += + s[1973];
gout[n*2187+948] += + s[1974];
gout[n*2187+949] += + s[1975];
gout[n*2187+950] += + s[1976];
gout[n*2187+951] += + s[1977];
gout[n*2187+952] += + s[1978];
gout[n*2187+953] += + s[1979];
gout[n*2187+954] += + s[1980];
gout[n*2187+955] += + s[1981];
gout[n*2187+956] += + s[1982];
gout[n*2187+957] += + s[1983];
gout[n*2187+958] += + s[1984];
gout[n*2187+959] += + s[1985];
gout[n*2187+960] += + s[1986];
gout[n*2187+961] += + s[1987];
gout[n*2187+962] += + s[1988];
gout[n*2187+963] += + s[1989];
gout[n*2187+964] += + s[1990];
gout[n*2187+965] += + s[1991];
gout[n*2187+966] += + s[1992];
gout[n*2187+967] += + s[1993];
gout[n*2187+968] += + s[1994];
gout[n*2187+969] += + s[1995];
gout[n*2187+970] += + s[1996];
gout[n*2187+971] += + s[1997];
gout[n*2187+972] += + s[108];
gout[n*2187+973] += + s[109];
gout[n*2187+974] += + s[110];
gout[n*2187+975] += + s[111];
gout[n*2187+976] += + s[112];
gout[n*2187+977] += + s[113];
gout[n*2187+978] += + s[114];
gout[n*2187+979] += + s[115];
gout[n*2187+980] += + s[116];
gout[n*2187+981] += + s[117];
gout[n*2187+982] += + s[118];
gout[n*2187+983] += + s[119];
gout[n*2187+984] += + s[120];
gout[n*2187+985] += + s[121];
gout[n*2187+986] += + s[122];
gout[n*2187+987] += + s[123];
gout[n*2187+988] += + s[124];
gout[n*2187+989] += + s[125];
gout[n*2187+990] += + s[126];
gout[n*2187+991] += + s[127];
gout[n*2187+992] += + s[128];
gout[n*2187+993] += + s[129];
gout[n*2187+994] += + s[130];
gout[n*2187+995] += + s[131];
gout[n*2187+996] += + s[132];
gout[n*2187+997] += + s[133];
gout[n*2187+998] += + s[134];
gout[n*2187+999] += + s[837];
gout[n*2187+1000] += + s[838];
gout[n*2187+1001] += + s[839];
gout[n*2187+1002] += + s[840];
gout[n*2187+1003] += + s[841];
gout[n*2187+1004] += + s[842];
gout[n*2187+1005] += + s[843];
gout[n*2187+1006] += + s[844];
gout[n*2187+1007] += + s[845];
gout[n*2187+1008] += + s[846];
gout[n*2187+1009] += + s[847];
gout[n*2187+1010] += + s[848];
gout[n*2187+1011] += + s[849];
gout[n*2187+1012] += + s[850];
gout[n*2187+1013] += + s[851];
gout[n*2187+1014] += + s[852];
gout[n*2187+1015] += + s[853];
gout[n*2187+1016] += + s[854];
gout[n*2187+1017] += + s[855];
gout[n*2187+1018] += + s[856];
gout[n*2187+1019] += + s[857];
gout[n*2187+1020] += + s[858];
gout[n*2187+1021] += + s[859];
gout[n*2187+1022] += + s[860];
gout[n*2187+1023] += + s[861];
gout[n*2187+1024] += + s[862];
gout[n*2187+1025] += + s[863];
gout[n*2187+1026] += + s[1566];
gout[n*2187+1027] += + s[1567];
gout[n*2187+1028] += + s[1568];
gout[n*2187+1029] += + s[1569];
gout[n*2187+1030] += + s[1570];
gout[n*2187+1031] += + s[1571];
gout[n*2187+1032] += + s[1572];
gout[n*2187+1033] += + s[1573];
gout[n*2187+1034] += + s[1574];
gout[n*2187+1035] += + s[1575];
gout[n*2187+1036] += + s[1576];
gout[n*2187+1037] += + s[1577];
gout[n*2187+1038] += + s[1578];
gout[n*2187+1039] += + s[1579];
gout[n*2187+1040] += + s[1580];
gout[n*2187+1041] += + s[1581];
gout[n*2187+1042] += + s[1582];
gout[n*2187+1043] += + s[1583];
gout[n*2187+1044] += + s[1584];
gout[n*2187+1045] += + s[1585];
gout[n*2187+1046] += + s[1586];
gout[n*2187+1047] += + s[1587];
gout[n*2187+1048] += + s[1588];
gout[n*2187+1049] += + s[1589];
gout[n*2187+1050] += + s[1590];
gout[n*2187+1051] += + s[1591];
gout[n*2187+1052] += + s[1592];
gout[n*2187+1053] += + s[351];
gout[n*2187+1054] += + s[352];
gout[n*2187+1055] += + s[353];
gout[n*2187+1056] += + s[354];
gout[n*2187+1057] += + s[355];
gout[n*2187+1058] += + s[356];
gout[n*2187+1059] += + s[357];
gout[n*2187+1060] += + s[358];
gout[n*2187+1061] += + s[359];
gout[n*2187+1062] += + s[360];
gout[n*2187+1063] += + s[361];
gout[n*2187+1064] += + s[362];
gout[n*2187+1065] += + s[363];
gout[n*2187+1066] += + s[364];
gout[n*2187+1067] += + s[365];
gout[n*2187+1068] += + s[366];
gout[n*2187+1069] += + s[367];
gout[n*2187+1070] += + s[368];
gout[n*2187+1071] += + s[369];
gout[n*2187+1072] += + s[370];
gout[n*2187+1073] += + s[371];
gout[n*2187+1074] += + s[372];
gout[n*2187+1075] += + s[373];
gout[n*2187+1076] += + s[374];
gout[n*2187+1077] += + s[375];
gout[n*2187+1078] += + s[376];
gout[n*2187+1079] += + s[377];
gout[n*2187+1080] += + s[1080];
gout[n*2187+1081] += + s[1081];
gout[n*2187+1082] += + s[1082];
gout[n*2187+1083] += + s[1083];
gout[n*2187+1084] += + s[1084];
gout[n*2187+1085] += + s[1085];
gout[n*2187+1086] += + s[1086];
gout[n*2187+1087] += + s[1087];
gout[n*2187+1088] += + s[1088];
gout[n*2187+1089] += + s[1089];
gout[n*2187+1090] += + s[1090];
gout[n*2187+1091] += + s[1091];
gout[n*2187+1092] += + s[1092];
gout[n*2187+1093] += + s[1093];
gout[n*2187+1094] += + s[1094];
gout[n*2187+1095] += + s[1095];
gout[n*2187+1096] += + s[1096];
gout[n*2187+1097] += + s[1097];
gout[n*2187+1098] += + s[1098];
gout[n*2187+1099] += + s[1099];
gout[n*2187+1100] += + s[1100];
gout[n*2187+1101] += + s[1101];
gout[n*2187+1102] += + s[1102];
gout[n*2187+1103] += + s[1103];
gout[n*2187+1104] += + s[1104];
gout[n*2187+1105] += + s[1105];
gout[n*2187+1106] += + s[1106];
gout[n*2187+1107] += + s[1809];
gout[n*2187+1108] += + s[1810];
gout[n*2187+1109] += + s[1811];
gout[n*2187+1110] += + s[1812];
gout[n*2187+1111] += + s[1813];
gout[n*2187+1112] += + s[1814];
gout[n*2187+1113] += + s[1815];
gout[n*2187+1114] += + s[1816];
gout[n*2187+1115] += + s[1817];
gout[n*2187+1116] += + s[1818];
gout[n*2187+1117] += + s[1819];
gout[n*2187+1118] += + s[1820];
gout[n*2187+1119] += + s[1821];
gout[n*2187+1120] += + s[1822];
gout[n*2187+1121] += + s[1823];
gout[n*2187+1122] += + s[1824];
gout[n*2187+1123] += + s[1825];
gout[n*2187+1124] += + s[1826];
gout[n*2187+1125] += + s[1827];
gout[n*2187+1126] += + s[1828];
gout[n*2187+1127] += + s[1829];
gout[n*2187+1128] += + s[1830];
gout[n*2187+1129] += + s[1831];
gout[n*2187+1130] += + s[1832];
gout[n*2187+1131] += + s[1833];
gout[n*2187+1132] += + s[1834];
gout[n*2187+1133] += + s[1835];
gout[n*2187+1134] += + s[594];
gout[n*2187+1135] += + s[595];
gout[n*2187+1136] += + s[596];
gout[n*2187+1137] += + s[597];
gout[n*2187+1138] += + s[598];
gout[n*2187+1139] += + s[599];
gout[n*2187+1140] += + s[600];
gout[n*2187+1141] += + s[601];
gout[n*2187+1142] += + s[602];
gout[n*2187+1143] += + s[603];
gout[n*2187+1144] += + s[604];
gout[n*2187+1145] += + s[605];
gout[n*2187+1146] += + s[606];
gout[n*2187+1147] += + s[607];
gout[n*2187+1148] += + s[608];
gout[n*2187+1149] += + s[609];
gout[n*2187+1150] += + s[610];
gout[n*2187+1151] += + s[611];
gout[n*2187+1152] += + s[612];
gout[n*2187+1153] += + s[613];
gout[n*2187+1154] += + s[614];
gout[n*2187+1155] += + s[615];
gout[n*2187+1156] += + s[616];
gout[n*2187+1157] += + s[617];
gout[n*2187+1158] += + s[618];
gout[n*2187+1159] += + s[619];
gout[n*2187+1160] += + s[620];
gout[n*2187+1161] += + s[1323];
gout[n*2187+1162] += + s[1324];
gout[n*2187+1163] += + s[1325];
gout[n*2187+1164] += + s[1326];
gout[n*2187+1165] += + s[1327];
gout[n*2187+1166] += + s[1328];
gout[n*2187+1167] += + s[1329];
gout[n*2187+1168] += + s[1330];
gout[n*2187+1169] += + s[1331];
gout[n*2187+1170] += + s[1332];
gout[n*2187+1171] += + s[1333];
gout[n*2187+1172] += + s[1334];
gout[n*2187+1173] += + s[1335];
gout[n*2187+1174] += + s[1336];
gout[n*2187+1175] += + s[1337];
gout[n*2187+1176] += + s[1338];
gout[n*2187+1177] += + s[1339];
gout[n*2187+1178] += + s[1340];
gout[n*2187+1179] += + s[1341];
gout[n*2187+1180] += + s[1342];
gout[n*2187+1181] += + s[1343];
gout[n*2187+1182] += + s[1344];
gout[n*2187+1183] += + s[1345];
gout[n*2187+1184] += + s[1346];
gout[n*2187+1185] += + s[1347];
gout[n*2187+1186] += + s[1348];
gout[n*2187+1187] += + s[1349];
gout[n*2187+1188] += + s[2052];
gout[n*2187+1189] += + s[2053];
gout[n*2187+1190] += + s[2054];
gout[n*2187+1191] += + s[2055];
gout[n*2187+1192] += + s[2056];
gout[n*2187+1193] += + s[2057];
gout[n*2187+1194] += + s[2058];
gout[n*2187+1195] += + s[2059];
gout[n*2187+1196] += + s[2060];
gout[n*2187+1197] += + s[2061];
gout[n*2187+1198] += + s[2062];
gout[n*2187+1199] += + s[2063];
gout[n*2187+1200] += + s[2064];
gout[n*2187+1201] += + s[2065];
gout[n*2187+1202] += + s[2066];
gout[n*2187+1203] += + s[2067];
gout[n*2187+1204] += + s[2068];
gout[n*2187+1205] += + s[2069];
gout[n*2187+1206] += + s[2070];
gout[n*2187+1207] += + s[2071];
gout[n*2187+1208] += + s[2072];
gout[n*2187+1209] += + s[2073];
gout[n*2187+1210] += + s[2074];
gout[n*2187+1211] += + s[2075];
gout[n*2187+1212] += + s[2076];
gout[n*2187+1213] += + s[2077];
gout[n*2187+1214] += + s[2078];
gout[n*2187+1215] += + s[189];
gout[n*2187+1216] += + s[190];
gout[n*2187+1217] += + s[191];
gout[n*2187+1218] += + s[192];
gout[n*2187+1219] += + s[193];
gout[n*2187+1220] += + s[194];
gout[n*2187+1221] += + s[195];
gout[n*2187+1222] += + s[196];
gout[n*2187+1223] += + s[197];
gout[n*2187+1224] += + s[198];
gout[n*2187+1225] += + s[199];
gout[n*2187+1226] += + s[200];
gout[n*2187+1227] += + s[201];
gout[n*2187+1228] += + s[202];
gout[n*2187+1229] += + s[203];
gout[n*2187+1230] += + s[204];
gout[n*2187+1231] += + s[205];
gout[n*2187+1232] += + s[206];
gout[n*2187+1233] += + s[207];
gout[n*2187+1234] += + s[208];
gout[n*2187+1235] += + s[209];
gout[n*2187+1236] += + s[210];
gout[n*2187+1237] += + s[211];
gout[n*2187+1238] += + s[212];
gout[n*2187+1239] += + s[213];
gout[n*2187+1240] += + s[214];
gout[n*2187+1241] += + s[215];
gout[n*2187+1242] += + s[918];
gout[n*2187+1243] += + s[919];
gout[n*2187+1244] += + s[920];
gout[n*2187+1245] += + s[921];
gout[n*2187+1246] += + s[922];
gout[n*2187+1247] += + s[923];
gout[n*2187+1248] += + s[924];
gout[n*2187+1249] += + s[925];
gout[n*2187+1250] += + s[926];
gout[n*2187+1251] += + s[927];
gout[n*2187+1252] += + s[928];
gout[n*2187+1253] += + s[929];
gout[n*2187+1254] += + s[930];
gout[n*2187+1255] += + s[931];
gout[n*2187+1256] += + s[932];
gout[n*2187+1257] += + s[933];
gout[n*2187+1258] += + s[934];
gout[n*2187+1259] += + s[935];
gout[n*2187+1260] += + s[936];
gout[n*2187+1261] += + s[937];
gout[n*2187+1262] += + s[938];
gout[n*2187+1263] += + s[939];
gout[n*2187+1264] += + s[940];
gout[n*2187+1265] += + s[941];
gout[n*2187+1266] += + s[942];
gout[n*2187+1267] += + s[943];
gout[n*2187+1268] += + s[944];
gout[n*2187+1269] += + s[1647];
gout[n*2187+1270] += + s[1648];
gout[n*2187+1271] += + s[1649];
gout[n*2187+1272] += + s[1650];
gout[n*2187+1273] += + s[1651];
gout[n*2187+1274] += + s[1652];
gout[n*2187+1275] += + s[1653];
gout[n*2187+1276] += + s[1654];
gout[n*2187+1277] += + s[1655];
gout[n*2187+1278] += + s[1656];
gout[n*2187+1279] += + s[1657];
gout[n*2187+1280] += + s[1658];
gout[n*2187+1281] += + s[1659];
gout[n*2187+1282] += + s[1660];
gout[n*2187+1283] += + s[1661];
gout[n*2187+1284] += + s[1662];
gout[n*2187+1285] += + s[1663];
gout[n*2187+1286] += + s[1664];
gout[n*2187+1287] += + s[1665];
gout[n*2187+1288] += + s[1666];
gout[n*2187+1289] += + s[1667];
gout[n*2187+1290] += + s[1668];
gout[n*2187+1291] += + s[1669];
gout[n*2187+1292] += + s[1670];
gout[n*2187+1293] += + s[1671];
gout[n*2187+1294] += + s[1672];
gout[n*2187+1295] += + s[1673];
gout[n*2187+1296] += + s[432];
gout[n*2187+1297] += + s[433];
gout[n*2187+1298] += + s[434];
gout[n*2187+1299] += + s[435];
gout[n*2187+1300] += + s[436];
gout[n*2187+1301] += + s[437];
gout[n*2187+1302] += + s[438];
gout[n*2187+1303] += + s[439];
gout[n*2187+1304] += + s[440];
gout[n*2187+1305] += + s[441];
gout[n*2187+1306] += + s[442];
gout[n*2187+1307] += + s[443];
gout[n*2187+1308] += + s[444];
gout[n*2187+1309] += + s[445];
gout[n*2187+1310] += + s[446];
gout[n*2187+1311] += + s[447];
gout[n*2187+1312] += + s[448];
gout[n*2187+1313] += + s[449];
gout[n*2187+1314] += + s[450];
gout[n*2187+1315] += + s[451];
gout[n*2187+1316] += + s[452];
gout[n*2187+1317] += + s[453];
gout[n*2187+1318] += + s[454];
gout[n*2187+1319] += + s[455];
gout[n*2187+1320] += + s[456];
gout[n*2187+1321] += + s[457];
gout[n*2187+1322] += + s[458];
gout[n*2187+1323] += + s[1161];
gout[n*2187+1324] += + s[1162];
gout[n*2187+1325] += + s[1163];
gout[n*2187+1326] += + s[1164];
gout[n*2187+1327] += + s[1165];
gout[n*2187+1328] += + s[1166];
gout[n*2187+1329] += + s[1167];
gout[n*2187+1330] += + s[1168];
gout[n*2187+1331] += + s[1169];
gout[n*2187+1332] += + s[1170];
gout[n*2187+1333] += + s[1171];
gout[n*2187+1334] += + s[1172];
gout[n*2187+1335] += + s[1173];
gout[n*2187+1336] += + s[1174];
gout[n*2187+1337] += + s[1175];
gout[n*2187+1338] += + s[1176];
gout[n*2187+1339] += + s[1177];
gout[n*2187+1340] += + s[1178];
gout[n*2187+1341] += + s[1179];
gout[n*2187+1342] += + s[1180];
gout[n*2187+1343] += + s[1181];
gout[n*2187+1344] += + s[1182];
gout[n*2187+1345] += + s[1183];
gout[n*2187+1346] += + s[1184];
gout[n*2187+1347] += + s[1185];
gout[n*2187+1348] += + s[1186];
gout[n*2187+1349] += + s[1187];
gout[n*2187+1350] += + s[1890];
gout[n*2187+1351] += + s[1891];
gout[n*2187+1352] += + s[1892];
gout[n*2187+1353] += + s[1893];
gout[n*2187+1354] += + s[1894];
gout[n*2187+1355] += + s[1895];
gout[n*2187+1356] += + s[1896];
gout[n*2187+1357] += + s[1897];
gout[n*2187+1358] += + s[1898];
gout[n*2187+1359] += + s[1899];
gout[n*2187+1360] += + s[1900];
gout[n*2187+1361] += + s[1901];
gout[n*2187+1362] += + s[1902];
gout[n*2187+1363] += + s[1903];
gout[n*2187+1364] += + s[1904];
gout[n*2187+1365] += + s[1905];
gout[n*2187+1366] += + s[1906];
gout[n*2187+1367] += + s[1907];
gout[n*2187+1368] += + s[1908];
gout[n*2187+1369] += + s[1909];
gout[n*2187+1370] += + s[1910];
gout[n*2187+1371] += + s[1911];
gout[n*2187+1372] += + s[1912];
gout[n*2187+1373] += + s[1913];
gout[n*2187+1374] += + s[1914];
gout[n*2187+1375] += + s[1915];
gout[n*2187+1376] += + s[1916];
gout[n*2187+1377] += + s[675];
gout[n*2187+1378] += + s[676];
gout[n*2187+1379] += + s[677];
gout[n*2187+1380] += + s[678];
gout[n*2187+1381] += + s[679];
gout[n*2187+1382] += + s[680];
gout[n*2187+1383] += + s[681];
gout[n*2187+1384] += + s[682];
gout[n*2187+1385] += + s[683];
gout[n*2187+1386] += + s[684];
gout[n*2187+1387] += + s[685];
gout[n*2187+1388] += + s[686];
gout[n*2187+1389] += + s[687];
gout[n*2187+1390] += + s[688];
gout[n*2187+1391] += + s[689];
gout[n*2187+1392] += + s[690];
gout[n*2187+1393] += + s[691];
gout[n*2187+1394] += + s[692];
gout[n*2187+1395] += + s[693];
gout[n*2187+1396] += + s[694];
gout[n*2187+1397] += + s[695];
gout[n*2187+1398] += + s[696];
gout[n*2187+1399] += + s[697];
gout[n*2187+1400] += + s[698];
gout[n*2187+1401] += + s[699];
gout[n*2187+1402] += + s[700];
gout[n*2187+1403] += + s[701];
gout[n*2187+1404] += + s[1404];
gout[n*2187+1405] += + s[1405];
gout[n*2187+1406] += + s[1406];
gout[n*2187+1407] += + s[1407];
gout[n*2187+1408] += + s[1408];
gout[n*2187+1409] += + s[1409];
gout[n*2187+1410] += + s[1410];
gout[n*2187+1411] += + s[1411];
gout[n*2187+1412] += + s[1412];
gout[n*2187+1413] += + s[1413];
gout[n*2187+1414] += + s[1414];
gout[n*2187+1415] += + s[1415];
gout[n*2187+1416] += + s[1416];
gout[n*2187+1417] += + s[1417];
gout[n*2187+1418] += + s[1418];
gout[n*2187+1419] += + s[1419];
gout[n*2187+1420] += + s[1420];
gout[n*2187+1421] += + s[1421];
gout[n*2187+1422] += + s[1422];
gout[n*2187+1423] += + s[1423];
gout[n*2187+1424] += + s[1424];
gout[n*2187+1425] += + s[1425];
gout[n*2187+1426] += + s[1426];
gout[n*2187+1427] += + s[1427];
gout[n*2187+1428] += + s[1428];
gout[n*2187+1429] += + s[1429];
gout[n*2187+1430] += + s[1430];
gout[n*2187+1431] += + s[2133];
gout[n*2187+1432] += + s[2134];
gout[n*2187+1433] += + s[2135];
gout[n*2187+1434] += + s[2136];
gout[n*2187+1435] += + s[2137];
gout[n*2187+1436] += + s[2138];
gout[n*2187+1437] += + s[2139];
gout[n*2187+1438] += + s[2140];
gout[n*2187+1439] += + s[2141];
gout[n*2187+1440] += + s[2142];
gout[n*2187+1441] += + s[2143];
gout[n*2187+1442] += + s[2144];
gout[n*2187+1443] += + s[2145];
gout[n*2187+1444] += + s[2146];
gout[n*2187+1445] += + s[2147];
gout[n*2187+1446] += + s[2148];
gout[n*2187+1447] += + s[2149];
gout[n*2187+1448] += + s[2150];
gout[n*2187+1449] += + s[2151];
gout[n*2187+1450] += + s[2152];
gout[n*2187+1451] += + s[2153];
gout[n*2187+1452] += + s[2154];
gout[n*2187+1453] += + s[2155];
gout[n*2187+1454] += + s[2156];
gout[n*2187+1455] += + s[2157];
gout[n*2187+1456] += + s[2158];
gout[n*2187+1457] += + s[2159];
gout[n*2187+1458] += + s[54];
gout[n*2187+1459] += + s[55];
gout[n*2187+1460] += + s[56];
gout[n*2187+1461] += + s[57];
gout[n*2187+1462] += + s[58];
gout[n*2187+1463] += + s[59];
gout[n*2187+1464] += + s[60];
gout[n*2187+1465] += + s[61];
gout[n*2187+1466] += + s[62];
gout[n*2187+1467] += + s[63];
gout[n*2187+1468] += + s[64];
gout[n*2187+1469] += + s[65];
gout[n*2187+1470] += + s[66];
gout[n*2187+1471] += + s[67];
gout[n*2187+1472] += + s[68];
gout[n*2187+1473] += + s[69];
gout[n*2187+1474] += + s[70];
gout[n*2187+1475] += + s[71];
gout[n*2187+1476] += + s[72];
gout[n*2187+1477] += + s[73];
gout[n*2187+1478] += + s[74];
gout[n*2187+1479] += + s[75];
gout[n*2187+1480] += + s[76];
gout[n*2187+1481] += + s[77];
gout[n*2187+1482] += + s[78];
gout[n*2187+1483] += + s[79];
gout[n*2187+1484] += + s[80];
gout[n*2187+1485] += + s[783];
gout[n*2187+1486] += + s[784];
gout[n*2187+1487] += + s[785];
gout[n*2187+1488] += + s[786];
gout[n*2187+1489] += + s[787];
gout[n*2187+1490] += + s[788];
gout[n*2187+1491] += + s[789];
gout[n*2187+1492] += + s[790];
gout[n*2187+1493] += + s[791];
gout[n*2187+1494] += + s[792];
gout[n*2187+1495] += + s[793];
gout[n*2187+1496] += + s[794];
gout[n*2187+1497] += + s[795];
gout[n*2187+1498] += + s[796];
gout[n*2187+1499] += + s[797];
gout[n*2187+1500] += + s[798];
gout[n*2187+1501] += + s[799];
gout[n*2187+1502] += + s[800];
gout[n*2187+1503] += + s[801];
gout[n*2187+1504] += + s[802];
gout[n*2187+1505] += + s[803];
gout[n*2187+1506] += + s[804];
gout[n*2187+1507] += + s[805];
gout[n*2187+1508] += + s[806];
gout[n*2187+1509] += + s[807];
gout[n*2187+1510] += + s[808];
gout[n*2187+1511] += + s[809];
gout[n*2187+1512] += + s[1512];
gout[n*2187+1513] += + s[1513];
gout[n*2187+1514] += + s[1514];
gout[n*2187+1515] += + s[1515];
gout[n*2187+1516] += + s[1516];
gout[n*2187+1517] += + s[1517];
gout[n*2187+1518] += + s[1518];
gout[n*2187+1519] += + s[1519];
gout[n*2187+1520] += + s[1520];
gout[n*2187+1521] += + s[1521];
gout[n*2187+1522] += + s[1522];
gout[n*2187+1523] += + s[1523];
gout[n*2187+1524] += + s[1524];
gout[n*2187+1525] += + s[1525];
gout[n*2187+1526] += + s[1526];
gout[n*2187+1527] += + s[1527];
gout[n*2187+1528] += + s[1528];
gout[n*2187+1529] += + s[1529];
gout[n*2187+1530] += + s[1530];
gout[n*2187+1531] += + s[1531];
gout[n*2187+1532] += + s[1532];
gout[n*2187+1533] += + s[1533];
gout[n*2187+1534] += + s[1534];
gout[n*2187+1535] += + s[1535];
gout[n*2187+1536] += + s[1536];
gout[n*2187+1537] += + s[1537];
gout[n*2187+1538] += + s[1538];
gout[n*2187+1539] += + s[297];
gout[n*2187+1540] += + s[298];
gout[n*2187+1541] += + s[299];
gout[n*2187+1542] += + s[300];
gout[n*2187+1543] += + s[301];
gout[n*2187+1544] += + s[302];
gout[n*2187+1545] += + s[303];
gout[n*2187+1546] += + s[304];
gout[n*2187+1547] += + s[305];
gout[n*2187+1548] += + s[306];
gout[n*2187+1549] += + s[307];
gout[n*2187+1550] += + s[308];
gout[n*2187+1551] += + s[309];
gout[n*2187+1552] += + s[310];
gout[n*2187+1553] += + s[311];
gout[n*2187+1554] += + s[312];
gout[n*2187+1555] += + s[313];
gout[n*2187+1556] += + s[314];
gout[n*2187+1557] += + s[315];
gout[n*2187+1558] += + s[316];
gout[n*2187+1559] += + s[317];
gout[n*2187+1560] += + s[318];
gout[n*2187+1561] += + s[319];
gout[n*2187+1562] += + s[320];
gout[n*2187+1563] += + s[321];
gout[n*2187+1564] += + s[322];
gout[n*2187+1565] += + s[323];
gout[n*2187+1566] += + s[1026];
gout[n*2187+1567] += + s[1027];
gout[n*2187+1568] += + s[1028];
gout[n*2187+1569] += + s[1029];
gout[n*2187+1570] += + s[1030];
gout[n*2187+1571] += + s[1031];
gout[n*2187+1572] += + s[1032];
gout[n*2187+1573] += + s[1033];
gout[n*2187+1574] += + s[1034];
gout[n*2187+1575] += + s[1035];
gout[n*2187+1576] += + s[1036];
gout[n*2187+1577] += + s[1037];
gout[n*2187+1578] += + s[1038];
gout[n*2187+1579] += + s[1039];
gout[n*2187+1580] += + s[1040];
gout[n*2187+1581] += + s[1041];
gout[n*2187+1582] += + s[1042];
gout[n*2187+1583] += + s[1043];
gout[n*2187+1584] += + s[1044];
gout[n*2187+1585] += + s[1045];
gout[n*2187+1586] += + s[1046];
gout[n*2187+1587] += + s[1047];
gout[n*2187+1588] += + s[1048];
gout[n*2187+1589] += + s[1049];
gout[n*2187+1590] += + s[1050];
gout[n*2187+1591] += + s[1051];
gout[n*2187+1592] += + s[1052];
gout[n*2187+1593] += + s[1755];
gout[n*2187+1594] += + s[1756];
gout[n*2187+1595] += + s[1757];
gout[n*2187+1596] += + s[1758];
gout[n*2187+1597] += + s[1759];
gout[n*2187+1598] += + s[1760];
gout[n*2187+1599] += + s[1761];
gout[n*2187+1600] += + s[1762];
gout[n*2187+1601] += + s[1763];
gout[n*2187+1602] += + s[1764];
gout[n*2187+1603] += + s[1765];
gout[n*2187+1604] += + s[1766];
gout[n*2187+1605] += + s[1767];
gout[n*2187+1606] += + s[1768];
gout[n*2187+1607] += + s[1769];
gout[n*2187+1608] += + s[1770];
gout[n*2187+1609] += + s[1771];
gout[n*2187+1610] += + s[1772];
gout[n*2187+1611] += + s[1773];
gout[n*2187+1612] += + s[1774];
gout[n*2187+1613] += + s[1775];
gout[n*2187+1614] += + s[1776];
gout[n*2187+1615] += + s[1777];
gout[n*2187+1616] += + s[1778];
gout[n*2187+1617] += + s[1779];
gout[n*2187+1618] += + s[1780];
gout[n*2187+1619] += + s[1781];
gout[n*2187+1620] += + s[540];
gout[n*2187+1621] += + s[541];
gout[n*2187+1622] += + s[542];
gout[n*2187+1623] += + s[543];
gout[n*2187+1624] += + s[544];
gout[n*2187+1625] += + s[545];
gout[n*2187+1626] += + s[546];
gout[n*2187+1627] += + s[547];
gout[n*2187+1628] += + s[548];
gout[n*2187+1629] += + s[549];
gout[n*2187+1630] += + s[550];
gout[n*2187+1631] += + s[551];
gout[n*2187+1632] += + s[552];
gout[n*2187+1633] += + s[553];
gout[n*2187+1634] += + s[554];
gout[n*2187+1635] += + s[555];
gout[n*2187+1636] += + s[556];
gout[n*2187+1637] += + s[557];
gout[n*2187+1638] += + s[558];
gout[n*2187+1639] += + s[559];
gout[n*2187+1640] += + s[560];
gout[n*2187+1641] += + s[561];
gout[n*2187+1642] += + s[562];
gout[n*2187+1643] += + s[563];
gout[n*2187+1644] += + s[564];
gout[n*2187+1645] += + s[565];
gout[n*2187+1646] += + s[566];
gout[n*2187+1647] += + s[1269];
gout[n*2187+1648] += + s[1270];
gout[n*2187+1649] += + s[1271];
gout[n*2187+1650] += + s[1272];
gout[n*2187+1651] += + s[1273];
gout[n*2187+1652] += + s[1274];
gout[n*2187+1653] += + s[1275];
gout[n*2187+1654] += + s[1276];
gout[n*2187+1655] += + s[1277];
gout[n*2187+1656] += + s[1278];
gout[n*2187+1657] += + s[1279];
gout[n*2187+1658] += + s[1280];
gout[n*2187+1659] += + s[1281];
gout[n*2187+1660] += + s[1282];
gout[n*2187+1661] += + s[1283];
gout[n*2187+1662] += + s[1284];
gout[n*2187+1663] += + s[1285];
gout[n*2187+1664] += + s[1286];
gout[n*2187+1665] += + s[1287];
gout[n*2187+1666] += + s[1288];
gout[n*2187+1667] += + s[1289];
gout[n*2187+1668] += + s[1290];
gout[n*2187+1669] += + s[1291];
gout[n*2187+1670] += + s[1292];
gout[n*2187+1671] += + s[1293];
gout[n*2187+1672] += + s[1294];
gout[n*2187+1673] += + s[1295];
gout[n*2187+1674] += + s[1998];
gout[n*2187+1675] += + s[1999];
gout[n*2187+1676] += + s[2000];
gout[n*2187+1677] += + s[2001];
gout[n*2187+1678] += + s[2002];
gout[n*2187+1679] += + s[2003];
gout[n*2187+1680] += + s[2004];
gout[n*2187+1681] += + s[2005];
gout[n*2187+1682] += + s[2006];
gout[n*2187+1683] += + s[2007];
gout[n*2187+1684] += + s[2008];
gout[n*2187+1685] += + s[2009];
gout[n*2187+1686] += + s[2010];
gout[n*2187+1687] += + s[2011];
gout[n*2187+1688] += + s[2012];
gout[n*2187+1689] += + s[2013];
gout[n*2187+1690] += + s[2014];
gout[n*2187+1691] += + s[2015];
gout[n*2187+1692] += + s[2016];
gout[n*2187+1693] += + s[2017];
gout[n*2187+1694] += + s[2018];
gout[n*2187+1695] += + s[2019];
gout[n*2187+1696] += + s[2020];
gout[n*2187+1697] += + s[2021];
gout[n*2187+1698] += + s[2022];
gout[n*2187+1699] += + s[2023];
gout[n*2187+1700] += + s[2024];
gout[n*2187+1701] += + s[135];
gout[n*2187+1702] += + s[136];
gout[n*2187+1703] += + s[137];
gout[n*2187+1704] += + s[138];
gout[n*2187+1705] += + s[139];
gout[n*2187+1706] += + s[140];
gout[n*2187+1707] += + s[141];
gout[n*2187+1708] += + s[142];
gout[n*2187+1709] += + s[143];
gout[n*2187+1710] += + s[144];
gout[n*2187+1711] += + s[145];
gout[n*2187+1712] += + s[146];
gout[n*2187+1713] += + s[147];
gout[n*2187+1714] += + s[148];
gout[n*2187+1715] += + s[149];
gout[n*2187+1716] += + s[150];
gout[n*2187+1717] += + s[151];
gout[n*2187+1718] += + s[152];
gout[n*2187+1719] += + s[153];
gout[n*2187+1720] += + s[154];
gout[n*2187+1721] += + s[155];
gout[n*2187+1722] += + s[156];
gout[n*2187+1723] += + s[157];
gout[n*2187+1724] += + s[158];
gout[n*2187+1725] += + s[159];
gout[n*2187+1726] += + s[160];
gout[n*2187+1727] += + s[161];
gout[n*2187+1728] += + s[864];
gout[n*2187+1729] += + s[865];
gout[n*2187+1730] += + s[866];
gout[n*2187+1731] += + s[867];
gout[n*2187+1732] += + s[868];
gout[n*2187+1733] += + s[869];
gout[n*2187+1734] += + s[870];
gout[n*2187+1735] += + s[871];
gout[n*2187+1736] += + s[872];
gout[n*2187+1737] += + s[873];
gout[n*2187+1738] += + s[874];
gout[n*2187+1739] += + s[875];
gout[n*2187+1740] += + s[876];
gout[n*2187+1741] += + s[877];
gout[n*2187+1742] += + s[878];
gout[n*2187+1743] += + s[879];
gout[n*2187+1744] += + s[880];
gout[n*2187+1745] += + s[881];
gout[n*2187+1746] += + s[882];
gout[n*2187+1747] += + s[883];
gout[n*2187+1748] += + s[884];
gout[n*2187+1749] += + s[885];
gout[n*2187+1750] += + s[886];
gout[n*2187+1751] += + s[887];
gout[n*2187+1752] += + s[888];
gout[n*2187+1753] += + s[889];
gout[n*2187+1754] += + s[890];
gout[n*2187+1755] += + s[1593];
gout[n*2187+1756] += + s[1594];
gout[n*2187+1757] += + s[1595];
gout[n*2187+1758] += + s[1596];
gout[n*2187+1759] += + s[1597];
gout[n*2187+1760] += + s[1598];
gout[n*2187+1761] += + s[1599];
gout[n*2187+1762] += + s[1600];
gout[n*2187+1763] += + s[1601];
gout[n*2187+1764] += + s[1602];
gout[n*2187+1765] += + s[1603];
gout[n*2187+1766] += + s[1604];
gout[n*2187+1767] += + s[1605];
gout[n*2187+1768] += + s[1606];
gout[n*2187+1769] += + s[1607];
gout[n*2187+1770] += + s[1608];
gout[n*2187+1771] += + s[1609];
gout[n*2187+1772] += + s[1610];
gout[n*2187+1773] += + s[1611];
gout[n*2187+1774] += + s[1612];
gout[n*2187+1775] += + s[1613];
gout[n*2187+1776] += + s[1614];
gout[n*2187+1777] += + s[1615];
gout[n*2187+1778] += + s[1616];
gout[n*2187+1779] += + s[1617];
gout[n*2187+1780] += + s[1618];
gout[n*2187+1781] += + s[1619];
gout[n*2187+1782] += + s[378];
gout[n*2187+1783] += + s[379];
gout[n*2187+1784] += + s[380];
gout[n*2187+1785] += + s[381];
gout[n*2187+1786] += + s[382];
gout[n*2187+1787] += + s[383];
gout[n*2187+1788] += + s[384];
gout[n*2187+1789] += + s[385];
gout[n*2187+1790] += + s[386];
gout[n*2187+1791] += + s[387];
gout[n*2187+1792] += + s[388];
gout[n*2187+1793] += + s[389];
gout[n*2187+1794] += + s[390];
gout[n*2187+1795] += + s[391];
gout[n*2187+1796] += + s[392];
gout[n*2187+1797] += + s[393];
gout[n*2187+1798] += + s[394];
gout[n*2187+1799] += + s[395];
gout[n*2187+1800] += + s[396];
gout[n*2187+1801] += + s[397];
gout[n*2187+1802] += + s[398];
gout[n*2187+1803] += + s[399];
gout[n*2187+1804] += + s[400];
gout[n*2187+1805] += + s[401];
gout[n*2187+1806] += + s[402];
gout[n*2187+1807] += + s[403];
gout[n*2187+1808] += + s[404];
gout[n*2187+1809] += + s[1107];
gout[n*2187+1810] += + s[1108];
gout[n*2187+1811] += + s[1109];
gout[n*2187+1812] += + s[1110];
gout[n*2187+1813] += + s[1111];
gout[n*2187+1814] += + s[1112];
gout[n*2187+1815] += + s[1113];
gout[n*2187+1816] += + s[1114];
gout[n*2187+1817] += + s[1115];
gout[n*2187+1818] += + s[1116];
gout[n*2187+1819] += + s[1117];
gout[n*2187+1820] += + s[1118];
gout[n*2187+1821] += + s[1119];
gout[n*2187+1822] += + s[1120];
gout[n*2187+1823] += + s[1121];
gout[n*2187+1824] += + s[1122];
gout[n*2187+1825] += + s[1123];
gout[n*2187+1826] += + s[1124];
gout[n*2187+1827] += + s[1125];
gout[n*2187+1828] += + s[1126];
gout[n*2187+1829] += + s[1127];
gout[n*2187+1830] += + s[1128];
gout[n*2187+1831] += + s[1129];
gout[n*2187+1832] += + s[1130];
gout[n*2187+1833] += + s[1131];
gout[n*2187+1834] += + s[1132];
gout[n*2187+1835] += + s[1133];
gout[n*2187+1836] += + s[1836];
gout[n*2187+1837] += + s[1837];
gout[n*2187+1838] += + s[1838];
gout[n*2187+1839] += + s[1839];
gout[n*2187+1840] += + s[1840];
gout[n*2187+1841] += + s[1841];
gout[n*2187+1842] += + s[1842];
gout[n*2187+1843] += + s[1843];
gout[n*2187+1844] += + s[1844];
gout[n*2187+1845] += + s[1845];
gout[n*2187+1846] += + s[1846];
gout[n*2187+1847] += + s[1847];
gout[n*2187+1848] += + s[1848];
gout[n*2187+1849] += + s[1849];
gout[n*2187+1850] += + s[1850];
gout[n*2187+1851] += + s[1851];
gout[n*2187+1852] += + s[1852];
gout[n*2187+1853] += + s[1853];
gout[n*2187+1854] += + s[1854];
gout[n*2187+1855] += + s[1855];
gout[n*2187+1856] += + s[1856];
gout[n*2187+1857] += + s[1857];
gout[n*2187+1858] += + s[1858];
gout[n*2187+1859] += + s[1859];
gout[n*2187+1860] += + s[1860];
gout[n*2187+1861] += + s[1861];
gout[n*2187+1862] += + s[1862];
gout[n*2187+1863] += + s[621];
gout[n*2187+1864] += + s[622];
gout[n*2187+1865] += + s[623];
gout[n*2187+1866] += + s[624];
gout[n*2187+1867] += + s[625];
gout[n*2187+1868] += + s[626];
gout[n*2187+1869] += + s[627];
gout[n*2187+1870] += + s[628];
gout[n*2187+1871] += + s[629];
gout[n*2187+1872] += + s[630];
gout[n*2187+1873] += + s[631];
gout[n*2187+1874] += + s[632];
gout[n*2187+1875] += + s[633];
gout[n*2187+1876] += + s[634];
gout[n*2187+1877] += + s[635];
gout[n*2187+1878] += + s[636];
gout[n*2187+1879] += + s[637];
gout[n*2187+1880] += + s[638];
gout[n*2187+1881] += + s[639];
gout[n*2187+1882] += + s[640];
gout[n*2187+1883] += + s[641];
gout[n*2187+1884] += + s[642];
gout[n*2187+1885] += + s[643];
gout[n*2187+1886] += + s[644];
gout[n*2187+1887] += + s[645];
gout[n*2187+1888] += + s[646];
gout[n*2187+1889] += + s[647];
gout[n*2187+1890] += + s[1350];
gout[n*2187+1891] += + s[1351];
gout[n*2187+1892] += + s[1352];
gout[n*2187+1893] += + s[1353];
gout[n*2187+1894] += + s[1354];
gout[n*2187+1895] += + s[1355];
gout[n*2187+1896] += + s[1356];
gout[n*2187+1897] += + s[1357];
gout[n*2187+1898] += + s[1358];
gout[n*2187+1899] += + s[1359];
gout[n*2187+1900] += + s[1360];
gout[n*2187+1901] += + s[1361];
gout[n*2187+1902] += + s[1362];
gout[n*2187+1903] += + s[1363];
gout[n*2187+1904] += + s[1364];
gout[n*2187+1905] += + s[1365];
gout[n*2187+1906] += + s[1366];
gout[n*2187+1907] += + s[1367];
gout[n*2187+1908] += + s[1368];
gout[n*2187+1909] += + s[1369];
gout[n*2187+1910] += + s[1370];
gout[n*2187+1911] += + s[1371];
gout[n*2187+1912] += + s[1372];
gout[n*2187+1913] += + s[1373];
gout[n*2187+1914] += + s[1374];
gout[n*2187+1915] += + s[1375];
gout[n*2187+1916] += + s[1376];
gout[n*2187+1917] += + s[2079];
gout[n*2187+1918] += + s[2080];
gout[n*2187+1919] += + s[2081];
gout[n*2187+1920] += + s[2082];
gout[n*2187+1921] += + s[2083];
gout[n*2187+1922] += + s[2084];
gout[n*2187+1923] += + s[2085];
gout[n*2187+1924] += + s[2086];
gout[n*2187+1925] += + s[2087];
gout[n*2187+1926] += + s[2088];
gout[n*2187+1927] += + s[2089];
gout[n*2187+1928] += + s[2090];
gout[n*2187+1929] += + s[2091];
gout[n*2187+1930] += + s[2092];
gout[n*2187+1931] += + s[2093];
gout[n*2187+1932] += + s[2094];
gout[n*2187+1933] += + s[2095];
gout[n*2187+1934] += + s[2096];
gout[n*2187+1935] += + s[2097];
gout[n*2187+1936] += + s[2098];
gout[n*2187+1937] += + s[2099];
gout[n*2187+1938] += + s[2100];
gout[n*2187+1939] += + s[2101];
gout[n*2187+1940] += + s[2102];
gout[n*2187+1941] += + s[2103];
gout[n*2187+1942] += + s[2104];
gout[n*2187+1943] += + s[2105];
gout[n*2187+1944] += + s[216];
gout[n*2187+1945] += + s[217];
gout[n*2187+1946] += + s[218];
gout[n*2187+1947] += + s[219];
gout[n*2187+1948] += + s[220];
gout[n*2187+1949] += + s[221];
gout[n*2187+1950] += + s[222];
gout[n*2187+1951] += + s[223];
gout[n*2187+1952] += + s[224];
gout[n*2187+1953] += + s[225];
gout[n*2187+1954] += + s[226];
gout[n*2187+1955] += + s[227];
gout[n*2187+1956] += + s[228];
gout[n*2187+1957] += + s[229];
gout[n*2187+1958] += + s[230];
gout[n*2187+1959] += + s[231];
gout[n*2187+1960] += + s[232];
gout[n*2187+1961] += + s[233];
gout[n*2187+1962] += + s[234];
gout[n*2187+1963] += + s[235];
gout[n*2187+1964] += + s[236];
gout[n*2187+1965] += + s[237];
gout[n*2187+1966] += + s[238];
gout[n*2187+1967] += + s[239];
gout[n*2187+1968] += + s[240];
gout[n*2187+1969] += + s[241];
gout[n*2187+1970] += + s[242];
gout[n*2187+1971] += + s[945];
gout[n*2187+1972] += + s[946];
gout[n*2187+1973] += + s[947];
gout[n*2187+1974] += + s[948];
gout[n*2187+1975] += + s[949];
gout[n*2187+1976] += + s[950];
gout[n*2187+1977] += + s[951];
gout[n*2187+1978] += + s[952];
gout[n*2187+1979] += + s[953];
gout[n*2187+1980] += + s[954];
gout[n*2187+1981] += + s[955];
gout[n*2187+1982] += + s[956];
gout[n*2187+1983] += + s[957];
gout[n*2187+1984] += + s[958];
gout[n*2187+1985] += + s[959];
gout[n*2187+1986] += + s[960];
gout[n*2187+1987] += + s[961];
gout[n*2187+1988] += + s[962];
gout[n*2187+1989] += + s[963];
gout[n*2187+1990] += + s[964];
gout[n*2187+1991] += + s[965];
gout[n*2187+1992] += + s[966];
gout[n*2187+1993] += + s[967];
gout[n*2187+1994] += + s[968];
gout[n*2187+1995] += + s[969];
gout[n*2187+1996] += + s[970];
gout[n*2187+1997] += + s[971];
gout[n*2187+1998] += + s[1674];
gout[n*2187+1999] += + s[1675];
gout[n*2187+2000] += + s[1676];
gout[n*2187+2001] += + s[1677];
gout[n*2187+2002] += + s[1678];
gout[n*2187+2003] += + s[1679];
gout[n*2187+2004] += + s[1680];
gout[n*2187+2005] += + s[1681];
gout[n*2187+2006] += + s[1682];
gout[n*2187+2007] += + s[1683];
gout[n*2187+2008] += + s[1684];
gout[n*2187+2009] += + s[1685];
gout[n*2187+2010] += + s[1686];
gout[n*2187+2011] += + s[1687];
gout[n*2187+2012] += + s[1688];
gout[n*2187+2013] += + s[1689];
gout[n*2187+2014] += + s[1690];
gout[n*2187+2015] += + s[1691];
gout[n*2187+2016] += + s[1692];
gout[n*2187+2017] += + s[1693];
gout[n*2187+2018] += + s[1694];
gout[n*2187+2019] += + s[1695];
gout[n*2187+2020] += + s[1696];
gout[n*2187+2021] += + s[1697];
gout[n*2187+2022] += + s[1698];
gout[n*2187+2023] += + s[1699];
gout[n*2187+2024] += + s[1700];
gout[n*2187+2025] += + s[459];
gout[n*2187+2026] += + s[460];
gout[n*2187+2027] += + s[461];
gout[n*2187+2028] += + s[462];
gout[n*2187+2029] += + s[463];
gout[n*2187+2030] += + s[464];
gout[n*2187+2031] += + s[465];
gout[n*2187+2032] += + s[466];
gout[n*2187+2033] += + s[467];
gout[n*2187+2034] += + s[468];
gout[n*2187+2035] += + s[469];
gout[n*2187+2036] += + s[470];
gout[n*2187+2037] += + s[471];
gout[n*2187+2038] += + s[472];
gout[n*2187+2039] += + s[473];
gout[n*2187+2040] += + s[474];
gout[n*2187+2041] += + s[475];
gout[n*2187+2042] += + s[476];
gout[n*2187+2043] += + s[477];
gout[n*2187+2044] += + s[478];
gout[n*2187+2045] += + s[479];
gout[n*2187+2046] += + s[480];
gout[n*2187+2047] += + s[481];
gout[n*2187+2048] += + s[482];
gout[n*2187+2049] += + s[483];
gout[n*2187+2050] += + s[484];
gout[n*2187+2051] += + s[485];
gout[n*2187+2052] += + s[1188];
gout[n*2187+2053] += + s[1189];
gout[n*2187+2054] += + s[1190];
gout[n*2187+2055] += + s[1191];
gout[n*2187+2056] += + s[1192];
gout[n*2187+2057] += + s[1193];
gout[n*2187+2058] += + s[1194];
gout[n*2187+2059] += + s[1195];
gout[n*2187+2060] += + s[1196];
gout[n*2187+2061] += + s[1197];
gout[n*2187+2062] += + s[1198];
gout[n*2187+2063] += + s[1199];
gout[n*2187+2064] += + s[1200];
gout[n*2187+2065] += + s[1201];
gout[n*2187+2066] += + s[1202];
gout[n*2187+2067] += + s[1203];
gout[n*2187+2068] += + s[1204];
gout[n*2187+2069] += + s[1205];
gout[n*2187+2070] += + s[1206];
gout[n*2187+2071] += + s[1207];
gout[n*2187+2072] += + s[1208];
gout[n*2187+2073] += + s[1209];
gout[n*2187+2074] += + s[1210];
gout[n*2187+2075] += + s[1211];
gout[n*2187+2076] += + s[1212];
gout[n*2187+2077] += + s[1213];
gout[n*2187+2078] += + s[1214];
gout[n*2187+2079] += + s[1917];
gout[n*2187+2080] += + s[1918];
gout[n*2187+2081] += + s[1919];
gout[n*2187+2082] += + s[1920];
gout[n*2187+2083] += + s[1921];
gout[n*2187+2084] += + s[1922];
gout[n*2187+2085] += + s[1923];
gout[n*2187+2086] += + s[1924];
gout[n*2187+2087] += + s[1925];
gout[n*2187+2088] += + s[1926];
gout[n*2187+2089] += + s[1927];
gout[n*2187+2090] += + s[1928];
gout[n*2187+2091] += + s[1929];
gout[n*2187+2092] += + s[1930];
gout[n*2187+2093] += + s[1931];
gout[n*2187+2094] += + s[1932];
gout[n*2187+2095] += + s[1933];
gout[n*2187+2096] += + s[1934];
gout[n*2187+2097] += + s[1935];
gout[n*2187+2098] += + s[1936];
gout[n*2187+2099] += + s[1937];
gout[n*2187+2100] += + s[1938];
gout[n*2187+2101] += + s[1939];
gout[n*2187+2102] += + s[1940];
gout[n*2187+2103] += + s[1941];
gout[n*2187+2104] += + s[1942];
gout[n*2187+2105] += + s[1943];
gout[n*2187+2106] += + s[702];
gout[n*2187+2107] += + s[703];
gout[n*2187+2108] += + s[704];
gout[n*2187+2109] += + s[705];
gout[n*2187+2110] += + s[706];
gout[n*2187+2111] += + s[707];
gout[n*2187+2112] += + s[708];
gout[n*2187+2113] += + s[709];
gout[n*2187+2114] += + s[710];
gout[n*2187+2115] += + s[711];
gout[n*2187+2116] += + s[712];
gout[n*2187+2117] += + s[713];
gout[n*2187+2118] += + s[714];
gout[n*2187+2119] += + s[715];
gout[n*2187+2120] += + s[716];
gout[n*2187+2121] += + s[717];
gout[n*2187+2122] += + s[718];
gout[n*2187+2123] += + s[719];
gout[n*2187+2124] += + s[720];
gout[n*2187+2125] += + s[721];
gout[n*2187+2126] += + s[722];
gout[n*2187+2127] += + s[723];
gout[n*2187+2128] += + s[724];
gout[n*2187+2129] += + s[725];
gout[n*2187+2130] += + s[726];
gout[n*2187+2131] += + s[727];
gout[n*2187+2132] += + s[728];
gout[n*2187+2133] += + s[1431];
gout[n*2187+2134] += + s[1432];
gout[n*2187+2135] += + s[1433];
gout[n*2187+2136] += + s[1434];
gout[n*2187+2137] += + s[1435];
gout[n*2187+2138] += + s[1436];
gout[n*2187+2139] += + s[1437];
gout[n*2187+2140] += + s[1438];
gout[n*2187+2141] += + s[1439];
gout[n*2187+2142] += + s[1440];
gout[n*2187+2143] += + s[1441];
gout[n*2187+2144] += + s[1442];
gout[n*2187+2145] += + s[1443];
gout[n*2187+2146] += + s[1444];
gout[n*2187+2147] += + s[1445];
gout[n*2187+2148] += + s[1446];
gout[n*2187+2149] += + s[1447];
gout[n*2187+2150] += + s[1448];
gout[n*2187+2151] += + s[1449];
gout[n*2187+2152] += + s[1450];
gout[n*2187+2153] += + s[1451];
gout[n*2187+2154] += + s[1452];
gout[n*2187+2155] += + s[1453];
gout[n*2187+2156] += + s[1454];
gout[n*2187+2157] += + s[1455];
gout[n*2187+2158] += + s[1456];
gout[n*2187+2159] += + s[1457];
gout[n*2187+2160] += + s[2160];
gout[n*2187+2161] += + s[2161];
gout[n*2187+2162] += + s[2162];
gout[n*2187+2163] += + s[2163];
gout[n*2187+2164] += + s[2164];
gout[n*2187+2165] += + s[2165];
gout[n*2187+2166] += + s[2166];
gout[n*2187+2167] += + s[2167];
gout[n*2187+2168] += + s[2168];
gout[n*2187+2169] += + s[2169];
gout[n*2187+2170] += + s[2170];
gout[n*2187+2171] += + s[2171];
gout[n*2187+2172] += + s[2172];
gout[n*2187+2173] += + s[2173];
gout[n*2187+2174] += + s[2174];
gout[n*2187+2175] += + s[2175];
gout[n*2187+2176] += + s[2176];
gout[n*2187+2177] += + s[2177];
gout[n*2187+2178] += + s[2178];
gout[n*2187+2179] += + s[2179];
gout[n*2187+2180] += + s[2180];
gout[n*2187+2181] += + s[2181];
gout[n*2187+2182] += + s[2182];
gout[n*2187+2183] += + s[2183];
gout[n*2187+2184] += + s[2184];
gout[n*2187+2185] += + s[2185];
gout[n*2187+2186] += + s[2186];
}}}
void int1e_ipipipipnnn_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 2187};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipipnnn_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipnnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipipnnn_cart
CACHE_SIZE_T int1e_ipipipipnnn_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipnnn;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipipnnn_sph
CACHE_SIZE_T int1e_ipipipipnnn_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipipnnn;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipipnnn_spinor
ALL_CINT1E(int1e_ipipipipnnn)
ALL_CINT1E_FORTRAN_(int1e_ipipipipnnn)
/* <NABLA i|RJ RJ RJ |NABLA j> */
void CINTgout1e_int1e_ipnnnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[243];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipnnnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnnnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnnnip_cart
CACHE_SIZE_T int1e_ipnnnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnnnip_sph
CACHE_SIZE_T int1e_ipnnnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnnnip_spinor
ALL_CINT1E(int1e_ipnnnip)
ALL_CINT1E_FORTRAN_(int1e_ipnnnip)
/* <NABLA i|RJ RJ RJ |NABLA NABLA j> */
void CINTgout1e_int1e_ipnnnipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+1, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g20, g16, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g28, g24, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+1, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[81];
gout[n*729+82] = + s[82];
gout[n*729+83] = + s[83];
gout[n*729+84] = + s[84];
gout[n*729+85] = + s[85];
gout[n*729+86] = + s[86];
gout[n*729+87] = + s[87];
gout[n*729+88] = + s[88];
gout[n*729+89] = + s[89];
gout[n*729+90] = + s[90];
gout[n*729+91] = + s[91];
gout[n*729+92] = + s[92];
gout[n*729+93] = + s[93];
gout[n*729+94] = + s[94];
gout[n*729+95] = + s[95];
gout[n*729+96] = + s[96];
gout[n*729+97] = + s[97];
gout[n*729+98] = + s[98];
gout[n*729+99] = + s[99];
gout[n*729+100] = + s[100];
gout[n*729+101] = + s[101];
gout[n*729+102] = + s[102];
gout[n*729+103] = + s[103];
gout[n*729+104] = + s[104];
gout[n*729+105] = + s[105];
gout[n*729+106] = + s[106];
gout[n*729+107] = + s[107];
gout[n*729+108] = + s[108];
gout[n*729+109] = + s[109];
gout[n*729+110] = + s[110];
gout[n*729+111] = + s[111];
gout[n*729+112] = + s[112];
gout[n*729+113] = + s[113];
gout[n*729+114] = + s[114];
gout[n*729+115] = + s[115];
gout[n*729+116] = + s[116];
gout[n*729+117] = + s[117];
gout[n*729+118] = + s[118];
gout[n*729+119] = + s[119];
gout[n*729+120] = + s[120];
gout[n*729+121] = + s[121];
gout[n*729+122] = + s[122];
gout[n*729+123] = + s[123];
gout[n*729+124] = + s[124];
gout[n*729+125] = + s[125];
gout[n*729+126] = + s[126];
gout[n*729+127] = + s[127];
gout[n*729+128] = + s[128];
gout[n*729+129] = + s[129];
gout[n*729+130] = + s[130];
gout[n*729+131] = + s[131];
gout[n*729+132] = + s[132];
gout[n*729+133] = + s[133];
gout[n*729+134] = + s[134];
gout[n*729+135] = + s[135];
gout[n*729+136] = + s[136];
gout[n*729+137] = + s[137];
gout[n*729+138] = + s[138];
gout[n*729+139] = + s[139];
gout[n*729+140] = + s[140];
gout[n*729+141] = + s[141];
gout[n*729+142] = + s[142];
gout[n*729+143] = + s[143];
gout[n*729+144] = + s[144];
gout[n*729+145] = + s[145];
gout[n*729+146] = + s[146];
gout[n*729+147] = + s[147];
gout[n*729+148] = + s[148];
gout[n*729+149] = + s[149];
gout[n*729+150] = + s[150];
gout[n*729+151] = + s[151];
gout[n*729+152] = + s[152];
gout[n*729+153] = + s[153];
gout[n*729+154] = + s[154];
gout[n*729+155] = + s[155];
gout[n*729+156] = + s[156];
gout[n*729+157] = + s[157];
gout[n*729+158] = + s[158];
gout[n*729+159] = + s[159];
gout[n*729+160] = + s[160];
gout[n*729+161] = + s[161];
gout[n*729+162] = + s[162];
gout[n*729+163] = + s[163];
gout[n*729+164] = + s[164];
gout[n*729+165] = + s[165];
gout[n*729+166] = + s[166];
gout[n*729+167] = + s[167];
gout[n*729+168] = + s[168];
gout[n*729+169] = + s[169];
gout[n*729+170] = + s[170];
gout[n*729+171] = + s[171];
gout[n*729+172] = + s[172];
gout[n*729+173] = + s[173];
gout[n*729+174] = + s[174];
gout[n*729+175] = + s[175];
gout[n*729+176] = + s[176];
gout[n*729+177] = + s[177];
gout[n*729+178] = + s[178];
gout[n*729+179] = + s[179];
gout[n*729+180] = + s[180];
gout[n*729+181] = + s[181];
gout[n*729+182] = + s[182];
gout[n*729+183] = + s[183];
gout[n*729+184] = + s[184];
gout[n*729+185] = + s[185];
gout[n*729+186] = + s[186];
gout[n*729+187] = + s[187];
gout[n*729+188] = + s[188];
gout[n*729+189] = + s[189];
gout[n*729+190] = + s[190];
gout[n*729+191] = + s[191];
gout[n*729+192] = + s[192];
gout[n*729+193] = + s[193];
gout[n*729+194] = + s[194];
gout[n*729+195] = + s[195];
gout[n*729+196] = + s[196];
gout[n*729+197] = + s[197];
gout[n*729+198] = + s[198];
gout[n*729+199] = + s[199];
gout[n*729+200] = + s[200];
gout[n*729+201] = + s[201];
gout[n*729+202] = + s[202];
gout[n*729+203] = + s[203];
gout[n*729+204] = + s[204];
gout[n*729+205] = + s[205];
gout[n*729+206] = + s[206];
gout[n*729+207] = + s[207];
gout[n*729+208] = + s[208];
gout[n*729+209] = + s[209];
gout[n*729+210] = + s[210];
gout[n*729+211] = + s[211];
gout[n*729+212] = + s[212];
gout[n*729+213] = + s[213];
gout[n*729+214] = + s[214];
gout[n*729+215] = + s[215];
gout[n*729+216] = + s[216];
gout[n*729+217] = + s[217];
gout[n*729+218] = + s[218];
gout[n*729+219] = + s[219];
gout[n*729+220] = + s[220];
gout[n*729+221] = + s[221];
gout[n*729+222] = + s[222];
gout[n*729+223] = + s[223];
gout[n*729+224] = + s[224];
gout[n*729+225] = + s[225];
gout[n*729+226] = + s[226];
gout[n*729+227] = + s[227];
gout[n*729+228] = + s[228];
gout[n*729+229] = + s[229];
gout[n*729+230] = + s[230];
gout[n*729+231] = + s[231];
gout[n*729+232] = + s[232];
gout[n*729+233] = + s[233];
gout[n*729+234] = + s[234];
gout[n*729+235] = + s[235];
gout[n*729+236] = + s[236];
gout[n*729+237] = + s[237];
gout[n*729+238] = + s[238];
gout[n*729+239] = + s[239];
gout[n*729+240] = + s[240];
gout[n*729+241] = + s[241];
gout[n*729+242] = + s[242];
gout[n*729+243] = + s[243];
gout[n*729+244] = + s[244];
gout[n*729+245] = + s[245];
gout[n*729+246] = + s[246];
gout[n*729+247] = + s[247];
gout[n*729+248] = + s[248];
gout[n*729+249] = + s[249];
gout[n*729+250] = + s[250];
gout[n*729+251] = + s[251];
gout[n*729+252] = + s[252];
gout[n*729+253] = + s[253];
gout[n*729+254] = + s[254];
gout[n*729+255] = + s[255];
gout[n*729+256] = + s[256];
gout[n*729+257] = + s[257];
gout[n*729+258] = + s[258];
gout[n*729+259] = + s[259];
gout[n*729+260] = + s[260];
gout[n*729+261] = + s[261];
gout[n*729+262] = + s[262];
gout[n*729+263] = + s[263];
gout[n*729+264] = + s[264];
gout[n*729+265] = + s[265];
gout[n*729+266] = + s[266];
gout[n*729+267] = + s[267];
gout[n*729+268] = + s[268];
gout[n*729+269] = + s[269];
gout[n*729+270] = + s[270];
gout[n*729+271] = + s[271];
gout[n*729+272] = + s[272];
gout[n*729+273] = + s[273];
gout[n*729+274] = + s[274];
gout[n*729+275] = + s[275];
gout[n*729+276] = + s[276];
gout[n*729+277] = + s[277];
gout[n*729+278] = + s[278];
gout[n*729+279] = + s[279];
gout[n*729+280] = + s[280];
gout[n*729+281] = + s[281];
gout[n*729+282] = + s[282];
gout[n*729+283] = + s[283];
gout[n*729+284] = + s[284];
gout[n*729+285] = + s[285];
gout[n*729+286] = + s[286];
gout[n*729+287] = + s[287];
gout[n*729+288] = + s[288];
gout[n*729+289] = + s[289];
gout[n*729+290] = + s[290];
gout[n*729+291] = + s[291];
gout[n*729+292] = + s[292];
gout[n*729+293] = + s[293];
gout[n*729+294] = + s[294];
gout[n*729+295] = + s[295];
gout[n*729+296] = + s[296];
gout[n*729+297] = + s[297];
gout[n*729+298] = + s[298];
gout[n*729+299] = + s[299];
gout[n*729+300] = + s[300];
gout[n*729+301] = + s[301];
gout[n*729+302] = + s[302];
gout[n*729+303] = + s[303];
gout[n*729+304] = + s[304];
gout[n*729+305] = + s[305];
gout[n*729+306] = + s[306];
gout[n*729+307] = + s[307];
gout[n*729+308] = + s[308];
gout[n*729+309] = + s[309];
gout[n*729+310] = + s[310];
gout[n*729+311] = + s[311];
gout[n*729+312] = + s[312];
gout[n*729+313] = + s[313];
gout[n*729+314] = + s[314];
gout[n*729+315] = + s[315];
gout[n*729+316] = + s[316];
gout[n*729+317] = + s[317];
gout[n*729+318] = + s[318];
gout[n*729+319] = + s[319];
gout[n*729+320] = + s[320];
gout[n*729+321] = + s[321];
gout[n*729+322] = + s[322];
gout[n*729+323] = + s[323];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[405];
gout[n*729+406] = + s[406];
gout[n*729+407] = + s[407];
gout[n*729+408] = + s[408];
gout[n*729+409] = + s[409];
gout[n*729+410] = + s[410];
gout[n*729+411] = + s[411];
gout[n*729+412] = + s[412];
gout[n*729+413] = + s[413];
gout[n*729+414] = + s[414];
gout[n*729+415] = + s[415];
gout[n*729+416] = + s[416];
gout[n*729+417] = + s[417];
gout[n*729+418] = + s[418];
gout[n*729+419] = + s[419];
gout[n*729+420] = + s[420];
gout[n*729+421] = + s[421];
gout[n*729+422] = + s[422];
gout[n*729+423] = + s[423];
gout[n*729+424] = + s[424];
gout[n*729+425] = + s[425];
gout[n*729+426] = + s[426];
gout[n*729+427] = + s[427];
gout[n*729+428] = + s[428];
gout[n*729+429] = + s[429];
gout[n*729+430] = + s[430];
gout[n*729+431] = + s[431];
gout[n*729+432] = + s[432];
gout[n*729+433] = + s[433];
gout[n*729+434] = + s[434];
gout[n*729+435] = + s[435];
gout[n*729+436] = + s[436];
gout[n*729+437] = + s[437];
gout[n*729+438] = + s[438];
gout[n*729+439] = + s[439];
gout[n*729+440] = + s[440];
gout[n*729+441] = + s[441];
gout[n*729+442] = + s[442];
gout[n*729+443] = + s[443];
gout[n*729+444] = + s[444];
gout[n*729+445] = + s[445];
gout[n*729+446] = + s[446];
gout[n*729+447] = + s[447];
gout[n*729+448] = + s[448];
gout[n*729+449] = + s[449];
gout[n*729+450] = + s[450];
gout[n*729+451] = + s[451];
gout[n*729+452] = + s[452];
gout[n*729+453] = + s[453];
gout[n*729+454] = + s[454];
gout[n*729+455] = + s[455];
gout[n*729+456] = + s[456];
gout[n*729+457] = + s[457];
gout[n*729+458] = + s[458];
gout[n*729+459] = + s[459];
gout[n*729+460] = + s[460];
gout[n*729+461] = + s[461];
gout[n*729+462] = + s[462];
gout[n*729+463] = + s[463];
gout[n*729+464] = + s[464];
gout[n*729+465] = + s[465];
gout[n*729+466] = + s[466];
gout[n*729+467] = + s[467];
gout[n*729+468] = + s[468];
gout[n*729+469] = + s[469];
gout[n*729+470] = + s[470];
gout[n*729+471] = + s[471];
gout[n*729+472] = + s[472];
gout[n*729+473] = + s[473];
gout[n*729+474] = + s[474];
gout[n*729+475] = + s[475];
gout[n*729+476] = + s[476];
gout[n*729+477] = + s[477];
gout[n*729+478] = + s[478];
gout[n*729+479] = + s[479];
gout[n*729+480] = + s[480];
gout[n*729+481] = + s[481];
gout[n*729+482] = + s[482];
gout[n*729+483] = + s[483];
gout[n*729+484] = + s[484];
gout[n*729+485] = + s[485];
gout[n*729+486] = + s[486];
gout[n*729+487] = + s[487];
gout[n*729+488] = + s[488];
gout[n*729+489] = + s[489];
gout[n*729+490] = + s[490];
gout[n*729+491] = + s[491];
gout[n*729+492] = + s[492];
gout[n*729+493] = + s[493];
gout[n*729+494] = + s[494];
gout[n*729+495] = + s[495];
gout[n*729+496] = + s[496];
gout[n*729+497] = + s[497];
gout[n*729+498] = + s[498];
gout[n*729+499] = + s[499];
gout[n*729+500] = + s[500];
gout[n*729+501] = + s[501];
gout[n*729+502] = + s[502];
gout[n*729+503] = + s[503];
gout[n*729+504] = + s[504];
gout[n*729+505] = + s[505];
gout[n*729+506] = + s[506];
gout[n*729+507] = + s[507];
gout[n*729+508] = + s[508];
gout[n*729+509] = + s[509];
gout[n*729+510] = + s[510];
gout[n*729+511] = + s[511];
gout[n*729+512] = + s[512];
gout[n*729+513] = + s[513];
gout[n*729+514] = + s[514];
gout[n*729+515] = + s[515];
gout[n*729+516] = + s[516];
gout[n*729+517] = + s[517];
gout[n*729+518] = + s[518];
gout[n*729+519] = + s[519];
gout[n*729+520] = + s[520];
gout[n*729+521] = + s[521];
gout[n*729+522] = + s[522];
gout[n*729+523] = + s[523];
gout[n*729+524] = + s[524];
gout[n*729+525] = + s[525];
gout[n*729+526] = + s[526];
gout[n*729+527] = + s[527];
gout[n*729+528] = + s[528];
gout[n*729+529] = + s[529];
gout[n*729+530] = + s[530];
gout[n*729+531] = + s[531];
gout[n*729+532] = + s[532];
gout[n*729+533] = + s[533];
gout[n*729+534] = + s[534];
gout[n*729+535] = + s[535];
gout[n*729+536] = + s[536];
gout[n*729+537] = + s[537];
gout[n*729+538] = + s[538];
gout[n*729+539] = + s[539];
gout[n*729+540] = + s[540];
gout[n*729+541] = + s[541];
gout[n*729+542] = + s[542];
gout[n*729+543] = + s[543];
gout[n*729+544] = + s[544];
gout[n*729+545] = + s[545];
gout[n*729+546] = + s[546];
gout[n*729+547] = + s[547];
gout[n*729+548] = + s[548];
gout[n*729+549] = + s[549];
gout[n*729+550] = + s[550];
gout[n*729+551] = + s[551];
gout[n*729+552] = + s[552];
gout[n*729+553] = + s[553];
gout[n*729+554] = + s[554];
gout[n*729+555] = + s[555];
gout[n*729+556] = + s[556];
gout[n*729+557] = + s[557];
gout[n*729+558] = + s[558];
gout[n*729+559] = + s[559];
gout[n*729+560] = + s[560];
gout[n*729+561] = + s[561];
gout[n*729+562] = + s[562];
gout[n*729+563] = + s[563];
gout[n*729+564] = + s[564];
gout[n*729+565] = + s[565];
gout[n*729+566] = + s[566];
gout[n*729+567] = + s[567];
gout[n*729+568] = + s[568];
gout[n*729+569] = + s[569];
gout[n*729+570] = + s[570];
gout[n*729+571] = + s[571];
gout[n*729+572] = + s[572];
gout[n*729+573] = + s[573];
gout[n*729+574] = + s[574];
gout[n*729+575] = + s[575];
gout[n*729+576] = + s[576];
gout[n*729+577] = + s[577];
gout[n*729+578] = + s[578];
gout[n*729+579] = + s[579];
gout[n*729+580] = + s[580];
gout[n*729+581] = + s[581];
gout[n*729+582] = + s[582];
gout[n*729+583] = + s[583];
gout[n*729+584] = + s[584];
gout[n*729+585] = + s[585];
gout[n*729+586] = + s[586];
gout[n*729+587] = + s[587];
gout[n*729+588] = + s[588];
gout[n*729+589] = + s[589];
gout[n*729+590] = + s[590];
gout[n*729+591] = + s[591];
gout[n*729+592] = + s[592];
gout[n*729+593] = + s[593];
gout[n*729+594] = + s[594];
gout[n*729+595] = + s[595];
gout[n*729+596] = + s[596];
gout[n*729+597] = + s[597];
gout[n*729+598] = + s[598];
gout[n*729+599] = + s[599];
gout[n*729+600] = + s[600];
gout[n*729+601] = + s[601];
gout[n*729+602] = + s[602];
gout[n*729+603] = + s[603];
gout[n*729+604] = + s[604];
gout[n*729+605] = + s[605];
gout[n*729+606] = + s[606];
gout[n*729+607] = + s[607];
gout[n*729+608] = + s[608];
gout[n*729+609] = + s[609];
gout[n*729+610] = + s[610];
gout[n*729+611] = + s[611];
gout[n*729+612] = + s[612];
gout[n*729+613] = + s[613];
gout[n*729+614] = + s[614];
gout[n*729+615] = + s[615];
gout[n*729+616] = + s[616];
gout[n*729+617] = + s[617];
gout[n*729+618] = + s[618];
gout[n*729+619] = + s[619];
gout[n*729+620] = + s[620];
gout[n*729+621] = + s[621];
gout[n*729+622] = + s[622];
gout[n*729+623] = + s[623];
gout[n*729+624] = + s[624];
gout[n*729+625] = + s[625];
gout[n*729+626] = + s[626];
gout[n*729+627] = + s[627];
gout[n*729+628] = + s[628];
gout[n*729+629] = + s[629];
gout[n*729+630] = + s[630];
gout[n*729+631] = + s[631];
gout[n*729+632] = + s[632];
gout[n*729+633] = + s[633];
gout[n*729+634] = + s[634];
gout[n*729+635] = + s[635];
gout[n*729+636] = + s[636];
gout[n*729+637] = + s[637];
gout[n*729+638] = + s[638];
gout[n*729+639] = + s[639];
gout[n*729+640] = + s[640];
gout[n*729+641] = + s[641];
gout[n*729+642] = + s[642];
gout[n*729+643] = + s[643];
gout[n*729+644] = + s[644];
gout[n*729+645] = + s[645];
gout[n*729+646] = + s[646];
gout[n*729+647] = + s[647];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[81];
gout[n*729+82] += + s[82];
gout[n*729+83] += + s[83];
gout[n*729+84] += + s[84];
gout[n*729+85] += + s[85];
gout[n*729+86] += + s[86];
gout[n*729+87] += + s[87];
gout[n*729+88] += + s[88];
gout[n*729+89] += + s[89];
gout[n*729+90] += + s[90];
gout[n*729+91] += + s[91];
gout[n*729+92] += + s[92];
gout[n*729+93] += + s[93];
gout[n*729+94] += + s[94];
gout[n*729+95] += + s[95];
gout[n*729+96] += + s[96];
gout[n*729+97] += + s[97];
gout[n*729+98] += + s[98];
gout[n*729+99] += + s[99];
gout[n*729+100] += + s[100];
gout[n*729+101] += + s[101];
gout[n*729+102] += + s[102];
gout[n*729+103] += + s[103];
gout[n*729+104] += + s[104];
gout[n*729+105] += + s[105];
gout[n*729+106] += + s[106];
gout[n*729+107] += + s[107];
gout[n*729+108] += + s[108];
gout[n*729+109] += + s[109];
gout[n*729+110] += + s[110];
gout[n*729+111] += + s[111];
gout[n*729+112] += + s[112];
gout[n*729+113] += + s[113];
gout[n*729+114] += + s[114];
gout[n*729+115] += + s[115];
gout[n*729+116] += + s[116];
gout[n*729+117] += + s[117];
gout[n*729+118] += + s[118];
gout[n*729+119] += + s[119];
gout[n*729+120] += + s[120];
gout[n*729+121] += + s[121];
gout[n*729+122] += + s[122];
gout[n*729+123] += + s[123];
gout[n*729+124] += + s[124];
gout[n*729+125] += + s[125];
gout[n*729+126] += + s[126];
gout[n*729+127] += + s[127];
gout[n*729+128] += + s[128];
gout[n*729+129] += + s[129];
gout[n*729+130] += + s[130];
gout[n*729+131] += + s[131];
gout[n*729+132] += + s[132];
gout[n*729+133] += + s[133];
gout[n*729+134] += + s[134];
gout[n*729+135] += + s[135];
gout[n*729+136] += + s[136];
gout[n*729+137] += + s[137];
gout[n*729+138] += + s[138];
gout[n*729+139] += + s[139];
gout[n*729+140] += + s[140];
gout[n*729+141] += + s[141];
gout[n*729+142] += + s[142];
gout[n*729+143] += + s[143];
gout[n*729+144] += + s[144];
gout[n*729+145] += + s[145];
gout[n*729+146] += + s[146];
gout[n*729+147] += + s[147];
gout[n*729+148] += + s[148];
gout[n*729+149] += + s[149];
gout[n*729+150] += + s[150];
gout[n*729+151] += + s[151];
gout[n*729+152] += + s[152];
gout[n*729+153] += + s[153];
gout[n*729+154] += + s[154];
gout[n*729+155] += + s[155];
gout[n*729+156] += + s[156];
gout[n*729+157] += + s[157];
gout[n*729+158] += + s[158];
gout[n*729+159] += + s[159];
gout[n*729+160] += + s[160];
gout[n*729+161] += + s[161];
gout[n*729+162] += + s[162];
gout[n*729+163] += + s[163];
gout[n*729+164] += + s[164];
gout[n*729+165] += + s[165];
gout[n*729+166] += + s[166];
gout[n*729+167] += + s[167];
gout[n*729+168] += + s[168];
gout[n*729+169] += + s[169];
gout[n*729+170] += + s[170];
gout[n*729+171] += + s[171];
gout[n*729+172] += + s[172];
gout[n*729+173] += + s[173];
gout[n*729+174] += + s[174];
gout[n*729+175] += + s[175];
gout[n*729+176] += + s[176];
gout[n*729+177] += + s[177];
gout[n*729+178] += + s[178];
gout[n*729+179] += + s[179];
gout[n*729+180] += + s[180];
gout[n*729+181] += + s[181];
gout[n*729+182] += + s[182];
gout[n*729+183] += + s[183];
gout[n*729+184] += + s[184];
gout[n*729+185] += + s[185];
gout[n*729+186] += + s[186];
gout[n*729+187] += + s[187];
gout[n*729+188] += + s[188];
gout[n*729+189] += + s[189];
gout[n*729+190] += + s[190];
gout[n*729+191] += + s[191];
gout[n*729+192] += + s[192];
gout[n*729+193] += + s[193];
gout[n*729+194] += + s[194];
gout[n*729+195] += + s[195];
gout[n*729+196] += + s[196];
gout[n*729+197] += + s[197];
gout[n*729+198] += + s[198];
gout[n*729+199] += + s[199];
gout[n*729+200] += + s[200];
gout[n*729+201] += + s[201];
gout[n*729+202] += + s[202];
gout[n*729+203] += + s[203];
gout[n*729+204] += + s[204];
gout[n*729+205] += + s[205];
gout[n*729+206] += + s[206];
gout[n*729+207] += + s[207];
gout[n*729+208] += + s[208];
gout[n*729+209] += + s[209];
gout[n*729+210] += + s[210];
gout[n*729+211] += + s[211];
gout[n*729+212] += + s[212];
gout[n*729+213] += + s[213];
gout[n*729+214] += + s[214];
gout[n*729+215] += + s[215];
gout[n*729+216] += + s[216];
gout[n*729+217] += + s[217];
gout[n*729+218] += + s[218];
gout[n*729+219] += + s[219];
gout[n*729+220] += + s[220];
gout[n*729+221] += + s[221];
gout[n*729+222] += + s[222];
gout[n*729+223] += + s[223];
gout[n*729+224] += + s[224];
gout[n*729+225] += + s[225];
gout[n*729+226] += + s[226];
gout[n*729+227] += + s[227];
gout[n*729+228] += + s[228];
gout[n*729+229] += + s[229];
gout[n*729+230] += + s[230];
gout[n*729+231] += + s[231];
gout[n*729+232] += + s[232];
gout[n*729+233] += + s[233];
gout[n*729+234] += + s[234];
gout[n*729+235] += + s[235];
gout[n*729+236] += + s[236];
gout[n*729+237] += + s[237];
gout[n*729+238] += + s[238];
gout[n*729+239] += + s[239];
gout[n*729+240] += + s[240];
gout[n*729+241] += + s[241];
gout[n*729+242] += + s[242];
gout[n*729+243] += + s[243];
gout[n*729+244] += + s[244];
gout[n*729+245] += + s[245];
gout[n*729+246] += + s[246];
gout[n*729+247] += + s[247];
gout[n*729+248] += + s[248];
gout[n*729+249] += + s[249];
gout[n*729+250] += + s[250];
gout[n*729+251] += + s[251];
gout[n*729+252] += + s[252];
gout[n*729+253] += + s[253];
gout[n*729+254] += + s[254];
gout[n*729+255] += + s[255];
gout[n*729+256] += + s[256];
gout[n*729+257] += + s[257];
gout[n*729+258] += + s[258];
gout[n*729+259] += + s[259];
gout[n*729+260] += + s[260];
gout[n*729+261] += + s[261];
gout[n*729+262] += + s[262];
gout[n*729+263] += + s[263];
gout[n*729+264] += + s[264];
gout[n*729+265] += + s[265];
gout[n*729+266] += + s[266];
gout[n*729+267] += + s[267];
gout[n*729+268] += + s[268];
gout[n*729+269] += + s[269];
gout[n*729+270] += + s[270];
gout[n*729+271] += + s[271];
gout[n*729+272] += + s[272];
gout[n*729+273] += + s[273];
gout[n*729+274] += + s[274];
gout[n*729+275] += + s[275];
gout[n*729+276] += + s[276];
gout[n*729+277] += + s[277];
gout[n*729+278] += + s[278];
gout[n*729+279] += + s[279];
gout[n*729+280] += + s[280];
gout[n*729+281] += + s[281];
gout[n*729+282] += + s[282];
gout[n*729+283] += + s[283];
gout[n*729+284] += + s[284];
gout[n*729+285] += + s[285];
gout[n*729+286] += + s[286];
gout[n*729+287] += + s[287];
gout[n*729+288] += + s[288];
gout[n*729+289] += + s[289];
gout[n*729+290] += + s[290];
gout[n*729+291] += + s[291];
gout[n*729+292] += + s[292];
gout[n*729+293] += + s[293];
gout[n*729+294] += + s[294];
gout[n*729+295] += + s[295];
gout[n*729+296] += + s[296];
gout[n*729+297] += + s[297];
gout[n*729+298] += + s[298];
gout[n*729+299] += + s[299];
gout[n*729+300] += + s[300];
gout[n*729+301] += + s[301];
gout[n*729+302] += + s[302];
gout[n*729+303] += + s[303];
gout[n*729+304] += + s[304];
gout[n*729+305] += + s[305];
gout[n*729+306] += + s[306];
gout[n*729+307] += + s[307];
gout[n*729+308] += + s[308];
gout[n*729+309] += + s[309];
gout[n*729+310] += + s[310];
gout[n*729+311] += + s[311];
gout[n*729+312] += + s[312];
gout[n*729+313] += + s[313];
gout[n*729+314] += + s[314];
gout[n*729+315] += + s[315];
gout[n*729+316] += + s[316];
gout[n*729+317] += + s[317];
gout[n*729+318] += + s[318];
gout[n*729+319] += + s[319];
gout[n*729+320] += + s[320];
gout[n*729+321] += + s[321];
gout[n*729+322] += + s[322];
gout[n*729+323] += + s[323];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[405];
gout[n*729+406] += + s[406];
gout[n*729+407] += + s[407];
gout[n*729+408] += + s[408];
gout[n*729+409] += + s[409];
gout[n*729+410] += + s[410];
gout[n*729+411] += + s[411];
gout[n*729+412] += + s[412];
gout[n*729+413] += + s[413];
gout[n*729+414] += + s[414];
gout[n*729+415] += + s[415];
gout[n*729+416] += + s[416];
gout[n*729+417] += + s[417];
gout[n*729+418] += + s[418];
gout[n*729+419] += + s[419];
gout[n*729+420] += + s[420];
gout[n*729+421] += + s[421];
gout[n*729+422] += + s[422];
gout[n*729+423] += + s[423];
gout[n*729+424] += + s[424];
gout[n*729+425] += + s[425];
gout[n*729+426] += + s[426];
gout[n*729+427] += + s[427];
gout[n*729+428] += + s[428];
gout[n*729+429] += + s[429];
gout[n*729+430] += + s[430];
gout[n*729+431] += + s[431];
gout[n*729+432] += + s[432];
gout[n*729+433] += + s[433];
gout[n*729+434] += + s[434];
gout[n*729+435] += + s[435];
gout[n*729+436] += + s[436];
gout[n*729+437] += + s[437];
gout[n*729+438] += + s[438];
gout[n*729+439] += + s[439];
gout[n*729+440] += + s[440];
gout[n*729+441] += + s[441];
gout[n*729+442] += + s[442];
gout[n*729+443] += + s[443];
gout[n*729+444] += + s[444];
gout[n*729+445] += + s[445];
gout[n*729+446] += + s[446];
gout[n*729+447] += + s[447];
gout[n*729+448] += + s[448];
gout[n*729+449] += + s[449];
gout[n*729+450] += + s[450];
gout[n*729+451] += + s[451];
gout[n*729+452] += + s[452];
gout[n*729+453] += + s[453];
gout[n*729+454] += + s[454];
gout[n*729+455] += + s[455];
gout[n*729+456] += + s[456];
gout[n*729+457] += + s[457];
gout[n*729+458] += + s[458];
gout[n*729+459] += + s[459];
gout[n*729+460] += + s[460];
gout[n*729+461] += + s[461];
gout[n*729+462] += + s[462];
gout[n*729+463] += + s[463];
gout[n*729+464] += + s[464];
gout[n*729+465] += + s[465];
gout[n*729+466] += + s[466];
gout[n*729+467] += + s[467];
gout[n*729+468] += + s[468];
gout[n*729+469] += + s[469];
gout[n*729+470] += + s[470];
gout[n*729+471] += + s[471];
gout[n*729+472] += + s[472];
gout[n*729+473] += + s[473];
gout[n*729+474] += + s[474];
gout[n*729+475] += + s[475];
gout[n*729+476] += + s[476];
gout[n*729+477] += + s[477];
gout[n*729+478] += + s[478];
gout[n*729+479] += + s[479];
gout[n*729+480] += + s[480];
gout[n*729+481] += + s[481];
gout[n*729+482] += + s[482];
gout[n*729+483] += + s[483];
gout[n*729+484] += + s[484];
gout[n*729+485] += + s[485];
gout[n*729+486] += + s[486];
gout[n*729+487] += + s[487];
gout[n*729+488] += + s[488];
gout[n*729+489] += + s[489];
gout[n*729+490] += + s[490];
gout[n*729+491] += + s[491];
gout[n*729+492] += + s[492];
gout[n*729+493] += + s[493];
gout[n*729+494] += + s[494];
gout[n*729+495] += + s[495];
gout[n*729+496] += + s[496];
gout[n*729+497] += + s[497];
gout[n*729+498] += + s[498];
gout[n*729+499] += + s[499];
gout[n*729+500] += + s[500];
gout[n*729+501] += + s[501];
gout[n*729+502] += + s[502];
gout[n*729+503] += + s[503];
gout[n*729+504] += + s[504];
gout[n*729+505] += + s[505];
gout[n*729+506] += + s[506];
gout[n*729+507] += + s[507];
gout[n*729+508] += + s[508];
gout[n*729+509] += + s[509];
gout[n*729+510] += + s[510];
gout[n*729+511] += + s[511];
gout[n*729+512] += + s[512];
gout[n*729+513] += + s[513];
gout[n*729+514] += + s[514];
gout[n*729+515] += + s[515];
gout[n*729+516] += + s[516];
gout[n*729+517] += + s[517];
gout[n*729+518] += + s[518];
gout[n*729+519] += + s[519];
gout[n*729+520] += + s[520];
gout[n*729+521] += + s[521];
gout[n*729+522] += + s[522];
gout[n*729+523] += + s[523];
gout[n*729+524] += + s[524];
gout[n*729+525] += + s[525];
gout[n*729+526] += + s[526];
gout[n*729+527] += + s[527];
gout[n*729+528] += + s[528];
gout[n*729+529] += + s[529];
gout[n*729+530] += + s[530];
gout[n*729+531] += + s[531];
gout[n*729+532] += + s[532];
gout[n*729+533] += + s[533];
gout[n*729+534] += + s[534];
gout[n*729+535] += + s[535];
gout[n*729+536] += + s[536];
gout[n*729+537] += + s[537];
gout[n*729+538] += + s[538];
gout[n*729+539] += + s[539];
gout[n*729+540] += + s[540];
gout[n*729+541] += + s[541];
gout[n*729+542] += + s[542];
gout[n*729+543] += + s[543];
gout[n*729+544] += + s[544];
gout[n*729+545] += + s[545];
gout[n*729+546] += + s[546];
gout[n*729+547] += + s[547];
gout[n*729+548] += + s[548];
gout[n*729+549] += + s[549];
gout[n*729+550] += + s[550];
gout[n*729+551] += + s[551];
gout[n*729+552] += + s[552];
gout[n*729+553] += + s[553];
gout[n*729+554] += + s[554];
gout[n*729+555] += + s[555];
gout[n*729+556] += + s[556];
gout[n*729+557] += + s[557];
gout[n*729+558] += + s[558];
gout[n*729+559] += + s[559];
gout[n*729+560] += + s[560];
gout[n*729+561] += + s[561];
gout[n*729+562] += + s[562];
gout[n*729+563] += + s[563];
gout[n*729+564] += + s[564];
gout[n*729+565] += + s[565];
gout[n*729+566] += + s[566];
gout[n*729+567] += + s[567];
gout[n*729+568] += + s[568];
gout[n*729+569] += + s[569];
gout[n*729+570] += + s[570];
gout[n*729+571] += + s[571];
gout[n*729+572] += + s[572];
gout[n*729+573] += + s[573];
gout[n*729+574] += + s[574];
gout[n*729+575] += + s[575];
gout[n*729+576] += + s[576];
gout[n*729+577] += + s[577];
gout[n*729+578] += + s[578];
gout[n*729+579] += + s[579];
gout[n*729+580] += + s[580];
gout[n*729+581] += + s[581];
gout[n*729+582] += + s[582];
gout[n*729+583] += + s[583];
gout[n*729+584] += + s[584];
gout[n*729+585] += + s[585];
gout[n*729+586] += + s[586];
gout[n*729+587] += + s[587];
gout[n*729+588] += + s[588];
gout[n*729+589] += + s[589];
gout[n*729+590] += + s[590];
gout[n*729+591] += + s[591];
gout[n*729+592] += + s[592];
gout[n*729+593] += + s[593];
gout[n*729+594] += + s[594];
gout[n*729+595] += + s[595];
gout[n*729+596] += + s[596];
gout[n*729+597] += + s[597];
gout[n*729+598] += + s[598];
gout[n*729+599] += + s[599];
gout[n*729+600] += + s[600];
gout[n*729+601] += + s[601];
gout[n*729+602] += + s[602];
gout[n*729+603] += + s[603];
gout[n*729+604] += + s[604];
gout[n*729+605] += + s[605];
gout[n*729+606] += + s[606];
gout[n*729+607] += + s[607];
gout[n*729+608] += + s[608];
gout[n*729+609] += + s[609];
gout[n*729+610] += + s[610];
gout[n*729+611] += + s[611];
gout[n*729+612] += + s[612];
gout[n*729+613] += + s[613];
gout[n*729+614] += + s[614];
gout[n*729+615] += + s[615];
gout[n*729+616] += + s[616];
gout[n*729+617] += + s[617];
gout[n*729+618] += + s[618];
gout[n*729+619] += + s[619];
gout[n*729+620] += + s[620];
gout[n*729+621] += + s[621];
gout[n*729+622] += + s[622];
gout[n*729+623] += + s[623];
gout[n*729+624] += + s[624];
gout[n*729+625] += + s[625];
gout[n*729+626] += + s[626];
gout[n*729+627] += + s[627];
gout[n*729+628] += + s[628];
gout[n*729+629] += + s[629];
gout[n*729+630] += + s[630];
gout[n*729+631] += + s[631];
gout[n*729+632] += + s[632];
gout[n*729+633] += + s[633];
gout[n*729+634] += + s[634];
gout[n*729+635] += + s[635];
gout[n*729+636] += + s[636];
gout[n*729+637] += + s[637];
gout[n*729+638] += + s[638];
gout[n*729+639] += + s[639];
gout[n*729+640] += + s[640];
gout[n*729+641] += + s[641];
gout[n*729+642] += + s[642];
gout[n*729+643] += + s[643];
gout[n*729+644] += + s[644];
gout[n*729+645] += + s[645];
gout[n*729+646] += + s[646];
gout[n*729+647] += + s[647];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipnnnipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipnnnipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipnnnipip_cart
CACHE_SIZE_T int1e_ipnnnipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipnnnipip_sph
CACHE_SIZE_T int1e_ipnnnipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 5, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipnnnipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipnnnipip_spinor
ALL_CINT1E(int1e_ipnnnipip)
ALL_CINT1E_FORTRAN_(int1e_ipnnnipip)
/* <NABLA NABLA i|RJ RJ RJ |NABLA j> */
void CINTgout1e_int1e_ipipnnnip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+2, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*729+0] = + s[0];
gout[n*729+1] = + s[1];
gout[n*729+2] = + s[2];
gout[n*729+3] = + s[3];
gout[n*729+4] = + s[4];
gout[n*729+5] = + s[5];
gout[n*729+6] = + s[6];
gout[n*729+7] = + s[7];
gout[n*729+8] = + s[8];
gout[n*729+9] = + s[9];
gout[n*729+10] = + s[10];
gout[n*729+11] = + s[11];
gout[n*729+12] = + s[12];
gout[n*729+13] = + s[13];
gout[n*729+14] = + s[14];
gout[n*729+15] = + s[15];
gout[n*729+16] = + s[16];
gout[n*729+17] = + s[17];
gout[n*729+18] = + s[18];
gout[n*729+19] = + s[19];
gout[n*729+20] = + s[20];
gout[n*729+21] = + s[21];
gout[n*729+22] = + s[22];
gout[n*729+23] = + s[23];
gout[n*729+24] = + s[24];
gout[n*729+25] = + s[25];
gout[n*729+26] = + s[26];
gout[n*729+27] = + s[27];
gout[n*729+28] = + s[28];
gout[n*729+29] = + s[29];
gout[n*729+30] = + s[30];
gout[n*729+31] = + s[31];
gout[n*729+32] = + s[32];
gout[n*729+33] = + s[33];
gout[n*729+34] = + s[34];
gout[n*729+35] = + s[35];
gout[n*729+36] = + s[36];
gout[n*729+37] = + s[37];
gout[n*729+38] = + s[38];
gout[n*729+39] = + s[39];
gout[n*729+40] = + s[40];
gout[n*729+41] = + s[41];
gout[n*729+42] = + s[42];
gout[n*729+43] = + s[43];
gout[n*729+44] = + s[44];
gout[n*729+45] = + s[45];
gout[n*729+46] = + s[46];
gout[n*729+47] = + s[47];
gout[n*729+48] = + s[48];
gout[n*729+49] = + s[49];
gout[n*729+50] = + s[50];
gout[n*729+51] = + s[51];
gout[n*729+52] = + s[52];
gout[n*729+53] = + s[53];
gout[n*729+54] = + s[54];
gout[n*729+55] = + s[55];
gout[n*729+56] = + s[56];
gout[n*729+57] = + s[57];
gout[n*729+58] = + s[58];
gout[n*729+59] = + s[59];
gout[n*729+60] = + s[60];
gout[n*729+61] = + s[61];
gout[n*729+62] = + s[62];
gout[n*729+63] = + s[63];
gout[n*729+64] = + s[64];
gout[n*729+65] = + s[65];
gout[n*729+66] = + s[66];
gout[n*729+67] = + s[67];
gout[n*729+68] = + s[68];
gout[n*729+69] = + s[69];
gout[n*729+70] = + s[70];
gout[n*729+71] = + s[71];
gout[n*729+72] = + s[72];
gout[n*729+73] = + s[73];
gout[n*729+74] = + s[74];
gout[n*729+75] = + s[75];
gout[n*729+76] = + s[76];
gout[n*729+77] = + s[77];
gout[n*729+78] = + s[78];
gout[n*729+79] = + s[79];
gout[n*729+80] = + s[80];
gout[n*729+81] = + s[243];
gout[n*729+82] = + s[244];
gout[n*729+83] = + s[245];
gout[n*729+84] = + s[246];
gout[n*729+85] = + s[247];
gout[n*729+86] = + s[248];
gout[n*729+87] = + s[249];
gout[n*729+88] = + s[250];
gout[n*729+89] = + s[251];
gout[n*729+90] = + s[252];
gout[n*729+91] = + s[253];
gout[n*729+92] = + s[254];
gout[n*729+93] = + s[255];
gout[n*729+94] = + s[256];
gout[n*729+95] = + s[257];
gout[n*729+96] = + s[258];
gout[n*729+97] = + s[259];
gout[n*729+98] = + s[260];
gout[n*729+99] = + s[261];
gout[n*729+100] = + s[262];
gout[n*729+101] = + s[263];
gout[n*729+102] = + s[264];
gout[n*729+103] = + s[265];
gout[n*729+104] = + s[266];
gout[n*729+105] = + s[267];
gout[n*729+106] = + s[268];
gout[n*729+107] = + s[269];
gout[n*729+108] = + s[270];
gout[n*729+109] = + s[271];
gout[n*729+110] = + s[272];
gout[n*729+111] = + s[273];
gout[n*729+112] = + s[274];
gout[n*729+113] = + s[275];
gout[n*729+114] = + s[276];
gout[n*729+115] = + s[277];
gout[n*729+116] = + s[278];
gout[n*729+117] = + s[279];
gout[n*729+118] = + s[280];
gout[n*729+119] = + s[281];
gout[n*729+120] = + s[282];
gout[n*729+121] = + s[283];
gout[n*729+122] = + s[284];
gout[n*729+123] = + s[285];
gout[n*729+124] = + s[286];
gout[n*729+125] = + s[287];
gout[n*729+126] = + s[288];
gout[n*729+127] = + s[289];
gout[n*729+128] = + s[290];
gout[n*729+129] = + s[291];
gout[n*729+130] = + s[292];
gout[n*729+131] = + s[293];
gout[n*729+132] = + s[294];
gout[n*729+133] = + s[295];
gout[n*729+134] = + s[296];
gout[n*729+135] = + s[297];
gout[n*729+136] = + s[298];
gout[n*729+137] = + s[299];
gout[n*729+138] = + s[300];
gout[n*729+139] = + s[301];
gout[n*729+140] = + s[302];
gout[n*729+141] = + s[303];
gout[n*729+142] = + s[304];
gout[n*729+143] = + s[305];
gout[n*729+144] = + s[306];
gout[n*729+145] = + s[307];
gout[n*729+146] = + s[308];
gout[n*729+147] = + s[309];
gout[n*729+148] = + s[310];
gout[n*729+149] = + s[311];
gout[n*729+150] = + s[312];
gout[n*729+151] = + s[313];
gout[n*729+152] = + s[314];
gout[n*729+153] = + s[315];
gout[n*729+154] = + s[316];
gout[n*729+155] = + s[317];
gout[n*729+156] = + s[318];
gout[n*729+157] = + s[319];
gout[n*729+158] = + s[320];
gout[n*729+159] = + s[321];
gout[n*729+160] = + s[322];
gout[n*729+161] = + s[323];
gout[n*729+162] = + s[486];
gout[n*729+163] = + s[487];
gout[n*729+164] = + s[488];
gout[n*729+165] = + s[489];
gout[n*729+166] = + s[490];
gout[n*729+167] = + s[491];
gout[n*729+168] = + s[492];
gout[n*729+169] = + s[493];
gout[n*729+170] = + s[494];
gout[n*729+171] = + s[495];
gout[n*729+172] = + s[496];
gout[n*729+173] = + s[497];
gout[n*729+174] = + s[498];
gout[n*729+175] = + s[499];
gout[n*729+176] = + s[500];
gout[n*729+177] = + s[501];
gout[n*729+178] = + s[502];
gout[n*729+179] = + s[503];
gout[n*729+180] = + s[504];
gout[n*729+181] = + s[505];
gout[n*729+182] = + s[506];
gout[n*729+183] = + s[507];
gout[n*729+184] = + s[508];
gout[n*729+185] = + s[509];
gout[n*729+186] = + s[510];
gout[n*729+187] = + s[511];
gout[n*729+188] = + s[512];
gout[n*729+189] = + s[513];
gout[n*729+190] = + s[514];
gout[n*729+191] = + s[515];
gout[n*729+192] = + s[516];
gout[n*729+193] = + s[517];
gout[n*729+194] = + s[518];
gout[n*729+195] = + s[519];
gout[n*729+196] = + s[520];
gout[n*729+197] = + s[521];
gout[n*729+198] = + s[522];
gout[n*729+199] = + s[523];
gout[n*729+200] = + s[524];
gout[n*729+201] = + s[525];
gout[n*729+202] = + s[526];
gout[n*729+203] = + s[527];
gout[n*729+204] = + s[528];
gout[n*729+205] = + s[529];
gout[n*729+206] = + s[530];
gout[n*729+207] = + s[531];
gout[n*729+208] = + s[532];
gout[n*729+209] = + s[533];
gout[n*729+210] = + s[534];
gout[n*729+211] = + s[535];
gout[n*729+212] = + s[536];
gout[n*729+213] = + s[537];
gout[n*729+214] = + s[538];
gout[n*729+215] = + s[539];
gout[n*729+216] = + s[540];
gout[n*729+217] = + s[541];
gout[n*729+218] = + s[542];
gout[n*729+219] = + s[543];
gout[n*729+220] = + s[544];
gout[n*729+221] = + s[545];
gout[n*729+222] = + s[546];
gout[n*729+223] = + s[547];
gout[n*729+224] = + s[548];
gout[n*729+225] = + s[549];
gout[n*729+226] = + s[550];
gout[n*729+227] = + s[551];
gout[n*729+228] = + s[552];
gout[n*729+229] = + s[553];
gout[n*729+230] = + s[554];
gout[n*729+231] = + s[555];
gout[n*729+232] = + s[556];
gout[n*729+233] = + s[557];
gout[n*729+234] = + s[558];
gout[n*729+235] = + s[559];
gout[n*729+236] = + s[560];
gout[n*729+237] = + s[561];
gout[n*729+238] = + s[562];
gout[n*729+239] = + s[563];
gout[n*729+240] = + s[564];
gout[n*729+241] = + s[565];
gout[n*729+242] = + s[566];
gout[n*729+243] = + s[81];
gout[n*729+244] = + s[82];
gout[n*729+245] = + s[83];
gout[n*729+246] = + s[84];
gout[n*729+247] = + s[85];
gout[n*729+248] = + s[86];
gout[n*729+249] = + s[87];
gout[n*729+250] = + s[88];
gout[n*729+251] = + s[89];
gout[n*729+252] = + s[90];
gout[n*729+253] = + s[91];
gout[n*729+254] = + s[92];
gout[n*729+255] = + s[93];
gout[n*729+256] = + s[94];
gout[n*729+257] = + s[95];
gout[n*729+258] = + s[96];
gout[n*729+259] = + s[97];
gout[n*729+260] = + s[98];
gout[n*729+261] = + s[99];
gout[n*729+262] = + s[100];
gout[n*729+263] = + s[101];
gout[n*729+264] = + s[102];
gout[n*729+265] = + s[103];
gout[n*729+266] = + s[104];
gout[n*729+267] = + s[105];
gout[n*729+268] = + s[106];
gout[n*729+269] = + s[107];
gout[n*729+270] = + s[108];
gout[n*729+271] = + s[109];
gout[n*729+272] = + s[110];
gout[n*729+273] = + s[111];
gout[n*729+274] = + s[112];
gout[n*729+275] = + s[113];
gout[n*729+276] = + s[114];
gout[n*729+277] = + s[115];
gout[n*729+278] = + s[116];
gout[n*729+279] = + s[117];
gout[n*729+280] = + s[118];
gout[n*729+281] = + s[119];
gout[n*729+282] = + s[120];
gout[n*729+283] = + s[121];
gout[n*729+284] = + s[122];
gout[n*729+285] = + s[123];
gout[n*729+286] = + s[124];
gout[n*729+287] = + s[125];
gout[n*729+288] = + s[126];
gout[n*729+289] = + s[127];
gout[n*729+290] = + s[128];
gout[n*729+291] = + s[129];
gout[n*729+292] = + s[130];
gout[n*729+293] = + s[131];
gout[n*729+294] = + s[132];
gout[n*729+295] = + s[133];
gout[n*729+296] = + s[134];
gout[n*729+297] = + s[135];
gout[n*729+298] = + s[136];
gout[n*729+299] = + s[137];
gout[n*729+300] = + s[138];
gout[n*729+301] = + s[139];
gout[n*729+302] = + s[140];
gout[n*729+303] = + s[141];
gout[n*729+304] = + s[142];
gout[n*729+305] = + s[143];
gout[n*729+306] = + s[144];
gout[n*729+307] = + s[145];
gout[n*729+308] = + s[146];
gout[n*729+309] = + s[147];
gout[n*729+310] = + s[148];
gout[n*729+311] = + s[149];
gout[n*729+312] = + s[150];
gout[n*729+313] = + s[151];
gout[n*729+314] = + s[152];
gout[n*729+315] = + s[153];
gout[n*729+316] = + s[154];
gout[n*729+317] = + s[155];
gout[n*729+318] = + s[156];
gout[n*729+319] = + s[157];
gout[n*729+320] = + s[158];
gout[n*729+321] = + s[159];
gout[n*729+322] = + s[160];
gout[n*729+323] = + s[161];
gout[n*729+324] = + s[324];
gout[n*729+325] = + s[325];
gout[n*729+326] = + s[326];
gout[n*729+327] = + s[327];
gout[n*729+328] = + s[328];
gout[n*729+329] = + s[329];
gout[n*729+330] = + s[330];
gout[n*729+331] = + s[331];
gout[n*729+332] = + s[332];
gout[n*729+333] = + s[333];
gout[n*729+334] = + s[334];
gout[n*729+335] = + s[335];
gout[n*729+336] = + s[336];
gout[n*729+337] = + s[337];
gout[n*729+338] = + s[338];
gout[n*729+339] = + s[339];
gout[n*729+340] = + s[340];
gout[n*729+341] = + s[341];
gout[n*729+342] = + s[342];
gout[n*729+343] = + s[343];
gout[n*729+344] = + s[344];
gout[n*729+345] = + s[345];
gout[n*729+346] = + s[346];
gout[n*729+347] = + s[347];
gout[n*729+348] = + s[348];
gout[n*729+349] = + s[349];
gout[n*729+350] = + s[350];
gout[n*729+351] = + s[351];
gout[n*729+352] = + s[352];
gout[n*729+353] = + s[353];
gout[n*729+354] = + s[354];
gout[n*729+355] = + s[355];
gout[n*729+356] = + s[356];
gout[n*729+357] = + s[357];
gout[n*729+358] = + s[358];
gout[n*729+359] = + s[359];
gout[n*729+360] = + s[360];
gout[n*729+361] = + s[361];
gout[n*729+362] = + s[362];
gout[n*729+363] = + s[363];
gout[n*729+364] = + s[364];
gout[n*729+365] = + s[365];
gout[n*729+366] = + s[366];
gout[n*729+367] = + s[367];
gout[n*729+368] = + s[368];
gout[n*729+369] = + s[369];
gout[n*729+370] = + s[370];
gout[n*729+371] = + s[371];
gout[n*729+372] = + s[372];
gout[n*729+373] = + s[373];
gout[n*729+374] = + s[374];
gout[n*729+375] = + s[375];
gout[n*729+376] = + s[376];
gout[n*729+377] = + s[377];
gout[n*729+378] = + s[378];
gout[n*729+379] = + s[379];
gout[n*729+380] = + s[380];
gout[n*729+381] = + s[381];
gout[n*729+382] = + s[382];
gout[n*729+383] = + s[383];
gout[n*729+384] = + s[384];
gout[n*729+385] = + s[385];
gout[n*729+386] = + s[386];
gout[n*729+387] = + s[387];
gout[n*729+388] = + s[388];
gout[n*729+389] = + s[389];
gout[n*729+390] = + s[390];
gout[n*729+391] = + s[391];
gout[n*729+392] = + s[392];
gout[n*729+393] = + s[393];
gout[n*729+394] = + s[394];
gout[n*729+395] = + s[395];
gout[n*729+396] = + s[396];
gout[n*729+397] = + s[397];
gout[n*729+398] = + s[398];
gout[n*729+399] = + s[399];
gout[n*729+400] = + s[400];
gout[n*729+401] = + s[401];
gout[n*729+402] = + s[402];
gout[n*729+403] = + s[403];
gout[n*729+404] = + s[404];
gout[n*729+405] = + s[567];
gout[n*729+406] = + s[568];
gout[n*729+407] = + s[569];
gout[n*729+408] = + s[570];
gout[n*729+409] = + s[571];
gout[n*729+410] = + s[572];
gout[n*729+411] = + s[573];
gout[n*729+412] = + s[574];
gout[n*729+413] = + s[575];
gout[n*729+414] = + s[576];
gout[n*729+415] = + s[577];
gout[n*729+416] = + s[578];
gout[n*729+417] = + s[579];
gout[n*729+418] = + s[580];
gout[n*729+419] = + s[581];
gout[n*729+420] = + s[582];
gout[n*729+421] = + s[583];
gout[n*729+422] = + s[584];
gout[n*729+423] = + s[585];
gout[n*729+424] = + s[586];
gout[n*729+425] = + s[587];
gout[n*729+426] = + s[588];
gout[n*729+427] = + s[589];
gout[n*729+428] = + s[590];
gout[n*729+429] = + s[591];
gout[n*729+430] = + s[592];
gout[n*729+431] = + s[593];
gout[n*729+432] = + s[594];
gout[n*729+433] = + s[595];
gout[n*729+434] = + s[596];
gout[n*729+435] = + s[597];
gout[n*729+436] = + s[598];
gout[n*729+437] = + s[599];
gout[n*729+438] = + s[600];
gout[n*729+439] = + s[601];
gout[n*729+440] = + s[602];
gout[n*729+441] = + s[603];
gout[n*729+442] = + s[604];
gout[n*729+443] = + s[605];
gout[n*729+444] = + s[606];
gout[n*729+445] = + s[607];
gout[n*729+446] = + s[608];
gout[n*729+447] = + s[609];
gout[n*729+448] = + s[610];
gout[n*729+449] = + s[611];
gout[n*729+450] = + s[612];
gout[n*729+451] = + s[613];
gout[n*729+452] = + s[614];
gout[n*729+453] = + s[615];
gout[n*729+454] = + s[616];
gout[n*729+455] = + s[617];
gout[n*729+456] = + s[618];
gout[n*729+457] = + s[619];
gout[n*729+458] = + s[620];
gout[n*729+459] = + s[621];
gout[n*729+460] = + s[622];
gout[n*729+461] = + s[623];
gout[n*729+462] = + s[624];
gout[n*729+463] = + s[625];
gout[n*729+464] = + s[626];
gout[n*729+465] = + s[627];
gout[n*729+466] = + s[628];
gout[n*729+467] = + s[629];
gout[n*729+468] = + s[630];
gout[n*729+469] = + s[631];
gout[n*729+470] = + s[632];
gout[n*729+471] = + s[633];
gout[n*729+472] = + s[634];
gout[n*729+473] = + s[635];
gout[n*729+474] = + s[636];
gout[n*729+475] = + s[637];
gout[n*729+476] = + s[638];
gout[n*729+477] = + s[639];
gout[n*729+478] = + s[640];
gout[n*729+479] = + s[641];
gout[n*729+480] = + s[642];
gout[n*729+481] = + s[643];
gout[n*729+482] = + s[644];
gout[n*729+483] = + s[645];
gout[n*729+484] = + s[646];
gout[n*729+485] = + s[647];
gout[n*729+486] = + s[162];
gout[n*729+487] = + s[163];
gout[n*729+488] = + s[164];
gout[n*729+489] = + s[165];
gout[n*729+490] = + s[166];
gout[n*729+491] = + s[167];
gout[n*729+492] = + s[168];
gout[n*729+493] = + s[169];
gout[n*729+494] = + s[170];
gout[n*729+495] = + s[171];
gout[n*729+496] = + s[172];
gout[n*729+497] = + s[173];
gout[n*729+498] = + s[174];
gout[n*729+499] = + s[175];
gout[n*729+500] = + s[176];
gout[n*729+501] = + s[177];
gout[n*729+502] = + s[178];
gout[n*729+503] = + s[179];
gout[n*729+504] = + s[180];
gout[n*729+505] = + s[181];
gout[n*729+506] = + s[182];
gout[n*729+507] = + s[183];
gout[n*729+508] = + s[184];
gout[n*729+509] = + s[185];
gout[n*729+510] = + s[186];
gout[n*729+511] = + s[187];
gout[n*729+512] = + s[188];
gout[n*729+513] = + s[189];
gout[n*729+514] = + s[190];
gout[n*729+515] = + s[191];
gout[n*729+516] = + s[192];
gout[n*729+517] = + s[193];
gout[n*729+518] = + s[194];
gout[n*729+519] = + s[195];
gout[n*729+520] = + s[196];
gout[n*729+521] = + s[197];
gout[n*729+522] = + s[198];
gout[n*729+523] = + s[199];
gout[n*729+524] = + s[200];
gout[n*729+525] = + s[201];
gout[n*729+526] = + s[202];
gout[n*729+527] = + s[203];
gout[n*729+528] = + s[204];
gout[n*729+529] = + s[205];
gout[n*729+530] = + s[206];
gout[n*729+531] = + s[207];
gout[n*729+532] = + s[208];
gout[n*729+533] = + s[209];
gout[n*729+534] = + s[210];
gout[n*729+535] = + s[211];
gout[n*729+536] = + s[212];
gout[n*729+537] = + s[213];
gout[n*729+538] = + s[214];
gout[n*729+539] = + s[215];
gout[n*729+540] = + s[216];
gout[n*729+541] = + s[217];
gout[n*729+542] = + s[218];
gout[n*729+543] = + s[219];
gout[n*729+544] = + s[220];
gout[n*729+545] = + s[221];
gout[n*729+546] = + s[222];
gout[n*729+547] = + s[223];
gout[n*729+548] = + s[224];
gout[n*729+549] = + s[225];
gout[n*729+550] = + s[226];
gout[n*729+551] = + s[227];
gout[n*729+552] = + s[228];
gout[n*729+553] = + s[229];
gout[n*729+554] = + s[230];
gout[n*729+555] = + s[231];
gout[n*729+556] = + s[232];
gout[n*729+557] = + s[233];
gout[n*729+558] = + s[234];
gout[n*729+559] = + s[235];
gout[n*729+560] = + s[236];
gout[n*729+561] = + s[237];
gout[n*729+562] = + s[238];
gout[n*729+563] = + s[239];
gout[n*729+564] = + s[240];
gout[n*729+565] = + s[241];
gout[n*729+566] = + s[242];
gout[n*729+567] = + s[405];
gout[n*729+568] = + s[406];
gout[n*729+569] = + s[407];
gout[n*729+570] = + s[408];
gout[n*729+571] = + s[409];
gout[n*729+572] = + s[410];
gout[n*729+573] = + s[411];
gout[n*729+574] = + s[412];
gout[n*729+575] = + s[413];
gout[n*729+576] = + s[414];
gout[n*729+577] = + s[415];
gout[n*729+578] = + s[416];
gout[n*729+579] = + s[417];
gout[n*729+580] = + s[418];
gout[n*729+581] = + s[419];
gout[n*729+582] = + s[420];
gout[n*729+583] = + s[421];
gout[n*729+584] = + s[422];
gout[n*729+585] = + s[423];
gout[n*729+586] = + s[424];
gout[n*729+587] = + s[425];
gout[n*729+588] = + s[426];
gout[n*729+589] = + s[427];
gout[n*729+590] = + s[428];
gout[n*729+591] = + s[429];
gout[n*729+592] = + s[430];
gout[n*729+593] = + s[431];
gout[n*729+594] = + s[432];
gout[n*729+595] = + s[433];
gout[n*729+596] = + s[434];
gout[n*729+597] = + s[435];
gout[n*729+598] = + s[436];
gout[n*729+599] = + s[437];
gout[n*729+600] = + s[438];
gout[n*729+601] = + s[439];
gout[n*729+602] = + s[440];
gout[n*729+603] = + s[441];
gout[n*729+604] = + s[442];
gout[n*729+605] = + s[443];
gout[n*729+606] = + s[444];
gout[n*729+607] = + s[445];
gout[n*729+608] = + s[446];
gout[n*729+609] = + s[447];
gout[n*729+610] = + s[448];
gout[n*729+611] = + s[449];
gout[n*729+612] = + s[450];
gout[n*729+613] = + s[451];
gout[n*729+614] = + s[452];
gout[n*729+615] = + s[453];
gout[n*729+616] = + s[454];
gout[n*729+617] = + s[455];
gout[n*729+618] = + s[456];
gout[n*729+619] = + s[457];
gout[n*729+620] = + s[458];
gout[n*729+621] = + s[459];
gout[n*729+622] = + s[460];
gout[n*729+623] = + s[461];
gout[n*729+624] = + s[462];
gout[n*729+625] = + s[463];
gout[n*729+626] = + s[464];
gout[n*729+627] = + s[465];
gout[n*729+628] = + s[466];
gout[n*729+629] = + s[467];
gout[n*729+630] = + s[468];
gout[n*729+631] = + s[469];
gout[n*729+632] = + s[470];
gout[n*729+633] = + s[471];
gout[n*729+634] = + s[472];
gout[n*729+635] = + s[473];
gout[n*729+636] = + s[474];
gout[n*729+637] = + s[475];
gout[n*729+638] = + s[476];
gout[n*729+639] = + s[477];
gout[n*729+640] = + s[478];
gout[n*729+641] = + s[479];
gout[n*729+642] = + s[480];
gout[n*729+643] = + s[481];
gout[n*729+644] = + s[482];
gout[n*729+645] = + s[483];
gout[n*729+646] = + s[484];
gout[n*729+647] = + s[485];
gout[n*729+648] = + s[648];
gout[n*729+649] = + s[649];
gout[n*729+650] = + s[650];
gout[n*729+651] = + s[651];
gout[n*729+652] = + s[652];
gout[n*729+653] = + s[653];
gout[n*729+654] = + s[654];
gout[n*729+655] = + s[655];
gout[n*729+656] = + s[656];
gout[n*729+657] = + s[657];
gout[n*729+658] = + s[658];
gout[n*729+659] = + s[659];
gout[n*729+660] = + s[660];
gout[n*729+661] = + s[661];
gout[n*729+662] = + s[662];
gout[n*729+663] = + s[663];
gout[n*729+664] = + s[664];
gout[n*729+665] = + s[665];
gout[n*729+666] = + s[666];
gout[n*729+667] = + s[667];
gout[n*729+668] = + s[668];
gout[n*729+669] = + s[669];
gout[n*729+670] = + s[670];
gout[n*729+671] = + s[671];
gout[n*729+672] = + s[672];
gout[n*729+673] = + s[673];
gout[n*729+674] = + s[674];
gout[n*729+675] = + s[675];
gout[n*729+676] = + s[676];
gout[n*729+677] = + s[677];
gout[n*729+678] = + s[678];
gout[n*729+679] = + s[679];
gout[n*729+680] = + s[680];
gout[n*729+681] = + s[681];
gout[n*729+682] = + s[682];
gout[n*729+683] = + s[683];
gout[n*729+684] = + s[684];
gout[n*729+685] = + s[685];
gout[n*729+686] = + s[686];
gout[n*729+687] = + s[687];
gout[n*729+688] = + s[688];
gout[n*729+689] = + s[689];
gout[n*729+690] = + s[690];
gout[n*729+691] = + s[691];
gout[n*729+692] = + s[692];
gout[n*729+693] = + s[693];
gout[n*729+694] = + s[694];
gout[n*729+695] = + s[695];
gout[n*729+696] = + s[696];
gout[n*729+697] = + s[697];
gout[n*729+698] = + s[698];
gout[n*729+699] = + s[699];
gout[n*729+700] = + s[700];
gout[n*729+701] = + s[701];
gout[n*729+702] = + s[702];
gout[n*729+703] = + s[703];
gout[n*729+704] = + s[704];
gout[n*729+705] = + s[705];
gout[n*729+706] = + s[706];
gout[n*729+707] = + s[707];
gout[n*729+708] = + s[708];
gout[n*729+709] = + s[709];
gout[n*729+710] = + s[710];
gout[n*729+711] = + s[711];
gout[n*729+712] = + s[712];
gout[n*729+713] = + s[713];
gout[n*729+714] = + s[714];
gout[n*729+715] = + s[715];
gout[n*729+716] = + s[716];
gout[n*729+717] = + s[717];
gout[n*729+718] = + s[718];
gout[n*729+719] = + s[719];
gout[n*729+720] = + s[720];
gout[n*729+721] = + s[721];
gout[n*729+722] = + s[722];
gout[n*729+723] = + s[723];
gout[n*729+724] = + s[724];
gout[n*729+725] = + s[725];
gout[n*729+726] = + s[726];
gout[n*729+727] = + s[727];
gout[n*729+728] = + s[728];
} else {
gout[n*729+0] += + s[0];
gout[n*729+1] += + s[1];
gout[n*729+2] += + s[2];
gout[n*729+3] += + s[3];
gout[n*729+4] += + s[4];
gout[n*729+5] += + s[5];
gout[n*729+6] += + s[6];
gout[n*729+7] += + s[7];
gout[n*729+8] += + s[8];
gout[n*729+9] += + s[9];
gout[n*729+10] += + s[10];
gout[n*729+11] += + s[11];
gout[n*729+12] += + s[12];
gout[n*729+13] += + s[13];
gout[n*729+14] += + s[14];
gout[n*729+15] += + s[15];
gout[n*729+16] += + s[16];
gout[n*729+17] += + s[17];
gout[n*729+18] += + s[18];
gout[n*729+19] += + s[19];
gout[n*729+20] += + s[20];
gout[n*729+21] += + s[21];
gout[n*729+22] += + s[22];
gout[n*729+23] += + s[23];
gout[n*729+24] += + s[24];
gout[n*729+25] += + s[25];
gout[n*729+26] += + s[26];
gout[n*729+27] += + s[27];
gout[n*729+28] += + s[28];
gout[n*729+29] += + s[29];
gout[n*729+30] += + s[30];
gout[n*729+31] += + s[31];
gout[n*729+32] += + s[32];
gout[n*729+33] += + s[33];
gout[n*729+34] += + s[34];
gout[n*729+35] += + s[35];
gout[n*729+36] += + s[36];
gout[n*729+37] += + s[37];
gout[n*729+38] += + s[38];
gout[n*729+39] += + s[39];
gout[n*729+40] += + s[40];
gout[n*729+41] += + s[41];
gout[n*729+42] += + s[42];
gout[n*729+43] += + s[43];
gout[n*729+44] += + s[44];
gout[n*729+45] += + s[45];
gout[n*729+46] += + s[46];
gout[n*729+47] += + s[47];
gout[n*729+48] += + s[48];
gout[n*729+49] += + s[49];
gout[n*729+50] += + s[50];
gout[n*729+51] += + s[51];
gout[n*729+52] += + s[52];
gout[n*729+53] += + s[53];
gout[n*729+54] += + s[54];
gout[n*729+55] += + s[55];
gout[n*729+56] += + s[56];
gout[n*729+57] += + s[57];
gout[n*729+58] += + s[58];
gout[n*729+59] += + s[59];
gout[n*729+60] += + s[60];
gout[n*729+61] += + s[61];
gout[n*729+62] += + s[62];
gout[n*729+63] += + s[63];
gout[n*729+64] += + s[64];
gout[n*729+65] += + s[65];
gout[n*729+66] += + s[66];
gout[n*729+67] += + s[67];
gout[n*729+68] += + s[68];
gout[n*729+69] += + s[69];
gout[n*729+70] += + s[70];
gout[n*729+71] += + s[71];
gout[n*729+72] += + s[72];
gout[n*729+73] += + s[73];
gout[n*729+74] += + s[74];
gout[n*729+75] += + s[75];
gout[n*729+76] += + s[76];
gout[n*729+77] += + s[77];
gout[n*729+78] += + s[78];
gout[n*729+79] += + s[79];
gout[n*729+80] += + s[80];
gout[n*729+81] += + s[243];
gout[n*729+82] += + s[244];
gout[n*729+83] += + s[245];
gout[n*729+84] += + s[246];
gout[n*729+85] += + s[247];
gout[n*729+86] += + s[248];
gout[n*729+87] += + s[249];
gout[n*729+88] += + s[250];
gout[n*729+89] += + s[251];
gout[n*729+90] += + s[252];
gout[n*729+91] += + s[253];
gout[n*729+92] += + s[254];
gout[n*729+93] += + s[255];
gout[n*729+94] += + s[256];
gout[n*729+95] += + s[257];
gout[n*729+96] += + s[258];
gout[n*729+97] += + s[259];
gout[n*729+98] += + s[260];
gout[n*729+99] += + s[261];
gout[n*729+100] += + s[262];
gout[n*729+101] += + s[263];
gout[n*729+102] += + s[264];
gout[n*729+103] += + s[265];
gout[n*729+104] += + s[266];
gout[n*729+105] += + s[267];
gout[n*729+106] += + s[268];
gout[n*729+107] += + s[269];
gout[n*729+108] += + s[270];
gout[n*729+109] += + s[271];
gout[n*729+110] += + s[272];
gout[n*729+111] += + s[273];
gout[n*729+112] += + s[274];
gout[n*729+113] += + s[275];
gout[n*729+114] += + s[276];
gout[n*729+115] += + s[277];
gout[n*729+116] += + s[278];
gout[n*729+117] += + s[279];
gout[n*729+118] += + s[280];
gout[n*729+119] += + s[281];
gout[n*729+120] += + s[282];
gout[n*729+121] += + s[283];
gout[n*729+122] += + s[284];
gout[n*729+123] += + s[285];
gout[n*729+124] += + s[286];
gout[n*729+125] += + s[287];
gout[n*729+126] += + s[288];
gout[n*729+127] += + s[289];
gout[n*729+128] += + s[290];
gout[n*729+129] += + s[291];
gout[n*729+130] += + s[292];
gout[n*729+131] += + s[293];
gout[n*729+132] += + s[294];
gout[n*729+133] += + s[295];
gout[n*729+134] += + s[296];
gout[n*729+135] += + s[297];
gout[n*729+136] += + s[298];
gout[n*729+137] += + s[299];
gout[n*729+138] += + s[300];
gout[n*729+139] += + s[301];
gout[n*729+140] += + s[302];
gout[n*729+141] += + s[303];
gout[n*729+142] += + s[304];
gout[n*729+143] += + s[305];
gout[n*729+144] += + s[306];
gout[n*729+145] += + s[307];
gout[n*729+146] += + s[308];
gout[n*729+147] += + s[309];
gout[n*729+148] += + s[310];
gout[n*729+149] += + s[311];
gout[n*729+150] += + s[312];
gout[n*729+151] += + s[313];
gout[n*729+152] += + s[314];
gout[n*729+153] += + s[315];
gout[n*729+154] += + s[316];
gout[n*729+155] += + s[317];
gout[n*729+156] += + s[318];
gout[n*729+157] += + s[319];
gout[n*729+158] += + s[320];
gout[n*729+159] += + s[321];
gout[n*729+160] += + s[322];
gout[n*729+161] += + s[323];
gout[n*729+162] += + s[486];
gout[n*729+163] += + s[487];
gout[n*729+164] += + s[488];
gout[n*729+165] += + s[489];
gout[n*729+166] += + s[490];
gout[n*729+167] += + s[491];
gout[n*729+168] += + s[492];
gout[n*729+169] += + s[493];
gout[n*729+170] += + s[494];
gout[n*729+171] += + s[495];
gout[n*729+172] += + s[496];
gout[n*729+173] += + s[497];
gout[n*729+174] += + s[498];
gout[n*729+175] += + s[499];
gout[n*729+176] += + s[500];
gout[n*729+177] += + s[501];
gout[n*729+178] += + s[502];
gout[n*729+179] += + s[503];
gout[n*729+180] += + s[504];
gout[n*729+181] += + s[505];
gout[n*729+182] += + s[506];
gout[n*729+183] += + s[507];
gout[n*729+184] += + s[508];
gout[n*729+185] += + s[509];
gout[n*729+186] += + s[510];
gout[n*729+187] += + s[511];
gout[n*729+188] += + s[512];
gout[n*729+189] += + s[513];
gout[n*729+190] += + s[514];
gout[n*729+191] += + s[515];
gout[n*729+192] += + s[516];
gout[n*729+193] += + s[517];
gout[n*729+194] += + s[518];
gout[n*729+195] += + s[519];
gout[n*729+196] += + s[520];
gout[n*729+197] += + s[521];
gout[n*729+198] += + s[522];
gout[n*729+199] += + s[523];
gout[n*729+200] += + s[524];
gout[n*729+201] += + s[525];
gout[n*729+202] += + s[526];
gout[n*729+203] += + s[527];
gout[n*729+204] += + s[528];
gout[n*729+205] += + s[529];
gout[n*729+206] += + s[530];
gout[n*729+207] += + s[531];
gout[n*729+208] += + s[532];
gout[n*729+209] += + s[533];
gout[n*729+210] += + s[534];
gout[n*729+211] += + s[535];
gout[n*729+212] += + s[536];
gout[n*729+213] += + s[537];
gout[n*729+214] += + s[538];
gout[n*729+215] += + s[539];
gout[n*729+216] += + s[540];
gout[n*729+217] += + s[541];
gout[n*729+218] += + s[542];
gout[n*729+219] += + s[543];
gout[n*729+220] += + s[544];
gout[n*729+221] += + s[545];
gout[n*729+222] += + s[546];
gout[n*729+223] += + s[547];
gout[n*729+224] += + s[548];
gout[n*729+225] += + s[549];
gout[n*729+226] += + s[550];
gout[n*729+227] += + s[551];
gout[n*729+228] += + s[552];
gout[n*729+229] += + s[553];
gout[n*729+230] += + s[554];
gout[n*729+231] += + s[555];
gout[n*729+232] += + s[556];
gout[n*729+233] += + s[557];
gout[n*729+234] += + s[558];
gout[n*729+235] += + s[559];
gout[n*729+236] += + s[560];
gout[n*729+237] += + s[561];
gout[n*729+238] += + s[562];
gout[n*729+239] += + s[563];
gout[n*729+240] += + s[564];
gout[n*729+241] += + s[565];
gout[n*729+242] += + s[566];
gout[n*729+243] += + s[81];
gout[n*729+244] += + s[82];
gout[n*729+245] += + s[83];
gout[n*729+246] += + s[84];
gout[n*729+247] += + s[85];
gout[n*729+248] += + s[86];
gout[n*729+249] += + s[87];
gout[n*729+250] += + s[88];
gout[n*729+251] += + s[89];
gout[n*729+252] += + s[90];
gout[n*729+253] += + s[91];
gout[n*729+254] += + s[92];
gout[n*729+255] += + s[93];
gout[n*729+256] += + s[94];
gout[n*729+257] += + s[95];
gout[n*729+258] += + s[96];
gout[n*729+259] += + s[97];
gout[n*729+260] += + s[98];
gout[n*729+261] += + s[99];
gout[n*729+262] += + s[100];
gout[n*729+263] += + s[101];
gout[n*729+264] += + s[102];
gout[n*729+265] += + s[103];
gout[n*729+266] += + s[104];
gout[n*729+267] += + s[105];
gout[n*729+268] += + s[106];
gout[n*729+269] += + s[107];
gout[n*729+270] += + s[108];
gout[n*729+271] += + s[109];
gout[n*729+272] += + s[110];
gout[n*729+273] += + s[111];
gout[n*729+274] += + s[112];
gout[n*729+275] += + s[113];
gout[n*729+276] += + s[114];
gout[n*729+277] += + s[115];
gout[n*729+278] += + s[116];
gout[n*729+279] += + s[117];
gout[n*729+280] += + s[118];
gout[n*729+281] += + s[119];
gout[n*729+282] += + s[120];
gout[n*729+283] += + s[121];
gout[n*729+284] += + s[122];
gout[n*729+285] += + s[123];
gout[n*729+286] += + s[124];
gout[n*729+287] += + s[125];
gout[n*729+288] += + s[126];
gout[n*729+289] += + s[127];
gout[n*729+290] += + s[128];
gout[n*729+291] += + s[129];
gout[n*729+292] += + s[130];
gout[n*729+293] += + s[131];
gout[n*729+294] += + s[132];
gout[n*729+295] += + s[133];
gout[n*729+296] += + s[134];
gout[n*729+297] += + s[135];
gout[n*729+298] += + s[136];
gout[n*729+299] += + s[137];
gout[n*729+300] += + s[138];
gout[n*729+301] += + s[139];
gout[n*729+302] += + s[140];
gout[n*729+303] += + s[141];
gout[n*729+304] += + s[142];
gout[n*729+305] += + s[143];
gout[n*729+306] += + s[144];
gout[n*729+307] += + s[145];
gout[n*729+308] += + s[146];
gout[n*729+309] += + s[147];
gout[n*729+310] += + s[148];
gout[n*729+311] += + s[149];
gout[n*729+312] += + s[150];
gout[n*729+313] += + s[151];
gout[n*729+314] += + s[152];
gout[n*729+315] += + s[153];
gout[n*729+316] += + s[154];
gout[n*729+317] += + s[155];
gout[n*729+318] += + s[156];
gout[n*729+319] += + s[157];
gout[n*729+320] += + s[158];
gout[n*729+321] += + s[159];
gout[n*729+322] += + s[160];
gout[n*729+323] += + s[161];
gout[n*729+324] += + s[324];
gout[n*729+325] += + s[325];
gout[n*729+326] += + s[326];
gout[n*729+327] += + s[327];
gout[n*729+328] += + s[328];
gout[n*729+329] += + s[329];
gout[n*729+330] += + s[330];
gout[n*729+331] += + s[331];
gout[n*729+332] += + s[332];
gout[n*729+333] += + s[333];
gout[n*729+334] += + s[334];
gout[n*729+335] += + s[335];
gout[n*729+336] += + s[336];
gout[n*729+337] += + s[337];
gout[n*729+338] += + s[338];
gout[n*729+339] += + s[339];
gout[n*729+340] += + s[340];
gout[n*729+341] += + s[341];
gout[n*729+342] += + s[342];
gout[n*729+343] += + s[343];
gout[n*729+344] += + s[344];
gout[n*729+345] += + s[345];
gout[n*729+346] += + s[346];
gout[n*729+347] += + s[347];
gout[n*729+348] += + s[348];
gout[n*729+349] += + s[349];
gout[n*729+350] += + s[350];
gout[n*729+351] += + s[351];
gout[n*729+352] += + s[352];
gout[n*729+353] += + s[353];
gout[n*729+354] += + s[354];
gout[n*729+355] += + s[355];
gout[n*729+356] += + s[356];
gout[n*729+357] += + s[357];
gout[n*729+358] += + s[358];
gout[n*729+359] += + s[359];
gout[n*729+360] += + s[360];
gout[n*729+361] += + s[361];
gout[n*729+362] += + s[362];
gout[n*729+363] += + s[363];
gout[n*729+364] += + s[364];
gout[n*729+365] += + s[365];
gout[n*729+366] += + s[366];
gout[n*729+367] += + s[367];
gout[n*729+368] += + s[368];
gout[n*729+369] += + s[369];
gout[n*729+370] += + s[370];
gout[n*729+371] += + s[371];
gout[n*729+372] += + s[372];
gout[n*729+373] += + s[373];
gout[n*729+374] += + s[374];
gout[n*729+375] += + s[375];
gout[n*729+376] += + s[376];
gout[n*729+377] += + s[377];
gout[n*729+378] += + s[378];
gout[n*729+379] += + s[379];
gout[n*729+380] += + s[380];
gout[n*729+381] += + s[381];
gout[n*729+382] += + s[382];
gout[n*729+383] += + s[383];
gout[n*729+384] += + s[384];
gout[n*729+385] += + s[385];
gout[n*729+386] += + s[386];
gout[n*729+387] += + s[387];
gout[n*729+388] += + s[388];
gout[n*729+389] += + s[389];
gout[n*729+390] += + s[390];
gout[n*729+391] += + s[391];
gout[n*729+392] += + s[392];
gout[n*729+393] += + s[393];
gout[n*729+394] += + s[394];
gout[n*729+395] += + s[395];
gout[n*729+396] += + s[396];
gout[n*729+397] += + s[397];
gout[n*729+398] += + s[398];
gout[n*729+399] += + s[399];
gout[n*729+400] += + s[400];
gout[n*729+401] += + s[401];
gout[n*729+402] += + s[402];
gout[n*729+403] += + s[403];
gout[n*729+404] += + s[404];
gout[n*729+405] += + s[567];
gout[n*729+406] += + s[568];
gout[n*729+407] += + s[569];
gout[n*729+408] += + s[570];
gout[n*729+409] += + s[571];
gout[n*729+410] += + s[572];
gout[n*729+411] += + s[573];
gout[n*729+412] += + s[574];
gout[n*729+413] += + s[575];
gout[n*729+414] += + s[576];
gout[n*729+415] += + s[577];
gout[n*729+416] += + s[578];
gout[n*729+417] += + s[579];
gout[n*729+418] += + s[580];
gout[n*729+419] += + s[581];
gout[n*729+420] += + s[582];
gout[n*729+421] += + s[583];
gout[n*729+422] += + s[584];
gout[n*729+423] += + s[585];
gout[n*729+424] += + s[586];
gout[n*729+425] += + s[587];
gout[n*729+426] += + s[588];
gout[n*729+427] += + s[589];
gout[n*729+428] += + s[590];
gout[n*729+429] += + s[591];
gout[n*729+430] += + s[592];
gout[n*729+431] += + s[593];
gout[n*729+432] += + s[594];
gout[n*729+433] += + s[595];
gout[n*729+434] += + s[596];
gout[n*729+435] += + s[597];
gout[n*729+436] += + s[598];
gout[n*729+437] += + s[599];
gout[n*729+438] += + s[600];
gout[n*729+439] += + s[601];
gout[n*729+440] += + s[602];
gout[n*729+441] += + s[603];
gout[n*729+442] += + s[604];
gout[n*729+443] += + s[605];
gout[n*729+444] += + s[606];
gout[n*729+445] += + s[607];
gout[n*729+446] += + s[608];
gout[n*729+447] += + s[609];
gout[n*729+448] += + s[610];
gout[n*729+449] += + s[611];
gout[n*729+450] += + s[612];
gout[n*729+451] += + s[613];
gout[n*729+452] += + s[614];
gout[n*729+453] += + s[615];
gout[n*729+454] += + s[616];
gout[n*729+455] += + s[617];
gout[n*729+456] += + s[618];
gout[n*729+457] += + s[619];
gout[n*729+458] += + s[620];
gout[n*729+459] += + s[621];
gout[n*729+460] += + s[622];
gout[n*729+461] += + s[623];
gout[n*729+462] += + s[624];
gout[n*729+463] += + s[625];
gout[n*729+464] += + s[626];
gout[n*729+465] += + s[627];
gout[n*729+466] += + s[628];
gout[n*729+467] += + s[629];
gout[n*729+468] += + s[630];
gout[n*729+469] += + s[631];
gout[n*729+470] += + s[632];
gout[n*729+471] += + s[633];
gout[n*729+472] += + s[634];
gout[n*729+473] += + s[635];
gout[n*729+474] += + s[636];
gout[n*729+475] += + s[637];
gout[n*729+476] += + s[638];
gout[n*729+477] += + s[639];
gout[n*729+478] += + s[640];
gout[n*729+479] += + s[641];
gout[n*729+480] += + s[642];
gout[n*729+481] += + s[643];
gout[n*729+482] += + s[644];
gout[n*729+483] += + s[645];
gout[n*729+484] += + s[646];
gout[n*729+485] += + s[647];
gout[n*729+486] += + s[162];
gout[n*729+487] += + s[163];
gout[n*729+488] += + s[164];
gout[n*729+489] += + s[165];
gout[n*729+490] += + s[166];
gout[n*729+491] += + s[167];
gout[n*729+492] += + s[168];
gout[n*729+493] += + s[169];
gout[n*729+494] += + s[170];
gout[n*729+495] += + s[171];
gout[n*729+496] += + s[172];
gout[n*729+497] += + s[173];
gout[n*729+498] += + s[174];
gout[n*729+499] += + s[175];
gout[n*729+500] += + s[176];
gout[n*729+501] += + s[177];
gout[n*729+502] += + s[178];
gout[n*729+503] += + s[179];
gout[n*729+504] += + s[180];
gout[n*729+505] += + s[181];
gout[n*729+506] += + s[182];
gout[n*729+507] += + s[183];
gout[n*729+508] += + s[184];
gout[n*729+509] += + s[185];
gout[n*729+510] += + s[186];
gout[n*729+511] += + s[187];
gout[n*729+512] += + s[188];
gout[n*729+513] += + s[189];
gout[n*729+514] += + s[190];
gout[n*729+515] += + s[191];
gout[n*729+516] += + s[192];
gout[n*729+517] += + s[193];
gout[n*729+518] += + s[194];
gout[n*729+519] += + s[195];
gout[n*729+520] += + s[196];
gout[n*729+521] += + s[197];
gout[n*729+522] += + s[198];
gout[n*729+523] += + s[199];
gout[n*729+524] += + s[200];
gout[n*729+525] += + s[201];
gout[n*729+526] += + s[202];
gout[n*729+527] += + s[203];
gout[n*729+528] += + s[204];
gout[n*729+529] += + s[205];
gout[n*729+530] += + s[206];
gout[n*729+531] += + s[207];
gout[n*729+532] += + s[208];
gout[n*729+533] += + s[209];
gout[n*729+534] += + s[210];
gout[n*729+535] += + s[211];
gout[n*729+536] += + s[212];
gout[n*729+537] += + s[213];
gout[n*729+538] += + s[214];
gout[n*729+539] += + s[215];
gout[n*729+540] += + s[216];
gout[n*729+541] += + s[217];
gout[n*729+542] += + s[218];
gout[n*729+543] += + s[219];
gout[n*729+544] += + s[220];
gout[n*729+545] += + s[221];
gout[n*729+546] += + s[222];
gout[n*729+547] += + s[223];
gout[n*729+548] += + s[224];
gout[n*729+549] += + s[225];
gout[n*729+550] += + s[226];
gout[n*729+551] += + s[227];
gout[n*729+552] += + s[228];
gout[n*729+553] += + s[229];
gout[n*729+554] += + s[230];
gout[n*729+555] += + s[231];
gout[n*729+556] += + s[232];
gout[n*729+557] += + s[233];
gout[n*729+558] += + s[234];
gout[n*729+559] += + s[235];
gout[n*729+560] += + s[236];
gout[n*729+561] += + s[237];
gout[n*729+562] += + s[238];
gout[n*729+563] += + s[239];
gout[n*729+564] += + s[240];
gout[n*729+565] += + s[241];
gout[n*729+566] += + s[242];
gout[n*729+567] += + s[405];
gout[n*729+568] += + s[406];
gout[n*729+569] += + s[407];
gout[n*729+570] += + s[408];
gout[n*729+571] += + s[409];
gout[n*729+572] += + s[410];
gout[n*729+573] += + s[411];
gout[n*729+574] += + s[412];
gout[n*729+575] += + s[413];
gout[n*729+576] += + s[414];
gout[n*729+577] += + s[415];
gout[n*729+578] += + s[416];
gout[n*729+579] += + s[417];
gout[n*729+580] += + s[418];
gout[n*729+581] += + s[419];
gout[n*729+582] += + s[420];
gout[n*729+583] += + s[421];
gout[n*729+584] += + s[422];
gout[n*729+585] += + s[423];
gout[n*729+586] += + s[424];
gout[n*729+587] += + s[425];
gout[n*729+588] += + s[426];
gout[n*729+589] += + s[427];
gout[n*729+590] += + s[428];
gout[n*729+591] += + s[429];
gout[n*729+592] += + s[430];
gout[n*729+593] += + s[431];
gout[n*729+594] += + s[432];
gout[n*729+595] += + s[433];
gout[n*729+596] += + s[434];
gout[n*729+597] += + s[435];
gout[n*729+598] += + s[436];
gout[n*729+599] += + s[437];
gout[n*729+600] += + s[438];
gout[n*729+601] += + s[439];
gout[n*729+602] += + s[440];
gout[n*729+603] += + s[441];
gout[n*729+604] += + s[442];
gout[n*729+605] += + s[443];
gout[n*729+606] += + s[444];
gout[n*729+607] += + s[445];
gout[n*729+608] += + s[446];
gout[n*729+609] += + s[447];
gout[n*729+610] += + s[448];
gout[n*729+611] += + s[449];
gout[n*729+612] += + s[450];
gout[n*729+613] += + s[451];
gout[n*729+614] += + s[452];
gout[n*729+615] += + s[453];
gout[n*729+616] += + s[454];
gout[n*729+617] += + s[455];
gout[n*729+618] += + s[456];
gout[n*729+619] += + s[457];
gout[n*729+620] += + s[458];
gout[n*729+621] += + s[459];
gout[n*729+622] += + s[460];
gout[n*729+623] += + s[461];
gout[n*729+624] += + s[462];
gout[n*729+625] += + s[463];
gout[n*729+626] += + s[464];
gout[n*729+627] += + s[465];
gout[n*729+628] += + s[466];
gout[n*729+629] += + s[467];
gout[n*729+630] += + s[468];
gout[n*729+631] += + s[469];
gout[n*729+632] += + s[470];
gout[n*729+633] += + s[471];
gout[n*729+634] += + s[472];
gout[n*729+635] += + s[473];
gout[n*729+636] += + s[474];
gout[n*729+637] += + s[475];
gout[n*729+638] += + s[476];
gout[n*729+639] += + s[477];
gout[n*729+640] += + s[478];
gout[n*729+641] += + s[479];
gout[n*729+642] += + s[480];
gout[n*729+643] += + s[481];
gout[n*729+644] += + s[482];
gout[n*729+645] += + s[483];
gout[n*729+646] += + s[484];
gout[n*729+647] += + s[485];
gout[n*729+648] += + s[648];
gout[n*729+649] += + s[649];
gout[n*729+650] += + s[650];
gout[n*729+651] += + s[651];
gout[n*729+652] += + s[652];
gout[n*729+653] += + s[653];
gout[n*729+654] += + s[654];
gout[n*729+655] += + s[655];
gout[n*729+656] += + s[656];
gout[n*729+657] += + s[657];
gout[n*729+658] += + s[658];
gout[n*729+659] += + s[659];
gout[n*729+660] += + s[660];
gout[n*729+661] += + s[661];
gout[n*729+662] += + s[662];
gout[n*729+663] += + s[663];
gout[n*729+664] += + s[664];
gout[n*729+665] += + s[665];
gout[n*729+666] += + s[666];
gout[n*729+667] += + s[667];
gout[n*729+668] += + s[668];
gout[n*729+669] += + s[669];
gout[n*729+670] += + s[670];
gout[n*729+671] += + s[671];
gout[n*729+672] += + s[672];
gout[n*729+673] += + s[673];
gout[n*729+674] += + s[674];
gout[n*729+675] += + s[675];
gout[n*729+676] += + s[676];
gout[n*729+677] += + s[677];
gout[n*729+678] += + s[678];
gout[n*729+679] += + s[679];
gout[n*729+680] += + s[680];
gout[n*729+681] += + s[681];
gout[n*729+682] += + s[682];
gout[n*729+683] += + s[683];
gout[n*729+684] += + s[684];
gout[n*729+685] += + s[685];
gout[n*729+686] += + s[686];
gout[n*729+687] += + s[687];
gout[n*729+688] += + s[688];
gout[n*729+689] += + s[689];
gout[n*729+690] += + s[690];
gout[n*729+691] += + s[691];
gout[n*729+692] += + s[692];
gout[n*729+693] += + s[693];
gout[n*729+694] += + s[694];
gout[n*729+695] += + s[695];
gout[n*729+696] += + s[696];
gout[n*729+697] += + s[697];
gout[n*729+698] += + s[698];
gout[n*729+699] += + s[699];
gout[n*729+700] += + s[700];
gout[n*729+701] += + s[701];
gout[n*729+702] += + s[702];
gout[n*729+703] += + s[703];
gout[n*729+704] += + s[704];
gout[n*729+705] += + s[705];
gout[n*729+706] += + s[706];
gout[n*729+707] += + s[707];
gout[n*729+708] += + s[708];
gout[n*729+709] += + s[709];
gout[n*729+710] += + s[710];
gout[n*729+711] += + s[711];
gout[n*729+712] += + s[712];
gout[n*729+713] += + s[713];
gout[n*729+714] += + s[714];
gout[n*729+715] += + s[715];
gout[n*729+716] += + s[716];
gout[n*729+717] += + s[717];
gout[n*729+718] += + s[718];
gout[n*729+719] += + s[719];
gout[n*729+720] += + s[720];
gout[n*729+721] += + s[721];
gout[n*729+722] += + s[722];
gout[n*729+723] += + s[723];
gout[n*729+724] += + s[724];
gout[n*729+725] += + s[725];
gout[n*729+726] += + s[726];
gout[n*729+727] += + s[727];
gout[n*729+728] += + s[728];
}}}
void int1e_ipipnnnip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipnnnip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipnnnip_cart
CACHE_SIZE_T int1e_ipipnnnip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnnip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipnnnip_sph
CACHE_SIZE_T int1e_ipipnnnip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 729};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnnip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipnnnip_spinor
ALL_CINT1E(int1e_ipipnnnip)
ALL_CINT1E_FORTRAN_(int1e_ipipnnnip)
/* <NABLA NABLA i|RJ RJ RJ |NABLA NABLA j> */
void CINTgout1e_int1e_ipipnnnipip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double *g64 = g63 + envs->g_size * 3;
double *g65 = g64 + envs->g_size * 3;
double *g66 = g65 + envs->g_size * 3;
double *g67 = g66 + envs->g_size * 3;
double *g68 = g67 + envs->g_size * 3;
double *g69 = g68 + envs->g_size * 3;
double *g70 = g69 + envs->g_size * 3;
double *g71 = g70 + envs->g_size * 3;
double *g72 = g71 + envs->g_size * 3;
double *g73 = g72 + envs->g_size * 3;
double *g74 = g73 + envs->g_size * 3;
double *g75 = g74 + envs->g_size * 3;
double *g76 = g75 + envs->g_size * 3;
double *g77 = g76 + envs->g_size * 3;
double *g78 = g77 + envs->g_size * 3;
double *g79 = g78 + envs->g_size * 3;
double *g80 = g79 + envs->g_size * 3;
double *g81 = g80 + envs->g_size * 3;
double *g82 = g81 + envs->g_size * 3;
double *g83 = g82 + envs->g_size * 3;
double *g84 = g83 + envs->g_size * 3;
double *g85 = g84 + envs->g_size * 3;
double *g86 = g85 + envs->g_size * 3;
double *g87 = g86 + envs->g_size * 3;
double *g88 = g87 + envs->g_size * 3;
double *g89 = g88 + envs->g_size * 3;
double *g90 = g89 + envs->g_size * 3;
double *g91 = g90 + envs->g_size * 3;
double *g92 = g91 + envs->g_size * 3;
double *g93 = g92 + envs->g_size * 3;
double *g94 = g93 + envs->g_size * 3;
double *g95 = g94 + envs->g_size * 3;
double *g96 = g95 + envs->g_size * 3;
double *g97 = g96 + envs->g_size * 3;
double *g98 = g97 + envs->g_size * 3;
double *g99 = g98 + envs->g_size * 3;
double *g100 = g99 + envs->g_size * 3;
double *g101 = g100 + envs->g_size * 3;
double *g102 = g101 + envs->g_size * 3;
double *g103 = g102 + envs->g_size * 3;
double *g104 = g103 + envs->g_size * 3;
double *g105 = g104 + envs->g_size * 3;
double *g106 = g105 + envs->g_size * 3;
double *g107 = g106 + envs->g_size * 3;
double *g108 = g107 + envs->g_size * 3;
double *g109 = g108 + envs->g_size * 3;
double *g110 = g109 + envs->g_size * 3;
double *g111 = g110 + envs->g_size * 3;
double *g112 = g111 + envs->g_size * 3;
double *g113 = g112 + envs->g_size * 3;
double *g114 = g113 + envs->g_size * 3;
double *g115 = g114 + envs->g_size * 3;
double *g116 = g115 + envs->g_size * 3;
double *g117 = g116 + envs->g_size * 3;
double *g118 = g117 + envs->g_size * 3;
double *g119 = g118 + envs->g_size * 3;
double *g120 = g119 + envs->g_size * 3;
double *g121 = g120 + envs->g_size * 3;
double *g122 = g121 + envs->g_size * 3;
double *g123 = g122 + envs->g_size * 3;
double *g124 = g123 + envs->g_size * 3;
double *g125 = g124 + envs->g_size * 3;
double *g126 = g125 + envs->g_size * 3;
double *g127 = g126 + envs->g_size * 3;
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[2187];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g8, g0, envs->i_l+2, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g10, g8, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g12, g8, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g14, g12, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g16, g0, envs->i_l+2, envs->j_l+4, 0);
G1E_D_J(g17, g16, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g18, g16, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g19, g18, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g20, g16, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g21, g20, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g22, g20, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g23, g22, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g24, g16, envs->i_l+2, envs->j_l+3, 0);
G1E_D_J(g25, g24, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g26, g24, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g27, g26, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g28, g24, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g29, g28, envs->i_l+2, envs->j_l+0, 0);
G1E_D_J(g30, g28, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g31, g30, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g32, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g33, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g34, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g35, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g36, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g37, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g38, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g39, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g40, g8, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g41, g9, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g42, g10, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g43, g11, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g44, g12, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g45, g13, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g46, g14, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g47, g15, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g48, g16, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g49, g17, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g50, g18, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g51, g19, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g52, g20, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g53, g21, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g54, g22, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g55, g23, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g56, g24, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g57, g25, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g58, g26, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g59, g27, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g60, g28, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g61, g29, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g62, g30, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g63, g31, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g64, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g65, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g66, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g67, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g68, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g69, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g70, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g71, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g72, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g73, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g74, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g75, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g76, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g77, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g78, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g79, g15, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g80, g16, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g81, g17, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g82, g18, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g83, g19, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g84, g20, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g85, g21, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g86, g22, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g87, g23, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g88, g24, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g89, g25, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g90, g26, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g91, g27, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g92, g28, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g93, g29, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g94, g30, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g95, g31, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g96, g32, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g97, g33, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g98, g34, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g99, g35, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g100, g36, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g101, g37, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g102, g38, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g103, g39, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g104, g40, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g105, g41, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g106, g42, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g107, g43, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g108, g44, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g109, g45, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g110, g46, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g111, g47, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g112, g48, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g113, g49, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g114, g50, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g115, g51, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g116, g52, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g117, g53, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g118, g54, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g119, g55, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g120, g56, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g121, g57, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g122, g58, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g123, g59, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g124, g60, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g125, g61, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g126, g62, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g127, g63, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g127[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g126[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g126[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g125[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g124[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g124[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g125[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g124[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g124[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g123[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g122[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g122[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g121[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g120[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g120[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g121[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g120[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g120[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g123[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g122[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g122[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g121[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g120[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g120[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g121[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g120[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g120[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g119[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g118[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g118[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g117[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g116[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g116[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g117[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g116[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g116[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g115[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g114[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g114[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g113[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g112[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g112[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g113[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g112[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g112[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g115[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g114[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g114[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g113[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g112[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g112[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g113[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g112[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g112[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g119[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g118[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g118[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g117[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g116[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g116[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g117[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g116[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g116[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g115[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g114[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g114[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g113[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g112[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g112[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g113[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g112[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g112[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g115[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g114[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g114[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g113[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g112[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g112[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g113[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g112[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g112[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g111[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g110[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g110[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g109[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g108[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g108[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g109[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g108[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g108[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g107[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g106[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g106[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g105[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g104[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g104[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g105[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g104[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g104[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g107[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g106[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g106[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g105[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g104[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g104[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g105[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g104[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g104[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g103[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g102[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g102[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g101[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g100[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g100[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g101[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g100[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g100[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g99[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g98[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g98[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g97[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g96[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g96[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g97[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g96[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g96[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g99[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g98[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g98[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g97[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g96[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g96[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g97[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g96[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g96[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g103[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g102[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g102[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g101[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g100[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g100[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g101[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g100[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g100[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g99[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g98[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g98[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g97[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g96[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g96[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g97[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g96[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g96[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g99[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g98[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g98[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g97[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g96[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g96[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g97[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g96[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g96[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g111[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g110[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g110[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g109[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g108[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g108[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g109[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g108[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g108[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g107[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g106[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g106[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g105[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g104[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g104[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g105[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g104[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g104[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g107[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g106[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g106[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g105[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g104[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g104[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g105[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g104[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g104[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g103[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g102[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g102[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g101[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g100[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g100[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g101[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g100[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g100[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g99[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g98[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g98[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g97[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g96[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g96[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g97[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g96[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g96[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g99[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g98[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g98[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g97[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g96[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g96[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g97[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g96[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g96[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g103[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g102[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g102[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g101[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g100[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g100[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g101[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g100[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g100[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g99[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g98[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g98[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g97[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g96[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g96[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g97[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g96[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g96[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g99[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g98[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g98[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g97[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g96[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g96[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g97[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g96[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g96[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g95[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g94[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g94[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g93[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g92[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g92[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g93[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g92[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g92[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g91[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g90[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g90[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g89[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g88[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g88[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g89[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g88[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g88[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g91[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g90[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g90[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g89[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g88[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g88[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g89[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g88[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g88[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g87[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g86[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g86[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g85[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g84[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g84[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g85[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g84[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g84[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g83[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g82[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g82[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g81[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g80[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g80[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g81[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g80[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g80[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g83[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g82[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g82[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g81[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g80[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g80[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g81[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g80[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g80[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g87[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g86[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g86[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g85[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g84[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g84[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g85[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g84[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g84[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g83[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g82[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g82[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g81[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g80[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g80[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g81[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g80[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g80[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g83[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g82[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g82[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g81[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g80[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g80[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g81[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g80[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g80[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g79[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g78[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g78[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g77[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g76[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g76[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g77[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g76[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g76[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g75[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g74[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g74[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g73[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g72[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g72[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g73[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g72[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g72[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g75[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g74[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g74[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g73[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g72[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g72[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g73[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g72[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g72[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g71[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g70[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g70[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g69[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g68[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g68[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g69[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g68[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g68[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g67[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g66[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g66[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g65[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g64[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g64[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g65[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g64[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g64[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g67[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g66[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g66[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g65[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g64[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g64[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g65[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g64[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g64[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g71[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g70[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g70[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g69[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g68[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g68[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g69[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g68[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g68[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g67[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g66[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g66[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g65[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g64[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g64[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g65[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g64[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g64[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g67[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g66[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g66[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g65[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g64[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g64[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g65[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g64[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g64[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g79[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g78[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g78[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g77[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g76[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g76[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g77[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g76[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g76[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g75[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g74[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g74[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g73[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g72[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g72[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g73[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g72[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g72[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g75[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g74[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g74[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g73[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g72[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g72[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g73[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g72[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g72[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g71[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g70[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g70[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g69[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g68[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g68[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g69[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g68[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g68[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g67[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g66[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g66[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g65[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g64[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g64[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g65[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g64[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g64[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g67[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g66[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g66[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g65[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g64[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g64[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g65[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g64[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g64[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g71[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g70[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g70[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g69[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g68[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g68[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g69[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g68[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g68[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g67[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g66[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g66[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g65[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g64[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g64[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g65[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g64[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g64[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g67[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g66[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g66[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g65[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g64[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g64[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g65[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g64[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g64[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g95[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g94[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g94[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g93[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g92[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g92[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g93[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g92[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g92[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g91[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g90[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g90[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g89[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g88[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g88[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g89[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g88[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g88[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g91[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g90[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g90[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g89[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g88[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g88[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g89[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g88[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g88[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g87[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g86[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g86[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g85[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g84[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g84[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g85[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g84[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g84[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g83[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g82[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g82[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g81[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g80[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g80[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g81[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g80[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g80[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g83[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g82[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g82[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g81[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g80[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g80[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g81[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g80[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g80[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g87[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g86[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g86[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g85[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g84[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g84[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g85[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g84[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g84[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g83[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g82[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g82[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g81[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g80[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g80[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g81[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g80[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g80[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g83[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g82[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g82[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g81[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g80[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g80[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g81[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g80[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g80[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g79[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g78[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g78[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g77[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g76[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g76[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g77[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g76[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g76[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g75[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g74[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g74[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g73[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g72[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g72[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g73[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g72[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g72[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g75[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g74[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g74[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g73[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g72[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g72[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g73[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g72[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g72[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g71[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g70[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g70[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g69[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g68[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g68[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g69[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g68[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g68[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g67[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g66[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g66[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g65[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g64[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g64[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g65[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g64[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g64[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g67[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g66[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g66[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g65[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g64[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g64[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g65[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g64[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g64[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g71[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g70[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g70[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g69[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g68[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g68[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g69[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g68[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g68[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g67[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g66[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g66[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g65[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g64[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g64[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g65[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g64[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g64[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g67[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g66[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g66[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g65[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g64[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g64[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g65[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g64[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g64[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g79[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g78[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g78[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g77[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g76[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g76[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g77[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g76[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g76[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g75[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g74[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g74[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g73[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g72[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g72[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g73[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g72[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g72[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g75[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g74[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g74[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g73[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g72[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g72[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g73[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g72[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g72[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g71[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g70[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g70[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g69[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g68[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g68[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g69[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g68[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g68[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g67[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g66[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g66[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g65[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g64[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g64[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g65[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g64[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g64[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g67[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g66[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g66[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g65[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g64[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g64[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g65[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g64[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g64[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g71[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g70[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g70[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g69[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g68[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g68[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g69[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g68[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g68[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g67[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g66[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g66[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g65[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g64[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g64[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g65[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g64[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g64[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g67[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g66[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g66[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g65[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g64[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g64[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g65[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g64[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g64[ix+0]*g0[iy+0]*g63[iz+0];
s[729] = + g63[ix+0]*g64[iy+0]*g0[iz+0];
s[730] = + g62[ix+0]*g65[iy+0]*g0[iz+0];
s[731] = + g62[ix+0]*g64[iy+0]*g1[iz+0];
s[732] = + g61[ix+0]*g66[iy+0]*g0[iz+0];
s[733] = + g60[ix+0]*g67[iy+0]*g0[iz+0];
s[734] = + g60[ix+0]*g66[iy+0]*g1[iz+0];
s[735] = + g61[ix+0]*g64[iy+0]*g2[iz+0];
s[736] = + g60[ix+0]*g65[iy+0]*g2[iz+0];
s[737] = + g60[ix+0]*g64[iy+0]*g3[iz+0];
s[738] = + g59[ix+0]*g68[iy+0]*g0[iz+0];
s[739] = + g58[ix+0]*g69[iy+0]*g0[iz+0];
s[740] = + g58[ix+0]*g68[iy+0]*g1[iz+0];
s[741] = + g57[ix+0]*g70[iy+0]*g0[iz+0];
s[742] = + g56[ix+0]*g71[iy+0]*g0[iz+0];
s[743] = + g56[ix+0]*g70[iy+0]*g1[iz+0];
s[744] = + g57[ix+0]*g68[iy+0]*g2[iz+0];
s[745] = + g56[ix+0]*g69[iy+0]*g2[iz+0];
s[746] = + g56[ix+0]*g68[iy+0]*g3[iz+0];
s[747] = + g59[ix+0]*g64[iy+0]*g4[iz+0];
s[748] = + g58[ix+0]*g65[iy+0]*g4[iz+0];
s[749] = + g58[ix+0]*g64[iy+0]*g5[iz+0];
s[750] = + g57[ix+0]*g66[iy+0]*g4[iz+0];
s[751] = + g56[ix+0]*g67[iy+0]*g4[iz+0];
s[752] = + g56[ix+0]*g66[iy+0]*g5[iz+0];
s[753] = + g57[ix+0]*g64[iy+0]*g6[iz+0];
s[754] = + g56[ix+0]*g65[iy+0]*g6[iz+0];
s[755] = + g56[ix+0]*g64[iy+0]*g7[iz+0];
s[756] = + g55[ix+0]*g72[iy+0]*g0[iz+0];
s[757] = + g54[ix+0]*g73[iy+0]*g0[iz+0];
s[758] = + g54[ix+0]*g72[iy+0]*g1[iz+0];
s[759] = + g53[ix+0]*g74[iy+0]*g0[iz+0];
s[760] = + g52[ix+0]*g75[iy+0]*g0[iz+0];
s[761] = + g52[ix+0]*g74[iy+0]*g1[iz+0];
s[762] = + g53[ix+0]*g72[iy+0]*g2[iz+0];
s[763] = + g52[ix+0]*g73[iy+0]*g2[iz+0];
s[764] = + g52[ix+0]*g72[iy+0]*g3[iz+0];
s[765] = + g51[ix+0]*g76[iy+0]*g0[iz+0];
s[766] = + g50[ix+0]*g77[iy+0]*g0[iz+0];
s[767] = + g50[ix+0]*g76[iy+0]*g1[iz+0];
s[768] = + g49[ix+0]*g78[iy+0]*g0[iz+0];
s[769] = + g48[ix+0]*g79[iy+0]*g0[iz+0];
s[770] = + g48[ix+0]*g78[iy+0]*g1[iz+0];
s[771] = + g49[ix+0]*g76[iy+0]*g2[iz+0];
s[772] = + g48[ix+0]*g77[iy+0]*g2[iz+0];
s[773] = + g48[ix+0]*g76[iy+0]*g3[iz+0];
s[774] = + g51[ix+0]*g72[iy+0]*g4[iz+0];
s[775] = + g50[ix+0]*g73[iy+0]*g4[iz+0];
s[776] = + g50[ix+0]*g72[iy+0]*g5[iz+0];
s[777] = + g49[ix+0]*g74[iy+0]*g4[iz+0];
s[778] = + g48[ix+0]*g75[iy+0]*g4[iz+0];
s[779] = + g48[ix+0]*g74[iy+0]*g5[iz+0];
s[780] = + g49[ix+0]*g72[iy+0]*g6[iz+0];
s[781] = + g48[ix+0]*g73[iy+0]*g6[iz+0];
s[782] = + g48[ix+0]*g72[iy+0]*g7[iz+0];
s[783] = + g55[ix+0]*g64[iy+0]*g8[iz+0];
s[784] = + g54[ix+0]*g65[iy+0]*g8[iz+0];
s[785] = + g54[ix+0]*g64[iy+0]*g9[iz+0];
s[786] = + g53[ix+0]*g66[iy+0]*g8[iz+0];
s[787] = + g52[ix+0]*g67[iy+0]*g8[iz+0];
s[788] = + g52[ix+0]*g66[iy+0]*g9[iz+0];
s[789] = + g53[ix+0]*g64[iy+0]*g10[iz+0];
s[790] = + g52[ix+0]*g65[iy+0]*g10[iz+0];
s[791] = + g52[ix+0]*g64[iy+0]*g11[iz+0];
s[792] = + g51[ix+0]*g68[iy+0]*g8[iz+0];
s[793] = + g50[ix+0]*g69[iy+0]*g8[iz+0];
s[794] = + g50[ix+0]*g68[iy+0]*g9[iz+0];
s[795] = + g49[ix+0]*g70[iy+0]*g8[iz+0];
s[796] = + g48[ix+0]*g71[iy+0]*g8[iz+0];
s[797] = + g48[ix+0]*g70[iy+0]*g9[iz+0];
s[798] = + g49[ix+0]*g68[iy+0]*g10[iz+0];
s[799] = + g48[ix+0]*g69[iy+0]*g10[iz+0];
s[800] = + g48[ix+0]*g68[iy+0]*g11[iz+0];
s[801] = + g51[ix+0]*g64[iy+0]*g12[iz+0];
s[802] = + g50[ix+0]*g65[iy+0]*g12[iz+0];
s[803] = + g50[ix+0]*g64[iy+0]*g13[iz+0];
s[804] = + g49[ix+0]*g66[iy+0]*g12[iz+0];
s[805] = + g48[ix+0]*g67[iy+0]*g12[iz+0];
s[806] = + g48[ix+0]*g66[iy+0]*g13[iz+0];
s[807] = + g49[ix+0]*g64[iy+0]*g14[iz+0];
s[808] = + g48[ix+0]*g65[iy+0]*g14[iz+0];
s[809] = + g48[ix+0]*g64[iy+0]*g15[iz+0];
s[810] = + g47[ix+0]*g80[iy+0]*g0[iz+0];
s[811] = + g46[ix+0]*g81[iy+0]*g0[iz+0];
s[812] = + g46[ix+0]*g80[iy+0]*g1[iz+0];
s[813] = + g45[ix+0]*g82[iy+0]*g0[iz+0];
s[814] = + g44[ix+0]*g83[iy+0]*g0[iz+0];
s[815] = + g44[ix+0]*g82[iy+0]*g1[iz+0];
s[816] = + g45[ix+0]*g80[iy+0]*g2[iz+0];
s[817] = + g44[ix+0]*g81[iy+0]*g2[iz+0];
s[818] = + g44[ix+0]*g80[iy+0]*g3[iz+0];
s[819] = + g43[ix+0]*g84[iy+0]*g0[iz+0];
s[820] = + g42[ix+0]*g85[iy+0]*g0[iz+0];
s[821] = + g42[ix+0]*g84[iy+0]*g1[iz+0];
s[822] = + g41[ix+0]*g86[iy+0]*g0[iz+0];
s[823] = + g40[ix+0]*g87[iy+0]*g0[iz+0];
s[824] = + g40[ix+0]*g86[iy+0]*g1[iz+0];
s[825] = + g41[ix+0]*g84[iy+0]*g2[iz+0];
s[826] = + g40[ix+0]*g85[iy+0]*g2[iz+0];
s[827] = + g40[ix+0]*g84[iy+0]*g3[iz+0];
s[828] = + g43[ix+0]*g80[iy+0]*g4[iz+0];
s[829] = + g42[ix+0]*g81[iy+0]*g4[iz+0];
s[830] = + g42[ix+0]*g80[iy+0]*g5[iz+0];
s[831] = + g41[ix+0]*g82[iy+0]*g4[iz+0];
s[832] = + g40[ix+0]*g83[iy+0]*g4[iz+0];
s[833] = + g40[ix+0]*g82[iy+0]*g5[iz+0];
s[834] = + g41[ix+0]*g80[iy+0]*g6[iz+0];
s[835] = + g40[ix+0]*g81[iy+0]*g6[iz+0];
s[836] = + g40[ix+0]*g80[iy+0]*g7[iz+0];
s[837] = + g39[ix+0]*g88[iy+0]*g0[iz+0];
s[838] = + g38[ix+0]*g89[iy+0]*g0[iz+0];
s[839] = + g38[ix+0]*g88[iy+0]*g1[iz+0];
s[840] = + g37[ix+0]*g90[iy+0]*g0[iz+0];
s[841] = + g36[ix+0]*g91[iy+0]*g0[iz+0];
s[842] = + g36[ix+0]*g90[iy+0]*g1[iz+0];
s[843] = + g37[ix+0]*g88[iy+0]*g2[iz+0];
s[844] = + g36[ix+0]*g89[iy+0]*g2[iz+0];
s[845] = + g36[ix+0]*g88[iy+0]*g3[iz+0];
s[846] = + g35[ix+0]*g92[iy+0]*g0[iz+0];
s[847] = + g34[ix+0]*g93[iy+0]*g0[iz+0];
s[848] = + g34[ix+0]*g92[iy+0]*g1[iz+0];
s[849] = + g33[ix+0]*g94[iy+0]*g0[iz+0];
s[850] = + g32[ix+0]*g95[iy+0]*g0[iz+0];
s[851] = + g32[ix+0]*g94[iy+0]*g1[iz+0];
s[852] = + g33[ix+0]*g92[iy+0]*g2[iz+0];
s[853] = + g32[ix+0]*g93[iy+0]*g2[iz+0];
s[854] = + g32[ix+0]*g92[iy+0]*g3[iz+0];
s[855] = + g35[ix+0]*g88[iy+0]*g4[iz+0];
s[856] = + g34[ix+0]*g89[iy+0]*g4[iz+0];
s[857] = + g34[ix+0]*g88[iy+0]*g5[iz+0];
s[858] = + g33[ix+0]*g90[iy+0]*g4[iz+0];
s[859] = + g32[ix+0]*g91[iy+0]*g4[iz+0];
s[860] = + g32[ix+0]*g90[iy+0]*g5[iz+0];
s[861] = + g33[ix+0]*g88[iy+0]*g6[iz+0];
s[862] = + g32[ix+0]*g89[iy+0]*g6[iz+0];
s[863] = + g32[ix+0]*g88[iy+0]*g7[iz+0];
s[864] = + g39[ix+0]*g80[iy+0]*g8[iz+0];
s[865] = + g38[ix+0]*g81[iy+0]*g8[iz+0];
s[866] = + g38[ix+0]*g80[iy+0]*g9[iz+0];
s[867] = + g37[ix+0]*g82[iy+0]*g8[iz+0];
s[868] = + g36[ix+0]*g83[iy+0]*g8[iz+0];
s[869] = + g36[ix+0]*g82[iy+0]*g9[iz+0];
s[870] = + g37[ix+0]*g80[iy+0]*g10[iz+0];
s[871] = + g36[ix+0]*g81[iy+0]*g10[iz+0];
s[872] = + g36[ix+0]*g80[iy+0]*g11[iz+0];
s[873] = + g35[ix+0]*g84[iy+0]*g8[iz+0];
s[874] = + g34[ix+0]*g85[iy+0]*g8[iz+0];
s[875] = + g34[ix+0]*g84[iy+0]*g9[iz+0];
s[876] = + g33[ix+0]*g86[iy+0]*g8[iz+0];
s[877] = + g32[ix+0]*g87[iy+0]*g8[iz+0];
s[878] = + g32[ix+0]*g86[iy+0]*g9[iz+0];
s[879] = + g33[ix+0]*g84[iy+0]*g10[iz+0];
s[880] = + g32[ix+0]*g85[iy+0]*g10[iz+0];
s[881] = + g32[ix+0]*g84[iy+0]*g11[iz+0];
s[882] = + g35[ix+0]*g80[iy+0]*g12[iz+0];
s[883] = + g34[ix+0]*g81[iy+0]*g12[iz+0];
s[884] = + g34[ix+0]*g80[iy+0]*g13[iz+0];
s[885] = + g33[ix+0]*g82[iy+0]*g12[iz+0];
s[886] = + g32[ix+0]*g83[iy+0]*g12[iz+0];
s[887] = + g32[ix+0]*g82[iy+0]*g13[iz+0];
s[888] = + g33[ix+0]*g80[iy+0]*g14[iz+0];
s[889] = + g32[ix+0]*g81[iy+0]*g14[iz+0];
s[890] = + g32[ix+0]*g80[iy+0]*g15[iz+0];
s[891] = + g47[ix+0]*g64[iy+0]*g16[iz+0];
s[892] = + g46[ix+0]*g65[iy+0]*g16[iz+0];
s[893] = + g46[ix+0]*g64[iy+0]*g17[iz+0];
s[894] = + g45[ix+0]*g66[iy+0]*g16[iz+0];
s[895] = + g44[ix+0]*g67[iy+0]*g16[iz+0];
s[896] = + g44[ix+0]*g66[iy+0]*g17[iz+0];
s[897] = + g45[ix+0]*g64[iy+0]*g18[iz+0];
s[898] = + g44[ix+0]*g65[iy+0]*g18[iz+0];
s[899] = + g44[ix+0]*g64[iy+0]*g19[iz+0];
s[900] = + g43[ix+0]*g68[iy+0]*g16[iz+0];
s[901] = + g42[ix+0]*g69[iy+0]*g16[iz+0];
s[902] = + g42[ix+0]*g68[iy+0]*g17[iz+0];
s[903] = + g41[ix+0]*g70[iy+0]*g16[iz+0];
s[904] = + g40[ix+0]*g71[iy+0]*g16[iz+0];
s[905] = + g40[ix+0]*g70[iy+0]*g17[iz+0];
s[906] = + g41[ix+0]*g68[iy+0]*g18[iz+0];
s[907] = + g40[ix+0]*g69[iy+0]*g18[iz+0];
s[908] = + g40[ix+0]*g68[iy+0]*g19[iz+0];
s[909] = + g43[ix+0]*g64[iy+0]*g20[iz+0];
s[910] = + g42[ix+0]*g65[iy+0]*g20[iz+0];
s[911] = + g42[ix+0]*g64[iy+0]*g21[iz+0];
s[912] = + g41[ix+0]*g66[iy+0]*g20[iz+0];
s[913] = + g40[ix+0]*g67[iy+0]*g20[iz+0];
s[914] = + g40[ix+0]*g66[iy+0]*g21[iz+0];
s[915] = + g41[ix+0]*g64[iy+0]*g22[iz+0];
s[916] = + g40[ix+0]*g65[iy+0]*g22[iz+0];
s[917] = + g40[ix+0]*g64[iy+0]*g23[iz+0];
s[918] = + g39[ix+0]*g72[iy+0]*g16[iz+0];
s[919] = + g38[ix+0]*g73[iy+0]*g16[iz+0];
s[920] = + g38[ix+0]*g72[iy+0]*g17[iz+0];
s[921] = + g37[ix+0]*g74[iy+0]*g16[iz+0];
s[922] = + g36[ix+0]*g75[iy+0]*g16[iz+0];
s[923] = + g36[ix+0]*g74[iy+0]*g17[iz+0];
s[924] = + g37[ix+0]*g72[iy+0]*g18[iz+0];
s[925] = + g36[ix+0]*g73[iy+0]*g18[iz+0];
s[926] = + g36[ix+0]*g72[iy+0]*g19[iz+0];
s[927] = + g35[ix+0]*g76[iy+0]*g16[iz+0];
s[928] = + g34[ix+0]*g77[iy+0]*g16[iz+0];
s[929] = + g34[ix+0]*g76[iy+0]*g17[iz+0];
s[930] = + g33[ix+0]*g78[iy+0]*g16[iz+0];
s[931] = + g32[ix+0]*g79[iy+0]*g16[iz+0];
s[932] = + g32[ix+0]*g78[iy+0]*g17[iz+0];
s[933] = + g33[ix+0]*g76[iy+0]*g18[iz+0];
s[934] = + g32[ix+0]*g77[iy+0]*g18[iz+0];
s[935] = + g32[ix+0]*g76[iy+0]*g19[iz+0];
s[936] = + g35[ix+0]*g72[iy+0]*g20[iz+0];
s[937] = + g34[ix+0]*g73[iy+0]*g20[iz+0];
s[938] = + g34[ix+0]*g72[iy+0]*g21[iz+0];
s[939] = + g33[ix+0]*g74[iy+0]*g20[iz+0];
s[940] = + g32[ix+0]*g75[iy+0]*g20[iz+0];
s[941] = + g32[ix+0]*g74[iy+0]*g21[iz+0];
s[942] = + g33[ix+0]*g72[iy+0]*g22[iz+0];
s[943] = + g32[ix+0]*g73[iy+0]*g22[iz+0];
s[944] = + g32[ix+0]*g72[iy+0]*g23[iz+0];
s[945] = + g39[ix+0]*g64[iy+0]*g24[iz+0];
s[946] = + g38[ix+0]*g65[iy+0]*g24[iz+0];
s[947] = + g38[ix+0]*g64[iy+0]*g25[iz+0];
s[948] = + g37[ix+0]*g66[iy+0]*g24[iz+0];
s[949] = + g36[ix+0]*g67[iy+0]*g24[iz+0];
s[950] = + g36[ix+0]*g66[iy+0]*g25[iz+0];
s[951] = + g37[ix+0]*g64[iy+0]*g26[iz+0];
s[952] = + g36[ix+0]*g65[iy+0]*g26[iz+0];
s[953] = + g36[ix+0]*g64[iy+0]*g27[iz+0];
s[954] = + g35[ix+0]*g68[iy+0]*g24[iz+0];
s[955] = + g34[ix+0]*g69[iy+0]*g24[iz+0];
s[956] = + g34[ix+0]*g68[iy+0]*g25[iz+0];
s[957] = + g33[ix+0]*g70[iy+0]*g24[iz+0];
s[958] = + g32[ix+0]*g71[iy+0]*g24[iz+0];
s[959] = + g32[ix+0]*g70[iy+0]*g25[iz+0];
s[960] = + g33[ix+0]*g68[iy+0]*g26[iz+0];
s[961] = + g32[ix+0]*g69[iy+0]*g26[iz+0];
s[962] = + g32[ix+0]*g68[iy+0]*g27[iz+0];
s[963] = + g35[ix+0]*g64[iy+0]*g28[iz+0];
s[964] = + g34[ix+0]*g65[iy+0]*g28[iz+0];
s[965] = + g34[ix+0]*g64[iy+0]*g29[iz+0];
s[966] = + g33[ix+0]*g66[iy+0]*g28[iz+0];
s[967] = + g32[ix+0]*g67[iy+0]*g28[iz+0];
s[968] = + g32[ix+0]*g66[iy+0]*g29[iz+0];
s[969] = + g33[ix+0]*g64[iy+0]*g30[iz+0];
s[970] = + g32[ix+0]*g65[iy+0]*g30[iz+0];
s[971] = + g32[ix+0]*g64[iy+0]*g31[iz+0];
s[972] = + g31[ix+0]*g96[iy+0]*g0[iz+0];
s[973] = + g30[ix+0]*g97[iy+0]*g0[iz+0];
s[974] = + g30[ix+0]*g96[iy+0]*g1[iz+0];
s[975] = + g29[ix+0]*g98[iy+0]*g0[iz+0];
s[976] = + g28[ix+0]*g99[iy+0]*g0[iz+0];
s[977] = + g28[ix+0]*g98[iy+0]*g1[iz+0];
s[978] = + g29[ix+0]*g96[iy+0]*g2[iz+0];
s[979] = + g28[ix+0]*g97[iy+0]*g2[iz+0];
s[980] = + g28[ix+0]*g96[iy+0]*g3[iz+0];
s[981] = + g27[ix+0]*g100[iy+0]*g0[iz+0];
s[982] = + g26[ix+0]*g101[iy+0]*g0[iz+0];
s[983] = + g26[ix+0]*g100[iy+0]*g1[iz+0];
s[984] = + g25[ix+0]*g102[iy+0]*g0[iz+0];
s[985] = + g24[ix+0]*g103[iy+0]*g0[iz+0];
s[986] = + g24[ix+0]*g102[iy+0]*g1[iz+0];
s[987] = + g25[ix+0]*g100[iy+0]*g2[iz+0];
s[988] = + g24[ix+0]*g101[iy+0]*g2[iz+0];
s[989] = + g24[ix+0]*g100[iy+0]*g3[iz+0];
s[990] = + g27[ix+0]*g96[iy+0]*g4[iz+0];
s[991] = + g26[ix+0]*g97[iy+0]*g4[iz+0];
s[992] = + g26[ix+0]*g96[iy+0]*g5[iz+0];
s[993] = + g25[ix+0]*g98[iy+0]*g4[iz+0];
s[994] = + g24[ix+0]*g99[iy+0]*g4[iz+0];
s[995] = + g24[ix+0]*g98[iy+0]*g5[iz+0];
s[996] = + g25[ix+0]*g96[iy+0]*g6[iz+0];
s[997] = + g24[ix+0]*g97[iy+0]*g6[iz+0];
s[998] = + g24[ix+0]*g96[iy+0]*g7[iz+0];
s[999] = + g23[ix+0]*g104[iy+0]*g0[iz+0];
s[1000] = + g22[ix+0]*g105[iy+0]*g0[iz+0];
s[1001] = + g22[ix+0]*g104[iy+0]*g1[iz+0];
s[1002] = + g21[ix+0]*g106[iy+0]*g0[iz+0];
s[1003] = + g20[ix+0]*g107[iy+0]*g0[iz+0];
s[1004] = + g20[ix+0]*g106[iy+0]*g1[iz+0];
s[1005] = + g21[ix+0]*g104[iy+0]*g2[iz+0];
s[1006] = + g20[ix+0]*g105[iy+0]*g2[iz+0];
s[1007] = + g20[ix+0]*g104[iy+0]*g3[iz+0];
s[1008] = + g19[ix+0]*g108[iy+0]*g0[iz+0];
s[1009] = + g18[ix+0]*g109[iy+0]*g0[iz+0];
s[1010] = + g18[ix+0]*g108[iy+0]*g1[iz+0];
s[1011] = + g17[ix+0]*g110[iy+0]*g0[iz+0];
s[1012] = + g16[ix+0]*g111[iy+0]*g0[iz+0];
s[1013] = + g16[ix+0]*g110[iy+0]*g1[iz+0];
s[1014] = + g17[ix+0]*g108[iy+0]*g2[iz+0];
s[1015] = + g16[ix+0]*g109[iy+0]*g2[iz+0];
s[1016] = + g16[ix+0]*g108[iy+0]*g3[iz+0];
s[1017] = + g19[ix+0]*g104[iy+0]*g4[iz+0];
s[1018] = + g18[ix+0]*g105[iy+0]*g4[iz+0];
s[1019] = + g18[ix+0]*g104[iy+0]*g5[iz+0];
s[1020] = + g17[ix+0]*g106[iy+0]*g4[iz+0];
s[1021] = + g16[ix+0]*g107[iy+0]*g4[iz+0];
s[1022] = + g16[ix+0]*g106[iy+0]*g5[iz+0];
s[1023] = + g17[ix+0]*g104[iy+0]*g6[iz+0];
s[1024] = + g16[ix+0]*g105[iy+0]*g6[iz+0];
s[1025] = + g16[ix+0]*g104[iy+0]*g7[iz+0];
s[1026] = + g23[ix+0]*g96[iy+0]*g8[iz+0];
s[1027] = + g22[ix+0]*g97[iy+0]*g8[iz+0];
s[1028] = + g22[ix+0]*g96[iy+0]*g9[iz+0];
s[1029] = + g21[ix+0]*g98[iy+0]*g8[iz+0];
s[1030] = + g20[ix+0]*g99[iy+0]*g8[iz+0];
s[1031] = + g20[ix+0]*g98[iy+0]*g9[iz+0];
s[1032] = + g21[ix+0]*g96[iy+0]*g10[iz+0];
s[1033] = + g20[ix+0]*g97[iy+0]*g10[iz+0];
s[1034] = + g20[ix+0]*g96[iy+0]*g11[iz+0];
s[1035] = + g19[ix+0]*g100[iy+0]*g8[iz+0];
s[1036] = + g18[ix+0]*g101[iy+0]*g8[iz+0];
s[1037] = + g18[ix+0]*g100[iy+0]*g9[iz+0];
s[1038] = + g17[ix+0]*g102[iy+0]*g8[iz+0];
s[1039] = + g16[ix+0]*g103[iy+0]*g8[iz+0];
s[1040] = + g16[ix+0]*g102[iy+0]*g9[iz+0];
s[1041] = + g17[ix+0]*g100[iy+0]*g10[iz+0];
s[1042] = + g16[ix+0]*g101[iy+0]*g10[iz+0];
s[1043] = + g16[ix+0]*g100[iy+0]*g11[iz+0];
s[1044] = + g19[ix+0]*g96[iy+0]*g12[iz+0];
s[1045] = + g18[ix+0]*g97[iy+0]*g12[iz+0];
s[1046] = + g18[ix+0]*g96[iy+0]*g13[iz+0];
s[1047] = + g17[ix+0]*g98[iy+0]*g12[iz+0];
s[1048] = + g16[ix+0]*g99[iy+0]*g12[iz+0];
s[1049] = + g16[ix+0]*g98[iy+0]*g13[iz+0];
s[1050] = + g17[ix+0]*g96[iy+0]*g14[iz+0];
s[1051] = + g16[ix+0]*g97[iy+0]*g14[iz+0];
s[1052] = + g16[ix+0]*g96[iy+0]*g15[iz+0];
s[1053] = + g15[ix+0]*g112[iy+0]*g0[iz+0];
s[1054] = + g14[ix+0]*g113[iy+0]*g0[iz+0];
s[1055] = + g14[ix+0]*g112[iy+0]*g1[iz+0];
s[1056] = + g13[ix+0]*g114[iy+0]*g0[iz+0];
s[1057] = + g12[ix+0]*g115[iy+0]*g0[iz+0];
s[1058] = + g12[ix+0]*g114[iy+0]*g1[iz+0];
s[1059] = + g13[ix+0]*g112[iy+0]*g2[iz+0];
s[1060] = + g12[ix+0]*g113[iy+0]*g2[iz+0];
s[1061] = + g12[ix+0]*g112[iy+0]*g3[iz+0];
s[1062] = + g11[ix+0]*g116[iy+0]*g0[iz+0];
s[1063] = + g10[ix+0]*g117[iy+0]*g0[iz+0];
s[1064] = + g10[ix+0]*g116[iy+0]*g1[iz+0];
s[1065] = + g9[ix+0]*g118[iy+0]*g0[iz+0];
s[1066] = + g8[ix+0]*g119[iy+0]*g0[iz+0];
s[1067] = + g8[ix+0]*g118[iy+0]*g1[iz+0];
s[1068] = + g9[ix+0]*g116[iy+0]*g2[iz+0];
s[1069] = + g8[ix+0]*g117[iy+0]*g2[iz+0];
s[1070] = + g8[ix+0]*g116[iy+0]*g3[iz+0];
s[1071] = + g11[ix+0]*g112[iy+0]*g4[iz+0];
s[1072] = + g10[ix+0]*g113[iy+0]*g4[iz+0];
s[1073] = + g10[ix+0]*g112[iy+0]*g5[iz+0];
s[1074] = + g9[ix+0]*g114[iy+0]*g4[iz+0];
s[1075] = + g8[ix+0]*g115[iy+0]*g4[iz+0];
s[1076] = + g8[ix+0]*g114[iy+0]*g5[iz+0];
s[1077] = + g9[ix+0]*g112[iy+0]*g6[iz+0];
s[1078] = + g8[ix+0]*g113[iy+0]*g6[iz+0];
s[1079] = + g8[ix+0]*g112[iy+0]*g7[iz+0];
s[1080] = + g7[ix+0]*g120[iy+0]*g0[iz+0];
s[1081] = + g6[ix+0]*g121[iy+0]*g0[iz+0];
s[1082] = + g6[ix+0]*g120[iy+0]*g1[iz+0];
s[1083] = + g5[ix+0]*g122[iy+0]*g0[iz+0];
s[1084] = + g4[ix+0]*g123[iy+0]*g0[iz+0];
s[1085] = + g4[ix+0]*g122[iy+0]*g1[iz+0];
s[1086] = + g5[ix+0]*g120[iy+0]*g2[iz+0];
s[1087] = + g4[ix+0]*g121[iy+0]*g2[iz+0];
s[1088] = + g4[ix+0]*g120[iy+0]*g3[iz+0];
s[1089] = + g3[ix+0]*g124[iy+0]*g0[iz+0];
s[1090] = + g2[ix+0]*g125[iy+0]*g0[iz+0];
s[1091] = + g2[ix+0]*g124[iy+0]*g1[iz+0];
s[1092] = + g1[ix+0]*g126[iy+0]*g0[iz+0];
s[1093] = + g0[ix+0]*g127[iy+0]*g0[iz+0];
s[1094] = + g0[ix+0]*g126[iy+0]*g1[iz+0];
s[1095] = + g1[ix+0]*g124[iy+0]*g2[iz+0];
s[1096] = + g0[ix+0]*g125[iy+0]*g2[iz+0];
s[1097] = + g0[ix+0]*g124[iy+0]*g3[iz+0];
s[1098] = + g3[ix+0]*g120[iy+0]*g4[iz+0];
s[1099] = + g2[ix+0]*g121[iy+0]*g4[iz+0];
s[1100] = + g2[ix+0]*g120[iy+0]*g5[iz+0];
s[1101] = + g1[ix+0]*g122[iy+0]*g4[iz+0];
s[1102] = + g0[ix+0]*g123[iy+0]*g4[iz+0];
s[1103] = + g0[ix+0]*g122[iy+0]*g5[iz+0];
s[1104] = + g1[ix+0]*g120[iy+0]*g6[iz+0];
s[1105] = + g0[ix+0]*g121[iy+0]*g6[iz+0];
s[1106] = + g0[ix+0]*g120[iy+0]*g7[iz+0];
s[1107] = + g7[ix+0]*g112[iy+0]*g8[iz+0];
s[1108] = + g6[ix+0]*g113[iy+0]*g8[iz+0];
s[1109] = + g6[ix+0]*g112[iy+0]*g9[iz+0];
s[1110] = + g5[ix+0]*g114[iy+0]*g8[iz+0];
s[1111] = + g4[ix+0]*g115[iy+0]*g8[iz+0];
s[1112] = + g4[ix+0]*g114[iy+0]*g9[iz+0];
s[1113] = + g5[ix+0]*g112[iy+0]*g10[iz+0];
s[1114] = + g4[ix+0]*g113[iy+0]*g10[iz+0];
s[1115] = + g4[ix+0]*g112[iy+0]*g11[iz+0];
s[1116] = + g3[ix+0]*g116[iy+0]*g8[iz+0];
s[1117] = + g2[ix+0]*g117[iy+0]*g8[iz+0];
s[1118] = + g2[ix+0]*g116[iy+0]*g9[iz+0];
s[1119] = + g1[ix+0]*g118[iy+0]*g8[iz+0];
s[1120] = + g0[ix+0]*g119[iy+0]*g8[iz+0];
s[1121] = + g0[ix+0]*g118[iy+0]*g9[iz+0];
s[1122] = + g1[ix+0]*g116[iy+0]*g10[iz+0];
s[1123] = + g0[ix+0]*g117[iy+0]*g10[iz+0];
s[1124] = + g0[ix+0]*g116[iy+0]*g11[iz+0];
s[1125] = + g3[ix+0]*g112[iy+0]*g12[iz+0];
s[1126] = + g2[ix+0]*g113[iy+0]*g12[iz+0];
s[1127] = + g2[ix+0]*g112[iy+0]*g13[iz+0];
s[1128] = + g1[ix+0]*g114[iy+0]*g12[iz+0];
s[1129] = + g0[ix+0]*g115[iy+0]*g12[iz+0];
s[1130] = + g0[ix+0]*g114[iy+0]*g13[iz+0];
s[1131] = + g1[ix+0]*g112[iy+0]*g14[iz+0];
s[1132] = + g0[ix+0]*g113[iy+0]*g14[iz+0];
s[1133] = + g0[ix+0]*g112[iy+0]*g15[iz+0];
s[1134] = + g15[ix+0]*g96[iy+0]*g16[iz+0];
s[1135] = + g14[ix+0]*g97[iy+0]*g16[iz+0];
s[1136] = + g14[ix+0]*g96[iy+0]*g17[iz+0];
s[1137] = + g13[ix+0]*g98[iy+0]*g16[iz+0];
s[1138] = + g12[ix+0]*g99[iy+0]*g16[iz+0];
s[1139] = + g12[ix+0]*g98[iy+0]*g17[iz+0];
s[1140] = + g13[ix+0]*g96[iy+0]*g18[iz+0];
s[1141] = + g12[ix+0]*g97[iy+0]*g18[iz+0];
s[1142] = + g12[ix+0]*g96[iy+0]*g19[iz+0];
s[1143] = + g11[ix+0]*g100[iy+0]*g16[iz+0];
s[1144] = + g10[ix+0]*g101[iy+0]*g16[iz+0];
s[1145] = + g10[ix+0]*g100[iy+0]*g17[iz+0];
s[1146] = + g9[ix+0]*g102[iy+0]*g16[iz+0];
s[1147] = + g8[ix+0]*g103[iy+0]*g16[iz+0];
s[1148] = + g8[ix+0]*g102[iy+0]*g17[iz+0];
s[1149] = + g9[ix+0]*g100[iy+0]*g18[iz+0];
s[1150] = + g8[ix+0]*g101[iy+0]*g18[iz+0];
s[1151] = + g8[ix+0]*g100[iy+0]*g19[iz+0];
s[1152] = + g11[ix+0]*g96[iy+0]*g20[iz+0];
s[1153] = + g10[ix+0]*g97[iy+0]*g20[iz+0];
s[1154] = + g10[ix+0]*g96[iy+0]*g21[iz+0];
s[1155] = + g9[ix+0]*g98[iy+0]*g20[iz+0];
s[1156] = + g8[ix+0]*g99[iy+0]*g20[iz+0];
s[1157] = + g8[ix+0]*g98[iy+0]*g21[iz+0];
s[1158] = + g9[ix+0]*g96[iy+0]*g22[iz+0];
s[1159] = + g8[ix+0]*g97[iy+0]*g22[iz+0];
s[1160] = + g8[ix+0]*g96[iy+0]*g23[iz+0];
s[1161] = + g7[ix+0]*g104[iy+0]*g16[iz+0];
s[1162] = + g6[ix+0]*g105[iy+0]*g16[iz+0];
s[1163] = + g6[ix+0]*g104[iy+0]*g17[iz+0];
s[1164] = + g5[ix+0]*g106[iy+0]*g16[iz+0];
s[1165] = + g4[ix+0]*g107[iy+0]*g16[iz+0];
s[1166] = + g4[ix+0]*g106[iy+0]*g17[iz+0];
s[1167] = + g5[ix+0]*g104[iy+0]*g18[iz+0];
s[1168] = + g4[ix+0]*g105[iy+0]*g18[iz+0];
s[1169] = + g4[ix+0]*g104[iy+0]*g19[iz+0];
s[1170] = + g3[ix+0]*g108[iy+0]*g16[iz+0];
s[1171] = + g2[ix+0]*g109[iy+0]*g16[iz+0];
s[1172] = + g2[ix+0]*g108[iy+0]*g17[iz+0];
s[1173] = + g1[ix+0]*g110[iy+0]*g16[iz+0];
s[1174] = + g0[ix+0]*g111[iy+0]*g16[iz+0];
s[1175] = + g0[ix+0]*g110[iy+0]*g17[iz+0];
s[1176] = + g1[ix+0]*g108[iy+0]*g18[iz+0];
s[1177] = + g0[ix+0]*g109[iy+0]*g18[iz+0];
s[1178] = + g0[ix+0]*g108[iy+0]*g19[iz+0];
s[1179] = + g3[ix+0]*g104[iy+0]*g20[iz+0];
s[1180] = + g2[ix+0]*g105[iy+0]*g20[iz+0];
s[1181] = + g2[ix+0]*g104[iy+0]*g21[iz+0];
s[1182] = + g1[ix+0]*g106[iy+0]*g20[iz+0];
s[1183] = + g0[ix+0]*g107[iy+0]*g20[iz+0];
s[1184] = + g0[ix+0]*g106[iy+0]*g21[iz+0];
s[1185] = + g1[ix+0]*g104[iy+0]*g22[iz+0];
s[1186] = + g0[ix+0]*g105[iy+0]*g22[iz+0];
s[1187] = + g0[ix+0]*g104[iy+0]*g23[iz+0];
s[1188] = + g7[ix+0]*g96[iy+0]*g24[iz+0];
s[1189] = + g6[ix+0]*g97[iy+0]*g24[iz+0];
s[1190] = + g6[ix+0]*g96[iy+0]*g25[iz+0];
s[1191] = + g5[ix+0]*g98[iy+0]*g24[iz+0];
s[1192] = + g4[ix+0]*g99[iy+0]*g24[iz+0];
s[1193] = + g4[ix+0]*g98[iy+0]*g25[iz+0];
s[1194] = + g5[ix+0]*g96[iy+0]*g26[iz+0];
s[1195] = + g4[ix+0]*g97[iy+0]*g26[iz+0];
s[1196] = + g4[ix+0]*g96[iy+0]*g27[iz+0];
s[1197] = + g3[ix+0]*g100[iy+0]*g24[iz+0];
s[1198] = + g2[ix+0]*g101[iy+0]*g24[iz+0];
s[1199] = + g2[ix+0]*g100[iy+0]*g25[iz+0];
s[1200] = + g1[ix+0]*g102[iy+0]*g24[iz+0];
s[1201] = + g0[ix+0]*g103[iy+0]*g24[iz+0];
s[1202] = + g0[ix+0]*g102[iy+0]*g25[iz+0];
s[1203] = + g1[ix+0]*g100[iy+0]*g26[iz+0];
s[1204] = + g0[ix+0]*g101[iy+0]*g26[iz+0];
s[1205] = + g0[ix+0]*g100[iy+0]*g27[iz+0];
s[1206] = + g3[ix+0]*g96[iy+0]*g28[iz+0];
s[1207] = + g2[ix+0]*g97[iy+0]*g28[iz+0];
s[1208] = + g2[ix+0]*g96[iy+0]*g29[iz+0];
s[1209] = + g1[ix+0]*g98[iy+0]*g28[iz+0];
s[1210] = + g0[ix+0]*g99[iy+0]*g28[iz+0];
s[1211] = + g0[ix+0]*g98[iy+0]*g29[iz+0];
s[1212] = + g1[ix+0]*g96[iy+0]*g30[iz+0];
s[1213] = + g0[ix+0]*g97[iy+0]*g30[iz+0];
s[1214] = + g0[ix+0]*g96[iy+0]*g31[iz+0];
s[1215] = + g31[ix+0]*g64[iy+0]*g32[iz+0];
s[1216] = + g30[ix+0]*g65[iy+0]*g32[iz+0];
s[1217] = + g30[ix+0]*g64[iy+0]*g33[iz+0];
s[1218] = + g29[ix+0]*g66[iy+0]*g32[iz+0];
s[1219] = + g28[ix+0]*g67[iy+0]*g32[iz+0];
s[1220] = + g28[ix+0]*g66[iy+0]*g33[iz+0];
s[1221] = + g29[ix+0]*g64[iy+0]*g34[iz+0];
s[1222] = + g28[ix+0]*g65[iy+0]*g34[iz+0];
s[1223] = + g28[ix+0]*g64[iy+0]*g35[iz+0];
s[1224] = + g27[ix+0]*g68[iy+0]*g32[iz+0];
s[1225] = + g26[ix+0]*g69[iy+0]*g32[iz+0];
s[1226] = + g26[ix+0]*g68[iy+0]*g33[iz+0];
s[1227] = + g25[ix+0]*g70[iy+0]*g32[iz+0];
s[1228] = + g24[ix+0]*g71[iy+0]*g32[iz+0];
s[1229] = + g24[ix+0]*g70[iy+0]*g33[iz+0];
s[1230] = + g25[ix+0]*g68[iy+0]*g34[iz+0];
s[1231] = + g24[ix+0]*g69[iy+0]*g34[iz+0];
s[1232] = + g24[ix+0]*g68[iy+0]*g35[iz+0];
s[1233] = + g27[ix+0]*g64[iy+0]*g36[iz+0];
s[1234] = + g26[ix+0]*g65[iy+0]*g36[iz+0];
s[1235] = + g26[ix+0]*g64[iy+0]*g37[iz+0];
s[1236] = + g25[ix+0]*g66[iy+0]*g36[iz+0];
s[1237] = + g24[ix+0]*g67[iy+0]*g36[iz+0];
s[1238] = + g24[ix+0]*g66[iy+0]*g37[iz+0];
s[1239] = + g25[ix+0]*g64[iy+0]*g38[iz+0];
s[1240] = + g24[ix+0]*g65[iy+0]*g38[iz+0];
s[1241] = + g24[ix+0]*g64[iy+0]*g39[iz+0];
s[1242] = + g23[ix+0]*g72[iy+0]*g32[iz+0];
s[1243] = + g22[ix+0]*g73[iy+0]*g32[iz+0];
s[1244] = + g22[ix+0]*g72[iy+0]*g33[iz+0];
s[1245] = + g21[ix+0]*g74[iy+0]*g32[iz+0];
s[1246] = + g20[ix+0]*g75[iy+0]*g32[iz+0];
s[1247] = + g20[ix+0]*g74[iy+0]*g33[iz+0];
s[1248] = + g21[ix+0]*g72[iy+0]*g34[iz+0];
s[1249] = + g20[ix+0]*g73[iy+0]*g34[iz+0];
s[1250] = + g20[ix+0]*g72[iy+0]*g35[iz+0];
s[1251] = + g19[ix+0]*g76[iy+0]*g32[iz+0];
s[1252] = + g18[ix+0]*g77[iy+0]*g32[iz+0];
s[1253] = + g18[ix+0]*g76[iy+0]*g33[iz+0];
s[1254] = + g17[ix+0]*g78[iy+0]*g32[iz+0];
s[1255] = + g16[ix+0]*g79[iy+0]*g32[iz+0];
s[1256] = + g16[ix+0]*g78[iy+0]*g33[iz+0];
s[1257] = + g17[ix+0]*g76[iy+0]*g34[iz+0];
s[1258] = + g16[ix+0]*g77[iy+0]*g34[iz+0];
s[1259] = + g16[ix+0]*g76[iy+0]*g35[iz+0];
s[1260] = + g19[ix+0]*g72[iy+0]*g36[iz+0];
s[1261] = + g18[ix+0]*g73[iy+0]*g36[iz+0];
s[1262] = + g18[ix+0]*g72[iy+0]*g37[iz+0];
s[1263] = + g17[ix+0]*g74[iy+0]*g36[iz+0];
s[1264] = + g16[ix+0]*g75[iy+0]*g36[iz+0];
s[1265] = + g16[ix+0]*g74[iy+0]*g37[iz+0];
s[1266] = + g17[ix+0]*g72[iy+0]*g38[iz+0];
s[1267] = + g16[ix+0]*g73[iy+0]*g38[iz+0];
s[1268] = + g16[ix+0]*g72[iy+0]*g39[iz+0];
s[1269] = + g23[ix+0]*g64[iy+0]*g40[iz+0];
s[1270] = + g22[ix+0]*g65[iy+0]*g40[iz+0];
s[1271] = + g22[ix+0]*g64[iy+0]*g41[iz+0];
s[1272] = + g21[ix+0]*g66[iy+0]*g40[iz+0];
s[1273] = + g20[ix+0]*g67[iy+0]*g40[iz+0];
s[1274] = + g20[ix+0]*g66[iy+0]*g41[iz+0];
s[1275] = + g21[ix+0]*g64[iy+0]*g42[iz+0];
s[1276] = + g20[ix+0]*g65[iy+0]*g42[iz+0];
s[1277] = + g20[ix+0]*g64[iy+0]*g43[iz+0];
s[1278] = + g19[ix+0]*g68[iy+0]*g40[iz+0];
s[1279] = + g18[ix+0]*g69[iy+0]*g40[iz+0];
s[1280] = + g18[ix+0]*g68[iy+0]*g41[iz+0];
s[1281] = + g17[ix+0]*g70[iy+0]*g40[iz+0];
s[1282] = + g16[ix+0]*g71[iy+0]*g40[iz+0];
s[1283] = + g16[ix+0]*g70[iy+0]*g41[iz+0];
s[1284] = + g17[ix+0]*g68[iy+0]*g42[iz+0];
s[1285] = + g16[ix+0]*g69[iy+0]*g42[iz+0];
s[1286] = + g16[ix+0]*g68[iy+0]*g43[iz+0];
s[1287] = + g19[ix+0]*g64[iy+0]*g44[iz+0];
s[1288] = + g18[ix+0]*g65[iy+0]*g44[iz+0];
s[1289] = + g18[ix+0]*g64[iy+0]*g45[iz+0];
s[1290] = + g17[ix+0]*g66[iy+0]*g44[iz+0];
s[1291] = + g16[ix+0]*g67[iy+0]*g44[iz+0];
s[1292] = + g16[ix+0]*g66[iy+0]*g45[iz+0];
s[1293] = + g17[ix+0]*g64[iy+0]*g46[iz+0];
s[1294] = + g16[ix+0]*g65[iy+0]*g46[iz+0];
s[1295] = + g16[ix+0]*g64[iy+0]*g47[iz+0];
s[1296] = + g15[ix+0]*g80[iy+0]*g32[iz+0];
s[1297] = + g14[ix+0]*g81[iy+0]*g32[iz+0];
s[1298] = + g14[ix+0]*g80[iy+0]*g33[iz+0];
s[1299] = + g13[ix+0]*g82[iy+0]*g32[iz+0];
s[1300] = + g12[ix+0]*g83[iy+0]*g32[iz+0];
s[1301] = + g12[ix+0]*g82[iy+0]*g33[iz+0];
s[1302] = + g13[ix+0]*g80[iy+0]*g34[iz+0];
s[1303] = + g12[ix+0]*g81[iy+0]*g34[iz+0];
s[1304] = + g12[ix+0]*g80[iy+0]*g35[iz+0];
s[1305] = + g11[ix+0]*g84[iy+0]*g32[iz+0];
s[1306] = + g10[ix+0]*g85[iy+0]*g32[iz+0];
s[1307] = + g10[ix+0]*g84[iy+0]*g33[iz+0];
s[1308] = + g9[ix+0]*g86[iy+0]*g32[iz+0];
s[1309] = + g8[ix+0]*g87[iy+0]*g32[iz+0];
s[1310] = + g8[ix+0]*g86[iy+0]*g33[iz+0];
s[1311] = + g9[ix+0]*g84[iy+0]*g34[iz+0];
s[1312] = + g8[ix+0]*g85[iy+0]*g34[iz+0];
s[1313] = + g8[ix+0]*g84[iy+0]*g35[iz+0];
s[1314] = + g11[ix+0]*g80[iy+0]*g36[iz+0];
s[1315] = + g10[ix+0]*g81[iy+0]*g36[iz+0];
s[1316] = + g10[ix+0]*g80[iy+0]*g37[iz+0];
s[1317] = + g9[ix+0]*g82[iy+0]*g36[iz+0];
s[1318] = + g8[ix+0]*g83[iy+0]*g36[iz+0];
s[1319] = + g8[ix+0]*g82[iy+0]*g37[iz+0];
s[1320] = + g9[ix+0]*g80[iy+0]*g38[iz+0];
s[1321] = + g8[ix+0]*g81[iy+0]*g38[iz+0];
s[1322] = + g8[ix+0]*g80[iy+0]*g39[iz+0];
s[1323] = + g7[ix+0]*g88[iy+0]*g32[iz+0];
s[1324] = + g6[ix+0]*g89[iy+0]*g32[iz+0];
s[1325] = + g6[ix+0]*g88[iy+0]*g33[iz+0];
s[1326] = + g5[ix+0]*g90[iy+0]*g32[iz+0];
s[1327] = + g4[ix+0]*g91[iy+0]*g32[iz+0];
s[1328] = + g4[ix+0]*g90[iy+0]*g33[iz+0];
s[1329] = + g5[ix+0]*g88[iy+0]*g34[iz+0];
s[1330] = + g4[ix+0]*g89[iy+0]*g34[iz+0];
s[1331] = + g4[ix+0]*g88[iy+0]*g35[iz+0];
s[1332] = + g3[ix+0]*g92[iy+0]*g32[iz+0];
s[1333] = + g2[ix+0]*g93[iy+0]*g32[iz+0];
s[1334] = + g2[ix+0]*g92[iy+0]*g33[iz+0];
s[1335] = + g1[ix+0]*g94[iy+0]*g32[iz+0];
s[1336] = + g0[ix+0]*g95[iy+0]*g32[iz+0];
s[1337] = + g0[ix+0]*g94[iy+0]*g33[iz+0];
s[1338] = + g1[ix+0]*g92[iy+0]*g34[iz+0];
s[1339] = + g0[ix+0]*g93[iy+0]*g34[iz+0];
s[1340] = + g0[ix+0]*g92[iy+0]*g35[iz+0];
s[1341] = + g3[ix+0]*g88[iy+0]*g36[iz+0];
s[1342] = + g2[ix+0]*g89[iy+0]*g36[iz+0];
s[1343] = + g2[ix+0]*g88[iy+0]*g37[iz+0];
s[1344] = + g1[ix+0]*g90[iy+0]*g36[iz+0];
s[1345] = + g0[ix+0]*g91[iy+0]*g36[iz+0];
s[1346] = + g0[ix+0]*g90[iy+0]*g37[iz+0];
s[1347] = + g1[ix+0]*g88[iy+0]*g38[iz+0];
s[1348] = + g0[ix+0]*g89[iy+0]*g38[iz+0];
s[1349] = + g0[ix+0]*g88[iy+0]*g39[iz+0];
s[1350] = + g7[ix+0]*g80[iy+0]*g40[iz+0];
s[1351] = + g6[ix+0]*g81[iy+0]*g40[iz+0];
s[1352] = + g6[ix+0]*g80[iy+0]*g41[iz+0];
s[1353] = + g5[ix+0]*g82[iy+0]*g40[iz+0];
s[1354] = + g4[ix+0]*g83[iy+0]*g40[iz+0];
s[1355] = + g4[ix+0]*g82[iy+0]*g41[iz+0];
s[1356] = + g5[ix+0]*g80[iy+0]*g42[iz+0];
s[1357] = + g4[ix+0]*g81[iy+0]*g42[iz+0];
s[1358] = + g4[ix+0]*g80[iy+0]*g43[iz+0];
s[1359] = + g3[ix+0]*g84[iy+0]*g40[iz+0];
s[1360] = + g2[ix+0]*g85[iy+0]*g40[iz+0];
s[1361] = + g2[ix+0]*g84[iy+0]*g41[iz+0];
s[1362] = + g1[ix+0]*g86[iy+0]*g40[iz+0];
s[1363] = + g0[ix+0]*g87[iy+0]*g40[iz+0];
s[1364] = + g0[ix+0]*g86[iy+0]*g41[iz+0];
s[1365] = + g1[ix+0]*g84[iy+0]*g42[iz+0];
s[1366] = + g0[ix+0]*g85[iy+0]*g42[iz+0];
s[1367] = + g0[ix+0]*g84[iy+0]*g43[iz+0];
s[1368] = + g3[ix+0]*g80[iy+0]*g44[iz+0];
s[1369] = + g2[ix+0]*g81[iy+0]*g44[iz+0];
s[1370] = + g2[ix+0]*g80[iy+0]*g45[iz+0];
s[1371] = + g1[ix+0]*g82[iy+0]*g44[iz+0];
s[1372] = + g0[ix+0]*g83[iy+0]*g44[iz+0];
s[1373] = + g0[ix+0]*g82[iy+0]*g45[iz+0];
s[1374] = + g1[ix+0]*g80[iy+0]*g46[iz+0];
s[1375] = + g0[ix+0]*g81[iy+0]*g46[iz+0];
s[1376] = + g0[ix+0]*g80[iy+0]*g47[iz+0];
s[1377] = + g15[ix+0]*g64[iy+0]*g48[iz+0];
s[1378] = + g14[ix+0]*g65[iy+0]*g48[iz+0];
s[1379] = + g14[ix+0]*g64[iy+0]*g49[iz+0];
s[1380] = + g13[ix+0]*g66[iy+0]*g48[iz+0];
s[1381] = + g12[ix+0]*g67[iy+0]*g48[iz+0];
s[1382] = + g12[ix+0]*g66[iy+0]*g49[iz+0];
s[1383] = + g13[ix+0]*g64[iy+0]*g50[iz+0];
s[1384] = + g12[ix+0]*g65[iy+0]*g50[iz+0];
s[1385] = + g12[ix+0]*g64[iy+0]*g51[iz+0];
s[1386] = + g11[ix+0]*g68[iy+0]*g48[iz+0];
s[1387] = + g10[ix+0]*g69[iy+0]*g48[iz+0];
s[1388] = + g10[ix+0]*g68[iy+0]*g49[iz+0];
s[1389] = + g9[ix+0]*g70[iy+0]*g48[iz+0];
s[1390] = + g8[ix+0]*g71[iy+0]*g48[iz+0];
s[1391] = + g8[ix+0]*g70[iy+0]*g49[iz+0];
s[1392] = + g9[ix+0]*g68[iy+0]*g50[iz+0];
s[1393] = + g8[ix+0]*g69[iy+0]*g50[iz+0];
s[1394] = + g8[ix+0]*g68[iy+0]*g51[iz+0];
s[1395] = + g11[ix+0]*g64[iy+0]*g52[iz+0];
s[1396] = + g10[ix+0]*g65[iy+0]*g52[iz+0];
s[1397] = + g10[ix+0]*g64[iy+0]*g53[iz+0];
s[1398] = + g9[ix+0]*g66[iy+0]*g52[iz+0];
s[1399] = + g8[ix+0]*g67[iy+0]*g52[iz+0];
s[1400] = + g8[ix+0]*g66[iy+0]*g53[iz+0];
s[1401] = + g9[ix+0]*g64[iy+0]*g54[iz+0];
s[1402] = + g8[ix+0]*g65[iy+0]*g54[iz+0];
s[1403] = + g8[ix+0]*g64[iy+0]*g55[iz+0];
s[1404] = + g7[ix+0]*g72[iy+0]*g48[iz+0];
s[1405] = + g6[ix+0]*g73[iy+0]*g48[iz+0];
s[1406] = + g6[ix+0]*g72[iy+0]*g49[iz+0];
s[1407] = + g5[ix+0]*g74[iy+0]*g48[iz+0];
s[1408] = + g4[ix+0]*g75[iy+0]*g48[iz+0];
s[1409] = + g4[ix+0]*g74[iy+0]*g49[iz+0];
s[1410] = + g5[ix+0]*g72[iy+0]*g50[iz+0];
s[1411] = + g4[ix+0]*g73[iy+0]*g50[iz+0];
s[1412] = + g4[ix+0]*g72[iy+0]*g51[iz+0];
s[1413] = + g3[ix+0]*g76[iy+0]*g48[iz+0];
s[1414] = + g2[ix+0]*g77[iy+0]*g48[iz+0];
s[1415] = + g2[ix+0]*g76[iy+0]*g49[iz+0];
s[1416] = + g1[ix+0]*g78[iy+0]*g48[iz+0];
s[1417] = + g0[ix+0]*g79[iy+0]*g48[iz+0];
s[1418] = + g0[ix+0]*g78[iy+0]*g49[iz+0];
s[1419] = + g1[ix+0]*g76[iy+0]*g50[iz+0];
s[1420] = + g0[ix+0]*g77[iy+0]*g50[iz+0];
s[1421] = + g0[ix+0]*g76[iy+0]*g51[iz+0];
s[1422] = + g3[ix+0]*g72[iy+0]*g52[iz+0];
s[1423] = + g2[ix+0]*g73[iy+0]*g52[iz+0];
s[1424] = + g2[ix+0]*g72[iy+0]*g53[iz+0];
s[1425] = + g1[ix+0]*g74[iy+0]*g52[iz+0];
s[1426] = + g0[ix+0]*g75[iy+0]*g52[iz+0];
s[1427] = + g0[ix+0]*g74[iy+0]*g53[iz+0];
s[1428] = + g1[ix+0]*g72[iy+0]*g54[iz+0];
s[1429] = + g0[ix+0]*g73[iy+0]*g54[iz+0];
s[1430] = + g0[ix+0]*g72[iy+0]*g55[iz+0];
s[1431] = + g7[ix+0]*g64[iy+0]*g56[iz+0];
s[1432] = + g6[ix+0]*g65[iy+0]*g56[iz+0];
s[1433] = + g6[ix+0]*g64[iy+0]*g57[iz+0];
s[1434] = + g5[ix+0]*g66[iy+0]*g56[iz+0];
s[1435] = + g4[ix+0]*g67[iy+0]*g56[iz+0];
s[1436] = + g4[ix+0]*g66[iy+0]*g57[iz+0];
s[1437] = + g5[ix+0]*g64[iy+0]*g58[iz+0];
s[1438] = + g4[ix+0]*g65[iy+0]*g58[iz+0];
s[1439] = + g4[ix+0]*g64[iy+0]*g59[iz+0];
s[1440] = + g3[ix+0]*g68[iy+0]*g56[iz+0];
s[1441] = + g2[ix+0]*g69[iy+0]*g56[iz+0];
s[1442] = + g2[ix+0]*g68[iy+0]*g57[iz+0];
s[1443] = + g1[ix+0]*g70[iy+0]*g56[iz+0];
s[1444] = + g0[ix+0]*g71[iy+0]*g56[iz+0];
s[1445] = + g0[ix+0]*g70[iy+0]*g57[iz+0];
s[1446] = + g1[ix+0]*g68[iy+0]*g58[iz+0];
s[1447] = + g0[ix+0]*g69[iy+0]*g58[iz+0];
s[1448] = + g0[ix+0]*g68[iy+0]*g59[iz+0];
s[1449] = + g3[ix+0]*g64[iy+0]*g60[iz+0];
s[1450] = + g2[ix+0]*g65[iy+0]*g60[iz+0];
s[1451] = + g2[ix+0]*g64[iy+0]*g61[iz+0];
s[1452] = + g1[ix+0]*g66[iy+0]*g60[iz+0];
s[1453] = + g0[ix+0]*g67[iy+0]*g60[iz+0];
s[1454] = + g0[ix+0]*g66[iy+0]*g61[iz+0];
s[1455] = + g1[ix+0]*g64[iy+0]*g62[iz+0];
s[1456] = + g0[ix+0]*g65[iy+0]*g62[iz+0];
s[1457] = + g0[ix+0]*g64[iy+0]*g63[iz+0];
s[1458] = + g63[ix+0]*g0[iy+0]*g64[iz+0];
s[1459] = + g62[ix+0]*g1[iy+0]*g64[iz+0];
s[1460] = + g62[ix+0]*g0[iy+0]*g65[iz+0];
s[1461] = + g61[ix+0]*g2[iy+0]*g64[iz+0];
s[1462] = + g60[ix+0]*g3[iy+0]*g64[iz+0];
s[1463] = + g60[ix+0]*g2[iy+0]*g65[iz+0];
s[1464] = + g61[ix+0]*g0[iy+0]*g66[iz+0];
s[1465] = + g60[ix+0]*g1[iy+0]*g66[iz+0];
s[1466] = + g60[ix+0]*g0[iy+0]*g67[iz+0];
s[1467] = + g59[ix+0]*g4[iy+0]*g64[iz+0];
s[1468] = + g58[ix+0]*g5[iy+0]*g64[iz+0];
s[1469] = + g58[ix+0]*g4[iy+0]*g65[iz+0];
s[1470] = + g57[ix+0]*g6[iy+0]*g64[iz+0];
s[1471] = + g56[ix+0]*g7[iy+0]*g64[iz+0];
s[1472] = + g56[ix+0]*g6[iy+0]*g65[iz+0];
s[1473] = + g57[ix+0]*g4[iy+0]*g66[iz+0];
s[1474] = + g56[ix+0]*g5[iy+0]*g66[iz+0];
s[1475] = + g56[ix+0]*g4[iy+0]*g67[iz+0];
s[1476] = + g59[ix+0]*g0[iy+0]*g68[iz+0];
s[1477] = + g58[ix+0]*g1[iy+0]*g68[iz+0];
s[1478] = + g58[ix+0]*g0[iy+0]*g69[iz+0];
s[1479] = + g57[ix+0]*g2[iy+0]*g68[iz+0];
s[1480] = + g56[ix+0]*g3[iy+0]*g68[iz+0];
s[1481] = + g56[ix+0]*g2[iy+0]*g69[iz+0];
s[1482] = + g57[ix+0]*g0[iy+0]*g70[iz+0];
s[1483] = + g56[ix+0]*g1[iy+0]*g70[iz+0];
s[1484] = + g56[ix+0]*g0[iy+0]*g71[iz+0];
s[1485] = + g55[ix+0]*g8[iy+0]*g64[iz+0];
s[1486] = + g54[ix+0]*g9[iy+0]*g64[iz+0];
s[1487] = + g54[ix+0]*g8[iy+0]*g65[iz+0];
s[1488] = + g53[ix+0]*g10[iy+0]*g64[iz+0];
s[1489] = + g52[ix+0]*g11[iy+0]*g64[iz+0];
s[1490] = + g52[ix+0]*g10[iy+0]*g65[iz+0];
s[1491] = + g53[ix+0]*g8[iy+0]*g66[iz+0];
s[1492] = + g52[ix+0]*g9[iy+0]*g66[iz+0];
s[1493] = + g52[ix+0]*g8[iy+0]*g67[iz+0];
s[1494] = + g51[ix+0]*g12[iy+0]*g64[iz+0];
s[1495] = + g50[ix+0]*g13[iy+0]*g64[iz+0];
s[1496] = + g50[ix+0]*g12[iy+0]*g65[iz+0];
s[1497] = + g49[ix+0]*g14[iy+0]*g64[iz+0];
s[1498] = + g48[ix+0]*g15[iy+0]*g64[iz+0];
s[1499] = + g48[ix+0]*g14[iy+0]*g65[iz+0];
s[1500] = + g49[ix+0]*g12[iy+0]*g66[iz+0];
s[1501] = + g48[ix+0]*g13[iy+0]*g66[iz+0];
s[1502] = + g48[ix+0]*g12[iy+0]*g67[iz+0];
s[1503] = + g51[ix+0]*g8[iy+0]*g68[iz+0];
s[1504] = + g50[ix+0]*g9[iy+0]*g68[iz+0];
s[1505] = + g50[ix+0]*g8[iy+0]*g69[iz+0];
s[1506] = + g49[ix+0]*g10[iy+0]*g68[iz+0];
s[1507] = + g48[ix+0]*g11[iy+0]*g68[iz+0];
s[1508] = + g48[ix+0]*g10[iy+0]*g69[iz+0];
s[1509] = + g49[ix+0]*g8[iy+0]*g70[iz+0];
s[1510] = + g48[ix+0]*g9[iy+0]*g70[iz+0];
s[1511] = + g48[ix+0]*g8[iy+0]*g71[iz+0];
s[1512] = + g55[ix+0]*g0[iy+0]*g72[iz+0];
s[1513] = + g54[ix+0]*g1[iy+0]*g72[iz+0];
s[1514] = + g54[ix+0]*g0[iy+0]*g73[iz+0];
s[1515] = + g53[ix+0]*g2[iy+0]*g72[iz+0];
s[1516] = + g52[ix+0]*g3[iy+0]*g72[iz+0];
s[1517] = + g52[ix+0]*g2[iy+0]*g73[iz+0];
s[1518] = + g53[ix+0]*g0[iy+0]*g74[iz+0];
s[1519] = + g52[ix+0]*g1[iy+0]*g74[iz+0];
s[1520] = + g52[ix+0]*g0[iy+0]*g75[iz+0];
s[1521] = + g51[ix+0]*g4[iy+0]*g72[iz+0];
s[1522] = + g50[ix+0]*g5[iy+0]*g72[iz+0];
s[1523] = + g50[ix+0]*g4[iy+0]*g73[iz+0];
s[1524] = + g49[ix+0]*g6[iy+0]*g72[iz+0];
s[1525] = + g48[ix+0]*g7[iy+0]*g72[iz+0];
s[1526] = + g48[ix+0]*g6[iy+0]*g73[iz+0];
s[1527] = + g49[ix+0]*g4[iy+0]*g74[iz+0];
s[1528] = + g48[ix+0]*g5[iy+0]*g74[iz+0];
s[1529] = + g48[ix+0]*g4[iy+0]*g75[iz+0];
s[1530] = + g51[ix+0]*g0[iy+0]*g76[iz+0];
s[1531] = + g50[ix+0]*g1[iy+0]*g76[iz+0];
s[1532] = + g50[ix+0]*g0[iy+0]*g77[iz+0];
s[1533] = + g49[ix+0]*g2[iy+0]*g76[iz+0];
s[1534] = + g48[ix+0]*g3[iy+0]*g76[iz+0];
s[1535] = + g48[ix+0]*g2[iy+0]*g77[iz+0];
s[1536] = + g49[ix+0]*g0[iy+0]*g78[iz+0];
s[1537] = + g48[ix+0]*g1[iy+0]*g78[iz+0];
s[1538] = + g48[ix+0]*g0[iy+0]*g79[iz+0];
s[1539] = + g47[ix+0]*g16[iy+0]*g64[iz+0];
s[1540] = + g46[ix+0]*g17[iy+0]*g64[iz+0];
s[1541] = + g46[ix+0]*g16[iy+0]*g65[iz+0];
s[1542] = + g45[ix+0]*g18[iy+0]*g64[iz+0];
s[1543] = + g44[ix+0]*g19[iy+0]*g64[iz+0];
s[1544] = + g44[ix+0]*g18[iy+0]*g65[iz+0];
s[1545] = + g45[ix+0]*g16[iy+0]*g66[iz+0];
s[1546] = + g44[ix+0]*g17[iy+0]*g66[iz+0];
s[1547] = + g44[ix+0]*g16[iy+0]*g67[iz+0];
s[1548] = + g43[ix+0]*g20[iy+0]*g64[iz+0];
s[1549] = + g42[ix+0]*g21[iy+0]*g64[iz+0];
s[1550] = + g42[ix+0]*g20[iy+0]*g65[iz+0];
s[1551] = + g41[ix+0]*g22[iy+0]*g64[iz+0];
s[1552] = + g40[ix+0]*g23[iy+0]*g64[iz+0];
s[1553] = + g40[ix+0]*g22[iy+0]*g65[iz+0];
s[1554] = + g41[ix+0]*g20[iy+0]*g66[iz+0];
s[1555] = + g40[ix+0]*g21[iy+0]*g66[iz+0];
s[1556] = + g40[ix+0]*g20[iy+0]*g67[iz+0];
s[1557] = + g43[ix+0]*g16[iy+0]*g68[iz+0];
s[1558] = + g42[ix+0]*g17[iy+0]*g68[iz+0];
s[1559] = + g42[ix+0]*g16[iy+0]*g69[iz+0];
s[1560] = + g41[ix+0]*g18[iy+0]*g68[iz+0];
s[1561] = + g40[ix+0]*g19[iy+0]*g68[iz+0];
s[1562] = + g40[ix+0]*g18[iy+0]*g69[iz+0];
s[1563] = + g41[ix+0]*g16[iy+0]*g70[iz+0];
s[1564] = + g40[ix+0]*g17[iy+0]*g70[iz+0];
s[1565] = + g40[ix+0]*g16[iy+0]*g71[iz+0];
s[1566] = + g39[ix+0]*g24[iy+0]*g64[iz+0];
s[1567] = + g38[ix+0]*g25[iy+0]*g64[iz+0];
s[1568] = + g38[ix+0]*g24[iy+0]*g65[iz+0];
s[1569] = + g37[ix+0]*g26[iy+0]*g64[iz+0];
s[1570] = + g36[ix+0]*g27[iy+0]*g64[iz+0];
s[1571] = + g36[ix+0]*g26[iy+0]*g65[iz+0];
s[1572] = + g37[ix+0]*g24[iy+0]*g66[iz+0];
s[1573] = + g36[ix+0]*g25[iy+0]*g66[iz+0];
s[1574] = + g36[ix+0]*g24[iy+0]*g67[iz+0];
s[1575] = + g35[ix+0]*g28[iy+0]*g64[iz+0];
s[1576] = + g34[ix+0]*g29[iy+0]*g64[iz+0];
s[1577] = + g34[ix+0]*g28[iy+0]*g65[iz+0];
s[1578] = + g33[ix+0]*g30[iy+0]*g64[iz+0];
s[1579] = + g32[ix+0]*g31[iy+0]*g64[iz+0];
s[1580] = + g32[ix+0]*g30[iy+0]*g65[iz+0];
s[1581] = + g33[ix+0]*g28[iy+0]*g66[iz+0];
s[1582] = + g32[ix+0]*g29[iy+0]*g66[iz+0];
s[1583] = + g32[ix+0]*g28[iy+0]*g67[iz+0];
s[1584] = + g35[ix+0]*g24[iy+0]*g68[iz+0];
s[1585] = + g34[ix+0]*g25[iy+0]*g68[iz+0];
s[1586] = + g34[ix+0]*g24[iy+0]*g69[iz+0];
s[1587] = + g33[ix+0]*g26[iy+0]*g68[iz+0];
s[1588] = + g32[ix+0]*g27[iy+0]*g68[iz+0];
s[1589] = + g32[ix+0]*g26[iy+0]*g69[iz+0];
s[1590] = + g33[ix+0]*g24[iy+0]*g70[iz+0];
s[1591] = + g32[ix+0]*g25[iy+0]*g70[iz+0];
s[1592] = + g32[ix+0]*g24[iy+0]*g71[iz+0];
s[1593] = + g39[ix+0]*g16[iy+0]*g72[iz+0];
s[1594] = + g38[ix+0]*g17[iy+0]*g72[iz+0];
s[1595] = + g38[ix+0]*g16[iy+0]*g73[iz+0];
s[1596] = + g37[ix+0]*g18[iy+0]*g72[iz+0];
s[1597] = + g36[ix+0]*g19[iy+0]*g72[iz+0];
s[1598] = + g36[ix+0]*g18[iy+0]*g73[iz+0];
s[1599] = + g37[ix+0]*g16[iy+0]*g74[iz+0];
s[1600] = + g36[ix+0]*g17[iy+0]*g74[iz+0];
s[1601] = + g36[ix+0]*g16[iy+0]*g75[iz+0];
s[1602] = + g35[ix+0]*g20[iy+0]*g72[iz+0];
s[1603] = + g34[ix+0]*g21[iy+0]*g72[iz+0];
s[1604] = + g34[ix+0]*g20[iy+0]*g73[iz+0];
s[1605] = + g33[ix+0]*g22[iy+0]*g72[iz+0];
s[1606] = + g32[ix+0]*g23[iy+0]*g72[iz+0];
s[1607] = + g32[ix+0]*g22[iy+0]*g73[iz+0];
s[1608] = + g33[ix+0]*g20[iy+0]*g74[iz+0];
s[1609] = + g32[ix+0]*g21[iy+0]*g74[iz+0];
s[1610] = + g32[ix+0]*g20[iy+0]*g75[iz+0];
s[1611] = + g35[ix+0]*g16[iy+0]*g76[iz+0];
s[1612] = + g34[ix+0]*g17[iy+0]*g76[iz+0];
s[1613] = + g34[ix+0]*g16[iy+0]*g77[iz+0];
s[1614] = + g33[ix+0]*g18[iy+0]*g76[iz+0];
s[1615] = + g32[ix+0]*g19[iy+0]*g76[iz+0];
s[1616] = + g32[ix+0]*g18[iy+0]*g77[iz+0];
s[1617] = + g33[ix+0]*g16[iy+0]*g78[iz+0];
s[1618] = + g32[ix+0]*g17[iy+0]*g78[iz+0];
s[1619] = + g32[ix+0]*g16[iy+0]*g79[iz+0];
s[1620] = + g47[ix+0]*g0[iy+0]*g80[iz+0];
s[1621] = + g46[ix+0]*g1[iy+0]*g80[iz+0];
s[1622] = + g46[ix+0]*g0[iy+0]*g81[iz+0];
s[1623] = + g45[ix+0]*g2[iy+0]*g80[iz+0];
s[1624] = + g44[ix+0]*g3[iy+0]*g80[iz+0];
s[1625] = + g44[ix+0]*g2[iy+0]*g81[iz+0];
s[1626] = + g45[ix+0]*g0[iy+0]*g82[iz+0];
s[1627] = + g44[ix+0]*g1[iy+0]*g82[iz+0];
s[1628] = + g44[ix+0]*g0[iy+0]*g83[iz+0];
s[1629] = + g43[ix+0]*g4[iy+0]*g80[iz+0];
s[1630] = + g42[ix+0]*g5[iy+0]*g80[iz+0];
s[1631] = + g42[ix+0]*g4[iy+0]*g81[iz+0];
s[1632] = + g41[ix+0]*g6[iy+0]*g80[iz+0];
s[1633] = + g40[ix+0]*g7[iy+0]*g80[iz+0];
s[1634] = + g40[ix+0]*g6[iy+0]*g81[iz+0];
s[1635] = + g41[ix+0]*g4[iy+0]*g82[iz+0];
s[1636] = + g40[ix+0]*g5[iy+0]*g82[iz+0];
s[1637] = + g40[ix+0]*g4[iy+0]*g83[iz+0];
s[1638] = + g43[ix+0]*g0[iy+0]*g84[iz+0];
s[1639] = + g42[ix+0]*g1[iy+0]*g84[iz+0];
s[1640] = + g42[ix+0]*g0[iy+0]*g85[iz+0];
s[1641] = + g41[ix+0]*g2[iy+0]*g84[iz+0];
s[1642] = + g40[ix+0]*g3[iy+0]*g84[iz+0];
s[1643] = + g40[ix+0]*g2[iy+0]*g85[iz+0];
s[1644] = + g41[ix+0]*g0[iy+0]*g86[iz+0];
s[1645] = + g40[ix+0]*g1[iy+0]*g86[iz+0];
s[1646] = + g40[ix+0]*g0[iy+0]*g87[iz+0];
s[1647] = + g39[ix+0]*g8[iy+0]*g80[iz+0];
s[1648] = + g38[ix+0]*g9[iy+0]*g80[iz+0];
s[1649] = + g38[ix+0]*g8[iy+0]*g81[iz+0];
s[1650] = + g37[ix+0]*g10[iy+0]*g80[iz+0];
s[1651] = + g36[ix+0]*g11[iy+0]*g80[iz+0];
s[1652] = + g36[ix+0]*g10[iy+0]*g81[iz+0];
s[1653] = + g37[ix+0]*g8[iy+0]*g82[iz+0];
s[1654] = + g36[ix+0]*g9[iy+0]*g82[iz+0];
s[1655] = + g36[ix+0]*g8[iy+0]*g83[iz+0];
s[1656] = + g35[ix+0]*g12[iy+0]*g80[iz+0];
s[1657] = + g34[ix+0]*g13[iy+0]*g80[iz+0];
s[1658] = + g34[ix+0]*g12[iy+0]*g81[iz+0];
s[1659] = + g33[ix+0]*g14[iy+0]*g80[iz+0];
s[1660] = + g32[ix+0]*g15[iy+0]*g80[iz+0];
s[1661] = + g32[ix+0]*g14[iy+0]*g81[iz+0];
s[1662] = + g33[ix+0]*g12[iy+0]*g82[iz+0];
s[1663] = + g32[ix+0]*g13[iy+0]*g82[iz+0];
s[1664] = + g32[ix+0]*g12[iy+0]*g83[iz+0];
s[1665] = + g35[ix+0]*g8[iy+0]*g84[iz+0];
s[1666] = + g34[ix+0]*g9[iy+0]*g84[iz+0];
s[1667] = + g34[ix+0]*g8[iy+0]*g85[iz+0];
s[1668] = + g33[ix+0]*g10[iy+0]*g84[iz+0];
s[1669] = + g32[ix+0]*g11[iy+0]*g84[iz+0];
s[1670] = + g32[ix+0]*g10[iy+0]*g85[iz+0];
s[1671] = + g33[ix+0]*g8[iy+0]*g86[iz+0];
s[1672] = + g32[ix+0]*g9[iy+0]*g86[iz+0];
s[1673] = + g32[ix+0]*g8[iy+0]*g87[iz+0];
s[1674] = + g39[ix+0]*g0[iy+0]*g88[iz+0];
s[1675] = + g38[ix+0]*g1[iy+0]*g88[iz+0];
s[1676] = + g38[ix+0]*g0[iy+0]*g89[iz+0];
s[1677] = + g37[ix+0]*g2[iy+0]*g88[iz+0];
s[1678] = + g36[ix+0]*g3[iy+0]*g88[iz+0];
s[1679] = + g36[ix+0]*g2[iy+0]*g89[iz+0];
s[1680] = + g37[ix+0]*g0[iy+0]*g90[iz+0];
s[1681] = + g36[ix+0]*g1[iy+0]*g90[iz+0];
s[1682] = + g36[ix+0]*g0[iy+0]*g91[iz+0];
s[1683] = + g35[ix+0]*g4[iy+0]*g88[iz+0];
s[1684] = + g34[ix+0]*g5[iy+0]*g88[iz+0];
s[1685] = + g34[ix+0]*g4[iy+0]*g89[iz+0];
s[1686] = + g33[ix+0]*g6[iy+0]*g88[iz+0];
s[1687] = + g32[ix+0]*g7[iy+0]*g88[iz+0];
s[1688] = + g32[ix+0]*g6[iy+0]*g89[iz+0];
s[1689] = + g33[ix+0]*g4[iy+0]*g90[iz+0];
s[1690] = + g32[ix+0]*g5[iy+0]*g90[iz+0];
s[1691] = + g32[ix+0]*g4[iy+0]*g91[iz+0];
s[1692] = + g35[ix+0]*g0[iy+0]*g92[iz+0];
s[1693] = + g34[ix+0]*g1[iy+0]*g92[iz+0];
s[1694] = + g34[ix+0]*g0[iy+0]*g93[iz+0];
s[1695] = + g33[ix+0]*g2[iy+0]*g92[iz+0];
s[1696] = + g32[ix+0]*g3[iy+0]*g92[iz+0];
s[1697] = + g32[ix+0]*g2[iy+0]*g93[iz+0];
s[1698] = + g33[ix+0]*g0[iy+0]*g94[iz+0];
s[1699] = + g32[ix+0]*g1[iy+0]*g94[iz+0];
s[1700] = + g32[ix+0]*g0[iy+0]*g95[iz+0];
s[1701] = + g31[ix+0]*g32[iy+0]*g64[iz+0];
s[1702] = + g30[ix+0]*g33[iy+0]*g64[iz+0];
s[1703] = + g30[ix+0]*g32[iy+0]*g65[iz+0];
s[1704] = + g29[ix+0]*g34[iy+0]*g64[iz+0];
s[1705] = + g28[ix+0]*g35[iy+0]*g64[iz+0];
s[1706] = + g28[ix+0]*g34[iy+0]*g65[iz+0];
s[1707] = + g29[ix+0]*g32[iy+0]*g66[iz+0];
s[1708] = + g28[ix+0]*g33[iy+0]*g66[iz+0];
s[1709] = + g28[ix+0]*g32[iy+0]*g67[iz+0];
s[1710] = + g27[ix+0]*g36[iy+0]*g64[iz+0];
s[1711] = + g26[ix+0]*g37[iy+0]*g64[iz+0];
s[1712] = + g26[ix+0]*g36[iy+0]*g65[iz+0];
s[1713] = + g25[ix+0]*g38[iy+0]*g64[iz+0];
s[1714] = + g24[ix+0]*g39[iy+0]*g64[iz+0];
s[1715] = + g24[ix+0]*g38[iy+0]*g65[iz+0];
s[1716] = + g25[ix+0]*g36[iy+0]*g66[iz+0];
s[1717] = + g24[ix+0]*g37[iy+0]*g66[iz+0];
s[1718] = + g24[ix+0]*g36[iy+0]*g67[iz+0];
s[1719] = + g27[ix+0]*g32[iy+0]*g68[iz+0];
s[1720] = + g26[ix+0]*g33[iy+0]*g68[iz+0];
s[1721] = + g26[ix+0]*g32[iy+0]*g69[iz+0];
s[1722] = + g25[ix+0]*g34[iy+0]*g68[iz+0];
s[1723] = + g24[ix+0]*g35[iy+0]*g68[iz+0];
s[1724] = + g24[ix+0]*g34[iy+0]*g69[iz+0];
s[1725] = + g25[ix+0]*g32[iy+0]*g70[iz+0];
s[1726] = + g24[ix+0]*g33[iy+0]*g70[iz+0];
s[1727] = + g24[ix+0]*g32[iy+0]*g71[iz+0];
s[1728] = + g23[ix+0]*g40[iy+0]*g64[iz+0];
s[1729] = + g22[ix+0]*g41[iy+0]*g64[iz+0];
s[1730] = + g22[ix+0]*g40[iy+0]*g65[iz+0];
s[1731] = + g21[ix+0]*g42[iy+0]*g64[iz+0];
s[1732] = + g20[ix+0]*g43[iy+0]*g64[iz+0];
s[1733] = + g20[ix+0]*g42[iy+0]*g65[iz+0];
s[1734] = + g21[ix+0]*g40[iy+0]*g66[iz+0];
s[1735] = + g20[ix+0]*g41[iy+0]*g66[iz+0];
s[1736] = + g20[ix+0]*g40[iy+0]*g67[iz+0];
s[1737] = + g19[ix+0]*g44[iy+0]*g64[iz+0];
s[1738] = + g18[ix+0]*g45[iy+0]*g64[iz+0];
s[1739] = + g18[ix+0]*g44[iy+0]*g65[iz+0];
s[1740] = + g17[ix+0]*g46[iy+0]*g64[iz+0];
s[1741] = + g16[ix+0]*g47[iy+0]*g64[iz+0];
s[1742] = + g16[ix+0]*g46[iy+0]*g65[iz+0];
s[1743] = + g17[ix+0]*g44[iy+0]*g66[iz+0];
s[1744] = + g16[ix+0]*g45[iy+0]*g66[iz+0];
s[1745] = + g16[ix+0]*g44[iy+0]*g67[iz+0];
s[1746] = + g19[ix+0]*g40[iy+0]*g68[iz+0];
s[1747] = + g18[ix+0]*g41[iy+0]*g68[iz+0];
s[1748] = + g18[ix+0]*g40[iy+0]*g69[iz+0];
s[1749] = + g17[ix+0]*g42[iy+0]*g68[iz+0];
s[1750] = + g16[ix+0]*g43[iy+0]*g68[iz+0];
s[1751] = + g16[ix+0]*g42[iy+0]*g69[iz+0];
s[1752] = + g17[ix+0]*g40[iy+0]*g70[iz+0];
s[1753] = + g16[ix+0]*g41[iy+0]*g70[iz+0];
s[1754] = + g16[ix+0]*g40[iy+0]*g71[iz+0];
s[1755] = + g23[ix+0]*g32[iy+0]*g72[iz+0];
s[1756] = + g22[ix+0]*g33[iy+0]*g72[iz+0];
s[1757] = + g22[ix+0]*g32[iy+0]*g73[iz+0];
s[1758] = + g21[ix+0]*g34[iy+0]*g72[iz+0];
s[1759] = + g20[ix+0]*g35[iy+0]*g72[iz+0];
s[1760] = + g20[ix+0]*g34[iy+0]*g73[iz+0];
s[1761] = + g21[ix+0]*g32[iy+0]*g74[iz+0];
s[1762] = + g20[ix+0]*g33[iy+0]*g74[iz+0];
s[1763] = + g20[ix+0]*g32[iy+0]*g75[iz+0];
s[1764] = + g19[ix+0]*g36[iy+0]*g72[iz+0];
s[1765] = + g18[ix+0]*g37[iy+0]*g72[iz+0];
s[1766] = + g18[ix+0]*g36[iy+0]*g73[iz+0];
s[1767] = + g17[ix+0]*g38[iy+0]*g72[iz+0];
s[1768] = + g16[ix+0]*g39[iy+0]*g72[iz+0];
s[1769] = + g16[ix+0]*g38[iy+0]*g73[iz+0];
s[1770] = + g17[ix+0]*g36[iy+0]*g74[iz+0];
s[1771] = + g16[ix+0]*g37[iy+0]*g74[iz+0];
s[1772] = + g16[ix+0]*g36[iy+0]*g75[iz+0];
s[1773] = + g19[ix+0]*g32[iy+0]*g76[iz+0];
s[1774] = + g18[ix+0]*g33[iy+0]*g76[iz+0];
s[1775] = + g18[ix+0]*g32[iy+0]*g77[iz+0];
s[1776] = + g17[ix+0]*g34[iy+0]*g76[iz+0];
s[1777] = + g16[ix+0]*g35[iy+0]*g76[iz+0];
s[1778] = + g16[ix+0]*g34[iy+0]*g77[iz+0];
s[1779] = + g17[ix+0]*g32[iy+0]*g78[iz+0];
s[1780] = + g16[ix+0]*g33[iy+0]*g78[iz+0];
s[1781] = + g16[ix+0]*g32[iy+0]*g79[iz+0];
s[1782] = + g15[ix+0]*g48[iy+0]*g64[iz+0];
s[1783] = + g14[ix+0]*g49[iy+0]*g64[iz+0];
s[1784] = + g14[ix+0]*g48[iy+0]*g65[iz+0];
s[1785] = + g13[ix+0]*g50[iy+0]*g64[iz+0];
s[1786] = + g12[ix+0]*g51[iy+0]*g64[iz+0];
s[1787] = + g12[ix+0]*g50[iy+0]*g65[iz+0];
s[1788] = + g13[ix+0]*g48[iy+0]*g66[iz+0];
s[1789] = + g12[ix+0]*g49[iy+0]*g66[iz+0];
s[1790] = + g12[ix+0]*g48[iy+0]*g67[iz+0];
s[1791] = + g11[ix+0]*g52[iy+0]*g64[iz+0];
s[1792] = + g10[ix+0]*g53[iy+0]*g64[iz+0];
s[1793] = + g10[ix+0]*g52[iy+0]*g65[iz+0];
s[1794] = + g9[ix+0]*g54[iy+0]*g64[iz+0];
s[1795] = + g8[ix+0]*g55[iy+0]*g64[iz+0];
s[1796] = + g8[ix+0]*g54[iy+0]*g65[iz+0];
s[1797] = + g9[ix+0]*g52[iy+0]*g66[iz+0];
s[1798] = + g8[ix+0]*g53[iy+0]*g66[iz+0];
s[1799] = + g8[ix+0]*g52[iy+0]*g67[iz+0];
s[1800] = + g11[ix+0]*g48[iy+0]*g68[iz+0];
s[1801] = + g10[ix+0]*g49[iy+0]*g68[iz+0];
s[1802] = + g10[ix+0]*g48[iy+0]*g69[iz+0];
s[1803] = + g9[ix+0]*g50[iy+0]*g68[iz+0];
s[1804] = + g8[ix+0]*g51[iy+0]*g68[iz+0];
s[1805] = + g8[ix+0]*g50[iy+0]*g69[iz+0];
s[1806] = + g9[ix+0]*g48[iy+0]*g70[iz+0];
s[1807] = + g8[ix+0]*g49[iy+0]*g70[iz+0];
s[1808] = + g8[ix+0]*g48[iy+0]*g71[iz+0];
s[1809] = + g7[ix+0]*g56[iy+0]*g64[iz+0];
s[1810] = + g6[ix+0]*g57[iy+0]*g64[iz+0];
s[1811] = + g6[ix+0]*g56[iy+0]*g65[iz+0];
s[1812] = + g5[ix+0]*g58[iy+0]*g64[iz+0];
s[1813] = + g4[ix+0]*g59[iy+0]*g64[iz+0];
s[1814] = + g4[ix+0]*g58[iy+0]*g65[iz+0];
s[1815] = + g5[ix+0]*g56[iy+0]*g66[iz+0];
s[1816] = + g4[ix+0]*g57[iy+0]*g66[iz+0];
s[1817] = + g4[ix+0]*g56[iy+0]*g67[iz+0];
s[1818] = + g3[ix+0]*g60[iy+0]*g64[iz+0];
s[1819] = + g2[ix+0]*g61[iy+0]*g64[iz+0];
s[1820] = + g2[ix+0]*g60[iy+0]*g65[iz+0];
s[1821] = + g1[ix+0]*g62[iy+0]*g64[iz+0];
s[1822] = + g0[ix+0]*g63[iy+0]*g64[iz+0];
s[1823] = + g0[ix+0]*g62[iy+0]*g65[iz+0];
s[1824] = + g1[ix+0]*g60[iy+0]*g66[iz+0];
s[1825] = + g0[ix+0]*g61[iy+0]*g66[iz+0];
s[1826] = + g0[ix+0]*g60[iy+0]*g67[iz+0];
s[1827] = + g3[ix+0]*g56[iy+0]*g68[iz+0];
s[1828] = + g2[ix+0]*g57[iy+0]*g68[iz+0];
s[1829] = + g2[ix+0]*g56[iy+0]*g69[iz+0];
s[1830] = + g1[ix+0]*g58[iy+0]*g68[iz+0];
s[1831] = + g0[ix+0]*g59[iy+0]*g68[iz+0];
s[1832] = + g0[ix+0]*g58[iy+0]*g69[iz+0];
s[1833] = + g1[ix+0]*g56[iy+0]*g70[iz+0];
s[1834] = + g0[ix+0]*g57[iy+0]*g70[iz+0];
s[1835] = + g0[ix+0]*g56[iy+0]*g71[iz+0];
s[1836] = + g7[ix+0]*g48[iy+0]*g72[iz+0];
s[1837] = + g6[ix+0]*g49[iy+0]*g72[iz+0];
s[1838] = + g6[ix+0]*g48[iy+0]*g73[iz+0];
s[1839] = + g5[ix+0]*g50[iy+0]*g72[iz+0];
s[1840] = + g4[ix+0]*g51[iy+0]*g72[iz+0];
s[1841] = + g4[ix+0]*g50[iy+0]*g73[iz+0];
s[1842] = + g5[ix+0]*g48[iy+0]*g74[iz+0];
s[1843] = + g4[ix+0]*g49[iy+0]*g74[iz+0];
s[1844] = + g4[ix+0]*g48[iy+0]*g75[iz+0];
s[1845] = + g3[ix+0]*g52[iy+0]*g72[iz+0];
s[1846] = + g2[ix+0]*g53[iy+0]*g72[iz+0];
s[1847] = + g2[ix+0]*g52[iy+0]*g73[iz+0];
s[1848] = + g1[ix+0]*g54[iy+0]*g72[iz+0];
s[1849] = + g0[ix+0]*g55[iy+0]*g72[iz+0];
s[1850] = + g0[ix+0]*g54[iy+0]*g73[iz+0];
s[1851] = + g1[ix+0]*g52[iy+0]*g74[iz+0];
s[1852] = + g0[ix+0]*g53[iy+0]*g74[iz+0];
s[1853] = + g0[ix+0]*g52[iy+0]*g75[iz+0];
s[1854] = + g3[ix+0]*g48[iy+0]*g76[iz+0];
s[1855] = + g2[ix+0]*g49[iy+0]*g76[iz+0];
s[1856] = + g2[ix+0]*g48[iy+0]*g77[iz+0];
s[1857] = + g1[ix+0]*g50[iy+0]*g76[iz+0];
s[1858] = + g0[ix+0]*g51[iy+0]*g76[iz+0];
s[1859] = + g0[ix+0]*g50[iy+0]*g77[iz+0];
s[1860] = + g1[ix+0]*g48[iy+0]*g78[iz+0];
s[1861] = + g0[ix+0]*g49[iy+0]*g78[iz+0];
s[1862] = + g0[ix+0]*g48[iy+0]*g79[iz+0];
s[1863] = + g15[ix+0]*g32[iy+0]*g80[iz+0];
s[1864] = + g14[ix+0]*g33[iy+0]*g80[iz+0];
s[1865] = + g14[ix+0]*g32[iy+0]*g81[iz+0];
s[1866] = + g13[ix+0]*g34[iy+0]*g80[iz+0];
s[1867] = + g12[ix+0]*g35[iy+0]*g80[iz+0];
s[1868] = + g12[ix+0]*g34[iy+0]*g81[iz+0];
s[1869] = + g13[ix+0]*g32[iy+0]*g82[iz+0];
s[1870] = + g12[ix+0]*g33[iy+0]*g82[iz+0];
s[1871] = + g12[ix+0]*g32[iy+0]*g83[iz+0];
s[1872] = + g11[ix+0]*g36[iy+0]*g80[iz+0];
s[1873] = + g10[ix+0]*g37[iy+0]*g80[iz+0];
s[1874] = + g10[ix+0]*g36[iy+0]*g81[iz+0];
s[1875] = + g9[ix+0]*g38[iy+0]*g80[iz+0];
s[1876] = + g8[ix+0]*g39[iy+0]*g80[iz+0];
s[1877] = + g8[ix+0]*g38[iy+0]*g81[iz+0];
s[1878] = + g9[ix+0]*g36[iy+0]*g82[iz+0];
s[1879] = + g8[ix+0]*g37[iy+0]*g82[iz+0];
s[1880] = + g8[ix+0]*g36[iy+0]*g83[iz+0];
s[1881] = + g11[ix+0]*g32[iy+0]*g84[iz+0];
s[1882] = + g10[ix+0]*g33[iy+0]*g84[iz+0];
s[1883] = + g10[ix+0]*g32[iy+0]*g85[iz+0];
s[1884] = + g9[ix+0]*g34[iy+0]*g84[iz+0];
s[1885] = + g8[ix+0]*g35[iy+0]*g84[iz+0];
s[1886] = + g8[ix+0]*g34[iy+0]*g85[iz+0];
s[1887] = + g9[ix+0]*g32[iy+0]*g86[iz+0];
s[1888] = + g8[ix+0]*g33[iy+0]*g86[iz+0];
s[1889] = + g8[ix+0]*g32[iy+0]*g87[iz+0];
s[1890] = + g7[ix+0]*g40[iy+0]*g80[iz+0];
s[1891] = + g6[ix+0]*g41[iy+0]*g80[iz+0];
s[1892] = + g6[ix+0]*g40[iy+0]*g81[iz+0];
s[1893] = + g5[ix+0]*g42[iy+0]*g80[iz+0];
s[1894] = + g4[ix+0]*g43[iy+0]*g80[iz+0];
s[1895] = + g4[ix+0]*g42[iy+0]*g81[iz+0];
s[1896] = + g5[ix+0]*g40[iy+0]*g82[iz+0];
s[1897] = + g4[ix+0]*g41[iy+0]*g82[iz+0];
s[1898] = + g4[ix+0]*g40[iy+0]*g83[iz+0];
s[1899] = + g3[ix+0]*g44[iy+0]*g80[iz+0];
s[1900] = + g2[ix+0]*g45[iy+0]*g80[iz+0];
s[1901] = + g2[ix+0]*g44[iy+0]*g81[iz+0];
s[1902] = + g1[ix+0]*g46[iy+0]*g80[iz+0];
s[1903] = + g0[ix+0]*g47[iy+0]*g80[iz+0];
s[1904] = + g0[ix+0]*g46[iy+0]*g81[iz+0];
s[1905] = + g1[ix+0]*g44[iy+0]*g82[iz+0];
s[1906] = + g0[ix+0]*g45[iy+0]*g82[iz+0];
s[1907] = + g0[ix+0]*g44[iy+0]*g83[iz+0];
s[1908] = + g3[ix+0]*g40[iy+0]*g84[iz+0];
s[1909] = + g2[ix+0]*g41[iy+0]*g84[iz+0];
s[1910] = + g2[ix+0]*g40[iy+0]*g85[iz+0];
s[1911] = + g1[ix+0]*g42[iy+0]*g84[iz+0];
s[1912] = + g0[ix+0]*g43[iy+0]*g84[iz+0];
s[1913] = + g0[ix+0]*g42[iy+0]*g85[iz+0];
s[1914] = + g1[ix+0]*g40[iy+0]*g86[iz+0];
s[1915] = + g0[ix+0]*g41[iy+0]*g86[iz+0];
s[1916] = + g0[ix+0]*g40[iy+0]*g87[iz+0];
s[1917] = + g7[ix+0]*g32[iy+0]*g88[iz+0];
s[1918] = + g6[ix+0]*g33[iy+0]*g88[iz+0];
s[1919] = + g6[ix+0]*g32[iy+0]*g89[iz+0];
s[1920] = + g5[ix+0]*g34[iy+0]*g88[iz+0];
s[1921] = + g4[ix+0]*g35[iy+0]*g88[iz+0];
s[1922] = + g4[ix+0]*g34[iy+0]*g89[iz+0];
s[1923] = + g5[ix+0]*g32[iy+0]*g90[iz+0];
s[1924] = + g4[ix+0]*g33[iy+0]*g90[iz+0];
s[1925] = + g4[ix+0]*g32[iy+0]*g91[iz+0];
s[1926] = + g3[ix+0]*g36[iy+0]*g88[iz+0];
s[1927] = + g2[ix+0]*g37[iy+0]*g88[iz+0];
s[1928] = + g2[ix+0]*g36[iy+0]*g89[iz+0];
s[1929] = + g1[ix+0]*g38[iy+0]*g88[iz+0];
s[1930] = + g0[ix+0]*g39[iy+0]*g88[iz+0];
s[1931] = + g0[ix+0]*g38[iy+0]*g89[iz+0];
s[1932] = + g1[ix+0]*g36[iy+0]*g90[iz+0];
s[1933] = + g0[ix+0]*g37[iy+0]*g90[iz+0];
s[1934] = + g0[ix+0]*g36[iy+0]*g91[iz+0];
s[1935] = + g3[ix+0]*g32[iy+0]*g92[iz+0];
s[1936] = + g2[ix+0]*g33[iy+0]*g92[iz+0];
s[1937] = + g2[ix+0]*g32[iy+0]*g93[iz+0];
s[1938] = + g1[ix+0]*g34[iy+0]*g92[iz+0];
s[1939] = + g0[ix+0]*g35[iy+0]*g92[iz+0];
s[1940] = + g0[ix+0]*g34[iy+0]*g93[iz+0];
s[1941] = + g1[ix+0]*g32[iy+0]*g94[iz+0];
s[1942] = + g0[ix+0]*g33[iy+0]*g94[iz+0];
s[1943] = + g0[ix+0]*g32[iy+0]*g95[iz+0];
s[1944] = + g31[ix+0]*g0[iy+0]*g96[iz+0];
s[1945] = + g30[ix+0]*g1[iy+0]*g96[iz+0];
s[1946] = + g30[ix+0]*g0[iy+0]*g97[iz+0];
s[1947] = + g29[ix+0]*g2[iy+0]*g96[iz+0];
s[1948] = + g28[ix+0]*g3[iy+0]*g96[iz+0];
s[1949] = + g28[ix+0]*g2[iy+0]*g97[iz+0];
s[1950] = + g29[ix+0]*g0[iy+0]*g98[iz+0];
s[1951] = + g28[ix+0]*g1[iy+0]*g98[iz+0];
s[1952] = + g28[ix+0]*g0[iy+0]*g99[iz+0];
s[1953] = + g27[ix+0]*g4[iy+0]*g96[iz+0];
s[1954] = + g26[ix+0]*g5[iy+0]*g96[iz+0];
s[1955] = + g26[ix+0]*g4[iy+0]*g97[iz+0];
s[1956] = + g25[ix+0]*g6[iy+0]*g96[iz+0];
s[1957] = + g24[ix+0]*g7[iy+0]*g96[iz+0];
s[1958] = + g24[ix+0]*g6[iy+0]*g97[iz+0];
s[1959] = + g25[ix+0]*g4[iy+0]*g98[iz+0];
s[1960] = + g24[ix+0]*g5[iy+0]*g98[iz+0];
s[1961] = + g24[ix+0]*g4[iy+0]*g99[iz+0];
s[1962] = + g27[ix+0]*g0[iy+0]*g100[iz+0];
s[1963] = + g26[ix+0]*g1[iy+0]*g100[iz+0];
s[1964] = + g26[ix+0]*g0[iy+0]*g101[iz+0];
s[1965] = + g25[ix+0]*g2[iy+0]*g100[iz+0];
s[1966] = + g24[ix+0]*g3[iy+0]*g100[iz+0];
s[1967] = + g24[ix+0]*g2[iy+0]*g101[iz+0];
s[1968] = + g25[ix+0]*g0[iy+0]*g102[iz+0];
s[1969] = + g24[ix+0]*g1[iy+0]*g102[iz+0];
s[1970] = + g24[ix+0]*g0[iy+0]*g103[iz+0];
s[1971] = + g23[ix+0]*g8[iy+0]*g96[iz+0];
s[1972] = + g22[ix+0]*g9[iy+0]*g96[iz+0];
s[1973] = + g22[ix+0]*g8[iy+0]*g97[iz+0];
s[1974] = + g21[ix+0]*g10[iy+0]*g96[iz+0];
s[1975] = + g20[ix+0]*g11[iy+0]*g96[iz+0];
s[1976] = + g20[ix+0]*g10[iy+0]*g97[iz+0];
s[1977] = + g21[ix+0]*g8[iy+0]*g98[iz+0];
s[1978] = + g20[ix+0]*g9[iy+0]*g98[iz+0];
s[1979] = + g20[ix+0]*g8[iy+0]*g99[iz+0];
s[1980] = + g19[ix+0]*g12[iy+0]*g96[iz+0];
s[1981] = + g18[ix+0]*g13[iy+0]*g96[iz+0];
s[1982] = + g18[ix+0]*g12[iy+0]*g97[iz+0];
s[1983] = + g17[ix+0]*g14[iy+0]*g96[iz+0];
s[1984] = + g16[ix+0]*g15[iy+0]*g96[iz+0];
s[1985] = + g16[ix+0]*g14[iy+0]*g97[iz+0];
s[1986] = + g17[ix+0]*g12[iy+0]*g98[iz+0];
s[1987] = + g16[ix+0]*g13[iy+0]*g98[iz+0];
s[1988] = + g16[ix+0]*g12[iy+0]*g99[iz+0];
s[1989] = + g19[ix+0]*g8[iy+0]*g100[iz+0];
s[1990] = + g18[ix+0]*g9[iy+0]*g100[iz+0];
s[1991] = + g18[ix+0]*g8[iy+0]*g101[iz+0];
s[1992] = + g17[ix+0]*g10[iy+0]*g100[iz+0];
s[1993] = + g16[ix+0]*g11[iy+0]*g100[iz+0];
s[1994] = + g16[ix+0]*g10[iy+0]*g101[iz+0];
s[1995] = + g17[ix+0]*g8[iy+0]*g102[iz+0];
s[1996] = + g16[ix+0]*g9[iy+0]*g102[iz+0];
s[1997] = + g16[ix+0]*g8[iy+0]*g103[iz+0];
s[1998] = + g23[ix+0]*g0[iy+0]*g104[iz+0];
s[1999] = + g22[ix+0]*g1[iy+0]*g104[iz+0];
s[2000] = + g22[ix+0]*g0[iy+0]*g105[iz+0];
s[2001] = + g21[ix+0]*g2[iy+0]*g104[iz+0];
s[2002] = + g20[ix+0]*g3[iy+0]*g104[iz+0];
s[2003] = + g20[ix+0]*g2[iy+0]*g105[iz+0];
s[2004] = + g21[ix+0]*g0[iy+0]*g106[iz+0];
s[2005] = + g20[ix+0]*g1[iy+0]*g106[iz+0];
s[2006] = + g20[ix+0]*g0[iy+0]*g107[iz+0];
s[2007] = + g19[ix+0]*g4[iy+0]*g104[iz+0];
s[2008] = + g18[ix+0]*g5[iy+0]*g104[iz+0];
s[2009] = + g18[ix+0]*g4[iy+0]*g105[iz+0];
s[2010] = + g17[ix+0]*g6[iy+0]*g104[iz+0];
s[2011] = + g16[ix+0]*g7[iy+0]*g104[iz+0];
s[2012] = + g16[ix+0]*g6[iy+0]*g105[iz+0];
s[2013] = + g17[ix+0]*g4[iy+0]*g106[iz+0];
s[2014] = + g16[ix+0]*g5[iy+0]*g106[iz+0];
s[2015] = + g16[ix+0]*g4[iy+0]*g107[iz+0];
s[2016] = + g19[ix+0]*g0[iy+0]*g108[iz+0];
s[2017] = + g18[ix+0]*g1[iy+0]*g108[iz+0];
s[2018] = + g18[ix+0]*g0[iy+0]*g109[iz+0];
s[2019] = + g17[ix+0]*g2[iy+0]*g108[iz+0];
s[2020] = + g16[ix+0]*g3[iy+0]*g108[iz+0];
s[2021] = + g16[ix+0]*g2[iy+0]*g109[iz+0];
s[2022] = + g17[ix+0]*g0[iy+0]*g110[iz+0];
s[2023] = + g16[ix+0]*g1[iy+0]*g110[iz+0];
s[2024] = + g16[ix+0]*g0[iy+0]*g111[iz+0];
s[2025] = + g15[ix+0]*g16[iy+0]*g96[iz+0];
s[2026] = + g14[ix+0]*g17[iy+0]*g96[iz+0];
s[2027] = + g14[ix+0]*g16[iy+0]*g97[iz+0];
s[2028] = + g13[ix+0]*g18[iy+0]*g96[iz+0];
s[2029] = + g12[ix+0]*g19[iy+0]*g96[iz+0];
s[2030] = + g12[ix+0]*g18[iy+0]*g97[iz+0];
s[2031] = + g13[ix+0]*g16[iy+0]*g98[iz+0];
s[2032] = + g12[ix+0]*g17[iy+0]*g98[iz+0];
s[2033] = + g12[ix+0]*g16[iy+0]*g99[iz+0];
s[2034] = + g11[ix+0]*g20[iy+0]*g96[iz+0];
s[2035] = + g10[ix+0]*g21[iy+0]*g96[iz+0];
s[2036] = + g10[ix+0]*g20[iy+0]*g97[iz+0];
s[2037] = + g9[ix+0]*g22[iy+0]*g96[iz+0];
s[2038] = + g8[ix+0]*g23[iy+0]*g96[iz+0];
s[2039] = + g8[ix+0]*g22[iy+0]*g97[iz+0];
s[2040] = + g9[ix+0]*g20[iy+0]*g98[iz+0];
s[2041] = + g8[ix+0]*g21[iy+0]*g98[iz+0];
s[2042] = + g8[ix+0]*g20[iy+0]*g99[iz+0];
s[2043] = + g11[ix+0]*g16[iy+0]*g100[iz+0];
s[2044] = + g10[ix+0]*g17[iy+0]*g100[iz+0];
s[2045] = + g10[ix+0]*g16[iy+0]*g101[iz+0];
s[2046] = + g9[ix+0]*g18[iy+0]*g100[iz+0];
s[2047] = + g8[ix+0]*g19[iy+0]*g100[iz+0];
s[2048] = + g8[ix+0]*g18[iy+0]*g101[iz+0];
s[2049] = + g9[ix+0]*g16[iy+0]*g102[iz+0];
s[2050] = + g8[ix+0]*g17[iy+0]*g102[iz+0];
s[2051] = + g8[ix+0]*g16[iy+0]*g103[iz+0];
s[2052] = + g7[ix+0]*g24[iy+0]*g96[iz+0];
s[2053] = + g6[ix+0]*g25[iy+0]*g96[iz+0];
s[2054] = + g6[ix+0]*g24[iy+0]*g97[iz+0];
s[2055] = + g5[ix+0]*g26[iy+0]*g96[iz+0];
s[2056] = + g4[ix+0]*g27[iy+0]*g96[iz+0];
s[2057] = + g4[ix+0]*g26[iy+0]*g97[iz+0];
s[2058] = + g5[ix+0]*g24[iy+0]*g98[iz+0];
s[2059] = + g4[ix+0]*g25[iy+0]*g98[iz+0];
s[2060] = + g4[ix+0]*g24[iy+0]*g99[iz+0];
s[2061] = + g3[ix+0]*g28[iy+0]*g96[iz+0];
s[2062] = + g2[ix+0]*g29[iy+0]*g96[iz+0];
s[2063] = + g2[ix+0]*g28[iy+0]*g97[iz+0];
s[2064] = + g1[ix+0]*g30[iy+0]*g96[iz+0];
s[2065] = + g0[ix+0]*g31[iy+0]*g96[iz+0];
s[2066] = + g0[ix+0]*g30[iy+0]*g97[iz+0];
s[2067] = + g1[ix+0]*g28[iy+0]*g98[iz+0];
s[2068] = + g0[ix+0]*g29[iy+0]*g98[iz+0];
s[2069] = + g0[ix+0]*g28[iy+0]*g99[iz+0];
s[2070] = + g3[ix+0]*g24[iy+0]*g100[iz+0];
s[2071] = + g2[ix+0]*g25[iy+0]*g100[iz+0];
s[2072] = + g2[ix+0]*g24[iy+0]*g101[iz+0];
s[2073] = + g1[ix+0]*g26[iy+0]*g100[iz+0];
s[2074] = + g0[ix+0]*g27[iy+0]*g100[iz+0];
s[2075] = + g0[ix+0]*g26[iy+0]*g101[iz+0];
s[2076] = + g1[ix+0]*g24[iy+0]*g102[iz+0];
s[2077] = + g0[ix+0]*g25[iy+0]*g102[iz+0];
s[2078] = + g0[ix+0]*g24[iy+0]*g103[iz+0];
s[2079] = + g7[ix+0]*g16[iy+0]*g104[iz+0];
s[2080] = + g6[ix+0]*g17[iy+0]*g104[iz+0];
s[2081] = + g6[ix+0]*g16[iy+0]*g105[iz+0];
s[2082] = + g5[ix+0]*g18[iy+0]*g104[iz+0];
s[2083] = + g4[ix+0]*g19[iy+0]*g104[iz+0];
s[2084] = + g4[ix+0]*g18[iy+0]*g105[iz+0];
s[2085] = + g5[ix+0]*g16[iy+0]*g106[iz+0];
s[2086] = + g4[ix+0]*g17[iy+0]*g106[iz+0];
s[2087] = + g4[ix+0]*g16[iy+0]*g107[iz+0];
s[2088] = + g3[ix+0]*g20[iy+0]*g104[iz+0];
s[2089] = + g2[ix+0]*g21[iy+0]*g104[iz+0];
s[2090] = + g2[ix+0]*g20[iy+0]*g105[iz+0];
s[2091] = + g1[ix+0]*g22[iy+0]*g104[iz+0];
s[2092] = + g0[ix+0]*g23[iy+0]*g104[iz+0];
s[2093] = + g0[ix+0]*g22[iy+0]*g105[iz+0];
s[2094] = + g1[ix+0]*g20[iy+0]*g106[iz+0];
s[2095] = + g0[ix+0]*g21[iy+0]*g106[iz+0];
s[2096] = + g0[ix+0]*g20[iy+0]*g107[iz+0];
s[2097] = + g3[ix+0]*g16[iy+0]*g108[iz+0];
s[2098] = + g2[ix+0]*g17[iy+0]*g108[iz+0];
s[2099] = + g2[ix+0]*g16[iy+0]*g109[iz+0];
s[2100] = + g1[ix+0]*g18[iy+0]*g108[iz+0];
s[2101] = + g0[ix+0]*g19[iy+0]*g108[iz+0];
s[2102] = + g0[ix+0]*g18[iy+0]*g109[iz+0];
s[2103] = + g1[ix+0]*g16[iy+0]*g110[iz+0];
s[2104] = + g0[ix+0]*g17[iy+0]*g110[iz+0];
s[2105] = + g0[ix+0]*g16[iy+0]*g111[iz+0];
s[2106] = + g15[ix+0]*g0[iy+0]*g112[iz+0];
s[2107] = + g14[ix+0]*g1[iy+0]*g112[iz+0];
s[2108] = + g14[ix+0]*g0[iy+0]*g113[iz+0];
s[2109] = + g13[ix+0]*g2[iy+0]*g112[iz+0];
s[2110] = + g12[ix+0]*g3[iy+0]*g112[iz+0];
s[2111] = + g12[ix+0]*g2[iy+0]*g113[iz+0];
s[2112] = + g13[ix+0]*g0[iy+0]*g114[iz+0];
s[2113] = + g12[ix+0]*g1[iy+0]*g114[iz+0];
s[2114] = + g12[ix+0]*g0[iy+0]*g115[iz+0];
s[2115] = + g11[ix+0]*g4[iy+0]*g112[iz+0];
s[2116] = + g10[ix+0]*g5[iy+0]*g112[iz+0];
s[2117] = + g10[ix+0]*g4[iy+0]*g113[iz+0];
s[2118] = + g9[ix+0]*g6[iy+0]*g112[iz+0];
s[2119] = + g8[ix+0]*g7[iy+0]*g112[iz+0];
s[2120] = + g8[ix+0]*g6[iy+0]*g113[iz+0];
s[2121] = + g9[ix+0]*g4[iy+0]*g114[iz+0];
s[2122] = + g8[ix+0]*g5[iy+0]*g114[iz+0];
s[2123] = + g8[ix+0]*g4[iy+0]*g115[iz+0];
s[2124] = + g11[ix+0]*g0[iy+0]*g116[iz+0];
s[2125] = + g10[ix+0]*g1[iy+0]*g116[iz+0];
s[2126] = + g10[ix+0]*g0[iy+0]*g117[iz+0];
s[2127] = + g9[ix+0]*g2[iy+0]*g116[iz+0];
s[2128] = + g8[ix+0]*g3[iy+0]*g116[iz+0];
s[2129] = + g8[ix+0]*g2[iy+0]*g117[iz+0];
s[2130] = + g9[ix+0]*g0[iy+0]*g118[iz+0];
s[2131] = + g8[ix+0]*g1[iy+0]*g118[iz+0];
s[2132] = + g8[ix+0]*g0[iy+0]*g119[iz+0];
s[2133] = + g7[ix+0]*g8[iy+0]*g112[iz+0];
s[2134] = + g6[ix+0]*g9[iy+0]*g112[iz+0];
s[2135] = + g6[ix+0]*g8[iy+0]*g113[iz+0];
s[2136] = + g5[ix+0]*g10[iy+0]*g112[iz+0];
s[2137] = + g4[ix+0]*g11[iy+0]*g112[iz+0];
s[2138] = + g4[ix+0]*g10[iy+0]*g113[iz+0];
s[2139] = + g5[ix+0]*g8[iy+0]*g114[iz+0];
s[2140] = + g4[ix+0]*g9[iy+0]*g114[iz+0];
s[2141] = + g4[ix+0]*g8[iy+0]*g115[iz+0];
s[2142] = + g3[ix+0]*g12[iy+0]*g112[iz+0];
s[2143] = + g2[ix+0]*g13[iy+0]*g112[iz+0];
s[2144] = + g2[ix+0]*g12[iy+0]*g113[iz+0];
s[2145] = + g1[ix+0]*g14[iy+0]*g112[iz+0];
s[2146] = + g0[ix+0]*g15[iy+0]*g112[iz+0];
s[2147] = + g0[ix+0]*g14[iy+0]*g113[iz+0];
s[2148] = + g1[ix+0]*g12[iy+0]*g114[iz+0];
s[2149] = + g0[ix+0]*g13[iy+0]*g114[iz+0];
s[2150] = + g0[ix+0]*g12[iy+0]*g115[iz+0];
s[2151] = + g3[ix+0]*g8[iy+0]*g116[iz+0];
s[2152] = + g2[ix+0]*g9[iy+0]*g116[iz+0];
s[2153] = + g2[ix+0]*g8[iy+0]*g117[iz+0];
s[2154] = + g1[ix+0]*g10[iy+0]*g116[iz+0];
s[2155] = + g0[ix+0]*g11[iy+0]*g116[iz+0];
s[2156] = + g0[ix+0]*g10[iy+0]*g117[iz+0];
s[2157] = + g1[ix+0]*g8[iy+0]*g118[iz+0];
s[2158] = + g0[ix+0]*g9[iy+0]*g118[iz+0];
s[2159] = + g0[ix+0]*g8[iy+0]*g119[iz+0];
s[2160] = + g7[ix+0]*g0[iy+0]*g120[iz+0];
s[2161] = + g6[ix+0]*g1[iy+0]*g120[iz+0];
s[2162] = + g6[ix+0]*g0[iy+0]*g121[iz+0];
s[2163] = + g5[ix+0]*g2[iy+0]*g120[iz+0];
s[2164] = + g4[ix+0]*g3[iy+0]*g120[iz+0];
s[2165] = + g4[ix+0]*g2[iy+0]*g121[iz+0];
s[2166] = + g5[ix+0]*g0[iy+0]*g122[iz+0];
s[2167] = + g4[ix+0]*g1[iy+0]*g122[iz+0];
s[2168] = + g4[ix+0]*g0[iy+0]*g123[iz+0];
s[2169] = + g3[ix+0]*g4[iy+0]*g120[iz+0];
s[2170] = + g2[ix+0]*g5[iy+0]*g120[iz+0];
s[2171] = + g2[ix+0]*g4[iy+0]*g121[iz+0];
s[2172] = + g1[ix+0]*g6[iy+0]*g120[iz+0];
s[2173] = + g0[ix+0]*g7[iy+0]*g120[iz+0];
s[2174] = + g0[ix+0]*g6[iy+0]*g121[iz+0];
s[2175] = + g1[ix+0]*g4[iy+0]*g122[iz+0];
s[2176] = + g0[ix+0]*g5[iy+0]*g122[iz+0];
s[2177] = + g0[ix+0]*g4[iy+0]*g123[iz+0];
s[2178] = + g3[ix+0]*g0[iy+0]*g124[iz+0];
s[2179] = + g2[ix+0]*g1[iy+0]*g124[iz+0];
s[2180] = + g2[ix+0]*g0[iy+0]*g125[iz+0];
s[2181] = + g1[ix+0]*g2[iy+0]*g124[iz+0];
s[2182] = + g0[ix+0]*g3[iy+0]*g124[iz+0];
s[2183] = + g0[ix+0]*g2[iy+0]*g125[iz+0];
s[2184] = + g1[ix+0]*g0[iy+0]*g126[iz+0];
s[2185] = + g0[ix+0]*g1[iy+0]*g126[iz+0];
s[2186] = + g0[ix+0]*g0[iy+0]*g127[iz+0];
if (gout_empty) {
gout[n*2187+0] = + s[0];
gout[n*2187+1] = + s[1];
gout[n*2187+2] = + s[2];
gout[n*2187+3] = + s[3];
gout[n*2187+4] = + s[4];
gout[n*2187+5] = + s[5];
gout[n*2187+6] = + s[6];
gout[n*2187+7] = + s[7];
gout[n*2187+8] = + s[8];
gout[n*2187+9] = + s[9];
gout[n*2187+10] = + s[10];
gout[n*2187+11] = + s[11];
gout[n*2187+12] = + s[12];
gout[n*2187+13] = + s[13];
gout[n*2187+14] = + s[14];
gout[n*2187+15] = + s[15];
gout[n*2187+16] = + s[16];
gout[n*2187+17] = + s[17];
gout[n*2187+18] = + s[18];
gout[n*2187+19] = + s[19];
gout[n*2187+20] = + s[20];
gout[n*2187+21] = + s[21];
gout[n*2187+22] = + s[22];
gout[n*2187+23] = + s[23];
gout[n*2187+24] = + s[24];
gout[n*2187+25] = + s[25];
gout[n*2187+26] = + s[26];
gout[n*2187+27] = + s[27];
gout[n*2187+28] = + s[28];
gout[n*2187+29] = + s[29];
gout[n*2187+30] = + s[30];
gout[n*2187+31] = + s[31];
gout[n*2187+32] = + s[32];
gout[n*2187+33] = + s[33];
gout[n*2187+34] = + s[34];
gout[n*2187+35] = + s[35];
gout[n*2187+36] = + s[36];
gout[n*2187+37] = + s[37];
gout[n*2187+38] = + s[38];
gout[n*2187+39] = + s[39];
gout[n*2187+40] = + s[40];
gout[n*2187+41] = + s[41];
gout[n*2187+42] = + s[42];
gout[n*2187+43] = + s[43];
gout[n*2187+44] = + s[44];
gout[n*2187+45] = + s[45];
gout[n*2187+46] = + s[46];
gout[n*2187+47] = + s[47];
gout[n*2187+48] = + s[48];
gout[n*2187+49] = + s[49];
gout[n*2187+50] = + s[50];
gout[n*2187+51] = + s[51];
gout[n*2187+52] = + s[52];
gout[n*2187+53] = + s[53];
gout[n*2187+54] = + s[54];
gout[n*2187+55] = + s[55];
gout[n*2187+56] = + s[56];
gout[n*2187+57] = + s[57];
gout[n*2187+58] = + s[58];
gout[n*2187+59] = + s[59];
gout[n*2187+60] = + s[60];
gout[n*2187+61] = + s[61];
gout[n*2187+62] = + s[62];
gout[n*2187+63] = + s[63];
gout[n*2187+64] = + s[64];
gout[n*2187+65] = + s[65];
gout[n*2187+66] = + s[66];
gout[n*2187+67] = + s[67];
gout[n*2187+68] = + s[68];
gout[n*2187+69] = + s[69];
gout[n*2187+70] = + s[70];
gout[n*2187+71] = + s[71];
gout[n*2187+72] = + s[72];
gout[n*2187+73] = + s[73];
gout[n*2187+74] = + s[74];
gout[n*2187+75] = + s[75];
gout[n*2187+76] = + s[76];
gout[n*2187+77] = + s[77];
gout[n*2187+78] = + s[78];
gout[n*2187+79] = + s[79];
gout[n*2187+80] = + s[80];
gout[n*2187+81] = + s[81];
gout[n*2187+82] = + s[82];
gout[n*2187+83] = + s[83];
gout[n*2187+84] = + s[84];
gout[n*2187+85] = + s[85];
gout[n*2187+86] = + s[86];
gout[n*2187+87] = + s[87];
gout[n*2187+88] = + s[88];
gout[n*2187+89] = + s[89];
gout[n*2187+90] = + s[90];
gout[n*2187+91] = + s[91];
gout[n*2187+92] = + s[92];
gout[n*2187+93] = + s[93];
gout[n*2187+94] = + s[94];
gout[n*2187+95] = + s[95];
gout[n*2187+96] = + s[96];
gout[n*2187+97] = + s[97];
gout[n*2187+98] = + s[98];
gout[n*2187+99] = + s[99];
gout[n*2187+100] = + s[100];
gout[n*2187+101] = + s[101];
gout[n*2187+102] = + s[102];
gout[n*2187+103] = + s[103];
gout[n*2187+104] = + s[104];
gout[n*2187+105] = + s[105];
gout[n*2187+106] = + s[106];
gout[n*2187+107] = + s[107];
gout[n*2187+108] = + s[108];
gout[n*2187+109] = + s[109];
gout[n*2187+110] = + s[110];
gout[n*2187+111] = + s[111];
gout[n*2187+112] = + s[112];
gout[n*2187+113] = + s[113];
gout[n*2187+114] = + s[114];
gout[n*2187+115] = + s[115];
gout[n*2187+116] = + s[116];
gout[n*2187+117] = + s[117];
gout[n*2187+118] = + s[118];
gout[n*2187+119] = + s[119];
gout[n*2187+120] = + s[120];
gout[n*2187+121] = + s[121];
gout[n*2187+122] = + s[122];
gout[n*2187+123] = + s[123];
gout[n*2187+124] = + s[124];
gout[n*2187+125] = + s[125];
gout[n*2187+126] = + s[126];
gout[n*2187+127] = + s[127];
gout[n*2187+128] = + s[128];
gout[n*2187+129] = + s[129];
gout[n*2187+130] = + s[130];
gout[n*2187+131] = + s[131];
gout[n*2187+132] = + s[132];
gout[n*2187+133] = + s[133];
gout[n*2187+134] = + s[134];
gout[n*2187+135] = + s[135];
gout[n*2187+136] = + s[136];
gout[n*2187+137] = + s[137];
gout[n*2187+138] = + s[138];
gout[n*2187+139] = + s[139];
gout[n*2187+140] = + s[140];
gout[n*2187+141] = + s[141];
gout[n*2187+142] = + s[142];
gout[n*2187+143] = + s[143];
gout[n*2187+144] = + s[144];
gout[n*2187+145] = + s[145];
gout[n*2187+146] = + s[146];
gout[n*2187+147] = + s[147];
gout[n*2187+148] = + s[148];
gout[n*2187+149] = + s[149];
gout[n*2187+150] = + s[150];
gout[n*2187+151] = + s[151];
gout[n*2187+152] = + s[152];
gout[n*2187+153] = + s[153];
gout[n*2187+154] = + s[154];
gout[n*2187+155] = + s[155];
gout[n*2187+156] = + s[156];
gout[n*2187+157] = + s[157];
gout[n*2187+158] = + s[158];
gout[n*2187+159] = + s[159];
gout[n*2187+160] = + s[160];
gout[n*2187+161] = + s[161];
gout[n*2187+162] = + s[162];
gout[n*2187+163] = + s[163];
gout[n*2187+164] = + s[164];
gout[n*2187+165] = + s[165];
gout[n*2187+166] = + s[166];
gout[n*2187+167] = + s[167];
gout[n*2187+168] = + s[168];
gout[n*2187+169] = + s[169];
gout[n*2187+170] = + s[170];
gout[n*2187+171] = + s[171];
gout[n*2187+172] = + s[172];
gout[n*2187+173] = + s[173];
gout[n*2187+174] = + s[174];
gout[n*2187+175] = + s[175];
gout[n*2187+176] = + s[176];
gout[n*2187+177] = + s[177];
gout[n*2187+178] = + s[178];
gout[n*2187+179] = + s[179];
gout[n*2187+180] = + s[180];
gout[n*2187+181] = + s[181];
gout[n*2187+182] = + s[182];
gout[n*2187+183] = + s[183];
gout[n*2187+184] = + s[184];
gout[n*2187+185] = + s[185];
gout[n*2187+186] = + s[186];
gout[n*2187+187] = + s[187];
gout[n*2187+188] = + s[188];
gout[n*2187+189] = + s[189];
gout[n*2187+190] = + s[190];
gout[n*2187+191] = + s[191];
gout[n*2187+192] = + s[192];
gout[n*2187+193] = + s[193];
gout[n*2187+194] = + s[194];
gout[n*2187+195] = + s[195];
gout[n*2187+196] = + s[196];
gout[n*2187+197] = + s[197];
gout[n*2187+198] = + s[198];
gout[n*2187+199] = + s[199];
gout[n*2187+200] = + s[200];
gout[n*2187+201] = + s[201];
gout[n*2187+202] = + s[202];
gout[n*2187+203] = + s[203];
gout[n*2187+204] = + s[204];
gout[n*2187+205] = + s[205];
gout[n*2187+206] = + s[206];
gout[n*2187+207] = + s[207];
gout[n*2187+208] = + s[208];
gout[n*2187+209] = + s[209];
gout[n*2187+210] = + s[210];
gout[n*2187+211] = + s[211];
gout[n*2187+212] = + s[212];
gout[n*2187+213] = + s[213];
gout[n*2187+214] = + s[214];
gout[n*2187+215] = + s[215];
gout[n*2187+216] = + s[216];
gout[n*2187+217] = + s[217];
gout[n*2187+218] = + s[218];
gout[n*2187+219] = + s[219];
gout[n*2187+220] = + s[220];
gout[n*2187+221] = + s[221];
gout[n*2187+222] = + s[222];
gout[n*2187+223] = + s[223];
gout[n*2187+224] = + s[224];
gout[n*2187+225] = + s[225];
gout[n*2187+226] = + s[226];
gout[n*2187+227] = + s[227];
gout[n*2187+228] = + s[228];
gout[n*2187+229] = + s[229];
gout[n*2187+230] = + s[230];
gout[n*2187+231] = + s[231];
gout[n*2187+232] = + s[232];
gout[n*2187+233] = + s[233];
gout[n*2187+234] = + s[234];
gout[n*2187+235] = + s[235];
gout[n*2187+236] = + s[236];
gout[n*2187+237] = + s[237];
gout[n*2187+238] = + s[238];
gout[n*2187+239] = + s[239];
gout[n*2187+240] = + s[240];
gout[n*2187+241] = + s[241];
gout[n*2187+242] = + s[242];
gout[n*2187+243] = + s[729];
gout[n*2187+244] = + s[730];
gout[n*2187+245] = + s[731];
gout[n*2187+246] = + s[732];
gout[n*2187+247] = + s[733];
gout[n*2187+248] = + s[734];
gout[n*2187+249] = + s[735];
gout[n*2187+250] = + s[736];
gout[n*2187+251] = + s[737];
gout[n*2187+252] = + s[738];
gout[n*2187+253] = + s[739];
gout[n*2187+254] = + s[740];
gout[n*2187+255] = + s[741];
gout[n*2187+256] = + s[742];
gout[n*2187+257] = + s[743];
gout[n*2187+258] = + s[744];
gout[n*2187+259] = + s[745];
gout[n*2187+260] = + s[746];
gout[n*2187+261] = + s[747];
gout[n*2187+262] = + s[748];
gout[n*2187+263] = + s[749];
gout[n*2187+264] = + s[750];
gout[n*2187+265] = + s[751];
gout[n*2187+266] = + s[752];
gout[n*2187+267] = + s[753];
gout[n*2187+268] = + s[754];
gout[n*2187+269] = + s[755];
gout[n*2187+270] = + s[756];
gout[n*2187+271] = + s[757];
gout[n*2187+272] = + s[758];
gout[n*2187+273] = + s[759];
gout[n*2187+274] = + s[760];
gout[n*2187+275] = + s[761];
gout[n*2187+276] = + s[762];
gout[n*2187+277] = + s[763];
gout[n*2187+278] = + s[764];
gout[n*2187+279] = + s[765];
gout[n*2187+280] = + s[766];
gout[n*2187+281] = + s[767];
gout[n*2187+282] = + s[768];
gout[n*2187+283] = + s[769];
gout[n*2187+284] = + s[770];
gout[n*2187+285] = + s[771];
gout[n*2187+286] = + s[772];
gout[n*2187+287] = + s[773];
gout[n*2187+288] = + s[774];
gout[n*2187+289] = + s[775];
gout[n*2187+290] = + s[776];
gout[n*2187+291] = + s[777];
gout[n*2187+292] = + s[778];
gout[n*2187+293] = + s[779];
gout[n*2187+294] = + s[780];
gout[n*2187+295] = + s[781];
gout[n*2187+296] = + s[782];
gout[n*2187+297] = + s[783];
gout[n*2187+298] = + s[784];
gout[n*2187+299] = + s[785];
gout[n*2187+300] = + s[786];
gout[n*2187+301] = + s[787];
gout[n*2187+302] = + s[788];
gout[n*2187+303] = + s[789];
gout[n*2187+304] = + s[790];
gout[n*2187+305] = + s[791];
gout[n*2187+306] = + s[792];
gout[n*2187+307] = + s[793];
gout[n*2187+308] = + s[794];
gout[n*2187+309] = + s[795];
gout[n*2187+310] = + s[796];
gout[n*2187+311] = + s[797];
gout[n*2187+312] = + s[798];
gout[n*2187+313] = + s[799];
gout[n*2187+314] = + s[800];
gout[n*2187+315] = + s[801];
gout[n*2187+316] = + s[802];
gout[n*2187+317] = + s[803];
gout[n*2187+318] = + s[804];
gout[n*2187+319] = + s[805];
gout[n*2187+320] = + s[806];
gout[n*2187+321] = + s[807];
gout[n*2187+322] = + s[808];
gout[n*2187+323] = + s[809];
gout[n*2187+324] = + s[810];
gout[n*2187+325] = + s[811];
gout[n*2187+326] = + s[812];
gout[n*2187+327] = + s[813];
gout[n*2187+328] = + s[814];
gout[n*2187+329] = + s[815];
gout[n*2187+330] = + s[816];
gout[n*2187+331] = + s[817];
gout[n*2187+332] = + s[818];
gout[n*2187+333] = + s[819];
gout[n*2187+334] = + s[820];
gout[n*2187+335] = + s[821];
gout[n*2187+336] = + s[822];
gout[n*2187+337] = + s[823];
gout[n*2187+338] = + s[824];
gout[n*2187+339] = + s[825];
gout[n*2187+340] = + s[826];
gout[n*2187+341] = + s[827];
gout[n*2187+342] = + s[828];
gout[n*2187+343] = + s[829];
gout[n*2187+344] = + s[830];
gout[n*2187+345] = + s[831];
gout[n*2187+346] = + s[832];
gout[n*2187+347] = + s[833];
gout[n*2187+348] = + s[834];
gout[n*2187+349] = + s[835];
gout[n*2187+350] = + s[836];
gout[n*2187+351] = + s[837];
gout[n*2187+352] = + s[838];
gout[n*2187+353] = + s[839];
gout[n*2187+354] = + s[840];
gout[n*2187+355] = + s[841];
gout[n*2187+356] = + s[842];
gout[n*2187+357] = + s[843];
gout[n*2187+358] = + s[844];
gout[n*2187+359] = + s[845];
gout[n*2187+360] = + s[846];
gout[n*2187+361] = + s[847];
gout[n*2187+362] = + s[848];
gout[n*2187+363] = + s[849];
gout[n*2187+364] = + s[850];
gout[n*2187+365] = + s[851];
gout[n*2187+366] = + s[852];
gout[n*2187+367] = + s[853];
gout[n*2187+368] = + s[854];
gout[n*2187+369] = + s[855];
gout[n*2187+370] = + s[856];
gout[n*2187+371] = + s[857];
gout[n*2187+372] = + s[858];
gout[n*2187+373] = + s[859];
gout[n*2187+374] = + s[860];
gout[n*2187+375] = + s[861];
gout[n*2187+376] = + s[862];
gout[n*2187+377] = + s[863];
gout[n*2187+378] = + s[864];
gout[n*2187+379] = + s[865];
gout[n*2187+380] = + s[866];
gout[n*2187+381] = + s[867];
gout[n*2187+382] = + s[868];
gout[n*2187+383] = + s[869];
gout[n*2187+384] = + s[870];
gout[n*2187+385] = + s[871];
gout[n*2187+386] = + s[872];
gout[n*2187+387] = + s[873];
gout[n*2187+388] = + s[874];
gout[n*2187+389] = + s[875];
gout[n*2187+390] = + s[876];
gout[n*2187+391] = + s[877];
gout[n*2187+392] = + s[878];
gout[n*2187+393] = + s[879];
gout[n*2187+394] = + s[880];
gout[n*2187+395] = + s[881];
gout[n*2187+396] = + s[882];
gout[n*2187+397] = + s[883];
gout[n*2187+398] = + s[884];
gout[n*2187+399] = + s[885];
gout[n*2187+400] = + s[886];
gout[n*2187+401] = + s[887];
gout[n*2187+402] = + s[888];
gout[n*2187+403] = + s[889];
gout[n*2187+404] = + s[890];
gout[n*2187+405] = + s[891];
gout[n*2187+406] = + s[892];
gout[n*2187+407] = + s[893];
gout[n*2187+408] = + s[894];
gout[n*2187+409] = + s[895];
gout[n*2187+410] = + s[896];
gout[n*2187+411] = + s[897];
gout[n*2187+412] = + s[898];
gout[n*2187+413] = + s[899];
gout[n*2187+414] = + s[900];
gout[n*2187+415] = + s[901];
gout[n*2187+416] = + s[902];
gout[n*2187+417] = + s[903];
gout[n*2187+418] = + s[904];
gout[n*2187+419] = + s[905];
gout[n*2187+420] = + s[906];
gout[n*2187+421] = + s[907];
gout[n*2187+422] = + s[908];
gout[n*2187+423] = + s[909];
gout[n*2187+424] = + s[910];
gout[n*2187+425] = + s[911];
gout[n*2187+426] = + s[912];
gout[n*2187+427] = + s[913];
gout[n*2187+428] = + s[914];
gout[n*2187+429] = + s[915];
gout[n*2187+430] = + s[916];
gout[n*2187+431] = + s[917];
gout[n*2187+432] = + s[918];
gout[n*2187+433] = + s[919];
gout[n*2187+434] = + s[920];
gout[n*2187+435] = + s[921];
gout[n*2187+436] = + s[922];
gout[n*2187+437] = + s[923];
gout[n*2187+438] = + s[924];
gout[n*2187+439] = + s[925];
gout[n*2187+440] = + s[926];
gout[n*2187+441] = + s[927];
gout[n*2187+442] = + s[928];
gout[n*2187+443] = + s[929];
gout[n*2187+444] = + s[930];
gout[n*2187+445] = + s[931];
gout[n*2187+446] = + s[932];
gout[n*2187+447] = + s[933];
gout[n*2187+448] = + s[934];
gout[n*2187+449] = + s[935];
gout[n*2187+450] = + s[936];
gout[n*2187+451] = + s[937];
gout[n*2187+452] = + s[938];
gout[n*2187+453] = + s[939];
gout[n*2187+454] = + s[940];
gout[n*2187+455] = + s[941];
gout[n*2187+456] = + s[942];
gout[n*2187+457] = + s[943];
gout[n*2187+458] = + s[944];
gout[n*2187+459] = + s[945];
gout[n*2187+460] = + s[946];
gout[n*2187+461] = + s[947];
gout[n*2187+462] = + s[948];
gout[n*2187+463] = + s[949];
gout[n*2187+464] = + s[950];
gout[n*2187+465] = + s[951];
gout[n*2187+466] = + s[952];
gout[n*2187+467] = + s[953];
gout[n*2187+468] = + s[954];
gout[n*2187+469] = + s[955];
gout[n*2187+470] = + s[956];
gout[n*2187+471] = + s[957];
gout[n*2187+472] = + s[958];
gout[n*2187+473] = + s[959];
gout[n*2187+474] = + s[960];
gout[n*2187+475] = + s[961];
gout[n*2187+476] = + s[962];
gout[n*2187+477] = + s[963];
gout[n*2187+478] = + s[964];
gout[n*2187+479] = + s[965];
gout[n*2187+480] = + s[966];
gout[n*2187+481] = + s[967];
gout[n*2187+482] = + s[968];
gout[n*2187+483] = + s[969];
gout[n*2187+484] = + s[970];
gout[n*2187+485] = + s[971];
gout[n*2187+486] = + s[1458];
gout[n*2187+487] = + s[1459];
gout[n*2187+488] = + s[1460];
gout[n*2187+489] = + s[1461];
gout[n*2187+490] = + s[1462];
gout[n*2187+491] = + s[1463];
gout[n*2187+492] = + s[1464];
gout[n*2187+493] = + s[1465];
gout[n*2187+494] = + s[1466];
gout[n*2187+495] = + s[1467];
gout[n*2187+496] = + s[1468];
gout[n*2187+497] = + s[1469];
gout[n*2187+498] = + s[1470];
gout[n*2187+499] = + s[1471];
gout[n*2187+500] = + s[1472];
gout[n*2187+501] = + s[1473];
gout[n*2187+502] = + s[1474];
gout[n*2187+503] = + s[1475];
gout[n*2187+504] = + s[1476];
gout[n*2187+505] = + s[1477];
gout[n*2187+506] = + s[1478];
gout[n*2187+507] = + s[1479];
gout[n*2187+508] = + s[1480];
gout[n*2187+509] = + s[1481];
gout[n*2187+510] = + s[1482];
gout[n*2187+511] = + s[1483];
gout[n*2187+512] = + s[1484];
gout[n*2187+513] = + s[1485];
gout[n*2187+514] = + s[1486];
gout[n*2187+515] = + s[1487];
gout[n*2187+516] = + s[1488];
gout[n*2187+517] = + s[1489];
gout[n*2187+518] = + s[1490];
gout[n*2187+519] = + s[1491];
gout[n*2187+520] = + s[1492];
gout[n*2187+521] = + s[1493];
gout[n*2187+522] = + s[1494];
gout[n*2187+523] = + s[1495];
gout[n*2187+524] = + s[1496];
gout[n*2187+525] = + s[1497];
gout[n*2187+526] = + s[1498];
gout[n*2187+527] = + s[1499];
gout[n*2187+528] = + s[1500];
gout[n*2187+529] = + s[1501];
gout[n*2187+530] = + s[1502];
gout[n*2187+531] = + s[1503];
gout[n*2187+532] = + s[1504];
gout[n*2187+533] = + s[1505];
gout[n*2187+534] = + s[1506];
gout[n*2187+535] = + s[1507];
gout[n*2187+536] = + s[1508];
gout[n*2187+537] = + s[1509];
gout[n*2187+538] = + s[1510];
gout[n*2187+539] = + s[1511];
gout[n*2187+540] = + s[1512];
gout[n*2187+541] = + s[1513];
gout[n*2187+542] = + s[1514];
gout[n*2187+543] = + s[1515];
gout[n*2187+544] = + s[1516];
gout[n*2187+545] = + s[1517];
gout[n*2187+546] = + s[1518];
gout[n*2187+547] = + s[1519];
gout[n*2187+548] = + s[1520];
gout[n*2187+549] = + s[1521];
gout[n*2187+550] = + s[1522];
gout[n*2187+551] = + s[1523];
gout[n*2187+552] = + s[1524];
gout[n*2187+553] = + s[1525];
gout[n*2187+554] = + s[1526];
gout[n*2187+555] = + s[1527];
gout[n*2187+556] = + s[1528];
gout[n*2187+557] = + s[1529];
gout[n*2187+558] = + s[1530];
gout[n*2187+559] = + s[1531];
gout[n*2187+560] = + s[1532];
gout[n*2187+561] = + s[1533];
gout[n*2187+562] = + s[1534];
gout[n*2187+563] = + s[1535];
gout[n*2187+564] = + s[1536];
gout[n*2187+565] = + s[1537];
gout[n*2187+566] = + s[1538];
gout[n*2187+567] = + s[1539];
gout[n*2187+568] = + s[1540];
gout[n*2187+569] = + s[1541];
gout[n*2187+570] = + s[1542];
gout[n*2187+571] = + s[1543];
gout[n*2187+572] = + s[1544];
gout[n*2187+573] = + s[1545];
gout[n*2187+574] = + s[1546];
gout[n*2187+575] = + s[1547];
gout[n*2187+576] = + s[1548];
gout[n*2187+577] = + s[1549];
gout[n*2187+578] = + s[1550];
gout[n*2187+579] = + s[1551];
gout[n*2187+580] = + s[1552];
gout[n*2187+581] = + s[1553];
gout[n*2187+582] = + s[1554];
gout[n*2187+583] = + s[1555];
gout[n*2187+584] = + s[1556];
gout[n*2187+585] = + s[1557];
gout[n*2187+586] = + s[1558];
gout[n*2187+587] = + s[1559];
gout[n*2187+588] = + s[1560];
gout[n*2187+589] = + s[1561];
gout[n*2187+590] = + s[1562];
gout[n*2187+591] = + s[1563];
gout[n*2187+592] = + s[1564];
gout[n*2187+593] = + s[1565];
gout[n*2187+594] = + s[1566];
gout[n*2187+595] = + s[1567];
gout[n*2187+596] = + s[1568];
gout[n*2187+597] = + s[1569];
gout[n*2187+598] = + s[1570];
gout[n*2187+599] = + s[1571];
gout[n*2187+600] = + s[1572];
gout[n*2187+601] = + s[1573];
gout[n*2187+602] = + s[1574];
gout[n*2187+603] = + s[1575];
gout[n*2187+604] = + s[1576];
gout[n*2187+605] = + s[1577];
gout[n*2187+606] = + s[1578];
gout[n*2187+607] = + s[1579];
gout[n*2187+608] = + s[1580];
gout[n*2187+609] = + s[1581];
gout[n*2187+610] = + s[1582];
gout[n*2187+611] = + s[1583];
gout[n*2187+612] = + s[1584];
gout[n*2187+613] = + s[1585];
gout[n*2187+614] = + s[1586];
gout[n*2187+615] = + s[1587];
gout[n*2187+616] = + s[1588];
gout[n*2187+617] = + s[1589];
gout[n*2187+618] = + s[1590];
gout[n*2187+619] = + s[1591];
gout[n*2187+620] = + s[1592];
gout[n*2187+621] = + s[1593];
gout[n*2187+622] = + s[1594];
gout[n*2187+623] = + s[1595];
gout[n*2187+624] = + s[1596];
gout[n*2187+625] = + s[1597];
gout[n*2187+626] = + s[1598];
gout[n*2187+627] = + s[1599];
gout[n*2187+628] = + s[1600];
gout[n*2187+629] = + s[1601];
gout[n*2187+630] = + s[1602];
gout[n*2187+631] = + s[1603];
gout[n*2187+632] = + s[1604];
gout[n*2187+633] = + s[1605];
gout[n*2187+634] = + s[1606];
gout[n*2187+635] = + s[1607];
gout[n*2187+636] = + s[1608];
gout[n*2187+637] = + s[1609];
gout[n*2187+638] = + s[1610];
gout[n*2187+639] = + s[1611];
gout[n*2187+640] = + s[1612];
gout[n*2187+641] = + s[1613];
gout[n*2187+642] = + s[1614];
gout[n*2187+643] = + s[1615];
gout[n*2187+644] = + s[1616];
gout[n*2187+645] = + s[1617];
gout[n*2187+646] = + s[1618];
gout[n*2187+647] = + s[1619];
gout[n*2187+648] = + s[1620];
gout[n*2187+649] = + s[1621];
gout[n*2187+650] = + s[1622];
gout[n*2187+651] = + s[1623];
gout[n*2187+652] = + s[1624];
gout[n*2187+653] = + s[1625];
gout[n*2187+654] = + s[1626];
gout[n*2187+655] = + s[1627];
gout[n*2187+656] = + s[1628];
gout[n*2187+657] = + s[1629];
gout[n*2187+658] = + s[1630];
gout[n*2187+659] = + s[1631];
gout[n*2187+660] = + s[1632];
gout[n*2187+661] = + s[1633];
gout[n*2187+662] = + s[1634];
gout[n*2187+663] = + s[1635];
gout[n*2187+664] = + s[1636];
gout[n*2187+665] = + s[1637];
gout[n*2187+666] = + s[1638];
gout[n*2187+667] = + s[1639];
gout[n*2187+668] = + s[1640];
gout[n*2187+669] = + s[1641];
gout[n*2187+670] = + s[1642];
gout[n*2187+671] = + s[1643];
gout[n*2187+672] = + s[1644];
gout[n*2187+673] = + s[1645];
gout[n*2187+674] = + s[1646];
gout[n*2187+675] = + s[1647];
gout[n*2187+676] = + s[1648];
gout[n*2187+677] = + s[1649];
gout[n*2187+678] = + s[1650];
gout[n*2187+679] = + s[1651];
gout[n*2187+680] = + s[1652];
gout[n*2187+681] = + s[1653];
gout[n*2187+682] = + s[1654];
gout[n*2187+683] = + s[1655];
gout[n*2187+684] = + s[1656];
gout[n*2187+685] = + s[1657];
gout[n*2187+686] = + s[1658];
gout[n*2187+687] = + s[1659];
gout[n*2187+688] = + s[1660];
gout[n*2187+689] = + s[1661];
gout[n*2187+690] = + s[1662];
gout[n*2187+691] = + s[1663];
gout[n*2187+692] = + s[1664];
gout[n*2187+693] = + s[1665];
gout[n*2187+694] = + s[1666];
gout[n*2187+695] = + s[1667];
gout[n*2187+696] = + s[1668];
gout[n*2187+697] = + s[1669];
gout[n*2187+698] = + s[1670];
gout[n*2187+699] = + s[1671];
gout[n*2187+700] = + s[1672];
gout[n*2187+701] = + s[1673];
gout[n*2187+702] = + s[1674];
gout[n*2187+703] = + s[1675];
gout[n*2187+704] = + s[1676];
gout[n*2187+705] = + s[1677];
gout[n*2187+706] = + s[1678];
gout[n*2187+707] = + s[1679];
gout[n*2187+708] = + s[1680];
gout[n*2187+709] = + s[1681];
gout[n*2187+710] = + s[1682];
gout[n*2187+711] = + s[1683];
gout[n*2187+712] = + s[1684];
gout[n*2187+713] = + s[1685];
gout[n*2187+714] = + s[1686];
gout[n*2187+715] = + s[1687];
gout[n*2187+716] = + s[1688];
gout[n*2187+717] = + s[1689];
gout[n*2187+718] = + s[1690];
gout[n*2187+719] = + s[1691];
gout[n*2187+720] = + s[1692];
gout[n*2187+721] = + s[1693];
gout[n*2187+722] = + s[1694];
gout[n*2187+723] = + s[1695];
gout[n*2187+724] = + s[1696];
gout[n*2187+725] = + s[1697];
gout[n*2187+726] = + s[1698];
gout[n*2187+727] = + s[1699];
gout[n*2187+728] = + s[1700];
gout[n*2187+729] = + s[243];
gout[n*2187+730] = + s[244];
gout[n*2187+731] = + s[245];
gout[n*2187+732] = + s[246];
gout[n*2187+733] = + s[247];
gout[n*2187+734] = + s[248];
gout[n*2187+735] = + s[249];
gout[n*2187+736] = + s[250];
gout[n*2187+737] = + s[251];
gout[n*2187+738] = + s[252];
gout[n*2187+739] = + s[253];
gout[n*2187+740] = + s[254];
gout[n*2187+741] = + s[255];
gout[n*2187+742] = + s[256];
gout[n*2187+743] = + s[257];
gout[n*2187+744] = + s[258];
gout[n*2187+745] = + s[259];
gout[n*2187+746] = + s[260];
gout[n*2187+747] = + s[261];
gout[n*2187+748] = + s[262];
gout[n*2187+749] = + s[263];
gout[n*2187+750] = + s[264];
gout[n*2187+751] = + s[265];
gout[n*2187+752] = + s[266];
gout[n*2187+753] = + s[267];
gout[n*2187+754] = + s[268];
gout[n*2187+755] = + s[269];
gout[n*2187+756] = + s[270];
gout[n*2187+757] = + s[271];
gout[n*2187+758] = + s[272];
gout[n*2187+759] = + s[273];
gout[n*2187+760] = + s[274];
gout[n*2187+761] = + s[275];
gout[n*2187+762] = + s[276];
gout[n*2187+763] = + s[277];
gout[n*2187+764] = + s[278];
gout[n*2187+765] = + s[279];
gout[n*2187+766] = + s[280];
gout[n*2187+767] = + s[281];
gout[n*2187+768] = + s[282];
gout[n*2187+769] = + s[283];
gout[n*2187+770] = + s[284];
gout[n*2187+771] = + s[285];
gout[n*2187+772] = + s[286];
gout[n*2187+773] = + s[287];
gout[n*2187+774] = + s[288];
gout[n*2187+775] = + s[289];
gout[n*2187+776] = + s[290];
gout[n*2187+777] = + s[291];
gout[n*2187+778] = + s[292];
gout[n*2187+779] = + s[293];
gout[n*2187+780] = + s[294];
gout[n*2187+781] = + s[295];
gout[n*2187+782] = + s[296];
gout[n*2187+783] = + s[297];
gout[n*2187+784] = + s[298];
gout[n*2187+785] = + s[299];
gout[n*2187+786] = + s[300];
gout[n*2187+787] = + s[301];
gout[n*2187+788] = + s[302];
gout[n*2187+789] = + s[303];
gout[n*2187+790] = + s[304];
gout[n*2187+791] = + s[305];
gout[n*2187+792] = + s[306];
gout[n*2187+793] = + s[307];
gout[n*2187+794] = + s[308];
gout[n*2187+795] = + s[309];
gout[n*2187+796] = + s[310];
gout[n*2187+797] = + s[311];
gout[n*2187+798] = + s[312];
gout[n*2187+799] = + s[313];
gout[n*2187+800] = + s[314];
gout[n*2187+801] = + s[315];
gout[n*2187+802] = + s[316];
gout[n*2187+803] = + s[317];
gout[n*2187+804] = + s[318];
gout[n*2187+805] = + s[319];
gout[n*2187+806] = + s[320];
gout[n*2187+807] = + s[321];
gout[n*2187+808] = + s[322];
gout[n*2187+809] = + s[323];
gout[n*2187+810] = + s[324];
gout[n*2187+811] = + s[325];
gout[n*2187+812] = + s[326];
gout[n*2187+813] = + s[327];
gout[n*2187+814] = + s[328];
gout[n*2187+815] = + s[329];
gout[n*2187+816] = + s[330];
gout[n*2187+817] = + s[331];
gout[n*2187+818] = + s[332];
gout[n*2187+819] = + s[333];
gout[n*2187+820] = + s[334];
gout[n*2187+821] = + s[335];
gout[n*2187+822] = + s[336];
gout[n*2187+823] = + s[337];
gout[n*2187+824] = + s[338];
gout[n*2187+825] = + s[339];
gout[n*2187+826] = + s[340];
gout[n*2187+827] = + s[341];
gout[n*2187+828] = + s[342];
gout[n*2187+829] = + s[343];
gout[n*2187+830] = + s[344];
gout[n*2187+831] = + s[345];
gout[n*2187+832] = + s[346];
gout[n*2187+833] = + s[347];
gout[n*2187+834] = + s[348];
gout[n*2187+835] = + s[349];
gout[n*2187+836] = + s[350];
gout[n*2187+837] = + s[351];
gout[n*2187+838] = + s[352];
gout[n*2187+839] = + s[353];
gout[n*2187+840] = + s[354];
gout[n*2187+841] = + s[355];
gout[n*2187+842] = + s[356];
gout[n*2187+843] = + s[357];
gout[n*2187+844] = + s[358];
gout[n*2187+845] = + s[359];
gout[n*2187+846] = + s[360];
gout[n*2187+847] = + s[361];
gout[n*2187+848] = + s[362];
gout[n*2187+849] = + s[363];
gout[n*2187+850] = + s[364];
gout[n*2187+851] = + s[365];
gout[n*2187+852] = + s[366];
gout[n*2187+853] = + s[367];
gout[n*2187+854] = + s[368];
gout[n*2187+855] = + s[369];
gout[n*2187+856] = + s[370];
gout[n*2187+857] = + s[371];
gout[n*2187+858] = + s[372];
gout[n*2187+859] = + s[373];
gout[n*2187+860] = + s[374];
gout[n*2187+861] = + s[375];
gout[n*2187+862] = + s[376];
gout[n*2187+863] = + s[377];
gout[n*2187+864] = + s[378];
gout[n*2187+865] = + s[379];
gout[n*2187+866] = + s[380];
gout[n*2187+867] = + s[381];
gout[n*2187+868] = + s[382];
gout[n*2187+869] = + s[383];
gout[n*2187+870] = + s[384];
gout[n*2187+871] = + s[385];
gout[n*2187+872] = + s[386];
gout[n*2187+873] = + s[387];
gout[n*2187+874] = + s[388];
gout[n*2187+875] = + s[389];
gout[n*2187+876] = + s[390];
gout[n*2187+877] = + s[391];
gout[n*2187+878] = + s[392];
gout[n*2187+879] = + s[393];
gout[n*2187+880] = + s[394];
gout[n*2187+881] = + s[395];
gout[n*2187+882] = + s[396];
gout[n*2187+883] = + s[397];
gout[n*2187+884] = + s[398];
gout[n*2187+885] = + s[399];
gout[n*2187+886] = + s[400];
gout[n*2187+887] = + s[401];
gout[n*2187+888] = + s[402];
gout[n*2187+889] = + s[403];
gout[n*2187+890] = + s[404];
gout[n*2187+891] = + s[405];
gout[n*2187+892] = + s[406];
gout[n*2187+893] = + s[407];
gout[n*2187+894] = + s[408];
gout[n*2187+895] = + s[409];
gout[n*2187+896] = + s[410];
gout[n*2187+897] = + s[411];
gout[n*2187+898] = + s[412];
gout[n*2187+899] = + s[413];
gout[n*2187+900] = + s[414];
gout[n*2187+901] = + s[415];
gout[n*2187+902] = + s[416];
gout[n*2187+903] = + s[417];
gout[n*2187+904] = + s[418];
gout[n*2187+905] = + s[419];
gout[n*2187+906] = + s[420];
gout[n*2187+907] = + s[421];
gout[n*2187+908] = + s[422];
gout[n*2187+909] = + s[423];
gout[n*2187+910] = + s[424];
gout[n*2187+911] = + s[425];
gout[n*2187+912] = + s[426];
gout[n*2187+913] = + s[427];
gout[n*2187+914] = + s[428];
gout[n*2187+915] = + s[429];
gout[n*2187+916] = + s[430];
gout[n*2187+917] = + s[431];
gout[n*2187+918] = + s[432];
gout[n*2187+919] = + s[433];
gout[n*2187+920] = + s[434];
gout[n*2187+921] = + s[435];
gout[n*2187+922] = + s[436];
gout[n*2187+923] = + s[437];
gout[n*2187+924] = + s[438];
gout[n*2187+925] = + s[439];
gout[n*2187+926] = + s[440];
gout[n*2187+927] = + s[441];
gout[n*2187+928] = + s[442];
gout[n*2187+929] = + s[443];
gout[n*2187+930] = + s[444];
gout[n*2187+931] = + s[445];
gout[n*2187+932] = + s[446];
gout[n*2187+933] = + s[447];
gout[n*2187+934] = + s[448];
gout[n*2187+935] = + s[449];
gout[n*2187+936] = + s[450];
gout[n*2187+937] = + s[451];
gout[n*2187+938] = + s[452];
gout[n*2187+939] = + s[453];
gout[n*2187+940] = + s[454];
gout[n*2187+941] = + s[455];
gout[n*2187+942] = + s[456];
gout[n*2187+943] = + s[457];
gout[n*2187+944] = + s[458];
gout[n*2187+945] = + s[459];
gout[n*2187+946] = + s[460];
gout[n*2187+947] = + s[461];
gout[n*2187+948] = + s[462];
gout[n*2187+949] = + s[463];
gout[n*2187+950] = + s[464];
gout[n*2187+951] = + s[465];
gout[n*2187+952] = + s[466];
gout[n*2187+953] = + s[467];
gout[n*2187+954] = + s[468];
gout[n*2187+955] = + s[469];
gout[n*2187+956] = + s[470];
gout[n*2187+957] = + s[471];
gout[n*2187+958] = + s[472];
gout[n*2187+959] = + s[473];
gout[n*2187+960] = + s[474];
gout[n*2187+961] = + s[475];
gout[n*2187+962] = + s[476];
gout[n*2187+963] = + s[477];
gout[n*2187+964] = + s[478];
gout[n*2187+965] = + s[479];
gout[n*2187+966] = + s[480];
gout[n*2187+967] = + s[481];
gout[n*2187+968] = + s[482];
gout[n*2187+969] = + s[483];
gout[n*2187+970] = + s[484];
gout[n*2187+971] = + s[485];
gout[n*2187+972] = + s[972];
gout[n*2187+973] = + s[973];
gout[n*2187+974] = + s[974];
gout[n*2187+975] = + s[975];
gout[n*2187+976] = + s[976];
gout[n*2187+977] = + s[977];
gout[n*2187+978] = + s[978];
gout[n*2187+979] = + s[979];
gout[n*2187+980] = + s[980];
gout[n*2187+981] = + s[981];
gout[n*2187+982] = + s[982];
gout[n*2187+983] = + s[983];
gout[n*2187+984] = + s[984];
gout[n*2187+985] = + s[985];
gout[n*2187+986] = + s[986];
gout[n*2187+987] = + s[987];
gout[n*2187+988] = + s[988];
gout[n*2187+989] = + s[989];
gout[n*2187+990] = + s[990];
gout[n*2187+991] = + s[991];
gout[n*2187+992] = + s[992];
gout[n*2187+993] = + s[993];
gout[n*2187+994] = + s[994];
gout[n*2187+995] = + s[995];
gout[n*2187+996] = + s[996];
gout[n*2187+997] = + s[997];
gout[n*2187+998] = + s[998];
gout[n*2187+999] = + s[999];
gout[n*2187+1000] = + s[1000];
gout[n*2187+1001] = + s[1001];
gout[n*2187+1002] = + s[1002];
gout[n*2187+1003] = + s[1003];
gout[n*2187+1004] = + s[1004];
gout[n*2187+1005] = + s[1005];
gout[n*2187+1006] = + s[1006];
gout[n*2187+1007] = + s[1007];
gout[n*2187+1008] = + s[1008];
gout[n*2187+1009] = + s[1009];
gout[n*2187+1010] = + s[1010];
gout[n*2187+1011] = + s[1011];
gout[n*2187+1012] = + s[1012];
gout[n*2187+1013] = + s[1013];
gout[n*2187+1014] = + s[1014];
gout[n*2187+1015] = + s[1015];
gout[n*2187+1016] = + s[1016];
gout[n*2187+1017] = + s[1017];
gout[n*2187+1018] = + s[1018];
gout[n*2187+1019] = + s[1019];
gout[n*2187+1020] = + s[1020];
gout[n*2187+1021] = + s[1021];
gout[n*2187+1022] = + s[1022];
gout[n*2187+1023] = + s[1023];
gout[n*2187+1024] = + s[1024];
gout[n*2187+1025] = + s[1025];
gout[n*2187+1026] = + s[1026];
gout[n*2187+1027] = + s[1027];
gout[n*2187+1028] = + s[1028];
gout[n*2187+1029] = + s[1029];
gout[n*2187+1030] = + s[1030];
gout[n*2187+1031] = + s[1031];
gout[n*2187+1032] = + s[1032];
gout[n*2187+1033] = + s[1033];
gout[n*2187+1034] = + s[1034];
gout[n*2187+1035] = + s[1035];
gout[n*2187+1036] = + s[1036];
gout[n*2187+1037] = + s[1037];
gout[n*2187+1038] = + s[1038];
gout[n*2187+1039] = + s[1039];
gout[n*2187+1040] = + s[1040];
gout[n*2187+1041] = + s[1041];
gout[n*2187+1042] = + s[1042];
gout[n*2187+1043] = + s[1043];
gout[n*2187+1044] = + s[1044];
gout[n*2187+1045] = + s[1045];
gout[n*2187+1046] = + s[1046];
gout[n*2187+1047] = + s[1047];
gout[n*2187+1048] = + s[1048];
gout[n*2187+1049] = + s[1049];
gout[n*2187+1050] = + s[1050];
gout[n*2187+1051] = + s[1051];
gout[n*2187+1052] = + s[1052];
gout[n*2187+1053] = + s[1053];
gout[n*2187+1054] = + s[1054];
gout[n*2187+1055] = + s[1055];
gout[n*2187+1056] = + s[1056];
gout[n*2187+1057] = + s[1057];
gout[n*2187+1058] = + s[1058];
gout[n*2187+1059] = + s[1059];
gout[n*2187+1060] = + s[1060];
gout[n*2187+1061] = + s[1061];
gout[n*2187+1062] = + s[1062];
gout[n*2187+1063] = + s[1063];
gout[n*2187+1064] = + s[1064];
gout[n*2187+1065] = + s[1065];
gout[n*2187+1066] = + s[1066];
gout[n*2187+1067] = + s[1067];
gout[n*2187+1068] = + s[1068];
gout[n*2187+1069] = + s[1069];
gout[n*2187+1070] = + s[1070];
gout[n*2187+1071] = + s[1071];
gout[n*2187+1072] = + s[1072];
gout[n*2187+1073] = + s[1073];
gout[n*2187+1074] = + s[1074];
gout[n*2187+1075] = + s[1075];
gout[n*2187+1076] = + s[1076];
gout[n*2187+1077] = + s[1077];
gout[n*2187+1078] = + s[1078];
gout[n*2187+1079] = + s[1079];
gout[n*2187+1080] = + s[1080];
gout[n*2187+1081] = + s[1081];
gout[n*2187+1082] = + s[1082];
gout[n*2187+1083] = + s[1083];
gout[n*2187+1084] = + s[1084];
gout[n*2187+1085] = + s[1085];
gout[n*2187+1086] = + s[1086];
gout[n*2187+1087] = + s[1087];
gout[n*2187+1088] = + s[1088];
gout[n*2187+1089] = + s[1089];
gout[n*2187+1090] = + s[1090];
gout[n*2187+1091] = + s[1091];
gout[n*2187+1092] = + s[1092];
gout[n*2187+1093] = + s[1093];
gout[n*2187+1094] = + s[1094];
gout[n*2187+1095] = + s[1095];
gout[n*2187+1096] = + s[1096];
gout[n*2187+1097] = + s[1097];
gout[n*2187+1098] = + s[1098];
gout[n*2187+1099] = + s[1099];
gout[n*2187+1100] = + s[1100];
gout[n*2187+1101] = + s[1101];
gout[n*2187+1102] = + s[1102];
gout[n*2187+1103] = + s[1103];
gout[n*2187+1104] = + s[1104];
gout[n*2187+1105] = + s[1105];
gout[n*2187+1106] = + s[1106];
gout[n*2187+1107] = + s[1107];
gout[n*2187+1108] = + s[1108];
gout[n*2187+1109] = + s[1109];
gout[n*2187+1110] = + s[1110];
gout[n*2187+1111] = + s[1111];
gout[n*2187+1112] = + s[1112];
gout[n*2187+1113] = + s[1113];
gout[n*2187+1114] = + s[1114];
gout[n*2187+1115] = + s[1115];
gout[n*2187+1116] = + s[1116];
gout[n*2187+1117] = + s[1117];
gout[n*2187+1118] = + s[1118];
gout[n*2187+1119] = + s[1119];
gout[n*2187+1120] = + s[1120];
gout[n*2187+1121] = + s[1121];
gout[n*2187+1122] = + s[1122];
gout[n*2187+1123] = + s[1123];
gout[n*2187+1124] = + s[1124];
gout[n*2187+1125] = + s[1125];
gout[n*2187+1126] = + s[1126];
gout[n*2187+1127] = + s[1127];
gout[n*2187+1128] = + s[1128];
gout[n*2187+1129] = + s[1129];
gout[n*2187+1130] = + s[1130];
gout[n*2187+1131] = + s[1131];
gout[n*2187+1132] = + s[1132];
gout[n*2187+1133] = + s[1133];
gout[n*2187+1134] = + s[1134];
gout[n*2187+1135] = + s[1135];
gout[n*2187+1136] = + s[1136];
gout[n*2187+1137] = + s[1137];
gout[n*2187+1138] = + s[1138];
gout[n*2187+1139] = + s[1139];
gout[n*2187+1140] = + s[1140];
gout[n*2187+1141] = + s[1141];
gout[n*2187+1142] = + s[1142];
gout[n*2187+1143] = + s[1143];
gout[n*2187+1144] = + s[1144];
gout[n*2187+1145] = + s[1145];
gout[n*2187+1146] = + s[1146];
gout[n*2187+1147] = + s[1147];
gout[n*2187+1148] = + s[1148];
gout[n*2187+1149] = + s[1149];
gout[n*2187+1150] = + s[1150];
gout[n*2187+1151] = + s[1151];
gout[n*2187+1152] = + s[1152];
gout[n*2187+1153] = + s[1153];
gout[n*2187+1154] = + s[1154];
gout[n*2187+1155] = + s[1155];
gout[n*2187+1156] = + s[1156];
gout[n*2187+1157] = + s[1157];
gout[n*2187+1158] = + s[1158];
gout[n*2187+1159] = + s[1159];
gout[n*2187+1160] = + s[1160];
gout[n*2187+1161] = + s[1161];
gout[n*2187+1162] = + s[1162];
gout[n*2187+1163] = + s[1163];
gout[n*2187+1164] = + s[1164];
gout[n*2187+1165] = + s[1165];
gout[n*2187+1166] = + s[1166];
gout[n*2187+1167] = + s[1167];
gout[n*2187+1168] = + s[1168];
gout[n*2187+1169] = + s[1169];
gout[n*2187+1170] = + s[1170];
gout[n*2187+1171] = + s[1171];
gout[n*2187+1172] = + s[1172];
gout[n*2187+1173] = + s[1173];
gout[n*2187+1174] = + s[1174];
gout[n*2187+1175] = + s[1175];
gout[n*2187+1176] = + s[1176];
gout[n*2187+1177] = + s[1177];
gout[n*2187+1178] = + s[1178];
gout[n*2187+1179] = + s[1179];
gout[n*2187+1180] = + s[1180];
gout[n*2187+1181] = + s[1181];
gout[n*2187+1182] = + s[1182];
gout[n*2187+1183] = + s[1183];
gout[n*2187+1184] = + s[1184];
gout[n*2187+1185] = + s[1185];
gout[n*2187+1186] = + s[1186];
gout[n*2187+1187] = + s[1187];
gout[n*2187+1188] = + s[1188];
gout[n*2187+1189] = + s[1189];
gout[n*2187+1190] = + s[1190];
gout[n*2187+1191] = + s[1191];
gout[n*2187+1192] = + s[1192];
gout[n*2187+1193] = + s[1193];
gout[n*2187+1194] = + s[1194];
gout[n*2187+1195] = + s[1195];
gout[n*2187+1196] = + s[1196];
gout[n*2187+1197] = + s[1197];
gout[n*2187+1198] = + s[1198];
gout[n*2187+1199] = + s[1199];
gout[n*2187+1200] = + s[1200];
gout[n*2187+1201] = + s[1201];
gout[n*2187+1202] = + s[1202];
gout[n*2187+1203] = + s[1203];
gout[n*2187+1204] = + s[1204];
gout[n*2187+1205] = + s[1205];
gout[n*2187+1206] = + s[1206];
gout[n*2187+1207] = + s[1207];
gout[n*2187+1208] = + s[1208];
gout[n*2187+1209] = + s[1209];
gout[n*2187+1210] = + s[1210];
gout[n*2187+1211] = + s[1211];
gout[n*2187+1212] = + s[1212];
gout[n*2187+1213] = + s[1213];
gout[n*2187+1214] = + s[1214];
gout[n*2187+1215] = + s[1701];
gout[n*2187+1216] = + s[1702];
gout[n*2187+1217] = + s[1703];
gout[n*2187+1218] = + s[1704];
gout[n*2187+1219] = + s[1705];
gout[n*2187+1220] = + s[1706];
gout[n*2187+1221] = + s[1707];
gout[n*2187+1222] = + s[1708];
gout[n*2187+1223] = + s[1709];
gout[n*2187+1224] = + s[1710];
gout[n*2187+1225] = + s[1711];
gout[n*2187+1226] = + s[1712];
gout[n*2187+1227] = + s[1713];
gout[n*2187+1228] = + s[1714];
gout[n*2187+1229] = + s[1715];
gout[n*2187+1230] = + s[1716];
gout[n*2187+1231] = + s[1717];
gout[n*2187+1232] = + s[1718];
gout[n*2187+1233] = + s[1719];
gout[n*2187+1234] = + s[1720];
gout[n*2187+1235] = + s[1721];
gout[n*2187+1236] = + s[1722];
gout[n*2187+1237] = + s[1723];
gout[n*2187+1238] = + s[1724];
gout[n*2187+1239] = + s[1725];
gout[n*2187+1240] = + s[1726];
gout[n*2187+1241] = + s[1727];
gout[n*2187+1242] = + s[1728];
gout[n*2187+1243] = + s[1729];
gout[n*2187+1244] = + s[1730];
gout[n*2187+1245] = + s[1731];
gout[n*2187+1246] = + s[1732];
gout[n*2187+1247] = + s[1733];
gout[n*2187+1248] = + s[1734];
gout[n*2187+1249] = + s[1735];
gout[n*2187+1250] = + s[1736];
gout[n*2187+1251] = + s[1737];
gout[n*2187+1252] = + s[1738];
gout[n*2187+1253] = + s[1739];
gout[n*2187+1254] = + s[1740];
gout[n*2187+1255] = + s[1741];
gout[n*2187+1256] = + s[1742];
gout[n*2187+1257] = + s[1743];
gout[n*2187+1258] = + s[1744];
gout[n*2187+1259] = + s[1745];
gout[n*2187+1260] = + s[1746];
gout[n*2187+1261] = + s[1747];
gout[n*2187+1262] = + s[1748];
gout[n*2187+1263] = + s[1749];
gout[n*2187+1264] = + s[1750];
gout[n*2187+1265] = + s[1751];
gout[n*2187+1266] = + s[1752];
gout[n*2187+1267] = + s[1753];
gout[n*2187+1268] = + s[1754];
gout[n*2187+1269] = + s[1755];
gout[n*2187+1270] = + s[1756];
gout[n*2187+1271] = + s[1757];
gout[n*2187+1272] = + s[1758];
gout[n*2187+1273] = + s[1759];
gout[n*2187+1274] = + s[1760];
gout[n*2187+1275] = + s[1761];
gout[n*2187+1276] = + s[1762];
gout[n*2187+1277] = + s[1763];
gout[n*2187+1278] = + s[1764];
gout[n*2187+1279] = + s[1765];
gout[n*2187+1280] = + s[1766];
gout[n*2187+1281] = + s[1767];
gout[n*2187+1282] = + s[1768];
gout[n*2187+1283] = + s[1769];
gout[n*2187+1284] = + s[1770];
gout[n*2187+1285] = + s[1771];
gout[n*2187+1286] = + s[1772];
gout[n*2187+1287] = + s[1773];
gout[n*2187+1288] = + s[1774];
gout[n*2187+1289] = + s[1775];
gout[n*2187+1290] = + s[1776];
gout[n*2187+1291] = + s[1777];
gout[n*2187+1292] = + s[1778];
gout[n*2187+1293] = + s[1779];
gout[n*2187+1294] = + s[1780];
gout[n*2187+1295] = + s[1781];
gout[n*2187+1296] = + s[1782];
gout[n*2187+1297] = + s[1783];
gout[n*2187+1298] = + s[1784];
gout[n*2187+1299] = + s[1785];
gout[n*2187+1300] = + s[1786];
gout[n*2187+1301] = + s[1787];
gout[n*2187+1302] = + s[1788];
gout[n*2187+1303] = + s[1789];
gout[n*2187+1304] = + s[1790];
gout[n*2187+1305] = + s[1791];
gout[n*2187+1306] = + s[1792];
gout[n*2187+1307] = + s[1793];
gout[n*2187+1308] = + s[1794];
gout[n*2187+1309] = + s[1795];
gout[n*2187+1310] = + s[1796];
gout[n*2187+1311] = + s[1797];
gout[n*2187+1312] = + s[1798];
gout[n*2187+1313] = + s[1799];
gout[n*2187+1314] = + s[1800];
gout[n*2187+1315] = + s[1801];
gout[n*2187+1316] = + s[1802];
gout[n*2187+1317] = + s[1803];
gout[n*2187+1318] = + s[1804];
gout[n*2187+1319] = + s[1805];
gout[n*2187+1320] = + s[1806];
gout[n*2187+1321] = + s[1807];
gout[n*2187+1322] = + s[1808];
gout[n*2187+1323] = + s[1809];
gout[n*2187+1324] = + s[1810];
gout[n*2187+1325] = + s[1811];
gout[n*2187+1326] = + s[1812];
gout[n*2187+1327] = + s[1813];
gout[n*2187+1328] = + s[1814];
gout[n*2187+1329] = + s[1815];
gout[n*2187+1330] = + s[1816];
gout[n*2187+1331] = + s[1817];
gout[n*2187+1332] = + s[1818];
gout[n*2187+1333] = + s[1819];
gout[n*2187+1334] = + s[1820];
gout[n*2187+1335] = + s[1821];
gout[n*2187+1336] = + s[1822];
gout[n*2187+1337] = + s[1823];
gout[n*2187+1338] = + s[1824];
gout[n*2187+1339] = + s[1825];
gout[n*2187+1340] = + s[1826];
gout[n*2187+1341] = + s[1827];
gout[n*2187+1342] = + s[1828];
gout[n*2187+1343] = + s[1829];
gout[n*2187+1344] = + s[1830];
gout[n*2187+1345] = + s[1831];
gout[n*2187+1346] = + s[1832];
gout[n*2187+1347] = + s[1833];
gout[n*2187+1348] = + s[1834];
gout[n*2187+1349] = + s[1835];
gout[n*2187+1350] = + s[1836];
gout[n*2187+1351] = + s[1837];
gout[n*2187+1352] = + s[1838];
gout[n*2187+1353] = + s[1839];
gout[n*2187+1354] = + s[1840];
gout[n*2187+1355] = + s[1841];
gout[n*2187+1356] = + s[1842];
gout[n*2187+1357] = + s[1843];
gout[n*2187+1358] = + s[1844];
gout[n*2187+1359] = + s[1845];
gout[n*2187+1360] = + s[1846];
gout[n*2187+1361] = + s[1847];
gout[n*2187+1362] = + s[1848];
gout[n*2187+1363] = + s[1849];
gout[n*2187+1364] = + s[1850];
gout[n*2187+1365] = + s[1851];
gout[n*2187+1366] = + s[1852];
gout[n*2187+1367] = + s[1853];
gout[n*2187+1368] = + s[1854];
gout[n*2187+1369] = + s[1855];
gout[n*2187+1370] = + s[1856];
gout[n*2187+1371] = + s[1857];
gout[n*2187+1372] = + s[1858];
gout[n*2187+1373] = + s[1859];
gout[n*2187+1374] = + s[1860];
gout[n*2187+1375] = + s[1861];
gout[n*2187+1376] = + s[1862];
gout[n*2187+1377] = + s[1863];
gout[n*2187+1378] = + s[1864];
gout[n*2187+1379] = + s[1865];
gout[n*2187+1380] = + s[1866];
gout[n*2187+1381] = + s[1867];
gout[n*2187+1382] = + s[1868];
gout[n*2187+1383] = + s[1869];
gout[n*2187+1384] = + s[1870];
gout[n*2187+1385] = + s[1871];
gout[n*2187+1386] = + s[1872];
gout[n*2187+1387] = + s[1873];
gout[n*2187+1388] = + s[1874];
gout[n*2187+1389] = + s[1875];
gout[n*2187+1390] = + s[1876];
gout[n*2187+1391] = + s[1877];
gout[n*2187+1392] = + s[1878];
gout[n*2187+1393] = + s[1879];
gout[n*2187+1394] = + s[1880];
gout[n*2187+1395] = + s[1881];
gout[n*2187+1396] = + s[1882];
gout[n*2187+1397] = + s[1883];
gout[n*2187+1398] = + s[1884];
gout[n*2187+1399] = + s[1885];
gout[n*2187+1400] = + s[1886];
gout[n*2187+1401] = + s[1887];
gout[n*2187+1402] = + s[1888];
gout[n*2187+1403] = + s[1889];
gout[n*2187+1404] = + s[1890];
gout[n*2187+1405] = + s[1891];
gout[n*2187+1406] = + s[1892];
gout[n*2187+1407] = + s[1893];
gout[n*2187+1408] = + s[1894];
gout[n*2187+1409] = + s[1895];
gout[n*2187+1410] = + s[1896];
gout[n*2187+1411] = + s[1897];
gout[n*2187+1412] = + s[1898];
gout[n*2187+1413] = + s[1899];
gout[n*2187+1414] = + s[1900];
gout[n*2187+1415] = + s[1901];
gout[n*2187+1416] = + s[1902];
gout[n*2187+1417] = + s[1903];
gout[n*2187+1418] = + s[1904];
gout[n*2187+1419] = + s[1905];
gout[n*2187+1420] = + s[1906];
gout[n*2187+1421] = + s[1907];
gout[n*2187+1422] = + s[1908];
gout[n*2187+1423] = + s[1909];
gout[n*2187+1424] = + s[1910];
gout[n*2187+1425] = + s[1911];
gout[n*2187+1426] = + s[1912];
gout[n*2187+1427] = + s[1913];
gout[n*2187+1428] = + s[1914];
gout[n*2187+1429] = + s[1915];
gout[n*2187+1430] = + s[1916];
gout[n*2187+1431] = + s[1917];
gout[n*2187+1432] = + s[1918];
gout[n*2187+1433] = + s[1919];
gout[n*2187+1434] = + s[1920];
gout[n*2187+1435] = + s[1921];
gout[n*2187+1436] = + s[1922];
gout[n*2187+1437] = + s[1923];
gout[n*2187+1438] = + s[1924];
gout[n*2187+1439] = + s[1925];
gout[n*2187+1440] = + s[1926];
gout[n*2187+1441] = + s[1927];
gout[n*2187+1442] = + s[1928];
gout[n*2187+1443] = + s[1929];
gout[n*2187+1444] = + s[1930];
gout[n*2187+1445] = + s[1931];
gout[n*2187+1446] = + s[1932];
gout[n*2187+1447] = + s[1933];
gout[n*2187+1448] = + s[1934];
gout[n*2187+1449] = + s[1935];
gout[n*2187+1450] = + s[1936];
gout[n*2187+1451] = + s[1937];
gout[n*2187+1452] = + s[1938];
gout[n*2187+1453] = + s[1939];
gout[n*2187+1454] = + s[1940];
gout[n*2187+1455] = + s[1941];
gout[n*2187+1456] = + s[1942];
gout[n*2187+1457] = + s[1943];
gout[n*2187+1458] = + s[486];
gout[n*2187+1459] = + s[487];
gout[n*2187+1460] = + s[488];
gout[n*2187+1461] = + s[489];
gout[n*2187+1462] = + s[490];
gout[n*2187+1463] = + s[491];
gout[n*2187+1464] = + s[492];
gout[n*2187+1465] = + s[493];
gout[n*2187+1466] = + s[494];
gout[n*2187+1467] = + s[495];
gout[n*2187+1468] = + s[496];
gout[n*2187+1469] = + s[497];
gout[n*2187+1470] = + s[498];
gout[n*2187+1471] = + s[499];
gout[n*2187+1472] = + s[500];
gout[n*2187+1473] = + s[501];
gout[n*2187+1474] = + s[502];
gout[n*2187+1475] = + s[503];
gout[n*2187+1476] = + s[504];
gout[n*2187+1477] = + s[505];
gout[n*2187+1478] = + s[506];
gout[n*2187+1479] = + s[507];
gout[n*2187+1480] = + s[508];
gout[n*2187+1481] = + s[509];
gout[n*2187+1482] = + s[510];
gout[n*2187+1483] = + s[511];
gout[n*2187+1484] = + s[512];
gout[n*2187+1485] = + s[513];
gout[n*2187+1486] = + s[514];
gout[n*2187+1487] = + s[515];
gout[n*2187+1488] = + s[516];
gout[n*2187+1489] = + s[517];
gout[n*2187+1490] = + s[518];
gout[n*2187+1491] = + s[519];
gout[n*2187+1492] = + s[520];
gout[n*2187+1493] = + s[521];
gout[n*2187+1494] = + s[522];
gout[n*2187+1495] = + s[523];
gout[n*2187+1496] = + s[524];
gout[n*2187+1497] = + s[525];
gout[n*2187+1498] = + s[526];
gout[n*2187+1499] = + s[527];
gout[n*2187+1500] = + s[528];
gout[n*2187+1501] = + s[529];
gout[n*2187+1502] = + s[530];
gout[n*2187+1503] = + s[531];
gout[n*2187+1504] = + s[532];
gout[n*2187+1505] = + s[533];
gout[n*2187+1506] = + s[534];
gout[n*2187+1507] = + s[535];
gout[n*2187+1508] = + s[536];
gout[n*2187+1509] = + s[537];
gout[n*2187+1510] = + s[538];
gout[n*2187+1511] = + s[539];
gout[n*2187+1512] = + s[540];
gout[n*2187+1513] = + s[541];
gout[n*2187+1514] = + s[542];
gout[n*2187+1515] = + s[543];
gout[n*2187+1516] = + s[544];
gout[n*2187+1517] = + s[545];
gout[n*2187+1518] = + s[546];
gout[n*2187+1519] = + s[547];
gout[n*2187+1520] = + s[548];
gout[n*2187+1521] = + s[549];
gout[n*2187+1522] = + s[550];
gout[n*2187+1523] = + s[551];
gout[n*2187+1524] = + s[552];
gout[n*2187+1525] = + s[553];
gout[n*2187+1526] = + s[554];
gout[n*2187+1527] = + s[555];
gout[n*2187+1528] = + s[556];
gout[n*2187+1529] = + s[557];
gout[n*2187+1530] = + s[558];
gout[n*2187+1531] = + s[559];
gout[n*2187+1532] = + s[560];
gout[n*2187+1533] = + s[561];
gout[n*2187+1534] = + s[562];
gout[n*2187+1535] = + s[563];
gout[n*2187+1536] = + s[564];
gout[n*2187+1537] = + s[565];
gout[n*2187+1538] = + s[566];
gout[n*2187+1539] = + s[567];
gout[n*2187+1540] = + s[568];
gout[n*2187+1541] = + s[569];
gout[n*2187+1542] = + s[570];
gout[n*2187+1543] = + s[571];
gout[n*2187+1544] = + s[572];
gout[n*2187+1545] = + s[573];
gout[n*2187+1546] = + s[574];
gout[n*2187+1547] = + s[575];
gout[n*2187+1548] = + s[576];
gout[n*2187+1549] = + s[577];
gout[n*2187+1550] = + s[578];
gout[n*2187+1551] = + s[579];
gout[n*2187+1552] = + s[580];
gout[n*2187+1553] = + s[581];
gout[n*2187+1554] = + s[582];
gout[n*2187+1555] = + s[583];
gout[n*2187+1556] = + s[584];
gout[n*2187+1557] = + s[585];
gout[n*2187+1558] = + s[586];
gout[n*2187+1559] = + s[587];
gout[n*2187+1560] = + s[588];
gout[n*2187+1561] = + s[589];
gout[n*2187+1562] = + s[590];
gout[n*2187+1563] = + s[591];
gout[n*2187+1564] = + s[592];
gout[n*2187+1565] = + s[593];
gout[n*2187+1566] = + s[594];
gout[n*2187+1567] = + s[595];
gout[n*2187+1568] = + s[596];
gout[n*2187+1569] = + s[597];
gout[n*2187+1570] = + s[598];
gout[n*2187+1571] = + s[599];
gout[n*2187+1572] = + s[600];
gout[n*2187+1573] = + s[601];
gout[n*2187+1574] = + s[602];
gout[n*2187+1575] = + s[603];
gout[n*2187+1576] = + s[604];
gout[n*2187+1577] = + s[605];
gout[n*2187+1578] = + s[606];
gout[n*2187+1579] = + s[607];
gout[n*2187+1580] = + s[608];
gout[n*2187+1581] = + s[609];
gout[n*2187+1582] = + s[610];
gout[n*2187+1583] = + s[611];
gout[n*2187+1584] = + s[612];
gout[n*2187+1585] = + s[613];
gout[n*2187+1586] = + s[614];
gout[n*2187+1587] = + s[615];
gout[n*2187+1588] = + s[616];
gout[n*2187+1589] = + s[617];
gout[n*2187+1590] = + s[618];
gout[n*2187+1591] = + s[619];
gout[n*2187+1592] = + s[620];
gout[n*2187+1593] = + s[621];
gout[n*2187+1594] = + s[622];
gout[n*2187+1595] = + s[623];
gout[n*2187+1596] = + s[624];
gout[n*2187+1597] = + s[625];
gout[n*2187+1598] = + s[626];
gout[n*2187+1599] = + s[627];
gout[n*2187+1600] = + s[628];
gout[n*2187+1601] = + s[629];
gout[n*2187+1602] = + s[630];
gout[n*2187+1603] = + s[631];
gout[n*2187+1604] = + s[632];
gout[n*2187+1605] = + s[633];
gout[n*2187+1606] = + s[634];
gout[n*2187+1607] = + s[635];
gout[n*2187+1608] = + s[636];
gout[n*2187+1609] = + s[637];
gout[n*2187+1610] = + s[638];
gout[n*2187+1611] = + s[639];
gout[n*2187+1612] = + s[640];
gout[n*2187+1613] = + s[641];
gout[n*2187+1614] = + s[642];
gout[n*2187+1615] = + s[643];
gout[n*2187+1616] = + s[644];
gout[n*2187+1617] = + s[645];
gout[n*2187+1618] = + s[646];
gout[n*2187+1619] = + s[647];
gout[n*2187+1620] = + s[648];
gout[n*2187+1621] = + s[649];
gout[n*2187+1622] = + s[650];
gout[n*2187+1623] = + s[651];
gout[n*2187+1624] = + s[652];
gout[n*2187+1625] = + s[653];
gout[n*2187+1626] = + s[654];
gout[n*2187+1627] = + s[655];
gout[n*2187+1628] = + s[656];
gout[n*2187+1629] = + s[657];
gout[n*2187+1630] = + s[658];
gout[n*2187+1631] = + s[659];
gout[n*2187+1632] = + s[660];
gout[n*2187+1633] = + s[661];
gout[n*2187+1634] = + s[662];
gout[n*2187+1635] = + s[663];
gout[n*2187+1636] = + s[664];
gout[n*2187+1637] = + s[665];
gout[n*2187+1638] = + s[666];
gout[n*2187+1639] = + s[667];
gout[n*2187+1640] = + s[668];
gout[n*2187+1641] = + s[669];
gout[n*2187+1642] = + s[670];
gout[n*2187+1643] = + s[671];
gout[n*2187+1644] = + s[672];
gout[n*2187+1645] = + s[673];
gout[n*2187+1646] = + s[674];
gout[n*2187+1647] = + s[675];
gout[n*2187+1648] = + s[676];
gout[n*2187+1649] = + s[677];
gout[n*2187+1650] = + s[678];
gout[n*2187+1651] = + s[679];
gout[n*2187+1652] = + s[680];
gout[n*2187+1653] = + s[681];
gout[n*2187+1654] = + s[682];
gout[n*2187+1655] = + s[683];
gout[n*2187+1656] = + s[684];
gout[n*2187+1657] = + s[685];
gout[n*2187+1658] = + s[686];
gout[n*2187+1659] = + s[687];
gout[n*2187+1660] = + s[688];
gout[n*2187+1661] = + s[689];
gout[n*2187+1662] = + s[690];
gout[n*2187+1663] = + s[691];
gout[n*2187+1664] = + s[692];
gout[n*2187+1665] = + s[693];
gout[n*2187+1666] = + s[694];
gout[n*2187+1667] = + s[695];
gout[n*2187+1668] = + s[696];
gout[n*2187+1669] = + s[697];
gout[n*2187+1670] = + s[698];
gout[n*2187+1671] = + s[699];
gout[n*2187+1672] = + s[700];
gout[n*2187+1673] = + s[701];
gout[n*2187+1674] = + s[702];
gout[n*2187+1675] = + s[703];
gout[n*2187+1676] = + s[704];
gout[n*2187+1677] = + s[705];
gout[n*2187+1678] = + s[706];
gout[n*2187+1679] = + s[707];
gout[n*2187+1680] = + s[708];
gout[n*2187+1681] = + s[709];
gout[n*2187+1682] = + s[710];
gout[n*2187+1683] = + s[711];
gout[n*2187+1684] = + s[712];
gout[n*2187+1685] = + s[713];
gout[n*2187+1686] = + s[714];
gout[n*2187+1687] = + s[715];
gout[n*2187+1688] = + s[716];
gout[n*2187+1689] = + s[717];
gout[n*2187+1690] = + s[718];
gout[n*2187+1691] = + s[719];
gout[n*2187+1692] = + s[720];
gout[n*2187+1693] = + s[721];
gout[n*2187+1694] = + s[722];
gout[n*2187+1695] = + s[723];
gout[n*2187+1696] = + s[724];
gout[n*2187+1697] = + s[725];
gout[n*2187+1698] = + s[726];
gout[n*2187+1699] = + s[727];
gout[n*2187+1700] = + s[728];
gout[n*2187+1701] = + s[1215];
gout[n*2187+1702] = + s[1216];
gout[n*2187+1703] = + s[1217];
gout[n*2187+1704] = + s[1218];
gout[n*2187+1705] = + s[1219];
gout[n*2187+1706] = + s[1220];
gout[n*2187+1707] = + s[1221];
gout[n*2187+1708] = + s[1222];
gout[n*2187+1709] = + s[1223];
gout[n*2187+1710] = + s[1224];
gout[n*2187+1711] = + s[1225];
gout[n*2187+1712] = + s[1226];
gout[n*2187+1713] = + s[1227];
gout[n*2187+1714] = + s[1228];
gout[n*2187+1715] = + s[1229];
gout[n*2187+1716] = + s[1230];
gout[n*2187+1717] = + s[1231];
gout[n*2187+1718] = + s[1232];
gout[n*2187+1719] = + s[1233];
gout[n*2187+1720] = + s[1234];
gout[n*2187+1721] = + s[1235];
gout[n*2187+1722] = + s[1236];
gout[n*2187+1723] = + s[1237];
gout[n*2187+1724] = + s[1238];
gout[n*2187+1725] = + s[1239];
gout[n*2187+1726] = + s[1240];
gout[n*2187+1727] = + s[1241];
gout[n*2187+1728] = + s[1242];
gout[n*2187+1729] = + s[1243];
gout[n*2187+1730] = + s[1244];
gout[n*2187+1731] = + s[1245];
gout[n*2187+1732] = + s[1246];
gout[n*2187+1733] = + s[1247];
gout[n*2187+1734] = + s[1248];
gout[n*2187+1735] = + s[1249];
gout[n*2187+1736] = + s[1250];
gout[n*2187+1737] = + s[1251];
gout[n*2187+1738] = + s[1252];
gout[n*2187+1739] = + s[1253];
gout[n*2187+1740] = + s[1254];
gout[n*2187+1741] = + s[1255];
gout[n*2187+1742] = + s[1256];
gout[n*2187+1743] = + s[1257];
gout[n*2187+1744] = + s[1258];
gout[n*2187+1745] = + s[1259];
gout[n*2187+1746] = + s[1260];
gout[n*2187+1747] = + s[1261];
gout[n*2187+1748] = + s[1262];
gout[n*2187+1749] = + s[1263];
gout[n*2187+1750] = + s[1264];
gout[n*2187+1751] = + s[1265];
gout[n*2187+1752] = + s[1266];
gout[n*2187+1753] = + s[1267];
gout[n*2187+1754] = + s[1268];
gout[n*2187+1755] = + s[1269];
gout[n*2187+1756] = + s[1270];
gout[n*2187+1757] = + s[1271];
gout[n*2187+1758] = + s[1272];
gout[n*2187+1759] = + s[1273];
gout[n*2187+1760] = + s[1274];
gout[n*2187+1761] = + s[1275];
gout[n*2187+1762] = + s[1276];
gout[n*2187+1763] = + s[1277];
gout[n*2187+1764] = + s[1278];
gout[n*2187+1765] = + s[1279];
gout[n*2187+1766] = + s[1280];
gout[n*2187+1767] = + s[1281];
gout[n*2187+1768] = + s[1282];
gout[n*2187+1769] = + s[1283];
gout[n*2187+1770] = + s[1284];
gout[n*2187+1771] = + s[1285];
gout[n*2187+1772] = + s[1286];
gout[n*2187+1773] = + s[1287];
gout[n*2187+1774] = + s[1288];
gout[n*2187+1775] = + s[1289];
gout[n*2187+1776] = + s[1290];
gout[n*2187+1777] = + s[1291];
gout[n*2187+1778] = + s[1292];
gout[n*2187+1779] = + s[1293];
gout[n*2187+1780] = + s[1294];
gout[n*2187+1781] = + s[1295];
gout[n*2187+1782] = + s[1296];
gout[n*2187+1783] = + s[1297];
gout[n*2187+1784] = + s[1298];
gout[n*2187+1785] = + s[1299];
gout[n*2187+1786] = + s[1300];
gout[n*2187+1787] = + s[1301];
gout[n*2187+1788] = + s[1302];
gout[n*2187+1789] = + s[1303];
gout[n*2187+1790] = + s[1304];
gout[n*2187+1791] = + s[1305];
gout[n*2187+1792] = + s[1306];
gout[n*2187+1793] = + s[1307];
gout[n*2187+1794] = + s[1308];
gout[n*2187+1795] = + s[1309];
gout[n*2187+1796] = + s[1310];
gout[n*2187+1797] = + s[1311];
gout[n*2187+1798] = + s[1312];
gout[n*2187+1799] = + s[1313];
gout[n*2187+1800] = + s[1314];
gout[n*2187+1801] = + s[1315];
gout[n*2187+1802] = + s[1316];
gout[n*2187+1803] = + s[1317];
gout[n*2187+1804] = + s[1318];
gout[n*2187+1805] = + s[1319];
gout[n*2187+1806] = + s[1320];
gout[n*2187+1807] = + s[1321];
gout[n*2187+1808] = + s[1322];
gout[n*2187+1809] = + s[1323];
gout[n*2187+1810] = + s[1324];
gout[n*2187+1811] = + s[1325];
gout[n*2187+1812] = + s[1326];
gout[n*2187+1813] = + s[1327];
gout[n*2187+1814] = + s[1328];
gout[n*2187+1815] = + s[1329];
gout[n*2187+1816] = + s[1330];
gout[n*2187+1817] = + s[1331];
gout[n*2187+1818] = + s[1332];
gout[n*2187+1819] = + s[1333];
gout[n*2187+1820] = + s[1334];
gout[n*2187+1821] = + s[1335];
gout[n*2187+1822] = + s[1336];
gout[n*2187+1823] = + s[1337];
gout[n*2187+1824] = + s[1338];
gout[n*2187+1825] = + s[1339];
gout[n*2187+1826] = + s[1340];
gout[n*2187+1827] = + s[1341];
gout[n*2187+1828] = + s[1342];
gout[n*2187+1829] = + s[1343];
gout[n*2187+1830] = + s[1344];
gout[n*2187+1831] = + s[1345];
gout[n*2187+1832] = + s[1346];
gout[n*2187+1833] = + s[1347];
gout[n*2187+1834] = + s[1348];
gout[n*2187+1835] = + s[1349];
gout[n*2187+1836] = + s[1350];
gout[n*2187+1837] = + s[1351];
gout[n*2187+1838] = + s[1352];
gout[n*2187+1839] = + s[1353];
gout[n*2187+1840] = + s[1354];
gout[n*2187+1841] = + s[1355];
gout[n*2187+1842] = + s[1356];
gout[n*2187+1843] = + s[1357];
gout[n*2187+1844] = + s[1358];
gout[n*2187+1845] = + s[1359];
gout[n*2187+1846] = + s[1360];
gout[n*2187+1847] = + s[1361];
gout[n*2187+1848] = + s[1362];
gout[n*2187+1849] = + s[1363];
gout[n*2187+1850] = + s[1364];
gout[n*2187+1851] = + s[1365];
gout[n*2187+1852] = + s[1366];
gout[n*2187+1853] = + s[1367];
gout[n*2187+1854] = + s[1368];
gout[n*2187+1855] = + s[1369];
gout[n*2187+1856] = + s[1370];
gout[n*2187+1857] = + s[1371];
gout[n*2187+1858] = + s[1372];
gout[n*2187+1859] = + s[1373];
gout[n*2187+1860] = + s[1374];
gout[n*2187+1861] = + s[1375];
gout[n*2187+1862] = + s[1376];
gout[n*2187+1863] = + s[1377];
gout[n*2187+1864] = + s[1378];
gout[n*2187+1865] = + s[1379];
gout[n*2187+1866] = + s[1380];
gout[n*2187+1867] = + s[1381];
gout[n*2187+1868] = + s[1382];
gout[n*2187+1869] = + s[1383];
gout[n*2187+1870] = + s[1384];
gout[n*2187+1871] = + s[1385];
gout[n*2187+1872] = + s[1386];
gout[n*2187+1873] = + s[1387];
gout[n*2187+1874] = + s[1388];
gout[n*2187+1875] = + s[1389];
gout[n*2187+1876] = + s[1390];
gout[n*2187+1877] = + s[1391];
gout[n*2187+1878] = + s[1392];
gout[n*2187+1879] = + s[1393];
gout[n*2187+1880] = + s[1394];
gout[n*2187+1881] = + s[1395];
gout[n*2187+1882] = + s[1396];
gout[n*2187+1883] = + s[1397];
gout[n*2187+1884] = + s[1398];
gout[n*2187+1885] = + s[1399];
gout[n*2187+1886] = + s[1400];
gout[n*2187+1887] = + s[1401];
gout[n*2187+1888] = + s[1402];
gout[n*2187+1889] = + s[1403];
gout[n*2187+1890] = + s[1404];
gout[n*2187+1891] = + s[1405];
gout[n*2187+1892] = + s[1406];
gout[n*2187+1893] = + s[1407];
gout[n*2187+1894] = + s[1408];
gout[n*2187+1895] = + s[1409];
gout[n*2187+1896] = + s[1410];
gout[n*2187+1897] = + s[1411];
gout[n*2187+1898] = + s[1412];
gout[n*2187+1899] = + s[1413];
gout[n*2187+1900] = + s[1414];
gout[n*2187+1901] = + s[1415];
gout[n*2187+1902] = + s[1416];
gout[n*2187+1903] = + s[1417];
gout[n*2187+1904] = + s[1418];
gout[n*2187+1905] = + s[1419];
gout[n*2187+1906] = + s[1420];
gout[n*2187+1907] = + s[1421];
gout[n*2187+1908] = + s[1422];
gout[n*2187+1909] = + s[1423];
gout[n*2187+1910] = + s[1424];
gout[n*2187+1911] = + s[1425];
gout[n*2187+1912] = + s[1426];
gout[n*2187+1913] = + s[1427];
gout[n*2187+1914] = + s[1428];
gout[n*2187+1915] = + s[1429];
gout[n*2187+1916] = + s[1430];
gout[n*2187+1917] = + s[1431];
gout[n*2187+1918] = + s[1432];
gout[n*2187+1919] = + s[1433];
gout[n*2187+1920] = + s[1434];
gout[n*2187+1921] = + s[1435];
gout[n*2187+1922] = + s[1436];
gout[n*2187+1923] = + s[1437];
gout[n*2187+1924] = + s[1438];
gout[n*2187+1925] = + s[1439];
gout[n*2187+1926] = + s[1440];
gout[n*2187+1927] = + s[1441];
gout[n*2187+1928] = + s[1442];
gout[n*2187+1929] = + s[1443];
gout[n*2187+1930] = + s[1444];
gout[n*2187+1931] = + s[1445];
gout[n*2187+1932] = + s[1446];
gout[n*2187+1933] = + s[1447];
gout[n*2187+1934] = + s[1448];
gout[n*2187+1935] = + s[1449];
gout[n*2187+1936] = + s[1450];
gout[n*2187+1937] = + s[1451];
gout[n*2187+1938] = + s[1452];
gout[n*2187+1939] = + s[1453];
gout[n*2187+1940] = + s[1454];
gout[n*2187+1941] = + s[1455];
gout[n*2187+1942] = + s[1456];
gout[n*2187+1943] = + s[1457];
gout[n*2187+1944] = + s[1944];
gout[n*2187+1945] = + s[1945];
gout[n*2187+1946] = + s[1946];
gout[n*2187+1947] = + s[1947];
gout[n*2187+1948] = + s[1948];
gout[n*2187+1949] = + s[1949];
gout[n*2187+1950] = + s[1950];
gout[n*2187+1951] = + s[1951];
gout[n*2187+1952] = + s[1952];
gout[n*2187+1953] = + s[1953];
gout[n*2187+1954] = + s[1954];
gout[n*2187+1955] = + s[1955];
gout[n*2187+1956] = + s[1956];
gout[n*2187+1957] = + s[1957];
gout[n*2187+1958] = + s[1958];
gout[n*2187+1959] = + s[1959];
gout[n*2187+1960] = + s[1960];
gout[n*2187+1961] = + s[1961];
gout[n*2187+1962] = + s[1962];
gout[n*2187+1963] = + s[1963];
gout[n*2187+1964] = + s[1964];
gout[n*2187+1965] = + s[1965];
gout[n*2187+1966] = + s[1966];
gout[n*2187+1967] = + s[1967];
gout[n*2187+1968] = + s[1968];
gout[n*2187+1969] = + s[1969];
gout[n*2187+1970] = + s[1970];
gout[n*2187+1971] = + s[1971];
gout[n*2187+1972] = + s[1972];
gout[n*2187+1973] = + s[1973];
gout[n*2187+1974] = + s[1974];
gout[n*2187+1975] = + s[1975];
gout[n*2187+1976] = + s[1976];
gout[n*2187+1977] = + s[1977];
gout[n*2187+1978] = + s[1978];
gout[n*2187+1979] = + s[1979];
gout[n*2187+1980] = + s[1980];
gout[n*2187+1981] = + s[1981];
gout[n*2187+1982] = + s[1982];
gout[n*2187+1983] = + s[1983];
gout[n*2187+1984] = + s[1984];
gout[n*2187+1985] = + s[1985];
gout[n*2187+1986] = + s[1986];
gout[n*2187+1987] = + s[1987];
gout[n*2187+1988] = + s[1988];
gout[n*2187+1989] = + s[1989];
gout[n*2187+1990] = + s[1990];
gout[n*2187+1991] = + s[1991];
gout[n*2187+1992] = + s[1992];
gout[n*2187+1993] = + s[1993];
gout[n*2187+1994] = + s[1994];
gout[n*2187+1995] = + s[1995];
gout[n*2187+1996] = + s[1996];
gout[n*2187+1997] = + s[1997];
gout[n*2187+1998] = + s[1998];
gout[n*2187+1999] = + s[1999];
gout[n*2187+2000] = + s[2000];
gout[n*2187+2001] = + s[2001];
gout[n*2187+2002] = + s[2002];
gout[n*2187+2003] = + s[2003];
gout[n*2187+2004] = + s[2004];
gout[n*2187+2005] = + s[2005];
gout[n*2187+2006] = + s[2006];
gout[n*2187+2007] = + s[2007];
gout[n*2187+2008] = + s[2008];
gout[n*2187+2009] = + s[2009];
gout[n*2187+2010] = + s[2010];
gout[n*2187+2011] = + s[2011];
gout[n*2187+2012] = + s[2012];
gout[n*2187+2013] = + s[2013];
gout[n*2187+2014] = + s[2014];
gout[n*2187+2015] = + s[2015];
gout[n*2187+2016] = + s[2016];
gout[n*2187+2017] = + s[2017];
gout[n*2187+2018] = + s[2018];
gout[n*2187+2019] = + s[2019];
gout[n*2187+2020] = + s[2020];
gout[n*2187+2021] = + s[2021];
gout[n*2187+2022] = + s[2022];
gout[n*2187+2023] = + s[2023];
gout[n*2187+2024] = + s[2024];
gout[n*2187+2025] = + s[2025];
gout[n*2187+2026] = + s[2026];
gout[n*2187+2027] = + s[2027];
gout[n*2187+2028] = + s[2028];
gout[n*2187+2029] = + s[2029];
gout[n*2187+2030] = + s[2030];
gout[n*2187+2031] = + s[2031];
gout[n*2187+2032] = + s[2032];
gout[n*2187+2033] = + s[2033];
gout[n*2187+2034] = + s[2034];
gout[n*2187+2035] = + s[2035];
gout[n*2187+2036] = + s[2036];
gout[n*2187+2037] = + s[2037];
gout[n*2187+2038] = + s[2038];
gout[n*2187+2039] = + s[2039];
gout[n*2187+2040] = + s[2040];
gout[n*2187+2041] = + s[2041];
gout[n*2187+2042] = + s[2042];
gout[n*2187+2043] = + s[2043];
gout[n*2187+2044] = + s[2044];
gout[n*2187+2045] = + s[2045];
gout[n*2187+2046] = + s[2046];
gout[n*2187+2047] = + s[2047];
gout[n*2187+2048] = + s[2048];
gout[n*2187+2049] = + s[2049];
gout[n*2187+2050] = + s[2050];
gout[n*2187+2051] = + s[2051];
gout[n*2187+2052] = + s[2052];
gout[n*2187+2053] = + s[2053];
gout[n*2187+2054] = + s[2054];
gout[n*2187+2055] = + s[2055];
gout[n*2187+2056] = + s[2056];
gout[n*2187+2057] = + s[2057];
gout[n*2187+2058] = + s[2058];
gout[n*2187+2059] = + s[2059];
gout[n*2187+2060] = + s[2060];
gout[n*2187+2061] = + s[2061];
gout[n*2187+2062] = + s[2062];
gout[n*2187+2063] = + s[2063];
gout[n*2187+2064] = + s[2064];
gout[n*2187+2065] = + s[2065];
gout[n*2187+2066] = + s[2066];
gout[n*2187+2067] = + s[2067];
gout[n*2187+2068] = + s[2068];
gout[n*2187+2069] = + s[2069];
gout[n*2187+2070] = + s[2070];
gout[n*2187+2071] = + s[2071];
gout[n*2187+2072] = + s[2072];
gout[n*2187+2073] = + s[2073];
gout[n*2187+2074] = + s[2074];
gout[n*2187+2075] = + s[2075];
gout[n*2187+2076] = + s[2076];
gout[n*2187+2077] = + s[2077];
gout[n*2187+2078] = + s[2078];
gout[n*2187+2079] = + s[2079];
gout[n*2187+2080] = + s[2080];
gout[n*2187+2081] = + s[2081];
gout[n*2187+2082] = + s[2082];
gout[n*2187+2083] = + s[2083];
gout[n*2187+2084] = + s[2084];
gout[n*2187+2085] = + s[2085];
gout[n*2187+2086] = + s[2086];
gout[n*2187+2087] = + s[2087];
gout[n*2187+2088] = + s[2088];
gout[n*2187+2089] = + s[2089];
gout[n*2187+2090] = + s[2090];
gout[n*2187+2091] = + s[2091];
gout[n*2187+2092] = + s[2092];
gout[n*2187+2093] = + s[2093];
gout[n*2187+2094] = + s[2094];
gout[n*2187+2095] = + s[2095];
gout[n*2187+2096] = + s[2096];
gout[n*2187+2097] = + s[2097];
gout[n*2187+2098] = + s[2098];
gout[n*2187+2099] = + s[2099];
gout[n*2187+2100] = + s[2100];
gout[n*2187+2101] = + s[2101];
gout[n*2187+2102] = + s[2102];
gout[n*2187+2103] = + s[2103];
gout[n*2187+2104] = + s[2104];
gout[n*2187+2105] = + s[2105];
gout[n*2187+2106] = + s[2106];
gout[n*2187+2107] = + s[2107];
gout[n*2187+2108] = + s[2108];
gout[n*2187+2109] = + s[2109];
gout[n*2187+2110] = + s[2110];
gout[n*2187+2111] = + s[2111];
gout[n*2187+2112] = + s[2112];
gout[n*2187+2113] = + s[2113];
gout[n*2187+2114] = + s[2114];
gout[n*2187+2115] = + s[2115];
gout[n*2187+2116] = + s[2116];
gout[n*2187+2117] = + s[2117];
gout[n*2187+2118] = + s[2118];
gout[n*2187+2119] = + s[2119];
gout[n*2187+2120] = + s[2120];
gout[n*2187+2121] = + s[2121];
gout[n*2187+2122] = + s[2122];
gout[n*2187+2123] = + s[2123];
gout[n*2187+2124] = + s[2124];
gout[n*2187+2125] = + s[2125];
gout[n*2187+2126] = + s[2126];
gout[n*2187+2127] = + s[2127];
gout[n*2187+2128] = + s[2128];
gout[n*2187+2129] = + s[2129];
gout[n*2187+2130] = + s[2130];
gout[n*2187+2131] = + s[2131];
gout[n*2187+2132] = + s[2132];
gout[n*2187+2133] = + s[2133];
gout[n*2187+2134] = + s[2134];
gout[n*2187+2135] = + s[2135];
gout[n*2187+2136] = + s[2136];
gout[n*2187+2137] = + s[2137];
gout[n*2187+2138] = + s[2138];
gout[n*2187+2139] = + s[2139];
gout[n*2187+2140] = + s[2140];
gout[n*2187+2141] = + s[2141];
gout[n*2187+2142] = + s[2142];
gout[n*2187+2143] = + s[2143];
gout[n*2187+2144] = + s[2144];
gout[n*2187+2145] = + s[2145];
gout[n*2187+2146] = + s[2146];
gout[n*2187+2147] = + s[2147];
gout[n*2187+2148] = + s[2148];
gout[n*2187+2149] = + s[2149];
gout[n*2187+2150] = + s[2150];
gout[n*2187+2151] = + s[2151];
gout[n*2187+2152] = + s[2152];
gout[n*2187+2153] = + s[2153];
gout[n*2187+2154] = + s[2154];
gout[n*2187+2155] = + s[2155];
gout[n*2187+2156] = + s[2156];
gout[n*2187+2157] = + s[2157];
gout[n*2187+2158] = + s[2158];
gout[n*2187+2159] = + s[2159];
gout[n*2187+2160] = + s[2160];
gout[n*2187+2161] = + s[2161];
gout[n*2187+2162] = + s[2162];
gout[n*2187+2163] = + s[2163];
gout[n*2187+2164] = + s[2164];
gout[n*2187+2165] = + s[2165];
gout[n*2187+2166] = + s[2166];
gout[n*2187+2167] = + s[2167];
gout[n*2187+2168] = + s[2168];
gout[n*2187+2169] = + s[2169];
gout[n*2187+2170] = + s[2170];
gout[n*2187+2171] = + s[2171];
gout[n*2187+2172] = + s[2172];
gout[n*2187+2173] = + s[2173];
gout[n*2187+2174] = + s[2174];
gout[n*2187+2175] = + s[2175];
gout[n*2187+2176] = + s[2176];
gout[n*2187+2177] = + s[2177];
gout[n*2187+2178] = + s[2178];
gout[n*2187+2179] = + s[2179];
gout[n*2187+2180] = + s[2180];
gout[n*2187+2181] = + s[2181];
gout[n*2187+2182] = + s[2182];
gout[n*2187+2183] = + s[2183];
gout[n*2187+2184] = + s[2184];
gout[n*2187+2185] = + s[2185];
gout[n*2187+2186] = + s[2186];
} else {
gout[n*2187+0] += + s[0];
gout[n*2187+1] += + s[1];
gout[n*2187+2] += + s[2];
gout[n*2187+3] += + s[3];
gout[n*2187+4] += + s[4];
gout[n*2187+5] += + s[5];
gout[n*2187+6] += + s[6];
gout[n*2187+7] += + s[7];
gout[n*2187+8] += + s[8];
gout[n*2187+9] += + s[9];
gout[n*2187+10] += + s[10];
gout[n*2187+11] += + s[11];
gout[n*2187+12] += + s[12];
gout[n*2187+13] += + s[13];
gout[n*2187+14] += + s[14];
gout[n*2187+15] += + s[15];
gout[n*2187+16] += + s[16];
gout[n*2187+17] += + s[17];
gout[n*2187+18] += + s[18];
gout[n*2187+19] += + s[19];
gout[n*2187+20] += + s[20];
gout[n*2187+21] += + s[21];
gout[n*2187+22] += + s[22];
gout[n*2187+23] += + s[23];
gout[n*2187+24] += + s[24];
gout[n*2187+25] += + s[25];
gout[n*2187+26] += + s[26];
gout[n*2187+27] += + s[27];
gout[n*2187+28] += + s[28];
gout[n*2187+29] += + s[29];
gout[n*2187+30] += + s[30];
gout[n*2187+31] += + s[31];
gout[n*2187+32] += + s[32];
gout[n*2187+33] += + s[33];
gout[n*2187+34] += + s[34];
gout[n*2187+35] += + s[35];
gout[n*2187+36] += + s[36];
gout[n*2187+37] += + s[37];
gout[n*2187+38] += + s[38];
gout[n*2187+39] += + s[39];
gout[n*2187+40] += + s[40];
gout[n*2187+41] += + s[41];
gout[n*2187+42] += + s[42];
gout[n*2187+43] += + s[43];
gout[n*2187+44] += + s[44];
gout[n*2187+45] += + s[45];
gout[n*2187+46] += + s[46];
gout[n*2187+47] += + s[47];
gout[n*2187+48] += + s[48];
gout[n*2187+49] += + s[49];
gout[n*2187+50] += + s[50];
gout[n*2187+51] += + s[51];
gout[n*2187+52] += + s[52];
gout[n*2187+53] += + s[53];
gout[n*2187+54] += + s[54];
gout[n*2187+55] += + s[55];
gout[n*2187+56] += + s[56];
gout[n*2187+57] += + s[57];
gout[n*2187+58] += + s[58];
gout[n*2187+59] += + s[59];
gout[n*2187+60] += + s[60];
gout[n*2187+61] += + s[61];
gout[n*2187+62] += + s[62];
gout[n*2187+63] += + s[63];
gout[n*2187+64] += + s[64];
gout[n*2187+65] += + s[65];
gout[n*2187+66] += + s[66];
gout[n*2187+67] += + s[67];
gout[n*2187+68] += + s[68];
gout[n*2187+69] += + s[69];
gout[n*2187+70] += + s[70];
gout[n*2187+71] += + s[71];
gout[n*2187+72] += + s[72];
gout[n*2187+73] += + s[73];
gout[n*2187+74] += + s[74];
gout[n*2187+75] += + s[75];
gout[n*2187+76] += + s[76];
gout[n*2187+77] += + s[77];
gout[n*2187+78] += + s[78];
gout[n*2187+79] += + s[79];
gout[n*2187+80] += + s[80];
gout[n*2187+81] += + s[81];
gout[n*2187+82] += + s[82];
gout[n*2187+83] += + s[83];
gout[n*2187+84] += + s[84];
gout[n*2187+85] += + s[85];
gout[n*2187+86] += + s[86];
gout[n*2187+87] += + s[87];
gout[n*2187+88] += + s[88];
gout[n*2187+89] += + s[89];
gout[n*2187+90] += + s[90];
gout[n*2187+91] += + s[91];
gout[n*2187+92] += + s[92];
gout[n*2187+93] += + s[93];
gout[n*2187+94] += + s[94];
gout[n*2187+95] += + s[95];
gout[n*2187+96] += + s[96];
gout[n*2187+97] += + s[97];
gout[n*2187+98] += + s[98];
gout[n*2187+99] += + s[99];
gout[n*2187+100] += + s[100];
gout[n*2187+101] += + s[101];
gout[n*2187+102] += + s[102];
gout[n*2187+103] += + s[103];
gout[n*2187+104] += + s[104];
gout[n*2187+105] += + s[105];
gout[n*2187+106] += + s[106];
gout[n*2187+107] += + s[107];
gout[n*2187+108] += + s[108];
gout[n*2187+109] += + s[109];
gout[n*2187+110] += + s[110];
gout[n*2187+111] += + s[111];
gout[n*2187+112] += + s[112];
gout[n*2187+113] += + s[113];
gout[n*2187+114] += + s[114];
gout[n*2187+115] += + s[115];
gout[n*2187+116] += + s[116];
gout[n*2187+117] += + s[117];
gout[n*2187+118] += + s[118];
gout[n*2187+119] += + s[119];
gout[n*2187+120] += + s[120];
gout[n*2187+121] += + s[121];
gout[n*2187+122] += + s[122];
gout[n*2187+123] += + s[123];
gout[n*2187+124] += + s[124];
gout[n*2187+125] += + s[125];
gout[n*2187+126] += + s[126];
gout[n*2187+127] += + s[127];
gout[n*2187+128] += + s[128];
gout[n*2187+129] += + s[129];
gout[n*2187+130] += + s[130];
gout[n*2187+131] += + s[131];
gout[n*2187+132] += + s[132];
gout[n*2187+133] += + s[133];
gout[n*2187+134] += + s[134];
gout[n*2187+135] += + s[135];
gout[n*2187+136] += + s[136];
gout[n*2187+137] += + s[137];
gout[n*2187+138] += + s[138];
gout[n*2187+139] += + s[139];
gout[n*2187+140] += + s[140];
gout[n*2187+141] += + s[141];
gout[n*2187+142] += + s[142];
gout[n*2187+143] += + s[143];
gout[n*2187+144] += + s[144];
gout[n*2187+145] += + s[145];
gout[n*2187+146] += + s[146];
gout[n*2187+147] += + s[147];
gout[n*2187+148] += + s[148];
gout[n*2187+149] += + s[149];
gout[n*2187+150] += + s[150];
gout[n*2187+151] += + s[151];
gout[n*2187+152] += + s[152];
gout[n*2187+153] += + s[153];
gout[n*2187+154] += + s[154];
gout[n*2187+155] += + s[155];
gout[n*2187+156] += + s[156];
gout[n*2187+157] += + s[157];
gout[n*2187+158] += + s[158];
gout[n*2187+159] += + s[159];
gout[n*2187+160] += + s[160];
gout[n*2187+161] += + s[161];
gout[n*2187+162] += + s[162];
gout[n*2187+163] += + s[163];
gout[n*2187+164] += + s[164];
gout[n*2187+165] += + s[165];
gout[n*2187+166] += + s[166];
gout[n*2187+167] += + s[167];
gout[n*2187+168] += + s[168];
gout[n*2187+169] += + s[169];
gout[n*2187+170] += + s[170];
gout[n*2187+171] += + s[171];
gout[n*2187+172] += + s[172];
gout[n*2187+173] += + s[173];
gout[n*2187+174] += + s[174];
gout[n*2187+175] += + s[175];
gout[n*2187+176] += + s[176];
gout[n*2187+177] += + s[177];
gout[n*2187+178] += + s[178];
gout[n*2187+179] += + s[179];
gout[n*2187+180] += + s[180];
gout[n*2187+181] += + s[181];
gout[n*2187+182] += + s[182];
gout[n*2187+183] += + s[183];
gout[n*2187+184] += + s[184];
gout[n*2187+185] += + s[185];
gout[n*2187+186] += + s[186];
gout[n*2187+187] += + s[187];
gout[n*2187+188] += + s[188];
gout[n*2187+189] += + s[189];
gout[n*2187+190] += + s[190];
gout[n*2187+191] += + s[191];
gout[n*2187+192] += + s[192];
gout[n*2187+193] += + s[193];
gout[n*2187+194] += + s[194];
gout[n*2187+195] += + s[195];
gout[n*2187+196] += + s[196];
gout[n*2187+197] += + s[197];
gout[n*2187+198] += + s[198];
gout[n*2187+199] += + s[199];
gout[n*2187+200] += + s[200];
gout[n*2187+201] += + s[201];
gout[n*2187+202] += + s[202];
gout[n*2187+203] += + s[203];
gout[n*2187+204] += + s[204];
gout[n*2187+205] += + s[205];
gout[n*2187+206] += + s[206];
gout[n*2187+207] += + s[207];
gout[n*2187+208] += + s[208];
gout[n*2187+209] += + s[209];
gout[n*2187+210] += + s[210];
gout[n*2187+211] += + s[211];
gout[n*2187+212] += + s[212];
gout[n*2187+213] += + s[213];
gout[n*2187+214] += + s[214];
gout[n*2187+215] += + s[215];
gout[n*2187+216] += + s[216];
gout[n*2187+217] += + s[217];
gout[n*2187+218] += + s[218];
gout[n*2187+219] += + s[219];
gout[n*2187+220] += + s[220];
gout[n*2187+221] += + s[221];
gout[n*2187+222] += + s[222];
gout[n*2187+223] += + s[223];
gout[n*2187+224] += + s[224];
gout[n*2187+225] += + s[225];
gout[n*2187+226] += + s[226];
gout[n*2187+227] += + s[227];
gout[n*2187+228] += + s[228];
gout[n*2187+229] += + s[229];
gout[n*2187+230] += + s[230];
gout[n*2187+231] += + s[231];
gout[n*2187+232] += + s[232];
gout[n*2187+233] += + s[233];
gout[n*2187+234] += + s[234];
gout[n*2187+235] += + s[235];
gout[n*2187+236] += + s[236];
gout[n*2187+237] += + s[237];
gout[n*2187+238] += + s[238];
gout[n*2187+239] += + s[239];
gout[n*2187+240] += + s[240];
gout[n*2187+241] += + s[241];
gout[n*2187+242] += + s[242];
gout[n*2187+243] += + s[729];
gout[n*2187+244] += + s[730];
gout[n*2187+245] += + s[731];
gout[n*2187+246] += + s[732];
gout[n*2187+247] += + s[733];
gout[n*2187+248] += + s[734];
gout[n*2187+249] += + s[735];
gout[n*2187+250] += + s[736];
gout[n*2187+251] += + s[737];
gout[n*2187+252] += + s[738];
gout[n*2187+253] += + s[739];
gout[n*2187+254] += + s[740];
gout[n*2187+255] += + s[741];
gout[n*2187+256] += + s[742];
gout[n*2187+257] += + s[743];
gout[n*2187+258] += + s[744];
gout[n*2187+259] += + s[745];
gout[n*2187+260] += + s[746];
gout[n*2187+261] += + s[747];
gout[n*2187+262] += + s[748];
gout[n*2187+263] += + s[749];
gout[n*2187+264] += + s[750];
gout[n*2187+265] += + s[751];
gout[n*2187+266] += + s[752];
gout[n*2187+267] += + s[753];
gout[n*2187+268] += + s[754];
gout[n*2187+269] += + s[755];
gout[n*2187+270] += + s[756];
gout[n*2187+271] += + s[757];
gout[n*2187+272] += + s[758];
gout[n*2187+273] += + s[759];
gout[n*2187+274] += + s[760];
gout[n*2187+275] += + s[761];
gout[n*2187+276] += + s[762];
gout[n*2187+277] += + s[763];
gout[n*2187+278] += + s[764];
gout[n*2187+279] += + s[765];
gout[n*2187+280] += + s[766];
gout[n*2187+281] += + s[767];
gout[n*2187+282] += + s[768];
gout[n*2187+283] += + s[769];
gout[n*2187+284] += + s[770];
gout[n*2187+285] += + s[771];
gout[n*2187+286] += + s[772];
gout[n*2187+287] += + s[773];
gout[n*2187+288] += + s[774];
gout[n*2187+289] += + s[775];
gout[n*2187+290] += + s[776];
gout[n*2187+291] += + s[777];
gout[n*2187+292] += + s[778];
gout[n*2187+293] += + s[779];
gout[n*2187+294] += + s[780];
gout[n*2187+295] += + s[781];
gout[n*2187+296] += + s[782];
gout[n*2187+297] += + s[783];
gout[n*2187+298] += + s[784];
gout[n*2187+299] += + s[785];
gout[n*2187+300] += + s[786];
gout[n*2187+301] += + s[787];
gout[n*2187+302] += + s[788];
gout[n*2187+303] += + s[789];
gout[n*2187+304] += + s[790];
gout[n*2187+305] += + s[791];
gout[n*2187+306] += + s[792];
gout[n*2187+307] += + s[793];
gout[n*2187+308] += + s[794];
gout[n*2187+309] += + s[795];
gout[n*2187+310] += + s[796];
gout[n*2187+311] += + s[797];
gout[n*2187+312] += + s[798];
gout[n*2187+313] += + s[799];
gout[n*2187+314] += + s[800];
gout[n*2187+315] += + s[801];
gout[n*2187+316] += + s[802];
gout[n*2187+317] += + s[803];
gout[n*2187+318] += + s[804];
gout[n*2187+319] += + s[805];
gout[n*2187+320] += + s[806];
gout[n*2187+321] += + s[807];
gout[n*2187+322] += + s[808];
gout[n*2187+323] += + s[809];
gout[n*2187+324] += + s[810];
gout[n*2187+325] += + s[811];
gout[n*2187+326] += + s[812];
gout[n*2187+327] += + s[813];
gout[n*2187+328] += + s[814];
gout[n*2187+329] += + s[815];
gout[n*2187+330] += + s[816];
gout[n*2187+331] += + s[817];
gout[n*2187+332] += + s[818];
gout[n*2187+333] += + s[819];
gout[n*2187+334] += + s[820];
gout[n*2187+335] += + s[821];
gout[n*2187+336] += + s[822];
gout[n*2187+337] += + s[823];
gout[n*2187+338] += + s[824];
gout[n*2187+339] += + s[825];
gout[n*2187+340] += + s[826];
gout[n*2187+341] += + s[827];
gout[n*2187+342] += + s[828];
gout[n*2187+343] += + s[829];
gout[n*2187+344] += + s[830];
gout[n*2187+345] += + s[831];
gout[n*2187+346] += + s[832];
gout[n*2187+347] += + s[833];
gout[n*2187+348] += + s[834];
gout[n*2187+349] += + s[835];
gout[n*2187+350] += + s[836];
gout[n*2187+351] += + s[837];
gout[n*2187+352] += + s[838];
gout[n*2187+353] += + s[839];
gout[n*2187+354] += + s[840];
gout[n*2187+355] += + s[841];
gout[n*2187+356] += + s[842];
gout[n*2187+357] += + s[843];
gout[n*2187+358] += + s[844];
gout[n*2187+359] += + s[845];
gout[n*2187+360] += + s[846];
gout[n*2187+361] += + s[847];
gout[n*2187+362] += + s[848];
gout[n*2187+363] += + s[849];
gout[n*2187+364] += + s[850];
gout[n*2187+365] += + s[851];
gout[n*2187+366] += + s[852];
gout[n*2187+367] += + s[853];
gout[n*2187+368] += + s[854];
gout[n*2187+369] += + s[855];
gout[n*2187+370] += + s[856];
gout[n*2187+371] += + s[857];
gout[n*2187+372] += + s[858];
gout[n*2187+373] += + s[859];
gout[n*2187+374] += + s[860];
gout[n*2187+375] += + s[861];
gout[n*2187+376] += + s[862];
gout[n*2187+377] += + s[863];
gout[n*2187+378] += + s[864];
gout[n*2187+379] += + s[865];
gout[n*2187+380] += + s[866];
gout[n*2187+381] += + s[867];
gout[n*2187+382] += + s[868];
gout[n*2187+383] += + s[869];
gout[n*2187+384] += + s[870];
gout[n*2187+385] += + s[871];
gout[n*2187+386] += + s[872];
gout[n*2187+387] += + s[873];
gout[n*2187+388] += + s[874];
gout[n*2187+389] += + s[875];
gout[n*2187+390] += + s[876];
gout[n*2187+391] += + s[877];
gout[n*2187+392] += + s[878];
gout[n*2187+393] += + s[879];
gout[n*2187+394] += + s[880];
gout[n*2187+395] += + s[881];
gout[n*2187+396] += + s[882];
gout[n*2187+397] += + s[883];
gout[n*2187+398] += + s[884];
gout[n*2187+399] += + s[885];
gout[n*2187+400] += + s[886];
gout[n*2187+401] += + s[887];
gout[n*2187+402] += + s[888];
gout[n*2187+403] += + s[889];
gout[n*2187+404] += + s[890];
gout[n*2187+405] += + s[891];
gout[n*2187+406] += + s[892];
gout[n*2187+407] += + s[893];
gout[n*2187+408] += + s[894];
gout[n*2187+409] += + s[895];
gout[n*2187+410] += + s[896];
gout[n*2187+411] += + s[897];
gout[n*2187+412] += + s[898];
gout[n*2187+413] += + s[899];
gout[n*2187+414] += + s[900];
gout[n*2187+415] += + s[901];
gout[n*2187+416] += + s[902];
gout[n*2187+417] += + s[903];
gout[n*2187+418] += + s[904];
gout[n*2187+419] += + s[905];
gout[n*2187+420] += + s[906];
gout[n*2187+421] += + s[907];
gout[n*2187+422] += + s[908];
gout[n*2187+423] += + s[909];
gout[n*2187+424] += + s[910];
gout[n*2187+425] += + s[911];
gout[n*2187+426] += + s[912];
gout[n*2187+427] += + s[913];
gout[n*2187+428] += + s[914];
gout[n*2187+429] += + s[915];
gout[n*2187+430] += + s[916];
gout[n*2187+431] += + s[917];
gout[n*2187+432] += + s[918];
gout[n*2187+433] += + s[919];
gout[n*2187+434] += + s[920];
gout[n*2187+435] += + s[921];
gout[n*2187+436] += + s[922];
gout[n*2187+437] += + s[923];
gout[n*2187+438] += + s[924];
gout[n*2187+439] += + s[925];
gout[n*2187+440] += + s[926];
gout[n*2187+441] += + s[927];
gout[n*2187+442] += + s[928];
gout[n*2187+443] += + s[929];
gout[n*2187+444] += + s[930];
gout[n*2187+445] += + s[931];
gout[n*2187+446] += + s[932];
gout[n*2187+447] += + s[933];
gout[n*2187+448] += + s[934];
gout[n*2187+449] += + s[935];
gout[n*2187+450] += + s[936];
gout[n*2187+451] += + s[937];
gout[n*2187+452] += + s[938];
gout[n*2187+453] += + s[939];
gout[n*2187+454] += + s[940];
gout[n*2187+455] += + s[941];
gout[n*2187+456] += + s[942];
gout[n*2187+457] += + s[943];
gout[n*2187+458] += + s[944];
gout[n*2187+459] += + s[945];
gout[n*2187+460] += + s[946];
gout[n*2187+461] += + s[947];
gout[n*2187+462] += + s[948];
gout[n*2187+463] += + s[949];
gout[n*2187+464] += + s[950];
gout[n*2187+465] += + s[951];
gout[n*2187+466] += + s[952];
gout[n*2187+467] += + s[953];
gout[n*2187+468] += + s[954];
gout[n*2187+469] += + s[955];
gout[n*2187+470] += + s[956];
gout[n*2187+471] += + s[957];
gout[n*2187+472] += + s[958];
gout[n*2187+473] += + s[959];
gout[n*2187+474] += + s[960];
gout[n*2187+475] += + s[961];
gout[n*2187+476] += + s[962];
gout[n*2187+477] += + s[963];
gout[n*2187+478] += + s[964];
gout[n*2187+479] += + s[965];
gout[n*2187+480] += + s[966];
gout[n*2187+481] += + s[967];
gout[n*2187+482] += + s[968];
gout[n*2187+483] += + s[969];
gout[n*2187+484] += + s[970];
gout[n*2187+485] += + s[971];
gout[n*2187+486] += + s[1458];
gout[n*2187+487] += + s[1459];
gout[n*2187+488] += + s[1460];
gout[n*2187+489] += + s[1461];
gout[n*2187+490] += + s[1462];
gout[n*2187+491] += + s[1463];
gout[n*2187+492] += + s[1464];
gout[n*2187+493] += + s[1465];
gout[n*2187+494] += + s[1466];
gout[n*2187+495] += + s[1467];
gout[n*2187+496] += + s[1468];
gout[n*2187+497] += + s[1469];
gout[n*2187+498] += + s[1470];
gout[n*2187+499] += + s[1471];
gout[n*2187+500] += + s[1472];
gout[n*2187+501] += + s[1473];
gout[n*2187+502] += + s[1474];
gout[n*2187+503] += + s[1475];
gout[n*2187+504] += + s[1476];
gout[n*2187+505] += + s[1477];
gout[n*2187+506] += + s[1478];
gout[n*2187+507] += + s[1479];
gout[n*2187+508] += + s[1480];
gout[n*2187+509] += + s[1481];
gout[n*2187+510] += + s[1482];
gout[n*2187+511] += + s[1483];
gout[n*2187+512] += + s[1484];
gout[n*2187+513] += + s[1485];
gout[n*2187+514] += + s[1486];
gout[n*2187+515] += + s[1487];
gout[n*2187+516] += + s[1488];
gout[n*2187+517] += + s[1489];
gout[n*2187+518] += + s[1490];
gout[n*2187+519] += + s[1491];
gout[n*2187+520] += + s[1492];
gout[n*2187+521] += + s[1493];
gout[n*2187+522] += + s[1494];
gout[n*2187+523] += + s[1495];
gout[n*2187+524] += + s[1496];
gout[n*2187+525] += + s[1497];
gout[n*2187+526] += + s[1498];
gout[n*2187+527] += + s[1499];
gout[n*2187+528] += + s[1500];
gout[n*2187+529] += + s[1501];
gout[n*2187+530] += + s[1502];
gout[n*2187+531] += + s[1503];
gout[n*2187+532] += + s[1504];
gout[n*2187+533] += + s[1505];
gout[n*2187+534] += + s[1506];
gout[n*2187+535] += + s[1507];
gout[n*2187+536] += + s[1508];
gout[n*2187+537] += + s[1509];
gout[n*2187+538] += + s[1510];
gout[n*2187+539] += + s[1511];
gout[n*2187+540] += + s[1512];
gout[n*2187+541] += + s[1513];
gout[n*2187+542] += + s[1514];
gout[n*2187+543] += + s[1515];
gout[n*2187+544] += + s[1516];
gout[n*2187+545] += + s[1517];
gout[n*2187+546] += + s[1518];
gout[n*2187+547] += + s[1519];
gout[n*2187+548] += + s[1520];
gout[n*2187+549] += + s[1521];
gout[n*2187+550] += + s[1522];
gout[n*2187+551] += + s[1523];
gout[n*2187+552] += + s[1524];
gout[n*2187+553] += + s[1525];
gout[n*2187+554] += + s[1526];
gout[n*2187+555] += + s[1527];
gout[n*2187+556] += + s[1528];
gout[n*2187+557] += + s[1529];
gout[n*2187+558] += + s[1530];
gout[n*2187+559] += + s[1531];
gout[n*2187+560] += + s[1532];
gout[n*2187+561] += + s[1533];
gout[n*2187+562] += + s[1534];
gout[n*2187+563] += + s[1535];
gout[n*2187+564] += + s[1536];
gout[n*2187+565] += + s[1537];
gout[n*2187+566] += + s[1538];
gout[n*2187+567] += + s[1539];
gout[n*2187+568] += + s[1540];
gout[n*2187+569] += + s[1541];
gout[n*2187+570] += + s[1542];
gout[n*2187+571] += + s[1543];
gout[n*2187+572] += + s[1544];
gout[n*2187+573] += + s[1545];
gout[n*2187+574] += + s[1546];
gout[n*2187+575] += + s[1547];
gout[n*2187+576] += + s[1548];
gout[n*2187+577] += + s[1549];
gout[n*2187+578] += + s[1550];
gout[n*2187+579] += + s[1551];
gout[n*2187+580] += + s[1552];
gout[n*2187+581] += + s[1553];
gout[n*2187+582] += + s[1554];
gout[n*2187+583] += + s[1555];
gout[n*2187+584] += + s[1556];
gout[n*2187+585] += + s[1557];
gout[n*2187+586] += + s[1558];
gout[n*2187+587] += + s[1559];
gout[n*2187+588] += + s[1560];
gout[n*2187+589] += + s[1561];
gout[n*2187+590] += + s[1562];
gout[n*2187+591] += + s[1563];
gout[n*2187+592] += + s[1564];
gout[n*2187+593] += + s[1565];
gout[n*2187+594] += + s[1566];
gout[n*2187+595] += + s[1567];
gout[n*2187+596] += + s[1568];
gout[n*2187+597] += + s[1569];
gout[n*2187+598] += + s[1570];
gout[n*2187+599] += + s[1571];
gout[n*2187+600] += + s[1572];
gout[n*2187+601] += + s[1573];
gout[n*2187+602] += + s[1574];
gout[n*2187+603] += + s[1575];
gout[n*2187+604] += + s[1576];
gout[n*2187+605] += + s[1577];
gout[n*2187+606] += + s[1578];
gout[n*2187+607] += + s[1579];
gout[n*2187+608] += + s[1580];
gout[n*2187+609] += + s[1581];
gout[n*2187+610] += + s[1582];
gout[n*2187+611] += + s[1583];
gout[n*2187+612] += + s[1584];
gout[n*2187+613] += + s[1585];
gout[n*2187+614] += + s[1586];
gout[n*2187+615] += + s[1587];
gout[n*2187+616] += + s[1588];
gout[n*2187+617] += + s[1589];
gout[n*2187+618] += + s[1590];
gout[n*2187+619] += + s[1591];
gout[n*2187+620] += + s[1592];
gout[n*2187+621] += + s[1593];
gout[n*2187+622] += + s[1594];
gout[n*2187+623] += + s[1595];
gout[n*2187+624] += + s[1596];
gout[n*2187+625] += + s[1597];
gout[n*2187+626] += + s[1598];
gout[n*2187+627] += + s[1599];
gout[n*2187+628] += + s[1600];
gout[n*2187+629] += + s[1601];
gout[n*2187+630] += + s[1602];
gout[n*2187+631] += + s[1603];
gout[n*2187+632] += + s[1604];
gout[n*2187+633] += + s[1605];
gout[n*2187+634] += + s[1606];
gout[n*2187+635] += + s[1607];
gout[n*2187+636] += + s[1608];
gout[n*2187+637] += + s[1609];
gout[n*2187+638] += + s[1610];
gout[n*2187+639] += + s[1611];
gout[n*2187+640] += + s[1612];
gout[n*2187+641] += + s[1613];
gout[n*2187+642] += + s[1614];
gout[n*2187+643] += + s[1615];
gout[n*2187+644] += + s[1616];
gout[n*2187+645] += + s[1617];
gout[n*2187+646] += + s[1618];
gout[n*2187+647] += + s[1619];
gout[n*2187+648] += + s[1620];
gout[n*2187+649] += + s[1621];
gout[n*2187+650] += + s[1622];
gout[n*2187+651] += + s[1623];
gout[n*2187+652] += + s[1624];
gout[n*2187+653] += + s[1625];
gout[n*2187+654] += + s[1626];
gout[n*2187+655] += + s[1627];
gout[n*2187+656] += + s[1628];
gout[n*2187+657] += + s[1629];
gout[n*2187+658] += + s[1630];
gout[n*2187+659] += + s[1631];
gout[n*2187+660] += + s[1632];
gout[n*2187+661] += + s[1633];
gout[n*2187+662] += + s[1634];
gout[n*2187+663] += + s[1635];
gout[n*2187+664] += + s[1636];
gout[n*2187+665] += + s[1637];
gout[n*2187+666] += + s[1638];
gout[n*2187+667] += + s[1639];
gout[n*2187+668] += + s[1640];
gout[n*2187+669] += + s[1641];
gout[n*2187+670] += + s[1642];
gout[n*2187+671] += + s[1643];
gout[n*2187+672] += + s[1644];
gout[n*2187+673] += + s[1645];
gout[n*2187+674] += + s[1646];
gout[n*2187+675] += + s[1647];
gout[n*2187+676] += + s[1648];
gout[n*2187+677] += + s[1649];
gout[n*2187+678] += + s[1650];
gout[n*2187+679] += + s[1651];
gout[n*2187+680] += + s[1652];
gout[n*2187+681] += + s[1653];
gout[n*2187+682] += + s[1654];
gout[n*2187+683] += + s[1655];
gout[n*2187+684] += + s[1656];
gout[n*2187+685] += + s[1657];
gout[n*2187+686] += + s[1658];
gout[n*2187+687] += + s[1659];
gout[n*2187+688] += + s[1660];
gout[n*2187+689] += + s[1661];
gout[n*2187+690] += + s[1662];
gout[n*2187+691] += + s[1663];
gout[n*2187+692] += + s[1664];
gout[n*2187+693] += + s[1665];
gout[n*2187+694] += + s[1666];
gout[n*2187+695] += + s[1667];
gout[n*2187+696] += + s[1668];
gout[n*2187+697] += + s[1669];
gout[n*2187+698] += + s[1670];
gout[n*2187+699] += + s[1671];
gout[n*2187+700] += + s[1672];
gout[n*2187+701] += + s[1673];
gout[n*2187+702] += + s[1674];
gout[n*2187+703] += + s[1675];
gout[n*2187+704] += + s[1676];
gout[n*2187+705] += + s[1677];
gout[n*2187+706] += + s[1678];
gout[n*2187+707] += + s[1679];
gout[n*2187+708] += + s[1680];
gout[n*2187+709] += + s[1681];
gout[n*2187+710] += + s[1682];
gout[n*2187+711] += + s[1683];
gout[n*2187+712] += + s[1684];
gout[n*2187+713] += + s[1685];
gout[n*2187+714] += + s[1686];
gout[n*2187+715] += + s[1687];
gout[n*2187+716] += + s[1688];
gout[n*2187+717] += + s[1689];
gout[n*2187+718] += + s[1690];
gout[n*2187+719] += + s[1691];
gout[n*2187+720] += + s[1692];
gout[n*2187+721] += + s[1693];
gout[n*2187+722] += + s[1694];
gout[n*2187+723] += + s[1695];
gout[n*2187+724] += + s[1696];
gout[n*2187+725] += + s[1697];
gout[n*2187+726] += + s[1698];
gout[n*2187+727] += + s[1699];
gout[n*2187+728] += + s[1700];
gout[n*2187+729] += + s[243];
gout[n*2187+730] += + s[244];
gout[n*2187+731] += + s[245];
gout[n*2187+732] += + s[246];
gout[n*2187+733] += + s[247];
gout[n*2187+734] += + s[248];
gout[n*2187+735] += + s[249];
gout[n*2187+736] += + s[250];
gout[n*2187+737] += + s[251];
gout[n*2187+738] += + s[252];
gout[n*2187+739] += + s[253];
gout[n*2187+740] += + s[254];
gout[n*2187+741] += + s[255];
gout[n*2187+742] += + s[256];
gout[n*2187+743] += + s[257];
gout[n*2187+744] += + s[258];
gout[n*2187+745] += + s[259];
gout[n*2187+746] += + s[260];
gout[n*2187+747] += + s[261];
gout[n*2187+748] += + s[262];
gout[n*2187+749] += + s[263];
gout[n*2187+750] += + s[264];
gout[n*2187+751] += + s[265];
gout[n*2187+752] += + s[266];
gout[n*2187+753] += + s[267];
gout[n*2187+754] += + s[268];
gout[n*2187+755] += + s[269];
gout[n*2187+756] += + s[270];
gout[n*2187+757] += + s[271];
gout[n*2187+758] += + s[272];
gout[n*2187+759] += + s[273];
gout[n*2187+760] += + s[274];
gout[n*2187+761] += + s[275];
gout[n*2187+762] += + s[276];
gout[n*2187+763] += + s[277];
gout[n*2187+764] += + s[278];
gout[n*2187+765] += + s[279];
gout[n*2187+766] += + s[280];
gout[n*2187+767] += + s[281];
gout[n*2187+768] += + s[282];
gout[n*2187+769] += + s[283];
gout[n*2187+770] += + s[284];
gout[n*2187+771] += + s[285];
gout[n*2187+772] += + s[286];
gout[n*2187+773] += + s[287];
gout[n*2187+774] += + s[288];
gout[n*2187+775] += + s[289];
gout[n*2187+776] += + s[290];
gout[n*2187+777] += + s[291];
gout[n*2187+778] += + s[292];
gout[n*2187+779] += + s[293];
gout[n*2187+780] += + s[294];
gout[n*2187+781] += + s[295];
gout[n*2187+782] += + s[296];
gout[n*2187+783] += + s[297];
gout[n*2187+784] += + s[298];
gout[n*2187+785] += + s[299];
gout[n*2187+786] += + s[300];
gout[n*2187+787] += + s[301];
gout[n*2187+788] += + s[302];
gout[n*2187+789] += + s[303];
gout[n*2187+790] += + s[304];
gout[n*2187+791] += + s[305];
gout[n*2187+792] += + s[306];
gout[n*2187+793] += + s[307];
gout[n*2187+794] += + s[308];
gout[n*2187+795] += + s[309];
gout[n*2187+796] += + s[310];
gout[n*2187+797] += + s[311];
gout[n*2187+798] += + s[312];
gout[n*2187+799] += + s[313];
gout[n*2187+800] += + s[314];
gout[n*2187+801] += + s[315];
gout[n*2187+802] += + s[316];
gout[n*2187+803] += + s[317];
gout[n*2187+804] += + s[318];
gout[n*2187+805] += + s[319];
gout[n*2187+806] += + s[320];
gout[n*2187+807] += + s[321];
gout[n*2187+808] += + s[322];
gout[n*2187+809] += + s[323];
gout[n*2187+810] += + s[324];
gout[n*2187+811] += + s[325];
gout[n*2187+812] += + s[326];
gout[n*2187+813] += + s[327];
gout[n*2187+814] += + s[328];
gout[n*2187+815] += + s[329];
gout[n*2187+816] += + s[330];
gout[n*2187+817] += + s[331];
gout[n*2187+818] += + s[332];
gout[n*2187+819] += + s[333];
gout[n*2187+820] += + s[334];
gout[n*2187+821] += + s[335];
gout[n*2187+822] += + s[336];
gout[n*2187+823] += + s[337];
gout[n*2187+824] += + s[338];
gout[n*2187+825] += + s[339];
gout[n*2187+826] += + s[340];
gout[n*2187+827] += + s[341];
gout[n*2187+828] += + s[342];
gout[n*2187+829] += + s[343];
gout[n*2187+830] += + s[344];
gout[n*2187+831] += + s[345];
gout[n*2187+832] += + s[346];
gout[n*2187+833] += + s[347];
gout[n*2187+834] += + s[348];
gout[n*2187+835] += + s[349];
gout[n*2187+836] += + s[350];
gout[n*2187+837] += + s[351];
gout[n*2187+838] += + s[352];
gout[n*2187+839] += + s[353];
gout[n*2187+840] += + s[354];
gout[n*2187+841] += + s[355];
gout[n*2187+842] += + s[356];
gout[n*2187+843] += + s[357];
gout[n*2187+844] += + s[358];
gout[n*2187+845] += + s[359];
gout[n*2187+846] += + s[360];
gout[n*2187+847] += + s[361];
gout[n*2187+848] += + s[362];
gout[n*2187+849] += + s[363];
gout[n*2187+850] += + s[364];
gout[n*2187+851] += + s[365];
gout[n*2187+852] += + s[366];
gout[n*2187+853] += + s[367];
gout[n*2187+854] += + s[368];
gout[n*2187+855] += + s[369];
gout[n*2187+856] += + s[370];
gout[n*2187+857] += + s[371];
gout[n*2187+858] += + s[372];
gout[n*2187+859] += + s[373];
gout[n*2187+860] += + s[374];
gout[n*2187+861] += + s[375];
gout[n*2187+862] += + s[376];
gout[n*2187+863] += + s[377];
gout[n*2187+864] += + s[378];
gout[n*2187+865] += + s[379];
gout[n*2187+866] += + s[380];
gout[n*2187+867] += + s[381];
gout[n*2187+868] += + s[382];
gout[n*2187+869] += + s[383];
gout[n*2187+870] += + s[384];
gout[n*2187+871] += + s[385];
gout[n*2187+872] += + s[386];
gout[n*2187+873] += + s[387];
gout[n*2187+874] += + s[388];
gout[n*2187+875] += + s[389];
gout[n*2187+876] += + s[390];
gout[n*2187+877] += + s[391];
gout[n*2187+878] += + s[392];
gout[n*2187+879] += + s[393];
gout[n*2187+880] += + s[394];
gout[n*2187+881] += + s[395];
gout[n*2187+882] += + s[396];
gout[n*2187+883] += + s[397];
gout[n*2187+884] += + s[398];
gout[n*2187+885] += + s[399];
gout[n*2187+886] += + s[400];
gout[n*2187+887] += + s[401];
gout[n*2187+888] += + s[402];
gout[n*2187+889] += + s[403];
gout[n*2187+890] += + s[404];
gout[n*2187+891] += + s[405];
gout[n*2187+892] += + s[406];
gout[n*2187+893] += + s[407];
gout[n*2187+894] += + s[408];
gout[n*2187+895] += + s[409];
gout[n*2187+896] += + s[410];
gout[n*2187+897] += + s[411];
gout[n*2187+898] += + s[412];
gout[n*2187+899] += + s[413];
gout[n*2187+900] += + s[414];
gout[n*2187+901] += + s[415];
gout[n*2187+902] += + s[416];
gout[n*2187+903] += + s[417];
gout[n*2187+904] += + s[418];
gout[n*2187+905] += + s[419];
gout[n*2187+906] += + s[420];
gout[n*2187+907] += + s[421];
gout[n*2187+908] += + s[422];
gout[n*2187+909] += + s[423];
gout[n*2187+910] += + s[424];
gout[n*2187+911] += + s[425];
gout[n*2187+912] += + s[426];
gout[n*2187+913] += + s[427];
gout[n*2187+914] += + s[428];
gout[n*2187+915] += + s[429];
gout[n*2187+916] += + s[430];
gout[n*2187+917] += + s[431];
gout[n*2187+918] += + s[432];
gout[n*2187+919] += + s[433];
gout[n*2187+920] += + s[434];
gout[n*2187+921] += + s[435];
gout[n*2187+922] += + s[436];
gout[n*2187+923] += + s[437];
gout[n*2187+924] += + s[438];
gout[n*2187+925] += + s[439];
gout[n*2187+926] += + s[440];
gout[n*2187+927] += + s[441];
gout[n*2187+928] += + s[442];
gout[n*2187+929] += + s[443];
gout[n*2187+930] += + s[444];
gout[n*2187+931] += + s[445];
gout[n*2187+932] += + s[446];
gout[n*2187+933] += + s[447];
gout[n*2187+934] += + s[448];
gout[n*2187+935] += + s[449];
gout[n*2187+936] += + s[450];
gout[n*2187+937] += + s[451];
gout[n*2187+938] += + s[452];
gout[n*2187+939] += + s[453];
gout[n*2187+940] += + s[454];
gout[n*2187+941] += + s[455];
gout[n*2187+942] += + s[456];
gout[n*2187+943] += + s[457];
gout[n*2187+944] += + s[458];
gout[n*2187+945] += + s[459];
gout[n*2187+946] += + s[460];
gout[n*2187+947] += + s[461];
gout[n*2187+948] += + s[462];
gout[n*2187+949] += + s[463];
gout[n*2187+950] += + s[464];
gout[n*2187+951] += + s[465];
gout[n*2187+952] += + s[466];
gout[n*2187+953] += + s[467];
gout[n*2187+954] += + s[468];
gout[n*2187+955] += + s[469];
gout[n*2187+956] += + s[470];
gout[n*2187+957] += + s[471];
gout[n*2187+958] += + s[472];
gout[n*2187+959] += + s[473];
gout[n*2187+960] += + s[474];
gout[n*2187+961] += + s[475];
gout[n*2187+962] += + s[476];
gout[n*2187+963] += + s[477];
gout[n*2187+964] += + s[478];
gout[n*2187+965] += + s[479];
gout[n*2187+966] += + s[480];
gout[n*2187+967] += + s[481];
gout[n*2187+968] += + s[482];
gout[n*2187+969] += + s[483];
gout[n*2187+970] += + s[484];
gout[n*2187+971] += + s[485];
gout[n*2187+972] += + s[972];
gout[n*2187+973] += + s[973];
gout[n*2187+974] += + s[974];
gout[n*2187+975] += + s[975];
gout[n*2187+976] += + s[976];
gout[n*2187+977] += + s[977];
gout[n*2187+978] += + s[978];
gout[n*2187+979] += + s[979];
gout[n*2187+980] += + s[980];
gout[n*2187+981] += + s[981];
gout[n*2187+982] += + s[982];
gout[n*2187+983] += + s[983];
gout[n*2187+984] += + s[984];
gout[n*2187+985] += + s[985];
gout[n*2187+986] += + s[986];
gout[n*2187+987] += + s[987];
gout[n*2187+988] += + s[988];
gout[n*2187+989] += + s[989];
gout[n*2187+990] += + s[990];
gout[n*2187+991] += + s[991];
gout[n*2187+992] += + s[992];
gout[n*2187+993] += + s[993];
gout[n*2187+994] += + s[994];
gout[n*2187+995] += + s[995];
gout[n*2187+996] += + s[996];
gout[n*2187+997] += + s[997];
gout[n*2187+998] += + s[998];
gout[n*2187+999] += + s[999];
gout[n*2187+1000] += + s[1000];
gout[n*2187+1001] += + s[1001];
gout[n*2187+1002] += + s[1002];
gout[n*2187+1003] += + s[1003];
gout[n*2187+1004] += + s[1004];
gout[n*2187+1005] += + s[1005];
gout[n*2187+1006] += + s[1006];
gout[n*2187+1007] += + s[1007];
gout[n*2187+1008] += + s[1008];
gout[n*2187+1009] += + s[1009];
gout[n*2187+1010] += + s[1010];
gout[n*2187+1011] += + s[1011];
gout[n*2187+1012] += + s[1012];
gout[n*2187+1013] += + s[1013];
gout[n*2187+1014] += + s[1014];
gout[n*2187+1015] += + s[1015];
gout[n*2187+1016] += + s[1016];
gout[n*2187+1017] += + s[1017];
gout[n*2187+1018] += + s[1018];
gout[n*2187+1019] += + s[1019];
gout[n*2187+1020] += + s[1020];
gout[n*2187+1021] += + s[1021];
gout[n*2187+1022] += + s[1022];
gout[n*2187+1023] += + s[1023];
gout[n*2187+1024] += + s[1024];
gout[n*2187+1025] += + s[1025];
gout[n*2187+1026] += + s[1026];
gout[n*2187+1027] += + s[1027];
gout[n*2187+1028] += + s[1028];
gout[n*2187+1029] += + s[1029];
gout[n*2187+1030] += + s[1030];
gout[n*2187+1031] += + s[1031];
gout[n*2187+1032] += + s[1032];
gout[n*2187+1033] += + s[1033];
gout[n*2187+1034] += + s[1034];
gout[n*2187+1035] += + s[1035];
gout[n*2187+1036] += + s[1036];
gout[n*2187+1037] += + s[1037];
gout[n*2187+1038] += + s[1038];
gout[n*2187+1039] += + s[1039];
gout[n*2187+1040] += + s[1040];
gout[n*2187+1041] += + s[1041];
gout[n*2187+1042] += + s[1042];
gout[n*2187+1043] += + s[1043];
gout[n*2187+1044] += + s[1044];
gout[n*2187+1045] += + s[1045];
gout[n*2187+1046] += + s[1046];
gout[n*2187+1047] += + s[1047];
gout[n*2187+1048] += + s[1048];
gout[n*2187+1049] += + s[1049];
gout[n*2187+1050] += + s[1050];
gout[n*2187+1051] += + s[1051];
gout[n*2187+1052] += + s[1052];
gout[n*2187+1053] += + s[1053];
gout[n*2187+1054] += + s[1054];
gout[n*2187+1055] += + s[1055];
gout[n*2187+1056] += + s[1056];
gout[n*2187+1057] += + s[1057];
gout[n*2187+1058] += + s[1058];
gout[n*2187+1059] += + s[1059];
gout[n*2187+1060] += + s[1060];
gout[n*2187+1061] += + s[1061];
gout[n*2187+1062] += + s[1062];
gout[n*2187+1063] += + s[1063];
gout[n*2187+1064] += + s[1064];
gout[n*2187+1065] += + s[1065];
gout[n*2187+1066] += + s[1066];
gout[n*2187+1067] += + s[1067];
gout[n*2187+1068] += + s[1068];
gout[n*2187+1069] += + s[1069];
gout[n*2187+1070] += + s[1070];
gout[n*2187+1071] += + s[1071];
gout[n*2187+1072] += + s[1072];
gout[n*2187+1073] += + s[1073];
gout[n*2187+1074] += + s[1074];
gout[n*2187+1075] += + s[1075];
gout[n*2187+1076] += + s[1076];
gout[n*2187+1077] += + s[1077];
gout[n*2187+1078] += + s[1078];
gout[n*2187+1079] += + s[1079];
gout[n*2187+1080] += + s[1080];
gout[n*2187+1081] += + s[1081];
gout[n*2187+1082] += + s[1082];
gout[n*2187+1083] += + s[1083];
gout[n*2187+1084] += + s[1084];
gout[n*2187+1085] += + s[1085];
gout[n*2187+1086] += + s[1086];
gout[n*2187+1087] += + s[1087];
gout[n*2187+1088] += + s[1088];
gout[n*2187+1089] += + s[1089];
gout[n*2187+1090] += + s[1090];
gout[n*2187+1091] += + s[1091];
gout[n*2187+1092] += + s[1092];
gout[n*2187+1093] += + s[1093];
gout[n*2187+1094] += + s[1094];
gout[n*2187+1095] += + s[1095];
gout[n*2187+1096] += + s[1096];
gout[n*2187+1097] += + s[1097];
gout[n*2187+1098] += + s[1098];
gout[n*2187+1099] += + s[1099];
gout[n*2187+1100] += + s[1100];
gout[n*2187+1101] += + s[1101];
gout[n*2187+1102] += + s[1102];
gout[n*2187+1103] += + s[1103];
gout[n*2187+1104] += + s[1104];
gout[n*2187+1105] += + s[1105];
gout[n*2187+1106] += + s[1106];
gout[n*2187+1107] += + s[1107];
gout[n*2187+1108] += + s[1108];
gout[n*2187+1109] += + s[1109];
gout[n*2187+1110] += + s[1110];
gout[n*2187+1111] += + s[1111];
gout[n*2187+1112] += + s[1112];
gout[n*2187+1113] += + s[1113];
gout[n*2187+1114] += + s[1114];
gout[n*2187+1115] += + s[1115];
gout[n*2187+1116] += + s[1116];
gout[n*2187+1117] += + s[1117];
gout[n*2187+1118] += + s[1118];
gout[n*2187+1119] += + s[1119];
gout[n*2187+1120] += + s[1120];
gout[n*2187+1121] += + s[1121];
gout[n*2187+1122] += + s[1122];
gout[n*2187+1123] += + s[1123];
gout[n*2187+1124] += + s[1124];
gout[n*2187+1125] += + s[1125];
gout[n*2187+1126] += + s[1126];
gout[n*2187+1127] += + s[1127];
gout[n*2187+1128] += + s[1128];
gout[n*2187+1129] += + s[1129];
gout[n*2187+1130] += + s[1130];
gout[n*2187+1131] += + s[1131];
gout[n*2187+1132] += + s[1132];
gout[n*2187+1133] += + s[1133];
gout[n*2187+1134] += + s[1134];
gout[n*2187+1135] += + s[1135];
gout[n*2187+1136] += + s[1136];
gout[n*2187+1137] += + s[1137];
gout[n*2187+1138] += + s[1138];
gout[n*2187+1139] += + s[1139];
gout[n*2187+1140] += + s[1140];
gout[n*2187+1141] += + s[1141];
gout[n*2187+1142] += + s[1142];
gout[n*2187+1143] += + s[1143];
gout[n*2187+1144] += + s[1144];
gout[n*2187+1145] += + s[1145];
gout[n*2187+1146] += + s[1146];
gout[n*2187+1147] += + s[1147];
gout[n*2187+1148] += + s[1148];
gout[n*2187+1149] += + s[1149];
gout[n*2187+1150] += + s[1150];
gout[n*2187+1151] += + s[1151];
gout[n*2187+1152] += + s[1152];
gout[n*2187+1153] += + s[1153];
gout[n*2187+1154] += + s[1154];
gout[n*2187+1155] += + s[1155];
gout[n*2187+1156] += + s[1156];
gout[n*2187+1157] += + s[1157];
gout[n*2187+1158] += + s[1158];
gout[n*2187+1159] += + s[1159];
gout[n*2187+1160] += + s[1160];
gout[n*2187+1161] += + s[1161];
gout[n*2187+1162] += + s[1162];
gout[n*2187+1163] += + s[1163];
gout[n*2187+1164] += + s[1164];
gout[n*2187+1165] += + s[1165];
gout[n*2187+1166] += + s[1166];
gout[n*2187+1167] += + s[1167];
gout[n*2187+1168] += + s[1168];
gout[n*2187+1169] += + s[1169];
gout[n*2187+1170] += + s[1170];
gout[n*2187+1171] += + s[1171];
gout[n*2187+1172] += + s[1172];
gout[n*2187+1173] += + s[1173];
gout[n*2187+1174] += + s[1174];
gout[n*2187+1175] += + s[1175];
gout[n*2187+1176] += + s[1176];
gout[n*2187+1177] += + s[1177];
gout[n*2187+1178] += + s[1178];
gout[n*2187+1179] += + s[1179];
gout[n*2187+1180] += + s[1180];
gout[n*2187+1181] += + s[1181];
gout[n*2187+1182] += + s[1182];
gout[n*2187+1183] += + s[1183];
gout[n*2187+1184] += + s[1184];
gout[n*2187+1185] += + s[1185];
gout[n*2187+1186] += + s[1186];
gout[n*2187+1187] += + s[1187];
gout[n*2187+1188] += + s[1188];
gout[n*2187+1189] += + s[1189];
gout[n*2187+1190] += + s[1190];
gout[n*2187+1191] += + s[1191];
gout[n*2187+1192] += + s[1192];
gout[n*2187+1193] += + s[1193];
gout[n*2187+1194] += + s[1194];
gout[n*2187+1195] += + s[1195];
gout[n*2187+1196] += + s[1196];
gout[n*2187+1197] += + s[1197];
gout[n*2187+1198] += + s[1198];
gout[n*2187+1199] += + s[1199];
gout[n*2187+1200] += + s[1200];
gout[n*2187+1201] += + s[1201];
gout[n*2187+1202] += + s[1202];
gout[n*2187+1203] += + s[1203];
gout[n*2187+1204] += + s[1204];
gout[n*2187+1205] += + s[1205];
gout[n*2187+1206] += + s[1206];
gout[n*2187+1207] += + s[1207];
gout[n*2187+1208] += + s[1208];
gout[n*2187+1209] += + s[1209];
gout[n*2187+1210] += + s[1210];
gout[n*2187+1211] += + s[1211];
gout[n*2187+1212] += + s[1212];
gout[n*2187+1213] += + s[1213];
gout[n*2187+1214] += + s[1214];
gout[n*2187+1215] += + s[1701];
gout[n*2187+1216] += + s[1702];
gout[n*2187+1217] += + s[1703];
gout[n*2187+1218] += + s[1704];
gout[n*2187+1219] += + s[1705];
gout[n*2187+1220] += + s[1706];
gout[n*2187+1221] += + s[1707];
gout[n*2187+1222] += + s[1708];
gout[n*2187+1223] += + s[1709];
gout[n*2187+1224] += + s[1710];
gout[n*2187+1225] += + s[1711];
gout[n*2187+1226] += + s[1712];
gout[n*2187+1227] += + s[1713];
gout[n*2187+1228] += + s[1714];
gout[n*2187+1229] += + s[1715];
gout[n*2187+1230] += + s[1716];
gout[n*2187+1231] += + s[1717];
gout[n*2187+1232] += + s[1718];
gout[n*2187+1233] += + s[1719];
gout[n*2187+1234] += + s[1720];
gout[n*2187+1235] += + s[1721];
gout[n*2187+1236] += + s[1722];
gout[n*2187+1237] += + s[1723];
gout[n*2187+1238] += + s[1724];
gout[n*2187+1239] += + s[1725];
gout[n*2187+1240] += + s[1726];
gout[n*2187+1241] += + s[1727];
gout[n*2187+1242] += + s[1728];
gout[n*2187+1243] += + s[1729];
gout[n*2187+1244] += + s[1730];
gout[n*2187+1245] += + s[1731];
gout[n*2187+1246] += + s[1732];
gout[n*2187+1247] += + s[1733];
gout[n*2187+1248] += + s[1734];
gout[n*2187+1249] += + s[1735];
gout[n*2187+1250] += + s[1736];
gout[n*2187+1251] += + s[1737];
gout[n*2187+1252] += + s[1738];
gout[n*2187+1253] += + s[1739];
gout[n*2187+1254] += + s[1740];
gout[n*2187+1255] += + s[1741];
gout[n*2187+1256] += + s[1742];
gout[n*2187+1257] += + s[1743];
gout[n*2187+1258] += + s[1744];
gout[n*2187+1259] += + s[1745];
gout[n*2187+1260] += + s[1746];
gout[n*2187+1261] += + s[1747];
gout[n*2187+1262] += + s[1748];
gout[n*2187+1263] += + s[1749];
gout[n*2187+1264] += + s[1750];
gout[n*2187+1265] += + s[1751];
gout[n*2187+1266] += + s[1752];
gout[n*2187+1267] += + s[1753];
gout[n*2187+1268] += + s[1754];
gout[n*2187+1269] += + s[1755];
gout[n*2187+1270] += + s[1756];
gout[n*2187+1271] += + s[1757];
gout[n*2187+1272] += + s[1758];
gout[n*2187+1273] += + s[1759];
gout[n*2187+1274] += + s[1760];
gout[n*2187+1275] += + s[1761];
gout[n*2187+1276] += + s[1762];
gout[n*2187+1277] += + s[1763];
gout[n*2187+1278] += + s[1764];
gout[n*2187+1279] += + s[1765];
gout[n*2187+1280] += + s[1766];
gout[n*2187+1281] += + s[1767];
gout[n*2187+1282] += + s[1768];
gout[n*2187+1283] += + s[1769];
gout[n*2187+1284] += + s[1770];
gout[n*2187+1285] += + s[1771];
gout[n*2187+1286] += + s[1772];
gout[n*2187+1287] += + s[1773];
gout[n*2187+1288] += + s[1774];
gout[n*2187+1289] += + s[1775];
gout[n*2187+1290] += + s[1776];
gout[n*2187+1291] += + s[1777];
gout[n*2187+1292] += + s[1778];
gout[n*2187+1293] += + s[1779];
gout[n*2187+1294] += + s[1780];
gout[n*2187+1295] += + s[1781];
gout[n*2187+1296] += + s[1782];
gout[n*2187+1297] += + s[1783];
gout[n*2187+1298] += + s[1784];
gout[n*2187+1299] += + s[1785];
gout[n*2187+1300] += + s[1786];
gout[n*2187+1301] += + s[1787];
gout[n*2187+1302] += + s[1788];
gout[n*2187+1303] += + s[1789];
gout[n*2187+1304] += + s[1790];
gout[n*2187+1305] += + s[1791];
gout[n*2187+1306] += + s[1792];
gout[n*2187+1307] += + s[1793];
gout[n*2187+1308] += + s[1794];
gout[n*2187+1309] += + s[1795];
gout[n*2187+1310] += + s[1796];
gout[n*2187+1311] += + s[1797];
gout[n*2187+1312] += + s[1798];
gout[n*2187+1313] += + s[1799];
gout[n*2187+1314] += + s[1800];
gout[n*2187+1315] += + s[1801];
gout[n*2187+1316] += + s[1802];
gout[n*2187+1317] += + s[1803];
gout[n*2187+1318] += + s[1804];
gout[n*2187+1319] += + s[1805];
gout[n*2187+1320] += + s[1806];
gout[n*2187+1321] += + s[1807];
gout[n*2187+1322] += + s[1808];
gout[n*2187+1323] += + s[1809];
gout[n*2187+1324] += + s[1810];
gout[n*2187+1325] += + s[1811];
gout[n*2187+1326] += + s[1812];
gout[n*2187+1327] += + s[1813];
gout[n*2187+1328] += + s[1814];
gout[n*2187+1329] += + s[1815];
gout[n*2187+1330] += + s[1816];
gout[n*2187+1331] += + s[1817];
gout[n*2187+1332] += + s[1818];
gout[n*2187+1333] += + s[1819];
gout[n*2187+1334] += + s[1820];
gout[n*2187+1335] += + s[1821];
gout[n*2187+1336] += + s[1822];
gout[n*2187+1337] += + s[1823];
gout[n*2187+1338] += + s[1824];
gout[n*2187+1339] += + s[1825];
gout[n*2187+1340] += + s[1826];
gout[n*2187+1341] += + s[1827];
gout[n*2187+1342] += + s[1828];
gout[n*2187+1343] += + s[1829];
gout[n*2187+1344] += + s[1830];
gout[n*2187+1345] += + s[1831];
gout[n*2187+1346] += + s[1832];
gout[n*2187+1347] += + s[1833];
gout[n*2187+1348] += + s[1834];
gout[n*2187+1349] += + s[1835];
gout[n*2187+1350] += + s[1836];
gout[n*2187+1351] += + s[1837];
gout[n*2187+1352] += + s[1838];
gout[n*2187+1353] += + s[1839];
gout[n*2187+1354] += + s[1840];
gout[n*2187+1355] += + s[1841];
gout[n*2187+1356] += + s[1842];
gout[n*2187+1357] += + s[1843];
gout[n*2187+1358] += + s[1844];
gout[n*2187+1359] += + s[1845];
gout[n*2187+1360] += + s[1846];
gout[n*2187+1361] += + s[1847];
gout[n*2187+1362] += + s[1848];
gout[n*2187+1363] += + s[1849];
gout[n*2187+1364] += + s[1850];
gout[n*2187+1365] += + s[1851];
gout[n*2187+1366] += + s[1852];
gout[n*2187+1367] += + s[1853];
gout[n*2187+1368] += + s[1854];
gout[n*2187+1369] += + s[1855];
gout[n*2187+1370] += + s[1856];
gout[n*2187+1371] += + s[1857];
gout[n*2187+1372] += + s[1858];
gout[n*2187+1373] += + s[1859];
gout[n*2187+1374] += + s[1860];
gout[n*2187+1375] += + s[1861];
gout[n*2187+1376] += + s[1862];
gout[n*2187+1377] += + s[1863];
gout[n*2187+1378] += + s[1864];
gout[n*2187+1379] += + s[1865];
gout[n*2187+1380] += + s[1866];
gout[n*2187+1381] += + s[1867];
gout[n*2187+1382] += + s[1868];
gout[n*2187+1383] += + s[1869];
gout[n*2187+1384] += + s[1870];
gout[n*2187+1385] += + s[1871];
gout[n*2187+1386] += + s[1872];
gout[n*2187+1387] += + s[1873];
gout[n*2187+1388] += + s[1874];
gout[n*2187+1389] += + s[1875];
gout[n*2187+1390] += + s[1876];
gout[n*2187+1391] += + s[1877];
gout[n*2187+1392] += + s[1878];
gout[n*2187+1393] += + s[1879];
gout[n*2187+1394] += + s[1880];
gout[n*2187+1395] += + s[1881];
gout[n*2187+1396] += + s[1882];
gout[n*2187+1397] += + s[1883];
gout[n*2187+1398] += + s[1884];
gout[n*2187+1399] += + s[1885];
gout[n*2187+1400] += + s[1886];
gout[n*2187+1401] += + s[1887];
gout[n*2187+1402] += + s[1888];
gout[n*2187+1403] += + s[1889];
gout[n*2187+1404] += + s[1890];
gout[n*2187+1405] += + s[1891];
gout[n*2187+1406] += + s[1892];
gout[n*2187+1407] += + s[1893];
gout[n*2187+1408] += + s[1894];
gout[n*2187+1409] += + s[1895];
gout[n*2187+1410] += + s[1896];
gout[n*2187+1411] += + s[1897];
gout[n*2187+1412] += + s[1898];
gout[n*2187+1413] += + s[1899];
gout[n*2187+1414] += + s[1900];
gout[n*2187+1415] += + s[1901];
gout[n*2187+1416] += + s[1902];
gout[n*2187+1417] += + s[1903];
gout[n*2187+1418] += + s[1904];
gout[n*2187+1419] += + s[1905];
gout[n*2187+1420] += + s[1906];
gout[n*2187+1421] += + s[1907];
gout[n*2187+1422] += + s[1908];
gout[n*2187+1423] += + s[1909];
gout[n*2187+1424] += + s[1910];
gout[n*2187+1425] += + s[1911];
gout[n*2187+1426] += + s[1912];
gout[n*2187+1427] += + s[1913];
gout[n*2187+1428] += + s[1914];
gout[n*2187+1429] += + s[1915];
gout[n*2187+1430] += + s[1916];
gout[n*2187+1431] += + s[1917];
gout[n*2187+1432] += + s[1918];
gout[n*2187+1433] += + s[1919];
gout[n*2187+1434] += + s[1920];
gout[n*2187+1435] += + s[1921];
gout[n*2187+1436] += + s[1922];
gout[n*2187+1437] += + s[1923];
gout[n*2187+1438] += + s[1924];
gout[n*2187+1439] += + s[1925];
gout[n*2187+1440] += + s[1926];
gout[n*2187+1441] += + s[1927];
gout[n*2187+1442] += + s[1928];
gout[n*2187+1443] += + s[1929];
gout[n*2187+1444] += + s[1930];
gout[n*2187+1445] += + s[1931];
gout[n*2187+1446] += + s[1932];
gout[n*2187+1447] += + s[1933];
gout[n*2187+1448] += + s[1934];
gout[n*2187+1449] += + s[1935];
gout[n*2187+1450] += + s[1936];
gout[n*2187+1451] += + s[1937];
gout[n*2187+1452] += + s[1938];
gout[n*2187+1453] += + s[1939];
gout[n*2187+1454] += + s[1940];
gout[n*2187+1455] += + s[1941];
gout[n*2187+1456] += + s[1942];
gout[n*2187+1457] += + s[1943];
gout[n*2187+1458] += + s[486];
gout[n*2187+1459] += + s[487];
gout[n*2187+1460] += + s[488];
gout[n*2187+1461] += + s[489];
gout[n*2187+1462] += + s[490];
gout[n*2187+1463] += + s[491];
gout[n*2187+1464] += + s[492];
gout[n*2187+1465] += + s[493];
gout[n*2187+1466] += + s[494];
gout[n*2187+1467] += + s[495];
gout[n*2187+1468] += + s[496];
gout[n*2187+1469] += + s[497];
gout[n*2187+1470] += + s[498];
gout[n*2187+1471] += + s[499];
gout[n*2187+1472] += + s[500];
gout[n*2187+1473] += + s[501];
gout[n*2187+1474] += + s[502];
gout[n*2187+1475] += + s[503];
gout[n*2187+1476] += + s[504];
gout[n*2187+1477] += + s[505];
gout[n*2187+1478] += + s[506];
gout[n*2187+1479] += + s[507];
gout[n*2187+1480] += + s[508];
gout[n*2187+1481] += + s[509];
gout[n*2187+1482] += + s[510];
gout[n*2187+1483] += + s[511];
gout[n*2187+1484] += + s[512];
gout[n*2187+1485] += + s[513];
gout[n*2187+1486] += + s[514];
gout[n*2187+1487] += + s[515];
gout[n*2187+1488] += + s[516];
gout[n*2187+1489] += + s[517];
gout[n*2187+1490] += + s[518];
gout[n*2187+1491] += + s[519];
gout[n*2187+1492] += + s[520];
gout[n*2187+1493] += + s[521];
gout[n*2187+1494] += + s[522];
gout[n*2187+1495] += + s[523];
gout[n*2187+1496] += + s[524];
gout[n*2187+1497] += + s[525];
gout[n*2187+1498] += + s[526];
gout[n*2187+1499] += + s[527];
gout[n*2187+1500] += + s[528];
gout[n*2187+1501] += + s[529];
gout[n*2187+1502] += + s[530];
gout[n*2187+1503] += + s[531];
gout[n*2187+1504] += + s[532];
gout[n*2187+1505] += + s[533];
gout[n*2187+1506] += + s[534];
gout[n*2187+1507] += + s[535];
gout[n*2187+1508] += + s[536];
gout[n*2187+1509] += + s[537];
gout[n*2187+1510] += + s[538];
gout[n*2187+1511] += + s[539];
gout[n*2187+1512] += + s[540];
gout[n*2187+1513] += + s[541];
gout[n*2187+1514] += + s[542];
gout[n*2187+1515] += + s[543];
gout[n*2187+1516] += + s[544];
gout[n*2187+1517] += + s[545];
gout[n*2187+1518] += + s[546];
gout[n*2187+1519] += + s[547];
gout[n*2187+1520] += + s[548];
gout[n*2187+1521] += + s[549];
gout[n*2187+1522] += + s[550];
gout[n*2187+1523] += + s[551];
gout[n*2187+1524] += + s[552];
gout[n*2187+1525] += + s[553];
gout[n*2187+1526] += + s[554];
gout[n*2187+1527] += + s[555];
gout[n*2187+1528] += + s[556];
gout[n*2187+1529] += + s[557];
gout[n*2187+1530] += + s[558];
gout[n*2187+1531] += + s[559];
gout[n*2187+1532] += + s[560];
gout[n*2187+1533] += + s[561];
gout[n*2187+1534] += + s[562];
gout[n*2187+1535] += + s[563];
gout[n*2187+1536] += + s[564];
gout[n*2187+1537] += + s[565];
gout[n*2187+1538] += + s[566];
gout[n*2187+1539] += + s[567];
gout[n*2187+1540] += + s[568];
gout[n*2187+1541] += + s[569];
gout[n*2187+1542] += + s[570];
gout[n*2187+1543] += + s[571];
gout[n*2187+1544] += + s[572];
gout[n*2187+1545] += + s[573];
gout[n*2187+1546] += + s[574];
gout[n*2187+1547] += + s[575];
gout[n*2187+1548] += + s[576];
gout[n*2187+1549] += + s[577];
gout[n*2187+1550] += + s[578];
gout[n*2187+1551] += + s[579];
gout[n*2187+1552] += + s[580];
gout[n*2187+1553] += + s[581];
gout[n*2187+1554] += + s[582];
gout[n*2187+1555] += + s[583];
gout[n*2187+1556] += + s[584];
gout[n*2187+1557] += + s[585];
gout[n*2187+1558] += + s[586];
gout[n*2187+1559] += + s[587];
gout[n*2187+1560] += + s[588];
gout[n*2187+1561] += + s[589];
gout[n*2187+1562] += + s[590];
gout[n*2187+1563] += + s[591];
gout[n*2187+1564] += + s[592];
gout[n*2187+1565] += + s[593];
gout[n*2187+1566] += + s[594];
gout[n*2187+1567] += + s[595];
gout[n*2187+1568] += + s[596];
gout[n*2187+1569] += + s[597];
gout[n*2187+1570] += + s[598];
gout[n*2187+1571] += + s[599];
gout[n*2187+1572] += + s[600];
gout[n*2187+1573] += + s[601];
gout[n*2187+1574] += + s[602];
gout[n*2187+1575] += + s[603];
gout[n*2187+1576] += + s[604];
gout[n*2187+1577] += + s[605];
gout[n*2187+1578] += + s[606];
gout[n*2187+1579] += + s[607];
gout[n*2187+1580] += + s[608];
gout[n*2187+1581] += + s[609];
gout[n*2187+1582] += + s[610];
gout[n*2187+1583] += + s[611];
gout[n*2187+1584] += + s[612];
gout[n*2187+1585] += + s[613];
gout[n*2187+1586] += + s[614];
gout[n*2187+1587] += + s[615];
gout[n*2187+1588] += + s[616];
gout[n*2187+1589] += + s[617];
gout[n*2187+1590] += + s[618];
gout[n*2187+1591] += + s[619];
gout[n*2187+1592] += + s[620];
gout[n*2187+1593] += + s[621];
gout[n*2187+1594] += + s[622];
gout[n*2187+1595] += + s[623];
gout[n*2187+1596] += + s[624];
gout[n*2187+1597] += + s[625];
gout[n*2187+1598] += + s[626];
gout[n*2187+1599] += + s[627];
gout[n*2187+1600] += + s[628];
gout[n*2187+1601] += + s[629];
gout[n*2187+1602] += + s[630];
gout[n*2187+1603] += + s[631];
gout[n*2187+1604] += + s[632];
gout[n*2187+1605] += + s[633];
gout[n*2187+1606] += + s[634];
gout[n*2187+1607] += + s[635];
gout[n*2187+1608] += + s[636];
gout[n*2187+1609] += + s[637];
gout[n*2187+1610] += + s[638];
gout[n*2187+1611] += + s[639];
gout[n*2187+1612] += + s[640];
gout[n*2187+1613] += + s[641];
gout[n*2187+1614] += + s[642];
gout[n*2187+1615] += + s[643];
gout[n*2187+1616] += + s[644];
gout[n*2187+1617] += + s[645];
gout[n*2187+1618] += + s[646];
gout[n*2187+1619] += + s[647];
gout[n*2187+1620] += + s[648];
gout[n*2187+1621] += + s[649];
gout[n*2187+1622] += + s[650];
gout[n*2187+1623] += + s[651];
gout[n*2187+1624] += + s[652];
gout[n*2187+1625] += + s[653];
gout[n*2187+1626] += + s[654];
gout[n*2187+1627] += + s[655];
gout[n*2187+1628] += + s[656];
gout[n*2187+1629] += + s[657];
gout[n*2187+1630] += + s[658];
gout[n*2187+1631] += + s[659];
gout[n*2187+1632] += + s[660];
gout[n*2187+1633] += + s[661];
gout[n*2187+1634] += + s[662];
gout[n*2187+1635] += + s[663];
gout[n*2187+1636] += + s[664];
gout[n*2187+1637] += + s[665];
gout[n*2187+1638] += + s[666];
gout[n*2187+1639] += + s[667];
gout[n*2187+1640] += + s[668];
gout[n*2187+1641] += + s[669];
gout[n*2187+1642] += + s[670];
gout[n*2187+1643] += + s[671];
gout[n*2187+1644] += + s[672];
gout[n*2187+1645] += + s[673];
gout[n*2187+1646] += + s[674];
gout[n*2187+1647] += + s[675];
gout[n*2187+1648] += + s[676];
gout[n*2187+1649] += + s[677];
gout[n*2187+1650] += + s[678];
gout[n*2187+1651] += + s[679];
gout[n*2187+1652] += + s[680];
gout[n*2187+1653] += + s[681];
gout[n*2187+1654] += + s[682];
gout[n*2187+1655] += + s[683];
gout[n*2187+1656] += + s[684];
gout[n*2187+1657] += + s[685];
gout[n*2187+1658] += + s[686];
gout[n*2187+1659] += + s[687];
gout[n*2187+1660] += + s[688];
gout[n*2187+1661] += + s[689];
gout[n*2187+1662] += + s[690];
gout[n*2187+1663] += + s[691];
gout[n*2187+1664] += + s[692];
gout[n*2187+1665] += + s[693];
gout[n*2187+1666] += + s[694];
gout[n*2187+1667] += + s[695];
gout[n*2187+1668] += + s[696];
gout[n*2187+1669] += + s[697];
gout[n*2187+1670] += + s[698];
gout[n*2187+1671] += + s[699];
gout[n*2187+1672] += + s[700];
gout[n*2187+1673] += + s[701];
gout[n*2187+1674] += + s[702];
gout[n*2187+1675] += + s[703];
gout[n*2187+1676] += + s[704];
gout[n*2187+1677] += + s[705];
gout[n*2187+1678] += + s[706];
gout[n*2187+1679] += + s[707];
gout[n*2187+1680] += + s[708];
gout[n*2187+1681] += + s[709];
gout[n*2187+1682] += + s[710];
gout[n*2187+1683] += + s[711];
gout[n*2187+1684] += + s[712];
gout[n*2187+1685] += + s[713];
gout[n*2187+1686] += + s[714];
gout[n*2187+1687] += + s[715];
gout[n*2187+1688] += + s[716];
gout[n*2187+1689] += + s[717];
gout[n*2187+1690] += + s[718];
gout[n*2187+1691] += + s[719];
gout[n*2187+1692] += + s[720];
gout[n*2187+1693] += + s[721];
gout[n*2187+1694] += + s[722];
gout[n*2187+1695] += + s[723];
gout[n*2187+1696] += + s[724];
gout[n*2187+1697] += + s[725];
gout[n*2187+1698] += + s[726];
gout[n*2187+1699] += + s[727];
gout[n*2187+1700] += + s[728];
gout[n*2187+1701] += + s[1215];
gout[n*2187+1702] += + s[1216];
gout[n*2187+1703] += + s[1217];
gout[n*2187+1704] += + s[1218];
gout[n*2187+1705] += + s[1219];
gout[n*2187+1706] += + s[1220];
gout[n*2187+1707] += + s[1221];
gout[n*2187+1708] += + s[1222];
gout[n*2187+1709] += + s[1223];
gout[n*2187+1710] += + s[1224];
gout[n*2187+1711] += + s[1225];
gout[n*2187+1712] += + s[1226];
gout[n*2187+1713] += + s[1227];
gout[n*2187+1714] += + s[1228];
gout[n*2187+1715] += + s[1229];
gout[n*2187+1716] += + s[1230];
gout[n*2187+1717] += + s[1231];
gout[n*2187+1718] += + s[1232];
gout[n*2187+1719] += + s[1233];
gout[n*2187+1720] += + s[1234];
gout[n*2187+1721] += + s[1235];
gout[n*2187+1722] += + s[1236];
gout[n*2187+1723] += + s[1237];
gout[n*2187+1724] += + s[1238];
gout[n*2187+1725] += + s[1239];
gout[n*2187+1726] += + s[1240];
gout[n*2187+1727] += + s[1241];
gout[n*2187+1728] += + s[1242];
gout[n*2187+1729] += + s[1243];
gout[n*2187+1730] += + s[1244];
gout[n*2187+1731] += + s[1245];
gout[n*2187+1732] += + s[1246];
gout[n*2187+1733] += + s[1247];
gout[n*2187+1734] += + s[1248];
gout[n*2187+1735] += + s[1249];
gout[n*2187+1736] += + s[1250];
gout[n*2187+1737] += + s[1251];
gout[n*2187+1738] += + s[1252];
gout[n*2187+1739] += + s[1253];
gout[n*2187+1740] += + s[1254];
gout[n*2187+1741] += + s[1255];
gout[n*2187+1742] += + s[1256];
gout[n*2187+1743] += + s[1257];
gout[n*2187+1744] += + s[1258];
gout[n*2187+1745] += + s[1259];
gout[n*2187+1746] += + s[1260];
gout[n*2187+1747] += + s[1261];
gout[n*2187+1748] += + s[1262];
gout[n*2187+1749] += + s[1263];
gout[n*2187+1750] += + s[1264];
gout[n*2187+1751] += + s[1265];
gout[n*2187+1752] += + s[1266];
gout[n*2187+1753] += + s[1267];
gout[n*2187+1754] += + s[1268];
gout[n*2187+1755] += + s[1269];
gout[n*2187+1756] += + s[1270];
gout[n*2187+1757] += + s[1271];
gout[n*2187+1758] += + s[1272];
gout[n*2187+1759] += + s[1273];
gout[n*2187+1760] += + s[1274];
gout[n*2187+1761] += + s[1275];
gout[n*2187+1762] += + s[1276];
gout[n*2187+1763] += + s[1277];
gout[n*2187+1764] += + s[1278];
gout[n*2187+1765] += + s[1279];
gout[n*2187+1766] += + s[1280];
gout[n*2187+1767] += + s[1281];
gout[n*2187+1768] += + s[1282];
gout[n*2187+1769] += + s[1283];
gout[n*2187+1770] += + s[1284];
gout[n*2187+1771] += + s[1285];
gout[n*2187+1772] += + s[1286];
gout[n*2187+1773] += + s[1287];
gout[n*2187+1774] += + s[1288];
gout[n*2187+1775] += + s[1289];
gout[n*2187+1776] += + s[1290];
gout[n*2187+1777] += + s[1291];
gout[n*2187+1778] += + s[1292];
gout[n*2187+1779] += + s[1293];
gout[n*2187+1780] += + s[1294];
gout[n*2187+1781] += + s[1295];
gout[n*2187+1782] += + s[1296];
gout[n*2187+1783] += + s[1297];
gout[n*2187+1784] += + s[1298];
gout[n*2187+1785] += + s[1299];
gout[n*2187+1786] += + s[1300];
gout[n*2187+1787] += + s[1301];
gout[n*2187+1788] += + s[1302];
gout[n*2187+1789] += + s[1303];
gout[n*2187+1790] += + s[1304];
gout[n*2187+1791] += + s[1305];
gout[n*2187+1792] += + s[1306];
gout[n*2187+1793] += + s[1307];
gout[n*2187+1794] += + s[1308];
gout[n*2187+1795] += + s[1309];
gout[n*2187+1796] += + s[1310];
gout[n*2187+1797] += + s[1311];
gout[n*2187+1798] += + s[1312];
gout[n*2187+1799] += + s[1313];
gout[n*2187+1800] += + s[1314];
gout[n*2187+1801] += + s[1315];
gout[n*2187+1802] += + s[1316];
gout[n*2187+1803] += + s[1317];
gout[n*2187+1804] += + s[1318];
gout[n*2187+1805] += + s[1319];
gout[n*2187+1806] += + s[1320];
gout[n*2187+1807] += + s[1321];
gout[n*2187+1808] += + s[1322];
gout[n*2187+1809] += + s[1323];
gout[n*2187+1810] += + s[1324];
gout[n*2187+1811] += + s[1325];
gout[n*2187+1812] += + s[1326];
gout[n*2187+1813] += + s[1327];
gout[n*2187+1814] += + s[1328];
gout[n*2187+1815] += + s[1329];
gout[n*2187+1816] += + s[1330];
gout[n*2187+1817] += + s[1331];
gout[n*2187+1818] += + s[1332];
gout[n*2187+1819] += + s[1333];
gout[n*2187+1820] += + s[1334];
gout[n*2187+1821] += + s[1335];
gout[n*2187+1822] += + s[1336];
gout[n*2187+1823] += + s[1337];
gout[n*2187+1824] += + s[1338];
gout[n*2187+1825] += + s[1339];
gout[n*2187+1826] += + s[1340];
gout[n*2187+1827] += + s[1341];
gout[n*2187+1828] += + s[1342];
gout[n*2187+1829] += + s[1343];
gout[n*2187+1830] += + s[1344];
gout[n*2187+1831] += + s[1345];
gout[n*2187+1832] += + s[1346];
gout[n*2187+1833] += + s[1347];
gout[n*2187+1834] += + s[1348];
gout[n*2187+1835] += + s[1349];
gout[n*2187+1836] += + s[1350];
gout[n*2187+1837] += + s[1351];
gout[n*2187+1838] += + s[1352];
gout[n*2187+1839] += + s[1353];
gout[n*2187+1840] += + s[1354];
gout[n*2187+1841] += + s[1355];
gout[n*2187+1842] += + s[1356];
gout[n*2187+1843] += + s[1357];
gout[n*2187+1844] += + s[1358];
gout[n*2187+1845] += + s[1359];
gout[n*2187+1846] += + s[1360];
gout[n*2187+1847] += + s[1361];
gout[n*2187+1848] += + s[1362];
gout[n*2187+1849] += + s[1363];
gout[n*2187+1850] += + s[1364];
gout[n*2187+1851] += + s[1365];
gout[n*2187+1852] += + s[1366];
gout[n*2187+1853] += + s[1367];
gout[n*2187+1854] += + s[1368];
gout[n*2187+1855] += + s[1369];
gout[n*2187+1856] += + s[1370];
gout[n*2187+1857] += + s[1371];
gout[n*2187+1858] += + s[1372];
gout[n*2187+1859] += + s[1373];
gout[n*2187+1860] += + s[1374];
gout[n*2187+1861] += + s[1375];
gout[n*2187+1862] += + s[1376];
gout[n*2187+1863] += + s[1377];
gout[n*2187+1864] += + s[1378];
gout[n*2187+1865] += + s[1379];
gout[n*2187+1866] += + s[1380];
gout[n*2187+1867] += + s[1381];
gout[n*2187+1868] += + s[1382];
gout[n*2187+1869] += + s[1383];
gout[n*2187+1870] += + s[1384];
gout[n*2187+1871] += + s[1385];
gout[n*2187+1872] += + s[1386];
gout[n*2187+1873] += + s[1387];
gout[n*2187+1874] += + s[1388];
gout[n*2187+1875] += + s[1389];
gout[n*2187+1876] += + s[1390];
gout[n*2187+1877] += + s[1391];
gout[n*2187+1878] += + s[1392];
gout[n*2187+1879] += + s[1393];
gout[n*2187+1880] += + s[1394];
gout[n*2187+1881] += + s[1395];
gout[n*2187+1882] += + s[1396];
gout[n*2187+1883] += + s[1397];
gout[n*2187+1884] += + s[1398];
gout[n*2187+1885] += + s[1399];
gout[n*2187+1886] += + s[1400];
gout[n*2187+1887] += + s[1401];
gout[n*2187+1888] += + s[1402];
gout[n*2187+1889] += + s[1403];
gout[n*2187+1890] += + s[1404];
gout[n*2187+1891] += + s[1405];
gout[n*2187+1892] += + s[1406];
gout[n*2187+1893] += + s[1407];
gout[n*2187+1894] += + s[1408];
gout[n*2187+1895] += + s[1409];
gout[n*2187+1896] += + s[1410];
gout[n*2187+1897] += + s[1411];
gout[n*2187+1898] += + s[1412];
gout[n*2187+1899] += + s[1413];
gout[n*2187+1900] += + s[1414];
gout[n*2187+1901] += + s[1415];
gout[n*2187+1902] += + s[1416];
gout[n*2187+1903] += + s[1417];
gout[n*2187+1904] += + s[1418];
gout[n*2187+1905] += + s[1419];
gout[n*2187+1906] += + s[1420];
gout[n*2187+1907] += + s[1421];
gout[n*2187+1908] += + s[1422];
gout[n*2187+1909] += + s[1423];
gout[n*2187+1910] += + s[1424];
gout[n*2187+1911] += + s[1425];
gout[n*2187+1912] += + s[1426];
gout[n*2187+1913] += + s[1427];
gout[n*2187+1914] += + s[1428];
gout[n*2187+1915] += + s[1429];
gout[n*2187+1916] += + s[1430];
gout[n*2187+1917] += + s[1431];
gout[n*2187+1918] += + s[1432];
gout[n*2187+1919] += + s[1433];
gout[n*2187+1920] += + s[1434];
gout[n*2187+1921] += + s[1435];
gout[n*2187+1922] += + s[1436];
gout[n*2187+1923] += + s[1437];
gout[n*2187+1924] += + s[1438];
gout[n*2187+1925] += + s[1439];
gout[n*2187+1926] += + s[1440];
gout[n*2187+1927] += + s[1441];
gout[n*2187+1928] += + s[1442];
gout[n*2187+1929] += + s[1443];
gout[n*2187+1930] += + s[1444];
gout[n*2187+1931] += + s[1445];
gout[n*2187+1932] += + s[1446];
gout[n*2187+1933] += + s[1447];
gout[n*2187+1934] += + s[1448];
gout[n*2187+1935] += + s[1449];
gout[n*2187+1936] += + s[1450];
gout[n*2187+1937] += + s[1451];
gout[n*2187+1938] += + s[1452];
gout[n*2187+1939] += + s[1453];
gout[n*2187+1940] += + s[1454];
gout[n*2187+1941] += + s[1455];
gout[n*2187+1942] += + s[1456];
gout[n*2187+1943] += + s[1457];
gout[n*2187+1944] += + s[1944];
gout[n*2187+1945] += + s[1945];
gout[n*2187+1946] += + s[1946];
gout[n*2187+1947] += + s[1947];
gout[n*2187+1948] += + s[1948];
gout[n*2187+1949] += + s[1949];
gout[n*2187+1950] += + s[1950];
gout[n*2187+1951] += + s[1951];
gout[n*2187+1952] += + s[1952];
gout[n*2187+1953] += + s[1953];
gout[n*2187+1954] += + s[1954];
gout[n*2187+1955] += + s[1955];
gout[n*2187+1956] += + s[1956];
gout[n*2187+1957] += + s[1957];
gout[n*2187+1958] += + s[1958];
gout[n*2187+1959] += + s[1959];
gout[n*2187+1960] += + s[1960];
gout[n*2187+1961] += + s[1961];
gout[n*2187+1962] += + s[1962];
gout[n*2187+1963] += + s[1963];
gout[n*2187+1964] += + s[1964];
gout[n*2187+1965] += + s[1965];
gout[n*2187+1966] += + s[1966];
gout[n*2187+1967] += + s[1967];
gout[n*2187+1968] += + s[1968];
gout[n*2187+1969] += + s[1969];
gout[n*2187+1970] += + s[1970];
gout[n*2187+1971] += + s[1971];
gout[n*2187+1972] += + s[1972];
gout[n*2187+1973] += + s[1973];
gout[n*2187+1974] += + s[1974];
gout[n*2187+1975] += + s[1975];
gout[n*2187+1976] += + s[1976];
gout[n*2187+1977] += + s[1977];
gout[n*2187+1978] += + s[1978];
gout[n*2187+1979] += + s[1979];
gout[n*2187+1980] += + s[1980];
gout[n*2187+1981] += + s[1981];
gout[n*2187+1982] += + s[1982];
gout[n*2187+1983] += + s[1983];
gout[n*2187+1984] += + s[1984];
gout[n*2187+1985] += + s[1985];
gout[n*2187+1986] += + s[1986];
gout[n*2187+1987] += + s[1987];
gout[n*2187+1988] += + s[1988];
gout[n*2187+1989] += + s[1989];
gout[n*2187+1990] += + s[1990];
gout[n*2187+1991] += + s[1991];
gout[n*2187+1992] += + s[1992];
gout[n*2187+1993] += + s[1993];
gout[n*2187+1994] += + s[1994];
gout[n*2187+1995] += + s[1995];
gout[n*2187+1996] += + s[1996];
gout[n*2187+1997] += + s[1997];
gout[n*2187+1998] += + s[1998];
gout[n*2187+1999] += + s[1999];
gout[n*2187+2000] += + s[2000];
gout[n*2187+2001] += + s[2001];
gout[n*2187+2002] += + s[2002];
gout[n*2187+2003] += + s[2003];
gout[n*2187+2004] += + s[2004];
gout[n*2187+2005] += + s[2005];
gout[n*2187+2006] += + s[2006];
gout[n*2187+2007] += + s[2007];
gout[n*2187+2008] += + s[2008];
gout[n*2187+2009] += + s[2009];
gout[n*2187+2010] += + s[2010];
gout[n*2187+2011] += + s[2011];
gout[n*2187+2012] += + s[2012];
gout[n*2187+2013] += + s[2013];
gout[n*2187+2014] += + s[2014];
gout[n*2187+2015] += + s[2015];
gout[n*2187+2016] += + s[2016];
gout[n*2187+2017] += + s[2017];
gout[n*2187+2018] += + s[2018];
gout[n*2187+2019] += + s[2019];
gout[n*2187+2020] += + s[2020];
gout[n*2187+2021] += + s[2021];
gout[n*2187+2022] += + s[2022];
gout[n*2187+2023] += + s[2023];
gout[n*2187+2024] += + s[2024];
gout[n*2187+2025] += + s[2025];
gout[n*2187+2026] += + s[2026];
gout[n*2187+2027] += + s[2027];
gout[n*2187+2028] += + s[2028];
gout[n*2187+2029] += + s[2029];
gout[n*2187+2030] += + s[2030];
gout[n*2187+2031] += + s[2031];
gout[n*2187+2032] += + s[2032];
gout[n*2187+2033] += + s[2033];
gout[n*2187+2034] += + s[2034];
gout[n*2187+2035] += + s[2035];
gout[n*2187+2036] += + s[2036];
gout[n*2187+2037] += + s[2037];
gout[n*2187+2038] += + s[2038];
gout[n*2187+2039] += + s[2039];
gout[n*2187+2040] += + s[2040];
gout[n*2187+2041] += + s[2041];
gout[n*2187+2042] += + s[2042];
gout[n*2187+2043] += + s[2043];
gout[n*2187+2044] += + s[2044];
gout[n*2187+2045] += + s[2045];
gout[n*2187+2046] += + s[2046];
gout[n*2187+2047] += + s[2047];
gout[n*2187+2048] += + s[2048];
gout[n*2187+2049] += + s[2049];
gout[n*2187+2050] += + s[2050];
gout[n*2187+2051] += + s[2051];
gout[n*2187+2052] += + s[2052];
gout[n*2187+2053] += + s[2053];
gout[n*2187+2054] += + s[2054];
gout[n*2187+2055] += + s[2055];
gout[n*2187+2056] += + s[2056];
gout[n*2187+2057] += + s[2057];
gout[n*2187+2058] += + s[2058];
gout[n*2187+2059] += + s[2059];
gout[n*2187+2060] += + s[2060];
gout[n*2187+2061] += + s[2061];
gout[n*2187+2062] += + s[2062];
gout[n*2187+2063] += + s[2063];
gout[n*2187+2064] += + s[2064];
gout[n*2187+2065] += + s[2065];
gout[n*2187+2066] += + s[2066];
gout[n*2187+2067] += + s[2067];
gout[n*2187+2068] += + s[2068];
gout[n*2187+2069] += + s[2069];
gout[n*2187+2070] += + s[2070];
gout[n*2187+2071] += + s[2071];
gout[n*2187+2072] += + s[2072];
gout[n*2187+2073] += + s[2073];
gout[n*2187+2074] += + s[2074];
gout[n*2187+2075] += + s[2075];
gout[n*2187+2076] += + s[2076];
gout[n*2187+2077] += + s[2077];
gout[n*2187+2078] += + s[2078];
gout[n*2187+2079] += + s[2079];
gout[n*2187+2080] += + s[2080];
gout[n*2187+2081] += + s[2081];
gout[n*2187+2082] += + s[2082];
gout[n*2187+2083] += + s[2083];
gout[n*2187+2084] += + s[2084];
gout[n*2187+2085] += + s[2085];
gout[n*2187+2086] += + s[2086];
gout[n*2187+2087] += + s[2087];
gout[n*2187+2088] += + s[2088];
gout[n*2187+2089] += + s[2089];
gout[n*2187+2090] += + s[2090];
gout[n*2187+2091] += + s[2091];
gout[n*2187+2092] += + s[2092];
gout[n*2187+2093] += + s[2093];
gout[n*2187+2094] += + s[2094];
gout[n*2187+2095] += + s[2095];
gout[n*2187+2096] += + s[2096];
gout[n*2187+2097] += + s[2097];
gout[n*2187+2098] += + s[2098];
gout[n*2187+2099] += + s[2099];
gout[n*2187+2100] += + s[2100];
gout[n*2187+2101] += + s[2101];
gout[n*2187+2102] += + s[2102];
gout[n*2187+2103] += + s[2103];
gout[n*2187+2104] += + s[2104];
gout[n*2187+2105] += + s[2105];
gout[n*2187+2106] += + s[2106];
gout[n*2187+2107] += + s[2107];
gout[n*2187+2108] += + s[2108];
gout[n*2187+2109] += + s[2109];
gout[n*2187+2110] += + s[2110];
gout[n*2187+2111] += + s[2111];
gout[n*2187+2112] += + s[2112];
gout[n*2187+2113] += + s[2113];
gout[n*2187+2114] += + s[2114];
gout[n*2187+2115] += + s[2115];
gout[n*2187+2116] += + s[2116];
gout[n*2187+2117] += + s[2117];
gout[n*2187+2118] += + s[2118];
gout[n*2187+2119] += + s[2119];
gout[n*2187+2120] += + s[2120];
gout[n*2187+2121] += + s[2121];
gout[n*2187+2122] += + s[2122];
gout[n*2187+2123] += + s[2123];
gout[n*2187+2124] += + s[2124];
gout[n*2187+2125] += + s[2125];
gout[n*2187+2126] += + s[2126];
gout[n*2187+2127] += + s[2127];
gout[n*2187+2128] += + s[2128];
gout[n*2187+2129] += + s[2129];
gout[n*2187+2130] += + s[2130];
gout[n*2187+2131] += + s[2131];
gout[n*2187+2132] += + s[2132];
gout[n*2187+2133] += + s[2133];
gout[n*2187+2134] += + s[2134];
gout[n*2187+2135] += + s[2135];
gout[n*2187+2136] += + s[2136];
gout[n*2187+2137] += + s[2137];
gout[n*2187+2138] += + s[2138];
gout[n*2187+2139] += + s[2139];
gout[n*2187+2140] += + s[2140];
gout[n*2187+2141] += + s[2141];
gout[n*2187+2142] += + s[2142];
gout[n*2187+2143] += + s[2143];
gout[n*2187+2144] += + s[2144];
gout[n*2187+2145] += + s[2145];
gout[n*2187+2146] += + s[2146];
gout[n*2187+2147] += + s[2147];
gout[n*2187+2148] += + s[2148];
gout[n*2187+2149] += + s[2149];
gout[n*2187+2150] += + s[2150];
gout[n*2187+2151] += + s[2151];
gout[n*2187+2152] += + s[2152];
gout[n*2187+2153] += + s[2153];
gout[n*2187+2154] += + s[2154];
gout[n*2187+2155] += + s[2155];
gout[n*2187+2156] += + s[2156];
gout[n*2187+2157] += + s[2157];
gout[n*2187+2158] += + s[2158];
gout[n*2187+2159] += + s[2159];
gout[n*2187+2160] += + s[2160];
gout[n*2187+2161] += + s[2161];
gout[n*2187+2162] += + s[2162];
gout[n*2187+2163] += + s[2163];
gout[n*2187+2164] += + s[2164];
gout[n*2187+2165] += + s[2165];
gout[n*2187+2166] += + s[2166];
gout[n*2187+2167] += + s[2167];
gout[n*2187+2168] += + s[2168];
gout[n*2187+2169] += + s[2169];
gout[n*2187+2170] += + s[2170];
gout[n*2187+2171] += + s[2171];
gout[n*2187+2172] += + s[2172];
gout[n*2187+2173] += + s[2173];
gout[n*2187+2174] += + s[2174];
gout[n*2187+2175] += + s[2175];
gout[n*2187+2176] += + s[2176];
gout[n*2187+2177] += + s[2177];
gout[n*2187+2178] += + s[2178];
gout[n*2187+2179] += + s[2179];
gout[n*2187+2180] += + s[2180];
gout[n*2187+2181] += + s[2181];
gout[n*2187+2182] += + s[2182];
gout[n*2187+2183] += + s[2183];
gout[n*2187+2184] += + s[2184];
gout[n*2187+2185] += + s[2185];
gout[n*2187+2186] += + s[2186];
}}}
void int1e_ipipnnnipip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 2187};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipnnnipip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipnnnipip_cart
CACHE_SIZE_T int1e_ipipnnnipip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnnipip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipnnnipip_sph
CACHE_SIZE_T int1e_ipipnnnipip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 2187};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipnnnipip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipnnnipip_spinor
ALL_CINT1E(int1e_ipipnnnipip)
ALL_CINT1E_FORTRAN_(int1e_ipipnnnipip)
/* <i|R |j> */
void CINTgout1e_int1e_j(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double s[3];
G1E_R_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[0];
gout[n*3+1] = + s[1];
gout[n*3+2] = + s[2];
} else {
gout[n*3+0] += + s[0];
gout[n*3+1] += + s[1];
gout[n*3+2] += + s[2];
}}}
void int1e_j_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_j_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_j;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_j_cart
CACHE_SIZE_T int1e_j_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_j;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_j_sph
CACHE_SIZE_T int1e_j_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_j;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_j_spinor
ALL_CINT1E(int1e_j)
ALL_CINT1E_FORTRAN_(int1e_j)
/* <i|R R |j> */
void CINTgout1e_int1e_jj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double s[9];
G1E_R_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_jj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_jj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_jj_cart
CACHE_SIZE_T int1e_jj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_jj_sph
CACHE_SIZE_T int1e_jj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_jj_spinor
ALL_CINT1E(int1e_jj)
ALL_CINT1E_FORTRAN_(int1e_jj)
/* <i|R R R |j> */
void CINTgout1e_int1e_jjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double s[27];
G1E_R_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_R_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_R_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_jjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_jjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_jjj_cart
CACHE_SIZE_T int1e_jjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_jjj_sph
CACHE_SIZE_T int1e_jjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_jjj_spinor
ALL_CINT1E(int1e_jjj)
ALL_CINT1E_FORTRAN_(int1e_jjj)
/* <NABLA i|R |j> */
void CINTgout1e_int1e_ipj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double s[9];
G1E_R_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_ipj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipj_cart
CACHE_SIZE_T int1e_ipj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipj_sph
CACHE_SIZE_T int1e_ipj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 1, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipj_spinor
ALL_CINT1E(int1e_ipj)
ALL_CINT1E_FORTRAN_(int1e_ipj)
/* <i|R |NABLA j> */
void CINTgout1e_int1e_jip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double s[9];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_jip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_jip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_jip_cart
CACHE_SIZE_T int1e_jip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_jip_sph
CACHE_SIZE_T int1e_jip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_jip_spinor
ALL_CINT1E(int1e_jip)
ALL_CINT1E_FORTRAN_(int1e_jip)
/* <NABLA i|R R |j> */
void CINTgout1e_int1e_ipjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double s[27];
G1E_R_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_ipjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipjj_cart
CACHE_SIZE_T int1e_ipjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipjj_sph
CACHE_SIZE_T int1e_ipjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipjj_spinor
ALL_CINT1E(int1e_ipjj)
ALL_CINT1E_FORTRAN_(int1e_ipjj)
/* <i|R R |NABLA j> */
void CINTgout1e_int1e_jjip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double s[27];
G1E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_jjip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_jjip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jjip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_jjip_cart
CACHE_SIZE_T int1e_jjip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jjip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_jjip_sph
CACHE_SIZE_T int1e_jjip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_jjip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_jjip_spinor
ALL_CINT1E(int1e_jjip)
ALL_CINT1E_FORTRAN_(int1e_jjip)
/* <NABLA i|R R |NABLA j> */
void CINTgout1e_int1e_ipjjip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double s[81];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipjjip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipjjip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjjip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipjjip_cart
CACHE_SIZE_T int1e_ipjjip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjjip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipjjip_sph
CACHE_SIZE_T int1e_ipjjip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjjip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipjjip_spinor
ALL_CINT1E(int1e_ipjjip)
ALL_CINT1E_FORTRAN_(int1e_ipjjip)
/* <NABLA NABLA i|R R |j> */
void CINTgout1e_int1e_ipipjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double s[81];
G1E_R_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[27];
gout[n*81+10] = + s[28];
gout[n*81+11] = + s[29];
gout[n*81+12] = + s[30];
gout[n*81+13] = + s[31];
gout[n*81+14] = + s[32];
gout[n*81+15] = + s[33];
gout[n*81+16] = + s[34];
gout[n*81+17] = + s[35];
gout[n*81+18] = + s[54];
gout[n*81+19] = + s[55];
gout[n*81+20] = + s[56];
gout[n*81+21] = + s[57];
gout[n*81+22] = + s[58];
gout[n*81+23] = + s[59];
gout[n*81+24] = + s[60];
gout[n*81+25] = + s[61];
gout[n*81+26] = + s[62];
gout[n*81+27] = + s[9];
gout[n*81+28] = + s[10];
gout[n*81+29] = + s[11];
gout[n*81+30] = + s[12];
gout[n*81+31] = + s[13];
gout[n*81+32] = + s[14];
gout[n*81+33] = + s[15];
gout[n*81+34] = + s[16];
gout[n*81+35] = + s[17];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[63];
gout[n*81+46] = + s[64];
gout[n*81+47] = + s[65];
gout[n*81+48] = + s[66];
gout[n*81+49] = + s[67];
gout[n*81+50] = + s[68];
gout[n*81+51] = + s[69];
gout[n*81+52] = + s[70];
gout[n*81+53] = + s[71];
gout[n*81+54] = + s[18];
gout[n*81+55] = + s[19];
gout[n*81+56] = + s[20];
gout[n*81+57] = + s[21];
gout[n*81+58] = + s[22];
gout[n*81+59] = + s[23];
gout[n*81+60] = + s[24];
gout[n*81+61] = + s[25];
gout[n*81+62] = + s[26];
gout[n*81+63] = + s[45];
gout[n*81+64] = + s[46];
gout[n*81+65] = + s[47];
gout[n*81+66] = + s[48];
gout[n*81+67] = + s[49];
gout[n*81+68] = + s[50];
gout[n*81+69] = + s[51];
gout[n*81+70] = + s[52];
gout[n*81+71] = + s[53];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[27];
gout[n*81+10] += + s[28];
gout[n*81+11] += + s[29];
gout[n*81+12] += + s[30];
gout[n*81+13] += + s[31];
gout[n*81+14] += + s[32];
gout[n*81+15] += + s[33];
gout[n*81+16] += + s[34];
gout[n*81+17] += + s[35];
gout[n*81+18] += + s[54];
gout[n*81+19] += + s[55];
gout[n*81+20] += + s[56];
gout[n*81+21] += + s[57];
gout[n*81+22] += + s[58];
gout[n*81+23] += + s[59];
gout[n*81+24] += + s[60];
gout[n*81+25] += + s[61];
gout[n*81+26] += + s[62];
gout[n*81+27] += + s[9];
gout[n*81+28] += + s[10];
gout[n*81+29] += + s[11];
gout[n*81+30] += + s[12];
gout[n*81+31] += + s[13];
gout[n*81+32] += + s[14];
gout[n*81+33] += + s[15];
gout[n*81+34] += + s[16];
gout[n*81+35] += + s[17];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[63];
gout[n*81+46] += + s[64];
gout[n*81+47] += + s[65];
gout[n*81+48] += + s[66];
gout[n*81+49] += + s[67];
gout[n*81+50] += + s[68];
gout[n*81+51] += + s[69];
gout[n*81+52] += + s[70];
gout[n*81+53] += + s[71];
gout[n*81+54] += + s[18];
gout[n*81+55] += + s[19];
gout[n*81+56] += + s[20];
gout[n*81+57] += + s[21];
gout[n*81+58] += + s[22];
gout[n*81+59] += + s[23];
gout[n*81+60] += + s[24];
gout[n*81+61] += + s[25];
gout[n*81+62] += + s[26];
gout[n*81+63] += + s[45];
gout[n*81+64] += + s[46];
gout[n*81+65] += + s[47];
gout[n*81+66] += + s[48];
gout[n*81+67] += + s[49];
gout[n*81+68] += + s[50];
gout[n*81+69] += + s[51];
gout[n*81+70] += + s[52];
gout[n*81+71] += + s[53];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipipjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipjj_cart
CACHE_SIZE_T int1e_ipipjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipjj_sph
CACHE_SIZE_T int1e_ipipjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipjj_spinor
ALL_CINT1E(int1e_ipipjj)
ALL_CINT1E_FORTRAN_(int1e_ipipjj)
/* <NABLA NABLA NABLA i|R R |j> */
void CINTgout1e_int1e_ipipipjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double s[243];
G1E_R_J(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[81];
gout[n*243+10] = + s[82];
gout[n*243+11] = + s[83];
gout[n*243+12] = + s[84];
gout[n*243+13] = + s[85];
gout[n*243+14] = + s[86];
gout[n*243+15] = + s[87];
gout[n*243+16] = + s[88];
gout[n*243+17] = + s[89];
gout[n*243+18] = + s[162];
gout[n*243+19] = + s[163];
gout[n*243+20] = + s[164];
gout[n*243+21] = + s[165];
gout[n*243+22] = + s[166];
gout[n*243+23] = + s[167];
gout[n*243+24] = + s[168];
gout[n*243+25] = + s[169];
gout[n*243+26] = + s[170];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[108];
gout[n*243+37] = + s[109];
gout[n*243+38] = + s[110];
gout[n*243+39] = + s[111];
gout[n*243+40] = + s[112];
gout[n*243+41] = + s[113];
gout[n*243+42] = + s[114];
gout[n*243+43] = + s[115];
gout[n*243+44] = + s[116];
gout[n*243+45] = + s[189];
gout[n*243+46] = + s[190];
gout[n*243+47] = + s[191];
gout[n*243+48] = + s[192];
gout[n*243+49] = + s[193];
gout[n*243+50] = + s[194];
gout[n*243+51] = + s[195];
gout[n*243+52] = + s[196];
gout[n*243+53] = + s[197];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[135];
gout[n*243+64] = + s[136];
gout[n*243+65] = + s[137];
gout[n*243+66] = + s[138];
gout[n*243+67] = + s[139];
gout[n*243+68] = + s[140];
gout[n*243+69] = + s[141];
gout[n*243+70] = + s[142];
gout[n*243+71] = + s[143];
gout[n*243+72] = + s[216];
gout[n*243+73] = + s[217];
gout[n*243+74] = + s[218];
gout[n*243+75] = + s[219];
gout[n*243+76] = + s[220];
gout[n*243+77] = + s[221];
gout[n*243+78] = + s[222];
gout[n*243+79] = + s[223];
gout[n*243+80] = + s[224];
gout[n*243+81] = + s[9];
gout[n*243+82] = + s[10];
gout[n*243+83] = + s[11];
gout[n*243+84] = + s[12];
gout[n*243+85] = + s[13];
gout[n*243+86] = + s[14];
gout[n*243+87] = + s[15];
gout[n*243+88] = + s[16];
gout[n*243+89] = + s[17];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[171];
gout[n*243+100] = + s[172];
gout[n*243+101] = + s[173];
gout[n*243+102] = + s[174];
gout[n*243+103] = + s[175];
gout[n*243+104] = + s[176];
gout[n*243+105] = + s[177];
gout[n*243+106] = + s[178];
gout[n*243+107] = + s[179];
gout[n*243+108] = + s[36];
gout[n*243+109] = + s[37];
gout[n*243+110] = + s[38];
gout[n*243+111] = + s[39];
gout[n*243+112] = + s[40];
gout[n*243+113] = + s[41];
gout[n*243+114] = + s[42];
gout[n*243+115] = + s[43];
gout[n*243+116] = + s[44];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[198];
gout[n*243+127] = + s[199];
gout[n*243+128] = + s[200];
gout[n*243+129] = + s[201];
gout[n*243+130] = + s[202];
gout[n*243+131] = + s[203];
gout[n*243+132] = + s[204];
gout[n*243+133] = + s[205];
gout[n*243+134] = + s[206];
gout[n*243+135] = + s[63];
gout[n*243+136] = + s[64];
gout[n*243+137] = + s[65];
gout[n*243+138] = + s[66];
gout[n*243+139] = + s[67];
gout[n*243+140] = + s[68];
gout[n*243+141] = + s[69];
gout[n*243+142] = + s[70];
gout[n*243+143] = + s[71];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[225];
gout[n*243+154] = + s[226];
gout[n*243+155] = + s[227];
gout[n*243+156] = + s[228];
gout[n*243+157] = + s[229];
gout[n*243+158] = + s[230];
gout[n*243+159] = + s[231];
gout[n*243+160] = + s[232];
gout[n*243+161] = + s[233];
gout[n*243+162] = + s[18];
gout[n*243+163] = + s[19];
gout[n*243+164] = + s[20];
gout[n*243+165] = + s[21];
gout[n*243+166] = + s[22];
gout[n*243+167] = + s[23];
gout[n*243+168] = + s[24];
gout[n*243+169] = + s[25];
gout[n*243+170] = + s[26];
gout[n*243+171] = + s[99];
gout[n*243+172] = + s[100];
gout[n*243+173] = + s[101];
gout[n*243+174] = + s[102];
gout[n*243+175] = + s[103];
gout[n*243+176] = + s[104];
gout[n*243+177] = + s[105];
gout[n*243+178] = + s[106];
gout[n*243+179] = + s[107];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[45];
gout[n*243+190] = + s[46];
gout[n*243+191] = + s[47];
gout[n*243+192] = + s[48];
gout[n*243+193] = + s[49];
gout[n*243+194] = + s[50];
gout[n*243+195] = + s[51];
gout[n*243+196] = + s[52];
gout[n*243+197] = + s[53];
gout[n*243+198] = + s[126];
gout[n*243+199] = + s[127];
gout[n*243+200] = + s[128];
gout[n*243+201] = + s[129];
gout[n*243+202] = + s[130];
gout[n*243+203] = + s[131];
gout[n*243+204] = + s[132];
gout[n*243+205] = + s[133];
gout[n*243+206] = + s[134];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[72];
gout[n*243+217] = + s[73];
gout[n*243+218] = + s[74];
gout[n*243+219] = + s[75];
gout[n*243+220] = + s[76];
gout[n*243+221] = + s[77];
gout[n*243+222] = + s[78];
gout[n*243+223] = + s[79];
gout[n*243+224] = + s[80];
gout[n*243+225] = + s[153];
gout[n*243+226] = + s[154];
gout[n*243+227] = + s[155];
gout[n*243+228] = + s[156];
gout[n*243+229] = + s[157];
gout[n*243+230] = + s[158];
gout[n*243+231] = + s[159];
gout[n*243+232] = + s[160];
gout[n*243+233] = + s[161];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[81];
gout[n*243+10] += + s[82];
gout[n*243+11] += + s[83];
gout[n*243+12] += + s[84];
gout[n*243+13] += + s[85];
gout[n*243+14] += + s[86];
gout[n*243+15] += + s[87];
gout[n*243+16] += + s[88];
gout[n*243+17] += + s[89];
gout[n*243+18] += + s[162];
gout[n*243+19] += + s[163];
gout[n*243+20] += + s[164];
gout[n*243+21] += + s[165];
gout[n*243+22] += + s[166];
gout[n*243+23] += + s[167];
gout[n*243+24] += + s[168];
gout[n*243+25] += + s[169];
gout[n*243+26] += + s[170];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[108];
gout[n*243+37] += + s[109];
gout[n*243+38] += + s[110];
gout[n*243+39] += + s[111];
gout[n*243+40] += + s[112];
gout[n*243+41] += + s[113];
gout[n*243+42] += + s[114];
gout[n*243+43] += + s[115];
gout[n*243+44] += + s[116];
gout[n*243+45] += + s[189];
gout[n*243+46] += + s[190];
gout[n*243+47] += + s[191];
gout[n*243+48] += + s[192];
gout[n*243+49] += + s[193];
gout[n*243+50] += + s[194];
gout[n*243+51] += + s[195];
gout[n*243+52] += + s[196];
gout[n*243+53] += + s[197];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[135];
gout[n*243+64] += + s[136];
gout[n*243+65] += + s[137];
gout[n*243+66] += + s[138];
gout[n*243+67] += + s[139];
gout[n*243+68] += + s[140];
gout[n*243+69] += + s[141];
gout[n*243+70] += + s[142];
gout[n*243+71] += + s[143];
gout[n*243+72] += + s[216];
gout[n*243+73] += + s[217];
gout[n*243+74] += + s[218];
gout[n*243+75] += + s[219];
gout[n*243+76] += + s[220];
gout[n*243+77] += + s[221];
gout[n*243+78] += + s[222];
gout[n*243+79] += + s[223];
gout[n*243+80] += + s[224];
gout[n*243+81] += + s[9];
gout[n*243+82] += + s[10];
gout[n*243+83] += + s[11];
gout[n*243+84] += + s[12];
gout[n*243+85] += + s[13];
gout[n*243+86] += + s[14];
gout[n*243+87] += + s[15];
gout[n*243+88] += + s[16];
gout[n*243+89] += + s[17];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[171];
gout[n*243+100] += + s[172];
gout[n*243+101] += + s[173];
gout[n*243+102] += + s[174];
gout[n*243+103] += + s[175];
gout[n*243+104] += + s[176];
gout[n*243+105] += + s[177];
gout[n*243+106] += + s[178];
gout[n*243+107] += + s[179];
gout[n*243+108] += + s[36];
gout[n*243+109] += + s[37];
gout[n*243+110] += + s[38];
gout[n*243+111] += + s[39];
gout[n*243+112] += + s[40];
gout[n*243+113] += + s[41];
gout[n*243+114] += + s[42];
gout[n*243+115] += + s[43];
gout[n*243+116] += + s[44];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[198];
gout[n*243+127] += + s[199];
gout[n*243+128] += + s[200];
gout[n*243+129] += + s[201];
gout[n*243+130] += + s[202];
gout[n*243+131] += + s[203];
gout[n*243+132] += + s[204];
gout[n*243+133] += + s[205];
gout[n*243+134] += + s[206];
gout[n*243+135] += + s[63];
gout[n*243+136] += + s[64];
gout[n*243+137] += + s[65];
gout[n*243+138] += + s[66];
gout[n*243+139] += + s[67];
gout[n*243+140] += + s[68];
gout[n*243+141] += + s[69];
gout[n*243+142] += + s[70];
gout[n*243+143] += + s[71];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[225];
gout[n*243+154] += + s[226];
gout[n*243+155] += + s[227];
gout[n*243+156] += + s[228];
gout[n*243+157] += + s[229];
gout[n*243+158] += + s[230];
gout[n*243+159] += + s[231];
gout[n*243+160] += + s[232];
gout[n*243+161] += + s[233];
gout[n*243+162] += + s[18];
gout[n*243+163] += + s[19];
gout[n*243+164] += + s[20];
gout[n*243+165] += + s[21];
gout[n*243+166] += + s[22];
gout[n*243+167] += + s[23];
gout[n*243+168] += + s[24];
gout[n*243+169] += + s[25];
gout[n*243+170] += + s[26];
gout[n*243+171] += + s[99];
gout[n*243+172] += + s[100];
gout[n*243+173] += + s[101];
gout[n*243+174] += + s[102];
gout[n*243+175] += + s[103];
gout[n*243+176] += + s[104];
gout[n*243+177] += + s[105];
gout[n*243+178] += + s[106];
gout[n*243+179] += + s[107];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[45];
gout[n*243+190] += + s[46];
gout[n*243+191] += + s[47];
gout[n*243+192] += + s[48];
gout[n*243+193] += + s[49];
gout[n*243+194] += + s[50];
gout[n*243+195] += + s[51];
gout[n*243+196] += + s[52];
gout[n*243+197] += + s[53];
gout[n*243+198] += + s[126];
gout[n*243+199] += + s[127];
gout[n*243+200] += + s[128];
gout[n*243+201] += + s[129];
gout[n*243+202] += + s[130];
gout[n*243+203] += + s[131];
gout[n*243+204] += + s[132];
gout[n*243+205] += + s[133];
gout[n*243+206] += + s[134];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[72];
gout[n*243+217] += + s[73];
gout[n*243+218] += + s[74];
gout[n*243+219] += + s[75];
gout[n*243+220] += + s[76];
gout[n*243+221] += + s[77];
gout[n*243+222] += + s[78];
gout[n*243+223] += + s[79];
gout[n*243+224] += + s[80];
gout[n*243+225] += + s[153];
gout[n*243+226] += + s[154];
gout[n*243+227] += + s[155];
gout[n*243+228] += + s[156];
gout[n*243+229] += + s[157];
gout[n*243+230] += + s[158];
gout[n*243+231] += + s[159];
gout[n*243+232] += + s[160];
gout[n*243+233] += + s[161];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipipjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipjj_cart
CACHE_SIZE_T int1e_ipipipjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipjj_sph
CACHE_SIZE_T int1e_ipipipjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipjj_spinor
ALL_CINT1E(int1e_ipipipjj)
ALL_CINT1E_FORTRAN_(int1e_ipipipjj)
/* <NABLA NABLA i|R R |NABLA j> */
void CINTgout1e_int1e_ipipjjip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double s[243];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipjjip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipjjip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipjjip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipjjip_cart
CACHE_SIZE_T int1e_ipipjjip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipjjip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipjjip_sph
CACHE_SIZE_T int1e_ipipjjip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipjjip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipjjip_spinor
ALL_CINT1E(int1e_ipipjjip)
ALL_CINT1E_FORTRAN_(int1e_ipipjjip)
/* <NABLA i|R R R |j> */
void CINTgout1e_int1e_ipjjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double s[81];
G1E_R_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_R_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_R_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipjjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipjjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipjjj_cart
CACHE_SIZE_T int1e_ipjjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipjjj_sph
CACHE_SIZE_T int1e_ipjjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipjjj_spinor
ALL_CINT1E(int1e_ipjjj)
ALL_CINT1E_FORTRAN_(int1e_ipjjj)
/* <NABLA i|R R R |NABLA j> */
void CINTgout1e_int1e_ipjjjip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double s[243];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_R_J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipjjjip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipjjjip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjjjip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipjjjip_cart
CACHE_SIZE_T int1e_ipjjjip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjjjip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipjjjip_sph
CACHE_SIZE_T int1e_ipjjjip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipjjjip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipjjjip_spinor
ALL_CINT1E(int1e_ipjjjip)
ALL_CINT1E_FORTRAN_(int1e_ipjjjip)
/* <NABLA NABLA i|R R R |j> */
void CINTgout1e_int1e_ipipjjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double s[243];
G1E_R_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_R_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_R_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipjjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipjjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipjjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipjjj_cart
CACHE_SIZE_T int1e_ipipjjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipjjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipjjj_sph
CACHE_SIZE_T int1e_ipipjjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipjjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipjjj_spinor
ALL_CINT1E(int1e_ipipjjj)
ALL_CINT1E_FORTRAN_(int1e_ipipjjj)
/* <i|R0 |j> */
void CINTgout1e_int1e_r0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double s[3];
G1E_R0J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
if (gout_empty) {
gout[n*3+0] = + s[0];
gout[n*3+1] = + s[1];
gout[n*3+2] = + s[2];
} else {
gout[n*3+0] += + s[0];
gout[n*3+1] += + s[1];
gout[n*3+2] += + s[2];
}}}
void int1e_r0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_r0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_r0_cart
CACHE_SIZE_T int1e_r0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_r0_sph
CACHE_SIZE_T int1e_r0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 1, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_r0_spinor
ALL_CINT1E(int1e_r0)
ALL_CINT1E_FORTRAN_(int1e_r0)
/* <i|R0 R0 |j> */
void CINTgout1e_int1e_r0r0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double s[9];
G1E_R0J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_R0J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g3[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g2[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g2[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g1[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g0[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g0[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g1[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g0[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g0[ix+0]*g0[iy+0]*g3[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0];
gout[n*9+1] = + s[1];
gout[n*9+2] = + s[2];
gout[n*9+3] = + s[3];
gout[n*9+4] = + s[4];
gout[n*9+5] = + s[5];
gout[n*9+6] = + s[6];
gout[n*9+7] = + s[7];
gout[n*9+8] = + s[8];
} else {
gout[n*9+0] += + s[0];
gout[n*9+1] += + s[1];
gout[n*9+2] += + s[2];
gout[n*9+3] += + s[3];
gout[n*9+4] += + s[4];
gout[n*9+5] += + s[5];
gout[n*9+6] += + s[6];
gout[n*9+7] += + s[7];
gout[n*9+8] += + s[8];
}}}
void int1e_r0r0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_r0r0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_r0r0_cart
CACHE_SIZE_T int1e_r0r0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_r0r0_sph
CACHE_SIZE_T int1e_r0r0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 2, 0, 0, 2, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r0r0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_r0r0_spinor
ALL_CINT1E(int1e_r0r0)
ALL_CINT1E_FORTRAN_(int1e_r0r0)
/* <i|R0 R0 R0 |j> */
void CINTgout1e_int1e_r0r0r0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double s[27];
G1E_R0J(g1, g0, envs->i_l+0, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+0, envs->j_l+1, 0);
G1E_R0J(g3, g2, envs->i_l+0, envs->j_l+0, 0);
G1E_R0J(g4, g0, envs->i_l+0, envs->j_l+2, 0);
G1E_R0J(g5, g4, envs->i_l+0, envs->j_l+0, 0);
G1E_R0J(g6, g4, envs->i_l+0, envs->j_l+1, 0);
G1E_R0J(g7, g6, envs->i_l+0, envs->j_l+0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_r0r0r0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_r0r0r0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r0r0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_r0r0r0_cart
CACHE_SIZE_T int1e_r0r0r0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r0r0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_r0r0r0_sph
CACHE_SIZE_T int1e_r0r0r0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {0, 3, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_r0r0r0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_r0r0r0_spinor
ALL_CINT1E(int1e_r0r0r0)
ALL_CINT1E_FORTRAN_(int1e_r0r0r0)
/* <NABLA i|R0 R0 |j> */
void CINTgout1e_int1e_ipr0r0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double s[27];
G1E_R0J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_R0J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g7[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g6[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g6[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g5[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g4[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g4[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g5[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g4[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g4[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g3[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g2[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g2[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g1[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g0[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g0[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g1[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g0[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g0[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g3[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g2[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g2[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g1[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g0[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g0[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g1[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g0[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g0[ix+0]*g0[iy+0]*g7[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0];
gout[n*27+1] = + s[1];
gout[n*27+2] = + s[2];
gout[n*27+3] = + s[3];
gout[n*27+4] = + s[4];
gout[n*27+5] = + s[5];
gout[n*27+6] = + s[6];
gout[n*27+7] = + s[7];
gout[n*27+8] = + s[8];
gout[n*27+9] = + s[9];
gout[n*27+10] = + s[10];
gout[n*27+11] = + s[11];
gout[n*27+12] = + s[12];
gout[n*27+13] = + s[13];
gout[n*27+14] = + s[14];
gout[n*27+15] = + s[15];
gout[n*27+16] = + s[16];
gout[n*27+17] = + s[17];
gout[n*27+18] = + s[18];
gout[n*27+19] = + s[19];
gout[n*27+20] = + s[20];
gout[n*27+21] = + s[21];
gout[n*27+22] = + s[22];
gout[n*27+23] = + s[23];
gout[n*27+24] = + s[24];
gout[n*27+25] = + s[25];
gout[n*27+26] = + s[26];
} else {
gout[n*27+0] += + s[0];
gout[n*27+1] += + s[1];
gout[n*27+2] += + s[2];
gout[n*27+3] += + s[3];
gout[n*27+4] += + s[4];
gout[n*27+5] += + s[5];
gout[n*27+6] += + s[6];
gout[n*27+7] += + s[7];
gout[n*27+8] += + s[8];
gout[n*27+9] += + s[9];
gout[n*27+10] += + s[10];
gout[n*27+11] += + s[11];
gout[n*27+12] += + s[12];
gout[n*27+13] += + s[13];
gout[n*27+14] += + s[14];
gout[n*27+15] += + s[15];
gout[n*27+16] += + s[16];
gout[n*27+17] += + s[17];
gout[n*27+18] += + s[18];
gout[n*27+19] += + s[19];
gout[n*27+20] += + s[20];
gout[n*27+21] += + s[21];
gout[n*27+22] += + s[22];
gout[n*27+23] += + s[23];
gout[n*27+24] += + s[24];
gout[n*27+25] += + s[25];
gout[n*27+26] += + s[26];
}}}
void int1e_ipr0r0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipr0r0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipr0r0_cart
CACHE_SIZE_T int1e_ipr0r0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipr0r0_sph
CACHE_SIZE_T int1e_ipr0r0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipr0r0_spinor
ALL_CINT1E(int1e_ipr0r0)
ALL_CINT1E_FORTRAN_(int1e_ipr0r0)
/* <NABLA i|R0 R0 |NABLA j> */
void CINTgout1e_int1e_ipr0r0ip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double s[81];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipr0r0ip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipr0r0ip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0ip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipr0r0ip_cart
CACHE_SIZE_T int1e_ipr0r0ip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0ip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipr0r0ip_sph
CACHE_SIZE_T int1e_ipr0r0ip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0ip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipr0r0ip_spinor
ALL_CINT1E(int1e_ipr0r0ip)
ALL_CINT1E_FORTRAN_(int1e_ipr0r0ip)
/* <NABLA NABLA i|R0 R0 |j> */
void CINTgout1e_int1e_ipipr0r0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double s[81];
G1E_R0J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_R0J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[27];
gout[n*81+10] = + s[28];
gout[n*81+11] = + s[29];
gout[n*81+12] = + s[30];
gout[n*81+13] = + s[31];
gout[n*81+14] = + s[32];
gout[n*81+15] = + s[33];
gout[n*81+16] = + s[34];
gout[n*81+17] = + s[35];
gout[n*81+18] = + s[54];
gout[n*81+19] = + s[55];
gout[n*81+20] = + s[56];
gout[n*81+21] = + s[57];
gout[n*81+22] = + s[58];
gout[n*81+23] = + s[59];
gout[n*81+24] = + s[60];
gout[n*81+25] = + s[61];
gout[n*81+26] = + s[62];
gout[n*81+27] = + s[9];
gout[n*81+28] = + s[10];
gout[n*81+29] = + s[11];
gout[n*81+30] = + s[12];
gout[n*81+31] = + s[13];
gout[n*81+32] = + s[14];
gout[n*81+33] = + s[15];
gout[n*81+34] = + s[16];
gout[n*81+35] = + s[17];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[63];
gout[n*81+46] = + s[64];
gout[n*81+47] = + s[65];
gout[n*81+48] = + s[66];
gout[n*81+49] = + s[67];
gout[n*81+50] = + s[68];
gout[n*81+51] = + s[69];
gout[n*81+52] = + s[70];
gout[n*81+53] = + s[71];
gout[n*81+54] = + s[18];
gout[n*81+55] = + s[19];
gout[n*81+56] = + s[20];
gout[n*81+57] = + s[21];
gout[n*81+58] = + s[22];
gout[n*81+59] = + s[23];
gout[n*81+60] = + s[24];
gout[n*81+61] = + s[25];
gout[n*81+62] = + s[26];
gout[n*81+63] = + s[45];
gout[n*81+64] = + s[46];
gout[n*81+65] = + s[47];
gout[n*81+66] = + s[48];
gout[n*81+67] = + s[49];
gout[n*81+68] = + s[50];
gout[n*81+69] = + s[51];
gout[n*81+70] = + s[52];
gout[n*81+71] = + s[53];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[27];
gout[n*81+10] += + s[28];
gout[n*81+11] += + s[29];
gout[n*81+12] += + s[30];
gout[n*81+13] += + s[31];
gout[n*81+14] += + s[32];
gout[n*81+15] += + s[33];
gout[n*81+16] += + s[34];
gout[n*81+17] += + s[35];
gout[n*81+18] += + s[54];
gout[n*81+19] += + s[55];
gout[n*81+20] += + s[56];
gout[n*81+21] += + s[57];
gout[n*81+22] += + s[58];
gout[n*81+23] += + s[59];
gout[n*81+24] += + s[60];
gout[n*81+25] += + s[61];
gout[n*81+26] += + s[62];
gout[n*81+27] += + s[9];
gout[n*81+28] += + s[10];
gout[n*81+29] += + s[11];
gout[n*81+30] += + s[12];
gout[n*81+31] += + s[13];
gout[n*81+32] += + s[14];
gout[n*81+33] += + s[15];
gout[n*81+34] += + s[16];
gout[n*81+35] += + s[17];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[63];
gout[n*81+46] += + s[64];
gout[n*81+47] += + s[65];
gout[n*81+48] += + s[66];
gout[n*81+49] += + s[67];
gout[n*81+50] += + s[68];
gout[n*81+51] += + s[69];
gout[n*81+52] += + s[70];
gout[n*81+53] += + s[71];
gout[n*81+54] += + s[18];
gout[n*81+55] += + s[19];
gout[n*81+56] += + s[20];
gout[n*81+57] += + s[21];
gout[n*81+58] += + s[22];
gout[n*81+59] += + s[23];
gout[n*81+60] += + s[24];
gout[n*81+61] += + s[25];
gout[n*81+62] += + s[26];
gout[n*81+63] += + s[45];
gout[n*81+64] += + s[46];
gout[n*81+65] += + s[47];
gout[n*81+66] += + s[48];
gout[n*81+67] += + s[49];
gout[n*81+68] += + s[50];
gout[n*81+69] += + s[51];
gout[n*81+70] += + s[52];
gout[n*81+71] += + s[53];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipipr0r0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipr0r0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipr0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipr0r0_cart
CACHE_SIZE_T int1e_ipipr0r0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipr0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipr0r0_sph
CACHE_SIZE_T int1e_ipipr0r0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipr0r0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipr0r0_spinor
ALL_CINT1E(int1e_ipipr0r0)
ALL_CINT1E_FORTRAN_(int1e_ipipr0r0)
/* <NABLA NABLA NABLA i|R0 R0 |j> */
void CINTgout1e_int1e_ipipipr0r0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double s[243];
G1E_R0J(g1, g0, envs->i_l+3, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+3, envs->j_l+1, 0);
G1E_R0J(g3, g2, envs->i_l+3, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+2, envs->j_l, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[81];
gout[n*243+10] = + s[82];
gout[n*243+11] = + s[83];
gout[n*243+12] = + s[84];
gout[n*243+13] = + s[85];
gout[n*243+14] = + s[86];
gout[n*243+15] = + s[87];
gout[n*243+16] = + s[88];
gout[n*243+17] = + s[89];
gout[n*243+18] = + s[162];
gout[n*243+19] = + s[163];
gout[n*243+20] = + s[164];
gout[n*243+21] = + s[165];
gout[n*243+22] = + s[166];
gout[n*243+23] = + s[167];
gout[n*243+24] = + s[168];
gout[n*243+25] = + s[169];
gout[n*243+26] = + s[170];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[108];
gout[n*243+37] = + s[109];
gout[n*243+38] = + s[110];
gout[n*243+39] = + s[111];
gout[n*243+40] = + s[112];
gout[n*243+41] = + s[113];
gout[n*243+42] = + s[114];
gout[n*243+43] = + s[115];
gout[n*243+44] = + s[116];
gout[n*243+45] = + s[189];
gout[n*243+46] = + s[190];
gout[n*243+47] = + s[191];
gout[n*243+48] = + s[192];
gout[n*243+49] = + s[193];
gout[n*243+50] = + s[194];
gout[n*243+51] = + s[195];
gout[n*243+52] = + s[196];
gout[n*243+53] = + s[197];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[135];
gout[n*243+64] = + s[136];
gout[n*243+65] = + s[137];
gout[n*243+66] = + s[138];
gout[n*243+67] = + s[139];
gout[n*243+68] = + s[140];
gout[n*243+69] = + s[141];
gout[n*243+70] = + s[142];
gout[n*243+71] = + s[143];
gout[n*243+72] = + s[216];
gout[n*243+73] = + s[217];
gout[n*243+74] = + s[218];
gout[n*243+75] = + s[219];
gout[n*243+76] = + s[220];
gout[n*243+77] = + s[221];
gout[n*243+78] = + s[222];
gout[n*243+79] = + s[223];
gout[n*243+80] = + s[224];
gout[n*243+81] = + s[9];
gout[n*243+82] = + s[10];
gout[n*243+83] = + s[11];
gout[n*243+84] = + s[12];
gout[n*243+85] = + s[13];
gout[n*243+86] = + s[14];
gout[n*243+87] = + s[15];
gout[n*243+88] = + s[16];
gout[n*243+89] = + s[17];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[171];
gout[n*243+100] = + s[172];
gout[n*243+101] = + s[173];
gout[n*243+102] = + s[174];
gout[n*243+103] = + s[175];
gout[n*243+104] = + s[176];
gout[n*243+105] = + s[177];
gout[n*243+106] = + s[178];
gout[n*243+107] = + s[179];
gout[n*243+108] = + s[36];
gout[n*243+109] = + s[37];
gout[n*243+110] = + s[38];
gout[n*243+111] = + s[39];
gout[n*243+112] = + s[40];
gout[n*243+113] = + s[41];
gout[n*243+114] = + s[42];
gout[n*243+115] = + s[43];
gout[n*243+116] = + s[44];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[198];
gout[n*243+127] = + s[199];
gout[n*243+128] = + s[200];
gout[n*243+129] = + s[201];
gout[n*243+130] = + s[202];
gout[n*243+131] = + s[203];
gout[n*243+132] = + s[204];
gout[n*243+133] = + s[205];
gout[n*243+134] = + s[206];
gout[n*243+135] = + s[63];
gout[n*243+136] = + s[64];
gout[n*243+137] = + s[65];
gout[n*243+138] = + s[66];
gout[n*243+139] = + s[67];
gout[n*243+140] = + s[68];
gout[n*243+141] = + s[69];
gout[n*243+142] = + s[70];
gout[n*243+143] = + s[71];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[225];
gout[n*243+154] = + s[226];
gout[n*243+155] = + s[227];
gout[n*243+156] = + s[228];
gout[n*243+157] = + s[229];
gout[n*243+158] = + s[230];
gout[n*243+159] = + s[231];
gout[n*243+160] = + s[232];
gout[n*243+161] = + s[233];
gout[n*243+162] = + s[18];
gout[n*243+163] = + s[19];
gout[n*243+164] = + s[20];
gout[n*243+165] = + s[21];
gout[n*243+166] = + s[22];
gout[n*243+167] = + s[23];
gout[n*243+168] = + s[24];
gout[n*243+169] = + s[25];
gout[n*243+170] = + s[26];
gout[n*243+171] = + s[99];
gout[n*243+172] = + s[100];
gout[n*243+173] = + s[101];
gout[n*243+174] = + s[102];
gout[n*243+175] = + s[103];
gout[n*243+176] = + s[104];
gout[n*243+177] = + s[105];
gout[n*243+178] = + s[106];
gout[n*243+179] = + s[107];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[45];
gout[n*243+190] = + s[46];
gout[n*243+191] = + s[47];
gout[n*243+192] = + s[48];
gout[n*243+193] = + s[49];
gout[n*243+194] = + s[50];
gout[n*243+195] = + s[51];
gout[n*243+196] = + s[52];
gout[n*243+197] = + s[53];
gout[n*243+198] = + s[126];
gout[n*243+199] = + s[127];
gout[n*243+200] = + s[128];
gout[n*243+201] = + s[129];
gout[n*243+202] = + s[130];
gout[n*243+203] = + s[131];
gout[n*243+204] = + s[132];
gout[n*243+205] = + s[133];
gout[n*243+206] = + s[134];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[72];
gout[n*243+217] = + s[73];
gout[n*243+218] = + s[74];
gout[n*243+219] = + s[75];
gout[n*243+220] = + s[76];
gout[n*243+221] = + s[77];
gout[n*243+222] = + s[78];
gout[n*243+223] = + s[79];
gout[n*243+224] = + s[80];
gout[n*243+225] = + s[153];
gout[n*243+226] = + s[154];
gout[n*243+227] = + s[155];
gout[n*243+228] = + s[156];
gout[n*243+229] = + s[157];
gout[n*243+230] = + s[158];
gout[n*243+231] = + s[159];
gout[n*243+232] = + s[160];
gout[n*243+233] = + s[161];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[81];
gout[n*243+10] += + s[82];
gout[n*243+11] += + s[83];
gout[n*243+12] += + s[84];
gout[n*243+13] += + s[85];
gout[n*243+14] += + s[86];
gout[n*243+15] += + s[87];
gout[n*243+16] += + s[88];
gout[n*243+17] += + s[89];
gout[n*243+18] += + s[162];
gout[n*243+19] += + s[163];
gout[n*243+20] += + s[164];
gout[n*243+21] += + s[165];
gout[n*243+22] += + s[166];
gout[n*243+23] += + s[167];
gout[n*243+24] += + s[168];
gout[n*243+25] += + s[169];
gout[n*243+26] += + s[170];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[108];
gout[n*243+37] += + s[109];
gout[n*243+38] += + s[110];
gout[n*243+39] += + s[111];
gout[n*243+40] += + s[112];
gout[n*243+41] += + s[113];
gout[n*243+42] += + s[114];
gout[n*243+43] += + s[115];
gout[n*243+44] += + s[116];
gout[n*243+45] += + s[189];
gout[n*243+46] += + s[190];
gout[n*243+47] += + s[191];
gout[n*243+48] += + s[192];
gout[n*243+49] += + s[193];
gout[n*243+50] += + s[194];
gout[n*243+51] += + s[195];
gout[n*243+52] += + s[196];
gout[n*243+53] += + s[197];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[135];
gout[n*243+64] += + s[136];
gout[n*243+65] += + s[137];
gout[n*243+66] += + s[138];
gout[n*243+67] += + s[139];
gout[n*243+68] += + s[140];
gout[n*243+69] += + s[141];
gout[n*243+70] += + s[142];
gout[n*243+71] += + s[143];
gout[n*243+72] += + s[216];
gout[n*243+73] += + s[217];
gout[n*243+74] += + s[218];
gout[n*243+75] += + s[219];
gout[n*243+76] += + s[220];
gout[n*243+77] += + s[221];
gout[n*243+78] += + s[222];
gout[n*243+79] += + s[223];
gout[n*243+80] += + s[224];
gout[n*243+81] += + s[9];
gout[n*243+82] += + s[10];
gout[n*243+83] += + s[11];
gout[n*243+84] += + s[12];
gout[n*243+85] += + s[13];
gout[n*243+86] += + s[14];
gout[n*243+87] += + s[15];
gout[n*243+88] += + s[16];
gout[n*243+89] += + s[17];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[171];
gout[n*243+100] += + s[172];
gout[n*243+101] += + s[173];
gout[n*243+102] += + s[174];
gout[n*243+103] += + s[175];
gout[n*243+104] += + s[176];
gout[n*243+105] += + s[177];
gout[n*243+106] += + s[178];
gout[n*243+107] += + s[179];
gout[n*243+108] += + s[36];
gout[n*243+109] += + s[37];
gout[n*243+110] += + s[38];
gout[n*243+111] += + s[39];
gout[n*243+112] += + s[40];
gout[n*243+113] += + s[41];
gout[n*243+114] += + s[42];
gout[n*243+115] += + s[43];
gout[n*243+116] += + s[44];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[198];
gout[n*243+127] += + s[199];
gout[n*243+128] += + s[200];
gout[n*243+129] += + s[201];
gout[n*243+130] += + s[202];
gout[n*243+131] += + s[203];
gout[n*243+132] += + s[204];
gout[n*243+133] += + s[205];
gout[n*243+134] += + s[206];
gout[n*243+135] += + s[63];
gout[n*243+136] += + s[64];
gout[n*243+137] += + s[65];
gout[n*243+138] += + s[66];
gout[n*243+139] += + s[67];
gout[n*243+140] += + s[68];
gout[n*243+141] += + s[69];
gout[n*243+142] += + s[70];
gout[n*243+143] += + s[71];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[225];
gout[n*243+154] += + s[226];
gout[n*243+155] += + s[227];
gout[n*243+156] += + s[228];
gout[n*243+157] += + s[229];
gout[n*243+158] += + s[230];
gout[n*243+159] += + s[231];
gout[n*243+160] += + s[232];
gout[n*243+161] += + s[233];
gout[n*243+162] += + s[18];
gout[n*243+163] += + s[19];
gout[n*243+164] += + s[20];
gout[n*243+165] += + s[21];
gout[n*243+166] += + s[22];
gout[n*243+167] += + s[23];
gout[n*243+168] += + s[24];
gout[n*243+169] += + s[25];
gout[n*243+170] += + s[26];
gout[n*243+171] += + s[99];
gout[n*243+172] += + s[100];
gout[n*243+173] += + s[101];
gout[n*243+174] += + s[102];
gout[n*243+175] += + s[103];
gout[n*243+176] += + s[104];
gout[n*243+177] += + s[105];
gout[n*243+178] += + s[106];
gout[n*243+179] += + s[107];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[45];
gout[n*243+190] += + s[46];
gout[n*243+191] += + s[47];
gout[n*243+192] += + s[48];
gout[n*243+193] += + s[49];
gout[n*243+194] += + s[50];
gout[n*243+195] += + s[51];
gout[n*243+196] += + s[52];
gout[n*243+197] += + s[53];
gout[n*243+198] += + s[126];
gout[n*243+199] += + s[127];
gout[n*243+200] += + s[128];
gout[n*243+201] += + s[129];
gout[n*243+202] += + s[130];
gout[n*243+203] += + s[131];
gout[n*243+204] += + s[132];
gout[n*243+205] += + s[133];
gout[n*243+206] += + s[134];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[72];
gout[n*243+217] += + s[73];
gout[n*243+218] += + s[74];
gout[n*243+219] += + s[75];
gout[n*243+220] += + s[76];
gout[n*243+221] += + s[77];
gout[n*243+222] += + s[78];
gout[n*243+223] += + s[79];
gout[n*243+224] += + s[80];
gout[n*243+225] += + s[153];
gout[n*243+226] += + s[154];
gout[n*243+227] += + s[155];
gout[n*243+228] += + s[156];
gout[n*243+229] += + s[157];
gout[n*243+230] += + s[158];
gout[n*243+231] += + s[159];
gout[n*243+232] += + s[160];
gout[n*243+233] += + s[161];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipipr0r0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipipr0r0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipr0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipipr0r0_cart
CACHE_SIZE_T int1e_ipipipr0r0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipr0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipipr0r0_sph
CACHE_SIZE_T int1e_ipipipr0r0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {3, 2, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipipr0r0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipipr0r0_spinor
ALL_CINT1E(int1e_ipipipr0r0)
ALL_CINT1E_FORTRAN_(int1e_ipipipr0r0)
/* <NABLA NABLA i|R0 R0 |NABLA j> */
void CINTgout1e_int1e_ipipr0r0ip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double s[243];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_R0J(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_R0J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipr0r0ip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipr0r0ip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipr0r0ip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipr0r0ip_cart
CACHE_SIZE_T int1e_ipipr0r0ip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipr0r0ip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipr0r0ip_sph
CACHE_SIZE_T int1e_ipipr0r0ip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipr0r0ip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipr0r0ip_spinor
ALL_CINT1E(int1e_ipipr0r0ip)
ALL_CINT1E_FORTRAN_(int1e_ipipr0r0ip)
/* <NABLA i|R0 R0 R0 |j> */
void CINTgout1e_int1e_ipr0r0r0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double s[81];
G1E_R0J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_R0J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_R0J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_R0J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*81+0] = + s[0];
gout[n*81+1] = + s[1];
gout[n*81+2] = + s[2];
gout[n*81+3] = + s[3];
gout[n*81+4] = + s[4];
gout[n*81+5] = + s[5];
gout[n*81+6] = + s[6];
gout[n*81+7] = + s[7];
gout[n*81+8] = + s[8];
gout[n*81+9] = + s[9];
gout[n*81+10] = + s[10];
gout[n*81+11] = + s[11];
gout[n*81+12] = + s[12];
gout[n*81+13] = + s[13];
gout[n*81+14] = + s[14];
gout[n*81+15] = + s[15];
gout[n*81+16] = + s[16];
gout[n*81+17] = + s[17];
gout[n*81+18] = + s[18];
gout[n*81+19] = + s[19];
gout[n*81+20] = + s[20];
gout[n*81+21] = + s[21];
gout[n*81+22] = + s[22];
gout[n*81+23] = + s[23];
gout[n*81+24] = + s[24];
gout[n*81+25] = + s[25];
gout[n*81+26] = + s[26];
gout[n*81+27] = + s[27];
gout[n*81+28] = + s[28];
gout[n*81+29] = + s[29];
gout[n*81+30] = + s[30];
gout[n*81+31] = + s[31];
gout[n*81+32] = + s[32];
gout[n*81+33] = + s[33];
gout[n*81+34] = + s[34];
gout[n*81+35] = + s[35];
gout[n*81+36] = + s[36];
gout[n*81+37] = + s[37];
gout[n*81+38] = + s[38];
gout[n*81+39] = + s[39];
gout[n*81+40] = + s[40];
gout[n*81+41] = + s[41];
gout[n*81+42] = + s[42];
gout[n*81+43] = + s[43];
gout[n*81+44] = + s[44];
gout[n*81+45] = + s[45];
gout[n*81+46] = + s[46];
gout[n*81+47] = + s[47];
gout[n*81+48] = + s[48];
gout[n*81+49] = + s[49];
gout[n*81+50] = + s[50];
gout[n*81+51] = + s[51];
gout[n*81+52] = + s[52];
gout[n*81+53] = + s[53];
gout[n*81+54] = + s[54];
gout[n*81+55] = + s[55];
gout[n*81+56] = + s[56];
gout[n*81+57] = + s[57];
gout[n*81+58] = + s[58];
gout[n*81+59] = + s[59];
gout[n*81+60] = + s[60];
gout[n*81+61] = + s[61];
gout[n*81+62] = + s[62];
gout[n*81+63] = + s[63];
gout[n*81+64] = + s[64];
gout[n*81+65] = + s[65];
gout[n*81+66] = + s[66];
gout[n*81+67] = + s[67];
gout[n*81+68] = + s[68];
gout[n*81+69] = + s[69];
gout[n*81+70] = + s[70];
gout[n*81+71] = + s[71];
gout[n*81+72] = + s[72];
gout[n*81+73] = + s[73];
gout[n*81+74] = + s[74];
gout[n*81+75] = + s[75];
gout[n*81+76] = + s[76];
gout[n*81+77] = + s[77];
gout[n*81+78] = + s[78];
gout[n*81+79] = + s[79];
gout[n*81+80] = + s[80];
} else {
gout[n*81+0] += + s[0];
gout[n*81+1] += + s[1];
gout[n*81+2] += + s[2];
gout[n*81+3] += + s[3];
gout[n*81+4] += + s[4];
gout[n*81+5] += + s[5];
gout[n*81+6] += + s[6];
gout[n*81+7] += + s[7];
gout[n*81+8] += + s[8];
gout[n*81+9] += + s[9];
gout[n*81+10] += + s[10];
gout[n*81+11] += + s[11];
gout[n*81+12] += + s[12];
gout[n*81+13] += + s[13];
gout[n*81+14] += + s[14];
gout[n*81+15] += + s[15];
gout[n*81+16] += + s[16];
gout[n*81+17] += + s[17];
gout[n*81+18] += + s[18];
gout[n*81+19] += + s[19];
gout[n*81+20] += + s[20];
gout[n*81+21] += + s[21];
gout[n*81+22] += + s[22];
gout[n*81+23] += + s[23];
gout[n*81+24] += + s[24];
gout[n*81+25] += + s[25];
gout[n*81+26] += + s[26];
gout[n*81+27] += + s[27];
gout[n*81+28] += + s[28];
gout[n*81+29] += + s[29];
gout[n*81+30] += + s[30];
gout[n*81+31] += + s[31];
gout[n*81+32] += + s[32];
gout[n*81+33] += + s[33];
gout[n*81+34] += + s[34];
gout[n*81+35] += + s[35];
gout[n*81+36] += + s[36];
gout[n*81+37] += + s[37];
gout[n*81+38] += + s[38];
gout[n*81+39] += + s[39];
gout[n*81+40] += + s[40];
gout[n*81+41] += + s[41];
gout[n*81+42] += + s[42];
gout[n*81+43] += + s[43];
gout[n*81+44] += + s[44];
gout[n*81+45] += + s[45];
gout[n*81+46] += + s[46];
gout[n*81+47] += + s[47];
gout[n*81+48] += + s[48];
gout[n*81+49] += + s[49];
gout[n*81+50] += + s[50];
gout[n*81+51] += + s[51];
gout[n*81+52] += + s[52];
gout[n*81+53] += + s[53];
gout[n*81+54] += + s[54];
gout[n*81+55] += + s[55];
gout[n*81+56] += + s[56];
gout[n*81+57] += + s[57];
gout[n*81+58] += + s[58];
gout[n*81+59] += + s[59];
gout[n*81+60] += + s[60];
gout[n*81+61] += + s[61];
gout[n*81+62] += + s[62];
gout[n*81+63] += + s[63];
gout[n*81+64] += + s[64];
gout[n*81+65] += + s[65];
gout[n*81+66] += + s[66];
gout[n*81+67] += + s[67];
gout[n*81+68] += + s[68];
gout[n*81+69] += + s[69];
gout[n*81+70] += + s[70];
gout[n*81+71] += + s[71];
gout[n*81+72] += + s[72];
gout[n*81+73] += + s[73];
gout[n*81+74] += + s[74];
gout[n*81+75] += + s[75];
gout[n*81+76] += + s[76];
gout[n*81+77] += + s[77];
gout[n*81+78] += + s[78];
gout[n*81+79] += + s[79];
gout[n*81+80] += + s[80];
}}}
void int1e_ipr0r0r0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipr0r0r0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipr0r0r0_cart
CACHE_SIZE_T int1e_ipr0r0r0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipr0r0r0_sph
CACHE_SIZE_T int1e_ipr0r0r0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 3, 0, 0, 4, 1, 1, 81};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0r0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipr0r0r0_spinor
ALL_CINT1E(int1e_ipr0r0r0)
ALL_CINT1E_FORTRAN_(int1e_ipr0r0r0)
/* <NABLA i|R0 R0 R0 |NABLA j> */
void CINTgout1e_int1e_ipr0r0r0ip(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double s[243];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g4, g0, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g5, g4, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g6, g4, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g7, g6, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g8, g0, envs->i_l+1, envs->j_l+3, 0);
G1E_D_J(g9, g8, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g10, g8, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g11, g10, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g12, g8, envs->i_l+1, envs->j_l+2, 0);
G1E_D_J(g13, g12, envs->i_l+1, envs->j_l+0, 0);
G1E_R0J(g14, g12, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g15, g14, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[27];
gout[n*243+28] = + s[28];
gout[n*243+29] = + s[29];
gout[n*243+30] = + s[30];
gout[n*243+31] = + s[31];
gout[n*243+32] = + s[32];
gout[n*243+33] = + s[33];
gout[n*243+34] = + s[34];
gout[n*243+35] = + s[35];
gout[n*243+36] = + s[36];
gout[n*243+37] = + s[37];
gout[n*243+38] = + s[38];
gout[n*243+39] = + s[39];
gout[n*243+40] = + s[40];
gout[n*243+41] = + s[41];
gout[n*243+42] = + s[42];
gout[n*243+43] = + s[43];
gout[n*243+44] = + s[44];
gout[n*243+45] = + s[45];
gout[n*243+46] = + s[46];
gout[n*243+47] = + s[47];
gout[n*243+48] = + s[48];
gout[n*243+49] = + s[49];
gout[n*243+50] = + s[50];
gout[n*243+51] = + s[51];
gout[n*243+52] = + s[52];
gout[n*243+53] = + s[53];
gout[n*243+54] = + s[54];
gout[n*243+55] = + s[55];
gout[n*243+56] = + s[56];
gout[n*243+57] = + s[57];
gout[n*243+58] = + s[58];
gout[n*243+59] = + s[59];
gout[n*243+60] = + s[60];
gout[n*243+61] = + s[61];
gout[n*243+62] = + s[62];
gout[n*243+63] = + s[63];
gout[n*243+64] = + s[64];
gout[n*243+65] = + s[65];
gout[n*243+66] = + s[66];
gout[n*243+67] = + s[67];
gout[n*243+68] = + s[68];
gout[n*243+69] = + s[69];
gout[n*243+70] = + s[70];
gout[n*243+71] = + s[71];
gout[n*243+72] = + s[72];
gout[n*243+73] = + s[73];
gout[n*243+74] = + s[74];
gout[n*243+75] = + s[75];
gout[n*243+76] = + s[76];
gout[n*243+77] = + s[77];
gout[n*243+78] = + s[78];
gout[n*243+79] = + s[79];
gout[n*243+80] = + s[80];
gout[n*243+81] = + s[81];
gout[n*243+82] = + s[82];
gout[n*243+83] = + s[83];
gout[n*243+84] = + s[84];
gout[n*243+85] = + s[85];
gout[n*243+86] = + s[86];
gout[n*243+87] = + s[87];
gout[n*243+88] = + s[88];
gout[n*243+89] = + s[89];
gout[n*243+90] = + s[90];
gout[n*243+91] = + s[91];
gout[n*243+92] = + s[92];
gout[n*243+93] = + s[93];
gout[n*243+94] = + s[94];
gout[n*243+95] = + s[95];
gout[n*243+96] = + s[96];
gout[n*243+97] = + s[97];
gout[n*243+98] = + s[98];
gout[n*243+99] = + s[99];
gout[n*243+100] = + s[100];
gout[n*243+101] = + s[101];
gout[n*243+102] = + s[102];
gout[n*243+103] = + s[103];
gout[n*243+104] = + s[104];
gout[n*243+105] = + s[105];
gout[n*243+106] = + s[106];
gout[n*243+107] = + s[107];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[135];
gout[n*243+136] = + s[136];
gout[n*243+137] = + s[137];
gout[n*243+138] = + s[138];
gout[n*243+139] = + s[139];
gout[n*243+140] = + s[140];
gout[n*243+141] = + s[141];
gout[n*243+142] = + s[142];
gout[n*243+143] = + s[143];
gout[n*243+144] = + s[144];
gout[n*243+145] = + s[145];
gout[n*243+146] = + s[146];
gout[n*243+147] = + s[147];
gout[n*243+148] = + s[148];
gout[n*243+149] = + s[149];
gout[n*243+150] = + s[150];
gout[n*243+151] = + s[151];
gout[n*243+152] = + s[152];
gout[n*243+153] = + s[153];
gout[n*243+154] = + s[154];
gout[n*243+155] = + s[155];
gout[n*243+156] = + s[156];
gout[n*243+157] = + s[157];
gout[n*243+158] = + s[158];
gout[n*243+159] = + s[159];
gout[n*243+160] = + s[160];
gout[n*243+161] = + s[161];
gout[n*243+162] = + s[162];
gout[n*243+163] = + s[163];
gout[n*243+164] = + s[164];
gout[n*243+165] = + s[165];
gout[n*243+166] = + s[166];
gout[n*243+167] = + s[167];
gout[n*243+168] = + s[168];
gout[n*243+169] = + s[169];
gout[n*243+170] = + s[170];
gout[n*243+171] = + s[171];
gout[n*243+172] = + s[172];
gout[n*243+173] = + s[173];
gout[n*243+174] = + s[174];
gout[n*243+175] = + s[175];
gout[n*243+176] = + s[176];
gout[n*243+177] = + s[177];
gout[n*243+178] = + s[178];
gout[n*243+179] = + s[179];
gout[n*243+180] = + s[180];
gout[n*243+181] = + s[181];
gout[n*243+182] = + s[182];
gout[n*243+183] = + s[183];
gout[n*243+184] = + s[184];
gout[n*243+185] = + s[185];
gout[n*243+186] = + s[186];
gout[n*243+187] = + s[187];
gout[n*243+188] = + s[188];
gout[n*243+189] = + s[189];
gout[n*243+190] = + s[190];
gout[n*243+191] = + s[191];
gout[n*243+192] = + s[192];
gout[n*243+193] = + s[193];
gout[n*243+194] = + s[194];
gout[n*243+195] = + s[195];
gout[n*243+196] = + s[196];
gout[n*243+197] = + s[197];
gout[n*243+198] = + s[198];
gout[n*243+199] = + s[199];
gout[n*243+200] = + s[200];
gout[n*243+201] = + s[201];
gout[n*243+202] = + s[202];
gout[n*243+203] = + s[203];
gout[n*243+204] = + s[204];
gout[n*243+205] = + s[205];
gout[n*243+206] = + s[206];
gout[n*243+207] = + s[207];
gout[n*243+208] = + s[208];
gout[n*243+209] = + s[209];
gout[n*243+210] = + s[210];
gout[n*243+211] = + s[211];
gout[n*243+212] = + s[212];
gout[n*243+213] = + s[213];
gout[n*243+214] = + s[214];
gout[n*243+215] = + s[215];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[27];
gout[n*243+28] += + s[28];
gout[n*243+29] += + s[29];
gout[n*243+30] += + s[30];
gout[n*243+31] += + s[31];
gout[n*243+32] += + s[32];
gout[n*243+33] += + s[33];
gout[n*243+34] += + s[34];
gout[n*243+35] += + s[35];
gout[n*243+36] += + s[36];
gout[n*243+37] += + s[37];
gout[n*243+38] += + s[38];
gout[n*243+39] += + s[39];
gout[n*243+40] += + s[40];
gout[n*243+41] += + s[41];
gout[n*243+42] += + s[42];
gout[n*243+43] += + s[43];
gout[n*243+44] += + s[44];
gout[n*243+45] += + s[45];
gout[n*243+46] += + s[46];
gout[n*243+47] += + s[47];
gout[n*243+48] += + s[48];
gout[n*243+49] += + s[49];
gout[n*243+50] += + s[50];
gout[n*243+51] += + s[51];
gout[n*243+52] += + s[52];
gout[n*243+53] += + s[53];
gout[n*243+54] += + s[54];
gout[n*243+55] += + s[55];
gout[n*243+56] += + s[56];
gout[n*243+57] += + s[57];
gout[n*243+58] += + s[58];
gout[n*243+59] += + s[59];
gout[n*243+60] += + s[60];
gout[n*243+61] += + s[61];
gout[n*243+62] += + s[62];
gout[n*243+63] += + s[63];
gout[n*243+64] += + s[64];
gout[n*243+65] += + s[65];
gout[n*243+66] += + s[66];
gout[n*243+67] += + s[67];
gout[n*243+68] += + s[68];
gout[n*243+69] += + s[69];
gout[n*243+70] += + s[70];
gout[n*243+71] += + s[71];
gout[n*243+72] += + s[72];
gout[n*243+73] += + s[73];
gout[n*243+74] += + s[74];
gout[n*243+75] += + s[75];
gout[n*243+76] += + s[76];
gout[n*243+77] += + s[77];
gout[n*243+78] += + s[78];
gout[n*243+79] += + s[79];
gout[n*243+80] += + s[80];
gout[n*243+81] += + s[81];
gout[n*243+82] += + s[82];
gout[n*243+83] += + s[83];
gout[n*243+84] += + s[84];
gout[n*243+85] += + s[85];
gout[n*243+86] += + s[86];
gout[n*243+87] += + s[87];
gout[n*243+88] += + s[88];
gout[n*243+89] += + s[89];
gout[n*243+90] += + s[90];
gout[n*243+91] += + s[91];
gout[n*243+92] += + s[92];
gout[n*243+93] += + s[93];
gout[n*243+94] += + s[94];
gout[n*243+95] += + s[95];
gout[n*243+96] += + s[96];
gout[n*243+97] += + s[97];
gout[n*243+98] += + s[98];
gout[n*243+99] += + s[99];
gout[n*243+100] += + s[100];
gout[n*243+101] += + s[101];
gout[n*243+102] += + s[102];
gout[n*243+103] += + s[103];
gout[n*243+104] += + s[104];
gout[n*243+105] += + s[105];
gout[n*243+106] += + s[106];
gout[n*243+107] += + s[107];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[135];
gout[n*243+136] += + s[136];
gout[n*243+137] += + s[137];
gout[n*243+138] += + s[138];
gout[n*243+139] += + s[139];
gout[n*243+140] += + s[140];
gout[n*243+141] += + s[141];
gout[n*243+142] += + s[142];
gout[n*243+143] += + s[143];
gout[n*243+144] += + s[144];
gout[n*243+145] += + s[145];
gout[n*243+146] += + s[146];
gout[n*243+147] += + s[147];
gout[n*243+148] += + s[148];
gout[n*243+149] += + s[149];
gout[n*243+150] += + s[150];
gout[n*243+151] += + s[151];
gout[n*243+152] += + s[152];
gout[n*243+153] += + s[153];
gout[n*243+154] += + s[154];
gout[n*243+155] += + s[155];
gout[n*243+156] += + s[156];
gout[n*243+157] += + s[157];
gout[n*243+158] += + s[158];
gout[n*243+159] += + s[159];
gout[n*243+160] += + s[160];
gout[n*243+161] += + s[161];
gout[n*243+162] += + s[162];
gout[n*243+163] += + s[163];
gout[n*243+164] += + s[164];
gout[n*243+165] += + s[165];
gout[n*243+166] += + s[166];
gout[n*243+167] += + s[167];
gout[n*243+168] += + s[168];
gout[n*243+169] += + s[169];
gout[n*243+170] += + s[170];
gout[n*243+171] += + s[171];
gout[n*243+172] += + s[172];
gout[n*243+173] += + s[173];
gout[n*243+174] += + s[174];
gout[n*243+175] += + s[175];
gout[n*243+176] += + s[176];
gout[n*243+177] += + s[177];
gout[n*243+178] += + s[178];
gout[n*243+179] += + s[179];
gout[n*243+180] += + s[180];
gout[n*243+181] += + s[181];
gout[n*243+182] += + s[182];
gout[n*243+183] += + s[183];
gout[n*243+184] += + s[184];
gout[n*243+185] += + s[185];
gout[n*243+186] += + s[186];
gout[n*243+187] += + s[187];
gout[n*243+188] += + s[188];
gout[n*243+189] += + s[189];
gout[n*243+190] += + s[190];
gout[n*243+191] += + s[191];
gout[n*243+192] += + s[192];
gout[n*243+193] += + s[193];
gout[n*243+194] += + s[194];
gout[n*243+195] += + s[195];
gout[n*243+196] += + s[196];
gout[n*243+197] += + s[197];
gout[n*243+198] += + s[198];
gout[n*243+199] += + s[199];
gout[n*243+200] += + s[200];
gout[n*243+201] += + s[201];
gout[n*243+202] += + s[202];
gout[n*243+203] += + s[203];
gout[n*243+204] += + s[204];
gout[n*243+205] += + s[205];
gout[n*243+206] += + s[206];
gout[n*243+207] += + s[207];
gout[n*243+208] += + s[208];
gout[n*243+209] += + s[209];
gout[n*243+210] += + s[210];
gout[n*243+211] += + s[211];
gout[n*243+212] += + s[212];
gout[n*243+213] += + s[213];
gout[n*243+214] += + s[214];
gout[n*243+215] += + s[215];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipr0r0r0ip_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipr0r0r0ip_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0r0ip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipr0r0r0ip_cart
CACHE_SIZE_T int1e_ipr0r0r0ip_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0r0ip;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipr0r0r0ip_sph
CACHE_SIZE_T int1e_ipr0r0r0ip_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {1, 4, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipr0r0r0ip;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipr0r0r0ip_spinor
ALL_CINT1E(int1e_ipr0r0r0ip)
ALL_CINT1E_FORTRAN_(int1e_ipr0r0r0ip)
/* <NABLA NABLA i|R0 R0 R0 |j> */
void CINTgout1e_int1e_ipipr0r0r0(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double s[243];
G1E_R0J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_R0J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_R0J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_R0J(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_R0J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_R0J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_R0J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_D_I(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*243+0] = + s[0];
gout[n*243+1] = + s[1];
gout[n*243+2] = + s[2];
gout[n*243+3] = + s[3];
gout[n*243+4] = + s[4];
gout[n*243+5] = + s[5];
gout[n*243+6] = + s[6];
gout[n*243+7] = + s[7];
gout[n*243+8] = + s[8];
gout[n*243+9] = + s[9];
gout[n*243+10] = + s[10];
gout[n*243+11] = + s[11];
gout[n*243+12] = + s[12];
gout[n*243+13] = + s[13];
gout[n*243+14] = + s[14];
gout[n*243+15] = + s[15];
gout[n*243+16] = + s[16];
gout[n*243+17] = + s[17];
gout[n*243+18] = + s[18];
gout[n*243+19] = + s[19];
gout[n*243+20] = + s[20];
gout[n*243+21] = + s[21];
gout[n*243+22] = + s[22];
gout[n*243+23] = + s[23];
gout[n*243+24] = + s[24];
gout[n*243+25] = + s[25];
gout[n*243+26] = + s[26];
gout[n*243+27] = + s[81];
gout[n*243+28] = + s[82];
gout[n*243+29] = + s[83];
gout[n*243+30] = + s[84];
gout[n*243+31] = + s[85];
gout[n*243+32] = + s[86];
gout[n*243+33] = + s[87];
gout[n*243+34] = + s[88];
gout[n*243+35] = + s[89];
gout[n*243+36] = + s[90];
gout[n*243+37] = + s[91];
gout[n*243+38] = + s[92];
gout[n*243+39] = + s[93];
gout[n*243+40] = + s[94];
gout[n*243+41] = + s[95];
gout[n*243+42] = + s[96];
gout[n*243+43] = + s[97];
gout[n*243+44] = + s[98];
gout[n*243+45] = + s[99];
gout[n*243+46] = + s[100];
gout[n*243+47] = + s[101];
gout[n*243+48] = + s[102];
gout[n*243+49] = + s[103];
gout[n*243+50] = + s[104];
gout[n*243+51] = + s[105];
gout[n*243+52] = + s[106];
gout[n*243+53] = + s[107];
gout[n*243+54] = + s[162];
gout[n*243+55] = + s[163];
gout[n*243+56] = + s[164];
gout[n*243+57] = + s[165];
gout[n*243+58] = + s[166];
gout[n*243+59] = + s[167];
gout[n*243+60] = + s[168];
gout[n*243+61] = + s[169];
gout[n*243+62] = + s[170];
gout[n*243+63] = + s[171];
gout[n*243+64] = + s[172];
gout[n*243+65] = + s[173];
gout[n*243+66] = + s[174];
gout[n*243+67] = + s[175];
gout[n*243+68] = + s[176];
gout[n*243+69] = + s[177];
gout[n*243+70] = + s[178];
gout[n*243+71] = + s[179];
gout[n*243+72] = + s[180];
gout[n*243+73] = + s[181];
gout[n*243+74] = + s[182];
gout[n*243+75] = + s[183];
gout[n*243+76] = + s[184];
gout[n*243+77] = + s[185];
gout[n*243+78] = + s[186];
gout[n*243+79] = + s[187];
gout[n*243+80] = + s[188];
gout[n*243+81] = + s[27];
gout[n*243+82] = + s[28];
gout[n*243+83] = + s[29];
gout[n*243+84] = + s[30];
gout[n*243+85] = + s[31];
gout[n*243+86] = + s[32];
gout[n*243+87] = + s[33];
gout[n*243+88] = + s[34];
gout[n*243+89] = + s[35];
gout[n*243+90] = + s[36];
gout[n*243+91] = + s[37];
gout[n*243+92] = + s[38];
gout[n*243+93] = + s[39];
gout[n*243+94] = + s[40];
gout[n*243+95] = + s[41];
gout[n*243+96] = + s[42];
gout[n*243+97] = + s[43];
gout[n*243+98] = + s[44];
gout[n*243+99] = + s[45];
gout[n*243+100] = + s[46];
gout[n*243+101] = + s[47];
gout[n*243+102] = + s[48];
gout[n*243+103] = + s[49];
gout[n*243+104] = + s[50];
gout[n*243+105] = + s[51];
gout[n*243+106] = + s[52];
gout[n*243+107] = + s[53];
gout[n*243+108] = + s[108];
gout[n*243+109] = + s[109];
gout[n*243+110] = + s[110];
gout[n*243+111] = + s[111];
gout[n*243+112] = + s[112];
gout[n*243+113] = + s[113];
gout[n*243+114] = + s[114];
gout[n*243+115] = + s[115];
gout[n*243+116] = + s[116];
gout[n*243+117] = + s[117];
gout[n*243+118] = + s[118];
gout[n*243+119] = + s[119];
gout[n*243+120] = + s[120];
gout[n*243+121] = + s[121];
gout[n*243+122] = + s[122];
gout[n*243+123] = + s[123];
gout[n*243+124] = + s[124];
gout[n*243+125] = + s[125];
gout[n*243+126] = + s[126];
gout[n*243+127] = + s[127];
gout[n*243+128] = + s[128];
gout[n*243+129] = + s[129];
gout[n*243+130] = + s[130];
gout[n*243+131] = + s[131];
gout[n*243+132] = + s[132];
gout[n*243+133] = + s[133];
gout[n*243+134] = + s[134];
gout[n*243+135] = + s[189];
gout[n*243+136] = + s[190];
gout[n*243+137] = + s[191];
gout[n*243+138] = + s[192];
gout[n*243+139] = + s[193];
gout[n*243+140] = + s[194];
gout[n*243+141] = + s[195];
gout[n*243+142] = + s[196];
gout[n*243+143] = + s[197];
gout[n*243+144] = + s[198];
gout[n*243+145] = + s[199];
gout[n*243+146] = + s[200];
gout[n*243+147] = + s[201];
gout[n*243+148] = + s[202];
gout[n*243+149] = + s[203];
gout[n*243+150] = + s[204];
gout[n*243+151] = + s[205];
gout[n*243+152] = + s[206];
gout[n*243+153] = + s[207];
gout[n*243+154] = + s[208];
gout[n*243+155] = + s[209];
gout[n*243+156] = + s[210];
gout[n*243+157] = + s[211];
gout[n*243+158] = + s[212];
gout[n*243+159] = + s[213];
gout[n*243+160] = + s[214];
gout[n*243+161] = + s[215];
gout[n*243+162] = + s[54];
gout[n*243+163] = + s[55];
gout[n*243+164] = + s[56];
gout[n*243+165] = + s[57];
gout[n*243+166] = + s[58];
gout[n*243+167] = + s[59];
gout[n*243+168] = + s[60];
gout[n*243+169] = + s[61];
gout[n*243+170] = + s[62];
gout[n*243+171] = + s[63];
gout[n*243+172] = + s[64];
gout[n*243+173] = + s[65];
gout[n*243+174] = + s[66];
gout[n*243+175] = + s[67];
gout[n*243+176] = + s[68];
gout[n*243+177] = + s[69];
gout[n*243+178] = + s[70];
gout[n*243+179] = + s[71];
gout[n*243+180] = + s[72];
gout[n*243+181] = + s[73];
gout[n*243+182] = + s[74];
gout[n*243+183] = + s[75];
gout[n*243+184] = + s[76];
gout[n*243+185] = + s[77];
gout[n*243+186] = + s[78];
gout[n*243+187] = + s[79];
gout[n*243+188] = + s[80];
gout[n*243+189] = + s[135];
gout[n*243+190] = + s[136];
gout[n*243+191] = + s[137];
gout[n*243+192] = + s[138];
gout[n*243+193] = + s[139];
gout[n*243+194] = + s[140];
gout[n*243+195] = + s[141];
gout[n*243+196] = + s[142];
gout[n*243+197] = + s[143];
gout[n*243+198] = + s[144];
gout[n*243+199] = + s[145];
gout[n*243+200] = + s[146];
gout[n*243+201] = + s[147];
gout[n*243+202] = + s[148];
gout[n*243+203] = + s[149];
gout[n*243+204] = + s[150];
gout[n*243+205] = + s[151];
gout[n*243+206] = + s[152];
gout[n*243+207] = + s[153];
gout[n*243+208] = + s[154];
gout[n*243+209] = + s[155];
gout[n*243+210] = + s[156];
gout[n*243+211] = + s[157];
gout[n*243+212] = + s[158];
gout[n*243+213] = + s[159];
gout[n*243+214] = + s[160];
gout[n*243+215] = + s[161];
gout[n*243+216] = + s[216];
gout[n*243+217] = + s[217];
gout[n*243+218] = + s[218];
gout[n*243+219] = + s[219];
gout[n*243+220] = + s[220];
gout[n*243+221] = + s[221];
gout[n*243+222] = + s[222];
gout[n*243+223] = + s[223];
gout[n*243+224] = + s[224];
gout[n*243+225] = + s[225];
gout[n*243+226] = + s[226];
gout[n*243+227] = + s[227];
gout[n*243+228] = + s[228];
gout[n*243+229] = + s[229];
gout[n*243+230] = + s[230];
gout[n*243+231] = + s[231];
gout[n*243+232] = + s[232];
gout[n*243+233] = + s[233];
gout[n*243+234] = + s[234];
gout[n*243+235] = + s[235];
gout[n*243+236] = + s[236];
gout[n*243+237] = + s[237];
gout[n*243+238] = + s[238];
gout[n*243+239] = + s[239];
gout[n*243+240] = + s[240];
gout[n*243+241] = + s[241];
gout[n*243+242] = + s[242];
} else {
gout[n*243+0] += + s[0];
gout[n*243+1] += + s[1];
gout[n*243+2] += + s[2];
gout[n*243+3] += + s[3];
gout[n*243+4] += + s[4];
gout[n*243+5] += + s[5];
gout[n*243+6] += + s[6];
gout[n*243+7] += + s[7];
gout[n*243+8] += + s[8];
gout[n*243+9] += + s[9];
gout[n*243+10] += + s[10];
gout[n*243+11] += + s[11];
gout[n*243+12] += + s[12];
gout[n*243+13] += + s[13];
gout[n*243+14] += + s[14];
gout[n*243+15] += + s[15];
gout[n*243+16] += + s[16];
gout[n*243+17] += + s[17];
gout[n*243+18] += + s[18];
gout[n*243+19] += + s[19];
gout[n*243+20] += + s[20];
gout[n*243+21] += + s[21];
gout[n*243+22] += + s[22];
gout[n*243+23] += + s[23];
gout[n*243+24] += + s[24];
gout[n*243+25] += + s[25];
gout[n*243+26] += + s[26];
gout[n*243+27] += + s[81];
gout[n*243+28] += + s[82];
gout[n*243+29] += + s[83];
gout[n*243+30] += + s[84];
gout[n*243+31] += + s[85];
gout[n*243+32] += + s[86];
gout[n*243+33] += + s[87];
gout[n*243+34] += + s[88];
gout[n*243+35] += + s[89];
gout[n*243+36] += + s[90];
gout[n*243+37] += + s[91];
gout[n*243+38] += + s[92];
gout[n*243+39] += + s[93];
gout[n*243+40] += + s[94];
gout[n*243+41] += + s[95];
gout[n*243+42] += + s[96];
gout[n*243+43] += + s[97];
gout[n*243+44] += + s[98];
gout[n*243+45] += + s[99];
gout[n*243+46] += + s[100];
gout[n*243+47] += + s[101];
gout[n*243+48] += + s[102];
gout[n*243+49] += + s[103];
gout[n*243+50] += + s[104];
gout[n*243+51] += + s[105];
gout[n*243+52] += + s[106];
gout[n*243+53] += + s[107];
gout[n*243+54] += + s[162];
gout[n*243+55] += + s[163];
gout[n*243+56] += + s[164];
gout[n*243+57] += + s[165];
gout[n*243+58] += + s[166];
gout[n*243+59] += + s[167];
gout[n*243+60] += + s[168];
gout[n*243+61] += + s[169];
gout[n*243+62] += + s[170];
gout[n*243+63] += + s[171];
gout[n*243+64] += + s[172];
gout[n*243+65] += + s[173];
gout[n*243+66] += + s[174];
gout[n*243+67] += + s[175];
gout[n*243+68] += + s[176];
gout[n*243+69] += + s[177];
gout[n*243+70] += + s[178];
gout[n*243+71] += + s[179];
gout[n*243+72] += + s[180];
gout[n*243+73] += + s[181];
gout[n*243+74] += + s[182];
gout[n*243+75] += + s[183];
gout[n*243+76] += + s[184];
gout[n*243+77] += + s[185];
gout[n*243+78] += + s[186];
gout[n*243+79] += + s[187];
gout[n*243+80] += + s[188];
gout[n*243+81] += + s[27];
gout[n*243+82] += + s[28];
gout[n*243+83] += + s[29];
gout[n*243+84] += + s[30];
gout[n*243+85] += + s[31];
gout[n*243+86] += + s[32];
gout[n*243+87] += + s[33];
gout[n*243+88] += + s[34];
gout[n*243+89] += + s[35];
gout[n*243+90] += + s[36];
gout[n*243+91] += + s[37];
gout[n*243+92] += + s[38];
gout[n*243+93] += + s[39];
gout[n*243+94] += + s[40];
gout[n*243+95] += + s[41];
gout[n*243+96] += + s[42];
gout[n*243+97] += + s[43];
gout[n*243+98] += + s[44];
gout[n*243+99] += + s[45];
gout[n*243+100] += + s[46];
gout[n*243+101] += + s[47];
gout[n*243+102] += + s[48];
gout[n*243+103] += + s[49];
gout[n*243+104] += + s[50];
gout[n*243+105] += + s[51];
gout[n*243+106] += + s[52];
gout[n*243+107] += + s[53];
gout[n*243+108] += + s[108];
gout[n*243+109] += + s[109];
gout[n*243+110] += + s[110];
gout[n*243+111] += + s[111];
gout[n*243+112] += + s[112];
gout[n*243+113] += + s[113];
gout[n*243+114] += + s[114];
gout[n*243+115] += + s[115];
gout[n*243+116] += + s[116];
gout[n*243+117] += + s[117];
gout[n*243+118] += + s[118];
gout[n*243+119] += + s[119];
gout[n*243+120] += + s[120];
gout[n*243+121] += + s[121];
gout[n*243+122] += + s[122];
gout[n*243+123] += + s[123];
gout[n*243+124] += + s[124];
gout[n*243+125] += + s[125];
gout[n*243+126] += + s[126];
gout[n*243+127] += + s[127];
gout[n*243+128] += + s[128];
gout[n*243+129] += + s[129];
gout[n*243+130] += + s[130];
gout[n*243+131] += + s[131];
gout[n*243+132] += + s[132];
gout[n*243+133] += + s[133];
gout[n*243+134] += + s[134];
gout[n*243+135] += + s[189];
gout[n*243+136] += + s[190];
gout[n*243+137] += + s[191];
gout[n*243+138] += + s[192];
gout[n*243+139] += + s[193];
gout[n*243+140] += + s[194];
gout[n*243+141] += + s[195];
gout[n*243+142] += + s[196];
gout[n*243+143] += + s[197];
gout[n*243+144] += + s[198];
gout[n*243+145] += + s[199];
gout[n*243+146] += + s[200];
gout[n*243+147] += + s[201];
gout[n*243+148] += + s[202];
gout[n*243+149] += + s[203];
gout[n*243+150] += + s[204];
gout[n*243+151] += + s[205];
gout[n*243+152] += + s[206];
gout[n*243+153] += + s[207];
gout[n*243+154] += + s[208];
gout[n*243+155] += + s[209];
gout[n*243+156] += + s[210];
gout[n*243+157] += + s[211];
gout[n*243+158] += + s[212];
gout[n*243+159] += + s[213];
gout[n*243+160] += + s[214];
gout[n*243+161] += + s[215];
gout[n*243+162] += + s[54];
gout[n*243+163] += + s[55];
gout[n*243+164] += + s[56];
gout[n*243+165] += + s[57];
gout[n*243+166] += + s[58];
gout[n*243+167] += + s[59];
gout[n*243+168] += + s[60];
gout[n*243+169] += + s[61];
gout[n*243+170] += + s[62];
gout[n*243+171] += + s[63];
gout[n*243+172] += + s[64];
gout[n*243+173] += + s[65];
gout[n*243+174] += + s[66];
gout[n*243+175] += + s[67];
gout[n*243+176] += + s[68];
gout[n*243+177] += + s[69];
gout[n*243+178] += + s[70];
gout[n*243+179] += + s[71];
gout[n*243+180] += + s[72];
gout[n*243+181] += + s[73];
gout[n*243+182] += + s[74];
gout[n*243+183] += + s[75];
gout[n*243+184] += + s[76];
gout[n*243+185] += + s[77];
gout[n*243+186] += + s[78];
gout[n*243+187] += + s[79];
gout[n*243+188] += + s[80];
gout[n*243+189] += + s[135];
gout[n*243+190] += + s[136];
gout[n*243+191] += + s[137];
gout[n*243+192] += + s[138];
gout[n*243+193] += + s[139];
gout[n*243+194] += + s[140];
gout[n*243+195] += + s[141];
gout[n*243+196] += + s[142];
gout[n*243+197] += + s[143];
gout[n*243+198] += + s[144];
gout[n*243+199] += + s[145];
gout[n*243+200] += + s[146];
gout[n*243+201] += + s[147];
gout[n*243+202] += + s[148];
gout[n*243+203] += + s[149];
gout[n*243+204] += + s[150];
gout[n*243+205] += + s[151];
gout[n*243+206] += + s[152];
gout[n*243+207] += + s[153];
gout[n*243+208] += + s[154];
gout[n*243+209] += + s[155];
gout[n*243+210] += + s[156];
gout[n*243+211] += + s[157];
gout[n*243+212] += + s[158];
gout[n*243+213] += + s[159];
gout[n*243+214] += + s[160];
gout[n*243+215] += + s[161];
gout[n*243+216] += + s[216];
gout[n*243+217] += + s[217];
gout[n*243+218] += + s[218];
gout[n*243+219] += + s[219];
gout[n*243+220] += + s[220];
gout[n*243+221] += + s[221];
gout[n*243+222] += + s[222];
gout[n*243+223] += + s[223];
gout[n*243+224] += + s[224];
gout[n*243+225] += + s[225];
gout[n*243+226] += + s[226];
gout[n*243+227] += + s[227];
gout[n*243+228] += + s[228];
gout[n*243+229] += + s[229];
gout[n*243+230] += + s[230];
gout[n*243+231] += + s[231];
gout[n*243+232] += + s[232];
gout[n*243+233] += + s[233];
gout[n*243+234] += + s[234];
gout[n*243+235] += + s[235];
gout[n*243+236] += + s[236];
gout[n*243+237] += + s[237];
gout[n*243+238] += + s[238];
gout[n*243+239] += + s[239];
gout[n*243+240] += + s[240];
gout[n*243+241] += + s[241];
gout[n*243+242] += + s[242];
}}}
void int1e_ipipr0r0r0_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_ipipr0r0r0_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipr0r0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_ipipr0r0r0_cart
CACHE_SIZE_T int1e_ipipr0r0r0_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipr0r0r0;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_ipipr0r0r0_sph
CACHE_SIZE_T int1e_ipipr0r0r0_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 243};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_ipipr0r0r0;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_ipipr0r0r0_spinor
ALL_CINT1E(int1e_ipipr0r0r0)
ALL_CINT1E_FORTRAN_(int1e_ipipr0r0r0)
/* <RI DOT RI i|R R |j> */
void CINTgout1e_int1e_rrjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[81];
G1E_R_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_RCI(g4, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g5, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g6, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g7, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g8, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g15[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g14[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g14[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g13[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g12[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g12[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g13[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g12[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g12[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g11[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g10[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g10[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g9[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g8[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g8[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g9[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g8[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g8[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g11[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g10[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g10[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g9[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g8[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g8[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g9[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g8[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g8[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g7[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g6[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g6[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g5[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g4[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g4[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g5[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g4[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g4[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g3[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g2[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g2[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g1[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g0[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g0[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g1[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g0[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g0[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g3[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g2[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g2[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g1[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g0[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g0[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g1[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g0[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g0[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g7[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g6[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g6[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g5[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g4[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g4[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g5[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g4[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g4[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g3[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g2[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g2[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g1[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g0[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g0[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g1[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g0[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g0[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g3[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g2[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g2[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g1[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g0[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g0[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g1[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g0[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g0[ix+0]*g0[iy+0]*g15[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0] + s[36] + s[72];
gout[n*9+1] = + s[1] + s[37] + s[73];
gout[n*9+2] = + s[2] + s[38] + s[74];
gout[n*9+3] = + s[3] + s[39] + s[75];
gout[n*9+4] = + s[4] + s[40] + s[76];
gout[n*9+5] = + s[5] + s[41] + s[77];
gout[n*9+6] = + s[6] + s[42] + s[78];
gout[n*9+7] = + s[7] + s[43] + s[79];
gout[n*9+8] = + s[8] + s[44] + s[80];
} else {
gout[n*9+0] += + s[0] + s[36] + s[72];
gout[n*9+1] += + s[1] + s[37] + s[73];
gout[n*9+2] += + s[2] + s[38] + s[74];
gout[n*9+3] += + s[3] + s[39] + s[75];
gout[n*9+4] += + s[4] + s[40] + s[76];
gout[n*9+5] += + s[5] + s[41] + s[77];
gout[n*9+6] += + s[6] + s[42] + s[78];
gout[n*9+7] += + s[7] + s[43] + s[79];
gout[n*9+8] += + s[8] + s[44] + s[80];
}}}
void int1e_rrjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrjj_cart
CACHE_SIZE_T int1e_rrjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrjj_sph
CACHE_SIZE_T int1e_rrjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 2, 0, 0, 4, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrjj_spinor
ALL_CINT1E(int1e_rrjj)
ALL_CINT1E_FORTRAN_(int1e_rrjj)
/* <RI DOT RI i|R R |RJ DOT RJ j> */
void CINTgout1e_int1e_rrjjrr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[729];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g8, g0, envs->i_l+2, envs->j_l+3, 0);
G1E_RCJ(g9, g8, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g11, g10, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g12, g8, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g13, g12, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g15, g14, envs->i_l+2, envs->j_l+0, 0);
G1E_RCI(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0] + s[324] + s[648] + s[4] + s[328] + s[652] + s[8] + s[332] + s[656];
gout[n*9+1] = + s[9] + s[333] + s[657] + s[13] + s[337] + s[661] + s[17] + s[341] + s[665];
gout[n*9+2] = + s[18] + s[342] + s[666] + s[22] + s[346] + s[670] + s[26] + s[350] + s[674];
gout[n*9+3] = + s[27] + s[351] + s[675] + s[31] + s[355] + s[679] + s[35] + s[359] + s[683];
gout[n*9+4] = + s[36] + s[360] + s[684] + s[40] + s[364] + s[688] + s[44] + s[368] + s[692];
gout[n*9+5] = + s[45] + s[369] + s[693] + s[49] + s[373] + s[697] + s[53] + s[377] + s[701];
gout[n*9+6] = + s[54] + s[378] + s[702] + s[58] + s[382] + s[706] + s[62] + s[386] + s[710];
gout[n*9+7] = + s[63] + s[387] + s[711] + s[67] + s[391] + s[715] + s[71] + s[395] + s[719];
gout[n*9+8] = + s[72] + s[396] + s[720] + s[76] + s[400] + s[724] + s[80] + s[404] + s[728];
} else {
gout[n*9+0] += + s[0] + s[324] + s[648] + s[4] + s[328] + s[652] + s[8] + s[332] + s[656];
gout[n*9+1] += + s[9] + s[333] + s[657] + s[13] + s[337] + s[661] + s[17] + s[341] + s[665];
gout[n*9+2] += + s[18] + s[342] + s[666] + s[22] + s[346] + s[670] + s[26] + s[350] + s[674];
gout[n*9+3] += + s[27] + s[351] + s[675] + s[31] + s[355] + s[679] + s[35] + s[359] + s[683];
gout[n*9+4] += + s[36] + s[360] + s[684] + s[40] + s[364] + s[688] + s[44] + s[368] + s[692];
gout[n*9+5] += + s[45] + s[369] + s[693] + s[49] + s[373] + s[697] + s[53] + s[377] + s[701];
gout[n*9+6] += + s[54] + s[378] + s[702] + s[58] + s[382] + s[706] + s[62] + s[386] + s[710];
gout[n*9+7] += + s[63] + s[387] + s[711] + s[67] + s[391] + s[715] + s[71] + s[395] + s[719];
gout[n*9+8] += + s[72] + s[396] + s[720] + s[76] + s[400] + s[724] + s[80] + s[404] + s[728];
}}}
void int1e_rrjjrr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrjjrr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjjrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrjjrr_cart
CACHE_SIZE_T int1e_rrjjrr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjjrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrjjrr_sph
CACHE_SIZE_T int1e_rrjjrr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 4, 0, 0, 6, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjjrr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrjjrr_spinor
ALL_CINT1E(int1e_rrjjrr)
ALL_CINT1E_FORTRAN_(int1e_rrjjrr)
/* <RI DOT RI RI DOT RI i|R R |j> */
void CINTgout1e_int1e_rrrrjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[729];
G1E_R_J(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+4, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+4, envs->j_l+0, 0);
G1E_RCI(g4, g0, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g5, g1, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g6, g2, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g7, g3, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g8, g0, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g16, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g17, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g18, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g19, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g20, g4, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g21, g5, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g22, g6, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g23, g7, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g24, g8, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g25, g9, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g26, g10, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g27, g11, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g28, g12, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g29, g13, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g30, g14, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g31, g15, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g32, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g33, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g34, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g35, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g36, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g37, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g38, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g39, g7, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g40, g8, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g41, g9, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g42, g10, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g43, g11, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g44, g12, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g45, g13, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g46, g14, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g47, g15, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g48, g16, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g49, g17, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g50, g18, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g51, g19, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g52, g20, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g53, g21, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g54, g22, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g55, g23, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g56, g24, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g57, g25, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g58, g26, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g59, g27, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g60, g28, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g61, g29, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g62, g30, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g63, g31, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g63[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g62[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g62[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g61[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g60[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g60[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g61[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g60[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g60[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g59[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g58[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g58[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g57[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g56[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g56[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g57[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g56[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g56[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g59[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g58[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g58[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g57[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g56[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g56[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g57[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g56[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g56[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g55[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g54[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g54[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g53[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g52[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g52[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g53[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g52[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g52[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g51[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g50[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g50[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g49[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g48[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g48[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g49[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g48[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g48[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g51[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g50[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g50[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g49[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g48[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g48[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g49[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g48[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g48[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g55[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g54[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g54[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g53[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g52[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g52[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g53[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g52[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g52[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g51[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g50[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g50[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g49[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g48[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g48[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g49[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g48[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g48[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g51[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g50[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g50[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g49[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g48[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g48[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g49[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g48[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g48[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g47[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g46[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g46[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g45[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g44[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g44[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g45[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g44[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g44[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g43[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g42[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g42[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g41[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g40[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g40[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g41[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g40[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g40[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g43[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g42[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g42[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g41[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g40[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g40[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g41[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g40[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g40[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g39[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g38[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g38[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g37[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g36[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g36[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g37[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g36[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g36[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g35[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g34[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g34[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g33[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g32[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g32[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g33[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g32[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g32[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g35[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g34[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g34[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g33[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g32[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g32[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g33[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g32[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g32[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g39[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g38[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g38[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g37[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g36[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g36[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g37[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g36[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g36[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g35[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g34[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g34[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g33[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g32[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g32[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g33[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g32[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g32[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g35[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g34[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g34[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g33[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g32[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g32[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g33[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g32[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g32[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g47[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g46[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g46[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g45[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g44[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g44[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g45[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g44[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g44[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g43[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g42[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g42[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g41[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g40[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g40[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g41[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g40[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g40[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g43[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g42[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g42[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g41[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g40[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g40[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g41[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g40[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g40[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g39[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g38[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g38[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g37[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g36[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g36[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g37[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g36[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g36[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g35[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g34[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g34[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g33[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g32[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g32[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g33[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g32[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g32[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g35[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g34[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g34[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g33[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g32[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g32[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g33[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g32[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g32[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g39[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g38[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g38[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g37[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g36[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g36[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g37[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g36[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g36[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g35[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g34[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g34[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g33[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g32[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g32[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g33[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g32[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g32[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g35[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g34[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g34[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g33[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g32[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g32[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g33[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g32[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g32[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g31[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g30[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g30[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g29[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g28[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g28[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g29[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g28[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g28[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g27[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g26[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g26[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g25[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g24[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g24[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g25[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g24[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g24[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g27[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g26[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g26[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g25[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g24[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g24[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g25[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g24[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g24[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g23[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g22[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g22[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g21[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g20[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g20[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g21[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g20[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g20[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g19[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g18[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g18[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g17[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g16[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g16[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g17[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g16[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g16[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g19[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g18[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g18[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g17[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g16[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g16[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g17[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g16[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g16[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g23[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g22[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g22[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g21[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g20[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g20[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g21[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g20[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g20[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g19[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g18[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g18[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g17[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g16[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g16[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g17[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g16[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g16[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g19[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g18[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g18[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g17[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g16[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g16[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g17[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g16[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g16[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g15[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g14[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g14[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g13[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g12[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g12[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g13[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g12[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g12[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g11[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g10[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g10[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g9[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g8[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g8[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g9[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g8[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g8[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g11[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g10[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g10[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g9[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g8[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g8[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g9[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g8[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g8[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g7[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g6[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g6[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g5[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g4[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g4[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g5[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g4[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g4[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g3[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g2[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g2[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g1[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g0[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g0[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g1[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g0[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g0[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g3[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g2[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g2[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g1[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g0[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g0[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g1[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g0[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g0[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g7[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g6[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g6[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g5[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g4[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g4[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g5[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g4[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g4[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g3[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g2[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g2[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g1[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g0[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g0[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g1[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g0[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g0[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g3[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g2[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g2[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g1[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g0[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g0[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g1[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g0[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g0[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g15[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g14[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g14[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g13[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g12[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g12[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g13[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g12[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g12[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g11[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g10[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g10[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g9[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g8[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g8[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g9[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g8[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g8[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g11[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g10[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g10[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g9[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g8[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g8[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g9[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g8[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g8[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g7[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g6[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g6[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g5[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g4[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g4[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g5[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g4[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g4[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g3[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g2[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g2[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g1[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g0[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g0[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g1[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g0[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g0[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g3[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g2[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g2[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g1[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g0[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g0[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g1[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g0[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g0[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g7[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g6[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g6[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g5[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g4[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g4[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g5[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g4[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g4[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g3[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g2[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g2[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g1[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g0[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g0[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g1[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g0[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g0[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g3[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g2[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g2[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g1[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g0[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g0[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g1[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g0[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g0[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g31[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g30[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g30[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g29[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g28[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g28[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g29[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g28[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g28[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g27[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g26[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g26[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g25[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g24[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g24[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g25[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g24[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g24[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g27[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g26[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g26[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g25[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g24[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g24[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g25[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g24[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g24[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g23[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g22[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g22[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g21[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g20[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g20[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g21[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g20[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g20[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g19[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g18[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g18[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g17[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g16[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g16[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g17[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g16[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g16[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g19[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g18[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g18[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g17[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g16[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g16[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g17[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g16[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g16[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g23[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g22[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g22[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g21[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g20[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g20[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g21[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g20[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g20[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g19[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g18[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g18[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g17[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g16[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g16[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g17[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g16[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g16[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g19[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g18[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g18[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g17[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g16[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g16[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g17[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g16[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g16[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g15[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g14[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g14[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g13[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g12[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g12[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g13[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g12[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g12[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g11[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g10[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g10[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g9[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g8[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g8[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g9[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g8[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g8[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g11[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g10[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g10[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g9[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g8[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g8[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g9[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g8[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g8[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g7[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g6[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g6[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g5[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g4[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g4[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g5[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g4[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g4[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g3[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g2[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g2[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g1[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g0[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g0[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g1[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g0[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g0[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g3[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g2[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g2[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g1[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g0[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g0[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g1[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g0[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g0[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g7[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g6[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g6[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g5[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g4[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g4[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g5[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g4[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g4[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g3[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g2[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g2[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g1[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g0[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g0[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g1[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g0[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g0[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g3[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g2[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g2[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g1[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g0[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g0[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g1[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g0[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g0[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g15[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g14[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g14[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g13[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g12[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g12[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g13[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g12[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g12[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g11[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g10[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g10[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g9[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g8[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g8[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g9[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g8[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g8[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g11[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g10[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g10[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g9[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g8[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g8[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g9[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g8[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g8[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g7[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g6[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g6[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g5[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g4[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g4[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g5[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g4[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g4[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g3[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g2[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g2[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g1[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g0[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g0[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g1[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g0[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g0[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g3[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g2[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g2[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g1[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g0[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g0[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g1[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g0[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g0[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g7[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g6[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g6[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g5[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g4[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g4[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g5[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g4[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g4[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g3[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g2[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g2[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g1[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g0[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g0[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g1[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g0[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g0[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g3[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g2[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g2[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g1[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g0[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g0[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g1[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g0[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g0[ix+0]*g0[iy+0]*g63[iz+0];
if (gout_empty) {
gout[n*9+0] = + s[0] + 2*s[36] + 2*s[72] + s[360] + 2*s[396] + s[720];
gout[n*9+1] = + s[1] + 2*s[37] + 2*s[73] + s[361] + 2*s[397] + s[721];
gout[n*9+2] = + s[2] + 2*s[38] + 2*s[74] + s[362] + 2*s[398] + s[722];
gout[n*9+3] = + s[3] + 2*s[39] + 2*s[75] + s[363] + 2*s[399] + s[723];
gout[n*9+4] = + s[4] + 2*s[40] + 2*s[76] + s[364] + 2*s[400] + s[724];
gout[n*9+5] = + s[5] + 2*s[41] + 2*s[77] + s[365] + 2*s[401] + s[725];
gout[n*9+6] = + s[6] + 2*s[42] + 2*s[78] + s[366] + 2*s[402] + s[726];
gout[n*9+7] = + s[7] + 2*s[43] + 2*s[79] + s[367] + 2*s[403] + s[727];
gout[n*9+8] = + s[8] + 2*s[44] + 2*s[80] + s[368] + 2*s[404] + s[728];
} else {
gout[n*9+0] += + s[0] + 2*s[36] + 2*s[72] + s[360] + 2*s[396] + s[720];
gout[n*9+1] += + s[1] + 2*s[37] + 2*s[73] + s[361] + 2*s[397] + s[721];
gout[n*9+2] += + s[2] + 2*s[38] + 2*s[74] + s[362] + 2*s[398] + s[722];
gout[n*9+3] += + s[3] + 2*s[39] + 2*s[75] + s[363] + 2*s[399] + s[723];
gout[n*9+4] += + s[4] + 2*s[40] + 2*s[76] + s[364] + 2*s[400] + s[724];
gout[n*9+5] += + s[5] + 2*s[41] + 2*s[77] + s[365] + 2*s[401] + s[725];
gout[n*9+6] += + s[6] + 2*s[42] + 2*s[78] + s[366] + 2*s[402] + s[726];
gout[n*9+7] += + s[7] + 2*s[43] + 2*s[79] + s[367] + 2*s[403] + s[727];
gout[n*9+8] += + s[8] + 2*s[44] + 2*s[80] + s[368] + 2*s[404] + s[728];
}}}
void int1e_rrrrjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrrjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrrrjj_cart
CACHE_SIZE_T int1e_rrrrjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrrrjj_sph
CACHE_SIZE_T int1e_rrrrjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 2, 0, 0, 6, 1, 1, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrrrjj_spinor
ALL_CINT1E(int1e_rrrrjj)
ALL_CINT1E_FORTRAN_(int1e_rrrrjj)
/* <RI DOT RI i|R R R |j> */
void CINTgout1e_int1e_rrjjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[243];
G1E_R_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_R_J(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_R_J(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_RCI(g8, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g16, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g17, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g18, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g19, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g20, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g21, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g22, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g23, g7, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g24, g8, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g25, g9, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g26, g10, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g27, g11, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g28, g12, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g29, g13, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g30, g14, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g31, g15, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g31[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g30[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g30[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g29[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g28[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g28[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g29[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g28[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g28[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g27[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g26[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g26[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g25[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g24[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g24[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g25[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g24[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g24[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g27[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g26[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g26[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g25[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g24[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g24[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g25[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g24[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g24[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g23[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g22[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g22[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g21[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g20[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g20[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g21[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g20[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g20[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g19[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g18[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g18[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g17[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g16[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g16[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g17[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g16[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g16[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g19[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g18[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g18[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g17[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g16[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g16[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g17[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g16[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g16[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g23[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g22[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g22[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g21[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g20[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g20[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g21[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g20[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g20[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g19[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g18[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g18[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g17[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g16[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g16[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g17[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g16[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g16[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g19[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g18[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g18[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g17[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g16[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g16[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g17[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g16[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g16[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g15[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g14[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g14[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g13[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g12[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g12[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g13[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g12[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g12[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g11[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g10[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g10[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g9[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g8[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g8[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g9[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g8[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g8[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g11[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g10[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g10[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g9[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g8[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g8[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g9[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g8[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g8[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g7[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g6[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g6[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g5[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g4[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g4[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g5[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g4[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g4[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g3[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g2[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g2[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g1[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g0[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g0[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g1[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g0[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g0[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g3[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g2[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g2[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g1[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g0[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g0[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g1[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g0[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g0[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g7[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g6[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g6[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g5[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g4[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g4[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g5[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g4[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g4[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g3[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g2[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g2[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g1[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g0[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g0[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g1[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g0[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g0[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g3[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g2[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g2[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g1[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g0[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g0[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g1[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g0[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g0[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g15[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g14[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g14[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g13[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g12[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g12[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g13[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g12[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g12[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g11[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g10[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g10[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g9[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g8[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g8[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g9[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g8[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g8[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g11[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g10[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g10[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g9[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g8[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g8[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g9[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g8[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g8[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g7[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g6[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g6[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g5[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g4[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g4[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g5[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g4[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g4[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g3[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g2[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g2[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g1[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g0[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g0[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g1[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g0[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g0[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g3[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g2[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g2[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g1[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g0[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g0[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g1[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g0[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g0[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g7[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g6[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g6[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g5[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g4[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g4[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g5[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g4[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g4[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g3[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g2[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g2[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g1[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g0[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g0[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g1[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g0[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g0[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g3[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g2[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g2[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g1[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g0[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g0[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g1[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g0[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g0[ix+0]*g0[iy+0]*g31[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0] + s[108] + s[216];
gout[n*27+1] = + s[1] + s[109] + s[217];
gout[n*27+2] = + s[2] + s[110] + s[218];
gout[n*27+3] = + s[3] + s[111] + s[219];
gout[n*27+4] = + s[4] + s[112] + s[220];
gout[n*27+5] = + s[5] + s[113] + s[221];
gout[n*27+6] = + s[6] + s[114] + s[222];
gout[n*27+7] = + s[7] + s[115] + s[223];
gout[n*27+8] = + s[8] + s[116] + s[224];
gout[n*27+9] = + s[9] + s[117] + s[225];
gout[n*27+10] = + s[10] + s[118] + s[226];
gout[n*27+11] = + s[11] + s[119] + s[227];
gout[n*27+12] = + s[12] + s[120] + s[228];
gout[n*27+13] = + s[13] + s[121] + s[229];
gout[n*27+14] = + s[14] + s[122] + s[230];
gout[n*27+15] = + s[15] + s[123] + s[231];
gout[n*27+16] = + s[16] + s[124] + s[232];
gout[n*27+17] = + s[17] + s[125] + s[233];
gout[n*27+18] = + s[18] + s[126] + s[234];
gout[n*27+19] = + s[19] + s[127] + s[235];
gout[n*27+20] = + s[20] + s[128] + s[236];
gout[n*27+21] = + s[21] + s[129] + s[237];
gout[n*27+22] = + s[22] + s[130] + s[238];
gout[n*27+23] = + s[23] + s[131] + s[239];
gout[n*27+24] = + s[24] + s[132] + s[240];
gout[n*27+25] = + s[25] + s[133] + s[241];
gout[n*27+26] = + s[26] + s[134] + s[242];
} else {
gout[n*27+0] += + s[0] + s[108] + s[216];
gout[n*27+1] += + s[1] + s[109] + s[217];
gout[n*27+2] += + s[2] + s[110] + s[218];
gout[n*27+3] += + s[3] + s[111] + s[219];
gout[n*27+4] += + s[4] + s[112] + s[220];
gout[n*27+5] += + s[5] + s[113] + s[221];
gout[n*27+6] += + s[6] + s[114] + s[222];
gout[n*27+7] += + s[7] + s[115] + s[223];
gout[n*27+8] += + s[8] + s[116] + s[224];
gout[n*27+9] += + s[9] + s[117] + s[225];
gout[n*27+10] += + s[10] + s[118] + s[226];
gout[n*27+11] += + s[11] + s[119] + s[227];
gout[n*27+12] += + s[12] + s[120] + s[228];
gout[n*27+13] += + s[13] + s[121] + s[229];
gout[n*27+14] += + s[14] + s[122] + s[230];
gout[n*27+15] += + s[15] + s[123] + s[231];
gout[n*27+16] += + s[16] + s[124] + s[232];
gout[n*27+17] += + s[17] + s[125] + s[233];
gout[n*27+18] += + s[18] + s[126] + s[234];
gout[n*27+19] += + s[19] + s[127] + s[235];
gout[n*27+20] += + s[20] + s[128] + s[236];
gout[n*27+21] += + s[21] + s[129] + s[237];
gout[n*27+22] += + s[22] + s[130] + s[238];
gout[n*27+23] += + s[23] + s[131] + s[239];
gout[n*27+24] += + s[24] + s[132] + s[240];
gout[n*27+25] += + s[25] + s[133] + s[241];
gout[n*27+26] += + s[26] + s[134] + s[242];
}}}
void int1e_rrjjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrjjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrjjj_cart
CACHE_SIZE_T int1e_rrjjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrjjj_sph
CACHE_SIZE_T int1e_rrjjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 3, 0, 0, 5, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrjjj_spinor
ALL_CINT1E(int1e_rrjjj)
ALL_CINT1E_FORTRAN_(int1e_rrjjj)
/* <RI DOT RI i|R R R |RJ DOT RJ j> */
void CINTgout1e_int1e_rrjjjrr(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double *g64 = g63 + envs->g_size * 3;
double *g65 = g64 + envs->g_size * 3;
double *g66 = g65 + envs->g_size * 3;
double *g67 = g66 + envs->g_size * 3;
double *g68 = g67 + envs->g_size * 3;
double *g69 = g68 + envs->g_size * 3;
double *g70 = g69 + envs->g_size * 3;
double *g71 = g70 + envs->g_size * 3;
double *g72 = g71 + envs->g_size * 3;
double *g73 = g72 + envs->g_size * 3;
double *g74 = g73 + envs->g_size * 3;
double *g75 = g74 + envs->g_size * 3;
double *g76 = g75 + envs->g_size * 3;
double *g77 = g76 + envs->g_size * 3;
double *g78 = g77 + envs->g_size * 3;
double *g79 = g78 + envs->g_size * 3;
double *g80 = g79 + envs->g_size * 3;
double *g81 = g80 + envs->g_size * 3;
double *g82 = g81 + envs->g_size * 3;
double *g83 = g82 + envs->g_size * 3;
double *g84 = g83 + envs->g_size * 3;
double *g85 = g84 + envs->g_size * 3;
double *g86 = g85 + envs->g_size * 3;
double *g87 = g86 + envs->g_size * 3;
double *g88 = g87 + envs->g_size * 3;
double *g89 = g88 + envs->g_size * 3;
double *g90 = g89 + envs->g_size * 3;
double *g91 = g90 + envs->g_size * 3;
double *g92 = g91 + envs->g_size * 3;
double *g93 = g92 + envs->g_size * 3;
double *g94 = g93 + envs->g_size * 3;
double *g95 = g94 + envs->g_size * 3;
double *g96 = g95 + envs->g_size * 3;
double *g97 = g96 + envs->g_size * 3;
double *g98 = g97 + envs->g_size * 3;
double *g99 = g98 + envs->g_size * 3;
double *g100 = g99 + envs->g_size * 3;
double *g101 = g100 + envs->g_size * 3;
double *g102 = g101 + envs->g_size * 3;
double *g103 = g102 + envs->g_size * 3;
double *g104 = g103 + envs->g_size * 3;
double *g105 = g104 + envs->g_size * 3;
double *g106 = g105 + envs->g_size * 3;
double *g107 = g106 + envs->g_size * 3;
double *g108 = g107 + envs->g_size * 3;
double *g109 = g108 + envs->g_size * 3;
double *g110 = g109 + envs->g_size * 3;
double *g111 = g110 + envs->g_size * 3;
double *g112 = g111 + envs->g_size * 3;
double *g113 = g112 + envs->g_size * 3;
double *g114 = g113 + envs->g_size * 3;
double *g115 = g114 + envs->g_size * 3;
double *g116 = g115 + envs->g_size * 3;
double *g117 = g116 + envs->g_size * 3;
double *g118 = g117 + envs->g_size * 3;
double *g119 = g118 + envs->g_size * 3;
double *g120 = g119 + envs->g_size * 3;
double *g121 = g120 + envs->g_size * 3;
double *g122 = g121 + envs->g_size * 3;
double *g123 = g122 + envs->g_size * 3;
double *g124 = g123 + envs->g_size * 3;
double *g125 = g124 + envs->g_size * 3;
double *g126 = g125 + envs->g_size * 3;
double *g127 = g126 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double drj[3];
drj[0] = envs->rj[0] - envs->rj[0];
drj[1] = envs->rj[1] - envs->rj[1];
drj[2] = envs->rj[2] - envs->rj[2];
double s[2187];
G1E_RCJ(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g3, g2, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g5, g4, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g6, g4, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g7, g6, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g8, g0, envs->i_l+2, envs->j_l+3, 0);
G1E_RCJ(g9, g8, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g10, g8, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g11, g10, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g12, g8, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g13, g12, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g14, g12, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g15, g14, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g16, g0, envs->i_l+2, envs->j_l+4, 0);
G1E_RCJ(g17, g16, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g18, g16, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g19, g18, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g20, g16, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g21, g20, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g22, g20, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g23, g22, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g24, g16, envs->i_l+2, envs->j_l+3, 0);
G1E_RCJ(g25, g24, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g26, g24, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g27, g26, envs->i_l+2, envs->j_l+0, 0);
G1E_R_J(g28, g24, envs->i_l+2, envs->j_l+2, 0);
G1E_RCJ(g29, g28, envs->i_l+2, envs->j_l+0, 0);
G1E_RCJ(g30, g28, envs->i_l+2, envs->j_l+1, 0);
G1E_RCJ(g31, g30, envs->i_l+2, envs->j_l+0, 0);
G1E_RCI(g32, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g33, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g34, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g35, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g36, g4, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g37, g5, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g38, g6, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g39, g7, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g40, g8, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g41, g9, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g42, g10, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g43, g11, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g44, g12, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g45, g13, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g46, g14, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g47, g15, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g48, g16, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g49, g17, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g50, g18, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g51, g19, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g52, g20, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g53, g21, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g54, g22, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g55, g23, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g56, g24, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g57, g25, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g58, g26, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g59, g27, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g60, g28, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g61, g29, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g62, g30, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g63, g31, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g64, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g65, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g66, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g67, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g68, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g69, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g70, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g71, g7, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g72, g8, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g73, g9, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g74, g10, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g75, g11, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g76, g12, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g77, g13, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g78, g14, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g79, g15, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g80, g16, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g81, g17, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g82, g18, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g83, g19, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g84, g20, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g85, g21, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g86, g22, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g87, g23, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g88, g24, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g89, g25, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g90, g26, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g91, g27, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g92, g28, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g93, g29, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g94, g30, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g95, g31, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g96, g32, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g97, g33, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g98, g34, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g99, g35, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g100, g36, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g101, g37, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g102, g38, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g103, g39, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g104, g40, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g105, g41, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g106, g42, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g107, g43, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g108, g44, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g109, g45, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g110, g46, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g111, g47, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g112, g48, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g113, g49, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g114, g50, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g115, g51, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g116, g52, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g117, g53, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g118, g54, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g119, g55, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g120, g56, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g121, g57, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g122, g58, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g123, g59, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g124, g60, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g125, g61, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g126, g62, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g127, g63, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g127[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g126[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g126[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g125[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g124[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g124[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g125[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g124[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g124[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g123[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g122[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g122[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g121[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g120[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g120[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g121[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g120[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g120[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g123[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g122[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g122[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g121[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g120[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g120[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g121[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g120[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g120[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g119[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g118[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g118[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g117[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g116[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g116[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g117[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g116[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g116[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g115[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g114[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g114[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g113[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g112[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g112[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g113[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g112[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g112[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g115[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g114[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g114[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g113[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g112[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g112[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g113[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g112[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g112[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g119[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g118[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g118[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g117[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g116[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g116[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g117[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g116[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g116[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g115[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g114[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g114[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g113[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g112[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g112[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g113[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g112[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g112[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g115[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g114[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g114[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g113[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g112[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g112[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g113[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g112[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g112[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g111[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g110[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g110[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g109[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g108[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g108[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g109[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g108[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g108[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g107[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g106[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g106[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g105[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g104[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g104[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g105[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g104[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g104[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g107[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g106[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g106[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g105[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g104[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g104[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g105[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g104[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g104[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g103[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g102[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g102[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g101[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g100[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g100[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g101[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g100[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g100[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g99[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g98[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g98[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g97[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g96[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g96[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g97[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g96[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g96[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g99[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g98[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g98[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g97[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g96[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g96[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g97[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g96[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g96[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g103[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g102[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g102[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g101[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g100[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g100[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g101[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g100[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g100[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g99[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g98[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g98[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g97[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g96[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g96[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g97[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g96[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g96[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g99[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g98[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g98[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g97[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g96[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g96[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g97[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g96[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g96[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g111[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g110[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g110[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g109[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g108[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g108[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g109[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g108[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g108[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g107[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g106[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g106[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g105[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g104[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g104[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g105[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g104[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g104[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g107[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g106[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g106[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g105[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g104[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g104[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g105[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g104[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g104[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g103[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g102[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g102[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g101[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g100[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g100[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g101[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g100[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g100[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g99[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g98[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g98[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g97[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g96[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g96[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g97[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g96[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g96[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g99[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g98[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g98[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g97[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g96[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g96[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g97[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g96[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g96[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g103[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g102[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g102[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g101[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g100[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g100[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g101[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g100[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g100[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g99[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g98[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g98[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g97[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g96[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g96[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g97[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g96[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g96[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g99[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g98[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g98[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g97[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g96[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g96[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g97[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g96[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g96[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g95[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g94[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g94[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g93[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g92[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g92[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g93[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g92[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g92[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g91[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g90[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g90[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g89[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g88[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g88[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g89[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g88[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g88[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g91[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g90[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g90[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g89[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g88[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g88[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g89[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g88[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g88[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g87[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g86[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g86[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g85[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g84[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g84[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g85[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g84[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g84[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g83[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g82[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g82[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g81[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g80[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g80[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g81[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g80[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g80[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g83[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g82[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g82[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g81[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g80[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g80[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g81[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g80[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g80[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g87[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g86[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g86[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g85[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g84[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g84[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g85[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g84[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g84[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g83[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g82[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g82[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g81[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g80[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g80[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g81[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g80[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g80[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g83[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g82[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g82[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g81[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g80[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g80[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g81[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g80[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g80[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g79[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g78[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g78[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g77[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g76[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g76[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g77[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g76[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g76[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g75[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g74[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g74[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g73[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g72[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g72[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g73[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g72[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g72[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g75[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g74[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g74[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g73[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g72[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g72[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g73[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g72[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g72[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g71[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g70[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g70[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g69[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g68[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g68[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g69[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g68[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g68[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g67[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g66[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g66[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g65[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g64[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g64[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g65[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g64[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g64[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g67[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g66[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g66[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g65[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g64[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g64[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g65[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g64[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g64[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g71[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g70[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g70[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g69[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g68[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g68[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g69[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g68[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g68[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g67[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g66[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g66[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g65[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g64[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g64[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g65[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g64[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g64[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g67[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g66[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g66[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g65[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g64[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g64[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g65[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g64[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g64[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g79[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g78[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g78[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g77[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g76[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g76[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g77[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g76[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g76[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g75[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g74[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g74[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g73[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g72[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g72[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g73[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g72[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g72[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g75[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g74[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g74[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g73[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g72[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g72[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g73[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g72[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g72[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g71[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g70[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g70[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g69[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g68[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g68[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g69[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g68[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g68[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g67[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g66[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g66[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g65[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g64[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g64[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g65[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g64[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g64[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g67[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g66[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g66[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g65[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g64[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g64[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g65[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g64[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g64[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g71[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g70[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g70[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g69[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g68[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g68[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g69[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g68[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g68[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g67[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g66[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g66[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g65[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g64[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g64[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g65[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g64[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g64[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g67[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g66[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g66[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g65[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g64[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g64[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g65[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g64[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g64[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g95[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g94[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g94[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g93[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g92[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g92[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g93[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g92[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g92[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g91[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g90[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g90[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g89[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g88[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g88[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g89[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g88[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g88[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g91[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g90[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g90[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g89[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g88[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g88[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g89[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g88[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g88[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g87[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g86[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g86[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g85[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g84[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g84[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g85[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g84[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g84[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g83[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g82[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g82[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g81[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g80[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g80[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g81[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g80[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g80[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g83[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g82[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g82[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g81[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g80[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g80[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g81[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g80[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g80[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g87[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g86[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g86[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g85[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g84[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g84[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g85[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g84[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g84[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g83[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g82[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g82[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g81[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g80[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g80[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g81[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g80[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g80[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g83[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g82[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g82[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g81[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g80[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g80[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g81[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g80[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g80[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g79[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g78[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g78[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g77[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g76[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g76[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g77[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g76[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g76[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g75[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g74[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g74[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g73[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g72[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g72[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g73[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g72[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g72[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g75[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g74[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g74[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g73[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g72[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g72[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g73[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g72[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g72[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g71[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g70[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g70[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g69[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g68[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g68[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g69[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g68[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g68[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g67[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g66[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g66[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g65[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g64[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g64[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g65[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g64[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g64[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g67[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g66[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g66[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g65[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g64[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g64[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g65[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g64[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g64[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g71[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g70[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g70[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g69[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g68[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g68[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g69[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g68[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g68[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g67[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g66[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g66[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g65[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g64[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g64[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g65[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g64[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g64[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g67[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g66[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g66[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g65[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g64[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g64[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g65[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g64[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g64[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g79[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g78[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g78[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g77[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g76[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g76[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g77[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g76[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g76[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g75[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g74[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g74[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g73[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g72[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g72[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g73[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g72[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g72[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g75[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g74[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g74[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g73[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g72[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g72[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g73[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g72[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g72[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g71[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g70[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g70[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g69[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g68[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g68[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g69[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g68[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g68[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g67[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g66[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g66[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g65[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g64[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g64[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g65[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g64[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g64[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g67[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g66[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g66[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g65[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g64[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g64[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g65[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g64[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g64[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g71[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g70[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g70[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g69[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g68[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g68[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g69[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g68[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g68[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g67[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g66[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g66[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g65[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g64[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g64[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g65[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g64[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g64[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g67[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g66[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g66[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g65[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g64[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g64[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g65[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g64[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g64[ix+0]*g0[iy+0]*g63[iz+0];
s[729] = + g63[ix+0]*g64[iy+0]*g0[iz+0];
s[730] = + g62[ix+0]*g65[iy+0]*g0[iz+0];
s[731] = + g62[ix+0]*g64[iy+0]*g1[iz+0];
s[732] = + g61[ix+0]*g66[iy+0]*g0[iz+0];
s[733] = + g60[ix+0]*g67[iy+0]*g0[iz+0];
s[734] = + g60[ix+0]*g66[iy+0]*g1[iz+0];
s[735] = + g61[ix+0]*g64[iy+0]*g2[iz+0];
s[736] = + g60[ix+0]*g65[iy+0]*g2[iz+0];
s[737] = + g60[ix+0]*g64[iy+0]*g3[iz+0];
s[738] = + g59[ix+0]*g68[iy+0]*g0[iz+0];
s[739] = + g58[ix+0]*g69[iy+0]*g0[iz+0];
s[740] = + g58[ix+0]*g68[iy+0]*g1[iz+0];
s[741] = + g57[ix+0]*g70[iy+0]*g0[iz+0];
s[742] = + g56[ix+0]*g71[iy+0]*g0[iz+0];
s[743] = + g56[ix+0]*g70[iy+0]*g1[iz+0];
s[744] = + g57[ix+0]*g68[iy+0]*g2[iz+0];
s[745] = + g56[ix+0]*g69[iy+0]*g2[iz+0];
s[746] = + g56[ix+0]*g68[iy+0]*g3[iz+0];
s[747] = + g59[ix+0]*g64[iy+0]*g4[iz+0];
s[748] = + g58[ix+0]*g65[iy+0]*g4[iz+0];
s[749] = + g58[ix+0]*g64[iy+0]*g5[iz+0];
s[750] = + g57[ix+0]*g66[iy+0]*g4[iz+0];
s[751] = + g56[ix+0]*g67[iy+0]*g4[iz+0];
s[752] = + g56[ix+0]*g66[iy+0]*g5[iz+0];
s[753] = + g57[ix+0]*g64[iy+0]*g6[iz+0];
s[754] = + g56[ix+0]*g65[iy+0]*g6[iz+0];
s[755] = + g56[ix+0]*g64[iy+0]*g7[iz+0];
s[756] = + g55[ix+0]*g72[iy+0]*g0[iz+0];
s[757] = + g54[ix+0]*g73[iy+0]*g0[iz+0];
s[758] = + g54[ix+0]*g72[iy+0]*g1[iz+0];
s[759] = + g53[ix+0]*g74[iy+0]*g0[iz+0];
s[760] = + g52[ix+0]*g75[iy+0]*g0[iz+0];
s[761] = + g52[ix+0]*g74[iy+0]*g1[iz+0];
s[762] = + g53[ix+0]*g72[iy+0]*g2[iz+0];
s[763] = + g52[ix+0]*g73[iy+0]*g2[iz+0];
s[764] = + g52[ix+0]*g72[iy+0]*g3[iz+0];
s[765] = + g51[ix+0]*g76[iy+0]*g0[iz+0];
s[766] = + g50[ix+0]*g77[iy+0]*g0[iz+0];
s[767] = + g50[ix+0]*g76[iy+0]*g1[iz+0];
s[768] = + g49[ix+0]*g78[iy+0]*g0[iz+0];
s[769] = + g48[ix+0]*g79[iy+0]*g0[iz+0];
s[770] = + g48[ix+0]*g78[iy+0]*g1[iz+0];
s[771] = + g49[ix+0]*g76[iy+0]*g2[iz+0];
s[772] = + g48[ix+0]*g77[iy+0]*g2[iz+0];
s[773] = + g48[ix+0]*g76[iy+0]*g3[iz+0];
s[774] = + g51[ix+0]*g72[iy+0]*g4[iz+0];
s[775] = + g50[ix+0]*g73[iy+0]*g4[iz+0];
s[776] = + g50[ix+0]*g72[iy+0]*g5[iz+0];
s[777] = + g49[ix+0]*g74[iy+0]*g4[iz+0];
s[778] = + g48[ix+0]*g75[iy+0]*g4[iz+0];
s[779] = + g48[ix+0]*g74[iy+0]*g5[iz+0];
s[780] = + g49[ix+0]*g72[iy+0]*g6[iz+0];
s[781] = + g48[ix+0]*g73[iy+0]*g6[iz+0];
s[782] = + g48[ix+0]*g72[iy+0]*g7[iz+0];
s[783] = + g55[ix+0]*g64[iy+0]*g8[iz+0];
s[784] = + g54[ix+0]*g65[iy+0]*g8[iz+0];
s[785] = + g54[ix+0]*g64[iy+0]*g9[iz+0];
s[786] = + g53[ix+0]*g66[iy+0]*g8[iz+0];
s[787] = + g52[ix+0]*g67[iy+0]*g8[iz+0];
s[788] = + g52[ix+0]*g66[iy+0]*g9[iz+0];
s[789] = + g53[ix+0]*g64[iy+0]*g10[iz+0];
s[790] = + g52[ix+0]*g65[iy+0]*g10[iz+0];
s[791] = + g52[ix+0]*g64[iy+0]*g11[iz+0];
s[792] = + g51[ix+0]*g68[iy+0]*g8[iz+0];
s[793] = + g50[ix+0]*g69[iy+0]*g8[iz+0];
s[794] = + g50[ix+0]*g68[iy+0]*g9[iz+0];
s[795] = + g49[ix+0]*g70[iy+0]*g8[iz+0];
s[796] = + g48[ix+0]*g71[iy+0]*g8[iz+0];
s[797] = + g48[ix+0]*g70[iy+0]*g9[iz+0];
s[798] = + g49[ix+0]*g68[iy+0]*g10[iz+0];
s[799] = + g48[ix+0]*g69[iy+0]*g10[iz+0];
s[800] = + g48[ix+0]*g68[iy+0]*g11[iz+0];
s[801] = + g51[ix+0]*g64[iy+0]*g12[iz+0];
s[802] = + g50[ix+0]*g65[iy+0]*g12[iz+0];
s[803] = + g50[ix+0]*g64[iy+0]*g13[iz+0];
s[804] = + g49[ix+0]*g66[iy+0]*g12[iz+0];
s[805] = + g48[ix+0]*g67[iy+0]*g12[iz+0];
s[806] = + g48[ix+0]*g66[iy+0]*g13[iz+0];
s[807] = + g49[ix+0]*g64[iy+0]*g14[iz+0];
s[808] = + g48[ix+0]*g65[iy+0]*g14[iz+0];
s[809] = + g48[ix+0]*g64[iy+0]*g15[iz+0];
s[810] = + g47[ix+0]*g80[iy+0]*g0[iz+0];
s[811] = + g46[ix+0]*g81[iy+0]*g0[iz+0];
s[812] = + g46[ix+0]*g80[iy+0]*g1[iz+0];
s[813] = + g45[ix+0]*g82[iy+0]*g0[iz+0];
s[814] = + g44[ix+0]*g83[iy+0]*g0[iz+0];
s[815] = + g44[ix+0]*g82[iy+0]*g1[iz+0];
s[816] = + g45[ix+0]*g80[iy+0]*g2[iz+0];
s[817] = + g44[ix+0]*g81[iy+0]*g2[iz+0];
s[818] = + g44[ix+0]*g80[iy+0]*g3[iz+0];
s[819] = + g43[ix+0]*g84[iy+0]*g0[iz+0];
s[820] = + g42[ix+0]*g85[iy+0]*g0[iz+0];
s[821] = + g42[ix+0]*g84[iy+0]*g1[iz+0];
s[822] = + g41[ix+0]*g86[iy+0]*g0[iz+0];
s[823] = + g40[ix+0]*g87[iy+0]*g0[iz+0];
s[824] = + g40[ix+0]*g86[iy+0]*g1[iz+0];
s[825] = + g41[ix+0]*g84[iy+0]*g2[iz+0];
s[826] = + g40[ix+0]*g85[iy+0]*g2[iz+0];
s[827] = + g40[ix+0]*g84[iy+0]*g3[iz+0];
s[828] = + g43[ix+0]*g80[iy+0]*g4[iz+0];
s[829] = + g42[ix+0]*g81[iy+0]*g4[iz+0];
s[830] = + g42[ix+0]*g80[iy+0]*g5[iz+0];
s[831] = + g41[ix+0]*g82[iy+0]*g4[iz+0];
s[832] = + g40[ix+0]*g83[iy+0]*g4[iz+0];
s[833] = + g40[ix+0]*g82[iy+0]*g5[iz+0];
s[834] = + g41[ix+0]*g80[iy+0]*g6[iz+0];
s[835] = + g40[ix+0]*g81[iy+0]*g6[iz+0];
s[836] = + g40[ix+0]*g80[iy+0]*g7[iz+0];
s[837] = + g39[ix+0]*g88[iy+0]*g0[iz+0];
s[838] = + g38[ix+0]*g89[iy+0]*g0[iz+0];
s[839] = + g38[ix+0]*g88[iy+0]*g1[iz+0];
s[840] = + g37[ix+0]*g90[iy+0]*g0[iz+0];
s[841] = + g36[ix+0]*g91[iy+0]*g0[iz+0];
s[842] = + g36[ix+0]*g90[iy+0]*g1[iz+0];
s[843] = + g37[ix+0]*g88[iy+0]*g2[iz+0];
s[844] = + g36[ix+0]*g89[iy+0]*g2[iz+0];
s[845] = + g36[ix+0]*g88[iy+0]*g3[iz+0];
s[846] = + g35[ix+0]*g92[iy+0]*g0[iz+0];
s[847] = + g34[ix+0]*g93[iy+0]*g0[iz+0];
s[848] = + g34[ix+0]*g92[iy+0]*g1[iz+0];
s[849] = + g33[ix+0]*g94[iy+0]*g0[iz+0];
s[850] = + g32[ix+0]*g95[iy+0]*g0[iz+0];
s[851] = + g32[ix+0]*g94[iy+0]*g1[iz+0];
s[852] = + g33[ix+0]*g92[iy+0]*g2[iz+0];
s[853] = + g32[ix+0]*g93[iy+0]*g2[iz+0];
s[854] = + g32[ix+0]*g92[iy+0]*g3[iz+0];
s[855] = + g35[ix+0]*g88[iy+0]*g4[iz+0];
s[856] = + g34[ix+0]*g89[iy+0]*g4[iz+0];
s[857] = + g34[ix+0]*g88[iy+0]*g5[iz+0];
s[858] = + g33[ix+0]*g90[iy+0]*g4[iz+0];
s[859] = + g32[ix+0]*g91[iy+0]*g4[iz+0];
s[860] = + g32[ix+0]*g90[iy+0]*g5[iz+0];
s[861] = + g33[ix+0]*g88[iy+0]*g6[iz+0];
s[862] = + g32[ix+0]*g89[iy+0]*g6[iz+0];
s[863] = + g32[ix+0]*g88[iy+0]*g7[iz+0];
s[864] = + g39[ix+0]*g80[iy+0]*g8[iz+0];
s[865] = + g38[ix+0]*g81[iy+0]*g8[iz+0];
s[866] = + g38[ix+0]*g80[iy+0]*g9[iz+0];
s[867] = + g37[ix+0]*g82[iy+0]*g8[iz+0];
s[868] = + g36[ix+0]*g83[iy+0]*g8[iz+0];
s[869] = + g36[ix+0]*g82[iy+0]*g9[iz+0];
s[870] = + g37[ix+0]*g80[iy+0]*g10[iz+0];
s[871] = + g36[ix+0]*g81[iy+0]*g10[iz+0];
s[872] = + g36[ix+0]*g80[iy+0]*g11[iz+0];
s[873] = + g35[ix+0]*g84[iy+0]*g8[iz+0];
s[874] = + g34[ix+0]*g85[iy+0]*g8[iz+0];
s[875] = + g34[ix+0]*g84[iy+0]*g9[iz+0];
s[876] = + g33[ix+0]*g86[iy+0]*g8[iz+0];
s[877] = + g32[ix+0]*g87[iy+0]*g8[iz+0];
s[878] = + g32[ix+0]*g86[iy+0]*g9[iz+0];
s[879] = + g33[ix+0]*g84[iy+0]*g10[iz+0];
s[880] = + g32[ix+0]*g85[iy+0]*g10[iz+0];
s[881] = + g32[ix+0]*g84[iy+0]*g11[iz+0];
s[882] = + g35[ix+0]*g80[iy+0]*g12[iz+0];
s[883] = + g34[ix+0]*g81[iy+0]*g12[iz+0];
s[884] = + g34[ix+0]*g80[iy+0]*g13[iz+0];
s[885] = + g33[ix+0]*g82[iy+0]*g12[iz+0];
s[886] = + g32[ix+0]*g83[iy+0]*g12[iz+0];
s[887] = + g32[ix+0]*g82[iy+0]*g13[iz+0];
s[888] = + g33[ix+0]*g80[iy+0]*g14[iz+0];
s[889] = + g32[ix+0]*g81[iy+0]*g14[iz+0];
s[890] = + g32[ix+0]*g80[iy+0]*g15[iz+0];
s[891] = + g47[ix+0]*g64[iy+0]*g16[iz+0];
s[892] = + g46[ix+0]*g65[iy+0]*g16[iz+0];
s[893] = + g46[ix+0]*g64[iy+0]*g17[iz+0];
s[894] = + g45[ix+0]*g66[iy+0]*g16[iz+0];
s[895] = + g44[ix+0]*g67[iy+0]*g16[iz+0];
s[896] = + g44[ix+0]*g66[iy+0]*g17[iz+0];
s[897] = + g45[ix+0]*g64[iy+0]*g18[iz+0];
s[898] = + g44[ix+0]*g65[iy+0]*g18[iz+0];
s[899] = + g44[ix+0]*g64[iy+0]*g19[iz+0];
s[900] = + g43[ix+0]*g68[iy+0]*g16[iz+0];
s[901] = + g42[ix+0]*g69[iy+0]*g16[iz+0];
s[902] = + g42[ix+0]*g68[iy+0]*g17[iz+0];
s[903] = + g41[ix+0]*g70[iy+0]*g16[iz+0];
s[904] = + g40[ix+0]*g71[iy+0]*g16[iz+0];
s[905] = + g40[ix+0]*g70[iy+0]*g17[iz+0];
s[906] = + g41[ix+0]*g68[iy+0]*g18[iz+0];
s[907] = + g40[ix+0]*g69[iy+0]*g18[iz+0];
s[908] = + g40[ix+0]*g68[iy+0]*g19[iz+0];
s[909] = + g43[ix+0]*g64[iy+0]*g20[iz+0];
s[910] = + g42[ix+0]*g65[iy+0]*g20[iz+0];
s[911] = + g42[ix+0]*g64[iy+0]*g21[iz+0];
s[912] = + g41[ix+0]*g66[iy+0]*g20[iz+0];
s[913] = + g40[ix+0]*g67[iy+0]*g20[iz+0];
s[914] = + g40[ix+0]*g66[iy+0]*g21[iz+0];
s[915] = + g41[ix+0]*g64[iy+0]*g22[iz+0];
s[916] = + g40[ix+0]*g65[iy+0]*g22[iz+0];
s[917] = + g40[ix+0]*g64[iy+0]*g23[iz+0];
s[918] = + g39[ix+0]*g72[iy+0]*g16[iz+0];
s[919] = + g38[ix+0]*g73[iy+0]*g16[iz+0];
s[920] = + g38[ix+0]*g72[iy+0]*g17[iz+0];
s[921] = + g37[ix+0]*g74[iy+0]*g16[iz+0];
s[922] = + g36[ix+0]*g75[iy+0]*g16[iz+0];
s[923] = + g36[ix+0]*g74[iy+0]*g17[iz+0];
s[924] = + g37[ix+0]*g72[iy+0]*g18[iz+0];
s[925] = + g36[ix+0]*g73[iy+0]*g18[iz+0];
s[926] = + g36[ix+0]*g72[iy+0]*g19[iz+0];
s[927] = + g35[ix+0]*g76[iy+0]*g16[iz+0];
s[928] = + g34[ix+0]*g77[iy+0]*g16[iz+0];
s[929] = + g34[ix+0]*g76[iy+0]*g17[iz+0];
s[930] = + g33[ix+0]*g78[iy+0]*g16[iz+0];
s[931] = + g32[ix+0]*g79[iy+0]*g16[iz+0];
s[932] = + g32[ix+0]*g78[iy+0]*g17[iz+0];
s[933] = + g33[ix+0]*g76[iy+0]*g18[iz+0];
s[934] = + g32[ix+0]*g77[iy+0]*g18[iz+0];
s[935] = + g32[ix+0]*g76[iy+0]*g19[iz+0];
s[936] = + g35[ix+0]*g72[iy+0]*g20[iz+0];
s[937] = + g34[ix+0]*g73[iy+0]*g20[iz+0];
s[938] = + g34[ix+0]*g72[iy+0]*g21[iz+0];
s[939] = + g33[ix+0]*g74[iy+0]*g20[iz+0];
s[940] = + g32[ix+0]*g75[iy+0]*g20[iz+0];
s[941] = + g32[ix+0]*g74[iy+0]*g21[iz+0];
s[942] = + g33[ix+0]*g72[iy+0]*g22[iz+0];
s[943] = + g32[ix+0]*g73[iy+0]*g22[iz+0];
s[944] = + g32[ix+0]*g72[iy+0]*g23[iz+0];
s[945] = + g39[ix+0]*g64[iy+0]*g24[iz+0];
s[946] = + g38[ix+0]*g65[iy+0]*g24[iz+0];
s[947] = + g38[ix+0]*g64[iy+0]*g25[iz+0];
s[948] = + g37[ix+0]*g66[iy+0]*g24[iz+0];
s[949] = + g36[ix+0]*g67[iy+0]*g24[iz+0];
s[950] = + g36[ix+0]*g66[iy+0]*g25[iz+0];
s[951] = + g37[ix+0]*g64[iy+0]*g26[iz+0];
s[952] = + g36[ix+0]*g65[iy+0]*g26[iz+0];
s[953] = + g36[ix+0]*g64[iy+0]*g27[iz+0];
s[954] = + g35[ix+0]*g68[iy+0]*g24[iz+0];
s[955] = + g34[ix+0]*g69[iy+0]*g24[iz+0];
s[956] = + g34[ix+0]*g68[iy+0]*g25[iz+0];
s[957] = + g33[ix+0]*g70[iy+0]*g24[iz+0];
s[958] = + g32[ix+0]*g71[iy+0]*g24[iz+0];
s[959] = + g32[ix+0]*g70[iy+0]*g25[iz+0];
s[960] = + g33[ix+0]*g68[iy+0]*g26[iz+0];
s[961] = + g32[ix+0]*g69[iy+0]*g26[iz+0];
s[962] = + g32[ix+0]*g68[iy+0]*g27[iz+0];
s[963] = + g35[ix+0]*g64[iy+0]*g28[iz+0];
s[964] = + g34[ix+0]*g65[iy+0]*g28[iz+0];
s[965] = + g34[ix+0]*g64[iy+0]*g29[iz+0];
s[966] = + g33[ix+0]*g66[iy+0]*g28[iz+0];
s[967] = + g32[ix+0]*g67[iy+0]*g28[iz+0];
s[968] = + g32[ix+0]*g66[iy+0]*g29[iz+0];
s[969] = + g33[ix+0]*g64[iy+0]*g30[iz+0];
s[970] = + g32[ix+0]*g65[iy+0]*g30[iz+0];
s[971] = + g32[ix+0]*g64[iy+0]*g31[iz+0];
s[972] = + g31[ix+0]*g96[iy+0]*g0[iz+0];
s[973] = + g30[ix+0]*g97[iy+0]*g0[iz+0];
s[974] = + g30[ix+0]*g96[iy+0]*g1[iz+0];
s[975] = + g29[ix+0]*g98[iy+0]*g0[iz+0];
s[976] = + g28[ix+0]*g99[iy+0]*g0[iz+0];
s[977] = + g28[ix+0]*g98[iy+0]*g1[iz+0];
s[978] = + g29[ix+0]*g96[iy+0]*g2[iz+0];
s[979] = + g28[ix+0]*g97[iy+0]*g2[iz+0];
s[980] = + g28[ix+0]*g96[iy+0]*g3[iz+0];
s[981] = + g27[ix+0]*g100[iy+0]*g0[iz+0];
s[982] = + g26[ix+0]*g101[iy+0]*g0[iz+0];
s[983] = + g26[ix+0]*g100[iy+0]*g1[iz+0];
s[984] = + g25[ix+0]*g102[iy+0]*g0[iz+0];
s[985] = + g24[ix+0]*g103[iy+0]*g0[iz+0];
s[986] = + g24[ix+0]*g102[iy+0]*g1[iz+0];
s[987] = + g25[ix+0]*g100[iy+0]*g2[iz+0];
s[988] = + g24[ix+0]*g101[iy+0]*g2[iz+0];
s[989] = + g24[ix+0]*g100[iy+0]*g3[iz+0];
s[990] = + g27[ix+0]*g96[iy+0]*g4[iz+0];
s[991] = + g26[ix+0]*g97[iy+0]*g4[iz+0];
s[992] = + g26[ix+0]*g96[iy+0]*g5[iz+0];
s[993] = + g25[ix+0]*g98[iy+0]*g4[iz+0];
s[994] = + g24[ix+0]*g99[iy+0]*g4[iz+0];
s[995] = + g24[ix+0]*g98[iy+0]*g5[iz+0];
s[996] = + g25[ix+0]*g96[iy+0]*g6[iz+0];
s[997] = + g24[ix+0]*g97[iy+0]*g6[iz+0];
s[998] = + g24[ix+0]*g96[iy+0]*g7[iz+0];
s[999] = + g23[ix+0]*g104[iy+0]*g0[iz+0];
s[1000] = + g22[ix+0]*g105[iy+0]*g0[iz+0];
s[1001] = + g22[ix+0]*g104[iy+0]*g1[iz+0];
s[1002] = + g21[ix+0]*g106[iy+0]*g0[iz+0];
s[1003] = + g20[ix+0]*g107[iy+0]*g0[iz+0];
s[1004] = + g20[ix+0]*g106[iy+0]*g1[iz+0];
s[1005] = + g21[ix+0]*g104[iy+0]*g2[iz+0];
s[1006] = + g20[ix+0]*g105[iy+0]*g2[iz+0];
s[1007] = + g20[ix+0]*g104[iy+0]*g3[iz+0];
s[1008] = + g19[ix+0]*g108[iy+0]*g0[iz+0];
s[1009] = + g18[ix+0]*g109[iy+0]*g0[iz+0];
s[1010] = + g18[ix+0]*g108[iy+0]*g1[iz+0];
s[1011] = + g17[ix+0]*g110[iy+0]*g0[iz+0];
s[1012] = + g16[ix+0]*g111[iy+0]*g0[iz+0];
s[1013] = + g16[ix+0]*g110[iy+0]*g1[iz+0];
s[1014] = + g17[ix+0]*g108[iy+0]*g2[iz+0];
s[1015] = + g16[ix+0]*g109[iy+0]*g2[iz+0];
s[1016] = + g16[ix+0]*g108[iy+0]*g3[iz+0];
s[1017] = + g19[ix+0]*g104[iy+0]*g4[iz+0];
s[1018] = + g18[ix+0]*g105[iy+0]*g4[iz+0];
s[1019] = + g18[ix+0]*g104[iy+0]*g5[iz+0];
s[1020] = + g17[ix+0]*g106[iy+0]*g4[iz+0];
s[1021] = + g16[ix+0]*g107[iy+0]*g4[iz+0];
s[1022] = + g16[ix+0]*g106[iy+0]*g5[iz+0];
s[1023] = + g17[ix+0]*g104[iy+0]*g6[iz+0];
s[1024] = + g16[ix+0]*g105[iy+0]*g6[iz+0];
s[1025] = + g16[ix+0]*g104[iy+0]*g7[iz+0];
s[1026] = + g23[ix+0]*g96[iy+0]*g8[iz+0];
s[1027] = + g22[ix+0]*g97[iy+0]*g8[iz+0];
s[1028] = + g22[ix+0]*g96[iy+0]*g9[iz+0];
s[1029] = + g21[ix+0]*g98[iy+0]*g8[iz+0];
s[1030] = + g20[ix+0]*g99[iy+0]*g8[iz+0];
s[1031] = + g20[ix+0]*g98[iy+0]*g9[iz+0];
s[1032] = + g21[ix+0]*g96[iy+0]*g10[iz+0];
s[1033] = + g20[ix+0]*g97[iy+0]*g10[iz+0];
s[1034] = + g20[ix+0]*g96[iy+0]*g11[iz+0];
s[1035] = + g19[ix+0]*g100[iy+0]*g8[iz+0];
s[1036] = + g18[ix+0]*g101[iy+0]*g8[iz+0];
s[1037] = + g18[ix+0]*g100[iy+0]*g9[iz+0];
s[1038] = + g17[ix+0]*g102[iy+0]*g8[iz+0];
s[1039] = + g16[ix+0]*g103[iy+0]*g8[iz+0];
s[1040] = + g16[ix+0]*g102[iy+0]*g9[iz+0];
s[1041] = + g17[ix+0]*g100[iy+0]*g10[iz+0];
s[1042] = + g16[ix+0]*g101[iy+0]*g10[iz+0];
s[1043] = + g16[ix+0]*g100[iy+0]*g11[iz+0];
s[1044] = + g19[ix+0]*g96[iy+0]*g12[iz+0];
s[1045] = + g18[ix+0]*g97[iy+0]*g12[iz+0];
s[1046] = + g18[ix+0]*g96[iy+0]*g13[iz+0];
s[1047] = + g17[ix+0]*g98[iy+0]*g12[iz+0];
s[1048] = + g16[ix+0]*g99[iy+0]*g12[iz+0];
s[1049] = + g16[ix+0]*g98[iy+0]*g13[iz+0];
s[1050] = + g17[ix+0]*g96[iy+0]*g14[iz+0];
s[1051] = + g16[ix+0]*g97[iy+0]*g14[iz+0];
s[1052] = + g16[ix+0]*g96[iy+0]*g15[iz+0];
s[1053] = + g15[ix+0]*g112[iy+0]*g0[iz+0];
s[1054] = + g14[ix+0]*g113[iy+0]*g0[iz+0];
s[1055] = + g14[ix+0]*g112[iy+0]*g1[iz+0];
s[1056] = + g13[ix+0]*g114[iy+0]*g0[iz+0];
s[1057] = + g12[ix+0]*g115[iy+0]*g0[iz+0];
s[1058] = + g12[ix+0]*g114[iy+0]*g1[iz+0];
s[1059] = + g13[ix+0]*g112[iy+0]*g2[iz+0];
s[1060] = + g12[ix+0]*g113[iy+0]*g2[iz+0];
s[1061] = + g12[ix+0]*g112[iy+0]*g3[iz+0];
s[1062] = + g11[ix+0]*g116[iy+0]*g0[iz+0];
s[1063] = + g10[ix+0]*g117[iy+0]*g0[iz+0];
s[1064] = + g10[ix+0]*g116[iy+0]*g1[iz+0];
s[1065] = + g9[ix+0]*g118[iy+0]*g0[iz+0];
s[1066] = + g8[ix+0]*g119[iy+0]*g0[iz+0];
s[1067] = + g8[ix+0]*g118[iy+0]*g1[iz+0];
s[1068] = + g9[ix+0]*g116[iy+0]*g2[iz+0];
s[1069] = + g8[ix+0]*g117[iy+0]*g2[iz+0];
s[1070] = + g8[ix+0]*g116[iy+0]*g3[iz+0];
s[1071] = + g11[ix+0]*g112[iy+0]*g4[iz+0];
s[1072] = + g10[ix+0]*g113[iy+0]*g4[iz+0];
s[1073] = + g10[ix+0]*g112[iy+0]*g5[iz+0];
s[1074] = + g9[ix+0]*g114[iy+0]*g4[iz+0];
s[1075] = + g8[ix+0]*g115[iy+0]*g4[iz+0];
s[1076] = + g8[ix+0]*g114[iy+0]*g5[iz+0];
s[1077] = + g9[ix+0]*g112[iy+0]*g6[iz+0];
s[1078] = + g8[ix+0]*g113[iy+0]*g6[iz+0];
s[1079] = + g8[ix+0]*g112[iy+0]*g7[iz+0];
s[1080] = + g7[ix+0]*g120[iy+0]*g0[iz+0];
s[1081] = + g6[ix+0]*g121[iy+0]*g0[iz+0];
s[1082] = + g6[ix+0]*g120[iy+0]*g1[iz+0];
s[1083] = + g5[ix+0]*g122[iy+0]*g0[iz+0];
s[1084] = + g4[ix+0]*g123[iy+0]*g0[iz+0];
s[1085] = + g4[ix+0]*g122[iy+0]*g1[iz+0];
s[1086] = + g5[ix+0]*g120[iy+0]*g2[iz+0];
s[1087] = + g4[ix+0]*g121[iy+0]*g2[iz+0];
s[1088] = + g4[ix+0]*g120[iy+0]*g3[iz+0];
s[1089] = + g3[ix+0]*g124[iy+0]*g0[iz+0];
s[1090] = + g2[ix+0]*g125[iy+0]*g0[iz+0];
s[1091] = + g2[ix+0]*g124[iy+0]*g1[iz+0];
s[1092] = + g1[ix+0]*g126[iy+0]*g0[iz+0];
s[1093] = + g0[ix+0]*g127[iy+0]*g0[iz+0];
s[1094] = + g0[ix+0]*g126[iy+0]*g1[iz+0];
s[1095] = + g1[ix+0]*g124[iy+0]*g2[iz+0];
s[1096] = + g0[ix+0]*g125[iy+0]*g2[iz+0];
s[1097] = + g0[ix+0]*g124[iy+0]*g3[iz+0];
s[1098] = + g3[ix+0]*g120[iy+0]*g4[iz+0];
s[1099] = + g2[ix+0]*g121[iy+0]*g4[iz+0];
s[1100] = + g2[ix+0]*g120[iy+0]*g5[iz+0];
s[1101] = + g1[ix+0]*g122[iy+0]*g4[iz+0];
s[1102] = + g0[ix+0]*g123[iy+0]*g4[iz+0];
s[1103] = + g0[ix+0]*g122[iy+0]*g5[iz+0];
s[1104] = + g1[ix+0]*g120[iy+0]*g6[iz+0];
s[1105] = + g0[ix+0]*g121[iy+0]*g6[iz+0];
s[1106] = + g0[ix+0]*g120[iy+0]*g7[iz+0];
s[1107] = + g7[ix+0]*g112[iy+0]*g8[iz+0];
s[1108] = + g6[ix+0]*g113[iy+0]*g8[iz+0];
s[1109] = + g6[ix+0]*g112[iy+0]*g9[iz+0];
s[1110] = + g5[ix+0]*g114[iy+0]*g8[iz+0];
s[1111] = + g4[ix+0]*g115[iy+0]*g8[iz+0];
s[1112] = + g4[ix+0]*g114[iy+0]*g9[iz+0];
s[1113] = + g5[ix+0]*g112[iy+0]*g10[iz+0];
s[1114] = + g4[ix+0]*g113[iy+0]*g10[iz+0];
s[1115] = + g4[ix+0]*g112[iy+0]*g11[iz+0];
s[1116] = + g3[ix+0]*g116[iy+0]*g8[iz+0];
s[1117] = + g2[ix+0]*g117[iy+0]*g8[iz+0];
s[1118] = + g2[ix+0]*g116[iy+0]*g9[iz+0];
s[1119] = + g1[ix+0]*g118[iy+0]*g8[iz+0];
s[1120] = + g0[ix+0]*g119[iy+0]*g8[iz+0];
s[1121] = + g0[ix+0]*g118[iy+0]*g9[iz+0];
s[1122] = + g1[ix+0]*g116[iy+0]*g10[iz+0];
s[1123] = + g0[ix+0]*g117[iy+0]*g10[iz+0];
s[1124] = + g0[ix+0]*g116[iy+0]*g11[iz+0];
s[1125] = + g3[ix+0]*g112[iy+0]*g12[iz+0];
s[1126] = + g2[ix+0]*g113[iy+0]*g12[iz+0];
s[1127] = + g2[ix+0]*g112[iy+0]*g13[iz+0];
s[1128] = + g1[ix+0]*g114[iy+0]*g12[iz+0];
s[1129] = + g0[ix+0]*g115[iy+0]*g12[iz+0];
s[1130] = + g0[ix+0]*g114[iy+0]*g13[iz+0];
s[1131] = + g1[ix+0]*g112[iy+0]*g14[iz+0];
s[1132] = + g0[ix+0]*g113[iy+0]*g14[iz+0];
s[1133] = + g0[ix+0]*g112[iy+0]*g15[iz+0];
s[1134] = + g15[ix+0]*g96[iy+0]*g16[iz+0];
s[1135] = + g14[ix+0]*g97[iy+0]*g16[iz+0];
s[1136] = + g14[ix+0]*g96[iy+0]*g17[iz+0];
s[1137] = + g13[ix+0]*g98[iy+0]*g16[iz+0];
s[1138] = + g12[ix+0]*g99[iy+0]*g16[iz+0];
s[1139] = + g12[ix+0]*g98[iy+0]*g17[iz+0];
s[1140] = + g13[ix+0]*g96[iy+0]*g18[iz+0];
s[1141] = + g12[ix+0]*g97[iy+0]*g18[iz+0];
s[1142] = + g12[ix+0]*g96[iy+0]*g19[iz+0];
s[1143] = + g11[ix+0]*g100[iy+0]*g16[iz+0];
s[1144] = + g10[ix+0]*g101[iy+0]*g16[iz+0];
s[1145] = + g10[ix+0]*g100[iy+0]*g17[iz+0];
s[1146] = + g9[ix+0]*g102[iy+0]*g16[iz+0];
s[1147] = + g8[ix+0]*g103[iy+0]*g16[iz+0];
s[1148] = + g8[ix+0]*g102[iy+0]*g17[iz+0];
s[1149] = + g9[ix+0]*g100[iy+0]*g18[iz+0];
s[1150] = + g8[ix+0]*g101[iy+0]*g18[iz+0];
s[1151] = + g8[ix+0]*g100[iy+0]*g19[iz+0];
s[1152] = + g11[ix+0]*g96[iy+0]*g20[iz+0];
s[1153] = + g10[ix+0]*g97[iy+0]*g20[iz+0];
s[1154] = + g10[ix+0]*g96[iy+0]*g21[iz+0];
s[1155] = + g9[ix+0]*g98[iy+0]*g20[iz+0];
s[1156] = + g8[ix+0]*g99[iy+0]*g20[iz+0];
s[1157] = + g8[ix+0]*g98[iy+0]*g21[iz+0];
s[1158] = + g9[ix+0]*g96[iy+0]*g22[iz+0];
s[1159] = + g8[ix+0]*g97[iy+0]*g22[iz+0];
s[1160] = + g8[ix+0]*g96[iy+0]*g23[iz+0];
s[1161] = + g7[ix+0]*g104[iy+0]*g16[iz+0];
s[1162] = + g6[ix+0]*g105[iy+0]*g16[iz+0];
s[1163] = + g6[ix+0]*g104[iy+0]*g17[iz+0];
s[1164] = + g5[ix+0]*g106[iy+0]*g16[iz+0];
s[1165] = + g4[ix+0]*g107[iy+0]*g16[iz+0];
s[1166] = + g4[ix+0]*g106[iy+0]*g17[iz+0];
s[1167] = + g5[ix+0]*g104[iy+0]*g18[iz+0];
s[1168] = + g4[ix+0]*g105[iy+0]*g18[iz+0];
s[1169] = + g4[ix+0]*g104[iy+0]*g19[iz+0];
s[1170] = + g3[ix+0]*g108[iy+0]*g16[iz+0];
s[1171] = + g2[ix+0]*g109[iy+0]*g16[iz+0];
s[1172] = + g2[ix+0]*g108[iy+0]*g17[iz+0];
s[1173] = + g1[ix+0]*g110[iy+0]*g16[iz+0];
s[1174] = + g0[ix+0]*g111[iy+0]*g16[iz+0];
s[1175] = + g0[ix+0]*g110[iy+0]*g17[iz+0];
s[1176] = + g1[ix+0]*g108[iy+0]*g18[iz+0];
s[1177] = + g0[ix+0]*g109[iy+0]*g18[iz+0];
s[1178] = + g0[ix+0]*g108[iy+0]*g19[iz+0];
s[1179] = + g3[ix+0]*g104[iy+0]*g20[iz+0];
s[1180] = + g2[ix+0]*g105[iy+0]*g20[iz+0];
s[1181] = + g2[ix+0]*g104[iy+0]*g21[iz+0];
s[1182] = + g1[ix+0]*g106[iy+0]*g20[iz+0];
s[1183] = + g0[ix+0]*g107[iy+0]*g20[iz+0];
s[1184] = + g0[ix+0]*g106[iy+0]*g21[iz+0];
s[1185] = + g1[ix+0]*g104[iy+0]*g22[iz+0];
s[1186] = + g0[ix+0]*g105[iy+0]*g22[iz+0];
s[1187] = + g0[ix+0]*g104[iy+0]*g23[iz+0];
s[1188] = + g7[ix+0]*g96[iy+0]*g24[iz+0];
s[1189] = + g6[ix+0]*g97[iy+0]*g24[iz+0];
s[1190] = + g6[ix+0]*g96[iy+0]*g25[iz+0];
s[1191] = + g5[ix+0]*g98[iy+0]*g24[iz+0];
s[1192] = + g4[ix+0]*g99[iy+0]*g24[iz+0];
s[1193] = + g4[ix+0]*g98[iy+0]*g25[iz+0];
s[1194] = + g5[ix+0]*g96[iy+0]*g26[iz+0];
s[1195] = + g4[ix+0]*g97[iy+0]*g26[iz+0];
s[1196] = + g4[ix+0]*g96[iy+0]*g27[iz+0];
s[1197] = + g3[ix+0]*g100[iy+0]*g24[iz+0];
s[1198] = + g2[ix+0]*g101[iy+0]*g24[iz+0];
s[1199] = + g2[ix+0]*g100[iy+0]*g25[iz+0];
s[1200] = + g1[ix+0]*g102[iy+0]*g24[iz+0];
s[1201] = + g0[ix+0]*g103[iy+0]*g24[iz+0];
s[1202] = + g0[ix+0]*g102[iy+0]*g25[iz+0];
s[1203] = + g1[ix+0]*g100[iy+0]*g26[iz+0];
s[1204] = + g0[ix+0]*g101[iy+0]*g26[iz+0];
s[1205] = + g0[ix+0]*g100[iy+0]*g27[iz+0];
s[1206] = + g3[ix+0]*g96[iy+0]*g28[iz+0];
s[1207] = + g2[ix+0]*g97[iy+0]*g28[iz+0];
s[1208] = + g2[ix+0]*g96[iy+0]*g29[iz+0];
s[1209] = + g1[ix+0]*g98[iy+0]*g28[iz+0];
s[1210] = + g0[ix+0]*g99[iy+0]*g28[iz+0];
s[1211] = + g0[ix+0]*g98[iy+0]*g29[iz+0];
s[1212] = + g1[ix+0]*g96[iy+0]*g30[iz+0];
s[1213] = + g0[ix+0]*g97[iy+0]*g30[iz+0];
s[1214] = + g0[ix+0]*g96[iy+0]*g31[iz+0];
s[1215] = + g31[ix+0]*g64[iy+0]*g32[iz+0];
s[1216] = + g30[ix+0]*g65[iy+0]*g32[iz+0];
s[1217] = + g30[ix+0]*g64[iy+0]*g33[iz+0];
s[1218] = + g29[ix+0]*g66[iy+0]*g32[iz+0];
s[1219] = + g28[ix+0]*g67[iy+0]*g32[iz+0];
s[1220] = + g28[ix+0]*g66[iy+0]*g33[iz+0];
s[1221] = + g29[ix+0]*g64[iy+0]*g34[iz+0];
s[1222] = + g28[ix+0]*g65[iy+0]*g34[iz+0];
s[1223] = + g28[ix+0]*g64[iy+0]*g35[iz+0];
s[1224] = + g27[ix+0]*g68[iy+0]*g32[iz+0];
s[1225] = + g26[ix+0]*g69[iy+0]*g32[iz+0];
s[1226] = + g26[ix+0]*g68[iy+0]*g33[iz+0];
s[1227] = + g25[ix+0]*g70[iy+0]*g32[iz+0];
s[1228] = + g24[ix+0]*g71[iy+0]*g32[iz+0];
s[1229] = + g24[ix+0]*g70[iy+0]*g33[iz+0];
s[1230] = + g25[ix+0]*g68[iy+0]*g34[iz+0];
s[1231] = + g24[ix+0]*g69[iy+0]*g34[iz+0];
s[1232] = + g24[ix+0]*g68[iy+0]*g35[iz+0];
s[1233] = + g27[ix+0]*g64[iy+0]*g36[iz+0];
s[1234] = + g26[ix+0]*g65[iy+0]*g36[iz+0];
s[1235] = + g26[ix+0]*g64[iy+0]*g37[iz+0];
s[1236] = + g25[ix+0]*g66[iy+0]*g36[iz+0];
s[1237] = + g24[ix+0]*g67[iy+0]*g36[iz+0];
s[1238] = + g24[ix+0]*g66[iy+0]*g37[iz+0];
s[1239] = + g25[ix+0]*g64[iy+0]*g38[iz+0];
s[1240] = + g24[ix+0]*g65[iy+0]*g38[iz+0];
s[1241] = + g24[ix+0]*g64[iy+0]*g39[iz+0];
s[1242] = + g23[ix+0]*g72[iy+0]*g32[iz+0];
s[1243] = + g22[ix+0]*g73[iy+0]*g32[iz+0];
s[1244] = + g22[ix+0]*g72[iy+0]*g33[iz+0];
s[1245] = + g21[ix+0]*g74[iy+0]*g32[iz+0];
s[1246] = + g20[ix+0]*g75[iy+0]*g32[iz+0];
s[1247] = + g20[ix+0]*g74[iy+0]*g33[iz+0];
s[1248] = + g21[ix+0]*g72[iy+0]*g34[iz+0];
s[1249] = + g20[ix+0]*g73[iy+0]*g34[iz+0];
s[1250] = + g20[ix+0]*g72[iy+0]*g35[iz+0];
s[1251] = + g19[ix+0]*g76[iy+0]*g32[iz+0];
s[1252] = + g18[ix+0]*g77[iy+0]*g32[iz+0];
s[1253] = + g18[ix+0]*g76[iy+0]*g33[iz+0];
s[1254] = + g17[ix+0]*g78[iy+0]*g32[iz+0];
s[1255] = + g16[ix+0]*g79[iy+0]*g32[iz+0];
s[1256] = + g16[ix+0]*g78[iy+0]*g33[iz+0];
s[1257] = + g17[ix+0]*g76[iy+0]*g34[iz+0];
s[1258] = + g16[ix+0]*g77[iy+0]*g34[iz+0];
s[1259] = + g16[ix+0]*g76[iy+0]*g35[iz+0];
s[1260] = + g19[ix+0]*g72[iy+0]*g36[iz+0];
s[1261] = + g18[ix+0]*g73[iy+0]*g36[iz+0];
s[1262] = + g18[ix+0]*g72[iy+0]*g37[iz+0];
s[1263] = + g17[ix+0]*g74[iy+0]*g36[iz+0];
s[1264] = + g16[ix+0]*g75[iy+0]*g36[iz+0];
s[1265] = + g16[ix+0]*g74[iy+0]*g37[iz+0];
s[1266] = + g17[ix+0]*g72[iy+0]*g38[iz+0];
s[1267] = + g16[ix+0]*g73[iy+0]*g38[iz+0];
s[1268] = + g16[ix+0]*g72[iy+0]*g39[iz+0];
s[1269] = + g23[ix+0]*g64[iy+0]*g40[iz+0];
s[1270] = + g22[ix+0]*g65[iy+0]*g40[iz+0];
s[1271] = + g22[ix+0]*g64[iy+0]*g41[iz+0];
s[1272] = + g21[ix+0]*g66[iy+0]*g40[iz+0];
s[1273] = + g20[ix+0]*g67[iy+0]*g40[iz+0];
s[1274] = + g20[ix+0]*g66[iy+0]*g41[iz+0];
s[1275] = + g21[ix+0]*g64[iy+0]*g42[iz+0];
s[1276] = + g20[ix+0]*g65[iy+0]*g42[iz+0];
s[1277] = + g20[ix+0]*g64[iy+0]*g43[iz+0];
s[1278] = + g19[ix+0]*g68[iy+0]*g40[iz+0];
s[1279] = + g18[ix+0]*g69[iy+0]*g40[iz+0];
s[1280] = + g18[ix+0]*g68[iy+0]*g41[iz+0];
s[1281] = + g17[ix+0]*g70[iy+0]*g40[iz+0];
s[1282] = + g16[ix+0]*g71[iy+0]*g40[iz+0];
s[1283] = + g16[ix+0]*g70[iy+0]*g41[iz+0];
s[1284] = + g17[ix+0]*g68[iy+0]*g42[iz+0];
s[1285] = + g16[ix+0]*g69[iy+0]*g42[iz+0];
s[1286] = + g16[ix+0]*g68[iy+0]*g43[iz+0];
s[1287] = + g19[ix+0]*g64[iy+0]*g44[iz+0];
s[1288] = + g18[ix+0]*g65[iy+0]*g44[iz+0];
s[1289] = + g18[ix+0]*g64[iy+0]*g45[iz+0];
s[1290] = + g17[ix+0]*g66[iy+0]*g44[iz+0];
s[1291] = + g16[ix+0]*g67[iy+0]*g44[iz+0];
s[1292] = + g16[ix+0]*g66[iy+0]*g45[iz+0];
s[1293] = + g17[ix+0]*g64[iy+0]*g46[iz+0];
s[1294] = + g16[ix+0]*g65[iy+0]*g46[iz+0];
s[1295] = + g16[ix+0]*g64[iy+0]*g47[iz+0];
s[1296] = + g15[ix+0]*g80[iy+0]*g32[iz+0];
s[1297] = + g14[ix+0]*g81[iy+0]*g32[iz+0];
s[1298] = + g14[ix+0]*g80[iy+0]*g33[iz+0];
s[1299] = + g13[ix+0]*g82[iy+0]*g32[iz+0];
s[1300] = + g12[ix+0]*g83[iy+0]*g32[iz+0];
s[1301] = + g12[ix+0]*g82[iy+0]*g33[iz+0];
s[1302] = + g13[ix+0]*g80[iy+0]*g34[iz+0];
s[1303] = + g12[ix+0]*g81[iy+0]*g34[iz+0];
s[1304] = + g12[ix+0]*g80[iy+0]*g35[iz+0];
s[1305] = + g11[ix+0]*g84[iy+0]*g32[iz+0];
s[1306] = + g10[ix+0]*g85[iy+0]*g32[iz+0];
s[1307] = + g10[ix+0]*g84[iy+0]*g33[iz+0];
s[1308] = + g9[ix+0]*g86[iy+0]*g32[iz+0];
s[1309] = + g8[ix+0]*g87[iy+0]*g32[iz+0];
s[1310] = + g8[ix+0]*g86[iy+0]*g33[iz+0];
s[1311] = + g9[ix+0]*g84[iy+0]*g34[iz+0];
s[1312] = + g8[ix+0]*g85[iy+0]*g34[iz+0];
s[1313] = + g8[ix+0]*g84[iy+0]*g35[iz+0];
s[1314] = + g11[ix+0]*g80[iy+0]*g36[iz+0];
s[1315] = + g10[ix+0]*g81[iy+0]*g36[iz+0];
s[1316] = + g10[ix+0]*g80[iy+0]*g37[iz+0];
s[1317] = + g9[ix+0]*g82[iy+0]*g36[iz+0];
s[1318] = + g8[ix+0]*g83[iy+0]*g36[iz+0];
s[1319] = + g8[ix+0]*g82[iy+0]*g37[iz+0];
s[1320] = + g9[ix+0]*g80[iy+0]*g38[iz+0];
s[1321] = + g8[ix+0]*g81[iy+0]*g38[iz+0];
s[1322] = + g8[ix+0]*g80[iy+0]*g39[iz+0];
s[1323] = + g7[ix+0]*g88[iy+0]*g32[iz+0];
s[1324] = + g6[ix+0]*g89[iy+0]*g32[iz+0];
s[1325] = + g6[ix+0]*g88[iy+0]*g33[iz+0];
s[1326] = + g5[ix+0]*g90[iy+0]*g32[iz+0];
s[1327] = + g4[ix+0]*g91[iy+0]*g32[iz+0];
s[1328] = + g4[ix+0]*g90[iy+0]*g33[iz+0];
s[1329] = + g5[ix+0]*g88[iy+0]*g34[iz+0];
s[1330] = + g4[ix+0]*g89[iy+0]*g34[iz+0];
s[1331] = + g4[ix+0]*g88[iy+0]*g35[iz+0];
s[1332] = + g3[ix+0]*g92[iy+0]*g32[iz+0];
s[1333] = + g2[ix+0]*g93[iy+0]*g32[iz+0];
s[1334] = + g2[ix+0]*g92[iy+0]*g33[iz+0];
s[1335] = + g1[ix+0]*g94[iy+0]*g32[iz+0];
s[1336] = + g0[ix+0]*g95[iy+0]*g32[iz+0];
s[1337] = + g0[ix+0]*g94[iy+0]*g33[iz+0];
s[1338] = + g1[ix+0]*g92[iy+0]*g34[iz+0];
s[1339] = + g0[ix+0]*g93[iy+0]*g34[iz+0];
s[1340] = + g0[ix+0]*g92[iy+0]*g35[iz+0];
s[1341] = + g3[ix+0]*g88[iy+0]*g36[iz+0];
s[1342] = + g2[ix+0]*g89[iy+0]*g36[iz+0];
s[1343] = + g2[ix+0]*g88[iy+0]*g37[iz+0];
s[1344] = + g1[ix+0]*g90[iy+0]*g36[iz+0];
s[1345] = + g0[ix+0]*g91[iy+0]*g36[iz+0];
s[1346] = + g0[ix+0]*g90[iy+0]*g37[iz+0];
s[1347] = + g1[ix+0]*g88[iy+0]*g38[iz+0];
s[1348] = + g0[ix+0]*g89[iy+0]*g38[iz+0];
s[1349] = + g0[ix+0]*g88[iy+0]*g39[iz+0];
s[1350] = + g7[ix+0]*g80[iy+0]*g40[iz+0];
s[1351] = + g6[ix+0]*g81[iy+0]*g40[iz+0];
s[1352] = + g6[ix+0]*g80[iy+0]*g41[iz+0];
s[1353] = + g5[ix+0]*g82[iy+0]*g40[iz+0];
s[1354] = + g4[ix+0]*g83[iy+0]*g40[iz+0];
s[1355] = + g4[ix+0]*g82[iy+0]*g41[iz+0];
s[1356] = + g5[ix+0]*g80[iy+0]*g42[iz+0];
s[1357] = + g4[ix+0]*g81[iy+0]*g42[iz+0];
s[1358] = + g4[ix+0]*g80[iy+0]*g43[iz+0];
s[1359] = + g3[ix+0]*g84[iy+0]*g40[iz+0];
s[1360] = + g2[ix+0]*g85[iy+0]*g40[iz+0];
s[1361] = + g2[ix+0]*g84[iy+0]*g41[iz+0];
s[1362] = + g1[ix+0]*g86[iy+0]*g40[iz+0];
s[1363] = + g0[ix+0]*g87[iy+0]*g40[iz+0];
s[1364] = + g0[ix+0]*g86[iy+0]*g41[iz+0];
s[1365] = + g1[ix+0]*g84[iy+0]*g42[iz+0];
s[1366] = + g0[ix+0]*g85[iy+0]*g42[iz+0];
s[1367] = + g0[ix+0]*g84[iy+0]*g43[iz+0];
s[1368] = + g3[ix+0]*g80[iy+0]*g44[iz+0];
s[1369] = + g2[ix+0]*g81[iy+0]*g44[iz+0];
s[1370] = + g2[ix+0]*g80[iy+0]*g45[iz+0];
s[1371] = + g1[ix+0]*g82[iy+0]*g44[iz+0];
s[1372] = + g0[ix+0]*g83[iy+0]*g44[iz+0];
s[1373] = + g0[ix+0]*g82[iy+0]*g45[iz+0];
s[1374] = + g1[ix+0]*g80[iy+0]*g46[iz+0];
s[1375] = + g0[ix+0]*g81[iy+0]*g46[iz+0];
s[1376] = + g0[ix+0]*g80[iy+0]*g47[iz+0];
s[1377] = + g15[ix+0]*g64[iy+0]*g48[iz+0];
s[1378] = + g14[ix+0]*g65[iy+0]*g48[iz+0];
s[1379] = + g14[ix+0]*g64[iy+0]*g49[iz+0];
s[1380] = + g13[ix+0]*g66[iy+0]*g48[iz+0];
s[1381] = + g12[ix+0]*g67[iy+0]*g48[iz+0];
s[1382] = + g12[ix+0]*g66[iy+0]*g49[iz+0];
s[1383] = + g13[ix+0]*g64[iy+0]*g50[iz+0];
s[1384] = + g12[ix+0]*g65[iy+0]*g50[iz+0];
s[1385] = + g12[ix+0]*g64[iy+0]*g51[iz+0];
s[1386] = + g11[ix+0]*g68[iy+0]*g48[iz+0];
s[1387] = + g10[ix+0]*g69[iy+0]*g48[iz+0];
s[1388] = + g10[ix+0]*g68[iy+0]*g49[iz+0];
s[1389] = + g9[ix+0]*g70[iy+0]*g48[iz+0];
s[1390] = + g8[ix+0]*g71[iy+0]*g48[iz+0];
s[1391] = + g8[ix+0]*g70[iy+0]*g49[iz+0];
s[1392] = + g9[ix+0]*g68[iy+0]*g50[iz+0];
s[1393] = + g8[ix+0]*g69[iy+0]*g50[iz+0];
s[1394] = + g8[ix+0]*g68[iy+0]*g51[iz+0];
s[1395] = + g11[ix+0]*g64[iy+0]*g52[iz+0];
s[1396] = + g10[ix+0]*g65[iy+0]*g52[iz+0];
s[1397] = + g10[ix+0]*g64[iy+0]*g53[iz+0];
s[1398] = + g9[ix+0]*g66[iy+0]*g52[iz+0];
s[1399] = + g8[ix+0]*g67[iy+0]*g52[iz+0];
s[1400] = + g8[ix+0]*g66[iy+0]*g53[iz+0];
s[1401] = + g9[ix+0]*g64[iy+0]*g54[iz+0];
s[1402] = + g8[ix+0]*g65[iy+0]*g54[iz+0];
s[1403] = + g8[ix+0]*g64[iy+0]*g55[iz+0];
s[1404] = + g7[ix+0]*g72[iy+0]*g48[iz+0];
s[1405] = + g6[ix+0]*g73[iy+0]*g48[iz+0];
s[1406] = + g6[ix+0]*g72[iy+0]*g49[iz+0];
s[1407] = + g5[ix+0]*g74[iy+0]*g48[iz+0];
s[1408] = + g4[ix+0]*g75[iy+0]*g48[iz+0];
s[1409] = + g4[ix+0]*g74[iy+0]*g49[iz+0];
s[1410] = + g5[ix+0]*g72[iy+0]*g50[iz+0];
s[1411] = + g4[ix+0]*g73[iy+0]*g50[iz+0];
s[1412] = + g4[ix+0]*g72[iy+0]*g51[iz+0];
s[1413] = + g3[ix+0]*g76[iy+0]*g48[iz+0];
s[1414] = + g2[ix+0]*g77[iy+0]*g48[iz+0];
s[1415] = + g2[ix+0]*g76[iy+0]*g49[iz+0];
s[1416] = + g1[ix+0]*g78[iy+0]*g48[iz+0];
s[1417] = + g0[ix+0]*g79[iy+0]*g48[iz+0];
s[1418] = + g0[ix+0]*g78[iy+0]*g49[iz+0];
s[1419] = + g1[ix+0]*g76[iy+0]*g50[iz+0];
s[1420] = + g0[ix+0]*g77[iy+0]*g50[iz+0];
s[1421] = + g0[ix+0]*g76[iy+0]*g51[iz+0];
s[1422] = + g3[ix+0]*g72[iy+0]*g52[iz+0];
s[1423] = + g2[ix+0]*g73[iy+0]*g52[iz+0];
s[1424] = + g2[ix+0]*g72[iy+0]*g53[iz+0];
s[1425] = + g1[ix+0]*g74[iy+0]*g52[iz+0];
s[1426] = + g0[ix+0]*g75[iy+0]*g52[iz+0];
s[1427] = + g0[ix+0]*g74[iy+0]*g53[iz+0];
s[1428] = + g1[ix+0]*g72[iy+0]*g54[iz+0];
s[1429] = + g0[ix+0]*g73[iy+0]*g54[iz+0];
s[1430] = + g0[ix+0]*g72[iy+0]*g55[iz+0];
s[1431] = + g7[ix+0]*g64[iy+0]*g56[iz+0];
s[1432] = + g6[ix+0]*g65[iy+0]*g56[iz+0];
s[1433] = + g6[ix+0]*g64[iy+0]*g57[iz+0];
s[1434] = + g5[ix+0]*g66[iy+0]*g56[iz+0];
s[1435] = + g4[ix+0]*g67[iy+0]*g56[iz+0];
s[1436] = + g4[ix+0]*g66[iy+0]*g57[iz+0];
s[1437] = + g5[ix+0]*g64[iy+0]*g58[iz+0];
s[1438] = + g4[ix+0]*g65[iy+0]*g58[iz+0];
s[1439] = + g4[ix+0]*g64[iy+0]*g59[iz+0];
s[1440] = + g3[ix+0]*g68[iy+0]*g56[iz+0];
s[1441] = + g2[ix+0]*g69[iy+0]*g56[iz+0];
s[1442] = + g2[ix+0]*g68[iy+0]*g57[iz+0];
s[1443] = + g1[ix+0]*g70[iy+0]*g56[iz+0];
s[1444] = + g0[ix+0]*g71[iy+0]*g56[iz+0];
s[1445] = + g0[ix+0]*g70[iy+0]*g57[iz+0];
s[1446] = + g1[ix+0]*g68[iy+0]*g58[iz+0];
s[1447] = + g0[ix+0]*g69[iy+0]*g58[iz+0];
s[1448] = + g0[ix+0]*g68[iy+0]*g59[iz+0];
s[1449] = + g3[ix+0]*g64[iy+0]*g60[iz+0];
s[1450] = + g2[ix+0]*g65[iy+0]*g60[iz+0];
s[1451] = + g2[ix+0]*g64[iy+0]*g61[iz+0];
s[1452] = + g1[ix+0]*g66[iy+0]*g60[iz+0];
s[1453] = + g0[ix+0]*g67[iy+0]*g60[iz+0];
s[1454] = + g0[ix+0]*g66[iy+0]*g61[iz+0];
s[1455] = + g1[ix+0]*g64[iy+0]*g62[iz+0];
s[1456] = + g0[ix+0]*g65[iy+0]*g62[iz+0];
s[1457] = + g0[ix+0]*g64[iy+0]*g63[iz+0];
s[1458] = + g63[ix+0]*g0[iy+0]*g64[iz+0];
s[1459] = + g62[ix+0]*g1[iy+0]*g64[iz+0];
s[1460] = + g62[ix+0]*g0[iy+0]*g65[iz+0];
s[1461] = + g61[ix+0]*g2[iy+0]*g64[iz+0];
s[1462] = + g60[ix+0]*g3[iy+0]*g64[iz+0];
s[1463] = + g60[ix+0]*g2[iy+0]*g65[iz+0];
s[1464] = + g61[ix+0]*g0[iy+0]*g66[iz+0];
s[1465] = + g60[ix+0]*g1[iy+0]*g66[iz+0];
s[1466] = + g60[ix+0]*g0[iy+0]*g67[iz+0];
s[1467] = + g59[ix+0]*g4[iy+0]*g64[iz+0];
s[1468] = + g58[ix+0]*g5[iy+0]*g64[iz+0];
s[1469] = + g58[ix+0]*g4[iy+0]*g65[iz+0];
s[1470] = + g57[ix+0]*g6[iy+0]*g64[iz+0];
s[1471] = + g56[ix+0]*g7[iy+0]*g64[iz+0];
s[1472] = + g56[ix+0]*g6[iy+0]*g65[iz+0];
s[1473] = + g57[ix+0]*g4[iy+0]*g66[iz+0];
s[1474] = + g56[ix+0]*g5[iy+0]*g66[iz+0];
s[1475] = + g56[ix+0]*g4[iy+0]*g67[iz+0];
s[1476] = + g59[ix+0]*g0[iy+0]*g68[iz+0];
s[1477] = + g58[ix+0]*g1[iy+0]*g68[iz+0];
s[1478] = + g58[ix+0]*g0[iy+0]*g69[iz+0];
s[1479] = + g57[ix+0]*g2[iy+0]*g68[iz+0];
s[1480] = + g56[ix+0]*g3[iy+0]*g68[iz+0];
s[1481] = + g56[ix+0]*g2[iy+0]*g69[iz+0];
s[1482] = + g57[ix+0]*g0[iy+0]*g70[iz+0];
s[1483] = + g56[ix+0]*g1[iy+0]*g70[iz+0];
s[1484] = + g56[ix+0]*g0[iy+0]*g71[iz+0];
s[1485] = + g55[ix+0]*g8[iy+0]*g64[iz+0];
s[1486] = + g54[ix+0]*g9[iy+0]*g64[iz+0];
s[1487] = + g54[ix+0]*g8[iy+0]*g65[iz+0];
s[1488] = + g53[ix+0]*g10[iy+0]*g64[iz+0];
s[1489] = + g52[ix+0]*g11[iy+0]*g64[iz+0];
s[1490] = + g52[ix+0]*g10[iy+0]*g65[iz+0];
s[1491] = + g53[ix+0]*g8[iy+0]*g66[iz+0];
s[1492] = + g52[ix+0]*g9[iy+0]*g66[iz+0];
s[1493] = + g52[ix+0]*g8[iy+0]*g67[iz+0];
s[1494] = + g51[ix+0]*g12[iy+0]*g64[iz+0];
s[1495] = + g50[ix+0]*g13[iy+0]*g64[iz+0];
s[1496] = + g50[ix+0]*g12[iy+0]*g65[iz+0];
s[1497] = + g49[ix+0]*g14[iy+0]*g64[iz+0];
s[1498] = + g48[ix+0]*g15[iy+0]*g64[iz+0];
s[1499] = + g48[ix+0]*g14[iy+0]*g65[iz+0];
s[1500] = + g49[ix+0]*g12[iy+0]*g66[iz+0];
s[1501] = + g48[ix+0]*g13[iy+0]*g66[iz+0];
s[1502] = + g48[ix+0]*g12[iy+0]*g67[iz+0];
s[1503] = + g51[ix+0]*g8[iy+0]*g68[iz+0];
s[1504] = + g50[ix+0]*g9[iy+0]*g68[iz+0];
s[1505] = + g50[ix+0]*g8[iy+0]*g69[iz+0];
s[1506] = + g49[ix+0]*g10[iy+0]*g68[iz+0];
s[1507] = + g48[ix+0]*g11[iy+0]*g68[iz+0];
s[1508] = + g48[ix+0]*g10[iy+0]*g69[iz+0];
s[1509] = + g49[ix+0]*g8[iy+0]*g70[iz+0];
s[1510] = + g48[ix+0]*g9[iy+0]*g70[iz+0];
s[1511] = + g48[ix+0]*g8[iy+0]*g71[iz+0];
s[1512] = + g55[ix+0]*g0[iy+0]*g72[iz+0];
s[1513] = + g54[ix+0]*g1[iy+0]*g72[iz+0];
s[1514] = + g54[ix+0]*g0[iy+0]*g73[iz+0];
s[1515] = + g53[ix+0]*g2[iy+0]*g72[iz+0];
s[1516] = + g52[ix+0]*g3[iy+0]*g72[iz+0];
s[1517] = + g52[ix+0]*g2[iy+0]*g73[iz+0];
s[1518] = + g53[ix+0]*g0[iy+0]*g74[iz+0];
s[1519] = + g52[ix+0]*g1[iy+0]*g74[iz+0];
s[1520] = + g52[ix+0]*g0[iy+0]*g75[iz+0];
s[1521] = + g51[ix+0]*g4[iy+0]*g72[iz+0];
s[1522] = + g50[ix+0]*g5[iy+0]*g72[iz+0];
s[1523] = + g50[ix+0]*g4[iy+0]*g73[iz+0];
s[1524] = + g49[ix+0]*g6[iy+0]*g72[iz+0];
s[1525] = + g48[ix+0]*g7[iy+0]*g72[iz+0];
s[1526] = + g48[ix+0]*g6[iy+0]*g73[iz+0];
s[1527] = + g49[ix+0]*g4[iy+0]*g74[iz+0];
s[1528] = + g48[ix+0]*g5[iy+0]*g74[iz+0];
s[1529] = + g48[ix+0]*g4[iy+0]*g75[iz+0];
s[1530] = + g51[ix+0]*g0[iy+0]*g76[iz+0];
s[1531] = + g50[ix+0]*g1[iy+0]*g76[iz+0];
s[1532] = + g50[ix+0]*g0[iy+0]*g77[iz+0];
s[1533] = + g49[ix+0]*g2[iy+0]*g76[iz+0];
s[1534] = + g48[ix+0]*g3[iy+0]*g76[iz+0];
s[1535] = + g48[ix+0]*g2[iy+0]*g77[iz+0];
s[1536] = + g49[ix+0]*g0[iy+0]*g78[iz+0];
s[1537] = + g48[ix+0]*g1[iy+0]*g78[iz+0];
s[1538] = + g48[ix+0]*g0[iy+0]*g79[iz+0];
s[1539] = + g47[ix+0]*g16[iy+0]*g64[iz+0];
s[1540] = + g46[ix+0]*g17[iy+0]*g64[iz+0];
s[1541] = + g46[ix+0]*g16[iy+0]*g65[iz+0];
s[1542] = + g45[ix+0]*g18[iy+0]*g64[iz+0];
s[1543] = + g44[ix+0]*g19[iy+0]*g64[iz+0];
s[1544] = + g44[ix+0]*g18[iy+0]*g65[iz+0];
s[1545] = + g45[ix+0]*g16[iy+0]*g66[iz+0];
s[1546] = + g44[ix+0]*g17[iy+0]*g66[iz+0];
s[1547] = + g44[ix+0]*g16[iy+0]*g67[iz+0];
s[1548] = + g43[ix+0]*g20[iy+0]*g64[iz+0];
s[1549] = + g42[ix+0]*g21[iy+0]*g64[iz+0];
s[1550] = + g42[ix+0]*g20[iy+0]*g65[iz+0];
s[1551] = + g41[ix+0]*g22[iy+0]*g64[iz+0];
s[1552] = + g40[ix+0]*g23[iy+0]*g64[iz+0];
s[1553] = + g40[ix+0]*g22[iy+0]*g65[iz+0];
s[1554] = + g41[ix+0]*g20[iy+0]*g66[iz+0];
s[1555] = + g40[ix+0]*g21[iy+0]*g66[iz+0];
s[1556] = + g40[ix+0]*g20[iy+0]*g67[iz+0];
s[1557] = + g43[ix+0]*g16[iy+0]*g68[iz+0];
s[1558] = + g42[ix+0]*g17[iy+0]*g68[iz+0];
s[1559] = + g42[ix+0]*g16[iy+0]*g69[iz+0];
s[1560] = + g41[ix+0]*g18[iy+0]*g68[iz+0];
s[1561] = + g40[ix+0]*g19[iy+0]*g68[iz+0];
s[1562] = + g40[ix+0]*g18[iy+0]*g69[iz+0];
s[1563] = + g41[ix+0]*g16[iy+0]*g70[iz+0];
s[1564] = + g40[ix+0]*g17[iy+0]*g70[iz+0];
s[1565] = + g40[ix+0]*g16[iy+0]*g71[iz+0];
s[1566] = + g39[ix+0]*g24[iy+0]*g64[iz+0];
s[1567] = + g38[ix+0]*g25[iy+0]*g64[iz+0];
s[1568] = + g38[ix+0]*g24[iy+0]*g65[iz+0];
s[1569] = + g37[ix+0]*g26[iy+0]*g64[iz+0];
s[1570] = + g36[ix+0]*g27[iy+0]*g64[iz+0];
s[1571] = + g36[ix+0]*g26[iy+0]*g65[iz+0];
s[1572] = + g37[ix+0]*g24[iy+0]*g66[iz+0];
s[1573] = + g36[ix+0]*g25[iy+0]*g66[iz+0];
s[1574] = + g36[ix+0]*g24[iy+0]*g67[iz+0];
s[1575] = + g35[ix+0]*g28[iy+0]*g64[iz+0];
s[1576] = + g34[ix+0]*g29[iy+0]*g64[iz+0];
s[1577] = + g34[ix+0]*g28[iy+0]*g65[iz+0];
s[1578] = + g33[ix+0]*g30[iy+0]*g64[iz+0];
s[1579] = + g32[ix+0]*g31[iy+0]*g64[iz+0];
s[1580] = + g32[ix+0]*g30[iy+0]*g65[iz+0];
s[1581] = + g33[ix+0]*g28[iy+0]*g66[iz+0];
s[1582] = + g32[ix+0]*g29[iy+0]*g66[iz+0];
s[1583] = + g32[ix+0]*g28[iy+0]*g67[iz+0];
s[1584] = + g35[ix+0]*g24[iy+0]*g68[iz+0];
s[1585] = + g34[ix+0]*g25[iy+0]*g68[iz+0];
s[1586] = + g34[ix+0]*g24[iy+0]*g69[iz+0];
s[1587] = + g33[ix+0]*g26[iy+0]*g68[iz+0];
s[1588] = + g32[ix+0]*g27[iy+0]*g68[iz+0];
s[1589] = + g32[ix+0]*g26[iy+0]*g69[iz+0];
s[1590] = + g33[ix+0]*g24[iy+0]*g70[iz+0];
s[1591] = + g32[ix+0]*g25[iy+0]*g70[iz+0];
s[1592] = + g32[ix+0]*g24[iy+0]*g71[iz+0];
s[1593] = + g39[ix+0]*g16[iy+0]*g72[iz+0];
s[1594] = + g38[ix+0]*g17[iy+0]*g72[iz+0];
s[1595] = + g38[ix+0]*g16[iy+0]*g73[iz+0];
s[1596] = + g37[ix+0]*g18[iy+0]*g72[iz+0];
s[1597] = + g36[ix+0]*g19[iy+0]*g72[iz+0];
s[1598] = + g36[ix+0]*g18[iy+0]*g73[iz+0];
s[1599] = + g37[ix+0]*g16[iy+0]*g74[iz+0];
s[1600] = + g36[ix+0]*g17[iy+0]*g74[iz+0];
s[1601] = + g36[ix+0]*g16[iy+0]*g75[iz+0];
s[1602] = + g35[ix+0]*g20[iy+0]*g72[iz+0];
s[1603] = + g34[ix+0]*g21[iy+0]*g72[iz+0];
s[1604] = + g34[ix+0]*g20[iy+0]*g73[iz+0];
s[1605] = + g33[ix+0]*g22[iy+0]*g72[iz+0];
s[1606] = + g32[ix+0]*g23[iy+0]*g72[iz+0];
s[1607] = + g32[ix+0]*g22[iy+0]*g73[iz+0];
s[1608] = + g33[ix+0]*g20[iy+0]*g74[iz+0];
s[1609] = + g32[ix+0]*g21[iy+0]*g74[iz+0];
s[1610] = + g32[ix+0]*g20[iy+0]*g75[iz+0];
s[1611] = + g35[ix+0]*g16[iy+0]*g76[iz+0];
s[1612] = + g34[ix+0]*g17[iy+0]*g76[iz+0];
s[1613] = + g34[ix+0]*g16[iy+0]*g77[iz+0];
s[1614] = + g33[ix+0]*g18[iy+0]*g76[iz+0];
s[1615] = + g32[ix+0]*g19[iy+0]*g76[iz+0];
s[1616] = + g32[ix+0]*g18[iy+0]*g77[iz+0];
s[1617] = + g33[ix+0]*g16[iy+0]*g78[iz+0];
s[1618] = + g32[ix+0]*g17[iy+0]*g78[iz+0];
s[1619] = + g32[ix+0]*g16[iy+0]*g79[iz+0];
s[1620] = + g47[ix+0]*g0[iy+0]*g80[iz+0];
s[1621] = + g46[ix+0]*g1[iy+0]*g80[iz+0];
s[1622] = + g46[ix+0]*g0[iy+0]*g81[iz+0];
s[1623] = + g45[ix+0]*g2[iy+0]*g80[iz+0];
s[1624] = + g44[ix+0]*g3[iy+0]*g80[iz+0];
s[1625] = + g44[ix+0]*g2[iy+0]*g81[iz+0];
s[1626] = + g45[ix+0]*g0[iy+0]*g82[iz+0];
s[1627] = + g44[ix+0]*g1[iy+0]*g82[iz+0];
s[1628] = + g44[ix+0]*g0[iy+0]*g83[iz+0];
s[1629] = + g43[ix+0]*g4[iy+0]*g80[iz+0];
s[1630] = + g42[ix+0]*g5[iy+0]*g80[iz+0];
s[1631] = + g42[ix+0]*g4[iy+0]*g81[iz+0];
s[1632] = + g41[ix+0]*g6[iy+0]*g80[iz+0];
s[1633] = + g40[ix+0]*g7[iy+0]*g80[iz+0];
s[1634] = + g40[ix+0]*g6[iy+0]*g81[iz+0];
s[1635] = + g41[ix+0]*g4[iy+0]*g82[iz+0];
s[1636] = + g40[ix+0]*g5[iy+0]*g82[iz+0];
s[1637] = + g40[ix+0]*g4[iy+0]*g83[iz+0];
s[1638] = + g43[ix+0]*g0[iy+0]*g84[iz+0];
s[1639] = + g42[ix+0]*g1[iy+0]*g84[iz+0];
s[1640] = + g42[ix+0]*g0[iy+0]*g85[iz+0];
s[1641] = + g41[ix+0]*g2[iy+0]*g84[iz+0];
s[1642] = + g40[ix+0]*g3[iy+0]*g84[iz+0];
s[1643] = + g40[ix+0]*g2[iy+0]*g85[iz+0];
s[1644] = + g41[ix+0]*g0[iy+0]*g86[iz+0];
s[1645] = + g40[ix+0]*g1[iy+0]*g86[iz+0];
s[1646] = + g40[ix+0]*g0[iy+0]*g87[iz+0];
s[1647] = + g39[ix+0]*g8[iy+0]*g80[iz+0];
s[1648] = + g38[ix+0]*g9[iy+0]*g80[iz+0];
s[1649] = + g38[ix+0]*g8[iy+0]*g81[iz+0];
s[1650] = + g37[ix+0]*g10[iy+0]*g80[iz+0];
s[1651] = + g36[ix+0]*g11[iy+0]*g80[iz+0];
s[1652] = + g36[ix+0]*g10[iy+0]*g81[iz+0];
s[1653] = + g37[ix+0]*g8[iy+0]*g82[iz+0];
s[1654] = + g36[ix+0]*g9[iy+0]*g82[iz+0];
s[1655] = + g36[ix+0]*g8[iy+0]*g83[iz+0];
s[1656] = + g35[ix+0]*g12[iy+0]*g80[iz+0];
s[1657] = + g34[ix+0]*g13[iy+0]*g80[iz+0];
s[1658] = + g34[ix+0]*g12[iy+0]*g81[iz+0];
s[1659] = + g33[ix+0]*g14[iy+0]*g80[iz+0];
s[1660] = + g32[ix+0]*g15[iy+0]*g80[iz+0];
s[1661] = + g32[ix+0]*g14[iy+0]*g81[iz+0];
s[1662] = + g33[ix+0]*g12[iy+0]*g82[iz+0];
s[1663] = + g32[ix+0]*g13[iy+0]*g82[iz+0];
s[1664] = + g32[ix+0]*g12[iy+0]*g83[iz+0];
s[1665] = + g35[ix+0]*g8[iy+0]*g84[iz+0];
s[1666] = + g34[ix+0]*g9[iy+0]*g84[iz+0];
s[1667] = + g34[ix+0]*g8[iy+0]*g85[iz+0];
s[1668] = + g33[ix+0]*g10[iy+0]*g84[iz+0];
s[1669] = + g32[ix+0]*g11[iy+0]*g84[iz+0];
s[1670] = + g32[ix+0]*g10[iy+0]*g85[iz+0];
s[1671] = + g33[ix+0]*g8[iy+0]*g86[iz+0];
s[1672] = + g32[ix+0]*g9[iy+0]*g86[iz+0];
s[1673] = + g32[ix+0]*g8[iy+0]*g87[iz+0];
s[1674] = + g39[ix+0]*g0[iy+0]*g88[iz+0];
s[1675] = + g38[ix+0]*g1[iy+0]*g88[iz+0];
s[1676] = + g38[ix+0]*g0[iy+0]*g89[iz+0];
s[1677] = + g37[ix+0]*g2[iy+0]*g88[iz+0];
s[1678] = + g36[ix+0]*g3[iy+0]*g88[iz+0];
s[1679] = + g36[ix+0]*g2[iy+0]*g89[iz+0];
s[1680] = + g37[ix+0]*g0[iy+0]*g90[iz+0];
s[1681] = + g36[ix+0]*g1[iy+0]*g90[iz+0];
s[1682] = + g36[ix+0]*g0[iy+0]*g91[iz+0];
s[1683] = + g35[ix+0]*g4[iy+0]*g88[iz+0];
s[1684] = + g34[ix+0]*g5[iy+0]*g88[iz+0];
s[1685] = + g34[ix+0]*g4[iy+0]*g89[iz+0];
s[1686] = + g33[ix+0]*g6[iy+0]*g88[iz+0];
s[1687] = + g32[ix+0]*g7[iy+0]*g88[iz+0];
s[1688] = + g32[ix+0]*g6[iy+0]*g89[iz+0];
s[1689] = + g33[ix+0]*g4[iy+0]*g90[iz+0];
s[1690] = + g32[ix+0]*g5[iy+0]*g90[iz+0];
s[1691] = + g32[ix+0]*g4[iy+0]*g91[iz+0];
s[1692] = + g35[ix+0]*g0[iy+0]*g92[iz+0];
s[1693] = + g34[ix+0]*g1[iy+0]*g92[iz+0];
s[1694] = + g34[ix+0]*g0[iy+0]*g93[iz+0];
s[1695] = + g33[ix+0]*g2[iy+0]*g92[iz+0];
s[1696] = + g32[ix+0]*g3[iy+0]*g92[iz+0];
s[1697] = + g32[ix+0]*g2[iy+0]*g93[iz+0];
s[1698] = + g33[ix+0]*g0[iy+0]*g94[iz+0];
s[1699] = + g32[ix+0]*g1[iy+0]*g94[iz+0];
s[1700] = + g32[ix+0]*g0[iy+0]*g95[iz+0];
s[1701] = + g31[ix+0]*g32[iy+0]*g64[iz+0];
s[1702] = + g30[ix+0]*g33[iy+0]*g64[iz+0];
s[1703] = + g30[ix+0]*g32[iy+0]*g65[iz+0];
s[1704] = + g29[ix+0]*g34[iy+0]*g64[iz+0];
s[1705] = + g28[ix+0]*g35[iy+0]*g64[iz+0];
s[1706] = + g28[ix+0]*g34[iy+0]*g65[iz+0];
s[1707] = + g29[ix+0]*g32[iy+0]*g66[iz+0];
s[1708] = + g28[ix+0]*g33[iy+0]*g66[iz+0];
s[1709] = + g28[ix+0]*g32[iy+0]*g67[iz+0];
s[1710] = + g27[ix+0]*g36[iy+0]*g64[iz+0];
s[1711] = + g26[ix+0]*g37[iy+0]*g64[iz+0];
s[1712] = + g26[ix+0]*g36[iy+0]*g65[iz+0];
s[1713] = + g25[ix+0]*g38[iy+0]*g64[iz+0];
s[1714] = + g24[ix+0]*g39[iy+0]*g64[iz+0];
s[1715] = + g24[ix+0]*g38[iy+0]*g65[iz+0];
s[1716] = + g25[ix+0]*g36[iy+0]*g66[iz+0];
s[1717] = + g24[ix+0]*g37[iy+0]*g66[iz+0];
s[1718] = + g24[ix+0]*g36[iy+0]*g67[iz+0];
s[1719] = + g27[ix+0]*g32[iy+0]*g68[iz+0];
s[1720] = + g26[ix+0]*g33[iy+0]*g68[iz+0];
s[1721] = + g26[ix+0]*g32[iy+0]*g69[iz+0];
s[1722] = + g25[ix+0]*g34[iy+0]*g68[iz+0];
s[1723] = + g24[ix+0]*g35[iy+0]*g68[iz+0];
s[1724] = + g24[ix+0]*g34[iy+0]*g69[iz+0];
s[1725] = + g25[ix+0]*g32[iy+0]*g70[iz+0];
s[1726] = + g24[ix+0]*g33[iy+0]*g70[iz+0];
s[1727] = + g24[ix+0]*g32[iy+0]*g71[iz+0];
s[1728] = + g23[ix+0]*g40[iy+0]*g64[iz+0];
s[1729] = + g22[ix+0]*g41[iy+0]*g64[iz+0];
s[1730] = + g22[ix+0]*g40[iy+0]*g65[iz+0];
s[1731] = + g21[ix+0]*g42[iy+0]*g64[iz+0];
s[1732] = + g20[ix+0]*g43[iy+0]*g64[iz+0];
s[1733] = + g20[ix+0]*g42[iy+0]*g65[iz+0];
s[1734] = + g21[ix+0]*g40[iy+0]*g66[iz+0];
s[1735] = + g20[ix+0]*g41[iy+0]*g66[iz+0];
s[1736] = + g20[ix+0]*g40[iy+0]*g67[iz+0];
s[1737] = + g19[ix+0]*g44[iy+0]*g64[iz+0];
s[1738] = + g18[ix+0]*g45[iy+0]*g64[iz+0];
s[1739] = + g18[ix+0]*g44[iy+0]*g65[iz+0];
s[1740] = + g17[ix+0]*g46[iy+0]*g64[iz+0];
s[1741] = + g16[ix+0]*g47[iy+0]*g64[iz+0];
s[1742] = + g16[ix+0]*g46[iy+0]*g65[iz+0];
s[1743] = + g17[ix+0]*g44[iy+0]*g66[iz+0];
s[1744] = + g16[ix+0]*g45[iy+0]*g66[iz+0];
s[1745] = + g16[ix+0]*g44[iy+0]*g67[iz+0];
s[1746] = + g19[ix+0]*g40[iy+0]*g68[iz+0];
s[1747] = + g18[ix+0]*g41[iy+0]*g68[iz+0];
s[1748] = + g18[ix+0]*g40[iy+0]*g69[iz+0];
s[1749] = + g17[ix+0]*g42[iy+0]*g68[iz+0];
s[1750] = + g16[ix+0]*g43[iy+0]*g68[iz+0];
s[1751] = + g16[ix+0]*g42[iy+0]*g69[iz+0];
s[1752] = + g17[ix+0]*g40[iy+0]*g70[iz+0];
s[1753] = + g16[ix+0]*g41[iy+0]*g70[iz+0];
s[1754] = + g16[ix+0]*g40[iy+0]*g71[iz+0];
s[1755] = + g23[ix+0]*g32[iy+0]*g72[iz+0];
s[1756] = + g22[ix+0]*g33[iy+0]*g72[iz+0];
s[1757] = + g22[ix+0]*g32[iy+0]*g73[iz+0];
s[1758] = + g21[ix+0]*g34[iy+0]*g72[iz+0];
s[1759] = + g20[ix+0]*g35[iy+0]*g72[iz+0];
s[1760] = + g20[ix+0]*g34[iy+0]*g73[iz+0];
s[1761] = + g21[ix+0]*g32[iy+0]*g74[iz+0];
s[1762] = + g20[ix+0]*g33[iy+0]*g74[iz+0];
s[1763] = + g20[ix+0]*g32[iy+0]*g75[iz+0];
s[1764] = + g19[ix+0]*g36[iy+0]*g72[iz+0];
s[1765] = + g18[ix+0]*g37[iy+0]*g72[iz+0];
s[1766] = + g18[ix+0]*g36[iy+0]*g73[iz+0];
s[1767] = + g17[ix+0]*g38[iy+0]*g72[iz+0];
s[1768] = + g16[ix+0]*g39[iy+0]*g72[iz+0];
s[1769] = + g16[ix+0]*g38[iy+0]*g73[iz+0];
s[1770] = + g17[ix+0]*g36[iy+0]*g74[iz+0];
s[1771] = + g16[ix+0]*g37[iy+0]*g74[iz+0];
s[1772] = + g16[ix+0]*g36[iy+0]*g75[iz+0];
s[1773] = + g19[ix+0]*g32[iy+0]*g76[iz+0];
s[1774] = + g18[ix+0]*g33[iy+0]*g76[iz+0];
s[1775] = + g18[ix+0]*g32[iy+0]*g77[iz+0];
s[1776] = + g17[ix+0]*g34[iy+0]*g76[iz+0];
s[1777] = + g16[ix+0]*g35[iy+0]*g76[iz+0];
s[1778] = + g16[ix+0]*g34[iy+0]*g77[iz+0];
s[1779] = + g17[ix+0]*g32[iy+0]*g78[iz+0];
s[1780] = + g16[ix+0]*g33[iy+0]*g78[iz+0];
s[1781] = + g16[ix+0]*g32[iy+0]*g79[iz+0];
s[1782] = + g15[ix+0]*g48[iy+0]*g64[iz+0];
s[1783] = + g14[ix+0]*g49[iy+0]*g64[iz+0];
s[1784] = + g14[ix+0]*g48[iy+0]*g65[iz+0];
s[1785] = + g13[ix+0]*g50[iy+0]*g64[iz+0];
s[1786] = + g12[ix+0]*g51[iy+0]*g64[iz+0];
s[1787] = + g12[ix+0]*g50[iy+0]*g65[iz+0];
s[1788] = + g13[ix+0]*g48[iy+0]*g66[iz+0];
s[1789] = + g12[ix+0]*g49[iy+0]*g66[iz+0];
s[1790] = + g12[ix+0]*g48[iy+0]*g67[iz+0];
s[1791] = + g11[ix+0]*g52[iy+0]*g64[iz+0];
s[1792] = + g10[ix+0]*g53[iy+0]*g64[iz+0];
s[1793] = + g10[ix+0]*g52[iy+0]*g65[iz+0];
s[1794] = + g9[ix+0]*g54[iy+0]*g64[iz+0];
s[1795] = + g8[ix+0]*g55[iy+0]*g64[iz+0];
s[1796] = + g8[ix+0]*g54[iy+0]*g65[iz+0];
s[1797] = + g9[ix+0]*g52[iy+0]*g66[iz+0];
s[1798] = + g8[ix+0]*g53[iy+0]*g66[iz+0];
s[1799] = + g8[ix+0]*g52[iy+0]*g67[iz+0];
s[1800] = + g11[ix+0]*g48[iy+0]*g68[iz+0];
s[1801] = + g10[ix+0]*g49[iy+0]*g68[iz+0];
s[1802] = + g10[ix+0]*g48[iy+0]*g69[iz+0];
s[1803] = + g9[ix+0]*g50[iy+0]*g68[iz+0];
s[1804] = + g8[ix+0]*g51[iy+0]*g68[iz+0];
s[1805] = + g8[ix+0]*g50[iy+0]*g69[iz+0];
s[1806] = + g9[ix+0]*g48[iy+0]*g70[iz+0];
s[1807] = + g8[ix+0]*g49[iy+0]*g70[iz+0];
s[1808] = + g8[ix+0]*g48[iy+0]*g71[iz+0];
s[1809] = + g7[ix+0]*g56[iy+0]*g64[iz+0];
s[1810] = + g6[ix+0]*g57[iy+0]*g64[iz+0];
s[1811] = + g6[ix+0]*g56[iy+0]*g65[iz+0];
s[1812] = + g5[ix+0]*g58[iy+0]*g64[iz+0];
s[1813] = + g4[ix+0]*g59[iy+0]*g64[iz+0];
s[1814] = + g4[ix+0]*g58[iy+0]*g65[iz+0];
s[1815] = + g5[ix+0]*g56[iy+0]*g66[iz+0];
s[1816] = + g4[ix+0]*g57[iy+0]*g66[iz+0];
s[1817] = + g4[ix+0]*g56[iy+0]*g67[iz+0];
s[1818] = + g3[ix+0]*g60[iy+0]*g64[iz+0];
s[1819] = + g2[ix+0]*g61[iy+0]*g64[iz+0];
s[1820] = + g2[ix+0]*g60[iy+0]*g65[iz+0];
s[1821] = + g1[ix+0]*g62[iy+0]*g64[iz+0];
s[1822] = + g0[ix+0]*g63[iy+0]*g64[iz+0];
s[1823] = + g0[ix+0]*g62[iy+0]*g65[iz+0];
s[1824] = + g1[ix+0]*g60[iy+0]*g66[iz+0];
s[1825] = + g0[ix+0]*g61[iy+0]*g66[iz+0];
s[1826] = + g0[ix+0]*g60[iy+0]*g67[iz+0];
s[1827] = + g3[ix+0]*g56[iy+0]*g68[iz+0];
s[1828] = + g2[ix+0]*g57[iy+0]*g68[iz+0];
s[1829] = + g2[ix+0]*g56[iy+0]*g69[iz+0];
s[1830] = + g1[ix+0]*g58[iy+0]*g68[iz+0];
s[1831] = + g0[ix+0]*g59[iy+0]*g68[iz+0];
s[1832] = + g0[ix+0]*g58[iy+0]*g69[iz+0];
s[1833] = + g1[ix+0]*g56[iy+0]*g70[iz+0];
s[1834] = + g0[ix+0]*g57[iy+0]*g70[iz+0];
s[1835] = + g0[ix+0]*g56[iy+0]*g71[iz+0];
s[1836] = + g7[ix+0]*g48[iy+0]*g72[iz+0];
s[1837] = + g6[ix+0]*g49[iy+0]*g72[iz+0];
s[1838] = + g6[ix+0]*g48[iy+0]*g73[iz+0];
s[1839] = + g5[ix+0]*g50[iy+0]*g72[iz+0];
s[1840] = + g4[ix+0]*g51[iy+0]*g72[iz+0];
s[1841] = + g4[ix+0]*g50[iy+0]*g73[iz+0];
s[1842] = + g5[ix+0]*g48[iy+0]*g74[iz+0];
s[1843] = + g4[ix+0]*g49[iy+0]*g74[iz+0];
s[1844] = + g4[ix+0]*g48[iy+0]*g75[iz+0];
s[1845] = + g3[ix+0]*g52[iy+0]*g72[iz+0];
s[1846] = + g2[ix+0]*g53[iy+0]*g72[iz+0];
s[1847] = + g2[ix+0]*g52[iy+0]*g73[iz+0];
s[1848] = + g1[ix+0]*g54[iy+0]*g72[iz+0];
s[1849] = + g0[ix+0]*g55[iy+0]*g72[iz+0];
s[1850] = + g0[ix+0]*g54[iy+0]*g73[iz+0];
s[1851] = + g1[ix+0]*g52[iy+0]*g74[iz+0];
s[1852] = + g0[ix+0]*g53[iy+0]*g74[iz+0];
s[1853] = + g0[ix+0]*g52[iy+0]*g75[iz+0];
s[1854] = + g3[ix+0]*g48[iy+0]*g76[iz+0];
s[1855] = + g2[ix+0]*g49[iy+0]*g76[iz+0];
s[1856] = + g2[ix+0]*g48[iy+0]*g77[iz+0];
s[1857] = + g1[ix+0]*g50[iy+0]*g76[iz+0];
s[1858] = + g0[ix+0]*g51[iy+0]*g76[iz+0];
s[1859] = + g0[ix+0]*g50[iy+0]*g77[iz+0];
s[1860] = + g1[ix+0]*g48[iy+0]*g78[iz+0];
s[1861] = + g0[ix+0]*g49[iy+0]*g78[iz+0];
s[1862] = + g0[ix+0]*g48[iy+0]*g79[iz+0];
s[1863] = + g15[ix+0]*g32[iy+0]*g80[iz+0];
s[1864] = + g14[ix+0]*g33[iy+0]*g80[iz+0];
s[1865] = + g14[ix+0]*g32[iy+0]*g81[iz+0];
s[1866] = + g13[ix+0]*g34[iy+0]*g80[iz+0];
s[1867] = + g12[ix+0]*g35[iy+0]*g80[iz+0];
s[1868] = + g12[ix+0]*g34[iy+0]*g81[iz+0];
s[1869] = + g13[ix+0]*g32[iy+0]*g82[iz+0];
s[1870] = + g12[ix+0]*g33[iy+0]*g82[iz+0];
s[1871] = + g12[ix+0]*g32[iy+0]*g83[iz+0];
s[1872] = + g11[ix+0]*g36[iy+0]*g80[iz+0];
s[1873] = + g10[ix+0]*g37[iy+0]*g80[iz+0];
s[1874] = + g10[ix+0]*g36[iy+0]*g81[iz+0];
s[1875] = + g9[ix+0]*g38[iy+0]*g80[iz+0];
s[1876] = + g8[ix+0]*g39[iy+0]*g80[iz+0];
s[1877] = + g8[ix+0]*g38[iy+0]*g81[iz+0];
s[1878] = + g9[ix+0]*g36[iy+0]*g82[iz+0];
s[1879] = + g8[ix+0]*g37[iy+0]*g82[iz+0];
s[1880] = + g8[ix+0]*g36[iy+0]*g83[iz+0];
s[1881] = + g11[ix+0]*g32[iy+0]*g84[iz+0];
s[1882] = + g10[ix+0]*g33[iy+0]*g84[iz+0];
s[1883] = + g10[ix+0]*g32[iy+0]*g85[iz+0];
s[1884] = + g9[ix+0]*g34[iy+0]*g84[iz+0];
s[1885] = + g8[ix+0]*g35[iy+0]*g84[iz+0];
s[1886] = + g8[ix+0]*g34[iy+0]*g85[iz+0];
s[1887] = + g9[ix+0]*g32[iy+0]*g86[iz+0];
s[1888] = + g8[ix+0]*g33[iy+0]*g86[iz+0];
s[1889] = + g8[ix+0]*g32[iy+0]*g87[iz+0];
s[1890] = + g7[ix+0]*g40[iy+0]*g80[iz+0];
s[1891] = + g6[ix+0]*g41[iy+0]*g80[iz+0];
s[1892] = + g6[ix+0]*g40[iy+0]*g81[iz+0];
s[1893] = + g5[ix+0]*g42[iy+0]*g80[iz+0];
s[1894] = + g4[ix+0]*g43[iy+0]*g80[iz+0];
s[1895] = + g4[ix+0]*g42[iy+0]*g81[iz+0];
s[1896] = + g5[ix+0]*g40[iy+0]*g82[iz+0];
s[1897] = + g4[ix+0]*g41[iy+0]*g82[iz+0];
s[1898] = + g4[ix+0]*g40[iy+0]*g83[iz+0];
s[1899] = + g3[ix+0]*g44[iy+0]*g80[iz+0];
s[1900] = + g2[ix+0]*g45[iy+0]*g80[iz+0];
s[1901] = + g2[ix+0]*g44[iy+0]*g81[iz+0];
s[1902] = + g1[ix+0]*g46[iy+0]*g80[iz+0];
s[1903] = + g0[ix+0]*g47[iy+0]*g80[iz+0];
s[1904] = + g0[ix+0]*g46[iy+0]*g81[iz+0];
s[1905] = + g1[ix+0]*g44[iy+0]*g82[iz+0];
s[1906] = + g0[ix+0]*g45[iy+0]*g82[iz+0];
s[1907] = + g0[ix+0]*g44[iy+0]*g83[iz+0];
s[1908] = + g3[ix+0]*g40[iy+0]*g84[iz+0];
s[1909] = + g2[ix+0]*g41[iy+0]*g84[iz+0];
s[1910] = + g2[ix+0]*g40[iy+0]*g85[iz+0];
s[1911] = + g1[ix+0]*g42[iy+0]*g84[iz+0];
s[1912] = + g0[ix+0]*g43[iy+0]*g84[iz+0];
s[1913] = + g0[ix+0]*g42[iy+0]*g85[iz+0];
s[1914] = + g1[ix+0]*g40[iy+0]*g86[iz+0];
s[1915] = + g0[ix+0]*g41[iy+0]*g86[iz+0];
s[1916] = + g0[ix+0]*g40[iy+0]*g87[iz+0];
s[1917] = + g7[ix+0]*g32[iy+0]*g88[iz+0];
s[1918] = + g6[ix+0]*g33[iy+0]*g88[iz+0];
s[1919] = + g6[ix+0]*g32[iy+0]*g89[iz+0];
s[1920] = + g5[ix+0]*g34[iy+0]*g88[iz+0];
s[1921] = + g4[ix+0]*g35[iy+0]*g88[iz+0];
s[1922] = + g4[ix+0]*g34[iy+0]*g89[iz+0];
s[1923] = + g5[ix+0]*g32[iy+0]*g90[iz+0];
s[1924] = + g4[ix+0]*g33[iy+0]*g90[iz+0];
s[1925] = + g4[ix+0]*g32[iy+0]*g91[iz+0];
s[1926] = + g3[ix+0]*g36[iy+0]*g88[iz+0];
s[1927] = + g2[ix+0]*g37[iy+0]*g88[iz+0];
s[1928] = + g2[ix+0]*g36[iy+0]*g89[iz+0];
s[1929] = + g1[ix+0]*g38[iy+0]*g88[iz+0];
s[1930] = + g0[ix+0]*g39[iy+0]*g88[iz+0];
s[1931] = + g0[ix+0]*g38[iy+0]*g89[iz+0];
s[1932] = + g1[ix+0]*g36[iy+0]*g90[iz+0];
s[1933] = + g0[ix+0]*g37[iy+0]*g90[iz+0];
s[1934] = + g0[ix+0]*g36[iy+0]*g91[iz+0];
s[1935] = + g3[ix+0]*g32[iy+0]*g92[iz+0];
s[1936] = + g2[ix+0]*g33[iy+0]*g92[iz+0];
s[1937] = + g2[ix+0]*g32[iy+0]*g93[iz+0];
s[1938] = + g1[ix+0]*g34[iy+0]*g92[iz+0];
s[1939] = + g0[ix+0]*g35[iy+0]*g92[iz+0];
s[1940] = + g0[ix+0]*g34[iy+0]*g93[iz+0];
s[1941] = + g1[ix+0]*g32[iy+0]*g94[iz+0];
s[1942] = + g0[ix+0]*g33[iy+0]*g94[iz+0];
s[1943] = + g0[ix+0]*g32[iy+0]*g95[iz+0];
s[1944] = + g31[ix+0]*g0[iy+0]*g96[iz+0];
s[1945] = + g30[ix+0]*g1[iy+0]*g96[iz+0];
s[1946] = + g30[ix+0]*g0[iy+0]*g97[iz+0];
s[1947] = + g29[ix+0]*g2[iy+0]*g96[iz+0];
s[1948] = + g28[ix+0]*g3[iy+0]*g96[iz+0];
s[1949] = + g28[ix+0]*g2[iy+0]*g97[iz+0];
s[1950] = + g29[ix+0]*g0[iy+0]*g98[iz+0];
s[1951] = + g28[ix+0]*g1[iy+0]*g98[iz+0];
s[1952] = + g28[ix+0]*g0[iy+0]*g99[iz+0];
s[1953] = + g27[ix+0]*g4[iy+0]*g96[iz+0];
s[1954] = + g26[ix+0]*g5[iy+0]*g96[iz+0];
s[1955] = + g26[ix+0]*g4[iy+0]*g97[iz+0];
s[1956] = + g25[ix+0]*g6[iy+0]*g96[iz+0];
s[1957] = + g24[ix+0]*g7[iy+0]*g96[iz+0];
s[1958] = + g24[ix+0]*g6[iy+0]*g97[iz+0];
s[1959] = + g25[ix+0]*g4[iy+0]*g98[iz+0];
s[1960] = + g24[ix+0]*g5[iy+0]*g98[iz+0];
s[1961] = + g24[ix+0]*g4[iy+0]*g99[iz+0];
s[1962] = + g27[ix+0]*g0[iy+0]*g100[iz+0];
s[1963] = + g26[ix+0]*g1[iy+0]*g100[iz+0];
s[1964] = + g26[ix+0]*g0[iy+0]*g101[iz+0];
s[1965] = + g25[ix+0]*g2[iy+0]*g100[iz+0];
s[1966] = + g24[ix+0]*g3[iy+0]*g100[iz+0];
s[1967] = + g24[ix+0]*g2[iy+0]*g101[iz+0];
s[1968] = + g25[ix+0]*g0[iy+0]*g102[iz+0];
s[1969] = + g24[ix+0]*g1[iy+0]*g102[iz+0];
s[1970] = + g24[ix+0]*g0[iy+0]*g103[iz+0];
s[1971] = + g23[ix+0]*g8[iy+0]*g96[iz+0];
s[1972] = + g22[ix+0]*g9[iy+0]*g96[iz+0];
s[1973] = + g22[ix+0]*g8[iy+0]*g97[iz+0];
s[1974] = + g21[ix+0]*g10[iy+0]*g96[iz+0];
s[1975] = + g20[ix+0]*g11[iy+0]*g96[iz+0];
s[1976] = + g20[ix+0]*g10[iy+0]*g97[iz+0];
s[1977] = + g21[ix+0]*g8[iy+0]*g98[iz+0];
s[1978] = + g20[ix+0]*g9[iy+0]*g98[iz+0];
s[1979] = + g20[ix+0]*g8[iy+0]*g99[iz+0];
s[1980] = + g19[ix+0]*g12[iy+0]*g96[iz+0];
s[1981] = + g18[ix+0]*g13[iy+0]*g96[iz+0];
s[1982] = + g18[ix+0]*g12[iy+0]*g97[iz+0];
s[1983] = + g17[ix+0]*g14[iy+0]*g96[iz+0];
s[1984] = + g16[ix+0]*g15[iy+0]*g96[iz+0];
s[1985] = + g16[ix+0]*g14[iy+0]*g97[iz+0];
s[1986] = + g17[ix+0]*g12[iy+0]*g98[iz+0];
s[1987] = + g16[ix+0]*g13[iy+0]*g98[iz+0];
s[1988] = + g16[ix+0]*g12[iy+0]*g99[iz+0];
s[1989] = + g19[ix+0]*g8[iy+0]*g100[iz+0];
s[1990] = + g18[ix+0]*g9[iy+0]*g100[iz+0];
s[1991] = + g18[ix+0]*g8[iy+0]*g101[iz+0];
s[1992] = + g17[ix+0]*g10[iy+0]*g100[iz+0];
s[1993] = + g16[ix+0]*g11[iy+0]*g100[iz+0];
s[1994] = + g16[ix+0]*g10[iy+0]*g101[iz+0];
s[1995] = + g17[ix+0]*g8[iy+0]*g102[iz+0];
s[1996] = + g16[ix+0]*g9[iy+0]*g102[iz+0];
s[1997] = + g16[ix+0]*g8[iy+0]*g103[iz+0];
s[1998] = + g23[ix+0]*g0[iy+0]*g104[iz+0];
s[1999] = + g22[ix+0]*g1[iy+0]*g104[iz+0];
s[2000] = + g22[ix+0]*g0[iy+0]*g105[iz+0];
s[2001] = + g21[ix+0]*g2[iy+0]*g104[iz+0];
s[2002] = + g20[ix+0]*g3[iy+0]*g104[iz+0];
s[2003] = + g20[ix+0]*g2[iy+0]*g105[iz+0];
s[2004] = + g21[ix+0]*g0[iy+0]*g106[iz+0];
s[2005] = + g20[ix+0]*g1[iy+0]*g106[iz+0];
s[2006] = + g20[ix+0]*g0[iy+0]*g107[iz+0];
s[2007] = + g19[ix+0]*g4[iy+0]*g104[iz+0];
s[2008] = + g18[ix+0]*g5[iy+0]*g104[iz+0];
s[2009] = + g18[ix+0]*g4[iy+0]*g105[iz+0];
s[2010] = + g17[ix+0]*g6[iy+0]*g104[iz+0];
s[2011] = + g16[ix+0]*g7[iy+0]*g104[iz+0];
s[2012] = + g16[ix+0]*g6[iy+0]*g105[iz+0];
s[2013] = + g17[ix+0]*g4[iy+0]*g106[iz+0];
s[2014] = + g16[ix+0]*g5[iy+0]*g106[iz+0];
s[2015] = + g16[ix+0]*g4[iy+0]*g107[iz+0];
s[2016] = + g19[ix+0]*g0[iy+0]*g108[iz+0];
s[2017] = + g18[ix+0]*g1[iy+0]*g108[iz+0];
s[2018] = + g18[ix+0]*g0[iy+0]*g109[iz+0];
s[2019] = + g17[ix+0]*g2[iy+0]*g108[iz+0];
s[2020] = + g16[ix+0]*g3[iy+0]*g108[iz+0];
s[2021] = + g16[ix+0]*g2[iy+0]*g109[iz+0];
s[2022] = + g17[ix+0]*g0[iy+0]*g110[iz+0];
s[2023] = + g16[ix+0]*g1[iy+0]*g110[iz+0];
s[2024] = + g16[ix+0]*g0[iy+0]*g111[iz+0];
s[2025] = + g15[ix+0]*g16[iy+0]*g96[iz+0];
s[2026] = + g14[ix+0]*g17[iy+0]*g96[iz+0];
s[2027] = + g14[ix+0]*g16[iy+0]*g97[iz+0];
s[2028] = + g13[ix+0]*g18[iy+0]*g96[iz+0];
s[2029] = + g12[ix+0]*g19[iy+0]*g96[iz+0];
s[2030] = + g12[ix+0]*g18[iy+0]*g97[iz+0];
s[2031] = + g13[ix+0]*g16[iy+0]*g98[iz+0];
s[2032] = + g12[ix+0]*g17[iy+0]*g98[iz+0];
s[2033] = + g12[ix+0]*g16[iy+0]*g99[iz+0];
s[2034] = + g11[ix+0]*g20[iy+0]*g96[iz+0];
s[2035] = + g10[ix+0]*g21[iy+0]*g96[iz+0];
s[2036] = + g10[ix+0]*g20[iy+0]*g97[iz+0];
s[2037] = + g9[ix+0]*g22[iy+0]*g96[iz+0];
s[2038] = + g8[ix+0]*g23[iy+0]*g96[iz+0];
s[2039] = + g8[ix+0]*g22[iy+0]*g97[iz+0];
s[2040] = + g9[ix+0]*g20[iy+0]*g98[iz+0];
s[2041] = + g8[ix+0]*g21[iy+0]*g98[iz+0];
s[2042] = + g8[ix+0]*g20[iy+0]*g99[iz+0];
s[2043] = + g11[ix+0]*g16[iy+0]*g100[iz+0];
s[2044] = + g10[ix+0]*g17[iy+0]*g100[iz+0];
s[2045] = + g10[ix+0]*g16[iy+0]*g101[iz+0];
s[2046] = + g9[ix+0]*g18[iy+0]*g100[iz+0];
s[2047] = + g8[ix+0]*g19[iy+0]*g100[iz+0];
s[2048] = + g8[ix+0]*g18[iy+0]*g101[iz+0];
s[2049] = + g9[ix+0]*g16[iy+0]*g102[iz+0];
s[2050] = + g8[ix+0]*g17[iy+0]*g102[iz+0];
s[2051] = + g8[ix+0]*g16[iy+0]*g103[iz+0];
s[2052] = + g7[ix+0]*g24[iy+0]*g96[iz+0];
s[2053] = + g6[ix+0]*g25[iy+0]*g96[iz+0];
s[2054] = + g6[ix+0]*g24[iy+0]*g97[iz+0];
s[2055] = + g5[ix+0]*g26[iy+0]*g96[iz+0];
s[2056] = + g4[ix+0]*g27[iy+0]*g96[iz+0];
s[2057] = + g4[ix+0]*g26[iy+0]*g97[iz+0];
s[2058] = + g5[ix+0]*g24[iy+0]*g98[iz+0];
s[2059] = + g4[ix+0]*g25[iy+0]*g98[iz+0];
s[2060] = + g4[ix+0]*g24[iy+0]*g99[iz+0];
s[2061] = + g3[ix+0]*g28[iy+0]*g96[iz+0];
s[2062] = + g2[ix+0]*g29[iy+0]*g96[iz+0];
s[2063] = + g2[ix+0]*g28[iy+0]*g97[iz+0];
s[2064] = + g1[ix+0]*g30[iy+0]*g96[iz+0];
s[2065] = + g0[ix+0]*g31[iy+0]*g96[iz+0];
s[2066] = + g0[ix+0]*g30[iy+0]*g97[iz+0];
s[2067] = + g1[ix+0]*g28[iy+0]*g98[iz+0];
s[2068] = + g0[ix+0]*g29[iy+0]*g98[iz+0];
s[2069] = + g0[ix+0]*g28[iy+0]*g99[iz+0];
s[2070] = + g3[ix+0]*g24[iy+0]*g100[iz+0];
s[2071] = + g2[ix+0]*g25[iy+0]*g100[iz+0];
s[2072] = + g2[ix+0]*g24[iy+0]*g101[iz+0];
s[2073] = + g1[ix+0]*g26[iy+0]*g100[iz+0];
s[2074] = + g0[ix+0]*g27[iy+0]*g100[iz+0];
s[2075] = + g0[ix+0]*g26[iy+0]*g101[iz+0];
s[2076] = + g1[ix+0]*g24[iy+0]*g102[iz+0];
s[2077] = + g0[ix+0]*g25[iy+0]*g102[iz+0];
s[2078] = + g0[ix+0]*g24[iy+0]*g103[iz+0];
s[2079] = + g7[ix+0]*g16[iy+0]*g104[iz+0];
s[2080] = + g6[ix+0]*g17[iy+0]*g104[iz+0];
s[2081] = + g6[ix+0]*g16[iy+0]*g105[iz+0];
s[2082] = + g5[ix+0]*g18[iy+0]*g104[iz+0];
s[2083] = + g4[ix+0]*g19[iy+0]*g104[iz+0];
s[2084] = + g4[ix+0]*g18[iy+0]*g105[iz+0];
s[2085] = + g5[ix+0]*g16[iy+0]*g106[iz+0];
s[2086] = + g4[ix+0]*g17[iy+0]*g106[iz+0];
s[2087] = + g4[ix+0]*g16[iy+0]*g107[iz+0];
s[2088] = + g3[ix+0]*g20[iy+0]*g104[iz+0];
s[2089] = + g2[ix+0]*g21[iy+0]*g104[iz+0];
s[2090] = + g2[ix+0]*g20[iy+0]*g105[iz+0];
s[2091] = + g1[ix+0]*g22[iy+0]*g104[iz+0];
s[2092] = + g0[ix+0]*g23[iy+0]*g104[iz+0];
s[2093] = + g0[ix+0]*g22[iy+0]*g105[iz+0];
s[2094] = + g1[ix+0]*g20[iy+0]*g106[iz+0];
s[2095] = + g0[ix+0]*g21[iy+0]*g106[iz+0];
s[2096] = + g0[ix+0]*g20[iy+0]*g107[iz+0];
s[2097] = + g3[ix+0]*g16[iy+0]*g108[iz+0];
s[2098] = + g2[ix+0]*g17[iy+0]*g108[iz+0];
s[2099] = + g2[ix+0]*g16[iy+0]*g109[iz+0];
s[2100] = + g1[ix+0]*g18[iy+0]*g108[iz+0];
s[2101] = + g0[ix+0]*g19[iy+0]*g108[iz+0];
s[2102] = + g0[ix+0]*g18[iy+0]*g109[iz+0];
s[2103] = + g1[ix+0]*g16[iy+0]*g110[iz+0];
s[2104] = + g0[ix+0]*g17[iy+0]*g110[iz+0];
s[2105] = + g0[ix+0]*g16[iy+0]*g111[iz+0];
s[2106] = + g15[ix+0]*g0[iy+0]*g112[iz+0];
s[2107] = + g14[ix+0]*g1[iy+0]*g112[iz+0];
s[2108] = + g14[ix+0]*g0[iy+0]*g113[iz+0];
s[2109] = + g13[ix+0]*g2[iy+0]*g112[iz+0];
s[2110] = + g12[ix+0]*g3[iy+0]*g112[iz+0];
s[2111] = + g12[ix+0]*g2[iy+0]*g113[iz+0];
s[2112] = + g13[ix+0]*g0[iy+0]*g114[iz+0];
s[2113] = + g12[ix+0]*g1[iy+0]*g114[iz+0];
s[2114] = + g12[ix+0]*g0[iy+0]*g115[iz+0];
s[2115] = + g11[ix+0]*g4[iy+0]*g112[iz+0];
s[2116] = + g10[ix+0]*g5[iy+0]*g112[iz+0];
s[2117] = + g10[ix+0]*g4[iy+0]*g113[iz+0];
s[2118] = + g9[ix+0]*g6[iy+0]*g112[iz+0];
s[2119] = + g8[ix+0]*g7[iy+0]*g112[iz+0];
s[2120] = + g8[ix+0]*g6[iy+0]*g113[iz+0];
s[2121] = + g9[ix+0]*g4[iy+0]*g114[iz+0];
s[2122] = + g8[ix+0]*g5[iy+0]*g114[iz+0];
s[2123] = + g8[ix+0]*g4[iy+0]*g115[iz+0];
s[2124] = + g11[ix+0]*g0[iy+0]*g116[iz+0];
s[2125] = + g10[ix+0]*g1[iy+0]*g116[iz+0];
s[2126] = + g10[ix+0]*g0[iy+0]*g117[iz+0];
s[2127] = + g9[ix+0]*g2[iy+0]*g116[iz+0];
s[2128] = + g8[ix+0]*g3[iy+0]*g116[iz+0];
s[2129] = + g8[ix+0]*g2[iy+0]*g117[iz+0];
s[2130] = + g9[ix+0]*g0[iy+0]*g118[iz+0];
s[2131] = + g8[ix+0]*g1[iy+0]*g118[iz+0];
s[2132] = + g8[ix+0]*g0[iy+0]*g119[iz+0];
s[2133] = + g7[ix+0]*g8[iy+0]*g112[iz+0];
s[2134] = + g6[ix+0]*g9[iy+0]*g112[iz+0];
s[2135] = + g6[ix+0]*g8[iy+0]*g113[iz+0];
s[2136] = + g5[ix+0]*g10[iy+0]*g112[iz+0];
s[2137] = + g4[ix+0]*g11[iy+0]*g112[iz+0];
s[2138] = + g4[ix+0]*g10[iy+0]*g113[iz+0];
s[2139] = + g5[ix+0]*g8[iy+0]*g114[iz+0];
s[2140] = + g4[ix+0]*g9[iy+0]*g114[iz+0];
s[2141] = + g4[ix+0]*g8[iy+0]*g115[iz+0];
s[2142] = + g3[ix+0]*g12[iy+0]*g112[iz+0];
s[2143] = + g2[ix+0]*g13[iy+0]*g112[iz+0];
s[2144] = + g2[ix+0]*g12[iy+0]*g113[iz+0];
s[2145] = + g1[ix+0]*g14[iy+0]*g112[iz+0];
s[2146] = + g0[ix+0]*g15[iy+0]*g112[iz+0];
s[2147] = + g0[ix+0]*g14[iy+0]*g113[iz+0];
s[2148] = + g1[ix+0]*g12[iy+0]*g114[iz+0];
s[2149] = + g0[ix+0]*g13[iy+0]*g114[iz+0];
s[2150] = + g0[ix+0]*g12[iy+0]*g115[iz+0];
s[2151] = + g3[ix+0]*g8[iy+0]*g116[iz+0];
s[2152] = + g2[ix+0]*g9[iy+0]*g116[iz+0];
s[2153] = + g2[ix+0]*g8[iy+0]*g117[iz+0];
s[2154] = + g1[ix+0]*g10[iy+0]*g116[iz+0];
s[2155] = + g0[ix+0]*g11[iy+0]*g116[iz+0];
s[2156] = + g0[ix+0]*g10[iy+0]*g117[iz+0];
s[2157] = + g1[ix+0]*g8[iy+0]*g118[iz+0];
s[2158] = + g0[ix+0]*g9[iy+0]*g118[iz+0];
s[2159] = + g0[ix+0]*g8[iy+0]*g119[iz+0];
s[2160] = + g7[ix+0]*g0[iy+0]*g120[iz+0];
s[2161] = + g6[ix+0]*g1[iy+0]*g120[iz+0];
s[2162] = + g6[ix+0]*g0[iy+0]*g121[iz+0];
s[2163] = + g5[ix+0]*g2[iy+0]*g120[iz+0];
s[2164] = + g4[ix+0]*g3[iy+0]*g120[iz+0];
s[2165] = + g4[ix+0]*g2[iy+0]*g121[iz+0];
s[2166] = + g5[ix+0]*g0[iy+0]*g122[iz+0];
s[2167] = + g4[ix+0]*g1[iy+0]*g122[iz+0];
s[2168] = + g4[ix+0]*g0[iy+0]*g123[iz+0];
s[2169] = + g3[ix+0]*g4[iy+0]*g120[iz+0];
s[2170] = + g2[ix+0]*g5[iy+0]*g120[iz+0];
s[2171] = + g2[ix+0]*g4[iy+0]*g121[iz+0];
s[2172] = + g1[ix+0]*g6[iy+0]*g120[iz+0];
s[2173] = + g0[ix+0]*g7[iy+0]*g120[iz+0];
s[2174] = + g0[ix+0]*g6[iy+0]*g121[iz+0];
s[2175] = + g1[ix+0]*g4[iy+0]*g122[iz+0];
s[2176] = + g0[ix+0]*g5[iy+0]*g122[iz+0];
s[2177] = + g0[ix+0]*g4[iy+0]*g123[iz+0];
s[2178] = + g3[ix+0]*g0[iy+0]*g124[iz+0];
s[2179] = + g2[ix+0]*g1[iy+0]*g124[iz+0];
s[2180] = + g2[ix+0]*g0[iy+0]*g125[iz+0];
s[2181] = + g1[ix+0]*g2[iy+0]*g124[iz+0];
s[2182] = + g0[ix+0]*g3[iy+0]*g124[iz+0];
s[2183] = + g0[ix+0]*g2[iy+0]*g125[iz+0];
s[2184] = + g1[ix+0]*g0[iy+0]*g126[iz+0];
s[2185] = + g0[ix+0]*g1[iy+0]*g126[iz+0];
s[2186] = + g0[ix+0]*g0[iy+0]*g127[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0] + s[972] + s[1944] + s[4] + s[976] + s[1948] + s[8] + s[980] + s[1952];
gout[n*27+1] = + s[9] + s[981] + s[1953] + s[13] + s[985] + s[1957] + s[17] + s[989] + s[1961];
gout[n*27+2] = + s[18] + s[990] + s[1962] + s[22] + s[994] + s[1966] + s[26] + s[998] + s[1970];
gout[n*27+3] = + s[27] + s[999] + s[1971] + s[31] + s[1003] + s[1975] + s[35] + s[1007] + s[1979];
gout[n*27+4] = + s[36] + s[1008] + s[1980] + s[40] + s[1012] + s[1984] + s[44] + s[1016] + s[1988];
gout[n*27+5] = + s[45] + s[1017] + s[1989] + s[49] + s[1021] + s[1993] + s[53] + s[1025] + s[1997];
gout[n*27+6] = + s[54] + s[1026] + s[1998] + s[58] + s[1030] + s[2002] + s[62] + s[1034] + s[2006];
gout[n*27+7] = + s[63] + s[1035] + s[2007] + s[67] + s[1039] + s[2011] + s[71] + s[1043] + s[2015];
gout[n*27+8] = + s[72] + s[1044] + s[2016] + s[76] + s[1048] + s[2020] + s[80] + s[1052] + s[2024];
gout[n*27+9] = + s[81] + s[1053] + s[2025] + s[85] + s[1057] + s[2029] + s[89] + s[1061] + s[2033];
gout[n*27+10] = + s[90] + s[1062] + s[2034] + s[94] + s[1066] + s[2038] + s[98] + s[1070] + s[2042];
gout[n*27+11] = + s[99] + s[1071] + s[2043] + s[103] + s[1075] + s[2047] + s[107] + s[1079] + s[2051];
gout[n*27+12] = + s[108] + s[1080] + s[2052] + s[112] + s[1084] + s[2056] + s[116] + s[1088] + s[2060];
gout[n*27+13] = + s[117] + s[1089] + s[2061] + s[121] + s[1093] + s[2065] + s[125] + s[1097] + s[2069];
gout[n*27+14] = + s[126] + s[1098] + s[2070] + s[130] + s[1102] + s[2074] + s[134] + s[1106] + s[2078];
gout[n*27+15] = + s[135] + s[1107] + s[2079] + s[139] + s[1111] + s[2083] + s[143] + s[1115] + s[2087];
gout[n*27+16] = + s[144] + s[1116] + s[2088] + s[148] + s[1120] + s[2092] + s[152] + s[1124] + s[2096];
gout[n*27+17] = + s[153] + s[1125] + s[2097] + s[157] + s[1129] + s[2101] + s[161] + s[1133] + s[2105];
gout[n*27+18] = + s[162] + s[1134] + s[2106] + s[166] + s[1138] + s[2110] + s[170] + s[1142] + s[2114];
gout[n*27+19] = + s[171] + s[1143] + s[2115] + s[175] + s[1147] + s[2119] + s[179] + s[1151] + s[2123];
gout[n*27+20] = + s[180] + s[1152] + s[2124] + s[184] + s[1156] + s[2128] + s[188] + s[1160] + s[2132];
gout[n*27+21] = + s[189] + s[1161] + s[2133] + s[193] + s[1165] + s[2137] + s[197] + s[1169] + s[2141];
gout[n*27+22] = + s[198] + s[1170] + s[2142] + s[202] + s[1174] + s[2146] + s[206] + s[1178] + s[2150];
gout[n*27+23] = + s[207] + s[1179] + s[2151] + s[211] + s[1183] + s[2155] + s[215] + s[1187] + s[2159];
gout[n*27+24] = + s[216] + s[1188] + s[2160] + s[220] + s[1192] + s[2164] + s[224] + s[1196] + s[2168];
gout[n*27+25] = + s[225] + s[1197] + s[2169] + s[229] + s[1201] + s[2173] + s[233] + s[1205] + s[2177];
gout[n*27+26] = + s[234] + s[1206] + s[2178] + s[238] + s[1210] + s[2182] + s[242] + s[1214] + s[2186];
} else {
gout[n*27+0] += + s[0] + s[972] + s[1944] + s[4] + s[976] + s[1948] + s[8] + s[980] + s[1952];
gout[n*27+1] += + s[9] + s[981] + s[1953] + s[13] + s[985] + s[1957] + s[17] + s[989] + s[1961];
gout[n*27+2] += + s[18] + s[990] + s[1962] + s[22] + s[994] + s[1966] + s[26] + s[998] + s[1970];
gout[n*27+3] += + s[27] + s[999] + s[1971] + s[31] + s[1003] + s[1975] + s[35] + s[1007] + s[1979];
gout[n*27+4] += + s[36] + s[1008] + s[1980] + s[40] + s[1012] + s[1984] + s[44] + s[1016] + s[1988];
gout[n*27+5] += + s[45] + s[1017] + s[1989] + s[49] + s[1021] + s[1993] + s[53] + s[1025] + s[1997];
gout[n*27+6] += + s[54] + s[1026] + s[1998] + s[58] + s[1030] + s[2002] + s[62] + s[1034] + s[2006];
gout[n*27+7] += + s[63] + s[1035] + s[2007] + s[67] + s[1039] + s[2011] + s[71] + s[1043] + s[2015];
gout[n*27+8] += + s[72] + s[1044] + s[2016] + s[76] + s[1048] + s[2020] + s[80] + s[1052] + s[2024];
gout[n*27+9] += + s[81] + s[1053] + s[2025] + s[85] + s[1057] + s[2029] + s[89] + s[1061] + s[2033];
gout[n*27+10] += + s[90] + s[1062] + s[2034] + s[94] + s[1066] + s[2038] + s[98] + s[1070] + s[2042];
gout[n*27+11] += + s[99] + s[1071] + s[2043] + s[103] + s[1075] + s[2047] + s[107] + s[1079] + s[2051];
gout[n*27+12] += + s[108] + s[1080] + s[2052] + s[112] + s[1084] + s[2056] + s[116] + s[1088] + s[2060];
gout[n*27+13] += + s[117] + s[1089] + s[2061] + s[121] + s[1093] + s[2065] + s[125] + s[1097] + s[2069];
gout[n*27+14] += + s[126] + s[1098] + s[2070] + s[130] + s[1102] + s[2074] + s[134] + s[1106] + s[2078];
gout[n*27+15] += + s[135] + s[1107] + s[2079] + s[139] + s[1111] + s[2083] + s[143] + s[1115] + s[2087];
gout[n*27+16] += + s[144] + s[1116] + s[2088] + s[148] + s[1120] + s[2092] + s[152] + s[1124] + s[2096];
gout[n*27+17] += + s[153] + s[1125] + s[2097] + s[157] + s[1129] + s[2101] + s[161] + s[1133] + s[2105];
gout[n*27+18] += + s[162] + s[1134] + s[2106] + s[166] + s[1138] + s[2110] + s[170] + s[1142] + s[2114];
gout[n*27+19] += + s[171] + s[1143] + s[2115] + s[175] + s[1147] + s[2119] + s[179] + s[1151] + s[2123];
gout[n*27+20] += + s[180] + s[1152] + s[2124] + s[184] + s[1156] + s[2128] + s[188] + s[1160] + s[2132];
gout[n*27+21] += + s[189] + s[1161] + s[2133] + s[193] + s[1165] + s[2137] + s[197] + s[1169] + s[2141];
gout[n*27+22] += + s[198] + s[1170] + s[2142] + s[202] + s[1174] + s[2146] + s[206] + s[1178] + s[2150];
gout[n*27+23] += + s[207] + s[1179] + s[2151] + s[211] + s[1183] + s[2155] + s[215] + s[1187] + s[2159];
gout[n*27+24] += + s[216] + s[1188] + s[2160] + s[220] + s[1192] + s[2164] + s[224] + s[1196] + s[2168];
gout[n*27+25] += + s[225] + s[1197] + s[2169] + s[229] + s[1201] + s[2173] + s[233] + s[1205] + s[2177];
gout[n*27+26] += + s[234] + s[1206] + s[2178] + s[238] + s[1210] + s[2182] + s[242] + s[1214] + s[2186];
}}}
void int1e_rrjjjrr_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrjjjrr_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjjjrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrjjjrr_cart
CACHE_SIZE_T int1e_rrjjjrr_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjjjrr;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrjjjrr_sph
CACHE_SIZE_T int1e_rrjjjrr_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {2, 5, 0, 0, 7, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrjjjrr;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrjjjrr_spinor
ALL_CINT1E(int1e_rrjjjrr)
ALL_CINT1E_FORTRAN_(int1e_rrjjjrr)
/* <RI DOT RI RI DOT RI i|R R R |j> */
void CINTgout1e_int1e_rrrrjjj(double *gout, double *g, FINT *idx, CINTEnvVars *envs, FINT gout_empty) {
FINT nf = envs->nf;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double *g33 = g32 + envs->g_size * 3;
double *g34 = g33 + envs->g_size * 3;
double *g35 = g34 + envs->g_size * 3;
double *g36 = g35 + envs->g_size * 3;
double *g37 = g36 + envs->g_size * 3;
double *g38 = g37 + envs->g_size * 3;
double *g39 = g38 + envs->g_size * 3;
double *g40 = g39 + envs->g_size * 3;
double *g41 = g40 + envs->g_size * 3;
double *g42 = g41 + envs->g_size * 3;
double *g43 = g42 + envs->g_size * 3;
double *g44 = g43 + envs->g_size * 3;
double *g45 = g44 + envs->g_size * 3;
double *g46 = g45 + envs->g_size * 3;
double *g47 = g46 + envs->g_size * 3;
double *g48 = g47 + envs->g_size * 3;
double *g49 = g48 + envs->g_size * 3;
double *g50 = g49 + envs->g_size * 3;
double *g51 = g50 + envs->g_size * 3;
double *g52 = g51 + envs->g_size * 3;
double *g53 = g52 + envs->g_size * 3;
double *g54 = g53 + envs->g_size * 3;
double *g55 = g54 + envs->g_size * 3;
double *g56 = g55 + envs->g_size * 3;
double *g57 = g56 + envs->g_size * 3;
double *g58 = g57 + envs->g_size * 3;
double *g59 = g58 + envs->g_size * 3;
double *g60 = g59 + envs->g_size * 3;
double *g61 = g60 + envs->g_size * 3;
double *g62 = g61 + envs->g_size * 3;
double *g63 = g62 + envs->g_size * 3;
double *g64 = g63 + envs->g_size * 3;
double *g65 = g64 + envs->g_size * 3;
double *g66 = g65 + envs->g_size * 3;
double *g67 = g66 + envs->g_size * 3;
double *g68 = g67 + envs->g_size * 3;
double *g69 = g68 + envs->g_size * 3;
double *g70 = g69 + envs->g_size * 3;
double *g71 = g70 + envs->g_size * 3;
double *g72 = g71 + envs->g_size * 3;
double *g73 = g72 + envs->g_size * 3;
double *g74 = g73 + envs->g_size * 3;
double *g75 = g74 + envs->g_size * 3;
double *g76 = g75 + envs->g_size * 3;
double *g77 = g76 + envs->g_size * 3;
double *g78 = g77 + envs->g_size * 3;
double *g79 = g78 + envs->g_size * 3;
double *g80 = g79 + envs->g_size * 3;
double *g81 = g80 + envs->g_size * 3;
double *g82 = g81 + envs->g_size * 3;
double *g83 = g82 + envs->g_size * 3;
double *g84 = g83 + envs->g_size * 3;
double *g85 = g84 + envs->g_size * 3;
double *g86 = g85 + envs->g_size * 3;
double *g87 = g86 + envs->g_size * 3;
double *g88 = g87 + envs->g_size * 3;
double *g89 = g88 + envs->g_size * 3;
double *g90 = g89 + envs->g_size * 3;
double *g91 = g90 + envs->g_size * 3;
double *g92 = g91 + envs->g_size * 3;
double *g93 = g92 + envs->g_size * 3;
double *g94 = g93 + envs->g_size * 3;
double *g95 = g94 + envs->g_size * 3;
double *g96 = g95 + envs->g_size * 3;
double *g97 = g96 + envs->g_size * 3;
double *g98 = g97 + envs->g_size * 3;
double *g99 = g98 + envs->g_size * 3;
double *g100 = g99 + envs->g_size * 3;
double *g101 = g100 + envs->g_size * 3;
double *g102 = g101 + envs->g_size * 3;
double *g103 = g102 + envs->g_size * 3;
double *g104 = g103 + envs->g_size * 3;
double *g105 = g104 + envs->g_size * 3;
double *g106 = g105 + envs->g_size * 3;
double *g107 = g106 + envs->g_size * 3;
double *g108 = g107 + envs->g_size * 3;
double *g109 = g108 + envs->g_size * 3;
double *g110 = g109 + envs->g_size * 3;
double *g111 = g110 + envs->g_size * 3;
double *g112 = g111 + envs->g_size * 3;
double *g113 = g112 + envs->g_size * 3;
double *g114 = g113 + envs->g_size * 3;
double *g115 = g114 + envs->g_size * 3;
double *g116 = g115 + envs->g_size * 3;
double *g117 = g116 + envs->g_size * 3;
double *g118 = g117 + envs->g_size * 3;
double *g119 = g118 + envs->g_size * 3;
double *g120 = g119 + envs->g_size * 3;
double *g121 = g120 + envs->g_size * 3;
double *g122 = g121 + envs->g_size * 3;
double *g123 = g122 + envs->g_size * 3;
double *g124 = g123 + envs->g_size * 3;
double *g125 = g124 + envs->g_size * 3;
double *g126 = g125 + envs->g_size * 3;
double *g127 = g126 + envs->g_size * 3;
double dri[3];
dri[0] = envs->ri[0] - envs->ri[0];
dri[1] = envs->ri[1] - envs->ri[1];
dri[2] = envs->ri[2] - envs->ri[2];
double s[2187];
G1E_R_J(g1, g0, envs->i_l+4, envs->j_l+0, 0);
G1E_R_J(g2, g0, envs->i_l+4, envs->j_l+1, 0);
G1E_R_J(g3, g2, envs->i_l+4, envs->j_l+0, 0);
G1E_R_J(g4, g0, envs->i_l+4, envs->j_l+2, 0);
G1E_R_J(g5, g4, envs->i_l+4, envs->j_l+0, 0);
G1E_R_J(g6, g4, envs->i_l+4, envs->j_l+1, 0);
G1E_R_J(g7, g6, envs->i_l+4, envs->j_l+0, 0);
G1E_RCI(g8, g0, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g9, g1, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g10, g2, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g11, g3, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g12, g4, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g13, g5, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g14, g6, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g15, g7, envs->i_l+3, envs->j_l, 0);
G1E_RCI(g16, g0, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g17, g1, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g18, g2, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g19, g3, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g20, g4, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g21, g5, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g22, g6, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g23, g7, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g24, g8, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g25, g9, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g26, g10, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g27, g11, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g28, g12, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g29, g13, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g30, g14, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g31, g15, envs->i_l+2, envs->j_l, 0);
G1E_RCI(g32, g0, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g33, g1, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g34, g2, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g35, g3, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g36, g4, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g37, g5, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g38, g6, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g39, g7, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g40, g8, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g41, g9, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g42, g10, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g43, g11, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g44, g12, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g45, g13, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g46, g14, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g47, g15, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g48, g16, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g49, g17, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g50, g18, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g51, g19, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g52, g20, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g53, g21, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g54, g22, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g55, g23, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g56, g24, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g57, g25, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g58, g26, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g59, g27, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g60, g28, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g61, g29, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g62, g30, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g63, g31, envs->i_l+1, envs->j_l, 0);
G1E_RCI(g64, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g65, g1, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g66, g2, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g67, g3, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g68, g4, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g69, g5, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g70, g6, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g71, g7, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g72, g8, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g73, g9, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g74, g10, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g75, g11, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g76, g12, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g77, g13, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g78, g14, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g79, g15, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g80, g16, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g81, g17, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g82, g18, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g83, g19, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g84, g20, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g85, g21, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g86, g22, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g87, g23, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g88, g24, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g89, g25, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g90, g26, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g91, g27, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g92, g28, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g93, g29, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g94, g30, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g95, g31, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g96, g32, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g97, g33, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g98, g34, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g99, g35, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g100, g36, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g101, g37, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g102, g38, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g103, g39, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g104, g40, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g105, g41, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g106, g42, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g107, g43, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g108, g44, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g109, g45, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g110, g46, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g111, g47, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g112, g48, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g113, g49, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g114, g50, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g115, g51, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g116, g52, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g117, g53, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g118, g54, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g119, g55, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g120, g56, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g121, g57, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g122, g58, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g123, g59, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g124, g60, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g125, g61, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g126, g62, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g127, g63, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
s[0] = + g127[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g126[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g126[ix+0]*g0[iy+0]*g1[iz+0];
s[3] = + g125[ix+0]*g2[iy+0]*g0[iz+0];
s[4] = + g124[ix+0]*g3[iy+0]*g0[iz+0];
s[5] = + g124[ix+0]*g2[iy+0]*g1[iz+0];
s[6] = + g125[ix+0]*g0[iy+0]*g2[iz+0];
s[7] = + g124[ix+0]*g1[iy+0]*g2[iz+0];
s[8] = + g124[ix+0]*g0[iy+0]*g3[iz+0];
s[9] = + g123[ix+0]*g4[iy+0]*g0[iz+0];
s[10] = + g122[ix+0]*g5[iy+0]*g0[iz+0];
s[11] = + g122[ix+0]*g4[iy+0]*g1[iz+0];
s[12] = + g121[ix+0]*g6[iy+0]*g0[iz+0];
s[13] = + g120[ix+0]*g7[iy+0]*g0[iz+0];
s[14] = + g120[ix+0]*g6[iy+0]*g1[iz+0];
s[15] = + g121[ix+0]*g4[iy+0]*g2[iz+0];
s[16] = + g120[ix+0]*g5[iy+0]*g2[iz+0];
s[17] = + g120[ix+0]*g4[iy+0]*g3[iz+0];
s[18] = + g123[ix+0]*g0[iy+0]*g4[iz+0];
s[19] = + g122[ix+0]*g1[iy+0]*g4[iz+0];
s[20] = + g122[ix+0]*g0[iy+0]*g5[iz+0];
s[21] = + g121[ix+0]*g2[iy+0]*g4[iz+0];
s[22] = + g120[ix+0]*g3[iy+0]*g4[iz+0];
s[23] = + g120[ix+0]*g2[iy+0]*g5[iz+0];
s[24] = + g121[ix+0]*g0[iy+0]*g6[iz+0];
s[25] = + g120[ix+0]*g1[iy+0]*g6[iz+0];
s[26] = + g120[ix+0]*g0[iy+0]*g7[iz+0];
s[27] = + g119[ix+0]*g8[iy+0]*g0[iz+0];
s[28] = + g118[ix+0]*g9[iy+0]*g0[iz+0];
s[29] = + g118[ix+0]*g8[iy+0]*g1[iz+0];
s[30] = + g117[ix+0]*g10[iy+0]*g0[iz+0];
s[31] = + g116[ix+0]*g11[iy+0]*g0[iz+0];
s[32] = + g116[ix+0]*g10[iy+0]*g1[iz+0];
s[33] = + g117[ix+0]*g8[iy+0]*g2[iz+0];
s[34] = + g116[ix+0]*g9[iy+0]*g2[iz+0];
s[35] = + g116[ix+0]*g8[iy+0]*g3[iz+0];
s[36] = + g115[ix+0]*g12[iy+0]*g0[iz+0];
s[37] = + g114[ix+0]*g13[iy+0]*g0[iz+0];
s[38] = + g114[ix+0]*g12[iy+0]*g1[iz+0];
s[39] = + g113[ix+0]*g14[iy+0]*g0[iz+0];
s[40] = + g112[ix+0]*g15[iy+0]*g0[iz+0];
s[41] = + g112[ix+0]*g14[iy+0]*g1[iz+0];
s[42] = + g113[ix+0]*g12[iy+0]*g2[iz+0];
s[43] = + g112[ix+0]*g13[iy+0]*g2[iz+0];
s[44] = + g112[ix+0]*g12[iy+0]*g3[iz+0];
s[45] = + g115[ix+0]*g8[iy+0]*g4[iz+0];
s[46] = + g114[ix+0]*g9[iy+0]*g4[iz+0];
s[47] = + g114[ix+0]*g8[iy+0]*g5[iz+0];
s[48] = + g113[ix+0]*g10[iy+0]*g4[iz+0];
s[49] = + g112[ix+0]*g11[iy+0]*g4[iz+0];
s[50] = + g112[ix+0]*g10[iy+0]*g5[iz+0];
s[51] = + g113[ix+0]*g8[iy+0]*g6[iz+0];
s[52] = + g112[ix+0]*g9[iy+0]*g6[iz+0];
s[53] = + g112[ix+0]*g8[iy+0]*g7[iz+0];
s[54] = + g119[ix+0]*g0[iy+0]*g8[iz+0];
s[55] = + g118[ix+0]*g1[iy+0]*g8[iz+0];
s[56] = + g118[ix+0]*g0[iy+0]*g9[iz+0];
s[57] = + g117[ix+0]*g2[iy+0]*g8[iz+0];
s[58] = + g116[ix+0]*g3[iy+0]*g8[iz+0];
s[59] = + g116[ix+0]*g2[iy+0]*g9[iz+0];
s[60] = + g117[ix+0]*g0[iy+0]*g10[iz+0];
s[61] = + g116[ix+0]*g1[iy+0]*g10[iz+0];
s[62] = + g116[ix+0]*g0[iy+0]*g11[iz+0];
s[63] = + g115[ix+0]*g4[iy+0]*g8[iz+0];
s[64] = + g114[ix+0]*g5[iy+0]*g8[iz+0];
s[65] = + g114[ix+0]*g4[iy+0]*g9[iz+0];
s[66] = + g113[ix+0]*g6[iy+0]*g8[iz+0];
s[67] = + g112[ix+0]*g7[iy+0]*g8[iz+0];
s[68] = + g112[ix+0]*g6[iy+0]*g9[iz+0];
s[69] = + g113[ix+0]*g4[iy+0]*g10[iz+0];
s[70] = + g112[ix+0]*g5[iy+0]*g10[iz+0];
s[71] = + g112[ix+0]*g4[iy+0]*g11[iz+0];
s[72] = + g115[ix+0]*g0[iy+0]*g12[iz+0];
s[73] = + g114[ix+0]*g1[iy+0]*g12[iz+0];
s[74] = + g114[ix+0]*g0[iy+0]*g13[iz+0];
s[75] = + g113[ix+0]*g2[iy+0]*g12[iz+0];
s[76] = + g112[ix+0]*g3[iy+0]*g12[iz+0];
s[77] = + g112[ix+0]*g2[iy+0]*g13[iz+0];
s[78] = + g113[ix+0]*g0[iy+0]*g14[iz+0];
s[79] = + g112[ix+0]*g1[iy+0]*g14[iz+0];
s[80] = + g112[ix+0]*g0[iy+0]*g15[iz+0];
s[81] = + g111[ix+0]*g16[iy+0]*g0[iz+0];
s[82] = + g110[ix+0]*g17[iy+0]*g0[iz+0];
s[83] = + g110[ix+0]*g16[iy+0]*g1[iz+0];
s[84] = + g109[ix+0]*g18[iy+0]*g0[iz+0];
s[85] = + g108[ix+0]*g19[iy+0]*g0[iz+0];
s[86] = + g108[ix+0]*g18[iy+0]*g1[iz+0];
s[87] = + g109[ix+0]*g16[iy+0]*g2[iz+0];
s[88] = + g108[ix+0]*g17[iy+0]*g2[iz+0];
s[89] = + g108[ix+0]*g16[iy+0]*g3[iz+0];
s[90] = + g107[ix+0]*g20[iy+0]*g0[iz+0];
s[91] = + g106[ix+0]*g21[iy+0]*g0[iz+0];
s[92] = + g106[ix+0]*g20[iy+0]*g1[iz+0];
s[93] = + g105[ix+0]*g22[iy+0]*g0[iz+0];
s[94] = + g104[ix+0]*g23[iy+0]*g0[iz+0];
s[95] = + g104[ix+0]*g22[iy+0]*g1[iz+0];
s[96] = + g105[ix+0]*g20[iy+0]*g2[iz+0];
s[97] = + g104[ix+0]*g21[iy+0]*g2[iz+0];
s[98] = + g104[ix+0]*g20[iy+0]*g3[iz+0];
s[99] = + g107[ix+0]*g16[iy+0]*g4[iz+0];
s[100] = + g106[ix+0]*g17[iy+0]*g4[iz+0];
s[101] = + g106[ix+0]*g16[iy+0]*g5[iz+0];
s[102] = + g105[ix+0]*g18[iy+0]*g4[iz+0];
s[103] = + g104[ix+0]*g19[iy+0]*g4[iz+0];
s[104] = + g104[ix+0]*g18[iy+0]*g5[iz+0];
s[105] = + g105[ix+0]*g16[iy+0]*g6[iz+0];
s[106] = + g104[ix+0]*g17[iy+0]*g6[iz+0];
s[107] = + g104[ix+0]*g16[iy+0]*g7[iz+0];
s[108] = + g103[ix+0]*g24[iy+0]*g0[iz+0];
s[109] = + g102[ix+0]*g25[iy+0]*g0[iz+0];
s[110] = + g102[ix+0]*g24[iy+0]*g1[iz+0];
s[111] = + g101[ix+0]*g26[iy+0]*g0[iz+0];
s[112] = + g100[ix+0]*g27[iy+0]*g0[iz+0];
s[113] = + g100[ix+0]*g26[iy+0]*g1[iz+0];
s[114] = + g101[ix+0]*g24[iy+0]*g2[iz+0];
s[115] = + g100[ix+0]*g25[iy+0]*g2[iz+0];
s[116] = + g100[ix+0]*g24[iy+0]*g3[iz+0];
s[117] = + g99[ix+0]*g28[iy+0]*g0[iz+0];
s[118] = + g98[ix+0]*g29[iy+0]*g0[iz+0];
s[119] = + g98[ix+0]*g28[iy+0]*g1[iz+0];
s[120] = + g97[ix+0]*g30[iy+0]*g0[iz+0];
s[121] = + g96[ix+0]*g31[iy+0]*g0[iz+0];
s[122] = + g96[ix+0]*g30[iy+0]*g1[iz+0];
s[123] = + g97[ix+0]*g28[iy+0]*g2[iz+0];
s[124] = + g96[ix+0]*g29[iy+0]*g2[iz+0];
s[125] = + g96[ix+0]*g28[iy+0]*g3[iz+0];
s[126] = + g99[ix+0]*g24[iy+0]*g4[iz+0];
s[127] = + g98[ix+0]*g25[iy+0]*g4[iz+0];
s[128] = + g98[ix+0]*g24[iy+0]*g5[iz+0];
s[129] = + g97[ix+0]*g26[iy+0]*g4[iz+0];
s[130] = + g96[ix+0]*g27[iy+0]*g4[iz+0];
s[131] = + g96[ix+0]*g26[iy+0]*g5[iz+0];
s[132] = + g97[ix+0]*g24[iy+0]*g6[iz+0];
s[133] = + g96[ix+0]*g25[iy+0]*g6[iz+0];
s[134] = + g96[ix+0]*g24[iy+0]*g7[iz+0];
s[135] = + g103[ix+0]*g16[iy+0]*g8[iz+0];
s[136] = + g102[ix+0]*g17[iy+0]*g8[iz+0];
s[137] = + g102[ix+0]*g16[iy+0]*g9[iz+0];
s[138] = + g101[ix+0]*g18[iy+0]*g8[iz+0];
s[139] = + g100[ix+0]*g19[iy+0]*g8[iz+0];
s[140] = + g100[ix+0]*g18[iy+0]*g9[iz+0];
s[141] = + g101[ix+0]*g16[iy+0]*g10[iz+0];
s[142] = + g100[ix+0]*g17[iy+0]*g10[iz+0];
s[143] = + g100[ix+0]*g16[iy+0]*g11[iz+0];
s[144] = + g99[ix+0]*g20[iy+0]*g8[iz+0];
s[145] = + g98[ix+0]*g21[iy+0]*g8[iz+0];
s[146] = + g98[ix+0]*g20[iy+0]*g9[iz+0];
s[147] = + g97[ix+0]*g22[iy+0]*g8[iz+0];
s[148] = + g96[ix+0]*g23[iy+0]*g8[iz+0];
s[149] = + g96[ix+0]*g22[iy+0]*g9[iz+0];
s[150] = + g97[ix+0]*g20[iy+0]*g10[iz+0];
s[151] = + g96[ix+0]*g21[iy+0]*g10[iz+0];
s[152] = + g96[ix+0]*g20[iy+0]*g11[iz+0];
s[153] = + g99[ix+0]*g16[iy+0]*g12[iz+0];
s[154] = + g98[ix+0]*g17[iy+0]*g12[iz+0];
s[155] = + g98[ix+0]*g16[iy+0]*g13[iz+0];
s[156] = + g97[ix+0]*g18[iy+0]*g12[iz+0];
s[157] = + g96[ix+0]*g19[iy+0]*g12[iz+0];
s[158] = + g96[ix+0]*g18[iy+0]*g13[iz+0];
s[159] = + g97[ix+0]*g16[iy+0]*g14[iz+0];
s[160] = + g96[ix+0]*g17[iy+0]*g14[iz+0];
s[161] = + g96[ix+0]*g16[iy+0]*g15[iz+0];
s[162] = + g111[ix+0]*g0[iy+0]*g16[iz+0];
s[163] = + g110[ix+0]*g1[iy+0]*g16[iz+0];
s[164] = + g110[ix+0]*g0[iy+0]*g17[iz+0];
s[165] = + g109[ix+0]*g2[iy+0]*g16[iz+0];
s[166] = + g108[ix+0]*g3[iy+0]*g16[iz+0];
s[167] = + g108[ix+0]*g2[iy+0]*g17[iz+0];
s[168] = + g109[ix+0]*g0[iy+0]*g18[iz+0];
s[169] = + g108[ix+0]*g1[iy+0]*g18[iz+0];
s[170] = + g108[ix+0]*g0[iy+0]*g19[iz+0];
s[171] = + g107[ix+0]*g4[iy+0]*g16[iz+0];
s[172] = + g106[ix+0]*g5[iy+0]*g16[iz+0];
s[173] = + g106[ix+0]*g4[iy+0]*g17[iz+0];
s[174] = + g105[ix+0]*g6[iy+0]*g16[iz+0];
s[175] = + g104[ix+0]*g7[iy+0]*g16[iz+0];
s[176] = + g104[ix+0]*g6[iy+0]*g17[iz+0];
s[177] = + g105[ix+0]*g4[iy+0]*g18[iz+0];
s[178] = + g104[ix+0]*g5[iy+0]*g18[iz+0];
s[179] = + g104[ix+0]*g4[iy+0]*g19[iz+0];
s[180] = + g107[ix+0]*g0[iy+0]*g20[iz+0];
s[181] = + g106[ix+0]*g1[iy+0]*g20[iz+0];
s[182] = + g106[ix+0]*g0[iy+0]*g21[iz+0];
s[183] = + g105[ix+0]*g2[iy+0]*g20[iz+0];
s[184] = + g104[ix+0]*g3[iy+0]*g20[iz+0];
s[185] = + g104[ix+0]*g2[iy+0]*g21[iz+0];
s[186] = + g105[ix+0]*g0[iy+0]*g22[iz+0];
s[187] = + g104[ix+0]*g1[iy+0]*g22[iz+0];
s[188] = + g104[ix+0]*g0[iy+0]*g23[iz+0];
s[189] = + g103[ix+0]*g8[iy+0]*g16[iz+0];
s[190] = + g102[ix+0]*g9[iy+0]*g16[iz+0];
s[191] = + g102[ix+0]*g8[iy+0]*g17[iz+0];
s[192] = + g101[ix+0]*g10[iy+0]*g16[iz+0];
s[193] = + g100[ix+0]*g11[iy+0]*g16[iz+0];
s[194] = + g100[ix+0]*g10[iy+0]*g17[iz+0];
s[195] = + g101[ix+0]*g8[iy+0]*g18[iz+0];
s[196] = + g100[ix+0]*g9[iy+0]*g18[iz+0];
s[197] = + g100[ix+0]*g8[iy+0]*g19[iz+0];
s[198] = + g99[ix+0]*g12[iy+0]*g16[iz+0];
s[199] = + g98[ix+0]*g13[iy+0]*g16[iz+0];
s[200] = + g98[ix+0]*g12[iy+0]*g17[iz+0];
s[201] = + g97[ix+0]*g14[iy+0]*g16[iz+0];
s[202] = + g96[ix+0]*g15[iy+0]*g16[iz+0];
s[203] = + g96[ix+0]*g14[iy+0]*g17[iz+0];
s[204] = + g97[ix+0]*g12[iy+0]*g18[iz+0];
s[205] = + g96[ix+0]*g13[iy+0]*g18[iz+0];
s[206] = + g96[ix+0]*g12[iy+0]*g19[iz+0];
s[207] = + g99[ix+0]*g8[iy+0]*g20[iz+0];
s[208] = + g98[ix+0]*g9[iy+0]*g20[iz+0];
s[209] = + g98[ix+0]*g8[iy+0]*g21[iz+0];
s[210] = + g97[ix+0]*g10[iy+0]*g20[iz+0];
s[211] = + g96[ix+0]*g11[iy+0]*g20[iz+0];
s[212] = + g96[ix+0]*g10[iy+0]*g21[iz+0];
s[213] = + g97[ix+0]*g8[iy+0]*g22[iz+0];
s[214] = + g96[ix+0]*g9[iy+0]*g22[iz+0];
s[215] = + g96[ix+0]*g8[iy+0]*g23[iz+0];
s[216] = + g103[ix+0]*g0[iy+0]*g24[iz+0];
s[217] = + g102[ix+0]*g1[iy+0]*g24[iz+0];
s[218] = + g102[ix+0]*g0[iy+0]*g25[iz+0];
s[219] = + g101[ix+0]*g2[iy+0]*g24[iz+0];
s[220] = + g100[ix+0]*g3[iy+0]*g24[iz+0];
s[221] = + g100[ix+0]*g2[iy+0]*g25[iz+0];
s[222] = + g101[ix+0]*g0[iy+0]*g26[iz+0];
s[223] = + g100[ix+0]*g1[iy+0]*g26[iz+0];
s[224] = + g100[ix+0]*g0[iy+0]*g27[iz+0];
s[225] = + g99[ix+0]*g4[iy+0]*g24[iz+0];
s[226] = + g98[ix+0]*g5[iy+0]*g24[iz+0];
s[227] = + g98[ix+0]*g4[iy+0]*g25[iz+0];
s[228] = + g97[ix+0]*g6[iy+0]*g24[iz+0];
s[229] = + g96[ix+0]*g7[iy+0]*g24[iz+0];
s[230] = + g96[ix+0]*g6[iy+0]*g25[iz+0];
s[231] = + g97[ix+0]*g4[iy+0]*g26[iz+0];
s[232] = + g96[ix+0]*g5[iy+0]*g26[iz+0];
s[233] = + g96[ix+0]*g4[iy+0]*g27[iz+0];
s[234] = + g99[ix+0]*g0[iy+0]*g28[iz+0];
s[235] = + g98[ix+0]*g1[iy+0]*g28[iz+0];
s[236] = + g98[ix+0]*g0[iy+0]*g29[iz+0];
s[237] = + g97[ix+0]*g2[iy+0]*g28[iz+0];
s[238] = + g96[ix+0]*g3[iy+0]*g28[iz+0];
s[239] = + g96[ix+0]*g2[iy+0]*g29[iz+0];
s[240] = + g97[ix+0]*g0[iy+0]*g30[iz+0];
s[241] = + g96[ix+0]*g1[iy+0]*g30[iz+0];
s[242] = + g96[ix+0]*g0[iy+0]*g31[iz+0];
s[243] = + g95[ix+0]*g32[iy+0]*g0[iz+0];
s[244] = + g94[ix+0]*g33[iy+0]*g0[iz+0];
s[245] = + g94[ix+0]*g32[iy+0]*g1[iz+0];
s[246] = + g93[ix+0]*g34[iy+0]*g0[iz+0];
s[247] = + g92[ix+0]*g35[iy+0]*g0[iz+0];
s[248] = + g92[ix+0]*g34[iy+0]*g1[iz+0];
s[249] = + g93[ix+0]*g32[iy+0]*g2[iz+0];
s[250] = + g92[ix+0]*g33[iy+0]*g2[iz+0];
s[251] = + g92[ix+0]*g32[iy+0]*g3[iz+0];
s[252] = + g91[ix+0]*g36[iy+0]*g0[iz+0];
s[253] = + g90[ix+0]*g37[iy+0]*g0[iz+0];
s[254] = + g90[ix+0]*g36[iy+0]*g1[iz+0];
s[255] = + g89[ix+0]*g38[iy+0]*g0[iz+0];
s[256] = + g88[ix+0]*g39[iy+0]*g0[iz+0];
s[257] = + g88[ix+0]*g38[iy+0]*g1[iz+0];
s[258] = + g89[ix+0]*g36[iy+0]*g2[iz+0];
s[259] = + g88[ix+0]*g37[iy+0]*g2[iz+0];
s[260] = + g88[ix+0]*g36[iy+0]*g3[iz+0];
s[261] = + g91[ix+0]*g32[iy+0]*g4[iz+0];
s[262] = + g90[ix+0]*g33[iy+0]*g4[iz+0];
s[263] = + g90[ix+0]*g32[iy+0]*g5[iz+0];
s[264] = + g89[ix+0]*g34[iy+0]*g4[iz+0];
s[265] = + g88[ix+0]*g35[iy+0]*g4[iz+0];
s[266] = + g88[ix+0]*g34[iy+0]*g5[iz+0];
s[267] = + g89[ix+0]*g32[iy+0]*g6[iz+0];
s[268] = + g88[ix+0]*g33[iy+0]*g6[iz+0];
s[269] = + g88[ix+0]*g32[iy+0]*g7[iz+0];
s[270] = + g87[ix+0]*g40[iy+0]*g0[iz+0];
s[271] = + g86[ix+0]*g41[iy+0]*g0[iz+0];
s[272] = + g86[ix+0]*g40[iy+0]*g1[iz+0];
s[273] = + g85[ix+0]*g42[iy+0]*g0[iz+0];
s[274] = + g84[ix+0]*g43[iy+0]*g0[iz+0];
s[275] = + g84[ix+0]*g42[iy+0]*g1[iz+0];
s[276] = + g85[ix+0]*g40[iy+0]*g2[iz+0];
s[277] = + g84[ix+0]*g41[iy+0]*g2[iz+0];
s[278] = + g84[ix+0]*g40[iy+0]*g3[iz+0];
s[279] = + g83[ix+0]*g44[iy+0]*g0[iz+0];
s[280] = + g82[ix+0]*g45[iy+0]*g0[iz+0];
s[281] = + g82[ix+0]*g44[iy+0]*g1[iz+0];
s[282] = + g81[ix+0]*g46[iy+0]*g0[iz+0];
s[283] = + g80[ix+0]*g47[iy+0]*g0[iz+0];
s[284] = + g80[ix+0]*g46[iy+0]*g1[iz+0];
s[285] = + g81[ix+0]*g44[iy+0]*g2[iz+0];
s[286] = + g80[ix+0]*g45[iy+0]*g2[iz+0];
s[287] = + g80[ix+0]*g44[iy+0]*g3[iz+0];
s[288] = + g83[ix+0]*g40[iy+0]*g4[iz+0];
s[289] = + g82[ix+0]*g41[iy+0]*g4[iz+0];
s[290] = + g82[ix+0]*g40[iy+0]*g5[iz+0];
s[291] = + g81[ix+0]*g42[iy+0]*g4[iz+0];
s[292] = + g80[ix+0]*g43[iy+0]*g4[iz+0];
s[293] = + g80[ix+0]*g42[iy+0]*g5[iz+0];
s[294] = + g81[ix+0]*g40[iy+0]*g6[iz+0];
s[295] = + g80[ix+0]*g41[iy+0]*g6[iz+0];
s[296] = + g80[ix+0]*g40[iy+0]*g7[iz+0];
s[297] = + g87[ix+0]*g32[iy+0]*g8[iz+0];
s[298] = + g86[ix+0]*g33[iy+0]*g8[iz+0];
s[299] = + g86[ix+0]*g32[iy+0]*g9[iz+0];
s[300] = + g85[ix+0]*g34[iy+0]*g8[iz+0];
s[301] = + g84[ix+0]*g35[iy+0]*g8[iz+0];
s[302] = + g84[ix+0]*g34[iy+0]*g9[iz+0];
s[303] = + g85[ix+0]*g32[iy+0]*g10[iz+0];
s[304] = + g84[ix+0]*g33[iy+0]*g10[iz+0];
s[305] = + g84[ix+0]*g32[iy+0]*g11[iz+0];
s[306] = + g83[ix+0]*g36[iy+0]*g8[iz+0];
s[307] = + g82[ix+0]*g37[iy+0]*g8[iz+0];
s[308] = + g82[ix+0]*g36[iy+0]*g9[iz+0];
s[309] = + g81[ix+0]*g38[iy+0]*g8[iz+0];
s[310] = + g80[ix+0]*g39[iy+0]*g8[iz+0];
s[311] = + g80[ix+0]*g38[iy+0]*g9[iz+0];
s[312] = + g81[ix+0]*g36[iy+0]*g10[iz+0];
s[313] = + g80[ix+0]*g37[iy+0]*g10[iz+0];
s[314] = + g80[ix+0]*g36[iy+0]*g11[iz+0];
s[315] = + g83[ix+0]*g32[iy+0]*g12[iz+0];
s[316] = + g82[ix+0]*g33[iy+0]*g12[iz+0];
s[317] = + g82[ix+0]*g32[iy+0]*g13[iz+0];
s[318] = + g81[ix+0]*g34[iy+0]*g12[iz+0];
s[319] = + g80[ix+0]*g35[iy+0]*g12[iz+0];
s[320] = + g80[ix+0]*g34[iy+0]*g13[iz+0];
s[321] = + g81[ix+0]*g32[iy+0]*g14[iz+0];
s[322] = + g80[ix+0]*g33[iy+0]*g14[iz+0];
s[323] = + g80[ix+0]*g32[iy+0]*g15[iz+0];
s[324] = + g79[ix+0]*g48[iy+0]*g0[iz+0];
s[325] = + g78[ix+0]*g49[iy+0]*g0[iz+0];
s[326] = + g78[ix+0]*g48[iy+0]*g1[iz+0];
s[327] = + g77[ix+0]*g50[iy+0]*g0[iz+0];
s[328] = + g76[ix+0]*g51[iy+0]*g0[iz+0];
s[329] = + g76[ix+0]*g50[iy+0]*g1[iz+0];
s[330] = + g77[ix+0]*g48[iy+0]*g2[iz+0];
s[331] = + g76[ix+0]*g49[iy+0]*g2[iz+0];
s[332] = + g76[ix+0]*g48[iy+0]*g3[iz+0];
s[333] = + g75[ix+0]*g52[iy+0]*g0[iz+0];
s[334] = + g74[ix+0]*g53[iy+0]*g0[iz+0];
s[335] = + g74[ix+0]*g52[iy+0]*g1[iz+0];
s[336] = + g73[ix+0]*g54[iy+0]*g0[iz+0];
s[337] = + g72[ix+0]*g55[iy+0]*g0[iz+0];
s[338] = + g72[ix+0]*g54[iy+0]*g1[iz+0];
s[339] = + g73[ix+0]*g52[iy+0]*g2[iz+0];
s[340] = + g72[ix+0]*g53[iy+0]*g2[iz+0];
s[341] = + g72[ix+0]*g52[iy+0]*g3[iz+0];
s[342] = + g75[ix+0]*g48[iy+0]*g4[iz+0];
s[343] = + g74[ix+0]*g49[iy+0]*g4[iz+0];
s[344] = + g74[ix+0]*g48[iy+0]*g5[iz+0];
s[345] = + g73[ix+0]*g50[iy+0]*g4[iz+0];
s[346] = + g72[ix+0]*g51[iy+0]*g4[iz+0];
s[347] = + g72[ix+0]*g50[iy+0]*g5[iz+0];
s[348] = + g73[ix+0]*g48[iy+0]*g6[iz+0];
s[349] = + g72[ix+0]*g49[iy+0]*g6[iz+0];
s[350] = + g72[ix+0]*g48[iy+0]*g7[iz+0];
s[351] = + g71[ix+0]*g56[iy+0]*g0[iz+0];
s[352] = + g70[ix+0]*g57[iy+0]*g0[iz+0];
s[353] = + g70[ix+0]*g56[iy+0]*g1[iz+0];
s[354] = + g69[ix+0]*g58[iy+0]*g0[iz+0];
s[355] = + g68[ix+0]*g59[iy+0]*g0[iz+0];
s[356] = + g68[ix+0]*g58[iy+0]*g1[iz+0];
s[357] = + g69[ix+0]*g56[iy+0]*g2[iz+0];
s[358] = + g68[ix+0]*g57[iy+0]*g2[iz+0];
s[359] = + g68[ix+0]*g56[iy+0]*g3[iz+0];
s[360] = + g67[ix+0]*g60[iy+0]*g0[iz+0];
s[361] = + g66[ix+0]*g61[iy+0]*g0[iz+0];
s[362] = + g66[ix+0]*g60[iy+0]*g1[iz+0];
s[363] = + g65[ix+0]*g62[iy+0]*g0[iz+0];
s[364] = + g64[ix+0]*g63[iy+0]*g0[iz+0];
s[365] = + g64[ix+0]*g62[iy+0]*g1[iz+0];
s[366] = + g65[ix+0]*g60[iy+0]*g2[iz+0];
s[367] = + g64[ix+0]*g61[iy+0]*g2[iz+0];
s[368] = + g64[ix+0]*g60[iy+0]*g3[iz+0];
s[369] = + g67[ix+0]*g56[iy+0]*g4[iz+0];
s[370] = + g66[ix+0]*g57[iy+0]*g4[iz+0];
s[371] = + g66[ix+0]*g56[iy+0]*g5[iz+0];
s[372] = + g65[ix+0]*g58[iy+0]*g4[iz+0];
s[373] = + g64[ix+0]*g59[iy+0]*g4[iz+0];
s[374] = + g64[ix+0]*g58[iy+0]*g5[iz+0];
s[375] = + g65[ix+0]*g56[iy+0]*g6[iz+0];
s[376] = + g64[ix+0]*g57[iy+0]*g6[iz+0];
s[377] = + g64[ix+0]*g56[iy+0]*g7[iz+0];
s[378] = + g71[ix+0]*g48[iy+0]*g8[iz+0];
s[379] = + g70[ix+0]*g49[iy+0]*g8[iz+0];
s[380] = + g70[ix+0]*g48[iy+0]*g9[iz+0];
s[381] = + g69[ix+0]*g50[iy+0]*g8[iz+0];
s[382] = + g68[ix+0]*g51[iy+0]*g8[iz+0];
s[383] = + g68[ix+0]*g50[iy+0]*g9[iz+0];
s[384] = + g69[ix+0]*g48[iy+0]*g10[iz+0];
s[385] = + g68[ix+0]*g49[iy+0]*g10[iz+0];
s[386] = + g68[ix+0]*g48[iy+0]*g11[iz+0];
s[387] = + g67[ix+0]*g52[iy+0]*g8[iz+0];
s[388] = + g66[ix+0]*g53[iy+0]*g8[iz+0];
s[389] = + g66[ix+0]*g52[iy+0]*g9[iz+0];
s[390] = + g65[ix+0]*g54[iy+0]*g8[iz+0];
s[391] = + g64[ix+0]*g55[iy+0]*g8[iz+0];
s[392] = + g64[ix+0]*g54[iy+0]*g9[iz+0];
s[393] = + g65[ix+0]*g52[iy+0]*g10[iz+0];
s[394] = + g64[ix+0]*g53[iy+0]*g10[iz+0];
s[395] = + g64[ix+0]*g52[iy+0]*g11[iz+0];
s[396] = + g67[ix+0]*g48[iy+0]*g12[iz+0];
s[397] = + g66[ix+0]*g49[iy+0]*g12[iz+0];
s[398] = + g66[ix+0]*g48[iy+0]*g13[iz+0];
s[399] = + g65[ix+0]*g50[iy+0]*g12[iz+0];
s[400] = + g64[ix+0]*g51[iy+0]*g12[iz+0];
s[401] = + g64[ix+0]*g50[iy+0]*g13[iz+0];
s[402] = + g65[ix+0]*g48[iy+0]*g14[iz+0];
s[403] = + g64[ix+0]*g49[iy+0]*g14[iz+0];
s[404] = + g64[ix+0]*g48[iy+0]*g15[iz+0];
s[405] = + g79[ix+0]*g32[iy+0]*g16[iz+0];
s[406] = + g78[ix+0]*g33[iy+0]*g16[iz+0];
s[407] = + g78[ix+0]*g32[iy+0]*g17[iz+0];
s[408] = + g77[ix+0]*g34[iy+0]*g16[iz+0];
s[409] = + g76[ix+0]*g35[iy+0]*g16[iz+0];
s[410] = + g76[ix+0]*g34[iy+0]*g17[iz+0];
s[411] = + g77[ix+0]*g32[iy+0]*g18[iz+0];
s[412] = + g76[ix+0]*g33[iy+0]*g18[iz+0];
s[413] = + g76[ix+0]*g32[iy+0]*g19[iz+0];
s[414] = + g75[ix+0]*g36[iy+0]*g16[iz+0];
s[415] = + g74[ix+0]*g37[iy+0]*g16[iz+0];
s[416] = + g74[ix+0]*g36[iy+0]*g17[iz+0];
s[417] = + g73[ix+0]*g38[iy+0]*g16[iz+0];
s[418] = + g72[ix+0]*g39[iy+0]*g16[iz+0];
s[419] = + g72[ix+0]*g38[iy+0]*g17[iz+0];
s[420] = + g73[ix+0]*g36[iy+0]*g18[iz+0];
s[421] = + g72[ix+0]*g37[iy+0]*g18[iz+0];
s[422] = + g72[ix+0]*g36[iy+0]*g19[iz+0];
s[423] = + g75[ix+0]*g32[iy+0]*g20[iz+0];
s[424] = + g74[ix+0]*g33[iy+0]*g20[iz+0];
s[425] = + g74[ix+0]*g32[iy+0]*g21[iz+0];
s[426] = + g73[ix+0]*g34[iy+0]*g20[iz+0];
s[427] = + g72[ix+0]*g35[iy+0]*g20[iz+0];
s[428] = + g72[ix+0]*g34[iy+0]*g21[iz+0];
s[429] = + g73[ix+0]*g32[iy+0]*g22[iz+0];
s[430] = + g72[ix+0]*g33[iy+0]*g22[iz+0];
s[431] = + g72[ix+0]*g32[iy+0]*g23[iz+0];
s[432] = + g71[ix+0]*g40[iy+0]*g16[iz+0];
s[433] = + g70[ix+0]*g41[iy+0]*g16[iz+0];
s[434] = + g70[ix+0]*g40[iy+0]*g17[iz+0];
s[435] = + g69[ix+0]*g42[iy+0]*g16[iz+0];
s[436] = + g68[ix+0]*g43[iy+0]*g16[iz+0];
s[437] = + g68[ix+0]*g42[iy+0]*g17[iz+0];
s[438] = + g69[ix+0]*g40[iy+0]*g18[iz+0];
s[439] = + g68[ix+0]*g41[iy+0]*g18[iz+0];
s[440] = + g68[ix+0]*g40[iy+0]*g19[iz+0];
s[441] = + g67[ix+0]*g44[iy+0]*g16[iz+0];
s[442] = + g66[ix+0]*g45[iy+0]*g16[iz+0];
s[443] = + g66[ix+0]*g44[iy+0]*g17[iz+0];
s[444] = + g65[ix+0]*g46[iy+0]*g16[iz+0];
s[445] = + g64[ix+0]*g47[iy+0]*g16[iz+0];
s[446] = + g64[ix+0]*g46[iy+0]*g17[iz+0];
s[447] = + g65[ix+0]*g44[iy+0]*g18[iz+0];
s[448] = + g64[ix+0]*g45[iy+0]*g18[iz+0];
s[449] = + g64[ix+0]*g44[iy+0]*g19[iz+0];
s[450] = + g67[ix+0]*g40[iy+0]*g20[iz+0];
s[451] = + g66[ix+0]*g41[iy+0]*g20[iz+0];
s[452] = + g66[ix+0]*g40[iy+0]*g21[iz+0];
s[453] = + g65[ix+0]*g42[iy+0]*g20[iz+0];
s[454] = + g64[ix+0]*g43[iy+0]*g20[iz+0];
s[455] = + g64[ix+0]*g42[iy+0]*g21[iz+0];
s[456] = + g65[ix+0]*g40[iy+0]*g22[iz+0];
s[457] = + g64[ix+0]*g41[iy+0]*g22[iz+0];
s[458] = + g64[ix+0]*g40[iy+0]*g23[iz+0];
s[459] = + g71[ix+0]*g32[iy+0]*g24[iz+0];
s[460] = + g70[ix+0]*g33[iy+0]*g24[iz+0];
s[461] = + g70[ix+0]*g32[iy+0]*g25[iz+0];
s[462] = + g69[ix+0]*g34[iy+0]*g24[iz+0];
s[463] = + g68[ix+0]*g35[iy+0]*g24[iz+0];
s[464] = + g68[ix+0]*g34[iy+0]*g25[iz+0];
s[465] = + g69[ix+0]*g32[iy+0]*g26[iz+0];
s[466] = + g68[ix+0]*g33[iy+0]*g26[iz+0];
s[467] = + g68[ix+0]*g32[iy+0]*g27[iz+0];
s[468] = + g67[ix+0]*g36[iy+0]*g24[iz+0];
s[469] = + g66[ix+0]*g37[iy+0]*g24[iz+0];
s[470] = + g66[ix+0]*g36[iy+0]*g25[iz+0];
s[471] = + g65[ix+0]*g38[iy+0]*g24[iz+0];
s[472] = + g64[ix+0]*g39[iy+0]*g24[iz+0];
s[473] = + g64[ix+0]*g38[iy+0]*g25[iz+0];
s[474] = + g65[ix+0]*g36[iy+0]*g26[iz+0];
s[475] = + g64[ix+0]*g37[iy+0]*g26[iz+0];
s[476] = + g64[ix+0]*g36[iy+0]*g27[iz+0];
s[477] = + g67[ix+0]*g32[iy+0]*g28[iz+0];
s[478] = + g66[ix+0]*g33[iy+0]*g28[iz+0];
s[479] = + g66[ix+0]*g32[iy+0]*g29[iz+0];
s[480] = + g65[ix+0]*g34[iy+0]*g28[iz+0];
s[481] = + g64[ix+0]*g35[iy+0]*g28[iz+0];
s[482] = + g64[ix+0]*g34[iy+0]*g29[iz+0];
s[483] = + g65[ix+0]*g32[iy+0]*g30[iz+0];
s[484] = + g64[ix+0]*g33[iy+0]*g30[iz+0];
s[485] = + g64[ix+0]*g32[iy+0]*g31[iz+0];
s[486] = + g95[ix+0]*g0[iy+0]*g32[iz+0];
s[487] = + g94[ix+0]*g1[iy+0]*g32[iz+0];
s[488] = + g94[ix+0]*g0[iy+0]*g33[iz+0];
s[489] = + g93[ix+0]*g2[iy+0]*g32[iz+0];
s[490] = + g92[ix+0]*g3[iy+0]*g32[iz+0];
s[491] = + g92[ix+0]*g2[iy+0]*g33[iz+0];
s[492] = + g93[ix+0]*g0[iy+0]*g34[iz+0];
s[493] = + g92[ix+0]*g1[iy+0]*g34[iz+0];
s[494] = + g92[ix+0]*g0[iy+0]*g35[iz+0];
s[495] = + g91[ix+0]*g4[iy+0]*g32[iz+0];
s[496] = + g90[ix+0]*g5[iy+0]*g32[iz+0];
s[497] = + g90[ix+0]*g4[iy+0]*g33[iz+0];
s[498] = + g89[ix+0]*g6[iy+0]*g32[iz+0];
s[499] = + g88[ix+0]*g7[iy+0]*g32[iz+0];
s[500] = + g88[ix+0]*g6[iy+0]*g33[iz+0];
s[501] = + g89[ix+0]*g4[iy+0]*g34[iz+0];
s[502] = + g88[ix+0]*g5[iy+0]*g34[iz+0];
s[503] = + g88[ix+0]*g4[iy+0]*g35[iz+0];
s[504] = + g91[ix+0]*g0[iy+0]*g36[iz+0];
s[505] = + g90[ix+0]*g1[iy+0]*g36[iz+0];
s[506] = + g90[ix+0]*g0[iy+0]*g37[iz+0];
s[507] = + g89[ix+0]*g2[iy+0]*g36[iz+0];
s[508] = + g88[ix+0]*g3[iy+0]*g36[iz+0];
s[509] = + g88[ix+0]*g2[iy+0]*g37[iz+0];
s[510] = + g89[ix+0]*g0[iy+0]*g38[iz+0];
s[511] = + g88[ix+0]*g1[iy+0]*g38[iz+0];
s[512] = + g88[ix+0]*g0[iy+0]*g39[iz+0];
s[513] = + g87[ix+0]*g8[iy+0]*g32[iz+0];
s[514] = + g86[ix+0]*g9[iy+0]*g32[iz+0];
s[515] = + g86[ix+0]*g8[iy+0]*g33[iz+0];
s[516] = + g85[ix+0]*g10[iy+0]*g32[iz+0];
s[517] = + g84[ix+0]*g11[iy+0]*g32[iz+0];
s[518] = + g84[ix+0]*g10[iy+0]*g33[iz+0];
s[519] = + g85[ix+0]*g8[iy+0]*g34[iz+0];
s[520] = + g84[ix+0]*g9[iy+0]*g34[iz+0];
s[521] = + g84[ix+0]*g8[iy+0]*g35[iz+0];
s[522] = + g83[ix+0]*g12[iy+0]*g32[iz+0];
s[523] = + g82[ix+0]*g13[iy+0]*g32[iz+0];
s[524] = + g82[ix+0]*g12[iy+0]*g33[iz+0];
s[525] = + g81[ix+0]*g14[iy+0]*g32[iz+0];
s[526] = + g80[ix+0]*g15[iy+0]*g32[iz+0];
s[527] = + g80[ix+0]*g14[iy+0]*g33[iz+0];
s[528] = + g81[ix+0]*g12[iy+0]*g34[iz+0];
s[529] = + g80[ix+0]*g13[iy+0]*g34[iz+0];
s[530] = + g80[ix+0]*g12[iy+0]*g35[iz+0];
s[531] = + g83[ix+0]*g8[iy+0]*g36[iz+0];
s[532] = + g82[ix+0]*g9[iy+0]*g36[iz+0];
s[533] = + g82[ix+0]*g8[iy+0]*g37[iz+0];
s[534] = + g81[ix+0]*g10[iy+0]*g36[iz+0];
s[535] = + g80[ix+0]*g11[iy+0]*g36[iz+0];
s[536] = + g80[ix+0]*g10[iy+0]*g37[iz+0];
s[537] = + g81[ix+0]*g8[iy+0]*g38[iz+0];
s[538] = + g80[ix+0]*g9[iy+0]*g38[iz+0];
s[539] = + g80[ix+0]*g8[iy+0]*g39[iz+0];
s[540] = + g87[ix+0]*g0[iy+0]*g40[iz+0];
s[541] = + g86[ix+0]*g1[iy+0]*g40[iz+0];
s[542] = + g86[ix+0]*g0[iy+0]*g41[iz+0];
s[543] = + g85[ix+0]*g2[iy+0]*g40[iz+0];
s[544] = + g84[ix+0]*g3[iy+0]*g40[iz+0];
s[545] = + g84[ix+0]*g2[iy+0]*g41[iz+0];
s[546] = + g85[ix+0]*g0[iy+0]*g42[iz+0];
s[547] = + g84[ix+0]*g1[iy+0]*g42[iz+0];
s[548] = + g84[ix+0]*g0[iy+0]*g43[iz+0];
s[549] = + g83[ix+0]*g4[iy+0]*g40[iz+0];
s[550] = + g82[ix+0]*g5[iy+0]*g40[iz+0];
s[551] = + g82[ix+0]*g4[iy+0]*g41[iz+0];
s[552] = + g81[ix+0]*g6[iy+0]*g40[iz+0];
s[553] = + g80[ix+0]*g7[iy+0]*g40[iz+0];
s[554] = + g80[ix+0]*g6[iy+0]*g41[iz+0];
s[555] = + g81[ix+0]*g4[iy+0]*g42[iz+0];
s[556] = + g80[ix+0]*g5[iy+0]*g42[iz+0];
s[557] = + g80[ix+0]*g4[iy+0]*g43[iz+0];
s[558] = + g83[ix+0]*g0[iy+0]*g44[iz+0];
s[559] = + g82[ix+0]*g1[iy+0]*g44[iz+0];
s[560] = + g82[ix+0]*g0[iy+0]*g45[iz+0];
s[561] = + g81[ix+0]*g2[iy+0]*g44[iz+0];
s[562] = + g80[ix+0]*g3[iy+0]*g44[iz+0];
s[563] = + g80[ix+0]*g2[iy+0]*g45[iz+0];
s[564] = + g81[ix+0]*g0[iy+0]*g46[iz+0];
s[565] = + g80[ix+0]*g1[iy+0]*g46[iz+0];
s[566] = + g80[ix+0]*g0[iy+0]*g47[iz+0];
s[567] = + g79[ix+0]*g16[iy+0]*g32[iz+0];
s[568] = + g78[ix+0]*g17[iy+0]*g32[iz+0];
s[569] = + g78[ix+0]*g16[iy+0]*g33[iz+0];
s[570] = + g77[ix+0]*g18[iy+0]*g32[iz+0];
s[571] = + g76[ix+0]*g19[iy+0]*g32[iz+0];
s[572] = + g76[ix+0]*g18[iy+0]*g33[iz+0];
s[573] = + g77[ix+0]*g16[iy+0]*g34[iz+0];
s[574] = + g76[ix+0]*g17[iy+0]*g34[iz+0];
s[575] = + g76[ix+0]*g16[iy+0]*g35[iz+0];
s[576] = + g75[ix+0]*g20[iy+0]*g32[iz+0];
s[577] = + g74[ix+0]*g21[iy+0]*g32[iz+0];
s[578] = + g74[ix+0]*g20[iy+0]*g33[iz+0];
s[579] = + g73[ix+0]*g22[iy+0]*g32[iz+0];
s[580] = + g72[ix+0]*g23[iy+0]*g32[iz+0];
s[581] = + g72[ix+0]*g22[iy+0]*g33[iz+0];
s[582] = + g73[ix+0]*g20[iy+0]*g34[iz+0];
s[583] = + g72[ix+0]*g21[iy+0]*g34[iz+0];
s[584] = + g72[ix+0]*g20[iy+0]*g35[iz+0];
s[585] = + g75[ix+0]*g16[iy+0]*g36[iz+0];
s[586] = + g74[ix+0]*g17[iy+0]*g36[iz+0];
s[587] = + g74[ix+0]*g16[iy+0]*g37[iz+0];
s[588] = + g73[ix+0]*g18[iy+0]*g36[iz+0];
s[589] = + g72[ix+0]*g19[iy+0]*g36[iz+0];
s[590] = + g72[ix+0]*g18[iy+0]*g37[iz+0];
s[591] = + g73[ix+0]*g16[iy+0]*g38[iz+0];
s[592] = + g72[ix+0]*g17[iy+0]*g38[iz+0];
s[593] = + g72[ix+0]*g16[iy+0]*g39[iz+0];
s[594] = + g71[ix+0]*g24[iy+0]*g32[iz+0];
s[595] = + g70[ix+0]*g25[iy+0]*g32[iz+0];
s[596] = + g70[ix+0]*g24[iy+0]*g33[iz+0];
s[597] = + g69[ix+0]*g26[iy+0]*g32[iz+0];
s[598] = + g68[ix+0]*g27[iy+0]*g32[iz+0];
s[599] = + g68[ix+0]*g26[iy+0]*g33[iz+0];
s[600] = + g69[ix+0]*g24[iy+0]*g34[iz+0];
s[601] = + g68[ix+0]*g25[iy+0]*g34[iz+0];
s[602] = + g68[ix+0]*g24[iy+0]*g35[iz+0];
s[603] = + g67[ix+0]*g28[iy+0]*g32[iz+0];
s[604] = + g66[ix+0]*g29[iy+0]*g32[iz+0];
s[605] = + g66[ix+0]*g28[iy+0]*g33[iz+0];
s[606] = + g65[ix+0]*g30[iy+0]*g32[iz+0];
s[607] = + g64[ix+0]*g31[iy+0]*g32[iz+0];
s[608] = + g64[ix+0]*g30[iy+0]*g33[iz+0];
s[609] = + g65[ix+0]*g28[iy+0]*g34[iz+0];
s[610] = + g64[ix+0]*g29[iy+0]*g34[iz+0];
s[611] = + g64[ix+0]*g28[iy+0]*g35[iz+0];
s[612] = + g67[ix+0]*g24[iy+0]*g36[iz+0];
s[613] = + g66[ix+0]*g25[iy+0]*g36[iz+0];
s[614] = + g66[ix+0]*g24[iy+0]*g37[iz+0];
s[615] = + g65[ix+0]*g26[iy+0]*g36[iz+0];
s[616] = + g64[ix+0]*g27[iy+0]*g36[iz+0];
s[617] = + g64[ix+0]*g26[iy+0]*g37[iz+0];
s[618] = + g65[ix+0]*g24[iy+0]*g38[iz+0];
s[619] = + g64[ix+0]*g25[iy+0]*g38[iz+0];
s[620] = + g64[ix+0]*g24[iy+0]*g39[iz+0];
s[621] = + g71[ix+0]*g16[iy+0]*g40[iz+0];
s[622] = + g70[ix+0]*g17[iy+0]*g40[iz+0];
s[623] = + g70[ix+0]*g16[iy+0]*g41[iz+0];
s[624] = + g69[ix+0]*g18[iy+0]*g40[iz+0];
s[625] = + g68[ix+0]*g19[iy+0]*g40[iz+0];
s[626] = + g68[ix+0]*g18[iy+0]*g41[iz+0];
s[627] = + g69[ix+0]*g16[iy+0]*g42[iz+0];
s[628] = + g68[ix+0]*g17[iy+0]*g42[iz+0];
s[629] = + g68[ix+0]*g16[iy+0]*g43[iz+0];
s[630] = + g67[ix+0]*g20[iy+0]*g40[iz+0];
s[631] = + g66[ix+0]*g21[iy+0]*g40[iz+0];
s[632] = + g66[ix+0]*g20[iy+0]*g41[iz+0];
s[633] = + g65[ix+0]*g22[iy+0]*g40[iz+0];
s[634] = + g64[ix+0]*g23[iy+0]*g40[iz+0];
s[635] = + g64[ix+0]*g22[iy+0]*g41[iz+0];
s[636] = + g65[ix+0]*g20[iy+0]*g42[iz+0];
s[637] = + g64[ix+0]*g21[iy+0]*g42[iz+0];
s[638] = + g64[ix+0]*g20[iy+0]*g43[iz+0];
s[639] = + g67[ix+0]*g16[iy+0]*g44[iz+0];
s[640] = + g66[ix+0]*g17[iy+0]*g44[iz+0];
s[641] = + g66[ix+0]*g16[iy+0]*g45[iz+0];
s[642] = + g65[ix+0]*g18[iy+0]*g44[iz+0];
s[643] = + g64[ix+0]*g19[iy+0]*g44[iz+0];
s[644] = + g64[ix+0]*g18[iy+0]*g45[iz+0];
s[645] = + g65[ix+0]*g16[iy+0]*g46[iz+0];
s[646] = + g64[ix+0]*g17[iy+0]*g46[iz+0];
s[647] = + g64[ix+0]*g16[iy+0]*g47[iz+0];
s[648] = + g79[ix+0]*g0[iy+0]*g48[iz+0];
s[649] = + g78[ix+0]*g1[iy+0]*g48[iz+0];
s[650] = + g78[ix+0]*g0[iy+0]*g49[iz+0];
s[651] = + g77[ix+0]*g2[iy+0]*g48[iz+0];
s[652] = + g76[ix+0]*g3[iy+0]*g48[iz+0];
s[653] = + g76[ix+0]*g2[iy+0]*g49[iz+0];
s[654] = + g77[ix+0]*g0[iy+0]*g50[iz+0];
s[655] = + g76[ix+0]*g1[iy+0]*g50[iz+0];
s[656] = + g76[ix+0]*g0[iy+0]*g51[iz+0];
s[657] = + g75[ix+0]*g4[iy+0]*g48[iz+0];
s[658] = + g74[ix+0]*g5[iy+0]*g48[iz+0];
s[659] = + g74[ix+0]*g4[iy+0]*g49[iz+0];
s[660] = + g73[ix+0]*g6[iy+0]*g48[iz+0];
s[661] = + g72[ix+0]*g7[iy+0]*g48[iz+0];
s[662] = + g72[ix+0]*g6[iy+0]*g49[iz+0];
s[663] = + g73[ix+0]*g4[iy+0]*g50[iz+0];
s[664] = + g72[ix+0]*g5[iy+0]*g50[iz+0];
s[665] = + g72[ix+0]*g4[iy+0]*g51[iz+0];
s[666] = + g75[ix+0]*g0[iy+0]*g52[iz+0];
s[667] = + g74[ix+0]*g1[iy+0]*g52[iz+0];
s[668] = + g74[ix+0]*g0[iy+0]*g53[iz+0];
s[669] = + g73[ix+0]*g2[iy+0]*g52[iz+0];
s[670] = + g72[ix+0]*g3[iy+0]*g52[iz+0];
s[671] = + g72[ix+0]*g2[iy+0]*g53[iz+0];
s[672] = + g73[ix+0]*g0[iy+0]*g54[iz+0];
s[673] = + g72[ix+0]*g1[iy+0]*g54[iz+0];
s[674] = + g72[ix+0]*g0[iy+0]*g55[iz+0];
s[675] = + g71[ix+0]*g8[iy+0]*g48[iz+0];
s[676] = + g70[ix+0]*g9[iy+0]*g48[iz+0];
s[677] = + g70[ix+0]*g8[iy+0]*g49[iz+0];
s[678] = + g69[ix+0]*g10[iy+0]*g48[iz+0];
s[679] = + g68[ix+0]*g11[iy+0]*g48[iz+0];
s[680] = + g68[ix+0]*g10[iy+0]*g49[iz+0];
s[681] = + g69[ix+0]*g8[iy+0]*g50[iz+0];
s[682] = + g68[ix+0]*g9[iy+0]*g50[iz+0];
s[683] = + g68[ix+0]*g8[iy+0]*g51[iz+0];
s[684] = + g67[ix+0]*g12[iy+0]*g48[iz+0];
s[685] = + g66[ix+0]*g13[iy+0]*g48[iz+0];
s[686] = + g66[ix+0]*g12[iy+0]*g49[iz+0];
s[687] = + g65[ix+0]*g14[iy+0]*g48[iz+0];
s[688] = + g64[ix+0]*g15[iy+0]*g48[iz+0];
s[689] = + g64[ix+0]*g14[iy+0]*g49[iz+0];
s[690] = + g65[ix+0]*g12[iy+0]*g50[iz+0];
s[691] = + g64[ix+0]*g13[iy+0]*g50[iz+0];
s[692] = + g64[ix+0]*g12[iy+0]*g51[iz+0];
s[693] = + g67[ix+0]*g8[iy+0]*g52[iz+0];
s[694] = + g66[ix+0]*g9[iy+0]*g52[iz+0];
s[695] = + g66[ix+0]*g8[iy+0]*g53[iz+0];
s[696] = + g65[ix+0]*g10[iy+0]*g52[iz+0];
s[697] = + g64[ix+0]*g11[iy+0]*g52[iz+0];
s[698] = + g64[ix+0]*g10[iy+0]*g53[iz+0];
s[699] = + g65[ix+0]*g8[iy+0]*g54[iz+0];
s[700] = + g64[ix+0]*g9[iy+0]*g54[iz+0];
s[701] = + g64[ix+0]*g8[iy+0]*g55[iz+0];
s[702] = + g71[ix+0]*g0[iy+0]*g56[iz+0];
s[703] = + g70[ix+0]*g1[iy+0]*g56[iz+0];
s[704] = + g70[ix+0]*g0[iy+0]*g57[iz+0];
s[705] = + g69[ix+0]*g2[iy+0]*g56[iz+0];
s[706] = + g68[ix+0]*g3[iy+0]*g56[iz+0];
s[707] = + g68[ix+0]*g2[iy+0]*g57[iz+0];
s[708] = + g69[ix+0]*g0[iy+0]*g58[iz+0];
s[709] = + g68[ix+0]*g1[iy+0]*g58[iz+0];
s[710] = + g68[ix+0]*g0[iy+0]*g59[iz+0];
s[711] = + g67[ix+0]*g4[iy+0]*g56[iz+0];
s[712] = + g66[ix+0]*g5[iy+0]*g56[iz+0];
s[713] = + g66[ix+0]*g4[iy+0]*g57[iz+0];
s[714] = + g65[ix+0]*g6[iy+0]*g56[iz+0];
s[715] = + g64[ix+0]*g7[iy+0]*g56[iz+0];
s[716] = + g64[ix+0]*g6[iy+0]*g57[iz+0];
s[717] = + g65[ix+0]*g4[iy+0]*g58[iz+0];
s[718] = + g64[ix+0]*g5[iy+0]*g58[iz+0];
s[719] = + g64[ix+0]*g4[iy+0]*g59[iz+0];
s[720] = + g67[ix+0]*g0[iy+0]*g60[iz+0];
s[721] = + g66[ix+0]*g1[iy+0]*g60[iz+0];
s[722] = + g66[ix+0]*g0[iy+0]*g61[iz+0];
s[723] = + g65[ix+0]*g2[iy+0]*g60[iz+0];
s[724] = + g64[ix+0]*g3[iy+0]*g60[iz+0];
s[725] = + g64[ix+0]*g2[iy+0]*g61[iz+0];
s[726] = + g65[ix+0]*g0[iy+0]*g62[iz+0];
s[727] = + g64[ix+0]*g1[iy+0]*g62[iz+0];
s[728] = + g64[ix+0]*g0[iy+0]*g63[iz+0];
s[729] = + g63[ix+0]*g64[iy+0]*g0[iz+0];
s[730] = + g62[ix+0]*g65[iy+0]*g0[iz+0];
s[731] = + g62[ix+0]*g64[iy+0]*g1[iz+0];
s[732] = + g61[ix+0]*g66[iy+0]*g0[iz+0];
s[733] = + g60[ix+0]*g67[iy+0]*g0[iz+0];
s[734] = + g60[ix+0]*g66[iy+0]*g1[iz+0];
s[735] = + g61[ix+0]*g64[iy+0]*g2[iz+0];
s[736] = + g60[ix+0]*g65[iy+0]*g2[iz+0];
s[737] = + g60[ix+0]*g64[iy+0]*g3[iz+0];
s[738] = + g59[ix+0]*g68[iy+0]*g0[iz+0];
s[739] = + g58[ix+0]*g69[iy+0]*g0[iz+0];
s[740] = + g58[ix+0]*g68[iy+0]*g1[iz+0];
s[741] = + g57[ix+0]*g70[iy+0]*g0[iz+0];
s[742] = + g56[ix+0]*g71[iy+0]*g0[iz+0];
s[743] = + g56[ix+0]*g70[iy+0]*g1[iz+0];
s[744] = + g57[ix+0]*g68[iy+0]*g2[iz+0];
s[745] = + g56[ix+0]*g69[iy+0]*g2[iz+0];
s[746] = + g56[ix+0]*g68[iy+0]*g3[iz+0];
s[747] = + g59[ix+0]*g64[iy+0]*g4[iz+0];
s[748] = + g58[ix+0]*g65[iy+0]*g4[iz+0];
s[749] = + g58[ix+0]*g64[iy+0]*g5[iz+0];
s[750] = + g57[ix+0]*g66[iy+0]*g4[iz+0];
s[751] = + g56[ix+0]*g67[iy+0]*g4[iz+0];
s[752] = + g56[ix+0]*g66[iy+0]*g5[iz+0];
s[753] = + g57[ix+0]*g64[iy+0]*g6[iz+0];
s[754] = + g56[ix+0]*g65[iy+0]*g6[iz+0];
s[755] = + g56[ix+0]*g64[iy+0]*g7[iz+0];
s[756] = + g55[ix+0]*g72[iy+0]*g0[iz+0];
s[757] = + g54[ix+0]*g73[iy+0]*g0[iz+0];
s[758] = + g54[ix+0]*g72[iy+0]*g1[iz+0];
s[759] = + g53[ix+0]*g74[iy+0]*g0[iz+0];
s[760] = + g52[ix+0]*g75[iy+0]*g0[iz+0];
s[761] = + g52[ix+0]*g74[iy+0]*g1[iz+0];
s[762] = + g53[ix+0]*g72[iy+0]*g2[iz+0];
s[763] = + g52[ix+0]*g73[iy+0]*g2[iz+0];
s[764] = + g52[ix+0]*g72[iy+0]*g3[iz+0];
s[765] = + g51[ix+0]*g76[iy+0]*g0[iz+0];
s[766] = + g50[ix+0]*g77[iy+0]*g0[iz+0];
s[767] = + g50[ix+0]*g76[iy+0]*g1[iz+0];
s[768] = + g49[ix+0]*g78[iy+0]*g0[iz+0];
s[769] = + g48[ix+0]*g79[iy+0]*g0[iz+0];
s[770] = + g48[ix+0]*g78[iy+0]*g1[iz+0];
s[771] = + g49[ix+0]*g76[iy+0]*g2[iz+0];
s[772] = + g48[ix+0]*g77[iy+0]*g2[iz+0];
s[773] = + g48[ix+0]*g76[iy+0]*g3[iz+0];
s[774] = + g51[ix+0]*g72[iy+0]*g4[iz+0];
s[775] = + g50[ix+0]*g73[iy+0]*g4[iz+0];
s[776] = + g50[ix+0]*g72[iy+0]*g5[iz+0];
s[777] = + g49[ix+0]*g74[iy+0]*g4[iz+0];
s[778] = + g48[ix+0]*g75[iy+0]*g4[iz+0];
s[779] = + g48[ix+0]*g74[iy+0]*g5[iz+0];
s[780] = + g49[ix+0]*g72[iy+0]*g6[iz+0];
s[781] = + g48[ix+0]*g73[iy+0]*g6[iz+0];
s[782] = + g48[ix+0]*g72[iy+0]*g7[iz+0];
s[783] = + g55[ix+0]*g64[iy+0]*g8[iz+0];
s[784] = + g54[ix+0]*g65[iy+0]*g8[iz+0];
s[785] = + g54[ix+0]*g64[iy+0]*g9[iz+0];
s[786] = + g53[ix+0]*g66[iy+0]*g8[iz+0];
s[787] = + g52[ix+0]*g67[iy+0]*g8[iz+0];
s[788] = + g52[ix+0]*g66[iy+0]*g9[iz+0];
s[789] = + g53[ix+0]*g64[iy+0]*g10[iz+0];
s[790] = + g52[ix+0]*g65[iy+0]*g10[iz+0];
s[791] = + g52[ix+0]*g64[iy+0]*g11[iz+0];
s[792] = + g51[ix+0]*g68[iy+0]*g8[iz+0];
s[793] = + g50[ix+0]*g69[iy+0]*g8[iz+0];
s[794] = + g50[ix+0]*g68[iy+0]*g9[iz+0];
s[795] = + g49[ix+0]*g70[iy+0]*g8[iz+0];
s[796] = + g48[ix+0]*g71[iy+0]*g8[iz+0];
s[797] = + g48[ix+0]*g70[iy+0]*g9[iz+0];
s[798] = + g49[ix+0]*g68[iy+0]*g10[iz+0];
s[799] = + g48[ix+0]*g69[iy+0]*g10[iz+0];
s[800] = + g48[ix+0]*g68[iy+0]*g11[iz+0];
s[801] = + g51[ix+0]*g64[iy+0]*g12[iz+0];
s[802] = + g50[ix+0]*g65[iy+0]*g12[iz+0];
s[803] = + g50[ix+0]*g64[iy+0]*g13[iz+0];
s[804] = + g49[ix+0]*g66[iy+0]*g12[iz+0];
s[805] = + g48[ix+0]*g67[iy+0]*g12[iz+0];
s[806] = + g48[ix+0]*g66[iy+0]*g13[iz+0];
s[807] = + g49[ix+0]*g64[iy+0]*g14[iz+0];
s[808] = + g48[ix+0]*g65[iy+0]*g14[iz+0];
s[809] = + g48[ix+0]*g64[iy+0]*g15[iz+0];
s[810] = + g47[ix+0]*g80[iy+0]*g0[iz+0];
s[811] = + g46[ix+0]*g81[iy+0]*g0[iz+0];
s[812] = + g46[ix+0]*g80[iy+0]*g1[iz+0];
s[813] = + g45[ix+0]*g82[iy+0]*g0[iz+0];
s[814] = + g44[ix+0]*g83[iy+0]*g0[iz+0];
s[815] = + g44[ix+0]*g82[iy+0]*g1[iz+0];
s[816] = + g45[ix+0]*g80[iy+0]*g2[iz+0];
s[817] = + g44[ix+0]*g81[iy+0]*g2[iz+0];
s[818] = + g44[ix+0]*g80[iy+0]*g3[iz+0];
s[819] = + g43[ix+0]*g84[iy+0]*g0[iz+0];
s[820] = + g42[ix+0]*g85[iy+0]*g0[iz+0];
s[821] = + g42[ix+0]*g84[iy+0]*g1[iz+0];
s[822] = + g41[ix+0]*g86[iy+0]*g0[iz+0];
s[823] = + g40[ix+0]*g87[iy+0]*g0[iz+0];
s[824] = + g40[ix+0]*g86[iy+0]*g1[iz+0];
s[825] = + g41[ix+0]*g84[iy+0]*g2[iz+0];
s[826] = + g40[ix+0]*g85[iy+0]*g2[iz+0];
s[827] = + g40[ix+0]*g84[iy+0]*g3[iz+0];
s[828] = + g43[ix+0]*g80[iy+0]*g4[iz+0];
s[829] = + g42[ix+0]*g81[iy+0]*g4[iz+0];
s[830] = + g42[ix+0]*g80[iy+0]*g5[iz+0];
s[831] = + g41[ix+0]*g82[iy+0]*g4[iz+0];
s[832] = + g40[ix+0]*g83[iy+0]*g4[iz+0];
s[833] = + g40[ix+0]*g82[iy+0]*g5[iz+0];
s[834] = + g41[ix+0]*g80[iy+0]*g6[iz+0];
s[835] = + g40[ix+0]*g81[iy+0]*g6[iz+0];
s[836] = + g40[ix+0]*g80[iy+0]*g7[iz+0];
s[837] = + g39[ix+0]*g88[iy+0]*g0[iz+0];
s[838] = + g38[ix+0]*g89[iy+0]*g0[iz+0];
s[839] = + g38[ix+0]*g88[iy+0]*g1[iz+0];
s[840] = + g37[ix+0]*g90[iy+0]*g0[iz+0];
s[841] = + g36[ix+0]*g91[iy+0]*g0[iz+0];
s[842] = + g36[ix+0]*g90[iy+0]*g1[iz+0];
s[843] = + g37[ix+0]*g88[iy+0]*g2[iz+0];
s[844] = + g36[ix+0]*g89[iy+0]*g2[iz+0];
s[845] = + g36[ix+0]*g88[iy+0]*g3[iz+0];
s[846] = + g35[ix+0]*g92[iy+0]*g0[iz+0];
s[847] = + g34[ix+0]*g93[iy+0]*g0[iz+0];
s[848] = + g34[ix+0]*g92[iy+0]*g1[iz+0];
s[849] = + g33[ix+0]*g94[iy+0]*g0[iz+0];
s[850] = + g32[ix+0]*g95[iy+0]*g0[iz+0];
s[851] = + g32[ix+0]*g94[iy+0]*g1[iz+0];
s[852] = + g33[ix+0]*g92[iy+0]*g2[iz+0];
s[853] = + g32[ix+0]*g93[iy+0]*g2[iz+0];
s[854] = + g32[ix+0]*g92[iy+0]*g3[iz+0];
s[855] = + g35[ix+0]*g88[iy+0]*g4[iz+0];
s[856] = + g34[ix+0]*g89[iy+0]*g4[iz+0];
s[857] = + g34[ix+0]*g88[iy+0]*g5[iz+0];
s[858] = + g33[ix+0]*g90[iy+0]*g4[iz+0];
s[859] = + g32[ix+0]*g91[iy+0]*g4[iz+0];
s[860] = + g32[ix+0]*g90[iy+0]*g5[iz+0];
s[861] = + g33[ix+0]*g88[iy+0]*g6[iz+0];
s[862] = + g32[ix+0]*g89[iy+0]*g6[iz+0];
s[863] = + g32[ix+0]*g88[iy+0]*g7[iz+0];
s[864] = + g39[ix+0]*g80[iy+0]*g8[iz+0];
s[865] = + g38[ix+0]*g81[iy+0]*g8[iz+0];
s[866] = + g38[ix+0]*g80[iy+0]*g9[iz+0];
s[867] = + g37[ix+0]*g82[iy+0]*g8[iz+0];
s[868] = + g36[ix+0]*g83[iy+0]*g8[iz+0];
s[869] = + g36[ix+0]*g82[iy+0]*g9[iz+0];
s[870] = + g37[ix+0]*g80[iy+0]*g10[iz+0];
s[871] = + g36[ix+0]*g81[iy+0]*g10[iz+0];
s[872] = + g36[ix+0]*g80[iy+0]*g11[iz+0];
s[873] = + g35[ix+0]*g84[iy+0]*g8[iz+0];
s[874] = + g34[ix+0]*g85[iy+0]*g8[iz+0];
s[875] = + g34[ix+0]*g84[iy+0]*g9[iz+0];
s[876] = + g33[ix+0]*g86[iy+0]*g8[iz+0];
s[877] = + g32[ix+0]*g87[iy+0]*g8[iz+0];
s[878] = + g32[ix+0]*g86[iy+0]*g9[iz+0];
s[879] = + g33[ix+0]*g84[iy+0]*g10[iz+0];
s[880] = + g32[ix+0]*g85[iy+0]*g10[iz+0];
s[881] = + g32[ix+0]*g84[iy+0]*g11[iz+0];
s[882] = + g35[ix+0]*g80[iy+0]*g12[iz+0];
s[883] = + g34[ix+0]*g81[iy+0]*g12[iz+0];
s[884] = + g34[ix+0]*g80[iy+0]*g13[iz+0];
s[885] = + g33[ix+0]*g82[iy+0]*g12[iz+0];
s[886] = + g32[ix+0]*g83[iy+0]*g12[iz+0];
s[887] = + g32[ix+0]*g82[iy+0]*g13[iz+0];
s[888] = + g33[ix+0]*g80[iy+0]*g14[iz+0];
s[889] = + g32[ix+0]*g81[iy+0]*g14[iz+0];
s[890] = + g32[ix+0]*g80[iy+0]*g15[iz+0];
s[891] = + g47[ix+0]*g64[iy+0]*g16[iz+0];
s[892] = + g46[ix+0]*g65[iy+0]*g16[iz+0];
s[893] = + g46[ix+0]*g64[iy+0]*g17[iz+0];
s[894] = + g45[ix+0]*g66[iy+0]*g16[iz+0];
s[895] = + g44[ix+0]*g67[iy+0]*g16[iz+0];
s[896] = + g44[ix+0]*g66[iy+0]*g17[iz+0];
s[897] = + g45[ix+0]*g64[iy+0]*g18[iz+0];
s[898] = + g44[ix+0]*g65[iy+0]*g18[iz+0];
s[899] = + g44[ix+0]*g64[iy+0]*g19[iz+0];
s[900] = + g43[ix+0]*g68[iy+0]*g16[iz+0];
s[901] = + g42[ix+0]*g69[iy+0]*g16[iz+0];
s[902] = + g42[ix+0]*g68[iy+0]*g17[iz+0];
s[903] = + g41[ix+0]*g70[iy+0]*g16[iz+0];
s[904] = + g40[ix+0]*g71[iy+0]*g16[iz+0];
s[905] = + g40[ix+0]*g70[iy+0]*g17[iz+0];
s[906] = + g41[ix+0]*g68[iy+0]*g18[iz+0];
s[907] = + g40[ix+0]*g69[iy+0]*g18[iz+0];
s[908] = + g40[ix+0]*g68[iy+0]*g19[iz+0];
s[909] = + g43[ix+0]*g64[iy+0]*g20[iz+0];
s[910] = + g42[ix+0]*g65[iy+0]*g20[iz+0];
s[911] = + g42[ix+0]*g64[iy+0]*g21[iz+0];
s[912] = + g41[ix+0]*g66[iy+0]*g20[iz+0];
s[913] = + g40[ix+0]*g67[iy+0]*g20[iz+0];
s[914] = + g40[ix+0]*g66[iy+0]*g21[iz+0];
s[915] = + g41[ix+0]*g64[iy+0]*g22[iz+0];
s[916] = + g40[ix+0]*g65[iy+0]*g22[iz+0];
s[917] = + g40[ix+0]*g64[iy+0]*g23[iz+0];
s[918] = + g39[ix+0]*g72[iy+0]*g16[iz+0];
s[919] = + g38[ix+0]*g73[iy+0]*g16[iz+0];
s[920] = + g38[ix+0]*g72[iy+0]*g17[iz+0];
s[921] = + g37[ix+0]*g74[iy+0]*g16[iz+0];
s[922] = + g36[ix+0]*g75[iy+0]*g16[iz+0];
s[923] = + g36[ix+0]*g74[iy+0]*g17[iz+0];
s[924] = + g37[ix+0]*g72[iy+0]*g18[iz+0];
s[925] = + g36[ix+0]*g73[iy+0]*g18[iz+0];
s[926] = + g36[ix+0]*g72[iy+0]*g19[iz+0];
s[927] = + g35[ix+0]*g76[iy+0]*g16[iz+0];
s[928] = + g34[ix+0]*g77[iy+0]*g16[iz+0];
s[929] = + g34[ix+0]*g76[iy+0]*g17[iz+0];
s[930] = + g33[ix+0]*g78[iy+0]*g16[iz+0];
s[931] = + g32[ix+0]*g79[iy+0]*g16[iz+0];
s[932] = + g32[ix+0]*g78[iy+0]*g17[iz+0];
s[933] = + g33[ix+0]*g76[iy+0]*g18[iz+0];
s[934] = + g32[ix+0]*g77[iy+0]*g18[iz+0];
s[935] = + g32[ix+0]*g76[iy+0]*g19[iz+0];
s[936] = + g35[ix+0]*g72[iy+0]*g20[iz+0];
s[937] = + g34[ix+0]*g73[iy+0]*g20[iz+0];
s[938] = + g34[ix+0]*g72[iy+0]*g21[iz+0];
s[939] = + g33[ix+0]*g74[iy+0]*g20[iz+0];
s[940] = + g32[ix+0]*g75[iy+0]*g20[iz+0];
s[941] = + g32[ix+0]*g74[iy+0]*g21[iz+0];
s[942] = + g33[ix+0]*g72[iy+0]*g22[iz+0];
s[943] = + g32[ix+0]*g73[iy+0]*g22[iz+0];
s[944] = + g32[ix+0]*g72[iy+0]*g23[iz+0];
s[945] = + g39[ix+0]*g64[iy+0]*g24[iz+0];
s[946] = + g38[ix+0]*g65[iy+0]*g24[iz+0];
s[947] = + g38[ix+0]*g64[iy+0]*g25[iz+0];
s[948] = + g37[ix+0]*g66[iy+0]*g24[iz+0];
s[949] = + g36[ix+0]*g67[iy+0]*g24[iz+0];
s[950] = + g36[ix+0]*g66[iy+0]*g25[iz+0];
s[951] = + g37[ix+0]*g64[iy+0]*g26[iz+0];
s[952] = + g36[ix+0]*g65[iy+0]*g26[iz+0];
s[953] = + g36[ix+0]*g64[iy+0]*g27[iz+0];
s[954] = + g35[ix+0]*g68[iy+0]*g24[iz+0];
s[955] = + g34[ix+0]*g69[iy+0]*g24[iz+0];
s[956] = + g34[ix+0]*g68[iy+0]*g25[iz+0];
s[957] = + g33[ix+0]*g70[iy+0]*g24[iz+0];
s[958] = + g32[ix+0]*g71[iy+0]*g24[iz+0];
s[959] = + g32[ix+0]*g70[iy+0]*g25[iz+0];
s[960] = + g33[ix+0]*g68[iy+0]*g26[iz+0];
s[961] = + g32[ix+0]*g69[iy+0]*g26[iz+0];
s[962] = + g32[ix+0]*g68[iy+0]*g27[iz+0];
s[963] = + g35[ix+0]*g64[iy+0]*g28[iz+0];
s[964] = + g34[ix+0]*g65[iy+0]*g28[iz+0];
s[965] = + g34[ix+0]*g64[iy+0]*g29[iz+0];
s[966] = + g33[ix+0]*g66[iy+0]*g28[iz+0];
s[967] = + g32[ix+0]*g67[iy+0]*g28[iz+0];
s[968] = + g32[ix+0]*g66[iy+0]*g29[iz+0];
s[969] = + g33[ix+0]*g64[iy+0]*g30[iz+0];
s[970] = + g32[ix+0]*g65[iy+0]*g30[iz+0];
s[971] = + g32[ix+0]*g64[iy+0]*g31[iz+0];
s[972] = + g31[ix+0]*g96[iy+0]*g0[iz+0];
s[973] = + g30[ix+0]*g97[iy+0]*g0[iz+0];
s[974] = + g30[ix+0]*g96[iy+0]*g1[iz+0];
s[975] = + g29[ix+0]*g98[iy+0]*g0[iz+0];
s[976] = + g28[ix+0]*g99[iy+0]*g0[iz+0];
s[977] = + g28[ix+0]*g98[iy+0]*g1[iz+0];
s[978] = + g29[ix+0]*g96[iy+0]*g2[iz+0];
s[979] = + g28[ix+0]*g97[iy+0]*g2[iz+0];
s[980] = + g28[ix+0]*g96[iy+0]*g3[iz+0];
s[981] = + g27[ix+0]*g100[iy+0]*g0[iz+0];
s[982] = + g26[ix+0]*g101[iy+0]*g0[iz+0];
s[983] = + g26[ix+0]*g100[iy+0]*g1[iz+0];
s[984] = + g25[ix+0]*g102[iy+0]*g0[iz+0];
s[985] = + g24[ix+0]*g103[iy+0]*g0[iz+0];
s[986] = + g24[ix+0]*g102[iy+0]*g1[iz+0];
s[987] = + g25[ix+0]*g100[iy+0]*g2[iz+0];
s[988] = + g24[ix+0]*g101[iy+0]*g2[iz+0];
s[989] = + g24[ix+0]*g100[iy+0]*g3[iz+0];
s[990] = + g27[ix+0]*g96[iy+0]*g4[iz+0];
s[991] = + g26[ix+0]*g97[iy+0]*g4[iz+0];
s[992] = + g26[ix+0]*g96[iy+0]*g5[iz+0];
s[993] = + g25[ix+0]*g98[iy+0]*g4[iz+0];
s[994] = + g24[ix+0]*g99[iy+0]*g4[iz+0];
s[995] = + g24[ix+0]*g98[iy+0]*g5[iz+0];
s[996] = + g25[ix+0]*g96[iy+0]*g6[iz+0];
s[997] = + g24[ix+0]*g97[iy+0]*g6[iz+0];
s[998] = + g24[ix+0]*g96[iy+0]*g7[iz+0];
s[999] = + g23[ix+0]*g104[iy+0]*g0[iz+0];
s[1000] = + g22[ix+0]*g105[iy+0]*g0[iz+0];
s[1001] = + g22[ix+0]*g104[iy+0]*g1[iz+0];
s[1002] = + g21[ix+0]*g106[iy+0]*g0[iz+0];
s[1003] = + g20[ix+0]*g107[iy+0]*g0[iz+0];
s[1004] = + g20[ix+0]*g106[iy+0]*g1[iz+0];
s[1005] = + g21[ix+0]*g104[iy+0]*g2[iz+0];
s[1006] = + g20[ix+0]*g105[iy+0]*g2[iz+0];
s[1007] = + g20[ix+0]*g104[iy+0]*g3[iz+0];
s[1008] = + g19[ix+0]*g108[iy+0]*g0[iz+0];
s[1009] = + g18[ix+0]*g109[iy+0]*g0[iz+0];
s[1010] = + g18[ix+0]*g108[iy+0]*g1[iz+0];
s[1011] = + g17[ix+0]*g110[iy+0]*g0[iz+0];
s[1012] = + g16[ix+0]*g111[iy+0]*g0[iz+0];
s[1013] = + g16[ix+0]*g110[iy+0]*g1[iz+0];
s[1014] = + g17[ix+0]*g108[iy+0]*g2[iz+0];
s[1015] = + g16[ix+0]*g109[iy+0]*g2[iz+0];
s[1016] = + g16[ix+0]*g108[iy+0]*g3[iz+0];
s[1017] = + g19[ix+0]*g104[iy+0]*g4[iz+0];
s[1018] = + g18[ix+0]*g105[iy+0]*g4[iz+0];
s[1019] = + g18[ix+0]*g104[iy+0]*g5[iz+0];
s[1020] = + g17[ix+0]*g106[iy+0]*g4[iz+0];
s[1021] = + g16[ix+0]*g107[iy+0]*g4[iz+0];
s[1022] = + g16[ix+0]*g106[iy+0]*g5[iz+0];
s[1023] = + g17[ix+0]*g104[iy+0]*g6[iz+0];
s[1024] = + g16[ix+0]*g105[iy+0]*g6[iz+0];
s[1025] = + g16[ix+0]*g104[iy+0]*g7[iz+0];
s[1026] = + g23[ix+0]*g96[iy+0]*g8[iz+0];
s[1027] = + g22[ix+0]*g97[iy+0]*g8[iz+0];
s[1028] = + g22[ix+0]*g96[iy+0]*g9[iz+0];
s[1029] = + g21[ix+0]*g98[iy+0]*g8[iz+0];
s[1030] = + g20[ix+0]*g99[iy+0]*g8[iz+0];
s[1031] = + g20[ix+0]*g98[iy+0]*g9[iz+0];
s[1032] = + g21[ix+0]*g96[iy+0]*g10[iz+0];
s[1033] = + g20[ix+0]*g97[iy+0]*g10[iz+0];
s[1034] = + g20[ix+0]*g96[iy+0]*g11[iz+0];
s[1035] = + g19[ix+0]*g100[iy+0]*g8[iz+0];
s[1036] = + g18[ix+0]*g101[iy+0]*g8[iz+0];
s[1037] = + g18[ix+0]*g100[iy+0]*g9[iz+0];
s[1038] = + g17[ix+0]*g102[iy+0]*g8[iz+0];
s[1039] = + g16[ix+0]*g103[iy+0]*g8[iz+0];
s[1040] = + g16[ix+0]*g102[iy+0]*g9[iz+0];
s[1041] = + g17[ix+0]*g100[iy+0]*g10[iz+0];
s[1042] = + g16[ix+0]*g101[iy+0]*g10[iz+0];
s[1043] = + g16[ix+0]*g100[iy+0]*g11[iz+0];
s[1044] = + g19[ix+0]*g96[iy+0]*g12[iz+0];
s[1045] = + g18[ix+0]*g97[iy+0]*g12[iz+0];
s[1046] = + g18[ix+0]*g96[iy+0]*g13[iz+0];
s[1047] = + g17[ix+0]*g98[iy+0]*g12[iz+0];
s[1048] = + g16[ix+0]*g99[iy+0]*g12[iz+0];
s[1049] = + g16[ix+0]*g98[iy+0]*g13[iz+0];
s[1050] = + g17[ix+0]*g96[iy+0]*g14[iz+0];
s[1051] = + g16[ix+0]*g97[iy+0]*g14[iz+0];
s[1052] = + g16[ix+0]*g96[iy+0]*g15[iz+0];
s[1053] = + g15[ix+0]*g112[iy+0]*g0[iz+0];
s[1054] = + g14[ix+0]*g113[iy+0]*g0[iz+0];
s[1055] = + g14[ix+0]*g112[iy+0]*g1[iz+0];
s[1056] = + g13[ix+0]*g114[iy+0]*g0[iz+0];
s[1057] = + g12[ix+0]*g115[iy+0]*g0[iz+0];
s[1058] = + g12[ix+0]*g114[iy+0]*g1[iz+0];
s[1059] = + g13[ix+0]*g112[iy+0]*g2[iz+0];
s[1060] = + g12[ix+0]*g113[iy+0]*g2[iz+0];
s[1061] = + g12[ix+0]*g112[iy+0]*g3[iz+0];
s[1062] = + g11[ix+0]*g116[iy+0]*g0[iz+0];
s[1063] = + g10[ix+0]*g117[iy+0]*g0[iz+0];
s[1064] = + g10[ix+0]*g116[iy+0]*g1[iz+0];
s[1065] = + g9[ix+0]*g118[iy+0]*g0[iz+0];
s[1066] = + g8[ix+0]*g119[iy+0]*g0[iz+0];
s[1067] = + g8[ix+0]*g118[iy+0]*g1[iz+0];
s[1068] = + g9[ix+0]*g116[iy+0]*g2[iz+0];
s[1069] = + g8[ix+0]*g117[iy+0]*g2[iz+0];
s[1070] = + g8[ix+0]*g116[iy+0]*g3[iz+0];
s[1071] = + g11[ix+0]*g112[iy+0]*g4[iz+0];
s[1072] = + g10[ix+0]*g113[iy+0]*g4[iz+0];
s[1073] = + g10[ix+0]*g112[iy+0]*g5[iz+0];
s[1074] = + g9[ix+0]*g114[iy+0]*g4[iz+0];
s[1075] = + g8[ix+0]*g115[iy+0]*g4[iz+0];
s[1076] = + g8[ix+0]*g114[iy+0]*g5[iz+0];
s[1077] = + g9[ix+0]*g112[iy+0]*g6[iz+0];
s[1078] = + g8[ix+0]*g113[iy+0]*g6[iz+0];
s[1079] = + g8[ix+0]*g112[iy+0]*g7[iz+0];
s[1080] = + g7[ix+0]*g120[iy+0]*g0[iz+0];
s[1081] = + g6[ix+0]*g121[iy+0]*g0[iz+0];
s[1082] = + g6[ix+0]*g120[iy+0]*g1[iz+0];
s[1083] = + g5[ix+0]*g122[iy+0]*g0[iz+0];
s[1084] = + g4[ix+0]*g123[iy+0]*g0[iz+0];
s[1085] = + g4[ix+0]*g122[iy+0]*g1[iz+0];
s[1086] = + g5[ix+0]*g120[iy+0]*g2[iz+0];
s[1087] = + g4[ix+0]*g121[iy+0]*g2[iz+0];
s[1088] = + g4[ix+0]*g120[iy+0]*g3[iz+0];
s[1089] = + g3[ix+0]*g124[iy+0]*g0[iz+0];
s[1090] = + g2[ix+0]*g125[iy+0]*g0[iz+0];
s[1091] = + g2[ix+0]*g124[iy+0]*g1[iz+0];
s[1092] = + g1[ix+0]*g126[iy+0]*g0[iz+0];
s[1093] = + g0[ix+0]*g127[iy+0]*g0[iz+0];
s[1094] = + g0[ix+0]*g126[iy+0]*g1[iz+0];
s[1095] = + g1[ix+0]*g124[iy+0]*g2[iz+0];
s[1096] = + g0[ix+0]*g125[iy+0]*g2[iz+0];
s[1097] = + g0[ix+0]*g124[iy+0]*g3[iz+0];
s[1098] = + g3[ix+0]*g120[iy+0]*g4[iz+0];
s[1099] = + g2[ix+0]*g121[iy+0]*g4[iz+0];
s[1100] = + g2[ix+0]*g120[iy+0]*g5[iz+0];
s[1101] = + g1[ix+0]*g122[iy+0]*g4[iz+0];
s[1102] = + g0[ix+0]*g123[iy+0]*g4[iz+0];
s[1103] = + g0[ix+0]*g122[iy+0]*g5[iz+0];
s[1104] = + g1[ix+0]*g120[iy+0]*g6[iz+0];
s[1105] = + g0[ix+0]*g121[iy+0]*g6[iz+0];
s[1106] = + g0[ix+0]*g120[iy+0]*g7[iz+0];
s[1107] = + g7[ix+0]*g112[iy+0]*g8[iz+0];
s[1108] = + g6[ix+0]*g113[iy+0]*g8[iz+0];
s[1109] = + g6[ix+0]*g112[iy+0]*g9[iz+0];
s[1110] = + g5[ix+0]*g114[iy+0]*g8[iz+0];
s[1111] = + g4[ix+0]*g115[iy+0]*g8[iz+0];
s[1112] = + g4[ix+0]*g114[iy+0]*g9[iz+0];
s[1113] = + g5[ix+0]*g112[iy+0]*g10[iz+0];
s[1114] = + g4[ix+0]*g113[iy+0]*g10[iz+0];
s[1115] = + g4[ix+0]*g112[iy+0]*g11[iz+0];
s[1116] = + g3[ix+0]*g116[iy+0]*g8[iz+0];
s[1117] = + g2[ix+0]*g117[iy+0]*g8[iz+0];
s[1118] = + g2[ix+0]*g116[iy+0]*g9[iz+0];
s[1119] = + g1[ix+0]*g118[iy+0]*g8[iz+0];
s[1120] = + g0[ix+0]*g119[iy+0]*g8[iz+0];
s[1121] = + g0[ix+0]*g118[iy+0]*g9[iz+0];
s[1122] = + g1[ix+0]*g116[iy+0]*g10[iz+0];
s[1123] = + g0[ix+0]*g117[iy+0]*g10[iz+0];
s[1124] = + g0[ix+0]*g116[iy+0]*g11[iz+0];
s[1125] = + g3[ix+0]*g112[iy+0]*g12[iz+0];
s[1126] = + g2[ix+0]*g113[iy+0]*g12[iz+0];
s[1127] = + g2[ix+0]*g112[iy+0]*g13[iz+0];
s[1128] = + g1[ix+0]*g114[iy+0]*g12[iz+0];
s[1129] = + g0[ix+0]*g115[iy+0]*g12[iz+0];
s[1130] = + g0[ix+0]*g114[iy+0]*g13[iz+0];
s[1131] = + g1[ix+0]*g112[iy+0]*g14[iz+0];
s[1132] = + g0[ix+0]*g113[iy+0]*g14[iz+0];
s[1133] = + g0[ix+0]*g112[iy+0]*g15[iz+0];
s[1134] = + g15[ix+0]*g96[iy+0]*g16[iz+0];
s[1135] = + g14[ix+0]*g97[iy+0]*g16[iz+0];
s[1136] = + g14[ix+0]*g96[iy+0]*g17[iz+0];
s[1137] = + g13[ix+0]*g98[iy+0]*g16[iz+0];
s[1138] = + g12[ix+0]*g99[iy+0]*g16[iz+0];
s[1139] = + g12[ix+0]*g98[iy+0]*g17[iz+0];
s[1140] = + g13[ix+0]*g96[iy+0]*g18[iz+0];
s[1141] = + g12[ix+0]*g97[iy+0]*g18[iz+0];
s[1142] = + g12[ix+0]*g96[iy+0]*g19[iz+0];
s[1143] = + g11[ix+0]*g100[iy+0]*g16[iz+0];
s[1144] = + g10[ix+0]*g101[iy+0]*g16[iz+0];
s[1145] = + g10[ix+0]*g100[iy+0]*g17[iz+0];
s[1146] = + g9[ix+0]*g102[iy+0]*g16[iz+0];
s[1147] = + g8[ix+0]*g103[iy+0]*g16[iz+0];
s[1148] = + g8[ix+0]*g102[iy+0]*g17[iz+0];
s[1149] = + g9[ix+0]*g100[iy+0]*g18[iz+0];
s[1150] = + g8[ix+0]*g101[iy+0]*g18[iz+0];
s[1151] = + g8[ix+0]*g100[iy+0]*g19[iz+0];
s[1152] = + g11[ix+0]*g96[iy+0]*g20[iz+0];
s[1153] = + g10[ix+0]*g97[iy+0]*g20[iz+0];
s[1154] = + g10[ix+0]*g96[iy+0]*g21[iz+0];
s[1155] = + g9[ix+0]*g98[iy+0]*g20[iz+0];
s[1156] = + g8[ix+0]*g99[iy+0]*g20[iz+0];
s[1157] = + g8[ix+0]*g98[iy+0]*g21[iz+0];
s[1158] = + g9[ix+0]*g96[iy+0]*g22[iz+0];
s[1159] = + g8[ix+0]*g97[iy+0]*g22[iz+0];
s[1160] = + g8[ix+0]*g96[iy+0]*g23[iz+0];
s[1161] = + g7[ix+0]*g104[iy+0]*g16[iz+0];
s[1162] = + g6[ix+0]*g105[iy+0]*g16[iz+0];
s[1163] = + g6[ix+0]*g104[iy+0]*g17[iz+0];
s[1164] = + g5[ix+0]*g106[iy+0]*g16[iz+0];
s[1165] = + g4[ix+0]*g107[iy+0]*g16[iz+0];
s[1166] = + g4[ix+0]*g106[iy+0]*g17[iz+0];
s[1167] = + g5[ix+0]*g104[iy+0]*g18[iz+0];
s[1168] = + g4[ix+0]*g105[iy+0]*g18[iz+0];
s[1169] = + g4[ix+0]*g104[iy+0]*g19[iz+0];
s[1170] = + g3[ix+0]*g108[iy+0]*g16[iz+0];
s[1171] = + g2[ix+0]*g109[iy+0]*g16[iz+0];
s[1172] = + g2[ix+0]*g108[iy+0]*g17[iz+0];
s[1173] = + g1[ix+0]*g110[iy+0]*g16[iz+0];
s[1174] = + g0[ix+0]*g111[iy+0]*g16[iz+0];
s[1175] = + g0[ix+0]*g110[iy+0]*g17[iz+0];
s[1176] = + g1[ix+0]*g108[iy+0]*g18[iz+0];
s[1177] = + g0[ix+0]*g109[iy+0]*g18[iz+0];
s[1178] = + g0[ix+0]*g108[iy+0]*g19[iz+0];
s[1179] = + g3[ix+0]*g104[iy+0]*g20[iz+0];
s[1180] = + g2[ix+0]*g105[iy+0]*g20[iz+0];
s[1181] = + g2[ix+0]*g104[iy+0]*g21[iz+0];
s[1182] = + g1[ix+0]*g106[iy+0]*g20[iz+0];
s[1183] = + g0[ix+0]*g107[iy+0]*g20[iz+0];
s[1184] = + g0[ix+0]*g106[iy+0]*g21[iz+0];
s[1185] = + g1[ix+0]*g104[iy+0]*g22[iz+0];
s[1186] = + g0[ix+0]*g105[iy+0]*g22[iz+0];
s[1187] = + g0[ix+0]*g104[iy+0]*g23[iz+0];
s[1188] = + g7[ix+0]*g96[iy+0]*g24[iz+0];
s[1189] = + g6[ix+0]*g97[iy+0]*g24[iz+0];
s[1190] = + g6[ix+0]*g96[iy+0]*g25[iz+0];
s[1191] = + g5[ix+0]*g98[iy+0]*g24[iz+0];
s[1192] = + g4[ix+0]*g99[iy+0]*g24[iz+0];
s[1193] = + g4[ix+0]*g98[iy+0]*g25[iz+0];
s[1194] = + g5[ix+0]*g96[iy+0]*g26[iz+0];
s[1195] = + g4[ix+0]*g97[iy+0]*g26[iz+0];
s[1196] = + g4[ix+0]*g96[iy+0]*g27[iz+0];
s[1197] = + g3[ix+0]*g100[iy+0]*g24[iz+0];
s[1198] = + g2[ix+0]*g101[iy+0]*g24[iz+0];
s[1199] = + g2[ix+0]*g100[iy+0]*g25[iz+0];
s[1200] = + g1[ix+0]*g102[iy+0]*g24[iz+0];
s[1201] = + g0[ix+0]*g103[iy+0]*g24[iz+0];
s[1202] = + g0[ix+0]*g102[iy+0]*g25[iz+0];
s[1203] = + g1[ix+0]*g100[iy+0]*g26[iz+0];
s[1204] = + g0[ix+0]*g101[iy+0]*g26[iz+0];
s[1205] = + g0[ix+0]*g100[iy+0]*g27[iz+0];
s[1206] = + g3[ix+0]*g96[iy+0]*g28[iz+0];
s[1207] = + g2[ix+0]*g97[iy+0]*g28[iz+0];
s[1208] = + g2[ix+0]*g96[iy+0]*g29[iz+0];
s[1209] = + g1[ix+0]*g98[iy+0]*g28[iz+0];
s[1210] = + g0[ix+0]*g99[iy+0]*g28[iz+0];
s[1211] = + g0[ix+0]*g98[iy+0]*g29[iz+0];
s[1212] = + g1[ix+0]*g96[iy+0]*g30[iz+0];
s[1213] = + g0[ix+0]*g97[iy+0]*g30[iz+0];
s[1214] = + g0[ix+0]*g96[iy+0]*g31[iz+0];
s[1215] = + g31[ix+0]*g64[iy+0]*g32[iz+0];
s[1216] = + g30[ix+0]*g65[iy+0]*g32[iz+0];
s[1217] = + g30[ix+0]*g64[iy+0]*g33[iz+0];
s[1218] = + g29[ix+0]*g66[iy+0]*g32[iz+0];
s[1219] = + g28[ix+0]*g67[iy+0]*g32[iz+0];
s[1220] = + g28[ix+0]*g66[iy+0]*g33[iz+0];
s[1221] = + g29[ix+0]*g64[iy+0]*g34[iz+0];
s[1222] = + g28[ix+0]*g65[iy+0]*g34[iz+0];
s[1223] = + g28[ix+0]*g64[iy+0]*g35[iz+0];
s[1224] = + g27[ix+0]*g68[iy+0]*g32[iz+0];
s[1225] = + g26[ix+0]*g69[iy+0]*g32[iz+0];
s[1226] = + g26[ix+0]*g68[iy+0]*g33[iz+0];
s[1227] = + g25[ix+0]*g70[iy+0]*g32[iz+0];
s[1228] = + g24[ix+0]*g71[iy+0]*g32[iz+0];
s[1229] = + g24[ix+0]*g70[iy+0]*g33[iz+0];
s[1230] = + g25[ix+0]*g68[iy+0]*g34[iz+0];
s[1231] = + g24[ix+0]*g69[iy+0]*g34[iz+0];
s[1232] = + g24[ix+0]*g68[iy+0]*g35[iz+0];
s[1233] = + g27[ix+0]*g64[iy+0]*g36[iz+0];
s[1234] = + g26[ix+0]*g65[iy+0]*g36[iz+0];
s[1235] = + g26[ix+0]*g64[iy+0]*g37[iz+0];
s[1236] = + g25[ix+0]*g66[iy+0]*g36[iz+0];
s[1237] = + g24[ix+0]*g67[iy+0]*g36[iz+0];
s[1238] = + g24[ix+0]*g66[iy+0]*g37[iz+0];
s[1239] = + g25[ix+0]*g64[iy+0]*g38[iz+0];
s[1240] = + g24[ix+0]*g65[iy+0]*g38[iz+0];
s[1241] = + g24[ix+0]*g64[iy+0]*g39[iz+0];
s[1242] = + g23[ix+0]*g72[iy+0]*g32[iz+0];
s[1243] = + g22[ix+0]*g73[iy+0]*g32[iz+0];
s[1244] = + g22[ix+0]*g72[iy+0]*g33[iz+0];
s[1245] = + g21[ix+0]*g74[iy+0]*g32[iz+0];
s[1246] = + g20[ix+0]*g75[iy+0]*g32[iz+0];
s[1247] = + g20[ix+0]*g74[iy+0]*g33[iz+0];
s[1248] = + g21[ix+0]*g72[iy+0]*g34[iz+0];
s[1249] = + g20[ix+0]*g73[iy+0]*g34[iz+0];
s[1250] = + g20[ix+0]*g72[iy+0]*g35[iz+0];
s[1251] = + g19[ix+0]*g76[iy+0]*g32[iz+0];
s[1252] = + g18[ix+0]*g77[iy+0]*g32[iz+0];
s[1253] = + g18[ix+0]*g76[iy+0]*g33[iz+0];
s[1254] = + g17[ix+0]*g78[iy+0]*g32[iz+0];
s[1255] = + g16[ix+0]*g79[iy+0]*g32[iz+0];
s[1256] = + g16[ix+0]*g78[iy+0]*g33[iz+0];
s[1257] = + g17[ix+0]*g76[iy+0]*g34[iz+0];
s[1258] = + g16[ix+0]*g77[iy+0]*g34[iz+0];
s[1259] = + g16[ix+0]*g76[iy+0]*g35[iz+0];
s[1260] = + g19[ix+0]*g72[iy+0]*g36[iz+0];
s[1261] = + g18[ix+0]*g73[iy+0]*g36[iz+0];
s[1262] = + g18[ix+0]*g72[iy+0]*g37[iz+0];
s[1263] = + g17[ix+0]*g74[iy+0]*g36[iz+0];
s[1264] = + g16[ix+0]*g75[iy+0]*g36[iz+0];
s[1265] = + g16[ix+0]*g74[iy+0]*g37[iz+0];
s[1266] = + g17[ix+0]*g72[iy+0]*g38[iz+0];
s[1267] = + g16[ix+0]*g73[iy+0]*g38[iz+0];
s[1268] = + g16[ix+0]*g72[iy+0]*g39[iz+0];
s[1269] = + g23[ix+0]*g64[iy+0]*g40[iz+0];
s[1270] = + g22[ix+0]*g65[iy+0]*g40[iz+0];
s[1271] = + g22[ix+0]*g64[iy+0]*g41[iz+0];
s[1272] = + g21[ix+0]*g66[iy+0]*g40[iz+0];
s[1273] = + g20[ix+0]*g67[iy+0]*g40[iz+0];
s[1274] = + g20[ix+0]*g66[iy+0]*g41[iz+0];
s[1275] = + g21[ix+0]*g64[iy+0]*g42[iz+0];
s[1276] = + g20[ix+0]*g65[iy+0]*g42[iz+0];
s[1277] = + g20[ix+0]*g64[iy+0]*g43[iz+0];
s[1278] = + g19[ix+0]*g68[iy+0]*g40[iz+0];
s[1279] = + g18[ix+0]*g69[iy+0]*g40[iz+0];
s[1280] = + g18[ix+0]*g68[iy+0]*g41[iz+0];
s[1281] = + g17[ix+0]*g70[iy+0]*g40[iz+0];
s[1282] = + g16[ix+0]*g71[iy+0]*g40[iz+0];
s[1283] = + g16[ix+0]*g70[iy+0]*g41[iz+0];
s[1284] = + g17[ix+0]*g68[iy+0]*g42[iz+0];
s[1285] = + g16[ix+0]*g69[iy+0]*g42[iz+0];
s[1286] = + g16[ix+0]*g68[iy+0]*g43[iz+0];
s[1287] = + g19[ix+0]*g64[iy+0]*g44[iz+0];
s[1288] = + g18[ix+0]*g65[iy+0]*g44[iz+0];
s[1289] = + g18[ix+0]*g64[iy+0]*g45[iz+0];
s[1290] = + g17[ix+0]*g66[iy+0]*g44[iz+0];
s[1291] = + g16[ix+0]*g67[iy+0]*g44[iz+0];
s[1292] = + g16[ix+0]*g66[iy+0]*g45[iz+0];
s[1293] = + g17[ix+0]*g64[iy+0]*g46[iz+0];
s[1294] = + g16[ix+0]*g65[iy+0]*g46[iz+0];
s[1295] = + g16[ix+0]*g64[iy+0]*g47[iz+0];
s[1296] = + g15[ix+0]*g80[iy+0]*g32[iz+0];
s[1297] = + g14[ix+0]*g81[iy+0]*g32[iz+0];
s[1298] = + g14[ix+0]*g80[iy+0]*g33[iz+0];
s[1299] = + g13[ix+0]*g82[iy+0]*g32[iz+0];
s[1300] = + g12[ix+0]*g83[iy+0]*g32[iz+0];
s[1301] = + g12[ix+0]*g82[iy+0]*g33[iz+0];
s[1302] = + g13[ix+0]*g80[iy+0]*g34[iz+0];
s[1303] = + g12[ix+0]*g81[iy+0]*g34[iz+0];
s[1304] = + g12[ix+0]*g80[iy+0]*g35[iz+0];
s[1305] = + g11[ix+0]*g84[iy+0]*g32[iz+0];
s[1306] = + g10[ix+0]*g85[iy+0]*g32[iz+0];
s[1307] = + g10[ix+0]*g84[iy+0]*g33[iz+0];
s[1308] = + g9[ix+0]*g86[iy+0]*g32[iz+0];
s[1309] = + g8[ix+0]*g87[iy+0]*g32[iz+0];
s[1310] = + g8[ix+0]*g86[iy+0]*g33[iz+0];
s[1311] = + g9[ix+0]*g84[iy+0]*g34[iz+0];
s[1312] = + g8[ix+0]*g85[iy+0]*g34[iz+0];
s[1313] = + g8[ix+0]*g84[iy+0]*g35[iz+0];
s[1314] = + g11[ix+0]*g80[iy+0]*g36[iz+0];
s[1315] = + g10[ix+0]*g81[iy+0]*g36[iz+0];
s[1316] = + g10[ix+0]*g80[iy+0]*g37[iz+0];
s[1317] = + g9[ix+0]*g82[iy+0]*g36[iz+0];
s[1318] = + g8[ix+0]*g83[iy+0]*g36[iz+0];
s[1319] = + g8[ix+0]*g82[iy+0]*g37[iz+0];
s[1320] = + g9[ix+0]*g80[iy+0]*g38[iz+0];
s[1321] = + g8[ix+0]*g81[iy+0]*g38[iz+0];
s[1322] = + g8[ix+0]*g80[iy+0]*g39[iz+0];
s[1323] = + g7[ix+0]*g88[iy+0]*g32[iz+0];
s[1324] = + g6[ix+0]*g89[iy+0]*g32[iz+0];
s[1325] = + g6[ix+0]*g88[iy+0]*g33[iz+0];
s[1326] = + g5[ix+0]*g90[iy+0]*g32[iz+0];
s[1327] = + g4[ix+0]*g91[iy+0]*g32[iz+0];
s[1328] = + g4[ix+0]*g90[iy+0]*g33[iz+0];
s[1329] = + g5[ix+0]*g88[iy+0]*g34[iz+0];
s[1330] = + g4[ix+0]*g89[iy+0]*g34[iz+0];
s[1331] = + g4[ix+0]*g88[iy+0]*g35[iz+0];
s[1332] = + g3[ix+0]*g92[iy+0]*g32[iz+0];
s[1333] = + g2[ix+0]*g93[iy+0]*g32[iz+0];
s[1334] = + g2[ix+0]*g92[iy+0]*g33[iz+0];
s[1335] = + g1[ix+0]*g94[iy+0]*g32[iz+0];
s[1336] = + g0[ix+0]*g95[iy+0]*g32[iz+0];
s[1337] = + g0[ix+0]*g94[iy+0]*g33[iz+0];
s[1338] = + g1[ix+0]*g92[iy+0]*g34[iz+0];
s[1339] = + g0[ix+0]*g93[iy+0]*g34[iz+0];
s[1340] = + g0[ix+0]*g92[iy+0]*g35[iz+0];
s[1341] = + g3[ix+0]*g88[iy+0]*g36[iz+0];
s[1342] = + g2[ix+0]*g89[iy+0]*g36[iz+0];
s[1343] = + g2[ix+0]*g88[iy+0]*g37[iz+0];
s[1344] = + g1[ix+0]*g90[iy+0]*g36[iz+0];
s[1345] = + g0[ix+0]*g91[iy+0]*g36[iz+0];
s[1346] = + g0[ix+0]*g90[iy+0]*g37[iz+0];
s[1347] = + g1[ix+0]*g88[iy+0]*g38[iz+0];
s[1348] = + g0[ix+0]*g89[iy+0]*g38[iz+0];
s[1349] = + g0[ix+0]*g88[iy+0]*g39[iz+0];
s[1350] = + g7[ix+0]*g80[iy+0]*g40[iz+0];
s[1351] = + g6[ix+0]*g81[iy+0]*g40[iz+0];
s[1352] = + g6[ix+0]*g80[iy+0]*g41[iz+0];
s[1353] = + g5[ix+0]*g82[iy+0]*g40[iz+0];
s[1354] = + g4[ix+0]*g83[iy+0]*g40[iz+0];
s[1355] = + g4[ix+0]*g82[iy+0]*g41[iz+0];
s[1356] = + g5[ix+0]*g80[iy+0]*g42[iz+0];
s[1357] = + g4[ix+0]*g81[iy+0]*g42[iz+0];
s[1358] = + g4[ix+0]*g80[iy+0]*g43[iz+0];
s[1359] = + g3[ix+0]*g84[iy+0]*g40[iz+0];
s[1360] = + g2[ix+0]*g85[iy+0]*g40[iz+0];
s[1361] = + g2[ix+0]*g84[iy+0]*g41[iz+0];
s[1362] = + g1[ix+0]*g86[iy+0]*g40[iz+0];
s[1363] = + g0[ix+0]*g87[iy+0]*g40[iz+0];
s[1364] = + g0[ix+0]*g86[iy+0]*g41[iz+0];
s[1365] = + g1[ix+0]*g84[iy+0]*g42[iz+0];
s[1366] = + g0[ix+0]*g85[iy+0]*g42[iz+0];
s[1367] = + g0[ix+0]*g84[iy+0]*g43[iz+0];
s[1368] = + g3[ix+0]*g80[iy+0]*g44[iz+0];
s[1369] = + g2[ix+0]*g81[iy+0]*g44[iz+0];
s[1370] = + g2[ix+0]*g80[iy+0]*g45[iz+0];
s[1371] = + g1[ix+0]*g82[iy+0]*g44[iz+0];
s[1372] = + g0[ix+0]*g83[iy+0]*g44[iz+0];
s[1373] = + g0[ix+0]*g82[iy+0]*g45[iz+0];
s[1374] = + g1[ix+0]*g80[iy+0]*g46[iz+0];
s[1375] = + g0[ix+0]*g81[iy+0]*g46[iz+0];
s[1376] = + g0[ix+0]*g80[iy+0]*g47[iz+0];
s[1377] = + g15[ix+0]*g64[iy+0]*g48[iz+0];
s[1378] = + g14[ix+0]*g65[iy+0]*g48[iz+0];
s[1379] = + g14[ix+0]*g64[iy+0]*g49[iz+0];
s[1380] = + g13[ix+0]*g66[iy+0]*g48[iz+0];
s[1381] = + g12[ix+0]*g67[iy+0]*g48[iz+0];
s[1382] = + g12[ix+0]*g66[iy+0]*g49[iz+0];
s[1383] = + g13[ix+0]*g64[iy+0]*g50[iz+0];
s[1384] = + g12[ix+0]*g65[iy+0]*g50[iz+0];
s[1385] = + g12[ix+0]*g64[iy+0]*g51[iz+0];
s[1386] = + g11[ix+0]*g68[iy+0]*g48[iz+0];
s[1387] = + g10[ix+0]*g69[iy+0]*g48[iz+0];
s[1388] = + g10[ix+0]*g68[iy+0]*g49[iz+0];
s[1389] = + g9[ix+0]*g70[iy+0]*g48[iz+0];
s[1390] = + g8[ix+0]*g71[iy+0]*g48[iz+0];
s[1391] = + g8[ix+0]*g70[iy+0]*g49[iz+0];
s[1392] = + g9[ix+0]*g68[iy+0]*g50[iz+0];
s[1393] = + g8[ix+0]*g69[iy+0]*g50[iz+0];
s[1394] = + g8[ix+0]*g68[iy+0]*g51[iz+0];
s[1395] = + g11[ix+0]*g64[iy+0]*g52[iz+0];
s[1396] = + g10[ix+0]*g65[iy+0]*g52[iz+0];
s[1397] = + g10[ix+0]*g64[iy+0]*g53[iz+0];
s[1398] = + g9[ix+0]*g66[iy+0]*g52[iz+0];
s[1399] = + g8[ix+0]*g67[iy+0]*g52[iz+0];
s[1400] = + g8[ix+0]*g66[iy+0]*g53[iz+0];
s[1401] = + g9[ix+0]*g64[iy+0]*g54[iz+0];
s[1402] = + g8[ix+0]*g65[iy+0]*g54[iz+0];
s[1403] = + g8[ix+0]*g64[iy+0]*g55[iz+0];
s[1404] = + g7[ix+0]*g72[iy+0]*g48[iz+0];
s[1405] = + g6[ix+0]*g73[iy+0]*g48[iz+0];
s[1406] = + g6[ix+0]*g72[iy+0]*g49[iz+0];
s[1407] = + g5[ix+0]*g74[iy+0]*g48[iz+0];
s[1408] = + g4[ix+0]*g75[iy+0]*g48[iz+0];
s[1409] = + g4[ix+0]*g74[iy+0]*g49[iz+0];
s[1410] = + g5[ix+0]*g72[iy+0]*g50[iz+0];
s[1411] = + g4[ix+0]*g73[iy+0]*g50[iz+0];
s[1412] = + g4[ix+0]*g72[iy+0]*g51[iz+0];
s[1413] = + g3[ix+0]*g76[iy+0]*g48[iz+0];
s[1414] = + g2[ix+0]*g77[iy+0]*g48[iz+0];
s[1415] = + g2[ix+0]*g76[iy+0]*g49[iz+0];
s[1416] = + g1[ix+0]*g78[iy+0]*g48[iz+0];
s[1417] = + g0[ix+0]*g79[iy+0]*g48[iz+0];
s[1418] = + g0[ix+0]*g78[iy+0]*g49[iz+0];
s[1419] = + g1[ix+0]*g76[iy+0]*g50[iz+0];
s[1420] = + g0[ix+0]*g77[iy+0]*g50[iz+0];
s[1421] = + g0[ix+0]*g76[iy+0]*g51[iz+0];
s[1422] = + g3[ix+0]*g72[iy+0]*g52[iz+0];
s[1423] = + g2[ix+0]*g73[iy+0]*g52[iz+0];
s[1424] = + g2[ix+0]*g72[iy+0]*g53[iz+0];
s[1425] = + g1[ix+0]*g74[iy+0]*g52[iz+0];
s[1426] = + g0[ix+0]*g75[iy+0]*g52[iz+0];
s[1427] = + g0[ix+0]*g74[iy+0]*g53[iz+0];
s[1428] = + g1[ix+0]*g72[iy+0]*g54[iz+0];
s[1429] = + g0[ix+0]*g73[iy+0]*g54[iz+0];
s[1430] = + g0[ix+0]*g72[iy+0]*g55[iz+0];
s[1431] = + g7[ix+0]*g64[iy+0]*g56[iz+0];
s[1432] = + g6[ix+0]*g65[iy+0]*g56[iz+0];
s[1433] = + g6[ix+0]*g64[iy+0]*g57[iz+0];
s[1434] = + g5[ix+0]*g66[iy+0]*g56[iz+0];
s[1435] = + g4[ix+0]*g67[iy+0]*g56[iz+0];
s[1436] = + g4[ix+0]*g66[iy+0]*g57[iz+0];
s[1437] = + g5[ix+0]*g64[iy+0]*g58[iz+0];
s[1438] = + g4[ix+0]*g65[iy+0]*g58[iz+0];
s[1439] = + g4[ix+0]*g64[iy+0]*g59[iz+0];
s[1440] = + g3[ix+0]*g68[iy+0]*g56[iz+0];
s[1441] = + g2[ix+0]*g69[iy+0]*g56[iz+0];
s[1442] = + g2[ix+0]*g68[iy+0]*g57[iz+0];
s[1443] = + g1[ix+0]*g70[iy+0]*g56[iz+0];
s[1444] = + g0[ix+0]*g71[iy+0]*g56[iz+0];
s[1445] = + g0[ix+0]*g70[iy+0]*g57[iz+0];
s[1446] = + g1[ix+0]*g68[iy+0]*g58[iz+0];
s[1447] = + g0[ix+0]*g69[iy+0]*g58[iz+0];
s[1448] = + g0[ix+0]*g68[iy+0]*g59[iz+0];
s[1449] = + g3[ix+0]*g64[iy+0]*g60[iz+0];
s[1450] = + g2[ix+0]*g65[iy+0]*g60[iz+0];
s[1451] = + g2[ix+0]*g64[iy+0]*g61[iz+0];
s[1452] = + g1[ix+0]*g66[iy+0]*g60[iz+0];
s[1453] = + g0[ix+0]*g67[iy+0]*g60[iz+0];
s[1454] = + g0[ix+0]*g66[iy+0]*g61[iz+0];
s[1455] = + g1[ix+0]*g64[iy+0]*g62[iz+0];
s[1456] = + g0[ix+0]*g65[iy+0]*g62[iz+0];
s[1457] = + g0[ix+0]*g64[iy+0]*g63[iz+0];
s[1458] = + g63[ix+0]*g0[iy+0]*g64[iz+0];
s[1459] = + g62[ix+0]*g1[iy+0]*g64[iz+0];
s[1460] = + g62[ix+0]*g0[iy+0]*g65[iz+0];
s[1461] = + g61[ix+0]*g2[iy+0]*g64[iz+0];
s[1462] = + g60[ix+0]*g3[iy+0]*g64[iz+0];
s[1463] = + g60[ix+0]*g2[iy+0]*g65[iz+0];
s[1464] = + g61[ix+0]*g0[iy+0]*g66[iz+0];
s[1465] = + g60[ix+0]*g1[iy+0]*g66[iz+0];
s[1466] = + g60[ix+0]*g0[iy+0]*g67[iz+0];
s[1467] = + g59[ix+0]*g4[iy+0]*g64[iz+0];
s[1468] = + g58[ix+0]*g5[iy+0]*g64[iz+0];
s[1469] = + g58[ix+0]*g4[iy+0]*g65[iz+0];
s[1470] = + g57[ix+0]*g6[iy+0]*g64[iz+0];
s[1471] = + g56[ix+0]*g7[iy+0]*g64[iz+0];
s[1472] = + g56[ix+0]*g6[iy+0]*g65[iz+0];
s[1473] = + g57[ix+0]*g4[iy+0]*g66[iz+0];
s[1474] = + g56[ix+0]*g5[iy+0]*g66[iz+0];
s[1475] = + g56[ix+0]*g4[iy+0]*g67[iz+0];
s[1476] = + g59[ix+0]*g0[iy+0]*g68[iz+0];
s[1477] = + g58[ix+0]*g1[iy+0]*g68[iz+0];
s[1478] = + g58[ix+0]*g0[iy+0]*g69[iz+0];
s[1479] = + g57[ix+0]*g2[iy+0]*g68[iz+0];
s[1480] = + g56[ix+0]*g3[iy+0]*g68[iz+0];
s[1481] = + g56[ix+0]*g2[iy+0]*g69[iz+0];
s[1482] = + g57[ix+0]*g0[iy+0]*g70[iz+0];
s[1483] = + g56[ix+0]*g1[iy+0]*g70[iz+0];
s[1484] = + g56[ix+0]*g0[iy+0]*g71[iz+0];
s[1485] = + g55[ix+0]*g8[iy+0]*g64[iz+0];
s[1486] = + g54[ix+0]*g9[iy+0]*g64[iz+0];
s[1487] = + g54[ix+0]*g8[iy+0]*g65[iz+0];
s[1488] = + g53[ix+0]*g10[iy+0]*g64[iz+0];
s[1489] = + g52[ix+0]*g11[iy+0]*g64[iz+0];
s[1490] = + g52[ix+0]*g10[iy+0]*g65[iz+0];
s[1491] = + g53[ix+0]*g8[iy+0]*g66[iz+0];
s[1492] = + g52[ix+0]*g9[iy+0]*g66[iz+0];
s[1493] = + g52[ix+0]*g8[iy+0]*g67[iz+0];
s[1494] = + g51[ix+0]*g12[iy+0]*g64[iz+0];
s[1495] = + g50[ix+0]*g13[iy+0]*g64[iz+0];
s[1496] = + g50[ix+0]*g12[iy+0]*g65[iz+0];
s[1497] = + g49[ix+0]*g14[iy+0]*g64[iz+0];
s[1498] = + g48[ix+0]*g15[iy+0]*g64[iz+0];
s[1499] = + g48[ix+0]*g14[iy+0]*g65[iz+0];
s[1500] = + g49[ix+0]*g12[iy+0]*g66[iz+0];
s[1501] = + g48[ix+0]*g13[iy+0]*g66[iz+0];
s[1502] = + g48[ix+0]*g12[iy+0]*g67[iz+0];
s[1503] = + g51[ix+0]*g8[iy+0]*g68[iz+0];
s[1504] = + g50[ix+0]*g9[iy+0]*g68[iz+0];
s[1505] = + g50[ix+0]*g8[iy+0]*g69[iz+0];
s[1506] = + g49[ix+0]*g10[iy+0]*g68[iz+0];
s[1507] = + g48[ix+0]*g11[iy+0]*g68[iz+0];
s[1508] = + g48[ix+0]*g10[iy+0]*g69[iz+0];
s[1509] = + g49[ix+0]*g8[iy+0]*g70[iz+0];
s[1510] = + g48[ix+0]*g9[iy+0]*g70[iz+0];
s[1511] = + g48[ix+0]*g8[iy+0]*g71[iz+0];
s[1512] = + g55[ix+0]*g0[iy+0]*g72[iz+0];
s[1513] = + g54[ix+0]*g1[iy+0]*g72[iz+0];
s[1514] = + g54[ix+0]*g0[iy+0]*g73[iz+0];
s[1515] = + g53[ix+0]*g2[iy+0]*g72[iz+0];
s[1516] = + g52[ix+0]*g3[iy+0]*g72[iz+0];
s[1517] = + g52[ix+0]*g2[iy+0]*g73[iz+0];
s[1518] = + g53[ix+0]*g0[iy+0]*g74[iz+0];
s[1519] = + g52[ix+0]*g1[iy+0]*g74[iz+0];
s[1520] = + g52[ix+0]*g0[iy+0]*g75[iz+0];
s[1521] = + g51[ix+0]*g4[iy+0]*g72[iz+0];
s[1522] = + g50[ix+0]*g5[iy+0]*g72[iz+0];
s[1523] = + g50[ix+0]*g4[iy+0]*g73[iz+0];
s[1524] = + g49[ix+0]*g6[iy+0]*g72[iz+0];
s[1525] = + g48[ix+0]*g7[iy+0]*g72[iz+0];
s[1526] = + g48[ix+0]*g6[iy+0]*g73[iz+0];
s[1527] = + g49[ix+0]*g4[iy+0]*g74[iz+0];
s[1528] = + g48[ix+0]*g5[iy+0]*g74[iz+0];
s[1529] = + g48[ix+0]*g4[iy+0]*g75[iz+0];
s[1530] = + g51[ix+0]*g0[iy+0]*g76[iz+0];
s[1531] = + g50[ix+0]*g1[iy+0]*g76[iz+0];
s[1532] = + g50[ix+0]*g0[iy+0]*g77[iz+0];
s[1533] = + g49[ix+0]*g2[iy+0]*g76[iz+0];
s[1534] = + g48[ix+0]*g3[iy+0]*g76[iz+0];
s[1535] = + g48[ix+0]*g2[iy+0]*g77[iz+0];
s[1536] = + g49[ix+0]*g0[iy+0]*g78[iz+0];
s[1537] = + g48[ix+0]*g1[iy+0]*g78[iz+0];
s[1538] = + g48[ix+0]*g0[iy+0]*g79[iz+0];
s[1539] = + g47[ix+0]*g16[iy+0]*g64[iz+0];
s[1540] = + g46[ix+0]*g17[iy+0]*g64[iz+0];
s[1541] = + g46[ix+0]*g16[iy+0]*g65[iz+0];
s[1542] = + g45[ix+0]*g18[iy+0]*g64[iz+0];
s[1543] = + g44[ix+0]*g19[iy+0]*g64[iz+0];
s[1544] = + g44[ix+0]*g18[iy+0]*g65[iz+0];
s[1545] = + g45[ix+0]*g16[iy+0]*g66[iz+0];
s[1546] = + g44[ix+0]*g17[iy+0]*g66[iz+0];
s[1547] = + g44[ix+0]*g16[iy+0]*g67[iz+0];
s[1548] = + g43[ix+0]*g20[iy+0]*g64[iz+0];
s[1549] = + g42[ix+0]*g21[iy+0]*g64[iz+0];
s[1550] = + g42[ix+0]*g20[iy+0]*g65[iz+0];
s[1551] = + g41[ix+0]*g22[iy+0]*g64[iz+0];
s[1552] = + g40[ix+0]*g23[iy+0]*g64[iz+0];
s[1553] = + g40[ix+0]*g22[iy+0]*g65[iz+0];
s[1554] = + g41[ix+0]*g20[iy+0]*g66[iz+0];
s[1555] = + g40[ix+0]*g21[iy+0]*g66[iz+0];
s[1556] = + g40[ix+0]*g20[iy+0]*g67[iz+0];
s[1557] = + g43[ix+0]*g16[iy+0]*g68[iz+0];
s[1558] = + g42[ix+0]*g17[iy+0]*g68[iz+0];
s[1559] = + g42[ix+0]*g16[iy+0]*g69[iz+0];
s[1560] = + g41[ix+0]*g18[iy+0]*g68[iz+0];
s[1561] = + g40[ix+0]*g19[iy+0]*g68[iz+0];
s[1562] = + g40[ix+0]*g18[iy+0]*g69[iz+0];
s[1563] = + g41[ix+0]*g16[iy+0]*g70[iz+0];
s[1564] = + g40[ix+0]*g17[iy+0]*g70[iz+0];
s[1565] = + g40[ix+0]*g16[iy+0]*g71[iz+0];
s[1566] = + g39[ix+0]*g24[iy+0]*g64[iz+0];
s[1567] = + g38[ix+0]*g25[iy+0]*g64[iz+0];
s[1568] = + g38[ix+0]*g24[iy+0]*g65[iz+0];
s[1569] = + g37[ix+0]*g26[iy+0]*g64[iz+0];
s[1570] = + g36[ix+0]*g27[iy+0]*g64[iz+0];
s[1571] = + g36[ix+0]*g26[iy+0]*g65[iz+0];
s[1572] = + g37[ix+0]*g24[iy+0]*g66[iz+0];
s[1573] = + g36[ix+0]*g25[iy+0]*g66[iz+0];
s[1574] = + g36[ix+0]*g24[iy+0]*g67[iz+0];
s[1575] = + g35[ix+0]*g28[iy+0]*g64[iz+0];
s[1576] = + g34[ix+0]*g29[iy+0]*g64[iz+0];
s[1577] = + g34[ix+0]*g28[iy+0]*g65[iz+0];
s[1578] = + g33[ix+0]*g30[iy+0]*g64[iz+0];
s[1579] = + g32[ix+0]*g31[iy+0]*g64[iz+0];
s[1580] = + g32[ix+0]*g30[iy+0]*g65[iz+0];
s[1581] = + g33[ix+0]*g28[iy+0]*g66[iz+0];
s[1582] = + g32[ix+0]*g29[iy+0]*g66[iz+0];
s[1583] = + g32[ix+0]*g28[iy+0]*g67[iz+0];
s[1584] = + g35[ix+0]*g24[iy+0]*g68[iz+0];
s[1585] = + g34[ix+0]*g25[iy+0]*g68[iz+0];
s[1586] = + g34[ix+0]*g24[iy+0]*g69[iz+0];
s[1587] = + g33[ix+0]*g26[iy+0]*g68[iz+0];
s[1588] = + g32[ix+0]*g27[iy+0]*g68[iz+0];
s[1589] = + g32[ix+0]*g26[iy+0]*g69[iz+0];
s[1590] = + g33[ix+0]*g24[iy+0]*g70[iz+0];
s[1591] = + g32[ix+0]*g25[iy+0]*g70[iz+0];
s[1592] = + g32[ix+0]*g24[iy+0]*g71[iz+0];
s[1593] = + g39[ix+0]*g16[iy+0]*g72[iz+0];
s[1594] = + g38[ix+0]*g17[iy+0]*g72[iz+0];
s[1595] = + g38[ix+0]*g16[iy+0]*g73[iz+0];
s[1596] = + g37[ix+0]*g18[iy+0]*g72[iz+0];
s[1597] = + g36[ix+0]*g19[iy+0]*g72[iz+0];
s[1598] = + g36[ix+0]*g18[iy+0]*g73[iz+0];
s[1599] = + g37[ix+0]*g16[iy+0]*g74[iz+0];
s[1600] = + g36[ix+0]*g17[iy+0]*g74[iz+0];
s[1601] = + g36[ix+0]*g16[iy+0]*g75[iz+0];
s[1602] = + g35[ix+0]*g20[iy+0]*g72[iz+0];
s[1603] = + g34[ix+0]*g21[iy+0]*g72[iz+0];
s[1604] = + g34[ix+0]*g20[iy+0]*g73[iz+0];
s[1605] = + g33[ix+0]*g22[iy+0]*g72[iz+0];
s[1606] = + g32[ix+0]*g23[iy+0]*g72[iz+0];
s[1607] = + g32[ix+0]*g22[iy+0]*g73[iz+0];
s[1608] = + g33[ix+0]*g20[iy+0]*g74[iz+0];
s[1609] = + g32[ix+0]*g21[iy+0]*g74[iz+0];
s[1610] = + g32[ix+0]*g20[iy+0]*g75[iz+0];
s[1611] = + g35[ix+0]*g16[iy+0]*g76[iz+0];
s[1612] = + g34[ix+0]*g17[iy+0]*g76[iz+0];
s[1613] = + g34[ix+0]*g16[iy+0]*g77[iz+0];
s[1614] = + g33[ix+0]*g18[iy+0]*g76[iz+0];
s[1615] = + g32[ix+0]*g19[iy+0]*g76[iz+0];
s[1616] = + g32[ix+0]*g18[iy+0]*g77[iz+0];
s[1617] = + g33[ix+0]*g16[iy+0]*g78[iz+0];
s[1618] = + g32[ix+0]*g17[iy+0]*g78[iz+0];
s[1619] = + g32[ix+0]*g16[iy+0]*g79[iz+0];
s[1620] = + g47[ix+0]*g0[iy+0]*g80[iz+0];
s[1621] = + g46[ix+0]*g1[iy+0]*g80[iz+0];
s[1622] = + g46[ix+0]*g0[iy+0]*g81[iz+0];
s[1623] = + g45[ix+0]*g2[iy+0]*g80[iz+0];
s[1624] = + g44[ix+0]*g3[iy+0]*g80[iz+0];
s[1625] = + g44[ix+0]*g2[iy+0]*g81[iz+0];
s[1626] = + g45[ix+0]*g0[iy+0]*g82[iz+0];
s[1627] = + g44[ix+0]*g1[iy+0]*g82[iz+0];
s[1628] = + g44[ix+0]*g0[iy+0]*g83[iz+0];
s[1629] = + g43[ix+0]*g4[iy+0]*g80[iz+0];
s[1630] = + g42[ix+0]*g5[iy+0]*g80[iz+0];
s[1631] = + g42[ix+0]*g4[iy+0]*g81[iz+0];
s[1632] = + g41[ix+0]*g6[iy+0]*g80[iz+0];
s[1633] = + g40[ix+0]*g7[iy+0]*g80[iz+0];
s[1634] = + g40[ix+0]*g6[iy+0]*g81[iz+0];
s[1635] = + g41[ix+0]*g4[iy+0]*g82[iz+0];
s[1636] = + g40[ix+0]*g5[iy+0]*g82[iz+0];
s[1637] = + g40[ix+0]*g4[iy+0]*g83[iz+0];
s[1638] = + g43[ix+0]*g0[iy+0]*g84[iz+0];
s[1639] = + g42[ix+0]*g1[iy+0]*g84[iz+0];
s[1640] = + g42[ix+0]*g0[iy+0]*g85[iz+0];
s[1641] = + g41[ix+0]*g2[iy+0]*g84[iz+0];
s[1642] = + g40[ix+0]*g3[iy+0]*g84[iz+0];
s[1643] = + g40[ix+0]*g2[iy+0]*g85[iz+0];
s[1644] = + g41[ix+0]*g0[iy+0]*g86[iz+0];
s[1645] = + g40[ix+0]*g1[iy+0]*g86[iz+0];
s[1646] = + g40[ix+0]*g0[iy+0]*g87[iz+0];
s[1647] = + g39[ix+0]*g8[iy+0]*g80[iz+0];
s[1648] = + g38[ix+0]*g9[iy+0]*g80[iz+0];
s[1649] = + g38[ix+0]*g8[iy+0]*g81[iz+0];
s[1650] = + g37[ix+0]*g10[iy+0]*g80[iz+0];
s[1651] = + g36[ix+0]*g11[iy+0]*g80[iz+0];
s[1652] = + g36[ix+0]*g10[iy+0]*g81[iz+0];
s[1653] = + g37[ix+0]*g8[iy+0]*g82[iz+0];
s[1654] = + g36[ix+0]*g9[iy+0]*g82[iz+0];
s[1655] = + g36[ix+0]*g8[iy+0]*g83[iz+0];
s[1656] = + g35[ix+0]*g12[iy+0]*g80[iz+0];
s[1657] = + g34[ix+0]*g13[iy+0]*g80[iz+0];
s[1658] = + g34[ix+0]*g12[iy+0]*g81[iz+0];
s[1659] = + g33[ix+0]*g14[iy+0]*g80[iz+0];
s[1660] = + g32[ix+0]*g15[iy+0]*g80[iz+0];
s[1661] = + g32[ix+0]*g14[iy+0]*g81[iz+0];
s[1662] = + g33[ix+0]*g12[iy+0]*g82[iz+0];
s[1663] = + g32[ix+0]*g13[iy+0]*g82[iz+0];
s[1664] = + g32[ix+0]*g12[iy+0]*g83[iz+0];
s[1665] = + g35[ix+0]*g8[iy+0]*g84[iz+0];
s[1666] = + g34[ix+0]*g9[iy+0]*g84[iz+0];
s[1667] = + g34[ix+0]*g8[iy+0]*g85[iz+0];
s[1668] = + g33[ix+0]*g10[iy+0]*g84[iz+0];
s[1669] = + g32[ix+0]*g11[iy+0]*g84[iz+0];
s[1670] = + g32[ix+0]*g10[iy+0]*g85[iz+0];
s[1671] = + g33[ix+0]*g8[iy+0]*g86[iz+0];
s[1672] = + g32[ix+0]*g9[iy+0]*g86[iz+0];
s[1673] = + g32[ix+0]*g8[iy+0]*g87[iz+0];
s[1674] = + g39[ix+0]*g0[iy+0]*g88[iz+0];
s[1675] = + g38[ix+0]*g1[iy+0]*g88[iz+0];
s[1676] = + g38[ix+0]*g0[iy+0]*g89[iz+0];
s[1677] = + g37[ix+0]*g2[iy+0]*g88[iz+0];
s[1678] = + g36[ix+0]*g3[iy+0]*g88[iz+0];
s[1679] = + g36[ix+0]*g2[iy+0]*g89[iz+0];
s[1680] = + g37[ix+0]*g0[iy+0]*g90[iz+0];
s[1681] = + g36[ix+0]*g1[iy+0]*g90[iz+0];
s[1682] = + g36[ix+0]*g0[iy+0]*g91[iz+0];
s[1683] = + g35[ix+0]*g4[iy+0]*g88[iz+0];
s[1684] = + g34[ix+0]*g5[iy+0]*g88[iz+0];
s[1685] = + g34[ix+0]*g4[iy+0]*g89[iz+0];
s[1686] = + g33[ix+0]*g6[iy+0]*g88[iz+0];
s[1687] = + g32[ix+0]*g7[iy+0]*g88[iz+0];
s[1688] = + g32[ix+0]*g6[iy+0]*g89[iz+0];
s[1689] = + g33[ix+0]*g4[iy+0]*g90[iz+0];
s[1690] = + g32[ix+0]*g5[iy+0]*g90[iz+0];
s[1691] = + g32[ix+0]*g4[iy+0]*g91[iz+0];
s[1692] = + g35[ix+0]*g0[iy+0]*g92[iz+0];
s[1693] = + g34[ix+0]*g1[iy+0]*g92[iz+0];
s[1694] = + g34[ix+0]*g0[iy+0]*g93[iz+0];
s[1695] = + g33[ix+0]*g2[iy+0]*g92[iz+0];
s[1696] = + g32[ix+0]*g3[iy+0]*g92[iz+0];
s[1697] = + g32[ix+0]*g2[iy+0]*g93[iz+0];
s[1698] = + g33[ix+0]*g0[iy+0]*g94[iz+0];
s[1699] = + g32[ix+0]*g1[iy+0]*g94[iz+0];
s[1700] = + g32[ix+0]*g0[iy+0]*g95[iz+0];
s[1701] = + g31[ix+0]*g32[iy+0]*g64[iz+0];
s[1702] = + g30[ix+0]*g33[iy+0]*g64[iz+0];
s[1703] = + g30[ix+0]*g32[iy+0]*g65[iz+0];
s[1704] = + g29[ix+0]*g34[iy+0]*g64[iz+0];
s[1705] = + g28[ix+0]*g35[iy+0]*g64[iz+0];
s[1706] = + g28[ix+0]*g34[iy+0]*g65[iz+0];
s[1707] = + g29[ix+0]*g32[iy+0]*g66[iz+0];
s[1708] = + g28[ix+0]*g33[iy+0]*g66[iz+0];
s[1709] = + g28[ix+0]*g32[iy+0]*g67[iz+0];
s[1710] = + g27[ix+0]*g36[iy+0]*g64[iz+0];
s[1711] = + g26[ix+0]*g37[iy+0]*g64[iz+0];
s[1712] = + g26[ix+0]*g36[iy+0]*g65[iz+0];
s[1713] = + g25[ix+0]*g38[iy+0]*g64[iz+0];
s[1714] = + g24[ix+0]*g39[iy+0]*g64[iz+0];
s[1715] = + g24[ix+0]*g38[iy+0]*g65[iz+0];
s[1716] = + g25[ix+0]*g36[iy+0]*g66[iz+0];
s[1717] = + g24[ix+0]*g37[iy+0]*g66[iz+0];
s[1718] = + g24[ix+0]*g36[iy+0]*g67[iz+0];
s[1719] = + g27[ix+0]*g32[iy+0]*g68[iz+0];
s[1720] = + g26[ix+0]*g33[iy+0]*g68[iz+0];
s[1721] = + g26[ix+0]*g32[iy+0]*g69[iz+0];
s[1722] = + g25[ix+0]*g34[iy+0]*g68[iz+0];
s[1723] = + g24[ix+0]*g35[iy+0]*g68[iz+0];
s[1724] = + g24[ix+0]*g34[iy+0]*g69[iz+0];
s[1725] = + g25[ix+0]*g32[iy+0]*g70[iz+0];
s[1726] = + g24[ix+0]*g33[iy+0]*g70[iz+0];
s[1727] = + g24[ix+0]*g32[iy+0]*g71[iz+0];
s[1728] = + g23[ix+0]*g40[iy+0]*g64[iz+0];
s[1729] = + g22[ix+0]*g41[iy+0]*g64[iz+0];
s[1730] = + g22[ix+0]*g40[iy+0]*g65[iz+0];
s[1731] = + g21[ix+0]*g42[iy+0]*g64[iz+0];
s[1732] = + g20[ix+0]*g43[iy+0]*g64[iz+0];
s[1733] = + g20[ix+0]*g42[iy+0]*g65[iz+0];
s[1734] = + g21[ix+0]*g40[iy+0]*g66[iz+0];
s[1735] = + g20[ix+0]*g41[iy+0]*g66[iz+0];
s[1736] = + g20[ix+0]*g40[iy+0]*g67[iz+0];
s[1737] = + g19[ix+0]*g44[iy+0]*g64[iz+0];
s[1738] = + g18[ix+0]*g45[iy+0]*g64[iz+0];
s[1739] = + g18[ix+0]*g44[iy+0]*g65[iz+0];
s[1740] = + g17[ix+0]*g46[iy+0]*g64[iz+0];
s[1741] = + g16[ix+0]*g47[iy+0]*g64[iz+0];
s[1742] = + g16[ix+0]*g46[iy+0]*g65[iz+0];
s[1743] = + g17[ix+0]*g44[iy+0]*g66[iz+0];
s[1744] = + g16[ix+0]*g45[iy+0]*g66[iz+0];
s[1745] = + g16[ix+0]*g44[iy+0]*g67[iz+0];
s[1746] = + g19[ix+0]*g40[iy+0]*g68[iz+0];
s[1747] = + g18[ix+0]*g41[iy+0]*g68[iz+0];
s[1748] = + g18[ix+0]*g40[iy+0]*g69[iz+0];
s[1749] = + g17[ix+0]*g42[iy+0]*g68[iz+0];
s[1750] = + g16[ix+0]*g43[iy+0]*g68[iz+0];
s[1751] = + g16[ix+0]*g42[iy+0]*g69[iz+0];
s[1752] = + g17[ix+0]*g40[iy+0]*g70[iz+0];
s[1753] = + g16[ix+0]*g41[iy+0]*g70[iz+0];
s[1754] = + g16[ix+0]*g40[iy+0]*g71[iz+0];
s[1755] = + g23[ix+0]*g32[iy+0]*g72[iz+0];
s[1756] = + g22[ix+0]*g33[iy+0]*g72[iz+0];
s[1757] = + g22[ix+0]*g32[iy+0]*g73[iz+0];
s[1758] = + g21[ix+0]*g34[iy+0]*g72[iz+0];
s[1759] = + g20[ix+0]*g35[iy+0]*g72[iz+0];
s[1760] = + g20[ix+0]*g34[iy+0]*g73[iz+0];
s[1761] = + g21[ix+0]*g32[iy+0]*g74[iz+0];
s[1762] = + g20[ix+0]*g33[iy+0]*g74[iz+0];
s[1763] = + g20[ix+0]*g32[iy+0]*g75[iz+0];
s[1764] = + g19[ix+0]*g36[iy+0]*g72[iz+0];
s[1765] = + g18[ix+0]*g37[iy+0]*g72[iz+0];
s[1766] = + g18[ix+0]*g36[iy+0]*g73[iz+0];
s[1767] = + g17[ix+0]*g38[iy+0]*g72[iz+0];
s[1768] = + g16[ix+0]*g39[iy+0]*g72[iz+0];
s[1769] = + g16[ix+0]*g38[iy+0]*g73[iz+0];
s[1770] = + g17[ix+0]*g36[iy+0]*g74[iz+0];
s[1771] = + g16[ix+0]*g37[iy+0]*g74[iz+0];
s[1772] = + g16[ix+0]*g36[iy+0]*g75[iz+0];
s[1773] = + g19[ix+0]*g32[iy+0]*g76[iz+0];
s[1774] = + g18[ix+0]*g33[iy+0]*g76[iz+0];
s[1775] = + g18[ix+0]*g32[iy+0]*g77[iz+0];
s[1776] = + g17[ix+0]*g34[iy+0]*g76[iz+0];
s[1777] = + g16[ix+0]*g35[iy+0]*g76[iz+0];
s[1778] = + g16[ix+0]*g34[iy+0]*g77[iz+0];
s[1779] = + g17[ix+0]*g32[iy+0]*g78[iz+0];
s[1780] = + g16[ix+0]*g33[iy+0]*g78[iz+0];
s[1781] = + g16[ix+0]*g32[iy+0]*g79[iz+0];
s[1782] = + g15[ix+0]*g48[iy+0]*g64[iz+0];
s[1783] = + g14[ix+0]*g49[iy+0]*g64[iz+0];
s[1784] = + g14[ix+0]*g48[iy+0]*g65[iz+0];
s[1785] = + g13[ix+0]*g50[iy+0]*g64[iz+0];
s[1786] = + g12[ix+0]*g51[iy+0]*g64[iz+0];
s[1787] = + g12[ix+0]*g50[iy+0]*g65[iz+0];
s[1788] = + g13[ix+0]*g48[iy+0]*g66[iz+0];
s[1789] = + g12[ix+0]*g49[iy+0]*g66[iz+0];
s[1790] = + g12[ix+0]*g48[iy+0]*g67[iz+0];
s[1791] = + g11[ix+0]*g52[iy+0]*g64[iz+0];
s[1792] = + g10[ix+0]*g53[iy+0]*g64[iz+0];
s[1793] = + g10[ix+0]*g52[iy+0]*g65[iz+0];
s[1794] = + g9[ix+0]*g54[iy+0]*g64[iz+0];
s[1795] = + g8[ix+0]*g55[iy+0]*g64[iz+0];
s[1796] = + g8[ix+0]*g54[iy+0]*g65[iz+0];
s[1797] = + g9[ix+0]*g52[iy+0]*g66[iz+0];
s[1798] = + g8[ix+0]*g53[iy+0]*g66[iz+0];
s[1799] = + g8[ix+0]*g52[iy+0]*g67[iz+0];
s[1800] = + g11[ix+0]*g48[iy+0]*g68[iz+0];
s[1801] = + g10[ix+0]*g49[iy+0]*g68[iz+0];
s[1802] = + g10[ix+0]*g48[iy+0]*g69[iz+0];
s[1803] = + g9[ix+0]*g50[iy+0]*g68[iz+0];
s[1804] = + g8[ix+0]*g51[iy+0]*g68[iz+0];
s[1805] = + g8[ix+0]*g50[iy+0]*g69[iz+0];
s[1806] = + g9[ix+0]*g48[iy+0]*g70[iz+0];
s[1807] = + g8[ix+0]*g49[iy+0]*g70[iz+0];
s[1808] = + g8[ix+0]*g48[iy+0]*g71[iz+0];
s[1809] = + g7[ix+0]*g56[iy+0]*g64[iz+0];
s[1810] = + g6[ix+0]*g57[iy+0]*g64[iz+0];
s[1811] = + g6[ix+0]*g56[iy+0]*g65[iz+0];
s[1812] = + g5[ix+0]*g58[iy+0]*g64[iz+0];
s[1813] = + g4[ix+0]*g59[iy+0]*g64[iz+0];
s[1814] = + g4[ix+0]*g58[iy+0]*g65[iz+0];
s[1815] = + g5[ix+0]*g56[iy+0]*g66[iz+0];
s[1816] = + g4[ix+0]*g57[iy+0]*g66[iz+0];
s[1817] = + g4[ix+0]*g56[iy+0]*g67[iz+0];
s[1818] = + g3[ix+0]*g60[iy+0]*g64[iz+0];
s[1819] = + g2[ix+0]*g61[iy+0]*g64[iz+0];
s[1820] = + g2[ix+0]*g60[iy+0]*g65[iz+0];
s[1821] = + g1[ix+0]*g62[iy+0]*g64[iz+0];
s[1822] = + g0[ix+0]*g63[iy+0]*g64[iz+0];
s[1823] = + g0[ix+0]*g62[iy+0]*g65[iz+0];
s[1824] = + g1[ix+0]*g60[iy+0]*g66[iz+0];
s[1825] = + g0[ix+0]*g61[iy+0]*g66[iz+0];
s[1826] = + g0[ix+0]*g60[iy+0]*g67[iz+0];
s[1827] = + g3[ix+0]*g56[iy+0]*g68[iz+0];
s[1828] = + g2[ix+0]*g57[iy+0]*g68[iz+0];
s[1829] = + g2[ix+0]*g56[iy+0]*g69[iz+0];
s[1830] = + g1[ix+0]*g58[iy+0]*g68[iz+0];
s[1831] = + g0[ix+0]*g59[iy+0]*g68[iz+0];
s[1832] = + g0[ix+0]*g58[iy+0]*g69[iz+0];
s[1833] = + g1[ix+0]*g56[iy+0]*g70[iz+0];
s[1834] = + g0[ix+0]*g57[iy+0]*g70[iz+0];
s[1835] = + g0[ix+0]*g56[iy+0]*g71[iz+0];
s[1836] = + g7[ix+0]*g48[iy+0]*g72[iz+0];
s[1837] = + g6[ix+0]*g49[iy+0]*g72[iz+0];
s[1838] = + g6[ix+0]*g48[iy+0]*g73[iz+0];
s[1839] = + g5[ix+0]*g50[iy+0]*g72[iz+0];
s[1840] = + g4[ix+0]*g51[iy+0]*g72[iz+0];
s[1841] = + g4[ix+0]*g50[iy+0]*g73[iz+0];
s[1842] = + g5[ix+0]*g48[iy+0]*g74[iz+0];
s[1843] = + g4[ix+0]*g49[iy+0]*g74[iz+0];
s[1844] = + g4[ix+0]*g48[iy+0]*g75[iz+0];
s[1845] = + g3[ix+0]*g52[iy+0]*g72[iz+0];
s[1846] = + g2[ix+0]*g53[iy+0]*g72[iz+0];
s[1847] = + g2[ix+0]*g52[iy+0]*g73[iz+0];
s[1848] = + g1[ix+0]*g54[iy+0]*g72[iz+0];
s[1849] = + g0[ix+0]*g55[iy+0]*g72[iz+0];
s[1850] = + g0[ix+0]*g54[iy+0]*g73[iz+0];
s[1851] = + g1[ix+0]*g52[iy+0]*g74[iz+0];
s[1852] = + g0[ix+0]*g53[iy+0]*g74[iz+0];
s[1853] = + g0[ix+0]*g52[iy+0]*g75[iz+0];
s[1854] = + g3[ix+0]*g48[iy+0]*g76[iz+0];
s[1855] = + g2[ix+0]*g49[iy+0]*g76[iz+0];
s[1856] = + g2[ix+0]*g48[iy+0]*g77[iz+0];
s[1857] = + g1[ix+0]*g50[iy+0]*g76[iz+0];
s[1858] = + g0[ix+0]*g51[iy+0]*g76[iz+0];
s[1859] = + g0[ix+0]*g50[iy+0]*g77[iz+0];
s[1860] = + g1[ix+0]*g48[iy+0]*g78[iz+0];
s[1861] = + g0[ix+0]*g49[iy+0]*g78[iz+0];
s[1862] = + g0[ix+0]*g48[iy+0]*g79[iz+0];
s[1863] = + g15[ix+0]*g32[iy+0]*g80[iz+0];
s[1864] = + g14[ix+0]*g33[iy+0]*g80[iz+0];
s[1865] = + g14[ix+0]*g32[iy+0]*g81[iz+0];
s[1866] = + g13[ix+0]*g34[iy+0]*g80[iz+0];
s[1867] = + g12[ix+0]*g35[iy+0]*g80[iz+0];
s[1868] = + g12[ix+0]*g34[iy+0]*g81[iz+0];
s[1869] = + g13[ix+0]*g32[iy+0]*g82[iz+0];
s[1870] = + g12[ix+0]*g33[iy+0]*g82[iz+0];
s[1871] = + g12[ix+0]*g32[iy+0]*g83[iz+0];
s[1872] = + g11[ix+0]*g36[iy+0]*g80[iz+0];
s[1873] = + g10[ix+0]*g37[iy+0]*g80[iz+0];
s[1874] = + g10[ix+0]*g36[iy+0]*g81[iz+0];
s[1875] = + g9[ix+0]*g38[iy+0]*g80[iz+0];
s[1876] = + g8[ix+0]*g39[iy+0]*g80[iz+0];
s[1877] = + g8[ix+0]*g38[iy+0]*g81[iz+0];
s[1878] = + g9[ix+0]*g36[iy+0]*g82[iz+0];
s[1879] = + g8[ix+0]*g37[iy+0]*g82[iz+0];
s[1880] = + g8[ix+0]*g36[iy+0]*g83[iz+0];
s[1881] = + g11[ix+0]*g32[iy+0]*g84[iz+0];
s[1882] = + g10[ix+0]*g33[iy+0]*g84[iz+0];
s[1883] = + g10[ix+0]*g32[iy+0]*g85[iz+0];
s[1884] = + g9[ix+0]*g34[iy+0]*g84[iz+0];
s[1885] = + g8[ix+0]*g35[iy+0]*g84[iz+0];
s[1886] = + g8[ix+0]*g34[iy+0]*g85[iz+0];
s[1887] = + g9[ix+0]*g32[iy+0]*g86[iz+0];
s[1888] = + g8[ix+0]*g33[iy+0]*g86[iz+0];
s[1889] = + g8[ix+0]*g32[iy+0]*g87[iz+0];
s[1890] = + g7[ix+0]*g40[iy+0]*g80[iz+0];
s[1891] = + g6[ix+0]*g41[iy+0]*g80[iz+0];
s[1892] = + g6[ix+0]*g40[iy+0]*g81[iz+0];
s[1893] = + g5[ix+0]*g42[iy+0]*g80[iz+0];
s[1894] = + g4[ix+0]*g43[iy+0]*g80[iz+0];
s[1895] = + g4[ix+0]*g42[iy+0]*g81[iz+0];
s[1896] = + g5[ix+0]*g40[iy+0]*g82[iz+0];
s[1897] = + g4[ix+0]*g41[iy+0]*g82[iz+0];
s[1898] = + g4[ix+0]*g40[iy+0]*g83[iz+0];
s[1899] = + g3[ix+0]*g44[iy+0]*g80[iz+0];
s[1900] = + g2[ix+0]*g45[iy+0]*g80[iz+0];
s[1901] = + g2[ix+0]*g44[iy+0]*g81[iz+0];
s[1902] = + g1[ix+0]*g46[iy+0]*g80[iz+0];
s[1903] = + g0[ix+0]*g47[iy+0]*g80[iz+0];
s[1904] = + g0[ix+0]*g46[iy+0]*g81[iz+0];
s[1905] = + g1[ix+0]*g44[iy+0]*g82[iz+0];
s[1906] = + g0[ix+0]*g45[iy+0]*g82[iz+0];
s[1907] = + g0[ix+0]*g44[iy+0]*g83[iz+0];
s[1908] = + g3[ix+0]*g40[iy+0]*g84[iz+0];
s[1909] = + g2[ix+0]*g41[iy+0]*g84[iz+0];
s[1910] = + g2[ix+0]*g40[iy+0]*g85[iz+0];
s[1911] = + g1[ix+0]*g42[iy+0]*g84[iz+0];
s[1912] = + g0[ix+0]*g43[iy+0]*g84[iz+0];
s[1913] = + g0[ix+0]*g42[iy+0]*g85[iz+0];
s[1914] = + g1[ix+0]*g40[iy+0]*g86[iz+0];
s[1915] = + g0[ix+0]*g41[iy+0]*g86[iz+0];
s[1916] = + g0[ix+0]*g40[iy+0]*g87[iz+0];
s[1917] = + g7[ix+0]*g32[iy+0]*g88[iz+0];
s[1918] = + g6[ix+0]*g33[iy+0]*g88[iz+0];
s[1919] = + g6[ix+0]*g32[iy+0]*g89[iz+0];
s[1920] = + g5[ix+0]*g34[iy+0]*g88[iz+0];
s[1921] = + g4[ix+0]*g35[iy+0]*g88[iz+0];
s[1922] = + g4[ix+0]*g34[iy+0]*g89[iz+0];
s[1923] = + g5[ix+0]*g32[iy+0]*g90[iz+0];
s[1924] = + g4[ix+0]*g33[iy+0]*g90[iz+0];
s[1925] = + g4[ix+0]*g32[iy+0]*g91[iz+0];
s[1926] = + g3[ix+0]*g36[iy+0]*g88[iz+0];
s[1927] = + g2[ix+0]*g37[iy+0]*g88[iz+0];
s[1928] = + g2[ix+0]*g36[iy+0]*g89[iz+0];
s[1929] = + g1[ix+0]*g38[iy+0]*g88[iz+0];
s[1930] = + g0[ix+0]*g39[iy+0]*g88[iz+0];
s[1931] = + g0[ix+0]*g38[iy+0]*g89[iz+0];
s[1932] = + g1[ix+0]*g36[iy+0]*g90[iz+0];
s[1933] = + g0[ix+0]*g37[iy+0]*g90[iz+0];
s[1934] = + g0[ix+0]*g36[iy+0]*g91[iz+0];
s[1935] = + g3[ix+0]*g32[iy+0]*g92[iz+0];
s[1936] = + g2[ix+0]*g33[iy+0]*g92[iz+0];
s[1937] = + g2[ix+0]*g32[iy+0]*g93[iz+0];
s[1938] = + g1[ix+0]*g34[iy+0]*g92[iz+0];
s[1939] = + g0[ix+0]*g35[iy+0]*g92[iz+0];
s[1940] = + g0[ix+0]*g34[iy+0]*g93[iz+0];
s[1941] = + g1[ix+0]*g32[iy+0]*g94[iz+0];
s[1942] = + g0[ix+0]*g33[iy+0]*g94[iz+0];
s[1943] = + g0[ix+0]*g32[iy+0]*g95[iz+0];
s[1944] = + g31[ix+0]*g0[iy+0]*g96[iz+0];
s[1945] = + g30[ix+0]*g1[iy+0]*g96[iz+0];
s[1946] = + g30[ix+0]*g0[iy+0]*g97[iz+0];
s[1947] = + g29[ix+0]*g2[iy+0]*g96[iz+0];
s[1948] = + g28[ix+0]*g3[iy+0]*g96[iz+0];
s[1949] = + g28[ix+0]*g2[iy+0]*g97[iz+0];
s[1950] = + g29[ix+0]*g0[iy+0]*g98[iz+0];
s[1951] = + g28[ix+0]*g1[iy+0]*g98[iz+0];
s[1952] = + g28[ix+0]*g0[iy+0]*g99[iz+0];
s[1953] = + g27[ix+0]*g4[iy+0]*g96[iz+0];
s[1954] = + g26[ix+0]*g5[iy+0]*g96[iz+0];
s[1955] = + g26[ix+0]*g4[iy+0]*g97[iz+0];
s[1956] = + g25[ix+0]*g6[iy+0]*g96[iz+0];
s[1957] = + g24[ix+0]*g7[iy+0]*g96[iz+0];
s[1958] = + g24[ix+0]*g6[iy+0]*g97[iz+0];
s[1959] = + g25[ix+0]*g4[iy+0]*g98[iz+0];
s[1960] = + g24[ix+0]*g5[iy+0]*g98[iz+0];
s[1961] = + g24[ix+0]*g4[iy+0]*g99[iz+0];
s[1962] = + g27[ix+0]*g0[iy+0]*g100[iz+0];
s[1963] = + g26[ix+0]*g1[iy+0]*g100[iz+0];
s[1964] = + g26[ix+0]*g0[iy+0]*g101[iz+0];
s[1965] = + g25[ix+0]*g2[iy+0]*g100[iz+0];
s[1966] = + g24[ix+0]*g3[iy+0]*g100[iz+0];
s[1967] = + g24[ix+0]*g2[iy+0]*g101[iz+0];
s[1968] = + g25[ix+0]*g0[iy+0]*g102[iz+0];
s[1969] = + g24[ix+0]*g1[iy+0]*g102[iz+0];
s[1970] = + g24[ix+0]*g0[iy+0]*g103[iz+0];
s[1971] = + g23[ix+0]*g8[iy+0]*g96[iz+0];
s[1972] = + g22[ix+0]*g9[iy+0]*g96[iz+0];
s[1973] = + g22[ix+0]*g8[iy+0]*g97[iz+0];
s[1974] = + g21[ix+0]*g10[iy+0]*g96[iz+0];
s[1975] = + g20[ix+0]*g11[iy+0]*g96[iz+0];
s[1976] = + g20[ix+0]*g10[iy+0]*g97[iz+0];
s[1977] = + g21[ix+0]*g8[iy+0]*g98[iz+0];
s[1978] = + g20[ix+0]*g9[iy+0]*g98[iz+0];
s[1979] = + g20[ix+0]*g8[iy+0]*g99[iz+0];
s[1980] = + g19[ix+0]*g12[iy+0]*g96[iz+0];
s[1981] = + g18[ix+0]*g13[iy+0]*g96[iz+0];
s[1982] = + g18[ix+0]*g12[iy+0]*g97[iz+0];
s[1983] = + g17[ix+0]*g14[iy+0]*g96[iz+0];
s[1984] = + g16[ix+0]*g15[iy+0]*g96[iz+0];
s[1985] = + g16[ix+0]*g14[iy+0]*g97[iz+0];
s[1986] = + g17[ix+0]*g12[iy+0]*g98[iz+0];
s[1987] = + g16[ix+0]*g13[iy+0]*g98[iz+0];
s[1988] = + g16[ix+0]*g12[iy+0]*g99[iz+0];
s[1989] = + g19[ix+0]*g8[iy+0]*g100[iz+0];
s[1990] = + g18[ix+0]*g9[iy+0]*g100[iz+0];
s[1991] = + g18[ix+0]*g8[iy+0]*g101[iz+0];
s[1992] = + g17[ix+0]*g10[iy+0]*g100[iz+0];
s[1993] = + g16[ix+0]*g11[iy+0]*g100[iz+0];
s[1994] = + g16[ix+0]*g10[iy+0]*g101[iz+0];
s[1995] = + g17[ix+0]*g8[iy+0]*g102[iz+0];
s[1996] = + g16[ix+0]*g9[iy+0]*g102[iz+0];
s[1997] = + g16[ix+0]*g8[iy+0]*g103[iz+0];
s[1998] = + g23[ix+0]*g0[iy+0]*g104[iz+0];
s[1999] = + g22[ix+0]*g1[iy+0]*g104[iz+0];
s[2000] = + g22[ix+0]*g0[iy+0]*g105[iz+0];
s[2001] = + g21[ix+0]*g2[iy+0]*g104[iz+0];
s[2002] = + g20[ix+0]*g3[iy+0]*g104[iz+0];
s[2003] = + g20[ix+0]*g2[iy+0]*g105[iz+0];
s[2004] = + g21[ix+0]*g0[iy+0]*g106[iz+0];
s[2005] = + g20[ix+0]*g1[iy+0]*g106[iz+0];
s[2006] = + g20[ix+0]*g0[iy+0]*g107[iz+0];
s[2007] = + g19[ix+0]*g4[iy+0]*g104[iz+0];
s[2008] = + g18[ix+0]*g5[iy+0]*g104[iz+0];
s[2009] = + g18[ix+0]*g4[iy+0]*g105[iz+0];
s[2010] = + g17[ix+0]*g6[iy+0]*g104[iz+0];
s[2011] = + g16[ix+0]*g7[iy+0]*g104[iz+0];
s[2012] = + g16[ix+0]*g6[iy+0]*g105[iz+0];
s[2013] = + g17[ix+0]*g4[iy+0]*g106[iz+0];
s[2014] = + g16[ix+0]*g5[iy+0]*g106[iz+0];
s[2015] = + g16[ix+0]*g4[iy+0]*g107[iz+0];
s[2016] = + g19[ix+0]*g0[iy+0]*g108[iz+0];
s[2017] = + g18[ix+0]*g1[iy+0]*g108[iz+0];
s[2018] = + g18[ix+0]*g0[iy+0]*g109[iz+0];
s[2019] = + g17[ix+0]*g2[iy+0]*g108[iz+0];
s[2020] = + g16[ix+0]*g3[iy+0]*g108[iz+0];
s[2021] = + g16[ix+0]*g2[iy+0]*g109[iz+0];
s[2022] = + g17[ix+0]*g0[iy+0]*g110[iz+0];
s[2023] = + g16[ix+0]*g1[iy+0]*g110[iz+0];
s[2024] = + g16[ix+0]*g0[iy+0]*g111[iz+0];
s[2025] = + g15[ix+0]*g16[iy+0]*g96[iz+0];
s[2026] = + g14[ix+0]*g17[iy+0]*g96[iz+0];
s[2027] = + g14[ix+0]*g16[iy+0]*g97[iz+0];
s[2028] = + g13[ix+0]*g18[iy+0]*g96[iz+0];
s[2029] = + g12[ix+0]*g19[iy+0]*g96[iz+0];
s[2030] = + g12[ix+0]*g18[iy+0]*g97[iz+0];
s[2031] = + g13[ix+0]*g16[iy+0]*g98[iz+0];
s[2032] = + g12[ix+0]*g17[iy+0]*g98[iz+0];
s[2033] = + g12[ix+0]*g16[iy+0]*g99[iz+0];
s[2034] = + g11[ix+0]*g20[iy+0]*g96[iz+0];
s[2035] = + g10[ix+0]*g21[iy+0]*g96[iz+0];
s[2036] = + g10[ix+0]*g20[iy+0]*g97[iz+0];
s[2037] = + g9[ix+0]*g22[iy+0]*g96[iz+0];
s[2038] = + g8[ix+0]*g23[iy+0]*g96[iz+0];
s[2039] = + g8[ix+0]*g22[iy+0]*g97[iz+0];
s[2040] = + g9[ix+0]*g20[iy+0]*g98[iz+0];
s[2041] = + g8[ix+0]*g21[iy+0]*g98[iz+0];
s[2042] = + g8[ix+0]*g20[iy+0]*g99[iz+0];
s[2043] = + g11[ix+0]*g16[iy+0]*g100[iz+0];
s[2044] = + g10[ix+0]*g17[iy+0]*g100[iz+0];
s[2045] = + g10[ix+0]*g16[iy+0]*g101[iz+0];
s[2046] = + g9[ix+0]*g18[iy+0]*g100[iz+0];
s[2047] = + g8[ix+0]*g19[iy+0]*g100[iz+0];
s[2048] = + g8[ix+0]*g18[iy+0]*g101[iz+0];
s[2049] = + g9[ix+0]*g16[iy+0]*g102[iz+0];
s[2050] = + g8[ix+0]*g17[iy+0]*g102[iz+0];
s[2051] = + g8[ix+0]*g16[iy+0]*g103[iz+0];
s[2052] = + g7[ix+0]*g24[iy+0]*g96[iz+0];
s[2053] = + g6[ix+0]*g25[iy+0]*g96[iz+0];
s[2054] = + g6[ix+0]*g24[iy+0]*g97[iz+0];
s[2055] = + g5[ix+0]*g26[iy+0]*g96[iz+0];
s[2056] = + g4[ix+0]*g27[iy+0]*g96[iz+0];
s[2057] = + g4[ix+0]*g26[iy+0]*g97[iz+0];
s[2058] = + g5[ix+0]*g24[iy+0]*g98[iz+0];
s[2059] = + g4[ix+0]*g25[iy+0]*g98[iz+0];
s[2060] = + g4[ix+0]*g24[iy+0]*g99[iz+0];
s[2061] = + g3[ix+0]*g28[iy+0]*g96[iz+0];
s[2062] = + g2[ix+0]*g29[iy+0]*g96[iz+0];
s[2063] = + g2[ix+0]*g28[iy+0]*g97[iz+0];
s[2064] = + g1[ix+0]*g30[iy+0]*g96[iz+0];
s[2065] = + g0[ix+0]*g31[iy+0]*g96[iz+0];
s[2066] = + g0[ix+0]*g30[iy+0]*g97[iz+0];
s[2067] = + g1[ix+0]*g28[iy+0]*g98[iz+0];
s[2068] = + g0[ix+0]*g29[iy+0]*g98[iz+0];
s[2069] = + g0[ix+0]*g28[iy+0]*g99[iz+0];
s[2070] = + g3[ix+0]*g24[iy+0]*g100[iz+0];
s[2071] = + g2[ix+0]*g25[iy+0]*g100[iz+0];
s[2072] = + g2[ix+0]*g24[iy+0]*g101[iz+0];
s[2073] = + g1[ix+0]*g26[iy+0]*g100[iz+0];
s[2074] = + g0[ix+0]*g27[iy+0]*g100[iz+0];
s[2075] = + g0[ix+0]*g26[iy+0]*g101[iz+0];
s[2076] = + g1[ix+0]*g24[iy+0]*g102[iz+0];
s[2077] = + g0[ix+0]*g25[iy+0]*g102[iz+0];
s[2078] = + g0[ix+0]*g24[iy+0]*g103[iz+0];
s[2079] = + g7[ix+0]*g16[iy+0]*g104[iz+0];
s[2080] = + g6[ix+0]*g17[iy+0]*g104[iz+0];
s[2081] = + g6[ix+0]*g16[iy+0]*g105[iz+0];
s[2082] = + g5[ix+0]*g18[iy+0]*g104[iz+0];
s[2083] = + g4[ix+0]*g19[iy+0]*g104[iz+0];
s[2084] = + g4[ix+0]*g18[iy+0]*g105[iz+0];
s[2085] = + g5[ix+0]*g16[iy+0]*g106[iz+0];
s[2086] = + g4[ix+0]*g17[iy+0]*g106[iz+0];
s[2087] = + g4[ix+0]*g16[iy+0]*g107[iz+0];
s[2088] = + g3[ix+0]*g20[iy+0]*g104[iz+0];
s[2089] = + g2[ix+0]*g21[iy+0]*g104[iz+0];
s[2090] = + g2[ix+0]*g20[iy+0]*g105[iz+0];
s[2091] = + g1[ix+0]*g22[iy+0]*g104[iz+0];
s[2092] = + g0[ix+0]*g23[iy+0]*g104[iz+0];
s[2093] = + g0[ix+0]*g22[iy+0]*g105[iz+0];
s[2094] = + g1[ix+0]*g20[iy+0]*g106[iz+0];
s[2095] = + g0[ix+0]*g21[iy+0]*g106[iz+0];
s[2096] = + g0[ix+0]*g20[iy+0]*g107[iz+0];
s[2097] = + g3[ix+0]*g16[iy+0]*g108[iz+0];
s[2098] = + g2[ix+0]*g17[iy+0]*g108[iz+0];
s[2099] = + g2[ix+0]*g16[iy+0]*g109[iz+0];
s[2100] = + g1[ix+0]*g18[iy+0]*g108[iz+0];
s[2101] = + g0[ix+0]*g19[iy+0]*g108[iz+0];
s[2102] = + g0[ix+0]*g18[iy+0]*g109[iz+0];
s[2103] = + g1[ix+0]*g16[iy+0]*g110[iz+0];
s[2104] = + g0[ix+0]*g17[iy+0]*g110[iz+0];
s[2105] = + g0[ix+0]*g16[iy+0]*g111[iz+0];
s[2106] = + g15[ix+0]*g0[iy+0]*g112[iz+0];
s[2107] = + g14[ix+0]*g1[iy+0]*g112[iz+0];
s[2108] = + g14[ix+0]*g0[iy+0]*g113[iz+0];
s[2109] = + g13[ix+0]*g2[iy+0]*g112[iz+0];
s[2110] = + g12[ix+0]*g3[iy+0]*g112[iz+0];
s[2111] = + g12[ix+0]*g2[iy+0]*g113[iz+0];
s[2112] = + g13[ix+0]*g0[iy+0]*g114[iz+0];
s[2113] = + g12[ix+0]*g1[iy+0]*g114[iz+0];
s[2114] = + g12[ix+0]*g0[iy+0]*g115[iz+0];
s[2115] = + g11[ix+0]*g4[iy+0]*g112[iz+0];
s[2116] = + g10[ix+0]*g5[iy+0]*g112[iz+0];
s[2117] = + g10[ix+0]*g4[iy+0]*g113[iz+0];
s[2118] = + g9[ix+0]*g6[iy+0]*g112[iz+0];
s[2119] = + g8[ix+0]*g7[iy+0]*g112[iz+0];
s[2120] = + g8[ix+0]*g6[iy+0]*g113[iz+0];
s[2121] = + g9[ix+0]*g4[iy+0]*g114[iz+0];
s[2122] = + g8[ix+0]*g5[iy+0]*g114[iz+0];
s[2123] = + g8[ix+0]*g4[iy+0]*g115[iz+0];
s[2124] = + g11[ix+0]*g0[iy+0]*g116[iz+0];
s[2125] = + g10[ix+0]*g1[iy+0]*g116[iz+0];
s[2126] = + g10[ix+0]*g0[iy+0]*g117[iz+0];
s[2127] = + g9[ix+0]*g2[iy+0]*g116[iz+0];
s[2128] = + g8[ix+0]*g3[iy+0]*g116[iz+0];
s[2129] = + g8[ix+0]*g2[iy+0]*g117[iz+0];
s[2130] = + g9[ix+0]*g0[iy+0]*g118[iz+0];
s[2131] = + g8[ix+0]*g1[iy+0]*g118[iz+0];
s[2132] = + g8[ix+0]*g0[iy+0]*g119[iz+0];
s[2133] = + g7[ix+0]*g8[iy+0]*g112[iz+0];
s[2134] = + g6[ix+0]*g9[iy+0]*g112[iz+0];
s[2135] = + g6[ix+0]*g8[iy+0]*g113[iz+0];
s[2136] = + g5[ix+0]*g10[iy+0]*g112[iz+0];
s[2137] = + g4[ix+0]*g11[iy+0]*g112[iz+0];
s[2138] = + g4[ix+0]*g10[iy+0]*g113[iz+0];
s[2139] = + g5[ix+0]*g8[iy+0]*g114[iz+0];
s[2140] = + g4[ix+0]*g9[iy+0]*g114[iz+0];
s[2141] = + g4[ix+0]*g8[iy+0]*g115[iz+0];
s[2142] = + g3[ix+0]*g12[iy+0]*g112[iz+0];
s[2143] = + g2[ix+0]*g13[iy+0]*g112[iz+0];
s[2144] = + g2[ix+0]*g12[iy+0]*g113[iz+0];
s[2145] = + g1[ix+0]*g14[iy+0]*g112[iz+0];
s[2146] = + g0[ix+0]*g15[iy+0]*g112[iz+0];
s[2147] = + g0[ix+0]*g14[iy+0]*g113[iz+0];
s[2148] = + g1[ix+0]*g12[iy+0]*g114[iz+0];
s[2149] = + g0[ix+0]*g13[iy+0]*g114[iz+0];
s[2150] = + g0[ix+0]*g12[iy+0]*g115[iz+0];
s[2151] = + g3[ix+0]*g8[iy+0]*g116[iz+0];
s[2152] = + g2[ix+0]*g9[iy+0]*g116[iz+0];
s[2153] = + g2[ix+0]*g8[iy+0]*g117[iz+0];
s[2154] = + g1[ix+0]*g10[iy+0]*g116[iz+0];
s[2155] = + g0[ix+0]*g11[iy+0]*g116[iz+0];
s[2156] = + g0[ix+0]*g10[iy+0]*g117[iz+0];
s[2157] = + g1[ix+0]*g8[iy+0]*g118[iz+0];
s[2158] = + g0[ix+0]*g9[iy+0]*g118[iz+0];
s[2159] = + g0[ix+0]*g8[iy+0]*g119[iz+0];
s[2160] = + g7[ix+0]*g0[iy+0]*g120[iz+0];
s[2161] = + g6[ix+0]*g1[iy+0]*g120[iz+0];
s[2162] = + g6[ix+0]*g0[iy+0]*g121[iz+0];
s[2163] = + g5[ix+0]*g2[iy+0]*g120[iz+0];
s[2164] = + g4[ix+0]*g3[iy+0]*g120[iz+0];
s[2165] = + g4[ix+0]*g2[iy+0]*g121[iz+0];
s[2166] = + g5[ix+0]*g0[iy+0]*g122[iz+0];
s[2167] = + g4[ix+0]*g1[iy+0]*g122[iz+0];
s[2168] = + g4[ix+0]*g0[iy+0]*g123[iz+0];
s[2169] = + g3[ix+0]*g4[iy+0]*g120[iz+0];
s[2170] = + g2[ix+0]*g5[iy+0]*g120[iz+0];
s[2171] = + g2[ix+0]*g4[iy+0]*g121[iz+0];
s[2172] = + g1[ix+0]*g6[iy+0]*g120[iz+0];
s[2173] = + g0[ix+0]*g7[iy+0]*g120[iz+0];
s[2174] = + g0[ix+0]*g6[iy+0]*g121[iz+0];
s[2175] = + g1[ix+0]*g4[iy+0]*g122[iz+0];
s[2176] = + g0[ix+0]*g5[iy+0]*g122[iz+0];
s[2177] = + g0[ix+0]*g4[iy+0]*g123[iz+0];
s[2178] = + g3[ix+0]*g0[iy+0]*g124[iz+0];
s[2179] = + g2[ix+0]*g1[iy+0]*g124[iz+0];
s[2180] = + g2[ix+0]*g0[iy+0]*g125[iz+0];
s[2181] = + g1[ix+0]*g2[iy+0]*g124[iz+0];
s[2182] = + g0[ix+0]*g3[iy+0]*g124[iz+0];
s[2183] = + g0[ix+0]*g2[iy+0]*g125[iz+0];
s[2184] = + g1[ix+0]*g0[iy+0]*g126[iz+0];
s[2185] = + g0[ix+0]*g1[iy+0]*g126[iz+0];
s[2186] = + g0[ix+0]*g0[iy+0]*g127[iz+0];
if (gout_empty) {
gout[n*27+0] = + s[0] + 2*s[108] + 2*s[216] + s[1080] + 2*s[1188] + s[2160];
gout[n*27+1] = + s[1] + 2*s[109] + 2*s[217] + s[1081] + 2*s[1189] + s[2161];
gout[n*27+2] = + s[2] + 2*s[110] + 2*s[218] + s[1082] + 2*s[1190] + s[2162];
gout[n*27+3] = + s[3] + 2*s[111] + 2*s[219] + s[1083] + 2*s[1191] + s[2163];
gout[n*27+4] = + s[4] + 2*s[112] + 2*s[220] + s[1084] + 2*s[1192] + s[2164];
gout[n*27+5] = + s[5] + 2*s[113] + 2*s[221] + s[1085] + 2*s[1193] + s[2165];
gout[n*27+6] = + s[6] + 2*s[114] + 2*s[222] + s[1086] + 2*s[1194] + s[2166];
gout[n*27+7] = + s[7] + 2*s[115] + 2*s[223] + s[1087] + 2*s[1195] + s[2167];
gout[n*27+8] = + s[8] + 2*s[116] + 2*s[224] + s[1088] + 2*s[1196] + s[2168];
gout[n*27+9] = + s[9] + 2*s[117] + 2*s[225] + s[1089] + 2*s[1197] + s[2169];
gout[n*27+10] = + s[10] + 2*s[118] + 2*s[226] + s[1090] + 2*s[1198] + s[2170];
gout[n*27+11] = + s[11] + 2*s[119] + 2*s[227] + s[1091] + 2*s[1199] + s[2171];
gout[n*27+12] = + s[12] + 2*s[120] + 2*s[228] + s[1092] + 2*s[1200] + s[2172];
gout[n*27+13] = + s[13] + 2*s[121] + 2*s[229] + s[1093] + 2*s[1201] + s[2173];
gout[n*27+14] = + s[14] + 2*s[122] + 2*s[230] + s[1094] + 2*s[1202] + s[2174];
gout[n*27+15] = + s[15] + 2*s[123] + 2*s[231] + s[1095] + 2*s[1203] + s[2175];
gout[n*27+16] = + s[16] + 2*s[124] + 2*s[232] + s[1096] + 2*s[1204] + s[2176];
gout[n*27+17] = + s[17] + 2*s[125] + 2*s[233] + s[1097] + 2*s[1205] + s[2177];
gout[n*27+18] = + s[18] + 2*s[126] + 2*s[234] + s[1098] + 2*s[1206] + s[2178];
gout[n*27+19] = + s[19] + 2*s[127] + 2*s[235] + s[1099] + 2*s[1207] + s[2179];
gout[n*27+20] = + s[20] + 2*s[128] + 2*s[236] + s[1100] + 2*s[1208] + s[2180];
gout[n*27+21] = + s[21] + 2*s[129] + 2*s[237] + s[1101] + 2*s[1209] + s[2181];
gout[n*27+22] = + s[22] + 2*s[130] + 2*s[238] + s[1102] + 2*s[1210] + s[2182];
gout[n*27+23] = + s[23] + 2*s[131] + 2*s[239] + s[1103] + 2*s[1211] + s[2183];
gout[n*27+24] = + s[24] + 2*s[132] + 2*s[240] + s[1104] + 2*s[1212] + s[2184];
gout[n*27+25] = + s[25] + 2*s[133] + 2*s[241] + s[1105] + 2*s[1213] + s[2185];
gout[n*27+26] = + s[26] + 2*s[134] + 2*s[242] + s[1106] + 2*s[1214] + s[2186];
} else {
gout[n*27+0] += + s[0] + 2*s[108] + 2*s[216] + s[1080] + 2*s[1188] + s[2160];
gout[n*27+1] += + s[1] + 2*s[109] + 2*s[217] + s[1081] + 2*s[1189] + s[2161];
gout[n*27+2] += + s[2] + 2*s[110] + 2*s[218] + s[1082] + 2*s[1190] + s[2162];
gout[n*27+3] += + s[3] + 2*s[111] + 2*s[219] + s[1083] + 2*s[1191] + s[2163];
gout[n*27+4] += + s[4] + 2*s[112] + 2*s[220] + s[1084] + 2*s[1192] + s[2164];
gout[n*27+5] += + s[5] + 2*s[113] + 2*s[221] + s[1085] + 2*s[1193] + s[2165];
gout[n*27+6] += + s[6] + 2*s[114] + 2*s[222] + s[1086] + 2*s[1194] + s[2166];
gout[n*27+7] += + s[7] + 2*s[115] + 2*s[223] + s[1087] + 2*s[1195] + s[2167];
gout[n*27+8] += + s[8] + 2*s[116] + 2*s[224] + s[1088] + 2*s[1196] + s[2168];
gout[n*27+9] += + s[9] + 2*s[117] + 2*s[225] + s[1089] + 2*s[1197] + s[2169];
gout[n*27+10] += + s[10] + 2*s[118] + 2*s[226] + s[1090] + 2*s[1198] + s[2170];
gout[n*27+11] += + s[11] + 2*s[119] + 2*s[227] + s[1091] + 2*s[1199] + s[2171];
gout[n*27+12] += + s[12] + 2*s[120] + 2*s[228] + s[1092] + 2*s[1200] + s[2172];
gout[n*27+13] += + s[13] + 2*s[121] + 2*s[229] + s[1093] + 2*s[1201] + s[2173];
gout[n*27+14] += + s[14] + 2*s[122] + 2*s[230] + s[1094] + 2*s[1202] + s[2174];
gout[n*27+15] += + s[15] + 2*s[123] + 2*s[231] + s[1095] + 2*s[1203] + s[2175];
gout[n*27+16] += + s[16] + 2*s[124] + 2*s[232] + s[1096] + 2*s[1204] + s[2176];
gout[n*27+17] += + s[17] + 2*s[125] + 2*s[233] + s[1097] + 2*s[1205] + s[2177];
gout[n*27+18] += + s[18] + 2*s[126] + 2*s[234] + s[1098] + 2*s[1206] + s[2178];
gout[n*27+19] += + s[19] + 2*s[127] + 2*s[235] + s[1099] + 2*s[1207] + s[2179];
gout[n*27+20] += + s[20] + 2*s[128] + 2*s[236] + s[1100] + 2*s[1208] + s[2180];
gout[n*27+21] += + s[21] + 2*s[129] + 2*s[237] + s[1101] + 2*s[1209] + s[2181];
gout[n*27+22] += + s[22] + 2*s[130] + 2*s[238] + s[1102] + 2*s[1210] + s[2182];
gout[n*27+23] += + s[23] + 2*s[131] + 2*s[239] + s[1103] + 2*s[1211] + s[2183];
gout[n*27+24] += + s[24] + 2*s[132] + 2*s[240] + s[1104] + 2*s[1212] + s[2184];
gout[n*27+25] += + s[25] + 2*s[133] + 2*s[241] + s[1105] + 2*s[1213] + s[2185];
gout[n*27+26] += + s[26] + 2*s[134] + 2*s[242] + s[1106] + 2*s[1214] + s[2186];
}}}
void int1e_rrrrjjj_optimizer(CINTOpt **opt, FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 27};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
CACHE_SIZE_T int1e_rrrrjjj_cart(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrjjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_cart_1e, 0);
} // int1e_rrrrjjj_cart
CACHE_SIZE_T int1e_rrrrjjj_sph(double *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrjjj;
return CINT1e_drv(out, dims, &envs, cache, &c2s_sph_1e, 0);
} // int1e_rrrrjjj_sph
CACHE_SIZE_T int1e_rrrrjjj_spinor(double complex *out, FINT *dims, FINT *shls,
FINT *atm, FINT natm, FINT *bas, FINT nbas, double *env, CINTOpt *opt, double *cache) {
FINT ng[] = {4, 3, 0, 0, 7, 1, 1, 27};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_rrrrjjj;
return CINT1e_spinor_drv(out, dims, &envs, cache, &c2s_sf_1e, 0);
} // int1e_rrrrjjj_spinor
ALL_CINT1E(int1e_rrrrjjj)
ALL_CINT1E_FORTRAN_(int1e_rrrrjjj)
